(function (root, factory) {
  if (typeof define === 'function' && define.amd) {
    define([], factory);
  } else if (typeof module === 'object' && module.exports) {
    module.exports = factory();
  } else {
    root.MediaInfo = factory();
  }
}(this, function () {
var Module = function(Module) {
  Module = Module || {};
  var Module = Module;

var Module;if(!Module)Module=(typeof Module!=="undefined"?Module:null)||{};var moduleOverrides={};for(var key in Module){if(Module.hasOwnProperty(key)){moduleOverrides[key]=Module[key]}}var ENVIRONMENT_IS_WEB=false;var ENVIRONMENT_IS_WORKER=false;var ENVIRONMENT_IS_NODE=false;var ENVIRONMENT_IS_SHELL=false;if(Module["ENVIRONMENT"]){if(Module["ENVIRONMENT"]==="WEB"){ENVIRONMENT_IS_WEB=true}else if(Module["ENVIRONMENT"]==="WORKER"){ENVIRONMENT_IS_WORKER=true}else if(Module["ENVIRONMENT"]==="NODE"){ENVIRONMENT_IS_NODE=true}else if(Module["ENVIRONMENT"]==="SHELL"){ENVIRONMENT_IS_SHELL=true}else{throw new Error("The provided Module['ENVIRONMENT'] value is not valid. It must be one of: WEB|WORKER|NODE|SHELL.")}}else{ENVIRONMENT_IS_WEB=typeof window==="object";ENVIRONMENT_IS_WORKER=typeof importScripts==="function";ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof require==="function"&&!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_WORKER;ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER}if(ENVIRONMENT_IS_NODE){if(!Module["print"])Module["print"]=console.log;if(!Module["printErr"])Module["printErr"]=console.warn;var nodeFS;var nodePath;Module["read"]=function shell_read(filename,binary){if(!nodeFS)nodeFS=require("fs");if(!nodePath)nodePath=require("path");filename=nodePath["normalize"](filename);var ret=nodeFS["readFileSync"](filename);return binary?ret:ret.toString()};Module["readBinary"]=function readBinary(filename){var ret=Module["read"](filename,true);if(!ret.buffer){ret=new Uint8Array(ret)}assert(ret.buffer);return ret};Module["load"]=function load(f){globalEval(read(f))};if(!Module["thisProgram"]){if(process["argv"].length>1){Module["thisProgram"]=process["argv"][1].replace(/\\/g,"/")}else{Module["thisProgram"]="unknown-program"}}Module["arguments"]=process["argv"].slice(2);if(typeof module!=="undefined"){module["exports"]=Module}process["on"]("uncaughtException",(function(ex){if(!(ex instanceof ExitStatus)){throw ex}}));Module["inspect"]=(function(){return"[Emscripten Module object]"})}else if(ENVIRONMENT_IS_SHELL){if(!Module["print"])Module["print"]=print;if(typeof printErr!="undefined")Module["printErr"]=printErr;if(typeof read!="undefined"){Module["read"]=read}else{Module["read"]=function shell_read(){throw"no read() available"}}Module["readBinary"]=function readBinary(f){if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}var data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){Module["arguments"]=scriptArgs}else if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof quit==="function"){Module["quit"]=(function(status,toThrow){quit(status)})}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){Module["read"]=function shell_read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};if(ENVIRONMENT_IS_WORKER){Module["readBinary"]=function readBinary(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.responseType="arraybuffer";xhr.send(null);return new Uint8Array(xhr.response)}}Module["readAsync"]=function readAsync(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=function xhr_onload(){if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response)}else{onerror()}};xhr.onerror=onerror;xhr.send(null)};if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof console!=="undefined"){if(!Module["print"])Module["print"]=function shell_print(x){console.log(x)};if(!Module["printErr"])Module["printErr"]=function shell_printErr(x){console.warn(x)}}else{var TRY_USE_DUMP=false;if(!Module["print"])Module["print"]=TRY_USE_DUMP&&typeof dump!=="undefined"?(function(x){dump(x)}):(function(x){})}if(ENVIRONMENT_IS_WORKER){Module["load"]=importScripts}if(typeof Module["setWindowTitle"]==="undefined"){Module["setWindowTitle"]=(function(title){document.title=title})}}else{throw"Unknown runtime environment. Where are we?"}function globalEval(x){abort("NO_DYNAMIC_EXECUTION=1 was set, cannot eval")}if(!Module["load"]&&Module["read"]){Module["load"]=function load(f){globalEval(Module["read"](f))}}if(!Module["print"]){Module["print"]=(function(){})}if(!Module["printErr"]){Module["printErr"]=Module["print"]}if(!Module["arguments"]){Module["arguments"]=[]}if(!Module["thisProgram"]){Module["thisProgram"]="./this.program"}if(!Module["quit"]){Module["quit"]=(function(status,toThrow){throw toThrow})}Module.print=Module["print"];Module.printErr=Module["printErr"];Module["preRun"]=[];Module["postRun"]=[];for(var key in moduleOverrides){if(moduleOverrides.hasOwnProperty(key)){Module[key]=moduleOverrides[key]}}moduleOverrides=undefined;var Runtime={setTempRet0:(function(value){tempRet0=value;return value}),getTempRet0:(function(){return tempRet0}),stackSave:(function(){return STACKTOP}),stackRestore:(function(stackTop){STACKTOP=stackTop}),getNativeTypeSize:(function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:{if(type[type.length-1]==="*"){return Runtime.QUANTUM_SIZE}else if(type[0]==="i"){var bits=parseInt(type.substr(1));assert(bits%8===0);return bits/8}else{return 0}}}}),getNativeFieldSize:(function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)}),STACK_ALIGN:16,prepVararg:(function(ptr,type){if(type==="double"||type==="i64"){if(ptr&7){assert((ptr&7)===4);ptr+=4}}else{assert((ptr&3)===0)}return ptr}),getAlignSize:(function(type,size,vararg){if(!vararg&&(type=="i64"||type=="double"))return 8;if(!type)return Math.min(size,8);return Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE)}),dynCall:(function(sig,ptr,args){if(args&&args.length){return Module["dynCall_"+sig].apply(null,[ptr].concat(args))}else{return Module["dynCall_"+sig].call(null,ptr)}}),functionPointers:[],addFunction:(function(func){for(var i=0;i<Runtime.functionPointers.length;i++){if(!Runtime.functionPointers[i]){Runtime.functionPointers[i]=func;return 2*(1+i)}}throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."}),removeFunction:(function(index){Runtime.functionPointers[(index-2)/2]=null}),warnOnce:(function(text){if(!Runtime.warnOnce.shown)Runtime.warnOnce.shown={};if(!Runtime.warnOnce.shown[text]){Runtime.warnOnce.shown[text]=1;Module.printErr(text)}}),funcWrappers:{},getFuncWrapper:(function(func,sig){assert(sig);if(!Runtime.funcWrappers[sig]){Runtime.funcWrappers[sig]={}}var sigCache=Runtime.funcWrappers[sig];if(!sigCache[func]){if(sig.length===1){sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func)}}else if(sig.length===2){sigCache[func]=function dynCall_wrapper(arg){return Runtime.dynCall(sig,func,[arg])}}else{sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func,Array.prototype.slice.call(arguments))}}}return sigCache[func]}),getCompilerSetting:(function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"}),stackAlloc:(function(size){var ret=STACKTOP;STACKTOP=STACKTOP+size|0;STACKTOP=STACKTOP+15&-16;return ret}),staticAlloc:(function(size){var ret=STATICTOP;STATICTOP=STATICTOP+size|0;STATICTOP=STATICTOP+15&-16;return ret}),dynamicAlloc:(function(size){var ret=HEAP32[DYNAMICTOP_PTR>>2];var end=(ret+size+15|0)&-16;HEAP32[DYNAMICTOP_PTR>>2]=end;if(end>=TOTAL_MEMORY){var success=enlargeMemory();if(!success){HEAP32[DYNAMICTOP_PTR>>2]=ret;return 0}}return ret}),alignMemory:(function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret}),makeBigInt:(function(low,high,unsigned){var ret=unsigned?+(low>>>0)+ +(high>>>0)*+4294967296:+(low>>>0)+ +(high|0)*+4294967296;return ret}),GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module["Runtime"]=Runtime;var ABORT=0;var EXITSTATUS=0;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}function getCFunc(ident){var func=Module["_"+ident];if(!func){abort("NO_DYNAMIC_EXECUTION=1 was set, cannot eval")}assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)");return func}var cwrap,ccall;((function(){var JSfuncs={"stackSave":(function(){Runtime.stackSave()}),"stackRestore":(function(){Runtime.stackRestore()}),"arrayToC":(function(arr){var ret=Runtime.stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}),"stringToC":(function(str){var ret=0;if(str!==null&&str!==undefined&&str!==0){var len=(str.length<<2)+1;ret=Runtime.stackAlloc(len);stringToUTF8(str,ret,len)}return ret})};var toC={"string":JSfuncs["stringToC"],"array":JSfuncs["arrayToC"]};ccall=function ccallFunc(ident,returnType,argTypes,args,opts){var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=Runtime.stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);if(returnType==="string")ret=Pointer_stringify(ret);if(stack!==0){if(opts&&opts.async){EmterpreterAsync.asyncFinalizers.push((function(){Runtime.stackRestore(stack)}));return}Runtime.stackRestore(stack)}return ret};cwrap=function cwrap(ident,returnType,argTypes){return(function(){return ccall(ident,returnType,argTypes,arguments)})}}))();Module["ccall"]=ccall;Module["cwrap"]=cwrap;function setValue(ptr,value,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=+1?tempDouble>+0?(Math_min(+Math_floor(tempDouble/+4294967296),+4294967295)|0)>>>0:~~+Math_ceil((tempDouble- +(~~tempDouble>>>0))/+4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}Module["setValue"]=setValue;function getValue(ptr,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}Module["getValue"]=getValue;var ALLOC_NORMAL=0;var ALLOC_STACK=1;var ALLOC_STATIC=2;var ALLOC_DYNAMIC=3;var ALLOC_NONE=4;Module["ALLOC_NORMAL"]=ALLOC_NORMAL;Module["ALLOC_STACK"]=ALLOC_STACK;Module["ALLOC_STATIC"]=ALLOC_STATIC;Module["ALLOC_DYNAMIC"]=ALLOC_DYNAMIC;Module["ALLOC_NONE"]=ALLOC_NONE;function allocate(slab,types,allocator,ptr){var zeroinit,size;if(typeof slab==="number"){zeroinit=true;size=slab}else{zeroinit=false;size=slab.length}var singleType=typeof types==="string"?types:null;var ret;if(allocator==ALLOC_NONE){ret=ptr}else{ret=[typeof _malloc==="function"?_malloc:Runtime.staticAlloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][allocator===undefined?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length))}if(zeroinit){var ptr=ret,stop;assert((ret&3)==0);stop=ret+(size&~3);for(;ptr<stop;ptr+=4){HEAP32[ptr>>2]=0}stop=ret+size;while(ptr<stop){HEAP8[ptr++>>0]=0}return ret}if(singleType==="i8"){if(slab.subarray||slab.slice){HEAPU8.set(slab,ret)}else{HEAPU8.set(new Uint8Array(slab),ret)}return ret}var i=0,type,typeSize,previousType;while(i<size){var curr=slab[i];if(typeof curr==="function"){curr=Runtime.getFunctionIndex(curr)}type=singleType||types[i];if(type===0){i++;continue}if(type=="i64")type="i32";setValue(ret+i,curr,type);if(previousType!==type){typeSize=Runtime.getNativeTypeSize(type);previousType=type}i+=typeSize}return ret}Module["allocate"]=allocate;function getMemory(size){if(!staticSealed)return Runtime.staticAlloc(size);if(!runtimeInitialized)return Runtime.dynamicAlloc(size);return _malloc(size)}Module["getMemory"]=getMemory;function Pointer_stringify(ptr,length){if(length===0||!ptr)return"";var hasUtf=0;var t;var i=0;while(1){t=HEAPU8[ptr+i>>0];hasUtf|=t;if(t==0&&!length)break;i++;if(length&&i==length)break}if(!length)length=i;var ret="";if(hasUtf<128){var MAX_CHUNK=1024;var curr;while(length>0){curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK)));ret=ret?ret+curr:curr;ptr+=MAX_CHUNK;length-=MAX_CHUNK}return ret}return Module["UTF8ToString"](ptr)}Module["Pointer_stringify"]=Pointer_stringify;function AsciiToString(ptr){var str="";while(1){var ch=HEAP8[ptr++>>0];if(!ch)return str;str+=String.fromCharCode(ch)}}Module["AsciiToString"]=AsciiToString;function stringToAscii(str,outPtr){return writeAsciiToMemory(str,outPtr,false)}Module["stringToAscii"]=stringToAscii;var UTF8Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf8"):undefined;function UTF8ArrayToString(u8Array,idx){var endPtr=idx;while(u8Array[endPtr])++endPtr;if(endPtr-idx>16&&u8Array.subarray&&UTF8Decoder){return UTF8Decoder.decode(u8Array.subarray(idx,endPtr))}else{var u0,u1,u2,u3,u4,u5;var str="";while(1){u0=u8Array[idx++];if(!u0)return str;if(!(u0&128)){str+=String.fromCharCode(u0);continue}u1=u8Array[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}u2=u8Array[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u3=u8Array[idx++]&63;if((u0&248)==240){u0=(u0&7)<<18|u1<<12|u2<<6|u3}else{u4=u8Array[idx++]&63;if((u0&252)==248){u0=(u0&3)<<24|u1<<18|u2<<12|u3<<6|u4}else{u5=u8Array[idx++]&63;u0=(u0&1)<<30|u1<<24|u2<<18|u3<<12|u4<<6|u5}}}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}}Module["UTF8ArrayToString"]=UTF8ArrayToString;function UTF8ToString(ptr){return UTF8ArrayToString(HEAPU8,ptr)}Module["UTF8ToString"]=UTF8ToString;function stringToUTF8Array(str,outU8Array,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){if(outIdx>=endIdx)break;outU8Array[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;outU8Array[outIdx++]=192|u>>6;outU8Array[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;outU8Array[outIdx++]=224|u>>12;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=2097151){if(outIdx+3>=endIdx)break;outU8Array[outIdx++]=240|u>>18;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=67108863){if(outIdx+4>=endIdx)break;outU8Array[outIdx++]=248|u>>24;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else{if(outIdx+5>=endIdx)break;outU8Array[outIdx++]=252|u>>30;outU8Array[outIdx++]=128|u>>24&63;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}}outU8Array[outIdx]=0;return outIdx-startIdx}Module["stringToUTF8Array"]=stringToUTF8Array;function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}Module["stringToUTF8"]=stringToUTF8;function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){++len}else if(u<=2047){len+=2}else if(u<=65535){len+=3}else if(u<=2097151){len+=4}else if(u<=67108863){len+=5}else{len+=6}}return len}Module["lengthBytesUTF8"]=lengthBytesUTF8;var UTF16Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf-16le"):undefined;function demangle(func){var __cxa_demangle_func=Module["___cxa_demangle"]||Module["__cxa_demangle"];if(__cxa_demangle_func){try{var s=func.substr(1);var len=lengthBytesUTF8(s)+1;var buf=_malloc(len);stringToUTF8(s,buf,len);var status=_malloc(4);var ret=__cxa_demangle_func(buf,0,0,status);if(getValue(status,"i32")===0&&ret){return Pointer_stringify(ret)}}catch(e){}finally{if(buf)_free(buf);if(status)_free(status);if(ret)_free(ret)}return func}Runtime.warnOnce("warning: build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");return func}function demangleAll(text){var regex=/__Z[\w\d_]+/g;return text.replace(regex,(function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"}))}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){var js=jsStackTrace();if(Module["extraStackTrace"])js+="\n"+Module["extraStackTrace"]();return demangleAll(js)}Module["stackTrace"]=stackTrace;var HEAP,buffer,HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function updateGlobalBufferViews(){Module["HEAP8"]=HEAP8=new Int8Array(buffer);Module["HEAP16"]=HEAP16=new Int16Array(buffer);Module["HEAP32"]=HEAP32=new Int32Array(buffer);Module["HEAPU8"]=HEAPU8=new Uint8Array(buffer);Module["HEAPU16"]=HEAPU16=new Uint16Array(buffer);Module["HEAPU32"]=HEAPU32=new Uint32Array(buffer);Module["HEAPF32"]=HEAPF32=new Float32Array(buffer);Module["HEAPF64"]=HEAPF64=new Float64Array(buffer)}var STATIC_BASE,STATICTOP,staticSealed;var STACK_BASE,STACKTOP,STACK_MAX;var DYNAMIC_BASE,DYNAMICTOP_PTR;STATIC_BASE=STATICTOP=STACK_BASE=STACKTOP=STACK_MAX=DYNAMIC_BASE=DYNAMICTOP_PTR=0;staticSealed=false;function abortOnCannotGrowMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value "+TOTAL_MEMORY+", (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which allows increasing the size at runtime but prevents some optimizations, (3) set Module.TOTAL_MEMORY to a higher value before the program runs, or (4) if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ")}function enlargeMemory(){abortOnCannotGrowMemory()}var TOTAL_STACK=Module["TOTAL_STACK"]||16777216;var TOTAL_MEMORY=Module["TOTAL_MEMORY"]||268435456;if(TOTAL_MEMORY<TOTAL_STACK)Module.printErr("TOTAL_MEMORY should be larger than TOTAL_STACK, was "+TOTAL_MEMORY+"! (TOTAL_STACK="+TOTAL_STACK+")");if(Module["buffer"]){buffer=Module["buffer"]}else{{buffer=new ArrayBuffer(TOTAL_MEMORY)}}updateGlobalBufferViews();function getTotalMemory(){return TOTAL_MEMORY}HEAP32[0]=1668509029;HEAP16[1]=25459;if(HEAPU8[2]!==115||HEAPU8[3]!==99)throw"Runtime error: expected the system to be little-endian!";Module["HEAP"]=HEAP;Module["buffer"]=buffer;Module["HEAP8"]=HEAP8;Module["HEAP16"]=HEAP16;Module["HEAP32"]=HEAP32;Module["HEAPU8"]=HEAPU8;Module["HEAPU16"]=HEAPU16;Module["HEAPU32"]=HEAPU32;Module["HEAPF32"]=HEAPF32;Module["HEAPF64"]=HEAPF64;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback();continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){Module["dynCall_v"](func)}else{Module["dynCall_vi"](func,callback.arg)}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATEXIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){if(runtimeInitialized)return;runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__);runtimeExited=true}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}Module["addOnPreRun"]=addOnPreRun;function addOnInit(cb){__ATINIT__.unshift(cb)}Module["addOnInit"]=addOnInit;function addOnPreMain(cb){__ATMAIN__.unshift(cb)}Module["addOnPreMain"]=addOnPreMain;function addOnExit(cb){__ATEXIT__.unshift(cb)}Module["addOnExit"]=addOnExit;function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}Module["addOnPostRun"]=addOnPostRun;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;function intArrayToString(array){var ret=[];for(var i=0;i<array.length;i++){var chr=array[i];if(chr>255){chr&=255}ret.push(String.fromCharCode(chr))}return ret.join("")}Module["intArrayToString"]=intArrayToString;function writeStringToMemory(string,buffer,dontAddNull){Runtime.warnOnce("writeStringToMemory is deprecated and should not be called! Use stringToUTF8() instead!");var lastChar,end;if(dontAddNull){end=buffer+lengthBytesUTF8(string);lastChar=HEAP8[end]}stringToUTF8(string,buffer,Infinity);if(dontAddNull)HEAP8[end]=lastChar}Module["writeStringToMemory"]=writeStringToMemory;function writeArrayToMemory(array,buffer){HEAP8.set(array,buffer)}Module["writeArrayToMemory"]=writeArrayToMemory;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}Module["writeAsciiToMemory"]=writeAsciiToMemory;if(!Math["imul"]||Math["imul"](4294967295,5)!==-5)Math["imul"]=function imul(a,b){var ah=a>>>16;var al=a&65535;var bh=b>>>16;var bl=b&65535;return al*bl+(ah*bl+al*bh<<16)|0};Math.imul=Math["imul"];if(!Math["clz32"])Math["clz32"]=(function(x){x=x>>>0;for(var i=0;i<32;i++){if(x&1<<31-i)return i}return 32});Math.clz32=Math["clz32"];if(!Math["trunc"])Math["trunc"]=(function(x){return x<0?Math.ceil(x):Math.floor(x)});Math.trunc=Math["trunc"];var Math_abs=Math.abs;var Math_cos=Math.cos;var Math_sin=Math.sin;var Math_tan=Math.tan;var Math_acos=Math.acos;var Math_asin=Math.asin;var Math_atan=Math.atan;var Math_atan2=Math.atan2;var Math_exp=Math.exp;var Math_log=Math.log;var Math_sqrt=Math.sqrt;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_pow=Math.pow;var Math_imul=Math.imul;var Math_fround=Math.fround;var Math_round=Math.round;var Math_min=Math.min;var Math_clz32=Math.clz32;var Math_trunc=Math.trunc;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}Module["addRunDependency"]=addRunDependency;function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}Module["removeRunDependency"]=removeRunDependency;Module["preloadedImages"]={};Module["preloadedAudios"]={};var memoryInitializer=null;var ASM_CONSTS=[];STATIC_BASE=Runtime.GLOBAL_BASE;STATICTOP=STATIC_BASE+8800960;__ATINIT__.push({func:(function(){__GLOBAL__sub_I_MediaInfo_Config_cpp()})},{func:(function(){__GLOBAL__sub_I_InfoMap_cpp()})},{func:(function(){__GLOBAL__sub_I_Ztring_cpp()})});memoryInitializer="mediainfo.mem";var tempDoublePtr=STATICTOP;STATICTOP+=16;function __ZSt18uncaught_exceptionv(){return!!__ZSt18uncaught_exceptionv.uncaught_exception}var EXCEPTIONS={last:0,caught:[],infos:{},deAdjust:(function(adjusted){if(!adjusted||EXCEPTIONS.infos[adjusted])return adjusted;for(var ptr in EXCEPTIONS.infos){var info=EXCEPTIONS.infos[ptr];if(info.adjusted===adjusted){return ptr}}return adjusted}),addRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount++}),decRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];assert(info.refcount>0);info.refcount--;if(info.refcount===0&&!info.rethrown){if(info.destructor){Module["dynCall_vi"](info.destructor,ptr)}delete EXCEPTIONS.infos[ptr];___cxa_free_exception(ptr)}}),clearRef:(function(ptr){if(!ptr)return;var info=EXCEPTIONS.infos[ptr];info.refcount=0})};function ___resumeException(ptr){if(!EXCEPTIONS.last){EXCEPTIONS.last=ptr}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}function ___cxa_find_matching_catch(){var thrown=EXCEPTIONS.last;if(!thrown){return(Runtime.setTempRet0(0),0)|0}var info=EXCEPTIONS.infos[thrown];var throwntype=info.type;if(!throwntype){return(Runtime.setTempRet0(0),thrown)|0}var typeArray=Array.prototype.slice.call(arguments);var pointer=Module["___cxa_is_pointer_type"](throwntype);if(!___cxa_find_matching_catch.buffer)___cxa_find_matching_catch.buffer=_malloc(4);HEAP32[___cxa_find_matching_catch.buffer>>2]=thrown;thrown=___cxa_find_matching_catch.buffer;for(var i=0;i<typeArray.length;i++){if(typeArray[i]&&Module["___cxa_can_catch"](typeArray[i],throwntype,thrown)){thrown=HEAP32[thrown>>2];info.adjusted=thrown;return(Runtime.setTempRet0(typeArray[i]),thrown)|0}}thrown=HEAP32[thrown>>2];return(Runtime.setTempRet0(throwntype),thrown)|0}function ___cxa_throw(ptr,type,destructor){EXCEPTIONS.infos[ptr]={ptr:ptr,adjusted:ptr,type:type,destructor:destructor,refcount:0,caught:false,rethrown:false};EXCEPTIONS.last=ptr;if(!("uncaught_exception"in __ZSt18uncaught_exceptionv)){__ZSt18uncaught_exceptionv.uncaught_exception=1}else{__ZSt18uncaught_exceptionv.uncaught_exception++}throw ptr+" - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch."}function __isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0)}function __arraySum(array,index){var sum=0;for(var i=0;i<=index;sum+=array[i++]);return sum}var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date,days){var newDate=new Date(date.getTime());while(days>0){var leap=__isLeapYear(newDate.getFullYear());var currentMonth=newDate.getMonth();var daysInCurrentMonth=(leap?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR)[currentMonth];if(days>daysInCurrentMonth-newDate.getDate()){days-=daysInCurrentMonth-newDate.getDate()+1;newDate.setDate(1);if(currentMonth<11){newDate.setMonth(currentMonth+1)}else{newDate.setMonth(0);newDate.setFullYear(newDate.getFullYear()+1)}}else{newDate.setDate(newDate.getDate()+days);return newDate}}return newDate}function _strftime(s,maxsize,format,tm){var tm_zone=HEAP32[tm+40>>2];var date={tm_sec:HEAP32[tm>>2],tm_min:HEAP32[tm+4>>2],tm_hour:HEAP32[tm+8>>2],tm_mday:HEAP32[tm+12>>2],tm_mon:HEAP32[tm+16>>2],tm_year:HEAP32[tm+20>>2],tm_wday:HEAP32[tm+24>>2],tm_yday:HEAP32[tm+28>>2],tm_isdst:HEAP32[tm+32>>2],tm_gmtoff:HEAP32[tm+36>>2],tm_zone:tm_zone?Pointer_stringify(tm_zone):""};var pattern=Pointer_stringify(format);var EXPANSION_RULES_1={"%c":"%a %b %d %H:%M:%S %Y","%D":"%m/%d/%y","%F":"%Y-%m-%d","%h":"%b","%r":"%I:%M:%S %p","%R":"%H:%M","%T":"%H:%M:%S","%x":"%m/%d/%y","%X":"%H:%M:%S"};for(var rule in EXPANSION_RULES_1){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_1[rule])}var WEEKDAYS=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];var MONTHS=["January","February","March","April","May","June","July","August","September","October","November","December"];function leadingSomething(value,digits,character){var str=typeof value==="number"?value.toString():value||"";while(str.length<digits){str=character[0]+str}return str}function leadingNulls(value,digits){return leadingSomething(value,digits,"0")}function compareByDay(date1,date2){function sgn(value){return value<0?-1:value>0?1:0}var compare;if((compare=sgn(date1.getFullYear()-date2.getFullYear()))===0){if((compare=sgn(date1.getMonth()-date2.getMonth()))===0){compare=sgn(date1.getDate()-date2.getDate())}}return compare}function getFirstWeekStartDate(janFourth){switch(janFourth.getDay()){case 0:return new Date(janFourth.getFullYear()-1,11,29);case 1:return janFourth;case 2:return new Date(janFourth.getFullYear(),0,3);case 3:return new Date(janFourth.getFullYear(),0,2);case 4:return new Date(janFourth.getFullYear(),0,1);case 5:return new Date(janFourth.getFullYear()-1,11,31);case 6:return new Date(janFourth.getFullYear()-1,11,30)}}function getWeekBasedYear(date){var thisDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);var janFourthThisYear=new Date(thisDate.getFullYear(),0,4);var janFourthNextYear=new Date(thisDate.getFullYear()+1,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);if(compareByDay(firstWeekStartThisYear,thisDate)<=0){if(compareByDay(firstWeekStartNextYear,thisDate)<=0){return thisDate.getFullYear()+1}else{return thisDate.getFullYear()}}else{return thisDate.getFullYear()-1}}var EXPANSION_RULES_2={"%a":(function(date){return WEEKDAYS[date.tm_wday].substring(0,3)}),"%A":(function(date){return WEEKDAYS[date.tm_wday]}),"%b":(function(date){return MONTHS[date.tm_mon].substring(0,3)}),"%B":(function(date){return MONTHS[date.tm_mon]}),"%C":(function(date){var year=date.tm_year+1900;return leadingNulls(year/100|0,2)}),"%d":(function(date){return leadingNulls(date.tm_mday,2)}),"%e":(function(date){return leadingSomething(date.tm_mday,2," ")}),"%g":(function(date){return getWeekBasedYear(date).toString().substring(2)}),"%G":(function(date){return getWeekBasedYear(date)}),"%H":(function(date){return leadingNulls(date.tm_hour,2)}),"%I":(function(date){var twelveHour=date.tm_hour;if(twelveHour==0)twelveHour=12;else if(twelveHour>12)twelveHour-=12;return leadingNulls(twelveHour,2)}),"%j":(function(date){return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900)?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,date.tm_mon-1),3)}),"%m":(function(date){return leadingNulls(date.tm_mon+1,2)}),"%M":(function(date){return leadingNulls(date.tm_min,2)}),"%n":(function(){return"\n"}),"%p":(function(date){if(date.tm_hour>=0&&date.tm_hour<12){return"AM"}else{return"PM"}}),"%S":(function(date){return leadingNulls(date.tm_sec,2)}),"%t":(function(){return"\t"}),"%u":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()||7}),"%U":(function(date){var janFirst=new Date(date.tm_year+1900,0,1);var firstSunday=janFirst.getDay()===0?janFirst:__addDays(janFirst,7-janFirst.getDay());var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstSunday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstSundayUntilEndJanuary=31-firstSunday.getDate();var days=firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstSunday,janFirst)===0?"01":"00"}),"%V":(function(date){var janFourthThisYear=new Date(date.tm_year+1900,0,4);var janFourthNextYear=new Date(date.tm_year+1901,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);var endDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);if(compareByDay(endDate,firstWeekStartThisYear)<0){return"53"}if(compareByDay(firstWeekStartNextYear,endDate)<=0){return"01"}var daysDifference;if(firstWeekStartThisYear.getFullYear()<date.tm_year+1900){daysDifference=date.tm_yday+32-firstWeekStartThisYear.getDate()}else{daysDifference=date.tm_yday+1-firstWeekStartThisYear.getDate()}return leadingNulls(Math.ceil(daysDifference/7),2)}),"%w":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()}),"%W":(function(date){var janFirst=new Date(date.tm_year,0,1);var firstMonday=janFirst.getDay()===1?janFirst:__addDays(janFirst,janFirst.getDay()===0?1:7-janFirst.getDay()+1);var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstMonday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstMondayUntilEndJanuary=31-firstMonday.getDate();var days=firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstMonday,janFirst)===0?"01":"00"}),"%y":(function(date){return(date.tm_year+1900).toString().substring(2)}),"%Y":(function(date){return date.tm_year+1900}),"%z":(function(date){var off=date.tm_gmtoff;var ahead=off>=0;off=Math.abs(off)/60;off=off/60*100+off%60;return(ahead?"+":"-")+String("0000"+off).slice(-4)}),"%Z":(function(date){return date.tm_zone}),"%%":(function(){return"%"})};for(var rule in EXPANSION_RULES_2){if(pattern.indexOf(rule)>=0){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_2[rule](date))}}var bytes=intArrayFromString(pattern,false);if(bytes.length>maxsize){return 0}writeArrayToMemory(bytes,s);return bytes.length-1}function _strftime_l(s,maxsize,format,tm){return _strftime(s,maxsize,format,tm)}function _abort(){Module["abort"]()}var SYSCALLS={varargs:0,get:(function(varargs){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret}),getStr:(function(){var ret=Pointer_stringify(SYSCALLS.get());return ret}),get64:(function(){var low=SYSCALLS.get(),high=SYSCALLS.get();if(low>=0)assert(high===0);else assert(high===-1);return low}),getZero:(function(){assert(SYSCALLS.get()===0)})};function ___syscall195(which,varargs){SYSCALLS.varargs=varargs;try{var path=SYSCALLS.getStr(),buf=SYSCALLS.get();return SYSCALLS.doStat(FS.stat,path,buf)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _pthread_mutex_destroy(){}function _pthread_create(){return 11}function _pthread_once(ptr,func){if(!_pthread_once.seen)_pthread_once.seen={};if(ptr in _pthread_once.seen)return;Module["dynCall_v"](func);_pthread_once.seen[ptr]=1}var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_STATIC);function ___lock(){}function ___unlock(){}var PTHREAD_SPECIFIC={};function _pthread_getspecific(key){return PTHREAD_SPECIFIC[key]||0}function _llvm_stackrestore(p){var self=_llvm_stacksave;var ret=self.LLVM_SAVEDSTACKS[p];self.LLVM_SAVEDSTACKS.splice(p,1);Runtime.stackRestore(ret)}var PTHREAD_SPECIFIC_NEXT_KEY=1;var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};function _pthread_key_create(key,destructor){if(key==0){return ERRNO_CODES.EINVAL}HEAP32[key>>2]=PTHREAD_SPECIFIC_NEXT_KEY;PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY]=0;PTHREAD_SPECIFIC_NEXT_KEY++;return 0}function _pthread_mutex_init(){}var _llvm_pow_f32=Math_pow;function ___syscall91(which,varargs){SYSCALLS.varargs=varargs;try{var addr=SYSCALLS.get(),len=SYSCALLS.get();var info=SYSCALLS.mappings[addr];if(!info)return 0;if(len===info.len){var stream=FS.getStream(info.fd);SYSCALLS.doMsync(addr,stream,len,info.flags);FS.munmap(stream);SYSCALLS.mappings[addr]=null;if(info.allocated){_free(info.malloc)}}return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _pthread_setspecific(key,value){if(!(key in PTHREAD_SPECIFIC)){return ERRNO_CODES.EINVAL}PTHREAD_SPECIFIC[key]=value;return 0}function ___cxa_allocate_exception(size){return _malloc(size)}function ___syscall54(which,varargs){SYSCALLS.varargs=varargs;try{return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _pthread_attr_setdetachstate(){}var ___tm_current=STATICTOP;STATICTOP+=48;var ___tm_timezone=allocate(intArrayFromString("GMT"),"i8",ALLOC_STATIC);function _gmtime_r(time,tmPtr){var date=new Date(HEAP32[time>>2]*1e3);HEAP32[tmPtr>>2]=date.getUTCSeconds();HEAP32[tmPtr+4>>2]=date.getUTCMinutes();HEAP32[tmPtr+8>>2]=date.getUTCHours();HEAP32[tmPtr+12>>2]=date.getUTCDate();HEAP32[tmPtr+16>>2]=date.getUTCMonth();HEAP32[tmPtr+20>>2]=date.getUTCFullYear()-1900;HEAP32[tmPtr+24>>2]=date.getUTCDay();HEAP32[tmPtr+36>>2]=0;HEAP32[tmPtr+32>>2]=0;var start=Date.UTC(date.getUTCFullYear(),0,1,0,0,0,0);var yday=(date.getTime()-start)/(1e3*60*60*24)|0;HEAP32[tmPtr+28>>2]=yday;HEAP32[tmPtr+40>>2]=___tm_timezone;return tmPtr}function _gmtime(time){return _gmtime_r(time,___tm_current)}var _environ=STATICTOP;STATICTOP+=16;function ___buildEnvironment(env){var MAX_ENV_VALUES=64;var TOTAL_ENV_SIZE=1024;var poolPtr;var envPtr;if(!___buildEnvironment.called){___buildEnvironment.called=true;ENV["USER"]=ENV["LOGNAME"]="web_user";ENV["PATH"]="/";ENV["PWD"]="/";ENV["HOME"]="/home/web_user";ENV["LANG"]="C";ENV["_"]=Module["thisProgram"];poolPtr=allocate(TOTAL_ENV_SIZE,"i8",ALLOC_STATIC);envPtr=allocate(MAX_ENV_VALUES*4,"i8*",ALLOC_STATIC);HEAP32[envPtr>>2]=poolPtr;HEAP32[_environ>>2]=envPtr}else{envPtr=HEAP32[_environ>>2];poolPtr=HEAP32[envPtr>>2]}var strings=[];var totalSize=0;for(var key in env){if(typeof env[key]==="string"){var line=key+"="+env[key];strings.push(line);totalSize+=line.length}}if(totalSize>TOTAL_ENV_SIZE){throw new Error("Environment size exceeded TOTAL_ENV_SIZE!")}var ptrSize=4;for(var i=0;i<strings.length;i++){var line=strings[i];writeAsciiToMemory(line,poolPtr);HEAP32[envPtr+i*ptrSize>>2]=poolPtr;poolPtr+=line.length+1}HEAP32[envPtr+strings.length*ptrSize>>2]=0}var ENV={};function _getenv(name){if(name===0)return 0;name=Pointer_stringify(name);if(!ENV.hasOwnProperty(name))return 0;if(_getenv.ret)_free(_getenv.ret);_getenv.ret=allocate(intArrayFromString(ENV[name]),"i8",ALLOC_NORMAL);return _getenv.ret}function _pthread_attr_init(attr){return 0}function ___setErrNo(value){if(Module["___errno_location"])HEAP32[Module["___errno_location"]()>>2]=value;return value}function ___map_file(pathname,size){___setErrNo(ERRNO_CODES.EPERM);return-1}function ___syscall5(which,varargs){SYSCALLS.varargs=varargs;try{var pathname=SYSCALLS.getStr(),flags=SYSCALLS.get(),mode=SYSCALLS.get();var stream=FS.open(pathname,flags,mode);return stream.fd}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _emscripten_memcpy_big(dest,src,num){HEAPU8.set(HEAPU8.subarray(src,src+num),dest);return dest}function ___syscall6(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD();FS.close(stream);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___cxa_begin_catch(ptr){var info=EXCEPTIONS.infos[ptr];if(info&&!info.caught){info.caught=true;__ZSt18uncaught_exceptionv.uncaught_exception--}if(info)info.rethrown=false;EXCEPTIONS.caught.push(ptr);EXCEPTIONS.addRef(EXCEPTIONS.deAdjust(ptr));return ptr}var _llvm_pow_f64=Math_pow;function _llvm_stacksave(){var self=_llvm_stacksave;if(!self.LLVM_SAVEDSTACKS){self.LLVM_SAVEDSTACKS=[]}self.LLVM_SAVEDSTACKS.push(Runtime.stackSave());return self.LLVM_SAVEDSTACKS.length-1}function ___gxx_personality_v0(){}function _pthread_cond_wait(){return 0}function ___syscall140(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),offset_high=SYSCALLS.get(),offset_low=SYSCALLS.get(),result=SYSCALLS.get(),whence=SYSCALLS.get();var offset=offset_low;FS.llseek(stream,offset,whence);HEAP32[result>>2]=stream.position;if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall145(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doReadv(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall146(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.get(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();var ret=0;if(!___syscall146.buffer){___syscall146.buffers=[null,[],[]];___syscall146.printChar=(function(stream,curr){var buffer=___syscall146.buffers[stream];assert(buffer);if(curr===0||curr===10){(stream===1?Module["print"]:Module["printErr"])(UTF8ArrayToString(buffer,0));buffer.length=0}else{buffer.push(curr)}})}for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];for(var j=0;j<len;j++){___syscall146.printChar(stream,HEAPU8[ptr+j])}ret+=len}return ret}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall221(which,varargs){SYSCALLS.varargs=varargs;try{return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall220(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),dirp=SYSCALLS.get(),count=SYSCALLS.get();if(!stream.getdents){stream.getdents=FS.readdir(stream.path)}var pos=0;while(stream.getdents.length>0&&pos+268<=count){var id;var type;var name=stream.getdents.pop();assert(name.length<256);if(name[0]==="."){id=1;type=4}else{var child=FS.lookupNode(stream.node,name);id=child.id;type=FS.isChrdev(child.mode)?2:FS.isDir(child.mode)?4:FS.isLink(child.mode)?10:8}HEAP32[dirp+pos>>2]=id;HEAP32[dirp+pos+4>>2]=stream.position;HEAP16[dirp+pos+8>>1]=268;HEAP8[dirp+pos+10>>0]=type;for(var i=0;i<name.length;i++){HEAP8[dirp+pos+(11+i)>>0]=name.charCodeAt(i)}HEAP8[dirp+pos+(11+i)>>0]=0;pos+=268}return pos}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}___buildEnvironment(ENV);__ATEXIT__.push((function(){var fflush=Module["_fflush"];if(fflush)fflush(0);var printChar=___syscall146.printChar;if(!printChar)return;var buffers=___syscall146.buffers;if(buffers[1].length)printChar(1,10);if(buffers[2].length)printChar(2,10)}));DYNAMICTOP_PTR=allocate(1,"i32",ALLOC_STATIC);STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP);STACK_MAX=STACK_BASE+TOTAL_STACK;DYNAMIC_BASE=Runtime.alignMemory(STACK_MAX);HEAP32[DYNAMICTOP_PTR>>2]=DYNAMIC_BASE;staticSealed=true;function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiii(index,a1,a2,a3){try{return Module["dynCall_iiii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiid(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vi(index,a1){try{Module["dynCall_vi"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vii(index,a1,a2){try{Module["dynCall_vii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_ii(index,a1){try{return Module["dynCall_ii"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viii(index,a1,a2,a3){try{Module["dynCall_viii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_v(index){try{Module["dynCall_v"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){try{return Module["dynCall_iiiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iii(index,a1,a2){try{return Module["dynCall_iii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiii(index,a1,a2,a3,a4){try{Module["dynCall_viiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}Module.asmGlobalArg={"Math":Math,"Int8Array":Int8Array,"Int16Array":Int16Array,"Int32Array":Int32Array,"Uint8Array":Uint8Array,"Uint16Array":Uint16Array,"Uint32Array":Uint32Array,"Float32Array":Float32Array,"Float64Array":Float64Array,"NaN":NaN,"Infinity":Infinity};Module.asmLibraryArg={"abort":abort,"assert":assert,"enlargeMemory":enlargeMemory,"getTotalMemory":getTotalMemory,"abortOnCannotGrowMemory":abortOnCannotGrowMemory,"invoke_iiiiiiii":invoke_iiiiiiii,"invoke_iiii":invoke_iiii,"invoke_viiiii":invoke_viiiii,"invoke_iiiiiid":invoke_iiiiiid,"invoke_vi":invoke_vi,"invoke_vii":invoke_vii,"invoke_iiiiiii":invoke_iiiiiii,"invoke_iiiiid":invoke_iiiiid,"invoke_ii":invoke_ii,"invoke_viii":invoke_viii,"invoke_v":invoke_v,"invoke_iiiiiiiii":invoke_iiiiiiiii,"invoke_iiiii":invoke_iiiii,"invoke_viiiiii":invoke_viiiiii,"invoke_iii":invoke_iii,"invoke_iiiiii":invoke_iiiiii,"invoke_viiii":invoke_viiii,"___syscall221":___syscall221,"___syscall220":___syscall220,"_pthread_cond_wait":_pthread_cond_wait,"_llvm_pow_f64":_llvm_pow_f64,"_pthread_key_create":_pthread_key_create,"_abort":_abort,"___gxx_personality_v0":___gxx_personality_v0,"_llvm_stackrestore":_llvm_stackrestore,"___cxa_allocate_exception":___cxa_allocate_exception,"___cxa_find_matching_catch":___cxa_find_matching_catch,"_pthread_attr_setdetachstate":_pthread_attr_setdetachstate,"___buildEnvironment":___buildEnvironment,"__isLeapYear":__isLeapYear,"__addDays":__addDays,"_strftime_l":_strftime_l,"___setErrNo":___setErrNo,"_llvm_pow_f32":_llvm_pow_f32,"___cxa_begin_catch":___cxa_begin_catch,"___syscall195":___syscall195,"_pthread_attr_init":_pthread_attr_init,"___resumeException":___resumeException,"__ZSt18uncaught_exceptionv":__ZSt18uncaught_exceptionv,"_strftime":_strftime,"__arraySum":__arraySum,"_emscripten_memcpy_big":_emscripten_memcpy_big,"___syscall91":___syscall91,"_gmtime":_gmtime,"_pthread_mutex_destroy":_pthread_mutex_destroy,"_llvm_stacksave":_llvm_stacksave,"_pthread_once":_pthread_once,"_pthread_getspecific":_pthread_getspecific,"_getenv":_getenv,"___map_file":___map_file,"___syscall54":___syscall54,"___unlock":___unlock,"_pthread_create":_pthread_create,"_pthread_setspecific":_pthread_setspecific,"_gmtime_r":_gmtime_r,"___cxa_throw":___cxa_throw,"___lock":___lock,"___syscall6":___syscall6,"___syscall5":___syscall5,"___syscall140":___syscall140,"_pthread_mutex_init":_pthread_mutex_init,"___syscall145":___syscall145,"___syscall146":___syscall146,"DYNAMICTOP_PTR":DYNAMICTOP_PTR,"tempDoublePtr":tempDoublePtr,"ABORT":ABORT,"STACKTOP":STACKTOP,"STACK_MAX":STACK_MAX,"cttz_i8":cttz_i8};// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer) {
"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.DYNAMICTOP_PTR|0;var j=env.tempDoublePtr|0;var k=env.ABORT|0;var l=env.STACKTOP|0;var m=env.STACK_MAX|0;var n=env.cttz_i8|0;var o=0;var p=0;var q=0;var r=0;var s=global.NaN,t=global.Infinity;var u=0,v=0,w=0,x=0,y=0.0;var z=0;var A=global.Math.floor;var B=global.Math.abs;var C=global.Math.sqrt;var D=global.Math.pow;var E=global.Math.cos;var F=global.Math.sin;var G=global.Math.tan;var H=global.Math.acos;var I=global.Math.asin;var J=global.Math.atan;var K=global.Math.atan2;var L=global.Math.exp;var M=global.Math.log;var N=global.Math.ceil;var O=global.Math.imul;var P=global.Math.min;var Q=global.Math.max;var R=global.Math.clz32;var S=env.abort;var T=env.assert;var U=env.enlargeMemory;var V=env.getTotalMemory;var W=env.abortOnCannotGrowMemory;var X=env.invoke_iiiiiiii;var Y=env.invoke_iiii;var Z=env.invoke_viiiii;var _=env.invoke_iiiiiid;var $=env.invoke_vi;var aa=env.invoke_vii;var ba=env.invoke_iiiiiii;var ca=env.invoke_iiiiid;var da=env.invoke_ii;var ea=env.invoke_viii;var fa=env.invoke_v;var ga=env.invoke_iiiiiiiii;var ha=env.invoke_iiiii;var ia=env.invoke_viiiiii;var ja=env.invoke_iii;var ka=env.invoke_iiiiii;var la=env.invoke_viiii;var ma=env.___syscall221;var na=env.___syscall220;var oa=env._pthread_cond_wait;var pa=env._llvm_pow_f64;var qa=env._pthread_key_create;var ra=env._abort;var sa=env.___gxx_personality_v0;var ta=env._llvm_stackrestore;var ua=env.___cxa_allocate_exception;var va=env.___cxa_find_matching_catch;var wa=env._pthread_attr_setdetachstate;var xa=env.___buildEnvironment;var ya=env.__isLeapYear;var za=env.__addDays;var Aa=env._strftime_l;var Ba=env.___setErrNo;var Ca=env._llvm_pow_f32;var Da=env.___cxa_begin_catch;var Ea=env.___syscall195;var Fa=env._pthread_attr_init;var Ga=env.___resumeException;var Ha=env.__ZSt18uncaught_exceptionv;var Ia=env._strftime;var Ja=env.__arraySum;var Ka=env._emscripten_memcpy_big;var La=env.___syscall91;var Ma=env._gmtime;var Na=env._pthread_mutex_destroy;var Oa=env._llvm_stacksave;var Pa=env._pthread_once;var Qa=env._pthread_getspecific;var Ra=env._getenv;var Sa=env.___map_file;var Ta=env.___syscall54;var Ua=env.___unlock;var Va=env._pthread_create;var Wa=env._pthread_setspecific;var Xa=env._gmtime_r;var Ya=env.___cxa_throw;var Za=env.___lock;var _a=env.___syscall6;var $a=env.___syscall5;var ab=env.___syscall140;var bb=env._pthread_mutex_init;var cb=env.___syscall145;var db=env.___syscall146;var eb=0.0;
// EMSCRIPTEN_START_FUNCS
function ek(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=b+612|0;k=b+544|0;d=c[j>>2]|0;i=c[b+548>>2]|0;b=d;a:while(1){if((b+4|0)>>>0>i>>>0){e=d;h=22;break}while(1){e=b+3|0;if((b+4|0)>>>0>i>>>0)continue a;g=c[k>>2]|0;f=g+b|0;if((((a[f>>0]|0)==79?(a[g+(b+1)>>0]|0)==103:0)?(a[g+(b+2)>>0]|0)==103:0)?(a[g+e>>0]|0)==83:0)break;else d=e;while(1){c[j>>2]=d;if(d>>>0>=i>>>0){h=12;break}if((a[g+d>>0]|0)==103){h=11;break}d=d+2|0}if((h|0)==11){h=0;b=d+-1|0;if((a[g+b>>0]|0)==103)h=13;else b=d}else if((h|0)==12){b=d+-1|0;h=13}if((h|0)==13){h=0;c[j>>2]=b}b=b+-1|0;c[j>>2]=b;d=b}if((b+27|0)>>>0>i>>>0){b=0;break}e=(D9(a[f+26>>0]|0)|0)&255;if((d+27+e|0)>>>0>i>>>0){b=0;break}else{b=0;f=0}while(1){if((f|0)==(e|0))break;b=((D9(a[g+d+27+f>>0]|0)|0)&255)+b|0;f=f+1|0}if((e+31+d+b|0)>>>0>i>>>0){b=0;break}if((C9(g+d+27+e+b|0)|0)==1332176723){e=d;b=d;h=22;break}d=d+1|0;c[j>>2]=d;b=d}if((h|0)==22)if((b+4|0)>>>0>i>>>0){if((b+3|0)==(i|0)){h=(c[k>>2]|0)+b|0;b=e+1|0;if((R4(a[h>>0]|0,a[h+1>>0]|0,a[h+2>>0]|0)|0)==5203815){d=e;b=e}else{c[j>>2]=b;d=b}}else d=e;if((b+2|0)==(i|0)){h=(c[k>>2]|0)+b|0;e=d+1|0;if((d7(a[h>>0]|0,a[h+1>>0]|0)|0)<<16>>16==20327)b=d;else{c[j>>2]=e;b=e;d=e}}if((b+1|0)==(i|0)?(D9(a[(c[k>>2]|0)+b>>0]|0)|0)<<24>>24!=79:0){c[j>>2]=d+1;b=0}else b=0}else b=1;return b|0}function fk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+96|0;f=n+72|0;g=n+60|0;h=n+48|0;i=n+36|0;j=n+24|0;k=n+12|0;m=n;e=d&65535;tU(k,e>>>8,16);DW(k,0,(d&65535)<2560?42196:409096)|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];d=0;while(1){if((d|0)==3)break;c[k+(d<<2)>>2]=0;d=d+1|0}HX(j,42204)|0;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];d=0;while(1){if((d|0)==3)break;c[j+(d<<2)>>2]=0;d=d+1|0}e=e&255;HX(i,e>>>0<10?42196:409096)|0;c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];d=0;while(1){if((d|0)==3)break;c[i+(d<<2)>>2]=0;d=d+1|0}tU(m,e,16);d=a[m+8+3>>0]|0;e=d<<24>>24<0;Ex(h,e?c[m>>2]|0:m,e?c[m+4>>2]|0:d&255)|0;c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];d=0;while(1){if((d|0)==3)break;c[h+(d<<2)>>2]=0;d=d+1|0}HX(g,39952)|0;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];d=0;while(1){if((d|0)==3)break;c[g+(d<<2)>>2]=0;d=d+1|0}p2(b,f);O0(f);O0(g);z5(m);O0(h);O0(i);O0(j);z5(k);l=n;return}function gk(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;v=l;l=l+16|0;g=v+6|0;f=v+4|0;i=v;bB(d,g);g=a[g>>0]|0;k=d+528|0;e=k;h=c[e>>2]|0;e=c[e+4>>2]|0;j=d+536|0;p=j;o=c[p>>2]|0;p=c[p+4>>2]|0;if(g<<24>>24!=-1){w=z0(h|0,e|0,2,0)|0;x=z;if(g<<24>>24==-75&(x>>>0<p>>>0|(x|0)==(p|0)&w>>>0<o>>>0)){NB(d,f);y=(b[f>>1]|0)==49;f=k;e=c[f>>2]|0;f=c[f+4>>2]|0;h=j;g=c[h>>2]|0;h=c[h+4>>2]|0;x=z0(e|0,f|0,4,0)|0;w=z;if(y&(w>>>0<h>>>0|(w|0)==(h|0)&x>>>0<g>>>0)){aH(d,i);e=c[i>>2]|0;a:do if((e|0)<1195456820){switch(e|0){case 1146373937:break;default:{u=12;break a}}yt(d)}else{switch(e|0){case 1195456820:break;default:{u=12;break a}}Iy(d)}while(0);if((u|0)==12?(n=j,m=k,m=D_(c[n>>2]|0,c[n+4>>2]|0,c[m>>2]|0,c[m+4>>2]|0)|0,n=z,!((m|0)==0&(n|0)==0)):0)e1(d,m,n)}else{e=D_(g|0,h|0,e|0,f|0)|0;f=z;if(!((e|0)==0&(f|0)==0))e1(d,e,f)}}else{q=h;r=e;u=4}}else{q=z0(h|0,e|0,1,0)|0;r=z;u=k;c[u>>2]=q;c[u+4>>2]=r;u=4}if((u|0)==4?(s=D_(o|0,p|0,q|0,r|0)|0,t=z,!((s|0)==0&(t|0)==0)):0)e1(d,s,t);l=v;return}function hk(b,e,f,g,h,i){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;c[f>>2]=b;c[i>>2]=g;p=e;a:while(1){n=c[f>>2]|0;if(n>>>0>=e>>>0){b=0;break}if(g>>>0>=h>>>0){b=1;break}m=a[n>>0]|0;o=m&255;b=n+1|0;do if(m<<24>>24>-1)c[g>>2]=o;else{if((m&255)<194){b=2;break a}k=n+2|0;j=p-n|0;if((m&255)<224){if((j|0)<2){b=1;break a}b=d[b>>0]|0;if((b&192|0)!=128){b=2;break a}c[g>>2]=b&63|o<<6&1984;b=k;break}l=n+3|0;if((m&255)<240){if((j|0)<3){b=1;break a}j=a[k>>0]|0;k=d[b>>0]|0;b=k&224;switch(m<<24>>24){case -32:{if((b|0)!=160){b=2;break a}break}case -19:{if((b|0)!=128){b=2;break a}break}default:if((k&192|0)!=128){b=2;break a}}b=j&255;if((b&192|0)!=128){b=2;break a}c[g>>2]=k<<6&4032|o<<12&61440|b&63;b=l;break}if((m&255)>=245){b=2;break a}if((j|0)<4){b=1;break a}j=a[b>>0]|0;b=a[k>>0]|0;k=a[l>>0]|0;l=j&255;switch(m<<24>>24){case -16:{if((j+112&255)>=48){b=2;break a}break}case -12:{if((l&240|0)!=128){b=2;break a}break}default:if((l&192|0)!=128){b=2;break a}}j=b&255;if((j&192|0)!=128){b=2;break a}b=k&255;if((b&192|0)!=128){b=2;break a}b=l<<12&258048|o<<18&1835008|j<<6&4032|b&63;if(b>>>0>1114111){b=2;break a}c[g>>2]=b;b=n+4|0}while(0);c[f>>2]=b;g=(c[i>>2]|0)+4|0;c[i>>2]=g}return b|0}function ik(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+16|0;k=m;g=m+8|0;h=m+6|0;i=m+4|0;f=c[d+612>>2]|0;if(((f+64|0)>>>0<(c[d+548>>2]|0)>>>0?(e=(c[d+544>>2]|0)+f+32|0,j=C9(e)|0,(j|0)==(W8(372797)|0)):0)?(j=e+4|0,(d7(a[j>>0]|0,a[j+1>>0]|0)|0)<<16>>16==1):0){e1(d,32,0);GC(d);KK(d);j=d+528|0;e=j;e=z0(c[e>>2]|0,c[e+4>>2]|0,6,0)|0;f=j;c[f>>2]=e;c[f+4>>2]=z;ID(d,k);ID(d,d+1096|0);NB(d,g);NB(d,h);NB(d,i);f=j;f=z0(c[f>>2]|0,c[f+4>>2]|0,2,0)|0;h=j;c[h>>2]=f;c[h+4>>2]=z;GC(d);h=b[g>>1]|0;f=b[i>>1]|0;g=f&65535;e=0;while(1){if((e&65535)>=(h&65535))break;switch(f<<16>>16){case 1:{n=j;i=j;c[i>>2]=z0(c[n>>2]|0,c[n+4>>2]|0,1,0)|0;c[i+4>>2]=z;break}case 2:{i=j;n=j;c[n>>2]=z0(c[i>>2]|0,c[i+4>>2]|0,2,0)|0;c[n+4>>2]=z;break}case 4:{i=j;n=j;c[n>>2]=z0(c[i>>2]|0,c[i+4>>2]|0,4,0)|0;c[n+4>>2]=z;break}default:e1(d,g,0)}e=e+1<<16>>16}J3(d);J3(d);n=d+1088|0;c[n>>2]=c[k>>2];c[n+4>>2]=0;NP(d+980|0);NP(d+992|0)}l=m;return}function jk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+32|0;i=m+16|0;j=m+12|0;e=m+8|0;f=m+4|0;h=m;k=m+20|0;d=b+528|0;n=d;n=z0(c[n>>2]|0,c[n+4>>2]|0,1,0)|0;g=d;c[g>>2]=n;c[g+4>>2]=z;iF(b,6,0);bD(b,i);if((c[i>>2]|0)==0?(bB(b,k),bD(b,j),bD(b,e),bD(b,f),bD(b,h),Bx(b),i=b+648|0,G4(c[i>>2]|0,4),G4(c[i>>2]|0,4),wK(b),i=d,i=z0(c[i>>2]|0,c[i+4>>2]|0,1,0)|0,n=d,c[n>>2]=i,c[n+4>>2]=z,qO(b)|0):0){W5(b);Kc(b,2,-1)|0;i=b+20|0;RB(b,2,c[i>>2]|0,18,384424,-1,1,0);RB(b,2,c[i>>2]|0,52,384424,-1,1,0);g=c[e>>2]|0;if((g|0)>0)lL(b,2,c[i>>2]|0,118,g,10,0);f=c[f>>2]|0;if((f|0)>0)lL(b,2,c[i>>2]|0,112,f,10,0);d=c[h>>2]|0;if((d|0)>0)lL(b,2,c[i>>2]|0,114,d,10,0);e=c[i>>2]|0;if((f|0)==(d|0)&((f|0)!=0&(g|0)==(f|0)))RB(b,2,e,110,384431,-1,1,0);else RB(b,2,e,110,384435,-1,1,0);mL(b,2,c[i>>2]|0,122,a[k>>0]|0,10,0);lL(b,2,c[i>>2]|0,135,c[j>>2]|0,10,0)}l=m;return}function kk(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+16|0;p=s;g=b+8|0;q=g+3|0;f=a[q>>0]|0;h=f<<24>>24<0;i=f&255;r=b+4|0;if(h){k=c[r>>2]|0;j=(c[g>>2]&2147483647)+-1|0}else{k=i;j=1}o=e-d>>2;do if(o|0){if(h){h=c[b>>2]|0;g=c[r>>2]|0}else{h=b;g=i}if(!(I2(d,h,h+(g<<2)|0)|0)){g=k+o|0;if((j-k|0)>>>0<o>>>0){ax(b,j,g-j|0,k,k,0);f=a[q>>0]|0}if(f<<24>>24<0)f=c[b>>2]|0;else f=b;f=f+(k<<2)|0;while(1){if((d|0)==(e|0))break;y7(f,c[d>>2]|0);f=f+4|0;d=d+4|0}y7(f,0);if((a[q>>0]|0)<0){c[r>>2]=g;break}else{a[q>>0]=g;break}}else{c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;if(o>>>0>1073741807)uaa();f=p+8|0;g=p+4|0;h=f+3|0;do if(o>>>0>=2){i=o+4&-4;if(i>>>0>1073741823)ra();else{n=ZW(i<<2)|0;c[p>>2]=n;c[f>>2]=i|-2147483648;c[g>>2]=o;m=d;break}}else{a[h>>0]=o;m=d;n=p}while(0);while(1){if((m|0)==(e|0))break;y7(n,c[m>>2]|0);m=m+4|0;n=n+4|0}y7(n,0);e=a[h>>0]|0;r=e<<24>>24<0;Ex(b,r?c[p>>2]|0:p,r?c[g>>2]|0:e&255)|0;O0(p);break}}while(0);l=s;return b|0}function lk(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+176|0;n=r+168|0;o=r+40|0;p=r+36|0;q=r+32|0;k=r;i=r+24|0;m=r+16|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[k+(d<<2)>>2]=0;d=d+1|0}c[i+4>>2]=0;c[i>>2]=57120;g=a[h+8+3>>0]|0;d=g<<24>>24<0;e=d?c[h>>2]|0:h;g=e+((d?c[h+4>>2]|0:g&255)<<2)|0;h=o+32|0;d=0;while(1){if(!((d|0)!=2&e>>>0<g>>>0))break;c[q>>2]=e;f=qb[c[(c[i>>2]|0)+12>>2]&15](i,n,e,g,q,o,h,p)|0;if((f|0)==2?1:(c[q>>2]|0)==(e|0)){j=7;break}else d=o;while(1){if(d>>>0>=(c[p>>2]|0)>>>0)break;gy(k,a[d>>0]|0);d=d+1|0}e=c[q>>2]|0;d=f}if((j|0)==7)uaa();e=a[k+11>>0]|0;f=c[k>>2]|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}e=e<<24>>24<0?f:k;g=raa(e)|0;c[m+4>>2]=0;c[m>>2]=57168;g=e+(FD(g)|0)|0;h=g;i=o+128|0;d=0;while(1){if(!((d|0)!=2&e>>>0<g>>>0)){j=21;break}c[q>>2]=e;f=qb[c[(c[m>>2]|0)+16>>2]&15](m,n,e,(h-e|0)>32?e+32|0:g,q,o,i,p)|0;if((f|0)==2?1:(c[q>>2]|0)==(e|0)){j=17;break}else d=o;while(1){if(d>>>0>=(c[p>>2]|0)>>>0)break;Gx(b,c[d>>2]|0);d=d+4|0}e=c[q>>2]|0;d=f}if((j|0)==17)uaa();else if((j|0)==21){a1(k);l=r;return}}function mk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;r=l;l=l+16|0;h=r;a[b>>0]=0;e=c[(c[d>>2]|0)+-12>>2]|0;f=d+e|0;g=c[f+16>>2]|0;if(!g){f=c[f+72>>2]|0;if(f){XB(f)|0;e=c[(c[d>>2]|0)+-12>>2]|0}e=d+e|0;a:do if(c[e+4>>2]&4096|0){O4(h,e);q=u$(c[h>>2]|0,409148)|0;c6(h);k=c[d+(c[(c[d>>2]|0)+-12>>2]|0)+24>>2]|0;m=k;n=m+12|0;o=m+16|0;p=k;b:do if(k|0){while(1){e=c[n>>2]|0;if((e|0)==(c[o>>2]|0))e=nb[c[(c[p>>2]|0)+36>>2]&255](m)|0;else e=raa(c[e>>2]|0)|0;j=d8(e,-1)|0;e=j?0:k;if(j)break b;i=e;j=i+12|0;f=c[j>>2]|0;g=i+16|0;h=e;if((f|0)==(c[g>>2]|0))e=nb[c[(c[h>>2]|0)+36>>2]&255](i)|0;else e=raa(c[f>>2]|0)|0;s=gb[c[(c[q>>2]|0)+12>>2]&31](q,8192,e)|0;f=c[j>>2]|0;e=(f|0)==(c[g>>2]|0);if(!s)break;if(e){nb[c[(c[h>>2]|0)+40>>2]&255](i)|0;continue}else{c[j>>2]=f+4;continue}}if(e)e=nb[c[(c[p>>2]|0)+36>>2]&255](i)|0;else e=raa(c[f>>2]|0)|0;if(!(d8(e,-1)|0))break a}while(0);s=d+(c[(c[d>>2]|0)+-12>>2]|0)|0;C4(s,c[s+16>>2]|6)}while(0);a[b>>0]=(c[d+(c[(c[d>>2]|0)+-12>>2]|0)+16>>2]|0)==0&1}else C4(f,g|4);l=r;return}function nk(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;h=l;l=l+16|0;g=h;a:do if(!(a[e+4>>0]|0)){c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;f=0;while(1){if((f|0)==3)break a;c[b+(f<<2)>>2]=0;f=f+1|0}}else{c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[g+(f<<2)>>2]=0;f=f+1|0}if(a[e+8>>0]|0)gy(g,45);gy(g,((d[e>>0]|0)/10|0)+48<<24>>24);gy(g,(d[e>>0]|0)%10|0|48);gy(g,58);i=e+1|0;gy(g,((d[i>>0]|0)/10|0)+48<<24>>24);gy(g,(d[i>>0]|0)%10|0|48);gy(g,58);i=e+2|0;gy(g,((d[i>>0]|0)/10|0)+48<<24>>24);gy(g,(d[i>>0]|0)%10|0|48);gy(g,a[e+5>>0]|0?59:58);i=e+3|0;j=e+6|0;k=O(a[j>>0]|0?2:1,d[i>>0]|0)|0;f=e+7|0;gy(g,(((k+(d[f>>0]|0)|0)>>>0)/10|0)+48&255);e=O(a[j>>0]|0?2:1,d[i>>0]|0)|0;gy(g,(((e+(d[f>>0]|0)|0)>>>0)%10|0|48)&255);c[b>>2]=c[g>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];f=0;while(1){if((f|0)==3)break;c[g+(f<<2)>>2]=0;f=f+1|0}a1(g)}while(0);l=h;return}function ok(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,l=0;d=b+528|0;f=b+536|0;e=b+1410|0;while(1){j=d;l=c[j+4>>2]|0;i=f;k=c[i+4>>2]|0;if(!(l>>>0<k>>>0|((l|0)==(k|0)?(c[j>>2]|0)>>>0<(c[i>>2]|0)>>>0:0)))break;if(a[e>>0]|0)GC(b);zc(b);if(!(a[e>>0]|0))continue;J3(b)}if(((a[b+1257>>0]|0)!=-1?qO(b)|0:0)?(h=a[b+1183>>0]|0,(h&255)<=16):0){i=b+312|0;l=i;if((c[l>>2]|0)==0&(c[l+4>>2]|0)==0){a[b+1489>>0]=1;j=b+136|0;k=c[j+4>>2]|0;l=b+280|0;c[l>>2]=c[j>>2];c[l+4>>2]=k}d=a[b+1180>>0]|0;if(h<<24>>24!=9)if(d<<24>>24==3){d=a[b+1181>>0]|0;e=12804}else e=12456;else e=12804;l=b+112|0;c[l>>2]=c[e+((d&255)<<2)>>2];c[l+4>>2]=0;if((h&255)>10){k=a[b+1401>>0]|0;l=k<<24>>24==3;np(b,l?1536:((k&255)<<8)+256|0,l?0:0)}else np(b,1536,0);l=b+48|0;l=z0(c[b+612>>2]|0,0,c[l>>2]|0,c[l+4>>2]|0)|0;k=f;k=z0(l|0,z|0,c[k>>2]|0,c[k+4>>2]|0)|0;l=b+40|0;f=b+760|0;if((k|0)==(c[l>>2]|0)?(z|0)==(c[l+4>>2]|0):0){j=i;k=c[j+4>>2]|0;l=f;c[l>>2]=c[j>>2];c[l+4>>2]=k}e=b+728|0;d=c[e>>2]|0;if(!(d&1)){W5(b);d=c[e>>2]|0}if((((d&2|0)==0?(k=i,i=c[k+4>>2]|0,l=f,j=c[l+4>>2]|0,!(i>>>0<j>>>0|((i|0)==(j|0)?(c[k>>2]|0)>>>0<(c[l>>2]|0)>>>0:0))):0)?(t6(b),(a[b+492>>0]|0)==0):0)?+g[(c[b+24>>2]|0)+136>>2]<1.0:0)V5(b)}return}function pk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+16|0;i=m;j=d+8+3|0;e=a[j>>0]|0;f=e<<24>>24<0;k=d+4|0;if(f)e=c[k>>2]|0;else e=e&255;a:do if(!e){c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;e=0;while(1){if((e|0)==3)break a;c[b+(e<<2)>>2]=0;e=e+1|0}}else{if(f)e=c[d>>2]|0;else e=d;f=XY(0,e,0)|0;e=f+1|0;do if(e>>>0>1){g=iaa(e)|0;if((a[j>>0]|0)<0)e=c[d>>2]|0;else e=d;e=XY(g,e,f)|0;if((e+1|0)>>>0<=1){jaa(g);break}a[g+e>>0]=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;f=j9(g)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[b+11>>0]=f;e=b}else{k=f+16&-16;e=ZW(k)|0;c[b>>2]=e;c[b+8>>2]=k|-2147483648;c[b+4>>2]=f}i1(e,g,f)|0;J7(e+f|0,0);jaa(g);break a}while(0);h=iaa(m9()|0)|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;e=0;while(1){if((e|0)==3){g=0;break}c[i+(e<<2)>>2]=0;e=e+1|0}while(1){e=a[j>>0]|0;f=e<<24>>24<0;if(f)e=c[k>>2]|0;else e=e&255;if(g>>>0>=e>>>0)break;if(f)e=c[d>>2]|0;else e=d;e=H4(h,c[e+(g<<2)>>2]|0)|0;if((e|0)>-1)Wx(i,h,e)|0;else gy(i,63);g=g+1|0}jaa(h);wz(b,i);a1(i)}while(0);l=m;return}function qk(){var b=0,d=0;if((a[407784]|0)==0?E3(407784)|0:0){d=409528;do{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}d=d+12|0}while((d|0)!=409816)}IX(409528,402489)|0;IX(409540,402497)|0;IX(409552,402506)|0;IX(409564,402512)|0;IX(409576,402518)|0;IX(409588,402522)|0;IX(409600,402527)|0;IX(409612,402532)|0;IX(409624,402539)|0;IX(409636,402549)|0;IX(409648,402557)|0;IX(409660,402566)|0;IX(409672,402575)|0;IX(409684,402579)|0;IX(409696,402583)|0;IX(409708,402587)|0;IX(409720,402518)|0;IX(409732,402591)|0;IX(409744,402595)|0;IX(409756,402599)|0;IX(409768,402603)|0;IX(409780,402607)|0;IX(409792,402611)|0;IX(409804,402615)|0;return}function rk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a:do if(c[a+8>>2]|0){f=OP(a)|0;b:while(1){if(!f)break a;if((b|0)==(d|0)){b=f;break}KQ(f+16|0,b+16|0)|0;k1(f+28|0,b+28|0)|0;g=yB(f)|0;CA(a,f);e=c[b+4>>2]|0;if(!e)while(1){e=c[b+8>>2]|0;if((c[e>>2]|0)==(b|0)){f=g;b=e;continue b}else b=e}else b=e;while(1){e=c[b>>2]|0;if(!e)break;else b=e}f=g}while(1){e=c[b+8>>2]|0;if(!e)break;b=e}iz(b);b=d}while(0);c:while(1){if((b|0)==(d|0))break;Ut(a,b+16|0);e=c[b+4>>2]|0;if(!e)while(1){e=c[b+8>>2]|0;if((c[e>>2]|0)==(b|0)){b=e;continue c}else b=e}else b=e;while(1){e=c[b>>2]|0;if(!e)break;else b=e}}return}function sk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;i=n+4|0;h=n;if((c[b+784>>2]|0)==0?qO(b)|0:0){TX(i);m=b+520|0;lh(i,c[m>>2]|0)|0;Rf(b,i,3,c[b+20>>2]|0,1);d=Aj(3,1,i,1)|0;e=i9(24440)|0;g=a[d+8+3>>0]|0;j=b+788|0;k=b+916|0;if((e|0)==((g<<24>>24<0?c[d+4>>2]|0:g&255)|0)?(VG(d,24440,e)|0)==0:0){d=ZW(976)|0;zr(d);e=bF(k,j)|0;c[h>>2]=d;f=e+16|0;g=c[f>>2]|0;if(g>>>0<(c[e+20>>2]|0)>>>0){c[g>>2]=d;c[f>>2]=(c[f>>2]|0)+4}else Yy(e+12|0,h)}e=b+761|0;d=0;while(1){h=bF(k,j)|0;if(d>>>0>=(c[h+16>>2]|0)-(c[h+12>>2]|0)>>2>>>0)break;g=m;f=c[g>>2]|0;g=c[g+4>>2]|0;h=m;c[h>>2]=c[j>>2];c[h+4>>2]=0;aY(b,c[(c[(bF(k,j)|0)+12>>2]|0)+(d<<2)>>2]|0);h=m;c[h>>2]=f;c[h+4>>2]=g;a[e>>0]=1;d=d+1|0}k=b+528|0;k=z0(c[k>>2]|0,c[k+4>>2]|0,8,0)|0;h=z;m=b+536|0;j=c[m+4>>2]|0;if(h>>>0<j>>>0|((h|0)==(j|0)?k>>>0<(c[m>>2]|0)>>>0:0))o7(b);z5(i)}l=n;return}function tk(){var b=0,d=0;if((a[407864]|0)==0?E3(407864)|0:0){d=410340;do{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}d=d+12|0}while((d|0)!=410628)}GX(410340,55612)|0;GX(410352,55644)|0;GX(410364,55680)|0;GX(410376,55704)|0;GX(410388,55728)|0;GX(410400,55744)|0;GX(410412,55764)|0;GX(410424,55784)|0;GX(410436,55812)|0;GX(410448,55852)|0;GX(410460,55884)|0;GX(410472,55920)|0;GX(410484,55956)|0;GX(410496,55972)|0;GX(410508,55988)|0;GX(410520,56004)|0;GX(410532,55728)|0;GX(410544,56020)|0;GX(410556,56036)|0;GX(410568,56052)|0;GX(410580,56068)|0;GX(410592,56084)|0;GX(410604,56100)|0;GX(410616,56116)|0;return}function uk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;g=c[b>>2]|0;k=b+4|0;f=c[k>>2]|0;l=((c[d>>2]|0)-g<<3)+(c[d+4>>2]|0)-f|0;n=e+4|0;if((l|0)>0){d=c[n>>2]|0;if(f){i=32-f|0;j=(l|0)<(i|0)?l:i;i=-1>>>(i-j|0)&-1<<f&c[g>>2];g=32-d|0;h=g>>>0<j>>>0?g:j;f=c[e>>2]|0;d=c[f>>2]&~(-1>>>(g-h|0)&-1<<d);c[f>>2]=d;g=c[n>>2]|0;m=c[k>>2]|0;c[f>>2]=(g>>>0>m>>>0?i<<g-m:i>>>(m-g|0))|d;d=(c[n>>2]|0)+h|0;f=f+(d>>>5<<2)|0;c[e>>2]=f;d=d&31;c[n>>2]=d;g=j-h|0;if((g|0)>0){d=c[f>>2]&~(-1>>>(32-g|0));c[f>>2]=d;c[f>>2]=i>>>((c[k>>2]|0)+h|0)|d;c[n>>2]=g;d=g}g=(c[b>>2]|0)+4|0;c[b>>2]=g;l=l-j|0}m=32-d|0;f=-1<<d;h=~f;i=~l;j=(i|0)>-32;k=l+32|0;d=l;while(1){if((d|0)<=31)break;t=c[g>>2]|0;s=c[e>>2]|0;u=c[s>>2]&h;c[s>>2]=u;c[s>>2]=t<<c[n>>2]|u;s=s+4|0;c[e>>2]=s;c[s>>2]=c[s>>2]&f|t>>>m;s=(c[b>>2]|0)+4|0;c[b>>2]=s;d=d+-32|0;g=s}d=l-(k+(j?i:-32)&-32)|0;if((d|0)>0?(r=c[g>>2]&-1>>>(32-d|0),o=(m|0)<(d|0)?m:d,p=c[e>>2]|0,q=c[p>>2]&~(-1<<c[n>>2]&-1>>>(m-o|0)),c[p>>2]=q,c[p>>2]=r<<c[n>>2]|q,q=(c[n>>2]|0)+o|0,p=p+(q>>>5<<2)|0,c[e>>2]=p,c[n>>2]=q&31,q=d-o|0,(q|0)>0):0){c[p>>2]=c[p>>2]&~(-1>>>(32-q|0))|r>>>o;c[n>>2]=q}}c[a>>2]=c[e>>2];c[a+4>>2]=c[n>>2];return}function vk(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=b+612|0;v=b+544|0;p=b+492|0;q=b+48|0;r=b+40|0;e=c[u>>2]|0;t=c[b+548>>2]|0;g=e;a:while(1){if((e+3|0)>>>0>t>>>0){g=e;s=16;break}while(1){f=e+1|0;if((e+3|0)>>>0>t>>>0)continue a;h=c[v>>2]|0;e=h+e|0;if((a[e>>0]|0)==86?(o=a[h+f>>0]|0,(o&255)>=224):0)break;c[u>>2]=f;g=f;e=f}e=(d7(o,a[e+1+1>>0]|0)|0)&8191;n=e&65535;if(a[p>>0]|0?(n+3+g|0)==(t|0):0){s=16;break}m=q;l=c[m>>2]|0;m=c[m+4>>2]|0;i=e&65535;f=z0(i|0,0,3,0)|0;f=z0(f|0,z|0,g|0,0)|0;f=z0(f|0,z|0,l|0,m|0)|0;k=r;j=c[k>>2]|0;k=c[k+4>>2]|0;if((f|0)==(j|0)&(z|0)==(k|0)){s=16;break}if((n+6+g|0)>>>0>t>>>0){e=0;break}h=h+g+3+n|0;e=h+1|0;f=a[e>>0]|0;if(((d7(a[h>>0]|0,f)|0)&-32)<<16>>16==22240){e=(d7(f,a[e+1>>0]|0)|0)&8191;i=z0(i|0,0,6,0)|0;m=z0(i|0,z|0,l|0,m|0)|0;m=z0(m|0,z|0,e&65535|0,0)|0;m=z0(m|0,z|0,g|0,0)|0;if((m|0)==(j|0)&(z|0)==(k|0)){s=16;break}e=e&65535;if((n+9+g+e|0)>>>0>t>>>0){e=0;break}n=h+3+e|0;if(((d7(a[n>>0]|0,a[n+1>>0]|0)|0)&-32)<<16>>16==22240){s=16;break}}e=g+1|0;c[u>>2]=e;g=e}if((s|0)==16){while(1){e=g+2|0;f=g+1|0;if(e>>>0>t>>>0)break;s=c[v>>2]|0;if((a[s+g>>0]|0)==86?(d[s+f>>0]|0)>=224:0)break;c[u>>2]=f;g=f;s=16}if(e>>>0<t>>>0){c[b+908>>2]=5;e=1}else e=0}return e|0}function wk(b){b=b|0;var d=0.0,e=0,f=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;m=n;i=b+728|0;e=c[i>>2]|0;a:do if(!(e&8)){if(e&1){jt(b);e=b+120|0;h=b+144|0;if(((c[h>>2]|0)==-1?(c[h+4>>2]|0)==-1:0)?(h=b+184|0,!((c[h>>2]|0)==-1?(c[h+4>>2]|0)==-1:0)):0){f=b+160|0;h=e+40|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(h|0))}jb[c[(c[b>>2]|0)+60>>2]&511](b);if(c[i>>2]&4|0?(SM(b),a[b+492>>0]|0):0)c[i>>2]=c[i>>2]|4;Al(b);e=c[i>>2]|0}c[i>>2]=e|8;f=b+24|0;d=+g[(c[f>>2]|0)+136>>2];h=b+493|0;i=b+16|0;if((d>=1.0?(a[h>>0]|0)!=0:0)?(k=b+552|0,j=c[k>>2]|0,k=c[k+4>>2]|0,!((j|0)==0&(k|0)==0)):0){e=c[i>>2]|0;if((e|0)==3){c[i>>2]=1;e=1}aL(b,e,0,374296,j,k,1);d=+g[(c[f>>2]|0)+136>>2]}if(d>=1.0?a[h>>0]|0:0){e=b+312|0;k=e;f=c[k+4>>2]|0;switch(c[k>>2]|0){case 0:{if(!f)break a;break}case -1:{if((f|0)==-1)break a;break}default:{}}k=c[i>>2]|0;$x(m,b,k,0,Rb(k,52)|0,1);k=a[m+8+3>>0]|0;k=((k<<24>>24<0?c[m+4>>2]|0:k&255)|0)==0;z5(m);if(k){j=c[i>>2]|0;k=Rb(j,52)|0;m=e;oK(b,j,0,k,c[m>>2]|0,c[m+4>>2]|0,10,0)}}}while(0);l=n;return}function xk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+48|0;f=i+24|0;g=i+12|0;h=i;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[b+(e<<2)>>2]=0;e=e+1|0}uU(g,((d>>>2&1)+(d&1)<<24>>24)+(d>>>1&1)<<24>>24,10);Sn(f,g);e=a[f+11>>0]|0;j=e<<24>>24<0;Wx(b,j?c[f>>2]|0:f,j?c[f+4>>2]|0:e&255)|0;a1(f);z5(g);uU(h,(d>>>9&1)+(d>>>10&1)<<24>>24,10);Sn(g,h);rY(g)|0;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];e=0;while(1){if((e|0)==3)break;c[g+(e<<2)>>2]=0;e=e+1|0}e=a[f+11>>0]|0;j=e<<24>>24<0;Wx(b,j?c[f>>2]|0:f,j?c[f+4>>2]|0:e&255)|0;a1(f);a1(g);z5(h);uU(h,((d>>>4&1)+(d>>>8&1)<<24>>24)+(d>>>5&1)<<24>>24,10);Sn(g,h);rY(g)|0;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];e=0;while(1){if((e|0)==3)break;c[g+(e<<2)>>2]=0;e=e+1|0}j=a[f+11>>0]|0;e=j<<24>>24<0;Wx(b,e?c[f>>2]|0:f,e?c[f+4>>2]|0:j&255)|0;a1(f);a1(g);z5(h);if(d&8|0)JX(b,379402)|0;l=i;return}function yk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;d=k;if(!(a[b+904>>0]|0))a:do if(tu(b+760|0,d,0)|0)if(!(a[d>>0]|0)){j=b+612|0;i=b+544|0;h=c[b+548>>2]|0;d=c[j>>2]|0;b:while(1){b=d;c:while(1){if((b+4|0)>>>0>h>>>0){e=d;d=b;break b}else g=d;while(1){d=b+1|0;if((b+4|0)>>>0>h>>>0){d=g;continue c}f=c[i>>2]|0;e=f+b|0;if((((a[e>>0]|0)==119?(a[f+d>>0]|0)==118:0)?(a[f+(b+2)>>0]|0)==112:0)?(a[f+(b+3)>>0]|0)==107:0)break c;c[j>>2]=d;b=d;g=d}}d=(t7(e+4|0)|0)+8+g|0;if((d+4|0)>>>0>h>>>0){d=0;break a}if((((a[f+d>>0]|0)==119?(a[f+(d+1)>>0]|0)==118:0)?(a[f+(d+2)>>0]|0)==112:0)?(a[f+(d+3)>>0]|0)==107:0){e=g;d=g;break}d=g+1|0;c[j>>2]=d}if((d+4|0)>>>0>h>>>0){if((d+3|0)==(h|0)){g=(c[i>>2]|0)+d|0;d=e+1|0;if((R4(a[g>>0]|0,a[g+1>>0]|0,a[g+2>>0]|0)|0)==7829104){b=e;d=e}else{c[j>>2]=d;b=d}}else b=e;if((d+2|0)==(h|0)){g=(c[i>>2]|0)+d|0;e=b+1|0;if((d7(a[g>>0]|0,a[g+1>>0]|0)|0)<<16>>16==30582)d=b;else{c[j>>2]=e;d=e;b=e}}if((d+1|0)==(h|0)?(D9(a[(c[i>>2]|0)+d>>0]|0)|0)<<24>>24!=119:0){c[j>>2]=b+1;d=0}else d=0}else d=1}else d=1;else d=0;while(0);else d=1;l=k;return d|0}function zk(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;o=l;l=l+16|0;n=o+1|0;g=o;GC(b);a:do if(!(a[b+2461>>0]|0)){h=b+916|0;xR(b,4,h);f=b+648|0;e=0;while(1){if((e|0)>(d[h>>0]|0))break;xR(b,4,g);j=d[g>>0]|0;i=a[b+1046+j>>0]|0;a[b+1302+e>>0]=i;j=a[b+1174+j>>0]|0;a[b+1430+e>>0]=j;i=(j&255)+(b+918+((i&255)<<3))|0;j=d[i>>0]|0;switch(a[b+1558+j>>0]|0){case 0:{c[b+1944+(j<<2)>>2]=0;do{xR(b,8,n);m=a[n>>0]|0;k=b+1944+(d[i>>0]<<2)|0;c[k>>2]=(c[k>>2]|0)+(m&255)}while(m<<24>>24==-1);A6(c[f>>2]|0);break}case 7:case 5:case 3:{d4(c[f>>2]|0,2);break}default:{}}e=e+1|0}}else{j=b+914|0;k=b+915|0;g=b+648|0;e=0;while(1){m=e&255;if((e&255)>(d[j>>0]|0))break a;else f=0;while(1){if((f&255)>(d[k>>0]|0))break;h=(f&255)+(b+918+(m<<3))|0;i=d[h>>0]|0;switch(a[b+1558+i>>0]|0){case 0:{c[b+1944+(i<<2)>>2]=0;do{xR(b,8,n);i=a[n>>0]|0;p=b+1944+(d[h>>0]<<2)|0;c[p>>2]=(c[p>>2]|0)+(i&255)}while(i<<24>>24==-1);break}case 7:case 5:case 3:{d4(c[g>>2]|0,2);break}default:{}}f=f+1<<24>>24}e=e+1<<24>>24}}while(0);J3(b);l=o;return}function Ak(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;k=b+952|0;m=b+956|0;n=b+48|0;r=b+612|0;t=b+656|0;u=b+512|0;v=b+536|0;w=b+528|0;x=b+968|0;l=b+544|0;d=c[k>>2]|0;i=d;j=0;e=i;while(1){if(j>>>0>=(c[m>>2]|0)-d>>5>>>0)break;h=e+(j<<5)+16|0;d=e;if(!((c[h>>2]|0)==0&(c[h+4>>2]|0)==0)?(p=n,o=c[p>>2]|0,p=c[p+4>>2]|0,q=c[r>>2]|0,g=z0(q|0,0,o|0,p|0)|0,s=c[t>>2]|0,g=D_(g|0,z|0,s|0,0)|0,y=z,h=e+(j<<5)+8|0,f=c[h+4>>2]|0,!(y>>>0<f>>>0|((y|0)==(f|0)?g>>>0<(c[h>>2]|0)>>>0:0))):0){e=v;d=c[e>>2]|0;e=c[e+4>>2]|0;g=w;f=c[g>>2]|0;g=c[g+4>>2]|0;y=g>>>0>e>>>0|(g|0)==(e|0)&f>>>0>d>>>0;A=(a[u>>0]|0)==0|y;h=A?d:f;h=h+q|0;if(y){y=z0(f|0,g|0,o|0,p|0)|0;A=x;c[A>>2]=y;c[A+4>>2]=z;A=w;c[A>>2]=d;c[A+4>>2]=e}y=c[l>>2]|0;vU(i+(j<<5)+24|0,y+q+(0-s)|0,y+h|0);y=n;y=z0(c[y>>2]|0,c[y+4>>2]|0,h|0,0)|0;h=z;d=c[k>>2]|0;A=d+(j<<5)+16|0;i=c[A+4>>2]|0;if(h>>>0<i>>>0|((h|0)==(i|0)?y>>>0<(c[A>>2]|0)>>>0:0)){f=d;e=d}else{y=d+(j<<5)+24|0;A=~c[y>>2];c[y>>2]=A;if((c[d+(j<<5)+28>>2]|0)!=(A|0)){d=d+(j<<5)|0;aL(b,0,0,373099,c[d>>2]|0,c[d+4>>2]|0,0);d=c[k>>2]|0}f=d+(j<<5)+16|0;c[f>>2]=0;c[f+4>>2]=0;f=d;e=d}}else f=i;j=j+1|0;i=f}return}function Bk(a,d,f,g,h){a=a|0;d=d|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;k=a+4|0;m=d;do if((k|0)!=(d|0)?(i=b[d+16>>1]|0,(i&65535)<=(h&65535)):0){if((i&65535)<(h&65535)){j=1;g=m}else{c[f>>2]=m;c[g>>2]=m;d=g;break}while(1){if((j|0)<=0)break;i=g;g=c[i+4>>2]|0;a:do if(!g)while(1){g=c[i+8>>2]|0;if((c[g>>2]|0)==(i|0))break a;i=g}else while(1){i=c[g>>2]|0;if(!i)break;else g=i}while(0);j=j+-1|0}i=g;if((i|0)!=(k|0)?(e[g+16>>1]|0)<=(h&65535):0){d=Nu(a,f,h)|0;break}d=d+4|0;if(!(c[d>>2]|0)){c[f>>2]=m;break}else{c[f>>2]=i;d=i;break}}else l=3;while(0);do if((l|0)==3){g=c[d>>2]|0;j=(g|0)==0;if((c[a>>2]|0)!=(d|0)){if(j){i=d;while(1){g=c[i+8>>2]|0;if((c[g>>2]|0)==(i|0))i=g;else break}}else while(1){i=c[g+4>>2]|0;if(!i)break;else g=i}if((e[g+16>>1]|0)>=(h&65535)){d=Nu(a,f,h)|0;break}}else g=m;if(j){c[f>>2]=d;break}else{d=g;c[f>>2]=d;d=d+4|0;break}}while(0);return d|0}function Ck(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+160|0;h=k+136|0;i=k;j=d&255;a:do if(e<<24>>24==2){d=b+8+3|0;if((a[d>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0;f=0}else{y7(b,0);a[d>>0]=0;f=0}while(1){if(f>>>0>=8)break a;d=1<<f;if((j|0)<(d|0))break a;Yv(b,1,d&j|0?49:48)|0;f=f+1|0}}else{f=i+56|0;g=i+4|0;c[i>>2]=1244;c[f>>2]=1264;DO(i+56|0,g);c[i+128>>2]=0;c[i+132>>2]=-1;c[i>>2]=42060;c[f>>2]=42080;aV(g);c[g>>2]=42096;f=i+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[f+(d<<2)>>2]=0;d=d+1|0}c[i+48>>2]=0;c[i+52>>2]=16;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[h+(d<<2)>>2]=0;d=d+1|0}lq(g,h);O0(h);f=i+(c[(c[i>>2]|0)+-12>>2]|0)|0;switch(e<<24>>24){case 8:{d=64;break}case 10:{d=2;break}default:d=e<<24>>24==16?8:0}e=f+4|0;c[e>>2]=c[e>>2]&-75|d;rr(i,j)|0;Hk(h,g);rQ(b,h)|0;O0(h);YX(i)}while(0);tP(b)|0;l=k;return b|0}function Dk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;p=l;l=l+16|0;n=p;W0(n,b+360|0);h=b+20|0;i=c[h>>2]|0;a:do if(i|0?c[i+728>>2]&4|0:0){SM(i);i=(c[h>>2]|0)+728|0;j=c[i>>2]&-5;c[i>>2]=j;h=16;while(1){if((h|0)==32)break a;q=j&~(1<<h);c[i>>2]=q;h=h+1|0;j=q}}while(0);do if(((d|0)<=6?(k=b+28|0,q=c[k>>2]|0,(((c[q+(d*12|0)+4>>2]|0)-(c[q+(d*12|0)>>2]|0)|0)/40|0)>>>0>e>>>0):0)?(q=vn(d)|0,m=b+40|0,b=c[(c[m>>2]|0)+(d*12|0)>>2]|0,!((g|0)>8?1:((((c[b+(e*56|0)+4>>2]|0)-(c[b+(e*56|0)>>2]|0)|0)/40|0)+(((c[q+4>>2]|0)-(c[q>>2]|0)|0)/40|0)|0)>>>0<=f>>>0)):0){q=vn(d)|0;if((((c[q+4>>2]|0)-(c[q>>2]|0)|0)/40|0)>>>0<=f>>>0){m=c[(c[m>>2]|0)+(d*12|0)>>2]|0;q=vn(d)|0;p2(a,DN((c[m+(e*56|0)>>2]|0)+((f-(((c[q+4>>2]|0)-(c[q>>2]|0)|0)/40|0)|0)*40|0)|0,g)|0);break}if((g|0)!=1){p2(a,fm(d,f,g)|0);break}q=c[(c[k>>2]|0)+(d*12|0)>>2]|0;h=c[q+(e*40|0)>>2]|0;if((((c[q+(e*40|0)+4>>2]|0)-h|0)/12|0)>>>0>f>>>0){p2(a,h+(f*12|0)|0);break}else{p2(a,408444);break}}else o=9;while(0);if((o|0)==9)p2(a,408444);s7(c[n>>2]|0);l=p;return}function Ek(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+160|0;i=k+136|0;j=k;a:do if(e<<24>>24==2){f=b+8+3|0;if((a[f>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0}else{y7(b,0);a[f>>0]=0}f=d&65535;e=0;while(1){if(e>>>0>=16)break a;g=1<<e;if((f|0)<(g|0))break a;Yv(b,1,g&f|0?49:48)|0;e=e+1|0}}else{g=j+56|0;h=j+4|0;c[j>>2]=1244;c[g>>2]=1264;DO(j+56|0,h);c[j+128>>2]=0;c[j+132>>2]=-1;c[j>>2]=42060;c[g>>2]=42080;aV(h);c[h>>2]=42096;g=j+36|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[g+(f<<2)>>2]=0;f=f+1|0}c[j+48>>2]=0;c[j+52>>2]=16;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[i+(f<<2)>>2]=0;f=f+1|0}lq(h,i);O0(i);g=j+(c[(c[j>>2]|0)+-12>>2]|0)|0;switch(e<<24>>24){case 8:{f=64;break}case 10:{f=2;break}default:f=e<<24>>24==16?8:0}e=g+4|0;c[e>>2]=c[e>>2]&-75|f;cr(j,d)|0;Hk(i,h);rQ(b,i)|0;O0(i);YX(j)}while(0);tP(b)|0;l=k;return b|0}function Fk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+192|0;j=r+180|0;k=r+168|0;m=r+128|0;n=r+76|0;o=r+24|0;p=r+12|0;q=r;zM(b);i=a[d+8+3>>0]|0;a:do if((i<<24>>24<0?c[d+4>>2]|0:i&255)|0){h=o+12|0;i=n+12|0;g=0;e=0;while(1){if((e|0)==-1)break a;e=oH(d,10,g)|0;f=oH(d,59,g)|0;if(f>>>0<e>>>0){mI(m);lw(k,d,g,e-g|0);p2(j,k);og(m,j);z5(j);O0(k);lw(q,d,g,f-g|0);p2(p,q);p2(o,p);yw(h,m);p2(n,o);yw(i,h);g=as(b,j,n)|0;CN(k,b,n);HH(b,c[j>>2]|0,g,c[k>>2]|0);t2(n);t2(o);z5(p);O0(q);$_(m)}g=e+1|0}}while(0);l=r;return}function Gk(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+160|0;i=k+136|0;j=k;a:do if(e<<24>>24==2){f=b+8+3|0;if((a[f>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0;g=0}else{y7(b,0);a[f>>0]=0;g=0}while(1){if(g>>>0>=32)break a;f=1<<g;if(f>>>0>d>>>0)break a;Yv(b,1,f&d|0?49:48)|0;g=g+1|0}}else{g=j+56|0;h=j+4|0;c[j>>2]=1244;c[g>>2]=1264;DO(j+56|0,h);c[j+128>>2]=0;c[j+132>>2]=-1;c[j>>2]=42060;c[g>>2]=42080;aV(h);c[h>>2]=42096;g=j+36|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[g+(f<<2)>>2]=0;f=f+1|0}c[j+48>>2]=0;c[j+52>>2]=16;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[i+(f<<2)>>2]=0;f=f+1|0}lq(h,i);O0(i);g=j+(c[(c[j>>2]|0)+-12>>2]|0)|0;switch(e<<24>>24){case 8:{f=64;break}case 10:{f=2;break}default:f=e<<24>>24==16?8:0}e=g+4|0;c[e>>2]=c[e>>2]&-75|f;qr(j,d)|0;Hk(i,h);rQ(b,i)|0;O0(i);YX(j)}while(0);tP(b)|0;l=k;return b|0}function Hk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=c[d+48>>2]|0;j=b+4|0;k=b+8|0;i=k+3|0;a:do if(!(e&16)){if(!(e&8)){c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;e=0;while(1){if((e|0)==3)break a;c[b+(e<<2)>>2]=0;e=e+1|0}}f=c[d+8>>2]|0;d=c[d+16>>2]|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=d-f>>2;if(g>>>0>1073741807)uaa();do if(g>>>0>=2){e=g+4&-4;if(e>>>0>1073741823){b=ua(8)|0;K2(b,391652);c[b>>2]=57868;Ya(b|0,2712,367)}else{i=ZW(e<<2)|0;c[b>>2]=i;c[k>>2]=e|-2147483648;c[j>>2]=g;e=i;break}}else{a[i>>0]=g;e=b}while(0);while(1){if((f|0)==(d|0))break;y7(e,c[f>>2]|0);f=f+4|0;e=e+4|0}y7(e,0)}else{g=d+44|0;e=c[g>>2]|0;f=c[d+24>>2]|0;if(e>>>0<f>>>0){c[g>>2]=f;h=f}else h=e;f=c[d+20>>2]|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=h-f>>2;if(g>>>0>1073741807)uaa();do if(g>>>0>=2){e=g+4&-4;if(e>>>0>1073741823){b=ua(8)|0;K2(b,391652);c[b>>2]=57868;Ya(b|0,2712,367)}else{i=ZW(e<<2)|0;c[b>>2]=i;c[k>>2]=e|-2147483648;c[j>>2]=g;e=i;break}}else{a[i>>0]=g;e=b}while(0);while(1){if((f|0)==(h|0))break;y7(e,c[f>>2]|0);f=f+4|0;e=e+4|0}y7(e,0)}while(0);return}function Ik(a){a=a|0;do switch(a<<24>>24){case 16:{a=385574;break}case 17:{a=385566;break}case 18:{a=385558;break}case 19:{a=385550;break}case 24:{a=385538;break}case 25:{a=385526;break}case 26:{a=385514;break}case 27:{a=385502;break}case 32:{a=385492;break}case 33:{a=385482;break}case 40:{a=385469;break}case 41:{a=385456;break}case 42:{a=385443;break}case 48:{a=385421;break}case 49:{a=385399;break}case 50:{a=385377;break}case 51:{a=385355;break}case 52:{a=385333;break}case 53:{a=385311;break}case 54:{a=385289;break}case 55:{a=385267;break}case 56:{a=385248;break}case 57:{a=385229;break}case 58:{a=385210;break}case 59:{a=385191;break}case 60:{a=385172;break}case 61:{a=385153;break}case 62:{a=385134;break}case 63:{a=385115;break}case 64:{a=385098;break}case 65:{a=385081;break}case 66:{a=385064;break}case 67:{a=385047;break}case 72:{a=385015;break}case 73:{a=384983;break}case 74:{a=384951;break}case 75:{a=384919;break}case 76:{a=384887;break}case 77:{a=384855;break}case 80:{a=384849;break}case 81:{a=384843;break}case 82:{a=384837;break}case 83:{a=384831;break}case 88:{a=384813;break}case 89:{a=384795;break}case 90:{a=384777;break}case 91:{a=384759;break}case 96:{a=384727;break}case 97:{a=384695;break}case 98:{a=384663;break}case 99:{a=384631;break}default:a=8800948}while(0);return a|0}function Jk(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;a[d+774>>0]=0;k=d+804|0;e=c[k>>2]|0;if((e|0)!=(c[d+808>>2]|0)){a[e+22556>>0]=0;i=d+816|0;j=d+828|0;h=0;while(1){if((h|0)==256)break;e=c[k>>2]|0;g=e+(h*120|0)+72|0;c[g>>2]=-1;c[g+4>>2]=-1;c[g+8>>2]=-1;c[g+12>>2]=-1;c[g+16>>2]=-1;c[g+20>>2]=-1;c[g+24>>2]=-1;c[g+28>>2]=-1;a[e+(h*120|0)+117>>0]=0;g=0;while(1){f=c[e+(h*120|0)+28>>2]|0;if(g>>>0>=(c[e+(h*120|0)+32>>2]|0)-f>>2>>>0)break;f=c[f+(g<<2)>>2]|0;if(f){Kl(f);e=c[k>>2]|0}g=g+1|0}e=c[i>>2]|0;g=e+(h*120|0)+72|0;c[g>>2]=-1;c[g+4>>2]=-1;c[g+8>>2]=-1;c[g+12>>2]=-1;c[g+16>>2]=-1;c[g+20>>2]=-1;c[g+24>>2]=-1;c[g+28>>2]=-1;a[e+(h*120|0)+117>>0]=0;g=0;while(1){f=c[e+(h*120|0)+28>>2]|0;if(g>>>0>=(c[e+(h*120|0)+32>>2]|0)-f>>2>>>0)break;f=c[f+(g<<2)>>2]|0;if(f){Kl(f);e=c[i>>2]|0}g=g+1|0}e=c[j>>2]|0;g=e+(h*120|0)+72|0;c[g>>2]=-1;c[g+4>>2]=-1;c[g+8>>2]=-1;c[g+12>>2]=-1;c[g+16>>2]=-1;c[g+20>>2]=-1;c[g+24>>2]=-1;c[g+28>>2]=-1;a[e+(h*120|0)+117>>0]=0;g=0;while(1){f=c[e+(h*120|0)+28>>2]|0;if(g>>>0>=(c[e+(h*120|0)+32>>2]|0)-f>>2>>>0)break;f=c[f+(g<<2)>>2]|0;if(f){Kl(f);e=c[j>>2]|0}g=g+1|0}h=h+1|0}a[d+857>>0]=0;b[d+858>>1]=0;a[d+748>>0]=0}return}function Kk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;i=l;l=l+16|0;g=i;h=Sh(a,b,d)|0;k=e+8|0;f=d+8|0;j=f;if(M$(c[k>>2]|0,c[k+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0){c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];e=h+1|0;j=f;f=b+8|0;k=f;if(M$(c[j>>2]|0,c[j+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0){c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d>>2]=c[g>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];j=f;k=a+8|0;if(M$(c[j>>2]|0,c[j+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0){c[g>>2]=c[a>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b>>2]=c[g>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];e=h+3|0}else e=h+2|0}}else e=h;l=i;return e|0}function Lk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0;a:do if(b>>>0<=20)do switch(b|0){case 9:{e=(c[d>>2]|0)+(4-1)&~(4-1);b=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=b;break a}case 10:{e=(c[d>>2]|0)+(4-1)&~(4-1);b=c[e>>2]|0;c[d>>2]=e+4;e=a;c[e>>2]=b;c[e+4>>2]=((b|0)<0)<<31>>31;break a}case 11:{e=(c[d>>2]|0)+(4-1)&~(4-1);b=c[e>>2]|0;c[d>>2]=e+4;e=a;c[e>>2]=b;c[e+4>>2]=0;break a}case 12:{e=(c[d>>2]|0)+(8-1)&~(8-1);b=e;f=c[b>>2]|0;b=c[b+4>>2]|0;c[d>>2]=e+8;e=a;c[e>>2]=f;c[e+4>>2]=b;break a}case 13:{f=(c[d>>2]|0)+(4-1)&~(4-1);e=c[f>>2]|0;c[d>>2]=f+4;e=(e&65535)<<16>>16;f=a;c[f>>2]=e;c[f+4>>2]=((e|0)<0)<<31>>31;break a}case 14:{f=(c[d>>2]|0)+(4-1)&~(4-1);e=c[f>>2]|0;c[d>>2]=f+4;f=a;c[f>>2]=e&65535;c[f+4>>2]=0;break a}case 15:{f=(c[d>>2]|0)+(4-1)&~(4-1);e=c[f>>2]|0;c[d>>2]=f+4;e=(e&255)<<24>>24;f=a;c[f>>2]=e;c[f+4>>2]=((e|0)<0)<<31>>31;break a}case 16:{f=(c[d>>2]|0)+(4-1)&~(4-1);e=c[f>>2]|0;c[d>>2]=f+4;f=a;c[f>>2]=e&255;c[f+4>>2]=0;break a}case 17:{f=(c[d>>2]|0)+(8-1)&~(8-1);g=+h[f>>3];c[d>>2]=f+8;h[a>>3]=g;break a}case 18:{f=(c[d>>2]|0)+(8-1)&~(8-1);g=+h[f>>3];c[d>>2]=f+8;h[a>>3]=g;break a}default:break a}while(0);while(0);return}function Mk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[a+(e<<2)>>2]=0;e=e+1|0}e=b&65535;if((e&3|0)!=3){if(e&1|0)JX(a,384209)|0;if(e&2|0)JX(a,384218)|0}else JX(a,384229)|0;if(e&4|0)JX(a,372336)|0;if((e&16|0)!=0|d)JX(a,372348)|0;if((e&160|0)!=160){if(e&32|0)JX(a,372372)|0;if(e&128|0)JX(a,372384)|0}else JX(a,372358)|0;if(e&2048|0)JX(a,372336)|0;if(e&64|0)JX(a,372394)|0;if(e&256|0)JX(a,372406)|0;if(e&512|0)JX(a,372419)|0;if(e&1024|0)JX(a,372430)|0;if(e&8192|0)JX(a,372442)|0;if((e&49152|0)!=49152){if(e&16384|0)JX(a,372472)|0;if(e&32768|0)JX(a,372484)|0}else JX(a,372456)|0;if(e&8|0)JX(a,379396)|0;if(e&4096|0)JX(a,372498)|0;return}function Nk(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;j=l;l=l+32|0;g=j+28|0;e=j+27|0;f=j+26|0;i=j+12|0;h=j;Bx(d);xR(d,5,g);xR(d,6,e);KS(d);xR(d,6,f);AT(d,j+25|0);AT(d,j+24|0);wK(d);TX(i);g=a[g>>0]|0;uU(h,g,10);k=a[h+8+3>>0]|0;m=k<<24>>24<0;Ex(i,m?c[h>>2]|0:h,m?c[h+4>>2]|0:k&255)|0;z5(h);Gx(i,58);e=a[e>>0]|0;uU(h,e,10);k=a[h+8+3>>0]|0;m=k<<24>>24<0;Ex(i,m?c[h>>2]|0:h,m?c[h+4>>2]|0:k&255)|0;z5(h);Gx(i,58);f=a[f>>0]|0;uU(h,f,10);k=a[h+8+3>>0]|0;m=k<<24>>24<0;Ex(i,m?c[h>>2]|0:h,m?c[h+4>>2]|0:k&255)|0;z5(h);HX(i,35424)|0;if(qO(d)|0){h=d+828|0;e=(f&255)+((e&255)*60|0)+((g&255)*3600|0)|0;if((c[h>>2]|0)==-1)c[h>>2]=e;c[d+832>>2]=e;b[d+846>>1]=-1;HM(d)|0;s_(d);e=0;while(1){if((e&255)>=31)break;AR(d,e&255,0);e=e+1<<24>>24}AR(d,182,0)}z5(i);l=j;return}function Ok(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;s=l;l=l+16|0;p=s;o=a[d+8+3>>0]|0;m=o<<24>>24<0;n=d+4|0;if(m){j=c[n>>2]|0;k=c[d>>2]|0}else{j=o&255;k=d}t=a[e+8+3>>0]|0;u=t<<24>>24<0;i=u?c[e>>2]|0:e;e=u?c[e+4>>2]|0:t&255;do if(j>>>0>=g>>>0){if(e){u=k+(j<<2)|0;g=HA(k+(g<<2)|0,u,i,i+(e<<2)|0)|0;if((g|0)==(u|0)){r=8;break}else g=g-k>>2}if((g|0)!=-1){j=e+g|0;k=a[f+8+3>>0]|0;g=k<<24>>24<0;k=g?c[f+4>>2]|0:k&255;if(!k){lw(p,d,j,-1);p2(b,p);O0(p);break}if(m){e=c[n>>2]|0;i=c[d>>2]|0}else{e=o&255;i=d}g=g?c[f>>2]|0:f;if(e>>>0>=j>>>0?(u=i+(e<<2)|0,t=HA(i+(j<<2)|0,u,g,g+(k<<2)|0)|0,q=t-i>>2,!((t|0)==(u|0)|(q|0)==-1)):0){lw(p,d,j,q-j|0);p2(b,p);O0(p);break}if(!(h&4)){TX(b);break}else{lw(p,d,j,-1);p2(b,p);O0(p);break}}else r=8}else r=8;while(0);if((r|0)==8)TX(b);l=s;return}function Pk(a){a=a|0;var b=0,d=0,e=0,f=0;e=l;l=l+16|0;d=e;c[d>>2]=c[a>>2];c[d+4>>2]=c[a+4>>2];c[d+8>>2]=c[a+8>>2];c[d+12>>2]=c[a+12>>2];BH(d,16);a=(((At(d,16)|0)&65535)<<3)+17|0;b=d+4|0;a:do if(a>>>0<=(raa(c[b>>2]|0)|0)>>>0?(my(d,2)|0)<<24>>24==0:0){if((my(d,3)|0)<<24>>24==7)qW(d,3)|0;b:while(1){switch((my(d,5)|0)<<24>>24){case 0:break b;case 31:{qW(d,5)|0;break}default:{}}a=NF(d)|0;if(a)BH(d,12);if(NF(d)|0)qW(d,11)|0;if(NF(d)|0)qW(d,2)|0;if(NF(d)|0){a=0;break a}do if(!(NF(d)|0)){if(!a){if(!(NF(d)|0))break;BH(d,2)}BH(d,7)}while(0);BH(d,(qW(d,8)|0)<<3)}a=my(d,2)|0;switch(a<<24>>24){case 0:{a=0;break a}case 1:{a=8;break}case 2:{a=32;break}case 3:{a=-128;break}default:{}}f=my(d,2)|0;BH(d,a&255);BH(d,((f&255)<4?-2145384448>>>((f&255)<<3)&255:f)&255);a=(raa(c[b>>2]|0)|0)>>>0>16}else a=0;while(0);l=e;return a|0}function Qk(d){d=d|0;var e=0.0,f=0,g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;o=l;l=l+32|0;m=o+24|0;f=o+30|0;g=o+28|0;i=o;j=o+20|0;k=o+8|0;NB(d,f);ID(d,m);NB(d,g);_C(d,i);r=d+528|0;q=d+536|0;p=c[d+648>>2]|0;n=d+20|0;if(!(DT(c[r>>2]|0,c[r+4>>2]|0,c[q>>2]|0,c[q+4>>2]|0,c[p+4>>2]|0,c[p+8>>2]|0)|0)){RB(d,2,c[n>>2]|0,18,391465,-1,1,0);RB(d,2,c[n>>2]|0,52,391465,-1,1,0)}else{r3(d,j);M5(d);TX(k);r=c[j>>2]|0;q=lh(k,r)|0;Rf(d,q,2,c[n>>2]|0,1);z5(k);q=c[n>>2]|0;TX(k);zb(d,2,q,52,lh(k,r)|0,0);z5(k)}kL(d,2,c[n>>2]|0,122,b[f>>1]|0,10,0);kL(d,2,c[n>>2]|0,147,b[g>>1]|0,10,0);e=+h[i>>3];if(e!=0.0)tY(d,c[n>>2]|0,68,+((c[m>>2]|0)>>>0)/e*1.0e3,3);tY(d,c[n>>2]|0,135,e,0);r=d+520|0;q=r;c[q>>2]=-1;c[q+4>>2]=-1;q=d+772|0;c[q>>2]=-1;a[d+1038>>0]=1;jF(d+760|0,q)|0;c[r>>2]=-1;c[r+4>>2]=-1;PK(d);l=o;return}function Rk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+16|0;e=n+1|0;f=n;GC(b);m=0;do{bB(b,e);k=a[e>>0]|0;m=(k&255)+m|0}while(k<<24>>24==-1);k=0;do{bB(b,f);j=a[f>>0]|0;k=(j&255)+k|0}while(j<<24>>24==-1);J3(b);e=b+528|0;f=e;f=z0(c[f>>2]|0,c[f+4>>2]|0,k|0,0)|0;g=z;h=b+536|0;j=h;i=c[j>>2]|0;j=c[j+4>>2]|0;if(g>>>0>j>>>0|(g|0)==(j|0)&f>>>0>i>>>0){t4(b);m=h;d=e;d=D_(c[m>>2]|0,c[m+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e1(b,d,z)}else{o=h;c[o>>2]=f;c[o+4>>2]=g;do switch(m|0){case 0:{ck(b,d);break}case 1:{hn(b,d);break}case 5:{yv(b,k);break}case 6:{WP(b);break}case 129:{aC(b);break}case 132:{Bw(b);break}case 137:{AZ(b);break}case 144:{h_(b);break}case 147:{n1(b);break}default:e1(b,k,0)}while(0);o=e;c[o>>2]=f;c[o+4>>2]=g;o=h;c[o>>2]=i;c[o+4>>2]=j}l=n;return}function Sk(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a[b+4>>0]=e;a[b+5>>0]=f&1;a[b+6>>0]=0;a[b+7>>0]=0;i=b+1|0;j=b+2|0;k=b+3|0;g=b+8|0;if(!(e<<24>>24)){a[b>>0]=0;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;a[g>>0]=1}else{if((d|0)<0){a[g>>0]=1;h=D_(0,0,c|0,d|0)|0;d=z}else{a[g>>0]=0;h=c}g=e&255;if(f){c=(e&255)>30?4:2;c=((e&255)>60?c+2<<24>>24:c)+((e&255)>90?((e&255)>120?4:2):0)<<24>>24}else c=0;m=c&255;s=m*9|0;n=(g*600|0)-s|0;l=((n|0)<0)<<31>>31;f=nF(h|0,d|0,n|0,l|0)|0;p=z;l=UW(n|0,l|0,f|0,p|0)|0;l=D_(h|0,d|0,l|0,z|0)|0;n=z;m=(g*60|0)-m|0;o=((m|0)<0)<<31>>31;r=g5(l|0,n|0,m|0,o|0)|0;q=z;p=UW(s|0,0,f|0,p|0)|0;g=z;f=c&255;c=UW(r|0,q|0,f|0,0)|0;c=z0(c|0,z|0,h|0,d|0)|0;g=z0(c|0,z|0,p|0,g|0)|0;c=z;d=e&255;if(!(o>>>0>n>>>0|(o|0)==(n|0)&m>>>0>l>>>0)?(s=nF(g|0,c|0,d|0,0)|0,s=pB(s|0,z|0,60,0)|0,(s|0)==0&(z|0)==0):0){s=pB(g|0,c|0,d|0,0)|0;r=z;s=(r|0)<0|(r|0)==0&s>>>0<f>>>0;g=D_(g|0,c|0,(s?f:0)|0,(s?0:0)|0)|0;c=z}r=pB(g|0,c|0,d|0,0)|0;a[k>>0]=r;r=nF(g|0,c|0,d|0,0)|0;s=z;q=pB(r|0,s|0,60,0)|0;a[j>>0]=q;q=nF(r|0,s|0,60,0)|0;q=pB(q|0,z|0,60,0)|0;a[i>>0]=q;s=nF(r|0,s|0,3600,0)|0;s=pB(s|0,z|0,24,0)|0;a[b>>0]=s}return}function Tk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+32|0;j=m+12|0;k=m;g=an(b)|0;h=z;if(qO(b)|0?(c[b+880>>2]|0)>>>0<=1:0){VU(j,382808);i=b+760|0;d=b+840|0;e=kE(i,d)|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;f=j9(373189)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[k+11>>0]=f;b=k}else{n=f+16&-16;b=ZW(n)|0;c[k>>2]=b;c[k+8>>2]=n|-2147483648;c[k+4>>2]=f}i1(b,373189,f)|0;J7(b+f|0,0);vF(VC(e+88|0,k)|0,j)|0;a1(k);z5(j);if(h>>>0<0|(h|0)==0&g>>>0<2){VU(j,c[33624+(g<<2)>>2]|0);d=kE(i,d)|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;e=j9(373258)|0;if(e>>>0>4294967279)uaa();if(e>>>0<11){a[k+11>>0]=e;b=k}else{n=e+16&-16;b=ZW(n)|0;c[k>>2]=b;c[k+8>>2]=n|-2147483648;c[k+4>>2]=e}i1(b,373258,e)|0;J7(b+e|0,0);vF(VC(d+88|0,k)|0,j)|0;a1(k);z5(j)}}l=m;return}function Uk(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;z=l;l=l+336|0;o=z+48|0;n=z+32|0;i=z+24|0;g=z+8|0;m=z;r=z+300|0;p=z+296|0;s=z+68|0;w=z+64|0;u=z+60|0;v=z+56|0;q=m;c[q>>2]=37;c[q+4>>2]=0;q=d+4|0;j=Ux(m+1|0,8800948,c[q>>2]|0)|0;c[p>>2]=r;a=b0()|0;k=d+8|0;if(j){c[g>>2]=c[k>>2];h[g+8>>3]=f;a=dR(r,30,a,m,g)|0}else{h[i>>3]=f;a=dR(r,30,a,m,i)|0}if((a|0)>29){a=b0()|0;if(j){c[n>>2]=c[k>>2];h[n+8>>3]=f;g=wS(p,a,m,n)|0}else{h[o>>3]=f;g=wS(p,a,m,o)|0}a=c[p>>2]|0;if(!a)uaa();else{t=g;B=a;y=a}}else{t=a;B=0;y=r}i=y+t|0;g=kB(y,i,c[q>>2]|0)|0;do if((y|0)!=(r|0)){a=Ub(t<<3)|0;if(!a)uaa();else{x=a;A=0;C=a;break}}else{x=s;A=1;C=0}while(0);O4(v,d);Gg(y,g,i,x,w,u,v);c6(v);a=bn(c[b>>2]|0,x,c[w>>2]|0,c[u>>2]|0,d,e)|0;c[b>>2]=a;if(!A)pe(C);pe(B);l=z;return a|0}function Vk(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;z=l;l=l+336|0;o=z+48|0;n=z+32|0;i=z+24|0;g=z+8|0;m=z;r=z+300|0;p=z+296|0;s=z+68|0;w=z+64|0;u=z+60|0;v=z+56|0;q=m;c[q>>2]=37;c[q+4>>2]=0;q=d+4|0;j=Ux(m+1|0,402219,c[q>>2]|0)|0;c[p>>2]=r;a=b0()|0;k=d+8|0;if(j){c[g>>2]=c[k>>2];h[g+8>>3]=f;a=dR(r,30,a,m,g)|0}else{h[i>>3]=f;a=dR(r,30,a,m,i)|0}if((a|0)>29){a=b0()|0;if(j){c[n>>2]=c[k>>2];h[n+8>>3]=f;g=wS(p,a,m,n)|0}else{h[o>>3]=f;g=wS(p,a,m,o)|0}a=c[p>>2]|0;if(!a)uaa();else{t=g;B=a;y=a}}else{t=a;B=0;y=r}i=y+t|0;g=kB(y,i,c[q>>2]|0)|0;do if((y|0)!=(r|0)){a=Ub(t<<3)|0;if(!a)uaa();else{x=a;A=0;C=a;break}}else{x=s;A=1;C=0}while(0);O4(v,d);Gg(y,g,i,x,w,u,v);c6(v);a=bn(c[b>>2]|0,x,c[w>>2]|0,c[u>>2]|0,d,e)|0;c[b>>2]=a;if(!A)pe(C);pe(B);l=z;return a|0}function Wk(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;o=l;l=l+16|0;n=o;Ww(n,e);e=oH(n,61,0)|0;j=n+8+3|0;h=a[j>>0]|0;k=n+4|0;i=h<<24>>24<0;do if((e|0)==-1)if(i){e=c[k>>2]|0;break}else{e=h&255;break}while(0);p=i?c[n>>2]|0:n;g=p+(e<<2)|0;e=p;while(1){if((e|0)==(g|0))break;c[e>>2]=X7(c[e>>2]|0)|0;e=e+4|0}e=i9(10408)|0;g=c[k>>2]|0;do if((e|0)==((i?g:h&255)|0)){if(VG(n,10408,e)|0){h=a[j>>0]|0;g=c[k>>2]|0;m=16;break}h=i9(42196)|0;i=f+8+3|0;g=a[i>>0]|0;j=f+4|0;e=c[j>>2]|0;if((h|0)==((g<<24>>24<0?e:g&255)|0))if(!(VG(f,42196,h)|0))e=0;else{g=a[i>>0]|0;e=c[j>>2]|0;m=14}else m=14;if((m|0)==14)e=((g<<24>>24<0?e:g&255)|0)!=0;FR(d,e);Xy(b,409096)}else m=16;while(0);do if((m|0)==16){e=i9(10472)|0;if((e|0)==((h<<24>>24<0?g:h&255)|0)?(VG(n,10472,e)|0)==0:0){p=SR(d)|0;VU(b,p?385588:401470);break}Xy(b,10552)}while(0);O0(n);l=o;return}function Xk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=b+1008|0;i=f;g=b+612|0;a:do if((c[i>>2]|0)==0&(c[i+4>>2]|0)==0){h=b+48|0;i=c[g>>2]|0;h=z0(c[h>>2]|0,c[h+4>>2]|0,-4,-1)|0;i=z0(h|0,z|0,i|0,0)|0;h=b+1e3|0;c[h>>2]=i;c[h+4>>2]=z;Mt(b);h=b+764|0;i=b+1038|0;d=c[b+760>>2]|0;b:while(1){if((d|0)==(h|0))break a;e=c[d+24>>2]|0;if(!((e|0)!=(c[d+28>>2]|0)?(c[e>>2]|0)!=0:0))j=6;if((j|0)==6?(j=0,(c[d+36>>2]|0)!=1954051187):0){a[d+104>>0]=0;a[i>>0]=(a[i>>0]|0)+-1<<24>>24}e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue b}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}}while(0);j=b+536|0;i=c[j+4>>2]|0;c:do if(i>>>0<0|(i|0)==0&(c[j>>2]|0)>>>0<12)c3(c[b+508>>2]|0,c[b+668>>2]|0);else{if((C9((c[b+544>>2]|0)+(c[g>>2]|0)+8|0)|0)==1919247136)a[b+1039>>0]=1;if(!(a[b+1047>>0]|0)){i=HN(b,0)|0;j=f;i=z0(c[j>>2]|0,c[j+4>>2]|0,i|0,z|0)|0;j=f;c[j>>2]=i;c[j+4>>2]=z}do if(!(a[b+1040>>0]|0)){if((a[b+1038>>0]|0)==0?(c[b+800>>2]|0)==0:0)break;Xe(b);break c}while(0);i=HN(b,0)|0;j=b+528|0;c[j>>2]=i;c[j+4>>2]=z}while(0);return}function Yk(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=b+768|0;d=c[h>>2]|0;a:do if(d|0?(c[d+80>>2]|0)!=(c[d+84>>2]|0):0){i=b+64|0;g=0;f=d;while(1){if((g|0)==8192)break;RZ(c[(c[f+80>>2]|0)+(g<<2)>>2]|0,0);d=c[h>>2]|0;e=c[(c[d+80>>2]|0)+(g<<2)>>2]|0;f=e+96|0;c[f>>2]=-1;c[f+4>>2]=-1;a[e+114>>0]=0;f=e+104|0;c[f>>2]=-1;c[f+4>>2]=-1;f=e+80|0;if(!((c[f>>2]|0)==-1?(c[f+4>>2]|0)==-1:0)){TZ(e,1);d=c[h>>2]|0;e=c[(c[d+80>>2]|0)+(g<<2)>>2]|0}if(c[e>>2]|0){wZ(e,0);d=c[(c[(c[h>>2]|0)+80>>2]|0)+(g<<2)>>2]|0;if(a[(c[d>>2]|0)+784>>0]|0){EZ(d,1);d=c[(c[(c[h>>2]|0)+80>>2]|0)+(g<<2)>>2]|0}f=i;d=c[d>>2]|0;if((c[f>>2]|0)==0&(c[f+4>>2]|0)==0){f=d+752|0;c[f>>2]=0;c[f+4>>2]=0}Kl(d);d=c[h>>2]|0}g=g+1|0;f=d}d=f+40|0;e=f+48+3|0;if((a[e>>0]|0)<0){y7(c[d>>2]|0,0);c[f+44>>2]=0}else{y7(d,0);a[e>>0]=0}Ed(b,0,0,92);Ed(b,0,0,100);d=0;while(1){if(d>>>0>=(RA(b,6,-1)|0)>>>0)break a;Ed(b,6,d,37);d=d+1|0}}while(0);return}function Zk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+16|0;h=m+12|0;i=m;Nr(b);W0(h,b+360|0);j=b+84|0;e=c[j>>2]|0;k=b+88|0;while(1){f=c[k>>2]|0;if((f|0)==(e|0))break;f=f+-12|0;c[k>>2]=f;z5(f)}kQ(i,b+80|0);e=i9(4848)|0;f=a[i+8+3>>0]|0;if((e|0)==((f<<24>>24<0?c[i+4>>2]|0:f&255)|0)){f=(VG(i,4848,e)|0)==0;z5(i);if(f){Xy(i,22884);z3(j,i);z5(i);p2(i,d);og(j,i);z5(i)}else g=8}else{z5(i);g=8}if((g|0)==8?(g=a[d+8+3>>0]|0,(g<<24>>24<0?c[d+4>>2]|0:g&255)|0):0){p2(i,d);e=c[k>>2]|0;if(e>>>0<(c[b+92>>2]|0)>>>0){rV(e,i);c[k>>2]=(c[k>>2]|0)+12}else Dx(j,i);z5(i)}do if((c[j>>2]|0)!=(c[k>>2]|0)){c[b+136>>2]=1;a[b+221>>0]=0;s7(c[h>>2]|0);if((c[b+352>>2]|0)!=1){jb[c[(c[b>>2]|0)+8>>2]&511](b);e=sr(b,0,-1)|0;break}e=b+356|0;if(!(a[e>>0]|0)){OH(b);a[e>>0]=1;e=0}else e=0}else{s7(c[h>>2]|0);e=0}while(0);l=m;return e|0}function _k(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+16|0;k=d;j=q;o=b+11|0;f=a[o>>0]|0;h=f<<24>>24<0;p=b+4|0;g=f&255;if(h){m=c[p>>2]|0;i=(c[b+8>>2]&2147483647)+-1|0}else{m=g;i=10}n=e-k|0;do if(n|0){if(h){h=c[b>>2]|0;g=c[p>>2]|0}else h=b;if(I2(d,h,h+g|0)|0){c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;if(n>>>0>4294967279)uaa();h=j+4|0;i=j+11|0;if(n>>>0<11){a[i>>0]=n;g=j}else{p=n+16&-16;g=ZW(p)|0;c[j>>2]=g;c[j+8>>2]=p|-2147483648;c[h>>2]=n}f=g;while(1){if((d|0)==(e|0))break;J7(f,a[d>>0]|0);d=d+1|0;f=f+1|0}J7(g+n|0,0);e=a[i>>0]|0;p=e<<24>>24<0;Wx(b,p?c[j>>2]|0:j,p?c[h>>2]|0:e&255)|0;a1(j);break}j=m+n|0;if((i-m|0)>>>0<n>>>0){zz(b,i,j-i|0,m,m);f=a[o>>0]|0}if(f<<24>>24<0)h=c[b>>2]|0;else h=b;g=m-k|0;f=h+m|0;while(1){if((d|0)==(e|0))break;J7(f,a[d>>0]|0);f=f+1|0;d=d+1|0}J7(h+(e+g)|0,0);if((a[o>>0]|0)<0){c[p>>2]=j;break}else{a[o>>0]=j;break}}while(0);l=q;return b|0}function $k(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+32|0;i=k+12|0;j=k;g=an(b)|0;if(qO(b)|0?(c[b+880>>2]|0)>>>0<=1:0){VU(i,382808);h=b+760|0;d=b+840|0;e=kE(h,d)|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;f=j9(373189)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[j+11>>0]=f;b=j}else{m=f+16&-16;b=ZW(m)|0;c[j>>2]=b;c[j+8>>2]=m|-2147483648;c[j+4>>2]=f}i1(b,373189,f)|0;J7(b+f|0,0);vF(VC(e+88|0,j)|0,i)|0;a1(j);z5(i);VU(i,Zx(g&255)|0);d=kE(h,d)|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;e=j9(373233)|0;if(e>>>0>4294967279)uaa();if(e>>>0<11){a[j+11>>0]=e;b=j}else{m=e+16&-16;b=ZW(m)|0;c[j>>2]=b;c[j+8>>2]=m|-2147483648;c[j+4>>2]=e}i1(b,373233,e)|0;J7(b+e|0,0);vF(VC(d+88|0,j)|0,i)|0;a1(j);z5(i)}l=k;return}function al(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;j=b+612|0;i=c[j>>2]|0;l=b+544|0;k=c[b+548>>2]|0;e=i;while(1){if((e+4|0)>>>0>k>>>0)break;h=c[l>>2]|0;if(((a[h+e>>0]|0)==0?(a[h+(e+1)>>0]|0)==0:0)?(a[h+(e+2)>>0]|0)==1:0)break;while(1){f=e+2|0;c[j>>2]=f;if(f>>>0>=k>>>0){g=9;break}if(!(a[h+f>>0]|0)){g=8;break}else e=f}if((g|0)==8){e=e+1|0;if(a[h+e>>0]|0){e=f;continue}}else if((g|0)==9)e=e+1|0;c[j>>2]=e}if(e>>>0>i>>>0?(d=e+-1|0,(a[(c[l>>2]|0)+d>>0]|0)==0):0)c[j>>2]=d;else d=e;do if((d+4|0)==(k|0)){i=c[l>>2]|0;e=d+1|0;if((((a[i+d>>0]|0)==0?(a[i+e>>0]|0)==0:0)?(a[i+(d+2)>>0]|0)==0:0)?(a[i+(d+3)>>0]|0)==1:0)break;c[j>>2]=e;d=e}while(0);do if((d+3|0)==(k|0)){i=c[l>>2]|0;e=d+1|0;if(((a[i+d>>0]|0)==0?(a[i+e>>0]|0)==0:0)?(a[i+(d+2)>>0]|0)==1:0)break;c[j>>2]=e;d=e}while(0);do if((d+2|0)==(k|0)){i=c[l>>2]|0;e=d+1|0;if((a[i+d>>0]|0)==0?(a[i+e>>0]|0)==0:0)break;c[j>>2]=e;d=e}while(0);if((d+1|0)==(k|0)?(a[(c[l>>2]|0)+d>>0]|0)!=0:0){c[j>>2]=k;d=k}a:do if((d+4|0)>>>0>k>>>0)d=0;else{k=b+48|0;b:do if((d|0)==0&((c[k>>2]|0)==0&(c[k+4>>2]|0)==0)){switch(a[(c[l>>2]|0)+3>>0]|0){case -2:case -32:break;default:break b}z$(b);d=0;break a}while(0);a[b+376>>0]=1;d=1}while(0);return d|0}function bl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+48|0;k=n+24|0;m=n+12|0;h=n;W0(k,407712);p2(m,e);p2(h,d);vF(_0(407644,h,1)|0,m)|0;z5(h);z5(m);s7(c[k>>2]|0);Ww(k,d);d=oH(k,61,0)|0;i=k+8+3|0;f=a[i>>0]|0;j=k+4|0;g=f<<24>>24<0;do if((d|0)==-1)if(g){d=c[j>>2]|0;break}else{d=f&255;break}while(0);g=g?c[k>>2]|0:k;f=g+(d<<2)|0;d=g;while(1){if((d|0)==(f|0))break;c[d>>2]=X7(c[d>>2]|0)|0;d=d+4|0}TX(m);p2(h,e);vF(m,h)|0;z5(h);d=a[i>>0]|0;f=c[j>>2]|0;g=d<<24>>24<0?f:d&255;a:do if(!g)TX(b);else{do if((i9(3824)|0)==(g|0))if(!(VG(k,3824,g)|0)){R5(b);break a}else{g=a[i>>0]|0;f=c[j>>2]|0;break}else g=d;while(0);d=i9(3876)|0;if((d|0)==((g<<24>>24<0?f:g&255)|0)?(VG(k,3876,d)|0)==0:0){i6(b);break}Xy(b,10552)}while(0);z5(m);O0(k);l=n;return}function cl(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0;p=l;l=l+16|0;n=p;d=e;while(1){if((d|0)==(f|0)){d=f;break}if(!(c[d>>2]|0))break;d=d+4|0}c[j>>2]=h;c[g>>2]=e;m=i;o=b+8|0;a:while(1){if((h|0)==(i|0)|(e|0)==(f|0)){q=33;break}b=a0(c[o>>2]|0)|0;k=Co(h,g,d-e>>2,m-h|0)|0;if(b|0)a0(b)|0;switch(k|0){case -1:{q=10;break a}case 0:{e=1;break a}default:{}}h=(c[j>>2]|0)+k|0;c[j>>2]=h;if((h|0)==(i|0)){q=32;break}if((d|0)==(f|0)){e=c[g>>2]|0;d=f;continue}h=a0(c[o>>2]|0)|0;e=qw(n,0)|0;if(h|0)a0(h)|0;if((e|0)==-1){e=2;q=31;break}if(e>>>0>(m-(c[j>>2]|0)|0)>>>0){e=1;q=31;break}else h=n;while(1){if(!e)break;b=a[h>>0]|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k>>0]=b;h=h+1|0;e=e+-1|0}e=(c[g>>2]|0)+4|0;c[g>>2]=e;d=e;while(1){if((d|0)==(f|0)){d=f;break}if(!(c[d>>2]|0))break;d=d+4|0}h=c[j>>2]|0}if((q|0)==10){c[j>>2]=h;while(1){if((e|0)==(c[g>>2]|0))break;f=c[e>>2]|0;d=a0(c[o>>2]|0)|0;h=qw(h,f)|0;if(d|0)a0(d)|0;if((h|0)==-1)break;h=(c[j>>2]|0)+h|0;c[j>>2]=h;e=e+4|0}c[g>>2]=e;e=2}else if((q|0)!=31)if((q|0)==32){e=c[g>>2]|0;q=33}if((q|0)==33)e=(e|0)!=(f|0)&1;l=p;return e|0}function dl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;CK(b);h=b+528|0;k=h;k=z0(c[k>>2]|0,c[k+4>>2]|0,10,0)|0;c[h>>2]=k;c[h+4>>2]=z;h=b+48|0;k=h;i=b+612|0;j=c[i>>2]|0;k=z0(c[k>>2]|0,c[k+4>>2]|0,-24,-1)|0;j=z0(k|0,z|0,j|0,0)|0;oK(b,0,0,142,j,z,10,0);j=HN(b,0)|0;j=z0(j|0,z|0,24,0)|0;oK(b,0,0,143,j,z,10,0);j=b+832|0;c[j>>2]=0;k=b+764|0;l=b+823|0;d=c[b+760>>2]|0;a:while(1){if((d|0)==(k|0))break;f=d+24|0;do if(a[l>>0]|0){if(c[f>>2]|0){e=d+16|0;g=10;break}if((c[d+56>>2]|0)>>>0>32767){g=ZW(1128)|0;Wr(g);c[f>>2]=g;e=g+896|0;c[e>>2]=8;c[e+4>>2]=0;aY(b,g);g=8}else g=8}else g=8;while(0);if((g|0)==8){g=0;e=d+16|0;if(!((c[f>>2]|0)==0?(c[d+36>>2]|0)!=1:0))g=10}if((g|0)==10){a[e+61>>0]=1;c[j>>2]=(c[j>>2]|0)+1}e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue a}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}a[b+495>>0]=1;j=h;j=z0(c[i>>2]|0,0,c[j>>2]|0,c[j+4>>2]|0)|0;l=z;k=HN(b,0)|0;k=z0(j|0,l|0,k|0,z|0)|0;l=b+864|0;c[l>>2]=k;c[l+4>>2]=z;return}function el(a){a=a|0;do switch(a<<16>>16){case 100:{a=402006;break}case 101:{a=376919;break}case 102:{a=376919;break}case 103:{a=376931;break}case 104:{a=376927;break}case 105:{a=376923;break}case 106:{a=376919;break}case 107:{a=376911;break}case 108:{a=376531;break}case 109:{a=376897;break}case 110:{a=376880;break}case 111:{a=376854;break}case 112:{a=376820;break}case 113:{a=376814;break}case 114:{a=376808;break}case 115:{a=376799;break}case 116:{a=376790;break}case 117:{a=376778;break}case 118:{a=376766;break}case 119:{a=376754;break}case 120:{a=376742;break}case 121:{a=376726;break}case 122:{a=376710;break}case 123:{a=376694;break}case 124:{a=376678;break}case 125:{a=376659;break}case 126:{a=376637;break}case 127:{a=376615;break}case 128:{a=376592;break}case 129:{a=376570;break}case 130:{a=376548;break}case 131:{a=376541;break}case 132:{a=376531;break}case 133:{a=376523;break}case 134:{a=376512;break}case 135:{a=376498;break}case 136:{a=376488;break}case 137:{a=376475;break}case 138:{a=376461;break}case 139:{a=376446;break}case 140:{a=376426;break}case 141:{a=376410;break}case 142:{a=376391;break}case 143:{a=376371;break}case 144:{a=376348;break}case 145:{a=376293;break}case 146:{a=376219;break}case 147:{a=8800948;break}default:a=8800948}while(0);return a|0}function fl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+32|0;i=k+12|0;j=k;g=an(b)|0;if(qO(b)|0?(c[b+880>>2]|0)>>>0<=1:0){VU(i,382808);h=b+760|0;d=b+840|0;e=kE(h,d)|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;f=j9(373189)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[j+11>>0]=f;b=j}else{m=f+16&-16;b=ZW(m)|0;c[j>>2]=b;c[j+8>>2]=m|-2147483648;c[j+4>>2]=f}i1(b,373189,f)|0;J7(b+f|0,0);vF(VC(e+88|0,j)|0,i)|0;a1(j);z5(i);VU(i,mD(g&255)|0);d=kE(h,d)|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;e=j9(373216)|0;if(e>>>0>4294967279)uaa();if(e>>>0<11){a[j+11>>0]=e;b=j}else{m=e+16&-16;b=ZW(m)|0;c[j>>2]=b;c[j+8>>2]=m|-2147483648;c[j+4>>2]=e}i1(b,373216,e)|0;J7(b+e|0,0);vF(VC(d+88|0,j)|0,i)|0;a1(j);z5(i)}l=k;return}function gl(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;GC(b);a:do if(!(a[b+2461>>0]|0)){i=b+916|0;h=b+648|0;g=0;while(1){f=g&255;if((g&255)>(d[i>>0]|0))break a;f=d[(d[b+1430+f>>0]|0)+(b+918+(d[b+1302+f>>0]<<3))>>0]|0;switch(a[b+1558+f>>0]|0){case 0:{Yl(b);break}case 1:{G4(c[h>>2]|0,(e[b+1686+(f<<1)>>1]<<3)+160|0);break}default:{GC(b);J3(b)}}g=g+1<<24>>24}}else{j=b+914|0;k=b+915|0;l=b+734|0;m=b+896|0;h=b+648|0;f=0;while(1){n=f&255;if((f&255)>(d[j>>0]|0))break a;else g=0;while(1){if((g&255)>(d[k>>0]|0))break;i=d[(g&255)+(b+918+(n<<3))>>0]|0;b:do switch(a[b+1558+i>>0]|0){case 0:if(!(a[l>>0]|0)){Yl(b);break b}else{G4(c[h>>2]|0,c[b+1944+(i<<2)>>2]<<3);i=m;c[i>>2]=0;c[i+4>>2]=0;break b}case 1:{G4(c[h>>2]|0,(e[b+1686+(i<<1)>>1]<<3)+160|0);break}default:{GC(b);i=c[h>>2]|0;G4(i,Z9(c[i+4>>2]|0)|0);J3(b)}}while(0);g=g+1<<24>>24}f=f+1<<24>>24}}while(0);J3(b);return}function hl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a:do if(c[a+8>>2]|0){f=OP(a)|0;b:while(1){if(!f)break a;if((b|0)==(d|0)){b=f;break}k1(f+16|0,b+16|0)|0;k1(f+28|0,b+28|0)|0;g=yB(f)|0;IC(a,f);e=c[b+4>>2]|0;if(!e)while(1){e=c[b+8>>2]|0;if((c[e>>2]|0)==(b|0)){f=g;b=e;continue b}else b=e}else b=e;while(1){e=c[b>>2]|0;if(!e)break;else b=e}f=g}while(1){e=c[b+8>>2]|0;if(!e)break;b=e}VD(b);b=d}while(0);c:while(1){if((b|0)==(d|0))break;$v(a,b+16|0);e=c[b+4>>2]|0;if(!e)while(1){e=c[b+8>>2]|0;if((c[e>>2]|0)==(b|0)){b=e;continue c}else b=e}else b=e;while(1){e=c[b>>2]|0;if(!e)break;else b=e}}return}function il(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+816|0;n=p;o=p+792|0;i=p+805|0;e=p+804|0;GC(b);PP(n);aY(b,n);GC(b);c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;bB(b,i);j=a[i>>0]|0;k=j&255;MI(o,k+1|0);g=0;f=0;while(1){if((f|0)==(k|0))break;bB(b,e);m=d[e>>0]|0;c[(c[o>>2]|0)+(f<<2)>>2]=m;g=m+g|0;f=f+1|0}J3(b);m=b+528|0;e=m;e=z0(c[e>>2]|0,c[e+4>>2]|0,g|0,0)|0;f=z;h=b+536|0;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0)){e=D_(g|0,h|0,e|0,f|0)|0;f=c[o>>2]|0;c[f+(k<<2)>>2]=e;e=j+1<<24>>24;a[i>>0]=e;e=e&255;g=0;while(1){if(g>>>0>=e>>>0)break;iA(b,n,c[f+(g<<2)>>2]|0);iA(b,n,0);k=c[o>>2]|0;i=m;i=z0(c[i>>2]|0,c[i+4>>2]|0,c[k+(g<<2)>>2]|0,0)|0;j=m;c[j>>2]=i;c[j+4>>2]=z;f=k;g=g+1|0}G2(b,n);m=b+20|0;Gb(b,n,c[b+16>>2]|0,0,c[m>>2]|0,1)|0;Ed(b,2,c[m>>2]|0,147);J3(b)}cU(o);OW(n);l=p;return}function jl(f){f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;GC(f);p=f+2510|0;o=f+19544|0;n=0;a:while(1){g=a[p>>0]|0;if((n|0)>=(g&255|0)){g=23;break}if((g&255)>1)GC(f);m=f+19545+n|0;j=0;while(1){h=j&255;if((j&255)>=(d[m>>0]|0))break;k=f+19553+(n<<6)+h|0;g=a[k>>0]|0;b:do switch(g<<24>>24){case 15:case 14:case 13:case 0:break;default:{l=f+21090+(n<<7)+(h<<1)|0;i=b[l>>1]|0;if((i&65535)>>>0>=((d[o>>0]|0)+1|0)>>>0){g=9;break a}h=b[f+2520+(n<<11)+((e[f+20066+(n<<7)+(h<<1)>>1]|0)<<1)>>1]|0;while(1){if((h&65535)>=(e[f+2520+(n<<11)+((i&65535)<<1)>>1]|0))break b;vm(f,g);if(!(qO(f)|0)){g=15;break a}g=a[k>>0]|0;h=((g&255)<5?4:2)+(h&65535)&65535;i=b[l>>1]|0}}}while(0);j=j+1<<24>>24}if((d[p>>0]|0)>1)J3(f);n=n+1|0}if((g|0)==9){t4(f);o=c[f+648>>2]|0;G4(o,Z9(c[o+4>>2]|0)|0);if((d[p>>0]|0)>1)J3(f);J3(f)}else if((g|0)==15){o=c[f+648>>2]|0;G4(o,Z9(c[o+4>>2]|0)|0);if((d[p>>0]|0)>1)J3(f);J3(f)}else if((g|0)==23)J3(f);return}function kl(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;k=l;l=l+32|0;e=k;f=k+16|0;g=k+12|0;h=k+8|0;i=k+21|0;j=k+20|0;m=b+528|0;o=m;o=z0(c[o>>2]|0,c[o+4>>2]|0,4,0)|0;n=m;c[n>>2]=o;c[n+4>>2]=z;jB(b,f);jB(b,g);Bx(b);rR(b,20,h);xR(b,3,i);xR(b,5,j);RP(b,e);wK(b);n=m;n=z0(c[n>>2]|0,c[n+4>>2]|0,16,0)|0;c[m>>2]=n;c[m+4>>2]=z;m=(qO(b)|0)^1;h=c[h>>2]|0;if(!((h|0)==0|m)){o=b+760|0;P6(c[o>>2]|0);bv(o);RV(o);RB(b,2,0,18,378944,-1,1,0);RB(b,2,0,52,378944,-1,1,0);o=c[f>>2]|0;if(o|0?(o|0)==(c[g>>2]|0):0)RB(b,2,0,110,384431,-1,1,0);else RB(b,2,0,110,384435,-1,1,0);lL(b,2,0,135,h,10,0);sM(b,2,0,122,(d[i>>0]|0)+1|0,0);sM(b,2,0,147,(d[j>>0]|0)+1|0,0);if(!(a[b+492>>0]|0)){o=e;o=UW(c[o>>2]|0,c[o+4>>2]|0,1e3,0)|0;o=g5(o|0,z|0,h|0,0)|0;oK(b,2,0,68,o,z,10,0)}}l=k;return}function ll(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+16|0;h=n;NB(d,h);f=b[h>>1]|0;j=d+612|0;m=d+548|0;if(f<<16>>16){i=(c[j>>2]|0)+6|0;g=c[m>>2]|0;if((i+(f&65535)|0)>>>0>=g>>>0?(a[(c[d+24>>2]|0)+141>>0]|0)!=0:0){f=g-i&65535;b[h>>1]=f}}else f=0;h=e&255;a:do switch(e<<24>>24){case -1:case -8:case -14:case -15:case -16:case -65:case -66:case -68:case -69:break;default:switch(a[d+773>>0]|0){case 1:{bd(d,e);break a}case 2:{ec(d,e);break a}default:break a}}while(0);g=(f&65535)+6|0;if(f<<16>>16){Op(d,g,0);f=J1(c[d+508>>2]|0,c[d+668>>2]|0)|0;if(!f){i=d+528|0;o=c[i+4>>2]|0;e=d+536|0;f=c[e+4>>2]|0;if((o>>>0<f>>>0|((o|0)==(f|0)?(c[i>>2]|0)>>>0<(c[e>>2]|0)>>>0:0)?(k=(c[m>>2]|0)-(c[j>>2]|0)|0,g>>>0>k>>>0):0)?(h&224|0)==192|(h&240|0)==224:0){Op(d,k,0);b[d+858>>1]=g-(c[m>>2]|0)+(c[j>>2]|0);c[d+616>>2]=0;f=1}else f=1}else f=f^1}else{if(!(Jl(d)|0)){Op(d,(c[m>>2]|0)-(c[j>>2]|0)|0,0);a[d+857>>0]=1;c[d+616>>2]=0}f=(J1(c[d+508>>2]|0,c[d+668>>2]|0)|0)^1}l=n;return f|0}function ml(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=a+4|0;e=c[k>>2]|0;j=a+100|0;if(e>>>0<(c[j>>2]|0)>>>0){c[k>>2]=e+1;e=d[e>>0]|0}else e=_x(a)|0;switch(e|0){case 43:case 45:{f=(e|0)==45&1;e=c[k>>2]|0;if(e>>>0<(c[j>>2]|0)>>>0){c[k>>2]=e+1;e=d[e>>0]|0}else e=_x(a)|0;if((b|0)!=0&(e+-48|0)>>>0>9?(c[j>>2]|0)!=0:0)c[k>>2]=(c[k>>2]|0)+-1;break}default:f=0}if((e+-48|0)>>>0>9)if(!(c[j>>2]|0)){f=-2147483648;e=0}else{c[k>>2]=(c[k>>2]|0)+-1;f=-2147483648;e=0}else{i=0;do{i=e+-48+(i*10|0)|0;e=c[k>>2]|0;if(e>>>0<(c[j>>2]|0)>>>0){c[k>>2]=e+1;e=d[e>>0]|0}else e=_x(a)|0;g=(e+-48|0)>>>0<10}while((i|0)<214748364&g);b=((i|0)<0)<<31>>31;if(g){g=i;do{g=UW(g|0,b|0,10,0)|0;g=z0(g|0,z|0,-48,-1)|0;g=z0(g|0,z|0,e|0,((e|0)<0)<<31>>31|0)|0;b=z;e=c[k>>2]|0;if(e>>>0<(c[j>>2]|0)>>>0){c[k>>2]=e+1;e=d[e>>0]|0}else e=_x(a)|0}while(((b|0)<21474836|(b|0)==21474836&g>>>0<2061584302)&(e+-48|0)>>>0<10);h=e;i=g}else h=e;e=c[j>>2]|0;if((h+-48|0)>>>0<10)do{g=c[k>>2]|0;if(g>>>0<e>>>0){c[k>>2]=g+1;g=d[g>>0]|0}else{g=_x(a)|0;e=c[j>>2]|0}}while((g+-48|0)>>>0<10);if(e|0)c[k>>2]=(c[k>>2]|0)+-1;k=(f|0)!=0;e=D_(0,0,i|0,b|0)|0;f=k?z:b;e=k?e:i}z=f;return e|0}function nl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;x=l;l=l+160|0;o=x+48|0;n=x+32|0;i=x+24|0;g=x+8|0;m=x;r=x+130|0;p=x+68|0;s=x+72|0;w=x+64|0;u=x+60|0;v=x+56|0;q=m;c[q>>2]=37;c[q+4>>2]=0;q=d+4|0;j=Ux(m+1|0,8800948,c[q>>2]|0)|0;c[p>>2]=r;a=b0()|0;k=d+8|0;if(j){c[g>>2]=c[k>>2];h[g+8>>3]=f;a=dR(r,30,a,m,g)|0}else{h[i>>3]=f;a=dR(r,30,a,m,i)|0}if((a|0)>29){a=b0()|0;if(j){c[n>>2]=c[k>>2];h[n+8>>3]=f;g=wS(p,a,m,n)|0}else{h[o>>3]=f;g=wS(p,a,m,o)|0}a=c[p>>2]|0;if(!a)uaa();else{t=g;A=a;B=a}}else{t=a;A=0;B=r}i=B+t|0;g=kB(B,i,c[q>>2]|0)|0;if((B|0)!=(r|0)){a=Ub(t<<1)|0;if(!a)uaa();else{y=a;z=a}}else{y=s;z=0}O4(v,d);Kg(B,g,i,y,w,u,v);c6(v);B=Qo(c[b>>2]|0,y,c[w>>2]|0,c[u>>2]|0,d,e)|0;pe(z);pe(A);l=x;return B|0}function ol(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;x=l;l=l+160|0;o=x+48|0;n=x+32|0;i=x+24|0;g=x+8|0;m=x;r=x+130|0;p=x+68|0;s=x+72|0;w=x+64|0;u=x+60|0;v=x+56|0;q=m;c[q>>2]=37;c[q+4>>2]=0;q=d+4|0;j=Ux(m+1|0,402219,c[q>>2]|0)|0;c[p>>2]=r;a=b0()|0;k=d+8|0;if(j){c[g>>2]=c[k>>2];h[g+8>>3]=f;a=dR(r,30,a,m,g)|0}else{h[i>>3]=f;a=dR(r,30,a,m,i)|0}if((a|0)>29){a=b0()|0;if(j){c[n>>2]=c[k>>2];h[n+8>>3]=f;g=wS(p,a,m,n)|0}else{h[o>>3]=f;g=wS(p,a,m,o)|0}a=c[p>>2]|0;if(!a)uaa();else{t=g;A=a;B=a}}else{t=a;A=0;B=r}i=B+t|0;g=kB(B,i,c[q>>2]|0)|0;if((B|0)!=(r|0)){a=Ub(t<<1)|0;if(!a)uaa();else{y=a;z=a}}else{y=s;z=0}O4(v,d);Kg(B,g,i,y,w,u,v);c6(v);B=Qo(c[b>>2]|0,y,c[w>>2]|0,c[u>>2]|0,d,e)|0;pe(z);pe(A);l=x;return B|0}function pl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+64|0;o=q+56|0;p=q+16|0;i=q;W0(o,407712);m=d+8+3|0;e=a[m>>0]|0;f=e<<24>>24<0;k=d+4|0;j=f?c[d>>2]|0:d;g=i9(41840)|0;do if(!g)n=10;else{h=f?c[k>>2]|0:e&255;f=j+(h<<2)|0;g=HA(j,f,41840,41840+(g<<2)|0)|0;if((g|0)!=(f|0)?(g-j|0)!=-4:0){n=10;break}if(h>>>0>=7){e=i9(6380)|0;if(!e)e=7;else{e=HA(j,f,6380,6380+(e<<2)|0)|0;e=(e|0)==(f|0)?6:(e-j>>2)+7|0}if((e|0)==(h|0)){p2(p,d);m=a[m>>0]|0;FB(p,(m<<24>>24<0?c[k>>2]|0:m&255)+-7|0,0);p2(b,jJ(p)|0);z5(p);break}}p2(b,jJ(d)|0)}while(0);if((n|0)==10){mI(p);Xy(i,41840);z3(p,i);z5(i);og(p,d);f=p+4|0;e=0;while(1){g=c[p>>2]|0;if(e>>>0>=(((c[f>>2]|0)-g|0)/12|0)>>>0)break;n=jJ(g+(e*12|0)|0)|0;k1((c[p>>2]|0)+(e*12|0)|0,n)|0;e=e+1|0}de(b,p);$_(p)}s7(c[o>>2]|0);l=q;return}function ql(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=b+520|0;f=d;a[b+957>>0]=((c[f+4>>2]|0)==0?(c[f>>2]&-8|0)==16:0)&1;Bx(b);Gn(b);wK(b);f=b+536|0;h=b+528|0;h=D_(c[f>>2]|0,c[f+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0)|0;e1(b,h,z);if((qO(b)|0?(c[b+928>>2]|0)!=-1:0)?(l=b+836|0,a[b+958>>0]|0):0){h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,-19,-1)|0;f=z;d=c[l>>2]|0;e=d+1|0;if(f>>>0<0|(f|0)==0&h>>>0<2){c[l>>2]=e;d=e}h=b+312|0;f=h;e=c[f>>2]|0;f=c[f+4>>2]|0;n=z0(e|0,f|0,1,0)|0;m=h;c[m>>2]=n;c[m+4>>2]=z;if(d|0?(i=b+360|0,k=i,j=c[k>>2]|0,k=c[k+4>>2]|0,!((j|0)==-1&(k|0)==-1)):0){m=z0(j|0,k|0,1,0)|0;n=i;c[n>>2]=m;c[n+4>>2]=z}d=b+328|0;n=d;n=z0(c[n>>2]|0,c[n+4>>2]|0,1,0)|0;c[d>>2]=n;c[d+4>>2]=z;d=b+728|0;if((e|0)==0&(f|0)==0?(c[d>>2]&1|0)==0:0)W5(b);if(!(c[d>>2]&2)){d=b+760|0;f=c[h>>2]|0;h=c[h+4>>2]|0;if((c[l>>2]|0)>>>0>7){c[d>>2]=f;c[d+4>>2]=h;d=h;e=f}else{e=d;d=c[e+4>>2]|0;e=c[e>>2]|0}if((!(h>>>0<d>>>0|(h|0)==(d|0)&f>>>0<e>>>0)?(t6(b),(a[b+492>>0]|0)==0):0)?+g[(c[b+24>>2]|0)+136>>2]<1.0:0)V5(b)}}return}function rl(a){a=a|0;do switch(a<<16>>16){case 100:{a=384209;break}case 101:{a=384218;break}case 102:{a=376195;break}case 103:{a=376175;break}case 104:{a=376164;break}case 105:{a=376153;break}case 106:{a=376131;break}case 107:{a=376116;break}case 108:{a=375837;break}case 109:{a=384266;break}case 110:{a=376090;break}case 111:{a=375653;break}case 112:{a=376039;break}case 113:{a=384229;break}case 114:{a=384229;break}case 115:{a=376017;break}case 116:{a=376017;break}case 117:{a=378509;break}case 118:{a=378509;break}case 119:{a=378509;break}case 120:{a=378509;break}case 121:{a=378662;break}case 122:{a=378662;break}case 123:{a=378662;break}case 124:{a=378662;break}case 125:{a=375991;break}case 126:{a=375961;break}case 127:{a=375928;break}case 128:{a=384357;break}case 129:{a=384357;break}case 130:{a=375879;break}case 131:{a=375859;break}case 132:{a=375837;break}case 133:{a=378601;break}case 134:{a=375812;break}case 135:{a=378662;break}case 136:{a=378617;break}case 137:{a=375785;break}case 138:{a=375758;break}case 139:{a=384290;break}case 140:{a=375690;break}case 141:{a=375725;break}case 142:{a=384319;break}case 143:{a=375690;break}case 144:{a=375653;break}case 145:{a=375580;break}case 146:{a=375485;break}default:a=8800948}while(0);return a|0}function sl(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;p=c[b+544>>2]|0;q=c[b+612>>2]|0;e=a[p+(q+5)>>0]|0;a[b+1183>>0]=(e&255)>>>3;do if((e&255)>=80)if((e+-88&255)<48){j=b+1410|0;i=c[b+548>>2]|0;f=(((a[p+(q+2)>>0]&7)<<8|d[p+(q+3)>>0])<<1)+2|0;g=0;h=0;k=0;while(1){a[j>>0]=k;l=f&65535;m=l+q|0;if((m+6|0)>>>0>i>>>0)break;if(((a[p+(m+5)>>0]|0)+-80&255)>55){r=13;break}e=a[p+(m+2)>>0]|0;n=e&255;o=n>>>3&7;if(!((o|0)==(g&255|0)&(o|0)==(h&255|0))){r=13;break}e=(e&255)<64;if(!((o|0)!=0|e^1)){r=13;break}f=l+2+((d[p+(m+3)>>0]|n<<8&1792)<<1)|0;g=(e&1)+g<<24>>24;h=e?0:h+1<<24>>24;k=k+1<<24>>24}if((r|0)==13){e=f&65535;break}e=f&65535;if((a[b+492>>0]|0)==0?(c[b+772>>2]|0)==0:0)c3(c[b+508>>2]|0,c[b+668>>2]|0)}else e=1;else{q=p+(q+4)|0;e=b+1180|0;a[e>>0]=(d[q>>0]|0)>>>6;r=b+1182|0;a[r>>0]=a[q>>0]&63;q=VH(b+852|0,e)|0;p=q;p=z0(c[p>>2]|0,c[p+4>>2]|0,1,0)|0;c[q>>2]=p;c[q+4>>2]=z;b=VH(b+864|0,r)|0;q=b;q=z0(c[q>>2]|0,c[q+4>>2]|0,1,0)|0;c[b>>2]=q;c[b+4>>2]=z;e=MT(a[r>>0]|0,a[e>>0]|0)|0}while(0);return e&65535|0}function tl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;i=l;l=l+16|0;h=i+2|0;f=i;g=i+1|0;GC(b);xR(b,4,h);switch(a[h>>0]|0){case 11:{Ap(b);break}case 12:{LB(b,d);break}case 13:{id(b,d,e,0);break}case 14:{id(b,d,e,1);break}case 1:{e=b+648|0;d4(c[e>>2]|0,4);if((Z9(c[(c[e>>2]|0)+4>>2]|0)|0)>>>0>d>>>0){GC(b);while(1){f=c[e>>2]|0;if((Z9(c[f+4>>2]|0)|0)>>>0<=d>>>0)break;d4(f,8)}J3(b)}break}case 2:{xR(b,4,f);if(!(a[f>>0]|0)){e=0;while(1){xR(b,8,g);h=a[g>>0]|0;f=h&255;if(h<<24>>24==-1)e=f+(e&65535)|0;else break}G4(c[b+648>>2]|0,f+e<<3&524280)}break}default:{h=c[b+648>>2]|0;G4(h,(Z9(c[h+4>>2]|0)|0)-d|0)}}J3(b);g=b+648|0;f=c[g>>2]|0;e=c[f+4>>2]|0;h=Z9(e)|0;if(h>>>0>d>>>0){G4(f,h-d|0);e=c[g>>2]|0;f=e;e=c[e+4>>2]|0}e=Z9(e)|0;if((e|0)!=(d|0)){G4(f,e);t4(b)}l=i;return}function ul(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;o=c;p=b;f=0;a:while(1){m=b;if(!(f>>>0<e>>>0&b>>>0<c>>>0))break;n=a[b>>0]|0;k=n&255;i=b+1|0;b:do if(n<<24>>24<=-1){if((n&255)<194)break a;h=b+2|0;g=o-m|0;if((n&255)<224){if((g|0)<2)break a;if((a[i>>0]&-64)<<24>>24==-128){b=h;break}else break a}l=b+3|0;if((n&255)<240){if((g|0)<3)break a;h=a[h>>0]|0;b=d[i>>0]|0;g=b&224;switch(n<<24>>24){case -32:if((g|0)==160&(h&-64)<<24>>24==-128){b=l;break b}else break a;case -19:if((g|0)==128&(h&-64)<<24>>24==-128){b=l;break b}else break a;default:if((b&192|0)==128&(h&-64)<<24>>24==-128){b=l;break b}else break a}}if((n&255)>=245)break a;if((e-f|0)>>>0<2|(g|0)<4)break a;j=a[i>>0]|0;i=a[h>>0]|0;g=a[l>>0]|0;h=j&255;switch(n<<24>>24){case -16:{if(!((j+112&255)<48&(i&-64)<<24>>24==-128&(g&-64)<<24>>24==-128))break a;break}case -12:{if(!((h&240|0)==128&(i&-64)<<24>>24==-128&(g&-64)<<24>>24==-128))break a;break}default:if(!((h&192|0)==128&(i&-64)<<24>>24==-128&(g&-64)<<24>>24==-128))break a}if((h<<12&196608|k<<18&1835008)>>>0>1114111)break a;else{f=f+1|0;b=b+4|0}}else b=i;while(0);f=f+1|0}return m-p|0}function vl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i+12|0;h=i;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[g+(d<<2)>>2]=0;d=d+1|0}d=b+520|0;e=c[d>>2]|0;d=c[d+4>>2]|0;f=b+536|0;a:do if((e|0)<1096111176)if((e|0)<1095650895){switch(e|0){case 677587232:break;default:{d=13;break a}}if(d|0){d=13;break}IX(g,380189)|0;d=14;break}else{switch(e|0){case 1095650895:break;default:{d=13;break a}}if(d|0){d=13;break}IX(g,379557)|0;d=14;break}else if((e|0)<1312902469){switch(e|0){case 1096111176:break;default:{d=13;break a}}if(d|0){d=13;break}IX(g,380530)|0;d=14;break}else{switch(e|0){case 1312902469:break;default:{d=13;break a}}if(d|0){d=13;break}IX(g,380183)|0;d=14;break}while(0);if((d|0)==13){h=f;e1(b,c[h>>2]|0,c[h+4>>2]|0)}else if((d|0)==14){TX(h);jZ(b,c[f>>2]|0,c[f+4>>2]|0,h);Mc(b,0,0,(a[g+11>>0]|0)<0?c[g>>2]|0:g,h,0);z5(h)}a1(g);l=i;return}function wl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+16|0;d=m+4|0;k=m;bB(b,d);e=b+536|0;do if((c[b+784>>2]|0)>>>0>1){j=e;k=b+528|0;k=D_(c[j>>2]|0,c[j+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0;e1(b,k,z)}else{if((a[d>>0]|0)!=1){k=e;e1(b,c[k>>2]|0,c[k+4>>2]|0);break}i=b+916|0;j=b+788|0;e=0;while(1){h=bF(i,j)|0;h=e>>>0<(c[h+16>>2]|0)-(c[h+12>>2]|0)>>2>>>0;d=bF(i,j)|0;f=c[d+12>>2]|0;if(!h)break;d=c[f+(e<<2)>>2]|0;if(d|0)jb[c[(c[d>>2]|0)+4>>2]&511](d);e=e+1|0}d=d+16|0;e=c[d>>2]|0;while(1){if((e|0)==(f|0))break;h=e+-4|0;c[d>>2]=h;e=h}g=ZW(1056)|0;Mr(g);a[g+768>>0]=1;aY(b,g);h=g+769|0;a[h>>0]=1;a[g+733>>0]=0;d=bF(i,j)|0;c[k>>2]=g;e=d+16|0;f=c[e>>2]|0;if(f>>>0<(c[d+20>>2]|0)>>>0){c[f>>2]=g;c[e>>2]=(c[e>>2]|0)+4}else Yy(d+12|0,k);a[b+761>>0]=1;rB(b,g);a[h>>0]=0;a[g+770>>0]=1}while(0);l=m;return}function xl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=l;l=l+48|0;b=i;f=i+32|0;g=i+28|0;h=i+16|0;L2(b);j0(a,b);j=b+8|0;d=a+536|0;e=a+528|0;if(((c[j>>2]|0)==614161571?(c[j+4>>2]|0)==2089984219:0)?(j=b,(c[j>>2]|0)==764424473?(c[j+4>>2]|0)==-1878521984:0):0){ID(a,f);if((c[f>>2]|0)==1768776802){ID(a,g);if((c[g>>2]|0)==1){f=e;f=z0(c[f>>2]|0,c[f+4>>2]|0,4,0)|0;k=z;j=d;b=c[j+4>>2]|0;if(!(k>>>0>b>>>0|((k|0)==(b|0)?f>>>0>(c[j>>2]|0)>>>0:0))?(aH(a,g),(c[g>>2]|0)==0):0){j=e;j=z0(c[j>>2]|0,c[j+4>>2]|0,4,0)|0;k=e;c[k>>2]=j;c[k+4>>2]=z}TX(h);j=d;k=e;k=D_(c[j>>2]|0,c[j+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0;xZ(a,k,z,h);Mc(a,0,0,376963,h,0);z5(h)}else{j=d;k=e;k=D_(c[j>>2]|0,c[j+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0;e1(a,k,z)}}else{j=d;k=e;k=D_(c[j>>2]|0,c[j+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0;e1(a,k,z)}}else{j=d;k=e;k=D_(c[j>>2]|0,c[j+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0;e1(a,k,z)}l=i;return}function yl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+16|0;n=v;do if(!(d8(d,-1)|0)){r=b+12|0;s=b+8|0;t=(c[r>>2]|0)-(c[s>>2]|0)|0;u=b+24|0;j=c[u>>2]|0;m=b+28|0;f=c[m>>2]|0;e=b+32|0;o=b+44|0;p=b+48|0;q=e+11|0;if((j|0)==(f|0)){if(!(c[p>>2]&16)){e=-1;break}h=b+20|0;i=c[h>>2]|0;k=(c[o>>2]|0)-i|0;gy(e,0);if((a[q>>0]|0)<0)f=(c[b+40>>2]&2147483647)+-1|0;else f=10;CC(e,f);f=a[q>>0]|0;if(f<<24>>24<0){g=c[e>>2]|0;f=c[b+36>>2]|0}else{g=e;f=f&255}f=g+f|0;c[h>>2]=g;c[m>>2]=f;j=g+(j-i)|0;c[u>>2]=j;g=g+k|0;c[o>>2]=g;i=f}else{g=c[o>>2]|0;i=f}h=j+1|0;c[n>>2]=h;f=c[(h>>>0<g>>>0?o:n)>>2]|0;c[o>>2]=f;if(c[p>>2]&8|0){if((a[q>>0]|0)<0)e=c[e>>2]|0;c[s>>2]=e;c[r>>2]=e+t;c[b+16>>2]=f}e=d&255;if((j|0)==(i|0)){u=c[(c[b>>2]|0)+52>>2]|0;e=e9(e)|0;e=tb[u&31](b,e)|0;break}else{c[u>>2]=h;a[j>>0]=e;e=e9(e)|0;break}}else e=e3(d)|0;while(0);l=v;return e|0}function zl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;h=i+2|0;d=i+1|0;e=i;GC(b);a[h>>0]=0;AT(b,h);h=a[h>>0]|0;f=h<<24>>24==0;g=b+648|0;if(!f){d4(c[g>>2]|0,11);A6(c[g>>2]|0)}if(K6(c[g>>2]|0)|0){GC(b);A6(c[g>>2]|0);XV(b,11);J3(b)}else A6(c[g>>2]|0);if(K6(c[g>>2]|0)|0){GC(b);A6(c[g>>2]|0);XV(b,2);J3(b)}else A6(c[g>>2]|0);if(K6(c[g>>2]|0)|0){GC(b);A6(c[g>>2]|0);d4(c[g>>2]|0,8);J3(b)}else A6(c[g>>2]|0);a[d>>0]=0;AT(b,d);if(!(a[d>>0]|0)){a[e>>0]=0;if(f?(AT(b,e),(a[e>>0]|0)!=0):0){A6(c[g>>2]|0);A6(c[g>>2]|0);d=1}else d=0;if((d|h)<<24>>24){d4(c[g>>2]|0,5);d4(c[g>>2]|0,2)}}J3(b);l=i;return}function Al(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=l;l=l+16|0;d=i;g=b+492|0;if(!(a[g>>0]|0)){do if((RA(b,1,-1)|0)==1?(RA(b,2,-1)|0)==0:0){$x(d,b,1,0,185,1);f=a[d+8+3>>0]|0;f=((f<<24>>24<0?c[d+4>>2]|0:f&255)|0)==0;z5(d);d=b+24|0;if(f){f=b+360|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e|0)==-1&(f|0)==-1)?(k=b+48|0,k=z0(c[b+548>>2]|0,0,c[k>>2]|0,c[k+4>>2]|0)|0,j=b+40|0,(k|0)==(c[j>>2]|0)?(z|0)==(c[j+4>>2]|0):0):0){oK(b,1,0,185,e,f,10,0);break}e=c[d>>2]|0;e=((c[e+8>>2]|0)-(c[e+4>>2]|0)|0)/12|0;if(e>>>0>1?(a[b+493>>0]|0)!=0:0)lL(b,1,0,185,e,10,0)}}else h=5;while(0);if((h|0)==5)d=b+24|0;Jn(b);Jn(b);Sb(b);Jn(b);Sb(b);Jn(b);Sb(b);Jn(b);if(((a[g>>0]|0)==0?!(IR(c[d>>2]|0)|0):0)?NT()|0:0)oE(b)}l=i;return}function Bl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;j=k;g=c[d>>2]|0;i=g+84|0;$x(j,b,6,c[i>>2]|0,90,1);f=pn(j)|0;z5(j);$x(j,b,6,c[i>>2]|0,91,1);d=pn(j)|0;z5(j);if((f|0)!=0&(d|0)!=0){while(1){d=d+-1|0;e=c[i>>2]|0;if(d>>>0<f>>>0)break;Ed(b,6,e,d)}Ed(b,6,e,90);Ed(b,6,c[i>>2]|0,91)}if(c[g+68>>2]|0){f=c[i>>2]|0;lL(b,6,f,90,RA(b,6,f)|0,10,1);f=g+64|0;h=j+11|0;d=c[g+60>>2]|0;a:while(1){e=c[i>>2]|0;if((d|0)==(f|0))break;Sn(j,d+16|0);Mc(b,6,e,(a[h>>0]|0)<0?c[j>>2]|0:j,d+28|0,1);a1(j);e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue a}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}lL(b,6,e,91,RA(b,6,e)|0,10,1)}l=k;return}function Cl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=l;l=l+32|0;e=s+24|0;h=s+26|0;i=s+12|0;m=s;n=b+528|0;o=b+536|0;p=b+760|0;q=b+770|0;r=m+11|0;f=m+8|0;g=m+4|0;while(1){j=n;t=c[j+4>>2]|0;k=o;d=c[k+4>>2]|0;if(!(t>>>0<d>>>0|((t|0)==(d|0)?(c[j>>2]|0)>>>0<(c[k>>2]|0)>>>0:0))){d=11;break}GC(b);NB(b,e);bB(b,h);J3(b);if(qO(b)|0){VU(i,St(a[h>>0]|0)|0);j=$C((HD((c[p>>2]|0)+68|0,q)|0)+16|0,e)|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;k=j9(391048)|0;if(k>>>0>4294967279){d=5;break}if(k>>>0<11){a[r>>0]=k;d=m}else{t=k+16&-16;d=ZW(t)|0;c[m>>2]=d;c[f>>2]=t|-2147483648;c[g>>2]=k}i1(d,391048,k)|0;J7(d+k|0,0);vF(VC(j+4|0,m)|0,i)|0;a1(m);z5(i)}}if((d|0)==5)uaa();else if((d|0)==11){l=s;return}}function Dl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+16|0;i=h+3|0;e=h+2|0;f=h+1|0;g=h;Bx(b);AT(b,i);AT(b,e);AT(b,f);AT(b,g);d=b+648|0;A6(c[d>>2]|0);A6(c[d>>2]|0);A6(c[d>>2]|0);A6(c[d>>2]|0);wK(b);if(a[i>>0]|0){KS(b);KS(b);d4(c[d>>2]|0,14)}if(a[e>>0]|0){KS(b);KS(b);d4(c[d>>2]|0,14)}if(a[f>>0]|0){KS(b);KS(b);d4(c[d>>2]|0,14)}if(a[g>>0]|0){KS(b);KS(b);d4(c[d>>2]|0,14)}KS(b);KS(b);KS(b);KS(b);KS(b);KS(b);KS(b);KS(b);wK(b);e=b+536|0;d=b+528|0;d=D_(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e=z;if(!((d|0)==0&(e|0)==0))e1(b,d,e);l=h;return}function El(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=b+-8|0;e=a+8|0;d=a+16|0;f=a+24|0;switch(b-a>>3|0){case 1:case 0:{d=1;break}case 2:{e=h;d=c[e>>2]|0;e=c[e+4>>2]|0;g=a;f=c[g>>2]|0;g=c[g+4>>2]|0;if(e>>>0<g>>>0|(e|0)==(g|0)&d>>>0<f>>>0){c[a>>2]=d;c[a+4>>2]=e;d=h;c[d>>2]=f;c[d+4>>2]=g;d=1}else d=1;break}case 3:{ro(a,e,h)|0;d=1;break}case 4:{Jr(a,e,d,h)|0;d=1;break}case 5:{$n(a,e,d,f,h)|0;d=1;break}default:{ro(a,e,d)|0;m=0;a:while(1){l=f;while(1){if((l|0)==(b|0)){e=1;d=0;break a}k=l;j=c[k>>2]|0;k=c[k+4>>2]|0;g=d;e=c[g>>2]|0;g=c[g+4>>2]|0;f=l+8|0;if(k>>>0<g>>>0|(k|0)==(g|0)&j>>>0<e>>>0){h=l;i=e;break}else{d=l;l=f}}while(1){c[h>>2]=i;c[h+4>>2]=g;if((d|0)==(a|0)){d=a;break}e=d+-8|0;g=e;i=c[g>>2]|0;g=c[g+4>>2]|0;if(!(k>>>0<g>>>0|(k|0)==(g|0)&j>>>0<i>>>0))break;else{h=d;d=e}}c[d>>2]=j;c[d+4>>2]=k;d=m+1|0;if((d|0)==8){n=14;break}else{m=d;d=l}}if((n|0)==14){e=0;d=(f|0)==(b|0)}d=d|e}}return d|0}function Fl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;h=b+-8|0;e=a+8|0;d=a+16|0;f=a+24|0;switch(b-a>>3|0){case 1:case 0:{d=1;break}case 2:{e=h;d=c[e>>2]|0;e=c[e+4>>2]|0;g=a;f=c[g>>2]|0;g=c[g+4>>2]|0;if((e|0)<(g|0)|(e|0)==(g|0)&d>>>0<f>>>0){c[a>>2]=d;c[a+4>>2]=e;d=h;c[d>>2]=f;c[d+4>>2]=g;d=1}else d=1;break}case 3:{so(a,e,h)|0;d=1;break}case 4:{Kr(a,e,d,h)|0;d=1;break}case 5:{ao(a,e,d,f,h)|0;d=1;break}default:{so(a,e,d)|0;m=0;a:while(1){l=f;while(1){if((l|0)==(b|0)){e=1;d=0;break a}k=l;j=c[k>>2]|0;k=c[k+4>>2]|0;g=d;e=c[g>>2]|0;g=c[g+4>>2]|0;f=l+8|0;if((k|0)<(g|0)|(k|0)==(g|0)&j>>>0<e>>>0){h=l;i=e;break}else{d=l;l=f}}while(1){c[h>>2]=i;c[h+4>>2]=g;if((d|0)==(a|0)){d=a;break}e=d+-8|0;g=e;i=c[g>>2]|0;g=c[g+4>>2]|0;if(!((k|0)<(g|0)|(k|0)==(g|0)&j>>>0<i>>>0))break;else{h=d;d=e}}c[d>>2]=j;c[d+4>>2]=k;d=m+1|0;if((d|0)==8){n=14;break}else{m=d;d=l}}if((n|0)==14){e=0;d=(f|0)==(b|0)}d=d|e}}return d|0}function Gl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;v=l;l=l+16|0;n=v;do if(!(d8(d,-1)|0)){s=b+12|0;t=b+8|0;u=(c[s>>2]|0)-(c[t>>2]|0)>>2;r=b+24|0;i=c[r>>2]|0;m=b+28|0;g=c[m>>2]|0;e=b+32|0;o=b+44|0;p=b+48|0;f=b+40|0;q=f+3|0;if((i|0)==(g|0)){if(!(c[p>>2]&16)){e=-1;break}h=b+20|0;j=c[h>>2]|0;k=(c[o>>2]|0)-j>>2;Gx(e,0);if((a[q>>0]|0)<0)f=(c[f>>2]&2147483647)+-1|0;else f=1;FB(e,f,0);f=a[q>>0]|0;if(f<<24>>24<0){g=c[e>>2]|0;f=c[b+36>>2]|0}else{g=e;f=f&255}w=g+(f<<2)|0;c[h>>2]=g;c[m>>2]=w;i=g+(i-j>>2<<2)|0;c[r>>2]=i;f=g+(k<<2)|0;c[o>>2]=f;g=w}else f=c[o>>2]|0;h=i+4|0;c[n>>2]=h;f=c[(h>>>0<f>>>0?o:n)>>2]|0;c[o>>2]=f;if(c[p>>2]&8|0){if((a[q>>0]|0)<0)e=c[e>>2]|0;c[t>>2]=e;c[s>>2]=e+(u<<2);c[b+16>>2]=f}if((i|0)==(g|0)){w=c[(c[b>>2]|0)+52>>2]|0;e=raa(d)|0;e=tb[w&31](b,e)|0;break}else{c[r>>2]=h;c[i>>2]=d;e=raa(d)|0;break}}else e=e3(d)|0;while(0);l=v;return e|0}function Hl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;q=l;l=l+80|0;n=q+24|0;o=q+12|0;p=q;oG(n);WG(n);p2(o,d);uP(o)|0;j=n+4|0;k=o+8+3|0;m=o+4|0;d=c[n>>2]|0;a:while(1){if((d|0)==(j|0)){d=15;break}i=d+16|0;e=d+28|0;uP(e)|0;g=a[d+36+3>>0]|0;f=g<<24>>24<0;g=f?c[d+32>>2]|0:g&255;r=a[k>>0]|0;h=r<<24>>24<0;if((g|0)==((h?c[m>>2]|0:r&255)|0)?(L$(f?c[e>>2]|0:e,h?c[o>>2]|0:o,g)|0)==0:0){e=a[d+24+3>>0]|0;if(e<<24>>24<0){g=c[i>>2]|0;f=c[d+20>>2]|0}else{g=i;f=e&255}e=i9(6656)|0;if(!e){d=10;break}h=g+(f<<2)|0;r=HA(g,h,6656,6656+(e<<2)|0)|0;if((r|0)!=(h|0)&(r|0)==(g|0)){d=10;break}}e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue a}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}if((d|0)==10){lw(p,i,9,-1);p2(b,p);O0(p)}else if((d|0)==15)TX(b);z5(o);dT(n);l=q;return}function Il(a){a=a|0;var b=0,d=0,e=0,f=0;d=a+536|0;b=c[d>>2]|0;d=c[d+4>>2]|0;e=a+528|0;switch(b|0){case 1:{if(!d){d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;c[e>>2]=d;c[e+4>>2]=z}else f=20;break}case 2:{if(!d){d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,2,0)|0;c[e>>2]=d;c[e+4>>2]=z}else f=20;break}case 3:{if(!d){d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,3,0)|0;c[e>>2]=d;c[e+4>>2]=z}else f=20;break}case 4:{if(!d){d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,4,0)|0;c[e>>2]=d;c[e+4>>2]=z}else f=20;break}case 5:{if(!d){d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,5,0)|0;c[e>>2]=d;c[e+4>>2]=z}else f=20;break}case 6:{if(!d){d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,6,0)|0;c[e>>2]=d;c[e+4>>2]=z}else f=20;break}case 7:{if(!d){d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,7,0)|0;c[e>>2]=d;c[e+4>>2]=z}else f=20;break}case 8:{if(!d){d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,8,0)|0;c[e>>2]=d;c[e+4>>2]=z}else f=20;break}case 16:{if(!d){d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,16,0)|0;c[e>>2]=d;c[e+4>>2]=z}else f=20;break}default:f=20}if((f|0)==20)e1(a,b,d);return}function Jl(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;l=b+616|0;e=c[l>>2]|0;m=b+612|0;if(!e){e=(c[m>>2]|0)+4|0;c[l>>2]=e}j=b+544|0;k=c[b+548>>2]|0;while(1){h=e+4|0;f=e+2|0;g=e+1|0;if(h>>>0>k>>>0)break;i=c[j>>2]|0;if((((a[i+e>>0]|0)==0?(a[i+g>>0]|0)==0:0)?(a[i+f>>0]|0)==1:0)?(d[i+(e+3)>>0]|0)>=185:0)break;while(1){f=e+2|0;c[l>>2]=f;if(f>>>0>=k>>>0){n=12;break}if(!(a[i+f>>0]|0)){n=11;break}else e=f}if((n|0)==11){n=0;e=e+1|0;if(a[i+e>>0]|0){e=f;continue}}else if((n|0)==12){n=0;e=e+1|0}c[l>>2]=e}do if((h|0)==(k|0)){i=c[j>>2]|0;if(((a[i+e>>0]|0)==0?(a[i+g>>0]|0)==0:0)?(a[i+f>>0]|0)==1:0)break;c[l>>2]=g;e=g}while(0);do if((e+3|0)==(k|0)){i=c[j>>2]|0;f=e+1|0;if(((a[i+e>>0]|0)==0?(a[i+f>>0]|0)==0:0)?(a[i+(e+2)>>0]|0)==1:0)break;c[l>>2]=f;e=f}while(0);do if((e+2|0)==(k|0)){i=c[j>>2]|0;f=e+1|0;if((a[i+e>>0]|0)==0?(a[i+f>>0]|0)==0:0)break;c[l>>2]=f;e=f}while(0);if((e+1|0)==(k|0)?(a[(c[j>>2]|0)+e>>0]|0)!=0:0){c[l>>2]=k;e=k}if((e+4|0)>>>0>k>>>0)if(!(a[(c[b+24>>2]|0)+141>>0]|0))e=0;else{c[l>>2]=k;e=k;n=34}else n=34;if((n|0)==34){Op(b,e-(c[m>>2]|0)|0,0);c[l>>2]=0;e=1}return e|0}function Kl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+48|0;d=i;e=b+728|0;c[e>>2]=c[e>>2]&-9;a[(c[b+24>>2]|0)+141>>0]=0;T$(d);e=b+120|0;f=d;g=e+40|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(g|0));T$(d);e=b+160|0;f=d;g=e+40|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(g|0));T$(d);e=b+200|0;f=d;g=e+40|0;do{c[e>>2]=c[f>>2];e=e+4|0;f=f+4|0}while((e|0)<(g|0));g=b+752|0;d=g;e=c[d+4>>2]|0;f=b+360|0;h=f;c[h>>2]=c[d>>2];c[h+4>>2]=e;c[g>>2]=-1;c[g+4>>2]=-1;g=b+288|0;c[g>>2]=0;c[g+4>>2]=0;g=b+304|0;c[g>>2]=0;c[g+4>>2]=0;g=b+376|0;a:do if(a[g>>0]|0){e=0;while(1){if((e|0)==6)break a;h=RA(b,e,-1)|0;d=0;while(1){if((d|0)==(h|0))break;Ed(b,e,d,Rb(e,22)|0);d=d+1|0}e=e+1|0}}while(0);if(!((a[b+733>>0]|0)!=0?(h=b+56|0,(c[h>>2]|0)==-1?(c[h+4>>2]|0)==-1:0):0)){a[g>>0]=0;a[b+377>>0]=1;jb[c[(c[b>>2]|0)+24>>2]&511](b)}Dn(b);if(a[b+493>>0]|0?(h=b+64|0,(c[h>>2]|0)==0&(c[h+4>>2]|0)==0):0){b=b+144|0;c[b>>2]=0;c[b+4>>2]=0;b=f;c[b>>2]=0;c[b+4>>2]=0}l=i;return}function Ll(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;o=c;p=b;n=0;a:while(1){l=b;if(!(n>>>0<e>>>0&b>>>0<c>>>0))break;m=a[b>>0]|0;j=m&255;h=b+1|0;b:do if(m<<24>>24<=-1){if((m&255)<194)break a;g=b+2|0;f=o-l|0;if((m&255)<224){if((f|0)<2)break a;if((a[h>>0]&-64)<<24>>24==-128){b=g;break}else break a}k=b+3|0;if((m&255)<240){if((f|0)<3)break a;g=a[g>>0]|0;b=d[h>>0]|0;f=b&224;switch(m<<24>>24){case -32:if((f|0)==160&(g&-64)<<24>>24==-128){b=k;break b}else break a;case -19:if((f|0)==128&(g&-64)<<24>>24==-128){b=k;break b}else break a;default:if((b&192|0)==128&(g&-64)<<24>>24==-128){b=k;break b}else break a}}if((f|0)<4|(m&255)>244)break a;i=a[h>>0]|0;h=a[g>>0]|0;f=a[k>>0]|0;g=i&255;switch(m<<24>>24){case -16:{if(!((i+112&255)<48&(h&-64)<<24>>24==-128&(f&-64)<<24>>24==-128))break a;break}case -12:{if(!((g&240|0)==128&(h&-64)<<24>>24==-128&(f&-64)<<24>>24==-128))break a;break}default:if(!((g&192|0)==128&(h&-64)<<24>>24==-128&(f&-64)<<24>>24==-128))break a}if((g<<12&196608|j<<18&1835008)>>>0>1114111)break a;else b=b+4|0}else b=h;while(0);n=n+1|0}return l-p|0}function Ml(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+96|0;d=k;e=k+76|0;f=k+64|0;g=k+52|0;h=k+40|0;i=k+28|0;j=k+16|0;L2(d);Pl(d,b);if(qO(b)|0?(c[b+880>>2]|0)>>>0<=1:0){TX(e);zb(b,0,0,14,cC(e,Ct(d,10)|0)|0,0);z5(e);TX(i);cC(i,Ct(d,10)|0)|0;Bs(h,i,28020);TX(j);cC(j,Ct(d,16)|0)|0;d=a[j+8+3>>0]|0;m=d<<24>>24<0;Ex(h,m?c[j>>2]|0:j,m?c[j+4>>2]|0:d&255)|0;c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];d=0;while(1){if((d|0)==3)break;c[h+(d<<2)>>2]=0;d=d+1|0}Gx(g,41);c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];d=0;while(1){if((d|0)==3)break;c[g+(d<<2)>>2]=0;d=d+1|0}p2(e,f);zb(b,0,0,15,e,0);z5(e);O0(f);O0(g);z5(j);O0(h);z5(i)}l=k;return}function Nl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+208|0;j=m+8|0;k=m;i=k;c[i>>2]=1;c[i+4>>2]=0;a:do if(b|0){c[j+4>>2]=1;c[j>>2]=1;e=2;f=1;d=1;while(1){d=f+1+d|0;c[j+(e<<2)>>2]=d;if(d>>>0<b>>>0){i=f;e=e+1|0;f=d;d=i}else break}h=a+b+-1|0;if(h>>>0>a>>>0){g=h;i=k+4|0;b=a+(b+-1)|0;e=1;d=1;do{do if((d&3|0)!=3){f=e+-1|0;if((c[j+(f<<2)>>2]|0)>>>0<(g-a|0)>>>0)Iv(a,e,j);else Lo(a,d,c[i>>2]|0,e,0,j);if((e|0)==1){gT(k,1);e=0;break}else{gT(k,f);e=1;break}}else{Iv(a,e,j);qT(k,2);e=e+2|0}while(0);d=c[k>>2]|1;c[k>>2]=d;a=a+1|0}while((a|0)!=(b|0));a=h;g=i;f=c[i>>2]|0}else{e=1;g=k+4|0;f=0;d=1}Lo(a,d,f,e,0,j);b=k+4|0;f=a;while(1){if((d|0)==1&(e|0)==1){if(!(c[b>>2]|0))break a}else if((e|0)>=2){gT(k,2);i=e+-2|0;c[k>>2]=c[k>>2]^7;qT(k,1);Lo(f+(0-(c[j+(i<<2)>>2]|0))+-1|0,c[k>>2]|0,c[g>>2]|0,e+-1|0,1,j);gT(k,1);d=c[k>>2]|1;c[k>>2]=d;h=f+-1|0;Lo(h,d,c[g>>2]|0,i,1,j);f=h;e=i;continue}d=QX(k)|0;qT(k,d);f=f+-1|0;e=d+e|0;d=c[k>>2]|0}}while(0);l=m;return}function Ol(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+16|0;e=n+1|0;f=n;GC(b);m=0;do{bB(b,e);k=a[e>>0]|0;m=(k&255)+m|0}while(k<<24>>24==-1);k=0;do{bB(b,f);j=a[f>>0]|0;k=(j&255)+k|0}while(j<<24>>24==-1);J3(b);e=b+528|0;f=e;f=z0(c[f>>2]|0,c[f+4>>2]|0,k|0,0)|0;g=z;h=b+536|0;j=h;i=c[j>>2]|0;j=c[j+4>>2]|0;if(g>>>0>j>>>0|(g|0)==(j|0)&f>>>0>i>>>0){t4(b);m=h;d=e;d=D_(c[m>>2]|0,c[m+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e1(b,d,z)}else{o=h;c[o>>2]=f;c[o+4>>2]=g;switch(m|0){case 0:{Rq(b,d);break}case 1:{zd(b,c[d>>2]|0);break}case 4:{gk(b);break}case 5:{Oq(b,k);break}case 6:{JM(b);break}case 32:{pg(b,k);break}case 147:{o1(b);break}default:e1(b,k,0)}o=e;c[o>>2]=f;c[o+4>>2]=g;o=h;c[o>>2]=i;c[o+4>>2]=j}l=n;return}function Pl(a,b){a=a|0;b=b|0;var f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;f=j;h=b+536|0;g=c[h>>2]|0;h=c[h+4>>2]|0;switch(g|0){case 1:{if(!h){bB(b,f);RY(a,d[f>>0]|0)}else i=20;break}case 2:{if(!h){NB(b,f);RY(a,e[f>>1]|0)}else i=20;break}case 3:{if(!h){jB(b,f);F_(a,c[f>>2]|0)}else i=20;break}case 4:{if(!h){ID(b,f);F_(a,c[f>>2]|0)}else i=20;break}case 5:{if(!h){$y(b,f);h=f;hZ(a,c[h>>2]|0,c[h+4>>2]|0)}else i=20;break}case 6:{if(!h){_y(b,f);h=f;hZ(a,c[h>>2]|0,c[h+4>>2]|0)}else i=20;break}case 7:{if(!h){Zy(b,f);h=f;hZ(a,c[h>>2]|0,c[h+4>>2]|0)}else i=20;break}case 8:{if(!h){oz(b,f);h=f;hZ(a,c[h>>2]|0,c[h+4>>2]|0)}else i=20;break}case 16:{if(!h){L2(a);qu(b,a)}else i=20;break}default:i=20}if((i|0)==20){e1(b,g,h);RY(a,0)}l=j;return}function Ql(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;i=j;a:do if(!b){e=c[d>>2]|0;b=c[e>>2]|0;if(!b)e=0;else{f=e;e=0;do{if(b>>>0>127){b=qw(i,b)|0;if((b|0)==-1){e=-1;break a}}else b=1;e=b+e|0;f=f+4|0;b=c[f>>2]|0}while((b|0)!=0)}}else{b:do if(e>>>0>3){f=e;g=c[d>>2]|0;while(1){h=c[g>>2]|0;if((h+-1|0)>>>0>126){if(!h)break;h=qw(b,h)|0;if((h|0)==-1){e=-1;break a}b=b+h|0;f=f-h|0}else{a[b>>0]=h;b=b+1|0;f=f+-1|0;g=c[d>>2]|0}g=g+4|0;c[d>>2]=g;if(f>>>0<=3)break b}a[b>>0]=0;c[d>>2]=0;e=e-f|0;break a}else f=e;while(0);if(f){g=c[d>>2]|0;while(1){h=c[g>>2]|0;if((h+-1|0)>>>0>126){if(!h){g=19;break}h=qw(i,h)|0;if((h|0)==-1){e=-1;break a}if(f>>>0<h>>>0){g=22;break}qw(b,c[g>>2]|0)|0;b=b+h|0;f=f-h|0}else{a[b>>0]=h;b=b+1|0;f=f+-1|0;g=c[d>>2]|0}g=g+4|0;c[d>>2]=g;if(!f)break a}if((g|0)==19){a[b>>0]=0;c[d>>2]=0;e=e-f|0;break}else if((g|0)==22){e=e-f|0;break}}}while(0);l=j;return e|0}function Rl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=c[b>>2]|0;do if(!(a[f+492>>0]|0)){o=b+129|0;g=b+88|0;if(!(a[o>>0]|0)){if((d|0)==-1&(e|0)==-1){d=f+48|0;d=z0(c[f+612>>2]|0,0,c[d>>2]|0,c[d+4>>2]|0)|0;e=z}n=g;c[n>>2]=d;c[n+4>>2]=e;a[o>>0]=1}e=b+128|0;while(1){if(a[e>>0]|0)break;if(!(fd(b)|0)){h=10;break}}if((h|0)==10?(a[e>>0]|0)==0:0)break;f=g;d=c[f>>2]|0;f=c[f+4>>2]|0;do if(!((d|0)==-1&(f|0)==-1)){h=b+96|0;g=c[h>>2]|0;h=c[h+4>>2]|0;j=b+104|0;i=c[j>>2]|0;j=c[j+4>>2]|0;p=z0(i|0,j|0,g|0,h|0)|0;l=b+112|0;k=c[l>>2]|0;l=c[l+4>>2]|0;p=z0(p|0,z|0,k|0,l|0)|0;n=b+120|0;m=c[n>>2]|0;n=c[n+4>>2]|0;p=z0(p|0,z|0,m|0,n|0)|0;q=z;e=c[b>>2]|0;if(f>>>0<q>>>0|(f|0)==(q|0)&d>>>0<p>>>0){I1(e,d,f);break}else{q=D_(d|0,f|0,g|0,h|0)|0;q=D_(q|0,z|0,i|0,j|0)|0;q=D_(q|0,z|0,k|0,l|0)|0;q=D_(q|0,z|0,m|0,n|0)|0;I1(e,q,z);break}}while(0);a[o>>0]=0}else I1(f,d,e);while(0);return}function Sl(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+16|0;j=p+4|0;k=p+3|0;n=p+2|0;h=p+1|0;i=p;g=b+648|0;d4(c[g>>2]|0,4);AT(b,k);xR(b,3,j);j=(d[j>>0]|0)+1|0;f=0;m=0;while(1){if((f&255)>>>0>=j>>>0)break;e=m+1|0;AT(b,n);d4(c[g>>2]|0,4);if(a[n>>0]|0){AT(b,h);AT(b,i);e=(a[h>>0]|0)==0|(a[i>>0]|0)==0?e:m+2|0}f=f+1<<24>>24;m=e}A6(c[g>>2]|0);A6(c[g>>2]|0);d4(c[g>>2]|0,2);Jo(b,0);if(qO(b)|0){i=b+2510|0;j=b+2507|0;h=(a[k>>0]|0)==0;g=1;while(1){if(g>>>0>=m>>>0)break;a:do if(h){AT(b,n);if(!(a[n>>0]|0)){f=0;while(1){if((f|0)<(d[i>>0]|0))e=0;else break a;while(1){if((e|0)>=(d[j>>0]|0))break;if(a[b+19032+(f<<6)+e>>0]|0)mz(b);e=e+1|0}f=f+1|0}}else o=13}else{a[n>>0]=1;o=13}while(0);if((o|0)==13){o=0;mz(b)}g=g+1|0}}l=p;return}function Tl(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=c[b+728>>2]|0;a:do if(!(d&2)){r=b+552|0;p=c[r>>2]|0;r=c[r+4>>2]|0;o=b+560|0;e=b+848|0;q=e;o=z0(c[q>>2]|0,c[q+4>>2]|0,c[o>>2]|0,c[o+4>>2]|0)|0;q=z;f=b+793|0;h=b+795|0;i=b+797|0;j=b+796|0;k=b+798|0;l=b+794|0;d=(d&1|0)==0;do if(r>>>0>q>>>0|(r|0)==(q|0)&p>>>0>o>>>0)if(d){U5(b);break a}else{a[f>>0]=0;a[f+1>>0]=0;a[f+2>>0]=0;a[f+3>>0]=0;a[f+4>>0]=0;a[f+5>>0]=0;break}while(0);if(((((((c[b+804>>2]|0)!=(c[b+808>>2]|0)?(a[f>>0]|0)==0:0)?(a[l>>0]|0)==0:0)?(a[h>>0]|0)==0:0)?(a[j>>0]|0)==0:0)?(a[i>>0]|0)==0:0)?(a[k>>0]|0)==0:0){if(d?(W5(b),(a[b+492>>0]|0)==0):0)RB(b,0,0,57,378150,-1,1,0);t6(b);if(((a[b+732>>0]|0)==0?(q=b+48|0,q=z0(c[b+548>>2]|0,0,c[q>>2]|0,c[q+4>>2]|0)|0,n=e,m=c[n>>2]|0,n=c[n+4>>2]|0,q=z0(q|0,z|0,m|0,n|0)|0,o=z,r=b+40|0,p=c[r+4>>2]|0,o>>>0<p>>>0|((o|0)==(p|0)?q>>>0<(c[r>>2]|0)>>>0:0)):0)?+g[(c[b+24>>2]|0)+136>>2]<1.0:0){y0(b,m,n);Kl(b)}}}while(0);return}function Ul(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+16|0;g=m;i=m+14|0;k=m+12|0;TX(g);j=d+528|0;h=j;h=z0(c[h>>2]|0,c[h+4>>2]|0,1,0)|0;c[j>>2]=h;c[j+4>>2]=z;GC(d);NB(d,i);Bx(d);sR(d,14,k);d4(c[d+648>>2]|0,2);wK(d);J3(d);Ce(d,g);do if(qO(d)|0){h=d+764|0;f=c[h>>2]|0;j=d+768|0;n=(b[(c[(c[f+80>>2]|0)+(e[j>>1]<<2)>>2]|0)+166>>1]|0)==4;d=d+778|0;f=EE(f+108|0,i)|0;if(n){k1(vG(f,d)|0,g)|0;break}else{k1(vG((RC(qD(f+12|0,(c[(c[(c[h>>2]|0)+80>>2]|0)+(e[j>>1]<<2)>>2]|0)+166|0)|0,k)|0)+28|0,d)|0,g)|0;a[(EE((c[h>>2]|0)+108|0,i)|0)+24>>0]=1;a[(c[h>>2]|0)+120>>0]=1;break}}while(0);z5(g);l=m;return}function Vl(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0;j=l;l=l+32|0;d=j+24|0;h=j+12|0;i=j;Bx(b);d4(c[b+648>>2]|0,4);xR(b,4,j+28|0);wK(b);g=b+528|0;k=g;k=z0(c[k>>2]|0,c[k+4>>2]|0,2,0)|0;f=g;c[f>>2]=k;c[f+4>>2]=z;s3(b,d);f=b+536|0;g=D_(c[f>>2]|0,c[f+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0)|0;eS(b,g,z);if((qO(b)|0?(a[b+768>>0]|0)==2:0)?a[b+784>>0]|0:0){TX(h);Tv(h,c[d>>2]|0)|0;g=SG(h)|0;f=a[g+8+3>>0]|0;g=((f<<24>>24<0?c[g+4>>2]|0:f&255)|0)==0?h:g;b=c[(c[(c[b+760>>2]|0)+80>>2]|0)+(e[b+772>>1]<<2)>>2]|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;f=j9(384512)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[i+11>>0]=f;d=i}else{k=f+16&-16;d=ZW(k)|0;c[i>>2]=d;c[i+8>>2]=k|-2147483648;c[i+4>>2]=f}i1(d,384512,f)|0;J7(d+f|0,0);k1(VC(b+28|0,i)|0,g)|0;a1(i);z5(h)}l=j;return}function Wl(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+16|0;i=o+5|0;e=o+4|0;j=o+3|0;k=o+2|0;m=o+1|0;n=o;GC(b);a[i>>0]=0;AT(b,i);if(!(a[i>>0]|0)){xR(b,4,e);i=a[e>>0]|0;if(i&1){AT(b,j);AT(b,k);if(!(a[k>>0]|0))e=1;else{a[m>>0]=0;xR(b,3,m);e=(d[m>>0]|0)+2|0}g=b+648|0;f=0;while(1){if((f|0)==(e|0))break;GC(b);a[m>>0]=1;AT(b,m);if(!(a[m>>0]|0)){AT(b,n);h=c[g>>2]|0;if(!(a[n>>0]|0))d4(h,17);else d4(h,10)}J3(b);f=f+1|0}}if(i&2)d4(c[b+648>>2]|0,3);if(i&4?(xR(b,5,j),(a[j>>0]|0)==31):0){a[k>>0]=0;xR(b,7,k);a[j>>0]=(d[k>>0]|0)+31}if(i&8){xR(b,4,j);n=a[j>>0]|0;m=b+648|0;d4(c[m>>2]|0,n);d4(c[m>>2]|0,8-(n&7)&255)}}else A6(c[b+648>>2]|0);J3(b);l=o;return}function Xl(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j;e=b+20|0;$x(h,b,1,c[e>>2]|0,51,1);d=i9(24116)|0;i=a[h+8+3>>0]|0;if((d|0)==((i<<24>>24<0?c[h+4>>2]|0:i&255)|0))d=(VG(h,24116,d)|0)==0;else d=0;z5(h);i=b+788|0;f=b+916|0;a:do if(d){Ed(b,1,c[e>>2]|0,51);g=ZW(1104)|0;ln(g);d=bF(f,i)|0;c[h>>2]=g;e=d+16|0;f=c[e>>2]|0;if(f>>>0<(c[d+20>>2]|0)>>>0){c[f>>2]=g;c[e>>2]=(c[e>>2]|0)+4}else Yy(d+12|0,h);e=b+520|0;h=e;f=c[h>>2]|0;h=c[h+4>>2]|0;d=e;c[d>>2]=c[i>>2];c[d+4>>2]=0;aY(b,g);i=e;c[i>>2]=f;c[i+4>>2]=h;a[b+761>>0]=1;rB(b,g)}else{d=0;while(1){h=bF(f,i)|0;if(d>>>0>=(c[h+16>>2]|0)-(c[h+12>>2]|0)>>2>>>0)break a;YS(b,c[(c[(bF(f,i)|0)+12>>2]|0)+(d<<2)>>2]|0);d=d+1|0}}while(0);l=j;return}function Yl(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;g=k;do if((d[b+2468>>0]|0)>12){t4(b);j=c[b+648>>2]|0;G4(j,Z9(c[j+4>>2]|0)|0)}else{if((a[b+2462>>0]|0)!=2){j=c[b+648>>2]|0;G4(j,Z9(c[j+4>>2]|0)|0);break}GC(b);a[g>>0]=0;f=b+648|0;h=0;do{GC(b);xR(b,3,g);i=h;h=a[g>>0]|0;switch(h<<24>>24){case 0:{LZ(b);break}case 1:{wr(b);break}case 2:{Sl(b);break}case 3:{LZ(b);break}case 4:{Av(b);break}case 5:{Eb(b);break}case 6:{AA(b,i);break}default:{}}J3(b);if(!(qO(b)|0))break}while(!((Z9(c[(c[f>>2]|0)+4>>2]|0)|0)==0|h<<24>>24==7));if(qO(b)|0?(e=c[f>>2]|0,j=(Z9(c[e+4>>2]|0)|0)&7,j|0):0)d4(e,j&255);J3(b)}while(0);l=k;return}function Zl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+16|0;g=q;c[g>>2]=b;c[g+4>>2]=d;n=a+148|0;h=a+152|0;i=c[h>>2]|0;if((i|0)==(c[a+156>>2]|0)){Px(n,g);o=b}else{k=g;o=c[k>>2]|0;k=c[k+4>>2]|0;m=i;c[m>>2]=o;c[m+4>>2]=k;c[h>>2]=(c[h>>2]|0)+8}h=(f&-2|0)==2;i=a+208|0;j=a+216|0;k=a+212|0;m=a+192|0;if((e|0)==1&h?(g=j,(c[g>>2]|0)==1&(c[g+4>>2]|0)==0):0)if((c[k>>2]|0)!=(d|0))if(!(c[m>>2]|0))p=9;else{p=a+232|0;c[p>>2]=c[(c[n>>2]|0)+4>>2];c[p+4>>2]=0;c[i>>2]=d;c[k>>2]=d;p=9}else g=d;else p=9;if((p|0)==9)g=c[k>>2]|0;b=c[i>>2]|0;if(!((g|0)==(d|0)|(b|0)==(g|0)&((e+1|0)==(f|0)&h&(o|0)==1)^1)?(c[m>>2]|0)!=0:0){f=a+240|0;c[f>>2]=d;c[f+4>>2]=0}else{if(b>>>0>d>>>0)c[i>>2]=d;if(g>>>0<d>>>0)c[k>>2]=d}g=j;g=z0(c[g>>2]|0,c[g+4>>2]|0,o|0,0)|0;h=j;c[h>>2]=g;c[h+4>>2]=z;h=a+224|0;g=h;b=c[g>>2]|0;g=c[g+4>>2]|0;if((d|0)>-1){b=z0(b|0,g|0,O(o,d)|0,0)|0;g=z}else{b=D_(b|0,g|0,O(o,0-d|0)|0,0)|0;g=z}d=h;c[d>>2]=b;c[d+4>>2]=g;l=q;return}function _l(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+16|0;p=r;q=b+888|0;d=c[q>>2]|0;if(!d){m=b+760|0;n=b+764|0;o=p+8+3|0;j=p+4|0;k=b+772|0;d=c[m>>2]|0;a:while(1){if((d|0)==(n|0))break;i=d+16|0;e=d+88|0;if(!(c[d+56>>2]|0))a[e>>0]=0;f=c[d+60>>2]|0;g=i+73|0;h=i+74|0;if((f+-1|0)>>>0<2?(a[h>>0]=1,(f|0)==1):0)a[g>>0]=1;if(!(((a[e>>0]|0)==0?(a[h>>0]|0)==0:0)?!(a[g>>0]|0):0))c[k>>2]=(c[k>>2]|0)+1;$x(p,b,f,c[d+64>>2]|0,46,1);e=a[o>>0]|0;f=e<<24>>24<0;g=f?c[p>>2]|0:p;h=i9(20596)|0;if(!h)e=0;else{f=g+((f?c[j>>2]|0:e&255)<<2)|0;e=HA(g,f,20596,20596+(h<<2)|0)|0;e=(e|0)==(f|0)?-1:e-g>>2}z5(p);if(!e)c[(c[(kE(m,i)|0)+32>>2]|0)+908>>2]=2;e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue a}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}d=c[q>>2]|0}c[q>>2]=d+1;q=b+872|0;c[q>>2]=0;c[q+4>>2]=0;l=r;return}function $l(b,d,e,f,g,h,i,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;o=c[f>>2]|0;p=(o|0)==(e|0);do if(p){m=(a[l+24>>0]|0)==b<<24>>24;if(!m?(a[l+25>>0]|0)!=b<<24>>24:0){n=5;break}c[f>>2]=e+1;a[e>>0]=m?43:45;c[g>>2]=0;m=0}else n=5;while(0);a:do if((n|0)==5){n=a[i+11>>0]|0;if(b<<24>>24==h<<24>>24?((n<<24>>24<0?c[i+4>>2]|0:n&255)|0)!=0:0){m=c[k>>2]|0;if((m-j|0)>=160){m=0;break}f=c[g>>2]|0;c[k>>2]=m+4;c[m>>2]=f;c[g>>2]=0;m=0;break}i=l+26|0;h=0;while(1){m=l+h|0;if((h|0)==26){m=i;break}if((a[m>>0]|0)==b<<24>>24)break;else h=h+1|0}m=m-l|0;if((m|0)>23)m=-1;else{h=401970+m|0;i=o+1|0;switch(d|0){case 10:case 8:{if((m|0)>=(d|0)){m=-1;break a}break}case 16:{if((m|0)>=22){if(p){m=-1;break a}if((o-e|0)>=3){m=-1;break a}if((a[o+-1>>0]|0)!=48){m=-1;break a}c[g>>2]=0;m=a[h>>0]|0;c[f>>2]=i;a[o>>0]=m;m=0;break a}break}default:{}}m=a[h>>0]|0;c[f>>2]=i;a[o>>0]=m;c[g>>2]=(c[g>>2]|0)+1;m=0}}while(0);return m|0}function am(b,d,e,f,g,h,i,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;o=c[f>>2]|0;p=(o|0)==(e|0);do if(p){m=(c[l+96>>2]|0)==(b|0);if(!m?(c[l+100>>2]|0)!=(b|0):0){n=5;break}c[f>>2]=e+1;a[e>>0]=m?43:45;c[g>>2]=0;m=0}else n=5;while(0);a:do if((n|0)==5){n=a[i+11>>0]|0;if((b|0)==(h|0)?((n<<24>>24<0?c[i+4>>2]|0:n&255)|0)!=0:0){m=c[k>>2]|0;if((m-j|0)>=160){m=0;break}f=c[g>>2]|0;c[k>>2]=m+4;c[m>>2]=f;c[g>>2]=0;m=0;break}i=l+104|0;h=0;while(1){m=l+(h<<2)|0;if((h|0)==26){m=i;break}if((c[m>>2]|0)==(b|0))break;else h=h+1|0}m=m-l|0;h=m>>2;if((m|0)>92)m=-1;else{i=401970+h|0;j=o+1|0;switch(d|0){case 10:case 8:{if((h|0)>=(d|0)){m=-1;break a}break}case 16:{if((m|0)>=88){if(p){m=-1;break a}if((o-e|0)>=3){m=-1;break a}if((a[o+-1>>0]|0)!=48){m=-1;break a}c[g>>2]=0;m=a[i>>0]|0;c[f>>2]=j;a[o>>0]=m;m=0;break a}break}default:{}}m=a[i>>0]|0;c[f>>2]=j;a[o>>0]=m;c[g>>2]=(c[g>>2]|0)+1;m=0}}while(0);return m|0}function bm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+64|0;g=q+36|0;i=q+24|0;j=q+12|0;p=q+51|0;k=q;m=q+50|0;n=q+49|0;o=q+48|0;TX(g);TX(i);TX(j);Bx(b);f=b+648|0;d4(c[f>>2]|0,3);xR(b,5,p);wK(b);p=a[p>>0]|0;h=p<<24>>24==1;d=0;while(1){if((d&255)>=(p&255))break;GC(b);c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[k+(e<<2)>>2]=0;e=e+1|0}a[o>>0]=0;EU(b,3,0,k);Bx(b);AT(b,n);A6(c[f>>2]|0);if(!(a[n>>0]|0)){d4(c[f>>2]|0,5);AT(b,o);if(h&(a[o>>0]|0)!=0)a[o>>0]=0}else xR(b,6,m);A6(c[f>>2]|0);A6(c[f>>2]|0);d4(c[f>>2]|0,14);wK(b);J3(b);a1(k);d=d+1<<24>>24}z5(j);z5(i);z5(g);l=q;return}function cm(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;i=b+8|0;o=i+3|0;h=a[o>>0]|0;k=h<<24>>24<0;p=b+4|0;if(k)n=c[p>>2]|0;else n=h&255;if(n>>>0<d>>>0)uaa();j=n-d|0;e=j>>>0<e>>>0?j:e;if(k)h=(c[i>>2]&2147483647)+-1|0;else h=1;if((e-n+h|0)>>>0<g>>>0)at(b,h,n+g-e-h|0,n,d,e,g,f);else{if(k)m=c[b>>2]|0;else m=b;do if((e|0)!=(g|0)){k=j-e|0;if(!k){h=g;l=21}else{i=m+(d<<2)|0;j=i+(e<<2)|0;if(e>>>0>g>>>0){W2(i,f,g);W2(i+(g<<2)|0,j,k);h=g;break}do if(i>>>0<f>>>0&(m+(n<<2)|0)>>>0>f>>>0){h=g-e|0;if(j>>>0>f>>>0){W2(i,f,e);d=e+d|0;f=f+(g<<2)|0;e=0;break}else{f=f+(h<<2)|0;h=g;break}}else h=g;while(0);l=m+(d<<2)|0;W2(l+(h<<2)|0,l+(e<<2)|0,k);l=21}}else{e=g;h=g;l=21}while(0);if((l|0)==21)W2(m+(d<<2)|0,f,h);h=h-e+n|0;if((a[o>>0]|0)<0)c[p>>2]=h;else a[o>>0]=h;y7(m+(h<<2)|0,0)}return b|0}function dm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;h=i;f=kE(b+760|0,b+840|0)|0;d=f+32|0;e=c[d>>2]|0;a:do if(!e){g=f+36|0;d=c[g>>2]|0;e=f+40|0;if((d|0)==2){$x(h,b,2,c[e>>2]|0,46,1);d=i9(20624)|0;f=a[h+8+3>>0]|0;if((d|0)==((f<<24>>24<0?c[h+4>>2]|0:f&255)|0)){f=(VG(h,20624,d)|0)==0;z5(h);if(f){Lj(b);break}}else z5(h);d=c[g>>2]|0}do if((d|0)==1){$x(h,b,1,c[e>>2]|0,52,1);d=i9(20660)|0;g=a[h+8+3>>0]|0;if((d|0)!=((g<<24>>24<0?c[h+4>>2]|0:g&255)|0)){z5(h);break}g=(VG(h,20660,d)|0)==0;z5(h);if(g){Nd(b);break a}}while(0);e=b+536|0;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!((d|0)==0&(e|0)==0))e1(b,d,e)}else{YS(b,e);if(!(c[(c[d>>2]|0)+728>>2]&8))a[f+64>>0]=1}while(0);l=i;return}function em(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+32|0;h=k+12|0;g=k+16|0;j=k;i=d+528|0;f=i;f=z0(c[f>>2]|0,c[f+4>>2]|0,1,0)|0;e=i;c[e>>2]=f;c[e+4>>2]=z;ID(d,h);bB(d,g);GC(d);Bx(d);e=d+648|0;A6(c[e>>2]|0);A6(c[e>>2]|0);A6(c[e>>2]|0);d4(c[e>>2]|0,5);wK(d);e=i;e=z0(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;f=i;c[f>>2]=e;c[f+4>>2]=z;J3(d);f=d+536|0;i=D_(c[f>>2]|0,c[f+4>>2]|0,c[i>>2]|0,c[i+4>>2]|0)|0;b[d+770>>1]=i;if(!((i&65535|0)==0&0==0))Ao(d);if(qO(d)|0){i=d+764|0;d=c[i>>2]|0;e=a[d+36+3>>0]|0;if(e<<24>>24<0)f=c[d+32>>2]|0;else f=e&255;e=a[g>>0]|0;d=(c[h>>2]|0)+315964800-(e&255)|0;if(!f){TX(j);h=T2(j,d)|0;k1((c[i>>2]|0)+28|0,h)|0;z5(j)}TX(j);h=T2(j,d)|0;k1((c[i>>2]|0)+40|0,h)|0;z5(j);j=c[i>>2]|0;a[j+52>>0]=1;a[j+104>>0]=e}l=k;return}function fm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i;W0(f,407712);g=407252+(a*56|0)|0;h=407252+(a*56|0)+4|0;a:do if((c[g>>2]|0)==(c[h>>2]|0))switch(a|0){case 0:{kG();vc(0);break a}case 1:{qG();vc(1);break a}case 2:{tG();vc(2);break a}case 3:{wG();vc(3);break a}case 4:{rG();vc(4);break a}case 5:{sG();vc(5);break a}case 6:{xG();vc(6);break a}default:break a}while(0);s7(c[f>>2]|0);if((a|0)<=6?(g=c[g>>2]|0,e=g,(((c[h>>2]|0)-g|0)/40|0)>>>0>b>>>0):0){h=c[e+(b*40|0)>>2]|0;l=i;return ((((c[e+(b*40|0)+4>>2]|0)-h|0)/12|0)>>>0>d>>>0?h+(d*12|0)|0:408444)|0}l=i;return 408444}function gm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+80|0;e=k+68|0;f=k+56|0;h=k+16|0;i=k;gq(e,b,0,d,357790);m=a[e+8+3>>0]|0;m=((m<<24>>24<0?c[e+4>>2]|0:m&255)|0)==0;z5(e);if(m){$x(e,b,0,d,51,1);$x(f,b,0,d,52,1);m=a[e+8+3>>0]|0;if(!(((m<<24>>24<0?c[e+4>>2]|0:m&255)|0)==0?(m=a[f+8+3>>0]|0,!((m<<24>>24<0?c[f+4>>2]|0:m&255)|0)):0))j=4;if((j|0)==4?(MQ(),$x(h,b,0,d,57,1),g=Nv(h)|0,z5(h),(g|0)!=406808):0){mI(h);Xy(i,42252);z3(h,i);z5(i);og(h,cK(406804,g+16|0,6)|0);if((c[h>>2]|0)!=(c[h+4>>2]|0)?(Xy(i,42348),m=(PG(h,f,i)|0)==-1,z5(i),m):0){de(i,h);Mc(b,0,d,357790,i,0);z5(i)}$_(h)}z5(f);z5(e)}l=k;return}function hm(b){b=b|0;var d=0,f=0,h=0,i=0,j=0,k=0;d=b+2488|0;k=d;i=c[k>>2]|0;k=c[k+4>>2]|0;f=b+656|0;j=b+536|0;h=j;f=z0(c[h>>2]|0,c[h+4>>2]|0,c[f>>2]|0,c[f+4>>2]|0)|0;h=z;if(k>>>0>h>>>0|(k|0)==(h|0)&i>>>0>f>>>0){k=d;c[k>>2]=f;c[k+4>>2]=h}d=b+2496|0;k=d;i=c[k+4>>2]|0;if(i>>>0<h>>>0|((i|0)==(h|0)?(c[k>>2]|0)>>>0<f>>>0:0)){k=d;c[k>>2]=f;c[k+4>>2]=h}i=b+908|0;switch(c[i>>2]|0){case 4:{MZ(b);break}case 5:{oZ(b);break}default:{}}if(qO(b)|0){k=b+48|0;k=z0(c[b+612>>2]|0,0,c[k>>2]|0,c[k+4>>2]|0)|0;j=z0(k|0,z|0,c[j>>2]|0,c[j+4>>2]|0)|0;k=b+40|0;d=b+312|0;f=b+896|0;if((j|0)==(c[k>>2]|0)?(z|0)==(c[k+4>>2]|0):0){h=d;j=c[h+4>>2]|0;k=f;c[k>>2]=c[h>>2];c[k+4>>2]=j}h=b+728|0;if(!(c[h>>2]&1))pO(b);j=d;d=c[j+4>>2]|0;k=f;f=c[k+4>>2]|0;if((((!(d>>>0<f>>>0|((d|0)==(f|0)?(c[j>>2]|0)>>>0<(c[k>>2]|0)>>>0:0))?+g[(c[b+24>>2]|0)+136>>2]<1.0:0)?(c[i>>2]&-2|0)==4:0)?(c[h>>2]&2|0)==0:0)?(jt(b),(a[b+492>>0]|0)==0):0)xp(b+760|0,0);np(b,e[b+2466>>1]|0,0)}return}function im(d){d=d|0;var e=0,f=0,h=0;e=d+760|0;h=e;if((c[h>>2]|0)==0&(c[h+4>>2]|0)==0){f=+g[(c[d+24>>2]|0)+136>>2]>=.3;h=e;c[h>>2]=f?30:2;c[h+4>>2]=f?0:0}e=d+360|0;f=d+784|0;h=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));h=e;if((c[h>>2]|0)==-1?(c[h+4>>2]|0)==-1:0){h=e;c[h>>2]=0;c[h+4>>2]=0}c[d+824>>2]=0;e=d+828|0;c[e>>2]=-1;c[e+4>>2]=-1;c[e+8>>2]=-1;c[e+12>>2]=-1;c[e+16>>2]=-1;b[d+848>>1]=0;b[d+850>>1]=0;b[d+852>>1]=0;a[d+856>>0]=1;e=d+857|0;a[e>>0]=0;a[e+1>>0]=0;a[e+2>>0]=0;a[e+3>>0]=0;a[e+4>>0]=0;a[d+862>>0]=8;a[d+863>>0]=0;a[d+864>>0]=0;a[d+865>>0]=0;e=d+866|0;b[e>>1]=65535;b[e+2>>1]=65535;a[e+4>>0]=255;a[d+854>>0]=0;a[d+855>>0]=0;a[d+906>>0]=0;a[d+910>>0]=0;e=d+492|0;f=d+871|0;h=f+34|0;do{a[f>>0]=0;f=f+1|0}while((f|0)<(h|0));if(!(a[e>>0]|0)){h=d+144|0;c[h>>2]=0;c[h+4>>2]=0}h=d+772|0;yH(h);e=c[h>>2]|0;a[e>>0]=1;f=d+493|0;if(!(a[f>>0]|0))a[e+32>>0]=1;a[e+176>>0]=1;AR(d,0,0);if(!(a[f>>0]|0))AR(d,32,0);AR(d,176,0);e=255;while(1){if(e>>>0<=184)break;a[(c[h>>2]|0)+e>>0]=1;e=e+-1|0}return}function jm(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;do if((e+-1|0)>>>0>31)f=0;else{k=b+8|0;g=c[k>>2]|0;l=b+24|0;h=c[l>>2]|0;f=h+g|0;if(f>>>0<e>>>0){c[k>>2]=0;c[l>>2]=0;a[b+28>>0]=1;f=0;break}c[b+16>>2]=f;j=b+20|0;if(h>>>0<e>>>0){f=e-h|0;if((f|0)==32)h=0;else h=c[j>>2]<<f;i=b+4|0;switch((f+-1|0)>>>3&536870911|0){case 3:{f=f+-8|0;b=c[i>>2]|0;h=(d[b>>0]|0)<<f|h;b=b+1|0;c[i>>2]=b;g=g+-8|0;c[k>>2]=g;m=14;break}case 2:{b=c[i>>2]|0;m=14;break}case 1:{b=c[i>>2]|0;m=15;break}case 0:{b=c[i>>2]|0;m=16;break}default:{b=f;f=c[j>>2]|0}}if((m|0)==14){f=f+-8|0;h=(d[b>>0]|0)<<f|h;b=b+1|0;c[i>>2]=b;g=g+-8|0;c[k>>2]=g;m=15}if((m|0)==15){f=f+-8|0;h=(d[b>>0]|0)<<f|h;b=b+1|0;c[i>>2]=b;g=g+-8|0;c[k>>2]=g;m=16}if((m|0)==16){m=d[b>>0]|0;c[j>>2]=m;c[i>>2]=b+1;b=f;f=m}j=g>>>0<8?g:8;m=j-b|0;c[l>>2]=m;c[k>>2]=g-j;f=c[5676+(b<<2)>>2]&f>>>m|h}else{f=h-e|0;c[l>>2]=f;f=(c[j>>2]|0)>>>f}f=c[5676+(e<<2)>>2]&f}while(0);return f|0}function km(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+16|0;k=o;n=o+8|0;d=o+7|0;e=o+6|0;f=o+5|0;h=o+4|0;bB(b,o+9|0);jB(b,k);k=c[k>>2]|0;pY(k,0,0,n);pY(k,0,1,d);pY(k,0,3,e);pY(k,0,4,f);pY(k,0,5,h);k=b+788|0;ID(b,k);if(a[n>>0]|0)oz(b,b+888|0);g=b+528|0;if(a[d>>0]|0){m=g;m=z0(c[m>>2]|0,c[m+4>>2]|0,4,0)|0;n=g;c[n>>2]=m;c[n+4>>2]=z}m=(a[e>>0]|0)==0;n=b+896|0;if(!m)ID(b,n);i=(a[f>>0]|0)==0;j=b+900|0;if(!i)ID(b,j);if(a[h>>0]|0){f=g;f=z0(c[f>>2]|0,c[f+4>>2]|0,4,0)|0;h=g;c[h>>2]=f;c[h+4>>2]=z}if(qO(b)|0){f=b+916|0;d=wD(f,c[k>>2]|0)|0;e=b+928|0;c[e>>2]=d;if((d|0)==(b+920|0)){d=c[f>>2]|0;c[e>>2]=d}if(m)c[n>>2]=c[d+280>>2];if(i)c[j>>2]=c[d+284>>2]}l=o;return}function lm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;if((a[b+492>>0]|0)==0?(c[b+904>>2]|0)==1785737760:0)Ly(b);else e=4;a:do if((e|0)==4){d=c[b+936>>2]|0;k=b+909|0;if((d|0)==(c[b+940>>2]|0)){a[k>>0]=0;break}j=b+948|0;l=c[b+956>>2]|0;e=b+64|0;while(1){if((d|0)==(l|0)){d=l;e=12;break}g=d;f=c[g>>2]|0;g=c[g+4>>2]|0;i=e;h=c[i>>2]|0;i=c[i+4>>2]|0;if(!(g>>>0<i>>>0|(g|0)==(i|0)&f>>>0<h>>>0)){e=10;break}d=d+32|0}if((e|0)==10){c[j>>2]=d;if(g>>>0>i>>>0|(g|0)==(i|0)&f>>>0>h>>>0){d=d+-32|0;e=12}}if((e|0)==12)c[j>>2]=d;if((d|0)==(l|0)){a[k>>0]=0;break}K7(b);i=b+920|0;d=c[b+916>>2]|0;b:while(1){if((d|0)==(i|0))break a;f=d+36|0;g=d+40|0;e=0;while(1){h=c[f>>2]|0;if(e>>>0>=(c[g>>2]|0)-h>>2>>>0)break;Kl(c[h+(e<<2)>>2]|0);e=e+1|0}e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue b}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}}while(0);return}function mm(a){a=a|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+80|0;h=n+48|0;i=n+36|0;j=n+24|0;k=n+12|0;m=n;c=n+68|0;d=n+66|0;e=n+64|0;f=n+62|0;g=n+60|0;TX(h);TX(i);TX(j);TX(k);TX(m);HB(a,c);HB(a,d);HB(a,e);HB(a,f);HB(a,g);c=b[c>>1]|0;if(c<<16>>16)VY(a,c&65535,0,h);c=b[d>>1]|0;if(c<<16>>16)VY(a,c&65535,0,i);c=b[e>>1]|0;if(c<<16>>16)VY(a,c&65535,0,j);c=b[f>>1]|0;if(c<<16>>16)VY(a,c&65535,0,k);c=b[g>>1]|0;if(c<<16>>16)VY(a,c&65535,0,m);zb(a,0,0,159,h,0);zb(a,0,0,199,i,0);zb(a,0,0,300,j,0);zb(a,0,0,320,k,0);zb(a,0,0,321,m,0);z5(m);z5(k);z5(j);z5(i);z5(h);l=n;return}function nm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;g=a+80|0;e=a+84|0;d=0;while(1){b=c[g>>2]|0;if(d>>>0>=(c[e>>2]|0)-b>>2>>>0)break;b=c[b+(d<<2)>>2]|0;if(b|0){Rx(b);laa(b)}d=d+1|0}f=a+152|0;e=a+156|0;b=c[f>>2]|0;a:while(1){if((b|0)==(e|0))break;d=c[b+28>>2]|0;if(d|0){Ev(d);laa(d)}d=c[b+4>>2]|0;if(!d)while(1){d=c[b+8>>2]|0;if((c[d>>2]|0)==(b|0)){b=d;continue a}else b=d}else b=d;while(1){d=c[b>>2]|0;if(!d)break;else b=d}}bU(a+200|0);n4(a+188|0);w_(a+176|0);_O(a+164|0);GQ(f);_O(a+140|0);cU(a+128|0);rW(a+108|0);cU(g);oV(a+68|0);RX(a+56|0);z5(a+40|0);z5(a+28|0);z5(a+16|0);z5(a+4|0);return}function om(d){d=d|0;var e=0,f=0,h=0;e=d+768|0;f=e;if((c[f>>2]|0)==0&(c[f+4>>2]|0)==0){h=+g[(c[d+24>>2]|0)+136>>2]>=.3;f=e;c[f>>2]=h?512:2;c[f+4>>2]=h?0:0}e=d+892|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;e=d+980|0;c[e>>2]=0;c[e+4>>2]=0;c[d+916>>2]=-1;c[d+920>>2]=-1;c[d+924>>2]=-1;c[d+988>>2]=-1;c[d+952>>2]=0;e=d+960|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;b[e+12>>1]=0;b[d+976>>1]=-1;b[d+978>>1]=0;a[d+992>>0]=0;a[d+993>>0]=0;a[d+995>>0]=-1;a[d+996>>0]=-1;a[d+997>>0]=1;e=d+998|0;b[e>>1]=0;b[e+2>>1]=0>>>16;a[d+1002>>0]=5;a[d+1003>>0]=-1;a[d+1004>>0]=-1;a[d+1005>>0]=-1;a[d+1007>>0]=0;a[d+1008>>0]=-1;a[d+1009>>0]=0;a[d+1010>>0]=0;a[d+1011>>0]=1;a[d+1013>>0]=0;a[d+1014>>0]=0;a[d+1015>>0]=0;a[d+1017>>0]=0;a[d+1018>>0]=0;e=d+1048|0;c[e>>2]=-1;c[e+4>>2]=-1;b[d+1056>>1]=-1;e=d+1035|0;b[d+1042>>1]=0;h=d+1064|0;c[h>>2]=0;c[h+4>>2]=0;a[d+1072>>0]=0;c[d+1076>>2]=0;d=d+780|0;a[e>>0]=0;a[e+1>>0]=0;a[e+2>>0]=0;a[e+3>>0]=0;a[e+4>>0]=0;a[e+5>>0]=0;_F(d);d=c[d>>2]|0;a[d+537>>0]=1;e=255;while(1){if(e>>>0<=184)break;a[d+(e*3|0)>>0]=1;e=e+-1|0}return}function pm(a){a=a|0;var b=0,d=0,f=0,h=0,i=0,j=0;if(((c[a+908>>2]|0)+-3|0)>>>0<2)Vt(a+760|0);i=a+2488|0;b=i;j=c[b>>2]|0;b=c[b+4>>2]|0;do if(!((j|0)==-1&(b|0)==0)?(d=a+2496|0,h=d,f=c[h>>2]|0,h=c[h+4>>2]|0,!((f|0)==0&(h|0)==0)):0)if(+(f>>>0)+4294967296.0*+(h>>>0)>(+(j>>>0)+4294967296.0*+(b>>>0))*1.02){RB(a,2,0,110,384435,-1,1,1);if(!(+g[(c[a+24>>2]|0)+136>>2]>=1.0))break;h=i;i=a+2466|0;j=a+112|0;f=j;KW(a,2,0,114,(+((c[h>>2]|0)>>>0)+4294967296.0*+((c[h+4>>2]|0)>>>0))/+(e[i>>1]|0)*(+((c[f>>2]|0)>>>0)+4294967296.0*+(c[f+4>>2]|0))*8.0,0,0);f=d;h=j;KW(a,2,0,118,(+((c[f>>2]|0)>>>0)+4294967296.0*+((c[f+4>>2]|0)>>>0))/+(e[i>>1]|0)*(+((c[h>>2]|0)>>>0)+4294967296.0*+(c[h+4>>2]|0))*8.0,0,0);h=a+312|0;f=h;f=UW(e[i>>1]|0|0,0,c[f>>2]|0,c[f+4>>2]|0)|0;oK(a,2,0,137,f,z,10,0);KW(a,2,0,68,(+((c[h>>2]|0)>>>0)+4294967296.0*+((c[h+4>>2]|0)>>>0))*+(e[i>>1]|0)/(+((c[j>>2]|0)>>>0)+4294967296.0*+(c[j+4>>2]|0))*1.0e3,0,0);break}else{if(!(+g[(c[a+24>>2]|0)+136>>2]>=1.0))break;RB(a,2,0,110,384431,-1,1,0);break}while(0);return}function qm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;p=l;l=l+32|0;m=p+12|0;n=p;o=b+840|0;jZ(b,d,0,o);h=a[b+848+3>>0]|0;k=h<<24>>24<0;i=b+844|0;if(k){f=c[o>>2]|0;g=c[i>>2]|0}else{f=o;g=h&255}d=i9(35112)|0;if(!((d|0)!=0?(q=f+(g<<2)|0,g=HA(f,q,35112,35112+(d<<2)|0)|0,!((g|0)!=(q|0)&(g|0)==(f|0))):0))j=6;do if((j|0)==6){if(k){f=c[i>>2]|0;g=c[o>>2]|0}else{f=h&255;g=o}d=i9(35140)|0;if(!((f|0)==0|(d|0)==0)?(q=g+(f<<2)|0,j=YL(g,q,35140,35140+(d<<2)|0)|0,e=j-g>>2,(j|0)!=(q|0)):0){if(!e)break}else e=-1;f=e+-1|0;if(k)d=c[o>>2]|0;else d=o;if((c[d+(f<<2)>>2]|0)==32){lw(n,o,0,f);p2(m,n);vF(b+852|0,m)|0;z5(m);O0(n);lw(n,o,e,-1);p2(m,n);vF(b+864|0,m)|0;z5(m);O0(n)}}while(0);l=p;return}function rm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0.0;i=l;l=l+160|0;g=i;h=i+8|0;d=a[b+8+3>>0]|0;if(d<<24>>24<0)d=c[b+4>>2]|0;else d=d&255;if(!d){e=0;d=0}else{d=h+64|0;f=h+8|0;c[f>>2]=42320;e=h+12|0;c[h>>2]=1204;c[d>>2]=1224;c[h+4>>2]=0;DO(h+64|0,e);c[h+136>>2]=0;c[h+140>>2]=-1;c[h>>2]=42300;c[d>>2]=42340;c[f>>2]=42320;aV(e);c[e>>2]=42096;f=h+44|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[f+(d<<2)>>2]=0;d=d+1|0}c[h+56>>2]=0;c[h+60>>2]=24;lq(e,b);f=h+(c[(c[h>>2]|0)+-12>>2]|0)+4|0;c[f>>2]=c[f>>2]&-75|2;zu(h,g)|0;do if(!(c[h+(c[(c[h>>2]|0)+-12>>2]|0)+16>>2]&5))if((oH(b,46,0)|0)!=-1){j=+Cq(b);e=g;f=c[e>>2]|0;e=c[e+4>>2]|0;d=z0(f|0,e|0,1,0)|0;if(!(j-(+(f>>>0)+4294967296.0*+(e>>>0))>=.5))d=f;else{e=z;break}}else{e=g;d=c[e>>2]|0;e=c[e+4>>2]|0}else{d=0;e=0}while(0);hY(h)}z=e;l=i;return d|0}function sm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0.0;j=l;l=l+160|0;h=j+144|0;i=j;e=a[b+8+3>>0]|0;if(e<<24>>24<0)e=c[b+4>>2]|0;else e=e&255;if(!e)e=0;else{e=i+64|0;g=i+8|0;c[g>>2]=42320;f=i+12|0;c[i>>2]=1204;c[e>>2]=1224;c[i+4>>2]=0;DO(i+64|0,f);c[i+136>>2]=0;c[i+140>>2]=-1;c[i>>2]=42300;c[e>>2]=42340;c[g>>2]=42320;aV(f);c[f>>2]=42096;g=i+44|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[g+(e<<2)>>2]=0;e=e+1|0}c[i+56>>2]=0;c[i+60>>2]=24;lq(f,b);f=i+(c[(c[i>>2]|0)+-12>>2]|0)|0;switch(d<<24>>24){case 8:{e=64;break}case 10:{e=2;break}default:e=d<<24>>24==16?8:0}d=f+4|0;c[d>>2]=c[d>>2]&-75|e;Bu(i,h)|0;do if(!(c[i+(c[(c[i>>2]|0)+-12>>2]|0)+16>>2]&5)){if((oH(b,46,0)|0)!=-1){k=+Cq(b);e=c[h>>2]|0;if(k-+(e>>>0)>=.5){e=e+1&255;break}}else e=c[h>>2]|0;e=e&255}else e=0;while(0);hY(i)}l=j;return e|0}function tm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0.0;i=l;l=l+160|0;g=i;h=i+8|0;d=a[b+8+3>>0]|0;if(d<<24>>24<0)d=c[b+4>>2]|0;else d=d&255;if(!d){e=0;d=0}else{d=h+64|0;f=h+8|0;c[f>>2]=42320;e=h+12|0;c[h>>2]=1204;c[d>>2]=1224;c[h+4>>2]=0;DO(h+64|0,e);c[h+136>>2]=0;c[h+140>>2]=-1;c[h>>2]=42300;c[d>>2]=42340;c[f>>2]=42320;aV(e);c[e>>2]=42096;f=h+44|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[f+(d<<2)>>2]=0;d=d+1|0}c[h+56>>2]=0;c[h+60>>2]=24;lq(e,b);f=h+(c[(c[h>>2]|0)+-12>>2]|0)+4|0;c[f>>2]=c[f>>2]&-75|2;Au(h,g)|0;do if(!(c[h+(c[(c[h>>2]|0)+-12>>2]|0)+16>>2]&5))if((oH(b,46,0)|0)!=-1){j=+Cq(b);e=g;f=c[e>>2]|0;e=c[e+4>>2]|0;d=z0(f|0,e|0,1,0)|0;if(!(j-(+(f>>>0)+4294967296.0*+(e|0))>.5))d=f;else{e=z;break}}else{e=g;d=c[e>>2]|0;e=c[e+4>>2]|0}else{d=0;e=0}while(0);hY(h)}z=e;l=i;return d|0}function um(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+16|0;k=p+9|0;m=p+4|0;n=p;o=p+8|0;GC(b);j=e&255;i=b+648|0;h=0;g=0;while(1){if((h|0)==(j|0))break;GC(b);a[k>>0]=0;if((h|0)!=0?(AT(b,k),(a[k>>0]|0)!=0):0){AT(b,n);n3(b,m);f=0;e=0;while(1){if(f>>>0>g>>>0)break;if(K6(c[i>>2]|0)|0){GC(b);A6(c[i>>2]|0);J3(b);e=e+1|0}else{A6(c[i>>2]|0);AT(b,o);e=(d[o>>0]|0)+e|0}f=f+1|0}}else{n3(b,m);n3(b,n);f=c[m>>2]|0;g=c[n>>2]|0;e=0;while(1){if((e|0)==(f|0)){e=0;break}T5(b);A6(c[i>>2]|0);e=e+1|0}while(1){if((e|0)==(g|0))break;T5(b);A6(c[i>>2]|0);e=e+1|0}e=g+f|0}J3(b);h=h+1|0;g=e}J3(b);l=p;return}function vm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+4|0;i=j;GC(b);switch(d<<24>>24){case 4:case 2:case 1:{Mo(b,d,h,4);e=7;break}case 3:{tx(b,3,h,4);e=8;break}case 9:case 7:case 5:{tx(b,d,h,2);e=7;break}case 11:case 10:case 8:case 6:{Mo(b,d,h,2);e=7;break}default:{t4(b);J3(b)}}if((e|0)==7)switch(d<<24>>24){case 6:case 5:case 2:case 1:{e=20;break}default:e=8}a:do if((e|0)==8){f=(d&255)<5?4:2;g=b+648|0;e=0;while(1){if((e|0)>=(f|0))break;if(a[h+e>>0]|0)A6(c[g>>2]|0);e=e+1|0}if(d<<24>>24==11){f=0;while(1){if((f|0)==2){e=20;break a}switch(a[h+f>>0]|0){case -16:case 16:{GC(b);e=3;do{e=e+1|0;AT(b,i)}while((a[i>>0]|0)!=0);G4(c[g>>2]|0,e);J3(b);break}default:{}}f=f+1|0}}else e=20}while(0);if((e|0)==20)J3(b);l=j;return}function wm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=l;l=l+64|0;b=h+24|0;d=h+16|0;g=h;e=h+44|0;f=h+32|0;CK(a);i=a+528|0;j=i;j=z0(c[j>>2]|0,c[j+4>>2]|0,8,0)|0;k=i;c[k>>2]=j;c[k+4>>2]=z;Uy(a,b);k=i;k=z0(c[k>>2]|0,c[k+4>>2]|0,8,0)|0;j=i;c[j>>2]=k;c[j+4>>2]=z;Uy(a,d);Uy(a,h+8|0);Uy(a,g);bD(a,h+48|0);j=i;j=z0(c[j>>2]|0,c[j+4>>2]|0,4,0)|0;c[i>>2]=j;c[i+4>>2]=z;bD(a,a+816|0);bD(a,e);e=c[e>>2]|0;if(e|0)lL(a,0,0,109,e,10,0);TX(f);e=b;e=g5(c[e>>2]|0,c[e+4>>2]|0,1e4,0)|0;zb(a,0,0,256,Wq(f,e,z)|0,0);z5(f);f=d;e=c[f>>2]|0;f=c[f+4>>2]|0;k=g5(e|0,f|0,1e3,0)|0;j=z;d=g;b=c[d>>2]|0;d=c[d+4>>2]|0;if(j>>>0>d>>>0|(j|0)==(d|0)&k>>>0>b>>>0){k=g5(e|0,f|0,1e4,0)|0;k=D_(k|0,z|0,b|0,d|0)|0;oK(a,0,0,92,k,z,10,0)}c[a+876>>2]=b;l=h;return}function xm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+32|0;g=m+24|0;h=m+12|0;i=m;ID(b,g);k=b+536|0;j=b+528|0;if((c[g>>2]|0)==1296125530){e=j;d=c[e>>2]|0;e=c[e+4>>2]|0;g=k;f=c[g>>2]|0;g=c[g+4>>2]|0;if(g>>>0>e>>>0|(g|0)==(e|0)&f>>>0>d>>>0){g=D_(f|0,g|0,d|0,e|0)|0;iF(b,g,z)}Xy(h,40008);e=c[b+760>>2]|0;e=HD(e+68|0,e)|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;f=j9(387686)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[i+11>>0]=f;d=i}else{g=f+16&-16;d=ZW(g)|0;c[i>>2]=d;c[i+8>>2]=g|-2147483648;c[i+4>>2]=f}i1(d,387686,f)|0;J7(d+f|0,0);vF(VC(e+4|0,i)|0,h)|0;a1(i);z5(h)}g=j;f=c[g>>2]|0;g=c[g+4>>2]|0;e=k;d=c[e>>2]|0;e=c[e+4>>2]|0;if(e>>>0>g>>>0|(e|0)==(g|0)&d>>>0>f>>>0){k=D_(d|0,e|0,f|0,g|0)|0;iF(b,k,z)}l=m;return}function ym(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=c[d+48>>2]|0;i=b+8|0;j=b+4|0;k=b+11|0;a:do if(!(e&16)){if(!(e&8)){c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;e=0;while(1){if((e|0)==3)break a;c[b+(e<<2)>>2]=0;e=e+1|0}}e=c[d+8>>2]|0;g=c[d+16>>2]|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=g-e|0;if(d>>>0>4294967279)uaa();if(d>>>0<11)a[k>>0]=d;else{h=d+16&-16;k=ZW(h)|0;c[b>>2]=k;c[i>>2]=h|-2147483648;c[j>>2]=d;b=k}f=b;while(1){if((e|0)==(g|0))break;J7(f,a[e>>0]|0);e=e+1|0;f=f+1|0}J7(b+d|0,0)}else{g=d+44|0;e=c[g>>2]|0;f=c[d+24>>2]|0;if(e>>>0<f>>>0){c[g>>2]=f;h=f}else h=e;e=c[d+20>>2]|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=h-e|0;if(g>>>0>4294967279)uaa();if(g>>>0<11)a[k>>0]=g;else{d=g+16&-16;k=ZW(d)|0;c[b>>2]=k;c[i>>2]=d|-2147483648;c[j>>2]=g;b=k}f=b;while(1){if((e|0)==(h|0))break;J7(f,a[e>>0]|0);e=e+1|0;f=f+1|0}J7(b+g|0,0)}while(0);return}function zm(){var b=0,d=0,e=0,f=0;e=l;l=l+80|0;b=e+16|0;d=e;W0(b,407712);f=a[404959]|0;if(!((f<<24>>24<0?c[101238]|0:f&255)|0)){f=404800;c[f>>2]=0;c[f+4>>2]=0;f=404808;c[f>>2]=67108864;c[f+4>>2]=0;f=404816;c[f>>2]=-64771072;c[f+4>>2]=6;a[404824]=0;c[101207]=0;c[101208]=0;c[101209]=0;c[101210]=0;c[101211]=1;c[101212]=1;c[101213]=1;c[101214]=1;c[101215]=1;c[101216]=1;g[101217]=.5;g[101218]=.5;g[101219]=0.0;f=404880;c[f>>2]=70778;c[f+4>>2]=0;f=404888;c[f>>2]=1;c[f+4>>2]=0;a[404896]=0;c[101294]=0;a[404916]=0;a[404917]=1;a[404918]=1;a[404919]=1;a[404920]=0;a[404921]=0;Xy(d,42472);vF(404948,d)|0;z5(d);Xy(d,42436);vF(404936,d)|0;z5(d);Xy(d,41840);vF(404960,d)|0;z5(d);Xy(d,42444);vF(404972,d)|0;z5(d);Xy(d,42212);vF(404984,d)|0;z5(d);TX(d);vF(404996,d)|0;z5(d);s7(c[b>>2]|0);xA(b);tj(b);LT(b)}else s7(c[b>>2]|0);l=e;return}function Am(a){a=a|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=l;l=l+16|0;h=e+3|0;i=e+2|0;f=e+1|0;g=e;GC(a);NB(a,a+796|0);NB(a,a+798|0);Bx(a);RS(a);RS(a);RS(a);RS(a);xR(a,2,i);xR(a,2,g);wK(a);j=a+528|0;k=j;k=z0(c[k>>2]|0,c[k+4>>2]|0,2,0)|0;c[j>>2]=k;c[j+4>>2]=z;bB(a,h);bB(a,f);b[a+800>>1]=(d[i>>0]|0)<<8|(d[h>>0]|0);b[a+802>>1]=(d[g>>0]|0)<<8|(d[f>>0]|0);Bx(a);xR(a,3,a+804|0);KS(a);KS(a);RS(a);RS(a);RS(a);KS(a);RS(a);RS(a);RS(a);KS(a);AT(a,a+811|0);RS(a);RS(a);wK(a);J3(a);l=e;return}function Bm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;j=b+612|0;i=c[j>>2]|0;k=b+544|0;l=c[b+548>>2]|0;e=i;while(1){if((e+4|0)>>>0>l>>>0)break;h=c[k>>2]|0;if(((a[h+e>>0]|0)==0?(a[h+(e+1)>>0]|0)==0:0)?(a[h+(e+2)>>0]|0)==1:0)break;while(1){f=e+2|0;c[j>>2]=f;if(f>>>0>=l>>>0){g=9;break}if(!(a[h+f>>0]|0)){g=8;break}else e=f}if((g|0)==8){e=e+1|0;if(a[h+e>>0]|0){e=f;continue}}else if((g|0)==9)e=e+1|0;c[j>>2]=e}if(e>>>0>i>>>0?(d=e+-1|0,(a[(c[k>>2]|0)+d>>0]|0)==0):0)c[j>>2]=d;else d=e;do if((d+4|0)==(l|0)){i=c[k>>2]|0;e=d+1|0;if((((a[i+d>>0]|0)==0?(a[i+e>>0]|0)==0:0)?(a[i+(d+2)>>0]|0)==0:0)?(a[i+(d+3)>>0]|0)==1:0)break;c[j>>2]=e;d=e}while(0);do if((d+3|0)==(l|0)){i=c[k>>2]|0;e=d+1|0;if(((a[i+d>>0]|0)==0?(a[i+e>>0]|0)==0:0)?(a[i+(d+2)>>0]|0)==1:0)break;c[j>>2]=e;d=e}while(0);do if((d+2|0)==(l|0)){i=c[k>>2]|0;e=d+1|0;if((a[i+d>>0]|0)==0?(a[i+e>>0]|0)==0:0)break;c[j>>2]=e;d=e}while(0);if((d+1|0)==(l|0)?(a[(c[k>>2]|0)+d>>0]|0)!=0:0){c[j>>2]=l;d=l}if((d+4|0)>>>0>l>>>0)d=0;else{a[b+376>>0]=1;d=1}return d|0}function Cm(a,b){a=a|0;b=b|0;var d=0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[a+(d<<2)>>2]=0;d=d+1|0}d=b&65535;if((d&3|0)!=3){if(d&1|0)JX(a,384209)|0;if(d&2|0)JX(a,371775)|0}else JX(a,384229)|0;if(d&8|0)JX(a,372336)|0;if(d&128|0)JX(a,372348)|0;if((d&2064|0)!=2064){if(d&16|0)JX(a,371799)|0;if(d&2048|0)JX(a,371809)|0}else JX(a,371787)|0;if(d&32|0)JX(a,371817)|0;if(d&64|0)JX(a,372394)|0;if(d&256|0)JX(a,371826)|0;if(d&512|0)JX(a,371833)|0;if(d&1024|0)JX(a,371843)|0;if(d&4|0)JX(a,379396)|0;if(d&4096|0)JX(a,372498)|0;return}function Dm(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;j=l;l=l+16|0;f=j+14|0;h=j+12|0;i=j;if(!(a[d+797>>0]|0)){Bx(d);e=d+648|0;d4(c[e>>2]|0,4);g=d+770|0;sR(d,12,g);wK(d);if(b[g>>1]|0)Ao(d);Bx(d);d4(c[e>>2]|0,4);sR(d,12,f);wK(d);k=d+528|0;n=c[k+4>>2]|0;f=d+536|0;m=c[f+4>>2]|0;if(n>>>0<m>>>0|((n|0)==(m|0)?(c[k>>2]|0)>>>0<(c[f>>2]|0)>>>0:0)){GC(d);NB(d,d+776|0);NB(d,h);Bx(d);d4(c[e>>2]|0,4);sR(d,12,g);wK(d);if(b[g>>1]|0)Ao(d);J3(d);if(qO(d)|0){VU(i,vd(b[h>>1]|0)|0);vF((c[d+764>>2]|0)+4|0,i)|0;z5(i)}}}else{n=d+536|0;e1(d,c[n>>2]|0,c[n+4>>2]|0)}l=j;return}function Em(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;i=b+312|0;l=i;n=c[l+4>>2]|0;j=b+896|0;k=j;m=c[k+4>>2]|0;d=b+536|0;if(!(n>>>0>m>>>0|((n|0)==(m|0)?(c[l>>2]|0)>>>0>(c[k>>2]|0)>>>0:0))){Bx(b);Yl(b);wK(b);if(a[b+904>>0]|0?(f=b+528|0,e=c[f>>2]|0,f=c[f+4>>2]|0,h=d,g=c[h>>2]|0,h=c[h+4>>2]|0,h>>>0>f>>>0|(h|0)==(f|0)&g>>>0>e>>>0):0){n=D_(g|0,h|0,e|0,f|0)|0;e1(b,n,z)}if(qO(b)|0){d=i;d=z0(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;e=z;f=i;c[f>>2]=d;c[f+4>>2]=e;f=b+360|0;h=f;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!((g|0)==-1&(h|0)==-1)){m=z0(g|0,h|0,1,0)|0;n=f;c[n>>2]=m;c[n+4>>2]=z}if(!(c[b+728>>2]&1)){pO(b);d=i;e=c[d+4>>2]|0;d=c[d>>2]|0}n=j;m=c[n+4>>2]|0;if(!(e>>>0<m>>>0|((e|0)==(m|0)?d>>>0<(c[n>>2]|0)>>>0:0))){if((c[b+908>>2]|0)==5)pO(b);KM(b)}}}else{n=d;e1(b,c[n>>2]|0,c[n+4>>2]|0)}return}function Fm(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=d+908|0;if((c[j>>2]|0)==5?(RB(d,0,0,57,378440,-1,1,0),a[d+492>>0]|0):0)RB(d,2,0,44,378440,-1,1,0);g=d+22128|0;e=c[d+22124>>2]|0;a:while(1){if((e|0)==(g|0))break;f=e+16|0;if((a[f+11>>0]|0)<0)f=c[f>>2]|0;Mc(d,0,0,f,e+28|0,0);f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue a}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}g=d+760|0;RV(g);h=d+22140|0;i=d+20|0;e=c[d+22136>>2]|0;b:while(1){if((e|0)==(h|0))break;f=e+16|0;if((a[f+11>>0]|0)<0)f=c[f>>2]|0;Mc(d,2,c[i>>2]|0,f,e+28|0,0);f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue b}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}if((c[j>>2]|0)==4)bv(g);kL(d,2,c[i>>2]|0,134,b[d+2466>>1]|0,10,0);return}function Gm(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+16|0;k=o;m=o+4|0;i=b+520|0;j=b+648|0;e=c[j>>2]|0;do if((c[i>>2]|0)==5&(c[i+4>>2]|0)==0){A6(e);A6(c[j>>2]|0)}else{if(!(K6(e)|0)){A6(c[j>>2]|0);break}GC(b);A6(c[j>>2]|0);e=d+4|0;f=d+8|0;do{n3(b,k);g=c[k>>2]|0;switch(g|0){case 1:{T5(b);break}case 2:{T5(b);break}case 3:{T5(b);n=10;break}case 6:{n=10;break}case 4:{T5(b);break}default:{}}if((n|0)==10){n=0;T5(b)}h=g&255;a[m>>0]=h;i=c[e>>2]|0;if(i>>>0<(c[f>>2]|0)>>>0){a[i>>0]=h;c[e>>2]=(c[e>>2]|0)+1}else jz(d,m)}while((Z9(c[(c[j>>2]|0)+4>>2]|0)|0)!=0&(g|0)!=0);J3(b)}while(0);l=o;return}function Hm(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+16|0;h=i+12|0;g=i;bB(b,h);h=a[h>>0]|0;if(h<<24>>24!=15){d=b+536|0;f=b+528|0;f=D_(c[d>>2]|0,c[d+4>>2]|0,c[f>>2]|0,c[f+4>>2]|0)|0;e1(b,f,z);if(a[b+784>>0]|0){d=(c[(c[(c[b+760>>2]|0)+80>>2]|0)+(e[b+772>>1]<<2)>>2]|0)+28|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;f=j9(384553)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[g+11>>0]=f;b=g}else{j=f+16&-16;b=ZW(j)|0;c[g>>2]=b;c[g+8>>2]=j|-2147483648;c[g+4>>2]=f}i1(b,384553,f)|0;J7(b+f|0,0);b=VC(d,g)|0;a1(g);j=a[b+8+3>>0]|0;if((j<<24>>24<0?c[b+4>>2]|0:j&255)|0)HX(b,41840)|0;uU(g,h,10);j=a[g+8+3>>0]|0;h=j<<24>>24<0;Ex(b,h?c[g>>2]|0:g,h?c[g+4>>2]|0:j&255)|0;z5(g)}}else Dj(b);l=i;return}function Im(a){a=a|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+16|0;e=n+4|0;h=n;i=n+8|0;j=n+11|0;KK(a);ID(a,e);ID(a,h);NB(a,i);Bx(a);xR(a,3,n+10|0);xR(a,3,j);o=a+648|0;A6(c[o>>2]|0);A6(c[o>>2]|0);wK(a);if(qO(a)|0?(k=a+896|0,m=c[e>>2]|0,f=((d[j>>0]|0)<<3)+8|0,g=b[i>>1]|0,BA(k,c[h>>2]|0,0,m,f&255,g&255)|0):0){o=a+760|0;P6(c[o>>2]|0);RV(o);RB(a,2,0,18,371891,-1,1,0);RB(a,2,0,52,371891,-1,1,0);sM(a,2,0,147,f,0);j=a+20|0;sM(a,2,c[j>>2]|0,122,(g&65535)+1|0,0);lL(a,2,c[j>>2]|0,135,m,10,0);m=k;oK(a,2,0,68,c[m>>2]|0,c[m+4>>2]|0,10,0);xp(o,371891)}l=n;return}function Jm(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;k=n+5|0;e=n+4|0;f=n+3|0;g=n+2|0;h=n+1|0;m=n;GC(b);AT(b,k);if(a[k>>0]|0)d4(c[b+648>>2]|0,4);xg(b,0);jC(b,0);LN(b);fn(b,0,0);ct(b,0,0);AT(b,e);if(a[e>>0]|0)cN(b);AT(b,f);do if(a[f>>0]|0){xR(b,4,g);k=a[g>>0]|0;e=k&255;if(k<<24>>24==15){xR(b,8,h);e=(d[h>>0]|0)+e|0}k=b+648|0;g=c[k>>2]|0;j=c[g+4>>2]|0;f=Z9(j)|0;e=e<<3;if(f>>>0<e>>>0){G4(g,f);break}h=f-e|0;i=h+7|0;f=g;e=j;while(1){e=Z9(e)|0;if(e>>>0<=i>>>0)break;xR(b,2,m);if((a[m>>0]|0)==2)ic(b,h);e=c[k>>2]|0;f=e;e=c[e+4>>2]|0}if(e>>>0>h>>>0)G4(f,e-h|0)}while(0);J3(b);l=n;return}function Km(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=l;l=l+32|0;g=j;d=a+64|0;Re(a,a+32|0,d)|0;f=a+96|0;while(1){if((f|0)==(b|0))break;h=f;i=c[h>>2]|0;h=c[h+4>>2]|0;e=d;if(M$(i,h,c[e>>2]|0,c[e+4>>2]|0)|0){e=f+8|0;c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[g+16>>2]=c[e+16>>2];c[g+20>>2]=c[e+20>>2];e=f;while(1){c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];c[e+20>>2]=c[d+20>>2];c[e+24>>2]=c[d+24>>2];c[e+28>>2]=c[d+28>>2];if((d|0)==(a|0)){d=a;break}e=d+-32|0;k=e;if(M$(i,h,c[k>>2]|0,c[k+4>>2]|0)|0){k=d;d=e;e=k}else break}k=d;c[k>>2]=i;c[k+4>>2]=h;k=d+8|0;c[k>>2]=c[g>>2];c[k+4>>2]=c[g+4>>2];c[k+8>>2]=c[g+8>>2];c[k+12>>2]=c[g+12>>2];c[k+16>>2]=c[g+16>>2];c[k+20>>2]=c[g+20>>2]}d=f;f=f+32|0}l=j;return}function Lm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+32|0;d=m+26|0;g=m+12|0;e=m+25|0;j=m+24|0;k=m;if((a[b+784>>0]|0)!=0?(a[b+785>>0]|0)!=0:0){bB(b,d);h=a[d>>0]|0;i=h&255;pY(i,0,1,j);pY(i,0,6,g);pY(i,0,7,e);do if(!(h&1)){f=(a[e>>0]|0)!=0;d=(a[g>>0]|0)!=0;e=b+528|0;if(a[j>>0]|0){g=e;g=z0(c[g>>2]|0,c[g+4>>2]|0,(f?(d?7:6):d?5:4)|0,(f?(d?0:0):d?0:0)|0)|0;j=e;c[j>>2]=g;c[j+4>>2]=z;break}if(f){g=e;g=z0(c[g>>2]|0,c[g+4>>2]|0,(d?3:2)|0,(d?0:0)|0)|0;j=e;c[j>>2]=g;c[j+4>>2]=z;break}if(d){g=e;g=z0(c[g>>2]|0,c[g+4>>2]|0,1,0)|0;j=e;c[j>>2]=g;c[j+4>>2]=z}}while(0);uU(k,h,16);BZ(c[b+508>>2]|0,c[b+668>>2]|0,i,0);z5(k)}else{VU(g,379013);BZ(c[b+508>>2]|0,c[b+668>>2]|0,0,0);z5(g)}k=b+536|0;Op(b,c[k>>2]|0,c[k+4>>2]|0);l=m;return}function Mm(a){a=a|0;var b=0,d=0,e=0,f=0;d=a+520|0;b=c[d>>2]|0;d=c[d+4>>2]|0;e=a+536|0;do switch(b|0){case 0:{if(!d)xf(a);else f=21;break}case 176:{if(!d)e1(a,c[e>>2]|0,c[e+4>>2]|0);else f=21;break}case 177:{if(!d)e1(a,c[e>>2]|0,c[e+4>>2]|0);else f=21;break}case 178:{if(!d)Xb(a);else f=21;break}case 179:{if(!d)Me(a);else f=21;break}case 180:{if(d|0)f=21;break}case 181:{if(!d)hd(a);else f=21;break}case 182:{if(!d)e1(a,c[e>>2]|0,c[e+4>>2]|0);else f=21;break}case 183:{if(!d)AX(a);else f=21;break}case 184:{if(!d)Jg(a);else f=21;break}default:f=21}while(0);do if((f|0)==21)if(d>>>0<0|(d|0)==0&b>>>0<176){Uc(a);break}else{t4(a);break}while(0);return}function Nm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;k=l;l=l+16|0;d=k;RB(b,0,0,57,378325,-1,1,1);if(a[b+760>>0]|0)RB(b,0,0,65,378856,-1,1,0);if((a[b+492>>0]|0)==0?!(IR(c[b+24>>2]|0)|0):0){TX(d);z5(d)}j=b+56|0;if((c[j>>2]|0)==-1?(c[j+4>>2]|0)==-1:0){d=0;e=0}else{e=b+568|0;d=c[e>>2]|0;e=c[e+4>>2]|0}i=xP()|0;i=z0(i|0,z|0,d|0,e|0)|0;g=b+776|0;h=g;c[h>>2]=i;c[h+4>>2]=z;h=xP()|0;h=XZ(h|0,z|0,2)|0;i=z;j=b+784|0;m=j;c[m>>2]=h;c[m+4>>2]=i;m=g;n=c[m>>2]|0;m=c[m+4>>2]|0;e=b+40|0;d=c[e>>2]|0;e=c[e+4>>2]|0;b=z0(n|0,m|0,h|0,i|0)|0;f=z;do if(!(((n|0)!=-1|(m|0)!=-1)&(f>>>0<e>>>0|(f|0)==(e|0)&b>>>0<d>>>0)))if(f>>>0>e>>>0|(f|0)==(e|0)&b>>>0>d>>>0){n=g;c[n>>2]=d;c[n+4>>2]=e;n=j;c[n>>2]=0;c[n+4>>2]=0;break}else{m=D_(d|0,e|0,h|0,i|0)|0;n=g;c[n>>2]=m;c[n+4>>2]=z;break}while(0);l=k;return}function Om(b){b=b|0;var d=0,e=0;Eg(b);c[b>>2]=17184;x1(b+760|0);TX(b+784|0);x1(b+892|0);e=b+916|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[e+(d<<2)>>2]=0;d=d+1|0}e=b+928|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[e+(d<<2)>>2]=0;d=d+1|0}e=b+940|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[e+(d<<2)>>2]=0;d=d+1|0}c[b+952>>2]=0;c[b+956>>2]=0;c[b+960>>2]=0;c[b+976>>2]=0;c[b+980>>2]=0;c[b+984>>2]=0;c[b+1032>>2]=0;c[b+1036>>2]=0;c[b+1040>>2]=0;c[b+1048>>2]=0;c[b+1052>>2]=0;c[b+1056>>2]=0;c[b+1080>>2]=0;c[b+1084>>2]=0;c[b+1088>>2]=0;a[b+494>>0]=0;a[b+733>>0]=1;a[b+808>>0]=0;e=b+816|0;c[e>>2]=0;c[e+4>>2]=0;e=b+824|0;c[e>>2]=1e6;c[e+4>>2]=0;h[b+832>>3]=0.0;c[b+880>>2]=0;c[b+884>>2]=0;c[b+888>>2]=0;a[b+912>>0]=0;a[b+913>>0]=0;c[b+1092>>2]=0;e=b+1016|0;d=b+968|0;c[d>>2]=0;c[d+4>>2]=0;c[b+772>>2]=0;c[b+1096>>2]=0;c[b+776>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;return}function Pm(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+32|0;h=o;j=c[a>>2]|0;a:do if(d|0){k=c[a+8>>2]|0;m=a+4|0;n=c[m>>2]|0;f=n;g=b;if(k-f>>2>>>0<d>>>0){i=(f-j>>2)+d|0;if(i>>>0>1073741823)uaa();else{m=k-j|0;n=m>>1;BF(h,m>>2>>>0<536870911?(n>>>0<i>>>0?i:n):1073741823,g-j>>2,a+8|0);XO(h,d,e);Ew(a,h,b)|0;zS(h);break}}f=f-g>>2;if(f>>>0<d>>>0){g=d-f|0;h=n;do{c[h>>2]=c[e>>2];h=(c[m>>2]|0)+4|0;c[m>>2]=h;g=g+-1|0}while((g|0)!=0);if(!f)break}else f=d;OG(a,b,n,b+(d<<2)|0);if(b>>>0<=e>>>0)e=(c[m>>2]|0)>>>0>e>>>0?e+(d<<2)|0:e;while(1){if(!f)break a;c[b>>2]=c[e>>2];b=b+4|0;f=f+-1|0}}while(0);l=o;return}function Qm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+32|0;f=m;k=a+8|0;i=c[k>>2]|0;g=a+12|0;j=c[g>>2]|0;h=j;do if((i|0)==(j|0)){j=a+4|0;d=c[j>>2]|0;n=c[a>>2]|0;e=n;if(d>>>0<=n>>>0){n=h-e|0;n=(n|0)==0?1:((n|0)/56|0)<<1;fE(f,n,n>>>2,c[a+16>>2]|0);pM(f,c[j>>2]|0,c[k>>2]|0);n=c[a>>2]|0;c[a>>2]=c[f>>2];c[f>>2]=n;a=f+4|0;n=c[j>>2]|0;c[j>>2]=c[a>>2];c[a>>2]=n;a=f+8|0;n=c[k>>2]|0;c[k>>2]=c[a>>2];c[a>>2]=n;a=f+12|0;n=c[g>>2]|0;c[g>>2]=c[a>>2];c[a>>2]=n;CP(f);a=c[k>>2]|0;break}e=(((d-e|0)/56|0)+1|0)/-2|0;a=d+(e*56|0)|0;while(1){if((d|0)==(i|0))break;it(a,d)|0;a=a+56|0;d=d+56|0}c[k>>2]=a;c[j>>2]=(c[j>>2]|0)+(e*56|0)}else a=i;while(0);Iw(a,b);c[k>>2]=(c[k>>2]|0)+56;l=m;return}function Rm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;j=l;l=l+16|0;k=j+4|0;e=j+3|0;h=j+2|0;f=j+1|0;g=j;i=b+528|0;m=i;m=z0(c[m>>2]|0,c[m+4>>2]|0,4,0)|0;d=i;c[d>>2]=m;c[d+4>>2]=z;Bx(b);AT(b,k);d=b+648|0;d4(c[d>>2]|0,7);wK(b);if(!(a[k>>0]|0)){Bx(b);A6(c[d>>2]|0);AT(b,e);AT(b,h);AT(b,f);d4(c[d>>2]|0,4);wK(b);d=a[e>>0]|0;if(!(d<<24>>24!=0&(a[f>>0]|0)==0)){if(!(d<<24>>24)){bB(b,g);e=a[g>>0]|0;d=0;while(1){if((d&255)>=(e&255))break;k=i;k=z0(c[k>>2]|0,c[k+4>>2]|0,1,0)|0;m=i;c[m>>2]=k;c[m+4>>2]=z;fC(b);d=d+1<<24>>24}}}else fC(b);if(a[h>>0]|0)BJ(b);k=i;k=z0(c[k>>2]|0,c[k+4>>2]|0,4,0)|0;m=i;c[m>>2]=k;c[m+4>>2]=z}l=j;return}function Sm(b,f){b=b|0;f=f|0;var g=0.0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;k=b+792|0;j=b+796|0;i=b+800+3|0;if((d[b+822>>0]|0)>=29){h=i9(13756)|0;n=a[i>>0]|0;if((h|0)==((n<<24>>24<0?c[j>>2]|0:n&255)|0)?(VG(k,13756,h)|0)==0:0)l=4;else g=0.0}else l=4;a:do if((l|0)==4){h=i9(13756)|0;n=a[i>>0]|0;if((h|0)==((n<<24>>24<0?c[j>>2]|0:n&255)|0)?(VG(k,13756,h)|0)==0:0)g=0.0;else{h=d[b+820>>0]|0;if(!(63950>>>h&1))g=0.0;else g=+((c[13788+(h<<2)>>2]|0)>>>0)*(+(e[b+812>>1]|0)*8.0/+((e[b+814>>1]|0)<<5|0))}if(f?(n=a[b+829>>0]|0,m=n&255,n<<24>>24!=-1):0){n=a[b+827>>0]|0;i=n&255;switch(n<<24>>24){case 10:case 0:{h=7;break}case 11:case 5:case 1:{h=8;break}case 12:case 6:case 2:{h=9;break}case 13:case 7:case 3:{h=10;break}case 14:case 8:case 4:{h=11;break}case 15:case 9:{h=12;break}default:break a}h=m<<h;if(h)g=g+ +((c[b+808>>2]|0)>>>0)*8.0*+((c[13852+(i<<2)>>2]|0)>>>0)/+(h>>>0)}}while(0);return +g}function Tm(b){b=b|0;var e=0,f=0,g=0,h=0;a[b+785>>0]=0;c[b+788>>2]=0;a[b+792>>0]=0;g=b+793|0;a[g>>0]=255;a[g+1>>0]=255;a[g+2>>0]=255;a[g+3>>0]=255;a[g+4>>0]=255;a[g+5>>0]=255;c[b+800>>2]=0;g=b+804|0;yC(g);yC(b+816|0);yC(b+828|0);g=c[g>>2]|0;a[g+22436>>0]=1;a[b+856>>0]=85;c[b+880>>2]=0;h=b+48|0;e=b+760|0;if(((c[h>>2]|0)==0&(c[h+4>>2]|0)==0?(c[b+548>>2]|0)>>>0>3:0)?(f=c[b+544>>2]|0,h=C9(f)|0,(h+-509|0)>>>0<2|((h&-16|0)==480|(h&-32|0)==448|(h|0)==445|(h|0)==506)):0){a[e>>0]=1;a[b+773>>0]=2;a[g+((d[f+3>>0]|0)*120|0)+116>>0]=1}if(a[e>>0]|0){a[g+22796>>0]=1;a[g+22797>>0]=1;a[g+22798>>0]=1;a[g+23036>>0]=1;a[g+23037>>0]=1;a[g+23038>>0]=1;e=192;while(1){if((e|0)==240)break;a[g+(e*120|0)+116>>0]=1;a[g+(e*120|0)+117>>0]=1;a[g+(e*120|0)+118>>0]=1;e=e+1|0}a[g+30116>>0]=1;a[g+30117>>0]=1;a[g+30118>>0]=1;a[g+30476>>0]=1;a[g+30477>>0]=1;a[g+30478>>0]=1;a[g+30596>>0]=1;a[g+30597>>0]=1;a[g+30598>>0]=1}h=b+104|0;c[h>>2]=9e4;c[h+4>>2]=0;return}function Um(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+16|0;h=o+2|0;i=o;NB(d,h);Bx(d);d4(c[d+648>>2]|0,3);sR(d,13,i);wK(d);g=d+536|0;f=d+528|0;f=D_(c[g>>2]|0,c[g+4>>2]|0,c[f>>2]|0,c[f+4>>2]|0)|0;g=z;if(!((f|0)==0&(g|0)==0))e1(d,f,g);a:do if(qO(d)|0){f=d+760|0;switch(a[d+768>>0]|0){case 1:{f=c[(c[(c[f>>2]|0)+80>>2]|0)+(e[i>>1]<<2)>>2]|0;g=f+64|0;if(c[g>>2]|0)break a;c[g>>2]=2;nG(f+16|0);break a}case 2:break;default:break a}if((a[d+784>>0]|0?(g=b[h>>1]|0,h=c[f>>2]|0,j=c[h+80>>2]|0,k=c[j+(e[d+772>>1]<<2)>>2]|0,b[k+192>>1]=g,a[k+184>>0]=(K5(g)|0)&1,k=e[i>>1]|0,k>>>0<(c[h+84>>2]|0)-j>>2>>>0):0)?(m=c[j+(k<<2)>>2]|0,n=m+64|0,(c[n>>2]|0)==0):0){c[n>>2]=2;nG(m+16|0)}}while(0);l=o;return}function Vm(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;AK(b);e=b+796|0;d=c[e>>2]|0;if(d|0)laa(d);i=b+808|0;h=b+824|0;c[h>>2]=0;c[h+4>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;if((a[b+770>>0]|0)==0?(a[b+1048>>0]|0)!=0:0){Lq(b);h=15}else h=5;a:do if((h|0)==5){e=b+840|0;e=(c[e>>2]|0)==(c[b+844>>2]|0)?b+852|0:e;f=e+4|0;g=b+784|0;e=c[e>>2]|0;b:while(1){if((e|0)==(c[f>>2]|0)){h=15;break a}d=c[e>>2]|0;if(d|0){switch(a[d+44>>0]|0){case 0:{d=c[d+28>>2]|0;break}case 2:{d=c[d+32>>2]<<1;break}default:break b}FF(g,d<<2);c[i>>2]=d}e=e+4|0}t4(b)}while(0);if((h|0)==15){c[b+920>>2]=0;c[b+924>>2]=0;c[b+884>>2]=0;i=b+888|0;c[i>>2]=-1;c[i+4>>2]=-1;c[i+8>>2]=-1;c[i+12>>2]=-1;a[b+1045>>0]=1;a[b+1047>>0]=0;i=b+1032|0;c[i>>2]=0;c[i+4>>2]=0;i=b+288|0;c[i>>2]=0;c[i+4>>2]=0;b=b+304|0;c[b>>2]=0;c[b+4>>2]=0}return}function Wm(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+32|0;f=m;k=a+8|0;i=c[k>>2]|0;g=a+12|0;j=c[g>>2]|0;h=j;do if((i|0)==(j|0)){j=a+4|0;d=c[j>>2]|0;n=c[a>>2]|0;e=n;if(d>>>0<=n>>>0){n=h-e|0;n=(n|0)==0?1:((n|0)/40|0)<<1;lE(f,n,n>>>2,c[a+16>>2]|0);FM(f,c[j>>2]|0,c[k>>2]|0);n=c[a>>2]|0;c[a>>2]=c[f>>2];c[f>>2]=n;a=f+4|0;n=c[j>>2]|0;c[j>>2]=c[a>>2];c[a>>2]=n;a=f+8|0;n=c[k>>2]|0;c[k>>2]=c[a>>2];c[a>>2]=n;a=f+12|0;n=c[g>>2]|0;c[g>>2]=c[a>>2];c[a>>2]=n;VP(f);a=c[k>>2]|0;break}e=(((d-e|0)/40|0)+1|0)/-2|0;a=d+(e*40|0)|0;while(1){if((d|0)==(i|0))break;Kq(a,d)|0;a=a+40|0;d=d+40|0}c[k>>2]=a;c[j>>2]=(c[j>>2]|0)+(e*40|0)}else a=i;while(0);yw(a,b);c[k>>2]=(c[k>>2]|0)+40;l=m;return}function Xm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+32|0;i=s+8|0;m=s;bB(a,s+16|0);jB(a,s+12|0);ID(a,i);n=a+880|0;o=a+528|0;p=a+536|0;q=a+544|0;r=a+612|0;j=m+4|0;k=a+916|0;h=a+788|0;i=c[i>>2]|0;g=0;a:while(1){if(g>>>0>=i>>>0)break;b=p;a=c[b>>2]|0;b=c[b+4>>2]|0;do if(g>>>0<(c[n>>2]|0)>>>0){e=o;d=c[e>>2]|0;e=z0(d|0,c[e+4>>2]|0,12,0)|0;f=z;if(f>>>0>b>>>0|(f|0)==(b|0)&e>>>0>a>>>0)break a;a=(c[q>>2]|0)+(c[r>>2]|0)+d|0;c[m>>2]=W8(a)|0;c[j>>2]=W8(a+4|0)|0;a=o;c[a>>2]=e;c[a+4>>2]=f;a=bF(k,h)|0;b=a+92|0;d=c[b>>2]|0;if((d|0)==(c[a+96>>2]|0)){Px(a+88|0,m);break}else{a=m;e=c[a+4>>2]|0;f=d;c[f>>2]=c[a>>2];c[f+4>>2]=e;c[b>>2]=(c[b>>2]|0)+8;break}}else{f=o;c[f>>2]=a;c[f+4>>2]=b}while(0);g=g+1|0}l=s;return}function Ym(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+32|0;e=i+12|0;f=i;TX(e);Ce(b,e);a:do if(qO(b)|0){switch(a[b+768>>0]|0){case -38:case -55:case -56:break;default:break a}if(a[b+785>>0]|0?(h=a[e+8+3>>0]|0,(h<<24>>24<0?c[e+4>>2]|0:h&255)|0):0){g=$C((HD((c[b+760>>2]|0)+68|0,b+770|0)|0)+16|0,b+774|0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;h=j9(391021)|0;if(h>>>0>4294967279)uaa();if(h>>>0<11){a[f+11>>0]=h;d=f}else{j=h+16&-16;d=ZW(j)|0;c[f>>2]=d;c[f+8>>2]=j|-2147483648;c[f+4>>2]=h}i1(d,391021,h)|0;J7(d+h|0,0);k1(VC(g+4|0,f)|0,e)|0;a1(f)}}while(0);qO(b)|0;z5(e);l=i;return}function Zm(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;n=e+11|0;g=a[n>>0]|0;h=c[e+4>>2]|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[b+(f<<2)>>2]=0;f=f+1|0}m=g<<24>>24<0?h:g&255;Fp(b,((m<<3>>>0)/6|0)+1|0);l=0;while(1){if(l>>>0>=m>>>0)break;ay(b,1,a[372540+((d[((a[n>>0]|0)<0?c[e>>2]|0:e)+l>>0]|0)>>>2&255)>>0]|0)|0;g=(a[n>>0]|0)<0?c[e>>2]|0:e;f=a[g+l>>0]<<4&48;k=l+1|0;h=k>>>0<m>>>0;if(h)f=(d[g+k>>0]|0)>>>4|f;ay(b,1,a[372540+f>>0]|0)|0;i=l+2|0;j=i>>>0<m>>>0;if(h){g=(a[n>>0]|0)<0?c[e>>2]|0:e;f=a[g+k>>0]<<2&60;if(j)f=(d[g+i>>0]|0)>>>6|f;ay(b,1,a[372540+f>>0]|0)|0}else ay(b,1,61)|0;if(j)ay(b,1,a[372540+(a[((a[n>>0]|0)<0?c[e>>2]|0:e)+i>>0]&63)>>0]|0)|0;else ay(b,1,61)|0;l=l+3|0}return}function _m(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;o=l;l=l+16|0;f=o;k=d+528|0;n=k;n=z0(c[n>>2]|0,c[n+4>>2]|0,3,0)|0;m=z;g=k;c[g>>2]=n;c[g+4>>2]=m;g=d+536|0;h=d+782|0;i=d+770|0;j=d+794|0;e=d+648|0;while(1){p=g;q=c[p+4>>2]|0;if(!(m>>>0<q>>>0|((m|0)==(q|0)?n>>>0<(c[p>>2]|0)>>>0:0)))break;GC(d);YD(d,f);q=f;if((c[q>>2]|0)==-1?(c[q+4>>2]|0)==255:0){p=g;q=k;q=D_(c[p>>2]|0,c[p+4>>2]|0,c[q>>2]|0,c[q+4>>2]|0)|0;e1(d,q,z);J3(d)}else{NB(d,h);Bx(d);d4(c[e>>2]|0,6);A6(c[e>>2]|0);A6(c[e>>2]|0);d4(c[e>>2]|0,3);A6(c[e>>2]|0);sR(d,12,i);wK(d);a[j>>0]=1;if(b[i>>1]|0)Ao(d);J3(d)}n=k;m=c[n+4>>2]|0;n=c[n>>2]|0}l=o;return}function $m(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0;c[e>>2]=b;c[h>>2]=f;b=c[e>>2]|0;a:while(1){if(b>>>0>=d>>>0){b=0;break}m=c[b>>2]|0;if(m>>>0>1114111|(m&-2048|0)==55296){b=2;break}do if(m>>>0>=128){l=(m&63|128)&255;f=m>>>6;if(m>>>0<2048){b=c[h>>2]|0;if((g-b|0)<2){b=1;break a}c[h>>2]=b+1;a[b>>0]=f|192;m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=l;break}i=c[h>>2]|0;j=g-i|0;k=i+1|0;b=(f&63|128)&255;f=m>>>12;if(m>>>0<65536){if((j|0)<3){b=1;break a}c[h>>2]=k;a[i>>0]=f|224;m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=b;m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=l;break}else{if((j|0)<4){b=1;break a}c[h>>2]=k;a[i>>0]=m>>>18|240;m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=f&63|128;m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=b;m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=l;break}}else{b=c[h>>2]|0;if((g-b|0)<1){b=1;break a}c[h>>2]=b+1;a[b>>0]=m}while(0);b=(c[e>>2]|0)+4|0;c[e>>2]=b}return b|0}function an(a){a=a|0;var b=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;g=i;f=a+536|0;b=c[f>>2]|0;f=c[f+4>>2]|0;switch(b|0){case 1:{if(!f){bB(a,g);b=0;a=d[g>>0]|0}else h=18;break}case 2:{if(!f){NB(a,g);b=0;a=e[g>>1]|0}else h=18;break}case 3:{if(!f){jB(a,g);b=0;a=c[g>>2]|0}else h=18;break}case 4:{if(!f){ID(a,g);b=0;a=c[g>>2]|0}else h=18;break}case 5:{if(!f){$y(a,g);a=g;b=c[a+4>>2]|0;a=c[a>>2]|0}else h=18;break}case 6:{if(!f){_y(a,g);a=g;b=c[a+4>>2]|0;a=c[a>>2]|0}else h=18;break}case 7:{if(!f){Zy(a,g);a=g;b=c[a+4>>2]|0;a=c[a>>2]|0}else h=18;break}case 8:{if(!f){oz(a,g);a=g;b=c[a+4>>2]|0;a=c[a>>2]|0}else h=18;break}default:h=18}if((h|0)==18){e1(a,b,f);b=0;a=0}z=b;l=i;return a|0}function bn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+16|0;o=p;do if(!b)b=0;else{i=d;j=f-i>>2;m=g+12|0;k=c[m>>2]|0;j=(k|0)>(j|0)?k-j|0:0;k=e;i=k-i|0;g=i>>2;if((i|0)>0?(gb[c[(c[b>>2]|0)+48>>2]&31](b,d,g)|0)!=(g|0):0){b=0;break}if((j|0)>0){c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;if(j>>>0>1073741807)uaa();g=o+8|0;d=g+3|0;do if(j>>>0>=2){i=j+4&2147483644;if(i>>>0>1073741823)ra();else{n=ZW(i<<2)|0;c[o>>2]=n;c[g>>2]=i|-2147483648;c[o+4>>2]=j;break}}else{a[d>>0]=j;n=o}while(0);$2(n,j,h);y7(n+(j<<2)|0,0);h=(gb[c[(c[b>>2]|0)+48>>2]&31](b,(a[d>>0]|0)<0?c[o>>2]|0:o,j)|0)==(j|0);O0(o);if(!h){b=0;break}}o=f-k|0;f=o>>2;if((o|0)>0?(gb[c[(c[b>>2]|0)+48>>2]&31](b,e,f)|0)!=(f|0):0){b=0;break}c[m>>2]=0}while(0);l=p;return b|0}function cn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+32|0;f=m;k=a+8|0;i=c[k>>2]|0;g=a+12|0;j=c[g>>2]|0;h=j;do if((i|0)==(j|0)){j=a+4|0;d=c[j>>2]|0;n=c[a>>2]|0;e=n;if(d>>>0<=n>>>0){n=h-e|0;n=(n|0)==0?1:((n|0)/12|0)<<1;xE(f,n,n>>>2,c[a+16>>2]|0);gN(f,c[j>>2]|0,c[k>>2]|0);n=c[a>>2]|0;c[a>>2]=c[f>>2];c[f>>2]=n;a=f+4|0;n=c[j>>2]|0;c[j>>2]=c[a>>2];c[a>>2]=n;a=f+8|0;n=c[k>>2]|0;c[k>>2]=c[a>>2];c[a>>2]=n;a=f+12|0;n=c[g>>2]|0;c[g>>2]=c[a>>2];c[a>>2]=n;HQ(f);a=c[k>>2]|0;break}e=(((d-e|0)/12|0)+1|0)/-2|0;a=d+(e*12|0)|0;while(1){if((d|0)==(i|0))break;vF(a,d)|0;a=a+12|0;d=d+12|0}c[k>>2]=a;c[j>>2]=(c[j>>2]|0)+(e*12|0)}else a=i;while(0);rV(a,b);c[k>>2]=(c[k>>2]|0)+12;l=m;return}function dn(a){a=a|0;var b=0,d=0,e=0;a:do if((c[a+548>>2]|0)>>>0<8)b=0;else{b=c[a+544>>2]|0;e=V8(b+(c[a+612>>2]|0)|0)|0;b:do if(!((e|0)==1446063664&(z|0)==1145849632)?(d=C9(b)|0,(d|0)!=1380533830):0){b=C9(b+4|0)|0;c:do if((b|0)<1836019574){if((b|0)<1718909296)switch(b|0){case 1718773093:break b;default:break c}if((b|0)<1835295092)switch(b|0){case 1718909296:break b;default:break c}else switch(b|0){case 1835295092:break b;default:break c}}else{if((b|0)<1936419184)switch(b|0){case 1836019574:break b;default:break c}if((b|0)<2003395685)switch(b|0){case 1936419184:break b;default:break c}else switch(b|0){case 2003395685:break b;default:break c}}while(0);if((d|0)!=101591860){jb[c[(c[a>>2]|0)+44>>2]&511](a);b=1;break a}}while(0);U5(a);b=1}while(0);return b|0}function en(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+48|0;f=q+36|0;e=q+28|0;j=q;k=q+24|0;bB(b,f);jB(b,q+32|0);ID(b,e);m=j+8|0;n=j+16|0;o=b+916|0;p=b+788|0;e=c[e>>2]|0;f=(a[f>>0]|0)==0;d=0;while(1){if((d|0)==(e|0))break;GC(b);if(f){ID(b,k);i=j;c[i>>2]=c[k>>2];c[i+4>>2]=0;ID(b,k);i=m;c[i>>2]=c[k>>2];c[i+4>>2]=0}else{oz(b,j);oz(b,m)}ID(b,n);J3(b);g=bF(o,p)|0;h=g+68|0;i=c[h>>2]|0;if((i|0)==(c[g+72>>2]|0))Ws(g+64|0,j);else{c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];c[i+12>>2]=c[j+12>>2];c[i+16>>2]=c[j+16>>2];c[i+20>>2]=c[j+20>>2];c[h>>2]=(c[h>>2]|0)+24}d=d+1|0}l=q;return}function fn(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+16|0;k=p+4|0;m=p;GC(b);n=e&1;o=b+22116|0;j=e&f;f=c[o>>2]|0;e=(a[f+n>>0]|0)==0;do if(j)if(e){c[k>>2]=369459;c[m>>2]=369555;break}else{c[k>>2]=369411;c[m>>2]=369239;break}else if(e){c[k>>2]=369775;c[m>>2]=370015;break}else{c[k>>2]=369651;c[m>>2]=369287;break}while(0);i=b+648|0;h=0;e=f;while(1){g=h&255;if((h&255)>=(d[e+9+n>>0]|0))break;a:do if(!(a[e+29+(n<<2)+g>>0]|0)){e=(a[e+n>>0]|0)!=0;if(j){d4(c[i>>2]|0,e?5:6);f=1}else{d4(c[i>>2]|0,e?6:7);f=1}while(1){e=c[o>>2]|0;if((f&255)>=(d[(d[e+11+(n<<3)+g>>0]|0)+(e+42)>>0]|0))break a;DK(b,m);f=f+1<<24>>24}}else{f=0;while(1){if((f&255)>=(d[(d[e+11+(n<<3)+g>>0]|0)+(e+42)>>0]|0))break a;DK(b,k);f=f+1<<24>>24;e=c[o>>2]|0}}while(0);h=h+1<<24>>24}J3(b);l=p;return}function gn(a){a=a|0;var b=0,d=0,e=0,f=0;f=a+12|0;e=a+16|0;d=0;while(1){b=c[f>>2]|0;if(d>>>0>=(c[e>>2]|0)-b>>2>>>0)break;b=c[b+(d<<2)>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);d=d+1|0}b=c[a+36>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);b=c[a+40>>2]|0;if(b|0)laa(b);cU(a+388|0);cU(a+376|0);cU(a+364|0);cU(a+352|0);cU(a+340|0);cU(a+328|0);cU(a+316|0);cU(a+304|0);cU(a+292|0);cU(a+280|0);aU(a+148|0);aU(a+136|0);aU(a+112|0);aU(a+100|0);aU(a+88|0);aU(a+76|0);wR(a+64|0);IT(a+24|0);cU(f);z5(a);return}function hn(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=c[e>>2]|0;g=c[b+808>>2]|0;h=(c[b+812>>2]|0)-g|0;if((f|0)==-1)if((h|0)==4){c[e>>2]=0;e=0;i=4}else i=6;else{e=f;i=4}if((i|0)==4)if(e>>>0<h>>2>>>0?(k=g+(e<<2)|0,(c[k>>2]|0)!=0):0){Bx(b);f=c[k>>2]|0;e=c[f>>2]|0;if(!e)if((a[f+50>>0]|0)!=0?(a[f+51>>0]|0)!=0:0)i=11;else e=0;else if(a[e+32>>0]|0)i=11;if((i|0)==11){e=b+648|0;d4(c[e>>2]|0,4);d4(c[e>>2]|0,2);A6(c[e>>2]|0);e=c[c[k>>2]>>2]|0}if(r$(e)|0?(f=c[e+8>>2]|0,g=a[f+5>>0]|0,h=(a[f>>0]|0)==0,j=b+648|0,d4(c[j>>2]|0,(d[f+4>>0]|0)+1&255),d4(c[j>>2]|0,(g&255)+1&255),!h):0)d4(c[j>>2]|0,(d[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+2>>0]|0)+1&255);wK(b)}else i=6;if((i|0)==6){k=c[b+648>>2]|0;G4(k,Z9(c[k+4>>2]|0)|0)}return}function jn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0.0;i=l;l=l+160|0;g=i+144|0;h=i;d=a[b+8+3>>0]|0;if(d<<24>>24<0)d=c[b+4>>2]|0;else d=d&255;if(!d)d=0;else{d=h+64|0;f=h+8|0;c[f>>2]=42320;e=h+12|0;c[h>>2]=1204;c[d>>2]=1224;c[h+4>>2]=0;DO(h+64|0,e);c[h+136>>2]=0;c[h+140>>2]=-1;c[h>>2]=42300;c[d>>2]=42340;c[f>>2]=42320;aV(e);c[e>>2]=42096;f=h+44|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[f+(d<<2)>>2]=0;d=d+1|0}c[h+56>>2]=0;c[h+60>>2]=24;lq(e,b);f=h+(c[(c[h>>2]|0)+-12>>2]|0)+4|0;c[f>>2]=c[f>>2]&-75|2;Bu(h,g)|0;do if(!(c[h+(c[(c[h>>2]|0)+-12>>2]|0)+16>>2]&5)){if((oH(b,46,0)|0)!=-1){j=+Cq(b);d=c[g>>2]|0;if(j-+(d>>>0)>=.5){d=d+1&65535;break}}else d=c[g>>2]|0;d=d&65535}else d=0;while(0);hY(h)}l=i;return d|0}function kn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0;k=e+8+3|0;i=a[k>>0]|0;j=e+4|0;if((i<<24>>24<0?c[j>>2]|0:i&255)|0){TX(b);i=a[d+8+3>>0]|0;h=i<<24>>24<0;i=h?c[d+4>>2]|0:i&255;if(i|0){Ex(b,h?c[d>>2]|0:d,i)|0;HX(b,42252)|0}h=a[k>>0]|0;k=h<<24>>24<0;Ex(b,k?c[e>>2]|0:e,k?c[j>>2]|0:h&255)|0;h=f+8+3|0;k=a[h>>0]|0;i=f+4|0;if((k<<24>>24<0?c[i>>2]|0:k&255)|0){HX(b,42252)|0;k=a[h>>0]|0;e=k<<24>>24<0;Ex(b,e?c[f>>2]|0:f,e?c[i>>2]|0:k&255)|0}h=g+8+3|0;f=a[h>>0]|0;i=g+4|0;if((f<<24>>24<0?c[i>>2]|0:f&255)|0){HX(b,39932)|0;f=a[h>>0]|0;k=f<<24>>24<0;Ex(b,k?c[g>>2]|0:g,k?c[i>>2]|0:f&255)|0;HX(b,39944)|0}}else p2(b,h);return}function ln(b){b=b|0;var d=0,e=0;Eg(b);c[b>>2]=36004;e=b+780|0;c[b+808>>2]=0;c[b+812>>2]=0;c[b+816>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;TX(b+820|0);TX(b+832|0);TX(b+844|0);TX(b+856|0);TX(b+868|0);e=b+880|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[e+(d<<2)>>2]=0;d=d+1|0}x1(b+1080|0);e=b+1092|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[e+(d<<2)>>2]=0;d=d+1|0}IX(b+72|0,391454)|0;c[b+504>>2]=2;a[b+733>>0]=1;e=b+632|0;c[e>>2]=65536;c[e+4>>2]=0;a[b+96>>0]=1;a[b+493>>0]=1;e=b+360|0;c[e>>2]=0;c[e+4>>2]=0;a[b+760>>0]=1;e=b+768|0;c[e>>2]=0;c[e+4>>2]=0;a[b+776>>0]=0;a[b+777>>0]=0;c[b+804>>2]=0;e=b+928|0;c[e>>2]=1048576;c[e+4>>2]=0;e=b+936|0;c[e>>2]=1048576;c[e+4>>2]=0;e=b+944|0;c[e>>2]=-1;c[e+4>>2]=-1;a[b+1033>>0]=0;a[b+1016>>0]=0;e=b+144|0;c[e>>2]=0;c[e+4>>2]=0;a[b+1034>>0]=0;return}function mn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;m=l;l=l+16|0;k=m+4|0;h=m;if(!(c[e+4>>2]&1)){j=c[(c[b>>2]|0)+24>>2]|0;c[h>>2]=c[d>>2];c[k>>2]=c[h>>2];b=ub[j&31](b,k,e,f,g&1)|0}else{O4(k,e);b=u$(c[k>>2]|0,409132)|0;c6(k);e=c[b>>2]|0;if(g)kb[c[e+24>>2]&63](k,b);else kb[c[e+28>>2]&63](k,b);i=k+11|0;b=a[i>>0]|0;if(b<<24>>24<0){e=b;b=c[k>>2]|0;j=8}else{g=k;e=b}while(1){if((j|0)==8)g=b;j=e<<24>>24<0;b=c[d>>2]|0;if((g|0)==((j?c[k>>2]|0:k)+(j?c[k+4>>2]|0:e&255)|0))break;e=a[g>>0]|0;if(b|0){f=b+24|0;h=c[f>>2]|0;if((h|0)==(c[b+28>>2]|0)){h=c[(c[b>>2]|0)+52>>2]|0;j=e9(e)|0;b=tb[h&31](b,j)|0}else{c[f>>2]=h+1;a[h>>0]=e;b=e9(e)|0}if(d8(b,-1)|0)c[d>>2]=0}e=a[i>>0]|0;b=g+1|0;j=8}a1(k)}l=m;return b|0}function nn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;m=n+4|0;h=n;if(!(c[e+4>>2]&1)){k=c[(c[b>>2]|0)+24>>2]|0;c[h>>2]=c[d>>2];c[m>>2]=c[h>>2];b=ub[k&31](b,m,e,f,g&1)|0}else{O4(m,e);b=u$(c[m>>2]|0,409156)|0;c6(m);e=c[b>>2]|0;if(g)kb[c[e+24>>2]&63](m,b);else kb[c[e+28>>2]&63](m,b);j=m+8+3|0;e=a[j>>0]|0;f=c[m>>2]|0;k=m+4|0;g=c[d>>2]|0;b=g;i=e<<24>>24<0?f:m;while(1){h=e<<24>>24<0;if((i|0)==((h?f:m)+((h?c[k>>2]|0:e&255)<<2)|0))break;e=c[i>>2]|0;if(b){f=b+24|0;h=c[f>>2]|0;if((h|0)==(c[b+28>>2]|0)){h=c[(c[g>>2]|0)+52>>2]|0;e=raa(e)|0;e=tb[h&31](b,e)|0}else{c[f>>2]=h+4;c[h>>2]=e;e=raa(e)|0}if(d8(e,-1)|0){c[d>>2]=0;b=0;h=0}else h=g}else{b=0;h=0}i=i+4|0;e=a[j>>0]|0;f=c[m>>2]|0;g=h}O0(m)}l=n;return b|0}function on(d){d=d|0;var e=0,f=0,g=0;Eg(d);c[d>>2]=12688;x1(d+796|0);_$(d+809|0);e=d+852|0;f=d+816|0;g=f+36|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));x1(e);x1(d+864|0);a[d+733>>0]=1;f=d+632|0;c[f>>2]=32768;c[f+4>>2]=0;f=d+640|0;c[f>>2]=1048576;c[f+4>>2]=0;a[d+96>>0]=1;a[d+493>>0]=1;f=d+360|0;c[f>>2]=0;c[f+4>>2]=0;f=d+760|0;c[d+772>>2]=0;g=d+880|0;c[g>>2]=0;c[g+4>>2]=0;a[d+1180>>0]=0;a[d+1181>>0]=0;a[d+1182>>0]=0;c[f>>2]=0;c[f+4>>2]=0;b[f+8>>1]=0;a[f+10>>0]=0;a[d+1184>>0]=-1;f=0;while(1){if((f|0)==8)break;else e=0;while(1){if((e|0)==9)break;b[d+1032+(f*18|0)+(e<<1)>>1]=0;a[d+1257+(f*9|0)+e>>0]=-1;a[d+1411+(f*9|0)+e>>0]=0;a[d+1185+(f*9|0)+e>>0]=0;a[d+1329+(f*9|0)+e>>0]=0;a[d+1492+(f*9|0)+e>>0]=0;b[d+888+(f*18|0)+(e<<1)>>1]=0;e=e+1|0}f=f+1|0}a[d+1401>>0]=0;a[d+1409>>0]=0;a[d+1410>>0]=0;a[d+1483>>0]=0;a[d+1484>>0]=0;c[d+1488>>2]=0;c[d+1564>>2]=0;a[d+1569>>0]=1;a[d+1570>>0]=0;return}function pn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0.0;i=l;l=l+160|0;g=i+144|0;h=i;d=a[b+8+3>>0]|0;if(d<<24>>24<0)d=c[b+4>>2]|0;else d=d&255;if(!d)d=0;else{d=h+64|0;f=h+8|0;c[f>>2]=42320;e=h+12|0;c[h>>2]=1204;c[d>>2]=1224;c[h+4>>2]=0;DO(h+64|0,e);c[h+136>>2]=0;c[h+140>>2]=-1;c[h>>2]=42300;c[d>>2]=42340;c[f>>2]=42320;aV(e);c[e>>2]=42096;f=h+44|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[f+(d<<2)>>2]=0;d=d+1|0}c[h+56>>2]=0;c[h+60>>2]=24;lq(e,b);f=h+(c[(c[h>>2]|0)+-12>>2]|0)+4|0;c[f>>2]=c[f>>2]&-75|2;Bu(h,g)|0;do if(!(c[h+(c[(c[h>>2]|0)+-12>>2]|0)+16>>2]&5))if((oH(b,46,0)|0)!=-1){j=+Cq(b);d=c[g>>2]|0;if(j-+(d>>>0)>=.5){d=d+1|0;break}}else d=c[g>>2]|0;else d=0;while(0);hY(h)}l=i;return d|0}function qn(a){a=a|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;p=l;l=l+48|0;k=p+16|0;m=p+32|0;n=p;bB(a,p+36|0);jB(a,p+28|0);TX(k);r3(a,p+12|0);t3(a,m);NB(a,p+34|0);j=a+528|0;f=j;d=c[f>>2]|0;f=c[f+4>>2]|0;q=z0(d|0,f|0,2,0)|0;r=z;g=a+536|0;i=g;h=c[i>>2]|0;i=c[i+4>>2]|0;if(!(r>>>0>i>>>0|(r|0)==(i|0)&q>>>0>h>>>0)){yE(a,n);r=(b[n>>1]|0)==-257;f=g;d=j;d=D_(c[f>>2]|0,c[f+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;f=z;if(r)iZ(a,d,f,k);else o=4}else{d=D_(h|0,i|0,d|0,f|0)|0;f=z;o=4}if((o|0)==4)xZ(a,d,f,k);if(qO(a)|0){TX(n);Mc(a,0,0,376977,lh(n,e[m>>1]|0)|0,0);z5(n);Mc(a,0,0,376992,k,0)}z5(k);l=p;return}function rn(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+32|0;j=m+12|0;k=m;i=c[b>>2]|0;h=i+40|0;g=c[h>>2]|0;h=c[h+4>>2]|0;if(h>>>0<e>>>0|(h|0)==(e|0)&g>>>0<d>>>0){if(f|0){h=(c[i+508>>2]|0)==0;if(!h)J3(i);c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;g=j9(f)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[k+11>>0]=g;d=k}else{i=g+16&-16;d=ZW(i)|0;c[k>>2]=d;c[k+8>>2]=i|-2147483648;c[k+4>>2]=g}i1(d,f,g)|0;J7(d+g|0,0);JX(k,380327)|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];d=0;while(1){if((d|0)==3)break;c[k+(d<<2)>>2]=0;d=d+1|0}a1(j);a1(k);if(!h){k=(c[b>>2]|0)+508|0;c[k>>2]=(c[k>>2]|0)+1}}xp(b,f)}else{k=D_(g|0,h|0,d|0,e|0)|0;Rl(b,k,z)}l=m;return}function sn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0.0;i=l;l=l+160|0;g=i+144|0;h=i;d=a[b+8+3>>0]|0;if(d<<24>>24<0)d=c[b+4>>2]|0;else d=d&255;if(!d)d=0;else{d=h+64|0;f=h+8|0;c[f>>2]=42320;e=h+12|0;c[h>>2]=1204;c[d>>2]=1224;c[h+4>>2]=0;DO(h+64|0,e);c[h+136>>2]=0;c[h+140>>2]=-1;c[h>>2]=42300;c[d>>2]=42340;c[f>>2]=42320;aV(e);c[e>>2]=42096;f=h+44|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[f+(d<<2)>>2]=0;d=d+1|0}c[h+56>>2]=0;c[h+60>>2]=24;lq(e,b);f=h+(c[(c[h>>2]|0)+-12>>2]|0)+4|0;c[f>>2]=c[f>>2]&-75|2;Et(h,g)|0;do if(!(c[h+(c[(c[h>>2]|0)+-12>>2]|0)+16>>2]&5))if((oH(b,46,0)|0)!=-1){j=+Dq(b);d=c[g>>2]|0;if(j-+(d|0)>=.5){d=d+1|0;break}}else d=c[g>>2]|0;else d=0;while(0);hY(h)}l=i;return d|0}function tn(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=e&255;j=b+4|0;f=c[j>>2]|0;g=f&7;k=5676+(e<<2)|0;l=b+12|0;m=f-e|0;i=m&7;do if(e>>>0>g>>>0){if(f>>>0<e>>>0){c[j>>2]=0;a[b+13>>0]=1;e=0;break}g=e-g|0;f=g&255;a:do if((f|0)==32){e=0;n=10}else{e=(d[l>>0]|0)<<f;switch(f+-1>>3|0){case 3:{n=10;break a}case 2:{h=g;f=c[b>>2]|0;n=11;break a}case 1:{f=c[b>>2]|0;n=12;break a}default:{f=c[b>>2]|0;break a}}}while(0);if((n|0)==10){p=c[b>>2]|0;o=p+1|0;c[b>>2]=o;h=f+-8|0;e=(d[p>>0]|0)<<(g+248&255)|e;f=o;n=11}if((n|0)==11){p=f+1|0;c[b>>2]=p;g=(h&255)+-8|0;e=(d[f>>0]|0)<<(h+248&255)|e;f=p;n=12}if((n|0)==12){o=g+248|0;p=f+1|0;c[b>>2]=p;g=o;e=(d[f>>0]|0)<<(o&255)|e;f=p}c[b>>2]=f+1;p=a[f>>0]|0;a[l>>0]=p;c[j>>2]=m;e=(c[5676+((g&255)<<2)>>2]&(p&255)>>>i|e)&c[k>>2]}else{c[j>>2]=m;e=(d[l>>0]|0)>>>i&c[k>>2]}while(0);return e|0}function un(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;m=n;j=(d|0)!=-1|(e|0)!=-1;k=b+20|0;if(j&(((c[b+88>>2]|0)-(c[b+84>>2]|0)|0)/12|0)>>>0<2){h=b+176|0;c[h>>2]=d;c[h+4>>2]=e;h=b+208|0;c[h>>2]=d;c[h+4>>2]=e;h=c[b+124>>2]|0;i=c[b+128>>2]|0;if((h|0)!=(i|0)){i=h+((i-h>>3)+-1<<3)|0;c[i>>2]=d;c[i+4>>2]=e}h=c[k>>2]|0;if(h|0?($x(m,h,0,0,86,1),i=a[m+8+3>>0]|0,i=((i<<24>>24<0?c[m+4>>2]|0:i&255)|0)==0,z5(m),!i):0)oK(c[k>>2]|0,0,0,86,d,e,10,1)}if(j|(c[k>>2]|0)==0){c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;h=0;while(1){if((h|0)==3)break;c[m+(h<<2)>>2]=0;h=h+1|0}So(b,d,e,m);O0(m)}if(!((f|0)==-1&(g|0)==-1)?c[k>>2]|0:0){W0(m,b+360|0);WQ(c[k>>2]|0,f,g);s7(c[m>>2]|0)}l=n;return}function vn(a){a=a|0;var b=0,d=0,e=0;e=l;l=l+16|0;d=e;if((a|0)>6)b=408388;else{W0(d,407712);b=407252+(a*56|0)|0;a:do if((c[b>>2]|0)==(c[407252+(a*56|0)+4>>2]|0))switch(a|0){case 0:{kG();vc(0);break a}case 1:{qG();vc(1);break a}case 2:{tG();vc(2);break a}case 3:{wG();vc(3);break a}case 4:{rG();vc(4);break a}case 5:{sG();vc(5);break a}case 6:{xG();vc(6);break a}default:break a}while(0);s7(c[d>>2]|0)}l=e;return b|0}function wn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0;o=l;l=l+48|0;n=o+16|0;i=o+12|0;m=o+8|0;j=o+4|0;k=o;e=c[e>>2]|0;if(!(c[f+4>>2]&1)){c[m>>2]=-1;p=c[(c[b>>2]|0)+16>>2]|0;c[j>>2]=c[d>>2];c[k>>2]=e;c[i>>2]=c[j>>2];c[n>>2]=c[k>>2];e=lb[p&63](b,i,n,f,g,m)|0;c[d>>2]=e;switch(c[m>>2]|0){case 0:{a[h>>0]=0;break}case 1:{a[h>>0]=1;break}default:{a[h>>0]=1;c[g>>2]=4}}}else{O4(n,f);p=u$(c[n>>2]|0,409148)|0;c6(n);O4(n,f);i=u$(c[n>>2]|0,409156)|0;c6(n);kb[c[(c[i>>2]|0)+24>>2]&63](n,i);kb[c[(c[i>>2]|0)+28>>2]&63](n+12|0,i);i=n+24|0;a[h>>0]=(Nf(d,e,n,i,p,g,1)|0)==(n|0)&1;e=c[d>>2]|0;do{i=i+-12|0;O0(i)}while((i|0)!=(n|0))}l=o;return e|0}function xn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0;o=l;l=l+48|0;n=o+16|0;i=o+12|0;m=o+8|0;j=o+4|0;k=o;e=c[e>>2]|0;if(!(c[f+4>>2]&1)){c[m>>2]=-1;p=c[(c[b>>2]|0)+16>>2]|0;c[j>>2]=c[d>>2];c[k>>2]=e;c[i>>2]=c[j>>2];c[n>>2]=c[k>>2];e=lb[p&63](b,i,n,f,g,m)|0;c[d>>2]=e;switch(c[m>>2]|0){case 0:{a[h>>0]=0;break}case 1:{a[h>>0]=1;break}default:{a[h>>0]=1;c[g>>2]=4}}}else{O4(n,f);p=u$(c[n>>2]|0,409116)|0;c6(n);O4(n,f);i=u$(c[n>>2]|0,409132)|0;c6(n);kb[c[(c[i>>2]|0)+24>>2]&63](n,i);kb[c[(c[i>>2]|0)+28>>2]&63](n+12|0,i);i=n+24|0;a[h>>0]=(Df(d,e,n,i,p,g,1)|0)==(n|0)&1;e=c[d>>2]|0;do{i=i+-12|0;a1(i)}while((i|0)!=(n|0))}l=o;return e|0}function yn(a){a=a|0;do switch(a<<24>>24){case 1:{a=370611;break}case 2:{a=370604;break}case 3:{a=370596;break}case 4:{a=370588;break}case 5:{a=370584;break}case 6:{a=370571;break}case 7:{a=370564;break}case 8:{a=370559;break}case 9:{a=370554;break}case 12:{a=370549;break}case 13:{a=370534;break}case 14:{a=370514;break}case 15:{a=370501;break}case 16:{a=370466;break}case 17:{a=370456;break}case 19:{a=370445;break}case 20:{a=370429;break}case 21:{a=370419;break}case 22:{a=370411;break}case 23:{a=370401;break}case 24:{a=370393;break}case 25:{a=370385;break}case 26:{a=370377;break}case 27:{a=370363;break}case 28:{a=370359;break}case 29:{a=370356;break}case 31:{a=370347;break}case 32:{a=370339;break}case 33:{a=370331;break}case 34:{a=370323;break}case 35:{a=370319;break}case 36:{a=371891;break}case 37:{a=370315;break}case 38:{a=370302;break}case 39:{a=370291;break}case 40:{a=370280;break}case 41:{a=370271;break}default:a=8800948}while(0);return a|0}function zn(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;k=b+612|0;l=b+544|0;j=c[b+548>>2]|0;b=c[k>>2]|0;while(1){e=b+4|0;f=b+2|0;g=b+1|0;h=b+3|0;if(e>>>0>j>>>0)break;i=c[l>>2]|0;if((((a[i+b>>0]|0)==0?(a[i+g>>0]|0)==0:0)?(a[i+f>>0]|0)==1:0)?(d[i+h>>0]|0)>=185:0)break;while(1){e=b+2|0;c[k>>2]=e;if(e>>>0>=j>>>0){f=10;break}if(!(a[i+e>>0]|0)){f=9;break}else b=e}if((f|0)==9){b=b+1|0;if(a[i+b>>0]|0){b=e;continue}}else if((f|0)==10)b=b+1|0;c[k>>2]=b}do if((e|0)==(j|0)){i=c[l>>2]|0;if((((a[i+b>>0]|0)==0?(a[i+g>>0]|0)==0:0)?(a[i+f>>0]|0)==1:0)?(d[i+h>>0]|0)>=185:0)break;c[k>>2]=g;b=g}while(0);do if((b+3|0)==(j|0)){i=c[l>>2]|0;e=b+1|0;if(((a[i+b>>0]|0)==0?(a[i+e>>0]|0)==0:0)?(a[i+(b+2)>>0]|0)==1:0)break;c[k>>2]=e;b=e}while(0);do if((b+2|0)==(j|0)){i=c[l>>2]|0;e=b+1|0;if((a[i+b>>0]|0)==0?(a[i+e>>0]|0)==0:0)break;c[k>>2]=e;b=e}while(0);if((b+1|0)==(j|0)?(a[(c[l>>2]|0)+b>>0]|0)!=0:0){c[k>>2]=j;b=j}return (b+3|0)>>>0<=j>>>0|0}function An(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;o=l;l=l+48|0;j=o+20|0;k=o+12|0;m=o;bB(a,o+38|0);jB(a,o+32|0);TX(j);r3(a,o+16|0);r3(a,k);NB(a,o+36|0);i=a+528|0;e=i;d=c[e>>2]|0;e=c[e+4>>2]|0;p=z0(d|0,e|0,2,0)|0;q=z;f=a+536|0;h=f;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!(q>>>0>h>>>0|(q|0)==(h|0)&p>>>0>g>>>0)){yE(a,m);q=(b[m>>1]|0)==-257;e=f;d=i;d=D_(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e=z;if(q)iZ(a,d,e,j);else n=4}else{d=D_(g|0,h|0,d|0,e|0)|0;e=z;n=4}if((n|0)==4)xZ(a,d,e,j);if(qO(a)|0){TX(m);zb(a,0,0,250,lh(m,c[k>>2]|0)|0,0);z5(m);zb(a,0,0,251,j,0)}z5(j);l=o;return}function Bn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+32|0;h=i;e=a+64|0;ef(a,a+32|0,e,d)|0;g=a+96|0;while(1){if((g|0)==(b|0))break;if(tb[c[d>>2]&31](g,e)|0){c[h>>2]=c[g>>2];c[h+4>>2]=c[g+4>>2];c[h+8>>2]=c[g+8>>2];c[h+12>>2]=c[g+12>>2];c[h+16>>2]=c[g+16>>2];c[h+20>>2]=c[g+20>>2];c[h+24>>2]=c[g+24>>2];c[h+28>>2]=c[g+28>>2];f=g;while(1){c[f>>2]=c[e>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];c[f+16>>2]=c[e+16>>2];c[f+20>>2]=c[e+20>>2];c[f+24>>2]=c[e+24>>2];c[f+28>>2]=c[e+28>>2];if((e|0)==(a|0))break;f=e+-32|0;if(tb[c[d>>2]&31](h,f)|0){j=e;e=f;f=j}else break}c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[e+16>>2]=c[h+16>>2];c[e+20>>2]=c[h+20>>2];c[e+24>>2]=c[h+24>>2];c[e+28>>2]=c[h+28>>2]}e=g;g=g+32|0}l=i;return}function Cn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=l;l=l+16|0;d=g;e=b+776|0;if(((c[e>>2]|0?(f=b+840|0,h=f,!((c[h>>2]|0)==-1?(c[h+4>>2]|0)==-1:0)):0)?(h=b+800|0,!((c[h>>2]|0)==-1?(c[h+4>>2]|0)==-1:0)):0)?(h=b+760|0,i=c[(kE(h,f)|0)+36>>2]|0,gq(d,b,i,c[(kE(h,f)|0)+40>>2]|0,390999),h=a[d+8+3>>0]|0,h=((h<<24>>24<0?c[d+4>>2]|0:h&255)|0)==0,z5(d),!h):0){p=b+544|0;q=c[p>>2]|0;n=b+612|0;o=c[n>>2]|0;k=b+548|0;m=c[k>>2]|0;j=b+536|0;f=j;d=c[f>>2]|0;f=c[f+4>>2]|0;c[p>>2]=c[e>>2];c[n>>2]=0;i=b+780|0;s=c[i>>2]|0;c[k>>2]=s;h=b+528|0;r=h;c[r>>2]=0;c[r+4>>2]=0;r=j;c[r>>2]=s;c[r+4>>2]=0;dm(b);c[p>>2]=q;c[n>>2]=o;c[k>>2]=m;b=j;c[b>>2]=d;c[b+4>>2]=f;c[h>>2]=d;c[h+4>>2]=f;jaa(c[e>>2]|0);c[e>>2]=0;c[i>>2]=0}l=g;return}function Dn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;YZ(c[b+648>>2]|0,0,0);i=b+600|0;jaa(c[i>>2]|0);c[i>>2]=0;i=b+548|0;d=b+48|0;if(c[b+728>>2]&8){k=b+40|0;j=c[k+4>>2]|0;g=d;c[g>>2]=c[k>>2];c[g+4>>2]=j;if((a[b+492>>0]|0)==0?(h=c[b+24>>2]|0,e=c[h+4>>2]|0,f=c[h+8>>2]|0,(e|0)!=(f|0)):0){g=c[h+44>>2]|0;k=(f-e|0)/12|0;d=h+96|0;f=k+-1|0;if((c[h+48>>2]|0)-g>>3>>>0<k>>>0){e=d;d=c[e>>2]|0;e=c[e+4>>2]|0}else{e=g+(f<<3)|0;k=c[e>>2]|0;e=c[e+4>>2]|0;c[d>>2]=k;c[d+4>>2]=e;d=k}k=h+88|0;c[k>>2]=d;c[k+4>>2]=e;c[h+56>>2]=f}}else{j=d;j=z0(c[j>>2]|0,c[j+4>>2]|0,c[i>>2]|0,0)|0;k=d;c[k>>2]=j;c[k+4>>2]=z}c[i>>2]=0;c[b+604>>2]=0;c[b+612>>2]=0;c[b+616>>2]=0;c[b+620>>2]=0;c[b+272>>2]=0;d=c[b+240>>2]|0;e=b+244|0;f=c[e>>2]|0;while(1){if((f|0)==(d|0))break;k=f+-8|0;c[e>>2]=k;f=k}d=c[b+252>>2]|0;e=b+256|0;f=c[e>>2]|0;while(1){if((f|0)==(d|0))break;k=f+-8|0;c[e>>2]=k;f=k}c[b+264>>2]=-1;return}function En(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;o=l;l=l+32|0;f=o+24|0;m=o+12|0;n=o;NB(d,f);j=d+528|0;g=d+536|0;k=c[g>>2]|0;g=c[g+4>>2]|0;i=j;h=c[i+4>>2]|0;i=c[i>>2]|0;while(1){if(!(h>>>0<g>>>0|(h|0)==(g|0)&i>>>0<k>>>0))break;p=z0(i|0,h|0,1,0)|0;q=z;r=j;c[r>>2]=p;c[r+4>>2]=q;h=q;i=p}if((((b[f>>1]|0)==8?qO(d)|0:0)?(a[d+768>>0]|0)==2:0)?a[d+784>>0]|0:0){Xy(m,39500);f=c[(c[(c[d+760>>2]|0)+80>>2]|0)+(e[d+772>>1]<<2)>>2]|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;g=j9(384476)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[n+11>>0]=g;d=n}else{r=g+16&-16;d=ZW(r)|0;c[n>>2]=d;c[n+8>>2]=r|-2147483648;c[n+4>>2]=g}i1(d,384476,g)|0;J7(d+g|0,0);vF(VC(f+28|0,n)|0,m)|0;a1(n);z5(m)}l=o;return}function Fn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+160|0;g=j+136|0;h=j;f=h+56|0;i=h+4|0;c[h>>2]=1244;c[f>>2]=1264;DO(h+56|0,i);c[h+128>>2]=0;c[h+132>>2]=-1;c[h>>2]=42060;c[f>>2]=42080;aV(i);c[i>>2]=42096;f=h+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[f+(e<<2)>>2]=0;e=e+1|0}c[h+48>>2]=0;c[h+52>>2]=16;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[g+(e<<2)>>2]=0;e=e+1|0}lq(i,g);O0(g);f=h+(c[(c[h>>2]|0)+-12>>2]|0)|0;switch(d<<24>>24){case 8:{e=64;break}case 10:{e=2;break}default:e=d<<24>>24==16?8:0}d=f+4|0;c[d>>2]=c[d>>2]&-75|e;rr(h,b)|0;Hk(g,i);rQ(a,g)|0;O0(g);tP(a)|0;YX(h);l=j;return a|0}function Gn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;g=k;GC(b);a[g>>0]=0;i=b+958|0;AT(b,i);if(a[b+957>>0]|0)A6(c[b+648>>2]|0);e=b+928|0;n3(b,e);f=c[e>>2]|0;d=c[b+820>>2]|0;do if(f>>>0<(c[b+824>>2]|0)-d>>2>>>0?(h=c[d+(f<<2)>>2]|0,(h|0)!=0):0){d=(a[b+771>>0]|0)==0;if(!(a[i>>0]|0)){if(d?a[h+4>>0]|0:0)AT(b,g);i=c[b+648>>2]|0;G4(i,Z9(c[i+4>>2]|0)|0);J3(b);c[b+932>>2]=-1;break}else{if(d){d=b+648|0;d4(c[d>>2]|0,a[h+3>>0]|0)}else d=b+648|0;n3(b,b+932|0);i=c[d>>2]|0;G4(i,Z9(c[i+4>>2]|0)|0);J3(b);break}}else j=5;while(0);if((j|0)==5){j=c[b+648>>2]|0;G4(j,Z9(c[j+4>>2]|0)|0);J3(b);c[e>>2]=-1;c[b+932>>2]=-1}l=k;return}function Hn(b){b=b|0;var e=0,f=0,g=0,h=0;_c(b);fB(b);a:do if(!(a[b+734>>0]|0)){g=b+2479|0;h=b+2480|0;if(!(a[g>>0]|0)){if(!(a[h>>0]|0)){GC(b);d4(c[b+648>>2]|0,16);J3(b)}Yl(b);break}GC(b);f=b+648|0;b:do if(!(a[h>>0]|0)){e=1;while(1){if((e|0)>(d[g>>0]|0))break b;d4(c[f>>2]|0,16);e=e+1|0}}while(0);d4(c[f>>2]|0,16);J3(b);e=0;while(1){if((e|0)>(d[g>>0]|0))break a;Yl(b);if(!(a[h>>0]|0)){GC(b);G4(c[f>>2]|0,16);J3(b)}e=e+1|0}}else{wK(b);g=b+536|0;h=b+528|0;h=D_(c[g>>2]|0,c[g+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0)|0;e1(b,h,z);h=b+896|0;c[h>>2]=0;c[h+4>>2]=0}while(0);return}function In(b){b=b|0;var d=0,e=0,f=0;d=b+760|0;e=d;if((c[e>>2]|0)==0&(c[e+4>>2]|0)==0){f=+g[(c[b+24>>2]|0)+136>>2]>=.3;e=d;c[e>>2]=f?512:2;c[e+4>>2]=f?0:0}d=b+288|0;c[d>>2]=0;c[d+4>>2]=0;d=b+144|0;if(!(a[b+492>>0]|0)){c[d>>2]=0;c[d+4>>2]=0;d=0;e=0}else{e=d;d=c[e>>2]|0;e=c[e+4>>2]|0}f=b+296|0;c[f>>2]=d;c[f+4>>2]=e;f=b+304|0;c[f>>2]=d;c[f+4>>2]=e;e=b+796|0;d=b+824|0;c[d>>2]=0;c[d+4>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;a[b+876>>0]=-1;c[b+880>>2]=0;c[b+884>>2]=0;e=b+888|0;d=b+916|0;c[e>>2]=-1;c[e+4>>2]=-1;c[e+8>>2]=-1;c[e+12>>2]=-1;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;a[b+1045>>0]=1;a[b+1047>>0]=0;a[b+1048>>0]=0;d=b+1032|0;c[d>>2]=0;c[d+4>>2]=0;d=b+772|0;AH(d);d=c[d>>2]|0;a[d+12>>0]=1;a[d+14>>0]=1;a[d+18>>0]=1;a[d+30>>0]=1;e=255;while(1){if(e>>>0<=184)break;a[d+(e<<1)>>0]=1;e=e+-1|0}jb[c[(c[b>>2]|0)+44>>2]&511](b);return}function Jn(a){a=a|0;var b=0,c=0;c=0;while(1){if((c|0)==7){b=0;break}else b=0;while(1){if(b>>>0>=(RA(a,c,-1)|0)>>>0)break;Tc(a,c,b);b=b+1|0}c=c+1|0}while(1){if(b>>>0>=(RA(a,0,-1)|0)>>>0){b=0;break}gm(a,b);b=b+1|0}while(1){if(b>>>0>=(RA(a,1,-1)|0)>>>0){b=0;break}Pb(a,b);b=b+1|0}while(1){if(b>>>0>=(RA(a,2,-1)|0)>>>0){b=0;break}Xc(a,b);b=b+1|0}while(1){if(b>>>0>=(RA(a,3,-1)|0)>>>0){b=0;break}ww(a,b);b=b+1|0}while(1)if(b>>>0<(RA(a,4,-1)|0)>>>0)b=b+1|0;else{b=0;break}while(1)if(b>>>0<(RA(a,5,-1)|0)>>>0)b=b+1|0;else{b=0;break}while(1)if(b>>>0<(RA(a,6,-1)|0)>>>0)b=b+1|0;else break;return}function Kn(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+32|0;f=m+16|0;h=m+14|0;i=m+12|0;j=m;if(e){HB(d,f);HB(d,h);HB(d,i)}else{NB(d,f);NB(d,h);NB(d,i)}if((qO(d)|0?(k=d+20|0,$x(j,d,1,c[k>>2]|0,330,1),e=a[j+8+3>>0]|0,e=((e<<24>>24<0?c[j+4>>2]|0:e&255)|0)==0,z5(j),e):0)?(RB(d,1,c[k>>2]|0,330,382808,-1,1,0),j=c[k>>2]|0,RB(d,1,j,331,mD(b[f>>1]&255)|0,-1,1,0),j=c[k>>2]|0,RB(d,1,j,332,Zx(b[h>>1]&255)|0,-1,1,0),h=c[k>>2]|0,j=b[i>>1]|0,g=j&255,RB(d,1,h,333,SA(g)|0,-1,1,0),j<<16>>16!=2):0){k=c[k>>2]|0;RB(d,1,k,191,ZT(g)|0,-1,1,1)}l=m;return}function Ln(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+32|0;g=k+12|0;h=k;i=b+912|0;j=b+913|0;e=b+536|0;d=c[e+4>>2]|0;do if(d>>>0<0|(d|0)==0&(c[e>>2]|0)>>>0<16777217){d=c[b+508>>2]|0;e=c[b+668>>2]|0;if(!(k2(d,e)|0)){c3(d,e);break}c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[g+(d<<2)>>2]=0;d=d+1|0}f=HN(b,0)|0;Fw(b,f,z,g);if((a[j>>0]|0)==0?a[i>>0]|0:0){Zm(h,g);bw(b,0,0,318,h,1,0);RB(b,0,0,314,382808,-1,1,0);a[j>>0]=1;a1(h)}a1(g);f=11}else f=11;while(0);if((f|0)==11){j=HN(b,0)|0;e1(b,j,z)}l=k;return}function Mn(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+64|0;f=k+48|0;g=k+36|0;h=k+24|0;i=k+12|0;j=k;TX(i);cC(i,Fz(a[(c[e>>2]|0)+39>>0]|0)|0)|0;Bs(h,i,39996);TX(j);io(j,+(d[(c[e>>2]|0)+40>>0]|0)/10.0,1)|0;e=a[j+8+3>>0]|0;m=e<<24>>24<0;Ex(h,m?c[j>>2]|0:j,m?c[j+4>>2]|0:e&255)|0;c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];e=0;while(1){if((e|0)==3)break;c[h+(e<<2)>>2]=0;e=e+1|0}p2(f,g);O0(g);z5(j);O0(h);z5(i);$x(g,b,1,0,24,1);zb(b,1,0,24,f,1);m=a[g+8+3>>0]|0;if((m<<24>>24<0?c[g+4>>2]|0:m&255)|0)zb(b,1,0,24,g,0);z5(g);z5(f);l=k;return}function Nn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;f=l;l=l+16|0;b=f+4|0;d=f;bB(a,f+12|0);jB(a,f+8|0);e=a+788|0;ID(a,e);g=a+528|0;i=g;i=z0(c[i>>2]|0,c[i+4>>2]|0,4,0)|0;h=g;c[h>>2]=i;c[h+4>>2]=z;ID(a,b);ID(a,d);GC(a);Bx(a);h=a+648|0;d4(c[h>>2]|0,6);d4(c[h>>2]|0,2);d4(c[h>>2]|0,2);d4(c[h>>2]|0,2);d4(c[h>>2]|0,3);A6(c[h>>2]|0);wK(a);h=g;h=z0(c[h>>2]|0,c[h+4>>2]|0,2,0)|0;c[g>>2]=h;c[g+4>>2]=z;J3(a);if(qO(a)|0){h=c[b>>2]|0;i=a+916|0;c[(bF(i,e)|0)+256>>2]=h;h=c[d>>2]|0;c[(bF(i,e)|0)+260>>2]=h}l=f;return}function On(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if(nb[c[(c[b>>2]|0)+112>>2]&255](b)|0){e=b+508|0;while(1){if(!(c[e>>2]|0))break;J3(b)}k=b+692|0;f=b+512|0;d=0;while(1){i=c[k>>2]|0;if(d>>>0>=i>>>0)break;GC(b);a[f>>0]=1;d=c[e>>2]|0}g=c[b+704>>2]|0;h=b+708|0;d=c[h>>2]|0;if((g|0)!=(d|0)){f=b+668|0;j=c[b+716>>2]|0;e=0;while(1){if(e>>>0>i>>>0)break;o=g+(e<<3)|0;m=c[o+4>>2]|0;l=c[f>>2]|0;n=l+(e*24|0)|0;c[n>>2]=c[o>>2];c[n+4>>2]=m;n=j+(e<<3)|0;m=c[n+4>>2]|0;l=l+(e*24|0)+8|0;c[l>>2]=c[n>>2];c[l+4>>2]=m;e=e+1|0}while(1){if((d|0)==(g|0))break;o=d+-8|0;c[h>>2]=o;d=o}d=b+720|0;e=c[d>>2]|0;while(1){if((e|0)==(j|0))break;o=e+-8|0;c[d>>2]=o;e=o}c[k>>2]=0}d=b+64|0;o=d;if((c[o>>2]|0)==-1?(c[o+4>>2]|0)==-1:0){m=b+696|0;n=c[m+4>>2]|0;o=d;c[o>>2]=c[m>>2];c[o+4>>2]=n}}return}function Pn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+1040|0;m=q+8|0;o=q;g=c[b>>2]|0;c[o>>2]=g;p=(a|0)!=0;h=p?e:256;i=p?a:m;e=g;a:do if((h|0)!=0&(g|0)!=0){a=0;k=d;while(1){d=k>>>2;j=d>>>0>=h>>>0;if(!(k>>>0>131|j)){d=k;break a}e=j?h:d;d=k-e|0;e=zf(i,o,e,f)|0;if((e|0)==-1)break;g=(i|0)==(m|0);h=h-(g?0:e)|0;i=g?i:i+(e<<2)|0;a=e+a|0;e=c[o>>2]|0;g=e;if((h|0)!=0&(e|0)!=0)k=d;else break a}g=c[o>>2]|0;a=-1;h=0;e=g}else a=0;while(0);b:do if((e|0)!=0?(h|0)!=0&(d|0)!=0:0){while(1){g=Yn(i,e,d,f)|0;if((g+2|0)>>>0<3)break;e=e+g|0;d=d-g|0;h=h+-1|0;a=a+1|0;if(!((h|0)!=0&(d|0)!=0)){n=13;break}else i=i+4|0}if((n|0)==13){c[o>>2]=e;break}c[o>>2]=e;switch(g|0){case -1:{a=-1;break b}case 0:{c[o>>2]=0;e=0;break b}default:{c[f>>2]=0;break b}}}else e=g;while(0);if(p)c[b>>2]=e;l=q;return a|0}function Qn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;i=b;f=(d-i|0)/24|0;e=a+8|0;k=c[a>>2]|0;j=k;a:do if(f>>>0>(((c[e>>2]|0)-k|0)/24|0)>>>0){YM(a);if(f>>>0>178956970)uaa();else{k=((c[e>>2]|0)-(c[a>>2]|0)|0)/24|0;l=k<<1;aT(a,k>>>0<89478485?(l>>>0<f>>>0?f:l):178956970);NN(a,b,d);break}}else{l=a+4|0;g=((c[l>>2]|0)-k|0)/24|0;h=f>>>0>g>>>0;g=h?b+(g*24|0)|0:d;e=g-i|0;if(e|0)TR(k|0,b|0,e|0)|0;f=j+(((e|0)/24|0)*24|0)|0;if(h){NN(a,g,d);break}e=c[l>>2]|0;while(1){if((e|0)==(f|0))break a;d=e+-24|0;c[l>>2]=d;e=d}}while(0);return}function Rn(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;do if(e|0){if(e>>>0>32){f=e;do{kb[c[(c[b>>2]|0)+16>>2]&63](b,32);f=f+-32|0}while(f>>>0>32);kb[c[(c[b>>2]|0)+16>>2]&63](b,e+-32-(e+-33&-32)|0);break}i=b+8|0;f=c[i>>2]|0;j=b+24|0;g=c[j>>2]|0;h=g+f|0;if(h>>>0<e>>>0){c[i>>2]=0;c[j>>2]=0;a[b+28>>0]=1;break}c[b+16>>2]=h;if(g>>>0>=e>>>0){c[j>>2]=g-e;break}g=e-g|0;e=b+4|0;switch((g+-1|0)>>>3&536870911|0){case 3:{h=(c[e>>2]|0)+1|0;c[e>>2]=h;f=f+-8|0;c[i>>2]=f;g=g+-8|0;k=15;break}case 2:{h=c[e>>2]|0;k=15;break}case 1:{h=c[e>>2]|0;k=16;break}case 0:{h=c[e>>2]|0;k=17;break}default:{}}if((k|0)==15){h=h+1|0;c[e>>2]=h;f=f+-8|0;c[i>>2]=f;g=g+-8|0;k=16}if((k|0)==16){h=h+1|0;c[e>>2]=h;f=f+-8|0;c[i>>2]=f;g=g+-8|0;k=17}if((k|0)==17){c[b+20>>2]=d[h>>0];c[e>>2]=h+1}k=f>>>0<8?f:8;c[j>>2]=k-g;c[i>>2]=f-k}while(0);return}function Sn(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+16|0;k=m;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[b+(e<<2)>>2]=0;e=e+1|0}f=d+8+3|0;e=a[f>>0]|0;if(e<<24>>24<0)e=c[d+4>>2]|0;else e=e&255;Fp(b,e);if((a[f>>0]|0)<0)d=c[d>>2]|0;f=k+4|0;g=k+5|0;h=k+1|0;i=k+2|0;j=k+3|0;while(1){e=c[d>>2]|0;if(!e)break;d=d+4|0;if((e|0)<128){gy(b,e&255);continue}if(e>>>0<2048){n=k;c[n>>2]=0;c[n+4>>2]=0}else{if(e>>>0<65536){n=k;c[n>>2]=0;c[n+4>>2]=0}else{if(e>>>0<2097152){n=k;c[n>>2]=0;c[n+4>>2]=0}else{n=k;c[n>>2]=0;c[n+4>>2]=0;if(e>>>0>=67108864){a[g>>0]=e&63|128;e=e>>>6|67108864}a[f>>0]=e&63|128;e=e>>>6|2097152}a[j>>0]=e&63|128;e=e>>>6|65536}a[i>>0]=e&63|128;e=e>>>6|2048}a[h>>0]=e&63|128;a[k>>0]=e>>>6|192;JX(b,k)|0}l=m;return}function Tn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;m=l;l=l+16|0;e=m;f=a+520|0;j=f;j=(c[j>>2]|0)==1667522932&(c[j+4>>2]|0)==0;k=f;c[k>>2]=j?1:2;c[k+4>>2]=j?0:0;if(!(c[a+728>>2]&1)){W5(a);RB(a,0,0,57,378088,-1,1,1)}g=a+528|0;h=a+536|0;i=a+916|0;j=a+544|0;k=a+612|0;d=g;b=c[d>>2]|0;d=c[d+4>>2]|0;while(1){b=z0(b|0,d|0,2,0)|0;o=z;d=h;n=c[d+4>>2]|0;if(o>>>0>n>>>0|((o|0)==(n|0)?b>>>0>(c[d>>2]|0)>>>0:0))break;else b=0;while(1){c[e>>2]=c[f>>2];o=bF(i,e)|0;if(b>>>0>=(c[o+16>>2]|0)-(c[o+12>>2]|0)>>2>>>0)break;c[e>>2]=c[f>>2];o=c[(c[(bF(i,e)|0)+12>>2]|0)+(b<<2)>>2]|0;Sc(a,o,(c[j>>2]|0)+(c[k>>2]|0)+(c[g>>2]|0)|0,2,1);b=b+1|0}b=g;b=z0(c[b>>2]|0,c[b+4>>2]|0,2,0)|0;d=z;o=g;c[o>>2]=b;c[o+4>>2]=d}l=m;return}function Un(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=Cv(406860,b)|0;do if((f|0)!=406864?(k=c[f+28>>2]|0,i=k,(((c[f+32>>2]|0)-k|0)/12|0)>>>0>d>>>0):0){b=i+36|0;h=a[i+44+3>>0]|0;g=h<<24>>24<0;h=g?c[i+40>>2]|0:h&255;k=a[e+8+3>>0]|0;j=k<<24>>24<0;k=j?c[e+4>>2]|0:k&255;if((h|0)==(k|0)?(L$(g?c[b>>2]|0:b,j?c[e>>2]|0:e,h)|0)==0:0){b=i+(d*12|0)|0;break}b=c[f+4>>2]|0;if(!b)while(1){b=c[f+8>>2]|0;if((c[b>>2]|0)==(f|0))break;else f=b}else while(1){f=c[b>>2]|0;if(!f)break;else b=f}i=c[b+28>>2]|0;f=i;if((((c[b+32>>2]|0)-i|0)/12|0)>>>0>d>>>0?(l=f+36|0,i=a[f+44+3>>0]|0,m=i<<24>>24<0,((m?c[f+40>>2]|0:i&255)|0)==(k|0)):0){m=(L$(m?c[l>>2]|0:l,j?c[e>>2]|0:e,k)|0)==0;return (m?f+(d*12|0)|0:408456)|0}else b=408456}else b=408456;while(0);return b|0}function Vn(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=l;l=l+16|0;f=i+4|0;g=i;d=i+9|0;e=i+8|0;j=b+528|0;k=j;k=z0(c[k>>2]|0,c[k+4>>2]|0,9,0)|0;h=j;c[h>>2]=k;c[h+4>>2]=z;bB(b,d);h=j;h=z0(c[h>>2]|0,c[h+4>>2]|0,3,0)|0;k=j;c[k>>2]=h;c[k+4>>2]=z;bB(b,e);k=j;k=z0(c[k>>2]|0,c[k+4>>2]|0,6,0)|0;h=j;c[h>>2]=k;c[h+4>>2]=z;ID(b,f);ID(b,g);h=b+536|0;if(!((c[j>>2]|0)==(c[h>>2]|0)?(c[j+4>>2]|0)==(c[h+4>>2]|0):0))t4(b);if(qO(b)|0){d=a[d>>0]|0;h=b+20|0;if(d<<24>>24)mL(b,2,c[h>>2]|0,147,d,10,1);d=a[e>>0]|0;if(d<<24>>24)mL(b,2,c[h>>2]|0,122,d,10,1);d=c[f>>2]|0;if(d|0)lL(b,2,c[h>>2]|0,116,d,10,1);d=c[g>>2]|0;if(d|0)lL(b,2,c[h>>2]|0,135,d,10,1)}l=i;return}function Wn(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=l;l=l+16|0;e=j+4|0;f=j;k=j+11|0;g=j+10|0;HB(b,j+8|0);bB(b,g);bB(b,k);bD(b,e);r3(b,f);h=b+536|0;i=b+528|0;a:do switch(a[k>>0]|0){case 1:switch(a[g>>0]|0){case 0:{ih(b,c[e>>2]|0,c[f>>2]|0);break a}case 1:{KE(b,c[e>>2]|0);break a}default:{k=i;e1(b,D_(c[h>>2]|0,c[h+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0,z);break a}}case 0:if((d[g>>0]|0)<2){nr(b,c[e>>2]|0,c[f>>2]|0);break a}else{k=i;k=D_(c[h>>2]|0,c[h+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0;e1(b,k,z);break a}default:{k=i;e1(b,D_(c[h>>2]|0,c[h+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0,z)}}while(0);l=j;return}function Xn(d){d=d|0;var e=0,f=0;mI(d+4|0);c[d+44>>2]=0;c[d+48>>2]=0;c[d+52>>2]=0;TX(d+156|0);TX(d+168|0);TX(d+192|0);TX(d+204|0);TX(d+216|0);q2(d+264|0);a[d>>0]=0;a[d+142>>0]=1;a[d+143>>0]=0;a[d+144>>0]=0;a[d+145>>0]=0;a[d+146>>0]=1;e=d+147|0;h[d+184>>3]=0.0;c[d+228>>2]=0;a[e>>0]=0;a[e+1>>0]=0;a[e+2>>0]=0;a[e+3>>0]=0;a[e+4>>0]=0;a[e+5>>0]=0;c[d+232>>2]=67108864;a[d+236>>0]=0;a[d+237>>0]=1;a[d+238>>0]=1;a[d+239>>0]=0;a[d+240>>0]=0;a[d+241>>0]=0;a[d+242>>0]=1;h[d+248>>3]=10.0;c[d+56>>2]=0;c[d+72>>2]=0;c[d+60>>2]=0;e=d+256|0;c[e>>2]=0;c[e+4>>2]=0;c[d+64>>2]=65536;c[d+68>>2]=0;e=d+76|0;f=d+88|0;c[f>>2]=0;c[f+4>>2]=0;c[e>>2]=0;b[e+4>>1]=0;e=d+96|0;c[e>>2]=-1;c[e+4>>2]=-1;e=d+104|0;c[e>>2]=0;c[e+4>>2]=0;e=d+112|0;c[e>>2]=-1;c[e+4>>2]=-1;h[d+120>>3]=0.0;e=d+128|0;c[e>>2]=-1;c[e+4>>2]=-1;g[d+136>>2]=+nU();a[d+140>>0]=0;a[d+141>>0]=0;return}function Yn(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+16|0;g=k;i=(f|0)==0?409064:f;f=c[i>>2]|0;a:do if(!d)if(!f)f=0;else j=17;else{h=(b|0)==0?g:b;if(!e)f=-2;else{if(!f){f=a[d>>0]|0;if(f<<24>>24>-1){c[h>>2]=f&255;f=f<<24>>24!=0&1;break}if(!(c[c[12815]>>2]|0)){c[h>>2]=f<<24>>24&57343;f=1;break}f=(f&255)+-194|0;if(f>>>0>50){j=17;break}f=c[50744+(f<<2)>>2]|0;g=e+-1|0;if(g){d=d+1|0;j=11}}else{g=e;j=11}b:do if((j|0)==11){b=a[d>>0]|0;m=(b&255)>>>3;if((m+-16|m+(f>>26))>>>0>7){j=17;break a}while(1){d=d+1|0;f=f<<6|(b&255)+-128;g=g+-1|0;if((f|0)>=0)break;if(!g)break b;b=a[d>>0]|0;if((b&-64)<<24>>24!=-128){j=17;break a}}c[i>>2]=0;c[h>>2]=f;f=e-g|0;break a}while(0);c[i>>2]=f;f=-2}}while(0);if((j|0)==17){c[i>>2]=0;c[12784]=84;f=-1}l=k;return f|0}function Zn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!b)e1(a,d,0);else{e=b+64|0;p=e;if(!((c[p>>2]|0)==-1?(c[p+4>>2]|0)==-1:0)){p=e;c[p>>2]=-1;c[p+4>>2]=-1}i=a+48|0;f=c[a+612>>2]|0;i=z0(f|0,0,c[i>>2]|0,c[i+4>>2]|0)|0;g=a+528|0;k=g;h=c[k>>2]|0;k=z0(i|0,z|0,h|0,c[k+4>>2]|0)|0;i=b+48|0;c[i>>2]=k;c[i+4>>2]=z;i=b+40|0;k=i;j=c[k>>2]|0;k=c[k+4>>2]|0;m=a+40|0;l=c[m>>2]|0;m=c[m+4>>2]|0;if(!((j|0)==(l|0)&(k|0)==(m|0))){n=c[b+508>>2]|0;o=b+668|0;e=0;while(1){if(e>>>0>n>>>0)break;p=(c[o>>2]|0)+(e*24|0)+8|0;q=p;if((c[q>>2]|0)==(j|0)?(c[q+4>>2]|0)==(k|0):0){q=p;c[q>>2]=l;c[q+4>>2]=m}e=e+1|0}q=i;c[q>>2]=l;c[q+4>>2]=m}JI(b,(c[a+544>>2]|0)+f+h|0,d);q=g;d=z0(c[q>>2]|0,c[q+4>>2]|0,d|0,0)|0;q=g;c[q>>2]=d;c[q+4>>2]=z}return}function _n(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=a+4|0;g=b+-4|0;d=a+8|0;f=a+12|0;switch(b-a>>2|0){case 1:case 0:{d=1;break}case 2:{d=c[g>>2]|0;e=c[a>>2]|0;if(d>>>0<e>>>0){c[a>>2]=d;c[g>>2]=e;d=1}else d=1;break}case 3:{Ey(a,e,g)|0;d=1;break}case 4:{IB(a,e,d,g)|0;d=1;break}case 5:{Tx(a,e,d,f,g)|0;d=1;break}default:{Ey(a,e,d)|0;j=0;a:while(1){i=f;while(1){if((i|0)==(b|0)){e=1;d=0;break a}h=c[i>>2]|0;g=c[d>>2]|0;f=i+4|0;if(h>>>0<g>>>0){e=i;break}else{d=i;i=f}}while(1){c[e>>2]=g;if((d|0)==(a|0)){d=a;break}e=d+-4|0;g=c[e>>2]|0;if(h>>>0>=g>>>0)break;else{l=d;d=e;e=l}}c[d>>2]=h;d=j+1|0;if((d|0)==8){k=14;break}else{j=d;d=i}}if((k|0)==14){e=0;d=(f|0)==(b|0)}d=d|e}}return d|0}function $n(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;k=Jr(a,b,d,e)|0;g=f;j=c[g>>2]|0;g=c[g+4>>2]|0;i=e;h=c[i>>2]|0;i=c[i+4>>2]|0;if(g>>>0<i>>>0|(g|0)==(i|0)&j>>>0<h>>>0){l=e;c[l>>2]=j;c[l+4>>2]=g;g=f;c[g>>2]=h;c[g+4>>2]=i;g=k+1|0;i=e;h=c[i>>2]|0;i=c[i+4>>2]|0;j=d;f=c[j>>2]|0;j=c[j+4>>2]|0;if(i>>>0<j>>>0|(i|0)==(j|0)&h>>>0<f>>>0){g=d;c[g>>2]=h;c[g+4>>2]=i;g=e;c[g>>2]=f;c[g+4>>2]=j;g=k+2|0;i=d;h=c[i>>2]|0;i=c[i+4>>2]|0;j=b;f=c[j>>2]|0;j=c[j+4>>2]|0;if(i>>>0<j>>>0|(i|0)==(j|0)&h>>>0<f>>>0){g=b;c[g>>2]=h;c[g+4>>2]=i;h=d;c[h>>2]=f;c[h+4>>2]=j;h=b;g=c[h>>2]|0;h=c[h+4>>2]|0;f=a;i=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<i>>>0){l=a;c[l>>2]=g;c[l+4>>2]=h;g=b;c[g>>2]=i;c[g+4>>2]=f;g=k+4|0}else g=k+3|0}}}else g=k;return g|0}function ao(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;k=Kr(a,b,d,e)|0;g=f;j=c[g>>2]|0;g=c[g+4>>2]|0;i=e;h=c[i>>2]|0;i=c[i+4>>2]|0;if((g|0)<(i|0)|(g|0)==(i|0)&j>>>0<h>>>0){l=e;c[l>>2]=j;c[l+4>>2]=g;g=f;c[g>>2]=h;c[g+4>>2]=i;g=k+1|0;i=e;h=c[i>>2]|0;i=c[i+4>>2]|0;j=d;f=c[j>>2]|0;j=c[j+4>>2]|0;if((i|0)<(j|0)|(i|0)==(j|0)&h>>>0<f>>>0){g=d;c[g>>2]=h;c[g+4>>2]=i;g=e;c[g>>2]=f;c[g+4>>2]=j;g=k+2|0;i=d;h=c[i>>2]|0;i=c[i+4>>2]|0;j=b;f=c[j>>2]|0;j=c[j+4>>2]|0;if((i|0)<(j|0)|(i|0)==(j|0)&h>>>0<f>>>0){g=b;c[g>>2]=h;c[g+4>>2]=i;h=d;c[h>>2]=f;c[h+4>>2]=j;h=b;g=c[h>>2]|0;h=c[h+4>>2]|0;f=a;i=c[f>>2]|0;f=c[f+4>>2]|0;if((h|0)<(f|0)|(h|0)==(f|0)&g>>>0<i>>>0){l=a;c[l>>2]=g;c[l+4>>2]=h;g=b;c[g>>2]=i;c[g+4>>2]=f;g=k+4|0}else g=k+3|0}}}else g=k;return g|0}function bo(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=b+4|0;g=c[f>>2]|0;do if(g){f=e8(b)|0;k=a[e+11>>0]|0;j=k<<24>>24<0;k=j?c[e+4>>2]|0:k&255;j=j?c[e>>2]|0:e;b=g;while(1){e=b+16|0;g=a[e+11>>0]|0;h=g<<24>>24<0;e=h?c[e>>2]|0:e;g=h?c[b+20>>2]|0:g&255;h=g>>>0<k>>>0;l=R$(j,e,h?g:k)|0;i=k>>>0<g>>>0;if((((l|0)==0?(i?-2147483648:0):l)|0)<0){e=c[b>>2]|0;if(!e){e=6;break}else{f=b;b=e}}else{l=R$(e,j,i?k:g)|0;if((((l|0)==0?(h?-2147483648:0):l)|0)>=0){e=10;break}f=b+4|0;e=c[f>>2]|0;if(!e){e=9;break}else b=e}}if((e|0)==6){c[d>>2]=b;f=b;break}else if((e|0)==9){c[d>>2]=b;break}else if((e|0)==10){c[d>>2]=b;break}}else c[d>>2]=f;while(0);return f|0}function co(d){d=d|0;var e=0,f=0,g=0,h=0,i=0;h=l;l=l+16|0;i=h+3|0;f=h+2|0;e=h+1|0;g=h;GC(d);AT(d,i);b[d+2466>>1]=(a[i>>0]|0)==0?1024:960;AT(d,f);if(a[f>>0]|0)d4(c[d+648>>2]|0,14);AT(d,e);if(!(a[d+2464>>0]|0))Eb(d);f=d+2462|0;switch(a[f>>0]|0){case 20:case 6:{d4(c[d+648>>2]|0,3);break}default:{}}if(a[e>>0]|0){e=a[f>>0]|0;if(e<<24>>24==22){e=d+648|0;d4(c[e>>2]|0,5);d4(c[e>>2]|0,11);e=a[f>>0]|0}switch(e<<24>>24){case 23:case 20:case 19:case 17:{i=d+648|0;A6(c[i>>2]|0);A6(c[i>>2]|0);A6(c[i>>2]|0);break}default:{}}AT(d,g);if(a[g>>0]|0){i=c[d+648>>2]|0;G4(i,Z9(c[i+4>>2]|0)|0)}}J3(d);l=h;return}function eo(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+48|0;d=i+38|0;e=i+36|0;f=i+24|0;g=i+12|0;h=i;NB(a,d);NB(a,e);if(qO(a)|0){rU(h,b[d>>1]|0,10);HX(h,35184)|0;c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];d=0;while(1){if((d|0)==3)break;c[h+(d<<2)>>2]=0;d=d+1|0}p2(f,g);Mc(a,1,0,381078,f,0);z5(f);O0(g);z5(h);rU(h,b[e>>1]|0,10);HX(h,35184)|0;c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];d=0;while(1){if((d|0)==3)break;c[h+(d<<2)>>2]=0;d=d+1|0}p2(f,g);Mc(a,1,0,381085,f,0);z5(f);O0(g);z5(h)}l=i;return}function fo(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=b+4|0;g=c[f>>2]|0;do if(g){f=e8(b)|0;k=a[e+11>>0]|0;j=k<<24>>24<0;k=j?c[e+4>>2]|0:k&255;j=j?c[e>>2]|0:e;b=g;while(1){e=b+16|0;g=a[e+11>>0]|0;h=g<<24>>24<0;e=h?c[e>>2]|0:e;g=h?c[b+20>>2]|0:g&255;h=g>>>0<k>>>0;l=R$(j,e,h?g:k)|0;i=k>>>0<g>>>0;if((((l|0)==0?(i?-2147483648:0):l)|0)<0){e=c[b>>2]|0;if(!e){e=5;break}else{f=b;b=e}}else{l=R$(e,j,i?k:g)|0;if((((l|0)==0?(h?-2147483648:0):l)|0)>=0){e=10;break}f=b+4|0;e=c[f>>2]|0;if(!e){e=9;break}else b=e}}if((e|0)==5){c[d>>2]=b;f=b;break}else if((e|0)==9){c[d>>2]=b;break}else if((e|0)==10){c[d>>2]=b;break}}else c[d>>2]=f;while(0);return f|0}function go(b){b=b|0;var e=0,f=0,g=0,h=0;h=l;l=l+16|0;e=h;GC(b);if(a[b+912>>0]|0?(AT(b,e),(a[e>>0]|0)==0):0)Vg(b);if((a[b+2468>>0]|0)==-1){a[b+22148>>0]=0;b=c[b+648>>2]|0;G4(b,Z9(c[b+4>>2]|0)|0)}else{a:do if(!(a[b+917>>0]|0)){f=b+913|0;e=0;while(1){if((e&255)>(d[f>>0]|0))break;zk(b);gl(b);e=e+1<<24>>24}if(!(a[b+2460>>0]|0)){e=b+648|0;break}g=b+2456|0;e=b+648|0;f=0;while(1){if(f>>>0>=(c[g>>2]|0)>>>0)break a;A6(c[e>>2]|0);f=f+1|0}}else{GC(b);e=b+648|0;g=c[e>>2]|0;G4(g,Z9(c[g+4>>2]|0)|0);J3(b)}while(0);e=c[e>>2]|0;f=(Z9(c[e+4>>2]|0)|0)&7;if(f|0)d4(e,f&255);J3(b)}l=h;return}function ho(b){b=b|0;var d=0,e=0,f=0,g=0;g=l;l=l+16|0;d=g+1|0;e=g;bB(b,d);bB(b,e);a:do if((c[b+784>>2]|0)>>>0<=1?qO(b)|0:0){f=b+20|0;switch(a[d>>0]|0){case 1:{RB(b,1,c[f>>2]|0,197,384051,-1,1,1);break a}case 2:break;default:break a}RB(b,1,c[f>>2]|0,197,384063,-1,1,1);d=a[e>>0]|0;switch(d<<24>>24){case 9:case 1:{RB(b,1,c[f>>2]|0,204,384074,-1,1,1);break}case 14:case 6:{RB(b,1,c[f>>2]|0,204,384078,-1,1,1);break}default:break a}switch(d<<24>>24){case 6:case 1:{sM(b,1,c[f>>2]|0,202,2,1);RB(b,1,c[f>>2]|0,201,380879,-1,1,1);break a}case 14:case 9:{RB(b,1,c[f>>2]|0,201,380861,-1,1,1);break a}default:break a}}while(0);l=g;return}function io(a,b,d){a=a|0;b=+b;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+160|0;g=j+136|0;h=j;f=h+56|0;i=h+4|0;c[h>>2]=1244;c[f>>2]=1264;DO(h+56|0,i);c[h+128>>2]=0;c[h+132>>2]=-1;c[h>>2]=42060;c[f>>2]=42080;aV(i);c[i>>2]=42096;f=h+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[f+(e<<2)>>2]=0;e=e+1|0}c[h+48>>2]=0;c[h+52>>2]=16;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[g+(e<<2)>>2]=0;e=e+1|0}lq(i,g);O0(g);c[h+(c[(c[h>>2]|0)+-12>>2]|0)+8>>2]=d&255;d=h+(c[(c[h>>2]|0)+-12>>2]|0)+4|0;c[d>>2]=c[d>>2]&-261|4;yr(h,b)|0;Hk(g,i);rQ(a,g)|0;O0(g);YX(h);l=j;return a|0}function jo(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=b+4|0;g=c[f>>2]|0;do if(g){f=e8(b)|0;k=a[e+8+3>>0]|0;j=k<<24>>24<0;k=j?c[e+4>>2]|0:k&255;j=j?c[e>>2]|0:e;b=g;while(1){e=b+16|0;g=a[b+24+3>>0]|0;h=g<<24>>24<0;e=h?c[e>>2]|0:e;g=h?c[b+20>>2]|0:g&255;h=g>>>0<k>>>0;l=L$(j,e,h?g:k)|0;i=k>>>0<g>>>0;if((((l|0)==0?(i?-2147483648:0):l)|0)<0){e=c[b>>2]|0;if(!e){e=6;break}else{f=b;b=e}}else{l=L$(e,j,i?k:g)|0;if((((l|0)==0?(h?-2147483648:0):l)|0)>=0){e=10;break}f=b+4|0;e=c[f>>2]|0;if(!e){e=9;break}else b=e}}if((e|0)==6){c[d>>2]=b;f=b;break}else if((e|0)==9){c[d>>2]=b;break}else if((e|0)==10){c[d>>2]=b;break}}else c[d>>2]=f;while(0);return f|0}function ko(){var b=0,d=0;if((a[407800]|0)==0?E3(407800)|0:0){d=409820;do{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}d=d+12|0}while((d|0)!=409988)}IX(409820,402619)|0;IX(409832,402626)|0;IX(409844,402633)|0;IX(409856,402641)|0;IX(409868,402651)|0;IX(409880,402660)|0;IX(409892,402667)|0;IX(409904,402676)|0;IX(409916,402680)|0;IX(409928,402684)|0;IX(409940,402688)|0;IX(409952,402692)|0;IX(409964,402696)|0;IX(409976,402700)|0;return}function lo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;k=b+616|0;d=c[k>>2]|0;l=b+612|0;if(!d){d=(c[l>>2]|0)+4|0;c[k>>2]=d}h=b+544|0;i=b+888|0;g=c[b+548>>2]|0;while(1){if((d+4|0)>>>0>g>>>0){j=14;break}f=c[h>>2]|0;j=f+d|0;if((R4(a[j>>0]|0,a[j+1>>0]|0,a[j+2>>0]|0)|0)==1){j=14;break}while(1){e=d+2|0;c[k>>2]=e;if(e>>>0>=g>>>0){j=9;break}if(!(a[f+e>>0]|0)){j=8;break}else d=e}if((j|0)==8){j=0;d=d+1|0;if(!(a[f+d>>0]|0))j=10;else d=e}else if((j|0)==9){d=d+1|0;j=10}if((j|0)==10)c[k>>2]=d;if((a[i>>0]|0)!=13)continue;if((d-(c[l>>2]|0)|0)>>>0>20){j=13;break}}do if((j|0)==13){Op(b,16,0);j=19}else if((j|0)==14){if((d+4|0)>>>0>g>>>0){if((a[b+768>>0]|0)==0?(a[(c[b+24>>2]|0)+141>>0]|0)==0:0){d=0;break}c[k>>2]=g;d=g}Op(b,d-(c[l>>2]|0)|0,0);j=19}while(0);if((j|0)==19){c[k>>2]=0;d=1}return d|0}function mo(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;j=l;l=l+16|0;d=j+4|0;f=j;g=j+12|0;h=j+8|0;if(0==0?(c[a+520>>2]&1836253184|0)==1836253184:0){HB(a,j+14|0);HB(a,g);bD(a,d);bD(a,f);e=a+528|0;m=e;m=z0(c[m>>2]|0,c[m+4>>2]|0,2,0)|0;k=e;c[k>>2]=m;c[k+4>>2]=z;HB(a,j+10|0);if(qO(a)|0){m=a+20|0;k=b[g>>1]|0;sM(a,2,c[m>>2]|0,122,k<<16>>16!=5?k&65535:6,1);lL(a,2,c[m>>2]|0,135,c[d>>2]|0,10,1);lL(a,2,c[m>>2]|0,116,c[f>>2]<<3,10,1)}k=e;k=z0(c[k>>2]|0,c[k+4>>2]|0,2,0)|0;f=z;m=a+536|0;g=c[m+4>>2]|0;if(!(f>>>0>g>>>0|((f|0)==(g|0)?k>>>0>(c[m>>2]|0)>>>0:0))?(HB(a,h),i=b[h>>1]|0,i<<16>>16):0)e1(a,i&65535,0)}l=j;return}function no(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;if((e|0)>=8192)return Ka(b|0,d|0,e|0)|0;h=b|0;g=b+e|0;if((b&3)==(d&3)){while(b&3){if(!e)return h|0;a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}e=g&-4|0;f=e-64|0;while((b|0)<=(f|0)){c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];c[b+32>>2]=c[d+32>>2];c[b+36>>2]=c[d+36>>2];c[b+40>>2]=c[d+40>>2];c[b+44>>2]=c[d+44>>2];c[b+48>>2]=c[d+48>>2];c[b+52>>2]=c[d+52>>2];c[b+56>>2]=c[d+56>>2];c[b+60>>2]=c[d+60>>2];b=b+64|0;d=d+64|0}while((b|0)<(e|0)){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0}}else{e=g-4|0;while((b|0)<(e|0)){a[b>>0]=a[d>>0]|0;a[b+1>>0]=a[d+1>>0]|0;a[b+2>>0]=a[d+2>>0]|0;a[b+3>>0]=a[d+3>>0]|0;b=b+4|0;d=d+4|0}}while((b|0)<(g|0)){a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0}return h|0}function oo(){var b=0,d=0;if((a[407880]|0)==0?E3(407880)|0:0){d=410632;do{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}d=d+12|0}while((d|0)!=410800)}GX(410632,56132)|0;GX(410644,56160)|0;GX(410656,56188)|0;GX(410668,56220)|0;GX(410680,56260)|0;GX(410692,56296)|0;GX(410704,56324)|0;GX(410716,56360)|0;GX(410728,56376)|0;GX(410740,56392)|0;GX(410752,56408)|0;GX(410764,56424)|0;GX(410776,56440)|0;GX(410788,56456)|0;return}function po(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;g=l;l=l+32|0;e=g+12|0;f=g;W0(e,407712);if(!(c[101717]|0))fI();s7(c[e>>2]|0);TX(e);switch(d|0){case 0:{Xy(f,7740);vF(e,f)|0;z5(f);break}case 1:{Xy(f,3996);vF(e,f)|0;z5(f);break}case 2:{Xy(f,4004);vF(e,f)|0;z5(f);break}case 3:{Xy(f,4012);vF(e,f)|0;z5(f);break}case 5:{Xy(f,4020);vF(e,f)|0;z5(f);break}case 4:{Xy(f,35580);vF(e,f)|0;z5(f);break}case 6:{Xy(f,7748);vF(e,f)|0;z5(f);break}case 7:{Xy(f,42252);vF(e,f)|0;z5(f);break}default:{}}f=Un(a,b,e)|0;z5(e);l=g;return f|0}function qo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;f=b+784|0;g=b+772|0;h=b+536|0;if(!(a[f>>0]|0)){d=c[g>>2]|0;if(!d){switch(c[b+760>>2]|0){case 1:{d=ZW(1040)|0;_z(d);c[g>>2]=d;a[d+768>>0]=1;break}case 2:{d=ZW(22152)|0;Dt(d);c[g>>2]=d;c[d+908>>2]=1;break}default:d=0}e=b+520|0;c[e>>2]=-1;c[e+4>>2]=-1;aY(b,d);e=7}else e=11}else e=7;a:do if((e|0)==7){d=c[g>>2]|0;if(!d){e1(b,c[h>>2]|0,c[h+4>>2]|0);break}switch(a[f>>0]|0){case 106:case 101:case 100:case 99:case 98:case 97:case 96:break;default:{e=11;break a}}a[d+777>>0]=1;e=11}while(0);if((e|0)==11){rB(b,d);switch(a[f>>0]|0){case 106:case 101:case 100:case 99:case 98:case 97:case 96:{a[(c[g>>2]|0)+777>>0]=0;break}default:{}}f=h;g=c[f+4>>2]|0;h=b+528|0;c[h>>2]=c[f>>2];c[h+4>>2]=g}return}function ro(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=b;h=c[i>>2]|0;i=c[i+4>>2]|0;k=a;j=c[k>>2]|0;k=c[k+4>>2]|0;f=d;e=c[f>>2]|0;f=c[f+4>>2]|0;g=f>>>0<i>>>0|(f|0)==(i|0)&e>>>0<h>>>0;do if(i>>>0<k>>>0|(i|0)==(k|0)&h>>>0<j>>>0){if(g){b=a;c[b>>2]=e;c[b+4>>2]=f;e=d;c[e>>2]=j;c[e+4>>2]=k;e=1;break}f=a;c[f>>2]=h;c[f+4>>2]=i;f=b;c[f>>2]=j;c[f+4>>2]=k;f=d;e=c[f>>2]|0;f=c[f+4>>2]|0;if(f>>>0<k>>>0|(f|0)==(k|0)&e>>>0<j>>>0){c[b>>2]=e;c[b+4>>2]=f;e=d;c[e>>2]=j;c[e+4>>2]=k;e=2}else e=1}else if(g){g=b;c[g>>2]=e;c[g+4>>2]=f;f=d;c[f>>2]=h;c[f+4>>2]=i;f=b;e=c[f>>2]|0;f=c[f+4>>2]|0;h=a;g=c[h>>2]|0;h=c[h+4>>2]|0;if(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0){c[a>>2]=e;c[a+4>>2]=f;e=b;c[e>>2]=g;c[e+4>>2]=h;e=2}else e=1}else e=0;while(0);return e|0}
function rh(a,b){a=a|0;b=b|0;var c=0;a:do switch(a<<24>>24){case 30:case 2:case 1:{b=391454;break}case 3:{b=391443;break}case 4:{b=391443;break}case 15:{b=391425;break}case 16:{b=391429;break}case 17:{b=391425;break}case 27:{b=391410;break}case 28:{b=391425;break}case 29:{b=391414;break}case 31:{b=391410;break}case 32:{b=391410;break}case 39:case 36:{b=391405;break}default:{b:do if((b|0)<1212435798){if((b|0)<1129661769)switch(b|0){case -1:{b=8800948;break a}default:{c=34;break b}}if((b|0)<1195456820)switch(b|0){case 1129661769:{c=14;break b}default:{c=34;break b}}else switch(b|0){case 1195456820:{c=14;break b}default:{c=34;break b}}}else{if((b|0)>=1395733569)if((b|0)<1396921413)switch(b|0){case 1395733569:{c=14;break b}default:{c=34;break b}}else switch(b|0){case 1396921413:{c=14;break b}default:{c=34;break b}}switch(b|0){case 1212435798:break;default:{c=34;break b}}do switch(a<<24>>24){case -128:{b=391465;break a}case -127:{b=391372;break a}case -126:{b=391377;break a}case -125:{b=391372;break a}case -124:{b=391365;break a}case -123:{b=391377;break a}case -122:{b=391377;break a}case -112:{b=391388;break a}case -111:{b=391388;break a}case -110:{b=391381;break a}case -95:{b=391372;break a}case -94:{b=391377;break a}case -22:{b=391360;break a}default:{b=8800948;break a}}while(0)}while(0);if((c|0)==14)switch(a<<24>>24){case -128:{b=391454;break a}case -127:{b=391372;break a}case -126:{b=391400;break a}case -122:{b=391392;break a}case -121:{b=391365;break a}default:{b=8800948;break a}}else if((c|0)==34)switch(a<<24>>24){case -128:{b=391454;break a}case -127:{b=391372;break a}case -121:{b=391365;break a}case -120:{b=391360;break a}case -47:{b=391354;break a}default:{b=8800948;break a}}}}while(0);return b|0}function sh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;u=l;l=l+48|0;e=u+37|0;j=u+36|0;k=u+24|0;m=u+12|0;n=u;p=b+528|0;r=b+536|0;s=b+760|0;t=b+788|0;f=b+764|0;g=b+770|0;h=b+768|0;i=b+782|0;d=b+648|0;while(1){w=p;y=c[w+4>>2]|0;v=r;x=c[v+4>>2]|0;if(!(y>>>0<x>>>0|((y|0)==(x|0)?(c[w>>2]|0)>>>0<(c[v>>2]|0)>>>0:0)))break;Bx(b);xR(b,4,e);xR(b,4,j);d4(c[d>>2]|0,4);d4(c[d>>2]|0,4);wK(b);if(qO(b)|0?a[t>>0]|0:0){y=$C((HD((c[s>>2]|0)+68|0,f)|0)+16|0,g)|0;TX(n);bj(n,bq(a[e>>0]|0,a[j>>0]|0)|0)|0;Bs(m,n,39968);p2(k,m);vF((UB(kC(y+88|0,h)|0,i)|0)+48|0,k)|0;z5(k);O0(m);z5(n);a[y+100>>0]=1;a[(c[s>>2]|0)+121>>0]=1}}if((qO(b)|0?a[t>>0]|0:0)?(o=$C((HD((c[s>>2]|0)+68|0,f)|0)+16|0,g)|0,q=UB(kC(o+88|0,h)|0,i)|0,y=a[q+56+3>>0]|0,(y<<24>>24<0?c[q+52>>2]|0:y&255)|0):0){x=UB(kC(($C((HD((c[s>>2]|0)+68|0,f)|0)+16|0,g)|0)+88|0,h)|0,i)|0;y=a[x+56+3>>0]|0;FB(q+48|0,(y<<24>>24<0?c[x+52>>2]|0:y&255)+-2|0,0);a[o+100>>0]=1;a[(c[s>>2]|0)+121>>0]=1}l=u;return}function th(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=l;l=l+32|0;w=E+16|0;y=E+15|0;n=E+14|0;o=E+13|0;p=E+12|0;q=E+11|0;t=E+10|0;i=E+9|0;j=E+8|0;k=E+7|0;z=E;A=E+6|0;B=E+5|0;C=E+4|0;a[w>>0]=0;a[y>>0]=0;a[n>>0]=0;a[o>>0]=0;a[p>>0]=0;a[q>>0]=0;a[t>>0]=0;a[i>>0]=0;a[j>>0]=0;a[k>>0]=0;if(d){AT(b,i);AT(b,j);m=a[i>>0]|0;i=a[j>>0]|0;if(!((i|m)<<24>>24)){x=0;v=0;u=0;s=0;r=0;q=0;p=0;o=0}else{yT(b,k);j=a[k>>0]|0;d=j<<24>>24==0;if(d)A6(c[b+648>>2]|0);else{GC(b);x=b+648|0;A6(c[x>>2]|0);d4(c[x>>2]|0,8);xR(b,5,n);A6(c[x>>2]|0);xR(b,5,o);J3(b)}xR(b,4,w);xR(b,4,y);if(!d)d4(c[b+648>>2]|0,4);xR(b,5,p);xR(b,5,q);xR(b,5,t);x=j<<24>>24!=0;v=a[n>>0]|0;u=a[o>>0]|0;s=a[p>>0]|0;r=a[q>>0]|0;q=a[t>>0]|0;p=a[w>>0]|0;o=a[y>>0]|0}}else{i=0;m=0;x=0;v=0;u=0;s=0;r=0;q=0;p=0;o=0}n=(i|m)<<24>>24==0;m=m<<24>>24==0;k=i<<24>>24==0;j=0;while(1){if((j&255)>(e&255))break;c[z>>2]=0;a[B>>0]=1;a[C>>0]=0;AT(b,A);if((a[A>>0]|0)==0?(AT(b,B),(a[B>>0]|0)==0):0){AT(b,C);if(!(a[C>>0]|0))D=15;else d=0}else{T5(b);D=15}if((D|0)==15){D=0;n3(b,z);d=c[z>>2]|0;if(d>>>0>31){D=16;break}}if(!n){i=ZW(6)|0;_Q(i,x,v,u,s,r,q);c[f>>2]=i;if(!m)ij(b,i,p,o,d,g);if(!k)ij(b,c[f>>2]|0,p,o,d,h)}j=j+1<<24>>24}if((D|0)==16)t4(b);l=E;return}function uh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+96|0;o=w+86|0;u=w+68|0;v=w+56|0;p=w+8|0;q=w+52|0;r=w+48|0;s=w+44|0;t=w+40|0;f=w+36|0;g=w+32|0;h=w+28|0;i=w+24|0;j=w+20|0;k=w+16|0;m=w+84|0;n=w;bB(b,o);jB(b,w+80|0);TX(u);TX(v);o=(a[o>>0]|0)==0;if(o){ID(b,n);d=c[n>>2]|0;if(d|0)__(u,d)|0}else{oz(b,n);e=n;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!((d|0)==0&(e|0)==0))mZ(u,d,e)|0}if(o){ID(b,n);d=c[n>>2]|0;if(d|0)__(v,d)|0}else{oz(b,n);e=n;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!((d|0)==0&(e|0)==0))mZ(v,d,e)|0}ID(b,b+824|0);if(o){ID(b,n);c[p>>2]=c[n>>2];c[p+4>>2]=0}else oz(b,p);ID(b,k);NB(b,m);e1(b,10,0);GC(b);hy(b,16,q);hy(b,16,r);hy(b,2,s);hy(b,16,t);hy(b,16,f);hy(b,2,g);hy(b,16,h);hy(b,16,i);hy(b,2,j);J3(b);t=b+528|0;s=t;s=z0(c[s>>2]|0,c[s+4>>2]|0,28,0)|0;c[t>>2]=s;c[t+4>>2]=z;if(qO(b)|0){d=oH(u,13,0)|0;if((d|0)!=-1)FB(u,d,0);d=oH(u,10,0)|0;if((d|0)!=-1)FB(u,d,0);e=b+16|0;f=b+20|0;Mc(b,c[e>>2]|0,c[f>>2]|0,377029,u,0);d=oH(v,13,0)|0;if((d|0)!=-1)FB(v,d,0);d=oH(v,10,0)|0;if((d|0)!=-1)FB(v,d,0);Mc(b,c[e>>2]|0,c[f>>2]|0,377042,v,0)}z5(v);z5(u);l=w;return}function vh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+48|0;h=p;j=b+376|0;m=b+612|0;k=b+492|0;n=b+568|0;o=b+552|0;do if(a[j>>0]|0)if(nb[c[(c[b>>2]|0)+68>>2]&255](b)|0){d=b+120|0;i=d;g=c[i+4>>2]|0;if(!(0<g>>>0|(0==(g|0)?(c[m>>2]|0)>>>0<(c[i>>2]|0)>>>0:0))?(i=b+224|0,!((c[i>>2]|0)==-1?(c[i+4>>2]|0)==-1:0)):0){g=b+200|0;e=g;f=d+40|0;do{c[d>>2]=c[e>>2];d=d+4|0;e=e+4|0}while((d|0)<(f|0));T$(h);d=g;e=h;f=d+40|0;do{c[d>>2]=c[e>>2];d=d+4|0;e=e+4|0}while((d|0)<(f|0))}if(a[j>>0]|0){if(a[k>>0]|0){i=27;break}o=z0(c[m>>2]|0,0,c[o>>2]|0,c[o+4>>2]|0)|0;i=n;c[i>>2]=o;c[i+4>>2]=z;i=27;break}d=b+508|0;a[(c[b+668>>2]|0)+((c[d>>2]|0)*24|0)+18>>0]=1;t4(b);while(1){if(!(c[d>>2]|0))break;J3(b)}if(!(a[j>>0]|0))i=13;else i=27}else d=0;else i=13;while(0);do if((i|0)==13){g=b+56|0;if(!(nb[c[(c[b>>2]|0)+64>>2]&255](b)|0)){if(c[b+728>>2]&8|0)KM(b);if(a[k>>0]|0){d=0;break}n=g;if(!((c[n>>2]|0)==-1?(c[n+4>>2]|0)==-1:0)){d=0;break}n=o;n=z0(c[m>>2]|0,0,c[n>>2]|0,c[n+4>>2]|0)|0;k=z;o=b+632|0;m=c[o+4>>2]|0;if(k>>>0<m>>>0|((k|0)==(m|0)?n>>>0<(c[o>>2]|0)>>>0:0)){d=0;break}z$(b);d=0;break}a[j>>0]=1;if(!(a[k>>0]|0)){d=b+377|0;k=(a[d>>0]|0)==0;e=o;e=z0(c[e>>2]|0,c[e+4>>2]|0,c[m>>2]|0,0)|0;f=z;if(k){h=n;h=D_(e|0,f|0,c[h>>2]|0,c[h+4>>2]|0)|0;k=b+584|0;j=k;j=z0(h|0,z|0,c[j>>2]|0,c[j+4>>2]|0)|0;c[k>>2]=j;c[k+4>>2]=z}c[n>>2]=e;c[n+4>>2]=f;a[d>>0]=0}n=g;if((c[n>>2]|0)==-1?(c[n+4>>2]|0)==-1:0){jb[c[(c[b>>2]|0)+72>>2]&511](b);k=o;n=c[m>>2]|0;k=z0(n|0,0,c[k>>2]|0,c[k+4>>2]|0)|0;o=b+560|0;m=o;m=z0(k|0,z|0,c[m>>2]|0,c[m+4>>2]|0)|0;c[o>>2]=m;c[o+4>>2]=z;o=b+48|0;n=z0(c[o>>2]|0,c[o+4>>2]|0,n|0,0)|0;o=g;c[o>>2]=n;c[o+4>>2]=z}if(nb[c[(c[b>>2]|0)+68>>2]&255](b)|0)i=27;else d=0}while(0);if((i|0)==27)d=1;l=p;return d|0}function wh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+32|0;j=m;e=a+32|0;f=b+-32|0;g=a+64|0;switch(b-a>>5|0){case 1:case 0:{e=1;break}case 2:{if(tb[c[d>>2]&31](f,a)|0){c[j>>2]=c[a>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];c[j+12>>2]=c[a+12>>2];c[j+16>>2]=c[a+16>>2];c[j+20>>2]=c[a+20>>2];c[j+24>>2]=c[a+24>>2];c[j+28>>2]=c[a+28>>2];c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];c[a+16>>2]=c[f+16>>2];c[a+20>>2]=c[f+20>>2];c[a+24>>2]=c[f+24>>2];c[a+28>>2]=c[f+28>>2];c[f>>2]=c[j>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];c[f+24>>2]=c[j+24>>2];c[f+28>>2]=c[j+28>>2];e=1}else e=1;break}case 3:{ef(a,e,f,d)|0;e=1;break}case 4:{Ph(a,e,g,f,d)|0;e=1;break}case 5:{hg(a,e,g,a+96|0,f,d)|0;e=1;break}default:{ef(a,e,g,d)|0;f=a+96|0;i=0;e=g;a:while(1){h=f;while(1){if((h|0)==(b|0)){f=1;e=0;break a}g=h+32|0;if(tb[c[d>>2]&31](h,e)|0)break;else{e=h;h=g}}c[j>>2]=c[h>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];c[j+12>>2]=c[h+12>>2];c[j+16>>2]=c[h+16>>2];c[j+20>>2]=c[h+20>>2];c[j+24>>2]=c[h+24>>2];c[j+28>>2]=c[h+28>>2];f=h;while(1){c[f>>2]=c[e>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];c[f+16>>2]=c[e+16>>2];c[f+20>>2]=c[e+20>>2];c[f+24>>2]=c[e+24>>2];c[f+28>>2]=c[e+28>>2];if((e|0)==(a|0))break;f=e+-32|0;if(tb[c[d>>2]&31](j,f)|0){n=e;e=f;f=n}else break}c[e>>2]=c[j>>2];c[e+4>>2]=c[j+4>>2];c[e+8>>2]=c[j+8>>2];c[e+12>>2]=c[j+12>>2];c[e+16>>2]=c[j+16>>2];c[e+20>>2]=c[j+20>>2];c[e+24>>2]=c[j+24>>2];c[e+28>>2]=c[j+28>>2];e=i+1|0;if((e|0)==8){k=15;break}else{f=g;i=e;e=h}}if((k|0)==15){f=0;e=(g|0)==(b|0)}e=e|f}}l=m;return e|0}function xh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+32|0;j=m+12|0;f=m+17|0;d=m+16|0;k=m;KK(b);Bx(b);e=b+648|0;if(K6(c[e>>2]|0)|0){GC(b);A6(c[e>>2]|0);d4(c[e>>2]|0,32);d4(c[e>>2]|0,32);d4(c[e>>2]|0,8);J3(b)}else A6(c[e>>2]|0);A6(c[e>>2]|0);A6(c[e>>2]|0);AT(b,d);rR(b,23,j);xR(b,4,f);g=a[d>>0]|0;if(!(g<<24>>24))d4(c[e>>2]|0,20);h=a[f>>0]|0;e=(h&255)+1|0;d=0;while(1){if((d&255)>>>0>=e>>>0)break;Eb(b);d=d+1<<24>>24}wK(b);if(qO(b)|0){RB(b,0,0,57,370817,-1,1,1);i=b+536|0;oK(b,0,0,142,c[i>>2]|0,c[i+4>>2]|0,10,0);i=g<<24>>24!=0;f=i?384435:384431;RB(b,0,0,101,f,-1,1,0);d=0;while(1){if(d>>>0>=(RA(b,2,-1)|0)>>>0)break;RB(b,2,d,44,370817,-1,1,0);d=d+1|0}if(!(h<<24>>24)){h=b+22136|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;e=j9(387802)|0;if(e>>>0>4294967279)uaa();if(e>>>0<11){a[k+11>>0]=e;d=k}else{g=e+16&-16;d=ZW(g)|0;c[k>>2]=d;c[k+8>>2]=g|-2147483648;c[k+4>>2]=e}i1(d,387802,e)|0;J7(d+e|0,0);cC(VC(h,k)|0,f)|0;a1(k);g=c[j>>2]|0;if(g|0){e=i?387665:384534;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;f=j9(e)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[k+11>>0]=f;d=k}else{j=f+16&-16;d=ZW(j)|0;c[k>>2]=d;c[k+8>>2]=j|-2147483648;c[k+4>>2]=f}i1(d,e,f)|0;J7(d+f|0,0);Gk(VC(h,k)|0,g,10)|0;a1(k)}}xp(b+760|0,370817)}l=m;return}function yh(d){d=d|0;var e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;e=i;g=d+780|0;f=c[g>>2]|0;if(f|0)laa(f);c[g>>2]=ZW(48)|0;bB(d,e);switch(a[e>>0]|0){case 0:{Bx(d);AT(d,c[g>>2]|0);AT(d,(c[g>>2]|0)+1|0);AT(d,(c[g>>2]|0)+2|0);AT(d,(c[g>>2]|0)+3|0);AT(d,(c[g>>2]|0)+4|0);AT(d,(c[g>>2]|0)+5|0);AT(d,(c[g>>2]|0)+6|0);AT(d,(c[g>>2]|0)+7|0);wK(d);ID(d,(c[g>>2]|0)+8|0);ID(d,(c[g>>2]|0)+12|0);bB(d,(c[g>>2]|0)+16|0);bB(d,(c[g>>2]|0)+17|0);bB(d,(c[g>>2]|0)+18|0);bB(d,(c[g>>2]|0)+19|0);Bx(d);xR(d,4,(c[g>>2]|0)+20|0);xR(d,5,(c[g>>2]|0)+21|0);xR(d,5,(c[g>>2]|0)+22|0);d4(c[d+648>>2]|0,2);wK(d);e=c[g>>2]|0;f=e+24|0;if(!(a[e+7>>0]|0))h=10;else{ID(d,f);NB(d,(c[g>>2]|0)+28|0);NB(d,(c[g>>2]|0)+30|0);e=c[g>>2]|0}break}case 1:{e=c[g>>2]|0;h=e;c[h>>2]=0;c[h+4>>2]=0;c[e+8>>2]=1e3;c[e+12>>2]=0;a[e+16>>0]=32;h=e+17|0;a[h>>0]=0;a[h+1>>0]=0;a[h+2>>0]=0;a[h+3>>0]=0;a[h+4>>0]=0;a[h+5>>0]=0;h=7;break}case 2:{e=c[g>>2]|0;c[e>>2]=0;a[e+4>>0]=0;a[e+5>>0]=1;h=e+6|0;b[h>>1]=0;b[h+2>>1]=0;b[h+4>>1]=0;b[h+6>>1]=0;b[h+8>>1]=0;b[h+10>>1]=0;b[h+12>>1]=0;b[h+14>>1]=0;a[h+16>>0]=0;h=7;break}default:{e=c[g>>2]|0;h=e+18|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;a[e+16>>0]=0;b[h>>1]=0;b[h+2>>1]=0;a[h+4>>0]=0;h=7}}if((h|0)==7){f=e+24|0;h=10}if((h|0)==10){h=f;c[h>>2]=0;c[h+4>>2]=0}if(!(a[e+5>>0]|0)){Bx(d);h=c[g>>2]|0;cO(d,a[h+16>>0]|0,h+32|0);h=c[g>>2]|0;cO(d,a[h+16>>0]|0,h+40|0);wK(d)}else{h=e+32|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0}l=i;return}function zh(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+16|0;s=u;d=c[b+508>>2]|0;e=c[b+668>>2]|0;do if(k2(d,e)|0){if((a[b+492>>0]|0)==0?(f=c[b+24>>2]|0,+g[f+136>>2]>=1.0):0){q=b+552|0;r=b+40|0;CS(f,(+((c[q>>2]|0)>>>0)+4294967296.0*+((c[q+4>>2]|0)>>>0))/(+((c[r>>2]|0)>>>0)+4294967296.0*+((c[r+4>>2]|0)>>>0)))}c[s>>2]=c[b+520>>2];d=bF(b+916|0,s)|0;n=d+12|0;f=c[n>>2]|0;o=d+16|0;e=c[o>>2]|0;p=b+536|0;if((f|0)==(e|0)){t=p;e1(b,c[t>>2]|0,c[t+4>>2]|0);nx(b);break}q=b+544|0;r=b+612|0;m=d+20|0;k=0;i=f;d=e;h=f;while(1){f=p;e=c[f>>2]|0;f=c[f+4>>2]|0;if(k>>>0>=d-i>>2>>>0)break;Sc(b,c[h+(k<<2)>>2]|0,(c[q>>2]|0)+(c[r>>2]|0)|0,e,1);d=c[o>>2]|0;i=c[n>>2]|0;e=i;do if(d-i>>2>>>0>1){f=c[e+(k<<2)>>2]|0;h=c[f+728>>2]|0;j=f;if((h&9|0)==8){if(f){jb[c[(c[f>>2]|0)+4>>2]&511](f);e=c[n>>2]|0;d=c[o>>2]|0}h=e+(k<<2)|0;e=h+4|0;f=d-e|0;i=f>>2;if(!i)e=d;else{TR(h|0,e|0,f|0)|0;d=c[o>>2]|0;e=d}f=h+(i<<2)|0;while(1){if((e|0)==(f|0))break;j=e+-4|0;c[o>>2]=j;d=j;e=j}e=k+-1|0;break}if(h&1){c[s>>2]=j;h=0;f=i;while(1){if(h>>>0>=d-f>>2>>>0)break;if((h|0)!=(k|0)?(t=c[e+(h<<2)>>2]|0,(t|0)!=0):0){jb[c[(c[t>>2]|0)+4>>2]&511](t);d=c[o>>2]|0;e=c[n>>2]|0}else e=f;h=h+1|0;f=e}h=d;f=(d-e|0)>>>2;d=h;while(1){if((d|0)==(e|0))break;i=d+-4|0;c[o>>2]=i;d=i}d=h+(0-f<<2)|0;if((d|0)==(c[m>>2]|0)){Yy(n,s);d=c[o>>2]|0}else{c[d>>2]=j;d=(c[o>>2]|0)+4|0;c[o>>2]=d}e=k}else e=k}else e=k;while(0);h=c[n>>2]|0;k=e+1|0;i=h}t=b+528|0;c[t>>2]=e;c[t+4>>2]=f;nx(b)}else c3(d,e);while(0);l=u;return}function Ah(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+16|0;h=s+4|0;p=s+8|0;r=s;n=ZW(12)|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;k=b+528|0;q=k;q=z0(c[q>>2]|0,c[q+4>>2]|0,12,0)|0;o=k;c[o>>2]=q;c[o+4>>2]=z;ID(b,h);h=c[h>>2]|0;o=n+9|0;pY(h,0,0,o);pY(h,0,1,n+10|0);q=n+11|0;pY(h,0,2,q);ID(b,n);h=n+4|0;ID(b,h);bB(b,p);e=b+536|0;d=c[e>>2]|0;e=c[e+4>>2]|0;j=k;i=c[j>>2]|0;j=c[j+4>>2]|0;g=z0(i|0,j|0,3,0)|0;if(!((d|0)==(g|0)&(e|0)==(z|0))){f=z0(i|0,j|0,7,0)|0;g=z;if(!(e>>>0<g>>>0|(e|0)==(g|0)&d>>>0<f>>>0)?(g=z0(W8((c[b+544>>2]|0)+(c[b+612>>2]|0)+i+3|0)|0,0,f|0,g|0)|0,f=z,!(e>>>0<f>>>0|(e|0)==(f|0)&d>>>0<g>>>0)):0)m=4;else{d=1;e=0}}else m=4;if((m|0)==4){d=3;e=0}j=z0(i|0,j|0,d|0,e|0)|0;m=k;c[m>>2]=j;c[m+4>>2]=z;if(qO(b)|0){if((c[n>>2]|0)==25?(c[h>>2]|0)==100:0)c[n>>2]=2500;if((c[b+16>>2]|0)==4){f=b+788|0;g=b+916|0}else{Kc(b,4,-1)|0;m=b+20|0;RB(b,4,c[m>>2]|0,18,380054,-1,1,0);RB(b,4,c[m>>2]|0,19,377405,-1,1,0);g=b+916|0;f=b+788|0;c[(bF(g,f)|0)+44>>2]=4;m=c[m>>2]|0;c[(bF(g,f)|0)+48>>2]=m}c[(bF(g,f)|0)+40>>2]=n;h=ZW(776)|0;MV(h);aY(b,h);d=b+964|0;e=c[d>>2]|0;if((e|0)==(c[b+968>>2]|0))Yy(b+960|0,f);else{c[e>>2]=c[f>>2];c[d>>2]=e+4}a[(bF(g,f)|0)+271>>0]=1;a[h+760>>0]=a[p>>0]|0;a[h+761>>0]=a[o>>0]|0;a[h+762>>0]=a[q>>0]|0;d=bF(g,f)|0;c[r>>2]=h;e=d+16|0;f=c[e>>2]|0;if(f>>>0<(c[d+20>>2]|0)>>>0){c[f>>2]=h;c[e>>2]=(c[e>>2]|0)+4}else Yy(d+12|0,r);a[b+761>>0]=1}else laa(n);l=s;return}function Bh(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;q=b+4|0;h=d;m=g+4|0;n=g+11|0;do if((q|0)!=(d|0)?(i=d+16|0,j=a[i+11>>0]|0,o=j<<24>>24<0,i=o?c[i>>2]|0:i,j=o?c[d+20>>2]|0:j&255,o=a[n>>0]|0,p=o<<24>>24<0,o=p?c[m>>2]|0:o&255,p=p?c[g>>2]|0:g,k=j>>>0<o>>>0,s=R$(p,i,k?j:o)|0,l=o>>>0<j>>>0,(((s|0)==0?(l?-2147483648:0):s)|0)>=0):0){s=R$(i,p,l?o:j)|0;if((((s|0)==0?(k?-2147483648:0):s)|0)<0){f=1;i=h}else{c[e>>2]=h;c[f>>2]=h;d=f;break}while(1){if((f|0)<=0)break;j=i;i=c[j+4>>2]|0;a:do if(!i)while(1){i=c[j+8>>2]|0;if((c[i>>2]|0)==(j|0))break a;j=i}else while(1){j=c[i>>2]|0;if(!j)break;else i=j}while(0);f=f+-1|0}j=i;if((j|0)!=(q|0)?(m=i,s=m+16|0,q=a[s+11>>0]|0,n=q<<24>>24<0,q=n?c[m+20>>2]|0:q&255,s=R$(p,n?c[s>>2]|0:s,q>>>0<o>>>0?q:o)|0,(((s|0)==0?(o>>>0<q>>>0?-2147483648:0):s)|0)>=0):0){d=bo(b,e,g)|0;break}d=d+4|0;if(!(c[d>>2]|0)){c[e>>2]=h;break}else{c[e>>2]=j;d=j;break}}else r=3;while(0);do if((r|0)==3){j=c[d>>2]|0;if((c[b>>2]|0)!=(d|0)){if(!j){i=d;while(1){h=c[i+8>>2]|0;if((c[h>>2]|0)==(i|0))i=h;else break}}else{h=j;while(1){i=c[h+4>>2]|0;if(!i)break;else h=i}}p=h+16|0;r=a[n>>0]|0;s=r<<24>>24<0;r=s?c[m>>2]|0:r&255;q=a[p+11>>0]|0;o=q<<24>>24<0;q=o?c[h+20>>2]|0:q&255;s=R$(o?c[p>>2]|0:p,s?c[g>>2]|0:g,r>>>0<q>>>0?r:q)|0;if((((s|0)==0?(q>>>0<r>>>0?-2147483648:0):s)|0)>=0){d=bo(b,e,g)|0;break}}if(!j){c[e>>2]=d;break}else{d=h;c[e>>2]=d;d=d+4|0;break}}while(0);return d|0}function Ch(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;m=l;l=l+48|0;h=m+20|0;g=m;e=m+16|0;i=m+40|0;j=m+34|0;k=m+32|0;TX(h);L2(g);bB(a,m+45|0);bB(a,m+44|0);j0(a,g);HB(a,m+42|0);jZ(a,80,0,h);HB(a,i);HB(a,m+38|0);HB(a,m+36|0);HB(a,j);HB(a,k);GC(a);bD(a,e);e=c[e>>2]|0;f=a+528|0;d=0;while(1){if((d|0)==(e|0))break;o=f;o=z0(c[o>>2]|0,c[o+4>>2]|0,4,0)|0;n=f;c[n>>2]=o;c[n+4>>2]=z;d=d+1|0}J3(a);q=f;r=c[q>>2]|0;q=c[q+4>>2]|0;d=z0(r|0,q|0,16,0)|0;n=z;o=a+536|0;e=c[o>>2]|0;o=c[o+4>>2]|0;p=n>>>0<o>>>0|(n|0)==(o|0)&d>>>0<e>>>0;q=z0(r|0,q|0,20,0)|0;d=p?q:d;n=p?z:n;c[f>>2]=d;c[f+4>>2]=n;if(!((d|0)==(e|0)&(n|0)==(o|0)))t4(a);if(qO(a)|0){Kc(a,2,-1)|0;e=g+8|0;d=c[e>>2]|0;e=c[e+4>>2]|0;a:do if((d|0)<363974673){switch(d|0){case -1750644243:break;default:break a}if((e|0)==1965784205){RB(a,2,0,18,379565,-1,1,0);RB(a,2,0,52,379565,-1,1,0)}}else{if((d|0)>=1989195078){switch(d|0){case 1989195078:break;default:break a}if((e|0)!=-1915450906)break;RB(a,2,0,18,379622,-1,1,0);RB(a,2,0,52,379622,-1,1,0);break}switch(d|0){case 363974673:break;default:break a}if((e|0)<1114472286)switch(e|0){case 1097695070:break;default:break a}else switch(e|0){case 1114472286:break;default:break a}RB(a,2,0,18,379616,-1,1,0);RB(a,2,0,52,379616,-1,1,0)}while(0);kL(a,2,0,112,b[i>>1]|0,10,0);kL(a,2,0,135,b[j>>1]|0,10,0);kL(a,2,0,147,b[k>>1]|0,10,0);sM(a,2,0,122,1,0)}z5(h);l=m;return}function Dh(e){e=e|0;var f=0,h=0,i=0.0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;do if(!(a[e+492>>0]|0)){l=c[e+24>>2]|0;h=e+552|0;f=c[h>>2]|0;h=c[h+4>>2]|0;i=+(f>>>0)+4294967296.0*+(h>>>0);if(+g[l+136>>2]>=1.0){p=e+40|0;CS(l,i/(+((c[p>>2]|0)>>>0)+4294967296.0*+((c[p+4>>2]|0)>>>0)));break}j=e+848|0;j=PZ(c[j>>2]|0,c[j+4>>2]|0,1)|0;k=z;if(h>>>0>k>>>0|(h|0)==(k|0)&f>>>0>j>>>0){CS(l,.9900000095367432);break}else{CS(l,i/(+(j>>>0)+4294967296.0*+(k>>>0)));break}}while(0);k=e+858|0;f=b[k>>1]|0;l=e+548|0;p=e+536|0;if(f<<16>>16){h=c[l>>2]|0;j=f&65535;if(j>>>0<h>>>0){o=p;c[o>>2]=f&65535;c[o+4>>2]=0;f=0}else{f=p;c[f>>2]=h;c[f+4>>2]=0;f=j-h&65535}b[k>>1]=f;GC(e);jb[c[(c[e>>2]|0)+104>>2]&511](e);m=p;n=c[m+4>>2]|0;o=e+528|0;c[o>>2]=c[m>>2];c[o+4>>2]=n;J3(e)}o=e+857|0;if(a[o>>0]|0){a[e+748>>0]=1;a[e+749>>0]=0;n=c[l>>2]|0;m=e+544|0;f=0;while(1){h=f+4|0;j=f+1|0;k=f+2|0;if(h>>>0>n>>>0)break;l=c[m>>2]|0;if((((a[l+f>>0]|0)==0?(a[l+j>>0]|0)==0:0)?(a[l+k>>0]|0)==1:0)?(d[l+(f+3)>>0]|0)>=185:0)break;else f=k;while(1){if(f>>>0>=n>>>0){h=23;break}if(!(a[l+f>>0]|0)){h=22;break}f=f+2|0}if((h|0)==22){h=f+-1|0;if(!(a[l+h>>0]|0))f=h;else continue}else if((h|0)==23)f=f+-1|0}do if((h|0)==(n|0)){l=c[m>>2]|0;if(((a[l+f>>0]|0)==0?(a[l+j>>0]|0)==0:0)?(a[l+k>>0]|0)==1:0)break;f=j}while(0);do if((f+3|0)==(n|0)){l=c[m>>2]|0;h=f+1|0;if(((a[l+f>>0]|0)==0?(a[l+h>>0]|0)==0:0)?(a[l+(f+2)>>0]|0)==1:0)break;f=h}while(0);do if((f+2|0)==(n|0)){l=c[m>>2]|0;h=f+1|0;if((a[l+f>>0]|0)==0?(a[l+h>>0]|0)==0:0)break;f=h}while(0);if((f+1|0)==(n|0))f=(a[(c[m>>2]|0)+f>>0]|0)==0?f:n;if((f|0)!=(n|0)){m=p;c[m>>2]=f;c[m+4>>2]=0;if((f+4|0)>>>0>n>>>0)h=0;else{a[o>>0]=0;h=0}}else{f=p;c[f>>2]=n;c[f+4>>2]=0;f=n;h=0}if(!((f|0)==0&(h|0)==0)){GC(e);jb[c[(c[e>>2]|0)+104>>2]&511](e);n=p;o=c[n+4>>2]|0;p=e+528|0;c[p>>2]=c[n>>2];c[p+4>>2]=o;J3(e)}}return}function Eh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=l;l=l+48|0;k=A+36|0;s=A+24|0;t=A+12|0;u=A;v=b+808|0;w=b+812|0;x=s+8+3|0;y=s+4|0;m=s+8+3|0;n=s+4|0;o=t+8+3|0;p=t+4|0;q=u+8+3|0;r=u+4|0;j=0;a:while(1){d=c[v>>2]|0;if(j>>>0>=(c[w>>2]|0)-d>>3>>>0)break;d=c[c[d+(j<<3)>>2]>>2]|0;i=j+1|0;if(!d){j=i;continue}if(!(c[d+728>>2]&4)){j=i;continue}e4(d);h=0;while(1){if(h>>>0>=(RA(c[c[(c[v>>2]|0)+(j<<3)>>2]>>2]|0,3,-1)|0)>>>0){j=i;continue a}gq(k,b,3,(c[(c[v>>2]|0)+(j<<3)+4>>2]|0)+h|0,382758);$x(s,b,3,(c[(c[v>>2]|0)+(j<<3)+4>>2]|0)+h|0,10,1);d=Vj(c[c[(c[v>>2]|0)+(j<<3)>>2]>>2]|0,3,h,10,1)|0;f=a[x>>0]|0;e=f<<24>>24<0;f=e?c[y>>2]|0:f&255;B=a[d+8+3>>0]|0;g=B<<24>>24<0;if((f|0)==((g?c[d+4>>2]|0:B&255)|0)){B=(L$(e?c[s>>2]|0:s,g?c[d>>2]|0:d,f)|0)==0;z5(s);if(B)d=c[v>>2]|0;else z=12}else{z5(s);z=12}b:do if((z|0)==12){z=0;Kc(b,3,(c[(c[v>>2]|0)+(j<<3)+4>>2]|0)+h|0)|0;d=c[v>>2]|0;f=(c[w>>2]|0)-d>>3;e=i;while(1){if(e>>>0>=f>>>0)break b;B=d+(e<<3)+4|0;c[B>>2]=(c[B>>2]|0)+1;e=e+1|0}}while(0);Gb(b,c[c[d+(j<<3)>>2]>>2]|0,3,h,(c[d+(j<<3)+4>>2]|0)+h|0,1)|0;$x(s,c[c[(c[v>>2]|0)+(j<<3)>>2]>>2]|0,0,0,250,1);B=a[m>>0]|0;if((B<<24>>24<0?c[n>>2]|0:B&255)|0)zb(b,0,0,250,s,1);$x(t,c[c[(c[v>>2]|0)+(j<<3)>>2]>>2]|0,0,0,159,1);B=a[o>>0]|0;if((B<<24>>24<0?c[p>>2]|0:B&255)|0?($x(u,b,0,0,159,1),B=a[q>>0]|0,B=((B<<24>>24<0?c[r>>2]|0:B&255)|0)==0,z5(u),B):0)zb(b,0,0,159,t,0);Mc(b,3,(c[(c[v>>2]|0)+(j<<3)+4>>2]|0)+h|0,382758,k,1);z5(t);z5(s);z5(k);h=h+1|0}}l=A;return}function Fh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;k=l;l=l+16|0;i=k;j=b+536|0;e=j;d=c[e>>2]|0;e=c[e+4>>2]|0;if(e>>>0<0|(e|0)==0&d>>>0<8)e1(b,d,e);else{g=b+544|0;e=c[g>>2]|0;h=b+612|0;d=c[h>>2]|0;f=e+d|0;o=h8(f)|0;m=z;n=_7()|0;a:do if(!((o|0)==(n|0)&(m|0)==(z|0))){m=V8(f)|0;o=z;n=f8(379781)|0;do if((m|0)==(n|0)&(o|0)==(z|0)){$x(i,b,0,0,273,1);o=a[i+8+3>>0]|0;o=((o<<24>>24<0?c[i+4>>2]|0:o&255)|0)==0;z5(i);if(o){RB(b,0,0,273,379790,-1,1,0);break a}else{e=c[g>>2]|0;d=c[h>>2]|0;break}}while(0);m=V8(e+d|0)|0;o=z;n=f8(379798)|0;do if((m|0)==(n|0)&(o|0)==(z|0)){$x(i,b,0,0,273,1);o=a[i+8+3>>0]|0;o=((o<<24>>24<0?c[i+4>>2]|0:o&255)|0)==0;z5(i);if(o){RB(b,0,0,273,379807,-1,1,0);break a}else{e=c[g>>2]|0;d=c[h>>2]|0;break}}while(0);d=e+d|0;e=V8(d)|0;f=z;o=f8(379818)|0;if((e|0)==(o|0)&(f|0)==(z|0)){c[b+996>>2]=0;break}o=f8(379827)|0;if((e|0)==(o|0)&(f|0)==(z|0)){o=t7(d+8|0)|0;m=j;n=c[m>>2]|0;m=z0(n|0,c[m+4>>2]|0,-12,-1)|0;i=z;RB(b,0,0,273,d+12|0,0>i>>>0|0==(i|0)&o>>>0>m>>>0?n+-12|0:o,1,0);break}o=f8(379836)|0;if((e|0)==(o|0)&(f|0)==(z|0)){o=t7(d+8|0)|0;m=j;n=c[m>>2]|0;m=z0(n|0,c[m+4>>2]|0,-12,-1)|0;i=z;RB(b,0,0,273,d+12|0,0>i>>>0|0==(i|0)&o>>>0>m>>>0?n+-12|0:o,1,0);break}d=D9(a[d>>0]|0)|0;if(((d&255)>=((Z9(65)|0)&255)?(d&255)<=((Z9(122)|0)&255):0)?($x(i,b,0,0,273,1),o=a[i+8+3>>0]|0,o=((o<<24>>24<0?c[i+4>>2]|0:o&255)|0)==0,z5(i),o):0)RB(b,0,0,273,(c[g>>2]|0)+(c[h>>2]|0)|0,c[j>>2]|0,1,0)}else RB(b,0,0,57,379665,-1,1,1);while(0);o=j;e1(b,c[o>>2]|0,c[o+4>>2]|0)}l=k;return}function Gh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;m=a+4|0;l=c[m>>2]|0;d=l&-8;i=a+d|0;if(!(l&3)){if(b>>>0<256){a=0;return a|0}if(d>>>0>=(b+4|0)>>>0?(d-b|0)>>>0<=c[102240]<<1>>>0:0)return a|0;a=0;return a|0}if(d>>>0>=b>>>0){d=d-b|0;if(d>>>0<=15)return a|0;k=a+b|0;c[m>>2]=l&1|b|2;c[k+4>>2]=d|3;m=k+d+4|0;c[m>>2]=c[m>>2]|1;ze(k,d);return a|0}if((i|0)==(c[102126]|0)){k=(c[102123]|0)+d|0;d=k-b|0;e=a+b|0;if(k>>>0<=b>>>0){a=0;return a|0}c[m>>2]=l&1|b|2;c[e+4>>2]=d|1;c[102126]=e;c[102123]=d;return a|0}if((i|0)==(c[102125]|0)){f=(c[102122]|0)+d|0;if(f>>>0<b>>>0){a=0;return a|0}d=f-b|0;e=l&1;if(d>>>0>15){l=a+b|0;k=l+d|0;c[m>>2]=e|b|2;c[l+4>>2]=d|1;c[k>>2]=d;e=k+4|0;c[e>>2]=c[e>>2]&-2;e=l}else{c[m>>2]=e|f|2;e=a+f+4|0;c[e>>2]=c[e>>2]|1;e=0;d=0}c[102122]=d;c[102125]=e;return a|0}e=c[i+4>>2]|0;if(e&2|0){a=0;return a|0}j=(e&-8)+d|0;if(j>>>0<b>>>0){a=0;return a|0}k=j-b|0;f=e>>>3;do if(e>>>0<256){e=c[i+8>>2]|0;d=c[i+12>>2]|0;if((d|0)==(e|0)){c[102120]=c[102120]&~(1<<f);break}else{c[e+12>>2]=d;c[d+8>>2]=e;break}}else{h=c[i+24>>2]|0;d=c[i+12>>2]|0;do if((d|0)==(i|0)){f=i+16|0;e=f+4|0;d=c[e>>2]|0;if(!d){d=c[f>>2]|0;if(!d){g=0;break}else g=f}else g=e;while(1){f=d+20|0;e=c[f>>2]|0;if(e|0){d=e;g=f;continue}e=d+16|0;f=c[e>>2]|0;if(!f)break;else{d=f;g=e}}c[g>>2]=0;g=d}else{g=c[i+8>>2]|0;c[g+12>>2]=d;c[d+8>>2]=g;g=d}while(0);if(h|0){d=c[i+28>>2]|0;e=408784+(d<<2)|0;f=(g|0)==0;if((i|0)==(c[e>>2]|0)){c[e>>2]=g;if(f){c[102121]=c[102121]&~(1<<d);break}}else{c[h+16+(((c[h+16>>2]|0)!=(i|0)&1)<<2)>>2]=g;if(f)break}c[g+24>>2]=h;d=i+16|0;e=c[d>>2]|0;if(e|0){c[g+16>>2]=e;c[e+24>>2]=g}d=c[d+4>>2]|0;if(d|0){c[g+20>>2]=d;c[d+24>>2]=g}}}while(0);d=l&1;if(k>>>0<16){c[m>>2]=d|j|2;m=a+j+4|0;c[m>>2]=c[m>>2]|1;return a|0}else{l=a+b|0;c[m>>2]=d|b|2;c[l+4>>2]=k|3;m=l+k+4|0;c[m>>2]=c[m>>2]|1;ze(l,k);return a|0}return 0}function Hh(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;q=b+4|0;h=d;m=g+4|0;n=g+8+3|0;do if((q|0)!=(d|0)?(i=d+16|0,j=a[d+24+3>>0]|0,o=j<<24>>24<0,i=o?c[i>>2]|0:i,j=o?c[d+20>>2]|0:j&255,o=a[n>>0]|0,p=o<<24>>24<0,o=p?c[m>>2]|0:o&255,p=p?c[g>>2]|0:g,k=j>>>0<o>>>0,s=L$(p,i,k?j:o)|0,l=o>>>0<j>>>0,(((s|0)==0?(l?-2147483648:0):s)|0)>=0):0){s=L$(i,p,l?o:j)|0;if((((s|0)==0?(k?-2147483648:0):s)|0)<0){j=1;i=h}else{c[e>>2]=h;c[f>>2]=h;d=f;break}while(1){if((j|0)<=0)break;f=i;i=c[f+4>>2]|0;a:do if(!i)while(1){i=c[f+8>>2]|0;if((c[i>>2]|0)==(f|0))break a;f=i}else while(1){f=c[i>>2]|0;if(!f)break;else i=f}while(0);j=j+-1|0}f=i;if((f|0)!=(q|0)?(m=i,s=m+16|0,q=a[m+24+3>>0]|0,n=q<<24>>24<0,q=n?c[m+20>>2]|0:q&255,s=L$(p,n?c[s>>2]|0:s,q>>>0<o>>>0?q:o)|0,(((s|0)==0?(o>>>0<q>>>0?-2147483648:0):s)|0)>=0):0){d=jo(b,e,g)|0;break}d=d+4|0;if(!(c[d>>2]|0)){c[e>>2]=h;break}else{c[e>>2]=f;d=f;break}}else r=3;while(0);do if((r|0)==3){f=c[d>>2]|0;if((c[b>>2]|0)!=(d|0)){if(!f){i=d;while(1){h=c[i+8>>2]|0;if((c[h>>2]|0)==(i|0))i=h;else break}}else{h=f;while(1){i=c[h+4>>2]|0;if(!i)break;else h=i}}p=h+16|0;r=a[n>>0]|0;s=r<<24>>24<0;r=s?c[m>>2]|0:r&255;q=a[h+24+3>>0]|0;o=q<<24>>24<0;q=o?c[h+20>>2]|0:q&255;s=L$(o?c[p>>2]|0:p,s?c[g>>2]|0:g,r>>>0<q>>>0?r:q)|0;if((((s|0)==0?(q>>>0<r>>>0?-2147483648:0):s)|0)>=0){d=jo(b,e,g)|0;break}}if(!f){c[e>>2]=d;break}else{d=h;c[e>>2]=d;d=d+4|0;break}}while(0);return d|0}function Ih(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+96|0;o=r+56|0;p=r+16|0;q=r;$x(o,b,d,e,f,2);n=a[o+8+3>>0]|0;n=((n<<24>>24<0?c[o+4>>2]|0:n&255)|0)==0;z5(o);a:do if(!n){n=(d|0)==2;do if(n&(f|0)==149){$x(o,b,2,e,147,1);$x(p,b,2,e,149,1);h=a[o+8+3>>0]|0;g=h<<24>>24<0;h=g?c[o+4>>2]|0:h&255;m=a[p+8+3>>0]|0;i=m<<24>>24<0;if((h|0)==((i?c[p+4>>2]|0:m&255)|0)){m=(L$(g?c[o>>2]|0:o,i?c[p>>2]|0:p,h)|0)==0;z5(p);z5(o);if(m)break a;else break}else{z5(p);z5(o);break}}while(0);m=f+1|0;Ed(b,d,e,m);mI(o);Xy(p,41840);z3(o,p);z5(p);$x(p,b,d,e,f,1);og(o,p);z5(p);mI(p);Xy(q,41840);z3(p,q);z5(q);i=o+4|0;j=p+4|0;k=p+8|0;h=0;while(1){g=c[o>>2]|0;if(h>>>0>=(((c[i>>2]|0)-g|0)/12|0)>>>0)break;ne(q,g+(h*12|0)|0,SU(vn(d)|0,f,2)|0,0);g=c[j>>2]|0;if(g>>>0<(c[k>>2]|0)>>>0){rV(g,q);c[j>>2]=(c[j>>2]|0)+12}else Dx(p,q);z5(q);h=h+1|0}if(n?((f|0)==139?((c[j>>2]|0)-(c[p>>2]|0)|0)==12:0):0){$x(q,b,2,e,134,1);g=q+8+3|0;f=a[g>>0]|0;h=q+4|0;if((f<<24>>24<0?c[h>>2]|0:f&255)|0){HX(c[p>>2]|0,39932)|0;f=a[g>>0]|0;n=f<<24>>24<0;Ex(c[p>>2]|0,n?c[q>>2]|0:q,n?c[h>>2]|0:f&255)|0;HX(c[p>>2]|0,7756)|0}z5(q)}de(q,p);zb(b,d,e,m,q,0);z5(q);$_(p);$_(o)}while(0);l=r;return}function Jh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0.0,i=0,j=0,k=0,m=0,n=0,o=0.0,p=0;p=l;l=l+32|0;m=p+12|0;d=p;n=b+536|0;if((c[n>>2]|0)==72&(c[n+4>>2]|0)==0){GC(b);Bc(b);J3(b)}n=b+528|0;g=n;g=z0(c[g>>2]|0,c[g+4>>2]|0,32,0)|0;c[n>>2]=g;c[n+4>>2]=z;TX(m);lh(m,c[(jF(b+760|0,b+772|0)|0)+16>>2]|0)|0;Kc(b,1,-1)|0;n=b+20|0;$x(d,b,1,c[n>>2]|0,171,1);o=+Cq(d);z5(d);zb(b,1,c[n>>2]|0,58,m,0);zb(b,1,c[n>>2]|0,63,m,0);d=i9(29556)|0;g=m+8+3|0;f=a[g>>0]|0;j=m+4|0;e=c[j>>2]|0;k=o==25.0;h=o;if((d|0)==((f<<24>>24<0?e:f&255)|0))if(!(VG(m,29556,d)|0))i=9;else{f=a[g>>0]|0;e=c[j>>2]|0;i=6}else i=6;do if((i|0)==6){d=i9(29576)|0;if((d|0)==((f<<24>>24<0?e:f&255)|0)){if(!(VG(m,29576,d)|0)){i=9;break}f=a[g>>0]|0;e=c[j>>2]|0}d=i9(29596)|0;if((d|0)==((f<<24>>24<0?e:f&255)|0)?(VG(m,29596,d)|0)==0:0){sM(b,1,c[n>>2]|0,130,1440,0);if(!k){if(o==30.0)sM(b,1,c[n>>2]|0,138,960,0)}else sM(b,1,c[n>>2]|0,138,1152,0);KW(b,1,c[n>>2]|0,156,1.3333333333333333,3,1)}}while(0);if((i|0)==9){sM(b,1,c[n>>2]|0,130,720,0);if(!k){if(h==29.97)sM(b,1,c[n>>2]|0,138,480,0)}else sM(b,1,c[n>>2]|0,138,576,0);KW(b,1,c[n>>2]|0,156,1.3333333333333333,3,1)}Kc(b,2,-1)|0;Rf(b,m,2,c[n>>2]|0,3);zb(b,2,c[n>>2]|0,52,m,0);zb(b,2,c[n>>2]|0,57,m,0);z5(m);l=p;return}function Kh(b,d,f){b=b|0;d=d|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=l;l=l+352|0;u=z+80|0;v=z+76|0;j=z;i=(FD(d)|0)+1|0;y=Oa()|0;h=l;l=l+((1*i|0)+15&-16)|0;i=FD(b)|0;g=d3(d,47)|0;if(!g){h=d;s=0}else{l9(h,d)|0;a[h+(g-d)>>0]=0;while(1)if((a[g>>0]|0)==47)g=g+1|0;else{s=g;break}}k=mF(h)|0;g=a[b>>0]|0;if(g<<24>>24==47)i=(a[b+1>>0]|0)==0?0:i;t=qP(g<<24>>24?b:404781)|0;g=c[12784]|0;a:do if(!t){switch(g|0){case 20:{g=0;break a}case 13:{if(((a[h>>0]|0)==0?(vX(b,j)|0)==0:0)?(c[j+12>>2]&61440|0)==16384:0){g=(IO(f,b,i,i)|0)!=0&1;break a}break}default:{}}g=(saa(g)|0)==0;g=g?0:2}else{if(!(a[h>>0]|0)){g=(IO(f,b,i,i)|0)!=0&1;p9(t);break}g=wL(t,u,v)|0;d=(g|0)!=0;j=c[v>>2]|0;b:do if((j|0)!=0&(d^1)){r=i+2|0;o=(k|0)==0;p=(s|0)!=0;q=i+1|0;c:while(1){m=j+8|0;k=r+(e[m>>1]|0)|0;n=Oa()|0;g=l;l=l+((1*k|0)+15&-16)|0;k=j+11|0;if(o){if(!(a9(h,k)|0))x=21}else if(!(xN(h,k)|0))x=21;d:do if((x|0)==21){x=0;e:do if(p?(w=a[j+10>>0]|0,w<<24>>24):0){d=(w&255)<<12&65535;if(d<<16>>16<16384)switch(d<<16>>16){case -24576:break e;default:break d}else switch(d<<16>>16){case 16384:break e;default:break d}}while(0);if(!(a[b>>0]|0))g=k;else{no(g|0,b|0,i|0)|0;j=g+i|0;a[j>>0]=47;l9(j+1|0,k)|0}if(p){g=Kh(g,s,f)|0;if(!g)break;else{x=28;break c}}else if(!(IO(f,g,q+(e[m>>1]|0)|0,0)|0))break;else{x=30;break c}}while(0);ta(n|0);g=wL(t,u,v)|0;d=(g|0)!=0;j=c[v>>2]|0;if(!((j|0)!=0&(d^1)))break b}if((x|0)==28)p9(t);else if((x|0)==30){p9(t);g=1}ta(n|0);break a}while(0);p9(t);if(d?saa(g)|0:0){g=2;break}g=0}while(0);ta(y|0);l=z;return g|0}function Lh(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;r=l;l=l+80|0;k=r+64|0;m=r+52|0;e=r+48|0;i=r+77|0;j=r+76|0;n=r+36|0;o=r+24|0;p=r+12|0;q=r;TX(k);TX(m);s3(b,e);bB(b,i);Ko(b,d[i>>0]|0,0,k);bB(b,j);Ko(b,d[j>>0]|0,0,m);if((qO(b)|0?(f=b+768|0,((a[f>>0]|0)+-78&255)<34):0)?a[b+788>>0]|0:0){TX(n);Tv(n,c[e>>2]|0)|0;h=SG(n)|0;i=b+760|0;j=$C((HD((c[i>>2]|0)+68|0,b+764|0)|0)+16|0,b+770|0)|0;g=UB(kC(j+88|0,f)|0,b+782|0)|0;b=h+8+3|0;e=a[b>>0]|0;f=h+4|0;nt(q,((e<<24>>24<0?c[f>>2]|0:e&255)|0)==0?n:h,58);e=a[k+8+3>>0]|0;s=e<<24>>24<0;Ex(q,s?c[k>>2]|0:k,s?c[k+4>>2]|0:e&255)|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];e=0;while(1){if((e|0)==3)break;c[q+(e<<2)>>2]=0;e=e+1|0}p2(o,p);vF(g+24|0,o)|0;z5(o);O0(p);O0(q);e=a[b>>0]|0;nt(q,((e<<24>>24<0?c[f>>2]|0:e&255)|0)==0?n:h,58);e=a[m+8+3>>0]|0;s=e<<24>>24<0;Ex(q,s?c[m>>2]|0:m,s?c[m+4>>2]|0:e&255)|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];e=0;while(1){if((e|0)==3)break;c[q+(e<<2)>>2]=0;e=e+1|0}p2(o,p);vF(g+36|0,o)|0;z5(o);O0(p);O0(q);a[j+100>>0]=1;a[(c[i>>2]|0)+121>>0]=1;z5(n)}z5(m);z5(k);l=r;return}function Mh(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;m=l;l=l+16|0;g=m;Bx(b);f=b+648|0;A6(c[f>>2]|0);A6(c[f>>2]|0);AT(b,b+829|0);A6(c[f>>2]|0);A6(c[f>>2]|0);A6(c[f>>2]|0);AT(b,g);d4(c[f>>2]|0,2);A6(c[f>>2]|0);A6(c[f>>2]|0);d4(c[f>>2]|0,2);a:do if(a[b+824>>0]|0){h=b+818|0;e=0;while(1){if((e&255)>=(d[h>>0]|0))break a;GC(b);d4(c[f>>2]|0,8);J3(b);e=e+1<<24>>24}}while(0);if(K6(c[f>>2]|0)|0){GC(b);A6(c[f>>2]|0);d4(c[f>>2]|0,12);d4(c[f>>2]|0,12);J3(b)}else A6(c[f>>2]|0);if(a[g>>0]|0)A6(c[f>>2]|0);if(K6(c[f>>2]|0)|0){GC(b);A6(c[f>>2]|0);d4(c[f>>2]|0,3);J3(b)}else A6(c[f>>2]|0);if(K6(c[f>>2]|0)|0){GC(b);A6(c[f>>2]|0);d4(c[f>>2]|0,3);J3(b)}else A6(c[f>>2]|0);KS(b);wK(b);e=b+544|0;f=b+528|0;g=b+612|0;k=f;i=b+536|0;h=c[i>>2]|0;i=c[i+4>>2]|0;j=c[k+4>>2]|0;k=c[k>>2]|0;while(1){if(!(j>>>0<i>>>0|(j|0)==(i|0)&k>>>0<h>>>0))break;if(a[(c[e>>2]|0)+((c[g>>2]|0)+k)>>0]|0)break;n=z0(k|0,j|0,1,0)|0;o=z;p=f;c[p>>2]=n;c[p+4>>2]=o;j=o;k=n}if((k|0)==(h|0)&(j|0)==(i|0)){if(qO(b)|0?(HM(b)|0,s_(b),AR(b,13,0),a[(c[b+832>>2]|0)+39>>0]=1,a[b+889>>0]=1,(c[b+728>>2]&1|0)==0):0)W5(b)}else t4(b);l=m;return}function Nh(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;a:do if(!(d8(b,c[d+8>>2]|0)|0)){i=b+12|0;q=d+24|0;r=d+36|0;s=d+54|0;o=b+8|0;m=b+16|0;if(!(d8(b,c[d>>2]|0)|0)){p=c[i>>2]|0;j=b+16+(p<<3)|0;qM(m,d,e,f,g);h=b+24|0;if((p|0)<=1)break;i=c[o>>2]|0;if((i&2|0)==0?(c[r>>2]|0)!=1:0){if(!(i&1))while(1){if(a[s>>0]|0)break a;if((c[r>>2]|0)==1)break a;qM(h,d,e,f,g);h=h+8|0;if(h>>>0>=j>>>0)break a}while(1){if(a[s>>0]|0)break a;if((c[r>>2]|0)==1?(c[q>>2]|0)==1:0)break a;qM(h,d,e,f,g);h=h+8|0;if(h>>>0>=j>>>0)break a}}while(1){if(a[s>>0]|0)break a;qM(h,d,e,f,g);h=h+8|0;if(h>>>0>=j>>>0)break a}}h=d+32|0;if((c[d+16>>2]|0)!=(e|0)?(p=d+20|0,(c[p>>2]|0)!=(e|0)):0){c[h>>2]=f;n=d+44|0;if((c[n>>2]|0)==4)break;f=b+16+(c[i>>2]<<3)|0;k=d+52|0;l=d+53|0;h=0;b=m;j=0;b:while(1){if(b>>>0>=f>>>0){i=18;break}a[k>>0]=0;a[l>>0]=0;YK(b,d,e,e,1,g);if(a[s>>0]|0){i=18;break}do if(a[l>>0]|0){if(!(a[k>>0]|0))if(!(c[o>>2]&1)){h=1;i=18;break b}else{h=1;i=j;break}if((c[q>>2]|0)==1){i=23;break b}if(!(c[o>>2]&2)){i=23;break b}else{h=1;i=1}}else i=j;while(0);b=b+8|0;j=i}do if((i|0)==18){if((!j?(c[p>>2]=e,e=d+40|0,c[e>>2]=(c[e>>2]|0)+1,(c[r>>2]|0)==1):0)?(c[q>>2]|0)==2:0){a[s>>0]=1;if(h){i=23;break}else{h=4;break}}if(h)i=23;else h=4}while(0);if((i|0)==23)h=3;c[n>>2]=h;break}if((f|0)==1)c[h>>2]=1}else TV(d,e,f);while(0);return}function Oh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;l=b+772|0;a:do if(!(c[l>>2]|0)){n=b+544|0;d=c[n>>2]|0;o=b+612|0;e=c[o>>2]|0;g=d+e|0;m=b+548|0;p=b+376|0;h=d;do if((a[g>>0]|0)==11?(a[d+(e+1)>>0]|0)==119:0){f=D9(a[g+5>>0]|0)|0;a[b+1183>>0]=(f&255)>>>3;if((f&255)<80){f=D9(a[g+4>>0]|0)|0;f=MT(f&63,(f&255)>>>6)|0}else{if((f+-88&255)>=48)break;f=g+2|0;f=((d7(a[f>>0]|0,a[f+1>>0]|0)|0)<<1&4094)+2<<16>>16}g=f&65535;if((f&65535)>5){if((e+g|0)>>>0>(c[m>>2]|0)>>>0){d=0;break a}if(Rc(b,g)|0){a[p>>0]=1;d=1;break a}else{h=c[n>>2]|0;d=h;e=c[o>>2]|0;break}}}while(0);f=d+e|0;do if((a[f>>0]|0)==119?(a[d+(e+1)>>0]|0)==11:0){g=D9(a[f+4>>0]|0)|0;a[b+1183>>0]=(g&255)>>>3;if((g&255)<80){f=D9(a[f+5>>0]|0)|0;f=MT(f&63,(f&255)>>>6)|0}else{if((g+-88&255)>=48)break;f=f+2|0;f=((a5(a[f>>0]|0,a[f+1>>0]|0)|0)<<1&4094)+2<<16>>16}k=f&65535;if((f&65535)>5){d=c[m>>2]|0;if((e+k|0)>>>0>d>>>0){d=0;break a}c[l>>2]=h;i=b+776|0;c[i>>2]=e;j=b+780|0;c[j>>2]=d;f=h;g=iaa(k)|0;d=0;while(1){h=d|1;if(h>>>0>=k>>>0)break;q=d+e|0;a[g+h>>0]=a[f+q>>0]|0;a[g+d>>0]=a[f+(q+1)>>0]|0;d=d+2|0}c[n>>2]=g;c[o>>2]=0;c[m>>2]=k;q=Rc(b,k)|0;a[p>>0]=q&1;if(q){a[b+1569>>0]=0;d=c[n>>2]|0;c[n>>2]=c[l>>2];c[l>>2]=d;d=c[o>>2]|0;c[o>>2]=c[i>>2];c[i>>2]=d;d=c[m>>2]|0;c[m>>2]=c[j>>2];c[j>>2]=d;d=1;break a}else{jaa(g);d=c[l>>2]|0;c[n>>2]=d;c[l>>2]=0;e=c[i>>2]|0;c[o>>2]=e;c[m>>2]=c[j>>2];break}}}while(0);do if(!(a[b+1484>>0]|0)){if((((a[d+(e+4)>>0]|0)==-8?(a[d+(e+5)>>0]|0)==114:0)?(a[d+(e+6)>>0]|0)==111:0)?(a[d+(e+7)>>0]&-2)<<24>>24==-70:0)break;a[p>>0]=0;d=1;break a}while(0);a[b+1490>>0]=1;a[p>>0]=1;d=1}else d=1;while(0);return d|0}function Ph(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;i=l;l=l+32|0;h=i;g=ef(a,b,d,f)|0;if(tb[c[f>>2]&31](e,d)|0){c[h>>2]=c[d>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];c[h+24>>2]=c[d+24>>2];c[h+28>>2]=c[d+28>>2];c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];c[d+28>>2]=c[e+28>>2];c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[e+16>>2]=c[h+16>>2];c[e+20>>2]=c[h+20>>2];c[e+24>>2]=c[h+24>>2];c[e+28>>2]=c[h+28>>2];e=g+1|0;if(tb[c[f>>2]&31](d,b)|0){c[h>>2]=c[b>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[h+16>>2]=c[b+16>>2];c[h+20>>2]=c[b+20>>2];c[h+24>>2]=c[b+24>>2];c[h+28>>2]=c[b+28>>2];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];c[d>>2]=c[h>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];c[d+16>>2]=c[h+16>>2];c[d+20>>2]=c[h+20>>2];c[d+24>>2]=c[h+24>>2];c[d+28>>2]=c[h+28>>2];if(tb[c[f>>2]&31](b,a)|0){c[h>>2]=c[a>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[h+16>>2]=c[a+16>>2];c[h+20>>2]=c[a+20>>2];c[h+24>>2]=c[a+24>>2];c[h+28>>2]=c[a+28>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];c[b>>2]=c[h>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];c[b+16>>2]=c[h+16>>2];c[b+20>>2]=c[h+20>>2];c[b+24>>2]=c[h+24>>2];c[b+28>>2]=c[h+28>>2];g=g+3|0}else g=g+2|0}else g=e}l=i;return g|0}function Qh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+128|0;i=r+108|0;j=r+96|0;k=r+84|0;m=r+72|0;n=r+60|0;o=r+48|0;p=r+36|0;q=r+24|0;g=r+12|0;h=r;e=d>>>16&255;sU(q,e,16);DW(q,0,e>>>0<10?42196:409096)|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];e=0;while(1){if((e|0)==3)break;c[q+(e<<2)>>2]=0;e=e+1|0}HX(p,42204)|0;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];e=0;while(1){if((e|0)==3)break;c[p+(e<<2)>>2]=0;e=e+1|0}f=d>>>8&255;HX(o,f>>>0<10?42196:409096)|0;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];e=0;while(1){if((e|0)==3)break;c[o+(e<<2)>>2]=0;e=e+1|0}sU(g,f,16);e=a[g+8+3>>0]|0;f=e<<24>>24<0;Ex(n,f?c[g>>2]|0:g,f?c[g+4>>2]|0:e&255)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];e=0;while(1){if((e|0)==3)break;c[n+(e<<2)>>2]=0;e=e+1|0}HX(m,42204)|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];e=0;while(1){if((e|0)==3)break;c[m+(e<<2)>>2]=0;e=e+1|0}f=d&255;HX(k,f>>>0<10?42196:409096)|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];e=0;while(1){if((e|0)==3)break;c[k+(e<<2)>>2]=0;e=e+1|0}sU(h,f,16);e=a[h+8+3>>0]|0;d=e<<24>>24<0;Ex(j,d?c[h>>2]|0:h,d?c[h+4>>2]|0:e&255)|0;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];e=0;while(1){if((e|0)==3)break;c[j+(e<<2)>>2]=0;e=e+1|0}p2(b,i);O0(i);z5(h);O0(j);O0(k);O0(m);z5(g);O0(n);O0(o);O0(p);z5(q);l=r;return}function Rh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=l;l=l+16|0;m=u;n=b+780|0;o=b+760|0;p=b+761|0;q=b+492|0;d=c[b+776>>2]|0;a:while(1){if((d|0)==(n|0))break;k=d+16|0;f=d+24|0;e=c[f>>2]|0;do if(e|0){jt(e);Cp(b,c[f>>2]|0)|0;Gb(b,c[f>>2]|0,0,0,0,1)|0;e=c[(c[f>>2]|0)+760>>2]|0;i=d+28|0;c[i>>2]=e;e=(RA(b,e,-1)|0)+-1|0;j=d+32|0;c[j>>2]=e;h=d+48|0;if((a[o>>0]|0)==0?(a[p>>0]|0)==0:0){v=(c[f>>2]|0)+768|0;f=c[v+4>>2]|0;g=h;c[g>>2]=c[v>>2];c[g+4>>2]=f}if((c[i>>2]|0)==2?(v=h,(c[v>>2]|0)==0&(c[v+4>>2]|0)==0):0){$x(m,b,2,e,135,1);g=rm(m)|0;v=h;c[v>>2]=g;c[v+4>>2]=z;z5(m)}if(!(a[q>>0]|0)){g=d+40|0;f=c[g>>2]|0;g=c[g+4>>2]|0;if(!((f|0)==0&(g|0)==0)?(s=h,r=c[s>>2]|0,s=c[s+4>>2]|0,!((r|0)==0&(s|0)==0)):0){e=c[i>>2]|0;if((e|0)==2){e=c[j>>2]|0;h=Rb(2,22)|0;v=cT((+(f>>>0)+4294967296.0*+(g>>>0))*1.0e3/(+(r>>>0)+4294967296.0*+(s>>>0)))|0;jL(b,2,e,h,v,z,1);if(!(a[q>>0]|0))t=15;else break}}else t=15;if((t|0)==15){t=0;e=c[i>>2]|0}if((e|0)==7){c[i>>2]=0;c[j>>2]=0;e=0;f=0}else f=c[j>>2]|0;v=k;oK(b,e,f,10,c[v>>2]|0,c[v+4>>2]|0,10,0);i=c[i>>2]|0;v=c[j>>2]|0;Jz(m,k);zb(b,i,v,11,m,1);z5(m)}}while(0);e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue a}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}RB(b,0,0,57,378904,-1,1,1);if((RA(b,1,-1)|0)==0?(RA(b,5,-1)|0)==0:0)RB(b,0,0,69,378908,-1,1,1);l=u;return}function Sh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;j=l;l=l+16|0;i=j;f=b+8|0;h=f;m=c[h>>2]|0;h=c[h+4>>2]|0;g=a+8|0;k=g;k=M$(m,h,c[k>>2]|0,c[k+4>>2]|0)|0;e=d+8|0;n=e;h=M$(c[n>>2]|0,c[n+4>>2]|0,m,h)|0;do if(k){if(h){c[i>>2]=c[a>>2];c[i+4>>2]=c[a+4>>2];c[i+8>>2]=c[a+8>>2];c[i+12>>2]=c[a+12>>2];c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d>>2]=c[i>>2];c[d+4>>2]=c[i+4>>2];c[d+8>>2]=c[i+8>>2];c[d+12>>2]=c[i+12>>2];e=1;break}c[i>>2]=c[a>>2];c[i+4>>2]=c[a+4>>2];c[i+8>>2]=c[a+8>>2];c[i+12>>2]=c[a+12>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b>>2]=c[i>>2];c[b+4>>2]=c[i+4>>2];c[b+8>>2]=c[i+8>>2];c[b+12>>2]=c[i+12>>2];m=e;n=f;if(M$(c[m>>2]|0,c[m+4>>2]|0,c[n>>2]|0,c[n+4>>2]|0)|0){c[i>>2]=c[b>>2];c[i+4>>2]=c[b+4>>2];c[i+8>>2]=c[b+8>>2];c[i+12>>2]=c[b+12>>2];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d>>2]=c[i>>2];c[d+4>>2]=c[i+4>>2];c[d+8>>2]=c[i+8>>2];c[d+12>>2]=c[i+12>>2];e=2}else e=1}else if(h){c[i>>2]=c[b>>2];c[i+4>>2]=c[b+4>>2];c[i+8>>2]=c[b+8>>2];c[i+12>>2]=c[b+12>>2];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d>>2]=c[i>>2];c[d+4>>2]=c[i+4>>2];c[d+8>>2]=c[i+8>>2];c[d+12>>2]=c[i+12>>2];m=f;n=g;if(M$(c[m>>2]|0,c[m+4>>2]|0,c[n>>2]|0,c[n+4>>2]|0)|0){c[i>>2]=c[a>>2];c[i+4>>2]=c[a+4>>2];c[i+8>>2]=c[a+8>>2];c[i+12>>2]=c[a+12>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b>>2]=c[i>>2];c[b+4>>2]=c[i+4>>2];c[b+8>>2]=c[i+8>>2];c[b+12>>2]=c[i+12>>2];e=2}else e=1}else e=0;while(0);l=j;return e|0}function Th(a){a=a|0;var b=0;a:do if((a|0)>=39){if((a|0)>=65539)do switch(a|0){case 65539:{a=377237;break a}case 65540:{a=377226;break a}case 65541:{a=377215;break a}case 65542:{a=377204;break a}case 65543:{a=377193;break a}case 65544:{a=377182;break a}case 65545:{a=377171;break a}case 65546:{a=377159;break a}case 65547:{a=377147;break a}case 65548:{a=377135;break a}case 65549:{a=377123;break a}case 65550:{a=377111;break a}case 65551:{a=377099;break a}default:{b=50;break a}}while(0);if((a|0)<205)switch(a|0){case 39:{a=377289;break a}case 200:{a=377287;break a}case 201:{a=377281;break a}case 202:{a=381128;break a}case 203:{a=377285;break a}case 204:{a=377283;break a}default:{b=50;break a}}if((a|0)<65536)switch(a|0){case 205:{a=381224;break a}case 206:{a=377281;break a}case 207:{a=381128;break a}default:{b=50;break a}}else switch(a|0){case 65536:{a=377270;break a}case 65537:{a=377259;break a}case 65538:{a=377248;break a}default:{b=50;break a}}}else do switch(a|0){case 1:{a=402219;break a}case 2:{a=377075;break a}case 3:{a=402006;break a}case 4:{a=377071;break a}case 5:{a=377068;break a}case 6:{a=377065;break a}case 7:{a=377337;break a}case 8:{a=377334;break a}case 9:{a=377062;break a}case 10:{a=377058;break a}case 11:{a=377054;break a}case 12:{a=377330;break a}case 13:{a=377326;break a}case 14:{a=377322;break a}case 15:{a=377318;break a}case 16:{a=377314;break a}case 17:{a=377314;break a}case 18:{a=377314;break a}case 33:{a=377310;break a}case 34:{a=377306;break a}case 35:{a=377303;break a}case 36:{a=377300;break a}case 37:{a=377295;break a}case 38:{a=377292;break a}default:{b=50;break a}}while(0);while(0);if((b|0)==50)a=384483;return a|0}function Uh(a){a=a|0;var b=0;a:do if(a<<16>>16<5922)do switch(a<<16>>16){case 256:{a=390971;break a}case 5890:{b=12;break a}case 257:{a=390961;break a}case 1124:{a=390953;break a}case 1280:{a=390930;break a}case 1574:case 1570:case 1544:case 1542:case 1540:case 1538:{a=390923;break a}case 1792:{a=390910;break a}case 2401:case 2400:case 2329:case 2321:{a=390891;break a}case 2816:{a=390876;break a}case 3360:case 3335:case 3333:case 3331:case 3330:case 3328:{a=390864;break a}case 3584:{a=390856;break a}case 4096:{a=390822;break a}case 5904:{a=390783;break a}default:{b=32;break a}}while(0);else{b:do if(a<<16>>16<19041){if(a<<16>>16<8944){switch(a<<16>>16){case 5986:case 5922:{b=12;break a}case 6192:case 6160:case 6145:case 6144:break;default:{b=32;break a}}a=390771;break a}if(a<<16>>16>=18688)switch(a<<16>>16){case 19040:break b;case 18688:{a=390733;break a}case 18960:{a=390725;break a}case 18976:{a=390714;break a}default:{b=32;break a}}if(a<<16>>16<9728){switch(a<<16>>16){case 8944:break;default:{b=32;break a}}a=390761;break a}if(a<<16>>16<18432){switch(a<<16>>16){case 9728:break;default:{b=32;break a}}a=390756;break a}else{switch(a<<16>>16){case 18432:break;default:{b=32;break a}}a=390745;break a}}else do switch(a<<16>>16){case 19043:case 19041:break b;case 19056:{a=390663;break a}case 19072:{a=390651;break a}case 19105:{a=390644;break a}case 19135:{a=390635;break a}case 19153:case 19152:{a=390627;break a}case 19156:{a=390617;break a}case 19168:{a=390607;break a}case 19219:{a=390597;break a}case 21760:{a=390576;break a}case 21761:{a=390568;break a}default:{b=32;break a}}while(0);while(0);a=390674}while(0);if((b|0)==12)a=390795;else if((b|0)==32)a=390558;return a|0}function Vh(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;B=l;l=l+32|0;f=B+14|0;g=B+18|0;w=B+12|0;x=B+17|0;y=B+16|0;z=B;a[d+789>>0]=2;Bx(d);n=d+648|0;A6(c[n>>2]|0);AT(d,g);A6(c[n>>2]|0);d4(c[n>>2]|0,5);d4(c[n>>2]|0,7);KS(d);wK(d);A=d+770|0;NB(d,A);if(b[A>>1]|0)Ao(d);NB(d,f);o=d+528|0;p=d+536|0;q=d+764|0;r=z+11|0;s=z+8|0;t=z+4|0;u=d+780|0;v=d+793|0;m=e[f>>1]|0;k=(a[g>>0]|0)==0;f=0;while(1){i=o;g=c[i+4>>2]|0;j=p;h=c[j+4>>2]|0;if(!(g>>>0<h>>>0|((g|0)==(h|0)?(c[i>>2]|0)>>>0<(c[j>>2]|0)>>>0:0))){f=19;break}g=f&65535;if(g>>>0>=m>>>0){f=19;break}GC(d);bB(d,x);bB(d,y);NB(d,w);h=b[w>>1]|0;b[A>>1]=h;i=a[y>>0]|0;if(i<<24>>24==-3&k){d4(c[n>>2]|0,8);d4(c[n>>2]|0,8);KS(d);d4(c[n>>2]|0,7);f=b[A>>1]|0;if((f&65535)>2){f=(f&65535)+65533&65535;b[A>>1]=f}}else f=h;if(f<<16>>16){b[u>>1]=i&255;a[v>>0]=1;Ao(d)}J3(d);f=g+4+(h&65535)|0;if(qO(d)|0){j=a[x>>0]|0;h=c[(c[(c[q>>2]|0)+80>>2]|0)+((i&255)<<2)>>2]|0;a[h+168>>0]=j;c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;i=j9(390999)|0;if(i>>>0>4294967279){f=13;break}if(i>>>0<11){a[r>>0]=i;g=z}else{C=i+16&-16;g=ZW(C)|0;c[z>>2]=g;c[s>>2]=C|-2147483648;c[t>>2]=i}i1(g,390999,i)|0;J7(g+i|0,0);Ck(VC(h+28|0,z)|0,j,10)|0;a1(z)}}if((f|0)==13)uaa();else if((f|0)==19){l=B;return}}function Wh(b,d,e,f,g,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;i=+i;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;D=l;l=l+992|0;m=D+8|0;C=D;j=D+880|0;n=D+872|0;k=D+472|0;v=D+876|0;r=D+468|0;s=D+464|0;z=D+452|0;A=D+440|0;B=D+428|0;p=D+424|0;q=D+24|0;t=D+20|0;u=D+16|0;c[n>>2]=j;h[C>>3]=i;b=EY(j,0,0,C)|0;if(b>>>0>99){k=b0()|0;h[m>>3]=i;k=wS(n,k,403481,m)|0;b=c[n>>2]|0;if(!b)uaa();j=Ub(k<<2)|0;if(!j)uaa();else{w=j;y=k;F=j;G=b;o=b}}else{w=k;y=b;F=0;G=0;o=j}O4(C,f);j=c[C>>2]|0;m=u$(j,409148)|0;rb[c[(c[m>>2]|0)+48>>2]&7](m,o,o+y|0,w)|0;if(!y)k=0;else k=(a[o>>0]|0)==45;c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[z+(b<<2)>>2]=0;b=b+1|0}c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[A+(b<<2)>>2]=0;b=b+1|0}c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[B+(b<<2)>>2]=0;b=b+1|0}je(e,k,j,v,r,s,z,A,B,p);j=c[p>>2]|0;p=(y|0)>(j|0);b=a[A+8+3>>0]|0;e=a[B+8+3>>0]|0;b=b<<24>>24<0?c[A+4>>2]|0:b&255;e=e<<24>>24<0?c[B+4>>2]|0:e&255;b=(p?1:2)+j+(p?b:e)+(p?e+(y-j<<1)|0:b)|0;if(b>>>0>100){b=Ub(b<<2)|0;if(!b)uaa();else{x=b;E=b}}else{x=q;E=0}Hf(x,t,u,c[f+4>>2]|0,w,w+(y<<2)|0,m,k,v,c[r>>2]|0,c[s>>2]|0,z,A,B,j);b=bn(c[d>>2]|0,x,c[t>>2]|0,c[u>>2]|0,f,g)|0;if(E|0)pe(E);O0(B);O0(A);a1(z);c6(C);if(F|0)pe(F);if(G|0)pe(G);l=D;return b|0}function Xh(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0.0,k=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,E=0;B=l;l=l+256|0;u=B+192|0;y=B+128|0;v=B+64|0;z=B;o=a[370255+((e&255)+-1)>>0]|0;r=+(g&255);k=+(f&255);n=r/k>2.2449;t=n?(f&255)<<1&255:g;x=((_X(0,o,f,t)|0)&255)<<1;p=x&255;A=x&254;s=A+-1|0;if(s>>>0>62)e=0;else{j=+(t&255);m=+D(+(j/k),+(1.0/+(p&255)));h=0;i=~~(k+.5);while(1){e=h&255;if(e>>>0>=A>>>0)break;C=m*k;E=~~(C+.5);a[u+e>>0]=(E&255)-(i&255);h=h+1<<24>>24;i=E;k=C}Nl(u,A);a[y>>0]=f;e=1;while(1){h=e&255;if(h>>>0>A>>>0){q=9;break}i=h+-1|0;f=a[u+i>>0]|0;if(!(f<<24>>24)){e=0;break}a[y+h>>0]=(d[y+i>>0]|0)+(f&255);e=e+1<<24>>24}do if((q|0)==9){if(!n){e=0;while(1){h=e&255;if(h>>>0>A>>>0)break;a[c+h>>0]=a[y+h>>0]|0;e=e+1<<24>>24}a[b>>0]=p;e=1;break}e=v;h=e+64|0;do{a[e>>0]=0;e=e+1|0}while((e|0)<(h|0));n=((_X(1,o,t,g)|0)&255)<<1;e=n&255;n=n&254;a:do if((n|0)!=0?(w=n+A|0,w>>>0<=63):0){k=+D(+(r/j),+(1.0/+(e&255)));h=0;i=~~(j+.5);while(1){e=h&255;if(e>>>0>=n>>>0)break;C=k*j;E=~~(C+.5);a[v+e>>0]=(E&255)-(i&255);h=h+1<<24>>24;i=E;j=C}e=u+s|0;if((d[v>>0]|0)<(d[e>>0]|0)){Nl(v,n|1);u=a[e>>0]|0;s=d[v>>0]|0;a[v>>0]=u;E=v+(n+-1)|0;a[E>>0]=s-(u&255)+(d[E>>0]|0)}Nl(v,n);a[z>>0]=t;e=1;while(1){h=e&255;if(h>>>0>n>>>0)break;i=h+-1|0;f=a[v+i>>0]|0;if(!(f<<24>>24)){e=0;break a}a[z+h>>0]=(d[z+i>>0]|0)+(f&255);e=e+1<<24>>24}a[b>>0]=w;e=0;while(1){h=e&255;if(h>>>0>A>>>0)break;a[c+h>>0]=a[y+h>>0]|0;e=e+1<<24>>24}e=(x|1)&255;while(1){h=e&255;if((e&255)>(d[b>>0]|0)){e=1;break a}a[c+h>>0]=a[z+(h-A)>>0]|0;e=e+1<<24>>24}}else e=0;while(0)}while(0)}l=B;return e|0}function Yh(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;o=l;l=l+16|0;f=o;p=o+6|0;g=o+4|0;h=o+13|0;i=o+12|0;j=o+11|0;k=o+10|0;m=o+9|0;n=o+8|0;b[g>>1]=1;a[h>>0]=0;a[i>>0]=0;a[j>>0]=0;a[k>>0]=0;a[m>>0]=0;a[n>>0]=0;HB(e,p);if((b[p>>1]|0)==1){HB(e,g);bD(e,f);p=e+528|0;q=p;q=z0(c[q>>2]|0,c[q+4>>2]|0,8,0)|0;r=p;c[r>>2]=q;c[r+4>>2]=z;bB(e,h);bB(e,i);bB(e,j);r=p;r=z0(c[r>>2]|0,c[r+4>>2]|0,1,0)|0;q=p;c[q>>2]=r;c[q+4>>2]=z;bB(e,k);bB(e,m);bB(e,n);q=p;q=z0(c[q>>2]|0,c[q+4>>2]|0,1,0)|0;c[p>>2]=q;c[p+4>>2]=z;if(qO(e)|0){r=((d[i>>0]|0)*75|0)+((d[j>>0]|0)*4500|0)+(d[h>>0]|0)|0;q=((d[m>>0]|0)*75|0)+((d[n>>0]|0)*4500|0)+(d[k>>0]|0)|0;kL(e,0,0,187,b[g>>1]|0,10,0);RB(e,0,0,57,379675,-1,1,0);RB(e,0,0,59,379680,-1,1,0);lL(e,0,0,14,c[f>>2]|0,10,0);p=e+40|0;p=z0(c[p>>2]|0,c[p+4>>2]|0,q*2352|0,0)|0;oK(e,0,0,86,p,z,10,1);Kc(e,2,-1)|0;RB(e,2,0,18,391465,-1,1,0);RB(e,2,0,37,379711,-1,1,0);sM(e,2,0,147,16,0);sM(e,2,0,122,2,0);sM(e,2,0,135,44100,0);Bt(e,2,0,139,75.0,3,0);sM(e,2,0,112,1411200,0);RB(e,2,0,153,379718,-1,1,0);lL(e,2,0,143,q,10,0);sM(e,2,0,68,r6(+(q>>>0)*1.0e3/75.0)|0,0);sM(e,2,0,156,r6(+(r>>>0)*1.0e3/75.0)|0,0);V5(e)}}else{r=e+536|0;r=z0(c[r>>2]|0,c[r+4>>2]|0,-2,-1)|0;e1(e,r,z)}l=o;return}function Zh(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;x=l;l=l+32|0;o=x+26|0;p=x+12|0;q=x+24|0;r=x;Bx(b);j=b+648|0;d4(c[j>>2]|0,3);d4(c[j>>2]|0,13);wK(b);bB(b,o);s=b+528|0;t=b+760|0;u=r+11|0;v=r+11|0;w=r+8|0;k=r+4|0;m=r+8|0;n=r+4|0;o=a[o>>0]|0;i=0;while(1){if((i&255)>=(o&255)){d=3;break}GC(b);TX(p);g=s;g=z0(c[g>>2]|0,c[g+4>>2]|0,1,0)|0;h=s;c[h>>2]=g;c[h+4>>2]=z;Bx(b);d4(c[j>>2]|0,3);sR(b,13,q);wK(b);jZ(b,3,0,p);J3(b);h=e[q>>1]|0;g=c[t>>2]|0;d=c[g+80>>2]|0;if(h>>>0<(c[g+84>>2]|0)-d>>2>>>0){f=c[d+(h<<2)>>2]|0;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;g=j9(384512)|0;if(g>>>0>4294967279){d=6;break}if(g>>>0<11){a[u>>0]=g;d=r}else{y=g+16&-16;d=ZW(y)|0;c[r>>2]=d;c[m>>2]=y|-2147483648;c[n>>2]=g}i1(d,384512,g)|0;J7(d+g|0,0);g=VC(f+28|0,r)|0;y=a[g+8+3>>0]|0;y=((y<<24>>24<0?c[g+4>>2]|0:y&255)|0)==0;a1(r);if(y){f=c[(c[(c[t>>2]|0)+80>>2]|0)+(h<<2)>>2]|0;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;g=j9(384512)|0;if(g>>>0>4294967279){d=12;break}if(g>>>0<11){a[v>>0]=g;d=r}else{y=g+16&-16;d=ZW(y)|0;c[r>>2]=d;c[w>>2]=y|-2147483648;c[k>>2]=g}i1(d,384512,g)|0;J7(d+g|0,0);k1(VC(f+28|0,r)|0,p)|0;a1(r)}}z5(p);i=i+1<<24>>24}if((d|0)==3){l=x;return}else if((d|0)==6)uaa();else if((d|0)==12)uaa()}function _h(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+64|0;h=m+36|0;i=m+24|0;f=m+50|0;e=m+49|0;g=m+48|0;j=m+12|0;k=m;TX(h);TX(i);bB(b,f);bB(b,e);Ko(b,d[e>>0]|0,0,h);bB(b,g);Ko(b,d[g>>0]|0,0,i);if(qO(b)|0?a[b+785>>0]|0:0){g=($C((HD((c[b+760>>2]|0)+68|0,b+770|0)|0)+16|0,b+774|0)|0)+4|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;e=j9(391021)|0;if(e>>>0>4294967279)uaa();if(e>>>0<11){a[j+11>>0]=e;b=j}else{n=e+16&-16;b=ZW(n)|0;c[j>>2]=b;c[j+8>>2]=n|-2147483648;c[j+4>>2]=e}i1(b,391021,e)|0;J7(b+e|0,0);k1(VC(g,j)|0,i)|0;a1(j);c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;e=j9(385621)|0;if(e>>>0>4294967279)uaa();if(e>>>0<11){a[j+11>>0]=e;b=j}else{n=e+16&-16;b=ZW(n)|0;c[j>>2]=b;c[j+8>>2]=n|-2147483648;c[j+4>>2]=e}i1(b,385621,e)|0;J7(b+e|0,0);k1(VC(g,j)|0,h)|0;a1(j);VU(j,St(a[f>>0]|0)|0);c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;e=j9(391048)|0;if(e>>>0>4294967279)uaa();if(e>>>0<11){a[k+11>>0]=e;b=k}else{n=e+16&-16;b=ZW(n)|0;c[k>>2]=b;c[k+8>>2]=n|-2147483648;c[k+4>>2]=e}i1(b,391048,e)|0;J7(b+e|0,0);vF(VC(g,k)|0,j)|0;a1(k);z5(j)}z5(i);z5(h);l=m;return}function $h(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0;x=l;l=l+64|0;g=x+44|0;h=x+54|0;i=x+53|0;s=x+52|0;t=x+51|0;u=x+50|0;v=x+49|0;w=x+32|0;o=x+28|0;p=x+24|0;q=x+48|0;r=x;n3(b,g);xR(b,4,h);xR(b,4,i);f=c[g>>2]|0;if(f>>>0>31){t4(b);c[g>>2]=0;f=0}c[w>>2]=0;n=w+4|0;c[n>>2]=0;c[w+8>>2]=0;wA(w,f+1|0);m=w+8|0;k=(d[h>>0]|0)+6|0;j=(d[i>>0]|0)+4|0;i=0;while(1){if((i&255)>>>0>f>>>0)break;GC(b);n3(b,o);g=c[o>>2]|0;n3(b,p);h=c[p>>2]|0;AT(b,q);J3(b);if(qO(b)|0){y=+((h+1|0)>>>0)*+eaa(j);h=+B(y)>=1.0?(y>0.0?~~+P(+A(y/4294967296.0),4294967295.0)>>>0:~~+N((y-+(~~y>>>0))/4294967296.0)>>>0):0;z=+((g+1|0)>>>0)*+eaa(k);g=+B(z)>=1.0?(z>0.0?~~+P(+A(z/4294967296.0),4294967295.0)>>>0:~~+N((z-+(~~z>>>0))/4294967296.0)>>>0):0;yR(r,~~z>>>0,g,~~y>>>0,h,(a[q>>0]|0)!=0);g=c[n>>2]|0;if(g>>>0<(c[m>>2]|0)>>>0){c[g>>2]=c[r>>2];c[g+4>>2]=c[r+4>>2];c[g+8>>2]=c[r+8>>2];c[g+12>>2]=c[r+12>>2];c[g+16>>2]=c[r+16>>2];c[g+20>>2]=c[r+20>>2];c[n>>2]=g+24}else Ws(w,r)}i=i+1<<24>>24}xR(b,5,s);xR(b,5,t);xR(b,5,u);xR(b,5,v);do if(qO(b)|0){f=c[w>>2]|0;if(((c[n>>2]|0)-f|0)==24?(r=f,(c[r>>2]|0)==64&(c[r+4>>2]|0)==0):0)break;r=ZW(16)|0;_K(r,w,a[s>>0]|0,a[t>>0]|0,a[u>>0]|0,a[v>>0]|0);c[e>>2]=r}while(0);wR(w);l=x;return}function ai(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=l;l=l+32|0;j=s+12|0;r=s;do if(!(a[d+1565>>0]|0)){a[d+1566>>0]=0;q=d+772|0;e=c[q>>2]|0;k=d+780|0;m=d+548|0;n=d+776|0;o=d+612|0;i=d+48|0;p=d+544|0;if(!e){e=c[p>>2]|0;f=c[o>>2]|0}else{g=c[o>>2]|0;t=i;t=z0(c[t>>2]|0,c[t+4>>2]|0,g|0,0)|0;f=i;c[f>>2]=t;c[f+4>>2]=z;f=c[p>>2]|0;c[p>>2]=e;c[q>>2]=f;f=c[n>>2]|0;c[o>>2]=f;c[n>>2]=g;g=c[m>>2]|0;c[m>>2]=c[k>>2];c[k>>2]=g}g=e+(f+1)|0;switch(a[e+f>>0]|0){case 11:{if((a[g>>0]|0)==119)h=9;break}case 119:{if((a[g>>0]|0)==11)h=9;break}default:{}}if((h|0)==9){Op(d,sl(d)|0,0);VU(j,371150);BZ(c[d+508>>2]|0,c[d+668>>2]|0,0,0);z5(j);e=c[q>>2]|0;if(!e)break;t=c[p>>2]|0;c[p>>2]=e;c[q>>2]=t;t=c[o>>2]|0;r=c[n>>2]|0;c[o>>2]=r;c[n>>2]=t;t=c[m>>2]|0;c[m>>2]=c[k>>2];c[k>>2]=t;t=i;r=D_(c[t>>2]|0,c[t+4>>2]|0,r|0,0)|0;t=i;c[t>>2]=r;c[t+4>>2]=z;break}Bx(d);d4(c[d+648>>2]|0,4);sR(d,12,j);wK(d);e=d+528|0;t=e;t=z0(c[t>>2]|0,c[t+4>>2]|0,2,0)|0;c[e>>2]=t;c[e+4>>2]=z;e=c[q>>2]|0;if(e|0){t=c[p>>2]|0;c[p>>2]=e;c[q>>2]=t;t=c[o>>2]|0;c[o>>2]=c[n>>2];c[n>>2]=t;t=c[m>>2]|0;c[m>>2]=c[k>>2];c[k>>2]=t}e=b[j>>1]|0;if((e&65535)<2){a[d+376>>0]=0;b[j>>1]=2;e=2}Op(d,(e&65535)<<1&65534,0);VU(r,384102);BZ(c[d+508>>2]|0,c[d+668>>2]|0,1,0);z5(r)}else{Op(d,16,0);VU(j,371140);BZ(c[d+508>>2]|0,c[d+668>>2]|0,2,0);z5(j)}while(0);l=s;return}function bi(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;v=l;l=l+64|0;g=v+48|0;n=v+52|0;o=v+55|0;p=v+54|0;q=v+36|0;r=v+24|0;s=v+12|0;t=v;u=d+528|0;h=d+536|0;i=t+8+3|0;j=d+760|0;k=r+8+3|0;m=r+4|0;f=d+648|0;while(1){w=u;y=c[w+4>>2]|0;e=h;x=c[e+4>>2]|0;if(!(y>>>0<x>>>0|((y|0)==(x|0)?(c[w>>2]|0)>>>0<(c[e>>2]|0)>>>0:0)))break;s3(d,g);Bx(d);xR(d,6,o);A6(c[f>>2]|0);AT(d,p);wK(d);NB(d,n);x=u;x=z0(c[x>>2]|0,c[x+4>>2]|0,7,0)|0;y=u;c[y>>2]=x;c[y+4>>2]=z;if(qO(d)|0){TX(q);Tv(q,c[g>>2]|0)|0;e=a[o>>0]|0;if(e<<24>>24){uU(t,e,10);DW(t,0,39932)|0;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}HX(s,39944)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];e=0;while(1){if((e|0)==3)break;c[s+(e<<2)>>2]=0;e=e+1|0}y=a[k>>0]|0;x=y<<24>>24<0;Ex(q,x?c[r>>2]|0:r,x?c[m>>2]|0:y&255)|0;O0(r);O0(s);z5(t)}e=a[p>>0]|0;fk(t,b[n>>1]|0);zv(t,(a[i>>0]|0)<0?c[t>>2]|0:t,e<<24>>24?45:43);c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}p2(r,s);vF(yG((c[j>>2]|0)+56|0,q)|0,r)|0;z5(r);O0(s);z5(t);z5(q)}}l=v;return}function ci(b,d){b=b|0;d=d|0;var e=0,f=0.0,g=0,h=0.0,i=0.0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;t=l;l=l+112|0;k=t+96|0;m=t+84|0;n=t+72|0;o=t+60|0;p=t+48|0;q=t+36|0;r=t+24|0;s=t+12|0;j=t;h=+(d&65535);d=~~((h+-15078.2)/365.25);f=+(~~(+(d|0)*365.25)|0);e=~~((h+-14956.1-f)/30.6001);h=h+-14956.0;i=+(~~(+(e|0)*30.6001)|0);g=(e|1|0)==15;tU(r,d+1900+(g&1)|0,10);HX(r,42040)|0;c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];d=0;while(1){if((d|0)==3)break;c[r+(d<<2)>>2]=0;d=d+1|0}f=h-f-i;e=e+-1+(g?-12:0)|0;HX(q,(e|0)<10?42196:409096)|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];d=0;while(1){if((d|0)==3)break;c[q+(d<<2)>>2]=0;d=d+1|0}g=~~f;tU(s,e,10);d=a[s+8+3>>0]|0;e=d<<24>>24<0;Ex(p,e?c[s>>2]|0:s,e?c[s+4>>2]|0:d&255)|0;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];d=0;while(1){if((d|0)==3)break;c[p+(d<<2)>>2]=0;d=d+1|0}HX(o,42040)|0;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];d=0;while(1){if((d|0)==3)break;c[o+(d<<2)>>2]=0;d=d+1|0}HX(n,(g|0)<10?42196:409096)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];d=0;while(1){if((d|0)==3)break;c[n+(d<<2)>>2]=0;d=d+1|0}tU(j,g,10);d=a[j+8+3>>0]|0;g=d<<24>>24<0;Ex(m,g?c[j>>2]|0:j,g?c[j+4>>2]|0:d&255)|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];d=0;while(1){if((d|0)==3)break;c[m+(d<<2)>>2]=0;d=d+1|0}p2(b,k);O0(k);z5(j);O0(m);O0(n);O0(o);z5(s);O0(p);O0(q);z5(r);l=t;return}function di(b,d,e,f,g,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;i=+i;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;D=l;l=l+384|0;m=D+8|0;C=D;j=D+276|0;n=D+64|0;k=D+176|0;v=D+172|0;r=D+169|0;s=D+168|0;z=D+52|0;A=D+40|0;B=D+28|0;p=D+24|0;q=D+68|0;t=D+20|0;u=D+16|0;c[n>>2]=j;h[C>>3]=i;b=EY(j,0,0,C)|0;if(b>>>0>99){k=b0()|0;h[m>>3]=i;k=wS(n,k,403481,m)|0;b=c[n>>2]|0;if(!b)uaa();j=Ub(k)|0;if(!j)uaa();else{w=j;y=k;F=j;G=b;o=b}}else{w=k;y=b;F=0;G=0;o=j}O4(C,f);j=c[C>>2]|0;m=u$(j,409116)|0;rb[c[(c[m>>2]|0)+32>>2]&7](m,o,o+y|0,w)|0;if(!y)k=0;else k=(a[o>>0]|0)==45;c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[z+(b<<2)>>2]=0;b=b+1|0}c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[A+(b<<2)>>2]=0;b=b+1|0}c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[B+(b<<2)>>2]=0;b=b+1|0}le(e,k,j,v,r,s,z,A,B,p);j=c[p>>2]|0;p=(y|0)>(j|0);b=a[A+11>>0]|0;b=b<<24>>24<0?c[A+4>>2]|0:b&255;e=a[B+11>>0]|0;e=e<<24>>24<0?c[B+4>>2]|0:e&255;b=(p?1:2)+j+(p?b:e)+(p?e+(y-j<<1)|0:b)|0;if(b>>>0>100){b=Ub(b)|0;if(!b)uaa();else{x=b;E=b}}else{x=q;E=0}Kf(x,t,u,c[f+4>>2]|0,w,w+y|0,m,k,v,a[r>>0]|0,a[s>>0]|0,z,A,B,j);b=Qo(c[d>>2]|0,x,c[t>>2]|0,c[u>>2]|0,f,g)|0;if(E|0)pe(E);a1(B);a1(A);a1(z);c6(C);if(F|0)pe(F);if(G|0)pe(G);l=D;return b|0}function ei(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;o=l;l=l+32|0;n=o+4|0;j=o+18|0;f=o;g=o+16|0;if(!(a[b+769>>0]|0)){m=b+528|0;h=b+612|0;do if(!(a[b+772>>0]|0)){p=(a[(c[b+544>>2]|0)+((c[h>>2]|0)+2)>>0]|0)==0;f=m;g=c[f>>2]|0;f=c[f+4>>2]|0;h=z0(g|0,f|0,1,0)|0;i=z;if(p){g=m;c[g>>2]=h;c[g+4>>2]=i;g=h;f=i}i=z0(g|0,f|0,3,0)|0;p=m;c[p>>2]=i;c[p+4>>2]=z;Bx(b);RS(b);xR(b,6,n);xR(b,6,b+948|0);xR(b,3,j);wK(b);if(!(Pp(b)|0)){c3(c[b+508>>2]|0,c[b+668>>2]|0);break}if(!(a[j>>0]|0)){t4(b);k=24}else k=24}else{switch(a[b+832>>0]|0){case 0:{bB(b,g);c[f>>2]=d[g>>0];break}case 1:{NB(b,g);c[f>>2]=e[g>>1];break}case 2:{jB(b,f);break}case 3:{ID(b,f);break}default:{t4(b);c[f>>2]=(c[b+548>>2]|0)-(c[h>>2]|0)}}Bx(b);RS(b);xR(b,6,n);xR(b,6,b+948|0);xR(b,3,j);wK(b);if(!(a[j>>0]|0))t4(b);if(qO(b)|0){f=c[f>>2]|0;if(!f){f=(c[b+548>>2]|0)-(c[h>>2]|0)|0;g=0}else{g=m;p=c[g>>2]|0;g=c[g+4>>2]|0;f=z0(f|0,0,-2,-1)|0;f=z0(f|0,z|0,p|0,g|0)|0;g=z}Op(b,f,g)}k=24}while(0);if((k|0)==24)yZ(c[b+508>>2]|0,c[b+668>>2]|0,d[n>>0]|0,0)}else{p=b+536|0;Op(b,c[p>>2]|0,c[p+4>>2]|0);VU(n,381010);BZ(c[b+508>>2]|0,c[b+668>>2]|0,-1,-1);z5(n)}l=o;return}function fi(a,b){a=a|0;b=b|0;var c=0;a:do switch(a<<24>>24){case 1:{a=391514;break}case 2:{a=391482;break}case 3:{a=391506;break}case 4:{a=391498;break}case 15:{a=391425;break}case 16:{a=391490;break}case 17:{a=391425;break}case 27:{a=391410;break}case 28:{a=391425;break}case 29:{a=391400;break}case 30:{a=391482;break}case 31:{a=391410;break}case 32:{a=391410;break}case 39:case 36:{a=391405;break}default:{b:do if((b|0)<1212435798){if((b|0)<1129661769)switch(b|0){case -1:{a=8800948;break a}default:break b}if((b|0)<1195456820)switch(b|0){case 1129661769:{c=16;break b}default:break b}else switch(b|0){case 1195456820:{c=16;break b}default:break b}}else{if((b|0)>=1395733569)if((b|0)<1396921413)switch(b|0){case 1395733569:{c=16;break b}default:break b}else switch(b|0){case 1396921413:{c=16;break b}default:break b}switch(b|0){case 1212435798:break;default:break b}switch(a<<24>>24){case -128:{a=391465;break a}case -127:{a=391474;break a}case -126:{a=391377;break a}case -125:{a=391469;break a}case -122:{a=391377;break a}case -112:{a=391388;break a}case -111:{a=391388;break a}case -110:{a=391381;break a}case -22:{a=391478;break a}default:{a=8800948;break a}}}while(0);if((c|0)==16)switch(a<<24>>24){case -128:{a=391482;break a}case -127:{a=391474;break a}case -126:{a=391400;break a}case -121:{a=391469;break a}default:{a=8800948;break a}}switch(a<<24>>24){case -128:{a=391482;break a}case -127:{a=391474;break a}case -121:{a=391469;break a}case -120:{a=391360;break a}case -47:{a=391354;break a}default:{a=8800948;break a}}}}while(0);return a|0}function gi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+272|0;n=p+8|0;o=p;do if(!(a[d>>0]|0)){d=Ra(401415)|0;if(d|0?a[d>>0]|0:0)break;d=Ra(401343+(b*12|0)|0)|0;if(d|0?a[d>>0]|0:0)break;d=Ra(401422)|0;if(d|0?a[d>>0]|0:0)break;d=401427}while(0);e=0;a:do{switch(a[d+e>>0]|0){case 47:case 0:break a;default:{}}e=e+1|0}while(e>>>0<15);f=a[d>>0]|0;if(f<<24>>24!=46?(a[d+e>>0]|0)==0:0)if(f<<24>>24==67)m=15;else{k=d;m=16}else{d=401427;m=15}if((m|0)==15)if(!(a[d+1>>0]|0))m=18;else{k=d;m=16}b:do if((m|0)==16)if((xN(k,401427)|0)!=0?(xN(k,401435)|0)!=0:0){d=c[102267]|0;if(d|0)do{if(!(xN(k,d+8|0)|0))break b;d=c[d+24>>2]|0}while((d|0)!=0);Za(409072);d=c[102267]|0;c:do if(d|0){while(1){if(!(xN(k,d+8|0)|0))break;d=c[d+24>>2]|0;if(!d)break c}Ua(409072);break b}while(0);d:do if(((c[102246]|0)==0?(g=Ra(401441)|0,(g|0)!=0):0)?(a[g>>0]|0)!=0:0){i=254-e|0;j=e+1|0;f=g;while(1){h=Vv(f,58)|0;d=a[h>>0]|0;g=((d<<24>>24!=0)<<31>>31)+(h-f)|0;if(g>>>0<i>>>0){no(n|0,f|0,g|0)|0;f=n+g|0;a[f>>0]=47;no(f+1|0,k|0,e|0)|0;a[n+(j+g)>>0]=0;g=Sa(n|0,o|0)|0;if(g|0)break;d=a[h>>0]|0}f=h+(d<<24>>24!=0&1)|0;if(!(a[f>>0]|0)){m=41;break d}}d=Ub(28)|0;f=c[o>>2]|0;if(!d){UX(g,f);m=41;break}else{c[d>>2]=g;c[d+4>>2]=f;o=d+8|0;no(o|0,k|0,e|0)|0;a[o+e>>0]=0;c[d+24>>2]=c[102267];c[102267]=d;break}}else m=41;while(0);if((m|0)==41){d=Ub(28)|0;if(d){c[d>>2]=50700;c[d+4>>2]=20;o=d+8|0;no(o|0,k|0,e|0)|0;a[o+e>>0]=0;c[d+24>>2]=c[102267];c[102267]=d}}Ua(409072);d=(b|0)==0&(d|0)==0?50672:d}else{d=k;m=18}while(0);do if((m|0)==18){if((b|0)==0?(a[d+1>>0]|0)==46:0){d=50672;break}d=0}while(0);l=p;return d|0}function hi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=l;l=l+32|0;i=h+20|0;d=h+16|0;e=h+12|0;f=h+8|0;g=h;W5(b);NK(b);u3(b,i);LK(b);switch(a[i>>0]|0){case 49:{jB(b,d);jB(b,e);i=b+528|0;k=i;j=i;c[j>>2]=z0(c[k>>2]|0,c[k+4>>2]|0,6,0)|0;c[j+4>>2]=z;jB(b,h+4|0);jB(b,f);jB(b,g);j=i;c[i>>2]=z0(c[j>>2]|0,c[j+4>>2]|0,21,0)|0;c[i+4>>2]=z;RB(b,0,0,65,379569,-1,1,0);Kc(b,1,-1)|0;RB(b,1,0,51,379569,-1,1,0);lL(b,1,0,130,c[d>>2]|0,10,0);lL(b,1,0,138,c[e>>2]|0,10,0);Bt(b,1,0,171,+((c[f>>2]|0)>>>0),3,0);lL(b,1,0,185,c[g>>2]|0,10,0);V5(b);break}case 50:{gB(b,d);gB(b,e);i=b+528|0;j=i;k=i;c[k>>2]=z0(c[j>>2]|0,c[j+4>>2]|0,6,0)|0;c[k+4>>2]=z;k=b+1024|0;gB(b,k);gB(b,f);j=b+1028|0;gB(b,j);g=i;c[i>>2]=z0(c[g>>2]|0,c[g+4>>2]|0,21,0)|0;c[i+4>>2]=z;c[k>>2]=(c[k>>2]|0)+3;c[j>>2]=(c[j>>2]|0)+1;RB(b,0,0,65,379576,-1,1,0);Kc(b,1,-1)|0;RB(b,1,0,18,380258,-1,1,0);RB(b,1,0,58,380258,-1,1,0);RB(b,1,0,51,379576,-1,1,0);lL(b,1,0,130,c[d>>2]|0,10,0);lL(b,1,0,138,c[e>>2]|0,10,0);lL(b,1,0,171,c[f>>2]|0,10,0);lL(b,1,0,185,c[j>>2]|0,10,0);lL(b,1,0,252,O(c[j>>2]|0,c[k>>2]|0)|0,10,0);break}default:V5(b)}l=h;return}function ii(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+48|0;k=p;e=p+32|0;j=p+28|0;m=p+36|0;o=p+16|0;g=d+528|0;i=g;i=z0(c[i>>2]|0,c[i+4>>2]|0,1,0)|0;f=g;c[f>>2]=i;c[f+4>>2]=z;iF(d,6,0);f=g;f=z0(c[f>>2]|0,c[f+4>>2]|0,2,0)|0;i=g;c[i>>2]=f;c[i+4>>2]=z;r3(d,e);i=g;i=z0(c[i>>2]|0,c[i+4>>2]|0,4,0)|0;f=g;c[f>>2]=i;c[f+4>>2]=z;Uy(d,p+8|0);Uy(d,k);f=g;f=z0(c[f>>2]|0,c[f+4>>2]|0,12,0)|0;i=g;c[i>>2]=f;c[i+4>>2]=z;HB(d,m);i=g;i=z0(c[i>>2]|0,c[i+4>>2]|0,2,0)|0;f=g;c[f>>2]=i;c[f+4>>2]=z;bD(d,j);f=c[g>>2]|0;g=c[g+4>>2]|0;i=d+536|0;h=c[i>>2]|0;i=c[i+4>>2]|0;if(i>>>0>g>>>0|(i|0)==(g|0)&h>>>0>f>>>0){n=D_(h|0,i|0,f|0,g|0)|0;e1(d,n,z)}Kc(d,2,-1)|0;TX(o);n=c[e>>2]|0;lh(o,n)|0;aE(o,48)|0;f=d+20|0;Rf(d,o,2,c[f>>2]|0,3);zb(d,2,c[f>>2]|0,52,o,0);e=c[j>>2]|0;if((e|0)>-1)lL(d,2,c[f>>2]|0,112,e<<3,10,0);g=b[m>>1]|0;sM(d,2,c[f>>2]|0,122,g<<16>>16==5?6:g&65535,0);g=k;h=c[g>>2]|0;g=c[g+4>>2]|0;oK(d,2,c[f>>2]|0,135,h,g,10,0);f=d+768|0;c[f>>2]=h;c[f+4>>2]=g;f=UJ(o,4)|0;g=a[f+8+3>>0]|0;h=g<<24>>24<0;i=h?c[f>>2]|0:f;j=i9(28392)|0;e=d+776|0;if((j|0)!=0?(m=i+((h?c[f+4>>2]|0:g&255)<<2)|0,d=HA(i,m,28392,28392+(j<<2)|0)|0,!((d|0)!=(m|0)&(d|0)==(i|0))):0){if((n|0)==842018864){d=ZW(1584)|0;on(d);c[e>>2]=d;d=d+760|0;c[d>>2]=2;c[d+4>>2]=0}}else{d=ZW(1128)|0;Wr(d);c[e>>2]=d}z5(o);l=p;return}function ji(a,b){a=+a;b=+b;var d=0,e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h[j>>3]=a;i=c[j>>2]|0;l=c[j+4>>2]|0;h[j>>3]=b;n=c[j>>2]|0;o=c[j+4>>2]|0;e=XZ(i|0,l|0,52)|0;e=e&2047;m=XZ(n|0,o|0,52)|0;m=m&2047;p=l&-2147483648;g=PZ(n|0,o|0,1)|0;k=z;a:do if(!((g|0)==0&(k|0)==0)?(f=d0(b)|0,d=z&2147483647,!((e|0)==2047|(d>>>0>2146435072|(d|0)==2146435072&f>>>0>0))):0){d=PZ(i|0,l|0,1)|0;f=z;if(!(f>>>0>k>>>0|(f|0)==(k|0)&d>>>0>g>>>0))return +((d|0)==(g|0)&(f|0)==(k|0)?a*0.0:a);if(!e){d=PZ(i|0,l|0,12)|0;f=z;if((f|0)>-1|(f|0)==-1&d>>>0>4294967295){e=0;do{e=e+-1|0;d=PZ(d|0,f|0,1)|0;f=z}while((f|0)>-1|(f|0)==-1&d>>>0>4294967295)}else e=0;i=PZ(i|0,l|0,1-e|0)|0;g=z}else g=l&1048575|1048576;if(!m){f=PZ(n|0,o|0,12)|0;k=z;if((k|0)>-1|(k|0)==-1&f>>>0>4294967295){d=0;do{d=d+-1|0;f=PZ(f|0,k|0,1)|0;k=z}while((k|0)>-1|(k|0)==-1&f>>>0>4294967295)}else d=0;n=PZ(n|0,o|0,1-d|0)|0;m=d;l=z}else l=o&1048575|1048576;f=D_(i|0,g|0,n|0,l|0)|0;d=z;k=(d|0)>-1|(d|0)==-1&f>>>0>4294967295;b:do if((e|0)>(m|0)){while(1){if(k){if((f|0)==0&(d|0)==0)break}else{f=i;d=g}i=PZ(f|0,d|0,1)|0;g=z;e=e+-1|0;f=D_(i|0,g|0,n|0,l|0)|0;d=z;k=(d|0)>-1|(d|0)==-1&f>>>0>4294967295;if((e|0)<=(m|0))break b}b=a*0.0;break a}while(0);if(k){if((f|0)==0&(d|0)==0){b=a*0.0;break}}else{d=g;f=i}if(d>>>0<1048576|(d|0)==1048576&f>>>0<0)do{f=PZ(f|0,d|0,1)|0;d=z;e=e+-1|0}while(d>>>0<1048576|(d|0)==1048576&f>>>0<0);if((e|0)>0){o=z0(f|0,d|0,0,-1048576)|0;d=z;e=PZ(e|0,0,52)|0;d=d|z;e=o|e}else{e=XZ(f|0,d|0,1-e|0)|0;d=z}c[j>>2]=e;c[j+4>>2]=d|p;b=+h[j>>3]}else q=3;while(0);if((q|0)==3){b=a*b;b=b/b}return +b}function ki(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;m=l;l=l+32|0;d=m+29|0;e=m+28|0;f=m+27|0;g=m+26|0;h=m+25|0;i=m+24|0;j=m+12|0;k=m;e1(b,31,0);Bx(b);o=b+648|0;d4(c[o>>2]|0,2);d4(c[o>>2]|0,6);d4(c[o>>2]|0,1);d4(c[o>>2]|0,7);d4(c[o>>2]|0,1);d4(c[o>>2]|0,7);d4(c[o>>2]|0,2);d4(c[o>>2]|0,6);d4(c[o>>2]|0,8);d4(c[o>>2]|0,2);xR(b,6,d);d4(c[o>>2]|0,3);xR(b,5,e);xR(b,8,f);d4(c[o>>2]|0,8);d4(c[o>>2]|0,1);xR(b,7,g);d4(c[o>>2]|0,1);xR(b,7,h);d4(c[o>>2]|0,2);xR(b,6,i);d4(c[o>>2]|0,2);d4(c[o>>2]|0,1);d4(c[o>>2]|0,5);wK(b);o=b+536|0;n=b+528|0;n=D_(c[o>>2]|0,c[o+4>>2]|0,c[n>>2]|0,c[n+4>>2]|0)|0;e1(b,n,z);if(qO(b)|0){TX(k);p=a[f>>0]|0;e=a[e>>0]|0;f=a[d>>0]|0;i=a[i>>0]|0;n=a[h>>0]|0;o=a[g>>0]|0;p2(j,Ne(k,(((p&255)>>>4)*10&255)+(p&15)&255,(((e&255)>>>4)*10&255)+(e&15)&255,(((f&255)>>>4)*10&255)+(f&15)&255,(((i&255)>>>4)*10&255)+(i&15)&255,(((n&255)>>>4)*10&255)+(n&15)&255,(((o&255)>>>4)*10&255)+(o&15)&255)|0);z5(k);$x(k,b,0,0,256,1);o=a[k+8+3>>0]|0;o=((o<<24>>24<0?c[k+4>>2]|0:o&255)|0)==0;z5(k);if(o){zb(b,0,0,256,j,0);zb(b,0,0,99,j,0)}zb(b,0,0,100,j,1);z5(j)}l=m;return}function li(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;e=a>>>16;a=a&65535;do if((c|0)!=1)if(!b)a=1;else{if(c>>>0<16){while(1){if(!c)break;h=(d[b>>0]|0)+a|0;c=c+-1|0;b=b+1|0;e=h+e|0;a=h}a=((e>>>0)%65521|0)<<16|(a>>>0>65520?a+-65521|0:a);break}while(1){if(c>>>0>5551){f=347;g=b}else break;while(1){v=(d[g>>0]|0)+a|0;u=v+(d[g+1>>0]|0)|0;t=u+(d[g+2>>0]|0)|0;s=t+(d[g+3>>0]|0)|0;r=s+(d[g+4>>0]|0)|0;q=r+(d[g+5>>0]|0)|0;p=q+(d[g+6>>0]|0)|0;o=p+(d[g+7>>0]|0)|0;n=o+(d[g+8>>0]|0)|0;m=n+(d[g+9>>0]|0)|0;l=m+(d[g+10>>0]|0)|0;k=l+(d[g+11>>0]|0)|0;j=k+(d[g+12>>0]|0)|0;i=j+(d[g+13>>0]|0)|0;h=i+(d[g+14>>0]|0)|0;a=h+(d[g+15>>0]|0)|0;e=v+e+u+t+s+r+q+p+o+n+m+l+k+j+i+h+a|0;f=f+-1|0;if(!f)break;else g=g+16|0}c=c+-5552|0;b=b+5552|0;e=(e>>>0)%65521|0;a=(a>>>0)%65521|0}if(c){h=~c;h=c+16+(h>>>0>4294967280?h:-16)|0;f=c;g=b;while(1){if(f>>>0<=15)break;x=(d[g>>0]|0)+a|0;w=x+(d[g+1>>0]|0)|0;i=w+(d[g+2>>0]|0)|0;j=i+(d[g+3>>0]|0)|0;k=j+(d[g+4>>0]|0)|0;l=k+(d[g+5>>0]|0)|0;m=l+(d[g+6>>0]|0)|0;n=m+(d[g+7>>0]|0)|0;o=n+(d[g+8>>0]|0)|0;p=o+(d[g+9>>0]|0)|0;q=p+(d[g+10>>0]|0)|0;r=q+(d[g+11>>0]|0)|0;s=r+(d[g+12>>0]|0)|0;t=s+(d[g+13>>0]|0)|0;u=t+(d[g+14>>0]|0)|0;v=u+(d[g+15>>0]|0)|0;f=f+-16|0;g=g+16|0;e=x+e+w+i+j+k+l+m+n+o+p+q+r+s+t+u+v|0;a=v}x=h&-16;f=c-x|0;c=b+x|0;while(1){if(!f)break;x=(d[c>>0]|0)+a|0;f=f+-1|0;c=c+1|0;e=x+e|0;a=x}e=(e>>>0)%65521|0;a=(a>>>0)%65521|0}a=e<<16|a}else{a=(d[b>>0]|0)+a|0;a=a>>>0>65520?a+-65521|0:a;x=a+e|0;a=(x>>>0>65520?x+15|0:x)<<16|a}while(0);return a|0}function mi(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+64|0;d=n+52|0;f=n+56|0;g=n+59|0;i=n+36|0;j=n+24|0;k=n+12|0;m=n;ID(b,d);NB(b,f);Bx(b);AT(b,g);xR(b,2,n+63|0);xR(b,2,n+62|0);AT(b,n+58|0);xR(b,2,n+61|0);rR(b,28,n+48|0);xR(b,4,n+60|0);wK(b);if(qO(b)|0){h=HD((c[b+760>>2]|0)+68|0,b+764|0)|0;Gr(i,c[d>>2]|0);h=h+4|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;d=j9(387639)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11){a[j+11>>0]=d;b=j}else{o=d+16&-16;b=ZW(o)|0;c[j>>2]=b;c[j+8>>2]=o|-2147483648;c[j+4>>2]=d}i1(b,387639,d)|0;J7(b+d|0,0);vF(VC(h,j)|0,i)|0;a1(j);z5(i);LW(k,e[f>>1]|0);Gx(k,a[g>>0]|0?69:87);c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];b=0;while(1){if((b|0)==3)break;c[k+(b<<2)>>2]=0;b=b+1|0}p2(i,j);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;d=j9(387649)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11){a[m+11>>0]=d;b=m}else{o=d+16&-16;b=ZW(o)|0;c[m>>2]=b;c[m+8>>2]=o|-2147483648;c[m+4>>2]=d}i1(b,387649,d)|0;J7(b+d|0,0);vF(VC(h,m)|0,i)|0;a1(m);z5(i);O0(j);z5(k)}l=n;return}function ni(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+16|0;i=m;a:do if((d|0)!=0?(a[b>>0]|0)!=0:0){c[e>>2]=1;f=a[b>>0]|0;switch(f<<24>>24){case 42:{f=-5;break a}case 92:{f=b+1|0;if(!(a[f>>0]|0))f=92;else{c[e>>2]=2;g=f;h=1;f=a[f>>0]|0;k=30}break}case 91:{b:do if(d>>>0>1){switch(a[b+1>>0]|0){case 33:case 94:break;default:{f=1;break b}}f=2}else f=1;while(0);if(f>>>0<d>>>0)f=((a[b+f>>0]|0)==93&1)+f|0;c:do if(f>>>0<d>>>0)while(1){g=a[b+f>>0]|0;switch(g<<24>>24){case 93:case 0:{g=f;k=26;break c}default:{}}h=f+1|0;d:do if(h>>>0<d>>>0?(j=a[b+h>>0]|0,g<<24>>24==91&j<<24>>24!=0):0){switch(j<<24>>24){case 61:case 46:case 58:break;default:break d}g=f+2|0;if(g>>>0<d>>>0)f=(a[b+g>>0]|0)==0?g:f+3|0;else f=g;e:do if(f>>>0<d>>>0)do{g=a[b+f>>0]|0;if(!(g<<24>>24))break e;if(!(g<<24>>24!=93?1:(a[b+(f+-1)>>0]|0)!=j<<24>>24))break e;f=f+1|0}while(f>>>0<d>>>0);while(0);if((f|0)==(d|0)){f=91;g=1;break c}if(!(a[b+f>>0]|0)){g=f;k=26;break c}}while(0);f=f+1|0;if(f>>>0>=d>>>0){g=f;k=26;break c}}else{g=f;k=26}while(0);if((k|0)==26)if((g|0)==(d|0)){f=91;g=1}else{d=(a[b+g>>0]|0)==0;f=d?91:-3;g=d?1:g+1|0}c[e>>2]=g;break a}case 63:{f=-4;break a}default:{g=b;h=0;k=30}}if((k|0)==30)if(f<<24>>24<0){f=fq(i,g,d)|0;if((f|0)<0){c[e>>2]=0;f=-2}else{c[e>>2]=f+h;f=c[i>>2]|0}break}f=f<<24>>24}else k=3;while(0);if((k|0)==3){c[e>>2]=0;f=0}l=m;return f|0}function oi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+32|0;i=k+12|0;j=k;f=an(b)|0;if(qO(b)|0?(c[b+880>>2]|0)>>>0<=1:0){VU(i,382808);h=b+760|0;g=b+840|0;d=kE(h,g)|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;e=j9(373189)|0;if(e>>>0>4294967279)uaa();if(e>>>0<11){a[j+11>>0]=e;b=j}else{m=e+16&-16;b=ZW(m)|0;c[j>>2]=b;c[j+8>>2]=m|-2147483648;c[j+4>>2]=e}i1(b,373189,e)|0;J7(b+e|0,0);vF(VC(d+88|0,j)|0,i)|0;a1(j);z5(i);d=f&255;VU(i,SA(d)|0);e=kE(h,g)|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;f=j9(373271)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[j+11>>0]=f;b=j}else{m=f+16&-16;b=ZW(m)|0;c[j>>2]=b;c[j+8>>2]=m|-2147483648;c[j+4>>2]=f}i1(b,373271,f)|0;J7(b+f|0,0);vF(VC(e+88|0,j)|0,i)|0;a1(j);z5(i);VU(i,ZT(d)|0);d=kE(h,g)|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;e=j9(378056)|0;if(e>>>0>4294967279)uaa();if(e>>>0<11){a[j+11>>0]=e;b=j}else{m=e+16&-16;b=ZW(m)|0;c[j>>2]=b;c[j+8>>2]=m|-2147483648;c[j+4>>2]=e}i1(b,378056,e)|0;J7(b+e|0,0);vF(VC(d+88|0,j)|0,i)|0;a1(j);z5(i)}l=k;return}function pi(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=l;l=l+16|0;o=s;q=d+764|0;j=c[q>>2]|0;n=d+782|0;j=$C((HD(j+68|0,j)|0)+16|0,n)|0;k=j+52|0;j=j+56|0;p=d+780|0;i=0;d=c[j>>2]|0;while(1){e=c[k>>2]|0;if(i>>>0>=d-e>>1>>>0){k=0;break}g=e+(i<<1)|0;a:do if((b[g>>1]|0)==(b[p>>1]|0)){e=g+2|0;f=d-e|0;h=f>>1;if(!h)e=d;else{TR(g|0,e|0,f|0)|0;d=c[j>>2]|0;e=d}f=g+(h<<1)|0;while(1){if((e|0)==(f|0))break a;m=e+-2|0;c[j>>2]=m;d=m;e=m}}while(0);i=i+1|0}while(1){d=c[q>>2]|0;h=b[p>>1]|0;g=c[d+80>>2]|0;f=c[g+((h&65535)<<2)>>2]|0;m=f+8|0;i=c[m>>2]|0;t=c[f+4>>2]|0;e=t;j=i;if(k>>>0>=i-t>>1>>>0)break;g=e+(k<<1)|0;b:do if((b[g>>1]|0)==(b[n>>1]|0)){e=g+2|0;d=i-e|0;f=d>>1;if(!f)d=j;else{TR(g|0,e|0,d|0)|0;d=c[m>>2]|0}e=g+(f<<1)|0;while(1){if((d|0)==(e|0))break b;t=d+-2|0;c[m>>2]=t;d=t}}while(0);k=k+1|0}if((e|0)==(j|0)){k=c[f+52>>2]|0;e=c[f+60>>2]|0;c[o>>2]=e;do if((k|0)!=7&(e|0)!=-1){f=c[d+164>>2]|0;i=f+(k*12|0)+4|0;j=c[i>>2]|0;if((j|0)==(c[f+(k*12|0)+8>>2]|0)){Yy(f+(k*12|0)|0,o);g=c[q>>2]|0;d=g;h=b[p>>1]|0;g=c[g+80>>2]|0;break}else{c[j>>2]=e;c[i>>2]=j+4;break}}while(0);e=d+92|0;f=c[e>>2]|0;d=c[g+((h&65535)<<2)>>2]|0;switch(f|0){case 0:case -1:{if(d|0)r=27;break}default:if(!(a[d+68>>0]|0)){c[e>>2]=f+-1;r=27}else r=27}if((r|0)==27){Rx(d);laa(d)}r=ZW(200)|0;Ss(r);t=b[p>>1]|0;c[(c[(c[q>>2]|0)+80>>2]|0)+((t&65535)<<2)>>2]=r;SP((c[q>>2]|0)+188|0,t)}l=s;return}function qi(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+16|0;f=s;Bx(e);r=e+648|0;d4(c[r>>2]|0,11);g=e+1112|0;xR(e,2,g);n=e+1113|0;xR(e,2,n);AT(e,e+1119|0);o=e+1114|0;xR(e,4,o);p=e+1115|0;xR(e,2,p);q=e+1120|0;AT(e,q);A6(c[r>>2]|0);r=e+1116|0;xR(e,2,r);xR(e,2,e+1117|0);AT(e,e+1121|0);AT(e,e+1122|0);xR(e,2,e+1118|0);wK(e);g=d[g>>0]|0;h=b[61002+(g<<3)+((d[p>>0]|0)<<1)>>1]|0;if((h<<16>>16!=0?(i=a[n>>0]|0,j=i&255,k=a[372685+(g<<2)+j>>0]|0,k<<24>>24!=0):0)?(m=b[60490+(g<<7)+(j<<5)+((d[o>>0]|0)<<1)>>1]|0,!(i<<24>>24==0|m<<16>>16==0)):0){n=a[372701+j>>0]|0;k=UW(k&255|0,0,1e3,0)|0;m=UW(k|0,z|0,m&65535|0,0)|0;m=g5(m|0,z|0,h&65535|0,0)|0;m=z0(d[q>>0]|0|0,0,m|0,z|0)|0;m=UW(m|0,z|0,n&255|0,0)|0;q=z;k=e+48|0;k=z0(c[e+612>>2]|0,0,c[k>>2]|0,c[k+4>>2]|0)|0;n=z;o=z0(k|0,n|0,m|0,q|0)|0;h=z;j=e+40|0;i=e+784|0;i=D_(c[j>>2]|0,c[j+4>>2]|0,c[i>>2]|0,c[i+4>>2]|0)|0;j=z;o=h>>>0<j>>>0|(h|0)==(j|0)&o>>>0<i>>>0;n=D_(i|0,j|0,k|0,n|0)|0;Op(e,o?m:n,o?q:z);VU(f,372819);BZ(c[e+508>>2]|0,c[e+668>>2]|0,0,0);z5(f);q=WH(e+980|0,p)|0;c[q>>2]=(c[q>>2]|0)+1;r=WH(e+992|0,r)|0;c[r>>2]=(c[r>>2]|0)+1;qO(e)|0}else{r=e+528|0;c[r>>2]=1;c[r+4>>2]=0;Op(e,1,0);VU(f,372807);BZ(c[e+508>>2]|0,c[e+668>>2]|0,0,0);z5(f);a[e+376>>0]=0}l=s;return}function ri(d){d=d|0;var f=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;m=d+728|0;if(a[d+760>>0]|0?(c[m>>2]&1|0)==0:0)W5(d);n=d+768|0;i=c[n>>2]|0;o=d+762|0;l=b[o>>1]|0;h=c[i+80>>2]|0;f=c[h+((l&65535)<<2)>>2]|0;j=(c[f>>2]|0)+728|0;k=c[j>>2]|0;if(!(k&4))i=l;else{c[j>>2]=k&-5;a[f+183>>0]=1;k=0;j=l;while(1){if(k>>>0>=(c[f+8>>2]|0)-(c[f+4>>2]|0)>>1>>>0)break;l=(HD(i+68|0,i)|0)+16|0;a[($C(l,(c[(c[(c[(c[n>>2]|0)+80>>2]|0)+(e[o>>1]<<2)>>2]|0)+4>>2]|0)+(k<<1)|0)|0)+82>>0]=1;l=c[n>>2]|0;f=b[o>>1]|0;r=c[l+80>>2]|0;k=k+1|0;h=r;j=f;f=c[r+((f&65535)<<2)>>2]|0;i=l}c[m>>2]=c[m>>2]|524292;i=j}m=d+776|0;j=d+784|0;k=j;m=z0(c[k>>2]|0,c[k+4>>2]|0,c[m>>2]|0,c[m+4>>2]|0)|0;k=z;r=d+40|0;l=c[r+4>>2]|0;if(k>>>0>l>>>0|((k|0)==(l|0)?m>>>0>(c[r>>2]|0)>>>0:0)?(a[f+178>>0]|0)==0:0){h=c[h+((i&65535)<<2)>>2]|0;if(!(a[(c[h>>2]|0)+784>>0]|0))f=h;else{wZ(f,0);EZ(c[(c[(c[n>>2]|0)+80>>2]|0)+(e[o>>1]<<2)>>2]|0,1);f=c[(c[(c[n>>2]|0)+80>>2]|0)+(e[o>>1]<<2)>>2]|0}}if(c[(c[f>>2]|0)+728>>2]&10|0){if(!((a[f+173>>0]|0)==0?(a[f+174>>0]|0)==0:0)){h=c[d+24>>2]|0;if(+g[h+136>>2]<1.0?(r=j,!((c[r>>2]|0)==0&(c[r+4>>2]|0)==0)):0){if(UQ(h)|0){UZ(c[(c[(c[n>>2]|0)+80>>2]|0)+(e[o>>1]<<2)>>2]|0,0);OZ(c[(c[(c[n>>2]|0)+80>>2]|0)+(e[o>>1]<<2)>>2]|0,0)}i=c[n>>2]|0;f=c[(c[i+80>>2]|0)+(e[o>>1]<<2)>>2]|0;h=f+68|0;if((a[h>>0]|0)==0?(p=i+92|0,q=c[p>>2]|0,(q|0)!=0):0){a[h>>0]=1;c[p>>2]=q+-1}}}if(a[f+177>>0]|0)wZ(f,0)}return}function si(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;t=l;l=l+16|0;p=t+4|0;m=t;k=b+64|0;if(!(c[k>>2]|0))d=-1;else{e=rI(b)|0;s=b+12|0;d=c[s>>2]|0;q=b+8|0;r=b+16|0;if(!d){d=p+1|0;c[q>>2]=p;c[s>>2]=d;c[r>>2]=d}if(e){e=c[r>>2]|0;n=0}else{e=c[r>>2]|0;n=(e-(c[q>>2]|0)|0)/2|0;n=n>>>0<4?n:4}do if((d|0)==(e|0)){TR(c[q>>2]|0,d+(0-n)|0,n|0)|0;if(a[b+98>>0]|0){d=c[q>>2]|0;d=Sz(d+n|0,(c[r>>2]|0)-n-d|0,c[k>>2]|0)|0;if(!d){d=-1;break}o=(c[q>>2]|0)+n|0;c[s>>2]=o;c[r>>2]=o+d;d=e9(a[o>>0]|0)|0;break}h=b+40|0;g=c[h>>2]|0;i=b+36|0;d=c[i>>2]|0;j=b+32|0;f=g;e=d;if((g|0)==(d|0))d=f;else{TR(c[j>>2]|0,d|0,f-e|0)|0;e=c[i>>2]|0;d=c[h>>2]|0}f=c[j>>2]|0;e=f+(d-e)|0;c[i>>2]=e;if((f|0)==(b+44|0))d=8;else d=c[b+52>>2]|0;u=f+d|0;c[h>>2]=u;f=b+60|0;d=(c[f>>2]|0)-n|0;u=u-e|0;g=b+72|0;x=g;w=c[x+4>>2]|0;v=b+80|0;c[v>>2]=c[x>>2];c[v+4>>2]=w;e=Sz(e,u>>>0<d>>>0?u:d,c[k>>2]|0)|0;if(!e)d=-1;else{d=c[b+68>>2]|0;if(!d){x=ua(4)|0;G9(x);Ya(x|0,2744,371)}w=(c[i>>2]|0)+e|0;c[h>>2]=w;x=c[q>>2]|0;if((qb[c[(c[d>>2]|0)+16>>2]&15](d,g,c[j>>2]|0,w,i,x+n|0,x+(c[f>>2]|0)|0,m)|0)!=3){e=c[m>>2]|0;d=(c[q>>2]|0)+n|0;if((e|0)==(d|0))d=-1;else o=21}else{d=c[j>>2]|0;e=c[h>>2]|0;c[q>>2]=d;o=21}if((o|0)==21){c[s>>2]=d;c[r>>2]=e;d=e9(a[d>>0]|0)|0}}}else d=e9(a[d>>0]|0)|0;while(0);if((c[q>>2]|0)==(p|0)){c[q>>2]=0;c[s>>2]=0;c[r>>2]=0}}l=t;return d|0}function ti(a){a=a|0;var b=0;a:do if((a|0)<1212503619){if((a|0)>=1146377010){if((a|0)<1195456820)switch(a|0){case 1146377010:{a=391377;break a}case 1146377011:{a=391377;break a}default:{b=17;break a}}if((a|0)<1212435798){switch(a|0){case 1195456820:break;default:{b=17;break a}}a=388070;break}else{switch(a|0){case 1212435798:break;default:{b=17;break a}}a=388062;break}}if((a|0)<1129661769){if((a|0)<1112757060)switch(a|0){case 1094921523:{a=391372;break a}default:{b=17;break a}}switch(a|0){case 1112757060:break;default:{b=17;break a}}a=391465;break}if((a|0)<1146377009){switch(a|0){case 1129661769:break;default:{b=17;break a}}a=388089;break}else{switch(a|0){case 1146377009:break;default:{b=17;break a}}a=391377;break}}else if((a|0)<1395733569)if((a|0)<1296125530)if((a|0)<1263294017){switch(a|0){case 1212503619:break;default:{b=17;break a}}a=391405;break}else{switch(a|0){case 1263294017:break;default:{b=17;break a}}a=388058;break}else if((a|0)<1332770163){switch(a|0){case 1296125530:break;default:{b=17;break a}}a=387937;break}else{switch(a|0){case 1332770163:break;default:{b=17;break a}}a=388036;break}else if((a|0)<1414744150)if((a|0)<1396921413){switch(a|0){case 1395733569:break;default:{b=17;break a}}a=388041;break}else{switch(a|0){case 1396921413:break;default:{b=17;break a}}a=387958;break}else if((a|0)<1447243057){switch(a|0){case 1414744150:break;default:{b=17;break a}}a=387955;break}else{switch(a|0){case 1447243057:break;default:{b=17;break a}}a=391360;break}while(0);if((b|0)==17)a=8800948;return a|0}function ui(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+48|0;q=r+36|0;j=r+38|0;k=r+24|0;m=r+12|0;n=r;i=a[e+8+3>>0]|0;f=i<<24>>24<0;a:do if(((f?c[e+4>>2]|0:i&255)|0)==6?(p=f?c[e>>2]|0:e,(c[p>>2]|0)==48):0){switch(c[p+4>>2]|0){case 48:{b[q>>1]=0;j=2;f=0;g=0;while(1){if(j>>>0>=6){o=13;break}f=f<<4;h=f&65535;i=c[p+(j<<2)>>2]|0;if((i|0)<=47){o=11;break}g=f&65520;if((i|0)>=58){if((i|0)<=64){o=11;break}if((i|0)>=71)if((i+-97|0)>>>0<6)f=65449;else{o=11;break}else f=65481}else f=65488;g=g+f+i|0;j=j+1|0;f=g;g=g&65535}if((o|0)==11){b[q>>1]=h;p2(d,e)}else if((o|0)==13){b[q>>1]=g;WA(d,q)}break a}case 49:{i=2;f=0;break}default:{o=30;break a}}while(1){g=f&65535;if(i>>>0>=6)break;f=g<<4;h=c[p+(i<<2)>>2]|0;g=f&65520;if((h|0)<=47){o=22;break}if((h|0)>=58){if((h|0)<=64){o=22;break}if((h|0)>=71)if((h+-97|0)>>>0<6)g=65449;else{o=22;break}else{f=g;g=-55}}else{f=g;g=-48}i=i+1|0;f=g+h+f&65535}if((o|0)==22){p2(d,e);break}a[q>>0]=f;p=g-(f&255)|0;p=(p&65535)<<16>>16==0?0:p>>>8&255;a[j>>0]=p;YA(m,q);if(!(p<<24>>24))TX(n);else YA(n,j);f=a[n+8+3>>0]|0;q=f<<24>>24<0;Ex(m,q?c[n>>2]|0:n,q?c[n+4>>2]|0:f&255)|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];f=0;while(1){if((f|0)==3)break;c[m+(f<<2)>>2]=0;f=f+1|0}p2(d,k);O0(k);z5(n);z5(m)}else o=30;while(0);if((o|0)==30)p2(d,e);l=r;return}function vi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=b+376|0;g=b+552|0;h=b+612|0;j=b+568|0;f=b+492|0;if(a[d>>0]|0){if(!(a[f>>0]|0)){e=g;e=z0(c[h>>2]|0,0,c[e>>2]|0,c[e+4>>2]|0)|0;i=j;c[i>>2]=e;c[i+4>>2]=z}if(vh(b)|0)if(!(a[d>>0]|0))k=6;else k=23;else d=0}else k=6;do if((k|0)==6){e=b+728|0;if((c[e>>2]&2|0)==0?(l=g,n=c[l+4>>2]|0,i=b+640|0,m=c[i+4>>2]|0,!(n>>>0<m>>>0|((n|0)==(m|0)?(c[l>>2]|0)>>>0<(c[i>>2]|0)>>>0:0))):0){Kl(b);CI(b,0,0);d=0;break}i=b+56|0;if(!(nb[c[(c[b>>2]|0)+64>>2]&255](b)|0)){if(c[e>>2]&8|0)KM(b);if(a[f>>0]|0){d=0;break}n=i;if(!((c[n>>2]|0)==-1?(c[n+4>>2]|0)==-1:0)){d=0;break}m=g;m=z0(c[h>>2]|0,0,c[m>>2]|0,c[m+4>>2]|0)|0;j=z;n=b+632|0;l=c[n+4>>2]|0;if(j>>>0<l>>>0|((j|0)==(l|0)?m>>>0<(c[n>>2]|0)>>>0:0)){d=0;break}Kl(b);CI(b,0,0);d=0;break}a[d>>0]=1;if(!(a[f>>0]|0)){d=b+377|0;n=(a[d>>0]|0)==0;e=g;e=z0(c[h>>2]|0,0,c[e>>2]|0,c[e+4>>2]|0)|0;f=z;if(n){l=j;l=D_(e|0,f|0,c[l>>2]|0,c[l+4>>2]|0)|0;n=b+584|0;m=n;m=z0(l|0,z|0,c[m>>2]|0,c[m+4>>2]|0)|0;c[n>>2]=m;c[n+4>>2]=z}n=j;c[n>>2]=e;c[n+4>>2]=f;a[d>>0]=0}n=i;if((c[n>>2]|0)==-1?(c[n+4>>2]|0)==-1:0){jb[c[(c[b>>2]|0)+72>>2]&511](b);j=g;m=c[h>>2]|0;j=z0(m|0,0,c[j>>2]|0,c[j+4>>2]|0)|0;n=b+560|0;l=n;l=z0(j|0,z|0,c[l>>2]|0,c[l+4>>2]|0)|0;c[n>>2]=l;c[n+4>>2]=z;n=b+48|0;m=z0(c[n>>2]|0,c[n+4>>2]|0,m|0,0)|0;n=i;c[n>>2]=m;c[n+4>>2]=z}if(vh(b)|0)k=23;else d=0}while(0);if((k|0)==23)d=1;return d|0}function wi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;n=l;l=l+32|0;b=n+28|0;g=n+24|0;h=n+20|0;d=n+16|0;f=n+12|0;i=n+8|0;j=n+4|0;k=n;c[g>>2]=0;c[h>>2]=0;c[d>>2]=0;c[f>>2]=0;c[i>>2]=0;c[j>>2]=0;c[k>>2]=0;e=a+528|0;p=e;p=z0(c[p>>2]|0,c[p+4>>2]|0,1,0)|0;o=e;c[o>>2]=p;c[o+4>>2]=z;iF(a,6,0);jB(a,b);b=(c[b>>2]&197120|0)==197120;if(b){o=e;o=z0(c[o>>2]|0,c[o+4>>2]|0,4,0)|0;p=e;c[p>>2]=o;c[p+4>>2]=z;jB(a,g);jB(a,h);p=e;p=z0(c[p>>2]|0,c[p+4>>2]|0,2,0)|0;o=e;c[o>>2]=p;c[o+4>>2]=z;ID(a,d);ID(a,f);jB(a,i);jB(a,j);o=e;o=z0(c[o>>2]|0,c[o+4>>2]|0,1,0)|0;p=e;c[p>>2]=o;c[p+4>>2]=z;jB(a,k);Bx(a);p=a+648|0;G4(c[p>>2]|0,6);G4(c[p>>2]|0,5);G4(c[p>>2]|0,2);G4(c[p>>2]|0,3);wK(a)}if(qO(a)|0?(W5(a),Kc(a,1,-1)|0,m=a+20|0,RB(a,1,c[m>>2]|0,18,383567,-1,1,0),RB(a,1,c[m>>2]|0,58,383567,-1,1,0),b):0){d=c[d>>2]|0;b=c[f>>2]|0;if((d|0)!=0&(b|0)!=0)Bt(a,1,c[m>>2]|0,171,+(d>>>0)/+(b>>>0),3,0);i=c[i>>2]|0;o=c[j>>2]|0;p=c[g>>2]|0;lL(a,1,c[m>>2]|0,130,p,10,0);b=c[h>>2]|0;lL(a,1,c[m>>2]|0,138,b,10,0);Bt(a,1,c[m>>2]|0,156,((i|0)!=0&(o|0)!=0?+(i>>>0)/+(o>>>0):1.0)*(+(p>>>0)/+(b>>>0)),3,1);b=c[k>>2]|0;if(b|0)lL(a,1,c[m>>2]|0,124,b,10,0)}l=n;return}function xi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+32|0;p=q+12|0;o=q;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[p+(d<<2)>>2]=0;d=d+1|0}j=b+528|0;f=j;f=z0(c[f>>2]|0,c[f+4>>2]|0,8,0)|0;g=z;k=j;c[k>>2]=f;c[k+4>>2]=g;k=b+536|0;i=k;h=c[i>>2]|0;i=c[i+4>>2]|0;m=b+612|0;n=b+544|0;d=f;do{e=d;d=d+1|0;if(!(0<i>>>0|0==(i|0)&e>>>0<h>>>0))break}while((a[(c[n>>2]|0)+((c[m>>2]|0)+e)>>0]|0)!=0);g=D_(d|0,0,f|0,g|0)|0;EU(b,g,z,p);g=j;f=c[g>>2]|0;g=c[g+4>>2]|0;i=k;h=c[i>>2]|0;i=c[i+4>>2]|0;d=f;do{e=d;d=d+1|0;if(!(0<i>>>0|0==(i|0)&e>>>0<h>>>0))break}while((a[(c[n>>2]|0)+((c[m>>2]|0)+e)>>0]|0)!=0);i=D_(d|0,0,f|0,g|0)|0;iF(b,i,z);i=j;h=c[i>>2]|0;i=c[i+4>>2]|0;g=k;f=c[g>>2]|0;g=c[g+4>>2]|0;d=h;do{e=d;d=d+1|0;if(!(0<g>>>0|0==(g|0)&e>>>0<f>>>0))break}while((a[(c[n>>2]|0)+((c[m>>2]|0)+e)>>0]|0)!=0);n=D_(d|0,0,h|0,i|0)|0;iF(b,n,z);do if(qO(b)|0){Xy(o,24600);h=b+16|0;i=b+20|0;Rf(b,o,c[h>>2]|0,c[i>>2]|0,1);z5(o);d=c[h>>2]|0;e=c[i>>2]|0;RB(b,d,e,Rb(d,17)|0,377418,-1,1,1);d=a[p+11>>0]|0;e=d<<24>>24<0;f=e?c[p>>2]|0:p;g=j9(377423)|0;if(g|0?(n=f+(e?c[p+4>>2]|0:d&255)|0,o=tB(f,n,377423,377423+g|0)|0,(o|0)==(n|0)|(o-f|0)==-1):0)break;o=c[h>>2]|0;n=c[i>>2]|0;RB(b,o,n,Rb(o,0)|0,391414,-1,1,1)}while(0);a1(p);l=q;return}function yi(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=l;l=l+240|0;r=x;n=x+136|0;w=x+16|0;q=x+8|0;t=x+4|0;j=x+134|0;o=x+124|0;p=x+24|0;c[w>>2]=n;v=w+4|0;c[v>>2]=375;O4(t,g);m=c[t>>2]|0;b=u$(m,409116)|0;a[j>>0]=0;if(Vb(d,c[e>>2]|0,f,m,c[g+4>>2]|0,h,j,b,w,q,n+100|0)|0){rb[c[(c[b>>2]|0)+32>>2]&7](b,403269,403279,o)|0;m=c[q>>2]|0;f=c[w>>2]|0;b=m-f|0;if((b|0)>98){b=Ub(b+2|0)|0;if(!b)uaa();else{k=b;s=b}}else{k=p;s=0}if(!(a[j>>0]|0))b=k;else{a[k>>0]=45;b=k+1|0}k=o+10|0;n=o;j=f;g=b;b=m;while(1){if(j>>>0>=b>>>0)break;f=a[j>>0]|0;b=o;while(1){if((b|0)==(k|0)){b=k;break}if((a[b>>0]|0)==f<<24>>24)break;b=b+1|0}a[g>>0]=a[403269+(b-n)>>0]|0;j=j+1|0;g=g+1|0;b=c[q>>2]|0}a[g>>0]=0;c[r>>2]=i;if((GZ(p,0,r)|0)!=1)uaa();if(s|0)pe(s)}b=c[d>>2]|0;do if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))b=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0;else b=e9(a[f>>0]|0)|0;if(d8(b,-1)|0){c[d>>2]=0;g=1;break}else{g=(c[d>>2]|0)==0;break}}else g=1;while(0);b=c[e>>2]|0;do if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))b=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0;else b=e9(a[f>>0]|0)|0;if(!(d8(b,-1)|0))if(g)break;else{u=34;break}else{c[e>>2]=0;u=32;break}}else u=32;while(0);if((u|0)==32?g:0)u=34;if((u|0)==34)c[h>>2]=c[h>>2]|2;f=c[d>>2]|0;c6(t);b=c[w>>2]|0;c[w>>2]=0;if(b|0)jb[c[v>>2]&511](b);l=x;return f|0}function zi(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=l;l=l+16|0;t=u;r=u$(c[i>>2]|0,409148)|0;k=u$(c[i>>2]|0,409156)|0;kb[c[(c[k>>2]|0)+20>>2]&63](t,k);p=t+11|0;o=a[p>>0]|0;q=t+4|0;s=b;j=e;if((o<<24>>24<0?c[q>>2]|0:o&255)|0){c[h>>2]=f;i=a[b>>0]|0;switch(i<<24>>24){case 43:case 45:{n=tb[c[(c[r>>2]|0)+44>>2]&31](r,i)|0;o=c[h>>2]|0;c[h>>2]=o+4;c[o>>2]=n;b=b+1|0;break}default:{}}a:do if((j-b|0)>1?(a[b>>0]|0)==48:0){i=b+1|0;switch(a[i>>0]|0){case 88:case 120:break;default:break a}o=tb[c[(c[r>>2]|0)+44>>2]&31](r,48)|0;n=c[h>>2]|0;c[h>>2]=n+4;c[n>>2]=o;n=tb[c[(c[r>>2]|0)+44>>2]&31](r,a[i>>0]|0)|0;o=c[h>>2]|0;c[h>>2]=o+4;c[o>>2]=n;b=b+2|0}while(0);b:do if((b|0)!=(e|0)){i=e;j=b;while(1){i=i+-1|0;if(j>>>0>=i>>>0)break b;o=a[j>>0]|0;a[j>>0]=a[i>>0]|0;a[i>>0]=o;j=j+1|0}}while(0);o=nb[c[(c[k>>2]|0)+16>>2]&255](k)|0;n=b;i=0;j=0;while(1){if(n>>>0>=e>>>0)break;k=a[p>>0]|0;m=k<<24>>24<0;v=a[(m?c[t>>2]|0:t)+i>>0]|0;if(v<<24>>24!=0&(j|0)==(v<<24>>24|0)){j=c[h>>2]|0;c[h>>2]=j+4;c[j>>2]=o;i=(i>>>0<((m?c[q>>2]|0:k&255)+-1|0)>>>0&1)+i|0;j=0}m=tb[c[(c[r>>2]|0)+44>>2]&31](r,a[n>>0]|0)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=m;n=n+1|0;j=j+1|0}i=f+(b-s<<2)|0;b=c[h>>2]|0;if((i|0)!=(b|0)){while(1){b=b+-4|0;if(i>>>0>=b>>>0)break;v=c[i>>2]|0;c[i>>2]=c[b>>2];c[b>>2]=v;i=i+4|0}i=c[h>>2]|0}}else{rb[c[(c[r>>2]|0)+48>>2]&7](r,b,e,f)|0;i=f+(j-s<<2)|0;c[h>>2]=i}c[g>>2]=(d|0)==(e|0)?i:f+(d-s<<2)|0;a1(t);l=u;return}function Ai(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+32|0;d=n+12|0;f=n+8|0;j=n+4|0;k=n;m=n+16|0;GC(b);rR(b,2,d);e=c[d>>2]|0;if((e|0)==3){aR(b,2,j);i=(c[j>>2]|0)+3|0;c[d>>2]=i;d=i}else d=e;i=b+788|0;if(!d){rR(b,3,f);if((c[f>>2]|0)==7){aR(b,2,j);c[f>>2]=(c[j>>2]|0)+7}c[j>>2]=0;h=b+648|0;while(1){GC(b);rR(b,5,j);d=c[j>>2]|0;if((d|0)==31){aR(b,5,k);d=(c[k>>2]|0)+31|0;c[j>>2]=d}if(!d){d=11;break}zl(b);c[k>>2]=0;aR(b,8,k);g=Z9(c[(c[h>>2]|0)+4>>2]|0)|0;e=c[k>>2]<<3;g=g-e|0;GC(b);switch(d|0){case 11:{MA(b);break}case 14:{TQ(b);break}default:G4(c[h>>2]|0,e)}f=c[h>>2]|0;d=c[f+4>>2]|0;e=(Z9(d)|0)-g|0;if(e>>>0<8){qR(b,e&255,m);if(!(a[m>>0]|0)){f=c[h>>2]|0;d4(f,(Z9(c[f+4>>2]|0)|0)-g&255)}f=c[h>>2]|0;d=c[f+4>>2]|0}e=Z9(d)|0;if(e>>>0<=g>>>0){if(e>>>0<g>>>0){d=23;break}}else G4(f,e-g|0);J3(b);J3(b)}if((d|0)==11)J3(b);else if((d|0)==23){d=c[i>>2]|0;if(e>>>0<d>>>0)G4(f,e);else G4(f,e-d|0);J3(b);J3(b)}Os(b);J3(b)}else{k=c[b+648>>2]|0;m=Z9(c[k+4>>2]|0)|0;G4(k,m-(c[i>>2]|0)|0);J3(b)}l=n;return}function Bi(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+48|0;h=m+40|0;e=m+36|0;i=m+24|0;j=m+12|0;f=m;yE(d,h);k=d+20|0;do if((b[h>>1]|0)==28019){MK(d);NB(d,e);if((c[d+784>>2]|0)>>>0>1)break;if(qO(d)|0){$x(i,d,2,c[k>>2]|0,46,1);e=b[e>>1]|0;rU(j,e,16);g=a[i+8+3>>0]|0;f=g<<24>>24<0;g=f?c[i+4>>2]|0:g&255;n=a[j+8+3>>0]|0;h=n<<24>>24<0;if(!((g|0)==((h?c[j+4>>2]|0:n&255)|0)?!(L$(f?c[i>>2]|0:i,h?c[j>>2]|0:j,g)|0):0)){Ed(d,2,c[k>>2]|0,46);Rf(d,j,2,c[k>>2]|0,3)}kL(d,2,c[k>>2]|0,52,e,16,1);kL(d,2,c[k>>2]|0,57,e,16,1);z5(j);z5(i)}}else{r3(d,e);if((c[d+784>>2]|0)>>>0>1)break;if(qO(d)|0){h=c[e>>2]|0;if((h|0)!=1836069985){$x(i,d,2,c[k>>2]|0,46,1);TX(f);p2(j,lh(f,h)|0);z5(f);f=a[i+8+3>>0]|0;e=f<<24>>24<0;f=e?c[i+4>>2]|0:f&255;n=a[j+8+3>>0]|0;g=n<<24>>24<0;if(!((f|0)==((g?c[j+4>>2]|0:n&255)|0)?!(L$(e?c[i>>2]|0:i,g?c[j>>2]|0:j,f)|0):0)){Ed(d,2,c[k>>2]|0,46);Rf(d,j,2,c[k>>2]|0,1)}z5(j);z5(i)}n=c[k>>2]|0;TX(i);zb(d,2,n,52,lh(i,h)|0,1);z5(i);n=c[k>>2]|0;TX(i);zb(d,2,n,57,lh(i,h)|0,1);z5(i)}}while(0);l=m;return}function Ci(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=l;l=l+32|0;f=g+12|0;e=g;d=b+536|0;switch((c[b+520>>2]&65535)<<16>>16){case 0:{kl(b);break}case 1:{G$(b);break}case 2:{fR(b);break}case 3:{G$(b);break}case 4:{V_(b);break}case 5:{G$(b);break}case 6:{rj(b);break}default:{h=d;e1(b,c[h>>2]|0,c[h+4>>2]|0)}}if(a[b+891>>0]|0){if(!(a[b+492>>0]|0)){k=b+40|0;j=b+48|0;i=c[b+612>>2]|0;h=d;d=c[h>>2]|0;h=c[h+4>>2]|0;j=D_(c[k>>2]|0,c[k+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0;i=D_(j|0,z|0,i|0,0)|0;h=D_(i|0,z|0,d|0,h|0)|0;oK(b,2,0,194,h,z,10,0)}$x(f,b,2,0,128,1);k=a[f+8+3>>0]|0;a:do if(!((k<<24>>24<0?c[f+4>>2]|0:k&255)|0)){$x(e,b,2,0,129,1);k=a[e+8+3>>0]|0;k=((k<<24>>24<0?c[e+4>>2]|0:k&255)|0)==0;z5(e);z5(f);if(k){$x(f,b,2,0,122,1);k=sn(f)|0;z5(f);switch(k|0){case 1:{d=4;break}case 2:{d=3;break}case 3:{d=7;break}case 4:{d=1539;break}case 5:{d=1543;break}case 6:{d=1551;break}case 7:{d=1807;break}case 8:{d=1599;break}default:break a}Xo(f,d);bw(b,2,0,128,f,1,0);a1(f);xk(f,d);bw(b,2,0,129,f,1,0);a1(f)}}else z5(f);while(0);xp(b+760|0,372535)}l=g;return}function Di(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;s=l;l=l+16|0;r=s;p=u$(c[i>>2]|0,409116)|0;k=u$(c[i>>2]|0,409132)|0;kb[c[(c[k>>2]|0)+20>>2]&63](r,k);n=r+11|0;m=a[n>>0]|0;o=r+4|0;q=b;j=e;if((m<<24>>24<0?c[o>>2]|0:m&255)|0){c[h>>2]=f;i=a[b>>0]|0;switch(i<<24>>24){case 43:case 45:{i=tb[c[(c[p>>2]|0)+28>>2]&31](p,i)|0;m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=i;b=b+1|0;break}default:{}}a:do if((j-b|0)>1?(a[b>>0]|0)==48:0){i=b+1|0;switch(a[i>>0]|0){case 88:case 120:break;default:break a}m=tb[c[(c[p>>2]|0)+28>>2]&31](p,48)|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=m;j=tb[c[(c[p>>2]|0)+28>>2]&31](p,a[i>>0]|0)|0;m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=j;b=b+2|0}while(0);b:do if((b|0)!=(e|0)){i=e;j=b;while(1){i=i+-1|0;if(j>>>0>=i>>>0)break b;m=a[j>>0]|0;a[j>>0]=a[i>>0]|0;a[i>>0]=m;j=j+1|0}}while(0);m=nb[c[(c[k>>2]|0)+16>>2]&255](k)|0;k=b;i=0;j=0;while(1){if(k>>>0>=e>>>0)break;t=a[((a[n>>0]|0)<0?c[r>>2]|0:r)+i>>0]|0;if(t<<24>>24!=0&(j|0)==(t<<24>>24|0)){j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=m;j=a[n>>0]|0;i=(i>>>0<((j<<24>>24<0?c[o>>2]|0:j&255)+-1|0)>>>0&1)+i|0;j=0}u=tb[c[(c[p>>2]|0)+28>>2]&31](p,a[k>>0]|0)|0;t=c[h>>2]|0;c[h>>2]=t+1;a[t>>0]=u;k=k+1|0;j=j+1|0}i=f+(b-q)|0;b=c[h>>2]|0;if((i|0)!=(b|0)){while(1){b=b+-1|0;if(i>>>0>=b>>>0)break;u=a[i>>0]|0;a[i>>0]=a[b>>0]|0;a[b>>0]=u;i=i+1|0}i=c[h>>2]|0}}else{rb[c[(c[p>>2]|0)+32>>2]&7](p,b,e,f)|0;i=f+(j-q)|0;c[h>>2]=i}c[g>>2]=(d|0)==(e|0)?i:f+(d-q)|0;a1(r);l=s;return}function Ei(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=l;l=l+576|0;r=x;n=x+64|0;w=x+56|0;q=x+52|0;t=x+48|0;j=x+564|0;o=x+8|0;p=x+464|0;c[w>>2]=n;v=w+4|0;c[v>>2]=375;O4(t,g);m=c[t>>2]|0;b=u$(m,409148)|0;a[j>>0]=0;if(Yb(d,c[e>>2]|0,f,m,c[g+4>>2]|0,h,j,b,w,q,n+400|0)|0){rb[c[(c[b>>2]|0)+48>>2]&7](b,403375,403385,o)|0;m=c[q>>2]|0;f=c[w>>2]|0;b=m-f|0;if((b|0)>392){b=Ub((b>>>2)+2|0)|0;if(!b)uaa();else{k=b;s=b}}else{k=p;s=0}if(!(a[j>>0]|0))b=k;else{a[k>>0]=45;b=k+1|0}k=o+40|0;n=o;j=f;g=b;b=m;while(1){if(j>>>0>=b>>>0)break;f=c[j>>2]|0;b=o;while(1){if((b|0)==(k|0)){b=k;break}if((c[b>>2]|0)==(f|0))break;b=b+4|0}a[g>>0]=a[403375+(b-n>>2)>>0]|0;j=j+4|0;g=g+1|0;b=c[q>>2]|0}a[g>>0]=0;c[r>>2]=i;if((GZ(p,0,r)|0)!=1)uaa();if(s|0)pe(s)}b=c[d>>2]|0;do if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))b=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0;else b=raa(c[f>>2]|0)|0;if(d8(b,-1)|0){c[d>>2]=0;g=1;break}else{g=(c[d>>2]|0)==0;break}}else g=1;while(0);b=c[e>>2]|0;do if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))b=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0;else b=raa(c[f>>2]|0)|0;if(!(d8(b,-1)|0))if(g)break;else{u=34;break}else{c[e>>2]=0;u=32;break}}else u=32;while(0);if((u|0)==32?g:0)u=34;if((u|0)==34)c[h>>2]=c[h>>2]|2;f=c[d>>2]|0;c6(t);b=c[w>>2]|0;c[w>>2]=0;if(b|0)jb[c[v>>2]&511](b);l=x;return f|0}function Fi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+32|0;i=n+12|0;j=n;g=n+25|0;h=n+24|0;GC(b);c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;xR(b,2,b+949|0);AT(b,b+953|0);f=b+950|0;xR(b,5,f);GC(b);m=b+648|0;e=0;while(1){if((e&255)>=32)break;if(e<<24>>24==(a[f>>0]|0))AT(b,g);else A6(c[m>>2]|0);e=e+1<<24>>24}J3(b);AT(b,b+954|0);AT(b,b+955|0);A6(c[m>>2]|0);AT(b,b+956|0);d4(c[m>>2]|0,44);xR(b,8,b+951|0);k=d&255;e=0;while(1){if((e|0)==(k|0))break;GC(b);AT(b,g);AT(b,h);CB(i,g);CB(j,h);J3(b);e=e+1|0}a:do if(d<<24>>24){e=k;while(1){if(e>>>0>=8)break a;d4(c[m>>2]|0,2);e=e+1|0}}while(0);h=c[i>>2]|0;f=c[j>>2]|0;e=0;while(1){if((e|0)==(k|0))break;GC(b);d=e>>>5;g=1<<(e&31);if(c[h+(d<<2)>>2]&g|0){d4(c[m>>2]|0,2);A6(c[m>>2]|0);d4(c[m>>2]|0,5);d4(c[m>>2]|0,32);A6(c[m>>2]|0);A6(c[m>>2]|0);A6(c[m>>2]|0);A6(c[m>>2]|0);d4(c[m>>2]|0,44)}if(c[f+(d<<2)>>2]&g|0)d4(c[m>>2]|0,8);J3(b);e=e+1|0}J3(b);s8(f);s8(h);l=n;return}function Gi(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0;j=l;l=l+16|0;h=j;i=Kk(a,b,d,e)|0;m=f+8|0;g=e+8|0;k=g;if(M$(c[m>>2]|0,c[m+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0){c[h>>2]=c[e>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];c[e>>2]=c[f>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[f>>2]=c[h>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];f=i+1|0;k=g;g=d+8|0;m=g;if(M$(c[k>>2]|0,c[k+4>>2]|0,c[m>>2]|0,c[m+4>>2]|0)|0){c[h>>2]=c[d>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];f=i+2|0;k=g;g=b+8|0;m=g;if(M$(c[k>>2]|0,c[k+4>>2]|0,c[m>>2]|0,c[m+4>>2]|0)|0){c[h>>2]=c[b>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[d>>2]=c[h>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];k=g;m=a+8|0;if(M$(c[k>>2]|0,c[k+4>>2]|0,c[m>>2]|0,c[m+4>>2]|0)|0){c[h>>2]=c[a>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[b>>2]=c[h>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];f=i+4|0}else f=i+3|0}}}else f=i;l=j;return f|0}function Hi(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;a:do if((c[b+548>>2]|0)>>>0<768)d=1;else{h=c[b+544>>2]|0;e=V8(h)|0;f=z;d=XZ(e|0,f|0,40)|0;if(!((f|0)==807842421|((f|0)==1146111792|((f|0)==2135247942|((d|0)==4607062|((d|0)==4609875|((e|0)==1230127427&(f|0)==1264004420|(f|0)==1380533830))))))?!(0==0&(f&-65536|0)==1297743872|(f|0)==440786851):0){d=h8(h)|0;if((d|0)==1&(z|0)==0?(d7(a[h+14>>0]|0,a[h+15>>0]|0)|0)<<16>>16==-7710:0){z$(b);d=0;break}d=C9(h+4|0)|0;b:do if((d|0)<1835295092)if((d|0)<1718909296)switch(d|0){case 1718773093:{g=9;break b}default:break b}else switch(d|0){case 1718909296:{g=9;break b}default:break b}else if((d|0)<1936419184)switch(d|0){case 1835295092:{g=9;break b}default:break b}else switch(d|0){case 1936419184:{g=9;break b}default:break b}while(0);if((g|0)==9){z$(b);d=0;break}if((e|0)==927586833&(f|0)==-1210580960?(g=V8(h+8|0)|0,(g|0)==-379671155&(z|0)==-1504837625):0){z$(b);d=0;break}else e=0;while(1){if(e>>>0>=188){g=17;break}if((a[h+e>>0]|0)==71){g=16;break}e=e+1|0}if((g|0)==16){d=b+728|0;if(((a[h+(e+188)>>0]|0)==71?(a[h+(e+376)>>0]|0)==71:0)?(a[h+(e+564)>>0]|0)==71:0){c[d>>2]=c[d>>2]|8;d=0;break}}else if((g|0)==17)d=b+728|0;e=0;while(1){if(e>>>0>=192){d=1;break a}f=h+e|0;if((D9(a[f+4>>0]|0)|0)<<24>>24==71)break;e=e+1|0}if((D9(a[f+192+4>>0]|0)|0)<<24>>24!=71){d=1;break}if((D9(a[f+384+4>>0]|0)|0)<<24>>24!=71){d=1;break}if((D9(a[f+576+4>>0]|0)|0)<<24>>24!=71){d=1;break}c[d>>2]=c[d>>2]|8;d=0;break}z$(b);d=0}while(0);return d|0}function Ii(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+112|0;b=p+32|0;g=p+96|0;i=p+84|0;j=p+72|0;k=p+60|0;m=p+48|0;n=p+16|0;o=p;L2(b);HB(a,p+100|0);bD(a,g);j0(a,b);if(qO(a)|0){f=b+8|0;e=c[f>>2]|0;f=c[f+4>>2]|0;h=a+20|0;d=b;b=c[d>>2]|0;d=c[d+4>>2]|0;if((e|0)==4096&(f&65535|0)==0&((b|0)==3709809&(d|0)==-2147483478)){d=XZ(e|0,f|0,40)|0;o=XZ(e|0,f|0,56)|0;o=(d&65280|o)&65535;TX(i);d=Ek(i,o,16)|0;Rf(a,d,2,c[h>>2]|0,3);z5(i);$x(i,a,2,c[h>>2]|0,46,1);d=c[h>>2]|0;TX(m);dX(n,3709809,-2147483478,e,f);dh(m,n)|0;ms(k,21812,m);p2(j,k);zb(a,2,d,46,j,1);z5(j);O0(k);z5(m);n=c[h>>2]|0;TX(j);zb(a,2,n,52,UJ(Ek(j,o,16)|0,1)|0,1);z5(j);z5(i)}else{TX(i);dX(o,b,d,e,f);o=dh(i,o)|0;Rf(a,o,2,c[h>>2]|0,3);z5(i)}o=c[h>>2]|0;n=c[g>>2]|0;Xo(i,n);bw(a,2,o,128,i,1,0);a1(i);o=c[h>>2]|0;xk(i,n);bw(a,2,o,129,i,1,0);a1(i)}l=p;return}function Ji(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;r=l;l=l+32|0;i=r+31|0;h=r+20|0;j=r+30|0;k=r+29|0;m=r+28|0;n=r+8|0;o=r;p=r+16|0;bB(b,i);jB(b,r+24|0);g=b+528|0;e=g;e=z0(c[e>>2]|0,c[e+4>>2]|0,4,0)|0;f=g;c[f>>2]=e;c[f+4>>2]=z;Bx(b);d4(c[b+648>>2]|0,26);xR(b,2,j);xR(b,2,k);xR(b,2,m);wK(b);ID(b,h);h=c[h>>2]|0;i=(a[i>>0]|0)==0;j=a[j>>0]|0;k=a[k>>0]|0;m=a[m>>0]|0;f=0;while(1){if((f|0)==(h|0))break;GC(b);if(i){ID(b,p);e=n;c[e>>2]=c[p>>2];c[e+4>>2]=0;ID(b,p);e=o;c[e>>2]=c[p>>2];c[e+4>>2]=0}else{oz(b,n);oz(b,o)}switch(j<<24>>24){case 0:{d=1;e=0;q=11;break}case 1:{d=2;e=0;q=11;break}case 2:{d=3;e=0;q=11;break}case 3:{d=4;e=0;q=11;break}default:{}}if((q|0)==11){q=0;s=g;d=z0(c[s>>2]|0,c[s+4>>2]|0,d|0,e|0)|0;e=g;c[e>>2]=d;c[e+4>>2]=z}switch(k<<24>>24){case 0:{d=1;e=0;q=16;break}case 1:{d=2;e=0;q=16;break}case 2:{d=3;e=0;q=16;break}case 3:{d=4;e=0;q=16;break}default:{}}if((q|0)==16){q=0;s=g;e=z0(c[s>>2]|0,c[s+4>>2]|0,d|0,e|0)|0;s=g;c[s>>2]=e;c[s+4>>2]=z}switch(m<<24>>24){case 0:{d=1;e=0;q=21;break}case 1:{d=2;e=0;q=21;break}case 2:{d=3;e=0;q=21;break}case 3:{d=4;e=0;q=21;break}default:{}}if((q|0)==21){q=0;s=g;e=z0(c[s>>2]|0,c[s+4>>2]|0,d|0,e|0)|0;s=g;c[s>>2]=e;c[s+4>>2]=z}J3(b);f=f+1|0}l=r;return}function Ki(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=l;l=l+464|0;z=A+456|0;s=A+460|0;t=A+452|0;u=A+448|0;w=A+436|0;x=A+424|0;y=A+412|0;m=A+408|0;n=A+8|0;p=A+4|0;q=A;O4(z,f);i=c[z>>2]|0;r=u$(i,409148)|0;j=h+8+3|0;o=a[j>>0]|0;b=o<<24>>24<0;k=h+4|0;if(!((b?c[k>>2]|0:o&255)|0))o=0;else{o=c[(b?c[h>>2]|0:h)>>2]|0;o=(o|0)==(tb[c[(c[r>>2]|0)+44>>2]&31](r,45)|0)}c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[w+(b<<2)>>2]=0;b=b+1|0}c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[x+(b<<2)>>2]=0;b=b+1|0}c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[y+(b<<2)>>2]=0;b=b+1|0}je(e,o,i,s,t,u,w,x,y,m);j=a[j>>0]|0;e=j<<24>>24<0;j=e?c[k>>2]|0:j&255;i=c[m>>2]|0;k=(j|0)>(i|0);b=a[x+8+3>>0]|0;b=b<<24>>24<0?c[x+4>>2]|0:b&255;m=a[y+8+3>>0]|0;m=m<<24>>24<0?c[y+4>>2]|0:m&255;b=(k?1:2)+i+(k?b:m)+(k?m+(j-i<<1)|0:b)|0;if(b>>>0>100){b=Ub(b<<2)|0;if(!b)uaa();else{v=b;B=b}}else{v=n;B=0}b=e?c[h>>2]|0:h;Hf(v,p,q,c[f+4>>2]|0,b,b+(j<<2)|0,r,o,s,c[t>>2]|0,c[u>>2]|0,w,x,y,i);b=bn(c[d>>2]|0,v,c[p>>2]|0,c[q>>2]|0,f,g)|0;if(B|0)pe(B);O0(y);O0(x);a1(w);c6(z);l=A;return b|0}function Li(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[b+(f<<2)>>2]=0;f=f+1|0}if(!((d&14|0)==0&0==0))JX(b,379364)|0;if(!((d&2|0)==0&0==0))JX(b,379371)|0;if(!((d&8|0)==0&0==0))JX(b,379374)|0;if(!((d&4|0)==0&0==0))JX(b,379377)|0;h=b+4|0;g=b+11|0;if(!((d&3072|0)==0&0==0)){f=a[g>>0]|0;if(f<<24>>24<0)f=c[h>>2]|0;else f=f&255;if(f|0)JX(b,404778)|0;JX(b,377077)|0}if(!((d&1024|0)==0&0==0))JX(b,379371)|0;if(!((d&2048|0)==0&0==0))JX(b,379377)|0;if(!((d&608|0)==0&0==0)){f=a[g>>0]|0;if(f<<24>>24<0)f=c[h>>2]|0;else f=f&255;if(f|0)JX(b,404778)|0;JX(b,377083)|0}if(!((d&32|0)==0&0==0))JX(b,379371)|0;if(!((d&512|0)==0&0==0))JX(b,379374)|0;if(!((d&64|0)==0&0==0))JX(b,379377)|0;if(!((d&16|0)==0&0==0)){f=a[g>>0]|0;if(f<<24>>24<0)f=c[h>>2]|0;else f=f&255;if(f|0)JX(b,404778)|0;JX(b,377071)|0}d=0!=0|(e&192|0)!=0;if(d){f=a[g>>0]|0;if(f<<24>>24<0)f=c[h>>2]|0;else f=f&255;if(f|0)JX(b,404778)|0;JX(b,379364)|0}if(!(0==0&(e&64|0)==0))JX(b,379371)|0;if(!(0==0&(e&128|0)==0))JX(b,379377)|0;if(d)JX(b,377089)|0;return}function Mi(a){a=a|0;do switch(a|0){case 1:{a=382628;break}case 2:{a=382618;break}case 3:{a=382608;break}case 4:{a=382597;break}case 5:{a=382587;break}case 6:{a=382577;break}case 8:{a=382567;break}case 9:{a=382556;break}case 16:{a=382537;break}case 17:{a=382518;break}case 18:{a=382499;break}case 21:{a=391410;break}case 33:{a=382491;break}case 34:{a=382483;break}case 50:{a=385566;break}case 51:{a=385558;break}case 52:{a=385550;break}case 66:{a=382474;break}case 81:{a=382454;break}case 97:{a=382429;break}case 98:{a=382404;break}case 99:{a=382390;break}case 100:{a=382376;break}case 113:{a=382350;break}case 114:{a=382324;break}case 127:{a=391410;break}case 129:{a=382314;break}case 130:{a=382304;break}case 145:{a=382275;break}case 146:{a=382246;break}case 147:{a=382217;break}case 148:{a=382188;break}case 161:{a=382171;break}case 162:{a=382154;break}case 163:{a=382137;break}case 177:{a=382107;break}case 178:{a=382077;break}case 179:{a=382047;break}case 180:{a=382017;break}case 193:{a=382e3;break}case 194:{a=381983;break}case 209:{a=381954;break}case 210:{a=381925;break}case 211:{a=381896;break}case 225:{a=381879;break}case 226:{a=381862;break}case 227:{a=381845;break}case 228:{a=381828;break}case 229:{a=381813;break}case 230:{a=381798;break}case 231:{a=381783;break}case 232:{a=381768;break}case 235:{a=381751;break}case 236:{a=381734;break}case 240:{a=381715;break}case 241:{a=381696;break}case 242:{a=381677;break}case 243:{a=381658;break}case 244:{a=381639;break}case 245:{a=381620;break}case 247:{a=381600;break}case 248:{a=381571;break}case 249:{a=381542;break}case 250:{a=381513;break}case 251:{a=381484;break}case 252:{a=381455;break}case 253:{a=381426;break}default:a=8800948}while(0);return a|0}function Ni(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+32|0;m=o+4|0;d=o+16|0;h=o;e=b+20|0;RB(b,2,c[e>>2]|0,122,8800948,-1,1,1);$x(m,b,2,c[e>>2]|0,46,1);e=i9(24384)|0;g=a[m+8+3>>0]|0;n=b+761|0;if((e|0)==((g<<24>>24<0?c[m+4>>2]|0:g&255)|0)){g=(VG(m,24384,e)|0)==0;z5(m);if(g){bB(b,m);if((a[m>>0]|0)==1){bB(b,d);e=b+536|0;d=b+528|0;d=D_(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e1(b,d,z);d=b+916|0;e=b+788|0;g=bF(d,e)|0;if((c[g+12>>2]|0)==(c[g+16>>2]|0)){g=ZW(1584)|0;on(g);aY(b,g);f=g+760|0;c[f>>2]=2;c[f+4>>2]=0;d=bF(d,e)|0;c[h>>2]=g;e=d+16|0;f=c[e>>2]|0;if(f>>>0<(c[d+20>>2]|0)>>>0){c[f>>2]=g;c[e>>2]=(c[e>>2]|0)+4}else Yy(d+12|0,h);a[n>>0]=1}}else{h=b+536|0;e1(b,c[h>>2]|0,c[h+4>>2]|0)}}else i=13}else{z5(m);i=13}if(((i|0)==13?(c[b+784>>2]|0)>>>0<=1:0)?(j=b+916|0,k=b+788|0,i=bF(j,k)|0,(c[i+12>>2]|0)==(c[i+16>>2]|0)):0){g=ZW(1584)|0;on(g);aY(b,g);a[g+768>>0]=1;d=bF(j,k)|0;c[m>>2]=g;e=d+16|0;f=c[e>>2]|0;if(f>>>0<(c[d+20>>2]|0)>>>0){c[f>>2]=g;c[e>>2]=(c[e>>2]|0)+4}else Yy(d+12|0,m);a[n>>0]=1;rB(b,g)}l=o;return}function Oi(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;q=b+492|0;d=a[q>>0]|0;p=b+928|0;s=b+48|0;t=b+528|0;v=b+936|0;u=b+612|0;n=b+40|0;r=b+728|0;if(!(d<<24>>24)){f=n;e=c[f>>2]|0;f=c[f+4>>2]|0;i=p;h=c[i>>2]|0;i=c[i+4>>2]|0;k=v;j=c[k>>2]|0;k=c[k+4>>2]|0;m=z0(j|0,k|0,h|0,i|0)|0;l=z;if((f>>>0>l>>>0|(f|0)==(l|0)&e>>>0>m>>>0?(w=s,w=z0(c[u>>2]|0,0,c[w>>2]|0,c[w+4>>2]|0)|0,l=t,l=z0(w|0,z|0,c[l>>2]|0,c[l+4>>2]|0)|0,w=z,m=D_(e|0,f|0,j|0,k|0)|0,k=z,(w>>>0>i>>>0|(w|0)==(i|0)&l>>>0>h>>>0)&(w>>>0<k>>>0|(w|0)==(k|0)&l>>>0<m>>>0)):0)?+g[(c[b+24>>2]|0)+136>>2]<=.5:0)o=6}else if(c[r>>2]&2|0)o=6;do if((o|0)==6){e=d<<24>>24!=0;l=b+990|0;m=b+924|0;if((a[b+378>>0]|0)!=0?(o=b+312|0,j=c[o+4>>2]|0,w=b+768|0,k=c[w+4>>2]|0,j>>>0<k>>>0|((j|0)==(k|0)?(c[o>>2]|0)>>>0<(c[w>>2]|0)>>>0:0)):0){if(e)break;k=n;j=c[k>>2]|0;k=c[k+4>>2]|0;e=p;e=UW(c[e>>2]|0,c[e+4>>2]|0,10,0)|0;f=z;h=v;h=UW(c[h>>2]|0,c[h+4>>2]|0,10,0)|0;i=z;w=z0(h|0,i|0,e|0,f|0)|0;p=z;if(!(k>>>0>p>>>0|(k|0)==(p|0)&j>>>0>w>>>0))break;s=z0(c[u>>2]|0,0,c[s>>2]|0,c[s+4>>2]|0)|0;u=t;u=z0(s|0,z|0,c[u>>2]|0,c[u+4>>2]|0)|0;s=z;w=D_(j|0,k|0,h|0,i|0)|0;t=z;if(!((s>>>0>f>>>0|(s|0)==(f|0)&u>>>0>e>>>0)&(s>>>0<t>>>0|(s|0)==(t|0)&u>>>0<w>>>0)))break;c[m>>2]=-1;a[l>>0]=-1;o=13}else o=12;if((o|0)==12?(c[m>>2]=-1,a[l>>0]=-1,!e):0)o=13;if((o|0)==13)a[(c[b+780>>2]|0)+2>>0]=0;if(!(c[r>>2]&2)){t6(b);d=a[q>>0]|0}if(!(d<<24>>24))Kl(b);w=v;y0(b,c[w>>2]|0,c[w+4>>2]|0);a[b+379>>0]=1}while(0);return}function Pi(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+16|0;i=p+6|0;e=p+5|0;j=p+4|0;k=p+3|0;m=p+2|0;n=p+1|0;o=p;GC(b);AT(b,i);if(a[i>>0]|0){i=b+648|0;d4(c[i>>2]|0,4);d4(c[i>>2]|0,4)}AT(b,e);xg(b,0);e=a[e>>0]|0;f=e<<24>>24==0;a:do if(f)xg(b,1);else{g=b+22116|0;i=c[g>>2]|0;a[i+10>>0]=a[i+9>>0]|0;i=c[g>>2]|0;a[i+28>>0]=a[i+27>>0]|0;g=c[g>>2]|0;i=d[g+9>>0]|0;h=0;while(1){if((h|0)==(i|0))break a;a[g+19+h>>0]=a[g+11+h>>0]|0;h=h+1|0}}while(0);jC(b,0);jC(b,1);LN(b);if(f){LN(b);fn(b,0,0);fn(b,1,0);ct(b,0,0)}else{fn(b,0,1);ct(b,0,1);fn(b,1,1)}ct(b,1,e<<24>>24!=0);AT(b,j);if(a[j>>0]|0)cN(b);AT(b,j);if(a[j>>0]|0)cN(b);AT(b,k);do if(a[k>>0]|0){xR(b,4,m);m=a[m>>0]|0;e=m&255;if(m<<24>>24==15){xR(b,8,n);e=(d[n>>0]|0)+e|0}k=b+648|0;g=c[k>>2]|0;j=c[g+4>>2]|0;f=Z9(j)|0;e=e<<3;if(f>>>0<e>>>0){G4(g,f);break}h=f-e|0;i=h+7|0;f=g;e=j;while(1){e=Z9(e)|0;if(e>>>0<=i>>>0)break;xR(b,2,o);if((a[o>>0]|0)==2)ic(b,h);e=c[k>>2]|0;f=e;e=c[e+4>>2]|0}if(e>>>0>h>>>0)G4(f,e-h|0)}while(0);J3(b);l=p;return}function Qi(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=l;l=l+160|0;z=A+48|0;s=A+156|0;t=A+153|0;u=A+152|0;w=A+36|0;x=A+24|0;y=A+12|0;m=A+8|0;n=A+52|0;p=A+4|0;q=A;O4(z,f);i=c[z>>2]|0;r=u$(i,409116)|0;j=h+11|0;o=a[j>>0]|0;b=o<<24>>24<0;k=h+4|0;if(!((b?c[k>>2]|0:o&255)|0))o=0;else{o=a[(b?c[h>>2]|0:h)>>0]|0;o=o<<24>>24==(tb[c[(c[r>>2]|0)+28>>2]&31](r,45)|0)<<24>>24}c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[w+(b<<2)>>2]=0;b=b+1|0}c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[x+(b<<2)>>2]=0;b=b+1|0}c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[y+(b<<2)>>2]=0;b=b+1|0}le(e,o,i,s,t,u,w,x,y,m);j=a[j>>0]|0;e=j<<24>>24<0;j=e?c[k>>2]|0:j&255;i=c[m>>2]|0;k=(j|0)>(i|0);b=a[x+11>>0]|0;m=a[y+11>>0]|0;b=b<<24>>24<0?c[x+4>>2]|0:b&255;m=m<<24>>24<0?c[y+4>>2]|0:m&255;b=(k?1:2)+i+(k?b:m)+(k?m+(j-i<<1)|0:b)|0;if(b>>>0>100){b=Ub(b)|0;if(!b)uaa();else{v=b;B=b}}else{v=n;B=0}b=e?c[h>>2]|0:h;Kf(v,p,q,c[f+4>>2]|0,b,b+j|0,r,o,s,a[t>>0]|0,a[u>>0]|0,w,x,y,i);b=Qo(c[d>>2]|0,v,c[p>>2]|0,c[q>>2]|0,f,g)|0;if(B|0)pe(B);a1(y);a1(x);a1(w);c6(z);l=A;return b|0}function Ri(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+32|0;j=o+16|0;k=o;f=b+1|0;g=a[f>>0]|0;switch(g<<24>>24){case 33:case 94:{g=b+2|0;f=g;b=1;g=a[g>>0]|0;break}default:b=0}a:do switch(g<<24>>24){case 93:if((d|0)==93){b=b^1;break a}else{f=f+1|0;n=10;break a}case 45:if((d|0)==45){b=b^1;break a}else{f=f+1|0;n=10;break a}default:n=10}while(0);b:do if((n|0)==10){c[j>>2]=a[f+-1>>0];c:while(1){h=a[f>>0]|0;d:do switch(h<<24>>24){case 93:break b;case 45:{g=f+1|0;if((a[g>>0]|0)==93)n=31;else{g=fq(k,g,4)|0;if((g|0)<0){b=0;break c}h=c[j>>2]|0;i=c[k>>2]|0;if((i|0)>=(h|0)?(i=i-h|0,!((d-h|0)>>>0>i>>>0&(e-h|0)>>>0>i>>>0)):0){n=16;break c}f=f+(g+-1)|0}break}case 91:{i=a[f+1>>0]|0;switch(i<<24>>24){case 61:case 46:case 58:break;default:{n=31;break d}}h=f+3|0;while(1){g=h+-1|0;if((a[g>>0]|0)==i<<24>>24?(a[h>>0]|0)==93:0)break;h=h+1|0}f=f+2|0;if(i<<24>>24==58?(m=g-f|0,(m|0)<16):0){no(k|0,f|0,m|0)|0;a[k+m>>0]=0;f=aS(k)|0;if(Pz(d,f)|0){n=29;break c}if(Pz(e,f)|0){n=29;break c}f=h}else f=h;break}default:if(h<<24>>24>-1)n=31;else{g=fq(j,f,4)|0;if((g|0)<0){b=0;break b}f=f+(g+-1)|0;g=c[j>>2]|0;n=34}}while(0);if((n|0)==31){g=h&255;c[j>>2]=g;n=34}if((n|0)==34){n=0;if((g|0)==(d|0)|(g|0)==(e|0)){n=35;break}}f=f+1|0}if((n|0)==16)b=b^1;else if((n|0)==29){b=b^1;break}else if((n|0)==35){b=b^1;break}}while(0);l=o;return b|0}function Si(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+32|0;m=n+4|0;f=n;g=n+16|0;if(!(a[b+769>>0]|0)){k=b+528|0;h=b+612|0;if(!(a[b+770>>0]|0)){o=(a[(c[b+544>>2]|0)+((c[h>>2]|0)+2)>>0]|0)==0;f=k;g=c[f>>2]|0;f=c[f+4>>2]|0;h=z0(g|0,f|0,1,0)|0;i=z;if(o){g=k;c[g>>2]=h;c[g+4>>2]=i;g=h;f=i}i=z0(g|0,f|0,3,0)|0;o=k;c[o>>2]=i;c[o+4>>2]=z;Bx(b);RS(b);xR(b,2,b+1044|0);xR(b,5,m);wK(b);if(Pp(b)|0)j=20;else c3(c[b+508>>2]|0,c[b+668>>2]|0)}else{switch(a[b+876>>0]|0){case 0:{bB(b,g);c[f>>2]=d[g>>0];break}case 1:{NB(b,g);c[f>>2]=e[g>>1];break}case 2:{jB(b,f);break}case 3:{ID(b,f);break}default:{t4(b);c[f>>2]=(c[b+548>>2]|0)-(c[h>>2]|0)}}Bx(b);RS(b);xR(b,2,b+1044|0);xR(b,5,m);wK(b);if(qO(b)|0){f=c[f>>2]|0;if(!f){f=(c[b+548>>2]|0)-(c[h>>2]|0)|0;g=0}else{g=k;o=c[g>>2]|0;g=c[g+4>>2]|0;f=z0(f|0,0,-1,-1)|0;f=z0(f|0,z|0,o|0,g|0)|0;g=z}Op(b,f,g)}j=20}if((j|0)==20)yZ(c[b+508>>2]|0,c[b+668>>2]|0,d[m>>0]|0,0)}else{o=b+536|0;Op(b,c[o>>2]|0,c[o+4>>2]|0);VU(m,381010);BZ(c[b+508>>2]|0,c[b+668>>2]|0,-1,-1);z5(m)}l=n;return}function Ti(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+32|0;d=i+24|0;g=i+12|0;h=i;Bx(b);f=b+648|0;d4(c[f>>2]|0,2);rR(b,22,d);d4(c[f>>2]|0,2);d4(c[f>>2]|0,22);d4(c[f>>2]|0,2);d4(c[f>>2]|0,14);wK(b);a:do if(qO(b)|0){switch(a[b+768>>0]|0){case 2:break;case 127:{sU(g,(c[d>>2]|0)*400|0,10);d=c[b+760>>2]|0;d=HD(d+68|0,d)|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;f=j9(385598)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[h+11>>0]=f;b=h}else{j=f+16&-16;b=ZW(j)|0;c[h>>2]=b;c[h+8>>2]=j|-2147483648;c[h+4>>2]=f}i1(b,385598,f)|0;J7(b+f|0,0);vF(VC(d+4|0,h)|0,g)|0;a1(h);z5(g);break a}default:break a}if(a[b+784>>0]|0){sU(g,(c[d>>2]|0)*400|0,10);d=c[(c[(c[b+760>>2]|0)+80>>2]|0)+(e[b+772>>1]<<2)>>2]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;f=j9(385598)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[h+11>>0]=f;b=h}else{j=f+16&-16;b=ZW(j)|0;c[h>>2]=b;c[h+8>>2]=j|-2147483648;c[h+4>>2]=f}i1(b,385598,f)|0;J7(b+f|0,0);vF(VC(d+28|0,h)|0,g)|0;a1(h);z5(g)}}while(0);l=i;return}function Ui(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+32|0;d=n;e=n+28|0;f=n+24|0;g=n+20|0;m=n+8|0;i=b+528|0;h=i;h=z0(c[h>>2]|0,c[h+4>>2]|0,1,0)|0;k=i;c[k>>2]=h;c[k+4>>2]=z;iF(b,6,0);k=i;k=z0(c[k>>2]|0,c[k+4>>2]|0,2,0)|0;h=i;c[h>>2]=k;c[h+4>>2]=z;r3(b,e);h=i;h=z0(c[h>>2]|0,c[h+4>>2]|0,4,0)|0;k=i;c[k>>2]=h;c[k+4>>2]=z;Uy(b,d);k=i;k=z0(c[k>>2]|0,c[k+4>>2]|0,20,0)|0;h=i;c[h>>2]=k;c[h+4>>2]=z;bD(b,f);bD(b,g);h=c[i>>2]|0;i=c[i+4>>2]|0;k=b+536|0;j=c[k>>2]|0;k=c[k+4>>2]|0;if(k>>>0>i>>>0|(k|0)==(i|0)&j>>>0>h>>>0){k=D_(j|0,k|0,h|0,i|0)|0;e1(b,k,z)}Kc(b,1,-1)|0;TX(m);e=c[e>>2]|0;j=lh(m,e)|0;k=b+20|0;Rf(b,j,1,c[k>>2]|0,3);z5(m);j=c[k>>2]|0;TX(m);zb(b,1,j,58,lh(m,e)|0,0);z5(m);Bt(b,1,c[k>>2]|0,171,1.0e7/(+((c[d>>2]|0)>>>0)+4294967296.0*+((c[d+4>>2]|0)>>>0)),3,0);lL(b,1,c[k>>2]|0,130,c[f>>2]|0,10,0);lL(b,1,c[k>>2]|0,138,c[g>>2]|0,10,0);TX(m);d=Aj(1,3,lh(m,e)|0,1)|0;e=i9(29448)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)){k=(VG(d,29448,e)|0)==0;z5(m);if(k){m=ZW(1040)|0;_z(m);c[b+776>>2]=m;a[m+768>>0]=1}}else z5(m);l=n;return}function Vi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;e=i;f=b+4|0;g=b+11|0;h=b+8|0;switch(d<<24>>24){case 1:{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=j9(391075)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11)a[g>>0]=d;else{e=d+16&-16;g=ZW(e)|0;c[b>>2]=g;c[h>>2]=e|-2147483648;c[f>>2]=d;b=g}i1(b,391075,d)|0;J7(b+d|0,0);break}case 2:{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=j9(391082)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11)a[g>>0]=d;else{e=d+16&-16;g=ZW(e)|0;c[b>>2]=g;c[h>>2]=e|-2147483648;c[f>>2]=d;b=g}i1(b,391082,d)|0;J7(b+d|0,0);break}case 3:{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=j9(391094)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11)a[g>>0]=d;else{e=d+16&-16;g=ZW(e)|0;c[b>>2]=g;c[h>>2]=e|-2147483648;c[f>>2]=d;b=g}i1(b,391094,d)|0;J7(b+d|0,0);break}case 4:{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=j9(391106)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11)a[g>>0]=d;else{e=d+16&-16;g=ZW(e)|0;c[b>>2]=g;c[h>>2]=e|-2147483648;c[f>>2]=d;b=g}i1(b,391106,d)|0;J7(b+d|0,0);break}case 5:{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=j9(391119)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11)a[g>>0]=d;else{e=d+16&-16;g=ZW(e)|0;c[b>>2]=g;c[h>>2]=e|-2147483648;c[f>>2]=d;b=g}i1(b,391119,d)|0;J7(b+d|0,0);break}default:{uU(e,d,10);Sn(b,e);z5(e)}}l=i;return}function Wi(b){b=b|0;var d=0,e=0,f=0,g=0;Bx(b);g=b+857|0;e=b+856|0;do if(((a[g>>0]|0)+31&255)>=8){d=b+648|0;if(K6(c[d>>2]|0)|0){GC(b);A6(c[d>>2]|0);xR(b,4,e);G4(c[d>>2]|0,3);J3(b);break}else{A6(c[d>>2]|0);break}}else xR(b,4,e);while(0);e=b+854|0;xR(b,4,e);d=a[g>>0]|0;if((d&255)>=225){if((d&255)>232?((a[e>>0]|0)+-1&255)<2:0)f=9}else f=9;do if((f|0)==9){d=b+648|0;if(!(K6(c[d>>2]|0)|0)){A6(c[d>>2]|0);break}GC(b);A6(c[d>>2]|0);d4(c[d>>2]|0,3);A6(c[d>>2]|0);f=b+909|0;yT(b,f);if(!(a[f>>0]|0))A6(c[d>>2]|0);else{GC(b);A6(c[d>>2]|0);xR(b,8,b+867|0);xR(b,8,b+868|0);xR(b,8,b+869|0);J3(b)}J3(b)}while(0);wK(b);if(((a[g>>0]|0)+31&255)<8?(a[e>>0]|0)!=1:0)t4(b);f=b+528|0;g=b+536|0;if(!((c[f>>2]|0)==(c[g>>2]|0)?(c[f+4>>2]|0)==(c[g+4>>2]|0):0))t4(b);a:do if(qO(b)|0){s_(b);AR(b,178,0);d=0;while(1){if((d&255)>=47)break;AR(b,d&255,0);d=d+1<<24>>24}d=c[b+772>>2]|0;a[d+178>>0]=1;e=0;while(1){if((e|0)==37)break a;a[d+e>>0]=1;e=e+1|0}}while(0);return}function Xi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+16|0;e=o;f=a+16|0;d=a+32|0;g=b+-16|0;switch(b-a>>4|0){case 1:case 0:{d=1;break}case 2:{b=b+-8|0;n=a+8|0;if(M$(c[b>>2]|0,c[b+4>>2]|0,c[n>>2]|0,c[n+4>>2]|0)|0){c[e>>2]=c[a>>2];c[e+4>>2]=c[a+4>>2];c[e+8>>2]=c[a+8>>2];c[e+12>>2]=c[a+12>>2];c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];d=1}else d=1;break}case 3:{Sh(a,f,g)|0;d=1;break}case 4:{Kk(a,f,d,g)|0;d=1;break}case 5:{Gi(a,f,d,a+48|0,g)|0;d=1;break}default:{Sh(a,f,d)|0;e=a+48|0;m=0;a:while(1){k=e;while(1){if((k|0)==(b|0)){e=1;d=0;break a}g=k+8|0;f=c[g>>2]|0;g=c[g+4>>2]|0;i=d+8|0;j=k+16|0;if(M$(f,g,c[i>>2]|0,c[i+4>>2]|0)|0)break;else{d=k;k=j}}i=k;h=c[i>>2]|0;i=c[i+4>>2]|0;e=k;while(1){c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];if((d|0)==(a|0)){d=a;break}e=d+-8|0;if(M$(f,g,c[e>>2]|0,c[e+4>>2]|0)|0){e=d;d=d+-16|0}else break}e=d;c[e>>2]=h;c[e+4>>2]=i;d=d+8|0;c[d>>2]=f;c[d+4>>2]=g;d=m+1|0;if((d|0)==8){n=15;break}else{e=j;m=d;d=k}}if((n|0)==15){e=0;d=(j|0)==(b|0)}d=d|e}}l=o;return d|0}function Yi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=l;l=l+32|0;g=i+12|0;h=i;d=d&65535;e=d>>>11&1|(d&16)>>>3;e=(d&32|0)==0?e:e+2<<24>>24;e=(d&64|0)==0?e:e+2<<24>>24;e=(d&256|0)==0?e:(e&255)+2&255;e=(d&512|0)==0?e:(e&255)+2&255;e=(d&1024|0)==0?e:(e&255)+2&255;f=(d>>>2&1)+(d>>>12&1)<<24>>24;TX(b);uU(g,d&3,10);j=a[g+8+3>>0]|0;k=j<<24>>24<0;Ex(b,k?c[g>>2]|0:g,k?c[g+4>>2]|0:j&255)|0;z5(g);uU(h,d>>>7&1|(d&8)>>>2,10);zv(h,(a[h+8+3>>0]|0)<0?c[h>>2]|0:h,47);c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];d=0;while(1){if((d|0)==3)break;c[h+(d<<2)>>2]=0;d=d+1|0}d=a[g+8+3>>0]|0;k=d<<24>>24<0;Ex(b,k?c[g>>2]|0:g,k?c[g+4>>2]|0:d&255)|0;O0(g);z5(h);uU(h,e,10);zv(h,(a[h+8+3>>0]|0)<0?c[h>>2]|0:h,47);c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];d=0;while(1){if((d|0)==3)break;c[h+(d<<2)>>2]=0;d=d+1|0}d=a[g+8+3>>0]|0;k=d<<24>>24<0;Ex(b,k?c[g>>2]|0:g,k?c[g+4>>2]|0:d&255)|0;O0(g);z5(h);uU(h,f,10);zv(h,(a[h+8+3>>0]|0)<0?c[h>>2]|0:h,46);c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];d=0;while(1){if((d|0)==3)break;c[h+(d<<2)>>2]=0;d=d+1|0}k=a[g+8+3>>0]|0;j=k<<24>>24<0;Ex(b,j?c[g>>2]|0:g,j?c[g+4>>2]|0:k&255)|0;O0(g);z5(h);l=i;return}function Zi(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+32|0;e=n+20|0;g=n+16|0;f=n+12|0;i=n+24|0;k=n+26|0;m=n;j=d+20|0;RB(d,2,c[j>>2]|0,122,8800948,-1,1,1);if((c[d+784>>2]|0)>>>0<=1?(ID(d,e),ID(d,g),ID(d,f),h=d+528|0,o=h,o=z0(c[o>>2]|0,c[o+4>>2]|0,1,0)|0,h,c[h>>2]=o,c[h+4>>2]=z,Bx(d),h=d+648|0,d4(c[h>>2]|0,2),d4(c[h>>2]|0,5),A6(c[h>>2]|0),xR(d,6,k),d4(c[h>>2]|0,14),A6(c[h>>2]|0),d4(c[h>>2]|0,3),sR(d,16,i),A6(c[h>>2]|0),A6(c[h>>2]|0),d4(c[h>>2]|0,6),wK(d),qO(d)|0):0){e=c[e>>2]|0;h=d+16|0;if(e|0)lL(d,c[h>>2]|0,c[j>>2]|0,135,e,10,1);e=c[f>>2]|0;if(e|0)lL(d,c[h>>2]|0,c[j>>2]|0,112,e,10,0);e=c[g>>2]|0;if(e|0)lL(d,c[h>>2]|0,c[j>>2]|0,118,e,10,0);e=b[i>>1]|0;if(e<<16>>16){Mk(m,e,0);RB(d,2,0,128,(a[m+11>>0]|0)<0?c[m>>2]|0:m,-1,1,0);a1(m);nj(m,e,0);RB(d,2,0,129,(a[m+11>>0]|0)<0?c[m>>2]|0:m,-1,1,0);a1(m)}e=a[k>>0]|0;if((e+-1&255)<15){o=e&255;RB(d,2,0,128,c[13504+(o<<2)>>2]|0,-1,1,0);RB(d,2,0,129,c[13568+(o<<2)>>2]|0,-1,1,0)}}l=n;return}function _i(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=c[b>>2]|0;do if(g){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=e9(a[h>>0]|0)|0;if(d8(g,-1)|0){c[b>>2]=0;h=1;break}else{h=(c[b>>2]|0)==0;break}}else h=1;while(0);if(d){g=c[d+12>>2]|0;if((g|0)==(c[d+16>>2]|0))g=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else g=e9(a[g>>0]|0)|0;if(!(d8(g,-1)|0))if(h){i=d;j=15}else{g=6;j=35}else j=13}else j=13;if((j|0)==13)if(h){g=6;j=35}else{i=0;j=15}do if((j|0)==15){g=c[b>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=e9(a[h>>0]|0)|0;if((gb[c[(c[f>>2]|0)+36>>2]&31](f,g&255,0)|0)<<24>>24==37){g=c[b>>2]|0;h=g+12|0;d=c[h>>2]|0;if((d|0)==(c[g+16>>2]|0)){nb[c[(c[g>>2]|0)+40>>2]&255](g)|0;g=c[b>>2]|0;if(!g)h=1;else j=22}else{c[h>>2]=d+1;j=22}do if((j|0)==22){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=e9(a[h>>0]|0)|0;if(d8(g,-1)|0){c[b>>2]=0;h=1;break}else{h=(c[b>>2]|0)==0;break}}while(0);if(i|0){g=c[i+12>>2]|0;if((g|0)==(c[i+16>>2]|0))g=nb[c[(c[i>>2]|0)+36>>2]&255](i)|0;else g=e9(a[g>>0]|0)|0;if(!(d8(g,-1)|0))if(h)break;else{g=2;j=35;break}}if(h){g=2;j=35}}else{g=4;j=35}}while(0);if((j|0)==35)c[e>>2]=c[e>>2]|g;return}function $i(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+16|0;o=s;r=b+64|0;a:do if(!(c[r>>2]|0))d=0;else{m=b+68|0;e=c[m>>2]|0;if(!e){s=ua(4)|0;G9(s);Ya(s|0,2744,371)}n=b+92|0;d=c[n>>2]|0;p=b+32|0;q=b+72|0;if(!(d&16)){if(d&8|0){i=b+80|0;h=c[i+4>>2]|0;g=o;c[g>>2]=c[i>>2];c[g+4>>2]=h;g=b+36|0;h=b+40|0;i=b+16|0;j=b+12|0;k=b+8|0;do if(!(a[b+98>>0]|0)){e=nb[c[(c[e>>2]|0)+24>>2]&255](e)|0;f=c[g>>2]|0;d=(c[h>>2]|0)-f|0;if((e|0)>0){b=0;d=(O((c[i>>2]|0)-(c[j>>2]|0)|0,e)|0)+d|0;break}b=c[j>>2]|0;if((b|0)==(c[i>>2]|0))b=0;else{m=c[m>>2]|0;m=ub[c[(c[m>>2]|0)+32>>2]&31](m,o,c[p>>2]|0,f,b-(c[k>>2]|0)|0)|0;b=1;d=d-m+(c[g>>2]|0)-(c[p>>2]|0)|0}}else{b=0;d=(c[i>>2]|0)-(c[j>>2]|0)|0}while(0);if(x7(c[r>>2]|0,0-d|0,1)|0){d=-1;break}if(b){m=o;o=c[m+4>>2]|0;r=q;c[r>>2]=c[m>>2];c[r+4>>2]=o}r=c[p>>2]|0;c[h>>2]=r;c[g>>2]=r;c[k>>2]=0;c[j>>2]=0;c[i>>2]=0;c[n>>2]=0}}else{if((c[b+24>>2]|0)!=(c[b+20>>2]|0)?(tb[c[(c[b>>2]|0)+52>>2]&31](b,-1)|0)==-1:0){d=-1;break}d=b+52|0;b:while(1){k=c[m>>2]|0;b=c[p>>2]|0;b=ub[c[(c[k>>2]|0)+20>>2]&31](k,q,b,b+(c[d>>2]|0)|0,o)|0;k=c[p>>2]|0;n=(c[o>>2]|0)-k|0;if((w8(k,n,c[r>>2]|0)|0)!=(n|0)){d=-1;break a}switch(b|0){case 2:{d=-1;break a}case 1:break;default:break b}}if(ZK(c[r>>2]|0)|0){d=-1;break}}d=0}while(0);l=s;return d|0}function aj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+32|0;f=s+8|0;p=s;bB(a,s+16|0);jB(a,s+12|0);q=a+916|0;r=a+788|0;b=bF(q,r)|0;e=c[b+136>>2]|0;b=b+140|0;d=c[b>>2]|0;while(1){if((d|0)==(e|0))break;o=d+-8|0;c[b>>2]=o;d=o}ID(a,f);k=bF(q,r)|0;k=(c[k+136>>2]|0)==(c[k+140>>2]|0);m=a+528|0;n=a+536|0;o=a+544|0;j=a+612|0;i=c[f>>2]|0;d=1;h=0;while(1){if(h>>>0>=i>>>0)break;e=m;b=c[e>>2]|0;e=z0(b|0,c[e+4>>2]|0,4,0)|0;a=z;g=n;f=c[g+4>>2]|0;if(a>>>0>f>>>0|((a|0)==(f|0)?e>>>0>(c[g>>2]|0)>>>0:0))break;g=W8((c[o>>2]|0)+(c[j>>2]|0)+b|0)|0;f=m;c[f>>2]=e;c[f+4>>2]=a;a:do if((d|0)!=0&(g|0)==0){b=0;while(1){f=bF(q,r)|0;if(b>>>0>=(c[f+140>>2]|0)-(c[f+136>>2]|0)>>3>>>0){d=0;break a}f=(c[(bF(q,r)|0)+136>>2]|0)+(b<<3)|0;a=f;a=z0(c[a>>2]|0,c[a+4>>2]|0,-1,-1)|0;c[f>>2]=a;c[f+4>>2]=z;b=b+1|0}}while(0);f=bF(q,r)|0;b=g-d|0;e=p;c[e>>2]=b;c[e+4>>2]=0;e=f+140|0;a=c[e>>2]|0;if(a>>>0<(c[f+144>>2]|0)>>>0){g=a;c[g>>2]=b;c[g+4>>2]=0;c[e>>2]=a+8}else Px(f+136|0,p);h=h+1|0}if(!k){p=c[(bF(q,r)|0)+136>>2]|0;Ye(p,c[(bF(q,r)|0)+140>>2]|0)}l=s;return}function bj(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;a:do if(e|0){k=b+8+3|0;l=b+4|0;if((a[k>>0]|0)<0){y7(c[b>>2]|0,0);c[l>>2]=0}else{y7(b,0);a[k>>0]=0}b:while(1){f=a[e>>0]|0;if(!(f<<24>>24))break a;g=f&255;do if(f<<24>>24>-1){Gx(b,g);f=1}else{f=e+1|0;if((g&224|0)==192){f=d[f>>0]|0;if((f&192|0)!=128){e=12;break b}Gx(b,f&63|g<<6&1984);f=2;break}i=e+2|0;j=g&15;if((g&240|0)==224){g=d[f>>0]|0;if((g&192|0)!=128){e=19;break b}f=d[i>>0]|0;if((f&192|0)!=128){e=19;break b}Gx(b,g<<6&4032|j<<12|f&63);f=3;break}if((g&248|0)!=240){e=30;break b}h=d[f>>0]|0;if((h&192|0)!=128){e=27;break b}f=d[i>>0]|0;if((f&192|0)!=128){e=27;break b}g=d[e+3>>0]|0;if((g&192|0)!=128){e=27;break b}Gx(b,h<<12&258048|j<<18|f<<6&4032|g&63);f=4}while(0);e=e+f|0}if((e|0)==12)if((a[k>>0]|0)<0){y7(c[b>>2]|0,0);c[l>>2]=0;break}else{y7(b,0);a[k>>0]=0;break}else if((e|0)==19)if((a[k>>0]|0)<0){y7(c[b>>2]|0,0);c[l>>2]=0;break}else{y7(b,0);a[k>>0]=0;break}else if((e|0)==27)if((a[k>>0]|0)<0){y7(c[b>>2]|0,0);c[l>>2]=0;break}else{y7(b,0);a[k>>0]=0;break}else if((e|0)==30)if((a[k>>0]|0)<0){y7(c[b>>2]|0,0);c[l>>2]=0;break}else{y7(b,0);a[k>>0]=0;break}}while(0);return b|0}function cj(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;t=l;l=l+128|0;b=t+20|0;s=t+8|0;m=t+4|0;p=t;j=t+16|0;c[s>>2]=b;r=s+4|0;c[r>>2]=375;O4(p,g);u=c[p>>2]|0;k=u$(u,409116)|0;a[j>>0]=0;o=c[e>>2]|0;n=o;if(Vb(d,n,f,u,c[g+4>>2]|0,h,j,k,s,m,b+100|0)|0){b=i+11|0;if((a[b>>0]|0)<0){J7(c[i>>2]|0,0);c[i+4>>2]=0}else{J7(i,0);a[b>>0]=0}if(a[j>>0]|0)gy(i,tb[c[(c[k>>2]|0)+28>>2]&31](k,45)|0);f=tb[c[(c[k>>2]|0)+28>>2]&31](k,48)|0;j=c[m>>2]|0;k=j+-1|0;b=c[s>>2]|0;while(1){if(b>>>0>=k>>>0)break;if((a[b>>0]|0)!=f<<24>>24)break;b=b+1|0}_k(i,b,j)|0}b=c[d>>2]|0;do if(b){j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0))b=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0;else b=e9(a[j>>0]|0)|0;if(d8(b,-1)|0){c[d>>2]=0;j=1;break}else{j=(c[d>>2]|0)==0;break}}else j=1;while(0);do if(o){b=c[n+12>>2]|0;if((b|0)==(c[n+16>>2]|0))b=nb[c[(c[o>>2]|0)+36>>2]&255](n)|0;else b=e9(a[b>>0]|0)|0;if(!(d8(b,-1)|0))if(j)break;else{q=27;break}else{c[e>>2]=0;q=25;break}}else q=25;while(0);if((q|0)==25?j:0)q=27;if((q|0)==27)c[h>>2]=c[h>>2]|2;j=c[d>>2]|0;c6(p);b=c[s>>2]|0;c[s>>2]=0;if(b|0)jb[c[r>>2]&511](b);l=t;return j|0}function dj(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;p=l;l=l+48|0;i=p+24|0;m=p+12|0;q=p+40|0;e=p+39|0;f=p+38|0;g=p+37|0;n=p;o=p+36|0;a[d+797>>0]=1;TX(i);TX(m);Bx(d);h=d+648|0;d4(c[h>>2]|0,3);xR(d,5,q);wK(d);j=d+536|0;k=d+528|0;if(!(a[q>>0]|0)){LK(d);r=k;r=z0(c[r>>2]|0,c[r+4>>2]|0,5,0)|0;q=k;c[q>>2]=r;c[q+4>>2]=z;Bx(d);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);d4(c[h>>2]|0,4);wK(d);bB(d,e);Jp(d,a[e>>0]|0,i);bB(d,f);Jp(d,a[f>>0]|0,m);Bx(d);d4(c[h>>2]|0,3);xR(d,5,g);wK(d);f=a[g>>0]|0;e=0;while(1){if((e&255)>=(f&255))break;TX(n);bB(d,o);Jp(d,a[o>>0]|0,n);z5(n);e=e+1<<24>>24}q=k;n=c[q+4>>2]|0;r=j;o=c[r+4>>2]|0;if(n>>>0<o>>>0|((n|0)==(o|0)?(c[q>>2]|0)>>>0<(c[r>>2]|0)>>>0:0)?(Bx(d),d4(c[h>>2]|0,6),r=d+770|0,sR(d,10,r),wK(d),b[r>>1]|0):0)Ao(d)}else{q=j;r=k;r=D_(c[q>>2]|0,c[q+4>>2]|0,c[r>>2]|0,c[r+4>>2]|0)|0;e1(d,r,z)}z5(m);z5(i);l=p;return}function ej(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+48|0;d=k+24|0;h=k+12|0;i=k;TX(d);e=b+536|0;jZ(b,c[e>>2]|0,c[e+4>>2]|0,d);e=b+520|0;g=e;f=c[g>>2]|0;g=c[g+4>>2]|0;a:do if((f|0)<1701995884){if((f|0)<1701667948){switch(f|0){case 1701015410:break;default:{j=15;break a}}if(g|0){j=15;break}Mc(b,0,0,379899,d,0);break}if((f|0)<1701670516){switch(f|0){case 1701667948:break;default:{j=15;break a}}if(g|0){j=15;break}Mc(b,0,0,379904,d,0);break}else{switch(f|0){case 1701670516:break;default:{j=15;break a}}if(g|0){j=15;break}Mc(b,0,0,379910,d,0);break}}else{if((f|0)>=1702191981){if((f|0)>=1702258034){switch(f|0){case 1702258034:break;default:{j=15;break a}}if(!g)break;else{j=15;break}}switch(f|0){case 1702191981:break;default:{j=15;break a}}if(g|0){j=15;break}zb(b,0,0,320,d,0);break}if((f|0)<1702127981){switch(f|0){case 1701995884:break;default:{j=15;break a}}if(g|0){j=15;break}Mc(b,0,0,379921,d,0);break}else{switch(f|0){case 1702127981:break;default:{j=15;break a}}if(g|0){j=15;break}Mc(b,0,0,379938,d,0);break}}while(0);if((j|0)==15){TX(i);pk(h,lh(i,c[e>>2]|0)|0);Mc(b,0,0,(a[h+11>>0]|0)<0?c[h>>2]|0:h,d,0);a1(h);z5(i)}z5(d);l=k;return}function fj(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;p=l;l=l+32|0;f=p+12|0;n=p;o=e+789|0;i=e+536|0;if(!(a[e+760>>0]|0)){a[o>>0]=-1;a[e+792>>0]=0;VU(f,391303);BZ(c[e+508>>2]|0,c[e+668>>2]|0,-1,-1);z5(f);o=i;o=z0(c[o>>2]|0,c[o+4>>2]|0,-4,-1)|0;Op(e,o,z)}else{bB(e,o);Bx(e);h=e+792|0;AT(e,h);m=e+648|0;A6(c[m>>2]|0);d4(c[m>>2]|0,2);sR(e,12,f);wK(e);m=b[f>>1]|0;f=m&65535;g=e+528|0;j=c[g>>2]|0;g=c[g+4>>2]|0;h=(a[h>>0]|0)!=0;k=z0((h?4:0)|0,(h?0:0)|0,j|0,g|0)|0;q=z;do if(0<q>>>0|0==(q|0)&f>>>0<k>>>0)U5(e);else{r=i;k=c[r>>2]|0;r=c[r+4>>2]|0;q=z0(j|0,g|0,f|0,0)|0;i=z;if(r>>>0<i>>>0|(r|0)==(i|0)&k>>>0<q>>>0){c3(c[e+508>>2]|0,c[e+668>>2]|0);break}k=a[o>>0]|0;if(!(h|(k&255)>6)){t4(e);c[e+772>>2]=-1;z$(e);break}if(h|k<<24>>24==-63){i=e+772|0;c[i>>2]=-1;f=(c[e+544>>2]|0)+(c[e+612>>2]|0)+j|0;g=f+(m&65535)|0;f=f+-3|0;h=-1;while(1){if(f>>>0>=g>>>0)break;r=c[40292+((d[f>>0]^h>>>24)<<2)>>2]^h<<8;c[i>>2]=r;f=f+1|0;h=r}if(h|0){t4(e);z$(e);break}}TX(n);Ck(n,a[o>>0]|0,16)|0;BZ(c[e+508>>2]|0,c[e+668>>2]|0,k&255,0);z5(n);Op(e,(m&65535)+3|0,0)}while(0)}l=p;return}function gj(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;o=l;l=l+32|0;k=o+16|0;i=o+22|0;j=o+20|0;n=o+4|0;f=o;g=a+528|0;m=g;m=z0(c[m>>2]|0,c[m+4>>2]|0,20,0)|0;e=g;c[e>>2]=m;c[e+4>>2]=z;HB(a,i);HB(a,j);e=g;e=z0(c[e>>2]|0,c[e+4>>2]|0,8,0)|0;m=g;c[m>>2]=e;c[m+4>>2]=z;bD(a,k);c[n>>2]=0;m=n+4|0;c[m>>2]=0;c[n+8>>2]=0;e=n+8|0;k=c[k>>2]|0;d=0;while(1){if(d>>>0>=k>>>0)break;GC(a);p=g;p=z0(c[p>>2]|0,c[p+4>>2]|0,28,0)|0;h=g;c[h>>2]=p;c[h+4>>2]=z;bD(a,f);h=c[m>>2]|0;if((h|0)==(c[e>>2]|0))Yy(n,f);else{c[h>>2]=c[f>>2];c[m>>2]=h+4}J3(a);d=d+1|0}e=g;d=c[e>>2]|0;e=c[e+4>>2]|0;g=a+536|0;f=c[g>>2]|0;g=c[g+4>>2]|0;if(g>>>0>e>>>0|(g|0)==(e|0)&f>>>0>d>>>0){p=D_(f|0,g|0,d|0,e|0)|0;e1(a,p,z)}a:do if(qO(a)|0){e=b[i>>1]|0;d=b[j>>1]|0;if(e<<16>>16!=0&d<<16>>16!=0)Bt(a,1,0,156,+(d&65535)/+(e&65535),3,0);switch(k|0){case 1:{RB(a,1,0,197,384051,-1,1,0);break a}case 2:break;default:break a}RB(a,1,0,197,384063,-1,1,0);f=c[m>>2]|0;e=c[n>>2]|0;d=e;if((f-e|0)==8?(c[d>>2]|0)>>>0<(c[d+4>>2]|0)>>>0:0){RB(a,1,0,204,384074,-1,1,0);d=c[n>>2]|0;e=d;f=c[m>>2]|0}if((f-e|0)==8?(c[d>>2]|0)>>>0>(c[d+4>>2]|0)>>>0:0)RB(a,1,0,204,384078,-1,1,0)}while(0);cU(n);l=o;return}function hj(a,b){a=a|0;b=b|0;var c=0;a:do switch(a|0){case 39:case 36:case 32:case 31:case 30:case 27:case 16:case 2:case 1:{a=1;break}case 28:case 17:case 15:case 4:case 3:{a=2;break}case 29:{a=3;break}default:{b:do if((b|0)<1212435798){if((b|0)<1129661769)switch(b|0){case -1:{a=7;break a}default:{c=17;break b}}if((b|0)<1195456820)switch(b|0){case 1129661769:break b;default:{c=17;break b}}else switch(b|0){case 1195456820:break b;default:{c=17;break b}}}else{if((b|0)>=1396921413){if((b|0)<1414744150)switch(b|0){case 1396921413:break b;default:{c=17;break b}}switch(b|0){case 1414744150:break;default:{c=17;break b}}return ((a&-2|0)==160?0:7)|0}if((b|0)>=1395733569)switch(b|0){case 1395733569:break b;default:{c=17;break b}}switch(b|0){case 1212435798:break;default:{c=17;break b}}switch(a|0){case 162:case 161:case 134:case 133:case 132:case 131:case 130:case 129:case 128:{a=2;break a}case 144:{a=3;break a}case 145:{a=3;break a}case 146:{a=3;break a}case 234:{a=1;break a}default:{a=7;break a}}}while(0);if((c|0)==17)switch(a|0){case 209:case 136:case 128:{a=1;break a}case 129:{a=2;break a}case 135:{a=2;break a}default:{a=7;break a}}switch(a|0){case 128:{a=1;break a}case 129:{a=2;break a}case 130:{a=3;break a}case 135:{a=2;break a}default:{a=7;break a}}}}while(0);return a|0}function ij(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0.0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+48|0;u=v+32|0;q=v+28|0;r=v+24|0;s=v+44|0;p=v;c[u>>2]=0;t=u+4|0;c[t>>2]=0;c[u+8>>2]=0;wA(u,g+1|0);o=(e&255)+6|0;m=(f&255)+4|0;n=u+8|0;k=0;while(1){if((k&255)>>>0>g>>>0)break;GC(b);n3(b,q);i=+(((c[q>>2]|0)+1|0)>>>0);i=+eaa(o)*i;e=+B(i)>=1.0?(i>0.0?~~+P(+A(i/4294967296.0),4294967295.0)>>>0:~~+N((i-+(~~i>>>0))/4294967296.0)>>>0):0;n3(b,r);j=+(((c[r>>2]|0)+1|0)>>>0);j=+eaa(m)*j;f=+B(j)>=1.0?(j>0.0?~~+P(+A(j/4294967296.0),4294967295.0)>>>0:~~+N((j-+(~~j>>>0))/4294967296.0)>>>0):0;if(a[d>>0]|0){T5(b);T5(b)}AT(b,s);J3(b);if(qO(b)|0){yR(p,~~i>>>0,e,~~j>>>0,f,(a[s>>0]|0)!=0);e=c[t>>2]|0;if(e>>>0<(c[n>>2]|0)>>>0){c[e>>2]=c[p>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2];c[e+12>>2]=c[p+12>>2];c[e+16>>2]=c[p+16>>2];c[e+20>>2]=c[p+20>>2];c[t>>2]=e+24}else Ws(u,p)}k=k+1<<24>>24}do if(qO(b)|0){e=c[u>>2]|0;if(((c[t>>2]|0)-e|0)==24?(t=e,(c[t>>2]|0)==64&(c[t+4>>2]|0)==0):0)break;t=ZW(12)|0;FU(t,u);c[h>>2]=t}while(0);wR(u);l=v;return}function jj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+16|0;j=n+4|0;k=n;m=ge(b,j)|0;do if(m|0){KS(b);d=(Z9(c[(c[b+648>>2]|0)+4>>2]|0)|0)&7;while(1){if(!d)break;RS(b);d=d+-1|0}wK(b);i=b+528|0;d=i;e=c[d>>2]|0;d=c[d+4>>2]|0;o=z0(e|0,d|0,1,0)|0;h=b+536|0;f=h;g=c[f>>2]|0;f=c[f+4>>2]|0;if((o|0)==(g|0)&(z|0)==(f|0)){EG(b,k);o=(a[k>>0]|0)==-104;d=i;e=c[d>>2]|0;d=c[d+4>>2]|0;f=z0(e|0,d|0,1,0)|0;g=z;if(o){e=i;c[e>>2]=f;c[e+4>>2]=g;e=f;d=g}f=h;g=c[f>>2]|0;f=c[f+4>>2]|0}o=z0(e|0,d|0,4,0)|0;if((o|0)==(g|0)&(z|0)==(f|0)?(aH(b,k),(c[k>>2]|0)==-486132800):0){g=i;g=z0(c[g>>2]|0,c[g+4>>2]|0,4,0)|0;o=i;c[o>>2]=g;c[o+4>>2]=z}while(1){e=i;d=c[e>>2]|0;e=c[e+4>>2]|0;g=h;f=c[g>>2]|0;g=c[g+4>>2]|0;if(!(e>>>0<g>>>0|(e|0)==(g|0)&d>>>0<f>>>0))break;bB(b,k);if(a[k>>0]|0)t4(b)}if(!((d|0)==(f|0)&(e|0)==(g|0)))t4(b);if(!(qO(b)|0)){W_(c[m>>2]|0);laa(m);break}s_(b);AR(b,8,0);tv(b,b+840|0,c[j>>2]|0,m);e=c[b+772>>2]|0;a[e+16>>0]=1;d=e+20|0;if(!(a[e+15>>0]|0)){a[d>>0]=1;a[e+22>>0]=1;break}else{a[e+17>>0]=1;a[d>>0]=1;a[d+1>>0]=1;a[d+2>>0]=1;a[d+3>>0]=1;break}}while(0);l=n;return}function kj(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;t=l;l=l+432|0;b=t+16|0;s=t+8|0;m=t+4|0;p=t;j=t+416|0;c[s>>2]=b;r=s+4|0;c[r>>2]=375;O4(p,g);u=c[p>>2]|0;k=u$(u,409148)|0;a[j>>0]=0;o=c[e>>2]|0;n=o;if(Yb(d,n,f,u,c[g+4>>2]|0,h,j,k,s,m,b+400|0)|0){b=i+8+3|0;if((a[b>>0]|0)<0){y7(c[i>>2]|0,0);c[i+4>>2]=0}else{y7(i,0);a[b>>0]=0}if(a[j>>0]|0)Gx(i,tb[c[(c[k>>2]|0)+44>>2]&31](k,45)|0);f=tb[c[(c[k>>2]|0)+44>>2]&31](k,48)|0;j=c[m>>2]|0;k=j+-4|0;b=c[s>>2]|0;while(1){if(b>>>0>=k>>>0)break;if((c[b>>2]|0)!=(f|0))break;b=b+4|0}kk(i,b,j)|0}b=c[d>>2]|0;do if(b){j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0))b=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0;else b=raa(c[j>>2]|0)|0;if(d8(b,-1)|0){c[d>>2]=0;j=1;break}else{j=(c[d>>2]|0)==0;break}}else j=1;while(0);do if(o){b=c[n+12>>2]|0;if((b|0)==(c[n+16>>2]|0))b=nb[c[(c[o>>2]|0)+36>>2]&255](n)|0;else b=raa(c[b>>2]|0)|0;if(!(d8(b,-1)|0))if(j)break;else{q=27;break}else{c[e>>2]=0;q=25;break}}else q=25;while(0);if((q|0)==25?j:0)q=27;if((q|0)==27)c[h>>2]=c[h>>2]|2;j=c[d>>2]|0;c6(p);b=c[s>>2]|0;c[s>>2]=0;if(b|0)jb[c[r>>2]&511](b);l=t;return j|0}function lj(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0.0,k=0,m=0.0,n=0.0,o=0,p=0;o=l;l=l+16|0;k=o;p=a[d+8+3>>0]|0;if((((p<<24>>24<0?c[d+4>>2]|0:p&255)|0?($x(k,b,e,f,i,1),p=a[k+8+3>>0]|0,p=((p<<24>>24<0?c[k+4>>2]|0:p&255)|0)==0,z5(k),p):0)?($x(k,b,e,f,i,1),p=a[k+8+3>>0]|0,p=((p<<24>>24<0?c[k+4>>2]|0:p&255)|0)==0,z5(k),p):0)?(j=+Cq(d),m=j,j=m>1.0898182142972945&m<1.092000032544136?1.0909091234207153:j,m=j,j=m>.9081818452477455&m<.9100000271201133?.9090909361839294:j,m=j,j=m>1.4530909523963929&m<1.4560000433921811?1.454545497894287:j,m=j,j=m>1.0656000555753709&m<1.067733389019966?1.0666667222976685:j,m=j,j=m>1.210909126996994&m<1.2133333694934845?1.2121212482452393:j,m=j,j=m>2.179636428594589&m<2.184000065088272?2.1818182468414307:j,m=j,j=m>1.816363690495491&m<1.8200000542402266?1.8181818723678589:j,m=j,j=m>2.9061819047927857&m<2.9120000867843623?2.909090995788574:j,m=j,j=m>2.421818253993988&m<2.426666738986969?2.4242424964904785:j,m=j,j=m>1.634727261900902&m<1.6379999891519545?1.6363636255264282:j,m=j,j=m>1.3622727380990982&m<1.3650000108480451?1.3636363744735718:j,m=j,j=m>1.9374546031951905&m<1.941333391189575?1.9393939971923828:j,m=j,j=m>1.6145454232692718&m<1.61777774643898?1.616161584854126:j,m=j,j=m>1.3320000396966933&m<1.3466667068004607?1.3333333730697632:j,m=j,j=m>1.4985&m<1.5014999999999998?1.5:j,m=j,j=m>1.998&m<2.002?2.0:j,m=j,j=m>1.0915000044107437&m<1.093685189604759?1.0925925970077515:j,m=j,j=m>.8880000066161156&m<.8897777844071387?.8888888955116272:j,$x(k,b,e,f,g,1),m=+Cq(k),z5(k),$x(k,b,e,f,h,1),n=+Cq(k),z5(k),m!=0.0&(j!=0.0&n!=0.0)):0)Bt(b,e,f,i,j*(m/n),3,0);l=o;return}function mj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;q=l;l=l+32|0;p=q+12|0;g=q;do if(!((d|0)>6|(f|0)==0)?a[f>>0]|0:0){o=c[c[b+4>>2]>>2]|0;if((((c[o+(d*12|0)+4>>2]|0)-(c[o+(d*12|0)>>2]|0)|0)/40|0)>>>0>e>>>0){TX(g);p2(p,cC(g,f)|0);z5(g);f=Sx(vn(d)|0,p,0)|0;do if((f|0)==-1){f=(c[(c[c[b+8>>2]>>2]|0)+(d*12|0)>>2]|0)+(e*56|0)|0;g=Sx(f,p,0)|0;if((g|0)!=-1){f=wF(f,g,1)|0;g=f+8+3|0;if((a[g>>0]|0)<0){y7(c[f>>2]|0,0);c[f+4>>2]=0;break}else{y7(f,0);a[g>>0]=0;break}}}else Ed(b,d,e,f);while(0);z5(p);break}TX(g);p2(p,bj(g,f)|0);z5(g);o=b+380+(d*12|0)|0;k=b+380+(d*12|0)+4|0;m=p+8+3|0;n=p+4|0;j=c[k>>2]|0;e=0;f=j;while(1){i=c[o>>2]|0;g=i;if(e>>>0>=((f-i|0)/24|0)>>>0)break;b=g+(e*24|0)|0;h=a[g+(e*24|0)+8+3>>0]|0;d=h<<24>>24<0;h=d?c[g+(e*24|0)+4>>2]|0:h&255;r=a[m>>0]|0;i=r<<24>>24<0;if((h|0)==((i?c[n>>2]|0:r&255)|0)?(L$(d?c[b>>2]|0:b,i?c[p>>2]|0:p,h)|0)==0:0){g=g+(e*24|0)|0;while(1){f=g+24|0;if((f|0)==(j|0))break;T_(g,f)|0;g=f}while(1){f=c[k>>2]|0;if((f|0)==(g|0))break;r=f+-24|0;c[k>>2]=r;w4(r)}e=e+-1|0}else g=j;e=e+1|0;j=g}z5(p)}while(0);l=q;return}function nj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[a+(e<<2)>>2]=0;e=e+1|0}b=b&65535;do if((b&3|0)!=3){if(b&1|0){JX(a,385588)|0;break}if(!(b&2)){JX(a,401470)|0;break}else{JX(a,385590)|0;break}}else JX(a,383634)|0;while(0);e=(b&2112|0)==0;if(!(b&4)){if(e)JX(a,372324)|0}else JX(a,372321)|0;if(!((b&16|0)!=0|d)){if(e)JX(a,372324)|0}else JX(a,372327)|0;if((b&160|0)!=160){if(b&32|0)JX(a,372333)|0;if(b&128|0)JX(a,372333)|0}else JX(a,372330)|0;if(b&2048|0)JX(a,372321)|0;if(b&64|0)JX(a,372321)|0;if(b&256|0)JX(a,379402)|0;if(b&512|0)JX(a,372333)|0;if(b&1024|0)JX(a,372333)|0;if(b&8192|0)JX(a,372333)|0;if((b&49152|0)!=49152){if(b&16384|0)JX(a,379402)|0;if(b&32768|0)JX(a,372333)|0}else JX(a,372330)|0;if(b&8|0)JX(a,379402)|0;if(b&4096|0)JX(a,379402)|0;return}function oj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;p=l;l=l+48|0;m=p+32|0;n=p+16|0;o=p;if(!(VX(d)|0)){k=b;g=b+8|0;dX(m,c[k>>2]|0,c[k+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0);g=d;k=d+8|0;h=k;i=m;j=m+8|0;if(SX(c[g>>2]|0,c[g+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0,c[i>>2]|0,c[i+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0){c[e>>2]=c[b>>2];c[e+4>>2]=c[b+4>>2];c[e+8>>2]=c[b+8>>2];c[e+12>>2]=c[b+12>>2];hZ(a,0,0)}else{hZ(n,0,0);hZ(o,0,0);j=n+8|0;b=127;while(1){f=n;g=j;h=d;i=k;if(!(rS(c[f>>2]|0,c[f+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0,c[i>>2]|0,c[i+4>>2]|0)|0))break;iI(n)|0;f=b+-1|0;if(!(eU(m,b)|0)){b=f;continue}h=n;i=c[h+4>>2]|0;b=n;c[b>>2]=c[h>>2]|1;c[b+4>>2]=i;b=f}i=b+1|0;while(1){while(1){r=n;q=j;f=d;b=c[f>>2]|0;f=c[f+4>>2]|0;h=k;g=c[h>>2]|0;h=c[h+4>>2]|0;if(rS(c[r>>2]|0,c[r+4>>2]|0,c[q>>2]|0,c[q+4>>2]|0,b,f,g,h)|0)break;kO(n,b,f,g,h)|0;cL(o,i)}b=i+-1|0;if(!i)break;iI(n)|0;if(!(eU(m,b)|0)){i=b;continue}q=n;r=c[q+4>>2]|0;i=n;c[i>>2]=c[q>>2]|1;c[i+4>>2]=r;i=b}c[e>>2]=c[n>>2];c[e+4>>2]=c[n+4>>2];c[e+8>>2]=c[n+8>>2];c[e+12>>2]=c[n+12>>2];q=o;r=o+8|0;dX(a,c[q>>2]|0,c[q+4>>2]|0,c[r>>2]|0,c[r+4>>2]|0)}}else F_(a,(c[d>>2]|0)==1&1);l=p;return}function pj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=b+48|0;d=h;g=c[d>>2]|0;d=c[d+4>>2]|0;k=b+612|0;e=c[k>>2]|0;n=z0(e|0,0,g|0,d|0)|0;p=z;i=b+508|0;f=c[i>>2]|0;j=b+668|0;m=(c[j>>2]|0)+(f*24|0)+8|0;o=c[m+4>>2]|0;if(!(p>>>0<o>>>0|((p|0)==(o|0)?n>>>0<(c[m>>2]|0)>>>0:0))){while(1){d=z0(e|0,0,g|0,d|0)|0;e=z;if(!f)break;p=(c[j>>2]|0)+(f*24|0)+8|0;o=c[p+4>>2]|0;if(e>>>0<o>>>0|((e|0)==(o|0)?d>>>0<(c[p>>2]|0)>>>0:0))break;J3(b);d=h;e=c[k>>2]|0;f=c[i>>2]|0;g=c[d>>2]|0;d=c[d+4>>2]|0}p=b+40|0;if((d|0)==(c[p>>2]|0)?(e|0)==(c[p+4>>2]|0):0)d=0;else{a[b+495>>0]=0;l=7}}else l=7;a:do if((l|0)==7){if(a[b+733>>0]|0){d=b+376|0;do if(!(vi(b)|0)){d=0;break a}while(!(a[d>>0]|0))}i=b+264|0;d=c[i>>2]|0;e=b+252|0;f=b+256|0;if((d|0)==-1){g=c[e>>2]|0;e=c[f>>2]|0;if((g|0)!=(e|0)){c[i>>2]=0;d=0;h=g;f=g;l=15}}else{l=c[e>>2]|0;h=l;e=c[f>>2]|0;f=l;l=15}do if((l|0)==15){e=e-h>>3;while(1){if(d>>>0>=e>>>0)break;p=f+(d<<3)|0;o=c[p+4>>2]|0;if(!(0>o>>>0|(0==(o|0)?(c[k>>2]|0)>>>0>(c[p>>2]|0)>>>0:0))){l=19;break}p=d+1|0;c[i>>2]=p;d=p}if((l|0)==19?(p=h+(d<<3)|0,0==(c[p+4>>2]|0)?(c[k>>2]|0)==(c[p>>2]|0):0):0)break;c[i>>2]=d+-1}while(0);if(Je(b)|0?Od(b)|0:0){p=b+552|0;p=z0(c[k>>2]|0,0,c[p>>2]|0,c[p+4>>2]|0)|0;d=b+568|0;c[d>>2]=p;c[d+4>>2]=z;d=1}else d=0}while(0);return d|0}function qj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=c[a>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else f=raa(c[g>>2]|0)|0;if(d8(f,-1)|0){c[a>>2]=0;g=1;break}else{g=(c[a>>2]|0)==0;break}}else g=1;while(0);if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))f=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0;else f=raa(c[f>>2]|0)|0;if(!(d8(f,-1)|0))if(g){h=b;i=15}else{f=6;i=35}else i=13}else i=13;if((i|0)==13)if(g){f=6;i=35}else{h=0;i=15}do if((i|0)==15){f=c[a>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else f=raa(c[g>>2]|0)|0;if((gb[c[(c[e>>2]|0)+52>>2]&31](e,f,0)|0)<<24>>24==37){f=c[a>>2]|0;g=f+12|0;b=c[g>>2]|0;if((b|0)==(c[f+16>>2]|0)){nb[c[(c[f>>2]|0)+40>>2]&255](f)|0;f=c[a>>2]|0;if(!f)g=1;else i=22}else{c[g>>2]=b+4;i=22}do if((i|0)==22){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else f=raa(c[g>>2]|0)|0;if(d8(f,-1)|0){c[a>>2]=0;g=1;break}else{g=(c[a>>2]|0)==0;break}}while(0);if(h|0){f=c[h+12>>2]|0;if((f|0)==(c[h+16>>2]|0))f=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else f=raa(c[f>>2]|0)|0;if(!(d8(f,-1)|0))if(g)break;else{f=2;i=35;break}}if(g){f=2;i=35}}else{f=4;i=35}}while(0);if((i|0)==35)c[d>>2]=c[d>>2]|f;return}function rj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;p=l;l=l+64|0;f=p+60|0;d=p+56|0;g=p+52|0;h=p+48|0;k=p+36|0;m=p+24|0;n=p+12|0;o=p;TX(k);TX(m);ID(b,f);ID(b,d);jZ(b,c[d>>2]|0,0,k);ID(b,g);xZ(b,c[g>>2]|0,0,m);g=b+528|0;d=g;d=z0(c[d>>2]|0,c[d+4>>2]|0,16,0)|0;e=g;c[e>>2]=d;c[e+4>>2]=z;ID(b,h);e=g;d=c[e>>2]|0;e=c[e+4>>2]|0;h=c[h>>2]|0;q=z0(h|0,0,d|0,e|0)|0;s=z;i=b+536|0;j=i;r=c[j+4>>2]|0;if(!(s>>>0>r>>>0|((s|0)==(r|0)?q>>>0>(c[j>>2]|0)>>>0:0))){j=c[b+544>>2]|0;e=z0(c[b+612>>2]|0,0,d|0,e|0)|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;if(h>>>0>4294967279)uaa();if(h>>>0<11){a[n+11>>0]=h;d=n}else{s=h+16&-16;d=ZW(s)|0;c[n>>2]=d;c[n+8>>2]=s|-2147483648;c[n+4>>2]=h}i1(d,j+e|0,h)|0;J7(d+h|0,0);Zm(o,n);r=i;s=g;s=D_(c[r>>2]|0,c[r+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0;e1(b,s,z);RB(b,0,0,314,382808,-1,1,0);zb(b,0,0,315,m,0);RB(b,0,0,316,Zw(c[f>>2]&255)|0,-1,1,0);zb(b,0,0,317,k,0);bw(b,0,0,318,o,1,0);a1(o);a1(n)}z5(m);z5(k);l=p;return}function sj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=l;l=l+16|0;f=u+8|0;o=u+4|0;p=u;q=b+64|0;if(!(c[q>>2]|0))e=-1;else{lC(b);r=b+20|0;s=c[r>>2]|0;m=b+28|0;n=c[m>>2]|0;j=d8(d,-1)|0;k=b+24|0;e=c[k>>2]|0;if(j)f=s;else{if(!e){c[k>>2]=f;c[r>>2]=f;c[m>>2]=f+1;e=f}a[e>>0]=e9(d)|0;e=(c[k>>2]|0)+1|0;c[k>>2]=e;f=c[r>>2]|0}a:do if((e|0)==(f|0))t=23;else{do if(a[b+98>>0]|0){p=e-f|0;if((w8(f,p,c[q>>2]|0)|0)!=(p|0)){e=-1;break a}}else{h=b+32|0;c[o>>2]=c[h>>2];i=b+68|0;j=b+72|0;g=b+52|0;while(1){b=c[i>>2]|0;if(!b){t=11;break}v=c[h>>2]|0;e=qb[c[(c[b>>2]|0)+12>>2]&15](b,j,f,e,p,v,v+(c[g>>2]|0)|0,o)|0;f=c[r>>2]|0;if((c[p>>2]|0)==(f|0))break;if((e|0)==3){t=14;break}if((e|1|0)!=1)break;b=c[h>>2]|0;v=(c[o>>2]|0)-b|0;if((w8(b,v,c[q>>2]|0)|0)!=(v|0))break;if((e|0)!=1){t=21;break}e=c[p>>2]|0;v=c[k>>2]|0;c[r>>2]=e;c[m>>2]=v;f=e;e=f+(v-e)|0;c[k>>2]=e}if((t|0)==11){v=ua(4)|0;G9(v);Ya(v|0,2744,371)}else if((t|0)==14){v=(c[k>>2]|0)-f|0;if((w8(f,v,c[q>>2]|0)|0)==(v|0))break}else if((t|0)==21)break;e=-1;break a}while(0);c[k>>2]=s;c[r>>2]=s;c[m>>2]=n;t=23}while(0);if((t|0)==23)e=e3(d)|0}l=u;return e|0}function tj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+32|0;k=m+24|0;i=m+12|0;f=m;W0(k,407712);j=b+4|0;g=c[b>>2]|0;if(((((c[j>>2]|0)-g|0)==40?(n=c[g>>2]|0,d=n,((c[g+4>>2]|0)-n|0)==12):0)?(e=i9(3020)|0,n=a[d+8+3>>0]|0,(e|0)==((n<<24>>24<0?c[d+4>>2]|0:n&255)|0)):0)?(VG(d,3020,e)|0)==0:0){a[404916]=1;FN(405008);Xy(i,3036);Xy(f,3136);zY(i,f);z5(f);z5(i);Xy(i,3148);Xy(f,3244);zY(i,f);z5(f);z5(i);Xy(i,3260);Xy(f,3356);zY(i,f);z5(f);z5(i);Xy(i,7160);Xy(f,42212);zY(i,f);z5(f);z5(i);Xy(i,3368);TX(f);zY(i,f);z5(f);z5(i);d=0}else h=6;a:do if((h|0)==6){a[404916]=0;WG(405008);f=0;while(1){n=c[b>>2]|0;d=n;if(f>>>0>=(((c[j>>2]|0)-n|0)/40|0)>>>0){d=0;break a}e=c[d+(f*40|0)>>2]|0;d=(c[d+(f*40|0)+4>>2]|0)-e|0;if(((d|0)/12|0)>>>0<=1){if((d|0)==12){TX(i);zY(e,i);z5(i)}}else zY(e,e+12|0);f=f+1|0}}while(0);while(1){if(d>>>0>=7)break;if((c[407252+(d*56|0)>>2]|0)!=(c[407252+(d*56|0)+4>>2]|0))vc(d);d=d+1|0}s7(c[k>>2]|0);l=m;return}function uj(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=l;l=l+16|0;q=y;GC(e);r=e+2506|0;n=(a[r>>0]|0)==2?7:31;t=e+2510|0;u=e+2507|0;v=e+2477|0;p=e+648|0;o=0;a:while(1){w=o&255;f=a[t>>0]|0;if((o&255)>=(f&255)){x=30;break}if((f&255)>1){GC(e);f=0;i=0}else{f=0;i=0}while(1){j=i&255;if((i&255)>=(d[u>>0]|0))break;k=f&255;m=e+19553+(w<<6)+k|0;if(!(a[v>>0]|0))xR(e,4,m);else xR(e,5,m);if(((a[v>>0]|0)!=0?(s=a[m>>0]|0,(s&255)>=11):0)?!(s<<24>>24!=11&(s&255)<16):0){a[q>>0]=1;g=0;h=1}else{g=0;x=12}if((x|0)==12)while(1){x=0;if(!(Z9(c[(c[p>>2]|0)+4>>2]|0)|0)){x=13;break a}xR(e,(a[r>>0]|0)==2?3:5,q);h=a[q>>0]|0;if((h&255|0)==(n|0)){g=(g&255)+n&255;x=12}else break}z=i&255;b[e+20066+(w<<7)+(k<<1)>>1]=z;i=((g&255)+(h&255)&255)+j|0;b[e+21090+(w<<7)+(k<<1)>>1]=i;g=z;while(1){h=g&65535;if(h>>>0>=i>>>0)break;a[e+19032+(w<<6)+h>>0]=a[m>>0]|0;g=g+1<<16>>16}f=f+1<<24>>24;if((f&255)>64){x=22;break a}i=i&255}a[e+19545+w>>0]=f;if((d[t>>0]|0)>1)J3(e);o=o+1<<24>>24}if((x|0)==13){t4(e);if((d[t>>0]|0)>1)J3(e);J3(e);x=29}else if((x|0)==22){t4(e);if((d[t>>0]|0)>1)J3(e);J3(e);x=29}else if((x|0)==30)J3(e);l=y;return}function vj(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;j=g+8|0;while(1){g=c[d>>2]|0;do if(g){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=e9(a[h>>0]|0)|0;if(d8(g,-1)|0){c[d>>2]=0;h=1;break}else{h=(c[d>>2]|0)==0;break}}else h=1;while(0);if(e){g=c[e+12>>2]|0;if((g|0)==(c[e+16>>2]|0))g=nb[c[(c[e>>2]|0)+36>>2]&255](e)|0;else g=e9(a[g>>0]|0)|0;if(!(d8(g,-1)|0)){if(!h)break}else k=14}else k=14;if((k|0)==14){k=0;if(h){e=0;break}else e=0}g=c[d>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=e9(a[h>>0]|0)|0;if((g&255)<<24>>24<=-1)break;if(!(b[(c[j>>2]|0)+(g<<24>>24<<1)>>1]&8192))break;g=c[d>>2]|0;h=g+12|0;i=c[h>>2]|0;if((i|0)==(c[g+16>>2]|0)){nb[c[(c[g>>2]|0)+40>>2]&255](g)|0;continue}else{c[h>>2]=i+1;continue}}g=c[d>>2]|0;do if(g){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=e9(a[h>>0]|0)|0;if(d8(g,-1)|0){c[d>>2]=0;h=1;break}else{h=(c[d>>2]|0)==0;break}}else h=1;while(0);if(e){g=c[e+12>>2]|0;if((g|0)==(c[e+16>>2]|0))g=nb[c[(c[e>>2]|0)+36>>2]&255](e)|0;else g=e9(a[g>>0]|0)|0;if(!(d8(g,-1)|0)){if(!h)k=38}else k=36}else k=36;if((k|0)==36?h:0)k=38;if((k|0)==38)c[f>>2]=c[f>>2]|2;return}function wj(e,f,g,h,i,j){e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;c[g>>2]=e;c[j>>2]=h;q=f;r=i;a:while(1){k=c[g>>2]|0;if(k>>>0>=f>>>0){e=0;break}if(h>>>0>=i>>>0){e=1;break}o=a[k>>0]|0;p=o&255;e=k+1|0;do if(o<<24>>24>-1)b[h>>1]=o&255;else{if((o&255)<194){e=2;break a}l=q-k|0;m=k+2|0;if((o&255)<224){if((l|0)<2){e=1;break a}e=d[e>>0]|0;if((e&192|0)!=128){e=2;break a}b[h>>1]=e&63|p<<6&1984;e=m;break}n=k+3|0;if((o&255)<240){if((l|0)<3){e=1;break a}k=a[m>>0]|0;l=d[e>>0]|0;e=l&224;switch(o<<24>>24){case -32:{if((e|0)!=160){e=2;break a}break}case -19:{if((e|0)!=128){e=2;break a}break}default:if((l&192|0)!=128){e=2;break a}}e=k&255;if((e&192|0)!=128){e=2;break a}b[h>>1]=l<<6&4032|p<<12|e&63;e=n;break}if((o&255)>=245){e=2;break a}if((l|0)<4){e=1;break a}l=a[e>>0]|0;e=a[m>>0]|0;k=a[n>>0]|0;m=l&255;switch(o<<24>>24){case -16:{if((l+112&255)>=48){e=2;break a}break}case -12:{if((m&240|0)!=128){e=2;break a}break}default:if((m&192|0)!=128){e=2;break a}}l=e&255;if((l&192|0)!=128){e=2;break a}k=k&255;if((k&192|0)!=128){e=2;break a}if((r-h|0)<4){e=1;break a}e=p&7;if((m<<12&196608|e<<18)>>>0>1114111){e=2;break a}b[h>>1]=m<<2&60|l>>>4&3|((m>>>4&3|e<<2)<<6)+16320|55296;e=h+2|0;c[j>>2]=e;b[e>>1]=l<<6&960|k&63|56320;e=(c[g>>2]|0)+4|0}while(0);c[g>>2]=e;h=(c[j>>2]|0)+2|0;c[j>>2]=h}return e|0}function xj(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+32|0;d=i+24|0;g=i+12|0;h=i;Bx(b);d4(c[b+648>>2]|0,2);rR(b,22,d);wK(b);do if(qO(b)|0?(a[b+768>>0]|0)==2:0){d=(c[d>>2]|0)*400|0;if(!(a[b+784>>0]|0)){sU(g,d,10);f=c[b+760>>2]|0;b=$C((HD(f+68|0,f)|0)+16|0,b+770|0)|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;f=j9(387665)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[h+11>>0]=f;d=h}else{j=f+16&-16;d=ZW(j)|0;c[h>>2]=d;c[h+8>>2]=j|-2147483648;c[h+4>>2]=f}i1(d,387665,f)|0;J7(d+f|0,0);vF(VC(b+4|0,h)|0,g)|0;a1(h);z5(g);break}else{sU(g,d,10);b=c[(c[(c[b+760>>2]|0)+80>>2]|0)+(e[b+772>>1]<<2)>>2]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;f=j9(387665)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[h+11>>0]=f;d=h}else{j=f+16&-16;d=ZW(j)|0;c[h>>2]=d;c[h+8>>2]=j|-2147483648;c[h+4>>2]=f}i1(d,387665,f)|0;J7(d+f|0,0);vF(VC(b+28|0,h)|0,g)|0;a1(h);z5(g);break}}while(0);l=i;return}function yj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=l;l=l+16|0;g=h;b=(b>>>0)%5|0;a:do switch(b&7){case 4:case 2:break;default:{f=a+648|0;if(K6(c[f>>2]|0)|0){GC(a);A6(c[f>>2]|0);b:do{n3(a,g);e=c[g>>2]|0;do if(e>>>0<2)T5(a);else{if((e|0)==2){T5(a);break}if((e|1|0)==5&d){T5(a);if((e|0)==3)break b;else break}if((e|0)==3)break b;t4(a);e=c[f>>2]|0;G4(e,Z9(c[e+4>>2]|0)|0)}while(0)}while((Z9(c[(c[f>>2]|0)+4>>2]|0)|0)!=0);J3(a)}else A6(c[f>>2]|0);if((b|0)==1){if(!(K6(c[f>>2]|0)|0)){A6(c[f>>2]|0);break a}GC(a);A6(c[f>>2]|0);c:do{n3(a,g);b=c[g>>2]|0;do if(b>>>0<2)T5(a);else{if((b|0)==2){T5(a);break}if((b|1|0)==5&d){T5(a);if((b|0)==3)break c;else break}if((b|0)==3)break c;t4(a);e=c[f>>2]|0;G4(e,Z9(c[e+4>>2]|0)|0)}while(0)}while((Z9(c[(c[f>>2]|0)+4>>2]|0)|0)!=0);J3(a)}}}while(0);l=h;return}function zj(b){b=b|0;var d=0,e=0,f=0;if(!(+g[(c[b+24>>2]|0)+136>>2]>=.8)){d=aP()|0;d=UW(d|0,z|0,27,0)|0;d=g5(d|0,z|0,1e3,0)|0;e=z}else{d=-1;e=-1}f=b+800|0;c[f>>2]=d;c[f+4>>2]=e;d=ZW(212)|0;Vq(d);e=b+768|0;c[e>>2]=d;FF(d+80|0,8192);d=0;while(1){if((d|0)==8192)break;f=ZW(200)|0;Ss(f);c[(c[(c[e>>2]|0)+80>>2]|0)+(d<<2)>>2]=f;d=d+1|0}UZ(c[c[(c[e>>2]|0)+80>>2]>>2]|0,1);f=c[c[(c[e>>2]|0)+80>>2]>>2]|0;c[f+64>>2]=2;nG(f+16|0);f=ZW(16)|0;M0(f);c[c[(c[c[(c[e>>2]|0)+80>>2]>>2]|0)+16>>2]>>2]=f;UZ(c[(c[(c[e>>2]|0)+80>>2]|0)+4>>2]|0,1);f=c[(c[(c[e>>2]|0)+80>>2]|0)+4>>2]|0;c[f+64>>2]=2;nG(f+16|0);f=ZW(16)|0;M0(f);c[(c[(c[(c[(c[e>>2]|0)+80>>2]|0)+4>>2]|0)+16>>2]|0)+4>>2]=f;UZ(c[(c[(c[e>>2]|0)+80>>2]|0)+8>>2]|0,1);f=c[(c[(c[e>>2]|0)+80>>2]|0)+8>>2]|0;c[f+64>>2]=2;nG(f+16|0);UZ(c[(c[(c[e>>2]|0)+80>>2]|0)+12>>2]|0,1);f=c[(c[(c[e>>2]|0)+80>>2]|0)+12>>2]|0;c[f+64>>2]=2;nG(f+16|0);a[b+811>>0]=(mS()|0)&1;a[b+812>>0]=0;if(a[b+760>>0]|0)mp(b);jb[c[(c[b>>2]|0)+44>>2]&511](b);return}function Aj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i;if((a|0)>6|(b|0)>3)a=408444;else{W0(f,407712);g=405236+(b*392|0)+(a*56|0)|0;a:do if(!(c[405236+(b*392|0)+(a*56|0)+8>>2]|0)){h=(b|0)==1;switch(a|0){case 0:{if(!h)break a;gH(g);break a}case 1:switch(b|0){case 0:{bH(g);break a}case 1:{kH(g);break a}case 2:{qH(g);break a}case 3:{pH(g);break a}default:break a}case 2:switch(b|0){case 0:{cH(g);break a}case 1:{mH(g);break a}case 2:{tH(g);break a}case 3:{sH(g);break a}default:break a}case 3:switch(b|0){case 0:{fH(g);break a}case 1:{rH(g);break a}case 3:{xH(g);break a}default:break a}case 4:{if(!h)break a;lH(g);break a}default:break a}}while(0);s7(c[f>>2]|0);a=cK(g,d,e)|0}l=i;return a|0}function Bj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=l;l=l+96|0;g=j+72|0;i=j+16|0;h=j;TX(g);M2(g,(c[b+544>>2]|0)+(c[b+612>>2]|0)|0,c[b+536>>2]|0)|0;xA(i);Xy(h,42472);gI(i,0,h);z5(h);Xy(h,42204);gI(i,1,h);z5(h);SO(i);bf(i,g);h=i+4|0;f=0;while(1){if(f>>>0>=(((c[h>>2]|0)-(c[i>>2]|0)|0)/40|0)>>>0)break;d=wF(i,f,0)|0;e=i9(29728)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,29728,e)|0)==0:0)zb(b,0,0,159,wF(i,f,1)|0,0);d=wF(i,f,0)|0;e=i9(29752)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,29752,e)|0)==0:0)zb(b,0,0,160,wF(i,f,1)|0,0);d=wF(i,f,0)|0;e=i9(29800)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,29800,e)|0)==0:0)zb(b,0,0,161,wF(i,f,1)|0,0);d=wF(i,f,0)|0;e=i9(29816)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,29816,e)|0)==0:0)zb(b,0,0,14,wF(i,f,1)|0,0);f=f+1|0}LT(i);z5(g);l=j;return}function Cj(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;o=l;l=l+48|0;d=o+36|0;j=o+40|0;k=o+24|0;m=o+12|0;n=o;s3(b,d);bB(b,j);if((qO(b)|0?(a[b+768>>0]|0)==2:0)?a[b+784>>0]|0:0){TX(k);d=c[d>>2]|0;if(d|0)Tv(k,d)|0;g=SG(k)|0;i=a[g+8+3>>0]|0;g=((i<<24>>24<0?c[g+4>>2]|0:i&255)|0)==0?k:g;i=b+760|0;h=b+772|0;b=c[(c[(c[i>>2]|0)+80>>2]|0)+(e[h>>1]<<2)>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(384512)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;d=m}else{p=f+16&-16;d=ZW(p)|0;c[m>>2]=d;c[m+8>>2]=p|-2147483648;c[m+4>>2]=f}i1(d,384512,f)|0;J7(d+f|0,0);k1(VC(b+28|0,m)|0,g)|0;a1(m);d=a[j>>0]|0;if(d<<24>>24){VU(m,XU(d)|0);b=c[(c[(c[i>>2]|0)+80>>2]|0)+(e[h>>1]<<2)>>2]|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;f=j9(387702)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[n+11>>0]=f;d=n}else{p=f+16&-16;d=ZW(p)|0;c[n>>2]=d;c[n+8>>2]=p|-2147483648;c[n+4>>2]=f}i1(d,387702,f)|0;J7(d+f|0,0);vF(VC(b+28|0,n)|0,m)|0;a1(n);z5(m)}z5(k)}l=o;return}function Dj(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;o=l;l=l+64|0;g=o+48|0;j=o+36|0;k=o+24|0;m=o+12|0;n=o;bB(b,g);if(qO(b)|0?a[b+784>>0]|0:0){Xy(j,39640);i=b+760|0;h=b+772|0;d=c[(c[(c[i>>2]|0)+80>>2]|0)+(e[h>>1]<<2)>>2]|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;f=j9(384578)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[k+11>>0]=f;b=k}else{p=f+16&-16;b=ZW(p)|0;c[k>>2]=b;c[k+8>>2]=p|-2147483648;c[k+4>>2]=f}i1(b,384578,f)|0;J7(b+f|0,0);vF(VC(d+28|0,k)|0,j)|0;a1(k);z5(j);uU(m,a[g>>0]|0,10);DW(m,0,39708)|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];b=0;while(1){if((b|0)==3)break;c[m+(b<<2)>>2]=0;b=b+1|0}p2(j,k);d=c[(c[(c[i>>2]|0)+80>>2]|0)+(e[h>>1]<<2)>>2]|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;f=j9(384592)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[n+11>>0]=f;b=n}else{p=f+16&-16;b=ZW(p)|0;c[n>>2]=b;c[n+8>>2]=p|-2147483648;c[n+4>>2]=f}i1(b,384592,f)|0;J7(b+f|0,0);vF(VC(d+28|0,n)|0,j)|0;a1(n);z5(j);O0(k);z5(m)}l=o;return}function Ej(b,d,e,f,g,h,i,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0;r=k;q=j+4|0;p=j+11|0;a:do if(b<<24>>24==h<<24>>24)if(a[d>>0]|0){a[d>>0]=0;e=c[g>>2]|0;c[g>>2]=e+1;a[e>>0]=46;g=a[p>>0]|0;if(((g<<24>>24<0?c[q>>2]|0:g&255)|0)!=0?(o=c[l>>2]|0,(o-r|0)<160):0){k=c[m>>2]|0;c[l>>2]=o+4;c[o>>2]=k;k=0}else k=0}else k=-1;else{if(b<<24>>24==i<<24>>24?(i=a[p>>0]|0,(i<<24>>24<0?c[q>>2]|0:i&255)|0):0){if(!(a[d>>0]|0)){k=-1;break}k=c[l>>2]|0;if((k-r|0)>=160){k=0;break}g=c[m>>2]|0;c[l>>2]=k+4;c[k>>2]=g;c[m>>2]=0;k=0;break}o=n+32|0;j=0;while(1){k=n+j|0;if((j|0)==32){k=o;break}if((a[k>>0]|0)==b<<24>>24)break;else j=j+1|0}j=k-n|0;if((j|0)>31)k=-1;else{o=a[401970+j>>0]|0;switch(j|0){case 24:case 25:{k=c[g>>2]|0;if((k|0)!=(f|0)?(a[k+-1>>0]&95)!=(a[e>>0]&127):0){k=-1;break a}c[g>>2]=k+1;a[k>>0]=o;k=0;break a}case 23:case 22:{a[e>>0]=80;k=c[g>>2]|0;c[g>>2]=k+1;a[k>>0]=o;k=0;break a}default:{k=o&95;if((((k|0)==(a[e>>0]|0)?(a[e>>0]=k|128,a[d>>0]|0):0)?(a[d>>0]=0,e=a[p>>0]|0,(e<<24>>24<0?c[q>>2]|0:e&255)|0):0)?(s=c[l>>2]|0,(s-r|0)<160):0){e=c[m>>2]|0;c[l>>2]=s+4;c[s>>2]=e}l=c[g>>2]|0;c[g>>2]=l+1;a[l>>0]=o;if((j|0)>21){k=0;break a}c[m>>2]=(c[m>>2]|0)+1;k=0;break a}}}}while(0);return k|0}function Fj(a){a=a|0;var b=0,d=0,e=0,f=0;d=a+520|0;b=c[d>>2]|0;d=c[d+4>>2]|0;do switch(b|0){case 176:{if(!d)Ox(a);else e=28;break}case 177:{if(!d)uK(a);else e=28;break}case 178:{if(!d)$b(a);else e=28;break}case 179:{if(!d)Nk(a);else e=28;break}case 180:{if(d|0)e=28;break}case 181:{if(!d)Wi(a);else e=28;break}case 182:{if(!d)cc(a);else e=28;break}case 183:{if(d|0)e=28;break}case 184:{if(d|0)e=28;break}case 185:{if(d|0)e=28;break}case 186:{if(d|0)e=28;break}case 187:{if(d|0)e=28;break}case 188:{if(d|0)e=28;break}case 189:{if(d|0)e=28;break}case 190:{if(d|0)e=28;break}case 191:{if(d|0)e=28;break}case 192:{if(d|0)e=28;break}case 193:{if(d|0)e=28;break}case 194:{if(d|0)e=28;break}case 195:{if(d|0)e=28;break}default:e=28}while(0);do if((e|0)==28){if(d>>>0<0|(d|0)==0&b>>>0<32){QI(a);break}if(d>>>0<0|(d|0)==0&b>>>0<48){dc(a);break}if(!(d>>>0<0|(d|0)==0&b>>>0<198|(b&-16|0)==64&(d|0)==0)){e=a+312|0;if((c[e>>2]|0)==0&(c[e+4>>2]|0)==0?(d=a+552|0,f=c[d+4>>2]|0,e=a+632|0,b=c[e+4>>2]|0,f>>>0>b>>>0|((f|0)==(b|0)?(c[d>>2]|0)>>>0>(c[e>>2]|0)>>>0:0)):0)c[a+500>>2]=0;t4(a)}}while(0);return}function Gj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+80|0;b=m+32|0;h=m+60|0;i=m+48|0;j=m+16|0;k=m;L2(b);HB(a,m+64|0);bD(a,h);j0(a,b);if(qO(a)|0){f=b+8|0;e=c[f>>2]|0;f=c[f+4>>2]|0;g=a+20|0;d=b;b=c[d>>2]|0;d=c[d+4>>2]|0;if((e|0)==4096&(f&65535|0)==0&((b|0)==3709809&(d|0)==-2147483478)){d=XZ(e|0,f|0,40)|0;k=XZ(e|0,f|0,56)|0;k=(d&65280|k)&65535;TX(i);d=Ek(i,k,16)|0;Rf(a,d,2,c[g>>2]|0,3);z5(i);d=c[g>>2]|0;TX(i);dX(j,3709809,-2147483478,e,f);zb(a,2,d,46,dh(i,j)|0,1);z5(i);j=c[g>>2]|0;TX(i);zb(a,2,j,52,UJ(Ek(i,k,16)|0,1)|0,1);z5(i);PK(a)}else{TX(i);dX(k,b,d,e,f);k=dh(i,k)|0;Rf(a,k,2,c[g>>2]|0,3);z5(i)}k=c[g>>2]|0;j=c[h>>2]|0;Xo(i,j);bw(a,2,k,128,i,1,0);a1(i);k=c[g>>2]|0;xk(i,j);bw(a,2,k,129,i,1,0);a1(i)}l=m;return}function Hj(b){b=b|0;var e=0,f=0,g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+16|0;n=s+7|0;o=s+6|0;p=s+5|0;e=s+4|0;f=s+3|0;g=s+2|0;i=s+1|0;j=s;r=b+528|0;m=r;m=z0(c[m>>2]|0,c[m+4>>2]|0,2,0)|0;q=r;c[q>>2]=m;c[q+4>>2]=z;Bx(b);q=b+648|0;d4(c[q>>2]|0,8);xR(b,4,n);xR(b,4,o);d4(c[q>>2]|0,8);xR(b,4,p);xR(b,4,e);d4(c[q>>2]|0,8);xR(b,4,f);xR(b,4,g);d4(c[q>>2]|0,8);xR(b,4,i);xR(b,4,j);wK(b);q=r;q=z0(c[q>>2]|0,c[q+4>>2]|0,6,0)|0;c[r>>2]=q;c[r+4>>2]=z;do if(qO(b)|0){r=a[e>>0]|0;q=a[f>>0]|0;g=a[g>>0]|0;f=a[i>>0]|0;j=a[j>>0]|0;m=b+312|0;k=c[m>>2]|0;m=c[m+4>>2]|0;if((k|0)==0&(m|0)==0)h[b+1576>>3]=+(((f&255)*10|0)+(j&255)|0)/29.97+ +(((q&255)*10|0)+((r&255)*60|0)+(g&255)+((d[p>>0]|0)*600|0)+((d[o>>0]|0)*3600|0)+((d[n>>0]|0)*36e3|0)|0);a[b+1565>>0]=0;a[b+1566>>0]=1;i=b+1567|0;e=a[i>>0]|0;if(!(r<<24>>24==0?1:(g|q|f|e)<<24>>24!=0)){g=b+1568|0;switch(j<<24>>24){case 1:case 0:{e=0;f=8;break}case 2:{if(m>>>0>0|(m|0)==0&k>>>0>1){e=1;f=8}else f=7;break}default:f=7}if((f|0)==7){if(!(e<<24>>24))break}else if((f|0)==8){a[i>>0]=1;a[g>>0]=e}b=b+760|0;c[b>>2]=32;c[b+4>>2]=0}}while(0);l=s;return}function Ij(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;f=n;g=n+3|0;k=n+2|0;m=d+528|0;j=m;j=z0(c[j>>2]|0,c[j+4>>2]|0,1,0)|0;e=m;c[e>>2]=j;c[e+4>>2]=z;Bx(d);AT(d,k);e=d+648|0;d4(c[e>>2]|0,6);d4(c[e>>2]|0,33);d4(c[e>>2]|0,8);d4(c[e>>2]|0,12);sR(d,12,f);e=b[f>>1]|0;if(e<<16>>16==4095){j=d+536|0;j=z0(c[j>>2]|0,c[j+4>>2]|0,65532,0)|0;e=m;e=D_(j|0,z|0,c[e>>2]|0,c[e+4>>2]|0)|0;e=e&65535;b[f>>1]=e}xR(d,8,g);wK(d);GC(d);switch(a[g>>0]|0){case 7:case 4:case 0:break;case 5:{Rm(d);break}case 6:{S3(d);break}default:e1(d,e&65535,0)}J3(d);i=m;i=z0(c[i>>2]|0,c[i+4>>2]|0,4,0)|0;f=z;g=d+536|0;j=g;h=c[j+4>>2]|0;if(f>>>0<h>>>0|((f|0)==(h|0)?i>>>0<(c[j>>2]|0)>>>0:0)?(j=d+770|0,NB(d,j),b[d+776>>1]=b[c[d+764>>2]>>1]|0,b[j>>1]|0):0)Ao(d);e=m;f=c[e>>2]|0;e=c[e+4>>2]|0;i=z0(f|0,e|0,4,0)|0;j=z;h=g;g=c[h>>2]|0;h=c[h+4>>2]|0;if(h>>>0>j>>>0|(h|0)==(j|0)&g>>>0>i>>>0){e=D_(g|0,h|0,i|0,j|0)|0;e1(d,e,z);e=m;f=c[e>>2]|0;e=c[e+4>>2]|0}k=(a[k>>0]|0)==0;g=z0(f|0,e|0,4,0)|0;h=z;if(!k){f=m;c[f>>2]=g;c[f+4>>2]=h;f=g;e=h}k=z0(f|0,e|0,4,0)|0;c[m>>2]=k;c[m+4>>2]=z;l=n;return}function Jj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+16|0;r=s+7|0;j=s+6|0;k=s+5|0;m=s+4|0;n=s+3|0;o=s+2|0;p=s+1|0;q=s;GC(b);xR(b,8,r);xR(b,2,k);i=b+648|0;d4(c[i>>2]|0,3);xR(b,3,j);r=a[r>>0]|0;j=(a[j>>0]|0)==1;k=(a[k>>0]|0)==2;h=0;while(1){if((h&255)>=(r&255))break;xR(b,6,m);f=a[m>>0]|0;e=0;while(1){if((e&255)>=(f&255))break;AT(b,n);AT(b,p);AT(b,q);if(!j)A6(c[i>>2]|0);AT(b,o);g=(a[o>>0]|0)==0;if(g)A6(c[i>>2]|0);if(k)d4(c[i>>2]|0,2);A6(c[i>>2]|0);d=c[i>>2]|0;if(!(a[n>>0]|0))d4(d,16);else d4(d,4);do if(!(a[p>>0]|0)){d=c[i>>2]|0;if(g){d4(d,5);break}else{d4(d,7);break}}while(0);if(!(a[q>>0]|0))d4(c[i>>2]|0,5);e=e+1<<24>>24}AT(b,n);a:do if(a[n>>0]|0){e=f&255;d=0;while(1){if((d|0)==(e|0))break a;d4(c[i>>2]|0,6);d=d+1|0}}while(0);h=h+1<<24>>24}AT(b,m);if(a[m>>0]|0){d4(c[i>>2]|0,5);d4(c[i>>2]|0,5)}J3(b);l=s;return}function Kj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+32|0;j=s+8|0;p=s;bB(a,s+16|0);jB(a,s+12|0);ID(a,j);q=a+916|0;r=a+788|0;k=bF(q,r)|0;k=(c[k+136>>2]|0)==(c[k+140>>2]|0);m=a+528|0;n=a+536|0;o=a+544|0;i=a+612|0;j=c[j>>2]|0;b=1;h=0;while(1){if(h>>>0>=j>>>0)break;d=m;a=c[d>>2]|0;d=z0(a|0,c[d+4>>2]|0,4,0)|0;e=z;g=n;f=c[g+4>>2]|0;if(e>>>0>f>>>0|((e|0)==(f|0)?d>>>0>(c[g>>2]|0)>>>0:0))break;g=W8((c[o>>2]|0)+(c[i>>2]|0)+a|0)|0;f=m;c[f>>2]=d;c[f+4>>2]=e;a:do if((b|0)!=0&(g|0)==0){a=0;while(1){f=bF(q,r)|0;if(a>>>0>=(c[f+140>>2]|0)-(c[f+136>>2]|0)>>3>>>0){b=0;break a}f=(c[(bF(q,r)|0)+136>>2]|0)+(a<<3)|0;e=f;e=z0(c[e>>2]|0,c[e+4>>2]|0,-1,-1)|0;c[f>>2]=e;c[f+4>>2]=z;a=a+1|0}}while(0);f=bF(q,r)|0;a=g-b|0;d=p;c[d>>2]=a;c[d+4>>2]=0;d=f+140|0;e=c[d>>2]|0;if(e>>>0<(c[f+144>>2]|0)>>>0){g=e;c[g>>2]=a;c[g+4>>2]=0;c[d>>2]=e+8}else Px(f+136|0,p);h=h+1|0}if(!k){p=c[(bF(q,r)|0)+136>>2]|0;Ye(p,c[(bF(q,r)|0)+140>>2]|0)}l=s;return}function Lj(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+16|0;d=m;k=m+10|0;e=m+8|0;f=m+6|0;h=m+4|0;HB(a,k);HB(a,e);bD(a,d);i=a+864|0;bD(a,i);j=a+528|0;n=j;n=z0(c[n>>2]|0,c[n+4>>2]|0,2,0)|0;g=j;c[g>>2]=n;c[g+4>>2]=z;HB(a,f);if(qO(a)|0){c[a+796>>2]=3;n=a+784|0;Ek(n,b[k>>1]|0,16)|0;g=a+20|0;Rf(a,n,2,c[g>>2]|0,3);zb(a,2,c[g>>2]|0,52,n,1);zb(a,2,c[g>>2]|0,57,n,0);n=b[e>>1]|0;sM(a,2,c[g>>2]|0,122,n<<16>>16!=5?n&65535:6,1);lL(a,2,c[g>>2]|0,135,c[d>>2]|0,10,1);lL(a,2,c[g>>2]|0,112,c[i>>2]<<3,10,1);d=b[f>>1]|0;if(d<<16>>16)kL(a,2,c[g>>2]|0,147,d,10,0);fc(a);d=a+840|0;n=d;if(!((c[n>>2]|0)==-1?(c[n+4>>2]|0)==-1:0)){n=c[i>>2]|0;c[(kE(a+760|0,d)|0)+48>>2]=n}}j=z0(c[j>>2]|0,c[j+4>>2]|0,2,0)|0;g=z;n=a+536|0;i=c[n+4>>2]|0;if(!(g>>>0>i>>>0|((g|0)==(i|0)?j>>>0>(c[n>>2]|0)>>>0:0))){HB(a,h);d=b[h>>1]|0;do if(d<<16>>16)if((b[k>>1]|0)==-2){Ii(a);break}else{e1(a,d&65535,0);break}while(0)}l=m;return}function Mj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0.0,o=0.0;m=l;l=l+16|0;f=m;g=b+952|0;e=g;d=c[e>>2]|0;e=c[e+4>>2]|0;i=b+944|0;k=i;k=D_(d|0,e|0,c[k>>2]|0,c[k+4>>2]|0)|0;j=z;h=b+612|0;do if(!(j>>>0<0|(j|0)==0&k>>>0<100)){if(qO(b)|0){j=g;k=i;k=D_(c[j>>2]|0,c[j+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0;oK(b,2,0,194,k,z,10,0)}k=b+520|0;c[k>>2]=-1;c[k+4>>2]=-1;if(qO(b)|0){$x(f,b,2,0,68,1);d=rm(f)|0;e=z;z5(f);$x(f,b,2,0,112,1);j=rm(f)|0;k=z;z5(f);if(!((d|0)==0&(e|0)==0)){h=g;i=D_(c[h>>2]|0,c[h+4>>2]|0,c[i>>2]|0,c[i+4>>2]|0)|0;i=UW(i|0,z|0,8e3,0)|0;d=g5(i|0,z|0,d|0,e|0)|0;e=z;o=+(d>>>0)+4294967296.0*+(e>>>0);n=+(j>>>0)+4294967296.0*+(k>>>0);if(!(o<n*.95|o>n*1.05))break;oK(b,2,0,112,d,e,10,1);break}if(!((j|0)==0&(k|0)==0)){if(!(a[b+492>>0]|0)){e=g;d=i;d=D_(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e=z}else{d=t7((c[b+544>>2]|0)+(c[h>>2]|0)+-4|0)|0;e=0}i=UW(d|0,e|0,8e3,0)|0;j=g5(i|0,z|0,j|0,k|0)|0;k=z;oK(b,0,0,92,j,k,10,1);oK(b,2,0,68,j,k,10,1)}}}else{k=D_(d|0,e|0,c[h>>2]|0,0)|0;e1(b,k,z)}while(0);l=m;return}function Nj(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;q=l;l=l+64|0;h=q+36|0;i=q+49|0;j=q+24|0;m=q+48|0;n=q+12|0;o=q;TX(h);p=d+528|0;f=p;f=z0(c[f>>2]|0,c[f+4>>2]|0,2,0)|0;g=p;c[g>>2]=f;c[g+4>>2]=z;Ce(d,h);bB(d,i);wK(d);i=a[i>>0]|0;g=d+648|0;f=0;while(1){if((f&255)>=(i&255))break;GC(d);TX(j);e=p;e=z0(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;k=p;c[k>>2]=e;c[k+4>>2]=z;Ce(d,j);Bx(d);d4(c[g>>2]|0,3);A6(c[g>>2]|0);xR(d,4,m);wK(d);k=a[m>>0]|0;e=0;while(1){if((e&255)>=(k&255))break;GC(d);TX(n);TX(o);r=p;r=z0(c[r>>2]|0,c[r+4>>2]|0,1,0)|0;s=p;c[s>>2]=r;c[s+4>>2]=z;Ce(d,n);s=p;s=z0(c[s>>2]|0,c[s+4>>2]|0,1,0)|0;r=p;c[r>>2]=s;c[r+4>>2]=z;Ce(d,o);J3(d);z5(o);z5(n);e=e+1<<24>>24}J3(d);z5(j);f=f+1<<24>>24}Bx(d);d4(c[g>>2]|0,6);s=d+770|0;sR(d,10,s);wK(d);if(b[s>>1]|0)Ao(d);z5(h);l=q;return}function Oj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+800|0;m=o;a[b+773>>0]=2;QE(m);a[m+760>>0]=0;d=ZW(212)|0;Vq(d);e=m+764|0;c[e>>2]=d;FF(d+80|0,256);d=0;while(1){if((d|0)==256)break;k=ZW(200)|0;Ss(k);c[(c[(c[e>>2]|0)+80>>2]|0)+(d<<2)>>2]=k;d=d+1|0}aY(b,m);rB(b,m);G2(b,m);j=qO(b)|0;k=c[e>>2]|0;a:do if(j){j=b+804|0;d=c[j>>2]|0;i=d+22392|0;d=d+22632|0;c[d>>2]=c[i>>2];c[d+4>>2]=c[i+4>>2];c[d+8>>2]=c[i+8>>2];c[d+12>>2]=c[i+12>>2];c[d+16>>2]=c[i+16>>2];c[d+20>>2]=c[i+20>>2];c[d+24>>2]=c[i+24>>2];c[d+28>>2]=c[i+28>>2];d=c[j>>2]|0;i=d+22608|0;if((c[i>>2]|0)==-1?(c[i+4>>2]|0)==-1:0){h=d+22632|0;i=d+22600|0;c[i>>2]=c[h>>2];c[i+4>>2]=c[h+4>>2];c[i+8>>2]=c[h+8>>2];c[i+12>>2]=c[h+12>>2];c[i+16>>2]=c[h+16>>2];c[i+20>>2]=c[h+20>>2];c[i+24>>2]=c[h+24>>2];c[i+28>>2]=c[h+28>>2]}d=k+80|0;e=k+76|0;b=k+68|0;i=0;while(1){if((i|0)==255)break a;f=c[(c[d>>2]|0)+(i<<2)>>2]|0;g=a[f+168>>0]|0;if(g<<24>>24!=-1){h=c[j>>2]|0;if(c[e>>2]|0?(n=c[b>>2]|0,c[n+44>>2]|0):0)c[h+(i*120|0)+16>>2]=c[(c[n+36>>2]|0)+88>>2];c[h+(i*120|0)+20>>2]=c[f+160>>2];a[h+(i*120|0)+12>>0]=g}i=i+1|0}}while(0);if(k|0){nm(k);laa(k)}j8(m);l=o;return}function Pj(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;s=l;l=l+64|0;m=s+44|0;n=s+32|0;o=s;p=s+56|0;q=s+20|0;r=s+8|0;TX(m);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[n+(e<<2)>>2]=0;e=e+1|0}Kc(b,6,-1)|0;k=b+528|0;f=k;f=z0(c[f>>2]|0,c[f+4>>2]|0,9,0)|0;e=k;c[e>>2]=f;c[e+4>>2]=z;e=b+20|0;f=c[e>>2]|0;lL(b,6,f,90,RA(b,6,f)|0,10,1);f=b+536|0;g=n+11|0;h=m+8+3|0;i=m+4|0;j=q+11|0;while(1){u=k;w=c[u+4>>2]|0;t=f;v=c[t+4>>2]|0;if(!(w>>>0<v>>>0|((w|0)==(v|0)?(c[u>>2]|0)>>>0<(c[t>>2]|0)>>>0:0)))break;oz(b,o);bB(b,p);EU(b,d[p>>0]|0,0,n);bj(m,(a[g>>0]|0)<0?c[n>>2]|0:n)|0;w=a[h>>0]|0;if(!((w<<24>>24<0?c[i>>2]|0:w&255)|0))cC(m,(a[g>>0]|0)<0?c[n>>2]|0:n)|0;if(!(qO(b)|0))continue;w=c[e>>2]|0;TX(r);v=o;v=g5(c[v>>2]|0,c[v+4>>2]|0,1e4,0)|0;pk(q,Hg(r,v,z)|0);Mc(b,6,w,(a[j>>0]|0)<0?c[q>>2]|0:q,m,0);a1(q);z5(r)}w=c[e>>2]|0;lL(b,6,w,91,RA(b,6,w)|0,10,1);a1(n);z5(m);l=s;return}function Qj(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,i=0;a=~a;while(1){if(!e){e=0;break}if(!(b&3))break;a=c[42480+(((d[b>>0]|0)^a&255)<<2)>>2]^a>>>8;e=e+-1|0;b=b+1|0}h=~e;h=e+32+(h>>>0>4294967264?h:-32)|0;g=b;f=e;while(1){if(f>>>0<=31)break;i=c[g>>2]^a;i=c[44528+((i>>>8&255)<<2)>>2]^c[45552+((i&255)<<2)>>2]^c[43504+((i>>>16&255)<<2)>>2]^c[42480+(i>>>24<<2)>>2]^c[g+4>>2];i=c[44528+((i>>>8&255)<<2)>>2]^c[45552+((i&255)<<2)>>2]^c[43504+((i>>>16&255)<<2)>>2]^c[42480+(i>>>24<<2)>>2]^c[g+8>>2];i=c[44528+((i>>>8&255)<<2)>>2]^c[45552+((i&255)<<2)>>2]^c[43504+((i>>>16&255)<<2)>>2]^c[42480+(i>>>24<<2)>>2]^c[g+12>>2];i=c[44528+((i>>>8&255)<<2)>>2]^c[45552+((i&255)<<2)>>2]^c[43504+((i>>>16&255)<<2)>>2]^c[42480+(i>>>24<<2)>>2]^c[g+16>>2];i=c[44528+((i>>>8&255)<<2)>>2]^c[45552+((i&255)<<2)>>2]^c[43504+((i>>>16&255)<<2)>>2]^c[42480+(i>>>24<<2)>>2]^c[g+20>>2];i=c[44528+((i>>>8&255)<<2)>>2]^c[45552+((i&255)<<2)>>2]^c[43504+((i>>>16&255)<<2)>>2]^c[42480+(i>>>24<<2)>>2]^c[g+24>>2];i=c[44528+((i>>>8&255)<<2)>>2]^c[45552+((i&255)<<2)>>2]^c[43504+((i>>>16&255)<<2)>>2]^c[42480+(i>>>24<<2)>>2]^c[g+28>>2];g=g+32|0;a=c[44528+((i>>>8&255)<<2)>>2]^c[45552+((i&255)<<2)>>2]^c[43504+((i>>>16&255)<<2)>>2]^c[42480+(i>>>24<<2)>>2];f=f+-32|0}f=h&-32;h=b+f|0;f=e-f|0;g=~f;g=(f+4+(g>>>0>4294967292?g:-4)|0)>>>2;b=h;e=f;while(1){if(e>>>0<=3)break;i=c[b>>2]^a;b=b+4|0;a=c[44528+((i>>>8&255)<<2)>>2]^c[45552+((i&255)<<2)>>2]^c[43504+((i>>>16&255)<<2)>>2]^c[42480+(i>>>24<<2)>>2];e=e+-4|0}e=f-(g<<2)|0;if(e){b=h+(g<<2)|0;while(1){a=c[42480+(((d[b>>0]|0)^a&255)<<2)>>2]^a>>>8;e=e+-1|0;if(!e)break;else b=b+1|0}}return ~a|0}function Rj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;while(1){f=c[a>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else f=raa(c[g>>2]|0)|0;if(d8(f,-1)|0){c[a>>2]=0;g=1;break}else{g=(c[a>>2]|0)==0;break}}else g=1;while(0);if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))f=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0;else f=raa(c[f>>2]|0)|0;if(!(d8(f,-1)|0)){if(!g){g=b;break}}else i=14}else i=14;if((i|0)==14){i=0;if(g){g=0;break}else b=0}f=c[a>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else f=raa(c[g>>2]|0)|0;if(!(gb[c[(c[e>>2]|0)+12>>2]&31](e,8192,f)|0)){g=b;break}f=c[a>>2]|0;g=f+12|0;h=c[g>>2]|0;if((h|0)==(c[f+16>>2]|0)){nb[c[(c[f>>2]|0)+40>>2]&255](f)|0;continue}else{c[g>>2]=h+4;continue}}b=c[a>>2]|0;do if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))b=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0;else b=raa(c[f>>2]|0)|0;if(d8(b,-1)|0){c[a>>2]=0;f=1;break}else{f=(c[a>>2]|0)==0;break}}else f=1;while(0);if(g){b=c[g+12>>2]|0;if((b|0)==(c[g+16>>2]|0))b=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else b=raa(c[b>>2]|0)|0;if(!(d8(b,-1)|0)){if(!f)i=37}else i=35}else i=35;if((i|0)==35?f:0)i=37;if((i|0)==37)c[d>>2]=c[d>>2]|2;return}function Sj(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+32|0;j=n+25|0;o=n+24|0;k=n+12|0;m=n;bB(b,j);Bx(b);AT(b,o);h=b+648|0;A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);wK(b);o=(a[o>>0]|0)==0;h=b+528|0;d=h;f=c[d>>2]|0;d=c[d+4>>2]|0;g=z0(f|0,d|0,1,0)|0;i=z;if(!o){f=h;c[f>>2]=g;c[f+4>>2]=i;f=g;d=i}o=b+536|0;d=D_(c[o>>2]|0,c[o+4>>2]|0,f|0,d|0)|0;f=z;if(!((d|0)==0&(f|0)==0))e1(b,d,f);if((qO(b)|0?(a[b+768>>0]|0)==2:0)?a[b+784>>0]|0:0){g=b+760|0;f=b+772|0;a[(c[(c[(c[g>>2]|0)+80>>2]|0)+(e[f>>1]<<2)>>2]|0)+169>>0]=124;VU(k,Ik(a[j>>0]|0)|0);f=c[(c[(c[g>>2]|0)+80>>2]|0)+(e[f>>1]<<2)>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;g=j9(384616)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[m+11>>0]=g;d=m}else{o=g+16&-16;d=ZW(o)|0;c[m>>2]=d;c[m+8>>2]=o|-2147483648;c[m+4>>2]=g}i1(d,384616,g)|0;J7(d+g|0,0);vF(VC(f+28|0,m)|0,k)|0;a1(m);z5(k)}l=n;return}function Tj(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=d+44|0;j=c[i>>2]|0;t=d+24|0;r=c[t>>2]|0;l=r;if(j>>>0<r>>>0){c[i>>2]=r;q=l}else q=j;s=h&24;a:do if((s|0)!=0?!((g|0)==1&(s|0)==24):0){k=d+32|0;n=(h&8|0)!=0;o=d+12|0;p=d+8|0;s=d+20|0;m=d+40+3|0;b:do switch(g|0){case 0:{i=0;j=0;break}case 1:if(n){j=(c[o>>2]|0)-(c[p>>2]|0)>>2;i=j;j=((j|0)<0)<<31>>31;break b}else{j=l-(c[s>>2]|0)>>2;i=j;j=((j|0)<0)<<31>>31;break b}case 2:{if((a[m>>0]|0)<0)i=c[k>>2]|0;else i=k;j=q-i>>2;i=j;j=((j|0)<0)<<31>>31;break}default:{j=-1;i=-1;break a}}while(0);j=z0(i|0,j|0,e|0,f|0)|0;i=z;if((i|0)>=0){if((a[m>>0]|0)<0)k=c[k>>2]|0;f=q-k>>2;m=((f|0)<0)<<31>>31;if(!((m|0)<(i|0)|(m|0)==(i|0)&f>>>0<j>>>0)){l=(h&16|0)!=0;do if((j|0)==0&(i|0)==0)if(n){k=0;u=23}else k=0;else{k=l&(r|0)==0;if(n){if(k|(c[o>>2]|0)==0){j=-1;i=-1;break a}k=j;u=23;break}else{if(k){j=-1;i=-1;break a}k=j;break}}while(0);if((u|0)==23){c[o>>2]=(c[p>>2]|0)+(k<<2);c[d+16>>2]=q}if(l)c[t>>2]=(c[s>>2]|0)+(k<<2)}else{j=-1;i=-1}}else{j=-1;i=-1}}else{j=-1;i=-1}while(0);u=b;c[u>>2]=0;c[u+4>>2]=0;b=b+8|0;c[b>>2]=j;c[b+4>>2]=i;return}function Uj(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;r=l;l=l+48|0;p=r+20|0;q=r;h=c[a>>2]|0;i=d-h>>1;j=a+4|0;k=c[j>>2]|0;o=c[a+8>>2]|0;g=o;do if(k>>>0<o>>>0){f=d+2|0;if((k|0)==(d|0)){b[d>>1]=b[e>>1]|0;c[j>>2]=f;break}yJ(a,d,k,f);if(d>>>0<=e>>>0)e=(c[j>>2]|0)>>>0>e>>>0?e+2|0:e;b[d>>1]=b[e>>1]|0}else{o=k-h|0;f=(o>>1)+1|0;if((o|0)<-2)uaa();o=g-h|0;TF(q,o>>1>>>0<1073741823?(o>>>0<f>>>0?f:o):2147483647,i,a+8|0);o=q+8|0;f=c[o>>2]|0;g=q+12|0;n=c[g>>2]|0;h=n;j=f;do if((f|0)==(n|0)){m=q+4|0;n=c[m>>2]|0;s=c[q>>2]|0;i=s;k=n;if(n>>>0<=s>>>0){s=h-i|0;s=(s|0)==0?1:s;TF(p,s,s>>>2,c[q+16>>2]|0);dO(p,n,f);c[q>>2]=c[p>>2];c[p>>2]=i;s=p+4|0;c[m>>2]=c[s>>2];c[s>>2]=k;s=p+8|0;f=c[s>>2]|0;c[o>>2]=f;c[s>>2]=j;s=p+12|0;c[g>>2]=c[s>>2];c[s>>2]=h;yS(p);break}h=n+((((k-i>>1)+1|0)/-2|0)<<1)|0;f=j-k|0;g=f>>1;if(g|0)TR(h|0,n|0,f|0)|0;f=h+(g<<1)|0;c[o>>2]=f;c[m>>2]=h}while(0);b[f>>1]=b[e>>1]|0;c[o>>2]=f+2;yx(a,q,d)|0;yS(q)}while(0);l=r;return}function Vj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;do if((b|0)<=6?(i=a+4|0,h=c[c[i>>2]>>2]|0,(((c[h+(b*12|0)+4>>2]|0)-(c[h+(b*12|0)>>2]|0)|0)/40|0)>>>0>d>>>0):0){g=vn(b)|0;h=a+8|0;k=c[c[h>>2]>>2]|0;j=c[k+(b*12|0)>>2]|0;a=j;if((((c[k+(b*12|0)+4>>2]|0)-j|0)/56|0)>>>0>d>>>0)a=((c[a+(d*56|0)+4>>2]|0)-(c[a+(d*56|0)>>2]|0)|0)/40|0;else a=0;if(!((f|0)>8?1:(a+(((c[g+4>>2]|0)-(c[g>>2]|0)|0)/40|0)|0)>>>0<=e>>>0)){k=vn(b)|0;if((((c[k+4>>2]|0)-(c[k>>2]|0)|0)/40|0)>>>0>e>>>0)if((f|0)==1){j=c[(c[c[i>>2]>>2]|0)+(b*12|0)>>2]|0;k=c[j+(d*40|0)>>2]|0;return ((((c[j+(d*40|0)+4>>2]|0)-k|0)/12|0)>>>0>e>>>0?k+(e*12|0)|0:408444)|0}else{a=(c[(c[(vn(b)|0)>>2]|0)+(e*40|0)>>2]|0)+(f*12|0)|0;break}else{j=vn(b)|0;k=c[(c[c[h>>2]>>2]|0)+(b*12|0)>>2]|0;a=k+(d*56|0)|0;if((e-(((c[j+4>>2]|0)-(c[j>>2]|0)|0)/40|0)|0)>>>0>=(((c[k+(d*56|0)+4>>2]|0)-(c[a>>2]|0)|0)/40|0)>>>0){a=408444;break}k=vn(b)|0;k=e-(((c[k+4>>2]|0)-(c[k>>2]|0)|0)/40|0)|0;j=c[a>>2]|0;if((((c[j+(k*40|0)+4>>2]|0)-(c[j+(k*40|0)>>2]|0)|0)/12|0)>>>0<=f>>>0){a=408444;break}k=c[(c[c[h>>2]>>2]|0)+(b*12|0)>>2]|0;a=vn(b)|0;a=(c[(c[k+(d*56|0)>>2]|0)+((e-(((c[a+4>>2]|0)-(c[a>>2]|0)|0)/40|0)|0)*40|0)>>2]|0)+(f*12|0)|0;break}}else a=408444}else a=408444;while(0);return a|0}function Wj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=b+804|0;a:do if((c[e>>2]|0)!=(c[b+808>>2]|0)){f=b+136|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;d=0;while(1){if((d|0)==256)break;kc(b,d,(c[e>>2]|0)+(d*120|0)|0,0);d=d+1|0}c[b+876>>2]=0;e=b+816|0;d=0;while(1){if((d|0)==256)break;kc(b,d,(c[e>>2]|0)+(d*120|0)|0,1);d=d+1|0}h=b+144|0;e=b+828|0;d=0;while(1){if((d|0)==256)break;kc(b,d,(c[e>>2]|0)+(d*120|0)|0,2);d=d+1|0}if(!(a[b+492>>0]|0)){g=f;f=c[g>>2]|0;g=c[g+4>>2]|0;switch(f|0){case 0:{if(!g)break a;break}case -1:{if((g|0)==-1)break a;break}default:{}}e=h;d=c[e>>2]|0;e=c[e+4>>2]|0;if((!((d|0)==0&(e|0)==0)?(j=b+40|0,i=c[j>>2]|0,j=c[j+4>>2]|0,!((i|0)==-1&(j|0)==-1)):0)?(i=UW(i|0,j|0,72e4,0)|0,i=g5(i|0,z|0,d|0,e|0)|0,e=z,d=UW(f|0,g|0,3,0)|0,k=z,j=g5(f|0,g|0,20,0)|0,h=z,!((e>>>0<k>>>0|(e|0)==(k|0)&i>>>0<d>>>0)&(e>>>0>h>>>0|(e|0)==(h|0)&i>>>0>j>>>0))):0){e=0;while(1){if((e|0)==4)break;else d=0;while(1){if(d>>>0>=(RA(b,e,-1)|0)>>>0)break;Ed(b,e,d,Rb(e,22)|0);d=d+1|0}e=e+1|0}if((RA(b,1,-1)|0)==1)Ed(b,1,0,76)}}}while(0);return}function Xj(b,d,e,f,g,h,i,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0;r=k;q=j+4|0;p=j+11|0;a:do if((b|0)==(h|0))if(a[d>>0]|0){a[d>>0]=0;e=c[g>>2]|0;c[g>>2]=e+1;a[e>>0]=46;g=a[p>>0]|0;if(((g<<24>>24<0?c[q>>2]|0:g&255)|0)!=0?(o=c[l>>2]|0,(o-r|0)<160):0){k=c[m>>2]|0;c[l>>2]=o+4;c[o>>2]=k;k=0}else k=0}else k=-1;else{if((b|0)==(i|0)?(i=a[p>>0]|0,(i<<24>>24<0?c[q>>2]|0:i&255)|0):0){if(!(a[d>>0]|0)){k=-1;break}k=c[l>>2]|0;if((k-r|0)>=160){k=0;break}g=c[m>>2]|0;c[l>>2]=k+4;c[k>>2]=g;c[m>>2]=0;k=0;break}o=n+128|0;j=0;while(1){k=n+(j<<2)|0;if((j|0)==32){k=o;break}if((c[k>>2]|0)==(b|0))break;else j=j+1|0}j=k-n|0;k=j>>2;if((j|0)<=124){o=a[401970+k>>0]|0;switch(k|0){case 24:case 25:{k=c[g>>2]|0;if((k|0)!=(f|0)?(a[k+-1>>0]&95)!=(a[e>>0]&127):0){k=-1;break a}c[g>>2]=k+1;a[k>>0]=o;k=0;break a}case 23:case 22:{a[e>>0]=80;break}default:{k=o&95;if((((k|0)==(a[e>>0]|0)?(a[e>>0]=k|128,a[d>>0]|0):0)?(a[d>>0]=0,e=a[p>>0]|0,(e<<24>>24<0?c[q>>2]|0:e&255)|0):0)?(s=c[l>>2]|0,(s-r|0)<160):0){e=c[m>>2]|0;c[l>>2]=s+4;c[s>>2]=e}}}l=c[g>>2]|0;c[g>>2]=l+1;a[l>>0]=o;if((j|0)>84)k=0;else{c[m>>2]=(c[m>>2]|0)+1;k=0}}else k=-1}while(0);return k|0}function Yj(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;w=l;l=l+48|0;g=w+16|0;o=w+4|0;h=w;r=w+34|0;s=w+32|0;t=w+30|0;u=w+28|0;TX(g);TX(o);CK(d);bD(d,h);v=d+788|0;h=c[h>>2]&65535;hD(v,h);i=d+528|0;j=o+8+3|0;k=o+4|0;m=d+824|0;f=0;while(1){n=f&65535;if(n>>>0>=h>>>0)break;GC(d);HB(d,r);HB(d,s);VY(d,(e[s>>1]|0)<<1,0,g);HB(d,t);VY(d,(e[t>>1]|0)<<1,0,o);HB(d,u);p=b[r>>1]|0;q=b[u>>1]|0;do if(!(p<<16>>16==2&q<<16>>16==2))if(p<<16>>16==1&q<<16>>16==4){KK(d);break}else{e1(d,q&65535,0);break}else{x=i;x=z0(c[x>>2]|0,c[x+4>>2]|0,2,0)|0;q=i;c[q>>2]=x;c[q+4>>2]=z}while(0);J3(d);if(qO(d)|0){x=c[v>>2]|0;b[x+(n<<4)>>1]=p;k1(x+(n<<4)+4|0,g)|0;x=a[j>>0]|0;if((x<<24>>24<0?c[k>>2]|0:x&255)|0){HX((c[v>>2]|0)+(n<<4)+4|0,41596)|0;x=a[j>>0]|0;q=x<<24>>24<0;Ex((c[v>>2]|0)+(n<<4)+4|0,q?c[o>>2]|0:o,q?c[k>>2]|0:x&255)|0}c[m>>2]=(c[m>>2]|0)+1}f=f+1<<16>>16}z5(o);z5(g);l=w;return}function Zj(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;i=b+728|0;j=b+548|0;m=b+48|0;if((c[i>>2]&1|0)==0?!(nb[c[(c[b>>2]|0)+88>>2]&255](b)|0):0){if(c[i>>2]&8|0)z$(b);l=m;l=z0(c[j>>2]|0,0,c[l>>2]|0,c[l+4>>2]|0)|0;j=z;m=b+40|0;k=c[m+4>>2]|0;if(j>>>0<k>>>0|((j|0)==(k|0)?l>>>0<(c[m>>2]|0)>>>0:0))d=0;else{z$(b);d=0}}else e=7;do if((e|0)==7){d=c[j>>2]|0;k=b+528|0;l=b+612|0;g=k;e=c[g>>2]|0;f=c[l>>2]|0;g=z0(f|0,0,e|0,c[g+4>>2]|0)|0;h=z;if(h>>>0>0|(h|0)==0&g>>>0>4294967294|(d|0)!=0&(h>>>0>0|(h|0)==0&g>>>0>d>>>0)){d=m;d=z0(c[d>>2]|0,c[d+4>>2]|0,g|0,h|0)|0;ty(b,d,z);d=0;break}g=f+e|0;c[l>>2]=g;h=k;c[h>>2]=0;c[h+4>>2]=0;h=b+536|0;c[h>>2]=d-g;c[h+4>>2]=0;GC(b);jb[c[(c[b>>2]|0)+92>>2]&511](b);J3(b);if(c[i>>2]&8|0){KM(b);d=0;break}d=c[b+508>>2]|0;e=c[b+668>>2]|0;if(!(J1(d,e)|0)?(a[e+(d*24|0)+17>>0]|0)==0:0){j=c[j>>2]|0;f=k;d=c[f>>2]|0;e=c[l>>2]|0;f=z0(e|0,0,d|0,c[f+4>>2]|0)|0;g=z;if(g>>>0>0|(g|0)==0&f>>>0>4294967294|(j|0)!=0&(g>>>0>0|(g|0)==0&f>>>0>j>>>0)){d=m;d=z0(c[d>>2]|0,c[d+4>>2]|0,f|0,g|0)|0;ty(b,d,z);d=0;break}else{c[l>>2]=e+d;d=k;c[d>>2]=0;c[d+4>>2]=0;a[b+496>>0]=0;d=1;break}}else d=0}while(0);return d|0}function _j(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;i=d+44|0;j=c[i>>2]|0;t=d+24|0;r=c[t>>2]|0;l=r;if(j>>>0<r>>>0){c[i>>2]=r;q=l}else q=j;s=h&24;a:do if((s|0)!=0?!((g|0)==1&(s|0)==24):0){n=(h&8|0)!=0;k=d+32|0;o=d+12|0;s=d+20|0;p=d+8|0;m=k+11|0;b:do switch(g|0){case 0:{i=0;j=0;break}case 1:if(n){j=(c[o>>2]|0)-(c[p>>2]|0)|0;i=j;j=((j|0)<0)<<31>>31;break b}else{j=l-(c[s>>2]|0)|0;i=j;j=((j|0)<0)<<31>>31;break b}case 2:{if((a[m>>0]|0)<0)i=c[k>>2]|0;else i=k;j=q-i|0;i=j;j=((j|0)<0)<<31>>31;break}default:{j=-1;i=-1;break a}}while(0);j=z0(i|0,j|0,e|0,f|0)|0;i=z;if((i|0)>=0){if((a[m>>0]|0)<0)k=c[k>>2]|0;f=q-k|0;m=((f|0)<0)<<31>>31;if(!((m|0)<(i|0)|(m|0)==(i|0)&f>>>0<j>>>0)){l=(h&16|0)!=0;do if((j|0)==0&(i|0)==0)if(n){k=0;u=23}else k=0;else{k=l&(r|0)==0;if(n){if(k|(c[o>>2]|0)==0){j=-1;i=-1;break a}k=j;u=23;break}else{if(k){j=-1;i=-1;break a}k=j;break}}while(0);if((u|0)==23){c[o>>2]=(c[p>>2]|0)+k;c[d+16>>2]=q}if(l)c[t>>2]=(c[s>>2]|0)+k}else{j=-1;i=-1}}else{j=-1;i=-1}}else{j=-1;i=-1}while(0);u=b;c[u>>2]=0;c[u+4>>2]=0;b=b+8|0;c[b>>2]=j;c[b+4>>2]=i;return}function $j(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=l;l=l+32|0;d=j+17|0;e=j+16|0;h=j+12|0;f=j;g=b+528|0;k=g;k=z0(c[k>>2]|0,c[k+4>>2]|0,8,0)|0;i=g;c[i>>2]=k;c[i+4>>2]=z;ID(b,h);h=c[h>>2]|0;pY(h,0,30,e);pY(h,0,31,d);h=g;h=z0(c[h>>2]|0,c[h+4>>2]|0,6,0)|0;i=g;c[i>>2]=h;c[i+4>>2]=z;GC(b);i=b+536|0;h=c[i+4>>2]|0;if(h>>>0>0|(h|0)==0&(c[i>>2]|0)>>>0>42){i=(C9((c[b+544>>2]|0)+(c[b+612>>2]|0)+38|0)|0)==1718903138;h=i?4:8;i=i?0:0}else{h=8;i=0}k=g;k=z0(c[k>>2]|0,c[k+4>>2]|0,h|0,i|0)|0;i=g;c[i>>2]=k;c[i+4>>2]=z;J3(b);GC(b);i=g;i=z0(c[i>>2]|0,c[i+4>>2]|0,12,0)|0;k=g;c[k>>2]=i;c[k+4>>2]=z;J3(b);if(qO(b)|0){Xy(f,24560);k=b+16|0;i=b+20|0;Rf(b,f,c[k>>2]|0,c[i>>2]|0,1);z5(f);f=a[e>>0]|0;g=b+916|0;h=b+788|0;a[(bF(g,h)|0)+276>>0]=f;f=a[d>>0]|0;a[(bF(g,h)|0)+277>>0]=f;h=c[k>>2]|0;g=c[i>>2]|0;RB(b,h,g,Rb(h,17)|0,377400,-1,1,1);k=c[k>>2]|0;i=c[i>>2]|0;RB(b,k,i,Rb(k,0)|0,391414,-1,1,1)}l=j;return}function ak(d,f,g,h,i,j){d=d|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;c[g>>2]=d;c[j>>2]=h;o=f;d=c[g>>2]|0;a:while(1){if(d>>>0>=f>>>0){d=0;break}k=b[d>>1]|0;m=k&65535;do if((k&65535)<128){d=c[j>>2]|0;if((i-d|0)<1){d=1;break a}c[j>>2]=d+1;a[d>>0]=k}else{n=(m&63|128)&255;h=m>>>6;if((k&65535)<2048){d=c[j>>2]|0;if((i-d|0)<2){d=1;break a}c[j>>2]=d+1;a[d>>0]=h|192;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=n;break}l=(m>>>12|224)&255;h=(h&63|128)&255;if((k&65535)<55296){d=c[j>>2]|0;if((i-d|0)<3){d=1;break a}c[j>>2]=d+1;a[d>>0]=l;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=h;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=n;break}if((k&65535)>=56320){if((k&65535)<57344){d=2;break a}d=c[j>>2]|0;if((i-d|0)<3){d=1;break a}c[j>>2]=d+1;a[d>>0]=l;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=h;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=n;break}if((o-d|0)<4){d=1;break a}d=d+2|0;h=e[d>>1]|0;if((h&64512|0)!=56320){d=2;break a}if((i-(c[j>>2]|0)|0)<4){d=1;break a}k=m&960;if(((k<<10)+65536|0)>>>0>1114111){d=2;break a}c[g>>2]=d;l=(k>>>6)+1|0;n=c[j>>2]|0;c[j>>2]=n+1;a[n>>0]=l>>>2|240;n=c[j>>2]|0;c[j>>2]=n+1;a[n>>0]=m>>>2&15|l<<4&48|128;n=c[j>>2]|0;c[j>>2]=n+1;a[n>>0]=m<<4&48|h>>>6&15|128;n=c[j>>2]|0;c[j>>2]=n+1;a[n>>0]=h&63|128}while(0);d=(c[g>>2]|0)+2|0;c[g>>2]=d}return d|0}function bk(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+160|0;j=m+136|0;k=m;a:do if(f<<24>>24==2){g=b+8+3|0;if((a[g>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0;g=0}else{y7(b,0);a[g>>0]=0;g=0}while(1){if((g&255)>=32)break a;h=PZ(1,0,g&255|0)|0;f=z;if(f>>>0>e>>>0|(f|0)==(e|0)&h>>>0>d>>>0)break a;Yv(b,1,(h&d|0)!=0|(f&e|0)!=0?49:48)|0;g=g+1<<24>>24}}else{h=k+56|0;i=k+4|0;c[k>>2]=1244;c[h>>2]=1264;DO(k+56|0,i);c[k+128>>2]=0;c[k+132>>2]=-1;c[k>>2]=42060;c[h>>2]=42080;aV(i);c[i>>2]=42096;h=k+36|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;g=0;while(1){if((g|0)==3)break;c[h+(g<<2)>>2]=0;g=g+1|0}c[k+48>>2]=0;c[k+52>>2]=16;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;g=0;while(1){if((g|0)==3)break;c[j+(g<<2)>>2]=0;g=g+1|0}lq(i,j);O0(j);h=k+(c[(c[k>>2]|0)+-12>>2]|0)|0;switch(f<<24>>24){case 8:{g=64;break}case 10:{g=2;break}default:g=f<<24>>24==16?8:0}f=h+4|0;c[f>>2]=c[f>>2]&-75|g;Hq(k,d,e)|0;Hk(j,i);rQ(b,j)|0;O0(j);YX(k)}while(0);tP(b)|0;l=m;return b|0}function ck(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+16|0;i=k;m=b+528|0;e=b+536|0;do if(!((c[m>>2]|0)==(c[e>>2]|0)?(c[m+4>>2]|0)==(c[e+4>>2]|0):0)){Bx(b);n3(b,d);d=c[d>>2]|0;e=c[b+808>>2]|0;if(d>>>0<(c[b+812>>2]|0)-e>>2>>>0?(j=e+(d<<2)|0,f=c[j>>2]|0,f|0):0){d=c[f>>2]|0;if((d|0)!=0?(g=c[d+8>>2]|0,(g|0)!=0):0)d=a[g>>0]|0;else d=0;a[i>>0]=d;AT(b,i);d=c[c[j>>2]>>2]|0;if((d|0)!=0?(h=c[d+8>>2]|0,(h|0)!=0):0){d=a[h+4>>0]|0;f=a[h+5>>0]|0}else{d=23;f=23}g=a[i>>0]|0;e=(d&255)+1&255;if(!(g<<24>>24))d=b+648|0;else{d=b+648|0;d4(c[d>>2]|0,e);d4(c[d>>2]|0,(f&255)+1&255)}A6(c[d>>2]|0);d4(c[d>>2]|0,e);d=c[c[j>>2]>>2]|0;f=g<<24>>24!=0;if(N$(d)|0){if(!d)e=0;else e=c[d+8>>2]|0;Su(b,e,f,c[d>>2]|0);d=c[c[j>>2]>>2]|0}if(E$(d)|0){if(!d)e=0;else e=c[d+8>>2]|0;Su(b,e,f,c[d+4>>2]|0)}wK(b);break}m=c[b+648>>2]|0;G4(m,Z9(c[m+4>>2]|0)|0);wK(b)}while(0);l=k;return}function dk(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+16|0;q=r;k=e;while(1){if((k|0)==(f|0)){k=f;break}if(!(a[k>>0]|0))break;k=k+1|0}c[j>>2]=h;c[g>>2]=e;o=i;p=b+8|0;b=h;while(1){if((b|0)==(i|0)|(e|0)==(f|0)){b=32;break}m=d;h=c[m+4>>2]|0;n=q;c[n>>2]=c[m>>2];c[n+4>>2]=h;n=k;h=a0(c[p>>2]|0)|0;m=Pn(b,g,n-e|0,o-b>>2,d)|0;if(h|0)a0(h)|0;if((m|0)==-1){k=b;b=10;break}b=(c[j>>2]|0)+(m<<2)|0;c[j>>2]=b;e=c[g>>2]|0;if((b|0)==(i|0)){b=29;break}if((k|0)==(f|0))k=f;else{k=a0(c[p>>2]|0)|0;e=Yn(b,e,1,d)|0;if(k|0)a0(k)|0;if(e|0){e=2;b=28;break}c[j>>2]=(c[j>>2]|0)+4;e=(c[g>>2]|0)+1|0;c[g>>2]=e;k=e;while(1){if((k|0)==(f|0)){k=f;break}if(!(a[k>>0]|0))break;k=k+1|0}b=c[j>>2]|0}}do if((b|0)==10){a:while(1){c[j>>2]=k;if((e|0)==(c[g>>2]|0)){b=18;break}b=a0(c[p>>2]|0)|0;k=Yn(k,e,n-e|0,q)|0;if(b|0)a0(b)|0;switch(k|0){case -1:{b=15;break a}case -2:{b=16;break a}case 0:{k=1;break}default:{}}e=e+k|0;k=(c[j>>2]|0)+4|0;b=10}if((b|0)==15){c[g>>2]=e;e=2;b=28;break}else if((b|0)==16){c[g>>2]=e;e=1;b=28;break}else if((b|0)==18){c[g>>2]=e;e=(e|0)!=(f|0)&1;b=28;break}}else if((b|0)==29)b=32;while(0);if((b|0)!=28)if((b|0)==32)e=(e|0)!=(f|0)&1;l=r;return e|0}
function yf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=l;l=l+48|0;d=y+36|0;m=y+32|0;s=y+44|0;o=y+43|0;r=y+42|0;t=y+41|0;u=y+40|0;k=y+24|0;n=y+16|0;w=y+8|0;x=y;bB(b,y+45|0);jB(b,d);d=c[d>>2]|0;i=b+884|0;pY(d,0,0,i);pY(d,0,2,s);pY(d,0,8,o);pY(d,0,9,r);pY(d,0,10,t);pY(d,0,11,u);ID(b,m);d=b+888|0;f=d;e=c[f>>2]|0;f=c[f+4>>2]|0;h=(e|0)!=-1|(f|0)!=-1?d:b+872|0;g=c[h>>2]|0;h=c[h+4>>2]|0;v=k;c[v>>2]=g;c[v+4>>2]=h;if(a[i>>0]|0){ID(b,n);g=z0(g|0,h|0,c[n>>2]|0,0)|0;h=z;f=k;c[f>>2]=g;c[f+4>>2]=h;f=d;e=c[f>>2]|0;f=c[f+4>>2]|0}v=b+928|0;if(!((e|0)==-1&(f|0)==-1?!(a[i>>0]|0):0))j=5;do if((j|0)==5){d=c[v>>2]|0;e=d+104|0;f=c[e>>2]|0;if((f|0)==(c[d+108>>2]|0)){Px(d+100|0,k);break}else{q=f;c[q>>2]=g;c[q+4>>2]=h;c[e>>2]=f+8;break}}while(0);e=c[v>>2]|0;f=e+112|0;d=c[f>>2]|0;g=e+116|0;h=c[g>>2]|0;if((d|0)==(h|0))d=1;else d=(c[d+((h-d>>3)+-1<<3)>>2]|0)+1|0;c[n>>2]=d;q=c[m>>2]|0;c[n+4>>2]=q;if((h|0)==(c[e+120>>2]|0))Px(f,n);else{m=n;n=c[m+4>>2]|0;p=h;c[p>>2]=c[m>>2];c[p+4>>2]=n;c[g>>2]=(c[g>>2]|0)+8}n=qO(b)|0;p=(a[o>>0]|0)==0;if(n&p)Zl((c[v>>2]|0)+24|0,q,c[b+896>>2]|0,0,1);n=(a[r>>0]|0)==0;if(n){r=c[v>>2]|0;o=r+124|0;r=((c[r+128>>2]|0)-(c[o>>2]|0)>>3)+q|0;m=w;c[m>>2]=c[b+900>>2];c[m+4>>2]=0;KH(o,r,w)}o=b+528|0;if(a[s>>0]|0){r=o;r=z0(c[r>>2]|0,c[r+4>>2]|0,4,0)|0;s=o;c[s>>2]=r;c[s+4>>2]=z}m=b+880|0;k=(a[t>>0]|0)==0;i=(a[u>>0]|0)==0;h=0;while(1){if((h|0)==(q|0))break;GC(b);if(!p?(ID(b,w),qO(b)|0):0)Zl((c[v>>2]|0)+24|0,1,c[w>>2]|0,0,1);if(!n){ID(b,w);j=c[w>>2]|0;d=c[v>>2]|0;e=d+152|0;f=e;f=z0(c[f>>2]|0,c[f+4>>2]|0,j|0,0)|0;c[e>>2]=f;c[e+4>>2]=z;e=x;c[e>>2]=j;c[e+4>>2]=0;e=d+140|0;f=c[e>>2]|0;if(f>>>0<(c[d+144>>2]|0)>>>0){u=f;c[u>>2]=j;c[u+4>>2]=0;c[e>>2]=f+8}else{Px(d+136|0,x);d=c[v>>2]|0}e=d+124|0;f=d+128|0;u=c[f>>2]|0;g=u;if(u-(c[e>>2]|0)>>3>>>0<(c[m>>2]|0)>>>0){u=x;c[u>>2]=j;c[u+4>>2]=0;if(g>>>0<(c[d+132>>2]|0)>>>0){u=g;c[u>>2]=j;c[u+4>>2]=0;c[f>>2]=g+8}else Px(e,x)}}if(!k){t=o;t=z0(c[t>>2]|0,c[t+4>>2]|0,4,0)|0;u=o;c[u>>2]=t;c[u+4>>2]=z}if(!i){t=o;t=z0(c[t>>2]|0,c[t+4>>2]|0,4,0)|0;u=o;c[u>>2]=t;c[u+4>>2]=z}J3(b);h=h+1|0}l=y;return}function zf(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=c[e>>2]|0;if((g|0)!=0?(i=c[g>>2]|0,(i|0)!=0):0)if(!b){k=h;g=f;l=25}else{c[g>>2]=0;j=b;b=f;k=h;l=43}else l=5;a:do if((l|0)==5){g=(b|0)!=0;if(c[c[12815]>>2]|0)if(g){i=b;g=f;l=15;break}else{g=f;l=14;break}if(!g){f=FD(h)|0;l=60;break}b:do if(f){j=b;g=f;while(1){i=a[h>>0]|0;if(!(i<<24>>24))break;h=h+1|0;c[j>>2]=i<<24>>24&57343;g=g+-1|0;if(!g)break b;else j=j+4|0}c[j>>2]=0;c[e>>2]=0;f=f-g|0;l=60;break a}while(0);c[e>>2]=h;l=60}while(0);c:while(1){d:do if((l|0)==14){while(1){i=a[h>>0]|0;if(((i&255)+-1|0)>>>0<127?(h&3|0)==0:0){l=c[h>>2]|0;i=l&255;if(!((l+-16843009|l)&-2139062144)){do{h=h+4|0;g=g+-4|0;i=c[h>>2]|0}while(!((i+-16843009|i)&-2139062144|0));i=i&255}}j=i&255;if((j+-1|0)>>>0>=127)break;h=h+1|0;g=g+-1|0}j=j+-194|0;if(j>>>0>50){j=b;l=54}else{i=c[50744+(j<<2)>>2]|0;k=h+1|0;l=25;continue c}}else if((l|0)==15){e:do if(g){while(1){k=a[h>>0]|0;do if(((k&255)+-1|0)>>>0<127?g>>>0>4&(h&3|0)==0:0){while(1){k=c[h>>2]|0;if((k+-16843009|k)&-2139062144|0){l=38;break}c[i>>2]=k&255;c[i+4>>2]=d[h+1>>0];c[i+8>>2]=d[h+2>>0];k=h+4|0;j=i+16|0;c[i+12>>2]=d[h+3>>0];g=g+-4|0;if(g>>>0>4){i=j;h=k}else{l=37;break}}if((l|0)==37){h=k;k=a[k>>0]|0;break}else if((l|0)==38){j=i;k=k&255;break}}else j=i;while(0);i=k&255;if((i+-1|0)>>>0>=127)break;h=h+1|0;c[j>>2]=i;g=g+-1|0;if(!g)break e;else i=j+4|0}i=i+-194|0;if(i>>>0>50){i=k;l=54;break d}i=c[50744+(i<<2)>>2]|0;b=g;k=h+1|0;l=43;continue c}while(0);c[e>>2]=h;l=60;continue c}else if((l|0)==25){l=(d[k>>0]|0)>>>3;if((l+-16|l+(i>>26))>>>0>7){j=b;h=k;l=52}else{h=k+1|0;if(i&33554432){if((a[h>>0]&-64)<<24>>24!=-128){j=b;h=k;l=52;break}h=k+2|0;if(i&524288){if((a[h>>0]&-64)<<24>>24!=-128){j=b;h=k;l=52;break}h=k+3|0}}g=g+-1|0;l=14;continue c}}else if((l|0)==43){l=0;g=d[k>>0]|0;h=g>>>3;if((h+-16|h+(i>>26))>>>0>7){h=k;g=b;l=52}else{h=k+1|0;g=g+-128|i<<6;do if((g|0)<0){i=(d[h>>0]|0)+-128|0;if(i>>>0>63){h=k+-1|0;f=j;break d}h=k+2|0;g=i|g<<6;if((g|0)<0){i=(d[h>>0]|0)+-128|0;if(i>>>0>63){h=k+-1|0;f=j;break d}else{h=k+3|0;g=i|g<<6;break}}}while(0);c[j>>2]=g;i=j+4|0;g=b+-1|0;l=15;continue c}}else if((l|0)==60)return f|0;while(0);if((l|0)==52){l=0;k=h+-1|0;if(!i){h=k;i=a[k>>0]|0;l=54}else{h=k;f=j}}if((l|0)==54)if(!(i<<24>>24)){if(j|0){c[j>>2]=0;c[e>>2]=0}f=f-g|0;l=60;continue}else f=j;c[12784]=84;if(!f){f=-1;l=60;continue}c[e>>2]=h;f=-1;l=60}return 0}function Af(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;i=c[d>>2]|0;do if(i){j=c[i+12>>2]|0;if((j|0)==(c[i+16>>2]|0))i=nb[c[(c[i>>2]|0)+36>>2]&255](i)|0;else i=e9(a[j>>0]|0)|0;if(d8(i,-1)|0){c[d>>2]=0;j=1;break}else{j=(c[d>>2]|0)==0;break}}else j=1;while(0);if(e){i=c[e+12>>2]|0;if((i|0)==(c[e+16>>2]|0))i=nb[c[(c[e>>2]|0)+36>>2]&255](e)|0;else i=e9(a[i>>0]|0)|0;if(!(d8(i,-1)|0))if(j){l=e;s=16}else s=15;else s=13}else s=13;if((s|0)==13)if(j)s=15;else{l=0;s=16}a:do if((s|0)==15){c[f>>2]=c[f>>2]|6;i=0}else if((s|0)==16){i=c[d>>2]|0;j=c[i+12>>2]|0;if((j|0)==(c[i+16>>2]|0))i=nb[c[(c[i>>2]|0)+36>>2]&255](i)|0;else i=e9(a[j>>0]|0)|0;j=i&255;if(j<<24>>24>-1?(r=g+8|0,b[(c[r>>2]|0)+(i<<24>>24<<1)>>1]&2048):0){i=(gb[c[(c[g>>2]|0)+36>>2]&31](g,j,0)|0)<<24>>24;j=c[d>>2]|0;e=j+12|0;k=c[e>>2]|0;if((k|0)==(c[j+16>>2]|0)){nb[c[(c[j>>2]|0)+40>>2]&255](j)|0;n=h;m=l;k=l}else{c[e>>2]=k+1;n=h;m=l;k=l}while(1){i=i+-48|0;q=n+-1|0;j=c[d>>2]|0;do if(j){e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0))j=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else j=e9(a[e>>0]|0)|0;if(d8(j,-1)|0){c[d>>2]=0;h=1;break}else{h=(c[d>>2]|0)==0;break}}else h=1;while(0);if(!k){p=m;e=1;o=0}else{j=c[k+12>>2]|0;if((j|0)==(c[k+16>>2]|0))j=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else j=e9(a[j>>0]|0)|0;o=d8(j,-1)|0;p=o?0:m;e=o|(m|0)==0;o=o?0:m}k=c[d>>2]|0;j=k+12|0;l=k+16|0;if(!((n|0)>1&(h^e)))break;j=c[j>>2]|0;if((j|0)==(c[l>>2]|0))j=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else j=e9(a[j>>0]|0)|0;e=j&255;if(e<<24>>24<=-1)break a;if(!(b[(c[r>>2]|0)+(j<<24>>24<<1)>>1]&2048))break a;i=((gb[c[(c[g>>2]|0)+36>>2]&31](g,e,0)|0)<<24>>24)+(i*10|0)|0;j=c[d>>2]|0;e=j+12|0;k=c[e>>2]|0;if((k|0)==(c[j+16>>2]|0)){nb[c[(c[j>>2]|0)+40>>2]&255](j)|0;n=q;m=p;k=o;continue}else{c[e>>2]=k+1;n=q;m=p;k=o;continue}}do if(k){j=c[j>>2]|0;if((j|0)==(c[l>>2]|0))j=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else j=e9(a[j>>0]|0)|0;if(d8(j,-1)|0){c[d>>2]=0;e=1;break}else{e=(c[d>>2]|0)==0;break}}else e=1;while(0);if(p){j=c[p+12>>2]|0;if((j|0)==(c[p+16>>2]|0))j=nb[c[(c[p>>2]|0)+36>>2]&255](p)|0;else j=e9(a[j>>0]|0)|0;if(!(d8(j,-1)|0)){if(e)break}else s=58}else s=58;if((s|0)==58?!e:0)break;c[f>>2]=c[f>>2]|2;break}c[f>>2]=c[f>>2]|4;i=0}while(0);return i|0}function Bf(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;w=l;l=l+16|0;t=w;v=d+764|0;s=c[v>>2]|0;u=d+782|0;s=$C((HD(s+68|0,s)|0)+16|0,u)|0;q=s+52|0;p=s+56|0;o=0;while(1){d=c[q>>2]|0;if(o>>>0>=(c[p>>2]|0)-d>>1>>>0)break;n=e[d+(o<<1)>>1]|0;k=0;while(1){d=c[v>>2]|0;h=c[d+80>>2]|0;g=c[h+(n<<2)>>2]|0;m=g+8|0;i=c[m>>2]|0;x=c[g+4>>2]|0;f=x;j=i;if(k>>>0>=i-x>>1>>>0)break;h=f+(k<<1)|0;a:do if((b[h>>1]|0)==(b[u>>1]|0)){f=h+2|0;d=i-f|0;g=d>>1;if(!g)d=j;else{TR(h|0,f|0,d|0)|0;d=c[m>>2]|0}f=h+(g<<1)|0;while(1){if((d|0)==(f|0))break a;x=d+-2|0;c[m>>2]=x;d=x}}while(0);k=k+1|0}if((f|0)==(j|0)){k=c[g+52>>2]|0;f=c[g+60>>2]|0;c[t>>2]=f;do if((k|0)!=7&(f|0)!=-1){g=c[d+164>>2]|0;i=g+(k*12|0)+4|0;j=c[i>>2]|0;if((j|0)==(c[g+(k*12|0)+8>>2]|0)){Yy(g+(k*12|0)|0,t);h=c[v>>2]|0;d=h;h=c[h+80>>2]|0;break}else{c[j>>2]=f;c[i>>2]=j+4;break}}while(0);f=d+92|0;g=c[f>>2]|0;d=c[h+(n<<2)>>2]|0;switch(g|0){case 0:case -1:{if(d|0)r=22;break}default:if(!(a[d+68>>0]|0)){c[f>>2]=g+-1;r=22}else r=22}if((r|0)==22){r=0;Rx(d);laa(d)}x=ZW(200)|0;Ss(x);c[(c[(c[v>>2]|0)+80>>2]|0)+(n<<2)>>2]=x}o=o+1|0}d=c[v>>2]|0;d=iL(d+176|0,b[($C((HD(d+68|0,d)|0)+16|0,u)|0)+74>>1]|0)|0;f=c[v>>2]|0;if((d|0)!=(f+180|0)?(r=d+16|0,x=(b[r>>1]|0)+-1<<16>>16,b[r>>1]=x,x<<16>>16==0):0)oB(f+176|0,d);h=s+64|0;i=c[h>>2]|0;c[t>>2]=i;if((i|0)!=-1){d=c[(c[v>>2]|0)+164>>2]|0;f=d+76|0;g=c[f>>2]|0;if((g|0)==(c[d+80>>2]|0))Yy(d+72|0,t);else{c[g>>2]=i;c[f>>2]=g+4}c[h>>2]=-1}d=b[s+72>>1]|0;if(d<<16>>16){k=d&65535;j=0;while(1){f=c[(c[(c[v>>2]|0)+80>>2]|0)+(k<<2)>>2]|0;m=f+8|0;d=c[m>>2]|0;g=c[f+4>>2]|0;if(j>>>0>=d-g>>1>>>0)break;h=g+(j<<1)|0;b:do if((b[h>>1]|0)==(b[u>>1]|0)){f=h+2|0;g=d-f|0;i=g>>1;if(i){TR(h|0,f|0,g|0)|0;d=c[m>>2]|0}f=h+(i<<1)|0;while(1){if((d|0)==(f|0))break b;x=d+-2|0;c[m>>2]=x;d=x}}while(0);j=j+1|0}d=c[(c[f+16>>2]|0)+8>>2]|0;if(d|0)PB(d,b[u>>1]|0)}x=c[v>>2]|0;x=(HD(x+68|0,x)|0)+16|0;mC(x,b[u>>1]|0);l=w;return}function Cf(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+16|0;k=v+12|0;n=v;o=b+528|0;p=b+536|0;q=b+544|0;r=b+612|0;s=b+792|0;t=b+800+3|0;m=b+796|0;while(1){e=o;d=c[e>>2]|0;e=c[e+4>>2]|0;j=p;i=c[j>>2]|0;j=c[j+4>>2]|0;if(!(e>>>0<j>>>0|(e|0)==(j|0)&d>>>0<i>>>0))break;d=z0(d|0,e|0,4,0)|0;f=z;a:while(1){h=z0(d|0,f|0,4,0)|0;e=z;h=e>>>0>j>>>0|(e|0)==(j|0)&h>>>0>i>>>0;if(h)break;e=C9((c[q>>2]|0)+(c[r>>2]|0)+d|0)|0;b:do if((e|0)<1191201283){if((e|0)<496366178)switch(e|0){case 176167201:break a;default:break b}if((e|0)<1101174087)switch(e|0){case 496366178:break a;default:break b}else switch(e|0){case 1101174087:break a;default:break b}}else{if((e|0)<1515870810)switch(e|0){case 1191201283:break a;default:break b}if((e|0)<1700671838)switch(e|0){case 1515870810:break a;default:break b}else switch(e|0){case 1700671838:break a;default:break b}}while(0);h=z0(d|0,f|0,1,0)|0;d=h;f=z}i=h?i:d;e=h?j:f;GC(b);ID(b,k);d=c[k>>2]|0;c:do if((d|0)<1191201283){if((d|0)<496366178){switch(d|0){case 176167201:break;default:{u=14;break c}}j=o;j=D_(i|0,e|0,c[j>>2]|0,c[j+4>>2]|0)|0;oL(b,j,z);break}if((d|0)<1101174087){switch(d|0){case 496366178:break;default:{u=14;break c}}j=o;j=D_(i|0,e|0,c[j>>2]|0,c[j+4>>2]|0)|0;iK(b,j,z);break}else{switch(d|0){case 1101174087:break;default:{u=14;break c}}j=o;j=D_(i|0,e|0,c[j>>2]|0,c[j+4>>2]|0)|0;Dp(b,j,z);break}}else{if((d|0)<1515870810){switch(d|0){case 1191201283:break;default:{u=14;break c}}j=o;j=D_(i|0,e|0,c[j>>2]|0,c[j+4>>2]|0)|0;Dv(b,j,z);break}if((d|0)<1700671838){switch(d|0){case 1515870810:break;default:{u=14;break c}}j=o;j=D_(i|0,e|0,c[j>>2]|0,c[j+4>>2]|0)|0;VF(b,j,z);break}else{switch(d|0){case 1700671838:break;default:{u=14;break c}}j=o;j=D_(i|0,e|0,c[j>>2]|0,c[j+4>>2]|0)|0;pL(b,j,z);break}}while(0);if((u|0)==14){u=0;d=a[t>>0]|0;if(d<<24>>24<0)d=c[m>>2]|0;else d=d&255;if(!d){VU(n,384102);vF(s,n)|0;z5(n)}j=o;j=D_(i|0,e|0,c[j>>2]|0,c[j+4>>2]|0)|0;e1(b,j,z)}J3(b)}if((((qO(b)|0?(RA(b,2,-1)|0)==0:0)?(t=b+312|0,r=c[t+4>>2]|0,u=b+760|0,s=c[u+4>>2]|0,!(r>>>0<s>>>0|((r|0)==(s|0)?(c[t>>2]|0)>>>0<(c[u>>2]|0)>>>0:0))):0)?(W5(b),t6(b),(a[b+492>>0]|0)==0):0)?+g[(c[b+24>>2]|0)+136>>2]<1.0:0)V5(b);l=v;return}function Df(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=l;l=l+112|0;k=y;m=(f-e|0)/12|0;if(m>>>0>100){k=Ub(m)|0;if(!k)uaa();else{j=k;w=k}}else{j=k;w=0}o=e;p=j;k=0;while(1){if((o|0)==(f|0))break;n=a[o+11>>0]|0;if(n<<24>>24<0)n=c[o+4>>2]|0;else n=n&255;if(!n){a[p>>0]=2;m=m+-1|0;k=k+1|0}else a[p>>0]=1;o=o+12|0;p=p+1|0}v=0;s=k;o=d;a:while(1){k=c[b>>2]|0;do if(k){n=c[k+12>>2]|0;if((n|0)==(c[k+16>>2]|0))k=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else k=e9(a[n>>0]|0)|0;if(d8(k,-1)|0){c[b>>2]=0;d=1;break}else{d=(c[b>>2]|0)==0;break}}else d=1;while(0);if(!o){q=0;u=0;k=1}else{k=c[o+12>>2]|0;if((k|0)==(c[o+16>>2]|0))k=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else k=e9(a[k>>0]|0)|0;k=d8(k,-1)|0;q=k?0:o;u=k?0:o}o=c[b>>2]|0;p=o+16|0;n=o+12|0;if(!((m|0)!=0&(d^k)))break;k=c[n>>2]|0;if((k|0)==(c[p>>2]|0))k=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else k=e9(a[k>>0]|0)|0;k=k&255;if(!i)k=tb[c[(c[g>>2]|0)+12>>2]&31](g,k)|0;t=v+1|0;q=e;d=0;r=j;while(1){if((q|0)==(f|0))break;do if((a[r>>0]|0)==1){o=q+11|0;if((a[o>>0]|0)<0)n=c[q>>2]|0;else n=q;n=a[n+v>>0]|0;if(!i)n=tb[c[(c[g>>2]|0)+12>>2]&31](g,n)|0;p=m+-1|0;if(k<<24>>24!=n<<24>>24){a[r>>0]=0;n=d;o=s;m=p;break}n=a[o>>0]|0;if(n<<24>>24<0)n=c[q+4>>2]|0;else n=n&255;if((n|0)==(t|0)){a[r>>0]=2;n=1;o=s+1|0;m=p}else{n=1;o=s}}else{n=d;o=s}while(0);q=q+12|0;d=n;r=r+1|0;s=o}if(!d){v=t;o=u;continue}k=c[b>>2]|0;n=k+12|0;o=c[n>>2]|0;if((o|0)==(c[k+16>>2]|0))nb[c[(c[k>>2]|0)+40>>2]&255](k)|0;else c[n>>2]=o+1;if((s+m|0)>>>0>1){o=e;p=j;k=s}else{v=t;o=u;continue}while(1){if((o|0)==(f|0)){v=t;s=k;o=u;continue a}if((a[p>>0]|0)==2){n=a[o+11>>0]|0;if(n<<24>>24<0)n=c[o+4>>2]|0;else n=n&255;if((n|0)!=(t|0)){a[p>>0]=0;k=k+-1|0}}o=o+12|0;p=p+1|0}}do if(o){k=c[n>>2]|0;if((k|0)==(c[p>>2]|0))k=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else k=e9(a[k>>0]|0)|0;if(d8(k,-1)|0){c[b>>2]=0;m=1;break}else{m=(c[b>>2]|0)==0;break}}else m=1;while(0);if(q){k=c[q+12>>2]|0;if((k|0)==(c[q+16>>2]|0))k=nb[c[(c[q>>2]|0)+36>>2]&255](q)|0;else k=e9(a[k>>0]|0)|0;if(!(d8(k,-1)|0)){if(!m)x=75}else x=39}else x=39;if((x|0)==39)if(m)x=75;if((x|0)==75)c[h>>2]=c[h>>2]|2;while(1){if((e|0)==(f|0)){x=79;break}if((a[j>>0]|0)==2)break;e=e+12|0;j=j+1|0}if((x|0)==79){c[h>>2]=c[h>>2]|4;e=f}pe(w);l=y;return e|0}function Ef(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0.0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=l;l=l+48|0;x=C;d=C+32|0;h=C+40|0;g=C+39|0;f=C+38|0;y=C+37|0;z=C+36|0;A=C+20|0;B=C+8|0;w=x;c[w>>2]=-1;c[w+4>>2]=-1;c[d>>2]=1;a[g>>0]=0;w=b+536|0;a:do if(!((c[w>>2]|0)==0&(c[w+4>>2]|0)==0)){Bx(b);xR(b,5,h);AT(b,f);w=b+648|0;d4(c[w>>2]|0,2);if(!(a[f>>0]|0)){d=1;f=0}else{rR(b,21,d);xR(b,3,g);d=c[d>>2]|0;f=a[g>>0]|0}o=b+760|0;p=b+772|0;q=B+11|0;r=B+11|0;s=B+8|0;t=B+4|0;u=B+8|0;v=B+4|0;m=a[h>>0]|0;n=(d|0)==1;j=+(d>>>0);k=(f&255)<8;i=((f&255)<<3)+8&255;h=0;while(1){if((h&255)>=(m&255))break a;GC(b);AT(b,y);AT(b,z);d4(c[w>>2]|0,5);f=a[y>>0]|0;if(!(f<<24>>24)){A6(c[w>>2]|0);d4(c[w>>2]|0,13);d4(c[w>>2]|0,3)}else{AT(b,A);if(k)cO(b,i,x);else{d4(c[w>>2]|0,8);d4(c[w>>2]|0,64)}d=c[w>>2]|0;if(!(a[A>>0]|0))d4(d,7);else{d4(d,3);d4(c[w>>2]|0,4)}A6(c[w>>2]|0)}if(a[z>>0]|0)d4(c[w>>2]|0,64);J3(b);if(qO(b)|0){Xy(A,f<<24>>24?39568:39604);f=c[(c[(c[o>>2]|0)+80>>2]|0)+(e[p>>1]<<2)>>2]|0;c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;g=j9(384485)|0;if(g>>>0>4294967279){d=19;break}if(g>>>0<11){a[q>>0]=g;d=B}else{D=g+16&-16;d=ZW(D)|0;c[B>>2]=d;c[u>>2]=D|-2147483648;c[v>>2]=g}i1(d,384485,g)|0;J7(d+g|0,0);vF(VC(f+28|0,B)|0,A)|0;a1(B);z5(A);f=x;d=c[f>>2]|0;f=c[f+4>>2]|0;if(!((d|0)==-1&(f|0)==-1)){if(n)oT(A,d,f,10);else ST(A,(+(d>>>0)+4294967296.0*+(f>>>0))/j,3);f=c[(c[(c[o>>2]|0)+80>>2]|0)+(e[p>>1]<<2)>>2]|0;c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;g=j9(384494)|0;if(g>>>0>4294967279){d=28;break}if(g>>>0<11){a[r>>0]=g;d=B}else{D=g+16&-16;d=ZW(D)|0;c[B>>2]=d;c[s>>2]=D|-2147483648;c[t>>2]=g}i1(d,384494,g)|0;J7(d+g|0,0);vF(VC(f+28|0,B)|0,A)|0;a1(B);z5(A)}}h=h+1<<24>>24}if((d|0)==19)uaa();else if((d|0)==28)uaa()}while(0);l=C;return}function Ff(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;i=l;l=l+32|0;g=i;h=oh(a,b,d,e)|0;k=f;j=e;if(M$(c[k>>2]|0,c[k+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0){c[g>>2]=c[e>>2];c[g+4>>2]=c[e+4>>2];c[g+8>>2]=c[e+8>>2];c[g+12>>2]=c[e+12>>2];c[g+16>>2]=c[e+16>>2];c[g+20>>2]=c[e+20>>2];c[g+24>>2]=c[e+24>>2];c[g+28>>2]=c[e+28>>2];c[e>>2]=c[f>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];c[f+24>>2]=c[g+24>>2];c[f+28>>2]=c[g+28>>2];f=h+1|0;j=e;k=d;if(M$(c[j>>2]|0,c[j+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0){c[g>>2]=c[d>>2];c[g+4>>2]=c[d+4>>2];c[g+8>>2]=c[d+8>>2];c[g+12>>2]=c[d+12>>2];c[g+16>>2]=c[d+16>>2];c[g+20>>2]=c[d+20>>2];c[g+24>>2]=c[d+24>>2];c[g+28>>2]=c[d+28>>2];c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];c[d+28>>2]=c[e+28>>2];c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];c[e+16>>2]=c[g+16>>2];c[e+20>>2]=c[g+20>>2];c[e+24>>2]=c[g+24>>2];c[e+28>>2]=c[g+28>>2];f=h+2|0;j=d;k=b;if(M$(c[j>>2]|0,c[j+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0){c[g>>2]=c[b>>2];c[g+4>>2]=c[b+4>>2];c[g+8>>2]=c[b+8>>2];c[g+12>>2]=c[b+12>>2];c[g+16>>2]=c[b+16>>2];c[g+20>>2]=c[b+20>>2];c[g+24>>2]=c[b+24>>2];c[g+28>>2]=c[b+28>>2];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];c[d>>2]=c[g>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];c[d+12>>2]=c[g+12>>2];c[d+16>>2]=c[g+16>>2];c[d+20>>2]=c[g+20>>2];c[d+24>>2]=c[g+24>>2];c[d+28>>2]=c[g+28>>2];j=b;k=a;if(M$(c[j>>2]|0,c[j+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0){c[g>>2]=c[a>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];c[g+20>>2]=c[a+20>>2];c[g+24>>2]=c[a+24>>2];c[g+28>>2]=c[a+28>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];c[b>>2]=c[g>>2];c[b+4>>2]=c[g+4>>2];c[b+8>>2]=c[g+8>>2];c[b+12>>2]=c[g+12>>2];c[b+16>>2]=c[g+16>>2];c[b+20>>2]=c[g+20>>2];c[b+24>>2]=c[g+24>>2];c[b+28>>2]=c[g+28>>2];f=h+4|0}else f=h+3|0}}}else f=h;l=i;return f|0}function Gf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;B=b+312|0;e=B;e=z0(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;c[B>>2]=e;c[B+4>>2]=z;B=b+776|0;e=pE(B,b+520|0)|0;d=c[e>>2]|0;C=b+768|0;if(!d){if(!(a[C>>0]|0)){d=ZW(792)|0;PP(d);c[e>>2]=d;aY(b,d);d=c[e>>2]|0;a[d+765>>0]=a[b+492>>0]|0;y=b+764|0;c[y>>2]=(c[y>>2]|0)+1;A=5}}else{y=b+764|0;A=5}do if((A|0)==5){a[d+764>>0]=(c[b+784>>2]|0)>>>0>1&1;i=e+12|0;j=b+612|0;k=b+528|0;l=b+536|0;a:do if(!(a[i>>0]|0)){A=l;e1(b,c[A>>2]|0,c[A+4>>2]|0)}else{m=b+788|0;n=b+792|0;o=b+770|0;p=b+769|0;q=b+544|0;r=d+48|0;s=d+40|0;t=d+64|0;u=b+728|0;v=d+728|0;w=b+771|0;x=b+800|0;e=0;while(1){if(e>>>0>=(c[n>>2]|0)-(c[m>>2]|0)>>2>>>0)break a;if(!(((a[o>>0]|0)==0?(EG(b,p),(a[o>>0]|0)==0):0)?(g=r,h=s,(c[g>>2]|0)==(c[h>>2]|0)?(c[g+4>>2]|0)==(c[h+4>>2]|0):0):0)){h=c[(c[m>>2]|0)+(e<<2)>>2]|0;g=k;G=c[g>>2]|0;g=c[g+4>>2]|0;D=z0(G|0,g|0,h|0,0)|0;F=z;E=l;f=c[E>>2]|0;E=c[E+4>>2]|0;g=D_(f|0,E|0,G|0,g|0)|0;Sc(b,d,(c[q>>2]|0)+(c[j>>2]|0)+G|0,F>>>0>E>>>0|(F|0)==(E|0)&D>>>0>f>>>0?g:h,1)}f=c[m>>2]|0;g=((c[n>>2]|0)-f>>2)+-1|0;h=f;if(e>>>0>=g>>>0){if((e|0)==(g|0)?(a[x>>0]|0)!=0:0)A=15}else A=15;if((A|0)==15){A=0;Sc(b,d,(c[q>>2]|0)+(c[j>>2]|0)|0,0,1);f=c[m>>2]|0;h=f}F=k;F=z0(c[F>>2]|0,c[F+4>>2]|0,c[h+(e<<2)>>2]|0,0)|0;G=k;c[G>>2]=F;c[G+4>>2]=z;a[o>>0]=0;G=t;if(!((c[G>>2]|0)==-1?(c[G+4>>2]|0)==-1:0))e=(c[n>>2]|0)-f>>2;if((c[u>>2]&1|0)==0?c[v>>2]&1|0:0)W5(b);if(c[v>>2]&8|0)break;F=k;G=l;if(((c[F>>2]|0)==(c[G>>2]|0)?(c[F+4>>2]|0)==(c[G+4>>2]|0):0)?a[w>>0]|0:0)break;e=e+1|0}c[y>>2]=(c[y>>2]|0)+-1;a[i>>0]=0}while(0);if(!(a[C>>0]|0)){if(c[y>>2]|0?(F=b+48|0,F=z0(c[j>>2]|0,0,c[F>>2]|0,c[F+4>>2]|0)|0,G=k,G=z0(F|0,z|0,c[G>>2]|0,c[G+4>>2]|0)|0,F=z,!(F>>>0>0|(F|0)==0&G>>>0>262144)):0)break;if(!(a[b+492>>0]|0))y0(b,262144,0);else V5(b);G=b+64|0;b:do if(!((c[G>>2]|0)==-1?(c[G+4>>2]|0)==-1:0)){f=b+780|0;d=c[B>>2]|0;c:while(1){if((d|0)==(f|0))break b;e=d+40|0;c[e>>2]=0;c[e+4>>2]=0;e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue c}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}}while(0);a[C>>0]=1}}while(0);return}function Hf(b,d,e,f,g,h,i,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;c[e>>2]=b;B=p+8+3|0;I=p+4|0;C=o+8+3|0;D=o+4|0;E=(f&512|0)==0;F=(q|0)>0;G=n+11|0;H=n+4|0;A=0;while(1){if((A|0)==4)break;a:do switch(a[k+A>>0]|0){case 0:{c[d>>2]=c[e>>2];break}case 1:{c[d>>2]=c[e>>2];y=tb[c[(c[i>>2]|0)+44>>2]&31](i,32)|0;z=c[e>>2]|0;c[e>>2]=z+4;c[z>>2]=y;break}case 3:{z=a[B>>0]|0;r=z<<24>>24<0;if((r?c[I>>2]|0:z&255)|0){y=c[(r?c[p>>2]|0:p)>>2]|0;z=c[e>>2]|0;c[e>>2]=z+4;c[z>>2]=y}break}case 2:{v=a[C>>0]|0;r=v<<24>>24<0;v=r?c[D>>2]|0:v&255;if(!(E|(v|0)==0)){u=r?c[o>>2]|0:o;s=u+(v<<2)|0;t=c[e>>2]|0;r=t;while(1){if((u|0)==(s|0))break;c[r>>2]=c[u>>2];r=r+4|0;u=u+4|0}c[e>>2]=t+(v<<2)}break}case 4:{s=c[e>>2]|0;g=j?g+4|0:g;r=g;while(1){if(r>>>0>=h>>>0)break;if(!(gb[c[(c[i>>2]|0)+12>>2]&31](i,2048,c[r>>2]|0)|0))break;r=r+4|0}if(F){u=q;while(1){t=(u|0)>0;if(!(r>>>0>g>>>0&t))break;z=r+-4|0;x=c[z>>2]|0;y=c[e>>2]|0;c[e>>2]=y+4;c[y>>2]=x;u=u+-1|0;r=z}if(t)w=tb[c[(c[i>>2]|0)+44>>2]&31](i,48)|0;else w=0;v=c[e>>2]|0;while(1){t=v+4|0;if((u|0)<=0)break;c[v>>2]=w;u=u+-1|0;v=t}c[e>>2]=t;c[v>>2]=l}b:do if((r|0)==(g|0)){y=tb[c[(c[i>>2]|0)+44>>2]&31](i,48)|0;z=c[e>>2]|0;r=z+4|0;c[e>>2]=r;c[z>>2]=y}else{z=a[G>>0]|0;y=z<<24>>24<0;z=z&255;if(!((y?c[H>>2]|0:z)|0))t=-1;else t=a[(y?c[n>>2]|0:n)>>0]|0;u=0;v=0;x=r;r=c[e>>2]|0;while(1){if((x|0)==(g|0))break b;if((v|0)==(t|0)){w=r+4|0;c[e>>2]=w;c[r>>2]=m;r=u+1|0;if(r>>>0<(y?c[H>>2]|0:z)>>>0){t=a[(y?c[n>>2]|0:n)+r>>0]|0;t=t<<24>>24==127?-1:t<<24>>24;u=r;v=0;r=w}else{t=v;u=r;v=0;r=w}}J=x+-4|0;K=c[J>>2]|0;w=r+4|0;c[e>>2]=w;c[r>>2]=K;v=v+1|0;x=J;r=w}}while(0);if((s|0)!=(r|0))while(1){r=r+-4|0;if(s>>>0>=r>>>0)break a;K=c[s>>2]|0;c[s>>2]=c[r>>2];c[r>>2]=K;s=s+4|0}break}default:{}}while(0);A=A+1|0}r=a[B>>0]|0;g=r<<24>>24<0;r=g?c[I>>2]|0:r&255;if(r>>>0>1){s=g?c[p>>2]|0:p;u=s+4|0;r=s+(r<<2)|0;s=c[e>>2]|0;g=s;t=u;while(1){if((t|0)==(r|0))break;c[g>>2]=c[t>>2];g=g+4|0;t=t+4|0}c[e>>2]=s+((r-u|0)>>>2<<2)}switch((f&176)<<24>>24){case 32:{c[d>>2]=c[e>>2];break}case 16:break;default:c[d>>2]=b}return}function If(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;p=l;l=l+16|0;k=p;m=b+840|0;f=a[m>>0]|0;g=f&255;n=b+804|0;e=c[n>>2]|0;o=b+794|0;a:do if(!(c[e+(g*120|0)+104>>2]|0)){h=b+760|0;e=e+(g*120|0)+12|0;do if(a[h>>0]|0){f=b+793|0;g=b+795|0;if((a[f>>0]|0)==-1?(a[o>>0]|0)==-1:0){a[f>>0]=0;a[o>>0]=1;a[g>>0]=0;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;a[e>>0]=a[b+761>>0]|0;break}if(!(a[b+492>>0]|0)){a[f>>0]=255;a[f+1>>0]=255;a[f+2>>0]=255;a[f+3>>0]=255;a[f+4>>0]=255;a[f+5>>0]=255;a[h>>0]=0;i=8}}else i=8;while(0);if((i|0)==8?(a[e>>0]|0)==0:0)a[e>>0]=(a[b+773>>0]|0)==2?4:3;if((c[b+728>>2]&1|0)==0?(W5(b),(a[b+492>>0]|0)==0):0)RB(b,0,0,57,378150,-1,1,0);e=d[m>>0]|0;f=c[n>>2]|0;g=f+(e*120|0)+104|0;c[g>>2]=(c[g>>2]|0)+1;g=b+880|0;h=c[g>>2]|0;c[f+(e*120|0)+112>>2]=h;c[g>>2]=h+1;g=$e(b)|0;c[k>>2]=g;h=f+(e*120|0)+32|0;i=c[h>>2]|0;if(i>>>0<(c[f+(e*120|0)+36>>2]|0)>>>0){c[i>>2]=g;c[h>>2]=(c[h>>2]|0)+4}else Yy(f+(e*120|0)+28|0,k);g=d[m>>0]|0;h=c[n>>2]|0;i=h+(g*120|0)+28|0;j=h+(g*120|0)+32|0;e=c[j>>2]|0;q=c[i>>2]|0;f=q;if(!(c[f+((e-q>>2)+-1<<2)>>2]|0)){while(1){if((e|0)==(f|0))break;q=e+-4|0;c[j>>2]=q;e=q}e=V2()|0;c[k>>2]=e;f=c[j>>2]|0;if(f>>>0<(c[h+(g*120|0)+36>>2]|0)>>>0){c[f>>2]=e;c[j>>2]=(c[j>>2]|0)+4}else Yy(i,k);e=d[m>>0]|0;f=c[n>>2]|0;g=D3()|0;c[k>>2]=g;h=f+(e*120|0)+32|0;i=c[h>>2]|0;if(i>>>0<(c[f+(e*120|0)+36>>2]|0)>>>0){c[i>>2]=g;c[h>>2]=(c[h>>2]|0)+4}else Yy(f+(e*120|0)+28|0,k);g=d[m>>0]|0;h=c[n>>2]|0;i=B3()|0;c[k>>2]=i;e=h+(g*120|0)+32|0;f=c[e>>2]|0;if(f>>>0<(c[h+(g*120|0)+36>>2]|0)>>>0){c[f>>2]=i;c[e>>2]=(c[e>>2]|0)+4}else Yy(h+(g*120|0)+28|0,k);e=d[m>>0]|0;f=c[n>>2]|0;g=J0()|0;c[k>>2]=g;h=f+(e*120|0)+32|0;i=c[h>>2]|0;if(i>>>0<(c[f+(e*120|0)+36>>2]|0)>>>0){c[i>>2]=g;c[h>>2]=(c[h>>2]|0)+4}else Yy(f+(e*120|0)+28|0,k);e=d[m>>0]|0;f=c[n>>2]|0;g=I0()|0;c[k>>2]=g;h=f+(e*120|0)+32|0;i=c[h>>2]|0;if(i>>>0<(c[f+(e*120|0)+36>>2]|0)>>>0){c[i>>2]=g;c[h>>2]=(c[h>>2]|0)+4}else Yy(f+(e*120|0)+28|0,k)}h=b+734|0;g=0;while(1){f=a[m>>0]|0;q=f&255;e=c[n>>2]|0;i=c[e+(q*120|0)+28>>2]|0;if(g>>>0>=(c[e+(q*120|0)+32>>2]|0)-i>>2>>>0)break a;q=c[i+(g<<2)>>2]|0;a[q+734>>0]=a[h>>0]|0;aY(b,q);g=g+1|0}}while(0);ee(b,e+((f&255)*120|0)|0,o);l=p;return}function Jf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=l;l=l+240|0;x=A;v=A+204|0;y=A+192|0;z=A+180|0;w=A+176|0;s=A+16|0;t=A+8|0;u=A+4|0;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[y+(b<<2)>>2]=0;b=b+1|0}O4(z,f);b=u$(c[z>>2]|0,409116)|0;rb[c[(c[b>>2]|0)+32>>2]&7](b,401970,401996,v)|0;c6(z);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[z+(b<<2)>>2]=0;b=b+1|0}r=z+11|0;q=z+8|0;if((a[r>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;CC(z,b);b=(a[r>>0]|0)<0?c[z>>2]|0:z;c[w>>2]=b;c[t>>2]=s;c[u>>2]=0;p=z+4|0;j=c[d>>2]|0;i=j;a:while(1){if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=nb[c[(c[i>>2]|0)+36>>2]&255](i)|0;else f=e9(a[f>>0]|0)|0;if(d8(f,-1)|0){c[d>>2]=0;o=0;j=0;k=1}else{o=i;k=0}}else{o=0;j=0;k=1}i=c[e>>2]|0;m=o+12|0;n=o+16|0;do if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=nb[c[(c[i>>2]|0)+36>>2]&255](i)|0;else f=e9(a[f>>0]|0)|0;if(!(d8(f,-1)|0))if(k)break;else break a;else{c[e>>2]=0;B=22;break}}else B=22;while(0);if((B|0)==22){B=0;if(k){i=0;break}else i=0}f=a[r>>0]|0;f=f<<24>>24<0?c[p>>2]|0:f&255;if((c[w>>2]|0)==(b+f|0)){CC(z,f<<1);if((a[r>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;CC(z,b);b=(a[r>>0]|0)<0?c[z>>2]|0:z;c[w>>2]=b+f}f=c[m>>2]|0;if((f|0)==(c[n>>2]|0))f=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else f=e9(a[f>>0]|0)|0;if($l(f&255,16,b,w,u,0,y,s,t,v)|0)break;f=c[m>>2]|0;if((f|0)==(c[n>>2]|0)){nb[c[(c[o>>2]|0)+40>>2]&255](o)|0;i=o;continue}else{c[m>>2]=f+1;i=o;continue}}CC(z,(c[w>>2]|0)-b|0);v=(a[r>>0]|0)<0?c[z>>2]|0:z;w=b0()|0;c[x>>2]=h;if((_S(v,w,0,x)|0)!=1)c[g>>2]=4;if(o){b=c[m>>2]|0;if((b|0)==(c[n>>2]|0))b=nb[c[(c[j>>2]|0)+36>>2]&255](o)|0;else b=e9(a[b>>0]|0)|0;if(d8(b,-1)|0){c[d>>2]=0;f=1}else f=0}else f=1;do if(i){b=c[i+12>>2]|0;if((b|0)==(c[i+16>>2]|0))b=nb[c[(c[i>>2]|0)+36>>2]&255](i)|0;else b=e9(a[b>>0]|0)|0;if(!(d8(b,-1)|0))if(f)break;else{B=51;break}else{c[e>>2]=0;B=49;break}}else B=49;while(0);if((B|0)==49?f:0)B=51;if((B|0)==51)c[g>>2]=c[g>>2]|2;B=c[d>>2]|0;a1(z);a1(y);l=A;return B|0}function Kf(d,e,f,g,h,i,j,k,l,m,n,o,p,q,r){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;c[f>>2]=d;z=q+11|0;H=q+4|0;A=p+11|0;B=p+4|0;C=(g&512|0)==0;D=j+8|0;E=(r|0)>0;F=o+11|0;G=o+4|0;y=0;while(1){if((y|0)==4)break;a:do switch(a[l+y>>0]|0){case 0:{c[e>>2]=c[f>>2];break}case 1:{c[e>>2]=c[f>>2];w=tb[c[(c[j>>2]|0)+28>>2]&31](j,32)|0;x=c[f>>2]|0;c[f>>2]=x+1;a[x>>0]=w;break}case 3:{x=a[z>>0]|0;s=x<<24>>24<0;if((s?c[H>>2]|0:x&255)|0){w=a[(s?c[q>>2]|0:q)>>0]|0;x=c[f>>2]|0;c[f>>2]=x+1;a[x>>0]=w}break}case 2:{w=a[A>>0]|0;s=w<<24>>24<0;w=s?c[B>>2]|0:w&255;if(!(C|(w|0)==0)){t=s?c[p>>2]|0:p;u=t+w|0;v=c[f>>2]|0;s=v;while(1){if((t|0)==(u|0))break;a[s>>0]=a[t>>0]|0;s=s+1|0;t=t+1|0}c[f>>2]=v+w}break}case 4:{t=c[f>>2]|0;h=k?h+1|0:h;u=h;while(1){if(u>>>0>=i>>>0)break;s=a[u>>0]|0;if(s<<24>>24<=-1)break;if(!(b[(c[D>>2]|0)+(s<<24>>24<<1)>>1]&2048))break;u=u+1|0}if(E){v=r;while(1){s=(v|0)>0;if(!(u>>>0>h>>>0&s))break;x=u+-1|0;s=a[x>>0]|0;w=c[f>>2]|0;c[f>>2]=w+1;a[w>>0]=s;v=v+-1|0;u=x}if(s)w=tb[c[(c[j>>2]|0)+28>>2]&31](j,48)|0;else w=0;s=v;while(1){v=c[f>>2]|0;c[f>>2]=v+1;if((s|0)<=0)break;a[v>>0]=w;s=s+-1|0}a[v>>0]=m}b:do if((u|0)==(h|0)){w=tb[c[(c[j>>2]|0)+28>>2]&31](j,48)|0;x=c[f>>2]|0;c[f>>2]=x+1;a[x>>0]=w}else{x=a[F>>0]|0;s=x<<24>>24<0;if(!((s?c[G>>2]|0:x&255)|0)){w=-1;v=0;x=0}else{w=a[(s?c[o>>2]|0:o)>>0]|0;v=0;x=0}while(1){if((u|0)==(h|0))break b;if((x|0)==(w|0)){w=c[f>>2]|0;c[f>>2]=w+1;a[w>>0]=n;v=v+1|0;w=a[F>>0]|0;s=w<<24>>24<0;if(v>>>0<(s?c[G>>2]|0:w&255)>>>0){w=a[(s?c[o>>2]|0:o)+v>>0]|0;w=w<<24>>24==127?-1:w<<24>>24;s=0}else{w=x;s=0}}else s=x;I=u+-1|0;J=a[I>>0]|0;x=c[f>>2]|0;c[f>>2]=x+1;a[x>>0]=J;x=s+1|0;u=I}}while(0);s=c[f>>2]|0;if((t|0)!=(s|0))while(1){s=s+-1|0;if(t>>>0>=s>>>0)break a;J=a[t>>0]|0;a[t>>0]=a[s>>0]|0;a[s>>0]=J;t=t+1|0}break}default:{}}while(0);y=y+1|0}v=a[z>>0]|0;h=v<<24>>24<0;v=h?c[H>>2]|0:v&255;if(v>>>0>1){h=h?c[q>>2]|0:q;t=h+v|0;u=c[f>>2]|0;s=u;while(1){h=h+1|0;if((h|0)==(t|0))break;a[s>>0]=a[h>>0]|0;s=s+1|0}c[f>>2]=u+(v+-1)}switch((g&176)<<24>>24){case 32:{c[e>>2]=c[f>>2];break}case 16:break;default:c[e>>2]=d}return}function Lf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=l;l=l+64|0;p=u+48|0;q=u+36|0;r=u+24|0;s=u+12|0;t=u;TX(p);TX(q);TX(r);TX(s);j=d&65535;k=p+8+3|0;f=p+4|0;n=r+8+3|0;o=r+4|0;m=0;while(1){if(m>>>0>=16)break;a:do if(1<<15-m&j|0)switch((m&255)<<24>>24){case 0:{HX(p,16276)|0;break a}case 1:{HX(p,16288)|0;break a}case 2:{HX(p,16300)|0;break a}case 3:{HX(q,16276)|0;break a}case 4:{HX(q,16300)|0;break a}case 5:{e=a[k>>0]|0;g=e<<24>>24<0;h=g?c[p>>2]|0:p;i=i9(16300)|0;d=c[f>>2]|0;e=e&255;if(i|0?(v=h+((g?d:e)<<2)|0,i=HA(h,v,16300,16300+(i<<2)|0)|0,(i|0)==(v|0)|(i-h|0)==-4):0){HX(p,13312)|0;break a}FB(p,(g?d:e)+-2|0,0);HX(p,13312)|0;HX(p,16300)|0;break a}case 6:{HX(r,13332)|0;break a}case 7:{v=a[n>>0]|0;if(!((v<<24>>24<0?c[o>>2]|0:v&255)|0)){Xy(t,16288);vF(r,t)|0;z5(t);break a}else{Xy(t,13352);vF(r,t)|0;z5(t);break a}}case 15:{HX(s,14344)|0;break a}default:break a}while(0);m=m+1|0}TX(b);v=a[k>>0]|0;if((v<<24>>24<0?c[f>>2]|0:v&255)|0){ms(t,16248,p);v=a[t+8+3>>0]|0;m=v<<24>>24<0;Ex(b,m?c[t>>2]|0:t,m?c[t+4>>2]|0:v&255)|0;O0(t)}v=a[q+8+3>>0]|0;f=b+4|0;e=b+8+3|0;if((v<<24>>24<0?c[q+4>>2]|0:v&255)|0){d=a[e>>0]|0;if(d<<24>>24<0)d=c[f>>2]|0;else d=d&255;if(d|0)HX(b,39968)|0;ms(t,16312,q);v=a[t+8+3>>0]|0;m=v<<24>>24<0;Ex(b,m?c[t>>2]|0:t,m?c[t+4>>2]|0:v&255)|0;O0(t)}v=a[n>>0]|0;if((v<<24>>24<0?c[o>>2]|0:v&255)|0){d=a[e>>0]|0;if(d<<24>>24<0)d=c[f>>2]|0;else d=d&255;if(d|0)HX(b,39968)|0;ms(t,16348,r);v=a[t+8+3>>0]|0;o=v<<24>>24<0;Ex(b,o?c[t>>2]|0:t,o?c[t+4>>2]|0:v&255)|0;O0(t)}v=a[s+8+3>>0]|0;t=v<<24>>24<0;Ex(b,t?c[s>>2]|0:s,t?c[s+4>>2]|0:v&255)|0;z5(s);z5(r);z5(q);z5(p);l=u;return}function Mf(d,f,g,h,i,j){d=d|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;H=l;l=l+64|0;G=H+32|0;n=H;k=0;while(1){if((k|0)==16){k=0;break}b[G+(k<<1)>>1]=0;k=k+1|0}while(1){if((k|0)==(g|0))break;F=G+(e[f+(k<<1)>>1]<<1)|0;b[F>>1]=(b[F>>1]|0)+1<<16>>16;k=k+1|0}k=c[i>>2]|0;F=15;while(1){if(!F){m=11;break}if(b[G+(F<<1)>>1]|0){m=10;break}F=F+-1|0}a:do if((m|0)==10){k=k>>>0>F>>>0?F:k;p=1;while(1){if(p>>>0>=F>>>0)break;if(b[G+(p<<1)>>1]|0)break;p=p+1|0}E=k>>>0<p>>>0?p:k;k=1;m=1;while(1){if(m>>>0>=16)break;k=(k<<1)-(e[G+(m<<1)>>1]|0)|0;if((k|0)<0){k=-1;break a}else m=m+1|0}if((k|0)>0?(d|0)==0|(F|0)!=1:0){k=-1;break}else{k=0;m=1}while(1){b[n+(m<<1)>>1]=k;if((m|0)==15){k=0;break}k=(e[G+(m<<1)>>1]|0)+(k&65535)&65535;m=m+1|0}while(1){if((k|0)==(g|0))break;m=b[f+(k<<1)>>1]|0;if(m<<16>>16){C=n+((m&65535)<<1)|0;D=b[C>>1]|0;b[C>>1]=D+1<<16>>16;b[j+((D&65535)<<1)>>1]=k}k=k+1|0}k=E>>>0>9;switch(d|0){case 0:{B=j;C=j;D=20;m=0;z=0;break}case 1:{if(k){k=1;break a}else{B=64190;C=64064;D=257;m=0;z=1}break}default:{m=(d|0)==2;if(m&k){k=1;break a}else{B=64126;C=64e3;D=0;z=0}}}x=1<<E;y=x+-1|0;A=E&255;d=c[h>>2]|0;v=-1;o=0;u=0;k=E;n=0;g=p;b:while(1){t=1<<k;w=o;while(1){q=g-u|0;s=q&255;k=b[j+(n<<1)>>1]|0;o=k&65535;if((o+1|0)>>>0>=D>>>0){p=o-D|0;if(o>>>0<D>>>0){k=0;r=96}else{k=b[C+(p<<1)>>1]|0;r=b[B+(p<<1)>>1]&255}}else r=0;p=1<<q;q=w>>>u;o=t;do{o=o-p|0;I=o+q|0;a[d+(I<<2)>>0]=r;a[d+(I<<2)+1>>0]=s;b[d+(I<<2)+2>>1]=k}while((o|0)!=0);k=1<<g+-1;while(1)if(!(k&w))break;else k=k>>>1;w=(k|0)==0?0:(k+-1&w)+k|0;n=n+1|0;r=G+(g<<1)|0;I=(b[r>>1]|0)+-1<<16>>16;b[r>>1]=I;if(!(I<<16>>16)){if((g|0)==(F|0))break b;r=e[f+(e[j+(n<<1)>>1]<<1)>>1]|0}else r=g;if(r>>>0<=E>>>0){g=r;continue}o=w&y;if((o|0)!=(v|0))break;else g=r}p=(u|0)==0?E:u;d=d+(t<<2)|0;q=r-p|0;k=1<<q;while(1){g=q+p|0;if(g>>>0>=F>>>0)break;k=k-(e[G+(g<<1)>>1]|0)|0;if((k|0)<1)break;k=k<<1;q=q+1|0}k=(1<<q)+x|0;if(z&k>>>0>852|m&k>>>0>592){k=1;break a}v=c[h>>2]|0;a[v+(o<<2)>>0]=q;a[v+(o<<2)+1>>0]=A;b[v+(o<<2)+2>>1]=(d-v|0)>>>2;v=o;o=w;x=k;u=p;k=q;g=r}if(w|0){a[d+(w<<2)>>0]=64;a[d+(w<<2)+1>>0]=s;b[d+(w<<2)+2>>1]=0}c[h>>2]=(c[h>>2]|0)+(x<<2);c[i>>2]=E;k=0}else if((m|0)==11){k=c[h>>2]|0;c[h>>2]=k+4;a[k>>0]=64;a[k+1>>0]=1;b[k+2>>1]=0;k=c[h>>2]|0;c[h>>2]=k+4;a[k>>0]=64;a[k+1>>0]=1;b[k+2>>1]=0;c[i>>2]=1;k=0}while(0);l=H;return k|0}function Nf(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=l;l=l+112|0;k=y;m=(f-e|0)/12|0;if(m>>>0>100){k=Ub(m)|0;if(!k)uaa();else{j=k;w=k}}else{j=k;w=0}k=0;o=e;p=j;while(1){if((o|0)==(f|0))break;n=a[o+8+3>>0]|0;if(n<<24>>24<0)n=c[o+4>>2]|0;else n=n&255;if(!n){a[p>>0]=2;k=k+1|0;m=m+-1|0}else a[p>>0]=1;o=o+12|0;p=p+1|0}v=0;s=k;o=d;a:while(1){k=c[b>>2]|0;do if(k){n=c[k+12>>2]|0;if((n|0)==(c[k+16>>2]|0))k=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else k=raa(c[n>>2]|0)|0;if(d8(k,-1)|0){c[b>>2]=0;d=1;break}else{d=(c[b>>2]|0)==0;break}}else d=1;while(0);if(!o){q=0;u=0;k=1}else{k=c[o+12>>2]|0;if((k|0)==(c[o+16>>2]|0))k=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else k=raa(c[k>>2]|0)|0;k=d8(k,-1)|0;q=k?0:o;u=k?0:o}o=c[b>>2]|0;p=o+16|0;n=o+12|0;if(!((m|0)!=0&(d^k)))break;k=c[n>>2]|0;if((k|0)==(c[p>>2]|0))k=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else k=raa(c[k>>2]|0)|0;if(!i)k=tb[c[(c[g>>2]|0)+28>>2]&31](g,k)|0;t=v+1|0;q=e;d=0;r=j;while(1){if((q|0)==(f|0))break;do if((a[r>>0]|0)==1){o=q+8+3|0;if((a[o>>0]|0)<0)n=c[q>>2]|0;else n=q;n=c[n+(v<<2)>>2]|0;if(!i)n=tb[c[(c[g>>2]|0)+28>>2]&31](g,n)|0;p=m+-1|0;if((k|0)!=(n|0)){a[r>>0]=0;n=d;o=s;m=p;break}n=a[o>>0]|0;if(n<<24>>24<0)n=c[q+4>>2]|0;else n=n&255;if((n|0)==(t|0)){a[r>>0]=2;n=1;o=s+1|0;m=p}else{n=1;o=s}}else{n=d;o=s}while(0);q=q+12|0;d=n;r=r+1|0;s=o}if(!d){v=t;o=u;continue}k=c[b>>2]|0;n=k+12|0;o=c[n>>2]|0;if((o|0)==(c[k+16>>2]|0))nb[c[(c[k>>2]|0)+40>>2]&255](k)|0;else c[n>>2]=o+4;if((s+m|0)>>>0>1){o=e;p=j;k=s}else{v=t;o=u;continue}while(1){if((o|0)==(f|0)){v=t;s=k;o=u;continue a}if((a[p>>0]|0)==2){n=a[o+8+3>>0]|0;if(n<<24>>24<0)n=c[o+4>>2]|0;else n=n&255;if((n|0)!=(t|0)){a[p>>0]=0;k=k+-1|0}}o=o+12|0;p=p+1|0}}do if(o){k=c[n>>2]|0;if((k|0)==(c[p>>2]|0))k=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else k=raa(c[k>>2]|0)|0;if(d8(k,-1)|0){c[b>>2]=0;m=1;break}else{m=(c[b>>2]|0)==0;break}}else m=1;while(0);if(q){k=c[q+12>>2]|0;if((k|0)==(c[q+16>>2]|0))k=nb[c[(c[q>>2]|0)+36>>2]&255](q)|0;else k=raa(c[k>>2]|0)|0;if(!(d8(k,-1)|0)){if(!m)x=75}else x=39}else x=39;if((x|0)==39)if(m)x=75;if((x|0)==75)c[h>>2]=c[h>>2]|2;while(1){if((e|0)==(f|0)){x=79;break}if((a[j>>0]|0)==2)break;e=e+12|0;j=j+1|0}if((x|0)==79){c[h>>2]=c[h>>2]|4;e=f}pe(w);l=y;return e|0}function Of(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=j9(375143)|0;k=d+11|0;f=a[k>>0]|0;j=d+4|0;g=c[j>>2]|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(ZG(d,375143,e)|0)){IX(b,380189)|0;break}else{f=a[k>>0]|0;g=c[j>>2]|0;h=5;break}else h=5;while(0);a:do if((h|0)==5){e=j9(375173)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(ZG(d,375173,e)|0)){IX(b,380183)|0;break a}else{f=a[k>>0]|0;g=c[j>>2]|0;break}while(0);e=j9(375205)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(ZG(d,375205,e)|0)){IX(b,377029)|0;break a}else{f=a[k>>0]|0;g=c[j>>2]|0;break}while(0);e=j9(375210)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(ZG(d,375210,e)|0)){IX(b,375219)|0;break a}else{f=a[k>>0]|0;g=c[j>>2]|0;break}while(0);e=j9(377523)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(ZG(d,377523,e)|0)){IX(b,377523)|0;break a}else{f=a[k>>0]|0;g=c[j>>2]|0;break}while(0);e=j9(375233)|0;h=b+4|0;i=b+11|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0)){if(ZG(d,375233,e)|0){f=a[k>>0]|0;g=c[j>>2]|0;break}if((a[i>>0]|0)<0){J7(c[b>>2]|0,0);c[h>>2]=0;break a}else{J7(b,0);a[i>>0]=0;break a}}while(0);e=j9(375242)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0)){if(ZG(d,375242,e)|0){f=a[k>>0]|0;g=c[j>>2]|0;break}if((a[i>>0]|0)<0){J7(c[b>>2]|0,0);c[h>>2]=0;break a}else{J7(b,0);a[i>>0]=0;break a}}while(0);e=j9(375258)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0)){if(ZG(d,375258,e)|0){f=a[k>>0]|0;g=c[j>>2]|0;break}if((a[i>>0]|0)<0){J7(c[b>>2]|0,0);c[h>>2]=0;break a}else{J7(b,0);a[i>>0]=0;break a}}while(0);e=j9(375267)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(ZG(d,375267,e)|0)){IX(b,380530)|0;break a}else{g=c[j>>2]|0;f=a[k>>0]|0;break}while(0);e=j9(375277)|0;if((e|0)==((f<<24>>24<0?g:f&255)|0)?(ZG(d,375277,e)|0)==0:0){IX(b,375287)|0;break}KQ(b,d)|0}while(0);return}function Pf(b,e,f){b=b|0;e=e|0;f=f|0;var g=0.0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;switch(e|0){case 0:{l=-149;m=24;j=4;break}case 1:{l=-1074;m=53;j=4;break}case 2:{l=-1074;m=53;j=4;break}default:g=0.0}a:do if((j|0)==4){o=b+4|0;n=b+100|0;do{e=c[o>>2]|0;if(e>>>0<(c[n>>2]|0)>>>0){c[o>>2]=e+1;e=d[e>>0]|0}else e=_x(b)|0}while((Z8(e)|0)!=0);b:do switch(e|0){case 43:case 45:{i=1-(((e|0)==45&1)<<1)|0;e=c[o>>2]|0;if(e>>>0<(c[n>>2]|0)>>>0){c[o>>2]=e+1;h=d[e>>0]|0;break b}else{h=_x(b)|0;break b}}default:{h=e;i=1}}while(0);e=0;do{if((h|32|0)!=(a[401330+e>>0]|0))break;do if(e>>>0<7){h=c[o>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){c[o>>2]=h+1;h=d[h>>0]|0;break}else{h=_x(b)|0;break}}while(0);e=e+1|0}while(e>>>0<8);c:do switch(e|0){case 8:break;case 3:{j=23;break}default:{k=(f|0)!=0;if(k&e>>>0>3)if((e|0)==8)break c;else{j=23;break c}d:do if(!e){e=0;do{if((h|32|0)!=(a[401339+e>>0]|0))break d;do if(e>>>0<2){h=c[o>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){c[o>>2]=h+1;h=d[h>>0]|0;break}else{h=_x(b)|0;break}}while(0);e=e+1|0}while(e>>>0<3)}while(0);switch(e|0){case 3:{e=c[o>>2]|0;if(e>>>0<(c[n>>2]|0)>>>0){c[o>>2]=e+1;e=d[e>>0]|0}else e=_x(b)|0;if((e|0)==40)e=1;else{if(!(c[n>>2]|0)){g=s;break a}c[o>>2]=(c[o>>2]|0)+-1;g=s;break a}while(1){h=c[o>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){c[o>>2]=h+1;h=d[h>>0]|0}else h=_x(b)|0;if(!((h+-48|0)>>>0<10|(h+-65|0)>>>0<26)?!((h|0)==95|(h+-97|0)>>>0<26):0)break;e=e+1|0}if((h|0)==41){g=s;break a}h=(c[n>>2]|0)==0;if(!h)c[o>>2]=(c[o>>2]|0)+-1;if(!k){c[12784]=22;NV(b,0);g=0.0;break a}if(!e){g=s;break a}while(1){e=e+-1|0;if(!h)c[o>>2]=(c[o>>2]|0)+-1;if(!e){g=s;break a}}}case 0:{if((h|0)==48){e=c[o>>2]|0;if(e>>>0<(c[n>>2]|0)>>>0){c[o>>2]=e+1;e=d[e>>0]|0}else e=_x(b)|0;if((e|32|0)==120){g=+cf(b,m,l,i,f);break a}if(!(c[n>>2]|0))e=48;else{c[o>>2]=(c[o>>2]|0)+-1;e=48}}else e=h;g=+ed(b,e,m,l,i,f);break a}default:{if(c[n>>2]|0)c[o>>2]=(c[o>>2]|0)+-1;c[12784]=22;NV(b,0);g=0.0;break a}}}}while(0);if((j|0)==23){h=(c[n>>2]|0)==0;if(!h)c[o>>2]=(c[o>>2]|0)+-1;if((f|0)!=0&e>>>0>3)do{if(!h)c[o>>2]=(c[o>>2]|0)+-1;e=e+-1|0}while(e>>>0>3)}g=+(i|0)*t}while(0);return +g}function Qf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;x=l;l=l+32|0;w=x+12|0;v=x;p=b+544|0;q=b+612|0;g=(c[p>>2]|0)+(c[q>>2]|0)|0;r=b+536|0;e=c[r>>2]|0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;if(e>>>0>4294967279)uaa();s=w+4|0;f=w+11|0;if(e>>>0<11){a[f>>0]=e;d=w}else{n=e+16&-16;d=ZW(n)|0;c[w>>2]=d;c[w+8>>2]=n|-2147483648;c[s>>2]=e}i1(d,g,e)|0;J7(d+e|0,0);i=a[f>>0]|0;j=i<<24>>24<0;m=j?c[w>>2]|0:w;d=j9(372705)|0;n=b+944|0;if(d){h=m+(j?c[s>>2]|0:i&255)|0;g=tB(m,h,372705,372705+d|0)|0;d=g-m|0;if((g|0)==(h|0)|(d|0)==-1)h=13;else{e=d;h=8}}else{e=0;h=8}if((h|0)==8){g=r;f=c[g>>2]|0;g=c[g+4>>2]|0;d=z0(f|0,g|0,-8,-1)|0;y=z;if(0>y>>>0|0==(y|0)&e>>>0>d>>>0)h=13;else{d=b+528|0;y=d;c[y>>2]=e;c[y+4>>2]=0;y=z0(e|0,0,20,0)|0;v=z;if(v>>>0>g>>>0|(v|0)==(g|0)&y>>>0>f>>>0)jZ(b,8,0,n);else jZ(b,20,0,n);h1(n,65)|0;h1(n,85)|0;h1(n,170)|0;y=d;c[y>>2]=0;c[y+4>>2]=0}}do if((h|0)==13){d=j9(372710)|0;if(d){y=m+(j?c[s>>2]|0:i&255)|0;b=tB(m,y,372710,372710+d|0)|0;d=b-m|0;if(!((b|0)==(y|0)|(d|0)==-1)){k=d;h=15}}else{k=0;h=15}if((h|0)==15?(y=r,y=z0(c[y>>2]|0,c[y+4>>2]|0,-23,-1)|0,b=z,0<b>>>0|0==(b|0)&k>>>0<y>>>0):0){VU(v,372729);vF(n,v)|0;z5(v);KT(v,(c[p>>2]|0)+(c[q>>2]|0)+18|0,5);y=a[v+8+3>>0]|0;u=y<<24>>24<0;Ex(n,u?c[v>>2]|0:v,u?c[v+4>>2]|0:y&255)|0;z5(v);break}d=j9(372734)|0;if(d){y=m+(j?c[s>>2]|0:i&255)|0;k=tB(m,y,372734,372734+d|0)|0;d=k-m|0;if(!((k|0)==(y|0)|(d|0)==-1)){o=d;h=19}}else{o=0;h=19}if((h|0)==19?(y=r,y=z0(c[y>>2]|0,c[y+4>>2]|0,-29,-1)|0,r=z,0<r>>>0|0==(r|0)&o>>>0<y>>>0):0){VU(v,372757);vF(n,v)|0;z5(v);KT(v,(c[p>>2]|0)+(c[q>>2]|0)+22|0,6);y=a[v+8+3>>0]|0;u=y<<24>>24<0;Ex(n,u?c[v>>2]|0:v,u?c[v+4>>2]|0:y&255)|0;z5(v);break}d=j9(372766)|0;if(d|0?(t=m+(j?c[s>>2]|0:i&255)|0,y=tB(m,t,372766,372766+d|0)|0,u=m,(y|0)==(t|0)|(y-u|0)==-1):0){d=j9(372781)|0;if(d|0?(y=tB(m,t,372781,372781+d|0)|0,(y|0)==(t|0)|(y-u|0)==-1):0)break;VU(v,372786);vF(n,v)|0;z5(v);break}VU(v,372771);vF(n,v)|0;z5(v)}while(0);a1(w);l=x;return}function Rf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+16|0;i=m;zb(b,e,f,Rb(e,12)|0,d,0);h=Aj(e,g,d,1)|0;n=Rb(e,0)|0;j=a[h+8+3>>0]|0;zb(b,e,f,n,((j<<24>>24<0?c[h+4>>2]|0:j&255)|0)==0?d:h,1);h=Rb(e,13)|0;zb(b,e,f,h,Aj(e,g,d,3)|0,1);Mc(b,e,f,357472,Aj(e,g,d,2)|0,1);h=Rb(e,15)|0;zb(b,e,f,h,Aj(e,g,d,4)|0,1);h=Rb(e,5)|0;zb(b,e,f,h,Aj(e,g,d,6)|0,1);h=Rb(e,6)|0;zb(b,e,f,h,Aj(e,g,d,5)|0,1);h=Rb(e,54)|0;zb(b,e,f,h,Aj(e,g,d,7)|0,1);h=Rb(e,55)|0;zb(b,e,f,h,Aj(e,g,d,8)|0,1);h=Rb(e,58)|0;$x(i,b,e,f,h,1);j=a[i+8+3>>0]|0;if(!((j<<24>>24<0?c[i+4>>2]|0:j&255)|0)){j=Aj(e,g,d,9)|0;n=a[j+8+3>>0]|0;n=((n<<24>>24<0?c[j+4>>2]|0:n&255)|0)==0;z5(i);if(!n)zb(b,e,f,h,Aj(e,g,d,9)|0,1)}else z5(i);h=Rb(e,60)|0;$x(i,b,e,f,h,1);n=a[i+8+3>>0]|0;n=((n<<24>>24<0?c[i+4>>2]|0:n&255)|0)==0;z5(i);if(n)zb(b,e,f,h,Aj(e,g,d,10)|0,1);e=i9(7780)|0;g=d+8+3|0;i=a[g>>0]|0;j=d+4|0;h=c[j>>2]|0;if((e|0)==((i<<24>>24<0?h:i&255)|0))if(!(VG(d,7780,e)|0))e=12;else{i=a[g>>0]|0;h=c[j>>2]|0;e=10}else e=10;if(((e|0)==10?(k=i9(7800)|0,(k|0)==((i<<24>>24<0?h:i&255)|0)):0)?(VG(d,7800,k)|0)==0:0)e=12;if((e|0)==12)sM(b,1,f,195,10,0);l=m;return}function Sf(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=l;l=l+320|0;x=A;v=A+208|0;y=A+192|0;z=A+180|0;w=A+176|0;s=A+16|0;t=A+8|0;u=A+4|0;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[y+(b<<2)>>2]=0;b=b+1|0}O4(z,f);b=u$(c[z>>2]|0,409148)|0;rb[c[(c[b>>2]|0)+48>>2]&7](b,401970,401996,v)|0;c6(z);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[z+(b<<2)>>2]=0;b=b+1|0}r=z+11|0;q=z+8|0;if((a[r>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;CC(z,b);b=(a[r>>0]|0)<0?c[z>>2]|0:z;c[w>>2]=b;c[t>>2]=s;c[u>>2]=0;p=z+4|0;j=c[d>>2]|0;i=j;a:while(1){if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=nb[c[(c[i>>2]|0)+36>>2]&255](i)|0;else f=raa(c[f>>2]|0)|0;if(d8(f,-1)|0){c[d>>2]=0;o=0;j=0;k=1}else{o=i;k=0}}else{o=0;j=0;k=1}i=c[e>>2]|0;n=o+16|0;m=o+12|0;do if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=nb[c[(c[i>>2]|0)+36>>2]&255](i)|0;else f=raa(c[f>>2]|0)|0;if(!(d8(f,-1)|0))if(k)break;else break a;else{c[e>>2]=0;B=22;break}}else B=22;while(0);if((B|0)==22){B=0;if(k){i=0;break}else i=0}f=a[r>>0]|0;f=f<<24>>24<0?c[p>>2]|0:f&255;if((c[w>>2]|0)==(b+f|0)){CC(z,f<<1);if((a[r>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;CC(z,b);b=(a[r>>0]|0)<0?c[z>>2]|0:z;c[w>>2]=b+f}f=c[m>>2]|0;if((f|0)==(c[n>>2]|0))f=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else f=raa(c[f>>2]|0)|0;if(am(f,16,b,w,u,0,y,s,t,v)|0)break;f=c[m>>2]|0;if((f|0)==(c[n>>2]|0)){nb[c[(c[o>>2]|0)+40>>2]&255](o)|0;i=o;continue}else{c[m>>2]=f+4;i=o;continue}}CC(z,(c[w>>2]|0)-b|0);v=(a[r>>0]|0)<0?c[z>>2]|0:z;w=b0()|0;c[x>>2]=h;if((_S(v,w,0,x)|0)!=1)c[g>>2]=4;if(o){b=c[m>>2]|0;if((b|0)==(c[n>>2]|0))b=nb[c[(c[j>>2]|0)+36>>2]&255](o)|0;else b=raa(c[b>>2]|0)|0;if(d8(b,-1)|0){c[d>>2]=0;f=1}else f=0}else f=1;do if(i){b=c[i+12>>2]|0;if((b|0)==(c[i+16>>2]|0))b=nb[c[(c[i>>2]|0)+36>>2]&255](i)|0;else b=raa(c[b>>2]|0)|0;if(!(d8(b,-1)|0))if(f)break;else{B=51;break}else{c[e>>2]=0;B=49;break}}else B=49;while(0);if((B|0)==49?f:0)B=51;if((B|0)==51)c[g>>2]=c[g>>2]|2;B=c[d>>2]|0;a1(z);a1(y);l=A;return B|0}function Tf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;s=l;l=l+16|0;j=s+8|0;m=s;q=b+536|0;g=q;f=c[g>>2]|0;g=c[g+4>>2]|0;a:do if((a[b+1040>>0]|0)!=0?(k=b+1e3|0,e=k,d=c[e>>2]|0,e=c[e+4>>2]|0,!((d|0)==-1&(e|0)==-1)):0){n=b+612|0;o=b+544|0;p=b+528|0;if(g>>>0>0|(g|0)==0&f>>>0>15){h=z0(d|0,e|0,4,0)|0;i=z;e=p;d=c[e>>2]|0;e=c[e+4>>2]|0;if((h|0)==(t7((c[o>>2]|0)+(c[n>>2]|0)+d+8|0)|0)&(i|0)==0){i=k;c[i>>2]=0;c[i+4>>2]=0}}else{e=p;d=c[e>>2]|0;e=c[e+4>>2]|0}h=b+760|0;i=b+776|0;while(1){e=z0(d|0,e|0,16,0)|0;t=z;if(t>>>0>g>>>0|(t|0)==(g|0)&e>>>0>f>>>0)break;e=(c[o>>2]|0)+(c[n>>2]|0)+d|0;c[j>>2]=(W8(e)|0)&-65536;f=t7(e+8|0)|0;e=t7(e+12|0)|0;g=jF(h,j)|0;t=g+64|0;u=t;u=z0(c[u>>2]|0,c[u+4>>2]|0,e|0,0)|0;c[t>>2]=u;c[t+4>>2]=z;g=g+56|0;c[g>>2]=(c[g>>2]|0)+1;g=k;f=z0(c[g>>2]|0,c[g+4>>2]|0,f|0,0)|0;g=m;c[g>>2]=f;c[g+4>>2]=z;g=kD(i,m)|0;f=g;c[f>>2]=c[j>>2];c[f+4>>2]=0;g=g+8|0;c[g>>2]=e;c[g+4>>2]=0;g=p;g=z0(c[g>>2]|0,c[g+4>>2]|0,16,0)|0;e=z;f=p;c[f>>2]=g;c[f+4>>2]=e;f=q;d=g;g=c[f+4>>2]|0;f=c[f>>2]|0}j=b+780|0;k=b+808|0;m=b+816|0;n=b+824|0;o=b+832|0;e=0;i=0;d=c[b+776>>2]|0;b:while(1){if((d|0)==(j|0))break a;h=d+16|0;g=d+24|0;f=c[g>>2]|0;g=c[g+4>>2]|0;c:do if((f|0)<808517632){switch(f|0){case 808452096:break;default:{g=i;break c}}if(!g){u=k;if((c[u>>2]|0)==0&(c[u+4>>2]|0)==0){b=h;t=c[b+4>>2]|0;u=k;c[u>>2]=c[b>>2];c[u+4>>2]=t}u=m;if((c[u>>2]|0)==0&(c[u+4>>2]|0)==0){f=i+1|0;if(f>>>0>1){t=h;u=c[t+4>>2]|0;g=m;c[g>>2]=c[t>>2];c[g+4>>2]=u;g=f}else g=f}else g=i}else g=i}else{switch(f|0){case 808517632:break;default:{g=i;break c}}if(!g){u=n;if((c[u>>2]|0)==0&(c[u+4>>2]|0)==0){b=h;t=c[b+4>>2]|0;u=n;c[u>>2]=c[b>>2];c[u+4>>2]=t}u=o;if((c[u>>2]|0)==0&(c[u+4>>2]|0)==0){e=e+1|0;if(e>>>0>1){t=h;u=c[t+4>>2]|0;g=o;c[g>>2]=c[t>>2];c[g+4>>2]=u;g=i}else g=i}else g=i}else g=i}while(0);f=c[d+4>>2]|0;if(!f)while(1){f=c[d+8>>2]|0;if((c[f>>2]|0)==(d|0)){i=g;d=f;continue b}else d=f}else d=f;while(1){f=c[d>>2]|0;if(!f)break;else d=f}i=g}}else r=3;while(0);if((r|0)==3)e1(b,f,g);l=s;return}function Uf(){var b=0,d=0,e=0;c[102053]=0;c[102052]=57264;BT();c[102088]=0;c[102089]=0;c[102090]=0;d=j9(402006)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11){a[408363]=d;b=408352}else{e=d+16&-16;b=ZW(e)|0;c[102088]=b;c[102090]=e|-2147483648;c[102089]=d}i1(b,402006,d)|0;J7(b+d|0,0);d=c[102054]|0;b=c[102055]|0;while(1){if((b|0)==(d|0))break;e=b+-4|0;c[102055]=e;b=e}a7();A1();$6();z1();O7();M1();q7();L1();x5();B0();E5();A0();p5();u0();q5();v0();y8();u1();x8();t1();W1();q_();V1();p_();U1();o_();T1();n_();$5();U0();_5();T0();Z5();S0();Y5();R0();F1();f_();E1();e_();N1();d_();D1();c_();OX();m_();NX();l_();ZY();k_();YY();j_();U6();w1();T6();v1();return}function Vf(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;s=b+64|0;q=b+728|0;if(a[b+496>>0]|0)if((Zj(b)|0?(c[q>>2]&8|0)==0:0)?(v=s,(c[v>>2]|0)==-1?(c[v+4>>2]|0)==-1:0):0)u=5;else d=0;else u=5;do if((u|0)==5){d=b+528|0;r=d;c[r>>2]=0;c[r+4>>2]=0;r=b+548|0;l=b+536|0;c[l>>2]=c[r>>2];c[l+4>>2]=0;l=b+508|0;m=b+668|0;a[(c[m>>2]|0)+((c[l>>2]|0)*24|0)+16>>0]=0;jb[c[(c[b>>2]|0)+28>>2]&511](b);if(!(J1(c[l>>2]|0,c[m>>2]|0)|0)){v=b+612|0;i=c[v>>2]|0;e=d;d=c[e>>2]|0;e=z0(i|0,0,d|0,c[e+4>>2]|0)|0;h=z;t=b+48|0;if(h>>>0>0|(h|0)==0&e>>>0>4294967294){i=t;i=z0(c[i>>2]|0,c[i+4>>2]|0,e|0,h|0)|0;ty(b,i,z)}else c[v>>2]=d+i;h=b+732|0;if(c[q>>2]&8|0?(a[h>>0]|0)==0:0){d=0;break}d=c[v>>2]|0;e=c[r>>2]|0;if(d>>>0<=e>>>0?(i=s,(c[i>>2]|0)==-1?(c[i+4>>2]|0)==-1:0):0){while(1){if(d>>>0>=e>>>0)break;i=pj(b)|0;d=c[v>>2]|0;if(!i)break;e=c[r>>2]|0}e=b+552|0;i=e;d=z0(c[i>>2]|0,c[i+4>>2]|0,d|0,0)|0;c[e>>2]=d;c[e+4>>2]=z;e=s;d=c[e>>2]|0;e=c[e+4>>2]|0;if((!((d|0)==-1&(e|0)==-1)?(k=t,j=c[k>>2]|0,k=c[k+4>>2]|0,!(e>>>0<k>>>0|(e|0)==(k|0)&d>>>0<j>>>0)):0)?(f=c[r>>2]|0,n=z0(f|0,0,j|0,k|0)|0,o=z,o>>>0>e>>>0|(o|0)==(e|0)&n>>>0>d>>>0):0){l=b+604|0;q=(c[l>>2]|0)==0;e=D_(n|0,o|0,d|0,e|0)|0;c[l>>2]=e;j=b+600|0;i=c[j>>2]|0;k=b+544|0;if(q){h=b+608|0;d=c[h>>2]|0;if(i)if(d>>>0<e>>>0){jaa(i);c[j>>2]=0;c[l>>2]=0;c[h>>2]=0;e=0;d=0;u=23}else d=i;else u=23;if((u|0)==23){f=e>>>0>32768?e:32768;d=f>>>0<d>>>0?d:f;c[h>>2]=d;d=iaa(d)|0;c[j>>2]=d;f=c[r>>2]|0}no(d|0,(c[k>>2]|0)+f+(0-e)|0,e|0)|0}else TR(i|0,(c[k>>2]|0)+f+(0-e)|0,e|0)|0;d=c[l>>2]|0;b=t;b=z0((c[r>>2]|0)-d|0,0,c[b>>2]|0,c[b+4>>2]|0)|0;u=t;c[u>>2]=b;c[u+4>>2]=z;c[k>>2]=c[j>>2];c[v>>2]=0;c[r>>2]=d;d=s;c[d>>2]=-1;c[d+4>>2]=-1;d=1;break}jb[c[(c[b>>2]|0)+84>>2]&511](b);if((((a[b+492>>0]|0)==0?(p=b+379|0,(a[p>>0]|0)==0):0)?+g[(c[b+24>>2]|0)+136>>2]<1.0:0)?(RA(b,0,-1)|0)!=0:0){a[(c[m>>2]|0)+((c[l>>2]|0)*24|0)+16>>0]=0;jb[c[(c[b>>2]|0)+108>>2]&511](b);e=s;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!(!((d|0)==-1&(e|0)==-1)?(u=t,v=z0(c[v>>2]|0,0,c[u>>2]|0,c[u+4>>2]|0)|0,u=z,e>>>0>u>>>0|(e|0)==(u|0)&d>>>0>v>>>0):0)){if(!(c[q>>2]&8)){d=0;break}if(a[h>>0]|0){d=0;break}}a[p>>0]=1;d=0}else d=0}else d=0}else d=0}while(0);return d|0}function Wf(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;p=l;l=l+48|0;m=p+36|0;n=p+24|0;o=p+12|0;g=p;TX(m);h=b+528|0;i=b+536|0;j=b+768|0;k=b+784|0;d=g+8+3|0;f=g+4|0;while(1){r=h;t=c[r+4>>2]|0;q=i;s=c[q+4>>2]|0;if(!(t>>>0<s>>>0|((t|0)==(s|0)?(c[r>>2]|0)>>>0<(c[q>>2]|0)>>>0:0)))break;GC(b);s3(b,n);s=h;s=z0(c[s>>2]|0,c[s+4>>2]|0,5,0)|0;t=h;c[t>>2]=s;c[t+4>>2]=z;if((qO(b)|0?(a[j>>0]|0)==2:0)?a[k>>0]|0:0){TX(o);Tv(o,c[n>>2]|0)|0;t=SG(o)|0;s=a[t+8+3>>0]|0;Bs(g,((s<<24>>24<0?c[t+4>>2]|0:s&255)|0)==0?o:t,41840);t=a[d>>0]|0;s=t<<24>>24<0;Ex(m,s?c[g>>2]|0:g,s?c[f>>2]|0:t&255)|0;O0(g);z5(o)}J3(b)}if((qO(b)|0?(a[j>>0]|0)==2:0)?a[k>>0]|0:0){i=b+760|0;h=b+772|0;d=c[(c[(c[i>>2]|0)+80>>2]|0)+(e[h>>1]<<2)>>2]|0;c[d+56>>2]=3;a[d+169>>0]=89;f=a[m+8+3>>0]|0;f=f<<24>>24<0?c[m+4>>2]|0:f&255;if(f){FB(m,f+-3|0,0);d=c[(c[(c[i>>2]|0)+80>>2]|0)+(e[h>>1]<<2)>>2]|0}c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;g=j9(384512)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[n+11>>0]=g;f=n}else{t=g+16&-16;f=ZW(t)|0;c[n>>2]=f;c[n+8>>2]=t|-2147483648;c[n+4>>2]=g}i1(f,384512,g)|0;J7(f+g|0,0);k1(VC(d+28|0,n)|0,m)|0;a1(n);Xy(n,39880);f=c[(c[(c[i>>2]|0)+80>>2]|0)+(e[h>>1]<<2)>>2]|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;g=j9(384476)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[o+11>>0]=g;d=o}else{t=g+16&-16;d=ZW(t)|0;c[o>>2]=d;c[o+8>>2]=t|-2147483648;c[o+4>>2]=g}i1(d,384476,g)|0;J7(d+g|0,0);vF(VC(f+28|0,o)|0,n)|0;a1(o);z5(n);Xy(n,39880);f=c[(c[(c[i>>2]|0)+80>>2]|0)+(e[h>>1]<<2)>>2]|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;g=j9(385582)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[o+11>>0]=g;d=o}else{t=g+16&-16;d=ZW(t)|0;c[o>>2]=d;c[o+8>>2]=t|-2147483648;c[o+4>>2]=g}i1(d,385582,g)|0;J7(d+g|0,0);vF(VC(f+28|0,o)|0,n)|0;a1(o);z5(n)}z5(m);l=p;return}function Xf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=b+612|0;g=b+548|0;e=b+376|0;d=c[k>>2]|0;while(1){f=c[g>>2]|0;if((d+6|0)>>>0>f>>>0){j=7;break}if(!(ng(b)|0)){d=0;break}d=c[k>>2]|0;if(a[e>>0]|0){j=5;break}d=d+1|0;c[k>>2]=d}if((j|0)==5){f=c[g>>2]|0;j=7}a:do if((j|0)==7)if((d+6|0)>>>0>f>>>0){g=b+544|0;if(((d+5|0)==(f|0)?(h=h8((c[g>>2]|0)+d|0)|0,i=z,!((h&-4|0)==-25165316&(i&255|0)==127)):0)?(b=h&-256,j=i&255,!((b|0)==1478501632&(j|0)==100|((h&-16|0)==520153328&(i&255|0)==255|((b|0)==2130804736&(j|0)==254|(h&-9|0)==-1572857&(i&255|0)==31)))):0){d=d+1|0;c[k>>2]=d}b:do if((d+4|0)==(f|0)){e=C9((c[g>>2]|0)+d|0)|0;c:do if((e|0)<536864768)if((e|0)<-14745368)switch(e|0){case -25230976:break b;default:break c}else switch(e|0){case -14745368:break b;default:break c}else{if((e|0)<1683496997)switch(e|0){case 536864768:break b;default:break c}if((e|0)<2147385345)switch(e|0){case 1683496997:break b;default:break c}else switch(e|0){case 2147385345:break b;default:break c}}while(0);d=d+1|0;c[k>>2]=d}while(0);d:do if((d+3|0)==(f|0)){e=(c[g>>2]|0)+d|0;e=R4(a[e>>0]|0,a[e+1>>0]|0,a[e+2>>0]|0)|0;e:do if((e|0)<8388224)if((e|0)<6576160)switch(e|0){case 2097128:break d;default:break e}else switch(e|0){case 6576160:break d;default:break e}else{if((e|0)<16678657)switch(e|0){case 8388224:break d;default:break e}if((e|0)<16719616)switch(e|0){case 16678657:break d;default:break e}else switch(e|0){case 16719616:break d;default:break e}}while(0);d=d+1|0;c[k>>2]=d}while(0);f:do if((d+2|0)==(f|0)){e=(c[g>>2]|0)+d|0;e=d7(a[e>>0]|0,a[e+1>>0]|0)|0;g:do if(e<<16>>16>=8191){if(e<<16>>16<25688)switch(e<<16>>16){case 8191:break f;default:break g}if(e<<16>>16<32766)switch(e<<16>>16){case 25688:break f;default:break g}else switch(e<<16>>16){case 32766:break f;default:break g}}else switch(e<<16>>16){case -225:case -385:break f;default:{}}while(0);d=d+1|0;c[k>>2]=d}while(0);if((d+1|0)==(f|0)){switch((D9(a[(c[g>>2]|0)+d>>0]|0)|0)<<24>>24){case 100:case -1:case 31:case -2:case 127:{d=0;break a}default:{}}c[k>>2]=f;d=0}else d=0}else d=1;while(0);return d|0}function Yf(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;y=l;l=l+32|0;j=y+16|0;f=y+12|0;k=y+20|0;v=y;c[j>>2]=-1;m=d+528|0;i=m;i=z0(c[i>>2]|0,c[i+4>>2]|0,4,0)|0;e=m;c[e>>2]=i;c[e+4>>2]=z;HB(d,k);bD(d,f);GC(d);k=b[k>>1]|0;e=0;while(1){if((e&65535)>=(k&65535))break;GC(d);h=m;h=z0(c[h>>2]|0,c[h+4>>2]|0,4,0)|0;i=m;c[i>>2]=h;c[i+4>>2]=z;J3(d);e=e+1<<16>>16}J3(d);GC(d);i=c[f>>2]|0;h=0;while(1){if((h&65535)>>>0>=i>>>0)break;GC(d);bD(d,v);g=m;g=z0(c[g>>2]|0,c[g+4>>2]|0,2,0)|0;e=m;c[e>>2]=g;c[e+4>>2]=z;GC(d);e=0;while(1){if((e&65535)>=(k&65535))break;f=m;f=z0(c[f>>2]|0,c[f+4>>2]|0,8,0)|0;g=m;c[g>>2]=f;c[g+4>>2]=z;e=e+1<<16>>16}J3(d);GC(d);g=c[v>>2]|0;e=0;while(1){if((e|0)==(g|0))break;GC(d);if((c[j>>2]|0)==-1){bD(d,j);f=0}else{A=m;A=z0(c[A>>2]|0,c[A+4>>2]|0,4,0)|0;f=m;c[f>>2]=A;c[f+4>>2]=z;f=0}while(1){if((f&65535)>=(k&65535))break;B=m;B=z0(c[B>>2]|0,c[B+4>>2]|0,4,0)|0;A=m;c[A>>2]=B;c[A+4>>2]=z;f=f+1<<16>>16}J3(d);e=e+1|0}J3(d);J3(d);h=h+1<<16>>16}J3(d);if(((qO(d)|0?(Kc(d,4,-1)|0,w=d+20|0,RB(d,4,c[w>>2]|0,18,380054,-1,1,0),RB(d,4,c[w>>2]|0,19,380064,-1,1,0),n=c[j>>2]|0,(n|0)!=-1):0)?(x=n>>>28,o=n>>>20&15,p=n>>>16&15,q=n>>>12&15,r=n>>>8&15,s=n>>>4&15,t=n&15,n>>>0<2684354560):0)?(u=n>>>24&15,t>>>0<10&(s>>>0<10&(r>>>0<10&(q>>>0<10&(p>>>0<10&(u>>>0<10&o>>>0<10)))))):0){c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[v+(e<<2)>>2]=0;e=e+1|0}gy(v,(x|48)&255);gy(v,(u|48)&255);gy(v,58);gy(v,(o|48)&255);gy(v,(p|48)&255);gy(v,58);gy(v,(q|48)&255);gy(v,(r|48)&255);gy(v,58);gy(v,(s|48)&255);gy(v,(t|48)&255);RB(d,4,c[w>>2]|0,91,(a[v+11>>0]|0)<0?c[v>>2]|0:v,-1,1,0);a1(v)}l=y;return}function Zf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=c[a>>2]|0;do if(g){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=raa(c[h>>2]|0)|0;if(d8(g,-1)|0){c[a>>2]=0;h=1;break}else{h=(c[a>>2]|0)==0;break}}else h=1;while(0);if(b){g=c[b+12>>2]|0;if((g|0)==(c[b+16>>2]|0))g=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0;else g=raa(c[g>>2]|0)|0;if(!(d8(g,-1)|0))if(h){j=b;p=16}else p=15;else p=13}else p=13;if((p|0)==13)if(h)p=15;else{j=0;p=16}a:do if((p|0)==15){c[d>>2]=c[d>>2]|6;g=0}else if((p|0)==16){g=c[a>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=raa(c[h>>2]|0)|0;if(!(gb[c[(c[e>>2]|0)+12>>2]&31](e,2048,g)|0)){c[d>>2]=c[d>>2]|4;g=0;break}g=(gb[c[(c[e>>2]|0)+52>>2]&31](e,g,0)|0)<<24>>24;h=c[a>>2]|0;b=h+12|0;i=c[b>>2]|0;if((i|0)==(c[h+16>>2]|0)){nb[c[(c[h>>2]|0)+40>>2]&255](h)|0;m=f;k=j;i=j}else{c[b>>2]=i+4;m=f;k=j;i=j}while(1){g=g+-48|0;o=m+-1|0;h=c[a>>2]|0;do if(h){b=c[h+12>>2]|0;if((b|0)==(c[h+16>>2]|0))h=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else h=raa(c[b>>2]|0)|0;if(d8(h,-1)|0){c[a>>2]=0;f=1;break}else{f=(c[a>>2]|0)==0;break}}else f=1;while(0);if(!i){n=k;l=0;h=1}else{h=c[i+12>>2]|0;if((h|0)==(c[i+16>>2]|0))h=nb[c[(c[i>>2]|0)+36>>2]&255](i)|0;else h=raa(c[h>>2]|0)|0;h=d8(h,-1)|0;n=h?0:k;l=h?0:k;h=h|(k|0)==0}j=c[a>>2]|0;b=j+12|0;i=j+16|0;if(!((m|0)>1&(f^h)))break;h=c[b>>2]|0;if((h|0)==(c[i>>2]|0))h=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else h=raa(c[h>>2]|0)|0;if(!(gb[c[(c[e>>2]|0)+12>>2]&31](e,2048,h)|0))break a;g=((gb[c[(c[e>>2]|0)+52>>2]&31](e,h,0)|0)<<24>>24)+(g*10|0)|0;h=c[a>>2]|0;b=h+12|0;i=c[b>>2]|0;if((i|0)==(c[h+16>>2]|0)){nb[c[(c[h>>2]|0)+40>>2]&255](h)|0;m=o;k=n;i=l;continue}else{c[b>>2]=i+4;m=o;k=n;i=l;continue}}do if(j){h=c[b>>2]|0;if((h|0)==(c[i>>2]|0))h=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else h=raa(c[h>>2]|0)|0;if(d8(h,-1)|0){c[a>>2]=0;b=1;break}else{b=(c[a>>2]|0)==0;break}}else b=1;while(0);if(n){h=c[n+12>>2]|0;if((h|0)==(c[n+16>>2]|0))h=nb[c[(c[n>>2]|0)+36>>2]&255](n)|0;else h=raa(c[h>>2]|0)|0;if(!(d8(h,-1)|0)){if(b)break}else p=56}else p=56;if((p|0)==56?!b:0)break;c[d>>2]=c[d>>2]|2}while(0);return g|0}function _f(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=l;l=l+240|0;v=E+200|0;i=E+199|0;j=E+198|0;B=E+184|0;C=E+172|0;z=E+168|0;A=E+8|0;w=E+4|0;x=E;y=E+197|0;u=E+196|0;Yz(B,e,v,i,j);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[C+(e<<2)>>2]=0;e=e+1|0}s=C+11|0;t=C+8|0;if((a[s>>0]|0)<0)e=(c[t>>2]&2147483647)+-1|0;else e=10;CC(C,e);k=(a[s>>0]|0)<0?c[C>>2]|0:C;c[z>>2]=k;c[w>>2]=A;c[x>>2]=0;a[y>>0]=1;a[u>>0]=69;r=C+4|0;q=a[i>>0]|0;p=a[j>>0]|0;j=k;k=b;i=b;while(1){if(!k){o=0;b=0;k=1}else{e=c[k+12>>2]|0;if((e|0)==(c[k+16>>2]|0))e=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else e=e9(a[e>>0]|0)|0;n=d8(e,-1)|0;o=n?0:k;i=n?0:i;b=n?0:b;k=n}n=o+16|0;m=o+12|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!k)break}else D=17}else D=17;if((D|0)==17){D=0;if(k){d=0;break}else d=0}k=a[s>>0]|0;k=k<<24>>24<0?c[r>>2]|0:k&255;if((c[z>>2]|0)==(j+k|0)){CC(C,k<<1);if((a[s>>0]|0)<0)e=(c[t>>2]&2147483647)+-1|0;else e=10;CC(C,e);j=(a[s>>0]|0)<0?c[C>>2]|0:C;c[z>>2]=j+k}e=c[m>>2]|0;if((e|0)==(c[n>>2]|0))e=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else e=e9(a[e>>0]|0)|0;if(Ej(e&255,y,u,j,z,q,p,B,A,w,x,v)|0)break;e=c[m>>2]|0;if((e|0)==(c[n>>2]|0)){nb[c[(c[o>>2]|0)+40>>2]&255](o)|0;k=o;continue}else{c[m>>2]=e+1;k=o;continue}}v=a[B+11>>0]|0;e=c[w>>2]|0;if(!((a[y>>0]|0)==0?1:((v<<24>>24<0?c[B+4>>2]|0:v&255)|0)==0)?(e-A|0)<160:0){x=c[x>>2]|0;y=e+4|0;c[w>>2]=y;c[e>>2]=x;e=y}g[h>>2]=+eF(j,c[z>>2]|0,f);Vs(B,A,e,f);if(!o)j=1;else{e=c[m>>2]|0;if((e|0)==(c[n>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](o)|0;else e=e9(a[e>>0]|0)|0;j=d8(e,-1)|0;i=j?0:i}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!j)D=45}else D=43}else D=43;if((D|0)==43?j:0)D=45;if((D|0)==45)c[f>>2]=c[f>>2]|2;a1(C);a1(B);l=E;return i|0}function $f(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=l;l=l+240|0;v=E+200|0;i=E+199|0;j=E+198|0;B=E+184|0;C=E+172|0;z=E+168|0;A=E+8|0;w=E+4|0;x=E;y=E+197|0;u=E+196|0;Yz(B,e,v,i,j);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[C+(e<<2)>>2]=0;e=e+1|0}s=C+11|0;t=C+8|0;if((a[s>>0]|0)<0)e=(c[t>>2]&2147483647)+-1|0;else e=10;CC(C,e);k=(a[s>>0]|0)<0?c[C>>2]|0:C;c[z>>2]=k;c[w>>2]=A;c[x>>2]=0;a[y>>0]=1;a[u>>0]=69;r=C+4|0;q=a[i>>0]|0;p=a[j>>0]|0;j=k;k=b;i=b;while(1){if(!k){o=0;b=0;k=1}else{e=c[k+12>>2]|0;if((e|0)==(c[k+16>>2]|0))e=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else e=e9(a[e>>0]|0)|0;n=d8(e,-1)|0;o=n?0:k;i=n?0:i;b=n?0:b;k=n}n=o+16|0;m=o+12|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!k)break}else D=17}else D=17;if((D|0)==17){D=0;if(k){d=0;break}else d=0}k=a[s>>0]|0;k=k<<24>>24<0?c[r>>2]|0:k&255;if((c[z>>2]|0)==(j+k|0)){CC(C,k<<1);if((a[s>>0]|0)<0)e=(c[t>>2]&2147483647)+-1|0;else e=10;CC(C,e);j=(a[s>>0]|0)<0?c[C>>2]|0:C;c[z>>2]=j+k}e=c[m>>2]|0;if((e|0)==(c[n>>2]|0))e=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else e=e9(a[e>>0]|0)|0;if(Ej(e&255,y,u,j,z,q,p,B,A,w,x,v)|0)break;e=c[m>>2]|0;if((e|0)==(c[n>>2]|0)){nb[c[(c[o>>2]|0)+40>>2]&255](o)|0;k=o;continue}else{c[m>>2]=e+1;k=o;continue}}v=a[B+11>>0]|0;e=c[w>>2]|0;if(!((a[y>>0]|0)==0?1:((v<<24>>24<0?c[B+4>>2]|0:v&255)|0)==0)?(e-A|0)<160:0){x=c[x>>2]|0;y=e+4|0;c[w>>2]=y;c[e>>2]=x;e=y}h[g>>3]=+dF(j,c[z>>2]|0,f);Vs(B,A,e,f);if(!o)j=1;else{e=c[m>>2]|0;if((e|0)==(c[n>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](o)|0;else e=e9(a[e>>0]|0)|0;j=d8(e,-1)|0;i=j?0:i}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!j)D=45}else D=43}else D=43;if((D|0)==43?j:0)D=45;if((D|0)==45)c[f>>2]=c[f>>2]|2;a1(C);a1(B);l=E;return i|0}function ag(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=l;l=l+240|0;v=E+200|0;i=E+199|0;j=E+198|0;B=E+184|0;C=E+172|0;z=E+168|0;A=E+8|0;w=E+4|0;x=E;y=E+197|0;u=E+196|0;Yz(B,e,v,i,j);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[C+(e<<2)>>2]=0;e=e+1|0}s=C+11|0;t=C+8|0;if((a[s>>0]|0)<0)e=(c[t>>2]&2147483647)+-1|0;else e=10;CC(C,e);k=(a[s>>0]|0)<0?c[C>>2]|0:C;c[z>>2]=k;c[w>>2]=A;c[x>>2]=0;a[y>>0]=1;a[u>>0]=69;r=C+4|0;q=a[i>>0]|0;p=a[j>>0]|0;j=k;k=b;i=b;while(1){if(!k){o=0;b=0;k=1}else{e=c[k+12>>2]|0;if((e|0)==(c[k+16>>2]|0))e=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else e=e9(a[e>>0]|0)|0;n=d8(e,-1)|0;o=n?0:k;i=n?0:i;b=n?0:b;k=n}n=o+16|0;m=o+12|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!k)break}else D=17}else D=17;if((D|0)==17){D=0;if(k){d=0;break}else d=0}k=a[s>>0]|0;k=k<<24>>24<0?c[r>>2]|0:k&255;if((c[z>>2]|0)==(j+k|0)){CC(C,k<<1);if((a[s>>0]|0)<0)e=(c[t>>2]&2147483647)+-1|0;else e=10;CC(C,e);j=(a[s>>0]|0)<0?c[C>>2]|0:C;c[z>>2]=j+k}e=c[m>>2]|0;if((e|0)==(c[n>>2]|0))e=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else e=e9(a[e>>0]|0)|0;if(Ej(e&255,y,u,j,z,q,p,B,A,w,x,v)|0)break;e=c[m>>2]|0;if((e|0)==(c[n>>2]|0)){nb[c[(c[o>>2]|0)+40>>2]&255](o)|0;k=o;continue}else{c[m>>2]=e+1;k=o;continue}}v=a[B+11>>0]|0;e=c[w>>2]|0;if(!((a[y>>0]|0)==0?1:((v<<24>>24<0?c[B+4>>2]|0:v&255)|0)==0)?(e-A|0)<160:0){x=c[x>>2]|0;y=e+4|0;c[w>>2]=y;c[e>>2]=x;e=y}h[g>>3]=+fF(j,c[z>>2]|0,f);Vs(B,A,e,f);if(!o)j=1;else{e=c[m>>2]|0;if((e|0)==(c[n>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](o)|0;else e=e9(a[e>>0]|0)|0;j=d8(e,-1)|0;i=j?0:i}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!j)D=45}else D=43}else D=43;if((D|0)==43?j:0)D=45;if((D|0)==45)c[f>>2]=c[f>>2]|2;a1(C);a1(B);l=E;return i|0}function bg(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;p=l;l=l+16|0;i=p+8|0;n=p;o=d+528|0;f=o;g=c[f>>2]|0;f=c[f+4>>2]|0;j=z0(g|0,f|0,1,0)|0;q=z;m=d+536|0;k=m;h=c[k+4>>2]|0;do if(q>>>0>h>>>0|((q|0)==(h|0)?j>>>0>(c[k>>2]|0)>>>0:0)){vt(d);q=e;c[q>>2]=0;c[q+4>>2]=0}else{q=c[d+544>>2]|0;k=d+612|0;f=z0(c[k>>2]|0,0,g|0,f|0)|0;if((a[q+f>>0]|0)==-1){m=d+40|0;q=d+48|0;n=c[q>>2]|0;q=c[q+4>>2]|0;m=D_(c[m>>2]|0,c[m+4>>2]|0,f|0,z|0)|0;q=D_(m|0,z|0,n|0,q|0)|0;n=e;c[n>>2]=q;c[n+4>>2]=z;n=o;n=z0(c[n>>2]|0,c[n+4>>2]|0,1,0)|0;q=o;c[q>>2]=n;c[q+4>>2]=z;break}a[i>>0]=0;Bx(d);f=d+648|0;j=0;g=0;while(1){h=c[(c[f>>2]|0)+4>>2]|0;if(g<<24>>24)break;if(!((j&255)<9&(raa(h)|0)!=0))break;g=j+1<<24>>24;qR(d,g,i);j=g;g=a[i>>0]|0}f=(j&255)>8;do if(f|(raa(h)|0)==0){if(f)t4(d);q=e;c[q>>2]=0;c[q+4>>2]=0}else{wK(d);f=d+48|0;k=z0(c[k>>2]|0,0,c[f>>2]|0,c[f+4>>2]|0)|0;f=o;h=c[f>>2]|0;f=c[f+4>>2]|0;k=z0(k|0,z|0,h|0,f|0)|0;g=z;q=(c[d+668>>2]|0)+((c[d+508>>2]|0)*24|0)+8|0;i=c[q+4>>2]|0;if(!(g>>>0<i>>>0|((g|0)==(i|0)?k>>>0<(c[q>>2]|0)>>>0:0))){t4(d);q=e;c[q>>2]=0;c[q+4>>2]=0;break}g=j&255;k=z0(h|0,f|0,g|0,0)|0;i=z;q=m;m=c[q+4>>2]|0;if(i>>>0>m>>>0|((i|0)==(m|0)?k>>>0>(c[q>>2]|0)>>>0:0)){vt(d);q=e;c[q>>2]=0;c[q+4>>2]=0;break}switch(j<<24>>24){case 1:{EG(d,n);q=e;c[q>>2]=a[n>>0]&127;c[q+4>>2]=0;break}case 2:{yE(d,n);q=e;c[q>>2]=b[n>>1]&16383;c[q+4>>2]=0;break}case 3:{vD(d,n);q=e;c[q>>2]=c[n>>2]&2097151;c[q+4>>2]=0;break}case 4:{aH(d,n);q=e;c[q>>2]=c[n>>2]&268435455;c[q+4>>2]=0;break}case 5:{YD(d,n);m=n;n=c[m+4>>2]&7;q=e;c[q>>2]=c[m>>2];c[q+4>>2]=n;break}case 6:{XD(d,n);m=n;n=c[m+4>>2]&1023;q=e;c[q>>2]=c[m>>2];c[q+4>>2]=n;break}case 7:{WD(d,n);m=n;n=c[m+4>>2]&131071;q=e;c[q>>2]=c[m>>2];c[q+4>>2]=n;break}case 8:{zE(d,n);m=n;n=c[m+4>>2]&16777215;q=e;c[q>>2]=c[m>>2];c[q+4>>2]=n;break}default:{}}n=o;n=z0(c[n>>2]|0,c[n+4>>2]|0,g|0,0)|0;q=o;c[q>>2]=n;c[q+4>>2]=z}while(0)}while(0);l=p;return}function cg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;C=l;l=l+224|0;s=C+198|0;i=C+196|0;y=C+184|0;A=C+172|0;w=C+168|0;x=C+8|0;v=C+4|0;u=C;h=c[e+4>>2]|0;zC(y,e,s,i);c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[A+(e<<2)>>2]=0;e=e+1|0}t=FX(h)|0;q=A+11|0;r=A+8|0;if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(A,e);j=(a[q>>0]|0)<0?c[A>>2]|0:A;c[w>>2]=j;c[v>>2]=x;c[u>>2]=0;p=A+4|0;o=a[i>>0]|0;i=j;j=b;h=b;while(1){if(!j){n=0;b=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0))e=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else e=e9(a[e>>0]|0)|0;m=d8(e,-1)|0;n=m?0:j;h=m?0:h;b=m?0:b;j=m}k=n+12|0;m=n+16|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!j)break}else B=17}else B=17;if((B|0)==17){B=0;if(j){d=0;break}else d=0}j=a[q>>0]|0;j=j<<24>>24<0?c[p>>2]|0:j&255;if((c[w>>2]|0)==(i+j|0)){CC(A,j<<1);if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(A,e);i=(a[q>>0]|0)<0?c[A>>2]|0:A;c[w>>2]=i+j}e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[n>>2]|0)+36>>2]&255](n)|0;else e=e9(a[e>>0]|0)|0;if($l(e&255,t,i,w,u,o,y,x,v,s)|0)break;e=c[k>>2]|0;if((e|0)==(c[m>>2]|0)){nb[c[(c[n>>2]|0)+40>>2]&255](n)|0;j=n;continue}else{c[k>>2]=e+1;j=n;continue}}s=a[y+11>>0]|0;e=c[v>>2]|0;if(((s<<24>>24<0?c[y+4>>2]|0:s&255)|0)!=0?(e-x|0)<160:0){s=c[u>>2]|0;u=e+4|0;c[v>>2]=u;c[e>>2]=s;e=u}v=oy(i,c[w>>2]|0,f,t)|0;w=g;c[w>>2]=v;c[w+4>>2]=z;Vs(y,x,e,f);if(!n)i=1;else{e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](n)|0;else e=e9(a[e>>0]|0)|0;i=d8(e,-1)|0;h=i?0:h}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!i)B=45}else B=43}else B=43;if((B|0)==43?i:0)B=45;if((B|0)==45)c[f>>2]=c[f>>2]|2;a1(A);a1(y);l=C;return h|0}function dg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;C=l;l=l+224|0;s=C+198|0;i=C+196|0;y=C+184|0;A=C+172|0;w=C+168|0;x=C+8|0;v=C+4|0;u=C;h=c[e+4>>2]|0;zC(y,e,s,i);c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[A+(e<<2)>>2]=0;e=e+1|0}t=FX(h)|0;q=A+11|0;r=A+8|0;if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(A,e);j=(a[q>>0]|0)<0?c[A>>2]|0:A;c[w>>2]=j;c[v>>2]=x;c[u>>2]=0;p=A+4|0;o=a[i>>0]|0;i=j;j=b;h=b;while(1){if(!j){n=0;b=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0))e=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else e=e9(a[e>>0]|0)|0;m=d8(e,-1)|0;n=m?0:j;h=m?0:h;b=m?0:b;j=m}k=n+12|0;m=n+16|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!j)break}else B=17}else B=17;if((B|0)==17){B=0;if(j){d=0;break}else d=0}j=a[q>>0]|0;j=j<<24>>24<0?c[p>>2]|0:j&255;if((c[w>>2]|0)==(i+j|0)){CC(A,j<<1);if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(A,e);i=(a[q>>0]|0)<0?c[A>>2]|0:A;c[w>>2]=i+j}e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[n>>2]|0)+36>>2]&255](n)|0;else e=e9(a[e>>0]|0)|0;if($l(e&255,t,i,w,u,o,y,x,v,s)|0)break;e=c[k>>2]|0;if((e|0)==(c[m>>2]|0)){nb[c[(c[n>>2]|0)+40>>2]&255](n)|0;j=n;continue}else{c[k>>2]=e+1;j=n;continue}}s=a[y+11>>0]|0;e=c[v>>2]|0;if(((s<<24>>24<0?c[y+4>>2]|0:s&255)|0)!=0?(e-x|0)<160:0){s=c[u>>2]|0;u=e+4|0;c[v>>2]=u;c[e>>2]=s;e=u}v=yz(i,c[w>>2]|0,f,t)|0;w=g;c[w>>2]=v;c[w+4>>2]=z;Vs(y,x,e,f);if(!n)i=1;else{e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](n)|0;else e=e9(a[e>>0]|0)|0;i=d8(e,-1)|0;h=i?0:h}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!i)B=45}else B=43}else B=43;if((B|0)==43?i:0)B=45;if((B|0)==45)c[f>>2]=c[f>>2]|2;a1(A);a1(y);l=C;return h|0}function eg(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+16|0;m=s;k=b+760|0;p=b+785|0;o=b+788|0;n=b+528|0;if((a[k>>0]|0)==0?(a[p>>0]=0,c[o>>2]=0,!(rf(b)|0)):0){q=b+536|0;r=n;r=D_(c[q>>2]|0,c[q+4>>2]|0,c[r>>2]|0,c[r+4>>2]|0)|0;e1(b,r,z)}else{f=a[p>>0]|0;q=b+816|0;e=c[q>>2]|0;r=b+795|0;a:do if(!(c[e+((f&255)*120|0)+104>>2]|0)){do if(a[k>>0]|0){f=b+793|0;g=b+797|0;h=b+798|0;i=b+796|0;j=b+794|0;if((a[f>>0]|0)==-1?(a[j>>0]|0)==-1:0){a[f>>0]=0;a[j>>0]=0;a[r>>0]=1;a[i>>0]=0;a[g>>0]=0;a[h>>0]=0;a[p>>0]=0;c[o>>2]=0;a[e+12>>0]=a[b+761>>0]|0;break}if(!(a[b+492>>0]|0)){a[f>>0]=255;a[f+1>>0]=255;a[f+2>>0]=255;a[f+3>>0]=255;a[f+4>>0]=255;a[f+5>>0]=255;a[k>>0]=0}}while(0);if((c[b+728>>2]&1|0)==0?(W5(b),(a[b+492>>0]|0)==0):0)RB(b,0,0,57,378150,-1,1,0);e=(c[b+804>>2]|0)+((d[b+840>>0]|0)*120|0)+104|0;c[e>>2]=(c[e>>2]|0)+1;e=d[p>>0]|0;f=c[q>>2]|0;g=f+(e*120|0)+104|0;c[g>>2]=(c[g>>2]|0)+1;a[f+(e*120|0)+116>>0]=1;a[f+(e*120|0)+117>>0]=1;a[f+(e*120|0)+118>>0]=1;g=b+880|0;h=c[g>>2]|0;c[f+(e*120|0)+112>>2]=h;c[g>>2]=h+1;g=$e(b)|0;c[m>>2]=g;h=f+(e*120|0)+32|0;i=c[h>>2]|0;if(i>>>0<(c[f+(e*120|0)+36>>2]|0)>>>0){c[i>>2]=g;c[h>>2]=(c[h>>2]|0)+4}else Yy(f+(e*120|0)+28|0,m);g=d[p>>0]|0;h=c[q>>2]|0;i=h+(g*120|0)+28|0;j=h+(g*120|0)+32|0;e=c[j>>2]|0;k=c[i>>2]|0;f=k;if(!(c[f+((e-k>>2)+-1<<2)>>2]|0)){while(1){if((e|0)==(f|0))break;k=e+-4|0;c[j>>2]=k;e=k}e=D3()|0;c[m>>2]=e;f=c[j>>2]|0;if(f>>>0<(c[h+(g*120|0)+36>>2]|0)>>>0){c[f>>2]=e;c[j>>2]=(c[j>>2]|0)+4}else Yy(i,m);e=d[p>>0]|0;f=c[q>>2]|0;g=B3()|0;c[m>>2]=g;h=f+(e*120|0)+32|0;i=c[h>>2]|0;if(i>>>0<(c[f+(e*120|0)+36>>2]|0)>>>0){c[i>>2]=g;c[h>>2]=(c[h>>2]|0)+4}else Yy(f+(e*120|0)+28|0,m)}h=b+734|0;g=0;while(1){f=a[p>>0]|0;m=f&255;e=c[q>>2]|0;i=c[e+(m*120|0)+28>>2]|0;if(g>>>0>=(c[e+(m*120|0)+32>>2]|0)-i>>2>>>0)break a;m=c[i+(g<<2)>>2]|0;a[m+734>>0]=a[h>>0]|0;aY(b,m);g=g+1|0}}while(0);i=n;h=c[i>>2]|0;i=c[i+4>>2]|0;g=c[o>>2]|0;if(0>i>>>0|0==(i|0)&g>>>0>h>>>0){f=D_(g|0,0,h|0,i|0)|0;e1(b,f,z);f=a[p>>0]|0;e=c[q>>2]|0}ee(b,e+((f&255)*120|0)|0,r)}l=s;return}function fg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+16|0;g=m;k=b+528|0;d=k;d=z0(c[d>>2]|0,c[d+4>>2]|0,8,0)|0;h=k;c[h>>2]=d;c[h+4>>2]=z;h=b+16|0;d=c[h>>2]|0;i=b+520|0;j=b+20|0;if((d|0)==4){d=i;if((c[d>>2]|0)==1635148593&(c[d+4>>2]|0)==0){xd(b,4,c[j>>2]|0);Kc(b,1,-1)|0;d=c[h>>2]|0;f=b+916|0;e=b+788|0;c[(bF(f,e)|0)+44>>2]=d;d=c[j>>2]|0;c[(bF(f,e)|0)+48>>2]=d;xM(b,1,c[j>>2]|0,377340,382808,0);e=c[h>>2]|0;f=4}}else{e=d;f=4}if(((f|0)==4?(e|0)==1:0)?(f=i,(c[f>>2]|0)==1333158505&(c[f+4>>2]|0)==0):0){xd(b,1,c[j>>2]|0);Kc(b,4,-1)|0;d=c[h>>2]|0;e=b+916|0;f=b+788|0;c[(bF(e,f)|0)+44>>2]=d;d=c[j>>2]|0;c[(bF(e,f)|0)+48>>2]=d}if(qO(b)|0){d=c[h>>2]|0;e=b+788|0;f=b+916|0;if((d|0)==7){n=i;d=c[n+4>>2]|0;switch(c[n>>2]|0){case 1836069985:{if(!d)Kc(b,2,-1)|0;break}case 1836070003:{if(!d)Kc(b,4,-1)|0;break}case 1836070006:{if(!d)Kc(b,1,-1)|0;break}default:{}}d=c[h>>2]|0;c[(bF(f,e)|0)+44>>2]=d;d=c[j>>2]|0;c[(bF(f,e)|0)+48>>2]=d;d=c[h>>2]|0}a:do switch(d|0){case 1:{lc(b);break}case 2:{Dc(b);break}case 3:{sk(b);break}default:{TX(g);Rf(b,lh(g,c[i>>2]|0)|0,c[h>>2]|0,c[j>>2]|0,1);z5(g);n=i;if((c[n>>2]|0)==1836070003&(c[n+4>>2]|0)==0){$I(b);break a}else{i=HN(b,0)|0;n=k;n=D_(i|0,z|0,c[n>>2]|0,c[n+4>>2]|0)|0;e1(b,n,z);break a}}}while(0);if(!(J1(c[b+508>>2]|0,c[b+668>>2]|0)|0)){n=bF(f,e)|0;if(((c[n+16>>2]|0)-(c[n+12>>2]|0)|0)==4?(gq(g,b,c[h>>2]|0,c[j>>2]|0,380114),n=a[g+8+3>>0]|0,n=((n<<24>>24<0?c[g+4>>2]|0:n&255)|0)==0,z5(g),!n):0)G2(b,c[c[(bF(f,e)|0)+12>>2]>>2]|0);n=b+784|0;c[n>>2]=(c[n>>2]|0)+1}}l=m;return}function gg(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+112|0;g=s+96|0;h=s+102|0;f=s+101|0;e=s+100|0;n=s+84|0;o=s+72|0;p=s+60|0;q=s+48|0;r=s+36|0;i=s+24|0;k=s+12|0;m=s;r3(b,g);bB(b,h);bB(b,f);bB(b,e);if((c[b+784>>2]|0)>>>0<=1){TX(n);e=a[e>>0]|0;if(!(e<<24>>24)){Xy(o,24404);vF(n,o)|0;z5(o)}else Ck(n,e,10)|0;Gx(n,64);ST(o,+(d[f>>0]|0)/10.0,1);j=a[o+8+3>>0]|0;f=j<<24>>24<0;Ex(n,f?c[o>>2]|0:o,f?c[o+4>>2]|0:j&255)|0;z5(o);j=b+20|0;zb(b,1,c[j>>2]|0,24,n,0);f=c[j>>2]|0;Yo(o,c[g>>2]|0);zb(b,1,f,303,o,0);z5(o);f=a[h>>0]|0;mL(b,1,c[j>>2]|0,304,f,10,0);g=c[j>>2]|0;$x(r,b,1,g,303,1);Gx(r,32);c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];e=0;while(1){if((e|0)==3)break;c[r+(e<<2)>>2]=0;e=e+1|0}uU(i,f,10);e=a[i+8+3>>0]|0;h=e<<24>>24<0;Ex(q,h?c[i>>2]|0:i,h?c[i+4>>2]|0:e&255)|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];e=0;while(1){if((e|0)==3)break;c[q+(e<<2)>>2]=0;e=e+1|0}p2(o,p);zb(b,1,g,300,o,0);z5(o);O0(p);z5(i);O0(q);z5(r);$x(q,b,1,c[j>>2]|0,303,1);a:do if(!(f<<24>>24)){TX(m);c[r>>2]=c[m>>2];c[r+4>>2]=c[m+4>>2];c[r+8>>2]=c[m+8>>2];e=0;while(1){if((e|0)==3){f=1;g=0;break a}c[m+(e<<2)>>2]=0;e=e+1|0}}else{uU(k,f,10);DW(k,0,24340)|0;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];c[r+8>>2]=c[k+8>>2];e=0;while(1){if((e|0)==3){f=0;g=1;break a}c[k+(e<<2)>>2]=0;e=e+1|0}}while(0);e=a[r+8+3>>0]|0;i=e<<24>>24<0;Ex(q,i?c[r>>2]|0:r,i?c[r+4>>2]|0:e&255)|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];e=0;while(1){if((e|0)==3)break;c[q+(e<<2)>>2]=0;e=e+1|0}p2(o,p);O0(p);O0(r);if(f)z5(m);if(g)z5(k);z5(q);zb(b,1,c[j>>2]|0,301,o,1);z5(o);z5(n)}l=s;return}function hg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;j=l;l=l+32|0;h=j;i=Ph(a,b,d,e,g)|0;if(tb[c[g>>2]&31](f,e)|0){c[h>>2]=c[e>>2];c[h+4>>2]=c[e+4>>2];c[h+8>>2]=c[e+8>>2];c[h+12>>2]=c[e+12>>2];c[h+16>>2]=c[e+16>>2];c[h+20>>2]=c[e+20>>2];c[h+24>>2]=c[e+24>>2];c[h+28>>2]=c[e+28>>2];c[e>>2]=c[f>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];c[f>>2]=c[h>>2];c[f+4>>2]=c[h+4>>2];c[f+8>>2]=c[h+8>>2];c[f+12>>2]=c[h+12>>2];c[f+16>>2]=c[h+16>>2];c[f+20>>2]=c[h+20>>2];c[f+24>>2]=c[h+24>>2];c[f+28>>2]=c[h+28>>2];f=i+1|0;if(tb[c[g>>2]&31](e,d)|0){c[h>>2]=c[d>>2];c[h+4>>2]=c[d+4>>2];c[h+8>>2]=c[d+8>>2];c[h+12>>2]=c[d+12>>2];c[h+16>>2]=c[d+16>>2];c[h+20>>2]=c[d+20>>2];c[h+24>>2]=c[d+24>>2];c[h+28>>2]=c[d+28>>2];c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];c[d+28>>2]=c[e+28>>2];c[e>>2]=c[h>>2];c[e+4>>2]=c[h+4>>2];c[e+8>>2]=c[h+8>>2];c[e+12>>2]=c[h+12>>2];c[e+16>>2]=c[h+16>>2];c[e+20>>2]=c[h+20>>2];c[e+24>>2]=c[h+24>>2];c[e+28>>2]=c[h+28>>2];f=i+2|0;if(tb[c[g>>2]&31](d,b)|0){c[h>>2]=c[b>>2];c[h+4>>2]=c[b+4>>2];c[h+8>>2]=c[b+8>>2];c[h+12>>2]=c[b+12>>2];c[h+16>>2]=c[b+16>>2];c[h+20>>2]=c[b+20>>2];c[h+24>>2]=c[b+24>>2];c[h+28>>2]=c[b+28>>2];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];c[d>>2]=c[h>>2];c[d+4>>2]=c[h+4>>2];c[d+8>>2]=c[h+8>>2];c[d+12>>2]=c[h+12>>2];c[d+16>>2]=c[h+16>>2];c[d+20>>2]=c[h+20>>2];c[d+24>>2]=c[h+24>>2];c[d+28>>2]=c[h+28>>2];if(tb[c[g>>2]&31](b,a)|0){c[h>>2]=c[a>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];c[h+16>>2]=c[a+16>>2];c[h+20>>2]=c[a+20>>2];c[h+24>>2]=c[a+24>>2];c[h+28>>2]=c[a+28>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];c[b>>2]=c[h>>2];c[b+4>>2]=c[h+4>>2];c[b+8>>2]=c[h+8>>2];c[b+12>>2]=c[h+12>>2];c[b+16>>2]=c[h+16>>2];c[b+20>>2]=c[h+20>>2];c[b+24>>2]=c[h+24>>2];c[b+28>>2]=c[h+28>>2];f=i+4|0}else f=i+3|0}}}else f=i;l=j;return f|0}function ig(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=l;l=l+224|0;t=C+198|0;j=C+196|0;z=C+184|0;A=C+172|0;x=C+168|0;y=C+8|0;w=C+4|0;v=C;i=c[f+4>>2]|0;zC(z,f,t,j);c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[A+(f<<2)>>2]=0;f=f+1|0}u=FX(i)|0;r=A+11|0;s=A+8|0;if((a[r>>0]|0)<0)f=(c[s>>2]&2147483647)+-1|0;else f=10;CC(A,f);k=(a[r>>0]|0)<0?c[A>>2]|0:A;c[x>>2]=k;c[w>>2]=y;c[v>>2]=0;q=A+4|0;p=a[j>>0]|0;j=k;k=d;i=d;while(1){if(!k){o=0;d=0;k=1}else{f=c[k+12>>2]|0;if((f|0)==(c[k+16>>2]|0))f=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else f=e9(a[f>>0]|0)|0;n=d8(f,-1)|0;o=n?0:k;i=n?0:i;d=n?0:d;k=n}m=o+12|0;n=o+16|0;if(e){f=c[e+12>>2]|0;if((f|0)==(c[e+16>>2]|0))f=nb[c[(c[e>>2]|0)+36>>2]&255](e)|0;else f=e9(a[f>>0]|0)|0;if(!(d8(f,-1)|0)){if(!k)break}else B=17}else B=17;if((B|0)==17){B=0;if(k){e=0;break}else e=0}k=a[r>>0]|0;k=k<<24>>24<0?c[q>>2]|0:k&255;if((c[x>>2]|0)==(j+k|0)){CC(A,k<<1);if((a[r>>0]|0)<0)f=(c[s>>2]&2147483647)+-1|0;else f=10;CC(A,f);j=(a[r>>0]|0)<0?c[A>>2]|0:A;c[x>>2]=j+k}f=c[m>>2]|0;if((f|0)==(c[n>>2]|0))f=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else f=e9(a[f>>0]|0)|0;if($l(f&255,u,j,x,v,p,z,y,w,t)|0)break;f=c[m>>2]|0;if((f|0)==(c[n>>2]|0)){nb[c[(c[o>>2]|0)+40>>2]&255](o)|0;k=o;continue}else{c[m>>2]=f+1;k=o;continue}}t=a[z+11>>0]|0;f=c[w>>2]|0;if(((t<<24>>24<0?c[z+4>>2]|0:t&255)|0)!=0?(f-y|0)<160:0){t=c[v>>2]|0;v=f+4|0;c[w>>2]=v;c[f>>2]=t;f=v}b[h>>1]=Kx(j,c[x>>2]|0,g,u)|0;Vs(z,y,f,g);if(!o)j=1;else{f=c[m>>2]|0;if((f|0)==(c[n>>2]|0))f=nb[c[(c[d>>2]|0)+36>>2]&255](o)|0;else f=e9(a[f>>0]|0)|0;j=d8(f,-1)|0;i=j?0:i}if(e){f=c[e+12>>2]|0;if((f|0)==(c[e+16>>2]|0))f=nb[c[(c[e>>2]|0)+36>>2]&255](e)|0;else f=e9(a[f>>0]|0)|0;if(!(d8(f,-1)|0)){if(!j)B=45}else B=43}else B=43;if((B|0)==43?j:0)B=45;if((B|0)==45)c[g>>2]=c[g>>2]|2;a1(A);a1(z);l=C;return i|0}function jg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=l;l=l+224|0;s=B+198|0;i=B+196|0;y=B+184|0;z=B+172|0;w=B+168|0;x=B+8|0;v=B+4|0;u=B;h=c[e+4>>2]|0;zC(y,e,s,i);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[z+(e<<2)>>2]=0;e=e+1|0}t=FX(h)|0;q=z+11|0;r=z+8|0;if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(z,e);j=(a[q>>0]|0)<0?c[z>>2]|0:z;c[w>>2]=j;c[v>>2]=x;c[u>>2]=0;p=z+4|0;o=a[i>>0]|0;i=j;j=b;h=b;while(1){if(!j){n=0;b=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0))e=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else e=e9(a[e>>0]|0)|0;m=d8(e,-1)|0;n=m?0:j;h=m?0:h;b=m?0:b;j=m}k=n+12|0;m=n+16|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!j)break}else A=17}else A=17;if((A|0)==17){A=0;if(j){d=0;break}else d=0}j=a[q>>0]|0;j=j<<24>>24<0?c[p>>2]|0:j&255;if((c[w>>2]|0)==(i+j|0)){CC(z,j<<1);if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(z,e);i=(a[q>>0]|0)<0?c[z>>2]|0:z;c[w>>2]=i+j}e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[n>>2]|0)+36>>2]&255](n)|0;else e=e9(a[e>>0]|0)|0;if($l(e&255,t,i,w,u,o,y,x,v,s)|0)break;e=c[k>>2]|0;if((e|0)==(c[m>>2]|0)){nb[c[(c[n>>2]|0)+40>>2]&255](n)|0;j=n;continue}else{c[k>>2]=e+1;j=n;continue}}s=a[y+11>>0]|0;e=c[v>>2]|0;if(((s<<24>>24<0?c[y+4>>2]|0:s&255)|0)!=0?(e-x|0)<160:0){s=c[u>>2]|0;u=e+4|0;c[v>>2]=u;c[e>>2]=s;e=u}c[g>>2]=Yx(i,c[w>>2]|0,f,t)|0;Vs(y,x,e,f);if(!n)i=1;else{e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](n)|0;else e=e9(a[e>>0]|0)|0;i=d8(e,-1)|0;h=i?0:h}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!i)A=45}else A=43}else A=43;if((A|0)==43?i:0)A=45;if((A|0)==45)c[f>>2]=c[f>>2]|2;a1(z);a1(y);l=B;return h|0}function kg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=l;l=l+224|0;s=B+198|0;i=B+196|0;y=B+184|0;z=B+172|0;w=B+168|0;x=B+8|0;v=B+4|0;u=B;h=c[e+4>>2]|0;zC(y,e,s,i);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[z+(e<<2)>>2]=0;e=e+1|0}t=FX(h)|0;q=z+11|0;r=z+8|0;if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(z,e);j=(a[q>>0]|0)<0?c[z>>2]|0:z;c[w>>2]=j;c[v>>2]=x;c[u>>2]=0;p=z+4|0;o=a[i>>0]|0;i=j;j=b;h=b;while(1){if(!j){n=0;b=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0))e=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else e=e9(a[e>>0]|0)|0;m=d8(e,-1)|0;n=m?0:j;h=m?0:h;b=m?0:b;j=m}k=n+12|0;m=n+16|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!j)break}else A=17}else A=17;if((A|0)==17){A=0;if(j){d=0;break}else d=0}j=a[q>>0]|0;j=j<<24>>24<0?c[p>>2]|0:j&255;if((c[w>>2]|0)==(i+j|0)){CC(z,j<<1);if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(z,e);i=(a[q>>0]|0)<0?c[z>>2]|0:z;c[w>>2]=i+j}e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[n>>2]|0)+36>>2]&255](n)|0;else e=e9(a[e>>0]|0)|0;if($l(e&255,t,i,w,u,o,y,x,v,s)|0)break;e=c[k>>2]|0;if((e|0)==(c[m>>2]|0)){nb[c[(c[n>>2]|0)+40>>2]&255](n)|0;j=n;continue}else{c[k>>2]=e+1;j=n;continue}}s=a[y+11>>0]|0;e=c[v>>2]|0;if(((s<<24>>24<0?c[y+4>>2]|0:s&255)|0)!=0?(e-x|0)<160:0){s=c[u>>2]|0;u=e+4|0;c[v>>2]=u;c[e>>2]=s;e=u}c[g>>2]=Hu(i,c[w>>2]|0,f,t)|0;Vs(y,x,e,f);if(!n)i=1;else{e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](n)|0;else e=e9(a[e>>0]|0)|0;i=d8(e,-1)|0;h=i?0:h}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=e9(a[e>>0]|0)|0;if(!(d8(e,-1)|0)){if(!i)A=45}else A=43}else A=43;if((A|0)==43?i:0)A=45;if((A|0)==45)c[f>>2]=c[f>>2]|2;a1(z);a1(y);l=B;return h|0}function lg(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;j=l;l=l+48|0;g=j+24|0;h=j+12|0;i=j;if(!(a[d+771>>0]|0)){if(!(RA(d,1,-1)|0))Kc(d,1,-1)|0;RB(d,1,0,18,391405,-1,1,0);RB(d,1,0,58,391405,-1,1,0);f=d+812|0;e=c[d+808>>2]|0;while(1){if((e|0)==(c[f>>2]|0))break;if(c[e>>2]|0)Ue(d,e);e=e+4|0}m=d+840|0;zb(d,0,0,273,m,0);k=d+852|0;zb(d,0,0,276,k,0);f=d+864|0;zb(d,0,0,277,f,0);e=d+888|0;zb(d,0,0,279,e,0);zb(d,1,0,300,m,0);zb(d,1,0,303,k,0);zb(d,1,0,304,f,0);zb(d,1,0,306,e,0);e=a[d+908+3>>0]|0;if(e<<24>>24<0)e=c[d+904>>2]|0;else e=e&255;if(e|0){Mc(d,1,0,381019,d+900|0,0);Mc(d,1,0,381051,d+912|0,0)}e=b[d+944>>1]|0;if(e<<16>>16){rU(i,e,10);HX(i,35184)|0;c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];e=0;while(1){if((e|0)==3)break;c[i+(e<<2)>>2]=0;e=e+1|0}p2(g,h);Mc(d,1,0,381078,g,0);z5(g);O0(h);z5(i)}e=b[d+946>>1]|0;if(e<<16>>16){rU(i,e,10);HX(i,35184)|0;c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];e=0;while(1){if((e|0)==3)break;c[i+(e<<2)>>2]=0;e=e+1|0}p2(g,h);Mc(d,1,0,381085,g,0);z5(g);O0(h);z5(i)}f=d+936|0;e=c[f>>2]|0;if((e|0)!=-1){sU(i,e,10);DW(i,0,35212)|0;c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];e=0;while(1){if((e|0)==3)break;c[i+(e<<2)>>2]=0;e=e+1|0}p2(g,h);Mc(d,1,0,381093,g,0);z5(g);O0(h);z5(i);e=c[d+940>>2]|0;if((e|0)!=-1?(e|0)!=(c[f>>2]|0):0){sU(i,e,10);DW(i,0,35212)|0;c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];e=0;while(1){if((e|0)==3)break;c[i+(e<<2)>>2]=0;e=e+1|0}p2(g,h);Mc(d,1,0,381093,g,0);z5(g);O0(h);z5(i)}}}l=j;return}function mg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;r=l;l=l+16|0;q=r;if(!(c[b+728>>2]&1)){W5(b);RB(b,0,0,57,378046,-1,1,0)}$x(q,b,0,0,142,1);e=a[q+8+3>>0]|0;e=((e<<24>>24<0?c[q+4>>2]|0:e&255)|0)==0;z5(q);o=b+612|0;n=b+656|0;p=b+48|0;if(e){d=p;d=z0(c[o>>2]|0,0,c[d>>2]|0,c[d+4>>2]|0)|0;e=n;e=D_(d|0,z|0,c[e>>2]|0,c[e+4>>2]|0)|0;oK(b,0,0,142,e,z,10,0);e=HN(b,0)|0;d=n;e=z0(c[d>>2]|0,c[d+4>>2]|0,e|0,z|0)|0;oK(b,0,0,143,e,z,10,0);e=b+40|0;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!((d|0)==-1&(e|0)==-1)?(g=p,f=c[g>>2]|0,g=c[g+4>>2]|0,h=c[o>>2]|0,t=z0(h|0,0,f|0,g|0)|0,s=z,i=HN(b,0)|0,j=z,s=z0(t|0,s|0,i|0,j|0)|0,t=z,!(t>>>0>e>>>0|(t|0)==(e|0)&s>>>0>d>>>0)):0){t=D_(d|0,e|0,f|0,g|0)|0;t=D_(t|0,z|0,h|0,0)|0;t=D_(t|0,z|0,i|0,j|0)|0;oK(b,0,0,144,t,z,10,0)}t=b+864|0;RB(b,0,0,145,((c[t>>2]|0)==-1?(c[t+4>>2]|0)==-1:0)?382840:382808,-1,1,0)}if(((a[b+908>>0]|0)!=0?(k=c[b+936>>2]|0,m=k,(k|0)!=(c[b+940>>2]|0)):0)?(j=k,s=c[j>>2]|0,j=c[j+4>>2]|0,i=p,i=z0(c[o>>2]|0,0,c[i>>2]|0,c[i+4>>2]|0)|0,k=z,t=HN(b,0)|0,t=z0(i|0,k|0,t|0,z|0)|0,k=z,j>>>0<k>>>0|(j|0)==(k|0)&s>>>0<t>>>0):0){c[b+948>>2]=m;K7(b);nx(b)}else{d=b+848|0;t=d;if((c[t>>2]|0)==-1?(c[t+4>>2]|0)==-1:0){c[o>>2]=(c[o>>2]|0)-(c[n>>2]|0);s=b+508|0;c[s>>2]=(c[s>>2]|0)+-1;Mt(b);c[s>>2]=(c[s>>2]|0)+1;s=n;n=c[s>>2]|0;s=c[s+4>>2]|0;t=(c[o>>2]|0)+n|0;c[o>>2]=t;f=p;e=c[f>>2]|0;f=c[f+4>>2]|0;s=D_(t|0,0,n|0,s|0)|0;s=z0(s|0,z|0,e|0,f|0)|0;c[d>>2]=s;c[d+4>>2]=z;d=t}else{f=p;d=c[o>>2]|0;e=c[f>>2]|0;f=c[f+4>>2]|0}d=z0(d|0,0,e|0,f|0)|0;e=z;f=b+856|0;t=f;s=c[t+4>>2]|0;if(e>>>0>s>>>0|((e|0)==(s|0)?d>>>0>(c[t>>2]|0)>>>0:0)){s=HN(b,0)|0;s=z0(s|0,z|0,d|0,e|0)|0;t=f;c[t>>2]=s;c[t+4>>2]=z}t=HN(b,0)|0;e1(b,t,z);t=b+888|0;if(((c[t>>2]|0)==-1?(c[t+4>>2]|0)==-1:0)?(a[b+884>>0]|0)==0:0){h=c[b+928>>2]|0;d=p;d=z0(c[o>>2]|0,0,c[d>>2]|0,c[d+4>>2]|0)|0;e=z;f=q;c[f>>2]=d;c[f+4>>2]=e;f=h+104|0;g=c[f>>2]|0;if(g>>>0<(c[h+108>>2]|0)>>>0){t=g;c[t>>2]=d;c[t+4>>2]=e;c[f>>2]=g+8}else Px(h+100|0,q)}}l=r;return}function ng(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;w=b+768|0;a:do if(!(c[w>>2]|0)){s=b+544|0;q=c[s>>2]|0;v=b+612|0;r=c[v>>2]|0;e=q+r|0;t=g8(e)|0;u=z;x=b+376|0;if(!((t&-65536|0)==539295744&(u&65535|0)==25688|((t&-3849|0)==15265799&(u&65535|0)==65311|((t&-2064|0)==-402651152&(u&65535|0)==8191|((t&-1024|0)==-2147353600&(u&65535|0)==32766|(t&-65284|0)==25166076&(u&65535|0)==65151))))){a[x>>0]=0;e=1;break}switch(a[e>>0]|0){case -2:{o=1;p=0;break}case 31:{o=0;p=1;break}case -1:{o=0;p=0;break}default:{o=1;p=1}}a[b+831>>0]=o;t=b+832|0;a[t>>0]=p;n=b+548|0;u=b+804|0;k=q+(r+8)|0;f=q+(r+6)|0;j=q+(r+7)|0;l=q+(r+5)|0;m=q+(r+9)|0;do if((a[e>>0]|0)!=100){i=p<<24>>24!=0;g=d[f>>0]|0;h=g<<4;e=d[j>>0]|0;f=e<<4;if(!(o<<24>>24)){e=((i?g:e)<<12&12288|(i?f:h)|(a[(i?k:m)>>0]&60)>>>2)+1|0;m=e;e=(e<<4>>>0)/14|0;break}else{e=((i?e:g)>>>4|(i?h:f)|(a[(i?l:q+(r+4)|0)>>0]&3)<<12)+1|0;m=e;break}}else{if((r+10|0)>>>0>(c[n>>2]|0)>>>0){e=0;break a}g=d[f>>0]|0;e=d[k>>0]|0;f=d[j>>0]|0;if(!(a[l>>0]&32))f=f<<3|g<<11&63488;else{f=e<<3|g<<19&524288|f<<11;e=d[m>>0]|0}e=(f|e>>>5)+1|0;m=e}while(0);c[u>>2]=e;f=c[n>>2]|0;if((m+r|0)>>>0>f>>>0)e=0;else{g=o<<24>>24!=0;if(p<<24>>24==0|g^1){c[w>>2]=q;l=b+772|0;c[l>>2]=r;k=b+776|0;c[k>>2]=f;j=iaa(m)|0;b:do if(g){e=0;while(1){f=e|1;if(f>>>0>=m>>>0)break b;v=e+r|0;a[j+f>>0]=a[q+v>>0]|0;a[j+e>>0]=a[q+(v+1)>>0]|0;e=e+2|0}}else{i=0;while(1){h=i+8|0;if(h>>>0>e>>>0)break b;g=(c[s>>2]|0)+(c[v>>2]|0)+i|0;f=a[g>>0]|0;e=a[g+1>>0]|0;if(!(a[t>>0]|0)){q=PZ((a5(f,e)|0)&16383|0,0,42)|0;r=z;b=g+2|0;b=PZ((a5(a[b>>0]|0,a[b+1>>0]|0)|0)&16383|0,0,28)|0;r=z|r;f=g+4|0;f=PZ((a5(a[f>>0]|0,a[f+1>>0]|0)|0)&16383|0,0,14)|0;r=r|z;e=g+6|0;e=a5(a[e>>0]|0,a[e+1>>0]|0)|0;f=b|q|f;g=r}else{q=PZ((A5(f,e)|0)&16383|0,0,42)|0;r=z;b=g+2|0;b=PZ((A5(a[b>>0]|0,a[b+1>>0]|0)|0)&16383|0,0,28)|0;r=z|r;f=g+4|0;f=PZ((A5(a[f>>0]|0,a[f+1>>0]|0)|0)&16383|0,0,14)|0;r=r|z;e=g+6|0;e=A5(a[e>>0]|0,a[e+1>>0]|0)|0;f=b|q|f;g=r}A3(j+((i*14|0)>>>4)|0,e&16383|f,g);i=h;e=c[u>>2]|0}}while(0);c[w>>2]=j;c[l>>2]=0;c[k>>2]=m}a[x>>0]=1;e=1}}else e=1;while(0);return e|0}function og(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=l;l=l+64|0;A=G+48|0;B=G+36|0;C=G+24|0;D=G+12|0;E=G;e=c[b>>2]|0;F=b+4|0;while(1){f=c[F>>2]|0;if((f|0)==(e|0))break;z=f+-12|0;c[F>>2]=z;z5(z)}o=d+8+3|0;z=a[o>>0]|0;p=d+4|0;if((z<<24>>24<0?c[p>>2]|0:z&255)|0){TX(A);TX(B);TX(C);q=b+24|0;r=b+32+3|0;s=b+28|0;t=A+8+3|0;u=A+4|0;v=b+36|0;w=b+8|0;x=b+12|0;y=b+20+3|0;z=b+16|0;f=0;h=a[o>>0]|0;do{e=h<<24>>24<0;k=e?c[d>>2]|0:d;m=a[r>>0]|0;n=m<<24>>24<0;if(n)g=c[q>>2]|0;else g=q;if((c[k+(f<<2)>>2]|0)==(c[g>>2]|0)){g=e?c[p>>2]|0:h&255;j=f+1|0;while(1){if(j>>>0>=g>>>0)break;h=c[k+(j<<2)>>2]|0;if(n)e=c[q>>2]|0;else e=q;i=j+1|0;if(i>>>0<g>>>0?(h|0)==(c[e>>2]|0):0){if(n)e=c[q>>2]|0;else e=q;if((c[k+(i<<2)>>2]|0)==(c[e>>2]|0)){j=j+2|0;continue}}if(n)e=c[q>>2]|0;else e=q;if((h|0)==(c[e>>2]|0))break;else j=i}if(n)e=c[s>>2]|0;else e=m&255;lw(E,d,e+f|0,j-f|0);p2(D,E);k1(A,D)|0;z5(D);O0(E);g=a[t>>0]|0;i=g<<24>>24<0;g=i?c[u>>2]|0:g&255;e=a[r>>0]|0;h=e<<24>>24<0;if(h)e=c[s>>2]|0;else e=e&255;f=g+f+e|0;if(g){g=g+-1|0;if(h)e=c[q>>2]|0;else e=q;if((c[(i?c[A>>2]|0:A)+(g<<2)>>2]|0)==(c[e>>2]|0)){FB(A,g,0);e=a[r>>0]|0;if(e<<24>>24<0)e=c[s>>2]|0;else e=e&255;f=e+f|0}}}else{c[E>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[E+(e<<2)>>2]=0;e=e+1|0}Ok(D,d,E,x,f,4);k1(A,D)|0;z5(D);O0(E);g=a[t>>0]|0;e=a[y>>0]|0;if(e<<24>>24<0)e=c[z>>2]|0;else e=e&255;f=(g<<24>>24<0?c[u>>2]|0:g&255)+f+e|0}Mq(D,q,q);vo(A,D,q,0,8);O0(D);n=c[F>>2]|0;e=n;do if(((n-(c[b>>2]|0)|0)/12|0)>>>0<(c[v>>2]|0)>>>0)if((e|0)==(c[w>>2]|0)){Ax(b,A);break}else{p2(e,A);c[F>>2]=(c[F>>2]|0)+12;break}while(0);h=a[o>>0]|0}while(f>>>0<(h<<24>>24<0?c[p>>2]|0:h&255)>>>0);z5(C);z5(B);z5(A)}l=G;return}function pg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+48|0;h=m+36|0;i=m+24|0;j=m+12|0;k=m;TX(h);jZ(b,d,0,h);f=a[h+8+3>>0]|0;g=f<<24>>24<0;d=g?c[h>>2]|0:h;e=i9(33796)|0;if(!((e|0)!=0?(f=d+((g?c[h+4>>2]|0:f&255)<<2)|0,g=HA(d,f,33796,33796+(e<<2)|0)|0,(g|0)==(f|0)|(g-d|0)==-4):0)){c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;f=i9(33964)|0;if(f>>>0>1073741807)uaa();d=j+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){m=ua(8)|0;K2(m,391652);c[m>>2]=57868;Ya(m|0,2712,367)}else{g=ZW(e<<2)|0;c[j>>2]=g;c[d>>2]=e|-2147483648;c[j+4>>2]=f;d=g;break}}else{a[d+3>>0]=f;d=j}while(0);a3(d,33964,f);y7(d+(f<<2)|0,0);c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;f=i9(34016)|0;if(f>>>0>1073741807)uaa();d=k+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){m=ua(8)|0;K2(m,391652);c[m>>2]=57868;Ya(m|0,2712,367)}else{g=ZW(e<<2)|0;c[k>>2]=g;c[d>>2]=e|-2147483648;c[k+4>>2]=f;d=g;break}}else{a[d+3>>0]=f;d=k}while(0);a3(d,34016,f);y7(d+(f<<2)|0,0);Ok(i,h,j,k,0,0);vF(b+936|0,i)|0;z5(i);O0(k);O0(j);Xy(i,34080);vF(b+948|0,i)|0;z5(i);c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;f=i9(33796)|0;if(f>>>0>1073741807)uaa();d=j+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){m=ua(8)|0;K2(m,391652);c[m>>2]=57868;Ya(m|0,2712,367)}else{g=ZW(e<<2)|0;c[j>>2]=g;c[d>>2]=e|-2147483648;c[j+4>>2]=f;d=g;break}}else{a[d+3>>0]=f;d=j}while(0);a3(d,33796,f);y7(d+(f<<2)|0,0);c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;f=i9(34192)|0;if(f>>>0>1073741807)uaa();d=k+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){m=ua(8)|0;K2(m,391652);c[m>>2]=57868;Ya(m|0,2712,367)}else{g=ZW(e<<2)|0;c[k>>2]=g;c[d>>2]=e|-2147483648;c[k+4>>2]=f;d=g;break}}else{a[d+3>>0]=f;d=k}while(0);a3(d,34192,f);y7(d+(f<<2)|0,0);Ok(i,h,j,k,0,0);g=b+960|0;vF(g,i)|0;z5(i);O0(k);O0(j);k1(b+972|0,Ot(2,g,2)|0)|0}z5(h);l=m;return}function qg(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a[b+834>>0]=1;PU(b+836|0,0)|0;r=b+536|0;o=r;n=c[o>>2]|0;o=c[o+4>>2]|0;p=b+830|0;q=b+825|0;if(!(a[p>>0]|0)){i=n;d=o;f=n;e=o}else{j=a[q>>0]|0;l=b+544|0;m=b+612|0;a:do switch(j<<24>>24){case 3:case 0:{d=0;f=n;e=o;while(1){if(0>o>>>0|0==(o|0)&(d+4|0)>>>0>n>>>0)break a;k=(C9((c[l>>2]|0)+(c[m>>2]|0)+d|0)|0)==1515870810;i=k?d:f;d=d+1|0;f=i;e=k?0:e}}default:{e=o;f=n}}while(0);b:do if(j<<24>>24==6){d=0;i=n;h=o;while(1){if(0>o>>>0|0==(o|0)&(d+4|0)>>>0>n>>>0){k=i;break b}k=(C9((c[l>>2]|0)+(c[m>>2]|0)+d|0)|0)==1191201283;s=k?d:i;d=d+1|0;i=s;h=k?0:h}}else{h=o;k=n}while(0);c:do if((j&-2)<<24>>24==2){i=0;d=n;j=o;while(1){if(0>o>>>0|0==(o|0)&(i+4|0)>>>0>n>>>0)break c;s=(C9((c[l>>2]|0)+(c[m>>2]|0)+i|0)|0)==496366178;t=s?i:d;i=i+1|0;d=t;j=s?0:j}}else{j=o;d=n}while(0);t=e>>>0<o>>>0|(e|0)==(o|0)&f>>>0<n>>>0;i=t?f:n;t=t?e:o;s=h>>>0<t>>>0|(h|0)==(t|0)&k>>>0<i>>>0;i=s?k:i;t=s?h:t;s=j>>>0<t>>>0|(j|0)==(t|0)&d>>>0<i>>>0;i=s?d:i;d=s?j:t}h=b+528|0;t=h;t=D_(i|0,d|0,c[t>>2]|0,c[t+4>>2]|0)|0;e1(b,t,z);d:do if(a[p>>0]|0){d=a[q>>0]|0;if((d&-2)<<24>>24==2){GC(b);s=h;s=z0(c[s>>2]|0,c[s+4>>2]|0,4,0)|0;t=z;o=h;c[o>>2]=s;c[o+4>>2]=t;t=D_(f|0,e|0,s|0,t|0)|0;vA(b,t,z);J3(b);if(!(a[p>>0]|0))break;d=a[q>>0]|0}switch(d<<24>>24){case 3:case 0:{GC(b);s=h;s=z0(c[s>>2]|0,c[s+4>>2]|0,4,0)|0;t=z;o=h;c[o>>2]=s;c[o+4>>2]=t;o=r;er(b,D_(c[o>>2]|0,c[o+4>>2]|0,s|0,t|0)|0,z);J3(b);if(!(a[p>>0]|0))break d;d=a[q>>0]|0;break}default:{}}if(d<<24>>24==6){GC(b);s=h;s=z0(c[s>>2]|0,c[s+4>>2]|0,4,0)|0;t=z;q=h;c[q>>2]=s;c[q+4>>2]=t;t=D_(c[r>>2]|0,c[r+4>>2]|0,s|0,t|0)|0;hx(b,t,z);J3(b)}}while(0);if(qO(b)|0){e=b+728|0;d=c[e>>2]|0;f=b+312|0;if((d&1|0)==0?(t=f,s=c[t+4>>2]|0,s>>>0>0|(s|0)==0&(c[t>>2]|0)>>>0>1):0){W5(b);d=c[e>>2]|0}if((((d&2|0)==0?(s=f,q=c[s+4>>2]|0,t=b+760|0,r=c[t+4>>2]|0,!(q>>>0<r>>>0|((q|0)==(r|0)?(c[s>>2]|0)>>>0<(c[t>>2]|0)>>>0:0))):0)?(t6(b),(a[b+492>>0]|0)==0):0)?+g[(c[b+24>>2]|0)+136>>2]<1.0:0)V5(b)}return}function rg(b,d,e,f,h){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=l;l=l+352|0;v=E+208|0;i=E+200|0;j=E+196|0;B=E+184|0;C=E+172|0;z=E+168|0;A=E+8|0;w=E+4|0;x=E;y=E+337|0;u=E+336|0;Vz(B,e,v,i,j);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[C+(e<<2)>>2]=0;e=e+1|0}s=C+11|0;t=C+8|0;if((a[s>>0]|0)<0)e=(c[t>>2]&2147483647)+-1|0;else e=10;CC(C,e);k=(a[s>>0]|0)<0?c[C>>2]|0:C;c[z>>2]=k;c[w>>2]=A;c[x>>2]=0;a[y>>0]=1;a[u>>0]=69;r=C+4|0;q=c[i>>2]|0;p=c[j>>2]|0;j=k;k=b;i=b;while(1){if(!k){o=0;b=0;k=1}else{e=c[k+12>>2]|0;if((e|0)==(c[k+16>>2]|0))e=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else e=raa(c[e>>2]|0)|0;n=d8(e,-1)|0;o=n?0:k;i=n?0:i;b=n?0:b;k=n}m=o+12|0;n=o+16|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!k)break}else D=17}else D=17;if((D|0)==17){D=0;if(k){d=0;break}else d=0}k=a[s>>0]|0;k=k<<24>>24<0?c[r>>2]|0:k&255;if((c[z>>2]|0)==(j+k|0)){CC(C,k<<1);if((a[s>>0]|0)<0)e=(c[t>>2]&2147483647)+-1|0;else e=10;CC(C,e);j=(a[s>>0]|0)<0?c[C>>2]|0:C;c[z>>2]=j+k}e=c[m>>2]|0;if((e|0)==(c[n>>2]|0))e=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else e=raa(c[e>>2]|0)|0;if(Xj(e,y,u,j,z,q,p,B,A,w,x,v)|0)break;e=c[m>>2]|0;if((e|0)==(c[n>>2]|0)){nb[c[(c[o>>2]|0)+40>>2]&255](o)|0;k=o;continue}else{c[m>>2]=e+4;k=o;continue}}v=a[B+11>>0]|0;e=c[w>>2]|0;if(!((a[y>>0]|0)==0?1:((v<<24>>24<0?c[B+4>>2]|0:v&255)|0)==0)?(e-A|0)<160:0){x=c[x>>2]|0;y=e+4|0;c[w>>2]=y;c[e>>2]=x;e=y}g[h>>2]=+eF(j,c[z>>2]|0,f);Vs(B,A,e,f);if(!o)j=1;else{e=c[m>>2]|0;if((e|0)==(c[n>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](o)|0;else e=raa(c[e>>2]|0)|0;j=d8(e,-1)|0;i=j?0:i}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!j)D=45}else D=43}else D=43;if((D|0)==43?j:0)D=45;if((D|0)==45)c[f>>2]=c[f>>2]|2;a1(C);a1(B);l=E;return i|0}function sg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=l;l=l+352|0;v=E+208|0;i=E+200|0;j=E+196|0;B=E+184|0;C=E+172|0;z=E+168|0;A=E+8|0;w=E+4|0;x=E;y=E+337|0;u=E+336|0;Vz(B,e,v,i,j);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[C+(e<<2)>>2]=0;e=e+1|0}s=C+11|0;t=C+8|0;if((a[s>>0]|0)<0)e=(c[t>>2]&2147483647)+-1|0;else e=10;CC(C,e);k=(a[s>>0]|0)<0?c[C>>2]|0:C;c[z>>2]=k;c[w>>2]=A;c[x>>2]=0;a[y>>0]=1;a[u>>0]=69;r=C+4|0;q=c[i>>2]|0;p=c[j>>2]|0;j=k;k=b;i=b;while(1){if(!k){o=0;b=0;k=1}else{e=c[k+12>>2]|0;if((e|0)==(c[k+16>>2]|0))e=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else e=raa(c[e>>2]|0)|0;n=d8(e,-1)|0;o=n?0:k;i=n?0:i;b=n?0:b;k=n}m=o+12|0;n=o+16|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!k)break}else D=17}else D=17;if((D|0)==17){D=0;if(k){d=0;break}else d=0}k=a[s>>0]|0;k=k<<24>>24<0?c[r>>2]|0:k&255;if((c[z>>2]|0)==(j+k|0)){CC(C,k<<1);if((a[s>>0]|0)<0)e=(c[t>>2]&2147483647)+-1|0;else e=10;CC(C,e);j=(a[s>>0]|0)<0?c[C>>2]|0:C;c[z>>2]=j+k}e=c[m>>2]|0;if((e|0)==(c[n>>2]|0))e=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else e=raa(c[e>>2]|0)|0;if(Xj(e,y,u,j,z,q,p,B,A,w,x,v)|0)break;e=c[m>>2]|0;if((e|0)==(c[n>>2]|0)){nb[c[(c[o>>2]|0)+40>>2]&255](o)|0;k=o;continue}else{c[m>>2]=e+4;k=o;continue}}v=a[B+11>>0]|0;e=c[w>>2]|0;if(!((a[y>>0]|0)==0?1:((v<<24>>24<0?c[B+4>>2]|0:v&255)|0)==0)?(e-A|0)<160:0){x=c[x>>2]|0;y=e+4|0;c[w>>2]=y;c[e>>2]=x;e=y}h[g>>3]=+dF(j,c[z>>2]|0,f);Vs(B,A,e,f);if(!o)j=1;else{e=c[m>>2]|0;if((e|0)==(c[n>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](o)|0;else e=raa(c[e>>2]|0)|0;j=d8(e,-1)|0;i=j?0:i}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!j)D=45}else D=43}else D=43;if((D|0)==43?j:0)D=45;if((D|0)==45)c[f>>2]=c[f>>2]|2;a1(C);a1(B);l=E;return i|0}function tg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;E=l;l=l+352|0;v=E+208|0;i=E+200|0;j=E+196|0;B=E+184|0;C=E+172|0;z=E+168|0;A=E+8|0;w=E+4|0;x=E;y=E+337|0;u=E+336|0;Vz(B,e,v,i,j);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[C+(e<<2)>>2]=0;e=e+1|0}s=C+11|0;t=C+8|0;if((a[s>>0]|0)<0)e=(c[t>>2]&2147483647)+-1|0;else e=10;CC(C,e);k=(a[s>>0]|0)<0?c[C>>2]|0:C;c[z>>2]=k;c[w>>2]=A;c[x>>2]=0;a[y>>0]=1;a[u>>0]=69;r=C+4|0;q=c[i>>2]|0;p=c[j>>2]|0;j=k;k=b;i=b;while(1){if(!k){o=0;b=0;k=1}else{e=c[k+12>>2]|0;if((e|0)==(c[k+16>>2]|0))e=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else e=raa(c[e>>2]|0)|0;n=d8(e,-1)|0;o=n?0:k;i=n?0:i;b=n?0:b;k=n}m=o+12|0;n=o+16|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!k)break}else D=17}else D=17;if((D|0)==17){D=0;if(k){d=0;break}else d=0}k=a[s>>0]|0;k=k<<24>>24<0?c[r>>2]|0:k&255;if((c[z>>2]|0)==(j+k|0)){CC(C,k<<1);if((a[s>>0]|0)<0)e=(c[t>>2]&2147483647)+-1|0;else e=10;CC(C,e);j=(a[s>>0]|0)<0?c[C>>2]|0:C;c[z>>2]=j+k}e=c[m>>2]|0;if((e|0)==(c[n>>2]|0))e=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else e=raa(c[e>>2]|0)|0;if(Xj(e,y,u,j,z,q,p,B,A,w,x,v)|0)break;e=c[m>>2]|0;if((e|0)==(c[n>>2]|0)){nb[c[(c[o>>2]|0)+40>>2]&255](o)|0;k=o;continue}else{c[m>>2]=e+4;k=o;continue}}v=a[B+11>>0]|0;e=c[w>>2]|0;if(!((a[y>>0]|0)==0?1:((v<<24>>24<0?c[B+4>>2]|0:v&255)|0)==0)?(e-A|0)<160:0){x=c[x>>2]|0;y=e+4|0;c[w>>2]=y;c[e>>2]=x;e=y}h[g>>3]=+fF(j,c[z>>2]|0,f);Vs(B,A,e,f);if(!o)j=1;else{e=c[m>>2]|0;if((e|0)==(c[n>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](o)|0;else e=raa(c[e>>2]|0)|0;j=d8(e,-1)|0;i=j?0:i}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!j)D=45}else D=43}else D=43;if((D|0)==43?j:0)D=45;if((D|0)==45)c[f>>2]=c[f>>2]|2;a1(C);a1(B);l=E;return i|0}function ug(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;C=l;l=l+304|0;s=C+200|0;i=C+196|0;y=C+184|0;A=C+172|0;w=C+168|0;x=C+8|0;v=C+4|0;u=C;h=c[e+4>>2]|0;xC(y,e,s,i);c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[A+(e<<2)>>2]=0;e=e+1|0}t=FX(h)|0;q=A+11|0;r=A+8|0;if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(A,e);j=(a[q>>0]|0)<0?c[A>>2]|0:A;c[w>>2]=j;c[v>>2]=x;c[u>>2]=0;p=A+4|0;o=c[i>>2]|0;i=j;j=b;h=b;while(1){if(!j){n=0;b=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0))e=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else e=raa(c[e>>2]|0)|0;m=d8(e,-1)|0;n=m?0:j;h=m?0:h;b=m?0:b;j=m}m=n+16|0;k=n+12|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!j)break}else B=17}else B=17;if((B|0)==17){B=0;if(j){d=0;break}else d=0}j=a[q>>0]|0;j=j<<24>>24<0?c[p>>2]|0:j&255;if((c[w>>2]|0)==(i+j|0)){CC(A,j<<1);if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(A,e);i=(a[q>>0]|0)<0?c[A>>2]|0:A;c[w>>2]=i+j}e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[n>>2]|0)+36>>2]&255](n)|0;else e=raa(c[e>>2]|0)|0;if(am(e,t,i,w,u,o,y,x,v,s)|0)break;e=c[k>>2]|0;if((e|0)==(c[m>>2]|0)){nb[c[(c[n>>2]|0)+40>>2]&255](n)|0;j=n;continue}else{c[k>>2]=e+4;j=n;continue}}s=a[y+11>>0]|0;e=c[v>>2]|0;if(((s<<24>>24<0?c[y+4>>2]|0:s&255)|0)!=0?(e-x|0)<160:0){s=c[u>>2]|0;u=e+4|0;c[v>>2]=u;c[e>>2]=s;e=u}v=oy(i,c[w>>2]|0,f,t)|0;w=g;c[w>>2]=v;c[w+4>>2]=z;Vs(y,x,e,f);if(!n)i=1;else{e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](n)|0;else e=raa(c[e>>2]|0)|0;i=d8(e,-1)|0;h=i?0:h}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!i)B=45}else B=43}else B=43;if((B|0)==43?i:0)B=45;if((B|0)==45)c[f>>2]=c[f>>2]|2;a1(A);a1(y);l=C;return h|0}function vg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;C=l;l=l+304|0;s=C+200|0;i=C+196|0;y=C+184|0;A=C+172|0;w=C+168|0;x=C+8|0;v=C+4|0;u=C;h=c[e+4>>2]|0;xC(y,e,s,i);c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[A+(e<<2)>>2]=0;e=e+1|0}t=FX(h)|0;q=A+11|0;r=A+8|0;if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(A,e);j=(a[q>>0]|0)<0?c[A>>2]|0:A;c[w>>2]=j;c[v>>2]=x;c[u>>2]=0;p=A+4|0;o=c[i>>2]|0;i=j;j=b;h=b;while(1){if(!j){n=0;b=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0))e=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else e=raa(c[e>>2]|0)|0;m=d8(e,-1)|0;n=m?0:j;h=m?0:h;b=m?0:b;j=m}m=n+16|0;k=n+12|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!j)break}else B=17}else B=17;if((B|0)==17){B=0;if(j){d=0;break}else d=0}j=a[q>>0]|0;j=j<<24>>24<0?c[p>>2]|0:j&255;if((c[w>>2]|0)==(i+j|0)){CC(A,j<<1);if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(A,e);i=(a[q>>0]|0)<0?c[A>>2]|0:A;c[w>>2]=i+j}e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[n>>2]|0)+36>>2]&255](n)|0;else e=raa(c[e>>2]|0)|0;if(am(e,t,i,w,u,o,y,x,v,s)|0)break;e=c[k>>2]|0;if((e|0)==(c[m>>2]|0)){nb[c[(c[n>>2]|0)+40>>2]&255](n)|0;j=n;continue}else{c[k>>2]=e+4;j=n;continue}}s=a[y+11>>0]|0;e=c[v>>2]|0;if(((s<<24>>24<0?c[y+4>>2]|0:s&255)|0)!=0?(e-x|0)<160:0){s=c[u>>2]|0;u=e+4|0;c[v>>2]=u;c[e>>2]=s;e=u}v=yz(i,c[w>>2]|0,f,t)|0;w=g;c[w>>2]=v;c[w+4>>2]=z;Vs(y,x,e,f);if(!n)i=1;else{e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](n)|0;else e=raa(c[e>>2]|0)|0;i=d8(e,-1)|0;h=i?0:h}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!i)B=45}else B=43}else B=43;if((B|0)==43?i:0)B=45;if((B|0)==45)c[f>>2]=c[f>>2]|2;a1(A);a1(y);l=C;return h|0}function wg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;q=l;l=l+48|0;p=q+24|0;e=q+20|0;k=q+16|0;f=q+12|0;o=q;bB(b,q+40|0);jB(b,q+36|0);c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[p+(d<<2)>>2]=0;d=d+1|0}ID(b,e);ID(b,k);ID(b,f);j=c[e>>2]|0;n=p+11|0;m=p+4|0;if(!j){h=b+528|0;e=c[f>>2]|0;d=0;g=1;f=0;i=0;while(1){if((d|0)==(e|0))break;ID(b,o);v=c[o>>2]|0;t=v>>>0<64;s=PZ(1,0,v|0)|0;r=(t?z:0)|i;JX(p,Th(v)|0)|0;gy(p,32);v=h;v=z0(c[v>>2]|0,c[v+4>>2]|0,16,0)|0;u=h;c[u>>2]=v;c[u+4>>2]=z;d=d+1|0;g=t?g:0;f=(t?s:0)|f;i=r}e=a[n>>0]|0;e=e<<24>>24<0?c[m>>2]|0:e&255;d=(g&1)!=0;if(!e){g=d;e=i}else{CC(p,e+-1|0);g=d;e=i}}else{g=1;f=0;e=0}a:do if((c[b+784>>2]|0)>>>0<=1?qO(b)|0:0){h=b+20|0;b:do if((j|0)<65536){switch(j|0){case 0:break;default:break b}RB(b,2,c[h>>2]|0,132,(a[n>>0]|0)<0?c[p>>2]|0:p,-1,1,1);d=c[h>>2]|0;if(g){Li(o,f,e);bw(b,2,d,128,o,1,1);a1(o);break a}else{bw(b,2,d,128,p,1,0);break a}}else{switch(j|0){case 65536:break;default:break b}f=c[k>>2]|0;e=0;d=0;while(1){if((e|0)==18)break;if(f&1<<e){JX(p,Aw(e)|0)|0;gy(p,32);d=d+1<<24>>24}e=e+1|0}if(!(d<<24>>24))break a;d=c[h>>2]|0;Xo(o,f);bw(b,2,d,128,o,1,1);a1(o);d=a[n>>0]|0;d=d<<24>>24<0?c[m>>2]|0:d&255;if(!d)break a;CC(p,d+-1|0);RB(b,2,c[h>>2]|0,132,(a[n>>0]|0)<0?c[p>>2]|0:p,-1,1,1);break a}while(0);if(j>>>0>65536){v=j>>>16&65535;u=c[h>>2]|0;RB(b,2,u,128,rl(v)|0,-1,1,1);u=c[h>>2]|0;RB(b,2,u,132,el(v)|0,-1,1,0)}}while(0);a1(p);l=q;return}function xg(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+16|0;k=m+3|0;g=m+2|0;j=m+1|0;f=m;GC(b);xR(b,2,k);a:do switch(a[k>>0]|0){case 0:{xR(b,2,f);g=~~+eaa(d[f>>0]|0)&255;f=b+22116|0;j=e&1;a[(c[f>>2]|0)+9+j>>0]=g;g=c[f>>2]|0;if((a[g+9+j>>0]|0)==1){a[g+j>>0]=0;g=c[f>>2]|0}AT(b,g+11+(j<<3)|0);g=c[f>>2]|0;h=g+11+(j<<3)|0;i=d[g+9+j>>0]|0;e=1;while(1){if(e>>>0>=i>>>0){g=j;break a}a[g+11+(j<<3)+e>>0]=a[h>>0]|0;e=e+1|0}}case 1:{i=b+648|0;d4(c[i>>2]|0,2);xR(b,2,j);f=b+22116|0;e=e&1;a[(c[f>>2]|0)+9+e>>0]=(d[j>>0]|0)+1;g=0;while(1){h=a[(c[f>>2]|0)+9+e>>0]|0;if((g&255|0)>=((h&255)+-1|0))break;d4(c[i>>2]|0,2);g=g+1<<24>>24}k=~~+N(+(+M(+(+(h&255)+1.0))/.6931471805599453))&255;G4(c[i>>2]|0,k);GC(b);i=0;while(1){g=c[f>>2]|0;h=d[g+9+e>>0]|0;if(i>>>0>=h>>>0)break;AT(b,h+~i+(g+11+(e<<3))|0);i=i+1|0}J3(b);g=e;break}case 2:{i=b+648|0;d4(c[i>>2]|0,2);xR(b,2,g);f=b+22116|0;e=e&1;a[(c[f>>2]|0)+9+e>>0]=(d[g>>0]|0)+1;g=0;while(1){h=a[(c[f>>2]|0)+9+e>>0]|0;if((g&255|0)>=((h&255)+-1|0))break;d4(c[i>>2]|0,2);g=g+1<<24>>24}h=~~+N(+(+M(+(+(h&255)+1.0))/.6931471805599453))&255;G4(c[i>>2]|0,h);GC(b);h=0;while(1){g=c[f>>2]|0;if(h>>>0>=(d[g+9+e>>0]|0)>>>0)break;AT(b,g+11+(e<<3)+h|0);h=h+1|0}J3(b);g=e;break}case 3:{k=b+648|0;d4(c[k>>2]|0,2);d4(c[k>>2]|0,2);xR(b,2,g);xR(b,2,j);h=a[g>>0]|0;i=a[j>>0]|0;f=b+22116|0;e=e&1;a[(c[f>>2]|0)+9+e>>0]=(h&255)+1+(i&255);g=0;while(1){if((g&255)>=(h&255)){g=0;break}d4(c[k>>2]|0,2);g=g+1<<24>>24}while(1){if((g&255)>=(i&255))break;d4(c[k>>2]|0,2);g=g+1<<24>>24}h=~~+N(+(+M(+(+((d[(c[f>>2]|0)+9+e>>0]|0)+1|0)))/.6931471805599453))&255;G4(c[k>>2]|0,h);GC(b);h=0;while(1){g=c[f>>2]|0;if(h>>>0>=(d[g+9+e>>0]|0)>>>0)break;AT(b,g+11+(e<<3)+h|0);h=h+1|0}J3(b);g=e;break}default:{g=e&1;f=b+22116|0}}while(0);k=c[f>>2]|0;a[k+27+g>>0]=(d[k+9+g>>0]|0)>1?2:1;J3(b);l=m;return}function yg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;t=l;l=l+128|0;s=t+108|0;e=t+96|0;g=t+48|0;p=t+60|0;k=t+36|0;m=t+24|0;f=t+12|0;i=t;mI(b);p2(s,d);q=b+4|0;r=b+8|0;do if(nM(s)|0){d=c[q>>2]|0;if((d|0)==(c[r>>2]|0)){Ax(b,s);break}else{p2(d,s);c[q>>2]=(c[q>>2]|0)+12;break}}else if(rM(s)|0){pk(e,s);j=qP((a[e+11>>0]|0)<0?c[e>>2]|0:e)|0;a1(e);if(!j){pk(f,s);o=(xo((a[f+11>>0]|0)<0?c[f>>2]|0:f,p)|0)==0;a1(f);a:do if(o){h=c[p>>2]|0;e=c[p+4>>2]|0;d=0;while(1){if(d>>>0>=h>>>0)break a;TX(i);f=cC(i,c[e+(d<<2)>>2]|0)|0;g=c[q>>2]|0;if((g|0)==(c[r>>2]|0))Ax(b,f);else{p2(g,f);c[q>>2]=(c[q>>2]|0)+12}z5(i);d=d+1|0}}while(0);break}d=s+8+3|0;i=a[d>>0]|0;u=i<<24>>24<0;e=s+4|0;f=u?c[s>>2]|0:s;i=u?c[e>>2]|0:i&255;u=i9(42012)|0;i=f+(i<<2)|0;h=Ix(f,i,42012,42012+(u<<2)|0)|0;f=h-f>>2;if(!(!((u|0)!=0&(h|0)==(i|0)|(f|0)==-1)?(Xy(g,42012),h=a[g+8+3>>0]|0,v=c[g+4>>2]|0,u=a[d>>0]|0,i=c[e>>2]|0,z5(g),((h<<24>>24<0?v:h&255)+f|0)==((u<<24>>24<0?i:u&255)|0)):0))HX(s,42012)|0;g=p+8+3|0;h=p+4|0;while(1){d=az(j)|0;if(!d)break;VU(p,d+11|0);d=i9(42212)|0;e=a[g>>0]|0;f=c[h>>2]|0;if((d|0)==((e<<24>>24<0?f:e&255)|0)){if(VG(p,42212,d)|0){e=a[g>>0]|0;f=c[h>>2]|0;o=16}}else o=16;do if((o|0)==16){o=0;d=i9(41876)|0;if((d|0)==((e<<24>>24<0?f:e&255)|0)?(VG(p,41876,d)|0)==0:0)break;Mq(m,s,p);p2(k,m);O0(m);do if((!(rM(k)|0)?(v=a[g>>0]|0,n=v<<24>>24<0,(n?c[h>>2]|0:v&255)|0):0)?(c[(n?c[p>>2]|0:p)>>2]|0)!=46:0){d=c[q>>2]|0;if((d|0)==(c[r>>2]|0)){Ax(b,k);break}else{p2(d,k);c[q>>2]=(c[q>>2]|0)+12;break}}while(0);z5(k)}while(0);z5(p)}p9(j)}while(0);z5(s);l=t;return}function zg(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=l;l=l+304|0;t=C+200|0;j=C+196|0;z=C+184|0;A=C+172|0;x=C+168|0;y=C+8|0;w=C+4|0;v=C;i=c[f+4>>2]|0;xC(z,f,t,j);c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[A+(f<<2)>>2]=0;f=f+1|0}u=FX(i)|0;r=A+11|0;s=A+8|0;if((a[r>>0]|0)<0)f=(c[s>>2]&2147483647)+-1|0;else f=10;CC(A,f);k=(a[r>>0]|0)<0?c[A>>2]|0:A;c[x>>2]=k;c[w>>2]=y;c[v>>2]=0;q=A+4|0;p=c[j>>2]|0;j=k;k=d;i=d;while(1){if(!k){o=0;d=0;k=1}else{f=c[k+12>>2]|0;if((f|0)==(c[k+16>>2]|0))f=nb[c[(c[k>>2]|0)+36>>2]&255](k)|0;else f=raa(c[f>>2]|0)|0;n=d8(f,-1)|0;o=n?0:k;i=n?0:i;d=n?0:d;k=n}n=o+16|0;m=o+12|0;if(e){f=c[e+12>>2]|0;if((f|0)==(c[e+16>>2]|0))f=nb[c[(c[e>>2]|0)+36>>2]&255](e)|0;else f=raa(c[f>>2]|0)|0;if(!(d8(f,-1)|0)){if(!k)break}else B=17}else B=17;if((B|0)==17){B=0;if(k){e=0;break}else e=0}k=a[r>>0]|0;k=k<<24>>24<0?c[q>>2]|0:k&255;if((c[x>>2]|0)==(j+k|0)){CC(A,k<<1);if((a[r>>0]|0)<0)f=(c[s>>2]&2147483647)+-1|0;else f=10;CC(A,f);j=(a[r>>0]|0)<0?c[A>>2]|0:A;c[x>>2]=j+k}f=c[m>>2]|0;if((f|0)==(c[n>>2]|0))f=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else f=raa(c[f>>2]|0)|0;if(am(f,u,j,x,v,p,z,y,w,t)|0)break;f=c[m>>2]|0;if((f|0)==(c[n>>2]|0)){nb[c[(c[o>>2]|0)+40>>2]&255](o)|0;k=o;continue}else{c[m>>2]=f+4;k=o;continue}}t=a[z+11>>0]|0;f=c[w>>2]|0;if(((t<<24>>24<0?c[z+4>>2]|0:t&255)|0)!=0?(f-y|0)<160:0){t=c[v>>2]|0;v=f+4|0;c[w>>2]=v;c[f>>2]=t;f=v}b[h>>1]=Kx(j,c[x>>2]|0,g,u)|0;Vs(z,y,f,g);if(!o)j=1;else{f=c[m>>2]|0;if((f|0)==(c[n>>2]|0))f=nb[c[(c[d>>2]|0)+36>>2]&255](o)|0;else f=raa(c[f>>2]|0)|0;j=d8(f,-1)|0;i=j?0:i}if(e){f=c[e+12>>2]|0;if((f|0)==(c[e+16>>2]|0))f=nb[c[(c[e>>2]|0)+36>>2]&255](e)|0;else f=raa(c[f>>2]|0)|0;if(!(d8(f,-1)|0)){if(!j)B=45}else B=43}else B=43;if((B|0)==43?j:0)B=45;if((B|0)==45)c[g>>2]=c[g>>2]|2;a1(A);a1(z);l=C;return i|0}function Ag(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=l;l=l+304|0;s=B+200|0;i=B+196|0;y=B+184|0;z=B+172|0;w=B+168|0;x=B+8|0;v=B+4|0;u=B;h=c[e+4>>2]|0;xC(y,e,s,i);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[z+(e<<2)>>2]=0;e=e+1|0}t=FX(h)|0;q=z+11|0;r=z+8|0;if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(z,e);j=(a[q>>0]|0)<0?c[z>>2]|0:z;c[w>>2]=j;c[v>>2]=x;c[u>>2]=0;p=z+4|0;o=c[i>>2]|0;i=j;j=b;h=b;while(1){if(!j){n=0;b=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0))e=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else e=raa(c[e>>2]|0)|0;m=d8(e,-1)|0;n=m?0:j;h=m?0:h;b=m?0:b;j=m}m=n+16|0;k=n+12|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!j)break}else A=17}else A=17;if((A|0)==17){A=0;if(j){d=0;break}else d=0}j=a[q>>0]|0;j=j<<24>>24<0?c[p>>2]|0:j&255;if((c[w>>2]|0)==(i+j|0)){CC(z,j<<1);if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(z,e);i=(a[q>>0]|0)<0?c[z>>2]|0:z;c[w>>2]=i+j}e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[n>>2]|0)+36>>2]&255](n)|0;else e=raa(c[e>>2]|0)|0;if(am(e,t,i,w,u,o,y,x,v,s)|0)break;e=c[k>>2]|0;if((e|0)==(c[m>>2]|0)){nb[c[(c[n>>2]|0)+40>>2]&255](n)|0;j=n;continue}else{c[k>>2]=e+4;j=n;continue}}s=a[y+11>>0]|0;e=c[v>>2]|0;if(((s<<24>>24<0?c[y+4>>2]|0:s&255)|0)!=0?(e-x|0)<160:0){s=c[u>>2]|0;u=e+4|0;c[v>>2]=u;c[e>>2]=s;e=u}c[g>>2]=Yx(i,c[w>>2]|0,f,t)|0;Vs(y,x,e,f);if(!n)i=1;else{e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](n)|0;else e=raa(c[e>>2]|0)|0;i=d8(e,-1)|0;h=i?0:h}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!i)A=45}else A=43}else A=43;if((A|0)==43?i:0)A=45;if((A|0)==45)c[f>>2]=c[f>>2]|2;a1(z);a1(y);l=B;return h|0}function Bg(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=l;l=l+304|0;s=B+200|0;i=B+196|0;y=B+184|0;z=B+172|0;w=B+168|0;x=B+8|0;v=B+4|0;u=B;h=c[e+4>>2]|0;xC(y,e,s,i);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[z+(e<<2)>>2]=0;e=e+1|0}t=FX(h)|0;q=z+11|0;r=z+8|0;if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(z,e);j=(a[q>>0]|0)<0?c[z>>2]|0:z;c[w>>2]=j;c[v>>2]=x;c[u>>2]=0;p=z+4|0;o=c[i>>2]|0;i=j;j=b;h=b;while(1){if(!j){n=0;b=0;j=1}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0))e=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else e=raa(c[e>>2]|0)|0;m=d8(e,-1)|0;n=m?0:j;h=m?0:h;b=m?0:b;j=m}m=n+16|0;k=n+12|0;if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!j)break}else A=17}else A=17;if((A|0)==17){A=0;if(j){d=0;break}else d=0}j=a[q>>0]|0;j=j<<24>>24<0?c[p>>2]|0:j&255;if((c[w>>2]|0)==(i+j|0)){CC(z,j<<1);if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;CC(z,e);i=(a[q>>0]|0)<0?c[z>>2]|0:z;c[w>>2]=i+j}e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[n>>2]|0)+36>>2]&255](n)|0;else e=raa(c[e>>2]|0)|0;if(am(e,t,i,w,u,o,y,x,v,s)|0)break;e=c[k>>2]|0;if((e|0)==(c[m>>2]|0)){nb[c[(c[n>>2]|0)+40>>2]&255](n)|0;j=n;continue}else{c[k>>2]=e+4;j=n;continue}}s=a[y+11>>0]|0;e=c[v>>2]|0;if(((s<<24>>24<0?c[y+4>>2]|0:s&255)|0)!=0?(e-x|0)<160:0){s=c[u>>2]|0;u=e+4|0;c[v>>2]=u;c[e>>2]=s;e=u}c[g>>2]=Hu(i,c[w>>2]|0,f,t)|0;Vs(y,x,e,f);if(!n)i=1;else{e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))e=nb[c[(c[b>>2]|0)+36>>2]&255](n)|0;else e=raa(c[e>>2]|0)|0;i=d8(e,-1)|0;h=i?0:h}if(d){e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0))e=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0)){if(!i)A=45}else A=43}else A=43;if((A|0)==43?i:0)A=45;if((A|0)==45)c[f>>2]=c[f>>2]|2;a1(z);a1(y);l=B;return h|0}function Cg(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+16|0;q=w+11|0;r=w+10|0;k=w+9|0;m=w+4|0;n=w+8|0;o=w+7|0;p=w+6|0;s=b+795|0;a[s>>0]=0;g=b+796|0;a[g>>0]=0;h=b+798|0;a[h>>0]=0;i=b+872|0;c[i>>2]=0;Bx(b);KS(b);rR(b,22,w);KS(b);xR(b,6,q);v=b+648|0;A6(c[v>>2]|0);A6(c[v>>2]|0);A6(c[v>>2]|0);A6(c[v>>2]|0);KS(b);xR(b,5,r);A6(c[v>>2]|0);d4(c[v>>2]|0,7);a[k>>0]=0;if(LG(b)|0)yT(b,k);v=b+804|0;j=b+797|0;e=0;while(1){if(!(a[k>>0]|0))break;GC(b);a[o>>0]=0;xR(b,8,n);f=a[n>>0]|0;if(f<<24>>24==-73){KS(b);KS(b);RS(b);RS(b);RS(b);RS(b);RS(b);RS(b);RS(b);xR(b,8,o);KS(b);RS(b);KS(b);KS(b);RS(b);KS(b);KS(b);RS(b)}KS(b);KS(b);AT(b,p);sR(b,13,m);J3(b);a:do if(qO(b)|0){switch(f<<24>>24){case -67:{a[s>>0]=-1;if((c[(c[v>>2]|0)+22788>>2]|0)!=-1){c[i>>2]=(c[i>>2]|0)+1;break a}break}case -65:{a[g>>0]=-1;break}case -6:{a[h>>0]=-1;break}case -3:{a[j>>0]=-1;break}default:if((f&255)<=185)break a}c[(c[v>>2]|0)+((f&255)*120|0)+108>>2]=e;e=e+1|0}while(0);if(LG(b)|0)yT(b,k);else a[k>>0]=0}wK(b);f=b+794|0;e=a[f>>0]|0;if(e<<24>>24==-1){a[f>>0]=0;e=0}j=(d[q>>0]|0)+(e&255)&255;a[f>>0]=j;f=b+793|0;e=a[f>>0]|0;if(e<<24>>24==-1){a[f>>0]=0;e=0}i=(d[r>>0]|0)+(e&255)&255;a[f>>0]=i;h=(a[s>>0]|0)!=0;g=b+848|0;f=g;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h?(b=0==(f|0)?((c[b+800>>2]|0)*50|0)==(e|0):0,u=PZ(e|0,f|0,5)|0,t=z,b):0){f=g;c[f>>2]=u;c[f+4>>2]=t;f=t;e=u}if(f>>>0>0|(f|0)==0&e>>>0>8388608){u=g;c[u>>2]=8388608;c[u+4>>2]=0}e=c[v>>2]|0;if(!(j<<24>>24==0&(h^1)|i<<24>>24==0))a[e+22556>>0]=0;a[e+22676>>0]=1;l=w;return}function Dg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=c[d>>2]|0;m=d+4|0;if(e)if(!(c[m>>2]|0))n=d;else{e=gP(d)|0;n=e;e=c[e>>2]|0}else{n=d;e=0}j=n+4|0;k=c[(e|0?n:j)>>2]|0;l=(k|0)!=0;h=n+8|0;if(l)c[k+8>>2]=c[h>>2];e=c[h>>2]|0;f=e+4|0;if((c[e>>2]|0)==(n|0)){c[e>>2]=k;if((n|0)==(b|0)){b=k;i=0}else{e=f;o=9}}else{c[f>>2]=k;o=9}if((o|0)==9)i=c[e>>2]|0;f=n+12|0;g=(a[f>>0]|0)!=0;if((n|0)!=(d|0)){o=d+8|0;e=c[o>>2]|0;c[h>>2]=e;c[((c[c[o>>2]>>2]|0)==(d|0)?e:e+4|0)>>2]=n;e=c[d>>2]|0;c[n>>2]=e;c[e+8>>2]=n;e=c[m>>2]|0;c[j>>2]=e;if(e|0)c[e+8>>2]=n;a[f>>0]=a[d+12>>0]|0;b=(b|0)==(d|0)?n:b}a:do if(g&(b|0)!=0){if(l){a[k+12>>0]=1;break}while(1){e=c[i+8>>2]|0;f=i+12|0;g=(a[f>>0]|0)!=0;h=e+12|0;if((c[e>>2]|0)==(i|0)){if(g){e=i;k=b}else{a[f>>0]=1;a[h>>0]=0;IM(e);k=c[i+4>>2]|0;e=c[k>>2]|0;k=(b|0)==(k|0)?i:b}b=c[e>>2]|0;h=(b|0)==0;i=e+12|0;f=e+4|0;j=b+12|0;if(!h?(a[j>>0]|0)==0:0){o=43;break}f=c[f>>2]|0;g=e+8|0;if(f|0?(p=f+12|0,(a[p>>0]|0)==0):0){o=40;break}a[i>>0]=0;b=c[g>>2]|0;e=b+12|0;if((b|0)==(k|0)|(a[e>>0]|0)==0){o=39;break}else e=k}else{if(g){e=i;k=b}else{a[f>>0]=1;a[h>>0]=0;fN(e);k=c[i>>2]|0;e=c[k+4>>2]|0;k=(b|0)==(k|0)?i:b}o=c[e>>2]|0;f=e+12|0;b=c[e+4>>2]|0;g=b+12|0;h=o+12|0;i=(b|0)==0;j=e+8|0;if(o|0?(a[h>>0]|0)==0:0){o=28;break}if(!i?(a[g>>0]|0)==0:0){o=31;break}a[f>>0]=0;b=c[j>>2]|0;e=b+12|0;if((b|0)==(k|0)){o=27;break}if(!(a[e>>0]|0)){o=27;break}else e=k}i=c[b+8>>2]|0;i=c[((c[i>>2]|0)==(b|0)?i+4|0:i)>>2]|0;b=e}do if((o|0)==27){a[e>>0]=1;break a}else if((o|0)==28){if(!i?(a[g>>0]|0)==0:0){o=31;break}a[h>>0]=1;a[f>>0]=0;IM(e);b=c[j>>2]|0;e=b;b=c[b+4>>2]|0;o=31}else if((o|0)==39){a[e>>0]=1;break a}else if((o|0)==40){if(!h?(a[j>>0]|0)==0:0){o=43;break}a[p>>0]=1;a[i>>0]=0;fN(e);b=c[g>>2]|0;e=b;b=c[b>>2]|0;o=43}while(0);if((o|0)==31){p=c[e+8>>2]|0;o=p+12|0;a[e+12>>0]=a[o>>0]|0;a[o>>0]=1;a[b+12>>0]=1;fN(p);break}else if((o|0)==43){p=c[e+8>>2]|0;o=p+12|0;a[e+12>>0]=a[o>>0]|0;a[o>>0]=1;a[b+12>>0]=1;IM(p);break}}while(0);return}function Eg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;g=j;hJ(b);c[b>>2]=5464;e=b+72|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[e+(d<<2)>>2]=0;d=d+1|0}TX(b+84|0);T$(b+120|0);T$(b+160|0);T$(b+200|0);d=b+240|0;e=b+380|0;f=e+96|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));e=b+480|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;TX(e);h=b+668|0;c[h>>2]=0;c[b+672>>2]=0;c[b+676>>2]=0;x1(b+680|0);d=b+704|0;i=b+728|0;c[b+736>>2]=0;c[b+740>>2]=0;c[b+744>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;c[d+24>>2]=0;a[b+476>>0]=wU()|0;jT(g);vF(e,g)|0;z5(g);a[b+492>>0]=0;a[b+493>>0]=0;a[b+96>>0]=0;d=b+280|0;c[d>>2]=-1;c[d+4>>2]=-1;d=b+288|0;c[d>>2]=0;c[d+4>>2]=0;d=b+296|0;c[d>>2]=-1;c[d+4>>2]=-1;d=b+304|0;c[d>>2]=0;c[d+4>>2]=0;d=b+104|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[b+264>>2]=-1;c[b+268>>2]=0;c[b+272>>2]=0;c[b+276>>2]=0;d=b+360|0;e=b+312|0;f=e+48|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[d>>2]=-1;c[d+4>>2]=-1;c[d+8>>2]=-1;c[d+12>>2]=-1;a[b+494>>0]=1;a[b+495>>0]=0;a[b+733>>0]=0;a[b+734>>0]=0;a[b+735>>0]=0;c[b+544>>2]=0;g=b+600|0;c[b+548>>2]=0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;c[b+624>>2]=16777216;g=b+552|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;g=WO()|0;if((g|0)==0&(z|0)==0){d=1048576;e=0}else{d=WO()|0;e=z}f=b+632|0;c[f>>2]=d;c[f+4>>2]=e;f=e>>>0<4294967295|(e|0)==-1&d>>>0<4227858431;g=z0(d|0,e|0,67108864,0)|0;e=b+640|0;c[e>>2]=f?g:-1;c[e+4>>2]=f?z:-1;e=b+576|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;a[b+496>>0]=1;a[b+376>>0]=0;a[b+377>>0]=0;a[b+378>>0]=0;c[b+500>>2]=-1;c[b+504>>2]=1;e=b+656|0;c[e>>2]=0;c[e+4>>2]=0;a[b+512>>0]=0;e=b+528|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;NE(h);h=c[h>>2]|0;e=h;c[e>>2]=0;c[e+4>>2]=0;e=b+40|0;f=c[e+4>>2]|0;g=h+8|0;c[g>>2]=c[e>>2];c[g+4>>2]=f;a[h+16>>0]=0;a[h+17>>0]=0;a[h+18>>0]=0;c[b+664>>2]=0;c[b+508>>2]=0;h=ZW(16)|0;X1(h);c[b+648>>2]=h;h=ZW(76)|0;N6(h);c[b+652>>2]=h;c[i>>2]=c[i>>2]&-16;a[b+732>>0]=0;a[b+748>>0]=0;b=b+752|0;c[b>>2]=-1;c[b+4>>2]=-1;l=j;return}function Fg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;F=l;l=l+32|0;b=F+24|0;x=F+20|0;E=F+8|0;h=F;ID(a,b);do if(qO(a)|0){d=a+536|0;B=d;w=a+528|0;A=w;A=D_(c[B>>2]|0,c[B+4>>2]|0,c[A>>2]|0,c[A+4>>2]|0)|0;B=c[b>>2]|0;c[x>>2]=B;B=iaa(B)|0;C=a+544|0;D=a+612|0;A=(BX(B,x,(c[C>>2]|0)+(c[D>>2]|0)+4|0,A)|0)<0;b=c[d>>2]|0;d=c[d+4>>2]|0;if(A){e1(a,b,d);jaa(B);break}f=w;f=D_(b|0,d|0,c[f>>2]|0,c[f+4>>2]|0)|0;e1(a,f,z);c[E>>2]=0;f=E+4|0;c[f>>2]=0;c[E+8>>2]=0;y=a+508|0;A=c[y>>2]|0;g=E+8|0;b=A;while(1){if(!b)break;b=HN(a,0)|0;d=z;e=h;c[e>>2]=b;c[e+4>>2]=d;e=c[f>>2]|0;if(e>>>0<(c[g>>2]|0)>>>0){v=e;c[v>>2]=b;c[v+4>>2]=d;c[f>>2]=e+8}else Px(E,h);J3(a);b=c[y>>2]|0}f=c[C>>2]|0;g=a+548|0;h=c[g>>2]|0;i=a+600|0;j=c[i>>2]|0;k=a+604|0;m=c[k>>2]|0;n=c[D>>2]|0;o=a+616|0;p=c[o>>2]|0;c[C>>2]=0;c[g>>2]=0;c[i>>2]=0;c[k>>2]=0;c[D>>2]=0;c[o>>2]=0;q=a+48|0;s=q;r=c[s>>2]|0;s=c[s+4>>2]|0;t=a+40|0;v=t;u=c[v>>2]|0;v=c[v+4>>2]|0;b=w;b=z0(c[b>>2]|0,c[b+4>>2]|0,r|0,s|0)|0;e=c[x>>2]|0;b=z0(b|0,z|0,e|0,0)|0;d=z;if(v>>>0<d>>>0|(v|0)==(d|0)&u>>>0<b>>>0){x=t;c[x>>2]=b;c[x+4>>2]=d}else{b=u;d=v}c[y>>2]=1;Op(a,b,d);c[y>>2]=(c[y>>2]|0)+-1;x=a+864|0;c[x>>2]=-1;c[x+4>>2]=-1;c[C>>2]=B;c[g>>2]=e;do{}while(Vf(a)|0);jaa(B);B=q;c[B>>2]=r;c[B+4>>2]=s;B=t;c[B>>2]=u;c[B+4>>2]=v;c[C>>2]=f;c[g>>2]=h;c[i>>2]=j;c[k>>2]=m;c[D>>2]=n;c[o>>2]=p;while(1){if(!(c[y>>2]|0))break;J3(a)}c[y>>2]=1;B=t;C=q;b=c[D>>2]|0;D=D_(c[B>>2]|0,c[B+4>>2]|0,c[C>>2]|0,c[C+4>>2]|0)|0;b=D_(D|0,z|0,b|0,0)|0;Op(a,b,z);b=(c[y>>2]|0)+-1|0;c[y>>2]=b;while(1){if(b>>>0>=A>>>0)break;GC(a);GC(a);b=c[E>>2]|0;Op(a,c[b>>2]|0,c[b+4>>2]|0);J3(a);b=c[y>>2]|0}RB(a,0,0,68,378028,-1,1,0);aU(E)}while(0);l=F;return}function Gg(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=l;l=l+16|0;v=y;w=u$(c[i>>2]|0,409148)|0;t=u$(c[i>>2]|0,409156)|0;kb[c[(c[t>>2]|0)+20>>2]&63](v,t);c[h>>2]=f;i=a[b>>0]|0;switch(i<<24>>24){case 43:case 45:{u=tb[c[(c[w>>2]|0)+44>>2]&31](w,i)|0;i=c[h>>2]|0;c[h>>2]=i+4;c[i>>2]=u;i=b+1|0;break}default:i=b}u=e;a:do if((u-i|0)>1?(a[i>>0]|0)==48:0){j=i+1|0;switch(a[j>>0]|0){case 88:case 120:break;default:{j=i;x=10;break a}}r=tb[c[(c[w>>2]|0)+44>>2]&31](w,48)|0;s=c[h>>2]|0;c[h>>2]=s+4;c[s>>2]=r;i=i+2|0;s=tb[c[(c[w>>2]|0)+44>>2]&31](w,a[j>>0]|0)|0;j=c[h>>2]|0;c[h>>2]=j+4;c[j>>2]=s;j=i;while(1){if(j>>>0>=e>>>0)break a;s=a[j>>0]|0;b0()|0;if(!(daa(s)|0))break a;j=j+1|0}}else{j=i;x=10}while(0);b:do if((x|0)==10)while(1){x=0;if(j>>>0>=e>>>0)break b;s=a[j>>0]|0;b0()|0;if(!(R9(s)|0))break b;j=j+1|0;x=10}while(0);p=v+11|0;o=a[p>>0]|0;q=v+4|0;r=i;s=b;c:do if((o<<24>>24<0?c[q>>2]|0:o&255)|0){d:do if((i|0)!=(j|0)){b=j;k=i;while(1){b=b+-1|0;if(k>>>0>=b>>>0)break d;o=a[k>>0]|0;a[k>>0]=a[b>>0]|0;a[b>>0]=o;k=k+1|0}}while(0);o=nb[c[(c[t>>2]|0)+16>>2]&255](t)|0;b=0;k=0;while(1){if(i>>>0>=j>>>0)break;m=a[p>>0]|0;n=m<<24>>24<0;z=a[(n?c[v>>2]|0:v)+b>>0]|0;if(z<<24>>24>0&(k|0)==(z<<24>>24|0)){k=c[h>>2]|0;c[h>>2]=k+4;c[k>>2]=o;b=(b>>>0<((n?c[q>>2]|0:m&255)+-1|0)>>>0&1)+b|0;k=0}n=tb[c[(c[w>>2]|0)+44>>2]&31](w,a[i>>0]|0)|0;z=c[h>>2]|0;c[h>>2]=z+4;c[z>>2]=n;i=i+1|0;k=k+1|0}i=f+(r-s<<2)|0;k=c[h>>2]|0;if((i|0)!=(k|0)){b=k;while(1){b=b+-4|0;if(i>>>0>=b>>>0){i=k;break c}z=c[i>>2]|0;c[i>>2]=c[b>>2];c[b>>2]=z;i=i+4|0}}}else{rb[c[(c[w>>2]|0)+48>>2]&7](w,i,j,c[h>>2]|0)|0;i=(c[h>>2]|0)+(j-r<<2)|0;c[h>>2]=i}while(0);while(1){if(j>>>0>=e>>>0)break;i=a[j>>0]|0;j=j+1|0;if(i<<24>>24==46){x=28;break}r=tb[c[(c[w>>2]|0)+44>>2]&31](w,i)|0;z=c[h>>2]|0;i=z+4|0;c[h>>2]=i;c[z>>2]=r}if((x|0)==28){x=nb[c[(c[t>>2]|0)+12>>2]&255](t)|0;z=c[h>>2]|0;i=z+4|0;c[h>>2]=i;c[z>>2]=x}rb[c[(c[w>>2]|0)+48>>2]&7](w,j,e,i)|0;z=(c[h>>2]|0)+(u-j<<2)|0;c[h>>2]=z;c[g>>2]=(d|0)==(e|0)?z:f+(d-s<<2)|0;a1(v);l=y;return}function Hg(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;t=l;l=l+64|0;o=t+48|0;p=t+36|0;q=t+24|0;r=t+12|0;s=t;k=g5(d|0,e|0,1e3,0)|0;j=z;i=g5(d|0,e|0,6e4,0)|0;h=z;m=g5(d|0,e|0,36e5,0)|0;m=m&255;f=UW(m|0,0,-60,-1)|0;f=z0(f|0,z|0,i|0,h|0)|0;g=z;h=UW(i|0,h|0,-60,-1)|0;h=z0(h|0,z|0,k|0,j|0)|0;i=z;j=UW(k|0,j|0,-1e3,-1)|0;j=z0(j|0,z|0,d|0,e|0)|0;k=z;TX(o);TX(p);bk(o,m,0,10)|0;m=o+8+3|0;d=a[m>>0]|0;n=o+4|0;e=c[n>>2]|0;if((d<<24>>24<0?e:d&255)>>>0<2){Xy(s,42196);Mq(r,s,o);p2(q,r);k1(o,q)|0;z5(q);O0(r);z5(s);d=a[m>>0]|0;e=c[n>>2]|0}u=d<<24>>24<0;Ex(p,u?c[o>>2]|0:o,u?e:d&255)|0;HX(p,42204)|0;bk(o,f,g,10)|0;d=a[m>>0]|0;e=c[n>>2]|0;if((d<<24>>24<0?e:d&255)>>>0<2){Xy(s,42196);Mq(r,s,o);p2(q,r);k1(o,q)|0;z5(q);O0(r);z5(s);d=a[m>>0]|0;e=c[n>>2]|0}u=d<<24>>24<0;Ex(p,u?c[o>>2]|0:o,u?e:d&255)|0;HX(p,42204)|0;bk(o,h,i,10)|0;d=a[m>>0]|0;e=c[n>>2]|0;if((d<<24>>24<0?e:d&255)>>>0<2){Xy(s,42196);Mq(r,s,o);p2(q,r);k1(o,q)|0;z5(q);O0(r);z5(s);d=a[m>>0]|0;e=c[n>>2]|0}u=d<<24>>24<0;Ex(p,u?c[o>>2]|0:o,u?e:d&255)|0;HX(p,42212)|0;bk(o,j,k,10)|0;d=a[m>>0]|0;d=d<<24>>24<0?c[n>>2]|0:d&255;if(d>>>0>=2){if((d|0)==2){Xy(s,42196);Mq(r,s,o);p2(q,r);k1(o,q)|0;z5(q);O0(r);z5(s)}}else{Xy(s,42220);Mq(r,s,o);p2(q,r);k1(o,q)|0;z5(q);O0(r);z5(s)}u=a[m>>0]|0;s=u<<24>>24<0;Ex(p,s?c[o>>2]|0:o,s?c[n>>2]|0:u&255)|0;GX(b,(a[p+8+3>>0]|0)<0?c[p>>2]|0:p)|0;z5(p);z5(o);l=t;return b|0}function Ig(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;v=l;l=l+80|0;p=v+52|0;r=v+40|0;n=v+67|0;m=v+66|0;o=v+36|0;s=v+24|0;t=v+12|0;q=v;TX(p);TX(r);jZ(b,8,0,p);bB(b,v+68|0);bB(b,n);HB(b,v+64|0);bD(b,o);e=b+528|0;f=e;f=z0(c[f>>2]|0,c[f+4>>2]|0,2,0)|0;g=e;c[g>>2]=f;c[g+4>>2]=z;bB(b,m);m=a[m>>0]|0;g=e;f=c[g>>2]|0;g=c[g+4>>2]|0;if(m<<24>>24){j=z0(f|0,g|0,2,0)|0;k=z;h=e;c[h>>2]=j;c[h+4>>2]=k;h=a[n>>0]|0;i=h&255;d=0;while(1){if((d&255)>=(h&255))break;x=z0(j|0,k|0,1,0)|0;w=z;y=e;c[y>>2]=x;c[y+4>>2]=w;d=d+1<<24>>24;j=x;k=w}f=z0(f|0,g|0,i|0,0)|0;f=z0(f|0,z|0,2,0)|0;g=z}e=b+536|0;d=c[e>>2]|0;e=c[e+4>>2]|0;if(e>>>0>g>>>0|(e|0)==(g|0)&d>>>0>f>>>0){y=D_(d|0,e|0,f|0,g|0)|0;e1(b,y,z)}a:do if(qO(b)|0){W5(b);Kc(b,2,-1)|0;RB(b,2,0,18,388036,-1,1,0);RB(b,2,0,52,388036,-1,1,0);y=a[p+8+3>>0]|0;if((y<<24>>24<0?c[p+4>>2]|0:y&255)|0){y=c[o>>2]|0;lL(b,2,0,135,y|0?y:48e3,10,0);mL(b,2,0,122,a[n>>0]|0,10,0)}switch(m<<24>>24){case 0:{d=a[n>>0]|0;if((d&255)>2)break a;break}case 1:{d=a[n>>0]|0;break}default:break a}TX(s);f=d&255;cC(s,c[39180+(f<<2)>>2]|0)|0;TX(t);cC(t,c[39216+(f<<2)>>2]|0)|0;$x(q,b,2,0,128,1);f=a[s+8+3>>0]|0;e=f<<24>>24<0;f=e?c[s+4>>2]|0:f&255;y=a[q+8+3>>0]|0;d=y<<24>>24<0;if((f|0)==((d?c[q+4>>2]|0:y&255)|0)){y=(L$(e?c[s>>2]|0:s,d?c[q>>2]|0:q,f)|0)==0;z5(q);if(!y)u=17}else{z5(q);u=17}if((u|0)==17)zb(b,2,0,128,s,0);$x(q,b,2,0,129,1);e=a[t+8+3>>0]|0;d=e<<24>>24<0;e=d?c[t+4>>2]|0:e&255;y=a[q+8+3>>0]|0;f=y<<24>>24<0;if((e|0)==((f?c[q+4>>2]|0:y&255)|0)){y=(L$(d?c[t>>2]|0:t,f?c[q>>2]|0:q,e)|0)==0;z5(q);if(!y)u=21}else{z5(q);u=21}if((u|0)==21)zb(b,2,0,129,t,0);z5(t);z5(s)}while(0);a[b+760>>0]=1;z5(r);z5(p);l=v;return}function Jg(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;n=b+728|0;if(!((c[n>>2]&1|0)==0?!(HM(b)|0):0))e=3;do if((e|0)==3){l=c[b+612>>2]|0;m=b+528|0;k=m;j=c[k>>2]|0;w=j+l|0;e=c[b+544>>2]|0;p=a[e+w>>0]|0;r=p&255;p=(p&255)>>>7;q=r>>>2&31;s=d[e+(w+1)>>0]|0;r=r<<4&48|s>>>4;t=d[e+(w+2)>>0]|0;s=s<<3&56|t>>>5;w=d[e+(w+3)>>0]|0;t=t<<1&62|w>>>7;o=t&255;v=w&64;u=(v|0)==0;v=v>>>6&255;w=w>>>5&1;g=b+536|0;f=c[g>>2]|0;g=c[g+4>>2]|0;h=4;i=0;k=c[k+4>>2]|0;while(1){j=z0(h|0,i|0,j|0,k|0)|0;k=z;i=m;c[i>>2]=j;c[i+4>>2]=k;if(!(k>>>0<g>>>0|(k|0)==(g|0)&j>>>0<f>>>0))break;if(a[e+(j+l)>>0]|0)break;else{h=1;i=0}}if(!((j|0)==(f|0)&(k|0)==(g|0))){t4(b);break}if(qO(b)|0){ZB(b);if(!(c[n>>2]&1)){s_(b);AR(b,0,0);AR(b,178,0);AR(b,181,0);AR(b,184,0)}e=b+777|0;if(!(a[e>>0]|0)){f=b+916|0;g=b+988|0;h=b+880|0;if((c[f>>2]|0)==0?((a[g>>0]|0)==0?(r|q|s|t|0)==0:0):0){a[e>>0]=1;c[b+924>>2]=-1;e=h+11|0;if((a[e>>0]|0)<0){J7(c[h>>2]|0,0);c[b+884>>2]=0;break}else{J7(h,0);a[e>>0]=0;break}}c[f>>2]=(r*60|0)+(q*3600|0)+s;a[g>>0]=o;e=b+1017|0;if(!(a[e>>0]|0))a[e>>0]=1;e=b+1018|0;f=b+1028|0;g=b+1024|0;if(!(a[e>>0]|0)){a[e>>0]=1;a[b+1019>>0]=p;a[b+1020>>0]=v;a[b+1032>>0]=w;gy(h,((q>>>0)/10|0|48)&255);gy(h,((q>>>0)%10|0|48)&255);gy(h,58);gy(h,((r>>>0)/10|0|48)&255);gy(h,((r>>>0)%10|0|48)&255);gy(h,58);gy(h,((s>>>0)/10|0|48)&255);gy(h,((s>>>0)%10|0|48)&255);gy(h,p|58);gy(h,((t>>>0)/10|0|48)&255);gy(h,((t>>>0)%10|0|48)&255);c[g>>2]=0;c[f>>2]=0}if(u)c[f>>2]=(c[f>>2]|0)+1;else c[g>>2]=(c[g>>2]|0)+1;a[b+1039>>0]=0;f=b+1033|0;e=c[b+780>>2]|0;if(!(a[f>>0]|0))a[f>>0]=1;else a[e+553>>0]=0;a[e+2>>0]=1}}}while(0);return}function Kg(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;w=l;l=l+16|0;t=w;u=u$(c[i>>2]|0,409116)|0;s=u$(c[i>>2]|0,409132)|0;kb[c[(c[s>>2]|0)+20>>2]&63](t,s);c[h>>2]=f;i=a[b>>0]|0;switch(i<<24>>24){case 43:case 45:{r=tb[c[(c[u>>2]|0)+28>>2]&31](u,i)|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=r;j=b+1|0;break}default:j=b}r=e;a:do if((r-j|0)>1?(a[j>>0]|0)==48:0){i=j+1|0;switch(a[i>>0]|0){case 88:case 120:break;default:{i=j;v=10;break a}}p=tb[c[(c[u>>2]|0)+28>>2]&31](u,48)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q>>0]=p;j=j+2|0;q=tb[c[(c[u>>2]|0)+28>>2]&31](u,a[i>>0]|0)|0;i=c[h>>2]|0;c[h>>2]=i+1;a[i>>0]=q;i=j;while(1){if(i>>>0>=e>>>0)break a;q=a[i>>0]|0;b0()|0;if(!(daa(q)|0))break a;i=i+1|0}}else{i=j;v=10}while(0);b:do if((v|0)==10)while(1){v=0;if(i>>>0>=e>>>0)break b;q=a[i>>0]|0;b0()|0;if(!(R9(q)|0))break b;i=i+1|0;v=10}while(0);n=t+11|0;m=a[n>>0]|0;o=t+4|0;p=j;q=b;c:do if((m<<24>>24<0?c[o>>2]|0:m&255)|0){d:do if((j|0)!=(i|0)){b=i;k=j;while(1){b=b+-1|0;if(k>>>0>=b>>>0)break d;m=a[k>>0]|0;a[k>>0]=a[b>>0]|0;a[b>>0]=m;k=k+1|0}}while(0);m=nb[c[(c[s>>2]|0)+16>>2]&255](s)|0;k=0;b=0;while(1){if(j>>>0>=i>>>0)break;x=a[((a[n>>0]|0)<0?c[t>>2]|0:t)+b>>0]|0;if(x<<24>>24>0&(k|0)==(x<<24>>24|0)){k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=m;k=a[n>>0]|0;b=(b>>>0<((k<<24>>24<0?c[o>>2]|0:k&255)+-1|0)>>>0&1)+b|0;k=0}y=tb[c[(c[u>>2]|0)+28>>2]&31](u,a[j>>0]|0)|0;x=c[h>>2]|0;c[h>>2]=x+1;a[x>>0]=y;j=j+1|0;k=k+1|0}b=f+(p-q)|0;j=c[h>>2]|0;if((b|0)!=(j|0))while(1){j=j+-1|0;if(b>>>0>=j>>>0)break c;y=a[b>>0]|0;a[b>>0]=a[j>>0]|0;a[j>>0]=y;b=b+1|0}}else{rb[c[(c[u>>2]|0)+32>>2]&7](u,j,i,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(i-p)}while(0);while(1){if(i>>>0>=e>>>0)break;j=a[i>>0]|0;i=i+1|0;if(j<<24>>24==46){v=28;break}x=tb[c[(c[u>>2]|0)+28>>2]&31](u,j)|0;y=c[h>>2]|0;c[h>>2]=y+1;a[y>>0]=x}if((v|0)==28){x=nb[c[(c[s>>2]|0)+12>>2]&255](s)|0;y=c[h>>2]|0;c[h>>2]=y+1;a[y>>0]=x}rb[c[(c[u>>2]|0)+32>>2]&7](u,i,e,c[h>>2]|0)|0;y=(c[h>>2]|0)+(r-i)|0;c[h>>2]=y;c[g>>2]=(d|0)==(e|0)?y:f+(d-q)|0;a1(t);l=w;return}function Lg(b){b=b|0;var e=0,f=0,i=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;p=b+728|0;k=b+536|0;do if(!(c[p>>2]&2)){GC(b);yL(b);if((d[b+806>>0]|0)<4){to(b);e1(b,16,0);Am(b);e1(b,5,0);TN(b);hF(b);e1(b,3,0);Qe(b);e1(b,38,0);Mw(b);e1(b,3,0);bJ(b);J3(b);GC(b);m=k;q=b+528|0;o=q;n=c[o>>2]|0;o=c[o+4>>2]|0;m=z0(c[m>>2]|0,c[m+4>>2]|0,-4,-1)|0;o=D_(m|0,z|0,n|0,o|0)|0;e1(b,o,z);J3(b);GC(b);o=q;o=z0(c[o>>2]|0,c[o+4>>2]|0,4,0)|0;c[q>>2]=o;c[q+4>>2]=z;J3(b);break}else{J3(b);o=k;q=b+528|0;q=D_(c[o>>2]|0,c[o+4>>2]|0,c[q>>2]|0,c[q+4>>2]|0)|0;e1(b,q,z);break}}else{q=k;e1(b,c[q>>2]|0,c[q+4>>2]|0)}while(0);if(qO(b)|0){q=b+312|0;m=q;m=z0(c[m>>2]|0,c[m+4>>2]|0,1,0)|0;e=q;c[e>>2]=m;c[e+4>>2]=z;e=b+328|0;m=e;l=c[m>>2]|0;m=c[m+4>>2]|0;i=z0(l|0,m|0,1,0)|0;c[e>>2]=i;c[e+4>>2]=z;e=b+360|0;i=e;f=c[i>>2]|0;i=c[i+4>>2]|0;if(!((f|0)==-1&(i|0)==-1)){n=z0(f|0,i|0,1,0)|0;o=e;c[o>>2]=n;c[o+4>>2]=z}j=+h[b+768>>3];n=b+144|0;i=b+152|0;o=b+136|0;if(j!=0.0){l=cT(1.0e9/j)|0;m=z;f=n;f=z0(c[f>>2]|0,c[f+4>>2]|0,l|0,m|0)|0;k=z;c[n>>2]=f;c[n+4>>2]=k;c[o>>2]=f;c[o+4>>2]=k;o=i;c[o>>2]=l;c[o+4>>2]=m}else{e=i;f=c[e>>2]|0;e=c[e+4>>2]|0;if((f|0)==-1&(e|0)==-1){e=i;c[e>>2]=-1;c[e+4>>2]=-1;e=-1;f=-1}else{if((l|0)==0&(m|0)==0){m=k;m=g5(c[b+548>>2]|0,0,c[m>>2]|0,c[m+4>>2]|0)|0;f=g5(f|0,e|0,m|0,z|0)|0;e=z;m=i;c[m>>2]=f;c[m+4>>2]=e}m=n;e=z0(c[m>>2]|0,c[m+4>>2]|0,f|0,e|0)|0;f=z}c[n>>2]=e;c[n+4>>2]=f;c[o>>2]=e;c[o+4>>2]=f}e=c[p>>2]|0;if(!(e&1)){W5(b);e=c[p>>2]|0}if((((e&2|0)==0?(p=q,n=c[p+4>>2]|0,q=b+760|0,o=c[q+4>>2]|0,!(n>>>0<o>>>0|((n|0)==(o|0)?(c[p>>2]|0)>>>0<(c[q>>2]|0)>>>0:0))):0)?(t6(b),(a[b+492>>0]|0)==0):0)?+g[(c[b+24>>2]|0)+136>>2]<1.0:0)V5(b)}return}function Mg(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;r=l;l=l+80|0;g=r+73|0;i=r+72|0;k=r+60|0;m=r+48|0;n=r+36|0;o=r+24|0;p=r+12|0;q=r;bB(b,g);Bx(b);GC(b);j=b+648|0;A6(c[j>>2]|0);A6(c[j>>2]|0);A6(c[j>>2]|0);A6(c[j>>2]|0);A6(c[j>>2]|0);A6(c[j>>2]|0);A6(c[j>>2]|0);A6(c[j>>2]|0);J3(b);wK(b);bB(b,i);Bx(b);A6(c[j>>2]|0);A6(c[j>>2]|0);d4(c[j>>2]|0,6);wK(b);if((qO(b)|0?(a[b+768>>0]|0)==2:0)?a[b+784>>0]|0:0){Xy(k,39980);j=b+760|0;h=b+772|0;d=c[(c[(c[j>>2]|0)+80>>2]|0)+(e[h>>1]<<2)>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(384476)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;b=m}else{s=f+16&-16;b=ZW(s)|0;c[m>>2]=b;c[m+8>>2]=s|-2147483648;c[m+4>>2]=f}i1(b,384476,f)|0;J7(b+f|0,0);vF(VC(d+28|0,m)|0,k)|0;a1(m);z5(k);TX(o);cC(o,Fz(a[g>>0]|0)|0)|0;Bs(n,o,39996);TX(p);b=a[i>>0]|0;io(p,+(b&255)/10.0,((b&255)%10|0)<<24>>24!=0&1)|0;b=a[p+8+3>>0]|0;s=b<<24>>24<0;Ex(n,s?c[p>>2]|0:p,s?c[p+4>>2]|0:b&255)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}p2(k,m);d=c[(c[(c[j>>2]|0)+80>>2]|0)+(e[h>>1]<<2)>>2]|0;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[q+11>>0]=f;b=q}else{s=f+16&-16;b=ZW(s)|0;c[q>>2]=b;c[q+8>>2]=s|-2147483648;c[q+4>>2]=f}i1(b,384616,f)|0;J7(b+f|0,0);vF(VC(d+28|0,q)|0,k)|0;a1(q);z5(k);O0(m);z5(p);O0(n);z5(o)}l=r;return}function Ng(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+32|0;e=u+12|0;f=u+20|0;g=u+19|0;i=u+18|0;k=u+17|0;m=u+16|0;s=u;n=(a[b+1116>>0]|0)==3;n=(a[b+1112>>0]|0)==3?(n?17:32):n?9:17;d=c[b+612>>2]|0;do if((d+128+n|0)>>>0<(c[b+548>>2]|0)>>>0){r=(c[b+544>>2]|0)+d+n|0;d=C9(r)|0;if((d|0)!=(W8(372802)|0)?(d|0)!=(W8(387681)|0):0){d=0;break}GC(b);GC(b);e1(b,n,0);KK(b);ID(b,e);j=c[e>>2]|0;pY(j,0,0,f);pY(j,0,1,g);pY(j,0,2,i);pY(j,0,3,k);pY(j,0,4,m);j=a[f>>0]|0;h=a[g>>0]|0;g=a[i>>0]|0;f=a[k>>0]|0;d=a[m>>0]|0;J3(b);e=b+536|0;m=e;n=D_(c[m>>2]|0,c[m+4>>2]|0,n|0,0)|0;m=z;if(0>m>>>0|(0==(m|0)?((h<<24>>24?4:0)+(j<<24>>24?12:8)+(g<<24>>24?100:0)+(f<<24>>24?4:0)+(d<<24>>24?348:0)|0)>>>0>n>>>0:0))d=0;else{i=b+1096|0;if(j<<24>>24)ID(b,i);if(h<<24>>24?(ID(b,s),o=c[s>>2]|0,q=e,p=c[q>>2]|0,q=c[q+4>>2]|0,n=z0(p|0,q|0,4,0)|0,m=z,0>m>>>0|0==(m|0)&o>>>0>n>>>0):0){p=D_(o+-4|0,0,p|0,q|0)|0;q=b+1088|0;c[q>>2]=p;c[q+4>>2]=z}if(g<<24>>24)e1(b,100,0);if(f<<24>>24)ID(b,b+1104|0);TX(s);J3(b);cy(b,4,0,s);do if(!(d<<24>>24)){d=i9(15548)|0;g=s+8+3|0;f=a[g>>0]|0;h=s+4|0;e=c[h>>2]|0;if((d|0)==((f<<24>>24<0?e:f&255)|0)){if(!(VG(s,15548,d)|0)){t=24;break}f=a[g>>0]|0;e=c[h>>2]|0}d=i9(15568)|0;if((d|0)==((f<<24>>24<0?e:f&255)|0)){if(!(VG(s,15568,d)|0)){t=24;break}f=a[g>>0]|0;e=c[h>>2]|0}d=i9(15588)|0;if((d|0)==((f<<24>>24<0?e:f&255)|0)?(VG(s,15588,d)|0)==0:0)t=24}else t=24;while(0);if((t|0)==24)pd(b);t=C9(r)|0;if((t|0)==(W8(387681)|0))c[i>>2]=0;NP(b+980|0);NP(b+992|0);z5(s);d=1}}else d=0;while(0);l=u;return d|0}function Og(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+80|0;g=p+72|0;f=p+76|0;i=p+60|0;j=p+48|0;k=p+36|0;m=p+24|0;n=p+12|0;o=p;NB(d,f);jB(d,g);Bx(d);d4(c[d+648>>2]|0,4);h=d+770|0;sR(d,12,h);wK(d);if(b[h>>1]|0)Ao(d);h=d+528|0;e=h;e=z0(c[e>>2]|0,c[e+4>>2]|0,4,0)|0;c[h>>2]=e;c[h+4>>2]=z;if(qO(d)|0){h=d+764|0;d=c[h>>2]|0;e=a[d+36+3>>0]|0;if(e<<24>>24<0)d=c[d+32>>2]|0;else d=e&255;e=b[f>>1]|0;if(!d){ci(n,e);DW(n,0,42232)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];d=0;while(1){if((d|0)==3)break;c[n+(d<<2)>>2]=0;d=d+1|0}HX(m,42252)|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];d=0;while(1){if((d|0)==3)break;c[m+(d<<2)>>2]=0;d=d+1|0}Qh(o,c[g>>2]|0);d=a[o+8+3>>0]|0;f=d<<24>>24<0;Ex(k,f?c[o>>2]|0:o,f?c[o+4>>2]|0:d&255)|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];d=0;while(1){if((d|0)==3)break;c[k+(d<<2)>>2]=0;d=d+1|0}p2(i,j);vF((c[h>>2]|0)+28|0,i)|0;z5(i);O0(j);z5(o);O0(k);O0(m);z5(n)}ci(n,e);DW(n,0,42232)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];d=0;while(1){if((d|0)==3)break;c[n+(d<<2)>>2]=0;d=d+1|0}HX(m,42252)|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];d=0;while(1){if((d|0)==3)break;c[m+(d<<2)>>2]=0;d=d+1|0}Qh(o,c[g>>2]|0);d=a[o+8+3>>0]|0;g=d<<24>>24<0;Ex(k,g?c[o>>2]|0:o,g?c[o+4>>2]|0:d&255)|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];d=0;while(1){if((d|0)==3)break;c[k+(d<<2)>>2]=0;d=d+1|0}p2(i,j);vF((c[h>>2]|0)+40|0,i)|0;z5(i);O0(j);z5(o);O0(k);O0(m);z5(n);a[(c[h>>2]|0)+52>>0]=1}l=p;return}function Pg(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+16|0;f=s+4|0;p=s+6|0;q=s+2|0;r=s;bB(d,p);if(!(a[p>>0]|0)){NB(d,f);n=d+528|0;o=d+770|0;p=d+764|0;i=b[f>>1]|0;h=d+648|0;g=0;while(1){if((g&65535)>=(i&65535))break;GC(d);NB(d,q);Bx(d);d4(c[h>>2]|0,3);sR(d,13,r);d4(c[h>>2]|0,3);d4(c[h>>2]|0,5);wK(d);j=n;j=z0(c[j>>2]|0,c[j+4>>2]|0,4,0)|0;k=n;c[k>>2]=j;c[k+4>>2]=z;Bx(d);d4(c[h>>2]|0,4);sR(d,12,o);wK(d);if(b[o>>1]|0)Ao(d);J3(d);if(qO(d)|0){j=e[r>>1]|0;f=c[(c[(c[p>>2]|0)+80>>2]|0)+(j<<2)>>2]|0;k=b[q>>1]|0;a:do if(!(c[f+64>>2]|0)){switch(k<<16>>16){case 3:case 1:{f=15;break a}default:{}}UZ(f,1);f=c[(c[(c[p>>2]|0)+80>>2]|0)+(j<<2)>>2]|0;c[f+64>>2]=2;nG(f+16|0);f=12}else f=12;while(0);b:do if((f|0)==12)switch(k<<16>>16){case 0:{m=200;f=21;break b}case 2:{m=201;f=21;break b}case 4:{m=204;f=21;break b}default:{f=15;break b}}while(0);c:do if((f|0)==15){f=0;switch((k&-128)<<16>>16){case 256:{m=203;f=21;break c}case 512:{m=204;f=21;break c}default:{}}if((k+-769&65535)>=255)if((k+-4096&65535)>=255)if((k+-4352&65535)>=255){if((k+-5632&65535)<=254){m=218;f=21}}else{m=215;f=21}else{m=214;f=21}else{m=202;f=21}}while(0);if((f|0)==21?(0,(c[(c[(c[(c[(c[p>>2]|0)+80>>2]|0)+(j<<2)>>2]|0)+16>>2]|0)+(m<<2)>>2]|0)==0):0){f=ZW(16)|0;M0(f);c[(c[(c[(c[(c[p>>2]|0)+80>>2]|0)+(j<<2)>>2]|0)+16>>2]|0)+(m<<2)>>2]=f}k=k&65535;b[(c[(c[(c[p>>2]|0)+80>>2]|0)+(j<<2)>>2]|0)+166>>1]=k-(k>>>1&256)}g=g+1<<16>>16}Bx(d);d4(c[h>>2]|0,4);sR(d,12,o);wK(d);if(b[o>>1]|0)Ao(d)}else{q=d+536|0;r=d+528|0;r=D_(c[q>>2]|0,c[q+4>>2]|0,c[r>>2]|0,c[r+4>>2]|0)|0;e1(d,r,z)}l=s;return}function Qg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+64|0;r=s+36|0;j=s+24|0;k=s+12|0;m=s;g=1;while(1){if((g|0)==7)break;c[r+(g<<2)>>2]=RA(b,g,-1)|0;g=g+1|0}q=b+16|0;c[q>>2]=7;i=e+28|0;g=c[i>>2]|0;if(((g|0)!=(c[e+32>>2]|0)?(h=c[g>>2]|0,(h|0)!=0):0)?(c[h+728>>2]&1|0)!=0:0){s4(h);if((RA(c[c[i>>2]>>2]|0,1,-1)|0)!=0?(RA(c[c[i>>2]>>2]|0,3,-1)|0)!=0:0){Kc(b,1,-1)|0;g=Gb(b,c[c[i>>2]>>2]|0,1,0,c[b+20>>2]|0,1)|0}else g=Cp(b,c[c[i>>2]>>2]|0)|0;$x(j,c[c[i>>2]>>2]|0,0,0,250,1);o=a[j+8+3>>0]|0;if((o<<24>>24<0?c[j+4>>2]|0:o&255)|0)zb(b,0,0,250,j,1);$x(k,c[c[i>>2]>>2]|0,0,0,159,1);o=a[k+8+3>>0]|0;if((o<<24>>24<0?c[k+4>>2]|0:o&255)|0?($x(m,b,0,0,159,1),o=a[m+8+3>>0]|0,o=((o<<24>>24<0?c[m+4>>2]|0:o&255)|0)==0,z5(m),o):0)zb(b,0,0,159,k,0);z5(k);z5(j);if((c[q>>2]|0)==7)p=17}else{g=0;p=17}do if((p|0)==17){k=e+12|0;m=a[k>>0]|0;if((d|0)==189&m<<24>>24!=0){o=c[b+816>>2]|0;n=((c[b+820>>2]|0)-o|0)/120|0;j=0;h=0;while(1){if((j|0)==(n|0))break;i=c[o+(j*120|0)+28>>2]|0;if((i|0)!=(c[o+(j*120|0)+32>>2]|0))h=h|(c[i>>2]|0)!=0;j=j+1|0}if(h)a[k>>0]=0;else p=25}else p=25;if((p|0)==25)if(m<<24>>24){Kc(b,hj(m&255,0)|0,-1)|0;if((c[q>>2]|0)==7)g=1;else{g=1;break}}if((c[e+104>>2]|0)>>>0>16){if((d&-32|0)==192){Kc(b,2,-1)|0;g=1}if((d&-16|0)==224){Kc(b,1,-1)|0;g=1}}}while(0);c[e+8>>2]=g;h=c[q>>2]|0;if((h|0)==2)if(!(c[b+780>>2]|0))h=2;else{RB(b,2,c[b+20>>2]|0,44,378437,-1,1,0);h=c[q>>2]|0}p=(c[r+(h<<2)>>2]|0)+g|0;if((p|0)==(RA(b,h,-1)|0))Fc(b,d,e,f,g);else{h=c[q>>2]|0;g=1;while(1){if((g|0)==7)break;c[q>>2]=g;p=RA(b,g,-1)|0;Fc(b,d,e,f,p-(c[r+(g<<2)>>2]|0)|0);g=g+1|0}c[q>>2]=h}l=s;return}function Rg(a){a=a|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+64|0;o=w+40|0;r=w+52|0;s=w+62|0;t=w+60|0;f=w+58|0;g=w+56|0;u=w;k=w+32|0;m=a+528|0;d=m;d=z0(c[d>>2]|0,c[d+4>>2]|0,16,0)|0;n=m;c[n>>2]=d;c[n+4>>2]=z;bD(a,r);n=m;n=z0(c[n>>2]|0,c[n+4>>2]|0,24,0)|0;d=m;c[d>>2]=n;c[d+4>>2]=z;bD(a,w+48|0);HB(a,s);HB(a,t);Uy(a,o);HB(a,f);HB(a,g);f=b[f>>1]|0;d=0;while(1){if((d&65535)>=(f&65535))break;GC(a);j=m;j=z0(c[j>>2]|0,c[j+4>>2]|0,2,0)|0;n=m;c[n>>2]=j;c[n+4>>2]=z;HB(a,u);iF(a,e[u>>1]|0,0);J3(a);d=d+1<<16>>16}j=u+16|0;n=a+760|0;i=b[g>>1]|0;h=0;while(1){if((h&65535)>=(i&65535))break;GC(a);S5(u);j0(a,u);HB(a,j);bD(a,k);d=c[k>>2]|0;if(d|0)e1(a,d,0);J3(a);d=sF(n,s)|0;f=d+72|0;g=c[f>>2]|0;if((g|0)==(c[d+76>>2]|0))Gv(d+68|0,u);else{$T(g,u);c[f>>2]=(c[f>>2]|0)+32}h=h+1<<16>>16}i=m;g=c[i+4>>2]|0;d=a+536|0;j=d;h=c[j+4>>2]|0;if(g>>>0<h>>>0|((g|0)==(h|0)?(c[i>>2]|0)>>>0<(c[j>>2]|0)>>>0:0)){L2(u);GC(a);GC(a);j0(a,u);Uy(a,k);J3(a);j=k;i=c[j>>2]|0;j=c[j+4>>2]|0;g=m;h=c[g>>2]|0;g=c[g+4>>2]|0;f=d;d=c[f>>2]|0;f=c[f+4>>2]|0;do if(j>>>0>0|(j|0)==0&i>>>0>23?(p=z0(i|0,j|0,-24,-1)|0,q=z,m=z0(p|0,q|0,h|0,g|0)|0,(m|0)==(d|0)&(z|0)==(f|0)):0){u=u+8|0;if((c[u>>2]|0)==-1213608175?(c[u+4>>2]|0)==-1861755721:0){Ee(a);break}else{e1(a,p,q);break}}else v=18;while(0);if((v|0)==18){v=D_(d|0,f|0,h|0,g|0)|0;e1(a,v,z)}J3(a)}v=sF(n,s)|0;b[v+36>>1]=b[t>>1]|0;c[v+32>>2]=c[r>>2];t=o;u=c[t+4>>2]|0;v=v+24|0;c[v>>2]=c[t>>2];c[v+4>>2]=u;l=w;return}function Sg(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;a[d>>0]=a[e>>0]|0;h=d+4|0;x1(h);i=e+8|0;j=d+8|0;f=c[e+4>>2]|0;a:while(1){if((f|0)==(i|0))break;g=f+16|0;Hr(h,j,g,g);g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue a}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}h=d+16|0;x1(h);i=e+20|0;j=d+20|0;f=c[e+16>>2]|0;b:while(1){if((f|0)==(i|0))break;g=f+16|0;Hr(h,j,g,g);g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue b}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}h=d+28|0;x1(h);i=e+32|0;j=d+32|0;f=c[e+28>>2]|0;c:while(1){if((f|0)==(i|0))break;g=f+16|0;Hr(h,j,g,g);g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue c}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}h=d+40|0;x1(h);i=e+44|0;j=d+44|0;f=c[e+40>>2]|0;d:while(1){if((f|0)==(i|0))break;g=f+16|0;st(h,j,g,g);g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue d}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}FK(d+52|0,e+52|0);c[d+64>>2]=c[e+64>>2];c[d+68>>2]=c[e+68>>2];b[d+72>>1]=b[e+72>>1]|0;b[d+74>>1]=b[e+74>>1]|0;b[d+76>>1]=b[e+76>>1]|0;a[d+78>>0]=a[e+78>>0]|0;a[d+79>>0]=a[e+79>>0]|0;a[d+80>>0]=a[e+80>>0]|0;a[d+81>>0]=a[e+81>>0]|0;a[d+82>>0]=a[e+82>>0]|0;a[d+83>>0]=a[e+83>>0]|0;a[d+84>>0]=a[e+84>>0]|0;a[d+85>>0]=a[e+85>>0]|0;x1(d+88|0);a[d+100>>0]=a[e+100>>0]|0;c[d+104>>2]=c[e+104>>2];return}function Tg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a:while(1){m=b;n=b+-4|0;while(1){l=a;b:while(1){k=l;d=m-k|0;e=d>>2;a=l+4|0;switch(e|0){case 1:case 0:break a;case 2:{q=5;break a}case 3:{q=7;break a}case 4:{q=8;break a}case 5:{q=9;break a}default:{}}if((d|0)<124){q=11;break a}h=l+(((e|0)/2|0)<<2)|0;if((d|0)>3996){d=(e|0)/4|0;d=Tx(l,l+(d<<2)|0,h,h+(d<<2)|0,n)|0}else d=Ey(l,h,n)|0;i=c[l>>2]|0;f=c[h>>2]|0;if(i>>>0<f>>>0){e=n;break}else e=n;while(1){e=e+-4|0;if((l|0)==(e|0))break;g=c[e>>2]|0;if(g>>>0<f>>>0){q=28;break b}}f=c[n>>2]|0;if(i>>>0>=f>>>0){d=a;while(1){if((d|0)==(n|0))break a;e=c[d>>2]|0;a=d+4|0;if(i>>>0<e>>>0)break;else d=a}c[d>>2]=f;c[n>>2]=e}if((a|0)==(n|0))break a;else d=n;while(1){h=c[l>>2]|0;while(1){f=c[a>>2]|0;g=a+4|0;if(h>>>0<f>>>0)break;else a=g}do{d=d+-4|0;e=c[d>>2]|0}while(h>>>0<e>>>0);if(a>>>0>=d>>>0){l=a;continue b}c[a>>2]=e;c[d>>2]=f;a=g}}if((q|0)==28){q=0;c[l>>2]=g;c[e>>2]=i;d=d+1|0}c:do if(a>>>0<e>>>0){j=h;while(1){i=c[j>>2]|0;while(1){g=c[a>>2]|0;h=a+4|0;if(g>>>0<i>>>0)a=h;else break}do{e=e+-4|0;f=c[e>>2]|0}while(f>>>0>=i>>>0);if(a>>>0>e>>>0){e=j;f=a;break c}c[a>>2]=f;c[e>>2]=g;j=(j|0)==(a|0)?e:j;a=h;d=d+1|0}}else{e=h;f=a}while(0);if((f|0)!=(e|0)?(o=c[e>>2]|0,p=c[f>>2]|0,o>>>0<p>>>0):0){c[f>>2]=o;c[e>>2]=p;d=d+1|0}a=f+4|0;if(!d){d=_n(l,f)|0;if(_n(a,b)|0){q=44;break}if(d)continue}j=f;if((j-k|0)>=(m-j|0)){q=43;break}Tg(l,f)}if((q|0)==43){q=0;Tg(a,b);a=l;b=f;continue}else if((q|0)==44){q=0;if(d)break;else{a=l;b=f;continue}}}if((q|0)==5){a=c[n>>2]|0;b=c[l>>2]|0;if(a>>>0<b>>>0){c[l>>2]=a;c[n>>2]=b}}else if((q|0)==7)Ey(l,a,n)|0;else if((q|0)==8)IB(l,a,l+8|0,n)|0;else if((q|0)==9)Tx(l,a,l+8|0,l+12|0,n)|0;else if((q|0)==11)OB(l,b);return}function Ug(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+16|0;f=v;q=v+4|0;r=v+3|0;s=v+2|0;Bx(b);t=b+1112|0;if((a[t>>0]|0)==3)sR(b,9,f);else sR(b,8,f);g=e[f>>1]|0;f=b+1100|0;if(g>>>0>(c[f>>2]|0)>>>0)c[f>>2]=g;p=b+1076|0;c[p>>2]=(c[p>>2]|0)+g;p=b+1116|0;f=(a[p>>0]|0)==3;g=c[b+648>>2]|0;do if((a[t>>0]|0)==3)if(f){d4(g,5);break}else{d4(g,3);break}else if(f){d4(g,1);break}else{d4(g,2);break}while(0);if((a[t>>0]|0)==3){GC(b);h=b+1068|0;g=0;while(1){if((g&255)>>>0<(e[61546+(d[p>>0]<<1)>>1]|0)>>>0)f=0;else break;while(1){if((f&255)>=4)break;AT(b,q);if(a[q>>0]|0)c[h>>2]=(c[h>>2]|0)+1;f=f+1<<24>>24}g=g+1<<24>>24}J3(b)}k=b+1008|0;m=b+1072|0;n=b+1012|0;o=b+1016|0;j=b+648|0;i=0;while(1){if((i&255)>>>0>=((a[t>>0]|0)==3?2:1)>>>0){u=50;break}GC(b);f=a[p>>0]|0;if((f&255)>3)break;else h=0;while(1){if((h&255)>>>0>=(e[61546+((f&255)<<1)>>1]|0)>>>0)break;GC(b);d4(c[j>>2]|0,12);d4(c[j>>2]|0,9);d4(c[j>>2]|0,8);f=c[j>>2]|0;if((a[t>>0]|0)==3)d4(f,4);else d4(f,9);AT(b,q);if(!(a[q>>0]|0)){f=0;while(1){g=c[j>>2]|0;if((f&255)>=3)break;d4(g,5);f=f+1<<24>>24}d4(g,4);d4(c[j>>2]|0,3);c[k>>2]=(c[k>>2]|0)+1}else{xR(b,2,r);AT(b,s);f=0;while(1){if((f&255)>=2){f=0;break}d4(c[j>>2]|0,5);f=f+1<<24>>24}while(1){if((f&255)>=3)break;d4(c[j>>2]|0,3);f=f+1<<24>>24}do if((a[r>>0]|0)==2)if(!(a[s>>0]|0)){c[n>>2]=(c[n>>2]|0)+1;break}else{c[o>>2]=(c[o>>2]|0)+1;break}else c[k>>2]=(c[k>>2]|0)+1;while(0)}if((a[t>>0]|0)==3)A6(c[j>>2]|0);AT(b,r);if(a[r>>0]|0)c[m>>2]=(c[m>>2]|0)+1;A6(c[j>>2]|0);J3(b);h=h+1<<24>>24;f=a[p>>0]|0}J3(b);i=i+1<<24>>24}if((u|0)==50)wK(b);l=v;return}function Vg(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+16|0;q=v+4|0;p=v+3|0;s=v+2|0;t=v+1|0;u=v;GC(b);AT(b,q);q=(a[q>>0]|0)==0;e=b+917|0;if(!q){AT(b,e);o=(a[e>>0]|0)==0;GC(b);e=b+648|0;n=c[e>>2]|0;G4(n,Z9(c[n+4>>2]|0)|0);J3(b);if(o){o=e;r=4}}else{a[e>>0]=0;o=b+648|0;r=4}if((r|0)==4){j=b+2461|0;AT(b,j);xR(b,6,b+913|0);k=b+914|0;xR(b,4,k);m=b+915|0;e=0;i=0;while(1){n=i&255;if((i&255)>(d[k>>0]|0))break;xR(b,3,m);h=0;while(1){if((h&255)>(d[m>>0]|0))break;g=e&255;a[b+1046+g>>0]=i;a[b+1174+g>>0]=h;g=e+1<<24>>24;f=(h&255)+(b+918+(n<<3))|0;a[f>>0]=e;if((h|i)<<24>>24){AT(b,p);if(!(a[p>>0]|0))r=13}else{a[p>>0]=0;r=13}do if((r|0)==13){r=0;if(q){yd(b,-1);break}else{e=IG(b)|0;yd(b,(Z9(c[(c[o>>2]|0)+4>>2]|0)|0)-e|0);break}}while(0);xR(b,3,(d[f>>0]|0)+(b+1558)|0);e=d[f>>0]|0;switch(a[b+1558+e>>0]|0){case 0:{d4(c[o>>2]|0,8);if(!(a[j>>0]|0)){GC(b);f=c[o>>2]|0;G4(f,Z9(c[f+4>>2]|0)|0);J3(b)}break}case 1:{sR(b,9,b+1686+(e<<1)|0);break}case 5:case 4:case 3:{d4(c[o>>2]|0,6);break}case 7:case 6:{d4(c[o>>2]|0,1);break}default:{GC(b);f=c[o>>2]|0;G4(f,Z9(c[f+4>>2]|0)|0);J3(b)}}h=h+1<<24>>24;e=g}i=i+1<<24>>24}r=b+2460|0;AT(b,r);do if(a[r>>0]|0){if(!q){c[b+2456>>2]=IG(b)|0;break}e=b+2456|0;c[e>>2]=0;f=0;do{c[e>>2]=f<<8;AT(b,t);xR(b,8,u);f=(c[e>>2]|0)+(d[u>>0]|0)|0;c[e>>2]=f}while((a[t>>0]|0)!=0)}while(0);AT(b,s);if(a[s>>0]|0)d4(c[o>>2]|0,8)}J3(b);if(qO(b)|0)a[b+22148>>0]=1;l=v;return}function Wg(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;o=l;l=l+16|0;f=o+8|0;m=o;n=d+528|0;i=n;i=z0(c[i>>2]|0,c[i+4>>2]|0,1,0)|0;g=z;k=d+536|0;j=k;h=c[j+4>>2]|0;if(g>>>0>h>>>0|((g|0)==(h|0)?i>>>0>(c[j>>2]|0)>>>0:0)){vt(d);n=e;c[n>>2]=0;c[n+4>>2]=0}else{a[f>>0]=0;Bx(d);g=d+648|0;j=0;h=0;while(1){i=c[(c[g>>2]|0)+4>>2]|0;if(h<<24>>24)break;if(!((j&255)<9&(raa(i)|0)!=0))break;h=j+1<<24>>24;qR(d,h,f);j=h;h=a[f>>0]|0}f=(j&255)>8;do if(f|(raa(i)|0)==0){if(f)t4(d);n=e;c[n>>2]=0;c[n+4>>2]=0}else{wK(d);h=d+48|0;h=z0(c[d+612>>2]|0,0,c[h>>2]|0,c[h+4>>2]|0)|0;g=n;f=c[g>>2]|0;g=c[g+4>>2]|0;h=z0(h|0,z|0,f|0,g|0)|0;q=z;i=(c[d+668>>2]|0)+((c[d+508>>2]|0)*24|0)+8|0;p=c[i+4>>2]|0;if(!(q>>>0<p>>>0|((q|0)==(p|0)?h>>>0<(c[i>>2]|0)>>>0:0))){t4(d);q=e;c[q>>2]=0;c[q+4>>2]=0;break}h=j&255;p=z0(f|0,g|0,h|0,0)|0;i=z;q=k;k=c[q+4>>2]|0;if(i>>>0>k>>>0|((i|0)==(k|0)?p>>>0>(c[q>>2]|0)>>>0:0)){vt(d);q=e;c[q>>2]=0;c[q+4>>2]=0;break}switch(j<<24>>24){case 1:{EG(d,m);p=(a[m>>0]&127)+-63|0;q=e;c[q>>2]=p;c[q+4>>2]=((p|0)<0)<<31>>31;break}case 2:{yE(d,m);p=(b[m>>1]&16383)+-8191|0;q=e;c[q>>2]=p;c[q+4>>2]=((p|0)<0)<<31>>31;break}case 3:{vD(d,m);q=e;c[q>>2]=(c[m>>2]&2097151)+-1048575;c[q+4>>2]=0;break}case 4:{aH(d,m);q=e;c[q>>2]=(c[m>>2]&268435455)+-134217727;c[q+4>>2]=0;break}case 5:{YD(d,m);p=m;q=e;c[q>>2]=z0(c[p>>2]|0,c[p+4>>2]&7|0,1,-4)|0;c[q+4>>2]=z;break}case 6:{XD(d,m);p=m;q=e;c[q>>2]=z0(c[p>>2]|0,c[p+4>>2]&1023|0,1,-512)|0;c[q+4>>2]=z;break}case 7:{WD(d,m);p=m;q=e;c[q>>2]=z0(c[p>>2]|0,c[p+4>>2]&131071|0,1,-65536)|0;c[q+4>>2]=z;break}case 8:{zE(d,m);p=m;q=e;c[q>>2]=z0(c[p>>2]|0,c[p+4>>2]&16777215|0,1,-8388608)|0;c[q+4>>2]=z;break}default:{}}p=n;p=z0(c[p>>2]|0,c[p+4>>2]|0,h|0,0)|0;q=n;c[q>>2]=p;c[q+4>>2]=z}while(0)}l=o;return}function Xg(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;r=l;l=l+16|0;f=r+2|0;k=r;j=r+4|0;m=b+528|0;g=(c[m>>2]|0)+(c[b+612>>2]|0)|0;h=c[b+544>>2]|0;p=a[h+g>>0]|0;i=p&255;p=(p&-64)<<24>>24==64;q=b+800|0;n=b+728|0;o=b+804|0;if(p){w=PZ(i&56|0,0,30)|0;f=z;v=PZ(d[h+(g+1)>>0]|0,0,20)|0;f=f|z;t=d[h+(g+2)>>0]|0;u=PZ(d[h+(g+3)>>0]|0,0,5)|0;j=z;s=XZ(d[h+(g+4)>>0]|0,0,3)|0;k=(c[o>>2]|0)+22400|0;c[k>>2]=w|i<<28&805306368|v|u|t<<15&8126464|t<<13&24576|s;c[k+4>>2]=f|j|z;if(!(c[n>>2]&1))c[q>>2]=d[h+(g+7)>>0]<<6|d[h+(g+6)>>0]<<14|(d[h+(g+8)>>0]|0)>>>2;f=(a[h+(g+9)>>0]&7)+10&255;g=m;c[g>>2]=f;c[g+4>>2]=0;g=0}else{Bx(b);RS(b);RS(b);KS(b);RS(b);xR(b,3,j);KS(b);sR(b,15,f);KS(b);sR(b,15,k);u=PZ(d[j>>0]|0,0,30)|0;v=z;t=PZ(e[f>>1]|0,0,15)|0;f=c[o>>2]|0;w=f+22400|0;c[w>>2]=t|u|e[k>>1];c[w+4>>2]=z|v;if(a[b+774>>0]|0?a[f+22437>>0]|0:0){v=f+22392|0;w=f+22360|0;c[w>>2]=c[v>>2];c[w+4>>2]=c[v+4>>2];c[w+8>>2]=c[v+8>>2];c[w+12>>2]=c[v+12>>2];c[w+16>>2]=c[v+16>>2];c[w+20>>2]=c[v+20>>2];c[w+24>>2]=c[v+24>>2];c[w+28>>2]=c[v+28>>2];a[(c[o>>2]|0)+22437>>0]=0}KS(b);KS(b);rR(b,22,q);KS(b);wK(b);g=m;f=c[g>>2]|0;g=c[g+4>>2]|0}w=b+536|0;if(!((f|0)==(c[w>>2]|0)?(g|0)==(c[w+4>>2]|0):0))t4(b);if(qO(b)|0?(c[n>>2]&1|0)==0:0){W5(b);if(!(a[b+492>>0]|0))RB(b,0,0,57,378150,-1,1,0);f=c[o>>2]|0;a[f+22316>>0]=1;a[f+22556>>0]=1;a[f+22796>>0]=1;a[f+22797>>0]=1;a[f+22798>>0]=1;a[f+23036>>0]=1;a[f+30476>>0]=1;a[f+30477>>0]=1;a[f+30478>>0]=1;g=192;while(1){if((g|0)==240)break;a[f+(g*120|0)+116>>0]=1;a[f+(g*120|0)+117>>0]=1;a[f+(g*120|0)+118>>0]=1;g=g+1|0}a[b+773>>0]=p?2:1;v=UW(c[q>>2]|0,0,200,0)|0;t=(a[b+378>>0]|0)!=0;t=UW(v|0,z|0,(t?4:1)|0,(t?0:0)|0)|0;v=z;u=v>>>0<0|(v|0)==0&t>>>0<16777216;t=u?t:16777216;v=u?v:0;u=v>>>0>0|(v|0)==0&t>>>0>2097152;w=b+848|0;c[w>>2]=u?t:2097152;c[w+4>>2]=u?v:0}l=r;return}function Yg(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0;w=l;l=l+64|0;g=w+58|0;j=w+40|0;k=w+28|0;m=w+16|0;p=w+24|0;s=w+56|0;u=w;bB(d,g);jB(d,w+52|0);TX(j);TX(k);g=(a[g>>0]|0)==0;if(g){ID(d,u);e=c[u>>2]|0;if(e|0)__(j,e)|0}else{oz(d,u);f=u;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e|0)==0&(f|0)==0))mZ(j,e,f)|0}if(g){ID(d,u);e=c[u>>2]|0;if(e|0)__(k,e)|0}else{oz(d,u);f=u;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e|0)==0&(f|0)==0))mZ(k,e,f)|0}ID(d,p);if(g){ID(d,u);g=m;c[g>>2]=c[u>>2];c[g+4>>2]=0}else oz(d,m);NB(d,s);g=d+528|0;f=g;f=z0(c[f>>2]|0,c[f+4>>2]|0,2,0)|0;c[g>>2]=f;c[g+4>>2]=z;if(((qO(d)|0?(n=d+16|0,r=c[n>>2]|0,o=d+20|0,q=c[o>>2]|0,pv(u,b[s>>1]|0),Mc(d,r,q,384512,u,0),z5(u),s=m,m=c[s>>2]|0,s=c[s+4>>2]|0,q=d+916|0,r=d+788|0,t=(bF(q,r)|0)+200|0,c[t>>2]=m,c[t+4>>2]=s,t=c[p>>2]|0,c[(bF(q,r)|0)+192>>2]=t,u=(bF(q,r)|0)+184|0,v=+(m>>>0)+4294967296.0*+(s>>>0),(+((c[u>>2]|0)>>>0)+4294967296.0*+((c[u+4>>2]|0)>>>0))*1.01>=v*.99):0)?(u=(bF(q,r)|0)+184|0,t|0?(+((c[u>>2]|0)>>>0)+4294967296.0*+((c[u+4>>2]|0)>>>0))*.99<=v*1.01:0):0)?(h=d+824|0,i=c[h>>2]|0,!((i|0)==(t|0)|(i|0)==0)):0){u=(bF(q,r)|0)+184|0;p=c[u>>2]|0;u=c[u+4>>2]|0;s=bF(q,r)|0;t=cT((+(p>>>0)+4294967296.0*+(u>>>0))/(+(t>>>0)/+(i>>>0)))|0;s=s+184|0;c[s>>2]=t;c[s+4>>2]=z;mj(d,c[n>>2]|0,c[o>>2]|0,377437);s=c[n>>2]|0;t=c[o>>2]|0;u=(bF(q,r)|0)+184|0;u=cT((+((c[u>>2]|0)>>>0)+4294967296.0*+((c[u+4>>2]|0)>>>0))*1.0e3/+((c[h>>2]|0)>>>0))|0;VL(d,s,t,u,z,1)}z5(k);z5(j);l=w;return}function Zg(a){a=a|0;var b=0,d=0.0,f=0.0,g=0.0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;A=l;l=l+32|0;v=A+20|0;w=A+16|0;n=A+12|0;i=A+8|0;x=A+4|0;y=A;r=A+30|0;u=A+28|0;s=A+26|0;t=A+24|0;r3(a,v);v=c[v>>2]|0;if((v|0)==1635083379)bD(a,w);else r3(a,w);j=a+528|0;b=j;b=z0(c[b>>2]|0,c[b+4>>2]|0,12,0)|0;m=j;c[m>>2]=b;c[m+4>>2]=z;bD(a,n);bD(a,i);bD(a,x);bD(a,y);m=j;m=z0(c[m>>2]|0,c[m+4>>2]|0,12,0)|0;b=j;c[b>>2]=m;c[b+4>>2]=z;HB(a,r);HB(a,u);HB(a,s);HB(a,t);b=c[j>>2]|0;j=c[j+4>>2]|0;m=a+536|0;k=c[m>>2]|0;m=c[m+4>>2]|0;if(m>>>0>j>>>0|(m|0)==(j|0)&k>>>0>b>>>0){m=D_(k|0,m|0,b|0,j|0)|0;e1(a,m,z)}k=c[i>>2]|0;i=c[n>>2]|0;j=a+20|0;do if((k|0)!=0&(i|0)!=0){d=+(k>>>0)/+(i>>>0);do if(d>1.0){f=d-+(~~d>>>0>>>0);g=f;if(g<.01){d=d-f;break}if(g>.99){d=d+(1.0-f);break}g=d*1001.0/1.0e3;f=+(~~g>>>0>>>0);g=g-f;d=g<.001?f*1.0e3/1001.0:d;if(g>.999)d=+(((~~(d*1001.0/1.0e3)>>>0)+1|0)>>>0)*1.0e3/1001.0}while(0);if(d!=0.0?(p=X0(+((c[y>>2]|0)>>>0)*1.0e3/d)|0,q=z,o=c[a+992>>2]|0,(o|0)!=0):0){f=+h[a+984>>3];g=+(p>>>0)+4294967296.0*+(q>>>0);if(!(f==0.0)?(f=+(o>>>0)/f*1.0e3,!(g<f*1.1&g>f*.9)):0)break;aL(a,c[a+16>>2]|0,c[j>>2]|0,379845,p,q,0)}}else d=0.0;while(0);a:do if((v|0)<1986618483){switch(v|0){case 1954051187:break;default:break a}b=(e[s>>1]|0)-(e[r>>1]|0)|0;if((b|0)>0)sM(a,3,c[j>>2]|0,96,b,1);b=(e[t>>1]|0)-(e[u>>1]|0)|0;if((b|0)>0)sM(a,3,c[j>>2]|0,98,b,1)}else{switch(v|0){case 1986618483:break;default:break a}if(d>0.0)Bt(a,1,c[j>>2]|0,171,d,3,0);b=(e[s>>1]|0)-(e[r>>1]|0)|0;if((b|0)>0)sM(a,1,c[j>>2]|0,130,b,1);b=(e[t>>1]|0)-(e[u>>1]|0)|0;if((b|0)>0)sM(a,1,c[j>>2]|0,138,b,1)}while(0);a=jF(a+760|0,a+772|0)|0;c[a+12>>2]=v;c[a+16>>2]=c[w>>2];c[a+20>>2]=i;c[a+24>>2]=k;c[a+28>>2]=c[x>>2];c[a+32>>2]=c[y>>2];l=A;return}function _g(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;B=l;l=l+16|0;j=B;s=a+760|0;t=a+764|0;u=a+544|0;v=a+612|0;w=a+536|0;x=a+48|0;y=a+548|0;A=a+40|0;k=a+768|0;m=a+728|0;n=a+64|0;b=0;while(1){d=c[s>>2]|0;if(b>>>0>=(c[t>>2]|0)-d>>2>>>0)break;Oc(c[d+(b<<2)>>2]|0,(c[u>>2]|0)+(c[v>>2]|0)|0,c[w>>2]|0);h=x;h=z0(c[y>>2]|0,0,c[h>>2]|0,c[h+4>>2]|0)|0;i=A;if((h|0)==(c[i>>2]|0)?(z|0)==(c[i+4>>2]|0):0)jy(c[(c[s>>2]|0)+(b<<2)>>2]|0);d=c[s>>2]|0;e=c[d+(b<<2)>>2]|0;f=c[e+728>>2]|0;g=d;h=e;if((f&9|0)==8){if(e){jb[c[(c[e>>2]|0)+4>>2]&511](e);d=c[s>>2]|0}g=d+(b<<2)|0;d=g+4|0;e=c[t>>2]|0;f=e-d|0;h=f>>2;if(!h)i=e;else{TR(g|0,d|0,f|0)|0;i=c[t>>2]|0}d=g+(h<<2)|0;f=(i-d|0)>>>2;e=i;while(1){if((e|0)==(d|0))break;h=e+-4|0;c[t>>2]=h;e=h}b=b+-1|0;if((c[s>>2]|0)==(i+(0-f<<2)|0)){d=ZW(760)|0;Ow(d|0,0,760)|0;M4(d);c[j>>2]=d;e=c[t>>2]|0;if((e|0)==(c[k>>2]|0))Yy(s,j);else{c[e>>2]=d;c[t>>2]=(c[t>>2]|0)+4}jb[c[(c[a>>2]|0)+20>>2]&511](a)}}else{e=c[t>>2]|0;if((f&1|0)==0|e-g>>2>>>0<2){f=d;h=d}else{c[j>>2]=h;f=0;while(1){if(f>>>0>=e-g>>2>>>0)break;if((f|0)!=(b|0)?(o=c[d+(f<<2)>>2]|0,(o|0)!=0):0){jb[c[(c[o>>2]|0)+4>>2]&511](o);e=c[t>>2]|0;d=c[s>>2]|0}else d=g;f=f+1|0;g=d}f=e;b=(e-d|0)>>>2;e=f;while(1){if((e|0)==(d|0))break;i=e+-4|0;c[t>>2]=i;e=i}b=f+(0-b<<2)|0;if((b|0)==(c[k>>2]|0)){Yy(s,j);d=c[t>>2]|0}else{c[b>>2]=h;d=(c[t>>2]|0)+4|0;c[t>>2]=d}h=c[s>>2]|0;b=0;g=h;e=d;f=h}if((e-g|0)==4){d=c[m>>2]|0;e=f+(b<<2)|0;if((d&1|0)==0?(p=d|1,(c[(c[e>>2]|0)+728>>2]&1|0)!=0):0){c[m>>2]=p;d=p}if((d&2|0)==0?(q=d|2,(c[(c[e>>2]|0)+728>>2]&2|0)!=0):0){c[m>>2]=q;d=q}if((d&4|0)==0?(r=d|4,(c[(c[e>>2]|0)+728>>2]&4|0)!=0):0){c[m>>2]=r;d=r}if((d&8|0)==0?c[(c[e>>2]|0)+728>>2]&8|0:0)c[m>>2]=d|8;e=(c[h>>2]|0)+64|0;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!((d|0)==-1&(e|0)==-1)){i=n;c[i>>2]=d;c[i+4>>2]=e}}}b=b+1|0}l=B;return}function $g(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+48|0;e=r+28|0;g=r+24|0;o=r+38|0;f=r+36|0;m=r+34|0;h=r+32|0;p=r+12|0;n=r;HB(d,o);HB(d,f);bD(d,e);bD(d,g);j=d+528|0;k=j;k=z0(c[k>>2]|0,c[k+4>>2]|0,2,0)|0;c[j>>2]=k;c[j+4>>2]=z;HB(d,h);HB(d,m);Kc(d,2,-1)|0;j=d+760|0;k=d+772|0;a[(sF(j,k)|0)+52>>0]=1;TX(p);o=b[o>>1]|0;Ek(p,o,16)|0;tP(p)|0;i=d+20|0;Rf(d,p,2,c[i>>2]|0,3);zb(d,2,c[i>>2]|0,52,p,0);zb(d,2,c[i>>2]|0,57,p,0);f=b[f>>1]|0;if(f<<16>>16)kL(d,2,c[i>>2]|0,122,f,10,0);e=c[e>>2]|0;if(e|0)lL(d,2,c[i>>2]|0,135,e,10,0);e=c[g>>2]|0;if(e|0)lL(d,2,c[i>>2]|0,112,e<<3,10,0);e=b[h>>1]|0;if(e<<16>>16)kL(d,2,c[i>>2]|0,147,e,10,0);if(qO(d)|0){rU(n,o,16);e=Aj(2,3,n,1)|0;f=i9(40168)|0;i=a[e+8+3>>0]|0;if((f|0)==((i<<24>>24<0?c[e+4>>2]|0:i&255)|0)){i=(VG(e,40168,f)|0)==0;z5(n);if(i){i=sF(j,k)|0;n=ZW(1128)|0;Wr(n);c[i>>2]=n;i=n+896|0;c[i>>2]=8;c[i+4>>2]=0;a[n+732>>0]=1}}else z5(n);aY(d,c[(sF(j,k)|0)>>2]|0)}e=b[m>>1]|0;if(e<<16>>16){GC(d);a:do if(o<<16>>16<355)switch(o<<16>>16){case 354:case 353:{q=17;break}default:q=19}else{if(o<<16>>16<31265)switch(o<<16>>16){case 355:{q=17;break a}default:{q=19;break a}}switch(o<<16>>16){case 31266:case 31265:break;default:{q=19;break a}}uL(d)}while(0);if((q|0)==17)sX(d);else if((q|0)==19)e1(d,e&65535,0);J3(d)}z5(p);l=r;return}function ah(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0;B=l;l=l+32|0;p=B+24|0;r=B+20|0;s=B+16|0;t=B+12|0;u=B+8|0;x=B+30|0;v=B+4|0;y=B;z=B+28|0;iF(e,6,0);bB(e,x);lz(e);q=(d[x>>0]|0)+1|0;a[x>>0]=q;q=q&255;x=e+652|0;o=0;while(1){if((o|0)>=(q|0)){w=32;break}GC(e);mP(e,p);if((c[p>>2]|0)!=5653314)break;$K(e,16,r);$K(e,24,s);$K(e,1,t);if(!(c[t>>2]|0)){$K(e,1,v);g=c[s>>2]|0;h=(c[v>>2]|0)==0;f=0;while(1){if((f|0)==(g|0))break;if(!(!h?($K(e,1,y),!(c[y>>2]|0)):0))q1(c[x>>2]|0,5);f=f+1|0}}else{q1(c[x>>2]|0,5);g=c[s>>2]|0;f=0;while(1){if(g>>>0<=f>>>0)break;$K(e,o0(g-f|0)|0,v);k=f+-1|0;m=k-g|0;n=~c[v>>2];f=k-(m>>>0>n>>>0?m:n)|0}}$K(e,4,u);f=c[u>>2]|0;if(f>>>0>2)break;if(f|0){q1(c[x>>2]|0,32);q1(c[x>>2]|0,32);zP(e,v);n=(a[v>>0]|0)+1<<24>>24;a[v>>0]=n;q1(c[x>>2]|0,1);m=c[r>>2]|0;if((f|0)==1){j=~~+A(+(+D(+(+(g>>>0)),+(1.0/+(m>>>0)))))>>>0;while(1){k=j+1|0;f=0;h=1;i=1;while(1){if((f|0)==(m|0))break;f=f+1|0;h=O(h,k)|0;i=O(i,j)|0}if(i>>>0<=g>>>0&h>>>0>g>>>0){g=j;break}else j=i>>>0>g>>>0?j+-1|0:k}}else g=O(m,g)|0;f=0;while(1){if((f|0)>=(g|0))break;$K(e,n,y);f=f+1|0}}J3(e);o=o+1|0}if((w|0)==32){$K(e,6,v);g=(c[v>>2]|0)+1|0;f=0;while(1){if((f|0)==(g|0))break;q1(c[x>>2]|0,16);f=f+1|0}$K(e,6,y);g=c[y>>2]|0;f=0;while(1){if((f|0)==(g|0))break;nP(e,z);if(qO(e)|0?(y=b[z>>1]|0,kL(e,2,0,35,y,10,0),kL(e,2,0,62,y,10,0),y<<16>>16==0):0){RB(e,2,0,27,384439,-1,1,0);RB(e,2,0,60,384439,-1,1,0)}f=f+1|0}SH(e);V5(e)}l=B;return}function bh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+32|0;k=n;d=a+32|0;f=a+64|0;e=b+-32|0;switch(b-a>>5|0){case 1:case 0:{d=1;break}case 2:{b=e;m=a;if(M$(c[b>>2]|0,c[b+4>>2]|0,c[m>>2]|0,c[m+4>>2]|0)|0){c[k>>2]=c[a>>2];c[k+4>>2]=c[a+4>>2];c[k+8>>2]=c[a+8>>2];c[k+12>>2]=c[a+12>>2];c[k+16>>2]=c[a+16>>2];c[k+20>>2]=c[a+20>>2];c[k+24>>2]=c[a+24>>2];c[k+28>>2]=c[a+28>>2];c[a>>2]=c[e>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];c[a+16>>2]=c[e+16>>2];c[a+20>>2]=c[e+20>>2];c[a+24>>2]=c[e+24>>2];c[a+28>>2]=c[e+28>>2];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];c[e+8>>2]=c[k+8>>2];c[e+12>>2]=c[k+12>>2];c[e+16>>2]=c[k+16>>2];c[e+20>>2]=c[k+20>>2];c[e+24>>2]=c[k+24>>2];c[e+28>>2]=c[k+28>>2];d=1}else d=1;break}case 3:{Re(a,d,e)|0;d=1;break}case 4:{oh(a,d,f,e)|0;d=1;break}case 5:{Ff(a,d,f,a+96|0,e)|0;d=1;break}default:{Re(a,d,f)|0;e=a+96|0;j=0;d=f;a:while(1){i=e;while(1){if((i|0)==(b|0)){e=1;d=0;break a}g=i;f=c[g>>2]|0;g=c[g+4>>2]|0;e=d;h=i+32|0;if(M$(f,g,c[e>>2]|0,c[e+4>>2]|0)|0)break;else{d=i;i=h}}e=i+8|0;c[k>>2]=c[e>>2];c[k+4>>2]=c[e+4>>2];c[k+8>>2]=c[e+8>>2];c[k+12>>2]=c[e+12>>2];c[k+16>>2]=c[e+16>>2];c[k+20>>2]=c[e+20>>2];e=i;while(1){c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];c[e+16>>2]=c[d+16>>2];c[e+20>>2]=c[d+20>>2];c[e+24>>2]=c[d+24>>2];c[e+28>>2]=c[d+28>>2];if((d|0)==(a|0)){d=a;break}e=d+-32|0;o=e;if(M$(f,g,c[o>>2]|0,c[o+4>>2]|0)|0){o=d;d=e;e=o}else break}o=d;c[o>>2]=f;c[o+4>>2]=g;d=d+8|0;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];c[d+8>>2]=c[k+8>>2];c[d+12>>2]=c[k+12>>2];c[d+16>>2]=c[k+16>>2];c[d+20>>2]=c[k+20>>2];d=j+1|0;if((d|0)==8){m=15;break}else{e=h;j=d;d=i}}if((m|0)==15){e=0;d=(h|0)==(b|0)}d=d|e}}l=n;return d|0}function ch(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=a+48|0;o=a+612|0;p=a+952|0;q=a+548|0;r=a+536|0;s=a+1052|0;t=a+24|0;u=a+528|0;v=a+944|0;m=a+64|0;n=a+728|0;j=c[o>>2]|0;while(1){d=l;b=c[d>>2]|0;d=c[d+4>>2]|0;e=z0(j|0,0,b|0,d|0)|0;f=z;i=p;h=c[i>>2]|0;i=c[i+4>>2]|0;if(!(i>>>0>f>>>0|(i|0)==(f|0)&h>>>0>e>>>0)){b=1;break}k=c[q>>2]|0;d=z0(k|0,0,b|0,d|0)|0;b=z;if(b>>>0>i>>>0|(b|0)==(i|0)&d>>>0>h>>>0){b=D_(h|0,i|0,e|0,f|0)|0;i=r;c[i>>2]=b;c[i+4>>2]=z;i=p;c[i>>2]=0;c[i+4>>2]=0}else{b=r;c[b>>2]=k;c[b+4>>2]=0;b=k}if((b+j|0)>>>0>k>>>0){b=0;break}GC(a);o7(a);GC(a);o7(a);d=p;b=c[d>>2]|0;d=c[d+4>>2]|0;if((b|0)==0&(d|0)==0){k=r;Op(a,c[k>>2]|0,c[k+4>>2]|0)}else{j=l;k=c[o>>2]|0;j=D_(b|0,d|0,c[j>>2]|0,c[j+4>>2]|0)|0;k=D_(j|0,z|0,k|0,0)|0;Op(a,k,z)}J3(a);switch(c[s>>2]|0){case 2:{$Z(a);break}case 3:{E4(a);break}case 4:{$Z(a);break}default:_e(a)}e=u;d=c[e>>2]|0;e=c[e+4>>2]|0;if(+g[(c[t>>2]|0)+136>>2]<1.0){i=l;b=c[o>>2]|0;k=v;j=c[k>>2]|0;k=c[k+4>>2]|0;i=z0(c[i>>2]|0,c[i+4>>2]|0,d|0,e|0)|0;i=z0(i|0,z|0,b|0,0)|0;k=D_(i|0,z|0,j|0,k|0)|0;j=z;if(j>>>0>0|(j|0)==0&k>>>0>262143){k=p;d=c[k+4>>2]|0;b=m;c[b>>2]=c[k>>2];c[b+4>>2]=d;c[o>>2]=c[q>>2];b=0;d=0}else w=19}else{b=c[o>>2]|0;w=19}if((w|0)==19){w=0;k=r;j=c[k>>2]|0;k=c[k+4>>2]|0;c[o>>2]=j+b;b=D_(j|0,k|0,d|0,e|0)|0;d=z}k=r;c[k>>2]=b;c[k+4>>2]=d;k=u;c[k>>2]=0;c[k+4>>2]=0;J3(a);if(c[n>>2]&8|0){w=24;break}d=m;b=c[d>>2]|0;d=c[d+4>>2]|0;if(!((b|0)==-1&(d|0)==-1)){k=v;j=c[k+4>>2]|0;if(!(d>>>0>j>>>0|((d|0)==(j|0)?b>>>0>(c[k>>2]|0)>>>0:0))){w=24;break}k=p;j=c[k+4>>2]|0;if(!(d>>>0<j>>>0|((d|0)==(j|0)?b>>>0<(c[k>>2]|0)>>>0:0))){w=24;break}}j=c[o>>2]|0;if(j>>>0>=(c[q>>2]|0)>>>0){b=0;break}}if((w|0)==24){b=v;c[b>>2]=-1;c[b+4>>2]=-1;b=p;c[b>>2]=0;c[b+4>>2]=0;b=0}return b|0}function dh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=l;l=l+16|0;f=e;TX(f);i=d+8|0;ex(f,c[i+4>>2]&255)|0;h=f+8+3|0;j=a[h>>0]|0;k=j<<24>>24<0;g=f+4|0;Ex(b,k?c[f>>2]|0:f,k?c[g>>2]|0:j&255)|0;j=i;j=XZ(c[j>>2]|0,c[j+4>>2]|0,40)|0;ex(f,j&255)|0;j=a[h>>0]|0;k=j<<24>>24<0;Ex(b,k?c[f>>2]|0:f,k?c[g>>2]|0:j&255)|0;j=i;j=XZ(c[j>>2]|0,c[j+4>>2]|0,48)|0;ex(f,j&255)|0;j=a[h>>0]|0;k=j<<24>>24<0;Ex(b,k?c[f>>2]|0:f,k?c[g>>2]|0:j&255)|0;j=i;j=XZ(c[j>>2]|0,c[j+4>>2]|0,56)|0;ex(f,j&255)|0;j=a[h>>0]|0;k=j<<24>>24<0;Ex(b,k?c[f>>2]|0:f,k?c[g>>2]|0:j&255)|0;HX(b,42040)|0;j=i;j=XZ(c[j>>2]|0,c[j+4>>2]|0,16)|0;ex(f,j&255)|0;j=a[h>>0]|0;k=j<<24>>24<0;Ex(b,k?c[f>>2]|0:f,k?c[g>>2]|0:j&255)|0;j=i;j=XZ(c[j>>2]|0,c[j+4>>2]|0,24)|0;ex(f,j&255)|0;j=a[h>>0]|0;k=j<<24>>24<0;Ex(b,k?c[f>>2]|0:f,k?c[g>>2]|0:j&255)|0;HX(b,42040)|0;ex(f,c[i>>2]&255)|0;j=a[h>>0]|0;k=j<<24>>24<0;Ex(b,k?c[f>>2]|0:f,k?c[g>>2]|0:j&255)|0;i=XZ(c[i>>2]|0,c[i+4>>2]|0,8)|0;ex(f,i&255)|0;i=a[h>>0]|0;j=i<<24>>24<0;Ex(b,j?c[f>>2]|0:f,j?c[g>>2]|0:i&255)|0;HX(b,42040)|0;i=d;i=XZ(c[i>>2]|0,c[i+4>>2]|0,48)|0;dx(f,i&65535)|0;i=a[h>>0]|0;j=i<<24>>24<0;Ex(b,j?c[f>>2]|0:f,j?c[g>>2]|0:i&255)|0;HX(b,42040)|0;dx(f,c[d+4>>2]&65535)|0;i=a[h>>0]|0;j=i<<24>>24<0;Ex(b,j?c[f>>2]|0:f,j?c[g>>2]|0:i&255)|0;i=d;i=XZ(c[i>>2]|0,c[i+4>>2]|0,16)|0;dx(f,i&65535)|0;i=a[h>>0]|0;j=i<<24>>24<0;Ex(b,j?c[f>>2]|0:f,j?c[g>>2]|0:i&255)|0;dx(f,c[d>>2]&65535)|0;d=a[h>>0]|0;h=d<<24>>24<0;Ex(b,h?c[f>>2]|0:f,h?c[g>>2]|0:d&255)|0;z5(f);l=e;return b|0}function eh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;p=l;l=l+96|0;d=p+84|0;e=p+88|0;i=p+72|0;j=p+60|0;k=p+48|0;m=p+36|0;g=p+24|0;n=p+12|0;o=p;r3(b,d);bB(b,e);f=b+536|0;h=b+528|0;h=D_(c[f>>2]|0,c[f+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0)|0;e1(b,h,z);if((c[b+784>>2]|0)>>>0<=1){h=b+20|0;f=c[h>>2]|0;Yo(i,c[d>>2]|0);zb(b,2,f,250,i,0);z5(i);e=a[e>>0]|0;mL(b,2,c[h>>2]|0,251,e,10,0);f=c[h>>2]|0;$x(m,b,2,f,250,1);Gx(m,32);c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];d=0;while(1){if((d|0)==3)break;c[m+(d<<2)>>2]=0;d=d+1|0}uU(g,e,10);d=a[g+8+3>>0]|0;q=d<<24>>24<0;Ex(k,q?c[g>>2]|0:g,q?c[g+4>>2]|0:d&255)|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];d=0;while(1){if((d|0)==3)break;c[k+(d<<2)>>2]=0;d=d+1|0}p2(i,j);zb(b,2,f,247,i,0);z5(i);O0(j);z5(g);O0(k);z5(m);$x(k,b,2,c[h>>2]|0,250,1);a:do if(!(e<<24>>24)){TX(o);c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];d=0;while(1){if((d|0)==3){e=1;f=0;break a}c[o+(d<<2)>>2]=0;d=d+1|0}}else{uU(n,e,10);DW(n,0,23936)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];d=0;while(1){if((d|0)==3){e=0;f=1;break a}c[n+(d<<2)>>2]=0;d=d+1|0}}while(0);d=a[m+8+3>>0]|0;q=d<<24>>24<0;Ex(k,q?c[m>>2]|0:m,q?c[m+4>>2]|0:d&255)|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];d=0;while(1){if((d|0)==3)break;c[k+(d<<2)>>2]=0;d=d+1|0}p2(i,j);O0(j);O0(m);if(e)z5(o);if(f)z5(n);z5(k);zb(b,2,c[h>>2]|0,248,i,1);z5(i)}l=p;return}function fh(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;o=l;l=l+16|0;m=o;j=o+9|0;k=o+8|0;n=o+7|0;f=o+6|0;i=o+5|0;g=o+4|0;KK(b);ID(b,m);Bx(b);AT(b,j);h=b+648|0;d4(c[h>>2]|0,7);wK(b);if(!(a[j>>0]|0)){Bx(b);AT(b,f);AT(b,i);d4(c[h>>2]|0,6);wK(b);j=b+528|0;if(!(a[f>>0]|0)){bB(b,g);g=a[g>>0]|0;f=0;while(1){if((f&255)>=(g&255))break;q=j;q=z0(c[q>>2]|0,c[q+4>>2]|0,1,0)|0;p=j;c[p>>2]=q;c[p+4>>2]=z;Bx(b);d4(c[h>>2]|0,7);d4(c[h>>2]|0,33);wK(b);f=f+1<<24>>24}}q=(a[i>>0]|0)==0;f=j;g=c[f>>2]|0;f=c[f+4>>2]|0;h=z0(g|0,f|0,5,0)|0;i=z;if(!q){g=j;c[g>>2]=h;c[g+4>>2]=i;g=h;f=i}q=z0(g|0,f|0,1,0)|0;p=j;c[p>>2]=q;c[p+4>>2]=z;bB(b,k);e1(b,d[k>>0]|0,0);bB(b,n);p=j;p=z0(c[p>>2]|0,c[p+4>>2]|0,2,0)|0;q=j;c[q>>2]=p;c[q+4>>2]=z;a:do if(qO(b)|0){j=b+760|0;k=b+766|0;i=b+764|0;h=0;while(1){f=c[j>>2]|0;q=c[(c[f+80>>2]|0)+(e[k>>1]<<2)>>2]|0;if(h>>>0>=(c[q+8>>2]|0)-(c[q+4>>2]|0)>>1>>>0)break a;g=(HD(f+68|0,i)|0)+16|0;g=c[($C(g,(c[(c[(c[(c[j>>2]|0)+80>>2]|0)+(e[k>>1]<<2)>>2]|0)+4>>2]|0)+(h<<1)|0)|0)+104>>2]|0;if(g|0){switch(a[n>>0]|0){case 17:{a[n>>0]=16;f=1;break}case 18:{a[n>>0]=16;f=2;break}case 20:{a[n>>0]=19;f=1;break}case 33:{a[n>>0]=32;f=1;break}case 49:{a[n>>0]=48;f=1;break}case 51:{a[n>>0]=50;f=1;break}case 65:{a[n>>0]=64;f=1;break}default:f=0}a[(wB(VB(g,m)|0,n)|0)>>0]=f}h=h+1|0}}while(0)}l=o;return}function gh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;p=l;l=l+96|0;d=p+84|0;e=p+88|0;i=p+72|0;j=p+60|0;k=p+48|0;m=p+36|0;g=p+24|0;n=p+12|0;o=p;r3(b,d);bB(b,e);h=b+528|0;f=h;f=z0(c[f>>2]|0,c[f+4>>2]|0,4,0)|0;c[h>>2]=f;c[h+4>>2]=z;if((c[b+784>>2]|0)>>>0<=1){h=b+20|0;f=c[h>>2]|0;Yo(i,c[d>>2]|0);zb(b,2,f,250,i,0);z5(i);e=a[e>>0]|0;mL(b,2,c[h>>2]|0,251,e,10,0);f=c[h>>2]|0;$x(m,b,2,f,250,1);Gx(m,32);c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];d=0;while(1){if((d|0)==3)break;c[m+(d<<2)>>2]=0;d=d+1|0}uU(g,e,10);d=a[g+8+3>>0]|0;q=d<<24>>24<0;Ex(k,q?c[g>>2]|0:g,q?c[g+4>>2]|0:d&255)|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];d=0;while(1){if((d|0)==3)break;c[k+(d<<2)>>2]=0;d=d+1|0}p2(i,j);zb(b,2,f,247,i,0);z5(i);O0(j);z5(g);O0(k);z5(m);$x(k,b,2,c[h>>2]|0,250,1);a:do if(!(e<<24>>24)){TX(o);c[m>>2]=c[o>>2];c[m+4>>2]=c[o+4>>2];c[m+8>>2]=c[o+8>>2];d=0;while(1){if((d|0)==3){e=1;f=0;break a}c[o+(d<<2)>>2]=0;d=d+1|0}}else{uU(n,e,10);DW(n,0,24340)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];d=0;while(1){if((d|0)==3){e=0;f=1;break a}c[n+(d<<2)>>2]=0;d=d+1|0}}while(0);d=a[m+8+3>>0]|0;q=d<<24>>24<0;Ex(k,q?c[m>>2]|0:m,q?c[m+4>>2]|0:d&255)|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];d=0;while(1){if((d|0)==3)break;c[k+(d<<2)>>2]=0;d=d+1|0}p2(i,j);O0(j);O0(m);if(e)z5(o);if(f)z5(n);z5(k);zb(b,2,c[h>>2]|0,248,i,1);z5(i)}l=p;return}function hh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+32|0;n=o+12|0;j=o+16|0;m=o;a[j>>0]=1;gB(b,n);n=c[n>>2]|0;h=n&131072;k=(h|0)==0;f=b+936|0;e=c[f>>2]|0;g=e>>>0>3;if(k){if(g){d=e;i=5}}else if(g?(bB(b,j),d=c[f>>2]|0,d>>>0>4):0)i=5;if((i|0)==5)e1(b,d+-3-(h>>>17)|0,0);f=b+944|0;if(n&1|0)HX(f,16464)|0;if(n&2|0)HX(f,16480)|0;if(n&4|0)HX(f,16464)|0;if(n&8|0)HX(f,16496)|0;if(n&16|0)HX(f,16512)|0;if(n&32|0)HX(f,16532)|0;if(n&64|0)HX(f,16684)|0;if(n&128|0)HX(f,16800)|0;if(n&256|0)HX(f,16820)|0;if(n&512|0)HX(f,16840)|0;if(n&1024|0)HX(f,16880)|0;if(n&2048|0)HX(f,16896)|0;if(n&4096|0)HX(f,16912)|0;if(n&8192|0)HX(f,16464)|0;e=(n&16384|0)==0;if(!e)HX(f,16464)|0;if(n&32768|0)HX(f,16932)|0;if(n&65536|0)HX(f,16948)|0;do if(!k){HX(f,17012)|0;d=a[j>>0]|0;if(!(d<<24>>24))break;uU(m,d,10);k=a[m+8+3>>0]|0;j=k<<24>>24<0;Ex(f,j?c[m>>2]|0:m,j?c[m+4>>2]|0:k&255)|0;z5(m)}while(0);if(!e)HX(f,16464)|0;if(n&524288|0)HX(f,17028)|0;if(n&1048576|0)HX(f,17044)|0;if(n&2097152|0)HX(f,16464)|0;if(n&4194304|0)HX(f,16464)|0;if(n&8388608|0)HX(f,17108)|0;d=a[b+952+3>>0]|0;e=d<<24>>24<0;if(e)d=c[b+948>>2]|0;else d=d&255;if(d|0){if(e){e=c[f>>2]|0;d=e}else{d=f;e=f}ny(f,e-d>>2,1)|0}l=o;return}function ih(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;G=l;l=l+16|0;C=G+8|0;D=G;Uy(a,C);E=a+528|0;q=E;q=z0(c[q>>2]|0,c[q+4>>2]|0,4,0)|0;p=E;c[p>>2]=q;c[p+4>>2]=z;p=d&-65536;q=a+760|0;F=a+536|0;r=a+544|0;s=a+612|0;t=a+776|0;n=(p|0)!=808452096;u=(b>>>0)/10|0;o=(p|0)!=808517632;v=a+832|0;w=a+824|0;x=a+816|0;y=a+808|0;A=a+24|0;B=c[C>>2]|0;C=c[C+4>>2]|0;m=0;f=0;i=0;while(1){if(m>>>0>=b>>>0)break;e=E;d=c[e>>2]|0;e=z0(d|0,c[e+4>>2]|0,8,0)|0;h=z;k=F;j=c[k+4>>2]|0;if(h>>>0>j>>>0|((h|0)==(j|0)?e>>>0>(c[k>>2]|0)>>>0:0))break;d=(c[r>>2]|0)+(c[s>>2]|0)+d|0;j=t7(d)|0;d=(t7(d+4|0)|0)&2147483647;k=E;c[k>>2]=e;c[k+4>>2]=h;j=z0(j|0,0,-8,-1)|0;k=z;if(m>>>0>=300?!(+g[(c[A>>2]|0)+136>>2]>=1.0):0)e=0;else{H=z0(B|0,C|0,j|0,k|0)|0;h=z;e=D;c[e>>2]=H;c[e+4>>2]=h;e=kD(t,D)|0;c[e>>2]=p;c[e+4>>2]=0;e=D;c[e>>2]=H;c[e+4>>2]=h;e=(kD(t,D)|0)+8|0;c[e>>2]=d;c[e+4>>2]=0;e=0}f=z0(d|0,e|0,f|0,i|0)|0;h=z;c[D>>2]=p;d=(jF(q,D)|0)+56|0;c[d>>2]=(c[d>>2]|0)+1;d=(m|0)!=0;if(!(n|d)?(H=y,(c[H>>2]|0)==0&(c[H+4>>2]|0)==0):0){i=z0(B|0,C|0,j|0,k|0)|0;H=y;c[H>>2]=i;c[H+4>>2]=z}e=(m|0)!=(u|0);if(!(n|e)?(H=x,(c[H>>2]|0)==0&(c[H+4>>2]|0)==0):0){i=z0(B|0,C|0,j|0,k|0)|0;H=x;c[H>>2]=i;c[H+4>>2]=z}if(!(o|d)?(H=w,(c[H>>2]|0)==0&(c[H+4>>2]|0)==0):0){i=z0(B|0,C|0,j|0,k|0)|0;H=w;c[H>>2]=i;c[H+4>>2]=z}if(!(o|e)?(H=v,(c[H>>2]|0)==0&(c[H+4>>2]|0)==0):0){k=z0(B|0,C|0,j|0,k|0)|0;H=v;c[H>>2]=k;c[H+4>>2]=z}m=m+1|0;i=h}c[D>>2]=p;h=(jF(q,D)|0)+64|0;e=h;f=z0(c[e>>2]|0,c[e+4>>2]|0,f|0,i|0)|0;c[h>>2]=f;c[h+4>>2]=z;h=E;f=c[h>>2]|0;h=c[h+4>>2]|0;e=F;d=c[e>>2]|0;e=c[e+4>>2]|0;if(e>>>0>h>>>0|(e|0)==(h|0)&d>>>0>f>>>0){H=D_(d|0,e|0,f|0,h|0)|0;e1(a,H,z)}l=G;return}function jh(f){f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;q=l;l=l+16|0;g=q+1|0;h=q;GC(f);j=f+648|0;A6(c[j>>2]|0);k=f+2506|0;xR(f,2,k);A6(c[j>>2]|0);p=f+2468|0;i=f+2507|0;if((a[k>>0]|0)==2){xR(f,4,i);xR(f,7,f+2508|0)}else{xR(f,6,i);AT(f,g);do if(a[g>>0]|0)if((a[f+2462>>0]|0)==1){AT(f,h);if(a[h>>0]|0)d4(c[j>>2]|0,5);g=a[i>>0]|0;h=a[368811+(d[p>>0]|0)>>0]|0;g=(g&255)>(h&255)?h:g;h=0;while(1){if((h&255)>=(g&255))break;A6(c[j>>2]|0);h=h+1<<24>>24}break}else{AT(f,h);if(a[h>>0]|0)WC(f);if(a[f+2505>>0]|0?(AT(f,h),a[h>>0]|0):0)WC(f);break}while(0)}J3(f);m=f+2466|0;n=f+2510|0;o=f+19544|0;g=f+2509|0;h=f+2511|0;a:do switch(a[k>>0]|0){case 3:case 1:case 0:{a[g>>0]=1;a[n>>0]=1;a[h>>0]=1;h=c[10892+(d[p>>0]<<2)>>2]|0;j=a[h>>0]|0;a[o>>0]=j;g=0;while(1){i=g&255;if(i>>>0>=((j&255)+1|0)>>>0)break a;p=b[h+2+(i<<1)>>1]|0;j=b[m>>1]|0;j=(p&65535)<(j&65535)?p:j;b[f+18904+(i<<1)>>1]=j;b[f+2520+(i<<1)>>1]=j;g=g+1<<24>>24;j=a[o>>0]|0}}case 2:{a[g>>0]=8;a[n>>0]=1;a[h>>0]=1;i=c[10840+(d[p>>0]<<2)>>2]|0;g=a[i>>0]|0;a[o>>0]=g;h=0;while(1){j=h&255;g=g&255;if(j>>>0>=(g+1|0)>>>0)break;b[f+18904+(j<<1)>>1]=b[i+2+(j<<1)>>1]|0;h=h+1<<24>>24;g=a[o>>0]|0}b[f+18904+(g<<1)>>1]=(e[m>>1]|0)>>>3;g=f+2508|0;i=0;while(1){if((i|0)==7){h=0;break}h=a[n>>0]|0;if(!(d[g>>0]&1<<6-i)){m=h+1<<24>>24;a[n>>0]=m;a[(m&255)+-1+(f+2511)>>0]=1}else{m=(h&255)+-1+(f+2511)|0;a[m>>0]=(a[m>>0]|0)+1<<24>>24}i=i+1|0}while(1){if((h|0)>=(d[n>>0]|0))break a;i=f+2511+h|0;g=0;k=0;while(1){j=f+2520+(h<<11)+(k<<1)|0;if(k>>>0>=(d[o>>0]|0)>>>0)break;r=c[10840+(d[p>>0]<<2)>>2]|0;m=k+1|0;r=O((e[r+2+(m<<1)>>1]|0)-(e[r+2+(k<<1)>>1]|0)&65535,d[i>>0]|0)|0;b[j>>1]=g;g=r+(g&65535)&65535;k=m}b[j>>1]=g;h=h+1|0}}default:{}}while(0);l=q;return}function kh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+64|0;i=q+48|0;j=q+36|0;k=q+24|0;m=q+12|0;n=q;h=a[d+8+3>>0]|0;e=h<<24>>24<0;a:do if(((e?c[d+4>>2]|0:h&255)|0)==6?(o=e?c[d>>2]|0:d,(c[o>>2]|0)==48):0){switch(c[o+4>>2]|0){case 48:{h=2;e=0;while(1){if(h>>>0>=6){p=12;break}e=(e&65535)<<4;g=c[o+(h<<2)>>2]|0;f=e&65520;if((g|0)<=47){p=11;break}if((g|0)>=58){if((g|0)<=64){p=11;break}if((g|0)>=71)if((g+-97|0)>>>0<6)f=65449;else{p=11;break}else{e=f;f=-55}}else{e=f;f=-48}h=h+1|0;e=f+g+e&65535}if((p|0)==11){p2(b,d);break a}else if((p|0)==12){rU(b,e,10);break a}break}case 49:{h=2;f=0;break}default:{p=36;break a}}while(1){e=f&65535;if(h>>>0>=6)break;e=e<<4;g=c[o+(h<<2)>>2]|0;f=e&65520;if((g|0)<=47){p=20;break}if((g|0)>=58){if((g|0)<=64){p=20;break}if((g|0)>=71)if((g+-97|0)>>>0<6)f=65449;else{p=20;break}else{e=f;f=-55}}else{e=f;f=-48}h=h+1|0;f=f+g+e&65535}if((p|0)==20){p2(b,d);break}o=e-(f&255)|0;e=o>>>8&255;uU(j,f&255,10);b:do if((o&65535)<<16>>16==0|e<<24>>24==0){TX(n);c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];e=0;while(1){if((e|0)==3){f=1;g=0;break b}c[n+(e<<2)>>2]=0;e=e+1|0}}else{uU(m,e,10);zv(m,(a[m+8+3>>0]|0)<0?c[m>>2]|0:m,45);c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];e=0;while(1){if((e|0)==3){f=0;g=1;break b}c[m+(e<<2)>>2]=0;e=e+1|0}}while(0);e=a[k+8+3>>0]|0;o=e<<24>>24<0;Ex(j,o?c[k>>2]|0:k,o?c[k+4>>2]|0:e&255)|0;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];e=0;while(1){if((e|0)==3)break;c[j+(e<<2)>>2]=0;e=e+1|0}p2(b,i);O0(i);O0(k);if(f)z5(n);if(g)z5(m);z5(j)}else p=36;while(0);if((p|0)==36)p2(b,d);l=q;return}function lh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+64|0;p=u+48|0;q=u+36|0;r=u+24|0;s=u+12|0;t=u;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[p+(e<<2)>>2]=0;e=e+1|0}i=d>>>24&255;ay(p,1,i)|0;j=d>>>16&255;ay(p,1,j)|0;k=d>>>8&255;ay(p,1,k)|0;h=d&255;m=d&255;ay(p,1,m)|0;cC(b,(a[p+11>>0]|0)<0?c[p>>2]|0:p)|0;n=b+8+3|0;e=a[n>>0]|0;f=e<<24>>24<0;o=b+4|0;e=e&255;if(f)g=c[o>>2]|0;else g=e;do if((g|0)!=4){if(f)e=c[o>>2]|0;if((((h|0)==0&(e|0)==3?(c[(SQ(b,0)|0)>>2]|0)>31:0)?(c[(SQ(b,1)|0)>>2]|0)>31:0)?(c[(SQ(b,2)|0)>>2]|0)>31:0)break;e=a[n>>0]|0;if(e<<24>>24<0)e=c[o>>2]|0;else e=e&255;if(((d&65535|0)==0&(e|0)==2?(c[(SQ(b,0)|0)>>2]|0)>31:0)?(c[(SQ(b,1)|0)>>2]|0)>31:0)break;e=a[n>>0]|0;if(e<<24>>24<0)f=c[o>>2]|0;else f=e&255;if((d&16777215|0)==0&(f|0)==1){if((c[(SQ(b,0)|0)>>2]|0)>31)break;e=a[n>>0]|0}if(e<<24>>24<0){y7(c[b>>2]|0,0);c[o>>2]=0}else{y7(b,0);a[n>>0]=0}HX(b,42152)|0;TX(q);ex(q,i)|0;o=a[q+8+3>>0]|0;n=o<<24>>24<0;Ex(b,n?c[q>>2]|0:q,n?c[q+4>>2]|0:o&255)|0;z5(q);TX(r);ex(r,j)|0;q=a[r+8+3>>0]|0;o=q<<24>>24<0;Ex(b,o?c[r>>2]|0:r,o?c[r+4>>2]|0:q&255)|0;z5(r);TX(s);ex(s,k)|0;r=a[s+8+3>>0]|0;q=r<<24>>24<0;Ex(b,q?c[s>>2]|0:s,q?c[s+4>>2]|0:r&255)|0;z5(s);TX(t);ex(t,m)|0;s=a[t+8+3>>0]|0;r=s<<24>>24<0;Ex(b,r?c[t>>2]|0:t,r?c[t+4>>2]|0:s&255)|0;z5(t)}while(0);a1(p);l=u;return b|0}function mh(b){b=b|0;var e=0,f=0,g=0;e=b+312|0;f=e;f=z0(c[f>>2]|0,c[f+4>>2]|0,1,0)|0;c[e>>2]=f;c[e+4>>2]=z;e=b+840|0;f=b+536|0;a:do if(!(a[(c[b+804>>2]|0)+((d[e>>0]|0)*120|0)+116>>0]|0))e1(b,c[f>>2]|0,c[f+4>>2]|0);else{if((a[b+760>>0]|0?(c[b+728>>2]&1|0)==0:0)?(W5(b),(a[b+492>>0]|0)==0):0)RB(b,0,0,57,378150,-1,1,0);g=a[e>>0]|0;e=g&255;do switch(g<<24>>24){case -71:break a;case -70:{Xg(b);break a}case -69:{Cg(b);break a}case -68:{Oj(b);break a}case -67:{eg(b);break a}case -66:{G$(b);break a}case -65:{Xr(b);break a}case -16:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}case -15:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}case -14:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}case -13:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}case -12:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}case -11:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}case -10:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}case -9:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}case -8:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}case -7:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}case -6:{ce(b);break a}case -5:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}case -4:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}case -3:{Qc(b);break a}case -2:{of(b);break a}case -1:{g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break a}default:{if((e&224|0)==192){If(b);break a}if((e&240|0)==224){of(b);break a}else{t4(b);break a}}}while(0)}while(0);return}function nh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;n=l;l=l+832|0;k=n;f=n+816|0;g=n+804|0;h=n+792|0;EL(k);d=b+16|0;c[k+760>>2]=c[d>>2];i=b+20|0;c[k+764>>2]=c[i>>2];a[k+768>>0]=1;m=b+520|0;o=m;p=c[o>>2]|0;o=c[o+4>>2]|0;j=b+788|0;q=m;c[q>>2]=c[j>>2];c[q+4>>2]=0;aY(b,k);c[m>>2]=p;c[m+4>>2]=o;m=b+761|0;a[m>>0]=1;rB(b,k);G2(b,k);Gb(b,k,c[d>>2]|0,0,c[i>>2]|0,1)|0;a:do if((c[d>>2]|0)==2){$x(f,b,2,c[i>>2]|0,18,1);d=i9(29652)|0;q=a[f+8+3>>0]|0;if((d|0)==((q<<24>>24<0?c[f+4>>2]|0:q&255)|0)?(VG(f,29652,d)|0)==0:0)z5(f);else e=5;do if((e|0)==5){$x(g,b,2,c[i>>2]|0,18,1);d=i9(40168)|0;q=a[g+8+3>>0]|0;if((d|0)==((q<<24>>24<0?c[g+4>>2]|0:q&255)|0)?(VG(g,40168,d)|0)==0:0){z5(g);z5(f);break}$x(h,b,2,c[i>>2]|0,18,1);d=i9(29668)|0;q=a[h+8+3>>0]|0;if((d|0)==((q<<24>>24<0?c[h+4>>2]|0:q&255)|0)){q=(VG(h,29668,d)|0)==0;z5(h);z5(g);z5(f);if(q)break;else break a}else{z5(h);z5(g);z5(f);break a}}while(0);Ed(b,2,c[i>>2]|0,147)}while(0);h=k+772|0;if(c[h>>2]|0){g=b+916|0;e=0;while(1){q=bF(g,j)|0;q=e>>>0<(c[q+16>>2]|0)-(c[q+12>>2]|0)>>2>>>0;d=bF(g,j)|0;f=c[d+12>>2]|0;if(!q)break;d=c[f+(e<<2)>>2]|0;if(d|0)jb[c[(c[d>>2]|0)+4>>2]&511](d);e=e+1|0}d=d+16|0;e=c[d>>2]|0;while(1){if((e|0)==(f|0))break;q=e+-4|0;c[d>>2]=q;e=q}d=bF(g,j)|0;e=d+16|0;f=c[e>>2]|0;if((f|0)==(c[d+20>>2]|0))Yy(d+12|0,h);else{c[f>>2]=c[h>>2];c[e>>2]=(c[e>>2]|0)+4}a[m>>0]=1}EO(k);l=n;return}function oh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;h=l;l=l+32|0;f=h;g=Re(a,b,d)|0;j=e;i=d;if(M$(c[j>>2]|0,c[j+4>>2]|0,c[i>>2]|0,c[i+4>>2]|0)|0){c[f>>2]=c[d>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];c[f+12>>2]=c[d+12>>2];c[f+16>>2]=c[d+16>>2];c[f+20>>2]=c[d+20>>2];c[f+24>>2]=c[d+24>>2];c[f+28>>2]=c[d+28>>2];c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];c[d+28>>2]=c[e+28>>2];c[e>>2]=c[f>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];e=g+1|0;i=d;j=b;if(M$(c[i>>2]|0,c[i+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0){c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];c[d+28>>2]=c[f+28>>2];i=b;j=a;if(M$(c[i>>2]|0,c[i+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0){c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];c[b>>2]=c[f>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];c[b+16>>2]=c[f+16>>2];c[b+20>>2]=c[f+20>>2];c[b+24>>2]=c[f+24>>2];c[b+28>>2]=c[f+28>>2];e=g+3|0}else e=g+2|0}}else e=g;l=h;return e|0}function ph(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;l=a;j=b;k=j;h=d;n=e;i=n;if(!k){g=(f|0)!=0;if(!i){if(g){c[f>>2]=(l>>>0)%(h>>>0);c[f+4>>2]=0}n=0;f=(l>>>0)/(h>>>0)>>>0;return (z=n,f)|0}else{if(!g){n=0;f=0;return (z=n,f)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;f=0;return (z=n,f)|0}}g=(i|0)==0;do if(h){if(!g){g=(R(i|0)|0)-(R(k|0)|0)|0;if(g>>>0<=31){m=g+1|0;i=31-g|0;b=g-31>>31;h=m;a=l>>>(m>>>0)&b|k<<i;b=k>>>(m>>>0)&b;g=0;i=l<<i;break}if(!f){n=0;f=0;return (z=n,f)|0}c[f>>2]=a|0;c[f+4>>2]=j|b&0;n=0;f=0;return (z=n,f)|0}g=h-1|0;if(g&h|0){i=(R(h|0)|0)+33-(R(k|0)|0)|0;p=64-i|0;m=32-i|0;j=m>>31;o=i-32|0;b=o>>31;h=i;a=m-1>>31&k>>>(o>>>0)|(k<<m|l>>>(i>>>0))&b;b=b&k>>>(i>>>0);g=l<<p&j;i=(k<<p|l>>>(o>>>0))&j|l<<m&i-33>>31;break}if(f|0){c[f>>2]=g&l;c[f+4>>2]=0}if((h|0)==1){o=j|b&0;p=a|0|0;return (z=o,p)|0}else{p=$S(h|0)|0;o=k>>>(p>>>0)|0;p=k<<32-p|l>>>(p>>>0)|0;return (z=o,p)|0}}else{if(g){if(f|0){c[f>>2]=(k>>>0)%(h>>>0);c[f+4>>2]=0}o=0;p=(k>>>0)/(h>>>0)>>>0;return (z=o,p)|0}if(!l){if(f|0){c[f>>2]=0;c[f+4>>2]=(k>>>0)%(i>>>0)}o=0;p=(k>>>0)/(i>>>0)>>>0;return (z=o,p)|0}g=i-1|0;if(!(g&i)){if(f|0){c[f>>2]=a|0;c[f+4>>2]=g&k|b&0}o=0;p=k>>>(($S(i|0)|0)>>>0);return (z=o,p)|0}g=(R(i|0)|0)-(R(k|0)|0)|0;if(g>>>0<=30){b=g+1|0;i=31-g|0;h=b;a=k<<i|l>>>(b>>>0);b=k>>>(b>>>0);g=0;i=l<<i;break}if(!f){o=0;p=0;return (z=o,p)|0}c[f>>2]=a|0;c[f+4>>2]=j|b&0;o=0;p=0;return (z=o,p)|0}while(0);if(!h){k=i;j=0;i=0}else{m=d|0|0;l=n|e&0;k=z0(m|0,l|0,-1,-1)|0;d=z;j=i;i=0;do{e=j;j=g>>>31|j<<1;g=i|g<<1;e=a<<1|e>>>31|0;n=a>>>31|b<<1|0;D_(k|0,d|0,e|0,n|0)|0;p=z;o=p>>31|((p|0)<0?-1:0)<<1;i=o&1;a=D_(e|0,n|0,o&m|0,(((p|0)<0?-1:0)>>31|((p|0)<0?-1:0)<<1)&l|0)|0;b=z;h=h-1|0}while((h|0)!=0);k=j;j=0}h=0;if(f|0){c[f>>2]=a;c[f+4>>2]=b}o=(g|0)>>>31|(k|h)<<1|(h<<1|g>>>31)&0|j;p=(g<<1|0>>>31)&-2|i;return (z=o,p)|0}function qh(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+80|0;g=p+72|0;f=p+76|0;i=p+60|0;j=p+48|0;k=p+36|0;m=p+24|0;n=p+12|0;o=p;NB(d,f);jB(d,g);if(qO(d)|0){h=d+764|0;d=c[h>>2]|0;e=a[d+36+3>>0]|0;if(e<<24>>24<0)d=c[d+32>>2]|0;else d=e&255;e=b[f>>1]|0;if(!d){ci(n,e);DW(n,0,42232)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];d=0;while(1){if((d|0)==3)break;c[n+(d<<2)>>2]=0;d=d+1|0}HX(m,42252)|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];d=0;while(1){if((d|0)==3)break;c[m+(d<<2)>>2]=0;d=d+1|0}Qh(o,c[g>>2]|0);d=a[o+8+3>>0]|0;f=d<<24>>24<0;Ex(k,f?c[o>>2]|0:o,f?c[o+4>>2]|0:d&255)|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];d=0;while(1){if((d|0)==3)break;c[k+(d<<2)>>2]=0;d=d+1|0}p2(i,j);vF((c[h>>2]|0)+28|0,i)|0;z5(i);O0(j);z5(o);O0(k);O0(m);z5(n)}ci(n,e);DW(n,0,42232)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];d=0;while(1){if((d|0)==3)break;c[n+(d<<2)>>2]=0;d=d+1|0}HX(m,42252)|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];d=0;while(1){if((d|0)==3)break;c[m+(d<<2)>>2]=0;d=d+1|0}Qh(o,c[g>>2]|0);d=a[o+8+3>>0]|0;g=d<<24>>24<0;Ex(k,g?c[o>>2]|0:o,g?c[o+4>>2]|0:d&255)|0;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];d=0;while(1){if((d|0)==3)break;c[k+(d<<2)>>2]=0;d=d+1|0}p2(i,j);vF((c[h>>2]|0)+40|0,i)|0;z5(i);O0(j);z5(o);O0(k);O0(m);z5(n);a[(c[h>>2]|0)+52>>0]=1}l=p;return}
function cv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;f=d;a:do if(!((f^b)&3)){if(!(f&3))e=d;else while(1){f=a[d>>0]|0;a[b>>0]=f;if(!(f<<24>>24))break a;d=d+1|0;b=b+1|0;if(!(d&3)){e=d;break}}d=c[e>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))while(1){e=e+4|0;f=b+4|0;c[b>>2]=d;d=c[e>>2]|0;if((d&-2139062144^-2139062144)&d+-16843009|0){b=f;break}else b=f}g=b;h=8}else{e=d;g=b;h=8}while(0);if((h|0)==8?(h=a[e>>0]|0,a[g>>0]=h,h<<24>>24):0){b=g;do{e=e+1|0;b=b+1|0;h=a[e>>0]|0;a[b>>0]=h}while(h<<24>>24!=0)}return}function dv(a){a=a|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+32|0;j=k;f=k+14|0;g=k+16|0;TX(j);NB(a,f);NB(a,k+12|0);h=b[f>>1]|0;if(!(h<<16>>16))e=0;else{EG(a,g);i=a+528|0;e=h+-1<<16>>16;if((d[g>>0]|0)<32){h=i;h=z0(c[h>>2]|0,c[h+4>>2]|0,1,0)|0;c[i>>2]=h;c[i+4>>2]=z;b[f>>1]=e}else e=h}jZ(a,e&65535,0,j);if(qO(a)|0)Mc(a,4,c[a+20>>2]|0,380183,j,0);z5(j);l=k;return}function ev(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=b+528|0;j=g;h=c[j>>2]|0;j=z0(h|0,c[j+4>>2]|0,d|0,e|0)|0;l=z;i=b+536|0;k=c[i+4>>2]|0;do if(l>>>0>k>>>0|((l|0)==(k|0)?j>>>0>(c[i>>2]|0)>>>0:0)){vt(b);b=f+8+3|0;if((a[b>>0]|0)<0){y7(c[f>>2]|0,0);c[f+4>>2]=0;break}else{y7(f,0);a[b>>0]=0;break}}else{h2(f,(c[b+544>>2]|0)+(c[b+612>>2]|0)+h|0,d)|0;k=g;k=z0(c[k>>2]|0,c[k+4>>2]|0,d|0,e|0)|0;l=g;c[l>>2]=k;c[l+4>>2]=z}while(0);return}function fv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=b+528|0;j=g;h=c[j>>2]|0;j=z0(h|0,c[j+4>>2]|0,d|0,e|0)|0;l=z;i=b+536|0;k=c[i+4>>2]|0;do if(l>>>0>k>>>0|((l|0)==(k|0)?j>>>0>(c[i>>2]|0)>>>0:0)){vt(b);b=f+8+3|0;if((a[b>>0]|0)<0){y7(c[f>>2]|0,0);c[f+4>>2]=0;break}else{y7(f,0);a[b>>0]=0;break}}else{i2(f,(c[b+544>>2]|0)+(c[b+612>>2]|0)+h|0,d)|0;k=g;k=z0(c[k>>2]|0,c[k+4>>2]|0,d|0,e|0)|0;l=g;c[l>>2]=k;c[l+4>>2]=z}while(0);return}function gv(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j;bV(d);c[d>>2]=41956;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;e=d+52|0;i=d+68|0;f=e;g=f+44|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));b[e+44>>1]=0;a[e+46>>0]=0;e=d+4|0;N3(h,c[e>>2]|0);g=C2(c[h>>2]|0)|0;c6(h);if(g){N3(h,c[e>>2]|0);c[i>>2]=u$(c[h>>2]|0,410908)|0;c6(h);i=c[i>>2]|0;a[d+98>>0]=(nb[c[(c[i>>2]|0)+28>>2]&255](i)|0)&1}gb[c[(c[d>>2]|0)+12>>2]&31](d,0,4096)|0;l=j;return}function hv(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0;j=l;l=l+112|0;e=j+4|0;f=j;c[f>>2]=e+100;oF(b+8|0,e,f,g,h,i);i=c[f>>2]|0;h=e;e=c[d>>2]|0;while(1){if((h|0)==(i|0))break;f=a[h>>0]|0;if(!e)e=0;else{b=e+24|0;g=c[b>>2]|0;if((g|0)==(c[e+28>>2]|0)){d=c[(c[e>>2]|0)+52>>2]|0;f=e9(f)|0;f=tb[d&31](e,f)|0}else{c[b>>2]=g+1;a[g>>0]=f;f=e9(f)|0}d=d8(f,-1)|0;e=d?0:e}h=h+1|0}l=j;return e|0}function iv(a){a=a|0;var b=0,d=0,e=0,f=0;c[a>>2]=36004;e=a+792|0;f=a+796|0;d=0;while(1){b=c[e>>2]|0;if(d>>>0>=(c[f>>2]|0)-b>>2>>>0)break;b=c[b+(d<<2)>>2]|0;if(b|0)laa(b);d=d+1|0}a1(a+1092|0);iV(a+1080|0);a1(a+880|0);z5(a+868|0);z5(a+856|0);z5(a+844|0);z5(a+832|0);z5(a+820|0);aU(a+808|0);cU(e);pS(a+780|0);bt(a);return}function jv(a){a=a|0;var b=0,d=0,e=0,f=0;f=l;l=l+16|0;e=f;W0(e,a+360|0);d=a+20|0;b=c[d>>2]|0;if(b){jy(b);b=a+80|0;if(!(dS(b)|0)?!(VR(b)|0):0){b=c[d>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);c[d>>2]=0}if((c[a+136>>2]|0)>>>0<(((c[a+88>>2]|0)-(c[a+84>>2]|0)|0)/12|0)>>>0)b=1;else{b=a+152|0;jaa(c[b>>2]|0);c[b>>2]=0;c[a+148>>2]=0;c[a+140>>2]=0;b=1}}else b=0;s7(c[e>>2]|0);l=f;return b|0}function kv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=b+528|0;j=g;h=c[j>>2]|0;j=z0(h|0,c[j+4>>2]|0,d|0,e|0)|0;l=z;i=b+536|0;k=c[i+4>>2]|0;do if(l>>>0>k>>>0|((l|0)==(k|0)?j>>>0>(c[i>>2]|0)>>>0:0)){vt(b);b=f+8+3|0;if((a[b>>0]|0)<0){y7(c[f>>2]|0,0);c[f+4>>2]=0;break}else{y7(f,0);a[b>>0]=0;break}}else{M2(f,(c[b+544>>2]|0)+(c[b+612>>2]|0)+h|0,d)|0;k=g;k=z0(c[k>>2]|0,c[k+4>>2]|0,d|0,e|0)|0;l=g;c[l>>2]=k;c[l+4>>2]=z}while(0);return}function lv(d){d=d|0;var e=0,f=0,g=0;Eg(d);c[d>>2]=27516;c[d+860>>2]=0;c[d+864>>2]=0;c[d+868>>2]=0;e=d+72|0;f=d+804|0;g=f+36|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));IX(e,378318)|0;a[d+733>>0]=1;g=d+632|0;c[g>>2]=65536;c[g+4>>2]=0;g=d+640|0;c[g>>2]=-1;c[g+4>>2]=-1;c[d+504>>2]=2;a[d+760>>0]=0;a[d+761>>0]=0;g=d+764|0;c[g>>2]=0;c[g+4>>2]=0;b[g+8>>1]=0;a[d+774>>0]=1;c[d+776>>2]=0;c[d+780>>2]=0;a[d+784>>0]=0;g=d+848|0;c[g>>2]=8388608;c[g+4>>2]=0;a[d+857>>0]=0;b[d+858>>1]=0;c[d+800>>2]=-1;Mt(d);return}function mv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(h-d>>2>>>0<b>>>0){f=c[a>>2]|0;d=d-f>>2;e=d+b|0;if(e>>>0>1073741823)uaa();else{f=h-f|0;h=f>>1;BF(g,f>>2>>>0<536870911?(h>>>0<e>>>0?e:h):1073741823,d,a+8|0);gS(g,b);aB(a,g);zS(g);break}}else nS(a,b);while(0);l=i;return}function nv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=b+528|0;j=g;h=c[j>>2]|0;j=z0(h|0,c[j+4>>2]|0,d|0,e|0)|0;l=z;i=b+536|0;k=c[i+4>>2]|0;do if(l>>>0>k>>>0|((l|0)==(k|0)?j>>>0>(c[i>>2]|0)>>>0:0)){vt(b);b=f+8+3|0;if((a[b>>0]|0)<0){y7(c[f>>2]|0,0);c[f+4>>2]=0;break}else{y7(f,0);a[b>>0]=0;break}}else{b3(f,(c[b+544>>2]|0)+(c[b+612>>2]|0)+h|0,d)|0;k=g;k=z0(c[k>>2]|0,c[k+4>>2]|0,d|0,e|0)|0;l=g;c[l>>2]=k;c[l+4>>2]=z}while(0);return}function ov(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=b+528|0;j=g;h=c[j>>2]|0;j=z0(h|0,c[j+4>>2]|0,d|0,e|0)|0;l=z;i=b+536|0;k=c[i+4>>2]|0;do if(l>>>0>k>>>0|((l|0)==(k|0)?j>>>0>(c[i>>2]|0)>>>0:0)){vt(b);b=f+8+3|0;if((a[b>>0]|0)<0){y7(c[f>>2]|0,0);c[f+4>>2]=0;break}else{y7(f,0);a[b>>0]=0;break}}else{U2(f,(c[b+544>>2]|0)+(c[b+612>>2]|0)+h|0,d);k=g;k=z0(c[k>>2]|0,c[k+4>>2]|0,d|0,e|0)|0;l=g;c[l>>2]=k;c[l+4>>2]=z}while(0);return}function pv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=l;l=l+16|0;c=f;d=b&65535;if(b<<16>>16<32767)switch(b<<16>>16){case -1:{e=2;break}default:e=3}else switch(b<<16>>16){case 32767:{e=2;break}default:e=3}do if((e|0)==2)TX(a);else if((e|0)==3)if((b&65535)<256){GN(a,b);break}else{TX(c);Fx(c,1,d>>>10|96)|0;Fx(c,1,d>>>5&31|96)|0;Fx(c,1,d&31|96)|0;rV(a,c);z5(c);break}while(0);l=f;return}function qv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=b+4|0;i=c[h>>2]|0;f=c[a>>2]|0;e=d;g=i;while(1){if((e|0)==(f|0))break;k=e+-12|0;rV(g+-12|0,k);j=(c[h>>2]|0)+-12|0;c[h>>2]=j;e=k;g=j}e=a+4|0;f=c[e>>2]|0;g=b+8|0;while(1){if((d|0)==(f|0))break;rV(c[g>>2]|0,d);c[g>>2]=(c[g>>2]|0)+12;d=d+12|0}k=c[a>>2]|0;c[a>>2]=c[h>>2];c[h>>2]=k;k=c[e>>2]|0;c[e>>2]=c[g>>2];c[g>>2]=k;a=a+8|0;k=b+12|0;j=c[a>>2]|0;c[a>>2]=c[k>>2];c[k>>2]=j;c[b>>2]=c[h>>2];return i|0}function rv(a){a=a|0;var b=0,d=0,e=0,f=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);d=a+528|0;e=d;e=z0(c[e>>2]|0,c[e+4>>2]|0,16,0)|0;c[d>>2]=e;c[d+4>>2]=z;if(qO(a)|0?(c[a+16>>2]|0)==7:0){Kc(a,4,-1)|0;f=a+20|0;RB(a,4,c[f>>2]|0,18,377432,-1,1,0);d=a+916|0;e=a+788|0;c[(bF(d,e)|0)+44>>2]=4;a=c[f>>2]|0;c[(bF(d,e)|0)+48>>2]=a}l=b;return}function sv(a,b){a=a|0;b=b|0;if(!((b|0)>0|(b|0)==0&a>>>0>92016))if(!((b|0)>0|(b|0)==0&a>>>0>75131))if(!((b|0)>0|(b|0)==0&a>>>0>55425))if(!((b|0)>0|(b|0)==0&a>>>0>46008))if(!((b|0)>0|(b|0)==0&a>>>0>37565))if(!((b|0)>0|(b|0)==0&a>>>0>27712))if(!((b|0)>0|(b|0)==0&a>>>0>23003))if(!((b|0)>0|(b|0)==0&a>>>0>18782))if((b|0)>0|(b|0)==0&a>>>0>13855)a=8;else return ((b|0)>0|(b|0)==0&a>>>0>11501?9:(b|0)>0|(b|0)==0&a>>>0>9390?10:11)|0;else a=7;else a=6;else a=5;else a=4;else a=3;else a=2;else a=1;else a=0;return a|0}function tv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;g=c[d>>2]|0;if((c[d+4>>2]|0)-g>>2>>>0>e>>>0)a[b+1047>>0]=1;else{FF(d,e+1|0);g=c[d>>2]|0}g=g+(e<<2)|0;d=c[g>>2]|0;if(d|0){W_(c[d>>2]|0);laa(d)}c[g>>2]=f;switch(a[f+44>>0]|0){case 0:{h=c[f+28>>2]|0;j=9;break}case 2:case 1:{h=c[f+32>>2]<<1;j=9;break}default:{}}if((j|0)==9?(i=b+808|0,h>>>0>(c[i>>2]|0)>>>0):0){FF(b+784|0,h<<2);c[i>>2]=h}return}function uv(b){b=b|0;var d=0,e=0,f=0;f=l;l=l+16|0;d=f;e=b+24|0;if((a[b+492>>0]|0)==0?(c[b+904>>2]|0)==1785737760:0){a[b+493>>0]=1;TX(d);z5(d);d=c[e>>2]|0;if((((c[d+8>>2]|0)-(c[d+4>>2]|0)|0)/12|0)>>>0>1)d=1;else{d=IR(d)|0;d=d?1:5}Kc(b,d,-1)|0;if((c[b+16>>2]|0)==1){d=c[e>>2]|0;lL(b,1,c[b+20>>2]|0,185,((c[d+8>>2]|0)-(c[d+4>>2]|0)|0)/12|0,10,0)}}c[b+624>>2]=67108864;c[b+932>>2]=pR(c[e>>2]|0)|0;l=f;return}function vv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+32|0;d=h;e=c[a>>2]|0;f=((c[a+4>>2]|0)-e|0)/12|0;g=f+1|0;if(g>>>0>357913941)uaa();else{i=((c[a+8>>2]|0)-e|0)/12|0;e=i<<1;xE(d,i>>>0<178956970?(e>>>0<g>>>0?g:e):357913941,f,a+8|0);g=d+8|0;f=c[g>>2]|0;wz(f,b);c[g>>2]=f+12;Xv(a,d);EM(d);l=h;return}}function wv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=l;l=l+16|0;bB(a,f+4|0);jB(a,f);d=a+528|0;e=a+536|0;b=a+648|0;while(1){h=d;j=c[h+4>>2]|0;g=e;i=c[g+4>>2]|0;if(!(j>>>0<i>>>0|((j|0)==(i|0)?(c[h>>2]|0)>>>0<(c[g>>2]|0)>>>0:0)))break;GC(a);Bx(a);d4(c[b>>2]|0,2);d4(c[b>>2]|0,2);d4(c[b>>2]|0,2);d4(c[b>>2]|0,2);wK(a);J3(a)}l=f;return}function xv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=b+764|0;d=c[b+760>>2]|0;a:while(1){if((d|0)==(i|0))break;g=d+24|0;h=d+28|0;e=0;while(1){f=c[g>>2]|0;if(e>>>0>=(c[h>>2]|0)-f>>2>>>0)break;Kl(c[f+(e<<2)>>2]|0);e=e+1|0}e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue a}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}b:do if(a[b+492>>0]|0){d=b+508|0;while(1){if(!(c[d>>2]|0))break b;J3(b)}}while(0);return}function yv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=l;l=l+16|0;e=g;L2(e);j0(a,e);e=e+8|0;d=c[e>>2]|0;e=c[e+4>>2]|0;b=b+-16|0;a:do if((d|0)<-1198372831){switch(d|0){case -1256765477:break;default:{f=6;break a}}if((e|0)==748871177)cd(a,b);else f=6}else{switch(d|0){case -1198372831:break;default:{f=6;break a}}if((e|0)==1115671707)qm(a,b);else f=6}while(0);if((f|0)==6)e1(a,b,0);l=g;return}function zv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=b+8|0;k=f+3|0;g=a[k>>0]|0;i=g<<24>>24<0;l=b+4|0;if(i){h=c[b>>2]|0;f=(c[f>>2]&2147483647)+-1|0;j=c[l>>2]|0}else{h=b;f=1;j=g&255}d=d-h>>2;if((f|0)!=(j|0)){if(i)b=c[b>>2]|0;f=j-d|0;g=b+(d<<2)|0;if(f)W2(g+4|0,g,f)}else{ax(b,j,1,j,d,1);b=c[b>>2]|0}y7(b+(d<<2)|0,e);f=j+1|0;y7(b+(f<<2)|0,0);if((a[k>>0]|0)<0)c[l>>2]=f;else a[k>>0]=f;return}function Av(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+16|0;h=k+1|0;f=k;j=b+648|0;d4(c[j>>2]|0,4);AT(b,h);xR(b,8,f);m=a[f>>0]|0;e=m&255;if(m<<24>>24==-1){xR(b,8,f);e=(d[f>>0]|0)+e|0}if(a[h>>0]|0?(g=c[j>>2]|0,i=(Z9(c[g+4>>2]|0)|0)&7,i|0):0)d4(g,i&255);GC(b);f=e&65535;e=0;while(1){if((e&65535)>>>0>=f>>>0)break;d4(c[j>>2]|0,8);e=e+1<<16>>16}J3(b);l=k;return}function Bv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;g=l;l=l+16|0;b=g;d=an(a)|0;e=z;f=b;c[f>>2]=d;c[f+4>>2]=e;do if(qO(a)|0){f=a+1072|0;h=f;if((c[h>>2]|0)==-1?(c[h+4>>2]|0)==-1:0){h=a+1064|0;c[h>>2]=d;c[h+4>>2]=e;break}else{h=GG((kE(a+760|0,f)|0)+112|0,b)|0;e=h;e=z0(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;c[h>>2]=e;c[h+4>>2]=z;h=f;c[h>>2]=-1;c[h+4>>2]=-1;break}}while(0);l=g;return}function Cv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;b=b+4|0;e=Lw(d,c[b>>2]|0,b)|0;if((e|0)!=(b|0)?(h=e+16|0,f=a[e+24+3>>0]|0,i=f<<24>>24<0,f=i?c[e+20>>2]|0:f&255,g=a[d+8+3>>0]|0,j=g<<24>>24<0,g=j?c[d+4>>2]|0:g&255,d=L$(j?c[d>>2]|0:d,i?c[h>>2]|0:h,f>>>0<g>>>0?f:g)|0,(((d|0)==0?(g>>>0<f>>>0?-2147483648:0):d)|0)>=0):0)b=e;return b|0}function Dv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=l;l=l+16|0;f=h+12|0;g=h;Bx(b);i=b+648|0;d4(c[i>>2]|0,8);xR(b,2,f);d4(c[i>>2]|0,6);wK(b);e=z0(d|0,e|0,-2,-1)|0;e1(b,e,z);if(qO(b)|0){a[b+819>>0]=a[f>>0]|0;d=a[b+800+3>>0]|0;if(d<<24>>24<0)d=c[b+796>>2]|0;else d=d&255;if(!d){VU(g,375364);vF(b+792|0,g)|0;z5(g)}PU(b+836|0,6)|0}l=h;return}function Ev(a){a=a|0;hV(a+192|0);LV(a+180|0);LV(a+168|0);bU(a+136|0);dU(a+124|0);dU(a+112|0);n4(a+100|0);n4(a+88|0);n4(a+76|0);n4(a+64|0);n4(a+52|0);n4(a+40|0);SZ(a);return}function Fv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;j=l;l=l+32|0;g=j+12|0;i=j;$x(g,b,1,d,18,1);$x(i,b,1,d,e,1);h=pn(i)|0;z5(i);i=i9(39980)|0;k=a[g+8+3>>0]|0;if((i|0)==((k<<24>>24<0?c[g+4>>2]|0:k&255)|0)?(k=(VG(g,39980,i)|0)!=0,f=(h+-54942720|0)>>>0<2242561?56064e3:h,f=(f+-111390720|0)>>>0<4546561?113664e3:f,!((f|0)==(h|0)|k)):0)lL(b,1,d,e,f,0,1);z5(g);l=j;return}function Gv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+32|0;d=h;e=c[a>>2]|0;f=(c[a+4>>2]|0)-e>>5;g=f+1|0;if(g>>>0>134217727)uaa();else{i=(c[a+8>>2]|0)-e|0;e=i>>4;tE(d,i>>5>>>0<67108863?(e>>>0<g>>>0?g:e):134217727,f,a+8|0);g=d+8|0;f=c[g>>2]|0;$T(f,b);c[g>>2]=f+32;ly(a,d);zQ(d);l=h;return}}function Hv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=b+64|0;f=a+8|0;do if((c[e>>2]|0)!=0?(nb[c[(c[b>>2]|0)+24>>2]&255](b)|0)==0:0)if(!(x7(c[e>>2]|0,c[d+8>>2]|0,0)|0)){e=d;f=c[e+4>>2]|0;b=b+72|0;c[b>>2]=c[e>>2];c[b+4>>2]=f;c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];break}else{d=a;c[d>>2]=0;c[d+4>>2]=0;d=f;c[d>>2]=-1;c[d+4>>2]=-1;break}else g=3;while(0);if((g|0)==3){g=a;c[g>>2]=0;c[g+4>>2]=0;g=f;c[g>>2]=-1;c[g+4>>2]=-1}return}function Iv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+240|0;m=n;c[m>>2]=b;a:do if((d|0)>1){f=b;k=d;d=1;while(1){i=f+-1|0;j=k+-2|0;f=i+(0-(c[e+(j<<2)>>2]|0))|0;b=a[b>>0]|0;h=a[f>>0]|0;o=(z6(b,h)|0)>-1;g=a[i>>0]|0;if(o?(z6(b,g)|0)>-1:0)break a;b=d+1|0;d=m+(d<<2)|0;if((z6(h,g)|0)>-1){c[d>>2]=f;d=k+-1|0}else{c[d>>2]=i;f=i;d=j}if((d|0)<=1){d=b;break a}k=d;d=b;b=c[m>>2]|0}}else d=1;while(0);mG(m,d);l=n;return}function Jv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(h-d>>1>>>0<b>>>0){f=c[a>>2]|0;d=d-f>>1;e=d+b|0;if((e|0)<0)uaa();else{h=h-f|0;TF(g,h>>1>>>0<1073741823?(h>>>0<e>>>0?e:h):2147483647,d,a+8|0);JQ(g,b);$A(a,g);yS(g);break}}else nR(a,b);while(0);l=i;return}function Kv(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=a+4|0;g=c[f>>2]|0;do if(g){f=e8(a)|0;while(1){a=b[g+14>>1]|0;if((a&65535)>(e&65535)){a=c[g>>2]|0;if(!a){a=6;break}else{f=g;g=a}}else{if((a&65535)>=(e&65535)){a=10;break}f=g+4|0;a=c[f>>2]|0;if(!a){a=9;break}else g=a}}if((a|0)==6){c[d>>2]=g;f=g;break}else if((a|0)==9){c[d>>2]=g;break}else if((a|0)==10){c[d>>2]=g;break}}else c[d>>2]=f;while(0);return f|0}function Lv(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;j=b+8|0;j=nb[c[(c[j>>2]|0)+8>>2]&255](j)|0;b=a[j+8+3>>0]|0;if(b<<24>>24<0)i=c[j+4>>2]|0;else i=b&255;b=a[j+20+3>>0]|0;if(b<<24>>24<0)b=c[j+16>>2]|0;else b=b&255;do if((i|0)!=(0-b|0)){b=(Nf(e,f,j,j+24|0,h,g,0)|0)-j|0;i=c[d>>2]|0;if((i|0)==12&(b|0)==0){c[d>>2]=0;break}if((i|0)<12&(b|0)==12)c[d>>2]=i+12}else c[g>>2]=c[g>>2]|4;while(0);return}function Mv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+16|0;i=h+4|0;g=h;bB(b,i);f=b+528|0;d=f;d=z0(c[d>>2]|0,c[d+4>>2]|0,2,0)|0;e=z;c[f>>2]=d;c[f+4>>2]=e;f=b+536|0;switch(a[i>>0]|0){case 1:{ID(b,g);xM(b,c[b+16>>2]|0,0,378056,nX(c[g>>2]|0)|0,0);break}case 2:{i=f;e1(b,D_(c[i>>2]|0,c[i+4>>2]|0,d|0,e|0)|0,z);break}default:{i=f;e1(b,D_(c[i>>2]|0,c[i+4>>2]|0,d|0,e|0)|0,z)}}l=h;return}function Nv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=xw(b,c[101702]|0)|0;if(!((d|0)!=406808?(g=d+16|0,e=a[d+24+3>>0]|0,h=e<<24>>24<0,e=h?c[d+20>>2]|0:e&255,f=a[b+8+3>>0]|0,i=f<<24>>24<0,f=i?c[b+4>>2]|0:f&255,b=L$(i?c[b>>2]|0:b,h?c[g>>2]|0:g,e>>>0<f>>>0?e:f)|0,(((b|0)==0?(f>>>0<e>>>0?-2147483648:0):b)|0)>=0):0))d=406808;return d|0}function Ov(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;j=b+8|0;j=nb[c[(c[j>>2]|0)+8>>2]&255](j)|0;b=a[j+11>>0]|0;if(b<<24>>24<0)i=c[j+4>>2]|0;else i=b&255;b=a[j+12+11>>0]|0;if(b<<24>>24<0)b=c[j+16>>2]|0;else b=b&255;do if((i|0)!=(0-b|0)){b=(Df(e,f,j,j+24|0,h,g,0)|0)-j|0;i=c[d>>2]|0;if((i|0)==12&(b|0)==0){c[d>>2]=0;break}if((i|0)<12&(b|0)==12)c[d>>2]=i+12}else c[g>>2]=c[g>>2]|4;while(0);return}function Pv(a){a=a|0;var b=0,d=0,e=0,f=0;f=a+528|0;d=f;d=z0(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;b=f;c[b>>2]=d;c[b+4>>2]=z;iF(a,6,0);b=f;b=z0(c[b>>2]|0,c[b+4>>2]|0,2,0)|0;d=z;c[f>>2]=b;c[f+4>>2]=d;f=a+536|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(f>>>0>d>>>0|(f|0)==(d|0)&e>>>0>b>>>0){f=D_(e|0,f|0,b|0,d|0)|0;e1(a,f,z)}Kc(a,3,-1)|0;f=a+20|0;RB(a,3,c[f>>2]|0,18,378964,-1,1,0);RB(a,3,c[f>>2]|0,37,378964,-1,1,0);return}function Qv(b,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;c[b>>2]=d;c[b+4>>2]=e;a[b+8>>0]=f&1;c[b+12>>2]=g;c[b+16>>2]=h;c[b+20>>2]=i;c[b+24>>2]=j;c[b+28>>2]=k;c[b+32>>2]=l;c[b+36>>2]=m;c[b+40>>2]=n;a[b+44>>0]=o;a[b+45>>0]=p;a[b+46>>0]=q&1;a[b+47>>0]=r;a[b+48>>0]=s;a[b+49>>0]=t;a[b+50>>0]=u&1;a[b+51>>0]=v&1;a[b+52>>0]=w&1;return}function Rv(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;i=a+64|0;j=c[i>>2]|0;c[a+68>>2]=j;k=c[5676+(b<<2)>>2]|0;l=a+56|0;g=c[l>>2]|0;h=g+b|0;e=a+52|0;f=c[e>>2]|0;b=c[a+72>>2]|0;if((f+4|0)>=(b|0)?((f<<3)+h|0)>(b<<3|0):0){ob[c[(c[a>>2]|0)+8>>2]&3](a,0,0);b=-1}else{b=(d[j>>0]|0)>>>g;if(h>>>0>8){b=(d[j+1>>0]|0)<<8-g|b;if(h>>>0>16){b=(d[j+2>>0]|0)<<16-g|b;if(h>>>0>24){b=(d[j+3>>0]|0)<<24-g|b;if(!((g|0)==0|h>>>0<33))b=(d[j+4>>0]|0)<<32-g|b}}}c[i>>2]=j+(h>>>3);c[e>>2]=((h|0)/8|0)+f;c[l>>2]=h&7;b=b&k}return b|0}function Sv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+32|0;d=h;e=c[a>>2]|0;f=((c[a+4>>2]|0)-e|0)/24|0;g=f+1|0;if(g>>>0>178956970)uaa();else{i=((c[a+8>>2]|0)-e|0)/24|0;e=i<<1;zD(d,i>>>0<89478485?(e>>>0<g>>>0?g:e):178956970,f,a+8|0);g=d+8|0;f=c[g>>2]|0;h0(f,b);c[g>>2]=f+24;Qy(a,d);eO(d);l=h;return}}function Tv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;g=l;l=l+16|0;f=g;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[f+(e<<2)>>2]=0;e=e+1|0}ay(f,1,d>>>16&255)|0;ay(f,1,d>>>8&255)|0;ay(f,1,d&255)|0;cC(b,(a[f+11>>0]|0)<0?c[f>>2]|0:f)|0;e=a[b+8+3>>0]|0;if(e<<24>>24<0)e=c[b+4>>2]|0;else e=e&255;if(!e)GX(b,42164)|0;a1(f);l=g;return b|0}function Uv(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;do if((b|0)<=6?(h=c[c[a+4>>2]>>2]|0,!((f|0)>8?1:(((c[h+(b*12|0)+4>>2]|0)-(c[h+(b*12|0)>>2]|0)|0)/40|0)>>>0<=d>>>0)):0){h=Sx(vn(b)|0,e,g)|0;if((h|0)!=-1){a=Vj(a,b,d,h,f)|0;break}b=c[(c[c[a+8>>2]>>2]|0)+(b*12|0)>>2]|0;a=Sx(b+(d*56|0)|0,e,g)|0;if((a|0)!=-1)a=DN((c[b+(d*56|0)>>2]|0)+(a*40|0)|0,f)|0;else a=408444}else a=408444;while(0);return a|0}function Vv(b,d){b=b|0;d=d|0;var e=0,f=0;e=d&255;a:do if(!e)b=b+(FD(b)|0)|0;else{f=d&255;if(b&3)do{d=a[b>>0]|0;if(d<<24>>24==0?1:d<<24>>24==f<<24>>24)break a;b=b+1|0}while((b&3|0)!=0);e=O(e,16843009)|0;d=c[b>>2]|0;b:do if(!((d&-2139062144^-2139062144)&d+-16843009))do{d=d^e;if((d&-2139062144^-2139062144)&d+-16843009|0)break b;b=b+4|0;d=c[b>>2]|0}while(!((d&-2139062144^-2139062144)&d+-16843009|0));while(0);while(1){e=a[b>>0]|0;if(e<<24>>24==0?1:e<<24>>24==f<<24>>24)break;else b=b+1|0}}while(0);return b|0}function Wv(b){b=b|0;var d=0;Eg(b);c[b>>2]=38360;d=b+780|0;c[b+832>>2]=0;c[b+836>>2]=0;c[b+840>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;x1(b+844|0);c[b+856>>2]=0;c[b+860>>2]=0;c[b+864>>2]=0;c[b+908>>2]=0;c[b+912>>2]=0;c[b+916>>2]=0;a[b+733>>0]=1;d=b+632|0;c[d>>2]=65536;c[d+4>>2]=0;a[b+96>>0]=1;a[b+493>>0]=1;d=b+360|0;c[d>>2]=0;c[d+4>>2]=0;d=b+760|0;c[d>>2]=30;c[d+4>>2]=0;a[b+768>>0]=0;a[b+769>>0]=0;a[b+770>>0]=0;a[b+889>>0]=0;h[b+896>>3]=0.0;c[b+904>>2]=0;return}function Xv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;f=c[a>>2]|0;g=a+4|0;h=b+4|0;d=c[g>>2]|0;while(1){if((d|0)==(f|0))break;e=(c[h>>2]|0)+-12|0;d=d+-12|0;c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];e=0;while(1){if((e|0)==3)break;c[d+(e<<2)>>2]=0;e=e+1|0}c[h>>2]=(c[h>>2]|0)+-12}f=c[a>>2]|0;c[a>>2]=c[h>>2];c[h>>2]=f;f=b+8|0;e=c[g>>2]|0;c[g>>2]=c[f>>2];c[f>>2]=e;a=a+8|0;g=b+12|0;f=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=f;c[b>>2]=c[h>>2];return}function Yv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;g=b+8|0;j=g+3|0;f=a[j>>0]|0;i=f<<24>>24<0;k=b+4|0;if(i)h=c[k>>2]|0;else h=f&255;if(d|0){if(i)f=(c[g>>2]&2147483647)+-1|0;else f=1;g=h+d|0;if((f-h|0)>>>0>=d>>>0){if(i)f=c[b>>2]|0;else f=b;if(h)W2(f+(d<<2)|0,f,h)}else{ax(b,f,g-f|0,h,0,d);f=c[b>>2]|0}$2(f,d,e);if((a[j>>0]|0)<0)c[k>>2]=g;else a[j>>0]=g;y7(f+(g<<2)|0,0)}return b|0}function Zv(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=a+4|0;f=c[e>>2]|0;do if(f){e=e8(a)|0;while(1){a=c[f+16>>2]|0;if(a>>>0>d>>>0){a=c[f>>2]|0;if(!a){a=6;break}else{e=f;f=a}}else{if(a>>>0>=d>>>0){a=10;break}e=f+4|0;a=c[e>>2]|0;if(!a){a=9;break}else f=a}}if((a|0)==6){c[b>>2]=f;e=f;break}else if((a|0)==9){c[b>>2]=f;break}else if((a|0)==10){c[b>>2]=f;break}}else c[b>>2]=e;while(0);return e|0}function _v(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;Bx(a);f=a+648|0;A6(c[f>>2]|0);A6(c[f>>2]|0);A6(c[f>>2]|0);A6(c[f>>2]|0);d4(c[f>>2]|0,3);A6(c[f>>2]|0);wK(a);f=a+528|0;e=a+536|0;d=c[e>>2]|0;e=c[e+4>>2]|0;b=f;a=c[b+4>>2]|0;b=c[b>>2]|0;while(1){if(!(a>>>0<e>>>0|(a|0)==(e|0)&b>>>0<d>>>0))break;g=z0(b|0,a|0,1,0)|0;h=z;i=f;c[i>>2]=g;c[i+4>>2]=h;a=h;b=g}return}function $v(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=l;l=l+16|0;e=d+4|0;f=d;nL(e,a,b);b=c[e>>2]|0;e=ls(a,f,b+16|0)|0;HH(a,c[f>>2]|0,e,b);l=d;return}function aw(b){b=b|0;var d=0,e=0,f=0,h=0.0,i=0;do if(!(a[b+492>>0]|0)){i=c[b+24>>2]|0;f=b+552|0;e=c[f>>2]|0;f=c[f+4>>2]|0;h=+(e>>>0)+4294967296.0*+(f>>>0);if(+g[i+136>>2]>=1.0){f=b+40|0;CS(i,h/(+((c[f>>2]|0)>>>0)+4294967296.0*+((c[f+4>>2]|0)>>>0)));break}d=b+776|0;b=b+784|0;b=z0(c[b>>2]|0,c[b+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;d=z;if(f>>>0>d>>>0|(f|0)==(d|0)&e>>>0>b>>>0){CS(i,.9900000095367432);break}else{CS(i,h/(+(b>>>0)+4294967296.0*+(d>>>0)));break}}while(0);return}function bw(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0;n=l;l=l+16|0;j=n;k=g+4|0;m=g+11|0;if(h){TX(j);m=a[m>>0]|0;h=m<<24>>24<0;zb(b,d,e,f,b3(j,h?c[g>>2]|0:g,h?c[k>>2]|0:m&255)|0,i);z5(j)}else{TX(j);m=a[m>>0]|0;h=m<<24>>24<0;zb(b,d,e,f,M2(j,h?c[g>>2]|0:g,h?c[k>>2]|0:m&255)|0,i);z5(j)}l=n;return}function cw(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0;i=l;l=l+416|0;d=i+8|0;e=i;c[e>>2]=d+400;Zz(a+8|0,d,e,f,g,h);h=c[e>>2]|0;g=d;d=c[b>>2]|0;while(1){if((g|0)==(h|0))break;e=c[g>>2]|0;if(!d)d=0;else{a=d+24|0;f=c[a>>2]|0;if((f|0)==(c[d+28>>2]|0)){b=c[(c[d>>2]|0)+52>>2]|0;e=raa(e)|0;e=tb[b&31](d,e)|0}else{c[a>>2]=f+4;c[f>>2]=e;e=raa(e)|0}b=d8(e,-1)|0;d=b?0:d}g=g+4|0}l=i;return d|0}function dw(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;a:do if(!((d|0)==0|e>>>0<2)){f=d+2|0;g=e+-2|0;h=d+1|0;switch(a[d>>0]|0){case -1:{if((a[h>>0]|0)==-2){IK(b,f,g)|0;break a}break}case -2:{if((a[h>>0]|0)==-1){jH(b,f,g)|0;break a}break}case 0:{if(!(a[h>>0]|0)){d=b+8+3|0;if((a[d>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0;break a}else{y7(b,0);a[d>>0]=0;break a}}break}default:{}}IK(b,d,e)|0}while(0);return}function ew(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;f=b+44|0;e=c[f>>2]|0;g=c[b+24>>2]|0;if(e>>>0<g>>>0){c[f>>2]=g;e=g}h=b+12|0;f=c[h>>2]|0;do if((c[b+8>>2]|0)>>>0<f>>>0){i=b+16|0;if(d8(d,-1)|0){c[h>>2]=f+-1;c[i>>2]=e;d=e3(d)|0;break}if(!(c[b+48>>2]&16)){g=e9(d)|0;f=f+-1|0;if(!(C6(g,a[f>>0]|0)|0)){d=-1;break}}else{g=e9(d)|0;f=f+-1|0}c[h>>2]=f;c[i>>2]=e;a[f>>0]=g}else d=-1;while(0);return d|0}function fw(a){a=a|0;var c=0;RB(a,0,0,64,380977,-1,1,0);RB(a,1,0,18,380977,-1,1,0);RB(a,1,0,58,380977,-1,1,0);c=a+770|0;kL(a,1,0,130,b[61562+((d[c>>0]|0)<<1)>>1]|0,10,0);kL(a,1,0,138,b[61578+((d[c>>0]|0)<<1)>>1]|0,10,0);RB(a,1,0,191,384021,-1,1,0);RB(a,1,0,190,384035,-1,1,0);sM(a,1,0,195,8,0);Bt(a,1,0,150,+(d[a+771>>0]|0)/+(d[a+772>>0]|0),3,0);return}function gw(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+32|0;h=j;a:do if(!(_6(d)|0)){i=(d|0)==0;f=0;g=0;do{e=(1<<g&a|0)!=0;if(i|e)e=gi(g,e?b:8800948)|0;else e=c[d+(g<<2)>>2]|0;f=((e|0)!=0&1)+f|0;c[h+(g<<2)>>2]=e;g=g+1|0}while((g|0)!=6);switch(f|0){case 0:{d=409040;break a}case 1:{if((c[h>>2]|0)==50672){d=50720;break a}break}default:{}}}else{e=0;do{if(1<<e&a|0)c[d+(e<<2)>>2]=gi(e,b)|0;e=e+1|0}while((e|0)!=6)}while(0);l=j;return d|0}function hw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;f=a[b+8+3>>0]|0;e=f<<24>>24<0;g=e?c[b>>2]|0:b;f=e?c[b+4>>2]|0:f&255;e=407704;b=d;a:while(1){while(1){if(!b)break a;d=b+16|0;h=a[b+24+3>>0]|0;i=h<<24>>24<0;h=i?c[b+20>>2]|0:h&255;d=L$(i?c[d>>2]|0:d,g,f>>>0<h>>>0?f:h)|0;if((((d|0)==0?(h>>>0<f>>>0?-2147483648:0):d)|0)>=0)break;b=c[b+4>>2]|0}e=b;b=c[b>>2]|0}return e|0}function iw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=l;l=l+48|0;e=g+16|0;h=g+32|0;f=g;i=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(i,c[i+16>>2]&-3);RH(h,b);if(a[h>>0]|0?(i=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0,h=c[(c[i>>2]|0)+20>>2]|0,c[e>>2]=c[d>>2],c[e+4>>2]=c[d+4>>2],c[e+8>>2]=c[d+8>>2],c[e+12>>2]=c[d+12>>2],vb[h&15](f,i,e,8),i=f+8|0,(c[i>>2]|0)==-1?(c[i+4>>2]|0)==-1:0):0){i=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(i,c[i+16>>2]|4)}l=g;return b|0}function jw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=a+16|0;ro(a,a+8|0,d)|0;i=a+24|0;while(1){if((i|0)==(b|0))break;j=i;k=c[j>>2]|0;j=c[j+4>>2]|0;f=d;e=c[f>>2]|0;f=c[f+4>>2]|0;if(j>>>0<f>>>0|(j|0)==(f|0)&k>>>0<e>>>0){g=i;h=e;while(1){c[g>>2]=h;c[g+4>>2]=f;if((d|0)==(a|0)){d=a;break}e=d+-8|0;f=e;h=c[f>>2]|0;f=c[f+4>>2]|0;if(!(j>>>0<f>>>0|(j|0)==(f|0)&k>>>0<h>>>0))break;else{g=d;d=e}}h=d;c[h>>2]=k;c[h+4>>2]=j}d=i;i=i+8|0}return}function kw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;d=a+16|0;so(a,a+8|0,d)|0;i=a+24|0;while(1){if((i|0)==(b|0))break;j=i;k=c[j>>2]|0;j=c[j+4>>2]|0;f=d;e=c[f>>2]|0;f=c[f+4>>2]|0;if((j|0)<(f|0)|(j|0)==(f|0)&k>>>0<e>>>0){g=i;h=e;while(1){c[g>>2]=h;c[g+4>>2]=f;if((d|0)==(a|0)){d=a;break}e=d+-8|0;f=e;h=c[f>>2]|0;f=c[f+4>>2]|0;if(!((j|0)<(f|0)|(j|0)==(f|0)&k>>>0<h>>>0))break;else{g=d;d=e}}h=d;c[h>>2]=k;c[h+4>>2]=j}d=i;i=i+8|0}return}function lw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;h=a[d+8+3>>0]|0;g=h<<24>>24<0;h=g?c[d+4>>2]|0:h&255;if(h>>>0<e>>>0)uaa();i=(g?c[d>>2]|0:d)+(e<<2)|0;d=h-e|0;d=d>>>0<f>>>0?d:f;if(d>>>0>1073741807)uaa();g=b+8|0;do if(d>>>0>=2){h=d+4&-4;if(h>>>0>1073741823)ra();else{j=ZW(h<<2)|0;c[b>>2]=j;c[g>>2]=h|-2147483648;c[b+4>>2]=d;break}}else{a[g+3>>0]=d;j=b}while(0);a3(j,i,d);y7(j+(d<<2)|0,0);return}function mw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,i=0;i=l;l=l+16|0;b=i+4|0;bD(a,b);g=a+528|0;e=g;e=z0(c[e>>2]|0,c[e+4>>2]|0,8,0)|0;d=g;c[d>>2]=e;c[d+4>>2]=z;bD(a,i);bD(a,a+992|0);d=g;d=z0(c[d>>2]|0,c[d+4>>2]|0,36,0)|0;e=z;c[g>>2]=d;c[g+4>>2]=e;g=a+536|0;f=c[g>>2]|0;g=c[g+4>>2]|0;if(g>>>0>e>>>0|(g|0)==(e|0)&f>>>0>d>>>0){g=D_(f|0,g|0,d|0,e|0)|0;e1(a,g,z)}b=c[b>>2]|0;if(b|0)h[a+984>>3]=1.0e6/+(b>>>0);l=i;return}function nw(d){d=d|0;var e=0,f=0;c[d+772>>2]=0;c[d+776>>2]=0;MI(d+780|0,4);e=d+360|0;f=e;if((c[f>>2]|0)==-1?(c[f+4>>2]|0)==-1:0){f=e;c[f>>2]=0;c[f+4>>2]=0}f=d+804|0;c[f>>2]=0;c[f+4>>2]=0;a[d+812>>0]=-1;a[d+813>>0]=-1;a[d+814>>0]=1;f=d+815|0;a[f>>0]=0;a[f+1>>0]=0;a[f+2>>0]=0;a[f+3>>0]=0;a[d+819>>0]=7;f=d+820|0;b[d+868>>1]=0;c[f>>2]=0;c[f+4>>2]=0;b[f+8>>1]=0;if(!(a[d+492>>0]|0)){f=d+144|0;c[f>>2]=0;c[f+4>>2]=0}f=d+832|0;_F(f);a[(c[f>>2]|0)+45>>0]=1;return}function ow(b){b=b|0;var d=0,e=0,f=0,g=0;g=b+288|0;d=c[g>>2]|0;g=c[g+4>>2]|0;do if(!((d|0)==-1&(g|0)==-1)){if((a[b+492>>0]|0)==0?(f=b+48|0,f=z0(c[b+612>>2]|0,0,c[f>>2]|0,c[f+4>>2]|0)|0,e=b+536|0,e=z0(f|0,z|0,c[e>>2]|0,c[e+4>>2]|0)|0,f=b+40|0,!((e|0)==(c[f>>2]|0)?(z|0)==(c[f+4>>2]|0):0)):0)break;f=b+280|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(g>>>0>f>>>0|(g|0)==(f|0)&d>>>0>e>>>0){g=D_(d|0,g|0,e|0,f|0)|0;g=cT((+(g>>>0)+4294967296.0*+(z>>>0))/1.0e6)|0;jL(b,1,0,76,g,z,0)}}while(0);return}function pw(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;g=a[b+11>>0]|0;h=g<<24>>24<0;f=h?c[b>>2]|0:b;b=h?c[b+4>>2]|0:g&255;a:while(1){while(1){if(!d)break a;h=d+16|0;g=a[h+11>>0]|0;i=g<<24>>24<0;g=i?c[d+20>>2]|0:g&255;h=R$(i?c[h>>2]|0:h,f,b>>>0<g>>>0?b:g)|0;if((((h|0)==0?(g>>>0<b>>>0?-2147483648:0):h)|0)>=0)break;d=c[d+4>>2]|0}e=d;d=c[d>>2]|0}return e|0}function qw(b,d){b=b|0;d=d|0;do if(b){if(d>>>0<128){a[b>>0]=d;b=1;break}if(!(c[c[12815]>>2]|0))if((d&-128|0)==57216){a[b>>0]=d;b=1;break}else{c[12784]=84;b=-1;break}if(d>>>0<2048){a[b>>0]=d>>>6|192;a[b+1>>0]=d&63|128;b=2;break}if(d>>>0<55296|(d&-8192|0)==57344){a[b>>0]=d>>>12|224;a[b+1>>0]=d>>>6&63|128;a[b+2>>0]=d&63|128;b=3;break}if((d+-65536|0)>>>0<1048576){a[b>>0]=d>>>18|240;a[b+1>>0]=d>>>12&63|128;a[b+2>>0]=d>>>6&63|128;a[b+3>>0]=d&63|128;b=4;break}else{c[12784]=84;b=-1;break}}else b=1;while(0);return b|0}function rw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=l;l=l+16|0;f=b+4|0;d=b;bD(a,f);bD(a,d);e=a+528|0;g=e;g=z0(c[g>>2]|0,c[g+4>>2]|0,4,0)|0;c[e>>2]=g;c[e+4>>2]=z;Kc(a,5,-1)|0;e=a+20|0;RB(a,1,c[e>>2]|0,18,380258,-1,1,0);RB(a,1,c[e>>2]|0,58,380258,-1,1,0);lL(a,1,c[e>>2]|0,130,c[f>>2]|0,10,0);lL(a,1,c[e>>2]|0,138,c[d>>2]|0,10,0);l=b;return}function sw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;f=j;TX(f);d=b+536|0;jZ(b,c[d>>2]|0,c[d+4>>2]|0,f);d=a[f+8+3>>0]|0;h=d<<24>>24<0;g=h?c[f>>2]|0:f;d=h?c[f+4>>2]|0:d&255;h=i9(29304)|0;a:do if(d){e=g+(d<<2)|0;d=g;while(1){if((d|0)==(e|0)){i=7;break a}if(!(U_(29304,h,d)|0))break;d=d+4|0}if((d-g|0)==-4)i=7}else i=7;while(0);if((i|0)==7)k1(b+864|0,f)|0;z5(f);l=j;return}function tw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;f=j;TX(f);d=b+536|0;jZ(b,c[d>>2]|0,c[d+4>>2]|0,f);d=a[f+8+3>>0]|0;h=d<<24>>24<0;g=h?c[f>>2]|0:f;d=h?c[f+4>>2]|0:d&255;h=i9(29304)|0;a:do if(d){e=g+(d<<2)|0;d=g;while(1){if((d|0)==(e|0)){i=7;break a}if(!(U_(29304,h,d)|0))break;d=d+4|0}if((d-g|0)==-4)i=7}else i=7;while(0);if((i|0)==7)k1(b+852|0,f)|0;z5(f);l=j;return}function uw(d){d=d|0;var e=0;Eg(d);c[d>>2]=13640;c[d+780>>2]=0;c[d+784>>2]=0;c[d+788>>2]=0;TX(d+792|0);c[d+836>>2]=0;e=0;do{mI(d+840+(e*40|0)|0);e=e+1|0}while((e|0)!=10);IX(d+72|0,372531)|0;a[d+733>>0]=1;e=d+632|0;c[e>>2]=32768;c[e+4>>2]=0;a[d+96>>0]=1;a[d+493>>0]=1;e=d+760|0;c[e>>2]=0;c[e+4>>2]=0;c[d+768>>2]=0;c[d+808>>2]=0;b[d+812>>1]=0;e=d+816|0;c[e>>2]=-1;c[e+4>>2]=-1;c[e+8>>2]=-1;b[e+12>>1]=65535;a[d+830>>0]=0;a[d+833>>0]=0;a[d+834>>0]=0;return}function vw(a,b){a=a|0;b=b|0;var d=0.0,e=0,f=0,g=0,h=0;h=a+648|0;f=c[h>>2]|0;e=c[f+4>>2]|0;do if(raa(e)|0){g=0;while(1){if(!e)break;if(NF(f)|0)break;f=c[h>>2]|0;g=g+1<<24>>24;e=c[f+4>>2]|0}if((g&255)>=33){vt(a);break}d=+gaa(g&255)+-1.0;d=d+ +((tn(c[h>>2]|0,g)|0)>>>0);if(d<4294967295.0){c[b>>2]=~~(+D(-1.0,+(d+1.0))*+(~~+N(+(d*.5))>>>0>>>0));break}else{vt(a);break}}else{vt(a);c[b>>2]=0}while(0);return}function ww(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,h=0,i=0,j=0;i=l;l=l+16|0;h=i;$x(h,b,3,d,102,1);j=a[h+8+3>>0]|0;j=((j<<24>>24<0?c[h+4>>2]|0:j&255)|0)==0;z5(h);if(j?($x(h,b,3,d,114,1),e=rm(h)|0,f=z,z5(h),$x(h,b,3,d,42,1),g=+Eq(h)/1.0e3,z5(h),((e|0)!=0|(f|0)!=0)&g!=0.0):0)KW(b,3,d,102,(+(e>>>0)+4294967296.0*+(f>>>0))/g,3,0);l=i;return}function xw(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;f=a[b+8+3>>0]|0;e=f<<24>>24<0;g=e?c[b>>2]|0:b;f=e?c[b+4>>2]|0:f&255;e=406808;b=d;a:while(1){while(1){if(!b)break a;d=b+16|0;h=a[b+24+3>>0]|0;i=h<<24>>24<0;h=i?c[b+20>>2]|0:h&255;d=L$(i?c[d>>2]|0:d,g,f>>>0<h>>>0?f:h)|0;if((((d|0)==0?(h>>>0<f>>>0?-2147483648:0):d)|0)>=0)break;b=c[b+4>>2]|0}e=b;b=c[b>>2]|0}return e|0}function yw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;c[a>>2]=0;h=a+4|0;c[h>>2]=0;c[a+8>>2]=0;g=a+12|0;TX(g);i=a+24|0;TX(i);k1(g,b+12|0)|0;k1(i,b+24|0)|0;i=b+4|0;ZE(a,((c[i>>2]|0)-(c[b>>2]|0)|0)/12|0);g=a+8|0;f=0;while(1){d=c[b>>2]|0;if(f>>>0>=(((c[i>>2]|0)-d|0)/12|0)>>>0)break;d=d+(f*12|0)|0;e=c[h>>2]|0;if((e|0)==(c[g>>2]|0))Ax(a,d);else{p2(e,d);c[h>>2]=(c[h>>2]|0)+12}f=f+1|0}return}function zw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+128|0;g=n+124|0;m=n;h=m;i=51444;j=h+124|0;do{c[h>>2]=c[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(j|0));if((d+-1|0)>>>0>2147483646)if(!d){b=g;d=1;k=4}else{c[12784]=75;d=-1}else k=4;if((k|0)==4){k=-2-b|0;k=d>>>0>k>>>0?k:d;c[m+48>>2]=k;g=m+20|0;c[g>>2]=b;c[m+44>>2]=b;d=b+k|0;b=m+16|0;c[b>>2]=d;c[m+28>>2]=d;d=Xq(m,e,f)|0;if(k){m=c[g>>2]|0;a[m+(((m|0)==(c[b>>2]|0))<<31>>31)>>0]=0}}l=n;return d|0}function Aw(a){a=a|0;do switch(a|0){case 0:{a=402219;break}case 1:{a=377075;break}case 2:{a=402006;break}case 3:{a=377071;break}case 4:{a=377068;break}case 5:{a=377065;break}case 6:{a=384483;break}case 7:{a=384483;break}case 8:{a=377062;break}case 9:{a=377058;break}case 10:{a=377054;break}case 11:{a=384483;break}case 12:{a=384483;break}case 13:{a=384483;break}case 14:{a=384483;break}case 15:{a=384483;break}case 16:{a=384483;break}case 17:{a=384483;break}default:a=384483}while(0);return a|0}function Bw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+16|0;g=i;bB(b,g);e=b+924|0;f=b+536|0;g=a[g>>0]|0;d=0;while(1){h=(c[e>>2]|0)!=0;if((d&255)>>>0>=(h?3:1)>>>0)break;switch(g<<24>>24){case 0:{e1(b,16,0);break}case 1:{e1(b,2,0);break}case 2:{e1(b,4,0);break}default:{j=f;e1(b,g5(z0(c[j>>2]|0,c[j+4>>2]|0,-1,-1)|0,z|0,(h?1:3)|0,(h?0:0)|0)|0,z)}}d=d+1<<24>>24}l=i;return}function Cw(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+32|0;f=k;i=k+16|0;c[i>>2]=d;g=i+4|0;j=b+48|0;m=c[j>>2]|0;c[g>>2]=e-((m|0)!=0&1);h=b+44|0;c[i+8>>2]=c[h>>2];c[i+12>>2]=m;c[f>>2]=c[b+60>>2];c[f+4>>2]=i;c[f+8>>2]=2;f=b6(cb(145,f|0)|0)|0;if((f|0)>=1){i=c[g>>2]|0;if(f>>>0>i>>>0){g=c[h>>2]|0;h=b+4|0;c[h>>2]=g;c[b+8>>2]=g+(f-i);if(!(c[j>>2]|0))f=e;else{c[h>>2]=g+1;a[d+(e+-1)>>0]=a[g>>0]|0;f=e}}}else c[b>>2]=c[b>>2]|f&48^16;l=k;return f|0}function Dw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(h-d>>2>>>0<b>>>0){f=c[a>>2]|0;d=d-f>>2;e=d+b|0;if(e>>>0>1073741823)uaa();else{f=h-f|0;h=f>>1;BF(g,f>>2>>>0<536870911?(h>>>0<e>>>0?e:h):1073741823,d,a+8|0);jY(g,b);aB(a,g);zS(g);break}}else IY(a,b);while(0);l=i;return}function Ew(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=b+4|0;j=c[i>>2]|0;f=c[a>>2]|0;h=d;g=h-f|0;e=j+(0-(g>>2)<<2)|0;c[i>>2]=e;if((g|0)>0)no(e|0,f|0,g|0)|0;f=a+4|0;g=b+8|0;e=(c[f>>2]|0)-h|0;if((e|0)>0){no(c[g>>2]|0,d|0,e|0)|0;c[g>>2]=(c[g>>2]|0)+(e>>>2<<2)}h=c[a>>2]|0;c[a>>2]=c[i>>2];c[i>>2]=h;h=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=h;h=a+8|0;d=b+12|0;a=c[h>>2]|0;c[h>>2]=c[d>>2];c[d>>2]=a;c[b>>2]=c[i>>2];return j|0}function Fw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;h=b+528|0;g=c[h>>2]|0;h=z0(g|0,c[h+4>>2]|0,d|0,e|0)|0;j=z;e=b+536|0;i=c[e+4>>2]|0;do if(j>>>0>i>>>0|((j|0)==(i|0)?h>>>0>(c[e>>2]|0)>>>0:0)){vt(b);b=f+11|0;if((a[b>>0]|0)<0){J7(c[f>>2]|0,0);c[f+4>>2]=0;break}else{J7(f,0);a[b>>0]=0;break}}else Qx(f,(c[b+544>>2]|0)+(c[b+612>>2]|0)+g|0,d)|0;while(0);return}function Gw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(h-d>>3>>>0<b>>>0){f=c[a>>2]|0;d=d-f>>3;e=d+b|0;if(e>>>0>536870911)uaa();else{f=h-f|0;h=f>>2;EF(g,f>>3>>>0<268435455?(h>>>0<e>>>0?e:h):536870911,d,a+8|0);iY(g,b);_A(a,g);xS(g);break}}else HY(a,b);while(0);l=i;return}function Hw(a){a=a|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;j=l;l=l+16|0;i=j+14|0;f=j;g=j+12|0;NB(a,i);h=a+528|0;i=b[i>>1]|0;d=0;while(1){if((d&65535)>(i&65535))break;TX(f);GC(a);m=h;m=z0(c[m>>2]|0,c[m+4>>2]|0,8,0)|0;k=h;c[k>>2]=m;c[k+4>>2]=z;NB(a,g);jZ(a,e[g>>1]|0,0,f);J3(a);zb(a,0,0,320,f,0);z5(f);d=d+1<<16>>16}l=j;return}function Iw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;d=0;do{TX(a+12+(d*12|0)|0);d=d+1|0}while((d|0)!=2);e=a+36|0;TX(e);k1(a+12|0,b+12|0)|0;k1(a+24|0,b+24|0)|0;k1(e,b+36|0)|0;c[a+48>>2]=c[b+48>>2];c[a+52>>2]=c[b+52>>2];e=b+4|0;hE(a,((c[e>>2]|0)-(c[b>>2]|0)|0)/40|0);d=0;while(1){f=c[b>>2]|0;if(d>>>0>=(((c[e>>2]|0)-f|0)/40|0)>>>0)break;Mx(a,f+(d*40|0)|0);d=d+1|0}return}function Jw(a){a=a|0;var b=0,d=0,f=0,g=0;f=a+840|0;g=a+844|0;b=c[f>>2]|0;while(1){if((b|0)==(c[g>>2]|0))break;if(c[b>>2]|0)gc(a,b);b=b+4|0}d=a+856|0;b=c[a+852>>2]|0;while(1){if((b|0)==(c[d>>2]|0))break;if(c[b>>2]|0){if((c[f>>2]|0)==(c[g>>2]|0))gc(a,b);else Mn(a,b);sM(a,1,0,29,(e[(c[b>>2]|0)+36>>1]|0)+1|0,0)}b=b+4|0}return}function Kw(d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;c[d>>2]=e;c[d+4>>2]=f;c[d+8>>2]=g;c[d+12>>2]=h;c[d+16>>2]=i;b[d+20>>1]=j;b[d+22>>1]=k;a[d+24>>0]=l;a[d+25>>0]=m;a[d+26>>0]=n;a[d+27>>0]=o;a[d+28>>0]=p;a[d+29>>0]=q;a[d+30>>0]=r&1;a[d+31>>0]=s&1;a[d+32>>0]=t&1;a[d+33>>0]=u&1;a[d+34>>0]=v&1;return}function Lw(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;g=a[b+8+3>>0]|0;h=g<<24>>24<0;f=h?c[b>>2]|0:b;b=h?c[b+4>>2]|0:g&255;a:while(1){while(1){if(!d)break a;h=d+16|0;g=a[d+24+3>>0]|0;i=g<<24>>24<0;g=i?c[d+20>>2]|0:g&255;h=L$(i?c[h>>2]|0:h,f,b>>>0<g>>>0?b:g)|0;if((((h|0)==0?(g>>>0<b>>>0?-2147483648:0):h)|0)>=0)break;d=c[d+4>>2]|0}e=d;d=c[d>>2]|0}return e|0}function Mw(b){b=b|0;var c=0,d=0;c=l;l=l+16|0;d=c;GC(b);Bx(b);xR(b,4,d);RS(b);RS(b);RS(b);KS(b);wK(b);J3(b);GC(b);switch(a[d>>0]|0){case 0:{e1(b,260,0);break}case 8:{qB(b);break}default:e1(b,260,0)}J3(b);l=c;return}function Nw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;e=l;l=l+16|0;d=e;f=a+528|0;g=f;g=z0(c[g>>2]|0,c[g+4>>2]|0,10,0)|0;b=f;c[b>>2]=g;c[b+4>>2]=z;Uy(a,d);b=f;b=z0(c[b>>2]|0,c[b+4>>2]|0,24,0)|0;c[f>>2]=b;c[f+4>>2]=z;a=(sF(a+760|0,a+772|0)|0)+80|0;f=a;b=c[d>>2]|0;d=c[d+4>>2]|0;if(((c[f>>2]|0)==-1?(c[f+4>>2]|0)==-1:0)&((b|0)!=-1|(d|0)!=-1)){f=g5(b|0,d|0,1e4,0)|0;g=a;c[g>>2]=f;c[g+4>>2]=z}l=e;return}function Ow(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=b+e|0;d=d&255;if((e|0)>=67){while(b&3){a[b>>0]=d;b=b+1|0}f=h&-4|0;g=f-64|0;i=d|d<<8|d<<16|d<<24;while((b|0)<=(g|0)){c[b>>2]=i;c[b+4>>2]=i;c[b+8>>2]=i;c[b+12>>2]=i;c[b+16>>2]=i;c[b+20>>2]=i;c[b+24>>2]=i;c[b+28>>2]=i;c[b+32>>2]=i;c[b+36>>2]=i;c[b+40>>2]=i;c[b+44>>2]=i;c[b+48>>2]=i;c[b+52>>2]=i;c[b+56>>2]=i;c[b+60>>2]=i;b=b+64|0}while((b|0)<(f|0)){c[b>>2]=i;b=b+4|0}}while((b|0)<(h|0)){a[b>>0]=d;b=b+1|0}return h-e|0}function Pw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Kv(d,h,e)|0;e=c[g>>2]|0;if(!e){ER(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function Qw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Zv(d,h,e)|0;e=c[g>>2]|0;if(!e){OR(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function Rw(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b+4>>2]|0;a:do if(!d){e=b;while(1){d=c[e+8>>2]|0;if((c[d>>2]|0)==(e|0))break a;e=d}}else while(1){e=c[d>>2]|0;if(!e)break;else d=e}while(0);if((c[a>>2]|0)==(b|0))c[a>>2]=d;e=a+8|0;c[e>>2]=(c[e>>2]|0)+-1;Dg(c[a+4>>2]|0,b);t_(b+16|0);laa(b);return}function Sw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=a+44|0;d=c[e>>2]|0;f=c[a+24>>2]|0;if(d>>>0<f>>>0){c[e>>2]=f;d=f}g=a+12|0;e=c[g>>2]|0;do if((c[a+8>>2]|0)>>>0<e>>>0){h=a+16|0;if(d8(b,-1)|0){c[g>>2]=e+-4;c[h>>2]=d;b=e3(b)|0;break}if(!(c[a+48>>2]&16)){f=raa(b)|0;e=e+-4|0;if(!(d8(f,c[e>>2]|0)|0)){b=-1;break}}else{f=raa(b)|0;e=e+-4|0}c[g>>2]=e;c[h>>2]=d;c[e>>2]=f}else b=-1;while(0);return b|0}function Tw(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b+4>>2]|0;a:do if(!d){e=b;while(1){d=c[e+8>>2]|0;if((c[d>>2]|0)==(e|0))break a;e=d}}else while(1){e=c[d>>2]|0;if(!e)break;else d=e}while(0);if((c[a>>2]|0)==(b|0))c[a>>2]=d;e=a+8|0;c[e>>2]=(c[e>>2]|0)+-1;Dg(c[a+4>>2]|0,b);qZ(b+16|0);laa(b);return}function Uw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;f=b+1008|0;do if(!((c[f>>2]|0)==0&(c[f+4>>2]|0)==0)?(g=b+1047|0,(a[g>>0]|0)==0):0){d=b+776|0;e=b+788|0;f=(c[b+784>>2]|0)==0;if(a[b+1038>>0]|0){d=c[d>>2]|0;c[e>>2]=d;if(!f)h=7}else{if(f){d=0;break}d=c[d>>2]|0;c[e>>2]=d;h=7}if((h|0)==7){h=d+16|0;ty(b,c[h>>2]|0,c[h+4>>2]|0)}a[b+1040>>0]=0;a[g>>0]=1;KP(b+792|0);d=1}else d=0;while(0);return d|0}function Vw(b){b=b|0;var d=0,e=0,f=0;Eg(b);c[b>>2]=34784;c[b+776>>2]=0;c[b+780>>2]=0;c[b+784>>2]=0;d=b+840|0;e=b+796|0;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));TX(d);TX(b+852|0);TX(b+864|0);TX(b+876|0);TX(b+888|0);TX(b+900|0);TX(b+912|0);a[b+733>>0]=1;f=b+632|0;c[f>>2]=65536;c[f+4>>2]=0;a[b+96>>0]=1;a[b+493>>0]=1;f=b+360|0;c[f>>2]=0;c[f+4>>2]=0;f=b+760|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;a[f+12>>0]=0;a[b+832>>0]=-1;return}function Ww(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;if((a[d+8+3>>0]|0)<0){h=c[d>>2]|0;f=c[d+4>>2]|0;if(f>>>0>1073741807)uaa();d=b+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823)ra();else{g=ZW(e<<2)|0;c[b>>2]=g;c[d>>2]=e|-2147483648;c[b+4>>2]=f;break}}else{a[d+3>>0]=f;g=b}while(0);a3(g,h,f);y7(g+(f<<2)|0,0)}else{c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2]}return}function Xw(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;h=l;l=l+32|0;f=h+12|0;g=h;iX(f,b);Sn(g,f);d=b+940|0;e=d+11|0;if((a[e>>0]|0)<0){J7(c[d>>2]|0,0);c[b+944>>2]=0}else{J7(d,0);a[e>>0]=0}Fp(d,0);c[d>>2]=c[g>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];b=0;while(1){if((b|0)==3)break;c[g+(b<<2)>>2]=0;b=b+1|0}a1(g);z5(f);l=h;return}function Yw(a){a=a|0;var b=0,d=0,e=0,f=0;f=l;l=l+16|0;b=f;c[a>>2]=4836;Nr(a);d=a+360|0;W0(b,d);e=c[a+20>>2]|0;if(e|0)jb[c[(c[e>>2]|0)+4>>2]&511](e);s7(c[b>>2]|0);$3(d);jN(a+80|0);z5(a+64|0);a1(a+52|0);GM(a+40|0);aN(a+28|0);F5(a);l=f;return}function Zw(a){a=a|0;do switch(a<<24>>24){case 2:case 1:{a=380596;break}case 3:{a=380582;break}case 4:{a=380569;break}case 5:{a=380556;break}case 6:{a=380550;break}case 8:case 7:{a=380530;break}case 9:{a=380540;break}case 10:{a=380530;break}case 11:{a=380521;break}case 12:{a=380512;break}case 13:{a=380493;break}case 14:{a=380476;break}case 15:{a=380457;break}case 16:{a=380442;break}case 18:{a=380429;break}case 19:{a=380414;break}case 20:{a=380399;break}default:a=8800948}while(0);return a|0}function _w(d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;c[d>>2]=e;c[d+4>>2]=f;c[d+8>>2]=g;c[d+12>>2]=h;b[d+16>>1]=i;b[d+18>>1]=j;a[d+20>>0]=k;a[d+21>>0]=l;a[d+22>>0]=m;a[d+23>>0]=n;a[d+24>>0]=o;a[d+25>>0]=p;a[d+26>>0]=q&1;a[d+27>>0]=r&1;a[d+28>>0]=s&1;a[d+29>>0]=t&1;a[d+30>>0]=u&1;a[d+31>>0]=v&1;return}function $w(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;h=l;l=l+32|0;f=h+12|0;g=h;iX(f,b);Sn(g,f);d=b+928|0;e=d+11|0;if((a[e>>0]|0)<0){J7(c[d>>2]|0,0);c[b+932>>2]=0}else{J7(d,0);a[e>>0]=0}Fp(d,0);c[d>>2]=c[g>>2];c[d+4>>2]=c[g+4>>2];c[d+8>>2]=c[g+8>>2];b=0;while(1){if((b|0)==3)break;c[g+(b<<2)>>2]=0;b=b+1|0}a1(g);z5(f);l=h;return}function ax(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;if((1073741807-d|0)>>>0<e>>>0)uaa();l=b+8|0;if((a[l+3>>0]|0)<0)k=c[b>>2]|0;else k=b;if(d>>>0<536870887){e=e+d|0;i=d<<1;e=e>>>0<i>>>0?i:e;e=e>>>0<2?2:e+4&-4;if(e>>>0>1073741823)ra();else j=e}else j=1073741807;i=ZW(j<<2)|0;if(g|0)a3(i,k,g);e=f-g|0;if(e|0)a3(i+(g<<2)+(h<<2)|0,k+(g<<2)|0,e);if((d|0)!=1)laa(k);c[b>>2]=i;c[l>>2]=j|-2147483648;return}function bx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+32|0;d=h;e=c[a>>2]|0;f=((c[a+4>>2]|0)-e|0)/40|0;g=f+1|0;if(g>>>0>107374182)uaa();else{i=((c[a+8>>2]|0)-e|0)/40|0;e=i<<1;lE(d,i>>>0<53687091?(e>>>0<g>>>0?g:e):107374182,f,a+8|0);g=d+8|0;f=c[g>>2]|0;yw(f,b);c[g>>2]=f+40;Bz(a,d);VP(d);l=h;return}}function cx(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;g=i;h=HN(b,0)|0;e1(b,h,z);h=b+888|0;if(((c[h>>2]|0)==-1?(c[h+4>>2]|0)==-1:0)?(a[b+884>>0]|0)==0:0){h=c[b+928>>2]|0;d=b+48|0;b=z0(c[b+612>>2]|0,0,c[d>>2]|0,c[d+4>>2]|0)|0;d=z;e=g;c[e>>2]=b;c[e+4>>2]=d;e=h+104|0;f=c[e>>2]|0;if(f>>>0<(c[h+108>>2]|0)>>>0){h=f;c[h>>2]=b;c[h+4>>2]=d;c[e>>2]=f+8}else Px(h+100|0,g)}l=i;return}function dx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=l;l=l+16|0;e=g;f=b+8+3|0;if((a[f>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0}else{y7(b,0);a[f>>0]=0}TX(e);Ek(e,d,16)|0;f=e+8+3|0;h=a[f>>0]|0;d=e+4|0;FB(b,4-(h<<24>>24<0?c[d>>2]|0:h&255)|0,48);f=a[f>>0]|0;h=f<<24>>24<0;Ex(b,h?c[e>>2]|0:e,h?c[d>>2]|0:f&255)|0;tP(b)|0;z5(e);l=g;return b|0}function ex(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=l;l=l+16|0;e=g;f=b+8+3|0;if((a[f>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0}else{y7(b,0);a[f>>0]=0}TX(e);Ck(e,d,16)|0;f=e+8+3|0;h=a[f>>0]|0;d=e+4|0;FB(b,2-(h<<24>>24<0?c[d>>2]|0:h&255)|0,48);f=a[f>>0]|0;h=f<<24>>24<0;Ex(b,h?c[e>>2]|0:e,h?c[d>>2]|0:f&255)|0;tP(b)|0;z5(e);l=g;return b|0}function fx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=a+760|0;f=a+764|0;g=a+24|0;h=a+4|0;i=a+8|0;j=a+28|0;b=a+40|0;a=0;while(1){d=c[e>>2]|0;if(a>>>0>=(c[f>>2]|0)-d>>2>>>0)break;mx(c[d+(a<<2)>>2]|0,c[g>>2]|0,c[h>>2]|0,c[i>>2]|0);k1((c[(c[e>>2]|0)+(a<<2)>>2]|0)+28|0,j)|0;d=b;Mp(c[(c[e>>2]|0)+(a<<2)>>2]|0,c[d>>2]|0,c[d+4>>2]|0);a=a+1|0}return}function gx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;a[b+53>>0]=1;do if((c[b+4>>2]|0)==(e|0)){a[b+52>>0]=1;h=b+16|0;g=c[h>>2]|0;j=b+54|0;k=b+48|0;i=b+24|0;e=b+36|0;if(!g){c[h>>2]=d;c[i>>2]=f;c[e>>2]=1;if(!((f|0)==1&(c[k>>2]|0)==1))break;a[j>>0]=1;break}if((g|0)!=(d|0)){c[e>>2]=(c[e>>2]|0)+1;a[j>>0]=1;break}e=c[i>>2]|0;if((e|0)==2){c[i>>2]=f;e=f}if((e|0)==1&(c[k>>2]|0)==1)a[j>>0]=1}while(0);return}function hx(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0;h=l;l=l+16|0;g=h;Bx(b);i=b+648|0;d4(c[i>>2]|0,6);d4(c[i>>2]|0,1);d4(c[i>>2]|0,5);xR(b,2,g);d4(c[i>>2]|0,2);wK(b);f=z0(e|0,f|0,-2,-1)|0;e1(b,f,z);if(qO(b)|0){i=(d[g>>0]|0)+1&255;a[b+819>>0]=i;a[b+1243>>0]=i;PU(b+836|0,1)|0}l=h;return}function ix(a){a=a|0;c[a>>2]=33640;AK(a);Lq(a);a1(a+1020|0);z5(a+1008|0);z5(a+996|0);z5(a+984|0);z5(a+972|0);z5(a+960|0);z5(a+948|0);z5(a+936|0);dU(a+904|0);cU(a+864|0);cU(a+852|0);cU(a+840|0);cU(a+784|0);bU(a+772|0);bt(a);return}function jx(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);d=a+528|0;e=d;e=z0(c[e>>2]|0,c[e+4>>2]|0,8,0)|0;c[d>>2]=e;c[d+4>>2]=z;if(qO(a)|0?(c[a+16>>2]|0)!=1:0){Kc(a,1,-1)|0;d=a+916|0;e=a+788|0;c[(bF(d,e)|0)+44>>2]=1;a=c[a+20>>2]|0;c[(bF(d,e)|0)+48>>2]=a}l=b;return}function kx(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;j=l;l=l+32|0;f=j;g=c[b>>2]|0;k=(c[b+4>>2]|0)-g|0;h=k>>1;i=h+1|0;if((k|0)<-2)uaa();else{k=(c[b+8>>2]|0)-g|0;TF(f,k>>1>>>0<1073741823?(k>>>0<i>>>0?i:k):2147483647,h,b+8|0);k=f+8|0;i=c[k>>2]|0;h=d[e>>0]|d[e+1>>0]<<8;a[i>>0]=h;a[i+1>>0]=h>>8;c[k>>2]=i+2;$A(b,f);yS(f);l=j;return}}function lx(b){b=b|0;var d=0,e=0,f=0;d=b+760|0;e=d;if((c[e>>2]|0)==0&(c[e+4>>2]|0)==0){f=+g[(c[b+24>>2]|0)+136>>2]>=.3;e=d;c[e>>2]=f?32:2;c[e+4>>2]=f?0:0}f=b+288|0;c[f>>2]=0;c[f+4>>2]=0;if(!(a[b+492>>0]|0)){d=b+136|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;d=0;e=0}else{e=b+144|0;d=c[e>>2]|0;e=c[e+4>>2]|0}f=b+296|0;c[f>>2]=d;c[f+4>>2]=e;f=b+304|0;c[f>>2]=d;c[f+4>>2]=e;d=b+360|0;f=d;if((c[f>>2]|0)==-1?(c[f+4>>2]|0)==-1:0){f=d;c[f>>2]=0;c[f+4>>2]=0}return}function mx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;h=b+24|0;if(!(c[h>>2]|0)){g=b+4|0;if(!e){e=ZW(12)|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[g>>2]=e;iC(e);e=ZW(12)|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[b+8>>2]=e;TB(e);e=1}else{c[g>>2]=e;c[b+8>>2]=f;e=0}a[b+12>>0]=e;c[h>>2]=d}return}function nx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;f=a+40|0;d=c[f>>2]|0;f=c[f+4>>2]|0;if((c[a+936>>2]|0)!=(c[a+940>>2]|0)?(b=c[a+948>>2]|0,(b|0)!=(c[a+956>>2]|0)):0){e=c[b+4>>2]|0;b=c[b>>2]|0}else{e=f;b=d}g=e>>>0>f>>>0|(e|0)==(f|0)&b>>>0>d>>>0;d=g?d:b;b=g?f:e;e=a+48|0;e=z0(c[a+612>>2]|0,0,c[e>>2]|0,c[e+4>>2]|0)|0;f=a+536|0;f=z0(e|0,z|0,c[f>>2]|0,c[f+4>>2]|0)|0;if(!((d|0)==(f|0)&(b|0)==(z|0))){if(!(c[a+728>>2]&1))W5(a);I1(a,d,b)}return}function ox(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;f=j;i=0;while(1){if((i|0)==4)break;g=(i|0)==3?2:6;e=16<<(i<<1);e=(e|0)<64?e:64;h=i>>>0>1;d=0;while(1){if((d&255)>>>0>=g>>>0)break;AT(b,f);a:do if(!(a[f>>0]|0))T5(b);else{if(h){L5(b);c=0}else c=0;while(1){if(c>>>0>=e>>>0)break a;L5(b);c=c+1|0}}while(0);d=d+1<<24>>24}i=i+1|0}l=j;return}function px(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=l;l=l+32|0;d=b+16|0;h=b+12|0;g=b+8|0;f=b+4|0;e=b;TX(d);bD(a,h);e1(a,c[h>>2]|0,0);bD(a,g);iF(a,c[g>>2]|0,0);bD(a,f);iF(a,c[f>>2]|0,0);bD(a,e);jZ(a,c[e>>2]|0,0,d);Mc(a,0,0,380114,d,0);z5(d);l=b;return}function qx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=l;l=l+16|0;Bx(a);d4(c[a+648>>2]|0,2);AT(a,g+1|0);AT(a,g);xR(a,2,g+2|0);wK(a);f=a+528|0;a=a+536|0;e=c[a>>2]|0;a=c[a+4>>2]|0;d=f;b=c[d+4>>2]|0;d=c[d>>2]|0;while(1){if(!(b>>>0<a>>>0|(b|0)==(a|0)&d>>>0<e>>>0))break;h=z0(d|0,b|0,1,0)|0;i=z;j=f;c[j>>2]=h;c[j+4>>2]=i;b=i;d=h}l=g;return}function rx(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b+4>>2]|0;a:do if(!d){e=b;while(1){d=c[e+8>>2]|0;if((c[d>>2]|0)==(e|0))break a;e=d}}else while(1){e=c[d>>2]|0;if(!e)break;else d=e}while(0);if((c[a>>2]|0)==(b|0))c[a>>2]=d;e=a+8|0;c[e>>2]=(c[e>>2]|0)+-1;Dg(c[a+4>>2]|0,b);Q$(b+16|0);laa(b);return}function sx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=b+8|0;k=f+3|0;i=a[k>>0]|0;j=i<<24>>24<0;if(j)g=(c[f>>2]&2147483647)+-1|0;else g=1;h=b+4|0;do if(g>>>0>=e>>>0){if(j)f=c[b>>2]|0;else f=b;W2(f,d,e);y7(f+(e<<2)|0,0);if((a[k>>0]|0)<0){c[h>>2]=e;break}else{a[k>>0]=e;break}}else{if(j)f=c[h>>2]|0;else f=i&255;at(b,g,e-g|0,f,0,f,e,d)}while(0);return b|0}function tx(b,d,f,g){b=b|0;d=d|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;m=l;l=l+16|0;i=m;h=d&255;k=c[10792+(h<<2)>>2]|0;d=0;while(1){j=d&65535;if(a[k+(j*5|0)>>0]|0)break;AT(b,i);d=(a[((a[i>>0]|0)+1&255)+(k+(j*5|0))>>0]|0)+j|0}a:do if(j>>>0<(e[59684+(h<<1)>>1]|0)>>>0){h=g&255;d=0;while(1){if((d|0)==(h|0))break a;i=d+1|0;a[f+d>>0]=a[k+(j*5|0)+i>>0]|0;d=i}}else{f=c[b+648>>2]|0;G4(f,Z9(c[f+4>>2]|0)|0)}while(0);l=m;return}function ux(b){b=b|0;var d=0,e=0,f=0,g=0;e=b+776|0;d=c[e>>2]|0;if(!d){e=b+528|0;d=c[e>>2]|0;e=c[e+4>>2]|0;g=b+536|0;f=c[g>>2]|0;g=c[g+4>>2]|0;if(g>>>0>e>>>0|(g|0)==(e|0)&f>>>0>d>>>0?(g=D_(f|0,g|0,d|0,e|0)|0,e1(b,g,z),a[b+784>>0]|0):0)V5(b)}else{if(!(a[b+785>>0]|0)){ku(b);d=c[e>>2]|0}rB(b,d);if(a[b+784>>0]|0?c[(c[e>>2]|0)+728>>2]&2|0:0)V5(b)}return}function vx(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;do if(!(d8(b,c[d+8>>2]|0)|0)){if(d8(b,c[d>>2]|0)|0){b=d+32|0;if((c[d+16>>2]|0)!=(e|0)?(h=d+20|0,(c[h>>2]|0)!=(e|0)):0){c[b>>2]=f;c[h>>2]=e;f=d+40|0;c[f>>2]=(c[f>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0)a[d+54>>0]=1;c[d+44>>2]=4;break}if((f|0)==1)c[b>>2]=1}}else TV(d,e,f);while(0);return}function wx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;h=l;l=l+48|0;f=h+28|0;g=h+16|0;d=h+8|0;b=h+4|0;e=h;TX(f);TX(g);bD(a,h+12|0);bD(a,d);d=c[d>>2]|0;if(d|0)e1(a,d,0);bD(a,b);b=c[b>>2]|0;if(b|0)jZ(a,b,0,g);bD(a,e);b=c[e>>2]|0;if(b|0)jZ(a,b,0,f);z5(g);z5(f);l=h;return}function xx(b){b=b|0;var d=0,e=0,f=0;f=l;l=l+32|0;d=f+12|0;e=f;if(!(a[b+904>>0]|0)){KK(b);bD(b,d);Op(b,(c[d>>2]|0)+8|0,0);VU(e,373066);BZ(c[b+508>>2]|0,c[b+668>>2]|0,0,0);z5(e)}else{e=b+536|0;Op(b,c[e>>2]|0,c[e+4>>2]|0);VU(d,373066);BZ(c[b+508>>2]|0,c[b+668>>2]|0,0,0);z5(d)}l=f;return}function yx(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=b+4|0;j=c[i>>2]|0;f=c[a>>2]|0;h=d;g=h-f|0;e=j+(0-(g>>1)<<1)|0;c[i>>2]=e;if((g|0)>0)no(e|0,f|0,g|0)|0;f=a+4|0;g=b+8|0;e=(c[f>>2]|0)-h|0;if((e|0)>0){no(c[g>>2]|0,d|0,e|0)|0;c[g>>2]=(c[g>>2]|0)+(e>>>1<<1)}h=c[a>>2]|0;c[a>>2]=c[i>>2];c[i>>2]=h;h=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=h;h=a+8|0;d=b+12|0;a=c[h>>2]|0;c[h>>2]=c[d>>2];c[d>>2]=a;c[b>>2]=c[i>>2];return j|0}function zx(d){d=d|0;var e=0;Eg(d);c[d>>2]=29848;x1(d+760|0);e=d+776|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;TX(d+800|0);IX(d+72|0,380051)|0;a[d+494>>0]=0;c[d+828>>2]=0;c[d+816>>2]=-1;e=d+840|0;c[d+872>>2]=0;c[d+876>>2]=0;c[d+824>>2]=0;b[d+772>>1]=0;c[d+812>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;a[d+885>>0]=1;a[d+886>>0]=0;a[d+820>>0]=1;a[d+823>>0]=0;return}function Ax(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+32|0;d=h;e=c[a>>2]|0;f=((c[a+4>>2]|0)-e|0)/12|0;g=f+1|0;if(g>>>0>357913941)uaa();else{i=((c[a+8>>2]|0)-e|0)/12|0;e=i<<1;xE(d,i>>>0<178956970?(e>>>0<g>>>0?g:e):357913941,f,a+8|0);g=d+8|0;f=c[g>>2]|0;p2(f,b);c[g>>2]=f+12;Qz(a,d);HQ(d);l=h;return}}function Bx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;e=a+528|0;h=c[e>>2]|0;e=c[e+4>>2]|0;d=a+536|0;b=c[d>>2]|0;d=c[d+4>>2]|0;g=c[a+612>>2]|0;do if(d>>>0>e>>>0|(d|0)==(e|0)&b>>>0>h>>>0){i=z0(g|0,0,b|0,d|0)|0;j=z;f=c[a+548>>2]|0;if(!(j>>>0>0|(j|0)==0&i>>>0>f>>>0)){b=D_(b|0,d|0,h|0,e|0)|0;break}b=z0(g|0,0,h|0,e|0)|0;j=z;if(!(j>>>0>0|(j|0)==0&b>>>0>f>>>0))b=f-b|0;else b=0}else b=0;while(0);YZ(c[a+648>>2]|0,(c[a+544>>2]|0)+g+h|0,b);return}function Cx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=a+804|0;i=a+808|0;a=c[j>>2]|0;f=a;h=0;d=f;a:while(1){if(h>>>0<(((c[i>>2]|0)-a|0)/120|0)>>>0){g=0;e=f}else{a=0;break}while(1){a=c[e+(h*120|0)+28>>2]|0;if(g>>>0>=(c[e+(h*120|0)+32>>2]|0)-a>>2>>>0)break;a=c[a+(g<<2)>>2]|0;if(!a)a=d;else{a=tb[c[(c[a>>2]|0)+12>>2]&31](a,b)|0;if(a|0)break a;a=c[j>>2]|0}g=g+1|0;d=a;e=a}h=h+1|0;f=e;a=e}return a|0}function Dx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+32|0;d=h;e=c[a>>2]|0;f=((c[a+4>>2]|0)-e|0)/12|0;g=f+1|0;if(g>>>0>357913941)uaa();else{i=((c[a+8>>2]|0)-e|0)/12|0;e=i<<1;xE(d,i>>>0<178956970?(e>>>0<g>>>0?g:e):357913941,f,a+8|0);g=d+8|0;f=c[g>>2]|0;rV(f,b);c[g>>2]=f+12;Qz(a,d);HQ(d);l=h;return}}function Ex(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;g=b+8|0;j=g+3|0;f=a[j>>0]|0;i=f<<24>>24<0;k=b+4|0;if(i){h=c[k>>2]|0;f=(c[g>>2]&2147483647)+-1|0}else{h=f&255;f=1}g=h+e|0;if((f-h|0)>>>0>=e>>>0){if(e|0){if(i)f=c[b>>2]|0;else f=b;a3(f+(h<<2)|0,d,e);if((a[j>>0]|0)<0)c[k>>2]=g;else a[j>>0]=g;y7(f+(g<<2)|0,0)}}else at(b,f,g-f|0,h,h,0,e,d);return b|0}function Fx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;if(d|0){g=b+8|0;j=g+3|0;f=a[j>>0]|0;k=b+4|0;if(f<<24>>24<0){i=c[k>>2]|0;g=(c[g>>2]&2147483647)+-1|0}else{i=f&255;g=1}h=i+d|0;if((g-i|0)>>>0<d>>>0){ax(b,g,h-g|0,i,i,0);f=a[j>>0]|0}if(f<<24>>24<0)f=c[b>>2]|0;else f=b;$2(f+(i<<2)|0,d,e);if((a[j>>0]|0)<0)c[k>>2]=h;else a[j>>0]=h;y7(f+(h<<2)|0,0)}return b|0}function Gx(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;f=b+8|0;h=f+3|0;e=a[h>>0]|0;g=e<<24>>24<0;i=b+4|0;if(g){j=c[i>>2]|0;e=(c[f>>2]&2147483647)+-1|0}else{j=e&255;e=1}if((j|0)==(e|0)){ax(b,e,1,e,e,0);e=e+1|0;if((a[h>>0]|0)<0)f=8;else f=7}else{e=j+1|0;if(g)f=8;else f=7}if((f|0)==7)a[h>>0]=e;else if((f|0)==8){b=c[b>>2]|0;c[i>>2]=e}j=b+(j<<2)|0;y7(j,d);y7(j+4|0,0);return}function Hx(b){b=b|0;var d=0,f=0,g=0;d=b+312|0;g=d;g=z0(c[g>>2]|0,c[g+4>>2]|0,1,0)|0;c[d>>2]=g;c[d+4>>2]=z;d=c[(c[(c[b+768>>2]|0)+80>>2]|0)+(e[b+762>>1]<<2)>>2]|0;if((((a[d+173>>0]|0)==0?(a[d+174>>0]|0)==0:0)?(a[d+177>>0]|0)==0:0)?(a[d+178>>0]|0)==0:0){g=b+536|0;e1(b,c[g>>2]|0,c[g+4>>2]|0)}else f=6;a:do if((f|0)==6)switch(c[d+64>>2]|0){case 1:{sd(b);break a}case 2:{Sd(b);break a}default:break a}while(0);return}function Ix(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=e-d>>2;a:do if((f|0)!=0?(b-a>>2|0)>=(f|0):0){h=a+(f+-1<<2)|0;g=e+-4|0;a=b;b:while(1){while(1){if((h|0)==(a|0)){a=b;break a}e=a+-4|0;if(d8(c[e>>2]|0,c[g>>2]|0)|0){f=g;a=e;break}else a=e}while(1){if((f|0)==(d|0))break a;a=a+-4|0;f=f+-4|0;if(!(d8(c[a>>2]|0,c[f>>2]|0)|0)){a=e;continue b}}}}else a=b;while(0);return a|0}function Jx(b){b=b|0;var d=0,e=0,f=0,g=0;g=l;l=l+32|0;e=g+12|0;f=g;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[e+(d<<2)>>2]=0;d=d+1|0}EU(b,4,0,e);if(qO(b)|0){VU(f,(a[e+11>>0]|0)<0?c[e>>2]|0:e);Rf(b,f,1,c[b+20>>2]|0,1);z5(f)}a1(e);l=g;return}function Kx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j;do if((b|0)==(d|0)){c[e>>2]=4;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;b=0;break}i=c[12784]|0;c[12784]=0;b0()|0;g=B6(b,h,f)|0;b=z;f=c[12784]|0;if(!f)c[12784]=i;do if((c[h>>2]|0)==(d|0))if(b>>>0>0|(b|0)==0&g>>>0>65535|(f|0)==34){c[e>>2]=4;b=-1;break}else{b=g&65535;break}else{c[e>>2]=4;b=0}while(0)}while(0);l=j;return b|0}function Lx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a:do if(!(d8(b,c[d+8>>2]|0)|0)){h=c[b+12>>2]|0;g=b+16+(h<<3)|0;QM(b+16|0,d,e,f);if((h|0)>1){h=d+54|0;b=b+24|0;do{QM(b,d,e,f);if(a[h>>0]|0)break a;b=b+8|0}while(b>>>0<g>>>0)}}else jG(d,e,f);while(0);return}function Mx(a,b){a=a|0;b=b|0;var d=0,e=0;e=a+4|0;d=c[e>>2]|0;if((d|0)==(c[a+8>>2]|0)){bx(a,b);d=e;b=c[e>>2]|0}else{yw(d,b);b=(c[e>>2]|0)+40|0;c[e>>2]=b;d=e}e=c[a>>2]|0;z3(e+((((b-e|0)/40|0)+-1|0)*40|0)|0,a+24|0);e=c[a>>2]|0;Q3(e+(((((c[d>>2]|0)-e|0)/40|0)+-1|0)*40|0)|0,a+36|0);e=c[a>>2]|0;s5(e+(((((c[d>>2]|0)-e|0)/40|0)+-1|0)*40|0)|0,c[a+52>>2]|0);return}function Nx(a){a=a|0;var b=0,e=0,f=0,g=0;g=l;l=l+16|0;GC(a);xR(a,3,g+3|0);xR(a,5,g+2|0);sR(a,10,g);f=a+792|0;e=a+648|0;b=0;while(1){if((b&255)>=(d[f>>0]|0))break;if(K6(c[e>>2]|0)|0){GC(a);A6(c[e>>2]|0);J3(a)}else A6(c[e>>2]|0);b=b+1<<24>>24}J3(a);l=g;return}function Ox(b){b=b|0;var d=0,e=0;d=b+857|0;bB(b,d);if(a[d>>0]|0){e=b+528|0;d=b+536|0;if(!((c[e>>2]|0)==(c[d>>2]|0)?(c[e+4>>2]|0)==(c[d+4>>2]|0):0))t4(b);if(qO(b)|0){s_(b);AR(b,177,0);AR(b,178,0);AR(b,181,0);e=c[b+772>>2]|0;a[e+177>>0]=1;a[e+178>>0]=1;a[e+181>>0]=1}}else t4(b);return}function Px(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+32|0;d=h;e=c[a>>2]|0;f=(c[a+4>>2]|0)-e>>3;g=f+1|0;if(g>>>0>536870911)uaa();else{e=(c[a+8>>2]|0)-e|0;i=e>>2;EF(d,e>>3>>>0<268435455?(i>>>0<g>>>0?g:i):536870911,f,a+8|0);g=d+8|0;f=c[g>>2]|0;i=b;b=c[i+4>>2]|0;e=f;c[e>>2]=c[i>>2];c[e+4>>2]=b;c[g>>2]=f+8;_A(a,d);xS(d);l=h;return}}function Qx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;j=b+11|0;f=a[j>>0]|0;g=f<<24>>24<0;if(g)h=(c[b+8>>2]&2147483647)+-1|0;else h=10;i=b+4|0;do if(h>>>0>=e>>>0){if(g)f=c[b>>2]|0;else f=b;g1(f,d,e)|0;J7(f+e|0,0);if((a[j>>0]|0)<0){c[i>>2]=e;break}else{a[j>>0]=e;break}}else{if(g)f=c[i>>2]|0;else f=f&255;uu(b,h,e-h|0,f,0,f,e,d)}while(0);return b|0}function Rx(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);e=a+16|0;f=a+20|0;d=0;while(1){b=c[e>>2]|0;if(d>>>0>=(c[f>>2]|0)-b>>2>>>0)break;b=c[b+(d<<2)>>2]|0;if(b|0){DZ(b);laa(b)}d=d+1|0}IT(a+40|0);IT(a+28|0);cU(e);bU(a+4|0);return}function Sx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=c[b>>2]|0;i=((c[b+4>>2]|0)-f|0)/40|0;h=a[d+8+3>>0]|0;b=h<<24>>24<0;h=b?c[d+4>>2]|0:h&255;d=b?c[d>>2]|0:d;b=0;while(1){if(b>>>0>=i>>>0){b=-1;break}l=c[f+(b*40|0)>>2]|0;g=l;if(((((c[f+(b*40|0)+4>>2]|0)-l|0)/12|0)>>>0>e>>>0?(j=g+(e*12|0)|0,l=a[g+(e*12|0)+8+3>>0]|0,k=l<<24>>24<0,((k?c[g+(e*12|0)+4>>2]|0:l&255)|0)==(h|0)):0)?(L$(k?c[j>>2]|0:j,d,h)|0)==0:0)break;b=b+1|0}return b|0}function Tx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;i=IB(a,b,d,e)|0;g=c[f>>2]|0;h=c[e>>2]|0;if(g>>>0<h>>>0){c[e>>2]=g;c[f>>2]=h;f=i+1|0;g=c[e>>2]|0;h=c[d>>2]|0;if(g>>>0<h>>>0){c[d>>2]=g;c[e>>2]=h;f=i+2|0;g=c[d>>2]|0;h=c[b>>2]|0;if(g>>>0<h>>>0){c[b>>2]=g;c[d>>2]=h;f=c[b>>2]|0;g=c[a>>2]|0;if(f>>>0<g>>>0){c[a>>2]=f;c[b>>2]=g;f=i+4|0}else f=i+3|0}}}else f=i;return f|0}function Ux(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;if(d&2048){a[b>>0]=43;b=b+1|0}if(d&1024){a[b>>0]=35;b=b+1|0}h=d&260;e=(d&16384|0)!=0;f=(h|0)==260;if(f)g=0;else{a[b>>0]=46;a[b+1>>0]=42;g=1;b=b+2|0}while(1){d=a[c>>0]|0;if(!(d<<24>>24))break;a[b>>0]=d;c=c+1|0;b=b+1|0}a:do switch(h&511){case 4:{d=e?70:102;break}case 256:{d=e?69:101;break}default:if(f){d=e?65:97;break a}else{d=e?71:103;break a}}while(0);a[b>>0]=d;return g|0}function Vx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;f=l;l=l+16|0;e=f;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;d=0;do{TX(a+12+(d*12|0)|0);d=d+1|0}while((d|0)!=2);d=a+36|0;TX(d);Xy(e,42472);k1(a+12|0,e)|0;z5(e);Xy(e,42436);k1(a+24|0,e)|0;z5(e);Xy(e,42444);k1(d,e)|0;z5(e);c[a+48>>2]=-1;c[a+52>>2]=-1;Xy(e,b);bf(a,e);z5(e);l=f;return}function Wx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;j=b+11|0;f=a[j>>0]|0;i=f<<24>>24<0;k=b+4|0;if(i){g=c[k>>2]|0;f=(c[b+8>>2]&2147483647)+-1|0}else{g=f&255;f=10}h=g+e|0;if((f-g|0)>>>0>=e>>>0){if(e|0){if(i)f=c[b>>2]|0;else f=b;i1(f+g|0,d,e)|0;if((a[j>>0]|0)<0)c[k>>2]=h;else a[j>>0]=h;J7(f+h|0,0)}}else uu(b,f,h-f|0,g,g,0,e,d);return b|0}function Xx(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,i=0.0;f=l;l=l+16|0;b=f+4|0;d=f;ID(a,b);ID(a,d);if((c[a+784>>2]|0)>>>0<=1?(h=qO(a)|0,e=c[d>>2]|0,h&(e|0)!=0):0){i=+((c[b>>2]|0)>>>0)/+(e>>>0);h=a+20|0;Ed(a,1,c[h>>2]|0,156);Bt(a,1,c[h>>2]|0,150,i,3,1);g[(bF(a+916|0,a+788|0)|0)+408>>2]=i}l=f;return}function Yx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j;do if((b|0)==(d|0)){c[e>>2]=4;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;b=0;break}i=c[12784]|0;c[12784]=0;b0()|0;b=B6(b,h,f)|0;f=z;g=c[12784]|0;if(!g)c[12784]=i;do if((c[h>>2]|0)==(d|0))if(f>>>0>0|(f|0)==0&b>>>0>4294967295|(g|0)==34){c[e>>2]=4;b=-1;break}else break;else{c[e>>2]=4;b=0}while(0)}while(0);l=j;return b|0}function Zx(a){a=a|0;do switch(a<<24>>24){case 1:{a=383164;break}case 4:{a=383311;break}case 5:{a=383120;break}case 6:{a=383113;break}case 7:{a=383102;break}case 8:{a=383304;break}case 9:{a=383284;break}case 10:{a=383258;break}case 11:{a=383244;break}case 12:{a=383207;break}case 13:{a=383202;break}case 14:{a=383075;break}case 15:{a=383058;break}case 16:{a=383199;break}case 17:{a=383184;break}case 18:{a=383180;break}default:a=8800948}while(0);return a|0}function _x(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=b+104|0;i=c[f>>2]|0;if((i|0)!=0?(c[b+108>>2]|0)>=(i|0):0)j=4;else{e=cW(b)|0;if((e|0)>=0){g=c[f>>2]|0;f=b+8|0;i=c[b+4>>2]|0;if(!g){h=c[f>>2]|0;f=b+108|0;g=h}else{k=c[f>>2]|0;f=b+108|0;g=g-(c[f>>2]|0)|0;h=k;g=(k-i|0)<(g|0)?h:i+(g+-1)|0}c[b+100>>2]=g;if(h|0)c[f>>2]=1-i+h+(c[f>>2]|0);f=i+-1|0;if((d[f>>0]|0|0)!=(e|0))a[f>>0]=e}else j=4}if((j|0)==4){c[b+100>>2]=0;e=-1}return e|0}function $x(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;do if(((d|0)<=6?(k=c[c[b+4>>2]>>2]|0,b=c[k+(d*12|0)>>2]|0,h=b,(((c[k+(d*12|0)+4>>2]|0)-b|0)/40|0)>>>0>e>>>0):0)?(i=h+(e*40|0)|0,(((c[h+(e*40|0)+4>>2]|0)-(c[i>>2]|0)|0)/12|0)>>>0>f>>>0):0)if((g|0)==1){p2(a,DN(i,f)|0);break}else{p2(a,fm(d,f,g)|0);break}else j=4;while(0);if((j|0)==4)p2(a,408444);return}function ay(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;if(d|0){j=b+11|0;f=a[j>>0]|0;k=b+4|0;if(f<<24>>24<0){h=c[k>>2]|0;g=(c[b+8>>2]&2147483647)+-1|0}else{h=f&255;g=10}i=h+d|0;if((g-h|0)>>>0<d>>>0){zz(b,g,i-g|0,h,h);f=a[j>>0]|0}if(f<<24>>24<0)f=c[b>>2]|0;else f=b;NZ(f+h|0,d,e)|0;if((a[j>>0]|0)<0)c[k>>2]=i;else a[j>>0]=i;J7(f+i|0,0)}return b|0}function by(b){b=b|0;var d=0,e=0,f=0,g=0;d=l;l=l+32|0;f=d+12|0;g=d+16|0;e=d;Bx(b);AT(b,b+891|0);xR(b,7,g);wK(b);jB(b,f);g=a[g>>0]|0;TX(e);ex(e,g)|0;BZ(c[b+508>>2]|0,c[b+668>>2]|0,g&255,0);z5(e);e=b+528|0;e=z0(c[f>>2]|0,0,c[e>>2]|0,c[e+4>>2]|0)|0;Op(b,e,z);l=d;return}function cy(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;h=b+528|0;g=c[h>>2]|0;h=z0(g|0,c[h+4>>2]|0,d|0,e|0)|0;j=z;e=b+536|0;i=c[e+4>>2]|0;do if(j>>>0>i>>>0|((j|0)==(i|0)?h>>>0>(c[e>>2]|0)>>>0:0)){vt(b);b=f+8+3|0;if((a[b>>0]|0)<0){y7(c[f>>2]|0,0);c[f+4>>2]=0;break}else{y7(f,0);a[b>>0]=0;break}}else M2(f,(c[b+544>>2]|0)+(c[b+612>>2]|0)+g|0,d)|0;while(0);return}function dy(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;switch(a|0){case 1274:case 1253:{d=188416;e=9;break}case 1258:{d=212992;e=8;break}case 1252:{d=303104;e=8;break}case 1260:case 1259:{d=417792;e=8;break}case 1251:case 1250:{d=458752;e=8;break}case 1273:case 1244:case 1242:case 1237:{d=606208;e=9;break}case 1272:case 1271:case 1243:case 1241:case 1238:case 1235:{d=917504;e=9;break}case 1270:case 1256:{d=1835008;e=9;break}default:d=0}if((e|0)!=8)if((e|0)==9)if(a>>>0>1269)d=yF(d,0,b,c)|0;return d|0}function ey(a){a=a|0;var b=0,d=0,e=0,f=0;b=l;l=l+16|0;e=b;gB(a,e);e1(a,c[e>>2]|0,0);e=a+536|0;f=e;d=a+528|0;d=D_(c[f>>2]|0,c[f+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e1(a,d,z);d=a+48|0;d=z0(c[a+612>>2]|0,0,c[d>>2]|0,c[d+4>>2]|0)|0;e=z0(d|0,z|0,c[e>>2]|0,0)|0;d=a+1024|0;e=z0(e|0,z|0,O((c[a+1028>>2]|0)+-1|0,c[d>>2]|0)|0,0)|0;I1(a,e,z);c[d>>2]=0;l=b;return}function fy(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b+4>>2]|0;a:do if(!d){e=b;while(1){d=c[e+8>>2]|0;if((c[d>>2]|0)==(e|0))break a;e=d}}else while(1){e=c[d>>2]|0;if(!e)break;else d=e}while(0);if((c[a>>2]|0)==(b|0))c[a>>2]=d;e=a+8|0;c[e>>2]=(c[e>>2]|0)+-1;Dg(c[a+4>>2]|0,b);V3(b+16|0);laa(b);return}function gy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=b+11|0;e=a[g>>0]|0;f=e<<24>>24<0;h=b+4|0;if(f){i=c[h>>2]|0;e=(c[b+8>>2]&2147483647)+-1|0}else{i=e&255;e=10}if((i|0)==(e|0)){zz(b,e,1,e,e);e=e+1|0;if((a[g>>0]|0)<0)f=8;else f=7}else{e=i+1|0;if(f)f=8;else f=7}if((f|0)==7)a[g>>0]=e;else if((f|0)==8){b=c[b>>2]|0;c[h>>2]=e}i=b+i|0;J7(i,d);J7(i+1|0,0);return}function hy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,h=0,i=0,j=0;h=a+528|0;h=z0(c[h>>2]|0,c[h+4>>2]|0,4,0)|0;j=z;f=a+536|0;i=c[f+4>>2]|0;if(j>>>0>i>>>0|((j|0)==(i|0)?h>>>0>(c[f>>2]|0)>>>0:0)){vt(a);e=0.0}else{Bx(a);i=a+648|0;f=tn(c[i>>2]|0,b)|0;h=b&255;j=32-h|0;i=tn(c[i>>2]|0,j&255)|0;wK(a);h=1<<h;e=+(f-((f|0)<((h|0)/2|0|0)?0:h)|0)+ +(i>>>0)/+(1<<j|0)}g[d>>2]=e;return}function iy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;j=l;l=l+16|0;d=j;g=b+528|0;h=b+536|0;f=g;e=c[f+4>>2]|0;f=c[f>>2]|0;while(1){k=h;m=c[k+4>>2]|0;if(!(e>>>0<m>>>0|((e|0)==(m|0)?f>>>0<(c[k>>2]|0)>>>0:0)))break;EG(b,d);if((a[d>>0]|0)!=-1){i=5;break}f=g;f=z0(c[f>>2]|0,c[f+4>>2]|0,1,0)|0;e=z;m=g;c[m>>2]=f;c[m+4>>2]=e}Bx(b);KS(b);wK(b);l=j;return}function jy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=(c[b+24>>2]|0)+141|0;if(!(a[d>>0]|0)){a[d>>0]=1;d=b+40|0;e=d;f=c[e>>2]|0;e=c[e+4>>2]|0;h=b+48|0;h=z0(c[b+548>>2]|0,0,c[h>>2]|0,c[h+4>>2]|0)|0;g=d;c[g>>2]=h;c[g+4>>2]=z;Oc(b,0,0);c[d>>2]=f;c[d+4>>2]=e}d=b+508|0;while(1){if(!(c[d>>2]|0))break;J3(b)}jt(b);wk(b);Dn(b);return}function ky(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;f=l;l=l+16|0;e=f;W0(e,a+360|0);a=c[a+20>>2]|0;if((a|0)!=0?(b=a+64|0,d=c[b>>2]|0,b=c[b+4>>2]|0,!((d|0)==-1&(b|0)==-1)):0){i=a+48|0;h=c[i>>2]|0;i=c[i+4>>2]|0;a=z0(h|0,i|0,65536,0)|0;g=z;a=(b>>>0>i>>>0|(b|0)==(i|0)&d>>>0>=h>>>0)&(b>>>0<g>>>0|(b|0)==(g|0)&d>>>0<a>>>0);b=a?-1:b;a=a?-1:d}else{b=-1;a=-1}s7(c[e>>2]|0);z=b;l=f;return a|0}function ly(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;f=a+4|0;g=b+4|0;d=c[f>>2]|0;while(1){if((d|0)==(e|0))break;h=d+-32|0;$T((c[g>>2]|0)+-32|0,h);c[g>>2]=(c[g>>2]|0)+-32;d=h}e=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=e;e=b+8|0;h=c[f>>2]|0;c[f>>2]=c[e>>2];c[e>>2]=h;e=a+8|0;h=b+12|0;f=c[e>>2]|0;c[e>>2]=c[h>>2];c[h>>2]=f;c[b>>2]=c[g>>2];return}function my(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;e=e&255;i=b+4|0;f=c[i>>2]|0;g=f&7;j=357184+e|0;k=b+12|0;l=f-e|0;h=l&7;do if(e>>>0>g>>>0){if(f>>>0<e>>>0){c[i>>2]=0;a[b+13>>0]=1;e=0;break}f=e-g&255;if((f|0)==8)e=0;else e=(d[k>>0]|0)<<f&255;m=c[b>>2]|0;g=a[m>>0]|0;a[k>>0]=g;c[b>>2]=m+1;c[i>>2]=l;e=((d[357184+f>>0]|0)&(g&255)>>>h|e)&(d[j>>0]|0)&255}else{c[i>>2]=l;e=(d[k>>0]|0)>>>h&(d[j>>0]|0)&255}while(0);return e|0}function ny(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;k=b+8+3|0;g=a[k>>0]|0;f=g<<24>>24<0;l=b+4|0;if(f)i=c[l>>2]|0;else i=g&255;if(i>>>0<d>>>0)uaa();if(e|0){if(f)j=c[b>>2]|0;else j=b;f=i-d|0;h=f>>>0<e>>>0?f:e;e=f-h|0;f=j+(d<<2)|0;if(e){W2(f,f+(h<<2)|0,e);g=a[k>>0]|0}f=i-h|0;if(g<<24>>24<0)c[l>>2]=f;else a[k>>0]=f;y7(j+(f<<2)|0,0)}return b|0}function oy(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;h=k;do if((b|0)==(d|0)){c[e>>2]=4;f=0;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;f=0;b=0;break}i=c[12784]|0;c[12784]=0;b0()|0;b=B6(b,h,f)|0;f=z;g=c[12784]|0;if(!g)c[12784]=i;if((c[h>>2]|0)==(d|0)){if((g|0)==34){b=-1;f=-1;j=8}}else{b=0;f=0;j=8}if((j|0)==8)c[e>>2]=4}while(0);z=f;l=k;return b|0}function py(a){a=a|0;var b=0;GC(a);b=a+648|0;A6(c[b>>2]|0);d4(c[b>>2]|0,6);A6(c[b>>2]|0);d4(c[b>>2]|0,3);d4(c[b>>2]|0,4);d4(c[b>>2]|0,3);A6(c[b>>2]|0);A6(c[b>>2]|0);A6(c[b>>2]|0);d4(c[b>>2]|0,2);J3(a);return}function qy(a,b){a=a|0;b=b|0;var d=0,e=0;if(+g[(c[a+24>>2]|0)+136>>2]>=1.0?(e=a+536|0,(c[e>>2]|0)==0&(c[e+4>>2]|0)==0):0)c3(c[a+508>>2]|0,c[a+668>>2]|0);else d=4;do if((d|0)==4){if(!b){e=HN(a,0)|0;e1(a,e,z);break}if(!(c[b>>2]|0))a=1;else{e=HN(a,0)|0;e1(a,e,z);a=(c[b>>2]|0)+1|0}c[b>>2]=a}while(0);return}function ry(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;j=c[b+804>>2]|0;k=b+800|0;f=c[k>>2]|0;h=c[(c[b+840>>2]|0)+(e<<2)>>2]|0;g=d[h+46>>0]|0;e=(g<<2)+12|0;i=c[b+784>>2]|0;if((j-f|0)>>>0>e>>>0){e=j-e|0;while(1)if(!(c[i+(e<<2)>>2]|0))e=e+1|0;else break;c[k>>2]=e}else e=f;g=g<<1;f=h+51|0;while(1){b=c[i+(e<<2)>>2]|0;if(!((b|0)!=0&(e+g|0)>>>0<j>>>0))break;h=((a[b+6>>0]^1|a[f>>0])<<24>>24?2:1)+e|0;c[k>>2]=h;e=h}return}function sy(a){a=a|0;var b=0,d=0,e=0;b=a+536|0;a:do if(!((c[b>>2]|0)==0&(c[b+4>>2]|0)==0)){b=a+312|0;if((c[b>>2]|0)==0&(c[b+4>>2]|0)==0){e=a+136|0;d=c[e+4>>2]|0;b=a+280|0;c[b>>2]=c[e>>2];c[b+4>>2]=d}switch(c[a+908>>2]|0){case 1:{gU(a);break a}case 2:{Em(a);break a}case 4:case 3:{DR(a+760|0);break a}default:break a}}while(0);return}function ty(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0;do if(c[b+728>>2]&1){f=a[b+492>>0]|0;if(f<<24>>24?+g[(c[b+24>>2]|0)+136>>2]>=1.0:0)break;h=b+40|0;if((c[h>>2]|0)==(d|0)?(c[h+4>>2]|0)==(e|0):0){On(b);h=b+64|0;if(!((c[h>>2]|0)==-1?(c[h+4>>2]|0)==-1:0))break;wk(b);break}else{if((a[b+732>>0]|f)<<24>>24)break;h=b+64|0;c[h>>2]=d;c[h+4>>2]=e;break}}else z$(b);while(0);return}function uy(a){a=a|0;if(!a)return;else{uy(c[a>>2]|0);uy(c[a+4>>2]|0);UY(a+16|0);laa(a);return}}function vy(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=l;l=l+16|0;e=h+2|0;f=h;g=a+528|0;i=g;i=z0(c[i>>2]|0,c[i+4>>2]|0,4,0)|0;d=g;c[d>>2]=i;c[d+4>>2]=z;HB(a,e);e=b[e>>1]|0;d=0;while(1){if((d&65535)>=(e&65535))break;GC(a);j=g;j=z0(c[j>>2]|0,c[j+4>>2]|0,2,0)|0;i=g;c[i>>2]=j;c[i+4>>2]=z;HB(a,f);J3(a);d=d+1<<16>>16}l=h;return}function wy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;g=l;l=l+32|0;d=g+16|0;e=g+8|0;f=g;if(c[a+8>>2]<<5>>>0<b>>>0){c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;iW(d,b);h=c[a>>2]|0;c[e>>2]=h;c[e+4>>2]=0;b=c[a+4>>2]|0;c[f>>2]=h+(b>>>5<<2);c[f+4>>2]=b&31;Pq(d,e,f);EN(a,d);s8(c[d>>2]|0)}l=g;return}function xy(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b+4>>2]|0;a:do if(!d){e=b;while(1){d=c[e+8>>2]|0;if((c[d>>2]|0)==(e|0))break a;e=d}}else while(1){e=c[d>>2]|0;if(!e)break;else d=e}while(0);if((c[a>>2]|0)==(b|0))c[a>>2]=d;e=a+8|0;c[e>>2]=(c[e>>2]|0)+-1;Dg(c[a+4>>2]|0,b);w4(b+16|0);laa(b);return}function yy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=a+804|0;i=a+808|0;a=c[j>>2]|0;f=a;h=0;d=f;a:while(1){if(h>>>0<(((c[i>>2]|0)-a|0)/120|0)>>>0){g=0;e=f}else{a=0;break}while(1){a=c[e+(h*120|0)+28>>2]|0;if(g>>>0>=(c[e+(h*120|0)+32>>2]|0)-a>>2>>>0)break;a=c[a+(g<<2)>>2]|0;if(!a)a=d;else{a=tb[c[(c[a>>2]|0)+16>>2]&31](a,b)|0;if(a|0)break a;a=c[j>>2]|0}g=g+1|0;d=a;e=a}h=h+1|0;f=e;a=e}return a|0}function zy(d){d=d|0;var e=0,f=0;a[d>>0]=0;x1(d+4|0);x1(d+16|0);x1(d+28|0);x1(d+40|0);c[d+52>>2]=0;c[d+56>>2]=0;c[d+60>>2]=0;c[d+64>>2]=-1;e=d+68|0;c[e>>2]=0;c[e+4>>2]=0;b[d+76>>1]=-1;e=d+78|0;f=e;b[f>>1]=0;b[f+2>>1]=0>>>16;e=e+4|0;b[e>>1]=0;b[e+2>>1]=0>>>16;x1(d+88|0);a[d+100>>0]=0;c[d+104>>2]=0;return}function Ay(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=l;l=l+64|0;f=h;if(!(d8(a,b)|0))if((b|0)!=0?(g=Lp(b,2640)|0,(g|0)!=0):0){b=f+4|0;e=b+52|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(e|0));c[f>>2]=g;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;vb[c[(c[g>>2]|0)+28>>2]&15](g,f,c[d>>2]|0,1);if((c[f+24>>2]|0)==1){c[d>>2]=c[f+16>>2];b=1}else b=0}else b=0;else b=1;l=h;return b|0}function By(b){b=b|0;var d=0;Bx(b);d=b+648|0;d4(c[d>>2]|0,6);d4(c[d>>2]|0,7);d4(c[d>>2]|0,14);d4(c[d>>2]|0,6);A6(c[d>>2]|0);d4(c[d>>2]|0,2);wK(b);if((qO(b)|0?(a[b+768>>0]|0)==2:0)?a[b+784>>0]|0:0)a[(c[(c[(c[b+760>>2]|0)+80>>2]|0)+(e[b+772>>1]<<2)>>2]|0)+169>>0]=123;return}function Cy(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;h=l;l=l+32|0;i=h+16|0;g=h;j=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(j,c[j+16>>2]&-3);RH(i,b);if(a[i>>0]|0?(j=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0,sb[c[(c[j>>2]|0)+16>>2]&15](g,j,d,e,f,8),j=g+8|0,(c[j>>2]|0)==-1?(c[j+4>>2]|0)==-1:0):0){j=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(j,c[j+16>>2]|4)}l=h;return b|0}function Dy(a,b){a=a|0;b=b|0;var d=0,e=0;e=l;l=l+16|0;d=e;W0(d,407712);a=Ru(a)|0;if((a|0)==407704)a=0;else a=(Cv(a+28|0,b)|0)!=(a+32|0);s7(c[d>>2]|0);l=e;return a|0}function Ey(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=c[b>>2]|0;h=c[a>>2]|0;f=c[d>>2]|0;g=f>>>0<e>>>0;do if(e>>>0<h>>>0){if(g){c[a>>2]=f;c[d>>2]=h;e=1;break}c[a>>2]=e;c[b>>2]=h;e=c[d>>2]|0;if(e>>>0<h>>>0){c[b>>2]=e;c[d>>2]=h;e=2}else e=1}else if(g){c[b>>2]=f;c[d>>2]=e;e=c[b>>2]|0;f=c[a>>2]|0;if(e>>>0<f>>>0){c[a>>2]=e;c[b>>2]=f;e=2}else e=1}else e=0;while(0);return e|0}function Fy(a){a=a|0;var b=0,d=0;do if((c[a+548>>2]|0)>>>0>=4){b=C9(c[a+544>>2]|0)|0;if((b|0)<1380533830)switch(b|0){case 509:{d=3;break}default:{}}else switch(b|0){case 1380533830:{d=3;break}default:{}}if((d|0)==3){V5(a);b=0;break}b=a+760|0;d=b;if((c[d>>2]|0)==0&(c[d+4>>2]|0)==0){a=+g[(c[a+24>>2]|0)+136>>2]>=.3;c[b>>2]=a?32:2;c[b+4>>2]=a?0:0;b=1}else b=1}else b=0;while(0);return b|0}function Gy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;f=l;l=l+16|0;d=f+12|0;e=f;g=b+528|0;h=g;h=z0(c[h>>2]|0,c[h+4>>2]|0,3,0)|0;c[g>>2]=h;c[g+4>>2]=z;bB(b,d);if(fr(b)|0){h=a[d>>0]|0;TX(e);ex(e,h)|0;BZ(c[b+508>>2]|0,c[b+668>>2]|0,h&255,0);z5(e)}else c3(c[b+508>>2]|0,c[b+668>>2]|0);l=f;return}function Hy(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;i=l;l=l+16|0;h=i;c[g>>2]=e;d=a0(c[b+8>>2]|0)|0;b=qw(h,0)|0;if(d|0)a0(d)|0;a:do switch(b|0){case 0:case -1:{d=2;break}default:{d=b+-1|0;if(d>>>0>(f-(c[g>>2]|0)|0)>>>0)d=1;else while(1){if(!d){d=0;break a}e=a[h>>0]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=e;h=h+1|0;d=d+-1|0}}}while(0);l=i;return d|0}function Iy(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;e=l;l=l+16|0;f=e;d=b+528|0;h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,4,0)|0;g=d;c[g>>2]=h;c[g+4>>2]=z;bB(b,f);switch(a[f>>0]|0){case 3:{gV(b);break}case 6:{Dl(b);break}default:{g=b+536|0;h=d;e1(b,D_(c[g>>2]|0,c[g+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0)|0,z)}}l=e;return}function Jy(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,i=0;b=an(a)|0;e=z;if(((qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)?(d=a+848|0,c[d>>2]=b,c[d+4>>2]=e,d=a+840|0,i=d,!((b|0)==0&(e|0)==0|((c[i>>2]|0)==-1?(c[i+4>>2]|0)==-1:0))):0)?(h=a+856|0,f=c[h>>2]|0,h=c[h+4>>2]|0,!((f|0)==0&(h|0)==0)):0)g[(kE(a+760|0,d)|0)+52>>2]=(+(b>>>0)+4294967296.0*+(e>>>0))/(+(f>>>0)+4294967296.0*+(h>>>0));return}function Ky(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,i=0;b=an(a)|0;e=z;if(((qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)?(d=a+856|0,c[d>>2]=b,c[d+4>>2]=e,d=a+840|0,i=d,!((c[i>>2]|0)==-1?(c[i+4>>2]|0)==-1:0)):0)?(h=a+848|0,f=c[h>>2]|0,h=c[h+4>>2]|0,!((b|0)==0&(e|0)==0|(f|0)==0&(h|0)==0)):0)g[(kE(a+760|0,d)|0)+52>>2]=(+(f>>>0)+4294967296.0*+(h>>>0))/(+(b>>>0)+4294967296.0*+(e>>>0));return}function Ly(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=a+64|0;j=a+360|0;a=c[a+24>>2]|0;b=c[a+44>>2]|0;a=(c[a+48>>2]|0)-b>>3;d=0;e=0;h=c[i+4>>2]|0;i=c[i>>2]|0;while(1){g=j;c[g>>2]=d;c[g+4>>2]=e;if(!(e>>>0<0|(e|0)==0&d>>>0<a>>>0))break;g=b+(d<<3)|0;f=c[g>>2]|0;g=c[g+4>>2]|0;if(h>>>0<g>>>0|(h|0)==(g|0)&i>>>0<f>>>0)break;g=D_(i|0,h|0,f|0,g|0)|0;f=z;k=z0(d|0,e|0,1,0)|0;d=k;e=z;h=f;i=g}return}function My(b){b=b|0;var d=0,e=0,f=0,g=0;f=l;l=l+16|0;g=f;GC(b);AT(b,g);d=b+648|0;A6(c[d>>2]|0);A6(c[d>>2]|0);A6(c[d>>2]|0);e=c[d>>2]|0;if(!(a[g>>0]|0)){d4(e,5);d4(c[d>>2]|0,2);A6(c[d>>2]|0)}else d4(e,3);J3(b);l=f;return}function Ny(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;f=a+4|0;g=b+4|0;d=c[f>>2]|0;while(1){if((d|0)==(e|0))break;h=d+-120|0;SE((c[g>>2]|0)+-120|0,h);c[g>>2]=(c[g>>2]|0)+-120;d=h}e=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=e;e=b+8|0;h=c[f>>2]|0;c[f>>2]=c[e>>2];c[e>>2]=h;e=a+8|0;h=b+12|0;f=c[e>>2]|0;c[e>>2]=c[h>>2];c[h>>2]=f;c[b>>2]=c[g>>2];return}function Oy(a){a=a|0;if(!a)return;else{Oy(c[a>>2]|0);Oy(c[a+4>>2]|0);QZ(a+16|0);laa(a);return}}function Py(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;j=b+11|0;g=a[j>>0]|0;f=g<<24>>24<0;k=b+4|0;if(f)h=c[k>>2]|0;else h=g&255;if(h>>>0<d>>>0)uaa();if(e|0){if(f)i=c[b>>2]|0;else i=b;f=h-d|0;e=f>>>0<e>>>0?f:e;f=f-e|0;if(f){g=i+d|0;g1(g,g+e|0,f)|0;g=a[j>>0]|0}f=h-e|0;if(g<<24>>24<0)c[k>>2]=f;else a[j>>0]=f;J7(i+f|0,0)}return b|0}function Qy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;f=a+4|0;g=b+4|0;d=c[f>>2]|0;while(1){if((d|0)==(e|0))break;h=d+-24|0;c0((c[g>>2]|0)+-24|0,h);c[g>>2]=(c[g>>2]|0)+-24;d=h}e=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=e;e=b+8|0;h=c[f>>2]|0;c[f>>2]=c[e>>2];c[e>>2]=h;e=a+8|0;h=b+12|0;f=c[e>>2]|0;c[e>>2]=c[h>>2];c[h>>2]=f;c[b>>2]=c[g>>2];return}function Ry(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;h=f-e>>2;if(h>>>0>1073741807)uaa();d=b+8|0;do if(h>>>0>=2){g=h+4&-4;if(g>>>0>1073741823)ra();else{j=ZW(g<<2)|0;c[b>>2]=j;c[d>>2]=g|-2147483648;c[b+4>>2]=h;i=e;break}}else{a[d+3>>0]=h;i=e;j=b}while(0);while(1){if((i|0)==(f|0))break;y7(j,c[i>>2]|0);i=i+4|0;j=j+4|0}y7(j,0);return}function Sy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;f=a+4|0;g=b+4|0;d=c[f>>2]|0;while(1){if((d|0)==(e|0))break;h=d+-12|0;BP((c[g>>2]|0)+-12|0,h);c[g>>2]=(c[g>>2]|0)+-12;d=h}e=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=e;e=b+8|0;h=c[f>>2]|0;c[f>>2]=c[e>>2];c[e>>2]=h;e=a+8|0;h=b+12|0;f=c[e>>2]|0;c[e>>2]=c[h>>2];c[h>>2]=f;c[b>>2]=c[g>>2];return}function Ty(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;g=b+612|0;e=b+548|0;f=c[g>>2]|0;if(a[b+492>>0]|0){d=f+4|0;e=c[e>>2]|0;if((d|0)==(e|0)){h=W8((c[b+544>>2]|0)+f|0)|0;e=b+328|0;e=UW(h|0,0,c[e>>2]|0,c[e+4>>2]|0)|0;b=b+528|0;if((e|0)==(f|0)&(z|0)==0){h=b;h=z0(c[h>>2]|0,c[h+4>>2]|0,4,0)|0;c[b>>2]=h;c[b+4>>2]=z;c[g>>2]=d;b=d}else b=f}else{b=f;d=e}}else{b=f;d=c[e>>2]|0}return (b+640|0)>>>0<=d>>>0|0}function Uy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=a+528|0;g=d;e=c[g>>2]|0;g=z0(e|0,c[g+4>>2]|0,8,0)|0;i=z;f=a+536|0;h=c[f+4>>2]|0;if(i>>>0>h>>>0|((i|0)==(h|0)?g>>>0>(c[f>>2]|0)>>>0:0)){vt(a);i=b;c[i>>2]=0;c[i+4>>2]=0}else{i=I5((c[a+544>>2]|0)+(c[a+612>>2]|0)+e|0)|0;h=b;c[h>>2]=i;c[h+4>>2]=z;h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,8,0)|0;i=d;c[i>>2]=h;c[i+4>>2]=z}return}function Vy(b){b=b|0;var f=0,g=0,h=0,i=0;f=c[b+544>>2]|0;g=c[b+612>>2]|0;a[b+765>>0]=(d[f+(g+1)>>0]|0)>>>6&1;g=f+(g+3)|0;f=b+764|0;a[f>>0]=a[g>>0]&-64;g=d[g>>0]|0;h=b+528|0;i=h;i=z0(c[i>>2]|0,c[i+4>>2]|0,4,0)|0;c[h>>2]=i;c[h+4>>2]=z;if(g&32|0)Kd(b);if(g&16|0?a[f>>0]|0:0){i=(c[(c[(c[b+768>>2]|0)+80>>2]|0)+(e[b+762>>1]<<2)>>2]|0)+188|0;c[i>>2]=(c[i>>2]|0)+1}Op(b,188,0);return}function Wy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;f=a+4|0;g=b+4|0;d=c[f>>2]|0;while(1){if((d|0)==(e|0))break;h=d+-24|0;qI((c[g>>2]|0)+-24|0,h);c[g>>2]=(c[g>>2]|0)+-24;d=h}e=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=e;e=b+8|0;h=c[f>>2]|0;c[f>>2]=c[e>>2];c[e>>2]=h;e=a+8|0;h=b+12|0;f=c[e>>2]|0;c[e>>2]=c[h>>2];c[h>>2]=f;c[b>>2]=c[g>>2];return}function Xy(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=i9(d)|0;if(g>>>0>1073741807)uaa();e=b+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){g=ua(8)|0;K2(g,391652);c[g>>2]=57868;Ya(g|0,2712,367)}else{h=ZW(f<<2)|0;c[b>>2]=h;c[e>>2]=f|-2147483648;c[b+4>>2]=g;b=h;break}}else a[e+3>>0]=g;while(0);a3(b,d,g);y7(b+(g<<2)|0,0);return}function Yy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+32|0;d=h;e=c[a>>2]|0;f=(c[a+4>>2]|0)-e>>2;g=f+1|0;if(g>>>0>1073741823)uaa();else{i=(c[a+8>>2]|0)-e|0;e=i>>1;BF(d,i>>2>>>0<536870911?(e>>>0<g>>>0?g:e):1073741823,f,a+8|0);g=d+8|0;f=c[g>>2]|0;c[f>>2]=c[b>>2];c[g>>2]=f+4;aB(a,d);zS(d);l=h;return}}function Zy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=a+528|0;g=d;e=c[g>>2]|0;g=z0(e|0,c[g+4>>2]|0,7,0)|0;i=z;f=a+536|0;h=c[f+4>>2]|0;if(i>>>0>h>>>0|((i|0)==(h|0)?g>>>0>(c[f>>2]|0)>>>0:0)){vt(a);i=b;c[i>>2]=0;c[i+4>>2]=0}else{i=o6((c[a+544>>2]|0)+(c[a+612>>2]|0)+e|0)|0;h=b;c[h>>2]=i;c[h+4>>2]=z;h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,7,0)|0;i=d;c[i>>2]=h;c[i+4>>2]=z}return}function _y(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=a+528|0;g=d;e=c[g>>2]|0;g=z0(e|0,c[g+4>>2]|0,6,0)|0;i=z;f=a+536|0;h=c[f+4>>2]|0;if(i>>>0>h>>>0|((i|0)==(h|0)?g>>>0>(c[f>>2]|0)>>>0:0)){vt(a);i=b;c[i>>2]=0;c[i+4>>2]=0}else{i=p6((c[a+544>>2]|0)+(c[a+612>>2]|0)+e|0)|0;h=b;c[h>>2]=i;c[h+4>>2]=z;h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,6,0)|0;i=d;c[i>>2]=h;c[i+4>>2]=z}return}function $y(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=a+528|0;g=d;e=c[g>>2]|0;g=z0(e|0,c[g+4>>2]|0,5,0)|0;i=z;f=a+536|0;h=c[f+4>>2]|0;if(i>>>0>h>>>0|((i|0)==(h|0)?g>>>0>(c[f>>2]|0)>>>0:0)){vt(a);i=b;c[i>>2]=0;c[i+4>>2]=0}else{i=q6((c[a+544>>2]|0)+(c[a+612>>2]|0)+e|0)|0;h=b;c[h>>2]=i;c[h+4>>2]=z;h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,5,0)|0;i=d;c[i>>2]=h;c[i+4>>2]=z}return}function az(a){a=a|0;var b=0,d=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;d=i;g=a+8|0;b=c[g>>2]|0;f=a+12|0;a:do if((b|0)<(c[f>>2]|0))h=6;else{c[d>>2]=c[a>>2];c[d+4>>2]=a+24;c[d+8>>2]=2048;b=na(220,d|0)|0;if((b|0)>=1){c[f>>2]=b;c[g>>2]=0;b=0;h=6;break}switch(b|0){case 0:case -2:{b=0;break a}default:{}}c[12784]=0-b;b=0}while(0);if((h|0)==6){h=a+24+b|0;c[g>>2]=(e[h+8>>1]|0)+b;c[a+4>>2]=c[h+4>>2];b=h}l=i;return b|0}function bz(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+32|0;e=i;f=c[a>>2]|0;j=(c[a+4>>2]|0)-f|0;g=j>>1;h=g+1|0;if((j|0)<-2)uaa();else{j=(c[a+8>>2]|0)-f|0;TF(e,j>>1>>>0<1073741823?(j>>>0<h>>>0?h:j):2147483647,g,a+8|0);j=e+8|0;h=c[j>>2]|0;b[h>>1]=b[d>>1]|0;c[j>>2]=h+2;$A(a,e);yS(e);l=i;return}}function cz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;f=l;l=l+16|0;d=f;e=a[(c[b+544>>2]|0)+((c[b+612>>2]|0)+3)>>0]|0;g=b+528|0;h=g;h=z0(c[h>>2]|0,c[h+4>>2]|0,4,0)|0;c[g>>2]=h;c[g+4>>2]=z;if(jr(b)|0){TX(d);ex(d,e)|0;BZ(c[b+508>>2]|0,c[b+668>>2]|0,e&255,0);z5(d)}else c3(c[b+508>>2]|0,c[b+668>>2]|0);l=f;return}function dz(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+6|0;e=j;f=j+4|0;HB(a,h);g=a+760|0;h=b[h>>1]|0;d=0;while(1){if((d&65535)>=(h&65535))break;GC(a);HB(a,f);bD(a,e);J3(a);i=(sF(g,f)|0)+32|0;if(!(c[i>>2]|0))c[i>>2]=c[e>>2];d=d+1<<16>>16}l=j;return}function ez(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;f=a+4|0;g=b+4|0;d=c[f>>2]|0;while(1){if((d|0)==(e|0))break;h=d+-16|0;m0((c[g>>2]|0)+-16|0,h);c[g>>2]=(c[g>>2]|0)+-16;d=h}e=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=e;e=b+8|0;h=c[f>>2]|0;c[f>>2]=c[e>>2];c[e>>2]=h;e=a+8|0;h=b+12|0;f=c[e>>2]|0;c[e>>2]=c[h>>2];c[h>>2]=f;c[b>>2]=c[g>>2];return}function fz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;g=ZW(40)|0;c[b>>2]=g;c[b+4>>2]=d+4;f=b+8|0;a[f>>0]=0;b=g+16|0;d=c[e>>2]|0;c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}TX(g+28|0);a[f>>0]=1;return}function gz(a){a=a|0;if(!a)return;else{gz(c[a>>2]|0);gz(c[a+4>>2]|0);z5(a+16|0);laa(a);return}}function hz(b){b=b|0;var d=0,e=0;if(!(c[b+728>>2]&1)){W5(b);RB(b,0,0,57,378046,-1,1,0)}if((a[b+908>>0]|0)==0?(d=b+864|0,e=d,(c[e>>2]|0)==-1?(c[e+4>>2]|0)==-1:0):0){e=b+48|0;e=z0(c[b+612>>2]|0,0,c[e>>2]|0,c[e+4>>2]|0)|0;b=b+656|0;b=D_(e|0,z|0,c[b>>2]|0,c[b+4>>2]|0)|0;e=d;c[e>>2]=b;c[e+4>>2]=z}else{e=HN(b,0)|0;e1(b,e,z)}return}function iz(a){a=a|0;if(!a)return;else{iz(c[a>>2]|0);iz(c[a+4>>2]|0);FY(a+16|0);laa(a);return}}function jz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+32|0;e=i;f=c[b>>2]|0;g=(c[b+4>>2]|0)-f|0;h=g+1|0;if((h|0)<0)uaa();else{j=(c[b+8>>2]|0)-f|0;f=j<<1;eR(e,j>>>0<1073741823?(f>>>0<h>>>0?h:f):2147483647,g,b+8|0);h=e+8|0;g=c[h>>2]|0;a[g>>0]=a[d>>0]|0;c[h>>2]=g+1;mB(b,e);WT(e);l=i;return}}function kz(a){a=a|0;if(!a)return;else{kz(c[a>>2]|0);kz(c[a+4>>2]|0);t_(a+16|0);laa(a);return}}function lz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=c[a+612>>2]|0;e=a+536|0;d=c[e>>2]|0;e=c[e+4>>2]|0;i=z0(g|0,0,d|0,e|0)|0;j=z;f=c[a+548>>2]|0;b=a+528|0;h=c[b>>2]|0;b=c[b+4>>2]|0;if(j>>>0>0|(j|0)==0&i>>>0>f>>>0){b=z0(h|0,b|0,g|0,0)|0;j=z;if(j>>>0>0|(j|0)==0&b>>>0>f>>>0)b=0;else b=f-b|0}else b=D_(d|0,e|0,h|0,b|0)|0;j=c[a+652>>2]|0;ob[c[(c[j>>2]|0)+8>>2]&3](j,(c[a+544>>2]|0)+g+h|0,b);return}function mz(b){b=b|0;var e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i;GC(b);e=0;while(1){h=e&65535;if(!(a[368329+(h<<1)+1>>0]|0)){e=6;break}AT(b,f);g=d[(d[f>>0]|0)+(368329+(h<<1))>>0]|0;if((g+e&65535)>>>0>240){e=4;break}e=g+h|0}if((e|0)==4){h=c[b+648>>2]|0;G4(h,Z9(c[h+4>>2]|0)|0);J3(b)}else if((e|0)==6)J3(b);l=i;return}function nz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;d=l;l=l+16|0;b=d;TX(b);g=a+528|0;f=g;f=z0(c[f>>2]|0,c[f+4>>2]|0,12,0)|0;e=z;c[g>>2]=f;c[g+4>>2]=e;g=a+536|0;e=D_(c[g>>2]|0,c[g+4>>2]|0,f|0,e|0)|0;jZ(a,e,z,b);if(qO(a)|0)k1(bF(a+916|0,a+788|0)|0,b)|0;z5(b);l=d;return}function oz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=a+528|0;g=d;e=c[g>>2]|0;g=z0(e|0,c[g+4>>2]|0,8,0)|0;i=z;f=a+536|0;h=c[f+4>>2]|0;if(i>>>0>h>>>0|((i|0)==(h|0)?g>>>0>(c[f>>2]|0)>>>0:0)){vt(a);i=b;c[i>>2]=0;c[i+4>>2]=0}else{i=f8((c[a+544>>2]|0)+(c[a+612>>2]|0)+e|0)|0;h=b;c[h>>2]=i;c[h+4>>2]=z;h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,8,0)|0;i=d;c[i>>2]=h;c[i+4>>2]=z}return}function pz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;if(b|0){g=a+48|0;g=z0(c[a+612>>2]|0,0,c[g>>2]|0,c[g+4>>2]|0)|0;d=a+536|0;e=d;e=z0(g|0,z|0,c[e>>2]|0,c[e+4>>2]|0)|0;g=z;a=a+40|0;f=c[a+4>>2]|0;if(!(g>>>0<f>>>0|((g|0)==(f|0)?e>>>0<(c[a>>2]|0)>>>0:0))){f=d;c[f>>2]=0;c[f+4>>2]=0;f=b+40|0;g=b+48|0;g=D_(c[f>>2]|0,c[f+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0)|0;c[b+612>>2]=g}wk(b)}return}function qz(a){a=a|0;var b=0;e1(a,8,0);GC(a);b=jF(a+760|0,a+772|0)|0;rB(a,c[c[b>>2]>>2]|0);iA(a,c[c[b>>2]>>2]|0,0);G2(a,c[c[b>>2]>>2]|0);Gb(a,c[c[b>>2]>>2]|0,c[a+16>>2]|0,0,c[a+20>>2]|0,1)|0;J3(a);return}function rz(b){b=b|0;var d=0,e=0;d=b+916|0;e=d+11|0;if((a[e>>0]|0)<0){J7(c[d>>2]|0,0);c[b+920>>2]=0}else{J7(d,0);a[e>>0]=0}d=b+928|0;e=d+11|0;if((a[e>>0]|0)<0){J7(c[d>>2]|0,0);c[b+932>>2]=0}else{J7(d,0);a[e>>0]=0}d=b+940|0;e=d+11|0;if((a[e>>0]|0)<0){J7(c[d>>2]|0,0);c[b+944>>2]=0}else{J7(d,0);a[e>>0]=0}return}function sz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;f=a+4|0;g=b+4|0;d=c[f>>2]|0;while(1){if((d|0)==(e|0))break;h=d+-56|0;Iw((c[g>>2]|0)+-56|0,h);c[g>>2]=(c[g>>2]|0)+-56;d=h}e=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=e;e=b+8|0;h=c[f>>2]|0;c[f>>2]=c[e>>2];c[e>>2]=h;e=a+8|0;h=b+12|0;f=c[e>>2]|0;c[e>>2]=c[h>>2];c[h>>2]=f;c[b>>2]=c[g>>2];return}function tz(a){a=a|0;if(!a)return;else{tz(c[a>>2]|0);tz(c[a+4>>2]|0);qZ(a+16|0);laa(a);return}}function uz(a){a=a|0;if(!a)return;else{uz(c[a>>2]|0);uz(c[a+4>>2]|0);EX(a+16|0);laa(a);return}}function vz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;do if((c[b+64>>2]|0)!=0?(g=b+12|0,f=c[g>>2]|0,(c[b+8>>2]|0)>>>0<f>>>0):0){if(d8(d,-1)|0){c[g>>2]=f+-1;d=e3(d)|0;break}if(!(c[b+88>>2]&16)){e=e9(d)|0;b=f+-1|0;if(!(C6(e,a[b>>0]|0)|0)){d=-1;break}}else{e=e9(d)|0;b=f+-1|0}c[g>>2]=b;a[b>>0]=e}else d=-1;while(0);return d|0}function wz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;if((a[d+11>>0]|0)<0){e=c[d>>2]|0;d=c[d+4>>2]|0;if(d>>>0>4294967279)uaa();if(d>>>0<11)a[b+11>>0]=d;else{g=d+16&-16;f=ZW(g)|0;c[b>>2]=f;c[b+8>>2]=g|-2147483648;c[b+4>>2]=d;b=f}i1(b,e,d)|0;J7(b+d|0,0)}else{c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2]}return}function xz(b){b=b|0;var d=0;a:do if(!(a[b+784>>0]|0))Qd(b);else{if(!(a[b+785>>0]|0)){ux(b);break}switch(c[b+520>>2]&127){case 3:case 1:{ku(b);break a}case 8:case 5:case 2:case 0:{ux(b);break a}default:{d=b+536|0;e1(b,c[d>>2]|0,c[d+4>>2]|0);V5(b);break a}}}while(0);return}function yz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;g=j;if((a|0)==(b|0)){c[d>>2]=4;e=0;a=0}else{h=c[12784]|0;c[12784]=0;b0()|0;a=R6(a,g,e)|0;e=z;f=c[12784]|0;if(!f)c[12784]=h;if((c[g>>2]|0)==(b|0)){b=(e|0)>0|(e|0)==0&a>>>0>0;if((f|0)==34){a=b?-1:0;e=b?2147483647:-2147483648;i=6}}else{a=0;e=0;i=6}if((i|0)==6)c[d>>2]=4}z=e;l=j;return a|0}function zz(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;if((-17-d|0)>>>0<e>>>0)uaa();if((a[b+11>>0]|0)<0)j=c[b>>2]|0;else j=b;if(d>>>0<2147483623){h=e+d|0;i=d<<1;h=h>>>0<i>>>0?i:h;h=h>>>0<11?11:h+16&-16}else h=-17;i=ZW(h)|0;if(g|0)i1(i,j,g)|0;e=f-g|0;if(e|0)i1(i+g|0,j+g|0,e)|0;if((d|0)!=10)laa(j);c[b>>2]=i;c[b+8>>2]=h|-2147483648;return}function Az(a){a=a|0;bT(a+88|0);bU(a+52|0);RX(a+40|0);IT(a+28|0);IT(a+16|0);IT(a+4|0);return}function Bz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;f=a+4|0;g=b+4|0;d=c[f>>2]|0;while(1){if((d|0)==(e|0))break;h=d+-40|0;yw((c[g>>2]|0)+-40|0,h);c[g>>2]=(c[g>>2]|0)+-40;d=h}e=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=e;e=b+8|0;h=c[f>>2]|0;c[f>>2]=c[e>>2];c[e>>2]=h;e=a+8|0;h=b+12|0;f=c[e>>2]|0;c[e>>2]=c[h>>2];c[h>>2]=f;c[b>>2]=c[g>>2];return}function Cz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;i=b+24|0;j=b+28|0;f=0;while(1){if((f|0)>=(e|0))break;g=c[i>>2]|0;h=c[j>>2]|0;if(g>>>0<h>>>0){h=h-g|0;k=e-f|0;h=(k|0)<(h|0)?k:h;i1(g,d,h)|0;c[i>>2]=(c[i>>2]|0)+h;d=d+h|0;f=h+f|0;continue}h=c[(c[b>>2]|0)+52>>2]|0;k=e9(a[d>>0]|0)|0;if((tb[h&31](b,k)|0)==-1)break;d=d+1|0;f=f+1|0}return f|0}function Dz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=l;l=l+16|0;b=f;c[b>>2]=-1;d=a+528|0;e=a+536|0;while(1){h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,1,0)|0;j=z;g=e;i=c[g+4>>2]|0;if(!(j>>>0<i>>>0|((j|0)==(i|0)?h>>>0<(c[g>>2]|0)>>>0:0)))break;GC(a);Rk(a,b);J3(a)}Bx(a);KS(a);wK(a);l=f;return}function Ez(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+648|0;e=c[g>>2]|0;d=c[e+4>>2]|0;do if(raa(d)|0){f=0;while(1){if(!d)break;if(NF(e)|0)break;e=c[g>>2]|0;f=f+1<<24>>24;d=c[e+4>>2]|0}if((f&255)<33){a=(~~+gaa(f&255)>>>0)+-1|0;c[b>>2]=a+(tn(c[g>>2]|0,f)|0);break}else{vt(a);break}}else{vt(a);c[b>>2]=0}while(0);return}function Fz(a){a=a|0;do switch(a<<24>>24){case 44:{a=380803;break}case 66:{a=380794;break}case 77:{a=383821;break}case 83:{a=380776;break}case 86:{a=380762;break}case 88:{a=380753;break}case 100:{a=382668;break}case 110:{a=380745;break}case 118:{a=380730;break}case 122:{a=380719;break}case -128:{a=380707;break}case -118:{a=380686;break}case -112:{a=380675;break}case -12:{a=380653;break}default:a=8800948}while(0);return a|0}function Gz(b){b=b|0;var d=0,e=0,f=0,g=0;d=a[b+8+3>>0]|0;g=d<<24>>24<0;d=d&255;e=b+4|0;if(g)f=c[e>>2]|0;else f=d;a:do if(!f)d=0;else{if(g)f=c[e>>2]|0;else f=d;e=0;while(1){if(e>>>0>=f>>>0){d=1;break a}if(g)d=c[b>>2]|0;else d=b;if((c[d+(e<<2)>>2]|0)<48){d=0;break a}if(g)d=c[b>>2]|0;else d=b;if((c[d+(e<<2)>>2]|0)>57){d=0;break}else e=e+1|0}}while(0);return d|0}function Hz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;f=l;l=l+16|0;b=f;c[b>>2]=-1;d=a+528|0;e=a+536|0;while(1){h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,1,0)|0;j=z;g=e;i=c[g+4>>2]|0;if(!(j>>>0<i>>>0|((j|0)==(i|0)?h>>>0<(c[g>>2]|0)>>>0:0)))break;GC(a);Ol(a,b);J3(a)}Bx(a);KS(a);wK(a);l=f;return}function Iz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=l;l=l+48|0;d=g+24|0;e=g;f=g+12|0;VU(d,b);c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[f+(b<<2)>>2]=0;b=b+1|0}TU(e,c[a>>2]|0,d,f);_E(e);O0(e);O0(f);z5(d);l=g;return}function Jz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=l;l=l+16|0;f=e;TX(b);g=d;bk(b,c[g>>2]|0,c[g+4>>2]|0,10)|0;HX(b,28020)|0;oT(f,c[d>>2]|0,c[d+4>>2]|0,16);d=a[f+8+3>>0]|0;g=d<<24>>24<0;Ex(b,g?c[f>>2]|0:f,g?c[f+4>>2]|0:d&255)|0;z5(f);HX(b,39944)|0;l=e;return}function Kz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;f=l;l=l+16|0;e=f;bD(a,e);d=a+528|0;e=c[e>>2]|0;b=0;while(1){if((b|0)==(e|0))break;GC(a);g=d;g=z0(c[g>>2]|0,c[g+4>>2]|0,8,0)|0;h=d;c[h>>2]=g;c[h+4>>2]=z;KK(a);h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,12,0)|0;g=d;c[g>>2]=h;c[g+4>>2]=z;J3(a);b=b+1|0}l=f;return}function Lz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;g=a+4|0;h=b+4|0;f=(c[g>>2]|0)-e|0;d=(c[h>>2]|0)+(((f|0)/-24|0)*24|0)|0;c[h>>2]=d;if((f|0)>0){no(d|0,e|0,f|0)|0;d=c[h>>2]|0}f=c[a>>2]|0;c[a>>2]=d;c[h>>2]=f;f=b+8|0;e=c[g>>2]|0;c[g>>2]=c[f>>2];c[f>>2]=e;f=a+8|0;g=b+12|0;a=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=a;c[b>>2]=c[h>>2];return}function Mz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;i=b+12|0;j=b+16|0;h=0;while(1){if((h|0)>=(e|0))break;f=c[i>>2]|0;g=c[j>>2]|0;if(f>>>0<g>>>0){g=g-f|0;k=e-h|0;g=(k|0)<(g|0)?k:g;i1(d,f,g)|0;c[i>>2]=(c[i>>2]|0)+g;d=d+g|0;h=g+h|0;continue}f=nb[c[(c[b>>2]|0)+40>>2]&255](b)|0;if((f|0)==-1)break;a[d>>0]=e9(f)|0;d=d+1|0;h=h+1|0}return h|0}function Nz(a){a=a|0;if(!a)return;else{Nz(c[a>>2]|0);Nz(c[a+4>>2]|0);A$(a+16|0);laa(a);return}}function Oz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=a+4|0;f=(c[j>>2]|0)!=375;e=c[a>>2]|0;h=(c[d>>2]|0)-e|0;h=h>>>0<2147483647?h<<1:-1;h=(h|0)==0?4:h;i=(c[b>>2]|0)-e>>2;e=XG(f?e:0,h)|0;if(!e)uaa();g=e;if(!f){f=c[a>>2]|0;c[a>>2]=g;if(f){jb[c[j>>2]&511](f);e=c[a>>2]|0}}else c[a>>2]=g;c[j>>2]=376;c[b>>2]=e+(i<<2);c[d>>2]=(c[a>>2]|0)+(h>>>2<<2);return}function Pz(a,b){a=a|0;b=b|0;do switch(b|0){case 1:{a=q4(a)|0;break}case 2:{a=fZ(a)|0;break}case 3:{a=faa(a)|0;break}case 4:{a=_2(a)|0;break}case 5:{a=R9(a)|0;break}case 6:{a=p4(a)|0;break}case 7:{a=F9(a)|0;break}case 8:{a=YU(a)|0;break}case 9:{a=O_(a)|0;break}case 10:{a=D5(a)|0;break}case 11:{a=E9(a)|0;break}case 12:{a=G7(a)|0;break}default:a=0}while(0);return a|0}function Qz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;f=a+4|0;g=b+4|0;d=c[f>>2]|0;while(1){if((d|0)==(e|0))break;h=d+-12|0;rV((c[g>>2]|0)+-12|0,h);c[g>>2]=(c[g>>2]|0)+-12;d=h}e=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=e;e=b+8|0;h=c[f>>2]|0;c[f>>2]=c[e>>2];c[e>>2]=h;e=a+8|0;h=b+12|0;f=c[e>>2]|0;c[e>>2]=c[h>>2];c[h>>2]=f;c[b>>2]=c[g>>2];return}function Rz(a){a=a|0;var b=0;if(qO(a)|0){lJ(a);c[a+788>>2]=-1;b=a+792|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;Kc(a,7,-1)|0;KD(a+916|0,-1);b=a+912|0;lL(a,c[a+16>>2]|0,c[a+20>>2]|0,7,c[b>>2]|0,10,0);c[b>>2]=(c[b>>2]|0)+1}return}function Sz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=e+74|0;g=a[f>>0]|0;a[f>>0]=g+255|g;f=e+4|0;g=c[f>>2]|0;i=(c[e+8>>2]|0)-g|0;h=i>>>0<d>>>0?i:d;if((i|0)>0){no(b|0,g|0,h|0)|0;c[f>>2]=g+h;f=d-h|0;b=b+h|0}else f=d;a:do if(f|0){h=e+32|0;while(1){if(QF(e)|0)break;g=gb[c[h>>2]&31](e,b,f)|0;if((g+1|0)>>>0<2)break;f=f-g|0;if(!f)break a;else b=b+g|0}return d-f|0}while(0);return d|0}function Tz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;g=l;l=l+16|0;b=g+4|0;e=g;ID(a,b);ID(a,e);if((c[a+784>>2]|0)>>>0<=1?qO(a)|0:0){b=c[b>>2]|0;f=a+20|0;d=a+16|0;if(b|0)fM(a,c[d>>2]|0,c[f>>2]|0,384534,b,0);b=c[e>>2]|0;if(b|0)fM(a,c[d>>2]|0,c[f>>2]|0,387665,b,0)}l=g;return}function Uz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;e=l;l=l+32|0;b=e+12|0;d=e;TX(b);TX(d);$c(a,b,d);if(qO(a)|0){g=a+16|0;f=a+20|0;Mc(a,c[g>>2]|0,c[f>>2]|0,381019,b,0);Mc(a,c[g>>2]|0,c[f>>2]|0,381051,d,0)}z5(d);z5(b);l=e;return}function Vz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=l;l=l+16|0;h=g;O4(h,b);b=c[h>>2]|0;i=u$(b,409148)|0;rb[c[(c[i>>2]|0)+48>>2]&7](i,401970,402002,d)|0;d=u$(b,409156)|0;c[e>>2]=nb[c[(c[d>>2]|0)+12>>2]&255](d)|0;c[f>>2]=nb[c[(c[d>>2]|0)+16>>2]&255](d)|0;kb[c[(c[d>>2]|0)+20>>2]&63](a,d);c6(h);l=g;return}function Wz(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);if(qO(a)|0?(c[a+16>>2]|0)!=3:0){Kc(a,3,-1)|0;e=a+916|0;d=a+788|0;c[(bF(e,d)|0)+44>>2]=3;a=c[a+20>>2]|0;c[(bF(e,d)|0)+48>>2]=a}l=b;return}function Xz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;if(a){c[a+24>>2]=0;d=a+32|0;b=c[d>>2]|0;g=a+40|0;if(!b){c[d>>2]=24;c[g>>2]=0;b=24}f=a+36|0;if(!(c[f>>2]|0))c[f>>2]=38;d=gb[b&31](c[g>>2]|0,1,7120)|0;if(d){e=a+28|0;c[e>>2]=d;c[d>>2]=a;c[d+56>>2]=0;c[d+4>>2]=16180;b=QL(a)|0;if(!b)b=0;else{kb[c[f>>2]&63](c[g>>2]|0,d);c[e>>2]=0}}else b=-4}else b=-2;return b|0}function Yz(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=l;l=l+16|0;i=h;O4(i,d);d=c[i>>2]|0;j=u$(d,409116)|0;rb[c[(c[j>>2]|0)+32>>2]&7](j,401970,402002,e)|0;e=u$(d,409132)|0;a[f>>0]=nb[c[(c[e>>2]|0)+12>>2]&255](e)|0;a[g>>0]=nb[c[(c[e>>2]|0)+16>>2]&255](e)|0;kb[c[(c[e>>2]|0)+20>>2]&63](b,e);c6(i);l=h;return}function Zz(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+128|0;k=h+16|0;m=h+12|0;i=h;j=h+8|0;c[m>>2]=k+100;oF(a,k,m,e,f,g);e=i;c[e>>2]=0;c[e+4>>2]=0;c[j>>2]=k;e=I7(b,c[d>>2]|0)|0;a=a0(c[a>>2]|0)|0;e=zf(b,j,e,i)|0;if(a|0)a0(a)|0;if((e|0)==-1)uaa();else{c[d>>2]=b+(e<<2);l=h;return}}function _z(b){b=b|0;var d=0;Eg(b);c[b>>2]=35308;c[b+772>>2]=0;c[b+776>>2]=0;c[b+780>>2]=0;TX(b+912|0);TX(b+924|0);TX(b+936|0);TX(b+948|0);TX(b+960|0);TX(b+972|0);xA(b+984|0);c[b+504>>2]=2;a[b+733>>0]=1;d=b+632|0;c[d>>2]=65536;c[d+4>>2]=0;a[b+96>>0]=1;a[b+493>>0]=1;d=b+760|0;c[d>>2]=0;c[d+4>>2]=0;a[b+768>>0]=0;a[b+905>>0]=0;a[b+909>>0]=0;return}function $z(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;e=l;l=l+16|0;f=e;d=b+528|0;h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,4,0)|0;g=d;c[g>>2]=h;c[g+4>>2]=z;bB(b,f);switch(a[f>>0]|0){case 3:{gV(b);break}case 6:{gV(b);break}default:{g=b+536|0;h=d;e1(b,D_(c[g>>2]|0,c[g+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0)|0,z)}}l=e;return}function aA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;h=a+24|0;i=a+28|0;e=0;while(1){if((e|0)>=(d|0))break;f=c[h>>2]|0;g=c[i>>2]|0;if(f>>>0<g>>>0){g=g-f>>2;j=d-e|0;g=(j|0)<(g|0)?j:g;a3(f,b,g);c[h>>2]=(c[h>>2]|0)+(g<<2);b=b+(g<<2)|0;e=g+e|0;continue}g=c[(c[a>>2]|0)+52>>2]|0;j=raa(c[b>>2]|0)|0;if((tb[g&31](a,j)|0)==-1)break;b=b+4|0;e=e+1|0}return e|0}function bA(a){a=a|0;var b=0;GC(a);b=a+648|0;d4(c[b>>2]|0,5);G4(c[b>>2]|0,18);A6(c[b>>2]|0);A6(c[b>>2]|0);A6(c[b>>2]|0);A6(c[b>>2]|0);A6(c[b>>2]|0);A6(c[b>>2]|0);A6(c[b>>2]|0);J3(a);return}function cA(a){a=a|0;if(!a)return;else{cA(c[a>>2]|0);cA(c[a+4>>2]|0);Q$(a+16|0);laa(a);return}}function dA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;g=a+4|0;h=b+4|0;f=(c[g>>2]|0)-e|0;d=(c[h>>2]|0)+(((f|0)/-3|0)*3|0)|0;c[h>>2]=d;if((f|0)>0){no(d|0,e|0,f|0)|0;d=c[h>>2]|0}f=c[a>>2]|0;c[a>>2]=d;c[h>>2]=f;f=b+8|0;e=c[g>>2]|0;c[g>>2]=c[f>>2];c[f>>2]=e;f=a+8|0;g=b+12|0;a=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=a;c[b>>2]=c[h>>2];return}function eA(a,b,c){a=a|0;b=b|0;c=c|0;p2(a,c);b=b&65535;c=0;while(1){if((c|0)==16)break;a:do if(1<<15-c&b|0)switch((c&255)<<24>>24){case 5:{HX(a,13232)|0;break a}case 6:{HX(a,13260)|0;break a}case 7:{HX(a,13296)|0;break a}default:break a}while(0);c=c+1|0}return}function fA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;GC(a);e=a+528|0;f=e;f=z0(c[f>>2]|0,c[f+4>>2]|0,2,0)|0;d=e;c[d>>2]=f;c[d+4>>2]=z;d=b&65535;b=2;while(1){b=b&65535;if(b>>>0>=d>>>0)break;GC(a);g=e;g=z0(c[g>>2]|0,c[g+4>>2]|0,8,0)|0;f=e;c[f>>2]=g;c[f+4>>2]=z;J3(a);b=b+8|0}J3(a);return}function gA(a){a=a|0;if(!a)return;else{gA(c[a>>2]|0);gA(c[a+4>>2]|0);V$(a+16|0);laa(a);return}}function hA(a){a=a|0;var b=0,f=0,g=0,h=0;h=l;l=l+16|0;b=h;bB(a,a+931|0);f=c[a+936>>2]|0;g=a+932|0;switch(f|0){case 1:break;case 2:{bB(a,b);c[g>>2]=d[b>>0];break}case 3:{HB(a,b);c[g>>2]=e[b>>1];break}case 4:{gB(a,g);break}case 5:{bD(a,g);break}default:e1(a,f,0)}l=h;return}function iA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=a+528|0;e=g;f=c[e>>2]|0;e=c[e+4>>2]|0;i=z0(f|0,e|0,d|0,0)|0;k=z;h=a+536|0;j=c[h+4>>2]|0;if(!(k>>>0>j>>>0|((k|0)==(j|0)?i>>>0>(c[h>>2]|0)>>>0:0))){Sc(a,b,(c[a+544>>2]|0)+(c[a+612>>2]|0)+f|0,d,1);e=g;f=c[e>>2]|0;e=c[e+4>>2]|0}j=z0(f|0,e|0,d|0,0)|0;k=g;c[k>>2]=j;c[k+4>>2]=z;return}function jA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;h=a+12|0;i=a+16|0;g=0;while(1){if((g|0)>=(d|0))break;e=c[h>>2]|0;f=c[i>>2]|0;if(e>>>0<f>>>0){f=f-e>>2;j=d-g|0;f=(j|0)<(f|0)?j:f;a3(b,e,f);c[h>>2]=(c[h>>2]|0)+(f<<2);b=b+(f<<2)|0;g=f+g|0;continue}e=nb[c[(c[a>>2]|0)+40>>2]&255](a)|0;if((e|0)==-1)break;c[b>>2]=raa(e)|0;b=b+4|0;g=g+1|0}return g|0}function kA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=l;l=l+16|0;i=h;g=b+4|0;c[g>>2]=0;RH(i,b);f=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;if(a[i>>0]|0){i=c[f+24>>2]|0;i=gb[c[(c[i>>2]|0)+32>>2]&31](i,d,e)|0;c[g>>2]=i;if((i|0)!=(e|0)){i=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(i,c[i+16>>2]|6)}}else C4(f,c[f+16>>2]|4);l=h;return b|0}function lA(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;h=ZW(92)|0;c[d>>2]=h;c[d+4>>2]=e+4;g=d+8|0;b[h+16>>1]=b[c[f>>2]>>1]|0;d=h+20|0;e=d;f=e+72|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));_U(d);a[g>>0]=1;return}function mA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=a+4|0;f=(c[j>>2]|0)!=375;e=c[a>>2]|0;h=(c[d>>2]|0)-e|0;h=h>>>0<2147483647?h<<1:-1;h=(h|0)==0?1:h;i=(c[b>>2]|0)-e|0;e=XG(f?e:0,h)|0;if(!e)uaa();g=e;if(!f){f=c[a>>2]|0;c[a>>2]=g;if(f){jb[c[j>>2]&511](f);e=c[a>>2]|0}}else c[a>>2]=g;c[j>>2]=376;c[b>>2]=e+i;c[d>>2]=(c[a>>2]|0)+h;return}function nA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=b+648|0;e=0;f=0;a:while(1){c[d>>2]=f;f=a[38476+(f<<3)+4>>0]|0;switch(f<<24>>24){case -1:{h=3;break a}case 1:{e=(NF(c[g>>2]|0)|0)&1|e<<1;break}case 0:break;default:e=(my(c[g>>2]|0,f)|0)&255|e<<(f&255)}f=c[d>>2]|0;if((e|0)==(c[38476+(f<<3)>>2]|0))break;else f=f+1|0}if((h|0)==3)vt(b);return}function oA(a){a=a|0;if(!a)return;else{oA(c[a>>2]|0);oA(c[a+4>>2]|0);f0(a+16|0);laa(a);return}}function pA(b){b=b|0;var d=0,e=0,f=0,g=0;f=l;l=l+16|0;g=f;GC(b);AT(b,g);d=b+648|0;A6(c[d>>2]|0);A6(c[d>>2]|0);e=c[d>>2]|0;if(!(a[g>>0]|0)){d4(e,5);d4(c[d>>2]|0,2);A6(c[d>>2]|0)}else d4(e,3);J3(b);l=f;return}function qA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;g=a+4|0;f=a+8|0;e=0;while(1){if((e|0)==7)break;b=c[c[g>>2]>>2]|0;a=c[b+(e*12|0)>>2]|0;b=b+(e*12|0)+4|0;while(1){d=c[b>>2]|0;if((d|0)==(a|0))break;d=d+-40|0;c[b>>2]=d;$_(d)}b=c[c[f>>2]>>2]|0;a=c[b+(e*12|0)>>2]|0;b=b+(e*12|0)+4|0;while(1){d=c[b>>2]|0;if((d|0)==(a|0))break;d=d+-56|0;c[b>>2]=d;LT(d)}e=e+1|0}return}function rA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;g=a+4|0;h=b+4|0;f=(c[g>>2]|0)-e|0;d=(c[h>>2]|0)+(0-(f>>5)<<5)|0;c[h>>2]=d;if((f|0)>0){no(d|0,e|0,f|0)|0;d=c[h>>2]|0}f=c[a>>2]|0;c[a>>2]=d;c[h>>2]=f;f=b+8|0;e=c[g>>2]|0;c[g>>2]=c[f>>2];c[f>>2]=e;f=a+8|0;g=b+12|0;a=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=a;c[b>>2]=c[h>>2];return}function sA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;g=a+4|0;h=b+4|0;f=(c[g>>2]|0)-e|0;d=(c[h>>2]|0)+(0-(f>>4)<<4)|0;c[h>>2]=d;if((f|0)>0){no(d|0,e|0,f|0)|0;d=c[h>>2]|0}f=c[a>>2]|0;c[a>>2]=d;c[h>>2]=f;f=b+8|0;e=c[g>>2]|0;c[g>>2]=c[f>>2];c[f>>2]=e;f=a+8|0;g=b+12|0;a=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=a;c[b>>2]=c[h>>2];return}function tA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;f=a+968|0;e=c[f>>2]|0;f=c[f+4>>2]|0;d=a+48|0;b=c[d>>2]|0;d=c[d+4>>2]|0;if(f>>>0>d>>>0|(f|0)==(d|0)&e>>>0>b>>>0){d=D_(e|0,f|0,b|0,d|0)|0;b=z;e=a+536|0;g=e;f=c[g>>2]|0;g=c[g+4>>2]|0;if(g>>>0>b>>>0|(g|0)==(b|0)&f>>>0>d>>>0){g=e;c[g>>2]=d;c[g+4>>2]=b}else{d=f;b=g}g=a+528|0;c[g>>2]=d;c[g+4>>2]=b;Ak(a)}return}function uA(a){a=a|0;if(!a)return;else{uA(c[a>>2]|0);uA(c[a+4>>2]|0);g0(a+16|0);laa(a);return}}function vA(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;f=l;l=l+16|0;e=f;Bx(b);sR(b,12,f+12|0);xR(b,4,f+14|0);wK(b);d=z0(c|0,d|0,-2,-1)|0;e1(b,d,z);if(qO(b)|0){a[b+821>>0]=14;VU(e,372218);vF(b+792|0,e)|0;z5(e);PU(b+836|0,2)|0}l=f;return}function wA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;f=l;l=l+32|0;d=f;e=c[a>>2]|0;if((((c[a+8>>2]|0)-e|0)/24|0)>>>0<b>>>0){zD(d,b,((c[a+4>>2]|0)-e|0)/24|0,a+8|0);Lz(a,d);rP(d)}l=f;return}function xA(a){a=a|0;var b=0,d=0,e=0;e=l;l=l+16|0;d=e;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;do{TX(a+12+(b*12|0)|0);b=b+1|0}while((b|0)!=2);b=a+36|0;TX(b);Xy(d,42472);k1(a+12|0,d)|0;z5(d);Xy(d,42436);k1(a+24|0,d)|0;z5(d);Xy(d,42444);k1(b,d)|0;z5(d);c[a+48>>2]=-1;c[a+52>>2]=-1;l=e;return}function yA(a){a=a|0;do switch(a<<24>>24){case 0:{a=386318;break}case 1:{a=386302;break}case 2:{a=386292;break}case 3:{a=386283;break}case 4:{a=386250;break}case 5:{a=386239;break}case 6:{a=386227;break}case 7:{a=386203;break}case 8:{a=386184;break}case 9:{a=386174;break}case 10:{a=386151;break}case 11:{a=386143;break}case 15:{a=385637;break}default:a=391133}while(0);return a|0}function zA(a){a=a|0;do switch(a<<24>>24){case 0:{a=386820;break}case 1:{a=386805;break}case 2:{a=386788;break}case 3:{a=386772;break}case 4:{a=386758;break}case 5:{a=386725;break}case 6:{a=386715;break}case 7:{a=386703;break}case 8:{a=386691;break}case 9:{a=386677;break}case 10:{a=386666;break}case 11:{a=386651;break}case 15:{a=385637;break}default:a=391133}while(0);return a|0}function AA(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;i=j+1|0;f=j;xR(b,4,i);i=a[i>>0]|0;g=i&255;if(i<<24>>24==15){xR(b,8,f);g=g+-1+(d[f>>0]|0)|0}do if(g|0){h=c[b+648>>2]|0;i=Z9(c[h+4>>2]|0)|0;f=g<<3;if(i>>>0<f>>>0){G4(h,i);break}else{tl(b,i-f|0,e);break}}while(0);l=j;return}function BA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;if((e|0)!=0?(j=UW(b|0,d|0,1e3,0)|0,k=z,i=g5(j|0,k|0,e|0,0)|0,h=a,c[h>>2]=i,c[h+4>>2]=z,h=UW(f&255|0,0,b|0,d|0)|0,h=UW(h|0,z|0,g&255|0,0)|0,h=XZ(h|0,z|0,3)|0,i=z,!(0>k>>>0|0==(k|0)&e>>>0>j>>>0)):0){a=a+8|0;c[a>>2]=h;c[a+4>>2]=i;a=(h|0)!=0|(i|0)!=0}else a=0;return a|0}function CA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=l;l=l+16|0;f=d;e=Cr(a,f,b+16|0)|0;HH(a,c[f>>2]|0,e,b);l=d;return}function DA(b){b=b|0;var d=0,e=0;if((a[407816]|0)==0?E3(407816)|0:0){c[102503]=0;c[102504]=0;c[102505]=0;d=i9(55420)|0;if(d>>>0>1073741807)uaa();do if(d>>>0>=2){b=d+4&-4;if(b>>>0>1073741823)ra();else{e=ZW(b<<2)|0;c[102503]=e;c[102505]=b|-2147483648;c[102504]=d;break}}else{a[410023]=d;e=410012}while(0);a3(e,55420,d);y7(e+(d<<2)|0,0)}return 410012}function EA(b){b=b|0;var d=0,e=0;if((a[407824]|0)==0?E3(407824)|0:0){c[102506]=0;c[102507]=0;c[102508]=0;d=i9(55456)|0;if(d>>>0>1073741807)uaa();do if(d>>>0>=2){b=d+4&-4;if(b>>>0>1073741823)ra();else{e=ZW(b<<2)|0;c[102506]=e;c[102508]=b|-2147483648;c[102507]=d;break}}else{a[410035]=d;e=410024}while(0);a3(e,55456,d);y7(e+(d<<2)|0,0)}return 410024}function FA(b){b=b|0;var d=0,e=0;if((a[407832]|0)==0?E3(407832)|0:0){c[102509]=0;c[102510]=0;c[102511]=0;d=i9(55504)|0;if(d>>>0>1073741807)uaa();do if(d>>>0>=2){b=d+4&-4;if(b>>>0>1073741823)ra();else{e=ZW(b<<2)|0;c[102509]=e;c[102511]=b|-2147483648;c[102510]=d;break}}else{a[410047]=d;e=410036}while(0);a3(e,55504,d);y7(e+(d<<2)|0,0)}return 410036}function GA(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,i=0;b=l;l=l+16|0;e=b;g=b+13|0;f=b+12|0;TX(e);h=a+528|0;i=h;i=z0(c[i>>2]|0,c[i+4>>2]|0,3,0)|0;c[h>>2]=i;c[h+4>>2]=z;bB(a,g);e1(a,d[g>>0]|0,0);jZ(a,3,0,e);bB(a,f);iF(a,d[f>>0]|0,0);z5(e);l=b;return}function HA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;i=j;h=e-d>>2;if(h){f=b;if((f-a>>2|0)<(h|0))a=b;else{c[i>>2]=c[d>>2];g=1-h|0;while(1){e=f-a>>2;if((e|0)<(h|0)){a=b;break}a=U_(a,g+e|0,i)|0;if(!a){a=b;break}if(!(L$(a,d,h)|0))break;a=a+4|0}}}l=j;return a|0}function IA(a){a=a|0;var b=0,d=0;Bx(a);Ob(a);CU(a);wK(a);d=a+528|0;b=a+536|0;if(!((c[d>>2]|0)==(c[b>>2]|0)?(c[d+4>>2]|0)==(c[b+4>>2]|0):0))t4(a);a:do if(qO(a)|0){b=1;while(1){if((b&255)>=6)break a;AR(a,b&255,0);b=b+1<<24>>24}}while(0);return}function JA(b){b=b|0;var d=0,e=0;if((a[407808]|0)==0?E3(407808)|0:0){c[102500]=0;c[102501]=0;c[102502]=0;d=i9(55384)|0;if(d>>>0>1073741807)uaa();do if(d>>>0>=2){b=d+4&-4;if(b>>>0>1073741823)ra();else{e=ZW(b<<2)|0;c[102500]=e;c[102502]=b|-2147483648;c[102501]=d;break}}else{a[410011]=d;e=41e4}while(0);a3(e,55384,d);y7(e+(d<<2)|0,0)}return 41e4}function KA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;f=l;l=l+32|0;g=f+16|0;e=f;h=b;c[h>>2]=0;c[h+4>>2]=0;h=b+8|0;c[h>>2]=-1;c[h+4>>2]=-1;RH(g,d);if(a[g>>0]|0){h=c[d+(c[(c[d>>2]|0)+-12>>2]|0)+24>>2]|0;sb[c[(c[h>>2]|0)+16>>2]&15](e,h,0,0,1,8);c[b>>2]=c[e>>2];c[b+4>>2]=c[e+4>>2];c[b+8>>2]=c[e+8>>2];c[b+12>>2]=c[e+12>>2]}l=f;return}function LA(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=b+4|0;i=c[f>>2]|0;j=i&7;g=b+12|0;if(i>>>0<16){c[f>>2]=0;a[b+13>>0]=1;f=0}else{i=c[b>>2]|0;h=16-j|0;if(j){f=(d[g>>0]|0)<<h;if((h+-1|0)>>>0>7)k=5;else g=i}else{f=0;k=5}if((k|0)==5){f=(d[i>>0]|0)<<(h+248&255)|f&65535;g=i+1|0;c[b>>2]=g;h=h+-8|0}k=(d[g>>0]|0)>>>j&(e[57960+((h&255)<<1)>>1]|0);c[b>>2]=i;f=(k|f)&65535}return f|0}function MA(b){b=b|0;var c=0,e=0,f=0,g=0;g=l;l=l+16|0;c=g+2|0;e=g+1|0;f=g;GC(b);xR(b,2,c);if((a[c>>0]|0)==3){xR(b,3,e);a[c>>0]=(d[e>>0]|0)+3}xR(b,5,e);if((a[e>>0]|0)==31){xR(b,7,f);a[e>>0]=(d[f>>0]|0)+31}Wl(b);J3(b);l=g;return}function NA(a){a=a|0;if(!a)return;else{NA(c[a>>2]|0);NA(c[a+4>>2]|0);K0(a+16|0);laa(a);return}}function OA(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;a:do if(Pc(b+760|0)|0){g=b+612|0;h=b+544|0;d=c[b+548>>2]|0;i=c[g>>2]|0;while(1){if((i+2|0)>>>0>d>>>0){d=0;break a}e=(c[h>>2]|0)+i|0;f=a[e>>0]|0;if(f<<24>>24)break;f=i+1|0;c[g>>2]=f;i=f}if(((d7(f,a[e+1>>0]|0)|0)&-10)<<16>>16==-16)d=1;else{a[b+376>>0]=0;d=1}}else d=0;while(0);return d|0}function PA(a){a=a|0;if(!a)return;else{PA(c[a>>2]|0);PA(c[a+4>>2]|0);q0(a+16|0);laa(a);return}}function QA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;e=l;l=l+16|0;b=e;d=a+528|0;g=d;g=z0(c[g>>2]|0,c[g+4>>2]|0,8,0)|0;f=d;c[f>>2]=g;c[f+4>>2]=z;Uy(a,a+920|0);Uy(a,a+928|0);bD(a,b);b=c[b>>2]|0;a=0;while(1){if((a|0)==(b|0))break;f=d;f=z0(c[f>>2]|0,c[f+4>>2]|0,8,0)|0;g=d;c[g>>2]=f;c[g+4>>2]=z;a=a+1|0}l=e;return}function RA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if((b|0)<=6?(e=c[a+4>>2]|0,(e|0)!=0):0){e=c[e>>2]|0;e=((c[e+(b*12|0)+4>>2]|0)-(c[e+(b*12|0)>>2]|0)|0)/40|0;if((d|0)!=-1)if(e>>>0>d>>>0){e=vn(b)|0;b=c[(c[c[a+8>>2]>>2]|0)+(b*12|0)>>2]|0;e=(((c[b+(d*56|0)+4>>2]|0)-(c[b+(d*56|0)>>2]|0)|0)/40|0)+(((c[e+4>>2]|0)-(c[e>>2]|0)|0)/40|0)|0}else e=0}else e=0;return e|0}function SA(a){a=a|0;do switch(a<<24>>24){case 0:{a=383171;break}case 1:{a=383164;break}case 4:{a=383153;break}case 5:{a=383120;break}case 6:{a=383113;break}case 7:{a=383102;break}case 8:{a=383096;break}case 9:{a=383075;break}case 10:{a=383058;break}case 11:{a=383049;break}case 12:{a=383015;break}case 13:{a=382985;break}case 14:{a=382979;break}default:a=8800948}while(0);return a|0}function TA(b){b=b|0;var d=0,e=0;d=c[b+612>>2]|0;a:do if((d+6|0)>>>0>(c[b+548>>2]|0)>>>0)b=0;else{e=c[b+544>>2]|0;b:do if((a[e+d>>0]|0)==0?(a[e+(d+1)>>0]|0)==0:0){switch(a[e+(d+2)>>0]|0){case 1:break;case 0:{if((a[e+(d+3)>>0]|0)!=1)break b;break}default:break b}b=Sp(b)|0;break a}while(0);a[b+376>>0]=0;b=1}while(0);return b|0}function UA(a){a=a|0;var b=0,d=0,e=0,f=0;d=a+536|0;b=c[d>>2]|0;d=c[d+4>>2]|0;e=a+528|0;switch(b|0){case 4:{if(!d){d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,4,0)|0;c[e>>2]=d;c[e+4>>2]=z}else f=6;break}case 8:{if(!d){d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,8,0)|0;c[e>>2]=d;c[e+4>>2]=z}else f=6;break}default:f=6}if((f|0)==6)e1(a,b,d);return}function VA(b){b=b|0;var d=0,e=0;d=c[b+612>>2]|0;a:do if((d+6|0)>>>0>(c[b+548>>2]|0)>>>0)b=0;else{e=c[b+544>>2]|0;b:do if((a[e+d>>0]|0)==0?(a[e+(d+1)>>0]|0)==0:0){switch(a[e+(d+2)>>0]|0){case 1:break;case 0:{if((a[e+(d+3)>>0]|0)!=1)break b;break}default:break b}b=rp(b)|0;break a}while(0);a[b+376>>0]=0;b=1}while(0);return b|0}function WA(d,e){d=d|0;e=e|0;var f=0,g=0,h=0;f=l;l=l+16|0;g=f;TX(d);Ek(d,b[e>>1]|0,10)|0;HX(d,28020)|0;rU(g,b[e>>1]|0,16);e=a[g+8+3>>0]|0;h=e<<24>>24<0;Ex(d,h?c[g>>2]|0:g,h?c[g+4>>2]|0:e&255)|0;z5(g);HX(d,39944)|0;l=f;return}function XA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=l;l=l+16|0;f=e;TX(b);Gk(b,c[d>>2]|0,10)|0;HX(b,28020)|0;sU(f,c[d>>2]|0,16);d=a[f+8+3>>0]|0;g=d<<24>>24<0;Ex(b,g?c[f>>2]|0:f,g?c[f+4>>2]|0:d&255)|0;z5(f);HX(b,39944)|0;l=e;return}function YA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=l;l=l+16|0;f=e;TX(b);Ck(b,a[d>>0]|0,10)|0;HX(b,28020)|0;uU(f,a[d>>0]|0,16);d=a[f+8+3>>0]|0;g=d<<24>>24<0;Ex(b,g?c[f>>2]|0:f,g?c[f+4>>2]|0:d&255)|0;z5(f);HX(b,39944)|0;l=e;return}function ZA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;e=l;l=l+16|0;b=e+4|0;f=a+528|0;g=f;g=z0(c[g>>2]|0,c[g+4>>2]|0,4,0)|0;c[f>>2]=g;c[f+4>>2]=z;ID(a,b);ID(a,e);if((c[a+784>>2]|0)>>>0<=1?(g=qO(a)|0,d=c[b>>2]|0,g&(d|0)!=0):0)fM(a,c[a+16>>2]|0,c[a+20>>2]|0,387665,d,0);l=e;return}function _A(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;g=a+4|0;h=b+4|0;f=(c[g>>2]|0)-e|0;d=(c[h>>2]|0)+(0-(f>>3)<<3)|0;c[h>>2]=d;if((f|0)>0){no(d|0,e|0,f|0)|0;d=c[h>>2]|0}f=c[a>>2]|0;c[a>>2]=d;c[h>>2]=f;f=b+8|0;e=c[g>>2]|0;c[g>>2]=c[f>>2];c[f>>2]=e;f=a+8|0;g=b+12|0;a=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=a;c[b>>2]=c[h>>2];return}function $A(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;g=a+4|0;h=b+4|0;f=(c[g>>2]|0)-e|0;d=(c[h>>2]|0)+(0-(f>>1)<<1)|0;c[h>>2]=d;if((f|0)>0){no(d|0,e|0,f|0)|0;d=c[h>>2]|0}f=c[a>>2]|0;c[a>>2]=d;c[h>>2]=f;f=b+8|0;e=c[g>>2]|0;c[g>>2]=c[f>>2];c[f>>2]=e;f=a+8|0;g=b+12|0;a=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=a;c[b>>2]=c[h>>2];return}function aB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;g=a+4|0;h=b+4|0;f=(c[g>>2]|0)-e|0;d=(c[h>>2]|0)+(0-(f>>2)<<2)|0;c[h>>2]=d;if((f|0)>0){no(d|0,e|0,f|0)|0;d=c[h>>2]|0}f=c[a>>2]|0;c[a>>2]=d;c[h>>2]=f;f=b+8|0;e=c[g>>2]|0;c[g>>2]=c[f>>2];c[f>>2]=e;f=a+8|0;g=b+12|0;a=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=a;c[b>>2]=c[h>>2];return}function bB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=b+528|0;h=e;f=c[h>>2]|0;h=z0(f|0,c[h+4>>2]|0,1,0)|0;j=z;g=b+536|0;i=c[g+4>>2]|0;if(j>>>0>i>>>0|((j|0)==(i|0)?h>>>0>(c[g>>2]|0)>>>0:0)){vt(b);a[d>>0]=0}else{a[d>>0]=Z9(a[(c[b+544>>2]|0)+(c[b+612>>2]|0)+f>>0]|0)|0;i=e;i=z0(c[i>>2]|0,c[i+4>>2]|0,1,0)|0;j=e;c[j>>2]=i;c[j+4>>2]=z}return}function cB(a){a=a|0;if(!a)return;else{cB(c[a>>2]|0);cB(c[a+4>>2]|0);q0(a+16|0);laa(a);return}}function dB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=b+528|0;h=e;f=c[h>>2]|0;h=z0(f|0,c[h+4>>2]|0,1,0)|0;j=z;g=b+536|0;i=c[g+4>>2]|0;if(j>>>0>i>>>0|((j|0)==(i|0)?h>>>0>(c[g>>2]|0)>>>0:0)){vt(b);a[d>>0]=0}else{a[d>>0]=D9(a[(c[b+544>>2]|0)+(c[b+612>>2]|0)+f>>0]|0)|0;i=e;i=z0(c[i>>2]|0,c[i+4>>2]|0,1,0)|0;j=e;c[j>>2]=i;c[j+4>>2]=z}return}function eB(a){a=a|0;var b=0,d=0,e=0,f=0;b=an(a)|0;d=z;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){f=(kE(a+760|0,a+840|0)|0)+72|0;c[f>>2]=b;c[f+4>>2]=d;f=c[a+16>>2]|0;e=c[a+20>>2]|0;xM(a,f,e,382758,dI(b,d)|0,1)}return}function fB(d){d=d|0;var e=0,f=0,g=0;e=l;l=l+16|0;f=e;GC(d);g=d+648|0;A6(c[g>>2]|0);A6(c[g>>2]|0);sR(d,13,e+2|0);sR(d,11,f);xR(d,2,d+2479|0);J3(d);g=qO(d)|0;if(g&(b[f>>1]|0)==2047)a[d+2504>>0]=1;l=e;return}function gB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;f=b+528|0;h=f;g=c[h>>2]|0;h=z0(g|0,c[h+4>>2]|0,3,0)|0;e=z;i=b+536|0;j=c[i+4>>2]|0;if(e>>>0>j>>>0|((e|0)==(j|0)?h>>>0>(c[i>>2]|0)>>>0:0)){vt(b);c[d>>2]=0}else{j=(c[b+544>>2]|0)+(c[b+612>>2]|0)+g|0;c[d>>2]=D2(a[j>>0]|0,a[j+1>>0]|0,a[j+2>>0]|0)|0;j=f;c[j>>2]=h;c[j+4>>2]=e}return}function hB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=l;l=l+16|0;f=e;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;h=b+12|0;TX(h);g=b+24|0;TX(g);Xy(f,42436);k1(h,f)|0;z5(f);Xy(f,42444);k1(g,f)|0;z5(f);c[b+36>>2]=-1;Xy(f,(a[d+8+3>>0]|0)<0?c[d>>2]|0:d);og(b,f);z5(f);l=e;return}function iB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;g=l;l=l+48|0;f=g+32|0;e=g+16|0;b=g;if(fs(401459,114,4)|0){d=QY()|0;c[b>>2]=a;c[b+4>>2]=d|32768;c[b+8>>2]=438;b=b6($a(5,b|0)|0)|0;if((b|0)>=0){if(d&524288|0){c[e>>2]=b;c[e+4>>2]=2;c[e+8>>2]=1;ma(221,e|0)|0}a=Ps(b)|0;if(!a){c[f>>2]=b;_a(6,f|0)|0;a=0}}else a=0}else{c[12784]=22;a=0}l=g;return a|0}function jB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;f=b+528|0;h=f;g=c[h>>2]|0;h=z0(g|0,c[h+4>>2]|0,3,0)|0;e=z;i=b+536|0;j=c[i+4>>2]|0;if(e>>>0>j>>>0|((e|0)==(j|0)?h>>>0>(c[i>>2]|0)>>>0:0)){vt(b);c[d>>2]=0}else{j=(c[b+544>>2]|0)+(c[b+612>>2]|0)+g|0;c[d>>2]=g3(a[j>>0]|0,a[j+1>>0]|0,a[j+2>>0]|0)|0;j=f;c[j>>2]=h;c[j+4>>2]=e}return}function kB(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;a:do switch((d&176)<<24>>24){case 16:{d=a[b>>0]|0;e=b+1|0;switch(d<<24>>24){case 43:case 45:{b=e;break a}default:{}}if((c-b|0)>1&d<<24>>24==48){switch(a[e>>0]|0){case 88:case 120:break;default:{f=6;break a}}b=b+2|0}else f=6;break}case 32:{b=c;break}default:f=6}while(0);return b|0}function lB(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=l;l=l+16|0;g=h+2|0;e=h;HB(a,g);f=a+528|0;g=b[g>>1]|0;d=0;while(1){if((d&65535)>=(g&65535))break;GC(a);j=f;j=z0(c[j>>2]|0,c[j+4>>2]|0,2,0)|0;i=f;c[i>>2]=j;c[i+4>>2]=z;HB(a,e);J3(a);d=d+1<<16>>16}l=h;return}function mB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;g=a+4|0;h=b+4|0;f=(c[g>>2]|0)-e|0;d=(c[h>>2]|0)+(0-f)|0;c[h>>2]=d;if((f|0)>0){no(d|0,e|0,f|0)|0;d=c[h>>2]|0}f=c[a>>2]|0;c[a>>2]=d;c[h>>2]=f;f=b+8|0;e=c[g>>2]|0;c[g>>2]=c[f>>2];c[f>>2]=e;f=a+8|0;g=b+12|0;a=c[f>>2]|0;c[f>>2]=c[g>>2];c[g>>2]=a;c[b>>2]=c[h>>2];return}function nB(b){b=b|0;var e=0;Bx(b);xR(b,2,b+1180|0);xR(b,5,b+1183|0);xR(b,3,b+1185|0);xR(b,3,b+1257|0);AT(b,b+1411|0);e=b+1182|0;xR(b,5,e);a[e>>0]=(d[e>>0]|0)<<1;d4(c[b+648>>2]|0,5);wK(b);a[b+768>>0]=0;a[b+1483>>0]=1;return}function oB(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b+4>>2]|0;a:do if(!d){e=b;while(1){d=c[e+8>>2]|0;if((c[d>>2]|0)==(e|0))break a;e=d}}else while(1){e=c[d>>2]|0;if(!e)break;else d=e}while(0);if((c[a>>2]|0)==(b|0))c[a>>2]=d;e=a+8|0;c[e>>2]=(c[e>>2]|0)+-1;Dg(c[a+4>>2]|0,b);laa(b);return}function pB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;f=l;l=l+16|0;i=f|0;h=b>>31|((b|0)<0?-1:0)<<1;g=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;j=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;a=D_(h^a|0,g^b|0,h|0,g|0)|0;b=z;ph(a,b,D_(k^d|0,j^e|0,k|0,j|0)|0,z,i)|0;e=D_(c[i>>2]^h|0,c[i+4>>2]^g|0,h|0,g|0)|0;d=z;l=f;return (z=d,e)|0}function qB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=b+528|0;f=c[h>>2]|0;h=z0(f|0,c[h+4>>2]|0,260,0)|0;j=z;g=b+536|0;i=c[g+4>>2]|0;if((j>>>0<i>>>0|((j|0)==(i|0)?h>>>0<(c[g>>2]|0)>>>0:0)?(d=c[b+544>>2]|0,e=(c[b+612>>2]|0)+f|0,(a[d+(e+186)>>0]|0)==-106):0)?(a[d+(e+187)>>0]|0)==105:0){e1(b,186,0);e1(b,74,0)}else e1(b,260,0);return}function rB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=a+528|0;g=i;f=c[g>>2]|0;g=c[g+4>>2]|0;h=a+536|0;d=h;e=c[d>>2]|0;d=c[d+4>>2]|0;if(!(d>>>0<g>>>0|(d|0)==(g|0)&e>>>0<f>>>0)){j=(c[a+544>>2]|0)+(c[a+612>>2]|0)+f|0;d=D_(e|0,d|0,f|0,g|0)|0;Sc(a,b,j,d,1);d=h;e=c[d>>2]|0;d=c[d+4>>2]|0}j=i;c[j>>2]=e;c[j+4>>2]=d;return}function sB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;e=l;l=l+16|0;f=e;bB(a,e+4|0);jB(a,f);KK(a);g=a+528|0;b=g;b=z0(c[b>>2]|0,c[b+4>>2]|0,4,0)|0;d=z;c[g>>2]=b;c[g+4>>2]=d;if(c[f>>2]&1|0){g=a+536|0;g=D_(c[g>>2]|0,c[g+4>>2]|0,b|0,d|0)|0;iF(a,g,z)}l=e;return}function tB(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=e-d|0;a:do if(h){i=c;if((i-b|0)<(h|0))b=c;else{f=a[d>>0]|0;g=1-h|0;while(1){e=i-b|0;if((e|0)<(h|0)){b=c;break a}b=MY(b,g+e|0,f)|0;if(!b){b=c;break a}if(!(R$(b,d,h)|0))break a;b=b+1|0}}}while(0);return b|0}function uB(b){b=b|0;var c=0.0,d=0,e=0,f=0;e=a6(a[b>>0]|0,a[b+1>>0]|0)|0;d=e&65535;e=e&32767;if(e<<16>>16<32767)switch(e<<16>>16){case 0:{c=0.0;break}default:f=2}else switch(e<<16>>16){case 32767:{c=0.0;break}default:f=2}if((f|0)==2){f=MF(b+2|0)|0;c=(+(f>>>0)+4294967296.0*+((z&2147483647)>>>0))*1.0842021724855044e-19+1.0;c=+eaa((d&32767)+49153&65535)*c;c=(d&32768|0)==0?c:-c}return +c}function vB(a){a=a|0;var b=0,d=0,e=0;b=a+536|0;d=b;e1(a,c[d>>2]|0,c[d+4>>2]|0);if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){d=kE(a+760|0,a+840|0)|0;b=c[b>>2]|0;e=iaa(b)|0;c[d+84>>2]=e;no(e|0,(c[a+544>>2]|0)+(c[a+612>>2]|0)|0,b|0)|0;c[d+80>>2]=b}return}function wB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;$p(e,b,a[d>>0]|0,g);l=f;return (c[e>>2]|0)+14|0}function xB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;f=b+528|0;h=f;g=c[h>>2]|0;h=z0(g|0,c[h+4>>2]|0,3,0)|0;e=z;i=b+536|0;j=c[i+4>>2]|0;if(e>>>0>j>>>0|((e|0)==(j|0)?h>>>0>(c[i>>2]|0)>>>0:0)){vt(b);c[d>>2]=0}else{j=(c[b+544>>2]|0)+(c[b+612>>2]|0)+g|0;c[d>>2]=R4(a[j>>0]|0,a[j+1>>0]|0,a[j+2>>0]|0)|0;j=f;c[j>>2]=h;c[j+4>>2]=e}return}function yB(a){a=a|0;var b=0,d=0,e=0;b=c[a+8>>2]|0;do if(b){d=c[b>>2]|0;e=b+4|0;if((d|0)==(a|0)){c[b>>2]=0;a=c[e>>2]|0;if(!a)break;b=xW(a)|0;break}else{c[e>>2]=0;if(!d)break;b=xW(d)|0;break}}else b=0;while(0);return b|0}function zB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=i9(57408)|0;if(d>>>0>1073741807)uaa();e=b+8|0;do if(d>>>0>=2){f=d+4&-4;if(f>>>0>1073741823)ra();else{g=ZW(f<<2)|0;c[b>>2]=g;c[e>>2]=f|-2147483648;c[b+4>>2]=d;break}}else{a[e+3>>0]=d;g=b}while(0);a3(g,57408,d);y7(g+(d<<2)|0,0);return}function AB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=i9(57432)|0;if(d>>>0>1073741807)uaa();e=b+8|0;do if(d>>>0>=2){f=d+4&-4;if(f>>>0>1073741823)ra();else{g=ZW(f<<2)|0;c[b>>2]=g;c[e>>2]=f|-2147483648;c[b+4>>2]=d;break}}else{a[e+3>>0]=d;g=b}while(0);a3(g,57432,d);y7(g+(d<<2)|0,0);return}function BB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;f=a[b+8+3>>0]|0;h=f<<24>>24<0;f=f&255;g=b+4|0;if(h)e=c[g>>2]|0;else e=f;if(e|0){if(h)f=c[g>>2]|0;while(1){e=f+-1|0;if(!f){f=0;break}if(h)g=c[b>>2]|0;else g=b;if((c[g+(e<<2)>>2]|0)==(d|0))f=e;else break}if(h)e=c[b>>2]|0;else e=b;sx(b,e,f)|0}return b|0}function CB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;f=b+4|0;g=c[f>>2]|0;h=c[b+8>>2]|0;do if((g|0)==(h<<5|0))if((g+1|0)<0)uaa();else{e=h<<6;h=g+32&-32;wy(b,g>>>0<1073741823?(e>>>0<h>>>0?h:e):2147483647);e=c[f>>2]|0;break}else e=g;while(0);c[f>>2]=e+1;h=(c[b>>2]|0)+(e>>>5<<2)|0;g=1<<(e&31);f=c[h>>2]|0;c[h>>2]=a[d>>0]|0?f|g:f&~g;return}function DB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=a+4|0;e=wE(b,d,c[a>>2]|0,a)|0;if((e|0)!=(a|0)?(f=e+16|0,g=c[f+4>>2]|0,!(g>>>0>d>>>0|((g|0)==(d|0)?(c[f>>2]|0)>>>0>b>>>0:0))):0)a=e;return a|0}function EB(a){a=a|0;if(!a)return;else{EB(c[a>>2]|0);EB(c[a+4>>2]|0);H2(a+16|0);laa(a);return}}function FB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;g=b+8+3|0;f=a[g>>0]|0;h=f<<24>>24<0;i=b+4|0;if(h)f=c[i>>2]|0;else f=f&255;do if(f>>>0>=d>>>0)if(h){y7((c[b>>2]|0)+(d<<2)|0,0);c[i>>2]=d;break}else{y7(b+(d<<2)|0,0);a[g>>0]=d;break}else Fx(b,d-f|0,e)|0;while(0);return}function GB(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;e=e&255;f=b+4|0;g=c[f>>2]|0;h=g&7;k=357184+e|0;i=b+12|0;j=g-e&7;do if(e>>>0>h>>>0){if(g>>>0<e>>>0){c[f>>2]=0;a[b+13>>0]=1;e=0;break}f=e-h&255;if((f|0)==8)e=0;else e=(d[i>>0]|0)<<f&255;e=((d[c[b>>2]>>0]|0)>>>j&(d[357184+f>>0]|0)|e)&(d[k>>0]|0)&255}else e=(d[i>>0]|0)>>>j&(d[k>>0]|0)&255;while(0);return e|0}function HB(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;g=d+528|0;i=g;h=c[i>>2]|0;i=z0(h|0,c[i+4>>2]|0,2,0)|0;f=z;j=d+536|0;k=c[j+4>>2]|0;if(f>>>0>k>>>0|((f|0)==(k|0)?i>>>0>(c[j>>2]|0)>>>0:0)){vt(d);b[e>>1]=0}else{k=(c[d+544>>2]|0)+(c[d+612>>2]|0)+h|0;b[e>>1]=a5(a[k>>0]|0,a[k+1>>0]|0)|0;k=g;c[k>>2]=i;c[k+4>>2]=f}return}function IB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=Ey(a,b,d)|0;g=c[e>>2]|0;h=c[d>>2]|0;if(g>>>0<h>>>0){c[d>>2]=g;c[e>>2]=h;g=f+1|0;h=c[d>>2]|0;e=c[b>>2]|0;if(h>>>0<e>>>0){c[b>>2]=h;c[d>>2]=e;e=c[b>>2]|0;g=c[a>>2]|0;if(e>>>0<g>>>0){c[a>>2]=e;c[b>>2]=g;f=f+3|0}else f=f+2|0}else f=g}return f|0}function JB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=ZW(40)|0;c[b>>2]=f;c[b+4>>2]=d+4;g=c[e>>2]|0;d=c[g+4>>2]|0;e=f+16|0;c[e>>2]=c[g>>2];c[e+4>>2]=d;e=f+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;a[b+8>>0]=1;return}function KB(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;h=f-e|0;if(h>>>0>4294967279)uaa();if(h>>>0<11){a[b+11>>0]=h;g=b}else{d=h+16&-16;g=ZW(d)|0;c[b>>2]=g;c[b+8>>2]=d|-2147483648;c[b+4>>2]=h}d=e;b=g;while(1){if((d|0)==(f|0))break;J7(b,a[d>>0]|0);d=d+1|0;b=b+1|0}J7(g+h|0,0);return}function LB(a,b){a=a|0;b=b|0;var d=0,e=0;GC(a);d=a+648|0;d4(c[d>>2]|0,2);A6(c[d>>2]|0);A6(c[d>>2]|0);GC(a);while(1){e=c[d>>2]|0;if((Z9(c[e+4>>2]|0)|0)>>>0<=b>>>0)break;d4(e,8)}J3(a);J3(a);return}function MB(a){a=a|0;var b=0.0,d=0,e=0,f=0,i=0,j=0;j=l;l=l+16|0;d=j;f=a+536|0;e=c[f>>2]|0;f=c[f+4>>2]|0;switch(e|0){case 4:{if(!f){eD(a,d);b=+g[d>>2]}else i=6;break}case 8:{if(!f){dD(a,d);b=+h[d>>3]}else i=6;break}default:i=6}if((i|0)==6){e1(a,e,f);b=0.0}l=j;return +b}function NB(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;g=d+528|0;i=g;h=c[i>>2]|0;i=z0(h|0,c[i+4>>2]|0,2,0)|0;f=z;j=d+536|0;k=c[j+4>>2]|0;if(f>>>0>k>>>0|((f|0)==(k|0)?i>>>0>(c[j>>2]|0)>>>0:0)){vt(d);b[e>>1]=0}else{k=(c[d+544>>2]|0)+(c[d+612>>2]|0)+h|0;b[e>>1]=A5(a[k>>0]|0,a[k+1>>0]|0)|0;k=g;c[k>>2]=i;c[k+4>>2]=f}return}function OB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=a+8|0;Ey(a,a+4|0,d)|0;g=a+12|0;while(1){if((g|0)==(b|0))break;h=c[g>>2]|0;f=c[d>>2]|0;if(h>>>0<f>>>0){e=g;while(1){c[e>>2]=f;if((d|0)==(a|0)){d=a;break}e=d+-4|0;f=c[e>>2]|0;if(h>>>0>=f>>>0)break;else{i=d;d=e;e=i}}c[d>>2]=h}d=g;g=g+4|0}return}function PB(a,b){a=a|0;b=b|0;b=UD(a,b)|0;if((b|0)!=(a+4|0))Rw(a,b);return}function QB(a){a=a|0;var b=0,d=0,e=0,f=0;d=c[102054]|0;f=a+4|0;e=(c[102055]|0)-d|0;b=(c[f>>2]|0)+(0-(e>>2)<<2)|0;c[f>>2]=b;if((e|0)>0){no(b|0,d|0,e|0)|0;b=c[f>>2]|0}e=c[102054]|0;c[102054]=b;c[f>>2]=e;e=a+8|0;d=c[102055]|0;c[102055]=c[e>>2];c[e>>2]=d;e=a+12|0;d=c[102056]|0;c[102056]=c[e>>2];c[e>>2]=d;c[a>>2]=c[f>>2];return}function RB(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;j=l;l=l+16|0;i=j;if(g){TX(i);zb(a,b,c,d,b3(i,e,f)|0,h);z5(i)}else{TX(i);zb(a,b,c,d,M2(i,e,f)|0,h);z5(i)}l=j;return}function SB(a){a=a|0;var b=0,d=0;if(!(YV(a)|0)){d=c[a+28>>2]|0;c[d+32>>2]=0;c[a+20>>2]=0;c[a+8>>2]=0;c[a+24>>2]=0;b=c[d+12>>2]|0;if(b|0)c[a+48>>2]=b&1;c[d+4>>2]=16180;c[d+8>>2]=0;c[d+16>>2]=0;c[d+24>>2]=32768;c[d+36>>2]=0;c[d+60>>2]=0;c[d+64>>2]=0;a=d+1332|0;c[d+112>>2]=a;c[d+84>>2]=a;c[d+80>>2]=a;c[d+7108>>2]=1;c[d+7112>>2]=-1;a=0}else a=-2;return a|0}function TB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;g=a+4|0;b=c[g>>2]|0;f=c[a>>2]|0;d=b-f|0;e=(d|0)/12|0;a:do if(e>>>0>=7){if((d|0)!=84){a=f+84|0;while(1){if((b|0)==(a|0))break a;f=b+-12|0;c[g>>2]=f;QP(f);b=c[g>>2]|0}}}else Rt(a,7-e|0);while(0);return}function UB(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;pr(e,a,b[d>>1]|0,g);l=f;return (c[e>>2]|0)+20|0}function VB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;hs(d,a,c[b>>2]|0,f);l=e;return (c[d>>2]|0)+20|0}function WB(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=ZW(36)|0;c[d>>2]=g;c[d+4>>2]=e+4;b[g+16>>1]=b[c[f>>2]>>1]|0;f=g+20|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;m3(f);a[d+8>>0]=1;return}function XB(b){b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e;if(c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0){XP(d,b);if(a[d>>0]|0?(f=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0,(nb[c[(c[f>>2]|0)+24>>2]&255](f)|0)==-1):0){f=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(f,c[f+16>>2]|1)}TC(d)}l=e;return b|0}function YB(b){b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e;if(c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0){YP(d,b);if(a[d>>0]|0?(f=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0,(nb[c[(c[f>>2]|0)+24>>2]&255](f)|0)==-1):0){f=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(f,c[f+16>>2]|1)}TC(d)}l=e;return b|0}function ZB(a){a=a|0;var d=0,e=0,f=0,g=0;b[a+976>>1]=-1;b[a+978>>1]=0;g=a+792|0;d=c[g>>2]|0;e=(c[a+796>>2]|0)-d>>2;f=a+804|0;c[f>>2]=e;if(e>>>0>2047){e=0;a=d;while(1){if((e|0)==1024)break;d=c[a+(e<<2)>>2]|0;if(d){laa(d);a=c[g>>2]|0}e=e+1|0}xI(g,a,a+4096|0);g=c[f>>2]|0;c[f>>2]=g>>>0>1024?g+-1024|0:0}return}function _B(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(32)|0;c[b>>2]=f;c[b+4>>2]=d+4;c[f+16>>2]=c[c[e>>2]>>2];e=f+20|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;u2(e);a[b+8>>0]=1;return}function $B(a){a=a|0;var b=0;b=c[a>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);b=c[a+4>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);b=c[a+8>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);uS(a+68|0);o4(a+56|0);IT(a+40|0);return}function aC(a){a=a|0;var b=0,d=0,e=0;e=l;l=l+16|0;d=e;Bx(a);b=a+648|0;d4(c[b>>2]|0,4);A6(c[b>>2]|0);A6(c[b>>2]|0);n3(a,d);d=c[d>>2]|0;b=0;while(1){if(b>>>0>d>>>0)break;T5(a);b=b+1|0}wK(a);l=e;return}function bC(a){a=a|0;if(!a)return;else{bC(c[a>>2]|0);bC(c[a+4>>2]|0);V3(a+16|0);laa(a);return}}function cC(b,d){b=b|0;d=d|0;var e=0,f=0;do if(d|0){f=PY(0,d,0)|0;e=f+1|0;if(e>>>0>1){e=iaa(e>>>0>1073741823?-1:e<<2)|0;c[e+((PY(e,d,f)|0)<<2)>>2]=0;GX(b,e)|0;jaa(e);break}e=b+8+3|0;if((a[e>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0;break}else{y7(b,0);a[e>>0]=0;break}}while(0);return b|0}function dC(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;g=d+528|0;i=g;h=c[i>>2]|0;i=z0(h|0,c[i+4>>2]|0,2,0)|0;f=z;j=d+536|0;k=c[j+4>>2]|0;if(f>>>0>k>>>0|((f|0)==(k|0)?i>>>0>(c[j>>2]|0)>>>0:0)){vt(d);b[e>>1]=0}else{k=(c[d+544>>2]|0)+(c[d+612>>2]|0)+h|0;b[e>>1]=d7(a[k>>0]|0,a[k+1>>0]|0)|0;k=g;c[k>>2]=i;c[k+4>>2]=f}return}function eC(a){a=a|0;if(!a)return;else{eC(c[a>>2]|0);eC(c[a+4>>2]|0);t2(a+16|0);laa(a);return}}function fC(b){b=b|0;var d=0,e=0,f=0,g=0;f=l;l=l+16|0;g=f;GC(b);Bx(b);AT(b,g);d=b+648|0;e=c[d>>2]|0;if(!(a[g>>0]|0))d4(e,7);else{d4(e,6);d4(c[d>>2]|0,33)}wK(b);J3(b);l=f;return}function gC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(32)|0;c[b>>2]=f;c[b+4>>2]=d+4;a[f+16>>0]=a[c[e>>2]>>0]|0;e=f+20|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;u2(e);a[b+8>>0]=1;return}function hC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=c[a+4>>2]|0;if(!d)d=c[a>>2]|0;else{g=32-d|0;e=g>>>0>b>>>0?b:g;f=c[a>>2]|0;c[f>>2]=c[f>>2]&~(-1>>>(g-e|0)&-1<<d);d=f+4|0;c[a>>2]=d;b=b-e|0}e=b>>>5;Ow(d|0,0,e<<2|0)|0;b=b-(e<<5)|0;if(b|0){g=(c[a>>2]|0)+(e<<2)|0;c[a>>2]=g;c[g>>2]=c[g>>2]&~(-1>>>(32-b|0))}return}function iC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;g=a+4|0;b=c[g>>2]|0;f=c[a>>2]|0;d=b-f|0;e=(d|0)/12|0;a:do if(e>>>0>=7){if((d|0)!=84){a=f+84|0;while(1){if((b|0)==(a|0))break a;f=b+-12|0;c[g>>2]=f;mQ(f);b=c[g>>2]|0}}}else Yt(a,7-e|0);while(0);return}function jC(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;GC(a);h=a+22116|0;g=b&1;b=0;while(1){f=c[h>>2]|0;if((b|0)>=(d[f+9+g>>0]|0|0)){e=0;b=f;break}xR(a,1,f+29+(g<<2)+b|0);b=b+1|0}while(1){if((e|0)>=(d[b+27+g>>0]|0|0))break;xR(a,1,b+37+(g<<1)+e|0);e=e+1|0;b=c[h>>2]|0}J3(a);return}function kC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;Br(e,b,a[d>>0]|0,g);l=f;return (c[e>>2]|0)+20|0}function lC(b){b=b|0;var d=0,e=0,f=0;f=b+92|0;if(!(c[f>>2]&16)){c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;d=c[b+52>>2]|0;do if(d>>>0>8)if(!(a[b+98>>0]|0)){e=c[b+56>>2]|0;d=e+((c[b+60>>2]|0)+-1)|0;break}else{e=c[b+32>>2]|0;d=e+(d+-1)|0;break}else{d=0;e=0}while(0);c[b+24>>2]=e;c[b+20>>2]=e;c[b+28>>2]=d;c[f>>2]=16}return}function mC(a,b){a=a|0;b=b|0;b=UD(a,b)|0;if((b|0)!=(a+4|0))rx(a,b);return}function nC(a){a=a|0;if(!a)return;else{nC(c[a>>2]|0);nC(c[a+4>>2]|0);m4(a+16|0);laa(a);return}}function oC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=(d-f|0)/24|0;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b*24|0)|0;while(1){if((d|0)==(a|0))break a;f=d+-24|0;c[g>>2]=f;w4(f);d=c[g>>2]|0}}}else gt(a,b-e|0);while(0);return}function pC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=(d-f|0)/12|0;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b*12|0)|0;while(1){if((d|0)==(a|0))break a;f=d+-12|0;c[g>>2]=f;l1(f);d=c[g>>2]|0}}}else wt(a,b-e|0);while(0);return}function qC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=ZW(40)|0;c[b>>2]=f;c[b+4>>2]=d+4;g=c[e>>2]|0;d=c[g+4>>2]|0;e=f+16|0;c[e>>2]=c[g>>2];c[e+4>>2]=d;x1(f+24|0);a[b+8>>0]=1;return}function rC(a){a=a|0;var b=0,d=0,f=0;b=l;l=l+16|0;f=b+12|0;d=b;Bx(a);d4(c[a+648>>2]|0,11);sR(a,13,f);wK(a);Op(a,(e[f>>1]|0)+3|0,0);VU(d,378440);BZ(c[a+508>>2]|0,c[a+668>>2]|0,0,0);z5(d);l=b;return}function sC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=l;l=l+16|0;bB(a,g+4|0);jB(a,g);f=a+528|0;a=a+536|0;e=c[a>>2]|0;a=c[a+4>>2]|0;d=f;b=c[d+4>>2]|0;d=c[d>>2]|0;while(1){if(!(b>>>0<a>>>0|(b|0)==(a|0)&d>>>0<e>>>0))break;h=z0(d|0,b|0,8,0)|0;i=z;j=f;c[j>>2]=h;c[j+4>>2]=i;b=i;d=h}l=g;return}function tC(a){a=a|0;if(!a)return;else{tC(c[a>>2]|0);tC(c[a+4>>2]|0);O3(a+16|0);laa(a);return}}function uC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;Er(d,a,c[b>>2]|0,c[b+4>>2]|0,f);l=e;return (c[d>>2]|0)+24|0}function vC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=(d-f|0)/24|0;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b*24|0)|0;while(1){if((d|0)==(a|0))break a;f=d+-24|0;c[g>>2]=f;G0(f);d=c[g>>2]|0}}}else rt(a,b-e|0);while(0);return}function wC(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;Dr(e,a,b[d>>1]|0,g);l=f;return (c[e>>2]|0)+20|0}function xC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=l;l=l+16|0;g=f;O4(g,b);b=c[g>>2]|0;h=u$(b,409148)|0;rb[c[(c[h>>2]|0)+48>>2]&7](h,401970,401996,d)|0;d=u$(b,409156)|0;c[e>>2]=nb[c[(c[d>>2]|0)+16>>2]&255](d)|0;kb[c[(c[d>>2]|0)+20>>2]&63](a,d);c6(g);l=f;return}function yC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;g=a+4|0;b=c[g>>2]|0;f=c[a>>2]|0;d=b-f|0;e=(d|0)/120|0;a:do if(e>>>0>=256){if((d|0)!=30720){a=f+30720|0;while(1){if((b|0)==(a|0))break a;f=b+-120|0;c[g>>2]=f;OM(f);b=c[g>>2]|0}}}else ht(a,256-e|0);while(0);return}function zC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=l;l=l+16|0;h=g;O4(h,d);d=c[h>>2]|0;i=u$(d,409116)|0;rb[c[(c[i>>2]|0)+32>>2]&7](i,401970,401996,e)|0;e=u$(d,409132)|0;a[f>>0]=nb[c[(c[e>>2]|0)+16>>2]&255](e)|0;kb[c[(c[e>>2]|0)+20>>2]&63](b,e);c6(h);l=g;return}function AC(a){a=a|0;if(!a)return;else{AC(c[a>>2]|0);AC(c[a+4>>2]|0);I4(a+16|0);laa(a);return}}function BC(a){a=a|0;if(!a)return;else{BC(c[a>>2]|0);BC(c[a+4>>2]|0);J4(a+16|0);laa(a);return}}function CC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;f=b+11|0;e=a[f>>0]|0;g=e<<24>>24<0;h=b+4|0;if(g)e=c[h>>2]|0;else e=e&255;do if(e>>>0>=d>>>0)if(g){J7((c[b>>2]|0)+d|0,0);c[h>>2]=d;break}else{J7(b+d|0,0);a[f>>0]=d;break}else ay(b,d-e|0,0)|0;while(0);return}function DC(a){a=a|0;var b=0,d=0;d=HN(a,0)|0;b=a+528|0;c[b>>2]=d;c[b+4>>2]=z;if(qO(a)|0){Kc(a,1,-1)|0;b=a+20|0;RB(a,1,c[b>>2]|0,18,380258,-1,1,0);b=c[b>>2]|0;d=HN(a,0)|0;oK(a,1,b,252,d,z,10,0)}return}function EC(a){a=a|0;c[a>>2]=34784;es(a);z5(a+912|0);z5(a+900|0);z5(a+888|0);z5(a+876|0);z5(a+864|0);z5(a+852|0);z5(a+840|0);cU(a+820|0);cU(a+808|0);cU(a+796|0);dU(a+776|0);bt(a);return}function FC(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=ZW(32)|0;c[d>>2]=g;c[d+4>>2]=e+4;b[g+16>>1]=b[c[f>>2]>>1]|0;f=g+20|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;u2(f);a[d+8>>0]=1;return}function GC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;h=b+508|0;e=c[h>>2]|0;d=e+1|0;c[h>>2]=d;b=c[b+668>>2]|0;h=b+(d*24|0)|0;c[h>>2]=0;c[h+4>>2]=0;h=b+(e*24|0)+8|0;g=c[h+4>>2]|0;f=b+(d*24|0)+8|0;c[f>>2]=c[h>>2];c[f+4>>2]=g;a[b+(d*24|0)+16>>0]=a[b+(e*24|0)+16>>0]|0;a[b+(d*24|0)+17>>0]=a[b+(e*24|0)+17>>0]|0;a[b+(d*24|0)+18>>0]=a[b+(e*24|0)+18>>0]|0;return}function HC(a,b){a=a|0;b=b|0;var d=0,e=0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;d=b+4|0;e=(c[d>>2]|0)-(c[b>>2]|0)|0;if(e|0){aT(a,(e|0)/24|0);NN(a,c[b>>2]|0,c[d>>2]|0)}return}function IC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=l;l=l+16|0;f=d;e=ls(a,f,b+16|0)|0;HH(a,c[f>>2]|0,e,b);l=d;return}function JC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;if((d|0)==1)b=b-(c[a+8>>2]|0)+(c[a+4>>2]|0)|0;e=a+20|0;f=a+28|0;if((c[e>>2]|0)>>>0>(c[f>>2]|0)>>>0?(gb[c[a+36>>2]&31](a,0,0)|0,(c[e>>2]|0)==0):0)b=-1;else{c[a+16>>2]=0;c[f>>2]=0;c[e>>2]=0;if((gb[c[a+40>>2]&31](a,b,d)|0)<0)b=-1;else{c[a+8>>2]=0;c[a+4>>2]=0;c[a>>2]=c[a>>2]&-17;b=0}}return b|0}function KC(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;var g=0,h=0;g=d[e+5>>0]|0;h=(b&255)-g|0;a[e+43>>0]=h;b=h>>>1&127;a[e+42>>0]=b+h-(b<<1);c=a[c+g>>0]|0;do if((c&255)>32)b=0;else{g=a[e+8>>0]|0;b=e+41|0;if(g<<24>>24){h=_X(0,g,c,f)|0;a[b>>0]=h;if((h+-1&255)>4){b=0;break}}else a[b>>0]=1;b=1}while(0);return b|0}function LC(a,b){a=+a;b=b|0;var d=0,e=0;if((b|0)<=1023){if((b|0)<-1022){a=a*2.2250738585072014e-308;d=b+1022|0;e=(d|0)<-1022;b=b+2044|0;a=e?a*2.2250738585072014e-308:a;b=e?((b|0)>-1022?b:-1022):d}}else{a=a*8988465674311579538646525.0e283;e=b+-1023|0;d=(e|0)>1023;b=b+-2046|0;a=d?a*8988465674311579538646525.0e283:a;b=d?((b|0)<1023?b:1023):e}d=PZ(b+1023|0,0,52)|0;e=z;c[j>>2]=d;c[j+4>>2]=e;return +(a*+h[j>>3])}function MC(a){a=a|0;var b=0;GC(a);b=a+648|0;A6(c[b>>2]|0);d4(c[b>>2]|0,6);d4(c[b>>2]|0,10);d4(c[b>>2]|0,3);A6(c[b>>2]|0);A6(c[b>>2]|0);A6(c[b>>2]|0);J3(a);return}function NC(b,d){b=b|0;d=d|0;var e=0,f=0;a:do if(d|0){e=b+8+3|0;if((a[e>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0}else{y7(b,0);a[e>>0]=0}while(1){f=a[d>>0]|0;e=a[d+1>>0]|0;if(!((f|e)<<24>>24))break a;Fx(b,1,(J5(f,e)|0)&65535)|0;d=d+2|0}}while(0);return b|0}function OC(a){a=a|0;var b=0,d=0,e=0;e=l;l=l+32|0;b=e;d=e+8|0;oz(a,b);if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){TX(d);b=g5(c[b>>2]|0,c[b+4>>2]|0,1e9,0)|0;b=z0(b|0,z|0,978307200,0)|0;Mc(a,0,0,377029,T2(d,b)|0,0);z5(d)}l=e;return}function PC(a){a=a|0;var b=0;c[a>>2]=27516;b=c[a+776>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);b=c[a+780>>2]|0;if(b|0)laa(b);aU(a+860|0);jO(a+828|0);jO(a+816|0);jO(a+804|0);bt(a);return}function QC(b){b=b|0;var e=0,f=0,g=0;e=l;l=l+16|0;g=e;GC(b);d4(c[b+648>>2]|0,3);a[g>>0]=0;xR(b,6,g);f=b+792|0;a[f>>0]=(d[g>>0]|0)+1;f=WH(b+796|0,f)|0;c[f>>2]=(c[f>>2]|0)+1;xR(b,3,b+808|0);J3(b);l=e;return}function RC(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;Qr(e,a,b[d>>1]|0,g);l=f;return (c[e>>2]|0)+20|0}function SC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;yq(d,a,b,f);l=e;return (c[d>>2]|0)+28|0}function TC(a){a=a|0;var b=0;a=a+4|0;b=c[a>>2]|0;b=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;if((((c[b+24>>2]|0?(c[b+16>>2]|0)==0:0)?c[b+4>>2]&8192|0:0)?!(Ha()|0):0)?(b=c[a>>2]|0,b=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0,(nb[c[(c[b>>2]|0)+24>>2]&255](b)|0)==-1):0){b=c[a>>2]|0;b=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(b,c[b+16>>2]|1)}return}function UC(b,d){b=b|0;d=d|0;var e=0,f=0;a:do if(d|0){e=b+8+3|0;if((a[e>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0}else{y7(b,0);a[e>>0]=0}while(1){f=a[d>>0]|0;e=a[d+1>>0]|0;if(!((f|e)<<24>>24))break a;Fx(b,1,(a6(f,e)|0)&65535)|0;d=d+2|0}}while(0);return b|0}function VC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;zq(d,a,b,f);l=e;return (c[d>>2]|0)+28|0}function WC(b){b=b|0;var d=0,e=0,f=0,g=0;GC(b);sR(b,11,b+22114|0);e=b+648|0;d4(c[e>>2]|0,3);a:do if((a[b+2506>>0]|0)!=2){f=b+2507|0;d=0;while(1){g=a[f>>0]|0;if((d&255)>=(((g&255)<40?g:40)&255))break a;A6(c[e>>2]|0);d=d+1<<24>>24}}while(0);J3(b);return}function XC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=a+956|0;e=c[j>>2]|0;i=c[a+952>>2]|0;h=e-i>>5;f=0;while(1){if((f|0)==(h|0))break;g=i+(f<<5)+16|0;k=g;if(!((c[k>>2]|0)==0&(c[k+4>>2]|0)==0)){k=g;c[k>>2]=0;c[k+4>>2]=0}f=f+1|0}while(1){if((e|0)==(i|0))break;k=e+-32|0;c[j>>2]=k;e=k}ty(a,b,d);return}function YC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;g=l;l=l+16|0;b=g;iX(b,a);d=a+1048|0;ME(d,(c[a+508>>2]|0)+-5|0);e=a+1052|0;f=c[e>>2]|0;if((f|0)==(c[a+1056>>2]|0))Ax(d,b);else{p2(f,b);c[e>>2]=(c[e>>2]|0)+12}z5(b);l=g;return}function ZC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;f=l;l=l+16|0;d=f;W0(d,407712);b=Sx(405064,b,0)|0;if((b|0)!=-1?(g=c[101266]|0,e=c[g+(b*40|0)>>2]|0,(((c[g+(b*40|0)+4>>2]|0)-e|0)/12|0)>>>0>=2):0)p2(a,e+12|0);else p2(a,408444);s7(c[d>>2]|0);l=f;return}function _C(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,i=0,j=0;e=a+528|0;g=e;f=c[g>>2]|0;g=z0(f|0,c[g+4>>2]|0,10,0)|0;d=z;i=a+536|0;j=c[i+4>>2]|0;if(d>>>0>j>>>0|((d|0)==(j|0)?g>>>0>(c[i>>2]|0)>>>0:0)){vt(a);h[b>>3]=0.0}else{h[b>>3]=+P7((c[a+544>>2]|0)+(c[a+612>>2]|0)+f|0);j=e;c[j>>2]=g;c[j+4>>2]=d}return}function $C(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;Yr(e,a,b[d>>1]|0,g);l=f;return (c[e>>2]|0)+20|0}function aD(a){a=a|0;var b=0,d=0,e=0;b=a+528|0;e=b;e=z0(c[e>>2]|0,c[e+4>>2]|0,6,0)|0;d=z;c[b>>2]=e;c[b+4>>2]=d;b=a+536|0;if(!((e|0)==(c[b>>2]|0)?(d|0)==(c[b+4>>2]|0):0))t4(a);if(qO(a)|0){W5(a);RB(a,0,0,57,379645,-1,1,0)}else U5(a);return}function bD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=a+528|0;g=e;f=c[g>>2]|0;g=z0(f|0,c[g+4>>2]|0,4,0)|0;d=z;h=a+536|0;i=c[h+4>>2]|0;if(d>>>0>i>>>0|((d|0)==(i|0)?g>>>0>(c[h>>2]|0)>>>0:0)){vt(a);c[b>>2]=0}else{c[b>>2]=t7((c[a+544>>2]|0)+(c[a+612>>2]|0)+f|0)|0;i=e;c[i>>2]=g;c[i+4>>2]=d}return}function cD(b){b=b|0;var d=0,e=0,f=0;d=jF(b+760|0,b+772|0)|0;e=c[d+52>>2]|0;do if(e>>>0>3){f=c[d>>2]|0;if((f|0)!=(c[d+4>>2]|0)?(c[(c[f>>2]|0)+728>>2]&8|0)==0:0){if(e>>>0<=299)break;if(!(+g[(c[b+24>>2]|0)+136>>2]<1.0))break}a[d+80>>0]=0;f=b+1038|0;a[f>>0]=(a[f>>0]|0)+-1<<24>>24}while(0);return}function dD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,i=0,j=0;e=a+528|0;g=e;f=c[g>>2]|0;g=z0(f|0,c[g+4>>2]|0,8,0)|0;d=z;i=a+536|0;j=c[i+4>>2]|0;if(d>>>0>j>>>0|((d|0)==(j|0)?g>>>0>(c[i>>2]|0)>>>0:0)){vt(a);h[b>>3]=0.0}else{h[b>>3]=+Q7((c[a+544>>2]|0)+(c[a+612>>2]|0)+f|0);j=e;c[j>>2]=g;c[j+4>>2]=d}return}function eD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0;e=a+528|0;h=e;f=c[h>>2]|0;h=z0(f|0,c[h+4>>2]|0,4,0)|0;d=z;i=a+536|0;j=c[i+4>>2]|0;if(d>>>0>j>>>0|((d|0)==(j|0)?h>>>0>(c[i>>2]|0)>>>0:0)){vt(a);g[b>>2]=0.0}else{g[b>>2]=+R7((c[a+544>>2]|0)+(c[a+612>>2]|0)+f|0);j=e;c[j>>2]=h;c[j+4>>2]=d}return}function fD(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;_r(e,a,b[d>>1]|0,g);l=f;return (c[e>>2]|0)+20|0}function gD(a,b){a=a|0;b=b|0;var d=0,e=0;e=l;l=l+16|0;d=e;if(b>>>0>=4){ID(a,d);if((c[d>>2]|0)==1195456820)gV(a);else{b=a+536|0;d=a+528|0;d=D_(c[b>>2]|0,c[b+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e1(a,d,z)}}else e1(a,b,0);l=e;return}function hD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=d-f>>4;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b<<4)|0;while(1){if((d|0)==(a|0))break a;f=d+-16|0;c[g>>2]=f;Z7(f);d=c[g>>2]|0}}}else Kt(a,b-e|0);while(0);return}function iD(a){a=a|0;var d=0,e=0,f=0,g=0,h=0;f=l;l=l+32|0;e=f+16|0;d=f;L2(d);j0(a,d);HB(a,e);e=b[e>>1]|0;d=a+528|0;a=0;while(1){if((a&65535)>=(e&65535))break;h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,2,0)|0;g=d;c[g>>2]=h;c[g+4>>2]=z;a=a+1<<16>>16}l=f;return}function jD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(16)|0;c[b>>2]=f;c[b+4>>2]=d+4;a[f+13>>0]=a[c[e>>2]>>0]|0;I3(f+14|0);a[b+8>>0]=1;return}function kD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;js(d,a,c[b>>2]|0,c[b+4>>2]|0,f);l=e;return (c[d>>2]|0)+24|0}function lD(d){d=d|0;var e=0;x1(d+40|0);x1(d+56|0);c[d+68>>2]=0;c[d+72>>2]=0;c[d+76>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=7;e=d+16|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;b[d+36>>1]=-1;a[d+52>>0]=0;a[d+53>>0]=0;d=d+80|0;c[d>>2]=-1;c[d+4>>2]=-1;return}function mD(a){a=a|0;do switch(a<<24>>24){case 1:{a=383164;break}case 4:{a=383311;break}case 5:{a=383408;break}case 6:{a=383396;break}case 7:{a=383102;break}case 8:{a=383383;break}case 9:{a=383375;break}case 10:{a=383371;break}case 11:{a=383356;break}case 12:{a=383341;break}case 22:{a=383327;break}default:a=8800948}while(0);return a|0}function nD(a){a=a|0;var b=0,d=0,e=0;d=l;l=l+16|0;b=d;e=a+536|0;e1(a,c[e>>2]|0,c[e+4>>2]|0);if(qO(a)|0){W5(a);RB(a,0,0,57,376937,-1,1,0);Xy(b,23896);Rf(a,b,0,0,1);z5(b)}l=d;return}function oD(a){a=a|0;var b=0,d=0,e=0;d=l;l=l+16|0;b=d;e=a+536|0;e1(a,c[e>>2]|0,c[e+4>>2]|0);if(qO(a)|0){W5(a);RB(a,0,0,57,376937,-1,1,0);Xy(b,27352);Rf(a,b,0,0,1);z5(b)}l=d;return}function pD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=a+4|0;f=c[h>>2]|0;a=b+(((f-e|0)/56|0)*56|0)|0;e=a;g=f;while(1){if(e>>>0>=d>>>0)break;Iw(g,e);i=(c[h>>2]|0)+56|0;c[h>>2]=i;e=e+56|0;g=i}while(1){if((a|0)==(b|0))break;i=a+-56|0;d=f+-56|0;it(d,i)|0;f=d;a=i}return}function qD(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;bs(e,a,b[d>>1]|0,g);l=f;return (c[e>>2]|0)+20|0}function rD(a){a=a|0;var b=0;GC(a);b=ZW(22152)|0;Dt(b);c[b+908>>2]=1;aY(a,b);rB(a,b);G2(a,b);Gb(a,b,c[a+16>>2]|0,0,c[a+20>>2]|0,1)|0;jb[c[(c[b>>2]|0)+4>>2]&511](b);J3(a);return}function sD(a){a=a|0;var b=0,d=0,e=0;if(!(c[a+728>>2]&1)){W5(a);RB(a,0,0,57,373758,-1,1,0)}e=a+48|0;e=z0(c[a+612>>2]|0,0,c[e>>2]|0,c[e+4>>2]|0)|0;d=z;b=a+1e3|0;c[b>>2]=e;c[b+4>>2]=d;b=HN(a,0)|0;b=z0(e|0,d|0,b|0,z|0)|0;a=a+1008|0;c[a>>2]=b;c[a+4>>2]=z;return}function tD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+12>>2]=0;c[a+16>>2]=e;do if(b)if(b>>>0>35791394){d=ua(8)|0;K2(d,391652);c[d>>2]=57868;Ya(d|0,2712,367)}else{e=ZW(b*120|0)|0;break}else e=0;while(0);c[a>>2]=e;d=e+(d*120|0)|0;c[a+8>>2]=d;c[a+4>>2]=d;c[a+12>>2]=e+(b*120|0);return}function uD(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;j=b+8|0;j=nb[c[(c[j>>2]|0)+20>>2]&255](j)|0;i=a[j+8+3>>0]|0;k=i<<24>>24<0;l=k?c[j>>2]|0:j;return Ae(b,c[d>>2]|0,c[e>>2]|0,f,g,h,l,l+((k?c[j+4>>2]|0:i&255)<<2)|0)|0}function vD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=b+528|0;e=c[g>>2]|0;g=z0(e|0,c[g+4>>2]|0,3,0)|0;i=z;f=b+536|0;h=c[f+4>>2]|0;if(i>>>0>h>>>0|((i|0)==(h|0)?g>>>0>(c[f>>2]|0)>>>0:0)){vt(b);b=0}else{b=(c[b+544>>2]|0)+(c[b+612>>2]|0)+e|0;b=g3(a[b>>0]|0,a[b+1>>0]|0,a[b+2>>0]|0)|0}c[d>>2]=b;return}function wD(a,b){a=a|0;b=b|0;var d=0;a=a+4|0;d=NI(b,c[a>>2]|0,a)|0;if((d|0)!=(a|0)?(c[d+16>>2]|0)>>>0<=b>>>0:0)a=d;return a|0}function xD(a){a=a|0;if(!a)return;else{xD(c[a>>2]|0);xD(c[a+4>>2]|0);laa(a);return}}function yD(a){a=a|0;if(!a)return;else{yD(c[a>>2]|0);yD(c[a+4>>2]|0);laa(a);return}}function zD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+12>>2]=0;c[a+16>>2]=e;do if(b)if(b>>>0>178956970){d=ua(8)|0;K2(d,391652);c[d>>2]=57868;Ya(d|0,2712,367)}else{e=ZW(b*24|0)|0;break}else e=0;while(0);c[a>>2]=e;d=e+(d*24|0)|0;c[a+8>>2]=d;c[a+4>>2]=d;c[a+12>>2]=e+(b*24|0);return}function AD(b){b=b|0;var d=0,e=0;if((a[407736]|0)==0?E3(407736)|0:0){c[102300]=0;c[102301]=0;c[102302]=0;d=j9(402441)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11){a[409211]=d;b=409200}else{e=d+16&-16;b=ZW(e)|0;c[102300]=b;c[102302]=e|-2147483648;c[102301]=d}i1(b,402441,d)|0;J7(b+d|0,0)}return 409200}function BD(b){b=b|0;var d=0,e=0;if((a[407744]|0)==0?E3(407744)|0:0){c[102303]=0;c[102304]=0;c[102305]=0;d=j9(402450)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11){a[409223]=d;b=409212}else{e=d+16&-16;b=ZW(e)|0;c[102303]=b;c[102305]=e|-2147483648;c[102304]=d}i1(b,402450,d)|0;J7(b+d|0,0)}return 409212}function CD(b){b=b|0;var d=0,e=0;if((a[407752]|0)==0?E3(407752)|0:0){c[102306]=0;c[102307]=0;c[102308]=0;d=j9(402462)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11){a[409235]=d;b=409224}else{e=d+16&-16;b=ZW(e)|0;c[102306]=b;c[102308]=e|-2147483648;c[102307]=d}i1(b,402462,d)|0;J7(b+d|0,0)}return 409224}function DD(b){b=b|0;var d=0,e=0;if((a[407728]|0)==0?E3(407728)|0:0){c[102297]=0;c[102298]=0;c[102299]=0;d=j9(402432)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11){a[409199]=d;b=409188}else{e=d+16&-16;b=ZW(e)|0;c[102297]=b;c[102299]=e|-2147483648;c[102298]=d}i1(b,402432,d)|0;J7(b+d|0,0)}return 409188}function ED(b){b=b|0;var d=0,e=0,f=0;do if(!(a[b+904>>0]|0))if(Pc(b+760|0)|0?(d=c[b+612>>2]|0,e=d+3|0,e>>>0<=(c[b+548>>2]|0)>>>0):0){f=c[b+544>>2]|0;if((((a[f+d>>0]|0)==119?(a[f+(d+1)>>0]|0)==118:0)?(a[f+(d+2)>>0]|0)==112:0)?(a[f+e>>0]|0)==107:0){b=1;break}a[b+376>>0]=0;b=1}else b=0;else b=1;while(0);return b|0}function FD(b){b=b|0;var d=0,e=0,f=0;f=b;a:do if(!(f&3))e=4;else{d=f;while(1){if(!(a[b>>0]|0)){b=d;break a}b=b+1|0;d=b;if(!(d&3)){e=4;break}}}while(0);if((e|0)==4){while(1){d=c[b>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))b=b+4|0;else break}if((d&255)<<24>>24)do b=b+1|0;while((a[b>>0]|0)!=0)}return b-f|0}function GD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=(d-f|0)/56|0;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b*56|0)|0;while(1){if((d|0)==(a|0))break a;f=d+-56|0;c[g>>2]=f;LT(f);d=c[g>>2]|0}}}else _t(a,b-e|0);while(0);return}function HD(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;gs(e,a,b[d>>1]|0,g);l=f;return (c[e>>2]|0)+20|0}function ID(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=a+528|0;g=e;f=c[g>>2]|0;g=z0(f|0,c[g+4>>2]|0,4,0)|0;d=z;h=a+536|0;i=c[h+4>>2]|0;if(d>>>0>i>>>0|((d|0)==(i|0)?g>>>0>(c[h>>2]|0)>>>0:0)){vt(a);c[b>>2]=0}else{c[b>>2]=W8((c[a+544>>2]|0)+(c[a+612>>2]|0)+f|0)|0;i=e;c[i>>2]=g;c[i+4>>2]=d}return}function JD(){var b=0,e=0,f=0,g=0;g=l;l=l+16|0;f=g;a[f>>0]=10;b=c[12741]|0;if(!b)if(!(pN(50948)|0)){b=c[12741]|0;e=4}else b=-1;else e=4;do if((e|0)==4){e=c[12742]|0;if(!(e>>>0>=b>>>0|(a[51023]|0)==10)){c[12742]=e+1;a[e>>0]=10;b=10;break}if((gb[c[50984>>2]&31](50948,f,1)|0)==1)b=d[f>>0]|0;else b=-1}while(0);l=g;return b|0}function KD(a,b){a=a|0;b=b|0;b=wD(a,b)|0;if((b|0)!=(a+4|0))fy(a,b);return}function LD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;e=a+528|0;g=e;f=c[g>>2]|0;g=z0(f|0,c[g+4>>2]|0,4,0)|0;d=z;h=a+536|0;i=c[h+4>>2]|0;if(d>>>0>i>>>0|((d|0)==(i|0)?g>>>0>(c[h>>2]|0)>>>0:0)){vt(a);c[b>>2]=0}else{c[b>>2]=C9((c[a+544>>2]|0)+(c[a+612>>2]|0)+f|0)|0;i=e;c[i>>2]=g;c[i+4>>2]=d}return}function MD(a){a=a|0;var d=0,e=0,f=0,g=0,h=0;f=l;l=l+16|0;d=f;e=a+528|0;h=e;h=z0(c[h>>2]|0,c[h+4>>2]|0,6,0)|0;g=e;c[g>>2]=h;c[g+4>>2]=z;NB(a,d);d=b[d>>1]|0;a=0;while(1){if((a&65535)>(d&65535))break;g=e;g=z0(c[g>>2]|0,c[g+4>>2]|0,8,0)|0;h=e;c[h>>2]=g;c[h+4>>2]=z;a=a+1<<16>>16}l=f;return}function ND(a,b){a=+a;b=b|0;var d=0,e=0,f=0;h[j>>3]=a;d=c[j>>2]|0;e=c[j+4>>2]|0;f=XZ(d|0,e|0,52)|0;switch(f&2047){case 0:{if(a!=0.0){a=+ND(a*18446744073709551616.0,b);d=(c[b>>2]|0)+-64|0}else d=0;c[b>>2]=d;break}case 2047:break;default:{c[b>>2]=(f&2047)+-1022;c[j>>2]=d;c[j+4>>2]=e&-2146435073|1071644672;a=+h[j>>3]}}return +a}function OD(b,e){b=b|0;e=e|0;var f=0,g=0;g=0;while(1){if((d[393221+g>>0]|0)==(b|0)){b=2;break}f=g+1|0;if((f|0)==87){f=393309;g=87;b=5;break}else g=f}if((b|0)==2)if(!g)f=393309;else{f=393309;b=5}if((b|0)==5)while(1){do{b=f;f=f+1|0}while((a[b>>0]|0)!=0);g=g+-1|0;if(!g)break;else b=5}return b9(f,c[e+20>>2]|0)|0}function PD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=a+4|0;f=c[h>>2]|0;a=b+(((f-e|0)/40|0)*40|0)|0;e=a;g=f;while(1){if(e>>>0>=d>>>0)break;yw(g,e);i=(c[h>>2]|0)+40|0;c[h>>2]=i;e=e+40|0;g=i}while(1){if((a|0)==(b|0))break;i=a+-40|0;d=f+-40|0;Kq(d,i)|0;f=d;a=i}return}function QD(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0;j=b+8|0;j=nb[c[(c[j>>2]|0)+20>>2]&255](j)|0;i=a[j+11>>0]|0;k=i<<24>>24<0;l=k?c[j>>2]|0:j;return te(b,c[d>>2]|0,c[e>>2]|0,f,g,h,l,l+(k?c[j+4>>2]|0:i&255)|0)|0}function RD(a){a=a|0;var b=0,d=0;d=HN(a,0)|0;b=a+528|0;c[b>>2]=d;c[b+4>>2]=z;if(qO(a)|0){Kc(a,2,-1)|0;d=a+20|0;RB(a,2,c[d>>2]|0,18,379645,-1,1,0);RB(a,2,c[d>>2]|0,52,379650,-1,1,0);V5(a)}return}function SD(b){b=b|0;var d=0,e=0,f=0;d=l;l=l+16|0;e=d+4|0;bB(b,e);jB(b,d);if(!(a[e>>0]|0)){if(qO(b)|0)nh(b)}else{f=b+536|0;e=b+528|0;e=D_(c[f>>2]|0,c[f+4>>2]|0,c[e>>2]|0,c[e+4>>2]|0)|0;e1(b,e,z)}l=d;return}function TD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+12>>2]=0;c[a+16>>2]=e;do if(b)if(b>>>0>1431655765){d=ua(8)|0;K2(d,391652);c[d>>2]=57868;Ya(d|0,2712,367)}else{e=ZW(b*3|0)|0;break}else e=0;while(0);c[a>>2]=e;d=e+(d*3|0)|0;c[a+8>>2]=d;c[a+4>>2]=d;c[a+12>>2]=e+(b*3|0);return}function UD(a,b){a=a|0;b=b|0;var d=0;a=a+4|0;d=dJ(b,c[a>>2]|0,a)|0;if((d|0)!=(a|0)?(e[d+16>>1]|0)<=(b&65535):0)a=d;return a|0}function VD(a){a=a|0;if(!a)return;else{VD(c[a>>2]|0);VD(c[a+4>>2]|0);w4(a+16|0);laa(a);return}}function WD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;f=a+528|0;d=c[f>>2]|0;f=z0(d|0,c[f+4>>2]|0,7,0)|0;h=z;e=a+536|0;g=c[e+4>>2]|0;if(h>>>0>g>>>0|((h|0)==(g|0)?f>>>0>(c[e>>2]|0)>>>0:0)){vt(a);a=0;d=0}else{a=o6((c[a+544>>2]|0)+(c[a+612>>2]|0)+d|0)|0;d=z}h=b;c[h>>2]=a;c[h+4>>2]=d;return}function XD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;f=a+528|0;d=c[f>>2]|0;f=z0(d|0,c[f+4>>2]|0,6,0)|0;h=z;e=a+536|0;g=c[e+4>>2]|0;if(h>>>0>g>>>0|((h|0)==(g|0)?f>>>0>(c[e>>2]|0)>>>0:0)){vt(a);a=0;d=0}else{a=p6((c[a+544>>2]|0)+(c[a+612>>2]|0)+d|0)|0;d=z}h=b;c[h>>2]=a;c[h+4>>2]=d;return}function YD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;f=a+528|0;d=c[f>>2]|0;f=z0(d|0,c[f+4>>2]|0,5,0)|0;h=z;e=a+536|0;g=c[e+4>>2]|0;if(h>>>0>g>>>0|((h|0)==(g|0)?f>>>0>(c[e>>2]|0)>>>0:0)){vt(a);a=0;d=0}else{a=q6((c[a+544>>2]|0)+(c[a+612>>2]|0)+d|0)|0;d=z}h=b;c[h>>2]=a;c[h+4>>2]=d;return}function ZD(a){a=a|0;var b=0,d=0,e=0;d=l;l=l+16|0;b=d;W5(a);TX(b);e=a+536|0;jZ(a,c[e>>2]|0,c[e+4>>2]|0,b);if(qO(a)|0){RB(a,0,0,57,379670,-1,1,0);Mc(a,0,0,380183,b,0)}z5(b);l=d;return}function _D(a){a=a|0;var b=0.0,d=0,e=0,f=0;d=a+40|0;e=a+768|0;e=D_(c[d>>2]|0,c[d+4>>2]|0,c[e>>2]|0,c[e+4>>2]|0)|0;d=z;f=a+904|0;b=(+((c[f>>2]|0)>>>0)+4294967296.0*+((c[f+4>>2]|0)>>>0))/(+(e>>>0)+4294967296.0*+(d>>>0));oK(a,2,0,194,e,d,10,0);Bt(a,2,0,155,b,3,0);Vt(a+760|0);return}function $D(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;kr(d,a,b,f);l=e;return (c[d>>2]|0)+32|0}function aE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;h=a[b+8+3>>0]|0;f=h<<24>>24<0;g=b+4|0;h=h&255;i=0;while(1){if(f)e=c[g>>2]|0;else e=h;if(i>>>0>=e>>>0)break;if(f)e=c[b>>2]|0;else e=b;if((c[e+(i<<2)>>2]|0)!=(d|0))break;i=i+1|0}if(f)e=c[b>>2]|0;else e=b;GX(b,e+(i<<2)|0)|0;return b|0}function bE(a){a=a|0;var b=0,d=0,e=0;e=a+528|0;b=e;b=z0(c[b>>2]|0,c[b+4>>2]|0,16,0)|0;d=e;c[d>>2]=b;c[d+4>>2]=z;KK(a);d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,4,0)|0;b=z;c[e>>2]=d;c[e+4>>2]=b;e=a+536|0;b=D_(c[e>>2]|0,c[e+4>>2]|0,d|0,b|0)|0;e1(a,b,z);KM(a);return}function cE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=(d-f|0)/40|0;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b*40|0)|0;while(1){if((d|0)==(a|0))break a;f=d+-40|0;c[g>>2]=f;$_(f);d=c[g>>2]|0}}}else hu(a,b-e|0);while(0);return}function dE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=ZW(56)|0;c[b>>2]=f;c[b+4>>2]=d+4;g=c[e>>2]|0;d=c[g+4>>2]|0;e=f+16|0;c[e>>2]=c[g>>2];c[e+4>>2]=d;lV(f+24|0);a[b+8>>0]=1;return}function eE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=ZW(184)|0;c[b>>2]=f;c[b+4>>2]=d+4;g=c[e>>2]|0;d=c[g+4>>2]|0;e=f+16|0;c[e>>2]=c[g>>2];c[e+4>>2]=d;iu(f+24|0);a[b+8>>0]=1;return}function fE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+12>>2]=0;c[a+16>>2]=e;do if(b)if(b>>>0>76695844){d=ua(8)|0;K2(d,391652);c[d>>2]=57868;Ya(d|0,2712,367)}else{e=ZW(b*56|0)|0;break}else e=0;while(0);c[a>>2]=e;d=e+(d*56|0)|0;c[a+8>>2]=d;c[a+4>>2]=d;c[a+12>>2]=e+(b*56|0);return}function gE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=a+528|0;f=e;b=z0(c[f>>2]|0,c[f+4>>2]|0,b|0,d|0)|0;d=z;f=HN(a,0)|0;if(!((b|0)==(f|0)&(d|0)==(z|0))?(f=a+536|0,g=c[f+4>>2]|0,d>>>0>g>>>0|((d|0)==(g|0)?b>>>0>(c[f>>2]|0)>>>0:0)):0)vt(a);else{g=e;c[g>>2]=b;c[g+4>>2]=d}return}function hE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;f=l;l=l+32|0;d=f;e=c[a>>2]|0;if((((c[a+8>>2]|0)-e|0)/40|0)>>>0<b>>>0){lE(d,b,((c[a+4>>2]|0)-e|0)/40|0,a+8|0);Bz(a,d);VP(d)}l=f;return}function iE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(40)|0;c[b>>2]=f;c[b+4>>2]=d+4;wz(f+16|0,c[e>>2]|0);e=f+32|0;c[e>>2]=0;c[e+4>>2]=0;a[b+8>>0]=1;return}function jE(a){a=a|0;if(!a)return;else{jE(c[a>>2]|0);jE(c[a+4>>2]|0);C8(a+16|0);laa(a);return}}function kE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;As(d,a,c[b>>2]|0,c[b+4>>2]|0,f);l=e;return (c[d>>2]|0)+24|0}function lE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+12>>2]=0;c[a+16>>2]=e;do if(b)if(b>>>0>107374182){d=ua(8)|0;K2(d,391652);c[d>>2]=57868;Ya(d|0,2712,367)}else{e=ZW(b*40|0)|0;break}else e=0;while(0);c[a>>2]=e;d=e+(d*40|0)|0;c[a+8>>2]=d;c[a+4>>2]=d;c[a+12>>2]=e+(b*40|0);return}function mE(a){a=a|0;var b=0,d=0,e=0,f=0;d=l;l=l+16|0;b=d;CK(a);CK(a);e=a+528|0;f=e;f=z0(c[f>>2]|0,c[f+4>>2]|0,12,0)|0;c[e>>2]=f;c[e+4>>2]=z;CK(a);bD(a,b);b=c[b>>2]|0;if(b|0)e1(a,b,0);l=d;return}function nE(a){a=a|0;var b=0,d=0;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){d=(kE(a+760|0,a+840|0)|0)+72|0;c[d>>2]=0;c[d+4>>2]=0;d=c[a+16>>2]|0;b=c[a+20>>2]|0;xM(a,d,b,382758,dI(0,0)|0,1)}return}function oE(a){a=a|0;var b=0,c=0,d=0;d=0;while(1){if((d|0)==7)break;else c=0;while(1){if(c>>>0<(RA(a,d,-1)|0)>>>0)b=0;else break;while(1){if(b>>>0>=(RA(a,d,c)|0)>>>0)break;Ib(a,d,c,b);b=b+1|0}c=c+1|0}d=d+1|0}return}function pE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;zs(d,a,c[b>>2]|0,c[b+4>>2]|0,f);l=e;return (c[d>>2]|0)+24|0}function qE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=l;l=l+48|0;f=e+24|0;g=e+12|0;h=e;VU(f,b);VU(g,d);TU(h,c[a>>2]|0,f,g);_E(h);O0(h);z5(g);z5(f);l=e;return}function rE(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;a:do if(b|0){f=b+4|0;g=b+12|0;e=a+648|0;a=0;while(1){if(a>>>0>=(((c[f>>2]|0)-(c[b>>2]|0)|0)/24|0)>>>0)break a;d4(c[e>>2]|0,(d[g>>0]|0)+1&255);d4(c[e>>2]|0,(d[g>>0]|0)+1&255);a=a+1|0}}while(0);return}function sE(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if(c>>>0>0|(c|0)==0&b>>>0>4294967295){while(1){e=nW(b|0,c|0,10,0)|0;d=d+-1|0;a[d>>0]=e&255|48;e=b;b=g5(b|0,c|0,10,0)|0;if(!(c>>>0>9|(c|0)==9&e>>>0>4294967295))break;else c=z}c=b}else c=b;if(c)while(1){d=d+-1|0;a[d>>0]=(c>>>0)%10|0|48;if(c>>>0<10)break;else c=(c>>>0)/10|0}return d|0}function tE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+12>>2]=0;c[a+16>>2]=e;do if(b)if(b>>>0>134217727){d=ua(8)|0;K2(d,391652);c[d>>2]=57868;Ya(d|0,2712,367)}else{e=ZW(b<<5)|0;break}else e=0;while(0);c[a>>2]=e;d=e+(d<<5)|0;c[a+8>>2]=d;c[a+4>>2]=d;c[a+12>>2]=e+(b<<5);return}function uE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+12>>2]=0;c[a+16>>2]=e;do if(b)if(b>>>0>268435455){d=ua(8)|0;K2(d,391652);c[d>>2]=57868;Ya(d|0,2712,367)}else{e=ZW(b<<4)|0;break}else e=0;while(0);c[a>>2]=e;d=e+(d<<4)|0;c[a+8>>2]=d;c[a+4>>2]=d;c[a+12>>2]=e+(b<<4);return}function vE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;g=a+4|0;b=c[g>>2]|0;f=c[a>>2]|0;d=b-f|0;e=(d|0)/12|0;a:do if(e>>>0>=7){if((d|0)!=84){a=f+84|0;while(1){if((b|0)==(a|0))break a;f=b+-12|0;c[g>>2]=f;cU(f);b=c[g>>2]|0}}}else yu(a,7-e|0);while(0);return}function wE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;a:while(1){while(1){if(!d)break a;f=d+16|0;g=c[f+4>>2]|0;if(!(g>>>0<b>>>0|((g|0)==(b|0)?(c[f>>2]|0)>>>0<a>>>0:0)))break;d=c[d+4>>2]|0}e=d;d=c[d>>2]|0}return e|0}function xE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+12>>2]=0;c[a+16>>2]=e;do if(b)if(b>>>0>357913941){d=ua(8)|0;K2(d,391652);c[d>>2]=57868;Ya(d|0,2712,367)}else{e=ZW(b*12|0)|0;break}else e=0;while(0);c[a>>2]=e;d=e+(d*12|0)|0;c[a+8>>2]=d;c[a+4>>2]=d;c[a+12>>2]=e+(b*12|0);return}function yE(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;h=d+528|0;f=c[h>>2]|0;h=z0(f|0,c[h+4>>2]|0,2,0)|0;j=z;g=d+536|0;i=c[g+4>>2]|0;if(j>>>0>i>>>0|((j|0)==(i|0)?h>>>0>(c[g>>2]|0)>>>0:0)){vt(d);d=0}else{d=(c[d+544>>2]|0)+(c[d+612>>2]|0)+f|0;d=A5(a[d>>0]|0,a[d+1>>0]|0)|0}b[e>>1]=d;return}function zE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;f=a+528|0;d=c[f>>2]|0;f=z0(d|0,c[f+4>>2]|0,8,0)|0;h=z;e=a+536|0;g=c[e+4>>2]|0;if(h>>>0>g>>>0|((h|0)==(g|0)?f>>>0>(c[e>>2]|0)>>>0:0)){vt(a);a=0;d=0}else{a=f8((c[a+544>>2]|0)+(c[a+612>>2]|0)+d|0)|0;d=z}h=b;c[h>>2]=a;c[h+4>>2]=d;return}function AE(b){b=b|0;var d=0,f=0,g=0,h=0;h=l;l=l+16|0;d=h;g=b+778|0;if((e[g>>1]|0)<256){bB(b,d);f=a[d>>0]|0;d=0;while(1){if((d&255)>=(f&255))break;NB(b,g);_d(b);d=d+1<<24>>24}}else{g=b+536|0;e1(b,c[g>>2]|0,c[g+4>>2]|0)}l=h;return}function BE(a){a=a|0;var b=0,d=0,e=0;d=a+528|0;e=d;e=z0(c[e>>2]|0,c[e+4>>2]|0,10,0)|0;b=d;c[b>>2]=e;c[b+4>>2]=z;Bx(a);b=a+648|0;A6(c[b>>2]|0);d4(c[b>>2]|0,7);wK(a);b=d;b=z0(c[b>>2]|0,c[b+4>>2]|0,3,0)|0;a=d;c[a>>2]=b;c[a+4>>2]=z;return}function CE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=a+4|0;f=c[h>>2]|0;a=b+(((f-e|0)/12|0)*12|0)|0;e=a;g=f;while(1){if(e>>>0>=d>>>0)break;rV(g,e);i=(c[h>>2]|0)+12|0;c[h>>2]=i;e=e+12|0;g=i}while(1){if((a|0)==(b|0))break;i=a+-12|0;d=f+-12|0;vF(d,i)|0;f=d;a=i}return}function DE(a,b,d){a=a|0;b=b|0;d=d|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[b>>2]=d;a=c[c[101925]>>2]|0;if(a){c[101925]=a;d=c[b>>2]|0}gp(c[101926]|0,d);c[101927]=(c[101927]|0)+1;return}function EE(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;ws(e,a,b[d>>1]|0,g);l=f;return (c[e>>2]|0)+20|0}function FE(b){b=b|0;var d=0;GC(b);d=b+648|0;d4(c[d>>2]|0,3);A6(c[d>>2]|0);A6(c[d>>2]|0);A6(c[d>>2]|0);d4(c[d>>2]|0,3);if(!(a[b+2464>>0]|0))Eb(b);J3(b);return}function GE(a){a=a|0;var b=0,d=0,e=0;IV(a);e=(c[a>>2]&1|0)!=0;if(!e){taa();d=c[a+52>>2]|0;b=a+56|0;if(d|0)c[d+56>>2]=c[b>>2];b=c[b>>2]|0;if(b|0)c[b+52>>2]=d;if((c[102272]|0)==(a|0))c[102272]=b;paa()}b=ZK(a)|0;b=nb[c[a+12>>2]&255](a)|0|b;d=c[a+92>>2]|0;if(d|0)pe(d);if(e)return b|0;else{pe(a);return b|0}return 0}function HE(a){a=a|0;var b=0,d=0,e=0;d=l;l=l+16|0;b=d+8|0;e=d;c[e>>2]=a;Tp(b,a,e);l=d;return (c[b>>2]|0)+28|0}function IE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=l;l=l+64|0;f=h+16|0;g=h;e=c[a>>2]|0;if((((c[a+4>>2]|0)-e|0)/40|0)>>>0<=d>>>0){TX(g);hB(f,g);Wt(a,f,d);$_(f);z5(g);e=c[a>>2]|0}ar(e+(d*40|0)|0,b,0);l=h;return}function JE(a){a=a|0;do switch(a<<24>>24){case 0:{a=387164;break}case 1:{a=387145;break}case 2:{a=387123;break}case 3:{a=387092;break}case 4:{a=387085;break}case 5:{a=387060;break}case 6:{a=387052;break}case 7:{a=387001;break}case 8:{a=386983;break}case 15:{a=385637;break}default:a=391133}while(0);return a|0}function KE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;e=a+528|0;f=e;f=z0(c[f>>2]|0,c[f+4>>2]|0,12,0)|0;d=e;c[d>>2]=f;c[d+4>>2]=z;d=0;while(1){if((d|0)==(b|0))break;GC(a);g=e;g=z0(c[g>>2]|0,c[g+4>>2]|0,12,0)|0;f=e;c[f>>2]=g;c[f+4>>2]=z;J3(a);d=d+1|0}return}function LE(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;k=e;j=a+8|0;h=0;i=0;a:while(1){if((d|0)==(e|0)|h>>>0>=f>>>0)break;g=a0(c[j>>2]|0)|0;a=m6(d,k-d|0,b)|0;if(g|0)a0(g)|0;switch(a|0){case -2:case -1:break a;case 0:{a=1;break}default:{}}h=h+1|0;i=a+i|0;d=d+a|0}return i|0}function ME(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=(d-f|0)/12|0;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b*12|0)|0;while(1){if((d|0)==(a|0))break a;f=d+-12|0;c[g>>2]=f;z5(f);d=c[g>>2]|0}}}else Ku(a,b-e|0);while(0);return}function NE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;g=a+4|0;b=c[g>>2]|0;f=c[a>>2]|0;d=b-f|0;e=(d|0)/24|0;a:do if(e>>>0>=64){if((d|0)!=1536){a=f+1536|0;while(1){if((b|0)==(a|0))break a;f=b+-24|0;c[g>>2]=f;b=f}}}else Ks(a,64-e|0);while(0);return}function OE(a){a=a|0;if(!a)return;else{OE(c[a>>2]|0);OE(c[a+4>>2]|0);Z7(a+16|0);laa(a);return}}function PE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(40)|0;c[b>>2]=f;c[b+4>>2]=d+4;wz(f+16|0,c[e>>2]|0);TX(f+28|0);a[b+8>>0]=1;return}function QE(d){d=d|0;var e=0,f=0;Eg(d);c[d>>2]=41324;a[d+760>>0]=1;c[d+764>>2]=0;b[d+768>>1]=-1;b[d+776>>1]=0;c[d+772>>2]=0;f=d+780|0;b[d+786>>1]=0;e=d+793|0;a[d+791>>0]=0;c[f>>2]=0;a[f+4>>0]=0;a[e>>0]=0;a[e+1>>0]=0;a[e+2>>0]=0;a[e+3>>0]=0;a[e+4>>0]=0;a[d+798>>0]=(fT()|0)&1;return}function RE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=ZW(32)|0;c[b>>2]=f;c[b+4>>2]=d+4;g=c[e>>2]|0;d=c[g+4>>2]|0;e=f+16|0;c[e>>2]=c[g>>2];c[e+4>>2]=d;e=f+24|0;c[e>>2]=0;c[e+4>>2]=0;a[b+8>>0]=1;return}function SE(a,d){a=a|0;d=d|0;var e=0;c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];b[a+24>>1]=b[d+24>>1]|0;GK(a+28|0,d+28|0);e=a+40|0;a=d+40|0;d=e+80|0;do{c[e>>2]=c[a>>2];e=e+4|0;a=a+4|0}while((e|0)<(d|0));return}function TE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=a+20|0;h=a+28|0;if((c[b>>2]|0)>>>0>(c[h>>2]|0)>>>0?(gb[c[a+36>>2]&31](a,0,0)|0,(c[b>>2]|0)==0):0)a=-1;else{d=a+4|0;e=c[d>>2]|0;f=a+8|0;g=c[f>>2]|0;if(e>>>0<g>>>0)gb[c[a+40>>2]&31](a,e-g|0,1)|0;c[a+16>>2]=0;c[h>>2]=0;c[b>>2]=0;c[f>>2]=0;c[d>>2]=0;a=0}return a|0}function UE(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;i=h;O4(i,e);e=u$(c[i>>2]|0,409148)|0;c6(i);fG(a,g+16|0,b,c[d>>2]|0,f,e);l=h;return c[b>>2]|0}function VE(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;i=h;O4(i,e);e=u$(c[i>>2]|0,409148)|0;c6(i);CG(a,g+24|0,b,c[d>>2]|0,f,e);l=h;return c[b>>2]|0}function WE(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;i=h;O4(i,e);e=u$(c[i>>2]|0,409116)|0;c6(i);gG(a,g+16|0,b,c[d>>2]|0,f,e);l=h;return c[b>>2]|0}function XE(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;i=h;O4(i,e);e=u$(c[i>>2]|0,409116)|0;c6(i);DG(a,g+24|0,b,c[d>>2]|0,f,e);l=h;return c[b>>2]|0}function YE(b){b=b|0;var d=0;Eg(b);d=b+760|0;BG(d);c[b>>2]=16132;TX(b+944|0);c[d>>2]=b;a[b+733>>0]=1;d=b+632|0;c[d>>2]=32768;c[d+4>>2]=0;d=b+896|0;c[d>>2]=2;c[d+4>>2]=0;a[b+904>>0]=0;a[b+905>>0]=0;c[b+908>>2]=-1;c[b+912>>2]=0;c[b+916>>2]=0;a[b+930>>0]=-1;a[b+931>>0]=0;c[b+932>>2]=0;return}function ZE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;f=l;l=l+32|0;d=f;e=c[a>>2]|0;if((((c[a+8>>2]|0)-e|0)/12|0)>>>0<b>>>0){xE(d,b,((c[a+4>>2]|0)-e|0)/12|0,a+8|0);Qz(a,d);HQ(d)}l=f;return}function _E(b){b=b|0;var d=0,e=0,f=0,g=0;g=b+8+3|0;d=a[g>>0]|0;if(d<<24>>24<0){d=c[b+4>>2]|0;if(d>>>0<8388607)f=4;else{d=8388607;e=0}}else{d=d&255;f=4}if((f|0)==4)e=0;while(1){a[411044+d>>0]=e;e=d+-1|0;if((d|0)<=0)break;if((a[g>>0]|0)<0)f=c[b>>2]|0;else f=b;d=e;e=c[f+(e<<2)>>2]&255}return}function $E(d){d=d|0;var f=0,g=0,h=0;if(((a[d+492>>0]|0)==0?(f=c[d+832>>2]|0,(f|0)!=-1):0)?(g=c[d+828>>2]|0,(g|0)!=-1):0){f=(e[d+846>>1]|0)+((f-g|0)*1e3|0)-(e[d+844>>1]|0)|0;g=c[d+824>>2]|0;if((g|0)!=0?(h=b[d+852>>1]|0,h<<16>>16!=0):0)f=(r6(1.0e3/(+(h&65535)/+(g>>>0)))|0)+f|0;lL(d,1,0,76,f,10,0)}return}function aF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;f=a+4|0;b=c[f>>2]|0;e=c[a>>2]|0;g=b-e|0;d=(g|0)/24|0;a:do if(g){if(d>>>0>1){a=e+24|0;while(1){if((b|0)==(a|0))break a;g=b+-24|0;c[f>>2]=g;b=g}}}else Ks(a,1-d|0);while(0);return}function bF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;ks(d,a,c[b>>2]|0,f);l=e;return (c[d>>2]|0)+24|0}function cF(b){b=b|0;var d=0,e=0,f=0;d=jF(b+760|0,b+772|0)|0;f=c[d>>2]|0;if((f|0)!=(c[d+4>>2]|0)?(c[(c[f>>2]|0)+728>>2]&8|0)==0:0){if((c[d+52>>2]|0)>>>0>299?+g[(c[b+24>>2]|0)+136>>2]<1.0:0)e=5}else e=5;if((e|0)==5){a[d+80>>0]=0;f=b+1038|0;a[f>>0]=(a[f>>0]|0)+-1<<24>>24}return}function dF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i;if((a|0)==(b|0)){c[d>>2]=4;e=0.0}else{g=c[12784]|0;c[12784]=0;b0()|0;e=+s9(a,f);a=c[12784]|0;if(!a)c[12784]=g;if((c[f>>2]|0)==(b|0)){if((a|0)==34)h=6}else{e=0.0;h=6}if((h|0)==6)c[d>>2]=4}l=i;return +e}function eF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i;if((a|0)==(b|0)){c[d>>2]=4;e=0.0}else{g=c[12784]|0;c[12784]=0;b0()|0;e=+A9(a,f);a=c[12784]|0;if(!a)c[12784]=g;if((c[f>>2]|0)==(b|0)){if((a|0)==34)h=6}else{e=0.0;h=6}if((h|0)==6)c[d>>2]=4}l=i;return +e}function fF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i;if((a|0)==(b|0)){c[d>>2]=4;e=0.0}else{g=c[12784]|0;c[12784]=0;b0()|0;e=+B9(a,f);a=c[12784]|0;if(!a)c[12784]=g;if((c[f>>2]|0)==(b|0)){if((a|0)==34)h=6}else{e=0.0;h=6}if((h|0)==6)c[d>>2]=4}l=i;return +e}function gF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=a[e+8+3>>0]|0;a:do if((f<<24>>24<0?c[e+4>>2]|0:f&255)|0){f=0;while(1){if(f>>>0>=(RA(b,1,-1)|0)>>>0)break a;zb(b,1,f,245,e,0);zb(b,1,f,247,d,0);f=f+1|0}}while(0);return}function hF(a){a=a|0;GC(a);Bx(a);A6(c[a+648>>2]|0);AT(a,a+809|0);RS(a);RS(a);xR(a,2,a+807|0);AT(a,a+808|0);wK(a);J3(a);return}function iF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=a+528|0;g=e;f=c[g>>2]|0;g=c[g+4>>2]|0;h=z0(f|0,g|0,b|0,d|0)|0;j=z;d=a+536|0;i=c[d+4>>2]|0;if(j>>>0>i>>>0|((j|0)==(i|0)?h>>>0>(c[d>>2]|0)>>>0:0))vt(a);else{i=z0(f|0,g|0,b|0,0)|0;j=e;c[j>>2]=i;c[j+4>>2]=z}return}function jF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;os(d,a,c[b>>2]|0,f);l=e;return (c[d>>2]|0)+24|0}function kF(b){b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e;e1(b,c[b+936>>2]|0,0);if(qO(b)|0?($x(d,b,2,0,153,1),f=a[d+8+3>>0]|0,f=((f<<24>>24<0?c[d+4>>2]|0:f&255)|0)==0,z5(d),f):0)RB(b,2,0,153,379718,-1,1,1);l=e;return}function lF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;f=a+648|0;b=c[f>>2]|0;d=c[b+4>>2]|0;if(!(raa(d)|0))vt(a);else{e=0;a=d;while(1){if(!a)break;if(NF(b)|0){g=5;break}b=c[f>>2]|0;e=e+1<<24>>24;a=c[b+4>>2]|0}if((g|0)==5)b=c[f>>2]|0;BH(b,e&255)}return}function mF(b){b=b|0;var c=0,d=0;d=a[b>>0]|0;a:do if(!(d<<24>>24))b=1;else{c=0;while(1){switch(d<<24>>24|0){case 42:case 63:case 92:{b=0;break a}case 91:{c=1;break}case 93:{if(!c)c=0;else{b=0;break a}break}default:{}}b=b+1|0;d=a[b>>0]|0;if(!(d<<24>>24)){b=1;break a}}}while(0);return b|0}function nF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=b>>31|((b|0)<0?-1:0)<<1;i=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;f=d>>31|((d|0)<0?-1:0)<<1;e=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;h=D_(j^a|0,i^b|0,j|0,i|0)|0;g=z;a=f^j;b=e^i;return D_((ph(h,g,D_(f^c|0,e^d|0,f|0,e|0)|0,z,0)|0)^a|0,z^b|0,a|0,b|0)|0}function oF(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0;m=l;l=l+16|0;i=m;a[i>>0]=37;j=i+1|0;a[j>>0]=g;k=i+2|0;a[k>>0]=h;a[i+3>>0]=0;if(h<<24>>24){a[j>>0]=h;a[k>>0]=g}k=k8(d,c[e>>2]|0)|0;c[e>>2]=d+(Aa(d|0,k|0,i|0,f|0,c[b>>2]|0)|0);l=m;return}function pF(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=ZW(60)|0;c[d>>2]=g;c[d+4>>2]=e+4;b[g+16>>1]=b[c[f>>2]>>1]|0;gX(g+20|0);a[d+8>>0]=1;return}function qF(a){a=a|0;var b=0,d=0,e=0;d=l;l=l+16|0;b=d;TX(b);e=a+536|0;xZ(a,c[e>>2]|0,c[e+4>>2]|0,b);if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)Mc(a,c[a+16>>2]|0,c[a+20>>2]|0,380183,b,0);z5(b);l=d;return}function rF(a){a=a|0;c[a>>2]=22636;cU(a+960|0);uS(a+936|0);GW(a+916|0);z5(a+832|0);WM(a+808|0);a1(a+772|0);bt(a);return}function sF(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;ss(e,a,b[d>>1]|0,g);l=f;return (c[e>>2]|0)+24|0}function tF(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;if(e&2048){a[b>>0]=43;b=b+1|0}if(!(e&512))f=b;else{a[b>>0]=35;f=b+1|0}while(1){b=a[c>>0]|0;if(!(b<<24>>24))break;a[f>>0]=b;c=c+1|0;f=f+1|0}switch(e&74){case 64:{b=111;break}case 8:{b=e&16384|0?88:120;break}default:b=d?100:117}a[f>>0]=b;return}function uF(b){b=b|0;var d=0,e=0;if(!(a[b+908>>0]|0)){a[b+910>>0]=1;d=b+48|0;d=z0(c[b+612>>2]|0,0,c[d>>2]|0,c[d+4>>2]|0)|0;e=b+656|0;e=D_(d|0,z|0,c[e>>2]|0,c[e+4>>2]|0)|0;d=b+872|0;c[d>>2]=e;c[d+4>>2]=z;a[b+884>>0]=1}else{e=HN(b,0)|0;e1(b,e,z)}return}function vF(b,d){b=b|0;d=d|0;var e=0;e=b+8+3|0;if((a[e>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0}else{y7(b,0);a[e>>0]=0}pp(b,0);c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];e=0;while(1){if((e|0)==3)break;c[d+(e<<2)>>2]=0;e=e+1|0}return b|0}function wF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=l;l=l+64|0;f=h+16|0;g=h;e=c[a>>2]|0;if((((c[a+4>>2]|0)-e|0)/40|0)>>>0<=b>>>0){TX(g);hB(f,g);Wt(a,f,b);$_(f);z5(g);e=c[a>>2]|0}d=DN(e+(b*40|0)|0,d)|0;l=h;return d|0}function xF(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=ZW(128)|0;c[d>>2]=g;c[d+4>>2]=e+4;b[g+16>>1]=b[c[f>>2]>>1]|0;zy(g+20|0);a[d+8>>0]=1;return}function yF(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=UW(O(((d&15)!=0&1)+((d&65535)>>>4&65535)|0,((c&15)!=0&1)+((c&65535)>>>4&65535)|0)|0,0,a|0,b|0)|0;a=g5(a|0,z|0,8160,0)|0;b=z;c=a&4095;if(c>>>0>2047){b=z0(4096-c|0,0,a|0,b|0)|0;a=z}else{b=D_(a|0,b|0,c|0,0)|0;a=z}c=a>>>0>0|(a|0)==0&b>>>0>8192;d=c?b:8192;return d|0}function zF(a){a=a|0;var b=0,d=0,e=0;b=an(a)|0;d=z;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){e=(kE(a+760|0,a+840|0)|0)+24|0;c[e>>2]=b;c[e+4>>2]=d;oK(a,c[a+16>>2]|0,c[a+20>>2]|0,14,b,d,10,0)}return}function AF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=a+528|0;f=a+536|0;e=b;d=c[e+4>>2]|0;e=c[e>>2]|0;while(1){g=f;h=c[g+4>>2]|0;if(!(d>>>0<h>>>0|((d|0)==(h|0)?e>>>0<(c[g>>2]|0)>>>0:0)))break;iF(a,3,0);e=b;e=z0(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;d=z;h=b;c[h>>2]=e;c[h+4>>2]=d}return}function BF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+12>>2]=0;c[a+16>>2]=e;do if(b)if(b>>>0>1073741823){d=ua(8)|0;K2(d,391652);c[d>>2]=57868;Ya(d|0,2712,367)}else{e=ZW(b<<2)|0;break}else e=0;while(0);c[a>>2]=e;d=e+(d<<2)|0;c[a+8>>2]=d;c[a+4>>2]=d;c[a+12>>2]=e+(b<<2);return}function CF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0;i=l;l=l+128|0;h=i;f=h;g=f+124|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=h+4|0;c[f>>2]=a;g=h+8|0;c[g>>2]=-1;c[h+44>>2]=a;c[h+76>>2]=-1;NV(h,0);e=+Pf(h,d,1);d=(c[f>>2]|0)-(c[g>>2]|0)+(c[h+108>>2]|0)|0;if(b|0)c[b>>2]=d|0?a+d|0:a;l=i;return +e}function DF(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=ZW(28)|0;c[d>>2]=g;c[d+4>>2]=e+4;b[g+16>>1]=b[c[f>>2]>>1]|0;h4(g+20|0);a[d+8>>0]=1;return}function EF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+12>>2]=0;c[a+16>>2]=e;do if(b)if(b>>>0>536870911){d=ua(8)|0;K2(d,391652);c[d>>2]=57868;Ya(d|0,2712,367)}else{e=ZW(b<<3)|0;break}else e=0;while(0);c[a>>2]=e;d=e+(d<<3)|0;c[a+8>>2]=d;c[a+4>>2]=d;c[a+12>>2]=e+(b<<3);return}function FF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=d-f>>2;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b<<2)|0;while(1){if((d|0)==(a|0))break a;f=d+-4|0;c[g>>2]=f;d=f}}}else mv(a,b-e|0);while(0);return}function GF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;h=a;g=c[h>>2]|0;h=c[h+4>>2]|0;d=z0(g|0,h|0,b|0,d|0)|0;b=z;i=a;c[i>>2]=d;c[i+4>>2]=b;d=z0((b>>>0<h>>>0|(b|0)==(h|0)&d>>>0<g>>>0)&1|0,0,e|0,f|0)|0;f=a+8|0;e=f;e=z0(d|0,z|0,c[e>>2]|0,c[e+4>>2]|0)|0;c[f>>2]=e;c[f+4>>2]=z;return a|0}function HF(a){a=a|0;var b=0;b=PZ(d[a+7>>0]|0|0,0,8)|0;b=PZ(b|(d[a+6>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+5>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+4>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+3>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+2>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+1>>0]|0)|0,z|0,8)|0;return b|(d[a>>0]|0)|0}function IF(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);d=a+528|0;e=d;e=z0(c[e>>2]|0,c[e+4>>2]|0,4,0)|0;c[d>>2]=e;c[d+4>>2]=z;if(qO(a)|0?(c[a+16>>2]|0)!=2:0)Kc(a,2,-1)|0;l=b;return}function JF(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;a=l;l=l+16|0;h=a;O4(h,e);e=u$(c[h>>2]|0,409148)|0;c6(h);gK(g+20|0,b,c[d>>2]|0,f,e);l=a;return c[b>>2]|0}function KF(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;a=l;l=l+16|0;h=a;O4(h,e);e=u$(c[h>>2]|0,409116)|0;c6(h);hK(g+20|0,b,c[d>>2]|0,f,e);l=a;return c[b>>2]|0}function LF(){var b=0,d=0;if((a[407768]|0)==0?E3(407768)|0:0){d=409236;do{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}d=d+12|0}while((d|0)!=409524)}IX(409236,402483)|0;IX(409248,402486)|0;return}function MF(a){a=a|0;var b=0;b=PZ(d[a>>0]|0|0,0,8)|0;b=PZ(b|(d[a+1>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+2>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+3>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+4>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+5>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+6>>0]|0)|0,z|0,8)|0;return b|(d[a+7>>0]|0)|0}function NF(b){b=b|0;var e=0,f=0,g=0,h=0,i=0;e=b+4|0;f=c[e>>2]|0;g=b+12|0;h=f+-1|0;do if(!(f&7))if(!f){c[e>>2]=0;a[b+13>>0]=1;b=0;break}else{i=c[b>>2]|0;f=a[i>>0]|0;a[g>>0]=f;c[b>>2]=i+1;c[e>>2]=h;b=f<<24>>24<0;break}else{c[e>>2]=h;b=((d[g>>0]|0)&1<<(h&7)|0)!=0}while(0);return b|0}function OF(a){a=a|0;var b=0;c[a>>2]=10628;b=c[a+22116>>2]|0;if(b|0)laa(b);b=c[a+22120>>2]|0;if(b|0)laa(b);IT(a+22136|0);IT(a+22124|0);aI(a+760|0);bt(a);return}function PF(){var b=0,d=0;if((a[407848]|0)==0?E3(407848)|0:0){d=410048;do{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}d=d+12|0}while((d|0)!=410336)}GX(410048,55588)|0;GX(410060,55600)|0;return}function QF(b){b=b|0;var d=0,e=0;d=b+74|0;e=a[d>>0]|0;a[d>>0]=e+255|e;d=b+20|0;e=b+28|0;if((c[d>>2]|0)>>>0>(c[e>>2]|0)>>>0)gb[c[b+36>>2]&31](b,0,0)|0;c[b+16>>2]=0;c[e>>2]=0;c[d>>2]=0;d=c[b>>2]|0;if(!(d&4)){e=(c[b+44>>2]|0)+(c[b+48>>2]|0)|0;c[b+8>>2]=e;c[b+4>>2]=e;d=d<<27>>31}else{c[b>>2]=d|32;d=-1}return d|0}function RF(b){b=b|0;var d=0,e=0,f=0;d=l;l=l+16|0;e=d;f=(c[b+544>>2]|0)+(c[b+612>>2]|0)+3|0;Op(b,(g3(a[f>>0]|0,a[f+1>>0]|0,a[f+2>>0]|0)|0)>>>5&8191,0);VU(e,357912);BZ(c[b+508>>2]|0,c[b+668>>2]|0,0,0);z5(e);l=d;return}function SF(b){b=b|0;var d=0,e=0,f=0;d=b+44|0;f=c[d>>2]|0;e=c[b+24>>2]|0;if(f>>>0<e>>>0){c[d>>2]=e;f=e}if(c[b+48>>2]&8){d=b+16|0;e=c[d>>2]|0;if(e>>>0<f>>>0){c[d>>2]=f;e=f}d=c[b+12>>2]|0;if(d>>>0<e>>>0)d=e9(a[d>>0]|0)|0;else d=-1}else d=-1;return d|0}function TF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+12>>2]=0;c[a+16>>2]=e;do if(b)if((b|0)<0){d=ua(8)|0;K2(d,391652);c[d>>2]=57868;Ya(d|0,2712,367)}else{e=ZW(b<<1)|0;break}else e=0;while(0);c[a>>2]=e;d=e+(d<<1)|0;c[a+8>>2]=d;c[a+4>>2]=d;c[a+12>>2]=e+(b<<1);return}function UF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=l;l=l+16|0;f=e;W0(f,407712);p2(a,yG(HE(b)|0,d)|0);s7(c[f>>2]|0);l=e;return}function VF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;g=l;l=l+16|0;f=g;e1(b,d,e);if(qO(b)|0){a[b+819>>0]=1;d=a[b+800+3>>0]|0;if(d<<24>>24<0)d=c[b+796>>2]|0;else d=d&255;if(!d){VU(f,375364);vF(b+792|0,f)|0;z5(f)}}l=g;return}function WF(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);if((c[a+768>>2]|0)==1836070754){e=a+536|0;d=a+528|0;d=D_(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e1(a,d,z)}else t4(a);l=b;return}function XF(a){a=a|0;var b=0,d=0,e=0;e=l;l=l+16|0;d=a+528|0;b=d;b=z0(c[b>>2]|0,c[b+4>>2]|0,6,0)|0;c[d>>2]=b;c[d+4>>2]=z;bB(a,e);d=a+536|0;b=c[d>>2]|0;d=c[d+4>>2]|0;if(d>>>0>0|(d|0)==0&b>>>0>7){d=z0(b|0,d|0,-7,-1)|0;e1(a,d,z)}l=e;return}function YF(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);if((c[a+768>>2]|0)==1836070772){e=a+536|0;d=a+528|0;d=D_(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e1(a,d,z)}else t4(a);l=b;return}function ZF(a){a=a|0;var b=0,d=0,e=0,f=0;b=a+520|0;d=c[b>>2]|0;f=d&-65536;e=a+772|0;c[e>>2]=f;if((f|0)!=1769472e3){if((d&65535|0)==27e3&0==0){Wn(a);c[e>>2]=c[b>>2]&-65536;Xe(a)}}else{Wn(a);c[e>>2]=c[b>>2]<<16;Xe(a)}return}function _F(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;g=a+4|0;b=c[g>>2]|0;f=c[a>>2]|0;d=b-f|0;e=(d|0)/3|0;a:do if(e>>>0>=256){if((d|0)!=768){a=f+768|0;while(1){if((b|0)==(a|0))break a;f=b+-3|0;c[g>>2]=f;b=f}}}else zt(a,256-e|0);while(0);return}function $F(b,d){b=b|0;d=d|0;var e=0,f=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=j9(404783)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11)a[b+11>>0]=d;else{f=d+16&-16;e=ZW(f)|0;c[b>>2]=e;c[b+8>>2]=f|-2147483648;c[b+4>>2]=d;b=e}i1(b,404783,d)|0;J7(b+d|0,0);return}function aG(b,d){b=b|0;d=d|0;var e=0,f=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=j9(404789)|0;if(d>>>0>4294967279)uaa();if(d>>>0<11)a[b+11>>0]=d;else{f=d+16&-16;e=ZW(f)|0;c[b>>2]=e;c[b+8>>2]=f|-2147483648;c[b+4>>2]=d;b=e}i1(b,404789,d)|0;J7(b+d|0,0);return}function bG(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=ZW(80)|0;c[d>>2]=g;c[d+4>>2]=e+4;b[g+16>>1]=b[c[f>>2]>>1]|0;hM(g+20|0);a[d+8>>0]=1;return}function cG(b,d){b=b|0;d=d|0;var e=0;e=ZW(40)|0;c[b>>2]=e;c[b+4>>2]=407704;p2(e+16|0,c[d>>2]|0);x1(e+28|0);a[b+8>>0]=1;return}function dG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=d-f>>5;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b<<5)|0;while(1){if((d|0)==(a|0))break a;f=d+-32|0;c[g>>2]=f;d=f}}}else Zt(a,b-e|0);while(0);return}function eG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=d-f>>4;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b<<4)|0;while(1){if((d|0)==(a|0))break a;f=d+-16|0;c[g>>2]=f;d=f}}}else bu(a,b-e|0);while(0);return}function fG(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=a+8|0;a=nb[c[(c[a>>2]|0)+4>>2]&255](a)|0;e=(Nf(d,e,a,a+288|0,g,f,0)|0)-a|0;if((e|0)<288)c[b>>2]=((e|0)/12|0|0)%12|0;return}function gG(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=a+8|0;a=nb[c[(c[a>>2]|0)+4>>2]&255](a)|0;e=(Df(d,e,a,a+288|0,g,f,0)|0)-a|0;if((e|0)<288)c[b>>2]=((e|0)/12|0|0)%12|0;return}function hG(d){d=d|0;var e=0;c[d+28>>2]=0;c[d+32>>2]=0;c[d+36>>2]=0;YW(d+40|0);YW(d+72|0);c[d>>2]=7;c[d+4>>2]=0;c[d+8>>2]=0;a[d+12>>0]=0;e=d+16|0;c[d+104>>2]=0;c[e>>2]=0;c[e+4>>2]=0;b[e+8>>1]=0;c[d+108>>2]=-1;c[d+112>>2]=-1;c[d+116>>2]=0;return}function iG(a){a=a|0;c[a>>2]=15432;A_(a+992|0);A_(a+980|0);x_(a+968|0);z5(a+956|0);z5(a+944|0);z5(a+932|0);z5(a+920|0);z5(a+908|0);aI(a+760|0);bt(a);return}function jG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+16|0;g=c[f>>2]|0;h=b+36|0;i=b+24|0;do if(g){if((g|0)!=(d|0)){c[h>>2]=(c[h>>2]|0)+1;c[i>>2]=2;a[b+54>>0]=1;break}if((c[i>>2]|0)==2)c[i>>2]=e}else{c[f>>2]=d;c[i>>2]=e;c[h>>2]=1}while(0);return}function kG(){var a=0,b=0;a=l;l=l+16|0;b=a;Xy(b,42472);gI(407252,0,b);z5(b);TX(b);bf(407252,bj(b,238921)|0);z5(b);Xy(b,42472);gI(407252,0,b);z5(b);l=a;return}function lG(a,b){a=a|0;b=b|0;var d=0;d=b&255;a:do if(!(b<<24>>24))a=8800948;else switch(a<<24>>24){case 2:{if((b&255)>8){a=8800948;break a}a=c[28040+(d<<2)>>2]|0;break a}case 6:{if((b&255)>3){a=8800948;break a}a=c[28076+(d<<2)>>2]|0;break a}default:{a=8800948;break a}}while(0);return a|0}function mG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;h=l;l=l+256|0;e=h;a:do if((d|0)>=2){c[b+(d<<2)>>2]=e;f=c[b>>2]|0;a[e>>0]=a[f>>0]|0;e=0;while(1){i=b+(e<<2)|0;e=e+1|0;g=b+(e<<2)|0;a[f>>0]=a[c[g>>2]>>0]|0;c[i>>2]=(c[i>>2]|0)+1;if((e|0)==(d|0))break a;f=c[g>>2]|0}}while(0);l=h;return}function nG(a){a=a|0;var b=0,d=0,e=0,f=0;f=a+4|0;b=c[f>>2]|0;e=c[a>>2]|0;d=b-e>>2;a:do if(d>>>0>=256){if((d|0)!=256){a=e+1024|0;while(1){if((b|0)==(a|0))break a;e=b+-4|0;c[f>>2]=e;b=e}}}else mv(a,256-d|0);while(0);return}function oG(a){a=a|0;var b=0,c=0,d=0;d=l;l=l+16|0;c=d;x1(a);b=0;do{TX(a+12+(b*12|0)|0);b=b+1|0}while((b|0)!=2);TX(a+36|0);Xy(c,42472);k1(a+12|0,c)|0;z5(c);Xy(c,42436);k1(a+24|0,c)|0;z5(c);l=d;return}function pG(a,b){a=a|0;b=b|0;var d=0;d=b&255;a:do if(!(b<<24>>24))a=8800948;else switch(a<<24>>24){case 2:{if((b&255)>8){a=8800948;break a}a=c[28092+(d<<2)>>2]|0;break a}case 6:{if((b&255)>3){a=8800948;break a}a=c[28128+(d<<2)>>2]|0;break a}default:{a=8800948;break a}}while(0);return a|0}function qG(){var a=0,b=0;a=l;l=l+16|0;b=a;Xy(b,42472);gI(407308,0,b);z5(b);TX(b);bf(407308,bj(b,262452)|0);z5(b);Xy(b,42472);gI(407308,0,b);z5(b);l=a;return}function rG(){var a=0,b=0;a=l;l=l+16|0;b=a;Xy(b,42472);gI(407476,0,b);z5(b);TX(b);bf(407476,bj(b,326380)|0);z5(b);Xy(b,42472);gI(407476,0,b);z5(b);l=a;return}function sG(){var a=0,b=0;a=l;l=l+16|0;b=a;Xy(b,42472);gI(407532,0,b);z5(b);TX(b);bf(407532,bj(b,334047)|0);z5(b);Xy(b,42472);gI(407532,0,b);z5(b);l=a;return}function tG(){var a=0,b=0;a=l;l=l+16|0;b=a;Xy(b,42472);gI(407364,0,b);z5(b);TX(b);bf(407364,bj(b,287819)|0);z5(b);Xy(b,42472);gI(407364,0,b);z5(b);l=a;return}function uG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=ZW(32)|0;c[b>>2]=f;c[b+4>>2]=d+4;g=c[e>>2]|0;d=c[g+4>>2]|0;e=f+16|0;c[e>>2]=c[g>>2];c[e+4>>2]=d;a[f+24>>0]=0;a[b+8>>0]=1;return}function vG(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;Xs(e,a,b[d>>1]|0,g);l=f;return (c[e>>2]|0)+20|0}function wG(){var a=0,b=0;a=l;l=l+16|0;b=a;Xy(b,42472);gI(407420,0,b);z5(b);TX(b);bf(407420,bj(b,308757)|0);z5(b);Xy(b,42472);gI(407420,0,b);z5(b);l=a;return}function xG(){var a=0,b=0;a=l;l=l+16|0;b=a;Xy(b,42472);gI(407588,0,b);z5(b);TX(b);bf(407588,bj(b,342330)|0);z5(b);Xy(b,42472);gI(407588,0,b);z5(b);l=a;return}function yG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;Cs(d,a,b,f);l=e;return (c[d>>2]|0)+28|0}function zG(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;Bx(a);d=a+648|0;A6(c[d>>2]|0);A6(c[d>>2]|0);xR(a,6,b+1|0);xR(a,3,b);d4(c[d>>2]|0,5);wK(a);l=b;return}function AG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;Ds(d,a,b,f);l=e;return (c[d>>2]|0)+28|0}function BG(a){a=a|0;var d=0,e=0,f=0;c[a>>2]=0;d=a+56|0;e=a+8|0;f=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));a=a+96|0;e=d;f=e+40|0;do{c[e>>2]=-1;e=e+4|0}while((e|0)<(f|0));c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=0;b[a+32>>1]=0;return}
function so(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=b;h=c[i>>2]|0;i=c[i+4>>2]|0;k=a;j=c[k>>2]|0;k=c[k+4>>2]|0;f=d;e=c[f>>2]|0;f=c[f+4>>2]|0;g=(f|0)<(i|0)|(f|0)==(i|0)&e>>>0<h>>>0;do if((i|0)<(k|0)|(i|0)==(k|0)&h>>>0<j>>>0){if(g){b=a;c[b>>2]=e;c[b+4>>2]=f;e=d;c[e>>2]=j;c[e+4>>2]=k;e=1;break}f=a;c[f>>2]=h;c[f+4>>2]=i;f=b;c[f>>2]=j;c[f+4>>2]=k;f=d;e=c[f>>2]|0;f=c[f+4>>2]|0;if((f|0)<(k|0)|(f|0)==(k|0)&e>>>0<j>>>0){c[b>>2]=e;c[b+4>>2]=f;e=d;c[e>>2]=j;c[e+4>>2]=k;e=2}else e=1}else if(g){g=b;c[g>>2]=e;c[g+4>>2]=f;f=d;c[f>>2]=h;c[f+4>>2]=i;f=b;e=c[f>>2]|0;f=c[f+4>>2]|0;h=a;g=c[h>>2]|0;h=c[h+4>>2]|0;if((f|0)<(h|0)|(f|0)==(h|0)&e>>>0<g>>>0){c[a>>2]=e;c[a+4>>2]=f;e=b;c[e>>2]=g;c[e+4>>2]=h;e=2}else e=1}else e=0;while(0);return e|0}function to(b){b=b|0;var d=0,e=0,f=0;f=l;l=l+16|0;d=f;GC(b);Bx(b);RS(b);RS(b);RS(b);AT(b,b+812|0);RS(b);RS(b);xR(b,2,d);KS(b);RS(b);A6(c[b+648>>2]|0);AT(b,b+810|0);RS(b);RS(b);RS(b);RS(b);KS(b);RS(b);KS(b);RS(b);RS(b);AT(b,b+813|0);AT(b,b+814|0);AT(b,b+815|0);wK(b);J3(b);if(qO(b)|0?(e=b+805|0,(a[e>>0]|0)==-1):0)a[e>>0]=a[d>>0]|0;l=f;return}function uo(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0,g=0;f=l;l=l+16|0;g=f;$x(g,a,1,b,c,1);e=+Eq(g);z5(g);if(!(e>9.99&e<=10.01))if(!(e>11.984&e<=11.994))if(!(e>11.994&e<=12.01))if(!(e>14.98&e<=14.99))if(!(e>14.99&e<=15.01))if(!(e>23.952&e<=23.988))if(!(e>23.988&e<=24.024))if(!(e>24.975&e<=25.025))if(!(e>29.94&e<=29.985))if(!(e>29.97&e<=30.03))if(!(e>47.904&e<=47.976))if(!(e>47.976&e<=48.048))if(e>49.95&e<=50.05)d=50.0;else d=e>59.88&e<=59.97?59.94:e>59.94&e<=60.06?60.0:e;else d=48.0;else d=47.952;else d=30.0;else d=29.97;else d=25.0;else d=24.0;else d=23.976;else d=15.0;else d=14.985;else d=12.0;else d=11.988;else d=10.0;if(d!=e)KW(a,1,b,c,d,3,1);l=f;return}function vo(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;q=d+8+3|0;p=a[q>>0]|0;r=d+4|0;a:do if((p<<24>>24<0?c[r>>2]|0:p&255)|0){l=(g&8|0)==0;m=b+8+3|0;n=b+4|0;o=e+8+3|0;p=e+4|0;k=0;while(1){if(l&(k|0)==1)break a;g=a[m>>0]|0;if(g<<24>>24<0){h=c[n>>2]|0;i=c[b>>2]|0}else{h=g&255;i=b}j=a[q>>0]|0;s=j<<24>>24<0;g=s?c[d>>2]|0:d;j=s?c[r>>2]|0:j&255;if(h>>>0<f>>>0)break a;if(j){s=i+(h<<2)|0;g=HA(i+(f<<2)|0,s,g,g+(j<<2)|0)|0;if((g|0)==(s|0))break a;else f=g-i>>2}if((f|0)==-1)break a;s=a[o>>0]|0;i=s<<24>>24<0;cm(b,f,j,i?c[e>>2]|0:e,i?c[p>>2]|0:s&255)|0;s=a[o>>0]|0;f=(s<<24>>24<0?c[p>>2]|0:s&255)+f|0;k=k+1|0}}while(0);return}function wo(c,f){c=c|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;k=(f<<1)+-1|0;l=f+-1|0;a:do if(!((c+-43008|0)>>>0<22272|((c+-11776|0)>>>0<30784|((c+-1536|0)>>>0<2560|(fZ(c)|0)==0)))){g=(f|0)!=0;if(g&(c+-4256|0)>>>0<46){if((c|0)>4293)switch(c|0){case 4295:case 4301:break;default:break a}c=c+7264|0;break}if((c+-11520|0)>>>0<38&(g^1)){c=c+-7264|0;break}else g=0;do{i=a[64740+(g<<2)+2>>0]|0;j=i<<24>>24;h=c-(e[64740+(g<<2)>>1]|0)|0;if((h-(j&l)|0)>>>0<(d[64740+(g<<2)+3>>0]|0)>>>0){m=11;break}g=g+1|0}while((g|0)!=61);if((m|0)==11)if(i<<24>>24==1){c=f+c-(h&1)|0;break}else{c=(O(j,k)|0)+c|0;break}i=1-f|0;g=b[64252+(i<<1)>>1]|0;b:do if(g<<16>>16){h=0;while(1){if((g&65535|0)==(c|0))break;h=h+1|0;g=b[64252+(h<<2)+(i<<1)>>1]|0;if(!(g<<16>>16))break b}c=e[64252+(h<<2)+(f<<1)>>1]|0;break a}while(0);return ((c+-66600+(f*40|0)|0)>>>0<40?c+-40+(f*80|0)|0:c)|0}while(0);return c|0}function xo(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+16|0;j=m;k=m+8|0;i=j;c[i>>2]=0;c[i+4>>2]=0;c[k>>2]=j;if((a[b>>0]|0)==47){do b=b+1|0;while((a[b>>0]|0)==47);e=404776}else e=8800948;do if((FD(b)|0)>>>0<=4096){c[d+8>>2]=0;c[d>>2]=0;g=d+4|0;c[g>>2]=0;if(!(a[b>>0]|0)){c[k>>2]=0;b=3;break}b=Kh(e,b,k)|0;if((b|0)==1){k0(c[j>>2]|0);b=1;break}e=c[j>>2]|0;c[k>>2]=e;if(e){f=0;while(1){e=c[e>>2]|0;c[k>>2]=e;i=f+1|0;if(!e)break;else f=i}if(i){h=Ub((f<<2)+8|0)|0;c[g>>2]=h;if(!h){k0(c[j>>2]|0);b=1;break}f=c[j>>2]|0;c[k>>2]=f;e=0;g=h;while(1){c[g+(e<<2)>>2]=f+4;f=c[f>>2]|0;c[k>>2]=f;e=e+1|0;if((e|0)==(i|0))break;else g=h}c[h+(i<<2)>>2]=0;c[d>>2]=i}else b=3}else b=3}else b=1;while(0);l=m;return b|0}function yo(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;n=l;l=l+48|0;k=n+16|0;g=n;f=n+32|0;i=a+28|0;e=c[i>>2]|0;c[f>>2]=e;j=a+20|0;e=(c[j>>2]|0)-e|0;c[f+4>>2]=e;c[f+8>>2]=b;c[f+12>>2]=d;e=e+d|0;h=a+60|0;c[g>>2]=c[h>>2];c[g+4>>2]=f;c[g+8>>2]=2;g=b6(db(146,g|0)|0)|0;a:do if((e|0)!=(g|0)){b=2;while(1){if((g|0)<0)break;e=e-g|0;p=c[f+4>>2]|0;o=g>>>0>p>>>0;f=o?f+8|0:f;b=(o<<31>>31)+b|0;p=g-(o?p:0)|0;c[f>>2]=(c[f>>2]|0)+p;o=f+4|0;c[o>>2]=(c[o>>2]|0)-p;c[k>>2]=c[h>>2];c[k+4>>2]=f;c[k+8>>2]=b;g=b6(db(146,k|0)|0)|0;if((e|0)==(g|0)){m=3;break a}}c[a+16>>2]=0;c[i>>2]=0;c[j>>2]=0;c[a>>2]=c[a>>2]|32;if((b|0)==2)d=0;else d=d-(c[f+4>>2]|0)|0}else m=3;while(0);if((m|0)==3){p=c[a+44>>2]|0;c[a+16>>2]=p+(c[a+48>>2]|0);c[i>>2]=p;c[j>>2]=p}l=n;return d|0}function zo(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+160|0;g=j+136|0;h=j;f=h+56|0;i=h+4|0;c[h>>2]=1244;c[f>>2]=1264;DO(h+56|0,i);c[h+128>>2]=0;c[h+132>>2]=-1;c[h>>2]=42060;c[f>>2]=42080;aV(i);c[i>>2]=42096;f=h+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[f+(e<<2)>>2]=0;e=e+1|0}c[h+48>>2]=0;c[h+52>>2]=16;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[g+(e<<2)>>2]=0;e=e+1|0}lq(i,g);O0(g);f=h+(c[(c[h>>2]|0)+-12>>2]|0)+4|0;c[f>>2]=c[f>>2]&-75|2;Iq(h,b,d)|0;Hk(g,i);rQ(a,g)|0;O0(g);tP(a)|0;YX(h);l=j;return a|0}function Ao(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0;i=l;l=l+800|0;f=i;j=d+528|0;h=d+770|0;j=z0(e[h>>1]|0,0,c[j>>2]|0,c[j+4>>2]|0)|0;m=z;g=d+536|0;k=c[g+4>>2]|0;if(m>>>0>k>>>0|((m|0)==(k|0)?j>>>0>(c[g>>2]|0)>>>0:0))t4(d);else{AJ(f);c[f+760>>2]=c[d+764>>2];b[f+764>>1]=b[d+776>>1]|0;b[f+766>>1]=b[d+768>>1]|0;a[f+768>>0]=a[d+789>>0]|0;b[f+770>>1]=b[d+778>>1]|0;b[f+772>>1]=b[d+780>>1]|0;b[f+774>>1]=b[d+782>>1]|0;a[f+780>>0]=a[d+784>>0]|0;b[f+782>>1]=b[d+786>>1]|0;g=d+793|0;a[f+784>>0]=a[g>>0]|0;a[f+785>>0]=a[d+794>>0]|0;a[f+787>>0]=a[d+795>>0]|0;a[f+788>>0]=a[d+796>>0]|0;if(b[h>>1]|0){GC(d);aY(d,f);iA(d,f,e[h>>1]|0);J3(d)}a[g>>0]=0;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;bt(f)}l=i;return}function Bo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;k=l;l=l+16|0;h=k+13|0;f=k+12|0;i=k;a[h>>0]=0;a[f>>0]=0;bB(b,h);bB(b,f);j=b+536|0;d=j;e=c[d>>2]|0;d=c[d+4>>2]|0;if(!((e|0)==0&(d|0)==0))Op(b,e,d);g=b+528|0;e=g;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!((d|0)==0&(e|0)==0))Op(b,d,e);d=a[f>>0]|0;if(!(d<<24>>24)){e=0;f=0}else{e=d&255;Op(b,e,0);f=0}n=j;m=c[n>>2]|0;n=c[n+4>>2]|0;j=g;j=z0(c[j>>2]|0,c[j+4>>2]|0,e|0,f|0)|0;g=z;if(n>>>0<g>>>0|(n|0)==(g|0)&m>>>0<j>>>0)c3(c[b+508>>2]|0,c[b+668>>2]|0);else{n=a[h>>0]|0;TX(i);Ck(i,n,16)|0;BZ(c[b+508>>2]|0,c[b+668>>2]|0,n&255,0);z5(i);Op(b,(d&255)+2|0,0)}l=k;return}function Co(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+272|0;j=n+8|0;k=n;f=c[b>>2]|0;c[k>>2]=f;m=(a|0)!=0;h=m?e:256;g=m?a:j;e=f;a:do if((h|0)!=0&(f|0)!=0){a=0;i=g;while(1){g=d>>>0>=h>>>0;if(!(d>>>0>32|g)){g=i;break a}e=g?h:d;d=d-e|0;e=Ql(i,k,e)|0;if((e|0)==-1)break;g=(i|0)==(j|0);h=h-(g?0:e)|0;g=g?i:i+e|0;a=e+a|0;e=c[k>>2]|0;f=e;if((h|0)!=0&(e|0)!=0)i=g;else break a}f=c[k>>2]|0;g=i;a=-1;h=0;e=f}else a=0;while(0);do if((e|0)!=0?(h|0)!=0&(d|0)!=0:0){f=h;while(1){h=qw(g,c[e>>2]|0)|0;if((h+1|0)>>>0<2){f=9;break}e=e+4|0;d=d+-1|0;f=f-h|0;a=h+a|0;if(!((d|0)!=0&(f|0)!=0)){f=11;break}else g=g+h|0}if((f|0)==9){j=(h|0)==0;e=j?0:e;c[k>>2]=e;a=j?a:-1;break}else if((f|0)==11){c[k>>2]=e;break}}else e=f;while(0);if(m)c[b>>2]=e;l=n;return a|0}function Do(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+160|0;f=i+136|0;g=i;e=g+56|0;h=g+4|0;c[g>>2]=1244;c[e>>2]=1264;DO(g+56|0,h);c[g+128>>2]=0;c[g+132>>2]=-1;c[g>>2]=42060;c[e>>2]=42080;aV(h);c[h>>2]=42096;e=g+36|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[e+(d<<2)>>2]=0;d=d+1|0}c[g+48>>2]=0;c[g+52>>2]=16;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[f+(d<<2)>>2]=0;d=d+1|0}lq(h,f);O0(f);e=g+(c[(c[g>>2]|0)+-12>>2]|0)+4|0;c[e>>2]=c[e>>2]&-75|2;rr(g,b<<24>>24)|0;Hk(f,h);rQ(a,f)|0;O0(f);tP(a)|0;YX(g);l=i;return a|0}function Eo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+32|0;d=i+8|0;e=i+4|0;f=i;bB(a,i+16|0);jB(a,i+12|0);ID(a,d);g=a+916|0;h=a+788|0;b=wD(g,c[h>>2]|0)|0;c[a+928>>2]=b;c[b+232>>2]=-1;c[b+236>>2]=0;b=b+240|0;c[b>>2]=0;c[b+4>>2]=0;d=c[d>>2]|0;b=0;while(1){if((b|0)==(d|0))break;ID(a,e);ID(a,f);if(qO(a)|0){j=bF(g,h)|0;Zl(j,c[e>>2]|0,c[f>>2]|0,b,d)}b=b+1|0}b=a+928|0;if(qO(a)|0?(c[a+16>>2]|0)==1:0){j=(c[b>>2]|0)+240|0;oK(a,1,c[a+20>>2]|0,185,c[j>>2]|0,c[j+4>>2]|0,10,0)}l=i;return}function Fo(a){a=+a;var b=0,d=0,e=0,f=0,g=0.0,i=0.0,k=0.0,l=0.0,m=0.0;h[j>>3]=a;b=c[j>>2]|0;d=c[j+4>>2]|0;e=(d|0)<0;do if(e|d>>>0<1048576){if((b|0)==0&(d&2147483647|0)==0){a=-1.0/(a*a);break}if(e){a=(a-a)/0.0;break}else{h[j>>3]=a*18014398509481984.0;d=c[j+4>>2]|0;e=-1077;b=c[j>>2]|0;f=9;break}}else if(d>>>0<=2146435071)if((b|0)==0&0==0&(d|0)==1072693248)a=0.0;else{e=-1023;f=9}while(0);if((f|0)==9){f=d+614242|0;c[j>>2]=b;c[j+4>>2]=(f&1048575)+1072079006;k=+h[j>>3]+-1.0;i=k*k*.5;l=k/(k+2.0);m=l*l;a=m*m;h[j>>3]=k-i;d=c[j+4>>2]|0;c[j>>2]=0;c[j+4>>2]=d;g=+h[j>>3];a=k-g-i+l*(i+(a*(a*(a*.15313837699209373+.22222198432149784)+.3999999999940942)+m*(a*(a*(a*.14798198605116586+.1818357216161805)+.2857142874366239)+.6666666666666735)));m=g*.4342944818781689;i=+((f>>>20)+e|0);l=i*.30102999566361177;k=l+m;a=k+(m+(l-k)+(a*.4342944818781689+(i*3.694239077158931e-13+(g+a)*2.5082946711645275e-11)))}return +a}function Go(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,i=0;e=l;l=l+16|0;f=e+12|0;b=e;g=a+528|0;h=g;h=z0(c[h>>2]|0,c[h+4>>2]|0,22,0)|0;i=g;c[i>>2]=h;c[i+4>>2]=z;GC(a);i=g;i=z0(c[i>>2]|0,c[i+4>>2]|0,8,0)|0;h=g;c[h>>2]=i;c[h+4>>2]=z;J3(a);h=g;h=z0(c[h>>2]|0,c[h+4>>2]|0,20,0)|0;c[g>>2]=h;c[g+4>>2]=z;bB(a,f);iF(a,d[f>>0]|0,0);if(qO(a)|0){Xy(b,24580);i=a+16|0;h=a+20|0;Rf(a,b,c[i>>2]|0,c[h>>2]|0,1);z5(b);g=c[i>>2]|0;f=c[h>>2]|0;RB(a,g,f,Rb(g,17)|0,401454,-1,1,1);i=c[i>>2]|0;h=c[h>>2]|0;RB(a,i,h,Rb(i,0)|0,391414,-1,1,1)}l=e;return}function Ho(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+160|0;f=i+136|0;g=i;e=g+56|0;h=g+4|0;c[g>>2]=1244;c[e>>2]=1264;DO(g+56|0,h);c[g+128>>2]=0;c[g+132>>2]=-1;c[g>>2]=42060;c[e>>2]=42080;aV(h);c[h>>2]=42096;e=g+36|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[e+(d<<2)>>2]=0;d=d+1|0}c[g+48>>2]=0;c[g+52>>2]=16;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[f+(d<<2)>>2]=0;d=d+1|0}lq(h,f);O0(f);e=g+(c[(c[g>>2]|0)+-12>>2]|0)+4|0;c[e>>2]=c[e>>2]&-75|2;Up(g,b)|0;Hk(f,h);rQ(a,f)|0;O0(f);tP(a)|0;YX(g);l=i;return a|0}function Io(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;j=k;h=b+916|0;i=b+788|0;e=0;while(1){g=bF(h,i)|0;g=e>>>0<(c[g+16>>2]|0)-(c[g+12>>2]|0)>>2>>>0;d=bF(h,i)|0;f=c[d+12>>2]|0;if(!g)break;d=c[f+(e<<2)>>2]|0;if(d|0)jb[c[(c[d>>2]|0)+4>>2]&511](d);e=e+1|0}d=d+16|0;e=c[d>>2]|0;while(1){if((e|0)==(f|0))break;g=e+-4|0;c[d>>2]=g;e=g}g=ZW(960)|0;Vw(g);a[g+768>>0]=1;aY(b,g);a[g+769>>0]=1;a[g+733>>0]=0;d=bF(h,i)|0;c[j>>2]=g;e=d+16|0;f=c[e>>2]|0;if(f>>>0<(c[d+20>>2]|0)>>>0){c[f>>2]=g;c[e>>2]=(c[e>>2]|0)+4}else Yy(d+12|0,j);a[b+761>>0]=1;rB(b,g);a[g+772>>0]=1;l=k;return}function Jo(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i+2|0;g=i+1|0;h=i;GC(b);e=b+648|0;d4(c[e>>2]|0,8);if(!d)jh(b);do if(qO(b)|0){uj(b);if(!(qO(b)|0)){J3(b);break}_q(b);if(!(qO(b)|0)){J3(b);break}AT(b,f);if(a[f>>0]|0)ZH(b);AT(b,g);if(a[g>>0]|0)vq(b);AT(b,h);if(a[h>>0]|0)lr(b);if(!(a[b+2478>>0]|0))jl(b);else{h=c[e>>2]|0;G4(h,Z9(c[h+4>>2]|0)|0)}J3(b)}else J3(b);while(0);l=i;return}function Ko(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;j=l;l=l+16|0;h=j+2|0;i=j;if((e|0)==0&(f|0)==0)jZ(d,0,0,g);else{EG(d,h);h=a[h>>0]|0;do if((h&255)<32){k=d+528|0;m=k;m=z0(c[m>>2]|0,c[m+4>>2]|0,1,0)|0;c[k>>2]=m;c[k+4>>2]=z;if(h<<24>>24!=16){m=z0(e|0,f|0,-1,-1)|0;jZ(d,m,z,g);break}if(f>>>0<0|(f|0)==0&e>>>0<3){h=g+8+3|0;if((a[h>>0]|0)<0){y7(c[g>>2]|0,0);c[g+4>>2]=0;break}else{y7(g,0);a[h>>0]=0;break}}NB(d,i);m=(b[i>>1]|0)==2;h=z0(e|0,f|0,-3,-1)|0;e=z;if(m)uY(d,h,e,g);else jZ(d,h,e,g)}else jZ(d,e,f,g);while(0)}l=j;return}function Lo(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0;o=l;l=l+240|0;k=o+232|0;n=o;c[k>>2]=d;m=k+4|0;c[m>>2]=e;c[n>>2]=b;a:do if((d|0)!=1|(e|0)!=0?(j=b+(0-(c[h+(f<<2)>>2]|0))|0,i=a[j>>0]|0,(z6(i,a[b>>0]|0)|0)>=1):0){d=1;g=(g|0)==0;while(1){if(g&(f|0)>1){e=b+-1|0;if((z6(a[e>>0]|0,i)|0)>-1){e=10;break a}if((z6(a[e+(0-(c[h+(f+-2<<2)>>2]|0))>>0]|0,i)|0)>-1){e=10;break a}}b=d+1|0;c[n+(d<<2)>>2]=j;i=QX(k)|0;qT(k,i);f=i+f|0;if(!((c[k>>2]|0)!=1|(c[m>>2]|0)!=0)){d=b;b=j;e=10;break a}e=j+(0-(c[h+(f<<2)>>2]|0))|0;i=a[e>>0]|0;if((z6(i,a[c[n>>2]>>0]|0)|0)<1){d=b;b=j;e=10;break}else{p=j;d=b;g=1;j=e;b=p}}}else e=9;while(0);if((e|0)==9?(g|0)==0:0){d=1;e=10}if((e|0)==10){mG(n,d);Iv(b,f,h)}l=o;return}function Mo(b,f,g,h){b=b|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+16|0;i=p+1|0;k=p;o=f&255;j=a[368317+o>>0]|0;m=j&255;n=b+648|0;f=Z9(c[(c[n>>2]|0)+4>>2]|0)|0;qR(b,m>>>0>f>>>0?f&255:j,i);j=c[10744+(o<<2)>>2]|0;i=d[i>>0]|0;f=a[j+(i<<1)>>0]|0;i=a[j+(i<<1)+1>>0]|0;j=10792+(o<<2)|0;if(!(i<<24>>24)){b=c[j>>2]|0;G4(c[n>>2]|0,a[b+((f&255)*5|0)>>0]|0);f=f&255}else{G4(c[n>>2]|0,m);qR(b,i,k);i=(d[k>>0]|0)+(f&255)|0;b=c[j>>2]|0;f=(a[b+(i*5|0)>>0]|0)-m|0;if(f|0)G4(c[n>>2]|0,f);f=i&65535}j=f&65535;a:do if((f&65535)<(e[59684+(o<<1)>>1]|0)){i=h&255;f=0;while(1){if((f|0)==(i|0))break a;h=f+1|0;a[g+f>>0]=a[b+(j*5|0)+h>>0]|0;f=h}}else{g=c[n>>2]|0;G4(g,Z9(c[g+4>>2]|0)|0)}while(0);l=p;return}function No(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;q=l;l=l+32|0;h=q+8|0;j=q;bB(a,q+16|0);jB(a,q+12|0);ID(a,h);k=a+528|0;m=a+536|0;n=a+544|0;o=a+612|0;p=a+880|0;i=a+916|0;g=a+788|0;h=c[h>>2]|0;f=0;while(1){if(f>>>0>=h>>>0)break;b=k;a=c[b>>2]|0;b=z0(a|0,c[b+4>>2]|0,4,0)|0;d=z;e=m;r=c[e+4>>2]|0;if(d>>>0>r>>>0|((d|0)==(r|0)?b>>>0>(c[e>>2]|0)>>>0:0))break;e=W8((c[n>>2]|0)+(c[o>>2]|0)+a|0)|0;r=k;c[r>>2]=b;c[r+4>>2]=d;if(f>>>0<(c[p>>2]|0)>>>0){a=bF(i,g)|0;b=j;c[b>>2]=e;c[b+4>>2]=0;b=a+80|0;d=c[b>>2]|0;if(d>>>0<(c[a+84>>2]|0)>>>0){r=d;c[r>>2]=e;c[r+4>>2]=0;c[b>>2]=d+8}else Px(a+76|0,j)}f=f+1|0}l=q;return}function Oo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=l;l=l+16|0;d=j;Bx(b);i=b+648|0;A6(c[i>>2]|0);d4(c[i>>2]|0,6);if(K6(c[i>>2]|0)|0){GC(b);A6(c[i>>2]|0);AT(b,d);d4(c[i>>2]|0,7);wK(b);k=(a[d>>0]|0)==0;h=b+528|0;d=h;f=c[d>>2]|0;d=c[d+4>>2]|0;e=z0(f|0,d|0,8,0)|0;g=z;if(k)e=f;else{d=h;c[d>>2]=e;c[d+4>>2]=g;d=g}g=z0(e|0,d|0,4,0)|0;k=h;c[k>>2]=g;c[k+4>>2]=z;Bx(b);J3(b)}else A6(c[i>>2]|0);A6(c[i>>2]|0);A6(c[i>>2]|0);A6(c[i>>2]|0);d4(c[i>>2]|0,5);wK(b);l=j;return}function Po(a,b){a=a|0;b=b|0;do switch(a|0){case 1:{if(!b)a=373714;else a=8800948;break}case 2:{if(!b)a=373685;else a=8800948;break}case 3:{if(!b)a=373657;else a=8800948;break}case 4:{if(!b)a=373628;else a=8800948;break}case 5:{if(!b)a=373600;else a=8800948;break}case 6:{if(!b)a=373566;else a=8800948;break}case 7:{if(!b)a=373533;else a=8800948;break}case 8:{if(!b)a=373496;else a=8800948;break}case 9:{if(!b)a=373460;else a=8800948;break}case 10:{if(!b)a=373440;else a=8800948;break}case 11:{if(!b)a=373409;else a=8800948;break}case 12:{if(!b)a=373384;else a=8800948;break}case 13:{if(!b)a=373338;else a=8800948;break}case 14:{if(!b)a=373291;else a=8800948;break}default:a=8800948}while(0);return a|0}function Qo(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+16|0;m=n;do if(!b)b=0;else{o=d;i=f-o|0;k=g+12|0;j=c[k>>2]|0;i=(j|0)>(i|0)?j-i|0:0;j=e;g=j-o|0;if((g|0)>0?(gb[c[(c[b>>2]|0)+48>>2]&31](b,d,g)|0)!=(g|0):0){b=0;break}if((i|0)>0){c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;d=m+11|0;if(i>>>0<11){a[d>>0]=i;g=m}else{o=i+16&-16;g=ZW(o)|0;c[m>>2]=g;c[m+8>>2]=o|-2147483648;c[m+4>>2]=i}NZ(g,i,h)|0;J7(g+i|0,0);o=(gb[c[(c[b>>2]|0)+48>>2]&31](b,(a[d>>0]|0)<0?c[m>>2]|0:m,i)|0)==(i|0);a1(m);if(!o){b=0;break}}f=f-j|0;if((f|0)>0?(gb[c[(c[b>>2]|0)+48>>2]&31](b,e,f)|0)!=(f|0):0){b=0;break}c[k>>2]=0}while(0);l=n;return b|0}function Ro(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=a+536|0;j=h;if((c[j>>2]|0)==4&(c[j+4>>2]|0)==0){i=a+952|0;e=c[i>>2]|0;b=a+956|0;d=c[b>>2]|0;j=a+508|0;if((e|0)==(d|0)){xM(a,0,0,373779,(c[j>>2]|0)==3?373767:382825,1);e=c[i>>2]|0;g=e;f=c[b>>2]|0;b=e}else{g=e;f=d;b=e}d=c[j>>2]|0;if(f-g>>5>>>0<d>>>0){dG(i,d);d=c[j>>2]|0;b=c[i>>2]|0}bD(a,b+(d+-1<<5)+28|0);j=(c[j>>2]|0)+-1|0;g=c[i>>2]|0;c[g+(j<<5)+24>>2]=-1;f=a+48|0;f=z0(c[a+612>>2]|0,0,c[f>>2]|0,c[f+4>>2]|0)|0;i=z;e=g+(j<<5)|0;c[e>>2]=f;c[e+4>>2]=i;e=h;e=z0(f|0,i|0,c[e>>2]|0,c[e+4>>2]|0)|0;h=g+(j<<5)+8|0;c[h>>2]=e;c[h+4>>2]=z;h=HN(a,1)|0;i=z0(h|0,z|0,f|0,i|0)|0;j=g+(j<<5)+16|0;c[j>>2]=i;c[j+4>>2]=z}else Il(a);return}function So(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+16|0;i=m+12|0;j=m;W0(i,b+360|0);k=b+80|0;if(((d|0)!=-1|(e|0)!=-1)&(((c[b+88>>2]|0)-(c[b+84>>2]|0)|0)/12|0)>>>0<2?(g=b+176|0,c[g>>2]=d,c[g+4>>2]=e,g=b+208|0,c[g>>2]=d,c[g+4>>2]=e,g=c[b+124>>2]|0,h=c[b+128>>2]|0,(g|0)!=(h|0)):0){h=g+((h-g>>3)+-1<<3)|0;c[h>>2]=d;c[h+4>>2]=e}h=b+20|0;g=c[h>>2]|0;if(!g){g=ZW(776)|0;oe(g);c[h>>2]=g;a[b+24>>0]=1}mx(g,k,b+28|0,b+40|0);k=a[f+8+3>>0]|0;if((k<<24>>24<0?c[f+4>>2]|0:k&255)|0){p2(j,f);vF((c[h>>2]|0)+28|0,j)|0;z5(j)}Mp(c[h>>2]|0,d,e);s7(c[i>>2]|0);l=m;return}function To(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;q=l;l=l+48|0;f=q+16|0;i=q+32|0;j=q;k=b+528|0;m=b+536|0;n=i+8+3|0;o=i+4|0;p=b+880|0;g=b+884|0;h=b+876|0;e=f+8|0;while(1){r=k;t=c[r+4>>2]|0;d=m;s=c[d+4>>2]|0;if(!(t>>>0<s>>>0|((t|0)==(s|0)?(c[r>>2]|0)>>>0<(c[d>>2]|0)>>>0:0)))break;L2(f);au(b,f);TX(i);s=f;t=e;dX(j,c[s>>2]|0,c[s+4>>2]|0,c[t>>2]|0,c[t+4>>2]|0);X$(i,j)|0;while(1){t=a[n>>0]|0;d=t<<24>>24<0;if((d?c[o>>2]|0:t&255)>>>0>=32)break;zv(i,d?c[i>>2]|0:i,48)}uP(i)|0;d=c[p>>2]|0;if((d|0)==(c[g>>2]|0))Ax(h,i);else{p2(d,i);c[p>>2]=(c[p>>2]|0)+12}z5(i)}l=q;return}function Uo(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;q=l;l=l+32|0;i=q+21|0;j=q;k=q+20|0;m=q+16|0;bB(e,q+22|0);jB(e,q+12|0);NB(e,q+18|0);bB(e,i);n=e+528|0;o=e+536|0;i=a[i>>0]|0;h=0;while(1){if((h&255)>=(i&255))break;TX(j);bB(e,k);f=n;f=z0(c[f>>2]|0,c[f+4>>2]|0,2,0)|0;s=z;g=o;r=c[g+4>>2]|0;if(!(s>>>0>r>>>0|((s|0)==(r|0)?f>>>0>(c[g>>2]|0)>>>0:0))){yE(e,m);f=d[k>>0]|0;if((b[m>>1]|0)==-257)iZ(e,f,0,j);else{g=0;p=7}}else{f=d[k>>0]|0;g=0;p=7}if((p|0)==7){p=0;xZ(e,f,g,j)}if(qO(e)|0)Mc(e,0,0,376968,j,0);z5(j);h=h+1<<24>>24}l=q;return}function Vo(a){a=a|0;var d=0,e=0,f=0,h=0,i=0;TX(a);c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;x1(a+24|0);e=a+136|0;f=a+280|0;c[a+36>>2]=0;c[a+40>>2]=0;d=a+44|0;h=a+64|0;i=h+60|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(i|0));c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;h=f;i=h+120|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(i|0));c[d>>2]=7;d=a+48|0;h=a+128|0;c[h>>2]=0;c[h+4>>2]=0;h=a+160|0;c[h>>2]=0;c[h+4>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;d=a+168|0;c[d>>2]=1;c[d+4>>2]=0;d=a+176|0;h=a+200|0;c[h>>2]=0;c[h+4>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[a+208>>2]=-1;d=a+264|0;h=a+212|0;i=h+52|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(i|0));c[d>>2]=-1;i=a+268|0;g[a+400>>2]=0.0;g[a+404>>2]=0.0;g[a+408>>2]=0.0;c[i>>2]=0;c[i+4>>2]=0;b[i+8>>1]=0;return}function Wo(b){b=b|0;var d=0,e=0,f=0;Eg(b);c[b>>2]=28424;x1(b+760|0);x1(b+776|0);x1(b+792|0);TX(b+840|0);TX(b+852|0);TX(b+864|0);mI(b+876|0);a[b+494>>0]=0;f=b+808|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0;f=b+920|0;c[f>>2]=-1;c[f+4>>2]=0;f=b+928|0;c[f>>2]=-1;c[f+4>>2]=0;f=b+944|0;c[f>>2]=-1;c[f+4>>2]=-1;f=b+952|0;c[f>>2]=0;c[f+4>>2]=0;f=b+984|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;f=b+1e3|0;c[f>>2]=-1;c[f+4>>2]=-1;f=b+1008|0;c[f>>2]=0;c[f+4>>2]=0;f=b+1016|0;c[f>>2]=-1;c[f+4>>2]=-1;c[b+1024>>2]=0;c[b+1032>>2]=0;a[b+1038>>0]=0;a[b+1039>>0]=0;a[b+1040>>0]=1;f=b+780|0;e=b+788|0;b=b+1041|0;d=b+15|0;do{a[b>>0]=0;b=b+1|0}while((b|0)<(d|0));c[e>>2]=f;return}function Xo(a,b){a=a|0;b=b|0;var d=0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[a+(d<<2)>>2]=0;d=d+1|0}if(b&7|0)JX(a,379364)|0;if(b&1|0)JX(a,379371)|0;if(b&4|0)JX(a,379374)|0;if(b&2|0)JX(a,379377)|0;if(b&1536|0)JX(a,379380)|0;if(b&512|0)JX(a,379371)|0;if(b&1024|0)JX(a,379377)|0;if(b&304|0)JX(a,379388)|0;if(b&16|0)JX(a,379371)|0;if(b&256|0)JX(a,379374)|0;if(b&32|0)JX(a,379377)|0;if(b&8|0)JX(a,379396)|0;return}function Yo(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=l;l=l+16|0;c=e;a:do if((b|0)<1634758764){if((b|0)<1297044559){switch(b|0){case 1179012432:break;default:{d=8;break a}}Xy(a,23972);break}if((b|0)<1346915408){switch(b|0){case 1297044559:break;default:{d=8;break a}}Xy(a,24e3);break}else{switch(b|0){case 1346915408:break;default:{d=8;break a}}Xy(a,24036);break}}else{if((b|0)<1836020847){switch(b|0){case 1634758764:break;default:{d=8;break a}}Xy(a,24068);break}if((b|0)<1852795753){switch(b|0){case 1836020847:break;default:{d=8;break a}}Xy(a,24e3);break}else{switch(b|0){case 1852795753:break;default:{d=8;break a}}Xy(a,24092);break}}while(0);if((d|0)==8){TX(c);p2(a,lh(c,b)|0);z5(c)}l=e;return}function Zo(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+32|0;h=j+12|0;i=j;iX(h,b);Mc(b,0,0,373143,h,0);do if(!(a[b+913>>0]|0)){uP(h)|0;g=a[h+8+3>>0]|0;d=g<<24>>24<0;e=d?c[h>>2]|0:h;f=i9(20572)|0;if(f|0?(d=e+((d?c[h+4>>2]|0:g&255)<<2)|0,g=HA(e,d,20572,20572+(f<<2)|0)|0,(g|0)==(d|0)|(g-e|0)==-4):0)break;a[b+912>>0]=1}while(0);Sn(i,h);d=b+916|0;e=d+11|0;if((a[e>>0]|0)<0){J7(c[d>>2]|0,0);c[b+920>>2]=0}else{J7(d,0);a[e>>0]=0}Fp(d,0);c[d>>2]=c[i>>2];c[d+4>>2]=c[i+4>>2];c[d+8>>2]=c[i+8>>2];d=0;while(1){if((d|0)==3)break;c[i+(d<<2)>>2]=0;d=d+1|0}a1(i);z5(h);l=j;return}function _o(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;e=c[101926]|0;do if(e){k=a[d+8+3>>0]|0;j=k<<24>>24<0;k=j?c[d+4>>2]|0:k&255;j=j?c[d>>2]|0:d;d=407704;while(1){f=e+16|0;g=a[e+24+3>>0]|0;h=g<<24>>24<0;f=h?c[f>>2]|0:f;g=h?c[e+20>>2]|0:g&255;h=g>>>0<k>>>0;l=L$(j,f,h?g:k)|0;i=k>>>0<g>>>0;if((((l|0)==0?(i?-2147483648:0):l)|0)<0){f=c[e>>2]|0;if(!f){f=6;break}}else{l=L$(f,j,i?k:g)|0;if((((l|0)==0?(h?-2147483648:0):l)|0)>=0){f=10;break}d=e+4|0;f=c[d>>2]|0;if(!f){f=9;break}else e=d}d=e;e=f}if((f|0)==6){d=e;break}else if((f|0)==9)break;else if((f|0)==10)break}else{d=407704;e=407704}while(0);c[b>>2]=e;return d|0}function $o(a){a=a|0;do switch(a<<24>>24){case 4:case 3:case 2:case 1:{a=391425;break}case 5:{a=370584;break}case 6:{a=370571;break}case 7:{a=370564;break}case 8:{a=370559;break}case 9:{a=370554;break}case 12:{a=370549;break}case 13:{a=370534;break}case 14:{a=370514;break}case 15:{a=370501;break}case 16:{a=370466;break}case 20:case 19:case 17:{a=370810;break}case 21:{a=370419;break}case 22:{a=370411;break}case 23:{a=370401;break}case 24:{a=370393;break}case 25:{a=370385;break}case 26:{a=370377;break}case 27:{a=370363;break}case 28:{a=370359;break}case 29:{a=370793;break}case 32:{a=370339;break}case 33:{a=370331;break}case 34:{a=370323;break}case 35:{a=370319;break}case 36:{a=371891;break}case 38:case 37:{a=370315;break}case 39:{a=370291;break}case 40:{a=370280;break}case 41:{a=370271;break}default:a=8800948}while(0);return a|0}function ap(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;g=l;l=l+16|0;e=g;f=b+776|0;d=c[f>>2]|0;if(d|0){G2(b,d);d=b+20|0;if(RA(c[f>>2]|0,1,-1)|0){$x(e,b,1,0,58,1);Gb(b,c[f>>2]|0,1,0,0,1)|0;h=a[e+8+3>>0]|0;if((h<<24>>24<0?c[e+4>>2]|0:h&255)|0)zb(b,1,c[d>>2]|0,58,e,1);z5(e)}if(RA(c[f>>2]|0,2,-1)|0){$x(e,b,2,0,52,1);Gb(b,c[f>>2]|0,2,0,0,1)|0;h=a[e+8+3>>0]|0;if((h<<24>>24<0?c[e+4>>2]|0:h&255)|0)zb(b,2,c[d>>2]|0,52,e,1);z5(e)}Gb(b,c[f>>2]|0,3,0,0,1)|0;Gb(b,c[f>>2]|0,5,0,0,1)|0}l=g;return}function bp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=b+612|0;j=b+544|0;k=c[b+548>>2]|0;d=c[i>>2]|0;while(1){e=d+3|0;f=d+1|0;g=d+2|0;if(e>>>0>k>>>0)break;h=c[j>>2]|0;if(((a[h+d>>0]|0)==0?(a[h+f>>0]|0)==0:0)?(a[h+g>>0]&-4)<<24>>24==-128:0)break;while(1){e=d+2|0;c[i>>2]=e;if(e>>>0>=k>>>0){f=9;break}if(!(a[h+e>>0]|0)){f=8;break}else d=e}if((f|0)==8){d=d+1|0;if(a[h+d>>0]|0){d=e;continue}}else if((f|0)==9)d=d+1|0;c[i>>2]=d}do if((e|0)==(k|0)){h=c[j>>2]|0;if(((a[h+d>>0]|0)==0?(a[h+f>>0]|0)==0:0)?(a[h+g>>0]&-4)<<24>>24==-128:0)break;c[i>>2]=f;d=f}while(0);do if((d+2|0)==(k|0)){h=c[j>>2]|0;e=d+1|0;if((a[h+d>>0]|0)==0?(a[h+e>>0]|0)==0:0)break;c[i>>2]=e;d=e}while(0);if((d+1|0)==(k|0)?(a[(c[j>>2]|0)+d>>0]|0)!=0:0){c[i>>2]=k;d=k}if((d+3|0)>>>0>k>>>0)d=0;else{a[b+376>>0]=1;d=1}return d|0}function cp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;n=l;l=l+16|0;m=n;bB(a,n+8|0);jB(a,n+4|0);ID(a,m);m=c[m>>2]|0;a:do if(m|0){e=(bF(a+916|0,a+788|0)|0)+76|0;h=a+880|0;i=c[h>>2]|0;LI(e,m>>>0<i>>>0?m:i);i=a+528|0;j=a+536|0;k=a+544|0;g=a+612|0;f=0;a=c[e>>2]|0;while(1){if(f>>>0>=m>>>0)break a;d=i;b=c[d>>2]|0;d=z0(b|0,c[d+4>>2]|0,8,0)|0;e=z;o=j;p=c[o+4>>2]|0;if(e>>>0>p>>>0|((e|0)==(p|0)?d>>>0>(c[o>>2]|0)>>>0:0))break a;b=f8((c[k>>2]|0)+(c[g>>2]|0)+b|0)|0;p=i;c[p>>2]=d;c[p+4>>2]=e;if(f>>>0<(c[h>>2]|0)>>>0){p=a;c[p>>2]=b;c[p+4>>2]=z;a=a+8|0}f=f+1|0}}while(0);l=n;return}function dp(b){b=b|0;var e=0,f=0,g=0,h=0,i=0;g=l;l=l+800|0;i=g+792|0;e=g;h=b+528|0;f=h;f=z0(c[f>>2]|0,c[f+4>>2]|0,1,0)|0;c[h>>2]=f;c[h+4>>2]=z;bB(b,i);h=c[b+760>>2]|0;h=HD(h+68|0,h)|0;f=h+44|0;if((UD(f,d[i>>0]|0)|0)==(h+48|0)){EL(e);a[e+768>>0]=1;a[e+769>>0]=1;aY(b,e);rB(b,e);G2(b,e);h=c[e+772>>2]|0;i=e+776|0;c[(fD(f,i)|0)>>2]=h;h=c[e+780>>2]|0;c[(fD(f,i)|0)+4>>2]=h;EO(e)}l=g;return}function ep(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;g=l;l=l+16|0;e=g;f=b+776|0;d=c[f>>2]|0;if(d|0){s4(d);d=b+20|0;if(RA(c[f>>2]|0,1,-1)|0){$x(e,b,1,0,58,1);Gb(b,c[f>>2]|0,1,0,0,1)|0;h=a[e+8+3>>0]|0;if((h<<24>>24<0?c[e+4>>2]|0:h&255)|0)zb(b,1,c[d>>2]|0,58,e,1);z5(e)}if(RA(c[f>>2]|0,2,-1)|0){$x(e,b,2,0,52,1);Gb(b,c[f>>2]|0,2,0,0,1)|0;h=a[e+8+3>>0]|0;if((h<<24>>24<0?c[e+4>>2]|0:h&255)|0)zb(b,2,c[d>>2]|0,52,e,1);z5(e)}Gb(b,c[f>>2]|0,3,0,0,1)|0;Gb(b,c[f>>2]|0,5,0,0,1)|0}l=g;return}function fp(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;do if(!(d8(b,c[d+8>>2]|0)|0)){h=b+8|0;if(!(d8(b,c[d>>2]|0)|0)){j=c[h>>2]|0;hb[c[(c[j>>2]|0)+24>>2]&3](j,d,e,f,g);break}b=d+32|0;if((c[d+16>>2]|0)!=(e|0)?(i=d+20|0,(c[i>>2]|0)!=(e|0)):0){c[b>>2]=f;f=d+44|0;if((c[f>>2]|0)==4)break;b=d+52|0;a[b>>0]=0;k=d+53|0;a[k>>0]=0;h=c[h>>2]|0;sb[c[(c[h>>2]|0)+20>>2]&15](h,d,e,e,1,g);if(a[k>>0]|0)if(!(a[b>>0]|0)){b=3;j=11}else b=3;else{b=4;j=11}if((j|0)==11){c[i>>2]=e;k=d+40|0;c[k>>2]=(c[k>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0)a[d+54>>0]=1}c[f>>2]=b;break}if((f|0)==1)c[b>>2]=1}else TV(d,e,f);while(0);return}function gp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;a[d+12>>0]=(d|0)==(b|0)&1;g=d;while(1){if((g|0)==(b|0))break;e=c[g+8>>2]|0;i=e+12|0;if(a[i>>0]|0)break;h=e+8|0;d=c[h>>2]|0;f=c[d>>2]|0;if((f|0)==(e|0)){f=c[d+4>>2]|0;if(!f){j=8;break}f=f+12|0;if(!(a[f>>0]|0))e=f;else{j=8;break}}else{if(!f){j=13;break}f=f+12|0;if(!(a[f>>0]|0))e=f;else{j=13;break}}a[i>>0]=1;a[d+12>>0]=(d|0)==(b|0)&1;a[e>>0]=1;g=d}if((j|0)==8){if((c[e>>2]|0)!=(g|0)){fN(e);d=c[h>>2]|0;e=d;d=c[d+8>>2]|0}a[e+12>>0]=1;a[d+12>>0]=0;IM(d)}else if((j|0)==13){if((c[e>>2]|0)==(g|0)){IM(e);d=c[h>>2]|0;e=d;d=c[d+8>>2]|0}a[e+12>>0]=1;a[d+12>>0]=0;fN(d)}return}function hp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=b+612|0;j=b+544|0;k=c[b+548>>2]|0;d=c[i>>2]|0;while(1){e=d+3|0;f=d+2|0;g=d+1|0;if(e>>>0>k>>>0)break;h=c[j>>2]|0;if(((a[h+d>>0]|0)==0?(a[h+g>>0]|0)==0:0)?(a[h+f>>0]|0)==1:0)break;while(1){e=d+2|0;c[i>>2]=e;if(e>>>0>=k>>>0){f=9;break}if(!(a[h+e>>0]|0)){f=8;break}else d=e}if((f|0)==8){d=d+1|0;if(a[h+d>>0]|0){d=e;continue}}else if((f|0)==9)d=d+1|0;c[i>>2]=d}do if((e|0)==(k|0)){h=c[j>>2]|0;if(((a[h+d>>0]|0)==0?(a[h+g>>0]|0)==0:0)?(a[h+f>>0]|0)==1:0)break;c[i>>2]=g;d=g}while(0);do if((d+2|0)==(k|0)){h=c[j>>2]|0;e=d+1|0;if((a[h+d>>0]|0)==0?(a[h+e>>0]|0)==0:0)break;c[i>>2]=e;d=e}while(0);if((d+1|0)==(k|0)?(a[(c[j>>2]|0)+d>>0]|0)!=0:0){c[i>>2]=k;d=k}if((d+3|0)>>>0>k>>>0)d=0;else{a[b+376>>0]=1;d=1}return d|0}function ip(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0.0,k=0.0,m=0,n=0;n=l;l=l+16|0;d=n;RB(b,2,0,37,a[b+832>>0]|0?372224:379711,-1,1,1);RB(b,2,0,32,a[b+831>>0]|0?372228:372231,-1,1,1);m=b+136|0;f=m;e=c[f>>2]|0;f=c[f+4>>2]|0;if((!((e|0)==-1&(f|0)==-1)?(g=b+280|0,i=g,h=c[i>>2]|0,i=c[i+4>>2]|0,f>>>0>i>>>0|(f|0)==(i|0)&e>>>0>h>>>0):0)?(i=D_(e|0,f|0,h|0,i|0)|0,KW(b,2,0,68,(+(i>>>0)+4294967296.0*+(z>>>0))/1.0e6,0,1),$x(d,b,2,0,134,1),j=+Eq(d),z5(d),$x(d,b,2,0,135,1),k=+Eq(d),z5(d),j!=0.0&k!=0.0):0){i=m;m=g;m=D_(c[i>>2]|0,c[i+4>>2]|0,c[m>>2]|0,c[m+4>>2]|0)|0;KW(b,2,0,143,(+(m>>>0)+4294967296.0*+(z>>>0))/1.0e9/(j/k),0,1)}l=n;return}function jp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;i=j;iX(i,b);a:do if(qO(b)|0){d=i9(21860)|0;g=i+8+3|0;f=a[g>>0]|0;h=i+4|0;e=c[h>>2]|0;do if((d|0)==((f<<24>>24<0?e:f&255)|0))if(!(VG(i,21860,d)|0)){W5(b);RB(b,0,0,57,373758,-1,1,0);c[b+624>>2]=67108864;c[b+1096>>2]=pR(c[b+24>>2]|0)|0;break a}else{f=a[g>>0]|0;e=c[h>>2]|0;break}while(0);d=i9(21896)|0;if((d|0)==((f<<24>>24<0?e:f&255)|0)?(VG(i,21896,d)|0)==0:0){W5(b);RB(b,0,0,57,373798,-1,1,0);break}U5(b)}while(0);z5(i);l=j;return}function kp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;e=k+5|0;g=k+4|0;h=k+3|0;i=k+2|0;j=k;GC(b);f=b+648|0;A6(c[f>>2]|0);A6(c[f>>2]|0);A6(c[f>>2]|0);A6(c[f>>2]|0);AT(b,e);if(a[e>>0]|0){A6(c[f>>2]|0);A6(c[f>>2]|0);HJ(b)}while(1){xR(b,4,g);if(!(a[g>>0]|0))break;a[i>>0]=0;xR(b,4,h);e=a[h>>0]|0;d=e&255;if(e<<24>>24==15){xR(b,8,i);e=a[i>>0]|0;d=(e&255)+d|0;if(e<<24>>24==-1){sR(b,16,j);d=d+255|0}}e=0;while(1){if((e|0)==(d|0))break;d4(c[f>>2]|0,8);e=e+1|0}}J3(b);l=k;return}function lp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+16|0;g=m;h=b+528|0;i=b+536|0;j=b+916|0;k=b+788|0;while(1){e=h;n=c[e+4>>2]|0;f=i;d=c[f+4>>2]|0;if(!(n>>>0<d>>>0|((n|0)==(d|0)?(c[e>>2]|0)>>>0<(c[f>>2]|0)>>>0:0)))break;ID(b,g);if(!(qO(b)|0))continue;a[(bF(j,g)|0)+273>>0]=1;d=bF(j,g)|0;e=d+392|0;f=c[e>>2]|0;if((f|0)==(c[d+396>>2]|0))Yy(d+388|0,k);else{c[f>>2]=c[k>>2];c[e>>2]=f+4}d=bF(j,k)|0;e=d+380|0;f=c[e>>2]|0;if((f|0)==(c[d+384>>2]|0)){Yy(d+376|0,g);continue}else{c[f>>2]=c[g>>2];c[e>>2]=f+4;continue}}l=m;return}function mp(a){a=a|0;var b=0,d=0;d=a+768|0;c[(c[d>>2]|0)+92>>2]=-1;a=0;while(1){if((a|0)==8192){a=32;break}b=c[(c[(c[d>>2]|0)+80>>2]|0)+(a<<2)>>2]|0;if(b|0){Rx(b);laa(b)}b=ZW(200)|0;Ss(b);c[(c[(c[d>>2]|0)+80>>2]|0)+(a<<2)>>2]=b;a=a+1|0}while(1){if((a|0)==8191)break;b=c[(c[(c[d>>2]|0)+80>>2]|0)+(a<<2)>>2]|0;c[b+64>>2]=1;UZ(b,1);OZ(c[(c[(c[d>>2]|0)+80>>2]|0)+(a<<2)>>2]|0,0);RZ(c[(c[(c[d>>2]|0)+80>>2]|0)+(a<<2)>>2]|0,1);TZ(c[(c[(c[d>>2]|0)+80>>2]|0)+(a<<2)>>2]|0,0);wZ(c[(c[(c[d>>2]|0)+80>>2]|0)+(a<<2)>>2]|0,1);EZ(c[(c[(c[d>>2]|0)+80>>2]|0)+(a<<2)>>2]|0,0);a=a+1|0}return}function np(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=b+112|0;g=c[f>>2]|0;f=c[f+4>>2]|0;h=(g|0)!=0|(f|0)!=0;if((a[b+493>>0]|0)==0|h){i=UW(d|0,e|0,1e9,0)|0;i=nF(i|0,z|0,g|0,f|0)|0;j=z;g=b+152|0;c[g>>2]=i;c[g+4>>2]=j;g=h^1;d=b+136|0;e=d;f=c[e>>2]|0;e=c[e+4>>2]|0;if(!((f|0)==-1&(e|0)==-1|g)){e=z0(f|0,e|0,i|0,j|0)|0;h=d;c[h>>2]=e;c[h+4>>2]=z}d=b+144|0;e=d;f=c[e>>2]|0;e=c[e+4>>2]|0;if(!((f|0)==-1&(e|0)==-1|g)){i=z0(f|0,e|0,i|0,j|0)|0;j=d;c[j>>2]=i;c[j+4>>2]=z}d=b+312|0;e=d;e=z0(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;c[d>>2]=e;c[d+4>>2]=z;d=b+328|0;e=d;e=z0(c[e>>2]|0,c[e+4>>2]|0,1,0)|0;c[d>>2]=e;c[d+4>>2]=z;d=b+360|0;e=d;f=c[e>>2]|0;e=c[e+4>>2]|0;if(!((f|0)==-1&(e|0)==-1)){j=z0(f|0,e|0,1,0)|0;b=d;c[b>>2]=j;c[b+4>>2]=z}}return}function op(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;d=an(a)|0;b=a+904|0;e=b;c[e>>2]=d;c[e+4>>2]=z;if(qO(a)|0?(g=a+892|0,f=DB(g,-1,-1)|0,(f|0)!=(a+896|0)):0){d=uC(g,b)|0;e=f+28|0;a=c[f+24>>2]|0;a:while(1){if((a|0)==(e|0))break;k1(yG(d,a+16|0)|0,a+28|0)|0;b=c[a+4>>2]|0;if(!b)while(1){b=c[a+8>>2]|0;if((c[b>>2]|0)==(a|0)){a=b;continue a}else a=b}else a=b;while(1){b=c[a>>2]|0;if(!b)break;else a=b}}Tw(g,f)}return}function pp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if(d>>>0>1073741807)uaa();l=b+8|0;j=l+3|0;g=a[j>>0]|0;h=g<<24>>24<0;m=b+4|0;g=g&255;if(h){k=c[m>>2]|0;e=(c[l>>2]&2147483647)+-1|0}else{k=g;e=1}d=k>>>0>d>>>0?k:d;f=d>>>0<2;d=f?1:(d+4&-4)+-1|0;do if((d|0)!=(e|0)){i=d+1|0;e=g+1|0;do if(f){d=c[b>>2]|0;if(h){g=0;e=d;d=b;f=14}else{a3(b,d,e);laa(d);f=16}}else{if(i>>>0>1073741823)ra();d=ZW(i<<2)|0;if(h){g=1;e=c[b>>2]|0;f=14;break}else{a3(d,b,e);f=15;break}}while(0);if((f|0)==14){a3(d,e,(c[m>>2]|0)+1|0);laa(e);if(g)f=15;else f=16}if((f|0)==15){c[l>>2]=i|-2147483648;c[m>>2]=k;c[b>>2]=d;break}else if((f|0)==16){a[j>>0]=k;break}}while(0);return}function qp(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;if(d8(b,c[d+8>>2]|0)|0)gx(d,e,f,g);else{p=d+52|0;i=a[p>>0]|0;j=d+53|0;k=a[j>>0]|0;o=c[b+12>>2]|0;l=b+16+(o<<3)|0;a[p>>0]=0;a[j>>0]=0;YK(b+16|0,d,e,f,g,h);a:do if((o|0)>1){m=d+24|0;n=d+54|0;o=b+8|0;b=b+24|0;do{if(a[n>>0]|0)break a;if(!(a[p>>0]|0)){if(a[j>>0]|0?(c[o>>2]&1|0)==0:0)break a}else{if((c[m>>2]|0)==1)break a;if(!(c[o>>2]&2))break a}a[p>>0]=0;a[j>>0]=0;YK(b,d,e,f,g,h);b=b+8|0}while(b>>>0<l>>>0)}while(0);a[p>>0]=i;a[j>>0]=k}return}function rp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=b+612|0;h=b+548|0;i=b+544|0;j=b+772|0;k=b+376|0;l=c[g>>2]|0;d=c[h>>2]|0;while(1){if((l+6|0)>>>0>d>>>0){m=14;break}d=c[i>>2]|0;e=d+l|0;if(a[e>>0]|0){m=14;break}if(a[d+(l+1)>>0]|0){m=14;break}n=a[d+(l+2)>>0]|0;f=n<<24>>24==0;if(n<<24>>24!=1){if(!f){m=14;break}if((a[d+(l+3)>>0]|0)!=1){m=14;break}}d=(D9(a[e+(f?4:3)>>0]|0)|0)&31;e=c[j>>2]|0;if(a[e+(d<<1)>>0]|0){d=1;break}if(a[e+(d<<1)+1>>0]|0){d=1;break}c[g>>2]=l+4;a[k>>0]=0;if(!(nb[c[(c[b>>2]|0)+64>>2]&255](b)|0)){m=11;break}l=c[g>>2]|0;d=c[h>>2]|0;if((l+6|0)>>>0>d>>>0){m=13;break}}if((m|0)==11){a[b+377>>0]=1;d=0}else if((m|0)==13){a[b+377>>0]=1;d=0}else if((m|0)==14){t4(b);d=nb[c[(c[b>>2]|0)+64>>2]&255](b)|0}return d|0}function sp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;k=l;l=l+16|0;j=k+1|0;h=k;Bx(b);f=b+648|0;d4(c[f>>2]|0,2);xR(b,6,j);wK(b);i=b+528|0;j=a[j>>0]|0;e=0;while(1){if((e&255)>=(j&255))break;GC(b);d=i;d=z0(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;g=i;c[g>>2]=d;c[g+4>>2]=z;bB(b,h);g=a[h>>0]|0;d=0;while(1){if((d&255)>=(g&255))break;GC(b);n=i;n=z0(c[n>>2]|0,c[n+4>>2]|0,1,0)|0;m=i;c[m>>2]=n;c[m+4>>2]=z;Bx(b);d4(c[f>>2]|0,4);d4(c[f>>2]|0,4);wK(b);J3(b);d=d+1<<24>>24}J3(b);e=e+1<<24>>24}l=k;return}function tp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;b=i;g=a+892|0;h=DB(g,-1,-1)|0;if((h|0)!=(a+896|0)){e=b;c[e>>2]=0;c[e+4>>2]=0;e=uC(g,b)|0;f=h+28|0;b=c[h+24>>2]|0;a:while(1){if((b|0)==(f|0))break;k1(yG(e,b+16|0)|0,b+28|0)|0;d=c[b+4>>2]|0;if(!d)while(1){d=c[b+8>>2]|0;if((c[d>>2]|0)==(b|0)){b=d;continue a}else b=d}else b=d;while(1){d=c[b>>2]|0;if(!d)break;else b=d}}Tw(g,h)}h=a+904|0;c[h>>2]=0;c[h+4>>2]=0;l=i;return}function up(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;if((a[b+768>>0]|0)==0?(a[b+769>>0]|0)==0:0){h=b+612|0;f=c[h>>2]|0;i=b+1564|0;d=(a[i>>0]|0)!=0;e=f+6|0;if(((d?16:0)+e|0)>>>0<=(c[b+548>>2]|0)>>>0){g=b+1566|0;do if(d?(a[g>>0]|0)==0:0){d=c[b+544>>2]|0;if((((((((((a[d+f>>0]|0)==1?(a[d+(f+1)>>0]|0)==16:0)?(a[d+(f+2)>>0]|0)==0:0)?(j=a[d+(f+3)>>0]|0,(j&255)<96&(j&14)<10):0)?(a[d+(f+4)>>0]|0)==0:0)?(j=a[d+(f+5)>>0]|0,(j&255)<96&(j&14)<10):0)?(a[d+e>>0]|0)==0:0)?(j=a[d+(f+7)>>0]|0,(j&255)<96&(j&14)<10):0)?(a[d+(f+8)>>0]|0)==0:0)?(j=a[d+(f+9)>>0]|0,(j&255)<64&(j&14)<10):0){c[h>>2]=f+16;break}a[i>>0]=0}while(0);if(Oh(b)|0){d=a[b+376>>0]|0;if((d<<24>>24!=0?(a[i>>0]|0)!=0:0)?(a[g>>0]|0)==0:0){c[h>>2]=(c[h>>2]|0)+-16;a[b+1565>>0]=d;a[g>>0]=0;d=1}else d=1}else d=0}else d=0}else d=1;return d|0}function vp(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;i=(f&2|0)!=0;j=b+136|0;h=b+144|0;g=(f&1|0)==0;if(!(a[b+493>>0]|0)){b=b+104|0;f=c[b>>2]|0;b=c[b+4>>2]|0;if(!((f|0)==0&(b|0)==0)){l=nT(f,b)|0;k=z;m=nF(1e9,0,l|0,k|0)|0;d=UW(m|0,z|0,d|0,e|0)|0;e=z;f=nF(f|0,b|0,l|0,k|0)|0;f=nF(d|0,e|0,f|0,z|0)|0;b=z;if(!g){m=j;c[m>>2]=f;c[m+4>>2]=b}if(i){m=h;c[m>>2]=f;c[m+4>>2]=b}}}else{b=b+112|0;f=c[b>>2]|0;b=c[b+4>>2]|0;if(!((f|0)==0&(b|0)==0)){n=nT(f,b)|0;k=z;l=nF(1e9,0,n|0,k|0)|0;l=UW(l|0,z|0,d|0,e|0)|0;m=z;f=nF(f|0,b|0,n|0,k|0)|0;f=nF(l|0,m|0,f|0,z|0)|0;b=z;if(!g){n=j;c[n>>2]=f;c[n+4>>2]=b}if(i){n=h;c[n>>2]=f;c[n+4>>2]=b}}}return}function wp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;g=b;f=d-g>>2;e=a+8|0;k=c[a>>2]|0;j=k;a:do if(f>>>0>(c[e>>2]|0)-k>>2>>>0){jP(a);if(f>>>0>1073741823)uaa();else{k=(c[e>>2]|0)-(c[a>>2]|0)|0;l=k>>1;QV(a,k>>2>>>0<536870911?(l>>>0<f>>>0?f:l):1073741823);LR(a,b,d);break}}else{l=a+4|0;h=(c[l>>2]|0)-k>>2;i=f>>>0>h>>>0;h=i?b+(h<<2)|0:d;e=h-g|0;f=e>>2;if(f|0)TR(k|0,b|0,e|0)|0;f=j+(f<<2)|0;if(i){LR(a,h,d);break}e=c[l>>2]|0;while(1){if((e|0)==(f|0))break a;d=e+-4|0;c[l>>2]=d;e=d}}while(0);return}function xp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=l;l=l+32|0;g=j+12|0;h=j;if(d|0){e=c[b>>2]|0;i=(c[e+508>>2]|0)==0;if(!i)J3(e);c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;f=j9(d)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[h+11>>0]=f;e=h}else{k=f+16&-16;e=ZW(k)|0;c[h>>2]=e;c[h+8>>2]=k|-2147483648;c[h+4>>2]=f}i1(e,d,f)|0;J7(e+f|0,0);JX(h,380369)|0;c[g>>2]=c[h>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];e=0;while(1){if((e|0)==3)break;c[h+(e<<2)>>2]=0;e=e+1|0}a1(g);a1(h);if(!i){k=(c[b>>2]|0)+508|0;c[k>>2]=(c[k>>2]|0)+1}}rn(b,0,0,d);l=j;return}function yp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;g=b;f=d-g>>3;e=a+8|0;k=c[a>>2]|0;j=k;a:do if(f>>>0>(c[e>>2]|0)-k>>3>>>0){iP(a);if(f>>>0>536870911)uaa();else{k=(c[e>>2]|0)-(c[a>>2]|0)|0;l=k>>2;SV(a,k>>3>>>0<268435455?(l>>>0<f>>>0?f:l):536870911);JR(a,b,d);break}}else{l=a+4|0;h=(c[l>>2]|0)-k>>3;i=f>>>0>h>>>0;h=i?b+(h<<3)|0:d;e=h-g|0;f=e>>3;if(f|0)TR(k|0,b|0,e|0)|0;f=j+(f<<3)|0;if(i){JR(a,h,d);break}e=c[l>>2]|0;while(1){if((e|0)==(f|0))break a;d=e+-8|0;c[l>>2]=d;e=d}}while(0);return}function zp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+48|0;h=m+36|0;i=m+24|0;j=m+12|0;k=m;FN(b);g=a[d+8+3>>0]|0;a:do if((g<<24>>24<0?c[d+4>>2]|0:g&255)|0){e=0;f=0;while(1){if((e|0)==-1)break a;g=oH(d,10,f)|0;e=oH(d,59,f)|0;if(g>>>0>e>>>0){lw(i,d,e+1|0,g+-1-e|0);p2(h,i);lw(k,d,f,e-f|0);p2(j,k);k1(yG(b,j)|0,h)|0;z5(j);O0(k);z5(h);O0(i)}e=g;f=g+1|0}}while(0);l=m;return}function Ap(b){b=b|0;var e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;g=i+1|0;e=i;GC(b);AT(b,g);h=b+648|0;if(a[g>>0]|0){d4(c[h>>2]|0,4);d4(c[h>>2]|0,4)}A6(c[h>>2]|0);AT(b,g);if(!(a[g>>0]|0))f=1;else{xR(b,4,e);d4(c[h>>2]|0,4);f=(d[e>>0]|0)+1&255;e=0;while(1){if((e&255)>>>0>=f>>>0)break;d4(c[h>>2]|0,8);e=e+1<<24>>24}}AT(b,g);if(!(a[g>>0]|0))e=0;else{d4(c[h>>2]|0,7);d4(c[h>>2]|0,1);e=0}while(1){if((e&255)>>>0>=f>>>0)break;d4(c[h>>2]|0,1);d4(c[h>>2]|0,7);e=e+1<<24>>24}J3(b);l=i;return}function Bp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+32|0;i=k+24|0;b=k+8|0;d=k;e=a+4|0;h=c[e>>2]|0;if(h>>>0<256){f=c[a+8>>2]|0;g=f<<5;j=256-h|0;if(g>>>0<j>>>0|h>>>0>(g-j|0)>>>0){c[b>>2]=0;m=b+4|0;c[m>>2]=0;c[b+8>>2]=0;h=f<<6;wy(b,g>>>0<1073741823?(h>>>0>256?h:256):2147483647);h=c[e>>2]|0;c[m>>2]=h+j;g=c[a>>2]|0;c[i>>2]=c[b>>2];c[i+4>>2]=0;du(d,g,0,g+(h>>>5<<2)|0,h&31,i);h=d;g=c[h>>2]|0;h=c[h+4>>2]|0;EN(a,b);s8(c[b>>2]|0);b=g;a=h}else{b=(c[a>>2]|0)+(h>>>5<<2)|0;c[e>>2]=256;a=h&31}if(j|0){c[i>>2]=b;c[i+4>>2]=a;hC(i,j)}}else c[e>>2]=256;l=k;return}function Cp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;p=l;l=l+16|0;m=p;n=a+736|0;d=c[n>>2]|0;o=a+740|0;e=c[o>>2]|0;while(1){if((e|0)==(d|0))break;k=e+-8|0;c[o>>2]=k;e=k}j=b+4|0;k=a+16|0;h=a+20|0;i=a+744|0;g=1;d=0;while(1){if((g|0)==7)break;else f=0;while(1){e=c[c[j>>2]>>2]|0;if(f>>>0>=(((c[e+(g*12|0)+4>>2]|0)-(c[e+(g*12|0)>>2]|0)|0)/40|0)>>>0)break;Kc(a,g,-1)|0;p0(m,c[k>>2]|0,c[h>>2]|0);e=c[o>>2]|0;if(e>>>0<(c[i>>2]|0)>>>0){r=m;q=c[r+4>>2]|0;c[e>>2]=c[r>>2];c[e+4>>2]=q;c[o>>2]=(c[o>>2]|0)+8}else Px(n,m);Gb(a,b,g,f,c[h>>2]|0,1)|0;f=f+1|0;d=d+1|0}g=g+1|0}l=p;return d|0}function Dp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+16|0;k=q;m=b+836|0;f=c[m>>2]|0;n=b+1248|0;o=b+1244|0;if(!(f&512)){c[o>>2]=0;c[n>>2]=0}do if(!(f&1024)){h=c[o>>2]|0;i=(h|0)!=0;if(i?c[n>>2]|0:0)break;f=(c[b+544>>2]|0)+(c[b+612>>2]|0)+(c[b+528>>2]|0)|0;j=f+d+-3|0;while(1){if(f>>>0>=j>>>0){p=14;break}g=f;f=f+1|0;if((a[g>>0]|0)!=2)continue;if(a[f>>0]|0)continue;if((a[g+2>>0]|0)!=8)continue;if((a[g+3>>0]|0)==80)break}if((p|0)==14){c[o>>2]=h+1;break}p=(c[n>>2]|0)+1|0;c[n>>2]=p;if(!(i|p>>>0<8))PU(m,10)|0}while(0);e1(b,d,e);if(qO(b)|0){VU(k,375368);vF(b+792|0,k)|0;z5(k);PU(m,9)|0}l=q;return}function Ep(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+16|0;j=i+1|0;g=i;GC(b);h=b+22116|0;xR(b,1,(c[h>>2]|0)+2|0);xR(b,4,(c[h>>2]|0)+3|0);xR(b,4,(c[h>>2]|0)+4|0);xR(b,3,(c[h>>2]|0)+5|0);d=b+648|0;d4(c[d>>2]|0,2);AT(b,j);AT(b,g);e=c[h>>2]|0;f=e+6|0;if(!(a[j>>0]|0)){a[f>>0]=2;a[e+7>>0]=1;a[e+8>>0]=2}else{xR(b,2,f);xR(b,1,(c[h>>2]|0)+7|0);xR(b,2,(c[h>>2]|0)+8|0)}if(a[g>>0]|0){d4(c[d>>2]|0,2);d4(c[d>>2]|0,2);A6(c[d>>2]|0);A6(c[d>>2]|0)}J3(b);l=i;return}function Fp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if(d>>>0>4294967279)uaa();j=b+11|0;f=a[j>>0]|0;h=f<<24>>24<0;l=b+4|0;f=f&255;m=b+8|0;if(h){k=c[l>>2]|0;e=(c[m>>2]&2147483647)+-1|0}else{k=f;e=10}d=k>>>0>d>>>0?k:d;g=d>>>0<11;d=g?10:(d+16&-16)+-1|0;do if((d|0)!=(e|0)){e=f+1|0;i=d+1|0;do if(g){d=c[b>>2]|0;if(h){g=0;e=d;d=b;f=12}else{i1(b,d,e)|0;laa(d);f=14}}else{d=ZW(i)|0;if(h){g=1;e=c[b>>2]|0;f=12;break}else{i1(d,b,e)|0;f=13;break}}while(0);if((f|0)==12){i1(d,e,(c[l>>2]|0)+1|0)|0;laa(e);if(g)f=13;else f=14}if((f|0)==13){c[m>>2]=i|-2147483648;c[l>>2]=k;c[b>>2]=d;break}else if((f|0)==14){a[j>>0]=k;break}}while(0);return}function Gp(b){b=b|0;var d=0,f=0.0,g=0,h=0,i=0,j=0,k=0,l=0;RB(b,2,0,110,384435,-1,1,0);if(!(a[b+904>>0]|0)){d=a[b+930>>0]|0;if((d&255)<15){g=UW((c[b+920>>2]|0)+(c[b+916>>2]|0)-(c[b+912>>2]|0)|0,0,1e3,0)|0;l=c[16400+((d&255)<<2)>>2]|0;g=g5(g|0,z|0,l|0,0)|0;d=z;h=b+40|0;i=b+768|0;i=D_(c[h>>2]|0,c[h+4>>2]|0,c[i>>2]|0,c[i+4>>2]|0)|0;h=z;k=(a[b+926>>0]|0)!=0;j=e[61554+(((a[b+925>>0]<<1&255|a[b+924>>0])&255)<<1)>>1]|0;l=UW(l|0,0,g|0,d|0)|0;k=UW(l|0,z|0,(k?1:2)|0,(k?0:0)|0)|0;j=UW(k|0,z|0,j|0,0)|0;j=g5(j|0,z|0,8e3,0)|0;f=(+(j>>>0)+4294967296.0*+(z>>>0))/(+(i>>>0)+4294967296.0*+(h>>>0));oK(b,2,0,194,i,h,3,1);oK(b,2,0,68,g,d,10,1);Bt(b,2,0,155,f,3,1)}Vt(b+760|0)}return}function Hp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0.0,m=0.0;i=l;l=l+16|0;b=i+12|0;f=i;bD(a,b);b=c[b>>2]|0;if((b|0)==-1){d=a+928|0;b=c[d>>2]|0;d=c[d+4>>2]|0}else d=0;do if(qO(a)|0?($x(f,a,2,0,135,1),e=pn(f)|0,z5(f),e|0):0){b=UW(b|0,d|0,1e3,0)|0;b=g5(b|0,z|0,e|0,0)|0;d=z;e=a+40|0;j=e;if((!((c[j>>2]|0)==-1?(c[j+4>>2]|0)==-1:0)?($x(f,a,2,0,112,1),g=rm(f)|0,h=z,z5(f),!((g|0)==0&(h|0)==0)):0)?(j=e,j=UW(c[j>>2]|0,c[j+4>>2]|0,8e3,0)|0,j=g5(j|0,z|0,g|0,h|0)|0,m=+(j>>>0)+4294967296.0*+(z>>>0),k=+(b>>>0)+4294967296.0*+(d>>>0),m>k*1.02|m<k*.98):0)break;oK(a,2,0,68,b,d,10,0)}while(0);l=i;return}function Ip(b){b=b|0;var d=0,e=0.0,f=0,g=0,h=0,i=0,j=0,k=0,m=0.0,n=0;k=l;l=l+32|0;i=k+12|0;j=k;h=b+768|0;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!((g|0)==-1&(h|0)==0)?(f=b+760|0,d=a[f>>0]|0,d<<24>>24):0){e=+(d&255);d=b+761|0;if(a[d>>0]|0){m=e*60.0*60.0;e=e*((m+-108.0)/m)}n=UW(g|0,h|0,1e3,0)|0;sN(b,0,0,378106,(+(n>>>0)+4294967296.0*+(z|0))/e,0,0);Sk(i,g,h,a[f>>0]|0,(a[d>>0]|0)!=0);Kc(b,4,-1)|0;d=b+20|0;RB(b,4,c[d>>2]|0,18,380054,-1,1,0);h=c[d>>2]|0;nk(j,i);RB(b,4,h,91,(a[j+11>>0]|0)<0?c[j>>2]|0:j,-1,1,0);a1(j);j=b+312|0;if((c[j>>2]|0)==1&(c[j+4>>2]|0)==0)RB(b,4,c[d>>2]|0,93,382808,-1,1,0)}l=k;return}function Jp(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+16|0;j=n+1|0;k=n;GC(b);m=b+528|0;o=m;g=c[o>>2]|0;o=c[o+4>>2]|0;h=z0(g|0,o|0,e&255|0,0)|0;i=z;e=o;while(1){if(!(e>>>0<i>>>0|(e|0)==(i|0)&g>>>0<h>>>0))break;bB(b,j);e=a[j>>0]|0;do if((e&255)<63){bB(b,k);g=d[k>>0]|0;if(!(e<<24>>24))vY(b,g,0,f);else e1(b,g,0)}else{if(e<<24>>24==63){bB(b,k);WY(b,d[k>>0]|0,0,f);break}if((e&255)>159){bB(b,k);e1(b,d[k>>0]|0,0)}}while(0);g=m;e=c[g+4>>2]|0;g=c[g>>2]|0}J3(b);l=n;return}function Kp(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;e=c[d+780>>2]|0;f=0;while(1){if((f|0)==185)break;a[e+(f*3|0)>>0]=0;a[e+(f*3|0)+1>>0]=0;a[e+(f*3|0)+2>>0]=0;f=f+1|0}a[e+539>>0]=1;a[e+554>>0]=1;c[d+924>>2]=-1;a[d+990>>0]=-1;a[d+1039>>0]=0;a[d+1016>>0]=0;a[d+1017>>0]=0;e=d+1048|0;c[e>>2]=-1;c[e+4>>2]=-1;a[d+1072>>0]=0;e=d+1092|0;f=e+11|0;if((a[f>>0]|0)<0){J7(c[e>>2]|0,0);c[d+1096>>2]=0}else{J7(e,0);a[f>>0]=0}b[d+976>>1]=-1;h=d+792|0;i=d+796|0;f=0;while(1){e=c[i>>2]|0;j=c[h>>2]|0;g=j;if(f>>>0>=e-j>>2>>>0)break;e=c[g+(f<<2)>>2]|0;if(e|0)laa(e);f=f+1|0}while(1){if((e|0)==(g|0))break;j=e+-4|0;c[i>>2]=j;e=j}c[d+804>>2]=0;if(!(c[d+728>>2]&1)){s_(d);AR(d,179,0);AR(d,184,0)}return}function Lp(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+64|0;o=r;q=c[d>>2]|0;p=d+(c[q+-8>>2]|0)|0;q=c[q+-4>>2]|0;c[o>>2]=e;c[o+4>>2]=d;c[o+8>>2]=2656;g=o+12|0;h=o+16|0;i=o+20|0;j=o+24|0;k=o+28|0;m=o+32|0;n=o+40|0;d=d8(q,e)|0;e=g;f=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));b[g+40>>1]=0;a[g+42>>0]=0;a:do if(d){c[o+48>>2]=1;sb[c[(c[q>>2]|0)+20>>2]&15](q,o,p,p,1,0);d=(c[j>>2]|0)==1?p:0}else{hb[c[(c[q>>2]|0)+24>>2]&3](q,o,p,1,0);switch(c[o+36>>2]|0){case 0:{d=(c[n>>2]|0)==1&(c[k>>2]|0)==1&(c[m>>2]|0)==1?c[i>>2]|0:0;break a}case 1:break;default:{d=0;break a}}if((c[j>>2]|0)!=1?!((c[n>>2]|0)==0&(c[k>>2]|0)==1&(c[m>>2]|0)==1):0){d=0;break}d=c[h>>2]|0}while(0);l=r;return d|0}function Mp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,h=0;f=b+40|0;h=f;c[h>>2]=d;c[h+4>>2]=e;h=(c[b+668>>2]|0)+8|0;c[h>>2]=d;c[h+4>>2]=e;jb[c[(c[b>>2]|0)+20>>2]&511](b);d=b+48|0;h=c[d+4>>2]|0;e=f;f=c[e+4>>2]|0;if(!(h>>>0>f>>>0|((h|0)==(f|0)?(c[d>>2]|0)>>>0>(c[e>>2]|0)>>>0:0))){d=b+64|0;h=d;if(!((c[h>>2]|0)==-1?(c[h+4>>2]|0)==-1:0)){Kl(b);h=d;c[h>>2]=-1;c[h+4>>2]=-1}h=WO()|0;if(!((h|0)==0&(z|0)==0)){f=WO()|0;h=b+632|0;c[h>>2]=f;c[h+4>>2]=z}h=b+24|0;f=c[h>>2]|0;dN(f,+nU());h=c[h>>2]|0;a[b+379>>0]=+g[h+136>>2]>=1.0&1;if(dS(h)|0)a[b+492>>0]=1}else z$(b);return}function Np(d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;c[d>>2]=e;c[d+4>>2]=f;c[d+8>>2]=g;c[d+12>>2]=h;c[d+16>>2]=i;c[d+20>>2]=j;c[d+24>>2]=k;b[d+36>>1]=0;a[d+38>>0]=l;a[d+39>>0]=m;a[d+40>>0]=n;a[d+41>>0]=o;a[d+42>>0]=p;a[d+43>>0]=q;a[d+44>>0]=r;a[d+45>>0]=s;a[d+46>>0]=t;a[d+47>>0]=-1;a[d+48>>0]=u&1;a[d+49>>0]=v&1;a[d+50>>0]=w&1;a[d+51>>0]=x&1;a[d+52>>0]=y&1;n=d+32|0;e=d+28|0;switch(r<<24>>24){case 0:{c[e>>2]=~~+eaa((s&255)+4|0)>>>0;c[n>>2]=-1;break}case 2:case 1:{c[e>>2]=-1;c[n>>2]=~~+eaa((q&255)+4|0)>>>0;break}default:{c[n>>2]=-1;c[e>>2]=-1}}return}function Op(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;if((d|0)==0&(e|0)==0)t4(b);f=b+508|0;g=b+668|0;if(a[b+494>>0]|0?0<e>>>0|(0==(e|0)?(c[b+624>>2]|0)>>>0<d>>>0:0):0){i=c[f>>2]|0;h=c[g>>2]|0;a[h+(i*24|0)+18>>0]=1;a[h+((i+-1|0)*24|0)+18>>0]=1;t4(b)}h=c[f>>2]|0;i=c[g>>2]|0;if(!(a[i+(h*24|0)+17>>0]|0)){j=b+528|0;l=c[j>>2]|0;j=c[j+4>>2]|0;k=j>>>0>e>>>0|(j|0)==(e|0)&l>>>0>d>>>0;f=b+48|0;g=c[b+612>>2]|0;f=z0((k?l:d)|0,(k?j:e)|0,c[f>>2]|0,c[f+4>>2]|0)|0;g=z0(f|0,z|0,g|0,0)|0;f=z;if((h|0)==1)b=0;else{l=i+((h+-2|0)*24|0)+8|0;j=c[l>>2]|0;l=c[l+4>>2]|0;k=f>>>0>l>>>0|(f|0)==(l|0)&g>>>0>j>>>0;b=h+-1|0;g=k?j:g;f=k?l:f}l=i+(b*24|0)+8|0;c[l>>2]=g;c[l+4>>2]=f;a[i+(b*24|0)+18>>0]=1}return}function Pp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=b+616|0;d=c[j>>2]|0;k=b+612|0;if(!d){d=(c[k>>2]|0)+4|0;c[j>>2]=d}h=b+544|0;e=c[b+548>>2]|0;while(1){if((d+5|0)>>>0>e>>>0)break;g=c[h>>2]|0;f=g+d|0;if((R4(a[f>>0]|0,a[f+1>>0]|0,a[f+2>>0]|0)|0)==1)break;while(1){f=d+2|0;c[j>>2]=f;if(f>>>0>=e>>>0){i=9;break}if(!(a[g+f>>0]|0)){i=8;break}else d=f}if((i|0)==8){i=0;d=d+1|0;if(a[g+d>>0]|0){d=f;continue}}else if((i|0)==9){i=0;d=d+1|0}c[j>>2]=d}do if((d+5|0)>>>0>e>>>0){if((a[b+768>>0]|0)==0?(a[(c[b+24>>2]|0)+141>>0]|0)==0:0){d=0;break}c[j>>2]=e;i=15}else{e=d;i=15}while(0);if((i|0)==15){d=e+-1|0;if(!(a[(c[h>>2]|0)+d>>0]|0))c[j>>2]=d;else d=e;Op(b,d-(c[k>>2]|0)|0,0);c[j>>2]=0;d=1}return d|0}function Qp(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;i=l;l=l+16|0;h=i+13|0;f=i+12|0;g=i;bB(b,h);h=a[h>>0]|0;if(!(h<<24>>24)){VU(g,382735);BZ(c[b+508>>2]|0,c[b+668>>2]|0,0,0);z5(g);Op(b,1,0)}else{e=0;do{bB(b,f);j=d[f>>0]|0;e=j&127|e<<7}while((j&128|0)!=0);TX(g);ex(g,h)|0;BZ(c[b+508>>2]|0,c[b+668>>2]|0,h&255,0);z5(g);j=b+528|0;h=c[j>>2]|0;j=c[j+4>>2]|0;k=z0(h|0,j|0,e|0,0)|0;n=z;m=b+536|0;f=c[m>>2]|0;m=c[m+4>>2]|0;g=D_(f|0,m|0,h|0,j|0)|0;j=z0((n>>>0<m>>>0|(n|0)==(m|0)&k>>>0<f>>>0?e:g)|0,0,h|0,j|0)|0;Op(b,j,z)}l=i;return}function Rp(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=c[a+28>>2]|0;k=h+56|0;e=c[k>>2]|0;i=h+40|0;if(!e){e=gb[c[a+32>>2]&31](c[a+40>>2]|0,1<<c[i>>2],1)|0;c[k>>2]=e;if(!e)e=1;else f=3}else f=3;a:do if((f|0)==3){g=h+44|0;a=c[g>>2]|0;j=h+48|0;f=h+52|0;if(!a){a=1<<c[i>>2];c[g>>2]=a;c[f>>2]=0;c[j>>2]=0}do if(a>>>0>d>>>0){i=c[f>>2]|0;a=a-i|0;a=a>>>0>d>>>0?d:a;no(e+i|0,b+(0-d)|0,a|0)|0;e=d-a|0;if(e|0){no(c[k>>2]|0,b+(0-e)|0,e|0)|0;c[f>>2]=e;e=c[g>>2]|0;break}e=(c[f>>2]|0)+a|0;k=c[g>>2]|0;c[f>>2]=(e|0)==(k|0)?0:e;e=c[j>>2]|0;if(e>>>0>=k>>>0){e=0;break a}e=e+a|0}else{no(e|0,b+(0-a)|0,a|0)|0;c[f>>2]=0;e=c[g>>2]|0}while(0);c[j>>2]=e;e=0}while(0);return e|0}function Sp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;g=b+612|0;h=b+548|0;i=b+544|0;j=b+776|0;k=b+376|0;l=c[g>>2]|0;d=c[h>>2]|0;while(1){if((l+6|0)>>>0>d>>>0){m=13;break}d=c[i>>2]|0;e=d+l|0;if(a[e>>0]|0){m=13;break}if(a[d+(l+1)>>0]|0){m=13;break}n=a[d+(l+2)>>0]|0;f=n<<24>>24==0;if(n<<24>>24!=1){if(!f){m=13;break}if((a[d+(l+3)>>0]|0)!=1){m=13;break}}n=((D9(a[e+(f?4:3)>>0]|0)|0)&255)>>>1&63;if(a[(c[j>>2]|0)+n>>0]|0){d=1;break}c[g>>2]=l+4;a[k>>0]=0;if(!(nb[c[(c[b>>2]|0)+64>>2]&255](b)|0)){m=10;break}l=c[g>>2]|0;d=c[h>>2]|0;if((l+6|0)>>>0>d>>>0){m=12;break}}if((m|0)==10){a[b+377>>0]=1;d=0}else if((m|0)==12){a[b+377>>0]=1;d=0}else if((m|0)==13){t4(b);d=nb[c[(c[b>>2]|0)+64>>2]&255](b)|0}return d|0}function Tp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;i=l;l=l+16|0;g=i+12|0;h=i;f=_o(g,d)|0;d=c[f>>2]|0;if(!d){cG(h,e);d=c[h>>2]|0;DE(c[g>>2]|0,f,d);f=1}else f=0;c[b>>2]=d;a[b+4>>0]=f;l=i;return}function Up(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+16|0;g=o+12|0;m=o+8|0;n=o;XP(n,b);if(a[n>>0]|0){i=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;h=c[i+4>>2]&74;O4(g,i);i=u$(c[g>>2]|0,409180)|0;c6(g);j=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;k=c[j+24>>2]|0;f=j+76|0;e=c[f>>2]|0;if(d8(-1,e)|0){O4(g,j);e=u$(c[g>>2]|0,409148)|0;e=tb[c[(c[e>>2]|0)+44>>2]&31](e,32)|0;c6(g);c[f>>2]=e}f=c[(c[i>>2]|0)+16>>2]|0;c[m>>2]=k;c[g>>2]=c[m>>2];if(!(ub[f&31](i,g,j,e,(h|0)==64|(h|0)==8?d&65535:d<<16>>16)|0)){m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(m,c[m+16>>2]|5)}}TC(n);l=o;return b|0}function Vp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;GC(a);j=a+528|0;i=j;h=c[i>>2]|0;i=c[i+4>>2]|0;g=sF(a+760|0,a+772|0)|0;f=g+68|0;g=g+72|0;d=0;while(1){if(d>>>0>=(c[g>>2]|0)-(c[f>>2]|0)>>5>>>0)break;GC(a);e=c[f>>2]|0;k=e+(d<<5)+8|0;if((c[k>>2]|0)==960137799?(c[k+4>>2]|0)==-1212271343:0)Nw(a);else d=(c[g>>2]|0)-e>>5;J3(a);d=d+1|0}d=z0(h|0,i|0,b|0,0)|0;e=z;k=j;i=c[k+4>>2]|0;if(i>>>0<e>>>0|((i|0)==(e|0)?(c[k>>2]|0)>>>0<d>>>0:0)){GC(a);k=j;k=D_(d|0,e|0,c[k>>2]|0,c[k+4>>2]|0)|0;e1(a,k,z);J3(a)}J3(a);return}function Wp(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0;a:do if(((a[b+492>>0]|0)==0?(i=c[b+804>>2]|0,(i|0)!=(c[b+808>>2]|0)):0)?!(+g[(c[b+24>>2]|0)+136>>2]>=1.0):0){h=b+816|0;f=b+828|0;e=0;while(1){if((e|0)==256)break a;d=i+(e*120|0)+72|0;b=i+(e*120|0)+116|0;if(!((c[d>>2]|0)==-1?(c[d+4>>2]|0)==-1:0))a[b>>0]=1;d=i+(e*120|0)+88|0;if(!((c[d>>2]|0)==-1?(c[d+4>>2]|0)==-1:0))a[b>>0]=1;b=c[h>>2]|0;j=b+(e*120|0)+72|0;d=b+(e*120|0)+116|0;if(!((c[j>>2]|0)==-1?(c[j+4>>2]|0)==-1:0))a[d>>0]=1;j=b+(e*120|0)+88|0;if(!((c[j>>2]|0)==-1?(c[j+4>>2]|0)==-1:0))a[d>>0]=1;b=c[f>>2]|0;j=b+(e*120|0)+72|0;d=b+(e*120|0)+116|0;if(!((c[j>>2]|0)==-1?(c[j+4>>2]|0)==-1:0))a[d>>0]=1;j=b+(e*120|0)+88|0;if(!((c[j>>2]|0)==-1?(c[j+4>>2]|0)==-1:0))a[d>>0]=1;e=e+1|0}}while(0);return 0}function Xp(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+80|0;f=k+64|0;i=k;a:do if((c&255)<=8?(g=r_(a[b+3>>0]|0,c)|0,h=EP(a[b+4>>0]|0,c,g)|0,(h&255)>(g&255)):0){e=(h&255)-(g&255)|0;switch(c<<24>>24){case 3:case 2:case 1:case 0:{if((e|0)>32){c=0;break a}break}case 4:{if((e|0)>35){c=0;break a}break}case 8:case 7:case 6:case 5:{if((e|0)>48){c=0;break a}break}default:{}}c=a[b+6>>0]|0;if(c<<24>>24)if(Xh(f,i,c,g,h)|0)j=10;else c=0;else{or(f,i,a[b+7>>0]|0,g,h);j=10}if((j|0)==10){c=a[f>>0]|0;if((c&255)>(d[b+5>>0]|0))c=KC(c,i,b,h)|0;else c=0}}else c=0;while(0);l=k;return c|0}function Yp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;d=a+772|0;b=c[d>>2]|0;e=a+544|0;f=a+48|0;g=a+612|0;h=a+780|0;i=a+776|0;j=a+548|0;if(b|0){k=c[g>>2]|0;m=f;m=z0(c[m>>2]|0,c[m+4>>2]|0,k|0,0)|0;l=f;c[l>>2]=m;c[l+4>>2]=z;l=c[e>>2]|0;c[e>>2]=b;c[d>>2]=l;c[g>>2]=c[i>>2];c[i>>2]=k;b=c[j>>2]|0;c[j>>2]=c[h>>2];c[h>>2]=b}m=a+520|0;b=c[m+4>>2]|0;switch(c[m>>2]|0){case 0:{if(!b)ok(a);break}case 1:{if(!b)ie(a);break}case 2:{if(!b)Hj(a);break}default:{}}if(c[d>>2]|0){jaa(c[e>>2]|0);c[e>>2]=c[d>>2];c[d>>2]=0;l=c[i>>2]|0;c[g>>2]=l;c[j>>2]=c[h>>2];m=f;l=D_(c[m>>2]|0,c[m+4>>2]|0,l|0,0)|0;m=f;c[m>>2]=l;c[m+4>>2]=z}return}function Zp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;o=(c[b>>2]|0)+1794895138|0;h=c5(c[b+8>>2]|0,o)|0;f=c5(c[b+12>>2]|0,o)|0;g=c5(c[b+16>>2]|0,o)|0;a:do if((h>>>0<d>>>2>>>0?(n=d-(h<<2)|0,f>>>0<n>>>0&g>>>0<n>>>0):0)?((g|f)&3|0)==0:0){n=f>>>2;m=g>>>2;l=0;while(1){j=h>>>1;k=l+j|0;i=k<<1;g=i+n|0;f=c5(c[b+(g<<2)>>2]|0,o)|0;g=c5(c[b+(g+1<<2)>>2]|0,o)|0;if(!(g>>>0<d>>>0&f>>>0<(d-g|0)>>>0)){f=0;break a}if(a[b+(g+f)>>0]|0){f=0;break a}f=xN(e,b+g|0)|0;if(!f)break;f=(f|0)<0;if((h|0)==1){f=0;break a}else{l=f?l:k;h=f?j:h-j|0}}f=i+m|0;g=c5(c[b+(f<<2)>>2]|0,o)|0;f=c5(c[b+(f+1<<2)>>2]|0,o)|0;if(f>>>0<d>>>0&g>>>0<(d-f|0)>>>0)f=(a[b+(f+g)>>0]|0)==0?b+f|0:0;else f=0}else f=0;while(0);return f|0}function _p(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;g=l;l=l+16|0;e=g;d=b+769|0;do if((a[d>>0]|0)==0?(a[b+770>>0]|0)==0:0){d=b+528|0;h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,3,0)|0;c[d>>2]=h;c[d+4>>2]=z;d=b+888|0;bB(b,d);if(lo(b)|0){h=a[d>>0]|0;TX(e);ex(e,a[d>>0]|0)|0;BZ(c[b+508>>2]|0,c[b+668>>2]|0,h&255,0);z5(e);break}else{c3(c[b+508>>2]|0,c[b+668>>2]|0);break}}else f=3;while(0);if((f|0)==3){Op(b,c[b+548>>2]|0,0);h=a[d>>0]|0;TX(e);ex(e,a[d>>0]|0?15:13)|0;h=h<<24>>24!=0;BZ(c[b+508>>2]|0,c[b+668>>2]|0,h?15:13,h?0:0);z5(e)}l=g;return}function $p(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Ht(d,h,e)|0;e=c[g>>2]|0;if(!e){jD(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function aq(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+32|0;g=i+12|0;h=i;TX(g);Ce(b,g);if(((qO(b)|0?(a[b+768>>0]|0)==2:0)?a[b+784>>0]|0:0)?(f=a[g+8+3>>0]|0,(f<<24>>24<0?c[g+4>>2]|0:f&255)|0):0){d=c[(c[(c[b+760>>2]|0)+80>>2]|0)+(e[b+772>>1]<<2)>>2]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;f=j9(384507)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[h+11>>0]=f;b=h}else{j=f+16&-16;b=ZW(j)|0;c[h>>2]=b;c[h+8>>2]=j|-2147483648;c[h+4>>2]=f}i1(b,384507,f)|0;J7(b+f|0,0);k1(VC(d+28|0,h)|0,g)|0;a1(h)}z5(g);l=i;return}function bq(a,b){a=a|0;b=b|0;do switch(a<<24>>24){case 0:{a=385650;break}case 1:{a=JE(b)|0;break}case 2:{a=dP(b)|0;break}case 3:{a=RR(b)|0;break}case 4:{a=zA(b)|0;break}case 5:{a=iN(b)|0;break}case 6:{a=eL(b)|0;break}case 7:{a=yA(b)|0;break}case 8:{a=QR(b)|0;break}case 9:{a=vJ(b)|0;break}case 10:{a=uJ(b)|0;break}case 11:{a=PR(b)|0;break}case 15:{a=385637;break}default:a=391133}while(0);return a|0}function cq(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+16|0;k=m;i=m+5|0;j=m+4|0;bB(b,m+6|0);jB(b,k);pY(c[k>>2]|0,0,0,j);k=b+528|0;g=k;g=z0(c[g>>2]|0,c[g+4>>2]|0,4,0)|0;h=z;f=k;c[f>>2]=g;c[f+4>>2]=h;f=b+536|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(f>>>0>0|(f|0)==0&e>>>0>24){n=z0(d[(c[b+544>>2]|0)+((c[b+612>>2]|0)+24)>>0]|0|0,0,25,0)|0;f=(n|0)==(e|0)&(z|0)==(f|0);e=f?16:14;f=f?0:0}else{e=14;f=0}h=z0(e|0,f|0,g|0,h|0)|0;n=k;c[n>>2]=h;c[n+4>>2]=z;bB(b,i);iF(b,d[i>>0]|0,0);if(qO(b)|0){n=a[j>>0]|0;a[(bF(b+916|0,b+788|0)|0)+268>>0]=n}l=m;return}function dq(a){a=a|0;var b=0;a:do if((a|0)<1146377011){if((a|0)>=1146377009)switch(a|0){case 1146377010:case 1146377009:{a=2;break a}default:{b=4;break a}}if((a|0)<1112757060)switch(a|0){case 1094921523:{a=2;break a}default:{b=4;break a}}else switch(a|0){case 1112757060:{a=2;break a}default:{b=4;break a}}}else if((a|0)<1332770163){if((a|0)<1212503619)switch(a|0){case 1146377011:{a=2;break a}default:{b=4;break a}}switch(a|0){case 1212503619:break;default:{b=4;break a}}a=1;break}else{if((a|0)<1447243057)switch(a|0){case 1332770163:{a=2;break a}default:{b=4;break a}}switch(a|0){case 1447243057:break;default:{b=4;break a}}a=1;break}while(0);if((b|0)==4)a=7;return a|0}function eq(a){a=a|0;var b=0,d=0;b=jF(a+760|0,a+772|0)|0;d=c[b+12>>2]|0;a:do if((d|0)<1835623539)if((d|0)<1767994995){switch(d|0){case 1635083379:break;default:break a}Nc(a);break}else{switch(d|0){case 1767994995:break;default:break a}Jh(a);break}else{if((d|0)<1954051187){switch(d|0){case 1835623539:break;default:break a}$O(a);break}if((d|0)<1986618483){switch(d|0){case 1954051187:break;default:break a}ds(a);break}else{switch(d|0){case 1986618483:break;default:break a}Bc(a);break}}while(0);c[b+40>>2]=c[a+16>>2];c[b+44>>2]=c[a+20>>2];return}function fq(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;g=j;a:do if(!e)b=0;else{do if(f|0){i=(b|0)==0?g:b;b=a[e>>0]|0;if(b<<24>>24>-1){c[i>>2]=b&255;b=b<<24>>24!=0&1;break a}if(!(c[c[12815]>>2]|0)){c[i>>2]=b<<24>>24&57343;b=1;break a}b=(b&255)+-194|0;if(b>>>0<=50){g=e+1|0;h=c[50744+(b<<2)>>2]|0;if(f>>>0<4?h&-2147483648>>>((f*6|0)+-6|0)|0:0)break;b=d[g>>0]|0;f=b>>>3;if((f+-16|f+(h>>26))>>>0<=7){b=b+-128|h<<6;if((b|0)>=0){c[i>>2]=b;b=2;break a}g=(d[e+2>>0]|0)+-128|0;if(g>>>0<=63){g=g|b<<6;if((g|0)>=0){c[i>>2]=g;b=3;break a}b=(d[e+3>>0]|0)+-128|0;if(b>>>0<=63){c[i>>2]=b|g<<6;b=4;break a}}}}}while(0);c[12784]=84;b=-1}while(0);l=j;return b|0}function gq(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;k=l;l=l+32|0;j=k+12|0;h=k;if(((e|0)<=6?(i=d+4|0,m=c[c[i>>2]>>2]|0,!((g|0)==0?1:(((c[m+(e*12|0)+4>>2]|0)-(c[m+(e*12|0)>>2]|0)|0)/40|0)>>>0<=f>>>0)):0)?(a[g>>0]|0)!=0:0){TX(h);p2(j,cC(h,g)|0);z5(h);g=Sx(vn(e)|0,j,0)|0;do if((g|0)==-1){g=(c[(c[c[d+8>>2]>>2]|0)+(e*12|0)>>2]|0)+(f*56|0)|0;h=Sx(g,j,0)|0;if((h|0)==-1){p2(b,408444);break}else{p2(b,wF(g,h,1)|0);break}}else p2(b,DN((c[(c[c[i>>2]>>2]|0)+(e*12|0)>>2]|0)+(f*40|0)|0,g)|0);while(0);z5(j)}else p2(b,408444);l=k;return}function hq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;n=l;l=l+48|0;j=n+24|0;k=n+12|0;m=n;e=d+4|0;if((c[e>>2]|0)==(c[d>>2]|0))TX(b);else{TX(j);f=(((c[e>>2]|0)-(c[d>>2]|0)|0)/40|0)+-1|0;g=d+12|0;h=k+8+3|0;i=k+4|0;e=0;while(1){if(e>>>0>=f>>>0)break;ZU(m,d,e);Mq(k,m,g);o=a[h>>0]|0;p=o<<24>>24<0;Ex(j,p?c[k>>2]|0:k,p?c[i>>2]|0:o&255)|0;O0(k);z5(m);e=e+1|0}ZU(k,d,f);p=a[k+8+3>>0]|0;o=p<<24>>24<0;Ex(j,o?c[k>>2]|0:k,o?c[k+4>>2]|0:p&255)|0;z5(k);p2(b,j);z5(j)}l=n;return}function iq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+96|0;f=i+72|0;g=i+16|0;b=i;h=a+984|0;d=a+536|0;if((c[h>>2]|0)==(c[a+988>>2]|0)){TX(f);e=d;jZ(a,c[e>>2]|0,c[e+4>>2]|0,f);xA(g);Xy(b,42452);gI(g,0,b);z5(b);Xy(b,35620);gI(g,1,b);z5(b);bf(g,f);b=g+4|0;a=0;while(1){e=c[g>>2]|0;d=e;if(a>>>0>=(((c[b>>2]|0)-e|0)/40|0)>>>0)break;j=c[d+(a*40|0)>>2]|0;e=j;if(((c[d+(a*40|0)+4>>2]|0)-j|0)==24)k1(_0(h,e,1)|0,e+12|0)|0;a=a+1|0}LT(g);z5(f)}else{j=d;e1(a,c[j>>2]|0,c[j+4>>2]|0)}l=i;return}function jq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;g=l;l=l+16|0;d=g;f=b+536|0;do if((c[b+880>>2]|0)>>>0>1)e1(b,c[f>>2]|0,c[f+4>>2]|0);else{e=b+840|0;h=e;if((!((c[h>>2]|0)==-1?(c[h+4>>2]|0)==-1:0)?(h=b+800|0,!((c[h>>2]|0)==-1?(c[h+4>>2]|0)==-1:0)):0)?(h=b+760|0,i=c[(kE(h,e)|0)+36>>2]|0,gq(d,b,i,c[(kE(h,e)|0)+40>>2]|0,390999),h=a[d+8+3>>0]|0,h=((h<<24>>24<0?c[d+4>>2]|0:h&255)|0)==0,z5(d),!h):0){dm(b);break}e=b+776|0;jaa(c[e>>2]|0);i=c[f>>2]|0;c[b+780>>2]=i;h=iaa(i)|0;c[e>>2]=h;no(h|0,(c[b+544>>2]|0)+(c[b+612>>2]|0)|0,i|0)|0}while(0);l=g;return}function kq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;g=l;l=l+32|0;h=g+16|0;f=g;bB(b,h);jB(b,g+12|0);if(!(a[h>>0]|0)){if((((c[b+784>>2]|0)>>>0<=1?qO(b)|0:0)?(nh(b),d=b+916|0,e=b+788|0,h=bF(d,e)|0,((c[h+16>>2]|0)-(c[h+12>>2]|0)|0)==4):0)?(gq(f,b,c[b+16>>2]|0,c[b+20>>2]|0,380114),h=a[f+8+3>>0]|0,h=((h<<24>>24<0?c[f+4>>2]|0:h&255)|0)==0,z5(f),!h):0)G2(b,c[c[(bF(d,e)|0)+12>>2]>>2]|0)}else{f=b+536|0;h=b+528|0;h=D_(c[f>>2]|0,c[f+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0)|0;e1(b,h,z)}l=g;return}function lq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;f=b+32|0;rQ(f,d)|0;h=b+44|0;c[h>>2]=0;l=b+48|0;g=c[l>>2]|0;i=b+40|0;k=b+36|0;j=i+3|0;if(g&8|0){d=a[j>>0]|0;if(d<<24>>24<0){d=c[f>>2]|0;e=d;d=d+(c[k>>2]<<2)|0}else{e=f;d=f+((d&255)<<2)|0}c[h>>2]=d;c[b+8>>2]=e;c[b+12>>2]=e;c[b+16>>2]=d}if(g&16|0){d=a[j>>0]|0;if(d<<24>>24<0){g=c[k>>2]|0;c[h>>2]=(c[f>>2]|0)+(g<<2);d=(c[i>>2]&2147483647)+-1|0}else{g=d&255;c[h>>2]=f+(g<<2);d=1}FB(f,d,0);d=a[j>>0]|0;if(d<<24>>24<0){f=c[f>>2]|0;d=c[k>>2]|0}else d=d&255;e=b+24|0;c[e>>2]=f;c[b+20>>2]=f;c[b+28>>2]=f+(d<<2);if(c[l>>2]&3|0)c[e>>2]=f+(g<<2)}return}function mq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;nb[c[(c[b>>2]|0)+24>>2]&255](b)|0;d=u$(c[d>>2]|0,410908)|0;c[b+68>>2]=d;j=b+98|0;k=a[j>>0]|0;d=nb[c[(c[d>>2]|0)+28>>2]&255](d)|0;a[j>>0]=d&1;do if((k&255|0)!=(d&1|0)){g=b+8|0;f=b+96|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[g+20>>2]=0;g=(a[f>>0]|0)!=0;e=b+52|0;h=b+56|0;i=b+32|0;j=b+97|0;k=b+60|0;if(d){if(g)jaa(c[i>>2]|0);a[f>>0]=a[j>>0]|0;c[e>>2]=c[k>>2];c[i>>2]=c[h>>2];c[k>>2]=0;c[h>>2]=0;a[j>>0]=0;break}d=c[e>>2]|0;c[k>>2]=d;if(!g?(l=c[i>>2]|0,(l|0)!=(b+44|0)):0){c[h>>2]=l;a[j>>0]=0;c[i>>2]=iaa(d)|0;a[f>>0]=1;break}c[h>>2]=iaa(d)|0;a[j>>0]=1}while(0);return}function nq(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;h=l;l=l+16|0;m=h;n=(c[d+544>>2]|0)+(c[d+612>>2]|0)|0;k=n+24|0;f=d+796|0;b[f>>1]=A5(a[k>>0]|0,a[k+1>>0]|0)|0;k=n+26|0;j=d+798|0;b[j>>1]=A5(a[k>>0]|0,a[k+1>>0]|0)|0;k=n+34|0;i=d+811|0;a[i>>0]=((A5(a[k>>0]|0,a[k+1>>0]|0)|0)&65535)>>>2&1;k=d+792|0;c[k>>2]=W8(n+40|0)|0;VU(m,384015);BZ(c[d+508>>2]|0,c[d+668>>2]|0,0,0);z5(m);f=dy(c[k>>2]|0,b[j>>1]|0,(O(a[i>>0]|0?2:1,e[f>>1]|0)|0)&65535)|0;do if(!f)if(!(a[d+492>>0]|0)){z$(d);break}else{f=c[d+548>>2]|0;g=5;break}else g=5;while(0);if((g|0)==5)Op(d,f,0);l=h;return}function oq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+32|0;h=j;e=a+4|0;g=c[e>>2]|0;f=c[a+8>>2]|0;i=f;do if(g>>>0<f>>>0)if((g|0)==(b|0)){Iw(b,d);c[e>>2]=(c[e>>2]|0)+56;break}else{pD(a,b,g,b+56|0);it(b,d)|0;break}else{f=c[a>>2]|0;e=((g-f|0)/56|0)+1|0;if(e>>>0>76695844)uaa();else{g=(i-f|0)/56|0;i=g<<1;fE(h,g>>>0<38347922?(i>>>0<e>>>0?e:i):76695844,(b-f|0)/56|0,a+8|0);Qm(h,d);Lu(a,h,b)|0;CP(h);break}}while(0);l=j;return}function pq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;g=d;a:do if(!((g^b)&3)){f=(e|0)!=0;if(f&(g&3|0)!=0)do{g=a[d>>0]|0;a[b>>0]=g;if(!(g<<24>>24))break a;e=e+-1|0;d=d+1|0;b=b+1|0;f=(e|0)!=0}while(f&(d&3|0)!=0);if(f){if(a[d>>0]|0){b:do if(e>>>0>3){f=d;while(1){d=c[f>>2]|0;if((d&-2139062144^-2139062144)&d+-16843009|0){d=f;break b}c[b>>2]=d;e=e+-4|0;d=f+4|0;b=b+4|0;if(e>>>0>3)f=d;else break}}while(0);h=11}}else e=0}else h=11;while(0);c:do if((h|0)==11)if(!e)e=0;else while(1){h=a[d>>0]|0;a[b>>0]=h;if(!(h<<24>>24))break c;e=e+-1|0;b=b+1|0;if(!e){e=0;break}else d=d+1|0}while(0);Ow(b|0,0,e|0)|0;return}function qq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;j=k+1|0;g=k;Bx(b);f=b+648|0;d4(c[f>>2]|0,13);xR(b,3,j);h=b+1180|0;i=b+1183|0;j=a[j>>0]|0;e=0;while(1){d=e&255;if((e&255)>(j&255))break;GC(b);xR(b,2,h);xR(b,5,i);xR(b,3,b+1185+(d*9|0)|0);xR(b,3,b+1257+(d*9|0)|0);AT(b,b+1411+(d*9|0)|0);d4(c[f>>2]|0,3);xR(b,4,g);d=c[f>>2]|0;if(!(a[g>>0]|0))A6(d);else d4(d,9);J3(b);e=e+1<<24>>24}wK(b);a[b+769>>0]=0;a[b+1483>>0]=1;l=k;return}function rq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+16|0;f=k;g=a+528|0;h=a+536|0;i=a+916|0;j=a+788|0;while(1){d=g;m=c[d+4>>2]|0;e=h;b=c[e+4>>2]|0;if(!(m>>>0<b>>>0|((m|0)==(b|0)?(c[d>>2]|0)>>>0<(c[e>>2]|0)>>>0:0)))break;ID(a,f);if(!(qO(a)|0))continue;b=bF(i,j)|0;d=b+356|0;e=c[d>>2]|0;if((e|0)==(c[b+360>>2]|0))Yy(b+352|0,f);else{c[e>>2]=c[f>>2];c[d>>2]=e+4}b=bF(i,f)|0;d=b+368|0;e=c[d>>2]|0;if((e|0)==(c[b+372>>2]|0)){Yy(b+364|0,j);continue}else{c[e>>2]=c[j>>2];c[d>>2]=e+4;continue}}l=k;return}function sq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+16|0;f=k;g=a+528|0;h=a+536|0;i=a+916|0;j=a+788|0;while(1){d=g;m=c[d+4>>2]|0;e=h;b=c[e+4>>2]|0;if(!(m>>>0<b>>>0|((m|0)==(b|0)?(c[d>>2]|0)>>>0<(c[e>>2]|0)>>>0:0)))break;ID(a,f);if(!(qO(a)|0))continue;b=bF(i,j)|0;d=b+332|0;e=c[d>>2]|0;if((e|0)==(c[b+336>>2]|0))Yy(b+328|0,f);else{c[e>>2]=c[f>>2];c[d>>2]=e+4}b=bF(i,f)|0;d=b+344|0;e=c[d>>2]|0;if((e|0)==(c[b+348>>2]|0)){Yy(b+340|0,j);continue}else{c[e>>2]=c[j>>2];c[d>>2]=e+4;continue}}l=k;return}function tq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+16|0;f=k;g=a+528|0;h=a+536|0;i=a+916|0;j=a+788|0;while(1){d=g;m=c[d+4>>2]|0;e=h;b=c[e+4>>2]|0;if(!(m>>>0<b>>>0|((m|0)==(b|0)?(c[d>>2]|0)>>>0<(c[e>>2]|0)>>>0:0)))break;ID(a,f);if(!(qO(a)|0))continue;b=bF(i,j)|0;d=b+308|0;e=c[d>>2]|0;if((e|0)==(c[b+312>>2]|0))Yy(b+304|0,f);else{c[e>>2]=c[f>>2];c[d>>2]=e+4}b=bF(i,f)|0;d=b+320|0;e=c[d>>2]|0;if((e|0)==(c[b+324>>2]|0)){Yy(b+316|0,j);continue}else{c[e>>2]=c[j>>2];c[d>>2]=e+4;continue}}l=k;return}function uq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+16|0;f=k;g=a+528|0;h=a+536|0;i=a+916|0;j=a+788|0;while(1){d=g;m=c[d+4>>2]|0;e=h;b=c[e+4>>2]|0;if(!(m>>>0<b>>>0|((m|0)==(b|0)?(c[d>>2]|0)>>>0<(c[e>>2]|0)>>>0:0)))break;ID(a,f);if(!(qO(a)|0))continue;b=bF(i,j)|0;d=b+284|0;e=c[d>>2]|0;if((e|0)==(c[b+288>>2]|0))Yy(b+280|0,f);else{c[e>>2]=c[f>>2];c[d>>2]=e+4}b=bF(i,f)|0;d=b+296|0;e=c[d>>2]|0;if((e|0)==(c[b+300>>2]|0)){Yy(b+292|0,j);continue}else{c[e>>2]=c[j>>2];c[d>>2]=e+4;continue}}l=k;return}function vq(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+16|0;m=v+3|0;q=v+2|0;s=v+1|0;t=v;j=(a[b+2506>>0]|0)==2;e=j?3:5;i=j?4:6;j=j?1:2;u=b+2509|0;k=b+648|0;h=0;while(1){if((h&255)>=(d[u>>0]|0))break;xR(b,j,m);n=a[m>>0]|0;if(n<<24>>24){AT(b,q);o=a[q>>0]|0?4:3;g=0;while(1){if((g&255)>=(n&255))break;d4(c[k>>2]|0,i);xR(b,e,s);p=a[s>>0]|0;if(p<<24>>24){A6(c[k>>2]|0);AT(b,t);r=o-(d[t>>0]|0)&255;f=0;while(1){if((f&255)>=(p&255))break;d4(c[k>>2]|0,r);f=f+1<<24>>24}}g=g+1<<24>>24}}h=h+1<<24>>24}l=v;return}function wq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0.0,j=0;j=l;l=l+16|0;d=j;i=+MB(b);do if(qO(b)|0?(c[b+880>>2]|0)>>>0<=1:0){e=b+20|0;KW(b,2,c[e>>2]|0,135,i,0,1);$x(d,b,2,c[e>>2]|0,46,1);e=a[d+8+3>>0]|0;f=e<<24>>24<0;g=f?c[d>>2]|0:d;h=i9(20596)|0;if(h){f=g+((f?c[d+4>>2]|0:e&255)<<2)|0;h=HA(g,f,20596,20596+(h<<2)|0)|0;z5(d);if(!((h|0)==(g|0)&(h|0)!=(f|0)))break}else z5(d);g=c[(kE(b+760|0,b+840|0)|0)+32>>2]|0;h=cT(i)|0;Jb(g,h,z,-1,0,0,0,0)}while(0);l=j;return}function xq(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=b+612|0;h=b+548|0;i=b+544|0;j=b+780|0;k=b+376|0;f=c[g>>2]|0;e=c[h>>2]|0;while(1){l=f+4|0;if(l>>>0>e>>>0){m=13;break}e=c[i>>2]|0;if(a[e+f>>0]|0){m=13;break}if(a[e+(f+1)>>0]|0){m=13;break}if((a[e+(f+2)>>0]|0)!=1){m=13;break}e=d[e+(f+3)>>0]|0;f=c[j>>2]|0;if(a[f+(e*3|0)>>0]|0){e=1;break}if(a[f+(e*3|0)+1>>0]|0){e=1;break}if(a[f+(e*3|0)+2>>0]|0){e=1;break}c[g>>2]=l;a[k>>0]=0;if(!(nb[c[(c[b>>2]|0)+64>>2]&255](b)|0)){m=10;break}f=c[g>>2]|0;e=c[h>>2]|0;if((f+4|0)>>>0>e>>>0){m=12;break}}if((m|0)==10){a[b+377>>0]=1;e=0}else if((m|0)==12){a[b+377>>0]=1;e=0}else if((m|0)==13){t4(b);e=nb[c[(c[b>>2]|0)+64>>2]&255](b)|0}return e|0}function yq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=bo(d,h,e)|0;e=c[g>>2]|0;if(!e){PE(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function zq(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=bo(d,h,e)|0;e=c[g>>2]|0;if(!e){fz(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function Aq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=b+612|0;k=b+544|0;i=c[b+548>>2]|0;d=c[j>>2]|0;a:while(1){e=d+3|0;if((d+4|0)>>>0>i>>>0){f=9;break}f=c[k>>2]|0;if((((a[f+d>>0]|0)==26?(a[f+(d+1)>>0]|0)==69:0)?(a[f+(d+2)>>0]|0)==-33:0)?(a[f+e>>0]|0)==-93:0){f=18;break}while(1){d=d+1|0;c[j>>2]=d;if(d>>>0>=i>>>0)continue a;if((a[f+d>>0]|0)==26)continue a}}if((f|0)==9){if((e|0)==(i|0)?(b=(c[k>>2]|0)+d|0,g=d+1|0,(R4(a[b>>0]|0,a[b+1>>0]|0,a[b+2>>0]|0)|0)!=1721823):0){c[j>>2]=g;d=g}if((d+2|0)==(i|0)?(g=(c[k>>2]|0)+d|0,h=d+1|0,(d7(a[g>>0]|0,a[g+1>>0]|0)|0)<<16>>16!=6725):0){c[j>>2]=h;d=h}if((d+1|0)==(i|0)?(D9(a[(c[k>>2]|0)+d>>0]|0)|0)<<24>>24!=26:0){c[j>>2]=i;d=0}else d=0}else if((f|0)==18){a[b+733>>0]=0;d=1}return d|0}function Bq(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+64|0;k=m;j=m+56|0;g=c[e>>2]|0;f=c[b>>2]|0;if(!f){f=1;i=j}else{c[b>>2]=0;i=a}c[k>>2]=d;d=k+4|0;c[d>>2]=0;c[k+32>>2]=0;c[k+36>>2]=0;c[k+40>>2]=0;a=W9(k)|0;a:do if(!a){c[k+12>>2]=i;h=k+16|0;c[h>>2]=0;a=0;while(1){if(!a){c[h>>2]=f;f=0}if(!(c[d>>2]|0)){c[d>>2]=g;g=0}a=Lb(k)|0;if(a|0)break;a=c[h>>2]|0}c[e>>2]=(c[e>>2]|0)-((c[d>>2]|0)+g);g=c[k+20>>2]|0;d=(a|0)==-5;if((i|0)==(j|0))f=d&(g|0)!=0?1:f;else c[b>>2]=g;oN(k);switch(a|0){case 1:{a=0;break a}case 2:{a=-3;break a}default:{}}if(d?(f|0)!=(0-(c[h>>2]|0)|0):0){a=-3;break}}while(0);l=m;return a|0}function Cq(b){b=b|0;var d=0.0,e=0,f=0,h=0,i=0,j=0,k=0;k=l;l=l+160|0;i=k+144|0;j=k;e=a[b+8+3>>0]|0;if(e<<24>>24<0)e=c[b+4>>2]|0;else e=e&255;if(!e)d=0.0;else{e=j+64|0;h=j+8|0;c[h>>2]=42320;f=j+12|0;c[j>>2]=1204;c[e>>2]=1224;c[j+4>>2]=0;DO(j+64|0,f);c[j+136>>2]=0;c[j+140>>2]=-1;c[j>>2]=42300;c[e>>2]=42340;c[h>>2]=42320;aV(f);c[f>>2]=42096;h=j+44|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[h+(e<<2)>>2]=0;e=e+1|0}c[j+56>>2]=0;c[j+60>>2]=24;lq(f,b);Cu(j,i)|0;d=c[j+(c[(c[j>>2]|0)+-12>>2]|0)+16>>2]&5|0?0.0:+g[i>>2];hY(j)}l=k;return +d}function Dq(b){b=b|0;var d=0.0,e=0,f=0,g=0,i=0,j=0,k=0;k=l;l=l+160|0;i=k;j=k+8|0;e=a[b+8+3>>0]|0;if(e<<24>>24<0)e=c[b+4>>2]|0;else e=e&255;if(!e)d=0.0;else{e=j+64|0;g=j+8|0;c[g>>2]=42320;f=j+12|0;c[j>>2]=1204;c[e>>2]=1224;c[j+4>>2]=0;DO(j+64|0,f);c[j+136>>2]=0;c[j+140>>2]=-1;c[j>>2]=42300;c[e>>2]=42340;c[g>>2]=42320;aV(f);c[f>>2]=42096;g=j+44|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[g+(e<<2)>>2]=0;e=e+1|0}c[j+56>>2]=0;c[j+60>>2]=24;lq(f,b);Du(j,i)|0;d=c[j+(c[(c[j>>2]|0)+-12>>2]|0)+16>>2]&5|0?0.0:+h[i>>3];hY(j)}l=k;return +d}function Eq(b){b=b|0;var d=0.0,e=0,f=0,g=0,i=0,j=0,k=0;k=l;l=l+160|0;i=k;j=k+8|0;e=a[b+8+3>>0]|0;if(e<<24>>24<0)e=c[b+4>>2]|0;else e=e&255;if(!e)d=0.0;else{e=j+64|0;g=j+8|0;c[g>>2]=42320;f=j+12|0;c[j>>2]=1204;c[e>>2]=1224;c[j+4>>2]=0;DO(j+64|0,f);c[j+136>>2]=0;c[j+140>>2]=-1;c[j>>2]=42300;c[e>>2]=42340;c[g>>2]=42320;aV(f);c[f>>2]=42096;g=j+44|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[g+(e<<2)>>2]=0;e=e+1|0}c[j+56>>2]=0;c[j+60>>2]=24;lq(f,b);Eu(j,i)|0;d=c[j+(c[(c[j>>2]|0)+-12>>2]|0)+16>>2]&5|0?0.0:+h[i>>3];hY(j)}l=k;return +d}function Fq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+32|0;h=j;e=a+4|0;g=c[e>>2]|0;f=c[a+8>>2]|0;i=f;do if(g>>>0<f>>>0)if((g|0)==(b|0)){yw(b,d);c[e>>2]=(c[e>>2]|0)+40;break}else{PD(a,b,g,b+40|0);Kq(b,d)|0;break}else{f=c[a>>2]|0;e=((g-f|0)/40|0)+1|0;if(e>>>0>107374182)uaa();else{g=(i-f|0)/40|0;i=g<<1;lE(h,g>>>0<53687091?(i>>>0<e>>>0?e:i):107374182,(b-f|0)/40|0,a+8|0);Wm(h,d);Zu(a,h,b)|0;VP(h);break}}while(0);l=j;return}function Gq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=l;l=l+32|0;h=f+12|0;e=f;mT(b);p2(h,d);k1(b,h)|0;z5(h);d=ZW(192)|0;pk(e,b);h=a[e+11>>0]|0;g=c[e>>2]|0;k=d+112|0;j=d+8|0;c[j>>2]=41920;i=d+12|0;c[d>>2]=1092;c[k>>2]=1112;c[d+4>>2]=0;DO(k,i);c[d+184>>2]=0;c[d+188>>2]=-1;c[d>>2]=41900;c[k>>2]=41940;c[j>>2]=41920;gv(i);if(!(gW(i,h<<24>>24<0?g:e)|0)){k=d+(c[(c[d>>2]|0)+-12>>2]|0)|0;C4(k,c[k+16>>2]|4)}b=b+32|0;c[b>>2]=d;a1(e);d=c[b>>2]|0;if(!(c[d+76>>2]|0)){if(d|0)jb[c[(c[d>>2]|0)+4>>2]&511](d);c[b>>2]=0}l=f;return}function Hq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+16|0;h=o+12|0;m=o+8|0;n=o;XP(n,b);if(a[n>>0]|0){O4(h,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);i=u$(c[h>>2]|0,409180)|0;c6(h);j=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;k=c[j+24>>2]|0;g=j+76|0;f=c[g>>2]|0;if(d8(-1,f)|0){O4(h,j);f=u$(c[h>>2]|0,409148)|0;f=tb[c[(c[f>>2]|0)+44>>2]&31](f,32)|0;c6(h);c[g>>2]=f}g=c[(c[i>>2]|0)+28>>2]|0;c[m>>2]=k;c[h>>2]=c[m>>2];if(!(lb[g&63](i,h,j,f,d,e)|0)){m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(m,c[m+16>>2]|5)}}TC(n);l=o;return b|0}function Iq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+16|0;h=o+12|0;m=o+8|0;n=o;XP(n,b);if(a[n>>0]|0){O4(h,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);i=u$(c[h>>2]|0,409180)|0;c6(h);j=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;k=c[j+24>>2]|0;g=j+76|0;f=c[g>>2]|0;if(d8(-1,f)|0){O4(h,j);f=u$(c[h>>2]|0,409148)|0;f=tb[c[(c[f>>2]|0)+44>>2]&31](f,32)|0;c6(h);c[g>>2]=f}g=c[(c[i>>2]|0)+20>>2]|0;c[m>>2]=k;c[h>>2]=c[m>>2];if(!(lb[g&63](i,h,j,f,d,e)|0)){m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(m,c[m+16>>2]|5)}}TC(n);l=o;return b|0}function Jq(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;g=n+12|0;k=n+8|0;m=n;YP(m,b);if(a[m>>0]|0){O4(g,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);h=u$(c[g>>2]|0,409172)|0;c6(g);i=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;j=c[i+24>>2]|0;f=i+76|0;e=c[f>>2]|0;if(d8(-1,e)|0){O4(g,i);e=u$(c[g>>2]|0,409116)|0;e=tb[c[(c[e>>2]|0)+28>>2]&31](e,32)|0;c6(g);e=e<<24>>24;c[f>>2]=e}f=c[(c[h>>2]|0)+24>>2]|0;c[k>>2]=j;c[g>>2]=c[k>>2];if(!(ub[f&31](h,g,i,e&255,d)|0)){k=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(k,c[k+16>>2]|5)}}TC(m);l=n;return b|0}function Kq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+32|0;k=o+12|0;m=o;d=c[a>>2]|0;n=a+4|0;while(1){e=c[n>>2]|0;if((e|0)==(d|0))break;j=e+-12|0;c[n>>2]=j;z5(j)}j=a+12|0;p2(k,j);g=a+24|0;p2(m,g);k1(j,b+12|0)|0;k1(g,b+24|0)|0;h=b+4|0;ZE(a,((c[h>>2]|0)-(c[b>>2]|0)|0)/12|0);i=a+8|0;f=0;while(1){d=c[b>>2]|0;if(f>>>0>=(((c[h>>2]|0)-d|0)/12|0)>>>0)break;d=d+(f*12|0)|0;e=c[n>>2]|0;if((e|0)==(c[i>>2]|0))Ax(a,d);else{p2(e,d);c[n>>2]=(c[n>>2]|0)+12}f=f+1|0}k1(j,k)|0;k1(g,m)|0;z5(m);z5(k);l=o;return a|0}function Lq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;f=a+840|0;g=a+844|0;d=0;while(1){b=c[g>>2]|0;h=c[f>>2]|0;e=h;if(d>>>0>=b-h>>2>>>0)break;b=c[e+(d<<2)>>2]|0;if(b|0){W_(c[b>>2]|0);laa(b)}d=d+1|0}while(1){if((b|0)==(e|0))break;h=b+-4|0;c[g>>2]=h;b=h}f=a+852|0;g=a+856|0;d=0;while(1){b=c[g>>2]|0;h=c[f>>2]|0;e=h;if(d>>>0>=b-h>>2>>>0)break;b=c[e+(d<<2)>>2]|0;if(b|0){W_(c[b>>2]|0);laa(b)}d=d+1|0}while(1){if((b|0)==(e|0))break;h=b+-4|0;c[g>>2]=h;b=h}f=a+864|0;g=a+868|0;d=0;while(1){b=c[g>>2]|0;h=c[f>>2]|0;e=h;if(d>>>0>=b-h>>2>>>0)break;b=c[e+(d<<2)>>2]|0;if(b|0)laa(b);d=d+1|0}while(1){if((b|0)==(e|0))break;h=b+-4|0;c[g>>2]=h;b=h}return}function Mq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[b+(f<<2)>>2]=0;f=f+1|0}h=a[d+8+3>>0]|0;g=h<<24>>24<0;h=g?c[d+4>>2]|0:h&255;i=e+8+3|0;j=a[i>>0]|0;j=j<<24>>24<0?c[e+4>>2]|0:j&255;g=g?c[d>>2]|0:d;f=j+h|0;if(f>>>0>1073741807)uaa();d=b+8|0;do if(f>>>0>=2){f=f+4&-4;if(f>>>0>1073741823){e=ua(8)|0;K2(e,391652);c[e>>2]=57868;Ya(e|0,2712,367)}else{k=ZW(f<<2)|0;c[b>>2]=k;c[d>>2]=f|-2147483648;c[b+4>>2]=h;f=k;break}}else{a[d+3>>0]=h;f=b}while(0);a3(f,g,h);y7(f+(h<<2)|0,0);Ex(b,(a[i>>0]|0)<0?c[e>>2]|0:e,j)|0;return}function Nq(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;e=l;l=l+16|0;c=e;a:do if((b|0)<1852402543)if((b|0)<1634758764){switch(b|0){case 860444248:break;default:{d=7;break a}}Xy(a,23392);break}else{switch(b|0){case 1634758764:break;default:{d=7;break a}}Xy(a,23412);break}else{if((b|0)<1869379949){switch(b|0){case 1852402543:break;default:{d=7;break a}}Xy(a,23476);break}if((b|0)<1869442661){switch(b|0){case 1869379949:break;default:{d=7;break a}}Xy(a,23500);break}else{switch(b|0){case 1869442661:break;default:{d=7;break a}}Xy(a,23532);break}}while(0);if((d|0)==7){TX(c);p2(a,lh(c,b)|0);z5(c)}l=e;return}function Oq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=l;l=l+16|0;e=g;L2(e);j0(a,e);e=e+8|0;d=c[e>>2]|0;e=c[e+4>>2]|0;b=b+-16|0;a:do if((d|0)<-421967689){switch(d|0){case -1399697816:break;default:{f=8;break a}}if((e|0)==-78165408)qc(a,b);else f=8}else if((d|0)<-129166887){switch(d|0){case -421967689:break;default:{f=8;break a}}if((e|0)!=-599397955){f=8;break}qc(a,b);break}else{switch(d|0){case -129166887:break;default:{f=8;break a}}if((e|0)!=401509472){f=8;break}gD(a,b);break}while(0);if((f|0)==8)e1(a,b,0);l=g;return}function Pq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;q=l;l=l+64|0;i=q+48|0;j=q+40|0;k=q+32|0;m=q+24|0;n=q+16|0;o=q+8|0;p=q;e=a+4|0;r=c[e>>2]|0;h=c[b>>2]|0;f=c[b+4>>2]|0;g=c[d>>2]|0;d=c[d+4>>2]|0;c[e>>2]=r-f+d+(g-h<<3);e=r&31;b=(c[a>>2]|0)+(r>>>5<<2)|0;if((f|0)==(e|0)){c[i>>2]=h;c[i+4>>2]=f;c[j>>2]=g;c[j+4>>2]=d;c[k>>2]=b;c[k+4>>2]=f;Ur(p,i,j,k)}else{c[m>>2]=h;c[m+4>>2]=f;c[n>>2]=g;c[n+4>>2]=d;c[o>>2]=b;c[o+4>>2]=e;uk(p,m,n,o)}l=q;return}function Qq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=l;l=l+16|0;bB(a,i+4|0);jB(a,i);KK(a);r3(a,a+768|0);h=a+528|0;b=h;f=c[b>>2]|0;b=c[b+4>>2]|0;j=z0(f|0,b|0,12,0)|0;k=z;g=a+536|0;e=g;d=c[e>>2]|0;e=c[e+4>>2]|0;if(k>>>0>e>>>0|(k|0)==(e|0)&j>>>0>d>>>0){if(e>>>0>b>>>0|(e|0)==(b|0)&d>>>0>f>>>0){k=D_(d|0,e|0,f|0,b|0)|0;e1(a,k,z)}}else{KK(a);e=h;e=z0(c[e>>2]|0,c[e+4>>2]|0,8,0)|0;f=z;d=h;c[d>>2]=e;c[d+4>>2]=f;d=g;b=c[d>>2]|0;d=c[d+4>>2]|0;if(d>>>0>f>>>0|(d|0)==(f|0)&b>>>0>e>>>0){k=D_(b|0,d|0,e|0,f|0)|0;iF(a,k,z)}}l=i;return}function Rq(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+528|0;d=a+536|0;do if(!((c[g>>2]|0)==(c[d>>2]|0)?(c[g+4>>2]|0)==(c[d+4>>2]|0):0)){Bx(a);n3(a,b);b=c[b>>2]|0;d=c[a+840>>2]|0;if(b>>>0<(c[a+844>>2]|0)-d>>2>>>0?(f=d+(b<<2)|0,e=c[f>>2]|0,e|0):0){b=c[e>>2]|0;if(N$(b)|0){rE(a,c[b>>2]|0);b=c[c[f>>2]>>2]|0}if(E$(b)|0)rE(a,c[b+4>>2]|0);wK(a);break}g=c[a+648>>2]|0;G4(g,Z9(c[g+4>>2]|0)|0);wK(a)}while(0);return}function Sq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+16|0;j=i;pO(b);lz(b);yP(b,j);f=b+652|0;E7(c[f>>2]|0);C7(c[f>>2]|0);D7(c[f>>2]|0);wK(b);j=(a[j>>0]|0)==0;f=b+528|0;d=f;g=c[d>>2]|0;d=c[d+4>>2]|0;e=z0(g|0,d|0,7,0)|0;h=z;if(j){d=f;c[d>>2]=e;c[d+4>>2]=h;d=h}else e=g;j=b+536|0;j=D_(c[j>>2]|0,c[j+4>>2]|0,e|0,d|0)|0;e1(b,j,z);j=b+312|0;h=j;h=z0(c[h>>2]|0,c[h+4>>2]|0,1,0)|0;f=z;c[j>>2]=h;c[j+4>>2]=f;j=b+760|0;g=c[j+4>>2]|0;if(!(f>>>0<g>>>0|((f|0)==(g|0)?h>>>0<(c[j>>2]|0)>>>0:0)))KM(b);l=i;return}function Tq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;i=b+612|0;j=b+548|0;k=b+544|0;l=b+832|0;m=b+376|0;d=c[i>>2]|0;e=c[j>>2]|0;while(1){h=d+4|0;if(h>>>0>e>>>0){n=11;break}f=c[k>>2]|0;g=f+d|0;if(a[g>>0]|0){n=11;break}if(a[f+(d+1)>>0]|0){n=11;break}if((a[f+(d+2)>>0]|0)!=1){n=11;break}g=(D9(a[g+3>>0]|0)|0)&255;if(a[(c[l>>2]|0)+(g*3|0)>>0]|0){d=1;break}c[i>>2]=h;a[m>>0]=0;if(!(nb[c[(c[b>>2]|0)+64>>2]&255](b)|0)){n=8;break}d=c[i>>2]|0;e=c[j>>2]|0;if((d+4|0)>>>0>e>>>0){n=10;break}}if((n|0)==8){a[b+377>>0]=1;d=0}else if((n|0)==10){a[b+377>>0]=1;d=0}else if((n|0)==11)if((d+3|0)==(e|0))d=0;else{t4(b);d=nb[c[(c[b>>2]|0)+64>>2]&255](b)|0}return d|0}function Uq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;j=l;l=l+16|0;d=j;c[d>>2]=0;e=b+528|0;f=b+536|0;h=b+768|0;i=b+762|0;while(1){k=e;n=c[k+4>>2]|0;g=f;m=c[g+4>>2]|0;if(!(n>>>0<m>>>0|((n|0)==(m|0)?(c[k>>2]|0)>>>0<(c[g>>2]|0)>>>0:0)))break;ID(b,d);n=h;if(!((c[n>>2]|0)==-1&(c[n+4>>2]|0)==0))continue;g=c[d>>2]|0;n=h;c[n>>2]=g;c[n+4>>2]=0;if(!(a[i>>0]|0))continue;n=h;c[n>>2]=g;c[n+4>>2]=((g|0)<0)<<31>>31}if(qO(b)|0?(m=f,m=XZ(c[m>>2]|0,c[m+4>>2]|0,2)|0,n=b+312|0,k=n,m=z0(c[k>>2]|0,c[k+4>>2]|0,m|0,z|0)|0,n,c[n>>2]=m,c[n+4>>2]=z,(c[b+728>>2]&1|0)==0):0){W5(b);t6(b)}l=j;return}function Vq(d){d=d|0;var e=0;TX(d+4|0);TX(d+16|0);TX(d+28|0);TX(d+40|0);x1(d+56|0);x1(d+68|0);c[d+80>>2]=0;c[d+84>>2]=0;c[d+88>>2]=0;x1(d+108|0);e=d+128|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;x1(d+152|0);e=d+164|0;c[e>>2]=0;c[d+168>>2]=0;c[d+172>>2]=0;x1(d+176|0);x1(d+188|0);c[d+200>>2]=0;c[d+204>>2]=0;c[d+208>>2]=0;b[d>>1]=-1;a[d+2>>0]=0;a[d+52>>0]=0;c[d+92>>2]=-1;c[d+96>>2]=0;c[d+100>>2]=0;a[d+104>>0]=0;a[d+120>>0]=0;a[d+121>>0]=0;vE(e);a[d+122>>0]=0;c[d+124>>2]=0;return}function Wq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;i=l;l=l+16|0;h=i;do if(!(e>>>0>2711|(e|0)==2711&d>>>0>817260543)){d=b+8+3|0;if((a[d>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0;break}else{y7(b,0);a[d>>0]=0;break}}else{g=z0(d|0,e|0,-817260544,-2712)|0;g=g5(g|0,z|0,1e3,0)|0;T2(b,g)|0;HX(b,42212)|0;TX(h);d=nW(d|0,e|0,1e3,0)|0;bk(h,d,z,10)|0;d=h+8+3|0;e=h+4|0;while(1){g=a[d>>0]|0;f=g<<24>>24<0;g=f?c[e>>2]|0:g&255;if(g>>>0>=3)break;Gx(h,48)}Ex(b,f?c[h>>2]|0:h,g)|0;z5(h)}while(0);l=i;return b|0}function Xq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+224|0;n=r+120|0;o=r+80|0;p=r;q=r+136|0;f=o;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));c[n>>2]=c[e>>2];if((ld(0,d,n,p,o)|0)<0)e=-1;else{e=c[b>>2]|0;m=e&32;if((a[b+74>>0]|0)<1)c[b>>2]=e&-33;f=b+48|0;if(!(c[f>>2]|0)){g=b+44|0;h=c[g>>2]|0;c[g>>2]=q;i=b+28|0;c[i>>2]=q;j=b+20|0;c[j>>2]=q;c[f>>2]=80;k=b+16|0;c[k>>2]=q+80;e=ld(b,d,n,p,o)|0;if(h){gb[c[b+36>>2]&31](b,0,0)|0;e=(c[j>>2]|0)==0?-1:e;c[g>>2]=h;c[f>>2]=0;c[k>>2]=0;c[i>>2]=0;c[j>>2]=0}}else e=ld(b,d,n,p,o)|0;q=c[b>>2]|0;c[b>>2]=q|m;e=(q&32|0)==0?e:-1}l=r;return e|0}function Yq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;i=b+612|0;j=b+548|0;k=b+544|0;l=b+772|0;m=b+376|0;d=c[i>>2]|0;e=c[j>>2]|0;while(1){h=d+4|0;if(h>>>0>e>>>0){n=11;break}f=c[k>>2]|0;g=f+d|0;if(a[g>>0]|0){n=11;break}if(a[f+(d+1)>>0]|0){n=11;break}if((a[f+(d+2)>>0]|0)!=1){n=11;break}g=(D9(a[g+3>>0]|0)|0)&255;if(a[(c[l>>2]|0)+g>>0]|0){d=1;break}c[i>>2]=h;a[m>>0]=0;if(!(nb[c[(c[b>>2]|0)+64>>2]&255](b)|0)){n=8;break}d=c[i>>2]|0;e=c[j>>2]|0;if((d+4|0)>>>0>e>>>0){n=10;break}}if((n|0)==8){a[b+377>>0]=1;d=0}else if((n|0)==10){a[b+377>>0]=1;d=0}else if((n|0)==11)if((d+3|0)==(e|0))d=0;else{t4(b);d=nb[c[(c[b>>2]|0)+64>>2]&255](b)|0}return d|0}function Zq(b){b=b|0;var d=0,e=0,f=0;f=l;l=l+16|0;d=f;e=ge(b,d)|0;do if(e|0){switch(a[e+39>>0]|0){case 86:case 83:{x0(b);break}case -128:case 118:{KS(b);VK(b,e);break}default:{}}wK(b);if(qO(b)|0){s_(b);AR(b,8,0);tv(b,b+852|0,c[d>>2]|0,e);b=c[b+772>>2]|0;a[b+16>>0]=1;d=b+20|0;if(!(a[b+31>>0]|0)){a[d>>0]=1;a[b+22>>0]=1;break}else{a[b+17>>0]=1;a[d>>0]=1;a[d+1>>0]=1;a[d+2>>0]=1;a[d+3>>0]=1;break}}}while(0);l=f;return}function _q(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;GC(b);a:do if(!(a[b+2476>>0]|0)){j=b+2510|0;k=b+2507|0;i=b+648|0;h=0;e=1;while(1){if((h|0)<(d[j>>0]|0))g=0;else break a;while(1){f=g&255;if((g&255)>=(d[k>>0]|0))break;do if(a[b+19032+(h<<6)+f>>0]|0){if(pZ(b,h,f)|0){mz(b);break}if(!(Y1(b,h,f)|0)){mz(b);break}if(e){d4(c[i>>2]|0,9);e=0;break}else{mz(b);e=0;break}}while(0);g=g+1<<24>>24}h=h+1|0}}else{k=c[b+648>>2]|0;G4(k,Z9(c[k+4>>2]|0)|0)}while(0);J3(b);return}function $q(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+128|0;j=b;o=b+118|0;n=b+104|0;i=b+100|0;h=b+96|0;k=b+92|0;a[o>>0]=a[402221]|0;a[o+1>>0]=a[402222]|0;a[o+2>>0]=a[402223]|0;a[o+3>>0]=a[402224]|0;a[o+4>>0]=a[402225]|0;a[o+5>>0]=a[402226]|0;m=e+4|0;tF(o+1|0,404736,1,c[m>>2]|0);p=b0()|0;c[j>>2]=g;g=n+(dR(n,13,p,o,j)|0)|0;m=kB(n,g,c[m>>2]|0)|0;O4(k,e);zi(n,m,g,j,i,h,k);c6(k);g=bn(c[d>>2]|0,j,c[i>>2]|0,c[h>>2]|0,e,f)|0;l=b;return g|0}function ar(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;g=i;do if((d|0)!=-1){h=a+4|0;e=c[a>>2]|0;if((((c[h>>2]|0)-e|0)/12|0)>>>0>d>>>0){k1(e+(d*12|0)|0,b)|0;break}else e=1;while(1)if(e>>>0<d>>>0)e=e<<1;else break;ZE(a,e);f=a+8|0;while(1){e=c[h>>2]|0;if(((e-(c[a>>2]|0)|0)/12|0)>>>0>=d>>>0)break;TX(g);e=c[h>>2]|0;if((e|0)==(c[f>>2]|0))Ax(a,g);else{p2(e,g);c[h>>2]=(c[h>>2]|0)+12}z5(g)}if((e|0)==(c[f>>2]|0)){Ax(a,b);break}else{p2(e,b);c[h>>2]=(c[h>>2]|0)+12;break}}while(0);l=i;return}function br(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;p=l;l=l+16|0;f=p;g=d+528|0;i=d+536|0;k=d+768|0;m=d+784|0;n=d+760|0;o=d+772|0;while(1){h=g;r=c[h+4>>2]|0;j=i;q=c[j+4>>2]|0;if(!(r>>>0<q>>>0|((r|0)==(q|0)?(c[h>>2]|0)>>>0<(c[j>>2]|0)>>>0:0)))break;GC(d);NB(d,f);j=g;h=c[j>>2]|0;j=c[j+4>>2]|0;r=i;if(!((h|0)==(c[r>>2]|0)?(j|0)==(c[r+4>>2]|0):0)){q=z0(h|0,j|0,1,0)|0;r=g;c[r>>2]=q;c[r+4>>2]=z}J3(d);if(!(qO(d)|0))continue;if((a[k>>0]|0)!=2)continue;if(!(a[m>>0]|0))continue;r=c[(c[(c[n>>2]|0)+80>>2]|0)+(e[o>>1]<<2)>>2]|0;b[r+164>>1]=b[f>>1]|0;a[r+171>>0]=1}l=p;return}function cr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;g=n+12|0;k=n+8|0;m=n;XP(m,b);if(a[m>>0]|0){O4(g,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);h=u$(c[g>>2]|0,409180)|0;c6(g);i=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;j=c[i+24>>2]|0;f=i+76|0;e=c[f>>2]|0;if(d8(-1,e)|0){O4(g,i);e=u$(c[g>>2]|0,409148)|0;e=tb[c[(c[e>>2]|0)+44>>2]&31](e,32)|0;c6(g);c[f>>2]=e}f=c[(c[h>>2]|0)+24>>2]|0;c[k>>2]=j;c[g>>2]=c[k>>2];if(!(ub[f&31](h,g,i,e,d&65535)|0)){k=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(k,c[k+16>>2]|5)}}TC(m);l=n;return b|0}function dr(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+128|0;j=b;o=b+108|0;n=b+96|0;i=b+92|0;h=b+88|0;k=b+84|0;a[o>>0]=a[402221]|0;a[o+1>>0]=a[402222]|0;a[o+2>>0]=a[402223]|0;a[o+3>>0]=a[402224]|0;a[o+4>>0]=a[402225]|0;a[o+5>>0]=a[402226]|0;m=e+4|0;tF(o+1|0,404736,0,c[m>>2]|0);p=b0()|0;c[j>>2]=g;g=n+(dR(n,12,p,o,j)|0)|0;m=kB(n,g,c[m>>2]|0)|0;O4(k,e);zi(n,m,g,j,i,h,k);c6(k);g=bn(c[d>>2]|0,j,c[i>>2]|0,c[h>>2]|0,e,f)|0;l=b;return g|0}function er(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0;k=l;l=l+16|0;h=k;j=k+2|0;Bx(d);sR(d,10,h);xR(d,4,j);wK(d);i=b[h>>1]|0;n=d+536|0;m=d+528|0;g=c[m>>2]|0;m=c[m+4>>2]|0;n=z0(c[n>>2]|0,c[n+4>>2]|0,6,0)|0;m=D_(n|0,z|0,g|0,m|0)|0;g=i+-1<<16>>16;if((i&65535|0)==(m|0)&0==(z|0)){b[h>>1]=g;i=g}n=z0(i&65535|0,0,-5,-1)|0;m=z;g=z0(e|0,f|0,-2,-1)|0;h=z;if(m>>>0>h>>>0|(m|0)==(h|0)&n>>>0>g>>>0)e1(d,g,h);else{n=(i&65535)+-5|0;e1(d,n,((n|0)<0)<<31>>31)}if(qO(d)|0){n=a[j>>0]|0;a[d+819>>0]=n;PU(d+836|0,3)|0;a[d+1242>>0]=n}l=k;return}function fr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=b+616|0;d=c[i>>2]|0;j=b+612|0;if(!d){d=(c[j>>2]|0)+4|0;c[i>>2]=d}h=b+544|0;g=c[b+548>>2]|0;while(1){if((d+4|0)>>>0>g>>>0)break;f=c[h>>2]|0;e=f+d|0;if((R4(a[e>>0]|0,a[e+1>>0]|0,a[e+2>>0]|0)|0)==1)break;while(1){e=d+2|0;c[i>>2]=e;if(e>>>0>=g>>>0){k=9;break}if(!(a[f+e>>0]|0)){k=8;break}else d=e}if((k|0)==8){k=0;d=d+1|0;if(a[f+d>>0]|0){d=e;continue}}else if((k|0)==9){k=0;d=d+1|0}c[i>>2]=d}do if((d+4|0)>>>0>g>>>0){if((a[b+768>>0]|0)==0?(a[(c[b+24>>2]|0)+141>>0]|0)==0:0){d=0;break}c[i>>2]=g;d=g;k=15}else k=15;while(0);if((k|0)==15){Op(b,d-(c[j>>2]|0)|0,0);c[i>>2]=0;d=1}return d|0}function gr(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+64|0;j=b;o=b+48|0;n=b+36|0;i=b+32|0;h=b+28|0;k=b+24|0;a[o>>0]=a[402221]|0;a[o+1>>0]=a[402222]|0;a[o+2>>0]=a[402223]|0;a[o+3>>0]=a[402224]|0;a[o+4>>0]=a[402225]|0;a[o+5>>0]=a[402226]|0;m=e+4|0;tF(o+1|0,404736,0,c[m>>2]|0);p=b0()|0;c[j>>2]=g;g=n+(dR(n,12,p,o,j)|0)|0;m=kB(n,g,c[m>>2]|0)|0;O4(k,e);Di(n,m,g,j,i,h,k);c6(k);g=Qo(c[d>>2]|0,j,c[i>>2]|0,c[h>>2]|0,e,f)|0;l=b;return g|0}function hr(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+64|0;j=b;o=b+50|0;n=b+36|0;i=b+32|0;h=b+28|0;k=b+24|0;a[o>>0]=a[402221]|0;a[o+1>>0]=a[402222]|0;a[o+2>>0]=a[402223]|0;a[o+3>>0]=a[402224]|0;a[o+4>>0]=a[402225]|0;a[o+5>>0]=a[402226]|0;m=e+4|0;tF(o+1|0,404736,1,c[m>>2]|0);p=b0()|0;c[j>>2]=g;g=n+(dR(n,13,p,o,j)|0)|0;m=kB(n,g,c[m>>2]|0)|0;O4(k,e);Di(n,m,g,j,i,h,k);c6(k);g=Qo(c[d>>2]|0,j,c[i>>2]|0,c[h>>2]|0,e,f)|0;l=b;return g|0}function ir(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+32|0;d=i+24|0;g=i+12|0;h=i;bB(b,d);if(qO(b)|0){VU(g,Ik(a[d>>0]|0)|0);d=c[(c[(c[b+760>>2]|0)+80>>2]|0)+((e[b+772>>1]|0)<<2)>>2]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[h+11>>0]=f;b=h}else{j=f+16&-16;b=ZW(j)|0;c[h>>2]=b;c[h+8>>2]=j|-2147483648;c[h+4>>2]=f}i1(b,384616,f)|0;J7(b+f|0,0);vF(VC(d+28|0,h)|0,g)|0;a1(h);z5(g)}l=i;return}function jr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=b+616|0;d=c[i>>2]|0;j=b+612|0;if(!d){d=(c[j>>2]|0)+4|0;c[i>>2]=d}h=b+544|0;g=c[b+548>>2]|0;while(1){if((d+4|0)>>>0>g>>>0)break;f=c[h>>2]|0;e=f+d|0;if((R4(a[e>>0]|0,a[e+1>>0]|0,a[e+2>>0]|0)|0)==1)break;while(1){e=d+2|0;c[i>>2]=e;if(e>>>0>=g>>>0){k=9;break}if(!(a[f+e>>0]|0)){k=8;break}else d=e}if((k|0)==8){k=0;d=d+1|0;if(a[f+d>>0]|0){d=e;continue}}else if((k|0)==9){k=0;d=d+1|0}c[i>>2]=d}do if((d+4|0)>>>0>g>>>0){if((a[b+776>>0]|0)==0?(a[(c[b+24>>2]|0)+141>>0]|0)==0:0){d=0;break}c[i>>2]=g;d=g;k=15}else k=15;while(0);if((k|0)==15){Op(b,d-(c[j>>2]|0)|0,0);c[i>>2]=0;d=1}return d|0}function kr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=fo(d,h,e)|0;e=c[g>>2]|0;if(!e){iE(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function lr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+16|0;d=p+1|0;o=p;switch(a[b+2506>>0]|0){case 0:{k=1;m=5;n=5;e=5;break}case 1:{k=2;m=4;n=2;e=5;break}case 2:{k=8;m=2;n=2;e=5;break}case 3:{k=2;m=4;n=5;e=5;break}default:{}}a:do if((e|0)==5){xR(b,2,d);j=a[d>>0]|0;g=b+648|0;f=1;while(1){if((f&255)>(j&255))break a;else e=0;while(1){if((e&255)>>>0>=k>>>0)break;xR(b,3,o);h=e<<24>>24==0?m:n;i=a[o>>0]|0;d=0;while(1){if((d&255)>=(i&255))break;d4(c[g>>2]|0,4);d4(c[g>>2]|0,h);d=d+1<<24>>24}e=e+1<<24>>24}f=f+1<<24>>24}}while(0);l=p;return}function mr(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=l;l=l+32|0;d=j+16|0;e=j+20|0;g=j+4|0;h=j;CK(a);bD(a,d);i=a+528|0;k=i;k=z0(c[k>>2]|0,c[k+4>>2]|0,2,0)|0;f=i;c[f>>2]=k;c[f+4>>2]=z;HB(a,e);e=b[e>>1]|0;if(e<<16>>16)iF(a,e&65535,0);e=c[d>>2]|0;if(e|0)Kc(a,6,-1)|0;d=0;while(1){if((d|0)==(e|0))break;GC(a);TX(g);k=i;k=z0(c[k>>2]|0,c[k+4>>2]|0,26,0)|0;f=i;c[f>>2]=k;c[f+4>>2]=z;bD(a,h);f=c[h>>2]|0;if(f|0)VY(a,f<<1,0,g);J3(a);z5(g);d=d+1|0}l=j;return}function nr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;m=l;l=l+16|0;i=m;j=m+8|0;k=b+528|0;h=k;h=z0(c[h>>2]|0,c[h+4>>2]|0,12,0)|0;g=k;c[g>>2]=h;c[g+4>>2]=z;g=b+792|0;h=(jF(b+760|0,b+772|0)|0)+72|0;f=0;while(1){if((f|0)==(d|0))break;GC(b);Uy(b,i);n=k;n=z0(c[n>>2]|0,c[n+4>>2]|0,4,0)|0;o=k;c[o>>2]=n;c[o+4>>2]=z;bD(b,j);o=GG(g,i)|0;c[o>>2]=e;c[o+4>>2]=0;o=h;o=z0(c[o>>2]|0,c[o+4>>2]|0,c[j>>2]|0,0)|0;n=h;c[n>>2]=o;c[n+4>>2]=z;J3(b);f=f+1|0}a[b+1040>>0]=0;l=m;return}function or(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+64|0;n=o;k=(g&255)-(f&255)|0;if(!(e<<24>>24)){h=2;j=k&254}else{h=1;j=k+2>>2<<1}m=j&254;i=h&255;g=n;e=g+64|0;do{a[g>>0]=0;g=g+1|0}while((g|0)<(e|0));g=0;while(1){e=g&255;if(e>>>0>=m>>>0)break;a[n+e>>0]=h;g=g+1<<24>>24}g=k-(O(i,m)|0)|0;i=j&255;e=g&255;a:do if(e<<24>>24){g=(g<<24|0)>0;h=g?-1:1;g=g?m+-1|0:0;while(1){if(!(e<<24>>24))break a;g=g&255;if(g>>>0>63)break a;k=n+g|0;a[k>>0]=(d[k>>0]|0)-h;g=g+h|0;e=(e&255)+h&255}}while(0);a[c>>0]=f;g=1;while(1){e=g&255;if(e>>>0>m>>>0)break;f=e+-1|0;a[c+e>>0]=(d[n+f>>0]|0)+(d[c+f>>0]|0);g=g+1<<24>>24}a[b>>0]=i;l=o;return}function pr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Nu(d,h,e)|0;e=c[g>>2]|0;if(!e){lA(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function qr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;g=n+12|0;k=n+8|0;m=n;XP(m,b);if(a[m>>0]|0){O4(g,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);h=u$(c[g>>2]|0,409180)|0;c6(g);i=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;j=c[i+24>>2]|0;f=i+76|0;e=c[f>>2]|0;if(d8(-1,e)|0){O4(g,i);e=u$(c[g>>2]|0,409148)|0;e=tb[c[(c[e>>2]|0)+44>>2]&31](e,32)|0;c6(g);c[f>>2]=e}f=c[(c[h>>2]|0)+24>>2]|0;c[k>>2]=j;c[g>>2]=c[k>>2];if(!(ub[f&31](h,g,i,e,d)|0)){k=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(k,c[k+16>>2]|5)}}TC(m);l=n;return b|0}function rr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;g=n+12|0;k=n+8|0;m=n;XP(m,b);if(a[m>>0]|0){O4(g,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);h=u$(c[g>>2]|0,409180)|0;c6(g);i=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;j=c[i+24>>2]|0;f=i+76|0;e=c[f>>2]|0;if(d8(-1,e)|0){O4(g,i);e=u$(c[g>>2]|0,409148)|0;e=tb[c[(c[e>>2]|0)+44>>2]&31](e,32)|0;c6(g);c[f>>2]=e}f=c[(c[h>>2]|0)+16>>2]|0;c[k>>2]=j;c[g>>2]=c[k>>2];if(!(ub[f&31](h,g,i,e,d)|0)){k=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(k,c[k+16>>2]|5)}}TC(m);l=n;return b|0}function sr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+16|0;h=i;W0(h,a+360|0);e=a+20|0;f=c[e>>2]|0;a:do if(f|0?c[f+728>>2]&4|0:0){SM(f);f=(c[e>>2]|0)+728|0;g=c[f>>2]&-5;c[f>>2]=g;e=16;while(1){if((e|0)==32)break a;j=g&~(1<<e);c[f>>2]=j;e=e+1|0;g=j}}while(0);if((b|0)<=6){e=c[a+28>>2]|0;e=((c[e+(b*12|0)+4>>2]|0)-(c[e+(b*12|0)>>2]|0)|0)/40|0;if((d|0)!=-1)if(e>>>0>d>>>0){e=vn(b)|0;j=c[(c[a+40>>2]|0)+(b*12|0)>>2]|0;e=(((c[j+(d*56|0)+4>>2]|0)-(c[j+(d*56|0)>>2]|0)|0)/40|0)+(((c[e+4>>2]|0)-(c[e>>2]|0)|0)/40|0)|0}else e=0}else e=0;s7(c[h>>2]|0);l=i;return e|0}function tr(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=l;l=l+16|0;d=h+4|0;f=h;e=h+8|0;bD(a,d);bD(a,f);g=a+528|0;j=g;j=z0(c[j>>2]|0,c[j+4>>2]|0,6,0)|0;i=g;c[i>>2]=j;c[i+4>>2]=z;HB(a,e);e=b[e>>1]|0;if(!(e<<16>>16)){i=g;i=z0(c[i>>2]|0,c[i+4>>2]|0,1,0)|0;j=g;c[j>>2]=i;c[j+4>>2]=z}else e1(a,e&65535,0);Kc(a,5,-1)|0;j=a+20|0;RB(a,1,c[j>>2]|0,18,380258,-1,1,0);RB(a,1,c[j>>2]|0,58,380258,-1,1,0);lL(a,1,c[j>>2]|0,130,c[d>>2]|0,10,0);lL(a,1,c[j>>2]|0,138,c[f>>2]|0,10,0);l=h;return}function ur(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;g=j+4|0;e=j+2|0;i=j;CK(a);HB(a,g);HB(a,e);e=b[e>>1]|0;d=0;while(1){if((d&65535)>=(e&65535))break;GC(a);HB(a,i);f=b[i>>1]|0;if(f<<16>>16)iF(a,(f&65535)<<1,0);J3(a);d=d+1<<16>>16}h=a+528|0;f=b[g>>1]|0;d=0;while(1){if((d&65535)>=(f&65535))break;GC(a);g=h;g=z0(c[g>>2]|0,c[g+4>>2]|0,2,0)|0;e=h;c[e>>2]=g;c[e+4>>2]=z;HB(a,i);e=b[i>>1]|0;if(e<<16>>16)iF(a,(e&65535)<<1,0);J3(a);d=d+1<<16>>16}l=j;return}function vr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=b+32|0;KQ(f,d)|0;h=b+44|0;c[h>>2]=0;k=b+48|0;g=c[k>>2]|0;i=f+11|0;j=b+36|0;if(g&8|0){d=a[i>>0]|0;if(d<<24>>24<0){d=c[f>>2]|0;e=d;d=d+(c[j>>2]|0)|0}else{e=f;d=f+(d&255)|0}c[h>>2]=d;c[b+8>>2]=e;c[b+12>>2]=e;c[b+16>>2]=d}if(g&16|0){d=a[i>>0]|0;if(d<<24>>24<0){g=c[j>>2]|0;c[h>>2]=(c[f>>2]|0)+g;d=(c[b+40>>2]&2147483647)+-1|0}else{g=d&255;c[h>>2]=f+g;d=10}CC(f,d);d=a[i>>0]|0;if(d<<24>>24<0){f=c[f>>2]|0;d=c[j>>2]|0}else d=d&255;e=b+24|0;c[e>>2]=f;c[b+20>>2]=f;c[b+28>>2]=f+d;if(c[k>>2]&3|0)c[e>>2]=f+g}return}function wr(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;e=k;i=b+648|0;d4(c[i>>2]|0,4);j=b+2505|0;AT(b,j);if(!(a[j>>0]|0))e=0;else{jh(b);xR(b,2,e);if((a[e>>0]|0)==1){GC(b);g=b+2510|0;h=b+2507|0;f=0;while(1){if((f&255)>=(d[g>>0]|0))break;GC(b);e=0;while(1){if((e&255)>=(d[h>>0]|0))break;A6(c[i>>2]|0);e=e+1<<24>>24}J3(b);f=f+1<<24>>24}J3(b)}e=(a[j>>0]|0)!=0}Jo(b,e);if(qO(b)|0)Jo(b,(a[j>>0]|0)!=0);l=k;return}function xr(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+32|0;h=j;e=a+4|0;g=c[e>>2]|0;f=c[a+8>>2]|0;i=f;do if(g>>>0<f>>>0)if((g|0)==(b|0)){rV(b,d);c[e>>2]=(c[e>>2]|0)+12;break}else{CE(a,b,g,b+12|0);vF(b,d)|0;break}else{f=c[a>>2]|0;e=((g-f|0)/12|0)+1|0;if(e>>>0>357913941)uaa();else{g=(i-f|0)/12|0;i=g<<1;xE(h,g>>>0<178956970?(i>>>0<e>>>0?e:i):357913941,(b-f|0)/12|0,a+8|0);cn(h,d);qv(a,h,b)|0;HQ(h);break}}while(0);l=j;return}function yr(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;g=n+12|0;k=n+8|0;m=n;XP(m,b);if(a[m>>0]|0){O4(g,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);h=u$(c[g>>2]|0,409180)|0;c6(g);i=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;j=c[i+24>>2]|0;f=i+76|0;e=c[f>>2]|0;if(d8(-1,e)|0){O4(g,i);e=u$(c[g>>2]|0,409148)|0;e=tb[c[(c[e>>2]|0)+44>>2]&31](e,32)|0;c6(g);c[f>>2]=e}f=c[(c[h>>2]|0)+32>>2]|0;c[k>>2]=j;c[g>>2]=c[k>>2];if(!(mb[f&7](h,g,i,e,d)|0)){k=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(k,c[k+16>>2]|5)}}TC(m);l=n;return b|0}function zr(d){d=d|0;var e=0,f=0;Eg(d);c[d>>2]=22636;f=d+772|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[f+(e<<2)>>2]=0;e=e+1|0}c[d+808>>2]=0;c[d+812>>2]=0;c[d+816>>2]=0;TX(d+832|0);x1(d+916|0);c[d+936>>2]=0;c[d+940>>2]=0;c[d+944>>2]=0;c[d+960>>2]=0;c[d+964>>2]=0;c[d+968>>2]=0;IX(d+72|0,376937)|0;a[d+494>>0]=0;a[d+761>>0]=0;c[d+824>>2]=1;c[d+828>>2]=0;f=d+848|0;c[f>>2]=-1;c[f+4>>2]=-1;f=d+856|0;c[f>>2]=0;c[f+4>>2]=0;f=d+864|0;c[f>>2]=-1;c[f+4>>2]=-1;f=d+904|0;c[d+912>>2]=0;c[f>>2]=0;b[f+4>>1]=0;a[f+6>>0]=0;c[d+788>>2]=-1;a[d+972>>0]=0;f=d+888|0;c[f>>2]=-1;c[f+4>>2]=-1;a[d+884>>0]=1;c[d+952>>2]=0;return}function Ar(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;g=l;l=l+32|0;d=g+16|0;e=g+4|0;h=g;TX(e);aH(b,h);if((c[h>>2]|0)==1195459122?(f=b+536|0,h=f,i=c[h+4>>2]|0,i>>>0>0|(i|0)==0&(c[h>>2]|0)>>>0>16):0){KK(b);i=b+528|0;h=i;h=z0(c[h>>2]|0,c[h+4>>2]|0,3,0)|0;j=i;c[j>>2]=h;c[j+4>>2]=z;bD(b,d);iF(b,c[d>>2]|0,0);j=i;j=z0(c[j>>2]|0,c[j+4>>2]|0,6,0)|0;h=z;k=c[f>>2]|0;f=c[f+4>>2]|0;d=h>>>0>f>>>0|(h|0)==(f|0)&j>>>0>k>>>0;c[i>>2]=d?k:j;c[i+4>>2]=d?f:h}a[(jF(b+760|0,b+772|0)|0)+80>>0]=0;k=b+1038|0;a[k>>0]=(a[k>>0]|0)+-1<<24>>24;z5(e);l=g;return}function Br(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Yu(d,h,e)|0;e=c[g>>2]|0;if(!e){gC(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function Cr(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+4|0;b=c[f>>2]|0;do if(b){h=a[e+11>>0]|0;g=h<<24>>24<0;h=g?c[e+4>>2]|0:h&255;g=g?c[e>>2]|0:e;while(1){e=b+16|0;f=a[e+11>>0]|0;i=f<<24>>24<0;f=i?c[b+20>>2]|0:f&255;e=R$(g,i?c[e>>2]|0:e,f>>>0<h>>>0?f:h)|0;if((((e|0)==0?(h>>>0<f>>>0?-2147483648:0):e)|0)<0){f=c[b>>2]|0;if(!f){f=5;break}else b=f}else{e=b+4|0;f=c[e>>2]|0;if(!f){f=8;break}else b=f}}if((f|0)==5){c[d>>2]=b;break}else if((f|0)==8){c[d>>2]=b;b=e;break}}else{c[d>>2]=f;b=f}while(0);return b|0}function Dr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Nu(d,h,e)|0;e=c[g>>2]|0;if(!e){WB(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function Er(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;f=_s(d,h,e,f)|0;e=c[f>>2]|0;if(!e){qC(i,d,g);e=c[i>>2]|0;HH(d,c[h>>2]|0,f,e);f=1}else f=0;c[b>>2]=e;a[b+4>>0]=f;l=j;return}function Fr(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;do if(Pc(d+760|0)|0){f=d+612|0;g=d+544|0;e=c[d+548>>2]|0;i=c[f>>2]|0;while(1){j=i+1|0;if(i>>>0>=e>>>0)break;if(a[(c[g>>2]|0)+i>>0]|0)break;c[f>>2]=j;i=j}if((i+3|0)>>>0<=e>>>0){e=c[g>>2]|0;d=d+376|0;if(((a[e+i>>0]|0)==-1?(h=a[e+j>>0]|0,(h&255)>=224):0)?(k=a[e+(i+2)>>0]|0,j=k&255,!((j&240|0)==240|(j&12|0)==12)):0){f=(D9(h)|0)&255;g=f>>>3&3;k=D9(k)|0;e=(k&255)>>>4;if((b[61002+(g<<3)+(((k&255)>>>2&3)<<1)>>1]|0?(l=f>>>1&3,a[372685+(g<<2)+l>>0]|0):0)?!((l|0)==0?1:(b[60490+(g<<7)+(l<<5)+((e&255)<<1)>>1]|0)==0):0){e=1;break}a[d>>0]=0;e=1;break}a[d>>0]=0;e=1}else e=0}else e=0;while(0);return e|0}function Gr(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=XZ(b|0,0,28)|0;p=UW(p|0,z|0,1e7,0)|0;o=z;n=XZ(b|0,0,24)|0;n=UW(n&15|0,0,1e6,0)|0;m=z;l=XZ(b|0,0,20)|0;l=UW(l&15|0,0,1e5,0)|0;k=z;j=XZ(b|0,0,16)|0;j=UW(j&15|0,0,1e4,0)|0;i=z;h=XZ(b|0,0,12)|0;h=UW(h&15|0,0,1e3,0)|0;g=z;f=XZ(b|0,0,8)|0;f=UW(f&15|0,0,100,0)|0;e=z;d=XZ(b|0,0,4)|0;d=UW(d&15|0,0,10,0)|0;c=z;b=z0(p|b&15|0,o|0,n|0,m|0)|0;b=z0(b|0,z|0,l|0,k|0)|0;b=z0(b|0,z|0,j|0,i|0)|0;b=z0(b|0,z|0,h|0,g|0)|0;b=z0(b|0,z|0,f|0,e|0)|0;b=z0(b|0,z|0,d|0,c|0)|0;b=UW(b|0,z|0,1e4,0)|0;oT(a,b,z,10);return}function Hr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=l;l=l+32|0;f=h+16|0;g=h;b=Bh(a,b,f,h+12|0,d)|0;if(!(c[b>>2]|0)){zH(g,a,e);HH(a,c[f>>2]|0,b,c[g>>2]|0)}l=h;return}function Ir(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,i=0;d=an(a)|0;b=a+840|0;e=b;c[e>>2]=d;c[e+4>>2]=z;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){i=a+16|0;d=a+20|0;e=b;oK(a,c[i>>2]|0,c[d>>2]|0,10,c[e>>2]|0,c[e+4>>2]|0,10,0);e=kE(a+760|0,b)|0;b=c[i>>2]|0;if((b|0)!=7){c[e+36>>2]=b;c[e+40>>2]=c[d>>2]}d=a+848|0;b=c[d>>2]|0;d=c[d+4>>2]|0;if(!((b|0)==0&(d|0)==0)?(h=a+856|0,f=c[h>>2]|0,h=c[h+4>>2]|0,!((f|0)==0&(h|0)==0)):0)g[e+52>>2]=(+(b>>>0)+4294967296.0*+(d>>>0))/(+(f>>>0)+4294967296.0*+(h>>>0));b=c[a+864>>2]|0;if(b|0)c[e+48>>2]=b;fc(a);Cn(a)}return}function Jr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;j=ro(a,b,d)|0;f=e;i=c[f>>2]|0;f=c[f+4>>2]|0;h=d;g=c[h>>2]|0;h=c[h+4>>2]|0;if(f>>>0<h>>>0|(f|0)==(h|0)&i>>>0<g>>>0){k=d;c[k>>2]=i;c[k+4>>2]=f;f=e;c[f>>2]=g;c[f+4>>2]=h;f=j+1|0;h=d;g=c[h>>2]|0;h=c[h+4>>2]|0;i=b;e=c[i>>2]|0;i=c[i+4>>2]|0;if(h>>>0<i>>>0|(h|0)==(i|0)&g>>>0<e>>>0){f=b;c[f>>2]=g;c[f+4>>2]=h;g=d;c[g>>2]=e;c[g+4>>2]=i;g=b;f=c[g>>2]|0;g=c[g+4>>2]|0;e=a;h=c[e>>2]|0;e=c[e+4>>2]|0;if(g>>>0<e>>>0|(g|0)==(e|0)&f>>>0<h>>>0){k=a;c[k>>2]=f;c[k+4>>2]=g;f=b;c[f>>2]=h;c[f+4>>2]=e;f=j+3|0}else f=j+2|0}}else f=j;return f|0}function Kr(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;j=so(a,b,d)|0;f=e;i=c[f>>2]|0;f=c[f+4>>2]|0;h=d;g=c[h>>2]|0;h=c[h+4>>2]|0;if((f|0)<(h|0)|(f|0)==(h|0)&i>>>0<g>>>0){k=d;c[k>>2]=i;c[k+4>>2]=f;f=e;c[f>>2]=g;c[f+4>>2]=h;f=j+1|0;h=d;g=c[h>>2]|0;h=c[h+4>>2]|0;i=b;e=c[i>>2]|0;i=c[i+4>>2]|0;if((h|0)<(i|0)|(h|0)==(i|0)&g>>>0<e>>>0){f=b;c[f>>2]=g;c[f+4>>2]=h;g=d;c[g>>2]=e;c[g+4>>2]=i;g=b;f=c[g>>2]|0;g=c[g+4>>2]|0;e=a;h=c[e>>2]|0;e=c[e+4>>2]|0;if((g|0)<(e|0)|(g|0)==(e|0)&f>>>0<h>>>0){k=a;c[k>>2]=f;c[k+4>>2]=g;f=b;c[f>>2]=h;c[f+4>>2]=e;f=j+3|0}else f=j+2|0}}else f=j;return f|0}function Lr(){var a=0;c[101225]=0;_Z();TX(404924);TX(404936);TX(404948);TX(404960);TX(404972);TX(404984);TX(404996);oG(405008);xA(405064);xA(405120);oG(405180);a=0;do{oG(405236+(a*56|0)|0);a=a+1|0}while((a|0)!=28);oG(406804);oG(406860);a=0;do{oG(406916+(a*56|0)|0);a=a+1|0}while((a|0)!=4);oG(407140);oG(407196);a=0;do{xA(407252+(a*56|0)|0);a=a+1|0}while((a|0)!=7);xA(407644);DX();q2(407712);return}function Mr(d){d=d|0;var e=0,f=0,g=0;Eg(d);c[d>>2]=33640;f=d+772|0;c[d+904>>2]=0;c[d+908>>2]=0;c[d+912>>2]=0;e=d+936|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;f=d+840|0;g=f+36|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));TX(e);TX(d+948|0);TX(d+960|0);TX(d+972|0);TX(d+984|0);TX(d+996|0);TX(d+1008|0);f=d+1020|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[f+(e<<2)>>2]=0;e=e+1|0}a[d+733>>0]=1;g=d+632|0;c[g>>2]=65536;c[g+4>>2]=0;a[d+96>>0]=1;a[d+493>>0]=1;g=d+360|0;c[g>>2]=0;c[g+4>>2]=0;g=d+760|0;c[d+796>>2]=0;c[g>>2]=0;c[g+4>>2]=0;b[g+8>>1]=0;a[g+10>>0]=0;a[d+1046>>0]=2;return}function Nr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;h=l;l=l+16|0;g=h;if(YT(a)|0){NR(a);do{}while(hT(a)|0)}W0(g,a+360|0);b=a+28|0;d=c[b>>2]|0;e=a+32|0;while(1){f=c[e>>2]|0;if((f|0)==(d|0))break;f=f+-12|0;c[e>>2]=f;mQ(f)}iC(b);b=a+40|0;d=c[b>>2]|0;e=a+44|0;while(1){f=c[e>>2]|0;if((f|0)==(d|0))break;f=f+-12|0;c[e>>2]=f;QP(f)}TB(b);b=a+20|0;d=c[b>>2]|0;if(d|0)jb[c[(c[d>>2]|0)+4>>2]&511](d);c[b>>2]=0;s7(c[g>>2]|0);l=h;return}function Or(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;Bx(d);e=d+648|0;d4(c[e>>2]|0,4);f=d+770|0;sR(d,12,f);wK(d);if(b[f>>1]|0)Ao(d);g=d+528|0;h=d+536|0;i=d+782|0;j=d+794|0;while(1){l=g;n=c[l+4>>2]|0;k=h;m=c[k+4>>2]|0;if(!(n>>>0<m>>>0|((n|0)==(m|0)?(c[l>>2]|0)>>>0<(c[k>>2]|0)>>>0:0)))break;GC(d);NB(d,i);Bx(d);A6(c[e>>2]|0);d4(c[e>>2]|0,3);sR(d,12,f);wK(d);a[j>>0]=1;if(b[f>>1]|0)Ao(d);J3(d)}return}function Pr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;e=a+804|0;d=0;while(1){if((d|0)==256)break;else b=0;while(1){g=c[e>>2]|0;f=c[g+(d*120|0)+28>>2]|0;if(b>>>0>=(c[g+(d*120|0)+32>>2]|0)-f>>2>>>0)break;SM(c[f+(b<<2)>>2]|0);b=b+1|0}d=d+1|0}e=a+816|0;d=0;while(1){if((d|0)==256)break;else b=0;while(1){g=c[e>>2]|0;f=c[g+(d*120|0)+28>>2]|0;if(b>>>0>=(c[g+(d*120|0)+32>>2]|0)-f>>2>>>0)break;SM(c[f+(b<<2)>>2]|0);b=b+1|0}d=d+1|0}e=a+828|0;d=0;while(1){if((d|0)==256)break;else b=0;while(1){g=c[e>>2]|0;f=c[g+(d*120|0)+28>>2]|0;if(b>>>0>=(c[g+(d*120|0)+32>>2]|0)-f>>2>>>0)break;SM(c[f+(b<<2)>>2]|0);b=b+1|0}d=d+1|0}return}function Qr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Nu(d,h,e)|0;e=c[g>>2]|0;if(!e){pF(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function Rr(a){a=a|0;var b=0,d=0,e=0,f=0.0;a:do if((c[a+548>>2]|0)>>>0<8){b=a+40|0;a=c[b+4>>2]|0;b=a>>>0<0|(a|0)==0&(c[b>>2]|0)>>>0<8}else{b=c[a+544>>2]|0;d=C9(b)|0;e=d>>>8;b:do if(!((d&-65536|0)==1297743872|((d|0)==807842421|((d|0)==1146111792|((d|0)==2135247942|((e|0)==4607062|((d|0)==1380533830|(e|0)==4609875))))))){switch(d|0){case 256:case 435:case 442:break b;default:{}}e=V8(b+(c[a+612>>2]|0)|0)|0;if(!((e|0)==1446063664&(z|0)==1145849632)){b=a+896|0;e=b;if(!((c[e>>2]|0)==0&(c[e+4>>2]|0)==0)){b=1;break a}f=+g[(c[a+24>>2]|0)+136>>2];a=!(f>=.5);e=f>=.3;c[b>>2]=a?(e?32:4):128;c[b+4>>2]=a?(e?0:0):0;b=1;break a}}while(0);w5(c[a+760>>2]|0);b=0}while(0);return b|0}function Sr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,i=0,j=0;j=l;l=l+16|0;d=j+12|0;i=j+8|0;f=j+4|0;e=j;r3(a,d);ID(a,i);g=a+528|0;i=c[i>>2]|0;a:do if((c[d>>2]|0)==1346458214){d=g;b=c[d>>2]|0;d=c[d+4>>2]|0;if((i|0)!=20){i=a+536|0;i=D_(c[i>>2]|0,c[i+4>>2]|0,b|0,d|0)|0;e1(a,i,z);break}i=z0(b|0,d|0,4,0)|0;b=g;c[b>>2]=i;c[b+4>>2]=z;ID(a,f);ID(a,e);b=c[e>>2]|0;if(b|0)h[a+968>>3]=+((c[f>>2]|0)>>>0)/+(b>>>0)}else{b=8;while(1){if(b>>>0>=i>>>0)break a;a=g;a=z0(c[a>>2]|0,c[a+4>>2]|0,4,0)|0;f=g;c[f>>2]=a;c[f+4>>2]=z;b=b+1|0}}while(0);l=j;return}function Tr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+16|0;b=h;d=a+528|0;e=d;g=a+536|0;f=g;if(!((c[e>>2]|0)==(c[f>>2]|0)?(c[e+4>>2]|0)==(c[f+4>>2]|0):0)){iF(a,7,0);f=d;f=z0(c[f>>2]|0,c[f+4>>2]|0,1,0)|0;e=d;c[e>>2]=f;c[e+4>>2]=z;bD(a,b);e=d;e=z0(c[e>>2]|0,c[e+4>>2]|0,37,0)|0;f=z;i=d;c[i>>2]=e;c[i+4>>2]=f;b=(c[b>>2]|0)+8|0;if(0>f>>>0|0==(f|0)&b>>>0>e>>>0){e=D_(b|0,0,e|0,f|0)|0;e1(a,e,z);e=d;f=c[e+4>>2]|0;e=c[e>>2]|0}d=g;b=c[d>>2]|0;d=c[d+4>>2]|0;if(d>>>0>f>>>0|(d|0)==(f|0)&b>>>0>e>>>0){i=D_(b|0,d|0,e|0,f|0)|0;iF(a,i,z)}}l=h;return}function Ur(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;h=c[b>>2]|0;g=c[b+4>>2]|0;f=((c[d>>2]|0)-h<<3)+(c[d+4>>2]|0)-g|0;d=h;i=e+4|0;if((f|0)>0){if(!g)d=h;else{j=32-g|0;h=(f|0)<(j|0)?f:j;j=-1>>>(j-h|0)&-1<<g;g=c[e>>2]|0;c[g>>2]=c[g>>2]&~j|c[d>>2]&j;d=(c[i>>2]|0)+h|0;c[e>>2]=g+(d>>>5<<2);c[i>>2]=d&31;d=(c[b>>2]|0)+4|0;c[b>>2]=d;f=f-h|0}g=(f|0)/32|0;TR(c[e>>2]|0,d|0,g<<2|0)|0;f=f-(g<<5)|0;d=(c[e>>2]|0)+(g<<2)|0;c[e>>2]=d;if((f|0)>0){h=(c[b>>2]|0)+(g<<2)|0;c[b>>2]=h;j=-1>>>(32-f|0);d=c[e>>2]|0;c[d>>2]=c[d>>2]&~j|c[h>>2]&j;c[i>>2]=f}}else d=c[e>>2]|0;c[a>>2]=d;c[a+4>>2]=c[i>>2];return}function Vr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=b+616|0;d=c[j>>2]|0;k=b+612|0;if(!d){d=(c[k>>2]|0)+3|0;c[j>>2]=d}i=b+544|0;h=c[b+548>>2]|0;while(1){if((d+3|0)>>>0>h>>>0){g=13;break}f=c[i>>2]|0;if(((a[f+d>>0]|0)==0?(a[f+(d+1)>>0]|0)==0:0)?(a[f+(d+2)>>0]&-4)<<24>>24==-128:0){g=16;break}while(1){e=d+2|0;c[j>>2]=e;if(e>>>0>=h>>>0){g=11;break}if(!(a[f+e>>0]|0)){g=10;break}else d=e}if((g|0)==10){d=d+1|0;if(a[f+d>>0]|0){d=e;continue}}else if((g|0)==11)d=d+1|0;c[j>>2]=d}do if((g|0)==13){if((a[b+768>>0]|0)==0?(a[(c[b+24>>2]|0)+141>>0]|0)==0:0)break;c[j>>2]=h;d=h;g=16}while(0);if((g|0)==16){Op(b,d-(c[k>>2]|0)|0,0);c[j>>2]=0}return}function Wr(b){b=b|0;var d=0,e=0,f=0;Eg(b);d=b+760|0;BG(d);c[b>>2]=15432;TX(b+908|0);TX(b+920|0);TX(b+932|0);TX(b+944|0);TX(b+956|0);x1(b+968|0);x1(b+980|0);x1(b+992|0);c[d>>2]=b;a[b+733>>0]=1;d=b+632|0;c[d>>2]=65536;c[d+4>>2]=0;a[b+96>>0]=1;a[b+493>>0]=1;d=b+360|0;c[d>>2]=0;c[d+4>>2]=0;d=b+896|0;c[d>>2]=0;c[d+4>>2]=0;a[b+904>>0]=0;a[b+905>>0]=0;d=b+1080|0;e=b+1004|0;f=e+76|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));f=d;c[f>>2]=-1;c[f+4>>2]=-1;f=b+1088|0;c[b+1124>>2]=0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;return}function Xr(b){b=b|0;var d=0,e=0;if(a[b+760>>0]|0){d=b+536|0;a:do if((c[b+764>>2]|0)==1414744150)switch(a[b+761>>0]|0){case -96:{UU(b);break a}case -95:{ki(b);break a}default:{e1(b,c[d>>2]|0,c[d+4>>2]|0);break a}}else e1(b,c[d>>2]|0,c[d+4>>2]|0);while(0);if(!(c[b+728>>2]&1))W5(b)}else{Kc(b,6,-1)|0;e=b+20|0;RB(b,6,c[e>>2]|0,18,378175,-1,1,0);RB(b,6,c[e>>2]|0,33,378175,-1,1,0);d=c[b+804>>2]|0;c[d+22920>>2]=c[b+16>>2];c[d+22924>>2]=c[e>>2];a[d+23036>>0]=0;a[b+796>>0]=0}return}function Yr(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Nu(d,h,e)|0;e=c[g>>2]|0;if(!e){xF(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function Zr(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=l;l=l+16|0;i=j;c[i>>2]=76;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[b+(e<<2)>>2]=0;e=e+1|0}h=d+8+3|0;g=a[h>>0]|0;g=g<<24>>24<0?c[d+4>>2]|0:g&255;e=g+1|0;if(e>>>0>1073741807)uaa();f=b+8|0;do if(e>>>0>=2){e=g+5&-4;if(e>>>0>1073741823){j=ua(8)|0;K2(j,391652);c[j>>2]=57868;Ya(j|0,2712,367)}else{k=ZW(e<<2)|0;c[b>>2]=k;c[f>>2]=e|-2147483648;c[b+4>>2]=1;e=k;break}}else{a[f+3>>0]=1;e=b}while(0);a3(e,i,1);y7(e+4|0,0);Ex(b,(a[h>>0]|0)<0?c[d>>2]|0:d,g)|0;l=j;return}function _r(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Nu(d,h,e)|0;e=c[g>>2]|0;if(!e){DF(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function $r(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0;i=l;l=l+16|0;g=i;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[g+(d<<2)>>2]=0;d=d+1|0}e=a[h+11>>0]|0;f=e<<24>>24<0;d=f?c[h>>2]|0:h;e=d+(f?c[h+4>>2]|0:e&255)|0;while(1){if(d>>>0>=e>>>0)break;gy(g,a[d>>0]|0);d=d+1|0}e=a[g+11>>0]|0;f=c[g>>2]|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}d=e<<24>>24<0?f:g;e=d+(FD(raa(d)|0)|0)|0;while(1){if(d>>>0>=e>>>0)break;gy(b,a[d>>0]|0);d=d+1|0}a1(g);l=i;return}function as(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+4|0;b=c[f>>2]|0;do if(b){h=a[e+8+3>>0]|0;g=h<<24>>24<0;h=g?c[e+4>>2]|0:h&255;g=g?c[e>>2]|0:e;while(1){e=b+16|0;f=a[b+24+3>>0]|0;i=f<<24>>24<0;f=i?c[b+20>>2]|0:f&255;e=L$(g,i?c[e>>2]|0:e,f>>>0<h>>>0?f:h)|0;if((((e|0)==0?(h>>>0<f>>>0?-2147483648:0):e)|0)<0){f=c[b>>2]|0;if(!f){f=6;break}else b=f}else{e=b+4|0;f=c[e>>2]|0;if(!f){f=8;break}else b=f}}if((f|0)==6){c[d>>2]=b;break}else if((f|0)==8){c[d>>2]=b;b=e;break}}else{c[d>>2]=f;b=f}while(0);return b|0}function bs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Nu(d,h,e)|0;e=c[g>>2]|0;if(!e){FC(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function cs(b){b=b|0;var c=0,e=0,f=0,g=0,h=0,i=0;c=a[b+4>>0]|0;if(!(c<<24>>24)){c=0;e=0}else{f=d[b>>0]|0;h=UW(f|0,0,3600,0)|0;e=z;g=a[b+1>>0]|0;i=UW(g&255|0,0,60,0)|0;e=z0(i|0,z|0,h|0,e|0)|0;e=z0(e|0,z|0,d[b+2>>0]|0,0)|0;e=UW(e|0,z|0,c&255|0,0)|0;e=z0(e|0,z|0,d[b+3>>0]|0,0)|0;c=z;if(a[b+5>>0]|0){h=UW(f|0,0,-108,-1)|0;i=z;f=UW(((g&255)/10|0)&255|0,0,-18,-1)|0;i=z0(f|0,z|0,h|0,i|0)|0;i=D_(i|0,z|0,((g&255)%10|0)<<1&255|0,0)|0;e=z0(i|0,z|0,e|0,c|0)|0;c=z}h=(a[b+6>>0]|0)!=0;e=UW((h?2:1)|0,(h?0:0)|0,e|0,c|0)|0;e=z0(e|0,z|0,d[b+7>>0]|0,0)|0;c=z;h=(a[b+8>>0]|0)!=0;i=D_(0,0,e|0,c|0)|0;c=h?z:c;e=h?i:e}z=c;return e|0}function ds(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;g=l;l=l+16|0;b=g;TX(b);d=a+536|0;f=d;if((c[f>>2]|0)==0&(c[f+4>>2]|0)==0){e=0;f=0}else{jZ(a,10,0,b);e1(a,22,0);f=d;e=c[f>>2]|0;f=c[f+4>>2]|0}h=a+528|0;if(!((c[h>>2]|0)==(e|0)?(c[h+4>>2]|0)==(f|0):0))t4(a);do if(qO(a)|0){Kc(a,3,-1)|0;h=d;if((c[h>>2]|0)==0&(c[h+4>>2]|0)==0){jF(a+760|0,a+772|0)|0;PK(a);break}else{zb(a,3,c[a+20>>2]|0,18,b,0);break}}while(0);z5(b);l=g;return}function es(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;f=a+808|0;g=a+812|0;d=0;while(1){b=c[g>>2]|0;h=c[f>>2]|0;e=h;if(d>>>0>=b-h>>2>>>0)break;b=c[e+(d<<2)>>2]|0;if(b|0){P_(c[b>>2]|0);laa(b)}d=d+1|0}while(1){if((b|0)==(e|0))break;h=b+-4|0;c[g>>2]=h;b=h}f=a+820|0;g=a+824|0;d=0;while(1){b=c[g>>2]|0;h=c[f>>2]|0;e=h;if(d>>>0>=b-h>>2>>>0)break;b=c[e+(d<<2)>>2]|0;if(b|0)laa(b);d=d+1|0}while(1){if((b|0)==(e|0))break;h=b+-4|0;c[g>>2]=h;b=h}f=a+796|0;g=a+800|0;d=0;while(1){b=c[g>>2]|0;h=c[f>>2]|0;e=h;if(d>>>0>=b-h>>2>>>0)break;b=c[e+(d<<2)>>2]|0;if(b|0)laa(b);d=d+1|0}while(1){if((b|0)==(e|0))break;h=b+-4|0;c[g>>2]=h;b=h}return}function fs(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=d&255;f=(e|0)!=0;a:do if(f&(b&3|0)!=0){g=d&255;while(1){if((a[b>>0]|0)==g<<24>>24)break a;b=b+1|0;e=e+-1|0;f=(e|0)!=0;if(!(f&(b&3|0)!=0)){i=5;break}}}else i=5;while(0);b:do if((i|0)==5)if(f){g=d&255;if((a[b>>0]|0)!=g<<24>>24){f=O(h,16843009)|0;c:do if(e>>>0>3)while(1){h=c[b>>2]^f;if((h&-2139062144^-2139062144)&h+-16843009|0)break;b=b+4|0;e=e+-4|0;if(e>>>0<=3){i=11;break c}}else i=11;while(0);if((i|0)==11)if(!e){e=0;break}while(1){if((a[b>>0]|0)==g<<24>>24)break b;b=b+1|0;e=e+-1|0;if(!e){e=0;break}}}}else e=0;while(0);return (e|0?b:0)|0}function gs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Nu(d,h,e)|0;e=c[g>>2]|0;if(!e){bG(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function hs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Zv(d,h,e)|0;e=c[g>>2]|0;if(!e){_B(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function is(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0;b=l;l=l+192|0;j=b;k=b+172|0;h=b+152|0;n=b+148|0;a[k>>0]=a[402213]|0;a[k+1>>0]=a[402214]|0;a[k+2>>0]=a[402215]|0;a[k+3>>0]=a[402216]|0;a[k+4>>0]=a[402217]|0;a[k+5>>0]=a[402218]|0;i=b0()|0;c[j>>2]=g;g=dR(h,20,i,k,j)|0;k=h+g|0;i=kB(h,k,c[e+4>>2]|0)|0;O4(n,e);m=u$(c[n>>2]|0,409148)|0;c6(n);rb[c[(c[m>>2]|0)+48>>2]&7](m,h,k,j)|0;g=j+(g<<2)|0;g=bn(c[d>>2]|0,j,(i|0)==(k|0)?g:j+(i-h<<2)|0,g,e,f)|0;l=b;return g|0}function js(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;f=_s(d,h,e,f)|0;e=c[f>>2]|0;if(!e){JB(i,d,g);e=c[i>>2]|0;HH(d,c[h>>2]|0,f,e);f=1}else f=0;c[b>>2]=e;a[b+4>>0]=f;l=j;return}function ks(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=vu(d,h,e)|0;e=c[g>>2]|0;if(!e){LH(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function ls(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+4|0;b=c[f>>2]|0;do if(b){h=a[e+8+3>>0]|0;g=h<<24>>24<0;h=g?c[e+4>>2]|0:h&255;g=g?c[e>>2]|0:e;while(1){e=b+16|0;f=a[b+24+3>>0]|0;i=f<<24>>24<0;f=i?c[b+20>>2]|0:f&255;e=L$(g,i?c[e>>2]|0:e,f>>>0<h>>>0?f:h)|0;if((((e|0)==0?(h>>>0<f>>>0?-2147483648:0):e)|0)<0){f=c[b>>2]|0;if(!f){f=5;break}else b=f}else{e=b+4|0;f=c[e>>2]|0;if(!f){f=8;break}else b=f}}if((f|0)==5){c[d>>2]=b;break}else if((f|0)==8){c[d>>2]=b;b=e;break}}else{c[d>>2]=f;b=f}while(0);return b|0}function ms(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[b+(f<<2)>>2]=0;f=f+1|0}i=i9(d)|0;j=e+8+3|0;h=a[j>>0]|0;h=h<<24>>24<0?c[e+4>>2]|0:h&255;f=h+i|0;if(f>>>0>1073741807)uaa();g=b+8|0;do if(f>>>0>=2){f=f+4&-4;if(f>>>0>1073741823){e=ua(8)|0;K2(e,391652);c[e>>2]=57868;Ya(e|0,2712,367)}else{k=ZW(f<<2)|0;c[b>>2]=k;c[g>>2]=f|-2147483648;c[b+4>>2]=i;f=k;break}}else{a[g+3>>0]=i;f=b}while(0);a3(f,d,i);y7(f+(i<<2)|0,0);Ex(b,(a[j>>0]|0)<0?c[e>>2]|0:e,h)|0;return}function ns(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=l;l=l+32|0;f=h+16|0;g=h;b=Bk(a,b,f,h+12|0,d)|0;if(!(c[b>>2]|0)){TG(g,a,e);HH(a,c[f>>2]|0,b,c[g>>2]|0)}l=h;return}function os(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=vu(d,h,e)|0;e=c[g>>2]|0;if(!e){UH(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function ps(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;i=j+4|0;h=j;c[a+1092>>2]=0;b=c[a+1080>>2]|0;d=a+1084|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;g=e+-8|0;c[d>>2]=g;e=g}g=a+64|0;f=g;if((c[f>>2]|0)==0&(c[f+4>>2]|0)==0)c[a+508>>2]=0;f=a+764|0;b=c[a+760>>2]|0;d=i;while(1){c[d>>2]=b;e=c[i>>2]|0;if((e|0)==(f|0))break;a=g;if((c[a>>2]|0)==0&(c[a+4>>2]|0)==0)c[e+68>>2]=0;b=c[e+56>>2]|0;if(b|0)Kl(b);b=c[e+4>>2]|0;if(!b){d=e;while(1){b=c[d+8>>2]|0;if((c[b>>2]|0)==(d|0))break;else d=b}}else while(1){d=c[b>>2]|0;if(!d)break;else b=d}c[i>>2]=b;b=e;d=h}l=j;return}function qs(a){a=a|0;var b=0,d=0,e=0,f=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;m=l;l=l+16|0;b=m+12|0;d=m+8|0;j=m+4|0;k=m;ID(a,b);ID(a,d);ID(a,j);ID(a,k);n=a+528|0;o=n;o=z0(c[o>>2]|0,c[o+4>>2]|0,16,0)|0;c[n>>2]=o;c[n+4>>2]=z;if(((c[a+784>>2]|0)>>>0<=1?qO(a)|0:0)?(e=c[b>>2]|0,f=c[d>>2]|0,h=c[j>>2]|0,i=c[k>>2]|0,(e|0)!=0&(f|0)!=0&(h|0)!=0&(i|0)!=0):0){n=a+916|0;o=a+788|0;g[(bF(n,o)|0)+400>>2]=+(e>>>0)/+(f>>>0);g[(bF(n,o)|0)+404>>2]=+(h>>>0)/+(i>>>0)}l=m;return}function rs(a){a=a|0;var b=0,d=0,e=0;d=a+528|0;e=d;e=z0(c[e>>2]|0,c[e+4>>2]|0,4,0)|0;b=d;c[b>>2]=e;c[b+4>>2]=z;Bx(a);b=a+648|0;d4(c[b>>2]|0,3);A6(c[b>>2]|0);A6(c[b>>2]|0);A6(c[b>>2]|0);d4(c[b>>2]|0,2);d4(c[b>>2]|0,2);d4(c[b>>2]|0,3);d4(c[b>>2]|0,3);d4(c[b>>2]|0,3);d4(c[b>>2]|0,2);d4(c[b>>2]|0,2);A6(c[b>>2]|0);wK(a);b=d;b=z0(c[b>>2]|0,c[b+4>>2]|0,4,0)|0;a=d;c[a>>2]=b;c[a+4>>2]=z;return}function ss(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=ju(d,h,e)|0;e=c[g>>2]|0;if(!e){TH(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function ts(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0;b=l;l=l+80|0;j=b;k=b+64|0;h=b+44|0;n=b+40|0;a[k>>0]=a[402213]|0;a[k+1>>0]=a[402214]|0;a[k+2>>0]=a[402215]|0;a[k+3>>0]=a[402216]|0;a[k+4>>0]=a[402217]|0;a[k+5>>0]=a[402218]|0;i=b0()|0;c[j>>2]=g;g=dR(h,20,i,k,j)|0;k=h+g|0;i=kB(h,k,c[e+4>>2]|0)|0;O4(n,e);m=u$(c[n>>2]|0,409116)|0;c6(n);rb[c[(c[m>>2]|0)+32>>2]&7](m,h,k,j)|0;g=j+g|0;g=Qo(c[d>>2]|0,j,(i|0)==(k|0)?g:j+(i-h)|0,g,e,f)|0;l=b;return g|0}function us(a){a=+a;var b=0,d=0,e=0,f=0.0,h=0.0,i=0.0,k=0.0,l=0.0;b=(g[j>>2]=a,c[j>>2]|0);d=(b|0)<0;do if(b>>>0<8388608|d){if(!(b&2147483647)){a=-1.0/(a*a);break}if(d){a=(a-a)/0.0;break}else{d=-152;b=(g[j>>2]=a*33554432.0,c[j>>2]|0);e=9;break}}else if(b>>>0<=2139095039)if((b|0)==1065353216)a=0.0;else{d=-127;e=9}while(0);if((e|0)==9){e=b+4913933|0;l=(c[j>>2]=(e&8388607)+1060439283,+g[j>>2])+-1.0;k=l/(l+2.0);h=k*k;a=h*h;i=l*l*.5;f=(c[j>>2]=(g[j>>2]=l-i,c[j>>2]|0)&-4096,+g[j>>2]);a=l-f-i+k*(i+(h*(a*.2849878668785095+.6666666269302368)+a*(a*.24279078841209412+.40000972151756287)));h=+((e>>>23)+d|0);a=h*.3010292053222656+(f*.434326171875+(a*.434326171875+(h*7.903415166765626e-07-(f+a)*3.168997136526741e-05)))}return +a}function vs(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;g=b+612|0;h=b+544|0;e=c[b+548>>2]|0;b=c[g>>2]|0;a:while(1){d=b+3008|0;if(d>>>0>e>>>0)break;f=c[h>>2]|0;if((((((((((((((((a[f+b>>0]|0)==71?(a[f+(b+188)>>0]|0)==71:0)?(a[f+(b+376)>>0]|0)==71:0)?(a[f+(b+564)>>0]|0)==71:0)?(a[f+(b+752)>>0]|0)==71:0)?(a[f+(b+940)>>0]|0)==71:0)?(a[f+(b+1128)>>0]|0)==71:0)?(a[f+(b+1316)>>0]|0)==71:0)?(a[f+(b+1504)>>0]|0)==71:0)?(a[f+(b+1692)>>0]|0)==71:0)?(a[f+(b+1880)>>0]|0)==71:0)?(a[f+(b+2068)>>0]|0)==71:0)?(a[f+(b+2256)>>0]|0)==71:0)?(a[f+(b+2444)>>0]|0)==71:0)?(a[f+(b+2632)>>0]|0)==71:0)?(a[f+(b+2820)>>0]|0)==71:0)break;while(1){d=b+1|0;c[g>>2]=d;if((b+2|0)>>>0>e>>>0){b=d;continue a}if((a[f+d>>0]|0)==71){b=d;continue a}else b=d}}return d>>>0<e>>>0|0}function ws(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Nu(d,h,e)|0;e=c[g>>2]|0;if(!e){YG(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function xs(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;g=i;RB(b,2,c[b+20>>2]|0,122,8800948,-1,1,1);if((c[b+784>>2]|0)>>>0<=1?(d=b+916|0,e=b+788|0,h=bF(d,e)|0,(c[h+12>>2]|0)==(c[h+16>>2]|0)):0){h=ZW(1584)|0;on(h);aY(b,h);f=h+760|0;c[f>>2]=2;c[f+4>>2]=0;a[h+769>>0]=1;d=bF(d,e)|0;c[g>>2]=h;e=d+16|0;f=c[e>>2]|0;if(f>>>0<(c[d+20>>2]|0)>>>0){c[f>>2]=h;c[e>>2]=(c[e>>2]|0)+4}else Yy(d+12|0,g);a[b+761>>0]=1;rB(b,h)}l=i;return}function ys(a){a=a|0;var b=0,d=0,e=0,f=0;b=an(a)|0;d=z;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){f=a+800|0;c[f>>2]=b;c[f+4>>2]=d;switch(b|0){case 1:{if(!d)Kc(a,1,-1)|0;break}case 2:{if(!d)Kc(a,2,-1)|0;break}case 17:{if(!d)Kc(a,3,-1)|0;break}default:{}}b=a+840|0;f=b;if(!((c[f>>2]|0)==-1?(c[f+4>>2]|0)==-1:0)?(e=a+16|0,(c[e>>2]|0)!=7):0){f=kE(a+760|0,b)|0;c[f+36>>2]=c[e>>2];c[f+40>>2]=c[a+20>>2]}fc(a);Cn(a)}return}function zs(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;f=_s(d,h,e,f)|0;e=c[f>>2]|0;if(!e){dE(i,d,g);e=c[i>>2]|0;HH(d,c[h>>2]|0,f,e);f=1}else f=0;c[b>>2]=e;a[b+4>>0]=f;l=j;return}function As(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;f=_s(d,h,e,f)|0;e=c[f>>2]|0;if(!e){eE(i,d,g);e=c[i>>2]|0;HH(d,c[h>>2]|0,f,e);f=1}else f=0;c[b>>2]=e;a[b+4>>0]=f;l=j;return}function Bs(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[b+(f<<2)>>2]=0;f=f+1|0}h=a[d+8+3>>0]|0;g=h<<24>>24<0;h=g?c[d+4>>2]|0:h&255;i=i9(e)|0;g=g?c[d>>2]|0:d;f=h+i|0;if(f>>>0>1073741807)uaa();d=b+8|0;do if(f>>>0>=2){f=f+4&-4;if(f>>>0>1073741823){e=ua(8)|0;K2(e,391652);c[e>>2]=57868;Ya(e|0,2712,367)}else{j=ZW(f<<2)|0;c[b>>2]=j;c[d>>2]=f|-2147483648;c[b+4>>2]=h;f=j;break}}else{a[d+3>>0]=h;f=b}while(0);a3(f,g,h);y7(f+(h<<2)|0,0);Ex(b,e,i)|0;return}function Cs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=jo(d,h,e)|0;e=c[g>>2]|0;if(!e){yI(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function Ds(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=jo(d,h,e)|0;e=c[g>>2]|0;if(!e){DI(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function Es(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;g=n+8|0;k=n;YP(k,b);if(a[k>>0]|0){m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;h=c[m+24>>2]|0;i=c[m+4>>2]|0;j=d+1|0;f=m+76|0;e=c[f>>2]|0;if(d8(-1,e)|0){O4(g,m);e=u$(c[g>>2]|0,409116)|0;e=tb[c[(c[e>>2]|0)+28>>2]&31](e,32)|0;c6(g);e=e<<24>>24;c[f>>2]=e}if(!(Qo(h,d,(i&176|0)==32?j:d,j,m,e&255)|0)){m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(m,c[m+16>>2]|5)}}TC(k);l=n;return b|0}function Fs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;T5(a);f=d<<24>>24!=0;if(f)T5(a);e=a+648|0;d=0;while(1){if(d>>>0>b>>>0)break;if(K6(c[e>>2]|0)|0){GC(a);A6(c[e>>2]|0);L5(a);L5(a);J3(a)}else A6(c[e>>2]|0);d=d+1|0}do if(f)if(K6(c[e>>2]|0)|0){GC(a);A6(c[e>>2]|0);L5(a);L5(a);J3(a);break}else{A6(c[e>>2]|0);break}while(0);return}function Gs(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=l;l=l+16|0;j=i+3|0;e=i+2|0;f=i+1|0;g=i;NB(b,b+776|0);Bx(b);AT(b,j);AT(b,e);AT(b,f);d4(c[b+648>>2]|0,5);wK(b);h=b+528|0;if(a[j>>0]|0){k=h;k=z0(c[k>>2]|0,c[k+4>>2]|0,2,0)|0;j=h;c[j>>2]=k;c[j+4>>2]=z}if(a[e>>0]|0){bB(b,g);iF(b,d[g>>0]|0,0)}if(a[f>>0]|0){j=h;j=z0(c[j>>2]|0,c[j+4>>2]|0,2,0)|0;k=h;c[k>>2]=j;c[k+4>>2]=z}if(qO(b)|0)o7(b);l=i;return}function Hs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+32|0;d=h;e=c[a>>2]|0;f=(c[a+4>>2]|0)-e>>5;g=f+1|0;if(g>>>0>134217727)uaa();else{i=(c[a+8>>2]|0)-e|0;e=i>>4;tE(d,i>>5>>>0<67108863?(e>>>0<g>>>0?g:e):134217727,f,a+8|0);g=d+8|0;f=c[g>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];c[g>>2]=f+32;rA(a,d);zQ(d);l=h;return}}function Is(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;a=l;l=l+224|0;j=a+8|0;o=a;m=a+192|0;i=a+188|0;h=a+184|0;k=a+180|0;n=o;c[n>>2]=37;c[n+4>>2]=0;n=d+4|0;tF(o+1|0,404794,0,c[n>>2]|0);p=b0()|0;q=j;c[q>>2]=f;c[q+4>>2]=g;g=m+(dR(m,23,p,o,j)|0)|0;f=kB(m,g,c[n>>2]|0)|0;O4(k,d);zi(m,f,g,j,i,h,k);c6(k);g=bn(c[b>>2]|0,j,c[i>>2]|0,c[h>>2]|0,d,e)|0;l=a;return g|0}function Js(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;a=l;l=l+224|0;j=a+8|0;o=a;m=a+192|0;i=a+188|0;h=a+184|0;k=a+180|0;n=o;c[n>>2]=37;c[n+4>>2]=0;n=d+4|0;tF(o+1|0,404794,1,c[n>>2]|0);p=b0()|0;q=j;c[q>>2]=f;c[q+4>>2]=g;g=m+(dR(m,23,p,o,j)|0)|0;f=kB(m,g,c[n>>2]|0)|0;O4(k,d);zi(m,f,g,j,i,h,k);c6(k);g=bn(c[b>>2]|0,j,c[i>>2]|0,c[h>>2]|0,d,e)|0;l=a;return g|0}function Ks(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(((h-d|0)/24|0)>>>0<b>>>0){f=c[a>>2]|0;d=(d-f|0)/24|0;e=d+b|0;if(e>>>0>178956970)uaa();else{f=(h-f|0)/24|0;h=f<<1;zD(g,f>>>0<89478485?(h>>>0<e>>>0?e:h):178956970,d,a+8|0);nK(g,b);Lz(a,g);rP(g);break}}else HK(a,b);while(0);l=i;return}function Ls(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;i=j;W0(i,b+360|0);h=b+20|0;f=c[h>>2]|0;if(!f)d=0;else{Oc(f,d,e);d=b+24|0;if(a[d>>0]|0?(g=c[h>>2]|0,c[g+728>>2]&1|0):0){c[h>>2]=wN(g)|0;if(g|0)jb[c[(c[g>>2]|0)+4>>2]&511](g);a[d>>0]=0}d=c[h>>2]|0;g=d+64|0;if(!((c[g>>2]|0)==-1?(c[g+4>>2]|0)==-1:0)){b=SR(b+80|0)|0;d=c[h>>2]|0;if(!b){jt(d);d=c[h>>2]|0;h=d+64|0;c[h>>2]=-1;c[h+4>>2]=-1}}d=c[d+728>>2]|0}s7(c[i>>2]|0);l=j;return d|0}function Ms(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;a=l;l=l+96|0;j=a+8|0;o=a;m=a+64|0;i=a+60|0;h=a+56|0;k=a+52|0;n=o;c[n>>2]=37;c[n+4>>2]=0;n=d+4|0;tF(o+1|0,404794,0,c[n>>2]|0);p=b0()|0;q=j;c[q>>2]=f;c[q+4>>2]=g;g=m+(dR(m,23,p,o,j)|0)|0;f=kB(m,g,c[n>>2]|0)|0;O4(k,d);Di(m,f,g,j,i,h,k);c6(k);g=Qo(c[b>>2]|0,j,c[i>>2]|0,c[h>>2]|0,d,e)|0;l=a;return g|0}function Ns(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;a=l;l=l+96|0;j=a+8|0;o=a;m=a+64|0;i=a+60|0;h=a+56|0;k=a+52|0;n=o;c[n>>2]=37;c[n+4>>2]=0;n=d+4|0;tF(o+1|0,404794,1,c[n>>2]|0);p=b0()|0;q=j;c[q>>2]=f;c[q+4>>2]=g;g=m+(dR(m,23,p,o,j)|0)|0;f=kB(m,g,c[n>>2]|0)|0;O4(k,d);Di(m,f,g,j,i,h,k);c6(k);g=Qo(c[b>>2]|0,j,c[i>>2]|0,c[h>>2]|0,d,e)|0;l=a;return g|0}function Os(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;h=l;l=l+16|0;e=h+1|0;f=h;a[e>>0]=0;a[f>>0]=0;GC(b);xR(b,2,e);xR(b,2,f);d=a[e>>0]|0;switch(d<<24>>24){case 1:{a[e>>0]=8;d=8;break}case 2:{a[e>>0]=32;d=32;break}case 3:{a[e>>0]=-128;d=-128;break}default:{}}switch(a[f>>0]|0){case 0:{a[f>>0]=0;G4(c[b+648>>2]|0,d&255);break}case 1:{a[f>>0]=8;g=10;break}case 2:{a[f>>0]=32;g=10;break}case 3:{a[f>>0]=-128;g=10;break}default:g=10}if((g|0)==10){g=d&255;f=b+648|0;G4(c[f>>2]|0,g);G4(c[f>>2]|0,g)}J3(b);l=h;return}function Ps(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+48|0;i=j+16|0;g=j;h=j+32|0;if(fs(401459,114,4)|0){d=Ub(1156)|0;if(!d)d=0;else{e=d;f=e+124|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));if(!(d3(391569,43)|0)){c[d>>2]=8;e=8}else e=0;if(d3(391569,101)|0){c[g>>2]=b;c[g+4>>2]=2;c[g+8>>2]=1;ma(221,g|0)|0;e=c[d>>2]|0}c[d+60>>2]=b;c[d+44>>2]=d+132;c[d+48>>2]=1024;f=d+75|0;a[f>>0]=-1;if((e&8|0)==0?(c[i>>2]=b,c[i+4>>2]=21523,c[i+8>>2]=h,(Ta(54,i|0)|0)==0):0)a[f>>0]=10;c[d+32>>2]=25;c[d+36>>2]=8;c[d+40>>2]=9;c[d+12>>2]=79;if(!(c[102245]|0))c[d+76>>2]=-1;ZZ(d)|0}}else{c[12784]=22;d=0}l=j;return d|0}function Qs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=a+32|0;Sh(a,a+16|0,d)|0;f=a+48|0;while(1){if((f|0)==(b|0))break;g=f+8|0;j=c[g>>2]|0;g=c[g+4>>2]|0;i=d+8|0;if(M$(j,g,c[i>>2]|0,c[i+4>>2]|0)|0){i=f;h=c[i>>2]|0;i=c[i+4>>2]|0;e=f;while(1){c[e>>2]=c[d>>2];c[e+4>>2]=c[d+4>>2];c[e+8>>2]=c[d+8>>2];c[e+12>>2]=c[d+12>>2];if((d|0)==(a|0)){d=a;break}e=d+-8|0;if(M$(j,g,c[e>>2]|0,c[e+4>>2]|0)|0){e=d;d=d+-16|0}else break}e=d;c[e>>2]=h;c[e+4>>2]=i;i=d+8|0;c[i>>2]=j;c[i+4>>2]=g}d=f;f=f+16|0}return}function Rs(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+32|0;i=k;j=c[a+8>>2]|0;h=a+4|0;e=c[h>>2]|0;g=e;do if(j-e>>3>>>0<b>>>0){g=c[a>>2]|0;e=e-g>>3;f=e+b|0;if(f>>>0>536870911)uaa();else{h=j-g|0;j=h>>2;EF(i,h>>3>>>0<268435455?(j>>>0<f>>>0?f:j):536870911,e,a+8|0);WK(i,b,d);_A(a,i);xS(i);break}}else{e=b;f=g;while(1){a=d;i=c[a+4>>2]|0;j=f;c[j>>2]=c[a>>2];c[j+4>>2]=i;e=e+-1|0;if(!e)break;else f=f+8|0}c[h>>2]=g+(b<<3)}while(0);l=k;return}function Ss(d){d=d|0;var e=0,f=0,g=0;e=d+4|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;x1(d+28|0);x1(d+40|0);c[d>>2]=0;c[d+52>>2]=7;c[d+56>>2]=7;c[d+60>>2]=-1;c[d+64>>2]=0;a[d+68>>0]=0;a[d+69>>0]=0;h[d+72>>3]=0.0;e=d+80|0;c[e>>2]=-1;c[e+4>>2]=-1;c[e+8>>2]=-1;c[e+12>>2]=-1;c[e+16>>2]=-1;c[e+20>>2]=-1;c[e+24>>2]=-1;c[e+28>>2]=-1;b[d+112>>1]=0;a[d+114>>0]=0;e=d+168|0;f=d+120|0;g=f+48|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));a[e>>0]=-1;a[d+169>>0]=-1;a[d+170>>0]=-1;e=d+188|0;f=d+171|0;g=f+15|0;do{a[f>>0]=0;f=f+1|0}while((f|0)<(g|0));g=e;c[g>>2]=0;c[g+4>>2]=0;return}function Ts(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;h=b+8|0;l=h+3|0;g=a[l>>0]|0;i=g<<24>>24<0;m=b+4|0;if(i)j=c[m>>2]|0;else j=g&255;if(j>>>0<d>>>0)uaa();if(i)g=(c[h>>2]&2147483647)+-1|0;else g=1;k=j+f|0;if((g-j|0)>>>0>=f>>>0){if(f|0){if(i)i=c[b>>2]|0;else i=b;g=j-d|0;h=i+(d<<2)|0;if(g){W2(h+(f<<2)|0,h,g);e=h>>>0<=e>>>0&(i+(j<<2)|0)>>>0>e>>>0?e+(f<<2)|0:e}W2(h,e,f);if((a[l>>0]|0)<0)c[m>>2]=k;else a[l>>0]=k;y7(i+(k<<2)|0,0)}}else at(b,g,k-g|0,j,d,0,f,e);return b|0}function Us(b){b=b|0;var e=0,f=0,g=0,h=0,i=0;g=l;l=l+16|0;h=g+1|0;e=g;Bx(b);i=b+648|0;d4(c[i>>2]|0,10);AT(b,h);A6(c[i>>2]|0);d4(c[i>>2]|0,4);wK(b);if(a[h>>0]|0){bB(b,e);iF(b,d[e>>0]|0,0)}i=b+520|0;e=c[i+4>>2]|0;switch(c[i>>2]|0){case 2:{if(!e)f=6;break}case 16:{if(!e)f=6;break}default:{}}if((f|0)==6){i=b+528|0;h=i;h=z0(c[h>>2]|0,c[h+4>>2]|0,5,0)|0;c[i>>2]=h;c[i+4>>2]=z}if(qO(b)|0)o7(b);l=g;return}function Vs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;k=a[b+11>>0]|0;j=k<<24>>24<0;i=b+4|0;g=c[i>>2]|0;k=k&255;do if((j?g:k)|0){if((d|0)!=(e|0)){g=e;h=d;while(1){g=g+-4|0;if(h>>>0>=g>>>0)break;m=c[h>>2]|0;c[h>>2]=c[g>>2];c[g>>2]=m;h=h+4|0}g=c[i>>2]|0}m=j?c[b>>2]|0:b;e=e+-4|0;b=m+(j?g:k)|0;g=m;while(1){h=a[g>>0]|0;i=h<<24>>24>0&h<<24>>24!=127;h=h<<24>>24;if(d>>>0>=e>>>0)break;if(i?(h|0)!=(c[d>>2]|0):0){l=10;break}d=d+4|0;g=(b-g|0)>1?g+1|0:g}if((l|0)==10){c[f>>2]=4;break}if(i?((c[e>>2]|0)+-1|0)>>>0>=h>>>0:0)c[f>>2]=4}while(0);return}function Ws(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+32|0;d=h;e=c[a>>2]|0;f=((c[a+4>>2]|0)-e|0)/24|0;g=f+1|0;if(g>>>0>178956970)uaa();else{i=((c[a+8>>2]|0)-e|0)/24|0;e=i<<1;zD(d,i>>>0<89478485?(e>>>0<g>>>0?g:e):178956970,f,a+8|0);g=d+8|0;f=c[g>>2]|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[g>>2]=f+24;Lz(a,d);rP(d);l=h;return}}function Xs(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Nu(d,h,e)|0;e=c[g>>2]|0;if(!e){fJ(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function Ys(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+16|0;h=k;j=k+2|0;i=e+536|0;do if((c[i>>2]|0)==15&(c[i+4>>2]|0)==0){f=(c[e+544>>2]|0)+(c[e+612>>2]|0)|0;if((A5(a[f>>0]|0,a[f+1>>0]|0)|0)<<16>>16==1?(i=f+4|0,(A5(a[i>>0]|0,a[i+1>>0]|0)|0)<<16>>16==10):0){g=5;break}e1(e,15,0)}else g=5;while(0);if((g|0)==5){NB(e,h);i=e+528|0;g=b[h>>1]|0;f=0;while(1){if((f&65535)>=(g&65535))break;m=i;m=z0(c[m>>2]|0,c[m+4>>2]|0,2,0)|0;h=i;c[h>>2]=m;c[h+4>>2]=z;bB(e,j);iF(e,d[j>>0]|0,0);f=f+1<<16>>16}}l=k;return}function Zs(a){a=a|0;var b=0,d=0,e=0;e=a+520|0;b=c[e+4>>2]|0;do switch(c[e>>2]|0){case 10:{if(b|0)d=16;break}case 11:{if(b|0)d=16;break}case 12:{if(b|0)d=16;break}case 13:{if(!b)Yd(a);else d=16;break}case 14:{if(!b)Mh(a);else d=16;break}case 15:{if(!b)Jd(a);else d=16;break}case 27:{if(b|0)d=16;break}case 28:{if(b|0)d=16;break}case 29:{if(b|0)d=16;break}case 30:{if(b|0)d=16;break}case 31:{if(b|0)d=16;break}default:d=16}while(0);if((d|0)==16)t4(a);return}function _s(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=a+4|0;g=c[f>>2]|0;do if(g){f=e8(a)|0;while(1){h=g+16|0;a=c[h>>2]|0;h=c[h+4>>2]|0;if(h>>>0>e>>>0|(h|0)==(e|0)&a>>>0>d>>>0){a=c[g>>2]|0;if(!a){a=5;break}else{f=g;g=a}}else{if(!(h>>>0<e>>>0|(h|0)==(e|0)&a>>>0<d>>>0)){a=10;break}f=g+4|0;a=c[f>>2]|0;if(!a){a=9;break}else g=a}}if((a|0)==5){c[b>>2]=g;f=g;break}else if((a|0)==9){c[b>>2]=g;break}else if((a|0)==10){c[b>>2]=g;break}}else c[b>>2]=f;while(0);return f|0}function $s(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;k=l;l=l+32|0;b=k+12|0;d=k;e=k+27|0;f=k+26|0;g=k+25|0;h=k+24|0;TX(b);i=a+528|0;j=a+536|0;while(1){n=i;p=c[n+4>>2]|0;m=j;o=c[m+4>>2]|0;if(!(p>>>0<o>>>0|((p|0)==(o|0)?(c[n>>2]|0)>>>0<(c[m>>2]|0)>>>0:0)))break;GC(a);TX(d);jZ(a,3,0,d);Bx(a);xR(a,5,e);xR(a,3,f);xR(a,4,g);xR(a,4,h);wK(a);J3(a);z5(d)}z5(b);l=k;return}function at(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;if((1073741806-d|0)>>>0<e>>>0)uaa();m=b+8|0;if((a[m+3>>0]|0)<0)o=c[b>>2]|0;else o=b;if(d>>>0<536870887){e=e+d|0;l=d<<1;e=e>>>0<l>>>0?l:e;e=e>>>0<2?2:e+4&-4;if(e>>>0>1073741823)ra();else n=e}else n=1073741807;k=ZW(n<<2)|0;if(g|0)a3(k,o,g);l=k+(g<<2)|0;if(i|0)a3(l,j,i);e=f-h|0;f=e-g|0;if(f|0)a3(l+(i<<2)|0,o+(g<<2)+(h<<2)|0,f);if((d|0)!=1)laa(o);c[b>>2]=k;c[m>>2]=n|-2147483648;i=e+i|0;c[b+4>>2]=i;y7(k+(i<<2)|0,0);return}function bt(a){a=a|0;var b=0,d=0;c[a>>2]=5464;jaa(c[a+600>>2]|0);jaa(c[a+268>>2]|0);b=c[a+648>>2]|0;if(b|0)laa(b);b=c[a+652>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);aU(a+736|0);aU(a+716|0);aU(a+704|0);v_(a+680|0);wR(a+668|0);z5(a+480|0);b=a+380|0;d=a+476|0;do{d=d+-12|0;tO(d)}while((d|0)!=(b|0));aU(a+252|0);aU(a+240|0);z5(a+84|0);a1(a+72|0);EK(a);return}function ct(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;k=n+4|0;m=n;GC(b);j=e&f;c[k>>2]=j?369067:369115;c[m>>2]=j?369239:369287;j=b+22116|0;i=e&1;h=b+648|0;g=0;f=c[j>>2]|0;while(1){if((g|0)>=(d[f+27+i>>0]|0))break;a:do if(!(a[f+37+(i<<1)+g>>0]|0)){d4(c[h>>2]|0,5);e=1;while(1){f=c[j>>2]|0;if((e&255)>=(d[f+41>>0]|0))break a;DK(b,m);e=e+1<<24>>24}}else{e=0;while(1){if((e&255)>=(d[f+41>>0]|0))break a;DK(b,k);e=e+1<<24>>24;f=c[j>>2]|0}}while(0);g=g+1|0}J3(b);l=n;return}function dt(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;f=_s(d,h,e,f)|0;e=c[f>>2]|0;if(!e){RE(i,d,g);e=c[i>>2]|0;HH(d,c[h>>2]|0,f,e);f=1}else f=0;c[b>>2]=e;a[b+4>>0]=f;l=j;return}function et(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;f=_s(d,h,e,f)|0;e=c[f>>2]|0;if(!e){uG(i,d,g);e=c[i>>2]|0;HH(d,c[h>>2]|0,f,e);f=1}else f=0;c[b>>2]=e;a[b+4>>0]=f;l=j;return}function ft(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;h=l;l=l+64|0;d=h+16|0;e=h+32|0;f=h+40|0;g=h;if(!(a[b+495>>0]|0)){L2(d);j0(b,d);Uy(b,e);i=d+8|0;j=c[i>>2]|0;i=c[i+4>>2]|0;TX(f);dX(g,c[d>>2]|0,c[d+4>>2]|0,j,i);dh(f,g)|0;BZ(c[b+508>>2]|0,c[b+668>>2]|0,j,i);z5(f);g=e;Op(b,c[g>>2]|0,c[g+4>>2]|0)}else{VU(d,379956);BZ(c[b+508>>2]|0,c[b+668>>2]|0,0,0);z5(d);Op(b,c[b+816>>2]|0,0)}l=h;return}function gt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(((h-d|0)/24|0)>>>0<b>>>0){f=c[a>>2]|0;d=(d-f|0)/24|0;e=d+b|0;if(e>>>0>178956970)uaa();else{f=(h-f|0)/24|0;h=f<<1;zD(g,f>>>0<89478485?(h>>>0<e>>>0?e:h):178956970,d,a+8|0);vI(g,b);Qy(a,g);eO(g);break}}else YI(a,b);while(0);l=i;return}function ht(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(((h-d|0)/120|0)>>>0<b>>>0){f=c[a>>2]|0;d=(d-f|0)/120|0;e=d+b|0;if(e>>>0>35791394)uaa();else{f=(h-f|0)/120|0;h=f<<1;tD(g,f>>>0<17895697?(h>>>0<e>>>0?e:h):35791394,d,a+8|0);GP(g,b);Ny(a,g);XN(g);break}}else gQ(a,b);while(0);l=i;return}function it(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;d=c[a>>2]|0;j=a+4|0;while(1){e=c[j>>2]|0;if((e|0)==(d|0))break;i=e+-40|0;c[j>>2]=i;$_(i)}i=b+4|0;hE(a,((c[i>>2]|0)-(c[b>>2]|0)|0)/40|0);e=a+24|0;f=a+36|0;g=a+52|0;d=0;while(1){h=c[b>>2]|0;if(d>>>0>=(((c[i>>2]|0)-h|0)/40|0)>>>0)break;Mx(a,h+(d*40|0)|0);h=c[a>>2]|0;z3(h+(((((c[j>>2]|0)-h|0)/40|0)+-1|0)*40|0)|0,e);h=c[a>>2]|0;Q3(h+(((((c[j>>2]|0)-h|0)/40|0)+-1|0)*40|0)|0,f);h=c[a>>2]|0;s5(h+(((((c[j>>2]|0)-h|0)/40|0)+-1|0)*40|0)|0,c[g>>2]|0);d=d+1|0}return a|0}function jt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;b=a+728|0;a:do if(((((c[b>>2]&11|0)==1?(jb[c[(c[a>>2]|0)+52>>2]&511](a),c[b>>2]=c[b>>2]|6,b=a+40|0,(c[b>>2]|0)==-1?(c[b+4>>2]|0)==-1:0):0)?(e=a+136|0,d=c[e>>2]|0,e=c[e+4>>2]|0,!((d|0)==-1&(e|0)==-1)):0)?(g=a+280|0,f=c[g>>2]|0,g=c[g+4>>2]|0,!((f|0)==-1&(g|0)==-1)):0)?(h=D_(d|0,e|0,f|0,g|0)|0,i=z,!((h|0)==0&(i|0)==0)):0){b=a+16|0;d=c[b>>2]|0;switch(d|0){case 7:case 0:break a;default:{}}g=a+552|0;g=UW(c[g>>2]|0,c[g+4>>2]|0,-589934592,1)|0;i=g5(g|0,z|0,h|0,i|0)|0;aL(a,d,0,357081,i,z,0);Ou(a,c[b>>2]|0,0,357081,357103)}while(0);return}function kt(a){a=a|0;var b=0,d=0,e=0;e=l;l=l+16|0;b=e;r3(a,b);b=c[b>>2]|0;a:do if((b|0)>=1852009571)if((b|0)<1886547814){switch(b|0){case 1852009571:break;default:{d=5;break a}}Kn(a,0);break}else{switch(b|0){case 1886547814:break;default:{d=5;break a}}gV(a);break}else{switch(b|0){case 1668047726:break;default:{d=5;break a}}Kn(a,1)}while(0);if((d|0)==5){b=a+536|0;d=a+528|0;d=D_(c[b>>2]|0,c[b+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e1(a,d,z)}l=e;return}function lt(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;GC(b);g=jF(b+760|0,b+772|0)|0;h=c[c[g>>2]>>2]|0;a[h+769>>0]=0;a[h+770>>0]=0;a[h+733>>0]=1;f=b+528|0;e=f;d=c[e>>2]|0;e=c[e+4>>2]|0;rB(b,h);if(!(c[h+728>>2]&1)){h=f;c[h>>2]=d;c[h+4>>2]=e;d=c[c[g>>2]>>2]|0;if(d|0)jb[c[(c[d>>2]|0)+4>>2]&511](d);h=ZW(1056)|0;Mr(h);c[c[g>>2]>>2]=h;h=c[c[g>>2]>>2]|0;aY(b,h);a[h+768>>0]=1;a[h+769>>0]=1;a[h+770>>0]=1;a[h+733>>0]=0;rB(b,h)}J3(b);return}function mt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;h=l;l=l+32|0;g=h+12|0;e=h;if((b|0)<=6?(f=a+4|0,i=c[c[f>>2]>>2]|0,(((c[i+(b*12|0)+4>>2]|0)-(c[i+(b*12|0)>>2]|0)|0)/40|0)>>>0>d>>>0):0){TX(e);p2(g,cC(e,390999)|0);z5(e);e=Sx(vn(b)|0,g,0)|0;if((e|0)==-1){e=(c[(c[c[a+8>>2]>>2]|0)+(b*12|0)>>2]|0)+(d*56|0)|0;a=Sx(e,g,0)|0;if((a|0)==-1)e=408444;else e=wF(e,a,1)|0}else e=DN((c[(c[c[f>>2]>>2]|0)+(b*12|0)>>2]|0)+(d*40|0)|0,e)|0;z5(g)}else e=408444;l=h;return e|0}function nt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[b+(f<<2)>>2]=0;f=f+1|0}h=a[d+8+3>>0]|0;g=h<<24>>24<0;h=g?c[d+4>>2]|0:h&255;g=g?c[d>>2]|0:d;f=h+1|0;if(f>>>0>1073741807)uaa();d=b+8|0;do if(f>>>0>=2){f=h+5&-4;if(f>>>0>1073741823){e=ua(8)|0;K2(e,391652);c[e>>2]=57868;Ya(e|0,2712,367)}else{i=ZW(f<<2)|0;c[b>>2]=i;c[d>>2]=f|-2147483648;c[b+4>>2]=h;f=i;break}}else{a[d+3>>0]=h;f=b}while(0);a3(f,g,h);y7(f+(h<<2)|0,0);Gx(b,e);return}function ot(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Nu(d,h,e)|0;e=c[g>>2]|0;if(!e){XJ(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function pt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Xu(d,h,e)|0;e=c[g>>2]|0;if(!e){AI(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function qt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Yu(d,h,e)|0;e=c[g>>2]|0;if(!e){bK(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function rt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(((h-d|0)/24|0)>>>0<b>>>0){f=c[a>>2]|0;d=(d-f|0)/24|0;e=d+b|0;if(e>>>0>178956970)uaa();else{f=(h-f|0)/24|0;h=f<<1;zD(g,f>>>0<89478485?(h>>>0<e>>>0?e:h):178956970,d,a+8|0);UP(g,b);Wy(a,g);hO(g);break}}else AQ(a,b);while(0);l=i;return}function st(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=l;l=l+32|0;f=h+16|0;g=h;b=Hh(a,b,f,h+12|0,d)|0;if(!(c[b>>2]|0)){nL(g,a,e);HH(a,c[f>>2]|0,b,c[g>>2]|0)}l=h;return}function tt(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;h=b+776|0;g=b+780|0;d=c[h>>2]|0;a:while(1){if((d|0)==(g|0))break;e=d+24|0;f=c[e>>2]|0;if(f|0){G2(b,f);Gb(b,c[e>>2]|0,c[d+28>>2]|0,0,c[d+32>>2]|0,1)|0;Gb(b,c[e>>2]|0,0,0,0,1)|0}e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue a}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}d=a[b+36+3>>0]|0;if(d<<24>>24<0)d=c[b+32>>2]|0;else d=d&255;if(d|0)PM(h);return}function ut(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=b+4|0;i=c[e>>2]|0;j=i&7;g=b+12|0;if(i>>>0<32){c[e>>2]=0;a[b+13>>0]=1;e=0}else{i=c[b>>2]|0;h=32-j|0;f=i;if(!j){e=0;k=5}else{e=(d[g>>0]|0)<<h;switch(h+-1>>3|0){case 3:{k=5;break}case 2:{g=h;k=6;break}case 1:{g=h;k=7;break}default:g=h}}if((k|0)==5){e=(d[f>>0]|0)<<(h+248&255)|e;f=f+1|0;c[b>>2]=f;g=h+-8|0;k=6}if((k|0)==6){e=(d[f>>0]|0)<<(g+248&255)|e;f=f+1|0;c[b>>2]=f;g=(g&255)+-8|0;k=7}if((k|0)==7){g=g+248|0;e=(d[f>>0]|0)<<(g&255)|e;f=f+1|0;c[b>>2]=f}e=(d[f>>0]|0)>>>j&c[5676+((g&255)<<2)>>2]|e;c[b>>2]=i}return e|0}function vt(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=b+536|0;e=c[f+4>>2]|0;d=b+528|0;c[d>>2]=c[f>>2];c[d+4>>2]=e;YZ(c[b+648>>2]|0,0,0);d=c[b+508>>2]|0;e=c[b+668>>2]|0;f=e+(d*24|0)+17|0;h=b+500|0;i=b+728|0;do if(!(a[f>>0]|0)){if(!(a[e+(d*24|0)+18>>0]|0)){c3(d,e);break}a[f>>0]=1;a[b+376>>0]=0;d=c[i>>2]|0;if(!(d&2)){g=c[h>>2]|0;e=g+-1|0;if(!g){k=d;g=10}else{c[h>>2]=e;j=e;g=8}}else g=7}else g=7;while(0);if((g|0)==7){j=c[h>>2]|0;g=8}if((g|0)==8?(j|0)==0:0){k=c[i>>2]|0;g=10}if((g|0)==10?(k&1|0)==0:0)z$(b);return}function wt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(((h-d|0)/12|0)>>>0<b>>>0){f=c[a>>2]|0;d=(d-f|0)/12|0;e=d+b|0;if(e>>>0>357913941)uaa();else{f=(h-f|0)/12|0;h=f<<1;xE(g,f>>>0<178956970?(h>>>0<e>>>0?e:h):357913941,d,a+8|0);gM(g,b);Sy(a,g);bO(g);break}}else CM(a,b);while(0);l=i;return}function xt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=l;l=l+16|0;b=h+4|0;g=c[a+520>>2]&-65536;c[a+772>>2]=g;if((g|0)==1769472e3){HB(a,h+8|0);bB(a,h+10|0);bB(a,h+11|0);bD(a,b);r3(a,h);g=a+528|0;e=g;e=z0(c[e>>2]|0,c[e+4>>2]|0,12,0)|0;f=z;d=g;c[d>>2]=e;c[d+4>>2]=f;d=c[b>>2]|0;b=0;while(1){if((b|0)==(d|0))break;j=z0(e|0,f|0,24,0)|0;i=z;k=g;c[k>>2]=j;c[k+4>>2]=i;b=b+1|0;e=j;f=i}}BL(a+776|0);l=h;return}function yt(b){b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;f=e;KK(b);Bx(b);RS(b);AT(b,f);d=b+648|0;A6(c[d>>2]|0);A6(c[d>>2]|0);A6(c[d>>2]|0);A6(c[d>>2]|0);A6(c[d>>2]|0);A6(c[d>>2]|0);if(a[f>>0]|0){A6(c[d>>2]|0);A6(c[d>>2]|0);A6(c[d>>2]|0);A6(c[d>>2]|0);d4(c[d>>2]|0,4)}wK(b);l=e;return}function zt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(((h-d|0)/3|0)>>>0<b>>>0){f=c[a>>2]|0;d=(d-f|0)/3|0;e=d+b|0;if(e>>>0>1431655765)uaa();else{f=(h-f|0)/3|0;h=f<<1;TD(g,f>>>0<715827882?(h>>>0<e>>>0?e:h):1431655765,d,a+8|0);IQ(g,b);dA(a,g);qQ(g);break}}else mR(a,b);while(0);l=i;return}function At(b,f){b=b|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=f&255;j=b+4|0;g=c[j>>2]|0;h=g&7;k=57960+(f<<1)|0;l=b+12|0;m=g-f|0;i=m&7;do if(f>>>0>h>>>0){if(g>>>0<f>>>0){c[j>>2]=0;a[b+13>>0]=1;f=0;break}h=f-h|0;g=h&255;if((g|0)!=16){f=(d[l>>0]|0)<<g;if((g+-1|0)>>>0>7)n=8;else g=c[b>>2]|0}else{f=0;n=8}if((n|0)==8){n=c[b>>2]|0;f=(d[n>>0]|0)<<(h+248&255)|f&65535;n=n+1|0;c[b>>2]=n;h=g+-8|0;g=n}n=a[g>>0]|0;a[l>>0]=n;c[b>>2]=g+1;c[j>>2]=m;f=((e[57960+((h&255)<<1)>>1]|0)&(n&255)>>>i|f)&(e[k>>1]|0)&65535}else{c[j>>2]=m;f=(d[l>>0]|0)>>>i&(e[k>>1]|0)&65535}while(0);return f|0}function Bt(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;var h=0.0,i=0.0,j=0,k=0,m=0.0;k=l;l=l+16|0;j=k;if((b|0)==1&(d|0)==171?(Ed(a,1,c,173),Ed(a,1,c,174),e!=0.0):0){h=+(r6(e)|0);i=e;m=h-i*1.001;if(m>-2.0e-06&m<2.0e-06){Bt(a,1,c,173,e*1001.0,0,g);sM(a,1,c,174,1001,g)}m=h-i*1.001001;if(m>-2.0e-06&m<2.0e-06){Bt(a,1,c,173,e*1.0e3,0,g);sM(a,1,c,174,1e3,g)}}ST(j,e,f);zb(a,b,c,d,j,g);z5(j);l=k;return}function Ct(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=l;l=l+64|0;e=i+48|0;f=i+32|0;g=i+16|0;h=i;if(!(VX(b)|0))if((d+-2|0)>>>0>35)b=391619;else{Ow(8799652,0,256)|0;L2(e);j=b;b=b+8|0;dX(f,c[j>>2]|0,c[j+4>>2]|0,c[b>>2]|0,c[b+4>>2]|0);b=255;while(1){if(!((b|0)!=0&((VX(f)|0)^1)))break;F_(h,d);oj(g,f,h,e);c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];k=e;k=g9(c[k>>2]|0,c[k+4>>2]|0)|0;j=b+-1|0;a[8799652+j>>0]=(k>>>0>9?55:48)+k;b=j}b=8799652+b|0}else b=401470;l=i;return b|0}function Dt(d){d=d|0;var e=0;Eg(d);e=d+760|0;BG(e);c[d>>2]=10628;x1(d+22124|0);x1(d+22136|0);c[e>>2]=d;a[d+733>>0]=1;e=d+632|0;c[e>>2]=65536;c[e+4>>2]=0;a[d+96>>0]=1;a[d+493>>0]=1;e=d+896|0;c[e>>2]=0;c[e+4>>2]=0;a[d+904>>0]=0;c[d+908>>2]=0;a[d+2462>>0]=-1;a[d+2463>>0]=-1;a[d+2464>>0]=-1;b[d+2466>>1]=1024;a[d+2468>>0]=-1;a[d+2469>>0]=-1;c[d+2472>>2]=-1;a[d+2478>>0]=0;a[d+2477>>0]=0;a[d+2476>>0]=0;e=d+2488|0;c[e>>2]=-1;c[e+4>>2]=-1;e=d+2496|0;c[e>>2]=0;c[e+4>>2]=0;a[d+2504>>0]=0;a[d+912>>0]=1;a[d+917>>0]=0;c[d+22116>>2]=0;c[d+22120>>2]=0;a[d+22148>>0]=1;return}function Et(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;m=l;l=l+32|0;f=m+24|0;e=m+20|0;g=m+16|0;h=m+12|0;n=m+28|0;i=m+8|0;j=m+4|0;k=m;mk(n,b);if(a[n>>0]|0){c[i>>2]=0;O4(k,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);o=u$(c[k>>2]|0,409164)|0;n=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;p=c[(c[o>>2]|0)+16>>2]|0;c[g>>2]=c[n+24>>2];c[h>>2]=0;c[e>>2]=c[g>>2];c[f>>2]=c[h>>2];lb[p&63](o,e,f,n,i,j)|0;c6(k);c[d>>2]=c[j>>2];n=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(n,c[n+16>>2]|c[i>>2])}l=m;return b|0}function Ft(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=e+16|0;g=c[f>>2]|0;if(!g)if(!(pN(e)|0)){g=c[f>>2]|0;h=5}else f=0;else h=5;a:do if((h|0)==5){j=e+20|0;i=c[j>>2]|0;f=i;if((g-i|0)>>>0<d>>>0){f=gb[c[e+36>>2]&31](e,b,d)|0;break}b:do if((a[e+75>>0]|0)>-1){i=d;while(1){if(!i){h=0;g=b;break b}g=i+-1|0;if((a[b+g>>0]|0)==10)break;else i=g}f=gb[c[e+36>>2]&31](e,b,i)|0;if(f>>>0<i>>>0)break a;h=i;g=b+i|0;d=d-i|0;f=c[j>>2]|0}else{h=0;g=b}while(0);no(f|0,g|0,d|0)|0;c[j>>2]=(c[j>>2]|0)+d;f=h+d|0}while(0);return f|0}function Gt(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i;hP(b);c[b>>2]=4836;g=b+28|0;h=b+52|0;d=g;e=d+36|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));d=0;while(1){if((d|0)==3)break;c[h+(d<<2)>>2]=0;d=d+1|0}TX(b+64|0);Xn(b+80|0);h=b+360|0;q2(h);W0(f,h);zm();h=b+352|0;c[h>>2]=2;c[b+20>>2]=0;a[b+24>>0]=0;iC(g);TB(b+40|0);a[b+16>>0]=1;a[b+17>>0]=1;c[h>>2]=0;a[b+356>>0]=0;s7(c[f>>2]|0);l=i;return}function Ht(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=b+4|0;g=c[f>>2]|0;do if(g){f=e8(b)|0;while(1){b=a[g+13>>0]|0;if((b&255)>(e&255)){b=c[g>>2]|0;if(!b){b=6;break}else{f=g;g=b}}else{if((b&255)>=(e&255)){b=10;break}f=g+4|0;b=c[f>>2]|0;if(!b){b=9;break}else g=b}}if((b|0)==6){c[d>>2]=g;f=g;break}else if((b|0)==9){c[d>>2]=g;break}else if((b|0)==10){c[d>>2]=g;break}}else c[d>>2]=f;while(0);return f|0}function It(a){a=a|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=l;l=l+16|0;d=j;g=a+528|0;f=g;i=a+536|0;h=i;if(!((c[f>>2]|0)==(c[h>>2]|0)?(c[f+4>>2]|0)==(c[h+4>>2]|0):0)){iF(a,7,0);f=g;f=z0(c[f>>2]|0,c[f+4>>2]|0,1,0)|0;k=g;c[k>>2]=f;c[k+4>>2]=z;HB(a,d);k=(b[d>>1]|0)==3;d=g;f=c[d>>2]|0;d=c[d+4>>2]|0;h=z0(f|0,d|0,54,0)|0;e=z;if(k){c[g>>2]=h;c[g+4>>2]=e;g=e;f=h}else g=d;e=i;d=c[e>>2]|0;e=c[e+4>>2]|0;if(e>>>0>g>>>0|(e|0)==(g|0)&d>>>0>f>>>0){k=D_(d|0,e|0,f|0,g|0)|0;e1(a,k,z)}}l=j;return}function Jt(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0.0;d=b+896|0;e=d;if((c[e>>2]|0)==0&(c[e+4>>2]|0)==0){j=+g[(c[b+24>>2]|0)+136>>2];i=!(j>=.5);h=j>=.3;e=d;c[e>>2]=i?(h?32:8):128;c[e+4>>2]=i?(h?0:0):0}e=b+908|0;d=c[e>>2]|0;switch(d|0){case 3:case 1:{a[b+733>>0]=0;if((d|0)==3)f=5;else d=1;break}case 4:case 0:{f=5;break}default:d=1}if((f|0)==5){d=b+760|0;if(i3(d)|0?(c[b+548>>2]|0)>>>0>=4:0){i=c[b+544>>2]|0;if((((a[i>>0]|0)==65?(a[i+1>>0]|0)==68:0)?(a[i+2>>0]|0)==73:0)?(a[i+3>>0]|0)==70:0){c[e>>2]=3;P6(c[d>>2]|0);a[b+733>>0]=0;d=1}else d=1}else d=0}return d|0}function Kt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(h-d>>4>>>0<b>>>0){f=c[a>>2]|0;d=d-f>>4;e=d+b|0;if(e>>>0>268435455)uaa();else{f=h-f|0;h=f>>3;uE(g,f>>4>>>0<134217727?(h>>>0<e>>>0?e:h):268435455,d,a+8|0);fL(g,b);ez(a,g);AO(g);break}}else xL(a,b);while(0);l=i;return}function Lt(b){b=b|0;var d=0,e=0,f=0;e=b+728|0;d=c[e>>2]|0;if(d&524288){Kb(b);d=c[e>>2]|0}if(d&262144){Zb(b);d=c[e>>2]|0}if(d&65536){ff(b);d=c[e>>2]|0}if(d&131072|0)jW(b);d=a[b+36+3>>0]|0;if(d<<24>>24<0)d=c[b+32>>2]|0;else d=d&255;if((d|0)==0?+g[(c[b+24>>2]|0)+136>>2]>=1.0:0){f=b+48|0;f=z0(c[b+612>>2]|0,0,c[f>>2]|0,c[f+4>>2]|0)|0;e=b+40|0;d=e;e=((f|0)!=(c[d>>2]|0)?1:(z|0)!=(c[d+4>>2]|0))?b+552|0:e;oK(b,0,0,86,c[e>>2]|0,c[e+4>>2]|0,10,1)}return}function Mt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;f=c[a+508>>2]|0;g=a+692|0;c[g>>2]=f;e=a+704|0;LI(e,f+1|0);f=a+716|0;LI(f,(c[g>>2]|0)+1|0);g=c[g>>2]|0;d=a+668|0;b=0;while(1){if(b>>>0>g>>>0)break;j=c[d>>2]|0;k=j+(b*24|0)|0;h=c[k+4>>2]|0;i=(c[e>>2]|0)+(b<<3)|0;c[i>>2]=c[k>>2];c[i+4>>2]=h;j=j+(b*24|0)+8|0;i=c[j+4>>2]|0;h=(c[f>>2]|0)+(b<<3)|0;c[h>>2]=c[j>>2];c[h+4>>2]=i;b=b+1|0}k=a+48|0;k=z0(c[a+612>>2]|0,0,c[k>>2]|0,c[k+4>>2]|0)|0;j=a+528|0;j=z0(k|0,z|0,c[j>>2]|0,c[j+4>>2]|0)|0;k=a+696|0;c[k>>2]=j;c[k+4>>2]=z;return}function Nt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Kv(d,h,e)|0;e=c[g>>2]|0;if(!e){WJ(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function Ot(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;g=l;l=l+16|0;e=g;if((a|0)>3)a=408444;else{W0(e,407712);f=406916+(a*56|0)|0;a:do if(!(c[406916+(a*56|0)+8>>2]|0))switch(a|0){case 0:{GH(f);break a}case 1:{FH(f);break a}case 2:{$G(f);break a}case 3:{wH(f);break a}default:break a}while(0);s7(c[e>>2]|0);a=cK(f,b,d)|0}l=g;return a|0}function Pt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j+12|0;i=j;g=Zv(d,h,e)|0;e=c[g>>2]|0;if(!e){kK(i,d,f);e=c[i>>2]|0;HH(d,c[h>>2]|0,g,e);g=1}else g=0;c[b>>2]=e;a[b+4>>0]=g;l=j;return}function Qt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=b+528|0;j=g;h=c[j>>2]|0;j=z0(h|0,c[j+4>>2]|0,d|0,e|0)|0;l=z;i=b+536|0;k=c[i+4>>2]|0;do if(l>>>0>k>>>0|((l|0)==(k|0)?j>>>0>(c[i>>2]|0)>>>0:0)){vt(b);b=f+11|0;if((a[b>>0]|0)<0){J7(c[f>>2]|0,0);c[f+4>>2]=0;break}else{J7(f,0);a[b>>0]=0;break}}else{Qx(f,(c[b+544>>2]|0)+(c[b+612>>2]|0)+h|0,d)|0;k=g;k=z0(c[k>>2]|0,c[k+4>>2]|0,d|0,e|0)|0;l=g;c[l>>2]=k;c[l+4>>2]=z}while(0);return}function Rt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(((h-d|0)/12|0)>>>0<b>>>0){f=c[a>>2]|0;d=(d-f|0)/12|0;e=d+b|0;if(e>>>0>357913941)uaa();else{f=(h-f|0)/12|0;h=f<<1;xE(g,f>>>0<178956970?(h>>>0<e>>>0?e:h):357913941,d,a+8|0);SW(g,b);ru(a,g);tM(g);break}}else CX(a,b);while(0);l=i;return}function St(a){a=a|0;do switch(a<<24>>24){case 1:{a=387620;break}case 2:{a=387606;break}case 3:{a=387597;break}case 4:{a=387582;break}case 5:{a=387564;break}case 6:{a=387557;break}case 10:{a=387522;break}case 11:{a=387492;break}case 12:{a=387477;break}case 13:{a=387441;break}case 14:{a=387433;break}case 15:{a=387425;break}case 16:{a=387417;break}case 17:{a=387388;break}case 22:{a=387351;break}case 23:{a=387315;break}case 24:{a=387282;break}case 25:{a=387245;break}case 26:{a=387209;break}case 27:{a=387176;break}case -1:{a=391133;break}default:a=a<<24>>24<0?385637:391133}while(0);return a|0}function Tt(b){b=b|0;var e=0,f=0,g=0,h=0,i=0;a[b+748>>0]=1;a[b+749>>0]=1;e=b+136|0;c[e>>2]=-1;c[e+4>>2]=-1;c[e+8>>2]=-1;c[e+12>>2]=-1;e=a[(c[b+544>>2]|0)+((c[b+612>>2]|0)+3)>>0]|0;f=b+840|0;a[f>>0]=e;h=b+528|0;i=h;i=z0(c[i>>2]|0,c[i+4>>2]|0,4,0)|0;c[h>>2]=i;c[h+4>>2]=z;if((e+71&255)<2)if(Jl(b)|0)g=6;else c3(c[b+508>>2]|0,c[b+668>>2]|0);else if(ll(b,e)|0)g=6;else c3(c[b+508>>2]|0,c[b+668>>2]|0);if((g|0)==6)yZ(c[b+508>>2]|0,c[b+668>>2]|0,d[f>>0]|0,0);return}function Ut(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=l;l=l+16|0;e=d+4|0;f=d;zH(e,a,b);b=c[e>>2]|0;e=Cr(a,f,b+16|0)|0;HH(a,c[f>>2]|0,e,b);l=d;return}function Vt(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;g=l;l=l+16|0;d=g;e=c[b>>2]|0;if((a[e+492>>0]|0)==0?(f=b+8|0,h=f,i=c[h>>2]|0,h=c[h+4>>2]|0,$x(d,e,0,0,127,1),j=rm(d)|0,h=z0(j|0,z|0,i|0,h|0)|0,oK(e,0,0,127,h,z,10,1),z5(d),$x(d,c[b>>2]|0,2,0,194,1),e=a[d+8+3>>0]|0,e=((e<<24>>24<0?c[d+4>>2]|0:e&255)|0)==0,z5(d),e):0){i=c[b>>2]|0;h=i+40|0;j=f;j=D_(c[h>>2]|0,c[h+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0;oK(i,2,0,194,j,z,10,0)}l=g;return}function Wt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j;do if((d|0)!=-1){i=a+4|0;e=c[a>>2]|0;if((((c[i>>2]|0)-e|0)/40|0)>>>0>d>>>0){Kq(e+(d*40|0)|0,b)|0;break}g=a+8|0;if((c[g>>2]|0)==(e|0))hE(a,1);while(1){e=c[a>>2]|0;f=((c[g>>2]|0)-e|0)/40|0;if(f>>>0>d>>>0)break;hE(a,f<<1)}while(1){if((((c[i>>2]|0)-e|0)/40|0)>>>0>=d>>>0)break;TX(h);hI(a,h);z5(h);e=c[a>>2]|0}Mx(a,b)}while(0);l=j;return}function Xt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;d=a+768|0;f=a+40|0;g=a+48|0;h=a+612|0;i=a+528|0;j=a+544|0;b=0;while(1){if((b|0)==8192)break;e=c[c[(c[(c[d>>2]|0)+80>>2]|0)+(b<<2)>>2]>>2]|0;if(e|0?(c[e+728>>2]&8|0)==0:0){k=f;l=c[k>>2]|0;k=c[k+4>>2]|0;m=g;m=z0(c[h>>2]|0,0,c[m>>2]|0,c[m+4>>2]|0)|0;n=i;n=z0(m|0,z|0,c[n>>2]|0,c[n+4>>2]|0)|0;m=f;c[m>>2]=n;c[m+4>>2]=z;Sc(a,e,c[j>>2]|0,0,0);e=f;c[e>>2]=l;c[e+4>>2]=k;G2(a,c[c[(c[(c[d>>2]|0)+80>>2]|0)+(b<<2)>>2]>>2]|0)}b=b+1|0}return}function Yt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(((h-d|0)/12|0)>>>0<b>>>0){f=c[a>>2]|0;d=(d-f|0)/12|0;e=d+b|0;if(e>>>0>357913941)uaa();else{f=(h-f|0)/12|0;h=f<<1;xE(g,f>>>0<178956970?(h>>>0<e>>>0?e:h):357913941,d,a+8|0);SW(g,b);ru(a,g);LM(g);break}}else CX(a,b);while(0);l=i;return}function Zt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(h-d>>5>>>0<b>>>0){f=c[a>>2]|0;d=d-f>>5;e=d+b|0;if(e>>>0>134217727)uaa();else{f=h-f|0;h=f>>4;tE(g,f>>5>>>0<67108863?(h>>>0<e>>>0?e:h):134217727,d,a+8|0);OI(g,b);rA(a,g);zQ(g);break}}else kJ(a,b);while(0);l=i;return}function _t(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(((h-d|0)/56|0)>>>0<b>>>0){f=c[a>>2]|0;d=(d-f|0)/56|0;e=d+b|0;if(e>>>0>76695844)uaa();else{f=(h-f|0)/56|0;h=f<<1;fE(g,f>>>0<38347922?(h>>>0<e>>>0?e:h):76695844,d,a+8|0);BR(g,b);sz(a,g);CP(g);break}}else bS(a,b);while(0);l=i;return}function $t(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=a+32|0;if(!(c[h>>2]|0))a=0;else{i=a+16|0;e=i;if((c[e>>2]|0)==-1?(c[e+4>>2]|0)==-1:0)qK(a);e=a+24|0;d=e;if((c[d>>2]|0)==-1?(c[d+4>>2]|0)==-1:0)nu(a);d=i;a=c[d>>2]|0;d=c[d+4>>2]|0;if(!((a|0)==-1&(d|0)==-1)?(j=z0(a|0,d|0,1,0)|0,k=z,g=e,f=c[g>>2]|0,g=c[g+4>>2]|0,k>>>0>g>>>0|(k|0)==(g|0)&j>>>0>f>>>0):0)a=D_(f|0,g|0,a|0,d|0)|0;else a=1;kA(c[h>>2]|0,b,a)|0;a=c[(c[h>>2]|0)+4>>2]|0;j=i;j=z0(c[j>>2]|0,c[j+4>>2]|0,a|0,0)|0;k=i;c[k>>2]=j;c[k+4>>2]=z}return a|0}function au(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=l;l=l+16|0;f=i;g=a+528|0;d=g;h=c[d>>2]|0;d=z0(h|0,c[d+4>>2]|0,16,0)|0;e=z;j=a+536|0;k=c[j+4>>2]|0;if(e>>>0>k>>>0|((e|0)==(k|0)?d>>>0>(c[j>>2]|0)>>>0:0)){vt(a);RY(f,0);c[b>>2]=c[f>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2]}else{j=(c[a+544>>2]|0)+(c[a+612>>2]|0)+h|0;h=I5(j)|0;k=b;c[k>>2]=h;c[k+4>>2]=z;j=I5(j+8|0)|0;k=b+8|0;c[k>>2]=j;c[k+4>>2]=z;k=g;c[k>>2]=d;c[k+4>>2]=e}l=i;return}function bu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(h-d>>4>>>0<b>>>0){f=c[a>>2]|0;d=d-f>>4;e=d+b|0;if(e>>>0>268435455)uaa();else{f=h-f|0;h=f>>3;uE(g,f>>4>>>0<134217727?(h>>>0<e>>>0?e:h):268435455,d,a+8|0);MR(g,b);sA(a,g);BQ(g);break}}else iS(a,b);while(0);l=i;return}function cu(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0;f=l;l=l+48|0;h=f+32|0;d=f+24|0;i=f+16|0;g=f;f=f+36|0;a=IW()|0;if(a|0?(e=c[a>>2]|0,e|0):0){a=e+48|0;b=c[a>>2]|0;a=c[a+4>>2]|0;if(!((b&-256|0)==1126902528&(a|0)==1129074247)){c[d>>2]=404259;Y$(404209,d)}if((b|0)==1126902529&(a|0)==1129074247)a=c[e+44>>2]|0;else a=e+80|0;c[f>>2]=a;e=c[e>>2]|0;a=c[e+4>>2]|0;if(Ay(2632,e,f)|0){i=c[f>>2]|0;i=nb[c[(c[i>>2]|0)+8>>2]&255](i)|0;c[g>>2]=404259;c[g+4>>2]=a;c[g+8>>2]=i;Y$(404123,g)}else{c[i>>2]=404259;c[i+4>>2]=a;Y$(404168,i)}}Y$(404247,h)}function du(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;e=(e-b<<3)+f-d|0;i=g+4|0;if((e|0)>0){if(!d)f=c[g>>2]|0;else{f=32-d|0;h=(e|0)<(f|0)?e:f;d=-1>>>(f-h|0)&-1<<d;f=c[g>>2]|0;c[f>>2]=c[f>>2]&~d|c[b>>2]&d;d=(c[i>>2]|0)+h|0;f=f+(d>>>5<<2)|0;c[g>>2]=f;c[i>>2]=d&31;e=e-h|0;b=b+4|0}h=(e|0)/32|0;TR(f|0,b|0,h<<2|0)|0;f=e-(h<<5)|0;d=(c[g>>2]|0)+(h<<2)|0;c[g>>2]=d;e=d;if((f|0)>0){g=-1>>>(32-f|0);c[d>>2]=c[d>>2]&~g|c[b+(h<<2)>>2]&g;c[i>>2]=f}}else e=c[g>>2]|0;c[a>>2]=e;c[a+4>>2]=c[i>>2];return}function eu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;g=l;l=l+16|0;e=g;f=b+312|0;if(!((c[f>>2]|0)==0&(c[f+4>>2]|0)==0)?(c[b+908>>2]|0)==4:0){c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;f=j9(387802)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[e+11>>0]=f;d=e}else{h=f+16&-16;d=ZW(h)|0;c[e>>2]=d;c[e+8>>2]=h|-2147483648;c[e+4>>2]=f}i1(d,387802,f)|0;J7(d+f|0,0);h=VC(b+22136|0,e)|0;cC(h,a[b+2504>>0]|0?384435:384431)|0;a1(e)}l=g;return}function fu(b){b=b|0;var d=0,e=0;if((c[b+880>>2]|0)>>>0<=1){d=b+784|0;e=b+792+3|0;if((a[e>>0]|0)<0){y7(c[d>>2]|0,0);c[b+788>>2]=0}else{y7(d,0);a[e>>0]=0}c[b+796>>2]=0;d=b+800|0;c[d>>2]=-1;c[d+4>>2]=-1;d=b+840|0;c[d>>2]=-1;c[d+4>>2]=-1;d=b+848|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;Kc(b,7,-1)|0;lJ(b);d=b+16|0;e=b+20|0;xM(b,c[d>>2]|0,c[e>>2]|0,384512,373754,0);lL(b,c[d>>2]|0,c[e>>2]|0,7,c[b+768>>2]|0,10,0)}return}function gu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;b=b+4|0;e=pw(d,c[b>>2]|0,b)|0;if((e|0)!=(b|0)?(h=e+16|0,f=a[h+11>>0]|0,i=f<<24>>24<0,f=i?c[e+20>>2]|0:f&255,g=a[d+11>>0]|0,j=g<<24>>24<0,g=j?c[d+4>>2]|0:g&255,d=R$(j?c[d>>2]|0:d,i?c[h>>2]|0:h,f>>>0<g>>>0?f:g)|0,(((d|0)==0?(g>>>0<f>>>0?-2147483648:0):d)|0)>=0):0)b=e;return b|0}function hu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(((h-d|0)/40|0)>>>0<b>>>0){f=c[a>>2]|0;d=(d-f|0)/40|0;e=d+b|0;if(e>>>0>107374182)uaa();else{f=(h-f|0)/40|0;h=f<<1;lE(g,f>>>0<53687091?(h>>>0<e>>>0?e:h):107374182,d,a+8|0);XR(g,b);Bz(a,g);VP(g);break}}else DS(a,b);while(0);l=i;return}function iu(b){b=b|0;var d=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;x1(b+88|0);x1(b+112|0);d=b+16|0;c[d>>2]=-1;c[d+4>>2]=-1;c[d+8>>2]=-1;c[d+12>>2]=-1;c[b+32>>2]=0;c[b+36>>2]=7;d=b+40|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;a[b+64>>0]=1;a[b+65>>0]=0;a[b+66>>0]=0;a[b+67>>0]=1;a[b+68>>0]=0;d=b+72|0;c[d>>2]=-1;c[d+4>>2]=0;c[b+80>>2]=0;c[b+84>>2]=0;d=b+104|0;c[d>>2]=0;c[d+4>>2]=0;b=b+128|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;return}function ju(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=a+4|0;g=c[f>>2]|0;do if(g){f=e8(a)|0;while(1){a=b[g+16>>1]|0;if((a&65535)>(e&65535)){a=c[g>>2]|0;if(!a){a=5;break}else{f=g;g=a}}else{if((a&65535)>=(e&65535)){a=10;break}f=g+4|0;a=c[f>>2]|0;if(!a){a=9;break}else g=a}}if((a|0)==5){c[d>>2]=g;f=g;break}else if((a|0)==9){c[d>>2]=g;break}else if((a|0)==10){c[d>>2]=g;break}}else c[d>>2]=f;while(0);return f|0}function ku(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;d=i;f=b+536|0;h=f;g=c[h+4>>2]|0;if(!(g>>>0<0|(g|0)==0&(c[h>>2]|0)>>>0<8)){zE(b,d);h=d;if(!(!((c[h>>2]|0)==1415669619?(c[h+4>>2]|0)==1332770163:0)?!(a[b+785>>0]|0):0))e=4;do if((e|0)==4){h=b+528|0;g=c[h>>2]|0;h=c[h+4>>2]|0;e=f;d=c[e>>2]|0;e=c[e+4>>2]|0;if(e>>>0>h>>>0|(e|0)==(h|0)&d>>>0>g>>>0){h=D_(d|0,e|0,g|0,h|0)|0;e1(b,h,z)}if(a[b+784>>0]|0){h=c[b+776>>2]|0;if(h|0?(c[h+728>>2]&8|0)==0:0)break;V5(b)}}while(0)}l=i;return}function lu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;h=l;l=l+16|0;f=h;d=b+952|0;g=b+944|0;g=D_(c[d>>2]|0,c[d+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0)|0;oK(b,2,0,194,g,z,10,0);Kc(b,2,-1)|0;g=ZW(1128)|0;Wr(g);a[g+905>>0]=1;a[g+732>>0]=1;aY(b,g);c[f>>2]=-1;b=jF(b+760|0,f)|0;c[b+40>>2]=2;c[b+44>>2]=0;c[f>>2]=g;d=b+4|0;e=c[d>>2]|0;if(e>>>0<(c[b+8>>2]|0)>>>0){c[e>>2]=g;c[d>>2]=(c[d>>2]|0)+4}else Yy(b,f);l=h;return}function mu(a){a=a|0;var b=0,d=0,e=0,f=0;e=l;l=l+16|0;b=e;d=a+536|0;f=c[d+4>>2]|0;if(!(f>>>0<0|(f|0)==0&(c[d>>2]|0)>>>0<4)){r3(a,b);d=HN(a,0)|0;f=a+528|0;c[f>>2]=d;c[f+4>>2]=z;if(qO(a)|0){Kc(a,2,-1)|0;d=a+20|0;if((c[b>>2]|0)==1097101411)RB(a,2,c[d>>2]|0,18,379727,-1,1,0);d=c[d>>2]|0;f=HN(a,0)|0;oK(a,2,d,194,f,z,10,0)}}else c3(c[a+508>>2]|0,c[a+668>>2]|0);l=e;return}function nu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+48|0;d=h+32|0;e=h+16|0;f=h;g=a+32|0;b=c[g>>2]|0;if(b|0){KA(e,b);b=e+8|0;a=a+24|0;if((c[b>>2]|0)==-1?(c[b+4>>2]|0)==-1:0){g=a;c[g>>2]=-1;c[g+4>>2]=-1}else{Cy(c[g>>2]|0,0,0,2)|0;KA(f,c[g>>2]|0);i=f+8|0;b=c[i+4>>2]|0;f=a;c[f>>2]=c[i>>2];c[f+4>>2]=b;g=c[g>>2]|0;c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];iw(g,d)|0}}l=h;return}function ou(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i+4|0;g=i;c[g>>2]=a;do if((a|0)!=(b|0)){a=g;d=f;while(1){c[d>>2]=c[a>>2];a=(c[f>>2]|0)+4|0;c[f>>2]=a;if((a|0)==(b|0)){h=4;break}d=c[g>>2]|0;e=c[d>>2]|0;if((e|0)==(c[a>>2]|0))break;else{a=f;d=g}}if((h|0)==4){h=6;break}if((d|0)!=(b|0)){f=d;a=d+4|0;a:while(1){do{a=a+4|0;if((a|0)==(b|0))break a;d=c[a>>2]|0}while((e|0)==(d|0));e=f+4|0;c[e>>2]=d;f=e;e=d}b=f+4|0}}else h=6;while(0);l=i;return b|0}function pu(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;g=c[b+68>>2]|0;if(!g){a=ua(4)|0;G9(a);Ya(a|0,2744,371)}g=nb[c[(c[g>>2]|0)+24>>2]&255](g)|0;h=b+64|0;if((((c[h>>2]|0)!=0?!(((d|0)!=0|(e|0)!=0)&(g|0)<1):0)?f>>>0<3&(nb[c[(c[b>>2]|0)+24>>2]&255](b)|0)==0:0)?(i=c[h>>2]|0,e=UW(g|0,((g|0)<0)<<31>>31|0,d|0,e|0)|0,(x7(i,(g|0)>0?e:0,f)|0)==0):0){d=Y9(c[h>>2]|0)|0;h=b+72|0;g=c[h>>2]|0;h=c[h+4>>2]|0;b=d;d=((d|0)<0)<<31>>31}else{g=0;h=0;b=-1;d=-1}i=a;c[i>>2]=g;c[i+4>>2]=h;i=a+8|0;c[i>>2]=b;c[i+4>>2]=d;return}function qu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=l;l=l+16|0;f=i;g=a+528|0;d=g;h=c[d>>2]|0;d=z0(h|0,c[d+4>>2]|0,16,0)|0;e=z;j=a+536|0;k=c[j+4>>2]|0;if(e>>>0>k>>>0|((e|0)==(k|0)?d>>>0>(c[j>>2]|0)>>>0:0)){vt(a);RY(f,0);c[b>>2]=c[f>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2]}else{j=(c[a+544>>2]|0)+(c[a+612>>2]|0)+h|0;h=f8(j)|0;k=b+8|0;c[k>>2]=h;c[k+4>>2]=z;j=f8(j+8|0)|0;k=b;c[k>>2]=j;c[k+4>>2]=z;k=g;c[k>>2]=d;c[k+4>>2]=e}l=i;return}function ru(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;e=c[a>>2]|0;f=a+4|0;g=b+4|0;d=c[f>>2]|0;while(1){if((d|0)==(e|0))break;k=c[g>>2]|0;i=k+-12|0;h=d+-12|0;c[i>>2]=0;j=k+-8|0;c[j>>2]=0;c[k+-4>>2]=0;c[i>>2]=c[h>>2];i=d+-8|0;c[j>>2]=c[i>>2];j=d+-4|0;c[k+-4>>2]=c[j>>2];c[j>>2]=0;c[i>>2]=0;c[h>>2]=0;c[g>>2]=(c[g>>2]|0)+-12;d=h}i=c[a>>2]|0;c[a>>2]=c[g>>2];c[g>>2]=i;i=b+8|0;k=c[f>>2]|0;c[f>>2]=c[i>>2];c[i>>2]=k;i=a+8|0;k=b+12|0;j=c[i>>2]|0;c[i>>2]=c[k>>2];c[k>>2]=j;c[b>>2]=c[g>>2];return}function su(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;h=b+8|0;i=b+96|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;h=b+32|0;if(a[i>>0]|0)jaa(c[h>>2]|0);m=b+97|0;l=b+56|0;if(a[m>>0]|0)jaa(c[l>>2]|0);f=b+52|0;c[f>>2]=e;j=(a[b+98>>0]|0)!=0;k=(d|0)!=0;if(e>>>0>8){if(k&j){f=0;g=d}else{f=1;g=iaa(e)|0}c[h>>2]=g}else{c[h>>2]=b+44;c[f>>2]=8;f=0}a[i>>0]=f;f=b+60|0;if(!j){g=(e|0)>8?e:8;c[f>>2]=g;if(k&g>>>0>7)f=0;else{f=1;d=iaa(g)|0}}else{c[f>>2]=0;f=0;d=0}c[l>>2]=d;a[m>>0]=f;return b|0}function tu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=b+32|0;if((c[f>>2]|0)!=0?(Pc(b)|0,(c[f>>2]|0)!=0):0)b=0;else g=3;do if((g|0)==3){if(a[b+129>>0]|0){Rl(b,0,0);b=0;break}if((e|0)==0?!(Pc(b)|0):0){b=0;break}b=c[b>>2]|0;f=c[b+612>>2]|0;if((e+8+f|0)>>>0>(c[b+548>>2]|0)>>>0)b=0;else{e=(c[b+544>>2]|0)+f+e|0;g=R4(a[e>>0]|0,a[e+1>>0]|0,a[e+2>>0]|0)|0;e=V8(e)|0;b=z;a[d>>0]=((g|0)==5521735|((e|0)==1129529925&(b|0)==1280922185|((g|0)==4801587|(e|0)==1095189848&(b|0)==1095779668)))&1;b=1}}while(0);return b|0}function uu(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;if((-18-d|0)>>>0<e>>>0)uaa();if((a[b+11>>0]|0)<0)n=c[b>>2]|0;else n=b;if(d>>>0<2147483623){k=e+d|0;m=d<<1;k=k>>>0<m>>>0?m:k;k=k>>>0<11?11:k+16&-16}else k=-17;l=ZW(k)|0;if(g|0)i1(l,n,g)|0;m=l+g|0;if(i|0)i1(m,j,i)|0;e=f-h|0;f=e-g|0;if(f|0)i1(m+i|0,n+g+h|0,f)|0;if((d|0)!=10)laa(n);c[b>>2]=l;c[b+8>>2]=k|-2147483648;i=e+i|0;c[b+4>>2]=i;J7(l+i|0,0);return}function vu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=a+4|0;f=c[e>>2]|0;do if(f){e=e8(a)|0;while(1){a=c[f+16>>2]|0;if(a>>>0>d>>>0){a=c[f>>2]|0;if(!a){a=5;break}else{e=f;f=a}}else{if(a>>>0>=d>>>0){a=10;break}e=f+4|0;a=c[e>>2]|0;if(!a){a=9;break}else f=a}}if((a|0)==5){c[b>>2]=f;e=f;break}else if((a|0)==9){c[b>>2]=f;break}else if((a|0)==10){c[b>>2]=f;break}}else c[b>>2]=e;while(0);return e|0}function wu(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;g=n;m=n+12|0;h=n+14|0;TX(g);HB(d,m);i=d+780|0;j=d+784|0;k=d+776|0;m=b[m>>1]|0;f=0;while(1){if((f&65535)>=(m&65535))break;GC(d);bB(d,h);e=a[h>>0]|0;if(e<<24>>24)VY(d,e&255,0,g);J3(d);e=c[i>>2]|0;if((e|0)==(c[j>>2]|0))Ax(k,g);else{p2(e,g);c[i>>2]=(c[i>>2]|0)+12}f=f+1<<16>>16}z5(g);l=n;return}function xu(b){b=b|0;var d=0,e=0;Eg(b);c[b>>2]=27760;IX(b+72|0,378897)|0;a[b+733>>0]=1;d=b+632|0;c[d>>2]=65536;c[d+4>>2]=0;d=b+640|0;c[d>>2]=-1;c[d+4>>2]=-1;c[b+504>>2]=2;a[b+760>>0]=0;d=xP()|0;e=b+776|0;c[e>>2]=d;c[e+4>>2]=z;e=xP()|0;e=XZ(e|0,z|0,2)|0;d=b+784|0;c[d>>2]=e;c[d+4>>2]=z;d=b+792|0;c[d>>2]=-1;c[d+4>>2]=-1;a[b+810>>0]=1;c[b+768>>2]=0;a[b+808>>0]=(fT()|0)&1;a[b+809>>0]=(QS()|0)&1;return}function yu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(((h-d|0)/12|0)>>>0<b>>>0){f=c[a>>2]|0;d=(d-f|0)/12|0;e=d+b|0;if(e>>>0>357913941)uaa();else{f=(h-f|0)/12|0;h=f<<1;xE(g,f>>>0<178956970?(h>>>0<e>>>0?e:h):357913941,d,a+8|0);SW(g,b);ru(a,g);GO(g);break}}else CX(a,b);while(0);l=i;return}function zu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;k=l;l=l+32|0;f=k+20|0;e=k+16|0;g=k+12|0;h=k+8|0;m=k+24|0;i=k+4|0;j=k;mk(m,b);if(a[m>>0]|0){c[i>>2]=0;O4(j,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);n=u$(c[j>>2]|0,409164)|0;m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;o=c[(c[n>>2]|0)+36>>2]|0;c[g>>2]=c[m+24>>2];c[h>>2]=0;c[e>>2]=c[g>>2];c[f>>2]=c[h>>2];lb[o&63](n,e,f,m,i,d)|0;c6(j);m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(m,c[m+16>>2]|c[i>>2])}l=k;return b|0}function Au(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;k=l;l=l+32|0;f=k+20|0;e=k+16|0;g=k+12|0;h=k+8|0;m=k+24|0;i=k+4|0;j=k;mk(m,b);if(a[m>>0]|0){c[i>>2]=0;O4(j,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);n=u$(c[j>>2]|0,409164)|0;m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;o=c[(c[n>>2]|0)+20>>2]|0;c[g>>2]=c[m+24>>2];c[h>>2]=0;c[e>>2]=c[g>>2];c[f>>2]=c[h>>2];lb[o&63](n,e,f,m,i,d)|0;c6(j);m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(m,c[m+16>>2]|c[i>>2])}l=k;return b|0}function Bu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;k=l;l=l+32|0;f=k+20|0;e=k+16|0;g=k+12|0;h=k+8|0;m=k+24|0;i=k+4|0;j=k;mk(m,b);if(a[m>>0]|0){c[i>>2]=0;O4(j,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);n=u$(c[j>>2]|0,409164)|0;m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;o=c[(c[n>>2]|0)+28>>2]|0;c[g>>2]=c[m+24>>2];c[h>>2]=0;c[e>>2]=c[g>>2];c[f>>2]=c[h>>2];lb[o&63](n,e,f,m,i,d)|0;c6(j);m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(m,c[m+16>>2]|c[i>>2])}l=k;return b|0}function Cu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;k=l;l=l+32|0;f=k+20|0;e=k+16|0;g=k+12|0;h=k+8|0;m=k+24|0;i=k+4|0;j=k;mk(m,b);if(a[m>>0]|0){c[i>>2]=0;O4(j,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);n=u$(c[j>>2]|0,409164)|0;m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;o=c[(c[n>>2]|0)+40>>2]|0;c[g>>2]=c[m+24>>2];c[h>>2]=0;c[e>>2]=c[g>>2];c[f>>2]=c[h>>2];lb[o&63](n,e,f,m,i,d)|0;c6(j);m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(m,c[m+16>>2]|c[i>>2])}l=k;return b|0}function Du(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;k=l;l=l+32|0;f=k+20|0;e=k+16|0;g=k+12|0;h=k+8|0;m=k+24|0;i=k+4|0;j=k;mk(m,b);if(a[m>>0]|0){c[i>>2]=0;O4(j,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);n=u$(c[j>>2]|0,409164)|0;m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;o=c[(c[n>>2]|0)+48>>2]|0;c[g>>2]=c[m+24>>2];c[h>>2]=0;c[e>>2]=c[g>>2];c[f>>2]=c[h>>2];lb[o&63](n,e,f,m,i,d)|0;c6(j);m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(m,c[m+16>>2]|c[i>>2])}l=k;return b|0}function Eu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;k=l;l=l+32|0;f=k+20|0;e=k+16|0;g=k+12|0;h=k+8|0;m=k+24|0;i=k+4|0;j=k;mk(m,b);if(a[m>>0]|0){c[i>>2]=0;O4(j,b+(c[(c[b>>2]|0)+-12>>2]|0)|0);n=u$(c[j>>2]|0,409164)|0;m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;o=c[(c[n>>2]|0)+44>>2]|0;c[g>>2]=c[m+24>>2];c[h>>2]=0;c[e>>2]=c[g>>2];c[f>>2]=c[h>>2];lb[o&63](n,e,f,m,i,d)|0;c6(j);m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;C4(m,c[m+16>>2]|c[i>>2])}l=k;return b|0}function Fu(d){d=d|0;var e=0,f=0,g=0;e=d+760|0;f=e;if((c[f>>2]|0)==0&(c[f+4>>2]|0)==0){f=e;c[f>>2]=16;c[f+4>>2]=0}e=d+288|0;c[e>>2]=0;c[e+4>>2]=0;e=d+144|0;if(!(a[d+492>>0]|0)){c[e>>2]=0;c[e+4>>2]=0;e=0;f=0}else{f=e;e=c[f>>2]|0;f=c[f+4>>2]|0}g=d+296|0;c[g>>2]=e;c[g+4>>2]=f;g=d+304|0;c[g>>2]=e;c[g+4>>2]=f;c[d+836>>2]=0;c[d+936>>2]=-1;c[d+940>>2]=-1;b[d+944>>1]=0;b[d+946>>1]=0;a[d+952>>0]=2;e=d+776|0;yH(e);e=c[e>>2]|0;a[e+32>>0]=1;a[e+35>>0]=1;a[e+39>>0]=1;f=255;while(1){if(f>>>0<=47)break;a[e+f>>0]=1;f=f+-1|0}return}function Gu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;h=l;l=l+32|0;e=h;f=c[102056]|0;b=c[102055]|0;do if(f-b>>2>>>0<a>>>0){g=c[102054]|0;d=b-g>>2;b=d+a|0;if(b>>>0>1073741823)uaa();else{f=f-g|0;g=f>>1;NH(e,f>>2>>>0<536870911?(g>>>0<b>>>0?b:g):1073741823,d);gS(e,a);QB(e);nJ(e);break}}else kV(a);while(0);l=h;return}function Hu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;i=l;l=l+16|0;g=i;if((a|0)==(b|0)){c[d>>2]=4;a=0}else{h=c[12784]|0;c[12784]=0;b0()|0;a=R6(a,g,e)|0;e=z;f=c[12784]|0;if(!f)c[12784]=h;a:do if((c[g>>2]|0)==(b|0)){do if((f|0)==34){c[d>>2]=4;if((e|0)>0|(e|0)==0&a>>>0>0){a=2147483647;break a}}else{if((e|0)<-1|(e|0)==-1&a>>>0<2147483648){c[d>>2]=4;break}if((e|0)>0|(e|0)==0&a>>>0>2147483647){c[d>>2]=4;a=2147483647;break a}else break a}while(0);a=-2147483648}else{c[d>>2]=4;a=0}while(0)}l=i;return a|0}function Iu(a){a=a|0;var b=0,d=0,e=0,f=0;f=l;l=l+16|0;e=f;if((c[a+768>>2]|0)==1835299937){c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[e+(b<<2)>>2]=0;b=b+1|0}b=a+536|0;EU(a,c[b>>2]|0,c[b+4>>2]|0,e);b=a+812|0;d=c[b>>2]|0;if((d|0)==(c[a+816>>2]|0))vv(a+808|0,e);else{wz(d,e);c[b>>2]=(c[b>>2]|0)+12}a1(e)}else t4(a);l=f;return}function Ju(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;h=l;l=l+48|0;e=h+24|0;f=h+12|0;g=h;b=an(a)|0;d=z;if(qO(a)|0?(i=a+816|0,!((b|0)==(c[i>>2]|0)?(d|0)==(c[i+4>>2]|0):0)):0){oT(g,b,d,10);DW(g,0,38848)|0;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];b=0;while(1){if((b|0)==3)break;c[g+(b<<2)>>2]=0;b=b+1|0}p2(e,f);zb(a,0,0,64,e,0);z5(e);O0(f);z5(g)}l=h;return}function Ku(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;g=i;h=c[a+8>>2]|0;d=c[a+4>>2]|0;do if(((h-d|0)/12|0)>>>0<b>>>0){f=c[a>>2]|0;d=(d-f|0)/12|0;e=d+b|0;if(e>>>0>357913941)uaa();else{f=(h-f|0)/12|0;h=f<<1;xE(g,f>>>0<178956970?(h>>>0<e>>>0?e:h):357913941,d,a+8|0);ES(g,b);Qz(a,g);HQ(g);break}}else iT(a,b);while(0);l=i;return}function Lu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=b+4|0;i=c[h>>2]|0;f=c[a>>2]|0;e=d;g=i;while(1){if((e|0)==(f|0))break;k=e+-56|0;Iw(g+-56|0,k);j=(c[h>>2]|0)+-56|0;c[h>>2]=j;e=k;g=j}e=a+4|0;f=c[e>>2]|0;g=b+8|0;while(1){if((d|0)==(f|0))break;Iw(c[g>>2]|0,d);c[g>>2]=(c[g>>2]|0)+56;d=d+56|0}k=c[a>>2]|0;c[a>>2]=c[h>>2];c[h>>2]=k;k=c[e>>2]|0;c[e>>2]=c[g>>2];c[g>>2]=k;a=a+8|0;k=b+12|0;j=c[a>>2]|0;c[a>>2]=c[k>>2];c[k>>2]=j;c[b>>2]=c[h>>2];return i|0}function Mu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;g=l;l=l+48|0;d=g+24|0;e=g+12|0;f=g;i=an(a)|0;b=a+816|0;h=b;c[h>>2]=i;c[h+4>>2]=z;if(qO(a)|0){oT(f,c[b>>2]|0,c[b+4>>2]|0,10);DW(f,0,38848)|0;c[e>>2]=c[f>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];b=0;while(1){if((b|0)==3)break;c[f+(b<<2)>>2]=0;b=b+1|0}p2(d,e);zb(a,0,0,64,d,0);z5(d);O0(e);z5(f)}l=g;return}function Nu(a,d,e){a=a|0;d=d|0;e=e|0;var f=0,g=0;f=a+4|0;g=c[f>>2]|0;do if(g){f=e8(a)|0;while(1){a=b[g+16>>1]|0;if((a&65535)>(e&65535)){a=c[g>>2]|0;if(!a){a=6;break}else{f=g;g=a}}else{if((a&65535)>=(e&65535)){a=10;break}f=g+4|0;a=c[f>>2]|0;if(!a){a=9;break}else g=a}}if((a|0)==6){c[d>>2]=g;f=g;break}else if((a|0)==9){c[d>>2]=g;break}else if((a|0)==10){c[d>>2]=g;break}}else c[d>>2]=f;while(0);return f|0}function Ou(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;i=l;l=l+16|0;h=i;if(((!((f|0)==0|((d|0)>7?1:(c[b+728>>2]&1|0)==0))?!((d|0)==7|(a[f>>0]|0)==0):0)?(j=c[c[b+4>>2]>>2]|0,(((c[j+(d*12|0)+4>>2]|0)-(c[j+(d*12|0)>>2]|0)|0)/40|0)>>>0>e>>>0):0)?(j=vn(d)|0,TX(h),j=Sx(j,cC(h,f)|0,0)|0,z5(h),(j|0)==-1):0){j=c[(c[c[b+8>>2]>>2]|0)+(d*12|0)>>2]|0;TX(h);bj(_0(j+(e*56|0)|0,sP(h,f)|0,3)|0,g)|0;z5(h)}l=i;return}function Pu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=b+612|0;j=b+544|0;g=c[b+548>>2]|0;d=c[h>>2]|0;while(1){if(d>>>0>=g>>>0)break;if((a[(c[j>>2]|0)+d>>0]|0)!=-1)break;k=d+1|0;c[h>>2]=k;d=k}while(1){f=d+1|0;if((d+3|0)>>>0>g>>>0){d=0;break}i=c[j>>2]|0;e=a[i+(d+2)>>0]|0;k=i+f|0;i=(a[i+d>>0]|0)==0;if(e<<24>>24){l=9;break}if((a[k>>0]|0)!=0|i^1){e=0;l=9;break}c[h>>2]=f;d=f}do if((l|0)==9){d=b+376|0;if(i?e<<24>>24==1&(a[k>>0]|0)==0:0){if(a[d>>0]|0?!(jf(b)|0):0){d=0;break}}else a[d>>0]=0;d=1}while(0);return d|0}function Qu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;d=b+528|0;j=d;i=c[j>>2]|0;j=c[j+4>>2]|0;k=z0(i|0,j|0,1,0)|0;l=z;f=b+536|0;e=c[f>>2]|0;f=c[f+4>>2]|0;do if(!(l>>>0>f>>>0|(l|0)==(f|0)&k>>>0>e>>>0)){h=c[b+544>>2]|0;g=z0(c[b+612>>2]|0,0,i|0,j|0)|0;g=a[h+g>>0]|0;h=g&1^1;l=z0(g&255|0,0,k|0,l|0)|0;l=z0(l|0,z|0,h&255|0,0)|0;k=z;if(k>>>0>f>>>0|(k|0)==(f|0)&l>>>0>e>>>0){vt(b);break}else{k=z0((g&255)+1+(h&255)|0,0,i|0,j|0)|0;l=d;c[l>>2]=k;c[l+4>>2]=z;break}}else vt(b);while(0);return}function Ru(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;d=hw(b,c[101926]|0)|0;if(!((d|0)!=407704?(g=d+16|0,e=a[d+24+3>>0]|0,h=e<<24>>24<0,e=h?c[d+20>>2]|0:e&255,f=a[b+8+3>>0]|0,i=f<<24>>24<0,f=i?c[b+4>>2]|0:f&255,b=L$(i?c[b>>2]|0:b,h?c[g>>2]|0:g,e>>>0<f>>>0?e:f)|0,(((b|0)==0?(f>>>0<e>>>0?-2147483648:0):b)|0)>=0):0))d=407704;return d|0}function Su(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;a:do if((e|0)==0|(g|0)==0){j=c[b+648>>2]|0;G4(j,Z9(c[j+4>>2]|0)|0)}else{i=g+4|0;j=e+3|0;h=b+648|0;b=0;while(1){if(b>>>0>=(((c[i>>2]|0)-(c[g>>2]|0)|0)/24|0)>>>0)break a;d4(c[h>>2]|0,(d[j>>0]|0)+1&255);d4(c[h>>2]|0,(d[j>>0]|0)+1&255);if((a[e>>0]|0)!=0|f){d4(c[h>>2]|0,(d[j>>0]|0)+1&255);d4(c[h>>2]|0,(d[j>>0]|0)+1&255)}b=b+1|0}}while(0);return}function Tu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;d=l;l=l+16|0;e=d;KK(a);KK(a);b=a+528|0;g=b;g=z0(c[g>>2]|0,c[g+4>>2]|0,12,0)|0;f=b;c[f>>2]=g;c[f+4>>2]=z;ID(a,e);f=b;f=z0(c[f>>2]|0,c[f+4>>2]|0,24,0)|0;c[b>>2]=f;c[b+4>>2]=z;iF(a,32,0);iF(a,32,0);b=a+20|0;switch(c[e>>2]|0){case 1:{RB(a,1,c[b>>2]|0,197,384051,-1,1,1);break}case 2:{RB(a,1,c[b>>2]|0,197,384063,-1,1,1);break}default:{}}l=d;return}function Uu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;f=i;g=c[a+8>>2]|0;d=c[a+4>>2]|0;do if((g-d|0)>>>0<b>>>0){h=c[a>>2]|0;d=d-h|0;e=d+b|0;if((e|0)<0)uaa();else{g=g-h|0;h=g<<1;eR(f,g>>>0<1073741823?(h>>>0<e>>>0?e:h):2147483647,d,a+8|0);yQ(f,b);mB(a,f);lQ(f);break}}else cR(a,b);while(0);l=i;return}function Vu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=b+11|0;e=a[i>>0]|0;f=e<<24>>24<0;j=b+4|0;if(f){g=c[j>>2]|0;e=(c[b+8>>2]&2147483647)+-1|0}else{g=e&255;e=10}h=g+d|0;if((e-g|0)>>>0>=d>>>0){if(d|0){if(f)f=c[b>>2]|0;else f=b;if(!g)e=404776;else{g1(f+d|0,f,g)|0;e=f>>>0<=404776>>>0&(f+g|0)>>>0>404776>>>0?404776+d|0:404776}g1(f,e,d)|0;if((a[i>>0]|0)<0)c[j>>2]=h;else a[i>>0]=h;J7(f+h|0,0)}}else uu(b,e,h-e|0,g,0,0,d,404776);return b|0}function Wu(a){a=a|0;c[a>>2]=17184;jaa(c[a+776>>2]|0);aU(a+1080|0);XQ(a+1048|0);AS(a+1032|0);nO(a+976|0);uS(a+952|0);a1(a+940|0);a1(a+928|0);a1(a+916|0);pU(a+892|0);z5(a+784|0);VW(a+760|0);bt(a);return}function Xu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=b+4|0;g=c[f>>2]|0;do if(g){f=e8(b)|0;while(1){b=a[g+16>>0]|0;if((b&255)>(e&255)){b=c[g>>2]|0;if(!b){b=5;break}else{f=g;g=b}}else{if((b&255)>=(e&255)){b=10;break}f=g+4|0;b=c[f>>2]|0;if(!b){b=9;break}else g=b}}if((b|0)==5){c[d>>2]=g;f=g;break}else if((b|0)==9){c[d>>2]=g;break}else if((b|0)==10){c[d>>2]=g;break}}else c[d>>2]=f;while(0);return f|0}function Yu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;f=b+4|0;g=c[f>>2]|0;do if(g){f=e8(b)|0;while(1){b=a[g+16>>0]|0;if((b&255)>(e&255)){b=c[g>>2]|0;if(!b){b=6;break}else{f=g;g=b}}else{if((b&255)>=(e&255)){b=10;break}f=g+4|0;b=c[f>>2]|0;if(!b){b=9;break}else g=b}}if((b|0)==6){c[d>>2]=g;f=g;break}else if((b|0)==9){c[d>>2]=g;break}else if((b|0)==10){c[d>>2]=g;break}}else c[d>>2]=f;while(0);return f|0}function Zu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;h=b+4|0;i=c[h>>2]|0;f=c[a>>2]|0;e=d;g=i;while(1){if((e|0)==(f|0))break;k=e+-40|0;yw(g+-40|0,k);j=(c[h>>2]|0)+-40|0;c[h>>2]=j;e=k;g=j}e=a+4|0;f=c[e>>2]|0;g=b+8|0;while(1){if((d|0)==(f|0))break;yw(c[g>>2]|0,d);c[g>>2]=(c[g>>2]|0)+40;d=d+40|0}k=c[a>>2]|0;c[a>>2]=c[h>>2];c[h>>2]=k;k=c[e>>2]|0;c[e>>2]=c[g>>2];c[g>>2]=k;a=a+8|0;k=b+12|0;j=c[a>>2]|0;c[a>>2]=c[k>>2];c[k>>2]=j;c[b>>2]=c[h>>2];return i|0}function _u(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=b+528|0;j=g;h=c[j>>2]|0;j=z0(h|0,c[j+4>>2]|0,d|0,e|0)|0;l=z;i=b+536|0;k=c[i+4>>2]|0;do if(l>>>0>k>>>0|((l|0)==(k|0)?j>>>0>(c[i>>2]|0)>>>0:0)){vt(b);b=f+8+3|0;if((a[b>>0]|0)<0){y7(c[f>>2]|0,0);c[f+4>>2]=0;break}else{y7(f,0);a[b>>0]=0;break}}else{G1(f,(c[b+544>>2]|0)+(c[b+612>>2]|0)+h|0,d)|0;k=g;k=z0(c[k>>2]|0,c[k+4>>2]|0,d|0,e|0)|0;l=g;c[l>>2]=k;c[l+4>>2]=z}while(0);return}function $u(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;g=b+528|0;j=g;h=c[j>>2]|0;j=z0(h|0,c[j+4>>2]|0,d|0,e|0)|0;l=z;i=b+536|0;k=c[i+4>>2]|0;do if(l>>>0>k>>>0|((l|0)==(k|0)?j>>>0>(c[i>>2]|0)>>>0:0)){vt(b);b=f+8+3|0;if((a[b>>0]|0)<0){y7(c[f>>2]|0,0);c[f+4>>2]=0;break}else{y7(f,0);a[b>>0]=0;break}}else{H1(f,(c[b+544>>2]|0)+(c[b+612>>2]|0)+h|0,d)|0;k=g;k=z0(c[k>>2]|0,c[k+4>>2]|0,d|0,e|0)|0;l=g;c[l>>2]=k;c[l+4>>2]=z}while(0);return}function av(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;m=b+4|0;f=c[b>>2]|0;n=((c[m>>2]|0)-f|0)/40|0;h=a[d+8+3>>0]|0;i=h<<24>>24<0;h=i?c[d+4>>2]|0:h&255;i=i?c[d>>2]|0:d;g=0;while(1){if(g>>>0>=n>>>0){o=7;break}j=c[f+(g*40|0)>>2]|0;k=j;if(((c[f+(g*40|0)+4>>2]|0)!=(j|0)?(p=a[k+8+3>>0]|0,l=p<<24>>24<0,((l?c[k+4>>2]|0:p&255)|0)==(h|0)):0)?(L$(l?c[k>>2]|0:j,i,h)|0)==0:0)break;g=g+1|0}if((o|0)==7){IE(b,d,n);f=c[b>>2]|0;g=(((c[m>>2]|0)-f|0)/40|0)+-1|0}return DN(f+(g*40|0)|0,e)|0}function bv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;f=a+36|0;g=a+40|0;e=0;while(1){b=c[g>>2]|0;h=c[f>>2]|0;d=h;if(e>>>0>=b-h>>2>>>0)break;b=c[d+(e<<2)>>2]|0;do if(b|0){if(c[b+728>>2]&1){jb[c[(c[b>>2]|0)+32>>2]&511](b);Gb(c[a>>2]|0,c[(c[f>>2]|0)+(e<<2)>>2]|0,0,0,0,0)|0;Gb(c[a>>2]|0,c[(c[f>>2]|0)+(e<<2)>>2]|0,2,0,0,0)|0;b=c[(c[f>>2]|0)+(e<<2)>>2]|0;if(!b)break}jb[c[(c[b>>2]|0)+4>>2]&511](b)}while(0);e=e+1|0}while(1){if((b|0)==(d|0))break;h=b+-4|0;c[g>>2]=h;b=h}return}
function de(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;M=l;l=l+80|0;K=M+60|0;L=M+48|0;D=M+36|0;E=M+24|0;F=M+12|0;G=M;H=d+4|0;if((c[H>>2]|0)==(c[d>>2]|0))TX(b);else{TX(K);h=d+12|0;B=d+24|0;C=d+32+3|0;if((a[C>>0]|0)<0)e=c[B>>2]|0;else e=B;nt(E,h,c[e>>2]|0);Bs(D,E,42452);p2(L,D);O0(D);O0(E);n=L+8+3|0;o=L+4|0;p=D+8+3|0;q=D+4|0;r=d+20+3|0;J=d+16|0;s=d+28|0;t=E+8+3|0;u=E+4|0;v=D+8+3|0;w=D+4|0;x=D+8+3|0;y=D+4|0;m=0;while(1){A=c[d>>2]|0;z=A;if(m>>>0>=(((c[H>>2]|0)-A|0)/12|0)>>>0)break;A=z+(m*12|0)|0;k=a[z+(m*12|0)+8+3>>0]|0;j=k<<24>>24<0;if(j){g=c[z+(m*12|0)+4>>2]|0;i=c[A>>2]|0}else{g=k&255;i=A}f=a[n>>0]|0;N=f<<24>>24<0;e=N?c[L>>2]|0:L;f=N?c[o>>2]|0:f&255;do if(!((g|0)==0|(f|0)==0)?(g=i+(g<<2)|0,N=YL(i,g,e,e+(f<<2)|0)|0,!((N|0)==(g|0)|(N-i|0)==-4)):0){if(j){g=c[A>>2]|0;i=c[z+(m*12|0)+4>>2]|0}else{g=A;i=k&255}f=a[r>>0]|0;N=f<<24>>24<0;e=N?c[h>>2]|0:h;f=N?c[J>>2]|0:f&255;if(f|0?(i=g+(i<<2)|0,N=HA(g,i,e,e+(f<<2)|0)|0,(N|0)==(i|0)|(N-g|0)==-4):0){if(j){g=c[A>>2]|0;i=c[z+(m*12|0)+4>>2]|0}else{g=A;i=k&255}f=a[C>>0]|0;N=f<<24>>24<0;e=N?c[B>>2]|0:B;f=N?c[s>>2]|0:f&255;if(((f|0?(i=g+(i<<2)|0,N=HA(g,i,e,e+(f<<2)|0)|0,(N|0)==(i|0)|(N-g|0)==-4):0)?(oH(A,13,0)|0)==-1:0)?(oH(A,10,0)|0)==-1:0){Mq(D,A,h);N=a[x>>0]|0;A=N<<24>>24<0;Ex(K,A?c[D>>2]|0:D,A?c[y>>2]|0:N&255)|0;O0(D);break}}if(j){i=c[A>>2]|0;g=c[z+(m*12|0)+4>>2]|0}else{i=A;g=k&255}f=a[C>>0]|0;N=f<<24>>24<0;e=N?c[B>>2]|0:B;f=N?c[s>>2]|0:f&255;if(f|0?(k=i+(g<<2)|0,N=HA(i,k,e,e+(f<<2)|0)|0,(N|0)==(k|0)|(N-i|0)==-4):0){Mq(F,B,A);Mq(E,F,B);Mq(D,E,h);N=a[v>>0]|0;A=N<<24>>24<0;Ex(K,A?c[D>>2]|0:D,A?c[w>>2]|0:N&255)|0;O0(D);O0(E);O0(F);break}p2(D,z+(m*12|0)|0);Mq(E,B,B);vo(D,B,E,0,8);O0(E);Mq(G,B,D);Mq(F,G,B);Mq(E,F,h);N=a[t>>0]|0;A=N<<24>>24<0;Ex(K,A?c[E>>2]|0:E,A?c[u>>2]|0:N&255)|0;O0(E);O0(F);O0(G);z5(D)}else I=21;while(0);if((I|0)==21){I=0;Mq(D,A,h);N=a[p>>0]|0;A=N<<24>>24<0;Ex(K,A?c[D>>2]|0:D,A?c[q>>2]|0:N&255)|0;O0(D)}m=m+1|0}i=a[r>>0]|0;j=i<<24>>24<0;if(j)h=c[h>>2]|0;k=a[K+8+3>>0]|0;f=k<<24>>24<0;k=f?c[K+4>>2]|0:k&255;if(j)e=c[J>>2]|0;else e=i&255;e=k-e|0;g=f?c[K>>2]|0:K;f=i9(h)|0;do if(k>>>0>=e>>>0){if(f){N=g+(k<<2)|0;e=HA(g+(e<<2)|0,N,h,h+(f<<2)|0)|0;if((e|0)==(N|0))break;else e=e-g>>2}if((e|0)!=-1){if(j)e=c[J>>2]|0;else e=i&255;FB(K,k-e|0,0)}}while(0);p2(b,K);z5(L);z5(K)}l=M;return}function ee(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;O=l;l=l+16|0;C=O;f=a[b+840>>0]|0;K=b+48|0;L=b+612|0;M=d+48|0;N=d+40|0;switch(f<<24>>24){case -3:case -67:{f=f&255;g=c[b+804>>2]|0;h=g+(f*120|0)+80|0;j=h;i=c[j>>2]|0;j=c[j+4>>2]|0;k=b+774|0;m=d+117|0;n=g+(f*120|0)+118|0;if(!((i|0)==-1&(j|0)==-1)){if(a[n>>0]|0){x=K;x=z0(c[L>>2]|0,0,c[x>>2]|0,c[x+4>>2]|0)|0;y=d+72|0;c[y>>2]=x;c[y+4>>2]=z;y=d+80|0;c[y>>2]=i;c[y+4>>2]=j}if(!((a[k>>0]|0)==0|(a[m>>0]|0)==0)){x=K;x=z0(c[L>>2]|0,0,c[x>>2]|0,c[x+4>>2]|0)|0;w=N;c[w>>2]=x;c[w+4>>2]=z;w=h;x=c[w+4>>2]|0;y=M;c[y>>2]=c[w>>2];c[y+4>>2]=x;a[m>>0]=0}}f=g+(f*120|0)+96|0;h=f;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!((g|0)==-1&(h|0)==-1)){if(a[n>>0]|0){x=K;x=z0(c[L>>2]|0,0,c[x>>2]|0,c[x+4>>2]|0)|0;y=d+88|0;c[y>>2]=x;c[y+4>>2]=z;y=d+96|0;c[y>>2]=g;c[y+4>>2]=h}if(a[k>>0]|0?(p=f,o=c[p>>2]|0,p=c[p+4>>2]|0,!((o|0)==-1&(p|0)==-1|(a[m>>0]|0)==0)):0){y=d+64|0;c[y>>2]=o;c[y+4>>2]=p;a[m>>0]=0}}break}default:{}}q=d+28|0;r=d+32|0;h=c[r>>2]|0;g=c[q>>2]|0;s=b+528|0;t=b+536|0;f=g;if((h-g|0)==4?(c[(c[f>>2]|0)+728>>2]&8|0)!=0:0){M=t;N=s;N=D_(c[M>>2]|0,c[M+4>>2]|0,c[N>>2]|0,c[N+4>>2]|0)|0;e1(b,N,z)}else{u=b+544|0;v=b+492|0;w=b+378|0;x=b+848|0;y=d+36|0;n=d+119|0;o=b+656|0;p=b+360|0;d=b+128|0;i=0;j=h;while(1){if(i>>>0>=j-g>>2>>>0)break;f=c[f+(i<<2)>>2]|0;if((f|0)!=0?(c[f+728>>2]&8|0)==0:0){if(a[f+96>>0]|0){h=d;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!((g|0)==-1&(h|0)==-1)){m=f+128|0;c[m>>2]=g;c[m+4>>2]=h}sK(b,f);f=c[(c[q>>2]|0)+(i<<2)>>2]|0}m=s;j=c[m>>2]|0;k=(c[u>>2]|0)+(c[L>>2]|0)+j|0;h=t;m=D_(c[h>>2]|0,c[h+4>>2]|0,j|0,c[m+4>>2]|0)|0;Sc(b,f,k,m,1);if(a[v>>0]|0?(B=(c[(c[q>>2]|0)+(i<<2)>>2]|0)+360|0,A=c[B>>2]|0,B=c[B+4>>2]|0,!((A|0)==-1&(B|0)==-1)):0){m=p;c[m>>2]=A;c[m+4>>2]=B}if(!(a[w>>0]|0)){g=c[q>>2]|0;f=g;if(!(a[(c[g+(i<<2)>>2]|0)+378>>0]|0))k=f;else{m=x;m=PZ(c[m>>2]|0,c[m+4>>2]|0,2)|0;k=x;c[k>>2]=m;c[k+4>>2]=z;a[w>>0]=1;k=f}}else{g=c[q>>2]|0;k=g}f=c[r>>2]|0;do if(f-k>>2>>>0>1){h=c[g+(i<<2)>>2]|0;j=c[h+728>>2]|0;m=h;if((j&9|0)==8){if(h){jb[c[(c[h>>2]|0)+4>>2]&511](h);g=c[q>>2]|0;f=c[r>>2]|0}j=g+(i<<2)|0;g=j+4|0;h=f-g|0;k=h>>2;if(!k)g=f;else{TR(j|0,g|0,h|0)|0;f=c[r>>2]|0;g=f}h=j+(k<<2)|0;while(1){if((g|0)==(h|0))break;m=g+-4|0;c[r>>2]=m;f=m;g=m}i=i+-1|0;break}if(j&1){c[C>>2]=m;j=0;h=k;while(1){if(j>>>0>=f-h>>2>>>0)break;if((j|0)!=(i|0)?(D=c[g+(j<<2)>>2]|0,(D|0)!=0):0){jb[c[(c[D>>2]|0)+4>>2]&511](D);f=c[r>>2]|0;g=c[q>>2]|0}else g=h;j=j+1|0;h=g}j=f;h=(f-g|0)>>>2;f=j;while(1){if((f|0)==(g|0))break;k=f+-4|0;c[r>>2]=k;f=k}f=j+(0-h<<2)|0;if((f|0)==(c[y>>2]|0)){Yy(q,C);f=c[r>>2]|0}else{c[f>>2]=m;f=(c[r>>2]|0)+4|0;c[r>>2]=f}}}while(0);h=c[q>>2]|0;g=h;if((f-h|0)==4&(a[n>>0]|0)==0?(c[(c[g>>2]|0)+728>>2]&2|0)!=0:0){a[e>>0]=(a[e>>0]|0)+-1<<24>>24;a[n>>0]=1;g=c[q>>2]|0;f=c[r>>2]|0;h=g}if(((f-h|0)==4?(F=(c[g>>2]|0)+280|0,E=c[F>>2]|0,F=c[F+4>>2]|0,H=M,G=c[H>>2]|0,H=c[H+4>>2]|0,!((E|0)==-1&(F|0)==-1|(G|0)==-1&(H|0)==-1)):0)?(I=cT((+(E>>>0)+4294967296.0*+(F>>>0))*90.0/1.0e6)|0,J=z,(J|0)<(H|0)|(J|0)==(H|0)&I>>>0<G>>>0):0){m=K;m=z0(c[L>>2]|0,0,c[m>>2]|0,c[m+4>>2]|0)|0;k=o;k=D_(m|0,z|0,c[k>>2]|0,c[k+4>>2]|0)|0;m=N;c[m>>2]=k;c[m+4>>2]=z;m=M;c[m>>2]=I;c[m+4>>2]=J}}else{f=j;h=g}i=i+1|0;g=h;j=f;f=h}M_(b)}l=O;return}function fe(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;G=l;l=l+96|0;v=G+87|0;x=G+86|0;f=G+85|0;o=G+84|0;B=G+72|0;C=G+60|0;D=G+48|0;E=G+36|0;F=G+24|0;y=G+12|0;A=G;t=e+528|0;if(a[e+770>>0]|0){s=t;s=z0(c[s>>2]|0,c[s+4>>2]|0,1,0)|0;u=t;c[u>>2]=s;c[u+4>>2]=z}bB(e,v);r=t;r=z0(c[r>>2]|0,c[r+4>>2]|0,1,0)|0;q=t;c[q>>2]=r;c[q+4>>2]=z;bB(e,x);Bx(e);q=e+648|0;d4(c[q>>2]|0,6);xR(e,2,e+876|0);d4(c[q>>2]|0,3);xR(e,5,f);wK(e);r=e+520|0;u=e+536|0;s=e+612|0;g=a[f>>0]|0;f=0;while(1){if((f&255)>=(g&255))break;GC(e);NB(e,B);Bx(e);RS(e);d4(c[q>>2]|0,2);d4(c[q>>2]|0,5);wK(e);j=t;h=c[j>>2]|0;i=b[B>>1]|0;j=z0(h|0,c[j+4>>2]|0,-1,-1)|0;j=z0(i&65535|0,0,j|0,z|0)|0;k=z;n=u;m=c[n>>2]|0;n=c[n+4>>2]|0;if(k>>>0>n>>>0|(k|0)==(n|0)&j>>>0>m>>>0){p=6;break}c[s>>2]=(c[s>>2]|0)+h;H=t;c[H>>2]=0;c[H+4>>2]=0;H=(i&65535)-(i<<16>>16!=0&1)|0;i=u;c[i>>2]=H;c[i+4>>2]=((H|0)<0)<<31>>31;i=r;c[i>>2]=7;c[i+4>>2]=0;jb[c[(c[e>>2]|0)+104>>2]&511](e);c[s>>2]=(c[s>>2]|0)-h;i=t;c[i>>2]=j;c[i+4>>2]=k;k=u;c[k>>2]=m;c[k+4>>2]=n;J3(e);f=f+1<<24>>24}if((p|0)==6)t4(e);bB(e,o);i=a[o>>0]|0;g=0;while(1){if((g&255)>=(i&255)){p=13;break}GC(e);NB(e,B);Bx(e);RS(e);d4(c[q>>2]|0,2);d4(c[q>>2]|0,5);wK(e);k=t;j=c[k>>2]|0;k=c[k+4>>2]|0;n=u;m=c[n>>2]|0;n=c[n+4>>2]|0;c[s>>2]=(c[s>>2]|0)+j;o=t;c[o>>2]=0;c[o+4>>2]=0;o=b[B>>1]|0;h=(o&65535)+-1|0;f=((h|0)<0)<<31>>31;H=u;c[H>>2]=h;c[H+4>>2]=f;H=D_(m|0,n|0,j|0,k|0)|0;p=z;if(f>>>0>p>>>0|(f|0)==(p|0)&h>>>0>H>>>0){p=12;break}p=r;c[p>>2]=8;c[p+4>>2]=0;jb[c[(c[e>>2]|0)+104>>2]&511](e);c[s>>2]=(c[s>>2]|0)-j;p=z0(j|0,k|0,-1,-1)|0;p=z0(p|0,z|0,o&65535|0,0)|0;H=t;c[H>>2]=p;c[H+4>>2]=z;H=u;c[H>>2]=m;c[H+4>>2]=n;J3(e);g=g+1<<24>>24}if((p|0)==12){g=0;i=0}else if((p|0)==13){i=t;h=u;f=c[h+4>>2]|0;g=c[i+4>>2]|0;h=c[h>>2]|0;i=c[i>>2]|0}if(f>>>0>g>>>0|(f|0)==(g|0)&h>>>0>i>>>0){g=D_(h|0,f|0,i|0,g|0)|0;e1(e,g,z);g=t;f=u;i=c[g>>2]|0;h=c[f>>2]|0;g=c[g+4>>2]|0;f=c[f+4>>2]|0}if(!((i|0)==(h|0)&(g|0)==(f|0)))t4(e);if(qO(e)|0){f=c[e+840>>2]|0;do if((f|0)!=(c[e+844>>2]|0)?(w=c[f>>2]|0,w|0):0){f=a[v>>0]|0;if(f<<24>>24==(a[w+39>>0]|0)?(a[x>>0]|0)==(a[w+40>>0]|0):0)break;VU(F,380634);TX(y);cC(y,Fz(f)|0)|0;f=a[y+8+3>>0]|0;H=f<<24>>24<0;Ex(F,H?c[y>>2]|0:y,H?c[y+4>>2]|0:f&255)|0;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];f=0;while(1){if((f|0)==3)break;c[F+(f<<2)>>2]=0;f=f+1|0}HX(E,54768)|0;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];f=0;while(1){if((f|0)==3)break;c[E+(f<<2)>>2]=0;f=f+1|0}TX(A);io(A,+(d[x>>0]|0)/10.0,1)|0;f=a[A+8+3>>0]|0;H=f<<24>>24<0;Ex(D,H?c[A>>2]|0:A,H?c[A+4>>2]|0:f&255)|0;c[C>>2]=c[D>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];f=0;while(1){if((f|0)==3)break;c[D+(f<<2)>>2]=0;f=f+1|0}p2(B,C);vF(e+1008|0,B)|0;z5(B);O0(C);z5(A);O0(D);O0(E);z5(y);z5(F)}while(0);a[e+769>>0]=0;if(!(c[e+728>>2]&1))W5(e)}l=G;return}function ge(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=l;l=l+80|0;z=G+56|0;e=G+52|0;D=G+48|0;E=G+44|0;p=G+40|0;h=G+36|0;o=G+32|0;F=G+28|0;q=G+24|0;r=G+20|0;s=G+16|0;t=G+12|0;u=G+8|0;v=G+4|0;C=G+66|0;w=G+65|0;x=G+64|0;y=G+63|0;A=G+62|0;k=G+61|0;B=G+60|0;i=G;c[z>>2]=0;c[e>>2]=1;c[D>>2]=0;c[E>>2]=0;c[o>>2]=-1;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;a[y>>0]=0;a[A>>0]=0;a[B>>0]=0;bB(b,C);Bx(b);GC(b);n=b+648|0;A6(c[n>>2]|0);A6(c[n>>2]|0);A6(c[n>>2]|0);AT(b,x);A6(c[n>>2]|0);A6(c[n>>2]|0);G4(c[n>>2]|0,2);J3(b);xR(b,8,w);n3(b,d);C=a[C>>0]|0;switch(C<<24>>24){case -118:case -128:case 118:case 86:case 83:case 44:case -12:case 122:case 110:case 100:{GC(b);n3(b,e);f=c[e>>2]|0;if((f|0)==3)AT(b,y);n3(b,D);n3(b,E);A6(c[n>>2]|0);if(K6(c[n>>2]|0)|0){GC(b);A6(c[n>>2]|0);g=(f|0)!=3?8:12;e=0;while(1){if((e|0)==(g|0))break;if(K6(c[n>>2]|0)|0){GC(b);A6(c[n>>2]|0);UK(b,e>>>0<6?16:64);J3(b)}else A6(c[n>>2]|0);e=e+1|0}J3(b)}else A6(c[n>>2]|0);J3(b);j=f&255;break}default:j=1}n3(b,p);n3(b,h);h=c[h>>2]|0;a:do switch(h|0){case 0:{n3(b,o);m=23;break}case 1:{AT(b,A);L5(b);L5(b);n3(b,i);f=c[i>>2]|0;if(f>>>0>255){t4(b);e=0;break a}else e=0;while(1){if((e|0)==(f|0))break;L5(b);e=e+1|0}m=23;break}default:if(h>>>0>2){t4(b);e=0}else m=23}while(0);do if((m|0)==23){n3(b,F);A6(c[n>>2]|0);n3(b,q);n3(b,r);AT(b,k);g=a[k>>0]|0;if(!(g<<24>>24))AT(b,B);A6(c[n>>2]|0);if(K6(c[n>>2]|0)|0){GC(b);A6(c[n>>2]|0);n3(b,s);n3(b,t);n3(b,u);n3(b,v);J3(b)}else A6(c[n>>2]|0);if(K6(c[n>>2]|0)|0){GC(b);A6(c[n>>2]|0);De(b,z);J3(b)}else A6(c[n>>2]|0);if(!(qO(b)|0)){e=c[z>>2]|0;if(!e){e=0;break}JO(e);laa(e);e=0;break}if((c[d>>2]|0)>>>0>31){t4(b);e=c[z>>2]|0;if(!e){e=0;break}JO(e);laa(e);e=0;break}f=c[o>>2]|0;if((h|0)==0&f>>>0>12){t4(b);e=c[z>>2]|0;if(!e){e=0;break}JO(e);laa(e);e=0;break}e=c[p>>2]|0;if(e>>>0<=12){b=ZW(56)|0;Np(b,c[z>>2]|0,c[q>>2]|0,c[r>>2]|0,c[s>>2]|0,c[t>>2]|0,c[u>>2]|0,c[v>>2]|0,j,C,a[w>>0]|0,c[D>>2]&255,c[E>>2]&255,e&255,h&255,f&255,c[F>>2]&255,(a[x>>0]|0)!=0,(a[y>>0]|0)!=0,(a[A>>0]|0)!=0,g<<24>>24!=0,(a[B>>0]|0)!=0);e=b;break}t4(b);e=c[z>>2]|0;if(!e)e=0;else{JO(e);laa(e);e=0}}while(0);l=G;return e|0}function he(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;p=l;l=l+48|0;g=p+36|0;n=p+24|0;o=p+12|0;i=p;ID(b,g);f=b+536|0;d=b+528|0;d=D_(c[f>>2]|0,c[f+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;f=z;if(!((d|0)==0&(f|0)==0))e1(b,d,f);k=qO(b)|0;d=(a[b+768>>0]|0)==2;f=b+784|0;do if(k){if(d){h=c[g>>2]|0;k=b+760|0;d=c[k>>2]|0;if(!(a[f>>0]|0)){c[($C((HD(d+68|0,d)|0)+16|0,b+770|0)|0)+68>>2]=h;break}j=b+772|0;f=c[(c[d+80>>2]|0)+(e[j>>1]<<2)>>2]|0;c[f+160>>2]=h;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;g=j9(387784)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[n+11>>0]=g;d=n}else{q=g+16&-16;d=ZW(q)|0;c[n>>2]=d;c[n+8>>2]=q|-2147483648;c[n+4>>2]=g}i1(d,387784,g)|0;J7(d+g|0,0);d=VC(f+28|0,n)|0;a1(n);TX(n);k1(d,lh(n,h)|0)|0;z5(n);q=a[d+8+3>>0]|0;if(((q<<24>>24<0?c[d+4>>2]|0:q&255)|0)!=4){TX(n);Gk(n,h,16)|0;f=a[n+8+3>>0]|0;f=f<<24>>24<0?c[n+4>>2]|0:f&255;if(f>>>0<8)Yv(n,8-f|0,48)|0;ms(i,42152,n);p2(o,i);vF(d,o)|0;z5(o);O0(i);z5(n)}Xy(n,41856);f=c[(c[(c[k>>2]|0)+80>>2]|0)+(e[j>>1]<<2)>>2]|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;g=j9(387784)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[o+11>>0]=g;d=o}else{q=g+16&-16;d=ZW(q)|0;c[o>>2]=d;c[o+8>>2]=q|-2147483648;c[o+4>>2]=g}i1(d,387784,g)|0;J7(d+g|0,0);vF(VC(f+40|0,o)|0,n)|0;a1(o);z5(n);if((h|0)==1263294017){Xy(n,40080);f=c[(c[(c[k>>2]|0)+80>>2]|0)+(e[j>>1]<<2)>>2]|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;g=j9(384476)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[o+11>>0]=g;d=o}else{q=g+16&-16;d=ZW(q)|0;c[o>>2]=d;c[o+8>>2]=q|-2147483648;c[o+4>>2]=g}i1(d,384476,g)|0;J7(d+g|0,0);vF(VC(f+28|0,o)|0,n)|0;a1(o);z5(n);q=c[k>>2]|0;a[($C((HD(q+68|0,q)|0)+16|0,b+770|0)|0)+81>>0]=1}if((a[b+780>>0]|0)==-127?(m=(c[(c[(c[k>>2]|0)+80>>2]|0)+(e[j>>1]<<2)>>2]|0)+160|0,(c[m>>2]|0)==1112757060):0)c[m>>2]=0}}else if(d?a[f>>0]|0:0){Xy(n,40096);i=b+760|0;f=b+772|0;g=c[(c[(c[i>>2]|0)+80>>2]|0)+(e[f>>1]<<2)>>2]|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;h=j9(387784)|0;if(h>>>0>4294967279)uaa();if(h>>>0<11){a[o+11>>0]=h;d=o}else{q=h+16&-16;d=ZW(q)|0;c[o>>2]=d;c[o+8>>2]=q|-2147483648;c[o+4>>2]=h}i1(d,387784,h)|0;J7(d+h|0,0);vF(VC(g+28|0,o)|0,n)|0;a1(o);z5(n);Xy(n,41856);f=c[(c[(c[i>>2]|0)+80>>2]|0)+(e[f>>1]<<2)>>2]|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;g=j9(387784)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[o+11>>0]=g;d=o}else{q=g+16&-16;d=ZW(q)|0;c[o>>2]=d;c[o+8>>2]=q|-2147483648;c[o+4>>2]=g}i1(d,387784,g)|0;J7(d+g|0,0);vF(VC(f+40|0,o)|0,n)|0;a1(o);z5(n)}while(0);l=p;return}function ie(e){e=e|0;var f=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;v=l;l=l+16|0;m=v;h=v+6|0;k=v+5|0;n=v+4|0;vD(e,m);o=e+536|0;r=e+1404|0;p=e+528|0;a:do if((c[m>>2]|0)==16282223){if(((c[e+612>>2]|0)+28|0)>>>0>(c[e+548>>2]|0)>>>0){t4(e);break}GC(e);m=p;m=z0(c[m>>2]|0,c[m+4>>2]|0,3,0)|0;j=p;c[j>>2]=m;c[j+4>>2]=z;j=e+1402|0;bB(e,j);m=e+1407|0;switch(a[j>>0]|0){case -70:{Bx(e);xR(e,4,r);f=e+648|0;d4(c[f>>2]|0,8);xR(e,5,e+1406|0);d4(c[f>>2]|0,2);sR(e,13,e+1178|0);wK(e);a[m>>0]=24;a[e+1408>>0]=24;a[e+1405>>0]=a[r>>0]|0;break}case -69:{Bx(e);xR(e,4,m);xR(e,4,e+1408|0);xR(e,4,r);xR(e,4,e+1405|0);f=e+648|0;d4(c[f>>2]|0,11);q=e+1406|0;xR(e,5,q);wK(e);b[e+1178>>1]=d[q>>0]|0;break}default:{t=o;u=p;e1(e,D_(c[t>>2]|0,c[t+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0,z);break a}}w=p;w=z0(c[w>>2]|0,c[w+4>>2]|0,6,0)|0;i=p;c[i>>2]=w;c[i+4>>2]=z;Bx(e);AT(e,e+1487|0);sR(e,15,e+1176|0);i=e+1403|0;xR(e,4,i);d4(c[f>>2]|0,4);wK(e);w=p;w=z0(c[w>>2]|0,c[w+4>>2]|0,8,0)|0;q=p;c[q>>2]=w;c[q+4>>2]=z;Bx(e);d4(c[f>>2]|0,7);AT(e,h);wK(e);if(a[h>>0]|0){a[k>>0]=0;a[n>>0]=0;Bx(e);xR(e,4,k);xR(e,4,n);f=(a[n>>0]|0)!=0;wK(e);h=(d[k>>0]<<1|1)&255;while(1){if(!(h<<24>>24))break;bB(e,n);f=f|(a[n>>0]|0)!=0;h=h+-1<<24>>24}a[k>>0]=0;if(f)a[e+1488>>0]=1}J3(e);if((qO(e)|0?(a[e+1484>>0]=1,(a[i>>0]|0)==1):0)?(a[j>>0]|0)==-69:0){a[e+1408>>0]=a[m>>0]|0;a[e+1405>>0]=a[r>>0]|0}q=20}else q=20;while(0);if((q|0)==20){n=o;w=p;w=D_(c[n>>2]|0,c[n+4>>2]|0,c[w>>2]|0,c[w+4>>2]|0)|0;e1(e,w,z);w=o;if(!((c[p>>2]|0)==(c[w>>2]|0)?(c[p+4>>2]|0)==(c[w+4>>2]|0):0))t4(e);if(qO(e)|0){n=e+312|0;h=n;f=c[h>>2]|0;h=c[h+4>>2]|0;m=e+136|0;if((f|0)==0&(h|0)==0){o=m;p=c[o+4>>2]|0;w=e+280|0;c[w>>2]=c[o>>2];c[w+4>>2]=p}i=z0(f|0,h|0,1,0)|0;f=n;c[f>>2]=i;c[f+4>>2]=z;f=e+328|0;i=f;i=z0(c[i>>2]|0,c[i+4>>2]|0,1,0)|0;c[f>>2]=i;c[f+4>>2]=z;f=e+360|0;i=f;h=c[i>>2]|0;i=c[i+4>>2]|0;if(!((h|0)==-1&(i|0)==-1)){p=z0(h|0,i|0,1,0)|0;w=f;c[w>>2]=p;c[w+4>>2]=z}h=e+152|0;f=h;c[f>>2]=833333;c[f+4>>2]=0;f=Z0(a[r>>0]|0)|0;if((f|0)<48e3)switch(f|0){case 0:{j=833333;k=0;break}default:q=28}else switch(f|0){case 48e3:{j=833333;k=0;break}default:q=28}if((q|0)==28){j=g5(1345278336,9,f|0,0)|0;k=z;w=h;c[w>>2]=j;c[w+4>>2]=k}f=e+144|0;i=f;h=c[i>>2]|0;i=c[i+4>>2]|0;if(!((h|0)==-1&(i|0)==-1)){r=z0(h|0,i|0,j|0,k|0)|0;w=f;c[w>>2]=r;c[w+4>>2]=z}h=m;f=c[h>>2]|0;h=c[h+4>>2]|0;if(!((f|0)==-1&(h|0)==-1)){r=z0(f|0,h|0,j|0,k|0)|0;w=m;c[w>>2]=r;c[w+4>>2]=z}f=e+728|0;if((c[f>>2]&1|0)==0?(W5(e),s=e+760|0,u=s,t=c[u>>2]|0,u=c[u+4>>2]|0,u>>>0<0|(u|0)==0&t>>>0<1e4):0){u=PZ(t|0,u|0,5)|0;w=s;c[w>>2]=u;c[w+4>>2]=z}if(((((c[f>>2]&2|0)==0?(a[e+1489>>0]|0)==0:0)?(u=n,s=c[u+4>>2]|0,w=e+760|0,t=c[w+4>>2]|0,!(s>>>0<t>>>0|((s|0)==(t|0)?(c[u>>2]|0)>>>0<(c[w>>2]|0)>>>0:0))):0)?(t6(e),(a[e+492>>0]|0)==0):0)?+g[(c[e+24>>2]|0)+136>>2]<1.0:0)V5(e)}}l=v;return}function je(b,d,e,f,g,h,i,j,k,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+16|0;t=u;p=i+4|0;r=j+4|0;n=k+4|0;q=i+11|0;s=j+8+3|0;o=k+8+3|0;if(b){b=u$(e,410852)|0;e=c[b>>2]|0;if(d){kb[c[e+44>>2]&63](t,b);d=c[t>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;kb[c[(c[b>>2]|0)+32>>2]&63](t,b);if((a[o>>0]|0)<0){y7(c[k>>2]|0,0);c[n>>2]=0}else{y7(k,0);a[o>>0]=0}pp(k,0);c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}O0(t)}else{kb[c[e+40>>2]&63](t,b);d=c[t>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;kb[c[(c[b>>2]|0)+28>>2]&63](t,b);if((a[o>>0]|0)<0){y7(c[k>>2]|0,0);c[n>>2]=0}else{y7(k,0);a[o>>0]=0}pp(k,0);c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}O0(t)}c[g>>2]=nb[c[(c[b>>2]|0)+12>>2]&255](b)|0;c[h>>2]=nb[c[(c[b>>2]|0)+16>>2]&255](b)|0;kb[c[(c[b>>2]|0)+20>>2]&63](t,b);if((a[q>>0]|0)<0){J7(c[i>>2]|0,0);c[p>>2]=0}else{J7(i,0);a[q>>0]=0}Fp(i,0);c[i>>2]=c[t>>2];c[i+4>>2]=c[t+4>>2];c[i+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}a1(t);kb[c[(c[b>>2]|0)+24>>2]&63](t,b);if((a[s>>0]|0)<0){y7(c[j>>2]|0,0);c[r>>2]=0}else{y7(j,0);a[s>>0]=0}pp(j,0);c[j>>2]=c[t>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}O0(t);e=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0}else{b=u$(e,410844)|0;e=c[b>>2]|0;if(d){kb[c[e+44>>2]&63](t,b);d=c[t>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;kb[c[(c[b>>2]|0)+32>>2]&63](t,b);if((a[o>>0]|0)<0){y7(c[k>>2]|0,0);c[n>>2]=0}else{y7(k,0);a[o>>0]=0}pp(k,0);c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}O0(t)}else{kb[c[e+40>>2]&63](t,b);d=c[t>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;kb[c[(c[b>>2]|0)+28>>2]&63](t,b);if((a[o>>0]|0)<0){y7(c[k>>2]|0,0);c[n>>2]=0}else{y7(k,0);a[o>>0]=0}pp(k,0);c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}O0(t)}c[g>>2]=nb[c[(c[b>>2]|0)+12>>2]&255](b)|0;c[h>>2]=nb[c[(c[b>>2]|0)+16>>2]&255](b)|0;kb[c[(c[b>>2]|0)+20>>2]&63](t,b);if((a[q>>0]|0)<0){J7(c[i>>2]|0,0);c[p>>2]=0}else{J7(i,0);a[q>>0]=0}Fp(i,0);c[i>>2]=c[t>>2];c[i+4>>2]=c[t+4>>2];c[i+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}a1(t);kb[c[(c[b>>2]|0)+24>>2]&63](t,b);if((a[s>>0]|0)<0){y7(c[j>>2]|0,0);c[r>>2]=0}else{y7(j,0);a[s>>0]=0}pp(j,0);c[j>>2]=c[t>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}O0(t);e=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0}c[m>>2]=e;l=u;return}function ke(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+48|0;h=u+24|0;r=u+33|0;e=u+32|0;i=u+31|0;f=u+30|0;g=u+29|0;j=u+20|0;k=u+16|0;s=u+12|0;n=u+8|0;o=u+4|0;p=u;q=u+28|0;Bx(b);xR(b,4,r);do if(!(a[b+771>>0]|0)){m=b+648|0;d4(c[m>>2]|0,2);d4(c[m>>2]|0,6);xR(b,3,e);t=a[e>>0]|0;if((t&255)>6){t4(b);wK(b);break}AT(b,f);d4(c[m>>2]|0,16);Fi(b,t);AT(b,g);f=t&255;e=a[g>>0]|0?0:f;while(1){if(e>>>0>f>>>0)break;GC(b);T5(b);T5(b);T5(b);J3(b);e=e+1|0}xR(b,6,i);n3(b,h);h=c[h>>2]|0;if(h>>>0>1023){t4(b);wK(b);break}g=a[i>>0]|0;f=1;while(1){if(f>>>0>h>>>0)break;else e=0;while(1){if((e&255)>(g&255))break;A6(c[m>>2]|0);e=e+1<<24>>24}f=f+1|0}if(K6(c[m>>2]|0)|0){GC(b);A6(c[m>>2]|0);d4(c[m>>2]|0,32);rR(b,32,j);if(!(c[j>>2]|0)){t4(b);J3(b);wK(b);break}if(K6(c[m>>2]|0)|0){GC(b);A6(c[m>>2]|0);T5(b);J3(b)}else A6(c[m>>2]|0);n3(b,k);e=c[k>>2]|0;if(e>>>0>1024){t4(b);c[k>>2]=0;e=0}g=0;while(1){if((g|0)==(e|0))break;c[s>>2]=0;c[n>>2]=0;c[o>>2]=0;n3(b,p);if((c[p>>2]|0)>>>0>1023)t4(b);if(!g){a[q>>0]=1;f=1}else{AT(b,q);f=a[q>>0]|0}th(b,f<<24>>24!=0,t,s,n,o);f=c[s>>2]|0;if(f|0)laa(f);f=c[n>>2]|0;if(f|0){VZ(f);laa(f)}f=c[o>>2]|0;if(f|0){VZ(f);laa(f)}g=g+1|0}J3(b)}else A6(c[m>>2]|0);a:do if(K6(c[m>>2]|0)|0){GC(b);A6(c[m>>2]|0);s=c[m>>2]|0;G4(s,Z9(c[s+4>>2]|0)|0);t4(b);J3(b)}else{A6(c[m>>2]|0);KS(b);while(1){if(!(Z9(c[(c[m>>2]|0)+4>>2]|0)|0))break a;RS(b)}}while(0);wK(b);q=b+528|0;s=b+536|0;if(!((c[q>>2]|0)==(c[s>>2]|0)?(c[q+4>>2]|0)==(c[s+4>>2]|0):0))t4(b);if(qO(b)|0){g=d[r>>0]|0;f=b+796|0;e=c[f>>2]|0;if(g>>>0>=(c[b+800>>2]|0)-e>>2>>>0){FF(f,g+1|0);e=c[f>>2]|0}e=e+(g<<2)|0;f=c[e>>2]|0;if(f|0)laa(f);s=ZW(1)|0;k5(s,t);c[e>>2]=s;s_(b);AR(b,33,0);b=c[b+776>>2]|0;a[b+33>>0]=1;a[b+36>>0]=1;a[b+37>>0]=1;a[b+38>>0]=1}}else{wK(b);f=b+536|0;g=b+528|0;g=D_(c[f>>2]|0,c[f+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0)|0;e1(b,g,z);g=d[r>>0]|0;f=b+796|0;e=c[f>>2]|0;if(g>>>0>=(c[b+800>>2]|0)-e>>2>>>0){FF(f,g+1|0);e=c[f>>2]|0}e=e+(g<<2)|0;f=c[e>>2]|0;if(f|0)laa(f);t=ZW(1)|0;k5(t,0);c[e>>2]=t;s_(b);AR(b,33,0);b=c[b+776>>2]|0;a[b+33>>0]=1;a[b+36>>0]=1;a[b+37>>0]=1;a[b+38>>0]=1}while(0);l=u;return}function le(b,d,e,f,g,h,i,j,k,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+16|0;t=u;p=i+4|0;r=j+4|0;n=k+4|0;o=k+11|0;q=i+11|0;s=j+11|0;if(b){b=u$(e,410836)|0;e=c[b>>2]|0;if(d){kb[c[e+44>>2]&63](t,b);d=c[t>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;kb[c[(c[b>>2]|0)+32>>2]&63](t,b);if((a[o>>0]|0)<0){J7(c[k>>2]|0,0);c[n>>2]=0}else{J7(k,0);a[o>>0]=0}Fp(k,0);c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}a1(t)}else{kb[c[e+40>>2]&63](t,b);d=c[t>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;kb[c[(c[b>>2]|0)+28>>2]&63](t,b);if((a[o>>0]|0)<0){J7(c[k>>2]|0,0);c[n>>2]=0}else{J7(k,0);a[o>>0]=0}Fp(k,0);c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}a1(t)}a[g>>0]=nb[c[(c[b>>2]|0)+12>>2]&255](b)|0;a[h>>0]=nb[c[(c[b>>2]|0)+16>>2]&255](b)|0;kb[c[(c[b>>2]|0)+20>>2]&63](t,b);if((a[q>>0]|0)<0){J7(c[i>>2]|0,0);c[p>>2]=0}else{J7(i,0);a[q>>0]=0}Fp(i,0);c[i>>2]=c[t>>2];c[i+4>>2]=c[t+4>>2];c[i+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}a1(t);kb[c[(c[b>>2]|0)+24>>2]&63](t,b);if((a[s>>0]|0)<0){J7(c[j>>2]|0,0);c[r>>2]=0}else{J7(j,0);a[s>>0]=0}Fp(j,0);c[j>>2]=c[t>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}a1(t);e=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0}else{b=u$(e,410828)|0;e=c[b>>2]|0;if(d){kb[c[e+44>>2]&63](t,b);d=c[t>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;kb[c[(c[b>>2]|0)+32>>2]&63](t,b);if((a[o>>0]|0)<0){J7(c[k>>2]|0,0);c[n>>2]=0}else{J7(k,0);a[o>>0]=0}Fp(k,0);c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}a1(t)}else{kb[c[e+40>>2]&63](t,b);d=c[t>>2]|0;a[f>>0]=d;a[f+1>>0]=d>>8;a[f+2>>0]=d>>16;a[f+3>>0]=d>>24;kb[c[(c[b>>2]|0)+28>>2]&63](t,b);if((a[o>>0]|0)<0){J7(c[k>>2]|0,0);c[n>>2]=0}else{J7(k,0);a[o>>0]=0}Fp(k,0);c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];c[k+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}a1(t)}a[g>>0]=nb[c[(c[b>>2]|0)+12>>2]&255](b)|0;a[h>>0]=nb[c[(c[b>>2]|0)+16>>2]&255](b)|0;kb[c[(c[b>>2]|0)+20>>2]&63](t,b);if((a[q>>0]|0)<0){J7(c[i>>2]|0,0);c[p>>2]=0}else{J7(i,0);a[q>>0]=0}Fp(i,0);c[i>>2]=c[t>>2];c[i+4>>2]=c[t+4>>2];c[i+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}a1(t);kb[c[(c[b>>2]|0)+24>>2]&63](t,b);if((a[s>>0]|0)<0){J7(c[j>>2]|0,0);c[r>>2]=0}else{J7(j,0);a[s>>0]=0}Fp(j,0);c[j>>2]=c[t>>2];c[j+4>>2]=c[t+4>>2];c[j+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}a1(t);e=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0}c[m>>2]=e;l=u;return}function me(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;E=l;l=l+112|0;B=E+88|0;C=E+76|0;D=E+64|0;v=E+52|0;w=E+48|0;x=E+101|0;y=E+100|0;z=E+36|0;A=E+24|0;i=E+12|0;j=E;TX(B);TX(C);k=b+528|0;m=b+536|0;n=D+8+3|0;o=D+4|0;p=A+8+3|0;q=A+4|0;r=v+8+3|0;s=v+4|0;t=A+8+3|0;u=A+4|0;while(1){g=k;e=c[g+4>>2]|0;h=m;f=c[h+4>>2]|0;if(!(e>>>0<f>>>0|((e|0)==(f|0)?(c[g>>2]|0)>>>0<(c[h>>2]|0)>>>0:0)))break;TX(D);TX(v);s3(b,w);bB(b,x);Ko(b,d[x>>0]|0,0,D);bB(b,y);Ko(b,d[y>>0]|0,0,v);if(qO(b)|0){TX(A);p2(z,Tv(A,c[w>>2]|0)|0);z5(A);f=SG(z)|0;g=f+8+3|0;e=a[g>>0]|0;h=f+4|0;nt(j,((e<<24>>24<0?c[h>>2]|0:e&255)|0)==0?z:f,58);e=a[n>>0]|0;F=e<<24>>24<0;Ex(j,F?c[D>>2]|0:D,F?c[o>>2]|0:e&255)|0;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];e=0;while(1){if((e|0)==3)break;c[j+(e<<2)>>2]=0;e=e+1|0}HX(i,41596)|0;c[A>>2]=c[i>>2];c[A+4>>2]=c[i+4>>2];c[A+8>>2]=c[i+8>>2];e=0;while(1){if((e|0)==3)break;c[i+(e<<2)>>2]=0;e=e+1|0}e=a[p>>0]|0;F=e<<24>>24<0;Ex(B,F?c[A>>2]|0:A,F?c[q>>2]|0:e&255)|0;O0(A);O0(i);O0(j);e=a[g>>0]|0;nt(j,((e<<24>>24<0?c[h>>2]|0:e&255)|0)==0?z:f,58);e=a[r>>0]|0;F=e<<24>>24<0;Ex(j,F?c[v>>2]|0:v,F?c[s>>2]|0:e&255)|0;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];e=0;while(1){if((e|0)==3)break;c[j+(e<<2)>>2]=0;e=e+1|0}HX(i,41596)|0;c[A>>2]=c[i>>2];c[A+4>>2]=c[i+4>>2];c[A+8>>2]=c[i+8>>2];e=0;while(1){if((e|0)==3)break;c[i+(e<<2)>>2]=0;e=e+1|0}F=a[t>>0]|0;h=F<<24>>24<0;Ex(C,h?c[A>>2]|0:A,h?c[u>>2]|0:F&255)|0;O0(A);O0(i);O0(j);z5(z)}z5(v);z5(D)}e=a[B+8+3>>0]|0;e=e<<24>>24<0?c[B+4>>2]|0:e&255;i=b+760|0;j=b+774|0;k=b+785|0;h=b+770|0;if(e|0?(FB(B,e+-3|0,0),a[k>>0]|0):0){f=$C((HD((c[i>>2]|0)+68|0,h)|0)+16|0,j)|0;c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;g=j9(385621)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[D+11>>0]=g;e=D}else{F=g+16&-16;e=ZW(F)|0;c[D>>2]=e;c[D+8>>2]=F|-2147483648;c[D+4>>2]=g}i1(e,385621,g)|0;J7(e+g|0,0);k1(VC(f+4|0,D)|0,B)|0;a1(D)}e=a[C+8+3>>0]|0;e=e<<24>>24<0?c[C+4>>2]|0:e&255;if(e|0?(FB(C,e+-3|0,0),a[k>>0]|0):0){f=$C((HD((c[i>>2]|0)+68|0,h)|0)+16|0,j)|0;c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;g=j9(391021)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[D+11>>0]=g;e=D}else{F=g+16&-16;e=ZW(F)|0;c[D>>2]=e;c[D+8>>2]=F|-2147483648;c[D+4>>2]=g}i1(e,391021,g)|0;J7(e+g|0,0);k1(VC(f+4|0,D)|0,C)|0;a1(D)}z5(C);z5(B);l=E;return}function ne(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+64|0;r=u+48|0;s=u+36|0;o=u+24|0;p=u+12|0;q=u;k=d+8+3|0;h=a[k>>0]|0;g=h<<24>>24<0;m=d+4|0;h=g?c[m>>2]|0:h&255;do if(!h)t=7;else{i=g?c[d>>2]|0:d;j=i9(3912)|0;h=i+(h<<2)|0;g=i;while(1){if((g|0)==(h|0))break;if(!(U_(3912,j,g)|0)){t=6;break}g=g+4|0}if((t|0)==6?(g-i|0)!=-4:0){t=7;break}Bs(o,e,37572);p2(s,o);pl(r,s);n=a[r+8+3>>0]|0;n=((n<<24>>24<0?c[r+4>>2]|0:n&255)|0)==0;z5(r);z5(s);O0(o);if(n){pl(s,e);g=a[k>>0]|0;q=g<<24>>24<0;Ts(s,0,q?c[d>>2]|0:d,q?c[m>>2]|0:g&255)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];g=0;while(1){if((g|0)==3)break;c[s+(g<<2)>>2]=0;g=g+1|0}p2(b,r);O0(r);z5(s);break}do if(f)n=255;else{n=pn(d)|0;j=(n>>>0)%100|0;h=j>>>0<10;i=(j+-10|0)>>>0<10;j=((j>>>0)%10|0)&15;f=j>>>0<2;g=j>>>0<5?2:3;if(n>>>0>=100){n=f?3:g;n=h?n:i?3:n;break}if(!h){n=i|f?3:g;break}if((j|0)==0?(n=a[k>>0]|0,((n<<24>>24<0?c[m>>2]|0:n&255)|0)==1):0){n=0;break}n=f?1:g}while(0);p2(r,d);TX(p);io(p,0.0,1)|0;lw(o,p,1,1);p2(s,o);O0(o);z5(p);g=a[r+8+3>>0]|0;k=g<<24>>24<0;h=k?c[r>>2]|0:r;j=a[s+8+3>>0]|0;d=j<<24>>24<0;i=d?c[s>>2]|0:s;j=d?c[s+4>>2]|0:j&255;if(j){m=c[r+4>>2]|0;f=g&255;d=h+((k?m:f)<<2)|0;j=HA(h,d,i,i+(j<<2)|0)|0;g=j-h>>2;if((j|0)==(d|0)|(g|0)==-1)g=k?m:f;else t=23}else{g=0;t=23}if((t|0)==23){Xy(p,7160);pl(o,p);vo(r,s,o,g,0);z5(o);z5(p)}if(g>>>0>3){Xy(p,3368);pl(o,p);d=a[o+8+3>>0]|0;m=d<<24>>24<0;Ts(r,g+-3|0,m?c[o>>2]|0:o,m?c[o+4>>2]|0:d&255)|0;z5(o);z5(p)}switch((n&255)<<24>>24){case 0:{Bs(q,e,42196);p2(p,q);pl(o,p);vF(r,o)|0;z5(o);z5(p);O0(q);break}case 1:{Bs(q,e,37572);p2(p,q);pl(o,p);e=a[o+8+3>>0]|0;d=e<<24>>24<0;Ex(r,d?c[o>>2]|0:o,d?c[o+4>>2]|0:e&255)|0;z5(o);z5(p);O0(q);break}case 2:{Bs(q,e,25220);p2(p,q);pl(o,p);e=a[o+8+3>>0]|0;d=e<<24>>24<0;Ex(r,d?c[o>>2]|0:o,d?c[o+4>>2]|0:e&255)|0;z5(o);z5(p);O0(q);break}case 3:{Bs(q,e,3988);p2(p,q);pl(o,p);e=a[o+8+3>>0]|0;d=e<<24>>24<0;Ex(r,d?c[o>>2]|0:o,d?c[o+4>>2]|0:e&255)|0;z5(o);z5(p);O0(q);break}default:{pl(o,e);q=a[o+8+3>>0]|0;p=q<<24>>24<0;Ex(r,p?c[o>>2]|0:o,p?c[o+4>>2]|0:q&255)|0;z5(o)}}rV(b,r);z5(s);z5(r)}while(0);if((t|0)==7)p2(b,d);l=u;return}function oe(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;g=j;Eg(b);c[b>>2]=10168;h=b+760|0;c[h>>2]=0;i=b+764|0;c[i>>2]=0;c[b+768>>2]=0;d=ZW(1104)|0;Om(d);c[g>>2]=d;e=c[i>>2]|0;f=b+768|0;if(e>>>0<(c[f>>2]|0)>>>0){c[e>>2]=d;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(976)|0;zr(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(888)|0;lv(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(816)|0;xu(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(816)|0;xu(b);a[b+760>>0]=1;c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(808)|0;MG(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(1056)|0;Wo(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(888)|0;zx(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(1056)|0;Mr(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(960)|0;Vw(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(776)|0;bN(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(1040)|0;_z(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(1104)|0;ln(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(920)|0;Wv(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(824)|0;kM(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(22152)|0;Dt(b);c[b+908>>2]=3;c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(22152)|0;Dt(b);c[b+908>>2]=4;c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(1584)|0;on(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(912)|0;TW(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(1256)|0;uw(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(896)|0;uW(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(1128)|0;Wr(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);b=ZW(960)|0;YE(b);c[g>>2]=b;d=c[i>>2]|0;if(d>>>0<(c[f>>2]|0)>>>0){c[d>>2]=b;c[i>>2]=(c[i>>2]|0)+4}else Yy(h,g);l=j;return}function pe(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0;if(!a)return;d=a+-8|0;f=c[102124]|0;a=c[a+-4>>2]|0;b=a&-8;j=d+b|0;do if(!(a&1)){e=c[d>>2]|0;if(!(a&3))return;h=d+(0-e)|0;g=e+b|0;if(h>>>0<f>>>0)return;if((h|0)==(c[102125]|0)){a=j+4|0;b=c[a>>2]|0;if((b&3|0)!=3){i=h;b=g;break}c[102122]=g;c[a>>2]=b&-2;c[h+4>>2]=g|1;c[h+g>>2]=g;return}d=e>>>3;if(e>>>0<256){a=c[h+8>>2]|0;b=c[h+12>>2]|0;if((b|0)==(a|0)){c[102120]=c[102120]&~(1<<d);i=h;b=g;break}else{c[a+12>>2]=b;c[b+8>>2]=a;i=h;b=g;break}}f=c[h+24>>2]|0;a=c[h+12>>2]|0;do if((a|0)==(h|0)){d=h+16|0;b=d+4|0;a=c[b>>2]|0;if(!a){a=c[d>>2]|0;if(!a){a=0;break}else b=d}while(1){d=a+20|0;e=c[d>>2]|0;if(e|0){a=e;b=d;continue}d=a+16|0;e=c[d>>2]|0;if(!e)break;else{a=e;b=d}}c[b>>2]=0}else{i=c[h+8>>2]|0;c[i+12>>2]=a;c[a+8>>2]=i}while(0);if(f){b=c[h+28>>2]|0;d=408784+(b<<2)|0;e=(a|0)==0;if((h|0)==(c[d>>2]|0)){c[d>>2]=a;if(e){c[102121]=c[102121]&~(1<<b);i=h;b=g;break}}else{c[f+16+(((c[f+16>>2]|0)!=(h|0)&1)<<2)>>2]=a;if(e){i=h;b=g;break}}c[a+24>>2]=f;b=h+16|0;d=c[b>>2]|0;if(d|0){c[a+16>>2]=d;c[d+24>>2]=a}b=c[b+4>>2]|0;if(b){c[a+20>>2]=b;c[b+24>>2]=a;i=h;b=g}else{i=h;b=g}}else{i=h;b=g}}else{i=d;h=d}while(0);if(h>>>0>=j>>>0)return;a=j+4|0;e=c[a>>2]|0;if(!(e&1))return;if(!(e&2)){a=c[102125]|0;if((j|0)==(c[102126]|0)){j=(c[102123]|0)+b|0;c[102123]=j;c[102126]=i;c[i+4>>2]=j|1;if((i|0)!=(a|0))return;c[102125]=0;c[102122]=0;return}if((j|0)==(a|0)){j=(c[102122]|0)+b|0;c[102122]=j;c[102125]=h;c[i+4>>2]=j|1;c[h+j>>2]=j;return}f=(e&-8)+b|0;d=e>>>3;do if(e>>>0<256){b=c[j+8>>2]|0;a=c[j+12>>2]|0;if((a|0)==(b|0)){c[102120]=c[102120]&~(1<<d);break}else{c[b+12>>2]=a;c[a+8>>2]=b;break}}else{g=c[j+24>>2]|0;a=c[j+12>>2]|0;do if((a|0)==(j|0)){d=j+16|0;b=d+4|0;a=c[b>>2]|0;if(!a){a=c[d>>2]|0;if(!a){e=0;break}else b=d}while(1){d=a+20|0;e=c[d>>2]|0;if(e|0){a=e;b=d;continue}d=a+16|0;e=c[d>>2]|0;if(!e)break;else{a=e;b=d}}c[b>>2]=0;e=a}else{e=c[j+8>>2]|0;c[e+12>>2]=a;c[a+8>>2]=e;e=a}while(0);if(g|0){a=c[j+28>>2]|0;b=408784+(a<<2)|0;d=(e|0)==0;if((j|0)==(c[b>>2]|0)){c[b>>2]=e;if(d){c[102121]=c[102121]&~(1<<a);break}}else{c[g+16+(((c[g+16>>2]|0)!=(j|0)&1)<<2)>>2]=e;if(d)break}c[e+24>>2]=g;a=j+16|0;b=c[a>>2]|0;if(b|0){c[e+16>>2]=b;c[b+24>>2]=e}a=c[a+4>>2]|0;if(a|0){c[e+20>>2]=a;c[a+24>>2]=e}}}while(0);c[i+4>>2]=f|1;c[h+f>>2]=f;if((i|0)==(c[102125]|0)){c[102122]=f;return}}else{c[a>>2]=e&-2;c[i+4>>2]=b|1;c[h+b>>2]=b;f=b}a=f>>>3;if(f>>>0<256){d=408520+(a<<1<<2)|0;b=c[102120]|0;a=1<<a;if(!(b&a)){c[102120]=b|a;a=d;b=d+8|0}else{b=d+8|0;a=c[b>>2]|0}c[b>>2]=i;c[a+12>>2]=i;c[i+8>>2]=a;c[i+12>>2]=d;return}a=f>>>8;if(a)if(f>>>0>16777215)a=31;else{h=(a+1048320|0)>>>16&8;j=a<<h;g=(j+520192|0)>>>16&4;j=j<<g;a=(j+245760|0)>>>16&2;a=14-(g|h|a)+(j<<a>>>15)|0;a=f>>>(a+7|0)&1|a<<1}else a=0;e=408784+(a<<2)|0;c[i+28>>2]=a;c[i+20>>2]=0;c[i+16>>2]=0;b=c[102121]|0;d=1<<a;do if(b&d){b=f<<((a|0)==31?0:25-(a>>>1)|0);d=c[e>>2]|0;while(1){if((c[d+4>>2]&-8|0)==(f|0)){a=73;break}e=d+16+(b>>>31<<2)|0;a=c[e>>2]|0;if(!a){a=72;break}else{b=b<<1;d=a}}if((a|0)==72){c[e>>2]=i;c[i+24>>2]=d;c[i+12>>2]=i;c[i+8>>2]=i;break}else if((a|0)==73){h=d+8|0;j=c[h>>2]|0;c[j+12>>2]=i;c[h>>2]=i;c[i+8>>2]=j;c[i+12>>2]=d;c[i+24>>2]=0;break}}else{c[102121]=b|d;c[e>>2]=i;c[i+24>>2]=e;c[i+12>>2]=i;c[i+8>>2]=i}while(0);j=(c[102128]|0)+-1|0;c[102128]=j;if(!j)a=408936;else return;while(1){a=c[a>>2]|0;if(!a)break;else a=a+8|0}c[102128]=-1;return}function qe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=l;l=l+16|0;h=i;W0(h,d+360|0);e=c[d+20>>2]|0;if(e|0?c[e+728>>2]&4|0:0)SM(e);s7(c[h>>2]|0);TX(b);HX(b,4028)|0;HX(b,4036)|0;Ac(h,d,0,0);g=a[h+8+3>>0]|0;f=g<<24>>24<0;Ex(b,f?c[h>>2]|0:h,f?c[h+4>>2]|0:g&255)|0;z5(h);HX(b,4084)|0;if(sr(d,1,-1)|0)HX(b,4092)|0;f=h+8+3|0;g=h+4|0;e=0;while(1){if(e>>>0>=(sr(d,1,-1)|0)>>>0)break;Ac(h,d,1,e);j=a[f>>0]|0;k=j<<24>>24<0;Ex(b,k?c[h>>2]|0:h,k?c[g>>2]|0:j&255)|0;z5(h);if((e|0)!=((sr(d,1,-1)|0)+-1|0))HX(b,4140)|0;e=e+1|0}if(sr(d,1,-1)|0)HX(b,4156)|0;if(sr(d,2,-1)|0)HX(b,4168)|0;f=h+8+3|0;g=h+4|0;e=0;while(1){if(e>>>0>=(sr(d,2,-1)|0)>>>0)break;Ac(h,d,2,e);k=a[f>>0]|0;j=k<<24>>24<0;Ex(b,j?c[h>>2]|0:h,j?c[g>>2]|0:k&255)|0;z5(h);if((e|0)!=((sr(d,2,-1)|0)+-1|0))HX(b,4140)|0;e=e+1|0}if(sr(d,2,-1)|0)HX(b,4156)|0;if(sr(d,3,-1)|0)HX(b,4216)|0;f=h+8+3|0;g=h+4|0;e=0;while(1){if(e>>>0>=(sr(d,3,-1)|0)>>>0)break;Ac(h,d,3,e);k=a[f>>0]|0;j=k<<24>>24<0;Ex(b,j?c[h>>2]|0:h,j?c[g>>2]|0:k&255)|0;z5(h);if((e|0)!=((sr(d,3,-1)|0)+-1|0))HX(b,4140)|0;e=e+1|0}if(sr(d,3,-1)|0)HX(b,4156)|0;if(sr(d,4,-1)|0)HX(b,4260)|0;f=h+8+3|0;g=h+4|0;e=0;while(1){if(e>>>0>=(sr(d,4,-1)|0)>>>0)break;Ac(h,d,4,e);k=a[f>>0]|0;j=k<<24>>24<0;Ex(b,j?c[h>>2]|0:h,j?c[g>>2]|0:k&255)|0;z5(h);if((e|0)!=((sr(d,4,-1)|0)+-1|0))HX(b,4140)|0;e=e+1|0}if(sr(d,4,-1)|0)HX(b,4156)|0;if(sr(d,5,-1)|0)HX(b,4308)|0;f=h+8+3|0;g=h+4|0;e=0;while(1){if(e>>>0>=(sr(d,5,-1)|0)>>>0)break;Ac(h,d,5,e);k=a[f>>0]|0;j=k<<24>>24<0;Ex(b,j?c[h>>2]|0:h,j?c[g>>2]|0:k&255)|0;z5(h);if((e|0)!=((sr(d,5,-1)|0)+-1|0))HX(b,4140)|0;e=e+1|0}if(sr(d,5,-1)|0)HX(b,4156)|0;if(sr(d,6,-1)|0)HX(b,4356)|0;f=h+8+3|0;g=h+4|0;e=0;while(1){if(e>>>0>=(sr(d,6,-1)|0)>>>0)break;Ac(h,d,6,e);k=a[f>>0]|0;j=k<<24>>24<0;Ex(b,j?c[h>>2]|0:h,j?c[g>>2]|0:k&255)|0;z5(h);if((e|0)!=((sr(d,6,-1)|0)+-1|0))HX(b,4140)|0;e=e+1|0}if(sr(d,6,-1)|0)HX(b,4156)|0;HX(b,4084)|0;l=i;return}function re(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=l;l=l+48|0;o=C+16|0;w=C+12|0;B=C+8|0;x=C+4|0;y=C;z=C+22|0;A=C+20|0;g=C+34|0;p=C+33|0;q=C+32|0;r=C+31|0;s=C+30|0;t=C+29|0;v=C+28|0;i=C+27|0;u=C+26|0;j=C+25|0;n=C+24|0;c[o>>2]=0;c[w>>2]=0;c[B>>2]=0;c[x>>2]=-1;c[y>>2]=-1;b[z>>1]=-1;b[A>>1]=-1;a[g>>0]=0;a[p>>0]=5;a[q>>0]=0;a[r>>0]=2;a[s>>0]=2;a[t>>0]=2;a[j>>0]=0;yT(d,v);v=a[v>>0]|0;if(!(v<<24>>24)){h=d+648|0;A6(c[h>>2]|0);m=0}else{GC(d);h=d+648|0;A6(c[h>>2]|0);xR(d,8,g);g=a[g>>0]|0;if(g<<24>>24==-1){sR(d,16,z);sR(d,16,A)}J3(d);m=g}if(K6(c[h>>2]|0)|0){GC(d);A6(c[h>>2]|0);A6(c[h>>2]|0);J3(d)}else A6(c[h>>2]|0);yT(d,i);k=a[i>>0]|0;if(!(k<<24>>24)){A6(c[h>>2]|0);j=0}else{GC(d);A6(c[h>>2]|0);xR(d,3,p);xR(d,1,q);yT(d,j);g=a[j>>0]|0;if(!(g<<24>>24))A6(c[h>>2]|0);else{GC(d);A6(c[h>>2]|0);xR(d,8,r);xR(d,8,s);xR(d,8,t);J3(d)}J3(d);j=g}if(K6(c[h>>2]|0)|0){GC(d);A6(c[h>>2]|0);n3(d,d+936|0);n3(d,d+940|0);J3(d)}else A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);AT(d,u);if(K6(c[h>>2]|0)|0){GC(d);A6(c[h>>2]|0);T5(d);T5(d);T5(d);T5(d);J3(d)}else A6(c[h>>2]|0);yT(d,n);i=a[n>>0]|0;if(!(i<<24>>24))A6(c[h>>2]|0);else{GC(d);A6(c[h>>2]|0);rR(d,32,x);rR(d,32,y);if(K6(c[h>>2]|0)|0){GC(d);A6(c[h>>2]|0);T5(d);J3(d)}else A6(c[h>>2]|0);if(K6(c[h>>2]|0)|0){GC(d);A6(c[h>>2]|0);th(d,1,a[c[e>>2]>>0]|0,o,w,B);J3(d)}else A6(c[h>>2]|0);J3(d)}if(K6(c[h>>2]|0)|0){GC(d);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);T5(d);T5(d);T5(d);T5(d);T5(d);J3(d)}else A6(c[h>>2]|0);d=qO(d)|0;g=c[o>>2]|0;if(!d){if(g|0)laa(g);g=c[w>>2]|0;if(g|0){VZ(g);laa(g)}g=c[B>>2]|0;if(g|0){VZ(g);laa(g)}}else{o=ZW(36)|0;Kw(o,c[w>>2]|0,c[B>>2]|0,g,c[x>>2]|0,c[y>>2]|0,b[z>>1]|0,b[A>>1]|0,m,a[p>>0]|0,a[q>>0]|0,a[r>>0]|0,a[s>>0]|0,a[t>>0]|0,v<<24>>24!=0,k<<24>>24!=0,(a[u>>0]|0)!=0,j<<24>>24!=0,i<<24>>24!=0);c[f>>2]=o}l=C;return}function se(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+64|0;f=v+40|0;g=v+8|0;j=v;k=v+28|0;h=v+16|0;e=b+1080|0;if((c[e>>2]|0)==(c[b+1084>>2]|0)){EG(b,f);i=a[b+808>>0]|0;r=b+548|0;u=b+612|0;do if((d[f>>0]|0)<=(i&255)){f=b+616|0;e=c[f>>2]|0;if(!e){e=c[u>>2]|0;t=6}while(1){if((t|0)==6){e=e+1|0;c[f>>2]=e}if(e>>>0>=(c[r>>2]|0)>>>0){t=9;break}if((d[(c[b+544>>2]|0)+e>>0]|0)>(i&255)){t=10;break}else t=6}if((t|0)==9){c3(c[b+508>>2]|0,c[b+668>>2]|0);break}else if((t|0)==10){yZ(c[b+508>>2]|0,c[b+668>>2]|0,-1,0);Op(b,(c[f>>2]|0)-(c[u>>2]|0)|0,0);c[f>>2]=0;break}}else{s=g;c[s>>2]=0;c[s+4>>2]=0;s=j;c[s>>2]=0;c[s+4>>2]=0;s=b+528|0;m=s;m=z0(c[m>>2]|0,c[m+4>>2]|0,1,0)|0;f=z;t=b+536|0;i=c[t+4>>2]|0;do if(f>>>0<i>>>0|((f|0)==(i|0)?m>>>0<(c[t>>2]|0)>>>0:0)){EG(b,k);if((d[k>>0]|0)<16){j=s;j=z0(c[j>>2]|0,c[j+4>>2]|0,1,0)|0;g=s;c[g>>2]=j;c[g+4>>2]=z;VU(h,391269);BZ(c[b+508>>2]|0,c[b+668>>2]|0,0,0);z5(h);Op(b,1,0);g=s;j=c[g+4>>2]|0;g=c[g>>2]|0;h=0;f=0;k=0;i=0;t=21;break}else{t=15;break}}else t=15;while(0);if((t|0)==15){q3(b,g);q3(b,j);f=g;h=c[f>>2]|0;f=c[f+4>>2]|0;i=j;e=c[i>>2]|0;i=c[i+4>>2]|0;if((h|0)==139690087&(f|0)==0&((e|0)==0&(i|0)==0)){e=j;c[e>>2]=-1;c[e+4>>2]=16777215;xM(b,0,0,373803,382808,0);e=-1;i=16777215}TX(k);bk(k,h,f,16)|0;BZ(c[b+508>>2]|0,c[b+668>>2]|0,h,f);z5(k);m=s;m=z0(e|0,i|0,c[m>>2]|0,c[m+4>>2]|0)|0;Op(b,m,z);m=s;k=c[m>>2]|0;m=c[m+4>>2]|0;g=z0(k|0,m|0,e|0,i|0)|0;j=z;if(((h|2|0)==35&(f|0)==0?(n=z0(c[u>>2]|0,0,g|0,j|0)|0,o=z,p=c[r>>2]|0,o>>>0>0|(o|0)==0&n>>>0>p>>>0):0)?(q=c[b+1096>>2]|0,(q|0)!=0):0){u=D_(k|0,m|0,p|0,0)|0;u=z0(u|0,z|0,n|0,o|0)|0;s=0>0|0==0&u>>>0>131072;u=s?u:131072;c[q>>2]=u;c3(c[b+508>>2]|0,c[b+668>>2]|0)}else{k=e;t=21}}do if((t|0)==21){r=HN(b,0)|0;q=z;e=b+508|0;if(j>>>0>q>>>0|(j|0)==(q|0)&g>>>0>r>>>0?(c[e>>2]|0)>>>0<3:0)xM(b,0,0,379092,382808,0);e=(c[e>>2]|0)==3;if(!(e&((h|0)==256095861&(f|0)==0))){if(!(e&((h|0)==106212971&(f|0)==0)))break;e=b+1024|0;g=e;f=c[g>>2]|0;g=c[g+4>>2]|0;t=b+48|0;t=z0(c[u>>2]|0,0,c[t>>2]|0,c[t+4>>2]|0)|0;u=s;u=z0(t|0,z|0,c[u>>2]|0,c[u+4>>2]|0)|0;u=z0(u|0,z|0,k|0,i|0)|0;if(!((f|0)==(u|0)&(g|0)==(z|0)))break;XC(b,f,g);b=e;c[b>>2]=0;c[b+4>>2]=0;break}if(!(c[b+884>>2]|0)){f=b+1032|0;h=c[f>>2]|0;g=(c[b+1036>>2]|0)-h>>4;e=0;while(1){if(e>>>0>=g>>>0)break;s=h+(e<<4)|0;if((c[s>>2]|0)==106212971&(c[s+4>>2]|0)==0){t=29;break}e=e+1|0}if((t|0)==29){RB(b,0,0,145,382840,-1,1,0);t=b+48|0;t=z0(c[u>>2]|0,0,c[t>>2]|0,c[t+4>>2]|0)|0;u=b+1016|0;c[u>>2]=t;c[u+4>>2]=z;u=(c[f>>2]|0)+(e<<4)+8|0;XC(b,c[u>>2]|0,c[u+4>>2]|0)}u=b+64|0;if((c[u>>2]|0)==-1?(c[u+4>>2]|0)==-1:0){u=b+1008|0;XC(b,c[u>>2]|0,c[u+4>>2]|0)}}}while(0)}while(0)}else{VU(f,391007);BZ(c[b+508>>2]|0,c[b+668>>2]|0,-2,-1);z5(f);u=(c[e>>2]|0)+(c[b+1092>>2]<<3)|0;Op(b,c[u>>2]|0,c[u+4>>2]|0)}l=v;return}function te(d,e,f,g,h,i,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=l;l=l+16|0;u=B+12|0;t=B+8|0;v=B+4|0;w=B;O4(u,g);y=u$(c[u>>2]|0,409116)|0;c6(u);c[h>>2]=0;z=y+8|0;m=j;n=0;a:while(1){r=(m|0)!=(k|0);o=e;j=e;while(1){if(!(r&(n|0)==0)){e=f;break a}n=j;if(!j){e=o;j=0;p=1;q=n}else{e=c[j+12>>2]|0;if((e|0)==(c[j+16>>2]|0))e=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else e=e9(a[e>>0]|0)|0;q=d8(e,-1)|0;e=q?0:o;j=q?0:j;p=q;q=q?0:n}n=f;if(f){o=c[f+12>>2]|0;if((o|0)==(c[f+16>>2]|0))o=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else o=e9(a[o>>0]|0)|0;if(!(d8(o,-1)|0)){if(!p){A=57;break a}}else{n=0;A=14}}else A=14;if((A|0)==14){A=0;if(p){f=0;A=57;break a}else f=0}if((gb[c[(c[y>>2]|0)+36>>2]&31](y,a[m>>0]|0,0)|0)<<24>>24==37){A=17;break}n=a[m>>0]|0;if(n<<24>>24>-1?(x=c[z>>2]|0,b[x+(n<<24>>24<<1)>>1]&8192):0){A=25;break}o=j+12|0;n=c[o>>2]|0;p=j+16|0;if((n|0)==(c[p>>2]|0))n=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else n=e9(a[n>>0]|0)|0;s=tb[c[(c[y>>2]|0)+12>>2]&31](y,n&255)|0;if(s<<24>>24==(tb[c[(c[y>>2]|0)+12>>2]&31](y,a[m>>0]|0)|0)<<24>>24){A=53;break}c[h>>2]=4;o=e;n=4}b:do if((A|0)==17){A=0;o=m+1|0;if((o|0)==(k|0)){A=57;break a}e=gb[c[(c[y>>2]|0)+36>>2]&31](y,a[o>>0]|0,0)|0;switch(e<<24>>24){case 48:case 69:{m=m+2|0;if((m|0)==(k|0)){A=57;break a}p=e;j=gb[c[(c[y>>2]|0)+36>>2]&31](y,a[m>>0]|0,0)|0;m=o;break}default:{p=0;j=e}}e=c[(c[d>>2]|0)+36>>2]|0;c[v>>2]=q;c[w>>2]=n;c[t>>2]=c[v>>2];c[u>>2]=c[w>>2];m=m+2|0;e=qb[e&15](d,t,u,g,h,i,j,p)|0}else if((A|0)==25){while(1){A=0;m=m+1|0;if((m|0)==(k|0)){m=k;break}n=a[m>>0]|0;if(n<<24>>24<=-1)break;if(!(b[x+(n<<24>>24<<1)>>1]&8192))break;else A=25}n=f;s=f;o=f;while(1){if(!j){p=1;j=0}else{f=c[j+12>>2]|0;if((f|0)==(c[j+16>>2]|0))f=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else f=e9(a[f>>0]|0)|0;r=d8(f,-1)|0;e=r?0:e;p=r;j=r?0:j}if(o){f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))f=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else f=e9(a[f>>0]|0)|0;if(!(d8(f,-1)|0))if((n|0)==0^p){q=n;f=s;r=n}else{f=s;break b}else{n=0;f=0;A=39}}else{f=s;A=39}if((A|0)==39){A=0;if(p)break b;else{q=n;r=0}}o=j+12|0;n=c[o>>2]|0;p=j+16|0;if((n|0)==(c[p>>2]|0))n=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else n=e9(a[n>>0]|0)|0;if((n&255)<<24>>24<=-1)break b;if(!(b[(c[z>>2]|0)+(n<<24>>24<<1)>>1]&8192))break b;n=c[o>>2]|0;if((n|0)==(c[p>>2]|0)){nb[c[(c[j>>2]|0)+40>>2]&255](j)|0;n=q;s=f;o=r;continue}else{c[o>>2]=n+1;n=q;s=f;o=r;continue}}}else if((A|0)==53){A=0;m=m+1|0;n=c[o>>2]|0;if((n|0)==(c[p>>2]|0)){nb[c[(c[j>>2]|0)+40>>2]&255](j)|0;break}else{c[o>>2]=n+1;break}}while(0);n=c[h>>2]|0}if((A|0)==57){c[h>>2]=4;e=f}if(!j){j=0;m=1}else{f=c[j+12>>2]|0;if((f|0)==(c[j+16>>2]|0))f=nb[c[(c[j>>2]|0)+36>>2]&255](j)|0;else f=e9(a[f>>0]|0)|0;m=d8(f,-1)|0;j=m?0:j}if(e){f=c[e+12>>2]|0;if((f|0)==(c[e+16>>2]|0))f=nb[c[(c[e>>2]|0)+36>>2]&255](e)|0;else f=e9(a[f>>0]|0)|0;if(!(d8(f,-1)|0)){if(!m)A=70}else A=68}else A=68;if((A|0)==68?m:0)A=70;if((A|0)==70)c[h>>2]=c[h>>2]|2;l=B;return j|0}function ue(f){f=f|0;var i=0,j=0,k=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=l;l=l+48|0;y=A+24|0;z=A+12|0;m=A;i=a[f+815>>0]|0;if(i<<24>>24==15){i=a[f+817>>0]|0;if(!(i<<24>>24))n=1.0;else n=+(d[f+816>>0]|0)/+(i&255)}else n=+g[38524+((i&255)<<2)>>2];TX(y);i=f+812|0;j=a[i>>0]|0;if((j<<24>>24!=-1?(VU(z,c[38588+((j&255)<<2)>>2]|0),vF(y,z)|0,z5(z),(a[i>>0]|0)==3):0)?(k=a[f+813>>0]|0,k<<24>>24!=-1):0){uU(m,k,10);DW(m,0,39996)|0;c[z>>2]=c[m>>2];c[z+4>>2]=c[m+4>>2];c[z+8>>2]=c[m+8>>2];i=0;while(1){if((i|0)==3)break;c[m+(i<<2)>>2]=0;i=i+1|0}r=a[z+8+3>>0]|0;q=r<<24>>24<0;Ex(y,q?c[z>>2]|0:z,q?c[z+4>>2]|0:r&255)|0;O0(z);z5(m)}zb(f,1,0,24,y,0);zb(f,1,0,64,y,0);RB(f,1,0,191,384021,-1,1,0);RB(f,1,0,190,c[38604+(d[f+814>>0]<<2)>>2]|0,-1,1,0);i=b[f+804>>1]|0;j=f+20|0;if(i<<16>>16?(o=f+806|0,b[o>>1]|0):0){sM(f,1,c[j>>2]|0,130,((i&65535)<<1)+2|0,0);sM(f,1,c[j>>2]|0,138,(e[o>>1]<<1)+2|0,0)}if(n!=0.0)Bt(f,1,0,150,n,3,1);r=f+896|0;n=+h[r>>3];if(n!=0.0)KW(f,1,c[j>>2]|0,171,n,3,0);i=f+820|0;do if(a[i>>0]|0){j=c[f+780>>2]|0;if((c[j+4>>2]|0)==0?(c[j+8>>2]|0)==0:0){p=22;break}if(!(c[j>>2]|0)){RB(f,1,0,197,384063,-1,1,0);RB(f,1,0,211,384063,-1,1,0);break}else{RB(f,1,0,197,383624,-1,1,0);RB(f,1,0,211,383624,-1,1,0);break}}else p=22;while(0);if((p|0)==22){RB(f,1,0,197,384051,-1,1,0);RB(f,1,0,211,383620,-1,1,0)}q=f+312|0;if(!((c[q>>2]|0)==0&(c[q+4>>2]|0)==0)?a[i>>0]|0:0)RB(f,1,0,204,c[f+776>>2]|0?384078:384074,-1,1,0);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;i=0;while(1){if((i|0)==3)break;c[z+(i<<2)>>2]=0;i=i+1|0}k=f+848|0;i=c[f+844>>2]|0;a:while(1){if((i|0)==(k|0))break;JX(z,a[i+16>>0]|0?383630:383632)|0;JX(z,a[i+17>>0]|0?383634:385590)|0;j=c[i+4>>2]|0;if(!j)while(1){j=c[i+8>>2]|0;if((c[j>>2]|0)==(i|0)){i=j;continue a}else i=j}else i=j;while(1){j=c[i>>2]|0;if(!j)break;else i=j}}do if((vM(z,51,0)|0)!=-1){j=z+11|0;m=a[j>>0]|0;k=m<<24>>24<0;i=c[z>>2]|0;q=z+4|0;o=k?i:z;p=j9(383636)|0;if(!((((p|0)!=0?(s=o+(k?c[q>>2]|0:m&255)|0,p=tB(o,s,383636,383636+p|0)|0,t=o,(p|0)==(s|0)|(p-t|0)==-1):0)?(u=j9(383653)|0,(u|0)!=0):0)?(u=tB(o,s,383653,383653+u|0)|0,(u|0)==(s|0)|(u-t|0)==-1):0)){RB(f,1,0,204,383670,-1,1,1);KW(f,1,0,171,+h[r>>3]*24.0/30.0,3,1);RB(f,1,0,197,384051,-1,1,1);RB(f,1,0,211,383620,-1,1,1);m=a[j>>0]|0;i=c[z>>2]|0}k=m<<24>>24<0;i=k?i:z;j=j9(383683)|0;if(((j|0?(v=i+(k?c[q>>2]|0:m&255)|0,u=tB(i,v,383683,383683+j|0)|0,w=i,(u|0)==(v|0)|(u-w|0)==-1):0)?(x=j9(383732)|0,x|0):0)?(x=tB(i,v,383732,383732+x|0)|0,(x|0)==(v|0)|(x-w|0)==-1):0)break;RB(f,1,0,204,383781,-1,1,1);KW(f,1,0,171,+h[r>>3]*24.0/25.0,3,1);RB(f,1,0,197,384051,-1,1,1);RB(f,1,0,211,383620,-1,1,1)}while(0);j=f+792|0;k=f+796|0;i=0;while(1){m=c[j>>2]|0;if(i>>>0>=(c[k>>2]|0)-m>>2>>>0)break;lL(f,1,0,328,c[m+(i<<2)>>2]|0,10,0);i=i+1|0}a1(z);z5(y);l=A;return}function ve(b,d,e,f,g,h,i,j,k,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+16|0;v=w;n=k+4|0;t=i+4|0;p=j+4|0;r=h+4|0;s=h+11|0;q=j+8+3|0;o=k+8+3|0;u=i+8+3|0;if(b){b=u$(d,410852)|0;kb[c[(c[b>>2]|0)+44>>2]&63](v,b);d=c[v>>2]|0;a[e>>0]=d;a[e+1>>0]=d>>8;a[e+2>>0]=d>>16;a[e+3>>0]=d>>24;kb[c[(c[b>>2]|0)+32>>2]&63](v,b);if((a[o>>0]|0)<0){y7(c[k>>2]|0,0);c[n>>2]=0}else{y7(k,0);a[o>>0]=0}pp(k,0);c[k>>2]=c[v>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}O0(v);kb[c[(c[b>>2]|0)+28>>2]&63](v,b);if((a[q>>0]|0)<0){y7(c[j>>2]|0,0);c[p>>2]=0}else{y7(j,0);a[q>>0]=0}pp(j,0);c[j>>2]=c[v>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}O0(v);c[f>>2]=nb[c[(c[b>>2]|0)+12>>2]&255](b)|0;c[g>>2]=nb[c[(c[b>>2]|0)+16>>2]&255](b)|0;kb[c[(c[b>>2]|0)+20>>2]&63](v,b);if((a[s>>0]|0)<0){J7(c[h>>2]|0,0);c[r>>2]=0}else{J7(h,0);a[s>>0]=0}Fp(h,0);c[h>>2]=c[v>>2];c[h+4>>2]=c[v+4>>2];c[h+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}a1(v);kb[c[(c[b>>2]|0)+24>>2]&63](v,b);if((a[u>>0]|0)<0){y7(c[i>>2]|0,0);c[t>>2]=0}else{y7(i,0);a[u>>0]=0}pp(i,0);c[i>>2]=c[v>>2];c[i+4>>2]=c[v+4>>2];c[i+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}O0(v);d=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0}else{b=u$(d,410844)|0;kb[c[(c[b>>2]|0)+44>>2]&63](v,b);d=c[v>>2]|0;a[e>>0]=d;a[e+1>>0]=d>>8;a[e+2>>0]=d>>16;a[e+3>>0]=d>>24;kb[c[(c[b>>2]|0)+32>>2]&63](v,b);if((a[o>>0]|0)<0){y7(c[k>>2]|0,0);c[n>>2]=0}else{y7(k,0);a[o>>0]=0}pp(k,0);c[k>>2]=c[v>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}O0(v);kb[c[(c[b>>2]|0)+28>>2]&63](v,b);if((a[q>>0]|0)<0){y7(c[j>>2]|0,0);c[p>>2]=0}else{y7(j,0);a[q>>0]=0}pp(j,0);c[j>>2]=c[v>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}O0(v);c[f>>2]=nb[c[(c[b>>2]|0)+12>>2]&255](b)|0;c[g>>2]=nb[c[(c[b>>2]|0)+16>>2]&255](b)|0;kb[c[(c[b>>2]|0)+20>>2]&63](v,b);if((a[s>>0]|0)<0){J7(c[h>>2]|0,0);c[r>>2]=0}else{J7(h,0);a[s>>0]=0}Fp(h,0);c[h>>2]=c[v>>2];c[h+4>>2]=c[v+4>>2];c[h+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}a1(v);kb[c[(c[b>>2]|0)+24>>2]&63](v,b);if((a[u>>0]|0)<0){y7(c[i>>2]|0,0);c[t>>2]=0}else{y7(i,0);a[u>>0]=0}pp(i,0);c[i>>2]=c[v>>2];c[i+4>>2]=c[v+4>>2];c[i+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}O0(v);d=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0}c[m>>2]=d;l=w;return}function we(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;O=l;l=l+32|0;B=O+20|0;G=O+16|0;H=O+12|0;I=O+8|0;J=O+4|0;K=O+29|0;L=O+28|0;M=O+27|0;N=O;C=O+26|0;D=O+25|0;E=O+24|0;F=e+904|0;g=e+940|0;if((a[F>>0]|0)!=0?(f=e+905|0,(a[f>>0]|0)==0):0){HB(e,g);if(qO(e)|0)a[f>>0]=1}else{A=e+312|0;x=A;x=z0(c[x>>2]|0,c[x+4>>2]|0,1,0)|0;y=A;c[y>>2]=x;c[y+4>>2]=z;GC(e);if(!(a[F>>0]|0))HB(e,g);a:do if((b[g>>1]&-256)<<16>>16==1024){k=e+528|0;m=e+536|0;n=e+936|0;o=e+908|0;p=e+912|0;q=e+916|0;r=e+920|0;s=e+924|0;t=e+925|0;u=e+926|0;v=e+927|0;w=e+928|0;x=e+929|0;y=e+930|0;f=k;g=c[f+4>>2]|0;f=c[f>>2]|0;while(1){j=m;i=c[j+4>>2]|0;if(!(g>>>0<i>>>0|((g|0)==(i|0)?f>>>0<(c[j>>2]|0)>>>0:0)))break a;c[B>>2]=-1;c[G>>2]=-1;c[H>>2]=0;c[J>>2]=-1;a[K>>0]=1;a[L>>0]=1;if(!(a[F>>0]|0)){i=z0(f|0,g|0,2,0)|0;j=k;c[j>>2]=i;c[j+4>>2]=z;bD(e,B);bD(e,G);if(!(a[F>>0]|0))h=14;else{g=k;f=c[g>>2]|0;g=c[g+4>>2]|0;h=13}}else h=13;if((h|0)==13)if((f|0)==0&(g|0)==0)h=14;else h=23;do if((h|0)==14){h=0;bD(e,H);f=c[H>>2]|0;if(!f){g=k;f=c[g>>2]|0;g=c[g+4>>2]|0;h=23;break}if(!(a[F>>0]|0)){g=c[G>>2]|0;if(!g)c[o>>2]=c[B>>2];j=A;if((c[j>>2]|0)==1&(c[j+4>>2]|0)==0)c[p>>2]=g;c[q>>2]=g;c[r>>2]=f}bD(e,I);g=c[I>>2]|0;pY(g,0,0,s);pY(g,0,1,t);pY(g,0,2,u);pY(g,0,3,v);pY(g,0,4,w);pY(g,0,5,x);pY(g,0,11,K);pY(g,0,12,L);a[y>>0]=g>>>23&15;g=k;f=c[g>>2]|0;g=c[g+4>>2]|0}while(0);if((h|0)==23){f=z0(f|0,g|0,4,0)|0;g=z;i=k;c[i>>2]=f;c[i+4>>2]=g;i=A;i=z0(c[i>>2]|0,c[i+4>>2]|0,-1,-1)|0;j=A;c[j>>2]=i;c[j+4>>2]=z}g=z0(f|0,g|0,4,0)|0;f=k;c[f>>2]=g;c[f+4>>2]=z;J3(e);f=m;g=c[f>>2]|0;f=c[f+4>>2]|0;if((a[F>>0]|0)!=0?(a[K>>0]|0)==0|(a[L>>0]|0)==0:0){bD(e,J);i=k;i=z0(c[J>>2]|0,0,c[i>>2]|0,c[i+4>>2]|0)|0;g=z;f=m;j=c[f>>2]|0;f=c[f+4>>2]|0;h=g>>>0<f>>>0|(g|0)==(f|0)&i>>>0<j>>>0;f=h?g:f;j=h?i:j}else j=g;while(1){g=k;h=c[g>>2]|0;g=c[g+4>>2]|0;if(!(g>>>0<f>>>0|(g|0)==(f|0)&h>>>0<j>>>0))break;GC(e);Bx(e);AT(e,C);AT(e,D);xR(e,6,M);wK(e);if(!(a[C>>0]|0)){bB(e,E);h=d[E>>0]|0;c[N>>2]=h}else{gB(e,N);h=c[N>>2]|0}g=a[D>>0]|0;i=g<<24>>24==0;g=(h|0)!=0|i?(h<<1)-(g&255)|0:0;c[n>>2]=g;switch(a[M>>0]|0){case 7:{kF(e);break}case 13:{hA(e);break}case 37:{hh(e);break}default:if(h|0)e1(e,g,0)}if(!i)e1(e,1,0);J3(e)}f=h}}while(0);if((c[e+728>>2]&1|0)==0?(M=A,K=c[M+4>>2]|0,N=e+896|0,L=c[N+4>>2]|0,!(K>>>0<L>>>0|((K|0)==(L|0)?(c[M>>2]|0)>>>0<(c[N>>2]|0)>>>0:0))):0){P6(c[e+760>>2]|0);Id(e)}}l=O;return}function xe(b,d,e,f,g,h,i,j,k,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+16|0;v=w;n=k+4|0;p=j+11|0;r=h+11|0;t=i+4|0;q=j+4|0;s=h+4|0;u=i+11|0;o=k+11|0;if(b){b=u$(d,410836)|0;kb[c[(c[b>>2]|0)+44>>2]&63](v,b);d=c[v>>2]|0;a[e>>0]=d;a[e+1>>0]=d>>8;a[e+2>>0]=d>>16;a[e+3>>0]=d>>24;kb[c[(c[b>>2]|0)+32>>2]&63](v,b);if((a[o>>0]|0)<0){J7(c[k>>2]|0,0);c[n>>2]=0}else{J7(k,0);a[o>>0]=0}Fp(k,0);c[k>>2]=c[v>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}a1(v);kb[c[(c[b>>2]|0)+28>>2]&63](v,b);if((a[p>>0]|0)<0){J7(c[j>>2]|0,0);c[q>>2]=0}else{J7(j,0);a[p>>0]=0}Fp(j,0);c[j>>2]=c[v>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}a1(v);a[f>>0]=nb[c[(c[b>>2]|0)+12>>2]&255](b)|0;a[g>>0]=nb[c[(c[b>>2]|0)+16>>2]&255](b)|0;kb[c[(c[b>>2]|0)+20>>2]&63](v,b);if((a[r>>0]|0)<0){J7(c[h>>2]|0,0);c[s>>2]=0}else{J7(h,0);a[r>>0]=0}Fp(h,0);c[h>>2]=c[v>>2];c[h+4>>2]=c[v+4>>2];c[h+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}a1(v);kb[c[(c[b>>2]|0)+24>>2]&63](v,b);if((a[u>>0]|0)<0){J7(c[i>>2]|0,0);c[t>>2]=0}else{J7(i,0);a[u>>0]=0}Fp(i,0);c[i>>2]=c[v>>2];c[i+4>>2]=c[v+4>>2];c[i+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}a1(v);d=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0}else{b=u$(d,410828)|0;kb[c[(c[b>>2]|0)+44>>2]&63](v,b);d=c[v>>2]|0;a[e>>0]=d;a[e+1>>0]=d>>8;a[e+2>>0]=d>>16;a[e+3>>0]=d>>24;kb[c[(c[b>>2]|0)+32>>2]&63](v,b);if((a[o>>0]|0)<0){J7(c[k>>2]|0,0);c[n>>2]=0}else{J7(k,0);a[o>>0]=0}Fp(k,0);c[k>>2]=c[v>>2];c[k+4>>2]=c[v+4>>2];c[k+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}a1(v);kb[c[(c[b>>2]|0)+28>>2]&63](v,b);if((a[p>>0]|0)<0){J7(c[j>>2]|0,0);c[q>>2]=0}else{J7(j,0);a[p>>0]=0}Fp(j,0);c[j>>2]=c[v>>2];c[j+4>>2]=c[v+4>>2];c[j+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}a1(v);a[f>>0]=nb[c[(c[b>>2]|0)+12>>2]&255](b)|0;a[g>>0]=nb[c[(c[b>>2]|0)+16>>2]&255](b)|0;kb[c[(c[b>>2]|0)+20>>2]&63](v,b);if((a[r>>0]|0)<0){J7(c[h>>2]|0,0);c[s>>2]=0}else{J7(h,0);a[r>>0]=0}Fp(h,0);c[h>>2]=c[v>>2];c[h+4>>2]=c[v+4>>2];c[h+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}a1(v);kb[c[(c[b>>2]|0)+24>>2]&63](v,b);if((a[u>>0]|0)<0){J7(c[i>>2]|0,0);c[t>>2]=0}else{J7(i,0);a[u>>0]=0}Fp(i,0);c[i>>2]=c[v>>2];c[i+4>>2]=c[v+4>>2];c[i+8>>2]=c[v+8>>2];d=0;while(1){if((d|0)==3)break;c[v+(d<<2)>>2]=0;d=d+1|0}a1(v);d=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0}c[m>>2]=d;l=w;return}function ye(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;r=l;l=l+96|0;m=r+84|0;j=r+80|0;o=r+68|0;k=r+56|0;p=r+16|0;q=r;g=b+536|0;if(!(RA(b,0,-1)|0)){c[m>>2]=0;n=m+4|0;c[n>>2]=0;c[m+8>>2]=0;i=b+904|0;r3(b,i);d=c[n>>2]|0;f=m+8|0;if((d|0)==(c[f>>2]|0))Yy(m,i);else{c[d>>2]=c[i>>2];c[n>>2]=d+4}ID(b,j);d=b+528|0;while(1){e=d;t=c[e+4>>2]|0;h=g;s=c[h+4>>2]|0;if(!(t>>>0<s>>>0|((t|0)==(s|0)?(c[e>>2]|0)>>>0<(c[h>>2]|0)>>>0:0)))break;r3(b,o);e=c[n>>2]|0;if((e|0)==(c[f>>2]|0))Yy(m,o);else{c[e>>2]=c[o>>2];c[n>>2]=e+4}}if(qO(b)|0){W5(b);RB(b,0,0,57,376937,-1,1,0);f=b+24|0;g=b+16|0;h=b+20|0;e=0;while(1){d=c[m>>2]|0;if(e>>>0>=(c[n>>2]|0)-d>>2>>>0)break;d=c[d+(e<<2)>>2]|0;a:do if((d|0)>=1684108136){switch(d|0){case 1684108136:break;default:break a}t=c[f>>2]|0;if(((c[t+8>>2]|0)-(c[t+4>>2]|0)|0)==12){Xy(k,27368);z5(k)}}else{switch(d|0){case 1667330422:break;default:break a}xM(b,c[g>>2]|0,c[h>>2]|0,377532,378067,0)}while(0);e=e+1|0}TX(o);Rf(b,lh(o,c[i>>2]|0)|0,0,0,1);z5(o);TX(p);p2(o,lh(p,c[i>>2]|0)|0);z5(p);if((c[i>>2]|0)==1903435808){mI(p);Xy(q,42212);z3(p,q);z5(q);TX(q);f=c[j>>2]|0;d=dx(q,f>>>16&65535)|0;g=p+4|0;e=c[g>>2]|0;h=p+8|0;if((e|0)==(c[h>>2]|0))Ax(p,d);else{p2(e,d);c[g>>2]=(c[g>>2]|0)+12}z5(q);TX(q);d=ex(q,f>>>8&255)|0;e=c[g>>2]|0;if((e|0)==(c[h>>2]|0))Ax(p,d);else{p2(e,d);c[g>>2]=(c[g>>2]|0)+12}z5(q);if(f&255|0){TX(q);d=ex(q,f&255)|0;e=c[g>>2]|0;if((e|0)==(c[h>>2]|0))Ax(p,d);else{p2(e,d);c[g>>2]=(c[g>>2]|0)+12}z5(q)}de(q,p);zb(b,0,0,76,q,0);z5(q);Gx(o,32);de(q,p);t=a[q+8+3>>0]|0;s=t<<24>>24<0;Ex(o,s?c[q>>2]|0:q,s?c[q+4>>2]|0:t&255)|0;z5(q);$_(p)}if((c[n>>2]|0)-(c[m>>2]|0)>>2>>>0>1){mI(p);Xy(q,42012);z3(p,q);z5(q);g=p+4|0;h=p+8|0;f=1;while(1){d=c[m>>2]|0;if(f>>>0>=(c[n>>2]|0)-d>>2>>>0)break;if(c[d+(f<<2)>>2]|0){TX(q);d=lh(q,c[(c[m>>2]|0)+(f<<2)>>2]|0)|0;e=c[g>>2]|0;if((e|0)==(c[h>>2]|0))Ax(p,d);else{p2(e,d);c[g>>2]=(c[g>>2]|0)+12}z5(q)}f=f+1|0}de(q,p);zb(b,0,0,77,q,0);z5(q);HX(o,39932)|0;de(q,p);t=a[q+8+3>>0]|0;s=t<<24>>24<0;Ex(o,s?c[q>>2]|0:q,s?c[q+4>>2]|0:t&255)|0;z5(q);Gx(o,41);$_(p)}zb(b,0,0,71,o,1);z5(o)}cU(m)}else{t=g;e1(b,c[t>>2]|0,c[t+4>>2]|0)}l=r;return}function ze(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=a+b|0;d=c[a+4>>2]|0;do if(!(d&1)){e=c[a>>2]|0;if(!(d&3))return;g=a+(0-e)|0;h=e+b|0;if((g|0)==(c[102125]|0)){a=j+4|0;d=c[a>>2]|0;if((d&3|0)!=3){i=g;d=h;break}c[102122]=h;c[a>>2]=d&-2;c[g+4>>2]=h|1;c[g+h>>2]=h;return}b=e>>>3;if(e>>>0<256){a=c[g+8>>2]|0;d=c[g+12>>2]|0;if((d|0)==(a|0)){c[102120]=c[102120]&~(1<<b);i=g;d=h;break}else{c[a+12>>2]=d;c[d+8>>2]=a;i=g;d=h;break}}f=c[g+24>>2]|0;a=c[g+12>>2]|0;do if((a|0)==(g|0)){b=g+16|0;d=b+4|0;a=c[d>>2]|0;if(!a){a=c[b>>2]|0;if(!a){a=0;break}else d=b}while(1){b=a+20|0;e=c[b>>2]|0;if(e|0){a=e;d=b;continue}b=a+16|0;e=c[b>>2]|0;if(!e)break;else{a=e;d=b}}c[d>>2]=0}else{i=c[g+8>>2]|0;c[i+12>>2]=a;c[a+8>>2]=i}while(0);if(f){d=c[g+28>>2]|0;b=408784+(d<<2)|0;e=(a|0)==0;if((g|0)==(c[b>>2]|0)){c[b>>2]=a;if(e){c[102121]=c[102121]&~(1<<d);i=g;d=h;break}}else{c[f+16+(((c[f+16>>2]|0)!=(g|0)&1)<<2)>>2]=a;if(e){i=g;d=h;break}}c[a+24>>2]=f;d=g+16|0;b=c[d>>2]|0;if(b|0){c[a+16>>2]=b;c[b+24>>2]=a}d=c[d+4>>2]|0;if(d){c[a+20>>2]=d;c[d+24>>2]=a;i=g;d=h}else{i=g;d=h}}else{i=g;d=h}}else{i=a;d=b}while(0);a=j+4|0;e=c[a>>2]|0;if(!(e&2)){a=c[102125]|0;if((j|0)==(c[102126]|0)){j=(c[102123]|0)+d|0;c[102123]=j;c[102126]=i;c[i+4>>2]=j|1;if((i|0)!=(a|0))return;c[102125]=0;c[102122]=0;return}if((j|0)==(a|0)){j=(c[102122]|0)+d|0;c[102122]=j;c[102125]=i;c[i+4>>2]=j|1;c[i+j>>2]=j;return}g=(e&-8)+d|0;b=e>>>3;do if(e>>>0<256){d=c[j+8>>2]|0;a=c[j+12>>2]|0;if((a|0)==(d|0)){c[102120]=c[102120]&~(1<<b);break}else{c[d+12>>2]=a;c[a+8>>2]=d;break}}else{f=c[j+24>>2]|0;a=c[j+12>>2]|0;do if((a|0)==(j|0)){b=j+16|0;d=b+4|0;a=c[d>>2]|0;if(!a){a=c[b>>2]|0;if(!a){e=0;break}else d=b}while(1){b=a+20|0;e=c[b>>2]|0;if(e|0){a=e;d=b;continue}b=a+16|0;e=c[b>>2]|0;if(!e)break;else{a=e;d=b}}c[d>>2]=0;e=a}else{e=c[j+8>>2]|0;c[e+12>>2]=a;c[a+8>>2]=e;e=a}while(0);if(f|0){a=c[j+28>>2]|0;d=408784+(a<<2)|0;b=(e|0)==0;if((j|0)==(c[d>>2]|0)){c[d>>2]=e;if(b){c[102121]=c[102121]&~(1<<a);break}}else{c[f+16+(((c[f+16>>2]|0)!=(j|0)&1)<<2)>>2]=e;if(b)break}c[e+24>>2]=f;a=j+16|0;d=c[a>>2]|0;if(d|0){c[e+16>>2]=d;c[d+24>>2]=e}a=c[a+4>>2]|0;if(a|0){c[e+20>>2]=a;c[a+24>>2]=e}}}while(0);c[i+4>>2]=g|1;c[i+g>>2]=g;if((i|0)==(c[102125]|0)){c[102122]=g;return}else d=g}else{c[a>>2]=e&-2;c[i+4>>2]=d|1;c[i+d>>2]=d}a=d>>>3;if(d>>>0<256){b=408520+(a<<1<<2)|0;d=c[102120]|0;a=1<<a;if(!(d&a)){c[102120]=d|a;a=b;d=b+8|0}else{d=b+8|0;a=c[d>>2]|0}c[d>>2]=i;c[a+12>>2]=i;c[i+8>>2]=a;c[i+12>>2]=b;return}a=d>>>8;if(a)if(d>>>0>16777215)a=31;else{h=(a+1048320|0)>>>16&8;j=a<<h;g=(j+520192|0)>>>16&4;j=j<<g;a=(j+245760|0)>>>16&2;a=14-(g|h|a)+(j<<a>>>15)|0;a=d>>>(a+7|0)&1|a<<1}else a=0;f=408784+(a<<2)|0;c[i+28>>2]=a;c[i+20>>2]=0;c[i+16>>2]=0;b=c[102121]|0;e=1<<a;if(!(b&e)){c[102121]=b|e;c[f>>2]=i;c[i+24>>2]=f;c[i+12>>2]=i;c[i+8>>2]=i;return}b=d<<((a|0)==31?0:25-(a>>>1)|0);e=c[f>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(d|0)){a=69;break}f=e+16+(b>>>31<<2)|0;a=c[f>>2]|0;if(!a){a=68;break}else{b=b<<1;e=a}}if((a|0)==68){c[f>>2]=i;c[i+24>>2]=e;c[i+12>>2]=i;c[i+8>>2]=i;return}else if((a|0)==69){h=e+8|0;j=c[h>>2]|0;c[j+12>>2]=i;c[h>>2]=i;c[i+8>>2]=j;c[i+12>>2]=e;c[i+24>>2]=0;return}}function Ae(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=l;l=l+16|0;s=x+12|0;r=x+8|0;t=x+4|0;u=x;O4(s,e);v=u$(c[s>>2]|0,409148)|0;c6(s);c[f>>2]=0;j=h;k=0;a:while(1){p=(j|0)!=(i|0);m=b;h=b;while(1){if(!(p&(k|0)==0)){b=d;break a}k=h;if(!h){b=m;h=0;n=1;o=k}else{b=c[h+12>>2]|0;if((b|0)==(c[h+16>>2]|0))b=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else b=raa(c[b>>2]|0)|0;o=d8(b,-1)|0;b=o?0:m;h=o?0:h;n=o;o=o?0:k}k=d;if(d){m=c[d+12>>2]|0;if((m|0)==(c[d+16>>2]|0))m=nb[c[(c[d>>2]|0)+36>>2]&255](d)|0;else m=raa(c[m>>2]|0)|0;if(!(d8(m,-1)|0)){if(!n){w=54;break a}}else{k=0;w=14}}else w=14;if((w|0)==14){w=0;if(n){d=0;w=54;break a}else d=0}if((gb[c[(c[v>>2]|0)+52>>2]&31](v,c[j>>2]|0,0)|0)<<24>>24==37){w=17;break}if(gb[c[(c[v>>2]|0)+12>>2]&31](v,8192,c[j>>2]|0)|0){w=24;break}m=h+12|0;k=c[m>>2]|0;n=h+16|0;if((k|0)==(c[n>>2]|0))k=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else k=raa(c[k>>2]|0)|0;q=tb[c[(c[v>>2]|0)+28>>2]&31](v,k)|0;if((q|0)==(tb[c[(c[v>>2]|0)+28>>2]&31](v,c[j>>2]|0)|0)){w=50;break}c[f>>2]=4;m=b;k=4}b:do if((w|0)==17){w=0;m=j+4|0;if((m|0)==(i|0)){w=54;break a}b=gb[c[(c[v>>2]|0)+52>>2]&31](v,c[m>>2]|0,0)|0;switch(b<<24>>24){case 48:case 69:{j=j+8|0;if((j|0)==(i|0)){w=54;break a}n=b;h=gb[c[(c[v>>2]|0)+52>>2]&31](v,c[j>>2]|0,0)|0;j=m;break}default:{n=0;h=b}}b=c[(c[a>>2]|0)+36>>2]|0;c[t>>2]=o;c[u>>2]=k;c[r>>2]=c[t>>2];c[s>>2]=c[u>>2];j=j+8|0;b=qb[b&15](a,r,s,e,f,g,h,n)|0}else if((w|0)==24){while(1){w=0;j=j+4|0;if((j|0)==(i|0)){j=i;break}if(gb[c[(c[v>>2]|0)+12>>2]&31](v,8192,c[j>>2]|0)|0)w=24;else break}k=d;q=d;n=d;while(1){if(!h){m=1;h=0}else{d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0))d=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else d=raa(c[d>>2]|0)|0;p=d8(d,-1)|0;b=p?0:b;m=p;h=p?0:h}if(n){d=c[n+12>>2]|0;if((d|0)==(c[n+16>>2]|0))d=nb[c[(c[n>>2]|0)+36>>2]&255](n)|0;else d=raa(c[d>>2]|0)|0;if(!(d8(d,-1)|0))if((k|0)==0^m){o=k;d=q;p=k}else{d=q;break b}else{k=0;d=0;w=37}}else{d=q;w=37}if((w|0)==37){w=0;if(m)break b;else{o=k;p=0}}m=h+12|0;k=c[m>>2]|0;n=h+16|0;if((k|0)==(c[n>>2]|0))k=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else k=raa(c[k>>2]|0)|0;if(!(gb[c[(c[v>>2]|0)+12>>2]&31](v,8192,k)|0))break b;k=c[m>>2]|0;if((k|0)==(c[n>>2]|0)){nb[c[(c[h>>2]|0)+40>>2]&255](h)|0;k=o;q=d;n=p;continue}else{c[m>>2]=k+4;k=o;q=d;n=p;continue}}}else if((w|0)==50){w=0;j=j+4|0;k=c[m>>2]|0;if((k|0)==(c[n>>2]|0)){nb[c[(c[h>>2]|0)+40>>2]&255](h)|0;break}else{c[m>>2]=k+4;break}}while(0);k=c[f>>2]|0}if((w|0)==54){c[f>>2]=4;b=d}if(!h){h=0;j=1}else{d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0))d=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else d=raa(c[d>>2]|0)|0;j=d8(d,-1)|0;h=j?0:h}if(b){d=c[b+12>>2]|0;if((d|0)==(c[b+16>>2]|0))d=nb[c[(c[b>>2]|0)+36>>2]&255](b)|0;else d=raa(c[d>>2]|0)|0;if(!(d8(d,-1)|0)){if(!j)w=67}else w=65}else w=65;if((w|0)==65?j:0)w=67;if((w|0)==67)c[f>>2]=c[f>>2]|2;l=x;return h|0}function Be(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+32|0;t=u+12|0;s=u;f=a[e+828>>0]|0;k=f&255;m=e+880|0;if(f<<24>>24==-1){TX(t);f=e+884|0;g=c[f>>2]|0;if(g>>>0<(c[e+888>>2]|0)>>>0){rV(g,t);c[f>>2]=(c[f>>2]|0)+12}else Dx(m,t);z5(t);h=0}else{g=a[372234+(d[e+1240>>0]|0)>>0]|0;i=c[e+836>>2]|0;if(i&1)g=((a[e+1241>>0]|0)!=0&1)+g<<24>>24;if((i&8|0)==0?(j=(g&255)+1|0,h=k>>>0<j>>>0,(a[e+833>>0]|0)!=0):0)f=h?j&255:f;else h=0;uU(t,f,10);f=e+884|0;g=c[f>>2]|0;if(g>>>0<(c[e+888>>2]|0)>>>0){rV(g,t);c[f>>2]=(c[f>>2]|0)+12}else Dx(m,t);z5(t)}g=e+816|0;f=b[g>>1]|0;i=e+920|0;p=e+1e3|0;m=e+960|0;n=e+964|0;q=e+1004|0;r=e+1008|0;j=e+924|0;o=e+968|0;k=e+928|0;if(f<<16>>16==-1){TX(t);f=c[j>>2]|0;if(f>>>0<(c[k>>2]|0)>>>0){rV(f,t);c[j>>2]=(c[j>>2]|0)+12}else Dx(i,t);z5(t);TX(t);f=c[n>>2]|0;if(f>>>0<(c[o>>2]|0)>>>0){rV(f,t);c[n>>2]=(c[n>>2]|0)+12}else Dx(m,t);z5(t);TX(t);f=c[q>>2]|0;if(f>>>0<(c[r>>2]|0)>>>0){rV(f,t);c[q>>2]=(c[q>>2]|0)+12}else Dx(p,t);z5(t)}else{Mk(s,f,h);VU(t,(a[s+11>>0]|0)<0?c[s>>2]|0:s);f=c[j>>2]|0;if(f>>>0<(c[k>>2]|0)>>>0){rV(f,t);c[j>>2]=(c[j>>2]|0)+12}else Dx(i,t);z5(t);a1(s);nj(s,b[g>>1]|0,h);VU(t,(a[s+11>>0]|0)<0?c[s>>2]|0:s);f=c[n>>2]|0;if(f>>>0<(c[o>>2]|0)>>>0){rV(f,t);c[n>>2]=(c[n>>2]|0)+12}else Dx(m,t);z5(t);a1(s);TX(t);f=c[q>>2]|0;if(f>>>0<(c[r>>2]|0)>>>0){rV(f,t);c[q>>2]=(c[q>>2]|0)+12}else Dx(p,t);z5(t)}f=a[e+826>>0]|0;h=e+1040|0;if(f<<24>>24==-1){TX(t);f=e+1044|0;g=c[f>>2]|0;if(g>>>0<(c[e+1048>>2]|0)>>>0){rV(g,t);c[f>>2]=(c[f>>2]|0)+12}else Dx(h,t);z5(t)}else{uU(t,f,10);f=e+1044|0;g=c[f>>2]|0;if(g>>>0<(c[e+1048>>2]|0)>>>0){rV(g,t);c[f>>2]=(c[f>>2]|0)+12}else Dx(h,t);z5(t)}f=a[e+827>>0]|0;h=e+1080|0;if(f<<24>>24==-1){TX(t);f=e+1084|0;g=c[f>>2]|0;if(g>>>0<(c[e+1088>>2]|0)>>>0){rV(g,t);c[f>>2]=(c[f>>2]|0)+12}else Dx(h,t);z5(t)}else{sU(t,c[13852+((f&255)<<2)>>2]|0,10);f=e+1084|0;g=c[f>>2]|0;if(g>>>0<(c[e+1088>>2]|0)>>>0){rV(g,t);c[f>>2]=(c[f>>2]|0)+12}else Dx(h,t);z5(t)}ST(t,+Sm(e,1),0);f=e+1124|0;g=c[f>>2]|0;if(g>>>0<(c[e+1128>>2]|0)>>>0){rV(g,t);c[f>>2]=(c[f>>2]|0)+12}else Dx(e+1120|0,t);z5(t);Xy(t,40152);f=e+1164|0;g=c[f>>2]|0;if(g>>>0<(c[e+1168>>2]|0)>>>0){rV(g,t);c[f>>2]=(c[f>>2]|0)+12}else Dx(e+1160|0,t);z5(t);Xy(t,14516);f=e+1204|0;g=c[f>>2]|0;if(g>>>0<(c[e+1208>>2]|0)>>>0){rV(g,t);c[f>>2]=(c[f>>2]|0)+12}else Dx(e+1200|0,t);z5(t);l=u;return}function Ce(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=l;l=l+128|0;H=I+100|0;x=I+113|0;y=I+112|0;z=I+96|0;A=I+84|0;E=I+72|0;F=I+60|0;G=I+48|0;k=I+36|0;m=I+24|0;n=I+12|0;o=I;TX(H);GC(b);bB(b,x);p=A+8+3|0;q=A+4|0;r=k+8+3|0;s=k+4|0;t=H+8+3|0;u=H+4|0;v=E+8+3|0;w=E+4|0;x=a[x>>0]|0;j=0;while(1){if((j&255)>=(x&255))break;GC(b);s3(b,z);bB(b,y);i=a[y>>0]|0;h=0;while(1){if((h&255)>=(i&255))break;GC(b);TX(A);bB(b,E);bB(b,F);bB(b,G);a:do if(!(a[E>>0]|0)){f=a[F>>0]|0;switch(f<<24>>24){case 0:{jZ(b,d[G>>0]|0,0,A);break a}case 63:{WY(b,d[G>>0]|0,0,A);break a}default:{e1(b,d[G>>0]|0,0);uU(o,f,16);DW(o,0,41440)|0;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];f=0;while(1){if((f|0)==3)break;c[o+(f<<2)>>2]=0;f=f+1|0}Gx(n,41);c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];f=0;while(1){if((f|0)==3)break;c[n+(f<<2)>>2]=0;f=f+1|0}p2(k,m);vF(A,k)|0;z5(k);O0(m);O0(n);z5(o);break a}}}else{e1(b,d[G>>0]|0,0);Xy(k,41528);vF(A,k)|0;z5(k)}while(0);J3(b);b:do if(qO(b)|0?(C=a[p>>0]|0,D=C<<24>>24<0,B=D?c[A>>2]|0:A,C=D?c[q>>2]|0:C&255,D=i9(41580)|0,C|0):0){g=B+(C<<2)|0;f=B;while(1){if((f|0)==(g|0))break b;if(!(U_(41580,D,f)|0))break;f=f+4|0}if((f-B|0)!=-4){Bs(k,A,41596);g=a[r>>0]|0;f=g<<24>>24<0;Ex(H,f?c[k>>2]|0:k,f?c[s>>2]|0:g&255)|0;O0(k)}}while(0);z5(A);h=h+1<<24>>24}if(qO(b)|0){f=a[t>>0]|0;f=f<<24>>24<0?c[u>>2]|0:f&255;if(f|0)FB(H,f+-3|0,0);TX(E);p2(A,Tv(E,c[z>>2]|0)|0);z5(E);f=SG(A)|0;i=a[f+8+3>>0]|0;nt(G,((i<<24>>24<0?c[f+4>>2]|0:i&255)|0)==0?A:f,58);f=a[t>>0]|0;i=f<<24>>24<0;Ex(G,i?c[H>>2]|0:H,i?c[u>>2]|0:f&255)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];f=0;while(1){if((f|0)==3)break;c[G+(f<<2)>>2]=0;f=f+1|0}HX(F,41596)|0;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];f=0;while(1){if((f|0)==3)break;c[F+(f<<2)>>2]=0;f=f+1|0}i=a[v>>0]|0;h=i<<24>>24<0;Ex(e,h?c[E>>2]|0:E,h?c[w>>2]|0:i&255)|0;O0(E);O0(F);O0(G);z5(A)}J3(b);j=j+1<<24>>24}f=a[e+8+3>>0]|0;f=f<<24>>24<0?c[e+4>>2]|0:f&255;if(f|0)FB(e,f+-3|0,0);J3(b);z5(H);l=I;return}function De(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=l;l=l+48|0;q=F+16|0;z=F+12|0;A=F+8|0;B=F+4|0;C=F+22|0;D=F+20|0;f=F+37|0;E=F+36|0;s=F+35|0;t=F+34|0;u=F+33|0;v=F+32|0;y=F+31|0;h=F+30|0;i=F+29|0;k=F+28|0;w=F+27|0;n=F+26|0;p=F+25|0;x=F+24|0;r=F;c[q>>2]=0;c[z>>2]=0;c[A>>2]=-1;c[B>>2]=-1;b[C>>1]=-1;b[D>>1]=-1;a[f>>0]=0;a[E>>0]=5;a[s>>0]=0;a[t>>0]=2;a[u>>0]=2;a[v>>0]=2;a[i>>0]=0;a[w>>0]=0;yT(d,y);y=a[y>>0]|0;if(!(y<<24>>24)){g=d+648|0;A6(c[g>>2]|0);o=0}else{GC(d);g=d+648|0;A6(c[g>>2]|0);xR(d,8,f);f=a[f>>0]|0;if(f<<24>>24==-1){sR(d,16,C);sR(d,16,D)}J3(d);o=f}if(K6(c[g>>2]|0)|0){GC(d);A6(c[g>>2]|0);A6(c[g>>2]|0);J3(d)}else A6(c[g>>2]|0);yT(d,h);m=a[h>>0]|0;if(!(m<<24>>24)){A6(c[g>>2]|0);j=0}else{GC(d);A6(c[g>>2]|0);xR(d,3,E);xR(d,1,s);yT(d,i);f=a[i>>0]|0;if(!(f<<24>>24))A6(c[g>>2]|0);else{GC(d);A6(c[g>>2]|0);xR(d,8,t);xR(d,8,u);xR(d,8,v);J3(d)}J3(d);j=f}if(K6(c[g>>2]|0)|0){GC(d);A6(c[g>>2]|0);T5(d);T5(d);J3(d)}else A6(c[g>>2]|0);yT(d,k);i=a[k>>0]|0;if(!(i<<24>>24))A6(c[g>>2]|0);else{GC(d);A6(c[g>>2]|0);rR(d,32,A);rR(d,32,B);AT(d,w);J3(d)}yT(d,n);h=a[n>>0]|0;if(!(h<<24>>24))A6(c[g>>2]|0);else{GC(d);A6(c[g>>2]|0);$h(d,q);J3(d)}yT(d,p);f=a[p>>0]|0;if(!(f<<24>>24))A6(c[g>>2]|0);else{GC(d);A6(c[g>>2]|0);$h(d,z);J3(d)}if((f|h)<<24>>24)A6(c[g>>2]|0);AT(d,x);if(K6(c[g>>2]|0)|0){GC(d);A6(c[g>>2]|0);A6(c[g>>2]|0);T5(d);T5(d);T5(d);T5(d);n3(d,r);T5(d);J3(d)}else A6(c[g>>2]|0);r=qO(d)|0;f=c[q>>2]|0;if(!r){if(f|0){VZ(f);laa(f)}f=c[z>>2]|0;if(f|0){VZ(f);laa(f)}}else{r=ZW(32)|0;_w(r,f,c[z>>2]|0,c[A>>2]|0,c[B>>2]|0,b[C>>1]|0,b[D>>1]|0,o,a[E>>0]|0,a[s>>0]|0,a[t>>0]|0,a[u>>0]|0,a[v>>0]|0,y<<24>>24!=0,m<<24>>24!=0,j<<24>>24!=0,i<<24>>24!=0,(a[w>>0]|0)!=0,(a[x>>0]|0)!=0);c[e>>2]=r}l=F;return}function Ee(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;q=l;l=l+64|0;i=q;k=q+44|0;n=q+40|0;p=q+28|0;f=q+48|0;h=q+16|0;L2(i);j0(d,i);CK(d);j=d+528|0;e=j;e=z0(c[e>>2]|0,c[e+4>>2]|0,8,0)|0;o=j;c[o>>2]=e;c[o+4>>2]=z;bD(d,k);bD(d,n);o=d+772|0;HB(d,o);e=b[o>>1]|0;if(e<<16>>16<0){Xy(p,33456);b[f>>1]=b[o>>1]&127;f=sF(d+760|0,f)|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;g=j9(380114)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[h+11>>0]=g;e=h}else{r=g+16&-16;e=ZW(r)|0;c[h>>2]=e;c[h+8>>2]=r|-2147483648;c[h+4>>2]=g}i1(e,380114,g)|0;J7(e+g|0,0);vF(VC(f+40|0,h)|0,p)|0;a1(h);z5(p);e=b[o>>1]|0}b[o>>1]=e&127;e=j;e=z0(c[e>>2]|0,c[e+4>>2]|0,4,0)|0;f=j;c[f>>2]=e;c[f+4>>2]=z;f=i+8|0;e=c[f>>2]|0;f=c[f+4>>2]|0;a:do if((e|0)<485653065){if((e|0)<367316753){switch(e|0){case -280497600:break;default:{m=19;break a}}if((f|0)==-496633030){m=18;break}else{m=19;break}}switch(e|0){case 367316753:break;default:{m=19;break a}}if((f|0)==-528641995){GC(d);tr(d);J3(d)}else m=19}else{if((e|0)<1297862417){switch(e|0){case 485653065:break;default:{m=19;break a}}if((f|0)==740474257){m=18;break}else{m=19;break}}if((e|0)>=1314639633){switch(e|0){case 1314639633:break;default:{m=19;break a}}if((f|0)!=14752694){m=19;break}GC(d);rw(d);J3(d);break}switch(e|0){case 1297862417:break;default:{m=19;break a}}if((f|0)<1084123640){switch(f|0){case -1058072132:break;default:{m=19;break a}}GC(d);Ge(d);J3(d);break}else{switch(f|0){case 1084123640:break;default:{m=19;break a}}GC(d);$g(d);J3(d);break}}while(0);if((m|0)==18){GC(d);mE(d);c[d+16>>2]=7;c[d+20>>2]=-1;J3(d)}else if((m|0)==19){e=c[k>>2]|0;if(e|0)e1(d,e,0);c[d+16>>2]=7;c[d+20>>2]=-1}e=c[n>>2]|0;if(e|0)e1(d,e,0);g=sF(d+760|0,o)|0;c[g+12>>2]=c[d+16>>2];c[g+16>>2]=c[d+20>>2];g=g+40|0;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;f=j9(380243)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[p+11>>0]=f;e=p}else{r=f+16&-16;e=ZW(r)|0;c[p>>2]=e;c[p+8>>2]=r|-2147483648;c[p+4>>2]=f}i1(e,380243,f)|0;J7(e+f|0,0);f=VC(g,p)|0;Ek(f,b[o>>1]|0,10)|0;a1(p);c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;f=j9(380246)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[p+11>>0]=f;e=p}else{r=f+16&-16;e=ZW(r)|0;c[p>>2]=e;c[p+8>>2]=r|-2147483648;c[p+4>>2]=f}i1(e,380246,f)|0;J7(e+f|0,0);o=VC(g,p)|0;r=d+856|0;Gk(o,c[r>>2]|0,10)|0;a1(p);c[r>>2]=(c[r>>2]|0)+1;l=q;return}function Fe(f,g){f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;H=c[f+28>>2]|0;h=c[f>>2]|0;M=f+4|0;N=h+((c[M>>2]|0)+-5)|0;O=f+12|0;k=c[O>>2]|0;I=f+16|0;t=c[I>>2]|0;J=k+(t+-257)|0;y=c[H+44>>2]|0;z=c[H+48>>2]|0;A=c[H+52>>2]|0;B=c[H+56>>2]|0;K=H+60|0;L=H+64|0;C=c[H+80>>2]|0;D=c[H+84>>2]|0;E=(1<<c[H+88>>2])+-1|0;F=(1<<c[H+92>>2])+-1|0;t=k+(t-g)|0;u=H+7108|0;v=(A|0)==0;w=A+y|0;x=t-A|0;g=k;k=c[K>>2]|0;j=c[L>>2]|0;a:do{if(j>>>0<15){m=h+2|0;k=((d[h>>0]|0)<<j)+k+((d[h+1>>0]|0)<<j+8)|0;j=j+16|0}else m=h;l=k;h=k&E;while(1){G=a[C+(h<<2)>>0]|0;i=b[C+(h<<2)+2>>1]|0;h=d[C+(h<<2)+1>>0]|0;k=l>>>h;j=j-h|0;h=G&255;if(!(G<<24>>24)){G=6;break}o=i&65535;if(h&16|0){G=8;break}if(h&64|0){G=47;break a}l=k;h=(k&(1<<h)+-1)+o|0}do if((G|0)==6){G=0;a[g>>0]=i;h=m;g=g+1|0}else if((G|0)==8){G=0;l=h&15;if(!l)i=m;else{if(j>>>0<l>>>0){h=m+1|0;k=((d[m>>0]|0)<<j)+k|0;j=j+8|0}else h=m;o=(k&(1<<l)+-1)+o|0;i=h;k=k>>>l;j=j-l|0}if(j>>>0<15){h=i+2|0;k=((d[i>>0]|0)<<j)+k+((d[i+1>>0]|0)<<j+8)|0;j=j+16|0}else h=i;m=k;i=k&F;while(1){l=d[D+(i<<2)+1>>0]|0;k=m>>>l;j=j-l|0;l=d[D+(i<<2)>>0]|0;n=e[D+(i<<2)+2>>1]|0;if(l&16|0)break;if(l&64|0){i=392382;G=49;break a}m=k;i=(k&(1<<l)+-1)+n|0}m=l&15;if(j>>>0<m>>>0){i=h+1|0;k=((d[h>>0]|0)<<j)+k|0;l=j+8|0;if(l>>>0<m>>>0){h=h+2|0;k=((d[i>>0]|0)<<l)+k|0;j=j+16|0}else{h=i;j=l}}n=(k&(1<<m)+-1)+n|0;k=k>>>m;j=j-m|0;l=g;i=l-t|0;m=0-n|0;if(n>>>0<=i>>>0){l=g+m|0;m=g;while(1){a[m>>0]=a[l>>0]|0;a[m+1>>0]=a[l+1>>0]|0;i=l+3|0;g=m+3|0;a[m+2>>0]=a[l+2>>0]|0;o=o+-3|0;if(o>>>0<=2)break;else{l=i;m=g}}if(!o)break;n=m+4|0;a[g>>0]=a[i>>0]|0;if((o|0)==1){g=n;break}a[n>>0]=a[l+4>>0]|0;g=m+5|0;break}i=n-i|0;if(i>>>0>z>>>0?c[u>>2]|0:0){i=392404;G=49;break a}r=o-i|0;p=o>>>0>i>>>0;q=n-l|0;s=g+t+q|0;n=s+m|0;b:do if(v){l=B+(y-i)|0;if(p)while(1){a[g>>0]=a[l>>0]|0;i=i+-1|0;if(!i){o=r;g=s;break}else{l=l+1|0;g=g+1|0}}else n=l}else{if(A>>>0>=i>>>0){l=B+(A-i)|0;if(!p){n=l;break}while(1){a[g>>0]=a[l>>0]|0;i=i+-1|0;if(!i){o=r;g=s;break b}else{l=l+1|0;g=g+1|0}}}l=B+(w-i)|0;p=i-A|0;if(o>>>0>p>>>0){i=l;l=p;m=g;while(1){a[m>>0]=a[i>>0]|0;l=l+-1|0;if(!l)break;else{i=i+1|0;m=m+1|0}}o=o-p|0;g=g+x+q|0;if(o>>>0>A>>>0){i=B;l=A;while(1){a[g>>0]=a[i>>0]|0;l=l+-1|0;if(!l)break;else{i=i+1|0;g=g+1|0}}o=o-A|0;g=s}else n=B}else n=l}while(0);while(1){l=g+1|0;m=g+2|0;i=n+1|0;if(o>>>0<=2)break;a[g>>0]=a[n>>0]|0;a[l>>0]=a[i>>0]|0;a[m>>0]=a[n+2>>0]|0;o=o+-3|0;n=n+3|0;g=g+3|0}if(o){a[g>>0]=a[n>>0]|0;if((o|0)==1)g=l;else{a[l>>0]=a[i>>0]|0;g=m}}}while(0)}while(g>>>0<J>>>0&h>>>0<N>>>0);if((G|0)==47)if(!(h&32)){h=m;i=392354;G=49}else{h=m;i=16191;G=50}if((G|0)==49){c[f+24>>2]=i;i=16209;G=50}if((G|0)==50)c[H+4>>2]=i;H=j>>>3;G=h+(0-H)|0;H=j-(H<<3)|0;c[f>>2]=G;c[O>>2]=g;c[M>>2]=N+5-G;c[I>>2]=J+257-g;c[K>>2]=(1<<H)+-1&k;c[L>>2]=H;return}function Ge(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;r=l;l=l+32|0;f=r+20|0;g=r+16|0;j=r+12|0;o=r+26|0;e=r+24|0;m=r;bD(d,f);bD(d,g);p=d+528|0;s=p;s=z0(c[s>>2]|0,c[s+4>>2]|0,1,0)|0;q=p;c[q>>2]=s;c[q+4>>2]=z;HB(d,o);q=p;q=z0(c[q>>2]|0,c[q+4>>2]|0,4,0)|0;s=p;c[s>>2]=q;c[s+4>>2]=z;bD(d,f);bD(d,g);s=p;s=z0(c[s>>2]|0,c[s+4>>2]|0,2,0)|0;q=p;c[q>>2]=s;c[q+4>>2]=z;HB(d,e);r3(d,j);q=p;q=z0(c[q>>2]|0,c[q+4>>2]|0,20,0)|0;c[p>>2]=q;c[p+4>>2]=z;Kc(d,1,-1)|0;p=d+760|0;q=d+772|0;a[(sF(p,q)|0)+52>>0]=1;TX(m);j=c[j>>2]|0;s=lh(m,j)|0;k=d+20|0;Rf(d,s,1,c[k>>2]|0,3);z5(m);s=c[k>>2]|0;TX(m);zb(d,1,s,58,lh(m,j)|0,0);z5(m);s=c[k>>2]|0;TX(m);zb(d,1,s,63,lh(m,j)|0,0);z5(m);lL(d,1,c[k>>2]|0,130,c[f>>2]|0,10,0);lL(d,1,c[k>>2]|0,138,c[g>>2]|0,10,0);e=b[e>>1]|0;if(e<<16>>16)sM(d,1,c[k>>2]|0,195,(((e&65535)%3|0)<<16>>16?e:(e&65535)/3|0)&65535,0);if((j|0)==(W8(380263)|0))a[d+823>>0]=1;g=d+840|0;f=c[g>>2]|0;g=c[g+4>>2]|0;do if(!((f|0)==0&(g|0)==0)?(i=d+848|0,h=c[i>>2]|0,i=c[i+4>>2]|0,!((h|0)==0&(i|0)==0)):0){e=c[k>>2]|0;if((f|0)==16&(g|0)==0&((h|0)==9&(i|0)==0)){Bt(d,1,e,156,1.7777777910232544,3,0);break}if((f|0)==4&(g|0)==0&((h|0)==3&(i|0)==0)){Bt(d,1,e,156,1.3333333730697632,3,0);break}else{Bt(d,1,e,150,(+(f>>>0)+4294967296.0*+(g>>>0))/(+(h>>>0)+4294967296.0*+(i>>>0)),3,1);break}}while(0);TX(m);e=Aj(1,3,lh(m,j)|0,1)|0;f=i9(30008)|0;s=a[e+8+3>>0]|0;do if((f|0)==((s<<24>>24<0?c[e+4>>2]|0:s&255)|0)){s=(VG(e,30008,f)|0)==0;z5(m);if(s){s=sF(p,q)|0;e=ZW(920)|0;Wv(e);c[s>>2]=e;if((j|0)==(W8(383843)|0)){a[e+769>>0]=1;a[e+733>>0]=0}a[e+768>>0]=1;aY(d,e);e=b[o>>1]|0;if((e&65535)>40){f=sF(p,q)|0;iA(d,c[f>>2]|0,(e&65535)+-40|0);e=c[f>>2]|0;if(!(c[e+728>>2]&8)){a[e+770>>0]=1;a[e+733>>0]=0;break}G2(d,e);Gb(d,c[f>>2]|0,1,0,c[k>>2]|0,1)|0;e=c[f>>2]|0;if(e|0)jb[c[(c[e>>2]|0)+4>>2]&511](e);c[f>>2]=0}}else n=23}else{z5(m);n=23}while(0);do if((n|0)==23){TX(m);e=UJ(lh(m,j)|0,4)|0;f=a[e+8+3>>0]|0;g=f<<24>>24<0;h=g?c[e>>2]|0:e;i=i9(33496)|0;if(i){s=h+((g?c[e+4>>2]|0:f&255)<<2)|0;n=HA(h,s,33496,33496+(i<<2)|0)|0;z5(m);if(!((n|0)==(h|0)&(n|0)!=(s|0))){e=b[o>>1]|0;if((e&65535)<=40)break;s=(e&65535)+-40|0;e1(d,s,((s|0)<0)<<31>>31);break}}else z5(m);q=sF(p,q)|0;s=ZW(1104)|0;ln(s);c[q>>2]=s;q=s+768|0;c[q>>2]=30;c[q+4>>2]=0;aY(d,s)}while(0);l=r;return}function He(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;D=l;l=l+16|0;d=D;a:do if(tu(b+760|0,d,0)|0)if(!(a[d>>0]|0)){B=b+612|0;C=b+544|0;w=b+492|0;t=b+48|0;u=b+40|0;v=b+784|0;d=c[B>>2]|0;A=c[b+548>>2]|0;e=d;b:while(1){if((d+6|0)>>>0>A>>>0)break;else s=e;while(1){e=d+1|0;if((d+6|0)>>>0>A>>>0){e=s;continue b}r=c[C>>2]|0;d=r+d|0;if((a[d>>0]|0)==-1?(a[r+e>>0]&-10)<<24>>24==-16:0)break;c[B>>2]=e;d=e;s=e}d=d+3|0;d=(R4(a[d>>0]|0,a[d+1>>0]|0,a[d+2>>0]|0)|0)>>>5&8191;e=a[w>>0]|0;if(e<<24>>24!=0&(s+d|0)==(A|0)){e=s;d=s;break}n=t;m=c[n>>2]|0;n=c[n+4>>2]|0;k=z0(s|0,0,d|0,0)|0;k=z0(k|0,z|0,m|0,n|0)|0;q=z;p=u;o=v;o=D_(c[p>>2]|0,c[p+4>>2]|0,c[o>>2]|0,c[o+4>>2]|0)|0;p=z;if((k|0)==(o|0)&(q|0)==(p|0)){e=s;d=s;break}else f=d&65535;while(1){k=f&65535;j=k+s|0;if((j+2|0)>>>0>A>>>0){d=1;break}if(a[r+j>>0]|0){d=0;break}f=f+1<<16>>16}q=e<<24>>24!=0;if(q&(j|0)==(A|0)){e=s;d=s;break}if(d){d=0;break a}do if((f&65535)>=8?(y=r+s+k|0,((d7(a[y>>0]|0,a[y+1>>0]|0)|0)&-10)<<16>>16==-16):0){h=k+6|0;if((s+h|0)>>>0>A>>>0){d=0;break a}d=y+3|0;d=(R4(a[d>>0]|0,a[d+1>>0]|0,a[d+2>>0]|0)|0)>>>5&8191;i=f&65535;g=z0(m|0,n|0,i|0,0)|0;g=z0(g|0,z|0,s|0,0)|0;g=z0(g|0,z|0,d|0,0)|0;if((g|0)==(o|0)&(z|0)==(p|0)){e=s;d=s;break b}f=d&65535;while(1){g=f&65535;e=j+g|0;if((e+2|0)>>>0>A>>>0){d=1;break}if(a[r+e>>0]|0){d=0;break}f=f+1<<16>>16}if((e|0)==(A|0)&q){e=s;d=s;break b}if(d){d=0;break a}if((f&65535)>=8?(x=y+g|0,((d7(a[x>>0]|0,a[x+1>>0]|0)|0)&-10)<<16>>16==-16):0){if((g+h+s|0)>>>0>A>>>0){d=0;break a}e=x+3|0;e=(R4(a[e>>0]|0,a[e+1>>0]|0,a[e+2>>0]|0)|0)>>>5&8191;j=z0(f&65535|0,0,i|0,0)|0;n=z0(j|0,z|0,m|0,n|0)|0;n=z0(n|0,z|0,s|0,0)|0;n=z0(n|0,z|0,e|0,0)|0;if((n|0)==(o|0)&(z|0)==(p|0)){e=s;d=s;break b}d=g+k+s|0;e=e&65535;while(1){f=e&65535;g=d+f|0;if((g+2|0)>>>0>A>>>0){d=1;break}if(a[r+g>>0]|0){d=0;break}e=e+1<<16>>16}if((g|0)==(A|0)&q){e=s;d=s;break b}if(d){d=0;break a}if((e&65535)<8)break;r=x+f|0;if(((d7(a[r>>0]|0,a[r+1>>0]|0)|0)&-10)<<16>>16==-16){e=s;d=s;break b}}}while(0);d=s+1|0;c[B>>2]=d;e=d}if((d+6|0)>>>0<=A>>>0){c[b+908>>2]=4;d=1;break}if((d+5|0)==(A|0)){b=(c[C>>2]|0)+d|0;d=e+1|0;if(((d7(a[b>>0]|0,a[b+1>>0]|0)|0)&-10)<<16>>16==-16){f=e;d=e}else{c[B>>2]=d;f=d}}else f=e;if((d+4|0)==(A|0)){b=(c[C>>2]|0)+d|0;d=f+1|0;if(((d7(a[b>>0]|0,a[b+1>>0]|0)|0)&-10)<<16>>16==-16){g=f;d=f}else{c[B>>2]=d;g=d}}else g=f;if((d+3|0)==(A|0)){b=(c[C>>2]|0)+d|0;d=g+1|0;if(((d7(a[b>>0]|0,a[b+1>>0]|0)|0)&-10)<<16>>16==-16){e=g;d=g}else{c[B>>2]=d;e=d}}else e=g;if((d+2|0)==(A|0)){b=(c[C>>2]|0)+d|0;f=e+1|0;if(((d7(a[b>>0]|0,a[b+1>>0]|0)|0)&-10)<<16>>16==-16)d=e;else{c[B>>2]=f;d=f;e=f}}if((d+1|0)==(A|0)?(D9(a[(c[C>>2]|0)+d>>0]|0)|0)<<24>>24!=-1:0){c[B>>2]=e+1;d=0}else d=0}else d=1;else d=0;while(0);l=D;return d|0}function Ie(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+32|0;o=r+12|0;p=r;n=d+764|0;e=c[n>>2]|0;m=d+778|0;q=d+782|0;if(a[e+2>>0]|0){f=b[e>>1]|0;if((b[m>>1]|0)!=f<<16>>16)g=4}else{f=b[e>>1]|0;g=4}if((g|0)==4){a:do if((UD(e+68|0,f)|0)!=(e+72|0))while(1){k=(c[(HD(e+68|0,e)|0)+24>>2]|0)==0;e=c[n>>2]|0;if(k)break a;b[q>>1]=b[(c[(HD(e+68|0,e)|0)+16>>2]|0)+16>>1]|0;Bf(d);e=c[n>>2]|0}while(0);b[e>>1]=b[m>>1]|0;a[e+2>>0]=1}f=HD(e+68|0,m)|0;e=f+40|0;if((c[e>>2]|0)==-1)c[e>>2]=0;g=c[f+28>>2]|0;e=f+32|0;f=c[e>>2]|0;while(1){if((f|0)==(g|0))break;k=f+-2|0;c[e>>2]=k;f=k}e=c[n>>2]|0;e=HD(e+68|0,e)|0;x1(o);g=e+20|0;k=o+4|0;e=c[e+16>>2]|0;b:while(1){if((e|0)==(g|0))break;f=e+16|0;ns(o,k,b[f>>1]|0,f);f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue b}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}c[p>>2]=0;j=p+4|0;c[j>>2]=0;c[p+8>>2]=0;e=c[c[(c[c[(c[n>>2]|0)+80>>2]>>2]|0)+16>>2]>>2]|0;i=p+8|0;f=c[e>>2]|0;while(1){if((f|0)==(e+4|0))break;e=f+16|0;g=b[e>>1]|0;do if(g<<16>>16!=(b[m>>1]|0)){h=c[j>>2]|0;if((h|0)==(c[i>>2]|0)){bz(p,e);break}else{b[h>>1]=g;c[j>>2]=h+2;break}}while(0);e=c[f+4>>2]|0;if(!e)while(1){e=c[f+8>>2]|0;if((c[e>>2]|0)==(f|0))break;else f=e}else while(1){f=c[e>>2]|0;if(!f)break;else e=f}f=e;e=c[c[(c[c[(c[n>>2]|0)+80>>2]>>2]|0)+16>>2]>>2]|0}e=0;while(1){f=c[p>>2]|0;if(e>>>0>=(c[j>>2]|0)-f>>1>>>0)break;PB(c[c[(c[c[(c[n>>2]|0)+80>>2]>>2]|0)+16>>2]>>2]|0,b[f+(e<<1)>>1]|0);e=e+1|0}h=d+528|0;i=d+536|0;f=d+780|0;e=d+648|0;while(1){m=h;g=c[m+4>>2]|0;n=i;j=c[n+4>>2]|0;if(!(g>>>0<j>>>0|((g|0)==(j|0)?(c[m>>2]|0)>>>0<(c[n>>2]|0)>>>0:0)))break;GC(d);NB(d,q);Bx(d);d4(c[e>>2]|0,3);sR(d,13,f);wK(d);J3(d);if(!(qO(d)|0))continue;if(!(b[f>>1]|0))continue;uf(d);g=UD(o,b[q>>1]|0)|0;if((g|0)==(k|0))continue;rx(o,g)}wK(d);c:do if(qO(d)|0){e=c[o>>2]|0;d:while(1){if((e|0)==(k|0))break c;b[q>>1]=b[e+16>>1]|0;Bf(d);f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue d}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}}while(0);bU(p);zU(o);l=r;return}function Je(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;u=l;l=l+16|0;k=u;t=b+612|0;d=c[t>>2]|0;s=b+548|0;a:do if(d>>>0<(c[s>>2]|0)>>>0){m=b+508|0;o=b+668|0;q=(c[o>>2]|0)+((c[m>>2]|0)*24|0)+8|0;p=b+48|0;n=p;r=c[n>>2]|0;n=c[n+4>>2]|0;q=D_(c[q>>2]|0,c[q+4>>2]|0,d|0,0)|0;n=D_(q|0,z|0,r|0,n|0)|0;r=b+536|0;q=r;c[q>>2]=n;c[q+4>>2]=z;q=b+528|0;n=q;c[n>>2]=0;c[n+4>>2]=0;n=b+64|0;if(!(nb[c[(c[b>>2]|0)+96>>2]&255](b)|0)){f=b+379|0;if(a[f>>0]|0){d=0;break}if(!(+g[(c[b+24>>2]|0)+136>>2]<1.0)){d=0;break}s=n;if(!((c[s>>2]|0)==-1?(c[s+4>>2]|0)==-1:0)){d=0;break}a[(c[o>>2]|0)+((c[m>>2]|0)*24|0)+16>>0]=0;jb[c[(c[b>>2]|0)+108>>2]&511](b);e=n;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!(!((d|0)==-1&(e|0)==-1)?(s=p,t=z0(c[t>>2]|0,0,c[s>>2]|0,c[s+4>>2]|0)|0,s=z,e>>>0>s>>>0|(e|0)==(s|0)&d>>>0>t>>>0):0)){if(!(c[b+728>>2]&8)){d=0;break}if(a[b+732>>0]|0){d=0;break}}a[f>>0]=1;d=0;break}i=c[m>>2]|0;j=c[o>>2]|0;w=j+(i*24|0)+8|0;v=p;f=c[t>>2]|0;e=q;d=c[e>>2]|0;e=c[e+4>>2]|0;v=D_(c[w>>2]|0,c[w+4>>2]|0,c[v>>2]|0,c[v+4>>2]|0)|0;v=D_(v|0,z|0,f|0,0)|0;e=D_(v|0,z|0,d|0,e|0)|0;d=z;v=r;c[v>>2]=e;c[v+4>>2]=d;a[j+(i*24|0)+17>>0]=0;v=z0(e|0,d|0,f|0,0)|0;w=z;h=c[s>>2]|0;f=h-f|0;if(w>>>0>0|(w|0)==0&v>>>0>h>>>0){h=r;c[h>>2]=f;c[h+4>>2]=0;h=0;e=f;d=0}else h=1;a[j+(i*24|0)+18>>0]=h;if(!((e|0)==0&(d|0)==0)){d=q;c[d>>2]=0;c[d+4>>2]=0;GC(b);GC(b);jb[c[(c[b>>2]|0)+100>>2]&511](b);d=(c[o>>2]|0)+((c[m>>2]|0)*24|0)+17|0;do if(a[d>>0]|0){a[d>>0]=0;VU(k,380235);BZ(c[m>>2]|0,c[o>>2]|0,0,0);z5(k);if(!(a[b+733>>0]|0)){k=(c[o>>2]|0)+(((c[m>>2]|0)+-2|0)*24|0)+8|0;w=p;v=c[t>>2]|0;w=D_(c[k>>2]|0,c[k+4>>2]|0,c[w>>2]|0,c[w+4>>2]|0)|0;v=D_(w|0,z|0,v|0,0)|0;w=z;k=q;c[k>>2]=v;c[k+4>>2]=w;Op(b,v,w);break}else{w=q;c[w>>2]=1;c[w+4>>2]=0;Op(b,1,0);a[b+376>>0]=0;break}}while(0);d=c[m>>2]|0;o=c[o>>2]|0;do if(!(J1(d,o)|0)){if(a[b+494>>0]|0?(k=o+((d+-1|0)*24|0)+8|0,v=c[k>>2]|0,k=c[k+4>>2]|0,w=p,w=z0(c[s>>2]|0,0,c[w>>2]|0,c[w+4>>2]|0)|0,m=z,k>>>0>m>>>0|(k|0)==(m|0)&v>>>0>w>>>0):0)break;w=n;if((c[w>>2]|0)==-1?(c[w+4>>2]|0)==-1:0){a[o+(d*24|0)+16>>0]=0;a[o+(d*24|0)+18>>0]=1;n=d+-1|0;f=o+(n*24|0)+8|0;d=f;e=c[d>>2]|0;d=c[d+4>>2]|0;k=p;h=c[t>>2]|0;k=z0(h|0,0,c[k>>2]|0,c[k+4>>2]|0)|0;j=q;i=c[j>>2]|0;j=c[j+4>>2]|0;k=z0(k|0,z|0,i|0,j|0)|0;m=z;if(d>>>0<m>>>0|(d|0)==(m|0)&e>>>0<k>>>0){e=f;c[e>>2]=k;c[e+4>>2]=m;e=k;d=m}v=D_(e|0,d|0,k|0,m|0)|0;w=z;e=r;c[e>>2]=v;c[e+4>>2]=w;e=b+656|0;c[e>>2]=i;c[e+4>>2]=j;e=i+h|0;c[t>>2]=e;d=q;c[d>>2]=0;c[d+4>>2]=0;w=z0(v|0,w|0,e|0,0)|0;v=z;d=c[s>>2]|0;if(v>>>0>0|(v|0)==0&w>>>0>d>>>0){v=d>>>0>e>>>0;w=r;c[w>>2]=v?d-e|0:0;c[w+4>>2]=v?0:0;a[o+(n*24|0)+18>>0]=0}J3(b);d=1;break a}}while(0);a[o+(d*24|0)+16>>0]=1;J3(b);J3(b);d=0}else d=0}else d=0;while(0);l=u;return d|0}function Ke(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=l;l=l+48|0;k=s+36|0;m=s+24|0;n=s+12|0;o=s;c[k>>2]=d;q=b+916|0;e=c[q>>2]|0;r=b+920|0;g=0;j=-1;f=e;a:while(1){if((f|0)==(r|0))break;t=c[f+288>>2]|0;i=(t|0)==-1;h=(j|0)==-1;j=i?j:h?t:j;i=g|(h|i)^1;g=c[f+4>>2]|0;if(!g)while(1){h=c[f+8>>2]|0;if((c[h>>2]|0)==(f|0)){g=i;f=h;continue a}else f=h}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}g=i}b:do if((j|0)!=-1&(g^1)){f=e;c:while(1){if((f|0)==(r|0)){g=1;f=e;break b}c[f+288>>2]=j;g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue c}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}}else{g=1;f=e}while(0);d:while(1){if((f|0)==(r|0))break;i=g&(c[f+288>>2]|0)!=(d|0);g=c[f+4>>2]|0;if(!g)while(1){h=c[f+8>>2]|0;if((c[h>>2]|0)==(f|0)){g=i;f=h;continue d}else f=h}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}g=i}j=g^1;e:while(1){if((e|0)==(r|0))break;t=bF(q,k)|0;i=e+68|0;if(!((c[t+12>>2]|0)==(c[t+16>>2]|0)|j)?(p=c[i>>2]|0,(p|0)!=7):0){f=p;g=25}else g=23;if((g|0)==23?(g=0,(c[e+288>>2]|0)==(c[k>>2]|0)):0){f=c[i>>2]|0;g=25}if((g|0)==25){h=e+72|0;if((f|0)==1){g=c[h>>2]|0;Xy(o,23560);f=(a[(c[(bF(q,k)|0)+40>>2]|0)+9>>0]|0)!=0;HX(o,f?30156:30144)|0;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];f=0;while(1){if((f|0)==3)break;c[o+(f<<2)>>2]=0;f=f+1|0}p2(m,n);zb(b,1,g,224,m,0);z5(m);O0(n);z5(o);g=c[h>>2]|0;Xy(o,23604);f=(a[(c[(bF(q,k)|0)+40>>2]|0)+10>>0]|0)!=0;HX(o,f?30156:30144)|0;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];f=0;while(1){if((f|0)==3)break;c[o+(f<<2)>>2]=0;f=f+1|0}p2(m,n);zb(b,1,g,224,m,0);z5(m);O0(n);z5(o);g=c[h>>2]|0;Xy(o,23648);f=(a[(bF(q,k)|0)+268>>0]|0)!=0;HX(o,f?30156:30144)|0;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];f=0;while(1){if((f|0)==3)break;c[o+(f<<2)>>2]=0;f=f+1|0}p2(m,n);zb(b,1,g,224,m,0);z5(m);O0(n);z5(o);f=c[i>>2]|0}if((f|0)!=4){t=c[h>>2]|0;g=c[c[(bF(q,k)|0)+12>>2]>>2]|0;d=c[(c[g>>2]|0)+8>>2]|0;VU(m,378106);Mc(b,f,t,378106,lb[d&63](g,0,0,m,1,0)|0,0);z5(m);g=c[i>>2]|0;d=c[h>>2]|0;t=(a[(c[(bF(q,k)|0)+40>>2]|0)+9>>0]|0)!=0;tN(b,g,d,374599,t?30156:30144);xM(b,c[i>>2]|0,c[h>>2]|0,374615,380001,0)}}f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue e}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}l=s;return}function Le(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;e=b+840|0;y=kE(b+760|0,e)|0;f=y+72|0;h=c[f>>2]|0;f=c[f+4>>2]|0;x=y+64|0;switch(h|0){case 3:{if(!f)G=5;else G=4;break}case -1:{if(!f)G=5;else G=4;break}default:G=4}if((G|0)==4){a[x>>0]=0;d=0}else if((G|0)==5)d=a[x>>0]|0;A=b+528|0;D=b+536|0;B=b+24|0;H=b+1092|0;E=b+48|0;C=b+772|0;F=b+612|0;j=A;i=c[j>>2]|0;j=c[j+4>>2]|0;if(d<<24>>24){t=e;r=c[t+4>>2]|0;q=b+520|0;c[q>>2]=c[t>>2];c[q+4>>2]=r;q=b+544|0;r=c[q>>2]|0;t=E;s=c[t>>2]|0;t=c[t+4>>2]|0;u=c[F>>2]|0;w=D;v=c[w>>2]|0;w=c[w+4>>2]|0;if((h|0)==3&(f|0)==0){o=y+80|0;l=c[o>>2]|0;m=D_(v|0,w|0,i|0,0)|0;m=z0(l|0,0,m|0,z|0)|0;n=z;p=D;c[p>>2]=m;c[p+4>>2]=n;p=z0(s|0,t|0,i|0,j|0)|0;p=z0(p|0,z|0,u|0,0)|0;l=D_(p|0,z|0,l|0,0)|0;p=E;c[p>>2]=l;c[p+4>>2]=z;c[F>>2]=0;p=A;c[p>>2]=0;c[p+4>>2]=0;p=iaa(m)|0;no(p|0,c[y+84>>2]|0,c[o>>2]|0)|0;o=p+(c[o>>2]|0)|0;j=D_(v|0,w|0,i|0,j|0)|0;no(o|0,r+u+i|0,j|0)|0;c[q>>2]=p;i=0;j=0}else{m=v;n=w}o=(c[H>>2]|0)!=0;h=y+32|0;p=b+136|0;l=c[h>>2]|0;e=o?l+136|0:p;f=c[e+4>>2]|0;d=(o?b:l)+136|0;c[d>>2]=c[e>>2];c[d+4>>2]=f;d=y+44|0;if(o|(c[d>>2]|0)!=1){f=l+360|0;e=c[f>>2]|0;f=c[f+4>>2]|0}else{e=0;f=0}o=b+360|0;I=o;c[I>>2]=e;c[I+4>>2]=f;n=D_(m|0,n|0,i|0,j|0)|0;iA(b,l,n);do if(!(c[(c[h>>2]|0)+728>>2]&8)){d=c[d>>2]|0;if(d>>>0>299){k=+g[(c[B>>2]|0)+136>>2];if(k<1.0){G=17;break}}else{if(d>>>0<=2)break;k=+g[(c[B>>2]|0)+136>>2]}if(k==0.0)G=17}else G=17;while(0);if(((G|0)==17?(a[x>>0]=0,(a[y+65>>0]|0)==0):0)?(a[y+66>>0]|0)==0:0)c[C>>2]=(c[C>>2]|0)+-1;d=p;c[d>>2]=-1;c[d+4>>2]=-1;d=o;c[d>>2]=-1;c[d+4>>2]=-1;d=c[q>>2]|0;if((r|0)!=(d|0)){I=A;c[I>>2]=v;c[I+4>>2]=w;I=D;c[I>>2]=v;c[I+4>>2]=w;I=E;c[I>>2]=s;c[I+4>>2]=t;c[F>>2]=u;jaa(d);c[q>>2]=r}}else{I=D;I=D_(c[I>>2]|0,c[I+4>>2]|0,i|0,j|0)|0;e1(b,I,z)}j=b+312|0;d=j;d=z0(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;e=z;c[j>>2]=d;c[j+4>>2]=e;j=b+1080|0;l=b+1084|0;a:do if(!(c[b+728>>2]&2)){if(c[C>>2]|0?!(e>>>0>0|((e|0)==0?d>>>0>(O(+g[(c[B>>2]|0)+136>>2]!=0.0?512:3,c[b+768>>2]|0)|0)>>>0:0)):0)break;jt(b);if(+g[(c[B>>2]|0)+136>>2]<1.0){f=b+1032|0;e=b+1036|0;Ld(c[f>>2]|0,c[e>>2]|0);f=c[f>>2]|0;e=(c[e>>2]|0)-f>>4;d=0;while(1){if(d>>>0>=e>>>0)break;i=f+(d<<4)+8|0;h=c[i>>2]|0;i=c[i+4>>2]|0;C=E;C=z0(c[F>>2]|0,0,c[C>>2]|0,c[C+4>>2]|0)|0;I=D;I=z0(C|0,z|0,c[I>>2]|0,c[I+4>>2]|0)|0;C=z;if(i>>>0>C>>>0|(i|0)==(C|0)&h>>>0>I>>>0){G=30;break}else d=d+1|0}if((G|0)==30){XC(b,h,i);Kl(b)}I=b+64|0;if((c[I>>2]|0)==-1?(c[I+4>>2]|0)==-1:0){I=b+1008|0;XC(b,c[I>>2]|0,c[I+4>>2]|0);Kl(b)}}d=c[j>>2]|0;e=c[l>>2]|0;while(1){if((e|0)==(d|0))break a;I=e+-8|0;c[l>>2]=I;e=I}}while(0);G=(c[H>>2]|0)+1|0;c[H>>2]=G;d=c[l>>2]|0;I=c[j>>2]|0;e=I;if(G>>>0>=d-I>>3>>>0){while(1){if((d|0)==(e|0))break;I=d+-8|0;c[l>>2]=I;d=I}c[H>>2]=0}return}function Me(e){e=e|0;var f=0,g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=l;l=l+32|0;r=u+12|0;p=u+16|0;q=u;b[e+980>>1]=0;b[e+982>>1]=0;Bx(e);sR(e,12,e+968|0);sR(e,12,e+970|0);xR(e,4,e+992|0);s=e+993|0;xR(e,4,s);rR(e,18,r);KS(e);sR(e,10,e+986|0);n=e+648|0;A6(c[n>>2]|0);o=e+1009|0;yT(e,o);if(!(a[o>>0]|0))A6(c[n>>2]|0);else{GC(e);A6(c[n>>2]|0);o=e+856|0;f=a[e+864+3>>0]|0;if(f<<24>>24<0)f=c[e+860>>2]|0;else f=f&255;j=(f|0)==0;k=q+8+3|0;m=q+4|0;i=0;while(1){if((i|0)==64)break;xR(e,8,p);if(j){uU(q,a[p>>0]|0,16);f=a[k>>0]|0;g=c[m>>2]|0;if(((f<<24>>24<0?g:f&255)|0)==1){DW(q,0,42196)|0;f=a[k>>0]|0;g=c[m>>2]|0}v=f<<24>>24<0;Ex(o,v?c[q>>2]|0:q,v?g:f&255)|0;z5(q)}i=i+1|0}J3(e)}v=e+1010|0;yT(e,v);if(!(a[v>>0]|0))A6(c[n>>2]|0);else{GC(e);A6(c[n>>2]|0);n=e+868|0;f=a[e+876+3>>0]|0;if(f<<24>>24<0)f=c[e+872>>2]|0;else f=f&255;j=(f|0)==0;k=q+8+3|0;m=q+4|0;i=0;while(1){if((i|0)==64)break;xR(e,8,p);if(j){uU(q,a[p>>0]|0,16);f=a[k>>0]|0;g=c[m>>2]|0;if(((f<<24>>24<0?g:f&255)|0)==1){DW(q,0,42196)|0;f=a[k>>0]|0;g=c[m>>2]|0}v=f<<24>>24<0;Ex(n,v?c[q>>2]|0:q,v?g:f&255)|0;z5(q)}i=i+1|0}J3(e)}wK(e);k=e+528|0;g=k;j=c[g>>2]|0;g=c[g+4>>2]|0;m=e+536|0;f=m;i=c[f>>2]|0;f=c[f+4>>2]|0;if(f>>>0>g>>>0|(f|0)==(g|0)&i>>>0>j>>>0){n=e+544|0;o=e+612|0;p=i;q=f;do{p=z0(p|0,q|0,-1,-1)|0;q=z;if(!(q>>>0>g>>>0|(q|0)==(g|0)&p>>>0>j>>>0))break}while(!(a[(c[n>>2]|0)+((c[o>>2]|0)+p)>>0]|0));if((p|0)==(j|0)&(q|0)==(g|0)){g=D_(i|0,f|0,j|0,g|0)|0;e1(e,g,z);g=k;f=m;j=c[g>>2]|0;i=c[f>>2]|0;g=c[g+4>>2]|0;f=c[f+4>>2]|0}}if(!((j|0)==(i|0)&(g|0)==(f|0)))t4(e);if(qO(e)|0){ZB(e);i=e+1035|0;k=e+952|0;if(a[i>>0]|0){f=c[r>>2]|0;if((f|0)==(c[k>>2]|0))g=39;else{f=0;g=41}}else{f=c[k>>2]|0;g=39}if((g|0)==39?(f|0)==0:0){c[k>>2]=c[r>>2];f=1;g=41}if((g|0)==41)a[i>>0]=f;if(!(c[e+728>>2]&1)){s_(e);AR(e,0,0);AR(e,178,0);AR(e,181,0);AR(e,184,0)}f=c[e+780>>2]|0;a[f>>0]=1;a[f+534>>0]=1;a[f+543>>0]=1;i=e+312|0;g=c[i>>2]|0;i=c[i+4>>2]|0;j=(g|0)==0&(i|0)==0;if(j)a[f+553>>0]=1;a[f+554>>0]=1;v=d[s>>0]|0;f=736+(v<<3)|0;if((v+-1|0)>>>0<8){s=cT(1.0e9/+h[f>>3])|0;v=e+1064|0;c[v>>2]=s;c[v+4>>2]=z}v=e+768|0;s=c[v+4>>2]|0;if(i>>>0<s>>>0|((i|0)==(s|0)?g>>>0<(c[v>>2]|0)>>>0:0)){h[e+960>>3]=+h[f>>3];r=UW(c[k>>2]|0,0,100,0)|0;s=z;v=e+928|0;c[v>>2]=r;c[v+4>>2]=s;v=e+936|0;c[v>>2]=r;c[v+4>>2]=s}a[e+1016>>0]=1;a[e+1015>>0]=0;if(j?(t=e+144|0,v=t,(c[v>>2]|0)==-1?(c[v+4>>2]|0)==-1:0):0){v=t;c[v>>2]=0;c[v+4>>2]=0}}l=u;return}function Ne(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+80|0;s=u+60|0;t=u+48|0;q=u+36|0;m=u+24|0;n=u+12|0;o=u;TX(s);Xy(t,42232);Ck(s,d,10)|0;p=s+8+3|0;k=a[p>>0]|0;r=s+4|0;j=c[r>>2]|0;if((k<<24>>24<0?j:k&255)>>>0<2){Xy(n,42260);uU(o,d,10);Mq(m,n,o);p2(q,m);k1(s,q)|0;z5(q);O0(m);z5(o);z5(n);k=a[p>>0]|0;j=c[r>>2]|0}if((k<<24>>24<0?j:k&255)>>>0<3){Xy(n,42276);uU(o,d,10);Mq(m,n,o);p2(q,m);k1(s,q)|0;z5(q);O0(m);z5(o);z5(n);k=a[p>>0]|0;j=c[r>>2]|0}d=k<<24>>24<0;Ex(t,d?c[s>>2]|0:s,d?j:k&255)|0;HX(t,42040)|0;Ck(s,e,10)|0;k=a[p>>0]|0;j=c[r>>2]|0;if((k<<24>>24<0?j:k&255)>>>0<2){Xy(n,42196);uU(o,e,10);Mq(m,n,o);p2(q,m);k1(s,q)|0;z5(q);O0(m);z5(o);z5(n);k=a[p>>0]|0;j=c[r>>2]|0}e=k<<24>>24<0;Ex(t,e?c[s>>2]|0:s,e?j:k&255)|0;HX(t,42040)|0;Ck(s,f,10)|0;k=a[p>>0]|0;j=c[r>>2]|0;if((k<<24>>24<0?j:k&255)>>>0<2){Xy(n,42196);uU(o,f,10);Mq(m,n,o);p2(q,m);k1(s,q)|0;z5(q);O0(m);z5(o);z5(n);k=a[p>>0]|0;j=c[r>>2]|0}f=k<<24>>24<0;Ex(t,f?c[s>>2]|0:s,f?j:k&255)|0;HX(t,42252)|0;Ck(s,g,10)|0;k=a[p>>0]|0;j=c[r>>2]|0;if((k<<24>>24<0?j:k&255)>>>0<2){Xy(n,42196);uU(o,g,10);Mq(m,n,o);p2(q,m);k1(s,q)|0;z5(q);O0(m);z5(o);z5(n);k=a[p>>0]|0;j=c[r>>2]|0}g=k<<24>>24<0;Ex(t,g?c[s>>2]|0:s,g?j:k&255)|0;HX(t,42204)|0;uU(q,h,10);k1(s,q)|0;z5(q);k=a[p>>0]|0;j=c[r>>2]|0;if((k<<24>>24<0?j:k&255)>>>0<2){Xy(n,42196);uU(o,h,10);Mq(m,n,o);p2(q,m);k1(s,q)|0;z5(q);O0(m);z5(o);z5(n);k=a[p>>0]|0;j=c[r>>2]|0}h=k<<24>>24<0;Ex(t,h?c[s>>2]|0:s,h?j:k&255)|0;HX(t,42204)|0;Ck(s,i,10)|0;k=a[p>>0]|0;j=c[r>>2]|0;if((k<<24>>24<0?j:k&255)>>>0<2){Xy(n,42196);uU(o,i,10);Mq(m,n,o);p2(q,m);k1(s,q)|0;z5(q);O0(m);z5(o);z5(n);k=a[p>>0]|0;j=c[r>>2]|0}r=k<<24>>24<0;Ex(t,r?c[s>>2]|0:s,r?j:k&255)|0;GX(b,(a[t+8+3>>0]|0)<0?c[t>>2]|0:t)|0;z5(t);z5(s);l=u;return b|0}function Oe(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;r=l;l=l+64|0;h=r+62|0;i=r+61|0;f=r+60|0;p=r+48|0;q=r+36|0;j=r+24|0;k=r+12|0;m=r;Bx(b);o=b+648|0;A6(c[o>>2]|0);xR(b,1,h);xR(b,2,i);AT(b,f);d4(c[o>>2]|0,3);wK(b);if(qO(b)|0?a[b+784>>0]|0:0){Xy(p,a[f>>0]|0?40136:40152);o=b+760|0;n=b+772|0;b=c[(c[(c[o>>2]|0)+80>>2]|0)+(e[n>>1]<<2)>>2]|0;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;g=j9(387802)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[q+11>>0]=g;f=q}else{s=g+16&-16;f=ZW(s)|0;c[q>>2]=f;c[q+8>>2]=s|-2147483648;c[q+4>>2]=g}i1(f,387802,g)|0;J7(f+g|0,0);vF(VC(b+28|0,q)|0,p)|0;a1(q);z5(p);h=d[h>>0]|0;VU(j,c[15360+(h<<2)>>2]|0);i=d[i>>0]|0;VU(k,c[15376+(i<<2)>>2]|0);f=a[k+8+3>>0]|0;s=f<<24>>24<0;Ex(j,s?c[k>>2]|0:k,s?c[k+4>>2]|0:f&255)|0;c[q>>2]=c[j>>2];c[q+4>>2]=c[j+4>>2];c[q+8>>2]=c[j+8>>2];f=0;while(1){if((f|0)==3)break;c[j+(f<<2)>>2]=0;f=f+1|0}p2(p,q);b=c[(c[(c[o>>2]|0)+80>>2]|0)+(e[n>>1]<<2)>>2]|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;g=j9(385582)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[m+11>>0]=g;f=m}else{s=g+16&-16;f=ZW(s)|0;c[m>>2]=f;c[m+8>>2]=s|-2147483648;c[m+4>>2]=g}i1(f,385582,g)|0;J7(f+g|0,0);vF(VC(b+28|0,m)|0,p)|0;a1(m);z5(p);O0(q);z5(k);z5(j);Xy(p,40168);b=c[(c[(c[o>>2]|0)+80>>2]|0)+(e[n>>1]<<2)>>2]|0;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;g=j9(384476)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[q+11>>0]=g;f=q}else{s=g+16&-16;f=ZW(s)|0;c[q>>2]=f;c[q+8>>2]=s|-2147483648;c[q+4>>2]=g}i1(f,384476,g)|0;J7(f+g|0,0);vF(VC(b+28|0,q)|0,p)|0;a1(q);z5(p);VU(p,c[15392+(h<<2)>>2]|0);b=c[(c[(c[o>>2]|0)+80>>2]|0)+(e[n>>1]<<2)>>2]|0;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;g=j9(387815)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[q+11>>0]=g;f=q}else{s=g+16&-16;f=ZW(s)|0;c[q>>2]=f;c[q+8>>2]=s|-2147483648;c[q+4>>2]=g}i1(f,387815,g)|0;J7(f+g|0,0);vF(VC(b+28|0,q)|0,p)|0;a1(q);z5(p);VU(p,c[15408+(i<<2)>>2]|0);b=c[(c[(c[o>>2]|0)+80>>2]|0)+(e[n>>1]<<2)>>2]|0;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;g=j9(384616)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[q+11>>0]=g;f=q}else{s=g+16&-16;f=ZW(s)|0;c[q>>2]=f;c[q+8>>2]=s|-2147483648;c[q+4>>2]=g}i1(f,384616,g)|0;J7(f+g|0,0);vF(VC(b+28|0,q)|0,p)|0;a1(q);z5(p)}l=r;return}function Pe(d,f){d=d|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;p=l;l=l+16|0;n=p;m=d+764|0;h=c[m>>2]|0;o=d+780|0;g=c[(c[h+80>>2]|0)+(e[o>>1]<<2)>>2]|0;i=c[g+64>>2]|0;do if((i|0)!=2){k=d+784|0;q=a[g+168>>0]|0;if(q<<24>>24==-1?1:(a[k>>0]|0)==q<<24>>24){if((i|0)!=1)j=8}else{h=h+92|0;i=c[h>>2]|0;switch(i|0){case 0:case -1:break;default:if(!(a[g+68>>0]|0))c[h>>2]=i+-1}Rx(g);laa(g);q=ZW(200)|0;Ss(q);g=e[o>>1]|0;c[(c[(c[m>>2]|0)+80>>2]|0)+(g<<2)>>2]=q;g=c[(c[(c[m>>2]|0)+80>>2]|0)+(g<<2)>>2]|0;c[g+64>>2]=0;if(!g)j=9;else j=8}if((j|0)==8){Rx(g);laa(g);j=9}if((j|0)==9){h=ZW(200)|0;Ss(h);c[(c[(c[m>>2]|0)+80>>2]|0)+(e[o>>1]<<2)>>2]=h;h=c[m>>2]|0;i=h+92|0;g=c[i>>2]|0;if((g|0)==-1){c[i>>2]=0;g=0}c[i>>2]=g+1;h=$C((HD(h+68|0,h)|0)+16|0,d+778|0)|0;if((a[k>>0]|0)==-122?(c[h+68>>2]|0)==1129661769:0){a[h+81>>0]=1;q=c[(c[(c[m>>2]|0)+80>>2]|0)+(e[o>>1]<<2)>>2]|0;c[q+64>>2]=2;nG(q+16|0);q=ZW(16)|0;M0(q);g=b[o>>1]|0;c[(c[(c[(c[(c[m>>2]|0)+80>>2]|0)+((g&65535)<<2)>>2]|0)+16>>2]|0)+1008>>2]=q;h=h+104|0;if(!(c[h>>2]|0)){q=ZW(16)|0;I$(q);c[h>>2]=q;g=b[o>>1]|0;b[q+12>>1]=g}}else{i=c[(c[(c[m>>2]|0)+80>>2]|0)+(e[o>>1]<<2)>>2]|0;c[i+64>>2]=1;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;h=j9(390999)|0;if(h>>>0>4294967279)uaa();if(h>>>0<11){a[n+11>>0]=h;g=n}else{q=h+16&-16;g=ZW(q)|0;c[n>>2]=g;c[n+8>>2]=q|-2147483648;c[n+4>>2]=h}i1(g,390999,h)|0;J7(g+h|0,0);g=VC(i+28|0,n)|0;Ck(g,a[k>>0]|0,10)|0;a1(n);g=b[o>>1]|0}h=c[(c[(c[m>>2]|0)+80>>2]|0)+((g&65535)<<2)>>2]|0;a[h+168>>0]=a[k>>0]|0;UZ(h,1);RZ(c[(c[(c[m>>2]|0)+80>>2]|0)+(e[o>>1]<<2)>>2]|0,1);h=c[m>>2]|0;q=b[o>>1]|0;g=c[(c[h+80>>2]|0)+((q&65535)<<2)>>2]|0;b[g+112>>1]=f;if(WV(c[h+140>>2]|0,c[h+144>>2]|0,q)|0)a[g+180>>0]=1}k=c[g+4>>2]|0;j=(c[g+8>>2]|0)-k>>1;f=d+782|0;g=0;i=0;while(1){if((i|0)==(j|0))break;g=g|(b[k+(i<<1)>>1]|0)==(b[f>>1]|0);i=i+1|0}if(!g){j=$C((HD(h+68|0,h)|0)+16|0,f)|0;g=j+56|0;h=c[g>>2]|0;if((h|0)==(c[j+60>>2]|0))bz(j+52|0,o);else{b[h>>1]=b[o>>1]|0;c[g>>2]=h+2}g=c[(c[(c[m>>2]|0)+80>>2]|0)+(e[o>>1]<<2)>>2]|0;h=g+8|0;i=c[h>>2]|0;if((i|0)==(c[g+12>>2]|0))bz(g+4|0,f);else{b[i>>1]=b[f>>1]|0;c[h>>2]=i+2}if(!(a[d+798>>0]|0)){if((c[j+68>>2]|0)!=1212435798)break;h=c[m>>2]|0;g=b[o>>1]|0;if((a[(c[(c[h+80>>2]|0)+((g&65535)<<2)>>2]|0)+168>>0]|0)!=-112)break}else{g=b[o>>1]|0;h=c[m>>2]|0}Pw(n,h+188|0,g,o)}}while(0);l=p;return}function Qe(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;A=l;l=l+160|0;x=A+136|0;f=A+157|0;v=A+156|0;q=A+155|0;p=A+154|0;n=A+153|0;j=A+152|0;i=A+151|0;w=A+150|0;h=A+149|0;u=A+148|0;y=A;GC(b);Bx(b);AT(b,f);RS(b);RS(b);RS(b);RS(b);RS(b);RS(b);do if(!(a[f>>0]|0)){e=b+648|0;t=K6(c[e>>2]|0)|0;a[f>>0]=t&1;if(t){A6(c[e>>2]|0);g=5;break}else{RS(b);wK(b);y=b+528|0;x=y;x=z0(c[x>>2]|0,c[x+4>>2]|0,8,0)|0;c[y>>2]=x;c[y+4>>2]=z;break}}else{RS(b);e=b+648|0;g=5}while(0);if((g|0)==5){GC(b);d4(c[e>>2]|0,4);xR(b,4,h);d4(c[e>>2]|0,4);A6(c[e>>2]|0);AT(b,u);xR(b,2,w);d4(c[e>>2]|0,4);xR(b,4,i);d4(c[e>>2]|0,4);A6(c[e>>2]|0);xR(b,3,j);d4(c[e>>2]|0,4);xR(b,4,n);d4(c[e>>2]|0,4);A6(c[e>>2]|0);xR(b,3,p);d4(c[e>>2]|0,4);xR(b,4,q);d4(c[e>>2]|0,4);A6(c[e>>2]|0);A6(c[e>>2]|0);xR(b,2,v);if(qO(b)|0){r=b+776|0;s=r+11|0;e=a[s>>0]|0;t=b+780|0;if(e<<24>>24<0)e=c[t>>2]|0;else e=e&255;o=a[h>>0]|0;m=a[i>>0]|0;k=a[j>>0]|0;j=a[n>>0]|0;i=a[p>>0]|0;h=a[q>>0]|0;if((e|0)==0&(o&255)<10&(m&255)<10&(k&255)<6&(j&255)<10&(i&255)<6&(h&255)<10){f=y+56|0;g=y+4|0;c[y>>2]=940;c[f>>2]=960;DO(y+56|0,g);c[y+128>>2]=0;c[y+132>>2]=-1;c[y>>2]=38756;c[f>>2]=38776;bV(g);c[g>>2]=38792;f=y+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[f+(e<<2)>>2]=0;e=e+1|0}c[y+48>>2]=0;c[y+52>>2]=16;c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[x+(e<<2)>>2]=0;e=e+1|0}vr(g,x);a1(x);v=Jq(Jq(zT(Jq(Jq(zT(Jq(Jq(y,d[v>>0]|0)|0,h&255)|0,58)|0,i&255)|0,j&255)|0,58)|0,k&255)|0,m&255)|0;v=zT(v,a[u>>0]|0?59:58)|0;Jq(Jq(v,d[w>>0]|0)|0,o&255)|0;ym(x,g);if((a[s>>0]|0)<0){J7(c[r>>2]|0,0);c[t>>2]=0}else{J7(r,0);a[s>>0]=0}Fp(r,0);c[r>>2]=c[x>>2];c[r+4>>2]=c[x+4>>2];c[r+8>>2]=c[x+8>>2];e=0;while(1){if((e|0)==3)break;c[x+(e<<2)>>2]=0;e=e+1|0}a1(x);ZX(y)}}J3(b);wK(b)}J3(b);l=A;return}function Re(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;g=l;l=l+32|0;f=g;e=b;i=c[e>>2]|0;e=c[e+4>>2]|0;h=a;h=M$(i,e,c[h>>2]|0,c[h+4>>2]|0)|0;j=d;e=M$(c[j>>2]|0,c[j+4>>2]|0,i,e)|0;do if(h){if(e){c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];c[a+28>>2]=c[d+28>>2];c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];c[d+28>>2]=c[f+28>>2];a=1;break}c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];c[b>>2]=c[f>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];c[b+16>>2]=c[f+16>>2];c[b+20>>2]=c[f+20>>2];c[b+24>>2]=c[f+24>>2];c[b+28>>2]=c[f+28>>2];i=d;j=b;if(M$(c[i>>2]|0,c[i+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0){c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];c[d+28>>2]=c[f+28>>2];a=2}else a=1}else if(e){c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];c[d+28>>2]=c[f+28>>2];i=b;j=a;if(M$(c[i>>2]|0,c[i+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0){c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];c[b>>2]=c[f>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];c[b+16>>2]=c[f+16>>2];c[b+20>>2]=c[f+20>>2];c[b+24>>2]=c[f+24>>2];c[b+28>>2]=c[f+28>>2];a=2}else a=1}else a=0;while(0);l=g;return a|0}function Se(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=l;l=l+16|0;k=u+12|0;j=u+8|0;s=u+4|0;t=u;c[g>>2]=0;O4(k,f);m=u$(c[k>>2]|0,409148)|0;c6(k);n=h+8|0;o=h+20|0;p=h+16|0;q=h+24|0;r=b+8|0;do switch(i<<24>>24|0){case 65:case 97:{CG(b,q,d,c[e>>2]|0,g,m);v=26;break}case 104:case 66:case 98:{fG(b,p,d,c[e>>2]|0,g,m);v=26;break}case 99:{i=nb[c[(c[r>>2]|0)+12>>2]&255](r)|0;v=a[i+8+3>>0]|0;t=v<<24>>24<0;s=t?c[i>>2]|0:i;c[d>>2]=Ae(b,c[d>>2]|0,c[e>>2]|0,f,g,h,s,s+((t?c[i+4>>2]|0:v&255)<<2)|0)|0;v=26;break}case 101:case 100:{GL(h+12|0,d,c[e>>2]|0,g,m);v=26;break}case 68:{c[d>>2]=Ae(b,c[d>>2]|0,c[e>>2]|0,f,g,h,56472,56504)|0;v=26;break}case 70:{c[d>>2]=Ae(b,c[d>>2]|0,c[e>>2]|0,f,g,h,56504,56536)|0;v=26;break}case 72:{iM(n,d,c[e>>2]|0,g,m);v=26;break}case 73:{rL(n,d,c[e>>2]|0,g,m);v=26;break}case 106:{HL(h+28|0,d,c[e>>2]|0,g,m);v=26;break}case 109:{TL(p,d,c[e>>2]|0,g,m);v=26;break}case 77:{bM(h+4|0,d,c[e>>2]|0,g,m);v=26;break}case 116:case 110:{Rj(d,c[e>>2]|0,g,m);v=26;break}case 112:{Lv(b,n,d,c[e>>2]|0,g,m);v=26;break}case 114:{c[d>>2]=Ae(b,c[d>>2]|0,c[e>>2]|0,f,g,h,56536,56580)|0;v=26;break}case 82:{c[d>>2]=Ae(b,c[d>>2]|0,c[e>>2]|0,f,g,h,56580,56600)|0;v=26;break}case 83:{aM(h,d,c[e>>2]|0,g,m);v=26;break}case 84:{c[d>>2]=Ae(b,c[d>>2]|0,c[e>>2]|0,f,g,h,56600,56632)|0;v=26;break}case 119:{$L(q,d,c[e>>2]|0,g,m);v=26;break}case 120:{i=c[(c[b>>2]|0)+20>>2]|0;c[s>>2]=c[d>>2];c[t>>2]=c[e>>2];c[j>>2]=c[s>>2];c[k>>2]=c[t>>2];j=lb[i&63](b,j,k,f,g,h)|0;break}case 88:{i=nb[c[(c[r>>2]|0)+24>>2]&255](r)|0;v=a[i+8+3>>0]|0;t=v<<24>>24<0;s=t?c[i>>2]|0:i;c[d>>2]=Ae(b,c[d>>2]|0,c[e>>2]|0,f,g,h,s,s+((t?c[i+4>>2]|0:v&255)<<2)|0)|0;v=26;break}case 121:{gK(o,d,c[e>>2]|0,g,m);v=26;break}case 89:{NO(o,d,c[e>>2]|0,g,m);v=26;break}case 37:{qj(d,c[e>>2]|0,g,m);v=26;break}default:{c[g>>2]=c[g>>2]|4;v=26}}while(0);if((v|0)==26)j=c[d>>2]|0;l=u;return j|0}function Te(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=l;l=l+16|0;k=u+12|0;j=u+8|0;s=u+4|0;t=u;c[g>>2]=0;O4(k,f);m=u$(c[k>>2]|0,409116)|0;c6(k);n=h+8|0;o=h+20|0;p=h+16|0;q=h+24|0;r=b+8|0;do switch(i<<24>>24|0){case 65:case 97:{DG(b,q,d,c[e>>2]|0,g,m);v=26;break}case 104:case 66:case 98:{gG(b,p,d,c[e>>2]|0,g,m);v=26;break}case 99:{i=nb[c[(c[r>>2]|0)+12>>2]&255](r)|0;v=a[i+11>>0]|0;t=v<<24>>24<0;s=t?c[i>>2]|0:i;c[d>>2]=te(b,c[d>>2]|0,c[e>>2]|0,f,g,h,s,s+(t?c[i+4>>2]|0:v&255)|0)|0;v=26;break}case 101:case 100:{IL(h+12|0,d,c[e>>2]|0,g,m);v=26;break}case 68:{c[d>>2]=te(b,c[d>>2]|0,c[e>>2]|0,f,g,h,402704,402712)|0;v=26;break}case 70:{c[d>>2]=te(b,c[d>>2]|0,c[e>>2]|0,f,g,h,402712,402720)|0;v=26;break}case 72:{jM(n,d,c[e>>2]|0,g,m);v=26;break}case 73:{sL(n,d,c[e>>2]|0,g,m);v=26;break}case 106:{JL(h+28|0,d,c[e>>2]|0,g,m);v=26;break}case 109:{UL(p,d,c[e>>2]|0,g,m);v=26;break}case 77:{eM(h+4|0,d,c[e>>2]|0,g,m);v=26;break}case 116:case 110:{vj(d,c[e>>2]|0,g,m);v=26;break}case 112:{Ov(b,n,d,c[e>>2]|0,g,m);v=26;break}case 114:{c[d>>2]=te(b,c[d>>2]|0,c[e>>2]|0,f,g,h,402720,402731)|0;v=26;break}case 82:{c[d>>2]=te(b,c[d>>2]|0,c[e>>2]|0,f,g,h,402731,402736)|0;v=26;break}case 83:{dM(h,d,c[e>>2]|0,g,m);v=26;break}case 84:{c[d>>2]=te(b,c[d>>2]|0,c[e>>2]|0,f,g,h,402736,402744)|0;v=26;break}case 119:{cM(q,d,c[e>>2]|0,g,m);v=26;break}case 120:{i=c[(c[b>>2]|0)+20>>2]|0;c[s>>2]=c[d>>2];c[t>>2]=c[e>>2];c[j>>2]=c[s>>2];c[k>>2]=c[t>>2];j=lb[i&63](b,j,k,f,g,h)|0;break}case 88:{i=nb[c[(c[r>>2]|0)+24>>2]&255](r)|0;v=a[i+11>>0]|0;t=v<<24>>24<0;s=t?c[i>>2]|0:i;c[d>>2]=te(b,c[d>>2]|0,c[e>>2]|0,f,g,h,s,s+(t?c[i+4>>2]|0:v&255)|0)|0;v=26;break}case 121:{hK(o,d,c[e>>2]|0,g,m);v=26;break}case 89:{OO(o,d,c[e>>2]|0,g,m);v=26;break}case 37:{_i(d,c[e>>2]|0,g,m);v=26;break}default:{c[g>>2]=c[g>>2]|4;v=26}}while(0);if((v|0)==26)j=c[d>>2]|0;l=u;return j|0}function Ue(f,h){f=f|0;h=h|0;var i=0,j=0.0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=l;l=l+48|0;s=u+24|0;k=u+12|0;m=u;i=c[h>>2]|0;q=c[i+20>>2]|0;v=c[i+24>>2]|0;r=f$(i)|0;r=(r&255)>3?0:r&255;q=q-(O((c[i+32>>2]|0)+(c[i+28>>2]|0)|0,d[381120+r>>0]|0)|0)|0;r=v-(O((c[i+40>>2]|0)+(c[i+36>>2]|0)|0,d[381124+r>>0]|0)|0)|0;TX(s);i=c[h>>2]|0;if(!(c[i+4>>2]|0)){if(c[i+12>>2]|0){TX(k);k1(s,cC(k,OV(c[(c[h>>2]|0)+12>>2]|0)|0)|0)|0;z5(k);i=c[h>>2]|0}if(c[i+16>>2]|0){if(c[i+12>>2]|0)Gx(s,64);TX(m);v=c[(c[h>>2]|0)+16>>2]|0;io(m,+(v>>>0)/30.0,((v>>>0)%10|0|0)!=0&1)|0;Zr(k,m);v=a[k+8+3>>0]|0;i=v<<24>>24<0;Ex(s,i?c[k>>2]|0:k,i?c[k+4>>2]|0:v&255)|0;O0(k);z5(m);Gx(s,64);TX(k);cC(k,Q8((a[(c[h>>2]|0)+8>>0]|0)!=0)|0)|0;v=a[k+8+3>>0]|0;m=v<<24>>24<0;Ex(s,m?c[k>>2]|0:k,m?c[k+4>>2]|0:v&255)|0;z5(k)}}zb(f,1,0,24,s,0);zb(f,1,0,64,s,0);k=f+20|0;lL(f,1,c[k>>2]|0,130,q,10,0);lL(f,1,c[k>>2]|0,138,r,10,0);i=c[h>>2]|0;if(!((c[i+28>>2]|0)==0?(c[i+32>>2]|0)==0:0)){lL(f,1,c[k>>2]|0,146,c[i+20>>2]|0,10,0);i=c[h>>2]|0}if(!((c[i+36>>2]|0)==0?(c[i+40>>2]|0)==0:0)){lL(f,1,c[k>>2]|0,147,c[i+24>>2]|0,10,0);i=c[h>>2]|0}RB(f,1,0,191,yW(a[i+45>>0]|0)|0,-1,1,0);RB(f,1,0,190,RW(a[(c[h>>2]|0)+45>>0]|0)|0,-1,1,0);v=c[h>>2]|0;i=a[v+48>>0]|0;if(i<<24>>24==(a[v+49>>0]|0))sM(f,1,0,195,(i&255)+8|0,0);i=a[f+952>>0]|0;if(i<<24>>24!=2)RB(f,1,0,332,Zx(i)|0,-1,1,0);i=c[c[h>>2]>>2]|0;if(i|0){if(((a[i+34>>0]|0)!=0?(n=c[i+16>>2]|0,(n|0)!=0):0)?(o=c[i+12>>2]|0,(o|0)!=0):0){KW(f,1,c[k>>2]|0,171,+(n>>>0)/+(o>>>0),3,0);i=c[c[h>>2]>>2]|0}if(a[i+30>>0]|0){k=a[i+24>>0]|0;if((k&255)>=17)if(k<<24>>24==-1?(p=b[i+22>>1]|0,p<<16>>16!=0):0)j=+(e[i+20>>1]|0)/+(p&65535);else j=1.0;else j=+g[33524+((k&255)<<2)>>2];KW(f,1,0,150,j,3,1);KW(f,1,0,156,+(q>>>0)*j/+(r>>>0),3,1);i=c[c[h>>2]>>2]|0}if((a[i+31>>0]|0?(RB(f,1,0,187,c[33592+(d[i+25>>0]<<2)>>2]|0,-1,1,0),RB(f,1,0,329,c[33624+(d[(c[c[h>>2]>>2]|0)+26>>0]<<2)>>2]|0,-1,1,0),a[(c[c[h>>2]>>2]|0)+33>>0]|0):0)?(RB(f,1,0,330,382808,-1,1,0),RB(f,1,0,331,mD(a[(c[c[h>>2]>>2]|0)+27>>0]|0)|0,-1,1,0),RB(f,1,0,332,Zx(a[(c[c[h>>2]>>2]|0)+28>>0]|0)|0,-1,1,0),RB(f,1,0,333,SA(a[(c[c[h>>2]>>2]|0)+29>>0]|0)|0,-1,1,0),t=a[(c[c[h>>2]>>2]|0)+29>>0]|0,t<<24>>24!=2):0)RB(f,1,0,191,ZT(t)|0,-1,1,1)}z5(s);l=u;return}function Ve(a){a=a|0;var b=0,d=0,e=0;e=a+728|0;c[e>>2]=c[e>>2]|1;e=a+520|0;b=c[e+4>>2]|0;do switch(c[e>>2]|0){case 0:{if(!b)G$(a);else d=90;break}case 1:{if(!b)Us(a);else d=90;break}case 2:{if(!b)E2(a);else d=90;break}case 3:{if(!b)Gs(a);else d=90;break}case 4:{if(!b)hc(a);else d=90;break}case 5:{if(!b)qo(a);else d=90;break}case 6:{if(!b)yh(a);else d=90;break}case 7:{if(!b)G$(a);else d=90;break}case 8:{if(!b)G$(a);else d=90;break}case 9:{if(!b)MX(a);else d=90;break}case 10:{if(!b)G$(a);else d=90;break}case 11:{if(!b)G$(a);else d=90;break}case 12:{if(!b)G$(a);else d=90;break}case 13:{if(!b)G$(a);else d=90;break}case 14:{if(!b)BY(a);else d=90;break}case 15:{if(!b)MX(a);else d=90;break}case 16:{if(!b)F2(a);else d=90;break}case 17:{if(!b)E2(a);else d=90;break}case 18:{if(!b)G$(a);else d=90;break}case 19:{if(!b)G$(a);else d=90;break}case 20:{if(!b)G$(a);else d=90;break}case 64:{if(!b)G$(a);else d=90;break}case 65:{if(!b)G$(a);else d=90;break}case 66:{if(!b)G$(a);else d=90;break}case 67:{if(!b)G$(a);else d=90;break}case 68:{if(!b)G$(a);else d=90;break}case 69:{if(!b)G$(a);else d=90;break}case 70:{if(!b)G$(a);else d=90;break}case 71:{if(!b)G$(a);else d=90;break}case 72:{if(!b)G$(a);else d=90;break}case 73:{if(!b)G$(a);else d=90;break}case 74:{if(!b)G$(a);else d=90;break}case 75:{if(!b)G$(a);else d=90;break}case 76:{if(!b)G$(a);else d=90;break}case 96:{if(!b)G$(a);else d=90;break}case 97:{if(!b)G$(a);else d=90;break}case 98:{if(!b)G$(a);else d=90;break}case 99:{if(!b)G$(a);else d=90;break}case 100:{if(!b)G$(a);else d=90;break}case 101:{if(!b)G$(a);else d=90;break}case 102:{if(!b)G$(a);else d=90;break}case 103:{if(!b)G$(a);else d=90;break}case 104:{if(!b)G$(a);else d=90;break}case 105:{if(!b)G$(a);else d=90;break}default:d=90}while(0);if((d|0)==90){e=a+536|0;e1(a,c[e>>2]|0,c[e+4>>2]|0)}return}function We(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+80|0;g=q+72|0;o=q+60|0;p=q+48|0;j=q+36|0;k=q+24|0;m=q+12|0;n=q;c[g>>2]=d;g=Ma(g|0)|0;do if(!g){e=b+8+3|0;if((a[e>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0;break}else{y7(b,0);a[e>>0]=0;break}}else{TX(o);Xy(p,42232);tU(j,(c[g+20>>2]|0)+1900|0,10);d=a[j+8+3>>0]|0;h=d<<24>>24<0;Ex(p,h?c[j>>2]|0:j,h?c[j+4>>2]|0:d&255)|0;z5(j);HX(p,42040)|0;d=g+16|0;Fn(o,(c[d>>2]|0)+1|0,10)|0;h=o+8+3|0;f=a[h>>0]|0;i=o+4|0;e=c[i>>2]|0;if((f<<24>>24<0?e:f&255)>>>0<2){Xy(m,42196);tU(n,(c[d>>2]|0)+1|0,10);Mq(k,m,n);p2(j,k);k1(o,j)|0;z5(j);O0(k);z5(n);z5(m);f=a[h>>0]|0;e=c[i>>2]|0}d=f<<24>>24<0;Ex(p,d?c[o>>2]|0:o,d?e:f&255)|0;HX(p,42040)|0;d=g+12|0;Fn(o,c[d>>2]|0,10)|0;f=a[h>>0]|0;e=c[i>>2]|0;if((f<<24>>24<0?e:f&255)>>>0<2){Xy(m,42196);tU(n,c[d>>2]|0,10);Mq(k,m,n);p2(j,k);k1(o,j)|0;z5(j);O0(k);z5(n);z5(m);f=a[h>>0]|0;e=c[i>>2]|0}d=f<<24>>24<0;Ex(p,d?c[o>>2]|0:o,d?e:f&255)|0;HX(p,42252)|0;d=g+8|0;Fn(o,c[d>>2]|0,10)|0;f=a[h>>0]|0;e=c[i>>2]|0;if((f<<24>>24<0?e:f&255)>>>0<2){Xy(m,42196);tU(n,c[d>>2]|0,10);Mq(k,m,n);p2(j,k);k1(o,j)|0;z5(j);O0(k);z5(n);z5(m);f=a[h>>0]|0;e=c[i>>2]|0}d=f<<24>>24<0;Ex(p,d?c[o>>2]|0:o,d?e:f&255)|0;HX(p,42204)|0;d=g+4|0;tU(j,c[d>>2]|0,10);k1(o,j)|0;z5(j);f=a[h>>0]|0;e=c[i>>2]|0;if((f<<24>>24<0?e:f&255)>>>0<2){Xy(m,42196);tU(n,c[d>>2]|0,10);Mq(k,m,n);p2(j,k);k1(o,j)|0;z5(j);O0(k);z5(n);z5(m);f=a[h>>0]|0;e=c[i>>2]|0}d=f<<24>>24<0;Ex(p,d?c[o>>2]|0:o,d?e:f&255)|0;HX(p,42204)|0;Fn(o,c[g>>2]|0,10)|0;d=a[h>>0]|0;e=c[i>>2]|0;if((d<<24>>24<0?e:d&255)>>>0<2){Xy(m,42196);tU(n,c[g>>2]|0,10);Mq(k,m,n);p2(j,k);k1(o,j)|0;z5(j);O0(k);z5(n);z5(m);d=a[h>>0]|0;e=c[i>>2]|0}n=d<<24>>24<0;Ex(p,n?c[o>>2]|0:o,n?e:d&255)|0;GX(b,(a[p+8+3>>0]|0)<0?c[p>>2]|0:p)|0;z5(p);z5(o)}while(0);l=q;return b|0}function Xe(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+16|0;m=s;h=b+792|0;e=b+800|0;q=b+508|0;o=b+612|0;r=b+536|0;p=b+48|0;do if(c[e>>2]|0){d=c[h>>2]|0;f=d+16|0;j=c[f>>2]|0;f=c[f+4>>2]|0;m=p;m=z0(c[o>>2]|0,0,c[m>>2]|0,c[m+4>>2]|0)|0;i=z;k=b+520|0;if(!(f>>>0>i>>>0|(f|0)==(i|0)&j>>>0>m>>>0)?(m=k,!((c[m>>2]|0)==1836021353&(c[m+4>>2]|0)==0)):0){oB(h,d);d=b+40|0;if(!(c[e>>2]|0))e=d;else{f=d;d=c[h>>2]|0;n=7}}else{f=b+40|0;n=7}if((n|0)==7){e=d+16|0;d=f}j=e;i=c[j>>2]|0;j=c[j+4>>2]|0;f=d;d=c[f>>2]|0;f=c[f+4>>2]|0;h=j>>>0>f>>>0|(j|0)==(f|0)&i>>>0>d>>>0;i=h?d:i;j=h?f:j;f=p;f=z0(c[o>>2]|0,0,c[f>>2]|0,c[f+4>>2]|0)|0;h=z;d=HN(b,(c[q>>2]|0)+-2|0)|0;d=z0(f|0,h|0,d|0,z|0)|0;e=z;if(!(j>>>0<e>>>0|(j|0)==(e|0)&i>>>0<d>>>0)){I1(b,d,e);break}q=k;if((c[q>>2]|0)==1836021353&(c[q+4>>2]|0)==0){d=0;e=0}else{e=r;d=c[e>>2]|0;e=c[e+4>>2]|0}r=z0(d|0,e|0,f|0,h|0)|0;if(!((i|0)==(r|0)&(j|0)==(z|0)))I1(b,i,j)}else{k=b+760|0;if(a[b+1038>>0]|0){f=b+780|0;h=b+788|0;d=c[h>>2]|0;if((d|0)==(f|0))break;i=b+24|0;e=d;while(1){d=c[e+4>>2]|0;if(!d)while(1){d=c[e+8>>2]|0;if((c[d>>2]|0)==(e|0))break;else e=d}else while(1){e=c[d>>2]|0;if(!e)break;else d=e}c[h>>2]=d;if((d|0)==(f|0))break;c[m>>2]=c[d+24>>2];e=(a[(jF(k,m)|0)+80>>0]|0)==0;j=c[h>>2]|0;if(!e?+g[(c[i>>2]|0)+136>>2]<1.0:0){n=44;break}else{e=j;continue}}if((n|0)==44?(j|0)!=(f|0):0){j=j+16|0;i=c[j>>2]|0;j=c[j+4>>2]|0;f=p;f=z0(c[o>>2]|0,0,c[f>>2]|0,c[f+4>>2]|0)|0;h=z;d=HN(b,(c[q>>2]|0)+-2|0)|0;d=z0(f|0,h|0,d|0,z|0)|0;e=z;if(!(j>>>0<e>>>0|(j|0)==(e|0)&i>>>0<d>>>0)){I1(b,d,e);break}r=z0(c[r>>2]|0,c[r+4>>2]|0,f|0,h|0)|0;if((i|0)==(r|0)&(j|0)==(z|0))break;I1(b,i,j);break}V5(b);break}if(a[b+1039>>0]|0)J3(b);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;e=j9(379745)|0;if(e>>>0>4294967279)uaa();if(e>>>0<11){a[m+11>>0]=e;d=m}else{r=e+16&-16;d=ZW(r)|0;c[m>>2]=d;c[m+8>>2]=r|-2147483648;c[m+4>>2]=e}i1(d,379745,e)|0;J7(d+e|0,0);a1(m);if(!(a[b+1047>>0]|0)){p=z0(c[o>>2]|0,0,c[p>>2]|0,c[p+4>>2]|0)|0;q=z;r=HN(b,0)|0;r=z0(p|0,q|0,r|0,z|0)|0;I1(b,r,z);break}j=b+764|0;d=c[k>>2]|0;a:while(1){if((d|0)==(j|0))break;f=d+24|0;h=d+28|0;e=0;while(1){i=c[f>>2]|0;if(e>>>0>=(c[h>>2]|0)-i>>2>>>0)break;jt(c[i+(e<<2)>>2]|0);Kl(c[(c[f>>2]|0)+(e<<2)>>2]|0);e=e+1|0}e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue a}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}V5(b)}while(0);l=s;return}function Ye(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;a:while(1){o=b;v=b+-8|0;while(1){p=a;b:while(1){n=p;d=o-n|0;e=d>>3;a=p+8|0;switch(e|0){case 1:case 0:break a;case 2:{u=5;break a}case 3:{u=7;break a}case 4:{u=8;break a}case 5:{u=9;break a}default:{}}if((d|0)<248){u=11;break a}j=p+(((e|0)/2|0)<<3)|0;if((d|0)>7992){d=(e|0)/4|0;d=$n(p,p+(d<<3)|0,j,j+(d<<3)|0,v)|0}else d=ro(p,j,v)|0;l=p;k=c[l>>2]|0;l=c[l+4>>2]|0;i=j;h=c[i>>2]|0;i=c[i+4>>2]|0;if(l>>>0<i>>>0|(l|0)==(i|0)&k>>>0<h>>>0){e=v;break}else e=v;while(1){e=e+-8|0;if((p|0)==(e|0))break;g=e;f=c[g>>2]|0;g=c[g+4>>2]|0;if(g>>>0<i>>>0|(g|0)==(i|0)&f>>>0<h>>>0){u=28;break b}}h=v;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!(l>>>0<h>>>0|(l|0)==(h|0)&k>>>0<g>>>0)){while(1){if((a|0)==(v|0))break a;e=a;d=c[e>>2]|0;e=c[e+4>>2]|0;f=a+8|0;if(l>>>0<e>>>0|(l|0)==(e|0)&k>>>0<d>>>0)break;else a=f}c[a>>2]=g;c[a+4>>2]=h;a=v;c[a>>2]=d;c[a+4>>2]=e;a=f}if((a|0)==(v|0))break a;else d=v;while(1){j=p;k=c[j>>2]|0;j=c[j+4>>2]|0;while(1){h=a;g=c[h>>2]|0;h=c[h+4>>2]|0;i=a+8|0;if(j>>>0<h>>>0|(j|0)==(h|0)&k>>>0<g>>>0)break;else a=i}do{d=d+-8|0;f=d;e=c[f>>2]|0;f=c[f+4>>2]|0}while(j>>>0<f>>>0|(j|0)==(f|0)&k>>>0<e>>>0);if(a>>>0>=d>>>0){p=a;continue b}c[a>>2]=e;c[a+4>>2]=f;a=d;c[a>>2]=g;c[a+4>>2]=h;a=i}}if((u|0)==28){u=0;m=p;c[m>>2]=f;c[m+4>>2]=g;m=e;c[m>>2]=k;c[m+4>>2]=l;d=d+1|0}c:do if(a>>>0<e>>>0){m=j;while(1){l=m;k=c[l>>2]|0;l=c[l+4>>2]|0;while(1){i=a;h=c[i>>2]|0;i=c[i+4>>2]|0;j=a+8|0;if(i>>>0<l>>>0|(i|0)==(l|0)&h>>>0<k>>>0)a=j;else break}do{e=e+-8|0;g=e;f=c[g>>2]|0;g=c[g+4>>2]|0}while(!(g>>>0<l>>>0|(g|0)==(l|0)&f>>>0<k>>>0));if(a>>>0>e>>>0){e=m;f=a;break c}l=a;c[l>>2]=f;c[l+4>>2]=g;l=e;c[l>>2]=h;c[l+4>>2]=i;m=(m|0)==(a|0)?e:m;a=j;d=d+1|0}}else{e=j;f=a}while(0);if((f|0)!=(e|0)?(r=e,q=c[r>>2]|0,r=c[r+4>>2]|0,t=f,s=c[t>>2]|0,t=c[t+4>>2]|0,r>>>0<t>>>0|(r|0)==(t|0)&q>>>0<s>>>0):0){m=f;c[m>>2]=q;c[m+4>>2]=r;m=e;c[m>>2]=s;c[m+4>>2]=t;d=d+1|0}a=f+8|0;if(!d){d=El(p,f)|0;if(El(a,b)|0){u=44;break}if(d)continue}m=f;if((m-n|0)>=(o-m|0)){u=43;break}Ye(p,f)}if((u|0)==43){u=0;Ye(a,b);a=p;b=f;continue}else if((u|0)==44){u=0;if(d)break;else{a=p;b=f;continue}}}if((u|0)==5){b=v;a=c[b>>2]|0;b=c[b+4>>2]|0;e=p;d=c[e>>2]|0;e=c[e+4>>2]|0;if(b>>>0<e>>>0|(b|0)==(e|0)&a>>>0<d>>>0){u=p;c[u>>2]=a;c[u+4>>2]=b;c[v>>2]=d;c[v+4>>2]=e}}else if((u|0)==7)ro(p,a,v)|0;else if((u|0)==8)Jr(p,a,p+16|0,v)|0;else if((u|0)==9)$n(p,a,p+16|0,p+24|0,v)|0;else if((u|0)==11)jw(p,b);return}function Ze(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;a:while(1){o=b;v=b+-8|0;while(1){p=a;b:while(1){n=p;d=o-n|0;e=d>>3;a=p+8|0;switch(e|0){case 1:case 0:break a;case 2:{u=5;break a}case 3:{u=7;break a}case 4:{u=8;break a}case 5:{u=9;break a}default:{}}if((d|0)<248){u=11;break a}j=p+(((e|0)/2|0)<<3)|0;if((d|0)>7992){d=(e|0)/4|0;d=ao(p,p+(d<<3)|0,j,j+(d<<3)|0,v)|0}else d=so(p,j,v)|0;l=p;k=c[l>>2]|0;l=c[l+4>>2]|0;i=j;h=c[i>>2]|0;i=c[i+4>>2]|0;if((l|0)<(i|0)|(l|0)==(i|0)&k>>>0<h>>>0){e=v;break}else e=v;while(1){e=e+-8|0;if((p|0)==(e|0))break;g=e;f=c[g>>2]|0;g=c[g+4>>2]|0;if((g|0)<(i|0)|(g|0)==(i|0)&f>>>0<h>>>0){u=28;break b}}h=v;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!((l|0)<(h|0)|(l|0)==(h|0)&k>>>0<g>>>0)){while(1){if((a|0)==(v|0))break a;e=a;d=c[e>>2]|0;e=c[e+4>>2]|0;f=a+8|0;if((l|0)<(e|0)|(l|0)==(e|0)&k>>>0<d>>>0)break;else a=f}c[a>>2]=g;c[a+4>>2]=h;a=v;c[a>>2]=d;c[a+4>>2]=e;a=f}if((a|0)==(v|0))break a;else d=v;while(1){j=p;k=c[j>>2]|0;j=c[j+4>>2]|0;while(1){h=a;g=c[h>>2]|0;h=c[h+4>>2]|0;i=a+8|0;if((j|0)<(h|0)|(j|0)==(h|0)&k>>>0<g>>>0)break;else a=i}do{d=d+-8|0;f=d;e=c[f>>2]|0;f=c[f+4>>2]|0}while((j|0)<(f|0)|(j|0)==(f|0)&k>>>0<e>>>0);if(a>>>0>=d>>>0){p=a;continue b}c[a>>2]=e;c[a+4>>2]=f;a=d;c[a>>2]=g;c[a+4>>2]=h;a=i}}if((u|0)==28){u=0;m=p;c[m>>2]=f;c[m+4>>2]=g;m=e;c[m>>2]=k;c[m+4>>2]=l;d=d+1|0}c:do if(a>>>0<e>>>0){m=j;while(1){l=m;k=c[l>>2]|0;l=c[l+4>>2]|0;while(1){i=a;h=c[i>>2]|0;i=c[i+4>>2]|0;j=a+8|0;if((i|0)<(l|0)|(i|0)==(l|0)&h>>>0<k>>>0)a=j;else break}do{e=e+-8|0;g=e;f=c[g>>2]|0;g=c[g+4>>2]|0}while(!((g|0)<(l|0)|(g|0)==(l|0)&f>>>0<k>>>0));if(a>>>0>e>>>0){e=m;f=a;break c}l=a;c[l>>2]=f;c[l+4>>2]=g;l=e;c[l>>2]=h;c[l+4>>2]=i;m=(m|0)==(a|0)?e:m;a=j;d=d+1|0}}else{e=j;f=a}while(0);if((f|0)!=(e|0)?(r=e,q=c[r>>2]|0,r=c[r+4>>2]|0,t=f,s=c[t>>2]|0,t=c[t+4>>2]|0,(r|0)<(t|0)|(r|0)==(t|0)&q>>>0<s>>>0):0){m=f;c[m>>2]=q;c[m+4>>2]=r;m=e;c[m>>2]=s;c[m+4>>2]=t;d=d+1|0}a=f+8|0;if(!d){d=Fl(p,f)|0;if(Fl(a,b)|0){u=44;break}if(d)continue}m=f;if((m-n|0)>=(o-m|0)){u=43;break}Ze(p,f)}if((u|0)==43){u=0;Ze(a,b);a=p;b=f;continue}else if((u|0)==44){u=0;if(d)break;else{a=p;b=f;continue}}}if((u|0)==5){b=v;a=c[b>>2]|0;b=c[b+4>>2]|0;e=p;d=c[e>>2]|0;e=c[e+4>>2]|0;if((b|0)<(e|0)|(b|0)==(e|0)&a>>>0<d>>>0){u=p;c[u>>2]=a;c[u+4>>2]=b;c[v>>2]=d;c[v+4>>2]=e}}else if((u|0)==7)so(p,a,v)|0;else if((u|0)==8)Kr(p,a,p+16|0,v)|0;else if((u|0)==9)ao(p,a,p+16|0,p+24|0,v)|0;else if((u|0)==11)kw(p,b);return}function _e(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=l;l=l+16|0;u=z;w=b+520|0;f=w;e=c[f>>2]|0;f=c[f+4>>2]|0;x=b+536|0;d=b+772|0;a:do if((e|0)<1247104587){switch(e|0){case -1:break;default:{y=6;break a}}if((f|0)==-1){c[d>>2]=-1;y=10}else y=6}else{switch(e|0){case 1247104587:break;default:{y=6;break a}}if(!f){e1(b,c[x>>2]|0,c[x+4>>2]|0);Xe(b)}else y=6}while(0);do if((y|0)==6){t=e&-65536;c[d>>2]=t;if((t|0)==1769472e3){Wn(b);c[d>>2]=c[w>>2]<<16;Xe(b);break}if((e&65535|0)==27e3&0==0){Wn(b);c[d>>2]=c[w>>2]&-65536;Xe(b)}else y=10}while(0);do if((y|0)==10){k=jF(b+760|0,d)|0;t=k+52|0;c[t>>2]=(c[t>>2]|0)+1;if(!(a[k+80>>0]|0)){Xe(b);break}if(0==0?(c[w>>2]&65535|0)==29816:0)Ar(b);m=k+4|0;n=b+528|0;o=b+136|0;p=b+144|0;q=b+544|0;r=b+612|0;s=k+82|0;t=k+8|0;d=0;while(1){e=c[k>>2]|0;if(d>>>0>=(c[m>>2]|0)-e>>2>>>0)break;g=c[e+(d<<2)>>2]|0;do if(g){f=o;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e|0)==-1&(f|0)==-1)){j=g+136|0;c[j>>2]=e;c[j+4>>2]=f}f=p;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e|0)==-1&(f|0)==-1)){j=g+144|0;c[j>>2]=e;c[j+4>>2]=f}e=n;f=c[e>>2]|0;i=(c[q>>2]|0)+(c[r>>2]|0)+f|0;h=x;e=D_(c[h>>2]|0,c[h+4>>2]|0,f|0,c[e+4>>2]|0)|0;Sc(b,g,i,e,1);e=c[m>>2]|0;i=c[k>>2]|0;g=e-i|0;f=i;h=f+(d<<2)|0;if((g|0)==4){if(!(c[(c[h>>2]|0)+548>>2]|0))break;a[s>>0]=0;break}if(g>>2>>>0>1){g=c[h>>2]|0;h=c[g+728>>2]|0;j=g;if((h&9|0)==8){if(g){jb[c[(c[g>>2]|0)+4>>2]&511](g);f=c[k>>2]|0;e=c[m>>2]|0}h=f+(d<<2)|0;f=h+4|0;g=e-f|0;i=g>>2;if(i){TR(h|0,f|0,g|0)|0;e=c[m>>2]|0}f=h+(i<<2)|0;while(1){if((e|0)==(f|0))break;j=e+-4|0;c[m>>2]=j;e=j}d=d+-1|0;break}if(h&1){c[u>>2]=j;g=0;f=i;while(1){h=f;if(g>>>0>=e-f>>2>>>0)break;if((g|0)!=(d|0)?(v=c[h+(g<<2)>>2]|0,(v|0)!=0):0){jb[c[(c[v>>2]|0)+4>>2]&511](v);e=c[m>>2]|0;f=c[k>>2]|0}g=g+1|0}g=e;d=(e+(0-f)|0)>>>2;e=g;while(1){if((e|0)==(h|0))break;i=e+-4|0;c[m>>2]=i;e=i}d=g+(0-d<<2)|0;if((d|0)==(c[t>>2]|0))Yy(k,u);else{c[d>>2]=j;c[m>>2]=(c[m>>2]|0)+4}d=0}}}while(0);d=d+1|0}v=x;x=c[v+4>>2]|0;d=n;c[d>>2]=c[v>>2];c[d+4>>2]=x;d=c[w>>2]&65535;b:do if(d<<16>>16<25699)switch(d<<16>>16){case 25698:case 24415:{y=50;break}default:{}}else{if(d<<16>>16<30562)switch(d<<16>>16){case 25699:{y=50;break b}default:break b}switch(d<<16>>16){case 30562:break;default:break b}cD(b)}while(0);if((y|0)==50)cF(b);Xe(b)}while(0);l=z;return}function $e(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;f=(a[b+760>>0]|0)==0;g=b+840|0;j=b+544|0;i=b+536|0;k=b+612|0;h=b+804|0;a:do if(f){m=d[g>>0]|0;n=c[h>>2]|0;e=n+(m*120|0)+20|0;if(((c[n+(m*120|0)+16>>2]|0)==0?(c[e>>2]|0)==0:0)?(a[n+(m*120|0)+24>>0]|0)==0:0){n=b+520|0;if((c[n>>2]|0)==189&(c[n+4>>2]|0)==0?a[b+792>>0]|0:0){e=a[b+785>>0]|0;if((e&255)<16){e=_J(b)|0;break}if((e&-32)<<24>>24==32){e=_J(b)|0;break}if((e&255)>111&e<<24>>24>-1){e=_J(b)|0;break}if(e<<24>>24<0&(e&255)<136){e=D3()|0;break}switch((e&-8)<<24>>24){case -120:{e=B3()|0;break a}case -112:{e=B3()|0;break a}case -104:{e=B3()|0;break a}default:switch((e&-16)<<24>>24){case -96:{e=aK(b)|0;break a}case -64:{e=D3()|0;break a}default:{e=0;break a}}}}h=i;g=c[h>>2]|0;h=c[h+4>>2]|0;if(h>>>0>0|(h|0)==0&g>>>0>2){e=(c[j>>2]|0)+(c[k>>2]|0)|0;f=d7(a[e>>0]|0,a[e+1>>0]|0)|0;if(f<<16>>16==2935){e=D3()|0;break}if(h>>>0>0|(h|0)==0&g>>>0>4?(C9(e)|0)==2147385345:0){e=B3()|0;break}if((f&-2)<<16>>16==-96){e=OT(b)|0;break}if((h>>>0>0|(h|0)==0&g>>>0>6)&f<<16>>16==-112){n=e+4|0;if((d7(a[n>>0]|0,a[n+1>>0]|0)|0)<<16>>16==2935){e=D3()|0;break}n=e+4|0;if(!((d7(a[n>>0]|0,a[n+1>>0]|0)|0)<<16>>16))e=_J(b)|0;else e=0}else e=0}else e=0}else l=6}else{e=b+768|0;l=6}while(0);b:do if((l|0)==6){if((c[e>>2]|0)==1112757060){e=KJ(b)|0;break}if(f)e=(c[h>>2]|0)+((d[g>>0]|0)*120|0)+12|0;else e=b+761|0;switch(a[e>>0]|0){case 4:case 3:{e=V2()|0;break b}case 15:{e=J0()|0;break b}case 17:{e=I0()|0;break b}case -128:{e=aK(b)|0;break b}case -95:case -121:case -124:case -125:case -127:{e=D3()|0;break b}case -94:case -122:case -123:case -126:{e=B3()|0;break b}case -112:{e=$J(b)|0;break b}case -22:{e=pX(b)|0;break b}default:{if(f)e=(c[h>>2]|0)+((d[g>>0]|0)*120|0)+24|0;else e=b+772|0;switch(a[e>>0]|0){case 86:{e=PJ(b)|0;break b}case 89:{e=LJ(b)|0;break b}case -127:case 122:case 106:{e=D3()|0;break b}case 123:{e=B3()|0;break b}case 124:{e=w3()|0;break b}default:{g=i;f=c[g>>2]|0;g=c[g+4>>2]|0;if(!(g>>>0>0|(g|0)==0&f>>>0>2)){e=0;break b}e=(c[j>>2]|0)+(c[k>>2]|0)|0;if((d7(a[e>>0]|0,a[e+1>>0]|0)|0)<<16>>16==2935){e=D3()|0;break b}if(!(g>>>0>0|(g|0)==0&f>>>0>4)){e=0;break b}if((C9(e)|0)!=2147385345){e=0;break b}e=B3()|0;break b}}}}}while(0);return e|0}function af(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;A=l;l=l+64|0;m=A+56|0;i=A+55|0;p=A+54|0;q=A+53|0;r=A+51|0;s=A+50|0;t=A+49|0;u=A+48|0;x=A+36|0;y=A+24|0;g=A+12|0;h=A;a[u>>0]=0;Bx(b);AT(b,m);AT(b,i);AT(b,p);AT(b,q);AT(b,A+52|0);AT(b,r);AT(b,s);AT(b,t);wK(b);n=b+784|0;v=b+760|0;o=b+768|0;w=b+772|0;if(a[m>>0]|0){Bx(b);AT(b,u);A6(c[b+648>>2]|0);xR(b,3,x);xR(b,3,y);if((qO(b)|0?(a[o>>0]|0)==2:0)?a[n>>0]|0:0){a[(c[(c[(c[v>>2]|0)+80>>2]|0)+(e[w>>1]<<2)>>2]|0)+169>>0]=122;TX(g);j=cC(g,c[39780+(d[y>>0]<<2)>>2]|0)|0;k=c[(c[(c[v>>2]|0)+80>>2]|0)+(e[w>>1]<<2)>>2]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;m=j9(384542)|0;if(m>>>0>4294967279)uaa();if(m>>>0<11){a[h+11>>0]=m;f=h}else{B=m+16&-16;f=ZW(B)|0;c[h>>2]=f;c[h+8>>2]=B|-2147483648;c[h+4>>2]=m}i1(f,384542,m)|0;J7(f+m|0,0);k1(VC(k+28|0,h)|0,j)|0;a1(h);z5(g)}wK(b)}if(a[i>>0]|0){Bx(b);B=b+648|0;d4(c[B>>2]|0,3);d4(c[B>>2]|0,5);wK(b)}f=b+528|0;if(a[p>>0]|0){p=f;p=z0(c[p>>2]|0,c[p+4>>2]|0,1,0)|0;B=f;c[B>>2]=p;c[B+4>>2]=z}if(a[q>>0]|0){q=f;q=z0(c[q>>2]|0,c[q+4>>2]|0,1,0)|0;B=f;c[B>>2]=q;c[B+4>>2]=z}if(a[r>>0]|0){r=f;r=z0(c[r>>2]|0,c[r+4>>2]|0,1,0)|0;B=f;c[B>>2]=r;c[B+4>>2]=z}if(a[s>>0]|0){s=f;s=z0(c[s>>2]|0,c[s+4>>2]|0,1,0)|0;B=f;c[B>>2]=s;c[B+4>>2]=z}if(a[t>>0]|0){t=f;t=z0(c[t>>2]|0,c[t+4>>2]|0,1,0)|0;B=f;c[B>>2]=t;c[B+4>>2]=z}if((qO(b)|0?(a[o>>0]|0)==2:0)?a[n>>0]|0:0){c[(c[(c[(c[v>>2]|0)+80>>2]|0)+(e[w>>1]<<2)>>2]|0)+56>>2]=2;Xy(x,a[u>>0]|0?39812:39840);g=c[(c[(c[v>>2]|0)+80>>2]|0)+(e[w>>1]<<2)>>2]|0;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;h=j9(384476)|0;if(h>>>0>4294967279)uaa();if(h>>>0<11){a[y+11>>0]=h;f=y}else{B=h+16&-16;f=ZW(B)|0;c[y>>2]=f;c[y+8>>2]=B|-2147483648;c[y+4>>2]=h}i1(f,384476,h)|0;J7(f+h|0,0);vF(VC(g+28|0,y)|0,x)|0;a1(y);z5(x);Xy(x,39860);g=c[(c[(c[v>>2]|0)+80>>2]|0)+(e[w>>1]<<2)>>2]|0;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;h=j9(385582)|0;if(h>>>0>4294967279)uaa();if(h>>>0<11){a[y+11>>0]=h;f=y}else{B=h+16&-16;f=ZW(B)|0;c[y>>2]=f;c[y+8>>2]=B|-2147483648;c[y+4>>2]=h}i1(f,385582,h)|0;J7(f+h|0,0);vF(VC(g+28|0,y)|0,x)|0;a1(y);z5(x)}l=A;return}function bf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=l;l=l+32|0;A=C+12|0;j=C;e=c[b>>2]|0;B=b+4|0;while(1){f=c[B>>2]|0;if((f|0)==(e|0))break;z=f+-40|0;c[B>>2]=z;$_(z)}z=d+8+3|0;y=a[z>>0]|0;h=d+4|0;if((y<<24>>24<0?c[h>>2]|0:y&255)|0){TX(A);i=b+12|0;e=i9(42472)|0;y=a[b+20+3>>0]|0;do if((e|0)==((y<<24>>24<0?c[b+16>>2]|0:y&255)|0)?(VG(i,42472,e)|0)==0:0){f=a[z>>0]|0;g=f<<24>>24<0;e=g?c[d>>2]|0:d;f=g?c[h>>2]|0:f&255;g=i9(42452)|0;if(!((f|0)==0|(g|0)==0)?(y=e+(f<<2)|0,k=YL(e,y,42452,42452+(g<<2)|0)|0,m=k-e>>2,!((k|0)==(y|0)|(m|0)==-1)):0){if((c[k>>2]|0)!=13){Xy(j,42472);k1(A,j)|0;z5(j);break}y=m+1|0;if(y>>>0<f>>>0?(c[e+(y<<2)>>2]|0)==10:0){Xy(j,42452);k1(A,j)|0;z5(j);break}Xy(j,42464);k1(A,j)|0;z5(j);break}k1(A,i)|0}else n=16;while(0);if((n|0)==16)k1(A,i)|0;w=a[z>>0]|0;w=w<<24>>24<0?c[h>>2]|0:w&255;x=b+36|0;y=b+44+3|0;e=a[y>>0]|0;if(e<<24>>24<0)v=c[b+40>>2]|0;else v=e&255;r=A+8+3|0;s=a[r>>0]|0;s=s<<24>>24<0?c[A+4>>2]|0:s&255;t=b+24|0;u=b+32+3|0;e=a[u>>0]|0;if(e<<24>>24<0)p=c[b+28>>2]|0;else p=e&255;q=v<<1;e=0;f=0;g=0;o=0;a:while(1){b:while(1){n=e+1|0;c:while(1){m=f+1|0;while(1){if(g>>>0>=w>>>0)break a;k=g+v|0;d:do if(k>>>0<=w>>>0){j=(a[z>>0]|0)<0?c[d>>2]|0:d;h=0;while(1){if(h>>>0>=v>>>0)break;if((a[y>>0]|0)<0)i=c[x>>2]|0;else i=x;if((c[j+(h+g<<2)>>2]|0)==(c[i+(h<<2)>>2]|0))h=h+1|0;else break d}if((g+q|0)>>>0>w>>>0)break b;else h=0;while(1){if(h>>>0>=v>>>0)break;if((a[y>>0]|0)<0)i=c[x>>2]|0;else i=x;if((c[j+(h+k<<2)>>2]|0)==(c[i+(h<<2)>>2]|0))h=h+1|0;else break b}g=g+1|0}while(0);if(!o){k=g+s|0;if(k>>>0<=w>>>0){i=(a[z>>0]|0)<0?c[d>>2]|0:d;j=(a[r>>0]|0)<0?c[A>>2]|0:A;h=0;while(1){if(h>>>0>=s>>>0){e=n;f=0;g=k;continue b}if((c[i+(h+g<<2)>>2]|0)==(c[j+(h<<2)>>2]|0))h=h+1|0;else break}}i=g+p|0;if(i>>>0<=w>>>0){j=(a[z>>0]|0)<0?c[d>>2]|0:d;h=0;while(1){if(h>>>0>=p>>>0){f=m;g=i;continue c}if((a[u>>0]|0)<0)k=c[t>>2]|0;else k=t;if((c[j+(h+g<<2)>>2]|0)==(c[k+(h<<2)>>2]|0))h=h+1|0;else break}}}h=c[b>>2]|0;e:do if(e>>>0>=(((c[B>>2]|0)-h|0)/40|0)>>>0){cE(b,n);i=0;while(1){h=c[b>>2]|0;if(i>>>0>e>>>0)break e;z3(h+(i*40|0)|0,t);i=i+1|0}}while(0);i=h+(e*40|0)|0;j=c[i>>2]|0;if(f>>>0<(((c[h+(e*40|0)+4>>2]|0)-j|0)/12|0)>>>0)h=j;else{ME(i,m);h=c[i>>2]|0}Gx(h+(f*12|0)|0,c[((a[z>>0]|0)<0?c[d>>2]|0:d)+(g<<2)>>2]|0);g=g+1|0}}}g=k;o=o^1}z5(A)}l=C;return}function cf(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0.0,i=0,j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=a+4|0;i=c[y>>2]|0;x=a+100|0;if(i>>>0<(c[x>>2]|0)>>>0){c[y>>2]=i+1;j=d[i>>0]|0;k=0}else{j=_x(a)|0;k=0}a:while(1){switch(j|0){case 46:{n=8;break a}case 48:break;default:{s=0;t=0;o=1.0;h=0.0;i=0;m=j;r=k;v=0;u=0;k=0;j=0;break a}}i=c[y>>2]|0;if(i>>>0<(c[x>>2]|0)>>>0){c[y>>2]=i+1;j=d[i>>0]|0;k=1;continue}else{j=_x(a)|0;k=1;continue}}if((n|0)==8){i=c[y>>2]|0;if(i>>>0<(c[x>>2]|0)>>>0){c[y>>2]=i+1;j=d[i>>0]|0}else j=_x(a)|0;if((j|0)==48){k=0;j=0;do{i=c[y>>2]|0;if(i>>>0<(c[x>>2]|0)>>>0){c[y>>2]=i+1;m=d[i>>0]|0}else m=_x(a)|0;k=z0(k|0,j|0,-1,-1)|0;j=z}while((m|0)==48);s=1;t=0;o=1.0;h=0.0;i=0;r=1;v=0;u=0}else{s=1;t=0;o=1.0;h=0.0;i=0;m=j;r=k;v=0;u=0;k=0;j=0}}while(1){n=m+-48|0;p=(m|0)==46;if(n>>>0>=10?!(p|((m|32)+-97|0)>>>0<6):0)break;if(p)if(!s){s=1;n=t;l=o;k=u;j=v;q=u;p=v}else{m=46;break}else{m=(m|0)>57?(m|32)+-87|0:n;do if(!((v|0)<0|(v|0)==0&u>>>0<8))if((v|0)<0|(v|0)==0&u>>>0<14){o=o*.0625;n=t;l=o;h=h+o*+(m|0);break}else{r=(t|0)!=0|(m|0)==0;n=r?t:1;l=o;h=r?h:h+o*.5;break}else{n=t;l=o;i=m+(i<<4)|0}while(0);q=z0(u|0,v|0,1,0)|0;r=1;p=z}m=c[y>>2]|0;if(m>>>0<(c[x>>2]|0)>>>0){c[y>>2]=m+1;t=n;o=l;m=d[m>>0]|0;v=p;u=q;continue}else{t=n;o=l;m=_x(a)|0;v=p;u=q;continue}}do if(!r){b=(c[x>>2]|0)!=0;if(b)c[y>>2]=(c[y>>2]|0)+-1;if(g){if(b?(w=c[y>>2]|0,c[y>>2]=w+-1,s|0):0)c[y>>2]=w+-2}else NV(a,0);h=+(f|0)*0.0}else{p=(s|0)==0;q=p?u:k;p=p?v:j;if((v|0)<0|(v|0)==0&u>>>0<8){k=u;j=v;do{i=i<<4;k=z0(k|0,j|0,1,0)|0;j=z}while((j|0)<0|(j|0)==0&k>>>0<8);n=i}else n=i;if((m|32|0)==112){j=ml(a,g)|0;i=z;if((j|0)==0&(i|0)==-2147483648){if(!g){NV(a,0);h=0.0;break}if(!(c[x>>2]|0)){j=0;i=0}else{c[y>>2]=(c[y>>2]|0)+-1;j=0;i=0}}}else if(!(c[x>>2]|0)){j=0;i=0}else{c[y>>2]=(c[y>>2]|0)+-1;j=0;i=0}k=PZ(q|0,p|0,2)|0;k=z0(k|0,z|0,-32,-1)|0;k=z0(k|0,z|0,j|0,i|0)|0;i=z;if(!n){h=+(f|0)*0.0;break}y=0-e|0;g=((y|0)<0)<<31>>31;if((i|0)>(g|0)|(i|0)==(g|0)&k>>>0>y>>>0){c[12784]=34;h=+(f|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}y=e+-106|0;g=((y|0)<0)<<31>>31;if((i|0)<(g|0)|(i|0)==(g|0)&k>>>0<y>>>0){c[12784]=34;h=+(f|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if((n|0)>-1){j=n;do{y=!(h>=.5);j=j<<1|(y^1)&1;h=h+(y?h:h+-1.0);k=z0(k|0,i|0,-1,-1)|0;i=z}while((j|0)>-1);o=h}else{o=h;j=n}y=((b|0)<0)<<31>>31;e=D_(32,0,e|0,((e|0)<0)<<31>>31|0)|0;i=z0(k|0,i|0,e|0,z|0)|0;e=z;l=+(f|0);if((y|0)>(e|0)|(y|0)==(e|0)&b>>>0>i>>>0)if((i|0)>0){b=i;n=58}else{i=0;b=84;n=59}else n=58;if((n|0)==58)if((b|0)<53){i=b;b=84-b|0;n=59}else h=0.0;if((n|0)==59){h=+H9(+LC(1.0,b),l);b=i}f=(j&1|0)==0&(o!=0.0&(b|0)<32);h=l*(f?0.0:o)+(h+l*+(((f&1)+j|0)>>>0))-h;if(!(h!=0.0))c[12784]=34;h=+L9(h,k)}while(0);return +h}function df(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;J=l;l=l+80|0;B=J+64|0;C=J+52|0;E=J+40|0;F=J+28|0;G=J+16|0;H=J+4|0;I=J;A=b+536|0;q=c[A>>2]|0;TX(B);TX(C);TX(E);TX(F);TX(G);TX(H);jZ(b,q,0,B);h=B+8+3|0;o=a[h>>0]|0;n=B+4|0;o=o<<24>>24<0?c[n>>2]|0:o&255;D=b+528|0;K=D;c[K>>2]=o;c[K+4>>2]=0;q=q-o|0;if(((((q|0?(t=z0(o|0,0,1,0)|0,K=D,c[K>>2]=t,c[K+4>>2]=z,K=q+-1|0,jZ(b,K,0,C),t=a[h>>0]|0,r=C+8+3|0,u=a[r>>0]|0,s=C+4|0,u=u<<24>>24<0?c[s>>2]|0:u&255,t=(t<<24>>24<0?c[n>>2]|0:t&255)+1+u|0,q=D,c[q>>2]=t,c[q+4>>2]=0,u=K-u|0,u|0):0)?(x=z0(t|0,0,1,0)|0,K=D,c[K>>2]=x,c[K+4>>2]=z,K=u+-1|0,jZ(b,K,0,E),u=a[h>>0]|0,x=a[r>>0]|0,v=E+8+3|0,y=a[v>>0]|0,w=E+4|0,y=y<<24>>24<0?c[w>>2]|0:y&255,x=(u<<24>>24<0?c[n>>2]|0:u&255)+2+(x<<24>>24<0?c[s>>2]|0:x&255)+y|0,u=D,c[u>>2]=x,c[u+4>>2]=0,y=K-y|0,y|0):0)?(x=z0(x|0,0,1,0)|0,K=D,c[K>>2]=x,c[K+4>>2]=z,K=y+-1|0,jZ(b,K,0,F),x=a[h>>0]|0,y=a[r>>0]|0,f=a[v>>0]|0,d=F+8+3|0,g=a[d>>0]|0,e=F+4|0,g=g<<24>>24<0?c[e>>2]|0:g&255,f=(x<<24>>24<0?c[n>>2]|0:x&255)+3+(y<<24>>24<0?c[s>>2]|0:y&255)+(f<<24>>24<0?c[w>>2]|0:f&255)+g|0,y=D,c[y>>2]=f,c[y+4>>2]=0,g=K-g|0,g|0):0)?(u=z0(f|0,0,1,0)|0,K=D,c[K>>2]=u,c[K+4>>2]=z,K=g+-1|0,jZ(b,K,0,G),u=a[h>>0]|0,x=a[r>>0]|0,y=a[v>>0]|0,k=a[d>>0]|0,i=G+8+3|0,m=a[i>>0]|0,j=G+4|0,m=m<<24>>24<0?c[j>>2]|0:m&255,k=(u<<24>>24<0?c[n>>2]|0:u&255)+4+(x<<24>>24<0?c[s>>2]|0:x&255)+(y<<24>>24<0?c[w>>2]|0:y&255)+(k<<24>>24<0?c[e>>2]|0:k&255)+m|0,y=D,c[y>>2]=k,c[y+4>>2]=0,m=K-m|0,m|0):0)?(t=z0(k|0,0,1,0)|0,y=D,c[y>>2]=t,c[y+4>>2]=z,y=m+-1|0,jZ(b,y,0,H),t=a[h>>0]|0,u=a[r>>0]|0,v=a[v>>0]|0,x=a[d>>0]|0,p=a[i>>0]|0,K=a[H+8+3>>0]|0,K=K<<24>>24<0?c[H+4>>2]|0:K&255,p=(t<<24>>24<0?c[n>>2]|0:t&255)+5+(u<<24>>24<0?c[s>>2]|0:u&255)+(v<<24>>24<0?c[w>>2]|0:v&255)+(x<<24>>24<0?c[e>>2]|0:x&255)+(p<<24>>24<0?c[j>>2]|0:p&255)+K|0,x=D,c[x>>2]=p,c[x+4>>2]=0,(y|0)!=(K|0)):0){f=z0(p|0,0,1,0)|0;g=D;c[g>>2]=f;c[g+4>>2]=z;bD(b,I);g=D;f=c[g>>2]|0;g=c[g+4>>2]|0;K=z0(f|0,g|0,8,0)|0;y=z;e=A;d=c[e>>2]|0;e=c[e+4>>2]|0;if(y>>>0<e>>>0|(y|0)==(e|0)&K>>>0<d>>>0){K=D_(d|0,e|0,f|0,g|0)|0;e1(b,K,z)}GC(b);A=D;A=z0(c[A>>2]|0,c[A+4>>2]|0,4,0)|0;K=D;c[K>>2]=A;c[K+4>>2]=z;KK(b);J3(b);zb(b,0,0,183,B,0);zb(b,0,0,199,C,0);zb(b,0,0,171,E,0);Mc(b,0,0,390991,F,0);zb(b,0,0,240,G,0);zb(b,0,0,320,H,0);lL(b,0,0,187,c[I>>2]|0,10,0)}z5(H);z5(G);z5(F);z5(E);z5(C);z5(B);l=J;return}function ef(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=l;l=l+32|0;f=h;i=tb[c[e>>2]&31](b,a)|0;g=tb[c[e>>2]&31](d,b)|0;do if(i){if(g){c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[a+16>>2]=c[d+16>>2];c[a+20>>2]=c[d+20>>2];c[a+24>>2]=c[d+24>>2];c[a+28>>2]=c[d+28>>2];c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];c[d+28>>2]=c[f+28>>2];a=1;break}c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];c[b>>2]=c[f>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];c[b+16>>2]=c[f+16>>2];c[b+20>>2]=c[f+20>>2];c[b+24>>2]=c[f+24>>2];c[b+28>>2]=c[f+28>>2];if(tb[c[e>>2]&31](d,b)|0){c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];c[d+28>>2]=c[f+28>>2];a=2}else a=1}else if(g){c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2];c[f+12>>2]=c[b+12>>2];c[f+16>>2]=c[b+16>>2];c[f+20>>2]=c[b+20>>2];c[f+24>>2]=c[b+24>>2];c[f+28>>2]=c[b+28>>2];c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];c[d+28>>2]=c[f+28>>2];if(tb[c[e>>2]&31](b,a)|0){c[f>>2]=c[a>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];c[a+12>>2]=c[b+12>>2];c[a+16>>2]=c[b+16>>2];c[a+20>>2]=c[b+20>>2];c[a+24>>2]=c[b+24>>2];c[a+28>>2]=c[b+28>>2];c[b>>2]=c[f>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[b+12>>2]=c[f+12>>2];c[b+16>>2]=c[f+16>>2];c[b+20>>2]=c[f+20>>2];c[b+24>>2]=c[f+24>>2];c[b+28>>2]=c[f+28>>2];a=2}else a=1}else a=0;while(0);l=h;return a|0}function ff(d){d=d|0;var f=0,g=0,i=0.0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=l;l=l+16|0;D=I;G=d+768|0;g=c[G>>2]|0;C=0;v=0;f=c[g+176>>2]|0;t=0;q=0;r=0;s=0;w=0;x=0;A=0;B=0;while(1){if((f|0)==(g+180|0))break;y=(c[g+80>>2]|0)+(e[f+14>>1]<<2)|0;u=c[y>>2]|0;if((u|0)!=0?(H=u+114|0,(a[H>>0]|0)!=0):0){k=u+96|0;j=k;g=c[j>>2]|0;j=c[j+4>>2]|0;p=u+80|0;o=c[p>>2]|0;p=c[p+4>>2]|0;n=z0(g|0,j|0,0,600)|0;m=z;if((j>>>0<300|(j|0)==300&g>>>0<0)&(p>>>0>300|(p|0)==300&o>>>0>0)){j=k;c[j>>2]=n;c[j+4>>2]=m;j=m;g=n}a:do if(j>>>0>p>>>0|(j|0)==(p|0)&g>>>0>o>>>0){j=D_(g|0,j|0,o|0,p|0)|0;k=z;p=u+104|0;g=u+88|0;g=D_(c[p>>2]|0,c[p+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0)|0;p=z;m=k>>>0>q>>>0|(k|0)==(q|0)&j>>>0>t>>>0;t=m?j:t;q=m?k:q;m=z0(r|0,s|0,1,0)|0;n=z;o=z0(j|0,k|0,w|0,x|0)|0;r=z;p=z0(g|0,p|0,A|0,B|0)|0;s=z;a[H>>0]=0;i=+(j>>>0)+4294967296.0*+(k>>>0);h[u+72>>3]=i;if(((RA(d,6,-1)|0)!=0?(E=c[G>>2]|0,(a[E+2>>0]|0)!=0):0)?(F=UD(E+68|0,b[E>>1]|0)|0,(F|0)!=(E+72|0)):0){k=F+36|0;i=i/27.0e3;g=0;while(1){B=c[y>>2]|0;j=c[B+4>>2]|0;if(g>>>0>=(c[B+8>>2]|0)-j>>1>>>0){k=r;j=p;g=s;break a}b[D>>1]=b[j+(g<<1)>>1]|0;if(a[($C(k,D)|0)+80>>0]|0)KW(d,6,c[($C(k,D)|0)+64>>2]|0,37,i,6,1);g=g+1|0}}else{k=r;j=p;g=s}}else{m=r;n=s;o=w;k=x;j=A;g=B}while(0);u=c[y>>2]|0;p=u+152|0;B=c[p+4>>2]|0;u=u+144|0;u=C|((c[u>>2]|0)!=0|(c[u+4>>2]|0)!=0);v=v|(B>>>0>0|(B|0)==0&(c[p>>2]|0)>>>0>3);p=g}else{u=C;m=r;n=s;o=w;k=x;j=A;p=B}g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;break}else f=g}else{f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}C=u;g=c[G>>2]|0;r=m;s=n;w=o;x=k;A=j;B=p}if(!((t|0)==0&(q|0)==0))KW(d,0,0,92,(+(t>>>0)+4294967296.0*+(q>>>0))/27.0e3,6,1);if(((r|0)!=0|(s|0)!=0)&((w|0)!=0|(x|0)!=0)&((A|0)!=0|(B|0)!=0)){G=PZ(A|0,B|0,3)|0;KW(d,0,0,103,(+(G>>>0)+4294967296.0*+(z>>>0))/((+(w>>>0)+4294967296.0*+(x>>>0))/27.0e6),0,1);G=D_(A|0,B|0,r|0,s|0)|0;G=PZ(G|0,z|0,3)|0;i=+(G>>>0)+4294967296.0*+(z>>>0);G=UW(r|0,s|0,13500,0)|0;H=z;F=z0(w|0,x|0,G|0,H|0)|0;sN(d,0,0,378353,i/((+(F>>>0)+4294967296.0*+(z>>>0))/27.0e6),0,1);Ou(d,0,0,378353,382945);F=z0(A|0,B|0,r|0,s|0)|0;F=PZ(F|0,z|0,3)|0;i=+(F>>>0)+4294967296.0*+(z>>>0);H=D_(w|0,x|0,G|0,H|0)|0;sN(d,0,0,378382,i/((+(H>>>0)+4294967296.0*+(z>>>0))/27.0e6),0,1);Ou(d,0,0,378382,382945)}do if(!v)if(C){RB(d,0,0,101,384431,-1,1,1);break}else{Ed(d,0,0,101);break}else RB(d,0,0,101,384435,-1,1,1);while(0);l=I;return}function gf(d){d=d|0;var e=0.0,f=0.0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;E=l;l=l+96|0;u=E+76|0;k=E+85|0;B=E+64|0;C=E+52|0;A=E+48|0;D=E+44|0;r=E+40|0;s=E+36|0;y=E+32|0;m=E+28|0;n=E+24|0;o=E+20|0;p=E+16|0;x=E+8|0;q=E+82|0;v=E+80|0;w=E+84|0;j=E;bB(d,k);jB(d,u);TX(B);TX(C);pY(c[u>>2]|0,0,0,w);k=(a[k>>0]|0)==0;if(k){ID(d,j);h=c[j>>2]|0;if(h|0)__(B,h)|0}else{oz(d,j);i=j;h=c[i>>2]|0;i=c[i+4>>2]|0;if(!((h|0)==0&(i|0)==0))mZ(B,h,i)|0}if(k){ID(d,j);h=c[j>>2]|0;if(h|0)__(C,h)|0}else{oz(d,j);i=j;h=c[i>>2]|0;i=c[i+4>>2]|0;if(!((h|0)==0&(i|0)==0))mZ(C,h,i)|0}u=d+788|0;ID(d,u);h=d+528|0;i=h;i=z0(c[i>>2]|0,c[i+4>>2]|0,4,0)|0;t=h;c[t>>2]=i;c[t+4>>2]=z;if(k){ID(d,j);t=x;c[t>>2]=c[j>>2];c[t+4>>2]=0}else oz(d,x);t=d+824|0;j=h;j=z0(c[j>>2]|0,c[j+4>>2]|0,10,0)|0;k=h;c[k>>2]=j;c[k+4>>2]=z;NB(d,v);NB(d,q);k=h;k=z0(c[k>>2]|0,c[k+4>>2]|0,2,0)|0;q=h;c[q>>2]=k;c[q+4>>2]=z;GC(d);hy(d,16,A);hy(d,16,D);hy(d,2,r);hy(d,16,s);hy(d,16,y);hy(d,2,m);hy(d,16,n);hy(d,16,o);hy(d,2,p);J3(d);o=d+792|0;hy(d,16,o);m=d+796|0;hy(d,16,m);if(qO(d)|0){n=d+916|0;i=wD(n,-1)|0;if((i|0)!=(d+920|0)){nf(bF(n,u)|0,i+24|0)|0;j=c[i+36>>2]|0;k=i+40|0;h=c[k>>2]|0;while(1){if((h|0)==(j|0))break;s=h+-4|0;c[k>>2]=s;h=s}fy(n,i)}h=a[w>>0]|0;a[(bF(n,u)|0)+274>>0]=h;h=b[v>>1]|0;i=d+16|0;j=d+20|0;if(h<<16>>16)_M(d,c[i>>2]|0,c[j>>2]|0,377014,h);h=c[t>>2]|0;if(h|0){t=c[i>>2]|0;v=c[j>>2]|0;w=x;w=cT((+((c[w>>2]|0)>>>0)+4294967296.0*+((c[w+4>>2]|0)>>>0))*1.0e3/+(h>>>0))|0;VL(d,t,v,w,z,0)}Mc(d,c[i>>2]|0,c[j>>2]|0,377029,B,0);Mc(d,c[i>>2]|0,c[j>>2]|0,377042,C,0);lL(d,c[i>>2]|0,c[j>>2]|0,10,c[u>>2]|0,10,1);w=x;v=c[w>>2]|0;w=c[w+4>>2]|0;x=(bF(n,u)|0)+184|0;c[x>>2]=v;c[x+4>>2]=w;f=+g[m>>2]*+g[y>>2];e=+g[A>>2];if(f!=0.0)g[d+800>>2]=e*+g[o>>2]/f;f=+K(+(+g[D>>2]),+e)*180.0/3.14159;g[d+804>>2]=f<0.0?f+360.0:f}z5(C);z5(B);l=E;return}function hf(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+16|0;g=p+4|0;i=p+3|0;j=p+2|0;k=p+1|0;m=p;Bx(b);h=b+648|0;d4(c[h>>2]|0,22);xR(b,8,g);e=b+773|0;f=b+769|0;g=a[g>>0]|0;if(!(a[e>>0]|0)){a[f>>0]=g;a[e>>0]=1;e=g}else{e=(a[f>>0]|0)+1<<24>>24;a[f>>0]=e}a:do if(g<<24>>24==e<<24>>24){GC(b);KS(b);RS(b);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);e=b+770|0;xR(b,3,e);if((a[e>>0]|0)!=7){A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0)}J3(b);if((a[e>>0]|0)==7){GC(b);a[j>>0]=0;a[k>>0]=0;a[m>>0]=0;xR(b,3,i);switch(a[i>>0]|0){case 0:break;case 1:{GC(b);xR(b,3,e);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);KS(b);RS(b);RS(b);RS(b);J3(b);break}default:{wK(b);n=b+536|0;o=b+528|0;e1(b,D_(c[n>>2]|0,c[n+4>>2]|0,c[o>>2]|0,c[o+4>>2]|0)|0,z);break a}}GC(b);d4(c[h>>2]|0,3);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);RS(b);RS(b);KS(b);J3(b);J3(b);A6(c[h>>2]|0);d4(c[h>>2]|0,2);GC(b);xR(b,4,j);xR(b,4,k);a[k>>0]=((a[k>>0]|0)+1&255)<<2;KS(b);xR(b,4,m);a[m>>0]=d[m>>0]<<2;J3(b);e=a[j>>0]|0;f=b+771|0;if(e<<24>>24==15){GC(b);xR(b,8,f);xR(b,8,b+772|0);J3(b)}else{m=e&255;a[f>>0]=a[380945+m>>0]|0;a[b+772>>0]=a[380961+m>>0]|0}}wK(b);k=b+536|0;m=b+528|0;m=D_(c[k>>2]|0,c[k+4>>2]|0,c[m>>2]|0,c[m+4>>2]|0)|0;e1(b,m,z);if((qO(b)|0?(m=b+312|0,n=m,n=z0(c[n>>2]|0,c[n+4>>2]|0,1,0)|0,o=z,m,c[m>>2]=n,c[m+4>>2]=o,(c[b+728>>2]&2|0)==0):0)?(m=b+760|0,k=c[m+4>>2]|0,!(o>>>0<k>>>0|((o|0)==(k|0)?n>>>0<(c[m>>2]|0)>>>0:0))):0){W5(b);V5(b)}}else{t4(b);Kl(b)}while(0);l=p;return}function jf(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;p=b+612|0;t=b+544|0;u=b+804|0;v=b+773|0;w=b+792|0;x=b+816|0;o=c[b+548>>2]|0;e=c[p>>2]|0;a:while(1){n=e+4|0;f=n>>>0>o>>>0;if(f){A=64;break}q=c[t>>2]|0;m=q+e|0;if((R4(a[m>>0]|0,a[m+1>>0]|0,a[m+2>>0]|0)|0)!=1){A=64;break}h=a[q+(e+3)>>0]|0;l=h&255;i=c[u>>2]|0;j=e+8|0;if(a[i+(l*120|0)+116>>0]|0){if(h<<24>>24!=-67){e=1;break}if(!(a[w>>0]|0)){e=1;break}f=e+9|0;if(f>>>0>=o>>>0){e=0;break}f=(d[q+j>>0]|0)+f|0;if(f>>>0>=o>>>0){e=0;break}f=d[q+f>>0]|0;g=c[x>>2]|0;if(!(c[g+(f*120|0)+104>>2]|0)){e=1;break}if(a[g+(f*120|0)+116>>0]|0){e=1;break}}k=e+6|0;b:do if(a[i+(l*120|0)+118>>0]|0){switch(h<<24>>24){case -1:case -8:case -14:case -15:case -16:case -65:case -66:case -68:case -69:case -70:case -71:break b;default:{}}switch(a[v>>0]|0){case 1:{g=k;break}case 2:{if(j>>>0>o>>>0){e=0;break a}if((d[q+(e+7)>>0]|0)>63){e=1;break a}else break b}default:break b}while(1){f=g;g=g+1|0;h=q+f|0;if(f>>>0>=o>>>0){f=0;break}if((a[h>>0]|0)!=-1){f=1;break}if((f+2|0)>>>0>=o>>>0){e=0;break a}}if(g>>>0>=o>>>0){e=0;break a}if(f?(d[h>>0]|0)>15:0){e=1;break a}}while(0);if((l+-185|0)>>>0<2){e=n;c:while(1){c[p>>2]=e;d:while(1){if((e+4|0)>>>0>o>>>0)break c;n=q+e|0;if((R4(a[n>>0]|0,a[n+1>>0]|0,a[n+2>>0]|0)|0)==1?(d[q+(e+3)>>0]|0)>=185:0)break c;while(1){f=e+2|0;c[p>>2]=f;if(f>>>0>=o>>>0)break d;if(!(a[q+f>>0]|0))break;else e=f}e=e+1|0;if(!(a[q+e>>0]|0))continue c;else e=f}e=e+1|0}if((e+4|0)>>>0<=o>>>0)continue;if((e+3|0)==(o|0)?(n=q+e|0,y=e+1|0,(R4(a[n>>0]|0,a[n+1>>0]|0,a[n+2>>0]|0)|0)!=1):0){c[p>>2]=y;e=y}if((e+2|0)==(o|0)?(n=q+e|0,z=e+1|0,(d7(a[n>>0]|0,a[n+1>>0]|0)|0)<<16>>16!=0):0){c[p>>2]=z;e=z}if((e+1|0)!=(o|0))continue;if(!((D9(a[q+e>>0]|0)|0)<<24>>24))continue;e=e+1|0;c[p>>2]=e;continue}if(k>>>0>=o>>>0){e=0;break}f=m+4|0;f=d7(a[f>>0]|0,a[f+1>>0]|0)|0;if(!(f<<16>>16))f=6;else{f=(f&65535)+6|0;while(1){e=f+e|0;c[p>>2]=e;if(e>>>0>=o>>>0)break;if((a[q+e>>0]|0)==-1)f=1;else break}while(1){if((e+3|0)>>>0>o>>>0)continue a;if(a[q+(e+2)>>0]|0)continue a;f=e+1|0;if(a[q+f>>0]|0)continue a;if(a[q+e>>0]|0)continue a;c[p>>2]=f;e=f}}while(1){e=e+f|0;c[p>>2]=e;f=e+4|0;if(f>>>0>o>>>0)break;n=q+e|0;if((R4(a[n>>0]|0,a[n+1>>0]|0,a[n+2>>0]|0)|0)!=1){f=1;continue}if((d[q+(e+3)>>0]|0)>=185)break;else f=1}if(f>>>0<=o>>>0)continue;if((e+3|0)==(o|0)?(n=q+e|0,r=e+1|0,(R4(a[n>>0]|0,a[n+1>>0]|0,a[n+2>>0]|0)|0)!=1):0){c[p>>2]=r;e=r}if((e+2|0)==(o|0)?(n=q+e|0,s=e+1|0,(d7(a[n>>0]|0,a[n+1>>0]|0)|0)<<16>>16!=0):0){c[p>>2]=s;e=s}if((e+1|0)!=(o|0))continue;if(!((D9(a[q+e>>0]|0)|0)<<24>>24))continue;e=e+1|0;c[p>>2]=e}if((A|0)==64)if((e+3|0)==(o|0))e=0;else{if(!f)t4(b);a[b+376>>0]=0;e=nb[c[(c[b>>2]|0)+64>>2]&255](b)|0}return e|0}function kf(b){b=b|0;var d=0,e=0.0,f=0.0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0;q=l;l=l+32|0;p=q+12|0;o=q;g=b+804|0;d=0;while(1){if((d|0)==256)break;Qg(b,d,(c[g>>2]|0)+(d*120|0)|0,0);d=d+1|0}g=b+816|0;d=0;while(1){if((d|0)==256)break;Qg(b,d,(c[g>>2]|0)+(d*120|0)|0,1);d=d+1|0}h=b+828|0;i=b+20|0;g=b+492|0;d=0;while(1){if((d|0)==256)break;Qg(b,d,(c[h>>2]|0)+(d*120|0)|0,2);switch(d|0){case 113:case 118:{n=c[h>>2]|0;if(((c[n+(d*120|0)+28>>2]|0)!=(c[n+(d*120|0)+32>>2]|0)?c[n+13784>>2]|0:0)?(RB(b,2,c[i>>2]|0,44,378218,-1,1,0),(a[g>>0]|0)==0):0)RB(b,2,c[i>>2]|0,45,378235,-1,1,0);break}default:{}}d=d+1|0}if(RA(b,1,-1)|0){$x(p,b,1,0,300,1);zb(b,0,0,273,p,0);z5(p)}j=b+860|0;k=b+864|0;if((c[k>>2]|0)-(c[j>>2]|0)>>3>>>0>11?($x(p,b,1,0,171,1),n=+Eq(p)>30.0,z5(p),n):0){Ye(c[j>>2]|0,c[k>>2]|0);m=c[j>>2]|0;wI(j,m,m+32|0);LI(j,((c[k>>2]|0)-(c[j>>2]|0)>>3)+-4|0);c[p>>2]=0;m=p+4|0;c[m>>2]=0;c[p+8>>2]=0;n=p+8|0;i=1;d=0;while(1){h=c[j>>2]|0;g=h;if(i>>>0>=(c[k>>2]|0)-h>>3>>>0)break;h=g+(i<<3)|0;g=g+(i+-1<<3)|0;g=D_(c[h>>2]|0,c[h+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0)|0;h=z;r=o;c[r>>2]=g;c[r+4>>2]=h;if(d>>>0<(c[n>>2]|0)>>>0){r=d;c[r>>2]=g;c[r+4>>2]=h;d=d+8|0;c[m>>2]=d}else{Px(p,o);d=c[m>>2]|0}i=i+1|0}Ye(c[p>>2]|0,d);r=c[p>>2]|0;wI(p,r,r+8|0);LI(p,((c[m>>2]|0)-(c[p>>2]|0)>>3)+-1|0);r=c[p>>2]|0;n=r;s=+((c[n>>2]|0)>>>0)+4294967296.0*+((c[n+4>>2]|0)>>>0);r=r+(((c[m>>2]|0)-r>>3)+-1<<3)|0;f=+((c[r>>2]|0)>>>0)+4294967296.0*+((c[r+4>>2]|0)>>>0);if(s*.9<f&s*1.1>f?(n=c[j>>2]|0,r=((c[k>>2]|0)-n>>3)+-1|0,n,m=n+(r<<3)|0,n,n=D_(c[m>>2]|0,c[m+4>>2]|0,c[n>>2]|0,c[n+4>>2]|0)|0,e=(+(n>>>0)+4294967296.0*+(z>>>0))/+(r>>>0)/90.0,e!=0.0):0){e=1.0e3/e;$x(o,b,1,0,197,1);d=i9(38184)|0;r=a[o+8+3>>0]|0;if((d|0)==((r<<24>>24<0?c[o+4>>2]|0:r&255)|0))d=(VG(o,38184,d)|0)==0;else d=0;z5(o);e=d?e*.5:e;$x(o,b,1,0,171,1);f=+Eq(o);z5(o);if((!(f>=e*.9)|!(f<=e*1.1)?!(e>=f*.9)|!(e<=f*1.1):0)?(Ed(b,1,0,171),KW(b,1,0,171,e,3,1),f!=0.0):0)KW(b,1,0,181,f,3,0)}aU(p)}do if((RA(b,1,-1)|0)==1){$x(p,b,1,0,23,1);d=i9(40212)|0;r=a[p+8+3>>0]|0;if((d|0)!=((r<<24>>24<0?c[p+4>>2]|0:r&255)|0)){z5(p);break}r=(VG(p,40212,d)|0)==0;z5(p);if(r)RB(b,0,0,69,378277,-1,1,1)}while(0);l=q;return}function lf(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;a:do if((a[b+768>>0]|0)==0?(a[b+769>>0]|0)==0:0){m=b+612|0;g=b+548|0;f=b+376|0;d=c[m>>2]|0;while(1){e=c[g>>2]|0;if((d+8|0)>>>0>e>>>0){l=e;break}if(!(Oh(b)|0)){d=0;break a}d=c[m>>2]|0;if(a[f>>0]|0){h=7;break}d=d+1|0;c[m>>2]=d}if((h|0)==7)l=c[g>>2]|0;g=b+544|0;f=d+-16|0;e=d>>>0>15;if((d+8|0)>>>0<=l>>>0){if(!e){d=1;break}e=c[g>>2]|0;if((a[e+f>>0]|0)!=1){d=1;break}if((a[e+(d+-15)>>0]|0)!=16){d=1;break}if(a[e+(d+-14)>>0]|0){d=1;break}l=a[e+(d+-13)>>0]|0;if(!((l&255)<96&(l&14)<10)){d=1;break}if(a[e+(d+-12)>>0]|0){d=1;break}l=a[e+(d+-11)>>0]|0;if(!((l&255)<96&(l&14)<10)){d=1;break}if(a[e+(d+-10)>>0]|0){d=1;break}l=a[e+(d+-9)>>0]|0;if(!((l&255)<96&(l&14)<10)){d=1;break}if(a[e+(d+-8)>>0]|0){d=1;break}l=a[e+(d+-7)>>0]|0;if(!((l&255)<64&(l&14)<10)){d=1;break}a[b+1564>>0]=1;c[m>>2]=f;d=b+760|0;m=d;l=c[m+4>>2]|0;if(!(l>>>0<0|(l|0)==0&(c[m>>2]|0)>>>0<1e4)){d=1;break}c[d>>2]=1e4;c[d+4>>2]=0;d=1;break}b=b+312|0;if((c[b>>2]|0)==0&(c[b+4>>2]|0)==0){c[m>>2]=e?f:0;d=0;break}b:do if((d+7|0)==(l|0)?(i=(c[g>>2]|0)+d|0,b=i+4|0,(R4(a[b>>0]|0,a[b+1>>0]|0,a[b+2>>0]|0)|0)!=16282223):0){e=d7(a[i>>0]|0,a[i+1>>0]|0)|0;if(e<<16>>16<30475)switch(e<<16>>16){case 2935:break b;default:{}}else switch(e<<16>>16){case 30475:break b;default:{}}d=d+1|0;c[m>>2]=d}while(0);c:do if((d+6|0)==(l|0)?(j=(c[g>>2]|0)+d|0,b=j+4|0,(d7(a[b>>0]|0,a[b+1>>0]|0)|0)<<16>>16!=-1934):0){e=d7(a[j>>0]|0,a[j+1>>0]|0)|0;if(e<<16>>16<30475)switch(e<<16>>16){case 2935:break c;default:{}}else switch(e<<16>>16){case 30475:break c;default:{}}d=d+1|0;c[m>>2]=d}while(0);d:do if((d+5|0)==(l|0)?(k=(c[g>>2]|0)+d|0,(D9(a[k+4>>0]|0)|0)<<24>>24!=-8):0){e=d7(a[k>>0]|0,a[k+1>>0]|0)|0;if(e<<16>>16<30475)switch(e<<16>>16){case 2935:break d;default:{}}else switch(e<<16>>16){case 30475:break d;default:{}}d=d+1|0;c[m>>2]=d}while(0);e:do if((d+4|0)==(l|0)){e=(c[g>>2]|0)+d|0;e=d7(a[e>>0]|0,a[e+1>>0]|0)|0;if(e<<16>>16<30475)switch(e<<16>>16){case 2935:break e;default:{}}else switch(e<<16>>16){case 30475:break e;default:{}}d=d+1|0;c[m>>2]=d}while(0);f:do if((d+3|0)==(l|0)){e=(c[g>>2]|0)+d|0;e=d7(a[e>>0]|0,a[e+1>>0]|0)|0;if(e<<16>>16<30475)switch(e<<16>>16){case 2935:break f;default:{}}else switch(e<<16>>16){case 30475:break f;default:{}}d=d+1|0;c[m>>2]=d}while(0);g:do if((d+2|0)==(l|0)){e=(c[g>>2]|0)+d|0;e=d7(a[e>>0]|0,a[e+1>>0]|0)|0;if(e<<16>>16<30475)switch(e<<16>>16){case 2935:break g;default:{}}else switch(e<<16>>16){case 30475:break g;default:{}}d=d+1|0;c[m>>2]=d}while(0);if((d+1|0)==(l|0)){switch((D9(a[(c[g>>2]|0)+d>>0]|0)|0)<<24>>24){case 119:case 11:{d=0;break a}default:{}}c[m>>2]=l;d=0}else d=0}else d=1;while(0);return d|0}function mf(f){f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+48|0;o=v+36|0;i=v+24|0;j=v+12|0;k=v;n=f+1096|0;if((c[n>>2]|0)==0?(c[f+976>>2]|0)>>>0>1:0){Xy(o,40136);vF(f+908|0,o)|0;z5(o)}r=f+760|0;RV(r);RB(f,2,0,18,391443,-1,1,0);p=f+1112|0;RB(f,2,0,23,c[15392+(d[p>>0]<<2)>>2]|0,-1,1,0);q=f+1113|0;RB(f,2,0,24,c[15408+(d[q>>0]<<2)>>2]|0,-1,1,0);m=f+1116|0;g=a[m>>0]|0;if((g+-1&255)<3){RB(f,2,0,27,c[16044+((g&255)<<2)>>2]|0,-1,1,0);RB(f,2,0,32,c[16044+(d[m>>0]<<2)>>2]|0,-1,1,0)}g=f+1117|0;h=a[g>>0]|0;if((h+-1&255)<3){RB(f,2,0,27,c[16060+((h&255)<<2)>>2]|0,-1,1,0);RB(f,2,0,33,c[16060+(d[g>>0]<<2)>>2]|0,-1,1,0)}g=f+1118|0;h=a[g>>0]|0;if((h+-1&255)<3){RB(f,2,0,27,c[16076+((h&255)<<2)>>2]|0,-1,1,0);RB(f,2,0,34,c[16076+(d[g>>0]<<2)>>2]|0,-1,1,0)}VU(j,c[15360+(d[p>>0]<<2)>>2]|0);VU(k,c[15376+(d[q>>0]<<2)>>2]|0);g=a[k+8+3>>0]|0;h=g<<24>>24<0;Ex(j,h?c[k>>2]|0:k,h?c[k+4>>2]|0:g&255)|0;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];g=0;while(1){if((g|0)==3)break;c[j+(g<<2)>>2]=0;g=g+1|0}p2(o,i);zb(f,2,0,52,o,0);z5(o);O0(i);z5(k);z5(j);VU(j,c[16092+(d[p>>0]<<2)>>2]|0);VU(k,c[16108+(d[q>>0]<<2)>>2]|0);g=a[k+8+3>>0]|0;h=g<<24>>24<0;Ex(j,h?c[k>>2]|0:k,h?c[k+4>>2]|0:g&255)|0;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];g=0;while(1){if((g|0)==3)break;c[j+(g<<2)>>2]=0;g=g+1|0}p2(o,i);zb(f,2,0,53,o,1);z5(o);O0(i);z5(k);z5(j);kL(f,2,0,135,b[61002+(d[p>>0]<<3)+(d[f+1115>>0]<<1)>>1]|0,10,0);g=a[m>>0]|0;if((g&255)<4){kL(f,2,0,122,b[61546+((g&255)<<1)>>1]|0,10,0);RB(f,2,0,59,c[16044+(d[m>>0]<<2)>>2]|0,-1,1,0)}h=f+908|0;do if(!(c[n>>2]|0)){g=i9(40136)|0;n=a[f+916+3>>0]|0;if((g|0)==((n<<24>>24<0?c[f+912>>2]|0:n&255)|0)?(VG(h,40136,g)|0)==0:0)break;Xy(o,40152);vF(h,o)|0;z5(o);q=(e[60490+(d[p>>0]<<7)+(d[q>>0]<<5)+(d[f+1114>>0]<<1)>>1]|0)*1e3|0;g=f+1108|0;c[g>>2]=q;lL(f,0,0,103,q,10,0);lL(f,2,0,112,c[g>>2]|0,10,0);if((a[f+905>>0]|0?(t=f+560|0,s=c[t>>2]|0,t=c[t+4>>2]|0,t>>>0>0|(t|0)==0&s>>>0>10):0)?(u=c[g>>2]|0,u|0):0){t=UW(s|0,t|0,8e3,0)|0;u=g5(t|0,z|0,u|0,0)|0;oK(f,2,0,156,u,z,0,0);RB(f,2,0,165,388261,-1,1,0)}}while(0);zb(f,2,0,110,h,0);zb(f,2,0,114,f+932|0,0);zb(f,2,0,116,f+920|0,0);bv(r);l=v;return}function nf(a,d){a=a|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;k1(a,d)|0;if((a|0)==(d|0)){i=a+24|0;ZI(i,i)|0}else{wp(a+12|0,c[d+12>>2]|0,c[d+16>>2]|0);ZI(a+24|0,d+24|0)|0;g=a+36|0;f=d+36|0;c[g>>2]=c[f>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];c[g+12>>2]=c[f+12>>2];c[g+16>>2]=c[f+16>>2];c[g+20>>2]=c[f+20>>2];c[g+24>>2]=c[f+24>>2];Qn(a+64|0,c[d+64>>2]|0,c[d+68>>2]|0);yp(a+76|0,c[d+76>>2]|0,c[d+80>>2]|0);yp(a+88|0,c[d+88>>2]|0,c[d+92>>2]|0);yp(a+100|0,c[d+100>>2]|0,c[d+104>>2]|0);yp(a+112|0,c[d+112>>2]|0,c[d+116>>2]|0);g=d+128|0;f=c[g+4>>2]|0;e=a+128|0;c[e>>2]=c[g>>2];c[e+4>>2]=f;yp(a+136|0,c[d+136>>2]|0,c[d+140>>2]|0);yp(a+148|0,c[d+148>>2]|0,c[d+152>>2]|0);e=a+160|0;f=d+160|0;g=e;h=f;i=g+116|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(i|0));b[e+116>>1]=b[f+116>>1]|0;wp(a+280|0,c[d+280>>2]|0,c[d+284>>2]|0);wp(a+292|0,c[d+292>>2]|0,c[d+296>>2]|0);wp(a+304|0,c[d+304>>2]|0,c[d+308>>2]|0);wp(a+316|0,c[d+316>>2]|0,c[d+320>>2]|0);wp(a+328|0,c[d+328>>2]|0,c[d+332>>2]|0);wp(a+340|0,c[d+340>>2]|0,c[d+344>>2]|0);wp(a+352|0,c[d+352>>2]|0,c[d+356>>2]|0);wp(a+364|0,c[d+364>>2]|0,c[d+368>>2]|0);wp(a+376|0,c[d+376>>2]|0,c[d+380>>2]|0);wp(a+388|0,c[d+388>>2]|0,c[d+392>>2]|0)}i=a+400|0;h=d+400|0;c[i>>2]=c[h>>2];c[i+4>>2]=c[h+4>>2];c[i+8>>2]=c[h+8>>2];return a|0}function of(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+16|0;m=q;n=e+840|0;g=a[n>>0]|0;i=g&255;o=e+804|0;f=c[o>>2]|0;p=e+793|0;a:do if(!(c[f+(i*120|0)+104>>2]|0)){g=e+760|0;do if(a[g>>0]|0){h=e+794|0;if((a[p>>0]|0)==-1?(a[h>>0]|0)==-1:0){a[p>>0]=1;b[h>>1]=0;b[h+2>>1]=0;a[h+4>>0]=0;a[f+(i*120|0)+12>>0]=a[e+761>>0]|0;break}if(!(a[e+492>>0]|0)){a[p>>0]=255;a[p+1>>0]=255;a[p+2>>0]=255;a[p+3>>0]=255;a[p+4>>0]=255;a[p+5>>0]=255;a[g>>0]=0}}while(0);if((c[e+728>>2]&1|0)==0?(W5(e),(a[e+492>>0]|0)==0):0)RB(e,0,0,57,378150,-1,1,0);i=d[n>>0]|0;j=c[o>>2]|0;k=j+(i*120|0)+104|0;c[k>>2]=(c[k>>2]|0)+1;k=e+880|0;h=c[k>>2]|0;c[j+(i*120|0)+112>>2]=h;c[k>>2]=h+1;k=j+(i*120|0)+28|0;switch(a[j+(i*120|0)+12>>0]|0){case -128:case 2:case 1:{f=C0()|0;c[m>>2]=f;g=j+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[j+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(k,m);break}case 16:{f=N2()|0;c[m>>2]=f;g=j+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[j+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(k,m);break}case 27:{f=C3()|0;c[m>>2]=f;g=j+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[j+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(k,m);break}case 39:case 36:{f=v3()|0;c[m>>2]=f;g=j+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[j+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(k,m);break}default:{f=C0()|0;c[m>>2]=f;g=j+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[j+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(k,m);f=d[n>>0]|0;g=c[o>>2]|0;h=C3()|0;c[m>>2]=h;i=g+(f*120|0)+32|0;j=c[i>>2]|0;if(j>>>0<(c[g+(f*120|0)+36>>2]|0)>>>0){c[j>>2]=h;c[i>>2]=(c[i>>2]|0)+4}else Yy(g+(f*120|0)+28|0,m);f=d[n>>0]|0;g=c[o>>2]|0;h=v3()|0;c[m>>2]=h;i=g+(f*120|0)+32|0;j=c[i>>2]|0;if(j>>>0<(c[g+(f*120|0)+36>>2]|0)>>>0){c[j>>2]=h;c[i>>2]=(c[i>>2]|0)+4}else Yy(g+(f*120|0)+28|0,m);f=d[n>>0]|0;g=c[o>>2]|0;h=N2()|0;c[m>>2]=h;i=g+(f*120|0)+32|0;j=c[i>>2]|0;if(j>>>0<(c[g+(f*120|0)+36>>2]|0)>>>0){c[j>>2]=h;c[i>>2]=(c[i>>2]|0)+4}else Yy(g+(f*120|0)+28|0,m)}}i=e+734|0;h=0;while(1){g=a[n>>0]|0;m=g&255;f=c[o>>2]|0;j=c[f+(m*120|0)+28>>2]|0;if(h>>>0>=(c[f+(m*120|0)+32>>2]|0)-j>>2>>>0)break a;m=c[j+(h<<2)>>2]|0;a[m+734>>0]=a[i>>0]|0;aY(e,m);h=h+1|0}}while(0);ee(e,f+((g&255)*120|0)|0,p);l=q;return}function pf(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;G=l;l=l+96|0;j=G+76|0;p=G+72|0;r=G+80|0;t=G+82|0;v=G+60|0;C=G+48|0;D=G+36|0;E=G+24|0;F=G+12|0;k=G;m=d+764|0;n=d+776|0;o=d+778|0;B=$C((HD((c[m>>2]|0)+68|0,n)|0)+16|0,o)|0;q=d+789|0;KI(kC(B+88|0,q)|0);a[B+100>>0]=1;a[(c[m>>2]|0)+121>>0]=1;NB(d,n);B=a[q>>0]|0;if(B<<24>>24==78|(B&-16)<<24>>24==80)b[n>>1]=b[c[m>>2]>>1]|0;s=d+528|0;h=s;h=z0(c[h>>2]|0,c[h+4>>2]|0,4,0)|0;e=z;u=s;c[u>>2]=h;c[u+4>>2]=e;u=d+536|0;g=u;f=c[g>>2]|0;g=c[g+4>>2]|0;a:do if(!((h|0)==(f|0)&(e|0)==(g|0))){w=d+786|0;x=d+770|0;y=d+796|0;A=k+8+3|0;B=k+4|0;i=d+648|0;while(1){if(!(e>>>0<g>>>0|(e|0)==(g|0)&h>>>0<f>>>0))break a;GC(d);NB(d,w);NB(d,r);jB(d,j);jB(d,p);Bx(d);xR(d,3,t);A6(c[i>>2]|0);sR(d,12,x);wK(d);a[y>>0]=1;if(b[x>>1]|0)Ao(d);J3(d);if(qO(d)|0){f=UB(kC(($C((HD((c[m>>2]|0)+68|0,n)|0)+16|0,o)|0)+88|0,q)|0,w)|0;ci(F,b[r>>1]|0);DW(F,0,42232)|0;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];e=0;while(1){if((e|0)==3)break;c[F+(e<<2)>>2]=0;e=e+1|0}HX(E,42252)|0;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];e=0;while(1){if((e|0)==3)break;c[E+(e<<2)>>2]=0;e=e+1|0}Qh(k,c[j>>2]|0);e=a[A>>0]|0;h=e<<24>>24<0;Ex(D,h?c[k>>2]|0:k,h?c[B>>2]|0:e&255)|0;c[C>>2]=c[D>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];e=0;while(1){if((e|0)==3)break;c[D+(e<<2)>>2]=0;e=e+1|0}p2(v,C);vF(f,v)|0;z5(v);O0(C);z5(k);O0(D);O0(E);z5(F);Qh(v,c[p>>2]|0);vF(f+12|0,v)|0;z5(v);e=a[t>>0]|0;if(e<<24>>24){VU(v,c[41612+((e&255)<<2)>>2]|0);vF(f+60|0,v)|0;z5(v)}}h=s;f=u;e=c[h+4>>2]|0;g=c[f+4>>2]|0;h=c[h>>2]|0;f=c[f>>2]|0}}while(0);l=G;return}function qf(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;t=l;l=l+48|0;q=t+16|0;s=t+32|0;p=t+28|0;f=t+47|0;g=t+46|0;h=t+45|0;n=t+44|0;o=t;r=b+796|0;do if(!(a[b+760>>0]|0)){if(a[b+761>>0]|0){m=b+788|0;n=b+792|0;o=b+536|0;if((c[m>>2]|0)==(c[n>>2]|0)){bB(b,q);g=d[q>>0]|0;f=0;h=0;i=0;while(1){if((f|0)==(g|0))break;c[s>>2]=0;j=0;do{bB(b,p);k=a[p>>0]|0;j=j+(k&255)|0}while(k<<24>>24==-1);c[s>>2]=j;k=c[n>>2]|0;if((k|0)==(c[r>>2]|0))Yy(m,s);else{c[k>>2]=j;c[n>>2]=k+4}k=z0(j|0,0,h|0,i|0)|0;f=f+1|0;h=k;i=z}f=o;g=c[f>>2]|0;f=c[f+4>>2]|0;p=D_(-1,0,h|0,i|0)|0;f=z0(p|0,z|0,g|0,f|0)|0;c[s>>2]=f;g=c[n>>2]|0;if(g>>>0<(c[r>>2]|0)>>>0){c[g>>2]=f;c[n>>2]=g+4}else Yy(m,s)}s=o;Op(b,c[s>>2]|0,c[s+4>>2]|0);tU(q,0,16);BZ(c[b+508>>2]|0,c[b+668>>2]|0,0,0);z5(q);break}KK(b);bB(b,f);bB(b,g);k=d[g>>0]|0;pY(k,0,0,b+770|0);pY(k,0,2,b+771|0);Uy(b,q);bD(b,s);bD(b,p);k=b+528|0;f=k;f=z0(c[f>>2]|0,c[f+4>>2]|0,4,0)|0;c[k>>2]=f;c[k+4>>2]=z;bB(b,h);k=b+788|0;f=c[k>>2]|0;m=b+792|0;g=c[m>>2]|0;while(1){if((g|0)==(f|0))break;p=g+-4|0;c[m>>2]=p;g=p}c[o>>2]=0;if(f>>>0<(c[r>>2]|0)>>>0){c[f>>2]=0;c[m>>2]=f+4}else Yy(k,o);j=b+800|0;i=a[h>>0]|0;h=0;f=0;while(1){if((h&255)>=(i&255))break;bB(b,n);p=a[n>>0]|0;v=p&255;f=v+(f&65535)&65535;g=c[m>>2]|0;u=c[k>>2]|0;u=u+((g-u>>2)+-1<<2)|0;c[u>>2]=(c[u>>2]|0)+v;if(p<<24>>24==-1)g=0;else{c[o>>2]=0;if(g>>>0<(c[r>>2]|0)>>>0){c[g>>2]=0;c[m>>2]=g+4}else Yy(k,o);g=1}a[j>>0]=g;h=h+1<<24>>24}if(a[j>>0]|0)MI(k,((c[m>>2]|0)-(c[k>>2]|0)>>2)+-1|0);Op(b,(f&65535)+27+(i&255)|0,0);r=c[s>>2]|0;sU(o,r,16);BZ(c[b+508>>2]|0,c[b+668>>2]|0,r,0);z5(o);u=q;s=c[u>>2]|0;u=c[u+4>>2]|0;v=o;c[v>>2]=r;c[v+4>>2]=0;v=(pE(b+776|0,o)|0)+16|0;c[v>>2]=s;c[v+4>>2]=u}else{NB(b,q);g=b+788|0;h=c[g>>2]|0;i=b+792|0;f=c[i>>2]|0;while(1){if((f|0)==(h|0))break;v=f+-4|0;c[i>>2]=v;f=v}f=e[q>>1]|0;c[s>>2]=f;if(h>>>0<(c[r>>2]|0)>>>0){c[h>>2]=f;c[i>>2]=h+4}else Yy(g,s);Op(b,f+2|0,0);tU(s,0,16);BZ(c[b+508>>2]|0,c[b+668>>2]|0,0,0);z5(s)}while(0);l=t;return}function rf(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=l;l=l+16|0;e=s+3|0;f=s;g=s+2|0;q=d+792|0;a[q>>0]=0;h=d+536|0;p=h;o=c[p+4>>2]|0;if(!(o>>>0<0|(o|0)==0&(c[p>>2]|0)>>>0<4)){j=d+544|0;k=d+612|0;p=(c[j>>2]|0)+(c[k>>2]|0)+(c[d+528>>2]|0)|0;if((d7(a[p>>0]|0,a[p+1>>0]|0)|0)<<16>>16==2935)e=1;else{bB(d,e);n=a[e>>0]|0;o=d+788|0;p=d+785|0;a:do if(!((n&255)<16|(n&-32)<<24>>24==32)?!((n&255)>111&n<<24>>24>-1):0){do if(n<<24>>24==-128){e=(c[j>>2]|0)+(c[k>>2]|0)+1|0;if(!(R4(a[e>>0]|0,a[e+1>>0]|0,a[e+2>>0]|0)|0)){e=4;r=36;break a}else e=-128}else{e=n&-16;if(e<<24>>24==-96){e=h;t=c[e+4>>2]|0;if(!(t>>>0>0|(t|0)==0&(c[e>>2]|0)>>>0>6)){e=-96;break}if((a[(c[j>>2]|0)+((c[k>>2]|0)+6)>>0]|0)==-128){e=1;r=36;break a}else{e=-96;break}}if(n<<24>>24==-1){bB(d,g);NB(d,f);switch(a[g>>0]|0){case -112:case -96:case -95:{c[o>>2]=4;a[p>>0]=b[f>>1];e=1;break}default:e=0}break a}}while(0);bB(d,g);NB(d,f);if(a[g>>0]|0?(i=b[f>>1]|0,g=z0(i&65535|0,0,8,0)|0,f=z,t=h,h=c[t+4>>2]|0,!(f>>>0>h>>>0|((f|0)==(h|0)?g>>>0>(c[t>>2]|0)>>>0:0))):0){g=i&65535;b:do if(n<<24>>24<0&(n&255)<136){d=(c[j>>2]|0)+(c[k>>2]|0)|0;t=d+4+g|0;e=a[t>>0]|0;if(((d7(e,a[t+1>>0]|0)|0)<<16>>16!=2935?(m=a[d+3+g>>0]|0,(d7(m,e)|0)<<16>>16!=2935):0)?(d7(a[d+2+g>>0]|0,m)|0)<<16>>16!=2935:0){e=0;break a}}else switch((n&-8)<<24>>24){case -120:{e=(c[j>>2]|0)+(c[k>>2]|0)|0;if((C9(e+4+g|0)|0)==2147385345)break b;if((C9(e+3+g|0)|0)==2147385345)break b;if((C9(e+2+g|0)|0)==2147385345)break b;e=0;break a}case -104:{e=(c[j>>2]|0)+(c[k>>2]|0)|0;if((C9(e+4+g|0)|0)==2147385345)break b;if((C9(e+3+g|0)|0)==2147385345)break b;if((C9(e+2+g|0)|0)==2147385345)break b;e=0;break a}default:switch(e<<24>>24){case -80:{f=(c[j>>2]|0)+(c[k>>2]|0)|0;t=f+4+g|0;d=a[t>>0]|0;if((d7(d,a[t+1>>0]|0)|0)<<16>>16==2935)break b;e=a[f+3+g>>0]|0;if((d7(e,d)|0)<<16>>16==2935)break b;if((d7(a[f+2+g>>0]|0,e)|0)<<16>>16==2935)break b;e=0;break a}case -64:{f=(c[j>>2]|0)+(c[k>>2]|0)|0;t=f+4+g|0;d=a[t>>0]|0;if((d7(d,a[t+1>>0]|0)|0)<<16>>16==2935)break b;e=a[f+3+g>>0]|0;if((d7(e,d)|0)<<16>>16==2935)break b;if((d7(a[f+2+g>>0]|0,e)|0)<<16>>16==2935)break b;e=0;break a}default:{e=0;break a}}}while(0);a[q>>0]=1;c[o>>2]=4}r=37}else{e=1;r=36}while(0);if((r|0)==36){a[q>>0]=1;c[o>>2]=e;r=37}if((r|0)==37){a[p>>0]=n;e=1}}}else e=0;l=s;return e|0}function sf(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=l;l=l+1088|0;f=x+1072|0;g=x+1086|0;h=x+1085|0;q=x+1084|0;u=x+1083|0;v=x+1068|0;r=x+1064|0;w=x+1078|0;s=x+1076|0;k=x+1082|0;m=x+1081|0;n=x+1080|0;o=x+1060|0;p=x+1056|0;t=x;j=b+648|0;while(1){d=c[(c[j>>2]|0)+4>>2]|0;if(!(Z9(d)|0))break;uT(b,f);d=c[j>>2]|0;if((c[f>>2]|0)==1095521024){i=4;break}A6(d)}if((i|0)==4)d=c[d+4>>2]|0;if(Z9(d)|0){GC(b);G4(c[j>>2]|0,32);rR(b,32,v);rR(b,32,r);sR(b,16,w);xR(b,3,n);d4(c[j>>2]|0,3);A6(c[j>>2]|0);A6(c[j>>2]|0);sR(b,16,s);xR(b,8,m);xR(b,2,k);A6(c[j>>2]|0);d4(c[j>>2]|0,2);A6(c[j>>2]|0);d4(c[j>>2]|0,10);d4(c[j>>2]|0,2);A6(c[j>>2]|0);A6(c[j>>2]|0);A6(c[j>>2]|0);A6(c[j>>2]|0);AT(b,g);AT(b,h);AT(b,q);A6(c[j>>2]|0);G4(c[j>>2]|0,5);AT(b,u);if(a[g>>0]|0)d4(c[j>>2]|0,16);a:do if(a[h>>0]|0){f=e[w>>1]|0;g=~~+N(+(+M(+(+(f+1|0)))/.6931471805599453))&65535;d=0;while(1){if((d&255)>>>0>f>>>0)break a;G4(c[j>>2]|0,g);d=d+1<<24>>24}}while(0);d=c[j>>2]|0;f=(Z9(c[d+4>>2]|0)|0)&7;if(f|0)d4(d,f&255);wK(b);ID(b,o);ID(b,p);g=b+528|0;if((a[n>>0]|0)==1){GC(b);Wo(t);aY(b,t);n=c[o>>2]|0;Sc(b,t,(c[b+544>>2]|0)+(c[b+612>>2]|0)+(c[g>>2]|0)|0,n,1);o=g;n=z0(c[o>>2]|0,c[o+4>>2]|0,n|0,0)|0;o=g;c[o>>2]=n;c[o+4>>2]=z;G2(b,t);J3(b);UG(t)}else e1(b,c[o>>2]|0,0);e1(b,c[p>>2]|0,0);if(a[q>>0]|0){p=g;p=z0(c[p>>2]|0,c[p+4>>2]|0,4,0)|0;q=g;c[q>>2]=p;c[q+4>>2]=z}b:do if(!((a[k>>0]|0)!=2|(a[m>>0]|0)==0)){f=((((c[r>>2]|0)+-1|0)>>>0)/(((e[s>>1]|0)+1|0)>>>0)|0)+1|0;d=0;while(1){if((d|0)==(f|0))break b;r=g;r=z0(c[r>>2]|0,c[r+4>>2]|0,4,0)|0;s=g;c[s>>2]=r;c[s+4>>2]=z;d=d+1|0}}while(0);if(a[u>>0]|0){ID(b,t);e1(b,c[t>>2]|0,0)}J3(b);Bx(b);if(qO(b)|0){Kc(b,2,-1)|0;sM(b,2,c[b+20>>2]|0,122,(e[w>>1]|0)+1|0,0);a[b+2464>>0]=0;a[b+2468>>0]=-1;w=b+112|0;c[w>>2]=c[v>>2];c[w+4>>2]=0}}l=x;return}function tf(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;x=l;l=l+64|0;k=x+52|0;h=x+51|0;q=x+50|0;r=x+49|0;s=x+48|0;v=x+36|0;w=x+24|0;m=x+12|0;n=x;Bx(b);a[s>>0]=0;AT(b,k);AT(b,h);AT(b,q);AT(b,r);g=b+648|0;A6(c[g>>2]|0);A6(c[g>>2]|0);A6(c[g>>2]|0);A6(c[g>>2]|0);wK(b);t=b+760|0;o=b+784|0;p=b+768|0;u=b+772|0;if(((a[k>>0]|0?(Bx(b),AT(b,s),A6(c[g>>2]|0),xR(b,3,v),xR(b,3,w),wK(b),qO(b)|0):0)?(a[p>>0]|0)==2:0)?a[o>>0]|0:0){a[(c[(c[(c[t>>2]|0)+80>>2]|0)+(e[u>>1]<<2)>>2]|0)+169>>0]=106;TX(m);i=cC(m,c[39780+(d[w>>0]<<2)>>2]|0)|0;j=c[(c[(c[t>>2]|0)+80>>2]|0)+(e[u>>1]<<2)>>2]|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;k=j9(384542)|0;if(k>>>0>4294967279)uaa();if(k>>>0<11){a[n+11>>0]=k;f=n}else{y=k+16&-16;f=ZW(y)|0;c[n>>2]=f;c[n+8>>2]=y|-2147483648;c[n+4>>2]=k}i1(f,384542,k)|0;J7(f+k|0,0);k1(VC(j+28|0,n)|0,i)|0;a1(n);z5(m)}if(a[h>>0]|0){Bx(b);d4(c[g>>2]|0,3);d4(c[g>>2]|0,5);wK(b)}f=b+528|0;if(a[q>>0]|0){q=f;q=z0(c[q>>2]|0,c[q+4>>2]|0,1,0)|0;y=f;c[y>>2]=q;c[y+4>>2]=z}if(a[r>>0]|0){r=f;r=z0(c[r>>2]|0,c[r+4>>2]|0,1,0)|0;y=f;c[y>>2]=r;c[y+4>>2]=z}if((qO(b)|0?(a[p>>0]|0)==2:0)?a[o>>0]|0:0){c[(c[(c[(c[t>>2]|0)+80>>2]|0)+(e[u>>1]<<2)>>2]|0)+56>>2]=2;Xy(v,a[s>>0]|0?39812:39840);g=c[(c[(c[t>>2]|0)+80>>2]|0)+(e[u>>1]<<2)>>2]|0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;h=j9(384476)|0;if(h>>>0>4294967279)uaa();if(h>>>0<11){a[w+11>>0]=h;f=w}else{y=h+16&-16;f=ZW(y)|0;c[w>>2]=f;c[w+8>>2]=y|-2147483648;c[w+4>>2]=h}i1(f,384476,h)|0;J7(f+h|0,0);vF(VC(g+28|0,w)|0,v)|0;a1(w);z5(v);Xy(v,39860);g=c[(c[(c[t>>2]|0)+80>>2]|0)+(e[u>>1]<<2)>>2]|0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;h=j9(385582)|0;if(h>>>0>4294967279)uaa();if(h>>>0<11){a[w+11>>0]=h;f=w}else{y=h+16&-16;f=ZW(y)|0;c[w>>2]=f;c[w+8>>2]=y|-2147483648;c[w+4>>2]=h}i1(f,385582,h)|0;J7(f+h|0,0);vF(VC(g+28|0,w)|0,v)|0;a1(w);z5(v);f=(c[(c[(c[t>>2]|0)+80>>2]|0)+(e[u>>1]<<2)>>2]|0)+160|0;if((c[f>>2]|0)==1112757060)c[f>>2]=0}l=x;return}function uf(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;k=d+764|0;l=d+780|0;f=b[l>>1]|0;g=c[(c[(c[k>>2]|0)+80>>2]|0)+((f&65535)<<2)>>2]|0;do if((c[g+64>>2]|0)!=2){UZ(g,1);j=c[(c[(c[k>>2]|0)+80>>2]|0)+(e[l>>1]<<2)>>2]|0;c[j+64>>2]=2;nG(j+16|0);if(!(b[d+782>>1]|0)){f=b[l>>1]|0;break}else{j=ZW(16)|0;M0(j);f=b[l>>1]|0;c[(c[(c[(c[(c[k>>2]|0)+80>>2]|0)+((f&65535)<<2)>>2]|0)+16>>2]|0)+8>>2]=j;break}}while(0);g=c[k>>2]|0;h=g+80|0;if(WV(c[g+140>>2]|0,c[g+144>>2]|0,f)|0)a[(c[(c[h>>2]|0)+((f&65535)<<2)>>2]|0)+180>>0]=1;j=d+782|0;a:do if(!(b[j>>1]|0)){if(!(c[c[(c[(c[h>>2]|0)+((f&65535)<<2)>>2]|0)+16>>2]>>2]|0)){g=1;while(1){if(g>>>0>=256)break a;if(!(c[(c[(c[(c[(c[k>>2]|0)+80>>2]|0)+((f&65535)<<2)>>2]|0)+16>>2]|0)+(g<<2)>>2]|0)){j=ZW(16)|0;M0(j);f=b[l>>1]|0;c[(c[(c[(c[(c[k>>2]|0)+80>>2]|0)+((f&65535)<<2)>>2]|0)+16>>2]|0)+(g<<2)>>2]=j}g=g+1+((g|0)==1&1)|0}}}else{f=d+778|0;g=(HD(g+68|0,f)|0)+40|0;c[g>>2]=(c[g>>2]|0)+1;g=b[l>>1]|0;b[($C((HD((c[k>>2]|0)+68|0,f)|0)+16|0,j)|0)+72>>1]=g;f=HD((c[k>>2]|0)+68|0,f)|0;g=f+32|0;h=c[g>>2]|0;if((h|0)==(c[f+36>>2]|0))bz(f+28|0,j);else{b[h>>1]=b[j>>1]|0;c[g>>2]=h+2}f=c[k>>2]|0;g=f+80|0;if((c[f+84>>2]|0)-(c[g>>2]|0)>>2>>>0<8192){FF(g,8192);f=c[k>>2]|0}g=c[f+80>>2]|0;h=c[g+(e[l>>1]<<2)>>2]|0;d=h+8|0;i=c[d>>2]|0;if((i|0)==(c[h+12>>2]|0)){bz(h+4|0,j);g=c[k>>2]|0;f=g;g=c[g+80>>2]|0}else{b[i>>1]=b[j>>1]|0;c[d>>2]=i+2}d=b[l>>1]|0;h=c[g+((d&65535)<<2)>>2]|0;g=h+16|0;if((c[h+20>>2]|0)-(c[g>>2]|0)>>2>>>0<256){nG(g);f=c[k>>2]|0;d=b[l>>1]|0;h=c[(c[f+80>>2]|0)+((d&65535)<<2)>>2]|0}g=c[(c[h+16>>2]|0)+8>>2]|0;if(!g){g=ZW(16)|0;M0(g);f=e[l>>1]|0;c[(c[(c[(c[(c[k>>2]|0)+80>>2]|0)+(f<<2)>>2]|0)+16>>2]|0)+8>>2]=g;f=c[(c[(c[(c[(c[k>>2]|0)+80>>2]|0)+(f<<2)>>2]|0)+16>>2]|0)+8>>2]|0;g=f}else f=c[(c[(c[(c[f+80>>2]|0)+((d&65535)<<2)>>2]|0)+16>>2]|0)+8>>2]|0;if((UD(g,b[j>>1]|0)|0)==(f+4|0)){a[f+12>>0]=0;a[(wC(f,j)|0)+12>>0]=-1;c[(wC(c[(c[(c[(c[(c[k>>2]|0)+80>>2]|0)+(e[l>>1]<<2)>>2]|0)+16>>2]|0)+8>>2]|0,j)|0)+4>>2]=0;Bp(wC(c[(c[(c[(c[(c[k>>2]|0)+80>>2]|0)+(e[l>>1]<<2)>>2]|0)+16>>2]|0)+8>>2]|0,j)|0)}}while(0);return}function vf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;q=l;l=l+64|0;m=q+16|0;n=q;g=vM(d,32,0)|0;k=d+11|0;o=d+4|0;do if((g|0)!=-1){i=a[k>>0]|0;h=i<<24>>24<0;e=i&255;if(h)f=c[o>>2]|0;else f=e;if(g>>>0>f>>>1>>>0){CC(d,g);break}if(h){e=c[o>>2]|0;g=c[d>>2]|0}else g=d;a:do if(e){f=g+e|0;e=g;while(1){if((e|0)==(f|0)){e=i;break a}if(!(C6(a[e>>0]|0,32)|0))break;e=e+1|0}e=e-g|0;if((e|0)!=-1){Py(d,0,e)|0;e=a[k>>0]|0}else e=i}else e=i;while(0);if(e<<24>>24<0){f=c[d>>2]|0;e=c[o>>2]|0}else{f=d;e=e&255}e=f+e|0;while(1){if((e|0)==(f|0))break;e=e+-1|0;if(!(C6(a[e>>0]|0,32)|0)){p=21;break}}if((p|0)==21?(j=e-f|0,(j|0)!=-1):0)Py(d,j+1|0,-1)|0;mI(m);Xy(n,42252);z3(m,n);z5(n);TX(n);og(m,oY(n,d)|0);z5(n);i=c[m>>2]|0;j=((c[m+4>>2]|0)-i|0)/12|0;g=0;h=0;e=0;while(1){if((g|0)==(j|0))break;r=a[i+(g*12|0)+8+3>>0]|0;f=r&255;if(r<<24>>24<0){r=c[i+(g*12|0)+4>>2]|0;f=r>>>0<=e>>>0;e=f?e:r}else{r=f>>>0<=e>>>0;e=r?e:f;f=r}r=f?h:g;g=g+1|0;h=r}pk(n,i+(h*12|0)|0);if((a[k>>0]|0)<0){J7(c[d>>2]|0,0);c[o>>2]=0}else{J7(d,0);a[k>>0]=0}Fp(d,0);c[d>>2]=c[n>>2];c[d+4>>2]=c[n+4>>2];c[d+8>>2]=c[n+8>>2];e=0;while(1){if((e|0)==3)break;c[n+(e<<2)>>2]=0;e=e+1|0}a1(n);$_(m)}while(0);i=a[k>>0]|0;e=i<<24>>24<0;if(e){g=c[d>>2]|0;h=c[o>>2]|0}else{g=d;h=i&255}f=j9(380901)|0;j=b+8|0;k=b+4|0;m=b+11|0;b:do if((f|0)!=0?(n=g+h|0,r=tB(g,n,380901,380901+f|0)|0,!((r|0)!=(n|0)&(r|0)==(g|0))):0){if(e){d=c[d>>2]|0;f=c[o>>2]|0}else f=i&255;e=j9(380910)|0;if(e|0?(o=d+f|0,r=tB(d,o,380910,380910+e|0)|0,!((r|0)!=(o|0)&(r|0)==(d|0))):0){c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;e=0;while(1){if((e|0)==3)break b;c[b+(e<<2)>>2]=0;e=e+1|0}}c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;e=j9(384078)|0;if(e>>>0>4294967279)uaa();if(e>>>0<11)a[m>>0]=e;else{o=e+16&-16;r=ZW(o)|0;c[b>>2]=r;c[j>>2]=o|-2147483648;c[k>>2]=e;b=r}i1(b,384078,e)|0;J7(b+e|0,0)}else p=41;while(0);if((p|0)==41){c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;e=j9(384074)|0;if(e>>>0>4294967279)uaa();if(e>>>0<11)a[m>>0]=e;else{p=e+16&-16;r=ZW(p)|0;c[b>>2]=r;c[j>>2]=p|-2147483648;c[k>>2]=e;b=r}i1(b,384074,e)|0;J7(b+e|0,0)}l=q;return}function wf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;t=l;l=l+16|0;r=t+4|0;s=t;if((a[d>>0]|0)==46?(a[b>>0]|0)!=46:0)b=1;else{e=-1;h=-1;f=3}a:do if((f|0)==3){b:while(1){f=0;g=ni(b,h,r)|0;switch(g|0){case -2:{b=1;break a}case -5:break b;default:{}}f=NJ(d,e,s)|0;if((f|0)<1){f=7;break}q=c[s>>2]|0;d=d+q|0;e=e-q|0;switch(g|0){case -3:{if(!(Ri(b,f,f)|0)){b=1;break a}break}case -4:break;default:if((f|0)!=(g|0)){b=1;break a}}f=c[r>>2]|0;b=b+f|0;h=h-f|0;f=3}if((f|0)==7){b=(g|0)!=0&1;break}p=b+1|0;i=u4(p,h+-1|0)|0;m=b+(i+1)|0;c:do if((i|0)>0){j=m;g=1;h=1;f=0;while(1){q=b+h|0;switch(ni(q,j-q|0,r)|0){case -2:{b=1;break a}case -5:{f=0;g=h+1|0;break}default:f=f+1|0}h=(c[r>>2]|0)+h|0;if((h|0)>(i|0))break c}}else{f=0;g=1}while(0);q=b+g|0;e=u4(d,e)|0;k=d+e|0;if(e>>>0>=f>>>0){b=(f|0)!=0;if(b&(e|0)>0){i=c[12815]|0;e=k;do{b=e+-1|0;h=a[b>>0]|0;d:do if(h<<24>>24<=-1?(c[i>>2]|0)!=0:0)while(1){b=e+-1|0;if(!(b>>>0>d>>>0&(h&-64)<<24>>24==-128)){e=b;break d}h=a[e+-2>>0]|0;e=b}else e=b;while(0);f=f+-1|0;b=(f|0)!=0}while(b&e>>>0>d>>>0)}else e=k;if(!b){o=q;b=ni(q,m-o|0,r)|0;h=c[r>>2]|0;n=e;f=NJ(e,k-n|0,s)|0;e:do if((f|0)>=1){i=h;j=q+h|0;while(1){e=e+(c[s>>2]|0)|0;switch(b|0){case -3:{if(!(Ri(j+(0-i)|0,f,f)|0)){b=1;break a}break}case -4:break;default:if((f|0)!=(b|0)){b=1;break a}}b=ni(j,m-j|0,r)|0;h=c[r>>2]|0;f=NJ(e,k-e|0,s)|0;if((f|0)<1)break e;else{i=h;j=j+h|0}}}while(0);if(!b)if((g|0)>1){b=p;while(1){j=o-b|0;g=ni(b,j,r)|0;e=c[r>>2]|0;f=b+e|0;f:do if((g|0)==-5)b=f;else{h=e;while(1){e=d;i=g;g:while(1){g=NJ(e,n-e|0,s)|0;if(!g){b=1;break a}switch(i|0){case -3:{if(!(Ri(f+(0-h)|0,g,g)|0))break g;break}case -4:break;default:if((g|0)!=(i|0))break g}e=e+(c[s>>2]|0)|0;i=ni(f,o-f|0,r)|0;h=c[r>>2]|0;f=f+h|0;if((i|0)==-5){d=e;b=f;break f}}if((NJ(d,n-d|0,s)|0)>0)d=d+(c[s>>2]|0)|0;else do d=d+1|0;while((NJ(d,n-d|0,s)|0)<0);g=ni(b,j,r)|0;h=c[r>>2]|0;e=b+h|0;if((g|0)==-5){b=e;break}else f=e}}while(0);if(b>>>0>=q>>>0){b=0;break}}}else b=0;else b=1}else b=1}else b=1}while(0);l=t;return b|0}function xf(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;q=l;l=l+16|0;f=q;n=d+728|0;if(!((c[n>>2]&1|0)==0?!(HM(d)|0):0)){o=d+991|0;p=a[o>>0]|0;Bx(d);m=d+974|0;sR(d,10,m);xR(d,3,o);sR(d,16,d+984|0);e=d+648|0;if((a[o>>0]&-2)<<24>>24==2?(d4(c[e>>2]|0,1),d4(c[e>>2]|0,3),(a[o>>0]|0)==3):0){d4(c[e>>2]|0,1);d4(c[e>>2]|0,3)}while(1){yT(d,f);if(!(a[f>>0]|0))break;d4(c[e>>2]|0,1);d4(c[e>>2]|0,8)}wK(d);e=d+544|0;f=d+528|0;g=d+612|0;k=f;i=d+536|0;h=c[i>>2]|0;i=c[i+4>>2]|0;j=c[k+4>>2]|0;k=c[k>>2]|0;while(1){if(!(j>>>0<i>>>0|(j|0)==(i|0)&k>>>0<h>>>0))break;if(a[(c[e>>2]|0)+((c[g>>2]|0)+k)>>0]|0)break;r=z0(k|0,j|0,1,0)|0;s=z;t=f;c[t>>2]=r;c[t+4>>2]=s;j=s;k=r}a:do if((k|0)==(h|0)&(j|0)==(i|0)){if(qO(d)|0){e=a[o>>0]|0;f=d+944|0;if(e<<24>>24==1){r=d+360|0;s=c[r+4>>2]|0;t=f;c[t>>2]=c[r>>2];c[t+4>>2]=s}g=d+1072|0;b:do if(!(a[g>>0]|0)){switch(e<<24>>24){case 4:case 1:break;default:break b}a[g>>0]=1}while(0);e=c[f>>2]|0;f=c[f+4>>2]|0;g=b[m>>1]|0;if(!((e|0)==-1&(f|0)==-1)){s=z0(g&65535|0,0,e|0,f|0)|0;t=d+368|0;c[t>>2]=s;c[t+4>>2]=z}a[d+1012>>0]=1;a[d+1006>>0]=3;j=d+804|0;f=c[j>>2]|0;h=g&65535;i=d+792|0;e=c[i>>2]|0;if((f+h|0)>>>0<(c[d+796>>2]|0)-e>>2>>>0)h=i;else{FF(i,h+1+f|0);h=i;g=b[m>>1]|0;f=c[j>>2]|0;e=c[i>>2]|0}if(!(c[e+((g&65535)+f<<2)>>2]|0)){e=ZW(7)|0;s0(e);f=c[j>>2]|0;g=b[m>>1]|0;c[(c[h>>2]|0)+((g&65535)+f<<2)>>2]=e;e=c[h>>2]|0}a[(c[e+((g&65535)+f<<2)>>2]|0)+2>>0]=1;f=a[o>>0]|0;g=d+1092|0;e=a[g+11>>0]|0;if(e<<24>>24<0)e=c[d+1096>>2]|0;else e=e&255;e=(e|0)==0;if(f<<24>>24!=1){if(!e)JX(g,c[37288+((f&255)<<2)>>2]|0)|0}else{if(!e){t=$D(d+1080|0,g)|0;s=t;s=z0(c[s>>2]|0,c[s+4>>2]|0,1,0)|0;c[t>>2]=s;c[t+4>>2]=z}YR(g)|0}if(p<<24>>24==1&(a[o>>0]|0)==1?(a[d+1015>>0]|0)==0:0)b[d+976>>1]=-1;if(!(c[n>>2]&1)){s_(d);e=0;f=1;while(1){if(!(e>>>0<0|(e|0)==0&f>>>0<176))break;AR(d,f,e);t=z0(f|0,e|0,1,0)|0;e=z;f=t}AR(d,178,0);AR(d,181,0);AR(d,184,0)}e=d+780|0;f=1;while(1){if((f|0)==176)break a;a[(c[e>>2]|0)+(f*3|0)>>0]=1;f=f+1|0}}}else t4(d);while(0)}l=q;return}
function fd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;I=l;l=l+16|0;v=I;E=b+128|0;a[E>>0]=1;f=b+96|0;n=f;D=b+24|0;do if(((c[n>>2]|0)==0&(c[n+4>>2]|0)==0?(n=D,(c[n>>2]|0)==0&(c[n+4>>2]|0)==0):0)?(d=c[b>>2]|0,g=d+40|0,e=c[g>>2]|0,g=c[g+4>>2]|0,g>>>0>0|(g|0)==0&e>>>0>127):0){i=d+48|0;h=c[i>>2]|0;i=c[i+4>>2]|0;j=z0(e|0,g|0,-128,0)|0;k=z;m=z0(e|0,g|0,-160,-1)|0;n=z;if(i>>>0>n>>>0|(i|0)==(n|0)&h>>>0>m>>>0){I1(d,m,n);a[E>>0]=0;d=0;break}J=z0(c[d+548>>2]|0,0,h|0,i|0)|0;K=z;if(!(K>>>0<g>>>0|(K|0)==(g|0)&J>>>0<e>>>0)){J=c[d+544>>2]|0;K=D_(j|0,k|0,h|0,i|0)|0;K=J+K|0;K=R4(a[K>>0]|0,a[K+1>>0]|0,a[K+2>>0]|0)|0;if((K|0)!=(k9()|0)){t=12;break}K=f;c[K>>2]=128;c[K+4>>2]=0;K=D;c[K>>2]=128;c[K+4>>2]=0;K=d+40|0;K=z0(c[K>>2]|0,c[K+4>>2]|0,-128,-1)|0;t=b+56|0;c[t>>2]=K;c[t+4>>2]=z;a[E>>0]=0;t=12;break}if(i>>>0<n>>>0|(i|0)==(n|0)&h>>>0<m>>>0)I1(d,m,n);a[E>>0]=0;d=0}else t=12;while(0);a:do if((t|0)==12){m=b+104|0;K=m;if((c[K>>2]|0)==0&(c[K+4>>2]|0)==0?(s=c[b>>2]|0,p=s+40|0,o=c[p>>2]|0,p=c[p+4>>2]|0,r=D,q=c[r>>2]|0,r=c[r+4>>2]|0,K=z0(q|0,r|0,9,0)|0,J=z,!(p>>>0<J>>>0|(p|0)==(J|0)&o>>>0<K>>>0)):0){j=s+48|0;i=c[j>>2]|0;j=c[j+4>>2]|0;d=D_(o|0,p|0,q|0,r|0)|0;e=z;f=z0(d|0,e|0,-9,-1)|0;g=z;if(g>>>0<j>>>0|(g|0)==(j|0)&f>>>0<i>>>0){I1(s,f,g);a[E>>0]=0;d=0;break}h=c[s+548>>2]|0;K=z0(h|0,0,i|0,j|0)|0;J=z;if(J>>>0<e>>>0|(J|0)==(e|0)&K>>>0<d>>>0){if(!((i|0)==(d|0)&(j|0)==(e|0)))I1(s,d,e);a[E>>0]=0;d=0;break}k=c[s+544>>2]|0;r=D_(f|0,g|0,i|0,j|0)|0;r=V8(k+r|0)|0;K=z;J=f8(380288)|0;if((r|0)==(J|0)&(K|0)==(z|0)){d=z0(d|0,e|0,-5100,-1)|0;e=z;if(j>>>0>e>>>0|(j|0)==(e|0)&i>>>0>d>>>0){I1(s,d,e);a[E>>0]=0;d=0;break}g=c[s+612>>2]|0;e=h-g|0;c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;if(e>>>0>4294967279)uaa();h=v+4|0;f=v+11|0;if(e>>>0<11){a[f>>0]=e;d=v}else{K=e+16&-16;d=ZW(K)|0;c[v>>2]=d;c[v+8>>2]=K|-2147483648;c[h>>2]=e}i1(d,k+g|0,e)|0;J7(d+e|0,0);d=a[f>>0]|0;e=d<<24>>24<0;f=e?c[v>>2]|0:v;g=j9(380297)|0;if(g){K=f+(e?c[h>>2]|0:d&255)|0;J=tB(f,K,380297,380297+g|0)|0;d=J-f|0;if(!((J|0)==(K|0)|(d|0)==-1))t=30}else{d=0;t=30}if((t|0)==30){q=c[b>>2]|0;t=q+40|0;s=c[t>>2]|0;t=c[t+4>>2]|0;K=D;J=c[K>>2]|0;K=c[K+4>>2]|0;r=q+48|0;p=c[r>>2]|0;r=c[r+4>>2]|0;q=c[q+612>>2]|0;o=D_(s|0,t|0,d|0,0)|0;o=D_(o|0,z|0,J|0,K|0)|0;r=D_(o|0,z|0,p|0,r|0)|0;q=D_(r|0,z|0,q|0,0)|0;r=z;p=m;c[p>>2]=q;c[p+4>>2]=r;K=z0(q|0,r|0,J|0,K|0)|0;J=z;r=D;c[r>>2]=K;c[r+4>>2]=J;J=D_(s|0,t|0,K|0,J|0)|0;K=b+64|0;c[K>>2]=J;c[K+4>>2]=z;a[E>>0]=0}a1(v)}}f=b+112|0;K=f;do if((c[K>>2]|0)==0&(c[K+4>>2]|0)==0?(u=c[b>>2]|0,x=u+40|0,w=c[x>>2]|0,x=c[x+4>>2]|0,A=D,y=c[A>>2]|0,A=c[A+4>>2]|0,K=z0(y|0,A|0,15,0)|0,J=z,!(x>>>0<J>>>0|(x|0)==(J|0)&w>>>0<K>>>0)):0){h=u+48|0;g=c[h>>2]|0;h=c[h+4>>2]|0;i=D_(w|0,x|0,y|0,A|0)|0;j=z;d=z0(i|0,j|0,-15,-1)|0;e=z;if(h>>>0>e>>>0|(h|0)==(e|0)&g>>>0>d>>>0){I1(u,d,e);a[E>>0]=0;d=0;break a}K=z0(c[u+548>>2]|0,0,g|0,h|0)|0;J=z;if(!(J>>>0<j>>>0|(J|0)==(j|0)&K>>>0<i>>>0)){d=c[u+544>>2]|0;u=z0(i|0,j|0,-9,0)|0;u=D_(u|0,z|0,g|0,h|0)|0;u=V8(d+u|0)|0;K=z;J=f8(380309)|0;if(!((u|0)==(J|0)&(K|0)==(z|0)))break;K=z0(w|0,x|0,-15,0)|0;K=D_(K|0,z|0,y|0,A|0)|0;K=D_(K|0,z|0,g|0,h|0)|0;KT(v,d+K|0,6);K=f;c[K>>2]=(pn(v)|0)+15;c[K+4>>2]=0;z5(v);K=f;J=D;K=z0(c[J>>2]|0,c[J+4>>2]|0,c[K>>2]|0,c[K+4>>2]|0)|0;J=z;A=D;c[A>>2]=K;c[A+4>>2]=J;A=(c[b>>2]|0)+40|0;J=D_(c[A>>2]|0,c[A+4>>2]|0,K|0,J|0)|0;K=b+72|0;c[K>>2]=J;c[K+4>>2]=z;a[E>>0]=0;break}if(!((g|0)==(i|0)&(h|0)==(j|0)))I1(u,i,j);a[E>>0]=0;d=0;break a}while(0);j=b+120|0;K=j;if((c[K>>2]|0)==0&(c[K+4>>2]|0)==0?(F=c[b>>2]|0,C=F+40|0,B=c[C>>2]|0,C=c[C+4>>2]|0,H=D,G=c[H>>2]|0,H=c[H+4>>2]|0,K=z0(G|0,H|0,32,0)|0,J=z,!(C>>>0<J>>>0|(C|0)==(J|0)&B>>>0<K>>>0)):0){i=F+48|0;h=c[i>>2]|0;i=c[i+4>>2]|0;d=D_(B|0,C|0,G|0,H|0)|0;e=z;f=z0(d|0,e|0,-32,-1)|0;g=z;if(g>>>0<i>>>0|(g|0)==(i|0)&f>>>0<h>>>0){I1(F,f,g);a[E>>0]=0;d=0;break}K=z0(c[F+548>>2]|0,0,h|0,i|0)|0;J=z;if(J>>>0<e>>>0|(J|0)==(e|0)&K>>>0<d>>>0){if(!((f|0)==(h|0)&(g|0)==(i|0)))I1(F,f,g);a[E>>0]=0;d=0;break}d=c[F+544>>2]|0;A=D_(f|0,g|0,h|0,i|0)|0;A=V8(d+A|0)|0;K=z;J=f8(380318)|0;if((A|0)==(J|0)&(K|0)==(z|0)){e=z0(B|0,C|0,-20,0)|0;e=D_(e|0,z|0,G|0,H|0)|0;e=D_(e|0,z|0,h|0,i|0)|0;e=t7(d+e|0)|0;K=j;c[K>>2]=e;c[K+4>>2]=0;K=z0(B|0,C|0,-24,0)|0;K=D_(K|0,z|0,G|0,H|0)|0;K=D_(K|0,z|0,h|0,i|0)|0;K=(t7(d+K|0)|0)==2e3;f=z0(e|0,0,32,0)|0;d=z;if(K){e=j;c[e>>2]=f;c[e+4>>2]=d;e=f}else d=0;d=z0(G|0,H|0,e|0,d|0)|0;K=z;J=D;c[J>>2]=d;c[J+4>>2]=K;J=F+40|0;K=D_(c[J>>2]|0,c[J+4>>2]|0,d|0,K|0)|0;d=b+80|0;c[d>>2]=K;c[d+4>>2]=z;a[E>>0]=0;d=1}else d=1}else d=1}while(0);l=I;return d|0}function gd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+16|0;i=k;if(e>>>0<10)RT(b,d,e)|0;else{TX(i);RT(i,d,e)|0;j=i+8+3|0;m=a[j>>0]|0;h=m<<24>>24<0;f=i+4|0;switch((h?c[f>>2]|0:m&255)|0){case 24:{f=c[i>>2]|0;g=6;break}case 25:{f=c[i>>2]|0;if((c[(h?f:i)+96>>2]|0)==10)g=6;else g=71;break}case 20:{m=h?c[i>>2]|0:i;if((((((c[m+16>>2]|0)==45?(c[m+28>>2]|0)==45:0)?(c[m+40>>2]|0)==84:0)?(c[m+52>>2]|0)==58:0)?(c[m+64>>2]|0)==58:0)?(c[m+76>>2]|0)==90:0){FB(i,19,0);c[((a[j>>0]|0)<0?c[i>>2]|0:i)+40>>2]=32;GX(b,42232)|0;m=a[j>>0]|0;j=m<<24>>24<0;Ex(b,j?c[i>>2]|0:i,j?c[f>>2]|0:m&255)|0}else g=71;break}case 23:{m=h?c[i>>2]|0:i;if((((((c[m+16>>2]|0)==45?(c[m+28>>2]|0)==45:0)?(c[m+40>>2]|0)==32:0)?(c[m+56>>2]|0)==32:0)?(c[m+68>>2]|0)==58:0)?(c[m+80>>2]|0)==58:0){ny(i,10,4)|0;m=a[j>>0]|0;j=m<<24>>24<0;Ex(b,j?c[i>>2]|0:i,j?c[f>>2]|0:m&255)|0}else g=71;break}default:g=71}do if((g|0)==6){m=h?f:i;if((((c[m+92>>2]|0)+-48|0)>>>0<10?((c[m+84>>2]|0)+-48|0)>>>0<10:0)?(c[m+76>>2]|0)==32:0){f=b+8+3|0;if((a[f>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0}else{y7(b,0);a[f>>0]=0}Fx(b,1,c[((a[j>>0]|0)<0?c[i>>2]|0:i)+80>>2]|0)|0;Fx(b,1,c[((a[j>>0]|0)<0?c[i>>2]|0:i)+84>>2]|0)|0;Fx(b,1,c[((a[j>>0]|0)<0?c[i>>2]|0:i)+88>>2]|0)|0;Fx(b,1,c[((a[j>>0]|0)<0?c[i>>2]|0:i)+92>>2]|0)|0;Fx(b,1,45)|0;m=(a[j>>0]|0)<0?c[i>>2]|0:i;f=m+28|0;g=m+24|0;d=m+20|0;a:do switch(c[m+16>>2]|0){case 74:{switch(c[d>>2]|0){case 97:{if((c[g>>2]|0)!=110){g=55;break a}if((c[f>>2]|0)!=32){g=55;break a}Fx(b,1,48)|0;Fx(b,1,49)|0;g=56;break a}case 117:break;default:{g=55;break a}}switch(c[g>>2]|0){case 110:{if((c[f>>2]|0)!=32){g=55;break a}Fx(b,1,48)|0;Fx(b,1,54)|0;g=56;break a}case 108:{if((c[f>>2]|0)!=32){g=55;break a}Fx(b,1,48)|0;Fx(b,1,55)|0;g=56;break a}default:{g=55;break a}}}case 70:{if(((c[d>>2]|0)==101?(c[g>>2]|0)==98:0)?(c[f>>2]|0)==32:0){Fx(b,1,48)|0;Fx(b,1,50)|0;g=56}else g=55;break}case 77:{if((c[d>>2]|0)==97)switch(c[g>>2]|0){case 114:{if((c[f>>2]|0)!=32){g=55;break a}Fx(b,1,48)|0;Fx(b,1,51)|0;g=56;break a}case 121:{if((c[f>>2]|0)!=32){g=55;break a}Fx(b,1,48)|0;Fx(b,1,53)|0;g=56;break a}default:{g=55;break a}}else g=55;break}case 65:switch(c[d>>2]|0){case 112:{if((c[g>>2]|0)!=114){g=55;break a}if((c[f>>2]|0)!=32){g=55;break a}Fx(b,1,48)|0;Fx(b,1,52)|0;g=56;break a}case 117:{if((c[g>>2]|0)!=103){g=55;break a}if((c[f>>2]|0)!=32){g=55;break a}Fx(b,1,48)|0;Fx(b,1,56)|0;g=56;break a}default:{g=55;break a}}case 83:{if(((c[d>>2]|0)==101?(c[g>>2]|0)==112:0)?(c[f>>2]|0)==32:0){Fx(b,1,48)|0;Fx(b,1,57)|0;g=56}else g=55;break}case 79:{if(((c[d>>2]|0)==99?(c[g>>2]|0)==116:0)?(c[f>>2]|0)==32:0){Fx(b,1,49)|0;Fx(b,1,48)|0;g=56}else g=55;break}case 78:{if(((c[d>>2]|0)==111?(c[g>>2]|0)==118:0)?(c[f>>2]|0)==32:0){Fx(b,1,49)|0;Fx(b,1,49)|0;g=56}else g=55;break}case 68:{if(((c[d>>2]|0)==101?(c[g>>2]|0)==99:0)?(c[f>>2]|0)==32:0){Fx(b,1,49)|0;Fx(b,1,50)|0;g=56}else g=55;break}default:g=55}while(0);if((g|0)==55){rQ(b,i)|0;break}else if((g|0)==56){Fx(b,1,45)|0;Fx(b,1,c[((a[j>>0]|0)<0?c[i>>2]|0:i)+32>>2]|0)|0;Fx(b,1,c[((a[j>>0]|0)<0?c[i>>2]|0:i)+36>>2]|0)|0;Fx(b,1,32)|0;Fx(b,1,c[((a[j>>0]|0)<0?c[i>>2]|0:i)+44>>2]|0)|0;Fx(b,1,c[((a[j>>0]|0)<0?c[i>>2]|0:i)+48>>2]|0)|0;Fx(b,1,58)|0;Fx(b,1,c[((a[j>>0]|0)<0?c[i>>2]|0:i)+56>>2]|0)|0;Fx(b,1,c[((a[j>>0]|0)<0?c[i>>2]|0:i)+60>>2]|0)|0;Fx(b,1,58)|0;Fx(b,1,c[((a[j>>0]|0)<0?c[i>>2]|0:i)+68>>2]|0)|0;Fx(b,1,c[((a[j>>0]|0)<0?c[i>>2]|0:i)+72>>2]|0)|0;break}}else g=71}while(0);if((g|0)==71)RT(b,d,e)|0;z5(i)}l=k;return b|0}function hd(e){e=e|0;var f=0,g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+16|0;u=v;a[e+760>>0]=2;Bx(e);xR(e,4,u);o=e+612|0;g=e+536|0;p=e+528|0;q=e+544|0;a:do switch(a[u>>0]|0){case 1:{u=e+1036|0;yT(e,u);if(!(a[u>>0]|0)){A6(c[e+648>>2]|0);xR(e,3,e+995|0);xR(e,4,e+996|0)}else xR(e,8,e+994|0);AT(e,e+1011|0);xR(e,2,e+997|0);xR(e,2,e+998|0);xR(e,2,e+999|0);sR(e,12,e+972|0);KS(e);xR(e,8,e+1007|0);AT(e,e+1038|0);k=e+1e3|0;xR(e,2,k);m=e+1001|0;xR(e,5,m);wK(e);j=p;f=c[g>>2]|0;g=c[g+4>>2]|0;i=c[j+4>>2]|0;j=c[j>>2]|0;while(1){if(!(i>>>0<g>>>0|(i|0)==(g|0)&j>>>0<f>>>0))break;if(a[(c[q>>2]|0)+((c[o>>2]|0)+j)>>0]|0)break;u=z0(j|0,i|0,1,0)|0;t=z;s=p;c[s>>2]=u;c[s+4>>2]=t;i=t;j=u}if(!((j|0)==(f|0)&(i|0)==(g|0))){t4(e);break a}if(qO(e)|0?(n=a[m>>0]|0,n<<24>>24):0){u=e+960|0;h[u>>3]=+h[u>>3]*+((d[k>>0]|0)+1|0)/+((n&255)+1|0)}break}case 2:{xR(e,3,e+1002|0);u=e+1037|0;yT(e,u);if(!(a[u>>0]|0))A6(c[e+648>>2]|0);else{GC(e);A6(c[e+648>>2]|0);xR(e,8,e+1003|0);xR(e,8,e+1004|0);xR(e,8,e+1005|0);J3(e)}sR(e,14,e+980|0);KS(e);sR(e,14,e+982|0);wK(e);break}case 5:{u=e+648|0;d4(c[u>>2]|0,10);KS(e);d4(c[u>>2]|0,15);KS(e);d4(c[u>>2]|0,15);d4(c[u>>2]|0,2);A6(c[u>>2]|0);A6(c[u>>2]|0);wK(e);break}case 8:{f=e+648|0;d4(c[f>>2]|0,4);d4(c[f>>2]|0,4);d4(c[f>>2]|0,4);d4(c[f>>2]|0,4);xR(e,2,e+1008|0);r=e+1006|0;xR(e,2,r);s=e+1013|0;AT(e,s);A6(c[f>>2]|0);A6(c[f>>2]|0);A6(c[f>>2]|0);A6(c[f>>2]|0);A6(c[f>>2]|0);t=e+1014|0;AT(e,t);A6(c[f>>2]|0);u=e+1012|0;AT(e,u);if(K6(c[f>>2]|0)|0){GC(e);A6(c[f>>2]|0);A6(c[f>>2]|0);d4(c[f>>2]|0,3);A6(c[f>>2]|0);d4(c[f>>2]|0,7);d4(c[f>>2]|0,8);J3(e)}else A6(c[f>>2]|0);wK(e);j=p;i=g;g=c[i>>2]|0;i=c[i+4>>2]|0;f=c[j>>2]|0;j=c[j+4>>2]|0;while(1){if(!(j>>>0<i>>>0|(j|0)==(i|0)&f>>>0<g>>>0))break;if(a[(c[q>>2]|0)+((c[o>>2]|0)+f)>>0]|0)break;m=z0(f|0,j|0,1,0)|0;n=z;k=p;c[k>>2]=m;c[k+4>>2]=n;f=m;j=n}if(!((f|0)==(g|0)&(j|0)==(i|0))){t4(e);break a}if(qO(e)|0){f=e+912|0;n=e+804|0;q=e+991|0;o=e+974|0;g=e+900|0;i=e+904|0;p=e+792|0;m=e+796|0;if(a[u>>0]|0){e=e+896|0;c[e>>2]=(c[e>>2]|0)+1;if(!(a[s>>0]|0))c[i>>2]=(c[i>>2]|0)+1;else c[g>>2]=(c[g>>2]|0)+1;c[f>>2]=(c[f>>2]|0)+1;if((a[r>>0]|0)!=3)break a;g=c[n>>2]|0;i=b[o>>1]|0;j=(i&65535)+g|0;f=c[p>>2]|0;if(j>>>0>=(c[m>>2]|0)-f>>2>>>0){FF(p,j+1|0);i=b[o>>1]|0;g=c[n>>2]|0;f=c[p>>2]|0}if(!(c[f+((i&65535)+g<<2)>>2]|0)){f=ZW(7)|0;s0(f);g=c[n>>2]|0;i=b[o>>1]|0;c[(c[p>>2]|0)+((i&65535)+g<<2)>>2]=f;f=c[p>>2]|0}e=c[f+((i&65535)+g<<2)>>2]|0;a[e>>0]=a[q>>0]|0;a[e+4>>0]=a[u>>0]|0;a[e+1>>0]=a[r>>0]|0;a[e+5>>0]=a[s>>0]|0;a[e+6>>0]=a[t>>0]|0;a[e+3>>0]=1;break a}j=a[r>>0]|0;k=e+1015|0;if(j<<24>>24!=3){f=(a[k>>0]|0)!=0;do if(!f)if(j<<24>>24==1){c[g>>2]=(c[g>>2]|0)+1;break}else{c[i>>2]=(c[i>>2]|0)+1;break}while(0);a[k>>0]=(f^1)&1;u=e+908|0;c[u>>2]=(c[u>>2]|0)+1;break a}if(!(a[s>>0]|0))c[i>>2]=(c[i>>2]|0)+1;else c[g>>2]=(c[g>>2]|0)+1;c[f>>2]=(c[f>>2]|0)+1;a[k>>0]=0;g=c[n>>2]|0;i=b[o>>1]|0;j=(i&65535)+g|0;f=c[p>>2]|0;if(j>>>0>=(c[m>>2]|0)-f>>2>>>0){FF(p,j+1|0);i=b[o>>1]|0;g=c[n>>2]|0;f=c[p>>2]|0}if(!(c[f+((i&65535)+g<<2)>>2]|0)){f=ZW(7)|0;s0(f);g=c[n>>2]|0;i=b[o>>1]|0;c[(c[p>>2]|0)+((i&65535)+g<<2)>>2]=f;f=c[p>>2]|0}e=c[f+((i&65535)+g<<2)>>2]|0;a[e>>0]=a[q>>0]|0;a[e+4>>0]=a[u>>0]|0;a[e+1>>0]=a[r>>0]|0;a[e+5>>0]=a[s>>0]|0;a[e+6>>0]=a[t>>0]|0;a[e+3>>0]=1}break}case 9:{d4(c[e+648>>2]|0,4);wK(e);t=g;u=p;u=D_(c[t>>2]|0,c[t+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;e1(e,u,z);break}case 10:{d4(c[e+648>>2]|0,4);wK(e);t=g;u=p;u=D_(c[t>>2]|0,c[t+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;e1(e,u,z);break}default:{d4(c[e+648>>2]|0,4);wK(e);t=g;u=p;u=D_(c[t>>2]|0,c[t+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;e1(e,u,z)}}while(0);l=v;return}function id(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=l;l=l+64|0;s=x+48|0;m=x+36|0;n=x+24|0;o=x+12|0;p=x;q=b+112|0;t=b+2469|0;r=b+2472|0;v=b+896|0;if(qO(b)|0){k=b+22136|0;c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;i=j9(370620)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[s+11>>0]=i;h=s}else{j=i+16&-16;h=ZW(j)|0;c[s>>2]=h;c[s+8>>2]=j|-2147483648;c[s+4>>2]=i}i1(h,370620,i)|0;J7(h+i|0,0);i=VC(k,s)|0;j=a[i+8+3>>0]|0;j=((j<<24>>24<0?c[i+4>>2]|0:j&255)|0)==0;a1(s);if(j){Xy(s,12040);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;i=j9(384616)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[m+11>>0]=i;h=m}else{j=i+16&-16;h=ZW(j)|0;c[m>>2]=h;c[m+8>>2]=j|-2147483648;c[m+4>>2]=i}i1(h,384616,i)|0;J7(h+i|0,0);vF(VC(k,m)|0,s)|0;a1(m);z5(s);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;i=j9(384521)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[m+11>>0]=i;h=m}else{j=i+16&-16;h=ZW(j)|0;c[m>>2]=h;c[m+8>>2]=j|-2147483648;c[m+4>>2]=i}i1(h,384521,i)|0;J7(h+i|0,0);p2(s,VC(k,m)|0);a1(m);j=a[s+8+3>>0]|0;if(!((j<<24>>24<0?c[s+4>>2]|0:j&255)|0)){j=q;zo(s,c[j>>2]|0,c[j+4>>2]|0)|0}c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;i=j9(384521)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[m+11>>0]=i;h=m}else{j=i+16&-16;h=ZW(j)|0;c[m>>2]=h;c[m+8>>2]=j|-2147483648;c[m+4>>2]=i}i1(h,384521,i)|0;J7(h+i|0,0);j=VC(k,m)|0;if((a[t>>0]|0)==-1){h=q;h=PZ(c[h>>2]|0,c[h+4>>2]|0,1)|0;i=z}else{h=c[r>>2]|0;i=0}zo(j,h,i)|0;a1(m);if(tT()|0){c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;i=j9(384616)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[m+11>>0]=i;h=m}else{j=i+16&-16;h=ZW(j)|0;c[m>>2]=h;c[m+8>>2]=j|-2147483648;c[m+4>>2]=i}i1(h,384616,i)|0;J7(h+i|0,0);HX(VC(k,m)|0,12068)|0;a1(m);ms(m,41840,s);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;i=j9(384521)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[n+11>>0]=i;h=n}else{j=i+16&-16;h=ZW(j)|0;c[n>>2]=h;c[n+8>>2]=j|-2147483648;c[n+4>>2]=i}i1(h,384521,i)|0;J7(h+i|0,0);h=VC(k,n)|0;j=a[m+8+3>>0]|0;i=j<<24>>24<0;Ex(h,i?c[m>>2]|0:m,i?c[m+4>>2]|0:j&255)|0;a1(n);O0(m)}Xy(m,39604);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;i=j9(370731)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[n+11>>0]=i;h=n}else{j=i+16&-16;h=ZW(j)|0;c[n>>2]=h;c[n+8>>2]=j|-2147483648;c[n+4>>2]=i}i1(h,370731,i)|0;J7(h+i|0,0);vF(VC(k,n)|0,m)|0;a1(n);z5(m);Xy(m,11768);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;i=j9(370620)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[n+11>>0]=i;h=n}else{j=i+16&-16;h=ZW(j)|0;c[n>>2]=h;c[n+8>>2]=j|-2147483648;c[n+4>>2]=i}i1(h,370620,i)|0;J7(h+i|0,0);vF(VC(k,n)|0,m)|0;a1(n);z5(m);TX(o);cC(o,yn(a[b+2462>>0]|0)|0)|0;Bs(n,o,12208);p2(m,n);c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;i=j9(385582)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[p+11>>0]=i;h=p}else{j=i+16&-16;h=ZW(j)|0;c[p>>2]=h;c[p+8>>2]=j|-2147483648;c[p+4>>2]=i}i1(h,385582,i)|0;J7(h+i|0,0);vF(VC(k,p)|0,m)|0;a1(p);z5(m);O0(n);z5(o);p=v;o=c[p+4>>2]|0;if(o>>>0<0|(o|0)==0&(c[p>>2]|0)>>>0<32){p=v;c[p>>2]=32;c[p+4>>2]=0}z5(s)}}GC(b);if(f)d4(c[b+648>>2]|0,10);AT(b,s);i=b+22116|0;if(a[s>>0]|0){if((a[t>>0]|0)==-1){s=c[q>>2]<<1;c[r>>2]=s;a[t>>0]=sv(s,0)|0}h=c[i>>2]|0;if(h|0)laa(h);c[i>>2]=ZW(44)|0;Ep(b);if(!(Xp(c[i>>2]|0,a[t>>0]|0)|0)){h=c[i>>2]|0;if(h|0)laa(h);c[i>>2]=0}else w=69}else w=69;if((((w|0)==69?(u=c[i>>2]|0,u|0):0)?(a[u>>0]=a[u+2>>0]|0,w=c[i>>2]|0,a[w+1>>0]=a[w+2>>0]|0,YO(b,e),qO(b)|0):0)?+g[(c[b+24>>2]|0)+136>>2]<.3:0){w=b+312|0;e=c[w>>2]|0;w=c[w+4>>2]|0;u=z0(e|0,w|0,1,0)|0;e=w>>>0<0|(w|0)==0&e>>>0<8;w=v;c[w>>2]=e?9:u;c[w+4>>2]=e?0:z}h=c[b+648>>2]|0;i=Z9(c[h+4>>2]|0)|0;if(i>>>0>d>>>0)G4(h,i-d|0);J3(b);l=x;return}function jd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+32|0;n=p;a:while(1){k=b;m=b+-32|0;while(1){b:while(1){j=a;f=k-j|0;g=f>>5;e=a+32|0;switch(g|0){case 1:case 0:break a;case 2:{o=5;break a}case 3:{o=7;break a}case 4:{o=8;break a}case 5:{o=9;break a}default:{}}if((f|0)<992){o=11;break a}i=a+(((g|0)/2|0)<<5)|0;if((f|0)>31968){f=(g|0)/4|0;f=hg(a,a+(f<<5)|0,i,i+(f<<5)|0,m,d)|0}else f=ef(a,i,m,d)|0;if(tb[c[d>>2]&31](a,i)|0){g=m;break}else g=m;while(1){g=g+-32|0;h=c[d>>2]|0;if((a|0)==(g|0))break;if(tb[h&31](g,i)|0){o=28;break b}}if(!(tb[h&31](a,m)|0)){while(1){if((e|0)==(m|0))break a;f=e+32|0;if(tb[c[d>>2]&31](a,e)|0)break;else e=f}c[n>>2]=c[e>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2];c[n+16>>2]=c[e+16>>2];c[n+20>>2]=c[e+20>>2];c[n+24>>2]=c[e+24>>2];c[n+28>>2]=c[e+28>>2];c[e>>2]=c[m>>2];c[e+4>>2]=c[m+4>>2];c[e+8>>2]=c[m+8>>2];c[e+12>>2]=c[m+12>>2];c[e+16>>2]=c[m+16>>2];c[e+20>>2]=c[m+20>>2];c[e+24>>2]=c[m+24>>2];c[e+28>>2]=c[m+28>>2];c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];c[m+24>>2]=c[n+24>>2];c[m+28>>2]=c[n+28>>2];e=f}if((e|0)==(m|0))break a;else f=m;while(1){while(1){g=e+32|0;if(tb[c[d>>2]&31](a,e)|0)break;else e=g}do f=f+-32|0;while(tb[c[d>>2]&31](a,f)|0);if(e>>>0>=f>>>0){a=e;continue b}c[n>>2]=c[e>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2];c[n+16>>2]=c[e+16>>2];c[n+20>>2]=c[e+20>>2];c[n+24>>2]=c[e+24>>2];c[n+28>>2]=c[e+28>>2];c[e>>2]=c[f>>2];c[e+4>>2]=c[f+4>>2];c[e+8>>2]=c[f+8>>2];c[e+12>>2]=c[f+12>>2];c[e+16>>2]=c[f+16>>2];c[e+20>>2]=c[f+20>>2];c[e+24>>2]=c[f+24>>2];c[e+28>>2]=c[f+28>>2];c[f>>2]=c[n>>2];c[f+4>>2]=c[n+4>>2];c[f+8>>2]=c[n+8>>2];c[f+12>>2]=c[n+12>>2];c[f+16>>2]=c[n+16>>2];c[f+20>>2]=c[n+20>>2];c[f+24>>2]=c[n+24>>2];c[f+28>>2]=c[n+28>>2];e=g}}if((o|0)==28){o=0;c[n>>2]=c[a>>2];c[n+4>>2]=c[a+4>>2];c[n+8>>2]=c[a+8>>2];c[n+12>>2]=c[a+12>>2];c[n+16>>2]=c[a+16>>2];c[n+20>>2]=c[a+20>>2];c[n+24>>2]=c[a+24>>2];c[n+28>>2]=c[a+28>>2];c[a>>2]=c[g>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];c[a+12>>2]=c[g+12>>2];c[a+16>>2]=c[g+16>>2];c[a+20>>2]=c[g+20>>2];c[a+24>>2]=c[g+24>>2];c[a+28>>2]=c[g+28>>2];c[g>>2]=c[n>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];c[g+12>>2]=c[n+12>>2];c[g+16>>2]=c[n+16>>2];c[g+20>>2]=c[n+20>>2];c[g+24>>2]=c[n+24>>2];c[g+28>>2]=c[n+28>>2];f=f+1|0}c:do if(e>>>0<g>>>0)while(1){while(1){h=e+32|0;if(tb[c[d>>2]&31](e,i)|0)e=h;else break}do g=g+-32|0;while(!(tb[c[d>>2]&31](g,i)|0));if(e>>>0>g>>>0){g=i;break c}c[n>>2]=c[e>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2];c[n+16>>2]=c[e+16>>2];c[n+20>>2]=c[e+20>>2];c[n+24>>2]=c[e+24>>2];c[n+28>>2]=c[e+28>>2];c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];c[e+16>>2]=c[g+16>>2];c[e+20>>2]=c[g+20>>2];c[e+24>>2]=c[g+24>>2];c[e+28>>2]=c[g+28>>2];c[g>>2]=c[n>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];c[g+12>>2]=c[n+12>>2];c[g+16>>2]=c[n+16>>2];c[g+20>>2]=c[n+20>>2];c[g+24>>2]=c[n+24>>2];c[g+28>>2]=c[n+28>>2];i=(i|0)==(e|0)?g:i;e=h;f=f+1|0}else g=i;while(0);if((e|0)!=(g|0)?tb[c[d>>2]&31](g,e)|0:0){c[n>>2]=c[e>>2];c[n+4>>2]=c[e+4>>2];c[n+8>>2]=c[e+8>>2];c[n+12>>2]=c[e+12>>2];c[n+16>>2]=c[e+16>>2];c[n+20>>2]=c[e+20>>2];c[n+24>>2]=c[e+24>>2];c[n+28>>2]=c[e+28>>2];c[e>>2]=c[g>>2];c[e+4>>2]=c[g+4>>2];c[e+8>>2]=c[g+8>>2];c[e+12>>2]=c[g+12>>2];c[e+16>>2]=c[g+16>>2];c[e+20>>2]=c[g+20>>2];c[e+24>>2]=c[g+24>>2];c[e+28>>2]=c[g+28>>2];c[g>>2]=c[n>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];c[g+12>>2]=c[n+12>>2];c[g+16>>2]=c[n+16>>2];c[g+20>>2]=c[n+20>>2];c[g+24>>2]=c[n+24>>2];c[g+28>>2]=c[n+28>>2];f=f+1|0}if(!f){f=wh(a,e,d)|0;g=e+32|0;if(wh(g,b,d)|0){o=44;break}if(f){a=g;continue}}i=e;if((i-j|0)>=(k-i|0)){o=43;break}jd(a,e,d);a=e+32|0}if((o|0)==43){o=0;jd(e+32|0,b,d);b=e;continue}else if((o|0)==44){o=0;if(f)break;else{b=e;continue}}}if((o|0)==5){if(tb[c[d>>2]&31](m,a)|0){c[n>>2]=c[a>>2];c[n+4>>2]=c[a+4>>2];c[n+8>>2]=c[a+8>>2];c[n+12>>2]=c[a+12>>2];c[n+16>>2]=c[a+16>>2];c[n+20>>2]=c[a+20>>2];c[n+24>>2]=c[a+24>>2];c[n+28>>2]=c[a+28>>2];c[a>>2]=c[m>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];c[m+12>>2]=c[n+12>>2];c[m+16>>2]=c[n+16>>2];c[m+20>>2]=c[n+20>>2];c[m+24>>2]=c[n+24>>2];c[m+28>>2]=c[n+28>>2]}}else if((o|0)==7)ef(a,e,m,d)|0;else if((o|0)==8)Ph(a,e,a+64|0,m,d)|0;else if((o|0)==9)hg(a,e,a+64|0,a+96|0,m,d)|0;else if((o|0)==11)Bn(a,b,d);l=p;return}function kd(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+48|0;t=u+24|0;r=u+12|0;s=u;Ud(b);k=b+836|0;if(!((a[b+833>>0]|0)==0?!(c[k>>2]&8|0):0))e=3;a:do if((e|0)==3){h=b+880|0;i=b+884|0;g=c[h>>2]|0;g=sm(g+(((((c[i>>2]|0)-g|0)/12|0)+-1|0)*12|0)|0,10)|0;f=c[i>>2]|0;e=f+-12|0;while(1){if((f|0)==(e|0))break;q=f+-12|0;c[i>>2]=q;z5(q);f=c[i>>2]|0}n=b+924|0;f=c[n>>2]|0;e=f+-12|0;while(1){if((f|0)==(e|0))break;q=f+-12|0;c[n>>2]=q;z5(q);f=c[n>>2]|0}o=b+964|0;f=c[o>>2]|0;e=f+-12|0;while(1){if((f|0)==(e|0))break;q=f+-12|0;c[o>>2]=q;z5(q);f=c[o>>2]|0}q=b+1004|0;f=c[q>>2]|0;e=f+-12|0;while(1){if((f|0)==(e|0))break;p=f+-12|0;c[q>>2]=p;z5(p);f=c[q>>2]|0}j=b+920|0;m=b+960|0;p=b+1e3|0;f=b+1242|0;if(!(c[k>>2]&8))e=1;else e=d[f>>0]|0;tU(t,e+(g&255)|0,10);e=c[i>>2]|0;if(e>>>0<(c[b+888>>2]|0)>>>0){rV(e,t);c[i>>2]=(c[i>>2]|0)+12}else Dx(h,t);z5(t);e=a[b+1240>>0]|0;h=b+968|0;i=b+1008|0;g=b+928|0;b:do if(e<<24>>24==9){c:do if(c[k>>2]&8|0){switch(a[f>>0]|0){case 1:break c;case 2:break;default:break b}Xy(s,14756);f=b+1241|0;HX(s,a[f>>0]|0?14344:409096)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];e=0;while(1){if((e|0)==3)break;c[s+(e<<2)>>2]=0;e=e+1|0}p2(t,r);e=c[n>>2]|0;if(e>>>0<(c[g>>2]|0)>>>0){rV(e,t);c[n>>2]=(c[n>>2]|0)+12}else Dx(j,t);z5(t);O0(r);z5(s);Xy(s,14896);HX(s,a[f>>0]|0?16388:409096)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];e=0;while(1){if((e|0)==3)break;c[s+(e<<2)>>2]=0;e=e+1|0}p2(t,r);e=c[o>>2]|0;if(e>>>0<(c[h>>2]|0)>>>0){rV(e,t);c[o>>2]=(c[o>>2]|0)+12}else Dx(m,t);z5(t);O0(r);z5(s);Xy(s,14920);HX(s,a[f>>0]|0?14444:409096)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];e=0;while(1){if((e|0)==3)break;c[s+(e<<2)>>2]=0;e=e+1|0}p2(t,r);e=c[q>>2]|0;if(e>>>0<(c[i>>2]|0)>>>0){rV(e,t);c[q>>2]=(c[q>>2]|0)+12}else Dx(p,t);z5(t);O0(r);z5(s);break a}while(0);Xy(s,14540);f=b+1241|0;HX(s,a[f>>0]|0?14344:409096)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];e=0;while(1){if((e|0)==3)break;c[s+(e<<2)>>2]=0;e=e+1|0}p2(t,r);e=c[n>>2]|0;if(e>>>0<(c[g>>2]|0)>>>0){rV(e,t);c[n>>2]=(c[n>>2]|0)+12}else Dx(j,t);z5(t);O0(r);z5(s);Xy(s,14672);HX(s,a[f>>0]|0?16388:409096)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];e=0;while(1){if((e|0)==3)break;c[s+(e<<2)>>2]=0;e=e+1|0}p2(t,r);e=c[o>>2]|0;if(e>>>0<(c[h>>2]|0)>>>0){rV(e,t);c[o>>2]=(c[o>>2]|0)+12}else Dx(m,t);z5(t);O0(r);z5(s);Xy(s,14696);HX(s,a[f>>0]|0?14444:409096)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];e=0;while(1){if((e|0)==3)break;c[s+(e<<2)>>2]=0;e=e+1|0}p2(t,r);e=c[q>>2]|0;if(e>>>0<(c[i>>2]|0)>>>0){rV(e,t);c[q>>2]=(c[q>>2]|0)+12}else Dx(p,t);z5(t);O0(r);z5(s);break a}while(0);uU(s,e,10);DW(s,0,15e3)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];e=0;while(1){if((e|0)==3)break;c[s+(e<<2)>>2]=0;e=e+1|0}p2(t,r);O0(r);z5(s);if(c[k>>2]&8|0){uU(s,a[f>>0]|0,10);DW(s,0,15096)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];e=0;while(1){if((e|0)==3)break;c[s+(e<<2)>>2]=0;e=e+1|0}k=a[r+8+3>>0]|0;f=k<<24>>24<0;Ex(t,f?c[r>>2]|0:r,f?c[r+4>>2]|0:k&255)|0;O0(r);z5(s)}uU(s,a[b+1241>>0]|0,10);DW(s,0,15168)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];e=0;while(1){if((e|0)==3)break;c[s+(e<<2)>>2]=0;e=e+1|0}e=a[r+8+3>>0]|0;b=e<<24>>24<0;Ex(t,b?c[r>>2]|0:r,b?c[r+4>>2]|0:e&255)|0;O0(r);z5(s);e=c[n>>2]|0;if((e|0)==(c[g>>2]|0))Ax(j,t);else{p2(e,t);c[n>>2]=(c[n>>2]|0)+12}e=c[o>>2]|0;if((e|0)==(c[h>>2]|0))Ax(m,t);else{p2(e,t);c[o>>2]=(c[o>>2]|0)+12}e=c[q>>2]|0;if((e|0)==(c[i>>2]|0))Ax(p,t);else{p2(e,t);c[q>>2]=(c[q>>2]|0)+12}z5(t)}while(0);l=u;return}function ld(d,e,f,g,i){d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=l;l=l+64|0;D=H+16|0;E=H;B=H+24|0;F=H+8|0;G=H+20|0;c[D>>2]=e;x=(d|0)!=0;y=B+40|0;A=y;B=B+39|0;C=F+4|0;k=0;j=0;p=0;a:while(1){do if((j|0)>-1)if((k|0)>(2147483647-j|0)){c[12784]=75;j=-1;break}else{j=k+j|0;break}while(0);k=a[e>>0]|0;if(!(k<<24>>24)){w=87;break}else m=e;b:while(1){switch(k<<24>>24){case 37:{k=m;w=9;break b}case 0:{k=m;break b}default:{}}v=m+1|0;c[D>>2]=v;k=a[v>>0]|0;m=v}c:do if((w|0)==9)while(1){w=0;if((a[m+1>>0]|0)!=37)break c;k=k+1|0;m=m+2|0;c[D>>2]=m;if((a[m>>0]|0)==37)w=9;else break}while(0);k=k-e|0;if(x)_3(d,e,k);if(k|0){e=m;continue}n=m+1|0;k=(a[n>>0]|0)+-48|0;if(k>>>0<10){v=(a[m+2>>0]|0)==36;u=v?k:-1;p=v?1:p;n=v?m+3|0:n}else u=-1;c[D>>2]=n;k=a[n>>0]|0;m=(k<<24>>24)+-32|0;d:do if(m>>>0<32){o=0;q=k;while(1){k=1<<m;if(!(k&75913)){k=q;break d}o=o|k;n=n+1|0;c[D>>2]=n;k=a[n>>0]|0;m=(k<<24>>24)+-32|0;if(m>>>0>=32)break;else q=k}}else o=0;while(0);if(k<<24>>24==42){m=n+1|0;k=(a[m>>0]|0)+-48|0;if(k>>>0<10?(a[n+2>>0]|0)==36:0){c[i+(k<<2)>>2]=10;k=c[g+((a[m>>0]|0)+-48<<3)>>2]|0;p=1;n=n+3|0}else{if(p|0){j=-1;break}if(x){p=(c[f>>2]|0)+(4-1)&~(4-1);k=c[p>>2]|0;c[f>>2]=p+4;p=0;n=m}else{k=0;p=0;n=m}}c[D>>2]=n;v=(k|0)<0;k=v?0-k|0:k;o=v?o|8192:o}else{k=vS(D)|0;if((k|0)<0){j=-1;break}n=c[D>>2]|0}do if((a[n>>0]|0)==46){m=n+1|0;if((a[m>>0]|0)!=42){c[D>>2]=m;m=vS(D)|0;n=c[D>>2]|0;break}q=n+2|0;m=(a[q>>0]|0)+-48|0;if(m>>>0<10?(a[n+3>>0]|0)==36:0){c[i+(m<<2)>>2]=10;m=c[g+((a[q>>0]|0)+-48<<3)>>2]|0;n=n+4|0;c[D>>2]=n;break}if(p|0){j=-1;break a}if(x){v=(c[f>>2]|0)+(4-1)&~(4-1);m=c[v>>2]|0;c[f>>2]=v+4}else m=0;c[D>>2]=q;n=q}else m=-1;while(0);t=0;while(1){if(((a[n>>0]|0)+-65|0)>>>0>57){j=-1;break a}v=n+1|0;c[D>>2]=v;q=a[(a[n>>0]|0)+-65+(392700+(t*58|0))>>0]|0;r=q&255;if((r+-1|0)>>>0<8){t=r;n=v}else break}if(!(q<<24>>24)){j=-1;break}s=(u|0)>-1;do if(q<<24>>24==19)if(s){j=-1;break a}else w=49;else{if(s){c[i+(u<<2)>>2]=r;s=g+(u<<3)|0;u=c[s+4>>2]|0;w=E;c[w>>2]=c[s>>2];c[w+4>>2]=u;w=49;break}if(!x){j=0;break a}Lk(E,r,f)}while(0);if((w|0)==49?(w=0,!x):0){k=0;e=v;continue}n=a[n>>0]|0;n=(t|0)!=0&(n&15|0)==3?n&-33:n;s=o&-65537;u=(o&8192|0)==0?o:s;e:do switch(n|0){case 110:switch((t&255)<<24>>24){case 0:{c[c[E>>2]>>2]=j;k=0;e=v;continue a}case 1:{c[c[E>>2]>>2]=j;k=0;e=v;continue a}case 2:{k=c[E>>2]|0;c[k>>2]=j;c[k+4>>2]=((j|0)<0)<<31>>31;k=0;e=v;continue a}case 3:{b[c[E>>2]>>1]=j;k=0;e=v;continue a}case 4:{a[c[E>>2]>>0]=j;k=0;e=v;continue a}case 6:{c[c[E>>2]>>2]=j;k=0;e=v;continue a}case 7:{k=c[E>>2]|0;c[k>>2]=j;c[k+4>>2]=((j|0)<0)<<31>>31;k=0;e=v;continue a}default:{k=0;e=v;continue a}}case 112:{n=120;m=m>>>0>8?m:8;e=u|8;w=61;break}case 88:case 120:{e=u;w=61;break}case 111:{n=E;e=c[n>>2]|0;n=c[n+4>>2]|0;r=fV(e,n,y)|0;s=A-r|0;o=0;q=393164;m=(u&8|0)==0|(m|0)>(s|0)?m:s+1|0;s=u;w=67;break}case 105:case 100:{n=E;e=c[n>>2]|0;n=c[n+4>>2]|0;if((n|0)<0){e=D_(0,0,e|0,n|0)|0;n=z;o=E;c[o>>2]=e;c[o+4>>2]=n;o=1;q=393164;w=66;break e}else{o=(u&2049|0)!=0&1;q=(u&2048|0)==0?((u&1|0)==0?393164:393166):393165;w=66;break e}}case 117:{n=E;o=0;q=393164;e=c[n>>2]|0;n=c[n+4>>2]|0;w=66;break}case 99:{a[B>>0]=c[E>>2];e=B;o=0;q=393164;r=y;n=1;m=s;break}case 109:{n=q9(c[12784]|0)|0;w=71;break}case 115:{n=c[E>>2]|0;n=n|0?n:401463;w=71;break}case 67:{c[F>>2]=c[E>>2];c[C>>2]=0;c[E>>2]=F;r=-1;n=F;w=75;break}case 83:{e=c[E>>2]|0;if(!m){dK(d,32,k,0,u);e=0;w=84}else{r=m;n=e;w=75}break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{k=Yc(d,+h[E>>3],k,m,u,n)|0;e=v;continue a}default:{o=0;q=393164;r=y;n=m;m=u}}while(0);f:do if((w|0)==61){u=E;t=c[u>>2]|0;u=c[u+4>>2]|0;r=NS(t,u,y,n&32)|0;q=(e&8|0)==0|(t|0)==0&(u|0)==0;o=q?0:2;q=q?393164:393164+(n>>4)|0;s=e;e=t;n=u;w=67}else if((w|0)==66){r=sE(e,n,y)|0;s=u;w=67}else if((w|0)==71){w=0;u=fs(n,0,m)|0;t=(u|0)==0;e=n;o=0;q=393164;r=t?n+m|0:u;n=t?m:u-n|0;m=s}else if((w|0)==75){w=0;q=n;e=0;m=0;while(1){o=c[q>>2]|0;if(!o)break;m=H4(G,o)|0;if((m|0)<0|m>>>0>(r-e|0)>>>0)break;e=m+e|0;if(r>>>0>e>>>0)q=q+4|0;else break}if((m|0)<0){j=-1;break a}dK(d,32,k,e,u);if(!e){e=0;w=84}else{o=0;while(1){m=c[n>>2]|0;if(!m){w=84;break f}m=H4(G,m)|0;o=m+o|0;if((o|0)>(e|0)){w=84;break f}_3(d,G,m);if(o>>>0>=e>>>0){w=84;break}else n=n+4|0}}}while(0);if((w|0)==67){w=0;n=(e|0)!=0|(n|0)!=0;u=n|(m|0)!=0;n=A-r+((n^1)&1)|0;e=u?r:y;r=y;n=u?((m|0)>(n|0)?m:n):m;m=(m|0)>-1?s&-65537:s}else if((w|0)==84){w=0;dK(d,32,k,e,u^8192);k=(k|0)>(e|0)?k:e;e=v;continue}t=r-e|0;s=(n|0)<(t|0)?t:n;u=s+o|0;k=(k|0)<(u|0)?u:k;dK(d,32,k,u,m);_3(d,q,o);dK(d,48,k,u,m^65536);dK(d,48,s,t,0);_3(d,e,t);dK(d,32,k,u,m^8192);e=v}g:do if((w|0)==87)if(!d)if(!p)j=0;else{j=1;while(1){e=c[i+(j<<2)>>2]|0;if(!e){k=0;break}Lk(g+(j<<3)|0,e,f);j=j+1|0;if((j|0)>=10){j=1;break g}}while(1){e=j+1|0;if(k|0){j=-1;break g}if((e|0)>=10){j=1;break g}j=e;k=c[i+(e<<2)>>2]|0}}while(0);l=H;return j|0}function md(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;F=l;l=l+64|0;q=F+52|0;s=F+48|0;h=F+44|0;C=F+40|0;D=F+36|0;i=F+32|0;j=F+28|0;k=F+24|0;n=F+20|0;v=F+16|0;w=F+12|0;x=F+8|0;y=F+4|0;B=F+59|0;g=F+58|0;A=F+57|0;m=F+56|0;o=F;c[q>>2]=0;c[v>>2]=0;c[w>>2]=0;c[x>>2]=0;c[y>>2]=0;a[A>>0]=0;Bx(b);xR(b,4,B);B=a[B>>0]|0;e=B&255;f=c[b+796>>2]|0;do if(e>>>0<(c[b+800>>2]|0)-f>>2>>>0?(r=f+(e<<2)|0,(c[r>>2]|0)!=0):0){xR(b,3,g);p=b+648|0;A6(c[p>>2]|0);e=a[g>>0]|0;Fi(b,e);n3(b,s);if(a[b+771>>0]|0){wK(b);f=b+536|0;g=b+528|0;g=D_(c[f>>2]|0,c[f+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0)|0;e1(b,g,z);g=c[s>>2]|0;f=b+808|0;e=c[f>>2]|0;if(g>>>0>=(c[b+812>>2]|0)-e>>2>>>0){FF(f,g+1|0);e=c[f>>2]|0}e=e+(g<<2)|0;f=c[e>>2]|0;if(f|0){P_(c[f>>2]|0);laa(f)}D=ZW(56)|0;Qv(D,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);c[e>>2]=D;s_(b);AR(b,34,0);a[(c[b+776>>2]|0)+34>>0]=1;break}n3(b,h);u=c[h>>2]|0;if(u>>>0>3){t4(b);wK(b);break}if((u|0)==3)AT(b,A);n3(b,C);n3(b,D);if(K6(c[p>>2]|0)|0){GC(b);A6(c[p>>2]|0);n3(b,v);n3(b,w);n3(b,x);n3(b,y);J3(b)}else A6(c[p>>2]|0);n3(b,i);t=c[i>>2]|0;if(t>>>0>6){t4(b);break}n3(b,j);j=c[j>>2]|0;if(j>>>0>6){t4(b);break}n3(b,k);i=c[k>>2]|0;if(i>>>0>12){t4(b);break}AT(b,m);f=e&255;e=a[m>>0]|0?0:f;while(1){if(e>>>0>f>>>0)break;GC(b);T5(b);T5(b);T5(b);J3(b);e=e+1|0}T5(b);T5(b);T5(b);T5(b);T5(b);T5(b);if(K6(c[p>>2]|0)|0){GC(b);A6(c[p>>2]|0);if(K6(c[p>>2]|0)|0){GC(b);A6(c[p>>2]|0);ox(b);J3(b)}else A6(c[p>>2]|0);J3(b)}else A6(c[p>>2]|0);A6(c[p>>2]|0);A6(c[p>>2]|0);if(K6(c[p>>2]|0)|0){GC(b);A6(c[p>>2]|0);GC(b);d4(c[p>>2]|0,4);d4(c[p>>2]|0,4);T5(b);T5(b);A6(c[p>>2]|0);J3(b);J3(b)}else A6(c[p>>2]|0);n3(b,n);e=c[n>>2]|0;if(e>>>0>64){wK(b);t4(b);break}um(b,e&255);if(K6(c[p>>2]|0)|0){GC(b);A6(c[p>>2]|0);GC(b);n3(b,o);f=c[o>>2]|0;g=i+4|0;e=0;while(1){if((e|0)==(f|0))break;G4(c[p>>2]|0,g);A6(c[p>>2]|0);e=e+1|0}J3(b);J3(b)}else A6(c[p>>2]|0);A6(c[p>>2]|0);A6(c[p>>2]|0);if(K6(c[p>>2]|0)|0){GC(b);A6(c[p>>2]|0);re(b,r,q);J3(b)}else A6(c[p>>2]|0);a:do if(K6(c[p>>2]|0)|0){GC(b);A6(c[p>>2]|0);r=c[p>>2]|0;G4(r,Z9(c[r+4>>2]|0)|0);t4(b);J3(b)}else{A6(c[p>>2]|0);KS(b);while(1){if(!(Z9(c[(c[p>>2]|0)+4>>2]|0)|0))break a;RS(b)}}while(0);wK(b);p=b+528|0;r=b+536|0;if(!((c[p>>2]|0)==(c[r>>2]|0)?(c[p+4>>2]|0)==(c[r+4>>2]|0):0))t4(b);r=qO(b)|0;h=c[q>>2]|0;if(!r){if(!h)break;PL(h);laa(h);break}g=c[s>>2]|0;f=b+808|0;e=c[f>>2]|0;if(g>>>0>=(c[b+812>>2]|0)-e>>2>>>0){FF(f,g+1|0);e=c[f>>2]|0}e=e+(g<<2)|0;f=c[e>>2]|0;if(f|0){P_(c[f>>2]|0);laa(f)}s=ZW(56)|0;Qv(s,h,d[b+949>>0]|0,(a[b+953>>0]|0)!=0,d[b+950>>0]|0,d[b+951>>0]|0,c[C>>2]|0,c[D>>2]|0,c[v>>2]|0,c[w>>2]|0,c[x>>2]|0,c[y>>2]|0,B,u&255,(a[A>>0]|0)!=0,i&255,t&255,j&255,(a[b+954>>0]|0)!=0,(a[b+955>>0]|0)!=0,(a[b+956>>0]|0)!=0);c[e>>2]=s;s_(b);AR(b,34,0);a[(c[b+776>>2]|0)+34>>0]=1}else E=3;while(0);if((E|0)==3){E=c[b+648>>2]|0;G4(E,Z9(c[E+4>>2]|0)|0);wK(b)}l=F;return}function nd(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;v=l;l=l+48|0;r=v;j=v+40|0;n=v+36|0;s=v+24|0;k=v+12|0;g=d+909|0;t=d+612|0;u=d+48|0;do if(!(a[g>>0]|0)){i=d+536|0;h=i;m=d+528|0;do if((c[h>>2]|0)==2&(c[h+4>>2]|0)==0){e=d+508|0;f=c[e>>2]|0;g=d+668|0;h=c[g>>2]|0;if(!(k2(f,h)|0)){c3(f,h);break}yE(d,s);if(!(b[s>>1]|0)){t=m;t=z0(c[t>>2]|0,c[t+4>>2]|0,2,0)|0;u=m;c[u>>2]=t;c[u+4>>2]=z;VU(k,391269);BZ(c[e>>2]|0,c[g>>2]|0,0,0);z5(k);Op(d,2,0);break}else{q=32;break}}else q=32;while(0);a:do if((q|0)==32){ID(d,j);h=c[j>>2]|0;b:do if(!h){q=i;e=c[q+4>>2]|0;switch(c[q>>2]|0){case 4:{if(e|0)break b;break}case 8:{if(e|0)break b;break}default:break b}e=d+508|0;f=c[e>>2]|0;g=d+668|0;h=c[g>>2]|0;if(k2(f,h)|0){VU(s,391269);BZ(c[e>>2]|0,c[g>>2]|0,0,0);z5(s);Op(d,4,0);break a}else{c3(f,h);break a}}while(0);e=r;c[e>>2]=h;c[e+4>>2]=0;r3(d,n);e=c[n>>2]|0;c:do if((e|0)<1635150180){switch(e|0){case 862221926:break;default:{f=e;g=e;break c}}c[n>>2]=1836019574;f=1836019574;g=1836019574}else{switch(e|0){case 1635150180:break;default:{f=e;g=e;break c}}c[n>>2]=1835295092;f=1836019574;g=1835295092}while(0);i=d+508|0;j=d+24|0;e=d+728|0;d:do if(h>>>0<8)switch(h|0){case 0:{w=(c[j>>2]|0)+96|0;h=u;k=c[t>>2]|0;q=r;c[q>>2]=D_(D_(c[w>>2]|0,c[w+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0)|0,z|0,k|0,0)|0;c[q+4>>2]=z;if(!(c[e>>2]&1))break d;if(!((f|0)==0&(c[i>>2]|0)==2))break d;g=m;c[g>>2]=0;c[g+4>>2]=0;c[n>>2]=1835295092;g=1835295092;break d}case 1:{oz(d,r);break d}default:{m=(c[j>>2]|0)+96|0;n=u;q=c[t>>2]|0;w=r;c[w>>2]=D_(D_(c[m>>2]|0,c[m+4>>2]|0,c[n>>2]|0,c[n+4>>2]|0)|0,z|0,q|0,0)|0;c[w+4>>2]=z;break d}}while(0);e:do if(!(c[e>>2]&1)){f:do if((g|0)>=1936419184)if((g|0)<2003395685)switch(g|0){case 1936419184:break f;default:break e}else switch(g|0){case 2003395685:break f;default:break e}else switch(g|0){case 1718773093:break;default:break e}while(0);W5(d);RB(d,0,0,57,378046,-1,1,0)}while(0);TX(s);lh(s,g)|0;BZ(c[i>>2]|0,c[d+668>>2]|0,g,0);z5(s);f=r;e=c[f>>2]|0;f=c[f+4>>2]|0;Op(d,e,f);if(((g|0)==1836019574?(w=c[t>>2]|0,s=z0(w|0,0,e|0,f|0)|0,r=z,o=d+548|0,r>>>0>0|((r|0)==0?s>>>0>((c[o>>2]|0)-w|0)>>>0:0)):0)?(p=pR(c[j>>2]|0)|0,c[d+932>>2]=p,(p|0)!=0&(f>>>0>0|(f|0)==0&e>>>0>131072)):0){w=c[t>>2]|0;s=z0(w|0,0,e|0,f|0)|0;w=D_(s|0,z|0,(c[o>>2]|0)-w|0,0)|0;c[p>>2]=w>>>0>131072?w:131072}if((c[i>>2]|0)>>>0<3?(s=u,u=c[t>>2]|0,s=z0(c[s>>2]|0,c[s+4>>2]|0,e|0,f|0)|0,u=z0(s|0,z|0,u|0,0)|0,s=z,w=d+40|0,t=c[w+4>>2]|0,s>>>0>t>>>0|((s|0)==(t|0)?u>>>0>(c[w>>2]|0)>>>0:0)):0)xM(d,0,0,379092,382808,0)}while(0)}else{k=d+948|0;f=c[k>>2]|0;m=d+956|0;if((f|0)!=(c[m>>2]|0)?(s=u,s=z0(c[t>>2]|0,0,c[s>>2]|0,c[s+4>>2]|0)|0,o=z,w=f,p=c[w+4>>2]|0,!(o>>>0<p>>>0|((o|0)==(p|0)?s>>>0<(c[w>>2]|0)>>>0:0))):0){e=d+508|0;g=d+668|0;yZ(c[e>>2]|0,c[g>>2]|0,c[f+16>>2]|0,0);f=(c[k>>2]|0)+8|0;Op(d,c[f>>2]|0,c[f+4>>2]|0);f=c[k>>2]|0;w=f+8|0;w=z0(c[w>>2]|0,c[w+4>>2]|0,c[t>>2]|0,0)|0;t=z;j=d+548|0;g:do if(t>>>0>0|((t|0)==0?w>>>0>(c[j>>2]|0)>>>0:0))c3(c[e>>2]|0,c[g>>2]|0);else{g=d+972|0;h=d+916|0;while(1){e=f+32|0;c[k>>2]=e;if((e|0)==(c[m>>2]|0))break g;if(a[g>>0]|0){if(!(a[(bF(h,f+48|0)|0)+271>>0]|0))break g;if(!(a[g>>0]|0)){i=c[k>>2]|0;q=20}}else{i=e;q=20}if((q|0)==20?(q=0,a[(bF(h,i+16|0)|0)+271>>0]|0):0)break g;f=c[k>>2]|0}}while(0);i=c[d+932>>2]|0;if(!i)break;e=c[k>>2]|0;if((e|0)==(c[m>>2]|0))break;t=e;d=c[t>>2]|0;t=c[t+4>>2]|0;g=e+8|0;g=z0(c[g>>2]|0,c[g+4>>2]|0,d|0,t|0)|0;h=z;e=u;e=z0(c[j>>2]|0,0,c[e>>2]|0,c[e+4>>2]|0)|0;f=z;w=z0(e|0,f|0,131072,0)|0;u=z;if(!((h>>>0>f>>>0|(h|0)==(f|0)&g>>>0>e>>>0)&(t>>>0<u>>>0|(t|0)==(u|0)&d>>>0<w>>>0)))break;w=D_(g|0,h|0,e|0,f|0)|0;c[i>>2]=w>>>0>131072?w:131072;break}VU(r,374005);BZ(c[d+508>>2]|0,c[d+668>>2]|0,0,0);z5(r);e=c[k>>2]|0;if((e|0)==(c[m>>2]|0)){e=HN(d,0)|0;f=z}else{w=e;f=u;e=c[t>>2]|0;f=D_(c[w>>2]|0,c[w+4>>2]|0,c[f>>2]|0,c[f+4>>2]|0)|0;e=D_(f|0,z|0,e|0,0)|0;f=z}if(f>>>0>0|(f|0)==0&e>>>0>1){u=c[d+624>>2]|0;w=f>>>0<0|(f|0)==0&e>>>0<u>>>1>>>0;e=w?e:u;f=w?f:0}w=HN(d,0)|0;if((e|0)==(w|0)&(f|0)==(z|0))a[g>>0]=0;Op(d,e,f)}while(0);l=v;return}function od(b){b=b|0;var f=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;G=b+536|0;h=G;f=c[h>>2]|0;h=c[h+4>>2]|0;a:do if(!((f|0)==0&(h|0)==0)){E=b+656|0;E=z0(c[E>>2]|0,c[E+4>>2]|0,f|0,h|0)|0;C=z;l=b+1112|0;D=d[l>>0]|0;n=b+1113|0;F=d[n>>0]|0;m=b+1114|0;B=e[60490+(D<<7)+(F<<5)+(d[m>>0]<<1)>>1]|0;k=UW(d[372685+(D<<2)+F>>0]|0,0,1e3,0)|0;B=UW(k|0,z|0,B|0,0)|0;k=b+1115|0;D=g5(B|0,z|0,e[61002+(D<<3)+(d[k>>0]<<1)>>1]|0,0)|0;D=z0(d[b+1120>>0]|0,0,D|0,z|0)|0;F=UW(D|0,z|0,d[372701+F>>0]|0,0)|0;D=z;if(C>>>0<D>>>0|(C|0)==(D|0)&E>>>0<F>>>0){e1(b,f,h);break}C=b+312|0;F=C;E=c[F+4>>2]|0;if(E>>>0<0|(E|0)==0&(c[F>>2]|0)>>>0<3?!(Ng(b)|0):0)ik(b);D=b+48|0;j=D;E=b+612|0;j=z0(c[E>>2]|0,0,c[j>>2]|0,c[j+4>>2]|0)|0;i=G;i=z0(j|0,z|0,c[i>>2]|0,c[i+4>>2]|0)|0;j=z;F=b+40|0;B=F;y=b+760|0;A=b+784|0;x=A;x=D_(c[B>>2]|0,c[B+4>>2]|0,c[x>>2]|0,c[x+4>>2]|0)|0;B=b+896|0;h=C;f=c[h>>2]|0;h=c[h+4>>2]|0;if((i|0)==(x|0)&(j|0)==(z|0)){x=B;c[x>>2]=f;c[x+4>>2]=h}if((f|0)==0&(h|0)==0?(x=b+360|0,(c[x>>2]|0)==0&(c[x+4>>2]|0)==0):0){u=b+136|0;w=c[u+4>>2]|0;x=b+280|0;c[x>>2]=c[u>>2];c[x+4>>2]=w}x=b+1080|0;w=x;c[w>>2]=i;c[w+4>>2]=j;w=a[l>>0]|0;f=w&255;switch(w<<24>>24){case 3:{if((a[n>>0]|0)==3){h=384;i=0}else p=15;break}case 0:case 2:{if((a[n>>0]|0)==1){h=576;i=0}else p=15;break}default:p=15}if((p|0)==15){h=1152;i=0}u=b+112|0;c[u>>2]=e[61002+(f<<3)+(d[k>>0]<<1)>>1];c[u+4>>2]=0;np(b,h,i);u=b+952+3|0;f=a[u>>0]|0;w=b+948|0;if(f<<24>>24<0)f=c[w>>2]|0;else f=f&255;do if(!f){s=C;q=c[s+4>>2]|0;t=B;r=c[t+4>>2]|0;if(!(q>>>0<r>>>0|((q|0)==(r|0)?(c[s>>2]|0)>>>0<(c[t>>2]|0)>>>0:0))?(t=D,t=z0(c[E>>2]|0,0,c[t>>2]|0,c[t+4>>2]|0)|0,r=G,r=z0(t|0,z|0,c[r>>2]|0,c[r+4>>2]|0)|0,t=z,q=F,s=A,s=D_(c[q>>2]|0,c[q+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0,!((r|0)==(s|0)&(t|0)==(z|0))):0)break;Qf(b)}while(0);t=QH(b+968|0,60490+(d[l>>0]<<7)+(d[n>>0]<<5)+(d[m>>0]<<1)|0)|0;c[t>>2]=(c[t>>2]|0)+1;t=b+1020+(d[b+1116>>0]<<2)|0;c[t>>2]=(c[t>>2]|0)+1;t=b+1036+(d[b+1117>>0]<<2)|0;c[t>>2]=(c[t>>2]|0)+1;t=b+1052+(d[b+1118>>0]<<2)|0;c[t>>2]=(c[t>>2]|0)+1;t=b+728|0;if(c[t>>2]&2|0){e1(b,c[G>>2]|0,c[G+4>>2]|0);break}s=b+528|0;if(a[b+1119>>0]|0){GC(b);q=s;q=z0(c[q>>2]|0,c[q+4>>2]|0,2,0)|0;r=s;c[r>>2]=q;c[r+4>>2]=z;J3(b)}GC(b);if((a[n>>0]|0)==1)Ug(b);else{q=G;r=s;r=D_(c[q>>2]|0,c[q+4>>2]|0,c[r>>2]|0,c[r+4>>2]|0)|0;e1(b,r,z)}J3(b);i=s;f=c[i>>2]|0;i=c[i+4>>2]|0;j=G;h=c[j>>2]|0;j=c[j+4>>2]|0;k=b+544|0;q=f;r=i;while(1){o=z0(q|0,r|0,4,0)|0;n=z;if(!(n>>>0<j>>>0|(n|0)==(j|0)&o>>>0<h>>>0))break;o=c[k>>2]|0;l=z0(c[E>>2]|0,0,q|0,r|0)|0;m=z;if((a[o+l>>0]|0)==-49?(v=z0(l|0,m|0,1,0)|0,v=d[o+v>>0]|0,(v&240|0)==48):0){p=34;break}o=z0(q|0,r|0,1,0)|0;q=o;r=z}if((p|0)==34){k=z0(l|0,m|0,2,0)|0;k=d[o+k>>0]|0;p=z0(l|0,m|0,3,0)|0;p=k<<8&3840|d[o+p>>0];k=k>>>4|v<<4&240;n=z0(k|0,0,q|0,r|0)|0;v=z;H=z0(n|0,v|0,-4,-1)|0;I=z;v=z0(n|0,v|0,4,0)|0;n=z;if((I>>>0<j>>>0|(I|0)==(j|0)&H>>>0<=h>>>0)&(n>>>0<j>>>0|(n|0)==(j|0)&v>>>0<h>>>0)){l=z0(l|0,m|0,4,0)|0;n=k+-4|0;m=0;k=o+l|0;l=4095;while(1){if((m&255|0)>=(n|0))break;I=(e[61034+((d[k>>0]^l>>>4)<<1)>>1]^l<<8)&4095;m=m+1<<24>>24;k=k+1|0;l=I}if((l|0)==(p|0)){f=D_(q|0,r|0,f|0,i|0)|0;e1(b,f,z);Bx(b);GC(b);f=b+648|0;d4(c[f>>2]|0,12);d4(c[f>>2]|0,8);d4(c[f>>2]|0,12);wK(b);e1(b,n,((n|0)<0)<<31>>31);J3(b);f=b+1004|0;c[f>>2]=(c[f>>2]|0)+1;f=s;h=G;j=c[h+4>>2]|0;i=c[f+4>>2]|0;h=c[h>>2]|0;f=c[f>>2]|0}}}if(j>>>0>i>>>0|(j|0)==(i|0)&h>>>0>f>>>0){I=D_(h|0,j|0,f|0,i|0)|0;e1(b,I,z)}if(qO(b)|0){h=b+492|0;if(a[h>>0]|0?(c[b+976>>2]|0)>>>0>1:0){f=a[u>>0]|0;if(f<<24>>24<0)f=c[w>>2]|0;else f=f&255;if(f|0){w=C;H=c[w+4>>2]|0;I=B;c[I>>2]=c[w>>2];c[I+4>>2]=H}}f=c[t>>2]|0;if(!(f&1)){W5(b);f=c[t>>2]|0}do if((f&2|0)==0?(H=C,w=c[H+4>>2]|0,I=B,C=c[I+4>>2]|0,!(w>>>0<C>>>0|((w|0)==(C|0)?(c[H>>2]|0)>>>0<(c[I>>2]|0)>>>0:0))):0){t6(b);if(a[h>>0]|0)break a;if(+g[(c[b+24>>2]|0)+136>>2]<1.0){H=D;H=z0(c[E>>2]|0,0,c[H>>2]|0,c[H+4>>2]|0)|0;B=z;I=F;I=XZ(c[I>>2]|0,c[I+4>>2]|0,1)|0;C=z;if(!(B>>>0<C>>>0|(B|0)==(C|0)&H>>>0<I>>>0))break;rn(y,16384,0,388168);I=x;c[I>>2]=-1;c[I+4>>2]=-1;I=b+64|0;if((c[I>>2]|0)==-1?(c[I+4>>2]|0)==-1:0)break;Kl(b)}}while(0);if((a[h>>0]|0)==0?(H=D,H=z0(c[E>>2]|0,0,c[H>>2]|0,c[H+4>>2]|0)|0,H=z0(H|0,z|0,c[G>>2]|0,0)|0,E=z,G=F,I=A,I=D_(c[G>>2]|0,c[G+4>>2]|0,c[I>>2]|0,c[I+4>>2]|0)|0,G=z,E>>>0>G>>>0|(E|0)==(G|0)&H>>>0>I>>>0):0){Kl(b);H=F;I=A;I=D_(c[H>>2]|0,c[H+4>>2]|0,c[I>>2]|0,c[I+4>>2]|0)|0;I1(b,I,z)}}}while(0);return}function pd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;r=l;l=l+32|0;g=r+28|0;m=r+27|0;i=r+26|0;n=r+25|0;k=r+24|0;o=r+12|0;p=r;j=b+528|0;e=j;d=c[e>>2]|0;e=z0(d|0,c[e+4>>2]|0,9,0)|0;t=z;f=b+536|0;s=c[f+4>>2]|0;h=b+944|0;a:do if(t>>>0>s>>>0|((t|0)==(s|0)?e>>>0>(c[f>>2]|0)>>>0:0))q=60;else{f=(c[b+544>>2]|0)+(c[b+612>>2]|0)+d|0;d=W8(f)|0;e=f+4|0;if((d|0)<1279348037){switch(d|0){case 1278422585:break;default:{q=60;break a}}if((a[e>>0]|0)!=57){q=60;break}}else{switch(d|0){case 1279348037:break;default:{q=60;break a}}if((a[f+5>>0]|0)!=46){q=60;break}d=a[e>>0]|0;if((d&255)<=51){if(d<<24>>24!=51){q=60;break}if((a[f+6>>0]|0)!=57?((a[f+8>>0]|0)+-48&255)>=10:0){q=60;break}}}jZ(b,9,0,h);bB(b,g);f=a[g>>0]|0;b:do if((f&-16&255)<33){VU(o,c[15608+((f&15)<<2)>>2]|0);vF(b+908|0,o)|0;z5(o);switch(f&15){case 8:case 1:break;default:break b}c[b+1096>>2]=0}while(0);bB(b,m);s=j;s=z0(c[s>>2]|0,c[s+4>>2]|0,8,0)|0;t=j;c[t>>2]=s;c[t+4>>2]=z;bB(b,i);bB(b,n);t=j;t=z0(c[t>>2]|0,c[t+4>>2]|0,3,0)|0;s=j;c[s>>2]=t;c[s+4>>2]=z;Bx(b);s=b+648|0;d4(c[s>>2]|0,2);A6(c[s>>2]|0);xR(b,3,k);d4(c[s>>2]|0,2);wK(b);s=j;s=z0(c[s>>2]|0,c[s+4>>2]|0,11,0)|0;t=j;c[t>>2]=s;c[t+4>>2]=z;c:do if(qO(b)|0){g=b+956|0;HX(g,15672)|0;switch(a[k>>0]|0){case 0:{HX(g,15688)|0;break}case 1:{HX(g,15696)|0;break}case 2:{HX(g,15704)|0;break}case 3:{HX(g,15712)|0;break}case 4:{HX(g,15720)|0;break}case 5:{HX(g,15728)|0;break}case 6:{HX(g,15736)|0;break}default:{}}e=b+1104|0;d=c[e>>2]|0;if(d>>>0<101){sU(p,((100-d|0)>>>0)/10|0,10);DW(p,0,15744)|0;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];d=0;while(1){if((d|0)==3)break;c[p+(d<<2)>>2]=0;d=d+1|0}d=a[o+8+3>>0]|0;t=d<<24>>24<0;Ex(g,t?c[o>>2]|0:o,t?c[o+4>>2]|0:d&255)|0;O0(o);z5(p);sU(p,((100-(c[e>>2]|0)|0)>>>0)%10|0,10);DW(p,0,15764)|0;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];d=0;while(1){if((d|0)==3)break;c[p+(d<<2)>>2]=0;d=d+1|0}t=a[o+8+3>>0]|0;s=t<<24>>24<0;Ex(g,s?c[o>>2]|0:o,s?c[o+4>>2]|0:t&255)|0;O0(o);z5(p)}e=a[m>>0]|0;if(e<<24>>24){d=a[b+964+3>>0]|0;if(d<<24>>24<0)d=c[b+960>>2]|0;else d=d&255;if(!(((e&255)%10|0)<<24>>24))tU(p,((e&255)/10|0)&255,10);else ST(p,+(e&255)/10.0,1);DW(p,0,(d|0)==0?15784:15824)|0;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];d=0;while(1){if((d|0)==3)break;c[p+(d<<2)>>2]=0;d=d+1|0}t=a[o+8+3>>0]|0;s=t<<24>>24<0;Ex(g,s?c[o>>2]|0:o,s?c[o+4>>2]|0:t&255)|0;O0(o);z5(p)}switch(f&15){case 9:case 2:{HX(g,15868)|0;break}case 3:{HX(g,15896)|0;break}case 4:{HX(g,15940)|0;break}case 5:{HX(g,15984)|0;break}default:{}}d=a[n>>0]|0;switch(d<<24>>24){case -1:case 0:break c;default:{}}e=(d&255)*1e3|0;switch(f&15){case 8:case 1:{uU(p,d,10);DW(p,0,16024)|0;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];d=0;while(1){if((d|0)==3)break;c[p+(d<<2)>>2]=0;d=d+1|0}t=a[o+8+3>>0]|0;s=t<<24>>24<0;Ex(g,s?c[o>>2]|0:o,s?c[o+4>>2]|0:t&255)|0;O0(o);z5(p);break c}case 9:case 2:{Fn(b+920|0,e,10)|0;uU(p,d,10);DW(p,0,42252)|0;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];d=0;while(1){if((d|0)==3)break;c[p+(d<<2)>>2]=0;d=d+1|0}t=a[o+8+3>>0]|0;s=t<<24>>24<0;Ex(g,s?c[o>>2]|0:o,s?c[o+4>>2]|0:t&255)|0;O0(o);z5(p);break c}case 5:case 4:case 3:{Fn(b+932|0,e,10)|0;uU(p,d,10);DW(p,0,16024)|0;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];d=0;while(1){if((d|0)==3)break;c[p+(d<<2)>>2]=0;d=d+1|0}t=a[o+8+3>>0]|0;s=t<<24>>24<0;Ex(g,s?c[o>>2]|0:o,s?c[o+4>>2]|0:t&255)|0;O0(o);z5(p);break c}default:break c}}while(0)}while(0);if((q|0)==60)jZ(b,20,0,h);l=r;return}function qd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;K=l;l=l+112|0;J=K+64|0;C=K+52|0;D=K+48|0;E=K+36|0;F=K+24|0;G=K+12|0;H=K;g=vM(e,32,0)|0;do if((g|0)!=-1){m=e+11|0;j=a[m>>0]|0;h=j<<24>>24<0;f=j&255;n=e+4|0;if(h)i=c[n>>2]|0;else i=f;if(g>>>0>i>>>1>>>0){CC(e,g);break}if(h){f=c[n>>2]|0;h=c[e>>2]|0}else h=e;a:do if(f){g=h+f|0;f=h;while(1){if((f|0)==(g|0)){f=j;break a}if(!(C6(a[f>>0]|0,32)|0))break;f=f+1|0}f=f-h|0;if((f|0)!=-1){Py(e,0,f)|0;f=a[m>>0]|0}else f=j}else f=j;while(0);if(f<<24>>24<0){g=c[e>>2]|0;f=c[n>>2]|0}else{g=e;f=f&255}f=g+f|0;while(1){if((f|0)==(g|0))break;f=f+-1|0;if(!(C6(a[f>>0]|0,32)|0)){I=21;break}}if((I|0)==21?(k=f-g|0,(k|0)!=-1):0)Py(e,k+1|0,-1)|0;mI(J);Xy(C,42252);z3(J,C);z5(C);TX(C);og(J,oY(C,e)|0);z5(C);j=c[J>>2]|0;k=((c[J+4>>2]|0)-j|0)/12|0;h=0;i=0;f=0;while(1){if((h|0)==(k|0))break;y=a[j+(h*12|0)+8+3>>0]|0;g=y&255;if(y<<24>>24<0){y=c[j+(h*12|0)+4>>2]|0;g=y>>>0<=f>>>0;f=g?f:y}else{y=g>>>0<=f>>>0;f=y?f:g;g=y}y=g?i:h;h=h+1|0;i=y}pk(C,j+(i*12|0)|0);if((a[m>>0]|0)<0){J7(c[e>>2]|0,0);c[n>>2]=0}else{J7(e,0);a[m>>0]=0}Fp(e,0);c[e>>2]=c[C>>2];c[e+4>>2]=c[C+4>>2];c[e+8>>2]=c[C+8>>2];f=0;while(1){if((f|0)==3)break;c[C+(f<<2)>>2]=0;f=f+1|0}a1(C);$_(J)}while(0);c[J>>2]=0;y=J+4|0;c[y>>2]=0;c[J+8>>2]=0;q=C+4|0;r=C+8|0;s=C+8|0;t=F+8+3|0;u=F+4|0;v=J+8|0;w=F+8+3|0;x=F+4|0;p=0;f=vM(e,73,0)|0;n=0;b:while(1){while(1){if((f|0)==-1)break b;i=f+1|0;o=vM(e,73,i)|0;if((o|0)==-1)f=-1;else break}c[C>>2]=0;c[q>>2]=0;c[r>>2]=0;c[D>>2]=f;g=f;while(1){g=vM(e,80,g+1|0)|0;c[D>>2]=g;if(g>>>0>=o>>>0)break;h=c[q>>2]|0;if((h|0)==(c[s>>2]|0)){Yy(C,D);continue}else{c[h>>2]=g;c[q>>2]=h+4;continue}}h=c[C>>2]|0;g=(c[q>>2]|0)-h>>2;if((g>>>0>1?(c[h>>2]|0)>>>0>i>>>0:0)?(z=g+-1|0,(c[h+(z<<2)>>2]|0)==(o+-1|0)):0)MI(C,z);TX(E);j=c[C>>2]|0;g=c[q>>2]|0;m=o-f|0;do if((j|0)==(g|0)){g=n;I=60}else{i=c[j>>2]|0;k=i-f|0;h=g-j>>2;g=1;while(1){if(g>>>0>=h>>>0)break;L=i;i=c[j+(g<<2)>>2]|0;if((i-L|0)!=(k|0)){I=66;break}else g=g+1|0}if((I|0)==66){I=0;TX(F);f=c[y>>2]|0;if(f>>>0<(c[v>>2]|0)>>>0){rV(f,F);c[y>>2]=(c[y>>2]|0)+12}else Dx(J,F);z5(F);g=n;break}sU(H,k,10);DW(H,0,37320)|0;c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];g=0;while(1){if((g|0)==3)break;c[H+(g<<2)>>2]=0;g=g+1|0}HX(G,39968)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];g=0;while(1){if((g|0)==3)break;c[G+(g<<2)>>2]=0;g=g+1|0}g=a[w>>0]|0;I=g<<24>>24<0;Ex(E,I?c[F>>2]|0:F,I?c[x>>2]|0:g&255)|0;O0(F);O0(G);z5(H);g=(c[c[C>>2]>>2]|0)-f|0;g=g>>>0>n>>>0?g:n;I=60}while(0);do if((I|0)==60){I=0;sU(G,m,10);DW(G,0,37332)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];f=0;while(1){if((f|0)==3)break;c[G+(f<<2)>>2]=0;f=f+1|0}f=a[t>>0]|0;L=f<<24>>24<0;Ex(E,L?c[F>>2]|0:F,L?c[u>>2]|0:f&255)|0;O0(F);z5(G);f=c[y>>2]|0;if((f|0)==(c[v>>2]|0)){Ax(J,E);break}else{p2(f,E);c[y>>2]=(c[y>>2]|0)+12;break}}while(0);z5(E);cU(C);p=m+p|0;f=o;n=g}L=d+312|0;H=c[L+4>>2]|0;if(0>H>>>0|(0==(H|0)?(n+p|0)>>>0>(c[L>>2]|0)>>>0:0)?(A=c[J>>2]|0,B=c[y>>2]|0,(A|0)!=(B|0)):0)ME(J,((B-A|0)/12|0)+-1|0);h=c[y>>2]|0;g=c[J>>2]|0;i=h;if(((h-g|0)/12|0)>>>0>4){while(1){f=g+12|0;if((f|0)==(i|0))break;vF(g,f)|0;g=f}while(1){f=c[y>>2]|0;if((f|0)==(g|0))break;L=f+-12|0;c[y>>2]=L;z5(L)}n=c[J>>2]|0}else{f=h;n=g;g=h}c:do if(((g-n|0)/12|0)>>>0>3){m=1;while(1){k=n;if(m>>>0>=((g-n|0)/12|0)>>>0)break;g=k+(m*12|0)|0;i=a[k+(m*12|0)+8+3>>0]|0;h=i<<24>>24<0;i=h?c[k+(m*12|0)+4>>2]|0:i&255;L=a[k+8+3>>0]|0;j=L<<24>>24<0;if((i|0)!=((j?c[k+4>>2]|0:L&255)|0)){I=87;break c}if(L$(h?c[g>>2]|0:g,j?c[k>>2]|0:n,i)|0){I=87;break c}m=m+1|0;g=f}pk(b,k)}else I=87;while(0);d:do if((I|0)==87){c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;f=0;while(1){if((f|0)==3)break d;c[b+(f<<2)>>2]=0;f=f+1|0}}while(0);XQ(J);l=K;return}function rd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+32|0;n=q+12|0;p=q;a:do if(Gz(b)|0?Gz(d)|0:0){k=tm(b)|0;m=z;i=tm(d)|0;h=z;b=i9(42348)|0;j=e+8+3|0;g=a[j>>0]|0;n=e+4|0;f=c[n>>2]|0;do if((b|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(e,42348,b)|0)){b=(k|0)==(i|0)&(m|0)==(h|0);break a}else{g=a[j>>0]|0;f=c[n>>2]|0;break}while(0);b=i9(42360)|0;do if((b|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(e,42360,b)|0)){b=(m|0)<(h|0)|(m|0)==(h|0)&k>>>0<i>>>0;break a}else{g=a[j>>0]|0;f=c[n>>2]|0;break}while(0);b=i9(42368)|0;do if((b|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(e,42368,b)|0)){b=(m|0)<(h|0)|(m|0)==(h|0)&k>>>0<=i>>>0;break a}else{g=a[j>>0]|0;f=c[n>>2]|0;break}while(0);b=i9(42380)|0;do if((b|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(e,42380,b)|0)){b=(m|0)>(h|0)|(m|0)==(h|0)&k>>>0>=i>>>0;break a}else{g=a[j>>0]|0;f=c[n>>2]|0;break}while(0);b=i9(42392)|0;do if((b|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(e,42392,b)|0)){b=(m|0)>(h|0)|(m|0)==(h|0)&k>>>0>i>>>0;break a}else{g=a[j>>0]|0;f=c[n>>2]|0;break}while(0);d=i9(42400)|0;b=(k|0)!=(i|0)|(m|0)!=(h|0);if((d|0)==((g<<24>>24<0?f:g&255)|0)){if(!(VG(e,42400,d)|0))break;g=a[j>>0]|0;f=c[n>>2]|0}d=i9(42412)|0;if((d|0)==((g<<24>>24<0?f:g&255)|0)){e=b&(VG(e,42412,d)|0)==0;l=q;return e|0}else b=0}else o=28;while(0);if((o|0)==28){i=e+4|0;g=e+8+3|0;if((a[b+8+3>>0]|0)<0)b=c[b>>2]|0;Xy(n,b);Xy(p,(a[d+8+3>>0]|0)<0?c[d>>2]|0:d);uP(n)|0;uP(p)|0;b=i9(42348)|0;f=a[g>>0]|0;d=c[i>>2]|0;m=p+4|0;j=n+4|0;h=n+8+3|0;k=p+8+3|0;do if((b|0)==((f<<24>>24<0?d:f&255)|0)){if(VG(e,42348,b)|0){f=a[g>>0]|0;d=c[i>>2]|0;o=35;break}d=a[h>>0]|0;f=d<<24>>24<0;d=f?c[j>>2]|0:d&255;e=a[k>>0]|0;b=e<<24>>24<0;if((d|0)==((b?c[m>>2]|0:e&255)|0))b=(L$(f?c[n>>2]|0:n,b?c[p>>2]|0:p,d)|0)==0;else b=0}else o=35;while(0);b:do if((o|0)==35){b=i9(42424)|0;do if((b|0)==((f<<24>>24<0?d:f&255)|0)){if(VG(e,42424,b)|0){f=a[g>>0]|0;d=c[i>>2]|0;break}f=a[h>>0]|0;g=f<<24>>24<0;h=g?c[n>>2]|0:n;b=a[k>>0]|0;e=b<<24>>24<0;d=e?c[p>>2]|0:p;b=e?c[m>>2]|0:b&255;if(!b){b=1;break b}e=h+((g?c[j>>2]|0:f&255)<<2)|0;b=HA(h,e,d,d+(b<<2)|0)|0;b=(b|0)!=(e|0)&(b-h|0)!=-4;break b}while(0);b=i9(42360)|0;do if((b|0)==((f<<24>>24<0?d:f&255)|0))if(!(VG(e,42360,b)|0)){e=a[k>>0]|0;b=e<<24>>24<0;e=b?c[m>>2]|0:e&255;o=a[h>>0]|0;m=o<<24>>24<0;o=m?c[j>>2]|0:o&255;b=L$(m?c[n>>2]|0:n,b?c[p>>2]|0:p,e>>>0<o>>>0?e:o)|0;b=(((b|0)==0?(o>>>0<e>>>0?-2147483648:0):b)|0)<0;break b}else{f=a[g>>0]|0;d=c[i>>2]|0;break}while(0);b=i9(42368)|0;do if((b|0)==((f<<24>>24<0?d:f&255)|0))if(!(VG(e,42368,b)|0)){e=a[h>>0]|0;b=e<<24>>24<0;e=b?c[j>>2]|0:e&255;o=a[k>>0]|0;k=o<<24>>24<0;o=k?c[m>>2]|0:o&255;b=L$(k?c[p>>2]|0:p,b?c[n>>2]|0:n,e>>>0<o>>>0?e:o)|0;b=(((b|0)==0?(o>>>0<e>>>0?-2147483648:0):b)|0)>-1;break b}else{f=a[g>>0]|0;d=c[i>>2]|0;break}while(0);b=i9(42380)|0;do if((b|0)==((f<<24>>24<0?d:f&255)|0))if(!(VG(e,42380,b)|0)){e=a[k>>0]|0;b=e<<24>>24<0;e=b?c[m>>2]|0:e&255;o=a[h>>0]|0;m=o<<24>>24<0;o=m?c[j>>2]|0:o&255;b=L$(m?c[n>>2]|0:n,b?c[p>>2]|0:p,e>>>0<o>>>0?e:o)|0;b=(((b|0)==0?(o>>>0<e>>>0?-2147483648:0):b)|0)>-1;break b}else{f=a[g>>0]|0;d=c[i>>2]|0;break}while(0);b=i9(42392)|0;do if((b|0)==((f<<24>>24<0?d:f&255)|0))if(!(VG(e,42392,b)|0)){e=a[h>>0]|0;b=e<<24>>24<0;e=b?c[j>>2]|0:e&255;o=a[k>>0]|0;k=o<<24>>24<0;o=k?c[m>>2]|0:o&255;b=L$(k?c[p>>2]|0:p,b?c[n>>2]|0:n,e>>>0<o>>>0?e:o)|0;b=(((b|0)==0?(o>>>0<e>>>0?-2147483648:0):b)|0)<0;break b}else{f=a[g>>0]|0;d=c[i>>2]|0;break}while(0);b=i9(42400)|0;do if((b|0)==((f<<24>>24<0?d:f&255)|0)){if(VG(e,42400,b)|0){f=a[g>>0]|0;d=c[i>>2]|0;break}d=a[h>>0]|0;f=d<<24>>24<0;d=f?c[j>>2]|0:d&255;e=a[k>>0]|0;b=e<<24>>24<0;if((d|0)!=((b?c[m>>2]|0:e&255)|0)){b=1;break b}b=(L$(f?c[n>>2]|0:n,b?c[p>>2]|0:p,d)|0)!=0;break b}while(0);b=i9(42412)|0;if((b|0)==((f<<24>>24<0?d:f&255)|0)?(VG(e,42412,b)|0)==0:0){d=a[h>>0]|0;f=d<<24>>24<0;d=f?c[j>>2]|0:d&255;e=a[k>>0]|0;b=e<<24>>24<0;if((d|0)==((b?c[m>>2]|0:e&255)|0))b=(L$(f?c[n>>2]|0:n,b?c[p>>2]|0:p,d)|0)!=0;else b=1}else b=0}while(0);z5(p);z5(n)}l=q;return b|0}function sd(f){f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+16|0;m=u;s=f+768|0;k=c[s>>2]|0;t=f+762|0;i=b[t>>1]|0;g=c[(c[k+80>>2]|0)+((i&65535)<<2)>>2]|0;h=g+181|0;if(!(a[h>>0]|0)){a[h>>0]=1;j=0;h=k;while(1){if(j>>>0>=(c[g+8>>2]|0)-(c[g+4>>2]|0)>>1>>>0)break;k=(HD(h+68|0,h)|0)+16|0;if(!(a[($C(k,(c[(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0)+4>>2]|0)+(j<<1)|0)|0)+80>>0]|0)){k=c[s>>2]|0;k=(HD(k+68|0,k)|0)+16|0;a[($C(k,(c[(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0)+4>>2]|0)+(j<<1)|0)|0)+82>>0]=1;k=c[s>>2]|0;k=(HD(k+68|0,k)|0)+16|0;a[($C(k,(c[(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0)+4>>2]|0)+(j<<1)|0)|0)+80>>0]=1}h=c[s>>2]|0;g=b[t>>1]|0;j=j+1|0;i=g;g=c[(c[h+80>>2]|0)+((g&65535)<<2)>>2]|0}a[g+182>>0]=1;Pw(m,h+188|0,i,t);g=f+728|0;c[g>>2]=c[g>>2]|524292;g=c[s>>2]|0;k=g;g=c[(c[g+80>>2]|0)+(e[t>>1]<<2)>>2]|0}do if(!(a[f+764>>0]|0)){h=g+188|0;i=c[h>>2]|0;if(i|0)c[h>>2]=i+-1;h=c[g>>2]|0;m=f+765|0;if(!h){if(!(a[m>>0]|0))break;j=f+24|0;if((((a[k+2>>0]|0?(p=d[g+168>>0]|0,q=(HD(k+68|0,k)|0)+16|0,(hj(p,c[($C(q,c[(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0)+4>>2]|0)|0)+68>>2]|0)|0)==7):0)?(r=c[s>>2]|0,q=a[(c[(c[r+80>>2]|0)+(e[t>>1]<<2)>>2]|0)+168>>0]|0,q<<24>>24!=6&q<<24>>24>-1):0)?(r=(HD(r+68|0,r)|0)+16|0,(dq(c[($C(r,c[(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0)+4>>2]|0)|0)+68>>2]|0)|0)==7):0)?VQ(c[j>>2]|0)|0:0){UZ(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0,0);OZ(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0,0);wZ(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0,0);EZ(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0,0);g=c[s>>2]|0;i=(c[(c[g+80>>2]|0)+(e[t>>1]<<2)>>2]|0)+68|0;if(a[i>>0]|0)break;g=g+92|0;h=c[g>>2]|0;if(!h)break;a[i>>0]=1;c[g>>2]=h+-1;break}r=ZW(888)|0;lv(r);h=b[t>>1]|0;g=c[(c[s>>2]|0)+80>>2]|0;i=g+((h&65535)<<2)|0;c[c[i>>2]>>2]=r;if(a[f+810>>0]|0){wZ(c[i>>2]|0,1);h=b[t>>1]|0;g=c[(c[s>>2]|0)+80>>2]|0}h=c[g+((h&65535)<<2)>>2]|0;r=c[h>>2]|0;a[r+774>>0]=a[h+177>>0]|0;a[r+760>>0]=1;r=VQ(c[j>>2]|0)|0;h=c[s>>2]|0;g=c[(c[h+80>>2]|0)+(e[t>>1]<<2)>>2]|0;i=c[g>>2]|0;if(r)a[i+761>>0]=a[g+168>>0]|0;a[i+772>>0]=a[g+169>>0]|0;if((c[g+4>>2]|0)!=(c[g+8>>2]|0)){r=(HD(h+68|0,h)|0)+16|0;r=c[($C(r,c[(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0)+4>>2]|0)|0)+68>>2]|0;h=c[s>>2]|0;g=c[(c[h+80>>2]|0)+(e[t>>1]<<2)>>2]|0;i=c[g>>2]|0;c[i+764>>2]=r}c[i+768>>2]=c[g+160>>2];a[i+773>>0]=2;g=HD(h+68|0,h)|0;r=c[s>>2]|0;g=UD(g+44|0,b[(c[(c[r+80>>2]|0)+(e[t>>1]<<2)>>2]|0)+164>>1]|0)|0;if((g|0)==((HD(r+68|0,r)|0)+48|0)){g=b[t>>1]|0;h=c[(c[s>>2]|0)+80>>2]|0}else{p=g+20|0;r=b[t>>1]|0;h=c[(c[s>>2]|0)+80>>2]|0;q=h+((r&65535)<<2)|0;c[(c[c[q>>2]>>2]|0)+776>>2]=c[p>>2];c[p>>2]=0;g=g+24|0;c[(c[c[q>>2]>>2]|0)+780>>2]=c[g>>2];c[g>>2]=0;g=r}h=c[h+((g&65535)<<2)>>2]|0;a[(c[h>>2]|0)+732>>0]=1;OZ(h,1);h=c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0;g=c[h>>2]|0;a[g+734>>0]=a[h+184>>0]|0;aY(f,g);g=c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0;h=c[g>>2]|0}if((a[h+376>>0]|0)==0?(a[m>>0]|0)==0:0)break;if(a[g+69>>0]|0){r=g+96|0;t=c[r>>2]|0;r=c[r+4>>2]|0;s=(t|0)==-1&(r|0)==-1;r=UW(t|0,r|0,1e3,0)|0;r=g5(r|0,z|0,27,0)|0;t=h+128|0;c[t>>2]=s?-1:r;c[t+4>>2]=s?-1:z}rB(f,h);ri(f)}else{if(!(a[g+174>>0]|0)){OZ(g,1);g=c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0}if(((c[g+188>>2]|0)>>>0>16?(UZ(g,0),OZ(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0,0),wZ(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0,0),n=c[s>>2]|0,o=(c[(c[n+80>>2]|0)+(e[t>>1]<<2)>>2]|0)+68|0,(a[o>>0]|0)==0):0)?(p=n+92|0,q=c[p>>2]|0,q|0):0){a[o>>0]=1;c[p>>2]=q+-1}s=f+536|0;t=f+528|0;t=D_(c[s>>2]|0,c[s+4>>2]|0,c[t>>2]|0,c[t+4>>2]|0)|0;e1(f,t,z)}while(0);l=u;return}function td(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=l;l=l+64|0;s=x+36|0;t=x+52|0;u=x+24|0;v=x+12|0;w=x;i=x+48|0;j=x+46|0;m=x+44|0;n=x+51|0;o=x+50|0;q=x+42|0;r=x+40|0;bB(d,x+53|0);jB(d,s);pY(c[s>>2]|0,0,0,t);if(!(a[t>>0]|0)){TX(u);TX(v);TX(w);GC(d);s=d+528|0;k=s;k=z0(c[k>>2]|0,c[k+4>>2]|0,4,0)|0;t=s;c[t>>2]=k;c[t+4>>2]=z;NB(d,i);NB(d,j);t=d+536|0;k=t;f=c[k>>2]|0;k=c[k+4>>2]|0;h=s;g=c[h>>2]|0;h=c[h+4>>2]|0;if((b[j>>1]|0)==2){h=z0(g|0,h|0,-8,-1)|0;i=z0(h|0,z|0,e[i>>1]|0,0)|0;h=z;j=h>>>0>k>>>0|(h|0)==(k|0)&i>>>0>f>>>0;i=j?f:i;h=j?k:h;NB(d,m);bB(d,n);f=a[n>>0]|0;if((f&255)<=27){jZ(d,f&255,0,v);if(f<<24>>24!=27){n=27-(f&255)|0;e1(d,n,((n|0)<0)<<31>>31)}}else{a[n>>0]=27;jZ(d,27,0,v)}n=s;n=z0(c[n>>2]|0,c[n+4>>2]|0,12,0)|0;f=s;c[f>>2]=n;c[f+4>>2]=z;bB(d,o);f=a[o>>0]|0;if((f&255)>99){a[o>>0]=99;f=99}jZ(d,f&255,0,u);g=f&255;a:do if((f&255)>=63)if(f<<24>>24!=63){if((f&255)<67){p=67-g|0;e1(d,p,((p|0)<0)<<31>>31);p=17;break}if(f<<24>>24!=67){if((f&255)<71){p=71-g|0;e1(d,p,((p|0)<0)<<31>>31);p=21;break}if(f<<24>>24!=71){if((f&255)<75){p=75-g|0;e1(d,p,((p|0)<0)<<31>>31);p=25;break}if(f<<24>>24!=75){if((f&255)<79){p=79-g|0;e1(d,p,((p|0)<0)<<31>>31);p=29;break}switch(f<<24>>24){case 79:{p=29;break a}case 80:{p=81-g|0;e1(d,p,((p|0)<0)<<31>>31);p=32;break a}default:{}}if((f&255)>=82){if(f<<24>>24==82){p=83-g|0;e1(d,p,((p|0)<0)<<31>>31);p=36;break}if((f&255)<84)p=36;else{if((f&255)<87){p=87-g|0;e1(d,p,((p|0)<0)<<31>>31);p=40;break}switch(f<<24>>24){case 87:{p=40;break a}case 88:{p=89-g|0;e1(d,p,((p|0)<0)<<31>>31);p=43;break a}default:{}}if((f&255)<90){p=43;break}if((f&255)>=99)break;o=99-g|0;e1(d,o,((o|0)<0)<<31>>31)}}else p=32}else p=25}else p=21}else p=17}else p=13;else{p=63-g|0;e1(d,p,((p|0)<0)<<31>>31);p=13}while(0);if((p|0)==13){n=s;n=z0(c[n>>2]|0,c[n+4>>2]|0,4,0)|0;o=s;c[o>>2]=n;c[o+4>>2]=z;p=17}if((p|0)==17){n=s;n=z0(c[n>>2]|0,c[n+4>>2]|0,4,0)|0;o=s;c[o>>2]=n;c[o+4>>2]=z;p=21}if((p|0)==21){n=s;n=z0(c[n>>2]|0,c[n+4>>2]|0,4,0)|0;o=s;c[o>>2]=n;c[o+4>>2]=z;p=25}if((p|0)==25){n=s;n=z0(c[n>>2]|0,c[n+4>>2]|0,4,0)|0;o=s;c[o>>2]=n;c[o+4>>2]=z;p=29}if((p|0)==29){n=s;n=z0(c[n>>2]|0,c[n+4>>2]|0,2,0)|0;o=s;c[o>>2]=n;c[o+4>>2]=z;p=32}if((p|0)==32){n=s;n=z0(c[n>>2]|0,c[n+4>>2]|0,2,0)|0;o=s;c[o>>2]=n;c[o+4>>2]=z;p=36}if((p|0)==36){n=s;n=z0(c[n>>2]|0,c[n+4>>2]|0,4,0)|0;o=s;c[o>>2]=n;c[o+4>>2]=z;p=40}if((p|0)==40){n=s;n=z0(c[n>>2]|0,c[n+4>>2]|0,2,0)|0;o=s;c[o>>2]=n;c[o+4>>2]=z;p=43}if((p|0)==43)e1(d,10,0);f=d+500|0;while(1){p=s;o=c[p+4>>2]|0;if(!(o>>>0<h>>>0|((o|0)==(h|0)?(c[p>>2]|0)>>>0<i>>>0:0)))break;c[f>>2]=(c[f>>2]|0)+1;NB(d,q);NB(d,r);switch(b[q>>1]|0){case 0:{g=b[r>>1]|0;jZ(d,g&65535,0,w);break}case 2:{g=b[r>>1]|0;iF(d,g&65535,0);break}case -1:{g=s;e1(d,D_(i|0,h|0,c[g>>2]|0,c[g+4>>2]|0)|0,z);g=b[r>>1]|0;break}default:{g=b[r>>1]|0;iF(d,g&65535,0)}}if(g&1){o=s;o=z0(c[o>>2]|0,c[o+4>>2]|0,1,0)|0;p=s;c[p>>2]=o;c[p+4>>2]=z}}J3(d);i=s;h=c[i>>2]|0;i=c[i+4>>2]|0;g=t;f=c[g>>2]|0;g=c[g+4>>2]|0;if(g>>>0>i>>>0|(g|0)==(i|0)&f>>>0>h>>>0){t=D_(f|0,g|0,h|0,i|0)|0;e1(d,t,z)}if(qO(d)|0){i=d+916|0;h=d+788|0;f=bF(i,h)|0;g=a[f+8+3>>0]|0;if(g<<24>>24<0)f=c[f+4>>2]|0;else f=g&255;if(!f){f=w+8+3|0;d=a[f>>0]|0;g=w+4|0;if((d<<24>>24<0?c[g>>2]|0:d&255)|0){s=bF(i,h)|0;d=a[f>>0]|0;t=d<<24>>24<0;Ex(s,t?c[w>>2]|0:w,t?c[g>>2]|0:d&255)|0;Gx(bF(i,h)|0,47)}s=bF(i,h)|0;d=a[u+8+3>>0]|0;t=d<<24>>24<0;Ex(s,t?c[u>>2]|0:u,t?c[u+4>>2]|0:d&255)|0}}}else{t=D_(f|0,k|0,g|0,h|0)|0;e1(d,t,z)}z5(w);z5(v);z5(u)}l=x;return}function ud(d){d=d|0;var f=0,h=0,i=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;q=d+768|0;h=c[q>>2]|0;do if(h|0){l=d+728|0;f=c[l>>2]|0;n=d+552|0;o=d+560|0;x=d+776|0;if((f&1|0)==0?(B=n,D=o,D=D_(c[B>>2]|0,c[B+4>>2]|0,c[D>>2]|0,c[D+4>>2]|0)|0,B=z,E=x,E=XZ(c[E>>2]|0,c[E+4>>2]|0,2)|0,C=z,!(B>>>0<C>>>0|(B|0)==(C|0)&D>>>0<E>>>0)):0){z$(d);break}B=d+784|0;C=d+792|0;D=d+548|0;E=d+48|0;a:do if(!(f&2)){y=d+40|0;if(!(c[h+92>>2]|0)){if(!(a[d+760>>0]|0))if(!((a[h+2>>0]|0)!=0?!(c[(HD(h+68|0,h)|0)+40>>2]|0):0))A=10}else A=10;do if((A|0)==10){i=n;k=o;k=D_(c[i>>2]|0,c[i+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0;i=z;p=x;j=c[p+4>>2]|0;if(!(i>>>0<j>>>0|((i|0)==(j|0)?k>>>0<(c[p>>2]|0)>>>0:0))?+g[(c[d+24>>2]|0)+136>>2]<.8:0)break;k=E;k=z0(c[D>>2]|0,0,c[k>>2]|0,c[k+4>>2]|0)|0;p=y;if(!((k|0)==(c[p>>2]|0)?(z|0)==(c[p+4>>2]|0):0)){A=55;break a}}while(0);j=c[q>>2]|0;f=c[j+188>>2]|0;b:while(1){if((f|0)==(j+192|0))break;k=f+14|0;i=b[k>>1]|0;h=c[c[(c[j+80>>2]|0)+((i&65535)<<2)>>2]>>2]|0;if(!h)h=0;else{s4(h);j=c[q>>2]|0;i=b[k>>1]|0;h=c[(c[j+80>>2]|0)+((i&65535)<<2)>>2]|0;p=(c[h>>2]|0)+728|0;c[p>>2]=c[p>>2]&-5;a[h+183>>0]=1;h=0}while(1){p=c[(c[j+80>>2]|0)+((i&65535)<<2)>>2]|0;if(h>>>0>=(c[p+8>>2]|0)-(c[p+4>>2]|0)>>1>>>0)break;i=(HD(j+68|0,j)|0)+16|0;a[($C(i,(c[(c[(c[(c[q>>2]|0)+80>>2]|0)+(e[k>>1]<<2)>>2]|0)+4>>2]|0)+(h<<1)|0)|0)+82>>0]=1;h=h+1|0;i=b[k>>1]|0;j=c[q>>2]|0}h=c[f+4>>2]|0;if(!h)while(1){h=c[f+8>>2]|0;if((c[h>>2]|0)==(f|0)){f=h;continue b}else f=h}else f=h;while(1){h=c[f>>2]|0;if(!h)break;else f=h}}c[j+92>>2]=0;jt(d);p=d+24|0;c:do if(UQ(c[p>>2]|0)|0){f=c[q>>2]|0;h=c[f+188>>2]|0;while(1){if((h|0)==(f+192|0))break c;k=h+14|0;UZ(c[(c[f+80>>2]|0)+(e[k>>1]<<2)>>2]|0,0);OZ(c[(c[(c[q>>2]|0)+80>>2]|0)+(e[k>>1]<<2)>>2]|0,0);f=c[h+4>>2]|0;if(!f)while(1){f=c[h+8>>2]|0;if((c[f>>2]|0)==(h|0))break;else h=f}else while(1){h=c[f>>2]|0;if(!h)break;else f=h}h=f;f=c[q>>2]|0}}while(0);c[l>>2]=c[l>>2]|524292;h=o;f=c[h>>2]|0;h=c[h+4>>2]|0;n=D_(c[n>>2]|0,c[n+4>>2]|0,f|0,h|0)|0;k=z;o=x;l=c[o+4>>2]|0;m=+g[(c[p>>2]|0)+136>>2];do if(!((k>>>0>l>>>0|((k|0)==(l|0)?n>>>0>=(c[o>>2]|0)>>>0:0))&m<.8)){l=E;j=c[d+612>>2]|0;l=D_(c[l>>2]|0,c[l+4>>2]|0,f|0,h|0)|0;l=z0(j|0,0,l|0,z|0)|0;j=z;o=x;c[o>>2]=l;c[o+4>>2]=j;o=B;c[o>>2]=l;c[o+4>>2]=j;d:do if(m<.5){f=c[q>>2]|0;h=c[f+84>>2]|0;f=c[f+80>>2]|0;while(1){if((f|0)==(h|0)){f=j;break d}i=c[f>>2]|0;if((((i|0?(c[i+64>>2]|0)==1:0)?(s=i+80|0,r=c[s>>2]|0,s=c[s+4>>2]|0,!((r|0)==-1&(s|0)==-1)):0)?(u=i+96|0,t=c[u>>2]|0,u=c[u+4>>2]|0,!((t|0)==-1&(u|0)==-1|(t|0)==(r|0)&(u|0)==(s|0))):0)?(v=D_(t|0,u|0,r|0,s|0)|0,w=z,w>>>0<0|(w|0)==0&v>>>0<54e6):0)break;f=f+4|0}if((v|0)==0&(w|0)==0){f=0;h=0}else{f=g5(54e6,0,v|0,w|0)|0;h=z}v=UW(f|0,h|0,l|0,j|0)|0;t=z;w=B;c[w>>2]=v;c[w+4>>2]=t;w=xP()|0;w=XZ(w|0,z|0,2)|0;u=z;if(t>>>0>u>>>0|(t|0)==(u|0)&v>>>0>w>>>0){l=xP()|0;l=XZ(l|0,z|0,2)|0;f=z;w=B;c[w>>2]=l;c[w+4>>2]=f;break}else{f=B;l=c[f>>2]|0;f=c[f+4>>2]|0;break}}else f=j;while(0);h=x;h=z0(c[h>>2]|0,c[h+4>>2]|0,l|0,f|0)|0;i=z;k=y;j=c[k>>2]|0;k=c[k+4>>2]|0;if(!(i>>>0<k>>>0|(i|0)==(k|0)&h>>>0<j>>>0))if(i>>>0>k>>>0|(i|0)==(k|0)&h>>>0>j>>>0){c[x>>2]=j;c[x+4>>2]=k;x=B;c[x>>2]=0;c[x+4>>2]=0;break}else{w=D_(j|0,k|0,l|0,f|0)|0;c[x>>2]=w;c[x+4>>2]=z;break}}while(0);f=c[p>>2]|0;if(+g[f+136>>2]<1.0?SR(f)|0:0){f=C;h=c[f>>2]|0;f=c[f+4>>2]|0;if((h|0)==-1&(f|0)==-1){x=E;x=z0(c[D>>2]|0,0,c[x>>2]|0,c[x+4>>2]|0)|0;w=z;A=y;h=B;f=c[h>>2]|0;h=c[h+4>>2]|0;A=D_(c[A>>2]|0,c[A+4>>2]|0,f|0,h|0)|0;y=z;if((f|0)==0&(h|0)==0|(w>>>0>y>>>0|(w|0)==(y|0)&x>>>0>=A>>>0))A=55;else{CI(d,f,h);a[d+810>>0]=0;Kl(d);A=55}}}else A=55}else A=55;while(0);if((A|0)==55){f=C;h=c[f>>2]|0;f=c[f+4>>2]|0;if((h|0)==-1&(f|0)==-1)break}E=z0(c[D>>2]|0,0,c[E>>2]|0,c[E+4>>2]|0)|0;D=z;if(!(D>>>0<f>>>0|(D|0)==(f|0)&E>>>0<h>>>0)){E=C;c[E>>2]=-1;c[E+4>>2]=-1;E=B;CI(d,c[E>>2]|0,c[E+4>>2]|0);Kl(d)}}while(0);return}function vd(a){a=a|0;var b=0;a:do if(a<<16>>16>=126){if(a<<16>>16<270)do switch(a<<16>>16){case 126:{a=389619;break a}case 133:{a=389607;break a}case 144:{a=389603;break a}case 160:{a=389590;break a}case 161:{a=389590;break a}case 162:{a=389590;break a}case 163:{a=389590;break a}case 164:{a=389590;break a}case 165:{a=389590;break a}case 166:{a=389586;break a}case 167:{a=389576;break a}case 168:{a=389569;break a}case 169:{a=389553;break a}case 176:{a=388268;break a}case 177:{a=388268;break a}case 178:{a=388268;break a}case 179:{a=388268;break a}case 180:{a=389537;break a}case 181:{a=389521;break a}case 186:{a=389492;break a}case 192:{a=389485;break a}case 193:{a=389485;break a}case 194:{a=389485;break a}case 195:{a=389485;break a}case 196:{a=389485;break a}case 197:{a=389485;break a}case 198:{a=389485;break a}case 199:{a=389485;break a}case 200:{a=389485;break a}case 201:{a=389485;break a}case 202:{a=389485;break a}case 203:{a=389485;break a}case 204:{a=389485;break a}case 205:{a=389485;break a}case 256:{a=389467;break a}default:{b=140;break a}}while(0);if(a<<16>>16<4098)do switch(a<<16>>16){case 270:{a=389433;break a}case 272:{a=389424;break a}case 318:{a=389390;break a}case 366:{a=389356;break a}case 670:{a=389322;break a}case 702:{a=389275;break a}case 878:{a=389241;break a}case 1e3:{a=389235;break a}case 1166:{a=389201;break a}case 2048:{a=389189;break a}case 2049:{a=389189;break a}case 2176:{a=389172;break a}case 2178:{a=389155;break a}case 2179:{a=389137;break a}case 2191:{a=389128;break a}case 4096:{a=389092;break a}case 4097:{a=389055;break a}default:{b=140;break a}}while(0);if(a<<16>>16<4107)switch(a<<16>>16){case 4098:{a=389011;break a}case 4099:{a=388969;break a}case 4100:{a=388926;break a}case 4101:{a=388883;break a}case 4102:{a=388840;break a}case 4103:{a=388797;break a}case 4104:{a=388758;break a}case 4105:{a=388719;break a}case 4106:{a=388680;break a}default:{b=140;break a}}if(a<<16>>16<8916){if(a<<16>>16>=8228)switch(a<<16>>16){case 8228:{a=388455;break a}case 8468:{a=388417;break a}default:{b=140;break a}}if(a<<16>>16<8192){switch(a<<16>>16){case 4107:break;default:{b=140;break a}}a=388641;break}else{switch(a<<16>>16){case 8192:break;default:{b=140;break a}}a=388609;break}}if(a<<16>>16<9018)switch(a<<16>>16){case 8916:{a=388570;break a}case 8945:{a=388531;break a}default:{b=140;break a}}if(a<<16>>16<12288){switch(a<<16>>16){case 9018:break;default:{b=140;break a}}a=388497;break}if(a<<16>>16<20480){switch(a<<16>>16){case 12288:break;default:{b=140;break a}}a=388399;break}else{switch(a<<16>>16){case 20480:break;default:{b=140;break a}}a=388381;break}}else do switch(a<<16>>16){case 1:{a=390527;break a}case 2:{a=390496;break a}case 3:{a=390488;break a}case 4:{a=390480;break a}case 5:{a=390472;break a}case 6:{a=390464;break a}case 7:{a=390456;break a}case 8:{a=390448;break a}case 9:{a=390440;break a}case 10:{a=390432;break a}case 11:{a=390424;break a}case 12:{a=390415;break a}case 13:{a=390406;break a}case 14:{a=390397;break a}case 15:{a=390388;break a}case 16:{a=390379;break a}case 17:{a=390370;break a}case 18:{a=390361;break a}case 19:{a=390352;break a}case 20:{a=390343;break a}case 21:{a=390334;break a}case 22:{a=390325;break a}case 23:{a=390316;break a}case 24:{a=390307;break a}case 25:{a=390298;break a}case 32:{a=390292;break a}case 33:{a=390273;break a}case 34:{a=390254;break a}case 35:{a=390235;break a}case 36:{a=390216;break a}case 37:{a=390197;break a}case 38:{a=390178;break a}case 39:{a=390158;break a}case 40:{a=390138;break a}case 41:{a=390114;break a}case 48:{a=390089;break a}case 49:{a=390066;break a}case 50:{a=390047;break a}case 51:{a=390028;break a}case 52:{a=390009;break a}case 53:{a=389985;break a}case 55:{a=389977;break a}case 64:{a=389934;break a}case 65:{a=389925;break a}case 70:{a=389904;break a}case 71:{a=389904;break a}case 80:{a=389868;break a}case 81:{a=389862;break a}case 82:{a=389840;break a}case 85:{a=389816;break a}case 88:{a=389769;break a}case 94:{a=389727;break a}case 95:{a=389697;break a}case 96:{a=388343;break a}case 105:{a=389682;break a}case 112:{a=389652;break a}case 115:{a=388399;break a}case -4096:{a=388360;break a}case -4095:{a=388343;break a}case -4080:{a=388326;break a}case -4064:{a=388293;break a}case -1028:{a=388287;break a}case -1027:{a=388272;break a}case -1026:{a=388268;break a}case -1025:{a=388261;break a}case -1024:{a=388240;break a}case -1008:{a=388221;break a}case -768:{a=388196;break a}case -512:{a=388175;break a}default:{b=140;break a}}while(0);while(0);if((b|0)==140)a=8800948;return a|0}function wd(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+80|0;u=w+68|0;v=w+56|0;q=w;W0(u,d+360|0);p2(v,e);uP(v)|0;m=e+8+3|0;t=a[m>>0]|0;j=e+4|0;a:do if(!((t<<24>>24<0?c[j>>2]|0:t&255)|0)){c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=0;while(1){if((g|0)==3)break a;c[b+(g<<2)>>2]=0;g=g+1|0}}else{g=i9(4864)|0;k=v+8+3|0;i=a[k>>0]|0;n=v+4|0;h=c[n>>2]|0;s=b+8|0;p=d+20|0;t=b+4|0;r=s+3|0;do if((g|0)==((i<<24>>24<0?h:i&255)|0)){if(VG(v,4864,g)|0){i=a[k>>0]|0;h=c[n>>2]|0;break}g=c[p>>2]|0;do if(g|0){h=c[(c[g>>2]|0)+8>>2]|0;Xy(q,4928);g=lb[h&63](g,0,0,q,1,0)|0;h=i9(409096)|0;p=a[g+8+3>>0]|0;if((h|0)==((p<<24>>24<0?c[g+4>>2]|0:p&255)|0)){p=(VG(g,409096,h)|0)==0;z5(q);if(p)break}else z5(q);Vx(q,(a[f+8+3>>0]|0)<0?c[f>>2]|0:f);tj(q);c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;h=i9(409096)|0;if(h>>>0>1073741807)uaa();do if(h>>>0>=2){g=h+4&-4;if(g>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{r=ZW(g<<2)|0;c[b>>2]=r;c[s>>2]=g|-2147483648;c[t>>2]=h;g=r;break}}else{a[r>>0]=h;g=b}while(0);a3(g,409096,h);y7(g+(h<<2)|0,0);LT(q);break a}while(0);c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;h=i9(409096)|0;if(h>>>0>1073741807)uaa();do if(h>>>0>=2){g=h+4&-4;if(g>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{r=ZW(g<<2)|0;c[b>>2]=r;c[s>>2]=g|-2147483648;c[t>>2]=h;g=r;break}}else{a[r>>0]=h;g=b}while(0);a3(g,409096,h);y7(g+(h<<2)|0,0);break a}while(0);g=i9(4980)|0;do if((g|0)==((i<<24>>24<0?h:i&255)|0)){if(VG(v,4980,g)|0){i=a[k>>0]|0;h=c[n>>2]|0;break}g=c[p>>2]|0;if(g|0)jb[c[(c[g>>2]|0)+4>>2]&511](g);c[p>>2]=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;h=i9(409096)|0;if(h>>>0>1073741807)uaa();do if(h>>>0>=2){g=h+4&-4;if(g>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{r=ZW(g<<2)|0;c[b>>2]=r;c[s>>2]=g|-2147483648;c[t>>2]=h;g=r;break}}else{a[r>>0]=h;g=b}while(0);a3(g,409096,h);y7(g+(h<<2)|0,0);break a}while(0);g=i9(5032)|0;if((g|0)==((i<<24>>24<0?h:i&255)|0)?(VG(v,5032,g)|0)==0:0){c[d+352>>2]=1;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;h=i9(409096)|0;if(h>>>0>1073741807)uaa();do if(h>>>0>=2){g=h+4&-4;if(g>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{r=ZW(g<<2)|0;c[b>>2]=r;c[s>>2]=g|-2147483648;c[t>>2]=h;g=r;break}}else{a[r>>0]=h;g=b}while(0);a3(g,409096,h);y7(g+(h<<2)|0,0);break}g=i9(5060)|0;m=a[m>>0]|0;if((g|0)==((m<<24>>24<0?c[j>>2]|0:m&255)|0)?(VG(e,5060,g)|0)==0:0){c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;h=i9(5124)|0;if(h>>>0>1073741807)uaa();do if(h>>>0>=2){g=h+4&-4;if(g>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{r=ZW(g<<2)|0;c[b>>2]=r;c[s>>2]=g|-2147483648;c[t>>2]=h;g=r;break}}else{a[r>>0]=h;g=b}while(0);a3(g,5124,h);y7(g+(h<<2)|0,0);break}g=a[k>>0]|0;h=g<<24>>24<0;j=h?c[v>>2]|0:v;i=i9(5184)|0;if(i|0?(o=j+((h?c[n>>2]|0:g&255)<<2)|0,n=HA(j,o,5184,5184+(i<<2)|0)|0,!((n|0)!=(o|0)&(n|0)==(j|0))):0){g=i9(5432)|0;if(g|0?(t=HA(j,o,5432,5432+(g<<2)|0)|0,!((t|0)!=(o|0)&(t|0)==(j|0))):0){bl(q,e,f);c[b>>2]=c[q>>2];c[b+4>>2]=c[q+4>>2];c[b+8>>2]=c[q+8>>2];g=0;while(1){if((g|0)==3)break;c[q+(g<<2)>>2]=0;g=g+1|0}z5(q);break}Wk(q,d+80|0,e,f);g=c[p>>2]|0;if(g|0)jb[c[(c[g>>2]|0)+44>>2]&511](g);Ww(b,q);z5(q);break}c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;h=i9(5224)|0;if(h>>>0>1073741807)uaa();do if(h>>>0>=2){g=h+4&-4;if(g>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{r=ZW(g<<2)|0;c[b>>2]=r;c[s>>2]=g|-2147483648;c[t>>2]=h;g=r;break}}else{a[r>>0]=h;g=b}while(0);a3(g,5224,h);y7(g+(h<<2)|0,0)}while(0);z5(v);s7(c[u>>2]|0);l=w;return}function xd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+96|0;k=q+48|0;m=q+36|0;n=q+24|0;o=q+12|0;p=q;if((d|0)<=7?(RA(b,d,-1)|0)>>>0>e>>>0:0){if((d|0)!=0&(a[b+492>>0]|0)==0){i=Vj(b,d,0,3,1)|0;mI(k);Xy(m,41840);z3(k,m);z5(m);Bs(p,i,6064);p2(o,p);pk(n,o);gq(m,b,0,0,(a[n+11>>0]|0)<0?c[n>>2]|0:n);og(k,m);z5(m);a1(n);z5(o);O0(p);j=k+4|0;g=c[j>>2]|0;f=c[k>>2]|0;h=g;a:do if(((g-f|0)/12|0)>>>0>e>>>0){g=f+(e*12|0)|0;while(1){f=g+12|0;if((f|0)==(h|0))break;vF(g,f)|0;g=f}while(1){f=c[j>>2]|0;if((f|0)==(g|0))break a;h=f+-12|0;c[j>>2]=h;z5(h)}}while(0);Bs(o,i,6064);p2(n,o);pk(m,n);f=a[m+11>>0]|0;g=c[m>>2]|0;de(p,k);Mc(b,0,0,f<<24>>24<0?g:m,p,1);z5(p);a1(m);z5(n);O0(o);Bs(p,i,6112);p2(o,p);pk(n,o);gq(m,b,0,0,(a[n+11>>0]|0)<0?c[n>>2]|0:n);og(k,m);z5(m);a1(n);z5(o);O0(p);g=c[j>>2]|0;f=c[k>>2]|0;h=g;b:do if(((g-f|0)/12|0)>>>0>e>>>0){g=f+(e*12|0)|0;while(1){f=g+12|0;if((f|0)==(h|0))break;vF(g,f)|0;g=f}while(1){f=c[j>>2]|0;if((f|0)==(g|0))break b;h=f+-12|0;c[j>>2]=h;z5(h)}}while(0);Bs(o,i,6112);p2(n,o);pk(m,n);f=a[m+11>>0]|0;g=c[m>>2]|0;de(p,k);Mc(b,0,0,f<<24>>24<0?g:m,p,1);z5(p);a1(m);z5(n);O0(o);Bs(p,i,6172);p2(o,p);pk(n,o);gq(m,b,0,0,(a[n+11>>0]|0)<0?c[n>>2]|0:n);og(k,m);z5(m);a1(n);z5(o);O0(p);g=c[j>>2]|0;f=c[k>>2]|0;h=g;c:do if(((g-f|0)/12|0)>>>0>e>>>0){g=f+(e*12|0)|0;while(1){f=g+12|0;if((f|0)==(h|0))break;vF(g,f)|0;g=f}while(1){f=c[j>>2]|0;if((f|0)==(g|0))break c;h=f+-12|0;c[j>>2]=h;z5(h)}}while(0);Bs(o,i,6172);p2(n,o);pk(m,n);f=a[m+11>>0]|0;g=c[m>>2]|0;de(p,k);Mc(b,0,0,f<<24>>24<0?g:m,p,1);z5(p);a1(m);z5(n);O0(o);Bs(p,i,6224);p2(o,p);pk(n,o);gq(m,b,0,0,(a[n+11>>0]|0)<0?c[n>>2]|0:n);og(k,m);z5(m);a1(n);z5(o);O0(p);g=c[j>>2]|0;f=c[k>>2]|0;h=g;d:do if(((g-f|0)/12|0)>>>0>e>>>0){g=f+(e*12|0)|0;while(1){f=g+12|0;if((f|0)==(h|0))break;vF(g,f)|0;g=f}while(1){f=c[j>>2]|0;if((f|0)==(g|0))break d;h=f+-12|0;c[j>>2]=h;z5(h)}}while(0);Bs(o,i,6224);p2(n,o);pk(m,n);h=a[m+11>>0]|0;j=c[m>>2]|0;de(p,k);Mc(b,0,0,h<<24>>24<0?j:m,p,1);z5(p);a1(m);z5(n);O0(o);Bs(o,i,6312);p2(n,o);pk(m,n);i=a[m+11>>0]|0;j=c[m>>2]|0;p=RA(b,d,-1)|0;fM(b,0,0,i<<24>>24<0?j:m,p+-1|0,1);a1(m);z5(n);O0(o);$_(k)}h=c[c[b+4>>2]>>2]|0;i=h+(d*12|0)+4|0;g=c[i>>2]|0;h=(c[h+(d*12|0)>>2]|0)+(e*40|0)|0;while(1){f=h+40|0;if((f|0)==(g|0))break;Kq(h,f)|0;h=f}while(1){f=c[i>>2]|0;if((f|0)==(h|0))break;p=f+-40|0;c[i>>2]=p;$_(p)}g=c[c[b+8>>2]>>2]|0;i=g+(d*12|0)+4|0;h=c[i>>2]|0;g=(c[g+(d*12|0)>>2]|0)+(e*56|0)|0;while(1){f=g+56|0;if((f|0)==(h|0))break;it(g,f)|0;g=f}while(1){f=c[i>>2]|0;if((f|0)==(g|0))break;e=f+-56|0;c[i>>2]=e;LT(e)}g=b+16|0;f=0;while(1){if(f>>>0>=(RA(b,d,-1)|0)>>>0)break;lL(b,d,f,2,RA(b,c[g>>2]|0,-1)|0,10,1);lL(b,d,f,5,f,10,1);h=f+1|0;if((RA(b,d,-1)|0)>>>0>1){lL(b,d,f,6,h,10,1);f=h;continue}else{Ed(b,d,f,6);f=h;continue}}c[g>>2]=7;c[b+20>>2]=-1}l=q;return}function yd(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+32|0;r=w+16|0;u=w+15|0;t=w;j=w+14|0;n=w+12|0;a[r>>0]=0;a[u>>0]=0;GC(d);v=d+2462|0;DP(d,v);c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;g=j9(390999)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[t+11>>0]=g;f=t}else{s=g+16&-16;f=ZW(s)|0;c[t>>2]=f;c[t+8>>2]=s|-2147483648;c[t+4>>2]=g}i1(f,390999,g)|0;J7(f+g|0,0);h=VC(d+22136|0,t)|0;Ck(h,a[v>>0]|0,10)|0;a1(t);h=d+2468|0;xR(d,4,h);f=a[h>>0]|0;s=d+112|0;if(f<<24>>24==15){rR(d,24,t);q=c[t>>2]|0;p=s;c[p>>2]=q;c[p+4>>2]=0;a[h>>0]=sv(q,0)|0}else{q=s;c[q>>2]=c[11828+((f&255)<<2)>>2];c[q+4>>2]=0}xR(d,4,d+2464|0);g=a[v>>0]|0;m=d+2463|0;p=d+2472|0;q=d+2469|0;switch(g<<24>>24){case 29:case 5:{a[m>>0]=5;a[r>>0]=1;if(g<<24>>24==29)a[u>>0]=1;xR(d,4,q);f=a[q>>0]|0;if(f<<24>>24==15){rR(d,24,p);a[h>>0]=sv(c[p>>2]|0,0)|0}else c[p>>2]=c[11828+((f&255)<<2)>>2];DP(d,v);g=a[v>>0]|0;if(g<<24>>24==22){d4(c[d+648>>2]|0,4);f=1;g=a[v>>0]|0}else f=1;break}default:{a[m>>0]=0;f=0}}h=d+312|0;i=d+760|0;do switch(g<<24>>24){case 23:case 22:case 21:case 20:case 19:case 17:case 7:case 6:case 4:case 3:case 2:case 1:{co(d);k=37;break}case 8:{tI(d);k=37;break}case 9:{wP(d);k=37;break}case 12:{bA(d);k=37;break}case 24:{IH(d);k=37;break}case 25:{yO(d);k=37;break}case 27:case 26:{SL(d);k=37;break}case 28:{_G(d);k=37;break}case 34:case 33:case 32:{eX(d);k=37;break}case 35:{KO(d);k=37;break}case 36:{d4(c[d+648>>2]|0,5);sf(d);k=37;break}case 38:case 37:{FE(d);k=37;break}case 39:{kp(d);k=37;break}default:{GC(d);v=c[d+648>>2]|0;G4(v,(Z9(c[v+4>>2]|0)|0)-((e|0)==-1?0:e)|0);J3(d);if(qO(d)|0){switch(c[d+908>>2]|0){case 4:case 3:{xp(i,0);break}case 1:{KM(d);break}default:{}}v=h;c[v>>2]=-1;c[v+4>>2]=0}}}while(0);a:do if((k|0)==37){b:do switch(a[v>>0]|0){case 39:case 27:case 26:case 25:case 24:case 23:case 22:case 21:case 20:case 19:case 17:{xR(d,2,j);g=a[j>>0]|0;if((g&-2)<<24>>24==2?(Jj(d),g<<24>>24==3):0){AT(d,t);if(a[t>>0]|0)break b;GC(d);u=c[d+648>>2]|0;v=Z9(c[u+4>>2]|0)|0;G4(u,v-((e|0)==-1?0:e)|0);J3(d);switch(c[d+908>>2]|0){case 4:case 3:{xp(i,0);break}case 5:{pO(d);k=44;break}default:k=44}if((k|0)==44)KM(d);v=h;c[v>>2]=-1;c[v+4>>2]=0;break a}break}default:{}}while(0);o=d+648|0;if((e|0)!=-1&(a[m>>0]|0)!=5?(Z9(c[(c[o>>2]|0)+4>>2]|0)|0)>>>0>=(e+16|0)>>>0:0){sR(d,11,t);if((b[t>>1]|0)==695){DP(d,m);h=a[m>>0]|0;if(h<<24>>24==5){AT(d,r);f=a[r>>0]|0;if(f<<24>>24){xR(d,4,q);g=a[q>>0]|0;if(g<<24>>24==15){rR(d,24,p);a[q>>0]=sv(c[p>>2]|0,0)|0}else c[p>>2]=c[11828+((g&255)<<2)>>2];if((Z9(c[(c[o>>2]|0)+4>>2]|0)|0)>>>0>=(e+12|0)>>>0){sR(d,11,n);if((b[n>>1]|0)==1352){AT(d,u);g=1}else g=0}else g=0}else g=0;h=a[m>>0]|0}else g=0;if(h<<24>>24==29){AT(d,r);i=a[r>>0]|0;do if(i<<24>>24){xR(d,4,q);f=a[q>>0]|0;if(f<<24>>24==15){rR(d,24,p);a[q>>0]=sv(c[p>>2]|0,0)|0;break}else{c[p>>2]=c[11828+((f&255)<<2)>>2];break}}while(0);d4(c[o>>2]|0,4);h=1;f=i}else h=1}else{h=0;g=0}k=h;j=(g&1)!=0;i=f}else{k=0;j=0;i=f}J3(d);g=c[o>>2]|0;f=c[g+4>>2]|0;h=Z9(f)|0;if(h>>>0>e>>>0){a[t>>0]=-1;h=h-e|0;if(h>>>0<8){qR(d,h&255,t);f=c[o>>2]|0;g=f;f=c[f+4>>2]|0}G4(g,(Z9(f)|0)-e|0)}if(qO(d)|0){e=s;Jb(d,c[e>>2]|0,c[e+4>>2]|0,a[v>>0]|0,k,j,i<<24>>24!=0,(a[u>>0]|0)!=0)}}while(0);l=w;return}function zd(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,P=0,Q=0,R=0;Q=l;l=l+128|0;g=Q+118|0;E=Q+117|0;F=Q+116|0;G=Q+115|0;H=Q+100|0;I=Q+96|0;J=Q+114|0;K=Q+113|0;s=Q+112|0;t=Q+84|0;x=Q+72|0;y=Q+60|0;z=Q+48|0;A=Q+36|0;B=Q+24|0;C=Q+12|0;D=Q;f=c[b+840>>2]|0;q=(c[b+844>>2]|0)-f|0;e=(e|0)==-1?((q|0)!=4)<<31>>31:e;if(e>>>0<q>>2>>>0?(P=f+(e<<2)|0,(c[P>>2]|0)!=0):0){a[g>>0]=-1;Bx(b);e=c[c[P>>2]>>2]|0;if(rX(e)|0){p=c[(c[e>>2]|0?e:e+4|0)>>2]|0;e=a[p+14>>0]|0;q=b+648|0;d4(c[q>>2]|0,(d[p+13>>0]|0)+1&255);d4(c[q>>2]|0,(e&255)+1&255);e=c[c[P>>2]>>2]|0}a:do if((e|0)!=0?(a[e+31>>0]|0)!=0:0){xR(b,4,g);e=a[g>>0]|0;switch(e<<24>>24){case 6:case 5:case 4:case 3:case 2:case 1:case 0:{f=1;break}case 7:{f=2;break}case 8:{f=3;break}default:break a}a[b+1045>>0]=f;j=a[380625+(e&255)>>0]|0;a[E>>0]=0;a[F>>0]=0;a[G>>0]=0;k=C+8+3|0;m=C+4|0;n=D+8+3|0;o=D+4|0;p=t+8+3|0;q=t+4|0;i=b+648|0;h=0;while(1){if((h&255)>=(j&255))break;GC(b);if(K6(c[i>>2]|0)|0){GC(b);A6(c[i>>2]|0);TX(H);c[I>>2]=0;d4(c[i>>2]|0,2);AT(b,s);d4(c[i>>2]|0,5);AT(b,K);A6(c[i>>2]|0);A6(c[i>>2]|0);xR(b,8,J);do if(!(a[K>>0]|0)){if(!(K6(c[i>>2]|0)|0)){A6(c[i>>2]|0);break}GC(b);A6(c[i>>2]|0);xR(b,6,E);if(K6(c[i>>2]|0)|0){GC(b);A6(c[i>>2]|0);xR(b,6,F);if(K6(c[i>>2]|0)|0){GC(b);A6(c[i>>2]|0);xR(b,5,G);J3(b)}else A6(c[i>>2]|0);J3(b)}else A6(c[i>>2]|0);J3(b)}else{xR(b,6,E);xR(b,6,F);xR(b,5,G)}while(0);uU(B,a[G>>0]|0,10);Gx(B,58);c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];f=0;while(1){if((f|0)==3)break;c[B+(f<<2)>>2]=0;f=f+1|0}uU(C,a[F>>0]|0,10);f=a[k>>0]|0;r=f<<24>>24<0;Ex(A,r?c[C>>2]|0:C,r?c[m>>2]|0:f&255)|0;c[z>>2]=c[A>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];f=0;while(1){if((f|0)==3)break;c[A+(f<<2)>>2]=0;f=f+1|0}Gx(z,58);c[y>>2]=c[z>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];f=0;while(1){if((f|0)==3)break;c[z+(f<<2)>>2]=0;f=f+1|0}uU(D,a[E>>0]|0,10);f=a[n>>0]|0;r=f<<24>>24<0;Ex(y,r?c[D>>2]|0:D,r?c[o>>2]|0:f&255)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];f=0;while(1){if((f|0)==3)break;c[y+(f<<2)>>2]=0;f=f+1|0}p2(t,x);vF(H,t)|0;z5(t);O0(x);z5(D);O0(y);O0(z);z5(C);O0(A);z5(B);f=c[c[P>>2]>>2]|0;if(rX(f)|0){g=a[(c[(c[f>>2]|0?f:f+4|0)>>2]|0)+15>>0]|0;if(!(g<<24>>24)){v=f;r=43}else{rR(b,g,I);u=c[c[P>>2]>>2]|0;r=42}}else{u=f;r=42}if((r|0)==42?(r=0,u|0):0){v=u;r=43}if(((r|0)==43?(0,a[v+29>>0]|0):0)?(w=c[v+12>>2]|0,w|0):0){R=a[J>>0]|0;f=c[v+8>>2]|0;g=a[s>>0]|0;r=c[I>>2]|0;Gx(H,46);ST(t,+(((O(O(R&255,f)|0,g+1&255)|0)+r|0)>>>0)/+(w>>>0),3);r=a[p>>0]|0;g=r<<24>>24<0;Ex(H,g?c[t>>2]|0:t,g?c[q>>2]|0:r&255)|0;z5(t)}J3(b);z5(H)}else A6(c[i>>2]|0);J3(b);h=h+1<<24>>24}r=48}else{e=-1;r=48}while(0);if((r|0)==48){wK(b);K=b+528|0;R=b+536|0;if(!((c[K>>2]|0)==(c[R>>2]|0)?(c[K+4>>2]|0)==(c[R+4>>2]|0):0))t4(b);if(((qO(b)|0?(L=c[P>>2]|0,M=L+47|0,(a[M>>0]|0)==-1):0)?(N=c[L>>2]|0,N|0):0)?a[N+31>>0]|0:0)a[M>>0]=e}}else{R=c[b+648>>2]|0;G4(R,Z9(c[R+4>>2]|0)|0)}l=Q;return}function Ad(b){b=b|0;var e=0,f=0,g=0,h=0.0,i=0.0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0.0;C=l;l=l+48|0;e=C+28|0;A=C+24|0;f=C+36|0;B=C;m=C+12|0;bB(b,C+37|0);jB(b,C+32|0);w=b+916|0;x=b+788|0;c[b+928>>2]=wD(w,c[x>>2]|0)|0;v=b+520|0;u=b+528|0;if((c[v>>2]|0)==1937011578&(c[v+4>>2]|0)==0){ID(b,e);a[f>>0]=32;v=c[e>>2]|0;ID(b,A);t=b+928|0;if(v){s=b+16|0;u=b+20|0;if((c[s>>2]|0)==2){$x(B,b,2,c[u>>2]|0,46,1);e=i9(23916)|0;k=a[B+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[B+4>>2]|0:k&255)|0)?(VG(B,23916,e)|0)==0:0)y=12;else{e=Aj(2,1,B,1)|0;f=a[e+8+3>>0]|0;g=f<<24>>24<0;j=g?c[e>>2]|0:e;k=i9(28648)|0;if(!((((k|0)!=0?(g=j+((g?c[e+4>>2]|0:f&255)<<2)|0,k=HA(j,g,28648,28648+(k<<2)|0)|0,!((k|0)!=(g|0)&(k|0)==(j|0))):0)?(n=UJ(B,4)|0,o=a[n+8+3>>0]|0,p=o<<24>>24<0,q=p?c[n>>2]|0:n,r=i9(28648)|0,(r|0)!=0):0)?(p=q+((p?c[n+4>>2]|0:o&255)<<2)|0,r=HA(q,p,28648,28648+(r<<2)|0)|0,!((r|0)!=(p|0)&(r|0)==(q|0))):0))y=12}a:do if((y|0)==12){$x(m,b,c[s>>2]|0,c[u>>2]|0,68,1);q=rm(m)|0;r=z;z5(m);$x(m,b,c[s>>2]|0,c[u>>2]|0,147,1);o=rm(m)|0;p=z;z5(m);$x(m,b,c[s>>2]|0,c[u>>2]|0,135,1);f=rm(m)|0;e=z;z5(m);$x(m,b,c[s>>2]|0,c[u>>2]|0,122,1);g=rm(m)|0;j=z;z5(m);r=UW(o|0,p|0,q|0,r|0)|0;e=UW(r|0,z|0,f|0,e|0)|0;j=UW(e|0,z|0,g|0,j|0)|0;j=g5(j|0,z|0,8e3,0)|0;g=z;e=UW(c[A>>2]|0,0,v|0,0)|0;f=z;i=+(j>>>0)+4294967296.0*+(g>>>0);h=i*.995;i=i*1.005;g=0;j=1;while(1){if(!(g>>>0<0|(g|0)==0&j>>>0<33))break a;r=UW(e|0,f|0,j|0,g|0)|0;D=+(r>>>0)+4294967296.0*+(z>>>0);if(D>h&D<i)break;r=z0(j|0,g|0,1,0)|0;g=z;j=r}r=(bF(w,x)|0)+168|0;c[r>>2]=j;c[r+4>>2]=g}while(0);z5(B)}e=c[t>>2]|0;f=c[A>>2]|0;r=UW(f|0,0,v|0,0)|0;A=e+152|0;c[A>>2]=r;c[A+4>>2]=z;if((v|0)==1){x=(bF(w,x)|0)+168|0;e=c[t>>2]|0;A=e+152|0;w=A;x=UW(c[w>>2]|0,c[w+4>>2]|0,c[x>>2]|0,c[x+4>>2]|0)|0;c[A>>2]=x;c[A+4>>2]=z}else{A=e+192|0;c[A>>2]=1;c[A+4>>2]=0}A=e+184|0;c[A>>2]=v;c[A+4>>2]=0;A=e+200|0;c[A>>2]=f;c[A+4>>2]=0;if(f>>>0>1?(gq(B,b,c[s>>2]|0,c[u>>2]|0,387802),A=a[B+8+3>>0]|0,A=((A<<24>>24<0?c[B+4>>2]|0:A&255)|0)==0,z5(B),A):0)xM(b,c[s>>2]|0,c[u>>2]|0,387802,384431,0)}else{e=32;y=4}}else{y=u;y=z0(c[y>>2]|0,c[y+4>>2]|0,3,0)|0;t=u;c[t>>2]=y;c[t+4>>2]=z;bB(b,f);c[e>>2]=0;ID(b,A);t=b+928|0;e=a[f>>0]|0;y=4}b:do if((y|0)==4){q=b+536|0;r=b+544|0;s=b+612|0;p=b+880|0;o=c[A>>2]|0;m=(e&255)+-4|0;m=m>>>2|m<<30;n=(o&1|0)==0;k=0;while(1){if(k>>>0>=o>>>0)break b;j=u;g=c[j>>2]|0;j=c[j+4>>2]|0;e=z0(g|0,j|0,4,0)|0;f=z;b=q;A=c[b+4>>2]|0;if(f>>>0>A>>>0|((f|0)==(A|0)?e>>>0>(c[b>>2]|0)>>>0:0))break b;c:do switch(m|0){case 0:{e=d[(c[r>>2]|0)+((c[s>>2]|0)+g)>>0]|0;if(n){b=z0(g|0,j|0,1,0)|0;j=u;c[j>>2]=b;c[j+4>>2]=z;j=e>>>4;break c}else{j=e&15;break c}}case 1:{b=(Z9(a[(c[r>>2]|0)+(c[s>>2]|0)+g>>0]|0)|0)&255;A=u;c[A>>2]=z0(g|0,j|0,1,0)|0;c[A+4>>2]=z;j=b;break}case 3:{b=(c[r>>2]|0)+(c[s>>2]|0)+g|0;b=(A5(a[b>>0]|0,a[b+1>>0]|0)|0)&65535;A=u;c[A>>2]=z0(g|0,j|0,2,0)|0;c[A+4>>2]=z;j=b;break}case 7:{j=W8((c[r>>2]|0)+(c[s>>2]|0)+g|0)|0;b=u;c[b>>2]=e;c[b+4>>2]=f;break}default:break b}while(0);e=c[t>>2]|0;f=e+152|0;g=f;g=z0(c[g>>2]|0,c[g+4>>2]|0,j|0,0)|0;c[f>>2]=g;c[f+4>>2]=z;f=B;c[f>>2]=j;c[f+4>>2]=0;f=e+140|0;g=c[f>>2]|0;if(g>>>0<(c[e+144>>2]|0)>>>0){b=g;c[b>>2]=j;c[b+4>>2]=0;c[f>>2]=g+8}else Px(e+136|0,B);if(k>>>0<(c[p>>2]|0)>>>0){e=c[t>>2]|0;f=B;c[f>>2]=j;c[f+4>>2]=0;f=e+128|0;g=c[f>>2]|0;if(g>>>0<(c[e+132>>2]|0)>>>0){b=g;c[b>>2]=j;c[b+4>>2]=0;c[f>>2]=g+8}else Px(e+124|0,B)}k=k+1|0}}while(0);l=C;return}function Bd(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=l;l=l+48|0;u=I+24|0;y=I+20|0;h=I+16|0;A=I+12|0;B=I+8|0;i=I+4|0;C=I+33|0;D=I+32|0;E=I+31|0;v=I+30|0;w=I+29|0;x=I+28|0;s=I;c[i>>2]=0;a[C>>0]=0;Bx(b);n3(b,u);n3(b,y);y=c[y>>2]|0;F=b+840|0;G=b+844|0;e=c[F>>2]|0;if(y>>>0<(c[G>>2]|0)-e>>2>>>0?(f=e+(y<<2)|0,(c[f>>2]|0)!=0):0)t=6;else t=3;do if((t|0)==3){e=c[b+852>>2]|0;if(y>>>0<(c[b+856>>2]|0)-e>>2>>>0?(g=e+(y<<2)|0,c[g>>2]|0):0){f=g;t=6;break}H=c[b+648>>2]|0;G4(H,Z9(c[H+4>>2]|0)|0)}while(0);a:do if((t|0)==6){AT(b,D);AT(b,E);n3(b,h);j=c[h>>2]|0;b:do if(j>>>0<=7)if(!j){j=0;r=0}else{n3(b,i);e=c[i>>2]|0;switch(e|0){case 0:{e=0;while(1){if(e>>>0>j>>>0){r=0;break b}T5(b);e=e+1|0}}case 2:{e=0;while(1){if((e|0)==(j|0)){r=2;break b}T5(b);T5(b);e=e+1|0}}default:{if((e+-3|0)>>>0<3){A6(c[b+648>>2]|0);T5(b);r=e;break b}if((e|0)!=6){r=e;break b}n3(b,s);h=c[s>>2]|0;r=c[f>>2]|0;if(h>>>0>(O((c[r+8>>2]|0)+1|0,(c[r+4>>2]|0)+1|0)|0)>>>0){t4(b);break a}i=~~+N(+(+M(+(+((j+1|0)>>>0)))/2.3025851249694824))>>>0;g=b+648|0;e=0;while(1){if(e>>>0>h>>>0)break;G4(c[g>>2]|0,i);e=e+1|0}r=6;break b}}}else{t4(b);c[h>>2]=0;j=0;r=0}while(0);n3(b,A);n3(b,B);AT(b,w);xR(b,2,C);L5(b);L5(b);L5(b);AT(b,x);p=b+648|0;A6(c[p>>2]|0);AT(b,v);q=b+536|0;o=q;n=c[o>>2]|0;o=c[o+4>>2]|0;if(!((n|0)==0&(o|0)==0)){k=b+544|0;m=b+612|0;g=n;e=o;while(1){g=z0(g|0,e|0,-1,-1)|0;e=z;if((g|0)==0&(e|0)==0){i=0;h=0;break}if(a[(c[k>>2]|0)+((c[m>>2]|0)+g)>>0]|0){i=g;h=e;break}}e=7;while(1){if(!e){e=0;break}if(d[(c[k>>2]|0)+((c[m>>2]|0)+g)>>0]&1<<7-e|0)break;e=e+-1|0}m=Z9(c[(c[p>>2]|0)+4>>2]|0)|0;n=D_(n|0,o|0,i|0,h|0)|0;n=PZ(n|0,z|0,3)|0;o=z;k=z0(8-e|0,0,-8,-1)|0;o=z0(k|0,z|0,n|0,o|0)|0;n=z;if(0>n>>>0|0==(n|0)&m>>>0>o>>>0){AT(b,s);if(K6(c[p>>2]|0)|0){GC(b);A6(c[p>>2]|0);g=(a[s>>0]|0)==0;e=0;while(1){if(g)h=0;else h=(a[(c[f>>2]|0)+38>>0]|0)!=3?2:6;if((e&255)>>>0>=(h+6|0)>>>0)break;if(K6(c[p>>2]|0)|0){GC(b);A6(c[p>>2]|0);UK(b,(e&255)<6?16:64);J3(b)}else A6(c[p>>2]|0);e=e+1<<24>>24}J3(b)}else A6(c[p>>2]|0);L5(b)}}KS(b);wK(b);i=b+528|0;g=i;f=c[g+4>>2]|0;g=c[g>>2]|0;while(1){e=q;h=c[e>>2]|0;e=c[e+4>>2]|0;if(!(f>>>0<e>>>0|(f|0)==(e|0)&g>>>0<h>>>0))break;EG(b,s);f=i;e=c[f>>2]|0;f=c[f+4>>2]|0;if(a[s>>0]|0){t=48;break}g=z0(e|0,f|0,1,0)|0;f=z;p=i;c[p>>2]=g;c[p+4>>2]=f}if((t|0)==48){t=q;g=e;h=c[t>>2]|0;e=c[t+4>>2]|0}if(!((g|0)==(h|0)&(f|0)==(e|0)))t4(b);if(qO(b)|0){g=c[u>>2]|0;if(g>>>0>255){t4(b);break}if(y>>>0>31){t4(b);break}s_(b);AR(b,5,0);AR(b,6,0);h=b+852|0;i=b+856|0;if((c[h>>2]|0)!=(c[i>>2]|0))AR(b,20,0);f=b+864|0;e=c[f>>2]|0;if(g>>>0>=(c[b+868>>2]|0)-e>>2>>>0){FF(f,g+1|0);e=c[f>>2]|0}e=e+(g<<2)|0;f=c[e>>2]|0;if(f|0)laa(f);g=ZW(20)|0;QG(g,y&255,c[A>>2]&255,c[B>>2]&255,a[C>>0]|0,j,r,(a[D>>0]|0)!=0,(a[E>>0]|0)!=0,(a[w>>0]|0)!=0,(a[v>>0]|0)!=0,(a[x>>0]|0)!=0);c[e>>2]=g;g=b+772|0;c:do if((c[F>>2]|0)!=(c[G>>2]|0)){f=1;while(1){if((f|0)==7)break c;e=c[g>>2]|0;a[e+(f<<1)>>0]=1;if(a[e+17>>0]|0)a[e+(f<<1)+1>>0]=1;f=f+1|0}}while(0);if((c[h>>2]|0)!=(c[i>>2]|0)?(H=c[g>>2]|0,a[H+40>>0]=1,a[H+17>>0]|0):0)a[H+41>>0]=1;if(!(c[b+728>>2]&1))W5(b)}}while(0);l=I;return}function Cd(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0;h=b+789|0;d=a[h>>0]|0;j=b+792|0;e=(a[j>>0]|0)!=0;k=b+536|0;if((d&255)>6|e){if(!e){if(d<<24>>24==-63){d=k;e=-4;f=-1;i=6}}else{e=k;e=z0(c[e>>2]|0,c[e+4>>2]|0,-4,-1)|0;d=k;c[d>>2]=e;c[d+4>>2]=z;NB(b,b+778|0);Bx(b);d4(c[b+648>>2]|0,2);xR(b,5,b+790|0);AT(b,b+791|0);wK(b);d=b+528|0;e=2;f=0;i=6}if((i|0)==6){i=d;i=z0(c[i>>2]|0,c[i+4>>2]|0,e|0,f|0)|0;c[d>>2]=i;c[d+4>>2]=z;d=a[h>>0]|0}a:do switch(d<<24>>24){case 0:{Ie(b);break}case 1:{zK(b);break}case 2:{_b(b);break}case 3:{zK(b);break}case 4:{gV(b);break}case 5:{gV(b);break}case 6:{gV(b);break}case 56:{gV(b);break}case 57:{gV(b);break}case 58:{gV(b);break}case 59:{gV(b);break}case 60:{gV(b);break}case 61:{gV(b);break}case 62:{gV(b);break}case 63:{gV(b);break}case 64:{Dm(b);break}case 65:{gV(b);break}case 66:{_m(b);break}case 70:{Q5(b);break}case 74:{gV(b);break}case 78:{pf(b);break}case 79:{P5(b);break}case 95:case 94:case 92:case 91:case 90:case 89:case 88:case 87:case 86:case 85:case 84:case 83:case 82:case 81:case 80:{P5(b);break}case 111:case 110:case 109:case 108:case 107:case 106:case 105:case 104:case 103:case 102:case 101:case 100:case 99:case 98:case 97:case 96:{O5(b);break}case 112:{qh(b);break}case 113:{gV(b);break}case 114:{gV(b);break}case 115:{Og(b);break}case 116:{gV(b);break}case 117:{gV(b);break}case 118:{gV(b);break}case 119:{gV(b);break}case 120:{gV(b);break}case 121:{gV(b);break}case 126:{gV(b);break}case 127:{Or(b);break}case -64:{gV(b);break}case -63:{dj(b);break}case -62:{gV(b);break}case -61:{gV(b);break}case -60:{gV(b);break}case -59:{gV(b);break}case -58:{gV(b);break}case -57:{Pg(b);break}case -56:{N5(b);break}case -55:{Gc(b);break}case -54:{Nj(b);break}case -53:{_d(b);break}case -52:{Ul(b);break}case -51:{em(b);break}case -50:{gV(b);break}case -49:{gV(b);break}case -48:{gV(b);break}case -47:{gV(b);break}case -46:{gV(b);break}case -45:{gV(b);break}case -44:{gV(b);break}case -43:{gV(b);break}case -42:{AE(b);break}case -41:{gV(b);break}case -40:{gV(b);break}case -39:{gV(b);break}case -38:{N5(b);break}case -4:{Ij(b);break}default:{if((d&255)<56){i=k;e1(b,c[i>>2]|0,c[i+4>>2]|0);break a}if((d&255)>63&d<<24>>24>-1){i=k;e1(b,c[i>>2]|0,c[i+4>>2]|0);break a}if(d<<24>>24<0&(d&255)<144){i=k;e1(b,c[i>>2]|0,c[i+4>>2]|0);break a}if((d&-32)<<24>>24==-64){i=k;e1(b,c[i>>2]|0,c[i+4>>2]|0);break a}if(d<<24>>24!=-1){i=k;e1(b,c[i>>2]|0,c[i+4>>2]|0);break a}i=b+520|0;if((c[i>>2]|0)==-1?(c[i+4>>2]|0)==-1:0){Vh(b);break a}else{i=k;e1(b,c[i>>2]|0,c[i+4>>2]|0);break a}}}while(0);d=a[h>>0]|0;if((a[j>>0]|0)!=0|d<<24>>24==-63){i=k;i=z0(c[i>>2]|0,c[i+4>>2]|0,4,0)|0;j=k;c[j>>2]=i;c[j+4>>2]=z;j=b+528|0;i=j;i=z0(c[i>>2]|0,c[i+4>>2]|0,4,0)|0;c[j>>2]=i;c[j+4>>2]=z}b:do if((d&255)>63?+g[(c[b+24>>2]|0)+136>>2]>=.5:0){d=(c[b+764>>2]|0)+92|0;switch(c[d>>2]|0){case 0:case -1:break b;default:{}}c[d>>2]=-1}while(0);k=z0(c[b+612>>2]|0,0,c[k>>2]|0,c[k+4>>2]|0)|0;if((z|0)==0?(k|0)==(c[b+548>>2]|0):0){pO(b);jt(b);KM(b)}}else{e1(b,c[k>>2]|0,c[k+4>>2]|0);V5(b)}return}function Dd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=l;l=l+32|0;f=I+16|0;E=I+4|0;q=I;B=b+520|0;g=B;h=c[g>>2]|0;g=c[g+4>>2]|0;if((h|0)==-1&(g|0)==-1)fe(b);else{C=b+536|0;F=C;D=c[F>>2]|0;F=c[F+4>>2]|0;G=b+544|0;H=b+612|0;a:do if((D|0)==0&(F|0)==0){i=0;j=0;d=0;e=0}else{d=D;e=F;while(1){if((d|0)==0&(e|0)==0){i=d;j=e;d=0;e=0;break a}if(a[(c[G>>2]|0)+(d+-1+(c[H>>2]|0))>>0]|0){i=d;j=e;break a}x=z0(d|0,e|0,-1,-1)|0;y=z;w=C;c[w>>2]=x;c[w+4>>2]=y;d=x;e=y}}while(0);a[f>>0]=0;switch(h|0){case 14:{if(!g)A=10;else{y=d;d=0}break}case 20:{if(!g)A=10;else{y=d;d=0}break}default:{y=d;d=0}}if((A|0)==10){Bx(b);AT(b,f);d=a[f>>0]|0;if(!(d<<24>>24))MC(b);else py(b);wK(b);j=C;i=c[j>>2]|0;j=c[j+4>>2]|0;y=i;e=j}r=c[G>>2]|0;s=b+48|0;u=s;t=c[u>>2]|0;u=c[u+4>>2]|0;v=c[H>>2]|0;w=b+528|0;f=c[w>>2]|0;c[E>>2]=0;x=E+4|0;c[x>>2]=0;c[E+8>>2]=0;p=E+8|0;m=i;n=j;k=i;i=j;g=e;h=y;while(1){if(0>g>>>0|0==(g|0)&(f+3|0)>>>0>h>>>0)break;A=(c[G>>2]|0)+(c[H>>2]|0)+f|0;h=f+2|0;if((R4(a[A>>0]|0,a[A+1>>0]|0,a[A+2>>0]|0)|0)==3){c[q>>2]=h;f=c[x>>2]|0;if(f>>>0<(c[p>>2]|0)>>>0){c[f>>2]=h;c[x>>2]=f+4;g=m;f=n}else{Yy(E,q);f=C;g=c[f>>2]|0;f=c[f+4>>2]|0}m=g;n=f;j=f;o=g}else{j=i;o=k}f=h;while(1){if(!(0<j>>>0|0==(j|0)&f>>>0<o>>>0)){A=26;break}g=c[G>>2]|0;h=c[H>>2]|0;if(!(a[g+(h+f)>>0]|0)){A=25;break}f=f+2|0}if((A|0)==25){A=0;i=f+-1|0;if(!(a[g+(h+i)>>0]|0))f=i;else{k=o;i=j;g=j;h=o;continue}}else if((A|0)==26){A=0;f=f+-1|0}k=o;i=j;g=j;h=o}o=c[E>>2]|0;f=c[x>>2]|0;if((o|0)!=(f|0)){i=f-o>>2;h=D_(y|0,e|0,i|0,0)|0;g=z;k=C;c[k>>2]=h;c[k+4>>2]=g;k=s;k=z0(c[k>>2]|0,c[k+4>>2]|0,c[H>>2]|0,0)|0;j=s;c[j>>2]=k;c[j+4>>2]=z;c[H>>2]=0;j=iaa(h)|0;k=r+v|0;f=0;while(1){if(f>>>0>i>>>0)break;if((f|0)==(i|0))n=y;else n=c[o+(f<<2)>>2]|0;if(!f)m=0;else m=(c[o+(f+-1<<2)>>2]|0)+1|0;no(j+(m-f)|0,k+m|0,n-m|0)|0;f=f+1|0}c[G>>2]=j}f=c[B+4>>2]|0;do switch(c[B>>2]|0){case 0:{if(!f){B=w;B=D_(h|0,g|0,c[B>>2]|0,c[B+4>>2]|0)|0;e1(b,B,z)}else A=74;break}case 1:{if(!f)eW(b);else A=74;break}case 2:{if(!f){B=w;B=D_(h|0,g|0,c[B>>2]|0,c[B+4>>2]|0)|0;e1(b,B,z)}else A=74;break}case 3:{if(!f){B=w;B=D_(h|0,g|0,c[B>>2]|0,c[B+4>>2]|0)|0;e1(b,B,z)}else A=74;break}case 4:{if(!f){B=w;B=D_(h|0,g|0,c[B>>2]|0,c[B+4>>2]|0)|0;e1(b,B,z)}else A=74;break}case 5:{if(!f)IA(b);else A=74;break}case 6:{if(!f)Hz(b);else A=74;break}case 7:{if(!f)jj(b);else A=74;break}case 8:{if(!f)Bd(b);else A=74;break}case 9:{if(!f)gR(b);else A=74;break}case 10:{if(!f){B=w;B=D_(h|0,g|0,c[B>>2]|0,c[B+4>>2]|0)|0;e1(b,B,z)}else A=74;break}case 11:{if(!f){B=w;B=D_(h|0,g|0,c[B>>2]|0,c[B+4>>2]|0)|0;e1(b,B,z)}else A=74;break}case 12:{if(!f)iy(b);else A=74;break}case 13:{if(!f){B=w;B=D_(h|0,g|0,c[B>>2]|0,c[B+4>>2]|0)|0;e1(b,B,z)}else A=74;break}case 14:{if(!f)JT(b,d<<24>>24!=0);else A=74;break}case 15:{if(!f)Zq(b);else A=74;break}case 19:{if(!f){B=w;B=D_(h|0,g|0,c[B>>2]|0,c[B+4>>2]|0)|0;e1(b,B,z)}else A=74;break}case 20:{if(!f)_I(b,d<<24>>24!=0);else A=74;break}default:A=74}while(0);if((A|0)==74){B=w;B=D_(h|0,g|0,c[B>>2]|0,c[B+4>>2]|0)|0;e1(b,B,z)}if((c[E>>2]|0)!=(c[x>>2]|0)){b=C;c[b>>2]=y;c[b+4>>2]=e;b=s;c[b>>2]=t;c[b+4>>2]=u;c[H>>2]=v;jaa(c[G>>2]|0);c[G>>2]=r;G=w;G=z0((c[x>>2]|0)-(c[E>>2]|0)>>2|0,0,c[G>>2]|0,c[G+4>>2]|0)|0;H=w;c[H>>2]=G;c[H+4>>2]=z}H=C;c[H>>2]=D;c[H+4>>2]=F;cU(E)}l=I;return}function Ed(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;a:do if((d|0)<=6?(n=b+4|0,m=c[c[n>>2]>>2]|0,(((c[m+(d*12|0)+4>>2]|0)-(c[m+(d*12|0)>>2]|0)|0)/40|0)>>>0>e>>>0):0){m=vn(d)|0;g=c[(c[c[n>>2]>>2]|0)+(d*12|0)>>2]|0;h=c[g+(e*40|0)>>2]|0;g=((c[g+(e*40|0)+4>>2]|0)-h|0)/12|0;if((((c[m+4>>2]|0)-(c[m>>2]|0)|0)/40|0)>>>0<=f>>>0){g=f-g|0;f=c[(c[c[b+8>>2]>>2]|0)+(d*12|0)>>2]|0;h=f+(e*56|0)+4|0;d=c[h>>2]|0;f=c[f+(e*56|0)>>2]|0;b=d;if(g>>>0>=((d-f|0)/40|0)>>>0)break;g=f+(g*40|0)|0;while(1){f=g+40|0;if((f|0)==(b|0))break;Kq(g,f)|0;g=f}while(1){f=c[h>>2]|0;if((f|0)==(g|0))break a;e=f+-40|0;c[h>>2]=e;$_(e)}}if(g>>>0>f>>>0){g=h+(f*12|0)|0;b=h+(f*12|0)+8+3|0;if((a[b>>0]|0)<0){y7(c[g>>2]|0,0);c[h+(f*12|0)+4>>2]=0}else{y7(g,0);a[b>>0]=0}if(NT()|0){j=SU(vn(d)|0,f,2)|0;g=i9(7820)|0;k=j+8+3|0;b=a[k>>0]|0;l=j+4|0;h=c[l>>2]|0;do if((g|0)==((b<<24>>24<0?h:b&255)|0)){if(VG(j,7820,g)|0){b=a[k>>0]|0;h=c[l>>2]|0;break}g=SU(vn(d)|0,f,0)|0;b=a[g+8+3>>0]|0;h=b<<24>>24<0;i=h?c[g>>2]|0:g;j=i9(6336)|0;if(!j)g=7;else{m=i+((h?c[g+4>>2]|0:b&255)<<2)|0;g=HA(i,m,6336,6336+(j<<2)|0)|0;g=(g|0)==(m|0)|(g-i|0)==-4?5:7}i=g+f|0;while(1){f=f+1|0;if(f>>>0>i>>>0)break a;l=c[(c[c[n>>2]>>2]|0)+(d*12|0)>>2]|0;m=c[l+(e*40|0)>>2]|0;g=m;if(f>>>0>=(((c[l+(e*40|0)+4>>2]|0)-m|0)/12|0)>>>0)continue;b=g+(f*12|0)|0;h=g+(f*12|0)+8+3|0;if((a[h>>0]|0)<0){y7(c[b>>2]|0,0);c[g+(f*12|0)+4>>2]=0;continue}else{y7(b,0);a[h>>0]=0;continue}}}while(0);g=i9(7844)|0;m=f+1|0;if((g|0)==((b<<24>>24<0?h:b&255)|0)){if(VG(j,7844,g)|0){b=a[k>>0]|0;h=c[l>>2]|0;i=23}}else i=23;do if((i|0)==23){g=i9(7864)|0;if((g|0)==((b<<24>>24<0?h:b&255)|0)){if(!(VG(j,7864,g)|0))break;b=a[k>>0]|0;h=c[l>>2]|0}g=i9(7880)|0;do if((g|0)==((b<<24>>24<0?h:b&255)|0)){if(VG(j,7880,g)|0){b=a[k>>0]|0;f=c[l>>2]|0;break}i=f+6|0;f=m;while(1){if(f>>>0>i>>>0)break a;l=c[(c[c[n>>2]>>2]|0)+(d*12|0)>>2]|0;m=c[l+(e*40|0)>>2]|0;g=m;do if(f>>>0<(((c[l+(e*40|0)+4>>2]|0)-m|0)/12|0)>>>0){b=g+(f*12|0)|0;h=g+(f*12|0)+8+3|0;if((a[h>>0]|0)<0){y7(c[b>>2]|0,0);c[g+(f*12|0)+4>>2]=0;break}else{y7(b,0);a[h>>0]=0;break}}while(0);f=f+1|0}}else f=h;while(0);g=i9(30156)|0;do if((g|0)==((b<<24>>24<0?f:b&255)|0)){if(VG(j,30156,g)|0){b=a[k>>0]|0;f=c[l>>2]|0;break}n=c[(c[c[n>>2]>>2]|0)+(d*12|0)>>2]|0;d=c[n+(e*40|0)>>2]|0;b=d;if(m>>>0>=(((c[n+(e*40|0)+4>>2]|0)-d|0)/12|0)>>>0)break a;f=b+(m*12|0)|0;g=b+(m*12|0)+8+3|0;if((a[g>>0]|0)<0){y7(c[f>>2]|0,0);c[b+(m*12|0)+4>>2]=0;break a}else{y7(f,0);a[g>>0]=0;break a}}while(0);g=c[(c[c[n>>2]>>2]|0)+(d*12|0)>>2]|0;h=c[g+(e*40|0)>>2]|0;g=m>>>0<(((c[g+(e*40|0)+4>>2]|0)-h|0)/12|0)>>>0;if((b<<24>>24<0?f:b&255)|0){if(!g)break a;f=h+(m*12|0)|0;g=h+(m*12|0)+8+3|0;if((a[g>>0]|0)<0){y7(c[f>>2]|0,0);c[h+(m*12|0)+4>>2]=0;break a}else{y7(f,0);a[g>>0]=0;break a}}if(!g)break a;f=SU(vn(d)|0,m,0)|0;g=a[f+8+3>>0]|0;b=g<<24>>24<0;h=b?c[f>>2]|0:f;i=i9(6380)|0;if(i|0?(k=h+((b?c[f+4>>2]|0:g&255)<<2)|0,l=HA(h,k,6380,6380+(i<<2)|0)|0,(l|0)==(k|0)|(l-h|0)==-4):0)break a;f=c[(c[(c[c[n>>2]>>2]|0)+(d*12|0)>>2]|0)+(e*40|0)>>2]|0;g=f+(m*12|0)|0;b=f+(m*12|0)+8+3|0;if((a[b>>0]|0)<0){y7(c[g>>2]|0,0);c[f+(m*12|0)+4>>2]=0;break a}else{y7(g,0);a[b>>0]=0;break a}}while(0);n=c[(c[c[n>>2]>>2]|0)+(d*12|0)>>2]|0;d=c[n+(e*40|0)>>2]|0;b=d;if(m>>>0<(((c[n+(e*40|0)+4>>2]|0)-d|0)/12|0)>>>0){f=b+(m*12|0)|0;g=b+(m*12|0)+8+3|0;if((a[g>>0]|0)<0){y7(c[f>>2]|0,0);c[b+(m*12|0)+4>>2]=0;break}else{y7(f,0);a[g>>0]=0;break}}}}}while(0);return}function Fd(f){f=f|0;var g=0,h=0.0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;I=l;l=l+16|0;A=I;m=f+40|0;F=f+1088|0;H=f+760|0;n=f+776|0;o=f+784|0;do if(!(a[f+492>>0]|0)){k=m;j=c[k>>2]|0;k=c[k+4>>2]|0;g=f+1080|0;if((j|0)==-1&(k|0)==-1?(E=g,(c[E>>2]|0)==-1?(c[E+4>>2]|0)==-1:0):0)break;E=F;if((c[E>>2]|0)==0&(c[E+4>>2]|0)==0){i=c[g>>2]|0;g=c[g+4>>2]|0;if((i|0)==-1&(g|0)==-1){i=F;c[i>>2]=j;c[i+4>>2]=k;i=n;i=D_(j|0,k|0,c[i>>2]|0,c[i+4>>2]|0)|0;j=o;g=z}else j=n;D=F;c[D>>2]=i;c[D+4>>2]=g;D=j;D=D_(i|0,g|0,c[D>>2]|0,c[D+4>>2]|0)|0;E=F;c[E>>2]=D;c[E+4>>2]=z}}while(0);k=c[f+1096>>2]|0;y=f+1113|0;D=f+1112|0;E=f+1115|0;p=f+1108|0;if(!k){k=0;i=0}else{g=F;i=c[g>>2]|0;g=c[g+4>>2]|0;if((i|0)==0&(g|0)==0){i=m;g=o;g=D_(c[i>>2]|0,c[i+4>>2]|0,c[g>>2]|0,c[g+4>>2]|0)|0;i=n;i=D_(g|0,z|0,c[i>>2]|0,c[i+4>>2]|0)|0;g=z}h=(+(i>>>0)+4294967296.0*+(g>>>0))/+(k>>>0);i=a[D>>0]|0;j=i&255;a:do switch(i<<24>>24){case 3:{if((a[y>>0]|0)==3){q=48.0;G=18}else G=16;break}case 0:case 2:{g=a[y>>0]|0;if(g<<24>>24!=3){switch(i<<24>>24){case 0:case 2:break;default:{G=16;break a}}if(g<<24>>24==1){q=72.0;G=18}else G=16}else{q=24.0;G=18}break}default:if((i&255)<4){q=144.0;G=18}}while(0);if((G|0)==16){q=144.0;G=18}if((G|0)==18?(r=a[E>>0]|0,(r&255)<4):0)c[p>>2]=~~(h*+(e[61002+(j<<3)+((r&255)<<1)>>1]|0)/q)>>>0;Xy(A,40136);vF(f+908|0,A)|0;z5(A);i=0}j=F;g=c[j>>2]|0;j=c[j+4>>2]|0;if(!((g|0)==0&(j|0)==0)){m=c[p>>2]|0;if(((m|0?(r=UW(g|0,j|0,8e3,0)|0,r=g5(r|0,z|0,m|0,0)|0,oK(f,0,0,92,r,z,10,1),lL(f,0,0,103,c[p>>2]|0,10,1),lL(f,2,0,112,c[p>>2]|0,10,1),a[f+905>>0]|0):0)?(t=f+560|0,s=c[t>>2]|0,t=c[t+4>>2]|0,t>>>0>0|(t|0)==0&s>>>0>10):0)?(u=c[p>>2]|0,u|0):0){t=UW(s|0,t|0,8e3,0)|0;u=g5(t|0,z|0,u|0,0)|0;oK(f,2,0,156,u,z,0,1);RB(f,2,0,165,388261,-1,1,1)}u=F;oK(f,2,0,194,c[u>>2]|0,c[u+4>>2]|0,10,0)}zb(f,2,0,110,f+908|0,1);j=f+944|0;g=a[f+952+3>>0]|0;if(g<<24>>24<0)g=c[f+948>>2]|0;else g=g&255;if(g|0)zb(f,0,0,273,j,1);zb(f,2,0,247,j,1);zb(f,2,0,253,f+956|0,1);m=f+136|0;j=m;g=c[j>>2]|0;j=c[j+4>>2]|0;do if(!((g|0)==-1&(j|0)==-1)?(x=f+280|0,w=x,v=c[w>>2]|0,w=c[w+4>>2]|0,j>>>0>w>>>0|(j|0)==(w|0)&g>>>0>v>>>0):0){g=D_(g|0,j|0,v|0,w|0)|0;g=cT((+(g>>>0)+4294967296.0*+(z>>>0))/1.0e6)|0;jL(f,2,0,68,g,z,0);$x(A,f,2,0,110,1);g=i9(40152)|0;w=a[A+8+3>>0]|0;if((g|0)==((w<<24>>24<0?c[A+4>>2]|0:w&255)|0)?(VG(A,40152,g)|0)==0:0){if((d[D>>0]|0)>=4){z5(A);break}w=(d[E>>0]|0)<4;z5(A);if(!w)break;w=a[D>>0]|0;g=w&255;switch(w<<24>>24){case 3:{if((a[y>>0]|0)==3)h=384.0;else G=42;break}case 0:case 2:{if((a[y>>0]|0)==1)h=576.0;else G=42;break}default:G=42}if((G|0)==42)h=1152.0;q=h*(1.0/+(e[61002+(g<<3)+(d[E>>0]<<1)>>1]|0));i=m;k=x;k=D_(c[i>>2]|0,c[i+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0;k=cT((+(k>>>0)+4294967296.0*+(z>>>0))/1.0e9/q)|0;i=z;break}z5(A)}while(0);m=f+1114|0;do if((k|0)==0&(i|0)==0){x=F;if(!((c[x>>2]|0)==0&(c[x+4>>2]|0)==0)){$x(A,f,2,0,110,1);g=i9(40152)|0;x=a[A+8+3>>0]|0;if((((((g|0)==((x<<24>>24<0?c[A+4>>2]|0:x&255)|0)?(VG(A,40152,g)|0)==0:0)?(x=a[D>>0]|0,B=x&255,(x&255)<4):0)?(d[y>>0]|0)<4:0)?(C=a[E>>0]|0,(C&255)<4):0)?(d[m>>0]|0)<16:0){C=(b[61002+(B<<3)+((C&255)<<1)>>1]|0)==0;z5(A);if(C)break;j=a[D>>0]|0;B=j&255;C=d[y>>0]|0;h=+(d[372685+(B<<2)+C>>0]|0)*+(e[60490+(B<<7)+(C<<5)+(d[m>>0]<<1)>>1]|0)*1.0e3/+(e[61002+(B<<3)+(d[E>>0]<<1)>>1]|0)*+(d[372701+C>>0]|0);if(!(h!=0.0))break;g=F;g=cT((+((c[g>>2]|0)>>>0)+4294967296.0*+((c[g+4>>2]|0)>>>0))/h)|0;i=z;if((g|0)==0&(i|0)==0)break;else{k=g;G=59;break}}z5(A)}}else{j=a[D>>0]|0;G=59}while(0);if((G|0)==59){switch(j<<24>>24){case 3:{if((a[y>>0]|0)==3)g=384;else G=62;break}case 0:case 2:{if((a[y>>0]|0)==1)g=576;else G=62;break}default:G=62}if((G|0)==62)g=1152;oK(f,2,0,143,k,i,10,1);G=UW(g&65535|0,0,k|0,i|0)|0;oK(f,2,0,137,G,z,10,1);KW(f,2,0,139,+(e[61002+(d[D>>0]<<3)+(d[E>>0]<<1)>>1]|0)/+(g&65535),3,1)}Vt(H);l=I;return}function Gd(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;N=l;l=l+288|0;H=N+256|0;I=N+244|0;J=N+232|0;K=N+220|0;L=N+208|0;M=N+196|0;n=N+144|0;o=N+128|0;C=N+112|0;r=N+96|0;B=N+278|0;s=N+276|0;D=N+274|0;E=N+272|0;F=N+270|0;G=N+268|0;t=N+80|0;u=N+64|0;v=N+184|0;w=N+172|0;p=N+48|0;x=N+160|0;q=N+32|0;y=N+16|0;A=N;TX(H);TX(I);TX(J);TX(K);TX(L);TX(M);L2(n);L2(o);L2(C);L2(r);b[s>>1]=32767;b[D>>1]=32767;b[E>>1]=32767;b[F>>1]=32767;b[G>>1]=32767;jZ(d,256,0,H);jZ(d,32,0,I);jZ(d,32,0,J);jZ(d,10,0,K);jZ(d,8,0,L);i=d+1016|0;Uy(d,i);HB(d,B);B=b[B>>1]|0;j=B<<16>>16==0;B=(B&65535)>1;if(!j?(j0(d,n),j0(d,o),j0(d,C),j0(d,r),B):0){HB(d,s);HB(d,D);HB(d,E);HB(d,F);HB(d,G)}f=d+528|0;e=f;e=D_(602,0,c[e>>2]|0,c[e+4>>2]|0)|0;e1(d,e,z);e=c[f>>2]|0;f=c[f+4>>2]|0;h=d+536|0;g=c[h>>2]|0;h=c[h+4>>2]|0;if(h>>>0>f>>>0|(h|0)==(f|0)&g>>>0>e>>>0){h=D_(g|0,h|0,e|0,f|0)|0;jZ(d,h,z,M)}if(qO(d)|0){zb(d,0,0,245,H,0);zb(d,0,0,226,I,0);Mc(d,0,0,379417,J,0);nt(v,K,32);e=a[L+8+3>>0]|0;h=e<<24>>24<0;Ex(v,h?c[L>>2]|0:L,h?c[L+4>>2]|0:e&255)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];e=0;while(1){if((e|0)==3)break;c[v+(e<<2)>>2]=0;e=e+1|0}p2(t,u);zb(d,0,0,256,t,0);z5(t);O0(u);O0(v);zb(d,0,0,279,M,0);e=c[d+1032>>2]|0;if(e|0?(m=i,k=c[m>>2]|0,m=c[m+4>>2]|0,!((k|0)==-1&(m|0)==-1)):0){m=cT((+(k>>>0)+4294967296.0*+(m>>>0))*1.0e3/+(e>>>0))|0;jL(d,2,0,156,m,z,0);RB(d,2,0,165,379436,-1,1,0)}do if(!j){RY(t,0);k=n;m=c[k>>2]|0;k=c[k+4>>2]|0;g=n+8|0;j=c[g>>2]|0;g=c[g+4>>2]|0;i=t;n=t+8|0;if(!(oX(m,k,j,g,c[i>>2]|0,c[i+4>>2]|0,c[n>>2]|0,c[n+4>>2]|0)|0))break;RY(u,0);i=o;h=c[i>>2]|0;i=c[i+4>>2]|0;f=o+8|0;e=c[f>>2]|0;f=c[f+4>>2]|0;n=u;o=u+8|0;if(oX(h,i,e,f,c[n>>2]|0,c[n+4>>2]|0,c[o>>2]|0,c[o+4>>2]|0)|0){TX(w);dX(p,m,k,j,g);X$(w,p)|0;ms(v,42152,w);TX(x);dX(q,h,i,e,f);X$(x,q)|0;e=a[x+8+3>>0]|0;q=e<<24>>24<0;Ex(v,q?c[x>>2]|0:x,q?c[x+4>>2]|0:e&255)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];e=0;while(1){if((e|0)==3)break;c[v+(e<<2)>>2]=0;e=e+1|0}p2(t,u);O0(u);z5(x);O0(v);z5(w);if((m&-16777216|0)==855638016&0==0){TX(v);x=C;C=C+8|0;dX(y,c[x>>2]|0,c[x+4>>2]|0,c[C>>2]|0,c[C+4>>2]|0);X$(v,y)|0;TX(w);y=r;C=r+8|0;dX(A,c[y>>2]|0,c[y+4>>2]|0,c[C>>2]|0,c[C+4>>2]|0);X$(w,A)|0;Mq(u,v,w);C=a[u+8+3>>0]|0;A=C<<24>>24<0;Ex(t,A?c[u>>2]|0:u,A?c[u+4>>2]|0:C&255)|0;O0(u);z5(w);z5(v)}Mc(d,0,0,379412,t,0);z5(t)}}while(0);if(B){e=b[s>>1]|0;if(e<<16>>16!=32767)sN(d,2,0,379453,+(e<<16>>16)/100.0,2,0);e=b[D>>1]|0;if(e<<16>>16!=32767)sN(d,2,0,379467,+(e<<16>>16)/100.0,2,0);e=b[E>>1]|0;if(e<<16>>16!=32767)sN(d,2,0,379481,+(e<<16>>16)/100.0,2,0);e=b[F>>1]|0;if(e<<16>>16!=32767)sN(d,2,0,379498,+(e<<16>>16)/100.0,2,0);e=b[G>>1]|0;if(e<<16>>16!=32767)sN(d,2,0,379519,+(e<<16>>16)/100.0,2,0)}}z5(M);z5(L);z5(K);z5(J);z5(I);z5(H);l=N;return}function Hd(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;R=l;l=l+112|0;G=R+104|0;J=R+103|0;K=R+92|0;L=R+102|0;M=R+101|0;N=R+100|0;O=R+99|0;P=R+98|0;v=R+97|0;w=R+96|0;x=R+88|0;y=R+84|0;A=R+72|0;B=R+60|0;C=R+48|0;D=R+36|0;E=R+24|0;F=R+12|0;H=R;I=b+528|0;k=I;j=c[k>>2]|0;k=c[k+4>>2]|0;i=d&255;t=z0(j|0,k|0,i|0,0)|0;u=z;GC(b);d=1;while(1){g=I;f=c[g>>2]|0;g=c[g+4>>2]|0;s=z0(f|0,g|0,2,0)|0;r=z;if(r>>>0>u>>>0|(r|0)==(u|0)&s>>>0>t>>>0)break;bB(b,G);bB(b,J);g=I;f=c[g>>2]|0;g=c[g+4>>2]|0;s=a[J>>0]|0;h=s&255;r=z0(h|0,0,f|0,g|0)|0;q=z;if(!(q>>>0>u>>>0|(q|0)==(u|0)&r>>>0>t>>>0)?!((s&255)<4&(a[G>>0]|0)==-33):0)e1(b,h,0);else{d=D_(t|0,u|0,f|0,g|0)|0;e1(b,d,z);d=0}}a:do if(!(u>>>0>g>>>0|(u|0)==(g|0)&t>>>0>f>>>0)){J3(b);if(d){m=I;c[m>>2]=j;c[m+4>>2]=k;m=b+768|0;n=b+762|0;o=E+8+3|0;p=E+4|0;q=H+11|0;r=H+8|0;s=H+4|0;i=b+648|0;f=j;d=k;while(1){k=z0(f|0,d|0,2,0)|0;j=z;if(j>>>0>u>>>0|(j|0)==(u|0)&k>>>0>t>>>0)break a;GC(b);bB(b,G);bB(b,J);d=a[J>>0]|0;if((a[G>>0]|0)==-33&(d&255)>3){r3(b,K);if((c[K>>2]|0)==1161973808){f=I;k=c[f>>2]|0;f=c[f+4>>2]|0;d=z0(d&255|0,0,-4,-1)|0;d=z0(d|0,z|0,k|0,f|0)|0;f=z;Bx(b);AT(b,L);AT(b,M);AT(b,N);AT(b,O);AT(b,P);AT(b,v);A6(c[i>>2]|0);AT(b,w);if(a[w>>0]|0){A6(c[i>>2]|0);d4(c[i>>2]|0,7)}if(a[N>>0]|0){d4(c[i>>2]|0,3);d4(c[i>>2]|0,5)}if(a[O>>0]|0){a[x>>0]=1;g=1;while(1){if(!(g<<24>>24))break;k=I;j=c[k+4>>2]|0;if(!(j>>>0<f>>>0|((j|0)==(f|0)?(c[k>>2]|0)>>>0<d>>>0:0)))break;AT(b,x);d4(c[i>>2]|0,7);g=a[x>>0]|0}}wK(b);if(a[P>>0]|0){GC(b);k=c[(c[(c[m>>2]|0)+80>>2]|0)+(e[n>>1]<<2)>>2]|0;if((k|0)!=0?(a[k+185>>0]|0)==0:0){ID(b,x);ID(b,y);TX(D);T2(D,(c[x>>2]|0)+2085978496|0)|0;nt(C,D,46);ST(F,+((c[y>>2]|0)>>>0)*2.3283064365386963e-10,9);lw(E,F,2,-1);d=a[o>>0]|0;k=d<<24>>24<0;Ex(C,k?c[E>>2]|0:E,k?c[p>>2]|0:d&255)|0;c[B>>2]=c[C>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];d=0;while(1){if((d|0)==3)break;c[C+(d<<2)>>2]=0;d=d+1|0}p2(A,B);f=c[(c[(c[m>>2]|0)+80>>2]|0)+(e[n>>1]<<2)>>2]|0;c[H>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;g=j9(378333)|0;if(g>>>0>4294967279)break;if(g>>>0<11){a[q>>0]=g;d=H}else{k=g+16&-16;d=ZW(k)|0;c[H>>2]=d;c[r>>2]=k|-2147483648;c[s>>2]=g}i1(d,378333,g)|0;J7(d+g|0,0);vF(VC(f+28|0,H)|0,A)|0;a1(H);z5(A);O0(B);O0(E);z5(F);O0(C);z5(D);a[(c[(c[(c[m>>2]|0)+80>>2]|0)+(e[n>>1]<<2)>>2]|0)+185>>0]=1}else{j=I;j=z0(c[j>>2]|0,c[j+4>>2]|0,8,0)|0;k=I;c[k>>2]=j;c[k+4>>2]=z}J3(b)}k=(a[v>>0]|0)==0;f=I;d=c[f>>2]|0;f=c[f+4>>2]|0;h=z0(d|0,f|0,8,0)|0;g=z;if(!k){f=I;c[f>>2]=h;c[f+4>>2]=g;f=g;d=h}if(u>>>0>f>>>0|(u|0)==(f|0)&t>>>0>d>>>0){k=D_(t|0,u|0,d|0,f|0)|0;e1(b,k,z)}}else{k=(d&255)+-4|0;e1(b,k,((k|0)<0)<<31>>31)}}else e1(b,d&255,0);J3(b);d=I;f=c[d>>2]|0;d=c[d+4>>2]|0}uaa()}else Q=48}else{Q=D_(t|0,u|0,f|0,g|0)|0;e1(b,Q,z);J3(b);Q=48}while(0);if((Q|0)==48)e1(b,i,0);l=R;return}function Id(f){f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+64|0;n=w+48|0;r=w+36|0;s=w+24|0;t=w+12|0;u=w;v=f+760|0;RV(v);RB(f,2,0,18,373015,-1,1,0);g=f+940|0;tU(n,b[g>>1]&255,10);h=n+8+3|0;m=a[h>>0]|0;i=n+4|0;if(((m<<24>>24<0?c[i>>2]|0:m&255)|0)==1)Yv(n,1,48)|0;tU(u,(e[g>>1]|0)>>>8&65535,10);Gx(u,46);c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}g=a[h>>0]|0;m=g<<24>>24<0;Ex(t,m?c[n>>2]|0:n,m?c[i>>2]|0:g&255)|0;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];g=0;while(1){if((g|0)==3)break;c[t+(g<<2)>>2]=0;g=g+1|0}p2(r,s);zb(f,2,0,24,r,0);z5(r);O0(s);O0(t);z5(u);RB(f,2,0,52,373023,-1,1,0);kL(f,2,0,147,b[61554+(((a[f+925>>0]<<1&255|a[f+924>>0])&255)<<1)>>1]|0,10,0);m=f+20|0;g=a[f+931>>0]|0;if(!(g<<24>>24))g=a[f+926>>0]|0?1:2;else g=g&255;sM(f,2,c[m>>2]|0,122,g,0);k=f+932|0;if(c[k>>2]|0){TX(r);TX(s);g=c[k>>2]|0;if(g&199){HX(r,16248)|0;h=c[k>>2]|0;if(!(h&1))g=0;else{HX(r,16276)|0;g=1;h=c[k>>2]|0}if(h&4){HX(r,16288)|0;g=g+1<<24>>24;h=c[k>>2]|0}if(h&64){HX(r,16288)|0;g=g+1<<24>>24;h=c[k>>2]|0}if(h&128){HX(r,16288)|0;g=g+1<<24>>24;h=c[k>>2]|0}if(h&2){HX(r,16300)|0;g=g+1<<24>>24}uU(t,g,10);g=a[t+8+3>>0]|0;j=g<<24>>24<0;Ex(s,j?c[t>>2]|0:t,j?c[t+4>>2]|0:g&255)|0;z5(t);g=c[k>>2]|0}i=r+4|0;j=r+8+3|0;if(!(g&1536))HX(s,16336)|0;else{h=a[j>>0]|0;if((h<<24>>24<0?c[i>>2]|0:h&255)|0)HX(r,39968)|0;HX(r,16312)|0;h=c[k>>2]|0;if(!(h&512))g=0;else{HX(r,16276)|0;g=1;h=c[k>>2]|0}if(h&1024){HX(r,16300)|0;g=g+1<<24>>24}uU(u,g,10);zv(u,(a[u+8+3>>0]|0)<0?c[u>>2]|0:u,46);c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}h=a[t+8+3>>0]|0;g=h<<24>>24<0;Ex(s,g?c[t>>2]|0:t,g?c[t+4>>2]|0:h&255)|0;O0(t);z5(u)}if(!(c[k>>2]&304))HX(s,16336)|0;else{h=a[j>>0]|0;if((h<<24>>24<0?c[i>>2]|0:h&255)|0)HX(r,39968)|0;HX(r,16348)|0;h=c[k>>2]|0;if(!(h&16))g=0;else{HX(r,16276)|0;g=1;h=c[k>>2]|0}if(h&256){HX(r,16288)|0;g=g+1<<24>>24;h=c[k>>2]|0}if(h&32){HX(r,16300)|0;g=g+1<<24>>24}uU(u,g,10);zv(u,(a[u+8+3>>0]|0)<0?c[u>>2]|0:u,47);c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}h=a[t+8+3>>0]|0;g=h<<24>>24<0;Ex(s,g?c[t>>2]|0:t,g?c[t+4>>2]|0:h&255)|0;O0(t);z5(u)}if(c[k>>2]&8|0){u=a[j>>0]|0;if((u<<24>>24<0?c[i>>2]|0:u&255)|0)HX(r,39968)|0;HX(r,16372)|0;HX(s,16388)|0}zb(f,2,0,128,r,0);zb(f,2,0,129,s,0);z5(s);z5(r)}if(((a[f+904>>0]|0)==0?(o=f+930|0,p=a[o>>0]|0,(p&255)<15):0)?(lL(f,2,c[m>>2]|0,135,c[16400+((p&255)<<2)>>2]|0,10,0),q=c[f+908>>2]|0,(q|0)!=-1):0){u=UW(q|0,0,1e3,0)|0;u=g5(u|0,z|0,c[16400+(d[o>>0]<<2)>>2]|0,0)|0;oK(f,2,0,68,u,z,10,0)}u=f+927|0;RB(f,2,0,27,a[u>>0]|0?373031:379718,-1,1,0);RB(f,2,0,60,a[u>>0]|0?373044:373057,-1,1,0);zb(f,2,0,253,f+944|0,0);rn(v,524288,0,373015);z5(n);l=w;return}function Jd(b){b=b|0;var f=0,g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;v=l;l=l+16|0;i=v+6|0;n=v+4|0;o=v;Bx(b);r=b+812|0;xR(b,2,r);u=b+810|0;s=b+823|0;t=b+808|0;a:do switch(a[r>>0]|0){case 1:case 0:{r=b+648|0;d4(c[r>>2]|0,2);d4(c[r>>2]|0,3);d4(c[r>>2]|0,5);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);d4(c[r>>2]|0,2);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);d4(c[r>>2]|0,2);d4(c[r>>2]|0,2);A6(c[r>>2]|0);A6(c[r>>2]|0);break}case 3:{xR(b,3,b+813|0);xR(b,2,b+814|0);m=b+648|0;d4(c[m>>2]|0,3);d4(c[m>>2]|0,5);A6(c[m>>2]|0);sR(b,12,b+804|0);sR(b,12,b+806|0);AT(b,b+828|0);AT(b,b+820|0);AT(b,b+821|0);AT(b,b+825|0);A6(c[m>>2]|0);AT(b,b+827|0);if(K6(c[m>>2]|0)|0){GC(b);A6(c[m>>2]|0);d4(c[m>>2]|0,14);d4(c[m>>2]|0,14);if(K6(c[m>>2]|0)|0){GC(b);A6(c[m>>2]|0);r=b+815|0;xR(b,4,r);if((a[r>>0]|0)==15){xR(b,8,b+816|0);xR(b,8,b+817|0)}J3(b)}else A6(c[m>>2]|0);r=b+822|0;yT(b,r);if(!(a[r>>0]|0))A6(c[m>>2]|0);else{GC(b);A6(c[m>>2]|0);yT(b,s);if(!(a[s>>0]|0)){A6(c[m>>2]|0);xR(b,8,u);xR(b,4,b+811|0)}else{GC(b);A6(c[m>>2]|0);sR(b,16,t);J3(b)}J3(b)}if(K6(c[m>>2]|0)|0){GC(b);A6(c[m>>2]|0);d4(c[m>>2]|0,8);d4(c[m>>2]|0,8);d4(c[m>>2]|0,8);J3(b)}else A6(c[m>>2]|0);J3(b)}else A6(c[m>>2]|0);r=b+824|0;yT(b,r);if(!(a[r>>0]|0)){A6(c[m>>2]|0);break a}GC(b);A6(c[m>>2]|0);p=b+818|0;xR(b,5,p);d4(c[m>>2]|0,4);xR(b,4,i);q=b+792|0;f=c[q>>2]|0;r=b+796|0;g=c[r>>2]|0;while(1){if((g|0)==(f|0))break;k=g+-4|0;c[r>>2]=k;g=k}k=b+800|0;g=(d[i>>0]|0)+1|0;f=0;while(1){if((f&255)>=(d[p>>0]|0))break;GC(b);d4(c[m>>2]|0,16);sR(b,16,n);w=+((e[n>>1]|0)+1|0);i=~~(+eaa(g)*w)>>>0;c[o>>2]=i;J3(b);j=c[r>>2]|0;if((j|0)==(c[k>>2]|0))Yy(q,o);else{c[j>>2]=i;c[r>>2]=j+4}f=f+1<<24>>24}J3(b);break}default:j3(b)}while(0);KS(b);wK(b);f=b+544|0;g=b+528|0;i=b+612|0;n=g;k=b+536|0;j=c[k>>2]|0;k=c[k+4>>2]|0;m=c[n+4>>2]|0;n=c[n>>2]|0;while(1){if(!(m>>>0<k>>>0|(m|0)==(k|0)&n>>>0<j>>>0))break;if(a[(c[f>>2]|0)+((c[i>>2]|0)+n)>>0]|0)break;r=z0(n|0,m|0,1,0)|0;q=z;p=g;c[p>>2]=r;c[p+4>>2]=q;m=q;n=r}if((n|0)==(j|0)&(m|0)==(k|0)){if(qO(b)|0){s_(b);AR(b,13,0);AR(b,14,0);r=c[b+832>>2]|0;a[r+39>>0]=1;a[r+42>>0]=1;do if(a[b+822>>0]|0){g=b+896|0;if(a[s>>0]|0){h[g>>3]=+((e[t>>1]|0)+1|0)*.015625;break}f=Y4(a[b+811>>0]|0)|0;if(f<<16>>16)h[g>>3]=+((pP(a[u>>0]|0)|0)>>>0)/+(f&65535)}while(0);if(a[b+769>>0]|0){if(!(c[b+728>>2]&1))W5(b);V5(b)}}}else t4(b);l=v;return}function Kd(b){b=b|0;var f=0,g=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;K=b+544|0;g=c[K>>2]|0;P=b+612|0;F=c[P>>2]|0;f=a[g+(F+4)>>0]|0;X=f&255;Y=b+528|0;if((f&255)<=183)if(f<<24>>24){L=d[g+(F+5)>>0]|0;l=(L&128|0)==0;M=(L&16|0)!=0;N=(L&8|0)!=0;O=(L&2|0)==0;if(M){G=PZ(d[g+(F+6)>>0]|0,0,25)|0;C=z;E=PZ(d[g+(F+7)>>0]|0,0,17)|0;C=z|C;D=PZ(d[g+(F+8)>>0]|0,0,9)|0;C=C|z;m=PZ(d[g+(F+9)>>0]|0,0,1)|0;C=C|z;k=d[g+(F+10)>>0]|0;j=XZ(k|0,0,7)|0;C=UW(E|G|D|m|j|0,C|z|0,300,0)|0;j=z;k=PZ(k|0,0,8)|0;k=z0(C|0,j|0,k&256|d[g+(F+11)>>0]|0,0)|0;j=z;C=b+768|0;m=c[C>>2]|0;D=b+762|0;g=c[(c[m+80>>2]|0)+(e[D>>1]<<2)>>2]|0;G=b+48|0;E=b+728|0;do if(a[g+176>>0]|0){if(a[g+178>>0]|0?(a[g+69>>0]|0)==0:0){o=k;n=j;break}B=g+96|0;q=B;w=c[q>>2]|0;q=c[q+4>>2]|0;if(!((k|0)==(w|0)&(j|0)==(q|0))){A=g+104|0;o=A;p=c[o>>2]|0;o=c[o+4>>2]|0;if(!((p|0)==-1&(o|0)==-1)){y=z0(k|0,j|0,0,300)|0;x=z;y=x>>>0<q>>>0|(x|0)==(q|0)&y>>>0<w>>>0;x=z0(k|0,j|0,0,600)|0;k=y?x:k;j=y?z:j;y=z0(w|0,q|0,27e7,0)|0;x=z;if((j>>>0<x>>>0|(j|0)==(x|0)&k>>>0<y>>>0)&(l&(j>>>0>q>>>0|(j|0)==(q|0)&k>>>0>w>>>0))){r=D_(k|0,j|0,w|0,q|0)|0;s=z;l=z0(r|0,s|0,810,0)|0;u=+(l>>>0)+4294967296.0*+(z>>>0);l=G;n=c[l>>2]|0;l=c[l+4>>2]|0;x=D_(F|0,0,p|0,o|0)|0;x=z0(x|0,z|0,n|0,l|0)|0;t=(+(x>>>0)+4294967296.0*+(z>>>0))*8.0;u=t/u*27.0e6;x=g+120|0;v=+h[x>>3];y=g+136|0;if(v!=0.0){w=z0(r|0,s|0,-810,-1)|0;if(!(t/(+(w>>>0)+4294967296.0*+(z>>>0))*27.0e6<v)?!(u>+h[y>>3]):0)l=g+144|0;else l=g+152|0;o=l;o=z0(c[o>>2]|0,c[o+4>>2]|0,1,0)|0;q=l;c[q>>2]=o;c[q+4>>2]=z;q=B;l=G;o=A;r=c[q>>2]|0;q=c[q+4>>2]|0;p=c[o>>2]|0;o=c[o+4>>2]|0;n=c[l>>2]|0;l=c[l+4>>2]|0}else r=w;s=D_(k|0,j|0,r|0,q|0)|0;w=z;r=z0(s|0,w|0,-1,-1)|0;v=+(r>>>0)+4294967296.0*+(z>>>0);r=z0(s|0,w|0,1,0)|0;t=+(r>>>0)+4294967296.0*+(z>>>0);r=D_(F|0,0,p|0,o|0)|0;r=z0(r|0,z|0,n|0,l|0)|0;u=(+(r>>>0)+4294967296.0*+(z>>>0))*8.0;h[x>>3]=u/t*27.0e6;h[g+128>>3]=u/(+(s>>>0)+4294967296.0*+(w>>>0))*27.0e6;h[y>>3]=u/v*27.0e6}}n=B;c[n>>2]=k;c[n+4>>2]=j;a[g+114>>0]=1;n=G;n=z0(c[n>>2]|0,c[n+4>>2]|0,F|0,0)|0;o=A;c[o>>2]=n;c[o+4>>2]=z;c[E>>2]=c[E>>2]|65540;o=k;n=j}else{o=k;n=j}}else{o=k;n=j}while(0);if(a[g+175>>0]|0){B=g+80|0;c[B>>2]=o;c[B+4>>2]=n;B=G;B=z0(F|0,0,c[B>>2]|0,c[B+4>>2]|0)|0;F=z;m=g+88|0;c[m>>2]=B;c[m+4>>2]=F;m=g+96|0;c[m>>2]=o;c[m+4>>2]=n;a[g+114>>0]=1;m=g+104|0;c[m>>2]=B;c[m+4>>2]=F;RZ(g,0);TZ(c[(c[(c[C>>2]|0)+80>>2]|0)+(e[D>>1]<<2)>>2]|0,1);m=c[C>>2]|0;g=m+96|0;c[g>>2]=(c[g>>2]|0)+1;c[E>>2]=c[E>>2]|65540;g=c[(c[m+80>>2]|0)+(e[D>>1]<<2)>>2]|0}l=g+179|0;if(((a[l>>0]|0)==0?(H=g+80|0,I=H,i=c[I>>2]|0,I=c[I+4>>2]|0,!((i|0)==-1&(I|0)==-1)):0)?(R=G,R=z0(c[P>>2]|0,0,c[R>>2]|0,c[R+4>>2]|0)|0,Q=b+560|0,Q=D_(R|0,z|0,c[Q>>2]|0,c[Q+4>>2]|0)|0,R=z,F=PZ(Q|0,R|0,1)|0,D=z,G=b+40|0,E=c[G+4>>2]|0,D>>>0<E>>>0|((D|0)==(E|0)?F>>>0<(c[G>>2]|0)>>>0:0)):0){do if(I>>>0>n>>>0|(I|0)==(n|0)&i>>>0>o>>>0){G=D_(i|0,I|0,o|0,n|0)|0;F=z;if(F>>>0<0|(F|0)==0&G>>>0<27e7){j=H;c[j>>2]=o;c[j+4>>2]=n;j=o;k=n;i=o;g=n;break}else{j=z0(o|0,n|0,0,600)|0;k=z;g=I;break}}else{j=o;k=n;g=I}while(0);H=D_(j|0,k|0,i|0,g|0)|0;F=z;I=b+800|0;G=c[I+4>>2]|0;if((F>>>0>G>>>0|((F|0)==(G|0)?H>>>0>(c[I>>2]|0)>>>0:0)?(a[l>>0]=1,I=m+100|0,S=(c[I>>2]|0)+1|0,c[I>>2]=S,c[m+92>>2]|0):0)?(I=c[m+96>>2]|0,(I|0)!=0&(I|0)==(S|0)):0){S=b+776|0;c[S>>2]=Q;c[S+4>>2]=R;S=b+784|0;c[S>>2]=Q;c[S+4>>2]=R}}}if((!O?(T=M?6:0,U=N?6:0,J=L>>>2&1,V=J+1+U+(T|1)|0,X>>>0>V>>>0):0)?(W=a[(c[K>>2]|0)+((J|6)+T+U+(c[P>>2]|0))>>0]|0,((W&255)+V|0)>>>0<=X>>>0):0){V=Y;S=c[V>>2]|0;V=c[V+4>>2]|0;X=Y;c[X>>2]=(T+6+U|J)+1;c[X+4>>2]=0;Hd(b,W);X=Y;c[X>>2]=S;c[X+4>>2]=V}}else f=0;else f=-73;X=Y;X=z0((f&255)+1|0,0,c[X>>2]|0,c[X+4>>2]|0)|0;c[Y>>2]=X;c[Y+4>>2]=z;return}function Ld(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+16|0;s=u;a:while(1){q=b;r=b+-16|0;p=b+-8|0;while(1){b:while(1){o=a;d=q-o|0;e=d>>4;f=a+16|0;switch(e|0){case 1:case 0:break a;case 2:{t=5;break a}case 3:{t=7;break a}case 4:{t=8;break a}case 5:{t=9;break a}default:{}}if((d|0)<496){t=11;break a}g=(e|0)/2|0;j=a+(g<<4)|0;if((d|0)>15984){d=(e|0)/4|0;d=Gi(a,a+(d<<4)|0,j,j+(d<<4)|0,r)|0}else d=Sh(a,j,r)|0;n=a+8|0;m=n;k=c[m>>2]|0;m=c[m+4>>2]|0;i=a+(g<<4)+8|0;h=c[i>>2]|0;i=c[i+4>>2]|0;if(M$(k,m,h,i)|0){e=r;break}else e=r;while(1){g=e;e=e+-16|0;if((a|0)==(e|0))break;g=g+-8|0;if(M$(c[g>>2]|0,c[g+4>>2]|0,h,i)|0){t=28;break b}}o=p;if(M$(k,m,c[o>>2]|0,c[o+4>>2]|0)|0)a=f;else{d=f;while(1){if((d|0)==(r|0))break a;o=d+8|0;a=d+16|0;if(M$(k,m,c[o>>2]|0,c[o+4>>2]|0)|0)break;else d=a}c[s>>2]=c[d>>2];c[s+4>>2]=c[d+4>>2];c[s+8>>2]=c[d+8>>2];c[s+12>>2]=c[d+12>>2];c[d>>2]=c[r>>2];c[d+4>>2]=c[r+4>>2];c[d+8>>2]=c[r+8>>2];c[d+12>>2]=c[r+12>>2];c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2]}if((a|0)==(r|0))break a;else d=r;while(1){g=n;f=c[g>>2]|0;g=c[g+4>>2]|0;while(1){o=a+8|0;e=a+16|0;if(M$(f,g,c[o>>2]|0,c[o+4>>2]|0)|0)break;else a=e}do{o=d;d=d+-16|0;o=o+-8|0}while(M$(f,g,c[o>>2]|0,c[o+4>>2]|0)|0);if(a>>>0>=d>>>0)continue b;c[s>>2]=c[a>>2];c[s+4>>2]=c[a+4>>2];c[s+8>>2]=c[a+8>>2];c[s+12>>2]=c[a+12>>2];c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];c[d>>2]=c[s>>2];c[d+4>>2]=c[s+4>>2];c[d+8>>2]=c[s+8>>2];c[d+12>>2]=c[s+12>>2];a=e}}if((t|0)==28){t=0;c[s>>2]=c[a>>2];c[s+4>>2]=c[a+4>>2];c[s+8>>2]=c[a+8>>2];c[s+12>>2]=c[a+12>>2];c[a>>2]=c[e>>2];c[a+4>>2]=c[e+4>>2];c[a+8>>2]=c[e+8>>2];c[a+12>>2]=c[e+12>>2];c[e>>2]=c[s>>2];c[e+4>>2]=c[s+4>>2];c[e+8>>2]=c[s+8>>2];c[e+12>>2]=c[s+12>>2];d=d+1|0}c:do if(f>>>0<e>>>0)while(1){i=j+8|0;h=c[i>>2]|0;i=c[i+4>>2]|0;while(1){n=f+8|0;g=f+16|0;if(M$(c[n>>2]|0,c[n+4>>2]|0,h,i)|0)f=g;else break}do{n=e;e=e+-16|0;n=n+-8|0}while(!(M$(c[n>>2]|0,c[n+4>>2]|0,h,i)|0));if(f>>>0>e>>>0){e=j;break c}c[s>>2]=c[f>>2];c[s+4>>2]=c[f+4>>2];c[s+8>>2]=c[f+8>>2];c[s+12>>2]=c[f+12>>2];c[f>>2]=c[e>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];c[e>>2]=c[s>>2];c[e+4>>2]=c[s+4>>2];c[e+8>>2]=c[s+8>>2];c[e+12>>2]=c[s+12>>2];j=(j|0)==(f|0)?e:j;f=g;d=d+1|0}else e=j;while(0);if((f|0)!=(e|0)?(m=e+8|0,n=f+8|0,M$(c[m>>2]|0,c[m+4>>2]|0,c[n>>2]|0,c[n+4>>2]|0)|0):0){c[s>>2]=c[f>>2];c[s+4>>2]=c[f+4>>2];c[s+8>>2]=c[f+8>>2];c[s+12>>2]=c[f+12>>2];c[f>>2]=c[e>>2];c[f+4>>2]=c[e+4>>2];c[f+8>>2]=c[e+8>>2];c[f+12>>2]=c[e+12>>2];c[e>>2]=c[s>>2];c[e+4>>2]=c[s+4>>2];c[e+8>>2]=c[s+8>>2];c[e+12>>2]=c[s+12>>2];d=d+1|0}if(!d){d=Xi(a,f)|0;e=f+16|0;if(Xi(e,b)|0){t=44;break}if(d){a=e;continue}}n=f;if((n-o|0)>=(q-n|0)){t=43;break}Ld(a,f);a=f+16|0}if((t|0)==43){t=0;Ld(f+16|0,b);b=f;continue}else if((t|0)==44){t=0;if(d)break;else{b=f;continue}}}if((t|0)==5){q=p;t=a+8|0;if(M$(c[q>>2]|0,c[q+4>>2]|0,c[t>>2]|0,c[t+4>>2]|0)|0){c[s>>2]=c[a>>2];c[s+4>>2]=c[a+4>>2];c[s+8>>2]=c[a+8>>2];c[s+12>>2]=c[a+12>>2];c[a>>2]=c[r>>2];c[a+4>>2]=c[r+4>>2];c[a+8>>2]=c[r+8>>2];c[a+12>>2]=c[r+12>>2];c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2]}}else if((t|0)==7)Sh(a,f,r)|0;else if((t|0)==8)Kk(a,f,a+32|0,r)|0;else if((t|0)==9)Gi(a,f,a+32|0,a+48|0,r)|0;else if((t|0)==11)Qs(a,b);l=u;return}function Md(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+48|0;t=w+36|0;u=w+24|0;s=w+12|0;r=w;n=d+8+3|0;m=a[n>>0]|0;o=d+4|0;if((m<<24>>24<0?c[o>>2]|0:m&255)|0){k=+Cq(d);$x(t,b,e,f,i,1);m=a[t+8+3>>0]|0;m=((m<<24>>24<0?c[t+4>>2]|0:m&255)|0)==0;z5(t);if(m?($x(t,b,e,f,g,1),p=+Cq(t),z5(t),$x(t,b,e,f,h,1),q=+Cq(t),z5(t),p!=0.0&(k!=0.0&q!=0.0)):0){g=i9(37680)|0;m=a[n>>0]|0;h=c[o>>2]|0;if((g|0)==((m<<24>>24<0?h:m&255)|0)){g=(VG(d,37680,g)|0)==0;m=a[n>>0]|0;h=c[o>>2]|0;k=g?1.7777777910232544:k}g=i9(6892)|0;if((g|0)==((m<<24>>24<0?h:m&255)|0)){d=(VG(d,6892,g)|0)==0;k=d?1.3333333730697632:k}Bt(b,e,f,i,k/(p/q),3,0)}TX(t);do if(!(k>=1.2300000190734863&k<1.2699999809265137)){if(k>=1.2999999523162842&k<1.3700000047683716){Xy(u,6932);vF(t,u)|0;z5(u);break}if(k>=1.4500000476837158&k<1.5499999523162842){Xy(u,6948);vF(t,u)|0;z5(u);break}if(k>=1.5499999523162842&k<1.649999976158142){Xy(u,6964);vF(t,u)|0;z5(u);break}if(k>=1.649999976158142&k<1.7000000476837158){Xy(u,6988);vF(t,u)|0;z5(u);break}if(k>=1.7400000095367432&k<1.8200000524520874){Xy(u,7004);vF(t,u)|0;z5(u);break}if(k>=1.8200000524520874&k<1.8799999952316284){Xy(u,7024);vF(t,u)|0;z5(u);break}if(k>=2.1500000953674316&k<2.2200000286102295){Xy(u,7052);vF(t,u)|0;z5(u);break}if(k>=2.2300000190734863&k<2.299999952316284){Xy(u,7076);vF(t,u)|0;z5(u);break}if(k>=2.299999952316284&k<2.369999885559082){Xy(u,7104);vF(t,u)|0;z5(u);break}if(k>=2.369999885559082&k<2.450000047683716){Xy(u,7132);vF(t,u)|0;z5(u);break}else{io(t,k,3)|0;break}}else{Xy(u,6916);vF(t,u)|0;z5(u)}while(0);c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;m=i9(42212)|0;if(m>>>0>1073741807)uaa();g=u+8|0;do if(m>>>0>=2){h=m+4&-4;if(h>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{i=ZW(h<<2)|0;c[u>>2]=i;c[g>>2]=h|-2147483648;c[u+4>>2]=m;g=i;break}}else{a[g+3>>0]=m;g=u}while(0);a3(g,42212,m);y7(g+(m<<2)|0,0);Xy(r,7160);pl(s,r);vo(t,u,s,0,0);z5(s);z5(r);O0(u);Xy(s,7276);pl(u,s);g=i9(23700)|0;r=a[u+8+3>>0]|0;do if((g|0)==((r<<24>>24<0?c[u+4>>2]|0:r&255)|0)?(VG(u,23700,g)|0)==0:0){g=a[t+8+3>>0]|0;h=g<<24>>24<0;m=h?c[t>>2]|0:t;n=i9(7348)|0;if(!n){z5(u);z5(s);break}i=m+((h?c[t+4>>2]|0:g&255)<<2)|0;r=HA(m,i,7348,7348+(n<<2)|0)|0;z5(u);z5(s);if((r|0)==(i|0)|(r-m|0)==-4){c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;m=i9(42204)|0;if(m>>>0>1073741807)uaa();g=u+8|0;do if(m>>>0>=2){h=m+4&-4;if(h>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{r=ZW(h<<2)|0;c[u>>2]=r;c[g>>2]=h|-2147483648;c[u+4>>2]=m;g=r;break}}else{a[g+3>>0]=m;g=u}while(0);a3(g,42204,m);y7(g+(m<<2)|0,0);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;m=i9(42012)|0;if(m>>>0>1073741807)uaa();g=s+8|0;do if(m>>>0>=2){h=m+4&-4;if(h>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{r=ZW(h<<2)|0;c[s>>2]=r;c[g>>2]=h|-2147483648;c[s+4>>2]=m;g=r;break}}else{a[g+3>>0]=m;g=s}while(0);a3(g,42012,m);y7(g+(m<<2)|0,0);vo(t,u,s,0,0);O0(s);O0(u)}}else v=58;while(0);if((v|0)==58){z5(u);z5(s)}zb(b,e,f,j+1|0,t,1);z5(t)}l=w;return}function Nd(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=l;l=l+64|0;v=x+48|0;h=x+44|0;i=x+40|0;e=x+36|0;j=x+52|0;u=x+24|0;s=x+12|0;t=x;bD(d,v);bD(d,h);bD(d,i);w=d+528|0;r=w;r=z0(c[r>>2]|0,c[r+4>>2]|0,2,0)|0;q=w;c[q>>2]=r;c[q+4>>2]=z;HB(d,j);r3(d,e);q=w;q=z0(c[q>>2]|0,c[q+4>>2]|0,20,0)|0;r=w;c[r>>2]=q;c[r+4>>2]=z;if(qO(d)|0){TX(u);q=c[e>>2]|0;k=(q|0)==0;if(((((q&255)+-32|0)>>>0<95?((q&65280)+-8192|0)>>>0<24065:0)?((q&16711680)+-2097152|0)>>>0<6160385:0)?(f=q&-16777216,f>>>0>536870911):0){if(k|f>>>0<2113929217)g=8}else g=7;if((g|0)==7?k:0)g=8;a:do if((g|0)==8){c[d+796>>2]=3;e=d+784|0;lh(e,q)|0;r=d+20|0;f=c[r>>2]|0;if(k){RB(d,1,f,18,384047,-1,1,1);RB(d,1,c[r>>2]|0,58,384047,-1,1,1)}else{Rf(d,e,1,f,3);zb(d,1,c[r>>2]|0,58,e,1);zb(d,1,c[r>>2]|0,63,e,0)}lL(d,1,c[r>>2]|0,130,c[h>>2]|0,10,1);lL(d,1,c[r>>2]|0,138,c[i>>2]|0,10,1);m=b[j>>1]|0;n=m<<16>>16==32;p=d+16|0;if(n&(q|0)==1953719139){$M(d,c[p>>2]|0,c[r>>2]|0,379872,8);break}b:do if((q|0)<1146639170){switch(q|0){case 1145656883:break;default:break b}$M(d,c[p>>2]|0,c[r>>2]|0,379872,8);break a}else{switch(q|0){case 1146639170:break;default:break b}_M(d,c[p>>2]|0,c[r>>2]|0,379872,m);break a}while(0);o=(m&65535)>>>2&65535;if((m&65535)>16){e=c[p>>2]|0;TX(s);e=Aj(e,3,lh(s,q)|0,7)|0;f=a[e+8+3>>0]|0;g=f<<24>>24<0;h=g?c[e>>2]|0:e;i=i9(29388)|0;if(!i)e=0;else{j=h+((g?c[e+4>>2]|0:f&255)<<2)|0;e=HA(h,j,29388,29388+(i<<2)|0)|0;e=(e|0)==(j|0)?-1:e-h>>2}z5(s);if((e|0)!=-1){$M(d,c[p>>2]|0,c[r>>2]|0,379872,o);break}}j=((m&65535)/3|0)&65535;do if(!k){i=c[p>>2]|0;TX(s);i=Aj(i,3,lh(s,q)|0,7)|0;e=a[i+8+3>>0]|0;f=e<<24>>24<0;g=f?c[i>>2]|0:i;h=i9(29408)|0;if(!h){z5(s);break}i=g+((f?c[i+4>>2]|0:e&255)<<2)|0;k=HA(g,i,29408,29408+(h<<2)|0)|0;z5(s);if((k|0)==(i|0)|(k-g|0)==-4){do if((q|0)!=1448097330){e=c[p>>2]|0;TX(s);e=Aj(e,3,lh(s,q)|0,1)|0;f=i9(29424)|0;o=a[e+8+3>>0]|0;if((f|0)==((o<<24>>24<0?c[e+4>>2]|0:o&255)|0)?(VG(e,29424,f)|0)==0:0){z5(s);break}e=c[p>>2]|0;TX(t);e=Aj(e,3,lh(t,q)|0,1)|0;f=i9(30008)|0;q=a[e+8+3>>0]|0;if((f|0)==((q<<24>>24<0?c[e+4>>2]|0:q&255)|0)){q=(VG(e,30008,f)|0)==0;z5(t);z5(s);if(q)break;else break a}else{z5(t);z5(s);break a}}while(0);$M(d,c[p>>2]|0,c[r>>2]|0,379872,j);break a}}while(0);e=c[p>>2]|0;f=c[r>>2]|0;if(n){RB(d,e,f,Rb(e,0)|0,379881,-1,1,1);$M(d,c[p>>2]|0,c[r>>2]|0,379872,o);break}else{$M(d,e,f,379872,(m&65535)<17?8:j);break}}while(0);fc(d);z5(u)}s=w;i=d+536|0;t=i;u=c[d+648>>2]|0;if(DT(c[s>>2]|0,c[s+4>>2]|0,c[t>>2]|0,c[t+4>>2]|0,c[u+4>>2]|0,c[u+8>>2]|0)|0){GC(d);e=c[v>>2]|0;u=i;f=c[u>>2]|0;u=c[u+4>>2]|0;if(0>u>>>0|0==(u|0)&e>>>0>f>>>0){c[v>>2]=f;e=f}g=c[(kE(d+760|0,d+840|0)|0)+32>>2]|0;h=w;h=D_(e|0,0,c[h>>2]|0,c[h+4>>2]|0)|0;Zn(d,g,h);J3(d);h=w;g=c[h>>2]|0;h=c[h+4>>2]|0;f=i;e=c[f>>2]|0;f=c[f+4>>2]|0;if(f>>>0>h>>>0|(f|0)==(h|0)&e>>>0>g>>>0){w=D_(e|0,f|0,g|0,h|0)|0;e1(d,w,z)}}l=x;return}function Od(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;B=l;l=l+48|0;n=B;A=b+512|0;a[A>>0]=0;x=b+508|0;f=c[x>>2]|0;y=b+668|0;e=c[y>>2]|0;do if(!(a[e+(f*24|0)+17>>0]|0)){r=e+(f*24|0)|0;j=c[r+4>>2]|0;o=b+520|0;c[o>>2]=c[r>>2];c[o+4>>2]=j;jb[c[(c[b>>2]|0)+104>>2]&511](b);YZ(c[b+648>>2]|0,0,0);o=b+612|0;j=c[o>>2]|0;r=b+536|0;s=b+528|0;i=a[A>>0]|0?s:r;v=i;v=z0(c[v>>2]|0,c[v+4>>2]|0,j|0,0)|0;t=z;d=b+120|0;m=d;k=c[m>>2]|0;m=c[m+4>>2]|0;if(!(t>>>0<m>>>0|(t|0)==(m|0)&v>>>0<k>>>0)){e=b+320|0;v=e;t=c[v+4>>2]|0;h=b+312|0;f=c[h>>2]|0;h=c[h+4>>2]|0;if(t>>>0<h>>>0|((t|0)==(h|0)?(c[v>>2]|0)>>>0<f>>>0:0)){v=e;c[v>>2]=f;c[v+4>>2]=h}e=b+344|0;v=e;t=c[v+4>>2]|0;h=b+336|0;f=c[h>>2]|0;h=c[h+4>>2]|0;if(t>>>0<h>>>0|((t|0)==(h|0)?(c[v>>2]|0)>>>0<f>>>0:0)){v=e;c[v>>2]=f;c[v+4>>2]=h}}v=i;v=z0(c[v>>2]|0,c[v+4>>2]|0,j|0,0)|0;t=z;if(!(t>>>0<m>>>0|(t|0)==(m|0)&v>>>0<k>>>0)?(v=b+224|0,!((c[v>>2]|0)==-1?(c[v+4>>2]|0)==-1:0)):0){h=b+200|0;e=h;f=d+40|0;do{c[d>>2]=c[e>>2];d=d+4|0;e=e+4|0}while((d|0)<(f|0));T$(n);d=h;e=n;f=d+40|0;do{c[d>>2]=c[e>>2];d=d+4|0;e=e+4|0}while((d|0)<(f|0))}f=c[x>>2]|0;e=c[y>>2]|0;if(J1(f,e)|0){J3(b);c[o>>2]=(c[o>>2]|0)-(c[b+656>>2]|0);d=0;break}a[e+(f*24|0)+18>>0]=1;if(!(a[A>>0]|0))if((a[b+494>>0]|0)!=0?(w=s,v=c[w+4>>2]|0,q=r,p=c[q>>2]|0,q=c[q+4>>2]|0,v>>>0<q>>>0|((v|0)==(q|0)?(c[w>>2]|0)>>>0<p>>>0:0)):0){d=s;c[d>>2]=p;c[d+4>>2]=q;d=0;w=17}else{d=0;w=17}else{d=1;w=17}}else{d=0;o=b+612|0;r=b+536|0;s=b+528|0;w=17}while(0);a:do if((w|0)==17){n=b+64|0;q=n;v=b+48|0;t=b+656|0;h=d<<24>>24==0;do if((c[q>>2]|0)==-1?(c[q+4>>2]|0)==-1:0){p=b+728|0;m=(c[p>>2]&8|0)==0;q=b+732|0;if(!m?(a[q>>0]|0)==0:0)break;if(h){i=e+(f*24|0)+8|0;e=c[i>>2]|0;i=c[i+4>>2]|0;k=v;j=c[k>>2]|0;k=c[k+4>>2]|0;w=z0(c[b+548>>2]|0,0,j|0,k|0)|0;u=z;do if(!(i>>>0>u>>>0|(i|0)==(u|0)&e>>>0>w>>>0)){h=s;f=c[h>>2]|0;h=c[h+4>>2]|0;e=D_(e|0,i|0,j|0,k|0)|0;e=D_(e|0,z|0,c[o>>2]|0,0)|0;if(h>>>0<0|(h|0)==0&f>>>0<e>>>0){h=s;c[h>>2]=e;c[h+4>>2]=0;h=0;f=e}}else{if(!m){f=s;h=c[f+4>>2]|0;f=c[f>>2]|0;break}ty(b,e,i);if(a[A>>0]|0){d=0;break a}J3(b);d=0;break a}while(0);w=r;e=c[w>>2]|0;w=c[w+4>>2]|0;if(h>>>0<w>>>0|(h|0)==(w|0)&f>>>0<e>>>0){c[o>>2]=(c[o>>2]|0)+e;w=t;c[w>>2]=0;c[w+4>>2]=0;w=r;c[w>>2]=0;c[w+4>>2]=0;w=s;c[w>>2]=0;c[w+4>>2]=0;w=44}else{e=h;w=40}}else{e=s;f=c[e>>2]|0;e=c[e+4>>2]|0;w=40}if((w|0)==40){i=c[o>>2]|0;e=z0(i|0,0,f|0,e|0)|0;h=z;if(h>>>0>0|(h|0)==0&e>>>0>4294967294){d=v;d=z0(c[d>>2]|0,c[d+4>>2]|0,e|0,h|0)|0;ty(b,d,z);d=a[A>>0]|0}else c[o>>2]=i+f;A=t;c[A>>2]=0;c[A+4>>2]=0;A=r;c[A>>2]=0;c[A+4>>2]=0;A=s;c[A>>2]=0;c[A+4>>2]=0;if(!(d<<24>>24))w=44}if((w|0)==44)J3(b);e=c[x>>2]|0;d=c[y>>2]|0;a[d+(e*24|0)+17>>0]=0;f=b+379|0;if(a[f>>0]|0){d=1;break a}if(!(+g[(c[b+24>>2]|0)+136>>2]<1.0)){d=1;break a}A=n;if(!((c[A>>2]|0)==-1?(c[A+4>>2]|0)==-1:0)){d=1;break a}a[d+(e*24|0)+16>>0]=0;jb[c[(c[b>>2]|0)+108>>2]&511](b);e=n;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!(!((d|0)==-1&(e|0)==-1)?(b=v,b=z0(c[o>>2]|0,0,c[b>>2]|0,c[b+4>>2]|0)|0,A=z,e>>>0>A>>>0|(e|0)==(A|0)&d>>>0>b>>>0):0)){if(!(c[p>>2]&8)){d=1;break a}if(a[q>>0]|0){d=1;break a}}a[f>>0]=1;d=0;break a}while(0);if(h){J3(b);e=c[o>>2]|0;d=s;f=c[d>>2]|0;d=c[d+4>>2]|0;if((a[A>>0]|0)==0?(A=r,u=c[A>>2]|0,A=c[A+4>>2]|0,d>>>0<A>>>0|(d|0)==(A|0)&f>>>0<u>>>0):0)c[o>>2]=u+e;else{h=e;w=25}}else{d=s;h=c[o>>2]|0;f=c[d>>2]|0;d=c[d+4>>2]|0;w=25}do if((w|0)==25){d=z0(h|0,0,f|0,d|0)|0;e=z;if(e>>>0>0|(e|0)==0&d>>>0>4294967294){A=v;A=z0(c[A>>2]|0,c[A+4>>2]|0,d|0,e|0)|0;ty(b,A,z);break}else{c[o>>2]=h+f;break}}while(0);d=t;c[d>>2]=0;c[d+4>>2]=0;d=r;c[d>>2]=0;c[d+4>>2]=0;d=s;c[d>>2]=0;c[d+4>>2]=0;d=0}while(0);l=B;return d|0}function Pd(b){b=b|0;var f=0,g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=l;l=l+80|0;g=x+78|0;i=x+77|0;m=x+76|0;p=x+75|0;q=x+74|0;n=x+73|0;k=x+72|0;v=x+60|0;w=x+48|0;r=x+36|0;s=x+24|0;t=x+12|0;u=x;a[p>>0]=4;a[q>>0]=10;a[n>>0]=1;a[k>>0]=0;Bx(b);AT(b,i);xR(b,4,g);AT(b,m);f=b+648|0;A6(c[f>>2]|0);A6(c[f>>2]|0);m=a[m>>0]|0;if(!(m<<24>>24)){A6(c[f>>2]|0);xR(b,3,p);xR(b,4,q);xR(b,2,n);AT(b,k);d4(c[f>>2]|0,5)}wK(b);if((qO(b)|0?(a[b+768>>0]|0)==2:0)?a[b+784>>0]|0:0){if((a[i>>0]|0)==0?(j=a[g>>0]|0,(a[k>>0]|0)==0&j<<24>>24!=0):0){ST(v,+h[736+((j&255)<<3)>>3],3);g=c[(c[(c[b+760>>2]|0)+80>>2]|0)+(e[b+772>>1]<<2)>>2]|0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;i=j9(387830)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[w+11>>0]=i;f=w}else{o=i+16&-16;f=ZW(o)|0;c[w>>2]=f;c[w+8>>2]=o|-2147483648;c[w+4>>2]=i}i1(f,387830,i)|0;J7(f+i|0,0);vF(VC(g+28|0,w)|0,v)|0;a1(w);z5(v)}Xy(v,m<<24>>24?40212:40252);o=b+760|0;m=b+772|0;g=c[(c[(c[o>>2]|0)+80>>2]|0)+(e[m>>1]<<2)>>2]|0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;i=j9(387815)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[w+11>>0]=i;f=w}else{b=i+16&-16;f=ZW(b)|0;c[w>>2]=f;c[w+8>>2]=b|-2147483648;c[w+4>>2]=i}i1(f,387815,i)|0;J7(f+i|0,0);vF(VC(g+28|0,w)|0,v)|0;a1(w);z5(v);VU(v,c[35868+(d[n>>0]<<2)>>2]|0);g=c[(c[(c[o>>2]|0)+80>>2]|0)+(e[m>>1]<<2)>>2]|0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;i=j9(387840)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[w+11>>0]=i;f=w}else{n=i+16&-16;f=ZW(n)|0;c[w>>2]=f;c[w+8>>2]=n|-2147483648;c[w+4>>2]=i}i1(f,387840,i)|0;J7(f+i|0,0);vF(VC(g+28|0,w)|0,v)|0;a1(w);z5(v);f=a[p>>0]|0;if(f<<24>>24){TX(s);k=c[35900+((f&255)<<2)>>2]|0;cC(s,k)|0;Bs(r,s,54768);TX(t);j=c[35932+(d[q>>0]<<2)>>2]|0;cC(t,j)|0;f=a[t+8+3>>0]|0;q=f<<24>>24<0;Ex(r,q?c[t>>2]|0:t,q?c[t+4>>2]|0:f&255)|0;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];f=0;while(1){if((f|0)==3)break;c[r+(f<<2)>>2]=0;f=f+1|0}p2(v,w);g=c[(c[(c[o>>2]|0)+80>>2]|0)+(e[m>>1]<<2)>>2]|0;c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;i=j9(384616)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[u+11>>0]=i;f=u}else{q=i+16&-16;f=ZW(q)|0;c[u>>2]=f;c[u+8>>2]=q|-2147483648;c[u+4>>2]=i}i1(f,384616,i)|0;J7(f+i|0,0);vF(VC(g+28|0,u)|0,v)|0;a1(u);z5(v);O0(w);z5(t);O0(r);z5(s);TX(s);cC(s,k)|0;Bs(r,s,54768);TX(t);cC(t,j)|0;f=a[t+8+3>>0]|0;q=f<<24>>24<0;Ex(r,q?c[t>>2]|0:t,q?c[t+4>>2]|0:f&255)|0;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];f=0;while(1){if((f|0)==3)break;c[r+(f<<2)>>2]=0;f=f+1|0}p2(v,w);g=c[(c[(c[o>>2]|0)+80>>2]|0)+(e[m>>1]<<2)>>2]|0;c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;i=j9(387852)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[u+11>>0]=i;f=u}else{q=i+16&-16;f=ZW(q)|0;c[u>>2]=f;c[u+8>>2]=q|-2147483648;c[u+4>>2]=i}i1(f,387852,i)|0;J7(f+i|0,0);vF(VC(g+28|0,u)|0,v)|0;a1(u);z5(v);O0(w);z5(t);O0(r);z5(s)}}l=x;return}function Qd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;d=k;e=k+8|0;j=b+536|0;i=j;if((c[i>>2]|0)==4&(c[i+4>>2]|0)==0){aH(b,e);h=c[e>>2]|0;g=d;c[g>>2]=0;c[g+4>>2]=h;g=0}else{zE(b,d);h=d;g=c[h>>2]|0;h=c[h+4>>2]|0}a:do if((g|0)<538976288){switch(g|0){case 0:break;default:{i=9;break a}}if((h|0)==1129139532){hR(b);i=53}else i=9}else{switch(g|0){case 538976288:break;default:{i=9;break a}}if((h|0)==1128614996){iR(b);i=53}else i=9}while(0);b:do if((i|0)==9){d=XZ(g|0,h|0,24)|0;e=z&255;c:do if((d|0)<1179402563){switch(d|0){case 1111704576:break;default:break c}if((e|0)==66){jR(b);i=53;break b}}else{switch(d|0){case 1179402563:break;default:break c}if((e|0)==127){PW(b);i=53;break b}}while(0);d:do if((g|0)<1229211904){if((g|0)>=538976288)if((g|0)<1214603620){switch(g|0){case 538976288:break;default:break d}if((h|0)!=1346587936)break;VS(b);i=53;break b}else{switch(g|0){case 1214603620:break;default:break d}if((h|0)!=1332770163)break;NU(b);i=53;break b}switch(g|0){case 218765834:break;default:break d}if((h|0)<-1974645177){switch(h|0){case -1991225785:break;default:break d}US(b);i=53;break b}if((h|0)<-1958064569){switch(h|0){case -1974645177:break;default:break d}WS(b);i=53;break b}else{switch(h|0){case -1958064569:break;default:break d}XS(b);i=53;break b}}else if((g|0)<1694498816)if((g|0)<1230127427){switch(g|0){case 1229211904:break;default:break d}if((h|0)!=1298622285)break;JS(b);i=53;break b}else{switch(g|0){case 1230127427:break;default:break d}if((h|0)!=1264004420)break;zX(b);i=53;break b}else if((g|0)<2015371296){switch(g|0){case 1694498816:break;default:break d}if((h|0)!=-2140446348)break;PS(b);i=53;break b}else{switch(g|0){case 2015371296:break;default:break d}if((h|0)!=1399874917)break;bR(b);i=53;break b}while(0);f=XZ(g|0,h|0,8)|0;d=z;e=d&16777215;e:do if((f|0)<1919052147){switch(f|0){case 1701802593:break;default:break e}if((e|0)==8418408){vZ(b);i=53;break b}}else{switch(f|0){case 1919052147:break;default:break e}if((e|0)==95855){uZ(b);i=53;break b}}while(0);if((g|0)==1297106247&(h|0)==1498764852){HS(b);i=53;break}d=d&16777215;f:do if((f|0)<1684631296){switch(f|0){case 1684369152:break;default:break f}if((d|0)==95849){Ui(b);i=53;break b}}else if((f|0)<2020868096){switch(f|0){case 1684631296:break;default:break f}if((d|0)!=90485)break;ii(b);i=53;break b}else{switch(f|0){case 2020868096:break;default:break f}if((d|0)!=95333)break;Pv(b);i=53;break b}while(0);if(0==0&(h|0)==1716281667){NG(b);i=53;break}g:do if((g|0)<1869505792){switch(g|0){case 1700881408:break;default:break g}if((h|0)==1718186856){It(b);i=53;break b}}else{switch(g|0){case 1869505792:break;default:break g}if((h|0)==1718186850){Tr(b);i=53;break b}}while(0);e1(b,c[j>>2]|0,c[j+4>>2]|0);W5(b);V5(b)}while(0);if((i|0)==53){aY(b,c[b+776>>2]|0);ux(b);c[b+760>>2]=c[b+16>>2];h:do if((g|0)<1869505792){switch(g|0){case 1700881408:break;default:{i=58;break h}}if((h|0)==1718186856)It(b);else i=58}else{switch(g|0){case 1869505792:break;default:{i=58;break h}}if((h|0)==1718186850)Tr(b);else i=58}while(0);if((i|0)==58)a[b+784>>0]=1;W5(b)}l=k;return}function Rd(f){f=f|0;var g=0,i=0,j=0,k=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=l;l=l+48|0;p=s+24|0;q=s+12|0;m=s;Kc(f,1,-1)|0;RB(f,1,0,18,383874,-1,1,0);j=f+812|0;RB(f,1,0,118,a[j>>0]|0?384435:384431,-1,1,0);n=f+798|0;o=f+792|0;if(((a[j>>0]|0)==0?(k=+h[f+768>>3],k!=0.0):0)?(g=dy(c[o>>2]|0,b[n>>1]|0,(O(a[f+811>>0]|0?2:1,e[f+796>>1]|0)|0)&65535)|0,g|0):0)KW(f,1,0,120,k*+(g<<3>>>0),0,0);uU(m,a[f+806>>0]|0,10);DW(m,0,38848)|0;c[q>>2]=c[m>>2];c[q+4>>2]=c[m+4>>2];c[q+8>>2]=c[m+8>>2];g=0;while(1){if((g|0)==3)break;c[m+(g<<2)>>2]=0;g=g+1|0}p2(p,q);zb(f,1,0,23,p,0);z5(p);O0(q);z5(m);i=O1(c[o>>2]|0)|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;j=j9(i)|0;if(j>>>0>4294967279)uaa();if(j>>>0<11){a[m+11>>0]=j;g=m}else{t=j+16&-16;g=ZW(t)|0;c[m>>2]=g;c[m+8>>2]=t|-2147483648;c[m+4>>2]=j}i1(g,i,j)|0;J7(g+j|0,0);gy(m,64);c[q>>2]=c[m>>2];c[q+4>>2]=c[m+4>>2];c[q+8>>2]=c[m+8>>2];g=0;while(1){if((g|0)==3)break;c[m+(g<<2)>>2]=0;g=g+1|0}JX(q,ML(c[o>>2]|0)|0)|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];g=0;while(1){if((g|0)==3)break;c[q+(g<<2)>>2]=0;g=g+1|0}bw(f,1,0,24,p,1,0);a1(p);a1(q);a1(m);g=a[f+805>>0]|0;if(g<<24>>24!=-1)RB(f,1,0,204,c[38884+((g&255)<<2)>>2]|0,-1,1,0);g=c[o>>2]|0;if(!(b$(g)|0)){kL(f,1,0,130,b[n>>1]|0,10,0);n=f+811|0;sM(f,1,0,138,O(a[n>>0]|0?2:1,e[f+796>>1]|0)|0,0);mL(f,1,0,195,w0(d[f+804>>0]|0)|0,10,0);RB(f,1,0,197,c[38900+(d[n>>0]<<2)>>2]|0,-1,1,0);n=f+808|0;i=c[38908+(d[n>>0]<<2)>>2]|0;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;j=j9(i)|0;if(j>>>0>4294967279)uaa();if(j>>>0<11){a[q+11>>0]=j;g=q}else{t=j+16&-16;g=ZW(t)|0;c[q>>2]=g;c[q+8>>2]=t|-2147483648;c[q+4>>2]=j}i1(g,i,j)|0;J7(g+j|0,0);m=f+815|0;JX(q,a[m>>0]|0?384025:8800948)|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];g=0;while(1){if((g|0)==3)break;c[q+(g<<2)>>2]=0;g=g+1|0}bw(f,1,0,191,p,1,0);a1(p);a1(q);if(!(a[n>>0]|0)){i=c[38916+(d[f+809>>0]<<2)>>2]|0;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;j=j9(i)|0;if(j>>>0>4294967279)uaa();if(j>>>0<11){a[q+11>>0]=j;g=q}else{t=j+16&-16;g=ZW(t)|0;c[q>>2]=g;c[q+8>>2]=t|-2147483648;c[q+4>>2]=j}i1(g,i,j)|0;J7(g+j|0,0);JX(q,a[m>>0]|0?384027:8800948)|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];g=0;while(1){if((g|0)==3)break;c[q+(g<<2)>>2]=0;g=g+1|0}bw(f,1,0,192,p,1,0);a1(p);a1(q)}g=b[f+800>>1]|0;if(g<<16>>16?(r=b[f+802>>1]|0,r<<16>>16):0)KW(f,1,0,150,+(g&65535)/+(r&65535),3,0)}else{i=kP(g)|0;if(i<<16>>16){kL(f,1,0,130,i,10,0);g=c[o>>2]|0}i=IS(g)|0;if(i<<16>>16){kL(f,1,0,138,i,10,0);g=c[o>>2]|0}i=wT(g)|0;if(i<<24>>24){mL(f,1,0,195,i,10,0);g=c[o>>2]|0}RB(f,1,0,197,TO(g)|0,-1,1,0);RB(f,1,0,191,VO(c[o>>2]|0)|0,-1,1,0);g=c[o>>2]|0;if(!(xN(VO(g)|0,384021)|0))RB(f,1,0,192,UO(g)|0,-1,1,0);KW(f,1,0,150,1.0,3,0)}i=f+776|0;g=a[i+11>>0]|0;if(g<<24>>24<0)g=c[f+780>>2]|0;else g=g&255;if(g|0)bw(f,1,0,245,i,1,0);i=f+152|0;g=c[i>>2]|0;i=c[i+4>>2]|0;if(!((g|0)==-1&(i|0)==-1))KW(f,1,0,171,1.0e9/(+(g>>>0)+4294967296.0*+(i>>>0)),3,0);l=s;return}function Sd(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;z=l;l=l+48|0;v=z+24|0;w=z+12|0;x=z;y=d+768|0;k=d+762|0;f=c[c[(c[(c[y>>2]|0)+80>>2]|0)+(e[k>>1]<<2)>>2]>>2]|0;g=(f|0)==0;if(!(a[d+765>>0]|0))if(g){y=d+536|0;e1(d,c[y>>2]|0,c[y+4>>2]|0)}else h=7;else{if(!g)jb[c[(c[f>>2]|0)+4>>2]&511](f);h=ZW(800)|0;QE(h);u=(c[(c[y>>2]|0)+80>>2]|0)+(e[k>>1]<<2)|0;c[c[u>>2]>>2]=h;aY(d,c[c[u>>2]>>2]|0);u=c[y>>2]|0;h=b[k>>1]|0;f=(c[u+80>>2]|0)+((h&65535)<<2)|0;c[(c[c[f>>2]>>2]|0)+764>>2]=u;f=c[c[f>>2]>>2]|0;b[f+768>>1]=h;h=7}do if((h|0)==7){rB(d,f);h=b[k>>1]|0;j=c[(c[y>>2]|0)+80>>2]|0;f=c[j+((h&65535)<<2)>>2]|0;g=c[f>>2]|0;i=c[g+728>>2]|0;if(!(i&2)){OZ(f,1);break}u=d+728|0;if((i&1|0)!=0&(h<<16>>16==0&(c[u>>2]&1|0)==0)){W5(d);h=b[k>>1]|0;j=c[(c[y>>2]|0)+80>>2]|0;g=c[j+((h&65535)<<2)>>2]|0;f=g;g=c[g>>2]|0}if(!g)g=j;else{jb[c[(c[g>>2]|0)+4>>2]&511](g);f=b[k>>1]|0;t=c[(c[y>>2]|0)+80>>2]|0;h=f;g=t;f=c[t+((f&65535)<<2)>>2]|0}c[f>>2]=0;UZ(c[g+((h&65535)<<2)>>2]|0,1);OZ(c[(c[(c[y>>2]|0)+80>>2]|0)+(e[k>>1]<<2)>>2]|0,0);i=c[y>>2]|0;if(!((a[i+120>>0]|0)==0?!(a[i+121>>0]|0):0))c[u>>2]=c[u>>2]|262148;if(a[i+52>>0]|0)c[u>>2]=c[u>>2]|131076;f=b[k>>1]|0;h=f<<16>>16==0;if(h)c[u>>2]=c[u>>2]&-524295|524292;f=c[(c[i+80>>2]|0)+((f&65535)<<2)>>2]|0;g=c[f+16>>2]|0;f=(g|0)==(c[f+20>>2]|0);g=g+8|0;if(!f?c[g>>2]|0:0)c[u>>2]=c[u>>2]&-3;if(!h){if(f)break;if(!(c[g>>2]|0))break}q=w+8+3|0;r=v+8+3|0;s=v+4|0;t=w+4|0;p=1;f=i;while(1){if(p>>>0>=7)break;h=c[f+164>>2]|0;g=c[h+(p*12|0)>>2]|0;h=c[h+(p*12|0)+4>>2]|0;a:do if((g|0)!=(h|0)){Tg(g,h);g=c[(c[y>>2]|0)+164>>2]|0;o=(p|0)==6;n=(c[g+(p*12|0)+4>>2]|0)-(c[g+(p*12|0)>>2]|0)>>2;while(1){m=n;n=n+-1|0;$x(x,d,p,c[(c[g+(p*12|0)>>2]|0)+(n<<2)>>2]|0,10,1);Gx(x,45);c[w>>2]=c[x>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];f=0;while(1){if((f|0)==3)break;c[x+(f<<2)>>2]=0;f=f+1|0}p2(v,w);O0(w);z5(x);k=0;while(1){if(k>>>0>=(RA(d,3,-1)|0)>>>0)break;$x(w,d,3,k,10,1);f=a[q>>0]|0;g=f<<24>>24<0;h=g?c[w>>2]|0:w;j=a[r>>0]|0;A=j<<24>>24<0;i=A?c[v>>2]|0:v;j=A?c[s>>2]|0:j&255;if(!j)f=0;else{A=h+((g?c[t>>2]|0:f&255)<<2)|0;f=HA(h,A,i,i+(j<<2)|0)|0;f=(f|0)==(A|0)?-1:f-h>>2}z5(w);if(!f)xd(d,3,k);k=k+1|0}xd(d,p,c[(c[(c[(c[y>>2]|0)+164>>2]|0)+(p*12|0)>>2]|0)+(n<<2)>>2]|0);i=c[y>>2]|0;g=c[i+164>>2]|0;h=c[g+(p*12|0)>>2]|0;g=(c[g+(p*12|0)+4>>2]|0)-h>>2;f=m;while(1){if(f>>>0>=g>>>0)break;A=h+(f<<2)|0;c[A>>2]=(c[A>>2]|0)+-1;f=f+1|0}b:do if(o){h=c[h+(n<<2)>>2]|0;k=i+204|0;f=c[k>>2]|0;g=c[i+200>>2]|0;if(h>>>0<f-g>>1>>>0){i=g+(h<<1)|0;g=i+2|0;h=f-g|0;j=h>>1;if(j){TR(i|0,g|0,h|0)|0;f=c[k>>2]|0}g=i+(j<<1)|0;while(1){if((f|0)==(g|0))break b;A=f+-2|0;c[k>>2]=A;f=A}}}else{f=c[(HD(i+68|0,i)|0)+16>>2]|0;c:while(1){A=c[y>>2]|0;if((f|0)==((HD(A+68|0,A)|0)+20|0))break b;a[f+104>>0]=1;g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue c}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}}while(0);z5(v);f=c[y>>2]|0;g=c[f+164>>2]|0;if(!n)break}i=c[g+(p*12|0)>>2]|0;g=g+(p*12|0)+4|0;h=c[g>>2]|0;while(1){if((h|0)==(i|0))break a;A=h+-4|0;c[g>>2]=A;h=A}}while(0);p=p+1|0}c[u>>2]=c[u>>2]|524292}while(0);l=z;return}function Td(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+80|0;k=o+36|0;i=o+69|0;j=o+68|0;e=o+52|0;m=o+24|0;n=o+12|0;h=o;c[k>>2]=0;Bx(b);xR(b,4,i);xR(b,3,j);d=b+648|0;A6(c[d>>2]|0);wK(b);switch(a[i>>0]|0){case 4:case 0:{Bx(b);xR(b,3,j);AT(b,e);d4(c[d>>2]|0,4);wK(b);jB(b,o+44|0);ID(b,o+40|0);ID(b,k);Bx(b);xR(b,4,i);xR(b,3,o+67|0);xR(b,5,o+66|0);AT(b,o+51|0);A6(c[d>>2]|0);AT(b,o+50|0);A6(c[d>>2]|0);AT(b,o+49|0);AT(b,o+48|0);xR(b,2,o+65|0);xR(b,1,o+64|0);A6(c[d>>2]|0);xR(b,1,o+63|0);xR(b,1,o+62|0);xR(b,1,o+61|0);xR(b,3,o+60|0);xR(b,2,o+59|0);xR(b,1,o+58|0);A6(c[d>>2]|0);wK(b);break}case 12:{Bx(b);xR(b,3,j);AT(b,e);d4(c[d>>2]|0,6);xR(b,1,o+57|0);xR(b,1,o+56|0);xR(b,1,o+55|0);xR(b,1,o+54|0);xR(b,1,o+53|0);A6(c[d>>2]|0);wK(b);ID(b,k);GC(b);d=ZW(920)|0;Wv(d);a[d+768>>0]=1;aY(b,d);rB(b,d);g=b+536|0;f=c[g+4>>2]|0;e=b+528|0;c[e>>2]=c[g>>2];c[e+4>>2]=f;e=bF(b+916|0,b+788|0)|0;c[m>>2]=d;f=e+16|0;g=c[f>>2]|0;if(g>>>0<(c[e+20>>2]|0)>>>0){c[g>>2]=d;c[f>>2]=(c[f>>2]|0)+4}else Yy(e+12|0,m);a[b+761>>0]=1;J3(b);break}default:{}}if(qO(b)|0){TX(m);TX(n);a:do switch(a[i>>0]|0){case 0:{Xy(h,24132);vF(m,h)|0;z5(h);HX(m,54768)|0;switch(a[j>>0]|0){case 0:{Xy(h,24216);vF(n,h)|0;z5(h);d=m;break a}case 2:{Xy(h,24232);vF(n,h)|0;z5(h);d=m;break a}default:{Xy(h,409096);vF(n,h)|0;z5(h);d=m;break a}}}case 4:{Xy(h,24160);vF(m,h)|0;z5(h);HX(m,54768)|0;switch(a[j>>0]|0){case 0:{Xy(h,24216);vF(n,h)|0;z5(h);d=m;break a}case 2:{Xy(h,24232);vF(n,h)|0;z5(h);d=m;break a}case 4:{Xy(h,24260);vF(n,h)|0;z5(h);d=m;break a}default:{Xy(h,409096);vF(n,h)|0;z5(h);d=m;break a}}}case 12:{Xy(h,24180);vF(m,h)|0;z5(h);HX(m,54768)|0;switch(a[j>>0]|0){case 0:{Xy(h,24280);vF(n,h)|0;z5(h);d=m;break a}case 1:{Xy(h,24292);vF(n,h)|0;z5(h);d=m;break a}case 2:{Xy(h,24304);vF(n,h)|0;z5(h);d=m;break a}case 3:{Xy(h,24316);vF(n,h)|0;z5(h);d=m;break a}case 4:{Xy(h,24328);vF(n,h)|0;z5(h);d=m;break a}default:{Xy(h,409096);vF(n,h)|0;z5(h);d=m;break a}}}default:{Xy(h,409096);vF(m,h)|0;z5(h);HX(m,54768)|0;d=m}}while(0);e=a[n+8+3>>0]|0;j=e<<24>>24<0;Ex(d,j?c[n>>2]|0:n,j?c[n+4>>2]|0:e&255)|0;e=b+20|0;zb(b,1,c[e>>2]|0,24,m,0);zb(b,1,c[e>>2]|0,64,m,0);d=c[k>>2]|0;if((d+1|0)>>>0>1)lL(b,c[b+16>>2]|0,c[e>>2]|0,171,d,3,0);z5(n);z5(m)}l=o;return}function Ud(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=l;l=l+48|0;w=y+36|0;x=y+24|0;u=y+12|0;v=y;TX(w);e=a[b+822>>0]|0;do if((e&255)>=25)if(e<<24>>24==29){Xy(x,14324);vF(w,x)|0;z5(x);break}else{Xy(x,13976);vF(w,x)|0;z5(x);break}else{ST(x,+Sm(b,0),0);vF(w,x)|0;z5(x)}while(0);i=b+1240|0;e=a[i>>0]|0;f=b+880|0;n=b+1241|0;o=b+960|0;r=b+1e3|0;j=b+920|0;g=b+884|0;k=b+924|0;m=b+928|0;s=b+1008|0;p=b+968|0;t=b+1004|0;h=b+888|0;q=b+964|0;if((e&255)<16){tU(x,((a[n>>0]|0)!=0&1)+(d[372234+(e&255)>>0]|0)|0,10);e=c[g>>2]|0;if(e>>>0<(c[h>>2]|0)>>>0){rV(e,x);c[g>>2]=(c[g>>2]|0)+12}else Dx(f,x);z5(x);TX(v);cC(v,c[13504+(d[i>>0]<<2)>>2]|0)|0;Bs(u,v,a[n>>0]|0?14344:409096);p2(x,u);e=c[k>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){rV(e,x);c[k>>2]=(c[k>>2]|0)+12}else Dx(j,x);z5(x);O0(u);z5(v);TX(v);cC(v,c[13568+(d[i>>0]<<2)>>2]|0)|0;Bs(u,v,a[n>>0]|0?16388:14368);p2(x,u);e=c[q>>2]|0;if(e>>>0<(c[p>>2]|0)>>>0){rV(e,x);c[q>>2]=(c[q>>2]|0)+12}else Dx(o,x);z5(x);O0(u);z5(v);TX(v);cC(v,c[14380+(d[i>>0]<<2)>>2]|0)|0;Bs(u,v,a[n>>0]|0?14444:409096);p2(x,u);e=c[t>>2]|0;if(e>>>0<(c[s>>2]|0)>>>0){rV(e,x);c[t>>2]=(c[t>>2]|0)+12}else Dx(r,x);z5(x);O0(u);z5(v)}else{Xy(x,14464);e=c[g>>2]|0;if(e>>>0<(c[h>>2]|0)>>>0){rV(e,x);c[g>>2]=(c[g>>2]|0)+12}else Dx(f,x);z5(x);Xy(v,14464);HX(v,a[n>>0]|0?14344:409096)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];e=0;while(1){if((e|0)==3)break;c[v+(e<<2)>>2]=0;e=e+1|0}p2(x,u);e=c[k>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){rV(e,x);c[k>>2]=(c[k>>2]|0)+12}else Dx(j,x);z5(x);O0(u);z5(v);Xy(v,14464);HX(v,a[n>>0]|0?16388:14368)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];e=0;while(1){if((e|0)==3)break;c[v+(e<<2)>>2]=0;e=e+1|0}p2(x,u);e=c[q>>2]|0;if(e>>>0<(c[p>>2]|0)>>>0){rV(e,x);c[q>>2]=(c[q>>2]|0)+12}else Dx(o,x);z5(x);O0(u);z5(v);Xy(v,14464);HX(v,a[n>>0]|0?14444:409096)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];e=0;while(1){if((e|0)==3)break;c[v+(e<<2)>>2]=0;e=e+1|0}p2(x,u);e=c[t>>2]|0;if(e>>>0<(c[s>>2]|0)>>>0){rV(e,x);c[t>>2]=(c[t>>2]|0)+12}else Dx(r,x);z5(x);O0(u);z5(v)}uU(x,a[372250+(d[b+824>>0]|0)>>0]|0,10);e=b+1044|0;f=c[e>>2]|0;if(f>>>0<(c[b+1048>>2]|0)>>>0){rV(f,x);c[e>>2]=(c[e>>2]|0)+12}else Dx(b+1040|0,x);z5(x);sU(x,c[13788+(d[b+820>>0]<<2)>>2]|0,10);e=b+1084|0;f=c[e>>2]|0;if(f>>>0<(c[b+1088>>2]|0)>>>0){rV(f,x);c[e>>2]=(c[e>>2]|0)+12}else Dx(b+1080|0,x);z5(x);e=b+1124|0;f=c[e>>2]|0;if((f|0)==(c[b+1128>>2]|0))Ax(b+1120|0,w);else{p2(f,w);c[e>>2]=(c[e>>2]|0)+12}Xy(x,40152);e=b+1164|0;f=c[e>>2]|0;if(f>>>0<(c[b+1168>>2]|0)>>>0){rV(f,x);c[e>>2]=(c[e>>2]|0)+12}else Dx(b+1160|0,x);z5(x);Xy(x,14516);e=b+1204|0;f=c[e>>2]|0;if(f>>>0<(c[b+1208>>2]|0)>>>0){rV(f,x);c[e>>2]=(c[e>>2]|0)+12}else Dx(b+1200|0,x);z5(x);z5(w);l=y;return}function Vd(d){d=d|0;var e=0,f=0.0,g=0.0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;C=l;l=l+48|0;y=C+24|0;A=C+12|0;B=C;o=d+288|0;e=o;i=c[e>>2]|0;e=c[e+4>>2]|0;q=d+280|0;p=c[q>>2]|0;q=c[q+4>>2]|0;do if(!(e>>>0>q>>>0|(e|0)==(q|0)&i>>>0>p>>>0)){j=d+360|0;i=j;e=c[i>>2]|0;i=c[i+4>>2]|0;if(!((e|0)==-1&(i|0)==-1)){oK(d,1,0,185,e,i,10,0);f=+h[d+960>>3];if(!(f!=0.0))break;w=j;KW(d,1,0,76,(+((c[w>>2]|0)>>>0)+4294967296.0*+((c[w+4>>2]|0)>>>0))/f*1.0e3,0,0);break}if(((a[d+777>>0]|0)==0?(k=d+924|0,(c[k>>2]|0)!=-1):0)?(m=d+960|0,+h[m>>3]!=0.0):0){BU(y);f=+h[m>>3];g=+N(+f);a[y+4>>0]=~~g;if(!(a[d+1017>>0]|0))e=f-g!=0.0;else e=(a[d+1019>>0]|0)!=0;w=e&1;a[y+5>>0]=w;v=c[d+920>>2]|0;a[y>>0]=(v>>>0)/3600|0;a[y+1>>0]=(((v>>>0)%3600|0)>>>0)/60|0;a[y+2>>0]=(v>>>0)%60|0;a[y+3>>0]=a[d+989>>0]|0;BU(A);a[A+4>>0]=~~+N(+(+h[m>>3]));a[A+5>>0]=w;w=c[k>>2]|0;a[A>>0]=(w>>>0)/3600|0;a[A+1>>0]=(((w>>>0)%3600|0)>>>0)/60|0;a[A+2>>0]=(w>>>0)%60|0;a[A+3>>0]=a[d+990>>0]|0;w=cs(y)|0;v=z;u=cs(A)|0;v=D_(u|0,z|0,w|0,v|0)|0;w=z;oK(d,1,0,185,v,w,0,0);KW(d,1,0,76,(+(v>>>0)+4294967296.0*+(w>>>0))/+h[m>>3]*1.0e3,0,0)}}else{w=b[d+1056>>1]|0;j=w&65535;v=b[d+978>>1]|0;k=v&65535;if((v&65535)>(w&65535)){m=d+1064|0;if(!(a[d+1011>>0]|0))n=(a[d+1006>>0]|0)!=3&1;else n=0;v=XZ(c[m>>2]|0,c[m+4>>2]|0,n|0)|0;w=k+~j|0;w=UW(v|0,z|0,w|0,((w|0)<0)<<31>>31|0)|0;i=z0(w|0,z|0,i|0,e|0)|0;e=z;w=o;c[w>>2]=i;c[w+4>>2]=e}w=D_(i|0,e|0,p|0,q|0)|0;w=cT((+(w>>>0)+4294967296.0*+(z>>>0))/1.0e6)|0;jL(d,1,0,76,w,z,0)}while(0);if(c[d+1088>>2]|0){c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[y+(e<<2)>>2]=0;e=e+1|0}p=d+1080|0;w=d+1084|0;e=c[p>>2]|0;v=0;u=0;n=0;k=0;a:while(1){if((e|0)==(w|0))break;i=e+32|0;m=i;j=c[m>>2]|0;m=c[m+4>>2]|0;if(m>>>0>n>>>0|(m|0)==(n|0)&j>>>0>k>>>0){KQ(y,e+16|0)|0;o=i;i=c[o>>2]|0;o=c[o+4>>2]|0}else{i=j;o=m;j=k;m=n}n=z0(i|0,o|0,u|0,v|0)|0;k=z;i=c[e+4>>2]|0;if(!i)while(1){i=c[e+8>>2]|0;if((c[i>>2]|0)==(e|0)){e=i;v=k;u=n;n=m;k=j;continue a}else e=i}else e=i;while(1){i=c[e>>2]|0;if(!i)break;else e=i}v=k;u=n;n=m;k=j}do if(v>>>0>0|(v|0)==0&u>>>0>3){q=y+11|0;r=y+4|0;s=a[q>>0]|0;t=s<<24>>24<0;s=t?c[r>>2]|0:s&255;t=t?c[y>>2]|0:y;e=c[p>>2]|0;o=0;n=0;b:while(1){if((e|0)==(w|0))break;k=e+16|0;i=a[k+11>>0]|0;j=i<<24>>24<0;i=i&255;c:do if(((j?c[e+20>>2]|0:i)|0)==(s|0)){if(j)if(!(R$(c[k>>2]|0,t,s)|0)){j=o;break}else{x=40;break}m=t;j=k;while(1){if(!i){j=o;break c}if((a[j>>0]|0)!=(a[m>>0]|0)){x=40;break c}m=m+1|0;j=j+1|0;i=i+-1|0}}else x=40;while(0);if((x|0)==40){x=0;j=e+32|0;n=z0(c[j>>2]|0,c[j+4>>2]|0,n|0,o|0)|0;j=z}i=c[e+4>>2]|0;if(!i)while(1){i=c[e+8>>2]|0;if((c[i>>2]|0)==(e|0)){e=i;o=j;continue b}else e=i}else e=i;while(1){i=c[e>>2]|0;if(!i)break;else e=i}o=j}x=XZ(u|0,v|0,1)|0;w=z;if((o>>>0<w>>>0|(o|0)==(w|0)&n>>>0<x>>>0)&(o>>>0<0|(o|0)==0&n>>>0<4)){e=1;i=1;j=1}else{RB(d,1,0,47,382749,-1,1,1);break}while(1){if(e>>>0>=s>>>0)break;w=(a[t+e>>0]|0)==66;x=j+1|0;e=e+1|0;i=x>>>0>i>>>0&w?x:i;j=w?x:1}TX(A);if(i>>>0>1){HX(A,37320)|0;sU(B,i,10);x=a[B+8+3>>0]|0;w=x<<24>>24<0;Ex(A,w?c[B>>2]|0:B,w?c[B+4>>2]|0:x&255)|0;z5(B);HX(A,39968)|0}HX(A,37332)|0;x=a[q>>0]|0;sU(B,x<<24>>24<0?c[r>>2]|0:x&255,10);x=a[B+8+3>>0]|0;w=x<<24>>24<0;Ex(A,w?c[B>>2]|0:B,w?c[B+4>>2]|0:x&255)|0;z5(B);zb(d,1,0,47,A,1);z5(A)}while(0);a1(y)}l=C;return}function Wd(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+32|0;p=r+20|0;d=r+16|0;k=r+12|0;m=r+8|0;n=r+27|0;f=r+26|0;o=r+25|0;i=r+4|0;g=r;e=r+24|0;Bx(b);n3(b,p);p=c[p>>2]|0;do if(p>>>0>63){t4(b);wK(b)}else{n3(b,d);j=c[d>>2]|0;if(j>>>0>15){t4(b);break}q=c[b+808>>2]|0;if(j>>>0<(c[b+812>>2]|0)-q>>2>>>0?c[q+(j<<2)>>2]|0:0){q=b+776|0;if(a[b+771>>0]|0){wK(b);d=b+536|0;e=b+528|0;e=D_(c[d>>2]|0,c[d+4>>2]|0,c[e>>2]|0,c[e+4>>2]|0)|0;e1(b,e,z);e=b+820|0;d=c[e>>2]|0;if(p>>>0>=(c[b+824>>2]|0)-d>>2>>>0){FF(e,p+1|0);d=c[e>>2]|0}d=d+(p<<2)|0;e=c[d>>2]|0;if(e|0)laa(e);e=ZW(5)|0;tV(e,0,0,0,0,0);c[d>>2]=e;s_(b);e=c[q>>2]|0;d=e+16|0;f=e+10|0;do{a[e>>0]=1;e=e+1|0}while((e|0)<(f|0));a[d>>0]=1;a[d+1>>0]=1;a[d+2>>0]=1;a[d+3>>0]=1;a[d+4>>0]=1;a[d+5>>0]=1;break}AT(b,o);h=b+648|0;A6(c[h>>2]|0);xR(b,3,n);A6(c[h>>2]|0);A6(c[h>>2]|0);n3(b,k);n3(b,m);L5(b);A6(c[h>>2]|0);A6(c[h>>2]|0);if(K6(c[h>>2]|0)|0){GC(b);A6(c[h>>2]|0);T5(b);J3(b)}else A6(c[h>>2]|0);L5(b);L5(b);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);AT(b,f);A6(c[h>>2]|0);if(a[f>>0]|0){GC(b);n3(b,i);n3(b,g);AT(b,e);a:do if(!(a[e>>0]|0)){e=c[i>>2]|0;d=0;while(1){if((d|0)==(e|0))break;T5(b);d=d+1|0}e=c[g>>2]|0;d=0;while(1){if((d|0)==(e|0))break a;T5(b);d=d+1|0}}while(0);A6(c[h>>2]|0);J3(b)}A6(c[h>>2]|0);if(K6(c[h>>2]|0)|0){GC(b);A6(c[h>>2]|0);A6(c[h>>2]|0);AT(b,i);if(!(a[i>>0]|0)){L5(b);L5(b)}J3(b)}else A6(c[h>>2]|0);if(K6(c[h>>2]|0)|0){GC(b);A6(c[h>>2]|0);ox(b);J3(b)}else A6(c[h>>2]|0);A6(c[h>>2]|0);T5(b);A6(c[h>>2]|0);b:do if(K6(c[h>>2]|0)|0){GC(b);A6(c[h>>2]|0);i=c[h>>2]|0;G4(i,Z9(c[i+4>>2]|0)|0);t4(b);J3(b)}else{A6(c[h>>2]|0);KS(b);while(1){if(!(Z9(c[(c[h>>2]|0)+4>>2]|0)|0))break b;RS(b)}}while(0);wK(b);h=b+528|0;i=b+536|0;if(!((c[h>>2]|0)==(c[i>>2]|0)?(c[h+4>>2]|0)==(c[i+4>>2]|0):0))t4(b);if(!(qO(b)|0))break;e=b+820|0;d=c[e>>2]|0;if(p>>>0>=(c[b+824>>2]|0)-d>>2>>>0){FF(e,p+1|0);d=c[e>>2]|0}d=d+(p<<2)|0;e=c[d>>2]|0;if(e|0)laa(e);e=ZW(5)|0;tV(e,j&255,c[k>>2]&255,c[m>>2]&255,a[n>>0]|0,(a[o>>0]|0)!=0);c[d>>2]=e;s_(b);e=c[q>>2]|0;d=e+16|0;f=e+10|0;do{a[e>>0]=1;e=e+1|0}while((e|0)<(f|0));a[d>>0]=1;a[d+1>>0]=1;a[d+2>>0]=1;a[d+3>>0]=1;a[d+4>>0]=1;a[d+5>>0]=1;break}q=c[b+648>>2]|0;G4(q,Z9(c[q+4>>2]|0)|0);wK(b)}while(0);l=r;return}function Xd(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;w=l;l=l+16|0;f=w+6|0;k=w+5|0;m=w+4|0;q=w;r=w+3|0;s=w+2|0;u=e+528|0;if(a[e+772>>0]|0){p=u;p=z0(c[p>>2]|0,c[p+4>>2]|0,1,0)|0;v=u;c[v>>2]=p;c[v+4>>2]=z}bB(e,w+8|0);v=u;v=z0(c[v>>2]|0,c[v+4>>2]|0,1,0)|0;j=u;c[j>>2]=v;c[j+4>>2]=z;bB(e,w+7|0);Bx(e);j=e+648|0;d4(c[j>>2]|0,6);xR(e,2,e+832|0);d4(c[j>>2]|0,3);xR(e,5,f);wK(e);v=e+536|0;n=e+948|0;o=e+612|0;p=e+520|0;g=a[f>>0]|0;f=0;while(1){if((f&255)>=(g&255))break;GC(e);NB(e,q);h=b[q>>1]|0;if((h&65535)<2){t=7;break}y=u;i=h&65535;y=z0(c[y>>2]|0,c[y+4>>2]|0,i|0,0)|0;B=z;x=v;A=c[x+4>>2]|0;if(B>>>0>A>>>0|((B|0)==(A|0)?y>>>0>(c[x>>2]|0)>>>0:0)){t=7;break}Bx(e);RS(e);xR(e,6,r);xR(e,6,n);xR(e,3,s);if(!(a[s>>0]|0))t4(e);wK(e);x=u;B=c[x>>2]|0;x=c[x+4>>2]|0;A=v;y=c[A>>2]|0;A=c[A+4>>2]|0;c[o>>2]=(c[o>>2]|0)+B;C=u;c[C>>2]=0;c[C+4>>2]=0;C=(h&65535)+-2|0;h=v;c[h>>2]=C;c[h+4>>2]=((C|0)<0)<<31>>31;h=p;c[h>>2]=d[r>>0];c[h+4>>2]=0;jb[c[(c[e>>2]|0)+104>>2]&511](e);c[o>>2]=(c[o>>2]|0)-B;x=z0(B|0,x|0,-2,-1)|0;x=z0(x|0,z|0,i|0,0)|0;B=u;c[B>>2]=x;c[B+4>>2]=z;B=v;c[B>>2]=y;c[B+4>>2]=A;J3(e);f=f+1<<24>>24}if((t|0)==7)t4(e);if(!(a[e+771>>0]|0)){Bx(e);d4(c[j>>2]|0,3);xR(e,5,k);wK(e);g=a[k>>0]|0}else{a[k>>0]=0;g=0}f=0;while(1){if((f&255)>=(g&255))break;GC(e);NB(e,q);h=b[q>>1]|0;if((h&65535)<2){t=18;break}B=u;i=h&65535;B=z0(c[B>>2]|0,c[B+4>>2]|0,i|0,0)|0;y=z;C=v;A=c[C+4>>2]|0;if(y>>>0>A>>>0|((y|0)==(A|0)?B>>>0>(c[C>>2]|0)>>>0:0)){t=18;break}Bx(e);RS(e);xR(e,6,r);xR(e,6,n);xR(e,3,s);if(!(a[s>>0]|0))t4(e);wK(e);y=u;C=c[y>>2]|0;y=c[y+4>>2]|0;B=v;A=c[B>>2]|0;B=c[B+4>>2]|0;c[o>>2]=(c[o>>2]|0)+C;k=u;c[k>>2]=0;c[k+4>>2]=0;k=(h&65535)+-2|0;x=v;c[x>>2]=k;c[x+4>>2]=((k|0)<0)<<31>>31;x=p;c[x>>2]=d[r>>0];c[x+4>>2]=0;jb[c[(c[e>>2]|0)+104>>2]&511](e);c[o>>2]=(c[o>>2]|0)-C;y=z0(C|0,y|0,-2,-1)|0;y=z0(y|0,z|0,i|0,0)|0;C=u;c[C>>2]=y;c[C+4>>2]=z;C=v;c[C>>2]=A;c[C+4>>2]=B;J3(e);f=f+1<<24>>24}if((t|0)==18)t4(e);bB(e,m);g=a[m>>0]|0;f=0;while(1){if((f&255)>=(g&255))break;GC(e);NB(e,q);h=b[q>>1]|0;if((h&65535)<2){t=26;break}B=u;i=h&65535;B=z0(c[B>>2]|0,c[B+4>>2]|0,i|0,0)|0;y=z;C=v;A=c[C+4>>2]|0;if(y>>>0>A>>>0|((y|0)==(A|0)?B>>>0>(c[C>>2]|0)>>>0:0)){t=26;break}Bx(e);RS(e);xR(e,6,r);xR(e,6,n);xR(e,3,s);if(!(a[s>>0]|0))t4(e);wK(e);y=u;C=c[y>>2]|0;y=c[y+4>>2]|0;B=v;A=c[B>>2]|0;B=c[B+4>>2]|0;c[o>>2]=(c[o>>2]|0)+C;m=u;c[m>>2]=0;c[m+4>>2]=0;m=(h&65535)+-2|0;x=v;c[x>>2]=m;c[x+4>>2]=((m|0)<0)<<31>>31;x=p;c[x>>2]=d[r>>0];c[x+4>>2]=0;jb[c[(c[e>>2]|0)+104>>2]&511](e);c[o>>2]=(c[o>>2]|0)-C;y=z0(C|0,y|0,-2,-1)|0;y=z0(y|0,z|0,i|0,0)|0;C=u;c[C>>2]=y;c[C+4>>2]=z;C=v;c[C>>2]=A;c[C+4>>2]=B;J3(e);f=f+1<<24>>24}if((t|0)==26)t4(e);g=u;h=c[g>>2]|0;g=c[g+4>>2]|0;f=v;i=c[f>>2]|0;f=c[f+4>>2]|0;if(f>>>0>g>>>0|(f|0)==(g|0)&i>>>0>h>>>0){g=D_(i|0,f|0,h|0,g|0)|0;e1(e,g,z);g=u;f=v;h=c[g>>2]|0;i=c[f>>2]|0;g=c[g+4>>2]|0;f=c[f+4>>2]|0}a[e+769>>0]=0;if(!((h|0)==(i|0)&(g|0)==(f|0)))t4(e);if(qO(e)|0)W5(e);l=w;return}function Yd(e){e=e|0;var f=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0;D=l;l=l+16|0;u=D;w=D+6|0;x=D+4|0;t=e+896|0;s=e+48|0;A=e+612|0;s=z0(c[A>>2]|0,0,c[s>>2]|0,c[s+4>>2]|0)|0;y=e+536|0;r=y;r=z0(s|0,z|0,c[r>>2]|0,c[r+4>>2]|0)|0;s=e+40|0;B=e+312|0;C=e+760|0;i=B;f=c[i>>2]|0;i=c[i+4>>2]|0;if((r|0)==(c[s>>2]|0)?(z|0)==(c[s+4>>2]|0):0){s=C;c[s>>2]=f;c[s+4>>2]=i}j=z0(f|0,i|0,1,0)|0;q=B;c[q>>2]=j;c[q+4>>2]=z;q=e+328|0;j=q;j=z0(c[j>>2]|0,c[j+4>>2]|0,1,0)|0;f=q;c[f>>2]=j;c[f+4>>2]=z;f=e+360|0;j=f;i=c[j>>2]|0;j=c[j+4>>2]|0;if(!((i|0)==-1&(j|0)==-1)){r=z0(i|0,j|0,1,0)|0;s=f;c[s>>2]=r;c[s+4>>2]=z}Bx(e);do if((a[e+812>>0]|0)==3){r=e+820|0;if(!(a[r>>0]|0))f=0;else{AT(e,u);if(!(a[u>>0]|0))f=0;else{AT(e,w);f=a[w>>0]|0?2:1}}s=f&255;p=(c[e+780>>2]|0)+(s<<2)|0;c[p>>2]=(c[p>>2]|0)+1;if((s|0)==2){xR(e,3,u);f=a[u>>0]|0;if((f&255)<5)f=a[383604+((f&255)<<1)>>0]|0;else{t4(e);f=0}s=f}else{nA(e,u);s=a[38476+(c[u>>2]<<3)+7>>0]|0}f=e+904|0;i=c[f>>2]|0;p=(s&255)<2;if(p&i>>>0<2){i=i+1|0;c[f>>2]=i}f=e+144|0;k=f;j=c[k>>2]|0;k=c[k+4>>2]|0;o=e+822|0;if(!((j|0)==-1&(k|0)==-1)?a[o>>0]|0:0){m=cT(1.0e9/+h[t>>3])|0;m=z0(m|0,z|0,j|0,k|0)|0;n=f;c[n>>2]=m;c[n+4>>2]=z}n=e+136|0;m=c[n>>2]|0;n=c[n+4>>2]|0;do if(!((m|0)==-1&(n|0)==-1)){f=e+280|0;k=f;if(!(s<<24>>24!=0|((c[k>>2]|0)!=-1?1:(c[k+4>>2]|0)!=-1))){k=f;c[k>>2]=m;c[k+4>>2]=n}j=q;f=c[j>>2]|0;j=c[j+4>>2]|0;k=e+288|0;if(p){if(j>>>0<0|(j|0)==0&f>>>0<2){q=k;c[q>>2]=m;c[q+4>>2]=n}}else if(!((j>>>0>0|(j|0)==0&f>>>0>1)&i>>>0>1))break;if(a[o>>0]|0){q=cT(1.0e9/+h[t>>3])|0;t=k;q=z0(c[t>>2]|0,c[t+4>>2]|0,q|0,z|0)|0;t=k;c[t>>2]=q;c[t+4>>2]=z}}while(0);if(s<<24>>24!=4?a[e+821>>0]|0:0)d4(c[e+648>>2]|0,8);f=(a[e+828>>0]|0)!=0;if(a[r>>0]|0?(a[e+827>>0]|0)==0:0){a[u>>0]=1;a[w>>0]=0;if(f){AT(e,u);AT(e,w);p=a[u>>0]|0;if(!(p<<24>>24)){u=e+776|0;c[u>>2]=(c[u>>2]|0)+1}else{u=e+772|0;c[u>>2]=(c[u>>2]|0)+1}n=e+844|0;if((c[e+852>>2]|0)>>>0<30){q=e+856|0;o=e+860|0;f=c[o>>2]|0;a:do if((s&-2)<<24>>24!=2?(v=c[q>>2]|0,(v|0)!=(f|0)):0){k=e+868|0;j=1;m=v;i=v;while(1){b[k>>1]=(b[k>>1]|0)+1<<16>>16;if(j>>>0>=f-m>>1>>>0)break;m=i+(j<<1)|0;v=PH(n,k)|0;m=d[m>>0]|d[m+1>>0]<<8;a[v>>0]=m;a[v+1>>0]=m>>8;v=c[q>>2]|0;j=j+1|0;m=v;f=c[o>>2]|0;i=v}f=PH(n,k)|0;i=d[i>>0]|d[i+1>>0]<<8;a[f>>0]=i;a[f+1>>0]=i>>8;f=c[q>>2]|0;i=c[o>>2]|0;while(1){if((i|0)==(f|0))break a;v=i+-2|0;c[o>>2]=v;i=v}}while(0);a[x>>0]=p;a[x+1>>0]=a[w>>0]|0;if((f|0)==(c[e+864>>2]|0))kx(q,x);else{x=b[x>>1]|0;a[f>>0]=x;a[f+1>>0]=x>>8;c[o>>2]=(c[o>>2]|0)+2}}}break}a[u>>0]=0;if(f)xR(e,2,u)}while(0);wK(e);j=y;n=c[j>>2]|0;j=c[j+4>>2]|0;o=e+528|0;i=o;f=c[i>>2]|0;i=c[i+4>>2]|0;k=D_(n|0,j|0,f|0,i|0)|0;m=z;if(!((k|0)==0&(m|0)==0)){e1(e,k,m);i=o;n=y;j=c[n+4>>2]|0;n=c[n>>2]|0;f=c[i>>2]|0;i=c[i+4>>2]|0}k=e+544|0;while(1){if(!(i>>>0<j>>>0|(i|0)==(j|0)&f>>>0<n>>>0))break;if(a[(c[k>>2]|0)+((c[A>>2]|0)+f)>>0]|0)break;y=z0(f|0,i|0,1,0)|0;x=z;w=o;c[w>>2]=y;c[w+4>>2]=x;i=x;f=y}if((f|0)==(n|0)&(i|0)==(j|0)){if((((qO(e)|0?(HM(e)|0,s_(e),AR(e,13,0),AR(e,15,0),A=c[e+832>>2]|0,a[A+39>>0]=1,a[A+45>>0]=1,(c[e+728>>2]&2|0)==0):0)?(B,y=c[B+4>>2]|0,C,A=c[C+4>>2]|0,!(y>>>0<A>>>0|((y|0)==(A|0)?(c[B>>2]|0)>>>0<(c[C>>2]|0)>>>0:0))):0)?(t6(e),(a[e+492>>0]|0)==0):0)?+g[(c[e+24>>2]|0)+136>>2]<1.0:0)V5(e)}else t4(e);a[e+376>>0]=0;l=D;return}function Zd(f){f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;H=l;l=l+32|0;g=H;i=H+8|0;m=H+30|0;s=H+29|0;t=H+28|0;u=H+27|0;p=H+26|0;q=H+25|0;r=H+24|0;y=H+23|0;v=H+22|0;w=H+21|0;h=H+20|0;x=H+19|0;A=H+14|0;B=H+18|0;C=H+12|0;D=H+17|0;E=H+16|0;j=f+770|0;k=f+771|0;F=f+536|0;if((a[j>>0]|0)==0?(a[k>>0]|0)==0:0)G=11;else G=3;do if((G|0)==3){I=F;J=c[I+4>>2]|0;if(((((J>>>0>0|(J|0)==0&(c[I>>2]|0)>>>0>4?(n=c[f+544>>2]|0,o=c[f+612>>2]|0,(a[n+o>>0]|0)==1):0)?(a[n+(o+1)>>0]|0)==0:0)?(a[n+(o+2)>>0]|0)==0:0)?(a[n+(o+3)>>0]|0)==0:0)?(a[n+(o+4)>>0]|0)==-1:0){Xd(f);break}a[j>>0]=0;a[k>>0]=0;G=11}while(0);if((G|0)==11){bB(f,m);Bx(f);xR(f,2,p);AT(f,h);xR(f,5,q);wK(f);ID(f,i);_y(f,g);bB(f,r);Bx(f);r=f+648|0;A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);d4(c[r>>2]|0,12);wK(f);Bx(f);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);d4(c[r>>2]|0,2);wK(f);Bx(f);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);xR(f,2,s);wK(f);Bx(f);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);xR(f,3,t);wK(f);Bx(f);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);A6(c[r>>2]|0);xR(f,3,u);wK(f);q=f+528|0;o=q;o=z0(c[o>>2]|0,c[o+4>>2]|0,2,0)|0;n=q;c[n>>2]=o;c[n+4>>2]=z;Bx(f);xR(f,2,v);xR(f,3,w);AT(f,x);xR(f,2,f+832|0);wK(f);bB(f,y);n=f+948|0;o=f+612|0;p=f+520|0;j=d[y>>0]|0;g=0;while(1){if((g|0)==(j|0))break;GC(f);Bx(f);A6(c[r>>2]|0);A6(c[r>>2]|0);xR(f,6,B);wK(f);NB(f,A);k=e[A>>1]|0;h=0;while(1){if(h>>>0>=k>>>0)break;GC(f);NB(f,C);m=b[C>>1]|0;if((m&65535)<2){G=18;break}I=q;i=m&65535;I=z0(c[I>>2]|0,c[I+4>>2]|0,i|0,0)|0;x=z;J=F;y=c[J+4>>2]|0;if(x>>>0>y>>>0|((x|0)==(y|0)?I>>>0>(c[J>>2]|0)>>>0:0)){G=18;break}Bx(f);RS(f);xR(f,6,D);xR(f,6,n);xR(f,3,E);if(!(a[E>>0]|0))t4(f);wK(f);x=q;J=c[x>>2]|0;x=c[x+4>>2]|0;I=F;y=c[I>>2]|0;I=c[I+4>>2]|0;c[o>>2]=(c[o>>2]|0)+J;v=q;c[v>>2]=0;c[v+4>>2]=0;v=(m&65535)+-2|0;w=F;c[w>>2]=v;c[w+4>>2]=((v|0)<0)<<31>>31;w=p;c[w>>2]=d[D>>0];c[w+4>>2]=0;jb[c[(c[f>>2]|0)+104>>2]&511](f);c[o>>2]=(c[o>>2]|0)-J;x=z0(J|0,x|0,-2,-1)|0;x=z0(x|0,z|0,i|0,0)|0;J=q;c[J>>2]=x;c[J+4>>2]=z;J=F;c[J>>2]=y;c[J+4>>2]=I;J3(f);h=h+1|0}if((G|0)==18){G=0;t4(f)}J3(f);g=g+1|0}a[f+769>>0]=0;I=q;J=F;if(!((c[I>>2]|0)==(c[J>>2]|0)?(c[I+4>>2]|0)==(c[J+4>>2]|0):0))t4(f);if(qO(f)|0)W5(f)}l=H;return}function _d(f){f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;F=l;l=l+80|0;g=F+68|0;n=F+56|0;p=F+52|0;q=F+48|0;y=F+36|0;B=F+24|0;C=F+12|0;D=F;E=f+764|0;m=f+778|0;o=(EE((c[E>>2]|0)+108|0,m)|0)+12|0;A=f+789|0;b[g>>1]=d[A>>0]|0;eK(qD(o,g)|0);a[(EE((c[E>>2]|0)+108|0,m)|0)+24>>0]=1;o=f+728|0;c[o>>2]=c[o>>2]|4;o=f+528|0;if((a[A>>0]|0)==-53){x=o;x=z0(c[x>>2]|0,c[x+4>>2]|0,1,0)|0;A=o;c[A>>2]=x;c[A+4>>2]=z}bB(f,g);wK(f);r=f+786|0;s=f+770|0;t=f+796|0;u=f+768|0;v=B+8+3|0;w=B+4|0;x=B+8+3|0;A=B+4|0;k=a[g>>0]|0;j=f+648|0;i=0;while(1){if((i&255)>=(k&255))break;TX(n);GC(f);Bx(f);A6(c[j>>2]|0);A6(c[j>>2]|0);sR(f,14,r);wK(f);ID(f,p);Bx(f);d4(c[j>>2]|0,2);d4(c[j>>2]|0,2);rR(f,20,q);wK(f);g=o;g=z0(c[g>>2]|0,c[g+4>>2]|0,1,0)|0;h=o;c[h>>2]=g;c[h+4>>2]=z;Ce(f,n);Bx(f);d4(c[j>>2]|0,6);sR(f,10,s);wK(f);a[t>>0]=1;if(b[s>>1]|0)Ao(f);J3(f);if(qO(f)|0){g=c[p>>2]|0;h=(EE((c[E>>2]|0)+108|0,m)|0)+12|0;c[(RC(qD(h,(c[(c[(c[E>>2]|0)+80>>2]|0)+(e[u>>1]<<2)>>2]|0)+166|0)|0,r)|0)>>2]=g;h=c[q>>2]|0;sU(D,(h>>>0)/3600|0,10);DW(D,0,h>>>0<36e3?42196:409096)|0;c[C>>2]=c[D>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];g=0;while(1){if((g|0)==3)break;c[D+(g<<2)>>2]=0;g=g+1|0}HX(C,42204)|0;c[B>>2]=c[C>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];g=0;while(1){if((g|0)==3)break;c[C+(g<<2)>>2]=0;g=g+1|0}p2(y,B);O0(B);O0(C);z5(D);h=(h>>>0)%3600|0;c[q>>2]=h;sU(D,(h>>>0)/60|0,10);DW(D,0,h>>>0<600?42196:409096)|0;c[C>>2]=c[D>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];g=0;while(1){if((g|0)==3)break;c[D+(g<<2)>>2]=0;g=g+1|0}HX(C,42204)|0;c[B>>2]=c[C>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];g=0;while(1){if((g|0)==3)break;c[C+(g<<2)>>2]=0;g=g+1|0}g=a[v>>0]|0;G=g<<24>>24<0;Ex(y,G?c[B>>2]|0:B,G?c[w>>2]|0:g&255)|0;O0(B);O0(C);z5(D);g=(h>>>0)%60|0;c[q>>2]=g;sU(C,g,10);DW(C,0,g>>>0<10?42196:409096)|0;c[B>>2]=c[C>>2];c[B+4>>2]=c[C+4>>2];c[B+8>>2]=c[C+8>>2];g=0;while(1){if((g|0)==3)break;c[C+(g<<2)>>2]=0;g=g+1|0}G=a[x>>0]|0;h=G<<24>>24<0;Ex(y,h?c[B>>2]|0:B,h?c[A>>2]|0:G&255)|0;O0(B);z5(C);G=(EE((c[E>>2]|0)+108|0,m)|0)+12|0;k1((RC(qD(G,(c[(c[(c[E>>2]|0)+80>>2]|0)+(e[u>>1]<<2)>>2]|0)+166|0)|0,r)|0)+4|0,y)|0;G=(EE((c[E>>2]|0)+108|0,m)|0)+12|0;k1((RC(qD(G,(c[(c[(c[E>>2]|0)+80>>2]|0)+(e[u>>1]<<2)>>2]|0)+166|0)|0,r)|0)+16|0,n)|0;z5(y)}z5(n);i=i+1<<24>>24}l=F;return}function $d(b){b=b|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;J=l;l=l+80|0;G=J+48|0;H=J+36|0;I=J+24|0;n=J+69|0;q=J+68|0;y=J+66|0;x=J+65|0;w=J+64|0;B=J+63|0;C=J+62|0;E=J+61|0;F=J+60|0;u=J+12|0;v=J;TX(G);TX(H);TX(I);Bx(b);xR(b,3,n);n=a[n>>0]|0;o=(n&255)<4;D=b+648|0;d4(c[D>>2]|0,5);xR(b,6,q);xR(b,2,J+67|0);xR(b,3,y);xR(b,4,x);x=a[x>>0]|0;r=(x&255)<8;A6(c[D>>2]|0);wK(b);if((qO(b)|0?(a[b+768>>0]|0)==2:0)?a[b+784>>0]|0:0){s=b+760|0;t=b+772|0;a[(c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0)+169>>0]=-127;if(o){sU(u,c[12456+((n&255)<<2)>>2]|0,10);o=c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0;c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;p=j9(384521)|0;if(p>>>0>4294967279)uaa();if(p>>>0<11){a[v+11>>0]=p;n=v}else{K=p+16&-16;n=ZW(K)|0;c[v>>2]=n;c[v+8>>2]=K|-2147483648;c[v+4>>2]=p}i1(n,384521,p)|0;J7(n+p|0,0);vF(VC(o+28|0,v)|0,u)|0;a1(v);z5(u)}tU(u,(e[59708+(d[q>>0]<<1)>>1]|0)*1e3|0,10);o=c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0;c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;p=j9(384534)|0;if(p>>>0>4294967279)uaa();if(p>>>0<11){a[v+11>>0]=p;n=v}else{K=p+16&-16;n=ZW(K)|0;c[v>>2]=n;c[v+8>>2]=K|-2147483648;c[v+4>>2]=p}i1(n,384534,p)|0;J7(n+p|0,0);vF(VC(o+28|0,v)|0,u)|0;a1(v);z5(u);if(r){uU(u,a[371002+(x&255)>>0]|0,10);o=c[(c[(c[s>>2]|0)+80>>2]|0)+(e[t>>1]<<2)>>2]|0;c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;p=j9(384542)|0;if(p>>>0>4294967279)uaa();if(p>>>0<11){a[v+11>>0]=p;n=v}else{K=p+16&-16;n=ZW(K)|0;c[v>>2]=n;c[v+8>>2]=K|-2147483648;c[v+4>>2]=p}i1(n,384542,p)|0;J7(n+p|0,0);vF(VC(o+28|0,v)|0,u)|0;a1(v);z5(u)}}p=b+528|0;v=p;q=b+536|0;K=q;if(!((c[v>>2]|0)==(c[K>>2]|0)?(c[v+4>>2]|0)==(c[K+4>>2]|0):0)?(bB(b,w),k=p,m=c[k>>2]|0,k=c[k+4>>2]|0,j=q,A=c[j>>2]|0,j=c[j+4>>2]|0,!((m|0)==(A|0)&(k|0)==(j|0))):0){n=z0(m|0,k|0,1,0)|0;o=z;if(!(x<<24>>24)){m=p;c[m>>2]=n;c[m+4>>2]=o;m=n;k=o}if(!((m|0)==(A|0)&(k|0)==(j|0))){if((d[y>>0]|0)<2){Bx(b);d4(c[D>>2]|0,3);G4(c[D>>2]|0,2);d4(c[D>>2]|0,3);wK(b);m=p;j=q;n=c[m>>2]|0;k=c[j>>2]|0;m=c[m+4>>2]|0;j=c[j+4>>2]|0}else{n=z0(m|0,k|0,1,0)|0;m=z;k=p;c[k>>2]=n;c[k+4>>2]=m;k=A}if(!((n|0)==(k|0)&(m|0)==(j|0))){Bx(b);xR(b,7,B);xR(b,1,C);wK(b);j=a[B>>0]|0;if(j<<24>>24)jZ(b,j&255,0,G);C=p;K=q;if(!((c[C>>2]|0)==(c[K>>2]|0)?(c[C+4>>2]|0)==(c[K+4>>2]|0):0)?(Bx(b),AT(b,E),AT(b,F),d4(c[D>>2]|0,6),wK(b),f=p,h=c[f>>2]|0,f=c[f+4>>2]|0,g=q,i=c[g>>2]|0,g=c[g+4>>2]|0,!((h|0)==(i|0)&(f|0)==(g|0))):0){if(a[E>>0]|0){jZ(b,3,0,H);f=p;g=q;h=c[f>>2]|0;i=c[g>>2]|0;f=c[f+4>>2]|0;g=c[g+4>>2]|0}if(!((h|0)==(i|0)&(f|0)==(g|0))){if(a[F>>0]|0){jZ(b,3,0,I);f=p;g=q;i=c[g>>2]|0;h=c[f>>2]|0;g=c[g+4>>2]|0;f=c[f+4>>2]|0}if(!((i|0)==(h|0)&(g|0)==(f|0))){K=D_(i|0,g|0,h|0,f|0)|0;e1(b,K,z)}}}}}}z5(I);z5(H);z5(G);l=J;return}function ae(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=l;l=l+16|0;x=H+4|0;o=H;G=b+520|0;F=G;if((c[F>>2]|0)==-1?(c[F+4>>2]|0)==-1:0)Zd(b);else{y=b+536|0;B=y;A=c[B>>2]|0;B=c[B+4>>2]|0;C=b+544|0;D=b+612|0;E=c[C>>2]|0;F=c[D>>2]|0;a:do if((A|0)==0&(B|0)==0){v=0;w=0;e=0;f=0}else{d=F+-1|0;e=A;f=B;while(1){if((e|0)==0&(f|0)==0){v=0;w=0;break a}if(a[E+(d+e)>>0]|0){v=e;w=f;break a}v=z0(e|0,f|0,-1,-1)|0;w=z;u=y;c[u>>2]=v;c[u+4>>2]=w;e=v;f=w}}while(0);q=b+48|0;s=q;r=c[s>>2]|0;s=c[s+4>>2]|0;t=b+528|0;d=c[t>>2]|0;c[x>>2]=0;u=x+4|0;c[u>>2]=0;c[x+8>>2]=0;n=x+8|0;i=e;j=f;h=e;g=f;e=w;f=v;while(1){if(0>e>>>0|0==(e|0)&(d+3|0)>>>0>f>>>0)break;p=(c[C>>2]|0)+(c[D>>2]|0)+d|0;f=d+2|0;if((R4(a[p>>0]|0,a[p+1>>0]|0,a[p+2>>0]|0)|0)==3){c[o>>2]=f;d=c[u>>2]|0;if(d>>>0<(c[n>>2]|0)>>>0){c[d>>2]=f;c[u>>2]=d+4;e=i;d=j}else{Yy(x,o);d=y;e=c[d>>2]|0;d=c[d+4>>2]|0}i=e;j=d;k=d;m=e}else{k=g;m=h}d=f;while(1){if(!(0<k>>>0|0==(k|0)&d>>>0<m>>>0)){p=20;break}e=c[C>>2]|0;f=c[D>>2]|0;if(!(a[e+(f+d)>>0]|0)){p=19;break}d=d+2|0}if((p|0)==19){p=0;g=d+-1|0;if(!(a[e+(f+g)>>0]|0))d=g;else{h=m;g=k;e=k;f=m;continue}}else if((p|0)==20){p=0;d=d+-1|0}h=m;g=k;e=k;f=m}m=c[x>>2]|0;d=c[u>>2]|0;if((m|0)!=(d|0)){g=d-m>>2;f=D_(v|0,w|0,g|0,0)|0;e=z;i=y;c[i>>2]=f;c[i+4>>2]=e;i=q;i=z0(c[i>>2]|0,c[i+4>>2]|0,c[D>>2]|0,0)|0;h=q;c[h>>2]=i;c[h+4>>2]=z;c[D>>2]=0;h=iaa(f)|0;i=E+F|0;d=0;while(1){if(d>>>0>g>>>0)break;if((d|0)==(g|0))k=v;else k=c[m+(d<<2)>>2]|0;if(!d)j=0;else j=(c[m+(d+-1<<2)>>2]|0)+1|0;no(h+(j-d)|0,i+j|0,k-j|0)|0;d=d+1|0}c[C>>2]=h}o=G;d=c[o+4>>2]|0;do switch(c[o>>2]|0){case 0:{if(!d)p=57;else p=65;break}case 1:{if(!d)p=57;else p=65;break}case 2:{if(!d)p=57;else p=65;break}case 3:{if(!d)p=57;else p=65;break}case 4:{if(!d)p=58;else p=65;break}case 5:{if(!d)p=58;else p=65;break}case 6:{if(!d)p=58;else p=65;break}case 7:{if(!d)p=58;else p=65;break}case 8:{if(!d)p=58;else p=65;break}case 9:{if(!d)p=58;else p=65;break}case 16:{if(!d)p=57;else p=65;break}case 17:{if(!d)p=57;else p=65;break}case 18:{if(!d)p=57;else p=65;break}case 19:{if(!d)p=57;else p=65;break}case 20:{if(!d)p=57;else p=65;break}case 21:{if(!d)p=57;else p=65;break}case 32:{if(!d)ke(b);else p=65;break}case 33:{if(!d)md(b);else p=65;break}case 34:{if(!d)Wd(b);else p=65;break}case 35:{if(!d)yX(b);else p=65;break}case 36:{if(d|0)p=65;break}case 37:{if(d|0)p=65;break}case 38:{if(!d)G$(b);else p=65;break}case 39:{if(!d)p=64;else p=65;break}case 40:{if(!d)p=64;else p=65;break}default:p=65}while(0);if((p|0)==57)ql(b);else if((p|0)==58)gV(b);else if((p|0)==64)Dz(b);else if((p|0)==65?(p=t,p=D_(f|0,e|0,c[p>>2]|0,c[p+4>>2]|0)|0,e1(b,p,z),G,p=c[G+4>>2]|0,p>>>0>0|(p|0)==0&(c[G>>2]|0)>>>0>47):0)t4(b);if((c[x>>2]|0)!=(c[u>>2]|0)){G=y;c[G>>2]=v;c[G+4>>2]=w;G=q;c[G>>2]=r;c[G+4>>2]=s;c[D>>2]=F;jaa(c[C>>2]|0);c[C>>2]=E;F=t;F=z0((c[u>>2]|0)-(c[x>>2]|0)>>2|0,0,c[F>>2]|0,c[F+4>>2]|0)|0;G=t;c[G>>2]=F;c[G+4>>2]=z}G=y;c[G>>2]=A;c[G+4>>2]=B;cU(x)}l=H;return}function be(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a:do if(e>>>0>36){c[12784]=22;h=0;g=0}else{r=b+4|0;q=b+100|0;do{i=c[r>>2]|0;if(i>>>0<(c[q>>2]|0)>>>0){c[r>>2]=i+1;i=d[i>>0]|0}else i=_x(b)|0}while((Z8(i)|0)!=0);b:do switch(i|0){case 43:case 45:{i=((i|0)==45)<<31>>31;j=c[r>>2]|0;if(j>>>0<(c[q>>2]|0)>>>0){c[r>>2]=j+1;p=i;i=d[j>>0]|0;break b}else{p=i;i=_x(b)|0;break b}}default:p=0}while(0);j=(e|0)==0;do if((e|16|0)==16&(i|0)==48){i=c[r>>2]|0;if(i>>>0<(c[q>>2]|0)>>>0){c[r>>2]=i+1;i=d[i>>0]|0}else i=_x(b)|0;if((i|32|0)!=120)if(j){e=8;n=46;break}else{n=32;break}i=c[r>>2]|0;if(i>>>0<(c[q>>2]|0)>>>0){c[r>>2]=i+1;i=d[i>>0]|0}else i=_x(b)|0;if((d[392435+i>>0]|0)>15){g=(c[q>>2]|0)!=0;if(g)c[r>>2]=(c[r>>2]|0)+-1;if(!f){NV(b,0);h=0;g=0;break a}if(!g){h=0;g=0;break a}c[r>>2]=(c[r>>2]|0)+-1;h=0;g=0;break a}else{e=16;n=46}}else{e=j?10:e;if((d[392435+i>>0]|0)>>>0<e>>>0)n=32;else{if(c[q>>2]|0)c[r>>2]=(c[r>>2]|0)+-1;NV(b,0);c[12784]=22;h=0;g=0;break a}}while(0);c:do if((n|0)==32)if((e|0)==10){e=i+-48|0;if(e>>>0<10){i=0;j=e;do{i=(i*10|0)+j|0;e=c[r>>2]|0;if(e>>>0<(c[q>>2]|0)>>>0){c[r>>2]=e+1;e=d[e>>0]|0}else e=_x(b)|0;j=e+-48|0}while(i>>>0<429496729&j>>>0<10);f=0}else{e=i;i=0;f=0}k=e+-48|0;if(k>>>0<10){j=e;do{e=UW(i|0,f|0,10,0)|0;l=z;m=((k|0)<0)<<31>>31;o=~m;if(l>>>0>o>>>0|(l|0)==(o|0)&e>>>0>~k>>>0){e=10;n=72;break c}i=z0(e|0,l|0,k|0,m|0)|0;f=z;e=c[r>>2]|0;if(e>>>0<(c[q>>2]|0)>>>0){c[r>>2]=e+1;j=d[e>>0]|0}else j=_x(b)|0;k=j+-48|0}while((f>>>0<429496729|(f|0)==429496729&i>>>0<2576980378)&k>>>0<10);if(k>>>0>9){j=p;e=f}else{e=10;n=72}}else{j=p;e=f}}else n=46;while(0);d:do if((n|0)==46){k=a[392435+i>>0]|0;f=k&255;j=f>>>0<e>>>0;if(!(e+-1&e)){n=a[392691+((e*23|0)>>>5&7)>>0]|0;if(j){i=0;do{i=i<<n|f;j=c[r>>2]|0;if(j>>>0<(c[q>>2]|0)>>>0){c[r>>2]=j+1;j=d[j>>0]|0}else j=_x(b)|0;k=a[392435+j>>0]|0;f=k&255}while(i>>>0<134217728&f>>>0<e>>>0);f=0}else{j=i;f=0;i=0}l=XZ(-1,-1,n|0)|0;m=z;if((k&255)>>>0>=e>>>0|(f>>>0>m>>>0|(f|0)==(m|0)&i>>>0>l>>>0)){n=72;break}while(1){i=PZ(i|0,f|0,n|0)|0;f=z;i=i|k&255;j=c[r>>2]|0;if(j>>>0<(c[q>>2]|0)>>>0){c[r>>2]=j+1;j=d[j>>0]|0}else j=_x(b)|0;k=a[392435+j>>0]|0;if(f>>>0>m>>>0|(f|0)==(m|0)&i>>>0>l>>>0|(k&255)>>>0>=e>>>0){n=72;break d}}}if(j){i=0;do{i=(O(i,e)|0)+f|0;j=c[r>>2]|0;if(j>>>0<(c[q>>2]|0)>>>0){c[r>>2]=j+1;j=d[j>>0]|0}else j=_x(b)|0;k=a[392435+j>>0]|0;f=k&255}while(i>>>0<119304647&f>>>0<e>>>0);f=0}else{j=i;i=0;f=0}if((k&255)>>>0<e>>>0){n=g5(-1,-1,e|0,0)|0;o=z;while(1){if(f>>>0>o>>>0|(f|0)==(o|0)&i>>>0>n>>>0){n=72;break d}l=UW(i|0,f|0,e|0,0)|0;m=z;k=k&255;if(m>>>0>4294967295|(m|0)==-1&l>>>0>~k>>>0){n=72;break d}i=z0(l|0,m|0,k|0,0)|0;f=z;j=c[r>>2]|0;if(j>>>0<(c[q>>2]|0)>>>0){c[r>>2]=j+1;j=d[j>>0]|0}else j=_x(b)|0;k=a[392435+j>>0]|0;if((k&255)>>>0>=e>>>0){n=72;break}}}else n=72}while(0);if((n|0)==72)if((d[392435+j>>0]|0)>>>0<e>>>0){do{i=c[r>>2]|0;if(i>>>0<(c[q>>2]|0)>>>0){c[r>>2]=i+1;i=d[i>>0]|0}else i=_x(b)|0}while((d[392435+i>>0]|0)>>>0<e>>>0);c[12784]=34;j=(g&1|0)==0&0==0?p:0;e=h;i=g}else{j=p;e=f}if(c[q>>2]|0)c[r>>2]=(c[r>>2]|0)+-1;if(!(e>>>0<h>>>0|(e|0)==(h|0)&i>>>0<g>>>0)){if(!((g&1|0)!=0|0!=0|(j|0)!=0)){c[12784]=34;g=z0(g|0,h|0,-1,-1)|0;h=z;break}if(e>>>0>h>>>0|(e|0)==(h|0)&i>>>0>g>>>0){c[12784]=34;break}}g=((j|0)<0)<<31>>31;g=D_(i^j|0,e^g|0,j|0,g|0)|0;h=z}while(0);z=h;return g|0}function ce(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=l;l=l+16|0;o=z;n=z+11|0;p=z+10|0;q=z+9|0;r=z+8|0;s=z+7|0;t=z+6|0;u=z+5|0;w=z+4|0;v=b+840|0;f=a[v>>0]|0;g=f&255;x=b+804|0;e=c[x>>2]|0;h=e+(g*120|0)+104|0;y=b+798|0;a:do if(!(c[h>>2]|0)){i=b+760|0;k=b+761|0;do if(a[i>>0]|0){j=b+793|0;if((a[j>>0]|0)==-1?(a[b+794>>0]|0)==-1:0){a[j>>0]=0;a[j+1>>0]=0;a[j+2>>0]=0;a[j+3>>0]=0;a[j+4>>0]=0;a[y>>0]=1;a[e+(g*120|0)+12>>0]=a[k>>0]|0;break}if(!(a[b+492>>0]|0)){a[j>>0]=255;a[j+1>>0]=255;a[j+2>>0]=255;a[j+3>>0]=255;a[j+4>>0]=255;a[j+5>>0]=255;a[i>>0]=0}}while(0);c[h>>2]=1;m=b+880|0;j=c[m>>2]|0;c[e+(g*120|0)+112>>2]=j;c[m>>2]=j+1;if(!(c[b+728>>2]&1)){W5(b);f=a[v>>0]|0;e=c[x>>2]|0}j=f&255;a[e+(j*120|0)+117>>0]=1;h=b+776|0;g=c[h>>2]|0;i=g;m=e+(j*120|0)+28|0;b:do if(!g)switch(a[k>>0]|0){case 0:{f=J0()|0;c[o>>2]=f;g=e+(j*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(j*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(m,o);e=d[v>>0]|0;f=c[x>>2]|0;g=I0()|0;c[o>>2]=g;h=f+(e*120|0)+32|0;i=c[h>>2]|0;if(i>>>0<(c[f+(e*120|0)+36>>2]|0)>>>0){c[i>>2]=g;c[h>>2]=(c[h>>2]|0)+4}else Yy(f+(e*120|0)+28|0,o);break b}case 15:{f=J0()|0;c[o>>2]=f;g=e+(j*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(j*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(m,o);break b}case 17:{f=I0()|0;c[o>>2]=f;g=e+(j*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(j*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(m,o);break b}default:break b}else{f=e+(j*120|0)+32|0;g=c[f>>2]|0;if((g|0)==(c[e+(j*120|0)+36>>2]|0))Yy(m,h);else{c[g>>2]=i;c[f>>2]=(c[f>>2]|0)+4}c[h>>2]=0}while(0);i=b+734|0;g=0;while(1){f=a[v>>0]|0;m=f&255;e=c[x>>2]|0;h=c[e+(m*120|0)+28>>2]|0;if(g>>>0>=(c[e+(m*120|0)+32>>2]|0)-h>>2>>>0)break a;m=c[h+(g<<2)>>2]|0;a[m+734>>0]=a[i>>0]|0;aY(b,m);g=g+1|0}}while(0);g=b+780|0;if(c[g>>2]|0){Bx(b);a[o>>0]=0;a[n>>0]=0;a[p>>0]=0;a[q>>0]=0;a[r>>0]=0;e=c[g>>2]|0;if(a[e>>0]|0){AT(b,r);e=c[g>>2]|0}if(a[e+1>>0]|0){A6(c[b+648>>2]|0);e=c[g>>2]|0}if(a[e+17>>0]|0){AT(b,q);e=c[g>>2]|0}if(a[e+6>>0]|0){AT(b,p);e=c[g>>2]|0}if((a[e+4>>0]|0)!=0?(AT(b,n),(a[n>>0]|0)!=0):0){xR(b,3,o);e=1}else e=0;if((a[p>>0]|0)==0?!(e<<24>>24!=0&(a[o>>0]|0)==0):0){a[s>>0]=0;e=c[g>>2]|0;f=a[e+22>>0]|0;if(f<<24>>24){d4(c[b+648>>2]|0,f);e=c[g>>2]|0}if(a[e+20>>0]|0?(AT(b,s),a[s>>0]|0):0)d4(c[b+648>>2]|0,a[(c[g>>2]|0)+20>>0]|0);if(a[q>>0]|0)d4(c[b+648>>2]|0,a[(c[g>>2]|0)+17>>0]|0);if(a[r>>0]|0){a[t>>0]=0;a[u>>0]=0;a[w>>0]=0;e=c[g>>2]|0;if(a[e+2>>0]|0){A6(c[b+648>>2]|0);e=c[g>>2]|0}f=a[e+21>>0]|0;if(f<<24>>24){d4(c[b+648>>2]|0,f);e=c[g>>2]|0}if(a[e+5>>0]|0){AT(b,t);AT(b,u);e=c[g>>2]|0}if(a[e+19>>0]|0)AT(b,w);if(a[t>>0]|0)d4(c[b+648>>2]|0,a[(c[g>>2]|0)+16>>0]|0);if(a[u>>0]|0)d4(c[b+648>>2]|0,a[(c[g>>2]|0)+16>>0]|0);e=a[(c[g>>2]|0)+18>>0]|0;if(e<<24>>24)d4(c[b+648>>2]|0,e);if(a[w>>0]|0)d4(c[b+648>>2]|0,a[(c[g>>2]|0)+19>>0]|0)}}wK(b);f=a[v>>0]|0;e=c[x>>2]|0}ee(b,e+((f&255)*120|0)|0,y);l=z;return}
function CG(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=a+8|0;a=nb[c[c[a>>2]>>2]&255](a)|0;e=(Nf(d,e,a,a+168|0,g,f,0)|0)-a|0;if((e|0)<168)c[b>>2]=((e|0)/12|0|0)%7|0;return}function DG(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a=a+8|0;a=nb[c[c[a>>2]>>2]&255](a)|0;e=(Df(d,e,a,a+168|0,g,f,0)|0)-a|0;if((e|0)<168)c[b>>2]=((e|0)/12|0|0)%7|0;return}function EG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=b+528|0;e=c[g>>2]|0;g=z0(e|0,c[g+4>>2]|0,1,0)|0;i=z;f=b+536|0;h=c[f+4>>2]|0;if(i>>>0>h>>>0|((i|0)==(h|0)?g>>>0>(c[f>>2]|0)>>>0:0)){vt(b);b=0}else b=Z9(a[(c[b+544>>2]|0)+(c[b+612>>2]|0)+e>>0]|0)|0;a[d>>0]=b;return}function FG(a){a=a|0;c[a>>2]=38360;dU(a+908|0);bU(a+856|0);aW(a+844|0);pS(a+832|0);cU(a+792|0);cU(a+780|0);bt(a);return}function GG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;dt(d,a,c[b>>2]|0,c[b+4>>2]|0,f);l=e;return (c[d>>2]|0)+24|0}function HG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;et(d,a,c[b>>2]|0,c[b+4>>2]|0,f);l=e;return (c[d>>2]|0)+24|0}function IG(b){b=b|0;var c=0,e=0,f=0,g=0,h=0;h=l;l=l+16|0;f=h+1|0;g=h;GC(b);xR(b,2,g);g=a[g>>0]|0;c=0;e=0;while(1){if((c&255)>(g&255))break;xR(b,8,f);c=c+1<<24>>24;e=d[f>>0]|0|e<<8}J3(b);l=h;return e|0}function JG(a){a=a|0;var d=0,e=0,f=0,g=0,h=0;f=l;l=l+16|0;e=f;CK(a);HB(a,e);e=b[e>>1]|0;d=a+528|0;a=0;while(1){if((a&65535)>=(e&65535))break;h=d;h=z0(c[h>>2]|0,c[h+4>>2]|0,2,0)|0;g=d;c[g>>2]=h;c[g+4>>2]=z;a=a+1<<16>>16}l=f;return}function KG(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;d=b;e=a+360|0;W0(d,e);a=a+80|0;CS(a,0.0);s7(c[d>>2]|0);W0(d,e);CS(a,1.0);s7(c[d>>2]|0);l=b;return}function LG(a){a=a|0;var b=0,d=0,e=0,f=0;d=c[a+648>>2]|0;b=c[d+4>>2]|0;if(!(raa(b)|0)){e=a+528|0;f=c[e>>2]|0;e=c[e+4>>2]|0;b=z0(b7(b,c[d+8>>2]|0)|0,0,f|0,e|0)|0;e=z;d=a+536|0;a=c[d+4>>2]|0;return e>>>0<a>>>0|((e|0)==(a|0)?b>>>0<(c[d>>2]|0)>>>0:0)|0}else return 1;return 0}function MG(b){b=b|0;var d=0;Eg(b);c[b>>2]=28152;x1(b+776|0);c[b+788>>2]=0;c[b+792>>2]=0;c[b+796>>2]=0;a[b+733>>0]=1;d=b+632|0;c[d>>2]=65536;c[d+4>>2]=0;a[b+760>>0]=0;a[b+761>>0]=0;c[b+764>>2]=0;a[b+768>>0]=0;a[b+800>>0]=1;a[b+769>>0]=0;a[b+770>>0]=0;a[b+771>>0]=0;return}function NG(b){b=b|0;var d=0;d=ZW(896)|0;uW(d);c[b+776>>2]=d;c[b+16>>2]=2;Kc(b,2,-1)|0;RB(b,2,0,18,378944,-1,1,0);RB(b,2,0,52,378944,-1,1,0);RB(b,2,0,44,378949,-1,1,0);a[b+785>>0]=0;return}function OG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;h=a+4|0;i=c[h>>2]|0;f=i-e|0;g=f>>2;a=b+(g<<2)|0;e=i;while(1){if(a>>>0>=d>>>0)break;c[e>>2]=c[a>>2];j=(c[h>>2]|0)+4|0;c[h>>2]=j;a=a+4|0;e=j}if(g|0)TR(i+(0-g<<2)|0,b|0,f|0)|0;return}function PG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;g=a+4|0;h=0;while(1){e=c[g>>2]|0;f=c[a>>2]|0;if(h>>>0>=((e-f|0)/12|0)>>>0)break;if(rd(f+(h*12|0)|0,b,d)|0){i=4;break}h=h+1|0}if((i|0)==4){f=c[a>>2]|0;e=c[g>>2]|0}return (h>>>0<((e-f|0)/12|0)>>>0?h:-1)|0}function QG(b,d,e,f,g,h,i,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;a[b>>0]=d;a[b+1>>0]=e;a[b+2>>0]=f;a[b+3>>0]=g;c[b+4>>2]=h;c[b+8>>2]=i;a[b+12>>0]=j&1;a[b+13>>0]=k&1;a[b+14>>0]=l&1;a[b+15>>0]=m&1;a[b+16>>0]=n&1;return}function RG(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;W0(b,407712);if(!(c[101801]|0))_H();s7(c[b>>2]|0);p2(b,a);a=cK(407196,uP(b)|0,1)|0;z5(b);l=d;return a|0}function SG(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;W0(b,407712);if(!(c[101787]|0))$H();s7(c[b>>2]|0);p2(b,a);a=cK(407140,uP(b)|0,1)|0;z5(b);l=d;return a|0}function TG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(128)|0;c[b>>2]=f;c[b+4>>2]=d+4;d=b+8|0;a[d>>0]=0;bX(f+16|0,e);a[d>>0]=1;return}function UG(a){a=a|0;c[a>>2]=28424;$_(a+876|0);z5(a+864|0);z5(a+852|0);z5(a+840|0);u_(a+792|0);$V(a+776|0);MW(a+760|0);bt(a);return}function VG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=a[b+8+3>>0]|0;g=f<<24>>24<0;if(g)h=c[b+4>>2]|0;else h=f&255;if((e|0)==-1)uaa();if(g)b=c[b>>2]|0;f=h>>>0>e>>>0;b=L$(b,d,f?e:h)|0;if(!b)return (h>>>0<e>>>0?-1:f&1)|0;else return b|0;return 0}function WG(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);zp(a,bj(c,65756)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function XG(a,b){a=a|0;b=b|0;var d=0,e=0;if(!a){b=Ub(b)|0;return b|0}if(b>>>0>4294967231){c[12784]=12;b=0;return b|0}d=Gh(a+-8|0,b>>>0<11?16:b+11&-8)|0;if(d|0){b=d+8|0;return b|0}d=Ub(b)|0;if(!d){b=0;return b|0}e=c[a+-4>>2]|0;e=(e&-8)-((e&3|0)==0?8:4)|0;no(d|0,a|0,(e>>>0<b>>>0?e:b)|0)|0;pe(a);b=d;return b|0}function YG(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=ZW(48)|0;c[d>>2]=g;c[d+4>>2]=e+4;b[g+16>>1]=b[c[f>>2]>>1]|0;GY(g+20|0);a[d+8>>0]=1;return}function ZG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=a[b+11>>0]|0;g=f<<24>>24<0;if(g)h=c[b+4>>2]|0;else h=f&255;if((e|0)==-1)uaa();if(g)b=c[b>>2]|0;f=h>>>0>e>>>0;b=R$(b,d,f?e:h)|0;if(!b)return (h>>>0<e>>>0?-1:f&1)|0;else return b|0;return 0}function _G(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;GC(b);e=b+648|0;d4(c[e>>2]|0,2);d4(c[e>>2]|0,4);d4(c[e>>2]|0,2);if((a[b+2464>>0]|0)!=1)xR(b,2,d);J3(b);l=d;return}function $G(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,354892)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function aH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;f=a+528|0;d=c[f>>2]|0;f=z0(d|0,c[f+4>>2]|0,4,0)|0;h=z;e=a+536|0;g=c[e+4>>2]|0;if(h>>>0>g>>>0|((h|0)==(g|0)?f>>>0>(c[e>>2]|0)>>>0:0)){vt(a);a=0}else a=W8((c[a+544>>2]|0)+(c[a+612>>2]|0)+d|0)|0;c[b>>2]=a;return}function bH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,108257)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function cH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,161383)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function dH(b){b=b|0;var d=0,e=0,f=0;d=l;l=l+16|0;e=d+4|0;bB(b,e);jB(b,d);if(!(a[e>>0]|0))c[b+768>>2]=1835365473;else{f=b+536|0;e=b+528|0;e=D_(c[f>>2]|0,c[f+4>>2]|0,c[e>>2]|0,c[e+4>>2]|0)|0;e1(b,e,z)}l=d;return}function eH(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+128|0;h=j;c[h>>2]=0;i=h+4|0;c[i>>2]=a;c[h+44>>2]=a;g=h+8|0;c[g>>2]=(a|0)<0?-1:a+2147483647|0;c[h+76>>2]=-1;NV(h,0);d=be(h,d,1,e,f)|0;if(b|0)c[b>>2]=a+((c[i>>2]|0)+(c[h+108>>2]|0)-(c[g>>2]|0));l=j;return d|0}function fH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,173809)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function gH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,103982)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function hH(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;iX(b,a);if(qO(a)|0)k1((c[(c[(c[a+976>>2]|0)+((c[a+988>>2]|0)*12|0)>>2]|0)+((c[a+992>>2]|0)*24|0)+8>>2]|0)+((c[a+996>>2]|0)*24|0)+12|0,b)|0;z5(b);l=d;return}function iH(a){a=a|0;var b=0,d=0,e=0;b=a+44|0;e=c[b>>2]|0;d=c[a+24>>2]|0;if(e>>>0<d>>>0){c[b>>2]=d;e=d}if(c[a+48>>2]&8){b=a+16|0;d=c[b>>2]|0;if(d>>>0<e>>>0){c[b>>2]=e;d=e}b=c[a+12>>2]|0;if(b>>>0<d>>>0)b=raa(c[b>>2]|0)|0;else b=-1}else b=-1;return b|0}function jH(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if(c|0){if((d|0)==-1){d=0;while(1)if(!(a[c+d>>0]|0))break;else d=d+1|0}else d=d&-2;e=iaa(d+2|0)|0;no(e|0,c|0,d|0)|0;a[e+d>>0]=0;a[e+(d+1)>>0]=0;pp(b,d);UC(b,e)|0;jaa(e)}return b|0}function kH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,109984)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function lH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,174864)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function mH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,162836)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function nH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;e=l;l=l+32|0;g=e+12|0;f=e;$x(f,a,b,c,d,1);pl(g,f);zb(a,b,c,d+1|0,g,1);z5(g);z5(f);l=e;return}function oH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=l;l=l+16|0;g=h;f=a[b+8+3>>0]|0;if(f<<24>>24<0){f=c[b+4>>2]|0;b=c[b>>2]|0}else f=f&255;c[g>>2]=d;if(f>>>0>e>>>0){g=U_(b+(e<<2)|0,f-e|0,g)|0;b=(g|0)==0?-1:g-b>>2}else b=-1;l=h;return b|0}function pH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,122417)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function qH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,122053)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function rH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,174451)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function sH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,166054)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function tH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,165134)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function uH(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;iX(b,a);if(qO(a)|0)k1((c[(c[(c[a+976>>2]|0)+((c[a+988>>2]|0)*12|0)>>2]|0)+((c[a+992>>2]|0)*24|0)+8>>2]|0)+((c[a+996>>2]|0)*24|0)|0,b)|0;z5(b);l=d;return}function vH(a){a=a|0;var b=0,d=0,e=0;b=an(a)|0;d=z;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){e=a+20|0;sM(a,1,c[e>>2]|0,29,2,0);e=c[e>>2]|0;RB(a,1,e,30,Po(b,d)|0,-1,1,0)}return}function wH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,354926)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function xH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,174788)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function yH(a){a=a|0;var b=0,d=0,e=0,f=0;f=a+4|0;b=c[f>>2]|0;e=c[a>>2]|0;d=b-e|0;a:do if(d>>>0>=256){if((d|0)!=256){a=e+256|0;while(1){if((b|0)==(a|0))break a;e=b+-1|0;c[f>>2]=e;b=e}}}else Uu(a,256-d|0);while(0);return}function zH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(40)|0;c[b>>2]=f;c[b+4>>2]=d+4;AW(f+16|0,e);a[b+8>>0]=1;return}function AH(a){a=a|0;var b=0,d=0,e=0,f=0;f=a+4|0;b=c[f>>2]|0;e=c[a>>2]|0;d=b-e>>1;a:do if(d>>>0>=256){if((d|0)!=256){a=e+512|0;while(1){if((b|0)==(a|0))break a;e=b+-2|0;c[f>>2]=e;b=e}}}else Jv(a,256-d|0);while(0);return}function BH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=b+4|0;f=c[e>>2]|0;g=f&7;h=f-d|0;do if(g>>>0<d>>>0)if(f>>>0<d>>>0){c[e>>2]=0;a[b+13>>0]=1;break}else{g=(c[b>>2]|0)+((d+-1-g|0)>>>3)|0;c[b>>2]=g;a[b+12>>0]=a[g>>0]|0;c[b>>2]=g+1;c[e>>2]=h;break}else c[e>>2]=h;while(0);return}function CH(b){b=b|0;var c=0,d=0,e=0;e=l;l=l+16|0;d=e+1|0;c=e;GC(b);xR(b,2,d);d=a[d>>0]|0;if(!(d<<24>>24!=1?(EH(b),!(d<<24>>24)):0))PI(b);AT(b,c);J3(b);l=e;return}function DH(a){a=a|0;var b=0,d=0,e=0;e=l;l=l+16|0;b=e;d=a+888|0;c[d>>2]=-1;c[d+4>>2]=-1;d=a+916|0;if(!(c[a+924>>2]|0)){c[b>>2]=-1;bF(d,b)|0}d=c[d>>2]|0;c[a+928>>2]=d;c[a+896>>2]=c[d+280>>2];c[a+900>>2]=c[d+284>>2];l=e;return}function EH(b){b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;f=e;GC(b);d=b+648|0;A6(c[d>>2]|0);d4(c[d>>2]|0,2);AT(b,f);if(a[f>>0]|0)A6(c[d>>2]|0);J3(b);l=e;return}function FH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,353454)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function GH(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;Xy(c,42472);z3(a,c);z5(c);TX(c);Fk(a,bj(c,351400)|0);z5(c);Xy(c,42472);z3(a,c);z5(c);l=b;return}function HH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;b=c[c[a>>2]>>2]|0;if(b){c[a>>2]=b;e=c[d>>2]|0}gp(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1;return}function IH(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d+1|0;GC(b);AT(b,e);if(!(a[e>>0]|0)){AT(b,d);d4(c[b+648>>2]|0,2)}else My(b);J3(b);l=d;return}function JH(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;if(d|0){mx(d,c[b+24>>2]|0,0,0);a[d+492>>0]=1;k1(d+84|0,a[b+492>>0]|0?b+84|0:b+28|0)|0;Mp(d,e,f)}return}function KH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=a+4|0;e=c[h>>2]|0;g=c[a>>2]|0;f=e-g>>3;a:do if(f>>>0>=b>>>0){if(f>>>0>b>>>0){a=g+(b<<3)|0;while(1){if((e|0)==(a|0))break a;g=e+-8|0;c[h>>2]=g;e=g}}}else Rs(a,b-f|0,d);while(0);return}function LH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(440)|0;c[b>>2]=f;c[b+4>>2]=d+4;c[f+16>>2]=c[c[e>>2]>>2];Vo(f+24|0);a[b+8>>0]=1;return}function MH(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;b=c;while(1){if((e|0)==(f|0)){h=7;break}if((b|0)==(d|0)){b=-1;break}c=a[b>>0]|0;g=a[e>>0]|0;if(c<<24>>24<g<<24>>24){b=-1;break}if(g<<24>>24<c<<24>>24){b=1;break}e=e+1|0;b=b+1|0}if((h|0)==7)b=(b|0)!=(d|0)&1;return b|0}function NH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;c[b+12>>2]=0;c[b+16>>2]=408232;do if(d)if(d>>>0<29&(a[408344]|0)==0){a[408344]=1;f=408232;break}else{f=ZW(d<<2)|0;break}else f=0;while(0);c[b>>2]=f;e=f+(e<<2)|0;c[b+8>>2]=e;c[b+4>>2]=e;c[b+12>>2]=f+(d<<2);return}function OH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;g=l;l=l+48|0;b=g+44|0;d=g;W0(b,a+12|0);e=a+8|0;if((c[e>>2]|0)==0?(f=a+4|0,(c[f>>2]|0)==0):0){Fa(d|0)|0;wa(d|0,1)|0;Va(f|0,d|0,128,a|0)|0;c[e>>2]=1}s7(c[b>>2]|0);l=g;return}function PH(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;Nt(e,a,b[d>>1]|0,g);l=f;return (c[e>>2]|0)+16|0}function QH(a,d){a=a|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;ot(e,a,b[d>>1]|0,g);l=f;return (c[e>>2]|0)+20|0}function RH(b,d){b=b|0;d=d|0;var e=0,f=0;a[b>>0]=0;e=d+(c[(c[d>>2]|0)+-12>>2]|0)|0;f=c[e+16>>2]|0;if(!f){e=c[e+72>>2]|0;if(!e)e=1;else{YB(e)|0;e=(c[d+(c[(c[d>>2]|0)+-12>>2]|0)+16>>2]|0)==0&1}a[b>>0]=e}else C4(e,f|4);return}function SH(a){a=a|0;var b=0,d=0,e=0;b=a+652|0;d=c[b>>2]|0;jb[c[(c[d>>2]|0)+24>>2]&511](d);d=c[b>>2]|0;d=nb[c[(c[d>>2]|0)+28>>2]&255](d)|0;a=a+528|0;e=a;d=z0(c[e>>2]|0,c[e+4>>2]|0,d|0,0)|0;c[a>>2]=d;c[a+4>>2]=z;a=c[b>>2]|0;ob[c[(c[a>>2]|0)+8>>2]&3](a,0,0);return}function TH(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=ZW(112)|0;c[d>>2]=g;c[d+4>>2]=e+4;b[g+16>>1]=b[c[f>>2]>>1]|0;lD(g+24|0);a[d+8>>0]=1;return}function UH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(112)|0;c[b>>2]=f;c[b+4>>2]=d+4;c[f+16>>2]=c[c[e>>2]>>2];XH(f+24|0);a[b+8>>0]=1;return}function VH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;pt(e,b,a[d>>0]|0,g);l=f;return (c[e>>2]|0)+24|0}function WH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+16|0;e=f+8|0;g=f;c[g>>2]=d;qt(e,b,a[d>>0]|0,g);l=f;return (c[e>>2]|0)+20|0}function XH(b){b=b|0;var d=0,e=0,f=0;d=b+40|0;e=b;f=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));c[d>>2]=7;e=b+44|0;f=b+64|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;a[b+80>>0]=1;a[b+81>>0]=0;a[b+82>>0]=1;a[b+83>>0]=0;return}function YH(a){a=a|0;var b=0,d=0,e=0,f=0;f=a+288|0;e=c[f>>2]|0;f=c[f+4>>2]|0;d=a+280|0;b=c[d>>2]|0;d=c[d+4>>2]|0;if(f>>>0>d>>>0|(f|0)==(d|0)&e>>>0>b>>>0){f=D_(e|0,f|0,b|0,d|0)|0;f=cT((+(f>>>0)+4294967296.0*+(z>>>0))/1.0e6)|0;jL(a,1,0,76,f,z,0)}return}function ZH(a){a=a|0;var b=0,e=0,f=0;f=l;l=l+16|0;e=f;xR(a,2,e);b=a+648|0;d4(c[b>>2]|0,6);e=(d[e>>0]|0)+1|0;a=0;while(1){if((a|0)==(e|0))break;d4(c[b>>2]|0,5);d4(c[b>>2]|0,4);a=a+1|0}l=f;return}function _H(){var a=0,b=0;a=l;l=l+16|0;b=a;Xy(b,42472);z3(407196,b);z5(b);TX(b);Fk(407196,bj(b,349936)|0);z5(b);Xy(b,42472);z3(407196,b);z5(b);l=a;return}function $H(){var a=0,b=0;a=l;l=l+16|0;b=a;Xy(b,42472);z3(407140,b);z5(b);TX(b);Fk(407140,bj(b,348472)|0);z5(b);Xy(b,42472);z3(407140,b);z5(b);l=a;return}function aI(a){a=a|0;var b=0,d=0,e=0;b=c[a+32>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);e=a+36|0;d=a+40|0;a=0;while(1){b=c[e>>2]|0;if(a>>>0>=(c[d>>2]|0)-b>>2>>>0)break;b=c[b+(a<<2)>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);a=a+1|0}cU(e);return}function bI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e+8|0;f=e;c[f>>2]=b;Pt(d,a,c[b>>2]|0,f);l=e;return (c[d>>2]|0)+20|0}function cI(a){a=a|0;var b=0,d=0,e=0,f=0;c[a>>2]=57264;e=a+8|0;f=a+12|0;d=0;while(1){b=c[e>>2]|0;if(d>>>0>=(c[f>>2]|0)-b>>2>>>0)break;b=c[b+(d<<2)>>2]|0;if(b|0)zZ(b);d=d+1|0}a1(a+144|0);TK(e);return}function dI(a,b){a=a|0;b=b|0;var c=0;switch(a|0){case 0:{if(!b)a=373184;else c=9;break}case 1:{if(!b)a=373178;else c=9;break}case 2:{if(!b)a=373172;else c=9;break}case 3:{if(!b)a=373155;else c=9;break}default:c=9}if((c|0)==9)a=8800948;return a|0}function eI(){var a=0,b=0;a=l;l=l+16|0;b=a;Xy(b,42472);z3(406804,b);z5(b);TX(b);Fk(406804,bj(b,95839)|0);z5(b);Xy(b,42472);z3(406804,b);z5(b);l=a;return}function fI(){var a=0,b=0;a=l;l=l+16|0;b=a;Xy(b,42472);z3(406860,b);z5(b);TX(b);Fk(406860,bj(b,174890)|0);z5(b);Xy(b,42472);z3(406860,b);z5(b);l=a;return}function gI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a:do if(b>>>0<=1?(k1(a+12+(b*12|0)|0,d)|0,(b|0)==1):0){d=a+4|0;e=a+24|0;b=0;while(1){if(b>>>0>=(((c[d>>2]|0)-(c[a>>2]|0)|0)/40|0)>>>0)break a;z3(lI(a,b)|0,e);b=b+1|0}}while(0);return}function hI(a,b){a=a|0;b=b|0;var d=0,e=0;d=l;l=l+48|0;e=d;mI(e);z3(e,a+24|0);Q3(e,a+36|0);s5(e,c[a+52>>2]|0);og(e,b);Mx(a,e);$_(e);l=d;return}function iI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;e=a+8|0;g=e;g=PZ(c[g>>2]|0,c[g+4>>2]|0,1)|0;f=z;d=e;c[d>>2]=g;c[d+4>>2]=f;d=a;b=c[d>>2]|0;d=c[d+4>>2]|0;h=XZ(b|0,d|0,63)|0;c[e>>2]=h|g;c[e+4>>2]=z|f;d=PZ(b|0,d|0,1)|0;b=a;c[b>>2]=d;c[b+4>>2]=z;return a|0}function jI(b){b=b|0;var d=0;d=b+760|0;do if(i3(d)|0?(c[b+548>>2]|0)>>>0>=4:0){b=c[b+544>>2]|0;if((((a[b>>0]|0)==65?(a[b+1>>0]|0)==76:0)?(a[b+2>>0]|0)==83:0)?(a[b+3>>0]|0)==0:0){b=1;break}w5(c[d>>2]|0);b=0}else b=0;while(0);return b|0}function kI(a){a=a|0;var b=0,d=0,e=0;b=an(a)|0;d=z;if((qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)?(oK(a,1,c[a+20>>2]|0,138,b,d,10,1),e=a+856|0,a=e,(c[a>>2]|0)==0&(c[a+4>>2]|0)==0):0){c[e>>2]=b;c[e+4>>2]=d}return}function lI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=l;l=l+64|0;e=g+16|0;f=g;d=c[a>>2]|0;if((((c[a+4>>2]|0)-d|0)/40|0)>>>0<=b>>>0){TX(f);hB(e,f);Wt(a,e,b);$_(e);z5(f);d=c[a>>2]|0}l=g;return d+(b*40|0)|0}function mI(a){a=a|0;var b=0,d=0,e=0,f=0;b=l;l=l+16|0;d=b;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;f=a+12|0;TX(f);e=a+24|0;TX(e);Xy(d,42436);k1(f,d)|0;z5(d);Xy(d,42444);k1(e,d)|0;z5(d);c[a+36>>2]=-1;l=b;return}function nI(b,c){b=b|0;c=c|0;var d=0;d=c&255;a:do if(!(c<<24>>24))b=0;else switch(b<<24>>24){case 2:{if((c&255)>8){b=0;break a}b=a[378843+d>>0]|0;break a}case 6:{if((c&255)>3){b=0;break a}b=a[378852+d>>0]|0;break a}default:{b=0;break a}}while(0);return b|0}function oI(a){a=a|0;var b=0,d=0,e=0;b=an(a)|0;d=z;if((qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)?(oK(a,1,c[a+20>>2]|0,130,b,d,10,1),e=a+848|0,a=e,(c[a>>2]|0)==0&(c[a+4>>2]|0)==0):0){c[e>>2]=b;c[e+4>>2]=d}return}function pI(a){a=a|0;var b=0,d=0,e=0;b=c[102055]|0;e=c[102054]|0;d=b-e>>2;a:do if(d>>>0>=a>>>0){if(d>>>0>a>>>0){a=e+(a<<2)|0;while(1){if((b|0)==(a|0))break a;e=b+-4|0;c[102055]=e;b=e}}}else Gu(a-d|0);while(0);return}function qI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;f=b;d=c[f+4>>2]|0;e=a;c[e>>2]=c[f>>2];c[e+4>>2]=d;e=a+8|0;d=b+8|0;c[e>>2]=0;f=a+12|0;c[f>>2]=0;c[a+16>>2]=0;c[e>>2]=c[d>>2];e=b+12|0;c[f>>2]=c[e>>2];b=b+16|0;c[a+16>>2]=c[b>>2];c[b>>2]=0;c[e>>2]=0;c[d>>2]=0;return}function rI(b){b=b|0;var d=0,e=0,f=0;d=b+92|0;if(!(c[d>>2]&8)){c[b+24>>2]=0;c[b+20>>2]=0;c[b+28>>2]=0;e=(a[b+98>>0]|0)==0;f=c[(e?b+56|0:b+32|0)>>2]|0;e=f+(c[(e?b+60|0:b+52|0)>>2]|0)|0;c[b+8>>2]=f;c[b+12>>2]=e;c[b+16>>2]=e;c[d>>2]=8;b=1}else b=0;return b|0}function sI(a){a=a|0;JU(a+44|0);bU(a+28|0);zU(a+16|0);IT(a+4|0);return}function tI(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d+1|0;GC(b);AT(b,e);if(!(a[e>>0]|0)){AT(b,d);d4(c[b+648>>2]|0,2)}else pA(b);J3(b);l=d;return}function uI(b){b=b|0;var d=0,e=0,f=0,g=0;f=l;l=l+32|0;g=f+16|0;d=f;e=f+8|0;bB(b,g);jB(b,f+12|0);if(!(a[g>>0]|0)){ID(b,e);g=d;c[g>>2]=c[e>>2];c[g+4>>2]=0}else oz(b,d);l=f;return}function vI(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;b4(b);b=(c[d>>2]|0)+24|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function wI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a:do if((b|0)!=(d|0)){g=a+4|0;a=c[g>>2]|0;e=a-d|0;f=e>>3;if(f){TR(b|0,d|0,e|0)|0;a=c[g>>2]|0}e=b+(f<<3)|0;while(1){if((a|0)==(e|0))break a;b=a+-8|0;c[g>>2]=b;a=b}}while(0);return}function xI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a:do if((b|0)!=(d|0)){g=a+4|0;a=c[g>>2]|0;e=a-d|0;f=e>>2;if(f){TR(b|0,d|0,e|0)|0;a=c[g>>2]|0}e=b+(f<<2)|0;while(1){if((a|0)==(e|0))break a;b=a+-4|0;c[g>>2]=b;a=b}}while(0);return}function yI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(40)|0;c[b>>2]=f;c[b+4>>2]=d+4;p2(f+16|0,c[e>>2]|0);TX(f+28|0);a[b+8>>0]=1;return}function zI(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;a:do if(d|0)switch(e|0){case -2:{a[d>>0]=f;break a}case -1:{b[d>>1]=f;break a}case 0:{c[d>>2]=f;break a}case 1:{c[d>>2]=f;break a}case 3:{e=d;c[e>>2]=f;c[e+4>>2]=g;break a}default:break a}while(0);return}function AI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(32)|0;c[b>>2]=f;c[b+4>>2]=d+4;a[f+16>>0]=a[c[e>>2]>>0]|0;e=f+24|0;c[e>>2]=0;c[e+4>>2]=0;a[b+8>>0]=1;return}function BI(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=b;while(1){if((e|0)==(f|0)){h=7;break}if((a|0)==(d|0)){a=-1;break}b=c[a>>2]|0;g=c[e>>2]|0;if((b|0)<(g|0)){a=-1;break}if((g|0)<(b|0)){a=1;break}e=e+4|0;a=a+4|0}if((h|0)==7)a=(a|0)!=(d|0)&1;return a|0}function CI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=a+40|0;e=c[f>>2]|0;f=c[f+4>>2]|0;do if(!(f>>>0<d>>>0|(f|0)==(d|0)&e>>>0<b>>>0))if((e|0)==-1&(f|0)==-1){wk(a);break}else{f=D_(e|0,f|0,b|0,d|0)|0;ty(a,f,z);break}while(0);return}function DI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(40)|0;c[b>>2]=f;c[b+4>>2]=d+4;rV(f+16|0,c[e>>2]|0);TX(f+28|0);a[b+8>>0]=1;return}function EI(b){b=b|0;var d=0,e=0;if(Hi(b)|0)if(!(a[b+733>>0]|0)){jb[c[(c[b>>2]|0)+72>>2]&511](b);e=b+560|0;c[e>>2]=0;c[e+4>>2]=0;e=b+48|0;d=c[e+4>>2]|0;b=b+56|0;c[b>>2]=c[e>>2];c[b+4>>2]=d;b=1}else b=1;else b=0;return b|0}function FI(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;bB(a,b+6|0);jB(a,b);NB(a,b+4|0);e=a+536|0;d=a+528|0;d=D_(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e1(a,d,z);l=b;return}function GI(a){a=a|0;c[a>>2]=12688;z_(a+864|0);z_(a+852|0);aU(a+840|0);aU(a+828|0);aU(a+816|0);A_(a+796|0);bt(a);return}function HI(b){b=b|0;var d=0,e=0,f=0;if(a[b+890>>0]|0){d=b+528|0;f=d;f=z0(c[f>>2]|0,c[f+4>>2]|0,1,0)|0;e=d;c[e>>2]=f;c[e+4>>2]=z;iF(b,4,0);e=d;e=z0(c[e>>2]|0,c[e+4>>2]|0,4,0)|0;c[d>>2]=e;c[d+4>>2]=z}KK(b);return}function II(a){a=a|0;var b=0,d=0,f=0;b=l;l=l+16|0;d=b;GC(a);f=a+648|0;d4(c[f>>2]|0,16);sR(a,16,d);J3(a);f=Z9(c[(c[f>>2]|0)+4>>2]|0)|0;c[a+788>>2]=f-((e[d>>1]|0)<<3);l=b;return}function JI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;c[a+544>>2]=b;c[a+548>>2]=d;b=a+528|0;e=b;c[e>>2]=0;c[e+4>>2]=0;e=a+536|0;c[e>>2]=d;c[e+4>>2]=0;jb[c[(c[a>>2]|0)+76>>2]&511](a);c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;return}function KI(a){a=a|0;var b=0;b=a+4|0;uy(c[b>>2]|0);c[a+8>>2]=0;c[a>>2]=b;c[b>>2]=0;return}function LI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=d-f>>3;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b<<3)|0;while(1){if((d|0)==(a|0))break a;f=d+-8|0;c[g>>2]=f;d=f}}}else Gw(a,b-e|0);while(0);return}function MI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=d-f>>2;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b<<2)|0;while(1){if((d|0)==(a|0))break a;f=d+-4|0;c[g>>2]=f;d=f}}}else Dw(a,b-e|0);while(0);return}function NI(a,b,d){a=a|0;b=b|0;d=d|0;a:while(1){while(1){if(!b)break a;if((c[b+16>>2]|0)>>>0>=a>>>0)break;b=c[b+4>>2]|0}d=b;b=c[b>>2]|0}return d|0}function OI(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;b=(c[d>>2]|0)+32|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function PI(a){a=a|0;var b=0;GC(a);b=a+648|0;A6(c[b>>2]|0);d4(c[b>>2]|0,8);d4(c[b>>2]|0,4);d4(c[b>>2]|0,12);d4(c[b>>2]|0,2);J3(a);return}function QI(b){b=b|0;var d=0;d=b+536|0;if((c[d>>2]|0)==0&(c[d+4>>2]|0)==0){if(qO(b)|0){HM(b)|0;s_(b);AR(b,32,0);a[(c[b+772>>2]|0)+32>>0]=1}}else t4(b);return}function RI(a){a=a|0;if(!a)return;else{RI(c[a>>2]|0);RI(c[a+4>>2]|0);laa(a);return}}function SI(a){a=a|0;if(!a)return;else{SI(c[a>>2]|0);SI(c[a+4>>2]|0);laa(a);return}}function TI(a){a=a|0;if(!a)return;else{TI(c[a>>2]|0);TI(c[a+4>>2]|0);laa(a);return}}function UI(a){a=a|0;if(!a)return;else{UI(c[a>>2]|0);UI(c[a+4>>2]|0);laa(a);return}}function VI(a){a=a|0;if(!a)return;else{VI(c[a>>2]|0);VI(c[a+4>>2]|0);laa(a);return}}function WI(a){a=a|0;if(!a)return;else{WI(c[a>>2]|0);WI(c[a+4>>2]|0);laa(a);return}}function XI(a){a=a|0;if(!a)return;else{XI(c[a>>2]|0);XI(c[a+4>>2]|0);laa(a);return}}function YI(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;b4(b);b=(c[d>>2]|0)+24|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function ZI(a,b){a=a|0;b=b|0;if((a|0)!=(b|0))rk(a,c[b>>2]|0,b+4|0);return a|0}function _I(a,b){a=a|0;b=b|0;var d=0;if(b){d=a+536|0;b=a+528|0;b=D_(c[d>>2]|0,c[d+4>>2]|0,c[b>>2]|0,c[b+4>>2]|0)|0;e1(a,b,z)}else{Bx(a);Ob(a);CU(a);wK(a)}return}function $I(a){a=a|0;var b=0,d=0,e=0,f=0;if(((c[a+784>>2]|0)==0?qO(a)|0:0)?(d=a+528|0,d=z0(c[d>>2]|0,c[d+4>>2]|0,8,0)|0,f=z,b=a+536|0,e=c[b+4>>2]|0,f>>>0<e>>>0|((f|0)==(e|0)?d>>>0<(c[b>>2]|0)>>>0:0)):0)o7(a);return}function aJ(b){b=b|0;var d=0,e=0,f=0;d=b+760|0;if(i3(d)|0?(f=c[b+612>>2]|0,e=a[b+890>>0]|0?9:0,(c[b+548>>2]|0)>>>0>=(f+4+e|0)>>>0):0)if((C9((c[b+544>>2]|0)+f+e|0)|0)==1716281667)b=1;else{xp(d,372535);b=0}else b=0;return b|0}function bJ(a){a=a|0;var b=0;GC(a);e1(a,9,0);J3(a);GC(a);b=a+528|0;b=D_(c[a+788>>2]|0,0,c[b>>2]|0,c[b+4>>2]|0)|0;e1(a,b,z);J3(a);return}function cJ(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);if((c[a+768>>2]|0)==1835299937){a=a+528|0;d=a;d=z0(c[d>>2]|0,c[d+4>>2]|0,4,0)|0;c[a>>2]=d;c[a+4>>2]=z}else t4(a);l=b;return}function dJ(a,b,d){a=a|0;b=b|0;d=d|0;a:while(1){while(1){if(!b)break a;if((e[b+16>>1]|0)>=(a&65535))break;b=c[b+4>>2]|0}d=b;b=c[b>>2]|0}return d|0}function eJ(a){a=a|0;var b=0.0,d=0,e=0;if((a|0)<=127)if((a|0)<-126){d=a+126|0;e=(d|0)<-126;a=a+252|0;b=e?0.0:1.1754943508222875e-38;a=e?((a|0)>-126?a:-126):d}else b=1.0;else{e=a+-127|0;d=(e|0)>127;a=a+-254|0;b=d?t:1701411834604692317316873.0e14;a=d?((a|0)<127?a:127):e}return +(b*(c[j>>2]=(a<<23)+1065353216,+g[j>>2]))}function fJ(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=ZW(32)|0;c[d>>2]=g;c[d+4>>2]=e+4;b[g+16>>1]=b[c[f>>2]>>1]|0;TX(g+20|0);a[d+8>>0]=1;return}function gJ(a){a=a|0;var b=0;b=PZ(d[a>>0]|0|0,0,8)|0;b=PZ(b|(d[a+1>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+2>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+3>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+4>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+5>>0]|0)|0,z|0,8)|0;return b|(d[a+6>>0]|0)|0}function hJ(b){b=b|0;var d=0;c[b>>2]=10112;TX(b+28|0);c[b+4>>2]=0;c[b+8>>2]=0;a[b+12>>0]=0;d=b+40|0;c[d>>2]=-1;c[d+4>>2]=-1;d=b+48|0;c[d>>2]=0;c[d+4>>2]=0;d=b+56|0;c[d>>2]=-1;c[d+4>>2]=-1;c[d+8>>2]=-1;c[d+12>>2]=-1;c[b+16>>2]=7;c[b+20>>2]=-1;c[b+24>>2]=0;return}function iJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;f=a+528|0;e=a+536|0;d=c[e>>2]|0;e=c[e+4>>2]|0;b=f;a=c[b+4>>2]|0;b=c[b>>2]|0;while(1){if(!(a>>>0<e>>>0|(a|0)==(e|0)&b>>>0<d>>>0))break;g=z0(b|0,a|0,4,0)|0;h=z;i=f;c[i>>2]=g;c[i+4>>2]=h;a=h;b=g}return}function jJ(a){a=a|0;if((Cv(405008,a)|0)==405012)k1(yG(405008,a)|0,a)|0;return yG(405008,a)|0}function kJ(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;b=(c[d>>2]|0)+32|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function lJ(a){a=a|0;var b=0,d=0,e=0,f=0;Kc(a,7,-1)|0;b=0;while(1){if((b|0)==8)break;d=c[a+380+(b*12|0)>>2]|0;e=a+380+(b*12|0)+4|0;while(1){f=c[e>>2]|0;if((f|0)==(d|0))break;f=f+-24|0;c[e>>2]=f;w4(f)}b=b+1|0}return}function mJ(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);KK(a);e=a+536|0;d=a+528|0;d=D_(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;iF(a,d,z);l=b;return}function nJ(b){b=b|0;var d=0,e=0,f=0,g=0;d=c[b+4>>2]|0;e=b+8|0;f=c[e>>2]|0;while(1){if((f|0)==(d|0))break;g=f+-4|0;c[e>>2]=g;f=g}e=c[b>>2]|0;do if(e|0){d=c[b+16>>2]|0;if((d|0)==(e|0)){a[d+112>>0]=0;break}else{laa(e);break}}while(0);return}function oJ(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0;b=l;l=l+16|0;j=b+4|0;a=b;c[j>>2]=d;c[a>>2]=g;h=ak(d,e,j,g,h,a)|0;c[f>>2]=c[j>>2];c[i>>2]=c[a>>2];l=b;return h|0}function pJ(a){a=a|0;var b=0,d=0,e=0,f=0;c[a>>2]=10168;e=a+760|0;f=a+764|0;d=0;while(1){b=c[e>>2]|0;if(d>>>0>=(c[f>>2]|0)-b>>2>>>0)break;b=c[b+(d<<2)>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);d=d+1|0}cU(e);bt(a);return}function qJ(a,b){a=a|0;b=b|0;var d=0,e=0;h5(a);d=c[102054]|0;if((c[102055]|0)-d>>2>>>0<=b>>>0){pI(b+1|0);d=c[102054]|0}e=c[d+(b<<2)>>2]|0;if(e){zZ(e);d=c[102054]|0}c[d+(b<<2)>>2]=a;return}function rJ(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0;b=l;l=l+16|0;j=b+4|0;a=b;c[j>>2]=d;c[a>>2]=g;h=wj(d,e,j,g,h,a)|0;c[f>>2]=c[j>>2];c[i>>2]=c[a>>2];l=b;return h|0}function sJ(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0;b=l;l=l+16|0;j=b+4|0;a=b;c[j>>2]=d;c[a>>2]=g;h=$m(d,e,j,g,h,a)|0;c[f>>2]=c[j>>2];c[i>>2]=c[a>>2];l=b;return h|0}function tJ(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0;b=l;l=l+16|0;j=b+4|0;a=b;c[j>>2]=d;c[a>>2]=g;h=hk(d,e,j,g,h,a)|0;c[f>>2]=c[j>>2];c[i>>2]=c[a>>2];l=b;return h|0}function uJ(a){a=a|0;switch(a<<24>>24){case 0:{a=385816;break}case 1:{a=385801;break}case 2:{a=385790;break}case 3:{a=385781;break}case 4:{a=385762;break}case 5:{a=385754;break}case 6:{a=385731;break}case 7:{a=385721;break}case 15:{a=385637;break}default:a=391133}return a|0}function vJ(a){a=a|0;switch(a<<24>>24){case 0:{a=386002;break}case 1:{a=385975;break}case 2:{a=385947;break}case 3:{a=385916;break}case 4:{a=385886;break}case 5:{a=385860;break}case 6:{a=385842;break}case 7:{a=385832;break}case 15:{a=385637;break}default:a=391133}return a|0}function wJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;e=l;l=l+16|0;d=e;ID(a,d);d=c[d>>2]|0;b=a+528|0;a=0;while(1){if((a|0)==(d|0))break;g=b;g=z0(c[g>>2]|0,c[g+4>>2]|0,8,0)|0;f=b;c[f>>2]=g;c[f+4>>2]=z;a=a+1|0}l=e;return}function xJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;e=l;l=l+16|0;d=e;ID(a,d);d=c[d>>2]|0;b=a+528|0;a=0;while(1){if((a|0)==(d|0))break;g=b;g=z0(c[g>>2]|0,c[g+4>>2]|0,2,0)|0;f=b;c[f>>2]=g;c[f+4>>2]=z;a=a+1|0}l=e;return}function yJ(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;i=a+4|0;j=c[i>>2]|0;g=j-f|0;h=g>>1;a=d+(h<<1)|0;f=j;while(1){if(a>>>0>=e>>>0)break;b[f>>1]=b[a>>1]|0;k=f+2|0;c[i>>2]=k;a=a+2|0;f=k}if(h|0)TR(j+(0-h<<1)|0,d|0,g|0)|0;return}function zJ(a){a=a|0;switch(c[a+908>>2]|0){case 0:{if(vk(a)|0)a=1;else{c[a+612>>2]=0;a=He(a)|0}break}case 4:{a=He(a)|0;break}case 5:{a=vk(a)|0;break}default:a=1}return a|0}function AJ(d){d=d|0;var e=0,f=0;Eg(d);c[d>>2]=39384;f=d+760|0;e=d+770|0;d=d+782|0;c[f>>2]=0;c[f+4>>2]=0;a[f+8>>0]=0;b[e>>1]=0;b[e+2>>1]=0;b[e+4>>1]=0;b[e+6>>1]=0;b[e+8>>1]=0;a[e+10>>0]=0;b[d>>1]=0;b[d+2>>1]=0;b[d+4>>1]=0;a[d+6>>0]=0;return}function BJ(a){a=a|0;var b=0;GC(a);Bx(a);b=a+648|0;A6(c[b>>2]|0);d4(c[b>>2]|0,6);d4(c[b>>2]|0,33);wK(a);J3(a);return}function CJ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if(d8(a,c[b+8>>2]|0)|0)gx(b,d,e,f);else{a=c[a+8>>2]|0;sb[c[(c[a>>2]|0)+20>>2]&15](a,b,d,e,f,g)}return}function DJ(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,i=0,j=0;h=(FD(d)|0)+1|0;i=iaa(h>>>0>1073741823?-1:h<<2)|0;g=0;while(1){if((g|0)==(h|0))break;j=a[d+g>>0]|0;f=j&255;if((j&255)>159)f=e[61594+(f+-160<<1)>>1]|0;c[i+(g<<2)>>2]=f;g=g+1|0}v$(b,i)|0;jaa(i);return b|0}function EJ(a){a=a|0;var b=0,d=0,e=0;d=l;l=l+16|0;b=d;TX(b);e=a+536|0;Ko(a,c[e>>2]|0,c[e+4>>2]|0,b);if(qO(a)|0)k1((c[a+760>>2]|0)+16|0,b)|0;z5(b);l=d;return}function FJ(b){b=b|0;var d=0,e=0;d=c[b+612>>2]|0;do if((d+4|0)>>>0>(c[b+548>>2]|0)>>>0)b=0;else{e=c[b+544>>2]|0;if(((a[e+d>>0]|0)==0?(a[e+(d+1)>>0]|0)==0:0)?(a[e+(d+2)>>0]|0)==1:0){b=Yq(b)|0;break}a[b+376>>0]=0;b=1}while(0);return b|0}function GJ(a){a=a|0;var b=0;b=a+4|0;iz(c[b>>2]|0);c[a+8>>2]=0;c[a>>2]=b;c[b>>2]=0;return}function HJ(b){b=b|0;var c=0,d=0;switch(a[b+2464>>0]|0){case 2:case 1:{d=1;break}case 3:{d=2;break}case 6:case 5:case 4:{d=3;break}case 7:{d=4;break}default:d=0}c=0;while(1){if((c|0)>=(d|0))break;GC(b);J3(b);c=c+1|0}return}function IJ(a){a=a|0;var b=0;b=ZW(760)|0;Ow(b|0,0,760)|0;M4(b);aY(a,b);Kc(b,3,-1)|0;RB(b,3,0,18,378185,-1,1,0);RB(b,3,0,37,378185,-1,1,0);return b|0}function JJ(b){b=b|0;var d=0,e=0;d=c[b+612>>2]|0;do if((d+4|0)>>>0>(c[b+548>>2]|0)>>>0)b=0;else{e=c[b+544>>2]|0;if(((a[e+d>>0]|0)==0?(a[e+(d+1)>>0]|0)==0:0)?(a[e+(d+2)>>0]|0)==1:0){b=xq(b)|0;break}a[b+376>>0]=0;b=1}while(0);return b|0}function KJ(a){a=a|0;var b=0;b=ZW(760)|0;Ow(b|0,0,760)|0;M4(b);aY(a,b);Kc(b,2,-1)|0;RB(b,2,0,18,378162,-1,1,0);RB(b,2,0,52,378162,-1,1,0);return b|0}function LJ(a){a=a|0;var b=0;b=ZW(760)|0;Ow(b|0,0,760)|0;M4(b);aY(a,b);Kc(b,3,-1)|0;RB(b,3,0,18,388155,-1,1,0);RB(b,3,0,37,388155,-1,1,0);return b|0}function MJ(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0;f=+B(b)>=1.0?(b>0.0?~~+P(+A(b/4294967296.0),4294967295.0)>>>0:~~+N((b-+(~~b>>>0))/4294967296.0)>>>0):0;e=+B(d)>=1.0?(d>0.0?~~+P(+A(d/4294967296.0),4294967295.0)>>>0:~~+N((d-+(~~d>>>0))/4294967296.0)>>>0):0;_Y(c[a>>2]|0,~~b>>>0,f,~~d>>>0,e);return}function NJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;g=l;l=l+16|0;f=g;do if(!d){c[e>>2]=0;b=0}else{if((a[b>>0]|0)>=0){c[e>>2]=1;b=a[b>>0]|0;break}b=fq(f,b,d)|0;if((b|0)<0){c[e>>2]=1;b=-1}else{c[e>>2]=b;b=c[f>>2]|0}}while(0);l=g;return b|0}function OJ(a,b){a=a|0;b=b|0;var d=0,e=0;e=l;l=l+16|0;d=e;W0(d,407712);if(!(c[101703]|0))eI();s7(c[d>>2]|0);d=cK(406804,a,b)|0;l=e;return d|0}function PJ(a){a=a|0;var b=0;b=ZW(760)|0;Ow(b|0,0,760)|0;M4(b);aY(a,b);Kc(b,3,-1)|0;RB(b,3,0,18,387906,-1,1,0);RB(b,3,0,37,387906,-1,1,0);return b|0}function QJ(a){a=a|0;var b=0,d=0,e=0,f=0;bD(a,a+996|0);f=a+528|0;e=c[f>>2]|0;f=c[f+4>>2]|0;d=a+536|0;b=c[d>>2]|0;d=c[d+4>>2]|0;if(d>>>0>f>>>0|(d|0)==(f|0)&b>>>0>e>>>0){f=D_(b|0,d|0,e|0,f|0)|0;e1(a,f,z)}return}function RJ(a){a=a|0;var b=0,d=0,e=0;e=a+528|0;d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,4,0)|0;b=z;c[e>>2]=d;c[e+4>>2]=b;e=a+536|0;b=D_(c[e>>2]|0,c[e+4>>2]|0,d|0,b|0)|0;EU(a,b,z,a+772|0);return}function SJ(b){b=b|0;var d=0,e=0;d=c[b+612>>2]|0;do if((d+4|0)>>>0>(c[b+548>>2]|0)>>>0)b=0;else{e=c[b+544>>2]|0;if(((a[e+d>>0]|0)==0?(a[e+(d+1)>>0]|0)==0:0)?(a[e+(d+2)>>0]|0)==1:0){b=Tq(b)|0;break}a[b+376>>0]=0;b=1}while(0);return b|0}function TJ(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;iX(b,a);if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){k1(a+784|0,b)|0;fc(a);Cn(a)}z5(b);l=d;return}function UJ(a,b){a=a|0;b=b|0;var d=0,e=0;e=l;l=l+16|0;d=e;W0(d,407712);if(!(c[101717]|0))fI();s7(c[d>>2]|0);d=cK(406860,a,b)|0;l=e;return d|0}function VJ(a){a=a|0;var b=0;b=ZW(760)|0;Ow(b|0,0,760)|0;M4(b);aY(a,b);Kc(b,1,-1)|0;RB(b,1,0,58,391354,-1,1,0);RB(b,1,0,18,391354,-1,1,0);return b|0}function WJ(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=ZW(20)|0;c[d>>2]=g;c[d+4>>2]=e+4;b[g+14>>1]=b[c[f>>2]>>1]|0;b[g+16>>1]=0;a[d+8>>0]=1;return}function XJ(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=ZW(24)|0;c[d>>2]=g;c[d+4>>2]=e+4;b[g+16>>1]=b[c[f>>2]>>1]|0;c[g+20>>2]=0;a[d+8>>0]=1;return}function YJ(a,b){a=a|0;b=b|0;saa(410956)|0;while(1){if((c[a>>2]|0)!=1)break;oa(410984,410956)|0}if(!(c[a>>2]|0)){c[a>>2]=1;saa(410956)|0;W$(b);saa(410956)|0;c[a>>2]=-1;saa(410956)|0;saa(410984)|0}else saa(410956)|0;return}function ZJ(b){b=b|0;var d=0,e=0,f=0;d=l;l=l+16|0;e=d;f=b+520|0;c[f>>2]=-1;c[f+4>>2]=-1;c[b+772>>2]=-1;a[b+1038>>0]=1;c[e>>2]=-1;c[(jF(b+760|0,e)|0)+12>>2]=1635083379;eq(b);l=d;return}function _J(a){a=a|0;var b=0;b=ZW(760)|0;Ow(b|0,0,760)|0;M4(b);aY(a,b);Kc(b,3,-1)|0;RB(b,3,0,18,378158,-1,1,0);RB(b,3,0,37,378158,-1,1,0);return b|0}function $J(a){a=a|0;var b=0;b=ZW(760)|0;Ow(b|0,0,760)|0;M4(b);aY(a,b);Kc(b,3,-1)|0;RB(b,3,0,18,391388,-1,1,0);RB(b,3,0,37,391388,-1,1,0);return b|0}function aK(a){a=a|0;var b=0;b=ZW(760)|0;Ow(b|0,0,760)|0;M4(b);aY(a,b);Kc(b,2,-1)|0;RB(b,2,0,18,391465,-1,1,0);RB(b,2,0,52,391465,-1,1,0);return b|0}function bK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(24)|0;c[b>>2]=f;c[b+4>>2]=d+4;a[f+16>>0]=a[c[e>>2]>>0]|0;c[f+20>>2]=0;a[b+8>>0]=1;return}function cK(a,b,d){a=a|0;b=b|0;d=d|0;b=Cv(a,b)|0;if((b|0)==(a+4|0))return 408456;else{a=c[b+28>>2]|0;return ((((c[b+32>>2]|0)-a|0)/12|0)>>>0>d>>>0?a+(d*12|0)|0:408456)|0}return 0}function dK(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;g=l;l=l+256|0;f=g;if((c|0)>(d|0)&(e&73728|0)==0){c=c-d|0;Ow(f|0,b|0,(c>>>0<256?c:256)|0)|0;if(c>>>0>255){d=c;do{_3(a,f,256);d=d+-256|0}while(d>>>0>255);c=c&255}_3(a,f,c)}l=g;return}function eK(a){a=a|0;var b=0;b=a+4|0;Nz(c[b>>2]|0);c[a+8>>2]=0;c[a>>2]=b;c[b>>2]=0;return}function fK(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;e=b+544|0;f=b+612|0;d=c[b+548>>2]|0;g=c[f>>2]|0;while(1){if(g>>>0>=d>>>0)break;if(a[(c[e>>2]|0)+g>>0]|0)break;h=g+1|0;c[f>>2]=h;g=h}if((g+6|0)>>>0>d>>>0)d=0;else d=ng(b)|0;return d|0}function gK(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Zf(b,d,e,f,4)|0;if(!(c[e>>2]&4)){if((d|0)<69)d=d+2e3|0;else d=(d|0)<100?d+1900|0:d;c[a>>2]=d+-1900}return}function hK(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Af(b,d,e,f,4)|0;if(!(c[e>>2]&4)){if((d|0)<69)d=d+2e3|0;else d=(d|0)<100?d+1900|0:d;c[a>>2]=d+-1900}return}function iK(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;f=l;l=l+16|0;e=f;e1(b,c,d);if(qO(b)|0){a[b+820>>0]=14;VU(e,375364);vF(b+792|0,e)|0;z5(e);PU(b+836|0,7)|0}l=f;return}function jK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a:do if(!d){b=a;d=0}else{g=a;while(1){e=c[b>>2]|0;if(!e){b=g;break a}d=d+-1|0;f=g+4|0;c[g>>2]=e;if(!d){b=f;d=0;break}else{b=b+4|0;g=f}}}while(0);xX(b,0,d)|0;return a|0}function kK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(24)|0;c[b>>2]=f;c[b+4>>2]=d+4;c[f+16>>2]=c[c[e>>2]>>2];c[f+20>>2]=0;a[b+8>>0]=1;return}function lK(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;d=b;TX(d);e=a+536|0;jZ(a,c[e>>2]|0,c[e+4>>2]|0,d);Mc(a,c[a+16>>2]|0,c[a+20>>2]|0,380183,d,0);z5(d);l=b;return}function mK(a){a=a|0;var b=0,d=0,e=0;e=l;l=l+16|0;d=e;KK(a);KK(a);ID(a,d);d=c[d>>2]|0;b=0;while(1){if((b|0)==(d|0))break;KK(a);b=b+1|0}l=e;return}function nK(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;b=(c[d>>2]|0)+24|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function oK(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0;i=l;l=l+16|0;j=i;oT(j,e,f,g);zb(a,b,c,d,tP(j)|0,h);z5(j);l=i;return}function pK(a){a=a|0;var b=0,d=0,e=0;b=c[a+992>>2]|0;e=c[(c[a+976>>2]|0)+((c[a+988>>2]|0)*12|0)>>2]|0;d=e+(b*24|0)+8|0;b=((c[e+(b*24|0)+12>>2]|0)-(c[d>>2]|0)|0)/24|0;c[a+996>>2]=b;oC(d,b+1|0);return}function qK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;f=l;l=l+16|0;b=f;e=a+16|0;g=e;if(((c[g>>2]|0)==-1?(c[g+4>>2]|0)==-1:0)?(d=c[a+32>>2]|0,d|0):0){KA(b,d);b=b+8|0;d=c[b+4>>2]|0;g=e;c[g>>2]=c[b>>2];c[g+4>>2]=d}l=f;return}function rK(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;iX(b,a);if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)Mc(a,c[a+16>>2]|0,c[a+20>>2]|0,384512,b,1);z5(b);l=d;return}function sK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=a+136|0;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!((d|0)==-1&(e|0)==-1)){f=b+136|0;c[f>>2]=d;c[f+4>>2]=e}d=a+144|0;a=c[d>>2]|0;d=c[d+4>>2]|0;if(!((a|0)==-1&(d|0)==-1)){f=b+144|0;c[f>>2]=a;c[f+4>>2]=d}return}function tK(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);e=a+536|0;d=a+528|0;d=D_(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;iF(a,d,z);l=b;return}function uK(a){a=a|0;var b=0,d=0;d=a+528|0;b=a+536|0;if(!((c[d>>2]|0)==(c[b>>2]|0)?(c[d+4>>2]|0)==(c[b+4>>2]|0):0))t4(a);if(qO(a)|0){s_(a);AR(a,176,0)}return}function vK(a){a=a|0;var b=0,c=0;b=a&65535;a=0;c=0;while(1){if((c|0)==16)break;a:do if(1<<15-c&b)switch((c&255)<<24>>24){case 11:case 10:case 9:case 6:case 5:{a=(a&255)+2&255;break a}default:{a=a+1<<24>>24;break a}}while(0);c=c+1|0}return a|0}function wK(a){a=a|0;var b=0,d=0,e=0;b=a+648|0;D4(c[b>>2]|0);b=c[b>>2]|0;d=b7(c[b+4>>2]|0,c[b+8>>2]|0)|0;a=a+528|0;e=a;d=z0(c[e>>2]|0,c[e+4>>2]|0,d|0,0)|0;c[a>>2]=d;c[a+4>>2]=z;YZ(b,0,0);return}function xK(a){a=a|0;var c=0,d=0;d=l;l=l+16|0;c=d+4|0;bB(a,d+6|0);jB(a,d);NB(a,c);if(qO(a)|0)kL(a,0,0,253,b[c>>1]|0,10,0);l=d;return}function yK(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;e=XZ(c|0,d|0,48)|0;a[b>>0]=e;e=XZ(c|0,d|0,40)|0;a[b+1>>0]=e;a[b+2>>0]=d;e=XZ(c|0,d|0,24)|0;a[b+3>>0]=e;e=XZ(c|0,d|0,16)|0;a[b+4>>0]=e;d=XZ(c|0,d|0,8)|0;a[b+5>>0]=d;a[b+6>>0]=c;return}function zK(a){a=a|0;var d=0,e=0,f=0,g=0;g=a+528|0;f=c[g>>2]|0;g=c[g+4>>2]|0;e=a+536|0;d=c[e>>2]|0;e=c[e+4>>2]|0;if(e>>>0>g>>>0|(e|0)==(g|0)&d>>>0>f>>>0?(g=D_(d|0,e|0,f|0,g|0)|0,b[a+770>>1]=g,!((g&65535|0)==0&0==0)):0)Ao(a);return}function AK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;e=a+784|0;f=a+788|0;b=0;while(1){a=c[f>>2]|0;g=c[e>>2]|0;d=g;if(b>>>0>=a-g>>2>>>0)break;a=c[d+(b<<2)>>2]|0;if(a|0)laa(a);b=b+1|0}while(1){if((a|0)==(d|0))break;g=a+-4|0;c[f>>2]=g;a=g}return}function BK(a){a=a|0;var b=0;b=c[a+32>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);jaa(c[a+84>>2]|0);u_(a+112|0);IT(a+88|0);aU(a);return}function CK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=a+528|0;d=b;d=z0(c[d>>2]|0,c[d+4>>2]|0,16,0)|0;e=z;f=a+536|0;g=c[f+4>>2]|0;if(e>>>0>g>>>0|((e|0)==(g|0)?d>>>0>(c[f>>2]|0)>>>0:0))vt(a);else{g=b;c[g>>2]=d;c[g+4>>2]=e}return}function DK(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;h=l;l=l+16|0;g=h;GC(b);f=0;while(1){if((f|0)<=-1)break;xR(b,1,g);f=a[(d[g>>0]|0)+((c[e>>2]|0)+(f<<1))>>0]|0}J3(b);l=h;return}function EK(b){b=b|0;var d=0;c[b>>2]=10112;if(a[b+12>>0]|0){d=c[b+4>>2]|0;if(d|0){aN(d);laa(d)}d=c[b+8>>2]|0;if(d|0){GM(d);laa(d)}}z5(b+28|0);return}function FK(a,b){a=a|0;b=b|0;var d=0,e=0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;d=b+4|0;e=(c[d>>2]|0)-(c[b>>2]|0)>>1;if(e|0){kW(a,e);KR(a,c[b>>2]|0,c[d>>2]|0)}return}function GK(a,b){a=a|0;b=b|0;var d=0,e=0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;d=b+4|0;e=(c[d>>2]|0)-(c[b>>2]|0)>>2;if(e|0){QV(a,e);LR(a,c[b>>2]|0,c[d>>2]|0)}return}function HK(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;b=(c[d>>2]|0)+24|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function IK(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if(c|0){if((d|0)==-1){d=0;while(1)if(!(a[c+d>>0]|0))break;else d=d+2|0}else d=d&-2;e=iaa(d+2|0)|0;no(e|0,c|0,d|0)|0;a[e+d>>0]=0;a[e+(d|1)>>0]=0;NC(b,e)|0;jaa(e)}return b|0}function JK(a){a=a|0;var b=0,d=0;b=an(a)|0;d=z;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){a=(kE(a+760|0,a+840|0)|0)+128|0;c[a>>2]=b;c[a+4>>2]=d}return}function KK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=a+528|0;d=b;d=z0(c[d>>2]|0,c[d+4>>2]|0,4,0)|0;e=z;f=a+536|0;g=c[f+4>>2]|0;if(e>>>0>g>>>0|((e|0)==(g|0)?d>>>0>(c[f>>2]|0)>>>0:0))vt(a);else{g=b;c[g>>2]=d;c[g+4>>2]=e}return}function LK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=a+528|0;d=b;d=z0(c[d>>2]|0,c[d+4>>2]|0,3,0)|0;e=z;f=a+536|0;g=c[f+4>>2]|0;if(e>>>0>g>>>0|((e|0)==(g|0)?d>>>0>(c[f>>2]|0)>>>0:0))vt(a);else{g=b;c[g>>2]=d;c[g+4>>2]=e}return}function MK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=a+528|0;d=b;d=z0(c[d>>2]|0,c[d+4>>2]|0,2,0)|0;e=z;f=a+536|0;g=c[f+4>>2]|0;if(e>>>0>g>>>0|((e|0)==(g|0)?d>>>0>(c[f>>2]|0)>>>0:0))vt(a);else{g=b;c[g>>2]=d;c[g+4>>2]=e}return}function NK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=a+528|0;d=b;d=z0(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;e=z;f=a+536|0;g=c[f+4>>2]|0;if(e>>>0>g>>>0|((e|0)==(g|0)?d>>>0>(c[f>>2]|0)>>>0:0))vt(a);else{g=b;c[g>>2]=d;c[g+4>>2]=e}return}function OK(a){a=a|0;var b=0,d=0;b=an(a)|0;d=z;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){a=(kE(a+760|0,a+840|0)|0)+144|0;c[a>>2]=b;c[a+4>>2]=d}return}function PK(a){a=a|0;var b=0,d=0,e=0,f=0;d=jF(a+760|0,a+772|0)|0;e=d+4|0;b=0;while(1){f=c[d>>2]|0;if(b>>>0>=(c[e>>2]|0)-f>>2>>>0)break;aY(a,c[f+(b<<2)>>2]|0);b=b+1|0}return}function QK(a){a=a|0;var b=0,d=0;b=an(a)|0;d=z;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){a=(kE(a+760|0,a+840|0)|0)+136|0;c[a>>2]=b;c[a+4>>2]=d}return}function RK(a){a=a|0;var b=0,d=0;b=an(a)|0;d=z;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){a=(kE(a+760|0,a+840|0)|0)+152|0;c[a>>2]=b;c[a+4>>2]=d}return}function SK(a){a=a|0;var b=0,d=0,e=0;qy(a,a+884|0);e=a+48|0;e=z0(c[a+612>>2]|0,0,c[e>>2]|0,c[e+4>>2]|0)|0;d=z;b=HN(a,0)|0;b=z0(e|0,d|0,b|0,z|0)|0;a=a+1024|0;c[a>>2]=b;c[a+4>>2]=z;return}function TK(b){b=b|0;var d=0,e=0,f=0,g=0;d=c[b>>2]|0;do if(d|0){e=b+4|0;f=c[e>>2]|0;while(1){if((f|0)==(d|0))break;g=f+-4|0;c[e>>2]=g;f=g}if((b+16|0)==(d|0)){a[b+128>>0]=0;break}else{laa(d);break}}while(0);return}function UK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;h=i;d=0;e=8;f=8;while(1){if((d|0)==(b|0))break;if(!e)g=0;else{o3(a,h);g=(c[h>>2]|0)+f&255}d=d+1|0;e=g;f=(g|0)==0?f:g}l=i;return}function VK(a,d){a=a|0;d=d|0;var e=0,f=0;f=l;l=l+16|0;e=f;GC(a);n3(a,e);J3(a);if(qO(a)|0)b[d+36>>1]=c[e>>2];l=f;return}function WK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;g=a+8|0;e=c[g>>2]|0;a=b;f=e;while(1){j=d;i=c[j+4>>2]|0;h=f;c[h>>2]=c[j>>2];c[h+4>>2]=i;a=a+-1|0;if(!a)break;else f=f+8|0}c[g>>2]=e+(b<<3);return}function XK(a){a=a|0;var b=0,d=0;b=an(a)|0;d=z;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){a=(kE(a+760|0,a+840|0)|0)+104|0;c[a>>2]=b;c[a+4>>2]=d}return}function YK(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;i=c[a+4>>2]|0;h=i>>8;if(i&1)h=c[(c[e>>2]|0)+h>>2]|0;a=c[a>>2]|0;sb[c[(c[a>>2]|0)+20>>2]&15](a,b,d,e+h|0,i&2|0?f:2,g);return}function ZK(a){a=a|0;var b=0;if(a|0)return TE(a)|0;if(!(c[12860]|0))a=0;else a=ZK(c[12860]|0)|0;taa();b=c[102272]|0;if(b)do{if((c[b+20>>2]|0)>>>0>(c[b+28>>2]|0)>>>0)a=TE(b)|0|a;b=c[b+56>>2]|0}while((b|0)!=0);paa();return a|0}function _K(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;HC(b,c);a[b+12>>0]=d;a[b+13>>0]=e;a[b+14>>0]=f;a[b+15>>0]=g;return}function $K(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;b=b&255;e=a+652|0;f=c[e>>2]|0;if(b>>>0>(nb[c[(c[f>>2]|0)+20>>2]&255](f)|0)>>>0){vt(a);b=0}else{f=c[e>>2]|0;b=tb[c[(c[f>>2]|0)+12>>2]&31](f,b)|0}c[d>>2]=b;return}function aL(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;i=h;oT(i,e,f,10);Mc(a,b,c,d,tP(i)|0,g);z5(i);l=h;return}function bL(a){a=a|0;var b=0,d=0;a=a+8|0;b=a0(c[a>>2]|0)|0;d=fq(0,0,4)|0;if(b|0)a0(b)|0;if(!d){a=c[a>>2]|0;if(!a)a=1;else{b=a0(a)|0;a=m9()|0;if(b|0)a0(b)|0;return (a|0)==1|0}}else a=-1;return a|0}function cL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;b=b&127;d=a+8|0;if(b>>>0<64){b=PZ(1,0,b|0)|0;e=a;d=c[e+4>>2]|z;c[a>>2]=c[e>>2]|b;c[a+4>>2]=d}else{b=PZ(1,0,b+-64|0)|0;f=d;a=c[f+4>>2]|z;e=d;c[e>>2]=c[f>>2]|b;c[e+4>>2]=a}return}function dL(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);e=a+536|0;d=a+528|0;d=D_(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;e1(a,d,z);l=b;return}function eL(a){a=a|0;switch(a<<24>>24){case 0:{a=386435;break}case 1:{a=386426;break}case 2:{a=386396;break}case 3:{a=386373;break}case 4:{a=386368;break}case 5:{a=386354;break}case 6:{a=386347;break}case 15:{a=385637;break}default:a=391133}return a|0}function fL(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;T7(b);b=(c[d>>2]|0)+16|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function gL(a){a=a|0;var b=0;Bx(a);b=a+648|0;d4(c[b>>2]|0,2);d4(c[b>>2]|0,22);d4(c[b>>2]|0,2);d4(c[b>>2]|0,22);wK(a);return}function hL(a,b){a=a|0;b=b|0;var d=0,e=0;e=l;l=l+16|0;d=e;qe(d,b);c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}z5(d);l=e;return}function iL(a,b){a=a|0;b=b|0;var d=0;a=a+4|0;d=TM(b,c[a>>2]|0,a)|0;if((d|0)!=(a|0)?(e[d+14>>1]|0)<=(b&65535):0)a=d;return a|0}function jL(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;i=h;qU(i,e,f);zb(a,b,c,d,tP(i)|0,g);z5(i);l=h;return}function kL(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;i=h;rU(i,e,f);zb(a,b,c,d,tP(i)|0,g);z5(i);l=h;return}function lL(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;i=h;sU(i,e,f);zb(a,b,c,d,tP(i)|0,g);z5(i);l=h;return}function mL(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;i=h;uU(i,e,f);zb(a,b,c,d,tP(i)|0,g);z5(i);l=h;return}function nL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(40)|0;c[b>>2]=f;c[b+4>>2]=d+4;h0(f+16|0,e);a[b+8>>0]=1;return}function oL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=l;l=l+16|0;d=e;e1(a,b,c);if(qO(a)|0){VU(d,375371);vF(a+792|0,d)|0;z5(d);PU(a+836|0,8)|0}l=e;return}function pL(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;e=l;l=l+16|0;d=e;e1(a,b,c);if(qO(a)|0){VU(d,375364);vF(a+792|0,d)|0;z5(d);PU(a+836|0,5)|0}l=e;return}function qL(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;KK(a);KK(a);ID(a,b);a=a+528|0;d=a;d=z0(c[d>>2]|0,c[d+4>>2]|0,4,0)|0;c[a>>2]=d;c[a+4>>2]=z;l=b;return}function rL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Zf(b,d,e,f,2)|0;b=c[e>>2]|0;if((d+-1|0)>>>0<12&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function sL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Af(b,d,e,f,2)|0;b=c[e>>2]|0;if((d+-1|0)>>>0<12&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function tL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(a-b>>2>>>0>=d>>>0){if(d|0){e=a;while(1){d=d+-1|0;c[e>>2]=c[b>>2];if(!d)break;else{b=b+4|0;e=e+4|0}}}}else do{d=d+-1|0;c[a+(d<<2)>>2]=c[b+(d<<2)>>2]}while((d|0)!=0);return a|0}function uL(b){b=b|0;var d=0,e=0,f=0;d=l;l=l+16|0;f=d;e=d+4|0;bD(b,f);pY(c[f>>2]|0,0,1,e);RB(b,2,c[b+20>>2]|0,110,a[e>>0]|0?384435:384431,-1,1,0);l=d;return}function vL(b){b=b|0;var d=0,e=0;if(Hi(b)|0)if(!(a[b+733>>0]|0)){jb[c[(c[b>>2]|0)+72>>2]&511](b);e=b+48|0;d=c[e+4>>2]|0;b=b+56|0;c[b>>2]=c[e>>2];c[b+4>>2]=d;b=1}else b=1;else b=0;return b|0}function wL(a,b,d){a=a|0;b=b|0;d=d|0;var f=0,g=0,h=0;g=c[12784]|0;h=a+16|0;Za(h|0);c[12784]=0;f=az(a)|0;a=c[12784]|0;if(!a){c[12784]=g;if(!f)a=0;else{no(b|0,f|0,e[f+8>>1]|0|0)|0;a=b}Ua(h|0);c[d>>2]=a;a=0}else Ua(h|0);return a|0}function xL(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;T7(b);b=(c[d>>2]|0)+16|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function yL(a){a=a|0;var b=0;GC(a);b=a+788|0;ID(a,b);bB(a,a+806|0);J3(a);if(qO(a)|0?(c[b>>2]|0)>>>0<640:0)U5(a);return}function zL(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;VU(d,383567);BZ(c[a+508>>2]|0,c[a+668>>2]|0,0,0);z5(d);d=a+536|0;Op(a,c[d>>2]|0,c[d+4>>2]|0);l=b;return}function AL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+32|0;g=f;e=f+20|0;c[g>>2]=c[a+60>>2];c[g+4>>2]=0;c[g+8>>2]=b;c[g+12>>2]=e;c[g+16>>2]=d;if((b6(ab(140,g|0)|0)|0)<0){c[e>>2]=-1;a=-1}else a=c[e>>2]|0;l=f;return a|0}function BL(a){a=a|0;var b=0;b=a+4|0;xD(c[b>>2]|0);c[a+8>>2]=0;c[a>>2]=b;c[b>>2]=0;return}function CL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;h=l;l=l+16|0;g=h;if((b|e|0)==0&(d|f|0)==0)dX(a,b,d,e,f);else{d=D_(0,0,b|0,d|0)|0;b=g;c[b>>2]=~e;c[b+4>>2]=~f;JV(a,d,z,g)}l=h;return}function DL(b){b=b|0;var d=0,e=0;d=an(b)|0;e=z;if(qO(b)|0?(c[b+880>>2]|0)>>>0<=1:0)a[(kE(b+760|0,b+840|0)|0)+67>>0]=((d|0)!=0|(e|0)!=0)&1;return}function EL(d){d=d|0;Eg(d);c[d>>2]=23760;IX(d+72|0,375426)|0;a[d+493>>0]=1;c[d+760>>2]=7;c[d+764>>2]=-1;a[d+768>>0]=0;a[d+769>>0]=0;c[d+772>>2]=0;b[d+776>>1]=0;c[d+780>>2]=0;a[d+784>>0]=0;return}function FL(){var b=0,d=0,e=0;b=(a[51023]|0)==10;do if((c[12756]|0)<0){if(!b?(d=c[12742]|0,d>>>0<(c[12741]|0)>>>0):0){c[12742]=d+1;a[d>>0]=10;break}JD()|0}else{if(!b?(e=c[12742]|0,e>>>0<(c[12741]|0)>>>0):0){c[12742]=e+1;a[e>>0]=10;break}JD()|0}while(0);return}function GL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Zf(b,d,e,f,2)|0;b=c[e>>2]|0;if((d+-1|0)>>>0<31&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function HL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Zf(b,d,e,f,3)|0;b=c[e>>2]|0;if((d|0)<366&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function IL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Af(b,d,e,f,2)|0;b=c[e>>2]|0;if((d+-1|0)>>>0<31&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function JL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Af(b,d,e,f,3)|0;b=c[e>>2]|0;if((d|0)<366&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function KL(b){b=b|0;var d=0,e=0;d=an(b)|0;e=z;if(qO(b)|0?(c[b+880>>2]|0)>>>0<=1:0)a[(kE(b+760|0,b+840|0)|0)+68>>0]=((d|0)!=0|(e|0)!=0)&1;return}function LL(a){a=a|0;gz(c[a+4>>2]|0);return}function ML(a){a=a|0;switch(a|0){case 1270:case 1256:{a=384095;break}case 1271:case 1250:case 1241:case 1235:{a=384091;break}case 1272:case 1251:case 1243:case 1238:{a=384088;break}case 1273:case 1252:case 1242:case 1237:{a=384085;break}case 1274:case 1253:{a=384082;break}default:a=8800948}return a|0}function NL(a){a=a|0;var b=0;if(!(c[a+728>>2]&1)){W5(a);RB(a,0,0,57,379741,-1,1,0);c[a+1052>>2]=1;c[a+624>>2]=67108864}else{b=HN(a,0)|0;e1(a,b,z)}return}function OL(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;VU(d,388036);BZ(c[a+508>>2]|0,c[a+668>>2]|0,0,0);z5(d);d=a+536|0;Op(a,c[d>>2]|0,c[d+4>>2]|0);l=b;return}function PL(a){a=a|0;var b=0;b=c[a>>2]|0;if(b|0){VZ(b);laa(b)}b=c[a+4>>2]|0;if(b|0){VZ(b);laa(b)}b=c[a+8>>2]|0;if(b|0)laa(b);return}function QL(a){a=a|0;var b=0,d=0,e=0,f=0;if(!(YV(a)|0)){b=c[a+28>>2]|0;d=b+56|0;e=c[d>>2]|0;f=b+40|0;if(e|0?(c[f>>2]|0)!=15:0){kb[c[a+36>>2]&63](c[a+40>>2]|0,e);c[d>>2]=0}c[b+12>>2]=5;c[f>>2]=15;a=JW(a)|0}else a=-2;return a|0}function RL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;if(d8(a,c[b+8>>2]|0)|0)jG(b,d,e);else{a=c[a+8>>2]|0;vb[c[(c[a>>2]|0)+28>>2]&15](a,b,d,e)}return}function SL(b){b=b|0;var c=0,d=0;c=l;l=l+16|0;d=c;GC(b);AT(b,d);if(!(a[d>>0]|0))$N(b);else CH(b);J3(b);l=c;return}function TL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Zf(b,d,e,f,2)|0;b=c[e>>2]|0;if((d|0)<13&(b&4|0)==0)c[a>>2]=d+-1;else c[e>>2]=b|4;return}function UL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Af(b,d,e,f,2)|0;b=c[e>>2]|0;if((d|0)<13&(b&4|0)==0)c[a>>2]=d+-1;else c[e>>2]=b|4;return}function VL(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=l;l=l+16|0;h=g;qU(h,d,e);Mc(a,b,c,379845,tP(h)|0,f);z5(h);l=g;return}function WL(b){b=b|0;var d=0,e=0;d=c[b+612>>2]|0;do if((d+4|0)>>>0>(c[b+548>>2]|0)>>>0)b=0;else{e=c[b+544>>2]|0;if(((a[e+d>>0]|0)==0?(a[e+(d+1)>>0]|0)==0:0)?(a[e+(d+2)>>0]&-4)<<24>>24==-128:0){b=1;break}a[b+376>>0]=0;b=1}while(0);return b|0}function XL(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;ID(a,b);if(qO(a)|0){b=c[b>>2]|0;c[(bF(a+916|0,a+788|0)|0)+264>>2]=b}l=d;return}function YL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;a:while(1){if((a|0)==(b|0)){a=b;break}else f=d;while(1){if((f|0)==(e|0))break;if(d8(c[a>>2]|0,c[f>>2]|0)|0)break a;else f=f+4|0}a=a+4|0}return a|0}function ZL(a){a=a|0;var b=0,d=0,e=0;KK(a);e=a+528|0;d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,4,0)|0;b=z;c[e>>2]=d;c[e+4>>2]=b;e=a+536|0;b=D_(c[e>>2]|0,c[e+4>>2]|0,d|0,b|0)|0;e1(a,b,z);return}function _L(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;a:do if(!d)b=0;else{while(1){e=a[b>>0]|0;f=a[c>>0]|0;if(e<<24>>24!=f<<24>>24)break;d=d+-1|0;if(!d){b=0;break a}else{b=b+1|0;c=c+1|0}}b=(e&255)-(f&255)|0}while(0);return b|0}function $L(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Zf(b,d,e,f,1)|0;b=c[e>>2]|0;if((d|0)<7&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function aM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Zf(b,d,e,f,2)|0;b=c[e>>2]|0;if((d|0)<61&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function bM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Zf(b,d,e,f,2)|0;b=c[e>>2]|0;if((d|0)<60&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function cM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Af(b,d,e,f,1)|0;b=c[e>>2]|0;if((d|0)<7&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function dM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Af(b,d,e,f,2)|0;b=c[e>>2]|0;if((d|0)<61&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function eM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Af(b,d,e,f,2)|0;b=c[e>>2]|0;if((d|0)<60&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function fM(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=l;l=l+16|0;h=g;sU(h,e,10);Mc(a,b,c,d,tP(h)|0,f);z5(h);l=g;return}function gM(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;m3(b);b=(c[d>>2]|0)+12|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function hM(d){d=d|0;x1(d+4|0);x1(d+16|0);c[d+28>>2]=0;c[d+32>>2]=0;c[d+36>>2]=0;x1(d+44|0);a[d>>0]=0;b[d+56>>1]=-1;a[d+58>>0]=0;c[d+40>>2]=-1;return}function iM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Zf(b,d,e,f,2)|0;b=c[e>>2]|0;if((d|0)<24&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function jM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Af(b,d,e,f,2)|0;b=c[e>>2]|0;if((d|0)<24&(b&4|0)==0)c[a>>2]=d;else c[e>>2]=b|4;return}function kM(b){b=b|0;var d=0,e=0;Eg(b);c[b>>2]=38628;e=b+776|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[e+(d<<2)>>2]=0;d=d+1|0}e=b+760|0;c[e>>2]=2;c[e+4>>2]=0;h[b+768>>3]=0.0;a[b+805>>0]=-1;return}function lM(a){a=a|0;var b=0,d=0;W5(a);b=a+528|0;d=b;d=z0(c[d>>2]|0,c[d+4>>2]|0,6,0)|0;c[b>>2]=d;c[b+4>>2]=z;if(qO(a)|0){RB(a,0,0,57,380100,-1,1,0);c[a+856>>2]=0}return}function mM(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);d=a+528|0;e=d;e=z0(c[e>>2]|0,c[e+4>>2]|0,4,0)|0;c[d>>2]=e;c[d+4>>2]=z;c[a+784>>2]=0;l=b;return}function nM(b){b=b|0;var d=0,e=0,f=0;e=l;l=l+96|0;d=e+12|0;f=e;pk(f,b);b=vX((a[f+11>>0]|0)<0?c[f>>2]|0:f,d)|0;a1(f);if(!b)b=(c[d+12>>2]&61440|0)==32768;else b=0;l=e;return b|0}function oM(a){a=a|0;var b=0,e=0,f=0,g=0;b=l;l=l+16|0;e=b;f=a+528|0;g=f;g=z0(c[g>>2]|0,c[g+4>>2]|0,1,0)|0;c[f>>2]=g;c[f+4>>2]=z;bB(a,e);e1(a,d[e>>0]|0,0);l=b;return}function pM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+8|0;a=b;while(1){if((a|0)==(d|0))break;Iw(c[e>>2]|0,a);c[e>>2]=(c[e>>2]|0)+56;a=a+56|0}return}function qM(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;h=c[a+4>>2]|0;g=h>>8;if(h&1)g=c[(c[d>>2]|0)+g>>2]|0;a=c[a>>2]|0;hb[c[(c[a>>2]|0)+24>>2]&3](a,b,d+g|0,h&2|0?e:2,f);return}function rM(b){b=b|0;var d=0,e=0,f=0;e=l;l=l+96|0;d=e+12|0;f=e;pk(f,b);b=vX((a[f+11>>0]|0)<0?c[f>>2]|0:f,d)|0;a1(f);if(!b)b=(c[d+12>>2]&61440|0)==16384;else b=0;l=e;return b|0}function sM(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=l;l=l+16|0;h=g;tU(h,e,10);zb(a,b,c,d,tP(h)|0,f);z5(h);l=g;return}function tM(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;d=a+8|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-12|0;c[d>>2]=e;QP(e)}a=c[a>>2]|0;if(a|0)laa(a);return}function uM(a){a=a|0;var b=0;b=PZ(d[a>>0]|0|0,0,8)|0;b=PZ(b|(d[a+1>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+2>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+3>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+4>>0]|0)|0,z|0,8)|0;return b|(d[a+5>>0]|0)|0}function vM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=a[b+11>>0]|0;if(f<<24>>24<0){f=c[b+4>>2]|0;b=c[b>>2]|0}else f=f&255;if(f>>>0>e>>>0){e=MY(b+e|0,f-e|0,d)|0;b=(e|0)==0?-1:e-b|0}else b=-1;return b|0}function wM(a){a=a|0;var b=0.0,c=0,d=0;a=MF(a)|0;c=z;d=XZ(a|0,c|0,52)|0;switch(d&2047){case 0:case 2047:{b=0.0;break}default:{b=((+(a>>>0)+4294967296.0*+((c&1048575)>>>0))*2.220446049250313e-16+1.0)*+eaa(z0(d&2047|0,0,-1023,0)|0);b=(c|0)<0?-b:b}}return +b}function xM(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=l;l=l+16|0;h=g;TX(h);Mc(a,b,c,d,b3(h,e,-1)|0,f);z5(h);l=g;return}function yM(a){a=a|0;c[a>>2]=35308;LT(a+984|0);z5(a+972|0);z5(a+960|0);z5(a+948|0);z5(a+936|0);z5(a+924|0);z5(a+912|0);dU(a+772|0);bt(a);return}function zM(a){a=a|0;var b=0;b=a+4|0;eC(c[b>>2]|0);c[a+8>>2]=0;c[a>>2]=b;c[b>>2]=0;return}function AM(a){a=a|0;var b=0,d=0,e=0,f=0;b=l;l=l+16|0;d=b;e=a+528|0;f=e;f=z0(c[f>>2]|0,c[f+4>>2]|0,4,0)|0;c[e>>2]=f;c[e+4>>2]=z;bD(a,d);e1(a,c[d>>2]|0,0);l=b;return}function BM(a){a=a|0;var b=0,d=0;b=an(a)|0;d=z;if(qO(a)|0?!((b|0)==0&(d|0)==0|(c[a+880>>2]|0)>>>0>1):0)aL(a,c[a+16>>2]|0,c[a+20>>2]|0,379872,b,d,1);return}function CM(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;m3(b);b=(c[d>>2]|0)+12|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function DM(a){a=a|0;var b=0,d=0,e=0,f=0;d=l;l=l+16|0;b=d;q3(a,b);if(qO(a)|0){f=b;e=c[f+4>>2]|0;b=(c[a+1036>>2]|0)+-16|0;c[b>>2]=c[f>>2];c[b+4>>2]=e}l=d;return}function EM(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;d=a+8|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-12|0;c[d>>2]=e;a1(e)}a=c[a>>2]|0;if(a|0)laa(a);return}function FM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+8|0;a=b;while(1){if((a|0)==(d|0))break;yw(c[e>>2]|0,a);c[e>>2]=(c[e>>2]|0)+40;a=a+40|0}return}function GM(a){a=a|0;var b=0,d=0,e=0;b=c[a>>2]|0;if(b|0){d=a+4|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-12|0;c[d>>2]=e;QP(e)}laa(c[a>>2]|0)}return}function HM(a){a=a|0;var b=0;b=a+520|0;if((DB(a+680|0,c[b>>2]|0,c[b+4>>2]|0)|0)==(a+684|0)){t4(a);a=0}else a=1;return a|0}function IM(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a>>2]|0;d=b+4|0;e=c[d>>2]|0;c[a>>2]=e;if(e|0)c[e+8>>2]=a;e=a+8|0;c[b+8>>2]=c[e>>2];f=c[e>>2]|0;c[((c[f>>2]|0)==(a|0)?f:f+4|0)>>2]=b;c[d>>2]=a;c[e>>2]=b;return}function JM(a){a=a|0;var b=0;Bx(a);T5(a);b=a+648|0;A6(c[b>>2]|0);A6(c[b>>2]|0);d4(c[b>>2]|0,2);wK(a);return}function KM(b){b=b|0;var d=0,e=0;d=c[b+728>>2]|0;do if((d&8|0)==0?(e=b+732|0,(a[e>>0]|0)==0):0){if((d&2|0)==0?(jt(b),a[e>>0]|0):0)break;if(!(+g[(c[b+24>>2]|0)+136>>2]>=1.0))wk(b)}while(0);return}function LM(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;d=a+8|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-12|0;c[d>>2]=e;mQ(e)}a=c[a>>2]|0;if(a|0)laa(a);return}function MM(a,b){a=a|0;b=b|0;if((a|0)!=(b|0))hl(a,c[b>>2]|0,b+4|0);return a|0}function NM(a){a=a|0;var b=0,d=0;b=an(a)|0;d=z;if(qO(a)|0){a=(c[(c[a+976>>2]|0)+((c[a+988>>2]|0)*12|0)>>2]|0)+((c[a+992>>2]|0)*24|0)|0;c[a>>2]=b;c[a+4>>2]=d}return}function OM(a){a=a|0;var b=0,d=0,e=0;e=a+28|0;d=a+32|0;b=0;while(1){a=c[e>>2]|0;if(b>>>0>=(c[d>>2]|0)-a>>2>>>0)break;a=c[a+(b<<2)>>2]|0;if(a|0)jb[c[(c[a>>2]|0)+4>>2]&511](a);b=b+1|0}cU(e);return}function PM(a){a=a|0;var b=0;b=a+4|0;tC(c[b>>2]|0);c[a+8>>2]=0;c[a>>2]=b;c[b>>2]=0;return}function QM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;g=c[a+4>>2]|0;f=g>>8;if(g&1)f=c[(c[d>>2]|0)+f>>2]|0;a=c[a>>2]|0;vb[c[(c[a>>2]|0)+28>>2]&15](a,b,d+f|0,g&2|0?e:2);return}function RM(a){a=a|0;var b=0,d=0,e=0;b=an(a)|0;d=z;if(qO(a)|0){e=a+1e3|0;b=z0(c[e>>2]|0,c[e+4>>2]|0,b|0,d|0)|0;d=(c[a+1036>>2]|0)+-8|0;c[d>>2]=b;c[d+4>>2]=z}return}function SM(a){a=a|0;var b=0,d=0,e=0;d=a+728|0;b=c[d>>2]|0;if(b&1){jb[c[(c[a>>2]|0)+56>>2]&511](a);b=c[d>>2]|0}a=b&-5;c[d>>2]=a;b=16;while(1){if((b|0)==32)break;e=a&~(1<<b);c[d>>2]=e;b=b+1|0;a=e}return}function TM(a,b,d){a=a|0;b=b|0;d=d|0;a:while(1){while(1){if(!b)break a;if((e[b+14>>1]|0)>=(a&65535))break;b=c[b+4>>2]|0}d=b;b=c[b>>2]|0}return d|0}function UM(a){a=a|0;var b=0;b=a+4|0;AC(c[b>>2]|0);c[a+8>>2]=0;c[a>>2]=b;c[b>>2]=0;return}function VM(a){a=a|0;var b=0;b=a+4|0;BC(c[b>>2]|0);c[a+8>>2]=0;c[a>>2]=b;c[b>>2]=0;return}function WM(a){a=a|0;var b=0,d=0,e=0;b=c[a>>2]|0;if(b|0){d=a+4|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-12|0;c[d>>2]=e;a1(e)}laa(c[a>>2]|0)}return}function XM(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;iX(b,a);if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)Mc(a,0,0,377532,b,0);z5(b);l=d;return}function YM(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a>>2]|0;if(b|0){d=a+4|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-24|0;c[d>>2]=f;e=f}laa(b);c[a+8>>2]=0;c[d>>2]=0;c[a>>2]=0}return}function ZM(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;iX(b,a);if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)Mc(a,0,0,387686,b,0);z5(b);l=d;return}function _M(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=l;l=l+16|0;g=f;rU(g,e,10);Mc(a,b,c,d,tP(g)|0,0);z5(g);l=f;return}function $M(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=l;l=l+16|0;g=f;tU(g,e,10);Mc(a,b,c,d,tP(g)|0,0);z5(g);l=f;return}function aN(a){a=a|0;var b=0,d=0,e=0;b=c[a>>2]|0;if(b|0){d=a+4|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-12|0;c[d>>2]=e;mQ(e)}laa(c[a>>2]|0)}return}function bN(b){b=b|0;var d=0;Eg(b);c[b>>2]=34660;IX(b+72|0,380977)|0;a[b+733>>0]=1;d=b+632|0;c[d>>2]=65536;c[d+4>>2]=0;a[b+493>>0]=1;d=b+760|0;c[d>>2]=0;c[d+4>>2]=0;a[b+768>>0]=0;return}function cN(a){a=a|0;var b=0,e=0,f=0;GC(a);f=a+22116|0;e=a+648|0;b=0;while(1){if((b&255)>=(d[(c[f>>2]|0)+43>>0]|0))break;A6(c[e>>2]|0);b=b+1<<24>>24}J3(a);return}function dN(b,d){b=b|0;d=+d;var e=0,f=0,h=0;h=l;l=l+16|0;e=h;W0(e,b+264|0);f=b+140|0;if(!(a[f>>0]|0)){g[b+136>>2]=d;a[f>>0]=0}s7(c[e>>2]|0);l=h;return}function eN(a){a=a|0;uy(c[a+4>>2]|0);return}function fN(a){a=a|0;var b=0,d=0,e=0;e=a+4|0;b=c[e>>2]|0;d=c[b>>2]|0;c[e>>2]=d;if(d|0)c[d+8>>2]=a;e=a+8|0;c[b+8>>2]=c[e>>2];d=c[e>>2]|0;c[((c[d>>2]|0)==(a|0)?d:d+4|0)>>2]=b;c[b>>2]=a;c[e>>2]=b;return}function gN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+8|0;a=b;while(1){if((a|0)==(d|0))break;rV(c[e>>2]|0,a);c[e>>2]=(c[e>>2]|0)+12;a=a+12|0}return}function hN(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;iX(b,a);if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)Mc(a,0,0,380183,b,0);z5(b);l=d;return}function iN(a){a=a|0;switch(a<<24>>24){case 0:{a=386623;break}case 1:{a=386590;break}case 2:{a=386553;break}case 3:{a=386515;break}case 4:{a=386471;break}case 5:{a=386454;break}case 15:{a=385637;break}default:a=391133}return a|0}function jN(a){a=a|0;jaa(c[a+72>>2]|0);$3(a+264|0);z5(a+216|0);z5(a+204|0);z5(a+192|0);z5(a+168|0);z5(a+156|0);aU(a+44|0);$_(a+4|0);return}function kN(b){b=b|0;var d=0,e=0,f=0;f=a[b+8+3>>0]|0;e=f<<24>>24<0;if(((e?c[b+4>>2]|0:f&255)|0)==6?(d=e?c[b>>2]|0:b,(c[d>>2]|0)==48):0){b=c[d+4>>2]|0;b=(b|0)==48?388062:(b|0)==49?378175:8800948}else b=8800948;return b|0}function lN(a){a=a|0;c[a>>2]=29848;z5(a+800|0);RO(a+788|0);XQ(a+776|0);WW(a+760|0);bt(a);return}function mN(a){a=a|0;var b=0;b=a+536|0;e1(a,c[b>>2]|0,c[b+4>>2]|0);if(qO(a)|0){W5(a);RB(a,0,0,57,376944,-1,1,0);KM(a)}return}function nN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a:do if(!d)d=0;else{while(1){e=c[a>>2]|0;f=c[b>>2]|0;if((e|0)!=(f|0))break;d=d+-1|0;if(!d){d=0;break a}else{b=b+4|0;a=a+4|0}}d=e-f|0}while(0);return d|0}function oN(a){a=a|0;var b=0,d=0,e=0,f=0;if(!(YV(a)|0)){e=a+28|0;b=c[e>>2]|0;d=c[b+56>>2]|0;f=a+40|0;a=a+36|0;if(d){kb[c[a>>2]&63](c[f>>2]|0,d);b=c[e>>2]|0}kb[c[a>>2]&63](c[f>>2]|0,b);c[e>>2]=0}return}function pN(b){b=b|0;var d=0,e=0;d=b+74|0;e=a[d>>0]|0;a[d>>0]=e+255|e;d=c[b>>2]|0;if(!(d&8)){c[b+8>>2]=0;c[b+4>>2]=0;e=c[b+44>>2]|0;c[b+28>>2]=e;c[b+20>>2]=e;c[b+16>>2]=e+(c[b+48>>2]|0);b=0}else{c[b>>2]=d|32;b=-1}return b|0}function qN(a){a=a|0;var b=0,d=0,e=0;e=l;l=l+16|0;b=e;W0(b,a+12|0);d=a+8|0;switch(c[d>>2]|0){case 3:case 1:{c[a+4>>2]=0;c[d>>2]=4;break}default:{}}s7(c[b>>2]|0);l=e;return}function rN(b){b=b|0;Kc(b,1,-1)|0;RB(b,1,0,18,391360,-1,1,0);RB(b,1,0,58,a[b+769>>0]|0?383843:391360,-1,1,0);sM(b,1,0,195,8,0);return}function sN(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;i=h;ST(i,e,f);Mc(a,b,c,d,i,g);z5(i);l=h;return}function tN(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0;f=l;l=l+16|0;g=f;TX(g);Mc(a,b,c,d,L4(g,e)|0,0);z5(g);l=f;return}function uN(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;VU(d,384424);BZ(c[a+508>>2]|0,c[a+668>>2]|0,0,0);z5(d);Op(a,c[a+548>>2]|0,0);l=b;return}function vN(a){a=a|0;var b=0,d=0,e=0;d=a+528|0;e=d;e=z0(c[e>>2]|0,c[e+4>>2]|0,6,0)|0;b=d;c[b>>2]=e;c[b+4>>2]=z;KK(a);b=d;b=z0(c[b>>2]|0,c[b+4>>2]|0,2,0)|0;a=d;c[a>>2]=b;c[a+4>>2]=z;return}function wN(a){a=a|0;var b=0,d=0,e=0,f=0;e=a+764|0;b=c[e>>2]|0;a=c[a+760>>2]|0;d=a;a:do if((b-a|0)==4){a=c[d>>2]|0;while(1){if((b|0)==(d|0))break a;f=b+-4|0;c[e>>2]=f;b=f}}else a=0;while(0);return a|0}function xN(b,c){b=b|0;c=c|0;var d=0,e=0;d=a[b>>0]|0;e=a[c>>0]|0;if(d<<24>>24==0?1:d<<24>>24!=e<<24>>24)b=e;else{do{b=b+1|0;c=c+1|0;d=a[b>>0]|0;e=a[c>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=e<<24>>24));b=e}return (d&255)-(b&255)|0}function yN(a){a=a|0;var b=0,d=0,e=0;e=a+528|0;d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,4,0)|0;b=z;c[e>>2]=d;c[e+4>>2]=b;e=a+536|0;b=D_(c[e>>2]|0,c[e+4>>2]|0,d|0,b|0)|0;iF(a,b,z);return}function zN(a){a=a|0;var b=0,d=0,e=0,f=0;f=l;l=l+32|0;b=f+16|0;d=f+12|0;e=f;IZ(e,374,0,a);if((c[a>>2]|0)!=-1){c[b>>2]=e;c[d>>2]=b;YJ(a,d)}l=f;return (c[a+4>>2]|0)+-1|0}function AN(a){a=a|0;Oy(c[a+4>>2]|0);return}function BN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;g=l;l=l+32|0;f=g;c[b+36>>2]=8;if((c[b>>2]&64|0)==0?(c[f>>2]=c[b+60>>2],c[f+4>>2]=21523,c[f+8>>2]=g+16,Ta(54,f|0)|0):0)a[b+75>>0]=-1;f=yo(b,d,e)|0;l=g;return f|0}function CN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=ZW(68)|0;c$(e+16|0,d);c[a>>2]=e;d=a+4|0;c[d>>2]=b+4;c[d+4>>2]=1;return}function DN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;f=l;l=l+16|0;e=f;d=c[a>>2]|0;if((((c[a+4>>2]|0)-d|0)/12|0)>>>0<=b>>>0){TX(e);ar(a,e,b);z5(e);d=c[a>>2]|0}l=f;return d+(b*12|0)|0}function EN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;f=c[a>>2]|0;c[a>>2]=c[b>>2];c[b>>2]=f;f=a+4|0;d=b+4|0;e=c[f>>2]|0;c[f>>2]=c[d>>2];c[d>>2]=e;d=a+8|0;b=b+8|0;a=c[d>>2]|0;c[d>>2]=c[b>>2];c[b>>2]=a;return}function FN(a){a=a|0;var b=0;b=a+4|0;VD(c[b>>2]|0);c[a+8>>2]=0;c[a>>2]=b;c[b>>2]=0;return}function GN(a,b){a=a|0;b=b|0;switch(b<<16>>16){case 0:{Xy(a,23688);break}case 1:{Xy(a,23700);break}case 2:{Xy(a,23712);break}case 6:{Xy(a,23724);break}default:rU(a,b,10)}return}function HN(a,b){a=a|0;b=b|0;var d=0,e=0;e=(c[a+668>>2]|0)+(((c[a+508>>2]|0)-b|0)*24|0)+8|0;d=a+48|0;b=c[a+612>>2]|0;a=D_(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;b=D_(a|0,z|0,b|0,0)|0;return b|0}function IN(a){a=a|0;var b=0,d=0;d=a+15&-16|0;b=c[i>>2]|0;a=b+d|0;if((d|0)>0&(a|0)<(b|0)|(a|0)<0){W()|0;Ba(12);return -1}c[i>>2]=a;if((a|0)>(V()|0)?(U()|0)==0:0){c[i>>2]=b;Ba(12);return -1}return b|0}function JN(b,c){b=b|0;c=c|0;var d=0,e=0;d=c&255;if((c&255)>64){z=0;return 0}else{c=(c&255)>32?d+224&255:0;e=tn(b,c)|0;d=tn(b,d-(c&255)&255)|0;c=(a[b+13>>0]|0)==0;z=c?e:0;return (c?d:0)|0}return 0}function KN(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);a=a+528|0;d=a;d=z0(c[d>>2]|0,c[d+4>>2]|0,12,0)|0;c[a>>2]=d;c[a+4>>2]=z;l=b;return}function LN(a){a=a|0;var b=0,e=0,f=0;GC(a);f=a+22116|0;e=a+648|0;b=0;while(1){if((b|0)>=(d[(c[f>>2]|0)+41>>0]|0|0))break;d4(c[e>>2]|0,2);b=b+1|0}J3(a);return}function MN(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=l;l=l+16|0;f=e;uU(f,d,10);Mc(a,b,0,c,tP(f)|0,0);z5(f);l=e;return}function NN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+4|0;a=d-b|0;if((a|0)>0){no(c[e>>2]|0,b|0,a|0)|0;c[e>>2]=(c[e>>2]|0)+(((a>>>0)/24|0)*24|0)}return}function ON(a){a=a|0;var b=0,d=0,e=0;e=a+528|0;d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,4,0)|0;b=z;c[e>>2]=d;c[e+4>>2]=b;e=a+536|0;b=D_(c[e>>2]|0,c[e+4>>2]|0,d|0,b|0)|0;e1(a,b,z);return}function PN(a){a=a|0;var b=0,d=0,e=0;e=a+528|0;d=e;d=z0(c[d>>2]|0,c[d+4>>2]|0,1,0)|0;b=z;c[e>>2]=d;c[e+4>>2]=b;e=a+536|0;b=D_(c[e>>2]|0,c[e+4>>2]|0,d|0,b|0)|0;e1(a,b,z);return}function QN(a){a=a|0;var b=0,d=0,e=0;e=a+4|0;d=0;while(1){b=c[a>>2]|0;if(d>>>0>=(c[e>>2]|0)-b>>2>>>0)break;b=c[b+(d<<2)>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);d=d+1|0}cU(a);return}function RN(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);a=a+528|0;d=a;d=z0(c[d>>2]|0,c[d+4>>2]|0,16,0)|0;c[a>>2]=d;c[a+4>>2]=z;l=b;return}function SN(a){a=a|0;var b=0,d=0;GC(a);d=a+536|0;b=a+528|0;b=D_(c[d>>2]|0,c[d+4>>2]|0,c[b>>2]|0,c[b+4>>2]|0)|0;e1(a,b,z);J3(a);return}function TN(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;GC(a);ID(a,b);J3(a);if(qO(a)|0)c[a+792>>2]=c[b>>2];l=d;return}function UN(a){a=a|0;var b=0,d=0,e=0;b=c[a+988>>2]|0;e=c[a+976>>2]|0;d=e+(b*12|0)|0;b=((c[e+(b*12|0)+4>>2]|0)-(c[d>>2]|0)|0)/24|0;c[a+992>>2]=b;vC(d,b+1|0);return}function VN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=l;l=l+128|0;e=g;f=e;h=f+124|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));c[e+32>>2]=26;c[e+44>>2]=a;c[e+76>>2]=-1;c[e+84>>2]=a;h=wc(e,b,d)|0;l=g;return h|0}function WN(a){a=a|0;kz(c[a+4>>2]|0);return}function XN(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;d=a+8|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-120|0;c[d>>2]=e;OM(e)}a=c[a>>2]|0;if(a|0)laa(a);return}function YN(a){a=a|0;switch(a<<24>>24){case 1:{a=383821;break}case 2:{a=375343;break}case 3:{a=375346;break}case 4:{a=370267;break}case 17:{a=375343;break}case 19:{a=370267;break}case 37:{a=370258;break}default:a=8800948}return a|0}function ZN(a){a=a|0;var b=0,d=0,e=0;d=l;l=l+32|0;b=d+16|0;e=d;c[e>>2]=a;c[e+4>>2]=622592;c[e+8>>2]=0;a=$a(5,e|0)|0;if((a|0)>=0){c[b>>2]=a;c[b+4>>2]=2;c[b+8>>2]=1;ma(221,b|0)|0}e=b6(a)|0;l=d;return e|0}function _N(a){a=a|0;iz(c[a+4>>2]|0);return}function $N(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;GC(b);AT(b,e);if(a[e>>0]|0)d4(c[b+648>>2]|0,2);J3(b);l=d;return}function aO(a){a=a|0;var b=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);e1(a,256,0);e1(a,256,0);e1(a,512,0);l=b;return}function bO(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;d=a+8|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-12|0;c[d>>2]=e;l1(e)}a=c[a>>2]|0;if(a|0)laa(a);return}function cO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[a+648>>2]|0;if((b&255)>>>0>(raa(c[e+4>>2]|0)|0)>>>0){vt(a);a=0;b=0}else{a=JN(e,b)|0;b=z}c[d>>2]=a;c[d+4>>2]=b;return}function dO(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=a+8|0;a=d;while(1){if((a|0)==(e|0))break;d=c[f>>2]|0;b[d>>1]=b[a>>1]|0;c[f>>2]=d+2;a=a+2|0}return}function eO(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;d=a+8|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-24|0;c[d>>2]=e;w4(e)}a=c[a>>2]|0;if(a|0)laa(a);return}function fO(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);a=a+528|0;d=a;d=z0(c[d>>2]|0,c[d+4>>2]|0,8,0)|0;c[a>>2]=d;c[a+4>>2]=z;l=b;return}function gO(a){a=a|0;var b=0;if(!(c[a>>2]&128))b=1;else b=(c[a+20>>2]|0)>>>0>(c[a+28>>2]|0)>>>0?2:1;b=gb[c[a+40>>2]&31](a,0,b)|0;if((b|0)>=0)b=b-(c[a+8>>2]|0)+(c[a+4>>2]|0)+(c[a+20>>2]|0)-(c[a+28>>2]|0)|0;return b|0}function hO(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;d=a+8|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-24|0;c[d>>2]=e;G0(e)}a=c[a>>2]|0;if(a|0)laa(a);return}function iO(a){a=a|0;var b=0.0;b=+MB(a);if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)h[(kE(a+760|0,a+840|0)|0)+56>>3]=b;return}function jO(a){a=a|0;var b=0,d=0,e=0;b=c[a>>2]|0;if(b|0){d=a+4|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-120|0;c[d>>2]=e;OM(e)}laa(c[a>>2]|0)}return}function kO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=l;l=l+16|0;h=g;CL(h,b,d,e,f);e=h;f=h+8|0;f=GF(a,c[e>>2]|0,c[e+4>>2]|0,c[f>>2]|0,c[f+4>>2]|0)|0;l=g;return f|0}function lO(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;CK(a);d=a+528|0;e=d;e=z0(c[e>>2]|0,c[e+4>>2]|0,2,0)|0;c[d>>2]=e;c[d+4>>2]=z;bD(a,b);l=b;return}function mO(b){b=b|0;var e=0,f=0;e=b+4|0;f=c[e>>2]|0;do if(!(f&7))if(!f){c[e>>2]=0;a[b+13>>0]=1;b=0;break}else{b=(a[c[b>>2]>>0]|0)<0;break}else b=(d[b+12>>0]&1<<(f+7&7)|0)!=0;while(0);return b|0}function nO(a){a=a|0;var b=0,d=0,e=0;b=c[a>>2]|0;if(b|0){d=a+4|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-12|0;c[d>>2]=e;l1(e)}laa(c[a>>2]|0)}return}function oO(b){b=b|0;var d=0;d=c[b+612>>2]|0;if((d+2|0)>>>0<=(c[b+548>>2]|0)>>>0){d=(c[b+544>>2]|0)+d|0;if(((d7(a[d>>0]|0,a[d+1>>0]|0)|0)&-32)<<16>>16==22240)b=1;else{a[b+376>>0]=0;b=1}}else b=0;return b|0}function pO(a){a=a|0;var b=0,d=0;b=a+728|0;d=c[b>>2]|0;if((d&9|0)==0?(c[b>>2]=d|1,(RA(a,0,-1)|0)==0):0){Kc(a,0,-1)|0;jb[c[(c[a>>2]|0)+48>>2]&511](a)}return}function qO(b){b=b|0;var d=0;d=c[b+648>>2]|0;if(d|0?a[d+13>>0]|0:0)vt(b);d=c[b+508>>2]|0;b=c[b+668>>2]|0;if(!(a[b+(d*24|0)+16>>0]|0))b=(a[b+(d*24|0)+17>>0]|0)==0;else b=0;return b|0}function rO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=a+84|0;g=c[e>>2]|0;h=d+256|0;f=fs(g,0,h)|0;f=(f|0)==0?h:f-g|0;d=f>>>0<d>>>0?f:d;no(b|0,g|0,d|0)|0;c[a+4>>2]=g+d;b=g+f|0;c[a+8>>2]=b;c[e>>2]=b;return d|0}function sO(a){a=a|0;tz(c[a+4>>2]|0);return}function tO(a){a=a|0;var b=0,d=0,e=0;b=c[a>>2]|0;if(b|0){d=a+4|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-24|0;c[d>>2]=e;w4(e)}laa(c[a>>2]|0)}return}function uO(a){a=a|0;switch(c[a+908>>2]|0){case 4:{a=j5(c[a+548>>2]|0,c[a+612>>2]|0)|0;break}case 5:{a=i5(c[a+548>>2]|0,c[a+612>>2]|0)|0;break}default:a=1}return a|0}function vO(a){a=a|0;var b=0;Bx(a);b=a+648|0;d4(c[b>>2]|0,14);d4(c[b>>2]|0,14);d4(c[b>>2]|0,4);wK(a);return}function wO(a){a=a|0;var b=0,d=0,e=0;b=c[a>>2]|0;if(b|0){d=a+4|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-24|0;c[d>>2]=e;G0(e)}laa(c[a>>2]|0)}return}function xO(b){b=b|0;if((a[b+768>>0]|0)==0?(a[b+769>>0]|0)==0:0)if((c[b+548>>2]|0)>>>0>=4)if(Hi(b)|0)b=1;else{V5(b);b=0}else b=0;else b=1;return b|0}function yO(b){b=b|0;var c=0,d=0;c=l;l=l+16|0;d=c;GC(b);AT(b,d);if(a[d>>0]|0)EH(b);J3(b);l=c;return}function zO(a){a=a|0;uz(c[a+4>>2]|0);return}function AO(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;d=a+8|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-16|0;c[d>>2]=e;Z7(e)}a=c[a>>2]|0;if(a|0)laa(a);return}function BO(a){a=a|0;switch(a<<24>>24){case -126:{a=383527;break}case -123:{a=383516;break}case -118:{a=383500;break}case -117:{a=383479;break}case -115:{a=383463;break}case -114:{a=383448;break}default:a=8800948}return a|0}function CO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=l;l=l+16|0;e=h;c[e>>2]=c[d>>2];e=zw(0,0,b,e)|0;if((e|0)>=0?(f=e+1|0,g=Ub(f)|0,c[a>>2]=g,(g|0)!=0):0)a=zw(g,f,b,d)|0;else a=-1;l=h;return a|0}function DO(a,b){a=a|0;b=b|0;var d=0;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0&1;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;d=a+28|0;b=a+32|0;a=b+40|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));D$(d);return}function EO(b){b=b|0;var d=0,e=0;c[b>>2]=23760;if((a[b+768>>0]|0)==0?(e=c[b+772>>2]|0,e|0):0)jb[c[(c[e>>2]|0)+4>>2]&511](e);if((a[b+769>>0]|0)==0?(d=c[b+780>>2]|0,d|0):0)laa(d);bt(b);return}function FO(a){a=a|0;Nz(c[a+4>>2]|0);return}function GO(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;d=a+8|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-12|0;c[d>>2]=e;cU(e)}a=c[a>>2]|0;if(a|0)laa(a);return}function HO(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;VU(d,384015);BZ(c[a+508>>2]|0,c[a+668>>2]|0,0,0);z5(d);Vr(a);l=b;return}function IO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;e=Ub(e+9|0)|0;if(!e)e=-1;else{c[c[b>>2]>>2]=e;c[e>>2]=0;g=e+4|0;l9(g,d)|0;if(f|0){f=g+(FD(g)|0)|0;a[f>>0]=47;a[f+1>>0]=0}c[b>>2]=e;e=0}return e|0}function JO(a){a=a|0;var b=0;b=c[a>>2]|0;if(b|0){VZ(b);laa(b)}a=c[a+4>>2]|0;if(a|0){VZ(a);laa(a)}return}function KO(a){a=a|0;var b=0;GC(a);b=a+648|0;A6(c[b>>2]|0);d4(c[b>>2]|0,14);A6(c[b>>2]|0);J3(a);return}function LO(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);a=a+528|0;d=a;d=z0(c[d>>2]|0,c[d+4>>2]|0,4,0)|0;c[a>>2]=d;c[a+4>>2]=z;l=b;return}function MO(a){a=a|0;var b=0,d=0,e=0;b=a+760|0;d=b;if((c[d>>2]|0)==0&(c[d+4>>2]|0)==0){e=+g[(c[a+24>>2]|0)+136>>2]>=.3;d=b;c[d>>2]=e?32:4;c[d+4>>2]=e?0:0}Kc(a,1,-1)|0;return}function NO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Zf(b,d,e,f,4)|0;if(!(c[e>>2]&4))c[a>>2]=d+-1900;return}function OO(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;d=Af(b,d,e,f,4)|0;if(!(c[e>>2]&4))c[a>>2]=d+-1900;return}function PO(b){b=b|0;var d=0,e=0,f=0;d=b+760|0;e=d;if((c[e>>2]|0)==0&(c[e+4>>2]|0)==0){f=+g[(c[b+24>>2]|0)+136>>2]>=.3;e=d;c[e>>2]=f?8:2;c[e+4>>2]=f?0:0}a[b+771>>0]=12;a[b+772>>0]=11;a[b+773>>0]=0;return}function QO(b){b=b|0;var d=0;if((c[b+612>>2]|0)!=0?(d=b+789|0,EG(b,d),(a[d>>0]|0)==-1):0){pO(b);jt(b);KM(b);b=0}else b=1;return b|0}function RO(a){a=a|0;var b=0,d=0,e=0;b=c[a>>2]|0;if(b|0){d=a+4|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-16|0;c[d>>2]=e;Z7(e)}laa(c[a>>2]|0)}return}function SO(a){a=a|0;var b=0,d=0,e=0,f=0;d=a+52|0;c[d>>2]=2;e=a+4|0;b=0;while(1){if(b>>>0>=(((c[e>>2]|0)-(c[a>>2]|0)|0)/40|0)>>>0)break;f=lI(a,b)|0;s5(f,c[d>>2]|0);b=b+1|0}return}function TO(a){a=a|0;switch(a|0){case 1274:case 1273:case 1272:case 1271:case 1270:case 1259:case 1258:case 1256:case 1253:case 1252:case 1251:case 1250:case 1238:case 1237:case 1235:{a=384051;break}case 1260:case 1243:case 1242:case 1241:{a=384063;break}default:a=8800948}return a|0}function UO(a){a=a|0;switch(a|0){case 1274:case 1273:case 1272:case 1271:case 1260:case 1259:case 1258:case 1253:case 1252:case 1251:case 1250:case 1243:case 1242:case 1241:case 1238:case 1237:case 1235:{a=384029;break}case 1270:case 1256:{a=384041;break}default:a=8800948}return a|0}function VO(a){a=a|0;switch(a|0){case 1274:case 1273:case 1272:case 1271:case 1260:case 1259:case 1258:case 1253:case 1252:case 1251:case 1250:case 1243:case 1242:case 1241:case 1238:case 1237:case 1235:{a=384021;break}case 1270:case 1256:{a=384047;break}default:a=8800948}return a|0}function WO(){var a=0,b=0,d=0,e=0;b=l;l=l+16|0;e=b;W0(e,407712);d=404800;a=c[d>>2]|0;d=c[d+4>>2]|0;s7(c[e>>2]|0);z=d;l=b;return a|0}function XO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+8|0;a=b;b=c[e>>2]|0;do{c[b>>2]=c[d>>2];b=(c[e>>2]|0)+4|0;c[e>>2]=b;a=a+-1|0}while((a|0)!=0);return}function YO(a,b){a=a|0;b=b|0;GC(a);switch(b<<24>>24){case 0:{Jm(a);break}case 1:{Pi(a);break}default:{}}J3(a);return}function ZO(a){a=a|0;cA(c[a+4>>2]|0);return}function _O(a){a=a|0;var b=0,d=0,e=0;b=c[a>>2]|0;if(b|0){d=a+4|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-12|0;c[d>>2]=e;cU(e)}laa(c[a>>2]|0)}return}function $O(a){a=a|0;var b=0;Kc(a,2,-1)|0;b=a+20|0;RB(a,2,c[b>>2]|0,18,379645,-1,1,0);RB(a,2,c[b>>2]|0,52,379650,-1,1,0);return}function aP(){var a=0,b=0,d=0,e=0;b=l;l=l+16|0;e=b;W0(e,407712);d=404816;a=c[d>>2]|0;d=c[d+4>>2]|0;s7(c[e>>2]|0);z=d;l=b;return a|0}function bP(b){b=b|0;var d=0,e=0,f=0;d=b+508|0;e=c[d>>2]|0;if(e|0){f=e+-1|0;c[d>>2]=f;d=c[b+668>>2]|0;a[d+(f*24|0)+17>>0]=a[d+(e*24|0)+17>>0]|0;a[d+(f*24|0)+16>>0]=a[d+(e*24|0)+16>>0]|0}return}function cP(a){a=a|0;gA(c[a+4>>2]|0);return}function dP(a){a=a|0;switch(a<<24>>24){case 0:{a=386962;break}case 1:{a=386942;break}case 2:{a=386928;break}case 3:{a=386916;break}case 4:{a=386888;break}case 15:{a=385637;break}default:a=391133}return a|0}function eP(a){a=a|0;var b=0;GC(a);b=a+648|0;A6(c[b>>2]|0);d4(c[b>>2]|0,2);A6(c[b>>2]|0);J3(a);return}function fP(a){a=a|0;var b=0,d=0;b=an(a)|0;d=z;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)oK(a,2,c[a+20>>2]|0,122,b,d,10,1);return}function gP(a){a=a|0;var b=0;b=c[a+4>>2]|0;if(!b)while(1){b=c[a+8>>2]|0;if((c[b>>2]|0)==(a|0))break;else a=b}else while(1){a=c[b>>2]|0;if(!a)break;else b=a}return b|0}function hP(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;d=b;c[a>>2]=42028;e=a+12|0;q2(e);W0(d,e);c[a+8>>2]=0;c[a+4>>2]=0;s7(c[d>>2]|0);l=b;return}function iP(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a>>2]|0;if(b|0){d=a+4|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-8|0;c[d>>2]=f;e=f}laa(b);c[a+8>>2]=0;c[d>>2]=0;c[a>>2]=0}return}function jP(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a>>2]|0;if(b|0){d=a+4|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-4|0;c[d>>2]=f;e=f}laa(b);c[a+8>>2]=0;c[d>>2]=0;c[a>>2]=0}return}function kP(a){a=a|0;switch(a|0){case 1258:{a=960;break}case 1252:case 1251:case 1250:{a=1280;break}case 1244:case 1260:case 1259:{a=1440;break}case 1253:case 1243:case 1242:case 1241:case 1238:case 1237:case 1235:{a=1920;break}default:a=0}return a|0}function lP(a){a=a|0;xh(a);Bx(a);Yl(a);wK(a);if(qO(a)|0)xp(a+760|0,0);return}function mP(a,b){a=a|0;b=b|0;var d=0,e=0;d=a+652|0;e=c[d>>2]|0;if((nb[c[(c[e>>2]|0)+20>>2]&255](e)|0)>>>0<24){vt(a);a=0}else a=Q4(c[d>>2]|0)|0;c[b>>2]=a;return}function nP(a,d){a=a|0;d=d|0;var e=0,f=0;e=a+652|0;f=c[e>>2]|0;if((nb[c[(c[f>>2]|0)+20>>2]&255](f)|0)>>>0<16){vt(a);a=0}else a=f3(c[e>>2]|0)|0;b[d>>1]=a;return}function oP(a){a=a|0;oA(c[a+4>>2]|0);return}function pP(a){a=a|0;switch(a<<24>>24){case 1:{a=24e3;break}case 2:{a=25e3;break}case 3:{a=3e4;break}case 4:{a=5e4;break}case 5:{a=6e4;break}case 6:{a=48e3;break}case 7:{a=72e3;break}default:a=0}return a|0}function qP(a){a=a|0;var b=0,d=0,e=0;e=l;l=l+16|0;d=e;b=ZN(a)|0;do if((b|0)>=0){a=g$()|0;if(!a){c[d>>2]=b;_a(6,d|0)|0;a=0;break}else{c[a>>2]=b;break}}else a=0;while(0);l=e;return a|0}function rP(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+4>>2]|0;d=a+8|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-24|0;c[d>>2]=f;e=f}a=c[a>>2]|0;if(a|0)laa(a);return}function sP(a,b){a=a|0;b=b|0;var e=0,f=0,g=0;f=(FD(b)|0)+1|0;g=iaa(f>>>0>1073741823?-1:f<<2)|0;e=0;while(1){if((e|0)==(f|0))break;c[g+(e<<2)>>2]=d[b+e>>0];e=e+1|0}v$(a,g)|0;jaa(g);return a|0}function tP(b){b=b|0;var d=0,e=0;d=a[b+8+3>>0]|0;if(d<<24>>24<0){d=c[b>>2]|0;e=d+(c[b+4>>2]<<2)|0}else{e=b+((d&255)<<2)|0;d=b}while(1){if((d|0)==(e|0))break;c[d>>2]=W7(c[d>>2]|0)|0;d=d+4|0}return b|0}function uP(b){b=b|0;var d=0,e=0;d=a[b+8+3>>0]|0;if(d<<24>>24<0){d=c[b>>2]|0;e=d+(c[b+4>>2]<<2)|0}else{e=b+((d&255)<<2)|0;d=b}while(1){if((d|0)==(e|0))break;c[d>>2]=X7(c[d>>2]|0)|0;d=d+4|0}return b|0}function vP(b){b=b|0;var d=0;if((c[b+548>>2]|0)>>>0>=2){d=c[b+544>>2]|0;if((d7(a[d>>0]|0,a[d+1>>0]|0)|0)<<16>>16==19802){w5(c[b+760>>2]|0);b=0}else b=1}else b=0;return b|0}function wP(b){b=b|0;var c=0,d=0;c=l;l=l+16|0;d=c;GC(b);AT(b,d);if(a[d>>0]|0)eP(b);J3(b);l=c;return}function xP(){var a=0,b=0,d=0,e=0;b=l;l=l+16|0;e=b;W0(e,407712);d=404808;a=c[d>>2]|0;d=c[d+4>>2]|0;s7(c[e>>2]|0);z=d;l=b;return a|0}function yP(b,d){b=b|0;d=d|0;var e=0,f=0;e=b+652|0;f=c[e>>2]|0;if(!(nb[c[(c[f>>2]|0)+20>>2]&255](f)|0)){vt(b);b=0}else b=(P3(c[e>>2]|0)|0)&1;a[d>>0]=b;return}function zP(b,d){b=b|0;d=d|0;var e=0,f=0;e=b+652|0;f=c[e>>2]|0;if((nb[c[(c[f>>2]|0)+20>>2]&255](f)|0)>>>0<4){vt(b);b=0}else b=H3(c[e>>2]|0)|0;a[d>>0]=b;return}function AP(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return te(a,c[b>>2]|0,c[d>>2]|0,e,f,g,402744,402752)|0}function BP(a,b){a=a|0;b=b|0;var d=0,e=0;c[a>>2]=0;e=a+4|0;c[e>>2]=0;c[a+8>>2]=0;c[a>>2]=c[b>>2];d=b+4|0;c[e>>2]=c[d>>2];e=b+8|0;c[a+8>>2]=c[e>>2];c[e>>2]=0;c[d>>2]=0;c[b>>2]=0;return}function CP(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;d=a+8|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-56|0;c[d>>2]=e;LT(e)}a=c[a>>2]|0;if(a|0)laa(a);return}function DP(b,c){b=b|0;c=c|0;GC(b);xR(b,5,c);if((a[c>>0]|0)==31){xR(b,6,c);a[c>>0]=(d[c>>0]|0)+32}J3(b);return}function EP(b,c,e){b=b|0;c=c|0;e=e|0;e=e&255;switch(b<<24>>24){case 14:{e=e<<1;break}case 15:{e=e*3|0;break}default:{e=c&255;e=(a[(b&255)+(368941+(e*14|0))>>0]|0)+(d[368932+e>>0]|0)|0}}return ((e|0)<64?e:64)&255|0}function FP(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Ae(a,c[b>>2]|0,c[d>>2]|0,e,f,g,56632,56664)|0}function GP(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{hG(b);b=(c[d>>2]|0)+120|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function HP(a){a=a|0;uA(c[a+4>>2]|0);return}function IP(a){a=a|0;var b=0,d=0;c[a>>2]=13640;b=a+840|0;d=a+1240|0;do{d=d+-40|0;$_(d)}while((d|0)!=(b|0));z5(a+792|0);cU(a+780|0);bt(a);return}function JP(b){b=b|0;var c=0,d=0,e=0;c=an(b)|0;d=z;if(qO(b)|0){e=d>>>0<0|(d|0)==0&c>>>0<8;d=D_(8,0,(e?c:8)|0,(e?d:0)|0)|0;a[b+808>>0]=(1<<d)+255}return}function KP(a){a=a|0;var b=0;b=a+4|0;RI(c[b>>2]|0);c[a+8>>2]=0;c[a>>2]=b;c[b>>2]=0;return}function LP(a){a=a|0;var b=0;b=a+4|0;SI(c[b>>2]|0);c[a+8>>2]=0;c[a>>2]=b;c[b>>2]=0;return}function MP(a){a=a|0;PA(c[a+4>>2]|0);return}function NP(a){a=a|0;var b=0;b=a+4|0;XI(c[b>>2]|0);c[a+8>>2]=0;c[a>>2]=b;c[b>>2]=0;return}function OP(a){a=a|0;var b=0,d=0;b=c[a>>2]|0;d=a+4|0;c[a>>2]=d;c[(c[d>>2]|0)+8>>2]=0;c[d>>2]=0;c[a+8>>2]=0;a=c[b+4>>2]|0;return ((a|0)==0?b:a)|0}function PP(b){b=b|0;var d=0;Eg(b);c[b>>2]=28276;c[b+760>>2]=7;a[b+764>>0]=0;a[b+765>>0]=0;d=b+768|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;a[d+16>>0]=0;a[b+785>>0]=1;return}function QP(a){a=a|0;var b=0,d=0,e=0;b=c[a>>2]|0;if(b|0){d=a+4|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-56|0;c[d>>2]=e;LT(e)}laa(c[a>>2]|0)}return}function RP(a,b){a=a|0;b=b|0;var d=0;d=c[a+648>>2]|0;if((raa(c[d+4>>2]|0)|0)>>>0<36){vt(a);a=0;d=0}else{a=JN(d,36)|0;d=z}c[b>>2]=a;c[b+4>>2]=d;return}function SP(a,b){a=a|0;b=b|0;b=iL(a,b)|0;if((b|0)!=(a+4|0))oB(a,b);return}function TP(a){a=a|0;NA(c[a+4>>2]|0);return}function UP(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{j$(b);b=(c[d>>2]|0)+24|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function VP(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;d=a+8|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-40|0;c[d>>2]=e;$_(e)}a=c[a>>2]|0;if(a|0)laa(a);return}function WP(a){a=a|0;var b=0;Bx(a);L5(a);b=a+648|0;A6(c[b>>2]|0);A6(c[b>>2]|0);wK(a);return}function XP(b,d){b=b|0;d=d|0;a[b>>0]=0;c[b+4>>2]=d;d=d+(c[(c[d>>2]|0)+-12>>2]|0)|0;if(!(c[d+16>>2]|0)){d=c[d+72>>2]|0;if(d|0)XB(d)|0;a[b>>0]=1}return}function YP(b,d){b=b|0;d=d|0;a[b>>0]=0;c[b+4>>2]=d;d=d+(c[(c[d>>2]|0)+-12>>2]|0)|0;if(!(c[d+16>>2]|0)){d=c[d+72>>2]|0;if(d|0)YB(d)|0;a[b>>0]=1}return}function ZP(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return rg(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function _P(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return sg(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function $P(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return tg(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function aQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return _f(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function bQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return $f(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function cQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return ag(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function dQ(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,b+264|0);b=(a[b+238>>0]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function eQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if(d8(a,c[b+8>>2]|0)|0)gx(b,d,e,f);return}function fQ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=e;b=g;g=d;while(1){if((g|0)==(e|0))break;i=c[g>>2]|0;a[b>>0]=i>>>0<128?i&255:f;b=b+1|0;g=g+4|0}return d+((h-d|0)>>>2<<2)|0}function gQ(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{hG(b);b=(c[d>>2]|0)+120|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function hQ(a){a=a|0;var b=0;b=PZ(d[a>>0]|0|0,0,8)|0;b=PZ(b|(d[a+1>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+2>>0]|0)|0,z|0,8)|0;b=PZ(b|(d[a+3>>0]|0)|0,z|0,8)|0;return b|(d[a+4>>0]|0)|0}function iQ(a){a=a|0;var b=0;Kc(a,6,-1)|0;b=a+20|0;RB(a,6,c[b>>2]|0,18,379655,-1,1,0);RB(a,6,c[b>>2]|0,33,379665,-1,1,0);return}function jQ(a){a=a|0;var b=0,d=0,e=0,f=0;d=a+32|0;e=a+36|0;b=c[a+40>>2]|0;while(1){if(!b)break;f=b+-1|0;ob[c[(c[d>>2]|0)+(f<<2)>>2]&3](0,a,c[(c[e>>2]|0)+(f<<2)>>2]|0);b=f}return}function kQ(a,b){a=a|0;b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,b+264|0);p2(a,b+168|0);s7(c[e>>2]|0);l=d;return}function lQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+4>>2]|0;d=a+8|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-1|0;c[d>>2]=f;e=f}a=c[a>>2]|0;if(a|0)laa(a);return}function mQ(a){a=a|0;var b=0,d=0,e=0;b=c[a>>2]|0;if(b|0){d=a+4|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-40|0;c[d>>2]=e;$_(e)}laa(c[a>>2]|0)}return}function nQ(a){a=a|0;var b=0.0;b=+MB(a);if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)KW(a,2,c[a+20>>2]|0,135,b,0,1);return}function oQ(a){a=a|0;var b=0,d=0,e=0;e=a+760|0;b=a+764|0;a=0;while(1){d=c[e>>2]|0;if(a>>>0>=(c[b>>2]|0)-d>>2>>>0)break;Kl(c[d+(a<<2)>>2]|0);a=a+1|0}return}function pQ(a){a=a|0;cB(c[a+4>>2]|0);return}function qQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+4>>2]|0;d=a+8|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-3|0;c[d>>2]=f;e=f}a=c[a>>2]|0;if(a|0)laa(a);return}function rQ(b,d){b=b|0;d=d|0;var e=0,f=0;if((b|0)!=(d|0)){e=a[d+8+3>>0]|0;f=e<<24>>24<0;sx(b,f?c[d>>2]|0:d,f?c[d+4>>2]|0:e&255)|0}return b|0}function sQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return ug(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function tQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return zg(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function uQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Ag(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function vQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return cg(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function wQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return ig(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function xQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return jg(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function yQ(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{Y8(b);b=(c[d>>2]|0)+1|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function zQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+4>>2]|0;d=a+8|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-32|0;c[d>>2]=f;e=f}a=c[a>>2]|0;if(a|0)laa(a);return}function AQ(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{j$(b);b=(c[d>>2]|0)+24|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function BQ(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+4>>2]|0;d=a+8|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-16|0;c[d>>2]=f;e=f}a=c[a>>2]|0;if(a|0)laa(a);return}function CQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return vg(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function DQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return Bg(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function EQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return dg(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function FQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;return kg(c[b>>2]|0,c[d>>2]|0,e,f,g)|0}function GQ(a){a=a|0;LL(a);return}function HQ(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;d=a+8|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-12|0;c[d>>2]=e;z5(e)}a=c[a>>2]|0;if(a|0)laa(a);return}function IQ(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{r4(b);b=(c[d>>2]|0)+3|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function JQ(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{c7(b);b=(c[d>>2]|0)+2|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function KQ(b,d){b=b|0;d=d|0;var e=0,f=0;if((b|0)!=(d|0)){e=a[d+11>>0]|0;f=e<<24>>24<0;Qx(b,f?c[d>>2]|0:d,f?c[d+4>>2]|0:e&255)|0}return b|0}function LQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=b+4|0;if((c[f>>2]|0)!=(d|0)){c[f>>2]=d;f=e<<3;c[b+16>>2]=f;c[b+12>>2]=f;c[b+8>>2]=f;c[b+24>>2]=0;a[b+28>>0]=(f|0)==0&1;a[b+29>>0]=0}return}function MQ(){var a=0,b=0;b=l;l=l+16|0;a=b;W0(a,407712);if(!(c[101703]|0))eI();s7(c[a>>2]|0);l=b;return}function NQ(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=a&65535;e=b&65535;c=O(e,f)|0;d=a>>>16;a=(c>>>16)+(O(e,d)|0)|0;e=b>>>16;b=O(e,f)|0;return (z=(a>>>16)+(O(e,d)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|c&65535|0)|0}function OQ(a,b){a=a|0;b=b|0;var d=0;TX(a);c[a+32>>2]=0;d=a+16|0;c[d>>2]=-1;c[d+4>>2]=-1;c[d+8>>2]=-1;c[d+12>>2]=-1;Gq(a,b);return}function PQ(a,b){a=+a;b=+b;var d=0,e=0;h[j>>3]=a;e=c[j>>2]|0;d=c[j+4>>2]|0;h[j>>3]=b;d=c[j+4>>2]&-2147483648|d&2147483647;c[j>>2]=e;c[j+4>>2]=d;return +(+h[j>>3])}function QQ(a){a=a|0;xD(c[a+4>>2]|0);return}function RQ(a){a=a|0;yD(c[a+4>>2]|0);return}function SQ(b,d){b=b|0;d=d|0;var e=0,f=0;e=a[b+8+3>>0]|0;f=e<<24>>24<0;if(f)e=c[b+4>>2]|0;else e=e&255;if(e>>>0<=d>>>0)uaa();if(f)b=c[b>>2]|0;return b+(d<<2)|0}function TQ(b){b=b|0;GC(b);QC(b);Nx(b);x0(b);if(a[b+808>>0]|0)x0(b);J3(b);return}function UQ(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,b+264|0);b=(a[b+149>>0]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function VQ(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,b+264|0);b=(a[b+237>>0]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function WQ(a,b,d){a=a|0;b=b|0;d=d|0;if(!((b|0)==-1&(d|0)==-1)){b=D_(b|0,d|0,c[a+604>>2]|0,0)|0;d=a+48|0;c[d>>2]=b;c[d+4>>2]=z;d=a+64|0;c[d>>2]=-1;c[d+4>>2]=-1}return}function XQ(a){a=a|0;var b=0,d=0,e=0;b=c[a>>2]|0;if(b|0){d=a+4|0;while(1){e=c[d>>2]|0;if((e|0)==(b|0))break;e=e+-12|0;c[d>>2]=e;z5(e)}laa(c[a>>2]|0)}return}function YQ(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,b+264|0);b=(a[b+242>>0]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function ZQ(a){a=a|0;var b=0.0,c=0;a=S$(a)|0;c=a>>>23;switch((c&255)<<24>>24){case 0:case -1:{b=0.0;break}default:{b=(+((a&8388607)>>>0)*1.1920928955078125e-07+1.0)*+eaa((c&255)+-127|0);b=(a|0)<0?-b:b}}return +b}function _Q(b,c,d,e,f,g,h){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;a[b>>0]=c&1;a[b+1>>0]=d;a[b+2>>0]=e;a[b+3>>0]=f;a[b+4>>0]=g;a[b+5>>0]=h;return}function $Q(a){a=a|0;var b=0,d=0,e=0;e=l;l=l+48|0;b=e;T$(b);a=a+120|0;d=a+40|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(d|0));l=e;return}function aR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;c[d>>2]=0;a=a+648|0;do{e=(my(c[a>>2]|0,b)|0)&255;c[d>>2]=(c[d>>2]|0)+e}while(NF(c[a>>2]|0)|0);return}function bR(b){b=b|0;Kc(b,2,-1)|0;RB(b,2,0,18,378971,-1,1,0);RB(b,2,0,52,378971,-1,1,0);a[b+785>>0]=0;return}function cR(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{Y8(b);b=(c[d>>2]|0)+1|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function dR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=l;l=l+16|0;h=g;c[h>>2]=f;f=a0(d)|0;d=zw(a,b,e,h)|0;if(f|0)a0(f)|0;l=g;return d|0}function eR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+12>>2]=0;c[a+16>>2]=e;if(!b)e=0;else e=ZW(b)|0;c[a>>2]=e;d=e+d|0;c[a+8>>2]=d;c[a+4>>2]=d;c[a+12>>2]=e+b;return}function fR(a){a=a|0;var b=0,d=0;KK(a);d=a+536|0;b=c[d>>2]|0;d=c[d+4>>2]|0;if(d>>>0>0|(d|0)==0&b>>>0>4){d=z0(b|0,d|0,-4,-1)|0;e1(a,d,z)}return}function gR(a){a=a|0;var b=0;b=l;l=l+16|0;Bx(a);xR(a,3,b);A6(c[a+648>>2]|0);wK(a);l=b;return}function hR(b){b=b|0;Kc(b,3,-1)|0;RB(b,3,0,18,379003,-1,1,0);RB(b,3,0,37,379003,-1,1,0);a[b+785>>0]=0;return}function iR(b){b=b|0;Kc(b,2,-1)|0;RB(b,2,0,18,379008,-1,1,0);RB(b,2,0,52,379008,-1,1,0);a[b+785>>0]=0;return}function jR(b){b=b|0;Kc(b,1,-1)|0;RB(b,1,0,18,391354,-1,1,0);RB(b,1,0,58,391354,-1,1,0);a[b+785>>0]=0;return}function kR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e;c[d>>2]=c[a>>2];while(1){f=(c[d>>2]|0)+(4-1)&~(4-1);a=c[f>>2]|0;c[d>>2]=f+4;if(b>>>0>1)b=b+-1|0;else break}l=e;return a|0}function lR(b){b=b|0;var c=0,d=0,e=0;e=l;l=l+16|0;c=e;if(a[b+760>>0]|0?(bB(b,c),d=a[c>>0]|0,d<<24>>24):0)e1(b,d&255,0);l=e;return}function mR(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{r4(b);b=(c[d>>2]|0)+3|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function nR(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{c7(b);b=(c[d>>2]|0)+2|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function oR(a,b){a=a|0;b=b|0;var d=0,e=0;e=FD(b)|0;d=ZW(e+13|0)|0;c[d>>2]=e;c[d+4>>2]=e;c[d+8>>2]=0;d=S6(d)|0;no(d|0,b|0,e+1|0)|0;c[a>>2]=d;return}function pR(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;W0(d,a+264|0);a=c[a+228>>2]|0;s7(c[d>>2]|0);l=b;return a|0}function qR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=c[b+648>>2]|0;if((d&255)>>>0>(raa(c[f+4>>2]|0)|0)>>>0){vt(b);b=0}else b=GB(f,d)|0;a[e>>0]=b;return}function rR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[a+648>>2]|0;if((b&255)>>>0>(raa(c[e+4>>2]|0)|0)>>>0){vt(a);a=0}else a=tn(e,b)|0;c[d>>2]=a;return}function sR(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;f=c[a+648>>2]|0;if((d&255)>>>0>(raa(c[f+4>>2]|0)|0)>>>0){vt(a);a=0}else a=At(f,d)|0;b[e>>1]=a;return}function tR(a){a=a|0;if(!a)return;else{tR(c[a>>2]|0);tR(c[a+4>>2]|0);laa(a);return}}function uR(a){a=a|0;if(!a)return;else{uR(c[a>>2]|0);uR(c[a+4>>2]|0);laa(a);return}}function vR(a){a=a|0;EB(c[a+4>>2]|0);return}function wR(a){a=a|0;var b=0,d=0,e=0;d=c[a>>2]|0;if(d|0){a=a+4|0;b=c[a>>2]|0;while(1){if((b|0)==(d|0))break;e=b+-24|0;c[a>>2]=e;b=e}laa(d)}return}function xR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=c[b+648>>2]|0;if((d&255)>>>0>(raa(c[f+4>>2]|0)|0)>>>0){vt(b);b=0}else b=my(f,d)|0;a[e>>0]=b;return}function yR(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0;i=b;c[i>>2]=d;c[i+4>>2]=e;e=b+8|0;c[e>>2]=f;c[e+4>>2]=g;a[b+16>>0]=h&1;return}function zR(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,b+264|0);b=(a[b+236>>0]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function AR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=l;l=l+16|0;g=f;h=g;c[h>>2]=d;c[h+4>>2]=e;a[(HG(b+680|0,g)|0)>>0]=1;l=f;return}function BR(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{xA(b);b=(c[d>>2]|0)+56|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function CR(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,b+264|0);b=(a[b+239>>0]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function DR(b){b=b|0;var c=0,d=0,e=0;c=l;l=l+16|0;e=c;d=(tu(b,e,0)|0)^1;if(!((a[e>>0]|0)==0|d))Pc(b)|0;l=c;return}function ER(d,e,f){d=d|0;e=e|0;f=f|0;var g=0;g=ZW(16)|0;c[d>>2]=g;c[d+4>>2]=e+4;b[g+14>>1]=b[f>>1]|0;a[d+8>>0]=1;return}function FR(b,d){b=b|0;d=d|0;var e=0,f=0;e=l;l=l+16|0;f=e;W0(f,b+264|0);a[b+142>>0]=d&1;s7(c[f>>2]|0);l=e;return}function GR(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,b+264|0);b=(a[b+259>>0]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function HR(a){a=a|0;var b=0,d=0;GC(a);b=a+528|0;d=b;d=z0(c[d>>2]|0,c[d+4>>2]|0,12,0)|0;c[b>>2]=d;c[b+4>>2]=z;J3(a);return}function IR(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,b+264|0);b=(a[b+145>>0]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function JR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+4|0;a=d-b|0;if((a|0)>0){no(c[e>>2]|0,b|0,a|0)|0;c[e>>2]=(c[e>>2]|0)+(a>>>3<<3)}return}function KR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+4|0;a=d-b|0;if((a|0)>0){no(c[e>>2]|0,b|0,a|0)|0;c[e>>2]=(c[e>>2]|0)+(a>>>1<<1)}return}function LR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a+4|0;a=d-b|0;if((a|0)>0){no(c[e>>2]|0,b|0,a|0)|0;c[e>>2]=(c[e>>2]|0)+(a>>>2<<2)}return}function MR(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{L2(b);b=(c[d>>2]|0)+16|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function NR(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;W0(b,a+12|0);a=a+8|0;if((c[a>>2]|0)==1)c[a>>2]=3;s7(c[b>>2]|0);l=d;return}function OR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;f=ZW(20)|0;c[b>>2]=f;c[b+4>>2]=d+4;c[f+16>>2]=c[e>>2];a[b+8>>0]=1;return}function PR(a){a=a|0;switch(a<<24>>24){case 0:{a=385703;break}case 1:{a=385687;break}case 2:{a=385675;break}case 3:{a=385660;break}case 15:{a=385637;break}default:a=391133}return a|0}function QR(a){a=a|0;switch(a<<24>>24){case 0:{a=386109;break}case 1:{a=386079;break}case 2:{a=386053;break}case 3:{a=386035;break}case 15:{a=385637;break}default:a=391133}return a|0}function RR(a){a=a|0;switch(a<<24>>24){case 0:{a=386873;break}case 1:{a=386850;break}case 2:{a=386837;break}case 3:{a=386827;break}case 15:{a=385637;break}default:a=391133}return a|0}function SR(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,b+264|0);b=(a[b+142>>0]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function TR(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b>>0]=a[c>>0]|0}b=e}else no(b,c,d)|0;return b|0}function UR(a){a=a|0;eC(c[a+4>>2]|0);return}function VR(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,b+264|0);b=(a[b+147>>0]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function WR(a){a=a|0;bC(c[a+4>>2]|0);return}function XR(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{mI(b);b=(c[d>>2]|0)+40|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function YR(b){b=b|0;var d=0;d=b+11|0;if((a[d>>0]|0)<0){d=c[b>>2]|0;c[b+4>>2]=1}else{a[d>>0]=1;d=b}J7(d,73);J7(d+1|0,0);return b|0}function ZR(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;hL(d,c[a>>2]|0);_E(d);O0(d);l=b;return}function _R(a){a=a|0;var b=0;KK(a);KK(a);a=a+528|0;b=a;b=z0(c[b>>2]|0,c[b+4>>2]|0,20,0)|0;c[a>>2]=b;c[a+4>>2]=z;return}function $R(a){a=a|0;var b=0;KK(a);KK(a);a=a+528|0;b=a;b=z0(c[b>>2]|0,c[b+4>>2]|0,8,0)|0;c[a>>2]=b;c[a+4>>2]=z;return}function aS(b){b=b|0;var c=0,d=0,e=0,f=0;e=a[b>>0]|0;c=1;d=401257;f=97;while(1){if(e<<24>>24==f<<24>>24?(xN(b,d)|0)==0:0)break;d=d+6|0;f=a[d>>0]|0;if(!(f<<24>>24)){c=0;break}else c=c+1|0}return c|0}function bS(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{xA(b);b=(c[d>>2]|0)+56|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function cS(b){b=b|0;c[b>>2]=41956;dW(b);if(a[b+96>>0]|0)jaa(c[b+32>>2]|0);if(a[b+97>>0]|0)jaa(c[b+56>>2]|0);G3(b);return}function dS(b){b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,b+264|0);b=(a[b+143>>0]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function eS(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=l;l=l+16|0;e=d;TX(e);Ko(a,b,c,e);z5(e);l=d;return}function fS(a){a=a|0;nC(c[a+4>>2]|0);return}function gS(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;b=(c[d>>2]|0)+4|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function hS(a){a=a|0;var b=0,c=0;z5(a+36|0);b=a+12|0;c=a+36|0;do{c=c+-12|0;z5(c)}while((c|0)!=(b|0));wW(a);return}function iS(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{L2(b);b=(c[d>>2]|0)+16|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function jS(a){a=a|0;tC(c[a+4>>2]|0);return}function kS(a){a=a|0;eN(a);return}function lS(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;d=b;TX(d);e=a+536|0;jZ(a,c[e>>2]|0,c[e+4>>2]|0,d);z5(d);l=b;return}function mS(){var b=0,d=0,e=0;d=l;l=l+16|0;e=d;W0(e,407712);b=(a[404896]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function nS(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;b=(c[d>>2]|0)+4|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function oS(b){b=b|0;var d=0;if((nb[c[(c[b>>2]|0)+36>>2]&255](b)|0)==-1)b=-1;else{d=b+12|0;b=c[d>>2]|0;c[d>>2]=b+1;b=e9(a[b>>0]|0)|0}return b|0}function pS(a){a=a|0;var b=0,d=0,e=0;d=c[a>>2]|0;if(d|0){a=a+4|0;b=c[a>>2]|0;while(1){if((b|0)==(d|0))break;e=b+-3|0;c[a>>2]=e;b=e}laa(d)}return}function qS(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;while(1){if((d|0)==(f|0))break;a=c[d>>2]|0;if(a>>>0<128)a=e[65244+(a<<1)>>1]|0;else a=0;b[g>>1]=a;g=g+2|0;d=d+4|0}return f|0}function rS(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return ((c|0)==(g|0)&(d|0)==(h|0)?b>>>0<f>>>0|(b|0)==(f|0)&a>>>0<e>>>0:d>>>0<h>>>0|(d|0)==(h|0)&c>>>0<g>>>0)|0}function sS(a){a=a|0;AC(c[a+4>>2]|0);return}function tS(a){a=a|0;BC(c[a+4>>2]|0);return}function uS(a){a=a|0;var b=0,d=0,e=0;d=c[a>>2]|0;if(d|0){a=a+4|0;b=c[a>>2]|0;while(1){if((b|0)==(d|0))break;e=b+-32|0;c[a>>2]=e;b=e}laa(d)}return}function vS(b){b=b|0;var d=0,e=0,f=0;e=c[b>>2]|0;f=(a[e>>0]|0)+-48|0;if(f>>>0<10){d=0;do{d=(d*10|0)+f|0;e=e+1|0;c[b>>2]=e;f=(a[e>>0]|0)+-48|0}while(f>>>0<10)}else d=0;return d|0}function wS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=l;l=l+16|0;g=f;c[g>>2]=e;e=a0(b)|0;b=CO(a,d,g)|0;if(e|0)a0(e)|0;l=f;return b|0}function xS(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+4>>2]|0;d=a+8|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-8|0;c[d>>2]=f;e=f}a=c[a>>2]|0;if(a|0)laa(a);return}function yS(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+4>>2]|0;d=a+8|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-2|0;c[d>>2]=f;e=f}a=c[a>>2]|0;if(a|0)laa(a);return}function zS(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+4>>2]|0;d=a+8|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-4|0;c[d>>2]=f;e=f}a=c[a>>2]|0;if(a|0)laa(a);return}function AS(a){a=a|0;var b=0,d=0,e=0;d=c[a>>2]|0;if(d|0){a=a+4|0;b=c[a>>2]|0;while(1){if((b|0)==(d|0))break;e=b+-16|0;c[a>>2]=e;b=e}laa(d)}return}function BS(a){a=a|0;var b=0,d=0,e=0;b=l;l=l+16|0;d=b;TX(d);e=a+536|0;xZ(a,c[e>>2]|0,c[e+4>>2]|0,d);z5(d);l=b;return}function CS(a,b){a=a|0;b=+b;var d=0,e=0;d=l;l=l+16|0;e=d;W0(e,a+264|0);g[a+260>>2]=b;s7(c[e>>2]|0);l=d;return}function DS(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{mI(b);b=(c[d>>2]|0)+40|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function ES(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=b;b=c[d>>2]|0;do{TX(b);b=(c[d>>2]|0)+12|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function FS(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;while(1){if((e|0)==(f|0)){e=f;break}a=c[e>>2]|0;if(a>>>0>=128)break;if(!((b[65244+(a<<1)>>1]&d)<<16>>16))break;e=e+4|0}return e|0}function GS(a){a=a|0;var b=0,d=0;b=an(a)|0;d=z;if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0){a=a+824|0;c[a>>2]=b;c[a+4>>2]=d}return}function HS(a){a=a|0;Kc(a,1,-1)|0;RB(a,1,0,18,384021,-1,1,0);RB(a,1,0,58,384021,-1,1,0);return}function IS(a){a=a|0;switch(a|0){case 1258:case 1252:case 1251:case 1250:{a=720;break}case 1260:case 1259:case 1256:case 1253:case 1243:case 1242:case 1241:case 1238:case 1237:case 1235:{a=1080;break}default:a=0}return a|0}function JS(a){a=a|0;Kc(a,2,-1)|0;RB(a,2,0,18,379650,-1,1,0);RB(a,2,0,52,379650,-1,1,0);return}function KS(a){a=a|0;var b=0;b=c[a+648>>2]|0;if(raa(c[b+4>>2]|0)|0){if(!(NF(b)|0))j3(a)}else vt(a);return}function LS(b){b=b|0;var d=0;d=c[b+612>>2]|0;if((d+4|0)>>>0<=(c[b+548>>2]|0)>>>0)if((C9((c[b+544>>2]|0)+d|0)|0)==1332176723)b=1;else{a[b+376>>0]=0;b=1}else b=0;return b|0}function MS(a){a=a|0;switch(a<<24>>24){case 0:{a=391012;break}case 1:{a=391190;break}case 2:{a=391171;break}case 3:{a=391157;break}case 4:{a=391007;break}default:a=391133}return a|0}function NS(b,c,e,f){b=b|0;c=c|0;e=e|0;f=f|0;if(!((b|0)==0&(c|0)==0))do{e=e+-1|0;a[e>>0]=d[393205+(b&15)>>0]|0|f;b=XZ(b|0,c|0,4)|0;c=z}while(!((b|0)==0&(c|0)==0));return e|0}function OS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;if(d8(a,c[b+8>>2]|0)|0)jG(b,d,e);return}function PS(a){a=a|0;Kc(a,3,-1)|0;RB(a,3,0,18,378994,-1,1,0);RB(a,3,0,37,378994,-1,1,0);return}function QS(){var b=0,d=0,e=0;d=l;l=l+16|0;e=d;W0(e,407712);b=(a[404825]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function RS(a){a=a|0;var b=0;b=c[a+648>>2]|0;if(raa(c[b+4>>2]|0)|0){if(NF(b)|0)j3(a)}else vt(a);return}function SS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=l;l=l+16|0;e=f;c[e>>2]=c[d>>2];a=gb[c[(c[a>>2]|0)+16>>2]&31](a,b,e)|0;if(a)c[d>>2]=c[e>>2];l=f;return a&1|0}function TS(){var a=0,b=0;a=IW()|0;if((a|0?(b=c[a>>2]|0,b|0):0)?(a=b+48|0,(c[a>>2]&-256|0)==1126902528?(c[a+4>>2]|0)==1129074247:0):0)S1(c[b+12>>2]|0);S1(b8()|0)}function US(a){a=a|0;Kc(a,1,-1)|0;RB(a,1,0,18,378977,-1,1,0);RB(a,1,0,58,378977,-1,1,0);return}function VS(a){a=a|0;Kc(a,2,-1)|0;RB(a,2,0,18,391465,-1,1,0);RB(a,2,0,52,391465,-1,1,0);return}function WS(a){a=a|0;Kc(a,1,-1)|0;RB(a,1,0,18,378981,-1,1,0);RB(a,1,0,58,378981,-1,1,0);return}function XS(a){a=a|0;Kc(a,1,-1)|0;RB(a,1,0,18,378999,-1,1,0);RB(a,1,0,58,378999,-1,1,0);return}function YS(a,b){a=a|0;b=b|0;var d=0,e=0;e=a+536|0;d=a+528|0;d=D_(c[e>>2]|0,c[e+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;Zn(a,b,d);return}function ZS(a,b){a=a|0;b=b|0;var d=0,e=0;if(b|0){e=N0(b)|0;d=e+1|0;d=iaa(d>>>0>1073741823?-1:d<<2)|0;jK(d,b,e)|0;c[d+(e<<2)>>2]=0;v$(a,d)|0;jaa(d)}return a|0}function _S(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=l;l=l+16|0;d=f;c[d>>2]=e;b=a0(b)|0;d=VN(a,402003,d)|0;if(b|0)a0(b)|0;l=f;return d|0}function $S(b){b=b|0;var c=0;c=a[n+(b&255)>>0]|0;if((c|0)<8)return c|0;c=a[n+(b>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return (a[n+(b>>>24)>>0]|0)+24|0}function aT(a,b){a=a|0;b=b|0;var d=0;if(b>>>0>178956970)uaa();else{d=ZW(b*24|0)|0;c[a+4>>2]=d;c[a>>2]=d;c[a+8>>2]=d+(b*24|0);return}}function bT(a){a=a|0;AN(a);return}function cT(a){a=+a;var b=0,c=0;c=~~a>>>0;b=+B(a)>=1.0?(a>0.0?~~+P(+A(a/4294967296.0),4294967295.0)>>>0:~~+N((a-+(~~a>>>0))/4294967296.0)>>>0):0;b=z0(a-(+(c>>>0)+4294967296.0*+(b|0))>=.5|0,0,c|0,b|0)|0;return b|0}function dT(a){a=a|0;var b=0,c=0;z5(a+36|0);b=a+12|0;c=a+36|0;do{c=c+-12|0;z5(c)}while((c|0)!=(b|0));RX(a);return}function eT(a){a=a|0;var b=0;Bx(a);b=a+648|0;d4(c[b>>2]|0,7);A6(c[b>>2]|0);wK(a);return}function fT(){var b=0,d=0,e=0;d=l;l=l+16|0;e=d;W0(e,407712);b=(a[404824]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function gT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;f=a+4|0;d=c[a>>2]|0;if(b>>>0>31){c[f>>2]=d;c[a>>2]=0;b=b+-32|0;e=0}else{e=d;d=c[f>>2]|0}c[f>>2]=e>>>(32-b|0)|d<<b;c[a>>2]=e<<b;return}function hT(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;W0(d,a+12|0);a=c[a+8>>2]|0;s7(c[d>>2]|0);l=b;return (a|0)==0|(a|0)==3|0}function iT(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{TX(b);b=(c[d>>2]|0)+12|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function jT(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;W0(d,407712);p2(a,404948);s7(c[d>>2]|0);l=b;return}function kT(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;W0(d,407712);p2(a,404960);s7(c[d>>2]|0);l=b;return}function lT(b){b=b|0;var d=0,e=0;d=b+772|0;e=d+11|0;if((a[e>>0]|0)<0){J7(c[d>>2]|0,0);c[b+776>>2]=0}else{J7(d,0);a[e>>0]=0}return}function mT(a){a=a|0;var b=0,d=0;b=a+32|0;d=c[b>>2]|0;if(d|0)jb[c[(c[d>>2]|0)+4>>2]&511](d);c[b>>2]=0;d=a+16|0;c[d>>2]=-1;c[d+4>>2]=-1;c[d+8>>2]=-1;c[d+12>>2]=-1;return}function nT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0;c=1e9;d=0;while(1){if((a|0)==0&(b|0)==0)break;g=pB(c|0,d|0,a|0,b|0)|0;f=b;e=a;a=g;b=z;d=f;c=e}z=d;return c|0}function oT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=l;l=l+16|0;f=e;TX(f);p2(a,bk(f,b,c,d)|0);z5(f);l=e;return}function pT(a,b,d){a=a|0;b=b|0;d=d|0;a:do if(!d)a=0;else while(1){if((c[a>>2]|0)==(b|0))break a;d=d+-1|0;if(!d){a=0;break}else a=a+4|0}while(0);return a|0}function qT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;f=a+4|0;d=c[f>>2]|0;if(b>>>0>31){c[a>>2]=d;c[f>>2]=0;b=b+-32|0;e=0}else{e=d;d=c[a>>2]|0}c[a>>2]=e<<32-b|d>>>b;c[f>>2]=e>>>b;return}function rT(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if(c|0){if((d|0)==-1)d=FD(c)|0;e=iaa(d+1|0)|0;Y7(e,c,d)|0;a[e+d>>0]=0;DJ(b,e)|0;jaa(e)}return b|0}function sT(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if(c|0){if((d|0)==-1)d=FD(c)|0;e=iaa(d+1|0)|0;Y7(e,c,d)|0;a[e+d>>0]=0;sP(b,e)|0;jaa(e)}return b|0}function tT(){var b=0,d=0,e=0;d=l;l=l+16|0;e=d;W0(e,407712);b=(a[404919]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function uT(a,b){a=a|0;b=b|0;var d=0;d=c[a+648>>2]|0;if((raa(c[d+4>>2]|0)|0)>>>0<32){vt(a);a=0}else a=ut(d)|0;c[b>>2]=a;return}function vT(a){a=a|0;var b=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);nh(a);l=b;return}function wT(a){a=a|0;switch(a|0){case 1260:case 1259:case 1258:case 1253:case 1252:case 1251:case 1243:case 1242:case 1238:case 1237:{a=8;break}case 1256:case 1250:case 1241:case 1235:{a=10;break}default:a=0}return a|0}function xT(a){a=a|0;VD(c[a+4>>2]|0);return}function yT(b,d){b=b|0;d=d|0;var e=0;e=c[b+648>>2]|0;if(!(raa(c[e+4>>2]|0)|0)){vt(b);b=0}else b=(mO(e)|0)&1;a[d>>0]=b;return}function zT(b,c){b=b|0;c=c|0;var d=0,e=0;d=l;l=l+16|0;e=d;a[e>>0]=c;c=Es(b,e)|0;l=d;return c|0}function AT(b,d){b=b|0;d=d|0;var e=0;e=c[b+648>>2]|0;if(!(raa(c[e+4>>2]|0)|0)){vt(b);b=0}else b=(NF(e)|0)&1;a[d>>0]=b;return}function BT(){c[102054]=0;c[102055]=0;c[102056]=0;a[408344]=0;CW();kV(28);return}function CT(a){a=a|0;WN(a);return}function DT(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;f=b7(e,f)|0;d=D_(c|0,d|0,a|0,b|0)|0;d=D_(d|0,z|0,f|0,0)|0;return d|0}function ET(a){a=a|0;var b=0;b=l;l=l+16|0;NB(a,b);if((c[a+784>>2]|0)>>>0<=1)qO(a)|0;l=b;return}function FT(a){a=a|0;var b=0;b=l;l=l+16|0;bB(a,b+8|0);jB(a,b+4|0);ID(a,b);l=b;return}function GT(a){a=a|0;var b=0,d=0,e=0;if(!a)b=51568+((N0(51568)|0)<<2)|0;else{b=51568;while(1){e=c[b>>2]|0;d=(e|0)!=0;if((e|0)==(a|0)|d^1)break;else b=b+4|0}b=d?b:0}return b|0}function HT(a){a=a|0;jE(c[a+4>>2]|0);return}function IT(a){a=a|0;_N(a);return}function JT(a,b){a=a|0;b=b|0;var d=0;if(b){d=a+536|0;b=a+528|0;b=D_(c[d>>2]|0,c[d+4>>2]|0,c[b>>2]|0,c[b+4>>2]|0)|0;e1(a,b,z)}return}function KT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[a+(e<<2)>>2]=0;e=e+1|0}XT(a,b,d)|0;return}function LT(a){a=a|0;var b=0,c=0;z5(a+36|0);b=a+12|0;c=a+36|0;do{c=c+-12|0;z5(c)}while((c|0)!=(b|0));mQ(a);return}function MT(a,c){a=a|0;c=c|0;var d=0;if(!((a&255)>53|(c&255)>3)){d=b[60274+(((a&255)>>>1&255)<<3)+((c&255)<<1)>>1]|0;if(!(c<<24>>24!=1|(a&1)==0))d=(d&65535)+2&65535}else d=0;return d|0}function NT(){var b=0,d=0,e=0;d=l;l=l+16|0;e=d;W0(e,407712);b=(a[404917]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function OT(a){a=a|0;var b=0;b=ZW(760)|0;Ow(b|0,0,760)|0;M4(b);aY(a,b);Kc(b,2,-1)|0;return b|0}function PT(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;while(1){if((e|0)==(f|0)){e=f;break}a=c[e>>2]|0;if(a>>>0<128?(b[65244+(a<<1)>>1]&d)<<16>>16:0)break;e=e+4|0}return e|0}function QT(a){a=a|0;var b=0,d=0,e=0;b=c[a+4>>2]|0;e=c[a+8>>2]|0;d=(c[a>>2]|0)+(e>>1)|0;if(!(e&1))a=b;else a=c[(c[d>>2]|0)+b>>2]|0;jb[a&511](d);return}function RT(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if(c|0){if((d|0)==-1)d=FD(c)|0;e=iaa(d+1|0)|0;Y7(e,c,d)|0;a[e+d>>0]=0;cC(b,e)|0;jaa(e)}return b|0}function ST(a,b,c){a=a|0;b=+b;c=c|0;var d=0,e=0;d=l;l=l+16|0;e=d;TX(e);p2(a,io(e,b,c)|0);z5(e);l=d;return}function TT(a){a=a|0;var b=0,d=0;d=HN(a,0)|0;b=a+528|0;b=D_(d|0,z|0,c[b>>2]|0,c[b+4>>2]|0)|0;e1(a,b,z);return}function UT(){var b=0,d=0,e=0;d=l;l=l+16|0;e=d;W0(e,407712);b=(a[404918]|0)!=0;s7(c[e>>2]|0);l=d;return b|0}function VT(a){a=a|0;OE(c[a+4>>2]|0);return}function WT(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+4>>2]|0;d=a+8|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-1|0;c[d>>2]=f;e=f}laa(c[a>>2]|0);return}function XT(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if(c|0){if((d|0)==-1)d=FD(c)|0;e=iaa(d+1|0)|0;Y7(e,c,d)|0;a[e+d>>0]=0;bj(b,e)|0;jaa(e)}return b|0}function YT(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;W0(d,a+12|0);a=(c[a+8>>2]|0)==1;s7(c[d>>2]|0);l=b;return a|0}function ZT(a){a=a|0;switch(a<<24>>24){case 0:{a=384047;break}case 14:case 12:case 11:case 10:case 9:case 8:case 7:case 6:case 5:case 4:case 1:{a=384021;break}default:a=8800948}return a|0}function _T(a){a=a|0;var b=0;if((nb[c[(c[a>>2]|0)+36>>2]&255](a)|0)==-1)a=-1;else{b=a+12|0;a=c[b>>2]|0;c[b>>2]=a+4;a=raa(c[a>>2]|0)|0}return a|0}function $T(a,d){a=a|0;d=d|0;var e=0,f=0;f=d;e=d+8|0;dX(a,c[f>>2]|0,c[f+4>>2]|0,c[e>>2]|0,c[e+4>>2]|0);b[a+16>>1]=b[d+16>>1]|0;return}function aU(a){a=a|0;var b=0,d=0,e=0;d=c[a>>2]|0;if(d|0){a=a+4|0;b=c[a>>2]|0;while(1){if((b|0)==(d|0))break;e=b+-8|0;c[a>>2]=e;b=e}laa(d)}return}function bU(a){a=a|0;var b=0,d=0,e=0;d=c[a>>2]|0;if(d|0){a=a+4|0;b=c[a>>2]|0;while(1){if((b|0)==(d|0))break;e=b+-2|0;c[a>>2]=e;b=e}laa(d)}return}function cU(a){a=a|0;var b=0,d=0,e=0;d=c[a>>2]|0;if(d|0){a=a+4|0;b=c[a>>2]|0;while(1){if((b|0)==(d|0))break;e=b+-4|0;c[a>>2]=e;b=e}laa(d)}return}function dU(a){a=a|0;var b=0,d=0,e=0;d=c[a>>2]|0;if(d|0){a=a+4|0;b=c[a>>2]|0;while(1){if((b|0)==(d|0))break;e=b+-1|0;c[a>>2]=e;b=e}laa(d)}return}function eU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=b&127;f=e>>>0<64;b=f?a:a+8|0;d=c[b>>2]|0;b=c[b+4>>2]|0;a=PZ(1,0,(f?e:e+-64|0)|0)|0;return (d&a|0)!=0|(b&z|0)!=0|0}function fU(b){b=b|0;var d=0,e=0;c[b+16>>2]=7;c[b+20>>2]=-1;d=b+1038|0;e=a[d>>0]|0;c[b+772>>2]=((e&255)<<16)+3145728+((((e&255)/10|0)+48&255)<<24);a[d>>0]=e+1<<24>>24;return}function gU(a){a=a|0;pO(a);Bx(a);yd(a,0);wK(a);c[a+908>>2]=2;return}function hU(a){a=a|0;var b=0,d=0;d=a+976|0;b=((c[a+980>>2]|0)-(c[d>>2]|0)|0)/12|0;c[a+988>>2]=b;pC(d,b+1|0);return}function iU(a){a=a|0;FO(a);return}function jU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[a+32>>2]|0;if(e|0){a=a+16|0;c[a>>2]=-1;c[a+4>>2]=-1;Cy(e,b,d,0)|0}return}function kU(a){a=a|0;switch(c[a+908>>2]|0){case 4:{a=OA(a)|0;break}case 5:{a=oO(a)|0;break}default:a=1}return a|0}function lU(a){a=a|0;var b=0;if((c[a+764>>2]|0)==2053925218)Fg(a);else{b=a+536|0;e1(a,c[b>>2]|0,c[b+4>>2]|0)}return}function mU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;d=d+8|0;sb[c[(c[b>>2]|0)+16>>2]&15](a,b,c[d>>2]|0,c[d+4>>2]|0,0,e);return}function nU(){var a=0.0,b=0,d=0;b=l;l=l+16|0;d=b;W0(d,407712);a=+g[101217];s7(c[d>>2]|0);l=b;return +a}function oU(a){a=a|0;var b=0;yZ(c[a+508>>2]|0,c[a+668>>2]|0,0,0);b=a+536|0;Op(a,c[b>>2]|0,c[b+4>>2]|0);return}function pU(a){a=a|0;sO(a);return}function qU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=l;l=l+16|0;e=d;TX(e);p2(a,zo(e,b,c)|0);z5(e);l=d;return}function rU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=l;l=l+16|0;e=d;TX(e);p2(a,Ek(e,b,c)|0);z5(e);l=d;return}function sU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=l;l=l+16|0;e=d;TX(e);p2(a,Gk(e,b,c)|0);z5(e);l=d;return}function tU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=l;l=l+16|0;e=d;TX(e);p2(a,Fn(e,b,c)|0);z5(e);l=d;return}function uU(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=l;l=l+16|0;e=d;TX(e);p2(a,Ck(e,b,c)|0);z5(e);l=d;return}function vU(a,b,e){a=a|0;b=b|0;e=e|0;var f=0;while(1){if(b>>>0>=e>>>0)break;f=c[a>>2]|0;c[a>>2]=c[17300+(((d[b>>0]|0)^f&255)<<2)>>2]^f>>>8;b=b+1|0}return}function wU(){var b=0,d=0,e=0;d=l;l=l+16|0;e=d;W0(e,407712);b=a[404921]|0;s7(c[e>>2]|0);l=d;return b|0}function xU(b,d,e){b=b|0;d=d|0;e=e|0;while(1){if((d|0)==(e|0))break;b=a[d>>0]|0;if(b<<24>>24>-1)b=c[53704+(b<<24>>24<<2)>>2]&255;a[d>>0]=b;d=d+1|0}return e|0}function yU(b,d,e){b=b|0;d=d|0;e=e|0;while(1){if((d|0)==(e|0))break;b=a[d>>0]|0;if(b<<24>>24>-1)b=c[52168+(b<<24>>24<<2)>>2]&255;a[d>>0]=b;d=d+1|0}return e|0}function zU(a){a=a|0;ZO(a);return}function AU(a){a=a|0;zO(a);return}function BU(b){b=b|0;var c=0;c=b+4|0;a[b>>0]=-1;a[b+1>>0]=-1>>8;a[b+2>>0]=-1>>16;a[b+3>>0]=-1>>24;a[c>>0]=0;a[c+1>>0]=0;a[c+2>>0]=0;a[c+3>>0]=0;a[c+4>>0]=0;return}function CU(a){a=a|0;var b=0;GC(a);b=c[a+648>>2]|0;G4(b,Z9(c[b+4>>2]|0)|0);J3(a);return}function DU(a){a=a|0;var b=0;b=a+772|0;jaa(c[b>>2]|0);c[b>>2]=0;b=a+64|0;if((c[b>>2]|0)==0&(c[b+4>>2]|0)==0)jb[c[(c[a>>2]|0)+72>>2]&511](a);return}function EU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Qt(a,b,c,d);return}function FU(a,b){a=a|0;b=b|0;HC(a,b);return}function GU(b){b=b|0;Eg(b);c[b>>2]=38940;IX(b+72|0,384131)|0;a[b+493>>0]=1;b=b+760|0;c[b>>2]=0;c[b+4>>2]=0;return}function HU(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;iX(c,a);qO(a)|0;z5(c);l=b;return}function IU(a){a=a|0;var b=0,d=0;b=a+528|0;d=b;d=z0(c[d>>2]|0,c[d+4>>2]|0,12,0)|0;c[b>>2]=d;c[b+4>>2]=z;KK(a);return}function JU(a){a=a|0;cP(a);return}function KU(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}function LU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=l;l=l+16|0;f=e;g=f;c[g>>2]=b;c[g+4>>2]=d;Jz(a,f);l=e;return}function MU(){var a=0;c[101999]=0;c[101998]=57376;c[102e3]=46;c[102001]=44;c[102002]=0;c[102003]=0;c[102004]=0;a=0;while(1){if((a|0)==3)break;c[408008+(a<<2)>>2]=0;a=a+1|0}return}function NU(b){b=b|0;var d=0;c[b+16>>2]=2;d=ZW(768)|0;c2(d);c[b+776>>2]=d;a[b+785>>0]=0;b=b+768|0;c[b>>2]=48e3;c[b+4>>2]=0;return}function OU(){var b=0;c[101993]=0;c[101992]=57336;a[407976]=46;a[407977]=44;c[101995]=0;c[101996]=0;c[101997]=0;b=0;while(1){if((b|0)==3)break;c[407980+(b<<2)>>2]=0;b=b+1|0}return}function PU(a,b){a=a|0;b=b|0;if(b>>>0>10){b=ua(8)|0;K2(b,372185);c[b>>2]=57888;Ya(b|0,2728,367)}else{c[a>>2]=c[a>>2]|1<<b;return a|0}return 0}function QU(a){a=a|0;oP(a);return}function RU(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;while(1){if((c|0)==(d|0))break;b=a[c>>0]|0;a[f>>0]=b<<24>>24>-1?b:e;f=f+1|0;c=c+1|0}return d|0}function SU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[a>>2]|0;if((((c[a+4>>2]|0)-e|0)/40|0)>>>0>b>>>0)a=HZ(e+(b*40|0)|0,d)|0;else a=408468;return a|0}function TU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;wd(a,b,c,d);return}function UU(a){a=a|0;var b=0;b=a+536|0;e1(a,c[b>>2]|0,c[b+4>>2]|0);W5(a);V5(a);return}function VU(a,b){a=a|0;b=b|0;var d=0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[a+(d<<2)>>2]=0;d=d+1|0}bj(a,b)|0;return}function WU(a){a=a|0;W5(a);RB(a,0,0,57,379951,-1,1,0);Kc(a,2,-1)|0;c[a+1052>>2]=3;return}function XU(a){a=a|0;switch(a<<24>>24){case 0:{a=387774;break}case 1:{a=387760;break}case 2:{a=387743;break}case 3:{a=387716;break}default:a=391260}return a|0}function YU(a){a=a|0;if(a>>>0>=255)if((a+-57344|0)>>>0<8185|(a>>>0<8232|(a+-8234|0)>>>0<47062))a=1;else return (a&65534|0)!=65534&(a+-65532|0)>>>0<1048580&1|0;else a=(a+1&127)>>>0>32&1;return a|0}function ZU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=c[b>>2]|0;if((((c[b+4>>2]|0)-e|0)/40|0)>>>0>d>>>0)de(a,e+(d*40|0)|0);else TX(a);return}function _U(a){a=a|0;TX(a);TX(a+12|0);b4(a+24|0);TX(a+48|0);TX(a+60|0);return}function $U(a){a=a|0;if((c[a+548>>2]|0)>>>0>=4)if((C9(c[a+544>>2]|0)|0)==1380533830){V5(a);a=0}else a=1;else a=0;return a|0}function aV(a){a=a|0;c[a>>2]=54864;D$(a+4|0);a=a+8|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;return}function bV(a){a=a|0;c[a>>2]=54800;D$(a+4|0);a=a+8|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;return}function cV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=0;while(1){if((b|0)==(d|0))break;e=(c[b>>2]|0)+(a<<4)|0;f=e&-268435456;a=(f>>>24|f)^e;b=b+4|0}return a|0}function dV(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;b=0;while(1){if((c|0)==(d|0))break;e=(a[c>>0]|0)+(b<<4)|0;f=e&-268435456;b=(f>>>24|f)^e;c=c+1|0}return b|0}function eV(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;bD(a,d);e1(a,c[d>>2]|0,0);l=b;return}function fV(b,c,d){b=b|0;c=c|0;d=d|0;if(!((b|0)==0&(c|0)==0))do{d=d+-1|0;a[d>>0]=b&7|48;b=XZ(b|0,c|0,3)|0;c=z}while(!((b|0)==0&(c|0)==0));return d|0}function gV(a){a=a|0;var b=0,d=0;d=a+536|0;b=a+528|0;b=D_(c[d>>2]|0,c[d+4>>2]|0,c[b>>2]|0,c[b+4>>2]|0)|0;e1(a,b,z);return}function hV(a){a=a|0;MP(a);return}function iV(a){a=a|0;HP(a);return}function jV(a){a=a|0;z5(a+60|0);z5(a+48|0);w4(a+24|0);z5(a+12|0);z5(a);return}function kV(a){a=a|0;var b=0;b=c[102055]|0;do{c[b>>2]=0;b=(c[102055]|0)+4|0;c[102055]=b;a=a+-1|0}while((a|0)!=0);return}function lV(b){b=b|0;c[b>>2]=0;c[b+4>>2]=7;c[b+8>>2]=-1;a[b+12>>0]=1;a[b+13>>0]=1;b=b+16|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;return}function mV(a,b){a=a|0;b=b|0;var d=0,e=0;e=c[a+4>>2]|0;d=c[b+4>>2]|0;return e>>>0<d>>>0|((e|0)==(d|0)?(c[a>>2]|0)>>>0<(c[b>>2]|0)>>>0:0)|0}function nV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=a+20|0;f=c[e>>2]|0;a=(c[a+16>>2]|0)-f|0;a=a>>>0>d>>>0?d:a;no(f|0,b|0,a|0)|0;c[e>>2]=(c[e>>2]|0)+a;return d|0}function oV(a){a=a|0;TP(a);return}function pV(a,b,d){a=a|0;b=b|0;d=d|0;while(1){if((b|0)==(d|0))break;a=c[b>>2]|0;if(a>>>0<128)a=c[53704+(a<<2)>>2]|0;c[b>>2]=a;b=b+4|0}return d|0}function qV(a,b,d){a=a|0;b=b|0;d=d|0;while(1){if((b|0)==(d|0))break;a=c[b>>2]|0;if(a>>>0<128)a=c[52168+(a<<2)>>2]|0;c[b>>2]=a;b=b+4|0}return d|0}function rV(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];c[a+4>>2]=c[b+4>>2];c[a+8>>2]=c[b+8>>2];a=0;while(1){if((a|0)==3)break;c[b+(a<<2)>>2]=0;a=a+1|0}return}function sV(b){b=b|0;var d=0,e=0;d=c[b+508>>2]|0;e=c[b+668>>2]|0;a[e+(d*24|0)+16>>0]=0;a[e+(d*24|0)+18>>0]=1;vt(b);return}function tV(b,c,d,e,f,g){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;a[b>>0]=c;a[b+1>>0]=d;a[b+2>>0]=e;a[b+3>>0]=f;a[b+4>>0]=g&1;return}function uV(b,d){b=b|0;d=d|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;a[b+11>>0]=1;NZ(b,1,45)|0;J7(b+1|0,0);return}function vV(a){a=a|0;c[a>>2]=28152;cU(a+788|0);QW(a+776|0);bt(a);return}function wV(b){b=b|0;var d=0,e=0;e=l;l=l+16|0;d=e;if((c[b+908>>2]|0)==4?(a[b+492>>0]|0)==0:0){TX(d);z5(d)}l=e;return}function xV(a){a=a|0;var b=0,d=0;d=c[a+1048>>2]|0;a=a+1052|0;while(1){b=c[a>>2]|0;if((b|0)==(d|0))break;b=b+-12|0;c[a>>2]=b;z5(b)}return}function yV(a){a=a|0;RI(c[a+4>>2]|0);return}function zV(a){a=a|0;SI(c[a+4>>2]|0);return}function AV(a){a=a|0;TI(c[a+4>>2]|0);return}function BV(a){a=a|0;UI(c[a+4>>2]|0);return}function CV(a){a=a|0;VI(c[a+4>>2]|0);return}function DV(a){a=a|0;WI(c[a+4>>2]|0);return}function EV(a){a=a|0;XI(c[a+4>>2]|0);return}function FV(b,d){b=b|0;d=d|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;a[b+8+3>>0]=1;$2(b,1,45);y7(b+4|0,0);return}function GV(a){a=a|0;c[a>>2]=54784;jQ(a);c6(a+28|0);pe(c[a+32>>2]|0);pe(c[a+36>>2]|0);pe(c[a+48>>2]|0);pe(c[a+60>>2]|0);return}function HV(b){b=b|0;if(qO(b)|0)a[(bF(b+916|0,b+788|0)|0)+275>>0]=1;return}function IV(a){a=a|0;var b=0;if(c[a+68>>2]|0){b=c[a+116>>2]|0;a=a+112|0;if(b|0)c[b+112>>2]=c[a>>2];a=c[a>>2]|0;c[((a|0)==0?51304:a+116|0)>>2]=b}return}function JV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=a;c[f>>2]=b;c[f+4>>2]=d;b=e;d=c[b+4>>2]|0;e=a+8|0;c[e>>2]=c[b>>2];c[e+4>>2]=d;return}function KV(a){a=a|0;var b=0,d=0;if(!(c[a+612>>2]|0)){d=c[a+548>>2]|0;b=a+780|0;a=(d|0)==(c[b>>2]|0);c[b>>2]=a?0:d}else a=0;return a|0}function LV(a){a=a|0;pQ(a);return}function MV(b){b=b|0;var d=0;Eg(b);c[b>>2]=27392;d=b+768|0;c[d>>2]=-1;c[d+4>>2]=0;a[b+760>>0]=0;a[b+761>>0]=0;a[b+762>>0]=0;return}function NV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[a+104>>2]=b;d=c[a+8>>2]|0;e=c[a+4>>2]|0;f=d-e|0;c[a+108>>2]=f;c[a+100>>2]=(b|0)!=0&(f|0)>(b|0)?e+b|0:d;return}function OV(a){a=a|0;switch(a|0){case 0:{a=381149;break}case 1:{a=383821;break}case 2:{a=381141;break}case 3:{a=381130;break}default:a=8800948}return a|0}function PV(a){a=a|0;var b=0,d=0;c[a>>2]=27760;b=a+768|0;d=c[b>>2]|0;if(d|0){nm(d);laa(d)}c[b>>2]=0;bt(a);return}function QV(a,b){a=a|0;b=b|0;var d=0;if(b>>>0>1073741823)uaa();else{d=ZW(b<<2)|0;c[a+4>>2]=d;c[a>>2]=d;c[a+8>>2]=d+(b<<2);return}}function RV(a){a=a|0;if(!(RA(c[a>>2]|0,2,-1)|0))Kc(c[a>>2]|0,2,-1)|0;return}function SV(a,b){a=a|0;b=b|0;var d=0;if(b>>>0>536870911)uaa();else{d=ZW(b<<3)|0;c[a+4>>2]=d;c[a>>2]=d;c[a+8>>2]=d+(b<<3);return}}function TV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if((c[a+4>>2]|0)==(b|0)?(e=a+28|0,(c[e>>2]|0)!=1):0)c[e>>2]=d;return}function UV(a){a=a|0;var b=0,d=0,e=0;d=c[a+1032>>2]|0;a=a+1036|0;b=c[a>>2]|0;while(1){if((b|0)==(d|0))break;e=b+-16|0;c[a>>2]=e;b=e}return}function VV(a){a=a|0;var b=0;KK(a);a=a+528|0;b=a;b=z0(c[b>>2]|0,c[b+4>>2]|0,4,0)|0;c[a>>2]=b;c[a+4>>2]=z;return}function WV(a,b,d){a=a|0;b=b|0;d=d|0;d=d&65535;if((a|0)==(b|0))d=0;else d=(c[a+(d*12|0)>>2]|0)!=(c[a+(d*12|0)+4>>2]|0);return d|0}function XV(a,b){a=a|0;b=b|0;var d=0;d=a+648|0;a=b&255;do BH(c[d>>2]|0,a);while(NF(c[d>>2]|0)|0);return}function YV(a){a=a|0;var b=0;if((((a|0?c[a+32>>2]|0:0)?c[a+36>>2]|0:0)?(b=c[a+28>>2]|0,b|0):0)?(c[b>>2]|0)==(a|0):0)return ((c[b+4>>2]|0)+-16180|0)>>>0>31|0;return 1}function ZV(a){a=a|0;var b=0;a=c[a+8>>2]|0;if(a){b=a0(a)|0;a=m9()|0;if(b)a0(b)|0}else a=1;return a|0}function _V(a){a=a|0;QU(a+12|0);qY(a);return}function $V(a){a=a|0;QQ(a);return}function aW(a){a=a|0;RQ(a);return}function bW(a){a=a|0;var b=0,d=0;a=L7(c[a>>2]|0)|0;d=a+8|0;b=c[d>>2]|0;c[d>>2]=b+-1;if((b+-1|0)<0)laa(a);return}function cW(a){a=a|0;var b=0,e=0;e=l;l=l+16|0;b=e;if((QF(a)|0)==0?(gb[c[a+32>>2]&31](a,b,1)|0)==1:0)a=d[b>>0]|0;else a=-1;l=e;return a|0}function dW(a){a=a|0;var b=0,d=0;b=a+64|0;d=c[b>>2]|0;if(d|0?(nb[c[(c[a>>2]|0)+24>>2]&255](a)|0,(GE(d)|0)==0):0)c[b>>2]=0;return}function eW(a){a=a|0;Bx(a);Ob(a);CU(a);wK(a);return}function fW(a){a=a|0;var b=0,d=0,e=0;e=a+40|0;d=c[e+4>>2]|0;b=a+528|0;c[b>>2]=c[e>>2];c[b+4>>2]=d;V5(a);return}function gW(a,b){a=a|0;b=b|0;var d=0;d=a+64|0;if((c[d>>2]|0)==0?(b=iB(b)|0,c[d>>2]=b,(b|0)!=0):0)c[a+88>>2]=12;else a=0;return a|0}function hW(a){a=a|0;switch(c[a+908>>2]|0){case 4:{RF(a);break}case 5:{rC(a);break}default:{}}return}function iW(a,b){a=a|0;b=b|0;if((b|0)<0)uaa();else{b=((b+-1|0)>>>5)+1|0;c[a>>2]=ZW(b<<2)|0;c[a+4>>2]=0;c[a+8>>2]=b;return}}function jW(b){b=b|0;var d=0;d=b+768|0;zb(b,0,0,100,(c[d>>2]|0)+40|0,1);a[(c[d>>2]|0)+52>>0]=0;return}function kW(a,b){a=a|0;b=b|0;var d=0;if((b|0)<0)uaa();else{d=ZW(b<<1)|0;c[a+4>>2]=d;c[a>>2]=d;c[a+8>>2]=d+(b<<1);return}}function lW(a){a=a|0;var b=0;b=a+1064|0;c[b>>2]=-1;c[b+4>>2]=-1;c[b+8>>2]=-1;c[b+12>>2]=-1;Zc(a);return}function mW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(d|0){e=a;while(1){d=d+-1|0;c[e>>2]=c[b>>2];if(!d)break;else{b=b+4|0;e=e+4|0}}}return a|0}function nW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;g=l;l=l+16|0;f=g|0;ph(a,b,d,e,f)|0;l=g;return (z=c[f+4>>2]|0,c[f>>2]|0)|0}function oW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;return}function pW(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return qb[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function qW(a,b){a=a|0;b=b|0;var c=0;c=0;do c=(tn(a,b)|0)+c|0;while(NF(a)|0);return c|0}function rW(a){a=a|0;vR(a);return}function sW(b){b=b|0;var d=0;c[b>>2]=5636;d=b+4|0;c[b+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;a[b+28>>0]=1;a[b+29>>0]=0;return}function tW(a){a=a|0;var b=0.0;b=+MB(a);if(qO(a)|0?(c[a+880>>2]|0)>>>0<=1:0)h[a+832>>3]=b;return}function uW(b){b=b|0;var d=0;Eg(b);d=b+760|0;BG(d);c[b>>2]=15244;c[d>>2]=b;a[b+890>>0]=0;a[b+891>>0]=0;return}function vW(a){a=a|0;var b=0,c=0;b=a&65535;a=0;c=0;while(1){if((c|0)==13)break;a=((d[371852+c>>0]|0)&0-(b>>>c&1))+(a&255)&255;c=c+1|0}return a|0}function wW(a){a=a|0;UR(a);return}function xW(a){a=a|0;var b=0;while(1){b=c[a>>2]|0;if(b|0){a=b;continue}b=c[a+4>>2]|0;if(!b)break;else a=b}return a|0}function yW(a){a=a|0;switch(a<<24>>24){case 0:{a=381128;break}case 1:{a=384021;break}case 2:{a=384021;break}default:a=8800948}return a|0}function zW(a){a=a|0;var b=0;b=c[a>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);a=c[a+4>>2]|0;if(a|0)laa(a);return}function AW(a,b){a=a|0;b=b|0;wz(a,b);p2(a+12|0,b+12|0);return}function BW(a){a=a|0;var b=0;if(a)if(!(a&1)){b=a;a=0;do{a=a+1|0;b=b>>>1}while(!(b&1|0))}else a=0;else a=32;return a|0}function CW(){var b=0;if(!(a[408344]|0)){a[408344]=1;b=408232}else b=ZW(112)|0;c[102055]=b;c[102054]=b;c[102056]=b+112;return}function DW(a,b,c){a=a|0;b=b|0;c=c|0;return Ts(a,b,c,i9(c)|0)|0}function EW(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function FW(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return (c|0)==(g|0)&(d|0)==(h|0)&((a|0)==(e|0)&(b|0)==(f|0))|0}function GW(a){a=a|0;WR(a);return}function HW(a){a=a|0;var b=0;b=l;l=l+16|0;bB(a,b+4|0);jB(a,b);l=b;return}function IW(){var a=0,b=0;a=l;l=l+16|0;if(!(Pa(411032,2)|0)){b=Qa(c[102759]|0)|0;l=a;return b|0}else Y$(404398,a);return 0}function JW(a){a=a|0;var b=0;if(!(YV(a)|0)){b=c[a+28>>2]|0;c[b+44>>2]=0;c[b+48>>2]=0;c[b+52>>2]=0;a=SB(a)|0}else a=-2;return a|0}function KW(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;Bt(a,b,c,d,e,f,g);return}function LW(a,b){a=a|0;b=b|0;ST(a,+((((b>>>8&15)*100|0)+(b&15)+((b>>>12&15)*1e3|0)+((b>>>4&15)*10|0)|0)>>>0)/10.0,1);return}function MW(a){a=a|0;fS(a);return}function NW(a){a=a|0;c[a>>2]=42300;c[a+64>>2]=42340;c[a+8>>2]=42320;_W(a+12|0);return}function OW(a){a=a|0;var b=0;c[a>>2]=28276;b=c[a+776>>2]|0;if(b|0)jb[c[(c[b>>2]|0)+4>>2]&511](b);bt(a);return}function PW(b){b=b|0;var d=0;c[b+16>>2]=2;d=ZW(896)|0;uW(d);c[b+776>>2]=d;a[d+890>>0]=1;a[b+785>>0]=0;return}function QW(a){a=a|0;jS(a);return}function RW(a){a=a|0;switch(a<<24>>24){case 1:{a=384035;break}case 2:{a=384029;break}case 3:{a=384041;break}default:a=8800948}return a|0}function SW(a,b){a=a|0;b=b|0;var d=0;a=a+8|0;d=c[a>>2]|0;Ow(d|0,0,b*12|0)|0;c[a>>2]=d+(b*12|0);return}function TW(a){a=a|0;var b=0;Eg(a);b=a+760|0;BG(b);L2(a+896|0);c[a>>2]=13388;c[b>>2]=a;return}function UW(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;f=c;c=NQ(e,f)|0;a=z;return (z=(O(b,f)|0)+(O(d,e)|0)+a|a&0,c|0|0)|0}function VW(a){a=a|0;sS(a);return}function WW(a){a=a|0;tS(a);return}function XW(a){a=a|0;GC(a);II(a);Ai(a);J3(a);return}function YW(a){a=a|0;i_(a);i_(a+16|0);return}function ZW(a){a=a|0;var b=0;b=(a|0)==0?1:a;while(1){a=Ub(b)|0;if(a|0)break;a=H7()|0;if(!a){a=0;break}pb[a&3]()}return a|0}function _W(a){a=a|0;c[a>>2]=42096;O0(a+32|0);F3(a);return}function $W(a){a=a|0;c[a>>2]=38792;a1(a+32|0);G3(a);return}function aX(a){a=a|0;var b=0;b=c[a+760>>2]|0;if(((c[a+764>>2]|0)-b|0)==4)jy(c[b>>2]|0);return}function bX(a,c){a=a|0;c=c|0;b[a>>1]=b[c>>1]|0;Sg(a+4|0,c+4|0);return}function cX(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function dX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=a;c[g>>2]=b;c[g+4>>2]=d;d=a+8|0;c[d>>2]=e;c[d+4>>2]=f;return}function eX(a){a=a|0;GC(a);A6(c[a+648>>2]|0);J3(a);return}function fX(a){a=a|0;qY(a+28|0);z5(a+16|0);z5(a+4|0);return}function gX(a){a=a|0;c[a>>2]=-1;TX(a+4|0);TX(a+16|0);x1(a+28|0);return}function hX(a){a=a|0;var b=0;b=l;l=l+16|0;pe(a);if(!(Wa(c[102759]|0,0)|0)){l=b;return}else Y$(404497,b)}function iX(a,b){a=a|0;b=b|0;var d=0;TX(a);d=b+536|0;xZ(b,c[d>>2]|0,c[d+4>>2]|0,a);return}function jX(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;if((c[a+12>>2]|0)-d>>2>>>0>b>>>0)a=(c[d+(b<<2)>>2]|0)!=0;else a=0;return a|0}function kX(a){a=a|0;if((c[a+880>>2]|0)>>>0<=1){a=a+848|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0}return}function lX(a){a=a|0;var b=0;b=a+1032|0;eG(b,((c[a+1036>>2]|0)-(c[b>>2]|0)>>4)+1|0);return}function mX(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((c|0)==(d|0))break;a[e>>0]=a[c>>0]|0;e=e+1|0;c=c+1|0}return d|0}function nX(a){a=a|0;switch(a|0){case 16:{a=384047;break}case 17:{a=381128;break}case 18:{a=384021;break}default:a=8800948}return a|0}function oX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return (FW(a,b,c,d,e,f,g,h)|0)^1|0}function pX(a){a=a|0;var b=0;b=ZW(760)|0;Ow(b|0,0,760)|0;M4(b);aY(a,b);return b|0}function qX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return fb[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function rX(a){a=a|0;if(a)if(!(c[a>>2]|0))a=(c[a+4>>2]|0)!=0;else a=1;else a=0;return a|0}function sX(a){a=a|0;var b=0;a=a+528|0;b=a;b=z0(c[b>>2]|0,c[b+4>>2]|0,10,0)|0;c[a>>2]=b;c[a+4>>2]=z;return}function tX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;while(1){if((d|0)==(e|0))break;c[f>>2]=a[d>>0];f=f+4|0;d=d+1|0}return e|0}function uX(a){a=a|0;RB(a,1,0,18,384131,-1,1,0);RB(a,1,0,58,384131,-1,1,0);return}function vX(a,b){a=a|0;b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;c[e>>2]=a;c[e+4>>2]=b;b=b6(Ea(195,e|0)|0)|0;l=d;return b|0}function wX(a){a=a|0;kS(a);return}function xX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(d|0){e=a;while(1){d=d+-1|0;c[e>>2]=b;if(!d)break;else e=e+4|0}}return a|0}function yX(a){a=a|0;Bx(a);d4(c[a+648>>2]|0,3);wK(a);return}function zX(a){a=a|0;jR(a);RB(a,1,0,52,378985,-1,1,1);return}function AX(b){b=b|0;if((c[b+728>>2]&2|0)==0?a[b+1016>>0]|0:0){W5(b);V5(b)}return}function BX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=l;l=l+16|0;g=f;c[g>>2]=e;e=Bq(a,b,d,g)|0;l=f;return e|0}function CX(a,b){a=a|0;b=b|0;var d=0;a=a+4|0;d=c[a>>2]|0;Ow(d|0,0,b*12|0)|0;c[a>>2]=d+(b*12|0);return}function DX(){c[101926]=0;c[101927]=0;c[101925]=407704;return}function EX(a){a=a|0;RX(a+12|0);z5(a);return}function FX(a){a=a|0;switch(a&74){case 64:{a=8;break}case 8:{a=16;break}case 0:{a=0;break}default:a=10}return a|0}function GX(a,b){a=a|0;b=b|0;return sx(a,b,i9(b)|0)|0}function HX(a,b){a=a|0;b=b|0;return Ex(a,b,i9(b)|0)|0}function IX(a,b){a=a|0;b=b|0;return Qx(a,b,j9(b)|0)|0}function JX(a,b){a=a|0;b=b|0;return Wx(a,b,j9(b)|0)|0}function KX(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;c[d>>2]=raa(c[a+60>>2]|0)|0;a=b6(_a(6,d|0)|0)|0;l=b;return a|0}function LX(a){a=a|0;var b=0;a=a+528|0;b=a;b=z0(c[b>>2]|0,c[b+4>>2]|0,1,0)|0;c[a>>2]=b;c[a+4>>2]=z;return}function MX(a){a=a|0;var b=0;a=a+528|0;b=a;b=z0(c[b>>2]|0,c[b+4>>2]|0,2,0)|0;c[a>>2]=b;c[a+4>>2]=z;return}function NX(){c[102035]=0;c[102034]=57460;x9();c[102034]=55308;c[102036]=55356;return}function OX(){c[102031]=0;c[102030]=57460;y9();c[102030]=55224;c[102032]=55272;return}function PX(b){b=b|0;if(!(a[b+768>>0]|0)){if(a[b+769>>0]|0)qq(b)}else nB(b);return}function QX(a){a=a|0;var b=0;b=BW((c[a>>2]|0)+-1|0)|0;if(!b){b=BW(c[a+4>>2]|0)|0;return ((b|0)==0?0:b+32|0)|0}else return b|0;return 0}function RX(a){a=a|0;xT(a);return}function SX(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return rS(e,f,g,h,a,b,c,d)|0}function TX(a){a=a|0;var b=0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function UX(a,b){a=a|0;b=b|0;var d=0,e=0;d=l;l=l+16|0;e=d;c[e>>2]=a;c[e+4>>2]=b;b6(La(91,e|0)|0)|0;l=d;return}function VX(a){a=a|0;var b=0;b=a+8|0;if((c[b>>2]|0)==0&(c[b+4>>2]|0)==0)a=(c[a>>2]|0)==0&(c[a+4>>2]|0)==0;else a=0;return a|0}function WX(b){b=b|0;a[b+172>>0]=a[b+174>>0]|a[b+173>>0]|a[b+175>>0]|a[b+176>>0]|a[b+177>>0]|a[b+178>>0];return}function XX(a){a=a|0;HT(a);return}function YX(a){a=a|0;fY(a);N7(a+56|0);return}function ZX(a){a=a|0;gY(a);N7(a+56|0);return}function _X(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ~~(+(b&255)*+M(+(+(d&255)/+(c&255)))/(a?.9010912775993347:.6931471824645996)+.5)&255|0}function $X(a){a=a|0;var b=0;b=a+536|0;e1(a,c[b>>2]|0,c[b+4>>2]|0);V5(a);return}function aY(a,b){a=a|0;b=b|0;var d=0;d=a+40|0;JH(a,b,c[d>>2]|0,c[d+4>>2]|0);return}function bY(a){a=a|0;YX(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function cY(a){a=a|0;s$(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function dY(a){a=a|0;ZX(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function eY(a){a=a|0;t$(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function fY(a){a=a|0;c[a>>2]=42060;c[a+56>>2]=42080;_W(a+4|0);return}function gY(a){a=a|0;c[a>>2]=38756;c[a+56>>2]=38776;$W(a+4|0);return}function hY(a){a=a|0;NW(a);N7(a+64|0);return}function iY(a,b){a=a|0;b=b|0;var d=0;a=a+8|0;d=c[a>>2]|0;Ow(d|0,0,b<<3|0)|0;c[a>>2]=d+(b<<3);return}function jY(a,b){a=a|0;b=b|0;var d=0;a=a+8|0;d=c[a>>2]|0;Ow(d|0,0,b<<2|0)|0;c[a>>2]=d+(b<<2);return}function kY(a){a=a|0;var b=0;b=a+536|0;e1(a,c[b>>2]|0,c[b+4>>2]|0);KM(a);return}function lY(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;c[d>>2]=raa(a)|0;a=_a(6,d|0)|0;b6((a|0)==-4?0:a)|0;l=b;return}function mY(a){a=a|0;hY(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function nY(a){a=a|0;y$(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function oY(b,d){b=b|0;d=d|0;return cC(b,(a[d+11>>0]|0)<0?c[d>>2]|0:d)|0}function pY(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;d=PZ(1,0,d|0)|0;a[e>>0]=((d&b|0)!=0|(z&c|0)!=0)&1;return}function qY(a){a=a|0;VT(a);return}function rY(a){a=a|0;return Vu(a,j9(404776)|0)|0}function sY(b,d){b=b|0;d=d|0;return bj(b,(a[d+11>>0]|0)<0?c[d>>2]|0:d)|0}function tY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;Bt(a,2,b,c,d,e,0);return}function uY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;_u(a,b,c,d);return}function vY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;$u(a,b,c,d);return}function wY(a,b,d){a=a|0;b=b|0;d=d|0;c[a+52>>2]=0;c[a+56>>2]=0;c[a+60>>2]=b;c[a+64>>2]=b;c[a+72>>2]=d;return}function xY(a){a=a|0;var b=0;a=a+528|0;b=a;b=z0(c[b>>2]|0,c[b+4>>2]|0,12,0)|0;c[a>>2]=b;c[a+4>>2]=z;return}function yY(a){a=a|0;var b=0;c[a>>2]=57216;a=a+8|0;b=c[a>>2]|0;if((b|0)!=(b0()|0))R8(c[a>>2]|0);return}function zY(a,b){a=a|0;b=b|0;k1(yG(405008,a)|0,b)|0;return}function AY(a){a=a|0;var b=0;a=a+528|0;b=a;b=z0(c[b>>2]|0,c[b+4>>2]|0,8,0)|0;c[a>>2]=b;c[a+4>>2]=z;return}function BY(a){a=a|0;var b=0;a=a+528|0;b=a;b=z0(c[b>>2]|0,c[b+4>>2]|0,4,0)|0;c[a>>2]=b;c[a+4>>2]=z;return}function CY(a){a=a|0;W5(a);RB(a,0,0,57,379540,-1,1,0);c[a+1052>>2]=2;return}function DY(a){a=a|0;W5(a);RB(a,0,0,57,379583,-1,1,0);c[a+1052>>2]=4;return}function EY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;d=l;l=l+16|0;b=d;c[b>>2]=e;e=zw(a,100,403481,b)|0;l=d;return e|0}function FY(a){a=a|0;z5(a+12|0);a1(a);return}function GY(b){b=b|0;x1(b);x1(b+12|0);a[b+24>>0]=0;return}function HY(a,b){a=a|0;b=b|0;var d=0;a=a+4|0;d=c[a>>2]|0;Ow(d|0,0,b<<3|0)|0;c[a>>2]=d+(b<<3);return}function IY(a,b){a=a|0;b=b|0;var d=0;a=a+4|0;d=c[a>>2]|0;Ow(d|0,0,b<<2|0)|0;c[a>>2]=d+(b<<2);return}function JY(a){a=a|0;c[a>>2]=41900;c[a+112>>2]=41940;c[a+8>>2]=41920;cS(a+12|0);return}function KY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return ul(c,d,e)|0}function LY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return lb[a&63](b|0,c|0,d|0,e|0,f|0,g|0)|0}function MY(a,b,c){a=a|0;b=b|0;c=c|0;if(!b)c=0;else c=fs(a,e9(c)|0,b)|0;return c|0}function NY(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ll(c,d,e)|0}function OY(a){a=a|0;if(!(c[a+728>>2]&1))jk(a);else ah(a);return}function PY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=l;l=l+16|0;f=e;c[f>>2]=b;d=zf(a,f,d,0)|0;l=e;return d|0}function QY(){var a=0,b=0;a=(d3(391569,43)|0)==0;a=a?0:2;b=(d3(391569,120)|0)==0;a=b?a:a|128;b=(d3(391569,101)|0)==0;return (b?a:a|524288)|0}function RY(a,b){a=a|0;b=b|0;var d=0;d=a;c[d>>2]=b;c[d+4>>2]=((b|0)<0)<<31>>31;a=a+8|0;c[a>>2]=0;c[a+4>>2]=0;return}function SY(a){a=a|0;var b=0;b=l;l=l+16|0;r3(a,b);l=b;return}function TY(a){a=a|0;if(!(c[a+728>>2]&1))wi(a);else $X(a);return}function UY(a){a=a|0;jV(a+4|0);return}function VY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ev(a,b,c,d);return}function WY(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;fv(a,b,c,d);return}function XY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=l;l=l+16|0;f=e;c[f>>2]=b;d=Ql(a,f,d)|0;l=e;return d|0}function YY(){c[102043]=0;c[102042]=57460;c[102044]=b0()|0;c[102042]=56696;return}function ZY(){c[102039]=0;c[102038]=57460;c[102040]=b0()|0;c[102038]=56672;return}function _Y(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;un(a,b,c,d,e);return}function $Y(a){a=a|0;var b=0;b=a+288|0;c[b>>2]=0;c[b+4>>2]=0;a=a+304|0;c[a>>2]=0;c[a+4>>2]=0;return}function aZ(b){b=b|0;if((a[407856]|0)==0?E3(407856)|0:0){tk();c[102657]=410340}return c[102657]|0}function bZ(a){a=a|0;var b=0;b=HN(a,0)|0;a=a+528|0;c[a>>2]=b;c[a+4>>2]=z;return}function cZ(a){a=a|0;var b=0;b=an(a)|0;a=a+872|0;c[a>>2]=b;c[a+4>>2]=z;return}function dZ(){var a=0;a=l;l=l+16|0;if(!(qa(411036,377)|0)){l=a;return}else Y$(404447,a)}function eZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;return ib[a&3](b|0,c|0,d|0,e|0,f|0,+g)|0}function fZ(a){a=a|0;if(a>>>0<131072)a=(d[395113+((d[395113+(a>>>8)>>0]|0)<<5|a>>>3&31)>>0]|0)>>>(a&7)&1;else a=a>>>0<196606&1;return a|0}function gZ(b){b=b|0;if((a[407776]|0)==0?E3(407776)|0:0){qk();c[102454]=409528}return c[102454]|0}function hZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=b;c[e+4>>2]=d;d=a+8|0;c[d>>2]=0;c[d+4>>2]=0;return}function iZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ov(a,b,c,d);return}function jZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;kv(a,b,c,d);return}function kZ(b){b=b|0;if((a[407872]|0)==0?E3(407872)|0:0){oo();c[102700]=410632}return c[102700]|0}function lZ(b){b=b|0;if((a[407840]|0)==0?E3(407840)|0:0){PF();c[102584]=410048}return c[102584]|0}function mZ(a,b,c){a=a|0;b=b|0;c=c|0;c=z0(b|0,c|0,-2082844800,-1)|0;return We(a,c,z)|0}function nZ(a){a=a|0;c[a>>2]=16132;z5(a+944|0);aI(a+760|0);bt(a);return}function oZ(a){a=a|0;Bx(a);go(a);wK(a);return}function pZ(b,c,d){b=b|0;c=c|0;d=d|0;d=a[b+19032+(c<<6)+d>>0]|0;return (d<<24>>24==14?1:(d<<24>>24==15)<<31>>31)|0}function qZ(a){a=a|0;RX(a+8|0);return}function rZ(b){b=b|0;if((a[407792]|0)==0?E3(407792)|0:0){ko();c[102497]=409820}return c[102497]|0}function sZ(b){b=b|0;if((a[407760]|0)==0?E3(407760)|0:0){LF();c[102381]=409236}return c[102381]|0}function tZ(a,b,c){a=a|0;b=b|0;c=c|0;c=z0(b|0,c|0,1240428288,-3)|0;return We(a,c,z)|0}function uZ(a){a=a|0;var b=0;c[a+16>>2]=2;b=ZW(760)|0;T4(b);c[a+776>>2]=b;return}function vZ(a){a=a|0;var b=0;c[a+16>>2]=1;b=ZW(760)|0;U4(b);c[a+776>>2]=b;return}function wZ(b,c){b=b|0;c=c|0;a[b+177>>0]=c&1;WX(b);return}function xZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;nv(a,b,c,d);return}function yZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;b=b+((a+-1|0)*24|0)|0;c[b>>2]=d;c[b+4>>2]=e;return}function zZ(a){a=a|0;if((J2(a+4|0)|0)==-1)jb[c[(c[a>>2]|0)+8>>2]&511](a);return}function AZ(a){a=a|0;$c(a,a+900|0,a+912|0);return}function BZ(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;yZ(a,b,c,d);return}function CZ(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;sb[a&15](b|0,c|0,d|0,e|0,f|0,g|0)}function DZ(a){a=a|0;CT(a);return}function EZ(b,c){b=b|0;c=c|0;a[b+178>>0]=c&1;WX(b);return}function FZ(a){a=a|0;iU(a);return}function GZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;b=l;l=l+16|0;e=b;c[e>>2]=d;d=VN(a,404119,e)|0;l=b;return d|0}function HZ(a,b){a=a|0;b=b|0;var d=0;d=c[a>>2]|0;return ((((c[a+4>>2]|0)-d|0)/12|0)>>>0>b>>>0?d+(b*12|0)|0:408468)|0}function IZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=e;c[a+4>>2]=b;c[a+8>>2]=d;return}function JZ(b){b=b|0;if(!(a[b+28>>0]|0))b=((c[b+12>>2]|0)-(c[b+16>>2]|0)|0)>>>3;else b=0;return b|0}function KZ(b){b=b|0;if(!(a[b+760>>0]|0))Ig(b);else $X(b);return}function LZ(a){a=a|0;d4(c[a+648>>2]|0,4);Jo(a,0);return}function MZ(a){a=a|0;Bx(a);Hn(a);wK(a);return}function NZ(a,b,c){a=a|0;b=b|0;c=c|0;if(b|0)Ow(a|0,(e9(c)|0)&255|0,b|0)|0;return a|0}function OZ(b,c){b=b|0;c=c|0;a[b+174>>0]=c&1;WX(b);return}function PZ(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){z=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}z=a<<c-32;return 0}function QZ(a){a=a|0;wX(a+4|0);return}function RZ(b,c){b=b|0;c=c|0;a[b+175>>0]=c&1;WX(b);return}function SZ(a){a=a|0;var b=0;b=c[a+32>>2]|0;if(b|0){z7(b);laa(b)}z5(a+20|0);return}function TZ(b,c){b=b|0;c=c|0;a[b+176>>0]=c&1;WX(b);return}function UZ(b,c){b=b|0;c=c|0;a[b+173>>0]=c&1;WX(b);return}function VZ(a){a=a|0;wR(a);return}function WZ(a){a=a|0;var b=0;b=l;l=l+16|0;ID(a,b);l=b;return}function XZ(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){z=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}z=0;return b>>>c-32|0}function YZ(b,d,e){b=b|0;d=d|0;e=e|0;c[b>>2]=d;e=e<<3;c[b+8>>2]=e;c[b+4>>2]=e;a[b+13>>0]=0;return}function ZZ(a){a=a|0;var b=0;taa();b=c[102272]|0;c[a+56>>2]=b;if(b|0)c[b+52>>2]=a;c[102272]=a;paa();return a|0}function _Z(){c[101227]=0;c[101228]=0;c[101226]=404908;return}function $Z(a){a=a|0;var b=0;b=a+520|0;c[b>>2]=-1;c[b+4>>2]=-1;_e(a);return}function a_(a){a=a|0;c[a>>2]=38628;a1(a+776|0);bt(a);return}function b_(a){a=a|0;var b=0.0;b=+g[(c[a+24>>2]|0)+136>>2];c[a+880>>2]=!(b>=1.0)?(b<=.3?128:512):-1;return}function c_(){qJ(408112,zN(410884)|0);return}function d_(){qJ(408104,zN(410876)|0);return}function e_(){qJ(408096,zN(410868)|0);return}function f_(){qJ(408088,zN(410860)|0);return}function g_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;d=d-c|0;return (d>>>0<e>>>0?d:e)|0}function h_(a){a=a|0;NB(a,a+944|0);NB(a,a+946|0);return}function i_(a){a=a|0;c[a>>2]=-1;c[a+4>>2]=-1;c[a+8>>2]=-1;c[a+12>>2]=-1;return}function j_(){qJ(408168,zN(410820)|0);return}function k_(){qJ(408152,zN(410812)|0);return}function l_(){qJ(408136,zN(410804)|0);return}function m_(){qJ(408120,zN(409992)|0);return}function n_(){qJ(408048,zN(409180)|0);return}function o_(){qJ(408040,zN(409172)|0);return}function p_(){qJ(408032,zN(409164)|0);return}function q_(){qJ(408024,zN(409140)|0);return}function r_(a,b){a=a|0;b=b|0;b=b&255;return (d[(c[11732+(b<<2)>>2]|0)+(a&255)>>0]|0)+(d[368923+b>>0]|0)&255|0}function s_(a){a=a|0;LP(a+680|0);return}function t_(a){a=a|0;p1(a+4|0);return}function u_(a){a=a|0;yV(a);return}function v_(a){a=a|0;zV(a);return}function w_(a){a=a|0;AV(a);return}function x_(a){a=a|0;BV(a);return}function y_(a){a=a|0;CV(a);return}function z_(a){a=a|0;DV(a);return}function A_(a){a=a|0;EV(a);return}function B_(a){a=a|0;a=a+1064|0;c[a>>2]=-1;c[a+4>>2]=-1;c[a+8>>2]=-1;c[a+12>>2]=-1;return}function C_(){}function D_(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=b-d-(c>>>0>a>>>0|0)>>>0;return (z=d,a-c>>>0|0)|0}function E_(a,c,d){a=a|0;c=c|0;d=d|0;if(d>>>0<128)a=(b[65244+(d<<1)>>1]&c)<<16>>16!=0;else a=0;return a|0}function F_(a,b){a=a|0;b=b|0;var d=0;d=a;c[d>>2]=b;c[d+4>>2]=0;a=a+8|0;c[a>>2]=0;c[a+4>>2]=0;return}function G_(a){a=a|0;W5(a);RB(a,0,0,57,379405,-1,1,0);return}function H_(a){a=a|0;W5(a);RB(a,0,0,57,379588,-1,1,0);return}function I_(a){a=a|0;W5(a);RB(a,0,0,57,379597,-1,1,0);return}function J_(a){a=a|0;W5(a);RB(a,0,0,57,379607,-1,1,0);return}function K_(a){a=a|0;W5(a);RB(a,0,0,57,379627,-1,1,0);return}function L_(a){a=a|0;W5(a);RB(a,0,0,57,379632,-1,1,0);return}function M_(a){a=a|0;a=a+136|0;c[a>>2]=-1;c[a+4>>2]=-1;c[a+8>>2]=-1;c[a+12>>2]=-1;return}function N_(b){b=b|0;if(a[b+909>>0]|0?(c[b+508>>2]|0)==0:0)GC(b);return 1}function O_(a){a=a|0;if(a>>>0<131072)a=(d[398089+((d[398089+(a>>>8)>>0]|0)<<5|a>>>3&31)>>0]|0)>>>(a&7)&1;else a=0;return a|0}function P_(a){a=a|0;if(a|0){PL(a);laa(a)}return}function Q_(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ub[a&31](b|0,c|0,d|0,e|0,f|0)|0}function R_(b){b=b|0;if(!(a[b+28>>0]|0))b=((c[b+12>>2]|0)-(c[b+8>>2]|0)|0)>>>3;else b=0;return b|0}function S_(a){a=a|0;Oc(a,c[a+544>>2]|0,c[a+548>>2]|0);return}function T_(a,b){a=a|0;b=b|0;vF(a,b)|0;vF(a+12|0,b+12|0)|0;return a|0}function U_(a,b,d){a=a|0;b=b|0;d=d|0;if(!b)a=0;else a=pT(a,c[d>>2]|0,b)|0;return a|0}function V_(a){a=a|0;var b=0;b=a+528|0;e1(a,c[b>>2]|0,c[b+4>>2]|0);return}function W_(a){a=a|0;if(a|0){JO(a);laa(a)}return}function X_(){if((a[408368]|0)==0?E3(408368)|0:0){g4();c[102738]=410948}return c[102738]|0}function Y_(){if((a[408200]|0)==0?E3(408200)|0:0){l4();c[102736]=410940}return c[102736]|0}function Z_(a,b){a=a|0;b=b|0;if(!b)b=0;else b=Zp(c[b>>2]|0,c[b+4>>2]|0,a)|0;return (b|0?b:a)|0}function __(a,b){a=a|0;b=b|0;b=z0(b|0,0,-2082844800,-1)|0;return We(a,b,z)|0}function $_(a){a=a|0;z5(a+24|0);z5(a+12|0);XQ(a);return}function a$(a){a=a|0;JY(a);N7(a+112|0);return}function b$(a){a=a|0;a=a+-1235|0;if(a>>>0<26)return (61309389>>>(a&67108863)&1|0)!=0|0;else return 0;return 0}function c$(a,b){a=a|0;b=b|0;p2(a,b);yw(a+12|0,b+12|0);return}function d$(b){b=b|0;if(!(a[b+904>>0]|0))DR(b+760|0);return}function e$(a){a=a|0;var b=0;b=a+536|0;iF(a,c[b>>2]|0,c[b+4>>2]|0);return}function f$(b){b=b|0;if(!(a[b+46>>0]|0))b=a[b+45>>0]|0;else b=0;return b|0}function g$(){var a=0;a=Ub(2072)|0;if(!a)return a|0;if(!(c[a+-4>>2]&3))return a|0;Ow(a|0,0,2072)|0;return a|0}function h$(a,b,c){a=a|0;b=b|0;c=c|0;return Ls(a,b,c)|0}function i$(b){b=b|0;if(!(a[b+49>>0]|0))b=a[b+38>>0]|0;else b=0;return b|0}function j$(a){a=a|0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a>>2]=-1;c[a+4>>2]=-1;return}function k$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return mb[a&7](b|0,c|0,d|0,e|0,+f)|0}function l$(a){a=a|0;W3(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function m$(a){a=a|0;y2(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function n$(a){a=a|0;X3(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function o$(a){a=a|0;z2(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function p$(a){a=a|0;a$(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function q$(a){a=a|0;A2(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function r$(a){a=a|0;if(!a)a=0;else a=(c[a+8>>2]|0)!=0;return a|0}function s$(a){a=a|0;YX(a);laa(a);return}function t$(a){a=a|0;ZX(a);laa(a);return}function u$(a,b){a=a|0;b=b|0;b=zN(b)|0;return M6(c[a+8>>2]|0,b)|0}function v$(a,b){a=a|0;b=b|0;if(b|0)GX(a,b)|0;return a|0}function w$(a){a=a|0;hY(a+-8|0);return}function x$(a){a=a|0;y$(a+-8|0);return}function y$(a){a=a|0;hY(a);laa(a);return}function z$(a){a=a|0;var b=0;b=a+728|0;c[b>>2]=c[b>>2]&-10|8;Q6(a);return}function A$(a){a=a|0;fX(a+4|0);return}function B$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return -1}function C$(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;hb[a&3](b|0,c|0,d|0,e|0,f|0)}function D$(a){a=a|0;var b=0;b=c[(X_()|0)>>2]|0;c[a>>2]=b;h5(b);return}function E$(a){a=a|0;if(!a)a=0;else a=(c[a+4>>2]|0)!=0;return a|0}function F$(a){a=a|0;return (((d[a+3>>0]|0)<<8|(d[a+2>>0]|0))<<8|(d[a+1>>0]|0))<<8|(d[a>>0]|0)|0}function G$(a){a=a|0;var b=0;b=a+536|0;e1(a,c[b>>2]|0,c[b+4>>2]|0);return}function H$(a,b,d){a=a|0;b=b|0;d=d|0;return h$(c[a>>2]|0,b,d)|0}function I$(a){a=a|0;x1(a);b[a+12>>1]=-1;return}function J$(a){a=a|0;_W(a);laa(a);return}function K$(a){a=a|0;$W(a);laa(a);return}function L$(a,b,c){a=a|0;b=b|0;c=c|0;if(!c)a=0;else a=nN(a,b,c)|0;return a|0}function M$(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return b>>>0<d>>>0|(b|0)==(d|0)&a>>>0<c>>>0|0}function N$(a){a=a|0;if(!a)a=0;else a=(c[a>>2]|0)!=0;return a|0}function O$(a){a=a|0;tR(c[a+4>>2]|0);return}function P$(a){a=a|0;uR(c[a+4>>2]|0);return}function Q$(a){a=a|0;Az(a+4|0);return}function R$(a,b,c){a=a|0;b=b|0;c=c|0;if(!c)a=0;else a=_L(a,b,c)|0;return a|0}function S$(a){a=a|0;return (((d[a>>0]|0)<<8|(d[a+1>>0]|0))<<8|(d[a+2>>0]|0))<<8|(d[a+3>>0]|0)|0}function T$(a){a=a|0;var b=0;b=a+40|0;do{c[a>>2]=-1;a=a+4|0}while((a|0)<(b|0));return}function U$(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function V$(a){a=a|0;zW(a+4|0);return}function W$(a){a=a|0;QT(c[c[a>>2]>>2]|0);return}function X$(a,b){a=a|0;b=b|0;cC(a,Ct(b,16)|0)|0;return a|0}function Y$(a,b){a=a|0;b=b|0;var d=0;d=l;l=l+16|0;c[d>>2]=b;Xq(50948,a,d)|0;FL();ra()}function Z$(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function _$(b){b=b|0;a[b>>0]=0;a[b+1>>0]=0;a[b+2>>0]=0;a[b+3>>0]=0;a[b+4>>0]=0;return}function $$(a,b){a=a|0;b=b|0;b=a+(b*24|0)|0;z=c[b+4>>2]|0;return c[b>>2]|0}function a0(a){a=a|0;var b=0;b=c[12815]|0;if(a|0)c[12815]=(a|0)==(-1|0)?409016:a;return ((b|0)==409016?-1:b)|0}function b0(){if((a[407720]|0)==0?E3(407720)|0:0)c[102281]=gw(2147483647,402006,0)|0;return c[102281]|0}function c0(a,b){a=a|0;b=b|0;rV(a,b);rV(a+12|0,b+12|0);return}function d0(a){a=+a;var b=0;h[j>>3]=a;b=c[j>>2]|0;z=c[j+4>>2]|0;return b|0}function e0(b){b=b|0;var d=0;c[b>>2]=57284;d=c[b+8>>2]|0;if(d|0?a[b+12>>0]|0:0)jaa(d);return}function f0(a){a=a|0;FZ(a+4|0);return}function g0(a){a=a|0;a1(a);return}function h0(a,b){a=a|0;b=b|0;p2(a,b);p2(a+12|0,b+12|0);return}function i0(a){a=a|0;a=ky(a)|0;return a|0}function j0(a,b){a=a|0;b=b|0;qu(a,b);return}function k0(a){a=a|0;var b=0;if(a|0)do{b=a;a=c[a>>2]|0;pe(b)}while((a|0)!=0);return}function l0(a){a=a|0;var b=0;b=c[a>>2]|0;if((b|0)!=(b0()|0))R8(c[a>>2]|0);return}function m0(a,c){a=a|0;c=c|0;b[a>>1]=b[c>>1]|0;rV(a+4|0,c+4|0);return}function n0(a){a=a|0;ZA(a);return}function o0(a){a=a|0;var b=0;b=0;while(1){if(!a)break;b=b+1<<24>>24;a=a>>>1}return b|0}function p0(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=b;c[a+4>>2]=d;return}function q0(a){a=a|0;L8(c[a+4>>2]|0);return}function r0(a){a=a|0;if((c[a+908>>2]|0)==3)lP(a);return}function s0(b){b=b|0;a[b>>0]=-1;a[b+1>>0]=-1;a[b+2>>0]=0;a[b+3>>0]=0;return}function t0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return rb[a&7](b|0,c|0,d|0,e|0)|0}function u0(){qJ(407952,zN(410924)|0);return}function v0(){qJ(407960,zN(410932)|0);return}function w0(a){a=a|0;a=a+-1|0;if(a>>>0<3)return ((a&255)<<1&255)+8<<24>>24|0;else return 0;return 0}function x0(a){a=a|0;GC(a);J3(a);return}function y0(a,b,c){a=a|0;b=b|0;c=c|0;CI(a,b,c);return}function z0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c=a+c>>>0;return (z=b+d+(c>>>0<a>>>0|0)>>>0,c|0)|0}function A0(){qJ(407936,zN(410916)|0);return}function B0(){qJ(407928,zN(410908)|0);return}function C0(){var b=0;b=ZW(1104)|0;ln(b);a[b+732>>0]=1;return b|0}function D0(a,b){a=a|0;b=b|0;wz(a,b+16|0);return}function E0(a,b){a=a|0;b=b|0;wz(a,b+12|0);return}function F0(a){a=a|0;vy(a);return}function G0(a){a=a|0;tO(a+8|0);return}function H0(a,b){a=a|0;b=b|0;if(b<<24>>24>-1)b=c[52168+(b<<24>>24<<2)>>2]&255;return b|0}function I0(){var a=0;a=ZW(22152)|0;Dt(a);c[a+908>>2]=5;return a|0}function J0(){var a=0;a=ZW(22152)|0;Dt(a);c[a+908>>2]=4;return a|0}function K0(a){a=a|0;sI(a+4|0);return}function L0(a){a=a|0;if(c[a+728>>2]&1|0)SM(a);return}function M0(b){b=b|0;x1(b);a[b+12>>0]=1;return}function N0(a){a=a|0;var b=0;b=a;while(1)if(!(c[b>>2]|0))break;else b=b+4|0;return b-a>>2|0}function O0(b){b=b|0;if((a[b+8+3>>0]|0)<0)laa(c[b>>2]|0);return}function P0(a,b,c){a=a|0;b=b|0;c=c|0;return -1}function Q0(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;S(11);return 0}function R0(){qJ(408080,zN(410852)|0);return}function S0(){qJ(408072,zN(410844)|0);return}function T0(){qJ(408064,zN(410836)|0);return}function U0(){qJ(408056,zN(410828)|0);return}function V0(a,b){a=a|0;b=b|0;if(b<<24>>24>-1)b=c[53704+((b&255)<<2)>>2]&255;return b|0}function W0(a,b){a=a|0;b=b|0;c[a>>2]=b;i8(b);return}function X0(a){a=+a;var b=0;b=~~a;b=(a-+(b|0)>=.5&1)+b|0;z=((b|0)<0)<<31>>31;return b|0}function Y0(a){a=a|0;return (c[a+72>>2]<<3)-(c[a+56>>2]|0)+(O(c[a+52>>2]|0,-8)|0)|0}function Z0(a){a=a|0;var b=0;b=a&255;return (a<<24>>24==15?0:(b&8|0?44100:48e3)<<(b&7))|0}function _0(a,b,c){a=a|0;b=b|0;c=c|0;return av(a,b,c)|0}function $0(a){a=a|0;jb[c[(c[a>>2]|0)+8>>2]&511](a);qN(a);return 0}function a1(b){b=b|0;if((a[b+11>>0]|0)<0)laa(c[b>>2]|0);return}function b1(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;vb[a&15](b|0,c|0,d|0,e|0)}function c1(b){b=b|0;if(!(a[b+28>>0]|0))b=c[b+24>>2]|0;else b=0;return b|0}function d1(a){a=a|0;var b=0;b=ZW(368)|0;Gt(b);c[a>>2]=b;return}function e1(a,b,c){a=a|0;b=b|0;c=c|0;gE(a,b,c);return}function f1(a,b,c){a=a|0;b=b|0;c=c|0;return H$(a,b,c)|0}function g1(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)TR(a|0,b|0,c|0)|0;return a|0}function h1(a,b){a=a|0;b=b|0;aE(a,b)|0;BB(a,b)|0;return a|0}function i1(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)no(a|0,b|0,c|0)|0;return a|0}function j1(a){a=a|0;a=i0(c[a>>2]|0)|0;return a|0}function k1(a,b){a=a|0;b=b|0;rQ(a,b)|0;return a|0}function l1(a){a=a|0;wO(a);return}function m1(a){a=a|0;cq(a);return}function n1(a){a=a|0;bB(a,a+952|0);return}function o1(a){a=a|0;bB(a,a+1046|0);return}function p1(a){a=a|0;s8(c[a>>2]|0);return}function q1(a,b){a=a|0;b=b|0;kb[c[(c[a>>2]|0)+16>>2]&63](a,b);return}function r1(a){a=a|0;c[a>>2]=57376;a1(a+16|0);return}function s1(a){a=a|0;c[a>>2]=57336;a1(a+12|0);return}function t1(){qJ(407992,zN(409156)|0);return}function u1(){qJ(407968,zN(409132)|0);return}function v1(){qJ(408192,zN(410900)|0);return}function w1(){qJ(408184,zN(410892)|0);return}function x1(a){a=a|0;c[a+4>>2]=0;c[a+8>>2]=0;c[a>>2]=a+4;return}function y1(a){a=a|0;tb[c[(c[a>>2]|0)+12>>2]&31](a,c[a+24>>2]|0)|0;return}function z1(){qJ(407896,zN(409108)|0);return}function A1(){qJ(407888,zN(409100)|0);return}function B1(a){a=a|0;RB(a,0,0,57,379886,-1,0,1);return}function C1(a,b,c){a=a|0;b=b|0;c=c|0;if(!b)a=0;else a=Qj(a,b,c)|0;return a|0}function D1(){c[102029]=0;c[102028]=57028;return}function E1(){c[102025]=0;c[102024]=56972;return}function F1(){c[102023]=0;c[102022]=56944;return}function G1(a,b,c){a=a|0;b=b|0;c=c|0;return rT(a,b,c)|0}function H1(a,b,c){a=a|0;b=b|0;c=c|0;return sT(a,b,c)|0}function I1(a,b,c){a=a|0;b=b|0;c=c|0;ty(a,b,c);return}function J1(b,c){b=b|0;c=c|0;return (a[c+(b*24|0)+16>>0]|0)!=0|0}function K1(){S9();P9();r9();h9();return}function L1(){qJ(407920,zN(409148)|0);return}function M1(){qJ(407904,zN(409116)|0);return}function N1(){c[102027]=0;c[102026]=57e3;return}function O1(a){a=a|0;return ((a+-1235|0)>>>0<26?384102:(a+-1270|0)>>>0<6?384099:8800948)|0}function P1(a){a=a|0;Op(a,c[a+804>>2]|0,0);return}function Q1(a){a=a|0;aI(a+760|0);bt(a);return}function R1(a){a=a|0;Ad(a);return}function S1(a){a=a|0;var b=0;b=l;l=l+16|0;pb[a&3]();Y$(404550,b)}function T1(){c[102013]=0;c[102012]=55172;return}function U1(){c[102011]=0;c[102010]=55120;return}function V1(){c[102009]=0;c[102008]=55056;return}function W1(){c[102007]=0;c[102006]=54992;return}function X1(b){b=b|0;c[b>>2]=0;c[b+8>>2]=0;c[b+4>>2]=0;a[b+13>>0]=0;return}function Y1(b,c,d){b=b|0;c=c|0;d=d|0;return (a[b+19032+(c<<6)+d>>0]|0)==13|0}function Z1(a){a=a|0;RB(a,0,0,65,379733,-1,1,1);return}function _1(a){a=a|0;l0(a+8|0);laa(a);return}function $1(a){a=a|0;F3(a);laa(a);return}function a2(a){a=a|0;G3(a);laa(a);return}function b2(a,b){a=a|0;b=b|0;tb[c[(c[a>>2]|0)+12>>2]&31](a,b)|0;return}function c2(b){b=b|0;Eg(b);c[b>>2]=39064;a[b+760>>0]=0;return}function d2(a){a=a|0;DR(a+760|0);return}function e2(a){a=a|0;c[a+80>>2]=61824;c[a+88>>2]=9;c[a+84>>2]=63872;c[a+92>>2]=5;return}function f2(a,b){a=a|0;b=b|0;if(b>>>0<128)b=c[53704+(b<<2)>>2]|0;return b|0}function g2(a,b){a=a|0;b=b|0;if(b>>>0<128)b=c[52168+(b<<2)>>2]|0;return b|0}function h2(a,b,c){a=a|0;b=b|0;c=c|0;return IK(a,b,c)|0}function i2(a,b,c){a=a|0;b=b|0;c=c|0;return jH(a,b,c)|0}function j2(a){a=a|0;Kc(a,1,-1)|0;return}function k2(b,c){b=b|0;c=c|0;return (a[c+(b*24|0)+18>>0]|0)!=0|0}function l2(a){a=a|0;RJ(a);return}function m2(a){a=a|0;yN(a);return}function n2(a){a=a|0;Cb(a);return}function o2(a,b,c){a=a|0;b=b|0;c=c|0;qE(a,b,c);return 411044}function p2(a,b){a=a|0;b=b|0;Ww(a,b);return}function q2(a){a=a|0;var b=0;b=ZW(28)|0;c[a>>2]=b;bb(b|0,0)|0;return}function r2(a){a=a|0;BE(a);return}function s2(a){a=a|0;Mv(a);return}function t2(a){a=a|0;$_(a+12|0);z5(a);return}function u2(a){a=a|0;x1(a);return}function v2(a){a=a|0;a$(a+-8|0);return}function w2(a){a=a|0;A2(a+-8|0);return}function x2(a){a=a|0;var b=0;b=c[102282]|0;c[102282]=b+1;c[a+4>>2]=b+1;return}function y2(a){a=a|0;W3(a);laa(a);return}function z2(a){a=a|0;X3(a);laa(a);return}function A2(a){a=a|0;a$(a);laa(a);return}function B2(a){a=a|0;cS(a);laa(a);return}function C2(a){a=a|0;return jX(a,zN(410908)|0)|0}function D2(a,b,c){a=a|0;b=b|0;c=c|0;return X2(a,b,c)|0}function E2(a){a=a|0;Us(a);return}function F2(a){a=a|0;E2(a);return}function G2(a,b){a=a|0;b=b|0;pz(a,b);return}function H2(a){a=a|0;_V(a+4|0);return}function I2(a,b,c){a=a|0;b=b|0;c=c|0;return b>>>0<=a>>>0&a>>>0<c>>>0|0}function J2(a){a=a|0;var b=0;b=c[a>>2]|0;c[a>>2]=b+-1;return b+-1|0}function K2(a,b){a=a|0;b=b|0;c[a>>2]=57848;oR(a+4|0,b);return}function L2(a){a=a|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;return}function M2(a,b,c){a=a|0;b=b|0;c=c|0;return RT(a,b,c)|0}function N2(){var a=0;a=ZW(1040)|0;_z(a);return a|0}function O2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return gb[a&31](b|0,c|0,d|0)|0}function P2(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;S(0);return 0}function Q2(a,b,c){a=a|0;b=+b;c=+c;MJ(a,b,c);return 1}function R2(a){a=a|0;if(!a)a=0;else a=(Lp(a,2776)|0)!=0;return a&1|0}function S2(a){a=a|0;return jv(a)|0}function T2(a,b){a=a|0;b=b|0;return We(a,b,0)|0}function U2(a,b,c){a=a|0;b=b|0;c=c|0;dw(a,b,c);return}function V2(){var a=0;a=ZW(1128)|0;Wr(a);return a|0}function W2(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)tL(a,b,c)|0;return}function X2(a,b,c){a=a|0;b=b|0;c=c|0;return ((c&255)<<8|b&255)<<8|a&255|0}function Y2(a){a=a|0;if(a|0)jb[c[(c[a>>2]|0)+4>>2]&511](a);return}function Z2(a){a=a|0;return Hi(a)|0}function _2(a){a=a|0;return ((a+-65529|0)>>>0<3|((a&-2|0)==8232|(a>>>0<32|(a+-127|0)>>>0<33)))&1|0}function $2(a,b,c){a=a|0;b=b|0;c=c|0;if(b|0)xX(a,c,b)|0;return}function a3(a,b,c){a=a|0;b=b|0;c=c|0;if(c|0)mW(a,b,c)|0;return}function b3(a,b,c){a=a|0;b=b|0;c=c|0;return XT(a,b,c)|0}function c3(b,c){b=b|0;c=c|0;a[c+(b*24|0)+16>>0]=1;return}function d3(b,c){b=b|0;c=c|0;b=Vv(b,c)|0;return ((a[b>>0]|0)==(c&255)<<24>>24?b:0)|0}function e3(a){a=a|0;var b=0;b=d8(a,-1)|0;return (b?0:a)|0}function f3(a){a=a|0;return (tb[c[(c[a>>2]|0)+12>>2]&31](a,16)|0)&65535|0}function g3(a,b,c){a=a|0;b=b|0;c=c|0;return k3(a,b,c)|0}function h3(a){a=a|0;UA(a);return}function i3(a){a=a|0;return Pc(a)|0}function j3(a){a=a|0;sV(a);return}function k3(a,b,c){a=a|0;b=b|0;c=c|0;return ((a&255)<<8|b&255)<<8|c&255|0}function l3(a){a=a|0;Vt(a+760|0);return}function m3(a){a=a|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;return}function n3(a,b){a=a|0;b=b|0;Ez(a,b);return}function o3(a,b){a=a|0;b=b|0;vw(a,b);return}function p3(a,b){a=a|0;b=b|0;Wg(a,b);return}function q3(a,b){a=a|0;b=b|0;bg(a,b);return}function r3(a,b){a=a|0;b=b|0;LD(a,b);return}function s3(a,b){a=a|0;b=b|0;xB(a,b);return}function t3(a,b){a=a|0;b=b|0;dC(a,b);return}function u3(a,b){a=a|0;b=b|0;dB(a,b);return}function v3(){var a=0;a=ZW(960)|0;Vw(a);return a|0}function w3(){var a=0;a=ZW(22152)|0;Dt(a);return a|0}function x3(a){a=a|0;lT(a);return}function y3(a){a=a|0;Lc(a);return}function z3(a,b){a=a|0;b=b|0;k1(a+12|0,b)|0;return}function A3(a,b,c){a=a|0;b=b|0;c=c|0;yK(a,b,c);return}function B3(){var a=0;a=ZW(1256)|0;uw(a);return a|0}function C3(){var a=0;a=ZW(1056)|0;Mr(a);return a|0}function D3(){var a=0;a=ZW(1584)|0;on(a);return a|0}function E3(b){b=b|0;if((a[b>>0]|0)==1)b=0;else{a[b>>0]=1;b=1}return b|0}function F3(a){a=a|0;c[a>>2]=54864;c6(a+4|0);return}function G3(a){a=a|0;c[a>>2]=54800;c6(a+4|0);return}function H3(a){a=a|0;return (tb[c[(c[a>>2]|0)+12>>2]&31](a,4)|0)&255|0}function I3(b){b=b|0;a[b>>0]=-1;return}function J3(a){a=a|0;bP(a);return}function K3(){var a=0;a=ZW(920)|0;Wv(a);return a|0}function L3(a){a=a|0;l0(a+8|0);return}function M3(a){a=a|0;a=a+16|0;c[a>>2]=c[a>>2]|1;return}function N3(a,b){a=a|0;b=b|0;c[a>>2]=b;h5(b);return}function O3(a){a=a|0;Y2(c[a+8>>2]|0);return}function P3(a){a=a|0;return (tb[c[(c[a>>2]|0)+12>>2]&31](a,1)|0)!=0|0}function Q3(a,b){a=a|0;b=b|0;k1(a+24|0,b)|0;return}function R3(a){a=a|0;qy(a,a+880|0);return}function S3(a){a=a|0;fC(a);return}function T3(a){a=a|0;r3(a,a+764|0);return}function U3(){c[101985]=0;c[101984]=57216;c[101986]=b0()|0;return}function V3(a){a=a|0;gn(a+8|0);return}function W3(a){a=a|0;N7(a+4|0);return}function X3(a){a=a|0;N7(a+8|0);return}function Y3(a){a=a|0;return S2(c[a>>2]|0)|0}function Z3(a){a=a|0;c[a+832>>2]=-1;b[a+846>>1]=-1;return}function _3(a,b,d){a=a|0;b=b|0;d=d|0;if(!(c[a>>2]&32))Ft(b,d,a)|0;return}function $3(a){a=a|0;Na(c[a>>2]|0)|0;laa(c[a>>2]|0);return}function a4(a){a=a|0;return (c[a+68>>2]|0)-(c[a+60>>2]|0)|0}function b4(a){a=a|0;TX(a);TX(a+12|0);return}function c4(a){a=a|0;EO(a);laa(a);return}function d4(a,b){a=a|0;b=b|0;BH(a,b&255);return}function e4(a){a=a|0;if(a|0)L0(a);return}function f4(a){a=a|0;a=a+728|0;c[a>>2]=c[a>>2]|1048576;return}function g4(){N3(410948,c[(Y_()|0)>>2]|0);return}function h4(a){a=a|0;c[a>>2]=0;c[a+4>>2]=0;return}function i4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ob[a&3](b|0,c|0,d|0)}function j4(a){a=a|0;pJ(a);laa(a);return}function k4(a){a=a|0;var b=0;b=l;l=l+a|0;l=l+15&-16;return b|0}function l4(){q8();c[102735]=408208;return}function m4(a){a=a|0;QN(a+8|0);return}function n4(a){a=a|0;O$(a);return}function o4(a){a=a|0;P$(a);return}function p4(a){a=a|0;if(!(D5(a)|0))a=(YU(a)|0)!=0;else a=0;return a&1|0}function q4(a){a=a|0;if(!(R9(a)|0))a=(fZ(a)|0)!=0;else a=1;return a&1|0}function r4(b){b=b|0;a[b>>0]=0;a[b+1>>0]=0;a[b+2>>0]=0;return}function s4(a){a=a|0;if(a|0)jt(a);return}function t4(a){a=a|0;vt(a);return}function u4(a,b){a=a|0;b=b|0;var c=0;c=fs(a,0,b)|0;return ((c|0)==0?b:c-a|0)|0}function v4(a){a=a|0;a=j1(a)|0;return a|0}function w4(a){a=a|0;z5(a+12|0);z5(a);return}function x4(a){a=a|0;return hp(a)|0}function y4(b,c,d){b=b|0;c=c|0;d=d|0;a[d>>0]=b;return}function z4(a){a=a|0;$7(a);return}function A4(a){a=a|0;Qq(a);return}function B4(a){a=a|0;dd(a);return}function C4(a,b){a=a|0;b=b|0;c[a+16>>2]=(c[a+24>>2]|0)==0|b;return}function D4(a){a=a|0;BH(a,c[a+4>>2]&7);return}function E4(a){a=a|0;$Z(a);return}function F4(a){a=a|0;OW(a);laa(a);return}function G4(a,b){a=a|0;b=b|0;BH(a,b);return}function H4(a,b){a=a|0;b=b|0;if(!a)a=0;else a=qw(a,b)|0;return a|0}function I4(a){a=a|0;BK(a+8|0);return}function J4(a){a=a|0;$B(a+8|0);return}function K4(a,b,c){a=a|0;b=b|0;c=c|0;return (b>>>0<128?b&255:c)|0}function L4(a,b){a=a|0;b=b|0;return ZS(a,b)|0}function M4(a){a=a|0;Eg(a);c[a>>2]=10292;return}function N4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;S(6);return 0}function O4(a,b){a=a|0;b=b|0;N3(a,c[b+28>>2]|0);return}function P4(a,b,c){a=a|0;b=b|0;c=c|0;return (b<<24>>24>-1?b:c)|0}function Q4(a){a=a|0;return tb[c[(c[a>>2]|0)+12>>2]&31](a,24)|0}function R4(a,b,c){a=a|0;b=b|0;c=c|0;return g3(a,b,c)|0}function S4(a){a=a|0;Yw(a);laa(a);return}function T4(a){a=a|0;Eg(a);c[a>>2]=39260;return}function U4(a){a=a|0;Eg(a);c[a>>2]=38236;return}function V4(a){a=a|0;MK(a);return}function W4(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function X4(a){a=a|0;kb[c[(c[a>>2]|0)+16>>2]&63](a,19);return}function Y4(a){a=a|0;return (a<<24>>24==1?1e3:a<<24>>24==2?1001:0)|0}function Z4(a){a=a|0;qy(a,0);return}function _4(a){a=a|0;kb[c[(c[a>>2]|0)+16>>2]&63](a,1);return}function $4(a){a=a|0;kb[c[(c[a>>2]|0)+16>>2]&63](a,3);return}function a5(a,b){a=a|0;b=b|0;return J5(a,b)|0}function b5(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;S(3);return 0}function c5(a,b){a=a|0;b=b|0;var c=0;c=C5(a|0)|0;return ((b|0)==0?a:c)|0}function d5(a,b,c){a=a|0;b=b|0;c=c|0;c=eH(a,b,c,0,-2147483648)|0;return c|0}function e5(a,b){a=a|0;b=b|0;Iz(a,b);return 411044}function f5(){c[101977]=0;c[101976]=57284;a[407916]=0;c[101978]=65244;return}function g5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ph(a,b,c,d,0)|0}function h5(a){a=a|0;g6(a+4|0);return}function i5(a,b){a=a|0;b=b|0;return (b+3|0)>>>0<=a>>>0|0}function j5(a,b){a=a|0;b=b|0;return (b+8|0)>>>0<=a>>>0|0}function k5(b,c){b=b|0;c=c|0;a[b>>0]=c;return}function l5(a){a=a|0;BS(a);return}function m5(a){a=a|0;if(!a)a=1;else a=(c[a>>2]|0)==0;return a&1|0}function n5(a){a=a|0;if(a|0){l8(a);laa(a)}return}function o5(a){a=a|0;yY(a);laa(a);return}function p5(){c[101989]=0;c[101988]=57596;return}function q5(){c[101991]=0;c[101990]=57644;return}function r5(a){a=a|0;return (c[a+64>>2]|0)-(c[a+60>>2]|0)|0}function s5(a,b){a=a|0;b=b|0;if(b|0)c[a+36>>2]=b;return}function t5(a){a=a|0;sc(a);return}function u5(a){a=a|0;_e(a);return}function v5(a){a=a|0;m8(a);return}function w5(a){a=a|0;U5(a);return}function x5(){c[101983]=0;c[101982]=57548;return}function y5(a){a=a|0;c[a>>2]=57848;bW(a+4|0);return}function z5(a){a=a|0;O0(a);return}function A5(a,b){a=a|0;b=b|0;return a6(a,b)|0}function B5(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;S(13)}function C5(a){a=a|0;return (a&255)<<24|(a>>8&255)<<16|(a>>16&255)<<8|a>>>24|0}function D5(a){a=a|0;if(!a)a=0;else a=(GT(a)|0)!=0;return a&1|0}function E5(){U3();return}function F5(a){a=a|0;c[a>>2]=42028;$3(a+12|0);return}function G5(a,b,c){a=a|0;b=b|0;c=c|0;return tb[a&31](b|0,c|0)|0}function H5(a,b,c){a=a|0;b=b|0;c=c|0;c=eH(a,b,c,-1,-1)|0;return c|0}function I5(a){a=a|0;a=HF(a)|0;return a|0}function J5(a,b){a=a|0;b=b|0;return ((b&255)<<8|a&255)&65535|0}function K5(a){a=a|0;return a<<16>>16==19219|0}function L5(a){a=a|0;T5(a);return}function M5(a){a=a|0;Qu(a);return}function N5(a){a=a|0;Gc(a);return}function O5(a){a=a|0;P5(a);return}function P5(a){a=a|0;pf(a);return}function Q5(a){a=a|0;_m(a);return}function R5(a){a=a|0;Xy(a,2808);return}function S5(a){a=a|0;L2(a);return}function T5(a){a=a|0;lF(a);return}function U5(a){a=a|0;z$(a);return}function V5(a){a=a|0;KM(a);return}function W5(a){a=a|0;pO(a);return}function X5(a){a=a|0;return Y3(a)|0}function Y5(){c[102021]=0;c[102020]=56888;return}function Z5(){c[102019]=0;c[102018]=56832;return}function _5(){c[102017]=0;c[102016]=56776;return}function $5(){c[102015]=0;c[102014]=56720;return}function a6(a,b){a=a|0;b=b|0;return ((a&255)<<8|b&255)&65535|0}function b6(a){a=a|0;if(a>>>0>4294963200){c[12784]=0-a;a=-1}return a|0}function c6(a){a=a|0;zZ(c[a>>2]|0);return}function d6(a){a=a|0;PV(a);laa(a);return}function e6(a){a=a|0;PC(a);laa(a);return}function f6(a){a=a|0;yM(a);laa(a);return}function g6(a){a=a|0;c[a>>2]=(c[a>>2]|0)+1;return}function h6(a){a=a|0;return 2}function i6(a){a=a|0;Xy(a,2896);return}function j6(a,b){a=a|0;b=b|0;return +(+(a>>>0)+4294967296.0*+(b>>>0))}function k6(a){a=a|0;bt(a);laa(a);return}function l6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;S(15);return 0}function m6(a,b,c){a=a|0;b=b|0;c=c|0;return Yn(0,a,b,c|0?c:409092)|0}function n6(a){a=a|0;return (c[a+24>>2]|0)+(c[a+8>>2]|0)|0}function o6(a){a=a|0;a=gJ(a)|0;return a|0}function p6(a){a=a|0;a=uM(a)|0;return a|0}function q6(a){a=a|0;a=hQ(a)|0;return a|0}function r6(a){a=+a;var b=0;b=~~a;return (a-+(b|0)>=.5&1)+b|0}function s6(a){a=a|0;Nr(a);return}function t6(a){a=a|0;jt(a);return}function u6(a){a=a|0;EK(a);laa(a);return}function v6(a){a=a|0;iv(a);laa(a);return}function w6(a){a=a|0;iG(a);laa(a);return}function x6(a){a=a|0;rF(a);laa(a);return}function y6(){var a=0;a=ZW(4)|0;$8(a);return a|0}function z6(a,b){a=a|0;b=b|0;return (a&255)-(b&255)&255|0}function A6(a){a=a|0;BH(a,1);return}function B6(a,b,c){a=a|0;b=b|0;c=c|0;c=H5(a,b,c)|0;return c|0}function C6(a,b){a=a|0;b=b|0;return a<<24>>24==b<<24>>24|0}
function xc(b){b=b|0;var d=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;G=l;l=l+48|0;B=G+36|0;C=G+24|0;D=G+12|0;E=G;RB(b,0,0,57,391377,-1,1,0);Kc(b,2,-1)|0;RB(b,2,0,18,391377,-1,1,0);F=b+836|0;d=c[F>>2]|0;if(((d&512|0)!=0?(c[b+1248>>2]|0)!=0:0)?(c[b+1244>>2]|0)==0:0){PU(F,10)|0;d=c[F>>2]|0}r=b+840|0;s=b+1040|0;t=b+1120|0;u=b+1160|0;v=b+960|0;w=b+880|0;x=b+1e3|0;y=b+1200|0;z=b+1080|0;A=b+920|0;i=b+1204|0;j=b+1084|0;if(d&1024){Xy(B,13916);d=b+844|0;f=c[d>>2]|0;if(f>>>0<(c[b+848>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(r,B);z5(B);Xy(B,13924);d=b+884|0;f=c[d>>2]|0;if(f>>>0<(c[b+888>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(w,B);z5(B);Xy(B,13924);d=b+924|0;f=c[d>>2]|0;if(f>>>0<(c[b+928>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(A,B);z5(B);Xy(B,13924);d=b+964|0;f=c[d>>2]|0;if(f>>>0<(c[b+968>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(v,B);z5(B);Xy(B,13924);d=b+1004|0;f=c[d>>2]|0;if(f>>>0<(c[b+1008>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(x,B);z5(B);TX(B);d=b+1044|0;f=c[d>>2]|0;if(f>>>0<(c[b+1048>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(s,B);z5(B);TX(B);d=c[j>>2]|0;if(d>>>0<(c[b+1088>>2]|0)>>>0){rV(d,B);c[j>>2]=(c[j>>2]|0)+12}else Dx(z,B);z5(B);Xy(B,13976);d=b+1124|0;f=c[d>>2]|0;if(f>>>0<(c[b+1128>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(t,B);z5(B);Xy(B,40136);d=b+1164|0;f=c[d>>2]|0;if(f>>>0<(c[b+1168>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(u,B);z5(B);TX(B);d=c[i>>2]|0;if(d>>>0<(c[b+1208>>2]|0)>>>0){rV(d,B);c[i>>2]=(c[i>>2]|0)+12}else Dx(y,B);z5(B);d=c[F>>2]|0}if(d&512){Xy(B,14008);d=b+844|0;f=c[d>>2]|0;if(f>>>0<(c[b+848>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(r,B);z5(B);Be(b);h=b+1124|0;f=c[h>>2]|0;d=f+-12|0;while(1){if((f|0)==(d|0))break;p=f+-12|0;c[h>>2]=p;z5(p);f=c[h>>2]|0}g=b+1164|0;f=c[g>>2]|0;d=f+-12|0;while(1){if((f|0)==(d|0))break;p=f+-12|0;c[g>>2]=p;z5(p);f=c[g>>2]|0}f=c[i>>2]|0;d=f+-12|0;while(1){if((f|0)==(d|0))break;p=f+-12|0;c[i>>2]=p;z5(p);f=c[i>>2]|0}Xy(B,13976);d=c[h>>2]|0;if(d>>>0<(c[b+1128>>2]|0)>>>0){rV(d,B);c[h>>2]=(c[h>>2]|0)+12}else Dx(b+1120|0,B);z5(B);Xy(B,40136);d=c[g>>2]|0;if(d>>>0<(c[b+1168>>2]|0)>>>0){rV(d,B);c[g>>2]=(c[g>>2]|0)+12}else Dx(b+1160|0,B);z5(B);Xy(B,14020);d=c[i>>2]|0;if(d>>>0<(c[b+1208>>2]|0)>>>0){rV(d,B);c[i>>2]=(c[i>>2]|0)+12}else Dx(b+1200|0,B);z5(B);d=c[F>>2]|0}if(d&256){Xy(B,13756);d=b+844|0;f=c[d>>2]|0;if(f>>>0<(c[b+848>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(r,B);z5(B);Be(b);d=c[F>>2]|0}do if(!(d&226)){if(d&4|0){Xy(B,14072);d=b+844|0;f=c[d>>2]|0;if(f>>>0<(c[b+848>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(r,B);z5(B);if(c[F>>2]&128|0){Be(b);break}kd(b);f=c[j>>2]|0;d=f+-12|0;while(1){if((f|0)==(d|0))break;p=f+-12|0;c[j>>2]=p;z5(p);f=c[j>>2]|0}tU(B,96e3,10);d=c[j>>2]|0;if(d>>>0<(c[b+1088>>2]|0)>>>0){rV(d,B);c[j>>2]=(c[j>>2]|0)+12}else Dx(b+1080|0,B);z5(B)}}else{Xy(B,14056);d=b+844|0;f=c[d>>2]|0;if(f>>>0<(c[b+848>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(r,B);z5(B);if(c[F>>2]&224|0){Be(b);break}kd(b);if(c[F>>2]&128|0){f=c[j>>2]|0;d=f+-12|0;while(1){if((f|0)==(d|0))break;p=f+-12|0;c[j>>2]=p;z5(p);f=c[j>>2]|0}tU(B,96e3,10);d=c[j>>2]|0;if(d>>>0<(c[b+1088>>2]|0)>>>0){rV(d,B);c[j>>2]=(c[j>>2]|0)+12}else Dx(z,B);z5(B)}}while(0);d=c[F>>2]|0;f=(d&8|0)==0;do if(!(a[b+833>>0]|0)){if(!f){Xy(B,14096);d=b+844|0;f=c[d>>2]|0;if(f>>>0<(c[b+848>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(r,B);z5(B);k=107}}else if(f){Xy(B,14264);d=b+844|0;f=c[d>>2]|0;if(f>>>0<(c[b+848>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(r,B);z5(B);k=107;break}else{Xy(B,14216);d=b+844|0;f=c[d>>2]|0;if(f>>>0<(c[b+848>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(r,B);z5(B);k=107;break}while(0);if((k|0)==107){kd(b);d=c[F>>2]|0}if(d&1|0){Xy(B,14304);d=b+844|0;f=c[d>>2]|0;if(f>>>0<(c[b+848>>2]|0)>>>0){rV(f,B);c[d>>2]=(c[d>>2]|0)+12}else Dx(r,B);z5(B);Ud(b)}m=0;while(1){if((m|0)==10)break;n=b+840+(m*40|0)|0;Xy(B,41840);z3(n,B);z5(B);o=c[n>>2]|0;p=((c[b+840+(m*40|0)+4>>2]|0)-o|0)/12|0;if(p>>>0>1){k=1;d=0;while(1){f=o;if((k|0)==(p|0))break;g=f+(k*12|0)|0;i=a[f+(k*12|0)+8+3>>0]|0;h=i<<24>>24<0;i=h?c[f+(k*12|0)+4>>2]|0:i&255;H=a[f+8+3>>0]|0;j=H<<24>>24<0;if(!((i|0)==((j?c[f+4>>2]|0:H&255)|0)?(L$(h?c[g>>2]|0:g,j?c[f>>2]|0:o,i)|0)==0:0))d=1;k=k+1|0}if(!d)ME(n,1)}m=m+1|0}g=b+844|0;H=c[r>>2]|0;d=H;a:do if((((c[g>>2]|0)-H|0)==12?(q=i9(14304)|0,H=a[d+8+3>>0]|0,(q|0)==((H<<24>>24<0?c[d+4>>2]|0:H&255)|0)):0)?(VG(d,14304,q)|0)==0:0){d=c[r>>2]|0;while(1){f=c[g>>2]|0;if((f|0)==(d|0))break a;H=f+-12|0;c[g>>2]=H;z5(H)}}while(0);de(B,r);zb(b,2,0,24,B,0);z5(B);Xy(B,14008);Xy(C,42348);if((PG(r,B,C)|0)==-1){Xy(D,14056);Xy(E,42348);if((PG(r,D,E)|0)==-1)RB(b,2,0,52,391377,-1,1,0);else RB(b,2,0,52,375402,-1,1,0);z5(E);z5(D)}else RB(b,2,0,52,375402,-1,1,0);z5(C);z5(B);$x(B,b,2,0,24,1);zb(b,0,0,65,B,0);z5(B);de(B,w);zb(b,2,0,122,B,0);z5(B);de(B,A);zb(b,2,0,128,B,0);z5(B);de(B,v);zb(b,2,0,129,B,0);z5(B);de(B,x);zb(b,2,0,132,B,0);z5(B);de(B,s);zb(b,2,0,147,B,0);z5(B);de(B,z);zb(b,2,0,135,B,0);z5(B);de(B,t);zb(b,2,0,112,B,0);z5(B);de(B,u);zb(b,2,0,110,B,0);z5(B);$x(B,b,2,0,110,1);zb(b,0,0,101,B,0);z5(B);de(B,y);zb(b,2,0,153,B,1);z5(B);d=0;while(1){if((d|0)==10)break;f=c[b+840+(d*40|0)>>2]|0;g=b+840+(d*40|0)+4|0;while(1){h=c[g>>2]|0;if((h|0)==(f|0))break;H=h+-12|0;c[g>>2]=H;z5(H)}d=d+1|0}if(c[F>>2]&1|0)sM(b,2,0,134,e[b+814>>1]<<5,0);l=G;return}function yc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;C=l;l=l+80|0;g=C+68|0;o=C+64|0;A=C;m=C+40|0;i=C+52|0;B=b+508|0;j=b+544|0;u=b+612|0;q=b+548|0;x=b+40|0;v=b+48|0;if(((((c[B>>2]|0)==2?(w=v,d=c[q>>2]|0,w=z0(d|0,0,c[w>>2]|0,c[w+4>>2]|0)|0,y=x,d>>>0>8&((w|0)==(c[y>>2]|0)?(z|0)==(c[y+4>>2]|0):0)):0)?(e=(c[j>>2]|0)+d|0,(C9(e+-4|0)|0)==1462977609):0)?(f=t7(e+-8|0)|0,!(f>>>0<9|f>>>0>d>>>0)):0)?((c[u>>2]|0)+f|0)==(d|0):0){VU(g,379066);BZ(c[B>>2]|0,c[b+668>>2]|0,1462977609,0);z5(g);Op(b,f,0)}else p=7;do if((p|0)==7){d=b+1024|0;if(c[d>>2]|0){VU(g,379071);BZ(c[B>>2]|0,c[b+668>>2]|0,1397577274,0);z5(g);Op(b,c[d>>2]|0,0);break}r3(b,o);h=c[o>>2]|0;a:do if((h|0)==1397577264){VU(A,379081);BZ(c[B>>2]|0,c[b+668>>2]|0,1397577264,0);z5(A);Op(b,51,0)}else{d=(h|0)==1919510118;e=b+1042|0;y=b+952|0;n=b+936|0;w=b+944|0;if(!d){if(!(a[e>>0]|0)){d=b+1041|0;k=b+1045|0;if((h|0)<1297377380)switch(h|0){case 1179603533:{p=26;break}default:p=27}else switch(h|0){case 1297377380:{p=26;break}default:p=27}if((p|0)==26){a[d>>0]=1;p=28}else if((p|0)==27)if(!(a[d>>0]|0)){bD(b,g);f=b+1046|0;if(!(a[f>>0]|0)){e=c[g>>2]|0;if(e&1){p=v;D=c[p>>2]|0;p=c[p+4>>2]|0;d=c[u>>2]|0;E=z0(e|0,0,8,0)|0;p=z0(E|0,z|0,D|0,p|0)|0;d=z0(p|0,z|0,d|0,0)|0;p=x;if(!((d|0)==(c[p>>2]|0)?(z|0)==(c[p+4>>2]|0):0)){d=a[b+36+3>>0]|0;if(d<<24>>24<0)d=c[b+32>>2]|0;else d=d&255;if(d|0){p2(i,b+28|0);OQ(A,i);z5(i);D=v;E=c[u>>2]|0;D=z0(c[D>>2]|0,c[D+4>>2]|0,8,0)|0;E=z0(D|0,z|0,E|0,0)|0;E=z0(E|0,z|0,e|0,0)|0;jU(A,E,z);if($t(A,m)|0?(E=a[m>>0]|0,E<<24>>24==32|(E+-65&255)<58):0)a[k>>0]=1;z7(A)}}else a[k>>0]=1;a[f>>0]=1;p=42}}else p=42}else p=28;if((p|0)==28){ID(b,g);p=42}if((p|0)==42)e=c[g>>2]|0;b:do if(!((e|0)==0&(h|0)==1380533830))if((e|0)==-1){E=b+536|0;D=c[E+4>>2]|0;if(D>>>0<0|(D|0)==0&(c[E>>2]|0)>>>0<28){c3(c[B>>2]|0,c[b+668>>2]|0);break a}if((h|0)>=1684108385){switch(h|0){case 1684108385:break;default:{d=0;break b}}d=b+920|0;e=c[d>>2]|0;d=c[d+4>>2]|0;break}switch(h|0){case 1380333108:break;default:{d=0;break b}}d=(c[j>>2]|0)+(c[u>>2]|0)|0;if((C9(d+12|0)|0)==1685272116){e=I5(d+20|0)|0;d=z}else d=0}else d=0;else{e=x;e=z0(c[e>>2]|0,c[e+4>>2]|0,-8,-1)|0;d=z}while(0);f=c[b+788>>2]|0;if((f|0)!=(b+780|0)?(E=f+32|0,(c[E>>2]|0)==0&(c[E+4>>2]|0)==0):0){c[o>>2]=-1;e=0;d=0;h=-1}g=v;f=c[u>>2]|0;g=z0(c[g>>2]|0,c[g+4>>2]|0,8,0)|0;f=z0(g|0,z|0,f|0,0)|0;g=z;E=z0(f|0,g|0,e|0,d|0)|0;D=z;j=x;i=c[j>>2]|0;j=c[j+4>>2]|0;if(D>>>0>j>>>0|(D|0)==(j|0)&E>>>0>i>>>0){e=D_(i|0,j|0,f|0,g|0)|0;d=z;if((c[B>>2]|0)>>>0<3)xM(b,0,0,379092,382808,0)}if((e&1|0)==0&0==0){f=0;g=0}else{f=(a[k>>0]^1)&255;e=z0(f|0,0,e|0,d|0)|0;g=0;d=z}i=n;c[i>>2]=f;c[i+4>>2]=g;i=b+1043|0;c:do if((h|0)<1330524704)if((h|0)<1279873876)switch(h|0){case 1179603533:{p=62;break c}default:break c}else switch(h|0){case 1279873876:{p=62;break c}default:break c}else{if((h|0)<1380333108)switch(h|0){case 1330524704:{p=62;break c}default:break c}if((h|0)>=1380533830)switch(h|0){case 1380533830:{p=62;break c}default:break c}switch(h|0){case 1380333108:break;default:break c}a[i>>0]=1;p=62}while(0);do if((p|0)==62){r3(b,o);if((e&-4|0)==8&(d|0)==0){e=HN(b,0)|0;e=z0(e|0,z|0,-8,-1)|0;d=z;TX(A);h=c[o>>2]|0;Mc(b,0,0,379104,lh(A,h)|0,0);z5(A);break}else{h=c[o>>2]|0;break}}while(0);g=b+1044|0;d:do if((h|0)<1330524774){switch(h|0){case 0:break;default:{p=68;break d}}VU(A,391269);BZ(c[B>>2]|0,c[b+668>>2]|0,0,0);z5(A);B=x;D=v;E=c[u>>2]|0;D=D_(c[B>>2]|0,c[B+4>>2]|0,c[D>>2]|0,c[D+4>>2]|0)|0;E=D_(D|0,z|0,E|0,0)|0;Op(b,E,z);E=n;c[E>>2]=0;c[E+4>>2]=0;break a}else{switch(h|0){case 1330524774:break;default:{p=68;break d}}c[o>>2]=1096173856;h=1096173856;f=c[B>>2]|0;p=72}while(0);if((p|0)==68){f=c[B>>2]|0;if((h|0)==1463899717&(f|0)==2)if((a[i>>0]|0)==0?(E=x,D=c[E+4>>2]|0,D>>>0>0|(D|0)==0&(c[E>>2]|0)>>>0>4294967295):0){a[g>>0]=1;h=1463899717;f=2;p=74}else{h=1463899717;f=2;p=72}else p=72}e:do if((p|0)==72)if(a[g>>0]|0)if((h|0)<1684108385)switch(h|0){case 1463899717:{p=74;break e}default:break e}else switch(h|0){case 1684108385:{p=74;break e}default:break e}while(0);if((p|0)==74){D=x;d=v;E=c[d>>2]|0;d=c[d+4>>2]|0;e=c[u>>2]|0;D=z0(c[D>>2]|0,c[D+4>>2]|0,-8,-1)|0;d=D_(D|0,z|0,E|0,d|0)|0;e=D_(d|0,z|0,e|0,0)|0;d=z}o=b+1008|0;n=c[o>>2]|0;o=c[o+4>>2]|0;E=XZ(n|0,o|0,1)|0;D=z;g=z0(e|0,d|0,8,0)|0;i=z;if((!((h&65535|0)==27e3|((h&-65536|0)==1769472e3|(i>>>0>0|(i|0)==0&g>>>0>1048576)&(((n|0)!=0|(o|0)!=0)&(d>>>0>D>>>0|(d|0)==(D|0)&e>>>0>E>>>0))^1))?(f|0)==((a[b+1039>>0]|0?5:4)|0):0)?(r=c[u>>2]|0,s=r+8|0,E=z0(s|0,0,e|0,d|0)|0,D=z,t=c[q>>2]|0,D>>>0>0|(D|0)==0&E>>>0>t>>>0):0){e=z0(r|0,0,g|0,i|0)|0;d=v;d=z0(e|0,z|0,c[d>>2]|0,c[d+4>>2]|0)|0;e=y;c[e>>2]=d;c[e+4>>2]=z;e=t-s|0;d=0}if((h|0)<1684108385)switch(h|0){case 1397968452:{p=80;break}default:{}}else switch(h|0){case 1684108385:{p=80;break}default:{}}if((p|0)==80){g=v;f=c[u>>2]|0;g=z0(c[g>>2]|0,c[g+4>>2]|0,8,0)|0;f=z0(g|0,z|0,f|0,0)|0;g=z;E=w;c[E>>2]=f;c[E+4>>2]=g;if((e|0)==0&(d|0)==0){e=x;d=c[e>>2]|0;e=c[e+4>>2]|0}else{d=z0(f|0,g|0,e|0,d|0)|0;e=z}E=y;c[E>>2]=d;c[E+4>>2]=e;e=0;d=0}TX(A);lh(A,h)|0;BZ(c[B>>2]|0,c[b+668>>2]|0,h,0);z5(A);E=z0(e|0,d|0,8,0)|0;Op(b,E,z);break}}else a[e>>0]=1;e1(b,12,0);Uy(b,A);do if(!d){e=A;d=c[e>>2]|0;e=c[e+4>>2]|0;f=d&7;if((f|0)==0&0==0){E=n;c[E>>2]=0;c[E+4>>2]=0;break}else{D=n;c[D>>2]=f;c[D+4>>2]=0;D=z0(f|0,0,d|0,e|0)|0;E=A;c[E>>2]=D;c[E+4>>2]=z;break}}else{h=n;c[h>>2]=0;c[h+4>>2]=0;r3(b,o);e1(b,12,0);h=c[o>>2]|0}while(0);if((h|0)==1684108385){f=v;f=z0(c[u>>2]|0,0,c[f>>2]|0,c[f+4>>2]|0)|0;g=z;e=w;c[e>>2]=f;c[e+4>>2]=g;e=A;d=c[e>>2]|0;e=c[e+4>>2]|0;if((d|0)==0&(e|0)==0){e=x;d=c[e>>2]|0;e=c[e+4>>2]|0}else{d=z0(f|0,g|0,d|0,e|0)|0;e=z}c[y>>2]=d;c[y+4>>2]=e;y=b+528|0;D=c[y+4>>2]|0;E=A;c[E>>2]=c[y>>2];c[E+4>>2]=D}TX(m);lh(m,h)|0;BZ(c[B>>2]|0,c[b+668>>2]|0,h,0);z5(m);E=A;Op(b,c[E>>2]|0,c[E+4>>2]|0)}while(0)}while(0);l=C;return}function zc(f){f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;S=l;l=l+48|0;n=S;M=S+18|0;O=S+16|0;P=S+37|0;t=S+36|0;Q=S+35|0;u=S+34|0;R=S+33|0;x=S+32|0;G=S+31|0;I=S+30|0;o=S+29|0;J=S+28|0;K=S+27|0;p=S+26|0;s=S+25|0;v=S+24|0;w=S+23|0;L=S+22|0;q=S+21|0;r=S+20|0;B=f+536|0;D=B;C=c[D>>2]|0;D=c[D+4>>2]|0;E=f+1183|0;F=f+528|0;j=c[f+544>>2]|0;k=c[f+612>>2]|0;if(((a[E>>0]|0)+-11&255)<6){g=F;A=c[g>>2]|0;g=c[g+4>>2]|0;m=j+k+A+2|0;m=d7(a[m>>0]|0,a[m+1>>0]|0)|0;g=z0(A|0,g|0,2,0)|0;m=z0(g|0,z|0,m<<1&4094|0,0)|0;g=z;A=g>>>0>D>>>0|(g|0)==(D|0)&m>>>0>C>>>0;m=A?C:m;g=A?D:g;A=B;c[A>>2]=m;c[A+4>>2]=g}else{m=C;g=D}g=z0(k|0,0,m|0,g|0)|0;h=z;i=z0(g|0,h|0,-3,0)|0;i=d[j+i>>0]|0;if(!(i&2))A=65535;else{A=z0(g|0,h|0,-4,0)|0;A=d[j+A>>0]<<6|i>>>2}YZ(n,j+k|0,m);h=n+4|0;while(1){g=c[h>>2]|0;if((raa(g)|0)>>>0<=18)break;if((LA(n)|0)<<16>>16==22584?Pk(n)|0:0){H=9;break}BH(n,1)}if((H|0)==9)g=c[h>>2]|0;g=raa(g)|0;y=f+784|0;c[y>>2]=g>>>0>18?g:-1;b[M>>1]=0;b[O>>1]=0;a[P>>0]=-1;a[t>>0]=-1;a[Q>>0]=-1;a[u>>0]=-1;a[R>>0]=-1;a[x>>0]=-1;a[G>>0]=0;a[I>>0]=0;a[o>>0]=0;a[J>>0]=0;a[K>>0]=0;a[p>>0]=0;a[s>>0]=0;a[v>>0]=0;a[w>>0]=0;a[L>>0]=0;a[q>>0]=0;g=a[E>>0]|0;h=f+1180|0;do if((g&255)<10){GC(f);q=F;q=z0(c[q>>2]|0,c[q+4>>2]|0,4,0)|0;k=F;c[k>>2]=q;c[k+4>>2]=z;Bx(f);xR(f,2,h);xR(f,6,f+1182|0);J3(f);GC(f);xR(f,5,E);xR(f,3,J);xR(f,3,o);k=a[o>>0]|0;if(!(k<<24>>24==1|(k&1)==0))d4(c[f+648>>2]|0,2);if(k&4)d4(c[f+648>>2]|0,2);if(k<<24>>24==2)xR(f,2,K);AT(f,L);xR(f,5,P);AT(f,p);o=a[p>>0]|0;if(o<<24>>24)xR(f,8,Q);i=f+648|0;if(K6(c[i>>2]|0)|0){GC(f);A6(c[i>>2]|0);d4(c[i>>2]|0,8);J3(f)}else A6(c[i>>2]|0);if(K6(c[i>>2]|0)|0){GC(f);A6(c[i>>2]|0);d4(c[i>>2]|0,8);d4(c[i>>2]|0,2);J3(f)}else A6(c[i>>2]|0);j=k<<24>>24==0;do if(j){xR(f,5,t);AT(f,s);if(a[s>>0]|0)xR(f,8,u);if(K6(c[i>>2]|0)|0){GC(f);A6(c[i>>2]|0);d4(c[i>>2]|0,8);J3(f)}else A6(c[i>>2]|0);if(K6(c[i>>2]|0)|0){GC(f);A6(c[i>>2]|0);d4(c[i>>2]|0,8);d4(c[i>>2]|0,2);J3(f);break}else{A6(c[i>>2]|0);break}}while(0);A6(c[i>>2]|0);A6(c[i>>2]|0);if(K6(c[i>>2]|0)|0){GC(f);A6(c[i>>2]|0);d4(c[i>>2]|0,14);J3(f)}else A6(c[i>>2]|0);if(K6(c[i>>2]|0)|0){GC(f);A6(c[i>>2]|0);d4(c[i>>2]|0,14);J3(f)}else A6(c[i>>2]|0);if(K6(c[i>>2]|0)|0){GC(f);A6(c[i>>2]|0);xR(f,6,r);h=a[r>>0]|0;g=0;while(1){if((g&255)>(h&255))break;d4(c[i>>2]|0,8);g=g+1<<24>>24}J3(f)}else A6(c[i>>2]|0);J3(f);GC(f);h=a[371002+(k&255)>>0]|0;g=0;while(1){if((g&255)>=(h&255)){g=0;break}A6(c[i>>2]|0);g=g+1<<24>>24}while(1){if((g&255)>=(h&255))break;A6(c[i>>2]|0);g=g+1<<24>>24}AT(f,v);g=a[v>>0]|0;if(g<<24>>24)xR(f,8,R);if(j?(AT(f,w),a[w>>0]|0):0)xR(f,8,x);J3(f);m=0;p=k;n=0;q=g}else{if(!(g<<24>>24!=10&(g&255)<17)){p=B;m=F;m=D_(c[p>>2]|0,c[p+4>>2]|0,c[m>>2]|0,c[m+4>>2]|0)|0;e1(f,m,z);m=0;p=0;n=0;o=0;q=0;break}GC(f);x=F;x=z0(c[x>>2]|0,c[x+4>>2]|0,2,0)|0;g=F;c[g>>2]=x;c[g+4>>2]=z;J3(f);GC(f);Bx(f);xR(f,2,G);xR(f,3,I);sR(f,11,M);xR(f,2,h);g=f+1401|0;if((a[h>>0]|0)==3){xR(f,2,f+1181|0);a[g>>0]=3}else xR(f,2,g);xR(f,3,o);AT(f,L);xR(f,5,E);xR(f,5,P);yT(f,p);j=a[p>>0]|0;if(!(j<<24>>24))A6(c[f+648>>2]|0);else{GC(f);A6(c[f+648>>2]|0);xR(f,8,Q);J3(f)}i=a[o>>0]|0;do if(!(i<<24>>24)){xR(f,5,t);yT(f,s);if(!(a[s>>0]|0)){A6(c[f+648>>2]|0);break}else{GC(f);A6(c[f+648>>2]|0);xR(f,8,u);J3(f);break}}while(0);g=a[G>>0]|0;do if(g<<24>>24==1){yT(f,q);if(!(a[q>>0]|0)){A6(c[f+648>>2]|0);h=0;break}else{GC(f);A6(c[f+648>>2]|0);sR(f,16,O);J3(f);h=1;break}}else h=0;while(0);J3(f);m=g;p=i;n=h;o=j;q=0}while(0);if((d[E>>0]|0)<17){h=A&65535;h=(h|0)==65535?18:h+32|0;i=f+648|0;j=c[i>>2]|0;k=Z9(c[j+4>>2]|0)|0;if(k>>>0<h>>>0){wK(f);A=B;F=D_(c[A>>2]|0,c[A+4>>2]|0,c[F>>2]|0,c[F+4>>2]|0)|0;e1(f,F,z)}else{g=c[y>>2]|0;if(!((g|0)!=-1&h>>>0<g>>>0)){if(k>>>0>h>>>0)G4(j,k-h|0)}else{G4(j,k-g|0);XW(f);A=c[i>>2]|0;G4(A,(Z9(c[A+4>>2]|0)|0)-h|0)}GC(f);A6(c[i>>2]|0);J3(f);GC(f);A6(c[i>>2]|0);wK(f);A=F;A=z0(c[A>>2]|0,c[A+4>>2]|0,2,0)|0;c[F>>2]=A;c[F+4>>2]=z;J3(f)}if((d[E>>0]|0)>10){F=B;c[F>>2]=C;c[F+4>>2]=D}}if(qO(f)|0?(N=a[E>>0]|0,(N&255)<=16):0){i=f+1409|0;if((m&255)<=1){g=m&255;if(!(m<<24>>24))H=90;else h=g}else{a[G>>0]=0;g=0;H=90}if((H|0)==90){a[i>>0]=a[I>>0]|0;h=g}g=f+1184|0;H=a[g>>0]|0;if(H<<24>>24==-1|(N&255)>(H&255))a[g>>0]=N;N=f+312|0;if((c[N>>2]|0)==0&(c[N+4>>2]|0)==0){H=d[i>>0]|0;N=(d[I>>0]|0)+h|0;b[f+1032+(H*18|0)+(N<<1)>>1]=(e[M>>1]|0)+1;a[f+1257+(H*9|0)+N>>0]=p;M=d[i>>0]|0;a[f+1411+(M*9|0)+N>>0]=a[L>>0]|0;a[f+1185+(M*9|0)+N>>0]=a[J>>0]|0;a[f+1329+((d[i>>0]|0)*9|0)+N>>0]=a[K>>0]|0;M=d[i>>0]|0;a[f+1492+(M*9|0)+N>>0]=n;b[f+888+(M*18|0)+(N<<1)>>1]=b[O>>1]|0;a[f+809>>0]=a[P>>0]|0;if(o<<24>>24)a[f+810>>0]=a[Q>>0]|0;if(q<<24>>24)a[f+811>>0]=a[R>>0]|0;a[f+812>>0]=o;a[f+813>>0]=q}h=f+816|0;if((c[h>>2]|0)==(c[f+820>>2]|0))LI(h,32);g=a[P>>0]|0;if(g<<24>>24!=-1){P=(c[h>>2]|0)+((g&255)<<3)|0;O=P;O=z0(c[O>>2]|0,c[O+4>>2]|0,1,0)|0;c[P>>2]=O;c[P+4>>2]=z}if(o<<24>>24){h=f+828|0;if((c[h>>2]|0)==(c[f+832>>2]|0))LI(h,256);g=a[Q>>0]|0;if(g<<24>>24!=-1){Q=(c[h>>2]|0)+((g&255)<<3)|0;P=Q;P=z0(c[P>>2]|0,c[P+4>>2]|0,1,0)|0;c[Q>>2]=P;c[Q+4>>2]=z}}if(!(q<<24>>24))a[R>>0]=0;else a[f+1491>>0]=1;h=f+840|0;if((c[h>>2]|0)==(c[f+844>>2]|0))LI(h,256);g=a[R>>0]|0;if(g<<24>>24!=-1){R=(c[h>>2]|0)+((g&255)<<3)|0;f=R;f=z0(c[f>>2]|0,c[f+4>>2]|0,1,0)|0;c[R>>2]=f;c[R+4>>2]=z}}l=S;return}function Ac(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;U=l;l=l+176|0;O=U+156|0;P=U+144|0;Q=U+132|0;R=U+120|0;S=U+108|0;p=U+96|0;n=U+84|0;o=U+72|0;k=U+60|0;m=U+48|0;i=U+36|0;j=U+24|0;g=U+12|0;h=U;a:do if((e|0)<=6?(N=d+28|0,M=c[N>>2]|0,(((c[M+(e*12|0)+4>>2]|0)-(c[M+(e*12|0)>>2]|0)|0)/40|0)>>>0>f>>>0):0){Xy(P,4400);ZC(O,P);M=a[O+8+3>>0]|0;do if(!((M<<24>>24<0?c[O+4>>2]|0:M&255)|0)){Xy(R,4432);ZC(Q,R);M=a[Q+8+3>>0]|0;if((M<<24>>24<0?c[Q+4>>2]|0:M&255)|0){z5(Q);z5(R);z5(O);z5(P);break}Xy(p,4456);ZC(S,p);M=a[S+8+3>>0]|0;if(!((M<<24>>24<0?c[S+4>>2]|0:M&255)|0)){Xy(o,4480);ZC(n,o);M=a[n+8+3>>0]|0;if(!((M<<24>>24<0?c[n+4>>2]|0:M&255)|0)){Xy(m,4500);ZC(k,m);M=a[k+8+3>>0]|0;if(!((M<<24>>24<0?c[k+4>>2]|0:M&255)|0)){Xy(j,4524);ZC(i,j);M=a[i+8+3>>0]|0;if(!((M<<24>>24<0?c[i+4>>2]|0:M&255)|0)){Xy(h,4548);ZC(g,h);M=a[g+8+3>>0]|0;M=((M<<24>>24<0?c[g+4>>2]|0:M&255)|0)==0;z5(g);z5(h);g=M}else g=0;z5(i);z5(j)}else g=0;z5(k);z5(m)}else g=0;z5(n);z5(o)}else g=0;z5(S);z5(p);z5(Q);z5(R);z5(O);z5(P);if(g){TX(b);H=sr(d,e,f)|0;I=P+8+3|0;J=P+4|0;K=R+8+3|0;L=R+4|0;M=R+8+3|0;k=R+4|0;n=R+8|0;o=n+3|0;p=S+8|0;q=p+3|0;r=R+8|0;s=r+3|0;t=S+8|0;u=t+3|0;v=R+8|0;w=v+3|0;x=S+8|0;y=x+3|0;z=Q+8+3|0;A=Q+4|0;B=S+4|0;C=R+4|0;D=S+4|0;E=R+4|0;F=S+4|0;G=R+4|0;j=0;m=0;b:while(1){if(j>>>0>=H>>>0){T=17;break}Dk(O,d,e,f,j,5);Dk(P,d,e,f,j,1);i=a[I>>0]|0;i=((i<<24>>24<0?c[J>>2]|0:i&255)|0)==0;z5(P);if(i)g=m;else{if(!m){m=c[(c[N>>2]|0)+(e*12|0)>>2]|0;if(j>>>0<(((c[m+(f*40|0)+4>>2]|0)-(c[m+(f*40|0)>>2]|0)|0)/12|0)>>>0)g=0;else{HX(b,4568)|0;g=1}}else g=1;Dk(P,d,e,f,j,4);Dk(Q,d,e,f,j,0);vF(P,Q)|0;z5(Q);Dk(Q,d,e,f,j,1);if(!((oH(Q,13,0)|0)==-1?(oH(Q,10,0)|0)==-1:0))T=26;do if((T|0)==26){T=0;c[R>>2]=0;c[R+4>>2]=0;c[R+8>>2]=0;i=i9(42452)|0;if(i>>>0>1073741807){T=27;break b}if(i>>>0<2){a[o>>0]=i;h=R}else{h=i+4&-4;if(h>>>0>1073741823){T=31;break b}m=ZW(h<<2)|0;c[R>>2]=m;c[n>>2]=h|-2147483648;c[G>>2]=i;h=m}a3(h,42452,i);y7(h+(i<<2)|0,0);c[S>>2]=0;c[S+4>>2]=0;c[S+8>>2]=0;i=i9(41840)|0;if(i>>>0>1073741807){T=34;break b}if(i>>>0<2){a[q>>0]=i;h=S}else{h=i+4&-4;if(h>>>0>1073741823){T=38;break b}m=ZW(h<<2)|0;c[S>>2]=m;c[p>>2]=h|-2147483648;c[F>>2]=i;h=m}a3(h,41840,i);y7(h+(i<<2)|0,0);vo(Q,R,S,0,8);O0(S);O0(R);c[R>>2]=0;c[R+4>>2]=0;c[R+8>>2]=0;i=i9(42464)|0;if(i>>>0>1073741807){T=41;break b}if(i>>>0<2){a[s>>0]=i;h=R}else{h=i+4&-4;if(h>>>0>1073741823){T=45;break b}m=ZW(h<<2)|0;c[R>>2]=m;c[r>>2]=h|-2147483648;c[E>>2]=i;h=m}a3(h,42464,i);y7(h+(i<<2)|0,0);c[S>>2]=0;c[S+4>>2]=0;c[S+8>>2]=0;i=i9(41840)|0;if(i>>>0>1073741807){T=48;break b}if(i>>>0<2){a[u>>0]=i;h=S}else{h=i+4&-4;if(h>>>0>1073741823){T=52;break b}m=ZW(h<<2)|0;c[S>>2]=m;c[t>>2]=h|-2147483648;c[D>>2]=i;h=m}a3(h,41840,i);y7(h+(i<<2)|0,0);vo(Q,R,S,0,8);O0(S);O0(R);c[R>>2]=0;c[R+4>>2]=0;c[R+8>>2]=0;i=i9(42472)|0;if(i>>>0>1073741807){T=55;break b}if(i>>>0<2){a[w>>0]=i;h=R}else{h=i+4&-4;if(h>>>0>1073741823){T=59;break b}m=ZW(h<<2)|0;c[R>>2]=m;c[v>>2]=h|-2147483648;c[C>>2]=i;h=m}a3(h,42472,i);y7(h+(i<<2)|0,0);c[S>>2]=0;c[S+4>>2]=0;c[S+8>>2]=0;i=i9(41840)|0;if(i>>>0>1073741807){T=62;break b}if(i>>>0<2){a[y>>0]=i;h=S}else{h=i+4&-4;if(h>>>0>1073741823){T=66;break b}m=ZW(h<<2)|0;c[S>>2]=m;c[x>>2]=h|-2147483648;c[B>>2]=i;h=m}a3(h,41840,i);y7(h+(i<<2)|0,0);vo(Q,R,S,0,8);O0(S);O0(R);i=a[z>>0]|0;h=i<<24>>24<0;i=h?c[A>>2]|0:i&255;if(i>>>0<=2)break;h=h?c[Q>>2]|0:Q;W=i9(41840)|0;V=h+(i<<2)|0;m=Ix(h,V,41840,41840+(W<<2)|0)|0;h=(W|0)!=0&(m|0)==(V|0)?-1:m-h>>2;if((h|0)!=(i+-3|0))break;FB(Q,h,0)}while(0);TX(S);ac(R,P,S);W=a[K>>0]|0;V=W<<24>>24<0;Ex(b,V?c[R>>2]|0:R,V?c[L>>2]|0:W&255)|0;z5(R);z5(S);HX(b,42204)|0;ac(R,Q,P);W=a[M>>0]|0;V=W<<24>>24<0;Ex(b,V?c[R>>2]|0:R,V?c[k>>2]|0:W&255)|0;z5(R);HX(b,22884)|0;z5(Q);z5(P)}z5(O);j=j+1|0;m=g}switch(T|0){case 17:{g=a[b+8+3>>0]|0;j=g<<24>>24<0;k=b+4|0;g=g&255;if(j)h=c[k>>2]|0;else h=g;if(h>>>0>1){if(j){h=c[k>>2]|0;i=c[b>>2]|0}else{h=g;i=b}if((c[i+(h+-1<<2)>>2]|0)==44){if(j)g=c[k>>2]|0;ny(b,g+-1|0,1)|0}}if(!m)break a;HX(b,4084)|0;break a}case 27:{uaa();break}case 31:{W=ua(8)|0;K2(W,391652);c[W>>2]=57868;Ya(W|0,2712,367)}case 34:{uaa();break}case 38:{W=ua(8)|0;K2(W,391652);c[W>>2]=57868;Ya(W|0,2712,367)}case 41:{uaa();break}case 45:{W=ua(8)|0;K2(W,391652);c[W>>2]=57868;Ya(W|0,2712,367)}case 48:{uaa();break}case 52:{W=ua(8)|0;K2(W,391652);c[W>>2]=57868;Ya(W|0,2712,367)}case 55:{uaa();break}case 59:{W=ua(8)|0;K2(W,391652);c[W>>2]=57868;Ya(W|0,2712,367)}case 62:{uaa();break}case 66:{W=ua(8)|0;K2(W,391652);c[W>>2]=57868;Ya(W|0,2712,367)}}}}else{z5(O);z5(P)}while(0);TX(O);HX(O,4612)|0;rV(b,O);z5(O)}else T=3;while(0);if((T|0)==3)TX(b);l=U;return}function Bc(d){d=d|0;var e=0,f=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+48|0;t=w+32|0;e=w+28|0;f=w+24|0;h=w+36|0;u=w+12|0;m=w;v=d+528|0;r=v;r=z0(c[r>>2]|0,c[r+4>>2]|0,4,0)|0;p=v;c[p>>2]=r;c[p+4>>2]=z;bD(d,e);bD(d,f);p=v;p=z0(c[p>>2]|0,c[p+4>>2]|0,2,0)|0;r=v;c[r>>2]=p;c[r+4>>2]=z;HB(d,h);r3(d,t);r=v;r=z0(c[r>>2]|0,c[r+4>>2]|0,20,0)|0;p=v;c[p>>2]=r;c[p+4>>2]=z;p=c[t>>2]|0;r=d+760|0;s=d+772|0;c[(jF(r,s)|0)+36>>2]=p;p=c[t>>2]|0;if((p|0)==(W8(379854)|0)){RB(d,0,0,57,379665,-1,1,1);Kc(d,3,-1)|0}else Kc(d,1,-1)|0;TX(u);i=lh(u,c[t>>2]|0)|0;n=d+16|0;p=d+20|0;Rf(d,i,c[n>>2]|0,c[p>>2]|0,3);z5(u);i=c[n>>2]|0;k=c[p>>2]|0;TX(m);o=lh(m,c[t>>2]|0)|0;j=Rb(i,17)|0;pk(u,o);RB(d,i,k,j,(a[u+11>>0]|0)<0?c[u>>2]|0:u,-1,1,0);a1(u);z5(m);j=c[n>>2]|0;k=c[p>>2]|0;TX(m);i=lh(m,c[t>>2]|0)|0;o=Rb(j,21)|0;pk(u,i);RB(d,j,k,o,(a[u+11>>0]|0)<0?c[u>>2]|0:u,-1,1,0);a1(u);z5(m);fM(d,c[n>>2]|0,c[p>>2]|0,379859,c[e>>2]|0,1);o=c[f>>2]|0;fM(d,c[n>>2]|0,c[p>>2]|0,379865,(o|0)<0?0-o|0:o,1);o=b[h>>1]|0;k=o<<16>>16==32;e=c[t>>2]|0;a:do if(k&(e|0)==1953719139)$M(d,c[n>>2]|0,c[p>>2]|0,379872,8);else{f=c[n>>2]|0;if((e|0)==1145656883){$M(d,f,c[p>>2]|0,379872,8);break}TX(u);j=Aj(f,3,lh(u,c[t>>2]|0)|0,1)|0;e=a[j+8+3>>0]|0;f=e<<24>>24<0;h=f?c[j>>2]|0:j;i=i9(29356)|0;if(!i)e=0;else{j=h+((f?c[j+4>>2]|0:e&255)<<2)|0;e=HA(h,j,29356,29356+(i<<2)|0)|0;e=(e|0)==(j|0)?-1:e-h>>2}z5(u);f=c[n>>2]|0;if((e|0)!=-1){$M(d,f,c[p>>2]|0,379872,((o&65535)/3|0)&65535);break}if((c[t>>2]|0)==1146639170){_M(d,f,c[p>>2]|0,379872,o);break}TX(u);e=Aj(f,3,lh(u,c[t>>2]|0)|0,7)|0;f=a[e+8+3>>0]|0;h=f<<24>>24<0;i=h?c[e>>2]|0:e;j=i9(29388)|0;if(!j)e=0;else{h=i+((h?c[e+4>>2]|0:f&255)<<2)|0;e=HA(i,h,29388,29388+(j<<2)|0)|0;e=(e|0)==(h|0)?-1:e-i>>2}z5(u);if((e|0)!=-1){$M(d,c[n>>2]|0,c[p>>2]|0,379872,(o&65535)>>>2&65535);break}if(c[t>>2]|0){e=c[n>>2]|0;TX(u);e=Aj(e,3,lh(u,c[t>>2]|0)|0,7)|0;f=a[e+8+3>>0]|0;h=f<<24>>24<0;i=h?c[e>>2]|0:e;j=i9(29408)|0;if(!j)e=0;else{h=i+((h?c[e+4>>2]|0:f&255)<<2)|0;e=HA(i,h,29408,29408+(j<<2)|0)|0;e=(e|0)==(h|0)?-1:e-i>>2}z5(u);if((e|0)==-1){do if((c[t>>2]|0)!=1448097330){e=c[n>>2]|0;TX(u);e=Aj(e,3,lh(u,c[t>>2]|0)|0,1)|0;f=i9(29424)|0;k=a[e+8+3>>0]|0;if((f|0)==((k<<24>>24<0?c[e+4>>2]|0:k&255)|0)?(VG(e,29424,f)|0)==0:0){z5(u);break}e=c[n>>2]|0;TX(m);e=Aj(e,3,lh(m,c[t>>2]|0)|0,1)|0;f=i9(30008)|0;k=a[e+8+3>>0]|0;if((f|0)==((k<<24>>24<0?c[e+4>>2]|0:k&255)|0)){k=(VG(e,30008,f)|0)==0;z5(m);z5(u);if(k)break;else break a}else{z5(m);z5(u);break a}}while(0);$M(d,c[n>>2]|0,c[p>>2]|0,379872,((o&65535)/3|0)&65535);break}}f=c[n>>2]|0;h=c[p>>2]|0;if(k){RB(d,f,h,Rb(f,0)|0,379881,-1,1,1);$M(d,c[n>>2]|0,c[p>>2]|0,379872,8);break}if((o&65535)<17)e=8;else e=((o&65535)/3|0)&65535;$M(d,f,h,379872,e)}while(0);e=c[n>>2]|0;c[(jF(r,s)|0)+40>>2]=e;TX(u);e=Aj(1,3,lh(u,c[t>>2]|0)|0,1)|0;f=i9(29964)|0;n=a[e+8+3>>0]|0;if((f|0)==((n<<24>>24<0?c[e+4>>2]|0:n&255)|0)){n=(VG(e,29964,f)|0)==0;z5(u);if(n){i=ZW(1104)|0;ln(i);a[i+776>>0]=1;a[i+777>>0]=1;e=jF(r,s)|0;c[u>>2]=i;f=e+4|0;h=c[f>>2]|0;if(h>>>0<(c[e+8>>2]|0)>>>0){c[h>>2]=i;c[f>>2]=(c[f>>2]|0)+4}else Yy(e,u)}else q=42}else{z5(u);q=42}b:do if((q|0)==42){TX(u);e=Aj(1,3,lh(u,c[t>>2]|0)|0,1)|0;f=i9(29448)|0;q=a[e+8+3>>0]|0;if((f|0)==((q<<24>>24<0?c[e+4>>2]|0:q&255)|0)){q=(VG(e,29448,f)|0)==0;z5(u);if(q){i=ZW(1040)|0;_z(i);a[(jF(r,s)|0)+81>>0]=1;a[i+768>>0]=1;if(+g[(c[d+24>>2]|0)+136>>2]>=.5)a[i+732>>0]=1;e=jF(r,s)|0;c[u>>2]=i;f=e+4|0;h=c[f>>2]|0;if(h>>>0<(c[e+8>>2]|0)>>>0){c[h>>2]=i;c[f>>2]=(c[f>>2]|0)+4}else Yy(e,u);break}}else z5(u);TX(u);e=Aj(1,3,lh(u,c[t>>2]|0)|0,1)|0;f=i9(39980)|0;q=a[e+8+3>>0]|0;if((f|0)==((q<<24>>24<0?c[e+4>>2]|0:q&255)|0)){q=(VG(e,39980,f)|0)==0;z5(u);if(q){i=ZW(1056)|0;Mr(i);a[i+768>>0]=1;e=jF(r,s)|0;c[u>>2]=i;f=e+4|0;h=c[f>>2]|0;if(h>>>0<(c[e+8>>2]|0)>>>0){c[h>>2]=i;c[f>>2]=(c[f>>2]|0)+4}else Yy(e,u);break}}else z5(u);if((c[t>>2]|0)==1212569941)switch(o<<16>>16){case 16:{RB(d,1,c[p>>2]|0,191,384021,-1,1,0);RB(d,1,c[p>>2]|0,192,384029,-1,1,0);sM(d,1,c[p>>2]|0,195,8,0);break b}case 24:{RB(d,1,c[p>>2]|0,191,384047,-1,1,0);sM(d,1,c[p>>2]|0,195,8,0);break b}case 32:{RB(d,1,c[p>>2]|0,191,379881,-1,1,0);sM(d,1,c[p>>2]|0,195,8,0);break b}default:break b}}while(0);PK(d);r=v;p=c[r+4>>2]|0;h=d+536|0;s=h;q=c[s+4>>2]|0;do if(p>>>0<q>>>0|((p|0)==(q|0)?(c[r>>2]|0)>>>0<(c[s>>2]|0)>>>0:0)){TX(u);e=Aj(1,3,lh(u,c[t>>2]|0)|0,1)|0;f=i9(39980)|0;s=a[e+8+3>>0]|0;if((f|0)==((s<<24>>24<0?c[e+4>>2]|0:s&255)|0)){s=(VG(e,39980,f)|0)==0;z5(u);if(s){lt(d);break}}else z5(u);TX(u);e=Aj(1,3,lh(u,c[t>>2]|0)|0,1)|0;f=i9(29504)|0;s=a[e+8+3>>0]|0;if((f|0)==((s<<24>>24<0?c[e+4>>2]|0:s&255)|0)){s=(VG(e,29504,f)|0)==0;z5(u);if(s){SN(d);break}}else z5(u);TX(u);e=Aj(1,3,lh(u,c[t>>2]|0)|0,1)|0;f=i9(29524)|0;t=a[e+8+3>>0]|0;if((f|0)==((t<<24>>24<0?c[e+4>>2]|0:t&255)|0)){t=(VG(e,29524,f)|0)==0;z5(u);if(t){SN(d);break}}else z5(u);u=h;v=D_(c[u>>2]|0,c[u+4>>2]|0,c[v>>2]|0,c[v+4>>2]|0)|0;e1(d,v,z)}while(0);l=w;return}function Cc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0.0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;U=l;l=l+176|0;G=U+128|0;O=U+88|0;P=U+72|0;Q=U+60|0;R=U+48|0;S=U+36|0;o=U+24|0;p=U+12|0;q=U;$x(G,b,d,e,f,1);N=a[G+8+3>>0]|0;N=((N<<24>>24<0?c[G+4>>2]|0:N&255)|0)==0;z5(G);if(!N){r=f+1|0;Ed(b,d,e,r);mI(G);Xy(O,41840);z3(G,O);z5(O);$x(O,b,d,e,f,1);og(G,O);z5(O);mI(O);Xy(P,41840);z3(O,P);z5(P);s=G+4|0;t=O+4|0;u=O+8|0;v=(d|0)==2;w=(f|0)==112;x=Q+8+3|0;y=Q+4|0;A=R+8+3|0;B=R+4|0;C=S+8+3|0;D=S+4|0;E=o+8+3|0;F=o+4|0;H=p+8+3|0;I=p+4|0;J=q+8+3|0;K=q+4|0;L=(f|0)==135;M=P+8+3|0;N=P+4|0;n=0;while(1){g=c[G>>2]|0;if(n>>>0>=(((c[s>>2]|0)-g|0)/12|0)>>>0)break;k=rm(g+(n*12|0)|0)|0;m=z;do if((k|0)==0&(m|0)==0){j=c[G>>2]|0;g=a[j+(n*12|0)+8+3>>0]|0;i=g<<24>>24<0;if(i)g=c[j+(n*12|0)+4>>2]|0;else g=g&255;if(g|0){g=j+(n*12|0)|0;if(i)g=c[g>>2]|0;if((c[g>>2]|0)<=57){T=18;break}}pl(P,j+(n*12|0)|0);g=c[t>>2]|0;if(g>>>0<(c[u>>2]|0)>>>0){rV(g,P);c[t>>2]=(c[t>>2]|0)+12}else Dx(O,P);z5(P)}else T=18;while(0);if((T|0)==18){T=0;TX(P);if(v){j=(k|0)==176400&(m|0)==0;g=(k|0)==352800&(m|0)==0;a:do if(w){$x(Q,b,2,e,18,1);i=i9(28648)|0;V=a[x>>0]|0;if((i|0)==((V<<24>>24<0?c[y>>2]|0:V&255)|0)?(VG(Q,28648,i)|0)==0:0)z5(Q);else T=22;do if((T|0)==22){T=0;$x(R,b,2,e,18,1);i=i9(29032)|0;V=a[A>>0]|0;if((i|0)==((V<<24>>24<0?c[B>>2]|0:V&255)|0)?(VG(R,29032,i)|0)==0:0){z5(R);z5(Q);break}$x(S,b,2,e,18,1);i=i9(6732)|0;V=a[C>>0]|0;if((i|0)==((V<<24>>24<0?c[D>>2]|0:V&255)|0)?(VG(S,6732,i)|0)==0:0){z5(S);z5(R);z5(Q);break}$x(o,b,2,e,18,1);i=i9(7652)|0;V=a[E>>0]|0;if((i|0)==((V<<24>>24<0?c[F>>2]|0:V&255)|0)?(VG(o,7652,i)|0)==0:0){z5(o);z5(S);z5(R);z5(Q);break}$x(p,b,2,e,18,1);i=i9(7692)|0;V=a[H>>0]|0;if((i|0)==((V<<24>>24<0?c[I>>2]|0:V&255)|0)?(VG(p,7692,i)|0)==0:0){z5(p);z5(o);z5(S);z5(R);z5(Q);break}$x(q,b,2,e,18,1);i=i9(29616)|0;V=a[J>>0]|0;if((i|0)==((V<<24>>24<0?c[K>>2]|0:V&255)|0))i=(VG(q,29616,i)|0)==0;else i=0;z5(q);z5(p);z5(o);z5(S);z5(R);z5(Q);if(!i)break a}while(0);b:do if((k|0)<132300){switch(k|0){case 66150:break;default:break b}if(!m){VU(Q,357393);vF(P,Q)|0;z5(Q)}}else{switch(k|0){case 132300:break;default:break b}if(!m){VU(Q,357399);vF(P,Q)|0;z5(Q)}}while(0);if(!j){if((k|0)==264600&(m|0)==0){VU(Q,357411);vF(P,Q)|0;z5(Q)}}else{VU(Q,357405);vF(P,Q)|0;z5(Q)}if(g){VU(Q,357417);vF(P,Q)|0;z5(Q);g=1;break}if((k|0)<705600){switch(k|0){case 529200:break;default:{g=0;break a}}if(m|0){g=0;break}VU(Q,357423);vF(P,Q)|0;z5(Q);g=0;break}if((k|0)<1411200){switch(k|0){case 705600:break;default:{g=0;break a}}if(m|0){g=0;break}VU(Q,357429);vF(P,Q)|0;z5(Q);g=0;break}else{switch(k|0){case 1411200:break;default:{g=0;break a}}if(m|0){g=0;break}VU(Q,357435);vF(P,Q)|0;z5(Q);g=0;break}}while(0);if(L){c:do if((k|0)>=22050){if((k|0)<44100){switch(k|0){case 22050:break;default:break c}if(m|0)break;VU(Q,357456);vF(P,Q)|0;z5(Q);break}if((k|0)<88200){switch(k|0){case 44100:break;default:break c}if(m|0)break;VU(Q,357462);vF(P,Q)|0;z5(Q);break}else{switch(k|0){case 88200:break;default:break c}if(m|0)break;VU(Q,357467);vF(P,Q)|0;z5(Q);break}}else switch(k|0){case 11024:{if(m|0)break c;VU(Q,357442);vF(P,Q)|0;z5(Q);break c}case 11025:{if(m|0)break c;VU(Q,357449);vF(P,Q)|0;z5(Q);break c}default:break c}while(0);if(j){VU(Q,357405);vF(P,Q)|0;z5(Q)}if(g){VU(Q,357417);vF(P,Q)|0;z5(Q)}}}V=a[M>>0]|0;do if(!((V<<24>>24<0?c[N>>2]|0:V&255)|0)){h=+(k>>>0)+4294967296.0*+(m>>>0);if(m>>>0>2|(m|0)==2&k>>>0>1410065408){p2(Q,SU(vn(d)|0,f,2)|0);DW(Q,1,7740)|0;ST(S,h/1.0e9,(m>>>0<23|(m|0)==23&k>>>0<1215752193)&1);ne(R,S,Q,1);g=c[t>>2]|0;if(g>>>0<(c[u>>2]|0)>>>0){rV(g,R);c[t>>2]=(c[t>>2]|0)+12}else Dx(O,R);z5(R);z5(S);z5(Q);break}if(m>>>0>0|(m|0)==0&k>>>0>1e7){p2(Q,SU(vn(d)|0,f,2)|0);DW(Q,1,7748)|0;ST(S,h/1.0e6,(m>>>0<0|(m|0)==0&k>>>0<100000001)&1);ne(R,S,Q,1);g=c[t>>2]|0;if(g>>>0<(c[u>>2]|0)>>>0){rV(g,R);c[t>>2]=(c[t>>2]|0)+12}else Dx(O,R);z5(R);z5(S);z5(Q);break}if(m>>>0>0|(m|0)==0&k>>>0>1e4){p2(Q,SU(vn(d)|0,f,2)|0);DW(Q,1,7732)|0;ST(S,h/1.0e3,(m>>>0<0|(m|0)==0&k>>>0<100001)&1);ne(R,S,Q,1);g=c[t>>2]|0;if(g>>>0<(c[u>>2]|0)>>>0){rV(g,R);c[t>>2]=(c[t>>2]|0)+12}else Dx(O,R);z5(R);z5(S);z5(Q);break}else{oT(R,k,m,10);ne(Q,R,SU(vn(d)|0,f,2)|0,1);g=c[t>>2]|0;if(g>>>0<(c[u>>2]|0)>>>0){rV(g,Q);c[t>>2]=(c[t>>2]|0)+12}else Dx(O,Q);z5(Q);z5(R);break}}else{p2(Q,SU(vn(d)|0,f,2)|0);DW(Q,1,7732)|0;ne(R,P,Q,1);g=c[t>>2]|0;if(g>>>0<(c[u>>2]|0)>>>0){rV(g,R);c[t>>2]=(c[t>>2]|0)+12}else Dx(O,R);z5(R);z5(Q)}while(0);z5(P)}n=n+1|0}de(P,O);zb(b,d,e,r,P,0);z5(P);$_(O);$_(G)}l=U;return}function Dc(d){d=d|0;var f=0,g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;I=l;l=l+96|0;D=I+68|0;k=I+64|0;f=I+60|0;p=I+82|0;G=I;H=I+48|0;u=I+36|0;r=I+78|0;s=I+76|0;y=I+74|0;t=I+72|0;B=I+24|0;A=I+12|0;c[f>>2]=0;NB(d,p);E=d+528|0;C=E;C=z0(c[C>>2]|0,c[C+4>>2]|0,2,0)|0;F=E;c[F>>2]=C;c[F+4>>2]=z;KK(d);p=b[p>>1]|0;F=d+536|0;do if((p&65535)>=2)if(p<<16>>16==2){j=E;j=z0(c[j>>2]|0,c[j+4>>2]|0,16,0)|0;m=E;c[m>>2]=j;c[m+4>>2]=z;dD(d,G);ID(d,D);m=E;m=z0(c[m>>2]|0,c[m+4>>2]|0,4,0)|0;j=E;c[j>>2]=m;c[j+4>>2]=z;ID(d,k);ID(d,f);j=E;j=z0(c[j>>2]|0,c[j+4>>2]|0,8,0)|0;m=E;c[m>>2]=j;c[m+4>>2]=z;m=cT(+h[G>>3])|0;j=c[k>>2]|0;n=z;o=6;break}else{H=F;e1(d,c[H>>2]|0,c[H+4>>2]|0);break}else{NB(d,G);NB(d,H);NB(d,I+80|0);m=E;m=z0(c[m>>2]|0,c[m+4>>2]|0,2,0)|0;j=E;c[j>>2]=m;c[j+4>>2]=z;NB(d,u);j=E;m=p<<16>>16==0;m=z0(c[j>>2]|0,c[j+4>>2]|0,(m?2:18)|0,(m?0:0)|0)|0;j=E;c[j>>2]=m;c[j+4>>2]=z;c[D>>2]=e[G>>1];j=e[H>>1]|0;c[k>>2]=j;m=e[u>>1]|0;n=0;o=6}while(0);if((o|0)==6){C=d+520|0;g=C;f=c[g>>2]|0;g=c[g+4>>2]|0;i=(j|0)==16;if(!(i&((f|0)==1768829492&(g|0)==0)))if(i&((f|0)==1718367026&(g|0)==0)){c[k>>2]=32;x=32}else x=j;else{c[k>>2]=24;x=24}if((c[d+784>>2]|0)==0?qO(d)|0:0){g=C;f=c[g>>2]|0;g=c[g+4>>2]|0;v=d+788|0;w=d+916|0;if(!((f|0)==1935764850&(g|0)==0)){if((m|0)==1&(n|0)==0&((f|0)==1819304813&(g|0)==0)){m=c[(bF(w,v)|0)+192>>2]|0;n=0}}else{c[D>>2]=1;m=8e3;n=0}c[G>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[G+(f<<2)>>2]=0;f=f+1|0}f=C;f=XZ(c[f>>2]|0,c[f+4>>2]|0,24)|0;ay(G,1,f&255)|0;f=C;f=XZ(c[f>>2]|0,c[f+4>>2]|0,16)|0;ay(G,1,f&255)|0;f=j9(377360)|0;k=G+11|0;i=a[k>>0]|0;j=G+4|0;q=d+20|0;if((f|0)==((i<<24>>24<0?c[j>>2]|0:i&255)|0)){J=(ZG(G,377360,f)|0)==0;i=C;g=c[i>>2]|0;i=XZ(g|0,c[i+4>>2]|0,8)|0;f=i&255;if(J){g=z0(i&255|0,0,g&255|0,0)|0;i=z;TX(u);pk(H,bk(u,g,i,16)|0);if((a[k>>0]|0)<0){J7(c[G>>2]|0,0);c[j>>2]=0}else{J7(G,0);a[k>>0]=0}Fp(G,0);c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];f=0;while(1){if((f|0)==3)break;c[H+(f<<2)>>2]=0;f=f+1|0}a1(H);z5(u);oT(H,g,i,16);Rf(d,H,2,c[q>>2]|0,3);z5(H);bw(d,2,c[q>>2]|0,52,G,1,0);bw(d,2,c[q>>2]|0,57,G,1,0)}else o=22}else{f=C;f=XZ(c[f>>2]|0,c[f+4>>2]|0,8)|0;f=f&255;o=22}if((o|0)==22){ay(G,1,f)|0;ay(G,1,c[C>>2]&255)|0;VU(H,(a[k>>0]|0)<0?c[G>>2]|0:G);Rf(d,H,2,c[q>>2]|0,1);z5(H);f=j9(377363)|0;J=a[k>>0]|0;if((f|0)==((J<<24>>24<0?c[j>>2]|0:J&255)|0)){J=(ZG(G,377363,f)|0)==0;f=c[q>>2]|0;if(J)RB(d,2,f,52,391465,-1,0,1);else o=25}else{f=c[q>>2]|0;o=25}if((o|0)==25)bw(d,2,f,52,G,0,1);bw(d,2,c[q>>2]|0,57,G,0,1);f=j9(377368)|0;J=a[k>>0]|0;if((f|0)==((J<<24>>24<0?c[j>>2]|0:J&255)|0)?(ZG(G,377368,f)|0)==0:0)RB(d,2,c[q>>2]|0,274,377373,-1,1,0);f=j9(377380)|0;J=a[k>>0]|0;if((f|0)==((J<<24>>24<0?c[j>>2]|0:J&255)|0)?(ZG(G,377380,f)|0)==0:0)RB(d,2,c[q>>2]|0,274,390558,-1,1,0)}if((p+-1&65535)<2?(J=C,(c[J>>2]|0)==1836069985&(c[J+4>>2]|0)==0):0){f=ZW(22152)|0;Dt(f);Jb(f,m,n,2,0,0,0,0);c[f+908>>2]=2;a[f+904>>0]=1;g=bF(w,v)|0;c[H>>2]=f;i=g+16|0;j=c[i>>2]|0;if(j>>>0<(c[g+20>>2]|0)>>>0){c[j>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(g+12|0,H)}VU(H,(a[k>>0]|0)<0?c[G>>2]|0:G);f=Aj(2,1,H,1)|0;g=i9(40168)|0;J=a[f+8+3>>0]|0;if((g|0)==((J<<24>>24<0?c[f+4>>2]|0:J&255)|0)){J=(VG(f,40168,g)|0)==0;z5(H);if(J){f=ZW(1128)|0;Wr(f);g=bF(w,v)|0;c[H>>2]=f;i=g+16|0;j=c[i>>2]|0;if(j>>>0<(c[g+20>>2]|0)>>>0){c[j>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(g+12|0,H)}}else z5(H);J=C;if((c[J>>2]|0)==1870097761&(c[J+4>>2]|0)==0){HB(d,r);HB(d,s);bD(d,H);bD(d,u);J=E;J=z0(c[J>>2]|0,c[J+4>>2]|0,2,0)|0;k=E;c[k>>2]=J;c[k+4>>2]=z;HB(d,t);HB(d,y);TX(B);k=b[r>>1]|0;Ek(B,k,16)|0;tP(B)|0;Rf(d,B,2,c[q>>2]|0,3);zb(d,2,c[q>>2]|0,52,B,0);zb(d,2,c[q>>2]|0,57,B,0);kL(d,2,c[q>>2]|0,122,b[s>>1]|0,10,1);lL(d,2,c[q>>2]|0,135,c[H>>2]|0,10,1);lL(d,2,c[q>>2]|0,112,c[u>>2]<<3,10,1);kL(d,2,c[q>>2]|0,147,b[t>>1]|0,10,1);do if(qO(d)|0){rU(A,k,16);f=Aj(2,3,A,1)|0;g=i9(40168)|0;J=a[f+8+3>>0]|0;if((g|0)!=((J<<24>>24<0?c[f+4>>2]|0:J&255)|0)){z5(A);break}J=(VG(f,40168,g)|0)==0;z5(A);if(J){f=ZW(1128)|0;Wr(f);g=bF(w,v)|0;c[A>>2]=f;i=g+16|0;j=c[i>>2]|0;if(j>>>0<(c[g+20>>2]|0)>>>0){c[j>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(g+12|0,A)}}while(0);f=b[y>>1]|0;if(f<<16>>16){GC(d);if(k<<16>>16==353){A=E;A=z0(c[A>>2]|0,c[A+4>>2]|0,10,0)|0;J=E;c[J>>2]=A;c[J+4>>2]=z}else e1(d,f&65535,0);J3(d)}z5(B)}g=d+761|0;f=0;while(1){J=bF(w,v)|0;if(f>>>0>=(c[J+16>>2]|0)-(c[J+12>>2]|0)>>2>>>0)break;B=C;A=c[B>>2]|0;B=c[B+4>>2]|0;J=C;c[J>>2]=c[v>>2];c[J+4>>2]=0;aY(d,c[(c[(bF(w,v)|0)+12>>2]|0)+(f<<2)>>2]|0);J=C;c[J>>2]=A;c[J+4>>2]=B;a[g>>0]=1;f=f+1|0}lL(d,2,c[q>>2]|0,122,c[D>>2]|0,10,1);if((x|0?(D=C,J=c[D>>2]|0,!((J|0)==1836069985&(c[D+4>>2]|0)==0|(J&-65536|0)==1836253184&0==0)):0)?($x(H,d,2,c[q>>2]|0,147,1),J=a[H+8+3>>0]|0,J=((J<<24>>24<0?c[H+4>>2]|0:J&255)|0)==0,z5(H),J):0)lL(d,2,c[q>>2]|0,147,x,10,1);jL(d,2,c[q>>2]|0,135,m,n,1);H=E;H=z0(c[H>>2]|0,c[H+4>>2]|0,8,0)|0;E=z;J=F;F=c[J+4>>2]|0;if(E>>>0<F>>>0|((E|0)==(F|0)?H>>>0<(c[J>>2]|0)>>>0:0))o7(d);a1(G)}}l=I;return}function Ec(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;W=l;l=l+16|0;f=W+3|0;K=W+2|0;M=W+1|0;N=W;P=e+760|0;a:do if(tu(P,f,0)|0)if(!(a[f>>0]|0)){V=e+612|0;h=c[V>>2]|0;S=e+548|0;if((h+3|0)>>>0<=(c[S>>2]|0)>>>0){U=e+544|0;if((((c[e+728>>2]&1|0)==0?(g=c[U>>2]|0,(a[g+h>>0]|0)==70):0)?(a[g+(h+1)>>0]|0)==76:0)?(a[g+(h+2)>>0]|0)==86:0){w5(c[P>>2]|0);f=0;break}C=e+312|0;D=e+1124|0;E=e+492|0;F=e+48|0;G=e+40|0;B=e+784|0;f=0;g=h;b:while(1){e=g;h=g;c:while(1){g=c[S>>2]|0;if((e+4|0)>>>0>g>>>0){f=h;break b}else n=g;while(1){if((e+4|0)>>>0>n>>>0)continue c;m=c[U>>2]|0;if(((a[m+e>>0]|0)==-1?(Q=a[m+(e+1)>>0]|0,(Q&255)>223):0)?(A=d[m+(e+2)>>0]|0,!((A&240|0)==240|(A&12|0)==12)):0)break;if(!(tu(P,K,0)|0)){f=0;T=24;break b}if(a[K>>0]|0){f=1;T=24;break b}A=C;g=c[V>>2]|0;h=g+1|0;if((((((c[A>>2]|0)==0&(c[A+4>>2]|0)==0?(R=c[U>>2]|0,(a[R+g>>0]|0)==0):0)?(a[R+h>>0]|0)==0:0)?(a[R+(g+2)>>0]|0)==1:0)?(a[R+(g+3)>>0]|0)==-70:0)?(A=(c[D>>2]|0)+1|0,c[D>>2]=A,A>>>0>1):0){T=23;break b}c[V>>2]=h;e=h;n=c[S>>2]|0}j=((D9(Q)|0)&255)>>>3&3;k=m+h|0;A=D9(a[k+2>>0]|0)|0;g=(A&255)>>>4;e=A&2;A=b[61002+(j<<3)+(((A&255)>>>2&3)<<1)>>1]|0;i=A&65535;if((A<<16>>16?(H=((D9(a[k+1>>0]|0)|0)&255)>>>1&3,A=a[372685+(j<<2)+H>>0]|0,I=A&255,A<<24>>24):0)?(J=b[60490+(j<<7)+(H<<5)+((g&255)<<1)>>1]|0,!((H|0)==0|J<<16>>16==0)):0){g=O((((O(I*1e3|0,J&65535)|0)>>>0)/(i>>>0)|0)+(e>>>1)|0,d[372701+H>>0]|0)|0;if((a[E>>0]|0)!=0&(g+h|0)==(n|0)){e=h;f=h;break b}x=F;A=c[x>>2]|0;x=c[x+4>>2]|0;w=z0(g|0,0,h|0,0)|0;x=z0(w|0,z|0,A|0,x|0)|0;A=z;w=G;y=B;y=D_(c[w>>2]|0,c[w+4>>2]|0,c[y>>2]|0,c[y+4>>2]|0)|0;if((x|0)==(y|0)&(A|0)==(z|0)){e=h;f=h;break b}while(1){e=g+h|0;if((e+4|0)>>>0>n>>>0){f=0;break a}if(a[m+e>>0]|0)break;g=g+1|0}if(!(tu(P,K,g)|0)){f=0;T=86;break b}if(a[K>>0]|0){f=1;T=86;break b}p=F;o=c[p>>2]|0;p=c[p+4>>2]|0;s=c[V>>2]|0;y=z0(o|0,p|0,g|0,0)|0;y=z0(y|0,z|0,s|0,0)|0;A=z;r=G;q=B;q=D_(c[r>>2]|0,c[r+4>>2]|0,c[q>>2]|0,c[q+4>>2]|0)|0;r=z;if((y|0)==(q|0)&(A|0)==(r|0)){T=85;break b}t=c[U>>2]|0;h=t+s+g|0;e=a[h+1>>0]|0;d:do if(((d7(a[h>>0]|0,e)|0)&65535)>=65504?(L=D9(a[h+2>>0]|0)|0,!((L&255)>239|(L&12)==12)):0){e=(D9(e)|0)&255;h=e>>>3&3;i=(L&255)>>>4;m=L&2;A=b[61002+(h<<3)+(((L&255)>>>2&3)<<1)>>1]|0;n=A&65535;do if(A<<16>>16){j=e>>>1&3;k=a[372685+(h<<2)+j>>0]|0;if(!(k<<24>>24))break;e=b[60490+(h<<7)+(j<<5)+((i&255)<<1)>>1]|0;if((j|0)==0|e<<16>>16==0)break;A=O((((O((k&255)*1e3|0,e&65535)|0)>>>0)/(n>>>0)|0)+(m>>>1)|0,d[372701+j>>0]|0)|0;if(a[E>>0]|0?(s+g+A|0)==(c[S>>2]|0):0){T=85;break b}y=z0(s|0,0,g|0,0)|0;y=z0(y|0,z|0,A|0,0)|0;y=z0(y|0,z|0,o|0,p|0)|0;if((y|0)==(q|0)&(z|0)==(r|0)){T=85;break b}h=A+s|0;i=c[S>>2]|0;while(1){e=h+g|0;if((e+4|0)>>>0>i>>>0){f=0;T=86;break b}if(a[t+e>>0]|0)break;g=g+1|0}o=g+A|0;if(!(tu(P,M,o)|0)){f=0;T=88;break b}if(a[M>>0]|0){f=1;T=88;break b}q=F;p=c[q>>2]|0;q=c[q+4>>2]|0;y=c[V>>2]|0;r=z0(g|0,0,A|0,0)|0;s=z;n=z0(p|0,q|0,r|0,s|0)|0;n=z0(n|0,z|0,y|0,0)|0;x=z;w=G;v=c[w>>2]|0;w=c[w+4>>2]|0;t=B;t=D_(v|0,w|0,c[t>>2]|0,c[t+4>>2]|0)|0;u=z;if((n|0)==(t|0)&(x|0)==(u|0)){T=87;break b}x=c[U>>2]|0;e=x+y+g+A|0;h=a[e+1>>0]|0;e:do if(((d7(a[e>>0]|0,h)|0)&65535)<65504)T=63;else{e=D9(a[e+2>>0]|0)|0;if((e&255)>239|(e&12)==12){T=63;break}h=(D9(h)|0)&255;j=h>>>3&3;k=(e&255)>>>4;n=e&2;i=b[61002+(j<<3)+(((e&255)>>>2&3)<<1)>>1]|0;m=i&65535;do if(i<<16>>16){h=h>>>1&3;i=a[372685+(j<<2)+h>>0]|0;if(!(i<<24>>24))break;e=b[60490+(j<<7)+(h<<5)+((k&255)<<1)>>1]|0;if((h|0)==0|e<<16>>16==0)break;n=O((((O((i&255)*1e3|0,e&65535)|0)>>>0)/(m>>>0)|0)+(n>>>1)|0,d[372701+h>>0]|0)|0;m=(a[E>>0]|0)!=0;if(m?(y+o+n|0)==(c[S>>2]|0):0){T=87;break b}j=z0(p|0,q|0,y|0,0)|0;k=z;s=z0(n|0,0,r|0,s|0)|0;s=z0(s|0,z|0,j|0,k|0)|0;if((s|0)==(t|0)&(z|0)==(u|0)){T=87;break b}h=y+A+n|0;i=c[S>>2]|0;while(1){e=h+g|0;if((e+4|0)>>>0>i>>>0){T=75;break c}if(a[x+e>>0]|0)break;g=g+1|0}e=z0(n|0,0,A|0,0)|0;h=z;if(!(tu(P,N,n+A+g|0)|0)){g=1;f=0;T=81;break c}if(a[N>>0]|0){g=1;f=1;T=81;break c}w=F;y=c[w>>2]|0;w=c[w+4>>2]|0;i=c[V>>2]|0;v=z0(g|0,0,e|0,h|0)|0;w=z0(v|0,z|0,y|0,w|0)|0;w=z0(w|0,z|0,i|0,0)|0;y=z;v=G;x=B;x=D_(c[v>>2]|0,c[v+4>>2]|0,c[x>>2]|0,c[x+4>>2]|0)|0;if((w|0)==(x|0)&(y|0)==(z|0)){g=3;T=81;break c}g=(c[U>>2]|0)+i+g+A+n|0;if(((d7(a[g>>0]|0,a[g+1>>0]|0)|0)&65535)>=65504?(A=D9(a[g+2>>0]|0)|0,!((A&255)>239|(A&12)==12)):0){g=3;T=81;break c}g=i+1|0;c[V>>2]=g;break e}while(0);g=y+1|0;c[V>>2]=g}while(0);if((T|0)==63){T=0;g=y+1|0;c[V>>2]=g}break d}while(0);g=s+1|0;c[V>>2]=g}else T=40;while(0);if((T|0)==40){T=0;e=s+g|0;g=s+3|0;f:while(1){if((g+4|0)>>>0>=e>>>0)break;h=g+1|0;switch(a[t+g>>0]|0){case 0:{g=h;break}case 86:{T=43;break f}default:break f}}do if((T|0)==43){T=0;if((a[t+h>>0]|0)!=66)break;if((a[t+(g+2)>>0]|0)!=82)break;if((a[t+(g+3)>>0]|0)==73){T=85;break b}}while(0);g=s+1|0;c[V>>2]=g}e=g;h=g;continue}h=h+1|0;c[V>>2]=h;e=h}if((T|0)==75){T=0;e=z0(n|0,0,A|0,0)|0;e=z0(j|0,k|0,e|0,z|0)|0;e=z0(e|0,z|0,g|0,0)|0;A=z;e=A>>>0<w>>>0|(A|0)==(w|0)&e>>>0<v>>>0;if(m){T=87;break}else{g=e?3:1;f=f&e}}else if((T|0)==81)T=0;switch(g|0){case 3:{T=92;break b}case 0:break;default:break a}g=c[V>>2]|0}if((T|0)==23){w5(c[P>>2]|0);f=0;T=24}else if((T|0)==85){e=s;f=s}else if((T|0)==86)break;else if((T|0)==87){e=y;f=y}else if((T|0)==88)break;else if((T|0)==92){f=c[V>>2]|0;e=f}if((T|0)==24)break;h=c[S>>2]|0;if((e+4|0)>>>0>h>>>0){if((e+3|0)==(h|0)){T=(c[U>>2]|0)+e|0;g=f+1|0;if(((d7(a[T>>0]|0,a[T+1>>0]|0)|0)&65535)<65504){c[V>>2]=g;e=g;f=g}else e=f}if((e+2|0)==(h|0)){T=(c[U>>2]|0)+e|0;g=f+1|0;if(((d7(a[T>>0]|0,a[T+1>>0]|0)|0)&65535)<65504){c[V>>2]=g;e=g;f=g}else e=f}if((e+1|0)==(h|0)?(D9(a[(c[U>>2]|0)+e>>0]|0)|0)<<24>>24!=0:0){c[V>>2]=f+1;f=0}else f=0}else f=1}else f=0}else f=1;else f=0;while(0);l=W;return f|0}function Fc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;Z=l;l=l+64|0;T=Z+48|0;U=Z+36|0;V=Z+24|0;W=Z+12|0;X=Z;c[T>>2]=d;j=b+16|0;k=e+4|0;m=U+8+3|0;n=U+4|0;o=e+12|0;p=U+8+3|0;q=U+4|0;r=e+48|0;s=b+136|0;t=W+8+3|0;u=W+4|0;v=e+28|0;w=V+8+3|0;x=V+4|0;y=W+8+3|0;A=W+4|0;B=W+8+3|0;C=W+4|0;D=W+8+3|0;E=W+4|0;F=W+8+3|0;G=W+4|0;H=W+8+3|0;I=W+4|0;J=V+8+3|0;K=V+4|0;L=V+8+3|0;M=V+4|0;N=b+492|0;O=W+8+3|0;P=W+4|0;Q=V+8+3|0;R=V+4|0;i=(RA(b,c[j>>2]|0,-1)|0)-g|0;while(1){if(i>>>0>=(RA(b,c[j>>2]|0,-1)|0)>>>0)break;h=c[j>>2]|0;c[e>>2]=h;c[k>>2]=(RA(b,h,-1)|0)-g;switch(f|0){case 0:{TX(U);d=c[T>>2]|0;Gk(U,d,10)|0;XA(V,T);$x(W,b,c[j>>2]|0,i,10,1);h=a[t>>0]|0;h=((h<<24>>24<0?c[u>>2]|0:h&255)|0)==0;z5(W);if(!h){lL(b,c[j>>2]|0,i,10,d,10,0);XA(W,T);zb(b,c[j>>2]|0,i,11,W,1);z5(W)}zb(b,c[j>>2]|0,i,10,U,1);zb(b,c[j>>2]|0,i,11,V,1);z5(V);z5(U);break}case 1:{Xy(U,27632);d=c[T>>2]|0;h=(d|0)==0;if(!h){sU(W,d,10);DW(W,0,42040)|0;c[V>>2]=c[W>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];d=0;while(1){if((d|0)==3)break;c[W+(d<<2)>>2]=0;d=d+1|0}d=a[L>>0]|0;_=d<<24>>24<0;Ex(U,_?c[V>>2]|0:V,_?c[M>>2]|0:d&255)|0;O0(V);z5(W)}$x(V,c[c[v>>2]>>2]|0,c[j>>2]|0,i,10,1);_=a[w>>0]|0;_=((_<<24>>24<0?c[x>>2]|0:_&255)|0)==0;z5(V);if(!_){$x(W,c[c[v>>2]>>2]|0,c[j>>2]|0,i,10,1);DW(W,0,42040)|0;c[V>>2]=c[W>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];d=0;while(1){if((d|0)==3)break;c[W+(d<<2)>>2]=0;d=d+1|0}_=a[J>>0]|0;d=_<<24>>24<0;Ex(U,d?c[V>>2]|0:V,d?c[K>>2]|0:_&255)|0;O0(V);z5(W)}zb(b,c[j>>2]|0,i,10,U,1);Xy(V,27648);if(!h){XA(X,T);DW(X,0,42040)|0;c[W>>2]=c[X>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];d=0;while(1){if((d|0)==3)break;c[X+(d<<2)>>2]=0;d=d+1|0}_=a[H>>0]|0;d=_<<24>>24<0;Ex(V,d?c[W>>2]|0:W,d?c[I>>2]|0:_&255)|0;O0(W);z5(X)}$x(W,c[c[v>>2]>>2]|0,c[j>>2]|0,i,11,1);_=a[y>>0]|0;_=((_<<24>>24<0?c[A>>2]|0:_&255)|0)==0;z5(W);if(_){$x(W,c[c[v>>2]>>2]|0,c[j>>2]|0,i,10,1);_=a[B>>0]|0;_=((_<<24>>24<0?c[C>>2]|0:_&255)|0)==0;z5(W);if(!_){$x(X,c[c[v>>2]>>2]|0,c[j>>2]|0,i,10,1);DW(X,0,42040)|0;c[W>>2]=c[X>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];d=0;while(1){if((d|0)==3)break;c[X+(d<<2)>>2]=0;d=d+1|0}_=a[D>>0]|0;d=_<<24>>24<0;Ex(V,d?c[W>>2]|0:W,d?c[E>>2]|0:_&255)|0;O0(W);z5(X)}}else{$x(X,c[c[v>>2]>>2]|0,c[j>>2]|0,i,11,1);DW(X,0,42040)|0;c[W>>2]=c[X>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];d=0;while(1){if((d|0)==3)break;c[X+(d<<2)>>2]=0;d=d+1|0}_=a[F>>0]|0;d=_<<24>>24<0;Ex(V,d?c[W>>2]|0:W,d?c[G>>2]|0:_&255)|0;O0(W);z5(X)}zb(b,c[j>>2]|0,i,11,V,1);if(!h)xM(b,c[j>>2]|0,i,382758,378175,1);z5(V);z5(U);break}case 2:{if(!(a[N>>0]|0)){Xy(U,27692);d=c[T>>2]|0;h=(d|0)==0;if(!h){sU(W,d,10);DW(W,0,42040)|0;c[V>>2]=c[W>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];d=0;while(1){if((d|0)==3)break;c[W+(d<<2)>>2]=0;d=d+1|0}_=a[Q>>0]|0;d=_<<24>>24<0;Ex(U,d?c[V>>2]|0:V,d?c[R>>2]|0:_&255)|0;O0(V);z5(W);zb(b,c[j>>2]|0,i,10,U,1);Xy(V,27708);if(!h){XA(X,T);DW(X,0,42040)|0;c[W>>2]=c[X>>2];c[W+4>>2]=c[X+4>>2];c[W+8>>2]=c[X+8>>2];d=0;while(1){if((d|0)==3)break;c[X+(d<<2)>>2]=0;d=d+1|0}_=a[O>>0]|0;h=_<<24>>24<0;Ex(V,h?c[W>>2]|0:W,h?c[P>>2]|0:_&255)|0;O0(W);z5(X)}}else{zb(b,c[j>>2]|0,i,10,U,1);Xy(V,27708)}zb(b,c[j>>2]|0,i,11,V,1);z5(V);z5(U)}break}default:{}}_=c[j>>2]|0;$x(U,b,_,i,Rb(_,0)|0,1);_=a[m>>0]|0;if(!((_<<24>>24<0?c[n>>2]|0:_&255)|0)){_=(a[o>>0]|0)==0;z5(U);if(!_){h=c[j>>2]|0;_=Rb(h,0)|0;RB(b,h,i,_,rh(a[o>>0]|0,0)|0,-1,1,0)}}else z5(U);_=c[j>>2]|0;$x(U,b,_,i,Rb(_,17)|0,1);_=a[p>>0]|0;if(!((_<<24>>24<0?c[q>>2]|0:_&255)|0)){_=(a[o>>0]|0)==0;z5(U);if(!_){h=c[j>>2]|0;_=Rb(h,17)|0;RB(b,h,i,_,fi(a[o>>0]|0,0)|0,-1,1,0)}}else z5(U);_=r;if(!((c[_>>2]|0)==-1?(c[_+4>>2]|0)==-1:0)){h=c[j>>2]|0;d=Rb(h,74)|0;$x(U,b,h,i,Rb(h,63)|0,1);zb(b,h,i,d,U,1);z5(U);d=c[j>>2]|0;Ed(b,d,i,Rb(d,63)|0);d=c[j>>2]|0;h=Rb(d,83)|0;$x(U,b,d,i,Rb(d,72)|0,1);zb(b,d,i,h,U,1);z5(U);h=c[j>>2]|0;Ed(b,h,i,Rb(h,72)|0);h=c[j>>2]|0;d=Rb(h,81)|0;$x(U,b,h,i,Rb(h,70)|0,1);zb(b,h,i,d,U,1);z5(U);d=c[j>>2]|0;Ed(b,d,i,Rb(d,70)|0);d=c[j>>2]|0;h=Rb(d,63)|0;_=r;KW(b,d,i,h,(+((c[_>>2]|0)>>>0)+4294967296.0*+((c[_+4>>2]|0)>>>0))/90.0,3,1);_=c[j>>2]|0;RB(b,_,i,Rb(_,72)|0,380001,-1,1,0)}_=s;if(!((c[_>>2]|0)==-1?(c[_+4>>2]|0)==-1:0)?(S=c[j>>2]|0,(S+-1|0)>>>0<2):0){gq(U,b,S,i,384534);d=rm(U)|0;h=z;z5(U);if((d|0)==0&(h|0)==0){gq(U,b,c[j>>2]|0,i,378202);d=rm(U)|0;h=z;z5(U);if((d|0)==0&(h|0)==0){d=-1;h=-1}else Y=62}else Y=62;if((Y|0)==62){Y=0;_=s;d=z0(c[_>>2]|0,c[_+4>>2]|0,d|0,h|0)|0;h=z}_=s;c[_>>2]=d;c[_+4>>2]=h}i=i+1|0}l=Z;return}function Gc(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0;ba=l;l=l+64|0;m=ba+36|0;Y=ba+56|0;v=ba+52|0;H=ba+50|0;R=ba+48|0;Z=ba+55|0;_=ba+54|0;$=ba+24|0;aa=ba+12|0;n=ba;TX(m);o=d+528|0;q=o;q=z0(c[q>>2]|0,c[q+4>>2]|0,1,0)|0;p=o;c[p>>2]=q;c[p+4>>2]=z;bB(d,Y);wK(d);p=d+770|0;q=d+789|0;r=d+782|0;s=d+24|0;t=d+778|0;u=d+764|0;w=aa+11|0;x=aa+11|0;y=n+11|0;A=n+8|0;B=n+4|0;C=aa+8|0;D=aa+4|0;E=aa+8|0;F=aa+4|0;G=aa+11|0;I=n+11|0;J=aa+8|0;K=aa+4|0;L=aa+8+3|0;M=aa+4|0;N=aa+11|0;O=aa+11|0;P=n+11|0;Q=n+8|0;S=n+4|0;T=aa+8|0;U=aa+4|0;V=aa+8|0;W=aa+4|0;X=d+794|0;Y=a[Y>>0]|0;k=d+648|0;j=0;while(1){if((j&255)>=(Y&255)){i=64;break}GC(d);h=(a[q>>0]|0)==-38;WY(d,h?16:14,h?0:0,m);Bx(d);d4(c[k>>2]|0,4);sR(d,10,v);sR(d,10,H);if((a[q>>0]|0)==-38){xR(d,6,_);d4(c[k>>2]|0,32);d4(c[k>>2]|0,32);d4(c[k>>2]|0,2);wK(d);e=3;f=0}else{wK(d);bB(d,_);e=6;f=0}h=o;h=z0(c[h>>2]|0,c[h+4>>2]|0,e|0,f|0)|0;e=o;c[e>>2]=h;c[e+4>>2]=z;NB(d,r);Bx(d);d4(c[k>>2]|0,2);A6(c[k>>2]|0);A6(c[k>>2]|0);e=c[k>>2]|0;if((a[q>>0]|0)==-56){A6(e);A6(c[k>>2]|0)}else d4(e,2);A6(c[k>>2]|0);d4(c[k>>2]|0,3);xR(d,6,Z);wK(d);NB(d,R);if((a[q>>0]|0)==-38){g=o;g=z0(c[g>>2]|0,c[g+4>>2]|0,1,0)|0;h=o;c[h>>2]=g;c[h+4>>2]=z}Bx(d);d4(c[k>>2]|0,6);sR(d,10,p);wK(d);if(qO(d)|0){if(!(dQ(c[s>>2]|0)|0))b[t>>1]=b[c[u>>2]>>1]|0;rU($,b[v>>1]|0,10);e=b[H>>1]|0;if(e<<16>>16){rU(n,e,10);DW(n,0,42040)|0;c[aa>>2]=c[n>>2];c[aa+4>>2]=c[n+4>>2];c[aa+8>>2]=c[n+8>>2];e=0;while(1){if((e|0)==3)break;c[n+(e<<2)>>2]=0;e=e+1|0}e=a[L>>0]|0;h=e<<24>>24<0;Ex($,h?c[aa>>2]|0:aa,h?c[M>>2]|0:e&255)|0;O0(aa);z5(n);e=b[r>>1]|0;if(e<<16>>16!=-1){if((e&65535)<8192){f=$C((HD((c[u>>2]|0)+68|0,t)|0)+16|0,r)|0;c[aa>>2]=0;c[aa+4>>2]=0;c[aa+8>>2]=0;g=j9(391021)|0;if(g>>>0>4294967279){i=37;break}if(g>>>0<11){a[N>>0]=g;e=aa}else{i=g+16&-16;e=ZW(i)|0;c[aa>>2]=e;c[V>>2]=i|-2147483648;c[W>>2]=g}i1(e,391021,g)|0;J7(e+g|0,0);k1(VC(f+4|0,aa)|0,m)|0;a1(aa);f=$C((HD((c[u>>2]|0)+68|0,t)|0)+16|0,r)|0;c[aa>>2]=0;c[aa+4>>2]=0;c[aa+8>>2]=0;g=j9(391033)|0;if(g>>>0>4294967279){i=42;break}if(g>>>0<11){a[O>>0]=g;e=aa}else{i=g+16&-16;e=ZW(i)|0;c[aa>>2]=e;c[T>>2]=i|-2147483648;c[U>>2]=g}i1(e,391033,g)|0;J7(e+g|0,0);k1(VC(f+4|0,aa)|0,$)|0;a1(aa);VU(aa,MS(a[Z>>0]|0)|0);f=$C((HD((c[u>>2]|0)+68|0,t)|0)+16|0,r)|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;g=j9(391048)|0;if(g>>>0>4294967279){i=47;break}if(g>>>0<11){a[P>>0]=g;e=n}else{i=g+16&-16;e=ZW(i)|0;c[n>>2]=e;c[Q>>2]=i|-2147483648;c[S>>2]=g}i1(e,391048,g)|0;J7(e+g|0,0);vF(VC(f+4|0,n)|0,aa)|0;a1(n);z5(aa);e=b[R>>1]|0;b[($C((HD((c[u>>2]|0)+68|0,t)|0)+16|0,r)|0)+76>>1]=e;e=($C((HD((c[u>>2]|0)+68|0,t)|0)+16|0,r)|0)+78|0;i=52}}else i=19}else i=19;if((i|0)==19){f=HD((c[u>>2]|0)+68|0,t)|0;c[aa>>2]=0;c[aa+4>>2]=0;c[aa+8>>2]=0;g=j9(391021)|0;if(g>>>0>4294967279){i=20;break}if(g>>>0<11){a[w>>0]=g;e=aa}else{i=g+16&-16;e=ZW(i)|0;c[aa>>2]=e;c[E>>2]=i|-2147483648;c[F>>2]=g}i1(e,391021,g)|0;J7(e+g|0,0);k1(VC(f+4|0,aa)|0,m)|0;a1(aa);f=HD((c[u>>2]|0)+68|0,t)|0;c[aa>>2]=0;c[aa+4>>2]=0;c[aa+8>>2]=0;g=j9(391033)|0;if(g>>>0>4294967279){i=25;break}if(g>>>0<11){a[x>>0]=g;e=aa}else{i=g+16&-16;e=ZW(i)|0;c[aa>>2]=e;c[C>>2]=i|-2147483648;c[D>>2]=g}i1(e,391033,g)|0;J7(e+g|0,0);k1(VC(f+4|0,aa)|0,$)|0;a1(aa);VU(aa,MS(a[Z>>0]|0)|0);f=HD((c[u>>2]|0)+68|0,t)|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;g=j9(391048)|0;if(g>>>0>4294967279){i=30;break}if(g>>>0<11){a[y>>0]=g;e=n}else{i=g+16&-16;e=ZW(i)|0;c[n>>2]=e;c[A>>2]=i|-2147483648;c[B>>2]=g}i1(e,391048,g)|0;J7(e+g|0,0);vF(VC(f+4|0,n)|0,aa)|0;a1(n);z5(aa);e=b[R>>1]|0;b[(HD((c[u>>2]|0)+68|0,t)|0)+56>>1]=e;e=(HD((c[u>>2]|0)+68|0,t)|0)+58|0;i=52}if((i|0)==52){i=0;a[e>>0]=1}f=a[_>>0]|0;if(f<<24>>24){g=$C((HD((c[u>>2]|0)+68|0,t)|0)+16|0,r)|0;c[aa>>2]=0;c[aa+4>>2]=0;c[aa+8>>2]=0;h=j9(391060)|0;if(h>>>0>4294967279){i=55;break}if(h>>>0<11){a[G>>0]=h;e=aa}else{ca=h+16&-16;e=ZW(ca)|0;c[aa>>2]=e;c[J>>2]=ca|-2147483648;c[K>>2]=h}i1(e,391060,h)|0;J7(e+h|0,0);ca=VC(g+4|0,aa)|0;Vi(n,f);bj(ca,(a[I>>0]|0)<0?c[n>>2]|0:n)|0;a1(n);a1(aa)}z5($)}a[X>>0]=1;if(b[p>>1]|0)Ao(d);J3(d);j=j+1<<24>>24}if((i|0)==20)uaa();else if((i|0)==25)uaa();else if((i|0)==30)uaa();else if((i|0)==37)uaa();else if((i|0)==42)uaa();else if((i|0)==47)uaa();else if((i|0)==55)uaa();else if((i|0)==64){Bx(d);d4(c[k>>2]|0,6);sR(d,10,p);wK(d);if(b[p>>1]|0)Ao(d);z5(m);l=ba;return}}function Hc(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0.0;aa=l;l=l+32|0;r=aa+12|0;F=aa;$=d+760|0;V=d+764|0;W=d+788|0;X=d+792|0;Y=r+4|0;Z=r+8|0;s=F+8+3|0;t=F+4|0;A=F+8+3|0;C=F+4|0;D=F+8+3|0;E=F+4|0;G=F+8+3|0;H=F+4|0;I=d+800|0;J=d+808+3|0;K=d+804|0;L=d+16|0;M=d+20|0;N=r+8+3|0;P=r+4|0;R=F+8+3|0;S=F+4|0;T=d+776|0;U=d+780|0;e=c[$>>2]|0;a:while(1){if((e|0)==(V|0))break;h=e+68|0;p=e+36|0;q=e+40|0;f=c[e+64>>2]|0;b:while(1){if((f|0)==(h|0)){f=0;break}g=f+16|0;if((a[g+11>>0]|0)<0)g=c[g>>2]|0;Mc(d,c[p>>2]|0,c[q>>2]|0,g,f+28|0,1);g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue b}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}while(1){o=c[W>>2]|0;g=o;if(f>>>0>=(c[X>>2]|0)-o>>4>>>0)break;switch(b[g+(f<<4)>>1]|0){case 1:{if((c[p>>2]|0)==1){h=1;_=17}break}case 2:{if((c[p>>2]|0)==2){h=2;_=17}break}default:{}}if((_|0)==17){_=0;Mc(d,h,c[q>>2]|0,379963,g+(f<<4)+4|0,1);Mc(d,c[p>>2]|0,c[q>>2]|0,379983,(c[W>>2]|0)+(f<<4)+4|0,1)}f=f+1|0}o=e+24|0;if((c[p>>2]|0)==1){x1(r);i=e+84|0;h=-1;f=c[e+80>>2]|0;c:while(1){if((f|0)==(i|0))break;g=f+16|0;if((h|0)!=-1){c[F>>2]=(c[g>>2]|0)-h;n=bI(r,F)|0;c[n>>2]=(c[n>>2]|0)+1}h=c[g>>2]|0;g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue c}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}j=0;f=c[r>>2]|0;d:while(1){g=f;while(1){if((g|0)==(Y|0))break d;h=c[g+20>>2]|0;f=c[g+4>>2]|0;i=(f|0)==0;if(h>>>0>=3)break;if(i){h=g;while(1){f=c[h+8>>2]|0;if((c[f>>2]|0)==(h|0))break;else h=f}}else while(1){h=c[f>>2]|0;if(!h)break;else f=h}oB(r,g);g=f}h=h+j|0;if(i)while(1){f=c[g+8>>2]|0;if((c[f>>2]|0)==(g|0)){j=h;continue d}else g=f}while(1){g=c[f>>2]|0;if(!g)break;else f=g}j=h}f=c[Z>>2]|0;n=e+48|0;do if((((f|0)!=0?(u=(f|0)==1,!(j>>>0<16&u)):0)?(v=(f|0)==2,!(j>>>0<32&v)):0)?(w=c[r>>2]|0,x=c[w+16>>2]|0,(x|0)!=1):0){k=+(x>>>0);if(u){KW(d,1,c[q>>2]|0,171,1.0e3/k,3,1);h=n;g=c[h>>2]|0;h=c[h+4>>2]|0;if((g|0)==0&(h|0)==0)break;i=c[q>>2]|0;f=c[o>>2]|0;if(!f){Bt(d,1,i,177,1.0e7/(+(g>>>0)+4294967296.0*+(h>>>0)),3,1);break}$x(F,f,1,0,197,1);f=i9(38184)|0;j=a[A>>0]|0;if((f|0)==((j<<24>>24<0?c[C>>2]|0:j&255)|0)){j=(VG(F,38184,f)|0)==0;j=UW((j?2:1)|0,(j?0:0)|0,g|0,h|0)|0;Bt(d,1,i,177,1.0e7/(+(j>>>0)+4294967296.0*+(z>>>0)),3,1)}else Bt(d,1,i,177,1.0e7/(+(g>>>0)+4294967296.0*+(h>>>0)),3,1);z5(F);break}if(!v){RB(d,1,c[q>>2]|0,167,380821,-1,1,0);h=n;g=c[h>>2]|0;h=c[h+4>>2]|0;if((g|0)==0&(h|0)==0)break;i=c[q>>2]|0;f=c[o>>2]|0;if(!f){Bt(d,1,i,177,1.0e7/(+(g>>>0)+4294967296.0*+(h>>>0)),3,1);break}$x(F,f,1,0,197,1);f=i9(38184)|0;j=a[G>>0]|0;if((f|0)==((j<<24>>24<0?c[H>>2]|0:j&255)|0)){j=(VG(F,38184,f)|0)==0;j=UW((j?2:1)|0,(j?0:0)|0,g|0,h|0)|0;Bt(d,1,i,177,1.0e7/(+(j>>>0)+4294967296.0*+(z>>>0)),3,1)}else Bt(d,1,i,177,1.0e7/(+(g>>>0)+4294967296.0*+(h>>>0)),3,1);z5(F);break}m=+((c[w+20>>2]|0)>>>0);f=c[w+4>>2]|0;if(!f){g=w;while(1){f=c[g+8>>2]|0;if((c[f>>2]|0)==(g|0))break;else g=f}}else while(1){g=c[f>>2]|0;if(!g)break;else f=g}ba=+((c[f+20>>2]|0)>>>0);KW(d,c[p>>2]|0,c[q>>2]|0,171,1.0e3/((k*m+ +((c[f+16>>2]|0)>>>0)*ba)/(m+ba)),3,1);h=n;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!((g|0)==0&(h|0)==0)){i=c[q>>2]|0;f=c[o>>2]|0;if(!f){Bt(d,1,i,177,1.0e7/(+(g>>>0)+4294967296.0*+(h>>>0)),3,1);break}$x(F,f,1,0,197,1);f=i9(38184)|0;j=a[D>>0]|0;if((f|0)==((j<<24>>24<0?c[E>>2]|0:j&255)|0)){j=(VG(F,38184,f)|0)==0;j=UW((j?2:1)|0,(j?0:0)|0,g|0,h|0)|0;Bt(d,1,i,177,1.0e7/(+(j>>>0)+4294967296.0*+(z>>>0)),3,1)}else Bt(d,1,i,177,1.0e7/(+(g>>>0)+4294967296.0*+(h>>>0)),3,1);z5(F)}}else _=44;while(0);do if((_|0)==44?(_=0,B=n,y=c[B>>2]|0,B=c[B+4>>2]|0,!((y|0)==0&(B|0)==0)):0){g=c[q>>2]|0;f=c[o>>2]|0;if(!f){Bt(d,1,g,171,1.0e7/(+(y>>>0)+4294967296.0*+(B>>>0)),3,1);break}$x(F,f,1,0,197,1);f=i9(38184)|0;n=a[s>>0]|0;if((f|0)==((n<<24>>24<0?c[t>>2]|0:n&255)|0)){n=(VG(F,38184,f)|0)==0;n=UW((n?2:1)|0,(n?0:0)|0,y|0,B|0)|0;Bt(d,1,g,171,1.0e7/(+(n>>>0)+4294967296.0*+(z>>>0)),3,1)}else Bt(d,1,g,171,1.0e7/(+(y>>>0)+4294967296.0*+(B>>>0)),3,1);z5(F)}while(0);y_(r)}f=c[e+56>>2]|0;if(f|0)fM(d,c[p>>2]|0,c[q>>2]|0,384534,f,1);f=b[e+60>>1]|0;if(f<<16>>16!=-1?(O=f&65535,Q=c[T>>2]|0,O>>>0<((((c[U>>2]|0)-Q|0)/12|0)&65535)>>>0):0)Mc(d,c[p>>2]|0,c[q>>2]|0,384512,Q+(O*12|0)|0,0);else{f=a[J>>0]|0;if(f<<24>>24<0)f=c[K>>2]|0;else f=f&255;if(f|0)Mc(d,c[p>>2]|0,c[q>>2]|0,384512,I,0)}f=c[o>>2]|0;if(f|0){if((c[p>>2]|0)==7?RA(f,2,-1)|0:0){Kc(d,2,-1)|0;c[p>>2]=c[L>>2];c[q>>2]=c[M>>2]}TX(r);if((c[p>>2]|0)==1){$x(F,d,1,c[q>>2]|0,24,1);vF(r,F)|0;z5(F)}G2(d,c[o>>2]|0);f=Vj(c[o>>2]|0,1,0,18,1)|0;g=i9(29964)|0;n=a[f+8+3>>0]|0;if((g|0)==((n<<24>>24<0?c[f+4>>2]|0:n&255)|0)?(VG(f,29964,g)|0)==0:0){Ed(d,1,c[q>>2]|0,130);Ed(d,1,c[q>>2]|0,138);Ed(d,1,c[q>>2]|0,150);Ed(d,1,c[q>>2]|0,156)}g=e+104|0;f=c[g>>2]|0;g=c[g+4>>2]|0;if(!((f|0)==-1&(g|0)==-1)){n=c[p>>2]|0;j=c[q>>2]|0;oK(d,n,j,Rb(n,63)|0,f,g,10,0);n=c[p>>2]|0;j=c[q>>2]|0;RB(d,n,j,Rb(n,72)|0,380001,-1,1,0)}Gb(d,c[o>>2]|0,c[p>>2]|0,0,c[q>>2]|0,1)|0;p=a[N>>0]|0;if((p<<24>>24<0?c[P>>2]|0:p&255)|0){$x(F,d,1,c[q>>2]|0,24,1);f=a[N>>0]|0;g=f<<24>>24<0;h=g?c[r>>2]|0:r;j=a[R>>0]|0;p=j<<24>>24<0;i=p?c[F>>2]|0:F;j=p?c[S>>2]|0:j&255;if(!j)f=0;else{p=h+((g?c[P>>2]|0:f&255)<<2)|0;f=HA(h,p,i,i+(j<<2)|0)|0;f=(f|0)==(p|0)?-1:f-h>>2}z5(F);if(!f)zb(d,1,c[q>>2]|0,24,r,1)}z5(r)}f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue a}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}if((RA(d,1,-1)|0)==0?(RA(d,5,-1)|0)==0:0)RB(d,0,0,69,380011,-1,1,1);e=a[d+36+3>>0]|0;if(e<<24>>24<0)e=c[d+32>>2]|0;else e=e&255;if(e|0)VM($);l=aa;return}function Ic(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+48|0;s=w+24|0;t=w+12|0;k=w;$x(s,b,2,d,18,1);$x(t,b,2,d,52,1);$x(k,b,2,d,e,1);u=pn(k)|0;z5(k);j=po(t,4,2)|0;f=a[j+8+3>>0]|0;g=f<<24>>24<0;h=g?c[j>>2]|0:j;i=i9(28392)|0;a:do if((i|0)!=0?(g=h+((g?c[j+4>>2]|0:f&255)<<2)|0,j=HA(h,g,28392,28392+(i<<2)|0)|0,!((j|0)!=(g|0)&(j|0)==(h|0))):0){$x(k,b,2,d,53,1);f=a[k+8+3>>0]|0;g=f<<24>>24<0;h=g?c[k>>2]|0:k;i=i9(28392)|0;if(!i)f=0;else{j=h+((g?c[k+4>>2]|0:f&255)<<2)|0;f=HA(h,j,28392,28392+(i<<2)|0)|0;f=(f|0)==(j|0)?-1:f-h>>2}z5(k);if(f){f=po(t,1,2)|0;g=a[f+8+3>>0]|0;h=g<<24>>24<0;i=h?c[f>>2]|0:f;j=i9(6696)|0;k=(u+-31e3|0)>>>0<2001;if(j|0?(h=i+((h?c[f+4>>2]|0:g&255)<<2)|0,j=HA(i,h,6696,6696+(j<<2)|0)|0,!((j|0)!=(h|0)&(j|0)==(i|0))):0){f=po(t,1,2)|0;g=a[f+8+3>>0]|0;h=g<<24>>24<0;i=h?c[f>>2]|0:f;j=i9(29616)|0;if(j|0?(h=i+((h?c[f+4>>2]|0:g&255)<<2)|0,j=HA(i,h,29616,29616+(j<<2)|0)|0,!((j|0)!=(h|0)&(j|0)==(i|0))):0){j=t+8+3|0;f=a[j>>0]|0;g=f<<24>>24<0;k=t+4|0;h=g?c[t>>2]|0:t;i=i9(29652)|0;if(((i|0?(g=h+((g?c[k>>2]|0:f&255)<<2)|0,i=HA(h,g,29652,29652+(i<<2)|0)|0,!((i|0)!=(g|0)&(i|0)==(h|0))):0)?(m=po(t,1,2)|0,n=a[m+8+3>>0]|0,o=n<<24>>24<0,p=o?c[m>>2]|0:m,q=i9(29652)|0,q|0):0)?(o=p+((o?c[m+4>>2]|0:n&255)<<2)|0,q=HA(p,o,29652,29652+(q<<2)|0)|0,!((q|0)!=(o|0)&(q|0)==(p|0))):0){f=i9(28648)|0;h=a[j>>0]|0;g=c[k>>2]|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(VG(t,28648,f)|0){h=a[j>>0]|0;g=c[k>>2]|0;v=23}}else v=23;do if((v|0)==23){f=i9(6712)|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)?(VG(t,6712,f)|0)==0:0)break;f=po(t,1,2)|0;g=a[f+8+3>>0]|0;h=g<<24>>24<0;i=h?c[f>>2]|0:f;j=i9(28648)|0;if(j|0){p=i+((h?c[f+4>>2]|0:g&255)<<2)|0;q=HA(i,p,28648,28648+(j<<2)|0)|0;if((q|0)!=(p|0)&(q|0)==(i|0))break;f=po(t,1,2)|0;g=a[f+8+3>>0]|0;h=g<<24>>24<0;i=h?c[f>>2]|0:f;j=i9(29032)|0;do if(j|0){p=i+((h?c[f+4>>2]|0:g&255)<<2)|0;q=HA(i,p,29032,29032+(j<<2)|0)|0;if((q|0)!=(p|0)&(q|0)==(i|0))break;f=po(t,1,2)|0;g=a[f+8+3>>0]|0;h=g<<24>>24<0;i=h?c[f>>2]|0:f;j=i9(6732)|0;if(!j)break;p=i+((h?c[f+4>>2]|0:g&255)<<2)|0;q=HA(i,p,6732,6732+(j<<2)|0)|0;if((q|0)!=(p|0)&(q|0)==(i|0))break;f=po(t,4,2)|0;g=i9(29032)|0;q=a[f+8+3>>0]|0;if((g|0)==((q<<24>>24<0?c[f+4>>2]|0:q&255)|0)?(VG(f,29032,g)|0)==0:0)break;f=po(t,4,2)|0;g=i9(6732)|0;q=a[f+8+3>>0]|0;if((g|0)==((q<<24>>24<0?c[f+4>>2]|0:q&255)|0)?(VG(f,6732,g)|0)==0:0)break;f=i9(29032)|0;q=a[s+8+3>>0]|0;if((f|0)!=((q<<24>>24<0?c[s+4>>2]|0:q&255)|0))break a;if(VG(s,29032,f)|0)break a}while(0);r=(u+-42e3|0)>>>0<4001?44100:u;r=(r+-62720|0)>>>0<2561?64e3:r;r=(r+-86436|0)>>>0<3529?88200:r;r=(r+-125440|0)>>>0<5121?128e3:r;r=(r+-172872|0)>>>0<7057?176400:r;r=(r+-188160|0)>>>0<7681?192e3:r;r=(r+-250880|0)>>>0<10241?256e3:r;r=(r+-345744|0)>>>0<14113?352800:r;r=(r+-376320|0)>>>0<15361?384e3:r;v=39;break a}}while(0);r=(u+-62720|0)>>>0<2561?64e3:u;r=(r+-86436|0)>>>0<3529?88200:r;r=(r+-125440|0)>>>0<5121?128e3:r;r=(r+-172872|0)>>>0<7057?176400:r;r=(r+-188160|0)>>>0<7681?192e3:r;r=(r+-250880|0)>>>0<10241?256e3:r;r=(r+-345744|0)>>>0<14113?352800:r;r=(r+-376320|0)>>>0<15361?384e3:r;r=(r+-501760|0)>>>0<20481?512e3:r;r=(r+-691488|0)>>>0<28225?705600:r;r=(r+-752640|0)>>>0<30721?768e3:r;r=(r+-1003520|0)>>>0<40961?1024e3:r;r=(r+-1128960|0)>>>0<46081?1152e3:r;r=(r+-1382976|0)>>>0<56449?1411200:r;r=(r+-1505280|0)>>>0<61441?1536e3:r;r=(r+-4515840|0)>>>0<184321?4608e3:r;r=(r+-6021120|0)>>>0<245761?6144e3:r;v=39;break}r=(u+-46e3|0)>>>0<4001?48e3:u;r=(r+-64827|0)>>>0<2647?66150:r;r=(r+-70560|0)>>>0<2881?72e3:r;r=(r+-94080|0)>>>0<3841?96e3:r;r=(r+-94080|0)>>>0<3841?96e3:r;r=(r+-129654|0)>>>0<5293?132300:r;r=(r+-141120|0)>>>0<5761?144e3:r;r=(r+-188160|0)>>>0<7681?192e3:r;r=(r+-259308|0)>>>0<10585?264600:r;r=(r+-282240|0)>>>0<11521?288e3:r;r=(r+-345744|0)>>>0<14113?352800:r;r=(r+-376320|0)>>>0<15361?384e3:r;r=(r+-518616|0)>>>0<21169?529200:r;r=(r+-564480|0)>>>0<23041?576e3:r;r=(r+-648270|0)>>>0<26461?661500:r;v=39;break}r=k?32e3:u;r=(r+-54e3|0)>>>0<4001?56e3:r;r=(r+-62720|0)>>>0<2561?64e3:r;r=(r+-94080|0)>>>0<3841?96e3:r;r=(r+-109760|0)>>>0<4481?112e3:r;r=(r+-125440|0)>>>0<5121?128e3:r;r=(r+-188160|0)>>>0<7681?192e3:r;r=(r+-219520|0)>>>0<8961?224e3:r;r=(r+-250880|0)>>>0<10241?256e3:r;r=(r+-313600|0)>>>0<12801?32e4:r;r=(r+-376320|0)>>>0<15361?384e3:r;r=(r+-439040|0)>>>0<17921?448e3:r;r=(r+-501760|0)>>>0<20481?512e3:r;r=(r+-564480|0)>>>0<23041?576e3:r;r=(r+-627200|0)>>>0<25601?64e4:r;r=(r+-752640|0)>>>0<30721?768e3:r;r=(r+-940800|0)>>>0<38401?96e4:r;r=(r+-1003520|0)>>>0<40961?1024e3:r;r=(r+-1128960|0)>>>0<46081?1152e3:r;r=(r+-1254400|0)>>>0<51201?128e4:r;r=(r+-1317120|0)>>>0<53761?1344e3:r;r=(r+-1379840|0)>>>0<56321?1408e3:r;r=(r+-1382976|0)>>>0<56449?1411200:r;r=(r+-1442560|0)>>>0<58881?1472e3:r;r=(r+-1505280|0)>>>0<61441?1536e3:r;r=(r+-1881600|0)>>>0<76801?192e4:r;r=(r+-2007040|0)>>>0<81921?2048e3:r;r=(r+-3010560|0)>>>0<122881?3072e3:r;r=(r+-3763200|0)>>>0<153601?384e4:r;v=39;break}r=k?32e3:u;r=(r+-39e3|0)>>>0<2001?4e4:r;r=(r+-46e3|0)>>>0<4001?48e3:r;r=(r+-54e3|0)>>>0<4001?56e3:r;r=(r+-62720|0)>>>0<2561?64e3:r;r=(r+-78400|0)>>>0<3201?8e4:r;r=(r+-94080|0)>>>0<3841?96e3:r;r=(r+-109760|0)>>>0<4481?112e3:r;r=(r+-125440|0)>>>0<5121?128e3:r;r=(r+-156800|0)>>>0<6401?16e4:r;r=(r+-188160|0)>>>0<7681?192e3:r;r=(r+-219520|0)>>>0<8961?224e3:r;r=(r+-250880|0)>>>0<10241?256e3:r;r=(r+-313600|0)>>>0<12801?32e4:r;r=(r+-376320|0)>>>0<15361?384e3:r;r=(r+-439040|0)>>>0<17921?448e3:r;r=(r+-501760|0)>>>0<20481?512e3:r;r=(r+-564480|0)>>>0<23041?576e3:r;r=(r+-627200|0)>>>0<25601?64e4:r;v=39}else v=6}else v=6;while(0);do if((v|0)==6){f=(u+-7500|0)>>>0<1001?8e3:u;f=(f+-15e3|0)>>>0<2001?16e3:f;f=(f+-23e3|0)>>>0<2001?24e3:f;f=(f+-31e3|0)>>>0<2001?32e3:f;f=(f+-38e3|0)>>>0<4001?4e4:f;f=(f+-46e3|0)>>>0<4001?48e3:f;f=(f+-54e3|0)>>>0<4001?56e3:f;f=(f+-62720|0)>>>0<2561?64e3:f;f=(f+-78400|0)>>>0<3201?8e4:f;f=(f+-94080|0)>>>0<3841?96e3:f;f=(f+-109760|0)>>>0<4481?112e3:f;f=(f+-125440|0)>>>0<5121?128e3:f;f=(f+-156800|0)>>>0<6401?16e4:f;f=(f+-156800|0)>>>0<6401?16e4:f;f=(f+-188160|0)>>>0<7681?192e3:f;f=(f+-219520|0)>>>0<8961?224e3:f;f=(f+-219520|0)>>>0<8961?224e3:f;f=(f+-250880|0)>>>0<10241?256e3:f;f=(f+-282240|0)>>>0<11521?288e3:f;f=(f+-313600|0)>>>0<12801?32e4:f;f=(f+-344960|0)>>>0<14081?352e3:f;f=(f+-376320|0)>>>0<15361?384e3:f;f=(f+-407680|0)>>>0<16641?416e3:f;f=(f+-439040|0)>>>0<17921?448e3:f;gq(k,b,2,d,387802);g=i9(40136)|0;q=a[k+8+3>>0]|0;if((g|0)==((q<<24>>24<0?c[k+4>>2]|0:q&255)|0)){q=(VG(k,40136,g)|0)==0;z5(k);if(q)break;else{r=f;v=39;break}}else{z5(k);r=f;v=39;break}}while(0);if((v|0)==39?(r|0)!=(u|0):0)lL(b,2,d,e,r,0,1);z5(t);z5(s);l=w;return}function Jc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+96|0;f=k+72|0;g=k+60|0;h=k+48|0;d=k+36|0;e=k+24|0;i=k+12|0;j=k;do if(RA(b,0,-1)|0){$x(f,b,0,0,159,1);m=a[f+8+3>>0]|0;do if((m<<24>>24<0?c[f+4>>2]|0:m&255)|0){$x(g,b,0,0,167,1);m=a[g+8+3>>0]|0;if((m<<24>>24<0?c[g+4>>2]|0:m&255)|0){z5(g);z5(f);break}$x(h,b,0,0,183,1);m=a[h+8+3>>0]|0;m=((m<<24>>24<0?c[h+4>>2]|0:m&255)|0)==0;z5(h);z5(g);z5(f);if(m){if(RA(b,1,-1)|0?($x(f,b,0,0,163,1),m=a[f+8+3>>0]|0,m=((m<<24>>24<0?c[f+4>>2]|0:m&255)|0)==0,z5(f),m):0){$x(f,b,0,0,159,1);Mc(b,0,0,357345,f,0);z5(f);break}$x(f,b,0,0,159,1);Mc(b,0,0,375097,f,0);z5(f)}}else z5(f);while(0);$x(f,b,0,0,160,1);m=a[f+8+3>>0]|0;do if((m<<24>>24<0?c[f+4>>2]|0:m&255)|0){$x(g,b,0,0,168,1);m=a[g+8+3>>0]|0;if((m<<24>>24<0?c[g+4>>2]|0:m&255)|0){z5(g);z5(f);break}$x(h,b,0,0,184,1);m=a[h+8+3>>0]|0;m=((m<<24>>24<0?c[h+4>>2]|0:m&255)|0)==0;z5(h);z5(g);z5(f);if(m){if(RA(b,1,-1)|0?($x(f,b,0,0,163,1),m=a[f+8+3>>0]|0,m=((m<<24>>24<0?c[f+4>>2]|0:m&255)|0)==0,z5(f),m):0){$x(f,b,0,0,160,1);Mc(b,0,0,357351,f,0);z5(f);break}$x(f,b,0,0,160,1);Mc(b,0,0,357362,f,0);z5(f)}}else z5(f);while(0);$x(f,b,0,0,161,1);m=a[f+8+3>>0]|0;do if((m<<24>>24<0?c[f+4>>2]|0:m&255)|0){$x(g,b,0,0,170,1);m=a[g+8+3>>0]|0;if((m<<24>>24<0?c[g+4>>2]|0:m&255)|0){z5(g);z5(f);break}$x(h,b,0,0,185,1);m=a[h+8+3>>0]|0;m=((m<<24>>24<0?c[h+4>>2]|0:m&255)|0)==0;z5(h);z5(g);z5(f);if(m){if(RA(b,1,-1)|0?($x(f,b,0,0,163,1),m=a[f+8+3>>0]|0,m=((m<<24>>24<0?c[f+4>>2]|0:m&255)|0)==0,z5(f),m):0){$x(f,b,0,0,161,1);Mc(b,0,0,357373,f,0);z5(f);break}$x(f,b,0,0,161,1);Mc(b,0,0,374811,f,0);z5(f)}}else z5(f);while(0);$x(f,b,0,0,159,1);m=a[f+8+3>>0]|0;if(!((m<<24>>24<0?c[f+4>>2]|0:m&255)|0)){$x(g,b,0,0,167,1);m=a[g+8+3>>0]|0;m=((m<<24>>24<0?c[g+4>>2]|0:m&255)|0)==0;z5(g);z5(f);if(!m){$x(f,b,0,0,167,1);Mc(b,0,0,380183,f,0);z5(f)}}else z5(f);$x(f,b,0,0,159,1);m=a[f+8+3>>0]|0;if(!((m<<24>>24<0?c[f+4>>2]|0:m&255)|0)){$x(g,b,0,0,183,1);m=a[g+8+3>>0]|0;m=((m<<24>>24<0?c[g+4>>2]|0:m&255)|0)==0;z5(g);z5(f);if(!m){$x(f,b,0,0,183,1);Mc(b,0,0,380183,f,0);z5(f)}}else z5(f);$x(f,b,0,0,160,1);m=a[f+8+3>>0]|0;if(!((m<<24>>24<0?c[f+4>>2]|0:m&255)|0)){$x(g,b,0,0,168,1);m=a[g+8+3>>0]|0;m=((m<<24>>24<0?c[g+4>>2]|0:m&255)|0)==0;z5(g);z5(f);if(!m){$x(f,b,0,0,168,1);Mc(b,0,0,374689,f,0);z5(f)}}else z5(f);$x(f,b,0,0,160,1);m=a[f+8+3>>0]|0;if(!((m<<24>>24<0?c[f+4>>2]|0:m&255)|0)){$x(g,b,0,0,184,1);m=a[g+8+3>>0]|0;m=((m<<24>>24<0?c[g+4>>2]|0:m&255)|0)==0;z5(g);z5(f);if(!m){$x(f,b,0,0,184,1);Mc(b,0,0,374689,f,0);z5(f)}}else z5(f);$x(f,b,0,0,161,1);m=a[f+8+3>>0]|0;if(!((m<<24>>24<0?c[f+4>>2]|0:m&255)|0)){$x(g,b,0,0,170,1);m=a[g+8+3>>0]|0;m=((m<<24>>24<0?c[g+4>>2]|0:m&255)|0)==0;z5(g);z5(f);if(!m){$x(f,b,0,0,170,1);Mc(b,0,0,357383,f,0);z5(f)}}else z5(f);$x(f,b,0,0,161,1);m=a[f+8+3>>0]|0;if(!((m<<24>>24<0?c[f+4>>2]|0:m&255)|0)){$x(g,b,0,0,185,1);m=a[g+8+3>>0]|0;m=((m<<24>>24<0?c[g+4>>2]|0:m&255)|0)==0;z5(g);z5(f);if(!m){$x(f,b,0,0,185,1);Mc(b,0,0,357383,f,0);z5(f)}}else z5(f);$x(f,b,0,0,240,1);m=a[f+8+3>>0]|0;if(!((m<<24>>24<0?c[f+4>>2]|0:m&255)|0)){z5(f);break}$x(g,b,0,0,240,1);m=a[g+8+3>>0]|0;if((m<<24>>24<0?c[g+4>>2]|0:m&255)>>>0>=4){z5(g);z5(f);break}$x(d,b,0,0,240,1);if((c[((a[d+8+3>>0]|0)<0?c[d>>2]|0:d)>>2]|0)<=47){z5(d);z5(g);z5(f);break}$x(e,b,0,0,240,1);m=(c[((a[e+8+3>>0]|0)<0?c[e>>2]|0:e)>>2]|0)<58;z5(e);z5(d);z5(g);z5(f);if(m){TX(f);$x(g,b,0,0,240,1);m=a[g+8+3>>0]|0;m=((m<<24>>24<0?c[g+4>>2]|0:m&255)|0)==1;z5(g);if(m){Xy(i,7404);$x(j,b,0,0,240,1);d=a[j+8+3>>0]|0;m=d<<24>>24<0;Ex(i,m?c[j>>2]|0:j,m?c[j+4>>2]|0:d&255)|0;c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];d=0;while(1){if((d|0)==3)break;c[i+(d<<2)>>2]=0;d=d+1|0}p2(g,h);vF(f,g)|0;z5(g);O0(h);z5(j);z5(i)}$x(g,b,0,0,240,1);m=a[g+8+3>>0]|0;m=((m<<24>>24<0?c[g+4>>2]|0:m&255)|0)==2;z5(g);if(m){Xy(i,7440);$x(j,b,0,0,240,1);d=a[j+8+3>>0]|0;m=d<<24>>24<0;Ex(i,m?c[j>>2]|0:j,m?c[j+4>>2]|0:d&255)|0;c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];d=0;while(1){if((d|0)==3)break;c[i+(d<<2)>>2]=0;d=d+1|0}p2(g,h);vF(f,g)|0;z5(g);O0(h);z5(j);z5(i)}$x(g,b,0,0,240,1);m=a[g+8+3>>0]|0;m=((m<<24>>24<0?c[g+4>>2]|0:m&255)|0)==3;z5(g);if(m){Xy(i,7472);$x(j,b,0,0,240,1);d=a[j+8+3>>0]|0;m=d<<24>>24<0;Ex(i,m?c[j>>2]|0:j,m?c[j+4>>2]|0:d&255)|0;c[h>>2]=c[i>>2];c[h+4>>2]=c[i+4>>2];c[h+8>>2]=c[i+8>>2];d=0;while(1){if((d|0)==3)break;c[i+(d<<2)>>2]=0;d=d+1|0}p2(g,h);vF(f,g)|0;z5(g);O0(h);z5(j);z5(i)}pl(g,f);Mc(b,0,0,379551,g,1);z5(g);z5(f)}}while(0);l=k;return}function Kc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;v=l;l=l+112|0;t=v+48|0;k=v+36|0;m=v+24|0;n=v+12|0;o=v;do if((d|0)>7)f=-1;else{s=b+16|0;u=b+20|0;if((d|0)==7){c[s>>2]=7;c[u>>2]=-1;f=0;break}j=(RA(b,d,-1)|0)>>>0>e>>>0;f=b+4|0;g=c[c[f>>2]>>2]|0;h=g+(d*12|0)|0;if(j){j=(c[h>>2]|0)+(e*40|0)|0;mI(t);Fq(h,j,t);$_(t);j=(c[c[b+8>>2]>>2]|0)+(d*12|0)|0;f=(c[j>>2]|0)+(e*56|0)|0;xA(t);oq(j,f,t);LT(t);c[s>>2]=d;f=e}else{cE(h,(((c[g+(d*12|0)+4>>2]|0)-(c[h>>2]|0)|0)/40|0)+1|0);i=c[c[b+8>>2]>>2]|0;j=i+(d*12|0)|0;GD(j,(((c[i+(d*12|0)+4>>2]|0)-(c[j>>2]|0)|0)/56|0)+1|0);c[s>>2]=d;f=c[c[f>>2]>>2]|0;f=(((c[f+(d*12|0)+4>>2]|0)-(c[f+(d*12|0)>>2]|0)|0)/40|0)+-1|0}c[u>>2]=f;lL(b,d,f,0,RA(b,d,f)|0,10,0);j=c[s>>2]|0;f=c[u>>2]|0;zb(b,j,f,3,SU(vn(j)|0,3,1)|0,0);j=c[s>>2]|0;f=c[u>>2]|0;pl(t,SU(vn(j)|0,3,1)|0);zb(b,j,f,4,t,1);z5(t);f=0;while(1){if(f>>>0>=(RA(b,d,-1)|0)>>>0)break;j=c[s>>2]|0;lL(b,j,f,2,RA(b,j,-1)|0,10,1);lL(b,c[s>>2]|0,f,5,f,10,1);j=(RA(b,c[s>>2]|0,-1)|0)>>>0>1;g=c[s>>2]|0;h=f+1|0;if(j){lL(b,g,f,6,h,10,1);f=h;continue}else{Ed(b,g,f,6);f=h;continue}}j=b+492|0;f=a[j>>0]|0;if((d|0)!=0&f<<24>>24==0){g=Vj(b,d,0,3,1)|0;if((RA(b,d,-1)|0)>>>0>1){mI(t);Xy(k,41840);z3(t,k);z5(k);Bs(o,g,6064);p2(n,o);pk(m,n);gq(k,b,0,0,(a[m+11>>0]|0)<0?c[m>>2]|0:m);og(t,k);z5(k);a1(m);z5(n);O0(o);h=t+4|0;f=c[t>>2]|0;i=t+8|0;if((((c[h>>2]|0)-f|0)/12|0)>>>0>e>>>0){TX(k);xr(t,f+(e*12|0)|0,k);z5(k)}else{TX(k);f=c[h>>2]|0;if(f>>>0<(c[i>>2]|0)>>>0){rV(f,k);c[h>>2]=(c[h>>2]|0)+12}else Dx(t,k);z5(k)}Bs(n,g,6064);p2(m,n);pk(k,m);w=a[k+11>>0]|0;f=c[k>>2]|0;de(o,t);Mc(b,0,0,w<<24>>24<0?f:k,o,1);z5(o);a1(k);z5(m);O0(n);Bs(o,g,6112);p2(n,o);pk(m,n);gq(k,b,0,0,(a[m+11>>0]|0)<0?c[m>>2]|0:m);og(t,k);z5(k);a1(m);z5(n);O0(o);f=c[t>>2]|0;if((((c[h>>2]|0)-f|0)/12|0)>>>0>e>>>0){TX(k);xr(t,f+(e*12|0)|0,k);z5(k)}else{TX(k);f=c[h>>2]|0;if(f>>>0<(c[i>>2]|0)>>>0){rV(f,k);c[h>>2]=(c[h>>2]|0)+12}else Dx(t,k);z5(k)}Bs(n,g,6112);p2(m,n);pk(k,m);w=a[k+11>>0]|0;f=c[k>>2]|0;de(o,t);Mc(b,0,0,w<<24>>24<0?f:k,o,1);z5(o);a1(k);z5(m);O0(n);Bs(o,g,6172);p2(n,o);pk(m,n);gq(k,b,0,0,(a[m+11>>0]|0)<0?c[m>>2]|0:m);og(t,k);z5(k);a1(m);z5(n);O0(o);f=c[t>>2]|0;if((((c[h>>2]|0)-f|0)/12|0)>>>0>e>>>0){TX(k);xr(t,f+(e*12|0)|0,k);z5(k)}else{TX(k);f=c[h>>2]|0;if(f>>>0<(c[i>>2]|0)>>>0){rV(f,k);c[h>>2]=(c[h>>2]|0)+12}else Dx(t,k);z5(k)}Bs(n,g,6172);p2(m,n);pk(k,m);w=a[k+11>>0]|0;f=c[k>>2]|0;de(o,t);Mc(b,0,0,w<<24>>24<0?f:k,o,1);z5(o);a1(k);z5(m);O0(n);Bs(o,g,6224);p2(n,o);pk(m,n);gq(k,b,0,0,(a[m+11>>0]|0)<0?c[m>>2]|0:m);og(t,k);z5(k);a1(m);z5(n);O0(o);f=c[t>>2]|0;if((((c[h>>2]|0)-f|0)/12|0)>>>0>e>>>0){TX(k);xr(t,f+(e*12|0)|0,k);z5(k)}else{TX(k);f=c[h>>2]|0;if(f>>>0<(c[i>>2]|0)>>>0){rV(f,k);c[h>>2]=(c[h>>2]|0)+12}else Dx(t,k);z5(k)}Bs(n,g,6224);p2(m,n);pk(k,m);e=a[k+11>>0]|0;w=c[k>>2]|0;de(o,t);Mc(b,0,0,e<<24>>24<0?w:k,o,1);z5(o);a1(k);z5(m);O0(n);$_(t)}Bs(m,g,6312);p2(k,m);pk(t,k);o=a[t+11>>0]|0;w=c[t>>2]|0;f=RA(b,d,-1)|0;fM(b,0,0,o<<24>>24<0?w:t,f,1);a1(t);z5(k);O0(m);f=a[j>>0]|0}g=(d|0)==0;if(!(f<<24>>24)){if(g)r=46}else{f=a[b+36+3>>0]|0;if(f<<24>>24<0)f=c[b+32>>2]|0;else f=f&255;if(g&(f|0)!=0)r=46}if((r|0)==46?(q=b+40|0,p=c[q>>2]|0,q=c[q+4>>2]|0,!((p|0)==-1&(q|0)==-1)):0)oK(b,0,0,86,p,q,10,0);k=c[s>>2]|0;k=(c[b+380+(k*12|0)>>2]|0)==(c[b+380+(k*12|0)+4>>2]|0)?7:k;j=b+380+(k*12|0)|0;k=b+380+(k*12|0)+4|0;e=t+11|0;i=0;while(1){f=c[k>>2]|0;w=c[j>>2]|0;g=w;if(i>>>0>=((f-w|0)/24|0)>>>0)break;f=g+(i*24|0)|0;w=Gz(f)|0;g=c[s>>2]|0;h=c[u>>2]|0;if(w){w=pn(f)|0;zb(b,g,h,w,(c[j>>2]|0)+(i*24|0)+12|0,0)}else{Sn(t,f);Mc(b,g,h,(a[e>>0]|0)<0?c[t>>2]|0:t,(c[j>>2]|0)+(i*24|0)+12|0,0);a1(t)}i=i+1|0}while(1){if((f|0)==(g|0))break;w=f+-24|0;c[k>>2]=w;w4(w);f=c[k>>2]|0}f=c[u>>2]|0}while(0);l=v;return f|0}function Lc(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;y=l;l=l+48|0;x=y+24|0;u=y+20|0;t=y+16|0;w=y+12|0;f=y+40|0;v=y;bB(b,y+41|0);jB(b,y+36|0);TX(x);r3(b,u);r3(b,t);r3(b,w);k=b+528|0;m=k;m=z0(c[m>>2]|0,c[m+4>>2]|0,8,0)|0;i=z;g=k;c[g>>2]=m;c[g+4>>2]=i;g=b+536|0;n=g;j=c[n+4>>2]|0;s=x+4|0;r=x+8+3|0;a:do if(i>>>0<j>>>0|((i|0)==(j|0)?m>>>0<(c[n>>2]|0)>>>0:0)){EG(b,f);n=k;m=c[n>>2]|0;n=c[n+4>>2]|0;i=z0(m|0,n|0,1,0)|0;j=z;f=d[f>>0]|0;A=z0(f|0,0,i|0,j|0)|0;h=g;g=c[h>>2]|0;h=c[h+4>>2]|0;if((A|0)==(g|0)&(z|0)==(h|0)){A=k;c[A>>2]=i;c[A+4>>2]=j;jZ(b,f,0,x)}else{c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[v+(f<<2)>>2]=0;f=f+1|0}f=D_(g|0,h|0,m|0,n|0)|0;EU(b,f,z,v);f=v+11|0;bj(x,(a[f>>0]|0)<0?c[v>>2]|0:v)|0;A=a[r>>0]|0;if(!((A<<24>>24<0?c[s>>2]|0:A&255)|0))cC(x,(a[f>>0]|0)<0?c[v>>2]|0:v)|0;a1(v)}f=a[r>>0]|0;g=f<<24>>24<0;j=g?c[x>>2]|0:x;h=i9(24620)|0;do if(h){i=j+((g?c[s>>2]|0:f&255)<<2)|0;A=HA(j,i,24620,24620+(h<<2)|0)|0;if((A|0)!=(i|0)?(A-j|0)!=-4:0)break;g=i9(24652)|0;if((((((g|0)!=0?(A=HA(j,i,24652,24652+(g<<2)|0)|0,o=j,(A|0)==(i|0)|(A-o|0)==-4):0)?(p=i9(24684)|0,(p|0)!=0):0)?(A=HA(j,i,24684,24684+(p<<2)|0)|0,(A|0)==(i|0)|(A-o|0)==-4):0)?(q=i9(24704)|0,(q|0)!=0):0)?(A=HA(j,i,24704,24704+(q<<2)|0)|0,(A|0)==(i|0)|(A-o|0)==-4):0){TX(v);lh(v,c[t>>2]|0)|0;g=a[r>>0]|0;f=g<<24>>24<0;g=f?c[s>>2]|0:g&255;A=a[v+8+3>>0]|0;h=A<<24>>24<0;if((g|0)!=((h?c[v+4>>2]|0:A&255)|0)){z5(v);break a}A=(L$(f?c[x>>2]|0:x,h?c[v>>2]|0:v,g)|0)==0;z5(v);if(!A)break a;f=a[r>>0]|0}}while(0);if(f<<24>>24<0){y7(c[x>>2]|0,0);c[s>>2]=0;break}else{y7(x,0);a[r>>0]=0;break}}while(0);do if(qO(b)|0){A=a[r>>0]|0;k=b+20|0;j=b+16|0;if((A<<24>>24<0?c[s>>2]|0:A&255)|0?($x(v,b,0,0,159,1),A=a[v+8+3>>0]|0,A=((A<<24>>24<0?c[v+4>>2]|0:A&255)|0)==0,z5(v),A):0)Mc(b,c[j>>2]|0,c[k>>2]|0,380183,x,0);f=c[t>>2]|0;h=b+916|0;i=b+788|0;b:do if((f|0)<1935962989){if((f|0)<1751740020){if((f|0)<1668047728){if((f|0)>=1634494835)switch(f|0){case 1634494835:{g=66;break b}default:{g=64;break b}}switch(f|0){case 1297106247:break;default:{g=64;break b}}a[b+761>>0]=1;g=66;break}if((f|0)<1684108385){switch(f|0){case 1668047728:break;default:{g=64;break b}}if((c[j>>2]|0)==3){e=3;g=67;break}Kc(b,3,-1)|0;g=66;break}else{switch(f|0){case 1684108385:break;default:{g=64;break b}}if((c[j>>2]|0)==4){e=4;g=67;break}Kc(b,4,-1)|0;RB(b,4,c[k>>2]|0,18,391007,-1,1,0);g=66;break}}if((f|0)>=1868854125){if((f|0)>=1935832172)switch(f|0){case 1935832172:{g=39;break b}default:{g=64;break b}}switch(f|0){case 1868854125:break;default:{g=64;break b}}if((c[j>>2]|0)!=4)Kc(b,4,-1)|0;RB(b,4,c[k>>2]|0,18,377486,-1,1,0);g=66;break}if((f|0)<1868788589){switch(f|0){case 1751740020:break;default:{g=64;break b}}f=c[j>>2]|0;if((f|0)!=7){e=f;g=67;break}Kc(b,4,-1)|0;RB(b,4,c[k>>2]|0,18,377432,-1,1,0);c[(bF(h,i)|0)+44>>2]=4;g=c[k>>2]|0;c[(bF(h,i)|0)+48>>2]=g;g=66;break}switch(f|0){case 1868788589:break;default:{g=64;break b}}if((c[j>>2]|0)!=4)Kc(b,4,-1)|0;RB(b,4,c[k>>2]|0,18,377459,-1,1,0);g=66}else{if((f|0)>=1952807028){if((f|0)<1953981806){if((f|0)<1953325924)switch(f|0){case 1952807028:{g=39;break b}default:{g=64;break b}}switch(f|0){case 1953325924:break;default:{g=64;break b}}if((c[j>>2]|0)==3){e=3;g=67;break}Kc(b,4,-1)|0;RB(b,4,c[k>>2]|0,18,380054,-1,1,0);RB(b,4,c[k>>2]|0,19,377405,-1,1,0);g=66;break}if((f|0)<1986618469){switch(f|0){case 1953981806:break;default:{g=64;break b}}if((c[j>>2]|0)==3){e=3;g=67;break}Kc(b,4,-1)|0;RB(b,4,c[k>>2]|0,18,377453,-1,1,0);g=66;break}else{switch(f|0){case 1986618469:break;default:{g=64;break b}}if((c[j>>2]|0)==1){e=1;g=67;break}Kc(b,1,-1)|0;g=66;break}}if((f|0)>=1937072752)switch(f|0){case 1937072752:{if((c[j>>2]|0)==3){e=3;g=67;break b}Kc(b,3,-1)|0;g=66;break b}case 1937072756:{if((c[j>>2]|0)==3){e=3;g=67;break b}Kc(b,3,-1)|0;g=66;break b}default:{g=64;break b}}if((f|0)>=1936684398){switch(f|0){case 1936684398:break;default:{g=64;break b}}if((c[j>>2]|0)==2){e=2;g=67;break}Kc(b,2,-1)|0;g=66;break}switch(f|0){case 1935962989:break;default:{g=64;break b}}if((c[j>>2]|0)!=4)Kc(b,4,-1)|0;RB(b,4,c[k>>2]|0,18,377505,-1,1,0);g=66}while(0);do if((g|0)==39)if((c[j>>2]|0)!=3){if(a[(bF(h,i)|0)+273>>0]|0){Kc(b,6,-1)|0;g=66;break}Kc(b,3,-1)|0;if((f|0)==1952807028)g=66;else{g=c[k>>2]|0;TX(v);zb(b,3,g,29,lh(v,f)|0,0);z5(v);g=66}}else{e=3;g=67}else if((g|0)==64)if(!(c[(bF(h,i)|0)+56>>2]|0)){g=c[u>>2]|0;c[(bF(h,i)|0)+52>>2]=g;c[(bF(h,i)|0)+56>>2]=f;g=c[w>>2]|0;c[(bF(h,i)|0)+60>>2]=g;g=66}else g=66;while(0);if((g|0)==66?(e=c[j>>2]|0,(e|0)!=7):0)g=67;if((g|0)==67){c[(bF(h,i)|0)+44>>2]=e;A=c[k>>2]|0;c[(bF(h,i)|0)+48>>2]=A}g=c[w>>2]|0;if(g|0){e=b+828|0;f=c[e>>2]|0;if(!f){c[e>>2]=g;break}if((f|0)!=(g|0))c[e>>2]=-1}}while(0);z5(x);l=y;return}function Mc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;t=l;l=l+64|0;s=t+40|0;r=t+16|0;p=t;a:do if(!((d|0)>7|(f|0)==0)?a[f>>0]|0:0){if((oH(g,13,0)|0)==-1?(oH(g,10,0)|0)==-1:0){b:do if((d|0)==7){i=1;while(1){if(i>>>0>=7){d=i;break b}if((c[b+380+(i*12|0)>>2]|0)!=(c[b+380+(i*12|0)+4>>2]|0)){d=i;break b}i=i+1|0}}else{n=c[c[b+4>>2]>>2]|0;if((((c[n+(d*12|0)+4>>2]|0)-(c[n+(d*12|0)>>2]|0)|0)/40|0)>>>0<=e>>>0){m=b+464|0;e=b+468|0;n=b+380+(d*12|0)+4|0;o=b+380+(d*12|0)+8|0;p=b+380+(d*12|0)|0;k=0;while(1){i=c[e>>2]|0;u=c[m>>2]|0;j=u;if(k>>>0>=((i-u|0)/24|0)>>>0)break;i=j+(k*24|0)|0;j=c[n>>2]|0;if((j|0)==(c[o>>2]|0))Sv(p,i);else{h0(j,i);c[n>>2]=(c[n>>2]|0)+24}k=k+1|0}while(1){if((i|0)==(j|0))break b;u=i+-24|0;c[e>>2]=u;w4(u);i=c[e>>2]|0}}TX(r);p2(s,cC(r,f)|0);z5(r);i=Sx(vn(d)|0,s,0)|0;do if((i|0)==-1){if((d|0)==4?(xN(f,385582)|0)==0:0)break;i=c[(c[c[b+8>>2]>>2]|0)+(d*12|0)>>2]|0;n=i+(e*56|0)|0;TX(p);p2(r,sP(p,f)|0);z5(p);j=g+8+3|0;u=a[j>>0]|0;k=g+4|0;c:do if(!((u<<24>>24<0?c[k>>2]|0:u&255)|0)){if(h?(o=Sx(n,r,0)|0,(o|0)!=-1):0){m=i+(e*56|0)+4|0;k=c[m>>2]|0;j=(c[n>>2]|0)+(o*40|0)|0;while(1){i=j+40|0;if((i|0)==(k|0))break;Kq(j,i)|0;j=i}while(1){i=c[m>>2]|0;if((i|0)==(j|0))break c;u=i+-40|0;c[m>>2]=u;$_(u)}}}else{i=_0(n,r,1)|0;u=a[i+8+3>>0]|0;if(((u<<24>>24<0?c[i+4>>2]|0:u&255)|0)==0|h){k1(i,g)|0;pl(p,s);vF(_0(n,r,4)|0,p)|0;z5(p);Ou(b,d,e,f,357193);break}else{kT(p);u=a[p+8+3>>0]|0;h=u<<24>>24<0;Ex(i,h?c[p>>2]|0:p,h?c[p+4>>2]|0:u&255)|0;z5(p);u=a[j>>0]|0;h=u<<24>>24<0;Ex(i,h?c[g>>2]|0:g,h?c[k>>2]|0:u&255)|0;break}}while(0);lL(b,d,e,0,RA(b,d,e)|0,10,1);z5(r)}else zb(b,d,e,i,g,h);while(0);z5(s);break a}while(0);TX(r);p2(s,bj(r,f)|0);z5(r);e=b+380+(d*12|0)|0;f=b+380+(d*12|0)+4|0;d:do if(h){k=c[e>>2]|0;j=((c[f>>2]|0)-k|0)/24|0;m=a[s+8+3>>0]|0;n=m<<24>>24<0;m=n?c[s+4>>2]|0:m&255;n=n?c[s>>2]|0:s;i=0;while(1){if(i>>>0>=j>>>0){q=72;break d}o=k+(i*24|0)|0;u=a[k+(i*24|0)+8+3>>0]|0;p=u<<24>>24<0;if(((p?c[k+(i*24|0)+4>>2]|0:u&255)|0)==(m|0)?(L$(p?c[o>>2]|0:o,n,m)|0)==0:0)break;i=i+1|0}k1(k+(i*24|0)+12|0,g)|0}else q=72;while(0);if((q|0)==72){b4(r);k1(r,s)|0;k1(r+12|0,g)|0;i=c[f>>2]|0;if((i|0)==(c[b+380+(d*12|0)+8>>2]|0))Sv(e,r);else{h0(i,r);c[f>>2]=(c[f>>2]|0)+24}w4(r)}z5(s);break}p2(s,g);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;k=i9(42452)|0;if(k>>>0>1073741807)uaa();i=r+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{u=ZW(j<<2)|0;c[r>>2]=u;c[i>>2]=j|-2147483648;c[r+4>>2]=k;i=u;break}}else{a[i+3>>0]=k;i=r}while(0);a3(i,42452,k);y7(i+(k<<2)|0,0);c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;k=i9(41840)|0;if(k>>>0>1073741807)uaa();i=p+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{u=ZW(j<<2)|0;c[p>>2]=u;c[i>>2]=j|-2147483648;c[p+4>>2]=k;i=u;break}}else{a[i+3>>0]=k;i=p}while(0);a3(i,41840,k);y7(i+(k<<2)|0,0);vo(s,r,p,0,8);O0(p);O0(r);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;k=i9(42464)|0;if(k>>>0>1073741807)uaa();i=r+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{u=ZW(j<<2)|0;c[r>>2]=u;c[i>>2]=j|-2147483648;c[r+4>>2]=k;i=u;break}}else{a[i+3>>0]=k;i=r}while(0);a3(i,42464,k);y7(i+(k<<2)|0,0);c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;k=i9(41840)|0;if(k>>>0>1073741807)uaa();i=p+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{u=ZW(j<<2)|0;c[p>>2]=u;c[i>>2]=j|-2147483648;c[p+4>>2]=k;i=u;break}}else{a[i+3>>0]=k;i=p}while(0);a3(i,41840,k);y7(i+(k<<2)|0,0);vo(s,r,p,0,8);O0(p);O0(r);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;k=i9(42472)|0;if(k>>>0>1073741807)uaa();i=r+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{u=ZW(j<<2)|0;c[r>>2]=u;c[i>>2]=j|-2147483648;c[r+4>>2]=k;i=u;break}}else{a[i+3>>0]=k;i=r}while(0);a3(i,42472,k);y7(i+(k<<2)|0,0);c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;k=i9(41840)|0;if(k>>>0>1073741807)uaa();i=p+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{u=ZW(j<<2)|0;c[p>>2]=u;c[i>>2]=j|-2147483648;c[p+4>>2]=k;i=u;break}}else{a[i+3>>0]=k;i=p}while(0);a3(i,41840,k);y7(i+(k<<2)|0,0);vo(s,r,p,0,8);O0(p);O0(r);j=a[s+8+3>>0]|0;i=j<<24>>24<0;j=i?c[s+4>>2]|0:j&255;if(j>>>0>2?(m=i?c[s>>2]|0:s,g=i9(41840)|0,r=m+(j<<2)|0,u=Ix(m,r,41840,41840+(g<<2)|0)|0,m=(g|0)!=0&(u|0)==(r|0)?-1:u-m>>2,(m|0)==(j+-3|0)):0)FB(s,m,0);Mc(b,d,e,f,s,h);z5(s)}while(0);l=t;return}function Nc(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;B=l;l=l+32|0;n=B+24|0;f=B+30|0;i=B+28|0;A=B+12|0;u=B;o=d+1036|0;b[o>>1]=0;HB(d,f);HB(d,i);p=d+1032|0;bD(d,p);bD(d,n);x=d+528|0;t=x;m=c[t>>2]|0;t=c[t+4>>2]|0;w=z0(m|0,t|0,2,0)|0;y=x;c[y>>2]=w;c[y+4>>2]=z;t=z0(m|0,t|0,4,0)|0;m=z;y=d+536|0;w=y;s=c[w+4>>2]|0;if(!(m>>>0>s>>>0|((m|0)==(s|0)?t>>>0>(c[w>>2]|0)>>>0:0)))HB(d,o);w=b[f>>1]|0;s=w<<16>>16==1;do if(s){f=b[o>>1]|0;if(f<<16>>16){f=O(c[p>>2]|0,f&65535)|0;f=(O(f,e[i>>1]|0)|0)>>>3;if((f|0)!=(c[n>>2]<<3|0))break;c[n>>2]=f;break}f=c[n>>2]|0;if(f|0?(g=c[p>>2]|0,h=b[i>>1]|0,(g|0)!=0&h<<16>>16!=0):0)b[o>>1]=(((f<<3>>>0)/(g>>>0)|0)>>>0)/((h&65535)>>>0)|0}while(0);Kc(d,2,-1)|0;t=jF(d+760|0,d+772|0)|0;c[t+36>>2]=w&65535;TX(A);Ek(A,w,16)|0;tP(A)|0;m=d+20|0;Rf(d,A,2,c[m>>2]|0,3);zb(d,2,c[m>>2]|0,52,A,0);zb(d,2,c[m>>2]|0,57,A,0);k=b[i>>1]|0;if(k<<16>>16){p2(u,Aj(2,3,A,1)|0);do if(k<<16>>16==5){f=i9(39840)|0;h=u+8+3|0;i=a[h>>0]|0;j=u+4|0;g=c[j>>2]|0;if((f|0)==((i<<24>>24<0?g:i&255)|0)){if(!(VG(u,39840,f)|0))break;i=a[h>>0]|0;g=c[j>>2]|0}f=i9(29616)|0;if(!((f|0)==((i<<24>>24<0?g:i&255)|0)?!(VG(u,29616,f)|0):0))v=17}else v=17;while(0);if((v|0)==17)kL(d,2,c[m>>2]|0,122,k,10,0);z5(u)}f=c[p>>2]|0;if(f|0)lL(d,2,c[m>>2]|0,135,f,10,0);g=c[n>>2]|0;if(g|0)lL(d,2,c[m>>2]|0,112,g<<3,10,0);f=b[o>>1]|0;if(f<<16>>16)kL(d,2,c[m>>2]|0,147,f,10,0);c[t+48>>2]=g;f=c[p>>2]|0;if(f|0?(r=d+1016|0,q=c[r>>2]|0,r=c[r+4>>2]|0,!((q|0)==-1&(r|0)==-1)):0){r=cT((+(q>>>0)+4294967296.0*+(r>>>0))*1.0e3/+(f>>>0))|0;jL(d,2,0,156,r,z,0);RB(d,2,0,165,379436,-1,1,0)}h=t+8|0;i=t+4|0;do if(s){$x(u,d,0,0,57,1);f=i9(29632)|0;s=a[u+8+3>>0]|0;if((f|0)!=((s<<24>>24<0?c[u+4>>2]|0:s&255)|0)){z5(u);break}s=(VG(u,29632,f)|0)==0;z5(u);if(s){f=ZW(1256)|0;uw(f);g=f+760|0;c[g>>2]=2;c[g+4>>2]=0;a[f+732>>0]=1;c[u>>2]=f;g=c[i>>2]|0;if(g>>>0<(c[h>>2]|0)>>>0){c[g>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(t,u)}}while(0);f=Aj(2,3,A,1)|0;g=i9(40168)|0;s=a[f+8+3>>0]|0;if((g|0)==((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)?(VG(f,40168,g)|0)==0:0){f=ZW(1128)|0;Wr(f);a[f+905>>0]=1;a[f+732>>0]=1;c[u>>2]=f;g=c[i>>2]|0;if(g>>>0<(c[h>>2]|0)>>>0){c[g>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(t,u)}else v=42;do if((v|0)==42){f=Aj(2,3,A,1)|0;g=i9(39840)|0;s=a[f+8+3>>0]|0;if((g|0)==((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)?(VG(f,39840,g)|0)==0:0){f=ZW(1584)|0;on(f);g=f+760|0;c[g>>2]=2;c[g+4>>2]=0;a[f+770>>0]=1;a[f+732>>0]=1;c[u>>2]=f;g=c[i>>2]|0;if(g>>>0<(c[h>>2]|0)>>>0){c[g>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(t,u);break}f=Aj(2,3,A,1)|0;g=i9(29616)|0;s=a[f+8+3>>0]|0;if((g|0)==((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)?(VG(f,29616,g)|0)==0:0){f=ZW(1256)|0;uw(f);g=f+760|0;c[g>>2]=2;c[g+4>>2]=0;a[f+732>>0]=1;c[u>>2]=f;g=c[i>>2]|0;if(g>>>0<(c[h>>2]|0)>>>0){c[g>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(t,u);break}f=Aj(2,3,A,1)|0;g=i9(29652)|0;s=a[f+8+3>>0]|0;if((g|0)==((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)?(VG(f,29652,g)|0)==0:0){f=ZW(22152)|0;Dt(f);c[f+908>>2]=4;g=f+896|0;c[g>>2]=1;c[g+4>>2]=0;a[f+732>>0]=1;c[u>>2]=f;g=c[i>>2]|0;if(g>>>0<(c[h>>2]|0)>>>0){c[g>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(t,u);break}f=Aj(2,3,A,1)|0;g=i9(29668)|0;s=a[f+8+3>>0]|0;if((g|0)==((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)?!(w<<16>>16==22127|(VG(f,29668,g)|0)!=0):0){f=ZW(808)|0;MG(f);a[f+732>>0]=1;c[u>>2]=f;g=c[i>>2]|0;if(g>>>0<(c[h>>2]|0)>>>0){c[g>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(t,u)}}while(0);PK(d);s=x;s=z0(c[s>>2]|0,c[s+4>>2]|0,2,0)|0;q=z;t=y;r=c[t+4>>2]|0;if(!(q>>>0>r>>>0|((q|0)==(r|0)?s>>>0>(c[t>>2]|0)>>>0:0))){HB(d,u);f=b[u>>1]|0;a:do if(f<<16>>16){g=Aj(2,3,A,1)|0;h=i9(40168)|0;u=a[g+8+3>>0]|0;k=f&65535;if((h|0)==((u<<24>>24<0?c[g+4>>2]|0:u&255)|0)?(VG(g,40168,h)|0)==0:0)if(f<<16>>16==12){HR(d);break}else{e1(d,k,0);break}f=i9(29652)|0;i=A+8+3|0;h=a[i>>0]|0;j=A+4|0;g=c[j>>2]|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(VG(A,29652,f)|0){h=a[i>>0]|0;g=c[j>>2]|0;v=76}}else v=76;do if((v|0)==76){f=i9(29696)|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(A,29696,f)|0))break;h=a[i>>0]|0;g=c[j>>2]|0}f=i9(29708)|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)?(VG(A,29708,f)|0)==0:0)break;b:do if(w<<16>>16>=22127)if(w<<16>>16<26448){switch(w<<16>>16){case 22127:break;default:break b}il(d);break a}else{switch(w<<16>>16){case 26448:break;default:break b}qz(d);break a}else{switch(w<<16>>16){case -2:break;default:break b}Gj(d);break a}while(0);i=x;h=c[i>>2]|0;i=c[i+4>>2]|0;x=z0(h|0,i|0,k|0,0)|0;w=z;g=y;f=c[g>>2]|0;g=c[g+4>>2]|0;if(!(w>>>0>g>>>0|(w|0)==(g|0)&x>>>0>f>>>0)){e1(d,k,0);break a}if((f|0)==(h|0)&(g|0)==(i|0))break a;y=D_(f|0,g|0,h|0,i|0)|0;e1(d,y,z);break a}while(0);rD(d)}while(0)}z5(A);l=B;return}function Oc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0;y=l;l=l+48|0;u=y;n=(e|0)==0;if(!n){x=b+328|0;c[x>>2]=0;c[x+4>>2]=0;x=b+352|0;c[x>>2]=0;c[x+4>>2]=0}do if(!(c[b+728>>2]&8)){r=b+64|0;o=r;h=c[o>>2]|0;o=c[o+4>>2]|0;v=b+48|0;if(!((h|0)==-1&(o|0)==-1)){g=v;f=c[g>>2]|0;g=c[g+4>>2]|0;if(o>>>0<g>>>0|(o|0)==(g|0)&h>>>0<f>>>0)break;f=z0(f|0,g|0,e|0,0)|0;g=z;if(!(o>>>0<g>>>0|(o|0)==(g|0)&h>>>0<f>>>0)){b=v;c[b>>2]=f;c[b+4>>2]=g;break}}s=b+604|0;g=c[s>>2]|0;x=b+548|0;p=b+608|0;q=b+600|0;m=b+544|0;if(!g){c[m>>2]=d;f=e;g=o}else{f=c[p>>2]|0;if((g+e|0)>>>0>f>>>0){w=c[q>>2]|0;o=e>>>0>32768?e:32768;o=(o>>>0<f>>>0?f:o)+f|0;c[p>>2]=o;o=iaa(o)|0;c[q>>2]=o;no(o|0,w|0,g|0)|0;jaa(w)}if(n)f=c[s>>2]|0;else{no((c[q>>2]|0)+(c[x>>2]|0)|0,d|0,e|0)|0;f=(c[s>>2]|0)+e|0;c[s>>2]=f}c[m>>2]=c[q>>2];g=r;h=c[g>>2]|0;g=c[g+4>>2]|0}c[x>>2]=f;c[b+500>>2]=O(f>>>0>16384?f>>>13:2,c[b+504>>2]|0)|0;w=b+612|0;if(!((h|0)==-1&(g|0)==-1)){o=v;o=D_(h|0,g|0,c[o>>2]|0,c[o+4>>2]|0)|0;c[w>>2]=o+(c[w>>2]|0);o=r;c[o>>2]=-1;c[o+4>>2]=-1}n=b+24|0;do if(!(a[b+492>>0]|0)){h=c[n>>2]|0;g=h+128|0;f=c[g>>2]|0;g=c[g+4>>2]|0;switch(f|0){case 0:{if(g|0)t=22;break}case -1:{if((g|0)!=-1)t=22;break}default:t=22}if((t|0)==22){o=b+552|0;CS(h,(+((c[o>>2]|0)>>>0)+4294967296.0*+((c[o+4>>2]|0)>>>0))/(+(f>>>0)+4294967296.0*+(g>>>0)));break}f=((c[h+8>>2]|0)-(c[h+4>>2]|0)|0)/12|0;if(f>>>0>1)CS(h,+((c[h+56>>2]|0)>>>0)/+(f>>>0))}while(0);f=c[x>>2]|0;m=b+40|0;if(!(f>>>0<(c[b+620>>2]|0)>>>0?(o=v,o=z0(c[o>>2]|0,c[o+4>>2]|0,f|0,0)|0,i=m,j=c[i>>2]|0,i=c[i+4>>2]|0,!((o|0)==(j|0)&(z|0)==(i|0))):0))t=27;if((t|0)==27){while(1){t=0;if(Vf(b)|0)t=27;else break}i=m;j=c[i>>2]|0;i=c[i+4>>2]|0}f=r;h=c[f>>2]|0;f=c[f+4>>2]|0;if((j|0)==-1&(i|0)==-1|((h|0)!=(j|0)|(f|0)!=(i|0)))if((h|0)==-1&(f|0)==-1){o=v;g=c[w>>2]|0;o=z0(g|0,0,c[o>>2]|0,c[o+4>>2]|0)|0;A=z;if(!(A>>>0<i>>>0|(A|0)==(i|0)&o>>>0<j>>>0))t=32}else t=35;else t=32;if((t|0)==32){if(!(a[(c[n>>2]|0)+78>>0]|0)){On(b);f=r;g=c[f>>2]|0;f=c[f+4>>2]|0}else g=h;if((g|0)==-1&(f|0)==-1)g=c[w>>2]|0;else t=35}if((t|0)==35){if(!(SR(c[n>>2]|0)|0)){b=v;b=z0(c[b>>2]|0,c[b+4>>2]|0,c[w>>2]|0,0)|0;A=v;c[A>>2]=b;c[A+4>>2]=z;break}A=r;x=c[A+4>>2]|0;g=m;f=c[g>>2]|0;g=c[g+4>>2]|0;if(!(x>>>0<g>>>0|((x|0)==(g|0)?(c[A>>2]|0)>>>0<f>>>0:0))){A=r;c[A>>2]=f;c[A+4>>2]=g}Dn(b);break}f=c[x>>2]|0;if(f>>>0<=g>>>0){if(f>>>0<g>>>0){x=v;x=z0(c[x>>2]|0,c[x+4>>2]|0,g|0,0)|0;A=r;c[A>>2]=x;c[A+4>>2]=z}Dn(b);break}if(c[s>>2]|0)if(!g)f=0;else{A=c[q>>2]|0;TR(A|0,A+g|0,f-g|0)|0;f=c[w>>2]|0;c[s>>2]=(c[x>>2]|0)-f}else{f=c[q>>2]|0;i=c[p>>2]|0;if(f){h=e-g|0;if(i>>>0<h>>>0){jaa(f);c[q>>2]=0;c[s>>2]=0;c[p>>2]=0;g=c[w>>2]|0;f=0;t=49}}else{f=i;t=49}if((t|0)==49){h=e-g|0;A=h>>>0>32768?h:32768;f=A>>>0<f>>>0?f:A;c[p>>2]=f;f=iaa(f)|0;c[q>>2]=f}c[s>>2]=h;no(f|0,d+g|0,h|0)|0;f=c[w>>2]|0}A=v;g=c[A>>2]|0;A=c[A+4>>2]|0;if(A>>>0>4294967295|(A|0)==-1&g>>>0>~f>>>0){f=~g;c[w>>2]=f}if(f|0){i=b+120|0;A=i;t=c[A+4>>2]|0;j=b+200|0;if(!(0<t>>>0|(0==(t|0)?f>>>0<(c[A>>2]|0)>>>0:0))?(A=b+224|0,!((c[A>>2]|0)==-1?(c[A+4>>2]|0)==-1:0)):0){f=i;g=j;h=f+40|0;do{c[f>>2]=c[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0));T$(u);f=j;g=u;h=f+40|0;do{c[f>>2]=c[g>>2];f=f+4|0;g=g+4|0}while((f|0)<(h|0))}f=c[b+268>>2]|0;if(!f)k=1.0;else{t=b+272|0;d=c[t>>2]|0;k=+(d>>>0)/+((c[x>>2]|0)>>>0);u=c[w>>2]|0;A=cT(+(u>>>0)*k)|0;A=d-A|0;c[t>>2]=A;TR(f|0,f+u|0,A|0)|0}q=c[w>>2]|0;c[x>>2]=(c[x>>2]|0)-q;g=v;g=z0(c[g>>2]|0,c[g+4>>2]|0,q|0,0)|0;f=v;c[f>>2]=g;c[f+4>>2]=z;f=b+616|0;g=c[f>>2]|0;if(g>>>0>=q>>>0)c[f>>2]=g-q;g=i;f=c[g>>2]|0;g=c[g+4>>2]|0;if(!((f|0)==-1&(g|0)==-1|(g>>>0<0|(g|0)==0&f>>>0<q>>>0))){v=D_(f|0,g|0,q|0,0)|0;A=i;c[A>>2]=v;c[A+4>>2]=z}g=j;f=c[g>>2]|0;g=c[g+4>>2]|0;if(!((f|0)==-1&(g|0)==-1|(g>>>0<0|(g|0)==0&f>>>0<q>>>0))){v=D_(f|0,g|0,q|0,0)|0;A=j;c[A>>2]=v;c[A+4>>2]=z}o=b+252|0;p=c[o>>2]|0;f=c[b+256>>2]|0;a:do if((p|0)!=(f|0)){f=f-p>>3;n=b+240|0;do if(f>>>0>1&(f&1|0)==0){v=p;A=p+8|0;if(!((c[v>>2]|0)==(c[A>>2]|0)?(c[v+4>>2]|0)==(c[A+4>>2]|0):0))break;m=f+-2|0;while(1){f=p+(m<<3)|0;h=f;g=c[h>>2]|0;h=c[h+4>>2]|0;i=m+1|0;j=p+(i<<3)|0;if(!(h>>>0>0|(h|0)==0&g>>>0>q>>>0))break;A=D_(g|0,h|0,q|0,0)|0;v=f;c[v>>2]=A;c[v+4>>2]=z;v=j;v=D_(c[v>>2]|0,c[v+4>>2]|0,q|0,0)|0;A=j;c[A>>2]=v;c[A+4>>2]=z;if(!m)break a;f=m+-2|0;if(!f)break a;else m=f}u=cT(k*+(q>>>0)*.5)|0;A=z;d=D_(u|0,A|0,g|0,h|0)|0;g=c[n>>2]|0;v=g+(m<<3)|0;t=v;t=z0(d|0,z|0,c[t>>2]|0,c[t+4>>2]|0)|0;c[v>>2]=t;c[v+4>>2]=z;v=j;v=D_(u|0,A|0,c[v>>2]|0,c[v+4>>2]|0)|0;g=g+(i<<3)|0;A=g;A=z0(v|0,z|0,c[A>>2]|0,c[A+4>>2]|0)|0;c[g>>2]=A;c[g+4>>2]=z;g=f;c[g>>2]=0;c[g+4>>2]=0;g=j;c[g>>2]=0;c[g+4>>2]=0;wI(o,p,f);f=c[n>>2]|0;wI(n,f,f+(m<<3)|0);f=b+264|0;g=c[f>>2]|0;if(!((m|0)!=0&(g|0)!=-1))break a;if(g>>>0>m>>>0){c[f>>2]=g-m;break a}else{c[f>>2]=0;break a}}while(0);k=k*+(q>>>0);j=cT(k)|0;m=z;i=f+-1|0;while(1){f=p+(i<<3)|0;h=f;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!(+(g>>>0)+4294967296.0*+(h>>>0)>k))break;v=D_(g|0,h|0,j|0,m|0)|0;A=f;c[A>>2]=v;c[A+4>>2]=z;if(!i)break a;f=i+-1|0;if(!f)break a;else i=f}v=D_(j|0,m|0,g|0,h|0)|0;g=(c[n>>2]|0)+(i<<3)|0;A=g;A=z0(v|0,z|0,c[A>>2]|0,c[A+4>>2]|0)|0;c[g>>2]=A;c[g+4>>2]=z;g=f;c[g>>2]=0;c[g+4>>2]=0;wI(o,p,f);f=c[n>>2]|0;wI(n,f,f+(i<<3)|0);f=b+264|0;g=c[f>>2]|0;if(!((i|0)!=0&(g|0)!=-1))break;if(g>>>0>i>>>0){c[f>>2]=g-i;break}else{c[f>>2]=0;break}}while(0);c[w>>2]=0}if((c[x>>2]|0)>>>0>(c[b+624>>2]|0)>>>0)wk(b)}while(0);l=y;return}function Pc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=l;l=l+16|0;n=H;a:do if(!(a[b+129>>0]|0)){B=b+32|0;C=b+48|0;D=b+128|0;E=b+16|0;F=b+64|0;o=b+104|0;p=b+72|0;q=b+112|0;r=b+80|0;s=b+120|0;t=n+11|0;u=n+4|0;v=n+8|0;w=b+8|0;x=b+40|0;y=b+44|0;A=b+36|0;b:while(1){d=c[B>>2]|0;while(1){if(d|0)break;h=c[b>>2]|0;i=c[h+612>>2]|0;j=c[h+548>>2]|0;if((i+8|0)>>>0>j>>>0){G=6;break b}k=(c[h+544>>2]|0)+i|0;d=R4(a[k>>0]|0,a[k+1>>0]|0,a[k+2>>0]|0)|0;e=C9(k)|0;if((d|0)<6644019)switch(d|0){case 4801587:{G=8;break}default:G=15}else switch(d|0){case 6644019:{G=8;break}default:G=15}c:do if((G|0)==8){G=0;if((i+10|0)>>>0>j>>>0){m=0;break a}d=W8(k+6|0)|0;d=(d>>>1&16256|d&127|d>>>2&2080768|d>>>3&266338304)+10|0;c[C>>2]=d;if((d+i|0)>>>0>j>>>0){m=0;break a}if(!(a[D>>0]|0)){j=E;j=z0(c[j>>2]|0,c[j+4>>2]|0,d|0,0)|0;k=E;c[k>>2]=j;c[k+4>>2]=z}k=h+56|0;if((c[k>>2]|0)==-1?(c[k+4>>2]|0)==-1:0){k=h+632|0;j=k;j=z0(c[j>>2]|0,c[j+4>>2]|0,d|0,0)|0;c[k>>2]=j;c[k+4>>2]=z}k=ZW(760)|0;M4(k);c[B>>2]=k;GC(c[b>>2]|0)}else if((G|0)==15){G=0;f=V8(k)|0;g=z;d:do if((f|0)<1129529925){switch(f|0){case 1095189848:break;default:break d}if((g|0)==1095779668){if((i+16|0)>>>0>j>>>0){m=0;break a}g=t7(k+12|0)|0;c[C>>2]=g;k=(t7(k+8|0)|0)==0;d=g+32|0;c[C>>2]=k?g:d;d=k?g:d;if((i+d|0)>>>0>j>>>0){m=0;break a}if(!(a[D>>0]|0)){j=E;j=z0(c[j>>2]|0,c[j+4>>2]|0,d|0,0)|0;k=E;c[k>>2]=j;c[k+4>>2]=z}k=h+56|0;if((c[k>>2]|0)==-1?(c[k+4>>2]|0)==-1:0){k=h+632|0;j=k;j=z0(c[j>>2]|0,c[j+4>>2]|0,d|0,0)|0;c[k>>2]=j;c[k+4>>2]=z}k=ZW(760)|0;M4(k);c[B>>2]=k;GC(c[b>>2]|0);break c}}else{switch(f|0){case 1129529925:break;default:break d}if((g|0)==1280922185){if((i+16|0)>>>0>j>>>0){m=0;break a}e=j-i|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;if(e>>>0>4294967279){G=27;break b}if(e>>>0<11){a[t>>0]=e;d=n}else{j=e+16&-16;d=ZW(j)|0;c[n>>2]=d;c[v>>2]=j|-2147483648;c[u>>2]=e}i1(d,k,e)|0;J7(d+e|0,0);d=a[t>>0]|0;e=d<<24>>24<0;h=e?c[n>>2]|0:n;f=j9(380268)|0;do if(f){g=h+(e?c[u>>2]|0:d&255)|0;k=tB(h,g,380268,380268+f|0)|0;e=h;d=k-e|0;if((k|0)==(g|0)|(d|0)==-1){d=j9(380278)|0;if(d){k=tB(h,g,380278,380278+d|0)|0;d=k-e|0;if(!((k|0)!=(g|0)&(d|0)!=-1)){d=c[b>>2]|0;j=d+40|0;k=d+48|0;d=c[d+612>>2]|0;k=D_(c[j>>2]|0,c[j+4>>2]|0,c[k>>2]|0,c[k+4>>2]|0)|0;d=D_(k|0,z|0,d|0,0)|0;break}}else d=0;d=d+9|0}else G=35}else{d=0;G=35}while(0);if((G|0)==35){G=0;d=d+9|0}c[C>>2]=d;e=c[b>>2]|0;if(((c[e+612>>2]|0)+d|0)>>>0>(c[e+548>>2]|0)>>>0){G=44;break b}if(!(a[D>>0]|0)){j=E;j=z0(c[j>>2]|0,c[j+4>>2]|0,d|0,0)|0;k=E;c[k>>2]=j;c[k+4>>2]=z}k=e+56|0;if((c[k>>2]|0)==-1?(c[k+4>>2]|0)==-1:0){k=e+632|0;j=k;j=z0(c[j>>2]|0,c[j+4>>2]|0,d|0,0)|0;c[k>>2]=j;c[k+4>>2]=z}k=ZW(760)|0;M4(k);c[B>>2]=k;GC(c[b>>2]|0);a1(n);break c}}while(0);if((e|0)==1413564203){k=ZW(760)|0;M4(k);c[B>>2]=k;c[C>>2]=355;GC(c[b>>2]|0);break}if((d|0)==5521735){k=ZW(760)|0;M4(k);c[B>>2]=k;c[C>>2]=128;if(!(a[D>>0]|0)){j=E;j=z0(c[j>>2]|0,c[j+4>>2]|0,128,0)|0;k=E;c[k>>2]=j;c[k+4>>2]=z}GC(c[b>>2]|0);break}d=h+48|0;d=z0(i|0,0,c[d>>2]|0,c[d+4>>2]|0)|0;e=z;k=F;if((d|0)==(c[k>>2]|0)?(e|0)==(c[k+4>>2]|0):0){d=ZW(760)|0;Eg(d);c[B>>2]=d;d=c[o>>2]|0;c[C>>2]=d;if(!(a[D>>0]|0)){j=E;j=z0(c[j>>2]|0,c[j+4>>2]|0,d|0,0)|0;k=E;c[k>>2]=j;c[k+4>>2]=z}GC(c[b>>2]|0);break}k=p;if((d|0)==(c[k>>2]|0)?(e|0)==(c[k+4>>2]|0):0){d=ZW(760)|0;M4(d);c[B>>2]=d;d=c[q>>2]|0;c[C>>2]=d;if(!(a[D>>0]|0)){j=E;j=z0(c[j>>2]|0,c[j+4>>2]|0,d|0,0)|0;k=E;c[k>>2]=j;c[k+4>>2]=z}GC(c[b>>2]|0);break}k=r;if(!((d|0)==(c[k>>2]|0)?(e|0)==(c[k+4>>2]|0):0)){m=1;break a}k=ZW(760)|0;M4(k);c[B>>2]=k;if(!(a[D>>0]|0)){j=E;j=z0(c[j>>2]|0,c[j+4>>2]|0,c[C>>2]|0,0)|0;k=E;c[k>>2]=j;c[k+4>>2]=z}c[C>>2]=c[s>>2];GC(c[b>>2]|0)}while(0);aY(c[b>>2]|0,c[B>>2]|0);d=c[B>>2]|0;if(!d)d=0;else break}e=c[C>>2]|0;if(!e){G=65;break}i=c[b>>2]|0;j=c[i+612>>2]|0;k=(c[i+548>>2]|0)-j|0;k=e>>>0<k>>>0?e:k;Sc(i,d,(c[i+544>>2]|0)+j|0,k,1);d=c[b>>2]|0;j=d+612|0;c[j>>2]=(c[j>>2]|0)+k;j=w;j=z0(c[j>>2]|0,c[j+4>>2]|0,k|0,0)|0;e=w;c[e>>2]=j;c[e+4>>2]=z;k=(c[C>>2]|0)-k|0;c[C>>2]=k;e=c[B>>2]|0;if(!((k|0)==0?1:(c[e+728>>2]&8|0)!=0)){m=1;break a}if((c[d+728>>2]&1|0)!=0?(RA(e,0,-1)|0)!=0:0){d=c[b>>2]|0;if(!(c[d+728>>2]&2))jt(d);d=c[B>>2]|0;jb[c[(c[d>>2]|0)+32>>2]&511](d);Gb(c[b>>2]|0,c[B>>2]|0,0,0,0,0)|0;Gb(c[b>>2]|0,c[B>>2]|0,2,0,0,0)|0;d=c[B>>2]|0;if(d|0)jb[c[(c[d>>2]|0)+4>>2]&511](d)}else G=73;do if((G|0)==73){G=0;d=c[x>>2]|0;if((d|0)==(c[y>>2]|0)){Yy(A,B);break}else{c[d>>2]=c[B>>2];c[x>>2]=(c[x>>2]|0)+4;break}}while(0);c[B>>2]=0;d=c[C>>2]|0;if(d|0)e1(c[b>>2]|0,d,0);J3(c[b>>2]|0)}if((G|0)==6){m=(a[h+492>>0]|0)!=0;break}else if((G|0)==27)uaa();else if((G|0)==44){a1(n);m=0;break}else if((G|0)==65){jb[c[(c[d>>2]|0)+4>>2]&511](d);c[B>>2]=0;m=0;break}}else m=1;while(0);l=H;return m|0}function Qc(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+16|0;k=q;m=b+856|0;h=a[m>>0]|0;j=h&255;n=b+828|0;e=c[n>>2]|0;o=b+797|0;a:do if(!(c[e+(j*120|0)+104>>2]|0)){f=b+760|0;do if(a[f>>0]|0){g=b+793|0;i=b+798|0;if((a[g>>0]|0)==-1?(a[b+794>>0]|0)==-1:0){a[g>>0]=0;a[g+1>>0]=0;a[g+2>>0]=0;a[g+3>>0]=0;a[o>>0]=1;a[i>>0]=0;a[e+(j*120|0)+12>>0]=a[b+761>>0]|0;break}if(!(a[b+492>>0]|0)){a[g>>0]=255;a[g+1>>0]=255;a[g+2>>0]=255;a[g+3>>0]=255;a[g+4>>0]=255;a[g+5>>0]=255;a[f>>0]=0}}while(0);if(!(c[b+728>>2]&1)){W5(b);h=a[m>>0]|0;e=c[n>>2]|0}i=(c[b+804>>2]|0)+((d[b+840>>0]|0)*120|0)+104|0;c[i>>2]=(c[i>>2]|0)+1;i=h&255;f=e+(i*120|0)+104|0;c[f>>2]=(c[f>>2]|0)+1;a[e+(i*120|0)+116>>0]=1;a[e+(i*120|0)+117>>0]=1;a[e+(i*120|0)+118>>0]=1;f=b+880|0;j=c[f>>2]|0;c[e+(i*120|0)+112>>2]=j;c[f>>2]=j+1;f=a[e+(i*120|0)+12>>0]|0;j=e+(i*120|0)+28|0;b:do if(f<<24>>24>0){if(f<<24>>24==15){f=J0()|0;c[k>>2]=f;g=e+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(j,k)}}else{g=c[b+768>>2]|0;c:do if((g|0)>=1146377011){if((g|0)<1447243057)switch(g|0){case 1146377011:{p=21;break c}default:break c}if((g|0)<1685217635){switch(g|0){case 1447243057:break;default:break c}f=K3()|0;c[k>>2]=f;g=e+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(j,k);break b}else{switch(g|0){case 1685217635:break;default:break c}f=VJ(b)|0;c[k>>2]=f;g=e+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(j,k);break b}}else{if((g|0)>=1146377009)switch(g|0){case 1146377010:case 1146377009:{p=21;break c}default:break c}switch(g|0){case 1094921523:break;default:break c}f=D3()|0;c[k>>2]=f;g=e+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(j,k);break b}while(0);if((p|0)==21){f=B3()|0;c[k>>2]=f;g=e+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(j,k);break}if((c[b+764>>2]|0)==1212435798)switch(f<<24>>24){case -95:case -124:case -125:case -127:{f=D3()|0;c[k>>2]=f;g=e+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(j,k);break b}case -94:case -122:case -123:case -126:{f=B3()|0;c[k>>2]=f;g=e+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(j,k);break b}case -22:{f=K3()|0;c[k>>2]=f;g=e+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(j,k);break b}default:break b}if((h&255)>=2){if((h+-85&255)<11){f=K3()|0;c[k>>2]=f;g=e+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(j,k);break}if((h&-16)<<24>>24==96){f=VJ(b)|0;c[k>>2]=f;g=e+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(j,k);break}switch(h<<24>>24){case 118:case 114:case 113:break;case 117:{f=K3()|0;c[k>>2]=f;g=e+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(j,k);break b}default:break b}f=B3()|0;c[k>>2]=f;g=e+(i*120|0)+32|0;h=c[g>>2]|0;if(h>>>0<(c[e+(i*120|0)+36>>2]|0)>>>0){c[h>>2]=f;c[g>>2]=(c[g>>2]|0)+4}else Yy(j,k);e=d[m>>0]|0;f=c[n>>2]|0;g=D3()|0;c[k>>2]=g;h=f+(e*120|0)+32|0;i=c[h>>2]|0;if(i>>>0<(c[f+(e*120|0)+36>>2]|0)>>>0){c[i>>2]=g;c[h>>2]=(c[h>>2]|0)+4}else Yy(f+(e*120|0)+28|0,k)}}while(0);e=a[m>>0]|0;g=e&255;h=c[n>>2]|0;i=h+(g*120|0)+28|0;j=h+(g*120|0)+32|0;if((c[i>>2]|0)==(c[j>>2]|0)){e=K3()|0;c[k>>2]=e;f=c[j>>2]|0;if(f>>>0<(c[h+(g*120|0)+36>>2]|0)>>>0){c[f>>2]=e;c[j>>2]=(c[j>>2]|0)+4}else Yy(i,k);e=d[m>>0]|0;f=c[n>>2]|0;g=D3()|0;c[k>>2]=g;h=f+(e*120|0)+32|0;i=c[h>>2]|0;if(i>>>0<(c[f+(e*120|0)+36>>2]|0)>>>0){c[i>>2]=g;c[h>>2]=(c[h>>2]|0)+4}else Yy(f+(e*120|0)+28|0,k);e=d[m>>0]|0;f=c[n>>2]|0;g=B3()|0;c[k>>2]=g;h=f+(e*120|0)+32|0;i=c[h>>2]|0;if(i>>>0<(c[f+(e*120|0)+36>>2]|0)>>>0){c[i>>2]=g;c[h>>2]=(c[h>>2]|0)+4}else Yy(f+(e*120|0)+28|0,k);e=a[m>>0]|0}d:do switch(e<<24>>24){case 118:case 113:{f=0;while(1){k=c[n>>2]|0;h=k+13712|0;e=c[h>>2]|0;k=c[k+13708>>2]|0;g=k;if(f>>>0>=e-k>>2>>>0)break;e=c[g+(f<<2)>>2]|0;if(e|0)jb[c[(c[e>>2]|0)+4>>2]&511](e);f=f+1|0}while(1){if((e|0)==(g|0))break d;k=e+-4|0;c[h>>2]=k;e=k}}default:{}}while(0);g=b+734|0;f=0;while(1){h=a[m>>0]|0;k=h&255;e=c[n>>2]|0;i=c[e+(k*120|0)+28>>2]|0;if(f>>>0>=(c[e+(k*120|0)+32>>2]|0)-i>>2>>>0)break a;k=c[i+(f<<2)>>2]|0;a[k+734>>0]=a[g>>0]|0;aY(b,k);f=f+1|0}}while(0);do if(h<<24>>24==114){if((c[e+13588>>2]|0)==(c[e+13592>>2]|0)){f=c[e+14188>>2]|0;g=c[e+14192>>2]|0;if((f|0)==(g|0)){p=98;break}}else{ee(b,e+13560|0,o);e=c[n>>2]|0;f=c[e+14188>>2]|0;g=c[e+14192>>2]|0}if((f|0)!=(g|0))ee(b,e+14160|0,o)}else p=98;while(0);if((p|0)==98)ee(b,e+((h&255)*120|0)|0,o);l=q;return}function Rc(b,f){b=b|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;w=l;l=l+480|0;r=w;s=w+464|0;t=w+452|0;u=w+440|0;m=w+428|0;j=w+380|0;k=w+416|0;n=w+404|0;o=w+392|0;p=w+368|0;g=b+1570|0;if(!(a[g>>0]|0)){q=b+1571|0;i=(GR(c[b+24>>2]|0)|0)&1;a[q>>0]=i;a[g>>0]=1;g=i}else{g=b+1571|0;q=g;g=a[g>>0]|0}if(g<<24>>24)if(!(c[b+728>>2]&1)){Gt(r);c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;i=i9(12820)|0;if(i>>>0>1073741807)uaa();g=u+8|0;do if(i>>>0>=2){h=i+4&-4;if(h>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{x=ZW(h<<2)|0;c[u>>2]=x;c[g>>2]=h|-2147483648;c[u+4>>2]=i;g=x;break}}else{a[g+3>>0]=i;g=u}while(0);a3(g,12820,i);y7(g+(i<<2)|0,0);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;i=i9(409096)|0;if(i>>>0>1073741807)uaa();g=m+8|0;do if(i>>>0>=2){h=i+4&-4;if(h>>>0>1073741823){x=ua(8)|0;K2(x,391652);c[x>>2]=57868;Ya(x|0,2712,367)}else{x=ZW(h<<2)|0;c[m>>2]=x;c[g>>2]=h|-2147483648;c[m+4>>2]=i;g=x;break}}else{a[g+3>>0]=i;g=m}while(0);a3(g,409096,i);y7(g+(i<<2)|0,0);wd(t,r,u,m);p2(s,t);O0(t);O0(m);O0(u);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;i=i9(12880)|0;if(i>>>0>1073741807)uaa();g=m+8|0;do if(i>>>0>=2){h=i+4&-4;if(h>>>0>1073741823){x=ua(8)|0;K2(x,391652);c[x>>2]=57868;Ya(x|0,2712,367)}else{x=ZW(h<<2)|0;c[m>>2]=x;c[g>>2]=h|-2147483648;c[m+4>>2]=i;g=x;break}}else{a[g+3>>0]=i;g=m}while(0);a3(g,12880,i);y7(g+(i<<2)|0,0);c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;i=i9(409096)|0;if(i>>>0>1073741807)uaa();g=j+8|0;do if(i>>>0>=2){h=i+4&-4;if(h>>>0>1073741823){x=ua(8)|0;K2(x,391652);c[x>>2]=57868;Ya(x|0,2712,367)}else{x=ZW(h<<2)|0;c[j>>2]=x;c[g>>2]=h|-2147483648;c[j+4>>2]=i;g=x;break}}else{a[g+3>>0]=i;g=j}while(0);a3(g,409096,i);y7(g+(i<<2)|0,0);wd(u,r,m,j);p2(t,u);O0(u);O0(j);O0(m);c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;i=i9(12920)|0;if(i>>>0>1073741807)uaa();g=u+8|0;do if(i>>>0>=2){h=i+4&-4;if(h>>>0>1073741823){x=ua(8)|0;K2(x,391652);c[x>>2]=57868;Ya(x|0,2712,367)}else{x=ZW(h<<2)|0;c[u>>2]=x;c[g>>2]=h|-2147483648;c[u+4>>2]=i;g=x;break}}else{a[g+3>>0]=i;g=u}while(0);a3(g,12920,i);y7(g+(i<<2)|0,0);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;i=i9(42196)|0;if(i>>>0>1073741807)uaa();g=m+8|0;do if(i>>>0>=2){h=i+4&-4;if(h>>>0>1073741823){x=ua(8)|0;K2(x,391652);c[x>>2]=57868;Ya(x|0,2712,367)}else{x=ZW(h<<2)|0;c[m>>2]=x;c[g>>2]=h|-2147483648;c[m+4>>2]=i;g=x;break}}else{a[g+3>>0]=i;g=m}while(0);a3(g,42196,i);y7(g+(i<<2)|0,0);wd(k,r,u,m);O0(k);O0(m);O0(u);c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;i=i9(12964)|0;if(i>>>0>1073741807)uaa();g=u+8|0;do if(i>>>0>=2){h=i+4&-4;if(h>>>0>1073741823){x=ua(8)|0;K2(x,391652);c[x>>2]=57868;Ya(x|0,2712,367)}else{x=ZW(h<<2)|0;c[u>>2]=x;c[g>>2]=h|-2147483648;c[u+4>>2]=i;g=x;break}}else{a[g+3>>0]=i;g=u}while(0);a3(g,12964,i);y7(g+(i<<2)|0,0);TX(m);wd(n,r,u,m);O0(n);z5(m);O0(u);j=Zk(r,b+28|0)|0;c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;i=i9(12920)|0;if(i>>>0>1073741807)uaa();g=u+8|0;do if(i>>>0>=2){h=i+4&-4;if(h>>>0>1073741823){x=ua(8)|0;K2(x,391652);c[x>>2]=57868;Ya(x|0,2712,367)}else{x=ZW(h<<2)|0;c[u>>2]=x;c[g>>2]=h|-2147483648;c[u+4>>2]=i;g=x;break}}else{a[g+3>>0]=i;g=u}while(0);a3(g,12920,i);y7(g+(i<<2)|0,0);wd(o,r,u,s);O0(o);O0(u);c[u>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;i=i9(12964)|0;if(i>>>0>1073741807)uaa();g=u+8|0;do if(i>>>0>=2){h=i+4&-4;if(h>>>0>1073741823){x=ua(8)|0;K2(x,391652);c[x>>2]=57868;Ya(x|0,2712,367)}else{x=ZW(h<<2)|0;c[u>>2]=x;c[g>>2]=h|-2147483648;c[u+4>>2]=i;g=x;break}}else{a[g+3>>0]=i;g=u}while(0);a3(g,12964,i);y7(g+(i<<2)|0,0);wd(p,r,u,t);O0(p);O0(u);if(!j)a[q>>0]=0;else{Dk(u,r,0,0,57,1);g=i9(39840)|0;i=u+8+3|0;j=a[i>>0]|0;k=u+4|0;h=c[k>>2]|0;do if((g|0)==((j<<24>>24<0?h:j&255)|0)){if(!(VG(u,39840,g)|0))break;j=a[i>>0]|0;h=c[k>>2]|0;v=73}else v=73;while(0);do if((v|0)==73){g=i9(39812)|0;if((g|0)==((j<<24>>24<0?h:j&255)|0)?(VG(u,39812,g)|0)==0:0)break;a[q>>0]=0}while(0);z5(u)}z5(t);z5(s);Yw(r);if(!(a[q>>0]|0))v=79;else g=1}else g=1;else v=79;if((v|0)==79){h=(c[b+544>>2]|0)+(c[b+612>>2]|0)|0;q=h+((f>>>2)+(f>>>4)<<1)|0;o=h+f|0;p=o+-3|0;k=b+1183|0;m=p+1|0;n=p+2|0;h=h+2|0;g=0;while(1){if(h>>>0>=o>>>0)break;j=g&65535;i=d[h>>0]|0;j=e[59762+((i^j>>>8)<<1)>>1]^j<<8;g=j&65535;if((h|0)==(p|0))if((i&1|0)==0|(d[k>>0]|0)>9)h=p;else{x=j&65535;g=e[59762+((~a[m>>0]&255^x>>>8)<<1)>>1]|0;h=n;g=(e[59762+(((g^x<<8&65280)>>>8^~a[n>>0]&255)<<1)>>1]^g<<8)&65535}h=h+1|0;if((h|0)!=(q|0))continue;if(!(g<<16>>16==0|(d[k>>0]|0)>9))break}g=g<<16>>16==0}l=w;return g|0}function Sc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;O=l;l=l+48|0;N=O;if(d|0){h=d+64|0;K=h;if(!((c[K>>2]|0)==-1?(c[K+4>>2]|0)==-1:0)){K=h;c[K>>2]=-1;c[K+4>>2]=-1}v=b+48|0;r=v;I=b+612|0;w=c[I>>2]|0;r=z0(w|0,0,c[r>>2]|0,c[r+4>>2]|0)|0;J=b+528|0;y=J;x=c[y>>2]|0;y=c[y+4>>2]|0;r=z0(r|0,z|0,x|0,y|0)|0;s=z;t=d+48|0;i=t;c[i>>2]=r;c[i+4>>2]=s;i=d+40|0;k=i;j=c[k>>2]|0;k=c[k+4>>2]|0;n=b+40|0;m=c[n>>2]|0;n=c[n+4>>2]|0;if(!((j|0)==(m|0)&(k|0)==(n|0))){o=c[d+508>>2]|0;p=d+668|0;h=0;while(1){if(h>>>0>o>>>0)break;q=(c[p>>2]|0)+(h*24|0)+8|0;K=q;if((c[K>>2]|0)==(j|0)?(c[K+4>>2]|0)==(k|0):0){K=q;c[K>>2]=m;c[K+4>>2]=n}h=h+1|0}K=i;c[K>>2]=m;c[K+4>>2]=n}K=d+548|0;if((d|0)!=(b|0)?(u=c[K>>2]|0,!(s>>>0<0|(s|0)==0&r>>>0<u>>>0)):0){G=D_(r|0,s|0,u|0,0)|0;H=t;c[H>>2]=G;c[H+4>>2]=z}a[d+748>>0]=a[b+748>>0]|0;a[d+749>>0]=a[b+749>>0]|0;A=b+536|0;B=d+272|0;a:do if((f|0)!=0&g){u=b+240|0;n=c[u>>2]|0;g=b+244|0;C=d+240|0;D=d+244|0;F=d+256|0;E=d+248|0;G=d+260|0;H=d+252|0;if((n|0)==(c[g>>2]|0)){h=v;i=c[h>>2]|0;h=c[h+4>>2]|0;j=z0(w|0,0,x|0,y|0)|0;j=cT(+(j>>>0)+4294967296.0*+(z>>>0))|0;h=z0(j|0,z|0,i|0,h|0)|0;i=z;j=N;c[j>>2]=h;c[j+4>>2]=i;j=c[D>>2]|0;if(j>>>0<(c[E>>2]|0)>>>0){J=j;c[J>>2]=h;c[J+4>>2]=i;c[D>>2]=j+8}else Px(C,N);h=c[K>>2]|0;i=N;c[i>>2]=h;c[i+4>>2]=0;i=c[F>>2]|0;if(i>>>0<(c[G>>2]|0)>>>0){J=i;c[J>>2]=h;c[J+4>>2]=0;c[F>>2]=i+8}else Px(H,N);break}s=b+252|0;j=c[s>>2]|0;i=c[j>>2]|0;j=c[j+4>>2]|0;t=b+656|0;k=t;k=D_(w|0,0,c[k>>2]|0,c[k+4>>2]|0)|0;m=z;do if(!(j>>>0<m>>>0|(j|0)==(m|0)&i>>>0<k>>>0)){h=c[C>>2]|0;q=c[D>>2]|0;if((h|0)!=(q|0)?(r=(q-h>>3)+-1|0,v=h+(r<<3)|0,v=z0(c[K>>2]|0,0,c[v>>2]|0,c[v+4>>2]|0)|0,r=(c[d+252>>2]|0)+(r<<3)|0,r=D_(v|0,z|0,c[r>>2]|0,c[r+4>>2]|0)|0,v=n,(r|0)==(c[v>>2]|0)?(z|0)==(c[v+4>>2]|0):0):0)break;o=q+8|0;p=c[E>>2]|0;if(+(k>>>0)+4294967296.0*+(m>>>0)<+(i>>>0)+4294967296.0*+(j>>>0)){if((q|0)==(p|0))Px(C,n);else{w=n;x=c[w+4>>2]|0;y=q;c[y>>2]=c[w>>2];c[y+4>>2]=x;c[D>>2]=o}h=c[B>>2]|0;if(!h)h=c[K>>2]|0;x=c[s>>2]|0;i=c[I>>2]|0;j=J;y=c[j>>2]|0;j=c[j+4>>2]|0;h=z0(c[x>>2]|0,c[x+4>>2]|0,h|0,0)|0;h=D_(h|0,z|0,y|0,j|0)|0;h=D_(h|0,z|0,i|0,0)|0;i=z;j=N;c[j>>2]=h;c[j+4>>2]=i;j=c[F>>2]|0;if(j>>>0<(c[G>>2]|0)>>>0){y=j;c[y>>2]=h;c[y+4>>2]=i;c[F>>2]=j+8}else Px(H,N);break}else{h=n;v=c[h>>2]|0;h=c[h+4>>2]|0;y=z0(x|0,y|0,w|0,0)|0;i=D_(y|0,z|0,i|0,j|0)|0;h=z0(i|0,z|0,v|0,h|0)|0;i=z;y=N;c[y>>2]=h;c[y+4>>2]=i;if(q>>>0<p>>>0){y=q;c[y>>2]=h;c[y+4>>2]=i;c[D>>2]=o}else Px(C,N);h=c[B>>2]|0;if(!h)h=c[K>>2]|0;i=N;c[i>>2]=h;c[i+4>>2]=0;i=c[F>>2]|0;if(i>>>0<(c[G>>2]|0)>>>0){y=i;c[y>>2]=h;c[y+4>>2]=0;c[F>>2]=i+8}else Px(H,N);break}}while(0);r=1;while(1){y=c[u>>2]|0;h=y;if(r>>>0>=(c[g>>2]|0)-y>>3>>>0)break a;j=(c[s>>2]|0)+(r<<3)|0;i=c[j>>2]|0;j=c[j+4>>2]|0;k=c[I>>2]|0;n=J;m=c[n>>2]|0;n=c[n+4>>2]|0;y=z0(k|0,0,m|0,n|0)|0;x=z;do if(!(j>>>0<x>>>0|(j|0)==(x|0)&i>>>0<y>>>0)?(y=A,y=z0(c[y>>2]|0,c[y+4>>2]|0,k|0,0)|0,x=z,j>>>0<x>>>0|(j|0)==(x|0)&i>>>0<y>>>0):0){y=t;y=D_(k|0,0,c[y>>2]|0,c[y+4>>2]|0)|0;h=h+(r<<3)|0;o=c[D>>2]|0;p=c[E>>2]|0;q=o+8|0;if(+(y>>>0)+4294967296.0*+(z>>>0)<+(i>>>0)+4294967296.0*+(j>>>0)){if((o|0)==(p|0))Px(C,h);else{w=h;x=c[w+4>>2]|0;y=o;c[y>>2]=c[w>>2];c[y+4>>2]=x;c[D>>2]=q}h=c[B>>2]|0;if(!h)h=c[K>>2]|0;x=(c[s>>2]|0)+(r<<3)|0;i=c[I>>2]|0;j=J;y=c[j>>2]|0;j=c[j+4>>2]|0;h=z0(c[x>>2]|0,c[x+4>>2]|0,h|0,0)|0;h=D_(h|0,z|0,y|0,j|0)|0;h=D_(h|0,z|0,i|0,0)|0;i=z;j=N;c[j>>2]=h;c[j+4>>2]=i;j=c[F>>2]|0;if(j>>>0<(c[G>>2]|0)>>>0){y=j;c[y>>2]=h;c[y+4>>2]=i;c[F>>2]=j+8}else Px(H,N);break}else{y=c[h>>2]|0;h=c[h+4>>2]|0;i=D_(k|0,0,i|0,j|0)|0;i=z0(i|0,z|0,m|0,n|0)|0;h=z0(i|0,z|0,y|0,h|0)|0;i=z;y=N;c[y>>2]=h;c[y+4>>2]=i;if(o>>>0<p>>>0){y=o;c[y>>2]=h;c[y+4>>2]=i;c[D>>2]=q}else Px(C,N);h=c[B>>2]|0;if(!h)h=c[K>>2]|0;i=N;c[i>>2]=h;c[i+4>>2]=0;i=c[F>>2]|0;if(i>>>0<(c[G>>2]|0)>>>0){y=i;c[y>>2]=h;c[y+4>>2]=0;c[F>>2]=i+8}else Px(H,N);break}}while(0);r=r+1|0}}while(0);k=d+120|0;J=d+144|0;h=d+612|0;m=d+160|0;i=d+184|0;n=d+200|0;if(((c[J>>2]|0)==-1?(c[J+4>>2]|0)==-1:0)?(J=d+136|0,(c[J>>2]|0)==-1?(c[J+4>>2]|0)==-1:0):0){J=i;if(!(((c[J>>2]|0)==-1?(c[J+4>>2]|0)==-1:0)?(J=d+176|0,(c[J>>2]|0)==-1?(c[J+4>>2]|0)==-1:0):0)){L=m;M=73}}else{L=k;M=73}if((M|0)==73?(M=L,c[M>>2]=(c[h>>2]|0)+f+(c[K>>2]|0),c[M+4>>2]=0,M=i,!((c[M>>2]|0)==-1?(c[M+4>>2]|0)==-1:0)):0){h=n;i=k;j=h+40|0;do{c[h>>2]=c[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(j|0));h=k;i=m;j=h+40|0;do{c[h>>2]=c[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(j|0));T$(N);h=m;i=N;j=h+40|0;do{c[h>>2]=c[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(j|0));M=d+312|0;L=c[M+4>>2]|0;J=d+320|0;c[J>>2]=c[M>>2];c[J+4>>2]=L;J=d+336|0;L=c[J+4>>2]|0;M=d+344|0;c[M>>2]=c[J>>2];c[M+4>>2]=L}i=b+360|0;h=c[i>>2]|0;i=c[i+4>>2]|0;if(!((h|0)==-1&(i|0)==-1)){b=d+360|0;c[b>>2]=h;c[b+4>>2]=i}Oc(d,e,f);if(c[K>>2]|0){h=m;i=k;j=h+40|0;do{c[h>>2]=c[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(j|0));h=k;i=n;j=h+40|0;do{c[h>>2]=c[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(j|0));T$(N);h=n;i=N;j=h+40|0;do{c[h>>2]=c[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(j|0))}}l=O;return}function Tc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0.0,k=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0;E=l;l=l+48|0;B=E+36|0;C=E+24|0;D=E+12|0;x=E;r=(d|0)==4;i=(d|0)==1;y=Rb(d,91)|0;s=Rb(d,22)|0;a:do switch(d|0){case 0:case 4:case 6:break;default:{gq(B,b,d,e,384534);h=a[B+8+3>>0]|0;if((h<<24>>24<0?c[B+4>>2]|0:h&255)|0){z5(B);break a}$x(C,b,d,e,y,1);h=a[C+8+3>>0]|0;if(!((h<<24>>24<0?c[C+4>>2]|0:h&255)|0)){z5(C);z5(B);break a}$x(D,b,d,e,s,1);h=a[D+8+3>>0]|0;h=((h<<24>>24<0?c[D+4>>2]|0:h&255)|0)==0;z5(D);z5(C);z5(B);if(!h){do if(i){$x(B,b,1,e,185,1);h=a[B+8+3>>0]|0;if(!((h<<24>>24<0?c[B+4>>2]|0:h&255)|0)){z5(B);m=10;break}$x(C,b,1,e,171,1);h=a[C+8+3>>0]|0;h=((h<<24>>24<0?c[C+4>>2]|0:h&255)|0)==0;z5(C);z5(B);if(!(!h?($x(B,b,1,e,185,1),g=rm(B)|0,h=z,z5(B),$x(B,b,1,e,171,1),F=+Eq(B),z5(B),f=UW(g|0,h|0,1e3,0)|0,j=(+(f>>>0)+4294967296.0*+(z>>>0))/F,!((g|0)==0&(h|0)==0|F==0.0|j==0.0)):0))m=10}else m=10;while(0);if((m|0)==10){$x(B,b,d,e,s,1);j=+Eq(B);z5(B)}$x(B,b,d,e,y,1);f=rm(B)|0;g=z;z5(B);if(j>0.0&((f|0)!=0|(g|0)!=0)){h=UW(f|0,g|0,8e3,0)|0;sN(b,d,e,384534,(+(h>>>0)+4294967296.0*+(z>>>0))/j,0,0)}}}}while(0);b:do switch(d|0){case 0:case 4:case 6:break;default:{h=Rb(d,46)|0;$x(B,b,d,e,h,1);g=a[B+8+3>>0]|0;if((g<<24>>24<0?c[B+4>>2]|0:g&255)|0){z5(B);break b}f=Rb(d,107)|0;$x(C,b,d,e,f,1);g=a[C+8+3>>0]|0;if(!((g<<24>>24<0?c[C+4>>2]|0:g&255)|0)){z5(C);z5(B);break b}$x(D,b,d,e,s,1);g=a[D+8+3>>0]|0;g=((g<<24>>24<0?c[D+4>>2]|0:g&255)|0)==0;z5(D);z5(C);z5(B);if(!g){do if(i){$x(B,b,1,e,185,1);i=a[B+8+3>>0]|0;if(!((i<<24>>24<0?c[B+4>>2]|0:i&255)|0)){z5(B);m=25;break}$x(C,b,1,e,171,1);i=a[C+8+3>>0]|0;i=((i<<24>>24<0?c[C+4>>2]|0:i&255)|0)==0;z5(C);z5(B);if(!i?($x(B,b,1,e,185,1),g=rm(B)|0,i=z,z5(B),$x(B,b,1,e,171,1),F=+Eq(B),z5(B),G=UW(g|0,i|0,1e3,0)|0,k=(+(G>>>0)+4294967296.0*+(z>>>0))/F,!((g|0)==0&(i|0)==0|F==0.0|k==0.0)):0)j=k;else m=25}else m=25;while(0);if((m|0)==25){$x(B,b,d,e,s,1);j=+Eq(B);z5(B)}$x(B,b,d,e,f,1);f=rm(B)|0;g=z;z5(B);if(j>0.0&((f|0)!=0|(g|0)!=0)){G=UW(f|0,g|0,8e3,0)|0;KW(b,d,e,h,(+(G>>>0)+4294967296.0*+(z>>>0))/j,0,0)}}}}while(0);do if(!r){$x(B,b,d,e,s,1);G=a[B+8+3>>0]|0;do if(!((G<<24>>24<0?c[B+4>>2]|0:G&255)|0)){$x(C,b,d,e,y,1);G=a[C+8+3>>0]|0;if(!((G<<24>>24<0?c[C+4>>2]|0:G&255)|0)){z5(C);z5(B);break}gq(D,b,d,e,384534);G=a[D+8+3>>0]|0;if(!((G<<24>>24<0?c[D+4>>2]|0:G&255)|0)){z5(D);z5(C);z5(B);break}G=RA(b,1,-1)|0;G=((RA(b,2,-1)|0)+G|0)>>>0>1;z5(D);z5(C);z5(B);if(G?(gq(B,b,d,e,384534),n=rm(B)|0,o=z,z5(B),$x(B,b,d,e,y,1),p=rm(B)|0,q=z,z5(B),((n|0)!=0|(o|0)!=0)&((p|0)!=0|(q|0)!=0)):0){G=UW(p|0,q|0,8e3,0)|0;G=g5(G|0,z|0,n|0,o|0)|0;oK(b,d,e,s,G,z,10,0)}}else z5(B);while(0);$x(B,b,d,e,y,1);G=a[B+8+3>>0]|0;if((G<<24>>24<0?c[B+4>>2]|0:G&255)|0){z5(B);break}gq(C,b,d,e,384534);G=a[C+8+3>>0]|0;if(!((G<<24>>24<0?c[C+4>>2]|0:G&255)|0)){z5(C);z5(B);break}$x(D,b,d,e,s,1);G=a[D+8+3>>0]|0;if(!((G<<24>>24<0?c[D+4>>2]|0:G&255)|0)){z5(D);z5(C);z5(B);break}gq(x,b,d,e,384534);f=a[x+8+3>>0]|0;g=f<<24>>24<0;h=g?c[x>>2]|0:x;i=i9(41840)|0;if(!i){z5(x);z5(D);z5(C);z5(B);break}r=h+((g?c[x+4>>2]|0:f&255)<<2)|0;G=HA(h,r,41840,41840+(i<<2)|0)|0;z5(x);z5(D);z5(C);z5(B);if((G|0)==(r|0)|(G-h|0)==-4?(gq(B,b,d,e,384534),t=rm(B)|0,u=z,z5(B),$x(B,b,d,e,s,1),v=rm(B)|0,w=z,z5(B),((t|0)!=0|(u|0)!=0)&((v|0)!=0|(w|0)!=0)):0){G=UW(v|0,w|0,t|0,u|0)|0;G=g5(G|0,z|0,8e3,0)|0;oK(b,d,e,y,G,z,10,0)}}while(0);f=Rb(d,38)|0;$x(B,b,d,e,f,1);G=a[B+8+3>>0]|0;do if((G<<24>>24<0?c[B+4>>2]|0:G&255)|0){$x(C,b,d,e,f,1);f=Rb(d,44)|0;$x(D,b,d,e,f,1);h=a[C+8+3>>0]|0;g=h<<24>>24<0;h=g?c[C+4>>2]|0:h&255;G=a[D+8+3>>0]|0;i=G<<24>>24<0;if((h|0)!=((i?c[D+4>>2]|0:G&255)|0)){z5(D);z5(C);z5(B);break}G=(L$(g?c[C>>2]|0:C,i?c[D>>2]|0:D,h)|0)==0;z5(D);z5(C);z5(B);if(G?(Ed(b,d,e,f),A=Rb(d,36)|0,$x(B,b,d,e,A,1),G=a[B+8+3>>0]|0,G=((G<<24>>24<0?c[B+4>>2]|0:G&255)|0)==0,z5(B),G):0)RB(b,d,e,A,384431,-1,1,0)}else z5(B);while(0);l=E;return}function Uc(f){f=f|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0;do if(!(a[f+734>>0]|0)){O=f+728|0;if((c[O>>2]&1|0)==0?!(HM(f)|0):0)break;J=f+536|0;i=J;e1(f,c[i>>2]|0,c[i+4>>2]|0);i=f+544|0;j=f+528|0;I=f+612|0;n=j;l=J;k=c[l>>2]|0;l=c[l+4>>2]|0;m=c[n+4>>2]|0;n=c[n>>2]|0;while(1){if(!(m>>>0<l>>>0|(m|0)==(l|0)&n>>>0<k>>>0))break;if(a[(c[i>>2]|0)+((c[I>>2]|0)+n)>>0]|0)break;N=z0(n|0,m|0,1,0)|0;H=z;G=j;c[G>>2]=N;c[G+4>>2]=H;m=H;n=N}if(!((n|0)==(k|0)&(m|0)==(l|0))){t4(f);break}if(qO(f)|0){G=f+1064|0;F=c[G>>2]|0;G=c[G+4>>2]|0;H=(a[f+1011>>0]|0)!=0;E=f+1006|0;if(H)i=1;else i=(a[E>>0]|0)==3;m=XZ(F|0,G|0,(i^1)&1|0)|0;l=z;p=f+777|0;r=f+988|0;s=f+974|0;o=f+920|0;t=f+916|0;q=f+989|0;N=f+312|0;u=f+924|0;do if(!(a[p>>0]|0)){j=c[o>>2]|0;do if(a[f+1018>>0]|0){if((j|0)!=-1){D=N;C=c[D+4>>2]|0;if(!(C>>>0<0|(C|0)==0&(c[D>>2]|0)>>>0<16))break;n=c[t>>2]|0;P=+h[f+960>>3];k=a[r>>0]|0;i=b[s>>1]|0;if(+(n>>>0)*P+ +(k&255)+ +(i&65535)<+(j>>>0)*P+ +(d[q>>0]|0))j=n;else break}else{j=c[t>>2]|0;k=a[r>>0]|0;i=b[s>>1]|0}c[o>>2]=j;a[q>>0]=(k&255)+(i&65535)}while(0);i=c[t>>2]|0;if(i>>>0>=j>>>0){if((i|0)!=(j|0)){i=1;break}if(((b[s>>1]&255)+(d[r>>0]|0)|0)>>>0>=(d[q>>0]|0)>>>0){i=1;break}}a[p>>0]=1;c[u>>2]=-1;i=0}else i=0;while(0);y=f+990|0;A=a[f+991>>0]|0;p=A<<24>>24==1;B=A+-1<<24>>24;x=i&(B&255)<2;if(x){c[u>>2]=c[t>>2];C=b[s>>1]|0;a[y>>0]=(C&65535)+(d[r>>0]|0)}else C=b[s>>1]|0;n=C&65535;i=f+976|0;q=f+360|0;r=f+328|0;s=f+1072|0;u=f+144|0;D=f+136|0;if(C<<16>>16==(b[i>>1]|0)){o=N;o=z0(c[o>>2]|0,c[o+4>>2]|0,-1,-1)|0;t=N;c[t>>2]=o;c[t+4>>2]=z;if(a[s>>0]|0?(w=q,v=c[w>>2]|0,w=c[w+4>>2]|0,!((v|0)==-1&(w|0)==-1)):0){v=z0(v|0,w|0,-1,-1)|0;w=q;c[w>>2]=v;c[w+4>>2]=z}i=r;i=z0(c[i>>2]|0,c[i+4>>2]|0,-1,-1)|0;j=r;c[j>>2]=i;c[j+4>>2]=z;j=u;i=c[j>>2]|0;j=c[j+4>>2]|0;if(!((i|0)==-1&(j|0)==-1)){v=D_(i|0,j|0,m|0,l|0)|0;w=u;c[w>>2]=v;c[w+4>>2]=z}j=D;i=c[j>>2]|0;j=c[j+4>>2]|0;if(!((i|0)==-1&(j|0)==-1)){v=D_(i|0,j|0,m|0,l|0)|0;w=D;c[w>>2]=v;c[w+4>>2]=z}}else{b[i>>1]=C;i=f+978|0;if((e[i>>1]|0)<(C&65535))b[i>>1]=C}i=f+1048|0;v=f+1076|0;k=f+1042|0;if(p){b[k>>1]=C;j=D;w=c[j>>2]|0;j=c[j+4>>2]|0;c[i>>2]=w;c[i+4>>2]=j;c[v>>2]=(c[v>>2]|0)+1;i=w}else{j=i;i=c[j>>2]|0;j=c[j+4>>2]|0}do if(!((i|0)==-1&(j|0)==-1)){k=n-(e[k>>1]|0)|0;k=UW(k|0,((k|0)<0)<<31>>31|0,F|0,G|0)|0;i=z0(k|0,z|0,i|0,j|0)|0;j=z;k=D;c[k>>2]=i;c[k+4>>2]=j;k=f+280|0;o=k;n=c[o>>2]|0;o=c[o+4>>2]|0;if((n|0)!=-1|(o|0)!=-1|p^1){if((c[v>>2]|0)>>>0>=2)break;if(!(a[f+1017>>0]|0))break;if(!((j>>>0<o>>>0|(j|0)==(o|0)&i>>>0<n>>>0)&(a[f+1020>>0]|0)!=0))break}w=k;c[w>>2]=i;c[w+4>>2]=j}while(0);o=f+378|0;p=f+768|0;t=f+48|0;if((a[o>>0]|0)==0?(w=t,w=z0(c[I>>2]|0,0,c[w>>2]|0,c[w+4>>2]|0)|0,I=J,I=z0(w|0,z|0,c[I>>2]|0,c[I+4>>2]|0)|0,J=f+40|0,(I|0)==(c[J>>2]|0)?(z|0)==(c[J+4>>2]|0):0):0){w=N;I=c[w+4>>2]|0;J=p;c[J>>2]=c[w>>2];c[J+4>>2]=I}k=f+1013|0;n=f+1014|0;if(((x?(K=a[y>>0]|0,a[y>>0]=K+1<<24>>24,H):0)?a[n>>0]|0:0)?(a[y>>0]=K+2<<24>>24,a[k>>0]|0):0)a[y>>0]=K+3<<24>>24;K=N;K=z0(c[K>>2]|0,c[K+4>>2]|0,1,0)|0;J=N;c[J>>2]=K;c[J+4>>2]=z;J=r;J=z0(c[J>>2]|0,c[J+4>>2]|0,1,0)|0;K=r;c[K>>2]=J;c[K+4>>2]=z;if(a[s>>0]|0?(M=q,L=c[M>>2]|0,M=c[M+4>>2]|0,!((L|0)==-1&(M|0)==-1)):0){L=z0(L|0,M|0,1,0)|0;M=q;c[M>>2]=L;c[M+4>>2]=z}if(!H?(a[E>>0]|0)!=3:0){M=f+336|0;L=M;L=z0(c[L>>2]|0,c[L+4>>2]|0,1,0)|0;c[M>>2]=L;c[M+4>>2]=z;M=f+352|0;L=M;L=z0(c[L>>2]|0,c[L+4>>2]|0,1,0)|0;c[M>>2]=L;c[M+4>>2]=z}if(A<<24>>24==3){M=f+892|0;c[M>>2]=(c[M>>2]|0)+1}else a[f+1040>>0]=0;i=f+1039|0;j=a[i>>0]|0;if(((j|B)&255)<2)a[i>>0]=j+1<<24>>24;do if(a[n>>0]|0)if(H){l=z0(m|0,l|0,F|0,G|0)|0;m=(a[k>>0]|0)==0;m=z0(l|0,z|0,(m?0:F)|0,(m?0:G)|0)|0;l=z;break}else{M=XZ(F|0,G|0,1)|0;m=z0(m|0,l|0,M|0,z|0)|0;l=z;break}while(0);j=u;i=c[j>>2]|0;j=c[j+4>>2]|0;do if(!((i|0)==-1&(j|0)==-1)){j=z0(i|0,j|0,m|0,l|0)|0;k=z;i=u;c[i>>2]=j;c[i+4>>2]=k;i=f+304|0;M=i;L=c[M+4>>2]|0;if(!(L>>>0<k>>>0|((L|0)==(k|0)?(c[M>>2]|0)>>>0<j>>>0:0)))break;M=i;c[M>>2]=j;c[M+4>>2]=k}while(0);j=D;i=c[j>>2]|0;j=c[j+4>>2]|0;if(!((i|0)==-1&(j|0)==-1)){i=z0(i|0,j|0,m|0,l|0)|0;j=z;k=f+288|0;m=k;l=c[m>>2]|0;m=c[m+4>>2]|0;if(!(!(j>>>0>m>>>0|(j|0)==(m|0)&i>>>0>l>>>0)?(M=z0(l|0,m|0,-1e9,-1)|0,L=z,m>>>0<0|(m|0)==0&l>>>0<1000000001|(j>>>0>L>>>0|(j|0)==(L|0)&i>>>0>M>>>0)):0)){M=k;c[M>>2]=i;c[M+4>>2]=j;b[f+1056>>1]=C}L=(a[f+1038>>0]|0)==0;M=D;c[M>>2]=L?-1:i;c[M+4>>2]=L?-1:j}if(!(c[O>>2]&1)){s_(f);AR(f,0,0);AR(f,179,0);AR(f,184,0)}i=f+780|0;j=1;while(1){if((j|0)==176)break;a[(c[i>>2]|0)+(j*3|0)>>0]=0;j=j+1|0}if(!(c[O>>2]&1))W5(f);do if(!(a[o>>0]|0)){if((c[v>>2]|0)!=8)break;K=N;L=c[K+4>>2]|0;M=p;c[M>>2]=c[K>>2];c[M+4>>2]=L}while(0);if(c[O>>2]&2|0)break;L=c[N+4>>2]|0;O=p;M=c[O+4>>2]|0;if(L>>>0<M>>>0|((L|0)==(M|0)?(c[N>>2]|0)>>>0<(c[O>>2]|0)>>>0:0))break;t6(f);k=f+40|0;j=c[k>>2]|0;k=c[k+4>>2]|0;if((j|0)==-1&(k|0)==-1){V5(f);break}if(a[f+492>>0]|0)break;N=t;N=z0(c[f+548>>2]|0,0,c[N>>2]|0,c[N+4>>2]|0)|0;i=f+936|0;O=i;O=z0(N|0,z|0,c[O>>2]|0,c[O+4>>2]|0)|0;O=PZ(O|0,z|0,1)|0;N=z;if(!(N>>>0<k>>>0|(N|0)==(k|0)&O>>>0<j>>>0))break;if(!(+g[(c[f+24>>2]|0)+136>>2]<1.0))break;Kl(f);O=i;CI(f,c[O>>2]|0,c[O+4>>2]|0)}}else V5(f);while(0);return}function Vc(f){f=f|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;Q=l;l=l+48|0;P=Q+20|0;i=Q+16|0;M=Q+12|0;h=Q+39|0;N=Q+38|0;H=Q+37|0;k=Q+36|0;m=Q+35|0;j=Q+34|0;G=Q+33|0;I=Q+8|0;J=Q+4|0;K=Q+32|0;L=Q;O=f+828|0;c[O>>2]=(c[O>>2]|0)+1;c[i>>2]=0;c[M>>2]=0;GC(f);bB(f,h);F=a[h>>0]|0;y4(F&15,0,N);y4((F&255)>>>5&3,0,H);pY(F&255,0,7,G);if((a[G>>0]|0)!=0&(a[H>>0]|0)==0&(a[N>>0]|0)==2){bB(f,P);N=f+528|0;H=N;H=z0(c[H>>2]|0,c[H+4>>2]|0,1,0)|0;c[N>>2]=H;c[N+4>>2]=z}J3(f);GC(f);bB(f,h);E=a[h>>0]|0;N=f+887|0;pY(E&255,0,0,N);E=E&255;y4(E>>>1&3,0,k);y4(E>>>3&3,0,m);y4(E>>>5&3,0,j);bB(f,h);E=a[h>>0]|0;F=f+880|0;y4(E&3,0,F);E=E&255;G=f+881|0;y4(E>>>2&3,0,G);H=f+882|0;y4(E>>>4&3,0,H);y4(E>>>6,0,f+883|0);switch(a[j>>0]|0){case 1:{bB(f,P);c[i>>2]=d[P>>0];break}case 2:{HB(f,P);c[i>>2]=e[P>>1];break}case 3:{bD(f,i);break}default:{}}E=f+528|0;switch(a[k>>0]|0){case 1:{h=1;i=0;n=10;break}case 2:{h=2;i=0;n=10;break}case 3:{h=4;i=0;n=10;break}default:{}}if((n|0)==10){C=E;C=z0(c[C>>2]|0,c[C+4>>2]|0,h|0,i|0)|0;D=E;c[D>>2]=C;c[D+4>>2]=z}D=f+812|0;switch(a[m>>0]|0){case 1:{bB(f,P);c[D>>2]=d[P>>0];break}case 2:{HB(f,P);c[D>>2]=e[P>>1];break}case 3:{bD(f,D);break}default:c[D>>2]=0}r=E;r=z0(c[r>>2]|0,c[r+4>>2]|0,6,0)|0;q=E;c[q>>2]=r;c[q+4>>2]=z;J3(f);q=f+885|0;r=f+536|0;if(!(a[N>>0]|0)){C=r;p=E;p=D_(c[C>>2]|0,c[C+4>>2]|0,c[p>>2]|0,c[p+4>>2]|0)|0;p=D_(p|0,z|0,c[D>>2]|0,0)|0;c[M>>2]=p;a[q>>0]=1;p=f+884|0}else{GC(f);bB(f,P);C=a[P>>0]|0;y4(C&63,0,q);p=f+884|0;y4((C&255)>>>6,0,p);J3(f)}s=f+886|0;B=f+832|0;C=f+24|0;t=f+772|0;u=f+760|0;v=f+764|0;w=f+520|0;x=P+8+3|0;y=P+4|0;A=f+872|0;h=0;a:while(1){a[s>>0]=h;if((h&255)>=(d[q>>0]|0)){n=71;break}GC(f);c[I>>2]=0;c[J>>2]=0;bB(f,K);b[t>>1]=a[K>>0]&127;switch(a[H>>0]|0){case 1:{h=1;i=0;break}case 2:{h=2;i=0;break}case 3:{h=4;i=0;break}default:{n=24;break a}}o=E;h=z0(c[o>>2]|0,c[o+4>>2]|0,h|0,i|0)|0;i=z;o=E;c[o>>2]=h;c[o+4>>2]=i;switch(a[G>>0]|0){case 1:{j=1;k=0;break}case 2:{j=2;k=0;break}case 3:{j=4;k=0;break}default:{n=28;break a}}n=z0(j|0,k|0,h|0,i|0)|0;o=E;c[o>>2]=n;c[o+4>>2]=z;switch(a[F>>0]|0){case 1:{bB(f,P);h=d[P>>0]|0;c[I>>2]=h;break}case 2:{HB(f,P);h=e[P>>1]|0;c[I>>2]=h;break}case 3:{bD(f,I);h=c[I>>2]|0;break}default:{n=33;break a}}do if((h|0)!=0&(a[F>>0]|0)!=0){if(h>>>0<=7)if((h|0)==1){n=E;n=z0(c[n>>2]|0,c[n+4>>2]|0,1,0)|0;o=E;c[o>>2]=n;c[o+4>>2]=z;break}else{e1(f,h,0);break}bD(f,M);bD(f,L);if((h|0)!=8)Vp(f,h+-8|0);h=UD(u,b[t>>1]|0)|0;if((h|0)!=(v|0)?(c[h+36>>2]|0)==1:0)Qw(P,h+80|0,c[L>>2]|0,L)}while(0);b:do if(!(a[N>>0]|0)){i=r;h=E;h=D_(c[i>>2]|0,c[i+4>>2]|0,c[h>>2]|0,c[h+4>>2]|0)|0;i=z;j=c[D>>2]|0;if(i>>>0>0|(i|0)==0&h>>>0>j>>>0){k=D_(h|0,i|0,j|0,0)|0;c[J>>2]=k;break}else{t4(f);k=0;break}}else switch(a[p>>0]|0){case 1:{bB(f,P);k=d[P>>0]|0;c[J>>2]=k;break b}case 2:{HB(f,P);k=e[P>>1]|0;c[J>>2]=k;break b}case 3:{bD(f,J);k=c[J>>2]|0;break b}default:{n=50;break a}}while(0);n=E;n=z0(k|0,0,c[n>>2]|0,c[n+4>>2]|0)|0;n=z0(n|0,z|0,c[D>>2]|0,0)|0;j=z;o=r;m=c[o+4>>2]|0;do if(j>>>0>m>>>0|((j|0)==(m|0)?n>>>0>(c[o>>2]|0)>>>0:0))t4(f);else{m=w;c[m>>2]=e[t>>1];c[m+4>>2]=0;m=sF(u,t)|0;i=m+12|0;n=m+53|0;o=m+64|0;if((c[m>>2]|0)==0|(a[n>>0]|0)==0){e1(f,k,0);if(!((a[n>>0]|0)!=0&(c[i>>2]|0)==1&(c[o>>2]|0)>>>0>299))break;a[n>>0]=0;c[B>>2]=(c[B>>2]|0)+-1;break}h=c[M>>2]|0;if((h|0)==(k|0))j=1;else{j=c[A>>2]|0;j=((j|0)==0?h:j)-k|0;c[A>>2]=j;j=(j|0)==0&1}h=c[i>>2]|0;i=c[m+16>>2]|0;$x(P,f,h,i,Rb(h,0)|0,1);h=i9(30008)|0;i=a[x>>0]|0;if((h|0)==((i<<24>>24<0?c[y>>2]|0:i&255)|0))h=(VG(P,30008,h)|0)==0;else h=0;z5(P);i=c[m>>2]|0;if(h)a[i+768>>0]=j;iA(f,i,k);h=c[m>>2]|0;if(!(c[h+728>>2]&8)){if((c[o>>2]|0)>>>0<=299)break;if(!(+g[(c[C>>2]|0)+136>>2]<1.0))break}Kl(h);a[n>>0]=0;c[B>>2]=(c[B>>2]|0)+-1}while(0);J3(f);h=(a[s>>0]|0)+1<<24>>24}do if((n|0)==24){t4(f);n=69}else if((n|0)==28){t4(f);n=69}else if((n|0)==33){t4(f);n=69}else if((n|0)==50){t4(f);n=69}else if((n|0)==71){h=c[D>>2]|0;if(h|0)e1(f,h,0);if(c[B>>2]|0){if((c[O>>2]|0)>>>0<=999)break;if(!(+g[(c[C>>2]|0)+136>>2]<1.0))break}c[P>>2]=0;c[P+4>>2]=0;c[P+8>>2]=0;i=j9(380070)|0;if(i>>>0>4294967279)uaa();if(i>>>0<11){a[P+11>>0]=i;h=P}else{O=i+16&-16;h=ZW(O)|0;c[P>>2]=h;c[P+8>>2]=O|-2147483648;c[P+4>>2]=i}i1(h,380070,i)|0;J7(h+i|0,0);a1(P);P=f+864|0;I1(f,c[P>>2]|0,c[P+4>>2]|0)}while(0);l=Q;return}function Wc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;r=l;l=l+32|0;p=r;a:while(1){n=b;o=b+-32|0;while(1){b:while(1){m=a;e=n-m|0;f=e>>5;d=a+32|0;switch(f|0){case 1:case 0:break a;case 2:{q=5;break a}case 3:{q=7;break a}case 4:{q=8;break a}case 5:{q=9;break a}default:{}}if((e|0)<992){q=11;break a}k=a+(((f|0)/2|0)<<5)|0;if((e|0)>31968){e=(f|0)/4|0;e=Ff(a,a+(e<<5)|0,k,k+(e<<5)|0,o)|0}else e=Re(a,k,o)|0;j=a;i=c[j>>2]|0;j=c[j+4>>2]|0;h=k;g=c[h>>2]|0;h=c[h+4>>2]|0;if(M$(i,j,g,h)|0){f=o;break}else f=o;while(1){f=f+-32|0;if((a|0)==(f|0))break;s=f;if(M$(c[s>>2]|0,c[s+4>>2]|0,g,h)|0){q=28;break b}}s=o;if(!(M$(i,j,c[s>>2]|0,c[s+4>>2]|0)|0)){e=d;while(1){if((e|0)==(o|0))break a;s=e;d=e+32|0;if(M$(i,j,c[s>>2]|0,c[s+4>>2]|0)|0)break;else e=d}c[p>>2]=c[e>>2];c[p+4>>2]=c[e+4>>2];c[p+8>>2]=c[e+8>>2];c[p+12>>2]=c[e+12>>2];c[p+16>>2]=c[e+16>>2];c[p+20>>2]=c[e+20>>2];c[p+24>>2]=c[e+24>>2];c[p+28>>2]=c[e+28>>2];c[e>>2]=c[o>>2];c[e+4>>2]=c[o+4>>2];c[e+8>>2]=c[o+8>>2];c[e+12>>2]=c[o+12>>2];c[e+16>>2]=c[o+16>>2];c[e+20>>2]=c[o+20>>2];c[e+24>>2]=c[o+24>>2];c[e+28>>2]=c[o+28>>2];c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[o+12>>2]=c[p+12>>2];c[o+16>>2]=c[p+16>>2];c[o+20>>2]=c[p+20>>2];c[o+24>>2]=c[p+24>>2];c[o+28>>2]=c[p+28>>2]}if((d|0)==(o|0))break a;else e=o;while(1){h=a;g=c[h>>2]|0;h=c[h+4>>2]|0;while(1){s=d;f=d+32|0;if(M$(g,h,c[s>>2]|0,c[s+4>>2]|0)|0)break;else d=f}do{e=e+-32|0;s=e}while(M$(g,h,c[s>>2]|0,c[s+4>>2]|0)|0);if(d>>>0>=e>>>0){a=d;continue b}c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];c[p+12>>2]=c[d+12>>2];c[p+16>>2]=c[d+16>>2];c[p+20>>2]=c[d+20>>2];c[p+24>>2]=c[d+24>>2];c[p+28>>2]=c[d+28>>2];c[d>>2]=c[e>>2];c[d+4>>2]=c[e+4>>2];c[d+8>>2]=c[e+8>>2];c[d+12>>2]=c[e+12>>2];c[d+16>>2]=c[e+16>>2];c[d+20>>2]=c[e+20>>2];c[d+24>>2]=c[e+24>>2];c[d+28>>2]=c[e+28>>2];c[e>>2]=c[p>>2];c[e+4>>2]=c[p+4>>2];c[e+8>>2]=c[p+8>>2];c[e+12>>2]=c[p+12>>2];c[e+16>>2]=c[p+16>>2];c[e+20>>2]=c[p+20>>2];c[e+24>>2]=c[p+24>>2];c[e+28>>2]=c[p+28>>2];d=f}}if((q|0)==28){q=0;c[p>>2]=c[a>>2];c[p+4>>2]=c[a+4>>2];c[p+8>>2]=c[a+8>>2];c[p+12>>2]=c[a+12>>2];c[p+16>>2]=c[a+16>>2];c[p+20>>2]=c[a+20>>2];c[p+24>>2]=c[a+24>>2];c[p+28>>2]=c[a+28>>2];c[a>>2]=c[f>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];c[a+12>>2]=c[f+12>>2];c[a+16>>2]=c[f+16>>2];c[a+20>>2]=c[f+20>>2];c[a+24>>2]=c[f+24>>2];c[a+28>>2]=c[f+28>>2];c[f>>2]=c[p>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];c[f+16>>2]=c[p+16>>2];c[f+20>>2]=c[p+20>>2];c[f+24>>2]=c[p+24>>2];c[f+28>>2]=c[p+28>>2];e=e+1|0}c:do if(d>>>0<f>>>0){j=k;while(1){i=j;h=c[i>>2]|0;i=c[i+4>>2]|0;while(1){s=d;g=d+32|0;if(M$(c[s>>2]|0,c[s+4>>2]|0,h,i)|0)d=g;else break}do{f=f+-32|0;s=f}while(!(M$(c[s>>2]|0,c[s+4>>2]|0,h,i)|0));if(d>>>0>f>>>0){f=j;break c}c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];c[p+12>>2]=c[d+12>>2];c[p+16>>2]=c[d+16>>2];c[p+20>>2]=c[d+20>>2];c[p+24>>2]=c[d+24>>2];c[p+28>>2]=c[d+28>>2];c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];c[d+28>>2]=c[f+28>>2];c[f>>2]=c[p>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];c[f+16>>2]=c[p+16>>2];c[f+20>>2]=c[p+20>>2];c[f+24>>2]=c[p+24>>2];c[f+28>>2]=c[p+28>>2];j=(j|0)==(d|0)?f:j;d=g;e=e+1|0}}else f=k;while(0);if((d|0)!=(f|0)?(k=f,s=d,M$(c[k>>2]|0,c[k+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0):0){c[p>>2]=c[d>>2];c[p+4>>2]=c[d+4>>2];c[p+8>>2]=c[d+8>>2];c[p+12>>2]=c[d+12>>2];c[p+16>>2]=c[d+16>>2];c[p+20>>2]=c[d+20>>2];c[p+24>>2]=c[d+24>>2];c[p+28>>2]=c[d+28>>2];c[d>>2]=c[f>>2];c[d+4>>2]=c[f+4>>2];c[d+8>>2]=c[f+8>>2];c[d+12>>2]=c[f+12>>2];c[d+16>>2]=c[f+16>>2];c[d+20>>2]=c[f+20>>2];c[d+24>>2]=c[f+24>>2];c[d+28>>2]=c[f+28>>2];c[f>>2]=c[p>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];c[f+16>>2]=c[p+16>>2];c[f+20>>2]=c[p+20>>2];c[f+24>>2]=c[p+24>>2];c[f+28>>2]=c[p+28>>2];e=e+1|0}if(!e){e=bh(a,d)|0;f=d+32|0;if(bh(f,b)|0){q=44;break}if(e){a=f;continue}}s=d;if((s-m|0)>=(n-s|0)){q=43;break}Wc(a,d);a=d+32|0}if((q|0)==43){q=0;Wc(d+32|0,b);b=d;continue}else if((q|0)==44){q=0;if(e)break;else{b=d;continue}}}if((q|0)==5){q=o;s=a;if(M$(c[q>>2]|0,c[q+4>>2]|0,c[s>>2]|0,c[s+4>>2]|0)|0){c[p>>2]=c[a>>2];c[p+4>>2]=c[a+4>>2];c[p+8>>2]=c[a+8>>2];c[p+12>>2]=c[a+12>>2];c[p+16>>2]=c[a+16>>2];c[p+20>>2]=c[a+20>>2];c[p+24>>2]=c[a+24>>2];c[p+28>>2]=c[a+28>>2];c[a>>2]=c[o>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];c[a+12>>2]=c[o+12>>2];c[a+16>>2]=c[o+16>>2];c[a+20>>2]=c[o+20>>2];c[a+24>>2]=c[o+24>>2];c[a+28>>2]=c[o+28>>2];c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[o+12>>2]=c[p+12>>2];c[o+16>>2]=c[p+16>>2];c[o+20>>2]=c[p+20>>2];c[o+24>>2]=c[p+24>>2];c[o+28>>2]=c[p+28>>2]}}else if((q|0)==7)Re(a,d,o)|0;else if((q|0)==8)oh(a,d,a+64|0,o)|0;else if((q|0)==9)Ff(a,d,a+64|0,a+96|0,o)|0;else if((q|0)==11)Km(a,b);l=r;return}function Xc(b,d){b=b|0;d=d|0;var e=0,f=0.0,g=0,h=0,i=0.0,j=0,k=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0;C=l;l=l+80|0;t=C+40|0;y=C+24|0;A=C+12|0;B=C;$x(t,b,2,d,122,1);m=a[t+8+3>>0]|0;m=((m<<24>>24<0?c[t+4>>2]|0:m&255)|0)==0;z5(t);if(m){$x(t,b,2,d,46,1);e=i9(9644)|0;j=t+8+3|0;h=a[j>>0]|0;m=t+4|0;g=c[m>>2]|0;if((e|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,9644,e)|0))k=13;else{h=a[j>>0]|0;g=c[m>>2]|0;k=5}else k=5;do if((k|0)==5){e=i9(9664)|0;if((e|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(t,9664,e)|0)){k=13;break}h=a[j>>0]|0;g=c[m>>2]|0}e=i9(9684)|0;if((e|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(t,9684,e)|0)){k=13;break}h=a[j>>0]|0;g=c[m>>2]|0}e=i9(9704)|0;if((e|0)==((h<<24>>24<0?g:h&255)|0)?(VG(t,9704,e)|0)==0:0)k=13}while(0);if((k|0)==13)sM(b,2,d,122,1,0);z5(t)}$x(t,b,2,d,137,1);m=a[t+8+3>>0]|0;m=((m<<24>>24<0?c[t+4>>2]|0:m&255)|0)==0;z5(t);if(m){$x(t,b,2,d,68,1);e=tm(t)|0;g=z;z5(t);if((e|0)==0&(g|0)==0){$x(t,b,0,0,92,1);e=tm(t)|0;g=z;z5(t)}$x(t,b,2,d,135,1);f=+Cq(t);z5(t);if(((e|0)!=0|(g|0)!=0)&f!=0.0)KW(b,2,d,137,(+(e>>>0)+4294967296.0*+(g|0))/1.0e3*f,0,0)}$x(t,b,2,d,143,1);m=a[t+8+3>>0]|0;do if(!((m<<24>>24<0?c[t+4>>2]|0:m&255)|0)){e=b+360|0;m=e;if((c[m>>2]|0)==-1?(c[m+4>>2]|0)==-1:0){z5(t);break}k=b+48|0;k=z0(c[b+548>>2]|0,0,c[k>>2]|0,c[k+4>>2]|0)|0;m=b+40|0;m=(k|0)==(c[m>>2]|0)?(z|0)==(c[m+4>>2]|0):0;z5(t);if((m?(RA(b,1,-1)|0)==0:0)?(RA(b,2,-1)|0)==1:0){m=e;oK(b,2,0,143,c[m>>2]|0,c[m+4>>2]|0,10,0)}}else z5(t);while(0);$x(t,b,2,d,135,1);f=+Eq(t);$x(y,b,2,d,139,1);m=f==+Eq(y);z5(y);z5(t);if(m)Ed(b,2,d,139);$x(t,b,2,d,135,1);m=a[t+8+3>>0]|0;m=((m<<24>>24<0?c[t+4>>2]|0:m&255)|0)==0;z5(t);if(m?($x(t,b,2,d,147,1),i=+Eq(t),z5(t),$x(t,b,2,d,122,1),n=+Eq(t),z5(t),$x(t,b,2,d,112,1),o=+Eq(t),z5(t),i!=0.0&n!=0.0&o!=0.0):0)KW(b,2,d,135,o/n/i,0,0);$x(t,b,2,d,134,1);m=a[t+8+3>>0]|0;m=((m<<24>>24<0?c[t+4>>2]|0:m&255)|0)==0;z5(t);if(m){$x(t,b,2,d,139,1);i=+Eq(t);z5(t);mI(t);VU(y,357786);z3(t,y);z5(y);$x(y,b,2,d,135,1);og(t,y);z5(y);h=t+4|0;f=0.0;g=0;while(1){e=c[t>>2]|0;if(g>>>0>=(((c[h>>2]|0)-e|0)/12|0)>>>0)break;f=+Eq(e+(g*12|0)|0);if(f!=0.0)break;else g=g+1|0}if(i!=f&(i!=0.0&f!=0.0)){f=f/i;TX(y);do if(!(f>1601.0&f<1602.0))if(f>800.0&f<801.0){Xy(A,9752);vF(y,A)|0;z5(A);break}else{io(y,f,0)|0;break}else{Xy(A,9724);vF(y,A)|0;z5(A)}while(0);zb(b,2,d,134,y,0);z5(y)}$_(t)}$x(t,b,2,d,68,1);m=a[t+8+3>>0]|0;if(!((m<<24>>24<0?c[t+4>>2]|0:m&255)|0)){$x(y,b,2,d,135,1);m=rm(y)|0;m=(m|0)==0&(z|0)==0;z5(y);z5(t);if(!m?($x(t,b,2,d,137,1),p=rm(t)|0,p=UW(p|0,z|0,1e3,0)|0,q=z,$x(y,b,2,d,135,1),r=rm(y)|0,s=z,z5(y),z5(t),!(s>>>0>q>>>0|(s|0)==(q|0)&r>>>0>p>>>0)):0){s=g5(p|0,q|0,r|0,s|0)|0;oK(b,2,d,68,s,z,10,0)}}else z5(t);$x(t,b,2,d,194,1);s=a[t+8+3>>0]|0;do if(!((s<<24>>24<0?c[t+4>>2]|0:s&255)|0)){$x(y,b,2,d,112,1);s=a[y+8+3>>0]|0;if(!((s<<24>>24<0?c[y+4>>2]|0:s&255)|0)){z5(y);z5(t);break}$x(A,b,2,d,68,1);s=a[A+8+3>>0]|0;if(!((s<<24>>24<0?c[A+4>>2]|0:s&255)|0)){z5(A);z5(y);z5(t);break}$x(B,b,2,d,110,1);e=i9(40152)|0;s=a[B+8+3>>0]|0;if((e|0)!=((s<<24>>24<0?c[B+4>>2]|0:s&255)|0)){z5(B);z5(A);z5(y);z5(t);break}s=(VG(B,40152,e)|0)==0;z5(B);z5(A);z5(y);z5(t);if(s?($x(t,b,2,d,68,1),u=rm(t)|0,v=z,z5(t),$x(t,b,2,d,112,1),w=rm(t)|0,x=z,z5(t),((u|0)!=0|(v|0)!=0)&((w|0)!=0|(x|0)!=0)):0){B=UW(w|0,x|0,u|0,v|0)|0;B=g5(B|0,z|0,8e3,0)|0;oK(b,2,d,194,B,z,10,0)}}else z5(t);while(0);$x(t,b,2,d,110,1);B=a[t+8+3>>0]|0;if(!((B<<24>>24<0?c[t+4>>2]|0:B&255)|0)){$x(y,b,2,d,52,1);B=a[y+8+3>>0]|0;B=((B<<24>>24<0?c[y+4>>2]|0:B&255)|0)==0;z5(y);z5(t);if(!B){$x(y,b,2,d,52,1);p2(t,po(y,5,2)|0);z5(y);B=a[t+8+3>>0]|0;if((B<<24>>24<0?c[t+4>>2]|0:B&255)|0)zb(b,2,d,110,t,0);z5(t)}}else z5(t);l=C;return}function Yc(b,e,f,g,h,i){b=b|0;e=+e;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=l;l=l+560|0;m=H+8|0;u=H;G=H+524|0;F=G;n=H+512|0;c[u>>2]=0;E=n+12|0;d0(e)|0;if((z|0)<0){e=-e;C=1;B=393174}else{C=(h&2049|0)!=0&1;B=(h&2048|0)==0?((h&1|0)==0?393175:393180):393177}d0(e)|0;D=z&2146435072;do if(D>>>0<2146435072|(D|0)==2146435072&0<0){r=+O9(e,u)*2.0;j=r!=0.0;if(j)c[u>>2]=(c[u>>2]|0)+-1;w=i|32;if((w|0)==97){s=i&32;q=(s|0)==0?B:B+9|0;p=C|2;j=12-g|0;do if(!(g>>>0>11|(j|0)==0)){e=8.0;do{j=j+-1|0;e=e*16.0}while((j|0)!=0);if((a[q>>0]|0)==45){e=-(e+(-r-e));break}else{e=r+e-e;break}}else e=r;while(0);k=c[u>>2]|0;j=(k|0)<0?0-k|0:k;j=sE(j,((j|0)<0)<<31>>31,E)|0;if((j|0)==(E|0)){j=n+11|0;a[j>>0]=48}a[j+-1>>0]=(k>>31&2)+43;o=j+-2|0;a[o>>0]=i+15;n=(g|0)<1;m=(h&8|0)==0;j=G;do{D=~~e;k=j+1|0;a[j>>0]=d[393205+D>>0]|s;e=(e-+(D|0))*16.0;if((k-F|0)==1?!(m&(n&e==0.0)):0){a[k>>0]=46;j=j+2|0}else j=k}while(e!=0.0);D=j-F|0;F=E-o|0;E=(g|0)!=0&(D+-2|0)<(g|0)?g+2|0:D;j=F+p+E|0;dK(b,32,f,j,h);_3(b,q,p);dK(b,48,f,j,h^65536);_3(b,G,D);dK(b,48,E-D|0,0,0);_3(b,o,F);dK(b,32,f,j,h^8192);break}k=(g|0)<0?6:g;if(j){j=(c[u>>2]|0)+-28|0;c[u>>2]=j;e=r*268435456.0}else{e=r;j=c[u>>2]|0}D=(j|0)<0?m:m+288|0;m=D;do{y=~~e>>>0;c[m>>2]=y;m=m+4|0;e=(e-+(y>>>0))*1.0e9}while(e!=0.0);if((j|0)>0){n=D;p=m;while(1){o=(j|0)<29?j:29;j=p+-4|0;if(j>>>0>=n>>>0){m=0;do{x=PZ(c[j>>2]|0,0,o|0)|0;x=z0(x|0,z|0,m|0,0)|0;y=z;v=nW(x|0,y|0,1e9,0)|0;c[j>>2]=v;m=g5(x|0,y|0,1e9,0)|0;j=j+-4|0}while(j>>>0>=n>>>0);if(m){n=n+-4|0;c[n>>2]=m}}m=p;while(1){if(m>>>0<=n>>>0)break;j=m+-4|0;if(!(c[j>>2]|0))m=j;else break}j=(c[u>>2]|0)-o|0;c[u>>2]=j;if((j|0)>0)p=m;else break}}else n=D;if((j|0)<0){g=((k+25|0)/9|0)+1|0;t=(w|0)==102;do{s=0-j|0;s=(s|0)<9?s:9;if(n>>>0<m>>>0){o=(1<<s)+-1|0;p=1e9>>>s;q=0;j=n;do{y=c[j>>2]|0;c[j>>2]=(y>>>s)+q;q=O(y&o,p)|0;j=j+4|0}while(j>>>0<m>>>0);j=(c[n>>2]|0)==0?n+4|0:n;if(!q){n=j;j=m}else{c[m>>2]=q;n=j;j=m+4|0}}else{n=(c[n>>2]|0)==0?n+4|0:n;j=m}m=t?D:n;m=(j-m>>2|0)>(g|0)?m+(g<<2)|0:j;j=(c[u>>2]|0)+s|0;c[u>>2]=j}while((j|0)<0);j=n;g=m}else{j=n;g=m}y=D;if(j>>>0<g>>>0){m=(y-j>>2)*9|0;o=c[j>>2]|0;if(o>>>0>=10){n=10;do{n=n*10|0;m=m+1|0}while(o>>>0>=n>>>0)}}else m=0;t=(w|0)==103;v=(k|0)!=0;n=k-((w|0)!=102?m:0)+((v&t)<<31>>31)|0;if((n|0)<(((g-y>>2)*9|0)+-9|0)){n=n+9216|0;s=D+4+(((n|0)/9|0)+-1024<<2)|0;n=((n|0)%9|0)+1|0;if((n|0)<9){o=10;do{o=o*10|0;n=n+1|0}while((n|0)!=9)}else o=10;p=c[s>>2]|0;q=(p>>>0)%(o>>>0)|0;n=(s+4|0)==(g|0);if(!(n&(q|0)==0)){r=(((p>>>0)/(o>>>0)|0)&1|0)==0?9007199254740992.0:9007199254740994.0;x=(o|0)/2|0;e=q>>>0<x>>>0?.5:n&(q|0)==(x|0)?1.0:1.5;if(C){x=(a[B>>0]|0)==45;e=x?-e:e;r=x?-r:r}n=p-q|0;c[s>>2]=n;if(r+e!=r){x=n+o|0;c[s>>2]=x;if(x>>>0>999999999){m=s;while(1){n=m+-4|0;c[m>>2]=0;if(n>>>0<j>>>0){j=j+-4|0;c[j>>2]=0}x=(c[n>>2]|0)+1|0;c[n>>2]=x;if(x>>>0>999999999)m=n;else break}}else n=s;m=(y-j>>2)*9|0;p=c[j>>2]|0;if(p>>>0>=10){o=10;do{o=o*10|0;m=m+1|0}while(p>>>0>=o>>>0)}}else n=s}else n=s;n=n+4|0;n=g>>>0>n>>>0?n:g;x=j}else{n=g;x=j}w=n;while(1){if(w>>>0<=x>>>0){u=0;break}j=w+-4|0;if(!(c[j>>2]|0))w=j;else{u=1;break}}g=0-m|0;j=h&8;do if(t){v=((v^1)&1)+k|0;k=(v|0)>(m|0)&(m|0)>-5;o=(k?-1:-2)+i|0;k=v+-1+(k?g:0)|0;if(!j){if(u?(A=c[w+-4>>2]|0,(A|0)!=0):0)if(!((A>>>0)%10|0)){n=0;j=10;do{j=j*10|0;n=n+1|0}while(!((A>>>0)%(j>>>0)|0|0))}else n=0;else n=9;j=((w-y>>2)*9|0)+-9|0;if((o|32|0)==102){s=j-n|0;s=(s|0)>0?s:0;k=(k|0)<(s|0)?k:s;s=0;break}else{s=j+m-n|0;s=(s|0)>0?s:0;k=(k|0)<(s|0)?k:s;s=0;break}}else s=j}else{o=i;s=j}while(0);t=k|s;p=(t|0)!=0&1;q=(o|32|0)==102;if(q){v=0;j=(m|0)>0?m:0}else{j=(m|0)<0?g:m;j=sE(j,((j|0)<0)<<31>>31,E)|0;n=E;if((n-j|0)<2)do{j=j+-1|0;a[j>>0]=48}while((n-j|0)<2);a[j+-1>>0]=(m>>31&2)+43;j=j+-2|0;a[j>>0]=o;v=j;j=n-j|0}j=C+1+k+p+j|0;dK(b,32,f,j,h);_3(b,B,C);dK(b,48,f,j,h^65536);if(q){o=x>>>0>D>>>0?D:x;s=G+9|0;p=s;q=G+8|0;n=o;do{m=sE(c[n>>2]|0,0,s)|0;if((n|0)==(o|0)){if((m|0)==(s|0)){a[q>>0]=48;m=q}}else if(m>>>0>G>>>0){Ow(G|0,48,m-F|0)|0;do m=m+-1|0;while(m>>>0>G>>>0)}_3(b,m,p-m|0);n=n+4|0}while(n>>>0<=D>>>0);if(t|0)_3(b,404781,1);if((k|0)>0&n>>>0<w>>>0)while(1){m=sE(c[n>>2]|0,0,s)|0;if(m>>>0>G>>>0){Ow(G|0,48,m-F|0)|0;do m=m+-1|0;while(m>>>0>G>>>0)}_3(b,m,(k|0)<9?k:9);n=n+4|0;m=k+-9|0;if(!((k|0)>9&n>>>0<w>>>0)){k=m;break}else k=m}dK(b,48,k+9|0,9,0)}else{t=u?w:x+4|0;if((k|0)>-1){u=G+9|0;s=(s|0)==0;g=u;p=0-F|0;q=G+8|0;o=x;do{m=sE(c[o>>2]|0,0,u)|0;if((m|0)==(u|0)){a[q>>0]=48;m=q}do if((o|0)==(x|0)){n=m+1|0;_3(b,m,1);if(s&(k|0)<1){m=n;break}_3(b,404781,1);m=n}else{if(m>>>0<=G>>>0)break;Ow(G|0,48,m+p|0)|0;do m=m+-1|0;while(m>>>0>G>>>0)}while(0);F=g-m|0;_3(b,m,(k|0)>(F|0)?F:k);k=k-F|0;o=o+4|0}while(o>>>0<t>>>0&(k|0)>-1)}dK(b,48,k+18|0,18,0);_3(b,v,E-v|0)}dK(b,32,f,j,h^8192)}else{G=(i&32|0)!=0;j=C+3|0;dK(b,32,f,j,h&-65537);_3(b,B,C);_3(b,e!=e|0.0!=0.0?(G?401339:393201):G?393193:393197,3);dK(b,32,f,j,h^8192)}while(0);l=H;return ((j|0)<(f|0)?f:j)|0}function Zc(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;w=l;l=l+48|0;i=w+32|0;n=w+24|0;o=w+16|0;r=w+8|0;s=w;f=c[e+508>>2]|0;g=c[e+668>>2]|0;if(k2(f,g)|0){m=e+840|0;q3(e,m);m=kE(e+760|0,m)|0;k=m+44|0;c[k>>2]=(c[k>>2]|0)+1;k=m+64|0;u=e+1080|0;p=e+528|0;j=m+65|0;q=e+536|0;t=e+1088|0;v=e+1084|0;if((a[j>>0]|a[k>>0])<<24>>24==0?(a[m+66>>0]|0)==0:0){g=q;f=p;f=D_(c[g>>2]|0,c[g+4>>2]|0,c[f>>2]|0,c[f+4>>2]|0)|0;g=z;h=i;c[h>>2]=f;c[h+4>>2]=g;h=c[v>>2]|0;if(h>>>0<(c[t>>2]|0)>>>0){t=h;c[t>>2]=f;c[t+4>>2]=g;c[v>>2]=h+8}else Px(u,i)}else{NB(e,i);f=b[i>>1]|0;if(qO(e)|0){i=e+872|0;y=i;f=f<<16>>16;g=((f|0)<0)<<31>>31;y=z0(c[y>>2]|0,c[y+4>>2]|0,f|0,g|0)|0;B=z;h=m+16|0;x=h;A=c[x+4>>2]|0;if(B>>>0<A>>>0|((B|0)==(A|0)?y>>>0<(c[x>>2]|0)>>>0:0)?qO(e)|0:0){A=i;A=z0(c[A>>2]|0,c[A+4>>2]|0,f|0,g|0)|0;B=h;c[B>>2]=A;c[B+4>>2]=z}if(a[j>>0]|0){h=i;f=z0(c[h>>2]|0,c[h+4>>2]|0,f|0,g|0)|0;g=z;h=n;c[h>>2]=f;c[h+4>>2]=g;h=m+4|0;i=c[h>>2]|0;if(i>>>0<(c[m+8>>2]|0)>>>0){B=i;c[B>>2]=f;c[B+4>>2]=g;f=i+8|0;c[h>>2]=f}else{Px(m,n);f=c[h>>2]|0}if(f-(c[m>>2]|0)>>3>>>0>128)a[j>>0]=0}f=e+1064|0;B=f;if(!((c[B>>2]|0)==-1?(c[B+4>>2]|0)==-1:0)){B=GG(m+112|0,f)|0;A=B;A=z0(c[A>>2]|0,c[A+4>>2]|0,1,0)|0;c[B>>2]=A;c[B+4>>2]=z;B=f;c[B>>2]=-1;c[B+4>>2]=-1}}if(!(a[k>>0]|0)){g=q;f=p;f=D_(c[g>>2]|0,c[g+4>>2]|0,c[f>>2]|0,c[f+4>>2]|0)|0;g=z;h=n;c[h>>2]=f;c[h+4>>2]=g;h=c[v>>2]|0;if(h>>>0<(c[t>>2]|0)>>>0){B=h;c[B>>2]=f;c[B+4>>2]=g;c[v>>2]=h+8}else Px(u,n)}else{GC(e);Bx(e);f=e+648|0;G4(c[f>>2]|0,1);G4(c[f>>2]|0,3);G4(c[f>>2]|0,1);rR(e,2,n);G4(c[f>>2]|0,1);wK(e);J3(e);f=c[n>>2]|0;if(!f){g=q;f=p;f=D_(c[g>>2]|0,c[g+4>>2]|0,c[f>>2]|0,c[f+4>>2]|0)|0;g=z;h=o;c[h>>2]=f;c[h+4>>2]=g;h=c[v>>2]|0;if(h>>>0<(c[t>>2]|0)>>>0){B=h;c[B>>2]=f;c[B+4>>2]=g;c[v>>2]=h+8}else Px(u,o)}else{GC(e);bB(e,o);a:do switch(f|0){case 1:{k=a[o>>0]|0;j=0;f=0;g=0;while(1){if((j&255)>=(k&255))break;i=0;do{bB(e,r);B=a[r>>0]|0;i=(B&255)+i|0}while(B<<24>>24==-1);f=z0(i|0,0,f|0,g|0)|0;h=z;g=s;c[g>>2]=i;c[g+4>>2]=0;g=c[v>>2]|0;if(g>>>0<(c[t>>2]|0)>>>0){B=g;c[B>>2]=i;c[B+4>>2]=0;c[v>>2]=g+8}else Px(u,s);j=j+1<<24>>24;g=h}i=p;j=c[i>>2]|0;i=c[i+4>>2]|0;A=z0(j|0,i|0,f|0,g|0)|0;x=z;y=q;B=c[y>>2]|0;y=c[y+4>>2]|0;i=D_(B|0,y|0,j|0,i|0)|0;j=z;k=c[t>>2]|0;h=c[v>>2]|0;if(!(x>>>0>y>>>0|(x|0)==(y|0)&A>>>0>B>>>0)){f=D_(i|0,j|0,f|0,g|0)|0;g=z;B=r;c[B>>2]=f;c[B+4>>2]=g;if(h>>>0<k>>>0){B=h;c[B>>2]=f;c[B+4>>2]=g;c[v>>2]=h+8}else Px(u,r);break a}g=c[u>>2]|0;f=h;while(1){if((f|0)==(g|0))break;B=f+-8|0;c[v>>2]=B;f=B}B=r;c[B>>2]=i;c[B+4>>2]=j;if(g>>>0<k>>>0){B=g;c[B>>2]=i;c[B+4>>2]=j;c[v>>2]=g+8}else Px(u,r);break}case 2:{B=q;y=p;y=D_(c[B>>2]|0,c[B+4>>2]|0,c[y>>2]|0,c[y+4>>2]|0)|0;B=(d[o>>0]|0)+1|0;y=g5(y|0,z|0,B|0,0)|0;A=r;c[A>>2]=y;c[A+4>>2]=z;KH(u,B,r);break}case 3:{q3(e,r);f=c[v>>2]|0;if((f|0)==(c[t>>2]|0)){Px(u,r);i=r;f=c[i>>2]|0;i=c[i+4>>2]|0}else{i=r;B=c[i>>2]|0;i=c[i+4>>2]|0;A=f;c[A>>2]=B;c[A+4>>2]=i;c[v>>2]=f+8;f=B}m=a[o>>0]|0;k=1;g=f;n=i;h=f;f=i;while(1){if((k&255)>=(m&255))break;p3(e,s);j=s;j=z0(h|0,f|0,c[j>>2]|0,c[j+4>>2]|0)|0;f=z;i=r;c[i>>2]=j;c[i+4>>2]=f;g=z0(j|0,f|0,g|0,n|0)|0;i=z;h=c[v>>2]|0;if((h|0)==(c[t>>2]|0))Px(u,r);else{B=h;c[B>>2]=j;c[B+4>>2]=f;c[v>>2]=h+8}k=k+1<<24>>24;n=i;h=j}i=p;j=c[i>>2]|0;i=c[i+4>>2]|0;A=z0(j|0,i|0,g|0,n|0)|0;x=z;y=q;B=c[y>>2]|0;y=c[y+4>>2]|0;i=D_(B|0,y|0,j|0,i|0)|0;j=z;k=c[t>>2]|0;h=c[v>>2]|0;if(x>>>0>y>>>0|(x|0)==(y|0)&A>>>0>B>>>0){g=c[u>>2]|0;f=h;while(1){if((f|0)==(g|0))break;B=f+-8|0;c[v>>2]=B;f=B}B=s;c[B>>2]=i;c[B+4>>2]=j;if(g>>>0<k>>>0){B=g;c[B>>2]=i;c[B+4>>2]=j;c[v>>2]=g+8}else Px(u,s)}else{f=D_(i|0,j|0,g|0,n|0)|0;g=z;B=s;c[B>>2]=f;c[B+4>>2]=g;if(h>>>0<k>>>0){B=h;c[B>>2]=f;c[B+4>>2]=g;c[v>>2]=h+8}else Px(u,s)}break}default:{}}while(0);J3(e)}}}if(((c[v>>2]|0)-(c[u>>2]|0)|0)==8){GC(e);Le(e);J3(e)}}else c3(f,g);l=w;return}function _c(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+16|0;g=n+12|0;m=n;GC(b);k=b+648|0;G4(c[k>>2]|0,12);AT(b,g);G4(c[k>>2]|0,2);AT(b,b+2480|0);h=b+2462|0;xR(b,2,h);a[h>>0]=(a[h>>0]|0)+1<<24>>24;i=b+2468|0;xR(b,4,i);j=b+112|0;c[j>>2]=c[11828+(d[i>>0]<<2)>>2];c[j+4>>2]=0;A6(c[k>>2]|0);j=b+2464|0;xR(b,3,j);A6(c[k>>2]|0);A6(c[k>>2]|0);J3(b);do if(qO(b)|0){k=b+22136|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(384476)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{o=f+16&-16;e=ZW(o)|0;c[m>>2]=e;c[m+8>>2]=o|-2147483648;c[m+4>>2]=f}i1(e,384476,f)|0;J7(e+f|0,0);f=VC(k,m)|0;o=a[f+8+3>>0]|0;o=((o<<24>>24<0?c[f+4>>2]|0:o&255)|0)==0;a1(m);if(o){c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(384476)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{o=f+16&-16;e=ZW(o)|0;c[m>>2]=e;c[m+8>>2]=o|-2147483648;c[m+4>>2]=f}i1(e,384476,f)|0;J7(e+f|0,0);cC(VC(b+22124|0,m)|0,370822)|0;a1(m);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(384476)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{o=f+16&-16;e=ZW(o)|0;c[m>>2]=e;c[m+8>>2]=o|-2147483648;c[m+4>>2]=f}i1(e,384476,f)|0;J7(e+f|0,0);cC(VC(k,m)|0,391425)|0;a1(m);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(387815)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{o=f+16&-16;e=ZW(o)|0;c[m>>2]=e;c[m+8>>2]=o|-2147483648;c[m+4>>2]=f}i1(e,387815,f)|0;J7(e+f|0,0);f=VC(k,m)|0;cC(f,a[g>>0]|0?382769:373744)|0;a1(m);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{o=f+16&-16;e=ZW(o)|0;c[m>>2]=e;c[m+8>>2]=o|-2147483648;c[m+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);f=VC(k,m)|0;cC(f,YN(a[h>>0]|0)|0)|0;a1(m);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(385582)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{o=f+16&-16;e=ZW(o)|0;c[m>>2]=e;c[m+8>>2]=o|-2147483648;c[m+4>>2]=f}i1(e,385582,f)|0;J7(e+f|0,0);f=VC(k,m)|0;cC(f,yn(a[h>>0]|0)|0)|0;a1(m);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{o=f+16&-16;e=ZW(o)|0;c[m>>2]=e;c[m+8>>2]=o|-2147483648;c[m+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);f=VC(k,m)|0;Gk(f,c[11828+(d[i>>0]<<2)>>2]|0,10)|0;a1(m);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(384542)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{o=f+16&-16;e=ZW(o)|0;c[m>>2]=e;c[m+8>>2]=o|-2147483648;c[m+4>>2]=f}i1(e,384542,f)|0;J7(e+f|0,0);f=VC(k,m)|0;Ck(f,a[j>>0]|0,10)|0;a1(m);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(370675)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{o=f+16&-16;e=ZW(o)|0;c[m>>2]=e;c[m+8>>2]=o|-2147483648;c[m+4>>2]=f}i1(e,370675,f)|0;J7(e+f|0,0);f=VC(k,m)|0;cC(f,c[11880+(d[j>>0]<<2)>>2]|0)|0;a1(m);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(370692)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{o=f+16&-16;e=ZW(o)|0;c[m>>2]=e;c[m+8>>2]=o|-2147483648;c[m+4>>2]=f}i1(e,370692,f)|0;J7(e+f|0,0);f=VC(k,m)|0;cC(f,c[11944+(d[j>>0]<<2)>>2]|0)|0;a1(m);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(370717)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{o=f+16&-16;e=ZW(o)|0;c[m>>2]=e;c[m+8>>2]=o|-2147483648;c[m+4>>2]=f}i1(e,370717,f)|0;J7(e+f|0,0);o=VC(k,m)|0;cC(o,c[12008+(d[j>>0]<<2)>>2]|0)|0;a1(m);if(!(a[b+492>>0]|0))break;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(382758)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{o=f+16&-16;e=ZW(o)|0;c[m>>2]=e;c[m+8>>2]=o|-2147483648;c[m+4>>2]=f}i1(e,382758,f)|0;J7(e+f|0,0);cC(VC(k,m)|0,370822)|0;a1(m)}}while(0);l=n;return}function $c(b,d,f){b=b|0;d=d|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=l;l=l+320|0;E=M+292|0;D=M+288|0;h=M+304|0;i=M+296|0;J=M+276|0;K=M+264|0;L=M+252|0;F=M+240|0;G=M+228|0;H=M+216|0;I=M+204|0;m=M+192|0;n=M+180|0;o=M+168|0;p=M+156|0;q=M+144|0;r=M+132|0;s=M+120|0;t=M+108|0;u=M+96|0;v=M+84|0;w=M+72|0;x=M+60|0;y=M+48|0;z=M+36|0;A=M+24|0;B=M+12|0;C=M;g=0;while(1){if((g|0)==3)break;NB(b,h+(g<<1)|0);NB(b,i+(g<<1)|0);g=g+1|0}j=h+6|0;NB(b,j);k=i+6|0;NB(b,k);ID(b,E);ID(b,D);b=a[d+8+3>>0]|0;if(!((b<<24>>24<0?c[d+4>>2]|0:b&255)|0)){ST(v,+(e[h+4>>1]|0)/5.0e4,6);DW(v,0,5808)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}HX(u,5832)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}ST(w,+(e[i+4>>1]|0)/5.0e4,6);g=a[w+8+3>>0]|0;b=g<<24>>24<0;Ex(t,b?c[w>>2]|0:w,b?c[w+4>>2]|0:g&255)|0;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];g=0;while(1){if((g|0)==3)break;c[t+(g<<2)>>2]=0;g=g+1|0}HX(s,5848)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];g=0;while(1){if((g|0)==3)break;c[s+(g<<2)>>2]=0;g=g+1|0}ST(x,+(e[h>>1]|0)/5.0e4,6);g=a[x+8+3>>0]|0;b=g<<24>>24<0;Ex(r,b?c[x>>2]|0:x,b?c[x+4>>2]|0:g&255)|0;c[q>>2]=c[r>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];g=0;while(1){if((g|0)==3)break;c[r+(g<<2)>>2]=0;g=g+1|0}HX(q,5832)|0;c[p>>2]=c[q>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];g=0;while(1){if((g|0)==3)break;c[q+(g<<2)>>2]=0;g=g+1|0}ST(y,+(e[i>>1]|0)/5.0e4,6);g=a[y+8+3>>0]|0;b=g<<24>>24<0;Ex(p,b?c[y>>2]|0:y,b?c[y+4>>2]|0:g&255)|0;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];g=0;while(1){if((g|0)==3)break;c[p+(g<<2)>>2]=0;g=g+1|0}HX(o,5880)|0;c[n>>2]=c[o>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];g=0;while(1){if((g|0)==3)break;c[o+(g<<2)>>2]=0;g=g+1|0}ST(z,+(e[h+2>>1]|0)/5.0e4,6);g=a[z+8+3>>0]|0;h=g<<24>>24<0;Ex(n,h?c[z>>2]|0:z,h?c[z+4>>2]|0:g&255)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];g=0;while(1){if((g|0)==3)break;c[n+(g<<2)>>2]=0;g=g+1|0}HX(m,5832)|0;c[I>>2]=c[m>>2];c[I+4>>2]=c[m+4>>2];c[I+8>>2]=c[m+8>>2];g=0;while(1){if((g|0)==3)break;c[m+(g<<2)>>2]=0;g=g+1|0}ST(A,+(e[i+2>>1]|0)/5.0e4,6);g=a[A+8+3>>0]|0;i=g<<24>>24<0;Ex(I,i?c[A>>2]|0:A,i?c[A+4>>2]|0:g&255)|0;c[H>>2]=c[I>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2];g=0;while(1){if((g|0)==3)break;c[I+(g<<2)>>2]=0;g=g+1|0}HX(H,5912)|0;c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];g=0;while(1){if((g|0)==3)break;c[H+(g<<2)>>2]=0;g=g+1|0}ST(B,+(e[j>>1]|0)/5.0e4,6);g=a[B+8+3>>0]|0;j=g<<24>>24<0;Ex(G,j?c[B>>2]|0:B,j?c[B+4>>2]|0:g&255)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];g=0;while(1){if((g|0)==3)break;c[G+(g<<2)>>2]=0;g=g+1|0}HX(F,5832)|0;c[L>>2]=c[F>>2];c[L+4>>2]=c[F+4>>2];c[L+8>>2]=c[F+8>>2];g=0;while(1){if((g|0)==3)break;c[F+(g<<2)>>2]=0;g=g+1|0}ST(C,+(e[k>>1]|0)/5.0e4,6);g=a[C+8+3>>0]|0;k=g<<24>>24<0;Ex(L,k?c[C>>2]|0:C,k?c[C+4>>2]|0:g&255)|0;c[K>>2]=c[L>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];g=0;while(1){if((g|0)==3)break;c[L+(g<<2)>>2]=0;g=g+1|0}p2(J,K);vF(d,J)|0;z5(J);O0(K);z5(C);O0(L);O0(F);z5(B);O0(G);O0(H);z5(A);O0(I);O0(m);z5(z);O0(n);O0(o);z5(y);O0(p);O0(q);z5(x);O0(r);O0(s);z5(w);O0(t);O0(u);z5(v);ST(H,+((c[D>>2]|0)>>>0)/1.0e4,4);DW(H,0,5984)|0;c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];g=0;while(1){if((g|0)==3)break;c[H+(g<<2)>>2]=0;g=g+1|0}HX(G,6008)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];g=0;while(1){if((g|0)==3)break;c[G+(g<<2)>>2]=0;g=g+1|0}ST(I,+((c[E>>2]|0)>>>0)/1.0e4,4);g=a[I+8+3>>0]|0;E=g<<24>>24<0;Ex(F,E?c[I>>2]|0:I,E?c[I+4>>2]|0:g&255)|0;c[L>>2]=c[F>>2];c[L+4>>2]=c[F+4>>2];c[L+8>>2]=c[F+8>>2];g=0;while(1){if((g|0)==3)break;c[F+(g<<2)>>2]=0;g=g+1|0}HX(L,35184)|0;c[K>>2]=c[L>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];g=0;while(1){if((g|0)==3)break;c[L+(g<<2)>>2]=0;g=g+1|0}p2(J,K);vF(f,J)|0;z5(J);O0(K);O0(L);z5(I);O0(F);O0(G);z5(H)}l=M;return}function ad(d){d=d|0;var f=0.0,g=0,h=0.0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;R=l;l=l+64|0;J=R+58|0;x=R+40|0;I=R+28|0;K=R+24|0;L=R+56|0;M=R+54|0;N=R+52|0;O=R;P=R+12|0;HB(d,J);o=d+528|0;p=x+8+3|0;q=x+4|0;r=d+760|0;s=P+11|0;t=P+8|0;u=P+4|0;v=O+11|0;w=O+8|0;y=O+4|0;A=O+11|0;B=O+8|0;C=O+4|0;D=I+8+3|0;E=I+4|0;F=O+11|0;G=O+8|0;H=O+4|0;J=b[J>>1]|0;n=0;h=0.0;f=0.0;a:while(1){if((n&65535)>=(J&65535)){Q=3;break}GC(d);TX(x);TX(I);k=o;k=z0(c[k>>2]|0,c[k+4>>2]|0,2,0)|0;m=o;c[m>>2]=k;c[m+4>>2]=z;HB(d,L);HB(d,M);HB(d,N);bD(d,K);VY(d,e[M>>1]|0,0,x);switch(b[N>>1]|0){case 0:{VY(d,c[K>>2]|0,0,I);k=0;m=0;break}case 1:{e1(d,c[K>>2]|0,0);Xy(O,30108);vF(I,O)|0;z5(O);k=0;m=0;break}case 2:{HB(d,O);k=b[O>>1]|0;Xy(P,k<<16>>16==0?30144:30156);vF(I,P)|0;z5(P);k=k&65535;m=0;break}case 3:{bD(d,O);k=c[O>>2]|0;Gk(I,k,10)|0;m=0;break}case 4:{Uy(d,O);m=O;k=c[m>>2]|0;m=c[m+4>>2]|0;bk(I,k,m,10)|0;break}case 5:{HB(d,O);k=b[O>>1]|0;Ek(I,k,10)|0;k=k&65535;m=0;break}default:{e1(d,c[K>>2]|0,0);Xy(O,30172);vF(I,O)|0;z5(O);k=0;m=0}}J3(d);g=i9(30580)|0;j=a[p>>0]|0;i=c[q>>2]|0;do if((g|0)==((j<<24>>24<0?i:j&255)|0)){if(VG(x,30580,g)|0){j=a[p>>0]|0;i=c[q>>2]|0;Q=21;break}VU(O,(k|0)==0&(m|0)==0?384431:384435);i=sF(r,L)|0;c[P>>2]=0;c[P+4>>2]=0;c[P+8>>2]=0;j=j9(387802)|0;if(j>>>0>4294967279){Q=16;break a}if(j>>>0<11){a[s>>0]=j;g=P}else{m=j+16&-16;g=ZW(m)|0;c[P>>2]=g;c[t>>2]=m|-2147483648;c[u>>2]=j}i1(g,387802,j)|0;J7(g+j|0,0);vF(VC(i+40|0,P)|0,O)|0;a1(P);z5(O)}else Q=21;while(0);b:do if((Q|0)==21){Q=0;g=i9(30260)|0;do if((g|0)==((j<<24>>24<0?i:j&255)|0)){if(VG(x,30260,g)|0){j=a[p>>0]|0;i=c[q>>2]|0;break}f=+Cq(I);if(!(h!=0.0&f!=0.0))break b;i=sF(r,L)|0;c[O>>2]=0;c[O+4>>2]=0;c[O+8>>2]=0;j=j9(380218)|0;if(j>>>0>4294967279){Q=26;break a}if(j>>>0<11){a[v>>0]=j;g=O}else{m=j+16&-16;g=ZW(m)|0;c[O>>2]=g;c[w>>2]=m|-2147483648;c[y>>2]=j}i1(g,380218,j)|0;J7(g+j|0,0);io(VC(i+40|0,O)|0,f/h,3)|0;a1(O);break b}while(0);g=i9(30312)|0;do if((g|0)==((j<<24>>24<0?i:j&255)|0)){if(VG(x,30312,g)|0){j=a[p>>0]|0;i=c[q>>2]|0;break}h=+Cq(I);if(!(f!=0.0&h!=0.0))break b;i=sF(r,L)|0;c[O>>2]=0;c[O+4>>2]=0;c[O+8>>2]=0;j=j9(380218)|0;if(j>>>0>4294967279){Q=36;break a}if(j>>>0<11){a[A>>0]=j;g=O}else{m=j+16&-16;g=ZW(m)|0;c[O>>2]=g;c[B>>2]=m|-2147483648;c[C>>2]=j}i1(g,380218,j)|0;J7(g+j|0,0);io(VC(i+40|0,O)|0,f/h,3)|0;a1(O);break b}while(0);g=i9(32984)|0;do if((g|0)==((j<<24>>24<0?i:j&255)|0)){if(VG(x,32984,g)|0){j=a[p>>0]|0;i=c[q>>2]|0;break}g=i9(54768)|0;m=a[D>>0]|0;if((g|0)==((m<<24>>24<0?c[E>>2]|0:m&255)|0)?(VG(I,54768,g)|0)==0:0)break b;if((oH(I,64,0)|0)==-1)break b;i=sF(r,L)|0;c[O>>2]=0;c[O+4>>2]=0;c[O+8>>2]=0;j=j9(384616)|0;if(j>>>0>4294967279){Q=48;break a}if(j>>>0<11){a[F>>0]=j;g=O}else{m=j+16&-16;g=ZW(m)|0;c[O>>2]=g;c[G>>2]=m|-2147483648;c[H>>2]=j}i1(g,384616,j)|0;J7(g+j|0,0);k1(VC(i+40|0,O)|0,I)|0;a1(O);break b}while(0);g=i9(33088)|0;if((g|0)==((j<<24>>24<0?i:j&255)|0)){if(!(VG(x,33088,g)|0))break;j=a[p>>0]|0;i=c[q>>2]|0}g=i9(33180)|0;if((g|0)==((j<<24>>24<0?i:j&255)|0)){if(!(VG(x,33180,g)|0))break;j=a[p>>0]|0;i=c[q>>2]|0}g=i9(33284)|0;if((g|0)==((j<<24>>24<0?i:j&255)|0)){if(!(VG(x,33284,g)|0))break;j=a[p>>0]|0;i=c[q>>2]|0}g=i9(33376)|0;if((g|0)==((j<<24>>24<0?i:j&255)|0)?(VG(x,33376,g)|0)==0:0)break;m=sF(r,L)|0;pk(O,x);k1(VC(m+40|0,O)|0,I)|0;a1(O)}while(0);z5(I);z5(x);n=n+1<<16>>16}if((Q|0)==3){l=R;return}else if((Q|0)==16)uaa();else if((Q|0)==26)uaa();else if((Q|0)==36)uaa();else if((Q|0)==48)uaa()}function bd(b,f){b=b|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;C=l;l=l+16|0;h=C+10|0;j=C+6|0;m=C+4|0;q=C+2|0;s=C;k=C+9|0;r=C+8|0;i=b+528|0;while(1){EG(b,h);g=a[h>>0]|0;if(g<<24>>24!=-1)break;A=i;A=z0(c[A>>2]|0,c[A+4>>2]|0,1,0)|0;B=i;c[B>>2]=A;c[B+4>>2]=z}if((g&-64)<<24>>24==64){Bx(b);RS(b);KS(b);g=b+648|0;A6(c[g>>2]|0);d4(c[g>>2]|0,13);wK(b);EG(b,h);g=a[h>>0]|0}x=b+612|0;t=b+312|0;A=b+774|0;B=f&255;y=b+48|0;u=b+804|0;switch((g&-16)<<24>>24){case 32:{GC(b);Bx(b);RS(b);RS(b);KS(b);RS(b);xR(b,3,q);A6(c[b+648>>2]|0);sR(b,15,j);KS(b);sR(b,15,m);KS(b);wK(b);h=PZ(d[q>>0]|0,0,30)|0;g=z;o=PZ(e[j>>1]|0,0,15)|0;g=z|g;h=o|h|e[m>>1];o=b+136|0;i=o;c[i>>2]=h;c[i+4>>2]=g;i=(c[b+24>>2]|0)+81|0;if(!(a[i>>0]|0)){w=t;t=c[w+4>>2]|0;w=t>>>0<0|(t|0)==0&(c[w>>2]|0)>>>0<16;t=z0(h|0,g|0,-9e4,-1)|0;s=z;if((s>>>0>1|(s|0)==1&t>>>0>4294787296)&w){a[i>>0]=1;v=10}}else v=10;if((v|0)==10)if(g>>>0>1|(g|0)==1&h>>>0>4294877296){h=o;c[h>>2]=0;c[h+4>>2]=0;h=0;g=0}n=c[u>>2]|0;m=(f|64)<<24>>24==-3;if(!(m|(a[n+(B*120|0)+118>>0]|0)==0)){k=n+(B*120|0)+80|0;i=k;j=c[i>>2]|0;i=c[i+4>>2]|0;if((j|0)==-1&(i|0)==-1){i=k;c[i>>2]=h;c[i+4>>2]=g;i=g;j=h}while(1){w=z0(h|0,g|0,0,1)|0;v=z;if(!(v>>>0<i>>>0|(v|0)==(i|0)&w>>>0<j>>>0))break;v=z0(h|0,g|0,0,2)|0;w=z;u=o;c[u>>2]=v;c[u+4>>2]=w;h=v;g=w}u=y;u=z0(c[x>>2]|0,0,c[u>>2]|0,c[u+4>>2]|0)|0;v=z;w=n+(B*120|0)+72|0;c[w>>2]=u;c[w+4>>2]=v;w=n+(B*120|0)+88|0;c[w>>2]=u;c[w+4>>2]=v;w=k;c[w>>2]=h;c[w+4>>2]=g;w=n+(B*120|0)+96|0;c[w>>2]=h;c[w+4>>2]=g}if(a[A>>0]|0?(p=n+(B*120|0)+117|0,!(m|(a[p>>0]|0)==0)):0){x=z0(c[x>>2]|0,0,c[y>>2]|0,c[y+4>>2]|0)|0;y=z;A=n+(B*120|0)+40|0;c[A>>2]=x;c[A+4>>2]=y;A=n+(B*120|0)+56|0;c[A>>2]=x;c[A+4>>2]=y;A=n+(B*120|0)+48|0;c[A>>2]=h;c[A+4>>2]=g;B=n+(B*120|0)+64|0;c[B>>2]=h;c[B+4>>2]=g;a[p>>0]=0}vp(b,h,g,3);a[b+784>>0]=1;J3(b);break}case 48:{GC(b);Bx(b);RS(b);RS(b);KS(b);KS(b);xR(b,3,k);o=b+648|0;A6(c[o>>2]|0);sR(b,15,j);KS(b);sR(b,15,m);KS(b);wK(b);h=PZ(d[k>>0]|0,0,30)|0;g=z;n=PZ(e[j>>1]|0,0,15)|0;g=z|g;h=n|h|e[m>>1];n=b+136|0;f=n;c[f>>2]=h;c[f+4>>2]=g;f=b+24|0;i=(c[f>>2]|0)+81|0;if(!(a[i>>0]|0)){p=t;m=c[p+4>>2]|0;p=m>>>0<0|(m|0)==0&(c[p>>2]|0)>>>0<16;m=z0(h|0,g|0,-9e4,-1)|0;k=z;if((k>>>0>1|(k|0)==1&m>>>0>4294787296)&p){a[i>>0]=1;v=26}}else v=26;if((v|0)==26)if(g>>>0>1|(g|0)==1&h>>>0>4294877296){h=n;c[h>>2]=0;c[h+4>>2]=0;h=0;g=0}m=c[u>>2]|0;if(a[m+(B*120|0)+118>>0]|0){k=m+(B*120|0)+80|0;i=k;j=c[i>>2]|0;i=c[i+4>>2]|0;if((j|0)==-1&(i|0)==-1){i=k;c[i>>2]=h;c[i+4>>2]=g;i=g;j=h}while(1){p=z0(h|0,g|0,0,1)|0;D=z;if(!(D>>>0<i>>>0|(D|0)==(i|0)&p>>>0<j>>>0))break;p=z0(h|0,g|0,0,2)|0;D=z;E=n;c[E>>2]=p;c[E+4>>2]=D;h=p;g=D}D=y;D=z0(c[x>>2]|0,0,c[D>>2]|0,c[D+4>>2]|0)|0;E=m+(B*120|0)+72|0;c[E>>2]=D;c[E+4>>2]=z;E=k;c[E>>2]=h;c[E+4>>2]=g}if(a[A>>0]|0?a[m+(B*120|0)+117>>0]|0:0){D=y;D=z0(c[x>>2]|0,0,c[D>>2]|0,c[D+4>>2]|0)|0;E=m+(B*120|0)+40|0;c[E>>2]=D;c[E+4>>2]=z;E=m+(B*120|0)+48|0;c[E>>2]=h;c[E+4>>2]=g}vp(b,h,g,1);J3(b);GC(b);Bx(b);RS(b);RS(b);RS(b);A6(c[o>>2]|0);xR(b,3,r);KS(b);sR(b,15,q);KS(b);sR(b,15,s);KS(b);wK(b);h=PZ(d[r>>0]|0,0,30)|0;g=z;n=PZ(e[q>>1]|0,0,15)|0;g=z|g;h=n|h|e[s>>1];n=b+144|0;i=n;c[i>>2]=h;c[i+4>>2]=g;i=(c[f>>2]|0)+81|0;if(!(a[i>>0]|0)){E=t;D=c[E+4>>2]|0;E=D>>>0<0|(D|0)==0&(c[E>>2]|0)>>>0<16;D=z0(h|0,g|0,-9e4,-1)|0;t=z;if((t>>>0>1|(t|0)==1&D>>>0>4294787296)&E){a[i>>0]=1;v=41}}else v=41;if((v|0)==41)if(g>>>0>1|(g|0)==1&h>>>0>4294877296){h=n;c[h>>2]=0;c[h+4>>2]=0;h=0;g=0}m=c[u>>2]|0;if(a[m+(B*120|0)+118>>0]|0){k=m+(B*120|0)+96|0;i=k;j=c[i>>2]|0;i=c[i+4>>2]|0;if((j|0)==-1&(i|0)==-1){i=k;c[i>>2]=h;c[i+4>>2]=g;i=g;j=h}while(1){E=z0(h|0,g|0,0,1)|0;D=z;if(!(D>>>0<i>>>0|(D|0)==(i|0)&E>>>0<j>>>0))break;D=z0(h|0,g|0,0,2)|0;E=z;v=n;c[v>>2]=D;c[v+4>>2]=E;h=D;g=E}D=y;D=z0(c[x>>2]|0,0,c[D>>2]|0,c[D+4>>2]|0)|0;E=m+(B*120|0)+88|0;c[E>>2]=D;c[E+4>>2]=z;E=k;c[E>>2]=h;c[E+4>>2]=g}if(a[A>>0]|0?(w=m+(B*120|0)+117|0,a[w>>0]|0):0){E=m+(B*120|0)+64|0;c[E>>2]=h;c[E+4>>2]=g;a[w>>0]=0}vp(b,h,g,2);J3(b);break}default:{Bx(b);RS(b);RS(b);RS(b);RS(b);KS(b);KS(b);KS(b);KS(b);wK(b);if(!(a[b+760>>0]|0))a[b+749>>0]=0}}l=C;return}function cd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;J=l;l=l+48|0;F=J+36|0;G=J+24|0;H=J+12|0;I=J;TX(F);cy(b,d,0,F);C=F+8+3|0;e=a[C>>0]|0;z=F+4|0;f=c[z>>2]|0;E=e<<24>>24<0?f:e&255;do if((E|0)==(d|0)|(E+1|0)==(d|0)){E=b+840|0;o=b+848+3|0;D=b+844|0;p=G+8+3|0;q=G+4|0;r=b+888|0;s=b+896+3|0;t=b+892|0;u=H+8+3|0;v=H+4|0;w=G+8+3|0;x=G+4|0;k=0;n=0;while(1){g=e<<24>>24<0;e=e&255;h=g?c[F>>2]|0:F;i=g?f:e;d=i9(41596)|0;j=i>>>0<k>>>0;do if(!j){if(d){m=h+(i<<2)|0;d=HA(h+(k<<2)|0,m,41596,41596+(d<<2)|0)|0;if((d|0)==(m|0)){y=8;break}else d=d-h>>2}else d=k;if((d|0)!=-1)m=d;else y=8}else y=8;while(0);if((y|0)==8)m=g?f:e;d=i9(34900)|0;if(!j)if(!d)y=13;else{y=h+(i<<2)|0;d=HA(h+(k<<2)|0,y,34900,34900+(d<<2)|0)|0;d=(d|0)==(y|0)?-1:d-h>>2;y=12}else{d=-1;y=12}if((y|0)==12){y=0;if((d|0)==(k|0))y=13;else{TX(G);jZ(b,m-k|0,0,G);a:do switch(n|0){case 0:{while(1){d=a[p>>0]|0;e=d<<24>>24<0;f=c[q>>2]|0;if(!((e?f:d&255)|0)){e=f;break}if((c[(e?c[G>>2]|0:G)>>2]|0)>=48){e=f;break}ny(G,0,1)|0}while(1){f=d<<24>>24<0;e=f?e:d&255;if(!e)break;d=f?c[G>>2]|0:G;if((c[d+(e+-1<<2)>>2]|0)>=48)break;ny(G,d+(e<<2)+-4-d>>2,1)|0;d=a[p>>0]|0;e=c[q>>2]|0}d=oH(G,32,0)|0;if((d|0)!=-1)FB(G,d,0);k1(E,G)|0;break}case 1:{d=a[o>>0]|0;if(d<<24>>24<0){f=c[E>>2]|0;e=c[D>>2]|0}else{f=E;e=d&255}d=i9(35036)|0;if(d|0?(j=f+(e<<2)|0,k=HA(f,j,35036,35036+(d<<2)|0)|0,!((k|0)!=(j|0)&(k|0)==(f|0))):0)break a;d=a[p>>0]|0;e=d<<24>>24<0;f=e?c[G>>2]|0:G;g=i9(35056)|0;if(g){k=f+((e?c[q>>2]|0:d&255)<<2)|0;j=HA(f,k,35056,35056+(g<<2)|0)|0;d=j-f>>2;if(!((j|0)==(k|0)|(d|0)==-1))y=57}else{d=0;y=57}if((y|0)==57){y=0;FB(G,d,0)}HX(E,41596)|0;k=a[p>>0]|0;j=k<<24>>24<0;Ex(E,j?c[G>>2]|0:G,j?c[q>>2]|0:k&255)|0;break}default:{}}while(0);z5(G)}}if((y|0)==13){y=0;GC(b);if((a[s>>0]|0)<0){y7(c[r>>2]|0,0);c[t>>2]=0;d=k}else{y7(r,0);a[s>>0]=0;d=k}while(1){g=a[C>>0]|0;e=g<<24>>24<0;f=c[z>>2]|0;g=g&255;if((d|0)==((e?f:g)|0))break;j=oH(F,32,d)|0;j=(j|0)==-1?(e?f:g):j;TX(G);jZ(b,j-d|0,0,G);while(1){k=a[C>>0]|0;if((j|0)==((k<<24>>24<0?c[z>>2]|0:k&255)|0))break;TX(H);cy(b,1,0,H);d=i9(42252)|0;k=a[u>>0]|0;if((d|0)!=((k<<24>>24<0?c[v>>2]|0:k&255)|0)){y=21;break}if(VG(H,42252,d)|0){y=21;break}iF(b,1,0);z5(H);j=j+1|0}if((y|0)==21){y=0;z5(H)}e=i9(34940)|0;f=a[w>>0]|0;d=c[x>>2]|0;if((e|0)==((f<<24>>24<0?d:f&255)|0)){if(VG(G,34940,e)|0){f=a[w>>0]|0;d=c[x>>2]|0;y=26}}else y=26;do if((y|0)==26){y=0;g=f<<24>>24<0;e=g?d:f&255;i=c[G>>2]|0;g=g?i:G;if(e|0?((c[g>>2]|0)+-48|0)>>>0<10:0)break;h=i9(34976)|0;if(((h|0?(A=g+(e<<2)|0,k=HA(g,A,34976,34976+(h<<2)|0)|0,!((k|0)!=(A|0)&(k|0)==(g|0))):0)?(B=i9(34996)|0,B|0):0)?(k=HA(g,A,34996,34996+(B<<2)|0)|0,!((k|0)!=(A|0)&(k|0)==(g|0))):0){e=a[s>>0]|0;if(e<<24>>24<0)e=c[t>>2]|0;else e=e&255;if(!e)e=i;else{HX(r,41840)|0;f=a[w>>0]|0;e=c[G>>2]|0;d=c[x>>2]|0}k=f<<24>>24<0;Ex(r,k?e:G,k?d:f&255)|0}}while(0);z5(G);d=j}J3(b)}d=m+3|0;e=a[C>>0]|0;f=c[z>>2]|0;if(d>>>0>(e<<24>>24<0?f:e&255)>>>0)d=m;else{iF(b,3,0);e=a[C>>0]|0;f=c[z>>2]|0}if((d|0)==((e<<24>>24<0?f:e&255)|0))break;else{k=d;n=n+1|0}}d=a[o>>0]|0;if(d<<24>>24<0){g=c[E>>2]|0;f=c[D>>2]|0}else{g=E;f=d&255}d=i9(35080)|0;e=b+852|0;if(d|0?(C=g+(f<<2)|0,D=HA(g,C,35080,35080+(d<<2)|0)|0,!((D|0)!=(C|0)&(D|0)==(g|0))):0){k1(e,E)|0;break}Xy(G,35036);vF(e,G)|0;z5(G);c[H>>2]=0;c[H+4>>2]=0;c[H+8>>2]=0;f=i9(35080)|0;if(f>>>0>1073741807)uaa();d=H+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){J=ua(8)|0;K2(J,391652);c[J>>2]=57868;Ya(J|0,2712,367)}else{D=ZW(e<<2)|0;c[H>>2]=D;c[d>>2]=e|-2147483648;c[H+4>>2]=f;d=D;break}}else{a[d+3>>0]=f;d=H}while(0);a3(d,35080,f);y7(d+(f<<2)|0,0);TX(I);Ok(G,E,H,I,0,0);vF(b+864|0,G)|0;z5(G);z5(I);O0(H)}else e1(b,d,0);while(0);z5(F);l=J;return}function dd(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;y=l;l=l+64|0;x=y+48|0;r=y+36|0;q=y+24|0;n=y+12|0;o=y+60|0;p=y;c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[x+(e<<2)>>2]=0;e=e+1|0}m=d+520|0;m=Nb(x,c[m>>2]|0,c[m+4>>2]|0)|0;s=d+788|0;e=c[s>>2]|0;t=d+528|0;u=d+916|0;v=d+536|0;w=x+11|0;a:do switch(((m+-1|0)>>>0<2&(e|0)!=-1?3:m)|0){case 4:{e1(d,4,0);break}case 5:{w=v;e1(d,c[w>>2]|0,c[w+4>>2]|0);break}case 1:{TX(r);c[q>>2]=0;b[n>>1]=0;e=v;f=c[e>>2]|0;e=c[e+4>>2]|0;do if(!(e>>>0<0|(e|0)==0&f>>>0<5)){aH(d,q);h=c[q>>2]|0;m=z0(h|0,0,4,0)|0;k=z;e=v;f=c[e>>2]|0;e=c[e+4>>2]|0;if(k>>>0>e>>>0|(k|0)==(e|0)&m>>>0>f>>>0){c[q>>2]=0;yE(d,n);g=b[n>>1]|0;m=z0(g&65535|0,0,4,0)|0;k=z;e=v;f=c[e>>2]|0;e=c[e+4>>2]|0;if(k>>>0>e>>>0|(k|0)==(e|0)&m>>>0>f>>>0)break;else h=0}else g=0;k=p+8+3|0;m=p+4|0;while(1){j=t;i=c[j+4>>2]|0;if(!(i>>>0<e>>>0|((i|0)==(e|0)?(c[j>>2]|0)>>>0<f>>>0:0)))break;if(!h){NB(d,n);NB(d,o);g=b[n>>1]|0;jZ(d,g&65535,0,r)}else{jZ(d,h,0,r);ID(d,q)}do if(qO(d)|0){if((c[s>>2]|0)!=-1){k1(SC((bF(u,s)|0)+24|0,x)|0,r)|0;break}gq(p,d,0,0,(a[w>>0]|0)<0?c[x>>2]|0:x);j=a[k>>0]|0;j=((j<<24>>24<0?c[m>>2]|0:j&255)|0)==0;z5(p);if(j)Mc(d,0,0,(a[w>>0]|0)<0?c[x>>2]|0:x,r,0)}while(0);i=t;h=c[i>>2]|0;i=c[i+4>>2]|0;j=z0(h|0,i|0,1,0)|0;e=v;f=c[e>>2]|0;e=c[e+4>>2]|0;if((j|0)==(f|0)&(z|0)==(e|0)){EG(d,p);j=(a[p>>0]|0)==0;e=t;f=c[e>>2]|0;e=c[e+4>>2]|0;h=z0(f|0,e|0,1,0)|0;i=z;if(j){f=t;c[f>>2]=h;c[f+4>>2]=i;f=h;e=i}h=v;j=f;i=e;e=c[h+4>>2]|0;f=c[h>>2]|0}else j=h;A=z0(j|0,i|0,4,0)|0;B=z;h=c[q>>2]|0;if((B>>>0<e>>>0|(B|0)==(e|0)&A>>>0<=f>>>0)&(h|0)!=0){aH(d,p);if(!(c[p>>2]|0)){A=v;B=t;B=D_(c[A>>2]|0,c[A+4>>2]|0,c[B>>2]|0,c[B+4>>2]|0)|0;e1(d,B,z)}i=t;f=v;j=c[i>>2]|0;i=c[i+4>>2]|0;e=c[f+4>>2]|0;f=c[f>>2]|0}B=z0(j|0,i|0,2,0)|0;A=z;if(!((A>>>0<e>>>0|(A|0)==(e|0)&B>>>0<=f>>>0)&g<<16>>16!=0))continue;yE(d,p);if(!(b[p>>1]|0)){A=v;B=t;B=D_(c[A>>2]|0,c[A+4>>2]|0,c[B>>2]|0,c[B+4>>2]|0)|0;e1(d,B,z)}f=v;e=c[f+4>>2]|0;f=c[f>>2]|0}z5(r);break a}while(0);e1(d,f,e);z5(r);break}case 2:{bB(d,q);jB(d,r);TX(n);i=p+8+3|0;j=p+4|0;while(1){A=t;q=c[A+4>>2]|0;B=v;r=c[B+4>>2]|0;if(!(q>>>0<r>>>0|((q|0)==(r|0)?(c[A>>2]|0)>>>0<(c[B>>2]|0)>>>0:0)))break;NB(d,o);f=t;e=c[f>>2]|0;f=c[f+4>>2]|0;B=z0(e|0,f|0,2,0)|0;A=z;h=v;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!(A>>>0>h>>>0|(A|0)==(h|0)&B>>>0>g>>>0)){yE(d,p);B=(b[p>>1]|0)==-257;f=v;e=t;e=D_(c[f>>2]|0,c[f+4>>2]|0,c[e>>2]|0,c[e+4>>2]|0)|0;f=z;if(B)iZ(d,e,f,n);else k=37}else{e=D_(g|0,h|0,e|0,f|0)|0;f=z;k=37}if((k|0)==37){k=0;xZ(d,e,f,n)}if(!(qO(d)|0))continue;if((c[s>>2]|0)!=-1){k1(SC((bF(u,s)|0)+24|0,x)|0,n)|0;continue}gq(p,d,0,0,(a[w>>0]|0)<0?c[x>>2]|0:x);B=a[i>>0]|0;B=((B<<24>>24<0?c[j>>2]|0:B&255)|0)==0;z5(p);if(!B)continue;Mc(d,0,0,(a[w>>0]|0)<0?c[x>>2]|0:x,n,0)}z5(n);break}case 3:{if((e|0)==-1){bB(d,q);jB(d,r)}TX(r);i=q+8+3|0;j=q+4|0;k=x+4|0;while(1){f=t;e=c[f>>2]|0;f=c[f+4>>2]|0;h=v;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!(h>>>0>f>>>0|(h|0)==(f|0)&g>>>0>e>>>0))break;B=D_(g|0,h|0,e|0,f|0)|0;xZ(d,B,z,r);if(!(qO(d)|0))continue;if((c[s>>2]|0)==-1){gq(q,d,0,0,(a[w>>0]|0)<0?c[x>>2]|0:x);B=a[i>>0]|0;B=((B<<24>>24<0?c[j>>2]|0:B&255)|0)==0;z5(q);if(!B)continue;Mc(d,0,0,(a[w>>0]|0)<0?c[x>>2]|0:x,r,0);continue}e=j9(376948)|0;f=a[w>>0]|0;g=c[k>>2]|0;if((e|0)==((f<<24>>24<0?g:f&255)|0)){if(!(ZG(x,376948,e)|0))continue;f=a[w>>0]|0;g=c[k>>2]|0}e=j9(376953)|0;if((e|0)==((f<<24>>24<0?g:f&255)|0)){if(!(ZG(x,376953,e)|0))continue;f=a[w>>0]|0;g=c[k>>2]|0}e=j9(376958)|0;if((e|0)==((f<<24>>24<0?g:f&255)|0)?(ZG(x,376958,e)|0)==0:0)continue;k1(SC((bF(u,s)|0)+24|0,x)|0,r)|0}z5(r);break}default:{}}while(0);a1(x);l=y;return}function ed(a,b,e,f,g,h){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0.0,j=0.0,k=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,A=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;J=l;l=l+512|0;G=J;H=f+e|0;I=0-H|0;D=a+4|0;E=a+100|0;k=0;a:while(1){switch(b|0){case 46:{A=6;break a}case 48:break;default:{v=0;p=k;q=0;o=0;break a}}b=c[D>>2]|0;if(b>>>0<(c[E>>2]|0)>>>0){c[D>>2]=b+1;b=d[b>>0]|0;k=1;continue}else{b=_x(a)|0;k=1;continue}}if((A|0)==6){b=c[D>>2]|0;if(b>>>0<(c[E>>2]|0)>>>0){c[D>>2]=b+1;b=d[b>>0]|0}else b=_x(a)|0;if((b|0)==48){k=0;b=0;while(1){k=z0(k|0,b|0,-1,-1)|0;o=z;b=c[D>>2]|0;if(b>>>0<(c[E>>2]|0)>>>0){c[D>>2]=b+1;b=d[b>>0]|0}else b=_x(a)|0;if((b|0)==48)b=o;else{v=1;p=1;q=k;break}}}else{v=1;p=k;q=0;o=0}}c[G>>2]=0;n=b+-48|0;m=(b|0)==46;b:do if(m|n>>>0<10){A=G+496|0;w=0;k=0;u=0;x=v;C=p;v=m;y=n;p=0;m=0;c:while(1){do if(v)if(!x){x=1;n=C;q=p;o=m}else break c;else{p=z0(p|0,m|0,1,0)|0;m=z;v=(b|0)!=48;if((k|0)>=125){if(!v){n=C;break}c[A>>2]=c[A>>2]|1;n=C;break}n=G+(k<<2)|0;if(!w)b=y;else b=b+-48+((c[n>>2]|0)*10|0)|0;c[n>>2]=b;w=w+1|0;n=(w|0)==9;w=n?0:w;k=(n&1)+k|0;u=v?p:u;n=1}while(0);b=c[D>>2]|0;if(b>>>0<(c[E>>2]|0)>>>0){c[D>>2]=b+1;b=d[b>>0]|0}else b=_x(a)|0;y=b+-48|0;v=(b|0)==46;if(!(v|y>>>0<10)){v=x;A=29;break b}else C=n}b=w;n=(C|0)!=0;A=37}else{w=0;k=0;u=0;n=p;p=0;m=0;A=29}while(0);do if((A|0)==29){C=(v|0)==0;q=C?p:q;o=C?m:o;n=(n|0)!=0;if(!(n&(b|32|0)==101))if((b|0)>-1){b=w;A=37;break}else{b=w;A=39;break}n=ml(a,h)|0;b=z;if((n|0)==0&(b|0)==-2147483648){if(!h){NV(a,0);i=0.0;break}if(!(c[E>>2]|0)){n=0;b=0}else{c[D>>2]=(c[D>>2]|0)+-1;n=0;b=0}}y=z0(n|0,b|0,q|0,o|0)|0;b=w;o=z;A=41}while(0);if((A|0)==37)if(c[E>>2]|0){c[D>>2]=(c[D>>2]|0)+-1;if(n){y=q;A=41}else A=40}else A=39;if((A|0)==39)if(n){y=q;A=41}else A=40;do if((A|0)==40){c[12784]=22;NV(a,0);i=0.0}else if((A|0)==41){n=c[G>>2]|0;if(!n){i=+(g|0)*0.0;break}if(((m|0)<0|(m|0)==0&p>>>0<10)&((y|0)==(p|0)&(o|0)==(m|0))?(e|0)>30|(n>>>e|0)==0:0){i=+(g|0)*+(n>>>0);break}a=(f|0)/-2|0;E=((a|0)<0)<<31>>31;if((o|0)>(E|0)|(o|0)==(E|0)&y>>>0>a>>>0){c[12784]=34;i=+(g|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}a=f+-106|0;E=((a|0)<0)<<31>>31;if((o|0)<(E|0)|(o|0)==(E|0)&y>>>0<a>>>0){c[12784]=34;i=+(g|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if(b){if((b|0)<9){n=G+(k<<2)|0;m=c[n>>2]|0;do{m=m*10|0;b=b+1|0}while((b|0)!=9);c[n>>2]=m}k=k+1|0}if((u|0)<9?(u|0)<=(y|0)&(y|0)<18:0){b=c[G>>2]|0;if((y|0)==9){i=+(g|0)*+(b>>>0);break}if((y|0)<9){i=+(g|0)*+(b>>>0)/+(c[54728+(8-y<<2)>>2]|0);break}a=e+27+(O(y,-3)|0)|0;if((a|0)>30|(b>>>a|0)==0){i=+(g|0)*+(b>>>0)*+(c[54728+(y+-10<<2)>>2]|0);break}}b=(y|0)%9|0;if(!b){b=0;n=0}else{u=(y|0)>-1?b:b+9|0;p=c[54728+(8-u<<2)>>2]|0;if(k){q=1e9/(p|0)|0;n=0;o=0;m=y;b=0;do{D=G+(b<<2)|0;E=c[D>>2]|0;a=((E>>>0)/(p>>>0)|0)+n|0;c[D>>2]=a;n=O((E>>>0)%(p>>>0)|0,q)|0;a=(b|0)==(o|0)&(a|0)==0;m=a?m+-9|0:m;o=a?o+1&127:o;b=b+1|0}while((b|0)!=(k|0));if(!n)n=o;else{c[G+(k<<2)>>2]=n;n=o;k=k+1|0}}else{n=0;k=0;m=y}b=0;y=9-u+m|0}d:while(1){u=(y|0)<18;v=(y|0)==18;w=G+(n<<2)|0;while(1){if(!u){if(!v){m=y;break d}if((c[w>>2]|0)>>>0>=9007199){m=18;break d}}m=0;x=k;k=k+127|0;while(1){o=k&127;p=G+(o<<2)|0;k=PZ(c[p>>2]|0,0,29)|0;k=z0(k|0,z|0,m|0,0)|0;m=z;if(m>>>0>0|(m|0)==0&k>>>0>1e9){q=g5(k|0,m|0,1e9,0)|0;k=nW(k|0,m|0,1e9,0)|0}else q=0;c[p>>2]=k;a=(o|0)==(n|0);x=(k|0)==0&(((o|0)!=(x+127&127|0)|a)^1)?o:x;if(a)break;else{m=q;k=o+-1|0}}b=b+-29|0;if(q|0)break;else k=x}n=n+127&127;k=x+127&127;m=G+((x+126&127)<<2)|0;if((n|0)==(x|0))c[m>>2]=c[m>>2]|c[G+(k<<2)>>2];else k=x;c[G+(n<<2)>>2]=q;y=y+9|0}e:while(1){w=k+1&127;x=G+((k+127&127)<<2)|0;while(1){q=(m|0)==18;v=(m|0)>27?9:1;y=n;while(1){n=0;while(1){o=n+y&127;if((o|0)==(k|0)){F=2;A=88;break}o=c[G+(o<<2)>>2]|0;p=c[54760+(n<<2)>>2]|0;if(o>>>0<p>>>0){F=2;A=88;break}if(o>>>0>p>>>0)break;n=n+1|0;if((n|0)>=2){F=n;A=88;break}}if((A|0)==88?(A=0,q&(F|0)==2):0){i=0.0;o=0;break e}b=b+v|0;if((y|0)==(k|0))y=k;else break}q=(1<<v)+-1|0;u=1e9>>>v;p=0;n=y;o=y;do{D=G+(o<<2)|0;E=c[D>>2]|0;a=(E>>>v)+p|0;c[D>>2]=a;p=O(E&q,u)|0;a=(o|0)==(n|0)&(a|0)==0;m=a?m+-9|0:m;n=a?n+1&127:n;o=o+1&127}while((o|0)!=(k|0));if(!p)continue;if((w|0)!=(n|0))break;c[x>>2]=c[x>>2]|1}c[G+(k<<2)>>2]=p;k=w}do{n=o+y&127;m=k+1&127;if((n|0)==(k|0)){c[G+(m+-1<<2)>>2]=0;k=m}i=i*1.0e9+ +((c[G+(n<<2)>>2]|0)>>>0);o=o+1|0}while((o|0)!=2);t=+(g|0);j=t*i;o=b+53|0;p=o-f|0;q=(p|0)<(e|0);n=q?((p|0)>0?p:0):e;if((n|0)<53){K=+H9(+LC(1.0,105-n|0),j);r=+X9(j,+LC(1.0,53-n|0));s=K;i=r;r=K+(j-r)}else{s=0.0;i=0.0;r=j}m=y+2&127;if((m|0)!=(k|0)){m=c[G+(m<<2)>>2]|0;do if(m>>>0>=5e8){if((m|0)!=5e8){i=t*.75+i;break}if((y+3&127|0)==(k|0)){i=t*.5+i;break}else{i=t*.75+i;break}}else{if((m|0)==0?(y+3&127|0)==(k|0):0)break;i=t*.25+i}while(0);if((53-n|0)>1?!(+X9(i,1.0)!=0.0):0)j=i+1.0;else j=i}else j=i;i=r+j-s;do if((o&2147483647|0)>(-2-H|0)){H=!(+B(+i)>=9007199254740992.0);b=((H^1)&1)+b|0;i=H?i:i*.5;if((b+50|0)<=(I|0)?!(j!=0.0&(q&((n|0)!=(p|0)|H))):0)break;c[12784]=34}while(0);i=+L9(i,b)}while(0);l=J;return +i}
function Lb(f){f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0;Da=l;l=l+16|0;ca=Da;a:do if(((YV(f)|0)==0?(wa=f+12|0,n=c[wa>>2]|0,(n|0)!=0):0)?(m=c[f>>2]|0,qa=f+4|0,ra=c[qa>>2]|0,(m|0)!=0|(ra|0)==0):0){da=c[f+28>>2]|0;Ca=da+4|0;i=c[Ca>>2]|0;if((i|0)==16191){c[Ca>>2]=16192;i=16192}pa=f+16|0;x=c[pa>>2]|0;na=da+60|0;ya=da+64|0;z=da+80|0;za=da+28|0;A=da+84|0;B=da+100|0;C=da+36|0;oa=da+44|0;D=da+756|0;E=da+88|0;F=da+112|0;G=da+72|0;ta=da+32|0;H=da+108|0;Aa=da+8|0;I=da+96|0;ua=da+12|0;J=f+24|0;K=da+68|0;L=da+92|0;M=da+76|0;N=da+7112|0;O=da+116|0;P=ca+1|0;Ba=f+48|0;Q=da+1332|0;xa=da+20|0;va=f+20|0;R=da+104|0;S=da+40|0;T=da+24|0;U=da+16|0;V=da+7116|0;W=da+48|0;X=da+7108|0;Y=da+52|0;Z=da+56|0;_=ca+2|0;$=ca+3|0;aa=da+628|0;k=0;ba=x;o=ra;s=c[ya>>2]|0;j=c[na>>2]|0;y=n;b:while(1){v=x-ba|0;u=(ba|0)==0;c:do switch(i|0){case 16208:{i=s;h=o;k=1;g=ba;w=302;break b}case 16209:{sa=x;la=s;ka=j;h=o;ja=m;ma=-3;g=ba;break b}case 16210:{w=315;break b}case 16180:{p=c[ua>>2]|0;if(!p){c[Ca>>2]=16192;n=ba;p=y;q=x;i=s;break c}else i=s;while(1){if(i>>>0>=16)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}v=(d[m>>0]<<i)+j|0;o=o+-1|0;m=m+1|0;i=i+8|0;j=v}if((p&2|0)!=0&(j|0)==35615){if(!(c[S>>2]|0))c[S>>2]=15;n=F8(0,0,0)|0;c[za>>2]=n;a[ca>>0]=31;a[P>>0]=-117;c[za>>2]=F8(n,ca,2)|0;c[Ca>>2]=16181;n=ba;p=y;q=x;i=0;j=0;break c}c[xa>>2]=0;n=c[C>>2]|0;if(n|0)c[n+48>>2]=-1;if(p&1|0?((((j<<8&65280)+(j>>>8)|0)>>>0)%31|0|0)==0:0){if((j&15|0)!=8){c[J>>2]=391996;c[Ca>>2]=16209;n=ba;p=y;q=x;break c}r=j>>>4;p=r&15;q=p+8|0;n=c[S>>2]|0;if(!n){c[S>>2]=q;n=q}if(q>>>0>15|q>>>0>n>>>0){c[J>>2]=392023;c[Ca>>2]=16209;n=ba;p=y;q=x;i=i+-4|0;j=r;break c}else{c[T>>2]=256<<p;n=t8(0,0,0)|0;c[za>>2]=n;c[Ba>>2]=n;c[Ca>>2]=j>>>12&2^16191;n=ba;p=y;q=x;i=0;j=0;break c}}c[J>>2]=391973;c[Ca>>2]=16209;n=ba;p=y;q=x;break}case 16181:{i=s;while(1){if(i>>>0>=16)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}v=(d[m>>0]<<i)+j|0;o=o+-1|0;m=m+1|0;i=i+8|0;j=v}c[xa>>2]=j;if((j&255|0)!=8){c[J>>2]=391996;c[Ca>>2]=16209;n=ba;p=y;q=x;break c}if(j&57344|0){c[J>>2]=392043;c[Ca>>2]=16209;n=ba;p=y;q=x;break c}i=c[C>>2]|0;n=j>>>8;if(i|0)c[i>>2]=n&1;if(j&512|0?c[ua>>2]&4|0:0){a[ca>>0]=j;a[P>>0]=n;c[za>>2]=F8(c[za>>2]|0,ca,2)|0}c[Ca>>2]=16182;i=0;j=0;w=51;break}case 16182:{i=s;w=51;break}case 16183:{i=s;w=60;break}case 16184:{i=s;p=c[xa>>2]|0;w=69;break}case 16185:{i=s;p=c[xa>>2]|0;w=81;break}case 16186:{r=o;i=s;p=c[xa>>2]|0;w=92;break}case 16187:{i=s;r=o;p=c[xa>>2]|0;w=106;break}case 16188:{i=s;p=c[xa>>2]|0;w=120;break}case 16189:{i=s;while(1){if(i>>>0>=32)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}v=(d[m>>0]<<i)+j|0;i=i+8|0;j=v;o=o+-1|0;m=m+1|0}i=C5(j|0)|0;c[za>>2]=i;c[Ba>>2]=i;c[Ca>>2]=16190;i=0;j=0;w=134;break}case 16190:{i=s;w=134;break}case 16192:case 16191:{i=s;w=137;break}case 16193:{v=s&7;i=s-v|0;j=j>>>v;while(1){if(i>>>0>=32)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}v=(d[m>>0]<<i)+j|0;i=i+8|0;j=v;o=o+-1|0;m=m+1|0}n=j&65535;if((n|0)==(j>>>16^65535|0)){c[K>>2]=n;c[Ca>>2]=16194;i=0;j=0;w=155;break c}else{c[J>>2]=392107;c[Ca>>2]=16209;n=ba;p=y;q=x;break c}}case 16194:{i=s;w=155;break}case 16195:{i=s;w=156;break}case 16196:{i=s;while(1){if(i>>>0>=14)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}t=(d[m>>0]<<i)+j|0;i=i+8|0;j=t;o=o+-1|0;m=m+1|0}s=(j&31)+257|0;c[B>>2]=s;t=(j>>>5&31)+1|0;c[R>>2]=t;p=(j>>>10&15)+4|0;c[I>>2]=p;j=j>>>14;i=i+-14|0;if(s>>>0>286|t>>>0>30){c[J>>2]=392136;c[Ca>>2]=16209;n=ba;p=y;q=x;break c}else{c[H>>2]=0;c[Ca>>2]=16197;n=0;w=166;break c}}case 16197:{i=s;n=c[H>>2]|0;p=c[I>>2]|0;w=166;break}case 16198:{i=s;w=177;break}case 16199:{i=s;w=215;break}case 16200:{i=s;w=216;break}case 16201:{i=s;n=c[M>>2]|0;w=236;break}case 16202:{i=s;w=243;break}case 16203:{i=s;n=c[M>>2]|0;w=257;break}case 16204:{i=s;w=263;break}case 16205:{if(u){i=s;h=o;g=0;w=302;break b}a[y>>0]=c[K>>2];c[Ca>>2]=16200;n=ba+-1|0;p=y+1|0;q=x;i=s;break}case 16206:{n=c[ua>>2]|0;do if(n){i=s;while(1){if(i>>>0>=32)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}u=(d[m>>0]<<i)+j|0;i=i+8|0;j=u;o=o+-1|0;m=m+1|0}c[va>>2]=(c[va>>2]|0)+v;c[ta>>2]=(c[ta>>2]|0)+v;p=n&4;if((v|0)!=0&(p|0)!=0){q=c[xa>>2]|0;p=c[za>>2]|0;r=y+(0-v)|0;if(!q)p=t8(p,r,v)|0;else p=F8(p,r,v)|0;c[za>>2]=p;c[Ba>>2]=p}else{if(!p){p=ba;i=0;j=0;break}q=c[xa>>2]|0;p=c[za>>2]|0}x=C5(j|0)|0;if((((q|0)==0?x:j)|0)==(p|0)){p=ba;i=0;j=0}else{c[J>>2]=392310;c[Ca>>2]=16209;n=ba;p=y;q=ba;break c}}else{p=x;i=s;n=0}while(0);c[Ca>>2]=16207;q=p;w=294;break}case 16207:{q=x;i=s;n=c[ua>>2]|0;w=294;break}default:{g=-2;break a}}while(0);do if((w|0)==51){while(1){w=0;if(i>>>0>=32)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}w=(d[m>>0]<<i)+j|0;o=o+-1|0;m=m+1|0;i=i+8|0;j=w;w=51}i=c[C>>2]|0;if(i|0)c[i+4>>2]=j;if(c[xa>>2]&512|0?c[ua>>2]&4|0:0){a[ca>>0]=j;a[P>>0]=j>>>8;a[_>>0]=j>>>16;a[$>>0]=j>>>24;c[za>>2]=F8(c[za>>2]|0,ca,4)|0}c[Ca>>2]=16183;i=0;j=0;w=60}else if((w|0)==134){if(!(c[U>>2]|0)){w=135;break b}w=t8(0,0,0)|0;c[za>>2]=w;c[Ba>>2]=w;c[Ca>>2]=16191;w=137}else if((w|0)==155){c[Ca>>2]=16195;w=156}else if((w|0)==166){w=0;while(1){if(n>>>0>=p>>>0){k=n;break}while(1){if(i>>>0>=3)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}t=(d[m>>0]<<i)+j|0;i=i+8|0;j=t;o=o+-1|0;m=m+1|0}t=n+1|0;c[H>>2]=t;b[da+116+(e[61786+(n<<1)>>1]<<1)>>1]=j&7;i=i+-3|0;j=j>>>3;n=t}while(1){if(k>>>0>=19)break;t=k+1|0;c[H>>2]=t;b[da+116+(e[61786+(k<<1)>>1]<<1)>>1]=0;k=t}c[F>>2]=Q;c[z>>2]=Q;c[E>>2]=7;k=Mf(0,O,19,F,E,D)|0;if(!k){c[H>>2]=0;c[Ca>>2]=16198;k=0;w=177;break}else{c[J>>2]=392172;c[Ca>>2]=16209;n=ba;p=y;q=x;break}}else if((w|0)==294){w=0;if(!n){h=o;g=m;w=301;break b}if(!(c[xa>>2]|0)){h=o;g=m;w=301;break b}while(1){if(i>>>0>=32)break;if(!o){sa=q;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}x=(d[m>>0]<<i)+j|0;i=i+8|0;j=x;o=o+-1|0;m=m+1|0}if((j|0)==(c[ta>>2]|0)){i=0;j=0;h=o;g=m;w=301;break b}c[J>>2]=392331;c[Ca>>2]=16209;n=ba;p=y}while(0);d:do if((w|0)==60){while(1){w=0;if(i>>>0>=16)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}w=(d[m>>0]<<i)+j|0;o=o+-1|0;m=m+1|0;i=i+8|0;j=w;w=60}i=c[C>>2]|0;n=j>>>8;if(i|0){c[i+8>>2]=j&255;c[i+12>>2]=n}p=c[xa>>2]|0;if(p&512|0?c[ua>>2]&4|0:0){a[ca>>0]=j;a[P>>0]=n;c[za>>2]=F8(c[za>>2]|0,ca,2)|0}c[Ca>>2]=16184;i=0;j=0;w=69}else if((w|0)==137){w=0;if(!(c[Aa>>2]|0))n=j;else{v=i&7;c[Ca>>2]=16206;n=ba;p=y;q=x;i=i-v|0;j=j>>>v;break}while(1){if(i>>>0>=3)break;if(!o){sa=x;la=i;ka=n;h=0;ja=m;ma=k;g=ba;break b}v=(d[m>>0]<<i)+n|0;i=i+8|0;n=v;o=o+-1|0;m=m+1|0}c[Aa>>2]=n&1;j=n>>>3;i=i+-3|0;switch(n>>>1&3){case 0:{n=16193;break}case 1:{e2(da);c[Ca>>2]=16199;n=ba;p=y;q=x;break d}case 2:{n=16196;break}case 3:{c[J>>2]=392088;n=16209;break}default:{w=146;break b}}c[Ca>>2]=n;n=ba;p=y;q=x}else if((w|0)==156){w=0;n=c[K>>2]|0;if(!n){c[Ca>>2]=16191;n=ba;p=y;q=x;break}q=n>>>0>o>>>0?o:n;q=q>>>0>ba>>>0?ba:q;if(!q){h=o;g=ba;w=302;break b}no(y|0,m|0,q|0)|0;c[K>>2]=(c[K>>2]|0)-q;n=ba-q|0;o=o-q|0;p=y+q|0;m=m+q|0;q=x}else if((w|0)==177){w=0;e:while(1){s=c[H>>2]|0;n=c[B>>2]|0;t=(c[R>>2]|0)+n|0;if(s>>>0>=t>>>0)break;p=c[z>>2]|0;q=(1<<c[E>>2])+-1|0;while(1){n=j&q;r=d[p+(n<<2)+1>>0]|0;if(i>>>0>=r>>>0)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}r=(d[m>>0]<<i)+j|0;i=i+8|0;j=r;o=o+-1|0;m=m+1|0}n=b[p+(n<<2)+2>>1]|0;if((n&65535)<16){c[H>>2]=s+1;b[da+116+(s<<1)>>1]=n;i=i-r|0;j=j>>>r;continue}switch(n<<16>>16){case 16:{n=r+2|0;while(1){if(i>>>0>=n>>>0)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}q=(d[m>>0]<<i)+j|0;i=i+8|0;j=q;o=o+-1|0;m=m+1|0}n=j>>>r;i=i-r|0;if(!s){j=n;w=206;break e}p=e[da+116+(s+-1<<1)>>1]|0;i=i+-2|0;j=n>>>2;n=(n&3)+3|0;break}case 17:{n=r+3|0;while(1){if(i>>>0>=n>>>0)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}q=(d[m>>0]<<i)+j|0;i=i+8|0;j=q;o=o+-1|0;m=m+1|0}n=j>>>r;p=0;i=-3-r+i|0;j=n>>>3;n=(n&7)+3|0;break}default:{n=r+7|0;while(1){if(i>>>0>=n>>>0)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}q=(d[m>>0]<<i)+j|0;i=i+8|0;j=q;o=o+-1|0;m=m+1|0}n=j>>>r;p=0;i=-7-r+i|0;j=n>>>7;n=(n&127)+11|0}}if((n+s|0)>>>0>t>>>0){w=206;break}p=p&65535;while(1){if(!n)continue e;t=c[H>>2]|0;c[H>>2]=t+1;b[da+116+(t<<1)>>1]=p;n=n+-1|0}}if((w|0)==206){w=0;c[J>>2]=392197;c[Ca>>2]=16209;n=ba;p=y;q=x;break}if((c[Ca>>2]|0)!=16209){if(!(b[aa>>1]|0)){c[J>>2]=392223;c[Ca>>2]=16209;n=ba;p=y;q=x;break}c[F>>2]=Q;c[z>>2]=Q;c[E>>2]=9;k=Mf(1,O,n,F,E,D)|0;if(k|0){c[J>>2]=392260;c[Ca>>2]=16209;n=ba;p=y;q=x;break}c[A>>2]=c[F>>2];c[L>>2]=6;k=Mf(2,da+116+(c[B>>2]<<1)|0,c[R>>2]|0,F,L,D)|0;if(!k){c[Ca>>2]=16199;k=0;w=215;break}else{c[J>>2]=392288;c[Ca>>2]=16209;n=ba;p=y;q=x;break}}else{n=ba;p=y;q=x}}while(0);if((w|0)==69){w=0;if(!(p&1024)){n=c[C>>2]|0;if(n)c[n+16>>2]=0}else{while(1){if(i>>>0>=16)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}v=(d[m>>0]<<i)+j|0;o=o+-1|0;m=m+1|0;i=i+8|0;j=v}c[K>>2]=j;i=c[C>>2]|0;if(i|0)c[i+20>>2]=j;if((p&512|0)!=0?(c[ua>>2]&4|0)!=0:0){a[ca>>0]=j;a[P>>0]=j>>>8;c[za>>2]=F8(c[za>>2]|0,ca,2)|0;i=0;j=0}else{i=0;j=0}}c[Ca>>2]=16185;w=81}else if((w|0)==215){c[Ca>>2]=16200;w=216}do if((w|0)==81){if(p&1024){r=c[K>>2]|0;q=r>>>0>o>>>0?o:r;if(!q)n=r;else{n=c[C>>2]|0;if((n|0)!=0?(ea=c[n+16>>2]|0,(ea|0)!=0):0){p=(c[n+20>>2]|0)-r|0;w=c[n+24>>2]|0;no(ea+p|0,m|0,((p+q|0)>>>0>w>>>0?w-p|0:q)|0)|0;p=c[xa>>2]|0}if(p&512|0?c[ua>>2]&4|0:0)c[za>>2]=F8(c[za>>2]|0,m,q)|0;n=(c[K>>2]|0)-q|0;c[K>>2]=n;o=o-q|0;m=m+q|0}if(n){h=o;g=ba;w=302;break b}}c[K>>2]=0;c[Ca>>2]=16186;r=o;w=92}else if((w|0)==216){w=0;if(ba>>>0>257&o>>>0>5){c[wa>>2]=y;c[pa>>2]=ba;c[f>>2]=m;c[qa>>2]=o;c[na>>2]=j;c[ya>>2]=i;Fe(f,x);p=c[wa>>2]|0;n=c[pa>>2]|0;m=c[f>>2]|0;o=c[qa>>2]|0;j=c[na>>2]|0;i=c[ya>>2]|0;if((c[Ca>>2]|0)!=16191){q=x;break}c[N>>2]=-1;q=x;break}c[N>>2]=0;s=c[z>>2]|0;q=(1<<c[E>>2])+-1|0;while(1){p=j&q;n=a[s+(p<<2)+1>>0]|0;t=n&255;if(t>>>0<=i>>>0)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}t=(d[m>>0]<<i)+j|0;i=i+8|0;j=t;o=o+-1|0;m=m+1|0}r=a[s+(p<<2)>>0]|0;q=b[s+(p<<2)+2>>1]|0;p=r&255;if(r<<24>>24!=0&(p&240|0)==0){r=q&65535;q=(1<<p+t)+-1|0;while(1){p=((j&q)>>>t)+r|0;n=a[s+(p<<2)+1>>0]|0;if(((n&255)+t|0)>>>0<=i>>>0)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}p=(d[m>>0]<<i)+j|0;i=i+8|0;j=p;o=o+-1|0;m=m+1|0}q=b[s+(p<<2)+2>>1]|0;r=a[s+(p<<2)>>0]|0;c[N>>2]=t;i=i-t|0;j=j>>>t;p=t}else p=0;n=n&255;j=j>>>n;i=i-n|0;c[N>>2]=n+p;c[K>>2]=q&65535;n=r&255;if(!(r<<24>>24)){c[Ca>>2]=16205;n=ba;p=y;q=x;break}if(n&32|0){c[N>>2]=-1;c[Ca>>2]=16191;n=ba;p=y;q=x;break}if(!(n&64)){n=n&15;c[M>>2]=n;c[Ca>>2]=16201;w=236;break}else{c[J>>2]=392354;c[Ca>>2]=16209;n=ba;p=y;q=x;break}}while(0);if((w|0)==92){if(!(p&2048)){n=c[C>>2]|0;if(!n)o=r;else{c[n+28>>2]=0;o=r}}else{if(!r){h=0;g=ba;w=302;break}else q=0;do{n=q;q=q+1|0;n=a[m+n>>0]|0;o=c[C>>2]|0;if((o|0?(fa=c[o+28>>2]|0,fa|0):0)?(ga=c[K>>2]|0,ga>>>0<(c[o+32>>2]|0)>>>0):0){c[K>>2]=ga+1;a[fa+ga>>0]=n}n=n<<24>>24!=0}while(n&r>>>0>q>>>0);p=c[xa>>2]|0;if(p&512|0?c[ua>>2]&4|0:0)c[za>>2]=F8(c[za>>2]|0,m,q)|0;o=r-q|0;m=m+q|0;if(n){h=o;g=ba;w=302;break}}c[K>>2]=0;c[Ca>>2]=16187;r=o;w=106}else if((w|0)==236){w=0;if(!n)n=c[K>>2]|0;else{while(1){if(i>>>0>=n>>>0)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}t=(d[m>>0]<<i)+j|0;i=i+8|0;j=t;o=o+-1|0;m=m+1|0}w=(c[K>>2]|0)+(j&(1<<n)+-1)|0;c[K>>2]=w;c[N>>2]=(c[N>>2]|0)+n;i=i-n|0;j=j>>>n;n=w}c[V>>2]=n;c[Ca>>2]=16202;w=243}do if((w|0)==106){if(!(p&4096)){n=c[C>>2]|0;if(!n)o=r;else{c[n+36>>2]=0;o=r}}else{if(!r){h=0;g=ba;w=302;break b}else q=0;do{n=q;q=q+1|0;n=a[m+n>>0]|0;o=c[C>>2]|0;if((o|0?(ha=c[o+36>>2]|0,ha|0):0)?(ia=c[K>>2]|0,ia>>>0<(c[o+40>>2]|0)>>>0):0){c[K>>2]=ia+1;a[ha+ia>>0]=n}n=n<<24>>24!=0}while(n&r>>>0>q>>>0);p=c[xa>>2]|0;if(p&512|0?c[ua>>2]&4|0:0)c[za>>2]=F8(c[za>>2]|0,m,q)|0;o=r-q|0;m=m+q|0;if(n){h=o;g=ba;w=302;break b}}c[Ca>>2]=16188;w=120}else if((w|0)==243){w=0;t=c[A>>2]|0;q=(1<<c[L>>2])+-1|0;while(1){p=j&q;n=a[t+(p<<2)+1>>0]|0;s=n&255;if(s>>>0<=i>>>0)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}s=(d[m>>0]<<i)+j|0;i=i+8|0;j=s;o=o+-1|0;m=m+1|0}r=a[t+(p<<2)>>0]|0;q=b[t+(p<<2)+2>>1]|0;p=r&255;if(!(p&240)){r=q&65535;q=(1<<p+s)+-1|0;while(1){p=((j&q)>>>s)+r|0;n=a[t+(p<<2)+1>>0]|0;if(((n&255)+s|0)>>>0<=i>>>0)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}p=(d[m>>0]<<i)+j|0;i=i+8|0;j=p;o=o+-1|0;m=m+1|0}q=b[t+(p<<2)+2>>1]|0;r=a[t+(p<<2)>>0]|0;p=(c[N>>2]|0)+s|0;c[N>>2]=p;i=i-s|0;j=j>>>s}else p=c[N>>2]|0;n=n&255;j=j>>>n;i=i-n|0;c[N>>2]=n+p;n=r&255;if(!(n&64)){c[G>>2]=q&65535;n=n&15;c[M>>2]=n;c[Ca>>2]=16203;w=257;break}else{c[J>>2]=392382;c[Ca>>2]=16209;n=ba;p=y;q=x;break}}while(0);do if((w|0)==120){w=0;if(p&512){while(1){if(i>>>0>=16)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}v=(d[m>>0]<<i)+j|0;i=i+8|0;j=v;o=o+-1|0;m=m+1|0}if((c[ua>>2]&4|0)!=0?(j|0)!=(c[za>>2]&65535|0):0){c[J>>2]=392068;c[Ca>>2]=16209;n=ba;p=y;q=x;break}else{i=0;j=0}}n=c[C>>2]|0;if(n|0){c[n+44>>2]=p>>>9&1;c[n+48>>2]=1}n=F8(0,0,0)|0;c[za>>2]=n;c[Ba>>2]=n;c[Ca>>2]=16191;n=ba;p=y;q=x}else if((w|0)==257){w=0;if(n){while(1){if(i>>>0>=n>>>0)break;if(!o){sa=x;la=i;ka=j;h=0;ja=m;ma=k;g=ba;break b}t=(d[m>>0]<<i)+j|0;i=i+8|0;j=t;o=o+-1|0;m=m+1|0}c[G>>2]=(c[G>>2]|0)+(j&(1<<n)+-1);c[N>>2]=(c[N>>2]|0)+n;i=i-n|0;j=j>>>n}c[Ca>>2]=16204;w=263}while(0);do if((w|0)==263){w=0;if(u){h=o;g=0;w=302;break b}n=c[G>>2]|0;if(n>>>0>v>>>0){n=n-v|0;if(n>>>0>(c[W>>2]|0)>>>0?c[X>>2]|0:0){c[J>>2]=392404;c[Ca>>2]=16209;n=ba;p=y;q=x;break}p=c[Y>>2]|0;if(n>>>0>p>>>0){n=n-p|0;q=n;n=(c[oa>>2]|0)-n|0}else{q=n;n=p-n|0}p=c[K>>2]|0;s=(c[Z>>2]|0)+n|0;n=q>>>0>p>>>0?p:q}else{p=c[K>>2]|0;s=y+(0-n)|0;n=p}r=n>>>0>ba>>>0?ba:n;c[K>>2]=p-r;p=r;q=y;n=s;while(1){a[q>>0]=a[n>>0]|0;p=p+-1|0;if(!p)break;else{q=q+1|0;n=n+1|0}}n=ba-r|0;p=y+-1+(r+1)|0;if(!(c[K>>2]|0)){c[Ca>>2]=16200;q=x}else q=x}while(0);ba=n;x=q;s=i;y=p;i=c[Ca>>2]|0}if((w|0)==135){c[wa>>2]=y;c[pa>>2]=ba;c[f>>2]=m;c[qa>>2]=o;c[na>>2]=j;c[ya>>2]=i;g=2;break}else if((w|0)!=146)if((w|0)==301){c[Ca>>2]=16208;sa=q;la=i;ka=j;ja=g;ma=1;g=ba}else if((w|0)==302){sa=x;la=i;ka=j;ja=m;ma=k}else if((w|0)==315){g=-4;break}c[wa>>2]=y;c[pa>>2]=g;c[f>>2]=ja;c[qa>>2]=h;c[na>>2]=ka;c[ya>>2]=la;if(!(c[oa>>2]|0)){if((sa|0)!=(g|0)?(c[Ca>>2]|0)>>>0<16209:0)w=306}else w=306;do if((w|0)==306)if(!(Rp(f,y,sa-g|0)|0)){h=c[qa>>2]|0;g=c[pa>>2]|0;break}else{c[Ca>>2]=16210;g=-4;break a}while(0);j=ra-h|0;i=sa-g|0;sa=f+8|0;c[sa>>2]=(c[sa>>2]|0)+j;c[va>>2]=(c[va>>2]|0)+i;c[ta>>2]=(c[ta>>2]|0)+i;if((i|0)!=0&(c[ua>>2]&4|0)!=0){h=c[za>>2]|0;g=(c[wa>>2]|0)+(0-i)|0;if(!(c[xa>>2]|0))g=t8(h,g,i)|0;else g=F8(h,g,i)|0;c[za>>2]=g;c[Ba>>2]=g}g=c[Ca>>2]|0;c[f+44>>2]=(c[Aa>>2]|0?64:0)+(c[ya>>2]|0)+((g|0)==16191?128:0)+((g|0)==16199|(g|0)==16194?256:0);g=(ma|(j|i)|0)==0?-5:ma}else g=-2;while(0);l=Da;return g|0}function Mb(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0;nb=l;l=l+144|0;ua=nb+96|0;Ca=nb+84|0;Ja=nb+72|0;Ra=nb+60|0;Za=nb+48|0;eb=nb+36|0;r=nb+24|0;A=nb+12|0;H=nb;$x(ua,b,d,e,f,1);lb=a[ua+8+3>>0]|0;do if(!((lb<<24>>24<0?c[ua+4>>2]|0:lb&255)|0))z5(ua);else{if((d|0)==2){z5(ua);if((f|2|0)==238)break}else z5(ua);ia=f+1|0;Ed(b,d,e,ia);ja=f+2|0;Ed(b,d,e,ja);ka=f+3|0;Ed(b,d,e,ka);la=f+4|0;Ed(b,d,e,la);ma=f+5|0;Ed(b,d,e,ma);na=f+6|0;Ed(b,d,e,na);mI(ua);Xy(Ca,41840);z3(ua,Ca);z5(Ca);$x(Ca,b,d,e,f,1);og(ua,Ca);z5(Ca);oa=ua+4|0;pa=r+8+3|0;qa=r+4|0;ra=Za+8+3|0;sa=Za+4|0;ta=r+8+3|0;va=r+4|0;wa=Za+8+3|0;xa=Za+4|0;ya=A+8+3|0;za=A+4|0;Aa=Za+8+3|0;Ba=Za+4|0;Da=Za+8+3|0;Ea=Za+4|0;Fa=Ca+8+3|0;Ga=Ca+4|0;Ha=r+8+3|0;Ia=r+4|0;Ka=Za+8+3|0;La=Za+4|0;Ma=Ja+8+3|0;Na=Ja+4|0;Oa=r+8+3|0;Pa=r+4|0;Qa=Za+8+3|0;Sa=Za+4|0;Ta=A+8+3|0;Ua=A+4|0;Va=Za+8+3|0;Wa=Za+4|0;Xa=Za+8+3|0;Ya=Za+4|0;_a=r+8+3|0;$a=r+4|0;ab=Za+8+3|0;bb=Za+4|0;cb=r+8+3|0;db=r+4|0;fb=Za+8+3|0;gb=Za+4|0;hb=A+8+3|0;ib=A+4|0;jb=Za+8+3|0;kb=Za+4|0;lb=Za+8+3|0;s=Za+4|0;t=r+8+3|0;u=r+4|0;v=Za+8+3|0;w=Za+4|0;x=r+8+3|0;y=r+4|0;B=Za+8+3|0;C=Za+4|0;D=r+8+3|0;E=r+4|0;F=Za+8+3|0;G=Za+4|0;I=r+8+3|0;J=r+4|0;K=Za+8+3|0;L=Za+4|0;M=Za+8+3|0;N=Za+4|0;P=Ra+8+3|0;Q=Ra+4|0;R=eb+8+3|0;S=eb+4|0;T=Za+8+3|0;U=Za+4|0;V=r+8+3|0;W=r+4|0;X=(d|0)==1;Y=A+8+3|0;Z=A+4|0;_=A+8+3|0;$=A+4|0;aa=A+8+3|0;ba=A+4|0;ca=A+8+3|0;da=A+4|0;ea=H+8+3|0;fa=H+4|0;ga=A+8+3|0;ha=A+4|0;q=0;while(1){if(q>>>0>=(((c[oa>>2]|0)-(c[ua>>2]|0)|0)/12|0)>>>0)break;TX(Ca);TX(Ja);TX(Ra);k=sn((c[ua>>2]|0)+(q*12|0)|0)|0;p=(k|0)<0;k=p?0-k|0:k;h=(k|0)/36e5|0;o=(k|0)>3599999;if(o){tU(eb,h,10);Xy(A,7500);pl(r,A);g=a[pa>>0]|0;n=g<<24>>24<0;Ex(eb,n?c[r>>2]|0:r,n?c[qa>>2]|0:g&255)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}g=a[ra>>0]|0;n=g<<24>>24<0;Ex(Ca,n?c[Za>>2]|0:Za,n?c[sa>>2]|0:g&255)|0;O0(Za);z5(r);z5(A);z5(eb);tU(eb,h,10);Xy(A,7500);pl(r,A);g=a[ta>>0]|0;n=g<<24>>24<0;Ex(eb,n?c[r>>2]|0:r,n?c[va>>2]|0:g&255)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}n=a[wa>>0]|0;m=n<<24>>24<0;Ex(Ja,m?c[Za>>2]|0:Za,m?c[xa>>2]|0:n&255)|0;O0(Za);z5(r);z5(A);z5(eb);if((k|0)<36e6){Xy(r,42196);tU(A,h,10);g=a[ya>>0]|0;n=g<<24>>24<0;Ex(r,n?c[A>>2]|0:A,n?c[za>>2]|0:g&255)|0;c[eb>>2]=c[r>>2];c[eb+4>>2]=c[r+4>>2];c[eb+8>>2]=c[r+8>>2];g=0;while(1){if((g|0)==3)break;c[r+(g<<2)>>2]=0;g=g+1|0}HX(eb,42204)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}n=a[Aa>>0]|0;m=n<<24>>24<0;Ex(Ra,m?c[Za>>2]|0:Za,m?c[Ba>>2]|0:n&255)|0;O0(Za);O0(eb);z5(A);z5(r)}else{tU(eb,h,10);HX(eb,42204)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}n=a[Da>>0]|0;m=n<<24>>24<0;Ex(Ra,m?c[Za>>2]|0:Za,m?c[Ea>>2]|0:n&255)|0;O0(Za);z5(eb)}n=(O(h,-36e5)|0)+k|0}else{HX(Ra,7508)|0;n=k}h=(n|0)/6e4|0;m=(n|0)>59999;if(o|m){j=a[Fa>>0]|0;if((j<<24>>24<0?c[Ga>>2]|0:j&255)|0)HX(Ca,42252)|0;tU(eb,h,10);Xy(A,7524);pl(r,A);g=a[Ha>>0]|0;j=g<<24>>24<0;Ex(eb,j?c[r>>2]|0:r,j?c[Ia>>2]|0:g&255)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}g=a[Ka>>0]|0;j=g<<24>>24<0;Ex(Ca,j?c[Za>>2]|0:Za,j?c[La>>2]|0:g&255)|0;O0(Za);z5(r);z5(A);z5(eb);g=a[Ma>>0]|0;g=g<<24>>24<0?c[Na>>2]|0:g&255;if(g>>>0<5){if(g|0)HX(Ja,42252)|0;tU(eb,h,10);Xy(A,7524);pl(r,A);g=a[Oa>>0]|0;j=g<<24>>24<0;Ex(eb,j?c[r>>2]|0:r,j?c[Pa>>2]|0:g&255)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}j=a[Qa>>0]|0;i=j<<24>>24<0;Ex(Ja,i?c[Za>>2]|0:Za,i?c[Sa>>2]|0:j&255)|0;O0(Za);z5(r);z5(A);z5(eb)}if((n|0)<6e5){Xy(r,42196);tU(A,h,10);g=a[Ta>>0]|0;j=g<<24>>24<0;Ex(r,j?c[A>>2]|0:A,j?c[Ua>>2]|0:g&255)|0;c[eb>>2]=c[r>>2];c[eb+4>>2]=c[r+4>>2];c[eb+8>>2]=c[r+8>>2];g=0;while(1){if((g|0)==3)break;c[r+(g<<2)>>2]=0;g=g+1|0}HX(eb,42204)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}j=a[Va>>0]|0;i=j<<24>>24<0;Ex(Ra,i?c[Za>>2]|0:Za,i?c[Wa>>2]|0:j&255)|0;O0(Za);O0(eb);z5(A);z5(r)}else{tU(eb,h,10);HX(eb,42204)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}j=a[Xa>>0]|0;i=j<<24>>24<0;Ex(Ra,i?c[Za>>2]|0:Za,i?c[Ya>>2]|0:j&255)|0;O0(Za);z5(eb)}h=(O(h,-6e4)|0)+n|0}else{HX(Ra,7508)|0;h=n}i=(h|0)/1e3|0;j=(h|0)>999;k=(k+3599999|0)>>>0<7199999;if(o|(m|j)){g=a[Fa>>0]|0;if((g<<24>>24<0?c[Ga>>2]|0:g&255)|0)HX(Ca,42252)|0;tU(eb,i,10);Xy(A,15696);pl(r,A);g=a[_a>>0]|0;ob=g<<24>>24<0;Ex(eb,ob?c[r>>2]|0:r,ob?c[$a>>2]|0:g&255)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}ob=a[ab>>0]|0;g=ob<<24>>24<0;Ex(Ca,g?c[Za>>2]|0:Za,g?c[bb>>2]|0:ob&255)|0;O0(Za);z5(r);z5(A);z5(eb);if(k){ob=a[Ma>>0]|0;if((ob<<24>>24<0?c[Na>>2]|0:ob&255)|0)HX(Ja,42252)|0;tU(eb,i,10);Xy(A,15696);pl(r,A);g=a[cb>>0]|0;ob=g<<24>>24<0;Ex(eb,ob?c[r>>2]|0:r,ob?c[db>>2]|0:g&255)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}ob=a[fb>>0]|0;g=ob<<24>>24<0;Ex(Ja,g?c[Za>>2]|0:Za,g?c[gb>>2]|0:ob&255)|0;O0(Za);z5(r);z5(A);z5(eb)}if((h|0)<1e4){Xy(r,42196);tU(A,i,10);g=a[hb>>0]|0;ob=g<<24>>24<0;Ex(r,ob?c[A>>2]|0:A,ob?c[ib>>2]|0:g&255)|0;c[eb>>2]=c[r>>2];c[eb+4>>2]=c[r+4>>2];c[eb+8>>2]=c[r+8>>2];g=0;while(1){if((g|0)==3)break;c[r+(g<<2)>>2]=0;g=g+1|0}HX(eb,42212)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}ob=a[jb>>0]|0;g=ob<<24>>24<0;Ex(Ra,g?c[Za>>2]|0:Za,g?c[kb>>2]|0:ob&255)|0;O0(Za);O0(eb);z5(A);z5(r)}else{tU(eb,i,10);HX(eb,42212)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}ob=a[lb>>0]|0;g=ob<<24>>24<0;Ex(Ra,g?c[Za>>2]|0:Za,g?c[s>>2]|0:ob&255)|0;O0(Za);z5(eb)}h=(O(i,-1e3)|0)+h|0}else HX(Ra,7536)|0;do if(o|(m|(j|(h|0)>0))){ob=a[Fa>>0]|0;if((ob<<24>>24<0?c[Ga>>2]|0:ob&255)|0)HX(Ca,42252)|0;tU(eb,h,10);Xy(A,29056);pl(r,A);g=a[t>>0]|0;ob=g<<24>>24<0;Ex(eb,ob?c[r>>2]|0:r,ob?c[u>>2]|0:g&255)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}ob=a[v>>0]|0;o=ob<<24>>24<0;Ex(Ca,o?c[Za>>2]|0:Za,o?c[w>>2]|0:ob&255)|0;O0(Za);z5(r);z5(A);z5(eb);if(k&(n+59999|0)>>>0<119999){ob=a[Ma>>0]|0;if((ob<<24>>24<0?c[Na>>2]|0:ob&255)|0)HX(Ja,42252)|0;tU(eb,h,10);Xy(A,29056);pl(r,A);g=a[x>>0]|0;ob=g<<24>>24<0;Ex(eb,ob?c[r>>2]|0:r,ob?c[y>>2]|0:g&255)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}ob=a[B>>0]|0;o=ob<<24>>24<0;Ex(Ja,o?c[Za>>2]|0:Za,o?c[C>>2]|0:ob&255)|0;O0(Za);z5(r);z5(A);z5(eb)}if((h|0)<10){Xy(eb,42220);tU(r,h,10);g=a[D>>0]|0;ob=g<<24>>24<0;Ex(eb,ob?c[r>>2]|0:r,ob?c[E>>2]|0:g&255)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}ob=a[F>>0]|0;o=ob<<24>>24<0;Ex(Ra,o?c[Za>>2]|0:Za,o?c[G>>2]|0:ob&255)|0;O0(Za);z5(r);z5(eb);break}if((h|0)>=100){tU(Za,h,10);ob=a[M>>0]|0;o=ob<<24>>24<0;Ex(Ra,o?c[Za>>2]|0:Za,o?c[N>>2]|0:ob&255)|0;z5(Za);break}Xy(eb,42196);tU(r,h,10);g=a[I>>0]|0;ob=g<<24>>24<0;Ex(eb,ob?c[r>>2]|0:r,ob?c[J>>2]|0:g&255)|0;c[Za>>2]=c[eb>>2];c[Za+4>>2]=c[eb+4>>2];c[Za+8>>2]=c[eb+8>>2];g=0;while(1){if((g|0)==3)break;c[eb+(g<<2)>>2]=0;g=g+1|0}ob=a[K>>0]|0;o=ob<<24>>24<0;Ex(Ra,o?c[Za>>2]|0:Za,o?c[L>>2]|0:ob&255)|0;O0(Za);z5(r);z5(eb)}else HX(Ra,34252)|0;while(0);if(p){Xy(r,42040);g=a[Fa>>0]|0;ob=g<<24>>24<0;Ex(r,ob?c[Ca>>2]|0:Ca,ob?c[Ga>>2]|0:g&255)|0;c[eb>>2]=c[r>>2];c[eb+4>>2]=c[r+4>>2];c[eb+8>>2]=c[r+8>>2];g=0;while(1){if((g|0)==3)break;c[r+(g<<2)>>2]=0;g=g+1|0}p2(Za,eb);vF(Ca,Za)|0;z5(Za);O0(eb);z5(r);Xy(r,42040);g=a[Ma>>0]|0;ob=g<<24>>24<0;Ex(r,ob?c[Ja>>2]|0:Ja,ob?c[Na>>2]|0:g&255)|0;c[eb>>2]=c[r>>2];c[eb+4>>2]=c[r+4>>2];c[eb+8>>2]=c[r+8>>2];g=0;while(1){if((g|0)==3)break;c[r+(g<<2)>>2]=0;g=g+1|0}p2(Za,eb);vF(Ja,Za)|0;z5(Za);O0(eb);z5(r);Xy(r,42040);g=a[P>>0]|0;ob=g<<24>>24<0;Ex(r,ob?c[Ra>>2]|0:Ra,ob?c[Q>>2]|0:g&255)|0;c[eb>>2]=c[r>>2];c[eb+4>>2]=c[r+4>>2];c[eb+8>>2]=c[r+8>>2];g=0;while(1){if((g|0)==3)break;c[r+(g<<2)>>2]=0;g=g+1|0}p2(Za,eb);vF(Ra,Za)|0;z5(Za);O0(eb);z5(r)}zb(b,d,e,ia,Ja,0);zb(b,d,e,ja,Ca,0);zb(b,d,e,ka,Ja,0);zb(b,d,e,la,Ra,0);if((Rb(d,22)|0)==(f|0)){TX(Za);$x(eb,b,d,e,Rb(d,48)|0,1);$x(r,b,d,e,Rb(d,52)|0,1);ob=a[R>>0]|0;if((((ob<<24>>24<0?c[S>>2]|0:ob&255)|0?(ob=a[V>>0]|0,(ob<<24>>24<0?c[W>>2]|0:ob&255)|0):0)?(ob=rm(eb)|0,!((ob|0)==0&(z|0)==0)):0)?(ob=rm(eb)|0,p=z,p>>>0<0|(p|0)==0&ob>>>0<256):0){a:do if(X){$x(A,b,1,e,245,1);ob=a[Y>>0]|0;g=ob<<24>>24<0;b:do if((g?c[Z>>2]|0:ob&255)>>>0>10){g=g?c[A>>2]|0:A;if((c[g+8>>2]|0)!=58)break;if((c[g+20>>2]|0)!=58)break;switch(c[g+32>>2]|0){case 58:{g=0;break}case 59:{g=1;break}default:break b}z5(A);break a}while(0);z5(A);mb=133}else mb=133;while(0);c:do if((mb|0)==133){mb=0;$x(A,b,d,e,Rb(d,82)|0,1);ob=a[_>>0]|0;g=ob<<24>>24<0;d:do if((g?c[$>>2]|0:ob&255)>>>0>10){g=g?c[A>>2]|0:A;if((c[g+8>>2]|0)!=58)break;if((c[g+20>>2]|0)!=58)break;switch(c[g+32>>2]|0){case 58:{g=0;break}case 59:{g=1;break}default:break d}z5(A);break c}while(0);z5(A);$x(A,b,0,0,57,1);g=i9(24116)|0;ob=a[aa>>0]|0;if((g|0)==((ob<<24>>24<0?c[ba>>2]|0:ob&255)|0))g=(VG(A,24116,g)|0)==0;else g=0;z5(A);i=(g^1)&1;e:while(1){if(i>>>0>=2){mb=160;break}j=(i|0)==0;h=0;while(1){if(h>>>0>=(RA(b,4,-1)|0)>>>0)break;$x(A,b,4,h,18,1);g=i9(7552)|0;ob=a[ca>>0]|0;f:do if((g|0)==((ob<<24>>24<0?c[da>>2]|0:ob&255)|0)){if(VG(A,7552,g)|0){mb=150;break}do if(j){$x(H,b,4,h,92,1);g=i9(7592)|0;ob=a[ea>>0]|0;if((g|0)==((ob<<24>>24<0?c[fa>>2]|0:ob&255)|0)){ob=(VG(H,7592,g)|0)==0;z5(H);z5(A);if(ob)break;else break f}else{z5(H);z5(A);break f}}else z5(A);while(0);$x(A,b,4,h,91,1);ob=a[ga>>0]|0;g=ob<<24>>24<0;do if((g?c[ha>>2]|0:ob&255)>>>0>10){g=g?c[A>>2]|0:A;if((c[g+8>>2]|0)!=58)break;if((c[g+20>>2]|0)!=58)break;switch(c[g+32>>2]|0){case 58:{mb=161;break e}case 59:{g=1;break e}default:{}}}while(0);z5(A)}else mb=150;while(0);if((mb|0)==150){mb=0;z5(A)}h=h+1|0}i=i+1|0}if((mb|0)==160){mb=0;qb=+Cq(eb);pb=+(r6(+Cq(eb))|0);g=qb<pb&qb>=pb/1.0019999742507935;break}else if((mb|0)==161){mb=0;g=0}z5(A)}while(0);p=tm(r)|0;ob=z;Sk(A,p,ob,(r6(+Cq(eb))|0)&255,g);nk(H,A);sY(Za,H)|0;a1(H);zb(b,d,e,ma,Za,0)}p2(A,Ra);ob=a[T>>0]|0;if((ob<<24>>24<0?c[U>>2]|0:ob&255)|0){Gx(A,32);Gx(A,40);ob=a[T>>0]|0;p=ob<<24>>24<0;Ex(A,p?c[Za>>2]|0:Za,p?c[U>>2]|0:ob&255)|0;Gx(A,41)}zb(b,d,e,na,A,0);z5(A);z5(r);z5(eb);z5(Za)}z5(Ra);z5(Ja);z5(Ca);q=q+1|0}$_(ua)}while(0);l=nb;return}function Nb(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+48|0;n=r+36|0;o=r+24|0;p=r+12|0;q=r;j=XZ(d|0,e|0,24)|0;k=XZ(d|0,e|0,16)|0;g=b+4|0;h=XZ(d|0,e|0,8)|0;i=b+11|0;a:do if((d|0)<1667331175){if((d|0)<-1452449429){if((d|0)<-1453037198){if((d|0)<-1453230732)if((d|0)<-1453233054)if((d|0)<-1454353852){switch(d|0){case -1455336876:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380530)|0;f=1;break}else{switch(d|0){case -1454353852:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374775)|0;f=1;break}else switch(d|0){case -1453233054:{if(e|0){m=186;break a}IX(b,379545)|0;f=1;break a}case -1453231516:{if(e|0){m=186;break a}IX(b,374657)|0;f=1;break a}case -1453231513:{if(e|0){m=186;break a}IX(b,374666)|0;f=1;break a}default:{m=186;break a}}if((d|0)<-1453100935){if((d|0)<-1453102738){switch(d|0){case -1453230732:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380530)|0;f=1;break}switch(d|0){case -1453102738:{if(e|0){m=186;break a}IX(b,380540)|0;f=1;break a}case -1453101708:{if(e|0){m=186;break a}IX(b,379557)|0;f=1;break a}default:{m=186;break a}}}else{if((d|0)<-1453039239){switch(d|0){case -1453100935:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380189)|0;f=1;break}switch(d|0){case -1453039239:{if(e|0){m=186;break a}IX(b,374675)|0;f=1;break a}case -1453038221:{if(e|0){m=186;break a}IX(b,374689)|0;f=1;break a}default:{m=186;break a}}}}if((d|0)<-1452841618){if((d|0)<-1452972948)switch(d|0){case -1453037198:{if(e|0){m=186;break a}IX(b,374657)|0;f=1;break a}case -1453037197:{if(e|0){m=186;break a}IX(b,374700)|0;f=1;break a}default:{m=186;break a}}if((d|0)<-1452970397){switch(d|0){case -1452972948:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377042)|0;f=1;break}if((d|0)<-1452905100){switch(d|0){case -1452970397:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377532)|0;f=1;break}else{switch(d|0){case -1452905100:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374711)|0;f=1;break}}if((d|0)<-1452708250){if((d|0)<-1452838288){switch(d|0){case -1452841618:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,379551)|0;f=1;break}if((d|0)<-1452773517){switch(d|0){case -1452838288:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374718)|0;f=1;break}else{switch(d|0){case -1452773517:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374727)|0;f=1;break}}else{if((d|0)<-1452579463){switch(d|0){case -1452708250:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374689)|0;f=1;break}if((d|0)<-1452508814){switch(d|0){case -1452579463:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,376968)|0;f=1;break}else{switch(d|0){case -1452508814:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374740)|0;f=1;break}}}if((d|0)<-1452050574)if((d|0)<-1452248474){if((d|0)<-1452383891)if((d|0)<-1452445852){switch(d|0){case -1452449429:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,379899)|0;f=1;break}else{switch(d|0){case -1452445852:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,379904)|0;f=1;break}if((d|0)<-1452314523){switch(d|0){case -1452383891:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380183)|0;f=3;break}if((d|0)<-1452248476){switch(d|0){case -1452314523:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374747)|0;f=1;break}else{switch(d|0){case -1452248476:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374766)|0;f=1;break}}else{if((d|0)>=-1452052628)switch(d|0){case -1452052628:{if(e|0){m=186;break a}IX(b,380540)|0;f=1;break a}case -1452051869:{if(e|0){m=186;break a}IX(b,374797)|0;f=1;break a}case -1452051453:{if(e|0){m=186;break a}IX(b,387915)|0;f=1;break a}default:{m=186;break a}}if((d|0)<-1452120719){switch(d|0){case -1452248474:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380530)|0;f=1;break}if((d|0)<-1452052891){switch(d|0){case -1452120719:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,379557)|0;f=1;break}else{switch(d|0){case -1452052891:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374783)|0;f=1;break}}if((d|0)<1631670868)if((d|0)<-1451789714){if((d|0)<-1451987089){switch(d|0){case -1452050574:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377532)|0;f=1;break}if((d|0)<-1451920788){switch(d|0){case -1451987089:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377532)|0;f=1;break}else{switch(d|0){case -1451920788:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374811)|0;f=1;break}}else{if((d|0)<-1451789708){switch(d|0){case -1451789714:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374821)|0;f=1;break}if((d|0)<-1451724700){switch(d|0){case -1451789708:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380521)|0;f=1;break}else{switch(d|0){case -1451724700:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374829)|0;f=1;break}}else if((d|0)<1634748740){if((d|0)<1634421060){switch(d|0){case 1631670868:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374847)|0;f=2;break}if((d|0)<1634493037){switch(d|0){case 1634421060:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377624)|0;f=5;break}else{switch(d|0){case 1634493037:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,379545)|0;f=2;break}}else{if((d|0)<1635010884){switch(d|0){case 1634748740:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374863)|0;f=1;break}if((d|0)<1635087464){switch(d|0){case 1635010884:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374881)|0;f=5;break}else{switch(d|0){case 1635087464:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380530)|0;f=2;break}}}else{if((d|0)>=1918989413){if((d|0)<1953068140)if((d|0)<1936679276){if((d|0)<1935959411)if((d|0)<1920233063){switch(d|0){case 1918989413:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380211)|0;f=5;break}else{switch(d|0){case 1920233063:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380211)|0;f=5;break}if((d|0)<1936083268){switch(d|0){case 1935959411:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380199)|0;f=1;break}if((d|0)<1936679265){switch(d|0){case 1936083268:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377646)|0;f=5;break}else{switch(d|0){case 1936679265:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,375025)|0;f=1;break}}else{if((d|0)<1936682605)switch(d|0){case 1936679276:{if(e|0){m=186;break a}IX(b,375046)|0;f=2;break a}case 1936679282:{if(e|0){m=186;break a}IX(b,375057)|0;f=1;break a}case 1936679791:{if(e|0){m=186;break a}IX(b,375072)|0;f=1;break a}default:{m=186;break a}}if((d|0)<1936683886){switch(d|0){case 1936682605:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,375086)|0;f=1;break}if((d|0)<1937009003){switch(d|0){case 1936683886:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,375086)|0;f=1;break}else{switch(d|0){case 1937009003:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377612)|0;f=5;break}}if((d|0)>=1953918574){if((d|0)<2020172832)switch(d|0){case 1953918574:{if(e|0){m=186;break a}IX(b,375111)|0;f=1;break a}case 1953919848:{if(e|0){m=186;break a}IX(b,375125)|0;f=1;break a}case 1953919854:{if(e|0){m=186;break a}IX(b,375136)|0;f=1;break a}default:{m=186;break a}}if((d|0)<2036687218){switch(d|0){case 2020172832:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377353)|0;f=1;break}if((d|0)<2038002275){switch(d|0){case 2036687218:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374675)|0;f=2;break}else{switch(d|0){case 2038002275:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374675)|0;f=2;break}}if((d|0)>=1953655662){if((d|0)<1953916270){switch(d|0){case 1953655662:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,375097)|0;f=5;break}switch(d|0){case 1953916270:{if(e|0){m=186;break a}IX(b,375103)|0;f=5;break a}case 1953916275:{if(e|0){m=186;break a}IX(b,374923)|0;f=1;break a}default:{m=186;break a}}}if((d|0)<1953329263){switch(d|0){case 1953068140:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380183)|0;f=2;break}if((d|0)<1953460076){switch(d|0){case 1953329263:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377608)|0;f=5;break}else{switch(d|0){case 1953460076:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377532)|0;f=3;break}}if((d|0)<1735554416){if((d|0)<1684632427){if((d|0)<1668311404)if((d|0)<1668172100){switch(d|0){case 1667331175:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374894)|0;f=1;break}else{switch(d|0){case 1668172100:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374903)|0;f=1;break}if((d|0)<1668313716){switch(d|0){case 1668311404:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377572)|0;f=5;break}if((d|0)<1684370275){switch(d|0){case 1668313716:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380189)|0;f=2;break}else{switch(d|0){case 1684370275:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380199)|0;f=1;break}}if((d|0)<1718384242){if((d|0)<1685283696){switch(d|0){case 1684632427:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374923)|0;f=5;break}if((d|0)<1701276004){switch(d|0){case 1685283696:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374689)|0;f=2;break}else{switch(d|0){case 1701276004:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374928)|0;f=5;break}}else{if((d|0)<1734691140){switch(d|0){case 1718384242:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374950)|0;f=5;break}if((d|0)<1735291493){switch(d|0){case 1734691140:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374958)|0;f=5;break}else{switch(d|0){case 1735291493:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,379551)|0;f=2;break}}}if((d|0)<1885565812)if((d|0)<1801812343){if((d|0)<1751414372){switch(d|0){case 1735554416:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374718)|0;f=1;break}if((d|0)<1769238133){switch(d|0){case 1751414372:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377584)|0;f=5;break}else{switch(d|0){case 1769238133:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377592)|0;f=5;break}}else{if((d|0)<1818518899){switch(d|0){case 1801812343:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374966)|0;f=1;break}if((d|0)<1851878757){switch(d|0){case 1818518899:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374974)|0;f=1;break}else{switch(d|0){case 1851878757:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380183)|0;f=1;break}}else{if((d|0)>=1886144836){if((d|0)<1886745188){switch(d|0){case 1886144836:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,374990)|0;f=5;break}switch(d|0){case 1886745188:{if(e|0){m=186;break a}IX(b,375001)|0;f=1;break a}case 1886745196:{if(e|0){m=186;break a}IX(b,375014)|0;f=1;break a}default:{m=186;break a}}}if((d|0)<1885696614){switch(d|0){case 1885565812:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,377600)|0;f=5;break}if((d|0)<1885823344){switch(d|0){case 1885696614:break;default:{m=186;break a}}if(e|0){m=186;break}IX(b,380530)|0;f=2;break}switch(d|0){case 1885823344:break;default:{m=186;break a}}if(e|0){m=186;break}if((a[i>>0]|0)<0){J7(c[b>>2]|0,0);c[g>>2]=0;f=0;break}else{J7(b,0);a[i>>0]=0;f=0;break}}}while(0);if((m|0)==186){if((a[i>>0]|0)<0){J7(c[b>>2]|0,0);c[g>>2]=0}else{J7(b,0);a[i>>0]=0}ay(b,1,j&255)|0;ay(b,1,k&255)|0;ay(b,1,h&255)|0;ay(b,1,d&255)|0;f=1}TX(n);Fx(n,1,j&255)|0;Fx(n,1,k&255)|0;Fx(n,1,h&255)|0;Fx(n,1,d&255)|0;Xy(o,23736);m=Dy(o,n)|0;z5(o);if(m){Xy(q,23736);UF(p,q,n);pk(o,p);if((a[i>>0]|0)<0){J7(c[b>>2]|0,0);c[g>>2]=0}else{J7(b,0);a[i>>0]=0}Fp(b,0);c[b>>2]=c[o>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];e=0;while(1){if((e|0)==3)break;c[o+(e<<2)>>2]=0;e=e+1|0}a1(o);z5(p);z5(q)}z5(n);l=r;return f|0}function Ob(b){b=b|0;var e=0,f=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;V=l;l=l+64|0;f=V+56|0;s=V+52|0;q=V+48|0;h=V+44|0;E=V+40|0;p=V+36|0;o=V+32|0;r=V+28|0;t=V+24|0;n=V+61|0;C=V+60|0;U=V+12|0;R=V;if(!(a[b+734>>0]|0)){GC(b);c[s>>2]=-1;c[t>>2]=0;a[n>>0]=0;a[C>>0]=0;n3(b,q);n3(b,f);Q=c[f>>2]|0;a:do if(Q>>>0>9){U=c[b+648>>2]|0;G4(U,Z9(c[U+4>>2]|0)|0);J3(b)}else{n3(b,h);f=c[h>>2]|0;h=c[b+864>>2]|0;if(f>>>0<(c[b+868>>2]|0)-h>>2>>>0?(D=h+(f<<2)|0,m=c[D>>2]|0,m|0):0){h=d[m>>0]|0;O=b+840|0;P=b+844|0;f=c[O>>2]|0;if(h>>>0<(c[P>>2]|0)-f>>2>>>0?(i=f+(h<<2)|0,e=c[i>>2]|0,(e|0)!=0):0)S=i;else B=10;do if((B|0)==10){e=c[b+852>>2]|0;if(h>>>0<(c[b+856>>2]|0)-e>>2>>>0?(j=e+(h<<2)|0,k=c[j>>2]|0,k|0):0){S=j;e=k;break}U=c[b+648>>2]|0;G4(U,Z9(c[U+4>>2]|0)|0);J3(b);break a}while(0);if(!(a[e+49>>0]|0))f=m;else{d4(c[b+648>>2]|0,2);f=c[D>>2]|0;e=c[S>>2]|0}c[p>>2]=d[f+1>>0];c[o>>2]=d[f+2>>0];rR(b,(d[e+43>>0]|0)+4&255,E);do if(!(a[(c[S>>2]|0)+51>>0]|0)){yT(b,n);if(!(a[n>>0]|0)){A6(c[b+648>>2]|0);A=0;break}else{GC(b);A6(c[b+648>>2]|0);AT(b,C);J3(b);A=1;break}}else A=0;while(0);T=b+520|0;N=T;if((c[N>>2]|0)==5&(c[N+4>>2]|0)==0)T5(b);e=c[S>>2]|0;if((a[e+44>>0]|0)==0?(rR(b,(d[e+45>>0]|0)+4&255,s),A<<24>>24==0?(a[(c[D>>2]|0)+13>>0]|0)!=0:0):0)o3(b,t);N=c[S>>2]|0;if(((a[N+44>>0]|0)==1?(a[N+50>>0]|0)==0:0)?(L5(b),A<<24>>24==0?(a[(c[D>>2]|0)+13>>0]|0)!=0:0):0)L5(b);if(a[(c[D>>2]|0)+15>>0]|0)T5(b);switch(Q|0){case 1:case 6:{A6(c[b+648>>2]|0);switch(Q|0){case 8:case 6:case 5:case 3:case 1:case 0:{B=32;break}default:{}}break}case 8:case 5:case 3:case 0:{B=32;break}default:{}}do if((B|0)==32){e=b+648|0;if(!(K6(c[e>>2]|0)|0)){A6(c[e>>2]|0);break}GC(b);A6(c[e>>2]|0);n3(b,p);switch(Q|0){case 6:case 1:{n3(b,o);break}default:{}}J3(b)}while(0);e=T;yj(b,Q,(c[e>>2]|0)==20&(c[e+4>>2]|0)==0);e=c[D>>2]|0;if(!(a[e+14>>0]|0))B=39;else switch(Q|0){case 0:case 3:case 5:case 8:{B=41;break}default:B=39}if((B|0)==39?(a[e+3>>0]|0)==1:0)switch(Q|0){case 1:case 6:{B=41;break}default:{}}if((B|0)==41){N=c[p>>2]|0;Fs(b,N,i$(c[S>>2]|0)|0)}c[U>>2]=0;i=U+4|0;c[i>>2]=0;c[U+8>>2]=0;k=b+1044|0;if(a[k>>0]|0)Gm(b,U);b:do if(a[(c[D>>2]|0)+12>>0]|0){switch(Q|0){case 2:case 4:case 7:case 9:break b;default:{}}T5(b)}while(0);L5(b);switch(Q|0){case 8:case 3:{A6(c[b+648>>2]|0);B=49;break}case 9:case 4:{B=49;break}default:{}}if((B|0)==49)L5(b);if(a[(c[D>>2]|0)+16>>0]|0?(n3(b,r),(c[r>>2]|0)!=1):0){L5(b);L5(b)}J3(b);c:do if(qO(b)|0){I=c[q>>2]|0;J=(I|0)==0;M=b+880|0;d:do if(J){N=T;if((c[N>>2]|0)==20&(c[N+4>>2]|0)==0)break;switch(Q|0){case 2:case 7:break;default:break d}c[M>>2]=(c[M>>2]|0)+1}while(0);N=A<<24>>24==0;p=c[S>>2]|0;do if(!N){e=p+47|0;if((a[e>>0]|0)!=-1)break;a[e>>0]=a[C>>0]|0?2:1}while(0);h=a[p+44>>0]|0;F=b+924|0;K=b+784|0;G=b+920|0;H=b+1020|0;L=b+788|0;do if(J&h<<24>>24!=1){f=T;e=c[f>>2]|0;f=c[f+4>>2]|0;if((e|0)==20&(f|0)==0?(c[O>>2]|0)!=(c[P>>2]|0):0){k=0;break}do if(!N){y=b+928|0;c[y>>2]=(c[y>>2]|0)+1;if(!(a[C>>0]|0)){c[G>>2]=(c[G>>2]|0)+1;break}else{c[F>>2]=(c[F>>2]|0)+1;break}}else{y=b+932|0;c[y>>2]=(c[y>>2]|0)+1}while(0);q=b+900|0;x=b+800|0;u=b+884|0;v=b+824|0;w=b+812|0;y=b+804|0;j=(e|0)==5&(f|0)==0;switch(h<<24>>24){case 0:{m=b+892|0;n=b+888|0;k=p+28|0;o=a[C>>0]|0;do if(j){c[u>>2]=0;c[n>>2]=0;e=c[y>>2]|0;c[w>>2]=(e&1)+e;e=v;c[e>>2]=0;c[e+4>>2]=0;e=c[s>>2]|0;h=0;B=85}else{f=c[i>>2]|0;e=c[U>>2]|0;while(1){if((e|0)==(f|0)){B=78;break}if((a[e>>0]|0)==5){B=75;break}else e=e+1|0}if((B|0)==75){c[u>>2]=0;if(!(o<<24>>24))e=c[m>>2]|0;else e=0;c[n>>2]=e;h=e}else if((B|0)==78)h=c[n>>2]|0;i=c[s>>2]|0;if((h|0)==-1){e=(d[p+46>>0]<<1)+6|0;if(i>>>0<=e>>>0){f=0;e=i;break}c[x>>2]=i-e;f=0;e=i;break}if(h>>>0<=i>>>0){e=i;B=85;break}e=c[k>>2]|0;if((h-i|0)>>>0<e>>>1>>>0){e=i;B=85;break}f=(c[u>>2]|0)+e|0;e=i}while(0);do if((B|0)==85){f=c[u>>2]|0;if(e>>>0<=h>>>0)break;s=c[k>>2]|0;f=f-((e-h|0)>>>0>s>>>1>>>0?s:0)|0}while(0);h=f+e|0;t=N?0:c[t>>2]|0;c[u>>2]=f;c[n>>2]=e;c[m>>2]=h;h=(o<<24>>24?t:0)+h|0;e=((h|0)<0)<<31>>31;break}case 2:{f=c[i>>2]|0;e=c[U>>2]|0;while(1){if((e|0)==(f|0))break;if((a[e>>0]|0)==5){B=91;break}else e=e+1|0}if((B|0)==91)c[q>>2]=0;f=b+896|0;i=c[E>>2]|0;if(j){h=c[y>>2]|0;c[w>>2]=(h&1)+h;h=0;e=0}else{e=c[q>>2]|0;do if((e|0)==-1)e=0;else{if((c[f>>2]|0)>>>0<=i>>>0)break;e=(c[p+32>>2]|0)+e|0}while(0);h=e+i<<1;h=(((a[k>>0]|0)==0&(h|0)!=0)<<31>>31)+h|0}c[f>>2]=i;c[q>>2]=e;c[s>>2]=i;e=0;break}default:{e=0;h=0}}m=v;k=c[m>>2]|0;m=c[m+4>>2]|0;f=(e|0)<0;s=b+816|0;r=b+808|0;e:do if(!((m|0)>(e|0)|(m|0)==(e|0)&k>>>0>h>>>0)){i=c[w>>2]|0;if(f){f=k;j=m;B=108}else n=k}else{if(!f){t=c[x>>2]|0;i=c[w>>2]|0;f=z0(i|0,0,h|0,e|0)|0;if(t>>>0<=f>>>0){n=k;break}c[x>>2]=f;n=k;break}j=z0(c[w>>2]|0,0,k|0,m|0)|0;f=D_(k|0,m|0,h|0,e|0)|0;i=c[r>>2]<<2;do if(j>>>0<i>>>0&(j+f|0)>>>0<i>>>0){B=c[y>>2]|0;if(!((B-j|0)>>>0<i>>>0&(B>>>0<i>>>0&(B+f|0)>>>0<i>>>0)))break;i=(c[K>>2]|0)+(j<<2)|0;c[R>>2]=0;Pm(K,i,f,R);i=(c[w>>2]|0)+f|0;c[w>>2]=i;c[s>>2]=(c[s>>2]|0)+f;c[y>>2]=(c[y>>2]|0)+f;f=v;c[f>>2]=h;c[f+4>>2]=e;f=h;j=e;B=108;break e}while(0);t4(b);break c}while(0);do if((B|0)==108){t=D_(0,0,h|0,e|0)|0;if(i>>>0>=t>>>0){n=f;m=j;break}t4(b);break c}while(0);t=z0(i|0,0,h|0,e|0)|0;j=c[r>>2]|0;f=c[y>>2]|0;f:do if(t>>>0>=(j*3|0)>>>0){t=f-i|0;g:do if(((t&1)+t|0)>>>0>=j>>>0){if((e|0)<0|(e|0)==0&h>>>0<j>>>0)break;i=j+i|0;c[w>>2]=i;h=D_(h|0,e|0,j|0,0)|0;e=z;k=j>>>1;t=D_(n|0,m|0,k|0,0)|0;c[v>>2]=t;c[v+4>>2]=z;switch(a[(c[S>>2]|0)+44>>0]|0){case 0:{c[u>>2]=(c[u>>2]|0)-j;break g}case 2:{c[q>>2]=(c[q>>2]|0)-k;break g}default:break g}}while(0);o=H+11|0;p=b+1024|0;q=H;while(1){v=z0(i|0,0,h|0,e|0)|0;u=z;if((u|0)<0|(u|0)==0&v>>>0<(j*3|0)>>>0)break f;else{k=0;f=j}while(1){if(k>>>0>=f>>>0)break;f=c[(c[K>>2]|0)+(k<<2)>>2]|0;i=(k&1|0)==0;do if(!f){f=a[o>>0]|0;if(f<<24>>24<0)f=c[p>>2]|0;else f=f&255;if((f|0)==0|i^1)break;gy(H,32)}else{if(i){JX(H,c[33756+(d[f+4>>0]<<2)>>2]|0)|0;i=c[K>>2]|0;f=c[i+(k<<2)>>2]|0;if(!f)f=i;else B=125}else B=125;if((B|0)==125){B=0;laa(f);f=c[K>>2]|0}c[f+(k<<2)>>2]=0}while(0);k=k+1|0;f=c[r>>2]|0}k=a[o>>0]|0;j=k<<24>>24<0;k=k&255;if(j)m=c[p>>2]|0;else m=k;i=c[K>>2]|0;n=(c[L>>2]|0)-i|0;if(m>>>0>=n<<1>>>0){if(j){j=c[H>>2]|0;i=j;f=i+(c[p>>2]|0)|0}else{f=H+k|0;i=H;j=q}Py(H,j-i|0,f+(0-(n>>2))-j|0)|0;i=c[K>>2]|0;f=c[r>>2]|0}j=i;xI(K,j,j+(f<<2)|0);FF(K,c[r>>2]<<2);j=c[r>>2]|0;i=c[w>>2]|0;i=i>>>0>j>>>0?i-j|0:0;c[w>>2]=i;f=c[x>>2]|0;c[x>>2]=f>>>0>j>>>0?f-j|0:0;f=c[y>>2]|0;f=f>>>0>j>>>0?f-j|0:0;c[y>>2]=f;v=c[s>>2]|0;c[s>>2]=v>>>0>j>>>0?v-j|0:0}}while(0);e=z0(i|0,0,h|0,e|0)|0;k=e-(c[s>>2]|0)|0;c[s>>2]=e;if(f>>>0<=e>>>0)c[y>>2]=(a[(c[S>>2]|0)+51>>0]|0?2:1)+e;if((c[x>>2]|0)>>>0>e>>>0)c[x>>2]=e;j=b+796|0;f=c[j>>2]|0;if(f){h=c[K>>2]|0;i=c[h+(e<<2)>>2]|0;if(i){laa(i);h=c[K>>2]|0;e=c[s>>2]|0;f=c[j>>2]|0}c[h+(e<<2)>>2]=f}e=c[(c[K>>2]|0)+(e<<2)>>2]|0;if(!e){B=ZW(8)|0;S7(B);e=c[s>>2]|0;c[(c[K>>2]|0)+(e<<2)>>2]=B;e=c[(c[K>>2]|0)+(e<<2)>>2]|0}c[e>>2]=c[E>>2];a[e+4>>0]=Q;a[e+5>>0]=a[C>>0]^1;a[e+6>>0]=A;if(!(c[j>>2]|0))break;c[j>>2]=0;ry(b,d[c[D>>2]>>0]|0)}else k=0;while(0);m=c[S>>2]|0;f=c[m>>2]|0;u=b+1032|0;n=m+51|0;j=A<<24>>24!=0;do if(f|0){if(!(a[f+29>>0]|0))break;e=c[f+8>>2]|0;if(!e)break;D=cT(1.0e9/(+((c[f+12>>2]|0)>>>0)/+(e>>>0)/((a[m+44>>0]|0)==2?1.0:2.0)/+(d[b+1045>>0]|0))/(j&(a[n>>0]|0)==0?2.0:1.0))|0;E=u;c[E>>2]=D;c[E+4>>2]=z}while(0);f=(k|0)!=0;i=b+1047|0;v=b+312|0;t=b+144|0;s=b+136|0;h:do if(J){E=v;if((c[E>>2]|0)==0&(c[E+4>>2]|0)==0){e=s;h=c[e>>2]|0;e=c[e+4>>2]|0;if((h|0)==-1&(e|0)==-1){h=t;e=c[h>>2]|0;h=c[h+4>>2]|0;D=u;D=UW(c[D>>2]|0,c[D+4>>2]|0,(f?2:1)|0,(f?0:0)|0)|0;E=j&(a[n>>0]|0)==0;E=UW(D|0,z|0,(E?2:1)|0,(E?0:0)|0)|0;h=z0(E|0,z|0,e|0,h|0)|0;e=z;E=s;c[E>>2]=h;c[E+4>>2]=e}E=b+280|0;c[E>>2]=h;c[E+4>>2]=e}switch(Q|0){case 2:case 7:break;default:break h}a[i>>0]=0}else{f=s;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e|0)==-1&(f|0)==-1)){D=u;D=D_(e|0,f|0,c[D>>2]|0,c[D+4>>2]|0)|0;E=s;c[E>>2]=D;c[E+4>>2]=z}f=t;e=c[f>>2]|0;f=c[f+4>>2]|0;if((e|0)==-1&(f|0)==-1)break;D=u;D=D_(e|0,f|0,c[D>>2]|0,c[D+4>>2]|0)|0;E=t;c[E>>2]=D;c[E+4>>2]=z}while(0);e=v;f=c[e>>2]|0;e=c[e+4>>2]|0;q=b+492|0;o=b+328|0;p=b+360|0;r=b+760|0;switch(f|0){case 0:{if(!e)B=178;else B=168;break}case -1:{if((e|0)==-1)B=178;else B=168;break}default:B=168}do if((B|0)==168){do if(!(a[n>>0]|0)){if((c[G>>2]|0)!=(c[F>>2]|0)){B=171;break}if(!(j|(I|0)!=0))B=172}else B=171;while(0);if((B|0)==171?J:0)B=172;if((B|0)==172){I=T;if(!((c[I>>2]|0)==20&(c[I+4>>2]|0)==0)){B=178;break}if((c[O>>2]|0)==(c[P>>2]|0)){B=178;break}}f=z0(f|0,e|0,-1,-1)|0;e=z;R=v;c[R>>2]=f;c[R+4>>2]=e;do if(c[M>>2]|0){i=p;h=c[i>>2]|0;i=c[i+4>>2]|0;if((h|0)==-1&(i|0)==-1)break;Q=z0(h|0,i|0,-1,-1)|0;R=p;c[R>>2]=Q;c[R+4>>2]=z}while(0);Q=o;Q=z0(c[Q>>2]|0,c[Q+4>>2]|0,-1,-1)|0;R=o;c[R>>2]=Q;c[R+4>>2]=z}while(0);i:do if((B|0)==178){if(!J)break;j:do if((a[m+44>>0]|0)!=1){J=T;if((c[J>>2]|0)==20&(c[J+4>>2]|0)==0?(c[O>>2]|0)!=(c[P>>2]|0):0)break;if(!(a[q>>0]|0))switch(k|0){case 0:case 2:break j;default:{}}else{P=o;if((c[P>>2]|0)==0&(c[P+4>>2]|0)==0)break;switch(k|0){case 0:case 2:break j;default:{}}}P=(k-(j?1:2)|0)/((j&(a[n>>0]|0)==0?1:2)|0)|0;O=u;O=UW(P|0,((P|0)<0)<<31>>31|0,c[O>>2]|0,c[O+4>>2]|0)|0;P=s;O=z0(c[P>>2]|0,c[P+4>>2]|0,O|0,z|0)|0;P=s;c[P>>2]=O;c[P+4>>2]=z}while(0);if(a[i>>0]|0)break;switch(Q|0){case 0:case 5:break;default:break i}a[i>>0]=1;Q=r;P=c[Q+4>>2]|0;if(e>>>0>P>>>0|((e|0)==(P|0)?f>>>0>(c[Q>>2]|0)>>>0:0))break;wz(R,H);Fp(R,(c[L>>2]|0)-(c[K>>2]|0)>>2);i=R+11|0;j=R+4|0;h=0;while(1){e=c[K>>2]|0;if(h>>>0>=(c[L>>2]|0)-e>>2>>>0)break;e=c[e+(h<<2)>>2]|0;f=(h&1|0)==0;do if(!e){Q=a[i>>0]|0;if(((Q<<24>>24<0?c[j>>2]|0:Q&255)|0)==0|f^1)break;gy(R,32)}else{if(!f)break;JX(R,c[33756+(d[e+4>>0]<<2)>>2]|0)|0}while(0);h=h+1|0}a1(R);e=v;f=c[e>>2]|0;e=c[e+4>>2]|0}while(0);if((f|0)==-1&(e|0)==-1){m=-1;k=-1}else{R=b+48|0;R=z0(c[b+612>>2]|0,0,c[R>>2]|0,c[R+4>>2]|0)|0;Q=b+536|0;Q=z0(R|0,z|0,c[Q>>2]|0,c[Q+4>>2]|0)|0;R=b+40|0;if((Q|0)==(c[R>>2]|0)?(z|0)==(c[R+4>>2]|0):0){R=r;c[R>>2]=f;c[R+4>>2]=e}h=z0(f|0,e|0,1,0)|0;i=z;R=v;c[R>>2]=h;c[R+4>>2]=i;do if(c[M>>2]|0){f=p;e=c[f>>2]|0;f=c[f+4>>2]|0;if((e|0)==-1&(f|0)==-1)break;Q=z0(e|0,f|0,1,0)|0;R=p;c[R>>2]=Q;c[R+4>>2]=z}while(0);k=o;k=z0(c[k>>2]|0,c[k+4>>2]|0,1,0)|0;m=o;c[m>>2]=k;c[m+4>>2]=z;m=h;k=i}if(!(N|(a[(c[S>>2]|0)+44>>0]|0)!=0)){S=b+336|0;R=S;R=z0(c[R>>2]|0,c[R+4>>2]|0,1,0)|0;c[S>>2]=R;c[S+4>>2]=z;S=b+352|0;R=S;R=z0(c[R>>2]|0,c[R+4>>2]|0,1,0)|0;c[S>>2]=R;c[S+4>>2]=z}f=s;e=c[f>>2]|0;f=c[f+4>>2]|0;if((e|0)==-1&(f|0)==-1){i=-1;j=-1}else{i=u;i=z0(c[i>>2]|0,c[i+4>>2]|0,e|0,f|0)|0;j=z;S=s;c[S>>2]=i;c[S+4>>2]=j}f=t;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e|0)==-1&(f|0)==-1)){R=u;R=z0(c[R>>2]|0,c[R+4>>2]|0,e|0,f|0)|0;S=t;c[S>>2]=R;c[S+4>>2]=z}do if(!((i|0)==-1&(j|0)==-1)){e=b+288|0;h=e;f=c[h>>2]|0;h=c[h+4>>2]|0;if(!(j>>>0>h>>>0|(j|0)==(h|0)&i>>>0>f>>>0)?(S=z0(f|0,h|0,-1e9,-1)|0,R=z,h>>>0<0|(h|0)==0&f>>>0<1000000001|(j>>>0>R>>>0|(j|0)==(R|0)&i>>>0>S>>>0)):0)break;S=e;c[S>>2]=i;c[S+4>>2]=j}while(0);e=b+728|0;do if((m|0)==1&(k|0)==0){if(c[e>>2]&1|0)break;W5(b)}while(0);if(c[e>>2]&2|0)break;R=v;P=c[R+4>>2]|0;S=r;Q=c[S+4>>2]|0;if(P>>>0<Q>>>0|((P|0)==(Q|0)?(c[R>>2]|0)>>>0<(c[S>>2]|0)>>>0:0))break;t6(b);if(a[q>>0]|0)break;if(a[(c[b+772>>2]|0)+(c[T>>2]<<1)+1>>0]|0)break;if(!(+g[(c[b+24>>2]|0)+136>>2]<1.0))break;V5(b)}while(0);dU(U);break}U=c[b+648>>2]|0;G4(U,Z9(c[U+4>>2]|0)|0);J3(b)}while(0)}else{U=c[b+648>>2]|0;G4(U,Z9(c[U+4>>2]|0)|0);V5(b)}l=V;return}function Pb(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0.0,j=0.0,k=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;F=l;l=l+144|0;C=F+120|0;D=F+108|0;E=F+96|0;o=F+84|0;p=F+72|0;q=F+60|0;r=F+48|0;s=F+36|0;B=F+24|0;t=F+12|0;u=F;$x(C,b,1,d,185,1);y=a[C+8+3>>0]|0;do if(!((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)){e=b+360|0;y=e;if((c[y>>2]|0)==-1?(c[y+4>>2]|0)==-1:0){z5(C);break}x=b+48|0;x=z0(c[b+548>>2]|0,0,c[x>>2]|0,c[x+4>>2]|0)|0;y=b+40|0;y=(x|0)==(c[y>>2]|0)?(z|0)==(c[y+4>>2]|0):0;z5(C);if((y?(RA(b,1,-1)|0)==1:0)?(RA(b,2,-1)|0)==0:0){y=e;oK(b,1,0,185,c[y>>2]|0,c[y+4>>2]|0,10,0)}}else z5(C);while(0);$x(C,b,1,d,185,1);y=a[C+8+3>>0]|0;y=((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)==0;z5(C);if(y){$x(C,b,1,d,76,1);e=tm(C)|0;f=z;z5(C);if((e|0)==0&(f|0)==0){$x(C,b,0,0,92,1);e=tm(C)|0;f=z;z5(C)}$x(C,b,1,d,171,1);i=+Eq(C);z5(C);if(((e|0)!=0|(f|0)!=0)&i!=0.0)KW(b,1,d,185,(+(e>>>0)+4294967296.0*+(f|0))*i/1.0e3,0,0)}$x(C,b,1,d,76,1);y=a[C+8+3>>0]|0;y=((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)==0;z5(C);if(y?($x(C,b,1,d,185,1),m=rm(C)|0,n=z,z5(C),gq(C,b,1,d,387830),j=+Eq(C),z5(C),((m|0)!=0|(n|0)!=0)&j!=0.0):0)KW(b,1,d,76,(+(m>>>0)+4294967296.0*+(n>>>0))/j*1.0e3,0,0);$x(C,b,1,d,171,1);y=a[C+8+3>>0]|0;y=((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)==0;z5(C);if(y?($x(C,b,1,d,185,1),g=rm(C)|0,h=z,z5(C),$x(C,b,1,d,76,1),k=+Eq(C)/1.0e3,z5(C),((g|0)!=0|(h|0)!=0)&k!=0.0):0)KW(b,1,d,171,(+(g>>>0)+4294967296.0*+(h>>>0))/k,3,0);$x(C,b,1,d,150,1);y=a[C+8+3>>0]|0;y=((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)==0;z5(C);if(y)KW(b,1,d,150,1.0,3,0);$x(C,b,1,d,187,1);y=a[C+8+3>>0]|0;a:do if(!((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)){$x(D,b,1,d,130,1);e=i9(37756)|0;y=a[D+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[D+4>>2]|0:y&255)|0)?(VG(D,37756,e)|0)==0:0){z5(D);z5(C)}else A=26;do if((A|0)==26){$x(E,b,1,d,130,1);e=i9(9776)|0;y=a[E+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[E+4>>2]|0:y&255)|0)){y=(VG(E,9776,e)|0)==0;z5(E);z5(D);z5(C);if(y)break;else break a}else{z5(E);z5(D);z5(C);break a}}while(0);$x(C,b,1,d,138,1);e=i9(9792)|0;y=a[C+8+3>>0]|0;do if((e|0)==((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)?(VG(C,9792,e)|0)==0:0){$x(D,b,1,d,171,1);e=i9(38016)|0;y=a[D+8+3>>0]|0;if((e|0)!=((y<<24>>24<0?c[D+4>>2]|0:y&255)|0)){z5(D);z5(C);break}y=(VG(D,38016,e)|0)==0;z5(D);z5(C);if(y){RB(b,1,d,187,383429,-1,1,0);break a}}else A=33;while(0);if((A|0)==33)z5(C);$x(C,b,1,d,138,1);e=i9(9808)|0;y=a[C+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)?(VG(C,9808,e)|0)==0:0)f=0;else{$x(o,b,1,d,138,1);e=i9(9824)|0;y=a[o+8+3>>0]|0;if((e|0)!=((y<<24>>24<0?c[o+4>>2]|0:y&255)|0)){z5(o);z5(C);break}if(!(VG(o,9824,e)|0))f=1;else{z5(o);z5(C);break}}$x(D,b,1,d,171,1);e=i9(37904)|0;y=a[D+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[D+4>>2]|0:y&255)|0))e=(VG(D,37904,e)|0)==0;else e=0;z5(D);if(f){z5(o);z5(C);if(!e)break}else{z5(C);if(!e)break}RB(b,1,d,187,383433,-1,1,0)}else z5(C);while(0);$x(C,b,1,d,187,1);y=a[C+8+3>>0]|0;b:do if(!((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)){$x(D,b,1,d,130,1);e=i9(9840)|0;y=a[D+8+3>>0]|0;if((e|0)!=((y<<24>>24<0?c[D+4>>2]|0:y&255)|0)){z5(D);z5(C);break}y=(VG(D,9840,e)|0)==0;z5(D);z5(C);if(y){$x(C,b,1,d,138,1);e=i9(9792)|0;A=a[C+8+3>>0]|0;if((e|0)==((A<<24>>24<0?c[C+4>>2]|0:A&255)|0)?(VG(C,9792,e)|0)==0:0){f=0;A=57}else A=55;do if((A|0)==55){$x(p,b,1,d,138,1);e=i9(9856)|0;y=a[p+8+3>>0]|0;if((e|0)!=((y<<24>>24<0?c[p+4>>2]|0:y&255)|0)){z5(p);z5(C);break}if(!(VG(p,9856,e)|0)){f=1;A=57}else{z5(p);z5(C)}}while(0);do if((A|0)==57){$x(D,b,1,d,171,1);e=i9(38016)|0;y=a[D+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[D+4>>2]|0:y&255)|0))e=(VG(D,38016,e)|0)==0;else e=0;z5(D);if(f){z5(p);z5(C);if(!e)break}else{z5(C);if(!e)break}RB(b,1,d,187,383429,-1,1,0);break b}while(0);$x(C,b,1,d,138,1);e=i9(9808)|0;y=a[C+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)?(VG(C,9808,e)|0)==0:0){f=0;g=0;h=0}else A=67;do if((A|0)==67){$x(q,b,1,d,138,1);e=i9(9824)|0;y=a[q+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[q+4>>2]|0:y&255)|0)?(VG(q,9824,e)|0)==0:0){f=0;g=0;h=1;break}$x(r,b,1,d,138,1);e=i9(9872)|0;y=a[r+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[r+4>>2]|0:y&255)|0)?(VG(r,9872,e)|0)==0:0){f=0;g=1;h=1;break}$x(s,b,1,d,138,1);e=i9(9888)|0;y=a[s+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[s+4>>2]|0:y&255)|0)?(VG(s,9888,e)|0)==0:0){f=1;g=1;h=1;break}z5(s);z5(r);z5(q);z5(C);break b}while(0);$x(D,b,1,d,171,1);e=i9(37904)|0;A=a[D+8+3>>0]|0;if((e|0)==((A<<24>>24<0?c[D+4>>2]|0:A&255)|0))e=(VG(D,37904,e)|0)==0;else e=0;z5(D);if(f){z5(s);if(g)A=79;else A=80}else if(g)A=79;else A=80;if((A|0)==79){z5(r);if(h)A=81;else A=82}else if((A|0)==80)if(h)A=81;else A=82;if((A|0)==81){z5(q);z5(C);if(!e)break}else if((A|0)==82?(z5(C),!e):0)break;RB(b,1,d,187,383433,-1,1,0)}}else z5(C);while(0);$x(C,b,1,d,197,1);y=a[C+8+3>>0]|0;c:do if(!((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)){$x(D,b,1,d,18,1);e=i9(9904)|0;y=a[D+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[D+4>>2]|0:y&255)|0)?(VG(D,9904,e)|0)==0:0){z5(D);z5(C)}else A=89;do if((A|0)==89){$x(E,b,1,d,18,1);e=i9(9920)|0;y=a[E+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[E+4>>2]|0:y&255)|0)?(VG(E,9920,e)|0)==0:0){z5(E);z5(D);z5(C);break}$x(B,b,1,d,18,1);e=i9(9956)|0;y=a[B+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[B+4>>2]|0:y&255)|0)?(VG(B,9956,e)|0)==0:0){z5(B);z5(E);z5(D);z5(C);break}$x(t,b,1,d,18,1);e=i9(9972)|0;y=a[t+8+3>>0]|0;if((e|0)==((y<<24>>24<0?c[t+4>>2]|0:y&255)|0)){y=(VG(t,9972,e)|0)==0;z5(t);z5(B);z5(E);z5(D);z5(C);if(y)break;else break c}else{z5(t);z5(B);z5(E);z5(D);z5(C);break c}}while(0);RB(b,1,d,197,384051,-1,1,0)}else z5(C);while(0);$x(C,b,1,d,191,1);e=i9(29408)|0;y=a[C+8+3>>0]|0;do if((e|0)==((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)?(VG(C,29408,e)|0)==0:0){$x(D,b,1,d,192,1);e=i9(9988)|0;y=a[D+8+3>>0]|0;if((e|0)!=((y<<24>>24<0?c[D+4>>2]|0:y&255)|0)){z5(D);z5(C);break}y=(VG(D,9988,e)|0)==0;z5(D);z5(C);if(y)Ed(b,1,d,192)}else A=104;while(0);if((A|0)==104)z5(C);$x(C,b,1,d,193,1);y=a[C+8+3>>0]|0;do if(!((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)){$x(D,b,1,d,192,1);y=a[D+8+3>>0]|0;y=((y<<24>>24<0?c[D+4>>2]|0:y&255)|0)==0;z5(D);z5(C);if(!y){$x(C,b,1,d,194,1);y=a[C+8+3>>0]|0;y=((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)==0;z5(C);if(y){$x(C,b,1,d,192,1);zb(b,1,d,193,C,0);z5(C);break}$x(t,b,1,d,192,1);HX(t,39932)|0;c[B>>2]=c[t>>2];c[B+4>>2]=c[t+4>>2];c[B+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}$x(u,b,1,d,194,1);e=a[u+8+3>>0]|0;y=e<<24>>24<0;Ex(B,y?c[u>>2]|0:u,y?c[u+4>>2]|0:e&255)|0;c[E>>2]=c[B>>2];c[E+4>>2]=c[B+4>>2];c[E+8>>2]=c[B+8>>2];e=0;while(1){if((e|0)==3)break;c[B+(e<<2)>>2]=0;e=e+1|0}Gx(E,41);c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];e=0;while(1){if((e|0)==3)break;c[E+(e<<2)>>2]=0;e=e+1|0}p2(C,D);zb(b,1,d,193,C,0);z5(C);O0(D);O0(E);z5(u);O0(B);z5(t)}}else z5(C);while(0);$x(C,b,1,d,22,1);y=a[C+8+3>>0]|0;do if(!((y<<24>>24<0?c[C+4>>2]|0:y&255)|0)){$x(D,b,1,d,18,1);e=i9(24500)|0;y=a[D+8+3>>0]|0;if((e|0)!=((y<<24>>24<0?c[D+4>>2]|0:y&255)|0)){z5(D);z5(C);break}if(VG(D,24500,e)|0){z5(D);z5(C);break}$x(E,b,1,d,24,1);e=a[E+8+3>>0]|0;f=e<<24>>24<0;g=f?c[E>>2]|0:E;h=i9(10012)|0;if(!h)e=0;else{y=g+((f?c[E+4>>2]|0:e&255)<<2)|0;e=HA(g,y,10012,10012+(h<<2)|0)|0;e=(e|0)==(y|0)?-1:e-g>>2}z5(E);z5(D);z5(C);if(!e){$x(C,b,1,d,138,1);m=rm(C)|0;n=z;z5(C);$x(C,b,1,d,120,1);x=cT(+Eq(C)/1.0e6)|0;y=z;z5(C);$x(C,b,1,d,171,1);q=cT(+Eq(C))|0;w=z;z5(C);h=z0(m|0,n|0,-900,-1)|0;g=z;o=z0(x|0,y|0,-90,-1)|0;v=z;o=v>>>0<0|(v|0)==0&o>>>0<20;v=(q|0)==25&(w|0)==0;u=(q|0)==30&(w|0)==0;s=(q|0)==50&(w|0)==0;p=(q|0)==60&(w|0)==0;w=(q|0)==24&(w|0)==0;q=z0(x|0,y|0,-130,-1)|0;r=z;q=r>>>0<0|(r|0)==0&q>>>0<30;r=z0(x|0,y|0,-200,-1)|0;t=z;r=t>>>0<0|(t|0)==0&r>>>0<40;t=z0(x|0,y|0,-105,-1)|0;f=z;t=f>>>0<0|(f|0)==0&t>>>0<20;if(g>>>0<0|(g|0)==0&h>>>0<401){h=z0(x|0,y|0,-420,-1)|0;e=z;h=e>>>0<0|(e|0)==0&h>>>0<20;e=z0(x|0,y|0,-271,-1)|0;f=z;e=f>>>0<0|(f|0)==0&e>>>0<40;f=z0(x|0,y|0,-80,-1)|0;g=z;f=g>>>0<0|(g|0)==0&f>>>0<20;g=p?(f?90:e?290:h?440:0):0;e=p?(f?0:e?0:h?0:0):0;f=z0(x|0,y|0,-347,-1)|0;G=z;f=G>>>0<0|(G|0)==0&f>>>0<40;G=z0(x|0,y|0,-222,-1)|0;H=z;G=H>>>0<0|(H|0)==0&G>>>0<40;H=z0(x|0,y|0,-65,-1)|0;I=z;H=I>>>0<0|(I|0)==0&H>>>0<20;g=s?(H?75:G?240:f?365:g):g;e=s?(H?0:G?0:f?0:e):e;G=z0(x|0,y|0,-40,-1)|0;H=z;G=H>>>0<0|(H|0)==0&G>>>0<10;g=u?(G?45:o?100:q?145:r?220:h?440:g):g;e=u?(G?0:o?0:q?0:r?0:h?0:e):e;h=z0(x|0,y|0,-31,-1)|0;G=z;h=G>>>0<0|(G|0)==0&h>>>0<10;if(v){I=z0(x|0,y|0,-164,-1)|0;H=z;I=H>>>0<0|(H|0)==0&I>>>0<40;H=z0(x|0,y|0,-111,-1)|0;G=z;H=G>>>0<0|(G|0)==0&H>>>0<20;G=z0(x|0,y|0,-74,-1)|0;J=z;G=J>>>0<0|(J|0)==0&G>>>0<20;g=h?36:G?85:H?120:I?185:f?365:g;e=h?0:G?0:H?0:I?0:f?0:e}if(w){J=z0(x|0,y|0,-332,-1)|0;I=z;J=I>>>0<0|(I|0)==0&J>>>0<40;I=z0(x|0,y|0,-156,-1)|0;H=z;I=H>>>0<0|(H|0)==0&I>>>0<40;H=z0(x|0,y|0,-70,-1)|0;G=z;H=G>>>0<0|(G|0)==0&H>>>0<20;g=h?36:H?80:t?116:I?175:J?350:g;e=h?0:H?0:t?0:I?0:J?0:e}}else{g=0;e=0}J=z0(m|0,n|0,-600,-1)|0;I=z;do if(I>>>0<0|(I|0)==0&J>>>0<201){g=p?(o?100:q?145:r?220:g):g;e=p?(o?0:q?0:r?0:e):e;J=z0(x|0,y|0,-155,-1)|0;I=z;J=I>>>0<0|(I|0)==0&J>>>0<40;I=z0(x|0,y|0,-75,-1)|0;H=z;I=H>>>0<0|(H|0)==0&I>>>0<20;g=s?(I?85:t?115:J?175:g):g;e=s?(I?0:t?0:J?0:e):e;if(u){J=z0(x|0,y|0,-100,-1)|0;I=z;J=I>>>0<0|(I|0)==0&J>>>0<20;I=z0(x|0,y|0,-62,-1)|0;H=z;I=H>>>0<0|(H|0)==0&I>>>0<20;H=z0(x|0,y|0,-44,-1)|0;G=z;H=G>>>0<0|(G|0)==0&H>>>0<12;g=H?50:I?75:J?110:g;e=H?0:I?0:J?0:e}if(v){J=z0(x|0,y|0,-82,-1)|0;I=z;J=I>>>0<0|(I|0)==0&J>>>0<20;I=z0(x|0,y|0,-55,-1)|0;H=z;I=H>>>0<0|(H|0)==0&I>>>0<10;H=z0(x|0,y|0,-38,-1)|0;G=z;H=G>>>0<0|(G|0)==0&H>>>0<10;g=H?45:I?60:J?90:g;e=H?0:I?0:J?0:e}if(!w){A=141;break}f=z0(x|0,y|0,-78,-1)|0;h=z;f=h>>>0<0|(h|0)==0&f>>>0<20;h=z0(x|0,y|0,-53,-1)|0;J=z;h=J>>>0<0|(J|0)==0&h>>>0<10;J=z0(x|0,y|0,-36,-1)|0;I=z;if(I>>>0<0|(I|0)==0&J>>>0<10){g=41;e=0}else{g=h?60:f?90:g;e=h?0:f?0:e;A=141}}else A=141;while(0);if((A|0)==141)if((g|0)==0&(e|0)==0)break;$x(C,b,1,d,195,1);I=rm(C)|0;J=z;z5(C);f=(I|0)==10&(J|0)==0;if((I|2|0)==10&(J|0)==0){oT(B,g,e,10);DW(B,0,10024)|0;c[E>>2]=c[B>>2];c[E+4>>2]=c[B+4>>2];c[E+8>>2]=c[B+8>>2];e=0;while(1){if((e|0)==3)break;c[B+(e<<2)>>2]=0;e=e+1|0}HX(E,f?10052:409096)|0;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];e=0;while(1){if((e|0)==3)break;c[E+(e<<2)>>2]=0;e=e+1|0}p2(C,D);zb(b,1,d,22,C,0);z5(C);O0(D);O0(E);z5(B)}}}else z5(C);while(0);$x(C,b,1,d,22,1);J=a[C+8+3>>0]|0;do if(!((J<<24>>24<0?c[C+4>>2]|0:J&255)|0)){$x(D,b,1,d,18,1);e=i9(24500)|0;J=a[D+8+3>>0]|0;if((e|0)!=((J<<24>>24<0?c[D+4>>2]|0:J&255)|0)){z5(D);z5(C);break}if(VG(D,24500,e)|0){z5(D);z5(C);break}$x(E,b,1,d,24,1);e=a[E+8+3>>0]|0;f=e<<24>>24<0;g=f?c[E>>2]|0:E;h=i9(10060)|0;if(h){J=g+((f?c[E+4>>2]|0:e&255)<<2)|0;I=HA(g,J,10060,10060+(h<<2)|0)|0;z5(E);z5(D);z5(C);if(!((I|0)==(g|0)&(I|0)!=(J|0)))break}else{z5(E);z5(D);z5(C)}$x(B,b,1,d,24,1);lw(E,B,3,-1);DW(E,0,10076)|0;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];e=0;while(1){if((e|0)==3)break;c[E+(e<<2)>>2]=0;e=e+1|0}p2(C,D);zb(b,1,d,22,C,0);z5(C);O0(D);O0(E);z5(B)}else z5(C);while(0);l=F;return}function Qb(b){b=b|0;var d=0,e=0,f=0,g=0;e=a[b+768>>0]|0;f=b+536|0;d=b+520|0;g=c[d>>2]|0;d=c[d+4>>2]|0;a:do if((e+-1&255)<63){do switch(g|0){case 0:{if(!d){G$(b);break a}break}case 1:{if(!d){G$(b);break a}break}case 2:{if(!d){Pd(b);break a}break}case 3:{if(!d){Oe(b);break a}break}case 4:{if(!d){G$(b);break a}break}case 5:{if(!d){he(b);break a}break}case 6:{if(!d){LX(b);break a}break}case 7:{if(!d){vO(b);break a}break}case 8:{if(!d){vO(b);break a}break}case 9:{if(!d){Um(b);break a}break}case 10:{if(!d){Cj(b);break a}break}case 11:{if(!d){zG(b);break a}break}case 12:{if(!d){G$(b);break a}break}case 13:{if(!d){xm(b);break a}break}case 14:{if(!d){xj(b);break a}break}case 15:{if(!d){WZ(b);break a}break}case 16:{if(!d){gL(b);break a}break}case 17:{if(!d){eT(b);break a}break}case 18:{if(!d){G$(b);break a}break}case 19:{if(!d){G$(b);break a}break}case 20:{if(!d){G$(b);break a}break}case 21:{if(!d){G$(b);break a}break}case 22:{if(!d){G$(b);break a}break}case 23:{if(!d){G$(b);break a}break}case 24:{if(!d){G$(b);break a}break}case 25:{if(!d){G$(b);break a}break}case 26:{if(!d){G$(b);break a}break}case 27:{if(!d){G$(b);break a}break}case 28:{if(!d){ir(b);break a}break}case 29:{if(!d){dp(b);break a}break}case 30:{if(!d){G$(b);break a}break}case 31:{if(!d){br(b);break a}break}case 32:{if(!d){G$(b);break a}break}case 33:{if(!d){G$(b);break a}break}case 34:{if(!d){G$(b);break a}break}case 35:{if(!d){G$(b);break a}break}case 36:{if(!d){G$(b);break a}break}case 37:{if(!d){G$(b);break a}break}case 38:{if(!d){G$(b);break a}break}case 39:{if(!d){G$(b);break a}break}case 40:{if(!d){Mg(b);break a}break}case 41:{if(!d){G$(b);break a}break}case 42:{if(!d){Oo(b);break a}break}case 43:{if(!d){G$(b);break a}break}case 44:{if(!d){G$(b);break a}break}case 45:{if(!d){G$(b);break a}break}case 46:{if(!d){G$(b);break a}break}case 47:{if(!d){oM(b);break a}break}case 48:{if(!d){G$(b);break a}break}case 49:{if(!d){G$(b);break a}break}case 50:{if(!d){G$(b);break a}break}case 51:{if(!d){G$(b);break a}break}case 52:{if(!d){G$(b);break a}break}case 53:{if(!d){G$(b);break a}break}case 54:{if(!d){G$(b);break a}break}case 55:{if(!d){G$(b);break a}break}case 56:{if(!d){G$(b);break a}break}case 57:{if(!d){G$(b);break a}break}case 58:{if(!d){G$(b);break a}break}case 63:{if(!d){G$(b);break a}break}case 64:{if(!d){EJ(b);break a}break}case 65:{if(!d){Cl(b);break a}break}case 66:{if(!d){G$(b);break a}break}case 67:{if(!d){mi(b);break a}break}case 68:{if(!d){G$(b);break a}break}case 69:{if(!d){G$(b);break a}break}case 70:{if(!d){G$(b);break a}break}case 71:{if(!d){G$(b);break a}break}case 72:{if(!d){_h(b);break a}break}case 73:{if(!d){G$(b);break a}break}case 74:{if(!d){XF(b);break a}break}case 75:{if(!d){G$(b);break a}break}case 76:{if(!d){G$(b);break a}break}case 77:{if(!d){Lh(b);break a}break}case 78:{if(!d){G$(b);break a}break}case 79:{if(!d){G$(b);break a}break}case 80:{if(!d){Vl(b);break a}break}case 81:{if(!d){G$(b);break a}break}case 82:{if(!d){LX(b);break a}break}case 83:{if(!d){G$(b);break a}break}case 84:{if(!d){sh(b);break a}break}case 85:{if(!d){AF(b);break a}break}case 86:{if(!d){$s(b);break a}break}case 87:{if(!d){G$(b);break a}break}case 88:{if(!d){bi(b);break a}break}case 89:{if(!d){Wf(b);break a}break}case 90:{if(!d){rs(b);break a}break}case 91:{if(!d){G$(b);break a}break}case 92:{if(!d){G$(b);break a}break}case 93:{if(!d){me(b);break a}break}case 94:{if(!d){G$(b);break a}break}case 95:{if(!d){BY(b);break a}break}case 96:{if(!d){G$(b);break a}break}case 97:{if(!d){G$(b);break a}break}case 98:{if(!d){G$(b);break a}break}case 99:{if(!d){Ti(b);break a}break}case 100:{if(!d){G$(b);break a}break}case 101:{if(!d){G$(b);break a}break}case 102:{if(!d){GA(b);break a}break}case 103:{if(!d){G$(b);break a}break}case 104:{if(!d){G$(b);break a}break}case 105:{if(!d){G$(b);break a}break}case 106:{if(!d){tf(b);break a}break}case 107:{if(!d){G$(b);break a}break}case 108:{if(!d){G$(b);break a}break}case 109:{if(!d){G$(b);break a}break}case 110:{if(!d){G$(b);break a}break}case 111:{if(!d){G$(b);break a}break}case 112:{if(!d){G$(b);break a}break}case 113:{if(!d){G$(b);break a}break}case 114:{if(!d){G$(b);break a}break}case 115:{if(!d){G$(b);break a}break}case 116:{if(!d){G$(b);break a}break}case 117:{if(!d){G$(b);break a}break}case 118:{if(!d){G$(b);break a}break}case 119:{if(!d){G$(b);break a}break}case 120:{if(!d){G$(b);break a}break}case 121:{if(!d){G$(b);break a}break}case 122:{if(!d){af(b);break a}break}case 123:{if(!d){By(b);break a}break}case 124:{if(!d){Sj(b);break a}break}case 125:{if(!d){G$(b);break a}break}case 126:{if(!d){G$(b);break a}break}case 127:{if(!d){Hm(b);break a}break}case 128:{if(!d){G$(b);break a}break}case 129:{if(!d){$d(b);break a}break}case 134:{if(!d){bm(b);break a}break}case 135:{if(!d){sp(b);break a}break}case 160:{if(!d){Ym(b);break a}break}case 161:{if(!d){Zh(b);break a}break}case 162:{if(!d){G$(b);break a}break}case 163:{if(!d){aq(b);break a}break}case 168:{if(!d){G$(b);break a}break}case 169:{if(!d){G$(b);break a}break}case 170:{if(!d){G$(b);break a}break}case 171:{if(!d){G$(b);break a}break}case 193:{if(!d){qx(b);break a}break}case 196:{if(!d){G$(b);break a}break}case 200:{if(!d){G$(b);break a}break}case 222:{if(!d){_v(b);break a}break}case 233:{if(!d){Ef(b);break a}break}case 252:{if(!d){G$(b);break a}break}case 253:{if(!d){En(b);break a}break}default:{}}while(0);g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0)}else{if(!((e&255)>63&e<<24>>24>-1)){if((e&-32)<<24>>24!=-64){if(e<<24>>24!=-4){g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break}switch(g|0){case 0:{if(!d){VV(b);break a}break}case 1:{if(!d){G$(b);break a}break}case 2:{if(!d){fh(b);break a}break}default:{}}g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break}do switch(g|0){case 128:{if(!d){G$(b);break a}break}case 129:{if(!d){$d(b);break a}break}case 134:{if(!d){bm(b);break a}break}case 135:{if(!d){sp(b);break a}break}case 160:{if(!d){Ym(b);break a}break}case 161:{if(!d){Zh(b);break a}break}case 162:{if(!d){G$(b);break a}break}case 163:{if(!d){aq(b);break a}break}case 168:{if(!d){G$(b);break a}break}case 169:{if(!d){G$(b);break a}break}case 170:{if(!d){G$(b);break a}break}case 171:{if(!d){G$(b);break a}break}default:{}}while(0);g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0);break}do switch(g|0){case 64:{if(!d){EJ(b);break a}break}case 65:{if(!d){Cl(b);break a}break}case 66:{if(!d){G$(b);break a}break}case 67:{if(!d){mi(b);break a}break}case 68:{if(!d){G$(b);break a}break}case 69:{if(!d){G$(b);break a}break}case 70:{if(!d){G$(b);break a}break}case 71:{if(!d){G$(b);break a}break}case 72:{if(!d){_h(b);break a}break}case 73:{if(!d){G$(b);break a}break}case 74:{if(!d){XF(b);break a}break}case 75:{if(!d){G$(b);break a}break}case 76:{if(!d){G$(b);break a}break}case 77:{if(!d){Lh(b);break a}break}case 78:{if(!d){G$(b);break a}break}case 79:{if(!d){G$(b);break a}break}case 80:{if(!d){Vl(b);break a}break}case 81:{if(!d){G$(b);break a}break}case 82:{if(!d){LX(b);break a}break}case 83:{if(!d){G$(b);break a}break}case 84:{if(!d){sh(b);break a}break}case 85:{if(!d){AF(b);break a}break}case 86:{if(!d){$s(b);break a}break}case 87:{if(!d){G$(b);break a}break}case 88:{if(!d){bi(b);break a}break}case 89:{if(!d){Wf(b);break a}break}case 90:{if(!d){rs(b);break a}break}case 91:{if(!d){G$(b);break a}break}case 92:{if(!d){G$(b);break a}break}case 93:{if(!d){me(b);break a}break}case 94:{if(!d){G$(b);break a}break}case 95:{if(!d){BY(b);break a}break}case 96:{if(!d){G$(b);break a}break}case 97:{if(!d){G$(b);break a}break}case 98:{if(!d){G$(b);break a}break}case 99:{if(!d){Ti(b);break a}break}case 100:{if(!d){G$(b);break a}break}case 101:{if(!d){G$(b);break a}break}case 102:{if(!d){GA(b);break a}break}case 103:{if(!d){G$(b);break a}break}case 104:{if(!d){G$(b);break a}break}case 105:{if(!d){G$(b);break a}break}case 106:{if(!d){tf(b);break a}break}case 107:{if(!d){G$(b);break a}break}case 108:{if(!d){G$(b);break a}break}case 109:{if(!d){G$(b);break a}break}case 110:{if(!d){G$(b);break a}break}case 111:{if(!d){G$(b);break a}break}case 112:{if(!d){G$(b);break a}break}case 113:{if(!d){G$(b);break a}break}case 114:{if(!d){G$(b);break a}break}case 115:{if(!d){G$(b);break a}break}case 116:{if(!d){G$(b);break a}break}case 117:{if(!d){G$(b);break a}break}case 118:{if(!d){G$(b);break a}break}case 119:{if(!d){G$(b);break a}break}case 120:{if(!d){G$(b);break a}break}case 121:{if(!d){G$(b);break a}break}case 122:{if(!d){af(b);break a}break}case 123:{if(!d){By(b);break a}break}case 124:{if(!d){Sj(b);break a}break}case 125:{if(!d){G$(b);break a}break}case 126:{if(!d){G$(b);break a}break}case 127:{if(!d){Hm(b);break a}break}default:{}}while(0);g=f;e1(b,c[g>>2]|0,c[g+4>>2]|0)}while(0);return}function Rb(a,b){a=a|0;b=b|0;a:do switch(a|0){case 0:do switch(b|0){case 0:{a=57;break a}case 1:{a=59;break a}case 2:{a=60;break a}case 5:{a=64;break a}case 3:{a=62;break a}case 4:{a=63;break a}case 6:{a=65;break a}case 7:{a=66;break a}case 10:{a=68;break a}case 11:{a=69;break a}case 12:{a=70;break a}case 13:{a=72;break a}case 14:{a=73;break a}case 15:{a=74;break a}case 16:{a=75;break a}case 17:{a=79;break a}case 18:{a=80;break a}case 19:{a=81;break a}case 20:{a=82;break a}case 22:{a=92;break a}case 23:{a=93;break a}case 24:{a=94;break a}case 25:{a=95;break a}case 26:{a=96;break a}case 27:{a=97;break a}case 28:{a=98;break a}case 48:{a=111;break a}case 52:{a=115;break a}case 63:{a=116;break a}case 64:{a=117;break a}case 65:{a=118;break a}case 66:{a=119;break a}case 67:{a=120;break a}case 68:{a=121;break a}case 69:{a=122;break a}case 70:{a=123;break a}case 71:{a=124;break a}case 72:{a=125;break a}case 73:{a=126;break a}case 91:{a=127;break a}case 92:{a=128;break a}case 93:{a=129;break a}case 94:{a=130;break a}case 95:{a=131;break a}case 96:{a=132;break a}case 97:{a=133;break a}case 98:{a=134;break a}case 124:{a=304;break a}case 125:{a=307;break a}default:{a=-1;break a}}while(0);case 1:do switch(b|0){case 0:{a=18;break a}case 1:{a=19;break a}case 2:{a=20;break a}case 3:{a=21;break a}case 4:{a=22;break a}case 5:{a=23;break a}case 6:{a=24;break a}case 7:{a=25;break a}case 8:{a=26;break a}case 10:{a=31;break a}case 11:{a=50;break a}case 12:{a=52;break a}case 13:{a=54;break a}case 14:{a=55;break a}case 15:{a=56;break a}case 16:{a=57;break a}case 17:{a=58;break a}case 18:{a=59;break a}case 19:{a=61;break a}case 20:{a=62;break a}case 21:{a=63;break a}case 22:{a=76;break a}case 23:{a=77;break a}case 24:{a=78;break a}case 25:{a=79;break a}case 26:{a=80;break a}case 27:{a=81;break a}case 28:{a=82;break a}case 29:{a=97;break a}case 30:{a=98;break a}case 31:{a=99;break a}case 32:{a=100;break a}case 33:{a=101;break a}case 34:{a=102;break a}case 35:{a=103;break a}case 36:{a=118;break a}case 37:{a=119;break a}case 38:{a=120;break a}case 39:{a=121;break a}case 40:{a=122;break a}case 41:{a=123;break a}case 42:{a=124;break a}case 43:{a=125;break a}case 44:{a=126;break a}case 45:{a=127;break a}case 46:{a=128;break a}case 47:{a=129;break a}case 48:{a=171;break a}case 52:{a=185;break a}case 53:{a=186;break a}case 54:{a=191;break a}case 55:{a=192;break a}case 56:{a=188;break a}case 57:{a=189;break a}case 58:{a=195;break a}case 59:{a=196;break a}case 60:{a=213;break a}case 61:{a=214;break a}case 62:{a=215;break a}case 63:{a=217;break a}case 64:{a=218;break a}case 65:{a=219;break a}case 66:{a=220;break a}case 67:{a=221;break a}case 68:{a=222;break a}case 69:{a=223;break a}case 70:{a=224;break a}case 71:{a=225;break a}case 72:{a=226;break a}case 73:{a=227;break a}case 74:{a=228;break a}case 75:{a=229;break a}case 76:{a=230;break a}case 77:{a=231;break a}case 78:{a=232;break a}case 79:{a=233;break a}case 81:{a=235;break a}case 82:{a=236;break a}case 83:{a=237;break a}case 91:{a=252;break a}case 92:{a=253;break a}case 93:{a=254;break a}case 94:{a=255;break a}case 95:{a=256;break a}case 96:{a=257;break a}case 97:{a=258;break a}case 98:{a=259;break a}case 107:{a=275;break a}case 108:{a=276;break a}case 109:{a=277;break a}case 110:{a=278;break a}case 111:{a=279;break a}case 112:{a=280;break a}case 113:{a=281;break a}case 114:{a=282;break a}case 99:{a=267;break a}case 100:{a=268;break a}case 101:{a=269;break a}case 102:{a=270;break a}case 103:{a=271;break a}case 104:{a=272;break a}case 105:{a=273;break a}case 106:{a=274;break a}case 115:{a=283;break a}case 116:{a=284;break a}case 117:{a=285;break a}case 118:{a=286;break a}case 119:{a=287;break a}case 120:{a=288;break a}case 121:{a=289;break a}case 122:{a=290;break a}case 123:{a=308;break a}default:{a=-1;break a}}while(0);case 2:do switch(b|0){case 0:{a=18;break a}case 1:{a=19;break a}case 2:{a=20;break a}case 3:{a=21;break a}case 4:{a=22;break a}case 5:{a=23;break a}case 6:{a=24;break a}case 7:{a=25;break a}case 10:{a=27;break a}case 11:{a=43;break a}case 12:{a=46;break a}case 13:{a=48;break a}case 14:{a=49;break a}case 15:{a=50;break a}case 16:{a=51;break a}case 17:{a=52;break a}case 18:{a=53;break a}case 19:{a=55;break a}case 20:{a=56;break a}case 21:{a=57;break a}case 22:{a=68;break a}case 23:{a=69;break a}case 24:{a=70;break a}case 25:{a=71;break a}case 26:{a=72;break a}case 27:{a=73;break a}case 28:{a=74;break a}case 29:{a=89;break a}case 30:{a=90;break a}case 31:{a=91;break a}case 32:{a=92;break a}case 33:{a=93;break a}case 34:{a=94;break a}case 35:{a=95;break a}case 36:{a=110;break a}case 37:{a=111;break a}case 38:{a=112;break a}case 39:{a=113;break a}case 40:{a=114;break a}case 41:{a=115;break a}case 42:{a=116;break a}case 43:{a=117;break a}case 44:{a=118;break a}case 45:{a=119;break a}case 46:{a=120;break a}case 47:{a=121;break a}case 48:{a=139;break a}case 52:{a=143;break a}case 53:{a=144;break a}case 56:{a=145;break a}case 57:{a=146;break a}case 58:{a=147;break a}case 59:{a=148;break a}case 60:{a=153;break a}case 61:{a=154;break a}case 62:{a=155;break a}case 63:{a=156;break a}case 64:{a=157;break a}case 65:{a=158;break a}case 66:{a=159;break a}case 67:{a=160;break a}case 68:{a=161;break a}case 69:{a=162;break a}case 70:{a=163;break a}case 71:{a=164;break a}case 72:{a=165;break a}case 73:{a=166;break a}case 74:{a=167;break a}case 75:{a=168;break a}case 76:{a=169;break a}case 77:{a=170;break a}case 78:{a=171;break a}case 79:{a=172;break a}case 81:{a=174;break a}case 82:{a=175;break a}case 83:{a=176;break a}case 84:{a=177;break a}case 85:{a=178;break a}case 86:{a=179;break a}case 87:{a=180;break a}case 88:{a=181;break a}case 89:{a=182;break a}case 91:{a=194;break a}case 92:{a=195;break a}case 93:{a=196;break a}case 94:{a=197;break a}case 95:{a=198;break a}case 96:{a=199;break a}case 97:{a=200;break a}case 98:{a=201;break a}case 107:{a=217;break a}case 108:{a=218;break a}case 109:{a=219;break a}case 110:{a=220;break a}case 111:{a=221;break a}case 112:{a=222;break a}case 113:{a=223;break a}case 114:{a=224;break a}case 99:{a=209;break a}case 100:{a=210;break a}case 101:{a=211;break a}case 102:{a=212;break a}case 103:{a=213;break a}case 104:{a=214;break a}case 105:{a=215;break a}case 106:{a=216;break a}case 115:{a=225;break a}case 116:{a=226;break a}case 117:{a=227;break a}case 118:{a=228;break a}case 119:{a=229;break a}case 120:{a=230;break a}case 121:{a=231;break a}case 122:{a=232;break a}case 123:{a=255;break a}default:{a=-1;break a}}while(0);case 3:do switch(b|0){case 0:{a=18;break a}case 1:{a=19;break a}case 2:{a=20;break a}case 3:{a=21;break a}case 4:{a=22;break a}case 5:{a=23;break a}case 6:{a=24;break a}case 10:{a=26;break a}case 11:{a=28;break a}case 12:{a=31;break a}case 13:{a=33;break a}case 14:{a=34;break a}case 15:{a=35;break a}case 16:{a=36;break a}case 17:{a=37;break a}case 18:{a=38;break a}case 19:{a=39;break a}case 20:{a=40;break a}case 21:{a=41;break a}case 22:{a=42;break a}case 23:{a=43;break a}case 24:{a=44;break a}case 25:{a=45;break a}case 26:{a=46;break a}case 27:{a=47;break a}case 28:{a=48;break a}case 29:{a=63;break a}case 30:{a=64;break a}case 31:{a=65;break a}case 32:{a=66;break a}case 33:{a=67;break a}case 34:{a=68;break a}case 35:{a=69;break a}case 36:{a=84;break a}case 37:{a=85;break a}case 38:{a=86;break a}case 39:{a=87;break a}case 40:{a=88;break a}case 41:{a=89;break a}case 42:{a=90;break a}case 43:{a=91;break a}case 44:{a=92;break a}case 45:{a=93;break a}case 46:{a=94;break a}case 47:{a=95;break a}case 48:{a=102;break a}case 52:{a=114;break a}case 53:{a=116;break a}case 54:{a=117;break a}case 55:{a=118;break a}case 56:{a=119;break a}case 57:{a=120;break a}case 58:{a=121;break a}case 59:{a=122;break a}case 60:{a=123;break a}case 61:{a=124;break a}case 62:{a=125;break a}case 63:{a=126;break a}case 64:{a=127;break a}case 65:{a=128;break a}case 66:{a=129;break a}case 67:{a=130;break a}case 68:{a=131;break a}case 69:{a=132;break a}case 70:{a=133;break a}case 71:{a=134;break a}case 72:{a=135;break a}case 73:{a=136;break a}case 74:{a=137;break a}case 75:{a=138;break a}case 76:{a=139;break a}case 77:{a=140;break a}case 78:{a=141;break a}case 79:{a=142;break a}case 81:{a=144;break a}case 82:{a=145;break a}case 83:{a=146;break a}case 84:{a=147;break a}case 85:{a=148;break a}case 86:{a=149;break a}case 87:{a=150;break a}case 88:{a=151;break a}case 89:{a=152;break a}case 91:{a=161;break a}case 92:{a=162;break a}case 93:{a=163;break a}case 94:{a=164;break a}case 95:{a=165;break a}case 96:{a=166;break a}case 97:{a=167;break a}case 98:{a=168;break a}case 107:{a=184;break a}case 108:{a=185;break a}case 109:{a=186;break a}case 110:{a=187;break a}case 111:{a=188;break a}case 112:{a=189;break a}case 113:{a=190;break a}case 114:{a=191;break a}case 99:{a=176;break a}case 100:{a=177;break a}case 101:{a=178;break a}case 102:{a=179;break a}case 103:{a=180;break a}case 104:{a=181;break a}case 105:{a=182;break a}case 106:{a=183;break a}case 115:{a=192;break a}case 116:{a=193;break a}case 117:{a=194;break a}case 118:{a=195;break a}case 119:{a=196;break a}case 120:{a=197;break a}case 121:{a=198;break a}case 122:{a=199;break a}case 123:{a=215;break a}default:{a=-1;break a}}while(0);case 4:do switch(b|0){case 0:{a=19;break a}case 1:{a=20;break a}case 2:{a=21;break a}case 3:{a=22;break a}case 4:{a=23;break a}case 5:{a=24;break a}case 6:{a=25;break a}case 10:{a=27;break a}case 12:{a=29;break a}case 13:{a=31;break a}case 14:{a=32;break a}case 15:{a=33;break a}case 16:{a=34;break a}case 22:{a=35;break a}case 23:{a=36;break a}case 24:{a=37;break a}case 25:{a=38;break a}case 26:{a=39;break a}case 27:{a=40;break a}case 28:{a=41;break a}case 48:{a=44;break a}case 52:{a=48;break a}case 63:{a=49;break a}case 64:{a=50;break a}case 65:{a=51;break a}case 66:{a=52;break a}case 67:{a=53;break a}case 68:{a=54;break a}case 69:{a=55;break a}case 70:{a=56;break a}case 71:{a=57;break a}case 72:{a=58;break a}case 73:{a=59;break a}case 74:{a=60;break a}case 75:{a=61;break a}case 76:{a=62;break a}case 77:{a=63;break a}case 78:{a=64;break a}case 79:{a=65;break a}case 81:{a=67;break a}case 82:{a=68;break a}case 83:{a=69;break a}case 84:{a=70;break a}case 85:{a=71;break a}case 86:{a=72;break a}case 87:{a=73;break a}case 88:{a=74;break a}case 89:{a=75;break a}case 123:{a=96;break a}default:{a=-1;break a}}while(0);case 5:do switch(b|0){case 0:{a=19;break a}case 1:{a=20;break a}case 2:{a=21;break a}case 3:{a=22;break a}case 4:{a=23;break a}case 5:{a=24;break a}case 6:{a=25;break a}case 11:{a=29;break a}case 12:{a=30;break a}case 13:{a=32;break a}case 14:{a=33;break a}case 15:{a=34;break a}case 16:{a=35;break a}case 17:{a=36;break a}case 18:{a=37;break a}case 19:{a=39;break a}case 20:{a=40;break a}case 54:{a=61;break a}case 55:{a=62;break a}case 56:{a=63;break a}case 57:{a=64;break a}case 58:{a=65;break a}case 59:{a=66;break a}case 60:{a=67;break a}case 61:{a=68;break a}case 62:{a=69;break a}case 91:{a=70;break a}case 92:{a=71;break a}case 93:{a=72;break a}case 94:{a=73;break a}case 95:{a=74;break a}case 96:{a=75;break a}case 97:{a=76;break a}case 98:{a=77;break a}case 123:{a=91;break a}default:{a=-1;break a}}while(0);case 6:do switch(b|0){case 0:{a=18;break a}case 1:{a=19;break a}case 2:{a=20;break a}case 3:{a=21;break a}case 4:{a=22;break a}case 5:{a=23;break a}case 6:{a=24;break a}case 10:{a=26;break a}case 12:{a=27;break a}case 13:{a=29;break a}case 14:{a=30;break a}case 15:{a=31;break a}case 16:{a=32;break a}case 17:{a=33;break a}case 18:{a=34;break a}case 19:{a=35;break a}case 20:{a=36;break a}case 22:{a=37;break a}case 23:{a=38;break a}case 24:{a=39;break a}case 25:{a=40;break a}case 26:{a=41;break a}case 27:{a=42;break a}case 28:{a=43;break a}case 123:{a=61;break a}case 124:{a=70;break a}case 125:{a=73;break a}default:{a=-1;break a}}while(0);default:a=-1}while(0);return a|0}function Sb(b){b=b|0;var d=0,e=0.0,f=0.0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0,x=0,y=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;H=l;l=l+96|0;E=H+84|0;F=H+48|0;w=H+36|0;x=H+24|0;s=H+12|0;v=H;B=H+72|0;C=H+60|0;$x(E,b,0,0,92,1);D=a[E+8+3>>0]|0;D=((D<<24>>24<0?c[E+4>>2]|0:D&255)|0)==0;z5(E);if(D){k=E+8+3|0;m=E+4|0;i=1;g=0;d=0;while(1){if(i>>>0<7)j=0;else break;while(1){if(j>>>0>=(RA(b,i,-1)|0)>>>0)break;h=Rb(i,22)|0;$x(E,b,i,j,h,1);D=a[k>>0]|0;D=((D<<24>>24<0?c[m>>2]|0:D&255)|0)==0;z5(E);if(!D){$x(E,b,i,j,h,1);p=rm(E)|0;D=z;z5(E);A=D>>>0>d>>>0|(D|0)==(d|0)&p>>>0>g>>>0;g=A?p:g;d=A?D:d}j=j+1|0}i=i+1|0}if(!((g|0)==0&(d|0)==0))oK(b,0,0,92,g,d,10,0)}$x(E,b,0,0,127,1);A=a[E+8+3>>0]|0;A=((A<<24>>24<0?c[E+4>>2]|0:A&255)|0)==0;z5(E);D=b+40|0;if(A){m=E+8+3|0;n=E+4|0;o=E+8+3|0;p=E+4|0;k=1;g=1;h=0;d=0;while(1){if(k>>>0>=7)break;a:do switch(k|0){case 4:case 6:break;default:{j=0;i=d;while(1){if(j>>>0>=(RA(b,k,-1)|0)>>>0){d=i;break a}d=Rb(k,107)|0;$x(E,b,k,j,d,1);A=a[m>>0]|0;A=((A<<24>>24<0?c[n>>2]|0:A&255)|0)==0;z5(E);if(A){d=Rb(k,91)|0;$x(E,b,k,j,d,1);A=a[o>>0]|0;A=((A<<24>>24<0?c[p>>2]|0:A&255)|0)==0;z5(E);if(A){g=0;d=i}else{$x(E,b,k,j,d,1);d=rm(E)|0;h=z0(d|0,z|0,h|0,i|0)|0;d=z;z5(E)}}else{$x(E,b,k,j,d,1);d=rm(E)|0;h=z0(d|0,z|0,h|0,i|0)|0;d=z;z5(E)}j=j+1|0;i=d}}}while(0);k=k+1|0}if(g&((h|0)!=0|(d|0)!=0)?(r=D,q=c[r>>2]|0,r=c[r+4>>2]|0,r>>>0>d>>>0|(r|0)==(d|0)&q>>>0>h>>>0):0){A=D_(q|0,r|0,h|0,d|0)|0;oK(b,0,0,127,A,z,10,0)}}$x(E,b,0,0,92,1);A=a[E+8+3>>0]|0;do if(!((A<<24>>24<0?c[E+4>>2]|0:A&255)|0)){$x(F,b,0,0,103,1);A=a[F+8+3>>0]|0;if((A<<24>>24<0?c[F+4>>2]|0:A&255)|0){z5(F);z5(E);break}if(RA(b,1,-1)|0){z5(F);z5(E);break}if((RA(b,2,-1)|0)!=1){z5(F);z5(E);break}$x(w,b,2,0,112,1);A=rm(w)|0;if((A|0)==0&(z|0)==0){z5(w);z5(F);z5(E);break}$x(x,b,0,0,57,1);$x(s,b,2,0,18,1);g=a[x+8+3>>0]|0;d=g<<24>>24<0;g=d?c[x+4>>2]|0:g&255;A=a[s+8+3>>0]|0;h=A<<24>>24<0;if((g|0)==((h?c[s+4>>2]|0:A&255)|0)?(L$(d?c[x>>2]|0:x,h?c[s>>2]|0:s,g)|0)==0:0){z5(s);z5(x);z5(w);z5(F);z5(E)}else G=33;if((G|0)==33?($x(v,b,0,0,142,1),A=a[v+8+3>>0]|0,A=((A<<24>>24<0?c[v+4>>2]|0:A&255)|0)==0,z5(v),z5(s),z5(x),z5(w),z5(F),z5(E),A):0)break;$x(E,b,2,0,112,1);zb(b,0,0,103,E,0);z5(E)}else z5(E);while(0);$x(E,b,0,0,103,1);A=a[E+8+3>>0]|0;do if(!((A<<24>>24<0?c[E+4>>2]|0:A&255)|0)){$x(F,b,0,0,92,1);A=rm(F)|0;if((A|0)==0&(z|0)==0){z5(F);z5(E);break}$x(w,b,0,0,86,1);A=a[w+8+3>>0]|0;A=((A<<24>>24<0?c[w+4>>2]|0:A&255)|0)==0;z5(w);z5(F);z5(E);if(!A){do if((RA(b,1,-1)|0)==1){$x(E,b,0,0,92,1);$x(F,b,1,0,92,1);g=a[E+8+3>>0]|0;d=g<<24>>24<0;g=d?c[E+4>>2]|0:g&255;A=a[F+8+3>>0]|0;h=A<<24>>24<0;if((g|0)!=((h?c[F+4>>2]|0:A&255)|0)){z5(F);z5(E);G=53;break}if(L$(d?c[E>>2]|0:E,h?c[F>>2]|0:F,g)|0){z5(F);z5(E);G=53;break}$x(w,b,1,0,185,1);A=a[w+8+3>>0]|0;if(!((A<<24>>24<0?c[w+4>>2]|0:A&255)|0)){z5(w);z5(F);z5(E);G=53;break}$x(x,b,1,0,171,1);A=a[x+8+3>>0]|0;A=((A<<24>>24<0?c[x+4>>2]|0:A&255)|0)==0;z5(x);z5(w);z5(F);z5(E);if(!(!A?($x(E,b,1,0,185,1),v=rm(E)|0,A=z,z5(E),$x(E,b,1,0,171,1),y=+Eq(E),z5(E),s=UW(v|0,A|0,1e3,0)|0,e=(+(s>>>0)+4294967296.0*+(z>>>0))/y,!((v|0)==0&(A|0)==0|y==0.0|e==0.0)):0))G=53}else G=53;while(0);if((G|0)==53){$x(E,b,0,0,92,1);e=+Eq(E);z5(E)}$x(E,b,0,0,86,1);A=rm(E)|0;A=UW(A|0,z|0,8e3,0)|0;KW(b,0,0,103,(+(A>>>0)+4294967296.0*+(z>>>0))/e,0,0);z5(E)}}else z5(E);while(0);$x(E,b,0,0,92,1);A=a[E+8+3>>0]|0;if(!((A<<24>>24<0?c[E+4>>2]|0:A&255)|0)){$x(F,b,0,0,103,1);A=rm(F)|0;A=(A|0)==0&(z|0)==0;z5(F);z5(E);if(!A){$x(E,b,0,0,86,1);y=+Eq(E)*8.0*1.0e3;$x(F,b,0,0,103,1);KW(b,0,0,92,y/+Eq(F),0,0);z5(F);z5(E)}}else z5(E);do if((RA(b,1,-1)|0)==1){$x(E,b,1,0,120,1);A=a[E+8+3>>0]|0;if((A<<24>>24<0?c[E+4>>2]|0:A&255)|0){z5(E);break}$x(F,b,0,0,92,1);A=rm(F)|0;v=z;z5(F);z5(E);if(v>>>0<0|(v|0)==0&A>>>0<4e3){$x(E,b,1,0,124,1);zb(b,1,0,120,E,0);z5(E);Ed(b,1,0,124)}}while(0);do if((RA(b,1,-1)|0)==1){$x(E,b,0,0,103,1);A=a[E+8+3>>0]|0;if((A<<24>>24<0?c[E+4>>2]|0:A&255)>>>0<=4){z5(E);break}$x(F,b,1,0,120,1);A=a[F+8+3>>0]|0;if((A<<24>>24<0?c[F+4>>2]|0:A&255)|0){z5(F);z5(E);break}$x(w,b,1,0,128,1);A=a[w+8+3>>0]|0;if((A<<24>>24<0?c[w+4>>2]|0:A&255)|0){z5(w);z5(F);z5(E);break}$x(x,b,0,0,92,1);A=rm(x)|0;v=z;z5(x);z5(w);z5(F);z5(E);if(v>>>0>0|(v|0)==0&A>>>0>999){A=b+493|0;w=(a[A>>0]|0)==0;e=w?.98:1.0;d=c[(c[b>>2]|0)+8>>2]|0;Xy(E,9488);d=lb[d&63](b,0,0,E,1,0)|0;g=i9(9516)|0;x=a[d+8+3>>0]|0;if((g|0)==((x<<24>>24<0?c[d+4>>2]|0:x&255)|0))s=(VG(d,9516,g)|0)==0;else s=0;z5(E);d=c[(c[b>>2]|0)+8>>2]|0;Xy(E,9488);d=lb[d&63](b,0,0,E,1,0)|0;g=i9(9548)|0;x=a[d+8+3>>0]|0;if((g|0)==((x<<24>>24<0?c[d+4>>2]|0:x&255)|0))r=(VG(d,9548,g)|0)==0;else r=0;z5(E);$x(E,b,0,0,57,1);d=OJ(E,3)|0;g=i9(9580)|0;x=a[d+8+3>>0]|0;if((g|0)==((x<<24>>24<0?c[d+4>>2]|0:x&255)|0))j=(VG(d,9580,g)|0)==0;else j=0;z5(E);d=c[(c[b>>2]|0)+8>>2]|0;Xy(E,9488);d=lb[d&63](b,0,0,E,1,0)|0;g=i9(9608)|0;x=a[d+8+3>>0]|0;if((g|0)==((x<<24>>24<0?c[d+4>>2]|0:x&255)|0))h=(VG(d,9608,g)|0)==0;else h=0;z5(E);i=s|r|j|h;d=c[(c[b>>2]|0)+8>>2]|0;Xy(E,9488);d=lb[d&63](b,0,0,E,1,0)|0;g=i9(24116)|0;x=a[d+8+3>>0]|0;if((g|0)==((x<<24>>24<0?c[d+4>>2]|0:x&255)|0))d=(VG(d,24116,g)|0)==0;else d=0;z5(E);t=d?1.0:h?.99:j?1.0:r?.99:s?.97:e;u=d?1.0:h?.99:j?1.0:r?.99:s?.96:e;$x(E,b,0,0,103,1);f=+Eq(E);z5(E);k=E+8+3|0;m=E+4|0;n=E+8+3|0;o=E+4|0;p=C+8+3|0;x=u!=0.0;y=d?1.0e3:i?0.0:w?2.0e3:0.0;q=B+8+3|0;g=0;v=1;e=(d?1.0:h?.99:j?1.0:r?.99:s?.98:e)*f-(d?1.0e3:i?0.0:w?5.0e3:0.0);while(1){if(g>>>0>=(RA(b,2,-1)|0)>>>0)break;$x(E,b,2,g,120,1);G=a[k>>0]|0;do if(!((G<<24>>24<0?c[m>>2]|0:G&255)|0)){z5(E);G=88}else{$x(B,b,2,g,120,1);G=(c[((a[q>>0]|0)<0?c[B>>2]|0:B)>>2]|0)<58;z5(B);z5(E);if(!G){G=88;break}$x(E,b,2,g,120,1);f=+Eq(E);z5(E);G=92}while(0);do if((G|0)==88){G=0;$x(E,b,2,g,112,1);w=a[n>>0]|0;if(!((w<<24>>24<0?c[o>>2]|0:w&255)|0)){z5(E);d=0;break}$x(C,b,2,g,112,1);w=(c[((a[p>>0]|0)<0?c[C>>2]|0:C)>>2]|0)<58;z5(C);z5(E);if(!w){d=0;break}$x(E,b,2,g,112,1);f=+Eq(E);z5(E);G=92}while(0);if((G|0)==92){G=0;d=v;e=x&v?e-(y+f/u):e}g=g+1|0;v=d}g=E+8+3|0;h=E+4|0;d=0;while(1){if(d>>>0>=(RA(b,3,-1)|0)>>>0)break;$x(E,b,3,d,94,1);C=a[g>>0]|0;C=((C<<24>>24<0?c[h>>2]|0:C&255)|0)==0;z5(E);if(C){$x(E,b,3,d,86,1);f=+Eq(E);z5(E)}else{$x(E,b,3,d,94,1);f=+Eq(E);z5(E)}if(x)e=e-(y+f/u);else e=e+-1.0e3;d=d+1|0}if(v&e>=1.0e4){f=t*e-y;KW(b,1,0,120,f,0,0);$x(E,b,1,0,252,1);C=a[E+8+3>>0]|0;if((C<<24>>24<0?c[E+4>>2]|0:C&255)|0){z5(E);break}$x(F,b,1,0,76,1);C=a[F+8+3>>0]|0;C=((C<<24>>24<0?c[F+4>>2]|0:C&255)|0)==0;z5(F);z5(E);if(!C){$x(E,b,1,0,185,1);C=a[E+8+3>>0]|0;do if((C<<24>>24<0?c[E+4>>2]|0:C&255)|0){$x(F,b,1,0,171,1);C=a[F+8+3>>0]|0;C=((C<<24>>24<0?c[F+4>>2]|0:C&255)|0)==0;z5(F);z5(E);if(C){G=110;break}$x(E,b,1,0,185,1);B=rm(E)|0;C=z;z5(E);$x(E,b,1,0,171,1);y=+Eq(E);z5(E);x=UW(B|0,C|0,1e3,0)|0;e=(+(x>>>0)+4294967296.0*+(z>>>0))/y;if((B|0)==0&(C|0)==0|y==0.0|e==0.0)G=110}else{z5(E);G=110}while(0);if((G|0)==110){$x(E,b,1,0,76,1);e=+Eq(E);z5(E)}if(!(e!=0.0))break;h=cT(f*.125*e/1.0e3)|0;d=z;do if(!(a[A>>0]|0))g=h;else{i=D;g=c[i>>2]|0;i=c[i+4>>2]|0;if((g|0)==-1&(i|0)==-1){g=h;break}if(!(+(h>>>0)+4294967296.0*+(d>>>0)>=(+(g>>>0)+4294967296.0*+(i>>>0))*.99)){g=h;break}d=i}while(0);oK(b,1,0,252,g,d,10,0)}}}}while(0);C=D;if(!((c[C>>2]|0)==-1?(c[C+4>>2]|0)==-1:0)?($x(E,b,0,0,127,1),C=a[E+8+3>>0]|0,C=((C<<24>>24<0?c[E+4>>2]|0:C&255)|0)==0,z5(E),C):0){d=D;j=1;h=1;g=c[d+4>>2]|0;d=c[d>>2]|0;while(1){if(j>>>0>=6)break;k=(j|0)==3;i=0;while(1){if(i>>>0>=(RA(b,j,-1)|0)>>>0)break;$x(E,b,j,i,Rb(j,91)|0,1);B=rm(E)|0;D=z;z5(E);C=k|((B|0)!=0|(D|0)!=0);D=D_(d|0,g|0,(C?B:0)|0,(C?D:0)|0)|0;i=i+1|0;h=h&C;d=D;g=z}j=j+1|0}if(h&((g|0)>-1|(g|0)==-1&d>>>0>4294967295))jL(b,0,0,127,d,g,0)}$x(E,b,0,0,101,1);D=a[E+8+3>>0]|0;D=((D<<24>>24<0?c[E+4>>2]|0:D&255)|0)==0;z5(E);if(D){m=E+8+3|0;n=E+4|0;o=E+8+3|0;p=E+4|0;k=1;d=0;g=1;h=0;while(1){if((k|0)==6)break;else{j=0;i=g}while(1){if(j>>>0>=(RA(b,k,-1)|0)>>>0)break;h=Rb(k,36)|0;$x(E,b,k,j,h,1);g=i9(40152)|0;D=a[m>>0]|0;if((g|0)==((D<<24>>24<0?c[n>>2]|0:D&255)|0)){D=(VG(E,40152,g)|0)==0;z5(E);if(!D)G=138}else{z5(E);G=138}if((G|0)==138){G=0;i=0}$x(E,b,k,j,h,1);g=i9(40136)|0;D=a[o>>0]|0;if((g|0)==((D<<24>>24<0?c[p>>2]|0:D&255)|0)){D=(VG(E,40136,g)|0)==0;z5(E);d=d|D}else z5(E);j=j+1|0;h=1}k=k+1|0;g=i}if(h){if(g)RB(b,0,0,101,384431,-1,1,0);if(d)RB(b,0,0,101,384435,-1,1,0)}}$x(E,b,0,0,111,1);D=a[E+8+3>>0]|0;if(!((D<<24>>24<0?c[E+4>>2]|0:D&255)|0)){D=(RA(b,1,-1)|0)==0;z5(E);if(!D){$x(E,b,1,0,171,1);m=E+8+3|0;D=a[m>>0]|0;n=E+4|0;if(!((D<<24>>24<0?c[n>>2]|0:D&255)|0)){o=F+8+3|0;p=F+4|0;k=1;d=1;while(1){if(k>>>0<7)j=0;else break;while(1){if(j>>>0>=(RA(b,k,-1)|0)>>>0)break;$x(F,b,k,j,Rb(k,48)|0,1);h=a[o>>0]|0;g=h<<24>>24<0;h=g?c[p>>2]|0:h&255;do if(h){D=a[m>>0]|0;i=D<<24>>24<0;if((h|0)==((i?c[n>>2]|0:D&255)|0)?(L$(g?c[F>>2]|0:F,i?c[E>>2]|0:E,h)|0)==0:0)break;d=0}while(0);z5(F);j=j+1|0}k=k+1|0}if(d&1)G=160}else G=160;if((G|0)==160)zb(b,0,0,111,E,0);z5(E)}}else z5(E);$x(E,b,0,0,115,1);D=a[E+8+3>>0]|0;if(((D<<24>>24<0?c[E+4>>2]|0:D&255)|0)==0?(RA(b,1,-1)|0)!=0:0){gq(F,b,0,0,379092);D=a[F+8+3>>0]|0;D=((D<<24>>24<0?c[F+4>>2]|0:D&255)|0)==0;z5(F);z5(E);if(D){$x(E,b,1,0,185,1);m=E+8+3|0;D=a[m>>0]|0;n=E+4|0;if(!((D<<24>>24<0?c[n>>2]|0:D&255)|0)){o=F+8+3|0;p=F+4|0;k=1;d=1;while(1){if(k>>>0<7)j=0;else break;while(1){if(j>>>0>=(RA(b,k,-1)|0)>>>0)break;$x(F,b,k,j,Rb(k,52)|0,1);h=a[o>>0]|0;g=h<<24>>24<0;h=g?c[p>>2]|0:h&255;do if(h){D=a[m>>0]|0;i=D<<24>>24<0;if((h|0)==((i?c[n>>2]|0:D&255)|0)?(L$(g?c[F>>2]|0:F,i?c[E>>2]|0:E,h)|0)==0:0)break;d=0}while(0);z5(F);j=j+1|0}k=k+1|0}if(d&1)G=178}else G=178;if((G|0)==178)zb(b,0,0,115,E,0);z5(E)}}else z5(E);Jc(b);l=H;return}function Tb(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;L=l;l=l+80|0;E=L+78|0;t=L+60|0;D=L+48|0;F=L+76|0;G=L+74|0;H=L+72|0;I=L;J=L+36|0;K=L+24|0;m=L+12|0;HB(d,E);n=D+8+3|0;o=D+4|0;p=t+8+3|0;q=t+4|0;r=d+840|0;s=d+848|0;u=I+8+3|0;v=I+4|0;w=d+800|0;x=I+8+3|0;y=I+4|0;z=I+8|0;A=z+3|0;B=I+4|0;C=I+11|0;E=b[E>>1]|0;k=0;a:while(1){if((k&65535)>=(E&65535)){f=3;break}GC(d);TX(t);TX(D);HB(d,F);VY(d,e[F>>1]|0,0,t);HB(d,G);HB(d,H);b:do switch(b[G>>1]|0){case 0:{VY(d,e[H>>1]|0,0,D);i=0;j=0;break}case 1:{f=i9(30028)|0;j=a[p>>0]|0;g=b[H>>1]|0;if((f|0)==((j<<24>>24<0?c[q>>2]|0:j&255)|0)?(VG(t,30028,f)|0)==0:0){fA(d,g);i=0;j=0;break b}e1(d,g&65535,0);Xy(I,30108);vF(D,I)|0;z5(I);i=0;j=0;break}case 2:{bD(d,I);j=c[I>>2]|0;Xy(J,(j|0)==0?30144:30156);vF(D,J)|0;z5(J);i=0;break}case 3:{bD(d,I);j=c[I>>2]|0;Gk(D,j,10)|0;i=0;break}case 4:{Uy(d,I);i=I;j=c[i>>2]|0;i=c[i+4>>2]|0;bk(D,j,i,10)|0;break}case 5:{HB(d,I);j=b[I>>1]|0;Ek(D,j,10)|0;i=0;j=j&65535;break}default:{e1(d,e[H>>1]|0,0);Xy(I,30172);vF(D,I)|0;z5(I);i=0;j=0}}while(0);J3(d);h=a[n>>0]|0;c:do if((h<<24>>24<0?c[o>>2]|0:h&255)|0){f=i9(30212)|0;h=a[p>>0]|0;g=c[q>>2]|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(t,30212,f)|0))break;h=a[p>>0]|0;g=c[q>>2]|0}f=i9(30028)|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(t,30028,f)|0))break;h=a[p>>0]|0;g=c[q>>2]|0}f=i9(30260)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,30260,f)|0)){h=r;c[h>>2]=j;c[h+4>>2]=i;break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(30312)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,30312,f)|0)){h=s;c[h>>2]=j;c[h+4>>2]=i;break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(30364)|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(t,30364,f)|0))break;h=a[p>>0]|0;g=c[q>>2]|0}f=i9(30424)|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(t,30424,f)|0))break;h=a[p>>0]|0;g=c[q>>2]|0}f=i9(30512)|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(t,30512,f)|0))break;h=a[p>>0]|0;g=c[q>>2]|0}f=i9(30580)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,30580,f)|0)){RB(d,0,0,101,(j|0)==0&(i|0)==0?384431:384435,-1,1,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(30604)|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(t,30604,f)|0))break;h=a[p>>0]|0;g=c[q>>2]|0}f=i9(30640)|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(t,30640,f)|0))break;h=a[p>>0]|0;g=c[q>>2]|0}f=i9(30696)|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(t,30696,f)|0))break;h=a[p>>0]|0;g=c[q>>2]|0}f=i9(30748)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,30748,f)|0)){zb(d,0,0,171,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(30804)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,30804,f)|0)){RB(d,0,0,199,8800948,-1,1,0);zb(d,0,0,199,D,1);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(30864)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,30864,f)|0)){zb(d,0,0,200,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(30940)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,30940,f)|0)){Mc(d,0,0,380125,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(30992)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,30992,f)|0)){zb(d,0,0,292,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31064)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31064,f)|0)){RB(d,0,0,314,381128,-1,1,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31104)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31104,f)|0)){zb(d,0,0,320,D,1);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31152)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31152,f)|0)){zb(d,0,0,204,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31200)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31200,f)|0)){zb(d,0,0,210,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31252)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31252,f)|0)){zb(d,0,0,233,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31304)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31304,f)|0)){zb(d,0,0,279,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31380)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31380,f)|0)){TX(I);zb(d,0,0,256,tZ(I,j,i)|0,0);z5(I);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31444)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31444,f)|0)){zb(d,0,0,240,D,1);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31480)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(VG(t,31480,f)|0){h=a[p>>0]|0;g=c[q>>2]|0;break}$x(I,d,0,0,240,1);j=a[u>>0]|0;j=((j<<24>>24<0?c[v>>2]|0:j&255)|0)==0;z5(I);if(!j)break c;zb(d,0,0,240,D,0);break c}while(0);f=i9(31524)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31524,f)|0)){k1(w,D)|0;break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31572)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31572,f)|0)){zb(d,0,0,236,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31636)|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(t,31636,f)|0))break;h=a[p>>0]|0;g=c[q>>2]|0}f=i9(31728)|0;if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(!(VG(t,31728,f)|0))break;h=a[p>>0]|0;g=c[q>>2]|0}f=i9(31760)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31760,f)|0)){zb(d,0,0,234,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31816)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31816,f)|0)){Mc(d,0,0,380136,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31904)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31904,f)|0)){Mc(d,0,0,380151,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(31996)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,31996,f)|0)){zb(d,0,0,250,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(32068)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,32068,f)|0)){zb(d,0,0,251,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(32164)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,32164,f)|0)){RB(d,0,0,314,381128,-1,1,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(32208)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,32208,f)|0)){Mc(d,0,0,380174,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(32256)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,32256,f)|0)){zb(d,0,0,237,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(32308)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,32308,f)|0)){zb(d,0,0,304,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(32388)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,32388,f)|0)){zb(d,0,0,307,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(32472)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,32472,f)|0)){zb(d,0,0,160,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(32520)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,32520,f)|0)){zb(d,0,0,160,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(32612)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,32612,f)|0)){zb(d,0,0,267,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(32660)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(VG(t,32660,f)|0){h=a[p>>0]|0;g=c[q>>2]|0;break}$x(m,d,0,0,267,1);HX(m,42252)|0;c[K>>2]=c[m>>2];c[K+4>>2]=c[m+4>>2];c[K+8>>2]=c[m+8>>2];f=0;while(1){if((f|0)==3)break;c[m+(f<<2)>>2]=0;f=f+1|0}f=a[n>>0]|0;j=f<<24>>24<0;Ex(K,j?c[D>>2]|0:D,j?c[o>>2]|0:f&255)|0;c[J>>2]=c[K>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];f=0;while(1){if((f|0)==3)break;c[K+(f<<2)>>2]=0;f=f+1|0}p2(I,J);zb(d,0,0,267,I,1);z5(I);O0(J);O0(K);z5(m);break c}while(0);f=i9(32720)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,32720,f)|0)){zb(d,0,0,187,D,1);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(32780)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(VG(t,32780,f)|0){h=a[p>>0]|0;g=c[q>>2]|0;break}$x(I,d,0,0,187,1);j=a[x>>0]|0;j=((j<<24>>24<0?c[y>>2]|0:j&255)|0)==0;z5(I);if(!j)break c;lL(d,0,0,187,(pn(D)|0)+1|0,10,0);break c}while(0);f=i9(32816)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(VG(t,32816,f)|0){h=a[p>>0]|0;g=c[q>>2]|0;break}i=a[n>>0]|0;j=i<<24>>24<0;if((j?c[o>>2]|0:i&255)|0?(c[(j?c[D>>2]|0:D)>>2]|0)==59:0)break c;c[I>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;g=i9(42436)|0;if(g>>>0>1073741807){f=200;break a}if(g>>>0<2){a[A>>0]=g;f=I}else{f=g+4&-4;if(f>>>0>1073741823){f=204;break a}j=ZW(f<<2)|0;c[I>>2]=j;c[z>>2]=f|-2147483648;c[B>>2]=g;f=j}a3(f,42436,g);y7(f+(g<<2)|0,0);kT(J);vo(D,I,J,0,0);z5(J);O0(I);zb(d,0,0,14,D,0);break c}while(0);f=i9(32912)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0))if(!(VG(t,32912,f)|0)){zb(d,0,0,222,D,0);break c}else{h=a[p>>0]|0;g=c[q>>2]|0;break}while(0);f=i9(32952)|0;do if((f|0)==((h<<24>>24<0?g:h&255)|0)){if(VG(t,32952,f)|0)break;zb(d,0,0,255,D,0);break c}while(0);pk(I,t);Mc(d,0,0,(a[C>>0]|0)<0?c[I>>2]|0:I,D,0);a1(I)}while(0);z5(D);z5(t);k=k+1<<16>>16}if((f|0)==3){l=L;return}else if((f|0)==200)uaa();else if((f|0)==204){L=ua(8)|0;K2(L,391652);c[L>>2]=57868;Ya(L|0,2712,367)}}function Ub(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=l;l=l+16|0;o=x;do if(a>>>0<245){k=a>>>0<11?16:a+11&-8;a=k>>>3;n=c[102120]|0;d=n>>>a;if(d&3|0){b=(d&1^1)+a|0;a=408520+(b<<1<<2)|0;d=a+8|0;e=c[d>>2]|0;f=e+8|0;g=c[f>>2]|0;if((a|0)==(g|0))c[102120]=n&~(1<<b);else{c[g+12>>2]=a;c[d>>2]=g}w=b<<3;c[e+4>>2]=w|3;w=e+w+4|0;c[w>>2]=c[w>>2]|1;w=f;l=x;return w|0}m=c[102122]|0;if(k>>>0>m>>>0){if(d|0){b=2<<a;b=d<<a&(b|0-b);b=(b&0-b)+-1|0;h=b>>>12&16;b=b>>>h;d=b>>>5&8;b=b>>>d;f=b>>>2&4;b=b>>>f;a=b>>>1&2;b=b>>>a;e=b>>>1&1;e=(d|h|f|a|e)+(b>>>e)|0;b=408520+(e<<1<<2)|0;a=b+8|0;f=c[a>>2]|0;h=f+8|0;d=c[h>>2]|0;if((b|0)==(d|0)){a=n&~(1<<e);c[102120]=a}else{c[d+12>>2]=b;c[a>>2]=d;a=n}g=(e<<3)-k|0;c[f+4>>2]=k|3;e=f+k|0;c[e+4>>2]=g|1;c[e+g>>2]=g;if(m|0){f=c[102125]|0;b=m>>>3;d=408520+(b<<1<<2)|0;b=1<<b;if(!(a&b)){c[102120]=a|b;b=d;a=d+8|0}else{a=d+8|0;b=c[a>>2]|0}c[a>>2]=f;c[b+12>>2]=f;c[f+8>>2]=b;c[f+12>>2]=d}c[102122]=g;c[102125]=e;w=h;l=x;return w|0}i=c[102121]|0;if(i){d=(i&0-i)+-1|0;h=d>>>12&16;d=d>>>h;g=d>>>5&8;d=d>>>g;j=d>>>2&4;d=d>>>j;e=d>>>1&2;d=d>>>e;a=d>>>1&1;a=c[408784+((g|h|j|e|a)+(d>>>a)<<2)>>2]|0;d=(c[a+4>>2]&-8)-k|0;e=c[a+16+(((c[a+16>>2]|0)==0&1)<<2)>>2]|0;if(!e){j=a;g=d}else{do{h=(c[e+4>>2]&-8)-k|0;j=h>>>0<d>>>0;d=j?h:d;a=j?e:a;e=c[e+16+(((c[e+16>>2]|0)==0&1)<<2)>>2]|0}while((e|0)!=0);j=a;g=d}h=j+k|0;if(j>>>0<h>>>0){f=c[j+24>>2]|0;b=c[j+12>>2]|0;do if((b|0)==(j|0)){a=j+20|0;b=c[a>>2]|0;if(!b){a=j+16|0;b=c[a>>2]|0;if(!b){e=0;break}}while(1){d=b+20|0;e=c[d>>2]|0;if(e|0){b=e;a=d;continue}d=b+16|0;e=c[d>>2]|0;if(!e)break;else{b=e;a=d}}c[a>>2]=0;e=b}else{e=c[j+8>>2]|0;c[e+12>>2]=b;c[b+8>>2]=e;e=b}while(0);do if(f|0){b=c[j+28>>2]|0;a=408784+(b<<2)|0;d=(e|0)==0;if((j|0)==(c[a>>2]|0)){c[a>>2]=e;if(d){c[102121]=i&~(1<<b);break}}else{c[f+16+(((c[f+16>>2]|0)!=(j|0)&1)<<2)>>2]=e;if(d)break}c[e+24>>2]=f;b=c[j+16>>2]|0;if(b|0){c[e+16>>2]=b;c[b+24>>2]=e}b=c[j+20>>2]|0;if(b|0){c[e+20>>2]=b;c[b+24>>2]=e}}while(0);if(g>>>0<16){w=g+k|0;c[j+4>>2]=w|3;w=j+w+4|0;c[w>>2]=c[w>>2]|1}else{c[j+4>>2]=k|3;c[h+4>>2]=g|1;c[h+g>>2]=g;if(m|0){e=c[102125]|0;b=m>>>3;d=408520+(b<<1<<2)|0;b=1<<b;if(!(b&n)){c[102120]=b|n;b=d;a=d+8|0}else{a=d+8|0;b=c[a>>2]|0}c[a>>2]=e;c[b+12>>2]=e;c[e+8>>2]=b;c[e+12>>2]=d}c[102122]=g;c[102125]=h}w=j+8|0;l=x;return w|0}else n=k}else n=k}else n=k}else if(a>>>0<=4294967231){a=a+11|0;k=a&-8;j=c[102121]|0;if(j){e=0-k|0;a=a>>>8;if(a)if(k>>>0>16777215)i=31;else{n=(a+1048320|0)>>>16&8;v=a<<n;m=(v+520192|0)>>>16&4;v=v<<m;i=(v+245760|0)>>>16&2;i=14-(m|n|i)+(v<<i>>>15)|0;i=k>>>(i+7|0)&1|i<<1}else i=0;d=c[408784+(i<<2)>>2]|0;a:do if(!d){d=0;a=0;v=57}else{a=0;h=k<<((i|0)==31?0:25-(i>>>1)|0);g=0;while(1){f=(c[d+4>>2]&-8)-k|0;if(f>>>0<e>>>0)if(!f){a=d;e=0;f=d;v=61;break a}else{a=d;e=f}f=c[d+20>>2]|0;d=c[d+16+(h>>>31<<2)>>2]|0;g=(f|0)==0|(f|0)==(d|0)?g:f;f=(d|0)==0;if(f){d=g;v=57;break}else h=h<<((f^1)&1)}}while(0);if((v|0)==57){if((d|0)==0&(a|0)==0){a=2<<i;a=(a|0-a)&j;if(!a){n=k;break}n=(a&0-a)+-1|0;h=n>>>12&16;n=n>>>h;g=n>>>5&8;n=n>>>g;i=n>>>2&4;n=n>>>i;m=n>>>1&2;n=n>>>m;d=n>>>1&1;a=0;d=c[408784+((g|h|i|m|d)+(n>>>d)<<2)>>2]|0}if(!d){i=a;h=e}else{f=d;v=61}}if((v|0)==61)while(1){v=0;d=(c[f+4>>2]&-8)-k|0;n=d>>>0<e>>>0;d=n?d:e;a=n?f:a;f=c[f+16+(((c[f+16>>2]|0)==0&1)<<2)>>2]|0;if(!f){i=a;h=d;break}else{e=d;v=61}}if((i|0)!=0?h>>>0<((c[102122]|0)-k|0)>>>0:0){g=i+k|0;if(i>>>0>=g>>>0){w=0;l=x;return w|0}f=c[i+24>>2]|0;b=c[i+12>>2]|0;do if((b|0)==(i|0)){a=i+20|0;b=c[a>>2]|0;if(!b){a=i+16|0;b=c[a>>2]|0;if(!b){b=0;break}}while(1){d=b+20|0;e=c[d>>2]|0;if(e|0){b=e;a=d;continue}d=b+16|0;e=c[d>>2]|0;if(!e)break;else{b=e;a=d}}c[a>>2]=0}else{w=c[i+8>>2]|0;c[w+12>>2]=b;c[b+8>>2]=w}while(0);do if(f){a=c[i+28>>2]|0;d=408784+(a<<2)|0;e=(b|0)==0;if((i|0)==(c[d>>2]|0)){c[d>>2]=b;if(e){e=j&~(1<<a);c[102121]=e;break}}else{c[f+16+(((c[f+16>>2]|0)!=(i|0)&1)<<2)>>2]=b;if(e){e=j;break}}c[b+24>>2]=f;a=c[i+16>>2]|0;if(a|0){c[b+16>>2]=a;c[a+24>>2]=b}a=c[i+20>>2]|0;if(a){c[b+20>>2]=a;c[a+24>>2]=b;e=j}else e=j}else e=j;while(0);do if(h>>>0>=16){c[i+4>>2]=k|3;c[g+4>>2]=h|1;c[g+h>>2]=h;b=h>>>3;if(h>>>0<256){d=408520+(b<<1<<2)|0;a=c[102120]|0;b=1<<b;if(!(a&b)){c[102120]=a|b;b=d;a=d+8|0}else{a=d+8|0;b=c[a>>2]|0}c[a>>2]=g;c[b+12>>2]=g;c[g+8>>2]=b;c[g+12>>2]=d;break}b=h>>>8;if(b)if(h>>>0>16777215)b=31;else{v=(b+1048320|0)>>>16&8;w=b<<v;u=(w+520192|0)>>>16&4;w=w<<u;b=(w+245760|0)>>>16&2;b=14-(u|v|b)+(w<<b>>>15)|0;b=h>>>(b+7|0)&1|b<<1}else b=0;d=408784+(b<<2)|0;c[g+28>>2]=b;a=g+16|0;c[a+4>>2]=0;c[a>>2]=0;a=1<<b;if(!(a&e)){c[102121]=a|e;c[d>>2]=g;c[g+24>>2]=d;c[g+12>>2]=g;c[g+8>>2]=g;break}a=h<<((b|0)==31?0:25-(b>>>1)|0);d=c[d>>2]|0;while(1){if((c[d+4>>2]&-8|0)==(h|0)){v=97;break}e=d+16+(a>>>31<<2)|0;b=c[e>>2]|0;if(!b){v=96;break}else{a=a<<1;d=b}}if((v|0)==96){c[e>>2]=g;c[g+24>>2]=d;c[g+12>>2]=g;c[g+8>>2]=g;break}else if((v|0)==97){v=d+8|0;w=c[v>>2]|0;c[w+12>>2]=g;c[v>>2]=g;c[g+8>>2]=w;c[g+12>>2]=d;c[g+24>>2]=0;break}}else{w=h+k|0;c[i+4>>2]=w|3;w=i+w+4|0;c[w>>2]=c[w>>2]|1}while(0);w=i+8|0;l=x;return w|0}else n=k}else n=k}else n=-1;while(0);d=c[102122]|0;if(d>>>0>=n>>>0){b=d-n|0;a=c[102125]|0;if(b>>>0>15){w=a+n|0;c[102125]=w;c[102122]=b;c[w+4>>2]=b|1;c[w+b>>2]=b;c[a+4>>2]=n|3}else{c[102122]=0;c[102125]=0;c[a+4>>2]=d|3;w=a+d+4|0;c[w>>2]=c[w>>2]|1}w=a+8|0;l=x;return w|0}h=c[102123]|0;if(h>>>0>n>>>0){u=h-n|0;c[102123]=u;w=c[102126]|0;v=w+n|0;c[102126]=v;c[v+4>>2]=u|1;c[w+4>>2]=n|3;w=w+8|0;l=x;return w|0}if(!(c[102238]|0)){c[102240]=4096;c[102239]=4096;c[102241]=-1;c[102242]=-1;c[102243]=0;c[102231]=0;a=o&-16^1431655768;c[o>>2]=a;c[102238]=a;a=4096}else a=c[102240]|0;i=n+48|0;j=n+47|0;g=a+j|0;f=0-a|0;k=g&f;if(k>>>0<=n>>>0){w=0;l=x;return w|0}a=c[102230]|0;if(a|0?(m=c[102228]|0,o=m+k|0,o>>>0<=m>>>0|o>>>0>a>>>0):0){w=0;l=x;return w|0}b:do if(!(c[102231]&4)){d=c[102126]|0;c:do if(d){e=408928;while(1){a=c[e>>2]|0;if(a>>>0<=d>>>0?(r=e+4|0,(a+(c[r>>2]|0)|0)>>>0>d>>>0):0)break;a=c[e+8>>2]|0;if(!a){v=118;break c}else e=a}b=g-h&f;if(b>>>0<2147483647){a=IN(b|0)|0;if((a|0)==((c[e>>2]|0)+(c[r>>2]|0)|0)){if((a|0)!=(-1|0)){h=b;g=a;v=135;break b}}else{e=a;v=126}}else b=0}else v=118;while(0);do if((v|0)==118){d=IN(0)|0;if((d|0)!=(-1|0)?(b=d,p=c[102239]|0,q=p+-1|0,b=((q&b|0)==0?0:(q+b&0-p)-b|0)+k|0,p=c[102228]|0,q=b+p|0,b>>>0>n>>>0&b>>>0<2147483647):0){r=c[102230]|0;if(r|0?q>>>0<=p>>>0|q>>>0>r>>>0:0){b=0;break}a=IN(b|0)|0;if((a|0)==(d|0)){h=b;g=d;v=135;break b}else{e=a;v=126}}else b=0}while(0);do if((v|0)==126){d=0-b|0;if(!(i>>>0>b>>>0&(b>>>0<2147483647&(e|0)!=(-1|0))))if((e|0)==(-1|0)){b=0;break}else{h=b;g=e;v=135;break b}a=c[102240]|0;a=j-b+a&0-a;if(a>>>0>=2147483647){h=b;g=e;v=135;break b}if((IN(a|0)|0)==(-1|0)){IN(d|0)|0;b=0;break}else{h=a+b|0;g=e;v=135;break b}}while(0);c[102231]=c[102231]|4;v=133}else{b=0;v=133}while(0);if(((v|0)==133?k>>>0<2147483647:0)?(u=IN(k|0)|0,r=IN(0)|0,s=r-u|0,t=s>>>0>(n+40|0)>>>0,!((u|0)==(-1|0)|t^1|u>>>0<r>>>0&((u|0)!=(-1|0)&(r|0)!=(-1|0))^1)):0){h=t?s:b;g=u;v=135}if((v|0)==135){b=(c[102228]|0)+h|0;c[102228]=b;if(b>>>0>(c[102229]|0)>>>0)c[102229]=b;j=c[102126]|0;do if(j){b=408928;while(1){a=c[b>>2]|0;d=b+4|0;e=c[d>>2]|0;if((g|0)==(a+e|0)){v=145;break}f=c[b+8>>2]|0;if(!f)break;else b=f}if(((v|0)==145?(c[b+12>>2]&8|0)==0:0)?j>>>0<g>>>0&j>>>0>=a>>>0:0){c[d>>2]=e+h;w=j+8|0;w=(w&7|0)==0?0:0-w&7;v=j+w|0;w=(c[102123]|0)+(h-w)|0;c[102126]=v;c[102123]=w;c[v+4>>2]=w|1;c[v+w+4>>2]=40;c[102127]=c[102242];break}if(g>>>0<(c[102124]|0)>>>0)c[102124]=g;d=g+h|0;b=408928;while(1){if((c[b>>2]|0)==(d|0)){v=153;break}a=c[b+8>>2]|0;if(!a)break;else b=a}if((v|0)==153?(c[b+12>>2]&8|0)==0:0){c[b>>2]=g;m=b+4|0;c[m>>2]=(c[m>>2]|0)+h;m=g+8|0;m=g+((m&7|0)==0?0:0-m&7)|0;b=d+8|0;b=d+((b&7|0)==0?0:0-b&7)|0;k=m+n|0;i=b-m-n|0;c[m+4>>2]=n|3;do if((b|0)!=(j|0)){if((b|0)==(c[102125]|0)){w=(c[102122]|0)+i|0;c[102122]=w;c[102125]=k;c[k+4>>2]=w|1;c[k+w>>2]=w;break}a=c[b+4>>2]|0;if((a&3|0)==1){h=a&-8;e=a>>>3;d:do if(a>>>0<256){a=c[b+8>>2]|0;d=c[b+12>>2]|0;if((d|0)==(a|0)){c[102120]=c[102120]&~(1<<e);break}else{c[a+12>>2]=d;c[d+8>>2]=a;break}}else{g=c[b+24>>2]|0;a=c[b+12>>2]|0;do if((a|0)==(b|0)){e=b+16|0;d=e+4|0;a=c[d>>2]|0;if(!a){a=c[e>>2]|0;if(!a){a=0;break}else d=e}while(1){e=a+20|0;f=c[e>>2]|0;if(f|0){a=f;d=e;continue}e=a+16|0;f=c[e>>2]|0;if(!f)break;else{a=f;d=e}}c[d>>2]=0}else{w=c[b+8>>2]|0;c[w+12>>2]=a;c[a+8>>2]=w}while(0);if(!g)break;d=c[b+28>>2]|0;e=408784+(d<<2)|0;f=(a|0)==0;do if((b|0)!=(c[e>>2]|0)){c[g+16+(((c[g+16>>2]|0)!=(b|0)&1)<<2)>>2]=a;if(f)break d}else{c[e>>2]=a;if(!f)break;c[102121]=c[102121]&~(1<<d);break d}while(0);c[a+24>>2]=g;d=b+16|0;e=c[d>>2]|0;if(e|0){c[a+16>>2]=e;c[e+24>>2]=a}d=c[d+4>>2]|0;if(!d)break;c[a+20>>2]=d;c[d+24>>2]=a}while(0);b=b+h|0;f=h+i|0}else f=i;b=b+4|0;c[b>>2]=c[b>>2]&-2;c[k+4>>2]=f|1;c[k+f>>2]=f;b=f>>>3;if(f>>>0<256){d=408520+(b<<1<<2)|0;a=c[102120]|0;b=1<<b;if(!(a&b)){c[102120]=a|b;b=d;a=d+8|0}else{a=d+8|0;b=c[a>>2]|0}c[a>>2]=k;c[b+12>>2]=k;c[k+8>>2]=b;c[k+12>>2]=d;break}b=f>>>8;do if(!b)b=0;else{if(f>>>0>16777215){b=31;break}v=(b+1048320|0)>>>16&8;w=b<<v;u=(w+520192|0)>>>16&4;w=w<<u;b=(w+245760|0)>>>16&2;b=14-(u|v|b)+(w<<b>>>15)|0;b=f>>>(b+7|0)&1|b<<1}while(0);e=408784+(b<<2)|0;c[k+28>>2]=b;a=k+16|0;c[a+4>>2]=0;c[a>>2]=0;a=c[102121]|0;d=1<<b;if(!(a&d)){c[102121]=a|d;c[e>>2]=k;c[k+24>>2]=e;c[k+12>>2]=k;c[k+8>>2]=k;break}a=f<<((b|0)==31?0:25-(b>>>1)|0);d=c[e>>2]|0;while(1){if((c[d+4>>2]&-8|0)==(f|0)){v=194;break}e=d+16+(a>>>31<<2)|0;b=c[e>>2]|0;if(!b){v=193;break}else{a=a<<1;d=b}}if((v|0)==193){c[e>>2]=k;c[k+24>>2]=d;c[k+12>>2]=k;c[k+8>>2]=k;break}else if((v|0)==194){v=d+8|0;w=c[v>>2]|0;c[w+12>>2]=k;c[v>>2]=k;c[k+8>>2]=w;c[k+12>>2]=d;c[k+24>>2]=0;break}}else{w=(c[102123]|0)+i|0;c[102123]=w;c[102126]=k;c[k+4>>2]=w|1}while(0);w=m+8|0;l=x;return w|0}b=408928;while(1){a=c[b>>2]|0;if(a>>>0<=j>>>0?(w=a+(c[b+4>>2]|0)|0,w>>>0>j>>>0):0)break;b=c[b+8>>2]|0}f=w+-47|0;a=f+8|0;a=f+((a&7|0)==0?0:0-a&7)|0;f=j+16|0;a=a>>>0<f>>>0?j:a;b=a+8|0;d=g+8|0;d=(d&7|0)==0?0:0-d&7;v=g+d|0;d=h+-40-d|0;c[102126]=v;c[102123]=d;c[v+4>>2]=d|1;c[v+d+4>>2]=40;c[102127]=c[102242];d=a+4|0;c[d>>2]=27;c[b>>2]=c[102232];c[b+4>>2]=c[102233];c[b+8>>2]=c[102234];c[b+12>>2]=c[102235];c[102232]=g;c[102233]=h;c[102235]=0;c[102234]=b;b=a+24|0;do{v=b;b=b+4|0;c[b>>2]=7}while((v+8|0)>>>0<w>>>0);if((a|0)!=(j|0)){g=a-j|0;c[d>>2]=c[d>>2]&-2;c[j+4>>2]=g|1;c[a>>2]=g;b=g>>>3;if(g>>>0<256){d=408520+(b<<1<<2)|0;a=c[102120]|0;b=1<<b;if(!(a&b)){c[102120]=a|b;b=d;a=d+8|0}else{a=d+8|0;b=c[a>>2]|0}c[a>>2]=j;c[b+12>>2]=j;c[j+8>>2]=b;c[j+12>>2]=d;break}b=g>>>8;if(b)if(g>>>0>16777215)d=31;else{v=(b+1048320|0)>>>16&8;w=b<<v;u=(w+520192|0)>>>16&4;w=w<<u;d=(w+245760|0)>>>16&2;d=14-(u|v|d)+(w<<d>>>15)|0;d=g>>>(d+7|0)&1|d<<1}else d=0;e=408784+(d<<2)|0;c[j+28>>2]=d;c[j+20>>2]=0;c[f>>2]=0;b=c[102121]|0;a=1<<d;if(!(b&a)){c[102121]=b|a;c[e>>2]=j;c[j+24>>2]=e;c[j+12>>2]=j;c[j+8>>2]=j;break}a=g<<((d|0)==31?0:25-(d>>>1)|0);d=c[e>>2]|0;while(1){if((c[d+4>>2]&-8|0)==(g|0)){v=216;break}e=d+16+(a>>>31<<2)|0;b=c[e>>2]|0;if(!b){v=215;break}else{a=a<<1;d=b}}if((v|0)==215){c[e>>2]=j;c[j+24>>2]=d;c[j+12>>2]=j;c[j+8>>2]=j;break}else if((v|0)==216){v=d+8|0;w=c[v>>2]|0;c[w+12>>2]=j;c[v>>2]=j;c[j+8>>2]=w;c[j+12>>2]=d;c[j+24>>2]=0;break}}}else{w=c[102124]|0;if((w|0)==0|g>>>0<w>>>0)c[102124]=g;c[102232]=g;c[102233]=h;c[102235]=0;c[102129]=c[102238];c[102128]=-1;b=0;do{w=408520+(b<<1<<2)|0;c[w+12>>2]=w;c[w+8>>2]=w;b=b+1|0}while((b|0)!=32);w=g+8|0;w=(w&7|0)==0?0:0-w&7;v=g+w|0;w=h+-40-w|0;c[102126]=v;c[102123]=w;c[v+4>>2]=w|1;c[v+w+4>>2]=40;c[102127]=c[102242]}while(0);b=c[102123]|0;if(b>>>0>n>>>0){u=b-n|0;c[102123]=u;w=c[102126]|0;v=w+n|0;c[102126]=v;c[v+4>>2]=u|1;c[w+4>>2]=n|3;w=w+8|0;l=x;return w|0}}c[12784]=12;w=0;l=x;return w|0}function Vb(e,f,g,h,i,j,k,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=l;l=l+512|0;Q=$+88|0;q=$+96|0;_=$+80|0;K=$+72|0;L=$+68|0;M=$+500|0;N=$+497|0;O=$+496|0;U=$+56|0;V=$+44|0;W=$+32|0;X=$+20|0;Y=$+8|0;P=$+4|0;T=$;c[Q>>2]=p;c[_>>2]=q;Z=_+4|0;c[Z>>2]=375;c[K>>2]=q;c[L>>2]=q+400;c[U>>2]=0;c[U+4>>2]=0;c[U+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[U+(p<<2)>>2]=0;p=p+1|0}c[V>>2]=0;c[V+4>>2]=0;c[V+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[V+(p<<2)>>2]=0;p=p+1|0}c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[W+(p<<2)>>2]=0;p=p+1|0}c[X>>2]=0;c[X+4>>2]=0;c[X+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[X+(p<<2)>>2]=0;p=p+1|0}c[Y>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[Y+(p<<2)>>2]=0;p=p+1|0}xe(g,h,M,N,O,U,V,W,X,P);c[o>>2]=c[n>>2];F=m+8|0;G=W+11|0;H=W+4|0;I=X+11|0;J=X+4|0;x=(i&512|0)!=0;y=V+11|0;z=V+4|0;A=Y+11|0;B=Y+4|0;C=M+3|0;D=U+11|0;E=U+4|0;R=0;w=0;v=q;a:while(1){g=(R|0)!=0;if(w>>>0>=4){S=231;break}p=c[e>>2]|0;do if(p){h=c[p+12>>2]|0;if((h|0)==(c[p+16>>2]|0))p=nb[c[(c[p>>2]|0)+36>>2]&255](p)|0;else p=e9(a[h>>0]|0)|0;if(d8(p,-1)|0){c[e>>2]=0;h=1;break}else{h=(c[e>>2]|0)==0;break}}else h=1;while(0);if(f){p=c[f+12>>2]|0;if((p|0)==(c[f+16>>2]|0))p=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else p=e9(a[p>>0]|0)|0;if(!(d8(p,-1)|0)){if(!h){S=231;break}}else S=30}else S=30;if((S|0)==30){S=0;if(h){f=0;S=231;break}else f=0}p=(w|0)!=3;b:do switch(a[M+w>>0]|0){case 1:{if(p){p=c[e>>2]|0;h=c[p+12>>2]|0;if((h|0)==(c[p+16>>2]|0))p=nb[c[(c[p>>2]|0)+36>>2]&255](p)|0;else p=e9(a[h>>0]|0)|0;if((p&255)<<24>>24<=-1){S=44;break a}if(!(b[(c[F>>2]|0)+(p<<24>>24<<1)>>1]&8192)){S=44;break a}p=c[e>>2]|0;h=p+12|0;g=c[h>>2]|0;if((g|0)==(c[p+16>>2]|0))p=nb[c[(c[p>>2]|0)+40>>2]&255](p)|0;else{c[h>>2]=g+1;p=e9(a[g>>0]|0)|0}gy(Y,p&255);p=f;q=f;g=f;S=46}else{h=R;p=v}break}case 0:{if(p){p=f;q=f;g=f;S=46}else{h=R;p=v}break}case 3:{p=a[G>>0]|0;h=p<<24>>24<0?c[H>>2]|0:p&255;m=a[I>>0]|0;m=m<<24>>24<0?c[J>>2]|0:m&255;if((h|0)==(0-m|0)){h=R;p=v}else{i=(h|0)==0;q=c[e>>2]|0;r=c[q+12>>2]|0;h=c[q+16>>2]|0;g=(r|0)==(h|0);if(i|(m|0)==0){if(g)p=nb[c[(c[q>>2]|0)+36>>2]&255](q)|0;else p=e9(a[r>>0]|0)|0;h=p&255;if(i){p=a[I>>0]|0;if(h<<24>>24!=(a[(p<<24>>24<0?c[X>>2]|0:X)>>0]|0)){h=R;p=v;break b}h=c[e>>2]|0;g=h+12|0;m=c[g>>2]|0;if((m|0)==(c[h+16>>2]|0)){nb[c[(c[h>>2]|0)+40>>2]&255](h)|0;p=a[I>>0]|0}else c[g>>2]=m+1;a[k>>0]=1;h=(p<<24>>24<0?c[J>>2]|0:p&255)>>>0>1?X:R;p=v;break b}p=a[G>>0]|0;if(h<<24>>24!=(a[(p<<24>>24<0?c[W>>2]|0:W)>>0]|0)){a[k>>0]=1;h=R;p=v;break b}h=c[e>>2]|0;g=h+12|0;m=c[g>>2]|0;if((m|0)==(c[h+16>>2]|0)){nb[c[(c[h>>2]|0)+40>>2]&255](h)|0;p=a[G>>0]|0}else c[g>>2]=m+1;h=(p<<24>>24<0?c[H>>2]|0:p&255)>>>0>1?W:R;p=v;break b}if(g){i=nb[c[(c[q>>2]|0)+36>>2]&255](q)|0;h=c[e>>2]|0;p=a[G>>0]|0;q=h;m=c[h+12>>2]|0;h=c[h+16>>2]|0}else{i=e9(a[r>>0]|0)|0;m=r}g=q+12|0;h=(m|0)==(h|0);if((i&255)<<24>>24==(a[(p<<24>>24<0?c[W>>2]|0:W)>>0]|0)){if(h){nb[c[(c[q>>2]|0)+40>>2]&255](q)|0;p=a[G>>0]|0}else c[g>>2]=m+1;h=(p<<24>>24<0?c[H>>2]|0:p&255)>>>0>1?W:R;p=v;break b}if(h)h=nb[c[(c[q>>2]|0)+36>>2]&255](q)|0;else h=e9(a[m>>0]|0)|0;p=a[I>>0]|0;if((h&255)<<24>>24!=(a[(p<<24>>24<0?c[X>>2]|0:X)>>0]|0)){S=102;break a}h=c[e>>2]|0;g=h+12|0;m=c[g>>2]|0;if((m|0)==(c[h+16>>2]|0)){nb[c[(c[h>>2]|0)+40>>2]&255](h)|0;p=a[I>>0]|0}else c[g>>2]=m+1;a[k>>0]=1;h=(p<<24>>24<0?c[J>>2]|0:p&255)>>>0>1?X:R;p=v}break}case 2:{if(!(w>>>0<2|g)?!(x|(w|0)==2&(a[C>>0]|0)!=0):0){h=0;p=v;break b}r=a[y>>0]|0;p=r<<24>>24<0;s=c[V>>2]|0;h=p?s:V;q=h;c:do if((w|0)!=0?(d[M+(w+-1)>>0]|0)<2:0){p=h+(p?c[z>>2]|0:r&255)|0;i=q;while(1){g=i;if((g|0)==(p|0))break;m=a[g>>0]|0;if(m<<24>>24<=-1)break;if(!(b[(c[F>>2]|0)+(m<<24>>24<<1)>>1]&8192))break;i=g+1|0}m=i-q|0;g=a[A>>0]|0;p=g<<24>>24<0;g=p?c[B>>2]|0:g&255;if(m>>>0<=g>>>0){g=(p?c[Y>>2]|0:Y)+g|0;p=g+(0-m)|0;while(1){if((p|0)==(g|0)){t=f;u=f;g=i;h=r;p=s;m=f;break c}if((a[p>>0]|0)!=(a[h>>0]|0)){t=f;u=f;g=q;h=r;p=s;m=f;break c}h=h+1|0;p=p+1|0}}else{t=f;u=f;g=q;h=r;p=s;m=f}}else{t=f;u=f;g=q;h=r;p=s;m=f}while(0);while(1){q=h<<24>>24<0;p=(q?p:V)+(q?c[z>>2]|0:h&255)|0;q=g;if((q|0)==(p|0)){f=u;break}f=c[e>>2]|0;do if(f){p=c[f+12>>2]|0;if((p|0)==(c[f+16>>2]|0))f=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else f=e9(a[p>>0]|0)|0;if(d8(f,-1)|0){c[e>>2]=0;h=1;break}else{h=(c[e>>2]|0)==0;break}}else h=1;while(0);if(m){f=c[m+12>>2]|0;if((f|0)==(c[m+16>>2]|0))f=nb[c[(c[m>>2]|0)+36>>2]&255](m)|0;else f=e9(a[f>>0]|0)|0;if(!(d8(f,-1)|0))if((t|0)==0^h){m=t;f=u;i=t}else{p=q;f=u;break}else{p=0;f=0;S=130}}else{p=t;f=u;S=130}if((S|0)==130){S=0;if(h){p=q;break}else{m=p;i=0}}p=c[e>>2]|0;h=c[p+12>>2]|0;if((h|0)==(c[p+16>>2]|0))p=nb[c[(c[p>>2]|0)+36>>2]&255](p)|0;else p=e9(a[h>>0]|0)|0;if((p&255)<<24>>24!=(a[q>>0]|0)){p=q;break}p=c[e>>2]|0;h=p+12|0;g=c[h>>2]|0;if((g|0)==(c[p+16>>2]|0))nb[c[(c[p>>2]|0)+40>>2]&255](p)|0;else c[h>>2]=g+1;t=m;u=f;g=q+1|0;h=a[y>>0]|0;p=c[V>>2]|0;m=i}if(x?(u=a[y>>0]|0,t=u<<24>>24<0,(p|0)!=((t?c[V>>2]|0:V)+(t?c[z>>2]|0:u&255)|0)):0){S=142;break a}else{h=R;p=v}break}case 4:{u=a[O>>0]|0;i=0;h=f;r=f;m=f;p=v;while(1){f=c[e>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else f=e9(a[g>>0]|0)|0;if(d8(f,-1)|0){c[e>>2]=0;g=1;break}else{g=(c[e>>2]|0)==0;break}}else g=1;while(0);s=(i|0)!=0;if(m){f=c[m+12>>2]|0;if((f|0)==(c[m+16>>2]|0))f=nb[c[(c[m>>2]|0)+36>>2]&255](m)|0;else f=e9(a[f>>0]|0)|0;if(!(d8(f,-1)|0))if((h|0)==0^g){q=h;f=r;t=h}else{q=h;f=r;break}else{h=0;f=0;S=155}}else{f=r;S=155}if((S|0)==155){S=0;if(g){q=h;break}else{q=h;t=0}}h=c[e>>2]|0;g=c[h+12>>2]|0;if((g|0)==(c[h+16>>2]|0))h=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else h=e9(a[g>>0]|0)|0;g=h&255;if(g<<24>>24>-1?(b[(c[F>>2]|0)+(h<<24>>24<<1)>>1]&2048)!=0:0){h=c[o>>2]|0;if((h|0)==(c[Q>>2]|0)){mA(n,o,Q);h=c[o>>2]|0}c[o>>2]=h+1;a[h>>0]=g;i=i+1|0}else{v=a[D>>0]|0;if(!(g<<24>>24==u<<24>>24&(s&((v<<24>>24<0?c[E>>2]|0:v&255)|0)!=0)))break;if((p|0)==(c[L>>2]|0)){Oz(_,K,L);p=c[K>>2]|0}v=p+4|0;c[K>>2]=v;c[p>>2]=i;i=0;p=v}h=c[e>>2]|0;g=h+12|0;m=c[g>>2]|0;if((m|0)==(c[h+16>>2]|0)){nb[c[(c[h>>2]|0)+40>>2]&255](h)|0;h=q;r=f;m=t;continue}else{c[g>>2]=m+1;h=q;r=f;m=t;continue}}if(s&(c[_>>2]|0)!=(p|0)){if((p|0)==(c[L>>2]|0)){Oz(_,K,L);p=c[K>>2]|0}v=p+4|0;c[K>>2]=v;c[p>>2]=i;p=v}i=c[P>>2]|0;if((i|0)>0){h=c[e>>2]|0;do if(h){g=c[h+12>>2]|0;if((g|0)==(c[h+16>>2]|0))h=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else h=e9(a[g>>0]|0)|0;if(d8(h,-1)|0){c[e>>2]=0;g=1;break}else{g=(c[e>>2]|0)==0;break}}else g=1;while(0);if(q){h=c[q+12>>2]|0;if((h|0)==(c[q+16>>2]|0))h=nb[c[(c[q>>2]|0)+36>>2]&255](q)|0;else h=e9(a[h>>0]|0)|0;if(!(d8(h,-1)|0)){if(!g){S=229;break a}}else{f=0;S=189}}else S=189;if((S|0)==189){S=0;if(g){S=229;break a}else q=0}h=c[e>>2]|0;g=c[h+12>>2]|0;if((g|0)==(c[h+16>>2]|0))h=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else h=e9(a[g>>0]|0)|0;if((h&255)<<24>>24!=(a[N>>0]|0)){S=229;break a}h=c[e>>2]|0;g=h+12|0;m=c[g>>2]|0;if((m|0)==(c[h+16>>2]|0)){nb[c[(c[h>>2]|0)+40>>2]&255](h)|0;r=q;m=q}else{c[g>>2]=m+1;r=q;m=q}while(1){if((i|0)<=0)break;h=c[e>>2]|0;do if(h){g=c[h+12>>2]|0;if((g|0)==(c[h+16>>2]|0))h=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else h=e9(a[g>>0]|0)|0;if(d8(h,-1)|0){c[e>>2]=0;g=1;break}else{g=(c[e>>2]|0)==0;break}}else g=1;while(0);if(m){h=c[m+12>>2]|0;if((h|0)==(c[m+16>>2]|0))h=nb[c[(c[m>>2]|0)+36>>2]&255](m)|0;else h=e9(a[h>>0]|0)|0;if(!(d8(h,-1)|0))if((r|0)==0^g){s=r;q=r}else{S=228;break a}else{h=0;f=0;S=211}}else{h=r;S=211}if((S|0)==211){S=0;if(g){S=228;break a}else{s=h;q=0}}h=c[e>>2]|0;g=c[h+12>>2]|0;if((g|0)==(c[h+16>>2]|0))h=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else h=e9(a[g>>0]|0)|0;if((h&255)<<24>>24<=-1){S=228;break a}if(!(b[(c[F>>2]|0)+(h<<24>>24<<1)>>1]&2048)){S=228;break a}if((c[o>>2]|0)==(c[Q>>2]|0))mA(n,o,Q);h=c[e>>2]|0;g=c[h+12>>2]|0;if((g|0)==(c[h+16>>2]|0))h=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else h=e9(a[g>>0]|0)|0;g=c[o>>2]|0;c[o>>2]=g+1;a[g>>0]=h;i=i+-1|0;h=c[e>>2]|0;g=h+12|0;m=c[g>>2]|0;if((m|0)==(c[h+16>>2]|0)){nb[c[(c[h>>2]|0)+40>>2]&255](h)|0;r=s;m=q;continue}else{c[g>>2]=m+1;r=s;m=q;continue}}c[P>>2]=i}if((c[o>>2]|0)==(c[n>>2]|0)){S=229;break a}else h=R;break}default:{h=R;p=v}}while(0);d:do if((S|0)==46)while(1){S=0;f=c[e>>2]|0;do if(f){h=c[f+12>>2]|0;if((h|0)==(c[f+16>>2]|0))f=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else f=e9(a[h>>0]|0)|0;if(d8(f,-1)|0){c[e>>2]=0;h=1;break}else{h=(c[e>>2]|0)==0;break}}else h=1;while(0);if(g){f=c[g+12>>2]|0;if((f|0)==(c[g+16>>2]|0))f=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else f=e9(a[f>>0]|0)|0;if(!(d8(f,-1)|0))if((p|0)==0^h){i=p;f=q;m=p}else{h=R;f=q;p=v;break d}else{p=0;f=0;S=58}}else{f=q;S=58}if((S|0)==58){S=0;if(h){h=R;p=v;break d}else{i=p;m=0}}p=c[e>>2]|0;h=c[p+12>>2]|0;if((h|0)==(c[p+16>>2]|0))p=nb[c[(c[p>>2]|0)+36>>2]&255](p)|0;else p=e9(a[h>>0]|0)|0;if((p&255)<<24>>24<=-1){h=R;p=v;break d}if(!(b[(c[F>>2]|0)+(p<<24>>24<<1)>>1]&8192)){h=R;p=v;break d}p=c[e>>2]|0;h=p+12|0;g=c[h>>2]|0;if((g|0)==(c[p+16>>2]|0))p=nb[c[(c[p>>2]|0)+40>>2]&255](p)|0;else{c[h>>2]=g+1;p=e9(a[g>>0]|0)|0}gy(Y,p&255);p=i;q=f;g=m;S=46}while(0);R=h;w=w+1|0;v=p}e:do if((S|0)==44){c[j>>2]=c[j>>2]|4;p=0}else if((S|0)==102){c[j>>2]=c[j>>2]|4;p=0}else if((S|0)==142){c[j>>2]=c[j>>2]|4;p=0}else if((S|0)==228){c[P>>2]=i;S=229}else if((S|0)==231){f:do if(g){i=R+11|0;q=R+4|0;g=1;h=f;while(1){f=a[i>>0]|0;if(f<<24>>24<0)f=c[q>>2]|0;else f=f&255;if(g>>>0>=f>>>0)break f;f=c[e>>2]|0;do if(f){p=c[f+12>>2]|0;if((p|0)==(c[f+16>>2]|0))f=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else f=e9(a[p>>0]|0)|0;if(d8(f,-1)|0){c[e>>2]=0;p=1;break}else{p=(c[e>>2]|0)==0;break}}else p=1;while(0);if(h){f=c[h+12>>2]|0;if((f|0)==(c[h+16>>2]|0))f=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else f=e9(a[f>>0]|0)|0;if(!(d8(f,-1)|0))if(p)m=h;else break;else S=249}else S=249;if((S|0)==249){S=0;if(p)break;else m=0}f=c[e>>2]|0;p=c[f+12>>2]|0;if((p|0)==(c[f+16>>2]|0))f=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else f=e9(a[p>>0]|0)|0;if((a[i>>0]|0)<0)p=c[R>>2]|0;else p=R;if((f&255)<<24>>24!=(a[p+g>>0]|0))break;f=g+1|0;p=c[e>>2]|0;h=p+12|0;g=c[h>>2]|0;if((g|0)==(c[p+16>>2]|0)){nb[c[(c[p>>2]|0)+40>>2]&255](p)|0;g=f;h=m;continue}else{c[h>>2]=g+1;g=f;h=m;continue}}c[j>>2]=c[j>>2]|4;p=0;break e}while(0);f=c[_>>2]|0;if((f|0)!=(v|0)){c[T>>2]=0;Vs(U,f,v,T);if(!(c[T>>2]|0)){p=1;break}else{c[j>>2]=c[j>>2]|4;p=0;break}}else p=1}while(0);if((S|0)==229){c[j>>2]=c[j>>2]|4;p=0}a1(Y);a1(X);a1(W);a1(V);a1(U);f=c[_>>2]|0;c[_>>2]=0;if(f|0)jb[c[Z>>2]&511](f);l=$;return p|0}function Wb(f){f=f|0;var g=0,i=0,j=0,k=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;K=l;l=l+96|0;E=K+48|0;F=K+36|0;G=K+24|0;r=K+12|0;q=K;H=f+1484|0;I=f+1402|0;if(a[H>>0]|0){Kc(f,2,-1)|0;g=b[f+1176>>1]|0;if(g<<16>>16)lL(f,2,0,118,((O(Z0(a[f+1405>>0]|0)|0,g&65535)|0)+8|0)>>>4,10,0);g=a[I>>0]|0;if(g<<24>>24==-70){RB(f,0,0,57,371539,-1,1,0);RB(f,2,0,18,371539,-1,1,0);RB(f,2,0,52,371539,-1,1,0);g=f+1488|0;if(a[g>>0]|0){RB(f,2,0,24,371546,-1,1,0);RB(f,2,0,59,371546,-1,1,0);RB(f,2,0,122,371568,-1,1,0);RB(f,2,0,128,371568,-1,1,0);RB(f,2,0,129,371568,-1,1,0)}RB(f,2,0,110,384435,-1,1,0);TX(E);Gk(E,Z0(a[f+1404>>0]|0)|0,10)|0;if(a[g>>0]|0)DW(E,0,41840)|0;zb(f,2,0,135,E,0);g=f+1178|0;mL(f,2,0,122,vW(b[g>>1]|0)|0,10,0);Cm(F,b[g>>1]|0);bw(f,2,0,128,F,1,0);a1(F);Yi(F,b[g>>1]|0);zb(f,2,0,129,F,0);z5(F);z5(E);g=a[I>>0]|0}if(g<<24>>24==-69){RB(f,0,0,57,371581,-1,1,0);if(!(a[f+1489>>0]|0)){RB(f,2,0,18,371581,-1,1,0);RB(f,2,0,52,371581,-1,1,0)}RB(f,2,0,110,384435,-1,1,0);g=f+1405|0;lL(f,2,0,135,Z0(a[g>>0]|0)|0,10,0);g=a[g>>0]|0;if((a[f+1404>>0]|0)!=g<<24>>24)lL(f,2,0,135,Z0(g)|0,10,0);g=f+1406|0;lL(f,2,0,122,c[13004+(d[g>>0]<<2)>>2]|0,10,0);g=d[g>>0]|0;if((g|0)!=(e[f+1178>>1]|0))lL(f,2,0,122,c[13004+(g<<2)>>2]|0,10,0);D=f+1408|0;lL(f,2,0,147,c[13132+(d[D>>0]<<2)>>2]|0,10,0);g=a[f+1407>>0]|0;if(g<<24>>24!=(a[D>>0]|0))lL(f,2,0,147,c[13132+((g&255)<<2)>>2]|0,10,0)}}D=f+1184|0;do if((c[f+804>>2]|0)==1){i=c[f+796>>2]|0;g=c[i+20>>2]|0;B=f+760|0;B=XZ(c[B>>2]|0,c[B+4>>2]|0,1)|0;A=z;if(0<A>>>0|0==(A|0)&g>>>0<B>>>0?(B=f+312|0,B=XZ(c[B>>2]|0,c[B+4>>2]|0,1)|0,A=z,0<A>>>0|0==(A|0)&g>>>0<B>>>0):0)break;j=f+792|0;a[j>>0]=a[i+16>>0]|0;RB(f,2,0,24,(d[D>>0]|0)<10?371585:371596,-1,1,0);RB(f,2,0,59,(d[D>>0]|0)<10?371585:371596,-1,1,0);uU(G,a[j>>0]|0,10);HX(G,13196)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];g=0;while(1){if((g|0)==3)break;c[G+(g<<2)>>2]=0;g=g+1|0}p2(E,F);zb(f,2,0,122,E,0);z5(E);O0(F);z5(G);uU(G,a[j>>0]|0,10);HX(G,13196)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];g=0;while(1){if((g|0)==3)break;c[G+(g<<2)>>2]=0;g=g+1|0}p2(E,F);zb(f,2,0,128,E,0);z5(E);O0(F);z5(G);uU(G,a[j>>0]|0,10);HX(G,13196)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];g=0;while(1){if((g|0)==3)break;c[G+(g<<2)>>2]=0;g=g+1|0}p2(E,F);zb(f,2,0,129,E,0);z5(E);O0(F);z5(G)}while(0);g=a[D>>0]|0;A=f+1185|0;B=f+1411|0;a:do if((g&255)>=10){if((g&255)<17){p=f+1266|0;q=f+1401|0;r=f+1180|0;s=f+1181|0;t=f+1257|0;u=E+8+3|0;v=E+4|0;w=E+8+3|0;x=E+4|0;n=0;while(1){if(n>>>0>=8)break a;o=f+1257+(n*9|0)|0;y=n+1|0;if((a[o>>0]|0)==-1){n=y;continue}Kc(f,2,-1)|0;RB(f,2,0,18,391365,-1,1,0);RB(f,2,0,52,391469,-1,1,0);if((a[p>>0]|0)!=-1)lL(f,2,0,10,y,10,0);RB(f,2,0,110,384431,-1,1,0);i=a[q>>0]|0;j=i&255;g=0;m=0;while(1){if((g|0)==8)break;L=(e[f+1032+(n*18|0)+(g<<1)>>1]|0)+m|0;g=g+1|0;m=L}g=i<<24>>24==3?6:j+1|0;if((g&255)<<24>>24?(C=750/((g&255)>>>0)|0,lL(f,2,0,112,(O(m<<4,C)|0)>>>2,10,0),b[f+1032+(n*18|0)+2>>1]|0):0)sM(f,2,0,112,(O(C<<4,e[f+1032+(n*18|0)>>1]|0)|0)>>>2,0);g=a[r>>0]|0;if(g<<24>>24==3)lL(f,2,0,135,c[12804+(d[s>>0]<<2)>>2]|0,10,0);else lL(f,2,0,135,c[12456+((g&255)<<2)>>2]|0,10,0);if((a[f+1257+(n*9|0)+1>>0]|0)!=-1){g=0;j=0;while(1){if((j|0)==9)break;L=a[f+1257+(n*9|0)+j>>0]|0;i=L&255;do if(L<<24>>24!=-1)if(!(a[f+1492+(n*9|0)+j>>0]|0)){g=b[59746+(i<<1)>>1]|g|d[f+1411+(n*9|0)+j>>0];break}else{g=b[f+888+(n*18|0)+(j<<1)>>1]|g;break}while(0);j=j+1|0}RB(f,2,0,24,371623,-1,1,0);RB(f,2,0,59,371623,-1,1,0);mL(f,2,0,122,vK(g)|0,10,0);Lf(E,g);zb(f,2,0,128,E,0);z5(E);TX(E);cC(E,c[(a[B>>0]|0?12648:12616)+(d[t>>0]<<2)>>2]|0)|0;eA(F,g,E);zb(f,2,0,132,F,0);z5(F);z5(E)}$x(E,f,2,0,24,1);L=a[u>>0]|0;L=((L<<24>>24<0?c[v>>2]|0:L&255)|0)==0;z5(E);if(!L)RB(f,2,0,24,391365,-1,1,0);$x(E,f,2,0,59,1);L=a[w>>0]|0;L=((L<<24>>24<0?c[x>>2]|0:L&255)|0)==0;z5(E);if(!L)RB(f,2,0,59,391365,-1,1,0);RB(f,2,0,262,c[12472+(d[A>>0]<<2)>>2]|0,-1,1,0);RB(f,2,0,263,c[12504+(d[A>>0]<<2)>>2]|0,-1,1,0);g=a[o>>0]|0;if(g<<24>>24==-1){n=y;continue}g=a[371002+(g&255)>>0]|0;TX(E);cC(E,c[12552+(d[o>>0]<<2)>>2]|0)|0;if(a[f+1411+(n*9|0)>>0]|0){HX(E,14344)|0;g=(g&255)+1&255}mL(f,2,0,122,g,10,0);zb(f,2,0,128,E,0);RB(f,2,0,132,c[(a[B>>0]|0?12648:12616)+(d[t>>0]<<2)>>2]|0,-1,1,0);z5(E);n=y}}}else{if(!(RA(f,2,-1)|0))Kc(f,2,-1)|0;RB(f,0,0,57,391372,-1,1,0);RB(f,2,0,18,391372,-1,1,0);RB(f,2,0,52,391474,-1,1,0);sM(f,2,0,147,16,0);i=f+1180|0;g=(a[D>>0]|0)==9&1;sU(E,(c[12456+(d[i>>0]<<2)>>2]|0)>>>g,10);$x(F,f,2,0,135,1);m=a[E+8+3>>0]|0;j=m<<24>>24<0;m=j?c[E+4>>2]|0:m&255;L=a[F+8+3>>0]|0;n=L<<24>>24<0;if((m|0)==((n?c[F+4>>2]|0:L&255)|0)){L=(L$(j?c[E>>2]|0:E,n?c[F>>2]|0:F,m)|0)==0;z5(F);z5(E);if(!L)J=38}else{z5(F);z5(E);J=38}if((J|0)==38)lL(f,2,0,135,(c[12456+(d[i>>0]<<2)>>2]|0)>>>g,10,0);i=f+1182|0;g=a[i>>0]|0;if((g&255)<38){L=f+880|0;if(!((c[L>>2]|0)==0&(c[L+4>>2]|0)==0)){RB(f,2,0,112,390991,-1,1,0);g=a[i>>0]|0}g=(e[59708+(((g&255)>>>1&255)<<1)>>1]|0)*1e3|0;lL(f,2,0,112,g>>>((a[D>>0]|0)==9&1),10,0);if(a[f+770>>0]|0?(p=f+560|0,o=c[p>>2]|0,p=c[p+4>>2]|0,p>>>0>0|(p|0)==0&o>>>0>100):0){Bt(f,2,0,156,(+(o>>>0)+4294967296.0*+(p>>>0))*8.0*1.0e3/+(g>>>0),0,0);RB(f,2,0,165,388261,-1,1,0)}}RB(f,2,0,262,c[12472+(d[A>>0]<<2)>>2]|0,-1,1,0);RB(f,2,0,263,c[12504+(d[A>>0]<<2)>>2]|0,-1,1,0);i=f+1257|0;g=a[i>>0]|0;if(g<<24>>24!=-1){g=a[371002+(g&255)>>0]|0;TX(E);cC(E,c[12552+(d[i>>0]<<2)>>2]|0)|0;TX(F);cC(F,c[12584+(d[i>>0]<<2)>>2]|0)|0;TX(G);cC(G,c[(a[B>>0]|0?12648:12616)+(d[i>>0]<<2)>>2]|0)|0;if(a[B>>0]|0){HX(E,14344)|0;HX(F,16388)|0;g=(g&255)+1&255}uU(r,g,10);$x(q,f,2,0,122,1);j=a[r+8+3>>0]|0;i=j<<24>>24<0;j=i?c[r+4>>2]|0:j&255;L=a[q+8+3>>0]|0;m=L<<24>>24<0;if((j|0)==((m?c[q+4>>2]|0:L&255)|0)){L=(L$(i?c[r>>2]|0:r,m?c[q>>2]|0:q,j)|0)==0;z5(q);z5(r);if(!L)J=51}else{z5(q);z5(r);J=51}if((J|0)==51)mL(f,2,0,122,g,10,0);$x(r,f,2,0,128,1);i=a[E+8+3>>0]|0;g=i<<24>>24<0;i=g?c[E+4>>2]|0:i&255;L=a[r+8+3>>0]|0;j=L<<24>>24<0;if((i|0)==((j?c[r+4>>2]|0:L&255)|0)){L=(L$(g?c[E>>2]|0:E,j?c[r>>2]|0:r,i)|0)==0;z5(r);if(!L)J=55}else{z5(r);J=55}if((J|0)==55)zb(f,2,0,128,E,0);$x(r,f,2,0,129,1);i=a[F+8+3>>0]|0;g=i<<24>>24<0;i=g?c[F+4>>2]|0:i&255;L=a[r+8+3>>0]|0;j=L<<24>>24<0;if((i|0)==((j?c[r+4>>2]|0:L&255)|0)){L=(L$(g?c[F>>2]|0:F,j?c[r>>2]|0:r,i)|0)==0;z5(r);if(!L)J=59}else{z5(r);J=59}if((J|0)==59)zb(f,2,0,129,F,0);$x(r,f,2,0,132,1);i=a[G+8+3>>0]|0;g=i<<24>>24<0;i=g?c[G+4>>2]|0:i&255;L=a[r+8+3>>0]|0;j=L<<24>>24<0;if((i|0)==((j?c[r+4>>2]|0:L&255)|0)){L=(L$(g?c[G>>2]|0:G,j?c[r>>2]|0:r,i)|0)==0;z5(r);if(!L)J=63}else{z5(r);J=63}if((J|0)==63)zb(f,2,0,132,G,0);z5(G);z5(F);z5(E)}if((a[f+1329>>0]|0)==2)RB(f,2,0,32,371609,-1,1,0);$x(E,f,2,0,24,1);L=a[E+8+3>>0]|0;L=((L<<24>>24<0?c[E+4>>2]|0:L&255)|0)==0;z5(E);if(!L)RB(f,2,0,24,391372,-1,1,0);$x(E,f,2,0,59,1);L=a[E+8+3>>0]|0;L=((L<<24>>24<0?c[E+4>>2]|0:L&255)|0)==0;z5(E);if(!L)RB(f,2,0,59,391372,-1,1,0);$x(E,f,2,0,110,1);g=i9(40152)|0;L=a[E+8+3>>0]|0;if((g|0)==((L<<24>>24<0?c[E+4>>2]|0:L&255)|0)){L=(VG(E,40152,g)|0)==0;z5(E);if(L)break}else z5(E);RB(f,2,0,110,384431,-1,1,0)}while(0);if(a[H>>0]|0){mI(E);Xy(F,41840);z3(E,F);z5(F);$x(F,f,2,0,112,1);og(E,F);z5(F);g=c[E>>2]|0;if((((c[E+4>>2]|0)-g|0)/12|0)>>>0>1)zb(f,2,0,118,g+12|0,0);$_(E)}b:do if(a[f+1489>>0]|0){RB(f,2,0,37,a[f+1569>>0]|0?372224:379711,-1,1,0);MN(f,2,371634,a[D>>0]|0);g=f+809|0;L=a[g>>0]|0;$M(f,2,0,371639,L<<24>>24==0?-31:0-(L&255)|0);Ou(f,2,0,371639,382945);g=a[g>>0]|0;tU(G,g<<24>>24==0?-31:0-(g&255)|0,10);HX(G,12988)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];g=0;while(1){if((g|0)==3)break;c[G+(g<<2)>>2]=0;g=g+1|0}p2(E,F);Mc(f,2,0,371648,E,0);z5(E);O0(F);z5(G);Ou(f,2,0,371648,382945);if(a[f+812>>0]|0){g=d[f+810>>0]|0;k=+h[160+(g>>>4<<3)>>3];k=k+ +us(+(g&15|16|0)*.03125)*20.0;sN(f,2,0,371664,k,2,0);Ou(f,2,0,371664,382945);ST(G,k,2);HX(G,12988)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];g=0;while(1){if((g|0)==3)break;c[G+(g<<2)>>2]=0;g=g+1|0}p2(E,F);Mc(f,2,0,371670,E,0);z5(E);O0(F);z5(G);Ou(f,2,0,371670,382945)}if(!(a[f+813>>0]|0))i=0;else{L=a[f+811>>0]|0;g=L&255;if(!(L<<24>>24))k=0.0;else{k=+h[288+(g>>>5<<3)>>3];k=k+ +us(+(g&31|32|0)*.015625)*20.0}sN(f,2,0,371683,k,2,0);Ou(f,2,0,371683,382945);ST(G,k,2);HX(G,12988)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];g=0;while(1){if((g|0)==3)break;c[G+(g<<2)>>2]=0;g=g+1|0}p2(E,F);Mc(f,2,0,371690,E,0);z5(E);O0(F);z5(G);Ou(f,2,0,371690,382945);i=0}while(1){if((i|0)==8)break b;else j=0;c:while(1){if(j>>>0>=9)break;g=f+1257+(i*9|0)+j|0;switch(a[g>>0]|0){case -1:break c;case 2:{L=f+1329+(i*9|0)+j|0;MN(f,2,371704,a[L>>0]|0);Ou(f,2,0,371704,382945);xM(f,2,0,371712,c[12536+(d[L>>0]<<2)>>2]|0,0);Ou(f,2,0,371712,382945);break}default:{}}Ou(f,2,0,371634,382945);MN(f,2,371727,a[g>>0]|0);Ou(f,2,0,371727,382945);$M(f,2,0,371733,d[f+1411+(i*9|0)+j>>0]|0);Ou(f,2,0,371733,382945);j=j+1|0}i=i+1|0}}while(0);if(a[f+1564>>0]|0?(KW(f,2,0,156,+h[f+1576>>3]*1.0e3,0,0),RB(f,2,0,165,388261,-1,1,0),a[f+1567>>0]|0):0)RB(f,2,0,163,a[f+1568>>0]|0?371739:371757,-1,1,0);g=a[D>>0]|0;if((g&255)>=9)if(g<<24>>24!=9)if((g+-11&255)>=6){if(a[H>>0]|0?(a[I>>0]&-2)<<24>>24==-70:0){g=40;J=140}}else{g=256;J=140}else{g=768;J=140}else{g=1536;J=140}if((J|0)==140)kL(f,2,0,134,g,10,0);l=K;return}function Xb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;u=l;l=l+48|0;q=u+36|0;r=u+24|0;s=u+12|0;t=u;j=b+536|0;d=j;e=c[d>>2]|0;d=c[d+4>>2]|0;do if(d>>>0>0|(d|0)==0&e>>>0>3){aH(b,q);d=c[q>>2]|0;a:do if((d|0)>=1146373937)if((d|0)<1195456820){switch(d|0){case 1146373937:break;default:break a}ON(b);i=9;break}else{switch(d|0){case 1195456820:break;default:break a}$z(b);i=9;break}else{switch(d|0){case 1128464888:break;default:break a}ON(b);i=9}while(0);if((i|0)==9)break;EG(b,r);if((a[r>>0]|0)==3){PN(b);break}else{e=j;d=c[e+4>>2]|0;e=c[e>>2]|0;i=8;break}}else i=8;while(0);do if((i|0)==8){m=b+544|0;n=b+612|0;h=0;b:while(1){g=h+4|0;if(0>d>>>0|0==(d|0)&g>>>0>e>>>0){i=15;break}else f=0;while(1){if(f>>>0>=4)break b;k=a[(c[m>>2]|0)+(f+h+(c[n>>2]|0))>>0]|0;v=(f|0)!=0;if((k+-65&255)<61|((k&-16)<<24>>24==48|(v&k<<24>>24==41|((k+-39&255)<2|(k<<24>>24==34|v&k<<24>>24==32)))))f=f+1|0;else break}h=h+1|0}if((i|0)==15){e1(b,e,d);break}c:while(1){if(!(0<d>>>0|0==(d|0)&g>>>0<e>>>0))break;f=a[(c[m>>2]|0)+((c[n>>2]|0)+g)>>0]|0;switch(f<<24>>24){case 10:case 13:break;default:if(!((f&-32)<<24>>24==32|(f+-65&255)<61))break c}g=g+1|0}TX(q);if(h|0)e1(b,h,0);d=g-h|0;if(d|0)jZ(b,d,0,q);h=b+528|0;e=h;d=c[e>>2]|0;e=c[e+4>>2]|0;g=j;f=c[g>>2]|0;g=c[g+4>>2]|0;if(g>>>0>e>>>0|(g|0)==(e|0)&f>>>0>d>>>0){v=D_(f|0,g|0,d|0,e|0)|0;e1(b,v,z)}i=q+8+3|0;k=q+4|0;while(1){f=a[i>>0]|0;d=f<<24>>24<0;e=c[k>>2]|0;if((d?e:f&255)>>>0<=3)break;d=d?c[q>>2]|0:q;if((c[d+4>>2]|0)!=101)break;if((c[d+8>>2]|0)!=110)break;if((c[d+12>>2]|0)!=99)break;ny(q,0,1)|0}while(1){d=f<<24>>24<0;if((d?e:f&255)>>>0<=5)break;d=d?c[q>>2]|0:q;if((c[d+12>>2]|0)!=77)break;if((c[d+16>>2]|0)!=80)break;if((c[d+20>>2]|0)!=69)break;ny(q,0,1)|0;f=a[i>>0]|0;e=c[k>>2]|0}while(1){d=f<<24>>24<0;if(!((d?e:f&255)|0))break;if((c[(d?c[q>>2]|0:q)>>2]|0)!=48)break;ny(q,0,1)|0;f=a[i>>0]|0;e=c[k>>2]|0}g=h;e=j;d=c[e>>2]|0;e=c[e+4>>2]|0;f=c[g+4>>2]|0;g=c[g>>2]|0;while(1){if(!(f>>>0<e>>>0|(f|0)==(e|0)&g>>>0<d>>>0))break;if(a[(c[m>>2]|0)+((c[n>>2]|0)+g)>>0]|0)break;v=z0(g|0,f|0,1,0)|0;j=z;w=h;c[w>>2]=v;c[w+4>>2]=j;f=j;g=v}d:do if((g|0)==(d|0)&(f|0)==(e|0)){if(qO(b)|0?(p=a[i>>0]|0,o=p<<24>>24<0,p=o?c[k>>2]|0:p&255,p|0):0){d=o?c[q>>2]|0:q;e=i9(36120)|0;m=b+820|0;if((e|0)!=0?(v=d+(p<<2)|0,w=HA(d,v,36120,36120+(e<<2)|0)|0,!((w|0)!=(v|0)&(w|0)==(d|0))):0)k1(m,q)|0;else{Xy(s,42252);d=a[i>>0]|0;w=d<<24>>24<0;Ex(s,w?c[q>>2]|0:q,w?c[k>>2]|0:d&255)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];d=0;while(1){if((d|0)==3)break;c[s+(d<<2)>>2]=0;d=d+1|0}w=a[r+8+3>>0]|0;v=w<<24>>24<0;Ex(m,v?c[r>>2]|0:r,v?c[r+4>>2]|0:w&255)|0;O0(r);z5(s)}d=a[i>>0]|0;e=d<<24>>24<0;f=e?c[q>>2]|0:q;g=i9(36144)|0;j=b+832|0;if(g|0?(v=f+((e?c[k>>2]|0:d&255)<<2)|0,w=HA(f,v,36144,36144+(g<<2)|0)|0,!((w|0)!=(v|0)&(w|0)==(f|0))):0){h=a[b+828+3>>0]|0;g=h<<24>>24<0;i=b+824|0;if(g){e=c[m>>2]|0;f=c[i>>2]|0}else{e=m;f=h&255}d=i9(36260)|0;k=b+844|0;if(d|0?(v=e+(f<<2)|0,w=HA(e,v,36260,36260+(d<<2)|0)|0,!((w|0)!=(v|0)&(w|0)==(e|0))):0){if(g){e=c[m>>2]|0;f=c[i>>2]|0}else{e=m;f=h&255}d=i9(36396)|0;do if(d|0){v=e+(f<<2)|0;w=HA(e,v,36396,36396+(d<<2)|0)|0;if((w|0)!=(v|0)&(w|0)==(e|0))break;if(g){e=c[m>>2]|0;f=c[i>>2]|0}else{e=m;f=h&255}d=i9(36532)|0;do if(d|0){v=e+(f<<2)|0;w=HA(e,v,36532,36532+(d<<2)|0)|0;if((w|0)!=(v|0)&(w|0)==(e|0))break;if(g){e=c[m>>2]|0;f=c[i>>2]|0}else{e=m;f=h&255}d=i9(36752)|0;do if(d|0){v=e+(f<<2)|0;w=HA(e,v,36752,36752+(d<<2)|0)|0;if((w|0)!=(v|0)&(w|0)==(e|0))break;if(g){e=c[m>>2]|0;f=c[i>>2]|0}else{e=m;f=h&255}d=i9(37e3)|0;do if(d|0){v=e+(f<<2)|0;w=HA(e,v,37e3,37e3+(d<<2)|0)|0;if((w|0)!=(v|0)&(w|0)==(e|0))break;if(g){f=c[m>>2]|0;e=c[i>>2]|0}else{f=m;e=h&255}d=i9(37080)|0;do if(d|0){v=f+(e<<2)|0;w=HA(f,v,37080,37080+(d<<2)|0)|0;if((w|0)!=(v|0)&(w|0)==(f|0))break;k1(j,m)|0;break d}while(0);Xy(r,37140);vF(j,r)|0;z5(r);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=i9(37080)|0;if(f>>>0>1073741807)uaa();d=s+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[s>>2]=w;c[d>>2]=e|-2147483648;c[s+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=s}while(0);a3(d,37080,f);y7(d+(f<<2)|0,0);c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;f=i9(37272)|0;if(f>>>0>1073741807)uaa();d=t+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[t>>2]=w;c[d>>2]=e|-2147483648;c[t+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=t}while(0);a3(d,37272,f);y7(d+(f<<2)|0,0);Ok(r,m,s,t,0,0);vF(k,r)|0;z5(r);O0(t);O0(s);break d}while(0);Xy(r,36500);vF(j,r)|0;z5(r);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=i9(37e3)|0;if(f>>>0>1073741807)uaa();d=s+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[s>>2]=w;c[d>>2]=e|-2147483648;c[s+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=s}while(0);a3(d,37e3,f);y7(d+(f<<2)|0,0);c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;f=i9(409096)|0;if(f>>>0>1073741807)uaa();d=t+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[t>>2]=w;c[d>>2]=e|-2147483648;c[t+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=t}while(0);a3(d,409096,f);y7(d+(f<<2)|0,0);Ok(r,m,s,t,0,0);vF(k,r)|0;z5(r);O0(t);O0(s);break d}while(0);Xy(r,36880);vF(j,r)|0;z5(r);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=i9(36960)|0;if(f>>>0>1073741807)uaa();d=s+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[s>>2]=w;c[d>>2]=e|-2147483648;c[s+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=s}while(0);a3(d,36960,f);y7(d+(f<<2)|0,0);c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;f=i9(409096)|0;if(f>>>0>1073741807)uaa();d=t+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[t>>2]=w;c[d>>2]=e|-2147483648;c[t+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=t}while(0);a3(d,409096,f);y7(d+(f<<2)|0,0);Ok(r,m,s,t,0,0);vF(k,r)|0;z5(r);O0(t);O0(s);break d}while(0);Xy(r,36692);vF(j,r)|0;z5(r);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=i9(36532)|0;if(f>>>0>1073741807)uaa();d=s+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[s>>2]=w;c[d>>2]=e|-2147483648;c[s+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=s}while(0);a3(d,36532,f);y7(d+(f<<2)|0,0);c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;f=i9(409096)|0;if(f>>>0>1073741807)uaa();d=t+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[t>>2]=w;c[d>>2]=e|-2147483648;c[t+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=t}while(0);a3(d,409096,f);y7(d+(f<<2)|0,0);Ok(r,m,s,t,0,0);vF(k,r)|0;z5(r);O0(t);O0(s);break d}while(0);Xy(r,36500);vF(j,r)|0;z5(r);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=i9(36396)|0;if(f>>>0>1073741807)uaa();d=s+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[s>>2]=w;c[d>>2]=e|-2147483648;c[s+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=s}while(0);a3(d,36396,f);y7(d+(f<<2)|0,0);c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;f=i9(39944)|0;if(f>>>0>1073741807)uaa();d=t+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[t>>2]=w;c[d>>2]=e|-2147483648;c[t+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=t}while(0);a3(d,39944,f);y7(d+(f<<2)|0,0);Ok(r,m,s,t,0,0);vF(k,r)|0;z5(r);O0(t);O0(s);break}Xy(r,36360);vF(j,r)|0;z5(r);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=i9(36260)|0;if(f>>>0>1073741807)uaa();d=s+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[s>>2]=w;c[d>>2]=e|-2147483648;c[s+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=s}while(0);a3(d,36260,f);y7(d+(f<<2)|0,0);c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;f=i9(409096)|0;if(f>>>0>1073741807)uaa();d=t+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[t>>2]=w;c[d>>2]=e|-2147483648;c[t+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=t}while(0);a3(d,409096,f);y7(d+(f<<2)|0,0);Ok(r,m,s,t,0,0);vF(k,r)|0;z5(r);O0(t);O0(s);break}Xy(r,36216);vF(j,r)|0;z5(r)}}else t4(b);while(0);z5(q)}while(0);l=u;return}function Yb(b,e,f,g,h,i,j,k,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;_=l;l=l+512|0;O=_+496|0;p=_+96|0;Z=_+88|0;J=_+80|0;K=_+76|0;L=_+500|0;M=_+72|0;N=_+68|0;T=_+56|0;U=_+44|0;V=_+32|0;W=_+20|0;X=_+8|0;P=_+4|0;S=_;c[O>>2]=o;c[Z>>2]=p;Y=Z+4|0;c[Y>>2]=375;c[J>>2]=p;c[K>>2]=p+400;c[T>>2]=0;c[T+4>>2]=0;c[T+8>>2]=0;o=0;while(1){if((o|0)==3)break;c[T+(o<<2)>>2]=0;o=o+1|0}c[U>>2]=0;c[U+4>>2]=0;c[U+8>>2]=0;o=0;while(1){if((o|0)==3)break;c[U+(o<<2)>>2]=0;o=o+1|0}c[V>>2]=0;c[V+4>>2]=0;c[V+8>>2]=0;o=0;while(1){if((o|0)==3)break;c[V+(o<<2)>>2]=0;o=o+1|0}c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;o=0;while(1){if((o|0)==3)break;c[W+(o<<2)>>2]=0;o=o+1|0}c[X>>2]=0;c[X+4>>2]=0;c[X+8>>2]=0;o=0;while(1){if((o|0)==3)break;c[X+(o<<2)>>2]=0;o=o+1|0}ve(f,g,L,M,N,T,U,V,W,P);c[n>>2]=c[m>>2];F=V+8+3|0;G=V+4|0;H=W+8+3|0;I=W+4|0;x=(h&512|0)!=0;y=U+8+3|0;z=U+4|0;A=X+8+3|0;B=X+4|0;C=L+3|0;D=T+11|0;E=T+4|0;Q=0;w=0;o=c[P>>2]|0;v=p;a:while(1){h=(Q|0)!=0;if(w>>>0>=4){R=222;break}g=c[b>>2]|0;do if(g){f=c[g+12>>2]|0;if((f|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=raa(c[f>>2]|0)|0;if(d8(g,-1)|0){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);if(e){g=c[e+12>>2]|0;if((g|0)==(c[e+16>>2]|0))g=nb[c[(c[e>>2]|0)+36>>2]&255](e)|0;else g=raa(c[g>>2]|0)|0;if(!(d8(g,-1)|0)){if(!f){R=222;break}}else R=30}else R=30;if((R|0)==30){R=0;if(f){e=0;R=222;break}else e=0}g=(w|0)!=3;b:do switch(a[L+w>>0]|0){case 1:{if(g){g=c[b>>2]|0;f=c[g+12>>2]|0;if((f|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=raa(c[f>>2]|0)|0;if(!(gb[c[(c[k>>2]|0)+12>>2]&31](k,8192,g)|0)){R=42;break a}g=c[b>>2]|0;f=g+12|0;h=c[f>>2]|0;if((h|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+40>>2]&255](g)|0;else{c[f>>2]=h+4;g=raa(c[h>>2]|0)|0}Gx(X,g);g=e;r=e;h=e;R=44}else{f=Q;g=v}break}case 0:{if(g){g=e;r=e;h=e;R=44}else{f=Q;g=v}break}case 3:{g=a[F>>0]|0;f=g<<24>>24<0?c[G>>2]|0:g&255;p=a[H>>0]|0;p=p<<24>>24<0?c[I>>2]|0:p&255;if((f|0)==(0-p|0)){f=Q;g=v}else{q=(f|0)==0;r=c[b>>2]|0;s=c[r+12>>2]|0;f=c[r+16>>2]|0;h=(s|0)==(f|0);if(q|(p|0)==0){if(h)f=nb[c[(c[r>>2]|0)+36>>2]&255](r)|0;else f=raa(c[s>>2]|0)|0;if(q){g=a[H>>0]|0;if((f|0)!=(c[(g<<24>>24<0?c[W>>2]|0:W)>>2]|0)){f=Q;g=v;break b}f=c[b>>2]|0;h=f+12|0;p=c[h>>2]|0;if((p|0)==(c[f+16>>2]|0)){nb[c[(c[f>>2]|0)+40>>2]&255](f)|0;g=a[H>>0]|0}else c[h>>2]=p+4;a[j>>0]=1;f=(g<<24>>24<0?c[I>>2]|0:g&255)>>>0>1?W:Q;g=v;break b}g=a[F>>0]|0;if((f|0)!=(c[(g<<24>>24<0?c[V>>2]|0:V)>>2]|0)){a[j>>0]=1;f=Q;g=v;break b}f=c[b>>2]|0;h=f+12|0;p=c[h>>2]|0;if((p|0)==(c[f+16>>2]|0)){nb[c[(c[f>>2]|0)+40>>2]&255](f)|0;g=a[F>>0]|0}else c[h>>2]=p+4;f=(g<<24>>24<0?c[G>>2]|0:g&255)>>>0>1?V:Q;g=v;break b}if(h){q=nb[c[(c[r>>2]|0)+36>>2]&255](r)|0;f=c[b>>2]|0;g=a[F>>0]|0;r=f;p=c[f+12>>2]|0;f=c[f+16>>2]|0}else{q=raa(c[s>>2]|0)|0;p=s}h=r+12|0;f=(p|0)==(f|0);if((q|0)==(c[(g<<24>>24<0?c[V>>2]|0:V)>>2]|0)){if(f){nb[c[(c[r>>2]|0)+40>>2]&255](r)|0;g=a[F>>0]|0}else c[h>>2]=p+4;f=(g<<24>>24<0?c[G>>2]|0:g&255)>>>0>1?V:Q;g=v;break b}if(f)f=nb[c[(c[r>>2]|0)+36>>2]&255](r)|0;else f=raa(c[p>>2]|0)|0;g=a[H>>0]|0;if((f|0)!=(c[(g<<24>>24<0?c[W>>2]|0:W)>>2]|0)){R=99;break a}f=c[b>>2]|0;h=f+12|0;p=c[h>>2]|0;if((p|0)==(c[f+16>>2]|0)){nb[c[(c[f>>2]|0)+40>>2]&255](f)|0;g=a[H>>0]|0}else c[h>>2]=p+4;a[j>>0]=1;f=(g<<24>>24<0?c[I>>2]|0:g&255)>>>0>1?W:Q;g=v}break}case 2:{if(!(w>>>0<2|h)?!(x|(w|0)==2&(a[C>>0]|0)!=0):0){f=0;g=v;break b}g=a[y>>0]|0;h=c[U>>2]|0;f=g<<24>>24<0?h:U;c:do if((w|0)!=0?(d[L+(w+-1)>>0]|0)<2:0){while(1){u=g<<24>>24<0;p=f;if((p|0)==((u?h:U)+((u?c[z>>2]|0:g&255)<<2)|0))break;u=gb[c[(c[k>>2]|0)+12>>2]&31](k,8192,c[p>>2]|0)|0;h=c[U>>2]|0;g=a[y>>0]|0;if(!u)break;f=p+4|0}q=g<<24>>24<0?h:U;t=q;s=f-t>>2;r=a[A>>0]|0;p=r<<24>>24<0;r=p?c[B>>2]|0:r&255;if(s>>>0>r>>>0){s=e;u=e;f=t;p=e}else{r=(p?c[X>>2]|0:X)+(r<<2)|0;p=r+(0-s<<2)|0;while(1){if((p|0)==(r|0)){s=e;u=e;p=e;break c}if((c[p>>2]|0)!=(c[q>>2]|0)){s=e;u=e;f=t;p=e;break c}q=q+4|0;p=p+4|0}}}else{s=e;u=e;p=e}while(0);while(1){t=g<<24>>24<0;g=(t?h:U)+((t?c[z>>2]|0:g&255)<<2)|0;if((f|0)==(g|0)){e=u;break}e=c[b>>2]|0;do if(e){g=c[e+12>>2]|0;if((g|0)==(c[e+16>>2]|0))e=nb[c[(c[e>>2]|0)+36>>2]&255](e)|0;else e=raa(c[g>>2]|0)|0;if(d8(e,-1)|0){c[b>>2]=0;h=1;break}else{h=(c[b>>2]|0)==0;break}}else h=1;while(0);if(p){e=c[p+12>>2]|0;if((e|0)==(c[p+16>>2]|0))e=nb[c[(c[p>>2]|0)+36>>2]&255](p)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0))if((s|0)==0^h){q=s;e=u;r=s}else{g=f;e=u;break}else{g=0;e=0;R=125}}else{g=s;e=u;R=125}if((R|0)==125){R=0;if(h){g=f;break}else{q=g;r=0}}g=c[b>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=raa(c[h>>2]|0)|0;if((g|0)!=(c[f>>2]|0)){g=f;break}g=c[b>>2]|0;h=g+12|0;p=c[h>>2]|0;if((p|0)==(c[g+16>>2]|0))nb[c[(c[g>>2]|0)+40>>2]&255](g)|0;else c[h>>2]=p+4;s=q;u=e;f=f+4|0;g=a[y>>0]|0;h=c[U>>2]|0;p=r}if(x?(u=a[y>>0]|0,t=u<<24>>24<0,(g|0)!=((t?c[U>>2]|0:U)+((t?c[z>>2]|0:u&255)<<2)|0)):0){R=137;break a}else{f=Q;g=v}break}case 4:{q=0;f=e;r=e;p=e;g=v;while(1){e=c[b>>2]|0;do if(e){h=c[e+12>>2]|0;if((h|0)==(c[e+16>>2]|0))e=nb[c[(c[e>>2]|0)+36>>2]&255](e)|0;else e=raa(c[h>>2]|0)|0;if(d8(e,-1)|0){c[b>>2]=0;h=1;break}else{h=(c[b>>2]|0)==0;break}}else h=1;while(0);s=(q|0)!=0;if(p){e=c[p+12>>2]|0;if((e|0)==(c[p+16>>2]|0))e=nb[c[(c[p>>2]|0)+36>>2]&255](p)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0))if((f|0)==0^h){u=f;e=r;t=f}else{p=f;e=r;break}else{f=0;e=0;R=150}}else{e=r;R=150}if((R|0)==150){R=0;if(h){p=f;break}else{u=f;t=0}}f=c[b>>2]|0;h=c[f+12>>2]|0;if((h|0)==(c[f+16>>2]|0))h=nb[c[(c[f>>2]|0)+36>>2]&255](f)|0;else h=raa(c[h>>2]|0)|0;if(gb[c[(c[k>>2]|0)+12>>2]&31](k,2048,h)|0){f=c[n>>2]|0;if((f|0)==(c[O>>2]|0)){Oz(m,n,O);f=c[n>>2]|0}c[n>>2]=f+4;c[f>>2]=h;q=q+1|0}else{v=a[D>>0]|0;if(!((h|0)==(c[N>>2]|0)&(s&((v<<24>>24<0?c[E>>2]|0:v&255)|0)!=0))){p=u;break}if((g|0)==(c[K>>2]|0)){Oz(Z,J,K);g=c[J>>2]|0}v=g+4|0;c[J>>2]=v;c[g>>2]=q;q=0;g=v}f=c[b>>2]|0;h=f+12|0;p=c[h>>2]|0;if((p|0)==(c[f+16>>2]|0)){nb[c[(c[f>>2]|0)+40>>2]&255](f)|0;f=u;r=e;p=t;continue}else{c[h>>2]=p+4;f=u;r=e;p=t;continue}}if(s&(c[Z>>2]|0)!=(g|0)){if((g|0)==(c[K>>2]|0)){Oz(Z,J,K);g=c[J>>2]|0}s=g+4|0;c[J>>2]=s;c[g>>2]=q}else s=g;d:do if((o|0)>0){g=c[b>>2]|0;do if(g){f=c[g+12>>2]|0;if((f|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=raa(c[f>>2]|0)|0;if(d8(g,-1)|0){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);if(p){g=c[p+12>>2]|0;if((g|0)==(c[p+16>>2]|0))g=nb[c[(c[p>>2]|0)+36>>2]&255](p)|0;else g=raa(c[g>>2]|0)|0;if(!(d8(g,-1)|0)){if(!f){R=220;break a}}else{e=0;R=183}}else R=183;if((R|0)==183){R=0;if(f){R=220;break a}else p=0}g=c[b>>2]|0;f=c[g+12>>2]|0;if((f|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=raa(c[f>>2]|0)|0;if((g|0)!=(c[M>>2]|0)){R=220;break a}g=c[b>>2]|0;f=g+12|0;h=c[f>>2]|0;if((h|0)==(c[g+16>>2]|0)){nb[c[(c[g>>2]|0)+40>>2]&255](g)|0;q=p;h=p}else{c[f>>2]=h+4;q=p;h=p}while(1){if((o|0)<=0)break d;g=c[b>>2]|0;do if(g){f=c[g+12>>2]|0;if((f|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=raa(c[f>>2]|0)|0;if(d8(g,-1)|0){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);if(h){g=c[h+12>>2]|0;if((g|0)==(c[h+16>>2]|0))g=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else g=raa(c[g>>2]|0)|0;if(!(d8(g,-1)|0))if((q|0)==0^f){r=q;p=q}else{R=220;break a}else{g=0;e=0;R=205}}else{g=q;R=205}if((R|0)==205){R=0;if(f){R=220;break a}else{r=g;p=0}}g=c[b>>2]|0;f=c[g+12>>2]|0;if((f|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=raa(c[f>>2]|0)|0;if(!(gb[c[(c[k>>2]|0)+12>>2]&31](k,2048,g)|0)){R=220;break a}if((c[n>>2]|0)==(c[O>>2]|0))Oz(m,n,O);g=c[b>>2]|0;f=c[g+12>>2]|0;if((f|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=raa(c[f>>2]|0)|0;f=c[n>>2]|0;c[n>>2]=f+4;c[f>>2]=g;o=o+-1|0;g=c[b>>2]|0;f=g+12|0;h=c[f>>2]|0;if((h|0)==(c[g+16>>2]|0)){nb[c[(c[g>>2]|0)+40>>2]&255](g)|0;q=r;h=p;continue}else{c[f>>2]=h+4;q=r;h=p;continue}}}while(0);if((c[n>>2]|0)==(c[m>>2]|0)){R=220;break a}else{f=Q;g=s}break}default:{f=Q;g=v}}while(0);e:do if((R|0)==44)while(1){R=0;e=c[b>>2]|0;do if(e){f=c[e+12>>2]|0;if((f|0)==(c[e+16>>2]|0))e=nb[c[(c[e>>2]|0)+36>>2]&255](e)|0;else e=raa(c[f>>2]|0)|0;if(d8(e,-1)|0){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);if(h){e=c[h+12>>2]|0;if((e|0)==(c[h+16>>2]|0))e=nb[c[(c[h>>2]|0)+36>>2]&255](h)|0;else e=raa(c[e>>2]|0)|0;if(!(d8(e,-1)|0))if((g|0)==0^f){q=g;e=r;p=g}else{f=Q;e=r;g=v;break e}else{g=0;e=0;R=56}}else{e=r;R=56}if((R|0)==56){R=0;if(f){f=Q;g=v;break e}else{q=g;p=0}}g=c[b>>2]|0;f=c[g+12>>2]|0;if((f|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else g=raa(c[f>>2]|0)|0;if(!(gb[c[(c[k>>2]|0)+12>>2]&31](k,8192,g)|0)){f=Q;g=v;break e}g=c[b>>2]|0;f=g+12|0;h=c[f>>2]|0;if((h|0)==(c[g+16>>2]|0))g=nb[c[(c[g>>2]|0)+40>>2]&255](g)|0;else{c[f>>2]=h+4;g=raa(c[h>>2]|0)|0}Gx(X,g);g=q;r=e;h=p;R=44}while(0);Q=f;w=w+1|0;v=g}f:do if((R|0)==42){c[P>>2]=o;c[i>>2]=c[i>>2]|4;e=0}else if((R|0)==99){c[P>>2]=o;c[i>>2]=c[i>>2]|4;e=0}else if((R|0)==137){c[P>>2]=o;c[i>>2]=c[i>>2]|4;e=0}else if((R|0)==220){c[P>>2]=o;c[i>>2]=c[i>>2]|4;e=0}else if((R|0)==222){c[P>>2]=o;g:do if(h){p=Q+8+3|0;q=Q+4|0;f=1;g=e;while(1){o=a[p>>0]|0;if(o<<24>>24<0)o=c[q>>2]|0;else o=o&255;if(f>>>0>=o>>>0)break g;o=c[b>>2]|0;do if(o){e=c[o+12>>2]|0;if((e|0)==(c[o+16>>2]|0))o=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else o=raa(c[e>>2]|0)|0;if(d8(o,-1)|0){c[b>>2]=0;e=1;break}else{e=(c[b>>2]|0)==0;break}}else e=1;while(0);if(g){o=c[g+12>>2]|0;if((o|0)==(c[g+16>>2]|0))o=nb[c[(c[g>>2]|0)+36>>2]&255](g)|0;else o=raa(c[o>>2]|0)|0;if(!(d8(o,-1)|0))if(e)h=g;else break;else R=240}else R=240;if((R|0)==240){R=0;if(e)break;else h=0}o=c[b>>2]|0;e=c[o+12>>2]|0;if((e|0)==(c[o+16>>2]|0))o=nb[c[(c[o>>2]|0)+36>>2]&255](o)|0;else o=raa(c[e>>2]|0)|0;if((a[p>>0]|0)<0)e=c[Q>>2]|0;else e=Q;if((o|0)!=(c[e+(f<<2)>>2]|0))break;o=f+1|0;e=c[b>>2]|0;g=e+12|0;f=c[g>>2]|0;if((f|0)==(c[e+16>>2]|0)){nb[c[(c[e>>2]|0)+40>>2]&255](e)|0;f=o;g=h;continue}else{c[g>>2]=f+4;f=o;g=h;continue}}c[i>>2]=c[i>>2]|4;e=0;break f}while(0);o=c[Z>>2]|0;if((o|0)!=(v|0)){c[S>>2]=0;Vs(T,o,v,S);if(!(c[S>>2]|0)){e=1;break}else{c[i>>2]=c[i>>2]|4;e=0;break}}else e=1}while(0);O0(X);O0(W);O0(V);O0(U);a1(T);o=c[Z>>2]|0;c[Z>>2]=0;if(o|0)jb[c[Y>>2]&511](o);l=_;return e|0}function Zb(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;S=l;l=l+128|0;F=S+112|0;G=S+100|0;J=S+88|0;K=S+76|0;M=S+64|0;N=S+52|0;O=S+40|0;P=S+28|0;Q=S+12|0;R=S;H=S+24|0;I=e+768|0;f=c[I>>2]|0;if(a[f+2>>0]|0?(r=UD(f+68|0,b[f>>1]|0)|0,(r|0)!=(f+72|0)):0){if(a[r+16+62>>0]|0?(g=UD(f+108|0,b[r+76>>1]|0)|0,(g|0)!=(f+112|0)):0){x1(F);m=g+36|0;n=J+8+3|0;o=J+4|0;p=G+8+3|0;q=G+4|0;f=c[g+32>>2]|0;a:while(1){if((f|0)==(m|0))break;k=f+24|0;g=c[f+20>>2]|0;b:while(1){if((g|0)==(k|0))break;TX(G);j=g+52|0;h=c[g+48>>2]|0;c:while(1){if((h|0)==(j|0))break;Bs(J,h+20|0,41596);i=a[n>>0]|0;E=i<<24>>24<0;Ex(G,E?c[J>>2]|0:J,E?c[o>>2]|0:i&255)|0;O0(J);i=c[h+4>>2]|0;if(!i)while(1){i=c[h+8>>2]|0;if((c[i>>2]|0)==(h|0)){h=i;continue c}else h=i}else h=i;while(1){i=c[h>>2]|0;if(!i)break;else h=i}}h=a[p>>0]|0;h=h<<24>>24<0?c[q>>2]|0:h&255;if(h|0)FB(G,h+-3|0,0);Bs(P,g+36|0,41840);h=a[p>>0]|0;E=h<<24>>24<0;Ex(P,E?c[G>>2]|0:G,E?c[q>>2]|0:h&255)|0;c[O>>2]=c[P>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];h=0;while(1){if((h|0)==3)break;c[P+(h<<2)>>2]=0;h=h+1|0}HX(O,27876)|0;c[N>>2]=c[O>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];h=0;while(1){if((h|0)==3)break;c[O+(h<<2)>>2]=0;h=h+1|0}D=g+24|0;h=a[g+32+3>>0]|0;E=h<<24>>24<0;Ex(N,E?c[D>>2]|0:D,E?c[g+28>>2]|0:h&255)|0;c[M>>2]=c[N>>2];c[M+4>>2]=c[N+4>>2];c[M+8>>2]=c[N+8>>2];h=0;while(1){if((h|0)==3)break;c[N+(h<<2)>>2]=0;h=h+1|0}HX(M,41840)|0;c[K>>2]=c[M>>2];c[K+4>>2]=c[M+4>>2];c[K+8>>2]=c[M+8>>2];h=0;while(1){if((h|0)==3)break;c[M+(h<<2)>>2]=0;h=h+1|0}p2(J,K);TX(Q);vF(yG(F,T2(Q,(c[g+20>>2]|0)+315964800-(d[(c[I>>2]|0)+104>>0]|0)|0)|0)|0,J)|0;z5(Q);z5(J);O0(K);O0(M);O0(N);O0(O);O0(P);z5(G);h=c[g+4>>2]|0;if(!h)while(1){h=c[g+8>>2]|0;if((c[h>>2]|0)==(g|0)){g=h;continue b}else g=h}else g=h;while(1){h=c[g>>2]|0;if(!h)break;else g=h}}g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue a}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}if(c[F+8>>2]|0){$x(G,e,0,0,326,1);g=pn(G)|0;z5(G);$x(G,e,0,0,327,1);f=pn(G)|0;z5(G);d:do if((g|0)!=0&g>>>0<f>>>0)while(1){f=f+-1|0;if(f>>>0<g>>>0)break d;Ed(e,0,0,f)}while(0);lL(e,0,0,326,RA(e,0,0)|0,10,1);h=F+4|0;i=G+11|0;f=c[F>>2]|0;e:while(1){if((f|0)==(h|0))break;pk(G,f+16|0);Mc(e,0,0,(a[i>>0]|0)<0?c[G>>2]|0:G,f+28|0,1);a1(G);g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue e}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}lL(e,0,0,327,RA(e,0,0)|0,10,1)}RX(F)}g=r+36|0;switch(c[r+44>>2]|0){case 0:break;case 1:{f=c[g>>2]|0;if(!((((c[f+32>>2]|0)==0?(c[f+116>>2]|0)==0:0)?(E=c[I>>2]|0,(UD(E+108|0,b[f+96>>1]|0)|0)==(E+112|0)):0)?!(zR(c[e+24>>2]|0)|0):0))s=54;break}default:s=54}f:do if((s|0)==54){u=r+40|0;v=e+20|0;w=J+8+3|0;x=J+4|0;y=F+8+3|0;z=F+4|0;A=J+8+3|0;B=J+4|0;C=F+8+3|0;D=F+4|0;E=G+4|0;f=c[g>>2]|0;g:while(1){r=f;if((f|0)==(u|0))break f;t=f+16|0;if(a[t+83>>0]|0){x1(G);n=f+120|0;if(!(a[n>>0]|0))j=0;else{o=f+112|0;g=c[f+108>>2]|0;h:while(1){if((g|0)==(o|0))break;k=g+16|0;m=g+24|0;h=c[g+20>>2]|0;i:while(1){if((h|0)==(m|0))break;j=h+20|0;if(!((Cv(G,j)|0)!=(E|0)?(a[k>>0]|0)!=78:0)){Bs(R,h+44|0,41840);q=h+56|0;i=a[h+64+3>>0]|0;s=i<<24>>24<0;Ex(R,s?c[q>>2]|0:q,s?c[h+60>>2]|0:i&255)|0;c[Q>>2]=c[R>>2];c[Q+4>>2]=c[R+4>>2];c[Q+8>>2]=c[R+8>>2];i=0;while(1){if((i|0)==3)break;c[R+(i<<2)>>2]=0;i=i+1|0}HX(Q,41840)|0;c[P>>2]=c[Q>>2];c[P+4>>2]=c[Q+4>>2];c[P+8>>2]=c[Q+8>>2];i=0;while(1){if((i|0)==3)break;c[Q+(i<<2)>>2]=0;i=i+1|0}q=h+68|0;i=a[h+76+3>>0]|0;s=i<<24>>24<0;Ex(P,s?c[q>>2]|0:q,s?c[h+72>>2]|0:i&255)|0;c[O>>2]=c[P>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];i=0;while(1){if((i|0)==3)break;c[P+(i<<2)>>2]=0;i=i+1|0}HX(O,27916)|0;c[N>>2]=c[O>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];i=0;while(1){if((i|0)==3)break;c[O+(i<<2)>>2]=0;i=i+1|0}q=h+32|0;i=a[h+40+3>>0]|0;s=i<<24>>24<0;Ex(N,s?c[q>>2]|0:q,s?c[h+36>>2]|0:i&255)|0;c[M>>2]=c[N>>2];c[M+4>>2]=c[N+4>>2];c[M+8>>2]=c[N+8>>2];i=0;while(1){if((i|0)==3)break;c[N+(i<<2)>>2]=0;i=i+1|0}HX(M,41840)|0;c[K>>2]=c[M>>2];c[K+4>>2]=c[M+4>>2];c[K+8>>2]=c[M+8>>2];i=0;while(1){if((i|0)==3)break;c[M+(i<<2)>>2]=0;i=i+1|0}q=h+80|0;i=a[h+88+3>>0]|0;s=i<<24>>24<0;Ex(K,s?c[q>>2]|0:q,s?c[h+84>>2]|0:i&255)|0;c[J>>2]=c[K>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];i=0;while(1){if((i|0)==3)break;c[K+(i<<2)>>2]=0;i=i+1|0}p2(F,J);vF(yG(G,j)|0,F)|0;z5(F);O0(J);O0(K);O0(M);O0(N);O0(O);O0(P);O0(Q);O0(R)}i=c[h+4>>2]|0;if(!i)while(1){i=c[h+8>>2]|0;if((c[i>>2]|0)==(h|0)){h=i;continue i}else h=i}else h=i;while(1){i=c[h>>2]|0;if(!i)break;else h=i}}h=c[g+4>>2]|0;if(!h)while(1){h=c[g+8>>2]|0;if((c[h>>2]|0)==(g|0)){g=h;continue h}else g=h}else g=h;while(1){h=c[g>>2]|0;if(!h)break;else g=h}}a[n>>0]=0;j=1}q=f+84|0;if((a[t+82>>0]|0)!=0?(s=c[I>>2]|0,L=UD(s+108|0,b[f+96>>1]|0)|0,(L|0)!=(s+112|0)):0){if(c[L+28>>2]|0){TX(F);i=L+24|0;g=c[L+20>>2]|0;j:while(1){if((g|0)==(i|0))break;Bs(J,g+20|0,41596);h=a[A>>0]|0;s=h<<24>>24<0;Ex(F,s?c[J>>2]|0:J,s?c[B>>2]|0:h&255)|0;O0(J);h=c[g+4>>2]|0;if(!h)while(1){h=c[g+8>>2]|0;if((c[h>>2]|0)==(g|0)){g=h;continue j}else g=h}else g=h;while(1){h=c[g>>2]|0;if(!h)break;else g=h}}g=a[C>>0]|0;g=g<<24>>24<0?c[D>>2]|0:g&255;if(g|0)FB(F,g+-3|0,0);g=c[q>>2]|0;if((g|0)==-1){g=c[I>>2]|0;h=g+204|0;i=c[h>>2]|0;if((i|0)==(c[g+208>>2]|0))bz(g+200|0,t);else{b[i>>1]=b[t>>1]|0;c[h>>2]=i+2}Kc(e,6,-1)|0;g=c[v>>2]|0;c[q>>2]=g}zb(e,6,g,73,F,1);z5(F)}p=L+44|0;if(a[p>>0]|0){o=L+36|0;g=c[L+32>>2]|0;k:while(1){if((g|0)==(o|0))break;n=g+24|0;h=c[g+20>>2]|0;l:while(1){if((h|0)==(n|0))break;m=h+20|0;if((c[m>>2]|0)!=-1){TX(F);k=h+52|0;i=c[h+48>>2]|0;m:while(1){if((i|0)==(k|0))break;Bs(J,i+20|0,41596);j=a[w>>0]|0;s=j<<24>>24<0;Ex(F,s?c[J>>2]|0:J,s?c[x>>2]|0:j&255)|0;O0(J);j=c[i+4>>2]|0;if(!j)while(1){j=c[i+8>>2]|0;if((c[j>>2]|0)==(i|0)){i=j;continue m}else i=j}else i=j;while(1){j=c[i>>2]|0;if(!j)break;else i=j}}i=a[y>>0]|0;i=i<<24>>24<0?c[z>>2]|0:i&255;if(i|0)FB(F,i+-3|0,0);Bs(P,h+36|0,41840);i=a[y>>0]|0;s=i<<24>>24<0;Ex(P,s?c[F>>2]|0:F,s?c[z>>2]|0:i&255)|0;c[O>>2]=c[P>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];i=0;while(1){if((i|0)==3)break;c[P+(i<<2)>>2]=0;i=i+1|0}HX(O,27876)|0;c[N>>2]=c[O>>2];c[N+4>>2]=c[O+4>>2];c[N+8>>2]=c[O+8>>2];i=0;while(1){if((i|0)==3)break;c[O+(i<<2)>>2]=0;i=i+1|0}k=h+24|0;i=a[h+32+3>>0]|0;s=i<<24>>24<0;Ex(N,s?c[k>>2]|0:k,s?c[h+28>>2]|0:i&255)|0;c[M>>2]=c[N>>2];c[M+4>>2]=c[N+4>>2];c[M+8>>2]=c[N+8>>2];i=0;while(1){if((i|0)==3)break;c[N+(i<<2)>>2]=0;i=i+1|0}HX(M,41840)|0;c[K>>2]=c[M>>2];c[K+4>>2]=c[M+4>>2];c[K+8>>2]=c[M+8>>2];i=0;while(1){if((i|0)==3)break;c[M+(i<<2)>>2]=0;i=i+1|0}p2(J,K);TX(Q);vF(yG(G,T2(Q,(c[m>>2]|0)+315964800-(d[(c[I>>2]|0)+104>>0]|0)|0)|0)|0,J)|0;z5(Q);z5(J);O0(K);O0(M);O0(N);O0(O);O0(P);z5(F)}i=c[h+4>>2]|0;if(!i)while(1){i=c[h+8>>2]|0;if((c[i>>2]|0)==(h|0)){h=i;continue l}else h=i}else h=i;while(1){i=c[h>>2]|0;if(!i)break;else h=i}}h=c[g+4>>2]|0;if(!h)while(1){h=c[g+8>>2]|0;if((c[h>>2]|0)==(g|0)){g=h;continue k}else g=h}else g=h;while(1){h=c[g>>2]|0;if(!h)break;else g=h}}a[p>>0]=0;s=149}else s=148}else s=148;if((s|0)==148?(s=0,j):0)s=149;if((s|0)==149){if((c[q>>2]|0)==-1){g=c[I>>2]|0;h=g+204|0;i=c[h>>2]|0;if((i|0)==(c[g+208>>2]|0))bz(g+200|0,t);else{b[i>>1]=b[t>>1]|0;c[h>>2]=i+2}Kc(e,6,-1)|0;c[q>>2]=c[v>>2]}MM(f+60|0,G)|0;c[H>>2]=r;c[F>>2]=c[H>>2];Bl(e,F)}RX(G)}g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue g}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}}while(0);R=c[I>>2]|0;a[R+120>>0]=0;a[R+121>>0]=0}l=S;return}function _b(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;$=l;l=l+192|0;Y=$+172|0;T=$+184|0;Z=$+160|0;_=$+120|0;N=$+104|0;O=$+64|0;P=$+48|0;Q=$+36|0;R=$+24|0;L=$+12|0;M=$;W=d+764|0;f=c[W>>2]|0;f=HD(f+68|0,f)|0;k=d+778|0;g=$C(f+16|0,k)|0;h=g+79|0;if((a[h>>0]|0)==0?(i=f+40|0,j=c[i>>2]|0,j|0):0){c[i>>2]=j+-1;a[h>>0]=1}FK(Y,g+52|0);Bx(d);I=d+648|0;d4(c[I>>2]|0,3);sR(d,13,T);d4(c[I>>2]|0,4);J=d+770|0;sR(d,12,J);wK(d);b[d+776>>1]=b[c[W>>2]>>1]|0;V=d+782|0;b[V>>1]=b[k>>1]|0;a[d+794>>0]=1;if(b[J>>1]|0)Ao(d);n=d+528|0;X=d+536|0;K=d+780|0;o=d+24|0;p=d+784|0;q=d+84|0;r=d+92+3|0;s=d+88|0;t=Z+8+3|0;u=Z+4|0;v=N+4|0;w=N+8|0;x=_+4|0;y=O+8|0;A=y+3|0;B=P+8|0;C=B+3|0;D=P+4|0;E=O+4|0;F=O+4|0;G=Y+4|0;H=d+793|0;a:while(1){k=n;i=c[k+4>>2]|0;m=X;j=c[m+4>>2]|0;if(!(i>>>0<j>>>0|((i|0)==(j|0)?(c[k>>2]|0)>>>0<(c[m>>2]|0)>>>0:0))){S=83;break}GC(d);Bx(d);xR(d,8,p);d4(c[I>>2]|0,3);sR(d,13,K);d4(c[I>>2]|0,4);sR(d,12,J);wK(d);b:do if(qO(d)|0){if((a[p>>0]|0)==32){f=a[r>>0]|0;if(f<<24>>24<0)f=c[s>>2]|0;else f=f&255;if(f>>>0>26?YQ(c[o>>2]|0)|0:0){p2(Z,q);f=a[t>>0]|0;FB(Z,(f<<24>>24<0?c[u>>2]|0:f&255)+-27|0,0);Bs(L,Z,41644);Gx(L,47);c[R>>2]=c[L>>2];c[R+4>>2]=c[L+4>>2];c[R+8>>2]=c[L+8>>2];f=0;while(1){if((f|0)==3)break;c[L+(f<<2)>>2]=0;f=f+1|0}HX(R,41664)|0;c[Q>>2]=c[R>>2];c[Q+4>>2]=c[R+4>>2];c[Q+8>>2]=c[R+8>>2];f=0;while(1){if((f|0)==3)break;c[R+(f<<2)>>2]=0;f=f+1|0}Gx(Q,47);c[P>>2]=c[Q>>2];c[P+4>>2]=c[Q+4>>2];c[P+8>>2]=c[Q+8>>2];f=0;while(1){if((f|0)==3)break;c[Q+(f<<2)>>2]=0;f=f+1|0}HX(P,41700)|0;c[O>>2]=c[P>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];f=0;while(1){if((f|0)==3)break;c[P+(f<<2)>>2]=0;f=f+1|0}p2(N,O);yg(_,N);z5(N);O0(O);O0(P);O0(Q);O0(R);O0(L);c[N>>2]=0;c[v>>2]=0;c[w>>2]=0;FF(N,((c[x>>2]|0)-(c[_>>2]|0)|0)/12|0);h=0;while(1){if(h>>>0>=(c[v>>2]|0)-(c[N>>2]|0)>>2>>>0){g=0;break}i=ZW(368)|0;Gt(i);c[(c[N>>2]|0)+(h<<2)>>2]=i;i=c[(c[N>>2]|0)+(h<<2)>>2]|0;c[O>>2]=0;c[O+4>>2]=0;c[O+8>>2]=0;g=i9(41728)|0;if(g>>>0>1073741807){S=30;break a}if(g>>>0<2){a[A>>0]=g;f=O}else{f=g+4&-4;if(f>>>0>1073741823){S=34;break a}m=ZW(f<<2)|0;c[O>>2]=m;c[y>>2]=f|-2147483648;c[E>>2]=g;f=m}a3(f,41728,g);y7(f+(g<<2)|0,0);c[P>>2]=0;c[P+4>>2]=0;c[P+8>>2]=0;g=i9(42196)|0;if(g>>>0>1073741807){S=37;break a}if(g>>>0<2){a[C>>0]=g;f=P}else{f=g+4&-4;if(f>>>0>1073741823){S=41;break a}m=ZW(f<<2)|0;c[P>>2]=m;c[B>>2]=f|-2147483648;c[D>>2]=g;f=m}a3(f,42196,g);y7(f+(g<<2)|0,0);wd(M,i,O,P);O0(M);O0(P);O0(O);Zk(c[(c[N>>2]|0)+(h<<2)>>2]|0,(c[_>>2]|0)+(h*12|0)|0)|0;if((sr(c[(c[N>>2]|0)+(h<<2)>>2]|0,1,-1)|0)==1?(Dk(O,c[(c[N>>2]|0)+(h<<2)>>2]|0,1,0,10,1),m=jn(O)|0,z5(O),m<<16>>16==(b[K>>1]|0)):0){S=46;break}h=h+1|0}if((S|0)==46){S=0;mI(O);Xy(P,41840);z3(O,P);z5(P);Dk(P,c[(c[N>>2]|0)+(h<<2)>>2]|0,1,0,10,1);og(O,P);z5(P);f=c[O>>2]|0;if(((c[F>>2]|0)-f|0)==24){j=b[K>>1]|0;k=c[W>>2]|0;i=(jn(f+12|0)|0)&65535;b[(c[(c[k+80>>2]|0)+(i<<2)>>2]|0)+194>>1]=j;i=jn((c[O>>2]|0)+12|0)|0;b[(c[(c[(c[W>>2]|0)+80>>2]|0)+(e[K>>1]<<2)>>2]|0)+194>>1]=i;i=jn((c[O>>2]|0)+12|0)|0;b[K>>1]=i;a[p>>0]=27;f=c[W>>2]|0;i=c[(c[f+80>>2]|0)+((i&65535)<<2)>>2]|0;k=c[i+4>>2]|0;j=(c[i+8>>2]|0)-k>>1;g=0;h=0;while(1){if((g|0)==(j|0))break;m=h|(b[k+(g<<1)>>1]|0)==(b[V>>1]|0);g=g+1|0;h=m}if(!h){k=$C((HD(f+68|0,f)|0)+16|0,V)|0;f=k+56|0;g=c[f>>2]|0;if((g|0)==(c[k+60>>2]|0))bz(k+52|0,K);else{b[g>>1]=b[K>>1]|0;c[f>>2]=g+2}f=c[W>>2]|0;g=c[f+80>>2]|0;h=c[g+(e[K>>1]<<2)>>2]|0;i=h+8|0;j=c[i>>2]|0;if((j|0)==(c[h+12>>2]|0)){bz(h+4|0,V);f=c[W>>2]|0;g=c[f+80>>2]|0}else{b[j>>1]=b[V>>1]|0;c[i>>2]=j+2}i=c[g+(e[K>>1]<<2)>>2]|0;c[i+160>>2]=c[k+68>>2]}h=i+64|0;if((c[h>>2]|0)!=1){g=f+92|0;f=c[g>>2]|0;if((f|0)==-1){c[g>>2]=0;f=0}c[g>>2]=f+1;c[h>>2]=1;a[i+168>>0]=a[p>>0]|0;UZ(i,1);RZ(c[(c[(c[W>>2]|0)+80>>2]|0)+(e[K>>1]<<2)>>2]|0,1);k=c[W>>2]|0;m=b[K>>1]|0;f=c[k+80>>2]|0;b[(c[f+((m&65535)<<2)>>2]|0)+112>>1]=b[T>>1]|0;if(WV(c[k+140>>2]|0,c[k+144>>2]|0,m)|0)a[(c[f+(e[K>>1]<<2)>>2]|0)+180>>0]=1}}$_(O);g=0}while(1){f=c[N>>2]|0;if(g>>>0>=(c[v>>2]|0)-f>>2>>>0)break;f=c[f+(g<<2)>>2]|0;if(f|0)jb[c[(c[f>>2]|0)+4>>2]&511](f);g=g+1|0}cU(N);$_(_);z5(Z)}}if(b[K>>1]|0){Pe(d,b[T>>1]|0);k=c[G>>2]|0;m=0;g=k;while(1){f=c[Y>>2]|0;if(m>>>0>=k-f>>1>>>0)break b;i=f+(m<<1)|0;if((b[i>>1]|0)==(b[K>>1]|0)){f=i+2|0;h=k-f|0;j=h>>1;if(!j){h=k;f=k}else{TR(i|0,f|0,h|0)|0;f=c[G>>2]|0;h=f;g=f}i=i+(j<<1)|0;while(1){if((h|0)==(i|0))break;f=h+-2|0;h=f;g=f}c[G>>2]=g}else f=k;m=m+1|0;k=f}}}while(0);a[H>>0]=1;if(b[J>>1]|0)Ao(d);J3(d)}if((S|0)==30)uaa();else if((S|0)==34){$=ua(8)|0;K2($,391652);c[$>>2]=57868;Ya($|0,2712,367)}else if((S|0)==37)uaa();else if((S|0)==41){$=ua(8)|0;K2($,391652);c[$>>2]=57868;Ya($|0,2712,367)}else if((S|0)==83){if(qO(d)|0){c:do if(CR(c[o>>2]|0)|0){h=c[Y>>2]|0;g=(c[G>>2]|0)-h>>1;f=0;while(1){if(f>>>0>=g>>>0)break c;b[K>>1]=b[h+(f<<1)>>1]|0;pi(d);S=c[W>>2]|0;a[($C((HD(S+68|0,S)|0)+16|0,V)|0)+83>>0]=1;f=f+1|0}}while(0);f=b[T>>1]|0;if(f<<16>>16!=8191?(S=c[W>>2]|0,a[(c[(c[S+80>>2]|0)+((f&65535)<<2)>>2]|0)+69>>0]=1,S=PH(S+176|0,T)|0,b[S>>1]=(b[S>>1]|0)+1<<16>>16,S=b[T>>1]|0,U=c[W>>2]|0,b[($C((HD(U+68|0,U)|0)+16|0,V)|0)+74>>1]=S,U=c[(c[(c[W>>2]|0)+80>>2]|0)+(e[T>>1]<<2)>>2]|0,T=U+80|0,(c[T>>2]|0)==-1?(c[T+4>>2]|0)==-1:0):0)RZ(U,1);U=c[W>>2]|0;if(!(c[(HD(U+68|0,U)|0)+40>>2]|0)){f=c[(c[W>>2]|0)+80>>2]|0;g=c[f+64>>2]|0;if(!(c[g+64>>2]|0)){UZ(g,1);f=c[(c[(c[W>>2]|0)+80>>2]|0)+64>>2]|0;c[f+64>>2]=2;nG(f+16|0);f=ZW(16)|0;M0(f);c[(c[(c[(c[(c[W>>2]|0)+80>>2]|0)+64>>2]|0)+16>>2]|0)+256>>2]=f;f=c[(c[W>>2]|0)+80>>2]|0}g=c[f+68>>2]|0;if(!(c[g+64>>2]|0)){UZ(g,1);f=c[(c[(c[W>>2]|0)+80>>2]|0)+68>>2]|0;c[f+64>>2]=2;nG(f+16|0);f=ZW(16)|0;M0(f);c[(c[(c[(c[(c[W>>2]|0)+80>>2]|0)+68>>2]|0)+16>>2]|0)+264>>2]=f;f=c[(c[W>>2]|0)+80>>2]|0}g=c[f+72>>2]|0;if(!(c[g+64>>2]|0)){UZ(g,1);f=c[(c[(c[W>>2]|0)+80>>2]|0)+72>>2]|0;c[f+64>>2]=2;nG(f+16|0);f=ZW(16)|0;M0(f);c[(c[(c[(c[(c[W>>2]|0)+80>>2]|0)+72>>2]|0)+16>>2]|0)+312>>2]=f;f=80;while(1){if((f|0)==96)break;U=ZW(16)|0;M0(U);c[(c[(c[(c[(c[W>>2]|0)+80>>2]|0)+72>>2]|0)+16>>2]|0)+(f<<2)>>2]=U;f=f+1|0}f=c[(c[W>>2]|0)+80>>2]|0}g=c[f+80>>2]|0;if(!(c[g+64>>2]|0)){UZ(g,1);f=c[(c[(c[W>>2]|0)+80>>2]|0)+80>>2]|0;c[f+64>>2]=2;nG(f+16|0);f=ZW(16)|0;M0(f);c[(c[(c[(c[(c[W>>2]|0)+80>>2]|0)+80>>2]|0)+16>>2]|0)+448>>2]=f;f=ZW(16)|0;M0(f);c[(c[(c[(c[(c[W>>2]|0)+80>>2]|0)+80>>2]|0)+16>>2]|0)+460>>2]=f;f=c[(c[W>>2]|0)+80>>2]|0}f=c[f+32748>>2]|0;if(!(c[f+64>>2]|0)){UZ(f,1);U=c[(c[(c[W>>2]|0)+80>>2]|0)+32748>>2]|0;c[U+64>>2]=2;nG(U+16|0);U=ZW(16)|0;M0(U);c[(c[(c[(c[(c[W>>2]|0)+80>>2]|0)+32748>>2]|0)+16>>2]|0)+796>>2]=U;U=ZW(16)|0;M0(U);c[(c[(c[(c[(c[W>>2]|0)+80>>2]|0)+32748>>2]|0)+16>>2]|0)+820>>2]=U}}i=c[W>>2]|0;i=$C((HD(i+68|0,i)|0)+16|0,V)|0;g=d+612|0;j=i+28|0;i=i+16|0;if((c[g>>2]|0)>>>0>3){c[Z>>2]=0;c[Z+4>>2]=0;c[Z+8>>2]=0;h=j9(391274)|0;if(h>>>0>4294967279)uaa();if(h>>>0<11){a[Z+11>>0]=h;f=Z}else{W=h+16&-16;f=ZW(W)|0;c[Z>>2]=f;c[Z+8>>2]=W|-2147483648;c[Z+4>>2]=h}i1(f,391274,h)|0;J7(f+h|0,0);W=VC(i,Z)|0;Gk(W,(c[g>>2]|0)+-4|0,10)|0;a1(Z);Xy(Z,41856);c[_>>2]=0;c[_+4>>2]=0;c[_+8>>2]=0;g=j9(391274)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[_+11>>0]=g;f=_}else{W=g+16&-16;f=ZW(W)|0;c[_>>2]=f;c[_+8>>2]=W|-2147483648;c[_+4>>2]=g}i1(f,391274,g)|0;J7(f+g|0,0);vF(VC(j,_)|0,Z)|0;a1(_);z5(Z)}c[Z>>2]=0;c[Z+4>>2]=0;c[Z+8>>2]=0;g=j9(391288)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[Z+11>>0]=g;f=Z}else{W=g+16&-16;f=ZW(W)|0;c[Z>>2]=f;c[Z+8>>2]=W|-2147483648;c[Z+4>>2]=g}i1(f,391288,g)|0;J7(f+g|0,0);W=VC(i,Z)|0;g=X;g=z0(c[g>>2]|0,c[g+4>>2]|0,4,0)|0;bk(W,g,z,10)|0;a1(Z);Xy(Z,41856);c[_>>2]=0;c[_+4>>2]=0;c[_+8>>2]=0;g=j9(391288)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[_+11>>0]=g;f=_}else{X=g+16&-16;f=ZW(X)|0;c[_>>2]=f;c[_+8>>2]=X|-2147483648;c[_+4>>2]=g}i1(f,391288,g)|0;J7(f+g|0,0);vF(VC(j,_)|0,Z)|0;a1(_);z5(Z)}bU(Y);l=$;return}}
function $b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;u=l;l=l+64|0;s=u;t=u+48|0;q=u+36|0;r=u+24|0;p=u+12|0;m=b+536|0;d=m;e=c[d>>2]|0;d=c[d+4>>2]|0;j=z0(e|0,d|0,-120,-1)|0;i=z;do if(i>>>0<0|(i|0)==0&j>>>0<21){zE(b,s);j=s;if((c[j>>2]|0)==1768765984?(c[j+4>>2]|0)==1130458452:0){iq(b);break}else{e=m;d=c[e+4>>2]|0;e=c[e>>2]|0;k=5;break}}else k=5;while(0);do if((k|0)==5){i=b+544|0;j=b+612|0;h=0;a:while(1){g=h+4|0;if(0>d>>>0|0==(d|0)&g>>>0>e>>>0){k=10;break}else f=0;while(1){if(f>>>0>=4)break a;v=a[(c[i>>2]|0)+(f+h+(c[j>>2]|0))>>0]|0;w=(f|0)!=0;if((v+-65&255)<61|((v&-16)<<24>>24==48|(w&v<<24>>24==41|((v+-39&255)<2|(v<<24>>24==34|w&v<<24>>24==32)))))f=f+1|0;else break}h=h+1|0}if((k|0)==10){e1(b,e,d);break}b:while(1){if(!(0<d>>>0|0==(d|0)&g>>>0<e>>>0))break;f=a[(c[i>>2]|0)+((c[j>>2]|0)+g)>>0]|0;switch(f<<24>>24){case 10:case 13:break;default:if(!((f&-32)<<24>>24==32|(f+-65&255)<61))break b}g=g+1|0}TX(s);if(h|0)e1(b,h,0);d=g-h|0;if(d|0)jZ(b,d,0,s);g=b+528|0;f=c[g>>2]|0;g=c[g+4>>2]|0;e=m;d=c[e>>2]|0;e=c[e+4>>2]|0;if(e>>>0>g>>>0|(e|0)==(g|0)&d>>>0>f>>>0){w=D_(d|0,e|0,f|0,g|0)|0;e1(b,w,z)}g=s+8+3|0;h=s+4|0;while(1){f=a[g>>0]|0;d=f<<24>>24<0;e=c[h>>2]|0;if((d?e:f&255)>>>0<=3)break;d=d?c[s>>2]|0:s;if((c[d+4>>2]|0)!=101)break;if((c[d+8>>2]|0)!=110)break;if((c[d+12>>2]|0)!=99)break;ny(s,0,1)|0}while(1){d=f<<24>>24<0;if((d?e:f&255)>>>0<=5)break;d=d?c[s>>2]|0:s;if((c[d+12>>2]|0)!=77)break;if((c[d+16>>2]|0)!=80)break;if((c[d+20>>2]|0)!=69)break;ny(s,0,1)|0;f=a[g>>0]|0;e=c[h>>2]|0}do if(qO(b)|0?(o=a[g>>0]|0,n=o<<24>>24<0,o=n?c[h>>2]|0:o&255,o>>>0>3):0){d=n?c[s>>2]|0:s;e=i9(36120)|0;n=b+912|0;if((e|0)!=0?(v=d+(o<<2)|0,w=HA(d,v,36120,36120+(e<<2)|0)|0,!((w|0)!=(v|0)&(w|0)==(d|0))):0)k1(n,s)|0;else{Xy(q,42252);d=a[g>>0]|0;w=d<<24>>24<0;Ex(q,w?c[s>>2]|0:s,w?c[h>>2]|0:d&255)|0;c[t>>2]=c[q>>2];c[t+4>>2]=c[q+4>>2];c[t+8>>2]=c[q+8>>2];d=0;while(1){if((d|0)==3)break;c[q+(d<<2)>>2]=0;d=d+1|0}w=a[t+8+3>>0]|0;v=w<<24>>24<0;Ex(n,v?c[t>>2]|0:t,v?c[t+4>>2]|0:w&255)|0;O0(t);z5(q)}i=b+920+3|0;d=a[i>>0]|0;k=b+916|0;if(d<<24>>24<0){f=c[n>>2]|0;g=c[k>>2]|0}else{f=n;g=d&255}e=i9(35444)|0;m=b+936|0;j=b+924|0;o=b+948|0;if(!((e|0)!=0?(v=f+(g<<2)|0,w=HA(f,v,35444,35444+(e<<2)|0)|0,!((w|0)!=(v|0)&(w|0)==(f|0))):0)){Xy(t,35472);vF(j,t)|0;z5(t);c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;f=i9(35492)|0;if(f>>>0>1073741807)uaa();d=q+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[q>>2]=w;c[d>>2]=e|-2147483648;c[q+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=q}while(0);a3(d,35492,f);y7(d+(f<<2)|0,0);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;f=i9(409096)|0;if(f>>>0>1073741807)uaa();d=r+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[r>>2]=w;c[d>>2]=e|-2147483648;c[r+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=r}while(0);a3(d,409096,f);y7(d+(f<<2)|0,0);Ok(t,n,q,r,0,0);O0(r);O0(q);g=t+8+3|0;e=a[g>>0]|0;h=t+4|0;d=c[h>>2]|0;if(!((e<<24>>24<0?d:e&255)|0)){c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;f=i9(35516)|0;if(f>>>0>1073741807)uaa();d=r+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[r>>2]=w;c[d>>2]=e|-2147483648;c[r+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=r}while(0);a3(d,35516,f);y7(d+(f<<2)|0,0);c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;f=i9(35524)|0;if(f>>>0>1073741807)uaa();d=p+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[p>>2]=w;c[d>>2]=e|-2147483648;c[p+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=p}while(0);a3(d,35524,f);y7(d+(f<<2)|0,0);Ok(q,n,r,p,0,0);vF(t,q)|0;z5(q);O0(p);O0(r);e=a[g>>0]|0;d=c[h>>2]|0}if(!((e<<24>>24<0?d:e&255)|0)){c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;f=i9(35516)|0;if(f>>>0>1073741807)uaa();d=r+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[r>>2]=w;c[d>>2]=e|-2147483648;c[r+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=r}while(0);a3(d,35516,f);y7(d+(f<<2)|0,0);c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;f=i9(409096)|0;if(f>>>0>1073741807)uaa();d=p+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[p>>2]=w;c[d>>2]=e|-2147483648;c[p+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=p}while(0);a3(d,409096,f);y7(d+(f<<2)|0,0);Ok(q,n,r,p,0,0);vF(t,q)|0;z5(q);O0(p);O0(r)}k1(m,Ot(0,t,1)|0)|0;d=a[b+944+3>>0]|0;if(d<<24>>24<0)d=c[b+940>>2]|0;else d=d&255;if(!d)k1(m,t)|0;k1(o,Ot(0,t,2)|0)|0;z5(t);d=a[i>>0]|0}if(d<<24>>24<0){f=c[n>>2]|0;e=c[k>>2]|0}else{f=n;e=d&255}d=i9(35532)|0;if(d|0?(v=f+(e<<2)|0,w=HA(f,v,35532,35532+(d<<2)|0)|0,!((w|0)!=(v|0)&(w|0)==(f|0))):0)break;Xy(t,35532);vF(j,t)|0;z5(t);d=a[i>>0]|0;if(d<<24>>24<0){f=c[n>>2]|0;e=c[k>>2]|0}else{f=n;e=d&255}d=i9(35552)|0;if(d|0?(v=f+(e<<2)|0,w=HA(f,v,35552,35552+(d<<2)|0)|0,(w|0)==(v|0)|(w-f|0)==-4):0){c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;f=i9(35532)|0;if(f>>>0>1073741807)uaa();d=q+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[q>>2]=w;c[d>>2]=e|-2147483648;c[q+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=q}while(0);a3(d,35532,f);y7(d+(f<<2)|0,0);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;f=i9(409096)|0;if(f>>>0>1073741807)uaa();d=r+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[r>>2]=w;c[d>>2]=e|-2147483648;c[r+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=r}while(0);a3(d,409096,f);y7(d+(f<<2)|0,0);Ok(t,n,q,r,0,0);O0(r);O0(q);c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;f=i9(35580)|0;if(f>>>0>1073741807)uaa();d=q+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[q>>2]=w;c[d>>2]=e|-2147483648;c[q+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=q}while(0);a3(d,35580,f);y7(d+(f<<2)|0,0);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;f=i9(409096)|0;if(f>>>0>1073741807)uaa();d=r+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[r>>2]=w;c[d>>2]=e|-2147483648;c[r+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=r}while(0);a3(d,409096,f);y7(d+(f<<2)|0,0);vo(t,q,r,0,0);O0(r);O0(q);aE(t,48)|0;k1(m,Ot(1,t,1)|0)|0;d=a[b+944+3>>0]|0;if(d<<24>>24<0)d=c[b+940>>2]|0;else d=d&255;if(!d)k1(m,t)|0;k1(o,Ot(1,t,2)|0)|0;z5(t);break}c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;f=i9(35532)|0;if(f>>>0>1073741807)uaa();d=q+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[q>>2]=w;c[d>>2]=e|-2147483648;c[q+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=q}while(0);a3(d,35532,f);y7(d+(f<<2)|0,0);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;f=i9(409096)|0;if(f>>>0>1073741807)uaa();d=r+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[r>>2]=w;c[d>>2]=e|-2147483648;c[r+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=r}while(0);a3(d,409096,f);y7(d+(f<<2)|0,0);Ok(t,n,q,r,0,0);vF(m,t)|0;z5(t);O0(r);O0(q);c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;f=i9(35588)|0;if(f>>>0>1073741807)uaa();d=q+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[q>>2]=w;c[d>>2]=e|-2147483648;c[q+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=q}while(0);a3(d,35588,f);y7(d+(f<<2)|0,0);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;f=i9(409096)|0;if(f>>>0>1073741807)uaa();d=r+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){w=ua(8)|0;K2(w,391652);c[w>>2]=57868;Ya(w|0,2712,367)}else{w=ZW(e<<2)|0;c[r>>2]=w;c[d>>2]=e|-2147483648;c[r+4>>2]=f;d=w;break}}else{a[d+3>>0]=f;d=r}while(0);a3(d,409096,f);y7(d+(f<<2)|0,0);Ok(t,n,q,r,0,0);O0(r);O0(q);w=a[t+8+3>>0]|0;d=w<<24>>24<0;if(((d?c[t+4>>2]|0:w&255)|0)==10){w=d?c[t>>2]|0:t;c[w+16>>2]=45;c[w+28>>2]=45;ms(r,42232,t);p2(q,r);vF(o,q)|0;z5(q);O0(r)}z5(t)}while(0);z5(s)}while(0);l=u;return}function ac(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+48|0;r=u+24|0;s=u+12|0;t=u;p2(b,d);k=e+8+3|0;h=a[k>>0]|0;n=e+4|0;h=((h<<24>>24<0?c[n>>2]|0:h&255)|0)==0;if(h){c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;g=i9(42252)|0;if(g>>>0>1073741807)uaa();d=r+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{q=ZW(f<<2)|0;c[r>>2]=q;c[d>>2]=f|-2147483648;c[r+4>>2]=g;d=q;break}}else{a[d+3>>0]=g;d=r}while(0);a3(d,42252,g);y7(d+(g<<2)|0,0);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;g=i9(4696)|0;if(g>>>0>1073741807)uaa();d=s+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{q=ZW(f<<2)|0;c[s>>2]=q;c[d>>2]=f|-2147483648;c[s+4>>2]=g;d=q;break}}else{a[d+3>>0]=g;d=s}while(0);a3(d,4696,g);y7(d+(g<<2)|0,0);vo(b,r,s,0,8);O0(s);O0(r)}p=b+8+3|0;d=a[p>>0]|0;q=b+4|0;if(d<<24>>24<0)d=c[q>>2]|0;else d=d&255;if(!d){VU(r,390991);vF(b,r)|0;z5(r)}a:do if(!h){d=a[k>>0]|0;f=d<<24>>24<0;g=f?c[e>>2]|0:e;h=i9(6380)|0;b:do if((h|0)!=0?(f=g+((f?c[n>>2]|0:d&255)<<2)|0,j=HA(g,f,6380,6380+(h<<2)|0)|0,(j|0)==(f|0)|(j-g|0)==-4):0){f=i9(30156)|0;d=a[p>>0]|0;g=c[q>>2]|0;if((f|0)==((d<<24>>24<0?g:d&255)|0)){if(VG(b,30156,f)|0){d=a[p>>0]|0;g=c[q>>2]|0;m=31}}else m=31;do if((m|0)==31){f=i9(30144)|0;if((f|0)==((d<<24>>24<0?g:d&255)|0)){if(!(VG(b,30144,f)|0))break;d=a[p>>0]|0}j=d<<24>>24<0;d=d&255;i=0;f=0;c:while(1)while(1){if(j)g=c[q>>2]|0;else g=d;if(f>>>0>=g>>>0)break c;h=f+1|0;do if(!f){if(j)g=c[b>>2]|0;else g=b;if((c[g>>2]|0)==48){if(j)g=c[q>>2]|0;else g=d;if(g>>>0<=1)break;if(j)g=c[b>>2]|0;else g=b;if((c[g+(h<<2)>>2]|0)!=46){f=0;break c}}}while(0);if(j)g=c[b>>2]|0;else g=b;if((c[g+(f<<2)>>2]|0)>47){if(j)g=c[b>>2]|0;else g=b;if((c[g+(f<<2)>>2]|0)<58){f=h;continue}}if(!i){if(j)g=c[b>>2]|0;else g=b;if((c[g+(f<<2)>>2]|0)==46){i=1;f=h;continue c}}if(j)g=c[b>>2]|0;else g=b;if(f|0?1:(c[g+(f<<2)>>2]|0)!=45)break c;else f=h}if(j)d=c[q>>2]|0;if(f>>>0<16&(f|0)==(d|0))break a;else{h=1;break b}}while(0);d=i9(30156)|0;j=a[p>>0]|0;if((d|0)==((j<<24>>24<0?c[q>>2]|0:j&255)|0)?(VG(b,30156,d)|0)==0:0){Xy(r,57432);vF(b,r)|0;z5(r);h=0;break}Xy(r,57408);vF(b,r)|0;z5(r);h=0}else m=25;while(0);if((m|0)==25)if((a[p>>0]|0)<0?(i=c[q>>2]|0,i>>>0>1024):0){ny(b,1024,i+-1024|0)|0;h=1}else h=1;g=a[k>>0]|0;i=g<<24>>24<0;d=i?c[e>>2]|0:e;f=i9(4704)|0;if((f|0)!=0?(m=d+((i?c[n>>2]|0:g&255)<<2)|0,n=HA(d,m,4704,4704+(f<<2)|0)|0,(n|0)==(m|0)|(n-d|0)==-4):0)m=72;else m=71}else{h=1;m=72}while(0);if((m|0)==72){if((a[p>>0]|0)<0?(o=c[q>>2]|0,o>>>0>4096):0)ny(b,4096,o+-4096|0)|0;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;g=i9(4724)|0;if(g>>>0>1073741807)uaa();d=r+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[r>>2]=o;c[d>>2]=f|-2147483648;c[r+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=r}while(0);a3(d,4724,g);y7(d+(g<<2)|0,0);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;g=i9(4732)|0;if(g>>>0>1073741807)uaa();d=s+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[s>>2]=o;c[d>>2]=f|-2147483648;c[s+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=s}while(0);a3(d,4732,g);y7(d+(g<<2)|0,0);vo(b,r,s,0,8);O0(s);O0(r);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;g=i9(42444)|0;if(g>>>0>1073741807)uaa();d=r+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[r>>2]=o;c[d>>2]=f|-2147483648;c[r+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=r}while(0);a3(d,42444,g);y7(d+(g<<2)|0,0);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;g=i9(4744)|0;if(g>>>0>1073741807)uaa();d=s+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[s>>2]=o;c[d>>2]=f|-2147483648;c[s+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=s}while(0);a3(d,4744,g);y7(d+(g<<2)|0,0);vo(b,r,s,0,8);O0(s);O0(r);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;g=i9(4756)|0;if(g>>>0>1073741807)uaa();d=r+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[r>>2]=o;c[d>>2]=f|-2147483648;c[r+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=r}while(0);a3(d,4756,g);y7(d+(g<<2)|0,0);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;g=i9(4764)|0;if(g>>>0>1073741807)uaa();d=s+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[s>>2]=o;c[d>>2]=f|-2147483648;c[s+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=s}while(0);a3(d,4764,g);y7(d+(g<<2)|0,0);vo(b,r,s,0,8);O0(s);O0(r);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;g=i9(42452)|0;if(g>>>0>1073741807)uaa();d=r+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[r>>2]=o;c[d>>2]=f|-2147483648;c[r+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=r}while(0);a3(d,42452,g);y7(d+(g<<2)|0,0);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;g=i9(42472)|0;if(g>>>0>1073741807)uaa();d=s+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[s>>2]=o;c[d>>2]=f|-2147483648;c[s+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=s}while(0);a3(d,42472,g);y7(d+(g<<2)|0,0);vo(b,r,s,0,8);O0(s);O0(r);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;g=i9(42464)|0;if(g>>>0>1073741807)uaa();d=r+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[r>>2]=o;c[d>>2]=f|-2147483648;c[r+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=r}while(0);a3(d,42464,g);y7(d+(g<<2)|0,0);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;g=i9(42472)|0;if(g>>>0>1073741807)uaa();d=s+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[s>>2]=o;c[d>>2]=f|-2147483648;c[s+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=s}while(0);a3(d,42472,g);y7(d+(g<<2)|0,0);vo(b,r,s,0,8);O0(s);O0(r);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;g=i9(42472)|0;if(g>>>0>1073741807)uaa();d=r+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[r>>2]=o;c[d>>2]=f|-2147483648;c[r+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=r}while(0);a3(d,42472,g);y7(d+(g<<2)|0,0);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;g=i9(4776)|0;if(g>>>0>1073741807)uaa();d=s+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[s>>2]=o;c[d>>2]=f|-2147483648;c[s+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=s}while(0);a3(d,4776,g);y7(d+(g<<2)|0,0);vo(b,r,s,0,8);O0(s);O0(r);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;g=i9(4788)|0;if(g>>>0>1073741807)uaa();d=r+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[r>>2]=o;c[d>>2]=f|-2147483648;c[r+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=r}while(0);a3(d,4788,g);y7(d+(g<<2)|0,0);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;g=i9(4796)|0;if(g>>>0>1073741807)uaa();d=s+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[s>>2]=o;c[d>>2]=f|-2147483648;c[s+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=s}while(0);a3(d,4796,g);y7(d+(g<<2)|0,0);vo(b,r,s,0,8);O0(s);O0(r);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;g=i9(4808)|0;if(g>>>0>1073741807)uaa();d=r+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[r>>2]=o;c[d>>2]=f|-2147483648;c[r+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=r}while(0);a3(d,4808,g);y7(d+(g<<2)|0,0);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;g=i9(4816)|0;if(g>>>0>1073741807)uaa();d=s+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){u=ua(8)|0;K2(u,391652);c[u>>2]=57868;Ya(u|0,2712,367)}else{o=ZW(f<<2)|0;c[s>>2]=o;c[d>>2]=f|-2147483648;c[s+4>>2]=g;d=o;break}}else{a[d+3>>0]=g;d=s}while(0);a3(d,4816,g);y7(d+(g<<2)|0,0);vo(b,r,s,0,8);O0(s);O0(r);m=71}if((m|0)==71){g=0;d:while(1){while(1){d=a[p>>0]|0;f=d<<24>>24<0;if(f)d=c[q>>2]|0;else d=d&255;if(g>>>0>=d>>>0)break d;if(f)d=c[b>>2]|0;else d=b;if((c[d+(g<<2)>>2]|0)>=32){if(f)d=c[b>>2]|0;else d=b;if((c[d+(g<<2)>>2]|0)<=126)break}ny(b,g,1)|0}g=g+1|0}if(h){ms(t,42444,b);HX(t,42444)|0;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];d=0;while(1){if((d|0)==3)break;c[t+(d<<2)>>2]=0;d=d+1|0}p2(r,s);vF(b,r)|0;z5(r);O0(s);O0(t)}}l=u;return}function bc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;h=a+508|0;b=c[h>>2]|0;a:do if(b|0){i=a+668|0;d=c[i>>2]|0;e=$$(d,1)|0;f=z;g=(b|0)==1;b:do if((e|0)>=-1310339311){if((e|0)<-634007279){switch(e|0){case -1310339311:break;default:break b}if((f|0)!=-1878523853)break;if(!g)break a;o7(a);TT(a);break a}if((e|0)<1242301256){switch(e|0){case -634007279:break;default:break b}if((f|0)!=-752229674)break;if(!g)break a;o7(a);TT(a);break a}switch(e|0){case 1242301256:break;default:break b}if((f|0)==-801130692){if(!g)break a;if(k2(1,d)|0){Yf(a);break a}else{c3(1,d);break a}}}else{if((e|0)>=-1391303604){switch(e|0){case -1391303604:break;default:break b}if((f|0)!=-133975554)break;if(!g)break a;if(k2(1,d)|0)break a;c3(1,d);break a}switch(e|0){case -1905864943:break;default:break b}if((f|0)>=908505717){switch(f|0){case 908505717:break;default:break b}if(g){o7(a);dl(a);b=c[h>>2]|0}if((b|0)!=2)break a;b=c[i>>2]|0;if(k2(2,b)|0){Vc(a);break a}else{c3(2,b);break a}}switch(f|0){case 807842421:break;default:break b}if(g){o7(a);lM(a);b=c[h>>2]|0;if((b|0)==1)break a;d=c[i>>2]|0}e=$$(d,2)|0;f=z;c:do if((e|0)<489803793){if((e|0)>=-634007279){if((e|0)<-540407483){switch(e|0){case -634007279:break;default:break c}if((f|0)!=-601234730)break;if((b|0)!=2)break a;if(k2(2,d)|0){JG(a);break a}else{c3(2,d);break a}}if((e|0)<132370961){switch(e|0){case -540407483:break;default:break c}if((f|0)!=1960052248)break;if((b|0)!=2)break a;if(k2(2,d)|0){G$(a);break a}else{c3(2,d);break a}}else{switch(e|0){case 132370961:break;default:break c}if((f|0)!=1084543186)break;if((b|0)!=2)break a;if(k2(2,d)|0){Tb(a);break a}else{c3(2,d);break a}}}if((e|0)<-1905864943){switch(e|0){case -1924738799:break;default:break c}if((f|0)!=-831129477)break;if((b|0)!=2)break a;if(k2(2,d)|0){dz(a);break a}else{c3(2,d);break a}}if((e|0)>=-1213608175){switch(e|0){case -1213608175:break;default:break c}if((f|0)!=-1861755721)break;if((b|0)!=2)break a;if(k2(2,d)|0){Ee(a);break a}else{c3(2,d);break a}}switch(e|0){case -1905864943:break;default:break c}if((f|0)>=891728501){switch(f|0){case 891728501:break;default:break c}if((b|0)!=2)break a;if(k2(2,d)|0)break a;c3(2,d);break a}switch(f|0){case 858174069:break;default:break c}if((b|0)!=2)break a;if(k2(2,d)|0){mm(a);break a}else{c3(2,d);break a}}else{if((e|0)<782880529){if((e|0)<572921676){switch(e|0){case 489803793:break;default:break c}if((f|0)!=1079169414)break;if((b|0)!=2)break a;if(k2(2,d)|0){Yj(a);break a}else{c3(2,d);break a}}if((e|0)<599642641){switch(e|0){case 572921676:break;default:break c}if((f|0)!=350652969)break;if((b|0)!=2)break a;if(k2(2,d)|0){eV(a);break a}else{c3(2,d);break a}}switch(e|0){case 599642641:break;default:break c}if((f|0)<-72150750){switch(f|0){case -88927966:break;default:break c}if((b|0)!=2)break a;if(k2(2,d)|0){wx(a);break a}else{c3(2,d);break a}}if((f|0)<-55373534){switch(f|0){case -72150750:break;default:break c}if((b|0)!=2)break a;if(k2(2,d)|0){px(a);break a}else{c3(2,d);break a}}else{switch(f|0){case -55373534:break;default:break c}if((b|0)!=2)break a;if(k2(2,d)|0){AM(a);break a}else{c3(2,d);break a}}}if((e|0)>=1370083089)if((e|0)<1644941329){switch(e|0){case 1370083089:break;default:break c}if((f|0)!=30246900)break;if((b|0)!=2)break a;if(k2(2,d)|0){mr(a);break a}else{c3(2,d);break a}}else{switch(e|0){case 1644941329:break;default:break c}if((f|0)!=807074590)break;if((b|0)!=2)break a;if(k2(2,d)|0){ur(a);break a}else{c3(2,d);break a}}if((e|0)>=1202310929){switch(e|0){case 1202310929:break;default:break c}if((f|0)!=-1579373684)break;if((b|0)!=2)break a;if(k2(2,d)|0){wm(a);break a}else{c3(2,d);break a}}switch(e|0){case 782880529:break;default:break c}if((f|0)==-1258045601){if((b|0)==2){o7(a);lO(a);b=c[h>>2]|0;if((b|0)==2)break a;d=c[i>>2]|0}e=$$(d,3)|0;f=z;d:do if((e|0)<-540407483){if((e|0)<-1735077559){if((e|0)<-2075792313){switch(e|0){case -2123766199:break;default:break d}if((f|0)!=864355651)break;if((b|0)!=3)break a;if(k2(3,d)|0)break a;c3(3,d);break a}if((e|0)<-1751687861){switch(e|0){case -2075792313:break;default:break d}if((f|0)!=1569452326)break;if((b|0)!=3)break a;if(k2(3,d)|0){MX(a);break a}else{c3(3,d);break a}}else{switch(e|0){case -1751687861:break;default:break d}if((f|0)!=1833524981)break;if((b|0)!=3)break a;if(k2(3,d)|0){F0(a);break a}else{c3(3,d);break a}}}if((e|0)<-746041531){if((e|0)<-1352960184){switch(e|0){case -1735077559:break;default:break d}if((f|0)!=-1810095292)break;if((b|0)!=3)break a;if(k2(3,d)|0)break a;c3(3,d);break a}switch(e|0){case -1352960184:break;default:break d}if((f|0)!=-355731259)break;if((b|0)!=3)break a;if(k2(3,d)|0){ad(a);break a}else{c3(3,d);break a}}if((e|0)<-634007279){switch(e|0){case -746041531:break;default:break d}if((f|0)!=1540488916)break;if((b|0)!=3)break a;if(k2(3,d)|0){lB(a);break a}else{c3(3,d);break a}}else{switch(e|0){case -634007279:break;default:break d}if((f|0)!=-550903082)break;if((b|0)!=3)break a;if(k2(3,d)|0){vy(a);break a}else{c3(3,d);break a}}}else{if((e|0)<1925591619){if((e|0)>=289399880){if((e|0)>=394042447){switch(e|0){case 394042447:break;default:break d}if((f|0)!=551463641)break;if((b|0)!=3)break a;if(k2(3,d)|0)break a;c3(3,d);break a}switch(e|0){case 289399880:break;default:break d}if((f|0)!=-1388634005)break;if((b|0)!=3)break a;if(k2(3,d)|0){F0(a);break a}else{c3(3,d);break a}}if((e|0)<-521143221){switch(e|0){case -540407483:break;default:break d}if((f|0)!=1960052248)break;if((b|0)!=3)break a;if(k2(3,d)|0){G$(a);break a}else{c3(3,d);break a}}else{switch(e|0){case -521143221:break;default:break d}if((f|0)!=-1455012996)break;if((b|0)!=3)break a;if(k2(3,d)|0){wu(a);break a}else{c3(3,d);break a}}}if((e|0)<2035955779)if((e|0)<1967616070){switch(e|0){case 1925591619:break;default:break d}if((f|0)!=-878320108)break;if((b|0)!=3)break a;if(k2(3,d)|0){Rg(a);break a}else{c3(3,d);break a}}else{switch(e|0){case 1967616070:break;default:break d}if((f|0)!=-817264992)break;if((b|0)!=3)break a;if(k2(3,d)|0){iD(a);break a}else{c3(3,d);break a}}else if((e|0)<2068959761){switch(e|0){case 2035955779:break;default:break d}if((f|0)!=1079658193)break;if((b|0)!=3)break a;if(k2(3,d)|0){G$(a);break a}else{c3(3,d);break a}}else{switch(e|0){case 2068959761:break;default:break d}if((f|0)!=-435579226)break;if((b|0)!=3)break a;if(k2(3,d)|0){G$(a);break a}else{c3(3,d);break a}}}while(0);i=HN(a,0)|0;e1(a,i,z);break a}}while(0);i=HN(a,0)|0;e1(a,i,z);break a}while(0);i=HN(a,0)|0;e1(a,i,z)}while(0);return}function cc(e){e=e|0;var f=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;Q=l;l=l+16|0;M=Q;L=Q+14|0;m=Q+13|0;k=Q+12|0;K=Q+11|0;I=e+48|0;I=z0(c[e+612>>2]|0,0,c[I>>2]|0,c[I+4>>2]|0)|0;j=e+536|0;H=j;H=z0(I|0,z|0,c[H>>2]|0,c[H+4>>2]|0)|0;I=e+40|0;P=e+760|0;O=e+312|0;h=O;f=c[h>>2]|0;h=c[h+4>>2]|0;if((H|0)==(c[I>>2]|0)?(z|0)==(c[I+4>>2]|0):0){I=P;c[I>>2]=f;c[I+4>>2]=h}f=z0(f|0,h|0,1,0)|0;i=O;c[i>>2]=f;c[i+4>>2]=z;i=e+328|0;f=i;f=z0(c[f>>2]|0,c[f+4>>2]|0,1,0)|0;h=z;c[i>>2]=f;c[i+4>>2]=h;i=e+816|0;I=i;H=c[I+4>>2]|0;if(h>>>0>H>>>0|((h|0)==(H|0)?f>>>0>(c[I>>2]|0)>>>0:0)){I=i;c[I>>2]=f;c[I+4>>2]=h}f=e+360|0;i=f;h=c[i>>2]|0;i=c[i+4>>2]|0;if(!((h|0)==-1&(i|0)==-1)){H=z0(h|0,i|0,1,0)|0;I=f;c[I>>2]=H;c[I+4>>2]=z}Bx(e);H=e+863|0;I=e+864|0;do if(((a[e+857>>0]|0)+31&255)<8){GC(e);Bx(e);h=e+648|0;A6(c[h>>2]|0);AT(e,Q+4|0);xR(e,2,K);xR(e,4,k);A6(c[h>>2]|0);xR(e,3,Q+9|0);xR(e,4,Q+10|0);KS(e);A6(c[h>>2]|0);xR(e,3,Q+7|0);xR(e,4,Q+8|0);A6(c[h>>2]|0);A6(c[h>>2]|0);xR(e,2,Q+5|0);xR(e,4,Q+6|0);KS(e);d4(c[h>>2]|0,4);d4(c[h>>2]|0,4);d4(c[h>>2]|0,4);d4(c[h>>2]|0,4);KS(e);d4(c[h>>2]|0,4);d4(c[h>>2]|0,4);d4(c[h>>2]|0,4);d4(c[h>>2]|0,4);KS(e);d4(c[h>>2]|0,4);J3(e);d4(c[h>>2]|0,10);d4(c[h>>2]|0,2);xR(e,2,L);AT(e,m);f=a[m>>0]|0;if(f<<24>>24){if(a[H>>0]|0?(a[I>>0]|0)==1&(a[L>>0]|0)==0:0){d4(c[h>>2]|0,14);KS(e);d4(c[h>>2]|0,14);KS(e);d4(c[h>>2]|0,14);KS(e);d4(c[h>>2]|0,14);KS(e)}A6(c[h>>2]|0);A6(c[h>>2]|0);A6(c[h>>2]|0);wK(e);J=j;K=e+528|0;K=D_(c[J>>2]|0,c[J+4>>2]|0,c[K>>2]|0,c[K+4>>2]|0)|0;e1(e,K,z)}j=0;n=199}else{xR(e,2,L);j=0;while(1){AT(e,k);if(!(a[k>>0]|0))break;else j=j+1<<24>>24}KS(e);G=qO(e)|0;i=e+855|0;f=a[i>>0]|0;if(G&f<<24>>24==0){M=c[O+4>>2]|0;N=c[P+4>>2]|0;if(!(M>>>0<N>>>0|((M|0)==(N|0)?(c[O>>2]|0)>>>0<(c[P>>2]|0)>>>0:0))?(RA(e,1,-1)|0)==0:0){W5(e);V5(e)}break}rR(e,f,M);KS(e);AT(e,m);f=a[m>>0]|0;if(f<<24>>24){if(a[e+878>>0]|0){G=(d[i>>0]|0)+3|0;h=e+648|0;d4(c[h>>2]|0,(G>>>0<15?G:15)&255);if(K6(c[h>>2]|0)|0){GC(e);A6(c[h>>2]|0);G=(d[i>>0]|0)+3|0;G4(c[h>>2]|0,G>>>0<15?G:15);J3(e)}else A6(c[h>>2]|0);KS(e)}a:do if((a[H>>0]|0)!=2){switch(a[L>>0]|0){case 1:break;case 3:{if((a[I>>0]|0)!=2)break a;break}default:break a}A6(c[e+648>>2]|0)}while(0);if(a[e+879>>0]|0){h=a[H>>0]|0;if(h<<24>>24==0&(d[L>>0]|0)<2){A6(c[e+648>>2]|0);n=33}}else n=33;if((n|0)==33)h=a[H>>0]|0;do if(h<<24>>24){if((a[I>>0]|0)==1&(a[L>>0]|0)==0){h=e+648|0;d4(c[h>>2]|0,13);KS(e);d4(c[h>>2]|0,13);KS(e);d4(c[h>>2]|0,13);KS(e);d4(c[h>>2]|0,13);KS(e);h=a[H>>0]|0}if((h<<24>>24!=2?a[e+880>>0]|0:0)?a[e+881>>0]|0:0)A6(c[e+648>>2]|0);h=e+648|0;A6(c[h>>2]|0);if(K6(c[h>>2]|0)|0){GC(e);A6(c[h>>2]|0);d4(c[h>>2]|0,8);J3(e);break}else{A6(c[h>>2]|0);break}}while(0);if((a[H>>0]|0)!=2){b:do if((a[e+882>>0]|0)==0?(a[e+865>>0]|0)==0:0){h=a[L>>0]|0;i=e+894|0;k=e+884|0;m=e+892|0;n=e+885|0;o=e+895|0;p=e+887|0;q=e+889|0;r=e+893|0;s=e+883|0;t=e+896|0;u=e+903|0;v=e+888|0;w=e+886|0;do if(!(h<<24>>24)){if(a[s>>0]|0)d4(c[e+648>>2]|0,8);if(a[k>>0]|0)d4(c[e+648>>2]|0,8);if(a[n>>0]|0)d4(c[e+648>>2]|0,8);if(a[w>>0]|0)d4(c[e+648>>2]|0,8);if(a[p>>0]|0)d4(c[e+648>>2]|0,8);if(a[v>>0]|0)d4(c[e+648>>2]|0,8);if(a[q>>0]|0)d4(c[e+648>>2]|0,8);if(a[m>>0]|0)d4(c[e+648>>2]|0,8);if(a[r>>0]|0)d4(c[e+648>>2]|0,8);if(a[i>>0]|0)d4(c[e+648>>2]|0,8);if(a[o>>0]|0)d4(c[e+648>>2]|0,8);if(a[t>>0]|0)d4(c[e+648>>2]|0,4);if(!(a[u>>0]|0))break;d4(c[e+648>>2]|0,8)}while(0);x=e+897|0;y=e+890|0;A=e+902|0;B=e+900|0;C=e+898|0;D=e+901|0;E=e+904|0;F=e+891|0;do if(h<<24>>24==1){if(a[s>>0]|0)d4(c[e+648>>2]|0,8);if(a[k>>0]|0)d4(c[e+648>>2]|0,8);if(a[n>>0]|0)d4(c[e+648>>2]|0,8);if(a[w>>0]|0)d4(c[e+648>>2]|0,8);if(a[p>>0]|0)d4(c[e+648>>2]|0,8);if(a[v>>0]|0)d4(c[e+648>>2]|0,8);if(a[q>>0]|0)d4(c[e+648>>2]|0,8);if(a[m>>0]|0)d4(c[e+648>>2]|0,8);if(a[r>>0]|0)d4(c[e+648>>2]|0,8);if(a[i>>0]|0)d4(c[e+648>>2]|0,8);if(a[o>>0]|0)d4(c[e+648>>2]|0,8);if(a[t>>0]|0)d4(c[e+648>>2]|0,4);if(a[y>>0]|0)d4(c[e+648>>2]|0,8);if(a[F>>0]|0)d4(c[e+648>>2]|0,8);if(a[x>>0]|0)d4(c[e+648>>2]|0,8);if(a[C>>0]|0)d4(c[e+648>>2]|0,8);if(a[B>>0]|0)d4(c[e+648>>2]|0,8);if(a[D>>0]|0)d4(c[e+648>>2]|0,8);if(a[A>>0]|0)d4(c[e+648>>2]|0,8);if(a[u>>0]|0)d4(c[e+648>>2]|0,8);if(!(a[E>>0]|0))break;d4(c[e+648>>2]|0,8)}while(0);G=e+899|0;switch(h<<24>>24){case 2:break;case 3:{if((a[I>>0]|0)!=1)break b;if(a[q>>0]|0)d4(c[e+648>>2]|0,8);if(a[m>>0]|0)d4(c[e+648>>2]|0,8);if(a[r>>0]|0)d4(c[e+648>>2]|0,8);if(a[i>>0]|0)d4(c[e+648>>2]|0,8);if(a[o>>0]|0)d4(c[e+648>>2]|0,8);if(a[t>>0]|0)d4(c[e+648>>2]|0,4);if(a[y>>0]|0)d4(c[e+648>>2]|0,8);if(a[F>>0]|0)d4(c[e+648>>2]|0,8);if(a[x>>0]|0)d4(c[e+648>>2]|0,8);if(a[C>>0]|0)d4(c[e+648>>2]|0,8);if(a[B>>0]|0)d4(c[e+648>>2]|0,8);if(a[D>>0]|0)d4(c[e+648>>2]|0,8);if(a[A>>0]|0)d4(c[e+648>>2]|0,8);if(!(a[G>>0]|0))break b;d4(c[e+648>>2]|0,8);break b}default:break b}if(a[s>>0]|0)d4(c[e+648>>2]|0,8);if(a[k>>0]|0)d4(c[e+648>>2]|0,8);if(a[n>>0]|0)d4(c[e+648>>2]|0,8);if(a[w>>0]|0)d4(c[e+648>>2]|0,8);if(a[p>>0]|0)d4(c[e+648>>2]|0,8);if(a[v>>0]|0)d4(c[e+648>>2]|0,8);if(a[q>>0]|0)d4(c[e+648>>2]|0,8);if(a[m>>0]|0)d4(c[e+648>>2]|0,8);if(a[r>>0]|0)d4(c[e+648>>2]|0,8);if(a[i>>0]|0)d4(c[e+648>>2]|0,8);if(a[o>>0]|0)d4(c[e+648>>2]|0,8);if(a[t>>0]|0)d4(c[e+648>>2]|0,4);if(a[y>>0]|0)d4(c[e+648>>2]|0,8);if(a[F>>0]|0)d4(c[e+648>>2]|0,8);if(a[x>>0]|0)d4(c[e+648>>2]|0,8);if(a[C>>0]|0)d4(c[e+648>>2]|0,8);if(a[B>>0]|0)d4(c[e+648>>2]|0,8);if(a[D>>0]|0)d4(c[e+648>>2]|0,8);if(a[A>>0]|0)d4(c[e+648>>2]|0,8);if(a[G>>0]|0)d4(c[e+648>>2]|0,8);if(a[u>>0]|0)d4(c[e+648>>2]|0,8);if(!(a[E>>0]|0))break;d4(c[e+648>>2]|0,8)}while(0);if((a[H>>0]|0)!=2?(J=e+648|0,d4(c[J>>2]|0,3),a[e+877>>0]|0):0){AT(e,K);A6(c[J>>2]|0);if(!(a[K>>0]|0)){K=e+812|0;c[K>>2]=(c[K>>2]|0)+1}else{K=e+808|0;c[K>>2]=(c[K>>2]|0)+1}}}}wK(e);n=199}while(0);do if((n|0)==199){c:do if(!(f<<24>>24)){L=e+804|0;c[L>>2]=(c[L>>2]|0)+1}else{f=e+788|0;i=e+792|0;switch(a[L>>0]|0){case 0:{L=e+784|0;c[L>>2]=(c[L>>2]|0)+1;c[f>>2]=0;c[i>>2]=0;break c}case 1:{c[f>>2]=(c[f>>2]|0)+1;c[i>>2]=0;break c}case 2:{h=(c[i>>2]|0)+1|0;c[i>>2]=h;f=e+796|0;if(h>>>0<=(c[f>>2]|0)>>>0)break c;c[f>>2]=h;break c}case 3:{L=e+800|0;c[L>>2]=(c[L>>2]|0)+1;c[i>>2]=0;break c}default:break c}}while(0);if(qO(e)|0){if((a[c[35236+(d[e+854>>0]<<2)>>2]>>0]|0)==0?(N=b[e+852>>1]|0,N<<16>>16):0){h=((((c[M>>2]&65535)*1e3|0)>>>0)/((N&65535)>>>0)|0)+((j&255)*1e3|0)|0;m=e+846|0;j=b[m>>1]|0;i=j<<16>>16==-1;j=j&65535;f=h;while(1){k=f&65535;if(i){f=h;break}if((k+500|0)>>>0<j>>>0)f=k+1e3|0;else break}h=f&65535;b[m>>1]=h;f=e+844|0;if((b[f>>1]|0)==-1)b[f>>1]=h;j=e+144|0;h=j;f=c[h>>2]|0;h=c[h+4>>2]|0;if(!((f|0)==-1&(h|0)==-1)){i=c[e+824>>2]|0;if(!i){f=-1;h=-1}else{M=UW(i|0,0,1e9,0)|0;N=g5(M|0,z|0,N&65535|0,0)|0;f=z0(N|0,z|0,f|0,h|0)|0;h=z}N=j;c[N>>2]=f;c[N+4>>2]=h}}HM(e)|0;s_(e);f=0;while(1){if((f&255)>=47)break;AR(e,f&255,0);f=f+1<<24>>24}AR(e,177,0);AR(e,179,0);AR(e,181,0);AR(e,182,0);h=O;f=c[h>>2]|0;h=c[h+4>>2]|0;if((f|0)==2&(h|0)==0)if(!(c[e+728>>2]&1)){W5(e);f=O;h=c[f+4>>2]|0;f=c[f>>2]|0}else{h=0;f=2}O=c[P+4>>2]|0;if(!(h>>>0<O>>>0|((h|0)==(O|0)?f>>>0<(c[P>>2]|0)>>>0:0))?(RA(e,1,-1)|0)==0:0){f=e+492|0;if(a[f>>0]|0){V5(e);break}t6(e);if(+g[(c[e+24>>2]|0)+136>>2]<1.0){if(!(a[f>>0]|0))Kl(e);y0(e,1048576,0)}}}}while(0);l=Q;return}function dc(f){f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0;F=l;l=l+48|0;g=F+39|0;m=F+38|0;D=F+24|0;x=F+12|0;y=F;k=F+36|0;q=f+960|0;r=f+968+3|0;p=f+964|0;if((a[r>>0]|0)<0){y7(c[q>>2]|0,0);c[p>>2]=0}else{y7(q,0);a[r>>0]=0}u=f+972|0;v=f+980+3|0;w=f+976|0;if((a[v>>0]|0)<0){y7(c[u>>2]|0,0);c[w>>2]=0}else{y7(u,0);a[v>>0]=0}h=f+856|0;a[g>>0]=a[h>>0]|0;a[m>>0]=0;Bx(f);A=f+648|0;A6(c[A>>2]|0);d4(c[A>>2]|0,8);i=f+859|0;C=f+863|0;j=f+860|0;if(((a[f+857>>0]|0)+31&255)<8){xR(f,4,h);xR(f,2,C);xR(f,4,m);B=f+877|0;AT(f,B);a[B>>0]=a[B>>0]^1;if((a[C>>0]|0)!=2?(AT(f,f+910|0),xR(f,2,f+866|0),xR(f,4,f+862|0),(a[C>>0]|0)==0):0){KS(f);sR(f,14,f+848|0);KS(f);sR(f,14,f+850|0);KS(f)}xR(f,4,i);if((a[i>>0]|0)==15){xR(f,8,j);xR(f,8,f+861|0)}xR(f,4,f+870|0);sR(f,15,D);KS(f);sR(f,15,x);KS(f);sR(f,15,y);KS(f);sR(f,3,k);d4(c[A>>2]|0,11);KS(f);d4(c[A>>2]|0,15);KS(f);c[f+836>>2]=(e[D>>1]<<15)+(e[x>>1]|0);c[f+840>>2]=(e[y>>1]<<3)+(e[k>>1]|0);AT(f,f+872|0);A6(c[A>>2]|0);wK(f);B=f+536|0;D=f+528|0;D=D_(c[B>>2]|0,c[B+4>>2]|0,c[D>>2]|0,c[D+4>>2]|0)|0;e1(f,D,z)}else{if(K6(c[A>>2]|0)|0){GC(f);A6(c[A>>2]|0);xR(f,4,g);d4(c[A>>2]|0,3);J3(f)}else A6(c[A>>2]|0);xR(f,4,i);if((a[i>>0]|0)==15){xR(f,8,j);xR(f,8,f+861|0)}if(K6(c[A>>2]|0)|0){GC(f);A6(c[A>>2]|0);xR(f,2,f+866|0);AT(f,f+872|0);if(K6(c[A>>2]|0)|0){GC(f);A6(c[A>>2]|0);sR(f,15,D);KS(f);sR(f,15,x);KS(f);sR(f,15,y);KS(f);sR(f,3,k);d4(c[A>>2]|0,11);KS(f);d4(c[A>>2]|0,15);KS(f);c[f+836>>2]=(e[D>>1]<<3)+(e[x>>1]|0);c[f+840>>2]=(e[y>>1]<<15)+(e[k>>1]|0);J3(f)}else A6(c[A>>2]|0);J3(f)}else A6(c[A>>2]|0);xR(f,2,C);t=(a[g>>0]|0)==1;a:do if((a[C>>0]|0)!=3|t)n=27;else{xR(f,4,m);switch(a[m>>0]|0){case 8:case 7:case 5:case 1:case 0:{n=27;break a}case 11:case 9:case 6:case 3:case 2:{s=2;break a}case 12:case 10:case 4:{s=3;break a}default:{s=0;break a}}}while(0);if((n|0)==27)s=1;KS(f);h=f+852|0;sR(f,16,h);i=f+855|0;g=1;j=0;while(1){if((j&255)>=17)break;if((e[h>>1]|0)>>>0<g>>>0)break;g=g<<1;j=j+1<<24>>24}a[i>>0]=j;KS(f);if(K6(c[A>>2]|0)|0){GC(f);A6(c[A>>2]|0);rR(f,a[i>>0]|0,f+824|0);J3(f)}else A6(c[A>>2]|0);switch(a[C>>0]|0){case 2:{do if(!t)if(K6(c[A>>2]|0)|0){GC(f);A6(c[A>>2]|0);d4(c[A>>2]|0,4);d4(c[A>>2]|0,5);d4(c[A>>2]|0,5);d4(c[A>>2]|0,5);d4(c[A>>2]|0,5);J3(f);break}else{A6(c[A>>2]|0);break}while(0);A6(c[A>>2]|0);break}case 0:{KS(f);sR(f,13,f+848|0);KS(f);sR(f,13,f+850|0);KS(f);n=39;break}default:n=39}if((n|0)==39){AT(f,f+877|0);A6(c[A>>2]|0);g=f+864|0;if(t)xR(f,1,g);else xR(f,2,g);switch(a[g>>0]|0){case 2:{n=44;break}case 1:{d4(c[A>>2]|0,13);KS(f);d4(c[A>>2]|0,13);KS(f);d4(c[A>>2]|0,13);KS(f);d4(c[A>>2]|0,13);KS(f);n=44;break}default:{}}if((n|0)==44?(xR(f,6,f+858|0),d4(c[A>>2]|0,2),A6(c[A>>2]|0),(a[g>>0]|0)!=2):0)A6(c[A>>2]|0);if(!t?a[C>>0]|0:0)A6(c[A>>2]|0);if(K6(c[A>>2]|0)|0){GC(f);A6(c[A>>2]|0);d4(c[A>>2]|0,4);xR(f,4,f+862|0);J3(f)}else A6(c[A>>2]|0);if((a[C>>0]|0)==3){A6(c[A>>2]|0);A6(c[A>>2]|0);A6(c[A>>2]|0)}o=f+906|0;yT(f,o);if(!(a[o>>0]|0))A6(c[A>>2]|0);else{GC(f);A6(c[A>>2]|0);o=f+873|0;AT(f,o);b:do if(!(a[o>>0]|0)){VU(D,382832);vF(q,D)|0;z5(D)}else{k=x+8+3|0;m=x+4|0;n=x+8+3|0;o=x+4|0;g=0;while(1){if((g&65535)>=64)break b;xR(f,8,D);h=a[D>>0]|0;if(!(h<<24>>24)){h=a[r>>0]|0;i=h<<24>>24<0;h=h&255;if(i)j=c[p>>2]|0;else j=h;if(j>>>0<2)break;if(i)h=c[p>>2]|0;lw(y,q,h+-2|0,2);p2(x,y);O0(y);while(1){if((g&65535)>=64)break;j=a[k>>0]|0;i=j<<24>>24<0;Ex(q,i?c[x>>2]|0:x,i?c[m>>2]|0:j&255)|0;g=g+1<<16>>16}z5(x);g=64}else{uU(x,h,16);h=a[n>>0]|0;i=c[o>>2]|0;if(((h<<24>>24<0?i:h&255)|0)==1){DW(x,0,42196)|0;h=a[n>>0]|0;i=c[o>>2]|0}j=h<<24>>24<0;Ex(q,j?c[x>>2]|0:x,j?i:h&255)|0;z5(x)}g=g+1<<16>>16}}while(0);r=f+874|0;AT(f,r);c:do if(!(a[r>>0]|0)){VU(D,382832);vF(u,D)|0;z5(D)}else{k=x+8+3|0;m=x+4|0;n=x+8+3|0;o=x+4|0;g=0;while(1){if((g&65535)>=64)break c;xR(f,8,D);h=a[D>>0]|0;if(!(h<<24>>24)){h=a[v>>0]|0;i=h<<24>>24<0;h=h&255;if(i)j=c[w>>2]|0;else j=h;if(j>>>0<2)break;if(i)h=c[w>>2]|0;lw(y,u,h+-2|0,2);p2(x,y);O0(y);while(1){if((g&65535)>=64)break;r=a[k>>0]|0;q=r<<24>>24<0;Ex(u,q?c[x>>2]|0:x,q?c[m>>2]|0:r&255)|0;g=g+1<<16>>16}z5(x);g=64}else{uU(x,h,16);h=a[n>>0]|0;i=c[o>>2]|0;if(((h<<24>>24<0?i:h&255)|0)==1){DW(x,0,42196)|0;h=a[n>>0]|0;i=c[o>>2]|0}r=h<<24>>24<0;Ex(u,r?c[x>>2]|0:x,r?i:h&255)|0;z5(x)}g=g+1<<16>>16}}while(0);d:do if((a[C>>0]|0)==3){i=f+875|0;j=f+876|0;h=0;while(1){if((h|0)==(s|0))break d;AT(f,i);e:do if(a[i>>0]|0){g=0;while(1){if((g&65535)>=64)break e;xR(f,8,D);if(!(a[D>>0]|0))break;else g=g+1<<16>>16}}while(0);AT(f,j);f:do if(a[j>>0]|0){g=0;while(1){if((g&65535)>=64)break f;xR(f,8,D);if(!(a[D>>0]|0))break;else g=g+1<<16>>16}}while(0);h=h+1|0}}while(0);J3(f)}if(!t)AT(f,f+871|0);y=f+882|0;AT(f,y);do if((a[y>>0]|0)==0?(B=f+865|0,xR(f,2,B),(d[B>>0]|0)<2):0){if(K6(c[A>>2]|0)|0){GC(f);A6(c[A>>2]|0);AT(f,f+883|0);AT(f,f+884|0);AT(f,f+885|0);AT(f,f+886|0);AT(f,f+887|0);AT(f,f+888|0);J3(f)}else A6(c[A>>2]|0);if(K6(c[A>>2]|0)|0){GC(f);A6(c[A>>2]|0);AT(f,f+889|0);AT(f,f+890|0);AT(f,f+891|0);AT(f,f+892|0);J3(f)}else A6(c[A>>2]|0);KS(f);if(K6(c[A>>2]|0)|0){GC(f);A6(c[A>>2]|0);AT(f,f+893|0);AT(f,f+894|0);AT(f,f+895|0);AT(f,f+896|0);J3(f)}else A6(c[A>>2]|0);if(K6(c[A>>2]|0)|0){GC(f);A6(c[A>>2]|0);AT(f,f+897|0);AT(f,f+898|0);AT(f,f+899|0);AT(f,f+900|0);AT(f,f+901|0);AT(f,f+902|0);J3(f)}else A6(c[A>>2]|0);KS(f);if((a[B>>0]|0)!=1)break;if(K6(c[A>>2]|0)|0){GC(f);A6(c[A>>2]|0);AT(f,f+903|0);AT(f,f+904|0);J3(f);break}else{A6(c[A>>2]|0);break}}while(0);A6(c[A>>2]|0);B=f+907|0;yT(f,B);if(!(a[B>>0]|0))A6(c[A>>2]|0);else{GC(f);A6(c[A>>2]|0);AT(f,f+908|0);J3(f)}if(!t){B=f+878|0;AT(f,B);if(a[B>>0]|0){d4(c[A>>2]|0,2);A6(c[A>>2]|0)}AT(f,f+879|0)}B=f+880|0;AT(f,B);if(a[B>>0]|0?(AT(f,D),d4(c[A>>2]|0,4),A6(c[A>>2]|0),d4(c[A>>2]|0,5),d4(c[A>>2]|0,5),d4(c[A>>2]|0,5),d4(c[A>>2]|0,5),AT(f,f+881|0),(a[C>>0]|0)==1&(a[D>>0]|0)==0):0){A6(c[A>>2]|0);A6(c[A>>2]|0);d4(c[A>>2]|0,5);d4(c[A>>2]|0,5);d4(c[A>>2]|0,5);d4(c[A>>2]|0,5)}}wK(f)}do if(!(a[C>>0]|0)){g=b[f+848>>1]|0;if(((g<<16>>16?(E=b[f+850>>1]|0,E<<16>>16):0)?!(+(g&65535)/+(E&65535)<.10000000149011612):0)?(((g&65535)/(E&65535)|0)&65535)<=10:0)break;t4(f)}while(0);if(qO(f)|0){HM(f)|0;s_(f);AR(f,178,0);AR(f,179,0);AR(f,182,0);g=0;while(1){if((g&255)>=31)break;AR(f,g&255,0);g=g+1<<24>>24}E=c[f+772>>2]|0;a[E+178>>0]=1;a[E+179>>0]=1;a[E+182>>0]=1;a[f+905>>0]=1;if(!(c[f+728>>2]&1))W5(f)}l=F;return}function ec(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;ba=l;l=l+32|0;S=ba+8|0;T=ba+14|0;U=ba+12|0;V=ba+18|0;W=ba+17|0;X=ba+4|0;Y=ba;Z=ba+16|0;_=b+528|0;i=_;h=c[i>>2]|0;i=c[i+4>>2]|0;m=z0(h|0,i|0,3,0)|0;f=z;x=b+536|0;k=x;j=c[k>>2]|0;k=c[k+4>>2]|0;a:do if(f>>>0<k>>>0|(f|0)==(k|0)&m>>>0<j>>>0){y=b+612|0;H=c[y>>2]|0;g=H+h|0;A=b+544|0;n=c[A>>2]|0;if((a[n+g>>0]&-64)<<24>>24!=-128){j3(b);break}o=a[n+(g+1)>>0]|0;R=o&255;M=(R&32|0)==0;N=(R&16|0)==0;O=(R&8|0)==0;P=(R&4|0)==0;Q=(R&2|0)==0;R=(R&1|0)==0;$=a[n+(g+2)>>0]|0;aa=_;c[aa>>2]=m;c[aa+4>>2]=f;$=z0($&255|0,0,m|0,f|0)|0;aa=z;if(aa>>>0>k>>>0|(aa|0)==(k|0)&$>>>0>j>>>0){c3(c[b+508>>2]|0,c[b+668>>2]|0);break}L=e&255;E=b+24|0;F=b+312|0;s=z0(h|0,i|0,8,0)|0;t=z;I=b+48|0;K=b+774|0;D=b+136|0;g=t>>>0>k>>>0|(t|0)==(k|0)&s>>>0>j>>>0;G=b+804|0;J=b+784|0;e=H+m|0;f=n+e|0;h=n+(e+4)|0;i=n+(e+3)|0;j=n+(e+2)|0;e=n+(e+1)|0;b:do switch((o&255)>>>6&3){case 2:{if(g){c3(c[b+508>>2]|0,c[b+668>>2]|0);break a}f=a[f>>0]|0;if(((f&-63)<<24>>24==1?(u=a[j>>0]|0,u&1):0)?(p=a[h>>0]|0,p&1):0){x=PZ(f&14|0,0,29)|0;C=z;A=PZ(d[e>>0]|0,0,22)|0;e=z;u=PZ(u&-2&255|0,0,14)|0;B=z;g=PZ(d[i>>0]|0,0,7)|0;f=z;y=XZ(p&255|0,0,1)|0;g=u|x|y|A|g;f=B|C|z|e|f;e=D;c[e>>2]=g;c[e+4>>2]=f;e=_;c[e>>2]=s;c[e+4>>2]=t;e=(c[E>>2]|0)+81|0;if(!(a[e>>0]|0)){E=c[F+4>>2]|0;F=E>>>0<0|(E|0)==0&(c[F>>2]|0)>>>0<16;E=z0(g|0,f|0,-9e4,-1)|0;C=z;if((C>>>0>1|(C|0)==1&E>>>0>4294787296)&F){a[e>>0]=1;v=17}}else v=17;if((v|0)==17)if(f>>>0>1|(f|0)==1&g>>>0>4294877296){g=D;c[g>>2]=0;c[g+4>>2]=0;g=0;f=0}j=c[G>>2]|0;if(a[j+(L*120|0)+118>>0]|0){i=j+(L*120|0)+80|0;e=i;h=c[e>>2]|0;e=c[e+4>>2]|0;if((h|0)==-1&(e|0)==-1){e=i;c[e>>2]=g;c[e+4>>2]=f;e=f;h=g}while(1){G=z0(g|0,f|0,0,1)|0;F=z;if(!(F>>>0<e>>>0|(F|0)==(e|0)&G>>>0<h>>>0))break;F=z0(g|0,f|0,0,2)|0;G=z;E=D;c[E>>2]=F;c[E+4>>2]=G;g=F;f=G}E=I;E=z0(c[E>>2]|0,c[E+4>>2]|0,H|0,0)|0;F=z;G=j+(L*120|0)+72|0;c[G>>2]=E;c[G+4>>2]=F;G=j+(L*120|0)+88|0;c[G>>2]=E;c[G+4>>2]=F;G=i;c[G>>2]=g;c[G+4>>2]=f;G=j+(L*120|0)+96|0;c[G>>2]=g;c[G+4>>2]=f}if(a[K>>0]|0?(w=j+(L*120|0)+117|0,a[w>>0]|0):0){H=z0(c[I>>2]|0,c[I+4>>2]|0,H|0,0)|0;I=z;K=j+(L*120|0)+40|0;c[K>>2]=H;c[K+4>>2]=I;K=j+(L*120|0)+56|0;c[K>>2]=H;c[K+4>>2]=I;K=j+(L*120|0)+48|0;c[K>>2]=g;c[K+4>>2]=f;L=j+(L*120|0)+64|0;c[L>>2]=g;c[L+4>>2]=f;a[w>>0]=0}vp(b,g,f,3);a[J>>0]=1;break b}j3(b);break a}case 3:{if(g){c3(c[b+508>>2]|0,c[b+668>>2]|0);break a}f=a[f>>0]|0;if(((f&-63)<<24>>24==1?(q=a[j>>0]|0,q&1):0)?(r=a[h>>0]|0,r&1):0){o=PZ(f&14|0,0,29)|0;w=z;p=PZ(d[e>>0]|0,0,22)|0;g=z;q=PZ(q&-2&255|0,0,14)|0;u=z;e=PZ(d[i>>0]|0,0,7)|0;f=z;r=XZ(r&255|0,0,1)|0;e=q|o|r|p|e;f=u|w|z|g|f;g=D;c[g>>2]=e;c[g+4>>2]=f;g=_;c[g>>2]=s;c[g+4>>2]=t;g=(c[E>>2]|0)+81|0;if(!(a[g>>0]|0)){w=F;u=c[w+4>>2]|0;w=u>>>0<0|(u|0)==0&(c[w>>2]|0)>>>0<16;u=z0(e|0,f|0,-9e4,-1)|0;t=z;if((t>>>0>1|(t|0)==1&u>>>0>4294787296)&w){a[g>>0]=1;v=39}else g=e}else v=39;if((v|0)==39)if(f>>>0>1|(f|0)==1&e>>>0>4294877296){g=D;c[g>>2]=0;c[g+4>>2]=0;g=0;f=0}else g=e;j=c[G>>2]|0;if(a[j+(L*120|0)+118>>0]|0){i=j+(L*120|0)+80|0;e=i;h=c[e>>2]|0;e=c[e+4>>2]|0;if((h|0)==-1&(e|0)==-1){e=i;c[e>>2]=g;c[e+4>>2]=f;e=f;h=g}while(1){w=z0(g|0,f|0,0,1)|0;v=z;if(!(v>>>0<e>>>0|(v|0)==(e|0)&w>>>0<h>>>0))break;v=z0(g|0,f|0,0,2)|0;w=z;u=D;c[u>>2]=v;c[u+4>>2]=w;g=v;f=w}w=I;w=z0(c[w>>2]|0,c[w+4>>2]|0,H|0,0)|0;D=j+(L*120|0)+72|0;c[D>>2]=w;c[D+4>>2]=z;D=i;c[D>>2]=g;c[D+4>>2]=f}if(a[K>>0]|0?a[j+(L*120|0)+117>>0]|0:0){D=I;D=z0(c[D>>2]|0,c[D+4>>2]|0,H|0,0)|0;H=j+(L*120|0)+40|0;c[H>>2]=D;c[H+4>>2]=z;H=j+(L*120|0)+48|0;c[H>>2]=g;c[H+4>>2]=f}vp(b,g,f,1);h=_;f=c[h>>2]|0;h=z0(f|0,c[h+4>>2]|0,5,0)|0;i=z;H=x;D=c[H+4>>2]|0;if(i>>>0>D>>>0|((i|0)==(D|0)?h>>>0>(c[H>>2]|0)>>>0:0)){c3(c[b+508>>2]|0,c[b+668>>2]|0);break a}m=c[y>>2]|0;e=m+f|0;f=c[A>>2]|0;g=a[f+e>>0]|0;if(((g&-63)<<24>>24==1?(B=a[f+(e+2)>>0]|0,B&1):0)?(C=a[f+(e+4)>>0]|0,C&1):0){y=PZ(g&14|0,0,29)|0;H=z;A=PZ(d[f+(e+1)>>0]|0,0,22)|0;k=z;B=PZ(B&-2&255|0,0,14)|0;D=z;e=PZ(d[f+(e+3)>>0]|0,0,7)|0;g=z;f=XZ(C&255|0,0,1)|0;e=B|y|f|A|e;g=D|H|z|k|g;k=b+144|0;H=k;c[H>>2]=e;c[H+4>>2]=g;H=_;c[H>>2]=h;c[H+4>>2]=i;H=F;F=c[H+4>>2]|0;f=(c[E>>2]|0)+81|0;h=a[f>>0]|0;do if(F>>>0<0|(F|0)==0&(c[H>>2]|0)>>>0<16){if(g>>>0>0|(g|0)==0&e>>>0>4294967295){e=k;c[e>>2]=0;c[e+4>>2]=0;e=0;g=0}H=z0(e|0,g|0,-9e4,-1)|0;F=z;if(!(h<<24>>24==0&(F>>>0>1|(F|0)==1&H>>>0>4294787296)))break;a[f>>0]=1}else{if(!((g>>>0>1|(g|0)==1&e>>>0>4294877296)&h<<24>>24!=0))break;e=k;c[e>>2]=0;c[e+4>>2]=0;e=0;g=0}while(0);j=c[G>>2]|0;if(a[j+(L*120|0)+118>>0]|0){i=j+(L*120|0)+96|0;f=i;h=c[f>>2]|0;f=c[f+4>>2]|0;if((h|0)==-1&(f|0)==-1){f=i;c[f>>2]=e;c[f+4>>2]=g;f=g;h=e}while(1){H=z0(e|0,g|0,0,1)|0;G=z;if(!(G>>>0<f>>>0|(G|0)==(f|0)&H>>>0<h>>>0))break;G=z0(e|0,g|0,0,2)|0;H=z;F=k;c[F>>2]=G;c[F+4>>2]=H;e=G;g=H}H=I;H=z0(c[H>>2]|0,c[H+4>>2]|0,m|0,0)|0;I=j+(L*120|0)+88|0;c[I>>2]=H;c[I+4>>2]=z;I=i;c[I>>2]=e;c[I+4>>2]=g}do if(a[K>>0]|0){f=j+(L*120|0)+117|0;if(!(a[f>>0]|0))break;L=j+(L*120|0)+64|0;c[L>>2]=e;c[L+4>>2]=g;a[f>>0]=0}while(0);vp(b,e,g,2);a[J>>0]=1;break b}j3(b);break a}j3(b);break a}default:if(!(a[b+760>>0]|0))a[b+749>>0]=0}while(0);if(!M?(M=_,L=c[M+4>>2]|0,L>>>0<aa>>>0|((L|0)==(aa|0)?(c[M>>2]|0)>>>0<$>>>0:0)):0){GC(b);Bx(b);d4(c[b+648>>2]|0,2);xR(b,3,V);KS(b);sR(b,15,S);KS(b);sR(b,15,T);KS(b);sR(b,15,U);KS(b);wK(b);J3(b)}if(!N?(N=_,M=c[N+4>>2]|0,M>>>0<aa>>>0|((M|0)==(aa|0)?(c[N>>2]|0)>>>0<$>>>0:0)):0){GC(b);Bx(b);KS(b);rR(b,22,S);KS(b);wK(b);J3(b)}if(!O?(O=_,N=c[O+4>>2]|0,N>>>0<aa>>>0|((N|0)==(aa|0)?(c[O>>2]|0)>>>0<$>>>0:0)):0){GC(b);Bx(b);xR(b,3,S);switch(a[S>>0]|0){case 0:{O=b+648|0;d4(c[O>>2]|0,2);A6(c[O>>2]|0);d4(c[O>>2]|0,2);break}case 1:{xR(b,5,T);break}case 2:{O=b+648|0;d4(c[O>>2]|0,2);d4(c[O>>2]|0,3);break}case 3:{O=b+648|0;d4(c[O>>2]|0,2);A6(c[O>>2]|0);d4(c[O>>2]|0,2);break}case 4:{xR(b,5,T);break}default:d4(c[b+648>>2]|0,5)}wK(b);J3(b)}if(!P?(P=_,O=c[P+4>>2]|0,O>>>0<aa>>>0|((O|0)==(aa|0)?(c[P>>2]|0)>>>0<$>>>0:0)):0){GC(b);Bx(b);KS(b);d4(c[b+648>>2]|0,7);wK(b);J3(b)}if(!Q?(Q=_,P=c[Q+4>>2]|0,P>>>0<aa>>>0|((P|0)==(aa|0)?(c[Q>>2]|0)>>>0<$>>>0:0)):0){GC(b);P=_;P=z0(c[P>>2]|0,c[P+4>>2]|0,2,0)|0;Q=_;c[Q>>2]=P;c[Q+4>>2]=z;J3(b)}if(!R?(R=_,Q=c[R+4>>2]|0,Q>>>0<aa>>>0|((Q|0)==(aa|0)?(c[R>>2]|0)>>>0<$>>>0:0)):0){a[S>>0]=0;a[T>>0]=0;a[U>>0]=0;a[V>>0]=0;a[W>>0]=0;GC(b);Bx(b);AT(b,S);AT(b,T);AT(b,U);AT(b,V);o=b+648|0;d4(c[o>>2]|0,3);AT(b,W);wK(b);r=_;f=a[S>>0]|0;p=f<<24>>24!=0;r=z0((p?16:0)|0,(p?0:0)|0,c[r>>2]|0,c[r+4>>2]|0)|0;p=a[T>>0]|0;r=z0(r|0,z|0,p&255|0,0)|0;q=a[U>>0]|0;s=q<<24>>24!=0;s=z0(r|0,z|0,(s?2:0)|0,(s?0:0)|0)|0;r=a[V>>0]|0;Q=r<<24>>24!=0;Q=z0(s|0,z|0,(Q?2:0)|0,(Q?0:0)|0)|0;s=a[W>>0]|0;R=s<<24>>24!=0;R=z0(Q|0,z|0,(R?2:0)|0,(R?0:0)|0)|0;Q=z;if(!(Q>>>0>aa>>>0|(Q|0)==(aa|0)&R>>>0>$>>>0)){if(f<<24>>24){GC(b);aH(b,X);do if((c[X>>2]|0)==1128483155){h=b+785|0;i=d[h>>0]|0;j=b+816|0;k=c[j>>2]|0;m=k+(i*120|0)+28|0;n=k+(i*120|0)+32|0;f=c[n>>2]|0;W=c[m>>2]|0;g=W;e=k+(i*120|0)+104|0;if(f-W>>2>>>0<=1){if(c[e>>2]|0)break}else{while(1){if((f|0)==(g|0))break;W=f+-4|0;c[n>>2]=W;f=W}c[e>>2]=0}f=IJ(b)|0;c[Y>>2]=f;g=c[n>>2]|0;if(g>>>0<(c[k+(i*120|0)+36>>2]|0)>>>0){c[g>>2]=f;c[n>>2]=(c[n>>2]|0)+4}else Yy(m,Y);aY(b,c[c[(c[j>>2]|0)+((d[h>>0]|0)*120|0)+28>>2]>>2]|0);W=(c[j>>2]|0)+((d[h>>0]|0)*120|0)+104|0;c[W>>2]=(c[W>>2]|0)+1}while(0);V=_;V=z0(c[V>>2]|0,c[V+4>>2]|0,16,0)|0;W=_;c[W>>2]=V;c[W+4>>2]=z;J3(b)}if(p<<24>>24){GC(b);bB(b,X);e1(b,d[X>>0]|0,0);J3(b)}if(q<<24>>24){GC(b);Bx(b);KS(b);xR(b,7,X);KS(b);AT(b,Z);xR(b,6,Y);wK(b);J3(b)}if(r<<24>>24){GC(b);Bx(b);RS(b);A6(c[o>>2]|0);AT(b,X);d4(c[o>>2]|0,13);wK(b);J3(b)}if(s<<24>>24){GC(b);Bx(b);KS(b);xR(b,7,X);AT(b,Y);if(!(a[Y>>0]|0))xR(b,7,b+856|0);wK(b);f=a[X>>0]|0;if((f&255)>1){Z=(f&255)+-1|0;e1(b,Z,((Z|0)<0)<<31>>31)}J3(b)}}else{a[S>>0]=0;a[T>>0]=0;a[U>>0]=0;a[V>>0]=0;a[W>>0]=0}J3(b)}g=_;f=c[g>>2]|0;g=c[g+4>>2]|0;if(aa>>>0>g>>>0|(aa|0)==(g|0)&$>>>0>f>>>0){aa=D_($|0,aa|0,f|0,g|0)|0;e1(b,aa,z)}}else t4(b);while(0);l=ba;return}function fc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+32|0;n=u+12|0;o=u;t=b+800|0;do if(!((c[t>>2]|0)==-1?(c[t+4>>2]|0)==-1:0)?(q=b+840|0,t=q,!((c[t>>2]|0)==-1?(c[t+4>>2]|0)==-1:0)):0){r=b+784|0;s=b+792+3|0;d=a[s>>0]|0;t=b+788|0;if(d<<24>>24<0)d=c[t>>2]|0;else d=d&255;if(d|0?(e=b+760|0,(c[(kE(e,q)|0)+32>>2]|0)==0):0){d=b+16|0;p=c[d>>2]|0;m=b+20|0;j=c[m>>2]|0;$x(n,b,p,j,Rb(p,12)|0,1);p=a[n+8+3>>0]|0;p=((p<<24>>24<0?c[n+4>>2]|0:p&255)|0)==0;z5(n);if(p){Rf(b,r,c[d>>2]|0,c[m>>2]|0,0);p=c[d>>2]|0;j=c[m>>2]|0;zb(b,p,j,Rb(p,17)|0,r,0)}p=kE(e,q)|0;g=b+796|0;h=Aj(c[d>>2]|0,c[g>>2]|0,r,1)|0;d=i9(29448)|0;i=h+8+3|0;f=a[i>>0]|0;j=h+4|0;e=c[j>>2]|0;p=p+32|0;do if((d|0)==((f<<24>>24<0?e:f&255)|0))if(!(VG(h,29448,d)|0)){o=ZW(1040)|0;_z(o);c[p>>2]=o;a[o+768>>0]=1;break}else{f=a[i>>0]|0;e=c[j>>2]|0;k=14;break}else k=14;while(0);a:do if((k|0)==14){d=i9(39980)|0;do if((d|0)==((f<<24>>24<0?e:f&255)|0)){if(VG(h,39980,d)|0){f=a[i>>0]|0;e=c[j>>2]|0;break}d=ZW(1056)|0;Mr(d);c[p>>2]=d;a[d+768>>0]=1;if(c[g>>2]|0)break a;a[d+733>>0]=0;a[d+769>>0]=1;a[d+770>>0]=1;break a}while(0);d=i9(24480)|0;do if((d|0)==((f<<24>>24<0?e:f&255)|0)){if(VG(h,24480,d)|0){f=a[i>>0]|0;e=c[j>>2]|0;break}d=ZW(960)|0;Vw(d);c[p>>2]=d;a[d+768>>0]=1;if(c[g>>2]|0)break a;a[d+733>>0]=0;a[d+769>>0]=1;a[d+770>>0]=1;a[d+772>>0]=1;break a}while(0);d=i9(30008)|0;do if((d|0)==((f<<24>>24<0?e:f&255)|0))if(!(VG(h,30008,d)|0)){o=ZW(920)|0;Wv(o);c[p>>2]=o;a[o+768>>0]=1;break a}else{f=a[i>>0]|0;e=c[j>>2]|0;break}while(0);d=i9(29964)|0;do if((d|0)==((f<<24>>24<0?e:f&255)|0))if(!(VG(h,29964,d)|0)){o=ZW(1104)|0;ln(o);c[p>>2]=o;a[o+776>>0]=1;break a}else{f=a[i>>0]|0;e=c[j>>2]|0;break}while(0);d=i9(20724)|0;do if((d|0)==((f<<24>>24<0?e:f&255)|0))if(!(VG(h,20724,d)|0)){o=ZW(768)|0;GU(o);c[p>>2]=o;break a}else{f=a[i>>0]|0;e=c[j>>2]|0;break}while(0);d=i9(20740)|0;if((d|0)==((f<<24>>24<0?e:f&255)|0)){if(VG(h,20740,d)|0){f=a[i>>0]|0;e=c[j>>2]|0;k=39}}else k=39;do if((k|0)==39){d=i9(29668)|0;if((d|0)==((f<<24>>24<0?e:f&255)|0)){if(!(VG(h,29668,d)|0))break;f=a[i>>0]|0;e=c[j>>2]|0}d=i9(39840)|0;if((d|0)==((f<<24>>24<0?e:f&255)|0)){if(VG(h,39840,d)|0){f=a[i>>0]|0;e=c[j>>2]|0;k=46}}else k=46;do if((k|0)==46){d=i9(39812)|0;if((d|0)==((f<<24>>24<0?e:f&255)|0)){if(!(VG(h,39812,d)|0))break;f=a[i>>0]|0;e=c[j>>2]|0}d=i9(20768)|0;if((d|0)==((f<<24>>24<0?e:f&255)|0)){if(!(VG(h,20768,d)|0))break;f=a[i>>0]|0;e=c[j>>2]|0}d=i9(29616)|0;do if((d|0)==((f<<24>>24<0?e:f&255)|0)){if(VG(h,29616,d)|0)break;o=ZW(1256)|0;uw(o);c[p>>2]=o;break a}while(0);d=i9(20796)|0;e=a[s>>0]|0;do if((d|0)==((e<<24>>24<0?c[t>>2]|0:e&255)|0))if(!(VG(r,20796,d)|0)){o=ZW(22152)|0;Dt(o);c[p>>2]=o;c[o+908>>2]=1;break a}else{e=a[s>>0]|0;break}while(0);if(e<<24>>24<0){f=c[r>>2]|0;e=c[t>>2]|0}else{f=r;e=e&255}d=i9(20596)|0;do if(d|0){g=f+(e<<2)|0;k=HA(f,g,20596,20596+(d<<2)|0)|0;if((k|0)!=(g|0)&(k|0)==(f|0))break;d=i9(29652)|0;e=a[i>>0]|0;f=c[j>>2]|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(h,29652,d)|0)){o=ZW(22152)|0;Dt(o);c[p>>2]=o;c[o+908>>2]=4;break a}else{e=a[i>>0]|0;f=c[j>>2]|0;break}while(0);d=i9(40168)|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(h,40168,d)|0)){o=ZW(1128)|0;Wr(o);c[p>>2]=o;break a}else{e=a[i>>0]|0;f=c[j>>2]|0;break}while(0);d=i9(21732)|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0)){if(VG(h,21732,d)|0)break;o=ZW(896)|0;uW(o);c[p>>2]=o;break a}while(0);d=a[s>>0]|0;if(d<<24>>24<0){f=c[r>>2]|0;e=c[t>>2]|0}else{f=r;e=d&255}d=i9(21752)|0;do if(d|0){n=f+(e<<2)|0;o=HA(f,n,21752,21752+(d<<2)|0)|0;if((o|0)!=(n|0)&(o|0)==(f|0))break;d=i9(21780)|0;o=a[i>>0]|0;if((d|0)!=((o<<24>>24<0?c[j>>2]|0:o&255)|0))break a;if(VG(h,21780,d)|0)break a;o=ZW(960)|0;YE(o);c[p>>2]=o;a[o+904>>0]=1;break a}while(0);o=ZW(768)|0;c2(o);c[p>>2]=o;break a}while(0);TX(n);d=i9(20820)|0;e=a[s>>0]|0;f=c[t>>2]|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(r,20820,d)|0)){Xy(o,24160);vF(n,o)|0;z5(o);e=1;f=382769;g=2;d=2;k=112;break}else{e=a[s>>0]|0;f=c[t>>2]|0;k=69;break}else k=69;while(0);b:do if((k|0)==69){d=i9(20888)|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(r,20888,d)|0)){Xy(o,20948);vF(n,o)|0;z5(o);e=2;f=382769;g=2;d=0;k=112;break b}else{e=a[s>>0]|0;f=c[t>>2]|0;break}while(0);d=i9(20960)|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(r,20960,d)|0)){Xy(o,21036);vF(n,o)|0;z5(o);e=2;f=382769;g=2;d=1;k=112;break b}else{e=a[s>>0]|0;f=c[t>>2]|0;break}while(0);d=i9(21084)|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(r,21084,d)|0)){Xy(o,21148);vF(n,o)|0;z5(o);e=3;f=382769;g=2;d=2;k=112;break b}else{e=a[s>>0]|0;f=c[t>>2]|0;break}while(0);d=i9(21164)|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(r,21164,d)|0)){Xy(o,24160);vF(n,o)|0;z5(o);e=1;f=373744;g=2;d=2;k=112;break b}else{e=a[s>>0]|0;f=c[t>>2]|0;break}while(0);d=i9(21232)|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(r,21232,d)|0)){Xy(o,20948);vF(n,o)|0;z5(o);e=2;f=373744;g=2;d=0;k=112;break b}else{e=a[s>>0]|0;f=c[t>>2]|0;break}while(0);d=i9(21292)|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(r,21292,d)|0)){Xy(o,21036);vF(n,o)|0;z5(o);e=2;f=373744;g=0;d=1;k=112;break b}else{e=a[s>>0]|0;f=c[t>>2]|0;break}while(0);d=i9(21368)|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(r,21368,d)|0)){Xy(o,21456);vF(n,o)|0;z5(o);e=2;f=373744;g=1;d=1;k=112;break b}else{e=a[s>>0]|0;f=c[t>>2]|0;break}while(0);d=i9(21548)|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(r,21548,d)|0)){Xy(o,21148);vF(n,o)|0;z5(o);e=3;f=373744;g=2;d=2;k=112;break b}else{e=a[s>>0]|0;f=c[t>>2]|0;break}while(0);d=i9(21612)|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(r,21612,d)|0)){Xy(o,21676);vF(n,o)|0;z5(o);e=4;f=373744;g=2;d=2;k=112;break b}else{e=a[s>>0]|0;f=c[t>>2]|0;break}while(0);d=i9(21692)|0;do if((d|0)==((e<<24>>24<0?f:e&255)|0))if(!(VG(r,21692,d)|0)){Xy(o,20948);vF(n,o)|0;z5(o);e=2;f=2;d=2;break b}else{e=a[s>>0]|0;f=c[t>>2]|0;break}while(0);d=i9(21712)|0;if((d|0)!=((e<<24>>24<0?f:e&255)|0)){e=0;f=2;d=2;break}if(VG(r,21712,d)|0){e=0;f=2;d=2;break}Xy(o,21036);vF(n,o)|0;z5(o);e=2;f=0;d=1}while(0);if((k|0)==112){RB(b,2,c[m>>2]|0,23,f,-1,1,0);f=g}zb(b,2,c[m>>2]|0,24,n,0);if(d<<24>>24!=2)RB(b,2,c[m>>2]|0,28,d<<24>>24?382808:382840,-1,1,0);if(f<<24>>24!=2)RB(b,2,c[m>>2]|0,30,f<<24>>24?382808:382840,-1,1,0);$x(o,b,2,c[m>>2]|0,135,1);j=tm(o)|0;k=z;z5(o);i=ZW(22152)|0;Dt(i);c[p>>2]=i;c[i+908>>2]=1;m=d<<24>>24==1;o=f<<24>>24==1;Jb(i,j,k,e,m,o,m,o);z5(n);break a}while(0);o=ZW(1584)|0;on(o);c[p>>2]=o;break a}while(0);o=ZW(808)|0;MG(o);c[p>>2]=o;a[o+733>>0]=0;a[o+761>>0]=1}while(0);n=q;o=c[n+4>>2]|0;q=b+520|0;c[q>>2]=c[n>>2];c[q+4>>2]=o;aY(b,c[p>>2]|0);if((a[s>>0]|0)<0){y7(c[r>>2]|0,0);c[t>>2]=0;break}else{y7(r,0);a[s>>0]=0;break}}}while(0);l=u;return}function gc(f,h){f=f|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,P=0,Q=0,R=0,S=0,T=0;T=l;l=l+112|0;K=h;Q=T+96|0;R=T+84|0;S=T+72|0;N=T+36|0;H=T+60|0;I=T+48|0;P=T+12|0;J=T+24|0;M=T;k=c[h>>2]|0;F=(c[k+4>>2]<<4)+16|0;m=a[k+51>>0]|0;D=2-(m&255)|0;n=O(D,(c[k+8>>2]<<4)+16|0)|0;C=i$(k)|0;C=(C&255)>3?0:C&255;D=O(D,d[381124+C>>0]|0)|0;C=F-(O((c[k+16>>2]|0)+(c[k+12>>2]|0)|0,d[381120+C>>0]|0)|0)|0;D=n-(O(D,(c[k+24>>2]|0)+(c[k+20>>2]|0)|0)|0)|0;n=c[k>>2]|0;F=f+20|0;E=f+1045|0;if(n){do if(a[n+26>>0]|0){i=a[n+20>>0]|0;if((i&255)<17){q=+g[33524+((i&255)<<2)>>2];break}if(i<<24>>24==-1?(j=b[n+18>>1]|0,j<<16>>16!=0):0)q=+(e[n+16>>1]|0)/+(j&65535);else q=1.0}else q=1.0;while(0);do if(a[n+29>>0]|0){if(!(a[n+30>>0]|0)){RB(f,1,c[F>>2]|0,167,380821,-1,1,0);break}j=c[n+12>>2]|0;if(j|0?(o=c[n+8>>2]|0,o|0):0){if(!(m<<24>>24))i=(a[k+44>>0]|0)==2?1:2;else i=2;KW(f,1,c[F>>2]|0,171,+(j>>>0)/+(o>>>0)/+(i|0)/+(d[E>>0]|0),3,0)}}while(0);i=a[f+1046>>0]|0;if(i<<24>>24!=2)RB(f,1,0,332,Zx(i)|0,-1,1,0);i=c[c[h>>2]>>2]|0;if(a[i+27>>0]|0){RB(f,1,0,187,c[33592+(d[i+21>>0]<<2)>>2]|0,-1,1,0);RB(f,1,0,329,c[33624+(d[(c[c[h>>2]>>2]|0)+22>>0]<<2)>>2]|0,-1,1,0);i=c[c[h>>2]>>2]|0;if(a[i+28>>0]|0){RB(f,1,0,330,382808,-1,1,0);RB(f,1,0,331,mD(a[(c[c[h>>2]>>2]|0)+23>>0]|0)|0,-1,1,0);RB(f,1,0,332,Zx(a[(c[c[h>>2]>>2]|0)+24>>0]|0)|0,-1,1,0);RB(f,1,0,333,SA(a[(c[c[h>>2]>>2]|0)+25>>0]|0)|0,-1,1,0);i=c[c[h>>2]>>2]|0;j=a[i+25>>0]|0;if(j<<24>>24!=2){RB(f,1,0,191,ZT(j)|0,-1,1,1);i=c[c[h>>2]>>2]|0}}}z=c[i>>2]|0;if(!z){n=1;o=0;m=0;k=1;j=-1;s=-1}else{y=z+4|0;i=c[z>>2]|0;n=i;x=0;v=1;w=0;m=0;A=1;o=n;j=-1;B=-1;while(1){u=m&1;p=w&1;if(x>>>0>=(((c[y>>2]|0)-i|0)/24|0)>>>0)break;k=o+(x*24|0)+8|0;i=c[k>>2]|0;k=c[k+4>>2]|0;if(!((i|0)==-1&(k|0)==0)){oK(f,1,0,328,i,k,10,0);n=c[z>>2]|0;o=n}r=(j|0)==-1&(B|0)==-1;t=o+(x*24|0)|0;s=c[t>>2]|0;t=c[t+4>>2]|0;if(!(p<<24>>24)){i=v;k=1;m=a[n+(x*24|0)+16>>0]|0;o=n}else{i=u<<24>>24==(a[o+(x*24|0)+16>>0]|0)?v:0;k=w}x=x+1|0;v=i;w=k;A=r|(j|0)==(s|0)&(B|0)==(t|0)?A:0;i=o;j=r?s:j;B=r?t:B}n=(v&1)!=0;o=p<<24>>24!=0;m=u<<24>>24!=0;k=(A&1)!=0;i=c[c[h>>2]>>2]|0;s=B}x=c[i+4>>2]|0;a:do if(!x)i=s;else{y=x+4|0;p=c[x>>2]|0;w=0;r=p;i=s;while(1){if(w>>>0>=(((c[y>>2]|0)-r|0)/24|0)>>>0)break a;t=p+(w*24|0)+8|0;oK(f,1,0,328,c[t>>2]|0,c[t+4>>2]|0,10,0);t=(j|0)==-1&(i|0)==-1;s=c[x>>2]|0;v=s+(w*24|0)|0;u=c[v>>2]|0;v=c[v+4>>2]|0;p=a[s+(w*24|0)+16>>0]|0;if(o)n=n&(m&1|0)==(p&255|0);else m=p<<24>>24!=0;w=w+1|0;o=1;k=k&(t|(j|0)==(u|0)&(i|0)==(v|0));r=s;p=s;j=t?u:j;i=t?v:i}}while(0);if(o&n?(RB(f,1,0,118,m?384431:384435,-1,1,0),!((j|0)==-1&(i|0)==-1|k^1)):0)oK(f,1,0,m?124:126,j,i,10,0)}else q=1.0;if(!(RA(f,1,-1)|0))Kc(f,1,-1)|0;RB(f,1,0,18,391410,-1,1,0);RB(f,1,0,58,391410,-1,1,0);TX(R);p2(Q,cC(R,Fz(a[(c[h>>2]|0)+39>>0]|0)|0)|0);z5(R);i=c[h>>2]|0;switch(a[i+39>>0]|0){case -12:case 122:case 110:case 100:case 44:{if(a[i+48>>0]|0)HX(Q,34576)|0;break}default:{}}TX(S);i=a[(c[h>>2]|0)+40>>0]|0;io(S,+(i&255)/10.0,((i&255)%10|0)<<24>>24!=0&1)|0;ms(R,39996,S);i=a[R+8+3>>0]|0;B=i<<24>>24<0;Ex(Q,B?c[R>>2]|0:R,B?c[R+4>>2]|0:i&255)|0;O0(R);z5(S);zb(f,1,0,24,Q,0);zb(f,1,0,64,Q,0);lL(f,1,c[F>>2]|0,130,C,10,0);lL(f,1,c[F>>2]|0,138,D,10,0);i=c[h>>2]|0;if(!((c[i+12>>2]|0)==0?(c[i+16>>2]|0)==0:0)){lL(f,1,c[F>>2]|0,146,(c[i+4>>2]<<4)+16|0,10,0);i=c[h>>2]|0}if(!((c[i+20>>2]|0)==0?!(c[i+24>>2]|0):0))lL(f,1,c[F>>2]|0,147,O(2-(d[i+51>>0]|0)|0,(c[i+8>>2]<<4)+16|0)|0,10,0);KW(f,1,0,150,q,3,1);KW(f,1,0,156,+(C>>>0)*q/+(D>>>0),3,1);i=a[E>>0]|0;if(i<<24>>24==2){RB(f,1,c[F>>2]|0,46,380825,-1,1,0);RB(f,1,c[F>>2]|0,31,380825,-1,1,0);i=a[E>>0]|0}if(i<<24>>24==3){RB(f,1,c[F>>2]|0,46,380840,-1,1,0);RB(f,1,c[F>>2]|0,31,380840,-1,1,0)}i=c[h>>2]|0;j=f+932|0;if((a[i+52>>0]|0)!=0?(c[j>>2]|0)!=0:0){RB(f,1,0,197,380855,-1,1,0);RB(f,1,0,211,380855,-1,1,0)}else L=60;b:do if((L|0)==60){if((a[i+51>>0]|0)==0?(G=(c[f+928>>2]|0)==0,!((c[j>>2]|0)!=0&G)):0){if(G)break;RB(f,1,0,197,384063,-1,1,0);RB(f,1,0,211,384063,-1,1,0);break}switch(a[i+47>>0]|0){case 3:{RB(f,1,0,197,384063,-1,1,0);RB(f,1,0,211,384074,-1,1,0);RB(f,1,0,48,384015,-1,1,0);RB(f,1,0,201,380861,-1,1,0);break b}case 4:{RB(f,1,0,197,384063,-1,1,0);RB(f,1,0,211,384078,-1,1,0);RB(f,1,0,48,384015,-1,1,0);RB(f,1,0,201,380861,-1,1,0);break b}default:{RB(f,1,0,197,384051,-1,1,0);RB(f,1,0,211,383620,-1,1,0);break b}}}while(0);c[R>>2]=0;c[R+4>>2]=0;c[R+8>>2]=0;i=0;while(1){if((i|0)==3)break;c[R+(i<<2)>>2]=0;i=i+1|0}wz(S,f+1020|0);m=f+784|0;n=f+788|0;Fp(R,(c[n>>2]|0)-(c[m>>2]|0)>>2);o=S+11|0;p=S+4|0;k=0;while(1){i=c[m>>2]|0;if(k>>>0>=(c[n>>2]|0)-i>>2>>>0)break;i=c[i+(k<<2)>>2]|0;j=(k&1|0)==0;if(!i){G=a[o>>0]|0;if((G<<24>>24<0?c[p>>2]|0:G&255)|0?(gy(R,32),j):0)gy(S,32)}else{gy(R,a[i+5>>0]|0?84:66);if(j)JX(S,c[33756+(d[(c[(c[m>>2]|0)+(k<<2)>>2]|0)+4>>0]<<2)>>2]|0)|0}k=k+1|0}wz(H,R);vf(N,H);bw(f,1,0,204,N,1,0);a1(N);a1(H);wz(I,R);vf(N,I);a1(I);I=a[N+11>>0]|0;c:do if(!((I<<24>>24<0?c[N+4>>2]|0:I&255)|0))switch(a[(c[h>>2]|0)+47>>0]|0){case 1:{c[P>>2]=0;c[P+4>>2]=0;c[P+8>>2]=0;j=j9(384074)|0;if(j>>>0>4294967279)uaa();if(j>>>0<11){a[P+11>>0]=j;i=P}else{I=j+16&-16;i=ZW(I)|0;c[P>>2]=i;c[P+8>>2]=I|-2147483648;c[P+4>>2]=j}i1(i,384074,j)|0;J7(i+j|0,0);bw(f,1,0,204,P,1,0);a1(P);RB(f,1,0,201,380879,-1,1,1);break c}case 2:{c[P>>2]=0;c[P+4>>2]=0;c[P+8>>2]=0;j=j9(384078)|0;if(j>>>0>4294967279)uaa();if(j>>>0<11){a[P+11>>0]=j;i=P}else{I=j+16&-16;i=ZW(I)|0;c[P>>2]=i;c[P+8>>2]=I|-2147483648;c[P+4>>2]=j}i1(i,384078,j)|0;J7(i+j|0,0);bw(f,1,0,204,P,1,0);a1(P);RB(f,1,0,201,380879,-1,1,1);break c}case 3:{c[P>>2]=0;c[P+4>>2]=0;c[P+8>>2]=0;j=j9(384074)|0;if(j>>>0>4294967279)uaa();if(j>>>0<11){a[P+11>>0]=j;i=P}else{I=j+16&-16;i=ZW(I)|0;c[P>>2]=i;c[P+8>>2]=I|-2147483648;c[P+4>>2]=j}i1(i,384074,j)|0;J7(i+j|0,0);bw(f,1,0,204,P,1,0);a1(P);RB(f,1,0,201,380861,-1,1,1);break c}case 4:{c[P>>2]=0;c[P+4>>2]=0;c[P+8>>2]=0;j=j9(384078)|0;if(j>>>0>4294967279)uaa();if(j>>>0<11){a[P+11>>0]=j;i=P}else{I=j+16&-16;i=ZW(I)|0;c[P>>2]=i;c[P+8>>2]=I|-2147483648;c[P+4>>2]=j}i1(i,384078,j)|0;J7(i+j|0,0);bw(f,1,0,204,P,1,0);a1(P);RB(f,1,0,201,380861,-1,1,1);break c}default:break c}else{bw(f,1,0,211,N,1,1);RB(f,1,0,201,380879,-1,1,1)}while(0);a1(N);wz(J,S);qd(N,f,J);bw(f,1,0,47,N,1,0);a1(N);a1(J);n=f+936|0;zb(f,0,0,273,n,0);m=f+948|0;zb(f,0,0,276,m,0);k=f+960|0;zb(f,0,0,277,k,0);j=f+984|0;zb(f,0,0,279,j,0);zb(f,1,0,300,n,0);zb(f,1,0,303,m,0);zb(f,1,0,304,k,0);zb(f,1,0,306,j,0);zb(f,1,0,124,f+996|0,0);zb(f,1,0,51,f+1008|0,0);j=c[f+868>>2]|0;k=f+840|0;m=f+844|0;n=f+852|0;i=c[f+864>>2]|0;while(1){if((i|0)==(j|0))break;o=c[i>>2]|0;if(o|0?(d[o>>0]|0)==(K-(c[((c[k>>2]|0)==(c[m>>2]|0)?n:k)>>2]|0)>>2|0):0){L=111;break}i=i+4|0}do if((L|0)==111)if(!(a[o+12>>0]|0)){RB(f,1,0,41,382840,-1,1,0);RB(f,1,0,74,382840,-1,1,0);break}else{RB(f,1,0,31,380895,-1,1,0);RB(f,1,0,41,382808,-1,1,0);RB(f,1,0,66,380895,-1,1,0);RB(f,1,0,74,382808,-1,1,0);break}while(0);i=a[(c[h>>2]|0)+46>>0]|0;if(i<<24>>24){uU(M,i,10);HX(M,34604)|0;c[P>>2]=c[M>>2];c[P+4>>2]=c[M+4>>2];c[P+8>>2]=c[M+8>>2];i=0;while(1){if((i|0)==3)break;c[M+(i<<2)>>2]=0;i=i+1|0}p2(N,P);zb(f,1,0,31,N,0);z5(N);O0(P);z5(M);uU(M,a[(c[h>>2]|0)+46>>0]|0,10);HX(M,34604)|0;c[P>>2]=c[M>>2];c[P+4>>2]=c[M+4>>2];c[P+8>>2]=c[M+8>>2];i=0;while(1){if((i|0)==3)break;c[M+(i<<2)>>2]=0;i=i+1|0}p2(N,P);zb(f,1,0,66,N,0);z5(N);O0(P);z5(M);mL(f,1,0,43,a[(c[h>>2]|0)+46>>0]|0,10,0);mL(f,1,0,75,a[(c[h>>2]|0)+46>>0]|0,10,0)}$x(N,f,1,0,191,1);P=a[N+8+3>>0]|0;P=((P<<24>>24<0?c[N+4>>2]|0:P&255)|0)==0;z5(N);if(P)RB(f,1,0,191,yW(a[(c[h>>2]|0)+38>>0]|0)|0,-1,1,0);RB(f,1,0,190,RW(a[(c[h>>2]|0)+38>>0]|0)|0,-1,1,0);P=c[h>>2]|0;i=a[P+41>>0]|0;if(i<<24>>24==(a[P+42>>0]|0))sM(f,1,0,195,(i&255)+8|0,0);a1(S);a1(R);z5(Q);l=T;return}function hc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+32|0;j=p+20|0;i=p+16|0;f=p+12|0;n=p+24|0;g=p;o=b+784|0;bB(b,o);Bx(b);xR(b,6,n);m=b+648|0;A6(c[m>>2]|0);A6(c[m>>2]|0);wK(b);jB(b,j);ID(b,i);ID(b,f);if(qO(b)|0){e=b+760|0;d=c[e>>2]|0;a:do if((d|0)==7)switch(a[o>>0]|0){case -92:case -93:case 110:case 109:case 108:case 106:case 101:case 100:case 99:case 98:case 97:case 96:case 33:case 32:{c[e>>2]=1;d=1;break a}case -31:case -44:case -45:case -47:case -84:case -85:case -86:case -87:case -90:case -91:case -95:case -96:case 107:case 105:case 104:case 103:case 102:case 64:{c[e>>2]=2;d=2;break a}case -32:case 8:{c[e>>2]=3;d=3;break a}default:{d=7;break a}}while(0);if(!(RA(b,d,-1)|0))Kc(b,c[e>>2]|0,-1)|0;d=a[o>>0]|0;k=b+20|0;m=b+16|0;do switch(d<<24>>24){case 1:{h=c[m>>2]|0;RB(b,h,c[k>>2]|0,Rb(h,0)|0,375297,-1,0,1);h=49;break}case 2:{h=c[m>>2]|0;RB(b,h,c[k>>2]|0,Rb(h,0)|0,375304,-1,0,1);h=49;break}case 8:{RB(b,3,c[k>>2]|0,18,375316,-1,0,1);h=49;break}case 32:{RB(b,1,c[k>>2]|0,18,391429,-1,0,1);h=49;break}case 33:{RB(b,1,c[k>>2]|0,18,391410,-1,0,1);h=49;break}case 64:{RB(b,2,c[k>>2]|0,18,391425,-1,0,1);h=49;break}case 96:{RB(b,1,c[k>>2]|0,18,391454,-1,0,1);RB(b,1,c[k>>2]|0,24,383814,-1,0,1);RB(b,1,c[k>>2]|0,23,382769,-1,0,1);h=49;break}case 97:{RB(b,1,c[k>>2]|0,18,391454,-1,0,1);RB(b,1,c[k>>2]|0,24,383821,-1,0,1);RB(b,1,c[k>>2]|0,23,382769,-1,0,1);h=49;break}case 98:{RB(b,1,c[k>>2]|0,18,391454,-1,0,1);RB(b,1,c[k>>2]|0,24,375331,-1,0,1);RB(b,1,c[k>>2]|0,23,382769,-1,0,1);h=49;break}case 99:{RB(b,1,c[k>>2]|0,18,391454,-1,0,1);RB(b,1,c[k>>2]|0,24,375335,-1,0,1);RB(b,1,c[k>>2]|0,23,382769,-1,0,1);h=49;break}case 100:{RB(b,1,c[k>>2]|0,18,391454,-1,0,1);RB(b,1,c[k>>2]|0,24,382668,-1,0,1);RB(b,1,c[k>>2]|0,23,382769,-1,0,1);h=49;break}case 101:{RB(b,1,c[k>>2]|0,18,391454,-1,0,1);RB(b,1,c[k>>2]|0,24,384029,-1,0,1);RB(b,1,c[k>>2]|0,23,382769,-1,0,1);h=49;break}case 102:{RB(b,2,c[k>>2]|0,18,391425,-1,0,1);RB(b,2,c[k>>2]|0,24,383821,-1,0,1);h=49;break}case 103:{RB(b,2,c[k>>2]|0,18,391425,-1,0,1);RB(b,2,c[k>>2]|0,24,375343,-1,0,1);h=49;break}case 104:{RB(b,2,c[k>>2]|0,18,391425,-1,0,1);RB(b,2,c[k>>2]|0,24,375346,-1,0,1);h=49;break}case 105:{RB(b,2,c[k>>2]|0,18,391443,-1,0,1);RB(b,2,c[k>>2]|0,23,382769,-1,0,1);RB(b,2,c[k>>2]|0,24,375350,-1,0,1);h=49;break}case 106:{RB(b,1,c[k>>2]|0,18,391454,-1,0,1);RB(b,1,c[k>>2]|0,23,382779,-1,0,1);h=49;break}case 107:{RB(b,2,c[k>>2]|0,18,391443,-1,0,1);RB(b,2,c[k>>2]|0,23,382779,-1,0,1);h=49;break}case 108:{RB(b,1,c[k>>2]|0,18,380258,-1,0,1);h=49;break}case 109:{RB(b,1,c[k>>2]|0,18,378977,-1,0,1);h=49;break}case 110:{RB(b,1,c[k>>2]|0,18,391454,-1,0,1);h=49;break}case -96:{RB(b,2,c[k>>2]|0,18,379622,-1,0,1);sM(b,2,c[k>>2]|0,135,8e3,1);sM(b,2,c[k>>2]|0,122,1,1);h=49;break}case -95:{RB(b,2,c[k>>2]|0,18,379565,-1,0,1);sM(b,2,c[k>>2]|0,135,8e3,1);sM(b,2,c[k>>2]|0,122,1,1);h=49;break}case -94:{h=c[m>>2]|0;RB(b,h,c[k>>2]|0,Rb(h,0)|0,375358,-1,0,1);h=49;break}case -93:{RB(b,1,c[k>>2]|0,18,391360,-1,0,1);h=49;break}case -92:{RB(b,1,c[k>>2]|0,18,391354,-1,0,1);h=49;break}case -91:{RB(b,2,c[k>>2]|0,18,391372,-1,0,1);h=49;break}case -90:{RB(b,2,c[k>>2]|0,18,391365,-1,0,1);h=49;break}case -87:{RB(b,2,c[k>>2]|0,18,391377,-1,0,1);h=49;break}case -86:{RB(b,2,c[k>>2]|0,18,391377,-1,0,1);RB(b,2,c[k>>2]|0,24,375364,-1,0,1);h=49;break}case -85:{RB(b,2,c[k>>2]|0,18,391377,-1,0,1);RB(b,2,c[k>>2]|0,24,375368,-1,0,1);h=49;break}case -84:{RB(b,2,c[k>>2]|0,18,391377,-1,0,1);RB(b,2,c[k>>2]|0,24,375371,-1,0,1);h=49;break}case -47:{RB(b,2,c[k>>2]|0,18,379622,-1,0,1);sM(b,2,c[k>>2]|0,135,8e3,1);sM(b,2,c[k>>2]|0,122,1,1);h=49;break}case -45:{RB(b,2,c[k>>2]|0,18,391372,-1,0,1);h=49;break}case -44:{RB(b,2,c[k>>2]|0,18,391377,-1,0,1);h=49;break}case -35:{h=c[m>>2]|0;RB(b,h,c[k>>2]|0,Rb(h,0)|0,378904,-1,0,1);h=49;break}case -34:{h=c[m>>2]|0;RB(b,h,c[k>>2]|0,Rb(h,0)|0,378904,-1,0,1);h=49;break}case -32:{RB(b,3,c[k>>2]|0,18,375379,-1,0,1);Xy(g,23876);Rf(b,g,3,c[k>>2]|0,1);z5(g);h=49;break}case -31:{RB(b,2,c[k>>2]|0,18,379616,-1,0,1);sM(b,2,c[k>>2]|0,135,8e3,1);sM(b,2,c[k>>2]|0,122,1,1);h=49;break}default:{}}while(0);if((h|0)==49)d=a[o>>0]|0;do switch(d<<24>>24){case 1:{h=c[m>>2]|0;RB(b,h,c[k>>2]|0,Rb(h,17)|0,375297,-1,0,1);break}case 2:{h=c[m>>2]|0;RB(b,h,c[k>>2]|0,Rb(h,17)|0,375304,-1,0,1);break}case 32:{RB(b,1,c[k>>2]|0,58,391490,-1,0,1);break}case 33:{RB(b,1,c[k>>2]|0,58,375386,-1,0,1);break}case 64:{RB(b,2,c[k>>2]|0,52,391425,-1,0,1);break}case 96:{RB(b,1,c[k>>2]|0,58,391482,-1,0,1);break}case 97:{RB(b,1,c[k>>2]|0,58,391482,-1,0,1);break}case 98:{RB(b,1,c[k>>2]|0,58,391482,-1,0,1);break}case 99:{RB(b,1,c[k>>2]|0,58,391482,-1,0,1);break}case 100:{RB(b,1,c[k>>2]|0,58,391482,-1,0,1);break}case 101:{RB(b,1,c[k>>2]|0,58,391482,-1,0,1);break}case 102:{RB(b,2,c[k>>2]|0,52,391425,-1,0,1);break}case 103:{RB(b,2,c[k>>2]|0,52,391425,-1,0,1);break}case 104:{RB(b,2,c[k>>2]|0,52,391425,-1,0,1);break}case 105:{RB(b,2,c[k>>2]|0,52,375391,-1,0,1);break}case 106:{RB(b,1,c[k>>2]|0,58,391514,-1,0,1);break}case 107:{RB(b,2,c[k>>2]|0,52,391506,-1,0,1);break}case 108:{RB(b,1,c[k>>2]|0,58,380258,-1,0,1);break}case 109:{RB(b,1,c[k>>2]|0,58,378977,-1,0,1);break}case 110:{RB(b,1,c[k>>2]|0,58,391490,-1,0,1);break}case -96:{RB(b,1,c[k>>2]|0,58,379622,-1,0,1);break}case -95:{RB(b,1,c[k>>2]|0,58,379565,-1,0,1);break}case -94:{RB(b,1,c[k>>2]|0,58,391490,-1,0,1);break}case -93:{RB(b,2,c[k>>2]|0,52,391360,-1,0,1);break}case -92:{RB(b,2,c[k>>2]|0,52,391354,-1,0,1);break}case -91:{RB(b,2,c[k>>2]|0,52,391474,-1,0,1);break}case -90:{RB(b,2,c[k>>2]|0,52,391469,-1,0,1);break}case -87:{RB(b,2,c[k>>2]|0,52,391377,-1,0,1);break}case -85:case -86:{RB(b,2,c[k>>2]|0,52,375402,-1,0,1);break}case -84:{RB(b,2,c[k>>2]|0,52,375409,-1,0,1);break}case -47:{RB(b,2,c[k>>2]|0,52,379622,-1,0,1);break}case -45:{RB(b,2,c[k>>2]|0,52,391474,-1,0,1);break}case -44:{RB(b,2,c[k>>2]|0,52,391377,-1,0,1);break}case -35:{h=c[m>>2]|0;RB(b,h,c[k>>2]|0,Rb(h,17)|0,378904,-1,0,1);break}case -34:{h=c[m>>2]|0;RB(b,h,c[k>>2]|0,Rb(h,17)|0,378904,-1,0,1);break}case -32:{RB(b,3,c[k>>2]|0,37,375421,-1,0,1);break}case -31:{RB(b,2,c[k>>2]|0,52,379616,-1,0,1);break}default:{}}while(0);h=c[m>>2]|0;d=c[k>>2]|0;TX(g);e=ex(g,a[o>>0]|0)|0;zb(b,h,d,Rb(h,12)|0,e,1);z5(g);e=c[m>>2]|0;g=c[k>>2]|0;h=Rb(e,21)|0;mL(b,e,g,h,a[o>>0]|0,16,1);h=c[f>>2]|0;do if(h|0){g=c[i>>2]|0;if((c[j>>2]|0)==(h|0)?(h|0)==4096&(h|0)==(g|0):0)break;d=c[m>>2]|0;e=c[k>>2]|0;lL(b,d,e,Rb(d,42)|0,h,10,0);d=c[m>>2]|0;e=c[k>>2]|0;f=Rb(d,36)|0;if(!(+(g>>>0)<=+(h>>>0)*1.005)){RB(b,d,e,f,384435,-1,1,0);m=c[m>>2]|0;k=c[k>>2]|0;lL(b,m,k,Rb(m,44)|0,g,10,0);break}else{RB(b,d,e,f,384431,-1,1,0);break}}while(0);d=b+772|0;e=c[d>>2]|0;if(e|0)jb[c[(c[e>>2]|0)+4>>2]&511](e);c[d>>2]=0;do switch(a[o>>0]|0){case 1:{if((a[n>>0]|0)==1){o=ZW(792)|0;EL(o);c[d>>2]=o;d=o}else d=0;break}case 32:{o=ZW(1040)|0;_z(o);c[d>>2]=o;d=o+760|0;c[d>>2]=1;c[d+4>>2]=0;a[o+768>>0]=1;d=o;break}case 33:{o=ZW(1056)|0;Mr(o);c[d>>2]=o;a[o+769>>0]=1;a[o+733>>0]=0;a[o+770>>0]=1;d=o;break}case 104:case 103:case 102:case 64:{o=ZW(22152)|0;Dt(o);c[d>>2]=o;c[o+908>>2]=1;a[o+904>>0]=1;d=o;break}case 106:case 101:case 100:case 99:case 98:case 97:case 96:{o=ZW(1104)|0;ln(o);c[d>>2]=o;a[o+776>>0]=1;d=o;break}case 107:case 105:{o=ZW(1128)|0;Wr(o);c[d>>2]=o;d=o;break}case -35:case -34:{o=ZW(808)|0;MG(o);c[d>>2]=o;a[o+733>>0]=0;a[o+760>>0]=1;d=o;break}case -93:{o=ZW(920)|0;Wv(o);c[d>>2]=o;d=o;break}case -84:case -85:case -86:case -87:case -44:{o=ZW(1256)|0;uw(o);c[d>>2]=o;d=o;break}case -45:case -90:case -91:{o=ZW(1584)|0;on(o);c[d>>2]=o;d=o;break}default:d=0}while(0);o=b+520|0;c[o>>2]=-1;c[o+4>>2]=-1;aY(b,d);o7(b)}l=p;return}function ic(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;r=l;l=l+96|0;q=r+84|0;i=r+72|0;j=r+60|0;k=r+48|0;m=r+36|0;n=r+24|0;o=r+12|0;p=r;if(qO(b)|0){h=b+22136|0;c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;f=j9(370640)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[q+11>>0]=f;e=q}else{s=f+16&-16;e=ZW(s)|0;c[q>>2]=e;c[q+8>>2]=s|-2147483648;c[q+4>>2]=f}i1(e,370640,f)|0;J7(e+f|0,0);f=VC(h,q)|0;s=a[f+8+3>>0]|0;s=((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)==0;a1(q);if(s){Xy(q,12284);c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[i+11>>0]=f;e=i}else{s=f+16&-16;e=ZW(s)|0;c[i>>2]=e;c[i+8>>2]=s|-2147483648;c[i+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);vF(VC(h,i)|0,q)|0;a1(i);z5(q);c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;f=j9(384542)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[i+11>>0]=f;e=i}else{s=f+16&-16;e=ZW(s)|0;c[i>>2]=e;c[i+8>>2]=s|-2147483648;c[i+4>>2]=f}i1(e,384542,f)|0;J7(e+f|0,0);p2(q,VC(h,i)|0);a1(i);c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;f=j9(370675)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[j+11>>0]=f;e=j}else{s=f+16&-16;e=ZW(s)|0;c[j>>2]=e;c[j+8>>2]=s|-2147483648;c[j+4>>2]=f}i1(e,370675,f)|0;J7(e+f|0,0);p2(i,VC(h,j)|0);a1(j);c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[k+11>>0]=f;e=k}else{s=f+16&-16;e=ZW(s)|0;c[k>>2]=e;c[k+8>>2]=s|-2147483648;c[k+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);p2(j,VC(h,k)|0);a1(k);Xy(k,25220);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(384542)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{s=f+16&-16;e=ZW(s)|0;c[m>>2]=e;c[m+8>>2]=s|-2147483648;c[m+4>>2]=f}i1(e,384542,f)|0;J7(e+f|0,0);vF(VC(h,m)|0,k)|0;a1(m);z5(k);Xy(k,12320);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(370675)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{s=f+16&-16;e=ZW(s)|0;c[m>>2]=e;c[m+8>>2]=s|-2147483648;c[m+4>>2]=f}i1(e,370675,f)|0;J7(e+f|0,0);vF(VC(h,m)|0,k)|0;a1(m);z5(k);if(tT()|0){c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[k+11>>0]=f;e=k}else{s=f+16&-16;e=ZW(s)|0;c[k>>2]=e;c[k+8>>2]=s|-2147483648;c[k+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);HX(VC(h,k)|0,12364)|0;a1(k);ms(n,41840,q);HX(n,41840)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];e=0;while(1){if((e|0)==3)break;c[n+(e<<2)>>2]=0;e=e+1|0}e=a[q+8+3>>0]|0;s=e<<24>>24<0;Ex(m,s?c[q>>2]|0:q,s?c[q+4>>2]|0:e&255)|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];e=0;while(1){if((e|0)==3)break;c[m+(e<<2)>>2]=0;e=e+1|0}c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;f=j9(384542)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[o+11>>0]=f;e=o}else{s=f+16&-16;e=ZW(s)|0;c[o>>2]=e;c[o+8>>2]=s|-2147483648;c[o+4>>2]=f}i1(e,384542,f)|0;J7(e+f|0,0);f=VC(h,o)|0;e=a[k+8+3>>0]|0;s=e<<24>>24<0;Ex(f,s?c[k>>2]|0:k,s?c[k+4>>2]|0:e&255)|0;a1(o);O0(k);O0(m);O0(n);ms(n,41840,i);HX(n,41840)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];e=0;while(1){if((e|0)==3)break;c[n+(e<<2)>>2]=0;e=e+1|0}e=a[i+8+3>>0]|0;s=e<<24>>24<0;Ex(m,s?c[i>>2]|0:i,s?c[i+4>>2]|0:e&255)|0;c[k>>2]=c[m>>2];c[k+4>>2]=c[m+4>>2];c[k+8>>2]=c[m+8>>2];e=0;while(1){if((e|0)==3)break;c[m+(e<<2)>>2]=0;e=e+1|0}c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;f=j9(370675)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[o+11>>0]=f;e=o}else{s=f+16&-16;e=ZW(s)|0;c[o>>2]=e;c[o+8>>2]=s|-2147483648;c[o+4>>2]=f}i1(e,370675,f)|0;J7(e+f|0,0);e=VC(h,o)|0;s=a[k+8+3>>0]|0;f=s<<24>>24<0;Ex(e,f?c[k>>2]|0:k,f?c[k+4>>2]|0:s&255)|0;a1(o);O0(k);O0(m);O0(n);TX(o);if((a[b+2469>>0]|0)==-1){e=b+112|0;e=PZ(c[e>>2]|0,c[e+4>>2]|0,1)|0;f=z}else{e=c[b+2472>>2]|0;f=0}zo(o,e,f)|0;Bs(n,o,41840);e=a[j+8+3>>0]|0;s=e<<24>>24<0;Ex(n,s?c[j>>2]|0:j,s?c[j+4>>2]|0:e&255)|0;c[m>>2]=c[n>>2];c[m+4>>2]=c[n+4>>2];c[m+8>>2]=c[n+8>>2];e=0;while(1){if((e|0)==3)break;c[n+(e<<2)>>2]=0;e=e+1|0}p2(k,m);c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[p+11>>0]=f;e=p}else{s=f+16&-16;e=ZW(s)|0;c[p>>2]=e;c[p+8>>2]=s|-2147483648;c[p+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);vF(VC(h,p)|0,k)|0;a1(p);z5(k);O0(m);O0(n);z5(o)}c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[k+11>>0]=f;e=k}else{s=f+16&-16;e=ZW(s)|0;c[k>>2]=e;c[k+8>>2]=s|-2147483648;c[k+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);e=VC(h,k)|0;f=i9(39604)|0;s=a[e+8+3>>0]|0;if((f|0)==((s<<24>>24<0?c[e+4>>2]|0:s&255)|0)){s=(VG(e,39604,f)|0)==0;a1(k);if(!s)g=86}else{a1(k);g=86}if((g|0)==86){c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[k+11>>0]=f;e=k}else{s=f+16&-16;e=ZW(s)|0;c[k>>2]=e;c[k+8>>2]=s|-2147483648;c[k+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);g=VC(h,k)|0;s=a[g+8+3>>0]|0;s=((s<<24>>24<0?c[g+4>>2]|0:s&255)|0)==0;a1(k);if(!s){c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[k+11>>0]=f;e=k}else{s=f+16&-16;e=ZW(s)|0;c[k>>2]=e;c[k+8>>2]=s|-2147483648;c[k+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);DW(VC(h,k)|0,0,41840)|0;a1(k)}c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[k+11>>0]=f;e=k}else{s=f+16&-16;e=ZW(s)|0;c[k>>2]=e;c[k+8>>2]=s|-2147483648;c[k+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);DW(VC(h,k)|0,0,39604)|0;a1(k)}Xy(k,11768);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;f=j9(370640)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[m+11>>0]=f;e=m}else{s=f+16&-16;e=ZW(s)|0;c[m>>2]=e;c[m+8>>2]=s|-2147483648;c[m+4>>2]=f}i1(e,370640,f)|0;J7(e+f|0,0);vF(VC(h,m)|0,k)|0;a1(m);z5(k);$x(k,b,2,c[b+20>>2]|0,52,1);TX(o);cC(o,yn(a[b+2462>>0]|0)|0)|0;Bs(n,o,12424);p2(m,n);c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;f=j9(385582)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[p+11>>0]=f;e=p}else{s=f+16&-16;e=ZW(s)|0;c[p>>2]=e;c[p+8>>2]=s|-2147483648;c[p+4>>2]=f}i1(e,385582,f)|0;J7(e+f|0,0);vF(VC(h,p)|0,m)|0;a1(p);z5(m);O0(n);z5(o);z5(k);z5(j);z5(i);z5(q)}}GC(b);AT(b,q);f=b+22120|0;if(a[q>>0]|0){e=c[f>>2]|0;if(e|0)laa(e);e=ZW(5)|0;c[e>>2]=0;a[e+4>>0]=0;c[f>>2]=e;AT(b,e);e=c[f>>2]|0;if(a[e>>0]|0){xR(b,3,e+3|0);e=c[f>>2]|0}AT(b,e+1|0);e=c[f>>2]|0;if(a[e+1>>0]|0){xR(b,3,e+4|0);e=c[f>>2]|0}AT(b,e+2|0)}s=(c[f>>2]|0)==0;e=c[b+648>>2]|0;f=Z9(c[e+4>>2]|0)|0;g=f>>>0>d>>>0;if(s){if(g)G4(e,f-d|0);J3(b)}else{if(g)G4(e,f-d|0);J3(b)}l=r;return}function jc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0.0,k=0,m=0.0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0.0,B=0.0;y=l;l=l+96|0;r=y+84|0;s=y+72|0;t=y+60|0;u=y+48|0;v=y+36|0;w=y+24|0;p=y+12|0;q=y;$x(r,b,d,e,f,1);n=a[r+8+3>>0]|0;n=((n<<24>>24<0?c[r+4>>2]|0:n&255)|0)==0;z5(r);if(!n){$x(r,b,d,e,f,1);g=tm(r)|0;m=+(g>>>0)+4294967296.0*+(z|0);z5(r);g=0;while(1){if(!(m>=1024.0))break;m=m*.0009765625;g=g+1|0}k=!(m>=100.0);h=!(m>=10.0);i=k&h&1;n=k?(h?2:1):0;h=k?(h?3:2):1;TX(r);switch(g|0){case 0:{Xy(s,6756);vF(r,s)|0;z5(s);k=0;break}case 1:{Xy(s,6780);vF(r,s)|0;z5(s);k=1;break}case 2:{Xy(s,6800);vF(r,s)|0;z5(s);k=1;break}case 3:{Xy(s,6820);vF(r,s)|0;z5(s);k=1;break}case 4:{Xy(s,6840);vF(r,s)|0;z5(s);k=1;break}default:{Xy(s,6860);vF(r,s)|0;z5(s);k=1}}ST(t,m,0);ne(s,t,r,k);zb(b,d,e,f+2|0,s,1);z5(s);z5(t);ST(t,m,i);ne(s,t,r,k);zb(b,d,e,f+3|0,s,1);z5(s);z5(t);ST(t,m,n);ne(s,t,r,k);zb(b,d,e,f+4|0,s,1);z5(s);z5(t);ST(t,m,h);ne(s,t,r,k);zb(b,d,e,f+5|0,s,1);z5(s);z5(t);$x(s,b,d,e,f,1);B=+Eq(s);z5(s);$x(s,b,0,0,86,1);A=+Eq(s);o=A;z5(s);h=f+6|0;i=f+1|0;j=B/o;o=B*100.0/o;do if(A>0.0){g=!(o<=100.0);if(!(g|(Rb(d,91)|0)!=(f|0))){KW(b,d,e,Rb(d,98)|0,j,5,1);ST(p,m,n);ne(w,p,r,k);HX(w,39932)|0;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];g=0;while(1){if((g|0)==3)break;c[w+(g<<2)>>2]=0;g=g+1|0}ST(q,o,0);g=a[q+8+3>>0]|0;f=g<<24>>24<0;Ex(v,f?c[q>>2]|0:q,f?c[q+4>>2]|0:g&255)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}HX(u,6880)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}p2(s,t);zb(b,d,e,h,s,1);z5(s);O0(t);O0(u);z5(q);O0(v);z5(w);z5(p);ST(p,m,n);ne(w,p,r,k);HX(w,39932)|0;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];g=0;while(1){if((g|0)==3)break;c[w+(g<<2)>>2]=0;g=g+1|0}ST(q,o,0);g=a[q+8+3>>0]|0;n=g<<24>>24<0;Ex(v,n?c[q>>2]|0:q,n?c[q+4>>2]|0:g&255)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}HX(u,6880)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}p2(s,t);zb(b,d,e,i,s,1);z5(s);O0(t);O0(u);z5(q);O0(v);z5(w);z5(p);break}if(!(g|(Rb(d,107)|0)!=(f|0))){KW(b,d,e,Rb(d,114)|0,j,5,1);ST(p,m,n);ne(w,p,r,k);HX(w,39932)|0;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];g=0;while(1){if((g|0)==3)break;c[w+(g<<2)>>2]=0;g=g+1|0}ST(q,o,0);g=a[q+8+3>>0]|0;f=g<<24>>24<0;Ex(v,f?c[q>>2]|0:q,f?c[q+4>>2]|0:g&255)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}HX(u,6880)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}p2(s,t);zb(b,d,e,h,s,1);z5(s);O0(t);O0(u);z5(q);O0(v);z5(w);z5(p);ST(p,m,n);ne(w,p,r,k);HX(w,39932)|0;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];g=0;while(1){if((g|0)==3)break;c[w+(g<<2)>>2]=0;g=g+1|0}ST(q,o,0);g=a[q+8+3>>0]|0;n=g<<24>>24<0;Ex(v,n?c[q>>2]|0:q,n?c[q+4>>2]|0:g&255)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}HX(u,6880)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}p2(s,t);zb(b,d,e,i,s,1);z5(s);O0(t);O0(u);z5(q);O0(v);z5(w);z5(p);break}if(!(g|(Rb(d,99)|0)!=(f|0))){KW(b,d,e,Rb(d,106)|0,j,5,1);ST(p,m,n);ne(w,p,r,k);HX(w,39932)|0;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];g=0;while(1){if((g|0)==3)break;c[w+(g<<2)>>2]=0;g=g+1|0}ST(q,o,0);g=a[q+8+3>>0]|0;f=g<<24>>24<0;Ex(v,f?c[q>>2]|0:q,f?c[q+4>>2]|0:g&255)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}HX(u,6880)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}p2(s,t);zb(b,d,e,h,s,1);z5(s);O0(t);O0(u);z5(q);O0(v);z5(w);z5(p);ST(p,m,n);ne(w,p,r,k);HX(w,39932)|0;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];g=0;while(1){if((g|0)==3)break;c[w+(g<<2)>>2]=0;g=g+1|0}ST(q,o,0);g=a[q+8+3>>0]|0;n=g<<24>>24<0;Ex(v,n?c[q>>2]|0:q,n?c[q+4>>2]|0:g&255)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}HX(u,6880)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}p2(s,t);zb(b,d,e,i,s,1);z5(s);O0(t);O0(u);z5(q);O0(v);z5(w);z5(p);break}if(!(g|(Rb(d,115)|0)!=(f|0))){KW(b,d,e,Rb(d,122)|0,j,5,1);ST(p,m,n);ne(w,p,r,k);HX(w,39932)|0;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];g=0;while(1){if((g|0)==3)break;c[w+(g<<2)>>2]=0;g=g+1|0}ST(q,o,0);g=a[q+8+3>>0]|0;f=g<<24>>24<0;Ex(v,f?c[q>>2]|0:q,f?c[q+4>>2]|0:g&255)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}HX(u,6880)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}p2(s,t);zb(b,d,e,h,s,1);z5(s);O0(t);O0(u);z5(q);O0(v);z5(w);z5(p);ST(p,m,n);ne(w,p,r,k);HX(w,39932)|0;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];g=0;while(1){if((g|0)==3)break;c[w+(g<<2)>>2]=0;g=g+1|0}ST(q,o,0);g=a[q+8+3>>0]|0;n=g<<24>>24<0;Ex(v,n?c[q>>2]|0:q,n?c[q+4>>2]|0:g&255)|0;c[u>>2]=c[v>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}HX(u,6880)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}p2(s,t);zb(b,d,e,i,s,1);z5(s);O0(t);O0(u);z5(q);O0(v);z5(w);z5(p)}else x=93}else x=93;while(0);if((x|0)==93){ST(t,m,n);ne(s,t,r,k);zb(b,d,e,i,s,1);z5(s);z5(t)}z5(r)}l=y;return}function kc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;Y=l;l=l+96|0;X=Y+72|0;G=Y+60|0;H=Y+48|0;I=Y+36|0;J=Y+24|0;K=Y+12|0;T=Y;h=c[e>>2]|0;F=e+28|0;m=e+32|0;if((h|0)==7){V=c[F>>2]|0;if(((V|0)!=(c[m>>2]|0)?c[V>>2]|0:0)?(Qg(b,d,e,f),g=c[e>>2]|0,(g|0)!=7):0)O=5}else{g=h;O=5}if((O|0)==5){U=b+16|0;c[U>>2]=g;P=e+4|0;h=c[P>>2]|0;V=b+20|0;c[V>>2]=h;k=c[F>>2]|0;S=b+492|0;if((k|0)!=(c[m>>2]|0)?(n=c[k>>2]|0,(n|0)!=0):0){if(!(c[n+728>>2]&8)){a[n+732>>0]=0;E=b+40|0;D=E;C=c[D>>2]|0;D=c[D+4>>2]|0;B=b+48|0;B=z0(c[b+612>>2]|0,0,c[B>>2]|0,c[B+4>>2]|0)|0;A=b+528|0;A=z0(B|0,z|0,c[A>>2]|0,c[A+4>>2]|0)|0;B=E;c[B>>2]=A;c[B+4>>2]=z;Sc(b,n,c[b+544>>2]|0,0,0);c[E>>2]=C;c[E+4>>2]=D;G2(b,c[c[F>>2]>>2]|0)}h=e+8|0;g=0;while(1){if(g>>>0>=(c[h>>2]|0)>>>0)break;$x(X,b,c[U>>2]|0,(c[P>>2]|0)+g|0,10,1);$x(G,b,c[U>>2]|0,(c[P>>2]|0)+g|0,11,1);Gb(b,c[c[F>>2]>>2]|0,c[U>>2]|0,g,(c[P>>2]|0)+g|0,1)|0;zb(b,c[U>>2]|0,(c[P>>2]|0)+g|0,10,X,1);zb(b,c[U>>2]|0,(c[P>>2]|0)+g|0,11,G,1);z5(G);z5(X);g=g+1|0}C=e+108|0;D=e+112|0;E=b+804|0;if(!(a[S>>0]|0)){switch(f|0){case 1:{g=c[(c[E>>2]|0)+22788>>2]|0;h=b+876|0;if((g|0)!=-1)lL(b,c[U>>2]|0,c[V>>2]|0,7,(c[h>>2]|0)+g|0,10,0);g=c[b+872>>2]|0;if(g|0?(o=c[h>>2]|0,o>>>0<g>>>0):0)c[h>>2]=o+1;break}case 2:{g=c[(c[E>>2]|0)+30468>>2]|0;if((g|0)!=-1)lL(b,c[U>>2]|0,c[V>>2]|0,7,g,10,0);break}default:{g=c[C>>2]|0;if((g|0)!=-1)lL(b,c[U>>2]|0,c[V>>2]|0,7,g,10,0)}}lL(b,c[U>>2]|0,c[V>>2]|0,8,c[D>>2]|0,10,0)}if(RA(c[c[F>>2]>>2]|0,1,-1)|0?RA(c[c[F>>2]>>2]|0,3,-1)|0:0){o=RA(c[c[F>>2]>>2]|0,3,-1)|0;p=J+8+3|0;q=J+4|0;r=G+8+3|0;s=G+4|0;t=X+8+3|0;u=X+4|0;v=H+8+3|0;w=H+4|0;x=I+8+3|0;y=I+4|0;A=K+8+3|0;B=K+4|0;n=0;while(1){if(n>>>0>=o>>>0)break;$x(I,b,1,c[P>>2]|0,10,1);HX(I,42040)|0;c[H>>2]=c[I>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2];g=0;while(1){if((g|0)==3)break;c[I+(g<<2)>>2]=0;g=g+1|0}$x(J,c[c[F>>2]>>2]|0,3,n,10,1);g=a[p>>0]|0;m=g<<24>>24<0;Ex(H,m?c[J>>2]|0:J,m?c[q>>2]|0:g&255)|0;c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];g=0;while(1){if((g|0)==3)break;c[H+(g<<2)>>2]=0;g=g+1|0}p2(X,G);O0(G);z5(J);O0(H);z5(I);c[V>>2]=-1;g=0;a:while(1){if(g>>>0>=(RA(b,3,-1)|0)>>>0){O=45;break}$x(G,b,3,g,10,1);k=a[r>>0]|0;h=k<<24>>24<0;k=h?c[s>>2]|0:k&255;Z=a[t>>0]|0;m=Z<<24>>24<0;do if((k|0)==((m?c[u>>2]|0:Z&255)|0)?(L$(h?c[G>>2]|0:G,m?c[X>>2]|0:X,k)|0)==0:0){gq(H,b,1,c[P>>2]|0,382758);gq(I,c[c[F>>2]>>2]|0,3,n,382758);k=a[v>>0]|0;h=k<<24>>24<0;k=h?c[w>>2]|0:k&255;Z=a[x>>0]|0;m=Z<<24>>24<0;if((k|0)==((m?c[y>>2]|0:Z&255)|0)){Z=(L$(h?c[H>>2]|0:H,m?c[I>>2]|0:I,k)|0)==0;z5(I);z5(H);z5(G);if(Z){O=42;break a}else break}else{z5(I);z5(H);z5(G);break}}else O=41;while(0);if((O|0)==41){O=0;z5(G)}g=g+1|0}if((O|0)==42){O=0;c[V>>2]=g}else if((O|0)==45){O=0;g=c[V>>2]|0;if((g|0)==-1){Kc(b,3,-1)|0;g=c[V>>2]|0}}Gb(b,c[c[F>>2]>>2]|0,3,n,g,1)|0;if(!(a[S>>0]|0)){Z=c[V>>2]|0;TX(I);Gk(I,(c[P>>2]|0)+1|0,10)|0;ms(H,28664,I);p2(G,H);Mc(b,3,Z,379121,G,0);z5(G);O0(H);z5(I)}zb(b,3,c[V>>2]|0,10,X,1);h=c[V>>2]|0;$x(J,b,1,c[P>>2]|0,11,1);HX(J,42040)|0;c[I>>2]=c[J>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];g=0;while(1){if((g|0)==3)break;c[J+(g<<2)>>2]=0;g=g+1|0}$x(K,c[c[F>>2]>>2]|0,3,n,10,1);g=a[A>>0]|0;Z=g<<24>>24<0;Ex(I,Z?c[K>>2]|0:K,Z?c[B>>2]|0:g&255)|0;c[H>>2]=c[I>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2];g=0;while(1){if((g|0)==3)break;c[I+(g<<2)>>2]=0;g=g+1|0}p2(G,H);zb(b,3,h,11,G,1);z5(G);O0(H);z5(K);O0(I);z5(J);Z=c[V>>2]|0;$x(G,b,1,c[P>>2]|0,217,1);zb(b,3,Z,126,G,1);z5(G);if(!(a[S>>0]|0)){switch(f|0){case 1:{g=c[(c[E>>2]|0)+22788>>2]|0;if((g|0)!=-1)lL(b,3,c[V>>2]|0,7,g,10,0);break}case 2:{g=c[(c[E>>2]|0)+30468>>2]|0;if((g|0)!=-1)lL(b,3,c[V>>2]|0,7,g,10,0);break}default:{g=c[C>>2]|0;if((g|0)!=-1)lL(b,3,c[V>>2]|0,7,g,10,0)}}lL(b,c[U>>2]|0,c[V>>2]|0,8,c[D>>2]|0,10,0)}z5(X);n=n+1|0}c[U>>2]=c[e>>2];c[V>>2]=c[P>>2]}$x(X,c[c[F>>2]>>2]|0,0,0,250,1);Z=a[X+8+3>>0]|0;if((Z<<24>>24<0?c[X+4>>2]|0:Z&255)|0)zb(b,0,0,250,X,1);$x(G,c[c[F>>2]>>2]|0,0,0,159,1);Z=a[G+8+3>>0]|0;if((Z<<24>>24<0?c[G+4>>2]|0:Z&255)|0?($x(H,b,0,0,159,1),Z=a[H+8+3>>0]|0,Z=((Z<<24>>24<0?c[H+4>>2]|0:Z&255)|0)==0,z5(H),Z):0)zb(b,0,0,159,G,0);z5(G);z5(X);g=c[e>>2]|0;if((g|0)==7)O=87;else{h=c[P>>2]|0;O=72}}else O=72;do if((O|0)==72){$x(X,b,g,h,Rb(g,22)|0,1);Z=a[X+8+3>>0]|0;Z=((Z<<24>>24<0?c[X+4>>2]|0:Z&255)|0)==0;z5(X);if(Z){n=c[e>>2]|0;c[U>>2]=n;o=c[P>>2]|0;c[V>>2]=o;h=e+64|0;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!((g|0)==-1&(h|0)==-1)?(j=e+96|0,i=c[j>>2]|0,j=c[j+4>>2]|0,!((i|0)==-1&(j|0)==-1)):0){k=-1;m=-1}else{h=e+48|0;g=c[h>>2]|0;h=c[h+4>>2]|0;if((g|0)==-1&(h|0)==-1){O=87;break}j=e+80|0;i=c[j>>2]|0;j=c[j+4>>2]|0;if((i|0)==-1&(j|0)==-1){O=87;break}k=e+40|0;Z=c[k>>2]|0;k=c[k+4>>2]|0;O=e+72|0;K=c[O>>2]|0;O=c[O+4>>2]|0;m=O>>>0>k>>>0|(O|0)==(k|0)&K>>>0>Z>>>0;k=D_(K|0,O|0,Z|0,k|0)|0;k=m?k:-1;m=m?z:-1}if(((g|0)!=-1|(h|0)!=-1)&((i|0)!=-1|(j|0)!=-1)?(M=(h>>>0>1|(h|0)==1&g>>>0>0)&(j>>>0<1|(j|0)==1&i>>>0<0),L=z0(i|0,j|0,0,2)|0,L=M?L:i,M=M?z:j,M>>>0>h>>>0|(M|0)==(h|0)&L>>>0>g>>>0):0){i=D_(L|0,M|0,g|0,h|0)|0;g=z;h=(i|0)==0&(g|0)==0;if((k|0)==-1&(m|0)==-1){if(h){O=87;break}}else{Z=PZ(k|0,m|0,3)|0;if(h|(+(Z>>>0)+4294967296.0*+(z>>>0))/((+(i>>>0)+4294967296.0*+(g>>>0))/9.0e3)>1.0e10){O=87;break}}if((n|0)==1?($x(X,b,1,o,171,1),N=+Eq(X),z5(X),N!=0.0):0){ST(X,9.0e4/N,0);Z=rm(X)|0;i=z0(Z|0,z|0,i|0,g|0)|0;g=z;z5(X)}h=g5(i|0,g|0,90,0)|0;j=z;Z=c[e>>2]|0;O=c[P>>2]|0;oK(b,Z,O,Rb(Z,22)|0,h,j,10,0);if(!(g>>>0<0|(g|0)==0&i>>>0<90))O=89;else O=87}else O=87}else O=87}while(0);if(((O|0)==87?(Z=c[e>>2]|0,M=c[P>>2]|0,$x(X,b,Z,M,Rb(Z,22)|0,1),Z=a[X+8+3>>0]|0,Z=((Z<<24>>24<0?c[X+4>>2]|0:Z&255)|0)==0,z5(X),!Z):0)?(Q=c[e>>2]|0,R=c[P>>2]|0,$x(X,b,Q,R,Rb(Q,22)|0,1),Q=rm(X)|0,R=z,z5(X),!((Q|0)==0&(R|0)==0)):0){h=Q;j=R;O=89}b:do if((O|0)==89){m=(f|0)==0;n=X+8+3|0;o=X+4|0;k=1;while(1){if(k>>>0<7)i=0;else break b;while(1){if(i>>>0>=(RA(b,k,-1)|0)>>>0)break;if(!(a[S>>0]|0)){if(m){$x(T,b,k,i,10,1);Z=rm(T)|0;if((Z|0)==(d|0)&(z|0)==0){g=1;O=97}else z5(T)}}else{g=0;O=97}do if((O|0)==97){O=0;p=Rb(k,22)|0;$x(X,b,k,i,p,1);q=a[n>>0]|0;q=((q<<24>>24<0?c[o>>2]|0:q&255)|0)==0;z5(X);if(g){z5(T);if(!q)break}else if(!q)break;oK(b,k,i,p,h,j,10,0)}while(0);i=i+1|0}k=k+1|0}}while(0);i=b+136|0;Z=i;if(!((c[Z>>2]|0)==-1?(c[Z+4>>2]|0)==-1:0)?(W=c[U>>2]|0,(W+-1|0)>>>0<2):0){gq(X,b,W,c[V>>2]|0,384534);h=rm(X)|0;g=z;z5(X);if((h|0)==0&(g|0)==0){gq(X,b,c[U>>2]|0,c[V>>2]|0,378202);h=rm(X)|0;g=z;z5(X);if((h|0)==0&(g|0)==0){g=-1;h=-1}else O=106}else O=106;if((O|0)==106){Z=i;g=z0(c[Z>>2]|0,c[Z+4>>2]|0,h|0,g|0)|0;h=z}Z=i;c[Z>>2]=g;c[Z+4>>2]=h}}l=Y;return}function lc(d){d=d|0;var f=0,h=0,i=0,j=0,k=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0;E=l;l=l+64|0;m=E+54|0;n=E+52|0;h=E+50|0;i=E+48|0;f=E+56|0;D=E+36|0;u=E+24|0;r=E+12|0;s=E;B=d+528|0;y=B;y=z0(c[y>>2]|0,c[y+4>>2]|0,4,0)|0;A=B;c[A>>2]=y;c[A+4>>2]=z;KK(d);A=B;A=z0(c[A>>2]|0,c[A+4>>2]|0,8,0)|0;y=B;c[y>>2]=A;c[y+4>>2]=z;NB(d,m);NB(d,n);y=B;y=z0(c[y>>2]|0,c[y+4>>2]|0,14,0)|0;A=B;c[A>>2]=y;c[A+4>>2]=z;EG(d,f);f=a[f>>0]|0;if((f&255)<32){y=B;y=z0(c[y>>2]|0,c[y+4>>2]|0,1,0)|0;A=B;c[A>>2]=y;c[A+4>>2]=z;iF(d,f&255,0);A=31-(f&255)|0;e1(d,A,((A|0)<0)<<31>>31)}else iF(d,32,0);NB(d,h);j=b[h>>1]|0;a:do if((j+-33&65535)>=31){NB(d,i);switch(j<<16>>16){case 1:{x=1;y=1;break a}case 0:{x=0;y=0;break a}default:{}}if((j&65535)>8|(b[i>>1]|0)!=0){x=0;y=j}else{ID(d,D);f=B;f=z0(c[f>>2]|0,c[f+4>>2]|0,2,0)|0;h=B;c[h>>2]=f;c[h+4>>2]=z;NB(d,u);h=e[u>>1]|0;f=c[D>>2]|0;while(1){if(f>>>0>h>>>0)break;y=B;y=z0(c[y>>2]|0,c[y+4>>2]|0,8,0)|0;A=B;c[A>>2]=y;c[A+4>>2]=z;f=f+1|0}x=0;y=j}}else{y=(j&65535)+65504&65535;b[h>>1]=y;NB(d,i);x=1}while(0);if((c[d+784>>2]|0)==0?qO(d)|0:0){c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[D+(f<<2)>>2]=0;f=f+1|0}t=d+520|0;v=t;v=XZ(c[v>>2]|0,c[v+4>>2]|0,24)|0;ay(D,1,v&255)|0;v=t;v=XZ(c[v>>2]|0,c[v+4>>2]|0,16)|0;ay(D,1,v&255)|0;v=t;v=XZ(c[v>>2]|0,c[v+4>>2]|0,8)|0;ay(D,1,v&255)|0;ay(D,1,c[t>>2]&255)|0;v=D+11|0;VU(u,(a[v>>0]|0)<0?c[D>>2]|0:D);A=d+20|0;Rf(d,u,1,c[A>>2]|0,1);z5(u);bw(d,1,c[A>>2]|0,58,D,0,1);bw(d,1,c[A>>2]|0,63,D,0,1);f=j9(377368)|0;j=a[v>>0]|0;w=D+4|0;if((f|0)==((j<<24>>24<0?c[w>>2]|0:j&255)|0)?(ZG(D,377368,f)|0)==0:0)RB(d,1,c[A>>2]|0,327,377373,-1,1,0);f=j9(377385)|0;j=a[v>>0]|0;if((f|0)==((j<<24>>24<0?c[w>>2]|0:j&255)|0)?(ZG(D,377385,f)|0)==0:0)RB(d,1,c[A>>2]|0,327,390558,-1,1,0);h=b[m>>1]|0;if(h<<16>>16)kL(d,1,c[A>>2]|0,130,h,10,1);f=b[n>>1]|0;if((f<<16>>16?(kL(d,1,c[A>>2]|0,138,f,10,1),o=d+800|0,k=+g[o>>2],k!=0.0):0)?(p=+(h&65535),q=+(f&65535),k!=p/q):0){Bt(d,1,c[A>>2]|0,156,k,3,1);Bt(d,1,c[A>>2]|0,150,q*(+g[o>>2]/p),3,1)}o=d+804|0;Bt(d,1,c[A>>2]|0,165,+g[o>>2],3,0);k=+g[o>>2];if(k!=0.0){h=c[A>>2]|0;ST(s,k,0);HX(s,24472)|0;c[r>>2]=c[s>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];f=0;while(1){if((f|0)==3)break;c[s+(f<<2)>>2]=0;f=f+1|0}p2(u,r);zb(d,1,h,166,u,0);z5(u);O0(r);z5(s)}n=d+916|0;o=d+788|0;s=bF(n,o)|0;r=d+536|0;b:do if((c[s+12>>2]|0)==(c[s+16>>2]|0)){TX(u);f=Aj(1,1,lh(u,c[t>>2]|0)|0,1)|0;h=i9(39980)|0;s=a[f+8+3>>0]|0;if((h|0)==((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)){s=(VG(f,39980,h)|0)==0;z5(u);if(s){f=ZW(1056)|0;Mr(f);a[f+768>>0]=1;h=bF(n,o)|0;c[u>>2]=f;i=h+16|0;j=c[i>>2]|0;if(j>>>0<(c[h+20>>2]|0)>>>0){c[j>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(h+12|0,u)}}else z5(u);TX(u);f=Aj(1,1,lh(u,c[t>>2]|0)|0,1)|0;h=i9(29424)|0;s=a[f+8+3>>0]|0;if((h|0)==((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)){s=(VG(f,29424,h)|0)==0;z5(u);if(s){f=ZW(776)|0;bN(f);a[f+768>>0]=1;h=bF(n,o)|0;c[u>>2]=f;i=h+16|0;j=c[i>>2]|0;if(j>>>0<(c[h+20>>2]|0)>>>0){c[j>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(h+12|0,u)}}else z5(u);TX(u);f=Aj(1,1,lh(u,c[t>>2]|0)|0,1)|0;h=i9(24480)|0;s=a[f+8+3>>0]|0;if((h|0)==((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)){s=(VG(f,24480,h)|0)==0;z5(u);if(s){f=ZW(960)|0;Vw(f);a[f+768>>0]=1;h=bF(n,o)|0;c[u>>2]=f;i=h+16|0;j=c[i>>2]|0;if(j>>>0<(c[h+20>>2]|0)>>>0){c[j>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(h+12|0,u)}}else z5(u);TX(u);f=Aj(1,1,lh(u,c[t>>2]|0)|0,1)|0;h=i9(29964)|0;s=a[f+8+3>>0]|0;if((h|0)==((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)){s=(VG(f,29964,h)|0)==0;z5(u);if(s){f=ZW(1104)|0;ln(f);a[f+776>>0]=1;h=bF(n,o)|0;c[u>>2]=f;i=h+16|0;j=c[i>>2]|0;if(j>>>0<(c[h+20>>2]|0)>>>0){c[j>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(h+12|0,u)}}else z5(u);s=t;m=d+761|0;do if(!((c[s>>2]|0)==1986211121&(c[s+4>>2]|0)==0)){TX(u);f=Aj(1,1,lh(u,c[t>>2]|0)|0,1)|0;h=i9(30008)|0;s=a[f+8+3>>0]|0;if((h|0)!=((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)){z5(u);break}s=(VG(f,30008,h)|0)==0;z5(u);if(s){f=ZW(920)|0;Wv(f);a[f+768>>0]=1;aY(d,f);rB(d,f);j=r;i=c[j+4>>2]|0;h=B;c[h>>2]=c[j>>2];c[h+4>>2]=i;h=bF(n,o)|0;c[u>>2]=f;i=h+16|0;j=c[i>>2]|0;if(j>>>0<(c[h+20>>2]|0)>>>0){c[j>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(h+12|0,u);a[m>>0]=1}}while(0);TX(u);f=Aj(1,1,lh(u,c[t>>2]|0)|0,1)|0;h=i9(24500)|0;s=a[f+8+3>>0]|0;if((h|0)==((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)){s=(VG(f,24500,h)|0)==0;z5(u);if(s){f=ZW(824)|0;kM(f);h=bF(n,o)|0;c[u>>2]=f;i=h+16|0;j=c[i>>2]|0;if(j>>>0<(c[h+20>>2]|0)>>>0){c[j>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(h+12|0,u)}}else z5(u);VU(u,(a[v>>0]|0)<0?c[D>>2]|0:D);f=Aj(1,1,u,1)|0;h=i9(24520)|0;s=a[f+8+3>>0]|0;do if((h|0)==((s<<24>>24<0?c[f+4>>2]|0:s&255)|0)){s=(VG(f,24520,h)|0)==0;z5(u);if(!s){f=0;break}f=ZW(976)|0;zr(f);h=bF(n,o)|0;c[u>>2]=f;i=h+16|0;j=c[i>>2]|0;if(j>>>0<(c[h+20>>2]|0)>>>0){c[j>>2]=f;c[i>>2]=(c[i>>2]|0)+4}else Yy(h+12|0,u);f=0}else{z5(u);f=0}while(0);while(1){u=bF(n,o)|0;if(f>>>0>=(c[u+16>>2]|0)-(c[u+12>>2]|0)>>2>>>0)break b;if(!(c[(c[(c[(bF(n,o)|0)+12>>2]|0)+(f<<2)>>2]|0)+728>>2]&1)){s=t;j=c[s>>2]|0;s=c[s+4>>2]|0;u=t;c[u>>2]=c[o>>2];c[u+4>>2]=0;aY(d,c[(c[(bF(n,o)|0)+12>>2]|0)+(f<<2)>>2]|0);u=t;c[u>>2]=j;c[u+4>>2]=s;a[m>>0]=1}f=f+1|0}}while(0);f=j9(377363)|0;i=a[v>>0]|0;h=c[w>>2]|0;if((f|0)==((i<<24>>24<0?h:i&255)|0))if(!(ZG(D,377363,f)|0))m=96;else{i=a[v>>0]|0;h=c[w>>2]|0;m=93}else m=93;do if((m|0)==93){f=j9(377390)|0;if((f|0)==((i<<24>>24<0?h:i&255)|0)){if(!(ZG(D,377390,f)|0)){m=96;break}i=a[v>>0]|0;h=c[w>>2]|0}f=j9(377395)|0;if((f|0)==((i<<24>>24<0?h:i&255)|0)?(ZG(D,377395,f)|0)==0:0)sM(d,1,c[A>>2]|0,195,10,0)}while(0);do if((m|0)==96){if(x){RB(d,1,c[A>>2]|0,191,381128,-1,1,1);kL(d,1,c[A>>2]|0,195,y,10,0);break}f=c[A>>2]|0;if(y<<16>>16==32){RB(d,1,f,191,379881,-1,1,1);sM(d,1,c[A>>2]|0,195,8,0);break}else{sM(d,1,f,195,((y&65535)/3|0)&65535,0);break}}while(0);j=B;i=c[j>>2]|0;j=c[j+4>>2]|0;B=z0(i|0,j|0,8,0)|0;A=z;h=r;f=c[h>>2]|0;h=c[h+4>>2]|0;if((((!(A>>>0>h>>>0|(A|0)==(h|0)&B>>>0>f>>>0)?(C=(c[d+544>>2]|0)+(c[d+612>>2]|0)+i+4|0,B=D9(a[C>>0]|0)|0,(B+-65&255)<58|(B+-48&255)<10):0)?(B=D9(a[C+1>>0]|0)|0,(B+-65&255)<58|(B+-48&255)<10):0)?(B=D9(a[C+2>>0]|0)|0,(B+-65&255)<58|(B+-48&255)<10):0)?(C=D9(a[C+3>>0]|0)|0,(C+-65&255)<58|(C+-48&255)<10):0)o7(d);else m=110;if((m|0)==110?j>>>0<h>>>0|(j|0)==(h|0)&i>>>0<f>>>0:0)nh(d);a1(D)}l=E;return}function mc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+48|0;n=r+24|0;o=r+12|0;m=r;TX(n);iX(o,b);vF(n,o)|0;z5(o);p=b+1048|0;d=c[p>>2]|0;q=b+1052|0;a:do if((d|0)!=(c[q>>2]|0)){e=i9(18324)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,18324,e)|0)==0:0){Xy(o,18376);vF(c[p>>2]|0,o)|0;z5(o)}f=c[p>>2]|0;d=i9(18420)|0;e=a[f+8+3>>0]|0;g=c[f+4>>2]|0;if((d|0)==((e<<24>>24<0?g:e&255)|0)){if(!(VG(f,18420,d)|0))break;f=c[p>>2]|0;e=a[f+8+3>>0]|0;g=c[f+4>>2]|0}d=i9(18448)|0;if((d|0)==((e<<24>>24<0?g:e&255)|0)){if(!(VG(f,18448,d)|0))break;f=c[p>>2]|0;e=a[f+8+3>>0]|0;g=c[f+4>>2]|0}d=i9(18520)|0;if((d|0)==((e<<24>>24<0?g:e&255)|0)?(VG(f,18520,d)|0)==0:0){Xy(o,18572);vF(c[p>>2]|0,o)|0;z5(o)}d=c[p>>2]|0;e=i9(18620)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,18620,e)|0)==0:0){Xy(o,18660);vF(c[p>>2]|0,o)|0;z5(o)}d=c[p>>2]|0;e=i9(18700)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,18700,e)|0)==0:0){Xy(o,18756);vF(c[p>>2]|0,o)|0;z5(o);DW(n,0,42232)|0}d=c[p>>2]|0;e=i9(18808)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,18808,e)|0)==0:0){Xy(o,18868);vF(c[p>>2]|0,o)|0;z5(o);DW(n,0,42232)|0}d=c[p>>2]|0;e=i9(18924)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,18924,e)|0)==0:0){Xy(o,18976);vF(c[p>>2]|0,o)|0;z5(o)}d=c[p>>2]|0;e=i9(19032)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,19032,e)|0)==0:0){Xy(o,18976);vF(c[p>>2]|0,o)|0;z5(o)}d=c[p>>2]|0;e=i9(19088)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,19088,e)|0)==0:0){Xy(o,19136);vF(c[p>>2]|0,o)|0;z5(o)}d=c[p>>2]|0;e=i9(19184)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,19184,e)|0)==0:0){Xy(o,19228);vF(c[p>>2]|0,o)|0;z5(o)}d=c[p>>2]|0;e=i9(19268)|0;k=a[d+8+3>>0]|0;if((e|0)==((k<<24>>24<0?c[d+4>>2]|0:k&255)|0)?(VG(d,19268,e)|0)==0:0){Xy(o,19300);vF(c[p>>2]|0,o)|0;z5(o)}g=c[p>>2]|0;d=i9(19364)|0;e=a[g+8+3>>0]|0;f=c[g+4>>2]|0;if((d|0)==((e<<24>>24<0?f:e&255)|0)){if(!(VG(g,19364,d)|0))break;g=c[p>>2]|0;e=a[g+8+3>>0]|0;f=c[g+4>>2]|0}d=i9(19380)|0;j=n+8+3|0;k=n+4|0;if((d|0)==((e<<24>>24<0?f:e&255)|0)?(VG(g,19380,d)|0)==0:0){d=a[j>>0]|0;e=d<<24>>24<0;h=e?c[n>>2]|0:n;f=i9(24620)|0;if(!f)break;g=h+((e?c[k>>2]|0:d&255)<<2)|0;i=HA(h,g,24620,24620+(f<<2)|0)|0;e=h;if(!((i|0)==(g|0)|(i-e|0)==-4))break;d=i9(24652)|0;if(!d)break;i=HA(h,g,24652,24652+(d<<2)|0)|0;if(!((i|0)==(g|0)|(i-e|0)==-4))break;d=i9(24684)|0;if(!d)break;i=HA(h,g,24684,24684+(d<<2)|0)|0;if(!((i|0)==(g|0)|(i-e|0)==-4))break;d=i9(24704)|0;if(!d)break;i=HA(h,g,24704,24704+(d<<2)|0)|0;if(!((i|0)==(g|0)|(i-e|0)==-4))break;Xy(o,19432);vF(c[p>>2]|0,o)|0;z5(o)}d=c[p>>2]|0;e=i9(19456)|0;i=a[d+8+3>>0]|0;if((e|0)==((i<<24>>24<0?c[d+4>>2]|0:i&255)|0)?(VG(d,19456,e)|0)==0:0){Xy(o,19492);vF(c[p>>2]|0,o)|0;z5(o)}f=c[p>>2]|0;d=i9(19528)|0;e=a[f+8+3>>0]|0;g=c[f+4>>2]|0;if((d|0)==((e<<24>>24<0?g:e&255)|0)){if(!(VG(f,19528,d)|0))break;f=c[p>>2]|0;e=a[f+8+3>>0]|0;g=c[f+4>>2]|0}d=i9(19576)|0;if((d|0)==((e<<24>>24<0?g:e&255)|0)){if(!(VG(f,19576,d)|0))break;f=c[p>>2]|0;e=a[f+8+3>>0]|0;g=c[f+4>>2]|0}d=i9(19632)|0;do if((d|0)==((e<<24>>24<0?g:e&255)|0)){if(VG(f,19632,d)|0)break;Xy(o,19680);vF(c[p>>2]|0,o)|0;z5(o)}while(0);d=c[p>>2]|0;e=i9(19740)|0;i=a[d+8+3>>0]|0;do if((e|0)==((i<<24>>24<0?c[d+4>>2]|0:i&255)|0)){if(VG(d,19740,e)|0)break;Xy(o,19820);vF(c[p>>2]|0,o)|0;z5(o)}while(0);d=c[p>>2]|0;e=i9(19896)|0;i=a[d+8+3>>0]|0;do if((e|0)==((i<<24>>24<0?c[d+4>>2]|0:i&255)|0)){if(VG(d,19896,e)|0)break;i=c[p>>2]|0;d=i;if(((c[q>>2]|0)-i|0)!=24)break;e=i9(19632)|0;i=a[d+20+3>>0]|0;if((e|0)!=((i<<24>>24<0?c[d+16>>2]|0:i&255)|0))break;if(!(VG(d+12|0,19632,e)|0))break a}while(0);d=c[p>>2]|0;e=i9(19896)|0;i=a[d+8+3>>0]|0;do if((e|0)==((i<<24>>24<0?c[d+4>>2]|0:i&255)|0)){if(VG(d,19896,e)|0)break;i=c[p>>2]|0;d=i;if(((c[q>>2]|0)-i|0)!=24)break;e=i9(19924)|0;i=a[d+20+3>>0]|0;if((e|0)!=((i<<24>>24<0?c[d+16>>2]|0:i&255)|0))break;if(VG(d+12|0,19924,e)|0)break;ME(p,1);Xy(o,19948);vF(c[p>>2]|0,o)|0;z5(o)}while(0);f=c[p>>2]|0;d=i9(19992)|0;e=a[f+8+3>>0]|0;g=c[f+4>>2]|0;if((d|0)==((e<<24>>24<0?g:e&255)|0)){if(!(VG(f,19992,d)|0))break;f=c[p>>2]|0;e=a[f+8+3>>0]|0;g=c[f+4>>2]|0}d=i9(20040)|0;do if((d|0)==((e<<24>>24<0?g:e&255)|0)){if(VG(f,20040,d)|0)break;Xy(o,18376);vF(c[p>>2]|0,o)|0;z5(o)}while(0);d=c[p>>2]|0;e=i9(20092)|0;h=a[d+8+3>>0]|0;i=b+904|0;b=b+892|0;do if((e|0)==((h<<24>>24<0?c[d+4>>2]|0:h&255)|0)){if(VG(d,20092,e)|0)break;d=a[j>>0]|0;e=d<<24>>24<0;h=e?c[n>>2]|0:n;f=i9(24620)|0;if(!f)break a;g=h+((e?c[k>>2]|0:d&255)<<2)|0;k=HA(h,g,24620,24620+(f<<2)|0)|0;e=h;if(!((k|0)==(g|0)|(k-e|0)==-4))break a;d=i9(24652)|0;if(!d)break a;k=HA(h,g,24652,24652+(d<<2)|0)|0;if(!((k|0)==(g|0)|(k-e|0)==-4))break a;d=i9(24684)|0;if(!d)break a;k=HA(h,g,24684,24684+(d<<2)|0)|0;if(!((k|0)==(g|0)|(k-e|0)==-4))break a;d=i9(24704)|0;if(!d)break a;k=HA(h,g,24704,24704+(d<<2)|0)|0;if(!((k|0)==(g|0)|(k-e|0)==-4))break a;Xy(o,20128);vF(c[p>>2]|0,o)|0;z5(o);VU(o,373113);k=uC(b,i)|0;VU(m,373127);vF(AG(k,m)|0,o)|0;z5(m);z5(o)}while(0);d=c[p>>2]|0;e=i9(19924)|0;m=a[d+8+3>>0]|0;do if((e|0)==((m<<24>>24<0?c[d+4>>2]|0:m&255)|0)){if(VG(d,19924,e)|0)break;Xy(o,19432);vF(c[p>>2]|0,o)|0;z5(o)}while(0);d=c[p>>2]|0;e=i9(20208)|0;m=a[d+8+3>>0]|0;do if((e|0)==((m<<24>>24<0?c[d+4>>2]|0:m&255)|0)){if(VG(d,20208,e)|0)break;Xy(o,20256);vF(c[p>>2]|0,o)|0;z5(o)}while(0);f=0;while(1){m=c[p>>2]|0;d=m;if(f>>>0>=(((c[q>>2]|0)-m|0)/12|0)>>>0)break;e=i9(20340)|0;m=a[d+(f*12|0)+8+3>>0]|0;do if((e|0)==((m<<24>>24<0?c[d+(f*12|0)+4>>2]|0:m&255)|0)){if(VG(d+(f*12|0)|0,20340,e)|0)break;Xy(o,20372);vF((c[p>>2]|0)+(f*12|0)|0,o)|0;z5(o)}while(0);d=c[p>>2]|0;e=i9(20404)|0;m=a[d+(f*12|0)+8+3>>0]|0;do if((e|0)==((m<<24>>24<0?c[d+(f*12|0)+4>>2]|0:m&255)|0)){if(VG(d+(f*12|0)|0,20404,e)|0)break;Xy(o,20436);vF((c[p>>2]|0)+(f*12|0)|0,o)|0;z5(o)}while(0);d=c[p>>2]|0;e=i9(20468)|0;m=a[d+(f*12|0)+8+3>>0]|0;do if((e|0)==((m<<24>>24<0?c[d+(f*12|0)+4>>2]|0:m&255)|0)){if(VG(d+(f*12|0)|0,20468,e)|0)break;Xy(o,20504);vF((c[p>>2]|0)+(f*12|0)|0,o)|0;z5(o)}while(0);d=c[p>>2]|0;e=i9(20540)|0;m=a[d+(f*12|0)+8+3>>0]|0;do if((e|0)==((m<<24>>24<0?c[d+(f*12|0)+4>>2]|0:m&255)|0)){if(VG(d+(f*12|0)|0,20540,e)|0)break;Xy(o,20556);vF((c[p>>2]|0)+(f*12|0)|0,o)|0;z5(o)}while(0);f=f+1|0}TX(o);d=0;while(1){m=c[p>>2]|0;e=m;if(d>>>0>=(((c[q>>2]|0)-m|0)/12|0)>>>0)break;j=e+(d*12|0)|0;m=a[e+(d*12|0)+8+3>>0]|0;k=m<<24>>24<0;Ex(o,k?c[j>>2]|0:j,k?c[e+(d*12|0)+4>>2]|0:m&255)|0;d=d+1|0;if(d>>>0>=(((c[q>>2]|0)-(c[p>>2]|0)|0)/12|0)>>>0)continue;Gx(o,47)}k1(yG(uC(b,i)|0,o)|0,n)|0;z5(o)}while(0);z5(n);l=r;return}function nc(f){f=f|0;var g=0,i=0,j=0.0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+48|0;r=v+36|0;s=v+24|0;t=v+12|0;u=v;Kc(f,1,-1)|0;RB(f,1,0,18,391429,-1,1,0);RB(f,1,0,58,391490,-1,1,0);q=f+857|0;g=a[q>>0]|0;if(g<<24>>24){RB(f,1,0,24,Mi(g&255)|0,-1,1,0);RB(f,1,0,64,Mi(d[q>>0]|0)|0,-1,1,0)}g=a[f+870>>0]|0;m=f+20|0;if(g<<24>>24!=-1)KW(f,1,c[m>>2]|0,171,+h[736+((g&255)<<3)>>3],3,0);g=c[f+836>>2]|0;if((g|0)!=-1)lL(f,1,c[m>>2]|0,124,g*400|0,10,0);g=c[f+840>>2]|0;if((g|0)!=-1)lL(f,1,c[m>>2]|0,328,g<<11,10,0);g=c[f+824>>2]|0;if(g|0?(i=b[f+852>>1]|0,i<<16>>16):0)Bt(f,1,c[m>>2]|0,171,+(i&65535)/+(g>>>0),3,0);i=f+850|0;if(b[i>>1]|0){k=f+848|0;kL(f,1,c[m>>2]|0,130,b[k>>1]|0,10,0);kL(f,1,c[m>>2]|0,138,b[i>>1]|0,10,0);switch(a[f+859>>0]|0){case 2:{j=1.0909091234207153;break}case 3:{j=.9090909361839294;break}case 4:{j=1.454545497894287;break}case 5:{j=1.2121212482452393;break}case 15:{g=a[f+861>>0]|0;if(!(g<<24>>24))j=1.0;else j=+(d[f+860>>0]|0)/+(g&255);break}default:j=1.0}Bt(f,1,0,150,j,3,1);Bt(f,1,c[m>>2]|0,156,j*(+(e[k>>1]|0)/+(e[i>>1]|0)),3,1)}RB(f,1,0,191,a[f+910>>0]|0?384047:384021,-1,1,0);mL(f,1,0,195,a[f+862>>0]|0,10,0);g=a[f+866>>0]|0;if((g&255)<4)RB(f,1,0,190,c[35868+((g&255)<<2)>>2]|0,-1,1,0);if(a[f+909>>0]|0){RB(f,1,0,330,382808,-1,1,0);RB(f,1,0,331,mD(a[f+867>>0]|0)|0,-1,1,0);RB(f,1,0,332,Zx(a[f+868>>0]|0)|0,-1,1,0);p=f+869|0;RB(f,1,0,333,SA(a[p>>0]|0)|0,-1,1,0);RB(f,1,0,191,ZT(a[p>>0]|0)|0,-1,1,1)}if(!(a[f+872>>0]|0)){RB(f,1,0,31,382921,-1,1,0);RB(f,1,0,32,382808,-1,1,0);RB(f,1,0,66,382921,-1,1,0);RB(f,1,0,68,382808,-1,1,0)}else{RB(f,1,0,32,382840,-1,1,0);RB(f,1,0,68,382840,-1,1,0)}i=f+858|0;if(!(a[i>>0]|0)){sM(f,1,0,36,0,0);sM(f,1,0,70,0,0)}else{Xy(t,35632);uU(u,a[i>>0]|0,10);g=a[u+8+3>>0]|0;p=g<<24>>24<0;Ex(t,p?c[u>>2]|0:u,p?c[u+4>>2]|0:g&255)|0;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];g=0;while(1){if((g|0)==3)break;c[t+(g<<2)>>2]=0;g=g+1|0}p2(r,s);zb(f,1,0,31,r,0);z5(r);O0(s);z5(u);z5(t);mL(f,1,0,36,a[i>>0]|0,10,0);Xy(t,35632);uU(u,a[i>>0]|0,10);g=a[u+8+3>>0]|0;p=g<<24>>24<0;Ex(t,p?c[u>>2]|0:u,p?c[u+4>>2]|0:g&255)|0;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];g=0;while(1){if((g|0)==3)break;c[t+(g<<2)>>2]=0;g=g+1|0}p2(r,s);zb(f,1,0,66,r,0);z5(r);O0(s);z5(u);z5(t);mL(f,1,0,70,a[i>>0]|0,10,0)}if(!(a[f+871>>0]|0)){RB(f,1,0,34,382840,-1,1,0);RB(f,1,0,69,382840,-1,1,0)}else{RB(f,1,0,31,381226,-1,1,0);RB(f,1,0,34,382808,-1,1,0);RB(f,1,0,66,381226,-1,1,0);RB(f,1,0,69,382808,-1,1,0)}do if(!(a[f+906>>0]|0)){RB(f,1,0,38,381231,-1,1,0);RB(f,1,0,72,381231,-1,1,0)}else{if((a[f+875>>0]|0)==0?(a[f+876>>0]|0)==0:0){if((a[f+873>>0]|0)==0?(a[f+874>>0]|0)==0:0){RB(f,1,0,38,381296,-1,1,0);RB(f,1,0,72,381296,-1,1,0);break}RB(f,1,0,31,381282,-1,1,0);RB(f,1,0,38,382825,-1,1,0);zb(f,1,0,40,f+960|0,0);zb(f,1,0,40,f+972|0,0);RB(f,1,0,66,381282,-1,1,0);RB(f,1,0,72,382825,-1,1,0);break}RB(f,1,0,31,381247,-1,1,0);RB(f,1,0,38,381268,-1,1,0);RB(f,1,0,66,381247,-1,1,0);RB(f,1,0,72,381268,-1,1,0)}while(0);do if(a[f+877>>0]|0){RB(f,1,0,197,384063,-1,1,0);k=f+808|0;g=(c[f+812>>2]|0)==0;if(!(c[k>>2]|0))if(g)i=53;else{g=384078;i=54}else if(g){g=384074;i=54}else i=53;if((i|0)==53){RB(f,1,0,211,384063,-1,1,0);break}else if((i|0)==54){RB(f,1,0,204,g,-1,1,0);RB(f,1,0,211,c[k>>2]|0?384074:384078,-1,1,0);break}}else{RB(f,1,0,197,384051,-1,1,0);RB(f,1,0,211,383620,-1,1,0)}while(0);g=a[f+920+3>>0]|0;if(g<<24>>24<0)g=c[f+916>>2]|0;else g=g&255;if(g|0){zb(f,1,0,300,f+912|0,0);zb(f,1,0,303,f+924|0,0);zb(f,1,0,304,f+936|0,0);zb(f,1,0,305,f+948|0,0)}n=f+984|0;o=f+988|0;p=s+11|0;m=0;while(1){g=c[n>>2]|0;if(m>>>0>=(((c[o>>2]|0)-g|0)/40|0)>>>0)break;g=c[g+(m*40|0)>>2]|0;i=i9(35648)|0;k=a[g+8+3>>0]|0;if((i|0)==((k<<24>>24<0?c[g+4>>2]|0:k&255)|0)?(VG(g,35648,i)|0)==0:0){TX(r);Sn(s,(c[(c[n>>2]|0)+(m*40|0)>>2]|0)+12|0);zb(f,0,0,255,gd(r,(a[p>>0]|0)<0?c[s>>2]|0:s,-1)|0,0);a1(s);z5(r)}g=c[(c[n>>2]|0)+(m*40|0)>>2]|0;i=i9(35676)|0;k=a[g+8+3>>0]|0;do if((i|0)==((k<<24>>24<0?c[g+4>>2]|0:k&255)|0)){if(VG(g,35676,i)|0)break;Bt(f,1,0,171,+Cq((c[(c[n>>2]|0)+(m*40|0)>>2]|0)+12|0),3,0)}while(0);g=c[(c[n>>2]|0)+(m*40|0)>>2]|0;i=i9(35708)|0;k=a[g+8+3>>0]|0;do if((i|0)==((k<<24>>24<0?c[g+4>>2]|0:k&255)|0)){if(VG(g,35708,i)|0)break;k=rm((c[(c[n>>2]|0)+(m*40|0)>>2]|0)+12|0)|0;oK(f,1,0,217,k,z,10,0);RB(f,1,0,226,388261,-1,1,0)}while(0);g=c[(c[n>>2]|0)+(m*40|0)>>2]|0;i=i9(35744)|0;k=a[g+8+3>>0]|0;do if((i|0)==((k<<24>>24<0?c[g+4>>2]|0:k&255)|0)){if(VG(g,35744,i)|0)break;i=c[(c[n>>2]|0)+(m*40|0)>>2]|0;g=a[i+20+3>>0]|0;if(g<<24>>24<0)g=c[i+16>>2]|0;else g=g&255;if((g|0)!=16)break;lw(s,i+12|0,3,4);p2(r,s);MN(f,1,381311,sm(r,16)|0);z5(r);O0(s);lw(s,(c[(c[n>>2]|0)+(m*40|0)>>2]|0)+12|0,7,4);p2(r,s);MN(f,1,381311,sm(r,16)|0);z5(r);O0(s);lw(s,(c[(c[n>>2]|0)+(m*40|0)>>2]|0)+12|0,11,4);p2(r,s);MN(f,1,381311,sm(r,16)|0);z5(r);O0(s);k=c[(c[n>>2]|0)+(m*40|0)>>2]|0;g=k+12|0;k=(a[k+20+3>>0]|0)<0;if(k)i=c[g>>2]|0;else i=g;if((c[i+60>>2]|0)==77){tN(f,1,0,381311,35772);break}if(k)i=c[g>>2]|0;else i=g;if((c[i+60>>2]|0)==83){tN(f,1,0,381311,35792);break}if(k)g=c[g>>2]|0;$M(f,1,0,381311,c[g+60>>2]|0)}while(0);g=c[(c[n>>2]|0)+(m*40|0)>>2]|0;i=i9(35812)|0;k=a[g+8+3>>0]|0;do if((i|0)==((k<<24>>24<0?c[g+4>>2]|0:k&255)|0)){if(VG(g,35812,i)|0)break;i=c[(c[n>>2]|0)+(m*40|0)>>2]|0;g=a[i+20+3>>0]|0;if(g<<24>>24<0)g=c[i+16>>2]|0;else g=g&255;if((g|0)!=16)break;Mc(f,1,0,381338,i+12|0,0)}while(0);m=m+1|0}do if(((((a[q>>0]|0)+31&255)>=8?a[f+905>>0]|0:0)?(a[f+863>>0]|0)!=2:0)?(a[f+882>>0]|0)==0:0){q=f+907|0;xM(f,1,0,381350,a[q>>0]|0?382808:382840,0);Ou(f,1,0,381350,382945);if(!(a[q>>0]|0))break;xM(f,1,0,381367,a[f+908>>0]|0?382808:382840,0);Ou(f,1,0,381367,382945)}while(0);m=f+796|0;if(c[m>>2]|0){$x(r,f,1,0,31,1);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;k=i9(35848)|0;if(k>>>0>1073741807)uaa();g=s+8|0;do if(k>>>0>=2){i=k+4&-4;if(i>>>0>1073741823){v=ua(8)|0;K2(v,391652);c[v>>2]=57868;Ya(v|0,2712,367)}else{q=ZW(i<<2)|0;c[s>>2]=q;c[g>>2]=i|-2147483648;c[s+4>>2]=k;g=q;break}}else{a[g+3>>0]=k;g=s}while(0);a3(g,35848,k);y7(g+(k<<2)|0,0);sU(u,c[m>>2]|0,10);DW(u,0,35848)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}vo(r,s,t,0,0);O0(t);z5(u);O0(s);zb(f,1,0,31,r,1);lL(f,1,0,32,c[m>>2]|0,10,1);z5(r)}u=f+816|0;if((c[u>>2]|0)==2&(c[u+4>>2]|0)==0){VU(s,381382);pl(r,s);zb(f,1,0,51,r,0);z5(r);z5(s);RB(f,1,0,66,381409,-1,1,0);RB(f,1,0,67,382808,-1,1,0)}else RB(f,1,0,67,382840,-1,1,0);l=v;return}function oc(b){b=b|0;var d=0,e=0,f=0,g=0,i=0,j=0.0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0;fa=l;l=l+48|0;X=fa;Z=fa+32|0;if(a[b+761>>0]|0?(ca=b+64|0,da=ca,(c[da>>2]|0)==-1?(c[da+4>>2]|0)==-1:0):0){da=b+908|0;aa=b+916|0;a:do if(!(a[da>>0]|0)){m=b+920|0;n=X+8+3|0;o=X+4|0;p=Z+8+3|0;q=Z+4|0;d=c[aa>>2]|0;b:while(1){if((d|0)==(m|0))break a;c:do if((c[d+68>>2]|0)==2){f=d+72|0;$x(X,b,2,c[f>>2]|0,46,1);e=i9(22752)|0;W=a[n>>0]|0;if((e|0)==((W<<24>>24<0?c[o>>2]|0:W&255)|0)?(VG(X,22752,e)|0)==0:0)z5(X);else $=10;do if(($|0)==10){$=0;$x(Z,b,2,c[f>>2]|0,46,1);e=i9(25496)|0;W=a[p>>0]|0;if((e|0)==((W<<24>>24<0?c[q>>2]|0:W&255)|0)){W=(VG(Z,25496,e)|0)==0;z5(Z);z5(X);if(W)break;else break c}else{z5(Z);z5(X);break c}}while(0);g=d+152|0;V=g;V=XZ(c[V>>2]|0,c[V+4>>2]|0,4)|0;V=UW(V|0,z|0,17,0)|0;W=g;c[W>>2]=V;c[W+4>>2]=z;$x(X,b,2,c[f>>2]|0,116,1);j=+Cq(X);z5(X);if(j!=0.0)Bt(b,2,c[f>>2]|0,116,j*.0625*17.0,0,1);$x(X,b,2,c[f>>2]|0,122,1);i=rm(X)|0;e=z;z5(X);k=(i|0)!=2|(e|0)!=0;if(k){V=g;V=XZ(c[V>>2]|0,c[V+4>>2]|0,1)|0;V=UW(V|0,z|0,i|0,e|0)|0;W=g;c[W>>2]=V;c[W+4>>2]=z}g=c[d+112>>2]|0;f=(c[d+116>>2]|0)-g>>3;e=0;while(1){if((e|0)==(f|0))break c;W=g+(e<<3)+4|0;V=((c[W>>2]|0)>>>4)*17|0;U=O(V>>>1,i)|0;c[W>>2]=k?U:V;e=e+1|0}}while(0);e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue b}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}}while(0);V=b+936|0;e=c[V>>2]|0;U=b+940|0;d=c[U>>2]|0;W=b+948|0;T=b+956|0;if((e|0)==(d|0)){Wc(e,e);I=b+920|0;J=X+16|0;K=X+8|0;L=b+944|0;M=b+40|0;N=X+16|0;P=X+8|0;Q=b+880|0;R=X+16|0;S=X+8|0;d=c[aa>>2]|0;d:while(1){if((d|0)==(I|0))break;F=d+16|0;G=d+36|0;H=d+40|0;e:do if((c[G>>2]|0)!=(c[H>>2]|0)){e=a[d+32+3>>0]|0;if(e<<24>>24<0)e=c[d+28>>2]|0;else e=e&255;if(!e){f=d+104|0;e=d+100|0;if(c[d+64>>2]|0?(c[f>>2]|0)-(c[e>>2]|0)>>3>>>0>1:0)LI(e,1);C=d+124|0;D=d+128|0;E=d+184|0;if((c[C>>2]|0)==(c[D>>2]|0)?(B=E,(c[B>>2]|0)==0&(c[B+4>>2]|0)==0):0)break;if((c[d+68>>2]|0)==2){A=d+72|0;$x(X,b,2,c[A>>2]|0,147,1);B=pn(X)|0;$x(Z,b,2,c[A>>2]|0,122,1);B=(O(pn(Z)|0,B)|0)>>>3;z5(Z);z5(X)}else B=0;e=c[e>>2]|0;u=c[f>>2]|0;if((e|0)!=(u|0)?(Y=c[d+112>>2]|0,_=c[d+116>>2]|0,(Y|0)!=(_|0)):0){v=c[C>>2]|0;w=c[D>>2]|0;f=(v|0)==(w|0)?0:v;v=f+(w-v>>3<<3)|0;w=F+277|0;x=d+192|0;y=u+-8|0;A=(B|0)==0;i=Y;t=1;n=0;f:while(1){if(e>>>0<u>>>0)s=i;else break;while(1){g=s+8|0;if(g>>>0>=_>>>0)break;if(t>>>0<(c[g>>2]|0)>>>0)break;else s=g}i=E;g=c[i>>2]|0;i=c[i+4>>2]|0;k=(s|0)!=0;r=s+4|0;do if(k&((g|0)==0&(i|0)==0)){if((c[C>>2]|0)==(c[D>>2]|0)){$=57;break}else{m=0;k=0;i=0}while(1){if(m>>>0>=(c[r>>2]|0)>>>0)break;q=f;if(!((c[q>>2]|0)==0&(c[q+4>>2]|0)==0)){q=e;q=z0(c[q>>2]|0,c[q+4>>2]|0,k|0,i|0)|0;p=X;c[p>>2]=q;c[p+4>>2]=z;c[J>>2]=c[F>>2];p=f;q=c[p+4>>2]|0;g=K;c[g>>2]=c[p>>2];c[g+4>>2]=q;g=c[U>>2]|0;if((g|0)==(c[L>>2]|0))Hs(V,X);else{c[g>>2]=c[X>>2];c[g+4>>2]=c[X+4>>2];c[g+8>>2]=c[X+8>>2];c[g+12>>2]=c[X+12>>2];c[g+16>>2]=c[X+16>>2];c[g+20>>2]=c[X+20>>2];c[g+24>>2]=c[X+24>>2];c[g+28>>2]=c[X+28>>2];c[U>>2]=(c[U>>2]|0)+32}g=f;g=z0(c[g>>2]|0,c[g+4>>2]|0,k|0,i|0)|0;f=f+8|0;if(f>>>0<v>>>0)i=z;else break}else g=k;m=m+1|0;k=g}if(f>>>0<v>>>0)g=n;else break f}else $=57;while(0);g:do if(($|0)==57){$=0;do if(a[w>>0]|0){if(A){if(!k)break}else if(!(k&(i>>>0<0|(i|0)==0&g>>>0<=B>>>0)))break;i=UW(c[r>>2]|0,0,g|0,i|0)|0;g=x;g=UW(i|0,z|0,c[g>>2]|0,c[g+4>>2]|0)|0;i=z;if(!(i>>>0<0|(i|0)==0&g>>>0<16777216))break;p=e;q=c[p+4>>2]|0;r=X;c[r>>2]=c[p>>2];c[r+4>>2]=q;c[R>>2]=c[F>>2];r=S;c[r>>2]=g;c[r+4>>2]=i;g=c[U>>2]|0;if((g|0)==(c[L>>2]|0))Hs(V,X);else{c[g>>2]=c[X>>2];c[g+4>>2]=c[X+4>>2];c[g+8>>2]=c[X+8>>2];c[g+12>>2]=c[X+12>>2];c[g+16>>2]=c[X+16>>2];c[g+20>>2]=c[X+20>>2];c[g+24>>2]=c[X+24>>2];c[g+28>>2]=c[X+28>>2];c[U>>2]=(c[U>>2]|0)+32}g=n;break g}while(0);if(s>>>0<_>>>0){q=0;g=n;i=0;k=0}else{g=n;break}h:while(1){if(q>>>0>=(c[r>>2]|0)>>>0)break;n=E;m=c[n>>2]|0;n=c[n+4>>2]|0;do if(!((m|0)==0&(n|0)==0)){p=x;o=c[p>>2]|0;p=c[p+4>>2]|0;if((o|0)==0&(p|0)==0)break;m=UW(o|0,p|0,m|0,n|0)|0;n=z;p=M;o=c[p+4>>2]|0;if(!(n>>>0<o>>>0|((n|0)==(o|0)?m>>>0<(c[p>>2]|0)>>>0:0))){e=y;break h}p=e;p=z0(c[p>>2]|0,c[p+4>>2]|0,i|0,k|0)|0;o=X;c[o>>2]=p;c[o+4>>2]=z;c[N>>2]=c[F>>2];o=P;c[o>>2]=m;c[o+4>>2]=n;o=c[U>>2]|0;if((o|0)==(c[L>>2]|0))Hs(V,X);else{c[o>>2]=c[X>>2];c[o+4>>2]=c[X+4>>2];c[o+8>>2]=c[X+8>>2];c[o+12>>2]=c[X+12>>2];c[o+16>>2]=c[X+16>>2];c[o+20>>2]=c[X+20>>2];c[o+24>>2]=c[X+24>>2];c[o+28>>2]=c[X+28>>2];c[U>>2]=(c[U>>2]|0)+32}i=z0(m|0,n|0,i|0,k|0)|0;k=z;p=M;o=c[p+4>>2]|0;if(k>>>0<o>>>0|((k|0)==(o|0)?i>>>0<(c[p>>2]|0)>>>0:0))g=g+1|0;else{e=y;break h}}while(0);q=q+1|0}if(g>>>0>=(c[Q>>2]|0)>>>0)break f}while(0);i=s;e=e+8|0;t=t+1|0;n=g}m=c[G>>2]|0;f=(c[H>>2]|0)-m>>2;g=d+248|0;i=d+216|0;k=d+152|0;e=0;while(1){if((e|0)==(f|0))break e;o=g;n=c[o>>2]|0;o=c[o+4>>2]|0;do if(!((n|0)==0&(o|0)==0)){p=c[i>>2]|0;if(!p)break;H=k;H=PZ(c[H>>2]|0,c[H+4>>2]|0,3)|0;h[(c[m+(e<<2)>>2]|0)+592>>3]=(+(H>>>0)+4294967296.0*+(z>>>0))/((+(n>>>0)+4294967296.0*+(o>>>0))/+(p>>>0))}while(0);e=e+1|0}}}}while(0);e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue d}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}d=c[V>>2]|0;e=c[U>>2]|0;c[X>>2]=23;jd(d,e,X);e=c[V>>2]|0;d=c[U>>2]|0;$=(e|0)==(d|0)?0:e;c[W>>2]=$;c[T>>2]=$+(d-e>>5<<5)}if((e|0)!=(d|0)){a[b+909>>0]=0;i=b+960|0;d=c[i>>2]|0;k=b+964|0;m=b+40|0;n=b+508|0;i:do if((d|0)!=(c[k>>2]|0)){$=bF(aa,d)|0;j:do if((c[$+76>>2]|0)!=(c[$+80>>2]|0)){d=c[V>>2]|0;g=c[(bF(aa,c[i>>2]|0)|0)+76>>2]|0;f=c[g>>2]|0;g=c[g+4>>2]|0;e=c[T>>2]|0;while(1){if(d>>>0>=e>>>0)break j;aa=d;if((c[aa>>2]|0)==(f|0)?(c[aa+4>>2]|0)==(g|0):0)break;d=d+32|0}aa=m;$=c[aa+4>>2]|0;if(g>>>0<$>>>0|((g|0)==($|0)?f>>>0<(c[aa>>2]|0)>>>0:0)){while(1){if(!(c[n>>2]|0))break;J3(b)}GC(b);c[W>>2]=d;aa=d;ty(b,c[aa>>2]|0,c[aa+4>>2]|0);K7(b)}}while(0);g=c[i>>2]|0;e=g+4|0;d=c[k>>2]|0;f=d-e|0;i=f>>2;if(i){TR(g|0,e|0,f|0)|0;d=c[k>>2]|0}e=g+(i<<2)|0;while(1){if((d|0)==(e|0))break i;aa=d+-4|0;c[k>>2]=aa;d=aa}}while(0);if(((((c[ca>>2]|0)==-1?(c[ca+4>>2]|0)==-1:0)?(ea=b+972|0,(a[ea>>0]|0)==0):0)?(ba=c[V>>2]|0,(ba|0)!=(c[U>>2]|0)):0)?(ba,$=c[ba+4>>2]|0,ca=m,aa=c[ca+4>>2]|0,$>>>0<aa>>>0|(($|0)==(aa|0)?(c[ba>>2]|0)>>>0<(c[ca>>2]|0)>>>0:0)):0){while(1){if(!(c[n>>2]|0))break;J3(b)}GC(b);a[b+512>>0]=1;d=c[b+952>>2]|0;if(!d)d=c[V>>2]|0;c[W>>2]=d;ca=d;ty(b,c[ca>>2]|0,c[ca+4>>2]|0);K7(b);a[ea>>0]=1}a[da>>0]=1;ea=b+552|0;c[ea>>2]=0;c[ea+4>>2]=0}}l=fa;return 0}function pc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;n=l;l=l+80|0;h=n+60|0;i=n+48|0;j=n+36|0;k=n+24|0;m=n+12|0;g=n;a:do if((RA(b,1,-1)|0)==1){Jn(b);$x(h,b,1,0,18,1);d=i9(29144)|0;o=a[h+8+3>>0]|0;do if((d|0)==((o<<24>>24<0?c[h+4>>2]|0:o&255)|0)?(VG(h,29144,d)|0)==0:0){$x(i,b,1,0,21,1);d=i9(23012)|0;o=a[i+8+3>>0]|0;if((d|0)!=((o<<24>>24<0?c[i+4>>2]|0:o&255)|0)){z5(i);z5(h);break}o=(VG(i,23012,d)|0)==0;z5(i);z5(h);if(o?($x(h,b,1,0,120,1),o=pn(h)|0,z5(h),$x(h,b,1,0,126,1),e=pn(h)|0,z5(h),(e+-1|0)>>>0<o>>>0):0){Ed(b,1,0,126);lL(b,1,0,120,e,10,1);RB(b,1,0,118,384431,-1,1,1)}}else f=6;while(0);if((f|0)==6)z5(h);$x(h,b,1,0,22,1);o=a[h+8+3>>0]|0;o=((o<<24>>24<0?c[h+4>>2]|0:o&255)|0)==0;z5(h);if(!o){$x(h,b,1,0,22,1);zb(b,0,0,63,h,0);z5(h);$x(k,b,0,0,57,1);Gx(k,32);c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];d=0;while(1){if((d|0)==3)break;c[k+(d<<2)>>2]=0;d=d+1|0}$x(m,b,1,0,22,1);d=a[m+8+3>>0]|0;o=d<<24>>24<0;Ex(j,o?c[m>>2]|0:m,o?c[m+4>>2]|0:d&255)|0;c[i>>2]=c[j>>2];c[i+4>>2]=c[j+4>>2];c[i+8>>2]=c[j+8>>2];d=0;while(1){if((d|0)==3)break;c[j+(d<<2)>>2]=0;d=d+1|0}p2(h,i);zb(b,0,0,62,h,0);z5(h);O0(i);z5(m);O0(j);z5(k);break}$x(h,b,1,0,18,1);d=i9(29964)|0;o=a[h+8+3>>0]|0;b:do if((d|0)==((o<<24>>24<0?c[h+4>>2]|0:o&255)|0)?(VG(h,29964,d)|0)==0:0){$x(i,b,1,0,47,1);d=i9(29156)|0;o=a[i+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[i+4>>2]|0:o&255)|0)?(VG(i,29156,d)|0)==0:0){z5(i);z5(h);break}$x(j,b,1,0,190,1);d=i9(37712)|0;o=a[j+8+3>>0]|0;if((d|0)!=((o<<24>>24<0?c[j+4>>2]|0:o&255)|0)){z5(j);z5(i);z5(h);break}if(VG(j,37712,d)|0){z5(j);z5(i);z5(h);break}$x(k,b,1,0,120,1);d=i9(23284)|0;o=a[k+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[k+4>>2]|0:o&255)|0)?(VG(k,23284,d)|0)==0:0){z5(k);z5(j);z5(i);z5(h)}else f=26;do if((f|0)==26){$x(m,b,1,0,124,1);d=i9(23284)|0;o=a[m+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[m+4>>2]|0:o&255)|0)?(VG(m,23284,d)|0)==0:0){z5(m);z5(k);z5(j);z5(i);z5(h);break}$x(g,b,1,0,126,1);d=i9(23284)|0;o=a[g+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[g+4>>2]|0:o&255)|0))d=(VG(g,23284,d)|0)==0;else d=0;z5(g);z5(m);z5(k);z5(j);z5(i);z5(h);if(!d)break b}while(0);RB(b,0,0,63,374551,-1,1,0);RB(b,1,0,22,374551,-1,1,0);break a}else f=31;while(0);if((f|0)==31)z5(h);$x(h,b,1,0,18,1);d=i9(29964)|0;o=a[h+8+3>>0]|0;c:do if((d|0)==((o<<24>>24<0?c[h+4>>2]|0:o&255)|0)?(VG(h,29964,d)|0)==0:0){$x(i,b,1,0,47,1);d=i9(29156)|0;o=a[i+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[i+4>>2]|0:o&255)|0)?(VG(i,29156,d)|0)==0:0){z5(i);z5(h);break}$x(j,b,1,0,190,1);d=i9(37712)|0;o=a[j+8+3>>0]|0;if((d|0)!=((o<<24>>24<0?c[j+4>>2]|0:o&255)|0)){z5(j);z5(i);z5(h);break}if(VG(j,37712,d)|0){z5(j);z5(i);z5(h);break}$x(k,b,1,0,120,1);d=i9(23320)|0;o=a[k+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[k+4>>2]|0:o&255)|0)?(VG(k,23320,d)|0)==0:0){z5(k);z5(j);z5(i);z5(h)}else f=46;do if((f|0)==46){$x(m,b,1,0,124,1);d=i9(23320)|0;o=a[m+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[m+4>>2]|0:o&255)|0)?(VG(m,23320,d)|0)==0:0){z5(m);z5(k);z5(j);z5(i);z5(h);break}$x(g,b,1,0,126,1);d=i9(23320)|0;o=a[g+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[g+4>>2]|0:o&255)|0))d=(VG(g,23320,d)|0)==0;else d=0;z5(g);z5(m);z5(k);z5(j);z5(i);z5(h);if(!d)break c}while(0);RB(b,0,0,63,374563,-1,1,0);RB(b,1,0,22,374563,-1,1,0);break a}else f=51;while(0);if((f|0)==51)z5(h);$x(h,b,1,0,18,1);d=i9(29964)|0;o=a[h+8+3>>0]|0;d:do if((d|0)==((o<<24>>24<0?c[h+4>>2]|0:o&255)|0)?(VG(h,29964,d)|0)==0:0){$x(i,b,1,0,47,1);d=i9(29156)|0;o=a[i+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[i+4>>2]|0:o&255)|0)?(VG(i,29156,d)|0)==0:0){z5(i);z5(h);break}$x(j,b,1,0,190,1);d=i9(37712)|0;o=a[j+8+3>>0]|0;if((d|0)!=((o<<24>>24<0?c[j+4>>2]|0:o&255)|0)){z5(j);z5(i);z5(h);break}if(VG(j,37712,d)|0){z5(j);z5(i);z5(h);break}$x(k,b,1,0,120,1);d=i9(23356)|0;o=a[k+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[k+4>>2]|0:o&255)|0)?(VG(k,23356,d)|0)==0:0){z5(k);z5(j);z5(i);z5(h)}else f=66;do if((f|0)==66){$x(m,b,1,0,124,1);d=i9(23356)|0;o=a[m+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[m+4>>2]|0:o&255)|0)?(VG(m,23356,d)|0)==0:0){z5(m);z5(k);z5(j);z5(i);z5(h);break}$x(g,b,1,0,126,1);d=i9(23356)|0;o=a[g+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[g+4>>2]|0:o&255)|0))d=(VG(g,23356,d)|0)==0;else d=0;z5(g);z5(m);z5(k);z5(j);z5(i);z5(h);if(!d)break d}while(0);RB(b,0,0,63,374575,-1,1,0);RB(b,1,0,22,374575,-1,1,0);break a}else f=71;while(0);if((f|0)==71)z5(h);$x(h,b,1,0,18,1);d=i9(29964)|0;o=a[h+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[h+4>>2]|0:o&255)|0)?(VG(h,29964,d)|0)==0:0){$x(i,b,1,0,47,1);d=i9(29156)|0;o=a[i+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[i+4>>2]|0:o&255)|0)?(VG(i,29156,d)|0)==0:0){z5(i);z5(h);break}$x(j,b,1,0,190,1);d=i9(29172)|0;o=a[j+8+3>>0]|0;if((d|0)!=((o<<24>>24<0?c[j+4>>2]|0:o&255)|0)){z5(j);z5(i);z5(h);break}if(VG(j,29172,d)|0){z5(j);z5(i);z5(h);break}$x(k,b,1,0,120,1);d=i9(29268)|0;o=a[k+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[k+4>>2]|0:o&255)|0)?(VG(k,29268,d)|0)==0:0){z5(k);z5(j);z5(i);z5(h)}else f=86;do if((f|0)==86){$x(m,b,1,0,124,1);d=i9(29268)|0;o=a[m+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[m+4>>2]|0:o&255)|0)?(VG(m,29268,d)|0)==0:0){z5(m);z5(k);z5(j);z5(i);z5(h);break}$x(g,b,1,0,126,1);d=i9(29268)|0;o=a[g+8+3>>0]|0;if((d|0)==((o<<24>>24<0?c[g+4>>2]|0:o&255)|0))d=(VG(g,29268,d)|0)==0;else d=0;z5(g);z5(m);z5(k);z5(j);z5(i);z5(h);if(!d)break a}while(0);RB(b,0,0,63,374587,-1,1,0);RB(b,1,0,22,374587,-1,1,0);break}z5(h)}while(0);l=n;return}function qc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;L=l;l=l+96|0;H=L+72|0;I=L+60|0;J=L+48|0;K=L+36|0;D=L+24|0;E=L+12|0;F=L;TX(H);cy(b,d,0,H);A=H+8+3|0;e=a[A>>0]|0;B=H+4|0;f=c[B>>2]|0;G=e<<24>>24<0?f:e&255;do if((G|0)==(d|0)|(G+1|0)==(d|0)){G=b+936|0;o=b+944+3|0;C=b+940|0;p=I+8+3|0;q=I+4|0;r=b+984|0;s=b+992+3|0;t=b+988|0;u=J+8+3|0;v=J+4|0;w=I+8+3|0;x=I+4|0;y=b+996|0;n=0;k=0;while(1){g=e<<24>>24<0;e=e&255;h=g?c[H>>2]|0:H;i=g?f:e;d=i9(41596)|0;j=i>>>0<k>>>0;do if(!j){if(d){m=h+(i<<2)|0;d=HA(h+(k<<2)|0,m,41596,41596+(d<<2)|0)|0;if((d|0)==(m|0)){z=8;break}else d=d-h>>2}else d=k;if((d|0)!=-1)m=d;else z=8}else z=8;while(0);if((z|0)==8)m=g?f:e;d=i9(34900)|0;if(!j)if(!d)z=13;else{z=h+(i<<2)|0;d=HA(h+(k<<2)|0,z,34900,34900+(d<<2)|0)|0;d=(d|0)==(z|0)?-1:d-h>>2;z=12}else{d=-1;z=12}if((z|0)==12){z=0;if((d|0)==(k|0))z=13;else{TX(I);jZ(b,m-k|0,0,I);a:do switch(n|0){case 0:{while(1){d=a[p>>0]|0;e=d<<24>>24<0;f=c[q>>2]|0;if(!((e?f:d&255)|0)){e=f;break}if((c[(e?c[I>>2]|0:I)>>2]|0)>=48){e=f;break}ny(I,0,1)|0}while(1){f=d<<24>>24<0;e=f?e:d&255;if(!e)break;d=f?c[I>>2]|0:I;if((c[d+(e+-1<<2)>>2]|0)>=48)break;ny(I,d+(e<<2)+-4-d>>2,1)|0;d=a[p>>0]|0;e=c[q>>2]|0}k1(G,I)|0;break}case 1:{d=a[o>>0]|0;if(d<<24>>24<0){f=c[G>>2]|0;e=c[C>>2]|0}else{f=G;e=d&255}d=i9(34268)|0;if(d|0?(j=f+(e<<2)|0,k=HA(f,j,34268,34268+(d<<2)|0)|0,!((k|0)!=(j|0)&(k|0)==(f|0))):0)break a;HX(G,41596)|0;k=a[p>>0]|0;j=k<<24>>24<0;Ex(G,j?c[I>>2]|0:I,j?c[q>>2]|0:k&255)|0;break}default:{}}while(0);z5(I)}}if((z|0)==13){z=0;GC(b);if((a[s>>0]|0)<0){y7(c[r>>2]|0,0);c[t>>2]=0;e=k}else{y7(r,0);a[s>>0]=0;e=k}while(1){d=oH(H,32,e)|0;do if((d|0)==-1){d=a[A>>0]|0;if(d<<24>>24<0){d=c[B>>2]|0;break}else{d=d&255;break}}while(0);TX(I);jZ(b,d-e|0,0,I);do{TX(J);cy(b,1,0,J);e=i9(42252)|0;k=a[u>>0]|0;if((e|0)!=((k<<24>>24<0?c[v>>2]|0:k&255)|0)){z=23;break}if(VG(J,42252,e)|0){z=23;break}iF(b,1,0);d=d+1|0;z5(J);k=a[A>>0]|0}while((d|0)!=((k<<24>>24<0?c[B>>2]|0:k&255)|0));if((z|0)==23){z=0;z5(J)}e=i9(34940)|0;k=a[w>>0]|0;if(!((e|0)==((k<<24>>24<0?c[x>>2]|0:k&255)|0)?!(VG(I,34940,e)|0):0))z=27;do if((z|0)==27){z=0;e=a[s>>0]|0;if(e<<24>>24<0)e=c[t>>2]|0;else e=e&255;if(e|0)HX(r,41840)|0;e=a[w>>0]|0;f=e<<24>>24<0;Ex(r,f?c[I>>2]|0:I,f?c[x>>2]|0:e&255)|0;e=a[w>>0]|0;f=e<<24>>24<0;g=f?c[I>>2]|0:I;h=i9(34216)|0;if(h|0?(j=g+((f?c[x>>2]|0:e&255)<<2)|0,k=HA(g,j,34216,34216+(h<<2)|0)|0,!((k|0)!=(j|0)&(k|0)==(g|0))):0)break;lw(D,I,8,-1);HX(D,34252)|0;c[K>>2]=c[D>>2];c[K+4>>2]=c[D+4>>2];c[K+8>>2]=c[D+8>>2];e=0;while(1){if((e|0)==3)break;c[D+(e<<2)>>2]=0;e=e+1|0}p2(J,K);vF(y,J)|0;z5(J);O0(K);O0(D)}while(0);z5(I);k=a[A>>0]|0;if((d|0)==((k<<24>>24<0?c[B>>2]|0:k&255)|0))break;else e=d}J3(b)}d=m+3|0;e=a[A>>0]|0;f=c[B>>2]|0;if(d>>>0>(e<<24>>24<0?f:e&255)>>>0)d=m;else{iF(b,3,0);e=a[A>>0]|0;f=c[B>>2]|0}if((d|0)==((e<<24>>24<0?f:e&255)|0))break;else{n=n+1|0;k=d}}h=a[o>>0]|0;g=h<<24>>24<0;if(g){e=c[G>>2]|0;f=c[C>>2]|0}else{e=G;f=h&255}d=i9(34288)|0;i=b+948|0;j=b+960|0;if(d|0?(A=e+(f<<2)|0,B=HA(e,A,34288,34288+(d<<2)|0)|0,!((B|0)!=(A|0)&(B|0)==(e|0))):0){if(g){e=c[G>>2]|0;f=c[C>>2]|0}else{e=G;f=h&255}d=i9(34332)|0;if(d|0?(A=e+(f<<2)|0,B=HA(e,A,34332,34332+(d<<2)|0)|0,!((B|0)!=(A|0)&(B|0)==(e|0))):0){if(g){f=c[G>>2]|0;e=c[C>>2]|0}else{f=G;e=h&255}d=i9(34364)|0;if(d|0?(B=f+(e<<2)|0,C=HA(f,B,34364,34364+(d<<2)|0)|0,!((C|0)!=(B|0)&(C|0)==(f|0))):0){k1(i,G)|0;break}Xy(I,34460);vF(i,I)|0;z5(I);Xy(K,42232);c[E>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;f=i9(34552)|0;if(f>>>0>1073741807)uaa();d=E+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){L=ua(8)|0;K2(L,391652);c[L>>2]=57868;Ya(L|0,2712,367)}else{C=ZW(e<<2)|0;c[E>>2]=C;c[d>>2]=e|-2147483648;c[E+4>>2]=f;d=C;break}}else{a[d+3>>0]=f;d=E}while(0);a3(d,34552,f);y7(d+(f<<2)|0,0);c[F>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;f=i9(42252)|0;if(f>>>0>1073741807)uaa();d=F+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){L=ua(8)|0;K2(L,391652);c[L>>2]=57868;Ya(L|0,2712,367)}else{C=ZW(e<<2)|0;c[F>>2]=C;c[d>>2]=e|-2147483648;c[F+4>>2]=f;d=C;break}}else{a[d+3>>0]=f;d=F}while(0);a3(d,42252,f);y7(d+(f<<2)|0,0);Ok(D,G,E,F,0,0);d=a[D+8+3>>0]|0;G=d<<24>>24<0;Ex(K,G?c[D>>2]|0:D,G?c[D+4>>2]|0:d&255)|0;c[J>>2]=c[K>>2];c[J+4>>2]=c[K+4>>2];c[J+8>>2]=c[K+8>>2];d=0;while(1){if((d|0)==3)break;c[K+(d<<2)>>2]=0;d=d+1|0}p2(I,J);vF(b+972|0,I)|0;z5(I);O0(J);z5(D);O0(F);O0(E);z5(K);break}Xy(I,34268);vF(i,I)|0;z5(I);c[J>>2]=0;c[J+4>>2]=0;c[J+8>>2]=0;f=i9(34332)|0;if(f>>>0>1073741807)uaa();d=J+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){L=ua(8)|0;K2(L,391652);c[L>>2]=57868;Ya(L|0,2712,367)}else{F=ZW(e<<2)|0;c[J>>2]=F;c[d>>2]=e|-2147483648;c[J+4>>2]=f;d=F;break}}else{a[d+3>>0]=f;d=J}while(0);a3(d,34332,f);y7(d+(f<<2)|0,0);c[K>>2]=0;c[K+4>>2]=0;c[K+8>>2]=0;f=i9(409096)|0;if(f>>>0>1073741807)uaa();d=K+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){L=ua(8)|0;K2(L,391652);c[L>>2]=57868;Ya(L|0,2712,367)}else{F=ZW(e<<2)|0;c[K>>2]=F;c[d>>2]=e|-2147483648;c[K+4>>2]=f;d=F;break}}else{a[d+3>>0]=f;d=K}while(0);a3(d,409096,f);y7(d+(f<<2)|0,0);Ok(I,G,J,K,0,0);vF(j,I)|0;z5(I);O0(K);O0(J);break}Xy(I,34312);vF(i,I)|0;z5(I);c[J>>2]=0;c[J+4>>2]=0;c[J+8>>2]=0;f=i9(34288)|0;if(f>>>0>1073741807)uaa();d=J+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){L=ua(8)|0;K2(L,391652);c[L>>2]=57868;Ya(L|0,2712,367)}else{F=ZW(e<<2)|0;c[J>>2]=F;c[d>>2]=e|-2147483648;c[J+4>>2]=f;d=F;break}}else{a[d+3>>0]=f;d=J}while(0);a3(d,34288,f);y7(d+(f<<2)|0,0);c[K>>2]=0;c[K+4>>2]=0;c[K+8>>2]=0;f=i9(409096)|0;if(f>>>0>1073741807)uaa();d=K+8|0;do if(f>>>0>=2){e=f+4&-4;if(e>>>0>1073741823){L=ua(8)|0;K2(L,391652);c[L>>2]=57868;Ya(L|0,2712,367)}else{F=ZW(e<<2)|0;c[K>>2]=F;c[d>>2]=e|-2147483648;c[K+4>>2]=f;d=F;break}}else{a[d+3>>0]=f;d=K}while(0);a3(d,409096,f);y7(d+(f<<2)|0,0);Ok(I,G,J,K,0,0);vF(j,I)|0;z5(I);O0(K);O0(J)}else e1(b,d,0);while(0);z5(H);l=L;return}function rc(f){f=f|0;var g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;Y=l;l=l+16|0;D=Y;J=f+612|0;K=f+548|0;M=f+40|0;N=f+48|0;O=f+544|0;U=f+762|0;V=f+768|0;W=f+765|0;E=f+560|0;F=f+800|0;G=f+776|0;H=f+784|0;I=f+728|0;i=c[J>>2]|0;a:while(1){p=c[K>>2]|0;if((i+188|0)>>>0>p>>>0){X=86;break}m=c[O>>2]|0;if((a[m+i>>0]|0)!=71){X=4;break}g=m+(i+1)|0;s=(a[g>>0]&31)<<8|d[m+(i+2)>>0];b[U>>1]=s;r=c[V>>2]|0;s=c[(c[r+80>>2]|0)+(s<<2)>>2]|0;do if(a[s+172>>0]|0){C=a[g>>0]&64;a[W>>0]=(C&255)>>>6;if(C<<24>>24?a[s+173>>0]|0:0){if((c[s+64>>2]|0)!=2){g=1;break a}k=i+3|0;if(a[m+k>>0]&32){g=(d[m+(i+4)>>0]|0)+5|0;if(g>>>0>187){g=1;break a}}else g=4;j=g+1+(d[m+(g+i)>>0]|0)|0;if(j>>>0>187){g=1;break a}g=j+i|0;q=a[m+g>>0]|0;if(q<<24>>24==-51){X=13;break a}i=(c[s+16>>2]|0)+((q&255)<<2)|0;o=c[i>>2]|0;if(o|0){if((a[m+(g+1)>>0]|0)>=0){X=18;break a}if((j+8|0)>>>0>187){g=1;break a}k=j+k|0;C=(d[m+k>>0]<<8|d[m+(k+1)>>0])&65535;b[D>>1]=C;n=(d[m+(k+2)>>0]|0)>>>1&31;k=a[m+(k+3)>>0]|0;m=UD(o,C)|0;do if((m|0)==(o+4|0)){if(a[o+12>>0]|0){X=25;break a}}else{g=m+32|0;i=a[g>>0]|0;j=m+20|0;if(i<<24>>24!=n<<24>>24){X=27;break a}i=k&255;g=(c[j>>2]|0)+(i>>>5<<2)|0;i=1<<(i&31);j=c[g>>2]|0;if(!(j&i)){X=31;break a}if(q<<24>>24==2){if(!(c[(HD(r+68|0,r)|0)+40>>2]|0))break;g=c[(c[V>>2]|0)+80>>2]|0;i=c[g+64>>2]|0;if(!(c[i+64>>2]|0)){UZ(i,1);g=c[(c[(c[V>>2]|0)+80>>2]|0)+64>>2]|0;c[g+64>>2]=2;nG(g+16|0);g=ZW(16)|0;M0(g);c[(c[(c[(c[(c[V>>2]|0)+80>>2]|0)+64>>2]|0)+16>>2]|0)+256>>2]=g;g=c[(c[V>>2]|0)+80>>2]|0}i=c[g+68>>2]|0;if(!(c[i+64>>2]|0)){UZ(i,1);g=c[(c[(c[V>>2]|0)+80>>2]|0)+68>>2]|0;c[g+64>>2]=2;nG(g+16|0);g=ZW(16)|0;M0(g);c[(c[(c[(c[(c[V>>2]|0)+80>>2]|0)+68>>2]|0)+16>>2]|0)+264>>2]=g;g=c[(c[V>>2]|0)+80>>2]|0}i=c[g+72>>2]|0;if(!(c[i+64>>2]|0)){UZ(i,1);g=c[(c[(c[V>>2]|0)+80>>2]|0)+72>>2]|0;c[g+64>>2]=2;nG(g+16|0);g=ZW(16)|0;M0(g);c[(c[(c[(c[(c[V>>2]|0)+80>>2]|0)+72>>2]|0)+16>>2]|0)+312>>2]=g;g=80;while(1){if((g|0)==96)break;C=ZW(16)|0;M0(C);c[(c[(c[(c[(c[V>>2]|0)+80>>2]|0)+72>>2]|0)+16>>2]|0)+(g<<2)>>2]=C;g=g+1|0}g=c[(c[V>>2]|0)+80>>2]|0}i=c[g+80>>2]|0;if(!(c[i+64>>2]|0)){UZ(i,1);g=c[(c[(c[V>>2]|0)+80>>2]|0)+80>>2]|0;c[g+64>>2]=2;nG(g+16|0);g=ZW(16)|0;M0(g);c[(c[(c[(c[(c[V>>2]|0)+80>>2]|0)+80>>2]|0)+16>>2]|0)+448>>2]=g;g=ZW(16)|0;M0(g);c[(c[(c[(c[(c[V>>2]|0)+80>>2]|0)+80>>2]|0)+16>>2]|0)+460>>2]=g;g=c[(c[V>>2]|0)+80>>2]|0}g=c[g+32748>>2]|0;if(c[g+64>>2]|0)break;UZ(g,1);C=c[(c[(c[V>>2]|0)+80>>2]|0)+32748>>2]|0;c[C+64>>2]=2;nG(C+16|0);C=ZW(16)|0;M0(C);c[(c[(c[(c[(c[V>>2]|0)+80>>2]|0)+32748>>2]|0)+16>>2]|0)+796>>2]=C;C=ZW(16)|0;M0(C);c[(c[(c[(c[(c[V>>2]|0)+80>>2]|0)+32748>>2]|0)+16>>2]|0)+820>>2]=C}}while(0)}}if(a[s+174>>0]|0){g=1;break a}if(a[s+177>>0]|0){g=1;break a}if(a[s+178>>0]|0){g=1;break a}if((a[s+175>>0]|0)==0?(a[s+176>>0]|0)==0:0)break;g=c[O>>2]|0;C=c[J>>2]|0;if((a[g+(C+3)>>0]&32?(d[g+(C+4)>>0]|0)>4:0)?(B=d[g+(C+5)>>0]|0,L=(B&128|0)==0,B&16|0):0){y=PZ(d[g+(C+6)>>0]|0,0,25)|0;n=z;x=PZ(d[g+(C+7)>>0]|0,0,17)|0;n=z|n;A=PZ(d[g+(C+8)>>0]|0,0,9)|0;n=n|z;B=PZ(d[g+(C+9)>>0]|0,0,1)|0;n=n|z;j=d[g+(C+10)>>0]|0;i=XZ(j|0,0,7)|0;n=UW(x|y|A|B|i|0,n|z|0,300,0)|0;i=z;j=PZ(j|0,0,8)|0;j=z0(n|0,i|0,j&256|d[g+(C+11)>>0]|0,0)|0;i=z;n=c[V>>2]|0;g=c[(c[n+80>>2]|0)+(e[U>>1]<<2)>>2]|0;do if(a[g+176>>0]|0){if(a[g+178>>0]|0?(a[g+69>>0]|0)==0:0){p=j;o=i;break}A=g+96|0;q=A;w=c[q>>2]|0;q=c[q+4>>2]|0;if(!((j|0)==(w|0)&(i|0)==(q|0))){B=g+104|0;o=B;p=c[o>>2]|0;o=c[o+4>>2]|0;if(!((p|0)==-1&(o|0)==-1)){y=z0(j|0,i|0,0,300)|0;x=z;y=x>>>0<q>>>0|(x|0)==(q|0)&y>>>0<w>>>0;x=z0(j|0,i|0,0,600)|0;j=y?x:j;i=y?z:i;y=z0(w|0,q|0,27e7,0)|0;x=z;if((i>>>0<x>>>0|(i|0)==(x|0)&j>>>0<y>>>0)&(L&(i>>>0>q>>>0|(i|0)==(q|0)&j>>>0>w>>>0))){r=D_(j|0,i|0,w|0,q|0)|0;s=z;k=z0(r|0,s|0,810,0)|0;u=+(k>>>0)+4294967296.0*+(z>>>0);k=N;m=c[k>>2]|0;k=c[k+4>>2]|0;x=D_(C|0,0,p|0,o|0)|0;x=z0(x|0,z|0,m|0,k|0)|0;t=(+(x>>>0)+4294967296.0*+(z>>>0))*8.0;u=t/u*27.0e6;x=g+120|0;v=+h[x>>3];y=g+136|0;if(v!=0.0){w=z0(r|0,s|0,-810,-1)|0;do if(t/(+(w>>>0)+4294967296.0*+(z>>>0))*27.0e6<v)X=65;else{if(u>+h[y>>3]){X=65;break}k=g+144|0}while(0);if((X|0)==65){X=0;k=g+152|0}o=k;o=z0(c[o>>2]|0,c[o+4>>2]|0,1,0)|0;q=k;c[q>>2]=o;c[q+4>>2]=z;q=A;k=N;o=B;r=c[q>>2]|0;q=c[q+4>>2]|0;p=c[o>>2]|0;o=c[o+4>>2]|0;m=c[k>>2]|0;k=c[k+4>>2]|0}else r=w;s=D_(j|0,i|0,r|0,q|0)|0;w=z;r=z0(s|0,w|0,-1,-1)|0;v=+(r>>>0)+4294967296.0*+(z>>>0);r=z0(s|0,w|0,1,0)|0;t=+(r>>>0)+4294967296.0*+(z>>>0);r=D_(C|0,0,p|0,o|0)|0;r=z0(r|0,z|0,m|0,k|0)|0;u=(+(r>>>0)+4294967296.0*+(z>>>0))*8.0;h[x>>3]=u/t*27.0e6;h[g+128>>3]=u/(+(s>>>0)+4294967296.0*+(w>>>0))*27.0e6;h[y>>3]=u/v*27.0e6}}o=A;c[o>>2]=j;c[o+4>>2]=i;a[g+114>>0]=1;o=N;o=z0(c[o>>2]|0,c[o+4>>2]|0,C|0,0)|0;p=B;c[p>>2]=o;c[p+4>>2]=z;c[I>>2]=c[I>>2]|65540;p=j;o=i}else{p=j;o=i}}else{p=j;o=i}while(0);if(a[g+175>>0]|0){B=g+80|0;c[B>>2]=p;c[B+4>>2]=o;B=N;B=z0(C|0,0,c[B>>2]|0,c[B+4>>2]|0)|0;C=z;n=g+88|0;c[n>>2]=B;c[n+4>>2]=C;n=g+96|0;c[n>>2]=p;c[n+4>>2]=o;a[g+114>>0]=1;n=g+104|0;c[n>>2]=B;c[n+4>>2]=C;RZ(g,0);TZ(c[(c[(c[V>>2]|0)+80>>2]|0)+(e[U>>1]<<2)>>2]|0,1);n=c[V>>2]|0;g=n+96|0;c[g>>2]=(c[g>>2]|0)+1;c[I>>2]=c[I>>2]|65540;g=c[(c[n+80>>2]|0)+(e[U>>1]<<2)>>2]|0}m=g+179|0;if(((a[m>>0]|0)==0?(P=g+80|0,R=P,Q=c[R>>2]|0,R=c[R+4>>2]|0,!((Q|0)==-1&(R|0)==-1)):0)?(T=N,T=z0(c[J>>2]|0,0,c[T>>2]|0,c[T+4>>2]|0)|0,S=E,S=D_(T|0,z|0,c[S>>2]|0,c[S+4>>2]|0)|0,T=z,B=PZ(S|0,T|0,1)|0,y=z,C=M,A=c[C+4>>2]|0,y>>>0<A>>>0|((y|0)==(A|0)?B>>>0<(c[C>>2]|0)>>>0:0)):0){do if(R>>>0>o>>>0|(R|0)==(o|0)&Q>>>0>p>>>0){C=D_(Q|0,R|0,p|0,o|0)|0;B=z;if(B>>>0<0|(B|0)==0&C>>>0<27e7){j=P;c[j>>2]=p;c[j+4>>2]=o;j=p;k=o;i=p;g=o;break}else{j=z0(p|0,o|0,0,600)|0;k=z;i=Q;g=R;break}}else{j=p;k=o;i=Q;g=R}while(0);B=D_(j|0,k|0,i|0,g|0)|0;y=z;C=F;A=c[C+4>>2]|0;if(y>>>0>A>>>0|((y|0)==(A|0)?B>>>0>(c[C>>2]|0)>>>0:0)){a[m>>0]=1;C=n+100|0;g=(c[C>>2]|0)+1|0;c[C>>2]=g;if(!(c[n+92>>2]|0))break;C=c[n+96>>2]|0;if(!((C|0)!=0&(C|0)==(g|0)))break;C=G;c[C>>2]=S;c[C+4>>2]=T;C=H;c[C>>2]=S;c[C+4>>2]=T}}}}while(0);i=(c[J>>2]|0)+188|0;c[J>>2]=i}do if((X|0)==4){a[f+376>>0]=0;g=1}else if((X|0)==13){g=f+812|0;if((a[f+811>>0]|0)!=0?(a[g>>0]|0)==0:0){a[g>>0]=1;g=1}else g=1}else if((X|0)==18){g=f+812|0;if((q<<24>>24==112?(a[f+811>>0]|0)!=0:0)?(a[g>>0]|0)==0:0){a[g>>0]=1;g=1}else g=1}else if((X|0)==25){a[(wC(o,D)|0)+12>>0]=n;Bp(wC(c[i>>2]|0,D)|0);f=k&255;g=(c[(wC(c[i>>2]|0,D)|0)>>2]|0)+(f>>>5<<2)|0;i=c[g>>2]|1<<(f&31);X=84}else if((X|0)==27){if(i<<24>>24!=-1?a[f+811>>0]|0:0){X=86;break}a[g>>0]=n;c[m+24>>2]=0;Bp(j);i=k&255;g=(c[j>>2]|0)+(i>>>5<<2)|0;i=c[g>>2]|1<<(i&31);X=84}else if((X|0)==31){i=j|i;X=84}while(0);if((X|0)==84){c[g>>2]=i;g=1}else if((X|0)==86){W=N;W=z0(p|0,0,c[W>>2]|0,c[W+4>>2]|0)|0;U=z;X=M;V=c[X+4>>2]|0;if(U>>>0<V>>>0|((U|0)==(V|0)?W>>>0<(c[X>>2]|0)>>>0:0))g=0;else{jb[c[(c[f>>2]|0)+108>>2]&511](f);g=0}}l=Y;return g|0}function sc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+48|0;i=o+24|0;k=o+12|0;m=o;TX(i);j=b+536|0;jZ(b,c[j>>2]|0,c[j+4>>2]|0,i);j=b+520|0;h=j;g=c[h>>2]|0;h=c[h+4>>2]|0;a:do if((g|0)<1229278791){if((g|0)<1229145171){if((g|0)>=1229017908)switch(g|0){case 1229017908:{if(h|0){d=-1;e=0;f=0;break a}d=255;e=3;f=2;n=102;break a}case 1229017909:{if(h|0){d=-1;e=0;f=0;break a}d=255;e=4;f=2;n=102;break a}case 1229017910:{if(h|0){d=-1;e=0;f=0;break a}d=255;e=5;f=2;n=102;break a}case 1229017911:{if(h|0){d=-1;e=0;f=0;break a}d=255;e=6;f=2;n=102;break a}case 1229017912:{if(h|0){d=-1;e=0;f=0;break a}d=255;e=7;f=2;n=102;break a}case 1229017913:{if(h|0){d=-1;e=0;f=0;break a}d=255;e=8;f=2;n=102;break a}default:{d=-1;e=0;f=0;break a}}if((g|0)>=1229017905)switch(g|0){case 1229017905:{if(h|0){d=-1;e=0;f=0;break a}d=255;e=0;f=2;n=102;break a}case 1229017906:{if(h|0){d=-1;e=0;f=0;break a}d=255;e=1;f=2;n=102;break a}case 1229017907:{if(h|0){d=-1;e=0;f=0;break a}d=255;e=2;f=2;n=102;break a}default:{d=-1;e=0;f=0;break a}}if((g|0)<1229017676){switch(g|0){case 0:break;default:{d=-1;e=0;f=0;break a}}if(!h){d=320;e=0;f=0;n=102;break}else{d=-1;e=0;f=0;break}}switch(g|0){case 1229017676:{if(h|0){d=-1;e=0;f=0;break a}d=266;e=0;f=0;n=102;break a}case 1229017684:{if(h|0){d=-1;e=0;f=0;break a}d=211;e=0;f=0;n=102;break a}default:{d=-1;e=0;f=0;break a}}}if((g|0)<1229148740)switch(g|0){case 1229145171:{if(h|0){d=-1;e=0;f=0;break a}d=219;e=0;f=0;n=102;break a}case 1229147475:{if(h|0){d=-1;e=0;f=0;break a}d=225;e=0;f=0;n=102;break a}case 1229147476:if(!h){d=320;e=0;f=0;n=102;break a}else{d=-1;e=0;f=0;break a}case 1229147725:{if(h|0){d=-1;e=0;f=0;break a}d=214;e=0;f=0;n=102;break a}case 1229147732:{if(h|0){d=-1;e=0;f=0;break a}d=169;e=0;f=0;n=102;break a}case 1229147984:{if(h|0){d=-1;e=0;f=0;break a}d=300;e=0;f=0;n=102;break a}default:{d=-1;e=0;f=0;break a}}if((g|0)<1229211988){if((g|0)<1229148752){switch(g|0){case 1229148740:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}pk(k,i);gd(i,(a[k+11>>0]|0)<0?c[k>>2]|0:k,-1)|0;a1(k);d=255;e=0;f=0;n=102;break}if((g|0)<1229211981){switch(g|0){case 1229148752:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=281;e=0;f=0;n=102;break}else{switch(g|0){case 1229211981:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=282;e=0;f=0;n=102;break}}if((g|0)<1229214548)switch(g|0){case 1229211988:{if(h|0){d=-1;e=0;f=0;break a}pk(k,i);gd(i,(a[k+11>>0]|0)<0?c[k>>2]|0:k,-1)|0;a1(k);d=259;e=0;f=0;n=102;break a}case 1229213769:{if(h|0){d=-1;e=0;f=0;break a}d=283;e=0;f=0;n=102;break a}default:{d=-1;e=0;f=0;break a}}if((g|0)<1229276244){switch(g|0){case 1229214548:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=230;e=0;f=0;n=102;break}else{switch(g|0){case 1229276244:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=224;e=0;f=0;n=102;break}}else if((g|0)<1230000724)if((g|0)<1229800772){if((g|0)>=1229669721){if((g|0)<1229735764){switch(g|0){case 1229669721:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=246;e=0;f=0;n=102;break}switch(g|0){case 1229735764:{if(h|0){d=-1;e=0;f=0;break a}d=284;e=0;f=0;n=102;break a}case 1229737543:{if(h|0){d=-1;e=0;f=0;break a}d=255;e=0;f=2;n=102;break a}default:{d=-1;e=0;f=0;break a}}}if((g|0)<1229345357){switch(g|0){case 1229278791:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=233;e=0;f=0;n=102;break}if((g|0)<1229409874){switch(g|0){case 1229345357:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=182;e=0;f=0;n=102;break}else{switch(g|0){case 1229409874:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=240;e=0;f=0;n=102;break}}else{if((g|0)>=1229997139)switch(g|0){case 1229997139:{if(h|0){d=-1;e=0;f=0;break a}d=217;e=0;f=0;n=102;break a}case 1229999188:{if(h|0){d=-1;e=0;f=0;break a}d=287;e=0;f=0;n=102;break a}case 1230000708:{if(h|0){d=-1;e=0;f=0;break a}d=288;e=0;f=0;n=102;break a}case 1230000719:{if(h|0){d=-1;e=0;f=0;break a}d=226;e=0;f=0;n=102;break a}default:{d=-1;e=0;f=0;break a}}if((g|0)<1229804883){switch(g|0){case 1229800772:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=285;e=0;f=0;n=102;break}if((g|0)<1229865293){switch(g|0){case 1229804883:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=229;e=0;f=0;n=102;break}else{switch(g|0){case 1229865293:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=159;e=0;f=0;n=102;break}}else{if((g|0)<1230197315){if((g|0)>=1230194260)switch(g|0){case 1230194260:{if(h|0){d=-1;e=0;f=0;break a}d=267;e=0;f=0;n=102;break a}case 1230194510:{if(h|0){d=-1;e=0;f=0;break a}d=240;e=0;f=0;n=102;break a}case 1230194768:{if(h|0){d=-1;e=0;f=0;break a}d=290;e=0;f=0;n=102;break a}default:{d=-1;e=0;f=0;break a}}if((g|0)<1230132292){switch(g|0){case 1230000724:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=181;e=0;f=0;n=102;break}if((g|0)<1230193226){switch(g|0){case 1230132292:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=250;e=0;f=0;n=102;break}else{switch(g|0){case 1230193226:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=244;e=0;f=0;n=102;break}}if((g|0)<1230197842)switch(g|0){case 1230197315:{if(h|0){d=-1;e=0;f=0;break a}d=231;e=0;f=0;n=102;break a}case 1230197318:{if(h|0){d=-1;e=0;f=0;break a}d=286;e=0;f=0;n=102;break a}case 1230197828:{if(h|0){d=-1;e=0;f=0;break a}d=235;e=0;f=0;n=102;break a}default:{d=-1;e=0;f=0;break a}}if((g|0)<1230456130)if((g|0)<1230259016){switch(g|0){case 1230197842:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=199;e=0;f=0;n=102;break}else{switch(g|0){case 1230259016:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=233;e=0;f=0;n=102;break}else if((g|0)<1230459465){switch(g|0){case 1230456130:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=170;e=0;f=0;n=102;break}else{switch(g|0){case 1230459465:break;default:{d=-1;e=0;f=0;break a}}if(h|0){d=-1;e=0;f=0;break}d=222;e=0;f=0;n=102;break}}while(0);if((n|0)==102){h=j;g=c[h>>2]|0;h=c[h+4>>2]|0}b:do if((g|0)<1230196048){switch(g|0){case 1229409874:break;default:{n=110;break b}}if(!h){$x(k,b,0,0,240,1);Ed(b,0,0,240);zb(b,f,e,240,i,0);h=a[k+8+3>>0]|0;if((h<<24>>24<0?c[k+4>>2]|0:h&255)|0)zb(b,f,e,240,k,0);z5(k)}else n=110}else{switch(g|0){case 1230196048:break;default:{n=110;break b}}if(!h)k1(b+840|0,i)|0;else n=110}while(0);do if((n|0)==110?(n=a[i+8+3>>0]|0,(n<<24>>24<0?c[i+4>>2]|0:n&255)|0):0)if((d|0)==-1){TX(m);pk(k,lh(m,c[j>>2]|0)|0);Mc(b,f,e,(a[k+11>>0]|0)<0?c[k>>2]|0:k,i,1);a1(k);z5(m);break}else{zb(b,f,e,d,i,0);break}while(0);z5(i);l=o;return}function tc(e){e=e|0;var f=0,g=0.0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=l;l=l+32|0;h=M+16|0;k=M+20|0;p=M+28|0;o=M+27|0;m=M+26|0;i=M+25|0;j=M+24|0;x=M+4|0;y=M;v=M+23|0;w=M+22|0;C=e+768|0;f=c[C>>2]|0;D=e+772|0;E=e+48|0;F=e+831|0;G=e+776|0;H=e+548|0;I=e+536|0;J=e+612|0;K=e+544|0;if(f|0?(B=c[J>>2]|0,u=E,u=z0(c[u>>2]|0,c[u+4>>2]|0,B|0,0)|0,A=E,c[A>>2]=u,c[A+4>>2]=z,A=c[K>>2]|0,c[K>>2]=f,c[C>>2]=A,c[J>>2]=c[D>>2],c[D>>2]=B,B=c[H>>2]|0,c[H>>2]=c[G>>2],c[G>>2]=B,(a[F>>0]|0)==0):0){A=I;A=UW(c[A>>2]|0,c[A+4>>2]|0,14,0)|0;A=XZ(A|0,z|0,4)|0;B=I;c[B>>2]=A;c[B+4>>2]=z}ID(e,h);A=e+520|0;B=e+528|0;if((c[h>>2]|0)==1683496997){u=A;c[u>>2]=1;c[u+4>>2]=0;u=B;u=z0(c[u>>2]|0,c[u+4>>2]|0,1,0)|0;s=B;c[s>>2]=u;c[s+4>>2]=z;Bx(e);xR(e,2,p);AT(e,i);s=(a[i>>0]|0)==0;if(s){sR(e,8,k);u=(b[k>>1]|0)+1<<16>>16;b[k>>1]=u;f=e+808|0;rR(e,16,f)}else{sR(e,12,k);u=(b[k>>1]|0)+1<<16>>16;b[k>>1]=u;f=e+808|0;rR(e,20,f)}c[f>>2]=(c[f>>2]|0)+1;yT(e,j);t=(a[j>>0]|0)==0;if(t){A6(c[e+648>>2]|0);a[m>>0]=1;a[o>>0]=1;q=1}else{GC(e);r=e+648|0;A6(c[r>>2]|0);c[x>>2]=0;k=x+4|0;c[k>>2]=0;c[x+8>>2]=0;d4(c[r>>2]|0,2);q=e+829|0;xR(e,3,q);a[q>>0]=(a[q>>0]|0)+1<<24>>24;if(K6(c[r>>2]|0)|0){GC(e);A6(c[r>>2]|0);d4(c[r>>2]|0,36);J3(e)}else A6(c[r>>2]|0);xR(e,3,m);n=(a[m>>0]|0)+1<<24>>24;a[m>>0]=n;xR(e,3,o);q=(a[o>>0]|0)+1<<24>>24;a[o>>0]=q;GC(e);j=x+8|0;m=(d[p>>0]|0)+1|0;h=m&255;f=0;while(1){if((f&255)>=(n&255))break;rR(e,h,y);i=c[k>>2]|0;if((i|0)==(c[j>>2]|0))Yy(x,y);else{c[i>>2]=c[y>>2];c[k>>2]=i+4}f=f+1<<24>>24}J3(e);GC(e);i=n&255;h=0;while(1){if((h|0)==(i|0))break;else f=0;while(1){f=f&255;if(f>>>0>=m>>>0)break;if(c[(c[x>>2]|0)+(h<<2)>>2]&1|0)d4(c[r>>2]|0,8);f=f+2|0}h=h+1|0}J3(e);if(K6(c[r>>2]|0)|0){GC(e);A6(c[r>>2]|0);d4(c[r>>2]|0,2);xR(e,2,y);h=(d[y>>0]<<2)+4&255;a[y>>0]=h;xR(e,2,v);i=(a[v>>0]|0)+1<<24>>24;a[v>>0]=i;f=0;while(1){if((f&255)>=(i&255))break;d4(c[r>>2]|0,h);f=f+1<<24>>24}J3(e)}else A6(c[r>>2]|0);J3(e);cU(x)}k=e+780|0;f=c[k>>2]|0;m=e+784|0;h=c[m>>2]|0;while(1){if((h|0)==(f|0))break;r=h+-4|0;c[m>>2]=r;h=r}GC(e);h=e+788|0;f=0;while(1){if((f&255)>=(q&255))break;if(s)rR(e,16,x);else rR(e,20,x);j=(c[x>>2]|0)+1|0;c[x>>2]=j;i=c[m>>2]|0;if((i|0)==(c[h>>2]|0))Yy(k,x);else{c[i>>2]=j;c[m>>2]=i+4}f=f+1<<24>>24}J3(e);m=e+826|0;n=e+827|0;o=e+828|0;p=e+816|0;k=e+648|0;j=0;while(1){if((j&255)>=(q&255))break;GC(e);sR(e,9,x);b[x>>1]=(b[x>>1]|0)+1<<16>>16;d4(c[k>>2]|0,3);if(!t){if(K6(c[k>>2]|0)|0){GC(e);A6(c[k>>2]|0);d4(c[k>>2]|0,4);J3(e)}else A6(c[k>>2]|0);if(K6(c[k>>2]|0)|0){GC(e);A6(c[k>>2]|0);d4(c[k>>2]|0,24);J3(e)}else A6(c[k>>2]|0);if(K6(c[k>>2]|0)|0){GC(e);A6(c[k>>2]|0);sR(e,10,y);h=(b[y>>1]|0)+1<<16>>16;b[y>>1]=h;f=0;while(1){if((f&65535)>=(h&65535))break;d4(c[k>>2]|0,8);f=f+1<<16>>16}J3(e)}else A6(c[k>>2]|0);xR(e,5,m);a[m>>0]=(a[m>>0]|0)+1<<24>>24;xR(e,4,n);xR(e,8,o);a[o>>0]=(a[o>>0]|0)+1<<24>>24;if(K6(c[k>>2]|0)|0){GC(e);A6(c[k>>2]|0);if((d[o>>0]|0)>2?(A6(c[k>>2]|0),(d[o>>0]|0)>6):0)A6(c[k>>2]|0);if(K6(c[k>>2]|0)|0){GC(e);A6(c[k>>2]|0);xR(e,2,y);h=(d[y>>0]<<2)+4&255;a[y>>0]=h;sR(e,h,p);J3(e)}else{A6(c[k>>2]|0);a[y>>0]=0;h=0}xR(e,3,v);i=a[v>>0]|0;f=0;while(1){if((f&255)>=(i&255)){f=0;break}d4(c[k>>2]|0,h);f=f+1<<24>>24}while(1){if((f&255)>=(i&255))break;xR(e,5,w);f=f+1<<24>>24}J3(e)}else A6(c[k>>2]|0);J3(e)}j=j+1<<24>>24}wK(e);y=B;y=D_(u&65535|0,0,c[y>>2]|0,c[y+4>>2]|0)|0;e1(e,y,z)}else{f=A;c[f>>2]=0;c[f+4>>2]=0;Bx(e);f=e+648|0;A6(c[f>>2]|0);d4(c[f>>2]|0,5);AT(e,p);h=e+814|0;sR(e,7,h);b[h>>1]=(b[h>>1]|0)+1<<16>>16;h=e+812|0;sR(e,14,h);i=(b[h>>1]|0)+1<<16>>16;b[h>>1]=i;if(!(a[F>>0]|0))b[h>>1]=((i&65535)<<4>>>0)/14|0;y=e+818|0;xR(e,6,y);a[e+1240>>0]=a[y>>0]|0;xR(e,4,e+820|0);xR(e,5,e+822|0);A6(c[f>>2]|0);A6(c[f>>2]|0);A6(c[f>>2]|0);A6(c[f>>2]|0);A6(c[f>>2]|0);xR(e,3,e+825|0);AT(e,e+830|0);A6(c[f>>2]|0);y=e+823|0;xR(e,2,y);a[e+1241>>0]=a[y>>0]|0;A6(c[f>>2]|0);if(a[p>>0]|0)d4(c[f>>2]|0,16);A6(c[f>>2]|0);xR(e,4,k);d4(c[f>>2]|0,2);xR(e,2,e+824|0);AT(e,e+833|0);A6(c[f>>2]|0);A6(c[f>>2]|0);d4(c[f>>2]|0,4);switch(a[k>>0]|0){case 6:{d4(c[f>>2]|0,4);break}case 7:{d4(c[f>>2]|0,4);break}default:d4(c[f>>2]|0,4)}wK(e)}y=E;y=z0(c[J>>2]|0,0,c[y>>2]|0,c[y+4>>2]|0)|0;x=I;x=z0(y|0,z|0,c[x>>2]|0,c[x+4>>2]|0)|0;y=e+40|0;f=e+312|0;if((x|0)==(c[y>>2]|0)?(z|0)==(c[y+4>>2]|0):0){w=f;x=c[w+4>>2]|0;y=e+760|0;c[y>>2]=c[w>>2];c[y+4>>2]=x}y=A;if(!(!((c[y>>2]|0)==0&(c[y+4>>2]|0)==0)?(a[e+834>>0]|0)!=0:0)){i=f;h=c[i>>2]|0;i=c[i+4>>2]|0;m=e+136|0;if((h|0)==0&(i|0)==0){w=m;x=c[w+4>>2]|0;y=e+280|0;c[y>>2]=c[w>>2];c[y+4>>2]=x}x=z0(h|0,i|0,1,0)|0;y=f;c[y>>2]=x;c[y+4>>2]=z;y=e+328|0;x=y;x=z0(c[x>>2]|0,c[x+4>>2]|0,1,0)|0;c[y>>2]=x;c[y+4>>2]=z;g=+Sm(e,0);if(g!=0.0){j=I;k=e+656|0;j=z0(c[k>>2]|0,c[k+4>>2]|0,c[j>>2]|0,c[j+4>>2]|0)|0;j=cT((+(j>>>0)+4294967296.0*+(z>>>0))*8.0/g*1.0e9)|0;k=z;f=e+152|0;c[f>>2]=j;c[f+4>>2]=k;f=e+144|0;i=f;h=c[i>>2]|0;i=c[i+4>>2]|0;if(!((h|0)==-1&(i|0)==-1)){x=z0(h|0,i|0,j|0,k|0)|0;y=f;c[y>>2]=x;c[y+4>>2]=z}h=m;f=c[h>>2]|0;h=c[h+4>>2]|0;if(!((f|0)==-1&(h|0)==-1)){x=z0(f|0,h|0,j|0,k|0)|0;y=m;c[y>>2]=x;c[y+4>>2]=z}}}if(!(c[e+728>>2]&2)){B=A;f=c[B+4>>2]|0;switch(c[B>>2]|0){case 0:{if(!f)qg(e);else L=107;break}case 1:{if(!f)Cf(e);else L=107;break}default:L=107}if((L|0)==107){L=I;e1(e,c[L>>2]|0,c[L+4>>2]|0)}if(c[C>>2]|0?(jaa(c[K>>2]|0),c[K>>2]=c[C>>2],c[C>>2]=0,K=c[D>>2]|0,c[J>>2]=K,c[H>>2]=c[G>>2],L=E,K=D_(c[L>>2]|0,c[L+4>>2]|0,K|0,0)|0,L=E,c[L>>2]=K,c[L+4>>2]=z,(a[F>>0]|0)==0):0){K=I;K=PZ(c[K>>2]|0,c[K+4>>2]|0,4)|0;K=g5(K|0,z|0,14,0)|0;L=I;c[L>>2]=K;c[L+4>>2]=z}}else{if(c[C>>2]|0?(jaa(c[K>>2]|0),c[K>>2]=c[C>>2],c[C>>2]=0,K=c[D>>2]|0,c[J>>2]=K,c[H>>2]=c[G>>2],L=E,K=D_(c[L>>2]|0,c[L+4>>2]|0,K|0,0)|0,L=E,c[L>>2]=K,c[L+4>>2]=z,(a[F>>0]|0)==0):0){K=I;K=PZ(c[K>>2]|0,c[K+4>>2]|0,4)|0;K=g5(K|0,z|0,14,0)|0;L=I;c[L>>2]=K;c[L+4>>2]=z}K=I;L=B;L=D_(c[K>>2]|0,c[K+4>>2]|0,c[L>>2]|0,c[L+4>>2]|0)|0;e1(e,L,z)}l=M;return}function uc(b){b=b|0;var f=0.0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0.0,I=0,J=0,K=0,L=0;J=l;l=l+48|0;y=J+24|0;A=J+12|0;B=J;q=c[b+816>>2]|0;i=c[b+820>>2]|0;if((q|0)!=(i|0)){p=i-q>>3;n=1;j=31;f=0.0;o=0;r=0;v=0;while(1){i=o&255;if(i>>>0>=p>>>0)break;m=q+(i<<3)|0;k=c[m>>2]|0;m=c[m+4>>2]|0;if((k|0)==0&(m|0)==0){i=n;k=r;m=v}else{L=o<<24>>24==0?31:i;K=L&255;f=f+(+(k>>>0)+4294967296.0*+(m>>>0))*+D(10.0,+(-+(o&255)/10.0));k=z0(k|0,m|0,r|0,v|0)|0;i=(n&255)>>>0<L>>>0?K:n;j=(j&255)>>>0>L>>>0?K:j;m=z}n=i;o=o+1<<24>>24;r=k;v=m}if(!((r|0)==0&(v|0)==0)){u=+Fo(f/(+(r>>>0)+4294967296.0*+(v>>>0)))*10.0;sN(b,2,0,371160,u,0,0);Ou(b,2,0,371160,382945);ST(B,u,0);HX(B,12988)|0;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];i=0;while(1){if((i|0)==3)break;c[B+(i<<2)>>2]=0;i=i+1|0}p2(y,A);Mc(b,2,0,371177,y,0);z5(y);O0(A);z5(B);Ou(b,2,0,371177,382945);i=0-(n&255)|0;$M(b,2,0,371201,i);Ou(b,2,0,371201,382945);tU(B,i,10);HX(B,12988)|0;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];i=0;while(1){if((i|0)==3)break;c[B+(i<<2)>>2]=0;i=i+1|0}p2(y,A);Mc(b,2,0,371218,y,0);z5(y);O0(A);z5(B);Ou(b,2,0,371218,382945);i=0-(j&255)|0;$M(b,2,0,371242,i);Ou(b,2,0,371242,382945);tU(B,i,10);HX(B,12988)|0;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];i=0;while(1){if((i|0)==3)break;c[B+(i<<2)>>2]=0;i=i+1|0}p2(y,A);Mc(b,2,0,371259,y,0);z5(y);O0(A);z5(B);Ou(b,2,0,371259,382945);aL(b,2,0,371283,r,v,0);Ou(b,2,0,371283,382945)}}n=c[b+828>>2]|0;i=c[b+832>>2]|0;if((n|0)!=(i|0)){m=i-n>>3;k=0;f=0.0;s=-48.16;t=47.89;o=0;p=0;while(1){if((k|0)==(m|0))break;j=n+(k<<3)|0;i=c[j>>2]|0;j=c[j+4>>2]|0;if((i|0)==0&(j|0)==0){i=o;j=p}else{u=+h[160+(k>>>4<<3)>>3];u=u+ +us(+((k&15|16)>>>0)*.03125)*20.0;f=f+(+(i>>>0)+4294967296.0*+(j>>>0))*+D(10.0,+(u/10.0));i=z0(i|0,j|0,o|0,p|0)|0;s=s<u?u:s;t=t>u?u:t;j=z}k=k+1|0;o=i;p=j}if(!((o|0)==0&(p|0)==0)){u=+Fo(f/(+(o>>>0)+4294967296.0*+(p>>>0)))*10.0;sN(b,2,0,371298,u,2,0);Ou(b,2,0,371298,382945);ST(B,u,2);HX(B,12988)|0;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];i=0;while(1){if((i|0)==3)break;c[B+(i<<2)>>2]=0;i=i+1|0}p2(y,A);Mc(b,2,0,371312,y,0);z5(y);O0(A);z5(B);Ou(b,2,0,371312,382945);sN(b,2,0,371333,t,2,0);Ou(b,2,0,371333,382945);ST(B,t,2);HX(B,12988)|0;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];i=0;while(1){if((i|0)==3)break;c[B+(i<<2)>>2]=0;i=i+1|0}p2(y,A);Mc(b,2,0,371347,y,0);z5(y);O0(A);z5(B);Ou(b,2,0,371347,382945);sN(b,2,0,371368,s,2,0);Ou(b,2,0,371368,382945);ST(B,s,2);HX(B,12988)|0;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];i=0;while(1){if((i|0)==3)break;c[B+(i<<2)>>2]=0;i=i+1|0}p2(y,A);Mc(b,2,0,371382,y,0);z5(y);O0(A);z5(B);Ou(b,2,0,371382,382945);aL(b,2,0,371403,o,p,0);Ou(b,2,0,371403,382945)}}if(a[b+1491>>0]|0?(x=c[b+840>>2]|0,w=c[b+844>>2]|0,(x|0)!=(w|0)):0){m=w-x>>3;k=0;t=0.0;u=-24.08;f=23.95;n=0;o=0;while(1){if((k|0)==(m|0))break;j=x+(k<<3)|0;i=c[j>>2]|0;j=c[j+4>>2]|0;if((i|0)==0&(j|0)==0){i=n;j=o}else{if(!k)s=0.0;else{s=+h[288+(k>>>5<<3)>>3];s=s+ +us(+((k&31|32)>>>0)*.015625)*20.0}t=t+(+(i>>>0)+4294967296.0*+(j>>>0))*+D(10.0,+(s/10.0));i=z0(i|0,j|0,n|0,o|0)|0;u=u<s?s:u;f=f>s?s:f;j=z}k=k+1|0;n=i;o=j}if(!((n|0)==0&(o|0)==0)){t=+Fo(t/(+(n>>>0)+4294967296.0*+(o>>>0)))*10.0;sN(b,2,0,371415,t,2,0);Ou(b,2,0,371415,382945);ST(B,t,2);HX(B,12988)|0;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];i=0;while(1){if((i|0)==3)break;c[B+(i<<2)>>2]=0;i=i+1|0}p2(y,A);Mc(b,2,0,371430,y,0);z5(y);O0(A);z5(B);Ou(b,2,0,371430,382945);sN(b,2,0,371452,f,2,0);Ou(b,2,0,371452,382945);ST(B,f,2);HX(B,12988)|0;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];i=0;while(1){if((i|0)==3)break;c[B+(i<<2)>>2]=0;i=i+1|0}p2(y,A);Mc(b,2,0,371467,y,0);z5(y);O0(A);z5(B);Ou(b,2,0,371467,382945);sN(b,2,0,371489,u,2,0);Ou(b,2,0,371489,382945);ST(B,u,2);HX(B,12988)|0;c[A>>2]=c[B>>2];c[A+4>>2]=c[B+4>>2];c[A+8>>2]=c[B+8>>2];i=0;while(1){if((i|0)==3)break;c[B+(i<<2)>>2]=0;i=i+1|0}p2(y,A);Mc(b,2,0,371504,y,0);z5(y);O0(A);z5(B);Ou(b,2,0,371504,382945);aL(b,2,0,371526,n,o,0);Ou(b,2,0,371526,382945)}}a:do if(!(a[b+492>>0]|0)){r=b+1184|0;o=b+56|0;if(!(+g[(c[b+24>>2]|0)+136>>2]>=1.0)){if((d[r>>0]|0)>=10)break;if((c[b+872>>2]|0)!=1)break;if((c[b+860>>2]|0)!=1)break;L=b+880|0;if(!((c[L>>2]|0)==0&(c[L+4>>2]|0)==0))break;i=MT(a[(c[b+864>>2]|0)+16>>0]|0,a[(c[b+852>>2]|0)+16>>0]|0)|0;if(!(i<<16>>16))break;L=(a[b+1564>>0]|0)==0?i:(i&65535)+16&65535;q=b+40|0;p=o;p=D_(c[q>>2]|0,c[q+4>>2]|0,c[p>>2]|0,c[p+4>>2]|0)|0;L=L&65535;p=g5(p|0,z|0,L|0,0)|0;q=z;L=UW(p|0,q|0,L|0,0)|0;oK(b,2,0,194,L,z,10,0)}else{q=b+312|0;p=c[q>>2]|0;q=c[q+4>>2]|0;L=b+48|0;L=z0(c[b+612>>2]|0,0,c[L>>2]|0,c[L+4>>2]|0)|0;K=b+536|0;K=z0(L|0,z|0,c[K>>2]|0,c[K+4>>2]|0)|0;L=o;L=D_(K|0,z|0,c[L>>2]|0,c[L+4>>2]|0)|0;oK(b,2,0,194,L,z,10,0)}if(!((p|0)==0&(q|0)==0)){Ed(b,2,0,112);k=b+880|0;i=k;j=c[i>>2]|0;i=c[i+4>>2]|0;if(!((j|0)==0&(i|0)==0)?(G=Z0(a[b+1404>>0]|0)|0,G|0):0){do if(G>>>0>=44100){if(G>>>0>=48001)if(G>>>0>=96001)if(G>>>0>192e3)break;else{m=160;n=0}else{m=80;n=0}else{m=40;n=0}i=UW(m|0,n|0,j|0,i|0)|0;j=z;u=(+(i>>>0)+4294967296.0*+(j>>>0))/(+(G>>>0)/1.0e3);KW(b,2,0,68,u,0,0);oK(b,2,0,137,i,j,10,0);j=b+40|0;i=o;i=D_(c[j>>2]|0,c[j+4>>2]|0,c[i>>2]|0,c[i+4>>2]|0)|0;KW(b,2,0,112,(+(i>>>0)+4294967296.0*+(z>>>0))/u*8.0,0,0);i=k;j=c[i>>2]|0;i=c[i+4>>2]|0}while(0);oK(b,2,0,143,j,i,10,0)}if((a[b+1489>>0]|0?(oK(b,2,0,143,p,q,10,0),I=a[b+1180>>0]|0,I<<24>>24!=3):0)?(L=a[r>>0]|0,H=(L&255)<9?32.0:L<<24>>24==9?16.0:0.0,H!=0.0):0){H=H*(48.0e3/+((c[12456+((I&255)<<2)>>2]|0)>>>0));L=UW(p|0,q|0,1536,0)|0;oK(b,2,0,137,L,z,10,0);KW(b,2,0,68,(+(p>>>0)+4294967296.0*+(q>>>0))*H,0,0);lL(b,2,0,112,((e[59708+(((d[b+1182>>0]|0)>>>1&255)<<1)>>1]|0)*1e3|0)>>>((a[r>>0]|0)==9&1),10,0)}}}else{k=b+136|0;j=k;i=c[j>>2]|0;j=c[j+4>>2]|0;if(!((i|0)==-1&(j|0)==-1)?(F=b+280|0,E=F,C=c[E>>2]|0,E=c[E+4>>2]|0,j>>>0>E>>>0|(j|0)==(E|0)&i>>>0>C>>>0):0){i=D_(i|0,j|0,C|0,E|0)|0;i=cT((+(i>>>0)+4294967296.0*+(z>>>0))/1.0e6)|0;jL(b,2,0,68,i,z,0);i=a[b+1184>>0]|0;if((i&255)<9)f=32.0;else switch(i<<24>>24){case 9:case 11:case 12:case 13:case 14:case 15:case 16:{f=i<<24>>24==9?16.0:5.333333333333333;break}default:break a}K=k;L=F;L=D_(c[K>>2]|0,c[K+4>>2]|0,c[L>>2]|0,c[L+4>>2]|0)|0;L=cT((+(L>>>0)+4294967296.0*+(z>>>0))/1.0e6/f)|0;jL(b,2,0,143,L,z,0)}}while(0);l=J;return}function vc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;aa=l;l=l+64|0;V=aa+48|0;W=aa+36|0;X=aa+24|0;Y=aa+12|0;Z=aa;_=407252+(b*56|0)|0;T=407252+(b*56|0)+4|0;U=V+8+3|0;h=V+4|0;i=W+8|0;j=i+3|0;k=W+8|0;m=k+3|0;n=W+8|0;o=n+3|0;p=W+8|0;q=p+3|0;r=W+8|0;s=r+3|0;t=W+8|0;u=t+3|0;v=W+8|0;w=v+3|0;x=W+8|0;y=x+3|0;z=W+8|0;A=z+3|0;B=W+8|0;C=B+3|0;D=W+4|0;E=W+4|0;F=W+4|0;G=W+4|0;H=W+4|0;I=W+4|0;J=W+4|0;K=W+4|0;L=W+4|0;M=W+4|0;N=Y+8|0;O=N+3|0;P=Y+8|0;Q=P+3|0;R=Y+4|0;S=Y+4|0;g=0;a:while(1){if(g>>>0>=(((c[T>>2]|0)-(c[_>>2]|0)|0)/40|0)>>>0){$=3;break}p2(V,wF(_,g,0)|0);do if(!(a[404916]|0)){b=a[U>>0]|0;d=b<<24>>24<0;e=d?c[V>>2]|0:V;f=i9(6380)|0;if(!((f|0)!=0?(d=e+((d?c[h>>2]|0:b&255)<<2)|0,f=HA(e,d,6380,6380+(f<<2)|0)|0,(f|0)==(d|0)|(f-e|0)==-4):0)){c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;d=i9(3500)|0;if(d>>>0>1073741807){$=8;break a}if(d>>>0<2){a[j>>0]=d;b=W}else{b=d+4&-4;if(b>>>0>1073741823){$=12;break a}f=ZW(b<<2)|0;c[W>>2]=f;c[i>>2]=b|-2147483648;c[M>>2]=d;b=f}a3(b,3500,d);y7(b+(d<<2)|0,0);TX(X);vo(V,W,X,0,0);z5(X);O0(W);c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;d=i9(3536)|0;if(d>>>0>1073741807){$=15;break a}if(d>>>0<2){a[m>>0]=d;b=W}else{b=d+4&-4;if(b>>>0>1073741823){$=19;break a}f=ZW(b<<2)|0;c[W>>2]=f;c[k>>2]=b|-2147483648;c[L>>2]=d;b=f}a3(b,3536,d);y7(b+(d<<2)|0,0);TX(X);vo(V,W,X,0,0);z5(X);O0(W);c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;d=i9(3572)|0;if(d>>>0>1073741807){$=22;break a}if(d>>>0<2){a[o>>0]=d;b=W}else{b=d+4&-4;if(b>>>0>1073741823){$=26;break a}f=ZW(b<<2)|0;c[W>>2]=f;c[n>>2]=b|-2147483648;c[K>>2]=d;b=f}a3(b,3572,d);y7(b+(d<<2)|0,0);TX(X);vo(V,W,X,0,0);z5(X);O0(W);c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;d=i9(3608)|0;if(d>>>0>1073741807){$=29;break a}if(d>>>0<2){a[q>>0]=d;b=W}else{b=d+4&-4;if(b>>>0>1073741823){$=33;break a}f=ZW(b<<2)|0;c[W>>2]=f;c[p>>2]=b|-2147483648;c[J>>2]=d;b=f}a3(b,3608,d);y7(b+(d<<2)|0,0);TX(X);vo(V,W,X,0,0);z5(X);O0(W);c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;d=i9(3644)|0;if(d>>>0>1073741807){$=36;break a}if(d>>>0<2){a[s>>0]=d;b=W}else{b=d+4&-4;if(b>>>0>1073741823){$=40;break a}f=ZW(b<<2)|0;c[W>>2]=f;c[r>>2]=b|-2147483648;c[I>>2]=d;b=f}a3(b,3644,d);y7(b+(d<<2)|0,0);TX(X);vo(V,W,X,0,0);z5(X);O0(W);c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;d=i9(3680)|0;if(d>>>0>1073741807){$=43;break a}if(d>>>0<2){a[u>>0]=d;b=W}else{b=d+4&-4;if(b>>>0>1073741823){$=47;break a}f=ZW(b<<2)|0;c[W>>2]=f;c[t>>2]=b|-2147483648;c[H>>2]=d;b=f}a3(b,3680,d);y7(b+(d<<2)|0,0);TX(X);vo(V,W,X,0,0);z5(X);O0(W);c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;d=i9(3716)|0;if(d>>>0>1073741807){$=50;break a}if(d>>>0<2){a[w>>0]=d;b=W}else{b=d+4&-4;if(b>>>0>1073741823){$=54;break a}f=ZW(b<<2)|0;c[W>>2]=f;c[v>>2]=b|-2147483648;c[G>>2]=d;b=f}a3(b,3716,d);y7(b+(d<<2)|0,0);TX(X);vo(V,W,X,0,0);z5(X);O0(W);c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;d=i9(3752)|0;if(d>>>0>1073741807){$=57;break a}if(d>>>0<2){a[y>>0]=d;b=W}else{b=d+4&-4;if(b>>>0>1073741823){$=61;break a}f=ZW(b<<2)|0;c[W>>2]=f;c[x>>2]=b|-2147483648;c[F>>2]=d;b=f}a3(b,3752,d);y7(b+(d<<2)|0,0);TX(X);vo(V,W,X,0,0);z5(X);O0(W);c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;d=i9(3788)|0;if(d>>>0>1073741807){$=64;break a}if(d>>>0<2){a[A>>0]=d;b=W}else{b=d+4&-4;if(b>>>0>1073741823){$=68;break a}f=ZW(b<<2)|0;c[W>>2]=f;c[z>>2]=b|-2147483648;c[E>>2]=d;b=f}a3(b,3788,d);y7(b+(d<<2)|0,0);TX(X);vo(V,W,X,0,0);z5(X);O0(W);c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;d=i9(6380)|0;if(d>>>0>1073741807){$=71;break a}if(d>>>0<2){a[C>>0]=d;b=W}else{b=d+4&-4;if(b>>>0>1073741823){$=75;break a}f=ZW(b<<2)|0;c[W>>2]=f;c[B>>2]=b|-2147483648;c[D>>2]=d;b=f}a3(b,6380,d);y7(b+(d<<2)|0,0);TX(X);vo(V,W,X,0,0);z5(X);O0(W);if(a[404916]|0){$=94;break}}if((oH(V,47,0)|0)!=-1){TX(X);c[Y>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=0;d=i9(42012)|0;if(d>>>0>1073741807){$=80;break a}if(d>>>0<2){a[O>>0]=d;b=Y}else{b=d+4&-4;if(b>>>0>1073741823){$=84;break a}f=ZW(b<<2)|0;c[Y>>2]=f;c[N>>2]=b|-2147483648;c[S>>2]=d;b=f}a3(b,42012,d);y7(b+(d<<2)|0,0);Ok(W,V,X,Y,0,0);O0(Y);z5(X);c[Y>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=0;d=i9(42012)|0;if(d>>>0>1073741807){$=87;break a}if(d>>>0<2){a[Q>>0]=d;b=Y}else{b=d+4&-4;if(b>>>0>1073741823){$=91;break a}f=ZW(b<<2)|0;c[Y>>2]=f;c[P>>2]=b|-2147483648;c[R>>2]=d;b=f}a3(b,42012,d);y7(b+(d<<2)|0,0);TX(Z);Ok(X,V,Y,Z,0,0);z5(Z);O0(Y);e=jJ(W)|0;k1(wF(_,g,4)|0,e)|0;HX(wF(_,g,4)|0,42012)|0;e=jJ(X)|0;b=wF(_,g,4)|0;f=a[e+8+3>>0]|0;d=f<<24>>24<0;Ex(b,d?c[e>>2]|0:e,d?c[e+4>>2]|0:f&255)|0;z5(X);z5(W)}else $=94}else $=94;while(0);if(($|0)==94){$=0;f=jJ(V)|0;k1(wF(_,g,4)|0,f)|0}b=wF(_,g,5)|0;d=b+8+3|0;if((a[d>>0]|0)<0){y7(c[b>>2]|0,0);c[b+4>>2]=0}else{y7(b,0);a[d>>0]=0}f=jJ(wF(_,g,2)|0)|0;k1(wF(_,g,5)|0,f)|0;z5(V);g=g+1|0}switch($|0){case 3:{l=aa;return}case 8:{uaa();break}case 12:{aa=ua(8)|0;K2(aa,391652);c[aa>>2]=57868;Ya(aa|0,2712,367)}case 15:{uaa();break}case 19:{aa=ua(8)|0;K2(aa,391652);c[aa>>2]=57868;Ya(aa|0,2712,367)}case 22:{uaa();break}case 26:{aa=ua(8)|0;K2(aa,391652);c[aa>>2]=57868;Ya(aa|0,2712,367)}case 29:{uaa();break}case 33:{aa=ua(8)|0;K2(aa,391652);c[aa>>2]=57868;Ya(aa|0,2712,367)}case 36:{uaa();break}case 40:{aa=ua(8)|0;K2(aa,391652);c[aa>>2]=57868;Ya(aa|0,2712,367)}case 43:{uaa();break}case 47:{aa=ua(8)|0;K2(aa,391652);c[aa>>2]=57868;Ya(aa|0,2712,367)}case 50:{uaa();break}case 54:{aa=ua(8)|0;K2(aa,391652);c[aa>>2]=57868;Ya(aa|0,2712,367)}case 57:{uaa();break}case 61:{aa=ua(8)|0;K2(aa,391652);c[aa>>2]=57868;Ya(aa|0,2712,367)}case 64:{uaa();break}case 68:{aa=ua(8)|0;K2(aa,391652);c[aa>>2]=57868;Ya(aa|0,2712,367)}case 71:{uaa();break}case 75:{aa=ua(8)|0;K2(aa,391652);c[aa>>2]=57868;Ya(aa|0,2712,367)}case 80:{uaa();break}case 84:{aa=ua(8)|0;K2(aa,391652);c[aa>>2]=57868;Ya(aa|0,2712,367)}case 87:{uaa();break}case 91:{aa=ua(8)|0;K2(aa,391652);c[aa>>2]=57868;Ya(aa|0,2712,367)}}}function wc(b,e,f){b=b|0;e=e|0;f=f|0;var i=0,j=0,k=0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;O=l;l=l+288|0;J=O+8|0;K=O+17|0;L=O;M=O+16|0;i=a[e>>0]|0;a:do if(i<<24>>24){A=b+4|0;B=b+100|0;C=b+108|0;D=b+8|0;E=K+10|0;F=K+33|0;y=J+4|0;G=K+46|0;H=K+94|0;I=K+1|0;m=e;u=0;e=0;k=0;j=0;b:while(1){c:do if(!(Z8(i&255)|0)){i=i<<24>>24==37;d:do if(i){p=m+1|0;n=a[p>>0]|0;e:do switch(n<<24>>24){case 37:break d;case 42:{x=0;m=m+2|0;break}default:{i=(n&255)+-48|0;if(i>>>0<10?(a[m+2>>0]|0)==36:0){x=kR(f,i)|0;m=m+3|0;break e}m=(c[f>>2]|0)+(4-1)&~(4-1);x=c[m>>2]|0;c[f>>2]=m+4;m=p}}while(0);i=a[m>>0]|0;n=i&255;if((n+-48|0)>>>0<10){p=0;do{p=n+-48+(p*10|0)|0;m=m+1|0;i=a[m>>0]|0;n=i&255}while((n+-48|0)>>>0<10)}else p=0;i=i<<24>>24==109;w=(x|0)!=0;k=i?0:k;j=i?0:j;m=i?m+1|0:m;i=w&i;n=m+1|0;switch(a[m>>0]|0){case 104:{v=(a[n>>0]|0)==104;q=v?-2:-1;m=v?m+2|0:n;break}case 108:{v=(a[n>>0]|0)==108;q=v?3:1;m=v?m+2|0:n;break}case 106:{q=3;m=n;break}case 116:case 122:{q=1;m=n;break}case 76:{q=2;m=n;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{q=0;break}default:{N=133;break b}}s=d[m>>0]|0;t=(s&47|0)==3;s=t?s|32:s;t=t?1:q;r=s&255;switch(r<<24>>24){case 99:{p=(p|0)>1?p:1;break}case 91:break;case 110:{zI(x,t,u,((u|0)<0)<<31>>31);n=u;break c}default:{NV(b,0);do{n=c[A>>2]|0;if(n>>>0<(c[B>>2]|0)>>>0){c[A>>2]=n+1;n=d[n>>0]|0}else n=_x(b)|0}while((Z8(n)|0)!=0);if(!(c[B>>2]|0))n=c[A>>2]|0;else{n=(c[A>>2]|0)+-1|0;c[A>>2]=n}u=n+u+(c[C>>2]|0)-(c[D>>2]|0)|0}}NV(b,p);n=c[A>>2]|0;q=c[B>>2]|0;if(n>>>0<q>>>0)c[A>>2]=n+1;else{if((_x(b)|0)<0){N=133;break b}q=c[B>>2]|0}if(q|0)c[A>>2]=(c[A>>2]|0)+-1;f:do switch(r<<24>>24){case 91:case 99:case 115:{v=(s|0)==99;g:do if((s|16|0)==115){Ow(I|0,-1,256)|0;a[K>>0]=0;if((s|0)==115){a[F>>0]=0;a[E>>0]=0;a[E+1>>0]=0;a[E+2>>0]=0;a[E+3>>0]=0;a[E+4>>0]=0}}else{r=m+1|0;s=(a[r>>0]|0)==94;m=s?m+2|0:r;Ow(I|0,s&1|0,256)|0;a[K>>0]=0;s=(s^1)&1;switch(a[m>>0]|0){case 45:{n=G;N=61;break}case 93:{n=H;N=61;break}default:{}}if((N|0)==61){N=0;a[n>>0]=s;m=m+1|0}while(1){n=a[m>>0]|0;h:do switch(n<<24>>24){case 0:{N=133;break b}case 93:break g;case 45:{r=m+1|0;n=a[r>>0]|0;switch(n<<24>>24){case 93:case 0:{n=45;break h}default:{}}m=a[m+-1>>0]|0;if((m&255)<(n&255)){m=m&255;do{m=m+1|0;a[K+m>>0]=s;n=a[r>>0]|0}while((m|0)<(n&255|0));m=r}else m=r;break}default:{}}while(0);a[K+((n&255)+1)>>0]=s;m=m+1|0}}while(0);n=v?p+1|0:31;s=(t|0)==1;i:do if(s){if(i){j=Ub(n<<2)|0;if(!j){k=0;j=0;i=1;N=133;break b}}else j=x;c[J>>2]=0;c[y>>2]=0;r=n;k=0;j:while(1){q=(j|0)==0;do{k:while(1){n=c[A>>2]|0;if(n>>>0<(c[B>>2]|0)>>>0){c[A>>2]=n+1;n=d[n>>0]|0}else n=_x(b)|0;if(!(a[K+(n+1)>>0]|0))break j;a[M>>0]=n;switch(Yn(L,M,1,J)|0){case -1:{k=0;N=133;break b}case -2:break;default:break k}}if(!q){c[j+(k<<2)>>2]=c[L>>2];k=k+1|0}}while(!(i&(k|0)==(r|0)));k=r<<1|1;n=XG(j,k<<2)|0;if(!n){k=0;i=1;N=133;break b}else{t=r;r=k;j=n;k=t}}if(!(m5(J)|0)){k=0;N=133;break b}else{n=k;k=0;r=j}}else{if(i){k=Ub(n)|0;if(!k){k=0;j=0;i=1;N=133;break b}else{q=n;j=0}while(1){do{n=c[A>>2]|0;if(n>>>0<(c[B>>2]|0)>>>0){c[A>>2]=n+1;n=d[n>>0]|0}else n=_x(b)|0;if(!(a[K+(n+1)>>0]|0)){n=j;r=0;j=0;break i}a[k+j>>0]=n;j=j+1|0}while((j|0)!=(q|0));j=q<<1|1;n=XG(k,j)|0;if(!n){j=0;i=1;N=133;break b}else{t=q;q=j;k=n;j=t}}}if(!x){k=q;while(1){j=c[A>>2]|0;if(j>>>0<k>>>0){c[A>>2]=j+1;j=d[j>>0]|0}else j=_x(b)|0;if(!(a[K+(j+1)>>0]|0)){n=0;k=0;r=0;j=0;break i}k=c[B>>2]|0}}else{n=0;k=q;while(1){j=c[A>>2]|0;if(j>>>0<k>>>0){c[A>>2]=j+1;j=d[j>>0]|0}else j=_x(b)|0;if(!(a[K+(j+1)>>0]|0)){k=x;r=0;j=0;break i}a[x+n>>0]=j;n=n+1|0;k=c[B>>2]|0}}}while(0);if(!(c[B>>2]|0))q=c[A>>2]|0;else{q=(c[A>>2]|0)+-1|0;c[A>>2]=q}q=q-(c[D>>2]|0)+(c[C>>2]|0)|0;if(!q){N=135;break b}if(!((q|0)==(p|0)|v^1)){N=135;break b}do if(i)if(s){c[x>>2]=r;break}else{c[x>>2]=k;break}while(0);if(!v){if(r|0)c[r+(n<<2)>>2]=0;if(!k)k=0;else a[k+n>>0]=0}break}case 120:case 88:case 112:{n=16;N=121;break}case 111:{n=8;N=121;break}case 117:case 100:{n=10;N=121;break}case 105:{n=0;N=121;break}case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{o=+Pf(b,t,0);if((c[C>>2]|0)==((c[D>>2]|0)-(c[A>>2]|0)|0)){N=135;break b}if(x)switch(t|0){case 0:{g[x>>2]=o;break f}case 1:{h[x>>3]=o;break f}case 2:{h[x>>3]=o;break f}default:break f}break}default:{}}while(0);do if((N|0)==121){N=0;n=be(b,n,0,-1,-1)|0;if((c[C>>2]|0)==((c[D>>2]|0)-(c[A>>2]|0)|0)){N=135;break b}if(w&(s|0)==112){c[x>>2]=n;break}else{zI(x,t,n,z);break}}while(0);e=(w&1)+e|0;n=(c[C>>2]|0)+u+(c[A>>2]|0)-(c[D>>2]|0)|0;break c}while(0);m=m+(i&1)|0;NV(b,0);i=c[A>>2]|0;if(i>>>0<(c[B>>2]|0)>>>0){c[A>>2]=i+1;i=d[i>>0]|0}else i=_x(b)|0;if((i|0)!=(d[m>>0]|0)){N=20;break b}n=u+1|0}else{while(1){i=m+1|0;if(!(Z8(d[i>>0]|0)|0))break;else m=i}NV(b,0);do{i=c[A>>2]|0;if(i>>>0<(c[B>>2]|0)>>>0){c[A>>2]=i+1;i=d[i>>0]|0}else i=_x(b)|0}while((Z8(i)|0)!=0);if(!(c[B>>2]|0))i=c[A>>2]|0;else{i=(c[A>>2]|0)+-1|0;c[A>>2]=i}n=i+u+(c[C>>2]|0)-(c[D>>2]|0)|0}while(0);m=m+1|0;i=a[m>>0]|0;if(!(i<<24>>24))break a;else u=n}if((N|0)==20){if(c[B>>2]|0)c[A>>2]=(c[A>>2]|0)+-1;if((e|0)!=0|(i|0)>-1)break;else{i=0;N=134}}else if((N|0)==133){i=i&1;if(!e)N=134}else if((N|0)==135)i=i&1;if((N|0)==134)e=-1;if(i){pe(k);pe(j)}}else e=0;while(0);l=O;return e|0}
function Bb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;j=a+936|0;d=j;m=a+536|0;h=m;d=D_(c[h>>2]|0,c[h+4>>2]|0,c[d>>2]|0,c[d+4>>2]|0)|0;h=m;c[h>>2]=d;c[h+4>>2]=z;h=a+508|0;d=c[h>>2]|0;a:do if(!d)n=509;else{i=a+668|0;b=c[i>>2]|0;e=$$(b,1)|0;f=z;g=(d|0)==1;b:do if((e|0)<1297379947){if((e|0)>=1129138768){if((e|0)<1229866072){if((e|0)<1129140276){switch(e|0){case 1129138768:break;default:break b}if(f|0)break;if(!g){n=509;break a}DC(a);n=509;break a}if((e|0)>=1229215320){switch(e|0){case 1229215320:break;default:break b}if(f|0)break;if(!g){n=509;break a}if(k2(1,b)|0){n=509;break a}c3(1,b);break a}switch(e|0){case 1129140276:break;default:break b}if(f|0)break;if(!g){n=509;break a}if(k2(1,b)|0){ZD(a);n=509;break a}else{c3(1,b);break a}}if((e|0)<1247104587){switch(e|0){case 1229866072:break;default:break b}if(f|0)break;if(g){o7(a);b=c[h>>2]|0}else b=d;if((b|0)!=2){n=509;break a}b=c[i>>2]|0;if(k2(2,b)|0){xt(a);n=509;break a}else{c3(2,b);break a}}if((e|0)<1297377380){switch(e|0){case 1247104587:break;default:break b}if(f|0)break;if(!g){n=509;break a}o7(a);bZ(a);n=509;break a}switch(e|0){case 1297377380:break;default:break b}if(f|0)break;if(!g){n=509;break a}if(k2(1,b)|0){aD(a);n=509;break a}else{c3(1,b);break a}}if((e|0)>=1096173912){if((e|0)>=1128350800){if((e|0)<1128547393){switch(e|0){case 1128350800:break;default:break b}if(f|0)break;if(!g){n=509;break a}mu(a);n=509;break a}switch(e|0){case 1128547393:break;default:break b}if(f|0)break;if(g){o7(a);P6(a);b=c[h>>2]|0;if((b|0)==1){n=509;break a}d=b;b=c[i>>2]|0}i=$$(b,2)|0;if(!((i|0)==1718449184&(z|0)==0)){n=HN(a,0)|0;e1(a,n,z);n=509;break a}if((d|0)!=2){n=509;break a}if(k2(2,b)|0){Yh(a);n=509;break a}else{c3(2,b);break a}}switch(e|0){case 1096173912:break;default:break b}if(f|0)break;if(g){o7(a);Z1(a);b=c[h>>2]|0;if((b|0)==1){n=509;break a}d=b;b=c[i>>2]|0}e=$$(b,2)|0;f=z;c:do if((e|0)<1836021353){switch(e|0){case 1768192049:break;default:break c}if(!f){if((d|0)!=2){n=509;break a}if(k2(2,b)|0){F6(a);n=509;break a}else{c3(2,b);break a}}}else{switch(e|0){case 1836021353:break;default:break c}if(!f){if((d|0)==2){o7(a);E6(a);b=c[h>>2]|0;if((b|0)==2){n=509;break a}d=b;b=c[i>>2]|0}g=$$(b,3)|0;e=(d|0)==3;if(!((g|0)==1919247136&(z|0)==0)){if(!e){n=509;break a}if(k2(3,b)|0){u5(a);n=509;break a}else{c3(3,b);break a}}if(e){o7(a);v5(a);b=c[h>>2]|0}else b=d;if((b|0)!=4){n=509;break a}b=c[i>>2]|0;if(k2(4,b)|0){u5(a);n=509;break a}else{c3(4,b);break a}}}while(0);n=HN(a,0)|0;e1(a,n,z);n=509;break a}if((e|0)<1095321158){switch(e|0){case 1095321155:break;default:break b}if(f|0)break;if(g){o7(a);WU(a);b=c[h>>2]|0;if((b|0)==1){n=509;break a}d=b;b=c[i>>2]|0}e=$$(b,2)|0;f=z;d:do if((e|0)>=1180058962)if((e|0)<1397968452){switch(e|0){case 1180058962:break;default:break d}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){BY(a);n=509;break a}else{c3(2,b);break a}}else{switch(e|0){case 1397968452:break;default:break d}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){H6(a);n=509;break a}else{c3(2,b);break a}}else switch(e|0){case 1129270605:{if(f|0)break d;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){J6(a);n=509;break a}else{c3(2,b);break a}}case 1129270612:{if(f|0)break d;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){I6(a);n=509;break a}else{c3(2,b);break a}}default:break d}while(0);if((d|0)!=2){n=509;break a}if(k2(2,b)|0){G6(a);n=509;break a}else{c3(2,b);break a}}if((e|0)<1096173856){switch(e|0){case 1095321158:break;default:break b}if(f|0)break;if(g){o7(a);WU(a);b=c[h>>2]|0;if((b|0)==1){n=509;break a}d=b;b=c[i>>2]|0}e=$$(b,2)|0;f=z;e:do if((e|0)>=1229206304){if((e|0)>=1397968452){switch(e|0){case 1397968452:break;default:break e}if(f|0)break;if((d|0)!=2){n=509;break a}o7(a);D6(a);n=509;break a}switch(e|0){case 1229206304:break;default:break e}if(!f){if((d|0)!=2){n=509;break a}if(k2(2,b)|0){n=509;break a}c3(2,b);break a}}else switch(e|0){case 1129270605:{if(f|0)break e;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){Qk(a);n=509;break a}else{c3(2,b);break a}}case 1129270612:{if(f|0)break e;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){Hw(a);n=509;break a}else{c3(2,b);break a}}default:break e}while(0);if((d|0)!=2){n=509;break a}if(k2(2,b)|0){vl(a);n=509;break a}else{c3(2,b);break a}}switch(e|0){case 1096173856:break;default:break b}if(!f){if(g){o7(a);NL(a);b=c[h>>2]|0;if((b|0)==1){n=509;break a}d=b;b=c[i>>2]|0}e=$$(b,2)|0;f=z;f:do if((e|0)<1415864692){if((e|0)>=1247104587){if((e|0)<1296315680){switch(e|0){case 1247104587:break;default:break f}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){Fh(a);n=509;break a}else{c3(2,b);break a}}if((e|0)<1349676353){switch(e|0){case 1296315680:break;default:break f}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){To(a);n=509;break a}else{c3(2,b);break a}}else{switch(e|0){case 1349676353:break;default:break f}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){Sr(a);n=509;break a}else{c3(2,b);break a}}}if((e|0)<1196246356){switch(e|0){case 1131559026:break;default:break f}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){ZL(a);n=509;break a}else{c3(2,b);break a}}if((e|0)<1229866575){switch(e|0){case 1196246356:break;default:break f}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){Bj(a);n=509;break a}else{c3(2,b);break a}}switch(e|0){case 1229866575:break;default:break f}if(!f){if((d|0)==2){o7(a);b=c[h>>2]|0;if((b|0)==2){n=509;break a}d=b;b=c[i>>2]|0}e=$$(b,3)|0;f=z;g:do if((e|0)<1229803571)if((e|0)<1229740355){switch(e|0){case 1229538355:break;default:break g}if(f|0)break;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){n=509;break a}c3(3,b);break a}else{switch(e|0){case 1229740355:break;default:break g}if(f|0)break;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){n=509;break a}c3(3,b);break a}else if((e|0)<1247104587){switch(e|0){case 1229803571:break;default:break g}if(f|0)break;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){n=509;break a}c3(3,b);break a}else{switch(e|0){case 1247104587:break;default:break g}if(f|0)break;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){n=509;break a}c3(3,b);break a}while(0);if((d|0)!=3){n=509;break a}if(k2(3,b)|0){sc(a);n=509;break a}else{c3(3,b);break a}}}else{if((e|0)<1735356263){if((e|0)>=1668506996){if((e|0)<1702390118){switch(e|0){case 1668506996:break;default:break f}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){AY(a);n=509;break a}else{c3(2,b);break a}}switch(e|0){case 1702390118:break;default:break f}if(f|0)break;if((d|0)==2){o7(a);b=c[h>>2]|0}else b=d;if((b|0)!=3){n=509;break a}b=c[i>>2]|0;if(k2(3,b)|0){ej(a);n=509;break a}else{c3(3,b);break a}}switch(e|0){case 1415864692:break;default:break f}if(f|0)break;if((d|0)==2){o7(a);b=c[h>>2]|0;if((b|0)==2){n=509;break a}d=b;b=c[i>>2]|0}e=$$(b,3)|0;f=z;h:do if((e|0)<1952669505)switch(e|0){case 1919835969:{if(f|0)break h;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){e$(a);n=509;break a}else{c3(3,b);break a}}case 1919835983:{if(f|0)break h;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){e$(a);n=509;break a}else{c3(3,b);break a}}default:break h}else switch(e|0){case 1952669505:{if(f|0)break h;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){tw(a);n=509;break a}else{c3(3,b);break a}}case 1952669519:{if(f|0)break h;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){sw(a);n=509;break a}else{c3(3,b);break a}}default:break h}while(0);n=HN(a,0)|0;e1(a,n,z);n=509;break a}if((e|0)>=1768192049){if((e|0)<1836021353){switch(e|0){case 1768192049:break;default:break f}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){Tf(a);n=509;break a}else{c3(2,b);break a}}switch(e|0){case 1836021353:break;default:break f}if(f|0)break;if((d|0)==2){o7(a);Xk(a);b=c[h>>2]|0;if((b|0)==2){n=509;break a}d=b;b=c[i>>2]|0}g=$$(b,3)|0;e=(d|0)==3;if(!((g|0)==1919247136&(z|0)==0)){if(!e){n=509;break a}if(k2(3,b)|0){_e(a);n=509;break a}else{c3(3,b);break a}}if(e){o7(a);m8(a);b=c[h>>2]|0}else b=d;if((b|0)!=4){n=509;break a}b=c[i>>2]|0;if(k2(4,b)|0){_e(a);n=509;break a}else{c3(4,b);break a}}if((e|0)<1751413356){switch(e|0){case 1735356263:break;default:break f}if(f|0)break;if((d|0)==2){o7(a);B1(a);b=c[h>>2]|0;if((b|0)==2){n=509;break a}d=b;b=c[i>>2]|0}i=$$(b,3)|0;if(!((i|0)==1195655508&(z|0)==0)){n=HN(a,0)|0;e1(a,n,z);n=509;break a}if((d|0)!=3){n=509;break a}if(k2(3,b)|0){n=509;break a}c3(3,b);break a}switch(e|0){case 1751413356:break;default:break f}if(!f){if((d|0)==2){o7(a);b=c[h>>2]|0;if((b|0)==2){n=509;break a}d=b;b=c[i>>2]|0}e=$$(b,3)|0;f=z;i:do if((e|0)<1635150184){if((e|0)>=1247104587){if((e|0)<1330524776){switch(e|0){case 1247104587:break;default:break i}if(f|0)break;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){n=509;break a}c3(3,b);break a}switch(e|0){case 1330524776:break;default:break i}if(f|0)break;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){G$(a);n=509;break a}else{c3(3,b);break a}}switch(e|0){case 1229866575:break;default:break i}if(f|0)break;if((d|0)==3){o7(a);b=c[h>>2]|0;if((b|0)==3){n=509;break a}d=b;b=c[i>>2]|0}e=$$(b,4)|0;f=z;j:do if((e|0)<1229803571)if((e|0)<1229740355){switch(e|0){case 1229538355:break;default:break j}if(f|0)break;if((d|0)!=4){n=509;break a}if(k2(4,b)|0){n=509;break a}c3(4,b);break a}else{switch(e|0){case 1229740355:break;default:break j}if(f|0)break;if((d|0)!=4){n=509;break a}if(k2(4,b)|0){n=509;break a}c3(4,b);break a}else if((e|0)<1247104587){switch(e|0){case 1229803571:break;default:break j}if(f|0)break;if((d|0)!=4){n=509;break a}if(k2(4,b)|0){n=509;break a}c3(4,b);break a}else{switch(e|0){case 1247104587:break;default:break j}if(f|0)break;if((d|0)!=4){n=509;break a}if(k2(4,b)|0){n=509;break a}c3(4,b);break a}while(0);if((d|0)!=4){n=509;break a}if(k2(4,b)|0){sc(a);n=509;break a}else{c3(4,b);break a}}else{if((e|0)<1868852588){switch(e|0){case 1635150184:break;default:break i}if(f|0)break;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){mw(a);n=509;break a}else{c3(3,b);break a}}if((e|0)<1937011308){switch(e|0){case 1868852588:break;default:break i}if(f|0)break;if((d|0)==3){o7(a);b=c[h>>2]|0;if((b|0)==3){n=509;break a}d=b;b=c[i>>2]|0}i=$$(b,4)|0;if(!((i|0)==1684892776&(z|0)==0)){n=HN(a,0)|0;e1(a,n,z);n=509;break a}if((d|0)!=4){n=509;break a}if(k2(4,b)|0){QJ(a);n=509;break a}else{c3(4,b);break a}}switch(e|0){case 1937011308:break;default:break i}if(f|0)break;if((d|0)==3){o7(a);fU(a);b=c[h>>2]|0;if((b|0)==3){n=509;break a}d=b;b=c[i>>2]|0}e=$$(b,4)|0;f=z;k:do if((e|0)<1937011302){if((e|0)<1768842360){switch(e|0){case 1247104587:break;default:break k}if(f|0)break;if((d|0)!=4){n=509;break a}if(k2(4,b)|0){n=509;break a}c3(4,b);break a}if((e|0)<1937011300){switch(e|0){case 1768842360:break;default:break k}if(f|0)break;if((d|0)!=4){n=509;break a}if(k2(4,b)|0){Wn(a);n=509;break a}else{c3(4,b);break a}}else{switch(e|0){case 1937011300:break;default:break k}if(f|0)break;if((d|0)!=4){n=509;break a}if(k2(4,b)|0){G$(a);n=509;break a}else{c3(4,b);break a}}}else{if((e|0)<1937011310)switch(e|0){case 1937011302:{if(f|0)break k;if((d|0)!=4){n=509;break a}if(k2(4,b)|0){eq(a);n=509;break a}else{c3(4,b);break a}}case 1937011304:{if(f|0)break k;if((d|0)!=4){n=509;break a}if(k2(4,b)|0){Zg(a);n=509;break a}else{c3(4,b);break a}}default:break k}if((e|0)<1987080816){switch(e|0){case 1937011310:break;default:break k}if(f|0)break;if((d|0)!=4){n=509;break a}if(k2(4,b)|0){lK(a);n=509;break a}else{c3(4,b);break a}}else{switch(e|0){case 1987080816:break;default:break k}if(f|0)break;if((d|0)!=4){n=509;break a}if(k2(4,b)|0){gj(a);n=509;break a}else{c3(4,b);break a}}}while(0);n=HN(a,0)|0;e1(a,n,z);n=509;break a}while(0);if((d|0)!=3){n=509;break a}if(k2(3,b)|0){t5(a);n=509;break a}else{c3(3,b);break a}}}while(0);if((d|0)!=2){n=509;break a}if(k2(2,b)|0){ZF(a);n=509;break a}else{c3(2,b);break a}}}else{if((e|0)<1380798515){if((e|0)>=1380206914){if((e|0)<1380796740){switch(e|0){case 1380206914:break;default:break b}if(f|0)break;if(!g){n=509;break a}o7(a);J_(a);n=509;break a}switch(e|0){case 1380796740:{if(f|0)break b;if(!g){n=509;break a}o7(a);I_(a);n=509;break a}case 1380797776:{if(f|0)break b;if(!g){n=509;break a}o7(a);H_(a);n=509;break a}default:break b}}if((e|0)<1346456608){switch(e|0){case 1297379947:break;default:break b}if(f|0)break;if(!g){n=509;break a}o7(a);RD(a);n=509;break a}if((e|0)<1363952461){switch(e|0){case 1346456608:break;default:break b}if(f|0)break;if(!g){n=509;break a}o7(a);L_(a);n=509;break a}switch(e|0){case 1363952461:break;default:break b}if(f|0)break;if(g){o7(a);K_(a);b=c[h>>2]|0;if((b|0)==1){n=509;break a}d=b;b=c[i>>2]|0}i=$$(b,2)|0;if(!((i|0)==1718449184&(z|0)==0)){n=HN(a,0)|0;e1(a,n,z);n=509;break a}if((d|0)!=2){n=509;break a}if(k2(2,b)|0){Ch(a);n=509;break a}else{c3(2,b);break a}}if((e|0)<1462977609){if((e|0)>=1397577264)switch(e|0){case 1397577264:{if(f|0)break b;if(!g){n=509;break a}if(k2(1,b)|0){hi(a);n=509;break a}else{c3(1,b);break a}}case 1397577274:{if(f|0)break b;if(!g){n=509;break a}if(k2(1,b)|0){ey(a);n=509;break a}else{c3(1,b);break a}}default:break b}switch(e|0){case 1380798515:break;default:break b}if(f|0)break;if(g){o7(a);DY(a);d=c[h>>2]|0;if((d|0)==1){n=509;break a}b=c[i>>2]|0}e=$$(b,2)|0;f=z;l:do if((e|0)<1684108385){switch(e|0){case 1229866575:break;default:break l}if(!f){if((d|0)==2){o7(a);b=c[h>>2]|0;if((b|0)==2){n=509;break a}d=b;b=c[i>>2]|0}e=$$(b,3)|0;f=z;m:do if((e|0)<1229803571)if((e|0)<1229740355){switch(e|0){case 1229538355:break;default:break m}if(f|0)break;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){n=509;break a}c3(3,b);break a}else{switch(e|0){case 1229740355:break;default:break m}if(f|0)break;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){n=509;break a}c3(3,b);break a}else if((e|0)<1247104587){switch(e|0){case 1229803571:break;default:break m}if(f|0)break;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){n=509;break a}c3(3,b);break a}else{switch(e|0){case 1247104587:break;default:break m}if(f|0)break;if((d|0)!=3){n=509;break a}if(k2(3,b)|0){n=509;break a}c3(3,b);break a}while(0);if((d|0)!=3){n=509;break a}if(k2(3,b)|0){t5(a);n=509;break a}else{c3(3,b);break a}}}else{switch(e|0){case 1684108385:break;default:break l}if(!f){if((d|0)!=2){n=509;break a}o7(a);lu(a);n=509;break a}}while(0);n=HN(a,0)|0;e1(a,n,z);n=509;break a}if((e|0)>=1835363957){if((e|0)<2002876005){switch(e|0){case 1835363957:break;default:break b}if(f|0)break;if(!g){n=509;break a}o7(a);iQ(a);n=509;break a}switch(e|0){case 2002876005:break;default:break b}if(f|0)break;if(g){o7(a);G_(a);b=c[h>>2]|0;if((b|0)==1){n=509;break a}d=b;b=c[i>>2]|0}e=$$(b,2)|0;f=z;n:do if((e|0)<1718449184){switch(e|0){case 1684108385:break;default:break n}if(!f){if((d|0)!=2){n=509;break a}o7(a);D6(a);n=509;break a}}else{switch(e|0){case 1718449184:break;default:break n}if(!f){if((d|0)!=2){n=509;break a}if(k2(2,b)|0){O6(a);n=509;break a}else{c3(2,b);break a}}}while(0);n=HN(a,0)|0;e1(a,n,z);n=509;break a}if((e|0)<1463899717){switch(e|0){case 1462977609:break;default:break b}if(f|0)break;if(!g){n=509;break a}if(k2(1,b)|0){df(a);n=509;break a}else{c3(1,b);break a}}switch(e|0){case 1463899717:break;default:break b}if(!f){if(g){o7(a);CY(a);b=c[h>>2]|0;if((b|0)==1){n=509;break a}d=b;b=c[i>>2]|0}e=$$(b,2)|0;f=z;o:do if((e|0)<1684108385){if((e|0)>=1633176908){if((e|0)<1650817140){switch(e|0){case 1633176908:break;default:break o}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){e$(a);n=509;break a}else{c3(2,b);break a}}if((e|0)<1668637984){switch(e|0){case 1650817140:break;default:break o}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){Gd(a);n=509;break a}else{c3(2,b);break a}}else{switch(e|0){case 1668637984:break;default:break o}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){Kz(a);n=509;break a}else{c3(2,b);break a}}}if((e|0)<1229206304){switch(e|0){case 544763248:break;default:break o}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){lS(a);n=509;break a}else{c3(2,b);break a}}if((e|0)<1229866575){switch(e|0){case 1229206304:break;default:break o}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){n=509;break a}c3(2,b);break a}switch(e|0){case 1229866575:break;default:break o}if(!f){if((d|0)==2){o7(a);b=c[h>>2]|0}else b=d;if((b|0)!=3){n=509;break a}b=c[i>>2]|0;if(k2(3,b)|0){t5(a);n=509;break a}else{c3(3,b);break a}}}else{if((e|0)<1718449184){if((e|0)<1685272116){switch(e|0){case 1684108385:break;default:break o}if(f|0)break;if((d|0)!=2){n=509;break a}o7(a);Mj(a);n=509;break a}if((e|0)<1717658484){switch(e|0){case 1685272116:break;default:break o}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){QA(a);n=509;break a}else{c3(2,b);break a}}else{switch(e|0){case 1717658484:break;default:break o}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){Hp(a);n=509;break a}else{c3(2,b);break a}}}if((e|0)>=1768174368){if((e|0)<1835366516){switch(e|0){case 1768174368:break;default:break o}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){n=509;break a}c3(2,b);break a}switch(e|0){case 1835366516:break;default:break o}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){xY(a);n=509;break a}else{c3(2,b);break a}}if((e|0)<1767394636){switch(e|0){case 1718449184:break;default:break o}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){ZJ(a);n=509;break a}else{c3(2,b);break a}}else{switch(e|0){case 1767394636:break;default:break o}if(f|0)break;if((d|0)!=2){n=509;break a}if(k2(2,b)|0){e$(a);n=509;break a}else{c3(2,b);break a}}}while(0);n=HN(a,0)|0;e1(a,n,z);n=509;break a}}while(0);n=HN(a,0)|0;e1(a,n,z);n=509}while(0);if(((n|0)==509?(l=j,k=c[l>>2]|0,l=c[l+4>>2]|0,!((k|0)==0&(l|0)==0)):0)?(j=m,j=z0(c[j>>2]|0,c[j+4>>2]|0,k|0,l|0)|0,n=z,m,c[m>>2]=j,c[m+4>>2]=n,m=a+528|0,m=z0(c[m>>2]|0,c[m+4>>2]|0,k|0,l|0)|0,(m|0)==(j|0)&(z|0)==(n|0)):0)e1(a,k,l);return}function Cb(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0;B=l;l=l+128|0;h=B+120|0;i=B+116|0;A=B+104|0;y=B;x=B+64|0;v=B+48|0;w=B+36|0;r=B+24|0;s=B+12|0;TX(A);ID(d,h);o=d+508|0;n=d+668|0;e=$$(c[n>>2]|0,(c[o>>2]|0)+-1|0)|0;f=z;j=d+544|0;q=d+536|0;p=d+528|0;k=d+612|0;g=c[h>>2]|0;a:do if((e|0)<1953655662){switch(e|0){case 1684632427:break;default:{u=6;break a}}if(!f)u=4;else u=6}else{switch(e|0){case 1953655662:break;default:{u=6;break a}}if(!f)u=4;else u=6}while(0);b:do if((u|0)==4)if(!g)u=7;else{c[h>>2]=0;u=7}else if((u|0)==6)switch(g|0){case 0:{u=7;break b}case 1:{ID(d,i);u=($$(c[n>>2]|0,(c[o>>2]|0)+-1|0)|0)==-1453039239&(z|0)==0;f=p;g=q;f=D_(c[g>>2]|0,c[g+4>>2]|0,c[f>>2]|0,c[f+4>>2]|0)|0;g=z;if(!u){xZ(d,f,g,A);u=75;break b}c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[y+(e<<2)>>2]=0;e=e+1|0}EU(d,f,g,y);u=a[y+11>>0]|0;p=u<<24>>24<0;gd(A,p?c[y>>2]|0:y,p?c[y+4>>2]|0:u&255)|0;a1(y);u=75;break b}case 2:{Xy(y,24724);vF(A,y)|0;z5(y);u=75;break b}case 3:{ID(d,i);k=q;u=p;u=D_(c[k>>2]|0,c[k+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;jZ(d,u,z,A);u=75;break b}case 13:{ID(d,i);i=$$(c[n>>2]|0,(c[o>>2]|0)+-1|0)|0;if(!((i|0)==1668249202&(z|0)==0)){Xy(y,30108);vF(A,y)|0;z5(y);u=75;break b}h=c[j>>2]|0;g=p;w=c[g>>2]|0;g=c[g+4>>2]|0;f=z0(c[k>>2]|0,0,w|0,g|0)|0;v=q;g=D_(c[v>>2]|0,c[v+4>>2]|0,w|0,g|0)|0;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[y+11>>0]=g;e=y}else{w=g+16&-16;e=ZW(w)|0;c[y>>2]=e;c[y+8>>2]=w|-2147483648;c[y+4>>2]=g}i1(e,h+f|0,g)|0;J7(e+g|0,0);Zm(x,y);v=q;w=p;w=D_(c[v>>2]|0,c[v+4>>2]|0,c[w>>2]|0,c[w+4>>2]|0)|0;e1(d,w,z);bw(d,0,0,318,x,1,0);RB(d,0,0,314,382808,-1,1,0);a1(x);a1(y);break b}case 14:{ID(d,i);i=$$(c[n>>2]|0,(c[o>>2]|0)+-1|0)|0;if(!((i|0)==1668249202&(z|0)==0)){Xy(y,30108);vF(A,y)|0;z5(y);u=75;break b}h=c[j>>2]|0;g=p;w=c[g>>2]|0;g=c[g+4>>2]|0;f=z0(c[k>>2]|0,0,w|0,g|0)|0;v=q;g=D_(c[v>>2]|0,c[v+4>>2]|0,w|0,g|0)|0;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[y+11>>0]=g;e=y}else{w=g+16&-16;e=ZW(w)|0;c[y>>2]=e;c[y+8>>2]=w|-2147483648;c[y+4>>2]=g}i1(e,h+f|0,g)|0;J7(e+g|0,0);Zm(x,y);v=q;w=p;w=D_(c[v>>2]|0,c[v+4>>2]|0,c[w>>2]|0,c[w+4>>2]|0)|0;e1(d,w,z);bw(d,0,0,318,x,1,0);RB(d,0,0,314,382808,-1,1,0);a1(x);a1(y);break b}case 21:{ID(d,i);e=q;u=p;u=D_(c[e>>2]|0,c[e+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;e=z;switch(u|0){case 1:{if(!e){bB(d,y);Do(A,a[y>>0]|0)|0;u=75;break b}break}case 2:{if(!e){NB(d,y);Ho(A,b[y>>1]|0)|0;u=75;break b}break}case 4:{if(!e){ID(d,y);Fn(A,c[y>>2]|0,10)|0;u=75;break b}break}case 8:{if(!e){oz(d,y);u=y;zo(A,c[u>>2]|0,c[u+4>>2]|0)|0;u=75;break b}break}default:{}}Xy(y,24860);vF(A,y)|0;z5(y);u=75;break b}case 22:{e1(d,4,0);u=75;break b}case 23:{e1(d,8,0);u=75;break b}default:{Xy(y,24984);vF(A,y)|0;z5(y);u=75;break b}}while(0);c:do if((u|0)==7){ID(d,i);e=$$(c[n>>2]|0,(c[o>>2]|0)+-1|0)|0;f=z;d:do if((e|0)<1735291493){if((e|0)<1684632427){switch(e|0){case 1668249202:break;default:break d}if(f|0)break;h=c[j>>2]|0;g=p;w=c[g>>2]|0;g=c[g+4>>2]|0;f=z0(c[k>>2]|0,0,w|0,g|0)|0;v=q;g=D_(c[v>>2]|0,c[v+4>>2]|0,w|0,g|0)|0;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[y+11>>0]=g;e=y}else{w=g+16&-16;e=ZW(w)|0;c[y>>2]=e;c[y+8>>2]=w|-2147483648;c[y+4>>2]=g}i1(e,h+f|0,g)|0;J7(e+g|0,0);Zm(x,y);v=q;w=p;w=D_(c[v>>2]|0,c[v+4>>2]|0,c[w>>2]|0,c[w+4>>2]|0)|0;e1(d,w,z);bw(d,0,0,318,x,1,0);RB(d,0,0,314,382808,-1,1,0);a1(x);a1(y);break c}switch(e|0){case 1684632427:break;default:break d}if(!f){f=p;f=z0(c[f>>2]|0,c[f+4>>2]|0,2,0)|0;e=p;c[e>>2]=f;c[e+4>>2]=z;NB(d,y);NB(d,x);e=p;e=z0(c[e>>2]|0,c[e+4>>2]|0,2,0)|0;f=z;w=q;v=c[w+4>>2]|0;if(!(f>>>0>v>>>0|((f|0)==(v|0)?e>>>0>(c[w>>2]|0)>>>0:0))){w=p;c[w>>2]=e;c[w+4>>2]=f}e=b[y>>1]|0;if(e<<16>>16)kL(d,0,0,181,e,10,1);e=b[x>>1]|0;if(e<<16>>16)kL(d,0,0,182,e,10,1);break c}}else{if((e|0)<1953655662){switch(e|0){case 1735291493:break;default:break d}if(f|0)break;f=q;e=p;e=D_(c[f>>2]|0,c[f+4>>2]|0,c[e>>2]|0,c[e+4>>2]|0)|0;f=z;if(!((e|0)==2&(f|0)==0)){e1(d,e,f);break c}NB(d,y);e=b[y>>1]|0;if(e<<16>>16)sM(d,0,0,240,(e&65535)+-1|0,0);break c}switch(e|0){case 1953655662:break;default:break d}if(!f){f=p;f=z0(c[f>>2]|0,c[f+4>>2]|0,2,0)|0;e=p;c[e>>2]=f;c[e+4>>2]=z;NB(d,y);NB(d,x);e=p;e=z0(c[e>>2]|0,c[e+4>>2]|0,2,0)|0;f=z;w=q;v=c[w+4>>2]|0;if(!(f>>>0>v>>>0|((f|0)==(v|0)?e>>>0>(c[w>>2]|0)>>>0:0))){w=p;c[w>>2]=e;c[w+4>>2]=f}e=b[y>>1]|0;if(e<<16>>16)kL(d,0,0,187,e,10,1);e=b[x>>1]|0;if(e<<16>>16)kL(d,0,0,188,e,10,1);break c}}while(0);k=q;u=p;u=D_(c[k>>2]|0,c[k+4>>2]|0,c[u>>2]|0,c[u+4>>2]|0)|0;e1(d,u,z);Xy(y,30108);vF(A,y)|0;z5(y);u=75}while(0);e:do if((u|0)==75){e=c[d+768>>2]|0;if((e|0)>=1835299937){if((e|0)>=1835365473){switch(e|0){case 1835365473:break;default:break e}if(!(qO(d)|0))break;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[y+(e<<2)>>2]=0;e=e+1|0}x=$$(c[n>>2]|0,(c[o>>2]|0)+-1|0)|0;Nb(y,x,0)|0;x=a[y+11>>0]|0;e=x<<24>>24<0;if((e?c[y+4>>2]|0:x&255)|0)Mc(d,0,0,e?c[y>>2]|0:y,A,1);a1(y);break}switch(e|0){case 1835299937:break;default:break e}f=d+808|0;g=d+812|0;if((c[f>>2]|0)==(c[g>>2]|0))break;if(qO(d)|0){c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[y+(e<<2)>>2]=0;e=e+1|0}e=$$(c[n>>2]|0,(c[o>>2]|0)+-1|0)|0;if(e|0?(m=c[f>>2]|0,e>>>0<=(((c[g>>2]|0)-m|0)/12|0)>>>0):0)Of(y,m+((e+-1|0)*12|0)|0);e=j9(377664)|0;i=y+11|0;g=a[i>>0]|0;j=y+4|0;f=c[j>>2]|0;h=d+832|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0)){if(ZG(y,377664,e)|0){f=c[j>>2]|0;g=a[i>>0]|0;u=320;break}c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;g=i9(409096)|0;if(g>>>0>1073741807)uaa();e=v+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){B=ua(8)|0;K2(B,391652);c[B>>2]=57868;Ya(B|0,2712,367)}else{t=ZW(f<<2)|0;c[v>>2]=t;c[e>>2]=f|-2147483648;c[v+4>>2]=g;e=t;break}}else{a[e+3>>0]=g;e=v}while(0);a3(e,409096,g);y7(e+(g<<2)|0,0);c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;g=i9(42252)|0;if(g>>>0>1073741807)uaa();e=w+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){B=ua(8)|0;K2(B,391652);c[B>>2]=57868;Ya(B|0,2712,367)}else{t=ZW(f<<2)|0;c[w>>2]=t;c[e>>2]=f|-2147483648;c[w+4>>2]=g;e=t;break}}else{a[e+3>>0]=g;e=w}while(0);a3(e,42252,g);y7(e+(g<<2)|0,0);Ok(x,A,v,w,0,0);vF(h,x)|0;z5(x);O0(w);O0(v)}else u=320;while(0);f:do if((u|0)==320){e=j9(377692)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0)){if(ZG(y,377692,e)|0){g=a[i>>0]|0;f=c[j>>2]|0;break}c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;g=i9(409096)|0;if(g>>>0>1073741807)uaa();e=v+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){B=ua(8)|0;K2(B,391652);c[B>>2]=57868;Ya(B|0,2712,367)}else{u=ZW(f<<2)|0;c[v>>2]=u;c[e>>2]=f|-2147483648;c[v+4>>2]=g;e=u;break}}else{a[e+3>>0]=g;e=v}while(0);a3(e,409096,g);y7(e+(g<<2)|0,0);c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;g=i9(42252)|0;if(g>>>0>1073741807)uaa();e=w+8|0;do if(g>>>0>=2){f=g+4&-4;if(f>>>0>1073741823){B=ua(8)|0;K2(B,391652);c[B>>2]=57868;Ya(B|0,2712,367)}else{u=ZW(f<<2)|0;c[w>>2]=u;c[e>>2]=f|-2147483648;c[w+4>>2]=g;e=u;break}}else{a[e+3>>0]=g;e=w}while(0);a3(e,42252,g);y7(e+(g<<2)|0,0);Ok(x,A,v,w,0,0);vF(h,x)|0;z5(x);O0(w);O0(v);break f}while(0);e=j9(377727)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(ZG(y,377727,e)|0)){zb(d,0,0,320,A,1);break f}else{g=a[i>>0]|0;f=c[j>>2]|0;break}while(0);e=j9(377755)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(ZG(y,377755,e)|0)){zb(d,0,0,245,A,1);break f}else{g=a[i>>0]|0;f=c[j>>2]|0;break}while(0);e=j9(377787)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(ZG(y,377787,e)|0)){Mc(d,0,0,377823,A,0);break f}else{g=a[i>>0]|0;f=c[j>>2]|0;break}while(0);e=j9(377834)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(ZG(y,377834,e)|0)){Mc(d,0,0,377878,A,0);break f}else{g=a[i>>0]|0;f=c[j>>2]|0;break}while(0);e=j9(377897)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0)){if(ZG(y,377897,e)|0){g=a[i>>0]|0;f=c[j>>2]|0;break}Mc(d,0,0,377926,A,0);Ou(d,0,0,377926,377949);gq(x,d,0,0,377955);u=a[x+8+3>>0]|0;u=((u<<24>>24<0?c[x+4>>2]|0:u&255)|0)==0;z5(x);if(u)break f;Bs(r,A,39932);gq(s,d,0,0,377926);e=a[s+8+3>>0]|0;u=e<<24>>24<0;Ex(r,u?c[s>>2]|0:s,u?c[s+4>>2]|0:e&255)|0;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];e=0;while(1){if((e|0)==3)break;c[r+(e<<2)>>2]=0;e=e+1|0}HX(w,39944)|0;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];e=0;while(1){if((e|0)==3)break;c[w+(e<<2)>>2]=0;e=e+1|0}p2(x,v);Mc(d,0,0,377975,x,1);z5(x);O0(v);O0(w);z5(s);O0(r);Ou(d,0,0,377975,377996);break f}while(0);e=j9(378002)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0)){if(ZG(y,378002,e)|0){g=a[i>>0]|0;f=c[j>>2]|0;break}Mc(d,0,0,377955,A,0);Ou(d,0,0,377955,377949);gq(x,d,0,0,377926);u=a[x+8+3>>0]|0;u=((u<<24>>24<0?c[x+4>>2]|0:u&255)|0)==0;z5(x);if(u)break f;Bs(r,A,39932);gq(s,d,0,0,377926);e=a[s+8+3>>0]|0;u=e<<24>>24<0;Ex(r,u?c[s>>2]|0:s,u?c[s+4>>2]|0:e&255)|0;c[w>>2]=c[r>>2];c[w+4>>2]=c[r+4>>2];c[w+8>>2]=c[r+8>>2];e=0;while(1){if((e|0)==3)break;c[r+(e<<2)>>2]=0;e=e+1|0}HX(w,39944)|0;c[v>>2]=c[w>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];e=0;while(1){if((e|0)==3)break;c[w+(e<<2)>>2]=0;e=e+1|0}p2(x,v);Mc(d,0,0,377975,x,1);z5(x);O0(v);O0(w);z5(s);O0(r);Ou(d,0,0,377975,377996);break f}while(0);e=g<<24>>24<0;if((e?f:g&255)|0)Mc(d,0,0,e?c[y>>2]|0:y,A,1)}while(0);a1(y)}d=d+820|0;c[d>>2]=(c[d>>2]|0)+1;break}switch(e|0){case 1835297138:break;default:break e}if(qO(d)|0){c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[y+(e<<2)>>2]=0;e=e+1|0}e=$$(c[n>>2]|0,(c[o>>2]|0)+-1|0)|0;f=z;do if((e|0)==757935405&(f|0)==0){e=d+772|0;f=j9(377523)|0;u=a[e+11>>0]|0;if(((f|0)==((u<<24>>24<0?c[d+776>>2]|0:u&255)|0)?(ZG(e,377523,f)|0)==0:0)?(u=q,s=c[u+4>>2]|0,s>>>0>0|(s|0)==0&(c[u>>2]|0)>>>0>8):0)break;Of(y,e)}else Nb(y,e,f)|0;while(0);e=j9(377532)|0;n=y+11|0;u=a[n>>0]|0;j=y+4|0;m=A+4|0;i=d+20|0;k=A+8+3|0;do if((e|0)==((u<<24>>24<0?c[j>>2]|0:u&255)|0)?(ZG(y,377532,e)|0)==0:0){e=a[k>>0]|0;f=e<<24>>24<0;g=f?c[A>>2]|0:A;h=i9(25076)|0;if(h|0?(s=g+((f?c[m>>2]|0:e&255)<<2)|0,u=HA(g,s,25076,25076+(h<<2)|0)|0,!((u|0)!=(s|0)&(u|0)==(g|0))):0)break;mI(x);Xy(v,41840);z3(x,v);z5(v);og(x,A);u=c[i>>2]|0;zb(d,2,u,250,DN(x,0)|0,1);u=c[i>>2]|0;zb(d,2,u,251,DN(x,1)|0,1);if((a[n>>0]|0)<0){J7(c[y>>2]|0,0);c[j>>2]=0}else{J7(y,0);a[n>>0]=0}$_(x)}while(0);e=j9(377552)|0;u=a[n>>0]|0;do if((e|0)==((u<<24>>24<0?c[j>>2]|0:u&255)|0)?(ZG(y,377552,e)|0)==0:0){e=a[k>>0]|0;f=e<<24>>24<0;g=f?c[A>>2]|0:A;h=i9(25136)|0;if(h|0?(s=g+((f?c[m>>2]|0:e&255)<<2)|0,u=HA(g,s,25136,25136+(h<<2)|0)|0,!((u|0)!=(s|0)&(u|0)==(g|0))):0)break;mI(x);Xy(v,41840);z3(x,v);z5(v);og(x,A);RB(d,2,c[i>>2]|0,250,377557,-1,1,1);u=c[i>>2]|0;lw(w,DN(x,0)|0,8,-1);p2(v,w);zb(d,2,u,250,v,1);z5(v);O0(w);w=c[i>>2]|0;zb(d,2,w,253,DN(x,1)|0,1);if((a[n>>0]|0)<0){J7(c[y>>2]|0,0);c[j>>2]=0}else{J7(y,0);a[n>>0]=0}$_(x)}while(0);e=j9(377572)|0;f=a[n>>0]|0;g=c[j>>2]|0;if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(ZG(y,377572,e)|0))u=113;else{f=a[n>>0]|0;g=c[j>>2]|0;u=105}else u=105;do if((u|0)==105){e=j9(377584)|0;if((e|0)==((f<<24>>24<0?g:f&255)|0)){if(!(ZG(y,377584,e)|0)){u=113;break}f=a[n>>0]|0;g=c[j>>2]|0}e=j9(377592)|0;if((e|0)==((f<<24>>24<0?g:f&255)|0)){if(!(ZG(y,377592,e)|0)){u=113;break}f=a[n>>0]|0;g=c[j>>2]|0}e=j9(377600)|0;if((e|0)==((f<<24>>24<0?g:f&255)|0)?(ZG(y,377600,e)|0)==0:0)u=113}while(0);g:do if((u|0)==113){f=i9(37572)|0;e=a[k>>0]|0;do if((f|0)==((e<<24>>24<0?c[m>>2]|0:e&255)|0))if(!(VG(A,37572,f)|0)){Xy(x,30156);vF(A,x)|0;z5(x);break g}else{e=a[k>>0]|0;break}while(0);if(e<<24>>24<0){y7(c[A>>2]|0,0);c[m>>2]=0;break}else{y7(A,0);a[k>>0]=0;break}}while(0);e=j9(377608)|0;w=a[n>>0]|0;do if((((e|0)==((w<<24>>24<0?c[j>>2]|0:w&255)|0)?(ZG(y,377608,e)|0)==0:0)?(t=i9(42196)|0,w=a[k>>0]|0,(t|0)==((w<<24>>24<0?c[m>>2]|0:w&255)|0)):0)?(VG(A,42196,t)|0)==0:0)if((a[k>>0]|0)<0){y7(c[A>>2]|0,0);c[m>>2]=0;break}else{y7(A,0);a[k>>0]=0;break}while(0);e=j9(377612)|0;w=a[n>>0]|0;if((e|0)==((w<<24>>24<0?c[j>>2]|0:w&255)|0)?(ZG(y,377612,e)|0)==0:0){e=i9(42196)|0;g=a[k>>0]|0;f=c[m>>2]|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(A,42196,e)|0)){Xy(x,25172);vF(A,x)|0;z5(x);break}else{g=a[k>>0]|0;f=c[m>>2]|0;u=133;break}else u=133;while(0);h:do if((u|0)==133){e=i9(37572)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(A,37572,e)|0)){Xy(x,25196);vF(A,x)|0;z5(x);break h}else{g=a[k>>0]|0;f=c[m>>2]|0;break}while(0);e=i9(25220)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(A,25220,e)|0)){Xy(x,25228);vF(A,x)|0;z5(x);break h}else{g=a[k>>0]|0;f=c[m>>2]|0;break}while(0);e=i9(25268)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(A,25268,e)|0)){Xy(x,25276);vF(A,x)|0;z5(x);break h}else{g=a[k>>0]|0;f=c[m>>2]|0;break}while(0);e=i9(25344)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(A,25344,e)|0)){Xy(x,25352);vF(A,x)|0;z5(x);break h}else{g=a[k>>0]|0;f=c[m>>2]|0;break}while(0);e=i9(25400)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(A,25400,e)|0)){Xy(x,25408);vF(A,x)|0;z5(x);break h}else{g=a[k>>0]|0;f=c[m>>2]|0;break}while(0);e=i9(25452)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(A,25452,e)|0)){Xy(x,25464);vF(A,x)|0;z5(x);break h}else{g=a[k>>0]|0;f=c[m>>2]|0;break}while(0);e=i9(25496)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(A,25496,e)|0)){Xy(x,25508);vF(A,x)|0;z5(x);break h}else{g=a[k>>0]|0;f=c[m>>2]|0;break}while(0);e=i9(25540)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0))if(!(VG(A,25540,e)|0)){Xy(x,25552);vF(A,x)|0;z5(x);break h}else{g=a[k>>0]|0;f=c[m>>2]|0;break}while(0);e=i9(25588)|0;do if((e|0)==((g<<24>>24<0?f:g&255)|0)){if(VG(A,25588,e)|0)break;Xy(x,25600);vF(A,x)|0;z5(x);break h}while(0);Xy(x,25632);vF(A,x)|0;z5(x)}while(0);zb(d,0,0,243,A,0)}e=j9(377624)|0;w=a[n>>0]|0;if((e|0)==((w<<24>>24<0?c[j>>2]|0:w&255)|0)?(ZG(y,377624,e)|0)==0:0){e=i9(42196)|0;w=a[k>>0]|0;if((e|0)==((w<<24>>24<0?c[m>>2]|0:w&255)|0)?(VG(A,42196,e)|0)==0:0){Xy(x,25684);vF(A,x)|0;z5(x)}else{Xy(x,25712);vF(A,x)|0;z5(x)}zb(d,0,0,304,A,0)}e=j9(380211)|0;w=a[n>>0]|0;i:do if((e|0)==((w<<24>>24<0?c[j>>2]|0:w&255)|0)?(ZG(y,380211,e)|0)==0:0){e=i9(42196)|0;f=a[k>>0]|0;g=c[m>>2]|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,42196,e)|0)){Xy(x,25728);vF(A,x)|0;z5(x);break i}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(25220)|0;if((e|0)==((f<<24>>24<0?g:f&255)|0)?(VG(A,25220,e)|0)==0:0){Xy(x,25748);vF(A,x)|0;z5(x);break}Xy(x,39568);vF(A,x)|0;z5(x)}while(0);e=j9(377646)|0;w=a[n>>0]|0;j:do if((e|0)==((w<<24>>24<0?c[j>>2]|0:w&255)|0)?(ZG(y,377646,e)|0)==0:0){e=i9(25772)|0;f=a[k>>0]|0;g=c[m>>2]|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,25772,e)|0)){Xy(x,25800);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(25856)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,25856,e)|0)){Xy(x,25884);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(25912)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,25912,e)|0)){Xy(x,25940);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(25972)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,25972,e)|0)){Xy(x,26e3);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26060)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26060,e)|0)){Xy(x,26088);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26120)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26120,e)|0)){Xy(x,26148);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26180)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26180,e)|0)){Xy(x,26208);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26240)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26240,e)|0)){Xy(x,26268);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26296)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26296,e)|0)){Xy(x,26324);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26356)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26356,e)|0)){Xy(x,26384);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26408)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26408,e)|0)){Xy(x,26436);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26480)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26480,e)|0)){Xy(x,26508);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26556)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26556,e)|0)){Xy(x,26584);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26620)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26620,e)|0)){Xy(x,26648);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26672)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26672,e)|0)){Xy(x,26700);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26728)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26728,e)|0)){Xy(x,26756);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26784)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26784,e)|0)){Xy(x,26812);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26840)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26840,e)|0)){Xy(x,26868);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26900)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26900,e)|0)){Xy(x,26928);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(26976)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,26976,e)|0)){Xy(x,27004);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(27044)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,27044,e)|0)){Xy(x,27072);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(27120)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,27120,e)|0)){Xy(x,27148);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(27172)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,27172,e)|0)){Xy(x,27200);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(27240)|0;do if((e|0)==((f<<24>>24<0?g:f&255)|0))if(!(VG(A,27240,e)|0)){Xy(x,27268);vF(A,x)|0;z5(x);break j}else{f=a[k>>0]|0;g=c[m>>2]|0;break}while(0);e=i9(27296)|0;if((e|0)!=((f<<24>>24<0?g:f&255)|0))break;if(VG(A,27296,e)|0)break;Xy(x,27324);vF(A,x)|0;z5(x)}while(0);w=a[n>>0]|0;e=w<<24>>24<0;do if((e?c[j>>2]|0:w&255)|0){gq(x,d,0,0,e?c[y>>2]|0:y);e=a[k>>0]|0;g=e<<24>>24<0;e=g?c[m>>2]|0:e&255;w=a[x+8+3>>0]|0;f=w<<24>>24<0;if((e|0)==((f?c[x+4>>2]|0:w&255)|0)){w=(L$(g?c[A>>2]|0:A,f?c[x>>2]|0:x,e)|0)==0;z5(x);if(w)break}else z5(x);Mc(d,0,0,(a[n>>0]|0)<0?c[y>>2]|0:y,A,0)}while(0);a1(y)}}while(0);z5(A);l=B;return}function Db(b){b=b|0;var d=0,e=0,f=0,i=0,j=0,k=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,O=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0;ab=l;l=l+128|0;Za=ab+108|0;_a=ab+96|0;$a=ab+84|0;Ya=ab+72|0;ea=ab+60|0;ma=ab+48|0;xa=ab+36|0;Ga=ab+24|0;Oa=ab+12|0;C=ab;if(a[b+1043>>0]|0)RB(b,0,0,65,379116,-1,1,0);Xy(Za,28540);gF(b,Za,b+840|0);z5(Za);Xy(Za,28560);gF(b,Za,b+852|0);z5(Za);Xy(Za,28604);gF(b,Za,b+864|0);z5(Za);F=b+760|0;G=b+764|0;H=b+16|0;I=b+20|0;J=b+968|0;K=b+24|0;L=$a+8+3|0;M=$a+4|0;O=Ya+8+3|0;Q=Ya+4|0;R=Ya+8+3|0;S=Ya+4|0;T=ea+8+3|0;U=ea+4|0;V=ma+8+3|0;W=ma+4|0;X=Ya+8+3|0;Y=Ya+4|0;Z=ma+8+3|0;_=ma+4|0;$=ma+8+3|0;aa=ma+4|0;ca=Ya+8+3|0;fa=Ya+4|0;ga=ma+8+3|0;ha=ma+4|0;ia=ma+8+3|0;ja=ma+4|0;ka=_a+8+3|0;la=_a+4|0;ra=_a+8+3|0;sa=_a+4|0;ta=$a+8+3|0;ua=$a+4|0;va=_a+8+3|0;wa=_a+4|0;ya=_a+8+3|0;za=_a+4|0;Aa=b+992|0;Ba=b+984|0;Ca=$a+8+3|0;Da=$a+4|0;Ea=$a+8+3|0;Fa=$a+4|0;Ha=$a+8+3|0;Ia=$a+4|0;Ja=$a+8+3|0;Ka=$a+4|0;La=b+776|0;Ma=b+780|0;Na=ma+8+3|0;Pa=ma+4|0;e=c[F>>2]|0;while(1){if((e|0)==(G|0))break;x=e+16|0;i=c[e+64>>2]|0;c[H>>2]=i;j=c[e+68>>2]|0;c[I>>2]=j;y=e+88|0;f=y;d=c[f>>2]|0;f=c[f+4>>2]|0;if(!((d|0)==0&(f|0)==0))oK(b,i,j,Rb(i,91)|0,d,f,10,0);r=e+24|0;k=e+28|0;if((a[x+91>>0]|0?(D=c[r>>2]|0,E=c[k>>2]|0,(D|0)!=(E|0)):0)?(c[(c[D>>2]|0)+728>>2]&1|0)==0:0){i=0;j=D;d=E;f=D;while(1){if(i>>>0>=((d-j>>2)+-1|0)>>>0)break;f=c[j+(i<<2)>>2]|0;if(!f)f=j;else{jb[c[(c[f>>2]|0)+4>>2]&511](f);d=c[k>>2]|0;f=c[r>>2]|0}i=i+1|0;j=f}xI(r,j,f+(d-f>>2<<2)+-4|0);pO(c[c[r>>2]>>2]|0)}m=+h[J>>3];if(m!=0.0?(c[H>>2]|0)==1:0)KW(b,1,c[I>>2]|0,150,m,3,0);TX(Za);d=c[x>>2]|0;if((d|0)!=-1)Gk(Za,(d>>>16&255)+-528+((d>>>24)*10|0)|0,10)|0;d=c[r>>2]|0;w=e+48|0;if(((c[k>>2]|0)-d|0)!=4){d=c[H>>2]|0;if(d|0)zb(b,d,c[I>>2]|0,10,Za,0)}else{a[(c[d>>2]|0)+732>>0]=0;TX(_a);TX($a);d=c[H>>2]|0;if((d|0)==1){$x(Ya,b,1,c[I>>2]|0,58,1);vF($a,Ya)|0;z5(Ya);d=c[H>>2]|0}v=c[I>>2]|0;$x(Ya,b,d,v,Rb(d,91)|0,1);vF(_a,Ya)|0;z5(Ya);if(+g[(c[K>>2]|0)+136>>2]<=1.0){s4(c[c[r>>2]>>2]|0);Kl(c[c[r>>2]>>2]|0)}G2(b,c[c[r>>2]>>2]|0);d=c[r>>2]|0;a:do if((d|0)!=(c[k>>2]|0)?(RA(c[d>>2]|0,c[H>>2]|0,-1)|0)!=0:0){do if((c[H>>2]|0)==2?(c[e+60>>2]|0)==1:0){$x(Ya,b,0,0,57,1);d=i9(29632)|0;v=a[X>>0]|0;if((d|0)==((v<<24>>24<0?c[Y>>2]|0:v&255)|0)?(VG(Ya,29632,d)|0)==0:0){d=Vj(c[c[r>>2]>>2]|0,2,0,18,1)|0;f=i9(28648)|0;v=a[d+8+3>>0]|0;if((f|0)==((v<<24>>24<0?c[d+4>>2]|0:v&255)|0)){v=(VG(d,28648,f)|0)==0;z5(Ya);if(v)break}else z5(Ya);Ed(b,2,0,122);break}z5(Ya)}while(0);k=c[I>>2]|0;i=0;while(1){if(i>>>0>=(RA(c[c[r>>2]>>2]|0,c[H>>2]|0,-1)|0)>>>0)break a;p2(Ya,Za);p2(ea,Za);Gb(b,c[c[r>>2]>>2]|0,c[H>>2]|0,i,i+k|0,1)|0;$x(ma,b,c[H>>2]|0,c[I>>2]|0,10,1);v=a[Z>>0]|0;v=((v<<24>>24<0?c[_>>2]|0:v&255)|0)==0;z5(ma);if(!v){v=a[ca>>0]|0;if((v<<24>>24<0?c[fa>>2]|0:v&255)|0){Gx(Ya,45);Gx(ea,45)}$x(ma,b,c[H>>2]|0,c[I>>2]|0,10,1);v=a[ga>>0]|0;u=v<<24>>24<0;Ex(Ya,u?c[ma>>2]|0:ma,u?c[ha>>2]|0:v&255)|0;z5(ma);$x(ma,b,c[H>>2]|0,c[I>>2]|0,10,1);v=a[ia>>0]|0;u=v<<24>>24<0;Ex(ea,u?c[ma>>2]|0:ma,u?c[ja>>2]|0:v&255)|0;z5(ma)}zb(b,c[H>>2]|0,c[I>>2]|0,10,Ya,1);zb(b,c[H>>2]|0,c[I>>2]|0,7,ea,1);do if((c[H>>2]|0)==1){if(!(RA(c[c[r>>2]>>2]|0,3,-1)|0))break;p=RA(c[c[r>>2]>>2]|0,3,-1)|0;j=0;while(1){if(j>>>0>=p>>>0)break;d=c[I>>2]|0;lJ(b);Kc(b,3,-1)|0;KM(c[c[r>>2]>>2]|0);Gb(b,c[c[r>>2]>>2]|0,3,j,c[I>>2]|0,1)|0;f=c[I>>2]|0;$x(ma,b,1,d,76,1);zb(b,3,f,42,ma,0);z5(ma);$x(ma,b,3,c[I>>2]|0,10,1);f=c[I>>2]|0;$x(C,b,1,(RA(b,1,-1)|0)+-1|0,10,1);HX(C,42040)|0;c[Oa>>2]=c[C>>2];c[Oa+4>>2]=c[C+4>>2];c[Oa+8>>2]=c[C+8>>2];d=0;while(1){if((d|0)==3)break;c[C+(d<<2)>>2]=0;d=d+1|0}d=a[$>>0]|0;v=d<<24>>24<0;Ex(Oa,v?c[ma>>2]|0:ma,v?c[aa>>2]|0:d&255)|0;c[Ga>>2]=c[Oa>>2];c[Ga+4>>2]=c[Oa+4>>2];c[Ga+8>>2]=c[Oa+8>>2];d=0;while(1){if((d|0)==3)break;c[Oa+(d<<2)>>2]=0;d=d+1|0}p2(xa,Ga);zb(b,3,f,10,xa,1);z5(xa);O0(Ga);O0(Oa);z5(C);f=c[I>>2]|0;$x(C,b,1,(RA(b,1,-1)|0)+-1|0,11,1);HX(C,42040)|0;c[Oa>>2]=c[C>>2];c[Oa+4>>2]=c[C+4>>2];c[Oa+8>>2]=c[C+8>>2];d=0;while(1){if((d|0)==3)break;c[C+(d<<2)>>2]=0;d=d+1|0}d=a[$>>0]|0;v=d<<24>>24<0;Ex(Oa,v?c[ma>>2]|0:ma,v?c[aa>>2]|0:d&255)|0;c[Ga>>2]=c[Oa>>2];c[Ga+4>>2]=c[Oa+4>>2];c[Ga+8>>2]=c[Oa+8>>2];d=0;while(1){if((d|0)==3)break;c[Oa+(d<<2)>>2]=0;d=d+1|0}p2(xa,Ga);zb(b,3,f,11,xa,1);z5(xa);O0(Ga);O0(Oa);z5(C);v=c[I>>2]|0;$x(xa,b,1,(RA(b,1,-1)|0)+-1|0,293,1);zb(b,3,v,200,xa,1);z5(xa);v=c[I>>2]|0;TX(Oa);Gk(Oa,RA(b,1,-1)|0,10)|0;ms(Ga,28664,Oa);p2(xa,Ga);Mc(b,3,v,379121,xa,1);z5(xa);O0(Ga);z5(Oa);z5(ma);j=j+1|0}c[H>>2]=1;c[I>>2]=(RA(b,1,-1)|0)+-1}while(0);z5(ea);z5(Ya);i=i+1|0}}else Xa=62;while(0);if((Xa|0)==62){Xa=0;zb(b,c[H>>2]|0,c[I>>2]|0,10,Za,1);zb(b,c[H>>2]|0,c[I>>2]|0,7,Za,1)}d=c[H>>2]|0;v=c[I>>2]|0;zb(b,d,v,Rb(d,91)|0,_a,1);d=c[H>>2]|0;if((d|0)==1){v=a[L>>0]|0;if((v<<24>>24<0?c[M>>2]|0:v&255)|0)zb(b,1,c[I>>2]|0,58,$a,1);$x(Ya,b,1,c[I>>2]|0,171,1);if((pn(Ya)|0)==120){o=+Cq(Ya);Bt(b,1,c[I>>2]|0,175,o/5.0,3,1);Bt(b,1,c[I>>2]|0,179,o*.25,3,1);RB(b,1,c[I>>2]|0,167,380821,-1,1,0)}z5(Ya);d=c[H>>2]|0}do if((d|0)==2){$x(Ya,b,2,c[I>>2]|0,44,1);d=i9(28732)|0;v=a[O>>0]|0;if((d|0)==((v<<24>>24<0?c[Q>>2]|0:v&255)|0)?(VG(Ya,28732,d)|0)==0:0){u=Vj(c[c[r>>2]>>2]|0,2,0,122,1)|0;v=a[u+8+3>>0]|0;v=((v<<24>>24<0?c[u+4>>2]|0:v&255)|0)==0;z5(Ya);if(!v)break;Ed(b,2,c[I>>2]|0,122);break}z5(Ya)}while(0);b:do if((c[H>>2]|0)==2){if(RA(b,1,-1)|0){u=x+90|0;RB(b,2,c[I>>2]|0,233,a[u>>0]|0?379141:379149,-1,1,0);v=c[I>>2]|0;Xy(ea,a[u>>0]|0?28784:28856);pl(Ya,ea);zb(b,2,v,234,Ya,0);z5(Ya);z5(ea)}if((c[H>>2]|0)==2){c:do if((RA(b,1,-1)|0)==1){d=c[w>>2]|0;if(!d)break;f=c[c[r>>2]>>2]|0;if(!(c[f+728>>2]&1))break;v=f+560|0;u=c[v>>2]|0;v=c[v+4>>2]|0;o=+(d>>>0);Bt(b,2,c[I>>2]|0,156,((u|0)==0&(v|0)==0?0.0:(+(u>>>0)+4294967296.0*+(v>>>0))*1.0e3/o)+ +((c[e+52>>2]|0)>>>0)*1.0e3/o,0,1);RB(b,2,c[I>>2]|0,165,388261,-1,1,1);d=0;while(1){if(d>>>0>=(RA(b,1,-1)|0)>>>0)break c;sM(b,1,d,217,0,1);d=d+1|0}}while(0);if((c[H>>2]|0)==2){$x(Ya,b,2,c[I>>2]|0,18,1);d=i9(29652)|0;v=a[R>>0]|0;do if((d|0)==((v<<24>>24<0?c[S>>2]|0:v&255)|0)){if(VG(Ya,29652,d)|0){Xa=89;break}z5(Ya)}else Xa=89;while(0);d:do if((Xa|0)==89){Xa=0;$x(ea,b,2,c[I>>2]|0,18,1);d=i9(40168)|0;v=a[T>>0]|0;do if((d|0)==((v<<24>>24<0?c[U>>2]|0:v&255)|0)){if(VG(ea,40168,d)|0)break;z5(ea);z5(Ya);break d}while(0);$x(ma,b,2,c[I>>2]|0,18,1);d=i9(29668)|0;v=a[V>>0]|0;if((d|0)==((v<<24>>24<0?c[W>>2]|0:v&255)|0)){v=(VG(ma,29668,d)|0)==0;z5(ma);z5(ea);z5(Ya);if(v)break;else break b}else{z5(ma);z5(ea);z5(Ya);break b}}while(0);Ed(b,2,c[I>>2]|0,147)}}}while(0);z5($a);z5(_a)}t=e+80|0;i=c[t>>2]|0;do if(i|0){d=c[H>>2]|0;q=e+96|0;v=e+44|0;if((d|0)==1){f=q;d=c[f>>2]|0;f=c[f+4>>2]|0;if(!((d|0)==0&(f|0)==0)?(ba=c[w>>2]|0,(ba|0)!=0):0)KW(b,1,c[I>>2]|0,76,(+(d>>>0)+4294967296.0*+(f>>>0))*1.0e3*+((c[v>>2]|0)>>>0)/+(ba>>>0),0,1);else lL(b,1,c[I>>2]|0,185,i,10,1);d=c[H>>2]|0}s=e+56|0;u=e+72|0;do if((d|0)==2){$x(_a,b,2,c[I>>2]|0,18,1);d=i9(40168)|0;p=a[ka>>0]|0;if((d|0)==((p<<24>>24<0?c[la>>2]|0:p&255)|0)){p=(VG(_a,40168,d)|0)==0;z5(_a);if((p?(da=c[c[r>>2]>>2]|0,(da|0)!=0):0)?(r=da+896|0,0==(c[r+4>>2]|0)?(c[e+76>>2]|0)==(c[r>>2]|0):0):0){$x(_a,b,2,c[I>>2]|0,23,1);$x($a,b,2,c[I>>2]|0,24,1);d=i9(40212)|0;r=a[ra>>0]|0;do if((d|0)==((r<<24>>24<0?c[sa>>2]|0:r&255)|0)){if(VG(_a,40212,d)|0){Xa=116;break}d=i9(28920)|0;r=a[ta>>0]|0;if((d|0)!=((r<<24>>24<0?c[ua>>2]|0:r&255)|0)){Xa=116;break}if(!(VG($a,28920,d)|0)){d=384;f=0}else Xa=116}else Xa=116;while(0);e:do if((Xa|0)==116){d=i9(40252)|0;f=a[ra>>0]|0;i=c[sa>>2]|0;do if((d|0)==((f<<24>>24<0?i:f&255)|0)){if(!(VG(_a,40252,d)|0)){Xa=121;break}f=a[ra>>0]|0;i=c[sa>>2]|0;Xa=119}else Xa=119;while(0);do if((Xa|0)==119){Xa=0;d=i9(28952)|0;if((d|0)!=((f<<24>>24<0?i:f&255)|0))break;if(!(VG(_a,28952,d)|0))Xa=121}while(0);do if((Xa|0)==121){Xa=0;d=i9(28920)|0;r=a[ta>>0]|0;if((d|0)!=((r<<24>>24<0?c[ua>>2]|0:r&255)|0))break;if(!(VG($a,28920,d)|0)){d=192;f=0;break e}}while(0);d=i9(40252)|0;f=a[ra>>0]|0;i=c[sa>>2]|0;do if((d|0)==((f<<24>>24<0?i:f&255)|0)){if(!(VG(_a,40252,d)|0)){Xa=128;break}f=a[ra>>0]|0;i=c[sa>>2]|0;Xa=126}else Xa=126;while(0);do if((Xa|0)==126){Xa=0;d=i9(28952)|0;if((d|0)!=((f<<24>>24<0?i:f&255)|0))break;if(!(VG(_a,28952,d)|0))Xa=128}while(0);do if((Xa|0)==128){Xa=0;d=i9(29e3)|0;r=a[ta>>0]|0;if((d|0)!=((r<<24>>24<0?c[ua>>2]|0:r&255)|0))break;if(!(VG($a,29e3,d)|0)){d=576;f=0;break e}}while(0);d=1152;f=0}while(0);d=UW(c[t>>2]|0,0,d|0,f|0)|0;i=z;z5($a);z5(_a)}else{d=0;i=0}}else{z5(_a);d=0;i=0}$x(_a,b,2,c[I>>2]|0,18,1);f=i9(28648)|0;r=a[va>>0]|0;if((f|0)==((r<<24>>24<0?c[wa>>2]|0:r&255)|0)){r=(VG(_a,28648,f)|0)==0;z5(_a);if(r?($x(_a,b,2,c[I>>2]|0,147,1),na=rm(_a)|0,oa=z,z5(_a),$x(_a,b,2,c[I>>2]|0,122,1),pa=rm(_a)|0,qa=z,z5(_a),((na|0)!=0|(oa|0)!=0)&((pa|0)!=0|(qa|0)!=0)):0){d=y;d=PZ(c[d>>2]|0,c[d+4>>2]|0,3)|0;d=g5(d|0,z|0,na|0,oa|0)|0;d=g5(d|0,z|0,pa|0,qa|0)|0;i=z}}else z5(_a);$x(_a,b,2,c[I>>2]|0,18,1);f=i9(29032)|0;r=a[ya>>0]|0;if((f|0)==((r<<24>>24<0?c[za>>2]|0:r&255)|0)){r=(VG(_a,29032,f)|0)==0;z5(_a);if(r){$x(_a,b,2,c[I>>2]|0,147,1);f=rm(_a)|0;j=z;z5(_a);$x(_a,b,2,c[I>>2]|0,122,1);k=rm(_a)|0;p=z;z5(_a);if(((f|0)!=0|(j|0)!=0)&((k|0)!=0|(p|0)!=0)){d=y;d=PZ(c[d>>2]|0,c[d+4>>2]|0,3)|0;d=g5(d|0,z|0,f|0,j|0)|0;d=g5(d|0,z|0,k|0,p|0)|0;o=(+(d>>>0)+4294967296.0*+(z>>>0))*.98;d=~~o>>>0;f=+B(o)>=1.0?(o>0.0?~~+P(+A(o/4294967296.0),4294967295.0)>>>0:~~+N((o-+(~~o>>>0))/4294967296.0)>>>0):0}else f=i;$x(_a,b,2,c[I>>2]|0,135,1);m=+Cq(_a);z5(_a);if(m>0.0){r=UW(d|0,f|0,1e3,0)|0;n=(+(r>>>0)+4294967296.0*+(z>>>0))/m;o=+((c[Aa>>2]|0)>>>0)/+h[Ba>>3]*1.0e3;r=n<o*1.1&n>o*.1;d=r?0:d;f=r?0:f}}else f=i}else{z5(_a);f=i}$x(_a,b,2,c[I>>2]|0,135,1);m=+Cq(_a);z5(_a);do if(!(((d|0)!=0|(f|0)!=0)&m>0.0)){f=q;d=c[f>>2]|0;f=c[f+4>>2]|0;r=c[w>>2]|0;i=(r|0)==0;m=+(r>>>0);if(!((d|0)==0&(f|0)==0)){if(i)break;KW(b,2,c[I>>2]|0,68,(+(d>>>0)+4294967296.0*+(f>>>0))*1.0e3*+((c[v>>2]|0)>>>0)/m,0,1);break}if(!i){d=c[v>>2]|0;if((d|0)==1)break;KW(b,2,c[I>>2]|0,68,+(d>>>0)*+((c[s>>2]|0)>>>0)*1.0e3/m,0,1)}}else{q=c[I>>2]|0;r=UW(d|0,f|0,1e3,0)|0;Bt(b,2,q,68,(+(r>>>0)+4294967296.0*+(z>>>0))/m,0,1)}while(0);c[_a>>2]=808452096;if(!(c[(jF(F,_a)|0)+56>>2]|0))break;if(c[t>>2]|0){r=c[I>>2]|0;c[_a>>2]=808452096;o=+((c[(jF(F,_a)|0)+56>>2]|0)>>>0);sN(b,2,r,379155,o/+((c[t>>2]|0)>>>0),2,0);$x(_a,b,1,0,171,1);r=+Cq(_a)!=0.0;z5(_a);if(r){r=c[I>>2]|0;c[_a>>2]=808452096;o=+((c[(jF(F,_a)|0)+56>>2]|0)>>>0);o=o/+((c[t>>2]|0)>>>0)*1.0e3;$x($a,b,1,0,171,1);sN(b,2,r,379178,o/+Cq($a),0,0);z5($a);TX(_a);gq($a,b,2,c[I>>2]|0,379178);r=a[Ca>>0]|0;q=r<<24>>24<0;Ex(_a,q?c[$a>>2]|0:$a,q?c[Da>>2]|0:r&255)|0;z5($a);HX(_a,42252)|0;Xy(Ya,29056);pl($a,Ya);r=a[Ea>>0]|0;q=r<<24>>24<0;Ex(_a,q?c[$a>>2]|0:$a,q?c[Fa>>2]|0:r&255)|0;z5($a);z5(Ya);gq($a,b,2,c[I>>2]|0,379155);r=a[Ha>>0]|0;r=((r<<24>>24<0?c[Ia>>2]|0:r&255)|0)==0;z5($a);if(!r){HX(_a,39932)|0;gq(Ya,b,2,c[I>>2]|0,379155);Xy(ea,29068);ne($a,Ya,ea,0);r=a[Ja>>0]|0;q=r<<24>>24<0;Ex(_a,q?c[$a>>2]|0:$a,q?c[Ka>>2]|0:r&255)|0;z5($a);z5(ea);z5(Ya);HX(_a,39944)|0}Mc(b,2,c[I>>2]|0,379198,_a,0);z5(_a)}d=c[La>>2]|0;j=0;k=0;f:while(1){if((d|0)==(Ma|0))break;i=d+24|0;f=c[i>>2]|0;i=c[i+4>>2]|0;if((f|0)==808452096&(i|0)==0)break;if((i|0)==0?(f|0)==(c[x>>2]|0):0){r=d+32|0;j=z0(c[r>>2]|0,c[r+4>>2]|0,j|0,k|0)|0;k=z}f=c[d+4>>2]|0;if(!f)while(1){f=c[d+8>>2]|0;if((c[f>>2]|0)==(d|0)){d=f;continue f}else d=f}else d=f;while(1){f=c[d>>2]|0;if(!f)break;else d=f}}if((j|0)==0&(k|0)==0)break;d=c[u>>2]|0;if(!d)break;x=c[I>>2]|0;f=UW(j|0,k|0,1e3,0)|0;f=g5(f|0,z|0,d|0,0)|0;aL(b,2,x,379225,f,z,0);f=c[I>>2]|0;gq(ea,b,2,f,379225);HX(ea,42252)|0;c[Ya>>2]=c[ea>>2];c[Ya+4>>2]=c[ea+4>>2];c[Ya+8>>2]=c[ea+8>>2];d=0;while(1){if((d|0)==3)break;c[ea+(d<<2)>>2]=0;d=d+1|0}Xy(xa,29056);pl(ma,xa);d=a[Na>>0]|0;x=d<<24>>24<0;Ex(Ya,x?c[ma>>2]|0:ma,x?c[Pa>>2]|0:d&255)|0;c[$a>>2]=c[Ya>>2];c[$a+4>>2]=c[Ya+4>>2];c[$a+8>>2]=c[Ya+8>>2];d=0;while(1){if((d|0)==3)break;c[Ya+(d<<2)>>2]=0;d=d+1|0}p2(_a,$a);Mc(b,2,f,379244,_a,0);z5(_a);O0($a);z5(ma);z5(xa);O0(Ya);z5(ea)}}while(0);f=c[t>>2]|0;if(f|0?(c[s>>2]|0)!=(f|0):0){d=c[H>>2]|0;if((d|0)==1){d=c[w>>2]|0;if(!d)break;sN(b,1,c[I>>2]|0,379270,+(f>>>0)*1.0e3*+((c[v>>2]|0)>>>0)/+(d>>>0),0,0);d=c[H>>2]|0}if((d|0)==2?c[w>>2]|0:0){d=y;m=(+((c[d>>2]|0)>>>0)+4294967296.0*+((c[d+4>>2]|0)>>>0))*1.0e3/+((c[u>>2]|0)>>>0);$x(_a,b,2,c[I>>2]|0,68,1);n=+Eq(_a);z5(_a);o=m-n;d=c[v>>2]|0;if((d|0)!=1?(y=cT(n/m)|0,(y|0)==(d|0)&(z|0)==0):0){KW(b,2,c[I>>2]|0,68,m,0,1);break}if(o<-2.0|o>2.0)sN(b,2,c[I>>2]|0,379270,m,0,0)}}}while(0);d=c[e+4>>2]|0;if(!d)while(1){d=c[e+8>>2]|0;if((c[d>>2]|0)==(e|0))break;else e=d}else while(1){e=c[d>>2]|0;if(!e)break;else d=e}z5(Za);e=d}g:do if((RA(b,1,-1)|0?(Qa=b+996|0,c[Qa>>2]|0):0)?($x(Za,b,1,0,76,1),Pa=a[Za+8+3>>0]|0,Pa=((Pa<<24>>24<0?c[Za+4>>2]|0:Pa&255)|0)==0,z5(Za),Pa):0){d=0;while(1){if(d>>>0>=(RA(b,1,-1)|0)>>>0)break g;lL(b,1,d,185,c[Qa>>2]|0,10,1);d=d+1|0}}while(0);if(a[b+1039>>0]|0)RB(b,0,0,68,379286,-1,1,0);e=b+808|0;d=c[e>>2]|0;e=c[e+4>>2]|0;if(((!((d|0)==0&(e|0)==0)?(Sa=b+816|0,Ra=c[Sa>>2]|0,Sa=c[Sa+4>>2]|0,!((Ra|0)==0&(Sa|0)==0)):0)?(Ua=b+824|0,Ta=c[Ua>>2]|0,Ua=c[Ua+4>>2]|0,!((Ta|0)==0&(Ua|0)==0)):0)?(Wa=b+832|0,Va=c[Wa>>2]|0,Wa=c[Wa+4>>2]|0,!((Va|0)==0&(Wa|0)==0)):0)RB(b,0,0,78,(e>>>0<Ua>>>0|(e|0)==(Ua|0)&d>>>0<Ta>>>0)&(Sa>>>0>Ua>>>0|(Sa|0)==(Ua|0)&Ra>>>0>Ta>>>0)|(Ua>>>0<e>>>0|(Ua|0)==(e|0)&Ta>>>0<d>>>0)&(Wa>>>0>e>>>0|(Wa|0)==(e|0)&Va>>>0>d>>>0)?382808:382840,-1,1,0);j=b+876|0;k=b+880|0;i=1;d=0;while(1){if((i|0)==7)break;else f=0;while(1){if(f>>>0>=(RA(b,i,-1)|0)>>>0)break;e=c[j>>2]|0;if(d>>>0<(((c[k>>2]|0)-e|0)/12|0)>>>0){Mc(b,i,f,379290,e+(d*12|0)|0,0);d=d+1|0}f=f+1|0}i=i+1|0}h:do if((RA(b,1,-1)|0)==1){Jn(b);$x(Za,b,1,0,22,1);Wa=a[Za+8+3>>0]|0;Wa=((Wa<<24>>24<0?c[Za+4>>2]|0:Wa&255)|0)==0;z5(Za);if(!Wa){$x(Za,b,1,0,22,1);zb(b,0,0,63,Za,0);z5(Za);$x($a,b,1,0,22,1);DW($a,0,29124)|0;c[_a>>2]=c[$a>>2];c[_a+4>>2]=c[$a+4>>2];c[_a+8>>2]=c[$a+8>>2];d=0;while(1){if((d|0)==3)break;c[$a+(d<<2)>>2]=0;d=d+1|0}p2(Za,_a);zb(b,0,0,62,Za,0);z5(Za);O0(_a);z5($a);break}$x(Za,b,1,0,18,1);d=i9(29144)|0;Wa=a[Za+8+3>>0]|0;if((d|0)==((Wa<<24>>24<0?c[Za+4>>2]|0:Wa&255)|0)){Wa=(VG(Za,29144,d)|0)==0;z5(Za);if(Wa){RB(b,0,0,63,387955,-1,1,0);RB(b,0,0,62,379294,-1,1,0);break}}else z5(Za);$x(Za,b,1,0,18,1);d=i9(29964)|0;Wa=a[Za+8+3>>0]|0;do if((d|0)==((Wa<<24>>24<0?c[Za+4>>2]|0:Wa&255)|0)?(VG(Za,29964,d)|0)==0:0){$x(_a,b,1,0,47,1);d=i9(29156)|0;Wa=a[_a+8+3>>0]|0;if((d|0)!=((Wa<<24>>24<0?c[_a+4>>2]|0:Wa&255)|0)){z5(_a);z5(Za);break}if(VG(_a,29156,d)|0){z5(_a);z5(Za);break}$x($a,b,1,0,190,1);d=i9(29172)|0;Wa=a[$a+8+3>>0]|0;if((d|0)!=((Wa<<24>>24<0?c[$a+4>>2]|0:Wa&255)|0)){z5($a);z5(_a);z5(Za);break}if(VG($a,29172,d)|0){z5($a);z5(_a);z5(Za);break}$x(Ya,b,1,0,120,1);d=i9(29196)|0;Wa=a[Ya+8+3>>0]|0;if((d|0)!=((Wa<<24>>24<0?c[Ya+4>>2]|0:Wa&255)|0)){z5(Ya);z5($a);z5(_a);z5(Za);break}Wa=(VG(Ya,29196,d)|0)==0;z5(Ya);z5($a);z5(_a);z5(Za);if(Wa){RB(b,0,0,63,379301,-1,1,0);RB(b,1,0,22,379301,-1,1,0);break h}}else Xa=231;while(0);if((Xa|0)==231)z5(Za);$x(Za,b,1,0,18,1);d=i9(29964)|0;Wa=a[Za+8+3>>0]|0;do if((d|0)==((Wa<<24>>24<0?c[Za+4>>2]|0:Wa&255)|0)?(VG(Za,29964,d)|0)==0:0){$x(_a,b,1,0,47,1);d=i9(29156)|0;Wa=a[_a+8+3>>0]|0;if((d|0)!=((Wa<<24>>24<0?c[_a+4>>2]|0:Wa&255)|0)){z5(_a);z5(Za);break}if(VG(_a,29156,d)|0){z5(_a);z5(Za);break}$x($a,b,1,0,190,1);d=i9(29172)|0;Wa=a[$a+8+3>>0]|0;if((d|0)!=((Wa<<24>>24<0?c[$a+4>>2]|0:Wa&255)|0)){z5($a);z5(_a);z5(Za);break}if(VG($a,29172,d)|0){z5($a);z5(_a);z5(Za);break}$x(Ya,b,1,0,120,1);d=i9(29232)|0;Wa=a[Ya+8+3>>0]|0;if((d|0)!=((Wa<<24>>24<0?c[Ya+4>>2]|0:Wa&255)|0)){z5(Ya);z5($a);z5(_a);z5(Za);break}Wa=(VG(Ya,29232,d)|0)==0;z5(Ya);z5($a);z5(_a);z5(Za);if(Wa){RB(b,0,0,63,379313,-1,1,0);RB(b,1,0,22,379313,-1,1,0);break h}}else Xa=246;while(0);if((Xa|0)==246)z5(Za);$x(Za,b,1,0,18,1);d=i9(29964)|0;Xa=a[Za+8+3>>0]|0;if((d|0)==((Xa<<24>>24<0?c[Za+4>>2]|0:Xa&255)|0)?(VG(Za,29964,d)|0)==0:0){$x(_a,b,1,0,47,1);d=i9(29156)|0;Xa=a[_a+8+3>>0]|0;if((d|0)!=((Xa<<24>>24<0?c[_a+4>>2]|0:Xa&255)|0)){z5(_a);z5(Za);break}if(VG(_a,29156,d)|0){z5(_a);z5(Za);break}$x($a,b,1,0,190,1);d=i9(29172)|0;Xa=a[$a+8+3>>0]|0;if((d|0)!=((Xa<<24>>24<0?c[$a+4>>2]|0:Xa&255)|0)){z5($a);z5(_a);z5(Za);break}if(VG($a,29172,d)|0){z5($a);z5(_a);z5(Za);break}$x(Ya,b,1,0,120,1);d=i9(29268)|0;Xa=a[Ya+8+3>>0]|0;if((d|0)!=((Xa<<24>>24<0?c[Ya+4>>2]|0:Xa&255)|0)){z5(Ya);z5($a);z5(_a);z5(Za);break}Xa=(VG(Ya,29268,d)|0)==0;z5(Ya);z5($a);z5(_a);z5(Za);if(!Xa)break;RB(b,0,0,63,379325,-1,1,0);RB(b,1,0,22,379325,-1,1,0);break}z5(Za)}while(0);l=ab;return}function Eb(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;K=l;l=l+176|0;x=K+144|0;j=K+164|0;f=K+163|0;g=K+162|0;m=K+161|0;p=K+160|0;q=K+159|0;r=K+158|0;o=K+157|0;t=K+156|0;y=K+132|0;A=K+120|0;B=K+108|0;C=K+96|0;D=K+84|0;E=K+72|0;F=K+60|0;G=K+48|0;H=K+36|0;I=K+24|0;J=K+12|0;s=K;GC(b);TX(x);u=b+648|0;d4(c[u>>2]|0,4);xR(b,2,o);v=(a[o>>0]|0)+1<<24>>24;a[o>>0]=v;xR(b,4,t);xR(b,4,j);xR(b,4,f);xR(b,4,g);xR(b,2,m);xR(b,3,p);xR(b,4,q);if(K6(c[u>>2]|0)|0){GC(b);A6(c[u>>2]|0);d4(c[u>>2]|0,4);J3(b)}else A6(c[u>>2]|0);if(K6(c[u>>2]|0)|0){GC(b);A6(c[u>>2]|0);d4(c[u>>2]|0,4);J3(b)}else A6(c[u>>2]|0);if(K6(c[u>>2]|0)|0){GC(b);A6(c[u>>2]|0);d4(c[u>>2]|0,2);A6(c[u>>2]|0);J3(b)}else A6(c[u>>2]|0);e=a[f>>0]|0;i=a[g>>0]|0;h=i+-1<<24>>24;if(e<<24>>24==0&(h&255)<2){a[f>>0]=1;a[g>>0]=h;e=1}else h=i;o=a[j>>0]|0;n=0;g=0;j=0;i=0;while(1){if((j&255)>=(o&255)){k=0;j=0;break}GC(b);AT(b,y);d4(c[u>>2]|0,4);if(!(a[y>>0]|0)){f=n+1<<24>>24;g=g+1<<24>>24}else{i=i|j<<24>>24==0;f=(n&255)+2&255;g=(g&255)+2&255}J3(b);n=f;j=j+1<<24>>24}while(1){if((j&255)>=(e&255)){j=0;f=0;break}GC(b);AT(b,y);d4(c[u>>2]|0,4);if(!(a[y>>0]|0)){f=k+1<<24>>24;g=g+1<<24>>24}else{f=(k&255)+2&255;g=(g&255)+2&255}J3(b);k=f;j=j+1<<24>>24}while(1){if((f&255)>=(h&255))break;GC(b);AT(b,y);d4(c[u>>2]|0,4);if(!(a[y>>0]|0)){e=j+1<<24>>24;g=g+1<<24>>24}else{e=(j&255)+2&255;g=(g&255)+2&255}J3(b);j=e;f=f+1<<24>>24}h=a[m>>0]|0;e=0;while(1){if((e&255)>=(h&255))break;GC(b);d4(c[u>>2]|0,4);J3(b);e=e+1<<24>>24}m=g+h<<24>>24;f=a[p>>0]|0;e=0;while(1){if((e&255)>=(f&255))break;GC(b);d4(c[u>>2]|0,4);J3(b);e=e+1<<24>>24}f=a[q>>0]|0;e=0;while(1){if((e&255)>=(f&255))break;GC(b);A6(c[u>>2]|0);d4(c[u>>2]|0,4);J3(b);e=e+1<<24>>24}wK(b);bB(b,r);e=a[r>>0]|0;if(e<<24>>24)jZ(b,e&255,0,x);Bx(b);J3(b);TX(y);TX(A);TX(B);switch(n<<24>>24){case 0:break;case 1:{HX(y,10944)|0;HX(B,10980)|0;break}case 2:{HX(y,12320)|0;HX(B,10992)|0;break}case 3:{HX(y,11012)|0;HX(B,o<<24>>24==2?(i?11064:11092):11120)|0;break}default:{HX(y,11148)|0;uU(C,n,10);r=a[C+8+3>>0]|0;q=r<<24>>24<0;Ex(y,q?c[C>>2]|0:C,q?c[C+4>>2]|0:r&255)|0;z5(C);HX(B,11180)|0}}switch(k<<24>>24){case 0:break;case 1:{HX(y,11192)|0;HX(B,11232)|0;break}case 2:{HX(y,11248)|0;HX(B,11296)|0;break}case 3:{HX(y,11324)|0;HX(B,11120)|0;break}default:{HX(y,11380)|0;uU(C,k,10);r=a[C+8+3>>0]|0;q=r<<24>>24<0;Ex(y,q?c[C>>2]|0:C,q?c[C+4>>2]|0:r&255)|0;z5(C);HX(B,11180)|0}}switch(j<<24>>24){case 0:break;case 1:{HX(y,11416)|0;HX(B,11232)|0;break}case 2:{HX(y,11456)|0;HX(B,11504)|0;break}case 3:{HX(y,11540)|0;HX(B,11596)|0;break}default:{HX(y,11644)|0;uU(C,j,10);r=a[C+8+3>>0]|0;q=r<<24>>24<0;Ex(y,q?c[C>>2]|0:C,q?c[C+4>>2]|0:r&255)|0;z5(C);HX(B,11180)|0}}switch(h<<24>>24){case 0:break;case 1:{HX(y,14344)|0;HX(B,11680)|0;break}default:{HX(y,11700)|0;uU(C,h,10);r=a[C+8+3>>0]|0;q=r<<24>>24<0;Ex(y,q?c[C>>2]|0:C,q?c[C+4>>2]|0:r&255)|0;z5(C);HX(B,11180)|0}}uU(I,n,10);Gx(I,47);c[H>>2]=c[I>>2];c[H+4>>2]=c[I+4>>2];c[H+8>>2]=c[I+8>>2];e=0;while(1){if((e|0)==3)break;c[I+(e<<2)>>2]=0;e=e+1|0}uU(J,k,10);e=a[J+8+3>>0]|0;r=e<<24>>24<0;Ex(H,r?c[J>>2]|0:J,r?c[J+4>>2]|0:e&255)|0;c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];e=0;while(1){if((e|0)==3)break;c[H+(e<<2)>>2]=0;e=e+1|0}Gx(G,47);c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];e=0;while(1){if((e|0)==3)break;c[G+(e<<2)>>2]=0;e=e+1|0}uU(s,j,10);e=a[s+8+3>>0]|0;r=e<<24>>24<0;Ex(F,r?c[s>>2]|0:s,r?c[s+4>>2]|0:e&255)|0;c[E>>2]=c[F>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];e=0;while(1){if((e|0)==3)break;c[F+(e<<2)>>2]=0;e=e+1|0}HX(E,h<<24>>24?16388:409096)|0;c[D>>2]=c[E>>2];c[D+4>>2]=c[E+4>>2];c[D+8>>2]=c[E+8>>2];e=0;while(1){if((e|0)==3)break;c[E+(e<<2)>>2]=0;e=e+1|0}p2(C,D);vF(A,C)|0;z5(C);O0(D);O0(E);z5(s);O0(F);O0(G);z5(J);O0(H);z5(I);e=a[B+8+3>>0]|0;e=e<<24>>24<0?c[B+4>>2]|0:e&255;if(e|0)FB(B,e+-1|0,0);do if(qO(b)|0){e=a[t>>0]|0;if((m&255)>24){t4(b);J=c[u>>2]|0;G4(J,Z9(c[J+4>>2]|0)|0);break}n=b+2462|0;if((a[n>>0]|0)==-1)a[n>>0]=v;g=b+2468|0;if((a[g>>0]|0)==-1)a[g>>0]=e;c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;f=j9(379557)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[C+11>>0]=f;e=C}else{v=f+16&-16;e=ZW(v)|0;c[C>>2]=e;c[C+8>>2]=v|-2147483648;c[C+4>>2]=f}i1(e,379557,f)|0;J7(e+f|0,0);k1(VC(b+22124|0,C)|0,x)|0;a1(C);k=b+22136|0;c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;f=j9(390999)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[C+11>>0]=f;e=C}else{v=f+16&-16;e=ZW(v)|0;c[C>>2]=e;c[C+8>>2]=v|-2147483648;c[C+4>>2]=f}i1(e,390999,f)|0;J7(e+f|0,0);f=VC(k,C)|0;Ck(f,a[n>>0]|0,10)|0;a1(C);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;f=j9(384476)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[C+11>>0]=f;e=C}else{v=f+16&-16;e=ZW(v)|0;c[C>>2]=e;c[C+8>>2]=v|-2147483648;c[C+4>>2]=f}i1(e,384476,f)|0;J7(e+f|0,0);cC(VC(k,C)|0,391425)|0;a1(C);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[C+11>>0]=f;e=C}else{v=f+16&-16;e=ZW(v)|0;c[C>>2]=e;c[C+8>>2]=v|-2147483648;c[C+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);f=VC(k,C)|0;cC(f,YN(a[n>>0]|0)|0)|0;a1(C);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;f=j9(385582)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[C+11>>0]=f;e=C}else{v=f+16&-16;e=ZW(v)|0;c[C>>2]=e;c[C+8>>2]=v|-2147483648;c[C+4>>2]=f}i1(e,385582,f)|0;J7(e+f|0,0);f=VC(k,C)|0;cC(f,yn(a[n>>0]|0)|0)|0;a1(C);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[C+11>>0]=f;e=C}else{v=f+16&-16;e=ZW(v)|0;c[C>>2]=e;c[C+8>>2]=v|-2147483648;c[C+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);f=VC(k,C)|0;Gk(f,c[11828+(d[g>>0]<<2)>>2]|0,10)|0;a1(C);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;f=j9(384542)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[C+11>>0]=f;e=C}else{v=f+16&-16;e=ZW(v)|0;c[C>>2]=e;c[C+8>>2]=v|-2147483648;c[C+4>>2]=f}i1(e,384542,f)|0;J7(e+f|0,0);Ck(VC(k,C)|0,m,10)|0;a1(C);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;f=j9(370675)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[C+11>>0]=f;e=C}else{v=f+16&-16;e=ZW(v)|0;c[C>>2]=e;c[C+8>>2]=v|-2147483648;c[C+4>>2]=f}i1(e,370675,f)|0;J7(e+f|0,0);k1(VC(k,C)|0,y)|0;a1(C);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;f=j9(370692)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[C+11>>0]=f;e=C}else{v=f+16&-16;e=ZW(v)|0;c[C>>2]=e;c[C+8>>2]=v|-2147483648;c[C+4>>2]=f}i1(e,370692,f)|0;J7(e+f|0,0);k1(VC(k,C)|0,A)|0;a1(C);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;f=j9(370717)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[C+11>>0]=f;e=C}else{v=f+16&-16;e=ZW(v)|0;c[C>>2]=e;c[C+8>>2]=v|-2147483648;c[C+4>>2]=f}i1(e,370717,f)|0;J7(e+f|0,0);k1(VC(k,C)|0,B)|0;a1(C);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;f=j9(370620)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[C+11>>0]=f;e=C}else{v=f+16&-16;e=ZW(v)|0;c[C>>2]=e;c[C+8>>2]=v|-2147483648;c[C+4>>2]=f}i1(e,370620,f)|0;J7(e+f|0,0);h=VC(k,C)|0;v=a[h+8+3>>0]|0;v=((v<<24>>24<0?c[h+4>>2]|0:v&255)|0)==0;a1(C);h=b+2472|0;i=b+112|0;j=b+2469|0;if(!v){Xy(C,12040);c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[D+11>>0]=f;e=D}else{v=f+16&-16;e=ZW(v)|0;c[D>>2]=e;c[D+8>>2]=v|-2147483648;c[D+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);vF(VC(k,D)|0,C)|0;a1(D);z5(C);c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[D+11>>0]=f;e=D}else{v=f+16&-16;e=ZW(v)|0;c[D>>2]=e;c[D+8>>2]=v|-2147483648;c[D+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);p2(C,VC(k,D)|0);a1(D);c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[D+11>>0]=f;e=D}else{v=f+16&-16;e=ZW(v)|0;c[D>>2]=e;c[D+8>>2]=v|-2147483648;c[D+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);e=VC(k,D)|0;if((a[j>>0]|0)==-1){f=i;f=PZ(c[f>>2]|0,c[f+4>>2]|0,1)|0;g=z}else{f=c[h>>2]|0;g=0}zo(e,f,g)|0;a1(D);if(tT()|0){c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[D+11>>0]=f;e=D}else{v=f+16&-16;e=ZW(v)|0;c[D>>2]=e;c[D+8>>2]=v|-2147483648;c[D+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);HX(VC(k,D)|0,12068)|0;a1(D);ms(D,41840,C);c[E>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[E+11>>0]=f;e=E}else{v=f+16&-16;e=ZW(v)|0;c[E>>2]=e;c[E+8>>2]=v|-2147483648;c[E+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);t=VC(k,E)|0;v=a[D+8+3>>0]|0;u=v<<24>>24<0;Ex(t,u?c[D>>2]|0:D,u?c[D+4>>2]|0:v&255)|0;a1(E);O0(D)}Xy(D,12092);c[E>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[E+11>>0]=f;e=E}else{v=f+16&-16;e=ZW(v)|0;c[E>>2]=e;c[E+8>>2]=v|-2147483648;c[E+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);vF(VC(k,E)|0,D)|0;a1(E);z5(D);Xy(D,12168);c[E>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;f=j9(370620)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[E+11>>0]=f;e=E}else{v=f+16&-16;e=ZW(v)|0;c[E>>2]=e;c[E+8>>2]=v|-2147483648;c[E+4>>2]=f}i1(e,370620,f)|0;J7(e+f|0,0);vF(VC(k,E)|0,D)|0;a1(E);z5(D);TX(F);cC(F,yn(a[n>>0]|0)|0)|0;Bs(E,F,12208);p2(D,E);c[G>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;f=j9(385582)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[G+11>>0]=f;e=G}else{v=f+16&-16;e=ZW(v)|0;c[G>>2]=e;c[G+8>>2]=v|-2147483648;c[G+4>>2]=f}i1(e,385582,f)|0;J7(e+f|0,0);vF(VC(k,G)|0,D)|0;a1(G);z5(D);O0(E);z5(F);z5(C)}c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;f=j9(370640)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[C+11>>0]=f;e=C}else{v=f+16&-16;e=ZW(v)|0;c[C>>2]=e;c[C+8>>2]=v|-2147483648;c[C+4>>2]=f}i1(e,370640,f)|0;J7(e+f|0,0);u=VC(k,C)|0;v=a[u+8+3>>0]|0;v=((v<<24>>24<0?c[u+4>>2]|0:v&255)|0)==0;a1(C);if(v)break;Xy(C,12284);c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[D+11>>0]=f;e=D}else{v=f+16&-16;e=ZW(v)|0;c[D>>2]=e;c[D+8>>2]=v|-2147483648;c[D+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);vF(VC(k,D)|0,C)|0;a1(D);z5(C);c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;f=j9(384542)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[D+11>>0]=f;e=D}else{v=f+16&-16;e=ZW(v)|0;c[D>>2]=e;c[D+8>>2]=v|-2147483648;c[D+4>>2]=f}i1(e,384542,f)|0;J7(e+f|0,0);p2(C,VC(k,D)|0);a1(D);c[E>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;f=j9(370675)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[E+11>>0]=f;e=E}else{v=f+16&-16;e=ZW(v)|0;c[E>>2]=e;c[E+8>>2]=v|-2147483648;c[E+4>>2]=f}i1(e,370675,f)|0;J7(e+f|0,0);p2(D,VC(k,E)|0);a1(E);c[F>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[F+11>>0]=f;e=F}else{v=f+16&-16;e=ZW(v)|0;c[F>>2]=e;c[F+8>>2]=v|-2147483648;c[F+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);p2(E,VC(k,F)|0);a1(F);Xy(F,25220);c[G>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;f=j9(384542)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[G+11>>0]=f;e=G}else{v=f+16&-16;e=ZW(v)|0;c[G>>2]=e;c[G+8>>2]=v|-2147483648;c[G+4>>2]=f}i1(e,384542,f)|0;J7(e+f|0,0);vF(VC(k,G)|0,F)|0;a1(G);z5(F);Xy(F,12320);c[G>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;f=j9(370675)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[G+11>>0]=f;e=G}else{v=f+16&-16;e=ZW(v)|0;c[G>>2]=e;c[G+8>>2]=v|-2147483648;c[G+4>>2]=f}i1(e,370675,f)|0;J7(e+f|0,0);vF(VC(k,G)|0,F)|0;a1(G);z5(F);if(tT()|0){c[F>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[F+11>>0]=f;e=F}else{v=f+16&-16;e=ZW(v)|0;c[F>>2]=e;c[F+8>>2]=v|-2147483648;c[F+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);HX(VC(k,F)|0,12364)|0;a1(F);ms(H,41840,C);HX(H,41840)|0;c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];e=0;while(1){if((e|0)==3)break;c[H+(e<<2)>>2]=0;e=e+1|0}e=a[C+8+3>>0]|0;v=e<<24>>24<0;Ex(G,v?c[C>>2]|0:C,v?c[C+4>>2]|0:e&255)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];e=0;while(1){if((e|0)==3)break;c[G+(e<<2)>>2]=0;e=e+1|0}c[I>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;f=j9(384542)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[I+11>>0]=f;e=I}else{v=f+16&-16;e=ZW(v)|0;c[I>>2]=e;c[I+8>>2]=v|-2147483648;c[I+4>>2]=f}i1(e,384542,f)|0;J7(e+f|0,0);u=VC(k,I)|0;e=a[F+8+3>>0]|0;v=e<<24>>24<0;Ex(u,v?c[F>>2]|0:F,v?c[F+4>>2]|0:e&255)|0;a1(I);O0(F);O0(G);O0(H);ms(H,41840,D);HX(H,41840)|0;c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];e=0;while(1){if((e|0)==3)break;c[H+(e<<2)>>2]=0;e=e+1|0}e=a[D+8+3>>0]|0;v=e<<24>>24<0;Ex(G,v?c[D>>2]|0:D,v?c[D+4>>2]|0:e&255)|0;c[F>>2]=c[G>>2];c[F+4>>2]=c[G+4>>2];c[F+8>>2]=c[G+8>>2];e=0;while(1){if((e|0)==3)break;c[G+(e<<2)>>2]=0;e=e+1|0}c[I>>2]=0;c[I+4>>2]=0;c[I+8>>2]=0;f=j9(370675)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[I+11>>0]=f;e=I}else{v=f+16&-16;e=ZW(v)|0;c[I>>2]=e;c[I+8>>2]=v|-2147483648;c[I+4>>2]=f}i1(e,370675,f)|0;J7(e+f|0,0);t=VC(k,I)|0;v=a[F+8+3>>0]|0;u=v<<24>>24<0;Ex(t,u?c[F>>2]|0:F,u?c[F+4>>2]|0:v&255)|0;a1(I);O0(F);O0(G);O0(H);TX(I);if((a[j>>0]|0)==-1){e=i;e=PZ(c[e>>2]|0,c[e+4>>2]|0,1)|0;f=z}else{e=c[h>>2]|0;f=0}zo(I,e,f)|0;Bs(H,I,41840);e=a[E+8+3>>0]|0;v=e<<24>>24<0;Ex(H,v?c[E>>2]|0:E,v?c[E+4>>2]|0:e&255)|0;c[G>>2]=c[H>>2];c[G+4>>2]=c[H+4>>2];c[G+8>>2]=c[H+8>>2];e=0;while(1){if((e|0)==3)break;c[H+(e<<2)>>2]=0;e=e+1|0}p2(F,G);c[J>>2]=0;c[J+4>>2]=0;c[J+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[J+11>>0]=f;e=J}else{v=f+16&-16;e=ZW(v)|0;c[J>>2]=e;c[J+8>>2]=v|-2147483648;c[J+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);vF(VC(k,J)|0,F)|0;a1(J);z5(F);O0(G);O0(H);z5(I)}c[F>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[F+11>>0]=f;e=F}else{v=f+16&-16;e=ZW(v)|0;c[F>>2]=e;c[F+8>>2]=v|-2147483648;c[F+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);e=VC(k,F)|0;f=i9(12092)|0;v=a[e+8+3>>0]|0;if((f|0)==((v<<24>>24<0?c[e+4>>2]|0:v&255)|0)){v=(VG(e,12092,f)|0)==0;a1(F);if(!v)w=267}else{a1(F);w=267}if((w|0)==267){c[F>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[F+11>>0]=f;e=F}else{w=f+16&-16;e=ZW(w)|0;c[F>>2]=e;c[F+8>>2]=w|-2147483648;c[F+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);v=VC(k,F)|0;w=a[v+8+3>>0]|0;w=((w<<24>>24<0?c[v+4>>2]|0:w&255)|0)==0;a1(F);if(!w){c[F>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[F+11>>0]=f;e=F}else{w=f+16&-16;e=ZW(w)|0;c[F>>2]=e;c[F+8>>2]=w|-2147483648;c[F+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);DW(VC(k,F)|0,0,41840)|0;a1(F)}c[F>>2]=0;c[F+4>>2]=0;c[F+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[F+11>>0]=f;e=F}else{w=f+16&-16;e=ZW(w)|0;c[F>>2]=e;c[F+8>>2]=w|-2147483648;c[F+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);DW(VC(k,F)|0,0,12092)|0;a1(F)}Xy(F,12168);c[G>>2]=0;c[G+4>>2]=0;c[G+8>>2]=0;f=j9(370640)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[G+11>>0]=f;e=G}else{w=f+16&-16;e=ZW(w)|0;c[G>>2]=e;c[G+8>>2]=w|-2147483648;c[G+4>>2]=f}i1(e,370640,f)|0;J7(e+f|0,0);vF(VC(k,G)|0,F)|0;a1(G);z5(F);$x(F,b,2,c[b+20>>2]|0,52,1);TX(I);cC(I,yn(a[n>>0]|0)|0)|0;Bs(H,I,12424);p2(G,H);c[J>>2]=0;c[J+4>>2]=0;c[J+8>>2]=0;f=j9(385582)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[J+11>>0]=f;e=J}else{b=f+16&-16;e=ZW(b)|0;c[J>>2]=e;c[J+8>>2]=b|-2147483648;c[J+4>>2]=f}i1(e,385582,f)|0;J7(e+f|0,0);vF(VC(k,J)|0,G)|0;a1(J);z5(G);O0(H);z5(I);z5(F);z5(E);z5(D);z5(C)}while(0);z5(B);z5(A);z5(y);z5(x);l=K;return}function Fb(f){f=f|0;var i=0,j=0.0,k=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0;Z=l;l=l+192|0;T=Z+168|0;V=Z+156|0;W=Z+144|0;X=Z+132|0;Y=Z+120|0;Q=Z+108|0;P=Z+96|0;O=Z+84|0;N=Z+72|0;M=Z+60|0;L=Z+48|0;K=Z+36|0;J=Z+24|0;U=Z+12|0;S=Z;x=f+760|0;if((a[x>>0]|0)==2){RB(f,0,0,64,382769,-1,1,0);RB(f,1,0,18,391454,-1,1,0);RB(f,1,0,23,382769,-1,1,0);RB(f,1,0,21,387924,-1,1,0);RB(f,1,0,58,391482,-1,1,0);RB(f,1,0,59,387924,-1,1,1)}else{RB(f,0,0,64,382779,-1,1,0);RB(f,1,0,18,391454,-1,1,0);RB(f,1,0,23,382779,-1,1,0);RB(f,1,0,21,382789,-1,1,0);RB(f,1,0,58,391514,-1,1,0);RB(f,1,0,59,382789,-1,1,1)}r=f+998|0;s=f+968|0;sM(f,1,0,130,(d[r>>0]<<12)+(e[s>>1]|0)|0,0);t=f+999|0;n=f+970|0;sM(f,1,0,138,(d[t>>0]<<12)+(e[n>>1]|0)|0,0);i=f+997|0;RB(f,1,0,190,c[35868+(d[i>>0]<<2)>>2]|0,-1,1,0);RB(f,1,0,191,c[35884+(d[i>>0]<<2)>>2]|0,-1,1,0);sM(f,1,0,195,8,0);i=f+992|0;u=f+20|0;a:do if((a[x>>0]|0)==2){p=a[i>>0]|0;i=p&255;switch(p<<24>>24){case 0:break a;case 1:{KW(f,1,0,150,1.0,3,1);break a}default:{}}o=b[f+980>>1]|0;p=37344+(i<<2)|0;k=(i+-1|0)>>>0<4;if(o<<16>>16?(q=b[f+982>>1]|0,q<<16>>16):0){i=b[n>>1]|0;if(!(k&i<<16>>16!=0))break;Bt(f,1,c[u>>2]|0,156,+g[p>>2]*(+((d[r>>0]<<12)+(e[s>>1]|0)|0)/+((d[t>>0]<<12)+(i&65535)|0))/(+(o&65535)/+(q&65535)),3,1);break}if(k)Bt(f,1,c[u>>2]|0,156,+g[p>>2],3,1)}else{k=b[n>>1]|0;if(k<<16>>16){i=a[i>>0]|0;switch(i<<24>>24){case 0:case 15:break a;default:{}}Bt(f,1,c[u>>2]|0,156,+((d[r>>0]<<12)+(e[s>>1]|0)|0)/+((d[t>>0]<<12)+(k&65535)|0)/+g[37408+((i&255)<<2)>>2],3,1)}}while(0);i=d[f+993>>0]|0;if((i+-1|0)>>>0<8)KW(f,1,c[u>>2]|0,171,+h[736+(i<<3)>>3]*+((d[f+1e3>>0]|0)+1|0)/+((d[f+1001>>0]|0)+1|0),3,0);i=f+952|0;do if((b[f+984>>1]|0)==-1)R=21;else{if((a[x>>0]|0)==1?(c[i>>2]|0)==262143:0){R=21;break}RB(f,1,0,118,384431,-1,1,0)}while(0);if((R|0)==21)RB(f,1,0,118,384435,-1,1,0);if(a[f+1035>>0]|0?(v=b[f+972>>1]|0,w=c[i>>2]|0,!(v<<16>>16==0&(w|0)==262143)):0)lL(f,1,0,126,(((v&65535)<<12)+w|0)*400|0,10,0);s=f+960|0;if((a[x>>0]|0)!=1){x=c[f+896>>2]|0;w=f+312|0;v=c[w>>2]|0;w=c[w+4>>2]|0;k=z0(v|0,w|0,1,0)|0;i=(x|0)==(v|0)&0==(w|0);k=(x|0)==(k|0)&0==(z|0);if(!((v|0)==0&(w|0)==0|((x|0)==0|i|k)^1)){n=f+1011|0;o=f+904|0;do if(k|(i|(a[n>>0]|0)!=0)){RB(f,1,0,197,384051,-1,1,0);RB(f,1,0,211,383620,-1,1,0);if(!(a[n>>0]|0)){k=(c[f+900>>2]|0)!=0;i=(c[o>>2]|0)==0;if(k){if(!i)break}else if(i)break;RB(f,1,0,204,k?384074:384078,-1,1,0)}}else{RB(f,1,0,197,384063,-1,1,0);k=f+900|0;i=(c[o>>2]|0)==0;if(!(c[k>>2]|0))if(i)R=38;else{i=384078;R=39}else if(i){i=384074;R=39}else R=38;if((R|0)==38)RB(f,1,0,211,384063,-1,1,0);else if((R|0)==39){RB(f,1,0,204,i,-1,1,0);RB(f,1,0,211,c[k>>2]|0?384074:384078,-1,1,0)}i=(c[f+908>>2]|0)!=0;k=(c[f+912>>2]|0)==0;if(i){if(!k)break}else if(k)break;RB(f,1,0,48,i?382802:384015,-1,1,0)}while(0);c[T>>2]=0;c[T+4>>2]=0;c[T+8>>2]=0;i=0;while(1){if((i|0)==3)break;c[T+(i<<2)>>2]=0;i=i+1|0}n=f+792|0;o=f+796|0;k=0;while(1){i=c[n>>2]|0;if(k>>>0>=(c[o>>2]|0)-i>>2>>>0)break;i=c[i+(k<<2)>>2]|0;if(i|0?a[i+3>>0]|0:0){JX(T,a[i+5>>0]|0?383630:383632)|0;JX(T,a[(c[(c[n>>2]|0)+(k<<2)>>2]|0)+6>>0]|0?383634:385590)|0}k=k+1|0}do if((vM(T,51,0)|0)!=-1){k=T+11|0;o=a[k>>0]|0;n=o<<24>>24<0;i=c[T>>2]|0;r=T+4|0;p=n?i:T;q=j9(383636)|0;if(!((((q|0)!=0?(y=p+(n?c[r>>2]|0:o&255)|0,x=tB(p,y,383636,383636+q|0)|0,A=p,(x|0)==(y|0)|(x-A|0)==-1):0)?(B=j9(383653)|0,(B|0)!=0):0)?(B=tB(p,y,383653,383653+B|0)|0,(B|0)==(y|0)|(B-A|0)==-1):0)){RB(f,1,0,204,383670,-1,1,1);KW(f,1,0,171,+h[s>>3]*24.0/30.0,3,1);RB(f,1,0,197,384051,-1,1,1);RB(f,1,0,211,383620,-1,1,1);o=a[k>>0]|0;i=c[T>>2]|0}n=o<<24>>24<0;i=n?i:T;k=j9(383683)|0;if(((k|0?(C=i+(n?c[r>>2]|0:o&255)|0,B=tB(i,C,383683,383683+k|0)|0,D=i,(B|0)==(C|0)|(B-D|0)==-1):0)?(E=j9(383732)|0,E|0):0)?(E=tB(i,C,383732,383732+E|0)|0,(E|0)==(C|0)|(E-D|0)==-1):0)break;RB(f,1,0,204,383781,-1,1,1);KW(f,1,0,171,+h[s>>3]*24.0/25.0,3,1);RB(f,1,0,197,384051,-1,1,1);RB(f,1,0,211,383620,-1,1,1)}while(0);a1(T)}}else{RB(f,1,0,197,384051,-1,1,0);RB(f,1,0,211,383620,-1,1,0)}if(!(a[f+1036>>0]|0)){k=f+995|0;if((a[k>>0]|0)!=-1?(F=f+996|0,(a[F>>0]|0)!=-1):0){TX(X);cC(X,c[35900+(d[k>>0]<<2)>>2]|0)|0;Bs(W,X,54768);TX(Y);cC(Y,c[35932+(d[F>>0]<<2)>>2]|0)|0;i=a[Y+8+3>>0]|0;E=i<<24>>24<0;Ex(W,E?c[Y>>2]|0:Y,E?c[Y+4>>2]|0:i&255)|0;c[V>>2]=c[W>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];i=0;while(1){if((i|0)==3)break;c[W+(i<<2)>>2]=0;i=i+1|0}p2(T,V);zb(f,1,0,24,T,0);z5(T);O0(V);z5(Y);O0(W);z5(X);TX(X);cC(X,c[35900+(d[k>>0]<<2)>>2]|0)|0;Bs(W,X,54768);TX(Y);cC(Y,c[35932+(d[F>>0]<<2)>>2]|0)|0;i=a[Y+8+3>>0]|0;F=i<<24>>24<0;Ex(W,F?c[Y>>2]|0:Y,F?c[Y+4>>2]|0:i&255)|0;c[V>>2]=c[W>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];i=0;while(1){if((i|0)==3)break;c[W+(i<<2)>>2]=0;i=i+1|0}p2(T,V);zb(f,1,0,64,T,0);z5(T);O0(V);z5(Y);O0(W);z5(X)}}else{TX(T);F=f+994|0;zb(f,1,0,24,cC(T,BO(a[F>>0]|0)|0)|0,0);z5(T);TX(T);zb(f,1,0,64,cC(T,BO(a[F>>0]|0)|0)|0,0);z5(T)}RB(f,1,0,187,c[37472+(d[f+1002>>0]<<2)>>2]|0,-1,1,0);if(a[f+1037>>0]|0?(RB(f,1,0,330,382808,-1,1,0),RB(f,1,0,331,mD(a[f+1003>>0]|0)|0,-1,1,0),RB(f,1,0,332,Zx(a[f+1004>>0]|0)|0,-1,1,0),G=f+1005|0,RB(f,1,0,333,SA(a[G>>0]|0)|0,-1,1,0),G=a[G>>0]|0,G<<24>>24!=2):0)RB(f,1,0,191,ZT(G)|0,-1,1,1);if((a[f+1009>>0]|0)==0?(a[f+1010>>0]|0)==0:0){RB(f,1,0,38,382832,-1,1,0);RB(f,1,0,72,382832,-1,1,0)}else{RB(f,1,0,31,382812,-1,1,0);RB(f,1,0,38,382825,-1,1,0);zb(f,1,0,40,f+856|0,0);zb(f,1,0,40,f+868|0,0);RB(f,1,0,66,382812,-1,1,0);RB(f,1,0,72,382825,-1,1,0)}k=f+820|0;i=a[f+828+3>>0]|0;if(i<<24>>24<0)i=c[f+824>>2]|0;else i=i&255;if(i>>>0>7){zb(f,1,0,300,k,0);F=f+832|0;zb(f,1,0,303,F,0);G=f+844|0;zb(f,1,0,304,G,0);zb(f,0,0,273,k,0);zb(f,0,0,276,F,0);zb(f,0,0,277,G,0)}if((a[f+1018>>0]|0?(a[f+777>>0]|0)==0:0)?(H=c[f+920>>2]|0,(H|0)!=-1):0){j=+(H>>>0)*1.0e3;m=+h[s>>3];if(m!=0.0)j=j+ +(d[f+989>>0]|0)*1.0e3/m;KW(f,1,0,217,j,0,0);Xy(W,37504);k=f+1019|0;HX(W,a[k>>0]|0?37572:42196)|0;c[V>>2]=c[W>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];i=0;while(1){if((i|0)==3)break;c[W+(i<<2)>>2]=0;i=i+1|0}p2(T,V);zb(f,1,0,224,T,0);z5(T);O0(V);z5(W);Xy(W,37580);n=f+1020|0;HX(W,a[n>>0]|0?37572:42196)|0;c[V>>2]=c[W>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];i=0;while(1){if((i|0)==3)break;c[W+(i<<2)>>2]=0;i=i+1|0}p2(T,V);zb(f,1,0,224,T,0);z5(T);O0(V);z5(W);Xy(W,37628);HX(W,a[f+1032>>0]|0?37572:42196)|0;c[V>>2]=c[W>>2];c[V+4>>2]=c[W+4>>2];c[V+8>>2]=c[W+8>>2];i=0;while(1){if((i|0)==3)break;c[W+(i<<2)>>2]=0;i=i+1|0}p2(T,V);zb(f,1,0,224,T,0);z5(T);O0(V);z5(W);RB(f,1,0,226,388261,-1,1,0);RB(f,1,0,225,a[k>>0]|0?382808:382840,-1,1,0);i=c[f+1024>>2]|0;k=c[f+1028>>2]|0;do if((k+i|0)>>>0>3?(I=(k|0)==0,(i|0)==0|I|(i|0)==1&(a[n>>0]|0)!=0):0){if(I){xM(f,1,0,382843,382889,0);break}xM(f,1,0,382843,382858,0);if(!(a[n>>0]|0))break;xM(f,1,0,382863,382889,0)}while(0);i=f+880|0;if((a[i+11>>0]|0)<0)i=c[i>>2]|0;RB(f,1,0,245,i,-1,1,0);if(a[f+492>>0]|0)RB(f,1,0,247,382896,-1,1,0)}if(!(c[f+892>>2]|0))RB(f,1,0,32,382840,-1,1,0);else{RB(f,1,0,31,382921,-1,1,0);RB(f,1,0,32,382808,-1,1,0)}lL(f,1,0,328,(d[f+1007>>0]<<10)+(e[f+986>>1]|0)<<11,10,0);if(!(c[f+728>>2]&1)){s_(f);AR(f,0,0);AR(f,184,0)}i=c[f+780>>2]|0;k=1;while(1){if((k|0)==176)break;a[i+(k*3|0)>>0]=0;k=k+1|0}a[i+554>>0]=1;if(a[f+492>>0]|0){a[i+539>>0]=1;a[i+2>>0]=1}if(+g[(c[f+24>>2]|0)+136>>2]>=1.0){a[i>>0]=1;a[i+534>>0]=1;a[i+537>>0]=1;a[i+543>>0]=1}i=a[f+1008>>0]|0;if(i<<24>>24!=-1){$M(f,1,0,382926,(i&255)+8|0);Ou(f,1,0,382926,382945)}$x(T,f,1,0,23,1);i=i9(40252)|0;I=a[T+8+3>>0]|0;b:do if((i|0)==((I<<24>>24<0?c[T+4>>2]|0:I&255)|0)?(VG(T,40252,i)|0)==0:0){$x(V,f,1,0,156,1);i=i9(37680)|0;I=a[V+8+3>>0]|0;if((i|0)!=((I<<24>>24<0?c[V+4>>2]|0:I&255)|0)){z5(V);z5(T);break}if(VG(V,37680,i)|0){z5(V);z5(T);break}$x(W,f,1,0,195,1);i=i9(37704)|0;I=a[W+8+3>>0]|0;if((i|0)!=((I<<24>>24<0?c[W+4>>2]|0:I&255)|0)){z5(W);z5(V);z5(T);break}if(VG(W,37704,i)|0){z5(W);z5(V);z5(T);break}$x(X,f,1,0,192,1);i=i9(37712)|0;I=a[X+8+3>>0]|0;if((i|0)!=((I<<24>>24<0?c[X+4>>2]|0:I&255)|0)){z5(X);z5(W);z5(V);z5(T);break}I=(VG(X,37712,i)|0)==0;z5(X);z5(W);z5(V);z5(T);if(!I)break;$x(T,f,1,0,130,1);i=i9(37736)|0;I=a[T+8+3>>0]|0;do if((i|0)==((I<<24>>24<0?c[T+4>>2]|0:I&255)|0)){if(VG(T,37736,i)|0){R=183;break}$x(V,f,1,0,138,1);i=i9(37756)|0;I=a[V+8+3>>0]|0;if((i|0)!=((I<<24>>24<0?c[V+4>>2]|0:I&255)|0)){z5(V);z5(T);break}if(VG(V,37756,i)|0){z5(V);z5(T);break}$x(W,f,1,0,197,1);i=i9(37772)|0;I=a[W+8+3>>0]|0;if((i|0)!=((I<<24>>24<0?c[W+4>>2]|0:I&255)|0)){z5(W);z5(V);z5(T);break}if(VG(W,37772,i)|0){z5(W);z5(V);z5(T);break}$x(X,f,1,0,171,1);i=i9(37820)|0;R=a[X+8+3>>0]|0;if((i|0)==((R<<24>>24<0?c[X+4>>2]|0:R&255)|0)?(VG(X,37820,i)|0)==0:0){n=0;o=0;p=0;q=0;r=0;s=0;t=0;R=158}else R=144;do if((R|0)==144){$x(Q,f,1,0,171,1);i=i9(37848)|0;R=a[Q+8+3>>0]|0;if((i|0)==((R<<24>>24<0?c[Q+4>>2]|0:R&255)|0)?(VG(Q,37848,i)|0)==0:0){n=0;o=0;p=0;q=0;r=0;s=0;t=1;R=158;break}$x(P,f,1,0,171,1);i=i9(37876)|0;R=a[P+8+3>>0]|0;if((i|0)==((R<<24>>24<0?c[P+4>>2]|0:R&255)|0)?(VG(P,37876,i)|0)==0:0){n=0;o=0;p=0;q=0;r=0;s=1;t=1;R=158;break}$x(O,f,1,0,171,1);i=i9(37904)|0;R=a[O+8+3>>0]|0;if((i|0)==((R<<24>>24<0?c[O+4>>2]|0:R&255)|0)?(VG(O,37904,i)|0)==0:0){n=0;o=0;p=0;q=0;r=1;s=1;t=1;R=158;break}$x(N,f,1,0,171,1);i=i9(37932)|0;R=a[N+8+3>>0]|0;if((i|0)==((R<<24>>24<0?c[N+4>>2]|0:R&255)|0)?(VG(N,37932,i)|0)==0:0){n=0;o=0;p=0;q=1;r=1;s=1;t=1;R=158;break}$x(M,f,1,0,171,1);i=i9(37960)|0;R=a[M+8+3>>0]|0;if((i|0)==((R<<24>>24<0?c[M+4>>2]|0:R&255)|0)?(VG(M,37960,i)|0)==0:0){n=0;o=0;p=1;q=1;r=1;s=1;t=1;R=158;break}$x(L,f,1,0,171,1);i=i9(37988)|0;R=a[L+8+3>>0]|0;if((i|0)==((R<<24>>24<0?c[L+4>>2]|0:R&255)|0)?(VG(L,37988,i)|0)==0:0){n=0;o=1;p=1;q=1;r=1;s=1;t=1;R=158;break}$x(K,f,1,0,171,1);i=i9(38016)|0;R=a[K+8+3>>0]|0;if((i|0)==((R<<24>>24<0?c[K+4>>2]|0:R&255)|0)?(VG(K,38016,i)|0)==0:0){n=1;o=1;p=1;q=1;r=1;s=1;t=1;R=158;break}z5(K);z5(L);z5(M);z5(N);z5(O);z5(P);i=0;R=181}while(0);do if((R|0)==158){$x(Y,f,1,0,24,1);i=i9(38044)|0;R=a[Y+8+3>>0]|0;if((i|0)==((R<<24>>24<0?c[Y+4>>2]|0:R&255)|0)?(VG(Y,38044,i)|0)==0:0){k=0;R=162}else R=160;do if((R|0)==160){$x(J,f,1,0,24,1);i=i9(38084)|0;R=a[J+8+3>>0]|0;if((i|0)!=((R<<24>>24<0?c[J+4>>2]|0:R&255)|0)){i=0;R=165;break}if(!(VG(J,38084,i)|0)){k=1;R=162}else{i=0;R=165}}while(0);do if((R|0)==162){$x(U,f,1,0,120,1);R=rm(U)|0;I=z;if(I>>>0<0|(I|0)==0&R>>>0<2e7){$x(S,f,1,0,126,1);i=rm(S)|0;R=z;i=R>>>0<0|(R|0)==0&i>>>0<2e7;z5(S);z5(U);if(k){R=165;break}}else{z5(U);if(k){i=0;R=165;break}else i=0}z5(Y);if(n)R=168;else R=169}while(0);if((R|0)==165){z5(J);z5(Y);if(n)R=168;else R=169}if((R|0)==168){z5(K);if(o)R=170;else R=171}else if((R|0)==169)if(o)R=170;else R=171;if((R|0)==170){z5(L);if(p)R=172;else R=173}else if((R|0)==171)if(p)R=172;else R=173;if((R|0)==172){z5(M);if(q)R=174;else R=175}else if((R|0)==173)if(q)R=174;else R=175;if((R|0)==174){z5(N);if(r)R=176;else R=177}else if((R|0)==175)if(r)R=176;else R=177;if((R|0)==176){z5(O);if(s)R=178;else R=179}else if((R|0)==177)if(s)R=178;else R=179;if((R|0)==178){z5(P);if(t){R=181;break}}else if((R|0)==179)if(t){R=181;break}z5(X)}while(0);if((R|0)==181){z5(Q);z5(X)}z5(W);z5(V);z5(T);if(!i)break;RB(f,1,0,22,382950,-1,1,0)}else R=183;while(0);if((R|0)==183)z5(T);$x(T,f,1,0,130,1);i=i9(38144)|0;Q=a[T+8+3>>0]|0;do if((i|0)==((Q<<24>>24<0?c[T+4>>2]|0:Q&255)|0)){if(VG(T,38144,i)|0)break;$x(V,f,1,0,138,1);i=i9(38164)|0;Q=a[V+8+3>>0]|0;if((i|0)!=((Q<<24>>24<0?c[V+4>>2]|0:Q&255)|0)){z5(V);z5(T);break b}if(VG(V,38164,i)|0){z5(V);z5(T);break b}$x(W,f,1,0,24,1);i=i9(38084)|0;Q=a[W+8+3>>0]|0;if((i|0)!=((Q<<24>>24<0?c[W+4>>2]|0:Q&255)|0)){z5(W);z5(V);z5(T);break b}if(VG(W,38084,i)|0){z5(W);z5(V);z5(T);break b}$x(X,f,1,0,120,1);Q=rm(X)|0;P=z;if(!(P>>>0<0|(P|0)==0&Q>>>0<27e6)){z5(X);z5(W);z5(V);z5(T);break b}$x(Y,f,1,0,126,1);Q=rm(Y)|0;P=z;z5(Y);z5(X);z5(W);z5(V);z5(T);if(!(P>>>0<0|(P|0)==0&Q>>>0<27e6))break b;$x(T,f,1,0,197,1);i=i9(38184)|0;Q=a[T+8+3>>0]|0;c:do if((i|0)==((Q<<24>>24<0?c[T+4>>2]|0:Q&255)|0)){if(VG(T,38184,i)|0){R=208;break}$x(V,f,1,0,171,1);i=i9(37876)|0;Q=a[V+8+3>>0]|0;do if((i|0)==((Q<<24>>24<0?c[V+4>>2]|0:Q&255)|0)){if(VG(V,37876,i)|0){R=202;break}z5(V);z5(T)}else R=202;while(0);d:do if((R|0)==202){$x(W,f,1,0,171,1);i=i9(37904)|0;Q=a[W+8+3>>0]|0;do if((i|0)==((Q<<24>>24<0?c[W+4>>2]|0:Q&255)|0)){if(VG(W,37904,i)|0)break;z5(W);z5(V);z5(T);break d}while(0);$x(X,f,1,0,171,1);i=i9(37988)|0;Q=a[X+8+3>>0]|0;do if((i|0)==((Q<<24>>24<0?c[X+4>>2]|0:Q&255)|0)){if(VG(X,37988,i)|0)break;z5(X);z5(W);z5(V);z5(T);break d}while(0);$x(Y,f,1,0,171,1);i=i9(38016)|0;Q=a[Y+8+3>>0]|0;if((i|0)==((Q<<24>>24<0?c[Y+4>>2]|0:Q&255)|0)){Q=(VG(Y,38016,i)|0)==0;z5(Y);z5(X);z5(W);z5(V);z5(T);if(Q)break;else break c}else{z5(Y);z5(X);z5(W);z5(V);z5(T);break c}}while(0);RB(f,1,0,22,382959,-1,1,0)}else R=208;while(0);if((R|0)==208)z5(T);$x(T,f,1,0,197,1);i=i9(37772)|0;Q=a[T+8+3>>0]|0;do if((i|0)==((Q<<24>>24<0?c[T+4>>2]|0:Q&255)|0)){if(VG(T,37772,i)|0)break;$x(V,f,1,0,171,1);i=i9(37876)|0;Q=a[V+8+3>>0]|0;do if((i|0)==((Q<<24>>24<0?c[V+4>>2]|0:Q&255)|0)){if(VG(V,37876,i)|0){R=218;break}z5(V);z5(T)}else R=218;while(0);e:do if((R|0)==218){$x(W,f,1,0,171,1);i=i9(37904)|0;Q=a[W+8+3>>0]|0;do if((i|0)==((Q<<24>>24<0?c[W+4>>2]|0:Q&255)|0)){if(VG(W,37904,i)|0)break;z5(W);z5(V);z5(T);break e}while(0);$x(X,f,1,0,171,1);i=i9(37932)|0;Q=a[X+8+3>>0]|0;do if((i|0)==((Q<<24>>24<0?c[X+4>>2]|0:Q&255)|0)){if(VG(X,37932,i)|0)break;z5(X);z5(W);z5(V);z5(T);break e}while(0);$x(Y,f,1,0,171,1);i=i9(37960)|0;Q=a[Y+8+3>>0]|0;do if((i|0)==((Q<<24>>24<0?c[Y+4>>2]|0:Q&255)|0)){if(VG(Y,37960,i)|0)break;z5(Y);z5(X);z5(W);z5(V);z5(T);break e}while(0);$x(U,f,1,0,171,1);i=i9(37988)|0;Q=a[U+8+3>>0]|0;if((i|0)==((Q<<24>>24<0?c[U+4>>2]|0:Q&255)|0)?(VG(U,37988,i)|0)==0:0)i=1;else{$x(S,f,1,0,171,1);i=i9(38016)|0;Q=a[S+8+3>>0]|0;if((i|0)==((Q<<24>>24<0?c[S+4>>2]|0:Q&255)|0))i=(VG(S,38016,i)|0)==0;else i=0;z5(S)}z5(U);z5(Y);z5(X);z5(W);z5(V);z5(T);if(!i)break b}while(0);RB(f,1,0,22,382969,-1,1,0);break b}while(0);z5(T);break b}while(0);z5(T)}else R=135;while(0);if((R|0)==135)z5(T);l=Z;return}function Gb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;fa=l;l=l+432|0;ba=fa+412|0;ca=fa+400|0;da=fa+388|0;ea=fa+376|0;F=fa+364|0;G=fa+352|0;H=fa+340|0;I=fa+328|0;J=fa+316|0;K=fa+304|0;L=fa+292|0;M=fa+280|0;N=fa+268|0;O=fa+256|0;P=fa+244|0;Q=fa+232|0;R=fa+220|0;S=fa+208|0;T=fa+196|0;U=fa+184|0;V=fa+172|0;W=fa+160|0;X=fa+148|0;Y=fa+136|0;Z=fa+96|0;_=fa+84|0;$=fa+72|0;aa=fa+60|0;w=fa+48|0;x=fa+36|0;r=fa+24|0;q=fa+12|0;u=fa;if(((e|0)<=6?(i=c[d+4>>2]|0,(i|0)!=0):0)?(A=c[i>>2]|0,(((c[A+(e*12|0)+4>>2]|0)-(c[A+(e*12|0)>>2]|0)|0)/40|0)>>>0>f>>>0):0){A=b+4|0;while(1){v=c[c[A>>2]>>2]|0;if((((c[v+(e*12|0)+4>>2]|0)-(c[v+(e*12|0)>>2]|0)|0)/40|0)>>>0>g>>>0)break;Kc(b,e,-1)|0}TX(ba);TX(ca);TX(da);TX(ea);TX(F);TX(G);TX(H);TX(I);TX(J);TX(K);TX(L);TX(M);TX(N);TX(O);TX(P);TX(Q);TX(R);TX(S);TX(T);TX(U);TX(V);TX(W);p=(e|0)==1;s=T+4|0;t=T+8+3|0;if(!p)if((e|0)==2){$x(X,b,2,g,122,1);vF(L,X)|0;z5(X);v=1}else v=0;else{$x(X,b,1,g,130,1);vF(ba,X)|0;z5(X);$x(X,b,1,g,138,1);vF(ca,X)|0;z5(X);$x(X,b,1,g,150,1);vF(da,X)|0;z5(X);$x(X,b,1,g,156,1);vF(ea,X)|0;z5(X);$x(X,b,1,g,171,1);vF(F,X)|0;z5(X);$x(X,b,1,g,173,1);vF(G,X)|0;z5(X);$x(X,b,1,g,174,1);vF(H,X)|0;z5(X);$x(X,b,1,g,167,1);vF(I,X)|0;z5(X);$x(X,b,1,g,197,1);vF(J,X)|0;z5(X);$x(X,b,1,g,204,1);vF(K,X)|0;z5(X);$x(X,b,1,g,330,1);vF(T,X)|0;z5(X);v=a[t>>0]|0;if((v<<24>>24<0?c[s>>2]|0:v&255)|0){$x(X,b,1,g,331,1);vF(U,X)|0;z5(X);$x(X,b,1,g,332,1);vF(V,X)|0;z5(X);$x(X,b,1,g,333,1);vF(W,X)|0;z5(X)}Ed(b,1,g,330);Ed(b,1,g,331);Ed(b,1,g,332);Ed(b,1,g,333);v=0}$x(X,d,e,f,Rb(e,72)|0,1);i=i9(22972)|0;n=a[X+8+3>>0]|0;if((i|0)==((n<<24>>24<0?c[X+4>>2]|0:n&255)|0)){n=(VG(X,22972,i)|0)==0;z5(X);if(n){gq(X,b,e,g,378106);Mc(b,e,g,357211,X,1);z5(X);mj(b,e,g,378106);gq(X,b,e,g,374599);Mc(b,e,g,357226,X,1);z5(X);mj(b,e,g,374599);gq(X,b,e,g,374615);Mc(b,e,g,357251,X,1);z5(X);mj(b,e,g,374615);gq(X,d,e,g,384476);n=a[X+8+3>>0]|0;n=((n<<24>>24<0?c[X+4>>2]|0:n&255)|0)==0;z5(X);if(!n){gq(X,b,e,g,357273);Mc(b,e,g,357288,X,1);z5(X);mj(b,e,g,357273)}}else o=18}else{z5(X);o=18}if((o|0)==18){gq(X,b,e,g,378106);vF(M,X)|0;z5(X);gq(X,b,e,g,357273);vF(P,X)|0;z5(X);gq(X,b,e,g,374599);vF(N,X)|0;z5(X);gq(X,b,e,g,374615);vF(O,X)|0;z5(X)}gq(X,b,e,g,374413);vF(Q,X)|0;z5(X);gq(X,b,e,g,357312);vF(R,X)|0;z5(X);gq(X,b,e,g,374420);vF(S,X)|0;z5(X);gq(X,b,e,g,384534);gq(Y,b,e,g,390999);j=RA(d,e,f)|0;k=Z+11|0;m=Z+11|0;n=_+11|0;i=9;while(1){if(i>>>0>=j>>>0)break;o=Vj(d,e,f,i,1)|0;ga=a[o+8+3>>0]|0;do if((ga<<24>>24<0?c[o+4>>2]|0:ga&255)|0){if(!h?(ha=Vj(b,e,g,i,1)|0,ga=a[ha+8+3>>0]|0,(ga<<24>>24<0?c[ha+4>>2]|0:ga&255)|0):0)break;ha=vn(e)|0;if(i>>>0<(((c[ha+4>>2]|0)-(c[ha>>2]|0)|0)/40|0)>>>0){zb(b,e,g,i,o,1);break}else{Sn(Z,Vj(d,e,f,i,0)|0);Mc(b,e,g,(a[k>>0]|0)<0?c[Z>>2]|0:Z,o,1);a1(Z);Sn(Z,Vj(d,e,f,i,0)|0);ga=a[m>>0]|0;ha=c[Z>>2]|0;o=Vj(d,e,f,i,3)|0;Sn(_,o);Ou(b,e,g,ga<<24>>24<0?ha:Z,(a[n>>0]|0)<0?c[_>>2]|0:_);a1(_);a1(Z);break}}while(0);i=i+1|0}if(p){$x(Z,b,1,g,150,1);$x(_,b,1,g,156,1);m=ba+8+3|0;ha=a[m>>0]|0;n=ba+4|0;a:do if((ha<<24>>24<0?c[n>>2]|0:ha&255)|0){$x($,b,1,g,130,1);j=a[m>>0]|0;i=j<<24>>24<0;j=i?c[n>>2]|0:j&255;ha=a[$+8+3>>0]|0;k=ha<<24>>24<0;if((j|0)==((k?c[$+4>>2]|0:ha&255)|0)?(L$(i?c[ba>>2]|0:ba,k?c[$>>2]|0:$,j)|0)==0:0){z5($);break}$x(aa,b,1,g,18,1);i=i9(29144)|0;ha=a[aa+8+3>>0]|0;do if((i|0)==((ha<<24>>24<0?c[aa+4>>2]|0:ha&255)|0)){if(VG(aa,29144,i)|0){z5(aa);z5($);break}i=i9(7360)|0;ha=a[m>>0]|0;if((i|0)!=((ha<<24>>24<0?c[n>>2]|0:ha&255)|0)){z5(aa);z5($);break}if(VG(ba,7360,i)|0){z5(aa);z5($);break}i=b+20|0;$x(w,b,1,c[i>>2]|0,130,1);j=i9(37736)|0;ha=a[w+8+3>>0]|0;if((j|0)==((ha<<24>>24<0?c[w+4>>2]|0:ha&255)|0)?(VG(w,37736,j)|0)==0:0){z5(w);z5(aa);z5($);break a}$x(x,b,1,c[i>>2]|0,130,1);i=i9(38144)|0;ha=a[x+8+3>>0]|0;if((i|0)==((ha<<24>>24<0?c[x+4>>2]|0:ha&255)|0)){ha=(VG(x,38144,i)|0)==0;z5(x);z5(w);z5(aa);z5($);if(ha)break a;else break}else{z5(x);z5(w);z5(aa);z5($);break}}else{z5(aa);z5($)}while(0);zb(b,1,g,134,(c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(g*40|0)>>2]|0)+1560|0,1);zb(b,1,g,130,ba,1)}while(0);i=ca+8+3|0;ha=a[i>>0]|0;j=ca+4|0;do if((ha<<24>>24<0?c[j>>2]|0:ha&255)|0){$x($,b,1,g,138,1);i=a[i>>0]|0;k=i<<24>>24<0;i=k?c[j>>2]|0:i&255;ha=a[$+8+3>>0]|0;j=ha<<24>>24<0;if((i|0)==((j?c[$+4>>2]|0:ha&255)|0)){ha=(L$(k?c[ca>>2]|0:ca,j?c[$>>2]|0:$,i)|0)==0;z5($);if(ha)break}else z5($);zb(b,1,g,142,(c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(g*40|0)>>2]|0)+1656|0,1);zb(b,1,g,138,ca,1)}while(0);i=da+8+3|0;ha=a[i>>0]|0;j=da+4|0;do if((ha<<24>>24<0?c[j>>2]|0:ha&255)|0){$x($,b,1,g,150,1);i=a[i>>0]|0;k=i<<24>>24<0;i=k?c[j>>2]|0:i&255;ha=a[$+8+3>>0]|0;j=ha<<24>>24<0;if((i|0)==((j?c[$+4>>2]|0:ha&255)|0)){ha=(L$(k?c[da>>2]|0:da,j?c[$>>2]|0:$,i)|0)==0;z5($);if(ha)break}else z5($);zb(b,1,g,152,Z,1);zb(b,1,g,150,da,1)}while(0);j=a[ea+8+3>>0]|0;i=j<<24>>24<0;j=i?c[ea+4>>2]|0:j&255;do if(j|0){ha=a[_+8+3>>0]|0;k=ha<<24>>24<0;if((j|0)==((k?c[_+4>>2]|0:ha&255)|0)?(L$(i?c[ea>>2]|0:ea,k?c[_>>2]|0:_,j)|0)==0:0)break;zb(b,1,g,158,_,1);zb(b,1,g,156,ea,1)}while(0);i=F+8+3|0;ha=a[i>>0]|0;j=F+4|0;if((ha<<24>>24<0?c[j>>2]|0:ha&255)|0){$x(r,b,1,g,171,1);i=a[i>>0]|0;k=i<<24>>24<0;i=k?c[j>>2]|0:i&255;ha=a[r+8+3>>0]|0;j=ha<<24>>24<0;if((i|0)==((j?c[r+4>>2]|0:ha&255)|0)?(L$(k?c[F>>2]|0:F,j?c[r>>2]|0:r,i)|0)==0:0){n=1;o=65}else o=76}else{n=0;o=65}b:do if((o|0)==65){i=G+8+3|0;ha=a[i>>0]|0;j=G+4|0;do if((ha<<24>>24<0?c[j>>2]|0:ha&255)|0){$x(q,b,1,g,173,1);i=a[i>>0]|0;k=i<<24>>24<0;i=k?c[j>>2]|0:i&255;ha=a[q+8+3>>0]|0;j=ha<<24>>24<0;if((i|0)==((j?c[q+4>>2]|0:ha&255)|0)?(L$(k?c[G>>2]|0:G,j?c[q>>2]|0:q,i)|0)==0:0){m=1;break}z5(q);if(n){o=76;break b}else{o=79;break b}}else m=0;while(0);i=H+8+3|0;ha=a[i>>0]|0;j=H+4|0;do if(!((ha<<24>>24<0?c[j>>2]|0:ha&255)|0))if(m){i=0;o=74}else{i=0;o=75}else{$x($,b,1,g,174,1);i=a[i>>0]|0;k=i<<24>>24<0;i=k?c[j>>2]|0:i&255;ha=a[$+8+3>>0]|0;j=ha<<24>>24<0;if((i|0)==((j?c[$+4>>2]|0:ha&255)|0)){i=(L$(k?c[H>>2]|0:H,j?c[$>>2]|0:$,i)|0)!=0;z5($);if(m){o=74;break}else{o=75;break}}else{z5($);if(m){i=1;o=74;break}else{i=1;o=75;break}}}while(0);if((o|0)==74){z5(q);if(n)o=77;else o=78}else if((o|0)==75)if(n)o=77;else o=78;if((o|0)==77){z5(r);if(i){o=79;break}else break}else if((o|0)==78)if(i){o=79;break}else break}while(0);if((o|0)==76){z5(r);o=79}if((o|0)==79){$x($,d,1,g,171,1);zb(b,1,g,181,$,1);z5($);$x($,d,1,g,173,1);zb(b,1,g,183,$,1);z5($);$x($,d,1,g,174,1);zb(b,1,g,184,$,1);z5($);zb(b,1,g,171,F,1);zb(b,1,g,173,G,1);zb(b,1,g,174,H,1)}i=I+8+3|0;ha=a[i>>0]|0;j=I+4|0;do if((ha<<24>>24<0?c[j>>2]|0:ha&255)|0){$x($,b,1,g,167,1);i=a[i>>0]|0;k=i<<24>>24<0;i=k?c[j>>2]|0:i&255;ha=a[$+8+3>>0]|0;j=ha<<24>>24<0;if((i|0)==((j?c[$+4>>2]|0:ha&255)|0)){ha=(L$(k?c[I>>2]|0:I,j?c[$>>2]|0:$,i)|0)==0;z5($);if(ha)break}else z5($);zb(b,1,g,169,(c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(g*40|0)>>2]|0)+2004|0,1);zb(b,1,g,167,I,1)}while(0);i=J+8+3|0;ha=a[i>>0]|0;j=J+4|0;c:do if((ha<<24>>24<0?c[j>>2]|0:ha&255)|0){$x($,b,1,g,197,1);i=a[i>>0]|0;k=i<<24>>24<0;i=k?c[j>>2]|0:i&255;ha=a[$+8+3>>0]|0;j=ha<<24>>24<0;if((i|0)==((j?c[$+4>>2]|0:ha&255)|0)?(L$(k?c[J>>2]|0:J,j?c[$>>2]|0:$,i)|0)==0:0){z5($);break}do if((i9(38184)|0)==(i|0)?(VG(J,38184,i)|0)==0:0){$x(aa,b,1,g,197,1);i=i9(7380)|0;ha=a[aa+8+3>>0]|0;if((i|0)==((ha<<24>>24<0?c[aa+4>>2]|0:ha&255)|0)){ha=(VG(aa,7380,i)|0)==0;z5(aa);z5($);if(ha)break c;else break}else{z5(aa);z5($);break}}else o=93;while(0);if((o|0)==93)z5($);zb(b,1,g,199,(c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(g*40|0)>>2]|0)+2364|0,1);zb(b,1,g,197,J,1)}while(0);$x($,b,1,g,199,1);i=i9(37772)|0;ha=a[$+8+3>>0]|0;if((i|0)==((ha<<24>>24<0?c[$+4>>2]|0:ha&255)|0)?(VG($,37772,i)|0)==0:0)z5($);else o=99;d:do if((o|0)==99){m=K+8+3|0;ha=a[m>>0]|0;n=K+4|0;do if(!((ha<<24>>24<0?c[n>>2]|0:ha&255)|0)){j=0;o=102}else{$x(u,b,1,g,204,1);j=a[m>>0]|0;i=j<<24>>24<0;j=i?c[n>>2]|0:j&255;ha=a[u+8+3>>0]|0;k=ha<<24>>24<0;if((j|0)!=((k?c[u+4>>2]|0:ha&255)|0)){z5(u);z5($);break}if(!(L$(i?c[K>>2]|0:K,k?c[u>>2]|0:u,j)|0)){j=1;o=102;break}z5(u);z5($)}while(0);do if((o|0)==102){$x(aa,b,1,g,199,1);i=a[aa+8+3>>0]|0;i=((i<<24>>24<0?c[aa+4>>2]|0:i&255)|0)!=0;z5(aa);if(j){z5(u);z5($);if(i)break;else break d}else{z5($);if(i)break;else break d}}while(0);zb(b,1,g,209,(c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(g*40|0)>>2]|0)+2448|0,1);ha=a[m>>0]|0;if(!((ha<<24>>24<0?c[n>>2]|0:ha&255)|0)){Ed(b,1,g,204);Ed(b,1,g,205);break}else{zb(b,1,g,204,K,1);break}}while(0);ha=a[t>>0]|0;e:do if((ha<<24>>24<0?c[s>>2]|0:ha&255)|0){$x($,b,1,g,330,1);ha=a[$+8+3>>0]|0;f:do if(!((ha<<24>>24<0?c[$+4>>2]|0:ha&255)|0))z5($);else{$x(aa,b,1,g,331,1);j=a[U+8+3>>0]|0;i=j<<24>>24<0;j=i?c[U+4>>2]|0:j&255;ha=a[aa+8+3>>0]|0;k=ha<<24>>24<0;do if((j|0)==((k?c[aa+4>>2]|0:ha&255)|0)){if(L$(i?c[U>>2]|0:U,k?c[aa>>2]|0:aa,j)|0){z5(aa);z5($);break}$x(w,b,1,g,332,1);j=a[V+8+3>>0]|0;i=j<<24>>24<0;j=i?c[V+4>>2]|0:j&255;ha=a[w+8+3>>0]|0;k=ha<<24>>24<0;if((j|0)!=((k?c[w+4>>2]|0:ha&255)|0)){z5(w);z5(aa);z5($);break}if(L$(i?c[V>>2]|0:V,k?c[w>>2]|0:w,j)|0){z5(w);z5(aa);z5($);break}$x(x,b,1,g,333,1);j=a[W+8+3>>0]|0;i=j<<24>>24<0;j=i?c[W+4>>2]|0:j&255;ha=a[x+8+3>>0]|0;k=ha<<24>>24<0;if((j|0)==((k?c[x+4>>2]|0:ha&255)|0)){ha=(L$(i?c[W>>2]|0:W,k?c[x>>2]|0:x,j)|0)==0;z5(x);z5(w);z5(aa);z5($);if(ha)break f;else break}else{z5(x);z5(w);z5(aa);z5($);break}}else{z5(aa);z5($)}while(0);zb(b,1,g,334,(c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(g*40|0)>>2]|0)+3960|0,1);zb(b,1,g,330,T,1);zb(b,1,g,335,(c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(g*40|0)>>2]|0)+3972|0,1);zb(b,1,g,331,U,1);zb(b,1,g,336,(c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(g*40|0)>>2]|0)+3984|0,1);zb(b,1,g,332,V,1);zb(b,1,g,337,(c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(g*40|0)>>2]|0)+3996|0,1);zb(b,1,g,333,W,1);break e}while(0);zb(b,1,g,330,T,1);zb(b,1,g,331,U,1);zb(b,1,g,332,V,1);zb(b,1,g,333,W,1)}while(0);z5(_);z5(Z)}do if(v?(y=L+8+3|0,ha=a[y>>0]|0,z=L+4|0,(ha<<24>>24<0?c[z>>2]|0:ha&255)|0):0){$x(Z,b,2,g,122,1);j=a[y>>0]|0;i=j<<24>>24<0;j=i?c[z>>2]|0:j&255;ha=a[Z+8+3>>0]|0;k=ha<<24>>24<0;if((j|0)==((k?c[Z+4>>2]|0:ha&255)|0)){ha=(L$(i?c[L>>2]|0:L,k?c[Z>>2]|0:Z,j)|0)==0;z5(Z);if(ha)break}else z5(Z);mI(Z);Xy(_,41840);z3(Z,_);z5(_);$x(_,b,2,g,122,1);og(Z,_);z5(_);h=c[Z>>2]|0;p=((c[Z+4>>2]|0)-h|0)/12|0;n=a[y>>0]|0;o=n<<24>>24<0;n=o?c[z>>2]|0:n&255;o=o?c[L>>2]|0:L;m=0;i=0;while(1){if((m|0)==(p|0))break;j=h+(m*12|0)|0;ha=a[h+(m*12|0)+8+3>>0]|0;k=ha<<24>>24<0;if((n|0)==((k?c[h+(m*12|0)+4>>2]|0:ha&255)|0))i=i|(L$(o,k?c[j>>2]|0:j,n)|0)==0;m=m+1|0}$_(Z);if(!i){$x(Z,b,2,g,44,1);i=a[Z+8+3>>0]|0;j=i<<24>>24<0;k=j?c[Z>>2]|0:Z;m=i9(28732)|0;if(!m)i=0;else{ha=k+((j?c[Z+4>>2]|0:i&255)<<2)|0;i=HA(k,ha,28732,28732+(m<<2)|0)|0;i=(i|0)==(ha|0)?-1:i-k>>2}z5(Z);if((i|0)==-1){zb(b,2,g,124,(c[(c[(c[c[A>>2]>>2]|0)+24>>2]|0)+(g*40|0)>>2]|0)+1464|0,1);zb(b,2,g,122,L,1)}}}while(0);i=O+8+3|0;ha=a[i>>0]|0;j=O+4|0;do if((ha<<24>>24<0?c[j>>2]|0:ha&255)|0){gq(Z,b,e,g,374615);i=a[i>>0]|0;k=i<<24>>24<0;i=k?c[j>>2]|0:i&255;ha=a[Z+8+3>>0]|0;j=ha<<24>>24<0;if((i|0)==((j?c[Z+4>>2]|0:ha&255)|0)){ha=(L$(k?c[O>>2]|0:O,j?c[Z>>2]|0:Z,i)|0)==0;z5(Z);if(ha)break}else z5(Z);gq(Z,b,e,g,378106);Mc(b,e,g,357211,Z,1);z5(Z);Mc(b,e,g,378106,M,1);gq(Z,b,e,g,357273);Mc(b,e,g,357288,Z,1);z5(Z);Mc(b,e,g,357273,P,1);gq(Z,b,e,g,374599);Mc(b,e,g,357226,Z,1);z5(Z);Mc(b,e,g,374599,N,1);gq(Z,b,e,g,374615);Mc(b,e,g,357251,Z,1);z5(Z);Mc(b,e,g,374615,O,1)}while(0);i=Q+8+3|0;ha=a[i>>0]|0;j=Q+4|0;do if((ha<<24>>24<0?c[j>>2]|0:ha&255)|0){gq(Z,b,e,g,374413);i=a[i>>0]|0;k=i<<24>>24<0;i=k?c[j>>2]|0:i&255;ha=a[Z+8+3>>0]|0;j=ha<<24>>24<0;if((i|0)==((j?c[Z+4>>2]|0:ha&255)|0)){ha=(L$(k?c[Q>>2]|0:Q,j?c[Z>>2]|0:Z,i)|0)==0;z5(Z);if(ha)break}else z5(Z);gq(Z,b,e,g,374413);Mc(b,e,g,374432,Z,1);z5(Z);Mc(b,e,g,374413,Q,1);gq(Z,b,e,g,357312);Mc(b,e,g,357324,Z,1);z5(Z);Mc(b,e,g,357312,S,1);gq(Z,b,e,g,374420);Mc(b,e,g,374448,Z,1);z5(Z);Mc(b,e,g,374420,S,1)}while(0);j=a[X+8+3>>0]|0;i=j<<24>>24<0;j=i?c[X+4>>2]|0:j&255;if((j|0?(B=i?c[X>>2]|0:X,C=i9(41840)|0,C|0):0)?(ga=B+(j<<2)|0,ha=HA(B,ga,41840,41840+(C<<2)|0)|0,(ha|0)==(ga|0)|(ha-B|0)==-4):0){gq(Z,b,e,g,384534);i=a[Z+8+3>>0]|0;j=i<<24>>24<0;k=j?c[Z>>2]|0:Z;m=i9(13976)|0;if(!m)i=0;else{ha=k+((j?c[Z+4>>2]|0:i&255)<<2)|0;i=HA(k,ha,13976,13976+(m<<2)|0)|0;i=(i|0)==(ha|0)?-1:i-k>>2}z5(Z);if((i|0)!=-1){gq(Z,b,e,g,384534);c[_>>2]=0;c[_+4>>2]=0;c[_+8>>2]=0;k=i9(13976)|0;if(k>>>0>1073741807)uaa();i=_+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){ha=ua(8)|0;K2(ha,391652);c[ha>>2]=57868;Ya(ha|0,2712,367)}else{ha=ZW(j<<2)|0;c[_>>2]=ha;c[i>>2]=j|-2147483648;c[_+4>>2]=k;i=ha;break}}else{a[i+3>>0]=k;i=_}while(0);a3(i,13976,k);y7(i+(k<<2)|0,0);vo(Z,_,X,0,8);O0(_);Mc(b,e,g,384534,Z,1);z5(Z)}}i=mt(d,e,f)|0;k=a[Y+8+3>>0]|0;j=k<<24>>24<0;k=j?c[Y+4>>2]|0:k&255;do if(k|0?(E=a[i+8+3>>0]|0,D=E<<24>>24<0,E=D?c[i+4>>2]|0:E&255,E|0):0){if((k|0)==(E|0)?(L$(j?c[Y>>2]|0:Y,D?c[i>>2]|0:i,k)|0)==0:0)break;ha=IR(c[b+24>>2]|0)|0;if(ha^((IR(c[d+24>>2]|0)|0)^1)){nt($,Y,45);gq(aa,d,e,f,390999);i=a[aa+8+3>>0]|0;ha=i<<24>>24<0;Ex($,ha?c[aa>>2]|0:aa,ha?c[aa+4>>2]|0:i&255)|0;c[_>>2]=c[$>>2];c[_+4>>2]=c[$+4>>2];c[_+8>>2]=c[$+8>>2];i=0;while(1){if((i|0)==3)break;c[$+(i<<2)>>2]=0;i=i+1|0}p2(Z,_);Mc(b,e,g,390999,Z,1);z5(Z);O0(_);z5(aa);O0($)}}while(0);lL(b,e,g,0,RA(b,e,g)|0,10,1);z5(Y);z5(X);z5(W);z5(V);z5(U);z5(T);z5(S);z5(R);z5(Q);z5(P);z5(O);z5(N);z5(M);z5(L);z5(K);z5(J);z5(I);z5(H);z5(G);z5(F);z5(ea);z5(da);z5(ca);z5(ba);i=1}else i=0;l=fa;return i|0}function Hb(f,g){f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0;ja=l;l=l+112|0;S=ja+72|0;ga=ja+60|0;ha=ja+48|0;ia=ja+36|0;aa=ja+24|0;ba=ja+12|0;ca=ja;X=f+768|0;fa=c[(c[(c[X>>2]|0)+80>>2]|0)+(g<<2)>>2]|0;t=fa+168|0;R=fa+194|0;if(!((a[t>>0]|0)==32?(b[R>>1]|0)!=0:0)){i=c[fa>>2]|0;if(i|0)SM(i);i=1;while(1){if((i|0)==7)break;c[S+(i<<2)>>2]=RA(f,i,-1)|0;i=i+1|0}da=fa+52|0;i=c[da>>2]|0;ea=fa+60|0;P=fa+4|0;Z=f+20|0;_=f+16|0;Q=fa+8|0;if(((i|0)!=7?(j=c[ea>>2]|0,(j|0)!=-1):0)?(k=c[fa>>2]|0,(k|0)!=0):0){Gb(f,k,i,0,j,1)|0;c[_>>2]=c[da>>2];c[Z>>2]=c[ea>>2];Y=62}else Y=12;do if((Y|0)==12){c[_>>2]=7;i=c[fa>>2]|0;k=f+808|0;r=fa+181|0;if(i|0){if(c[i+728>>2]&1|0){j=b[R>>1]|0;if(j<<16>>16){s4(c[c[(c[(c[X>>2]|0)+80>>2]|0)+((j&65535)<<2)>>2]>>2]|0);i=c[fa>>2]|0}if((RA(i,1,-1)|0)!=0?(RA(c[fa>>2]|0,3,-1)|0)!=0:0){Kc(f,1,-1)|0;Gb(f,c[fa>>2]|0,1,0,c[Z>>2]|0,1)|0}else Cp(f,c[fa>>2]|0)|0;if((a[fa+171>>0]|0?(m=c[X>>2]|0,m=(HD(m+68|0,m)|0)+44|0,m=UD(m,b[fa+164>>1]|0)|0,Y=c[X>>2]|0,(m|0)!=((HD(Y+68|0,Y)|0)+48|0)):0)?(n=m+20|0,o=c[n>>2]|0,o|0):0){G2(f,o);Gb(f,c[n>>2]|0,c[_>>2]|0,c[Z>>2]|0,0,1)|0}i=c[X>>2]|0;i=HD(i+68|0,i)|0;Y=c[X>>2]|0;i=UD(i+44|0,b[(c[(c[Y+80>>2]|0)+(g<<2)>>2]|0)+164>>1]|0)|0;if(((i|0)!=((HD(Y+68|0,Y)|0)+48|0)?c[i+24>>2]|0:0)?($x(ga,f,2,c[Z>>2]|0,44,1),Y=a[ga+8+3>>0]|0,Y=((Y<<24>>24<0?c[ga+4>>2]|0:Y&255)|0)==0,z5(ga),Y):0)RB(f,2,c[Z>>2]|0,44,378437,-1,1,0);if((a[(c[(c[(c[X>>2]|0)+80>>2]|0)+(g<<2)>>2]|0)+168>>0]|0)==17?($x(ga,f,2,c[Z>>2]|0,44,1),Y=a[ga+8+3>>0]|0,Y=((Y<<24>>24<0?c[ga+4>>2]|0:Y&255)|0)==0,z5(ga),Y):0)RB(f,2,c[Z>>2]|0,44,378440,-1,1,0)}if((c[_>>2]|0)!=7){Y=63;break}}i=c[X>>2]|0;if((((a[i+2>>0]|0?(c[P>>2]|0)!=(c[Q>>2]|0):0)?c[(HD(i+68|0,i)|0)+24>>2]|0:0)?(p=c[X>>2]|0,p=(HD(p+68|0,p)|0)+16|0,p=c[($C(p,c[P>>2]|0)|0)+68>>2]|0,a[r>>0]|0):0)?(q=dq(p)|0,(q|0)!=7):0){c[_>>2]=q;Kc(f,q,-1)|0;M=c[_>>2]|0;N=c[Z>>2]|0;O=Rb(M,0)|0;Y=ti(p)|0;RB(f,M,N,O,Y,-1,1,0);O=c[_>>2]|0;N=c[Z>>2]|0;RB(f,O,N,Rb(O,17)|0,Y,-1,1,0)}if((c[_>>2]|0)==7){i=fa+160|0;j=c[i>>2]|0;if(((j|0?a[r>>0]|0:0)?(s=dq(j)|0,(s|0)!=7):0)?(c[_>>2]=s,Kc(f,s,-1)|0,Y=c[_>>2]|0,O=c[Z>>2]|0,N=Rb(Y,0)|0,RB(f,Y,O,N,ti(c[i>>2]|0)|0,-1,1,0),N=c[_>>2]|0,O=c[Z>>2]|0,Y=Rb(N,17)|0,RB(f,N,O,Y,ti(c[i>>2]|0)|0,-1,1,0),(c[_>>2]|0)!=7):0){Y=63;break}i=c[X>>2]|0;do if(((a[i+2>>0]|0?(c[P>>2]|0)!=(c[Q>>2]|0):0)?c[(HD(i+68|0,i)|0)+24>>2]|0:0)?(u=c[X>>2]|0,u=(HD(u+68|0,u)|0)+16|0,u=c[($C(u,c[P>>2]|0)|0)+68>>2]|0,h=hj(d[t>>0]|0,u)|0,(h|0)!=7):0){if((a[r>>0]|0)==0?!((u|0)==1212435798|(a[k>>0]|0)!=0):0)break;c[_>>2]=h;if(!h){h=c[fa>>2]|0;if(!h)h=0;else{Gb(f,h,0,0,0,1)|0;c[_>>2]=7;h=7}}Kc(f,h,-1)|0;Y=c[_>>2]|0;O=c[Z>>2]|0;N=Rb(Y,0)|0;RB(f,Y,O,N,rh(a[t>>0]|0,u)|0,-1,1,0);N=c[_>>2]|0;O=c[Z>>2]|0;Y=Rb(N,17)|0;RB(f,N,O,Y,fi(a[t>>0]|0,u)|0,-1,1,0)}while(0);if((c[_>>2]|0)==7){i=fa+56|0;h=c[i>>2]|0;if((h|0)==7)Y=62;else{if((a[r>>0]|0)==0?(a[k>>0]|0)==0:0)if((h|0)==3&(a[f+809>>0]|0)!=0)h=3;else{if((c[P>>2]|0)==(c[Q>>2]|0)){Y=62;break}Y=c[X>>2]|0;Y=(HD(Y+68|0,Y)|0)+16|0;if((c[($C(Y,c[P>>2]|0)|0)+68>>2]|0)!=1212435798){Y=62;break}h=c[i>>2]|0}Kc(f,h,-1)|0;Y=62}}else Y=63}else Y=63}while(0);if((Y|0)==62)if((c[_>>2]|0)==7)Y=208;else Y=63;if((Y|0)==63){r=fa+28|0;s=fa+192|0;t=fa+188|0;u=fa+32|0;v=ga+8+3|0;w=ga+4|0;x=ga+11|0;y=aa+8+3|0;z=aa+4|0;A=ga+8+3|0;B=ga+4|0;C=ha+8+3|0;D=ha+4|0;E=ca+8+3|0;F=ca+4|0;G=ca+8+3|0;H=ca+4|0;I=ga+8+3|0;J=ga+4|0;K=ca+8+3|0;L=ca+4|0;p=1;while(1){if(p>>>0>=7)break;M=RA(f,p,-1)|0;N=(p|0)==2;O=(p|0)==1;q=c[S+(p<<2)>>2]|0;while(1){if(q>>>0>=M>>>0)break;c[da>>2]=c[_>>2];c[ea>>2]=q;h=b[s>>1]|0;if(!(h<<16>>16)){if((c[t>>2]|0)>>>0>16)xM(f,p,q,380114,390558,0)}else xM(f,p,q,380114,Uh(h)|0,0);h=c[r>>2]|0;a:while(1){if((h|0)==(u|0))break;i=h+16|0;n=i+11|0;if((a[n>>0]|0)<0)j=c[i>>2]|0;else j=i;gq(ga,f,p,q,j);m=a[v>>0]|0;m=((m<<24>>24<0?c[w>>2]|0:m&255)|0)==0;z5(ga);o=h+28|0;j=h+20|0;b:do if(!m){k=j9(390999)|0;m=a[n>>0]|0;if((k|0)==((m<<24>>24<0?c[j>>2]|0:m&255)|0)?(ZG(i,390999,k)|0)==0:0){if((a[n>>0]|0)<0)j=c[i>>2]|0;else j=i;nt(ia,o,45);if((a[n>>0]|0)<0)i=c[i>>2]|0;gq(aa,f,p,q,i);i=a[y>>0]|0;o=i<<24>>24<0;Ex(ia,o?c[aa>>2]|0:aa,o?c[z>>2]|0:i&255)|0;c[ha>>2]=c[ia>>2];c[ha+4>>2]=c[ia+4>>2];c[ha+8>>2]=c[ia+8>>2];i=0;while(1){if((i|0)==3)break;c[ia+(i<<2)>>2]=0;i=i+1|0}p2(ga,ha);Mc(f,p,q,j,ga,1);z5(ga);O0(ha);z5(aa);O0(ia)}}else{do if((N?(T=j9(384592)|0,m=a[n>>0]|0,(T|0)==((m<<24>>24<0?c[j>>2]|0:m&255)|0)):0)?(ZG(i,384592,T)|0)==0:0){j=a[h+36+3>>0]|0;if(j<<24>>24<0){m=c[o>>2]|0;k=c[h+32>>2]|0}else{m=o;k=j&255}j=i9(39708)|0;if(j|0?(ka=m+(k<<2)|0,k=HA(m,ka,39708,39708+(j<<2)|0)|0,!((k|0)!=(ka|0)&(k|0)==(m|0))):0)break;$x(ga,f,2,q,122,1);k=sm(ga,10)|0;z5(ga);if(!(k<<24>>24))break b;lw(ha,o,17,-1);p2(ga,ha);i=sm(ga,10)|0;z5(ga);O0(ha);j=nI(k,i)|0;if(!(j<<24>>24))break b;mL(f,2,q,126,j,10,0);RB(f,2,q,130,pG(k,i)|0,-1,1,0);RB(f,2,q,129,lG(k,i)|0,-1,1,0);break b}while(0);if((a[n>>0]|0)<0)j=c[i>>2]|0;else j=i;Mc(f,p,q,j,o,1);if((a[n>>0]|0)<0)i=c[i>>2]|0;Sn(ga,o);Ou(f,p,q,i,(a[x>>0]|0)<0?c[ga>>2]|0:ga);a1(ga)}while(0);i=c[h+4>>2]|0;if(!i)while(1){i=c[h+8>>2]|0;if((c[i>>2]|0)==(h|0)){h=i;continue a}else h=i}else h=i;while(1){i=c[h>>2]|0;if(!i)break;else h=i}}do if(!(b[R>>1]|0)){$x(ga,f,p,q,10,1);ka=(oH(ga,45,0)|0)==-1;z5(ga);if(ka){lL(f,p,q,10,g,10,1);LU(ga,g,0);zb(f,p,q,11,ga,1);z5(ga);h=0;break}$x(ga,f,p,q,10,1);h=oH(ga,45,0)|0;if((h|0)!=-1){ka=(a[A>>0]|0)<0?c[ga>>2]|0:ga;ny(ga,0,ka+(h<<2)+4-ka>>2)|0}$x(ha,f,p,q,11,1);h=oH(ha,45,0)|0;if((h|0)!=-1){ka=(a[C>>0]|0)<0?c[ha>>2]|0:ha;ny(ha,0,ka+(h<<2)+4-ka>>2)|0}sU(ca,g,10);Gx(ca,45);c[ba>>2]=c[ca>>2];c[ba+4>>2]=c[ca+4>>2];c[ba+8>>2]=c[ca+8>>2];h=0;while(1){if((h|0)==3)break;c[ca+(h<<2)>>2]=0;h=h+1|0}h=a[A>>0]|0;ka=h<<24>>24<0;Ex(ba,ka?c[ga>>2]|0:ga,ka?c[B>>2]|0:h&255)|0;c[aa>>2]=c[ba>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];h=0;while(1){if((h|0)==3)break;c[ba+(h<<2)>>2]=0;h=h+1|0}p2(ia,aa);zb(f,p,q,10,ia,1);z5(ia);O0(aa);O0(ba);z5(ca);LU(ca,g,0);Gx(ca,45);c[ba>>2]=c[ca>>2];c[ba+4>>2]=c[ca+4>>2];c[ba+8>>2]=c[ca+8>>2];h=0;while(1){if((h|0)==3)break;c[ca+(h<<2)>>2]=0;h=h+1|0}h=a[C>>0]|0;ka=h<<24>>24<0;Ex(ba,ka?c[ha>>2]|0:ha,ka?c[D>>2]|0:h&255)|0;c[aa>>2]=c[ba>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];h=0;while(1){if((h|0)==3)break;c[ba+(h<<2)>>2]=0;h=h+1|0}p2(ia,aa);zb(f,p,q,11,ia,1);z5(ia);O0(aa);O0(ba);z5(ca);z5(ha);z5(ga);h=0}else{$x(ga,f,1,q,24,1);rU(ba,b[R>>1]|0,10);HX(ba,41840)|0;c[aa>>2]=c[ba>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];h=0;while(1){if((h|0)==3)break;c[ba+(h<<2)>>2]=0;h=h+1|0}sU(ca,g,10);h=a[E>>0]|0;ka=h<<24>>24<0;Ex(aa,ka?c[ca>>2]|0:ca,ka?c[F>>2]|0:h&255)|0;c[ia>>2]=c[aa>>2];c[ia+4>>2]=c[aa+4>>2];c[ia+8>>2]=c[aa+8>>2];h=0;while(1){if((h|0)==3)break;c[aa+(h<<2)>>2]=0;h=h+1|0}p2(ha,ia);zb(f,1,q,10,ha,1);z5(ha);O0(ia);z5(ca);O0(aa);z5(ba);LU(ba,e[R>>1]|0,0);HX(ba,41840)|0;c[aa>>2]=c[ba>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];h=0;while(1){if((h|0)==3)break;c[ba+(h<<2)>>2]=0;h=h+1|0}LU(ca,g,0);h=a[G>>0]|0;ka=h<<24>>24<0;Ex(aa,ka?c[ca>>2]|0:ca,ka?c[H>>2]|0:h&255)|0;c[ia>>2]=c[aa>>2];c[ia+4>>2]=c[aa+4>>2];c[ia+8>>2]=c[aa+8>>2];h=0;while(1){if((h|0)==3)break;c[aa+(h<<2)>>2]=0;h=h+1|0}p2(ha,ia);zb(f,1,q,11,ha,1);z5(ha);O0(ia);z5(ca);O0(aa);z5(ba);ka=a[I>>0]|0;if(((ka<<24>>24<0?c[J>>2]|0:ka&255)|0?(U=c[(c[(c[X>>2]|0)+80>>2]|0)+(e[R>>1]<<2)>>2]|0,U|0):0)?(V=c[U>>2]|0,V|0):0){$x(ba,V,1,0,24,1);HX(ba,41840)|0;c[aa>>2]=c[ba>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];h=0;while(1){if((h|0)==3)break;c[ba+(h<<2)>>2]=0;h=h+1|0}h=a[I>>0]|0;ka=h<<24>>24<0;Ex(aa,ka?c[ga>>2]|0:ga,ka?c[J>>2]|0:h&255)|0;c[ia>>2]=c[aa>>2];c[ia+4>>2]=c[aa+4>>2];c[ia+8>>2]=c[aa+8>>2];h=0;while(1){if((h|0)==3)break;c[aa+(h<<2)>>2]=0;h=h+1|0}p2(ha,ia);zb(f,1,q,24,ha,1);z5(ha);O0(ia);O0(aa);z5(ba)}z5(ga);h=0}while(0);while(1){i=c[P>>2]|0;if(h>>>0>=(c[Q>>2]|0)-i>>1>>>0)break;ka=(h|0)==0;kL(f,p,q,16,b[i+(h<<1)>>1]|0,10,ka);LU(ga,e[(c[P>>2]|0)+(h<<1)>>1]|0,0);zb(f,p,q,17,ga,ka);z5(ga);h=h+1|0}Ed(f,p,q,7);n=0;while(1){h=c[P>>2]|0;if(n>>>0>=(c[Q>>2]|0)-h>>1>>>0)break;b[ga>>1]=b[h+(n<<1)>>1]|0;h=c[X>>2]|0;h=HD(h+68|0,h)|0;j=c[h+28>>2]|0;h=(c[h+32>>2]|0)-j>>1;i=b[ga>>1]|0;m=0;while(1){if(m>>>0>=h>>>0)break;if((b[j+(m<<1)>>1]|0)==i<<16>>16){Y=160;break}m=m+1|0}c:do if((Y|0)==160){Y=0;k=c[X>>2]|0;k=$C((HD(k+68|0,k)|0)+16|0,ga)|0;j=k+52|0;k=k+56|0;i=0;while(1){h=c[j>>2]|0;if(i>>>0>=(c[k>>2]|0)-h>>1>>>0)break c;if((e[h+(i<<1)>>1]|0)==(g|0)){sU(ba,m,10);Gx(ba,45);c[aa>>2]=c[ba>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];h=0;while(1){if((h|0)==3)break;c[ba+(h<<2)>>2]=0;h=h+1|0}sU(ca,i,10);h=a[K>>0]|0;ka=h<<24>>24<0;Ex(aa,ka?c[ca>>2]|0:ca,ka?c[L>>2]|0:h&255)|0;c[ia>>2]=c[aa>>2];c[ia+4>>2]=c[aa+4>>2];c[ia+8>>2]=c[aa+8>>2];h=0;while(1){if((h|0)==3)break;c[aa+(h<<2)>>2]=0;h=h+1|0}p2(ha,ia);zb(f,p,q,7,ha,0);z5(ha);O0(ia);z5(ca);O0(aa);z5(ba)}i=i+1|0}}while(0);n=n+1|0}if(O?(W=c[fa>>2]|0,W|0):0)RA(W,3,-1)|0;q=q+1|0}p=p+1|0}GJ(r);GJ(fa+40|0);h=c[fa>>2]|0;if(h|0)if(!(RA(h,1,-1)|0))Y=208;else{n=RA(c[fa>>2]|0,3,-1)|0;o=ga+8+3|0;p=ga+4|0;q=aa+8+3|0;r=aa+4|0;s=ha+8+3|0;t=ha+4|0;u=ba+8+3|0;v=ba+4|0;w=ca+8+3|0;x=ca+4|0;y=f+492|0;m=0;while(1){if(m>>>0>=n>>>0)break;$x(ga,c[fa>>2]|0,3,m,10,1);if((oH(ga,45,0)|0)!=-1){ka=(a[o>>0]|0)<0?c[ga>>2]|0:ga;ny(ga,0,ka+((oH(ga,45,0)|0)<<2)+4-ka>>2)|0}$x(ba,f,1,c[ea>>2]|0,10,1);Gx(ba,45);c[aa>>2]=c[ba>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];h=0;while(1){if((h|0)==3)break;c[ba+(h<<2)>>2]=0;h=h+1|0}h=a[o>>0]|0;ka=h<<24>>24<0;Ex(aa,ka?c[ga>>2]|0:ga,ka?c[p>>2]|0:h&255)|0;c[ia>>2]=c[aa>>2];c[ia+4>>2]=c[aa+4>>2];c[ia+8>>2]=c[aa+8>>2];h=0;while(1){if((h|0)==3)break;c[aa+(h<<2)>>2]=0;h=h+1|0}p2(ha,ia);O0(ia);O0(aa);z5(ba);$x(ca,f,1,c[ea>>2]|0,11,1);Gx(ca,45);c[ba>>2]=c[ca>>2];c[ba+4>>2]=c[ca+4>>2];c[ba+8>>2]=c[ca+8>>2];h=0;while(1){if((h|0)==3)break;c[ca+(h<<2)>>2]=0;h=h+1|0}h=a[o>>0]|0;ka=h<<24>>24<0;Ex(ba,ka?c[ga>>2]|0:ga,ka?c[p>>2]|0:h&255)|0;c[aa>>2]=c[ba>>2];c[aa+4>>2]=c[ba+4>>2];c[aa+8>>2]=c[ba+8>>2];h=0;while(1){if((h|0)==3)break;c[ba+(h<<2)>>2]=0;h=h+1|0}p2(ia,aa);O0(aa);O0(ba);z5(ca);c[Z>>2]=-1;k=0;d:while(1){if(k>>>0>=(RA(f,3,-1)|0)>>>0){Y=203;break}$x(aa,f,3,k,10,1);i=a[q>>0]|0;h=i<<24>>24<0;i=h?c[r>>2]|0:i&255;ka=a[s>>0]|0;j=ka<<24>>24<0;do if((i|0)==((j?c[t>>2]|0:ka&255)|0)?(L$(h?c[aa>>2]|0:aa,j?c[ha>>2]|0:ha,i)|0)==0:0){gq(ba,f,3,k,382758);gq(ca,c[fa>>2]|0,3,m,382758);i=a[u>>0]|0;h=i<<24>>24<0;i=h?c[v>>2]|0:i&255;ka=a[w>>0]|0;j=ka<<24>>24<0;if((i|0)==((j?c[x>>2]|0:ka&255)|0)){ka=(L$(h?c[ba>>2]|0:ba,j?c[ca>>2]|0:ca,i)|0)==0;z5(ca);z5(ba);z5(aa);if(ka){Y=200;break d}else break}else{z5(ca);z5(ba);z5(aa);break}}else Y=199;while(0);if((Y|0)==199){Y=0;z5(aa)}k=k+1|0}if((Y|0)==200){Y=0;c[Z>>2]=k}else if((Y|0)==203?(Y=0,(c[Z>>2]|0)==-1):0)Kc(f,3,-1)|0;if(!(a[y>>0]|0)){ka=c[Z>>2]|0;TX(ca);Gk(ca,(c[ea>>2]|0)+1|0,10)|0;ms(ba,28664,ca);p2(aa,ba);Mc(f,3,ka,379121,aa,1);z5(aa);O0(ba);z5(ca)}Gb(f,c[fa>>2]|0,3,m,c[Z>>2]|0,1)|0;zb(f,3,c[Z>>2]|0,10,ha,1);zb(f,3,c[Z>>2]|0,11,ia,1);ka=c[Z>>2]|0;$x(aa,f,1,c[ea>>2]|0,7,1);zb(f,3,ka,7,aa,1);z5(aa);ka=c[Z>>2]|0;$x(aa,f,1,c[ea>>2]|0,16,1);zb(f,3,ka,16,aa,1);z5(aa);ka=c[Z>>2]|0;$x(aa,f,1,c[ea>>2]|0,17,1);zb(f,3,ka,17,aa,1);z5(aa);ka=c[Z>>2]|0;$x(aa,f,1,c[ea>>2]|0,76,1);zb(f,3,ka,42,aa,1);z5(aa);ka=c[Z>>2]|0;$x(aa,f,1,c[ea>>2]|0,217,1);zb(f,3,ka,126,aa,1);z5(aa);ka=c[Z>>2]|0;$x(aa,f,1,c[ea>>2]|0,226,1);zb(f,3,ka,135,aa,1);z5(aa);z5(ia);z5(ha);z5(ga);m=m+1|0}c[_>>2]=c[da>>2];c[Z>>2]=c[ea>>2];Y=208}}if((Y|0)==208?($=c[fa>>2]|0,$|0):0){$x(ga,$,0,0,250,1);ka=a[ga+8+3>>0]|0;do if((ka<<24>>24<0?c[ga+4>>2]|0:ka&255)|0){if(!(RA(f,6,-1)|0)){zb(f,0,0,250,ga,1);break}$x(ha,f,c[da>>2]|0,c[ea>>2]|0,16,1);i=ia+8+3|0;j=ia+4|0;k=ha+8+3|0;m=ha+4|0;h=0;while(1){if(h>>>0>=(RA(f,6,-1)|0)>>>0)break;$x(ia,f,6,h,16,1);o=a[i>>0]|0;n=o<<24>>24<0;o=n?c[j>>2]|0:o&255;ka=a[k>>0]|0;p=ka<<24>>24<0;if((o|0)==((p?c[m>>2]|0:ka&255)|0)){ka=(L$(n?c[ia>>2]|0:ia,p?c[ha>>2]|0:ha,o)|0)==0;z5(ia);if(ka)Mc(f,6,h,378427,ga,1)}else z5(ia);h=h+1|0}z5(ha)}while(0);z5(ga);h=c[fa>>2]|0;if(h|0){$x(ga,h,0,0,159,1);ka=a[ga+8+3>>0]|0;do if((ka<<24>>24<0?c[ga+4>>2]|0:ka&255)|0?($x(ha,f,0,0,159,1),ka=a[ha+8+3>>0]|0,ka=((ka<<24>>24<0?c[ha+4>>2]|0:ka&255)|0)==0,z5(ha),ka):0){if(!(RA(f,6,-1)|0)){zb(f,0,0,159,ga,0);break}$x(ha,f,c[da>>2]|0,c[ea>>2]|0,16,1);i=ia+8+3|0;j=ia+4|0;k=ha+8+3|0;m=ha+4|0;h=0;while(1){if(h>>>0>=(RA(f,6,-1)|0)>>>0)break;$x(ia,f,6,h,16,1);o=a[i>>0]|0;n=o<<24>>24<0;o=n?c[j>>2]|0:o&255;ka=a[k>>0]|0;p=ka<<24>>24<0;if((o|0)==((p?c[m>>2]|0:ka&255)|0)){ka=(L$(n?c[ia>>2]|0:ia,p?c[ha>>2]|0:ha,o)|0)==0;z5(ia);if(ka)Mc(f,6,h,380183,ga,1)}else z5(ia);h=h+1|0}z5(ha)}while(0);z5(ga)}}}l=ja;return}function Ib(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;C=l;l=l+192|0;z=C+172|0;A=C+160|0;B=C+120|0;w=C+108|0;x=C+96|0;y=C+84|0;v=C+72|0;u=C+60|0;o=C+48|0;p=C+36|0;q=C+24|0;r=C+12|0;s=C;$x(z,b,d,e,f,0);$x(A,b,d,e,f,1);k=SU(vn(d)|0,f,2)|0;g=i9(7820)|0;m=k+8+3|0;i=a[m>>0]|0;n=k+4|0;h=c[n>>2]|0;j=(d|0)==1;do if((g|0)==((i<<24>>24<0?h:i&255)|0))if(!(VG(k,7820,g)|0)){jc(b,d,e,f);o=j;break}else{i=a[m>>0]|0;h=c[n>>2]|0;t=5;break}else t=5;while(0);a:do if((t|0)==5){g=i9(7844)|0;if((g|0)==((i<<24>>24<0?h:i&255)|0)){if(VG(k,7844,g)|0){i=a[m>>0]|0;h=c[n>>2]|0;t=8}}else t=8;do if((t|0)==8){g=i9(7864)|0;if((g|0)==((i<<24>>24<0?h:i&255)|0)){if(!(VG(k,7864,g)|0))break;i=a[m>>0]|0;h=c[n>>2]|0}g=i9(7880)|0;do if((g|0)==((i<<24>>24<0?h:i&255)|0))if(!(VG(k,7880,g)|0)){Mb(b,d,e,f);o=j;break a}else{i=a[m>>0]|0;h=c[n>>2]|0;break}while(0);g=i9(30156)|0;if((g|0)==((i<<24>>24<0?h:i&255)|0)?(VG(k,30156,g)|0)==0:0){nH(b,d,e,f);o=j;break a}Ih(b,d,e,f);if(!j){o=0;break a}g=i9(7896)|0;t=a[m>>0]|0;do if((g|0)==((t<<24>>24<0?c[n>>2]|0:t&255)|0)?(VG(k,7896,g)|0)==0:0){$x(B,b,1,e,171,1);if((pn(B)|0)!=120){z5(B);break}$x(w,b,1,e,175,1);if((pn(w)|0)!=24){z5(w);z5(B);break}$x(x,b,1,e,179,1);t=(pn(x)|0)==30;z5(x);z5(w);z5(B);if(t){h=c[b+20>>2]|0;$x(y,b,1,e,171,1);HX(y,7916)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);Xy(v,7896);ne(B,w,v,0);zb(b,1,h,172,B,1);z5(B);z5(v);z5(w);O0(x);z5(y)}}while(0);if((f|0)==171){$x(B,b,1,e,171,1);t=a[B+8+3>>0]|0;if(!((t<<24>>24<0?c[B+4>>2]|0:t&255)|0)){z5(B);o=1;break a}$x(w,b,1,e,173,1);t=a[w+8+3>>0]|0;if(!((t<<24>>24<0?c[w+4>>2]|0:t&255)|0)){z5(w);z5(B);o=1;break a}$x(x,b,1,e,174,1);t=a[x+8+3>>0]|0;t=((t<<24>>24<0?c[x+4>>2]|0:t&255)|0)==0;z5(x);z5(w);z5(B);if(t){o=1;break a}$x(p,b,1,e,171,1);HX(p,39932)|0;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];g=0;while(1){if((g|0)==3)break;c[p+(g<<2)>>2]=0;g=g+1|0}$x(q,b,1,e,173,1);g=a[q+8+3>>0]|0;t=g<<24>>24<0;Ex(o,t?c[q>>2]|0:q,t?c[q+4>>2]|0:g&255)|0;c[u>>2]=c[o>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];g=0;while(1){if((g|0)==3)break;c[o+(g<<2)>>2]=0;g=g+1|0}HX(u,42012)|0;c[v>>2]=c[u>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}$x(r,b,1,e,174,1);g=a[r+8+3>>0]|0;t=g<<24>>24<0;Ex(v,t?c[r>>2]|0:r,t?c[r+4>>2]|0:g&255)|0;c[y>>2]=c[v>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}HX(y,39944)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);Xy(s,7896);ne(B,w,s,0);zb(b,1,e,172,B,1);z5(B);z5(s);z5(w);O0(x);O0(y);z5(r);O0(v);O0(u);z5(q);O0(o);z5(p)}if((f|0)!=181){o=1;break a}$x(B,b,1,e,181,1);t=a[B+8+3>>0]|0;if(!((t<<24>>24<0?c[B+4>>2]|0:t&255)|0)){z5(B);o=1;break a}$x(w,b,1,e,183,1);t=a[w+8+3>>0]|0;if(!((t<<24>>24<0?c[w+4>>2]|0:t&255)|0)){z5(w);z5(B);o=1;break a}$x(x,b,1,e,184,1);t=a[x+8+3>>0]|0;t=((t<<24>>24<0?c[x+4>>2]|0:t&255)|0)==0;z5(x);z5(w);z5(B);if(t){o=1;break a}$x(p,b,1,e,181,1);HX(p,39932)|0;c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];g=0;while(1){if((g|0)==3)break;c[p+(g<<2)>>2]=0;g=g+1|0}$x(q,b,1,e,183,1);g=a[q+8+3>>0]|0;t=g<<24>>24<0;Ex(o,t?c[q>>2]|0:q,t?c[q+4>>2]|0:g&255)|0;c[u>>2]=c[o>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];g=0;while(1){if((g|0)==3)break;c[o+(g<<2)>>2]=0;g=g+1|0}HX(u,42012)|0;c[v>>2]=c[u>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];g=0;while(1){if((g|0)==3)break;c[u+(g<<2)>>2]=0;g=g+1|0}$x(r,b,1,e,184,1);g=a[r+8+3>>0]|0;t=g<<24>>24<0;Ex(v,t?c[r>>2]|0:r,t?c[r+4>>2]|0:g&255)|0;c[y>>2]=c[v>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}HX(y,39944)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);Xy(s,7896);ne(B,w,s,0);zb(b,1,e,182,B,1);z5(B);z5(s);z5(w);O0(x);O0(y);z5(r);O0(v);O0(u);z5(q);O0(o);z5(p);o=1;break a}while(0);Cc(b,d,e,f);o=j}while(0);g=(d|0)==0;h=g?7952:8032;i=i9(h)|0;m=z+8+3|0;t=a[m>>0]|0;n=z+4|0;if(((i|0)==((t<<24>>24<0?c[n>>2]|0:t&255)|0)?(VG(z,h,i)|0)==0:0)?NT()|0:0){k=g?357485:357512;mj(b,d,e,k);mI(B);Xy(w,41840);z3(B,w);z5(w);$x(w,b,d,e,f,1);og(B,w);z5(w);i=B+4|0;h=0;while(1){if(h>>>0>=(((c[i>>2]|0)-(c[B>>2]|0)|0)/12|0)>>>0)break;Xy(v,8084);t=c[B>>2]|0;r=t+(h*12|0)|0;g=a[t+(h*12|0)+8+3>>0]|0;s=g<<24>>24<0;Ex(v,s?c[r>>2]|0:r,s?c[t+(h*12|0)+4>>2]|0:g&255)|0;c[y>>2]=c[v>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}p2(x,y);pl(w,x);vF((c[B>>2]|0)+(h*12|0)|0,w)|0;z5(w);z5(x);O0(y);z5(v);h=h+1|0}de(w,B);g=a[w+8+3>>0]|0;h=g<<24>>24<0;i=h?c[w>>2]|0:w;j=i9(8084)|0;if(!j)g=0;else{t=i+((h?c[w+4>>2]|0:g&255)<<2)|0;g=HA(i,t,8084,8084+(j<<2)|0)|0;g=(g|0)==(t|0)?-1:g-i>>2}Mc(b,d,e,k,g|0?w:A,0);z5(w);$_(B)}g=i9(8140)|0;h=a[m>>0]|0;i=c[n>>2]|0;if((g|0)==((h<<24>>24<0?i:h&255)|0))if(!(VG(z,8140,g)|0))t=101;else{h=a[m>>0]|0;i=c[n>>2]|0;t=90}else t=90;do if((t|0)==90){g=i9(8220)|0;if((g|0)==((h<<24>>24<0?i:h&255)|0)){if(!(VG(z,8220,g)|0)){t=101;break}h=a[m>>0]|0;i=c[n>>2]|0}g=i9(8348)|0;if((g|0)==((h<<24>>24<0?i:h&255)|0)){if(!(VG(z,8348,g)|0)){t=101;break}h=a[m>>0]|0;i=c[n>>2]|0}g=i9(8448)|0;if((g|0)==((h<<24>>24<0?i:h&255)|0)){if(!(VG(z,8448,g)|0)){t=101;break}h=a[m>>0]|0;i=c[n>>2]|0}g=i9(8560)|0;if((g|0)==((h<<24>>24<0?i:h&255)|0)?(VG(z,8560,g)|0)==0:0)t=101}while(0);if((t|0)==101?(gq(B,b,d,e,357532),t=a[B+8+3>>0]|0,t=((t<<24>>24<0?c[B+4>>2]|0:t&255)|0)==0,z5(B),t):0){gq(B,b,d,e,357559);gq(w,b,d,e,357591);gq(x,b,d,e,357616);gq(y,b,d,e,357644);g=w+8+3|0;t=a[g>>0]|0;h=w+4|0;if(!((t<<24>>24<0?c[h>>2]|0:t&255)|0)){gq(v,b,d,e,377532);Mc(b,d,e,357532,v,1);z5(v)}else{TX(v);j=a[B+8+3>>0]|0;i=j<<24>>24<0;j=i?c[B+4>>2]|0:j&255;if(j|0){Ex(v,i?c[B>>2]|0:B,j)|0;HX(v,42252)|0}g=a[g>>0]|0;t=g<<24>>24<0;Ex(v,t?c[w>>2]|0:w,t?c[h>>2]|0:g&255)|0;g=x+8+3|0;t=a[g>>0]|0;h=x+4|0;if((t<<24>>24<0?c[h>>2]|0:t&255)|0){HX(v,42252)|0;t=a[g>>0]|0;s=t<<24>>24<0;Ex(v,s?c[x>>2]|0:x,s?c[h>>2]|0:t&255)|0}g=y+8+3|0;t=a[g>>0]|0;h=y+4|0;if((t<<24>>24<0?c[h>>2]|0:t&255)|0){HX(v,39932)|0;t=a[g>>0]|0;s=t<<24>>24<0;Ex(v,s?c[y>>2]|0:y,s?c[h>>2]|0:t&255)|0;HX(v,39944)|0}Mc(b,d,e,357532,v,1);z5(v)}z5(y);z5(x);z5(w);z5(B)}g=i9(19300)|0;i=a[m>>0]|0;h=c[n>>2]|0;if((g|0)==((i<<24>>24<0?h:i&255)|0))if(!(VG(z,19300,g)|0))t=126;else{i=a[m>>0]|0;h=c[n>>2]|0;t=115}else t=115;do if((t|0)==115){g=i9(8660)|0;if((g|0)==((i<<24>>24<0?h:i&255)|0)){if(!(VG(z,8660,g)|0)){t=126;break}i=a[m>>0]|0;h=c[n>>2]|0}g=i9(8772)|0;if((g|0)==((i<<24>>24<0?h:i&255)|0)){if(!(VG(z,8772,g)|0)){t=126;break}i=a[m>>0]|0;h=c[n>>2]|0}g=i9(8856)|0;if((g|0)==((i<<24>>24<0?h:i&255)|0)){if(!(VG(z,8856,g)|0)){t=126;break}i=a[m>>0]|0;h=c[n>>2]|0}g=i9(8952)|0;if((g|0)==((i<<24>>24<0?h:i&255)|0)?(VG(z,8952,g)|0)==0:0)t=126}while(0);if((t|0)==126?(gq(B,b,d,e,357669),t=a[B+8+3>>0]|0,t=((t<<24>>24<0?c[B+4>>2]|0:t&255)|0)==0,z5(B),t):0){gq(B,b,d,e,357692);gq(w,b,d,e,357720);gq(x,b,d,e,357741);gq(y,b,d,e,357765);gq(v,b,d,e,387686);kn(u,B,w,x,y,v);Mc(b,d,e,357669,u,1);z5(u);z5(v);z5(y);z5(x);z5(w);z5(B)}m=A+4|0;n=A+8+3|0;if((f|0)==38&o){Xy(y,9036);g=a[n>>0]|0;u=g<<24>>24<0;Ex(y,u?c[A>>2]|0:A,u?c[m>>2]|0:g&255)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);pl(B,w);z5(w);O0(x);z5(y);g=a[B+8+3>>0]|0;h=g<<24>>24<0;i=h?c[B>>2]|0:B;j=i9(9036)|0;if(!j)g=0;else{u=i+((h?c[B+4>>2]|0:g&255)<<2)|0;g=HA(i,u,9036,9036+(j<<2)|0)|0;g=(g|0)==(u|0)?-1:g-i>>2}zb(b,1,e,39,g|0?B:A,0);z5(B)}if((f|0)==197&o){Xy(y,9132);g=a[n>>0]|0;u=g<<24>>24<0;Ex(y,u?c[A>>2]|0:A,u?c[m>>2]|0:g&255)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);pl(B,w);z5(w);O0(x);z5(y);g=a[B+8+3>>0]|0;h=g<<24>>24<0;i=h?c[B>>2]|0:B;j=i9(9132)|0;if(!j)g=0;else{u=i+((h?c[B+4>>2]|0:g&255)<<2)|0;g=HA(i,u,9132,9132+(j<<2)|0)|0;g=(g|0)==(u|0)?-1:g-i>>2}zb(b,1,e,198,g|0?B:A,0);z5(B)}if((f|0)==199&o){Xy(y,9132);g=a[n>>0]|0;u=g<<24>>24<0;Ex(y,u?c[A>>2]|0:A,u?c[m>>2]|0:g&255)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);pl(B,w);z5(w);O0(x);z5(y);g=a[B+8+3>>0]|0;h=g<<24>>24<0;i=h?c[B>>2]|0:B;j=i9(9132)|0;if(!j)g=0;else{u=i+((h?c[B+4>>2]|0:g&255)<<2)|0;g=HA(i,u,9132,9132+(j<<2)|0)|0;g=(g|0)==(u|0)?-1:g-i>>2}zb(b,1,e,200,g|0?B:A,0);z5(B)}if((f|0)==201&o){Xy(x,9180);g=a[n>>0]|0;u=g<<24>>24<0;Ex(x,u?c[A>>2]|0:A,u?c[m>>2]|0:g&255)|0;c[w>>2]=c[x>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];g=0;while(1){if((g|0)==3)break;c[x+(g<<2)>>2]=0;g=g+1|0}p2(B,w);O0(w);z5(x);$x(w,b,1,e,202,1);u=a[w+8+3>>0]|0;u=((u<<24>>24<0?c[w+4>>2]|0:u&255)|0)==0;z5(w);if(!u){$x(x,b,1,e,202,1);zv(x,(a[x+8+3>>0]|0)<0?c[x>>2]|0:x,95);c[w>>2]=c[x>>2];c[w+4>>2]=c[x+4>>2];c[w+8>>2]=c[x+8>>2];g=0;while(1){if((g|0)==3)break;c[x+(g<<2)>>2]=0;g=g+1|0}u=a[w+8+3>>0]|0;t=u<<24>>24<0;Ex(B,t?c[w>>2]|0:w,t?c[w+4>>2]|0:u&255)|0;O0(w);z5(x)}pl(w,B);g=a[w+8+3>>0]|0;h=g<<24>>24<0;i=h?c[w>>2]|0:w;j=i9(9180)|0;if(!j)g=0;else{u=i+((h?c[w+4>>2]|0:g&255)<<2)|0;g=HA(i,u,9180,9180+(j<<2)|0)|0;g=(g|0)==(u|0)?-1:g-i>>2}zb(b,1,e,203,g|0?w:A,0);z5(w);z5(B)}if((f|0)==204&o){Xy(y,9132);g=a[n>>0]|0;u=g<<24>>24<0;Ex(y,u?c[A>>2]|0:A,u?c[m>>2]|0:g&255)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);pl(B,w);z5(w);O0(x);z5(y);g=a[B+8+3>>0]|0;h=g<<24>>24<0;i=h?c[B>>2]|0:B;j=i9(9132)|0;if(!j)g=0;else{u=i+((h?c[B+4>>2]|0:g&255)<<2)|0;g=HA(i,u,9132,9132+(j<<2)|0)|0;g=(g|0)==(u|0)?-1:g-i>>2}zb(b,1,e,205,g|0?B:A,0);z5(B)}if((f|0)==206&o){Xy(y,9132);g=a[n>>0]|0;u=g<<24>>24<0;Ex(y,u?c[A>>2]|0:A,u?c[m>>2]|0:g&255)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);pl(B,w);z5(w);O0(x);z5(y);g=a[B+8+3>>0]|0;h=g<<24>>24<0;i=h?c[B>>2]|0:B;j=i9(9132)|0;if(!j)g=0;else{u=i+((h?c[B+4>>2]|0:g&255)<<2)|0;g=HA(i,u,9132,9132+(j<<2)|0)|0;g=(g|0)==(u|0)?-1:g-i>>2}zb(b,1,e,207,g|0?B:A,0);z5(B)}if((f|0)==209&o){Xy(y,9132);g=a[n>>0]|0;u=g<<24>>24<0;Ex(y,u?c[A>>2]|0:A,u?c[m>>2]|0:g&255)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);pl(B,w);z5(w);O0(x);z5(y);g=a[B+8+3>>0]|0;h=g<<24>>24<0;i=h?c[B>>2]|0:B;j=i9(9132)|0;if(!j)g=0;else{u=i+((h?c[B+4>>2]|0:g&255)<<2)|0;g=HA(i,u,9132,9132+(j<<2)|0)|0;g=(g|0)==(u|0)?-1:g-i>>2}zb(b,1,e,210,g|0?B:A,0);z5(B)}if((f|0)==211&o){$x(B,b,1,e,211,1);g=B+8+3|0;u=a[g>>0]|0;h=B+4|0;if(((u<<24>>24<0?c[h>>2]|0:u&255)|0)==3){Xy(v,9132);g=a[g>>0]|0;u=g<<24>>24<0;Ex(v,u?c[B>>2]|0:B,u?c[h>>2]|0:g&255)|0;c[y>>2]=c[v>>2];c[y+4>>2]=c[v+4>>2];c[y+8>>2]=c[v+8>>2];g=0;while(1){if((g|0)==3)break;c[v+(g<<2)>>2]=0;g=g+1|0}p2(x,y);pl(w,x);zb(b,1,e,212,w,0);z5(w);z5(x);O0(y);z5(v)}else{pl(w,B);zb(b,1,e,212,w,0);z5(w)}$x(w,b,1,e,212,1);v=a[w+8+3>>0]|0;v=((v<<24>>24<0?c[w+4>>2]|0:v&255)|0)==0;z5(w);if(v)zb(b,1,e,212,B,1);z5(B)}if((f|0)==167&o){Xy(y,9232);g=a[n>>0]|0;v=g<<24>>24<0;Ex(y,v?c[A>>2]|0:A,v?c[m>>2]|0:g&255)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);pl(B,w);z5(w);O0(x);z5(y);g=a[B+8+3>>0]|0;h=g<<24>>24<0;i=h?c[B>>2]|0:B;j=i9(9232)|0;if(!j)g=0;else{v=i+((h?c[B+4>>2]|0:g&255)<<2)|0;g=HA(i,v,9232,9232+(j<<2)|0)|0;g=(g|0)==(v|0)?-1:g-i>>2}zb(b,1,e,168,g|0?B:A,0);z5(B)}if((Rb(d,60)|0)==(f|0)){Xy(y,9296);g=a[n>>0]|0;v=g<<24>>24<0;Ex(y,v?c[A>>2]|0:A,v?c[m>>2]|0:g&255)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);pl(B,w);z5(w);O0(x);z5(y);k=Rb(d,61)|0;g=a[B+8+3>>0]|0;h=g<<24>>24<0;i=h?c[B>>2]|0:B;j=i9(9296)|0;if(!j)g=0;else{v=i+((h?c[B+4>>2]|0:g&255)<<2)|0;g=HA(i,v,9296,9296+(j<<2)|0)|0;g=(g|0)==(v|0)?-1:g-i>>2}zb(b,d,e,k,g|0?B:A,0);z5(B)}if((Rb(d,72)|0)==(f|0)){Xy(y,9368);g=a[n>>0]|0;v=g<<24>>24<0;Ex(y,v?c[A>>2]|0:A,v?c[m>>2]|0:g&255)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);pl(B,w);z5(w);O0(x);z5(y);k=Rb(d,73)|0;g=a[B+8+3>>0]|0;h=g<<24>>24<0;i=h?c[B>>2]|0:B;j=i9(9368)|0;if(!j)g=A;else{v=i+((h?c[B+4>>2]|0:g&255)<<2)|0;g=HA(i,v,9368,9368+(j<<2)|0)|0;g=(g|0)==(v|0)|(g|0)!=(i|0)?B:A}zb(b,d,e,k,g,0);z5(B)}if((f|2|0)==250&o){Xy(y,9424);g=a[n>>0]|0;d=g<<24>>24<0;Ex(y,d?c[A>>2]|0:A,d?c[m>>2]|0:g&255)|0;c[x>>2]=c[y>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];g=0;while(1){if((g|0)==3)break;c[y+(g<<2)>>2]=0;g=g+1|0}p2(w,x);pl(B,w);z5(w);O0(x);z5(y);g=a[B+8+3>>0]|0;h=g<<24>>24<0;i=h?c[B>>2]|0:B;j=i9(9424)|0;if(!j)g=A;else{y=i+((h?c[B+4>>2]|0:g&255)<<2)|0;g=HA(i,y,9424,9424+(j<<2)|0)|0;g=(g|0)==(y|0)|(g|0)!=(i|0)?B:A}zb(b,1,e,f+1|0,g,1);z5(B)}z5(A);z5(z);l=C;return}function Jb(b,e,f,g,h,i,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=l;l=l+96|0;y=A+84|0;z=A+72|0;r=A+60|0;s=A+48|0;t=A+36|0;u=A+24|0;v=A+12|0;w=A;p=b+112|0;x=p;if(((e|0)!=0|(f|0)!=0)&((c[x>>2]|0)==0&(c[x+4>>2]|0)==0)){x=p;c[x>>2]=e;c[x+4>>2]=f;a[b+2468>>0]=sv(e,0)|0}x=b+22136|0;q=b+2462|0;if(g<<24>>24==-1){if((a[q>>0]|0)!=-1){c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;f=j9(370620)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[y+11>>0]=f;e=y}else{o=f+16&-16;e=ZW(o)|0;c[y>>2]=e;c[y+8>>2]=o|-2147483648;c[y+4>>2]=f}i1(e,370620,f)|0;J7(e+f|0,0);f=gu(x,y)|0;a1(y);k=b+22140|0;if((f|0)==(k|0)){i=0;j=0}else{e=f+28|0;g=a[f+36+3>>0]|0;if(g<<24>>24<0){e=c[e>>2]|0;g=c[f+32>>2]|0}else g=g&255;f=i9(30156)|0;if(!f)e=0;else{n=e+(g<<2)|0;o=HA(e,n,30156,30156+(f<<2)|0)|0;e=(o|0)==(n|0)?-1:o-e>>2}i=1;j=(e|0)!=-1}c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;f=j9(370640)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[y+11>>0]=f;e=y}else{o=f+16&-16;e=ZW(o)|0;c[y>>2]=e;c[y+8>>2]=o|-2147483648;c[y+4>>2]=f}i1(e,370640,f)|0;J7(e+f|0,0);h=gu(x,y)|0;a1(y);if((h|0)==(k|0)){h=i;i=0;k=0;o=30}else{e=h+28|0;f=a[h+36+3>>0]|0;if(f<<24>>24<0){g=c[e>>2]|0;f=c[h+32>>2]|0}else{g=e;f=f&255}e=i9(30156)|0;if(!e)e=0;else{o=g+(f<<2)|0;e=HA(g,o,30156,30156+(e<<2)|0)|0;e=(e|0)==(o|0)?-1:e-g>>2}h=i;i=1;k=(e|0)!=-1;o=30}}}else{a[q>>0]=g;o=30}do if((o|0)==30){n=p;if(!((c[n>>2]|0)==0&(c[n+4>>2]|0)==0)){c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[y+11>>0]=f;e=y}else{n=f+16&-16;e=ZW(n)|0;c[y>>2]=e;c[y+8>>2]=n|-2147483648;c[y+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);m=VC(x,y)|0;n=p;zo(m,c[n>>2]|0,c[n+4>>2]|0)|0;a1(y)}c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;f=j9(384476)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[y+11>>0]=f;e=y}else{n=f+16&-16;e=ZW(n)|0;c[y>>2]=e;c[y+8>>2]=n|-2147483648;c[y+4>>2]=f}i1(e,384476,f)|0;J7(e+f|0,0);f=VC(x,y)|0;cC(f,$o(a[q>>0]|0)|0)|0;a1(y);c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[y+11>>0]=f;e=y}else{n=f+16&-16;e=ZW(n)|0;c[y>>2]=e;c[y+8>>2]=n|-2147483648;c[y+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);f=VC(x,y)|0;cC(f,YN(a[q>>0]|0)|0)|0;a1(y);c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;f=j9(385582)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[y+11>>0]=f;e=y}else{n=f+16&-16;e=ZW(n)|0;c[y>>2]=e;c[y+8>>2]=n|-2147483648;c[y+4>>2]=f}i1(e,385582,f)|0;J7(e+f|0,0);g=VC(x,y)|0;cC(g,yn(a[q>>0]|0)|0)|0;a1(y);g=b+2464|0;if(((a[g>>0]|0)+-1&255)<7){c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;f=j9(384542)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[y+11>>0]=f;e=y}else{n=f+16&-16;e=ZW(n)|0;c[y>>2]=e;c[y+8>>2]=n|-2147483648;c[y+4>>2]=f}i1(e,384542,f)|0;J7(e+f|0,0);f=VC(x,y)|0;Ck(f,a[370659+(d[g>>0]|0)>>0]|0,10)|0;a1(y);c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;f=j9(370675)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[y+11>>0]=f;e=y}else{n=f+16&-16;e=ZW(n)|0;c[y>>2]=e;c[y+8>>2]=n|-2147483648;c[y+4>>2]=f}i1(e,370675,f)|0;J7(e+f|0,0);f=VC(x,y)|0;cC(f,c[11880+(d[g>>0]<<2)>>2]|0)|0;a1(y);c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;f=j9(370692)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[y+11>>0]=f;e=y}else{n=f+16&-16;e=ZW(n)|0;c[y>>2]=e;c[y+8>>2]=n|-2147483648;c[y+4>>2]=f}i1(e,370692,f)|0;J7(e+f|0,0);f=VC(x,y)|0;cC(f,c[11944+(d[g>>0]<<2)>>2]|0)|0;a1(y);c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;f=j9(370717)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[y+11>>0]=f;e=y}else{n=f+16&-16;e=ZW(n)|0;c[y>>2]=e;c[y+8>>2]=n|-2147483648;c[y+4>>2]=f}i1(e,370717,f)|0;J7(e+f|0,0);n=VC(x,y)|0;cC(n,c[12008+(d[g>>0]<<2)>>2]|0)|0;a1(y)}m=b+2472|0;n=b+2469|0;if(!j){c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;f=j9(370620)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[y+11>>0]=f;e=y}else{j=f+16&-16;e=ZW(j)|0;c[y>>2]=e;c[y+8>>2]=j|-2147483648;c[y+4>>2]=f}i1(e,370620,f)|0;J7(e+f|0,0);g=VC(x,y)|0;j=a[g+8+3>>0]|0;j=((j<<24>>24<0?c[g+4>>2]|0:j&255)|0)==0;a1(y);if(j){if(h){Xy(y,12228);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;f=j9(370620)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[z+11>>0]=f;e=z}else{j=f+16&-16;e=ZW(j)|0;c[z>>2]=e;c[z+8>>2]=j|-2147483648;c[z+4>>2]=f}i1(e,370620,f)|0;J7(e+f|0,0);vF(VC(x,z)|0,y)|0;a1(z);z5(y)}}else o=81}else o=81;if((o|0)==81){Xy(y,12040);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[z+11>>0]=f;e=z}else{j=f+16&-16;e=ZW(j)|0;c[z>>2]=e;c[z+8>>2]=j|-2147483648;c[z+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);vF(VC(x,z)|0,y)|0;a1(z);z5(y);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[z+11>>0]=f;e=z}else{j=f+16&-16;e=ZW(j)|0;c[z>>2]=e;c[z+8>>2]=j|-2147483648;c[z+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);p2(y,VC(x,z)|0);a1(z);if((a[n>>0]|0)==-1)f=c[p>>2]<<1;else f=c[m>>2]|0;do if(f|0){c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;g=j9(384521)|0;if(g>>>0>4294967279)uaa();if(g>>>0<11){a[z+11>>0]=g;e=z}else{j=g+16&-16;e=ZW(j)|0;c[z>>2]=e;c[z+8>>2]=j|-2147483648;c[z+4>>2]=g}i1(e,384521,g)|0;J7(e+g|0,0);Gk(VC(x,z)|0,f,10)|0;a1(z);if(!(tT()|0))break;c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[z+11>>0]=f;e=z}else{j=f+16&-16;e=ZW(j)|0;c[z>>2]=e;c[z+8>>2]=j|-2147483648;c[z+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);HX(VC(x,z)|0,12068)|0;a1(z);ms(z,41840,y);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[r+11>>0]=f;e=r}else{j=f+16&-16;e=ZW(j)|0;c[r>>2]=e;c[r+8>>2]=j|-2147483648;c[r+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);f=VC(x,r)|0;j=a[z+8+3>>0]|0;g=j<<24>>24<0;Ex(f,g?c[z>>2]|0:z,g?c[z+4>>2]|0:j&255)|0;a1(r);O0(z)}while(0);Xy(z,h?39568:12092);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[r+11>>0]=f;e=r}else{j=f+16&-16;e=ZW(j)|0;c[r>>2]=e;c[r+8>>2]=j|-2147483648;c[r+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);vF(VC(x,r)|0,z)|0;a1(r);z5(z);Xy(z,h?12108:12168);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;f=j9(370620)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[r+11>>0]=f;e=r}else{j=f+16&-16;e=ZW(j)|0;c[r>>2]=e;c[r+8>>2]=j|-2147483648;c[r+4>>2]=f}i1(e,370620,f)|0;J7(e+f|0,0);vF(VC(x,r)|0,z)|0;a1(r);z5(z);TX(s);cC(s,yn(a[q>>0]|0)|0)|0;Bs(r,s,12208);p2(z,r);c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;f=j9(385582)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[t+11>>0]=f;e=t}else{j=f+16&-16;e=ZW(j)|0;c[t>>2]=e;c[t+8>>2]=j|-2147483648;c[t+4>>2]=f}i1(e,385582,f)|0;J7(e+f|0,0);vF(VC(x,t)|0,z)|0;a1(t);z5(z);O0(r);z5(s);z5(y)}if(!k){c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;f=j9(370640)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[y+11>>0]=f;e=y}else{j=f+16&-16;e=ZW(j)|0;c[y>>2]=e;c[y+8>>2]=j|-2147483648;c[y+4>>2]=f}i1(e,370640,f)|0;J7(e+f|0,0);k=VC(x,y)|0;j=a[k+8+3>>0]|0;j=((j<<24>>24<0?c[k+4>>2]|0:j&255)|0)==0;a1(y);if(j){if(!i)break;Xy(y,12228);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;f=j9(370640)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[z+11>>0]=f;e=z}else{w=f+16&-16;e=ZW(w)|0;c[z>>2]=e;c[z+8>>2]=w|-2147483648;c[z+4>>2]=f}i1(e,370640,f)|0;J7(e+f|0,0);vF(VC(x,z)|0,y)|0;a1(z);z5(y);break}}Xy(y,12284);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[z+11>>0]=f;e=z}else{j=f+16&-16;e=ZW(j)|0;c[z>>2]=e;c[z+8>>2]=j|-2147483648;c[z+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);vF(VC(x,z)|0,y)|0;a1(z);z5(y);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;f=j9(384542)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[z+11>>0]=f;e=z}else{j=f+16&-16;e=ZW(j)|0;c[z>>2]=e;c[z+8>>2]=j|-2147483648;c[z+4>>2]=f}i1(e,384542,f)|0;J7(e+f|0,0);p2(y,VC(x,z)|0);a1(z);c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;f=j9(370675)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[r+11>>0]=f;e=r}else{j=f+16&-16;e=ZW(j)|0;c[r>>2]=e;c[r+8>>2]=j|-2147483648;c[r+4>>2]=f}i1(e,370675,f)|0;J7(e+f|0,0);p2(z,VC(x,r)|0);a1(r);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[s+11>>0]=f;e=s}else{j=f+16&-16;e=ZW(j)|0;c[s>>2]=e;c[s+8>>2]=j|-2147483648;c[s+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);p2(r,VC(x,s)|0);a1(s);Xy(s,25220);c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;f=j9(384542)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[t+11>>0]=f;e=t}else{j=f+16&-16;e=ZW(j)|0;c[t>>2]=e;c[t+8>>2]=j|-2147483648;c[t+4>>2]=f}i1(e,384542,f)|0;J7(e+f|0,0);vF(VC(x,t)|0,s)|0;a1(t);z5(s);Xy(s,12320);c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;f=j9(370675)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[t+11>>0]=f;e=t}else{j=f+16&-16;e=ZW(j)|0;c[t>>2]=e;c[t+8>>2]=j|-2147483648;c[t+4>>2]=f}i1(e,370675,f)|0;J7(e+f|0,0);vF(VC(x,t)|0,s)|0;a1(t);z5(s);do if(tT()|0){c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=j9(384616)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[s+11>>0]=f;e=s}else{j=f+16&-16;e=ZW(j)|0;c[s>>2]=e;c[s+8>>2]=j|-2147483648;c[s+4>>2]=f}i1(e,384616,f)|0;J7(e+f|0,0);HX(VC(x,s)|0,12364)|0;a1(s);ms(u,41840,y);HX(u,41840)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];e=0;while(1){if((e|0)==3)break;c[u+(e<<2)>>2]=0;e=e+1|0}e=a[y+8+3>>0]|0;j=e<<24>>24<0;Ex(t,j?c[y>>2]|0:y,j?c[y+4>>2]|0:e&255)|0;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;f=j9(384542)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[v+11>>0]=f;e=v}else{j=f+16&-16;e=ZW(j)|0;c[v>>2]=e;c[v+8>>2]=j|-2147483648;c[v+4>>2]=f}i1(e,384542,f)|0;J7(e+f|0,0);k=VC(x,v)|0;e=a[s+8+3>>0]|0;j=e<<24>>24<0;Ex(k,j?c[s>>2]|0:s,j?c[s+4>>2]|0:e&255)|0;a1(v);O0(s);O0(t);O0(u);ms(u,41840,z);HX(u,41840)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];e=0;while(1){if((e|0)==3)break;c[u+(e<<2)>>2]=0;e=e+1|0}e=a[z+8+3>>0]|0;j=e<<24>>24<0;Ex(t,j?c[z>>2]|0:z,j?c[z+4>>2]|0:e&255)|0;c[s>>2]=c[t>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];e=0;while(1){if((e|0)==3)break;c[t+(e<<2)>>2]=0;e=e+1|0}c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;f=j9(370675)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[v+11>>0]=f;e=v}else{j=f+16&-16;e=ZW(j)|0;c[v>>2]=e;c[v+8>>2]=j|-2147483648;c[v+4>>2]=f}i1(e,370675,f)|0;J7(e+f|0,0);h=VC(x,v)|0;j=a[s+8+3>>0]|0;k=j<<24>>24<0;Ex(h,k?c[s>>2]|0:s,k?c[s+4>>2]|0:j&255)|0;a1(v);O0(s);O0(t);O0(u);if((a[n>>0]|0)==-1)e=c[p>>2]<<1;else e=c[m>>2]|0;if(!e)break;TX(v);Gk(v,e,10)|0;Bs(u,v,41840);e=a[r+8+3>>0]|0;p=e<<24>>24<0;Ex(u,p?c[r>>2]|0:r,p?c[r+4>>2]|0:e&255)|0;c[t>>2]=c[u>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];e=0;while(1){if((e|0)==3)break;c[u+(e<<2)>>2]=0;e=e+1|0}p2(s,t);c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;f=j9(384521)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[w+11>>0]=f;e=w}else{p=f+16&-16;e=ZW(p)|0;c[w>>2]=e;c[w+8>>2]=p|-2147483648;c[w+4>>2]=f}i1(e,384521,f)|0;J7(e+f|0,0);vF(VC(x,w)|0,s)|0;a1(w);z5(s);O0(t);O0(u);z5(v)}while(0);c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[s+11>>0]=f;e=s}else{p=f+16&-16;e=ZW(p)|0;c[s>>2]=e;c[s+8>>2]=p|-2147483648;c[s+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);e=VC(x,s)|0;g=i?39568:12092;f=i9(g)|0;p=a[e+8+3>>0]|0;if((f|0)==((p<<24>>24<0?c[e+4>>2]|0:p&255)|0)){p=(VG(e,g,f)|0)==0;a1(s);if(!p)o=221}else{a1(s);o=221}if((o|0)==221){c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[s+11>>0]=f;e=s}else{p=f+16&-16;e=ZW(p)|0;c[s>>2]=e;c[s+8>>2]=p|-2147483648;c[s+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);o=VC(x,s)|0;p=a[o+8+3>>0]|0;p=((p<<24>>24<0?c[o+4>>2]|0:p&255)|0)==0;a1(s);if(!p){c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[s+11>>0]=f;e=s}else{p=f+16&-16;e=ZW(p)|0;c[s>>2]=e;c[s+8>>2]=p|-2147483648;c[s+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);DW(VC(x,s)|0,0,41840)|0;a1(s)}c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;f=j9(370731)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[s+11>>0]=f;e=s}else{p=f+16&-16;e=ZW(p)|0;c[s>>2]=e;c[s+8>>2]=p|-2147483648;c[s+4>>2]=f}i1(e,370731,f)|0;J7(e+f|0,0);DW(VC(x,s)|0,0,g)|0;a1(s)}Xy(s,i?12108:12168);c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;f=j9(370640)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[t+11>>0]=f;e=t}else{p=f+16&-16;e=ZW(p)|0;c[t>>2]=e;c[t+8>>2]=p|-2147483648;c[t+4>>2]=f}i1(e,370640,f)|0;J7(e+f|0,0);vF(VC(x,t)|0,s)|0;a1(t);z5(s);e=c[b+20>>2]|0;if((e|0)!=-1){$x(s,b,2,e,52,1);TX(v);cC(v,yn(a[q>>0]|0)|0)|0;Bs(u,v,12424);p2(t,u);c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;f=j9(385582)|0;if(f>>>0>4294967279)uaa();if(f>>>0<11){a[w+11>>0]=f;e=w}else{b=f+16&-16;e=ZW(b)|0;c[w>>2]=e;c[w+8>>2]=b|-2147483648;c[w+4>>2]=f}i1(e,385582,f)|0;J7(e+f|0,0);vF(VC(x,w)|0,t)|0;a1(w);z5(t);O0(u);z5(v);z5(s)}z5(r);z5(z);z5(y)}while(0);l=A;return}function Kb(d){d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;Oa=l;l=l+192|0;Ga=Oa+180|0;Ha=Oa+168|0;Ia=Oa+156|0;Ja=Oa+144|0;Ka=Oa+132|0;La=Oa+120|0;Ma=Oa+108|0;Na=Oa+96|0;Ea=Oa+84|0;wa=Oa+72|0;xa=Oa+60|0;ya=Oa+48|0;za=Oa+36|0;Aa=Oa+24|0;Ba=Oa+12|0;Ca=Oa;Da=d+768|0;a:do if((a[d+808>>0]|0)==0?(ua=c[Da>>2]|0,(c[(HD(ua+68|0,ua)|0)+24>>2]|0)>>>0<3):0){f=c[Da>>2]|0;f=c[(HD(f+68|0,f)|0)+16>>2]|0;b:while(1){ua=c[Da>>2]|0;if((f|0)==((HD(ua+68|0,ua)|0)+20|0)){ua=1;break a}if(b[f+16>>1]|0?(c[f+88>>2]|0)!=1212435798:0){ua=0;break a}g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue b}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}}else ua=1;while(0);g=c[Da>>2]|0;f=c[g+188>>2]|0;c:while(1){if((f|0)==(g+192|0))break;h=f+14|0;i=e[h>>1]|0;if(!((!ua?(j=c[(c[g+80>>2]|0)+(i<<2)>>2]|0,(a[j+182>>0]|0)==0):0)?(a[j+183>>0]|0)==0:0)){Hb(d,i);g=c[Da>>2]|0;ta=c[(c[g+80>>2]|0)+(e[h>>1]<<2)>>2]|0;a[ta+182>>0]=0;a[ta+183>>0]=0}h=c[f+4>>2]|0;if(!h)while(1){h=c[f+8>>2]|0;if((c[h>>2]|0)==(f|0)){f=h;continue c}else f=h}else f=h;while(1){h=c[f>>2]|0;if(!h)break;else f=h}}if(a[g+2>>0]|0){kL(d,0,0,10,b[g>>1]|0,10,1);LU(Ga,e[c[Da>>2]>>1]|0,0);zb(d,0,0,11,Ga,1);z5(Ga);g=c[Da>>2]|0}f=a[g+24+3>>0]|0;if(f<<24>>24<0)f=c[g+20>>2]|0;else f=f&255;do if(f|0){zb(d,0,0,310,g+16|0,1);f=c[Da>>2]|0;g=f+16|0;h=f+24+3|0;if((a[h>>0]|0)<0){y7(c[g>>2]|0,0);c[f+20>>2]=0;break}else{y7(g,0);a[h>>0]=0;break}}while(0);g=c[Da>>2]|0;f=a[g+12+3>>0]|0;if(f<<24>>24<0)f=c[g+8>>2]|0;else f=f&255;do if(f|0){zb(d,0,0,311,g+4|0,1);f=c[Da>>2]|0;g=f+4|0;h=f+12+3|0;if((a[h>>0]|0)<0){y7(c[g>>2]|0,0);c[f+8>>2]=0;break}else{y7(g,0);a[h>>0]=0;break}}while(0);TX(Ga);TX(Ha);f=c[Da>>2]|0;h=Ia+8+3|0;i=Ia+4|0;j=Ia+8+3|0;k=Ia+4|0;g=c[f+56>>2]|0;while(1){if((g|0)==(f+60|0))break;Bs(Ia,g+16|0,41840);f=a[h>>0]|0;ta=f<<24>>24<0;Ex(Ga,ta?c[Ia>>2]|0:Ia,ta?c[i>>2]|0:f&255)|0;O0(Ia);Bs(Ia,g+28|0,41840);f=a[j>>0]|0;ta=f<<24>>24<0;Ex(Ha,ta?c[Ia>>2]|0:Ia,ta?c[k>>2]|0:f&255)|0;O0(Ia);f=c[g+4>>2]|0;if(!f)while(1){f=c[g+8>>2]|0;if((c[f>>2]|0)==(g|0))break;else g=f}else while(1){g=c[f>>2]|0;if(!g)break;else f=g}g=f;f=c[Da>>2]|0}f=a[Ga+8+3>>0]|0;f=f<<24>>24<0?c[Ga+4>>2]|0:f&255;if(f|0){FB(Ga,f+-3|0,0);zb(d,0,0,312,Ga,1);FN((c[Da>>2]|0)+56|0)}f=a[Ha+8+3>>0]|0;f=f<<24>>24<0?c[Ha+4>>2]|0:f&255;if(f|0){FB(Ha,f+-3|0,0);zb(d,0,0,313,Ha,1);FN((c[Da>>2]|0)+56|0)}g=c[Da>>2]|0;f=a[g+36+3>>0]|0;if(f<<24>>24<0)f=c[g+32>>2]|0;else f=f&255;do if(f|0){zb(d,0,0,99,g+28|0,1);f=c[Da>>2]|0;g=f+28|0;h=f+36+3|0;if((a[h>>0]|0)<0){y7(c[g>>2]|0,0);c[f+32>>2]=0;break}else{y7(g,0);a[h>>0]=0;break}}while(0);f=c[Da>>2]|0;d:do if((a[f+2>>0]|0)!=0?(n=UD(f+68|0,b[f>>1]|0)|0,(n|0)!=(f+72|0)):0){h=n+16|0;i=n+24|0;j=n+28|0;f=c[i>>2]|0;e:while(1){if((f|0)==(j|0))break;g=f+16|0;if((a[g+11>>0]|0)<0)g=c[g>>2]|0;Mc(d,0,0,g,f+28|0,1);g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue e}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}GJ(i);if((a[h+62>>0]|0?(ta=c[Da>>2]|0,m=UD(ta+108|0,b[n+76>>1]|0)|0,(m|0)!=(ta+112|0)):0)?c[m+28>>2]|0:0){TX(Ia);h=m+24|0;i=Ja+8+3|0;j=Ja+4|0;f=c[m+20>>2]|0;f:while(1){if((f|0)==(h|0))break;Bs(Ja,f+20|0,41596);g=a[i>>0]|0;ta=g<<24>>24<0;Ex(Ia,ta?c[Ja>>2]|0:Ja,ta?c[j>>2]|0:g&255)|0;O0(Ja);g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue f}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}f=a[Ia+8+3>>0]|0;f=f<<24>>24<0?c[Ia+4>>2]|0:f&255;if(f|0)FB(Ia,f+-3|0,0);zb(d,0,0,307,Ia,0);z5(Ia)}N=n+36|0;O=n+40|0;P=d+809|0;Q=za+8+3|0;R=za+4|0;S=Aa+11|0;T=Aa+8|0;U=Aa+4|0;V=Aa+8+3|0;W=Aa+4|0;X=Aa+8+3|0;Y=Aa+4|0;Z=Aa+8+3|0;_=Aa+4|0;$=Ba+8+3|0;aa=Ba+4|0;ba=Aa+8+3|0;ca=Aa+4|0;da=Ca+8+3|0;ea=Ca+4|0;fa=za+8+3|0;ga=za+4|0;ha=Aa+8+3|0;ia=Aa+4|0;ja=Ba+8+3|0;ka=Ba+4|0;la=Aa+8+3|0;ma=Aa+4|0;na=Aa+8+3|0;oa=Aa+4|0;pa=Aa+8+3|0;qa=Aa+4|0;ra=d+20|0;sa=n+44|0;ta=n+48|0;s=n+52|0;t=za+11|0;u=Ka+8+3|0;v=Ka+4|0;w=Ja+8+3|0;x=Ja+4|0;y=La+8+3|0;z=La+4|0;A=Ea+8+3|0;B=Ea+4|0;C=Na+8+3|0;D=Na+4|0;E=Ma+8+3|0;F=Ma+4|0;G=Ia+8+3|0;H=Ia+4|0;I=xa+8+3|0;J=xa+4|0;K=ya+8+3|0;L=ya+4|0;M=d+24|0;f=c[N>>2]|0;g:while(1){if((f|0)==(O|0)){Fa=d;break d}r=f+16|0;if(a[r+83>>0]|0){p=f+72|0;q=f+76|0;h:do if(a[P>>0]|0){g=c[q>>2]|0;k=c[p>>2]|0;j=g-k>>1;h=k;i=0;while(1){if(i>>>0>=j>>>0)break h;o=c[(c[(c[Da>>2]|0)+80>>2]|0)+(e[h+(i<<1)>>1]<<2)>>2]|0;if((c[o+52>>2]|0)==1?a[o+181>>0]|0:0){j=0;break}i=i+1|0}while(1){if(j>>>0>=g-k>>1>>>0)break h;h=e[h+(j<<1)>>1]|0;i=c[(c[(c[Da>>2]|0)+80>>2]|0)+(h<<2)>>2]|0;do if((c[i+56>>2]|0)==3){if(a[i+181>>0]|0){h=k;break}Hb(d,h);g=c[q>>2]|0;h=c[p>>2]|0}else h=k;while(0);j=j+1|0;k=h}}while(0);TX(Ia);TX(Ja);TX(Ka);TX(La);TX(Ma);TX(Na);TX(Ea);TX(wa);TX(xa);TX(ya);n=f+88|0;o=r+85|0;m=0;while(1){g=c[p>>2]|0;if(m>>>0>=(c[q>>2]|0)-g>>1>>>0)break;j=b[g+(m<<1)>>1]|0;k=j&65535;g=c[(c[(c[Da>>2]|0)+80>>2]|0)+(k<<2)>>2]|0;if(!(!ua?!(a[g+181>>0]|0):0))va=97;do if((va|0)==97){va=0;h=c[g+52>>2]|0;g=c[g+60>>2]|0;$x(za,d,h,g,Rb(h,0)|0,1);g=a[Q>>0]|0;h=c[R>>2]|0;if(!((g<<24>>24<0?h:g&255)|0)){VU(Aa,rh(a[(c[(c[(c[Da>>2]|0)+80>>2]|0)+(k<<2)>>2]|0)+168>>0]|0,c[n>>2]|0)|0);vF(za,Aa)|0;z5(Aa);g=a[Q>>0]|0;h=c[R>>2]|0}do if(!((g<<24>>24<0?h:g&255)|0)){h=c[(c[(c[Da>>2]|0)+80>>2]|0)+(k<<2)>>2]|0;c[Aa>>2]=0;c[Aa+4>>2]=0;c[Aa+8>>2]=0;i=j9(384476)|0;if(i>>>0>4294967279)break g;if(i>>>0<11){a[S>>0]=i;g=Aa}else{Pa=i+16&-16;g=ZW(Pa)|0;c[Aa>>2]=g;c[T>>2]=Pa|-2147483648;c[U>>2]=i}i1(g,384476,i)|0;J7(g+i|0,0);g=gu(h+28|0,Aa)|0;a1(Aa);if((g|0)==((c[(c[(c[Da>>2]|0)+80>>2]|0)+(k<<2)>>2]|0)+32|0))break;k1(za,g+28|0)|0}while(0);Pa=a[Q>>0]|0;if(!((Pa<<24>>24<0?c[R>>2]|0:Pa&255)|0))a[o>>0]=1;Bs(Aa,za,41840);Pa=a[V>>0]|0;g=Pa<<24>>24<0;Ex(Ka,g?c[Aa>>2]|0:Aa,g?c[W>>2]|0:Pa&255)|0;O0(Aa);Pa=c[(c[(c[Da>>2]|0)+80>>2]|0)+(k<<2)>>2]|0;g=c[Pa+52>>2]|0;Pa=c[Pa+60>>2]|0;$x(Ba,d,g,Pa,Rb(g,17)|0,1);HX(Ba,41840)|0;c[Aa>>2]=c[Ba>>2];c[Aa+4>>2]=c[Ba+4>>2];c[Aa+8>>2]=c[Ba+8>>2];g=0;while(1){if((g|0)==3)break;c[Ba+(g<<2)>>2]=0;g=g+1|0}g=a[X>>0]|0;Pa=g<<24>>24<0;Ex(Ja,Pa?c[Aa>>2]|0:Aa,Pa?c[Y>>2]|0:g&255)|0;O0(Aa);z5(Ba);g=c[(c[(c[(c[Da>>2]|0)+80>>2]|0)+(k<<2)>>2]|0)+52>>2]|0;if((g|0)!=7){tU(Aa,g,10);Pa=a[na>>0]|0;i=Pa<<24>>24<0;Ex(La,i?c[Aa>>2]|0:Aa,i?c[oa>>2]|0:Pa&255)|0;z5(Aa);sU(Aa,c[(c[(c[(c[Da>>2]|0)+80>>2]|0)+(k<<2)>>2]|0)+60>>2]|0,10);Pa=a[pa>>0]|0;i=Pa<<24>>24<0;Ex(Ma,i?c[Aa>>2]|0:Aa,i?c[qa>>2]|0:Pa&255)|0;z5(Aa)}HX(La,41840)|0;HX(Ma,41840)|0;rU(Ba,j,10);HX(Ba,41840)|0;c[Aa>>2]=c[Ba>>2];c[Aa+4>>2]=c[Ba+4>>2];c[Aa+8>>2]=c[Ba+8>>2];g=0;while(1){if((g|0)==3)break;c[Ba+(g<<2)>>2]=0;g=g+1|0}Pa=a[Z>>0]|0;i=Pa<<24>>24<0;Ex(Na,i?c[Aa>>2]|0:Aa,i?c[_>>2]|0:Pa&255)|0;O0(Aa);z5(Ba);Pa=c[(c[(c[Da>>2]|0)+80>>2]|0)+(k<<2)>>2]|0;gq(Aa,d,c[Pa+52>>2]|0,c[Pa+60>>2]|0,378411);Bs(Ba,Aa,41840);Pa=a[$>>0]|0;i=Pa<<24>>24<0;Ex(Ia,i?c[Ba>>2]|0:Ba,i?c[aa>>2]|0:Pa&255)|0;O0(Ba);LU(Ba,j&65535,0);HX(Ba,39932)|0;Pa=a[Q>>0]|0;j=Pa<<24>>24<0;Ex(Ba,j?c[za>>2]|0:za,j?c[R>>2]|0:Pa&255)|0;Pa=a[ba>>0]|0;if((Pa<<24>>24<0?c[ca>>2]|0:Pa&255)|0){HX(Ba,39968)|0;Pa=a[ba>>0]|0;j=Pa<<24>>24<0;Ex(Ba,j?c[Aa>>2]|0:Aa,j?c[ca>>2]|0:Pa&255)|0}HX(Ba,39944)|0;Bs(Ca,Ba,41840);g=a[da>>0]|0;Pa=g<<24>>24<0;Ex(Ea,Pa?c[Ca>>2]|0:Ca,Pa?c[ea>>2]|0:g&255)|0;O0(Ca);z5(Ba);z5(Aa);z5(za);g=c[(c[(c[Da>>2]|0)+80>>2]|0)+(k<<2)>>2]|0;if(a[g+69>>0]|0){g=g+80|0;ST(za,(+((c[g>>2]|0)>>>0)+4294967296.0*+((c[g+4>>2]|0)>>>0))/27.0e3,6);vF(wa,za)|0;z5(za);g=c[(c[(c[Da>>2]|0)+80>>2]|0)+(k<<2)>>2]|0}if(!g)break;g=c[g>>2]|0;if(!g)break;$x(za,g,0,0,250,1);Pa=a[fa>>0]|0;if((Pa<<24>>24<0?c[ga>>2]|0:Pa&255)|0){Bs(Aa,za,41840);Pa=a[la>>0]|0;j=Pa<<24>>24<0;Ex(xa,j?c[Aa>>2]|0:Aa,j?c[ma>>2]|0:Pa&255)|0;O0(Aa)}$x(Aa,c[c[(c[(c[Da>>2]|0)+80>>2]|0)+(k<<2)>>2]>>2]|0,0,0,159,1);Pa=a[ha>>0]|0;if((Pa<<24>>24<0?c[ia>>2]|0:Pa&255)|0){Bs(Ba,Aa,41840);Pa=a[ja>>0]|0;k=Pa<<24>>24<0;Ex(ya,k?c[Ba>>2]|0:Ba,k?c[ka>>2]|0:Pa&255)|0;O0(Ba)}z5(Aa);z5(za)}while(0);m=m+1|0}p=r+86|0;do if(!(a[r+89>>0]|0)){if(a[p>>0]|0){va=133;break}if(a[r+87>>0]|0){va=133;break}if(a[f+104>>0]|0)va=133}else va=133;while(0);i:do if((va|0)==133){va=0;j:do switch(c[sa>>2]|0){case 0:break i;case 1:{g=c[N>>2]|0;if(a[g+101>>0]|0)break j;if(c[g+32>>2]|0)break j;if(c[g+116>>2]|0)break j;if(a[g+98>>0]|0?(Pa=c[Da>>2]|0,(UD(Pa+108|0,b[g+96>>1]|0)|0)!=(Pa+112|0)):0)break j;if(!(zR(c[M>>2]|0)|0))break i;break}default:{}}while(0);o=f+84|0;g=c[o>>2]|0;if((g|0)==-1){h=c[Da>>2]|0;n=c[h+204>>2]|0;k=c[h+200>>2]|0;i=n-k>>1;j=k;m=n;g=0;while(1){if(g>>>0>=i>>>0){g=m;va=149;break}if((e[r>>1]|0)<(e[j+(g<<1)>>1]|0)){m=g;j=n;va=144;break}g=g+1|0}do if((va|0)==144){while(1){va=0;i=k;if(m>>>0>=j-k>>1>>>0)break;h=($C(N,i+(m<<1)|0)|0)+64|0;c[h>>2]=(c[h>>2]|0)+1;h=c[Da>>2]|0;m=m+1|0;k=c[h+200>>2]|0;j=c[h+204>>2]|0;va=144}Uj(h+200|0,i+(g<<1)|0,r);if((g|0)!=-1)break;g=c[Da>>2]|0;h=g;g=c[g+204>>2]|0;va=149}while(0);do if((va|0)==149){va=0;if((g|0)==(c[h+208>>2]|0)){bz(h+200|0,r);g=-1;break}else{b[g>>1]=b[r>>1]|0;c[h+204>>2]=g+2;g=-1;break}}while(0);Kc(d,6,g)|0;g=c[ra>>2]|0;c[o>>2]=g}else c[ra>>2]=g;Pa=f+92|0;kL(d,6,g,10,b[Pa>>1]|0,10,1);g=c[ra>>2]|0;LU(za,e[Pa>>1]|0,0);zb(d,6,g,11,za,1);z5(za);kL(d,6,c[ra>>2]|0,16,b[r>>1]|0,10,1);g=c[ra>>2]|0;LU(za,e[r>>1]|0,0);zb(d,6,g,17,za,1);z5(za);Ed(d,6,c[ra>>2]|0,7);g=0;while(1){h=c[ta>>2]|0;if(g>>>0>=(c[s>>2]|0)-h>>1>>>0)break;if((b[h+(g<<1)>>1]|0)==(b[r>>1]|0))lL(d,6,c[ra>>2]|0,7,g,10,0);g=g+1|0}i=f+24|0;j=f+28|0;g=c[i>>2]|0;k:while(1){if((g|0)==(j|0))break;h=g+16|0;if((a[h+11>>0]|0)<0)h=c[h>>2]|0;Mc(d,6,c[ra>>2]|0,h,g+28|0,1);h=c[g+4>>2]|0;if(!h)while(1){h=c[g+8>>2]|0;if((c[h>>2]|0)==(g|0)){g=h;continue k}else g=h}else g=h;while(1){h=c[g>>2]|0;if(!h)break;else g=h}}GJ(i);i=f+36|0;j=f+40|0;g=c[i>>2]|0;l:while(1){if((g|0)==(j|0))break;h=g+16|0;if((a[h+11>>0]|0)<0)h=c[h>>2]|0;Mc(d,6,c[ra>>2]|0,h,g+28|0,1);h=c[g+4>>2]|0;if(!h)while(1){h=c[g+8>>2]|0;if((c[h>>2]|0)==(g|0)){g=h;continue l}else g=h}else g=h;while(1){h=c[g>>2]|0;if(!h)break;else g=h}}GJ(i);j=f+48|0;k=f+52|0;g=c[j>>2]|0;m:while(1){if((g|0)==(k|0))break;i=c[ra>>2]|0;h=g+16|0;if((a[h+11>>0]|0)<0)h=c[h>>2]|0;Sn(za,g+28|0);Ou(d,6,i,h,(a[t>>0]|0)<0?c[za>>2]|0:za);a1(za);h=c[g+4>>2]|0;if(!h)while(1){h=c[g+8>>2]|0;if((c[h>>2]|0)==(g|0)){g=h;continue m}else g=h}else g=h;while(1){h=c[g>>2]|0;if(!h)break;else g=h}}GJ(j);g=a[u>>0]|0;g=g<<24>>24<0?c[v>>2]|0:g&255;if(g|0)FB(Ka,g+-3|0,0);zb(d,6,c[ra>>2]|0,18,Ka,1);g=a[w>>0]|0;g=g<<24>>24<0?c[x>>2]|0:g&255;if(g|0)FB(Ja,g+-3|0,0);zb(d,6,c[ra>>2]|0,33,Ja,1);g=a[y>>0]|0;g=g<<24>>24<0?c[z>>2]|0:g&255;if(g|0)FB(La,g+-3|0,0);zb(d,6,c[ra>>2]|0,56,La,1);g=a[A>>0]|0;g=g<<24>>24<0?c[B>>2]|0:g&255;if(g|0)FB(Ea,g+-3|0,0);zb(d,6,c[ra>>2]|0,59,Ea,1);g=a[C>>0]|0;g=g<<24>>24<0?c[D>>2]|0:g&255;if(g|0)FB(Na,g+-3|0,0);zb(d,6,c[ra>>2]|0,58,Na,1);g=a[E>>0]|0;g=g<<24>>24<0?c[F>>2]|0:g&255;if(g|0)FB(Ma,g+-3|0,0);zb(d,6,c[ra>>2]|0,57,Ma,1);g=a[G>>0]|0;g=g<<24>>24<0?c[H>>2]|0:g&255;if(g|0)FB(Ia,g+-3|0,0);zb(d,6,c[ra>>2]|0,61,Ia,1);g=a[I>>0]|0;g=g<<24>>24<0?c[J>>2]|0:g&255;if(g|0)FB(xa,g+-3|0,0);Mc(d,6,c[ra>>2]|0,378427,xa,1);if(c[ra>>2]|0)Ed(d,0,0,250);g=a[K>>0]|0;g=g<<24>>24<0?c[L>>2]|0:g&255;if(g|0)FB(ya,g+-3|0,0);Mc(d,6,c[ra>>2]|0,380183,ya,1);if(!(c[ra>>2]|0))break;Ed(d,0,0,159)}while(0);if(a[p>>0]|0){if(!(RA(d,6,-1)|0))zb(d,0,0,116,wa,1);else zb(d,6,c[ra>>2]|0,46,wa,1);a[p>>0]=0}if((RA(d,6,-1)|0)==2)Ed(d,0,0,116);z5(ya);z5(xa);z5(wa);z5(Ea);z5(Na);z5(Ma);z5(La);z5(Ka);z5(Ja);z5(Ia)}g=c[f+4>>2]|0;if(!g)while(1){g=c[f+8>>2]|0;if((c[g>>2]|0)==(f|0)){f=g;continue g}else f=g}else f=g;while(1){g=c[f>>2]|0;if(!g)break;else f=g}}uaa()}else Fa=d;while(0);do if((RA(Fa,1,-1)|0)==1?(RA(Fa,2,-1)|0)==1:0){$x(Ia,d,1,0,18,1);f=i9(29964)|0;Pa=a[Ia+8+3>>0]|0;if((f|0)==((Pa<<24>>24<0?c[Ia+4>>2]|0:Pa&255)|0)?(VG(Ia,29964,f)|0)==0:0){$x(Ja,d,1,0,22,1);f=a[Ja+8+3>>0]|0;g=f<<24>>24<0;h=g?c[Ja>>2]|0:Ja;i=i9(27944)|0;if(i|0?(Fa=h+((g?c[Ja+4>>2]|0:f&255)<<2)|0,Pa=HA(h,Fa,27944,27944+(i<<2)|0)|0,!((Pa|0)!=(Fa|0)&(Pa|0)==(h|0))):0){z5(Ja);z5(Ia);break}$x(Ka,d,2,0,18,1);f=i9(40168)|0;Pa=a[Ka+8+3>>0]|0;if((f|0)!=((Pa<<24>>24<0?c[Ka+4>>2]|0:Pa&255)|0)){z5(Ka);z5(Ja);z5(Ia);break}if(VG(Ka,40168,f)|0){z5(Ka);z5(Ja);z5(Ia);break}$x(La,d,2,0,23,1);f=i9(40212)|0;Pa=a[La+8+3>>0]|0;if((f|0)!=((Pa<<24>>24<0?c[La+4>>2]|0:Pa&255)|0)){z5(La);z5(Ka);z5(Ja);z5(Ia);break}if(VG(La,40212,f)|0){z5(La);z5(Ka);z5(Ja);z5(Ia);break}$x(Ma,d,2,0,24,1);f=i9(27960)|0;Pa=a[Ma+8+3>>0]|0;if((f|0)!=((Pa<<24>>24<0?c[Ma+4>>2]|0:Pa&255)|0)){z5(Ma);z5(La);z5(Ka);z5(Ja);z5(Ia);break}if(VG(Ma,27960,f)|0){z5(Ma);z5(La);z5(Ka);z5(Ja);z5(Ia);break}$x(Na,d,2,0,112,1);f=i9(27992)|0;Pa=a[Na+8+3>>0]|0;if((f|0)==((Pa<<24>>24<0?c[Na+4>>2]|0:Pa&255)|0))f=(VG(Na,27992,f)|0)==0;else f=0;z5(Na);z5(Ma);z5(La);z5(Ka);z5(Ja);z5(Ia);if(!f)break;$x(Ia,d,1,0,22,1);zb(d,0,0,63,Ia,0);z5(Ia);break}z5(Ia)}while(0);z5(Ha);z5(Ga);l=Oa;return}
function xb(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;a:do if(!(a[b+909>>0]|0)){j=b+520|0;if((c[j>>2]|0)==0&(c[j+4>>2]|0)==0?(j=b+536|0,(c[j>>2]|0)==0&(c[j+4>>2]|0)==0):0)break;i=b+508|0;e=c[i>>2]|0;if(e|0){j=b+668|0;d=c[j>>2]|0;f=$$(d,1)|0;g=z;h=(e|0)==1;b:do if((f|0)<1718909296){if((f|0)<1380271169){if((f|0)<1380210255){if((f|0)<1380204879){switch(f|0){case 1346978644:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){G$(b);break a}else{c3(1,d);break a}}switch(f|0){case 1380204879:{if(g|0)break b;if(!h)break a;if(k2(1,d)|0){G$(b);break a}else{c3(1,d);break a}}case 1380204883:{if(g|0)break b;if(!h)break a;if(k2(1,d)|0){G$(b);break a}else{c3(1,d);break a}}default:break b}}if((f|0)<1380210259){switch(f|0){case 1380210255:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){G$(b);break a}else{c3(1,d);break a}}if((f|0)<1380271153){switch(f|0){case 1380210259:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){G$(b);break a}else{c3(1,d);break a}}else{switch(f|0){case 1380271153:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){mN(b);break a}else{c3(1,d);break a}}}if((f|0)<1651273571)switch(f|0){case 1380271169:{if(g|0)break b;if(!h)break a;if(k2(1,d)|0){kY(b);break a}else{c3(1,d);break a}}case 1380271190:{if(g|0)break b;if(!h)break a;if(k2(1,d)|0){bE(b);break a}else{c3(1,d);break a}}case 1380273986:{if(g|0)break b;if(!h)break a;if(k2(1,d)|0){G$(b);break a}else{c3(1,d);break a}}default:break b}if((f|0)>=1667527730){if((f|0)>=1718773093){switch(f|0){case 1718773093:break;default:break b}if(g|0)break;if(!h)break a;o7(b);cx(b);break a}switch(f|0){case 1667527730:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){w7(b);break a}else{c3(1,d);break a}}if((f|0)<1667522932){switch(f|0){case 1651273571:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){aO(b);break a}else{c3(1,d);break a}}else{switch(f|0){case 1667522932:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){Tn(b);break a}else{c3(1,d);break a}}}else{if((f|0)<1836019558){if((f|0)<1785737827){if((f|0)<1768186228){switch(f|0){case 1718909296:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){ye(b);break a}else{c3(1,d);break a}}if((f|0)<1768190819){switch(f|0){case 1768186228:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){oD(b);break a}else{c3(1,d);break a}}else{switch(f|0){case 1768190819:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){oD(b);break a}else{c3(1,d);break a}}}if((f|0)<1835295092){switch(f|0){case 1785737827:{if(g|0)break b;if(!h)break a;if(k2(1,d)|0)break a;c3(1,d);break a}case 1785737832:break;default:break b}if(g|0)break;if(h){o7(b);d=c[i>>2]|0;if((d|0)==1)break a;e=d;d=c[j>>2]|0}f=$$(d,2)|0;g=z;c:do if((f|0)<1768449138){switch(f|0){case 1668246642:break;default:break c}if(!g){if((e|0)!=2)break a;if(k2(2,d)|0){Mv(b);break a}else{c3(2,d);break a}}}else{switch(f|0){case 1768449138:break;default:break c}if(!g){if((e|0)!=2)break a;if(k2(2,d)|0){BE(b);break a}else{c3(2,d);break a}}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}if((f|0)<1835430497){switch(f|0){case 1835295092:break;default:break b}if(g|0)break;if(h){o7(b);mg(b);d=c[i>>2]|0}else d=e;if((d|0)!=2)break a;d=c[j>>2]|0;if(k2(2,d)|0){zh(b);break a}else{c3(2,d);break a}}switch(f|0){case 1835430497:break;default:break b}if(g|0)break;if(h){o7(b);d=c[i>>2]|0;if((d|0)==1)break a;e=d;d=c[j>>2]|0}f=$$(d,2)|0;g=z;d:do if((f|0)<1952871009){switch(f|0){case 1835430511:break;default:break d}if(!g){if((e|0)!=2)break a;if(k2(2,d)|0){LO(b);break a}else{c3(2,d);break a}}}else{switch(f|0){case 1952871009:break;default:break d}if(!g){if((e|0)!=2)break a;if(k2(2,d)|0){Ji(b);break a}else{c3(2,d);break a}}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}if((f|0)>=1885628782){if((f|0)>=1936419184)if((f|0)<2003395685){switch(f|0){case 1936419184:break;default:break b}if(g|0)break;if(!h)break a;o7(b);G$(b);break a}else{switch(f|0){case 2003395685:break;default:break b}if(g|0)break;if(!h)break a;o7(b);G$(b);break a}if((f|0)<1886285684){switch(f|0){case 1885628782:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){sC(b);break a}else{c3(1,d);break a}}else{switch(f|0){case 1886285684:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){vN(b);break a}else{c3(1,d);break a}}}if((f|0)<1836019574){switch(f|0){case 1836019558:break;default:break b}if(g|0)break;if(h){o7(b);uF(b);d=c[i>>2]|0;if((d|0)==1)break a;e=d;d=c[j>>2]|0}f=$$(d,2)|0;g=z;e:do if((f|0)<1953653094){switch(f|0){case 1835427940:break;default:break e}if(!g){if((e|0)!=2)break a;if(k2(2,d)|0){LO(b);break a}else{c3(2,d);break a}}}else{switch(f|0){case 1953653094:break;default:break e}if(!g){if((e|0)==2){o7(b);DH(b);d=c[i>>2]|0;if((d|0)==2)break a;e=d;d=c[j>>2]|0}f=$$(d,3)|0;g=z;f:do if((f|0)<1952868452){switch(f|0){case 1935963248:break;default:break f}if(!g){if((e|0)!=3)break a;if(k2(3,d)|0){wv(b);break a}else{c3(3,d);break a}}}else if((f|0)<1953658222){switch(f|0){case 1952868452:break;default:break f}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){km(b);break a}else{c3(3,d);break a}}else{switch(f|0){case 1953658222:break;default:break f}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){yf(b);break a}else{c3(3,d);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}if((f|0)>=1885563751){switch(f|0){case 1885563751:break;default:break b}if(g|0)break;if(!h)break a;if(k2(1,d)|0){nD(b);break a}else{c3(1,d);break a}}switch(f|0){case 1836019574:break;default:break b}if(!g){if(h){o7(b);hz(b);d=c[i>>2]|0;if((d|0)==1)break a;e=d;d=c[j>>2]|0}f=$$(d,2)|0;g=z;g:do if((f|0)<1835365473){if((f|0)>=1668571490)if((f|0)<1768907891){switch(f|0){case 1668571490:break;default:break g}if(g|0)break;if((e|0)!=2)break a;if(k2(2,d)|0){MD(b);break a}else{c3(2,d);break a}}else{switch(f|0){case 1768907891:break;default:break g}if(g|0)break;if((e|0)!=2)break a;if(k2(2,d)|0){SD(b);break a}else{c3(2,d);break a}}if((f|0)<1668116342){switch(f|0){case 1634299494:break;default:break g}if(g|0)break;if((e|0)!=2)break a;if(k2(2,d)|0){mJ(b);break a}else{c3(2,d);break a}}switch(f|0){case 1668116342:break;default:break g}if(!g){if((e|0)==2){o7(b);d=c[i>>2]|0;if((d|0)==2)break a;e=d;d=c[j>>2]|0}f=$$(d,3)|0;g=z;h:do if((f|0)<1684238189){switch(f|0){case 1668118116:break;default:break h}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){lU(b);break a}else{c3(3,d);break a}}else{switch(f|0){case 1684238189:break;default:break h}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){T3(b);break a}else{c3(3,d);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}}else{if((f|0)<1836476516){if((f|0)>=1836475768){switch(f|0){case 1836475768:break;default:break g}if(g|0)break;if((e|0)==2){o7(b);d=c[i>>2]|0;if((d|0)==2)break a;e=d;d=c[j>>2]|0}f=$$(d,3)|0;g=z;i:do if((f|0)<1953654136){switch(f|0){case 1835362404:break;default:break i}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){uI(b);break a}else{c3(3,d);break a}}else{switch(f|0){case 1953654136:break;default:break i}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){Nn(b);break a}else{c3(3,d);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}switch(f|0){case 1835365473:break;default:break g}if(g|0)break;if((e|0)==2){o7(b);z8(b);d=c[i>>2]|0;if((d|0)==2)break a;e=d;d=c[j>>2]|0}f=$$(d,3)|0;g=z;j:do if((f|0)<1768715124)if((f|0)<1751411826){switch(f|0){case 1652059500:break;default:break j}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){WF(b);break a}else{c3(3,d);break a}}else{switch(f|0){case 1751411826:break;default:break j}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){Qq(b);break a}else{c3(3,d);break a}}else{if((f|0)>=1801812339){if((f|0)>=2020437024){switch(f|0){case 2020437024:break;default:break j}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){YF(b);break a}else{c3(3,d);break a}}switch(f|0){case 1801812339:break;default:break j}if(g|0)break;if((e|0)==3){o7(b);cJ(b);d=c[i>>2]|0;if((d|0)==3)break a;e=d;d=c[j>>2]|0}j=$$(d,4)|0;if(!((j|0)==1835299937&(z|0)==0)){j=HN(b,0)|0;e1(b,j,z);break a}if((e|0)!=4)break a;if(k2(4,d)|0){Iu(b);break a}else{c3(4,d);break a}}switch(f|0){case 1768715124:break;default:break j}if(g|0)break;if((e|0)==3){o7(b);$7(b);d=c[i>>2]|0}else d=e;switch(d|0){case 3:break a;case 4:{o7(b);lT(b);d=c[i>>2]|0;if((d|0)==4)break a;break}default:{}}e=c[j>>2]|0;f=$$(e,5)|0;g=z;k:do if((f|0)<1835360622){switch(f|0){case 1684108385:break;default:break k}if(g|0)break;if((d|0)!=5)break a;if(k2(5,e)|0){Cb(b);break a}else{c3(5,e);break a}}else if((f|0)<1851878757){switch(f|0){case 1835360622:break;default:break k}if(g|0)break;if((d|0)!=5)break a;if(k2(5,e)|0){yN(b);break a}else{c3(5,e);break a}}else{switch(f|0){case 1851878757:break;default:break k}if(g|0)break;if((d|0)!=5)break a;if(k2(5,e)|0){RJ(b);break a}else{c3(5,e);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}while(0);j=HN(b,0)|0;e1(b,j,z);break a}if((f|0)<1953653099){switch(f|0){case 1836476516:break;default:break g}if(g|0)break;if((e|0)!=2)break a;if(k2(2,d)|0){uh(b);break a}else{c3(2,d);break a}}if((f|0)>=1969517665){switch(f|0){case 1969517665:break;default:break g}if(g|0)break;if((e|0)==2){o7(b);v8(b);d=c[i>>2]|0;if((d|0)==2)break a;e=d;d=c[j>>2]|0}f=$$(d,3)|0;g=z;l:do if((f|0)<1751740006){if((f|0)>=1296257107)if((f|0)<1481461855){if((f|0)<1399155760){switch(f|0){case 1296257107:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){lS(b);break a}else{c3(3,d);break a}}if((f|0)<1464618819){switch(f|0){case 1399155760:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){G$(b);break a}else{c3(3,d);break a}}else{switch(f|0){case 1464618819:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){G$(b);break a}else{c3(3,d);break a}}}else{if((f|0)<1667788908){switch(f|0){case 1481461855:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){G$(b);break a}else{c3(3,d);break a}}if((f|0)<1668051814){switch(f|0){case 1667788908:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){Pj(b);break a}else{c3(3,d);break a}}else{switch(f|0){case 1668051814:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){qn(b);break a}else{c3(3,d);break a}}}if((f|0)>=1180193859){if((f|0)<1229206322){switch(f|0){case 1180193859:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){G$(b);break a}else{c3(3,d);break a}}if((f|0)<1280266064){switch(f|0){case 1229206322:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){FI(b);break a}else{c3(3,d);break a}}else{switch(f|0){case 1280266064:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){G$(b);break a}else{c3(3,d);break a}}}if((f|0)<1147358532){switch(f|0){case 1097624646:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){G$(b);break a}else{c3(3,d);break a}}if((f|0)>=1179206988){switch(f|0){case 1179206988:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){G$(b);break a}else{c3(3,d);break a}}switch(f|0){case 1147358532:break;default:break l}if(g|0)break;if((e|0)==3){o7(b);d=c[i>>2]|0;if((d|0)==3)break a;e=d;d=c[j>>2]|0}f=$$(d,4)|0;g=z;m:do if((f|0)<1147358533){switch(f|0){case 1131242095:break;default:break m}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){V4(b);break a}else{c3(4,d);break a}}else{switch(f|0){case 1147358533:break;default:break m}if(g|0)break;if((e|0)==4){o7(b);d=c[i>>2]|0;if((d|0)==4)break a;e=d;d=c[j>>2]|0}f=$$(d,5)|0;g=z;n:do if((f|0)<1299475812){switch(f|0){case 1264941431:break;default:break n}if(g|0)break;if((e|0)!=5)break a;if(k2(5,d)|0){G$(b);break a}else{c3(5,d);break a}}else if((f|0)<1382118501){switch(f|0){case 1299475812:break;default:break n}if(g|0)break;if((e|0)!=5)break a;if(k2(5,d)|0){G$(b);break a}else{c3(5,d);break a}}else{switch(f|0){case 1382118501:break;default:break n}if(g|0)break;if((e|0)!=5)break a;if(k2(5,d)|0){MX(b);break a}else{c3(5,d);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}while(0);j=HN(b,0)|0;e1(b,j,z);break a}else{if((f|0)>=1852076653){if((f|0)<1920233063){if((f|0)<1853055350){switch(f|0){case 1852076653:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){G$(b);break a}else{c3(3,d);break a}}if((f|0)<1886680608){switch(f|0){case 1853055350:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){G$(b);break a}else{c3(3,d);break a}}else{switch(f|0){case 1886680608:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){AY(b);break a}else{c3(3,d);break a}}}if((f|0)<1952540531){switch(f|0){case 1920233063:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){An(b);break a}else{c3(3,d);break a}}if((f|0)>=2037543523){switch(f|0){case 2037543523:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){xK(b);break a}else{c3(3,d);break a}}switch(f|0){case 1952540531:break;default:break l}if(g|0)break;if((e|0)==3){o7(b);d=c[i>>2]|0;if((d|0)==3)break a;e=d;d=c[j>>2]|0}f=$$(d,4)|0;g=z;o:do if((f|0)<1953719655){switch(f|0){case 1835365473:break;default:break o}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){G$(b);break a}else{c3(4,d);break a}}else{switch(f|0){case 1953719655:break;default:break o}if(g|0)break;if((e|0)==4){o7(b);d=c[i>>2]|0;if((d|0)==4)break a;e=d;d=c[j>>2]|0}j=$$(d,5)|0;if(!((j|0)==1953720420&(z|0)==0)){j=HN(b,0)|0;e1(b,j,z);break a}if((e|0)!=5)break a;if(k2(5,d)|0){G$(b);break a}else{c3(5,d);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}if((f|0)<1803122532){if((f|0)<1751740022){switch(f|0){case 1751740006:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){G$(b);break a}else{c3(3,d);break a}}if((f|0)<1752069225){switch(f|0){case 1751740022:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){e$(b);break a}else{c3(3,d);break a}}switch(f|0){case 1752069225:break;default:break l}if(g|0)break;if((e|0)==3){o7(b);d=c[i>>2]|0;if((d|0)==3)break a;e=d;d=c[j>>2]|0}j=$$(d,4)|0;if(!((j|0)==1920233504&(z|0)==0)){j=HN(b,0)|0;e1(b,j,z);break a}if((e|0)!=4)break a;if(k2(4,d)|0){e$(b);break a}else{c3(4,d);break a}}if((f|0)<1819239273){switch(f|0){case 1803122532:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){Uo(b);break a}else{c3(3,d);break a}}if((f|0)<1835365473){switch(f|0){case 1819239273:break;default:break l}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){dL(b);break a}else{c3(3,d);break a}}switch(f|0){case 1835365473:break;default:break l}if(g|0)break;if((e|0)==3){o7(b);dH(b);d=c[i>>2]|0;if((d|0)==3)break a;e=d;d=c[j>>2]|0}f=$$(d,4)|0;g=z;p:do if((f|0)<1768715124){switch(f|0){case 1751411826:break;default:break p}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){A4(b);break a}else{c3(4,d);break a}}else{if((f|0)>=1970628964){switch(f|0){case 1970628964:break;default:break p}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){xl(b);break a}else{c3(4,d);break a}}switch(f|0){case 1768715124:break;default:break p}if(g|0)break;if((e|0)==4){o7(b);z4(b);d=c[i>>2]|0}else d=e;switch(d|0){case 4:break a;case 5:{o7(b);x3(b);d=c[i>>2]|0;if((d|0)==5)break a;break}default:{}}e=c[j>>2]|0;f=$$(e,6)|0;g=z;q:do if((f|0)<1835360622){switch(f|0){case 1684108385:break;default:break q}if(g|0)break;if((d|0)!=6)break a;if(k2(6,e)|0){n2(b);break a}else{c3(6,e);break a}}else if((f|0)<1851878757){switch(f|0){case 1835360622:break;default:break q}if(g|0)break;if((d|0)!=6)break a;if(k2(6,e)|0){m2(b);break a}else{c3(6,e);break a}}else{switch(f|0){case 1851878757:break;default:break q}if(g|0)break;if((d|0)!=6)break a;if(k2(6,e)|0){l2(b);break a}else{c3(6,e);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}while(0);j=HN(b,0)|0;e1(b,j,z);break a}while(0);if((e|0)!=3)break a;if(k2(3,d)|0){dd(b);break a}else{c3(3,d);break a}}switch(f|0){case 1953653099:break;default:break g}if(!g){if((e|0)==2){o7(b);Rz(b);d=c[i>>2]|0;if((d|0)==2)break a;e=d;d=c[j>>2]|0}f=$$(d,3)|0;g=z;r:do if((f|0)<1953196132){if((f|0)<1835297121){if((f|0)>=1819238756){switch(f|0){case 1819238756:break;default:break r}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){xY(b);break a}else{c3(3,d);break a}}switch(f|0){case 1701082227:break;default:break r}if(g|0)break;if((e|0)==3){o7(b);d=c[i>>2]|0;if((d|0)==3)break a;e=d;d=c[j>>2]|0}j=$$(d,4)|0;if(!((j|0)==1701606260&(z|0)==0)){j=HN(b,0)|0;e1(b,j,z);break a}if((e|0)!=4)break a;if(k2(4,d)|0){en(b);break a}else{c3(4,d);break a}}if((f|0)>=1952542836){switch(f|0){case 1952542836:break;default:break r}if(g|0)break;if((e|0)==3){o7(b);d=c[i>>2]|0;if((d|0)==3)break a;e=d;d=c[j>>2]|0}f=$$(d,4)|0;g=z;s:do if((f|0)<1701736294){switch(f|0){case 1668048230:break;default:break s}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){fO(b);break a}else{c3(4,d);break a}}else if((f|0)<1886547814){switch(f|0){case 1701736294:break;default:break s}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){fO(b);break a}else{c3(4,d);break a}}else{switch(f|0){case 1886547814:break;default:break s}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){fO(b);break a}else{c3(4,d);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}switch(f|0){case 1835297121:break;default:break r}if(g|0)break;if((e|0)==3){o7(b);d=c[i>>2]|0;if((d|0)==3)break a;e=d;d=c[j>>2]|0}f=$$(d,4)|0;g=z;t:do if((f|0)<1835296868){if((f|0)<1768776048){switch(f|0){case 1751411826:break;default:break t}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){Lc(b);break a}else{c3(4,d);break a}}switch(f|0){case 1768776048:break;default:break t}if(g|0)break;if((e|0)==4){o7(b);xY(b);e=c[i>>2]|0;if((e|0)==4)break a;d=c[j>>2]|0}h=$$(d,5)|0;if(!((h|0)==1936023918&(z|0)==0)){j=HN(b,0)|0;e1(b,j,z);break a}if((e|0)==5){o7(b);xY(b);e=c[i>>2]|0;if((e|0)==5)break a;d=c[j>>2]|0}h=$$(d,6)|0;if(!((h|0)==26990&(z|0)==0)){j=HN(b,0)|0;e1(b,j,z);break a}if((e|0)==6){o7(b);xY(b);d=c[i>>2]|0;if((d|0)==6)break a;e=d;d=c[j>>2]|0}f=$$(d,7)|0;g=z;u:do if((f|0)<1685353332){switch(f|0){case 29817:break;default:break u}if(g|0)break;if((e|0)!=7)break a;if(k2(7,d)|0){BY(b);break a}else{c3(7,d);break a}}else if((f|0)<1868720484){switch(f|0){case 1685353332:break;default:break u}if(g|0)break;if((e|0)!=7)break a;if(k2(7,d)|0){IU(b);break a}else{c3(7,d);break a}}else{switch(f|0){case 1868720484:break;default:break u}if(g|0)break;if((e|0)!=7)break a;if(k2(7,d)|0){BY(b);break a}else{c3(7,d);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}else{if((f|0)<1835626086){switch(f|0){case 1835296868:break;default:break t}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){Yg(b);break a}else{c3(4,d);break a}}switch(f|0){case 1835626086:break;default:break t}if(g|0)break;if((e|0)==4){o7(b);d=c[i>>2]|0;if((d|0)==4)break a;e=d;d=c[j>>2]|0}f=$$(d,5)|0;g=z;v:do if((f|0)<1752000612){if((f|0)>=1735223396){if((f|0)>=1751411826)if((f|0)<1751740020){switch(f|0){case 1751411826:break;default:break v}if(g|0)break;if((e|0)!=5)break a;if(k2(5,d)|0){y3(b);break a}else{c3(5,d);break a}}else{switch(f|0){case 1751740020:break;default:break v}if(g|0)break;if((e|0)!=5)break a;if(k2(5,d)|0){RN(b);break a}else{c3(5,d);break a}}switch(f|0){case 1735223396:break;default:break v}if(g|0)break;if((e|0)==5){o7(b);d=c[i>>2]|0;if((d|0)==5)break a;e=d;d=c[j>>2]|0}f=$$(d,6)|0;g=z;w:do if((f|0)<1952673129){switch(f|0){case 1735223662:break;default:break w}if(g|0)break;if((e|0)!=6)break a;if(k2(6,d)|0){KN(b);break a}else{c3(6,d);break a}}else{if((f|0)<1953325924){switch(f|0){case 1952673129:break;default:break w}if(g|0)break;if((e|0)!=6)break a;if(k2(6,d)|0){m1(b);break a}else{c3(6,d);break a}}switch(f|0){case 1953325924:break;default:break w}if(g|0)break;if((e|0)==6){o7(b);d=c[i>>2]|0;if((d|0)==6)break a;e=d;d=c[j>>2]|0}j=$$(d,7)|0;if(!((j|0)==1952673129&(z|0)==0)){j=HN(b,0)|0;e1(b,j,z);break a}if((e|0)!=7)break a;if(k2(7,d)|0){cq(b);break a}else{c3(7,d);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}if((f|0)<1684631142){switch(f|0){case 1668244581:break;default:break v}if(g|0)break;if((e|0)==5){o7(b);xY(b);e=c[i>>2]|0;if((e|0)==5)break a;d=c[j>>2]|0}h=$$(d,6)|0;if(!((h|0)==1936023918&(z|0)==0)){j=HN(b,0)|0;e1(b,j,z);break a}if((e|0)==6){o7(b);xY(b);d=c[i>>2]|0;if((d|0)==6)break a;e=d;d=c[j>>2]|0}j=$$(d,7)|0;if(!((j|0)==1381313089&(z|0)==0)){j=HN(b,0)|0;e1(b,j,z);break a}if((e|0)!=7)break a;if(k2(7,d)|0){nz(b);break a}else{c3(7,d);break a}}switch(f|0){case 1684631142:break;default:break v}if(g|0)break;if((e|0)==5){o7(b);d=c[i>>2]|0;if((d|0)==5)break a;e=d;d=c[j>>2]|0}f=$$(d,6)|0;g=z;x:do if((f|0)<1970433056){switch(f|0){case 1685218662:break;default:break x}if(g|0)break;if((e|0)==6){o7(b);LO(b);d=c[i>>2]|0;if((d|0)==6)break a;e=d;d=c[j>>2]|0}f=$$(d,7)|0;g=z;y:do if((f|0)<1970433056)if((f|0)<1920168547){switch(f|0){case 1634494835:break;default:break y}if(g|0)break;if((e|0)!=7)break a;if(k2(7,d)|0){td(b);break a}else{c3(7,d);break a}}else{switch(f|0){case 1920168547:break;default:break y}if(g|0)break;if((e|0)!=7)break a;if(k2(7,d)|0){BY(b);break a}else{c3(7,d);break a}}else switch(f|0){case 1970433056:{if(g|0)break y;if((e|0)!=7)break a;if(k2(7,d)|0){tK(b);break a}else{c3(7,d);break a}}case 1970433568:{if(g|0)break y;if((e|0)!=7)break a;if(k2(7,d)|0){tK(b);break a}else{c3(7,d);break a}}default:break y}while(0);j=HN(b,0)|0;e1(b,j,z);break a}else switch(f|0){case 1970433056:{if(g|0)break x;if((e|0)!=6)break a;if(k2(6,d)|0){tK(b);break a}else{c3(6,d);break a}}case 1970433568:{if(g|0)break x;if((e|0)!=6)break a;if(k2(6,d)|0){tK(b);break a}else{c3(6,d);break a}}default:break x}while(0);j=HN(b,0)|0;e1(b,j,z);break a}else{if((f|0)<1937007212){if((f|0)<1852663908){switch(f|0){case 1752000612:break;default:break v}if(g|0)break;if((e|0)!=5)break a;if(k2(5,d)|0){rv(b);break a}else{c3(5,d);break a}}if((f|0)<1936549988){switch(f|0){case 1852663908:break;default:break v}if(g|0)break;if((e|0)!=5)break a;if(k2(5,d)|0){HW(b);break a}else{c3(5,d);break a}}else{switch(f|0){case 1936549988:break;default:break v}if(g|0)break;if((e|0)!=5)break a;if(k2(5,d)|0){IF(b);break a}else{c3(5,d);break a}}}if((f|0)>=1937008740)if((f|0)<1986881636){switch(f|0){case 1937008740:break;default:break v}if(g|0)break;if((e|0)!=5)break a;if(k2(5,d)|0){Wz(b);break a}else{c3(5,d);break a}}else{switch(f|0){case 1986881636:break;default:break v}if(g|0)break;if((e|0)!=5)break a;if(k2(5,d)|0){jx(b);break a}else{c3(5,d);break a}}switch(f|0){case 1937007212:break;default:break v}if(g|0)break;if((e|0)==5){o7(b);d=c[i>>2]|0;if((d|0)==5)break a;e=d;d=c[j>>2]|0}f=$$(d,6)|0;g=z;z:do if((f|0)<1937011555){if((f|0)<1935963248){if((f|0)<1668508775){switch(f|0){case 1668232756:break;default:break z}if(g|0)break;if((e|0)!=6)break a;if(k2(6,d)|0){cp(b);break a}else{c3(6,d);break a}}if((f|0)<1668576371){switch(f|0){case 1668508775:break;default:break z}if(g|0)break;if((e|0)!=6)break a;if(k2(6,d)|0){G$(b);break a}else{c3(6,d);break a}}else{switch(f|0){case 1668576371:break;default:break z}if(g|0)break;if((e|0)!=6)break a;if(k2(6,d)|0){FT(b);break a}else{c3(6,d);break a}}}if((f|0)<1937007728)if((f|0)<1937007471){switch(f|0){case 1935963248:break;default:break z}if(g|0)break;if((e|0)!=6)break a;if(k2(6,d)|0){G$(b);break a}else{c3(6,d);break a}}else{switch(f|0){case 1937007471:break;default:break z}if(g|0)break;if((e|0)!=6)break a;if(k2(6,d)|0){No(b);break a}else{c3(6,d);break a}}else if((f|0)<1937010803){switch(f|0){case 1937007728:break;default:break z}if(g|0)break;if((e|0)!=6)break a;if(k2(6,d)|0){xJ(b);break a}else{c3(6,d);break a}}else{switch(f|0){case 1937010803:break;default:break z}if(g|0)break;if((e|0)!=6)break a;if(k2(6,d)|0){Kj(b);break a}else{c3(6,d);break a}}}else switch(f|0){case 1937011555:{if(g|0)break z;if((e|0)!=6)break a;if(k2(6,d)|0){Xm(b);break a}else{c3(6,d);break a}}case 1937011556:{if(g|0)break z;if((e|0)==6){o7(b);mM(b);d=c[i>>2]|0;if((d|0)==6)break a;e=d;d=c[j>>2]|0}f=$$(d,7)|0;g=z;A:do if((f|0)<1953325924){if((f|0)>=1952807028){switch(f|0){case 1952807028:break;default:break A}if(g|0)break;if((e|0)!=7)break a;if(k2(7,d)|0){Go(b);break a}else{c3(7,d);break a}}switch(f|0){case 1937010800:break;default:break A}if(g|0)break;if((e|0)==7){o7(b);xi(b);d=c[i>>2]|0;if((d|0)==7)break a;e=d;d=c[j>>2]|0}j=$$(d,8)|0;if(!((j|0)==1651798644&(z|0)==0)){j=HN(b,0)|0;e1(b,j,z);break a}if((e|0)!=8)break a;if(k2(8,d)|0){n0(b);break a}else{c3(8,d);break a}}else if((f|0)<1954034535){switch(f|0){case 1953325924:break;default:break A}if(g|0)break;if((e|0)==7){o7(b);Ah(b);d=c[i>>2]|0;if((d|0)==7)break a;e=d;d=c[j>>2]|0}j=$$(d,8)|0;if(!((j|0)==1851878757&(z|0)==0)){j=HN(b,0)|0;e1(b,j,z);break a}if((e|0)!=8)break a;if(k2(8,d)|0){dv(b);break a}else{c3(8,d);break a}}else{switch(f|0){case 1954034535:break;default:break A}if(g|0)break;if((e|0)==7){o7(b);$j(b);d=c[i>>2]|0;if((d|0)==7)break a;e=d;d=c[j>>2]|0}j=$$(d,8)|0;if(!((j|0)==1718903138&(z|0)==0)){j=HN(b,0)|0;e1(b,j,z);break a}if((e|0)!=8)break a;if(k2(8,d)|0){Ys(b);break a}else{c3(8,d);break a}}while(0);if((e|0)==7){o7(b);fg(b);d=c[i>>2]|0;if((d|0)==7)break a;e=d;d=c[j>>2]|0}f=$$(d,8)|0;g=z;B:do if((f|0)<1684103987)if((f|0)<1651078258){if((f|0)<1095782983){if((f|0)<1094929490){switch(f|0){case 1094798416:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){mK(b);break a}else{c3(8,d);break a}}if((f|0)<1095717444){switch(f|0){case 1094929490:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){$R(b);break a}else{c3(8,d);break a}}else{switch(f|0){case 1095717444:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){_R(b);break a}else{c3(8,d);break a}}}if((f|0)<1634492771)if((f|0)<1095910739){switch(f|0){case 1095782983:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){qL(b);break a}else{c3(8,d);break a}}else{switch(f|0){case 1095910739:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){Tu(b);break a}else{c3(8,d);break a}}else if((f|0)<1635148611){switch(f|0){case 1634492771:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){Vn(b);break a}else{c3(8,d);break a}}else{switch(f|0){case 1635148611:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){wl(b);break a}else{c3(8,d);break a}}}else{if((f|0)<1668047216){if((f|0)<1651798644){switch(f|0){case 1651078258:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){Tz(b);break a}else{c3(8,d);break a}}if((f|0)<1667785070){switch(f|0){case 1651798644:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){ZA(b);break a}else{c3(8,d);break a}}else{switch(f|0){case 1667785070:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){wg(b);break a}else{c3(8,d);break a}}}if((f|0)<1668246642)if((f|0)<1668050025){switch(f|0){case 1668047216:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){qs(b);break a}else{c3(8,d);break a}}else{switch(f|0){case 1668050025:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){eo(b);break a}else{c3(8,d);break a}}else if((f|0)<1681012275){switch(f|0){case 1668246642:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){kt(b);break a}else{c3(8,d);break a}}else{switch(f|0){case 1681012275:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){gg(b);break a}else{c3(8,d);break a}}}else{if((f|0)<1735156332){if((f|0)<1684366131){if((f|0)<1684106610){switch(f|0){case 1684103987:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){Ni(b);break a}else{c3(8,d);break a}}if((f|0)<1684305011){switch(f|0){case 1684106610:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){gh(b);break a}else{c3(8,d);break a}}else{switch(f|0){case 1684305011:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){Zi(b);break a}else{c3(8,d);break a}}}if((f|0)<1702061171)if((f|0)<1685480241){switch(f|0){case 1684366131:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){xs(b);break a}else{c3(8,d);break a}}else{switch(f|0){case 1685480241:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){Td(b);break a}else{c3(8,d);break a}}else if((f|0)<1718183276){switch(f|0){case 1702061171:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){kq(b);break a}else{c3(8,d);break a}}else{switch(f|0){case 1718183276:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){ho(b);break a}else{c3(8,d);break a}}}if((f|0)<1835295606){if((f|0)<1768187501)if((f|0)<1752589123){switch(f|0){case 1735156332:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){Xl(b);break a}else{c3(8,d);break a}}else{switch(f|0){case 1752589123:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){Io(b);break a}else{c3(8,d);break a}}if((f|0)<1785737832){switch(f|0){case 1768187501:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){SY(b);break a}else{c3(8,d);break a}}switch(f|0){case 1785737832:break;default:break B}if(g|0)break;if((e|0)==8){o7(b);d=c[i>>2]|0;if((d|0)==8)break a;e=d;d=c[j>>2]|0}f=$$(d,9)|0;g=z;C:do if((f|0)<1768449138){switch(f|0){case 1668246642:break;default:break C}if(g|0)break;if((e|0)!=9)break a;if(k2(9,d)|0){s2(b);break a}else{c3(9,d);break a}}else{switch(f|0){case 1768449138:break;default:break C}if(g|0)break;if((e|0)!=9)break a;if(k2(9,d)|0){r2(b);break a}else{c3(9,d);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}if((f|0)<1936289382)if((f|0)<1885434736){switch(f|0){case 1835295606:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){Uz(b);break a}else{c3(8,d);break a}}else{switch(f|0){case 1885434736:break;default:break B}if(g|0)break;if((e|0)!=8)break a;if(k2(8,d)|0){Xx(b);break a}else{c3(8,d);break a}}if((f|0)<2002876005){switch(f|0){case 1936289382:break;default:break B}if(g|0)break;if((e|0)==8){o7(b);d=c[i>>2]|0;if((d|0)==8)break a;e=d;d=c[j>>2]|0}f=$$(d,9)|0;g=z;D:do if((f|0)<1935894633)if((f|0)<1768778086){switch(f|0){case 1718775137:break;default:break D}if(g|0)break;if((e|0)!=9)break a;if(k2(9,d)|0){Jx(b);break a}else{c3(9,d);break a}}else{switch(f|0){case 1768778086:break;default:break D}if(g|0)break;if((e|0)!=9)break a;if(k2(9,d)|0){vT(b);break a}else{c3(9,d);break a}}else switch(f|0){case 1935894633:{if(g|0)break D;if((e|0)!=9)break a;if(k2(9,d)|0){G$(b);break a}else{c3(9,d);break a}}case 1935894637:{if(g|0)break D;if((e|0)!=9)break a;if(k2(9,d)|0){sB(b);break a}else{c3(9,d);break a}}default:break D}while(0);j=HN(b,0)|0;e1(b,j,z);break a}switch(f|0){case 2002876005:break;default:break B}if(g|0)break;if((e|0)==8){o7(b);d=c[i>>2]|0;if((d|0)==8)break a;e=d;d=c[j>>2]|0}f=$$(d,9)|0;g=z;E:do if((f|0)<1718775137){if((f|0)<1701733473){switch(f|0){case 1633903206:break;default:break E}if(g|0)break;if((e|0)!=9)break a;if(k2(9,d)|0){BY(b);break a}else{c3(9,d);break a}}if((f|0)<1702061171){switch(f|0){case 1701733473:break;default:break E}if(g|0)break;if((e|0)!=9)break a;if(k2(9,d)|0){ET(b);break a}else{c3(9,d);break a}}else{switch(f|0){case 1702061171:break;default:break E}if(g|0)break;if((e|0)!=9)break a;if(k2(9,d)|0){kq(b);break a}else{c3(9,d);break a}}}else{if((f|0)<1935764850){switch(f|0){case 1718775137:break;default:break E}if(g|0)break;if((e|0)!=9)break a;if(k2(9,d)|0){Bi(b);break a}else{c3(9,d);break a}}if((f|0)<1936876401){switch(f|0){case 1935764850:break;default:break E}if(g|0)break;if((e|0)!=9)break a;if(k2(9,d)|0){eh(b);break a}else{c3(9,d);break a}}else{switch(f|0){case 1936876401:break;default:break E}if(g|0)break;if((e|0)!=9)break a;if(k2(9,d)|0){BY(b);break a}else{c3(9,d);break a}}}while(0);if((e|0)!=9)break a;if(k2(9,d)|0){mo(b);break a}else{c3(9,d);break a}}while(0);e1(b,HN(b,0)|0,z);break a}case 1937011560:{if(g|0)break z;if((e|0)!=6)break a;if(k2(6,d)|0){wJ(b);break a}else{c3(6,d);break a}}case 1937011571:{if(g|0)break z;if((e|0)!=6)break a;if(k2(6,d)|0){aj(b);break a}else{c3(6,d);break a}}case 1937011578:{if(g|0)break z;if((e|0)!=6)break a;if(k2(6,d)|0){Ad(b);break a}else{c3(6,d);break a}}case 1937011827:{if(g|0)break z;if((e|0)!=6)break a;if(k2(6,d)|0){Eo(b);break a}else{c3(6,d);break a}}case 1937013298:{if(g|0)break z;if((e|0)!=6)break a;if(k2(6,d)|0){R1(b);break a}else{c3(6,d);break a}}default:break z}while(0);j=HN(b,0)|0;e1(b,j,z);break a}while(0);j=HN(b,0)|0;e1(b,j,z);break a}while(0);j=HN(b,0)|0;e1(b,j,z);break a}else{if((f|0)>=1954046323){if((f|0)<1969517665){switch(f|0){case 1954046323:break;default:break r}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){HV(b);break a}else{c3(3,d);break a}}switch(f|0){case 1969517665:break;default:break r}if(g|0)break;if((e|0)==3){o7(b);d=c[i>>2]|0}else d=e;if((d|0)!=4)break a;d=c[j>>2]|0;if(k2(4,d)|0){B4(b);break a}else{c3(4,d);break a}}if((f|0)<1953654118){switch(f|0){case 1953196132:break;default:break r}if(g|0)break;if((e|0)!=3)break a;if(k2(3,d)|0){gf(b);break a}else{c3(3,d);break a}}switch(f|0){case 1953654118:break;default:break r}if(g|0)break;if((e|0)==3){o7(b);d=c[i>>2]|0;if((d|0)==3)break a;e=d;d=c[j>>2]|0}f=$$(d,4)|0;g=z;F:do if((f|0)<1751740020){if((f|0)>=1717660780){if((f|0)<1718578295){switch(f|0){case 1717660780:break;default:break F}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){tq(b);break a}else{c3(4,d);break a}}switch(f|0){case 1718578295:{if(g|0)break F;if((e|0)!=4)break a;if(k2(4,d)|0){sq(b);break a}else{c3(4,d);break a}}case 1718579811:{if(g|0)break F;if((e|0)!=4)break a;if(k2(4,d)|0){rq(b);break a}else{c3(4,d);break a}}default:break F}}if((f|0)<1668047728){switch(f|0){case 1667785072:break;default:break F}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){lp(b);break a}else{c3(4,d);break a}}if((f|0)<1685089892){switch(f|0){case 1668047728:break;default:break F}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){uq(b);break a}else{c3(4,d);break a}}else{switch(f|0){case 1685089892:break;default:break F}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){iJ(b);break a}else{c3(4,d);break a}}}else{if((f|0)<1935896692){if((f|0)<1768974706){switch(f|0){case 1751740020:break;default:break F}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){iJ(b);break a}else{c3(4,d);break a}}if((f|0)<1836085092){switch(f|0){case 1768974706:break;default:break F}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){iJ(b);break a}else{c3(4,d);break a}}else{switch(f|0){case 1836085092:break;default:break F}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){iJ(b);break a}else{c3(4,d);break a}}}if((f|0)<1937337955)if((f|0)<1936945763){switch(f|0){case 1935896692:break;default:break F}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){iJ(b);break a}else{c3(4,d);break a}}else{switch(f|0){case 1936945763:break;default:break F}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){iJ(b);break a}else{c3(4,d);break a}}else if((f|0)<1953325924){switch(f|0){case 1937337955:break;default:break F}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){iJ(b);break a}else{c3(4,d);break a}}else{switch(f|0){case 1953325924:break;default:break F}if(g|0)break;if((e|0)!=4)break a;if(k2(4,d)|0){XL(b);break a}else{c3(4,d);break a}}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}while(0);j=HN(b,0)|0;e1(b,j,z);break a}}while(0);j=HN(b,0)|0;e1(b,j,z);break a}}while(0);j=HN(b,0)|0;e1(b,j,z)}}else zh(b);while(0);return}function yb(b){b=b|0;var d=0,e=0,f=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Lc=0.0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0.0;pd=l;l=l+288|0;nd=pd+264|0;od=pd+252|0;md=pd+240|0;ed=pd+228|0;fd=pd+216|0;gd=pd+176|0;hd=pd+120|0;id=pd+64|0;jd=pd+48|0;Nc=pd+36|0;Oc=pd+24|0;Pc=pd+12|0;Qc=pd;$x(nd,b,0,0,57,1);d=i9(22772)|0;kd=a[nd+8+3>>0]|0;ld=b+20|0;a:do if((d|0)==((kd<<24>>24<0?c[nd+4>>2]|0:kd&255)|0)){kd=(VG(nd,22772,d)|0)==0;z5(nd);if(kd){i=b+916|0;j=b+920|0;k=b+520|0;m=nd+8+3|0;n=nd+4|0;o=od+8+3|0;p=od+4|0;q=md+8+3|0;r=md+4|0;d=c[i>>2]|0;b:while(1){if((d|0)==(j|0))break a;f=d+36|0;h=d+16|0;e=0;while(1){c[nd>>2]=c[k>>2];kd=bF(i,nd)|0;if(e>>>0>=(c[kd+16>>2]|0)-(c[kd+12>>2]|0)>>2>>>0)break;KM(c[(c[f>>2]|0)+(e<<2)>>2]|0);if(RA(c[(c[f>>2]|0)+(e<<2)>>2]|0,3,-1)|0){Kc(b,3,-1)|0;RB(b,3,c[ld>>2]|0,10,(c[h>>2]|0)==1?374012:374018,-1,1,0);tN(b,3,c[ld>>2]|0,382758,22844);Gb(b,c[(c[f>>2]|0)+(e<<2)>>2]|0,3,0,c[ld>>2]|0,1)|0}$x(nd,c[(c[f>>2]|0)+(e<<2)>>2]|0,0,0,250,1);kd=a[m>>0]|0;if((kd<<24>>24<0?c[n>>2]|0:kd&255)|0)zb(b,0,0,250,nd,1);$x(od,c[(c[f>>2]|0)+(e<<2)>>2]|0,0,0,159,1);kd=a[o>>0]|0;if((kd<<24>>24<0?c[p>>2]|0:kd&255)|0?($x(md,b,0,0,159,1),kd=a[q>>0]|0,kd=((kd<<24>>24<0?c[r>>2]|0:kd&255)|0)==0,z5(md),kd):0)zb(b,0,0,159,od,0);z5(od);z5(nd);e=e+1|0}e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue b}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}}else Q=20}else{z5(nd);Q=20}while(0);if((Q|0)==20){lJ(b);kd=b+40|0;h=kd;f=c[h>>2]|0;h=c[h+4>>2]|0;Ic=b+916|0;Jc=b+920|0;d=c[Ic>>2]|0;c:while(1){if((d|0)==(Jc|0))break;if(c[d+64>>2]|0)Ke(b,c[d+16>>2]|0);e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue c}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}S=b+16|0;T=b+910|0;U=b+824|0;V=b+24|0;W=gd+8+3|0;X=gd+4|0;Y=gd+8+3|0;Z=gd+4|0;_=gd+8+3|0;$=gd+4|0;aa=hd+8+3|0;ba=hd+4|0;ca=id+8+3|0;da=id+4|0;ea=b+8|0;fa=b+4|0;ga=jd+8+3|0;ha=jd+4|0;ia=Qc+8+3|0;ja=Qc+4|0;ka=jd+8+3|0;la=jd+4|0;ma=gd+4|0;na=Nc+8+3|0;oa=Nc+4|0;pa=hd+4|0;qa=Nc+11|0;ra=jd+8+3|0;sa=jd+4|0;ta=Nc+8+3|0;ua=Nc+4|0;va=Oc+8+3|0;wa=Oc+4|0;xa=nd+8+3|0;ya=nd+4|0;za=od+8+3|0;Aa=od+4|0;Ba=fd+8+3|0;Ca=fd+4|0;Da=gd+8+3|0;Ea=gd+4|0;Fa=gd+8+3|0;Ga=gd+4|0;Ha=gd+8+3|0;Ia=gd+4|0;Ja=gd+8+3|0;Ka=gd+4|0;La=gd+8+3|0;Ma=gd+4|0;Na=gd+8+3|0;Oa=gd+4|0;Pa=hd+8+3|0;Qa=hd+4|0;Ra=id+8+3|0;Sa=id+4|0;Ta=gd+8+3|0;Ua=gd+4|0;Va=gd+8+3|0;Wa=gd+4|0;Xa=jd+8+3|0;Ya=jd+4|0;Za=hd+4|0;_a=Nc+8+3|0;$a=Nc+4|0;ab=id+4|0;bb=Nc+11|0;cb=jd+8+3|0;db=jd+4|0;eb=Nc+8+3|0;fb=Nc+4|0;gb=Oc+8+3|0;hb=Oc+4|0;ib=Pc+8+3|0;kb=Pc+4|0;lb=Oc+8+3|0;mb=Oc+4|0;nb=nd+8+3|0;ob=nd+4|0;pb=od+8+3|0;qb=od+4|0;rb=md+8+3|0;sb=md+4|0;tb=fd+8+3|0;ub=fd+4|0;vb=nd+8+3|0;wb=nd+4|0;xb=nd+8+3|0;yb=nd+4|0;Ab=fd+8+3|0;Bb=fd+4|0;Cb=od+8+3|0;Db=od+4|0;Eb=fd+8+3|0;Fb=fd+4|0;Hb=fd+8+3|0;Ib=fd+4|0;Jb=gd+8+3|0;Kb=gd+4|0;Lb=fd+8+3|0;Mb=fd+4|0;Nb=fd+8+3|0;Ob=fd+4|0;Pb=jd+8+3|0;Qb=jd+4|0;Sb=fd+8+3|0;Tb=fd+4|0;Ub=fd+8+3|0;Vb=fd+4|0;Wb=jd+8+3|0;Xb=jd+4|0;Yb=fd+8+3|0;Zb=fd+4|0;_b=nd+8+3|0;$b=nd+4|0;ac=nd+8+3|0;bc=nd+4|0;cc=od+8+3|0;dc=od+4|0;ec=md+8+3|0;fc=md+4|0;gc=md+8+3|0;hc=md+4|0;ic=md+8+3|0;jc=md+4|0;kc=ed+8+3|0;lc=ed+4|0;mc=nd+8+3|0;nc=nd+4|0;oc=od+11|0;qc=od+4|0;rc=od+8|0;sc=nd+8+3|0;tc=nd+4|0;uc=md+11|0;vc=od+11|0;wc=od+8+3|0;xc=od+4|0;yc=od+11|0;zc=od+11|0;Ac=od+4|0;Bc=od+8|0;Cc=md+11|0;Dc=od+11|0;Ec=od+11|0;Fc=od+11|0;Gc=od+11|0;Hc=od+11|0;d=c[Ic>>2]|0;n=f;m=h;d:while(1){if((d|0)==(Jc|0))break;w=d+16|0;P=d+68|0;e=c[P>>2]|0;c[S>>2]=e;R=d+72|0;c[ld>>2]=c[R>>2];if((e|0)==7){e=d+80|0;if(!(c[e>>2]|0))Q=34;else{Kc(b,4,-1)|0;Q=c[ld>>2]|0;TX(nd);zb(b,4,Q,18,lh(nd,c[e>>2]|0)|0,0);z5(nd);e=c[S>>2]|0;Q=33}}else Q=33;if((Q|0)==33?(Q=0,(e|0)!=6):0)Q=34;if((Q|0)==34){Q=0;TX(nd);k=d+376|0;q=d+380|0;j=d+392|0;i=d+388|0;if((c[S>>2]|0)==3){GK(od,d+364|0);f=c[k>>2]|0;while(1){if((f|0)==(c[q>>2]|0))break;e=c[(bF(Ic,f)|0)+340>>2]|0;while(1){if((e|0)==(c[(bF(Ic,f)|0)+344>>2]|0))break;h=c[qc>>2]|0;if((h|0)==(c[rc>>2]|0))Yy(od,e);else{c[h>>2]=c[e>>2];c[qc>>2]=h+4}e=e+4|0}f=f+4|0}f=c[i>>2]|0;while(1){if((f|0)==(c[j>>2]|0))break;e=c[(bF(Ic,f)|0)+340>>2]|0;while(1){if((e|0)==(c[(bF(Ic,f)|0)+344>>2]|0))break;h=c[qc>>2]|0;if((h|0)==(c[rc>>2]|0))Yy(od,e);else{c[h>>2]=c[e>>2];c[qc>>2]=h+4}e=e+4|0}f=f+4|0}Tg(c[od>>2]|0,c[qc>>2]|0);e=ou(c[od>>2]|0,c[qc>>2]|0)|0;xI(od,e,c[qc>>2]|0);e=c[od>>2]|0;while(1){f=a[sc>>0]|0;f=((f<<24>>24<0?c[tc>>2]|0:f&255)|0)==0;if((e|0)==(c[qc>>2]|0))break;if(!f)HX(nd,22884)|0;TX(md);Gk(md,c[e>>2]|0,10)|0;O=a[md+8+3>>0]|0;N=O<<24>>24<0;Ex(nd,N?c[md>>2]|0:md,N?c[md+4>>2]|0:O&255)|0;z5(md);e=e+4|0}do if(!f){N=c[S>>2]|0;O=c[ld>>2]|0;pk(md,nd);xM(b,N,O,374024,(a[uc>>0]|0)<0?c[md>>2]|0:md,0);a1(md);if((a[sc>>0]|0)<0){y7(c[nd>>2]|0,0);c[tc>>2]=0;break}else{y7(nd,0);a[sc>>0]=0;break}}while(0);cU(od)}o=d+328|0;r=d+340|0;v=d+344|0;p=d+332|0;do if(!(a[w+283>>0]|0)){if(a[w+282>>0]|0){gq(od,b,c[S>>2]|0,c[ld>>2]|0,377014);O=a[wc>>0]|0;O=((O<<24>>24<0?c[xc>>2]|0:O&255)|0)==0;z5(od);if(O)break;xM(b,c[S>>2]|0,c[ld>>2]|0,382832,382808,0);break}e=c[o>>2]|0;while(1){if((e|0)==(c[p>>2]|0))break;if(a[(bF(Ic,e)|0)+274>>0]|0){O=a[sc>>0]|0;if(!((O<<24>>24<0?c[tc>>2]|0:O&255)|0)){Xy(od,22904);vF(nd,od)|0;z5(od)}else HX(nd,22892)|0;TX(od);Gk(od,c[e>>2]|0,10)|0;O=a[od+8+3>>0]|0;N=O<<24>>24<0;Ex(nd,N?c[od>>2]|0:od,N?c[od+4>>2]|0:O&255)|0;z5(od)}e=e+4|0}e=c[r>>2]|0;while(1){if((e|0)==(c[v>>2]|0))break;if(a[(bF(Ic,e)|0)+274>>0]|0){O=a[sc>>0]|0;if(!((O<<24>>24<0?c[tc>>2]|0:O&255)|0)){Xy(od,22904);vF(nd,od)|0;z5(od)}else HX(nd,22892)|0;TX(od);Gk(od,c[e>>2]|0,10)|0;O=a[od+8+3>>0]|0;N=O<<24>>24<0;Ex(nd,N?c[od>>2]|0:od,N?c[od+4>>2]|0:O&255)|0;z5(od)}e=e+4|0}e=c[S>>2]|0;f=c[ld>>2]|0;O=a[sc>>0]|0;if(!((O<<24>>24<0?c[tc>>2]|0:O&255)|0))xM(b,e,f,382832,382840,0);else{pk(od,nd);xM(b,e,f,382832,(a[vc>>0]|0)<0?c[od>>2]|0:od,0);a1(od)}if((a[sc>>0]|0)<0){y7(c[nd>>2]|0,0);c[tc>>2]=0;break}else{y7(nd,0);a[sc>>0]=0;break}}else xM(b,c[S>>2]|0,c[ld>>2]|0,382832,374038,0);while(0);e=c[S>>2]|0;if((e|0)==3){do if(a[d+300>>0]|0){e=c[ld>>2]|0;if(!(a[w+285>>0]|0))xM(b,3,e,374047,383624,0);else xM(b,3,e,374047,382808,0);f=c[j>>2]|0;e=c[i>>2]|0;if((f|0)!=(e|0)){while(1){if((e|0)==(f|0))break;O=a[sc>>0]|0;if((O<<24>>24<0?c[tc>>2]|0:O&255)|0)HX(nd,22884)|0;TX(od);Gk(od,c[e>>2]|0,10)|0;f=a[od+8+3>>0]|0;O=f<<24>>24<0;Ex(nd,O?c[od>>2]|0:od,O?c[od+4>>2]|0:f&255)|0;z5(od);e=e+4|0;f=c[j>>2]|0}N=c[S>>2]|0;O=c[ld>>2]|0;pk(od,nd);xM(b,N,O,374054,(a[zc>>0]|0)<0?c[od>>2]|0:od,0);a1(od);if((a[sc>>0]|0)<0){y7(c[nd>>2]|0,0);c[tc>>2]=0;break}else{y7(nd,0);a[sc>>0]=0;break}}}else xM(b,3,c[ld>>2]|0,374047,382840,0);while(0);f=c[q>>2]|0;e=c[k>>2]|0;do if((f|0)!=(e|0)){i=e;while(1){e=a[sc>>0]|0;h=((e<<24>>24<0?c[tc>>2]|0:e&255)|0)!=0;if((i|0)==(f|0))break;if(h)HX(nd,22884)|0;TX(od);Gk(od,c[i>>2]|0,10)|0;f=a[od+8+3>>0]|0;O=f<<24>>24<0;Ex(nd,O?c[od>>2]|0:od,O?c[od+4>>2]|0:f&255)|0;z5(od);i=i+4|0;f=c[q>>2]|0}if(h){O=c[S>>2]|0;e=c[ld>>2]|0;pk(od,nd);xM(b,O,e,374071,(a[yc>>0]|0)<0?c[od>>2]|0:od,0);a1(od);e=a[sc>>0]|0}if(e<<24>>24<0){y7(c[nd>>2]|0,0);c[tc>>2]=0;break}else{y7(nd,0);a[sc>>0]=0;break}}while(0);e=c[S>>2]|0}if((e|0)==2){f=c[p>>2]|0;e=c[o>>2]|0;do if((f|0)!=(e|0)){while(1){h=a[sc>>0]|0;h=((h<<24>>24<0?c[tc>>2]|0:h&255)|0)!=0;if((e|0)==(f|0))break;if(h)HX(nd,22884)|0;TX(od);Gk(od,c[e>>2]|0,10)|0;f=a[od+8+3>>0]|0;O=f<<24>>24<0;Ex(nd,O?c[od>>2]|0:od,O?c[od+4>>2]|0:f&255)|0;z5(od);e=e+4|0;f=c[p>>2]|0}if(h){N=c[S>>2]|0;O=c[ld>>2]|0;pk(od,nd);xM(b,N,O,374090,(a[Ec>>0]|0)<0?c[od>>2]|0:od,0);a1(od);if((a[sc>>0]|0)<0){y7(c[nd>>2]|0,0);c[tc>>2]=0;break}else{y7(nd,0);a[sc>>0]=0;break}}}while(0);f=c[v>>2]|0;e=c[r>>2]|0;do if((f|0)!=(e|0)){while(1){h=a[sc>>0]|0;h=((h<<24>>24<0?c[tc>>2]|0:h&255)|0)!=0;if((e|0)==(f|0))break;if(h)HX(nd,22884)|0;TX(od);Gk(od,c[e>>2]|0,10)|0;f=a[od+8+3>>0]|0;O=f<<24>>24<0;Ex(nd,O?c[od>>2]|0:od,O?c[od+4>>2]|0:f&255)|0;z5(od);e=e+4|0;f=c[v>>2]|0}if(h){N=c[S>>2]|0;O=c[ld>>2]|0;pk(od,nd);xM(b,N,O,374102,(a[Dc>>0]|0)<0?c[od>>2]|0:od,0);a1(od);if((a[sc>>0]|0)<0){y7(c[nd>>2]|0,0);c[tc>>2]=0;break}else{y7(nd,0);a[sc>>0]=0;break}}}while(0);e=d+352|0;i=d+356|0;if((c[i>>2]|0)!=(c[e>>2]|0)){GK(od,e);h=c[e>>2]|0;while(1){if((h|0)==(c[i>>2]|0))break;e=c[(bF(Ic,h)|0)+352>>2]|0;while(1){if((e|0)==(c[(bF(Ic,h)|0)+356>>2]|0))break;f=c[Ac>>2]|0;if((f|0)==(c[Bc>>2]|0))Yy(od,e);else{c[f>>2]=c[e>>2];c[Ac>>2]=f+4}e=e+4|0}e=c[(bF(Ic,h)|0)+364>>2]|0;while(1){if((e|0)==(c[(bF(Ic,h)|0)+368>>2]|0))break;f=c[Ac>>2]|0;if((f|0)==(c[Bc>>2]|0))Yy(od,e);else{c[f>>2]=c[e>>2];c[Ac>>2]=f+4}e=e+4|0}h=h+4|0}Tg(c[od>>2]|0,c[Ac>>2]|0);e=ou(c[od>>2]|0,c[Ac>>2]|0)|0;xI(od,e,c[Ac>>2]|0);e=c[od>>2]|0;while(1){f=a[sc>>0]|0;f=((f<<24>>24<0?c[tc>>2]|0:f&255)|0)==0;if((e|0)==(c[Ac>>2]|0))break;if(!f)HX(nd,22884)|0;TX(md);Gk(md,c[e>>2]|0,10)|0;O=a[md+8+3>>0]|0;N=O<<24>>24<0;Ex(nd,N?c[md>>2]|0:md,N?c[md+4>>2]|0:O&255)|0;z5(md);e=e+4|0}do if(!f){N=c[S>>2]|0;O=c[ld>>2]|0;pk(md,nd);xM(b,N,O,374116,(a[Cc>>0]|0)<0?c[md>>2]|0:md,0);a1(md);if((a[sc>>0]|0)<0){y7(c[nd>>2]|0,0);c[tc>>2]=0;break}else{y7(nd,0);a[sc>>0]=0;break}}while(0);cU(od)}}i=d+308|0;f=c[i>>2]|0;e=c[d+304>>2]|0;do if((f|0)==(e|0)){i=d+320|0;f=c[i>>2]|0;e=c[d+316>>2]|0;if((f|0)!=(e|0)){while(1){h=a[sc>>0]|0;h=((h<<24>>24<0?c[tc>>2]|0:h&255)|0)!=0;if((e|0)==(f|0))break;if(h)HX(nd,22884)|0;TX(od);Gk(od,c[e>>2]|0,10)|0;f=a[od+8+3>>0]|0;O=f<<24>>24<0;Ex(nd,O?c[od>>2]|0:od,O?c[od+4>>2]|0:f&255)|0;z5(od);e=e+4|0;f=c[i>>2]|0}if(h){N=c[S>>2]|0;O=c[ld>>2]|0;pk(od,nd);xM(b,N,O,374142,(a[Fc>>0]|0)<0?c[od>>2]|0:od,0);a1(od);if((a[sc>>0]|0)<0){y7(c[nd>>2]|0,0);c[tc>>2]=0;break}else{y7(nd,0);a[sc>>0]=0;break}}}}else{while(1){h=a[sc>>0]|0;h=((h<<24>>24<0?c[tc>>2]|0:h&255)|0)!=0;if((e|0)==(f|0))break;if(h)HX(nd,22884)|0;TX(od);Gk(od,c[e>>2]|0,10)|0;f=a[od+8+3>>0]|0;O=f<<24>>24<0;Ex(nd,O?c[od>>2]|0:od,O?c[od+4>>2]|0:f&255)|0;z5(od);e=e+4|0;f=c[i>>2]|0}if(h){N=c[S>>2]|0;O=c[ld>>2]|0;pk(od,nd);xM(b,N,O,374126,(a[Hc>>0]|0)<0?c[od>>2]|0:od,0);a1(od);if((a[sc>>0]|0)<0){y7(c[nd>>2]|0,0);c[tc>>2]=0;break}else{y7(nd,0);a[sc>>0]=0;break}}}while(0);i=d+404|0;f=c[i>>2]|0;e=c[d+400>>2]|0;do if((f|0)!=(e|0)){while(1){h=a[sc>>0]|0;h=((h<<24>>24<0?c[tc>>2]|0:h&255)|0)!=0;if((e|0)==(f|0))break;if(h)HX(nd,22884)|0;TX(od);Gk(od,c[e>>2]|0,10)|0;f=a[od+8+3>>0]|0;O=f<<24>>24<0;Ex(nd,O?c[od>>2]|0:od,O?c[od+4>>2]|0:f&255)|0;z5(od);e=e+4|0;f=c[i>>2]|0}if(h){N=c[S>>2]|0;O=c[ld>>2]|0;pk(od,nd);xM(b,N,O,374162,(a[Gc>>0]|0)<0?c[od>>2]|0:od,0);a1(od);if((a[sc>>0]|0)<0){y7(c[nd>>2]|0,0);c[tc>>2]=0;break}else{y7(nd,0);a[sc>>0]=0;break}}}while(0);z5(nd)}e=d+412|0;h=d+416|0;if((c[h>>2]|0)!=(c[e>>2]|0)){TX(nd);e=c[e>>2]|0;while(1){f=a[mc>>0]|0;f=((f<<24>>24<0?c[nc>>2]|0:f&255)|0)!=0;if((e|0)==(c[h>>2]|0))break;if(f)HX(nd,22884)|0;TX(od);Gk(od,c[e>>2]|0,10)|0;O=a[od+8+3>>0]|0;N=O<<24>>24<0;Ex(nd,N?c[od>>2]|0:od,N?c[od+4>>2]|0:O&255)|0;z5(od);e=e+4|0}do if(f){N=c[S>>2]|0;O=c[ld>>2]|0;pk(od,nd);xM(b,N,O,374168,(a[oc>>0]|0)<0?c[od>>2]|0:od,0);a1(od);if((a[mc>>0]|0)<0){y7(c[nd>>2]|0,0);c[nc>>2]=0;break}else{y7(nd,0);a[mc>>0]=0;break}}while(0);z5(nd)}D=d+88|0;F=d+92|0;j=c[D>>2]|0;i=((c[F>>2]|0)-j|0)/24|0;G=d+208|0;if(i>>>0>1?(N=j,O=G,(c[N>>2]|0)==(c[O>>2]|0)?(c[N+4>>2]|0)==(c[O+4>>2]|0):0):0){e=1;h=1;while(1){if((h|0)==(i|0))break;f=h+-1|0;N=j+(f*24|0)+8|0;O=j+(h*24|0)+8|0;if(!((((c[N>>2]|0)==(c[O>>2]|0)?(c[N+4>>2]|0)==(c[O+4>>2]|0):0)?(N=j+(f*24|0)|0,O=j+(h*24|0)|0,(c[N>>2]|0)==(c[O>>2]|0)?(c[N+4>>2]|0)==(c[O+4>>2]|0):0):0)?(c[j+(f*24|0)+16>>2]|0)==(c[j+(h*24|0)+16>>2]|0):0))e=0;h=h+1|0}if(e)aF(D)}J=d+248|0;K=d+216|0;if(!(a[T>>0]|0))I=d+240|0;else{I=c[S>>2]|0;N=c[ld>>2]|0;M=Rb(I,22)|0;L=J;Bt(b,I,N,M,(+((c[L>>2]|0)>>>0)+4294967296.0*+((c[L+4>>2]|0)>>>0))/+((c[K>>2]|0)>>>0)*1.0e3,0,1);L=c[S>>2]|0;M=c[ld>>2]|0;N=Rb(L,52)|0;I=d+240|0;O=I;oK(b,L,M,N,c[O>>2]|0,c[O+4>>2]|0,10,1)}E=d+232|0;H=w+277|0;M=d+36|0;N=d+136|0;B=d+64|0;C=d+236|0;O=d+140|0;L=d+40|0;if((c[U>>2]|0?(c[B>>2]|0)==0:0)?c[K>>2]|0:0){TX(nd);TX(od);f=d+256|0;A=f;e=c[A>>2]|0;i=d+172|0;if(!((e|0)==0&(c[A+4>>2]|0)==0))io(nd,+(e-(c[(c[i>>2]|0)+12>>2]|0)|0)*1.0e3/+((c[K>>2]|0)>>>0),0)|0;A=d+264|0;e=c[A>>2]|0;if(!((e|0)==0&(c[A+4>>2]|0)==0)){A=f;io(od,+(e-(c[(c[i>>2]|0)+((((c[A>>2]|0)!=0|(c[A+4>>2]|0)!=0)&1)<<3)+4>>2]|0)|0)*1.0e3/+((c[K>>2]|0)>>>0),0)|0}f=G;e=c[f>>2]|0;f=c[f+4>>2]|0;s=+((c[U>>2]|0)>>>0);j=J;t=(+((c[j>>2]|0)>>>0)+4294967296.0*+((c[j+4>>2]|0)>>>0))/+((c[K>>2]|0)>>>0);u=t*1.0e3;j=d+152|0;h=d+176|0;do if((a[T>>0]|0)==0&t!=0.0?(A=z0(e|0,f|0,-1,-1)|0,qd=(+(A>>>0)+4294967296.0*+(z>>>0))/s,A=z0(e|0,f|0,1,0)|0,t>=qd?!(t<=(+(A>>>0)+4294967296.0*+(z>>>0))/s):1):0){sN(b,c[S>>2]|0,c[ld>>2]|0,379270,u,0,0);Mc(b,c[S>>2]|0,c[ld>>2]|0,374177,nd,0);Mc(b,c[S>>2]|0,c[ld>>2]|0,374204,od,0);y=c[i>>2]|0;A=y;if(!((((c[h>>2]|0)-y|0)==8?(c[K>>2]|0)>>>0>=100:0)?(c[A+4>>2]|0)==1:0))Q=231;do if((Q|0)==231?(Q=0,(a[H>>0]|0)==0):0){f=I;e=c[f>>2]|0;f=c[f+4>>2]|0;if((e|0)==0&(f|0)==0)break;aL(b,c[S>>2]|0,c[ld>>2]|0,374230,e,f,0)}while(0);f=j;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e|0)==0&(f|0)==0))aL(b,c[S>>2]|0,c[ld>>2]|0,374248,e,f,0);y=c[S>>2]|0;A=c[ld>>2]|0;x=Rb(y,22)|0;e=G;Bt(b,y,A,x,(+((c[e>>2]|0)>>>0)+4294967296.0*+((c[e+4>>2]|0)>>>0))/+((c[U>>2]|0)>>>0)*1.0e3,0,1);mj(b,c[S>>2]|0,c[ld>>2]|0,374266);e=c[E>>2]|0;x=G;A=c[i>>2]|0;y=(c[h>>2]|0)-A|0;s=(+((c[x>>2]|0)>>>0)+4294967296.0*+((c[x+4>>2]|0)>>>0))/+((c[U>>2]|0)>>>0);do if(!e)Q=239;else{if((e|0)!=(c[C>>2]|0)){Q=239;break}j=c[K>>2]|0;k=cT(s*+(j>>>0)/+(e>>>0))|0;e=j;j=z}while(0);e:do if((Q|0)==239){Q=0;e=c[K>>2]|0;h=cT(s*+(e>>>0))|0;i=z;o=y>>3;f=0;r=0;v=0;k=0;j=0;while(1){if(f>>>0>=o>>>0)break e;p=c[A+(f<<3)>>2]|0;q=c[A+(f<<3)+4>>2]|0;w=UW(q|0,0,p|0,0)|0;w=z0(w|0,z|0,r|0,v|0)|0;x=z;if(!(x>>>0<i>>>0|(x|0)==(i|0)&w>>>0<h>>>0))break;q=z0(p|0,0,k|0,j|0)|0;f=f+1|0;r=w;v=x;k=q;j=z}if(!q)break;x=D_(h|0,i|0,r|0,v|0)|0;x=cT((+(x>>>0)+4294967296.0*+(z>>>0))/+(q>>>0))|0;k=z0(x|0,z|0,k|0,j|0)|0;j=z}while(0);if(!(!((y|0)!=8|e>>>0<100)?(c[A+4>>2]|0)==1:0))Q=247;do if((Q|0)==247){Q=0;if(a[H>>0]|0)break;aL(b,c[S>>2]|0,c[ld>>2]|0,374285,k,j,1)}while(0);i=c[N>>2]|0;e=c[O>>2]|0;if((i|0)==(e|0)){x=c[S>>2]|0;y=c[ld>>2]|0;w=d+184|0;w=UW(c[w>>2]|0,c[w+4>>2]|0,k|0,j|0)|0;A=d+192|0;A=UW(w|0,z|0,c[A>>2]|0,c[A+4>>2]|0)|0;aL(b,x,y,374296,A,z,0);break}if(j>>>0>0|(j|0)==0&k>>>0>e-i>>3>>>0)break;else{e=0;f=0;h=0}while(1){if(!(0<j>>>0|0==(j|0)&e>>>0<k>>>0))break;A=i+(e<<3)|0;A=z0(c[A>>2]|0,c[A+4>>2]|0,f|0,h|0)|0;e=e+1|0;f=A;h=z}gq(md,b,c[S>>2]|0,c[ld>>2]|0,374307);A=a[ec>>0]|0;A=((A<<24>>24<0?c[fc>>2]|0:A&255)|0)==0;z5(md);aL(b,c[S>>2]|0,c[ld>>2]|0,A?374296:374323,f,h,0)}else Q=255;while(0);if((Q|0)==255){Q=0;A=c[S>>2]|0;y=c[ld>>2]|0;$x(md,b,A,y,Rb(A,22)|0,1);A=a[gc>>0]|0;A=((A<<24>>24<0?c[hc>>2]|0:A&255)|0)==0;z5(md);if(A){A=c[S>>2]|0;y=c[ld>>2]|0;Bt(b,A,y,Rb(A,22)|0,u,0,0)}Mc(b,c[S>>2]|0,c[ld>>2]|0,374342,nd,0);Mc(b,c[S>>2]|0,c[ld>>2]|0,374266,od,0);y=c[i>>2]|0;A=y;if(!((((c[h>>2]|0)-y|0)==8?(c[K>>2]|0)>>>0>=100:0)?(c[A+4>>2]|0)==1:0))Q=260;do if((Q|0)==260?(0,(a[H>>0]|0)==0):0){Q=c[S>>2]|0;A=c[ld>>2]|0;$x(md,b,Q,A,Rb(Q,52)|0,1);Q=a[ic>>0]|0;if((Q<<24>>24<0?c[jc>>2]|0:Q&255)|0){z5(md);break}Q=I;Q=(c[Q>>2]|0)==0&(c[Q+4>>2]|0)==0;z5(md);if(Q)break;x=c[S>>2]|0;y=c[ld>>2]|0;A=Rb(x,52)|0;Q=I;oK(b,x,y,A,c[Q>>2]|0,c[Q+4>>2]|0,10,0)}while(0);f=c[L>>2]|0;e=c[M>>2]|0;h=e;do if((f-e|0)==4){gq(ed,c[h>>2]|0,c[S>>2]|0,c[ld>>2]|0,374307);Q=a[kc>>0]|0;if((Q<<24>>24<0?c[lc>>2]|0:Q&255)|0){e=1;Q=272;break}h=c[M>>2]|0;i=1;e=h;f=c[L>>2]|0;Q=268}else{i=0;Q=268}while(0);f:do if((Q|0)==268){Q=0;do if((f-e|0)==4){e=c[h>>2]|0;h=e+552|0;f=c[h>>2]|0;h=c[h+4>>2]|0;if((f|0)==0&(h|0)==0)break;e=e+576|0;e=(+((c[e>>2]|0)>>>0)+4294967296.0*+((c[e+4>>2]|0)>>>0))/(+(f>>>0)+4294967296.0*+(h>>>0))>.02;if(i){Q=272;break f}else break f}while(0);if(i){e=0;Q=272}else e=0}while(0);if((Q|0)==272){Q=0;z5(ed)}h=j;f=c[h>>2]|0;h=c[h+4>>2]|0;if(!((f|0)==0&(h|0)==0)){A=c[S>>2]|0;y=c[ld>>2]|0;oK(b,A,y,Rb(A,e?107:91)|0,f,h,10,0)}}z5(od);z5(nd)}D=c[D>>2]|0;e=D;f=e+16|0;h=e+8|0;switch(((c[F>>2]|0)-D|0)/24|0|0){case 2:{F=h;if(((((c[F>>2]|0)==-1&(c[F+4>>2]|0)==0?(Sc=e,Rc=c[Sc>>2]|0,Sc=c[Sc+4>>2]|0,Tc=e+24|0,Tc=z0(c[Tc>>2]|0,c[Tc+4>>2]|0,Rc|0,Sc|0)|0,Uc=z,F=G,(Tc|0)==(c[F>>2]|0)?(Uc|0)==(c[F+4>>2]|0):0):0)?(c[f>>2]|0)==65536:0)?(c[e+40>>2]|0)==65536:0)?(Vc=c[U>>2]|0,Vc|0):0){Lc=+(Rc>>>0)+4294967296.0*+(Sc>>>0);F=cT(Lc)|0;F=D_(Tc|0,Uc|0,F|0,z|0)|0;Q=G;c[Q>>2]=F;c[Q+4>>2]=z;Lc=Lc/+(Vc>>>0);Q=287}break}case 1:{F=e;if((((c[F>>2]|0)==(c[G>>2]|0)?(c[F+4>>2]|0)==(c[G+4>>2]|0):0)?(c[f>>2]|0)==65536:0)?c[U>>2]|0:0){Q=h;Lc=-(+((c[Q>>2]|0)>>>0)+4294967296.0*+((c[Q+4>>2]|0)>>>0));Q=c[K>>2]|0;Lc=(Q|0)==0?Lc:Lc/+(Q>>>0);Q=287}break}default:{}}if(((Q|0)==287?(Q=0,Lc!=0.0):0)?(gq(nd,b,c[S>>2]|0,c[ld>>2]|0,379270),G=a[_b>>0]|0,G=((G<<24>>24<0?c[$b>>2]|0:G&255)|0)==0,z5(nd),!G):0){G=c[S>>2]|0;F=c[ld>>2]|0;$x(nd,b,G,F,Rb(G,63)|0,1);s=Lc+ +Eq(nd)/1.0e3;z5(nd);G=c[S>>2]|0;F=c[ld>>2]|0;$x(nd,b,G,F,Rb(G,72)|0,1);G=a[ac>>0]|0;do if(!((G<<24>>24<0?c[bc>>2]|0:G&255)|0))z5(nd);else{e=c[S>>2]|0;G=c[ld>>2]|0;$x(od,b,e,G,Rb(e,72)|0,1);e=i9(22972)|0;G=a[cc>>0]|0;if((e|0)==((G<<24>>24<0?c[dc>>2]|0:G&255)|0)){G=(VG(od,22972,e)|0)==0;z5(od);z5(nd);if(G)break}else{z5(od);z5(nd)}G=c[S>>2]|0;F=c[ld>>2]|0;D=Rb(G,74)|0;$x(nd,b,G,F,Rb(G,63)|0,1);zb(b,G,F,D,nd,0);z5(nd);D=c[S>>2]|0;F=c[ld>>2]|0;G=Rb(D,83)|0;$x(nd,b,D,F,Rb(D,72)|0,1);zb(b,D,F,G,nd,0);z5(nd)}while(0);sN(b,c[S>>2]|0,c[ld>>2]|0,374362,s*1.0e3,0,1);xM(b,c[S>>2]|0,c[ld>>2]|0,374375,380001,1);Ou(b,c[S>>2]|0,c[ld>>2]|0,374362,382945);Ou(b,c[S>>2]|0,c[ld>>2]|0,374375,382945)}do if(((((c[S>>2]|0)==1?(c[B>>2]|0)==0:0)?(Wc=c[K>>2]|0,Wc|0):0)?(Xc=c[E>>2]|0,Xc|0):0)?(Yc=c[C>>2]|0,Yc|0):0){qd=+(Wc>>>0);s=qd/+(Yc>>>0);e=c[ld>>2]|0;if((Xc|0)!=(Yc|0)?qd/+(Xc>>>0)-s>=.001:0){Bt(b,1,e,175,s,3,1);e=c[E>>2]|0;if(e|0)Bt(b,1,c[ld>>2]|0,179,+((c[K>>2]|0)>>>0)/+(e>>>0),3,1);f=J;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e|0)==0&(f|0)==0))Bt(b,1,c[ld>>2]|0,171,(+((c[I>>2]|0)>>>0)+4294967296.0*+((c[I+4>>2]|0)>>>0))/(+(e>>>0)+4294967296.0*+(f>>>0))*+((c[K>>2]|0)>>>0),3,1);RB(b,1,c[ld>>2]|0,167,380821,-1,1,1);break}Bt(b,1,e,171,s,3,1);RB(b,1,c[ld>>2]|0,167,374395,-1,1,1)}while(0);if(((a[T>>0]|0)==0?(J,_c=d+224|0,Zc=c[_c>>2]|0,_c=c[_c+4>>2]|0,!((c[J>>2]|0)==(Zc|0)?(c[J+4>>2]|0)==(_c|0):0)):0)?($c=c[K>>2]|0,$c|0):0)sN(b,c[S>>2]|0,c[ld>>2]|0,374399,(+(Zc>>>0)+4294967296.0*+(_c>>>0))/+($c>>>0)*1.0e3,0,0);if((a[H>>0]|0?(ad=c[M>>2]|0,bd=c[L>>2]|0,(ad|0)!=(bd|0)):0)?(c[(c[ad>>2]|0)+728>>2]&1|0)==0:0){h=0;e=bd;i=ad;f=ad;while(1){if(h>>>0>=((e-i>>2)+-1|0)>>>0)break;f=c[i+(h<<2)>>2]|0;if(!f)f=i;else{jb[c[(c[f>>2]|0)+4>>2]&511](f);e=c[L>>2]|0;f=c[M>>2]|0}h=h+1|0;i=f}xI(M,i,f+(e-f>>2<<2)+-4|0);pO(c[c[M>>2]>>2]|0)}K=c[M>>2]|0;e=K;p=d+4|0;g:do if(((c[L>>2]|0)-K|0)==4){if(+g[(c[V>>2]|0)+136>>2]<=1.0){s4(c[e>>2]|0);Kl(c[c[M>>2]>>2]|0);e=c[M>>2]|0}G2(b,c[e>>2]|0);if(!(c[S>>2]|0)){e=c[Ic>>2]|0;h:while(1){if((e|0)==(Jc|0))break g;f=c[e+68>>2]|0;if(f|0)Gb(b,c[c[M>>2]>>2]|0,f,0,c[e+72>>2]|0,1)|0;f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue h}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}}TX(nd);TX(od);TX(md);TX(fd);do if((c[S>>2]|0)==1){do if(c[c[M>>2]>>2]|0){$x(gd,b,1,0,55,1);e=i9(23012)|0;Q=a[Y>>0]|0;if((e|0)!=((Q<<24>>24<0?c[Z>>2]|0:Q&255)|0)){z5(gd);break}Q=(VG(gd,23012,e)|0)==0;z5(gd);if(!Q)break;Ed(c[c[M>>2]>>2]|0,1,0,171);Ed(c[c[M>>2]>>2]|0,1,0,130);Ed(c[c[M>>2]>>2]|0,1,0,138);Ed(c[c[M>>2]>>2]|0,1,0,156);Ed(c[c[M>>2]>>2]|0,1,0,150)}while(0);$x(gd,b,1,c[ld>>2]|0,171,1);vF(nd,gd)|0;z5(gd);$x(gd,b,1,c[ld>>2]|0,167,1);vF(od,gd)|0;z5(gd);$x(gd,b,1,c[ld>>2]|0,76,1);vF(md,gd)|0;z5(gd);$x(gd,b,1,c[ld>>2]|0,217,1);vF(fd,gd)|0;z5(gd);e=Vj(c[c[M>>2]>>2]|0,1,0,18,1)|0;f=i9(29144)|0;Q=a[e+8+3>>0]|0;if((f|0)==((Q<<24>>24<0?c[e+4>>2]|0:Q&255)|0)){if(VG(e,29144,f)|0)break;$x(gd,b,1,c[S>>2]|0,130,1);e=i9(38164)|0;Q=a[W>>0]|0;if((e|0)!=((Q<<24>>24<0?c[X>>2]|0:Q&255)|0)){z5(gd);break}Q=(VG(gd,38164,e)|0)==0;z5(gd);if(!Q)break;Ed(b,1,c[S>>2]|0,130)}}while(0);$x(gd,c[c[M>>2]>>2]|0,0,0,57,1);e=i9(23052)|0;Q=a[_>>0]|0;do if((e|0)==((Q<<24>>24<0?c[$>>2]|0:Q&255)|0)?(VG(gd,23052,e)|0)==0:0){if(!(RA(c[c[M>>2]>>2]|0,2,-1)|0)){Q=349;break}z5(gd);Q=355}else Q=349;while(0);i:do if((Q|0)==349){Q=0;$x(hd,c[c[M>>2]>>2]|0,0,0,57,1);e=i9(22772)|0;L=a[aa>>0]|0;do if((e|0)==((L<<24>>24<0?c[ba>>2]|0:L&255)|0)){if(VG(hd,22772,e)|0)break;z5(hd);z5(gd);Q=355;break i}while(0);$x(id,c[c[M>>2]>>2]|0,0,0,57,1);e=i9(23116)|0;L=a[ca>>0]|0;if((e|0)==((L<<24>>24<0?c[da>>2]|0:L&255)|0)){L=(VG(id,23116,e)|0)==0;z5(id);z5(hd);z5(gd);if(L){Q=355;break}}else{z5(id);z5(hd);z5(gd)}mj(c[c[M>>2]>>2]|0,c[S>>2]|0,c[ld>>2]|0,374285);k=RA(c[c[M>>2]>>2]|0,c[S>>2]|0,-1)|0;TX(gd);mI(hd);xA(id);do if(k>>>0>1){$x(jd,b,c[S>>2]|0,c[ld>>2]|0,10,1);vF(gd,jd)|0;z5(jd);e=c[S>>2]|0;if((e|0)==7){j=0;break}de(jd,(c[(c[c[fa>>2]>>2]|0)+(e*12|0)>>2]|0)+((c[ld>>2]|0)*40|0)|0);og(hd,jd);z5(jd);hq(jd,(c[(c[c[ea>>2]>>2]|0)+((c[S>>2]|0)*12|0)>>2]|0)+((c[ld>>2]|0)*56|0)|0);bf(id,jd);z5(jd);j=0}else j=0;while(0);while(1){if(j>>>0>=k>>>0)break;i=(j|0)!=0;j:do if(i){Kc(b,c[S>>2]|0,(c[ld>>2]|0)+j|0)|0;e=c[p>>2]|0;if(!e){f=d;while(1){e=c[f+8>>2]|0;if((c[e>>2]|0)==(f|0))break;else f=e}}else while(1){f=c[e>>2]|0;if(!f)break;else e=f}k:while(1){if((e|0)==(Jc|0))break j;if((c[e+68>>2]|0)==(c[S>>2]|0)){L=e+72|0;c[L>>2]=(c[L>>2]|0)+1}f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue k}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}}while(0);Gb(b,c[c[M>>2]>>2]|0,c[S>>2]|0,j,c[ld>>2]|0,1)|0;$x(jd,c[c[M>>2]>>2]|0,c[S>>2]|0,j,10,1);L=a[Xa>>0]|0;if((L<<24>>24<0?c[Ya>>2]|0:L&255)|0){f=c[S>>2]|0;h=c[ld>>2]|0;nt(Pc,gd,45);e=a[Xa>>0]|0;L=e<<24>>24<0;Ex(Pc,L?c[jd>>2]|0:jd,L?c[Ya>>2]|0:e&255)|0;c[Oc>>2]=c[Pc>>2];c[Oc+4>>2]=c[Pc+4>>2];c[Oc+8>>2]=c[Pc+8>>2];e=0;while(1){if((e|0)==3)break;c[Pc+(e<<2)>>2]=0;e=e+1|0}p2(Nc,Oc);zb(b,f,h,10,Nc,1);z5(Nc);O0(Oc);O0(Pc)}l:do if(i){e=0;while(1){if(e>>>0>=(((c[Za>>2]|0)-(c[hd>>2]|0)|0)/12|0)>>>0){e=0;break}$x(Nc,b,c[S>>2]|0,c[ld>>2]|0,e,1);L=a[_a>>0]|0;L=((L<<24>>24<0?c[$a>>2]|0:L&255)|0)==0;z5(Nc);if(L)zb(b,c[S>>2]|0,c[ld>>2]|0,e,(c[hd>>2]|0)+(e*12|0)|0,0);e=e+1|0}while(1){if(e>>>0>=(((c[ab>>2]|0)-(c[id>>2]|0)|0)/40|0)>>>0)break l;H=c[S>>2]|0;I=c[ld>>2]|0;pk(Nc,wF(id,e,0)|0);J=a[bb>>0]|0;K=c[Nc>>2]|0;L=wF(id,e,1)|0;Mc(b,H,I,J<<24>>24<0?K:Nc,L,0);a1(Nc);e=e+1|0}}while(0);z5(jd);j=j+1|0}$x(jd,c[c[M>>2]>>2]|0,0,0,250,1);L=a[cb>>0]|0;if((L<<24>>24<0?c[db>>2]|0:L&255)|0)zb(b,0,0,250,jd,1);$x(Nc,c[c[M>>2]>>2]|0,0,0,159,1);L=a[eb>>0]|0;do if((L<<24>>24<0?c[fb>>2]|0:L&255)|0){$x(Oc,b,0,0,159,1);L=a[lb>>0]|0;L=((L<<24>>24<0?c[mb>>2]|0:L&255)|0)==0;z5(Oc);if(!L)break;zb(b,0,0,159,Nc,0)}while(0);$x(Oc,c[c[M>>2]>>2]|0,0,0,255,1);L=a[gb>>0]|0;do if((L<<24>>24<0?c[hb>>2]|0:L&255)|0){$x(Pc,b,0,0,255,1);L=a[ib>>0]|0;L=((L<<24>>24<0?c[kb>>2]|0:L&255)|0)==0;z5(Pc);if(!L)break;zb(b,0,0,255,Oc,0)}while(0);z5(Oc);z5(Nc);z5(jd);LT(id);$_(hd);z5(gd)}while(0);if((Q|0)==355){Q=0;L=c[S>>2]|0;K=c[ld>>2]|0;Ed(b,L,K,Rb(L,91)|0);if((c[S>>2]|0)==2)Ed(b,2,c[ld>>2]|0,38);mI(gd);xA(hd);e=c[S>>2]|0;if((e|0)==7)o=7;else{de(id,(c[(c[c[fa>>2]>>2]|0)+(e*12|0)>>2]|0)+((c[ld>>2]|0)*40|0)|0);og(gd,id);z5(id);hq(id,(c[(c[c[ea>>2]>>2]|0)+((c[S>>2]|0)*12|0)>>2]|0)+((c[ld>>2]|0)*56|0)|0);bf(hd,id);z5(id);o=c[S>>2]|0}TX(id);$x(jd,c[c[M>>2]>>2]|0,0,0,57,1);e=i9(23052)|0;L=a[ga>>0]|0;if((e|0)==((L<<24>>24<0?c[ha>>2]|0:L&255)|0))e=(VG(jd,23052,e)|0)==0;else e=0;z5(jd);f=c[ld>>2]|0;m:do if(e){i=f&-2;f=f|1;$x(Pc,b,c[S>>2]|0,i,10,1);HX(Pc,41840)|0;c[Oc>>2]=c[Pc>>2];c[Oc+4>>2]=c[Pc+4>>2];c[Oc+8>>2]=c[Pc+8>>2];e=0;while(1){if((e|0)==3)break;c[Pc+(e<<2)>>2]=0;e=e+1|0}$x(Qc,b,c[S>>2]|0,f,10,1);e=a[ia>>0]|0;L=e<<24>>24<0;Ex(Oc,L?c[Qc>>2]|0:Qc,L?c[ja>>2]|0:e&255)|0;c[Nc>>2]=c[Oc>>2];c[Nc+4>>2]=c[Oc+4>>2];c[Nc+8>>2]=c[Oc+8>>2];e=0;while(1){if((e|0)==3)break;c[Oc+(e<<2)>>2]=0;e=e+1|0}p2(jd,Nc);vF(id,jd)|0;z5(jd);O0(Nc);z5(Qc);O0(Oc);z5(Pc);xd(b,o,f);xd(b,o,i);e=c[p>>2]|0;if(!e){f=d;while(1){e=c[f+8>>2]|0;if((c[e>>2]|0)==(f|0))break;else f=e}}else while(1){f=c[e>>2]|0;if(!f)break;else e=f}h=(RA(c[c[M>>2]>>2]|0,2,-1)|0)+-2|0;n:while(1){if((e|0)==(Jc|0)){f=i;break m}if((c[e+68>>2]|0)==2){L=e+72|0;c[L>>2]=h+(c[L>>2]|0)}f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue n}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}}else{$x(jd,b,c[S>>2]|0,f,10,1);vF(id,jd)|0;z5(jd);xd(b,c[S>>2]|0,c[ld>>2]|0)}while(0);k=RA(c[c[M>>2]>>2]|0,o,-1)|0;j=0;while(1){if(j>>>0>=k>>>0)break;Kc(b,o,j+f|0)|0;Gb(b,c[c[M>>2]>>2]|0,c[S>>2]|0,j,c[ld>>2]|0,1)|0;$x(jd,b,c[S>>2]|0,c[ld>>2]|0,10,1);h=c[S>>2]|0;i=c[ld>>2]|0;Bs(Pc,id,42040);e=a[ka>>0]|0;L=e<<24>>24<0;Ex(Pc,L?c[jd>>2]|0:jd,L?c[la>>2]|0:e&255)|0;c[Oc>>2]=c[Pc>>2];c[Oc+4>>2]=c[Pc+4>>2];c[Oc+8>>2]=c[Pc+8>>2];e=0;while(1){if((e|0)==3)break;c[Pc+(e<<2)>>2]=0;e=e+1|0}p2(Nc,Oc);zb(b,h,i,10,Nc,1);z5(Nc);O0(Oc);O0(Pc);e=0;while(1){if(e>>>0>=(((c[ma>>2]|0)-(c[gd>>2]|0)|0)/12|0)>>>0){e=0;break}$x(Nc,b,c[S>>2]|0,c[ld>>2]|0,e,1);L=a[na>>0]|0;L=((L<<24>>24<0?c[oa>>2]|0:L&255)|0)==0;z5(Nc);if(L)zb(b,c[S>>2]|0,c[ld>>2]|0,e,(c[gd>>2]|0)+(e*12|0)|0,0);e=e+1|0}while(1){if(e>>>0>=(((c[pa>>2]|0)-(c[hd>>2]|0)|0)/40|0)>>>0)break;H=c[S>>2]|0;I=c[ld>>2]|0;pk(Nc,wF(hd,e,0)|0);J=a[qa>>0]|0;K=c[Nc>>2]|0;L=wF(hd,e,1)|0;Mc(b,H,I,J<<24>>24<0?K:Nc,L,0);a1(Nc);e=e+1|0}z5(jd);j=j+1|0}$x(jd,c[c[M>>2]>>2]|0,0,0,250,1);L=a[ra>>0]|0;if((L<<24>>24<0?c[sa>>2]|0:L&255)|0)zb(b,0,0,250,jd,1);$x(Nc,c[c[M>>2]>>2]|0,0,0,159,1);L=a[ta>>0]|0;do if((L<<24>>24<0?c[ua>>2]|0:L&255)|0){$x(Oc,b,0,0,159,1);L=a[va>>0]|0;L=((L<<24>>24<0?c[wa>>2]|0:L&255)|0)==0;z5(Oc);if(!L)break;zb(b,0,0,159,Nc,0)}while(0);z5(Nc);z5(jd);z5(id);LT(hd);$_(gd)}e=c[S>>2]|0;if((e|0)==1){zb(b,1,c[ld>>2]|0,76,md,1);L=a[xa>>0]|0;do if((L<<24>>24<0?c[ya>>2]|0:L&255)|0){$x(gd,b,1,c[ld>>2]|0,171,1);f=a[xa>>0]|0;e=f<<24>>24<0;f=e?c[ya>>2]|0:f&255;L=a[La>>0]|0;h=L<<24>>24<0;if((f|0)==((h?c[Ma>>2]|0:L&255)|0)){L=(L$(e?c[nd>>2]|0:nd,h?c[gd>>2]|0:gd,f)|0)==0;z5(gd);if(L)break}else z5(gd);zb(b,1,c[ld>>2]|0,171,nd,1)}while(0);L=a[za>>0]|0;do if((L<<24>>24<0?c[Aa>>2]|0:L&255)|0){$x(gd,b,1,c[ld>>2]|0,167,1);f=a[za>>0]|0;e=f<<24>>24<0;f=e?c[Aa>>2]|0:f&255;L=a[Ja>>0]|0;h=L<<24>>24<0;if((f|0)==((h?c[Ka>>2]|0:L&255)|0)){L=(L$(e?c[od>>2]|0:od,h?c[gd>>2]|0:gd,f)|0)==0;z5(gd);if(L)break}else z5(gd);zb(b,1,c[ld>>2]|0,167,od,1)}while(0);L=a[Ba>>0]|0;o:do if((L<<24>>24<0?c[Ca>>2]|0:L&255)|0){$x(gd,b,1,c[ld>>2]|0,217,1);f=a[Ba>>0]|0;e=f<<24>>24<0;f=e?c[Ca>>2]|0:f&255;L=a[Da>>0]|0;h=L<<24>>24<0;if((f|0)==((h?c[Ea>>2]|0:L&255)|0)){L=(L$(e?c[fd>>2]|0:fd,h?c[gd>>2]|0:gd,f)|0)==0;z5(gd);if(L)break;else e=0}else{z5(gd);e=0}while(1){if(e>>>0>=(RA(b,2,-1)|0)>>>0){e=0;break}gq(gd,b,2,e,379121);f=i9(23172)|0;L=a[Fa>>0]|0;do if((f|0)==((L<<24>>24<0?c[Ga>>2]|0:L&255)|0)){L=(VG(gd,23172,f)|0)==0;z5(gd);if(!L)break;$x(gd,b,1,c[ld>>2]|0,217,1);zb(b,2,e,156,gd,1);z5(gd);$x(gd,b,1,c[ld>>2]|0,224,1);zb(b,2,e,163,gd,1);z5(gd);$x(gd,b,1,c[ld>>2]|0,226,1);zb(b,2,e,165,gd,1);z5(gd);$x(gd,b,1,c[ld>>2]|0,228,1);zb(b,2,e,167,gd,1);z5(gd);$x(gd,b,1,c[ld>>2]|0,235,1);zb(b,2,e,174,gd,1);z5(gd);$x(gd,b,1,c[ld>>2]|0,237,1);zb(b,2,e,176,gd,1);z5(gd)}else z5(gd);while(0);e=e+1|0}while(1){if(e>>>0>=(RA(b,3,-1)|0)>>>0)break o;gq(gd,b,3,e,379121);f=i9(23172)|0;L=a[Ha>>0]|0;do if((f|0)==((L<<24>>24<0?c[Ia>>2]|0:L&255)|0)){L=(VG(gd,23172,f)|0)==0;z5(gd);if(!L)break;$x(gd,b,1,c[ld>>2]|0,217,1);zb(b,3,e,126,gd,1);z5(gd);$x(gd,b,1,c[ld>>2]|0,224,1);zb(b,3,e,133,gd,1);z5(gd);$x(gd,b,1,c[ld>>2]|0,226,1);zb(b,3,e,135,gd,1);z5(gd);$x(gd,b,1,c[ld>>2]|0,228,1);zb(b,3,e,137,gd,1);z5(gd);$x(gd,b,1,c[ld>>2]|0,235,1);zb(b,3,e,144,gd,1);z5(gd);$x(gd,b,1,c[ld>>2]|0,237,1);zb(b,3,e,146,gd,1);z5(gd)}else z5(gd);while(0);e=e+1|0}}while(0);e=c[S>>2]|0}p:do if((e|0)==2){$x(gd,b,2,c[ld>>2]|0,18,1);e=i9(29652)|0;L=a[Na>>0]|0;do if((e|0)==((L<<24>>24<0?c[Oa>>2]|0:L&255)|0)){if(VG(gd,29652,e)|0){Q=471;break}z5(gd)}else Q=471;while(0);q:do if((Q|0)==471){Q=0;$x(hd,b,2,c[ld>>2]|0,18,1);e=i9(40168)|0;L=a[Pa>>0]|0;do if((e|0)==((L<<24>>24<0?c[Qa>>2]|0:L&255)|0)){if(VG(hd,40168,e)|0)break;z5(hd);z5(gd);break q}while(0);$x(id,b,2,c[ld>>2]|0,18,1);e=i9(29668)|0;L=a[Ra>>0]|0;if((e|0)==((L<<24>>24<0?c[Sa>>2]|0:L&255)|0)){L=(VG(id,29668,e)|0)==0;z5(id);z5(hd);z5(gd);if(L)break;else break p}else{z5(id);z5(hd);z5(gd);break p}}while(0);Ed(b,2,c[ld>>2]|0,147)}while(0);do if((c[S>>2]|0)==1){e=c[c[M>>2]>>2]|0;if(!e)break;if((RA(e,2,-1)|0)==0?(RA(c[c[M>>2]>>2]|0,3,-1)|0)==0:0)break;h=RA(c[c[M>>2]>>2]|0,2,-1)|0;f=0;while(1){if(f>>>0>=h>>>0)break;lJ(b);Kc(b,2,-1)|0;i=(RA(b,2,-1)|0)+-1|0;Gb(b,c[c[M>>2]>>2]|0,2,f,c[ld>>2]|0,1)|0;$x(gd,c[c[M>>2]>>2]|0,0,0,57,1);zb(b,2,i,44,gd,0);z5(gd);TX(id);Gk(id,(c[R>>2]|0)+1|0,10)|0;ms(hd,28664,id);p2(gd,hd);zb(b,2,i,45,gd,0);z5(gd);O0(hd);z5(id);$x(gd,b,1,c[R>>2]|0,76,1);zb(b,2,i,68,gd,0);z5(gd);sM(b,2,i,217,0,0);$x(gd,b,2,i,10,1);$x(Nc,b,1,c[R>>2]|0,10,1);HX(Nc,42040)|0;c[jd>>2]=c[Nc>>2];c[jd+4>>2]=c[Nc+4>>2];c[jd+8>>2]=c[Nc+8>>2];e=0;while(1){if((e|0)==3)break;c[Nc+(e<<2)>>2]=0;e=e+1|0}e=a[Ta>>0]|0;L=e<<24>>24<0;Ex(jd,L?c[gd>>2]|0:gd,L?c[Ua>>2]|0:e&255)|0;c[id>>2]=c[jd>>2];c[id+4>>2]=c[jd+4>>2];c[id+8>>2]=c[jd+8>>2];e=0;while(1){if((e|0)==3)break;c[jd+(e<<2)>>2]=0;e=e+1|0}p2(hd,id);zb(b,2,i,10,hd,1);z5(hd);O0(id);O0(jd);z5(Nc);gq(hd,b,1,c[R>>2]|0,374413);Mc(b,2,i,374413,hd,0);z5(hd);gq(hd,b,1,c[R>>2]|0,374420);Mc(b,2,i,374420,hd,0);z5(hd);z5(gd);f=f+1|0}h=RA(c[c[M>>2]>>2]|0,3,-1)|0;f=0;while(1){if(f>>>0>=h>>>0)break;lJ(b);Kc(b,3,-1)|0;i=(RA(b,3,-1)|0)+-1|0;Gb(b,c[c[M>>2]>>2]|0,3,f,c[ld>>2]|0,1)|0;$x(gd,c[c[M>>2]>>2]|0,0,0,57,1);zb(b,3,i,29,gd,0);z5(gd);TX(id);Gk(id,(c[R>>2]|0)+1|0,10)|0;ms(hd,28664,id);p2(gd,hd);zb(b,3,i,30,gd,0);z5(gd);O0(hd);z5(id);$x(gd,b,1,c[R>>2]|0,76,1);zb(b,3,i,42,gd,0);z5(gd);sM(b,3,i,184,0,0);$x(gd,b,3,i,10,1);$x(Nc,b,1,c[R>>2]|0,10,1);HX(Nc,42040)|0;c[jd>>2]=c[Nc>>2];c[jd+4>>2]=c[Nc+4>>2];c[jd+8>>2]=c[Nc+8>>2];e=0;while(1){if((e|0)==3)break;c[Nc+(e<<2)>>2]=0;e=e+1|0}e=a[Va>>0]|0;L=e<<24>>24<0;Ex(jd,L?c[gd>>2]|0:gd,L?c[Wa>>2]|0:e&255)|0;c[id>>2]=c[jd>>2];c[id+4>>2]=c[jd+4>>2];c[id+8>>2]=c[jd+8>>2];e=0;while(1){if((e|0)==3)break;c[jd+(e<<2)>>2]=0;e=e+1|0}p2(hd,id);zb(b,3,i,10,hd,1);z5(hd);O0(id);O0(jd);z5(Nc);gq(hd,b,1,c[R>>2]|0,374413);Mc(b,3,i,374413,hd,0);z5(hd);gq(hd,b,1,c[R>>2]|0,374420);Mc(b,3,i,374420,hd,0);z5(hd);z5(gd);f=f+1|0}c[S>>2]=c[P>>2];c[ld>>2]=c[R>>2]}while(0);z5(fd);z5(md);z5(od);z5(nd)}while(0);o=d+60|0;M=c[o>>2]|0;if((M|0)!=0?(c[M+20>>2]|0)!=0:0){j=c[P>>2]|0;c[S>>2]=j;k=c[R>>2]|0;c[ld>>2]=k;$x(nd,b,j,k,Rb(j,12)|0,1);gq(od,b,c[S>>2]|0,c[ld>>2]|0,374413);gq(md,b,c[S>>2]|0,c[ld>>2]|0,374420);Gb(b,c[(c[o>>2]|0)+20>>2]|0,c[P>>2]|0,0,c[R>>2]|0,1)|0;Dk(fd,c[o>>2]|0,0,0,86,1);j=rm(fd)|0;j=z0(j|0,z|0,n|0,m|0)|0;k=z;z5(fd);f=c[S>>2]|0;e=c[ld>>2]|0;$x(fd,b,f,e,Rb(f,12)|0,1);f=a[xb>>0]|0;e=f<<24>>24<0;f=e?c[yb>>2]|0:f&255;P=a[Ab>>0]|0;h=P<<24>>24<0;if((f|0)==((h?c[Bb>>2]|0:P&255)|0)){P=(L$(e?c[nd>>2]|0:nd,h?c[fd>>2]|0:fd,f)|0)==0;z5(fd);if(!P)Q=507}else{z5(fd);Q=507}if((Q|0)==507){Q=0;P=a[xb>>0]|0;if((P<<24>>24<0?c[yb>>2]|0:P&255)|0)HX(nd,41840)|0;P=c[S>>2]|0;M=c[ld>>2]|0;$x(fd,b,P,M,Rb(P,12)|0,1);P=a[Yb>>0]|0;M=P<<24>>24<0;Ex(nd,M?c[fd>>2]|0:fd,M?c[Zb>>2]|0:P&255)|0;z5(fd);P=c[S>>2]|0;M=c[ld>>2]|0;zb(b,P,M,Rb(P,12)|0,nd,1)}gq(fd,b,c[S>>2]|0,c[ld>>2]|0,374413);f=a[Cb>>0]|0;e=f<<24>>24<0;f=e?c[Db>>2]|0:f&255;P=a[Eb>>0]|0;h=P<<24>>24<0;if((f|0)==((h?c[Fb>>2]|0:P&255)|0)){P=(L$(e?c[od>>2]|0:od,h?c[fd>>2]|0:fd,f)|0)==0;z5(fd);if(!P)Q=513}else{z5(fd);Q=513}if((Q|0)==513){gq(fd,b,c[S>>2]|0,c[ld>>2]|0,374413);gq(gd,b,c[S>>2]|0,c[ld>>2]|0,374420);Mc(b,c[S>>2]|0,c[ld>>2]|0,374413,od,1);Mc(b,c[S>>2]|0,c[ld>>2]|0,374420,md,1);Mc(b,c[S>>2]|0,c[ld>>2]|0,374432,fd,1);Mc(b,c[S>>2]|0,c[ld>>2]|0,374448,gd,1);z5(gd);z5(fd)}r:do if((c[S>>2]|0)==2){$x(fd,b,2,c[ld>>2]|0,18,1);e=i9(28648)|0;Q=a[Hb>>0]|0;do if((e|0)==((Q<<24>>24<0?c[Ib>>2]|0:Q&255)|0)){if(VG(fd,28648,e)|0)break;z5(fd);break r}while(0);$x(gd,b,2,c[ld>>2]|0,124,1);Q=a[Jb>>0]|0;Q=((Q<<24>>24<0?c[Kb>>2]|0:Q&255)|0)==0;z5(gd);z5(fd);if(Q)break;Ed(b,2,c[ld>>2]|0,124);sM(b,2,c[ld>>2]|0,122,6,1)}while(0);P=c[S>>2]|0;Q=c[ld>>2]|0;Dk(fd,c[o>>2]|0,0,0,57,1);Mc(b,P,Q,382758,fd,0);z5(fd);s:do if((c[S>>2]|0)==1){e=c[(c[o>>2]|0)+20>>2]|0;if(!e)break;if((RA(e,2,-1)|0)==0?(RA(c[(c[o>>2]|0)+20>>2]|0,3,-1)|0)==0:0)break;h=RA(c[(c[o>>2]|0)+20>>2]|0,2,-1)|0;f=0;while(1){if(f>>>0>=h>>>0)break;lJ(b);Kc(b,2,-1)|0;i=(RA(b,2,-1)|0)+-1|0;Gb(b,c[(c[o>>2]|0)+20>>2]|0,2,f,c[ld>>2]|0,1)|0;$x(fd,b,2,i,44,1);Q=a[Lb>>0]|0;Q=((Q<<24>>24<0?c[Mb>>2]|0:Q&255)|0)==0;z5(fd);if(Q){$x(fd,b,1,c[R>>2]|0,18,1);zb(b,2,i,44,fd,1);z5(fd)}else{$x(id,b,1,c[R>>2]|0,18,1);HX(id,41840)|0;c[hd>>2]=c[id>>2];c[hd+4>>2]=c[id+4>>2];c[hd+8>>2]=c[id+8>>2];e=0;while(1){if((e|0)==3)break;c[id+(e<<2)>>2]=0;e=e+1|0}$x(jd,b,2,i,44,1);e=a[Pb>>0]|0;Q=e<<24>>24<0;Ex(hd,Q?c[jd>>2]|0:jd,Q?c[Qb>>2]|0:e&255)|0;c[gd>>2]=c[hd>>2];c[gd+4>>2]=c[hd+4>>2];c[gd+8>>2]=c[hd+8>>2];e=0;while(1){if((e|0)==3)break;c[hd+(e<<2)>>2]=0;e=e+1|0}p2(fd,gd);zb(b,2,i,44,fd,1);z5(fd);O0(gd);z5(jd);O0(hd);z5(id)}TX(hd);Gk(hd,(c[R>>2]|0)+1|0,10)|0;ms(gd,28664,hd);p2(fd,gd);zb(b,2,i,45,fd,0);z5(fd);O0(gd);z5(hd);$x(fd,b,1,c[R>>2]|0,76,1);zb(b,2,i,68,fd,1);z5(fd);sM(b,2,i,217,0,0);$x(fd,b,2,i,10,1);$x(jd,b,1,c[R>>2]|0,10,1);HX(jd,42040)|0;c[id>>2]=c[jd>>2];c[id+4>>2]=c[jd+4>>2];c[id+8>>2]=c[jd+8>>2];e=0;while(1){if((e|0)==3)break;c[jd+(e<<2)>>2]=0;e=e+1|0}e=a[Nb>>0]|0;Q=e<<24>>24<0;Ex(id,Q?c[fd>>2]|0:fd,Q?c[Ob>>2]|0:e&255)|0;c[hd>>2]=c[id>>2];c[hd+4>>2]=c[id+4>>2];c[hd+8>>2]=c[id+8>>2];e=0;while(1){if((e|0)==3)break;c[id+(e<<2)>>2]=0;e=e+1|0}p2(gd,hd);zb(b,2,i,10,gd,1);z5(gd);O0(hd);O0(id);z5(jd);gq(gd,b,1,c[R>>2]|0,374413);Mc(b,2,i,374413,gd,0);z5(gd);gq(gd,b,1,c[R>>2]|0,374420);Mc(b,2,i,374420,gd,0);z5(gd);z5(fd);f=f+1|0}h=RA(c[(c[o>>2]|0)+20>>2]|0,3,-1)|0;f=0;while(1){if(f>>>0>=h>>>0)break s;lJ(b);Kc(b,3,-1)|0;i=(RA(b,3,-1)|0)+-1|0;Gb(b,c[(c[o>>2]|0)+20>>2]|0,3,f,c[ld>>2]|0,1)|0;$x(fd,b,3,i,29,1);Q=a[Sb>>0]|0;Q=((Q<<24>>24<0?c[Tb>>2]|0:Q&255)|0)==0;z5(fd);if(Q){$x(fd,b,1,c[R>>2]|0,18,1);zb(b,3,i,29,fd,1);z5(fd)}else{$x(id,b,1,c[R>>2]|0,18,1);HX(id,41840)|0;c[hd>>2]=c[id>>2];c[hd+4>>2]=c[id+4>>2];c[hd+8>>2]=c[id+8>>2];e=0;while(1){if((e|0)==3)break;c[id+(e<<2)>>2]=0;e=e+1|0}$x(jd,b,3,i,29,1);e=a[Wb>>0]|0;Q=e<<24>>24<0;Ex(hd,Q?c[jd>>2]|0:jd,Q?c[Xb>>2]|0:e&255)|0;c[gd>>2]=c[hd>>2];c[gd+4>>2]=c[hd+4>>2];c[gd+8>>2]=c[hd+8>>2];e=0;while(1){if((e|0)==3)break;c[hd+(e<<2)>>2]=0;e=e+1|0}p2(fd,gd);zb(b,3,i,29,fd,1);z5(fd);O0(gd);z5(jd);O0(hd);z5(id)}TX(hd);Gk(hd,(c[R>>2]|0)+1|0,10)|0;ms(gd,28664,hd);p2(fd,gd);zb(b,3,i,30,fd,0);z5(fd);O0(gd);z5(hd);$x(fd,b,1,c[R>>2]|0,76,1);zb(b,3,i,42,fd,0);z5(fd);sM(b,3,i,184,0,0);$x(fd,b,3,i,10,1);$x(jd,b,1,c[R>>2]|0,10,1);HX(jd,42040)|0;c[id>>2]=c[jd>>2];c[id+4>>2]=c[jd+4>>2];c[id+8>>2]=c[jd+8>>2];e=0;while(1){if((e|0)==3)break;c[jd+(e<<2)>>2]=0;e=e+1|0}e=a[Ub>>0]|0;Q=e<<24>>24<0;Ex(id,Q?c[fd>>2]|0:fd,Q?c[Vb>>2]|0:e&255)|0;c[hd>>2]=c[id>>2];c[hd+4>>2]=c[id+4>>2];c[hd+8>>2]=c[id+8>>2];e=0;while(1){if((e|0)==3)break;c[id+(e<<2)>>2]=0;e=e+1|0}p2(gd,hd);zb(b,3,i,10,gd,1);z5(gd);O0(hd);O0(id);z5(jd);gq(gd,b,1,c[R>>2]|0,374413);Mc(b,3,i,374413,gd,0);z5(gd);gq(gd,b,1,c[R>>2]|0,374420);Mc(b,3,i,374420,gd,0);z5(gd);z5(fd);f=f+1|0}}while(0);z5(md);z5(od);z5(nd);n=j;m=k}s=+g[d+424>>2];if(s!=0.0){sN(b,1,c[ld>>2]|0,374469,s,0,1);sN(b,1,c[ld>>2]|0,374489,+g[d+428>>2],0,1);sN(b,1,c[ld>>2]|0,374510,+g[d+432>>2],3,1)}do if((c[S>>2]|0)==2){$x(nd,b,2,c[ld>>2]|0,122,1);e=i9(25220)|0;R=a[nb>>0]|0;if((e|0)==((R<<24>>24<0?c[ob>>2]|0:R&255)|0)?(VG(nd,25220,e)|0)==0:0){$x(od,b,2,c[ld>>2]|0,132,1);R=a[pb>>0]|0;if((R<<24>>24<0?c[qb>>2]|0:R&255)|0){z5(od);z5(nd);break}$x(md,b,2,c[ld>>2]|0,128,1);R=a[rb>>0]|0;if((R<<24>>24<0?c[sb>>2]|0:R&255)|0){z5(md);z5(od);z5(nd);break}$x(fd,b,0,0,65,1);e=i9(23244)|0;R=a[tb>>0]|0;if((e|0)!=((R<<24>>24<0?c[ub>>2]|0:R&255)|0)){z5(fd);z5(md);z5(od);z5(nd);break}R=(VG(fd,23244,e)|0)==0;z5(fd);z5(md);z5(od);z5(nd);if(!R)break;R=c[ld>>2]|0;RB(b,2,R,128,rl(101)|0,-1,1,0);R=c[ld>>2]|0;RB(b,2,R,132,el(101)|0,-1,1,0);break}z5(nd)}while(0);gq(nd,b,c[S>>2]|0,c[ld>>2]|0,387802);R=a[vb>>0]|0;R=((R<<24>>24<0?c[wb>>2]|0:R&255)|0)==0;z5(nd);do if((R?(c[d+160>>2]|0)==(c[d+164>>2]|0):0)?(dd=c[N>>2]|0,cd=(c[O>>2]|0)-dd|0,dd,cd|0):0){if(a[T>>0]|0)break;f=cd>>3;e=0;h=-1;i=-1;j=0;k=0;while(1){if((e|0)==(f|0))break;R=dd+(e<<3)|0;P=c[R>>2]|0;R=c[R+4>>2]|0;O=R>>>0<i>>>0|(R|0)==(i|0)&P>>>0<h>>>0;Q=R>>>0>k>>>0|(R|0)==(k|0)&P>>>0>j>>>0;e=e+1|0;h=O?P:h;i=O?R:i;j=Q?P:j;k=Q?R:k}e=c[S>>2]|0;f=c[ld>>2]|0;if((+(h>>>0)+4294967296.0*+(i>>>0))*1.0099999999999998<+(j>>>0)+4294967296.0*+(k>>>0)){xM(b,e,f,387802,384435,0);break}else{xM(b,e,f,387802,384431,0);break}}while(0);h=d+52|0;e=c[d+48>>2]|0;t:while(1){if((e|0)==(h|0))break;f=e+16|0;if((a[f+11>>0]|0)<0)f=c[f>>2]|0;Mc(b,c[S>>2]|0,c[ld>>2]|0,f,e+28|0,0);f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue t}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}e=c[p>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue d}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}i=b+828|0;d=c[i>>2]|0;switch(d|0){case -1:case 0:break;default:{Nq(nd,d);e=b+832|0;f=b+840+3|0;d=a[f>>0]|0;h=b+836|0;if(d<<24>>24<0)d=c[h>>2]|0;else d=d&255;if(d|0){Gx(nd,32);md=a[f>>0]|0;ld=md<<24>>24<0;Ex(nd,ld?c[e>>2]|0:e,ld?c[h>>2]|0:md&255)|0}zb(b,0,0,273,nd,0);Nq(od,c[i>>2]|0);zb(b,0,0,276,od,0);z5(od);zb(b,0,0,277,e,0);z5(nd)}}od=kd;if(!((n|0)==(c[od>>2]|0)?(m|0)==(c[od+4>>2]|0):0))oK(b,0,0,86,n,m,10,1);if(((RA(b,1,-1)|0)==0?(RA(b,5,-1)|0)==0:0)?RA(b,2,-1)|0:0)RB(b,0,0,69,374541,-1,1,1);pc(b)}l=pd;return}function zb(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0;_=l;l=l+368|0;Z=_+328|0;Y=_+272|0;X=_+232|0;W=_+192|0;L=_+152|0;M=_+112|0;N=_+96|0;E=_+84|0;F=_+72|0;G=_+60|0;H=_+48|0;P=_+36|0;Q=_+24|0;R=_+12|0;S=_;o=b+735|0;a:do if(!(a[o>>0]|0)){if(!((d|0)>7|(f|0)==-1)){if((oH(g,13,0)|0)==-1?(oH(g,10,0)|0)==-1:0){b:do if((d|0)==7){i=1;while(1){if(i>>>0>=7){d=i;break b}if((c[b+380+(i*12|0)>>2]|0)!=(c[b+380+(i*12|0)+4>>2]|0)){d=i;break b}i=i+1|0}}else{U=b+4|0;K=c[c[U>>2]>>2]|0;T=c[K+(d*12|0)>>2]|0;j=T;if((((c[K+(d*12|0)+4>>2]|0)-T|0)/40|0)>>>0<=e>>>0){o=b+464|0;s=b+468|0;p=b+380+(d*12|0)+4|0;q=b+380+(d*12|0)+8|0;r=b+380+(d*12|0)|0;k=0;while(1){i=c[s>>2]|0;e=c[o>>2]|0;j=e;if(k>>>0>=((i-e|0)/24|0)>>>0)break;i=j+(k*24|0)|0;j=c[p>>2]|0;if((j|0)==(c[q>>2]|0))Sv(r,i);else{h0(j,i);c[p>>2]=(c[p>>2]|0)+24}k=k+1|0}while(1){if((i|0)==(j|0))break b;e=i+-24|0;c[s>>2]=e;w4(e);i=c[s>>2]|0}}k=Rb(d,3)|0;o=(Rb(d,4)|0)==(f|0);K=o|((k|0)==(f|0)|h);I=g+8+3|0;i=a[I>>0]|0;J=g+4|0;i=((i<<24>>24<0?c[J>>2]|0:i&255)|0)==0;if(K){if(i){Ed(b,d,e,f);break a}}else if(i)break a;i=DN(j+(e*40|0)|0,f)|0;T=a[i+8+3>>0]|0;if(K|((T<<24>>24<0?c[i+4>>2]|0:T&255)|0)==0)k1(i,g)|0;else{kT(Z);T=a[Z+8+3>>0]|0;D=T<<24>>24<0;Ex(i,D?c[Z>>2]|0:Z,D?c[Z+4>>2]|0:T&255)|0;z5(Z);T=a[I>>0]|0;D=T<<24>>24<0;Ex(i,D?c[g>>2]|0:g,D?c[J>>2]|0:T&255)|0}T=b+728|0;c[T>>2]=c[T>>2]|4;if((Rb(d,58)|0)==(f|0)){T=Rb(d,56)|0;$x(Z,b,d,e,f,1);zb(b,d,e,T,Z,1);z5(Z)}T=(d|0)==1;c:do if(!(T&(f|0)==190)){switch(d|0){case 1:{V=93;break c}case 2:break;case 5:switch(f|0){case 57:{Md(b,g,5,e,41,47,53,57);break c}case 53:{lj(b,g,5,e,41,47,57);break c}case 59:{Md(b,g,5,e,45,51,55,59);break c}case 55:{lj(b,g,5,e,45,51,59);break c}default:break c}default:break c}if((f|0)==134?($x(Z,b,2,e,139,1),D=a[Z+8+3>>0]|0,D=((D<<24>>24<0?c[Z+4>>2]|0:D&255)|0)==0,z5(Z),D):0){n=+Eq(g);mI(Z);VU(Y,357786);z3(Z,Y);z5(Y);$x(Y,b,2,e,135,1);og(Z,Y);z5(Y);j=c[Z>>2]|0;i=c[Z+4>>2]|0;d:do if((j|0)==(i|0))m=1797693134862315708145274.0e284;else{m=1797693134862315708145274.0e284;i=(i-j|0)/12|0;while(1){i=i+-1|0;$=+Eq(j+(i*12|0)|0);m=$!=0.0&$<m?$:m;if(!i)break d;j=c[Z>>2]|0}}while(0);if(n!=m&(m!=1797693134862315708145274.0e284&(n!=0.0&m!=0.0)))KW(b,2,e,139,m/n,3,0);$_(Z)}}else{zb(b,1,e,192,g,K);V=93}while(0);e:do if((V|0)==93){D=f+-130|0;i=b+493|0;switch(D>>>1|D<<31|0){case 0:{if(!(a[i>>0]|0))break e;zb(b,1,e,148,g,0);break e}case 4:{if(!(a[i>>0]|0))break e;zb(b,1,e,149,g,0);break e}case 13:{Md(b,g,1,e,130,138,150,156);break e}case 10:{lj(b,g,1,e,130,138,156);break e}case 15:{Md(b,g,1,e,136,144,154,160);break e}case 12:{lj(b,g,1,e,136,144,160);break e}case 14:{Md(b,g,1,e,134,142,152,158);break e}case 11:{lj(b,g,1,e,134,142,158);break e}default:break e}}while(0);y=Rb(d,0)|0;C=(y|0)==(f|0);if(C)zb(b,d,e,k,g,0);if(o)zb(b,d,e,k,g,1);if(a[b+492>>0]|0)break a;$x(Z,b,d,e,f,0);D=(d|0)==0;f:do if(!D){i=i9(6412)|0;A=Z+8+3|0;j=a[A>>0]|0;B=Z+4|0;k=c[B>>2]|0;do if((i|0)==((j<<24>>24<0?k:j&255)|0)){if(!(VG(Z,6412,i)|0))break;j=a[A>>0]|0;k=c[B>>2]|0;V=127}else V=127;while(0);do if((V|0)==127){i=i9(6464)|0;if((i|0)==((j<<24>>24<0?k:j&255)|0)){if(!(VG(Z,6464,i)|0))break;j=a[A>>0]|0;k=c[B>>2]|0}i=i9(9488)|0;if((i|0)==((j<<24>>24<0?k:j&255)|0)){if(!(VG(Z,9488,i)|0))break;j=a[A>>0]|0;k=c[B>>2]|0}i=i9(6528)|0;if((i|0)!=((j<<24>>24<0?k:j&255)|0))break f;if(VG(Z,6528,i)|0)break f}while(0);TX(Y);TX(X);p=W+8+3|0;q=W+4|0;r=W+8+3|0;s=W+4|0;t=W+8+3|0;h=W+4|0;u=W+8+3|0;v=W+4|0;w=W+8+3|0;x=W+4|0;o=0;while(1){k=c[c[U>>2]>>2]|0;if(o>>>0>=(((c[k+(d*12|0)+4>>2]|0)-(c[k+(d*12|0)>>2]|0)|0)/40|0)>>>0)break;i=i9(6528)|0;k=a[A>>0]|0;do if((i|0)==((k<<24>>24<0?c[B>>2]|0:k&255)|0)){if(VG(Z,6528,i)|0){V=144;break}$x(L,b,d,o,y,1);HX(L,41840)|0;c[W>>2]=c[L>>2];c[W+4>>2]=c[L+4>>2];c[W+8>>2]=c[L+8>>2];i=0;while(1){if((i|0)==3)break;c[L+(i<<2)>>2]=0;i=i+1|0}k=a[p>>0]|0;j=k<<24>>24<0;Ex(Y,j?c[W>>2]|0:W,j?c[q>>2]|0:k&255)|0;O0(W);z5(L)}else V=144;while(0);if((V|0)==144){$x(L,b,d,o,f,1);HX(L,41840)|0;c[W>>2]=c[L>>2];c[W+4>>2]=c[L+4>>2];c[W+8>>2]=c[L+8>>2];i=0;while(1){if((i|0)==3)break;c[L+(i<<2)>>2]=0;i=i+1|0}V=a[w>>0]|0;k=V<<24>>24<0;Ex(Y,k?c[W>>2]|0:W,k?c[x>>2]|0:V&255)|0;O0(W);z5(L)}i=i9(9488)|0;j=a[A>>0]|0;k=c[B>>2]|0;do if((i|0)==((j<<24>>24<0?k:j&255)|0)){if(!(VG(Z,9488,i)|0)){V=153;break}j=a[A>>0]|0;k=c[B>>2]|0;V=151}else V=151;while(0);do if((V|0)==151){V=0;i=i9(6528)|0;if((i|0)!=((j<<24>>24<0?k:j&255)|0))break;if(!(VG(Z,6528,i)|0))V=153}while(0);if((V|0)==153){V=0;$x(W,b,d,o,y,1);i=a[r>>0]|0;k=i<<24>>24<0;Ex(X,k?c[W>>2]|0:W,k?c[s>>2]|0:i&255)|0;z5(W);i=Rb(d,14)|0;$x(W,b,d,o,i,1);k=a[t>>0]|0;k=((k<<24>>24<0?c[h>>2]|0:k&255)|0)==0;z5(W);if(!k){HX(X,39932)|0;$x(W,b,d,o,i,1);k=a[u>>0]|0;j=k<<24>>24<0;Ex(X,j?c[W>>2]|0:W,j?c[v>>2]|0:k&255)|0;z5(W);HX(X,39944)|0}HX(X,41840)|0}o=o+1|0}i=a[Y+8+3>>0]|0;i=i<<24>>24<0?c[Y+4>>2]|0:i&255;if(i|0)FB(Y,i+-3|0,0);i=a[X+8+3>>0]|0;i=i<<24>>24<0?c[X+4>>2]|0:i&255;if(i|0)FB(X,i+-3|0,0);p2(W,Vj(b,d,0,3,1)|0);i=i9(6412)|0;V=a[A>>0]|0;do if((i|0)==((V<<24>>24<0?c[B>>2]|0:V&255)|0)){if(VG(Z,6412,i)|0)break;Bs(N,W,6064);p2(M,N);pk(L,M);Mc(b,0,0,(a[L+11>>0]|0)<0?c[L>>2]|0:L,Y,1);a1(L);z5(M);O0(N)}while(0);i=i9(6464)|0;V=a[A>>0]|0;do if((i|0)==((V<<24>>24<0?c[B>>2]|0:V&255)|0)){if(VG(Z,6464,i)|0)break;Bs(N,W,6112);p2(M,N);pk(L,M);Mc(b,0,0,(a[L+11>>0]|0)<0?c[L>>2]|0:L,Y,1);a1(L);z5(M);O0(N)}while(0);i=i9(9488)|0;k=a[A>>0]|0;j=c[B>>2]|0;do if((i|0)==((k<<24>>24<0?j:k&255)|0)){if(!(VG(Z,9488,i)|0)){V=171;break}k=a[A>>0]|0;j=c[B>>2]|0;V=169}else V=169;while(0);do if((V|0)==169){i=i9(6528)|0;if((i|0)!=((k<<24>>24<0?j:k&255)|0))break;if(!(VG(Z,6528,i)|0))V=171}while(0);if((V|0)==171){Bs(N,W,6172);p2(M,N);pk(L,M);Mc(b,0,0,(a[L+11>>0]|0)<0?c[L>>2]|0:L,Y,1);a1(L);z5(M);O0(N);Bs(N,W,6224);p2(M,N);pk(L,M);Mc(b,0,0,(a[L+11>>0]|0)<0?c[L>>2]|0:L,X,1);a1(L);z5(M);O0(N)}z5(W);z5(X);z5(Y)}while(0);do if(C){$x(Y,b,0,0,57,1);V=a[Y+8+3>>0]|0;if((V<<24>>24<0?c[Y+4>>2]|0:V&255)|0){z5(Y);break}V=a[I>>0]|0;V=((V<<24>>24<0?c[J>>2]|0:V&255)|0)==0;z5(Y);if(V)break;zb(b,0,0,57,g,0)}while(0);if((f|0)==10)zb(b,d,e,11,g,K);do if(C){j=Rb(d,1)|0;do if(K){$x(E,b,d,e,f,1);C=OJ(E,5)|0;V=a[C+8+3>>0]|0;if(!((V<<24>>24<0?c[C+4>>2]|0:V&255)|0)){i=1;V=184;break}z5(E);V=187}else{i=0;V=184}while(0);do if((V|0)==184){$x(Y,b,d,e,j,1);k=a[Y+8+3>>0]|0;k=((k<<24>>24<0?c[Y+4>>2]|0:k&255)|0)==0;z5(Y);if(i){z5(E);if(k){V=187;break}else break}else if(k){V=187;break}else break}while(0);if((V|0)==187){$x(Y,b,d,e,f,1);zb(b,d,e,j,OJ(Y,5)|0,1);z5(Y)}j=Rb(d,2)|0;do if(K){$x(F,b,d,e,f,1);E=OJ(F,8)|0;V=a[E+8+3>>0]|0;if(!((V<<24>>24<0?c[E+4>>2]|0:V&255)|0)){i=1;V=191;break}z5(F);V=194}else{i=0;V=191}while(0);do if((V|0)==191){$x(Y,b,d,e,j,1);k=a[Y+8+3>>0]|0;k=((k<<24>>24<0?c[Y+4>>2]|0:k&255)|0)==0;z5(Y);if(i){z5(F);if(k){V=194;break}else break}else if(k){V=194;break}else break}while(0);if((V|0)==194){$x(Y,b,d,e,f,1);zb(b,d,e,j,OJ(Y,8)|0,1);z5(Y)}g:do if((d|0)!=6){j=Rb(d,11)|0;do if(K){$x(G,b,d,e,f,1);F=OJ(G,7)|0;V=a[F+8+3>>0]|0;if(!((V<<24>>24<0?c[F+4>>2]|0:V&255)|0)){i=1;V=199;break}z5(G);V=202}else{i=0;V=199}while(0);do if((V|0)==199){$x(Y,b,d,e,j,1);k=a[Y+8+3>>0]|0;k=((k<<24>>24<0?c[Y+4>>2]|0:k&255)|0)==0;z5(Y);if(i){z5(G);if(k){V=202;break}else break}else if(k){V=202;break}else break}while(0);if((V|0)==202){$x(Y,b,d,e,f,1);zb(b,d,e,j,OJ(Y,7)|0,1);z5(Y)}j=Rb(d,60)|0;do if(K){$x(H,b,d,e,f,1);F=OJ(H,9)|0;G=a[F+8+3>>0]|0;if(!((G<<24>>24<0?c[F+4>>2]|0:G&255)|0)){i=1;V=206;break}z5(H)}else{i=0;V=206}while(0);do if((V|0)==206){$x(Y,b,d,e,j,1);k=a[Y+8+3>>0]|0;k=((k<<24>>24<0?c[Y+4>>2]|0:k&255)|0)==0;z5(Y);if(i){z5(H);if(k)break;else break g}else if(k)break;else break g}while(0);$x(Y,b,d,e,f,1);zb(b,d,e,j,OJ(Y,9)|0,1);z5(Y)}while(0);if(!D)break;zb(b,0,0,61,OJ(g,6)|0,1);zb(b,0,0,58,g,1);zb(b,0,0,79,g,1);zb(b,0,0,80,g,1);V=212}else V=212;while(0);do if((V|0)==212){if(D&(f|0)==59){k1(DN(c[c[c[U>>2]>>2]>>2]|0,81)|0,g)|0;break}if(D&(f|0)==60){k1(DN(c[c[c[U>>2]>>2]>>2]|0,82)|0,g)|0;break}if(D&(f|0)==61){k1(DN(c[c[c[U>>2]>>2]>>2]|0,83)|0,g)|0;break}if(!(D&(f|0)==68))break;k1(DN(c[c[c[U>>2]>>2]>>2]|0,84)|0,g)|0}while(0);do if((Rb(d,17)|0)==(f|0)){if(!(UT()|0))break;$x(Y,b,d,e,f,1);i=po(Y,1,d)|0;z5(Y);V=a[i+8+3>>0]|0;V=((V<<24>>24<0?c[i+4>>2]|0:V&255)|0)==0;j=Rb(d,18)|0;if(V){zb(b,d,e,j,g,1);break}else{gq(Y,b,d,e,357198);zb(b,d,e,j,i,1);$x(X,b,d,e,f,1);Mc(b,d,e,357198,po(X,4,d)|0,1);z5(X);$x(X,b,d,e,f,1);p2(W,po(X,4,d)|0);V=Rb(d,19)|0;$x(L,b,d,e,f,1);zb(b,d,e,V,po(L,6,d)|0,1);z5(L);V=Rb(d,20)|0;$x(L,b,d,e,f,1);zb(b,d,e,V,po(L,7,d)|0,1);z5(L);z5(W);z5(X);z5(Y);break}}while(0);do if((Rb(d,13)|0)==(f|0)){j=Rb(d,16)|0;$x(Y,b,d,e,j,1);o=a[Y+8+3>>0]|0;k=o<<24>>24<0;o=k?c[Y+4>>2]|0:o&255;V=a[I>>0]|0;i=V<<24>>24<0;if((o|0)!=((i?c[J>>2]|0:V&255)|0)){z5(Y);break}V=(L$(k?c[Y>>2]|0:Y,i?c[g>>2]|0:g,o)|0)==0;z5(Y);if(!V)break;Ed(b,d,e,j)}while(0);i=(Rb(d,38)|0)==(f|0);if(!i?(Rb(d,42)|0)!=(f|0):0)V=235;else{gq(Y,b,d,e,384534);$=+Cq(Y);z5(Y);gq(Y,b,d,e,378202);n=+Cq(Y);z5(Y);if(n>$*.95&n<$*1.05){gq(Y,b,d,e,378202);mj(b,d,e,378202);Mc(b,d,e,384534,Y,1);z5(Y)}if(i)V=236;else V=235}if((V|0)==235?(Rb(d,44)|0)==(f|0):0)V=236;do if((V|0)==236){gq(Y,b,d,e,384534);n=+Cq(Y);z5(Y);gq(Y,b,d,e,387665);$=+Cq(Y);z5(Y);if(!(n>$*.99&n<$*1.01))break;gq(Y,b,d,e,387665);mj(b,d,e,387665);Mc(b,d,e,384534,Y,1);z5(Y)}while(0);if(D&(f|0)==86){k=b+40|0;p=k;o=c[p>>2]|0;p=c[p+4>>2]|0;J=rm(g)|0;j=k;c[j>>2]=J;c[j+4>>2]=z;j=1;while(1){if(j>>>0<6)i=0;else break;while(1){if(i>>>0>=(RA(b,j,-1)|0)>>>0)break;jc(b,j,i,Rb(j,91)|0);i=i+1|0}j=j+1|0}J=k;c[J>>2]=o;c[J+4>>2]=p}u=T&(e|0)==0&(f|0)==217;h:do if(u){k=Y+8+3|0;o=Y+4|0;j=0;while(1){if(j>>>0>=(RA(b,2,-1)|0)>>>0)break;$x(Y,b,2,j,156,1);J=a[k>>0]|0;J=((J<<24>>24<0?c[o>>2]|0:J&255)|0)==0;z5(Y);i:do if(!J){$x(Y,b,2,j,156,1);H=tm(Y)|0;I=z;J=tm(g)|0;J=D_(H|0,I|0,J|0,z|0)|0;jL(b,2,j,177,J,z,1);z5(Y);$x(Y,b,2,j,177,1);J=rm(Y)|0;J=(J|0)==0&(z|0)==0;z5(Y);if(J)i=178;else break;while(1){if((i|0)==182)break i;I=c[(c[c[U>>2]>>2]|0)+24>>2]|0;J=c[I+(j*40|0)>>2]|0;p=J;do if(i>>>0<(((c[I+(j*40|0)+4>>2]|0)-J|0)/12|0)>>>0){q=p+(i*12|0)|0;r=p+(i*12|0)+8+3|0;if((a[r>>0]|0)<0){y7(c[q>>2]|0,0);c[p+(i*12|0)+4>>2]=0;break}else{y7(q,0);a[r>>0]=0;break}}while(0);i=i+1|0}}while(0);j=j+1|0}k=Y+8+3|0;o=Y+4|0;j=0;while(1){if(j>>>0>=(RA(b,3,-1)|0)>>>0)break h;$x(Y,b,3,j,126,1);J=a[k>>0]|0;J=((J<<24>>24<0?c[o>>2]|0:J&255)|0)==0;z5(Y);j:do if(!J){$x(Y,b,3,j,126,1);H=tm(Y)|0;I=z;J=tm(g)|0;J=D_(H|0,I|0,J|0,z|0)|0;jL(b,3,j,147,J,z,1);z5(Y);$x(Y,b,3,j,147,1);J=rm(Y)|0;J=(J|0)==0&(z|0)==0;z5(Y);if(J)i=148;else break;while(1){if((i|0)==152)break j;I=c[(c[c[U>>2]>>2]|0)+36>>2]|0;J=c[I+(j*40|0)>>2]|0;p=J;do if(i>>>0<(((c[I+(j*40|0)+4>>2]|0)-J|0)/12|0)>>>0){q=p+(i*12|0)|0;r=p+(i*12|0)+8+3|0;if((a[r>>0]|0)<0){y7(c[q>>2]|0,0);c[p+(i*12|0)+4>>2]=0;break}else{y7(q,0);a[r>>0]=0;break}}while(0);i=i+1|0}}while(0);j=j+1|0}}while(0);J=(d|0)==2;v=J&(f|0)==156;do if(v){if(!(RA(b,1,-1)|0)){h=0;t=0;s=0;break}$x(Y,b,2,e,156,1);I=a[Y+8+3>>0]|0;if(!((I<<24>>24<0?c[Y+4>>2]|0:I&255)|0)){z5(Y);h=0;t=0;s=0;break}$x(X,b,1,0,217,1);I=a[X+8+3>>0]|0;I=((I<<24>>24<0?c[X+4>>2]|0:I&255)|0)==0;z5(X);z5(Y);if(I){h=0;t=0;s=0;break}if(K)Ed(b,2,e,177);mI(Y);Xy(X,41840);z3(Y,X);z5(X);$x(X,b,2,e,156,1);og(Y,X);z5(X);mI(X);Xy(W,41840);z3(X,W);z5(W);$x(W,b,1,0,217,1);og(X,W);z5(W);I=c[Y>>2]|0;V=c[Y+4>>2]|0;i=V;j=I;k:do if((I|0)!=(V|0)){k=c[X>>2]|0;o=X+4|0;p=c[o>>2]|0;if((k|0)==(p|0))break;i=(i-j|0)/12|0;if(i>>>0>((p-k|0)/12|0)>>>0)break;H=tm(DN(Y,i+-1|0)|0)|0;I=z;V=tm(DN(X,(((c[o>>2]|0)-(c[X>>2]|0)|0)/12|0)+-1|0)|0)|0;V=D_(H|0,I|0,V|0,z|0)|0;jL(b,2,e,177,V,z,0);if(((c[o>>2]|0)-(c[X>>2]|0)|0)!=12)break;$x(W,b,2,e,177,1);V=rm(W)|0;V=(V|0)==0&(z|0)==0;z5(W);if(V)i=178;else break;while(1){if((i|0)==182)break k;I=c[(c[c[U>>2]>>2]|0)+24>>2]|0;V=c[I+(e*40|0)>>2]|0;j=V;do if(i>>>0<(((c[I+(e*40|0)+4>>2]|0)-V|0)/12|0)>>>0){k=j+(i*12|0)|0;o=j+(i*12|0)+8+3|0;if((a[o>>0]|0)<0){y7(c[k>>2]|0,0);c[j+(i*12|0)+4>>2]=0;break}else{y7(k,0);a[o>>0]=0;break}}while(0);i=i+1|0}}while(0);$_(X);$_(Y);V=287}else V=287;while(0);do if((V|0)==287){i=(f|0)==126;if((d|0)==3&i){if(!(RA(b,1,-1)|0)){h=1;t=0;s=1;break}$x(Y,b,3,e,126,1);I=a[Y+8+3>>0]|0;if(!((I<<24>>24<0?c[Y+4>>2]|0:I&255)|0)){z5(Y);h=1;t=0;s=1;break}$x(X,b,1,0,217,1);I=a[X+8+3>>0]|0;I=((I<<24>>24<0?c[X+4>>2]|0:I&255)|0)==0;z5(X);z5(Y);if(I){h=1;t=0;s=1;break}k=c[(c[b>>2]|0)+8>>2]|0;VU(X,379121);p2(Y,lb[k&63](b,3,e,X,1,0)|0);z5(X);c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;k=i9(28664)|0;if(k>>>0>1073741807)uaa();i=W+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){_=ua(8)|0;K2(_,391652);c[_>>2]=57868;Ya(_|0,2712,367)}else{I=ZW(j<<2)|0;c[W>>2]=I;c[i>>2]=j|-2147483648;c[W+4>>2]=k;i=I;break}}else{a[i+3>>0]=k;i=W}while(0);a3(i,28664,k);y7(i+(k<<2)|0,0);TX(L);Ok(X,Y,W,L,0,0);z5(L);O0(W);I=rm(X)|0;G=tm(g)|0;H=z;$x(W,b,1,(I|0)==0?0:I+-1|0,217,1);I=tm(W)|0;I=D_(G|0,H|0,I|0,z|0)|0;jL(b,3,e,147,I,z,1);z5(W);$x(W,b,3,e,147,1);I=rm(W)|0;I=(I|0)==0&(z|0)==0;z5(W);l:do if(I){i=148;while(1){if((i|0)==152)break l;H=c[(c[c[U>>2]>>2]|0)+36>>2]|0;I=c[H+(e*40|0)>>2]|0;j=I;do if(i>>>0<(((c[H+(e*40|0)+4>>2]|0)-I|0)/12|0)>>>0){k=j+(i*12|0)|0;o=j+(i*12|0)+8+3|0;if((a[o>>0]|0)<0){y7(c[k>>2]|0,0);c[j+(i*12|0)+4>>2]=0;break}else{y7(k,0);a[o>>0]=0;break}}while(0);i=i+1|0}}while(0);z5(X);z5(Y);i=1;r=1}else r=0;j=(d|0)==4;if(!(j&(f|0)==49)){h=i;t=j;s=r;break}if(!(RA(b,1,-1)|0)){h=i;t=1;s=r;break}$x(Y,b,4,e,49,1);I=a[Y+8+3>>0]|0;if(!((I<<24>>24<0?c[Y+4>>2]|0:I&255)|0)){z5(Y);h=i;t=1;s=r;break}$x(X,b,1,0,217,1);I=a[X+8+3>>0]|0;I=((I<<24>>24<0?c[X+4>>2]|0:I&255)|0)==0;z5(X);z5(Y);if(I){h=i;t=1;s=r;break}if(K)Ed(b,4,e,70);mI(Y);Xy(X,41840);z3(Y,X);z5(X);$x(X,b,4,e,49,1);og(Y,X);z5(X);mI(X);Xy(W,41840);z3(X,W);z5(W);$x(W,b,1,0,217,1);og(X,W);z5(W);H=c[Y>>2]|0;I=c[Y+4>>2]|0;j=I;k=H;m:do if((H|0)!=(I|0)){o=c[X>>2]|0;p=X+4|0;q=c[p>>2]|0;if((o|0)==(q|0))break;j=(j-k|0)/12|0;if(j>>>0>((q-o|0)/12|0)>>>0)break;G=tm(DN(Y,j+-1|0)|0)|0;H=z;I=tm(DN(X,(((c[p>>2]|0)-(c[X>>2]|0)|0)/12|0)+-1|0)|0)|0;I=D_(G|0,H|0,I|0,z|0)|0;jL(b,4,e,70,I,z,0);if(((c[p>>2]|0)-(c[X>>2]|0)|0)!=12)break;$x(W,b,4,e,70,1);I=rm(W)|0;I=(I|0)==0&(z|0)==0;z5(W);if(I)j=71;else break;while(1){if((j|0)==75)break m;H=c[(c[c[U>>2]>>2]|0)+48>>2]|0;I=c[H+(e*40|0)>>2]|0;k=I;do if(j>>>0<(((c[H+(e*40|0)+4>>2]|0)-I|0)/12|0)>>>0){o=k+(j*12|0)|0;p=k+(j*12|0)+8+3|0;if((a[p>>0]|0)<0){y7(c[o>>2]|0,0);c[k+(j*12|0)+4>>2]=0;break}else{y7(o,0);a[p>>0]=0;break}}while(0);j=j+1|0}}while(0);$_(X);$_(Y);h=i;t=1;s=r}while(0);n:do if(u){k=Y+8+3|0;o=Y+4|0;j=0;while(1){if(j>>>0>=(RA(b,2,-1)|0)>>>0)break;$x(Y,b,2,j,156,1);I=a[k>>0]|0;I=((I<<24>>24<0?c[o>>2]|0:I&255)|0)==0;z5(Y);o:do if(!I){$x(Y,b,2,j,156,1);G=tm(Y)|0;H=z;I=tm(g)|0;I=D_(G|0,H|0,I|0,z|0)|0;jL(b,2,j,184,I,z,1);z5(Y);$x(Y,b,2,j,184,1);I=rm(Y)|0;I=(I|0)==0&(z|0)==0;z5(Y);if(I)i=185;else break;while(1){if((i|0)==189)break o;H=c[(c[c[U>>2]>>2]|0)+24>>2]|0;I=c[H+(j*40|0)>>2]|0;p=I;do if(i>>>0<(((c[H+(j*40|0)+4>>2]|0)-I|0)/12|0)>>>0){q=p+(i*12|0)|0;r=p+(i*12|0)+8+3|0;if((a[r>>0]|0)<0){y7(c[q>>2]|0,0);c[p+(i*12|0)+4>>2]=0;break}else{y7(q,0);a[r>>0]=0;break}}while(0);i=i+1|0}}while(0);j=j+1|0}k=Y+8+3|0;o=Y+4|0;j=0;while(1){if(j>>>0>=(RA(b,3,-1)|0)>>>0)break n;$x(Y,b,3,j,126,1);I=a[k>>0]|0;I=((I<<24>>24<0?c[o>>2]|0:I&255)|0)==0;z5(Y);p:do if(!I){$x(Y,b,3,j,126,1);G=tm(Y)|0;H=z;I=tm(g)|0;I=D_(G|0,H|0,I|0,z|0)|0;jL(b,3,j,154,I,z,1);z5(Y);$x(Y,b,3,j,154,1);I=rm(Y)|0;I=(I|0)==0&(z|0)==0;z5(Y);if(I)i=155;else break;while(1){if((i|0)==159)break p;H=c[(c[c[U>>2]>>2]|0)+36>>2]|0;I=c[H+(j*40|0)>>2]|0;p=I;do if(i>>>0<(((c[H+(j*40|0)+4>>2]|0)-I|0)/12|0)>>>0){q=p+(i*12|0)|0;r=p+(i*12|0)+8+3|0;if((a[r>>0]|0)<0){y7(c[q>>2]|0,0);c[p+(i*12|0)+4>>2]=0;break}else{y7(q,0);a[r>>0]=0;break}}while(0);i=i+1|0}}while(0);j=j+1|0}}while(0);do if(v){if(!(RA(b,1,-1)|0))break;$x(Y,b,2,e,156,1);I=a[Y+8+3>>0]|0;if(!((I<<24>>24<0?c[Y+4>>2]|0:I&255)|0)){z5(Y);break}$x(X,b,1,0,217,1);I=a[X+8+3>>0]|0;I=((I<<24>>24<0?c[X+4>>2]|0:I&255)|0)==0;z5(X);z5(Y);if(I)break;if(K)Ed(b,2,e,184);mI(Y);Xy(X,41840);z3(Y,X);z5(X);$x(X,b,2,e,156,1);og(Y,X);z5(X);mI(X);Xy(W,41840);z3(X,W);z5(W);$x(W,b,1,0,217,1);og(X,W);z5(W);I=c[Y>>2]|0;K=c[Y+4>>2]|0;i=K;j=I;q:do if((I|0)!=(K|0)){k=c[X>>2]|0;o=X+4|0;p=c[o>>2]|0;if((k|0)==(p|0))break;i=(i-j|0)/12|0;if(i>>>0>((p-k|0)/12|0)>>>0)break;H=tm(DN(Y,i+-1|0)|0)|0;I=z;K=tm(DN(X,(((c[o>>2]|0)-(c[X>>2]|0)|0)/12|0)+-1|0)|0)|0;K=D_(H|0,I|0,K|0,z|0)|0;jL(b,2,e,184,K,z,0);if(((c[o>>2]|0)-(c[X>>2]|0)|0)!=12)break;$x(W,b,2,e,184,1);K=rm(W)|0;K=(K|0)==0&(z|0)==0;z5(W);if(K)i=185;else break;while(1){if((i|0)==189)break q;I=c[(c[c[U>>2]>>2]|0)+24>>2]|0;K=c[I+(e*40|0)>>2]|0;j=K;do if(i>>>0<(((c[I+(e*40|0)+4>>2]|0)-K|0)/12|0)>>>0){k=j+(i*12|0)|0;o=j+(i*12|0)+8+3|0;if((a[o>>0]|0)<0){y7(c[k>>2]|0,0);c[j+(i*12|0)+4>>2]=0;break}else{y7(k,0);a[o>>0]=0;break}}while(0);i=i+1|0}}while(0);$_(X);$_(Y)}while(0);do if(s){if(!(RA(b,1,-1)|0))break;$x(Y,b,3,e,126,1);K=a[Y+8+3>>0]|0;if(!((K<<24>>24<0?c[Y+4>>2]|0:K&255)|0)){z5(Y);break}$x(X,b,1,0,217,1);K=a[X+8+3>>0]|0;K=((K<<24>>24<0?c[X+4>>2]|0:K&255)|0)==0;z5(X);z5(Y);if(K)break;k=c[(c[b>>2]|0)+8>>2]|0;VU(X,379121);p2(Y,lb[k&63](b,3,e,X,1,0)|0);z5(X);c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;k=i9(28664)|0;if(k>>>0>1073741807)uaa();i=W+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){_=ua(8)|0;K2(_,391652);c[_>>2]=57868;Ya(_|0,2712,367)}else{K=ZW(j<<2)|0;c[W>>2]=K;c[i>>2]=j|-2147483648;c[W+4>>2]=k;i=K;break}}else{a[i+3>>0]=k;i=W}while(0);a3(i,28664,k);y7(i+(k<<2)|0,0);TX(L);Ok(X,Y,W,L,0,0);z5(L);O0(W);K=rm(X)|0;H=tm(g)|0;I=z;$x(W,b,1,(K|0)==0?0:K+-1|0,217,1);K=tm(W)|0;K=D_(H|0,I|0,K|0,z|0)|0;jL(b,3,e,154,K,z,1);z5(W);$x(W,b,3,e,154,1);K=rm(W)|0;K=(K|0)==0&(z|0)==0;z5(W);r:do if(K){i=155;while(1){if((i|0)==159)break r;I=c[(c[c[U>>2]>>2]|0)+36>>2]|0;K=c[I+(e*40|0)>>2]|0;j=K;do if(i>>>0<(((c[I+(e*40|0)+4>>2]|0)-K|0)/12|0)>>>0){k=j+(i*12|0)|0;o=j+(i*12|0)+8+3|0;if((a[o>>0]|0)<0){y7(c[k>>2]|0,0);c[j+(i*12|0)+4>>2]=0;break}else{y7(k,0);a[o>>0]=0;break}}while(0);i=i+1|0}}while(0);z5(X);z5(Y)}while(0);do if(h&t){if(!(RA(b,1,-1)|0))break;$x(Y,b,4,e,126,1);K=a[Y+8+3>>0]|0;if(!((K<<24>>24<0?c[Y+4>>2]|0:K&255)|0)){z5(Y);break}$x(X,b,1,0,217,1);K=a[X+8+3>>0]|0;K=((K<<24>>24<0?c[X+4>>2]|0:K&255)|0)==0;z5(X);z5(Y);if(K)break;k=c[(c[b>>2]|0)+8>>2]|0;VU(X,379121);p2(Y,lb[k&63](b,4,e,X,1,0)|0);z5(X);c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;k=i9(28664)|0;if(k>>>0>1073741807)uaa();i=W+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){_=ua(8)|0;K2(_,391652);c[_>>2]=57868;Ya(_|0,2712,367)}else{K=ZW(j<<2)|0;c[W>>2]=K;c[i>>2]=j|-2147483648;c[W+4>>2]=k;i=K;break}}else{a[i+3>>0]=k;i=W}while(0);a3(i,28664,k);y7(i+(k<<2)|0,0);TX(L);Ok(X,Y,W,L,0,0);z5(L);O0(W);H=rm(X)|0;I=tm(g)|0;K=z;$x(W,b,1,(H|0)==0?0:H+-1|0,217,1);g=tm(W)|0;g=D_(I|0,K|0,g|0,z|0)|0;jL(b,4,e,154,g,z,1);z5(W);$x(W,b,4,e,154,1);g=rm(W)|0;g=(g|0)==0&(z|0)==0;z5(W);s:do if(g){i=155;while(1){if((i|0)==159)break s;K=c[(c[c[U>>2]>>2]|0)+48>>2]|0;g=c[K+(e*40|0)>>2]|0;j=g;do if(i>>>0<(((c[K+(e*40|0)+4>>2]|0)-g|0)/12|0)>>>0){k=j+(i*12|0)|0;o=j+(i*12|0)+8+3|0;if((a[o>>0]|0)<0){y7(c[k>>2]|0,0);c[j+(i*12|0)+4>>2]=0;break}else{y7(k,0);a[o>>0]=0;break}}while(0);i=i+1|0}}while(0);z5(X);z5(Y)}while(0);if((Rb(d,123)|0)==(f|0)){D=f+1|0;Ed(b,d,e,D);E=f+2|0;Ed(b,d,e,E);F=f+3|0;Ed(b,d,e,F);G=f+4|0;Ed(b,d,e,G);H=f+5|0;Ed(b,d,e,H);xA(Y);Xy(X,41840);gI(Y,0,X);z5(X);Xy(X,42040);gI(Y,1,X);z5(X);bf(Y,(c[(c[(c[c[U>>2]>>2]|0)+(d*12|0)>>2]|0)+(e*40|0)>>2]|0)+(f*12|0)|0);I=Y+4|0;r=W+8+3|0;s=W+4|0;q=0;while(1){if(q>>>0>=(((c[I>>2]|0)-(c[Y>>2]|0)|0)/40|0)>>>0)break;TX(X);g=c[Y>>2]|0;i=c[g+(q*40|0)>>2]|0;t:do if((c[g+(q*40|0)+4>>2]|0)!=(i|0)){k1(X,i)|0;uP(c[(c[Y>>2]|0)+(q*40|0)>>2]|0)|0;k=c[(c[Y>>2]|0)+(q*40|0)>>2]|0;o=a[k+8+3>>0]|0;p=o<<24>>24<0;j=k+4|0;if(p)i=c[j>>2]|0;else i=o&255;do if((i|0)==3){i=i9(6580)|0;j=c[j>>2]|0;if((i|0)==((p?j:o&255)|0)){if(!(VG(k,6580,i)|0))break;k=c[(c[Y>>2]|0)+(q*40|0)>>2]|0;o=a[k+8+3>>0]|0;j=c[k+4>>2]|0}i=i9(6596)|0;if((i|0)==((o<<24>>24<0?j:o&255)|0)){if(!(VG(k,6596,i)|0))break;k=c[(c[Y>>2]|0)+(q*40|0)>>2]|0;o=a[k+8+3>>0]|0;j=c[k+4>>2]|0}i=i9(6612)|0;if((i|0)==((o<<24>>24<0?j:o&255)|0)){if(!(VG(k,6612,i)|0))break;k=c[(c[Y>>2]|0)+(q*40|0)>>2]|0;o=a[k+8+3>>0]|0;j=c[k+4>>2]|0}i=i9(6628)|0;if((i|0)!=((o<<24>>24<0?j:o&255)|0)){V=429;break}if(!(VG(k,6628,i)|0))break;k=c[(c[Y>>2]|0)+(q*40|0)>>2]|0;o=a[k+8+3>>0]|0;V=429}else V=429;while(0);if((V|0)==429){V=0;j=o<<24>>24<0;p=k+4|0;if(j)i=c[p>>2]|0;else i=o&255;if((i|0)!=2)break;i=i9(6644)|0;if((i|0)!=((j?c[p>>2]|0:o&255)|0))break;if(VG(k,6644,i)|0)break}j=c[Y>>2]|0;i=c[j+(q*40|0)>>2]|0;j=j+(q*40|0)+4|0;while(1){k=c[j>>2]|0;if((k|0)==(i|0))break t;g=k+-12|0;c[j>>2]=g;z5(g)}}while(0);K=c[Y>>2]|0;g=c[K+(q*40|0)>>2]|0;j=g;do if((c[K+(q*40|0)+4>>2]|0)!=(g|0)){i=a[j+8+3>>0]|0;if(i<<24>>24<0)i=c[j+4>>2]|0;else i=i&255;do if((i|0)==3){K=SG(j)|0;g=a[K+8+3>>0]|0;if(!((g<<24>>24<0?c[K+4>>2]|0:g&255)|0))break;g=SG(c[(c[Y>>2]|0)+(q*40|0)>>2]|0)|0;k1(c[(c[Y>>2]|0)+(q*40|0)>>2]|0,g)|0}while(0);j=c[(c[Y>>2]|0)+(q*40|0)>>2]|0;i=a[j+8+3>>0]|0;if(i<<24>>24<0)i=c[j+4>>2]|0;else i=i&255;do if(i>>>0>3){Hl(W,j);g=a[r>>0]|0;g=((g<<24>>24<0?c[s>>2]|0:g&255)|0)==0;z5(W);if(g)break;Hl(W,c[(c[Y>>2]|0)+(q*40|0)>>2]|0);k1(c[(c[Y>>2]|0)+(q*40|0)>>2]|0,W)|0;z5(W)}while(0);j=c[(c[Y>>2]|0)+(q*40|0)>>2]|0;i=a[j+8+3>>0]|0;if(i<<24>>24<0)i=c[j+4>>2]|0;else i=i&255;if(i>>>0<=3)break;k1(j,X)|0}while(0);z5(X);q=q+1|0}hq(X,Y);$x(W,b,d,e,f,1);j=a[X+8+3>>0]|0;i=j<<24>>24<0;j=i?c[X+4>>2]|0:j&255;g=a[W+8+3>>0]|0;k=g<<24>>24<0;do if((j|0)==((k?c[W+4>>2]|0:g&255)|0)){g=(L$(i?c[X>>2]|0:X,k?c[W>>2]|0:W,j)|0)==0;z5(W);z5(X);if(!g){V=459;break}mI(X);Xy(W,41840);z3(X,W);z5(W);mI(W);Xy(L,41840);z3(W,L);z5(L);mI(L);Xy(M,41840);z3(L,M);z5(M);mI(M);Xy(N,41840);z3(M,N);z5(N);t=X+4|0;h=X+8|0;u=W+4|0;v=W+8|0;w=L+4|0;x=L+8|0;y=M+4|0;A=M+8|0;B=N+8+3|0;C=N+4|0;s=0;while(1){g=c[Y>>2]|0;i=g;if(s>>>0>=(((c[I>>2]|0)-g|0)/40|0)>>>0)break;if((c[i+(s*40|0)+4>>2]|0)==(c[i+(s*40|0)>>2]|0)){TX(N);i=c[t>>2]|0;if(i>>>0<(c[h>>2]|0)>>>0){rV(i,N);c[t>>2]=(c[t>>2]|0)+12}else Dx(X,N);z5(N);TX(N);i=c[u>>2]|0;if(i>>>0<(c[v>>2]|0)>>>0){rV(i,N);c[u>>2]=(c[u>>2]|0)+12}else Dx(W,N);z5(N);TX(N);i=c[w>>2]|0;if(i>>>0<(c[x>>2]|0)>>>0){rV(i,N);c[w>>2]=(c[w>>2]|0)+12}else Dx(L,N);z5(N);TX(N);i=c[y>>2]|0;if(i>>>0<(c[A>>2]|0)>>>0){rV(i,N);c[y>>2]=(c[y>>2]|0)+12}else Dx(M,N);z5(N)}else{TX(N);i=c[Y>>2]|0;if(((c[i+(s*40|0)+4>>2]|0)-(c[i+(s*40|0)>>2]|0)|0)==24){de(S,i+(s*40|0)|0);DW(S,0,6656)|0;c[R>>2]=c[S>>2];c[R+4>>2]=c[S+4>>2];c[R+8>>2]=c[S+8>>2];i=0;while(1){if((i|0)==3)break;c[S+(i<<2)>>2]=0;i=i+1|0}p2(Q,R);pl(P,Q);vF(N,P)|0;z5(P);z5(Q);O0(R);z5(S)}i=a[B>>0]|0;o=i<<24>>24<0;p=c[N>>2]|0;j=o?p:N;k=i9(6656)|0;if((k|0)!=0?(O=c[C>>2]|0,g=j+((o?O:i&255)<<2)|0,V=HA(j,g,6656,6656+(k<<2)|0)|0,!((V|0)!=(g|0)&(V|0)==(j|0))):0){j=O;V=474}else V=471;do if((V|0)==471)if(o){y7(p,0);c[C>>2]=0;i=a[B>>0]|0;j=0;V=474;break}else{y7(N,0);a[B>>0]=0;i=0;V=475;break}while(0);if((V|0)==474){V=0;if(i<<24>>24<0)i=j;else V=475}if((V|0)==475){V=0;i=i&255}u:do if(!i){ms(R,6656,c[(c[Y>>2]|0)+(s*40|0)>>2]|0);p2(Q,R);pl(P,Q);vF(N,P)|0;z5(P);z5(Q);O0(R);i=a[B>>0]|0;j=i<<24>>24<0;k=j?c[N>>2]|0:N;o=i9(6656)|0;if(!((o|0)!=0?(K=k+((j?c[C>>2]|0:i&255)<<2)|0,g=HA(k,K,6656,6656+(o<<2)|0)|0,!((g|0)!=(K|0)&(g|0)==(k|0))):0))k1(N,c[(c[Y>>2]|0)+(s*40|0)>>2]|0)|0;j=c[Y>>2]|0;r=c[j+(s*40|0)+4>>2]|0;j=c[j+(s*40|0)>>2]|0;i=r-j|0;p=j;if(((i|0)/12|0)>>>0<=1)break;do if((i|0)==24){i=a[p+20+3>>0]|0;q=i<<24>>24<0;k=p+16|0;i=i&255;if(q)o=c[k>>2]|0;else o=i;if(o>>>0<=1){k=1;i=r;break}if(q)i=c[k>>2]|0;if(i>>>0>=4){k=1;i=r;break}i=p+12|0;if(q)k=c[i>>2]|0;else k=i;if((c[k>>2]&223)>>>0<=64){k=1;i=r;break}if(q)k=c[i>>2]|0;else k=i;if((c[k>>2]&223)>>>0>=91){k=1;i=r;break}if(q)k=c[i>>2]|0;else k=i;if((c[k+4>>2]&223)>>>0<=64){k=1;i=r;break}if(q)i=c[i>>2]|0;if((c[i+4>>2]&223)>>>0>=91){k=1;i=r;break}HX(N,39932)|0;p2(P,(c[(c[Y>>2]|0)+(s*40|0)>>2]|0)+12|0);tP(P)|0;g=a[P+8+3>>0]|0;K=g<<24>>24<0;Ex(N,K?c[P>>2]|0:P,K?c[P+4>>2]|0:g&255)|0;z5(P);HX(N,39944)|0;break u}else{k=1;i=r}while(0);while(1){if(k>>>0>=((i-j|0)/12|0)>>>0)break u;Gx(N,45);j=c[(c[Y>>2]|0)+(s*40|0)>>2]|0;K=j+(k*12|0)|0;i=a[j+(k*12|0)+8+3>>0]|0;g=i<<24>>24<0;Ex(N,g?c[K>>2]|0:K,g?c[j+(k*12|0)+4>>2]|0:i&255)|0;i=c[Y>>2]|0;k=k+1|0;j=c[i+(s*40|0)>>2]|0;i=c[i+(s*40|0)+4>>2]|0}}while(0);i=c[t>>2]|0;if((i|0)==(c[h>>2]|0))Ax(X,N);else{p2(i,N);c[t>>2]=(c[t>>2]|0)+12}j=c[(c[Y>>2]|0)+(s*40|0)>>2]|0;i=a[j+8+3>>0]|0;if(i<<24>>24<0)i=c[j+4>>2]|0;else i=i&255;if((i|0)==2){i=c[u>>2]|0;if((i|0)==(c[v>>2]|0))Ax(W,j);else{p2(i,j);c[u>>2]=(c[u>>2]|0)+12}de(P,(c[Y>>2]|0)+(s*40|0)|0);i=c[y>>2]|0;if(i>>>0<(c[A>>2]|0)>>>0){rV(i,P);c[y>>2]=(c[y>>2]|0)+12}else Dx(M,P);z5(P)}else{TX(P);i=c[u>>2]|0;if(i>>>0<(c[v>>2]|0)>>>0){rV(i,P);c[u>>2]=(c[u>>2]|0)+12}else Dx(W,P);z5(P);TX(P);i=c[y>>2]|0;if(i>>>0<(c[A>>2]|0)>>>0){rV(i,P);c[y>>2]=(c[y>>2]|0)+12}else Dx(M,P);z5(P)}j=c[(c[Y>>2]|0)+(s*40|0)>>2]|0;i=a[j+8+3>>0]|0;if(i<<24>>24<0)i=c[j+4>>2]|0;else i=i&255;do if((i|0)==3){i=c[w>>2]|0;if((i|0)==(c[x>>2]|0)){Ax(L,j);break}else{p2(i,j);c[w>>2]=(c[w>>2]|0)+12;break}}else{K=RG(j)|0;g=a[K+8+3>>0]|0;if((g<<24>>24<0?c[K+4>>2]|0:g&255)|0){i=RG(c[(c[Y>>2]|0)+(s*40|0)>>2]|0)|0;j=c[w>>2]|0;if((j|0)==(c[x>>2]|0)){Ax(L,i);break}else{p2(j,i);c[w>>2]=(c[w>>2]|0)+12;break}}TX(P);i=c[w>>2]|0;if(i>>>0<(c[x>>2]|0)>>>0){rV(i,P);c[w>>2]=(c[w>>2]|0)+12}else Dx(L,P);z5(P)}while(0);z5(N)}s=s+1|0}de(N,X);zb(b,d,e,E,N,0);z5(N);de(N,W);zb(b,d,e,F,N,0);z5(N);de(N,L);zb(b,d,e,G,N,0);z5(N);de(N,M);zb(b,d,e,H,N,0);z5(N);$x(N,b,d,e,E,1);zb(b,d,e,D,N,0);z5(N);$_(M);$_(L);$_(W);$_(X)}else{z5(W);z5(X);V=459}while(0);if((V|0)==459){hq(X,Y);zb(b,d,e,f,X,1);z5(X)}LT(Y)}if(!((Rb(d,124)|0)!=(f|0)?(Rb(d,125)|0)!=(f|0):0))V=557;v:do if((V|0)==557){$x(Y,b,d,e,f,1);i=a[Y+8+3>>0]|0;j=i<<24>>24<0;k=j?c[Y>>2]|0:Y;o=i9(41596)|0;do if(o|0){R=k+((j?c[Y+4>>2]|0:i&255)<<2)|0;S=HA(k,R,41596,41596+(o<<2)|0)|0;if((S|0)!=(R|0)?(S-k|0)!=-4:0)break;$x(X,b,d,e,f,1);if((oH(X,58,0)|0)!=2){$x(W,b,d,e,f,1);S=(oH(W,58,0)|0)==3;z5(W);z5(X);z5(Y);if(!S)break v}else{z5(X);z5(Y)}$x(Y,b,d,e,f,1);$x(X,b,d,e,f,1);ny(Y,0,(oH(X,58,0)|0)+1|0)|0;z5(X);k1(DN((c[(c[c[U>>2]>>2]|0)+(d*12|0)>>2]|0)+(e*40|0)|0,f)|0,Y)|0;z5(Y);break v}while(0);z5(Y)}while(0);o=(f|0)==171;p=f|4;w:do if(T){x:do switch(f|0){case 171:case 177:{$x(Y,b,1,e,171,1);$=+Cq(Y);z5(Y);$x(Y,b,1,e,177,1);n=+Cq(Y);z5(Y);if(!(n>$*.9995&n<$*1.0005))break x;$x(Y,b,1,e,177,1);Ed(b,1,e,177);if(o)zb(b,1,e,171,Y,1);z5(Y);break}default:{}}while(0);switch(f|0){case 171:case 177:case 181:{$x(Y,b,1,e,183,1);U=a[Y+8+3>>0]|0;U=((U<<24>>24<0?c[Y+4>>2]|0:U&255)|0)==0;z5(Y);do if(U){uo(b,e,f);$x(Y,b,1,e,177,1);$x(X,b,1,e,171,1);j=a[Y+8+3>>0]|0;i=j<<24>>24<0;j=i?c[Y+4>>2]|0:j&255;U=a[X+8+3>>0]|0;k=U<<24>>24<0;do if((j|0)==((k?c[X+4>>2]|0:U&255)|0)){U=(L$(i?c[Y>>2]|0:Y,k?c[X>>2]|0:X,j)|0)==0;z5(X);z5(Y);if(!U)break;Ed(b,1,e,177)}else{z5(X);z5(Y)}while(0);if((f|0)==181)break w;$x(Y,b,1,e,181,1);$x(X,b,1,e,171,1);j=a[Y+8+3>>0]|0;i=j<<24>>24<0;j=i?c[Y+4>>2]|0:j&255;U=a[X+8+3>>0]|0;k=U<<24>>24<0;if((j|0)!=((k?c[X+4>>2]|0:U&255)|0)){z5(X);z5(Y);break}U=(L$(i?c[Y>>2]|0:Y,k?c[X>>2]|0:X,j)|0)==0;z5(X);z5(Y);if(!U)break;Ed(b,1,e,181)}while(0);if(o)V=583;break}case 120:case 124:case 130:case 138:{V=583;break}default:{}}do if((V|0)==583){$x(Y,b,1,e,120,1);m=+Cq(Y);z5(Y);if(m==0.0){$x(Y,b,1,e,124,1);m=+Cq(Y);z5(Y)}$x(Y,b,1,e,130,1);n=+(sn(Y)|0);$x(X,b,1,e,138,1);n=n*+(sn(X)|0);$x(W,b,1,e,171,1);n=n*+Cq(W);z5(W);z5(X);z5(Y);if(!(m!=0.0&n!=0.0))break;Bt(b,1,e,216,m/n,3,1)}while(0);if((p|0)!=124){V=589;break}Fv(b,e,f)}else V=589;while(0);do if((V|0)==589){if(!(J&(p|0)==116))break;Ic(b,e,f)}while(0);z5(Z);break a}while(0);sU(Z,f,10);s=b+380+(d*12|0)|0;t=b+380+(d*12|0)+4|0;y:do if(h){k=c[s>>2]|0;j=((c[t>>2]|0)-k|0)/24|0;o=a[Z+8+3>>0]|0;p=o<<24>>24<0;o=p?c[Z+4>>2]|0:o&255;p=p?c[Z>>2]|0:Z;i=0;while(1){if(i>>>0>=j>>>0){V=76;break y}q=k+(i*24|0)|0;f=a[k+(i*24|0)+8+3>>0]|0;r=f<<24>>24<0;if(((r?c[k+(i*24|0)+4>>2]|0:f&255)|0)==(o|0)?(L$(r?c[q>>2]|0:q,p,o)|0)==0:0)break;i=i+1|0}k1(k+(i*24|0)+12|0,g)|0}else V=76;while(0);if((V|0)==76){b4(Y);k1(Y,Z)|0;k1(Y+12|0,g)|0;i=c[t>>2]|0;if((i|0)==(c[b+380+(d*12|0)+8>>2]|0))Sv(s,Y);else{h0(i,Y);c[t>>2]=(c[t>>2]|0)+24}w4(Y)}z5(Z);break}p2(Z,g);c[Y>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=0;k=i9(42452)|0;if(k>>>0>1073741807)uaa();i=Y+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){_=ua(8)|0;K2(_,391652);c[_>>2]=57868;Ya(_|0,2712,367)}else{W=ZW(j<<2)|0;c[Y>>2]=W;c[i>>2]=j|-2147483648;c[Y+4>>2]=k;i=W;break}}else{a[i+3>>0]=k;i=Y}while(0);a3(i,42452,k);y7(i+(k<<2)|0,0);c[X>>2]=0;c[X+4>>2]=0;c[X+8>>2]=0;k=i9(41840)|0;if(k>>>0>1073741807)uaa();i=X+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){_=ua(8)|0;K2(_,391652);c[_>>2]=57868;Ya(_|0,2712,367)}else{W=ZW(j<<2)|0;c[X>>2]=W;c[i>>2]=j|-2147483648;c[X+4>>2]=k;i=W;break}}else{a[i+3>>0]=k;i=X}while(0);a3(i,41840,k);y7(i+(k<<2)|0,0);vo(Z,Y,X,0,8);O0(X);O0(Y);c[Y>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=0;k=i9(42464)|0;if(k>>>0>1073741807)uaa();i=Y+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){_=ua(8)|0;K2(_,391652);c[_>>2]=57868;Ya(_|0,2712,367)}else{W=ZW(j<<2)|0;c[Y>>2]=W;c[i>>2]=j|-2147483648;c[Y+4>>2]=k;i=W;break}}else{a[i+3>>0]=k;i=Y}while(0);a3(i,42464,k);y7(i+(k<<2)|0,0);c[X>>2]=0;c[X+4>>2]=0;c[X+8>>2]=0;k=i9(41840)|0;if(k>>>0>1073741807)uaa();i=X+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){_=ua(8)|0;K2(_,391652);c[_>>2]=57868;Ya(_|0,2712,367)}else{W=ZW(j<<2)|0;c[X>>2]=W;c[i>>2]=j|-2147483648;c[X+4>>2]=k;i=W;break}}else{a[i+3>>0]=k;i=X}while(0);a3(i,41840,k);y7(i+(k<<2)|0,0);vo(Z,Y,X,0,8);O0(X);O0(Y);c[Y>>2]=0;c[Y+4>>2]=0;c[Y+8>>2]=0;k=i9(42472)|0;if(k>>>0>1073741807)uaa();i=Y+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){_=ua(8)|0;K2(_,391652);c[_>>2]=57868;Ya(_|0,2712,367)}else{W=ZW(j<<2)|0;c[Y>>2]=W;c[i>>2]=j|-2147483648;c[Y+4>>2]=k;i=W;break}}else{a[i+3>>0]=k;i=Y}while(0);a3(i,42472,k);y7(i+(k<<2)|0,0);c[X>>2]=0;c[X+4>>2]=0;c[X+8>>2]=0;k=i9(41840)|0;if(k>>>0>1073741807)uaa();i=X+8|0;do if(k>>>0>=2){j=k+4&-4;if(j>>>0>1073741823){_=ua(8)|0;K2(_,391652);c[_>>2]=57868;Ya(_|0,2712,367)}else{W=ZW(j<<2)|0;c[X>>2]=W;c[i>>2]=j|-2147483648;c[X+4>>2]=k;i=W;break}}else{a[i+3>>0]=k;i=X}while(0);a3(i,41840,k);y7(i+(k<<2)|0,0);vo(Z,Y,X,0,8);O0(X);O0(Y);j=a[Z+8+3>>0]|0;i=j<<24>>24<0;j=i?c[Z+4>>2]|0:j&255;if(j>>>0>2?(p=i?c[Z>>2]|0:Z,W=i9(41840)|0,X=p+(j<<2)|0,Y=Ix(p,X,41840,41840+(W<<2)|0)|0,p=(W|0)!=0&(Y|0)==(X|0)?-1:Y-p>>2,(p|0)==(j+-3|0)):0)FB(Z,p,0);zb(b,d,e,f,Z,h);z5(Z)}}else{a[o>>0]=0;j=b+736|0;k=(c[b+740>>2]|0)-(c[j>>2]|0)>>3;i=0;while(1){if((i|0)==(k|0))break;Z=c[j>>2]|0;zb(b,c[Z+(i<<3)>>2]|0,c[Z+(i<<3)+4>>2]|0,f,g,h);i=i+1|0}a[o>>0]=1}while(0);l=_;return}function Ab(b){b=b|0;var d=0,e=0,f=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,A=0,C=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,Ab=0;yb=l;l=l+224|0;ub=yb+208|0;F=yb+196|0;G=yb+184|0;vb=yb;wb=yb+144|0;xb=yb+132|0;nb=yb+120|0;pb=yb+108|0;qb=yb+96|0;Va=yb+84|0;Wa=yb+72|0;bb=yb+60|0;cb=yb+48|0;db=yb+36|0;eb=yb+24|0;fb=yb+12|0;t=+h[b+832>>3];gb=b+824|0;if(t!=0.0?(e=gb,d=c[e>>2]|0,e=c[e+4>>2]|0,!((d|0)==0&(e|0)==0)):0)KW(b,0,0,92,t*+j6(d,e)/1.0e6,0,0);$x(ub,b,0,0,145,1);tb=a[ub+8+3>>0]|0;tb=((tb<<24>>24<0?c[ub+4>>2]|0:tb&255)|0)==0;z5(ub);if(tb)RB(b,0,0,145,382808,-1,1,0);Sa=b+892|0;Ta=b+896|0;v=F+8+3|0;w=F+4|0;Ua=b+16|0;tb=b+20|0;x=G+8+3|0;y=G+4|0;A=ub+8+3|0;C=ub+4|0;E=ub+11|0;d=c[Sa>>2]|0;a:while(1){if((d|0)==(Ta|0))break;Qa=d+16|0;e=c[Qa+4>>2]|0;switch(c[Qa>>2]|0){case 0:{if(!e)Ra=12;break}case -1:{if((e|0)==-1)Ra=12;break}default:{}}b:do if((Ra|0)==12){Ra=0;u=d+28|0;e=c[d+24>>2]|0;c:while(1){if((e|0)==(u|0))break b;s=e+16|0;f=i9(19300)|0;o=e+24+3|0;Ra=a[o>>0]|0;p=e+20|0;if((f|0)==((Ra<<24>>24<0?c[p>>2]|0:Ra&255)|0)?(VG(s,19300,f)|0)==0:0){gq(F,b,0,0,387686);f=e+28|0;j=a[v>>0]|0;i=j<<24>>24<0;j=i?c[w>>2]|0:j&255;Ra=a[e+36+3>>0]|0;k=Ra<<24>>24<0;if((j|0)==((k?c[e+32>>2]|0:Ra&255)|0)?(L$(i?c[F>>2]|0:F,k?c[f>>2]|0:f,j)|0)==0:0)Ra=31;else{q=1;Ra=18}}else{q=0;Ra=18}do if((Ra|0)==18){Ra=0;f=i9(18756)|0;Qa=a[o>>0]|0;n=e+32|0;r=e+28|0;m=e+36+3|0;if((f|0)==((Qa<<24>>24<0?c[p>>2]|0:Qa&255)|0)?(VG(s,18756,f)|0)==0:0){gq(G,b,c[Ua>>2]|0,c[tb>>2]|0,377029);i=a[x>>0]|0;f=i<<24>>24<0;i=f?c[y>>2]|0:i&255;Qa=a[m>>0]|0;j=Qa<<24>>24<0;if((i|0)==((j?c[n>>2]|0:Qa&255)|0)?(L$(f?c[G>>2]|0:G,j?c[r>>2]|0:r,i)|0)==0:0){z5(G);if(q){Ra=31;break}else break}else k=1}else k=0;f=i9(19432)|0;Ra=a[o>>0]|0;do if((f|0)==((Ra<<24>>24<0?c[p>>2]|0:Ra&255)|0)?(VG(s,19432,f)|0)==0:0){gq(ub,b,c[Ua>>2]|0,c[tb>>2]|0,380183);j=a[A>>0]|0;i=j<<24>>24<0;j=i?c[C>>2]|0:j&255;Ra=a[m>>0]|0;f=Ra<<24>>24<0;if((j|0)==((f?c[n>>2]|0:Ra&255)|0)){f=(L$(i?c[ub>>2]|0:ub,f?c[r>>2]|0:r,j)|0)!=0;z5(ub);if(k){Ra=29;break}else{Ra=30;break}}else{z5(ub);if(k){f=1;Ra=29;break}else{f=1;Ra=30;break}}}else Ra=27;while(0);if((Ra|0)==27)if(k){f=1;Ra=29}else{f=1;Ra=30}if((Ra|0)==29){z5(G);if(q)Ra=32;else Ra=33}else if((Ra|0)==30)if(q)Ra=32;else Ra=33;if((Ra|0)==32){Ra=0;z5(F);if(!f)break}else if((Ra|0)==33?(Ra=0,!f):0)break;Sn(ub,s);Mc(b,0,0,(a[E>>0]|0)<0?c[ub>>2]|0:ub,r,0);a1(ub)}while(0);if((Ra|0)==31){Ra=0;z5(F)}f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue c}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}}while(0);e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue a}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}Qa=b+760|0;ma=b+764|0;na=xb+8|0;oa=na+3|0;pa=xb+8+3|0;qa=xb+4|0;ra=vb+8+3|0;sa=vb+4|0;ta=nb+8+3|0;va=nb+4|0;wa=wb+8+3|0;xa=wb+4|0;ya=ub+8+3|0;za=ub+4|0;Aa=vb+8+3|0;Ba=vb+4|0;Ca=wb+4|0;Da=wb+8+3|0;Ea=wb+4|0;Fa=wb+8+3|0;Ga=wb+4|0;Ha=xb+8+3|0;Ia=xb+4|0;Ja=nb+8+3|0;Ka=nb+4|0;La=xb+4|0;Ma=ub+8+3|0;Na=ub+4|0;Oa=ub+11|0;Pa=ub+11|0;y=ub+4|0;A=ub+4|0;C=ub+8|0;E=ub+8|0;F=ub+8+3|0;G=ub+4|0;L=ub+8+3|0;M=ub+4|0;N=ub+8+3|0;O=ub+4|0;P=ub+8+3|0;Q=ub+4|0;R=vb+8+3|0;S=vb+4|0;T=vb+8+3|0;U=vb+4|0;V=wb+8+3|0;W=wb+4|0;X=xb+8+3|0;Y=xb+4|0;Z=eb+8+3|0;_=eb+4|0;$=fb+8+3|0;aa=fb+4|0;ba=wb+8+3|0;ca=wb+4|0;da=xb+8+3|0;ea=xb+4|0;fa=vb+8+3|0;ga=vb+4|0;ha=wb+8+3|0;ia=wb+4|0;ja=ub+8+3|0;ka=ub+4|0;la=b+24|0;d=c[Qa>>2]|0;d:while(1){if((d|0)==(ma|0)){Ra=44;break}x=d+16|0;w=d+60|0;c[Ua>>2]=c[w>>2];c[tb>>2]=c[d+64>>2];j=d+48|0;u=j;e=c[u+4>>2]|0;v=d+128|0;switch(c[u>>2]|0){case 0:{if(!e){I=0.0;u=0}else Ra=48;break}case -1:{if((e|0)==-1){I=0.0;u=0}else Ra=48;break}default:Ra=48}e:do if((Ra|0)==48){Ra=0;i=d+116|0;e=c[d+112>>2]|0;f:while(1){if((e|0)==(i|0))break;f=e+16|0;if((a[f+11>>0]|0)<0)f=c[f>>2]|0;Mc(b,c[Ua>>2]|0,c[tb>>2]|0,f,e+28|0,0);f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue f}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}e=j;e=DB(Sa,c[e>>2]|0,c[e+4>>2]|0)|0;if((e|0)==(Ta|0)){I=0.0;u=0}else{q=e+24|0;Xy(ub,21916);f=Cv(q,ub)|0;z5(ub);r=e+28|0;u=(f|0)!=(r|0);if(u){p2(ub,f+28|0);xy(q,f);gq(vb,b,0,0,377532);gq(wb,b,0,0,377029);c[xb>>2]=0;c[xb+4>>2]=0;c[xb+8>>2]=0;f=i9(42232)|0;if(f>>>0>1073741807){Ra=60;break d}if(f>>>0<2){a[oa>>0]=f;e=xb}else{e=f+4&-4;if(e>>>0>1073741823){Ra=64;break d}s=ZW(e<<2)|0;c[xb>>2]=s;c[na>>2]=e|-2147483648;c[La>>2]=f;e=s}a3(e,42232,f);y7(e+(f<<2)|0,0);TX(nb);vo(wb,xb,nb,0,0);z5(nb);O0(xb);TX(xb);TX(nb);Xy(pb,21984);e=Cv(q,pb)|0;z5(pb);if((e|0)!=(r|0)){k1(xb,e+28|0)|0;xy(q,e)}Xy(pb,22080);e=Cv(q,pb)|0;z5(pb);if((e|0)!=(r|0)){k1(nb,e+28|0)|0;xy(q,e)}f=a[pa>>0]|0;e=f<<24>>24<0;f=e?c[qa>>2]|0:f&255;s=a[ra>>0]|0;i=s<<24>>24<0;if((((f|0)==((i?c[sa>>2]|0:s&255)|0)?(L$(e?c[xb>>2]|0:xb,i?c[vb>>2]|0:vb,f)|0)==0:0)?(ib=a[ta>>0]|0,hb=ib<<24>>24<0,ib=hb?c[va>>2]|0:ib&255,s=a[wa>>0]|0,jb=s<<24>>24<0,(ib|0)==((jb?c[xa>>2]|0:s&255)|0)):0)?(L$(hb?c[nb>>2]|0:nb,jb?c[wb>>2]|0:wb,ib)|0)==0:0)o=1;else{f=c[Ua>>2]|0;i=c[tb>>2]|0;nt(db,xb,32);e=a[ta>>0]|0;s=e<<24>>24<0;Ex(db,s?c[nb>>2]|0:nb,s?c[va>>2]|0:e&255)|0;c[cb>>2]=c[db>>2];c[cb+4>>2]=c[db+4>>2];c[cb+8>>2]=c[db+8>>2];e=0;while(1){if((e|0)==3)break;c[db+(e<<2)>>2]=0;e=e+1|0}HX(cb,41840)|0;c[bb>>2]=c[cb>>2];c[bb+4>>2]=c[cb+4>>2];c[bb+8>>2]=c[cb+8>>2];e=0;while(1){if((e|0)==3)break;c[cb+(e<<2)>>2]=0;e=e+1|0}e=a[ra>>0]|0;s=e<<24>>24<0;Ex(bb,s?c[vb>>2]|0:vb,s?c[sa>>2]|0:e&255)|0;c[Wa>>2]=c[bb>>2];c[Wa+4>>2]=c[bb+4>>2];c[Wa+8>>2]=c[bb+8>>2];e=0;while(1){if((e|0)==3)break;c[bb+(e<<2)>>2]=0;e=e+1|0}Gx(Wa,32);c[Va>>2]=c[Wa>>2];c[Va+4>>2]=c[Wa+4>>2];c[Va+8>>2]=c[Wa+8>>2];e=0;while(1){if((e|0)==3)break;c[Wa+(e<<2)>>2]=0;e=e+1|0}e=a[wa>>0]|0;s=e<<24>>24<0;Ex(Va,s?c[wb>>2]|0:wb,s?c[xa>>2]|0:e&255)|0;c[qb>>2]=c[Va>>2];c[qb+4>>2]=c[Va+4>>2];c[qb+8>>2]=c[Va+8>>2];e=0;while(1){if((e|0)==3)break;c[Va+(e<<2)>>2]=0;e=e+1|0}p2(pb,qb);Mc(b,f,i,373821,pb,0);z5(pb);O0(qb);O0(Va);O0(Wa);O0(bb);O0(cb);O0(db);o=0}z5(nb);z5(xb);z5(wb);z5(vb);TX(vb);i=a[ya>>0]|0;j=c[ub>>2]|0;t=0.0;H=0.0;p=i<<24>>24<0?j:ub;g:while(1){s=i<<24>>24<0;e=c[za>>2]|0;h:do if((p|0)==((s?j:ub)+((s?e:i&255)<<2)|0))Ra=93;else{f=c[p>>2]|0;switch(f|0){case 0:case 32:{Ra=93;break h}default:{}}Gx(vb,f)}while(0);do if((Ra|0)==93){Ra=0;s=a[Aa>>0]|0;if((s<<24>>24<0?c[Ba>>2]|0:s&255)|0){n=Cv(q,vb)|0;if((n|0)==(r|0)){K=t;f=j}else{k1(vb,n+16|0)|0;m=n+28|0;e=i9(22196)|0;f=a[Aa>>0]|0;i=c[Ba>>2]|0;do if((e|0)==((f<<24>>24<0?i:f&255)|0)){if(VG(vb,22196,e)|0){f=a[Aa>>0]|0;i=c[Ba>>2]|0;Ra=101;break}if(o){VU(wb,384534);k1(AG(q,wb)|0,m)|0;z5(wb);break}else{VU(wb,384534);vF(vb,wb)|0;z5(wb);Ra=147;break}}else Ra=101;while(0);i:do if((Ra|0)==101){Ra=0;e=i9(22212)|0;do if((e|0)==((f<<24>>24<0?i:f&255)|0)){if(VG(vb,22212,e)|0){f=a[Aa>>0]|0;i=c[Ba>>2]|0;break}if(!o){VU(wb,379845);vF(vb,wb)|0;z5(wb);Ra=147;break i}mI(wb);VU(xb,373843);z3(wb,xb);z5(xb);og(wb,m);e=c[Ca>>2]|0;s=c[wb>>2]|0;f=s;if((e|0)==(s|0)){t=0.0;i=e;j=e;e=f}else{t=+Eq(f)*60.0*60.0+0.0;e=c[wb>>2]|0;i=e;j=c[Ca>>2]|0}if(((j-i|0)/12|0)>>>0>1){t=t+ +Eq(e+12|0)*60.0;e=c[wb>>2]|0;i=e;f=c[Ca>>2]|0}else f=j;do if(((f-i|0)/12|0)>>>0>2){t=t+ +Eq(e+24|0);i=c[wb>>2]|0;e=a[i+32+3>>0]|0;f=e<<24>>24<0;e=e&255;i=i+28|0;if(f)j=c[i>>2]|0;else j=e;if(j>>>0<=6){e=0;break}if(f)e=c[i>>2]|0;e=e+250&255}else e=0;while(0);VU(xb,379845);io(AG(q,xb)|0,t*1.0e3,e)|0;z5(xb);$_(wb);break i}while(0);e=i9(22248)|0;do if((e|0)==((f<<24>>24<0?i:f&255)|0)){if(VG(vb,22248,e)|0){f=a[Aa>>0]|0;i=c[Ba>>2]|0;break}if(!o){VU(wb,374285);vF(vb,wb)|0;z5(wb);Ra=147;break i}H=+Eq(m);VU(wb,374285);k1(AG(q,wb)|0,m)|0;z5(wb);if((c[Ua>>2]|0)!=3)break i;gq(wb,b,3,c[tb>>2]|0,384476);e=a[Da>>0]|0;f=e<<24>>24<0;k=f?c[wb>>2]|0:wb;i=i9(22316)|0;do if(i|0){j=k+((f?c[Ea>>2]|0:e&255)<<2)|0;s=HA(k,j,22316,22316+(i<<2)|0)|0;e=k;if(!((s|0)==(j|0)|(s-e|0)==-4))break;f=i9(22332)|0;if(!f)break;s=HA(k,j,22332,22332+(f<<2)|0)|0;if(!((s|0)==(j|0)|(s-e|0)==-4))break;VU(xb,373845);k1(AG(q,xb)|0,m)|0;z5(xb)}while(0);z5(wb);break i}while(0);e=i9(22348)|0;do if((e|0)==((f<<24>>24<0?i:f&255)|0)){if(VG(vb,22348,e)|0){f=a[Aa>>0]|0;i=c[Ba>>2]|0;break}if(o){VU(wb,374296);k1(AG(q,wb)|0,m)|0;z5(wb);break i}else{VU(wb,374296);vF(vb,wb)|0;z5(wb);Ra=147;break i}}while(0);e=i9(22412)|0;do if((e|0)==((f<<24>>24<0?i:f&255)|0)){if(VG(vb,22412,e)|0){f=a[Aa>>0]|0;i=c[Ba>>2]|0;break}if(o){VU(wb,373858);k1(AG(q,wb)|0,m)|0;z5(wb);break i}else{VU(wb,373877);vF(vb,wb)|0;z5(wb);Ra=147;break i}}while(0);e=i9(22528)|0;if((e|0)!=((f<<24>>24<0?i:f&255)|0)){Ra=147;break}if(VG(vb,22528,e)|0){Ra=147;break}if(o){kh(wb,m);VU(xb,373904);vF(AG(q,xb)|0,wb)|0;z5(xb);z5(wb);ui(wb,m);VU(xb,373928);vF(AG(q,xb)|0,wb)|0;z5(xb);z5(wb);VU(wb,kN(m)|0);VU(xb,373959);vF(AG(q,xb)|0,wb)|0;z5(xb);z5(wb);break}else{VU(wb,373904);vF(vb,wb)|0;z5(wb);Ra=147;break}}while(0);if((Ra|0)==147){Ra=0;DW(vb,0,22568)|0;k1(yG(q,vb)|0,m)|0}xy(q,n);K=t;i=a[ya>>0]|0;f=c[ub>>2]|0;e=c[za>>2]|0}s=i<<24>>24<0;if((p|0)==((s?f:ub)+((s?e:i&255)<<2)|0))break g;if((a[Aa>>0]|0)<0){y7(c[vb>>2]|0,0);c[Ba>>2]=0;t=K;break}else{y7(vb,0);a[Aa>>0]=0;t=K;break}}}while(0);p=p+4|0;i=a[ya>>0]|0;j=c[ub>>2]|0}if(H!=0.0&K!=0.0){t=H/K;s=cT(t)|0;J=+(s>>>0)+4294967296.0*+(z|0);I=J-t*1.001;do if(I>-.0001&I<.0001){I=H/J;H=I*1.001;I=I*1.001001;if(+B(+((I-H)*1.0e4))>=15.0){TX(wb);io(wb,K,3)|0;TX(xb);io(xb,H,3)|0;TX(nb);io(nb,I,3)|0;i=a[Fa>>0]|0;f=i<<24>>24<0;i=f?c[Ga>>2]|0:i&255;s=a[Ha>>0]|0;e=s<<24>>24<0;if((i|0)==((e?c[Ia>>2]|0:s&255)|0))j=(L$(f?c[wb>>2]|0:wb,e?c[xb>>2]|0:xb,i)|0)==0;else j=0;s=a[Ja>>0]|0;e=s<<24>>24<0;do if((i|0)==((e?c[Ka>>2]|0:s&255)|0)){e=(L$(f?c[wb>>2]|0:wb,e?c[nb>>2]|0:nb,i)|0)==0;t=e|j^1?t:J/1.001;if(j|e^1)break;s=cT(t)|0;t=(+(s>>>0)+4294967296.0*+(z|0))/1.001001}else{t=j?J/1.001:t;e=0}while(0);z5(nb);z5(xb);z5(wb);if(j^e)break}f=v;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e|0)==0&(f|0)==0)){H=1.0e9/(+(e>>>0)+4294967296.0*+(f>>>0));s=cT(H)|0;I=+(s>>>0)+4294967296.0*+(z|0);K=I-H*1.001;if(K>-2.0e-06&K<2.0e-06){s=cT(t)|0;t=(+(s>>>0)+4294967296.0*+(z|0))/1.001}K=I-H*1.001001;if(!(K>-2.0e-06&K<2.0e-06))break;s=cT(t)|0;t=(+(s>>>0)+4294967296.0*+(z|0))/1.001001}}while(0);s=c[Ua>>2]|0;p=c[tb>>2]|0;KW(b,s,p,Rb(s,48)|0,t,3,1)}else t=0.0;z5(vb);z5(ub)}else t=0.0;e=c[q>>2]|0;j:while(1){if((e|0)==(r|0)){I=t;break e}m=e+20|0;n=e+16|0;k=e+24+3|0;k:do if((!u?(kb=i9(22212)|0,s=a[k>>0]|0,(kb|0)==((s<<24>>24<0?c[m>>2]|0:s&255)|0)):0)?(VG(n,22212,kb)|0)==0:0){Sn(ub,e+28|0);q=a[Pa>>0]|0;j=q<<24>>24<0;q=j?c[y>>2]|0:q&255;do if(((((q>>>0>11?(lb=c[ub>>2]|0,mb=j?lb:ub,ob=lb,((a[mb>>0]|0)+-48&255)<10):0)?((a[mb+1>>0]|0)+-48&255)<10:0)?(a[mb+2>>0]|0)==58:0)?((a[mb+3>>0]|0)+-48&255)<10:0)?((a[mb+4>>0]|0)+-48&255)<10:0){if((a[mb+5>>0]|0)!=58)break;o=a[mb+6>>0]|0;if((o+-48&255)>=10)break;p=a[mb+7>>0]|0;if((p+-48&255)>=10)break;if((a[mb+8>>0]|0)==46){f=9;i=0}else break;while(1){if((f|0)==(q|0))break;s=i|((a[mb+f>>0]|0)+-48&255)>9;f=f+1|0;i=s}if(i)break;if(j){f=lb;i=a[lb>>0]|0}else{f=ub;i=ob<<24>>24}j=9;H=+(((o<<24>>24)*10|0)+-1933008+(p<<24>>24)+(i*36e3|0)+((a[f+1>>0]|0)*3600|0)+((a[f+3>>0]|0)*600|0)+((a[f+4>>0]|0)*60|0)|0);while(1){if(j>>>0>=q>>>0)break;K=H+ +((a[mb+j>>0]|0)+-48|0)/+D(10.0,+(+(j>>>0)+-8.0));j=j+1|0;H=K}sN(b,c[Ua>>2]|0,c[tb>>2]|0,379845,H*1.0e3,q+244&255,0);a1(ub);break k}while(0);a1(ub);Ra=198}else Ra=198;while(0);do if((Ra|0)==198){Ra=0;f=i9(19492)|0;s=a[k>>0]|0;if(((f|0)==((s<<24>>24<0?c[m>>2]|0:s&255)|0)?(VG(n,19492,f)|0)==0:0)?(gq(ub,b,c[Ua>>2]|0,c[tb>>2]|0,384512),s=a[Ma>>0]|0,s=((s<<24>>24<0?c[Na>>2]|0:s&255)|0)==0,z5(ub),!s):0)break;q=c[Ua>>2]|0;s=c[tb>>2]|0;Sn(ub,n);Mc(b,q,s,(a[Oa>>0]|0)<0?c[ub>>2]|0:ub,e+28|0,0);a1(ub)}while(0);f=c[e+4>>2]|0;if(!f)while(1){f=c[e+8>>2]|0;if((c[f>>2]|0)==(e|0)){e=f;continue j}else e=f}else e=f;while(1){f=c[e>>2]|0;if(!f)break;else e=f}}}}while(0);k=d+76|0;t=+g[k>>2];if(t!=0.0){K=t;r=!(K>=1.777)|!(K<=1.778);t=r?t:1.7777777910232544;K=t;s=!(K>=1.333)|!(K<=1.334);t=s?t:1.3333333730697632;if(!(r&s))g[k>>2]=t;Bt(b,1,c[tb>>2]|0,156,t,3,1);$x(ub,b,1,c[tb>>2]|0,130,1);e=rm(ub)|0;f=z;z5(ub);$x(ub,b,1,c[tb>>2]|0,138,1);i=rm(ub)|0;j=z;z5(ub);if(!((e|0)==0&(f|0)==0))Bt(b,1,c[tb>>2]|0,150,(+(i>>>0)+4294967296.0*+(j>>>0))*+g[k>>2]/(+(e>>>0)+4294967296.0*+(f>>>0)),3,1)}s=d+56|0;e=c[s>>2]|0;if(e|0?(s4(e),+g[(c[la>>2]|0)+136>>2]<=1.0):0)Kl(c[s>>2]|0);if((c[Ua>>2]|0)==1){l:do if((c[d+144>>2]|0)>>>0<=2){k=d+24|0;m=d+28|0;e=c[m>>2]|0;f=c[k>>2]|0;if(e-f>>3>>>0>1){c[ub>>2]=0;c[A>>2]=0;c[C>>2]=0;Ye(f,e);j=1;while(1){r=c[k>>2]|0;e=r;if(j>>>0>=(c[m>>2]|0)-r>>3>>>0)break;f=e+(j<<3)|0;e=e+(j+-1<<3)|0;e=D_(c[f>>2]|0,c[f+4>>2]|0,c[e>>2]|0,c[e+4>>2]|0)|0;f=z;if(!((e|0)==0&(f|0)==0)){i=vb;c[i>>2]=e;c[i+4>>2]=f;i=c[A>>2]|0;if(i>>>0<(c[E>>2]|0)>>>0){r=i;c[r>>2]=e;c[r+4>>2]=f;c[A>>2]=i+8}else Px(ub,vb)}j=j+1|0}e=c[A>>2]|0;f=c[ub>>2]|0;i=e-f>>3;if(i>>>0>91){LI(ub,i+-16|0);f=c[ub>>2]|0;e=c[A>>2]|0}Ze(f,e);e=c[A>>2]|0;f=c[ub>>2]|0;j=e-f>>3;k=f;if(j>>>0>2){i=j+-1|0;q=k+(i<<3)|0;p=c[q>>2]|0;q=c[q+4>>2]|0;while(1){m=i+-1|0;o=k+(m<<3)|0;n=c[o>>2]|0;o=c[o+4>>2]|0;r=m>>>0>2;if((n|0)==(p|0)&(o|0)==(q|0)){Ab=k+(i+-2<<3)|0;if(r&((c[Ab>>2]|0)!=(p|0)?1:(c[Ab+4>>2]|0)!=(q|0))){i=m;p=n;q=o;continue}else break}else if(r){i=m;p=n;q=o;continue}else break}if(m>>>0>j>>>1>>>0){LI(ub,i+1|0);f=c[ub>>2]|0;e=c[A>>2]|0}}e=e-f>>3;if(e>>>0<=39){if(e>>>0>6)LI(ub,e+-4|0)}else LI(ub,e-((e>>>0)/10|0)|0);i=c[ub>>2]|0;f=(c[A>>2]|0)-i>>3;do if(f>>>0>2){Ab=i;J=+((c[Ab>>2]|0)>>>0)+4294967296.0*+(c[Ab+4>>2]|0);Ab=i+(f+-1<<3)|0;K=+((c[Ab>>2]|0)>>>0)+4294967296.0*+(c[Ab+4>>2]|0);if(J*.9<K&J*1.1>K?(sb=gb,rb=c[sb>>2]|0,sb=c[sb+4>>2]|0,!((rb|0)==0&(sb|0)==0)):0){e=0;t=0.0;while(1){if((e|0)==(f|0))break;Ab=i+(e<<3)|0;e=e+1|0;t=t+(+((c[Ab>>2]|0)>>>0)+4294967296.0*+(c[Ab+4>>2]|0))}t=t/+(f>>>0);e=v;f=c[e>>2]|0;e=c[e+4>>2]|0;H=+(rb>>>0)+4294967296.0*+(sb>>>0);if(!((f|0)==0&(e|0)==0)){J=t;Ab=g5(f|0,e|0,rb|0,sb|0)|0;K=+(Ab>>>0)+4294967296.0*+(z>>>0);t=!(J>=K*.95)|!(J<=K*1.05)?t:(+(f>>>0)+4294967296.0*+(e>>>0))/H}if(!(t!=0.0)){e=0;f=0;break}t=1.0e9/t/H;e=c[s>>2]|0;do if(!e)f=0;else{$x(vb,e,1,c[tb>>2]|0,171,1);H=+Cq(vb);z5(vb);if(!(H!=0.0)){f=0;break}K=H*2.0;J=t;t=K>J*.9&K<J*1.1?t*.5:t;J=H;K=t;f=J>K*.99&J<K*1.01&1}while(0);if(I!=0.0){J=t;e=gb;K=I*(+((c[e>>2]|0)>>>0)+4294967296.0*+((c[e+4>>2]|0)>>>0))*1.0021e-09;e=J<I-K|J>I+K;break}if(f<<24>>24){e=0;f=1;break}Bt(b,1,c[tb>>2]|0,171,t,3,0);e=0;f=0}else{e=1;f=0}}else{e=0;f=0}while(0);aU(ub);i=e;e=(f&1)!=0}else{i=0;e=0}m:do if(!(i|e)){$x(ub,b,1,c[tb>>2]|0,171,1);Ab=a[F>>0]|0;n:do if(!((Ab<<24>>24<0?c[G>>2]|0:Ab&255)|0)){f=v;e=c[f>>2]|0;f=c[f+4>>2]|0;o:do if((e|0)<32999999){switch(e|0){case 0:break;default:break o}if(!f)break n}else if((e|0)<41999998){switch(e|0){case 32999999:break;default:break o}if(!f)break n;else break}else{switch(e|0){case 41999998:break;default:break o}if(!f)break n;else break}while(0);z5(ub);if((e|0)==41999999&(f|0)==0)break m;f=v;e=c[f>>2]|0;f=c[f+4>>2]|0;$x(ub,b,1,c[tb>>2]|0,171,1);Ab=a[L>>0]|0;Ab=((Ab<<24>>24<0?c[M>>2]|0:Ab&255)|0)==0;z5(ub);if(!Ab)break m;Bt(b,1,c[tb>>2]|0,171,1.0e9/(+(e>>>0)+4294967296.0*+(f>>>0)),3,0);e=c[tb>>2]|0;f=374395;break l}while(0);z5(ub);e=c[tb>>2]|0;f=374395;break l}while(0);e=c[tb>>2]|0;if(i)Ra=266;else f=374395}else{e=c[tb>>2]|0;Ra=266}while(0);if((Ra|0)==266){Ra=0;f=380821}RB(b,1,e,167,f,-1,1,0)}if(c[s>>2]|0){f=d+40|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e|0)==-1&(f|0)==-1)?(Za=gb,Xa=c[Za>>2]|0,Za=c[Za+4>>2]|0,!((Xa|0)==0&(Za|0)==0)):0){t=(+(e>>>0)+4294967296.0*+(f>>>0))*+j6(Xa,Za)/1.0e6;do if((((c[Ua>>2]|0)==2?(RA(b,1,-1)|0)==1:0)?(RA(c[s>>2]|0,0,-1)|0)!=0:0)?(_a=c[s>>2]|0,ab=_a+560|0,$a=c[ab>>2]|0,ab=c[ab+4>>2]|0,!(($a|0)==0&(ab|0)==0)):0){e=c[d+72>>2]|0;if(e|0){t=t+(+($a>>>0)+4294967296.0*+(ab>>>0))*1.0e3/+(e>>>0);break}$x(ub,_a,2,0,112,1);e=rm(ub)|0;f=z;z5(ub);if((e|0)==0&(f|0)==0){$x(ub,c[s>>2]|0,2,0,116,1);e=rm(ub)|0;f=z;z5(ub);if((e|0)==0&(f|0)==0)break}Ab=(c[s>>2]|0)+560|0;t=t+(+((c[Ab>>2]|0)>>>0)+4294967296.0*+((c[Ab+4>>2]|0)>>>0))*1.0e3/(+(e>>>0)+4294967296.0*+(f>>>0))}while(0);Ab=c[Ua>>2]|0;v=c[tb>>2]|0;KW(b,Ab,v,Rb(Ab,63)|0,t,0,1);Ab=c[Ua>>2]|0;v=c[tb>>2]|0;RB(b,Ab,v,Rb(Ab,72)|0,380001,-1,1,0);Ab=c[Ua>>2]|0;v=c[tb>>2]|0;$x(ub,b,Ab,v,Rb(Ab,22)|0,1);H=+Eq(ub);if(!(!(H>=t)|(u|H==0.0))){Ab=oH(ub,46,0)|0;v=a[ja>>0]|0;v=v<<24>>24<0?c[ka>>2]|0:v&255;u=c[Ua>>2]|0;r=c[tb>>2]|0;KW(b,u,r,Rb(u,22)|0,H-t,v-((Ab|0)==-1?v:Ab+1|0)&255,1)}z5(ub)}Ab=c[Ua>>2]|0;v=c[tb>>2]|0;$x(ub,b,Ab,v,Rb(Ab,17)|0,1);G2(b,c[s>>2]|0);Gb(b,c[s>>2]|0,c[Ua>>2]|0,0,c[tb>>2]|0,1)|0;if((c[w>>2]|0)==1?(Ab=a[P>>0]|0,(Ab<<24>>24<0?c[Q>>2]|0:Ab&255)|0):0){Ab=c[Ua>>2]|0;w=c[tb>>2]|0;zb(b,Ab,w,Rb(Ab,17)|0,ub,1)}p:do if((c[Ua>>2]|0)==2){$x(vb,b,2,c[tb>>2]|0,18,1);e=i9(29652)|0;Ab=a[R>>0]|0;if((e|0)==((Ab<<24>>24<0?c[S>>2]|0:Ab&255)|0)?(VG(vb,29652,e)|0)==0:0){z5(vb);Ra=295}else Ra=290;do if((Ra|0)==290){Ra=0;$x(wb,b,2,c[tb>>2]|0,18,1);e=i9(40168)|0;Ab=a[ba>>0]|0;if((e|0)==((Ab<<24>>24<0?c[ca>>2]|0:Ab&255)|0)?(VG(wb,40168,e)|0)==0:0){z5(wb);z5(vb);Ra=295;break}$x(xb,b,2,c[tb>>2]|0,18,1);e=i9(29668)|0;Ab=a[da>>0]|0;if((e|0)==((Ab<<24>>24<0?c[ea>>2]|0:Ab&255)|0)){Ab=(VG(xb,29668,e)|0)==0;z5(xb);z5(wb);z5(vb);if(Ab){Ra=295;break}else break}else{z5(xb);z5(wb);z5(vb);break}}while(0);if((Ra|0)==295){Ra=0;Ed(b,2,c[tb>>2]|0,147)}if((c[Ua>>2]|0)==2){$x(vb,b,2,c[tb>>2]|0,18,1);e=i9(39840)|0;Ab=a[T>>0]|0;if((e|0)==((Ab<<24>>24<0?c[U>>2]|0:Ab&255)|0)?(VG(vb,39840,e)|0)==0:0){f=0;i=0}else Ra=300;do if((Ra|0)==300){Ra=0;$x(eb,b,2,c[tb>>2]|0,18,1);e=i9(39812)|0;Ab=a[Z>>0]|0;if((e|0)==((Ab<<24>>24<0?c[_>>2]|0:Ab&255)|0)?(VG(eb,39812,e)|0)==0:0){f=0;i=1;break}$x(fb,b,2,c[tb>>2]|0,18,1);e=i9(29616)|0;Ab=a[$>>0]|0;if((e|0)==((Ab<<24>>24<0?c[aa>>2]|0:Ab&255)|0)?(VG(fb,29616,e)|0)==0:0){f=1;i=1;break}z5(fb);z5(eb);z5(vb);break p}while(0);$x(wb,b,2,c[tb>>2]|0,124,1);e=i9(25344)|0;Ab=a[V>>0]|0;if((e|0)==((Ab<<24>>24<0?c[W>>2]|0:Ab&255)|0)?(VG(wb,25344,e)|0)==0:0){$x(xb,b,2,c[tb>>2]|0,122,1);e=i9(25268)|0;Ab=a[X>>0]|0;if((e|0)==((Ab<<24>>24<0?c[Y>>2]|0:Ab&255)|0))e=(VG(xb,25268,e)|0)==0;else e=0;z5(xb);z5(wb);if(f)Ra=311;else Ra=312}else{z5(wb);if(f){e=0;Ra=311}else{e=0;Ra=312}}if((Ra|0)==311){z5(fb);if(i)Ra=313;else Ra=314}else if((Ra|0)==312)if(i)Ra=313;else Ra=314;if((Ra|0)==313){Ra=0;z5(eb);z5(vb);if(!e)break}else if((Ra|0)==314?(Ra=0,z5(vb),!e):0)break;Ed(b,2,c[tb>>2]|0,124);sM(b,2,c[tb>>2]|0,122,6,1)}}while(0);$x(vb,b,1,c[tb>>2]|0,167,1);e=i9(22612)|0;Ab=a[fa>>0]|0;if((e|0)==((Ab<<24>>24<0?c[ga>>2]|0:Ab&255)|0)?(VG(vb,22612,e)|0)==0:0){$x(wb,b,1,c[tb>>2]|0,181,1);Ab=a[ha>>0]|0;Ab=((Ab<<24>>24<0?c[ia>>2]|0:Ab&255)|0)==0;z5(wb);z5(vb);if(Ab){Ab=c[tb>>2]|0;$x(vb,b,1,Ab,171,1);zb(b,1,Ab,181,vb,0);z5(vb);Ed(b,1,c[tb>>2]|0,171)}}else z5(vb);e=d+160|0;Ab=e;f=d+168|0;if(!((c[Ab>>2]|0)==0&(c[Ab+4>>2]|0)==0?(Ab=f,(c[Ab>>2]|0)==0&(c[Ab+4>>2]|0)==0):0)){w=c[tb>>2]|0;$x(vb,b,1,w,130,1);zb(b,1,w,134,vb,1);z5(vb);w=c[tb>>2]|0;$x(vb,b,1,w,130,1);Ab=rm(vb)|0;v=e;v=D_(Ab|0,z|0,c[v>>2]|0,c[v+4>>2]|0)|0;Ab=f;Ab=D_(v|0,z|0,c[Ab>>2]|0,c[Ab+4>>2]|0)|0;oK(b,1,w,130,Ab,z,10,1);z5(vb);Ab=e;oK(b,1,c[tb>>2]|0,132,c[Ab>>2]|0,c[Ab+4>>2]|0,10,1)}e=d+176|0;Ab=e;f=d+152|0;if(!((c[Ab>>2]|0)==0&(c[Ab+4>>2]|0)==0?(Ab=f,(c[Ab>>2]|0)==0&(c[Ab+4>>2]|0)==0):0)){w=c[tb>>2]|0;$x(vb,b,1,w,138,1);zb(b,1,w,142,vb,1);z5(vb);w=c[tb>>2]|0;$x(vb,b,1,w,138,1);Ab=rm(vb)|0;v=e;v=D_(Ab|0,z|0,c[v>>2]|0,c[v+4>>2]|0)|0;Ab=f;Ab=D_(v|0,z|0,c[Ab>>2]|0,c[Ab+4>>2]|0)|0;oK(b,1,w,138,Ab,z,10,1);z5(vb);Ab=e;oK(b,1,c[tb>>2]|0,140,c[Ab>>2]|0,c[Ab+4>>2]|0,10,1)}z5(ub)}e=d+80|0;if(+h[e>>3]!=0.0?($x(ub,b,1,c[tb>>2]|0,171,1),Ab=a[N>>0]|0,Ab=((Ab<<24>>24<0?c[O>>2]|0:Ab&255)|0)==0,z5(ub),Ab):0)KW(b,1,c[tb>>2]|0,171,+h[e>>3],3,0);xM(b,c[Ua>>2]|0,c[tb>>2]|0,382832,a[x+75>>0]|0?382808:382840,0);xM(b,c[Ua>>2]|0,c[tb>>2]|0,374047,a[d+92>>0]|0?382808:382840,0);e=c[d+4>>2]|0;if(!e)while(1){e=c[d+8>>2]|0;if((c[e>>2]|0)==(d|0)){d=e;continue d}else d=e}else d=e;while(1){e=c[d>>2]|0;if(!e)break;else d=e}}if((Ra|0)==44){Ab=gb;q:do if(!((c[Ab>>2]|0)==0&(c[Ab+4>>2]|0)==0)){i=b+988|0;j=b+976|0;k=b+980|0;m=b+992|0;n=b+996|0;o=wb+8+3|0;p=wb+4|0;q=ub+8+3|0;r=ub+4|0;s=vb+11|0;d=0;while(1){c[i>>2]=d;if(d>>>0>=(((c[k>>2]|0)-(c[j>>2]|0)|0)/12|0)>>>0)break q;Kc(b,6,-1)|0;d=c[tb>>2]|0;lL(b,6,d,90,RA(b,6,d)|0,10,1);d=0;while(1){c[m>>2]=d;Ab=c[i>>2]|0;sb=c[j>>2]|0;e=c[sb+(Ab*12|0)>>2]|0;if(d>>>0>=(((c[sb+(Ab*12|0)+4>>2]|0)-e|0)/24|0)>>>0)break;Ab=e+(d*24|0)|0;if(!((c[Ab>>2]|0)==-1?(c[Ab+4>>2]|0)==-1:0)){TX(ub);d=0;while(1){c[n>>2]=d;Ab=c[m>>2]|0;sb=c[(c[j>>2]|0)+((c[i>>2]|0)*12|0)>>2]|0;if(d>>>0>=(((c[sb+(Ab*24|0)+12>>2]|0)-(c[sb+(Ab*24|0)+8>>2]|0)|0)/24|0)>>>0)break;TX(vb);d=c[n>>2]|0;f=c[(c[(c[j>>2]|0)+((c[i>>2]|0)*12|0)>>2]|0)+((c[m>>2]|0)*24|0)+8>>2]|0;e=a[f+(d*24|0)+8+3>>0]|0;if(e<<24>>24<0)e=c[f+(d*24|0)+4>>2]|0;else e=e&255;if(!e)e=f;else{nt(xb,SG(f+(d*24|0)|0)|0,58);p2(wb,xb);vF(vb,wb)|0;z5(wb);O0(xb);e=c[(c[(c[j>>2]|0)+((c[i>>2]|0)*12|0)>>2]|0)+((c[m>>2]|0)*24|0)+8>>2]|0;d=c[n>>2]|0}rb=e+(d*24|0)+12|0;Ab=a[e+(d*24|0)+20+3>>0]|0;sb=Ab<<24>>24<0;Ex(vb,sb?c[rb>>2]|0:rb,sb?c[e+(d*24|0)+16>>2]|0:Ab&255)|0;Bs(wb,vb,41596);d=a[o>>0]|0;Ab=d<<24>>24<0;Ex(ub,Ab?c[wb>>2]|0:wb,Ab?c[p>>2]|0:d&255)|0;O0(wb);z5(vb);d=(c[n>>2]|0)+1|0}d=a[q>>0]|0;d=d<<24>>24<0?c[r>>2]|0:d&255;if(d|0)FB(ub,d+-3|0,0);d=c[tb>>2]|0;TX(wb);Ab=(c[(c[j>>2]|0)+((c[i>>2]|0)*12|0)>>2]|0)+((c[m>>2]|0)*24|0)|0;Ab=g5(c[Ab>>2]|0,c[Ab+4>>2]|0,1e6,0)|0;Sn(vb,Hg(wb,Ab,z)|0);Mc(b,6,d,(a[s>>0]|0)<0?c[vb>>2]|0:vb,ub,0);a1(vb);z5(wb);z5(ub);d=c[m>>2]|0}d=d+1|0}d=c[tb>>2]|0;lL(b,6,d,91,RA(b,6,d)|0,10,1);d=(c[i>>2]|0)+1|0}}while(0);d=a[b+36+3>>0]|0;if(d<<24>>24<0)d=c[b+32>>2]|0;else d=d&255;if(d|0)UM(Qa);l=yb;return}else if((Ra|0)==60)uaa();else if((Ra|0)==64){Ab=ua(8)|0;K2(Ab,391652);c[Ab>>2]=57868;Ya(Ab|0,2712,367)}}
function wb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;l=a+508|0;d=c[l>>2]|0;i=a+668|0;a:do if(!d)j=2287;else{e=c[i>>2]|0;f=$$(e,1)|0;g=z;h=(d|0)==1;b:do if((f|0)<172351395){switch(f|0){case 139690087:break;default:break b}if(!g){if(h){sD(a);o7(a);d=c[l>>2]|0;if((d|0)==1){j=2287;break a}e=c[i>>2]|0}f=$$(e,2)|0;g=z;c:do if((f|0)<39109479){if((f|0)<108)switch(f|0){case 63:{if(g|0)break c;if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){Ro(a);j=2287;break a}else{c3(2,e);break a}}case -1:{if(g|0)break c;if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){G$(a);j=2287;break a}else{c3(2,e);break a}}default:break c}if((f|0)<4433776){switch(f|0){case 108:break;default:break c}if(g|0)break;if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){n7(a);j=2287;break a}else{c3(2,e);break a}}if((f|0)>=21863284){switch(f|0){case 21863284:break;default:break c}if(g|0)break;if((d|0)==2){UV(a);o7(a);d=c[l>>2]|0;if((d|0)==2){j=2287;break a}e=c[i>>2]|0}h=$$(e,3)|0;f=z;switch(h|0){case 63:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){Ro(a);j=2287;break a}else{c3(3,e);break a}}break}case 108:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){n7(a);j=2287;break a}else{c3(3,e);break a}}break}case 3515:{if(!f){if((d|0)==3){lX(a);o7(a);d=c[l>>2]|0;if((d|0)==3){j=2287;break a}e=c[i>>2]|0}h=$$(e,4)|0;f=z;switch(h|0){case 63:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Ro(a);j=2287;break a}else{c3(4,e);break a}}break}case 108:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}break}case 5035:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){DM(a);j=2287;break a}else{c3(4,e);break a}}break}case 5036:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){RM(a);j=2287;break a}else{c3(4,e);break a}}break}case -1:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}break}default:{}}j=HN(a,0)|0;e1(a,j,z);j=2287;break a}break}case -1:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){G$(a);j=2287;break a}else{c3(3,e);break a}}break}default:{}}j=HN(a,0)|0;e1(a,j,z);j=2287;break a}switch(f|0){case 4433776:break;default:break c}if(!g){if((d|0)==2){o7(a);d=c[l>>2]|0;if((d|0)==2){j=2287;break a}e=c[i>>2]|0}h=$$(e,3)|0;f=z;switch(h|0){case 63:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){Ro(a);j=2287;break a}else{c3(3,e);break a}}break}case 108:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){n7(a);j=2287;break a}else{c3(3,e);break a}}break}case 1465:{if(!f){if((d|0)==3){hU(a);o7(a);d=c[l>>2]|0;if((d|0)==3){j=2287;break a}e=c[i>>2]|0}h=$$(e,4)|0;f=z;switch(h|0){case 54:{if(!f){if((d|0)==4){UN(a);o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}f=$$(e,5)|0;g=z;d:do if((f|0)<108)switch(f|0){case 0:{if(g|0)break d;if((d|0)==5){pK(a);o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}h=$$(e,6)|0;f=z;e:do switch(h|0){case 5:{if(f|0)break e;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){hH(a);j=2287;break a}else{c3(6,e);break a}}case 63:{if(f|0)break e;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case 108:{if(f|0)break e;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 892:{if(f|0)break e;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){uH(a);j=2287;break a}else{c3(6,e);break a}}case 893:{if(f|0)break e;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){l5(a);j=2287;break a}else{c3(6,e);break a}}case 894:{if(f|0)break e;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){l5(a);j=2287;break a}else{c3(6,e);break a}}case -1:{if(f|0)break e;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 15:{if(g|0)break d;if((d|0)==5){o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}h=$$(e,6)|0;f=z;f:do switch(h|0){case 9:{if(f|0)break f;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 63:{if(f|0)break f;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case 108:{if(f|0)break f;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case -1:{if(f|0)break f;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 17:{if(g|0)break d;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){NM(a);j=2287;break a}else{c3(5,e);break a}}case 18:{if(g|0)break d;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 24:{if(g|0)break d;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 54:{if(g|0)break d;if((d|0)==5){UN(a);o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}f=$$(e,6)|0;g=z;g:do if((f|0)<108)switch(f|0){case 0:{if(g|0)break g;if((d|0)==6){pK(a);o7(a);d=c[l>>2]|0;if((d|0)==6){j=2287;break a}e=c[i>>2]|0}h=$$(e,7)|0;f=z;h:do switch(h|0){case 5:{if(f|0)break h;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){hH(a);j=2287;break a}else{c3(7,e);break a}}case 63:{if(f|0)break h;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){Ro(a);j=2287;break a}else{c3(7,e);break a}}case 108:{if(f|0)break h;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case 892:{if(f|0)break h;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){uH(a);j=2287;break a}else{c3(7,e);break a}}case 893:{if(f|0)break h;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){l5(a);j=2287;break a}else{c3(7,e);break a}}case 894:{if(f|0)break h;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){l5(a);j=2287;break a}else{c3(7,e);break a}}case -1:{if(f|0)break h;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 15:{if(g|0)break g;if((d|0)==6){o7(a);d=c[l>>2]|0;if((d|0)==6){j=2287;break a}e=c[i>>2]|0}h=$$(e,7)|0;f=z;i:do switch(h|0){case 9:{if(f|0)break i;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case 63:{if(f|0)break i;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){Ro(a);j=2287;break a}else{c3(7,e);break a}}case 108:{if(f|0)break i;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case -1:{if(f|0)break i;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 17:{if(g|0)break g;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){NM(a);j=2287;break a}else{c3(6,e);break a}}case 18:{if(g|0)break g;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 24:{if(g|0)break g;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 63:{if(g|0)break g;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case -1:{if(g|0)break g;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:break g}else{if((f|0)<10564){if((f|0)<5716)switch(f|0){case 108:{if(g|0)break g;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 1432:{if(g|0)break g;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}default:break g}if((f|0)<9155){switch(f|0){case 5716:break;default:break g}if(g|0)break;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){l5(a);j=2287;break a}else{c3(6,e);break a}}else{switch(f|0){case 9155:break;default:break g}if(g|0)break;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}}switch(f|0){case 10564:{if(g|0)break g;if((d|0)==6){o7(a);d=c[l>>2]|0;if((d|0)==6){j=2287;break a}e=c[i>>2]|0}f=$$(e,7)|0;g=z;j:do if((f|0)<1293)switch(f|0){case 63:{if(g|0)break j;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){Ro(a);j=2287;break a}else{c3(7,e);break a}}case 108:{if(g|0)break j;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case -1:{if(g|0)break j;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}default:break j}else{if((f|0)<10513){switch(f|0){case 1293:break;default:break j}if(g|0)break;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}switch(f|0){case 10513:break;case 10581:{if(g|0)break j;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}default:break j}if(g|0)break;if((d|0)==7){o7(a);d=c[l>>2]|0;if((d|0)==7){j=2287;break a}e=c[i>>2]|0}f=$$(e,8)|0;g=z;k:do if((f|0)<108)switch(f|0){case 63:{if(g|0)break k;if((d|0)!=8){j=2287;break a}if(k2(8,e)|0){Ro(a);j=2287;break a}else{c3(8,e);break a}}case -1:{if(g|0)break k;if((d|0)!=8){j=2287;break a}if(k2(8,e)|0){G$(a);j=2287;break a}else{c3(8,e);break a}}default:break k}else{if((f|0)<10530){switch(f|0){case 108:break;default:break k}if(g|0)break;if((d|0)!=8){j=2287;break a}if(k2(8,e)|0){n7(a);j=2287;break a}else{c3(8,e);break a}}switch(f|0){case 10530:{if(g|0)break k;if((d|0)!=8){j=2287;break a}if(k2(8,e)|0){n7(a);j=2287;break a}else{c3(8,e);break a}}case 10547:{if(g|0)break k;if((d|0)!=8){j=2287;break a}if(k2(8,e)|0){G$(a);j=2287;break a}else{c3(8,e);break a}}default:break k}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 11879:{if(g|0)break g;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 11964:{if(g|0)break g;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 13252:{if(g|0)break g;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}default:break g}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 63:{if(g|0)break d;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case -1:{if(g|0)break d;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:break d}else{if((f|0)<10564){if((f|0)<5716)switch(f|0){case 108:{if(g|0)break d;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 1432:{if(g|0)break d;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}default:break d}if((f|0)<9155){switch(f|0){case 5716:break;default:break d}if(g|0)break;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){l5(a);j=2287;break a}else{c3(5,e);break a}}else{switch(f|0){case 9155:break;default:break d}if(g|0)break;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}}switch(f|0){case 10564:{if(g|0)break d;if((d|0)==5){o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}f=$$(e,6)|0;g=z;l:do if((f|0)<1293)switch(f|0){case 63:{if(g|0)break l;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case 108:{if(g|0)break l;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case -1:{if(g|0)break l;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:break l}else{if((f|0)<10513){switch(f|0){case 1293:break;default:break l}if(g|0)break;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}switch(f|0){case 10513:break;case 10581:{if(g|0)break l;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}default:break l}if(g|0)break;if((d|0)==6){o7(a);d=c[l>>2]|0;if((d|0)==6){j=2287;break a}e=c[i>>2]|0}f=$$(e,7)|0;g=z;m:do if((f|0)<108)switch(f|0){case 63:{if(g|0)break m;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){Ro(a);j=2287;break a}else{c3(7,e);break a}}case -1:{if(g|0)break m;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}default:break m}else{if((f|0)<10530){switch(f|0){case 108:break;default:break m}if(g|0)break;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}switch(f|0){case 10530:{if(g|0)break m;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case 10547:{if(g|0)break m;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}default:break m}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 11879:{if(g|0)break d;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 11964:{if(g|0)break d;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 13252:{if(g|0)break d;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}default:break d}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}break}case 63:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Ro(a);j=2287;break a}else{c3(4,e);break a}}break}case 108:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}break}case 1468:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}break}case 1469:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}break}case 1499:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}break}case 1501:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}break}case -1:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}break}default:{}}j=HN(a,0)|0;e1(a,j,z);j=2287;break a}break}case -1:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){G$(a);j=2287;break a}else{c3(3,e);break a}}break}default:{}}j=HN(a,0)|0;e1(a,j,z);j=2287;break a}}else{if((f|0)>=155296873){if((f|0)<206814059){switch(f|0){case 155296873:break;default:break c}if(g|0)break;if((d|0)==2){o7(a);d=c[l>>2]|0;if((d|0)==2){j=2287;break a}e=c[i>>2]|0}f=$$(e,3)|0;g=z;n:do if((f|0)>=108){if((f|0)<8615){switch(f|0){case 108:break;default:break n}if(g|0)break;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){n7(a);j=2287;break a}else{c3(3,e);break a}}switch(f|0){case 8615:break;default:break n}if(!g){if((d|0)==3){rz(a);o7(a);d=c[l>>2]|0;if((d|0)==3){j=2287;break a}e=c[i>>2]|0}h=$$(e,4)|0;f=z;o:do switch(h|0){case 63:{if(f|0)break o;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Ro(a);j=2287;break a}else{c3(4,e);break a}}case 108:{if(f|0)break o;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 1628:{if(f|0)break o;if((d|0)!=4){j=2287;break a}o7(a);Ln(a);j=2287;break a}case 1632:{if(f|0)break o;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){$w(a);j=2287;break a}else{c3(4,e);break a}}case 1633:{if(f|0)break o;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 1634:{if(f|0)break o;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 1646:{if(f|0)break o;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Zo(a);j=2287;break a}else{c3(4,e);break a}}case 1653:{if(f|0)break o;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}case 1662:{if(f|0)break o;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Xw(a);j=2287;break a}else{c3(4,e);break a}}case 1710:{if(f|0)break o;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case -1:{if(f|0)break o;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}default:{}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}}else switch(f|0){case 63:{if(g|0)break n;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){Ro(a);j=2287;break a}else{c3(3,e);break a}}case -1:{if(g|0)break n;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){G$(a);j=2287;break a}else{c3(3,e);break a}}default:break n}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}if((f|0)<256095861){switch(f|0){case 206814059:break;default:break c}if(g|0)break;if((d|0)==2){Z4(a);o7(a);d=c[l>>2]|0;if((d|0)==2){j=2287;break a}e=c[i>>2]|0}h=$$(e,3)|0;f=z;switch(h|0){case 59:{if(!f){if((d|0)==3){o7(a);d=c[l>>2]|0;if((d|0)==3){j=2287;break a}e=c[i>>2]|0}h=$$(e,4)|0;f=z;switch(h|0){case 51:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}break}case 55:{if(!f){if((d|0)==4){o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}h=$$(e,5)|0;f=z;p:do switch(h|0){case 50:{if(f|0)break p;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 63:{if(f|0)break p;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case 91:{if(f|0)break p;if((d|0)==5){o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}h=$$(e,6)|0;f=z;q:do switch(h|0){case 22:{if(f|0)break q;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 23:{if(f|0)break q;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 63:{if(f|0)break q;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case 107:{if(f|0)break q;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 108:{if(f|0)break q;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 4959:{if(f|0)break q;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case -1:{if(f|0)break q;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 106:{if(f|0)break p;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 108:{if(f|0)break p;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 112:{if(f|0)break p;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 113:{if(f|0)break p;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 119:{if(f|0)break p;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 4984:{if(f|0)break p;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case -1:{if(f|0)break p;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:{}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}break}case 63:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Ro(a);j=2287;break a}else{c3(4,e);break a}}break}case 108:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}break}case -1:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}break}default:{}}j=HN(a,0)|0;e1(a,j,z);j=2287;break a}break}case 63:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){Ro(a);j=2287;break a}else{c3(3,e);break a}}break}case 108:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){n7(a);j=2287;break a}else{c3(3,e);break a}}break}case -1:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){G$(a);j=2287;break a}else{c3(3,e);break a}}break}default:{}}j=HN(a,0)|0;e1(a,j,z);j=2287;break a}switch(f|0){case 256095861:break;default:break c}if(g|0)break;if((d|0)==2){_l(a);o7(a);d=c[l>>2]|0;if((d|0)==2){j=2287;break a}e=c[i>>2]|0}h=$$(e,3)|0;f=z;do switch(h|0){case 32:{if(!f){if((d|0)==3){B_(a);o7(a);d=c[l>>2]|0;if((d|0)==3){j=2287;break a}e=c[i>>2]|0}f=$$(e,4)|0;g=z;r:do if((f|0)<72)switch(f|0){case 14:{if(g|0)break r;if((d|0)==4){o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}h=$$(e,5)|0;f=z;s:do switch(h|0){case 63:{if(f|0)break s;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case 104:{if(f|0)break s;if((d|0)==5){o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}h=$$(e,6)|0;f=z;t:do switch(h|0){case 63:{if(f|0)break t;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case 75:{if(f|0)break t;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 76:{if(f|0)break t;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 77:{if(f|0)break t;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 78:{if(f|0)break t;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 79:{if(f|0)break t;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 108:{if(f|0)break t;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case -1:{if(f|0)break t;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 108:{if(f|0)break s;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case -1:{if(f|0)break s;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 27:{if(g|0)break r;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Bv(a);j=2287;break a}else{c3(4,e);break a}}case 33:{if(g|0)break r;if((d|0)==4){Zc(a);o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}h=$$(e,5)|0;f=z;u:do switch(h|0){case 63:{if(f|0)break u;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case 108:{if(f|0)break u;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case -2:{if((f|0)!=-1)break u;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Le(a);j=2287;break a}else{c3(5,e);break a}}case -1:{if(f|0)break u;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 34:{if(g|0)break r;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}case 36:{if(g|0)break r;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}case 63:{if(g|0)break r;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Ro(a);j=2287;break a}else{c3(4,e);break a}}case -1:{if(g|0)break r;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}default:break r}else{if((f|0)<123)switch(f|0){case 72:{if(g|0)break r;if((d|0)==4){o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}h=$$(e,5)|0;f=z;v:do switch(h|0){case 63:{if(f|0)break v;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case 73:{if(f|0)break v;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 74:{if(f|0)break v;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 108:{if(f|0)break v;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case -1:{if(f|0)break v;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 108:{if(g|0)break r;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 122:{if(g|0)break r;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}default:break r}if((f|0)<13729)switch(f|0){case 123:{if(g|0)break r;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 125:{if(g|0)break r;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}default:break r}switch(f|0){case 13729:break;case 13730:{if(g|0)break r;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}default:break r}if(g|0)break;if((d|0)==4){o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}h=$$(e,5)|0;f=z;w:do switch(h|0){case 38:{if(f|0)break w;if((d|0)==5){o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}h=$$(e,6)|0;f=z;x:do switch(h|0){case 37:{if(f|0)break x;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}case 63:{if(f|0)break x;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case 108:{if(f|0)break x;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 110:{if(f|0)break x;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case -1:{if(f|0)break x;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 63:{if(f|0)break w;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case 108:{if(f|0)break w;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case -1:{if(f|0)break w;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:{}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}break}case 35:{if(!f){if((d|0)==3){lW(a);o7(a);d=c[l>>2]|0;if((d|0)==3){j=2287;break a}e=c[i>>2]|0}h=$$(e,4)|0;f=z;switch(h|0){case 63:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Ro(a);j=2287;break a}else{c3(4,e);break a}}break}case 108:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}break}case -2:{if((f|0)==-1){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Le(a);j=2287;break a}else{c3(4,e);break a}}break}case -1:{if(!f){if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}break}default:{}}j=HN(a,0)|0;e1(a,j,z);j=2287;break a}break}case 39:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){n7(a);j=2287;break a}else{c3(3,e);break a}}break}case 43:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){n7(a);j=2287;break a}else{c3(3,e);break a}}break}case 47:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){G$(a);j=2287;break a}else{c3(3,e);break a}}break}case 63:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){Ro(a);j=2287;break a}else{c3(3,e);break a}}break}case 103:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){cZ(a);j=2287;break a}else{c3(3,e);break a}}break}case 108:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){n7(a);j=2287;break a}else{c3(3,e);break a}}break}case 6228:{if(!f){if((d|0)==3){o7(a);d=c[l>>2]|0;if((d|0)==3){j=2287;break a}e=c[i>>2]|0}f=$$(e,4)|0;g=z;y:do if((f|0)>=108)if((f|0)<6359){switch(f|0){case 108:break;default:break y}if(g|0)break;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}else{switch(f|0){case 6359:break;default:break y}if(g|0)break;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}else switch(f|0){case 63:{if(g|0)break y;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Ro(a);j=2287;break a}else{c3(4,e);break a}}case -1:{if(g|0)break y;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}default:break y}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}break}case -1:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){G$(a);j=2287;break a}else{c3(3,e);break a}}break}default:{}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}if((f|0)<88713574){switch(f|0){case 39109479:break;default:break c}if(g|0)break;if((d|0)==2){xV(a);o7(a);d=c[l>>2]|0;if((d|0)==2){j=2287;break a}e=c[i>>2]|0}f=$$(e,3)|0;g=z;z:do if((f|0)>=108){if((f|0)<13171){switch(f|0){case 108:break;default:break z}if(g|0)break;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){n7(a);j=2287;break a}else{c3(3,e);break a}}switch(f|0){case 13171:break;default:break z}if(!g){if((d|0)==3){tp(a);o7(a);d=c[l>>2]|0;if((d|0)==3){j=2287;break a}e=c[i>>2]|0}f=$$(e,4)|0;g=z;A:do if((f|0)<108)switch(f|0){case 63:{if(g|0)break A;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Ro(a);j=2287;break a}else{c3(4,e);break a}}case -1:{if(g|0)break A;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}default:break A}else{if((f|0)<9152){switch(f|0){case 108:break;default:break A}if(g|0)break;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}switch(f|0){case 9152:{if(g|0)break A;if((d|0)==4){o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}f=$$(e,5)|0;g=z;B:do if((f|0)<9157){if((f|0)<108)switch(f|0){case 63:{if(g|0)break B;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case -1:{if(g|0)break B;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:break B}if((f|0)<9156){switch(f|0){case 108:break;default:break B}if(g|0)break;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}else{switch(f|0){case 9156:break;default:break B}if(g|0)break;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}}else switch(f|0){case 9157:{if(g|0)break B;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){op(a);j=2287;break a}else{c3(5,e);break a}}case 9158:{if(g|0)break B;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 9161:{if(g|0)break B;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 9162:{if(g|0)break B;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){l5(a);j=2287;break a}else{c3(5,e);break a}}case 10442:{if(g|0)break B;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}default:break B}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 10184:break;default:break A}if(g|0)break;if((d|0)==4){o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}h=$$(e,5)|0;f=z;C:do switch(h|0){case 63:{if(f|0)break C;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case 108:{if(f|0)break C;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 1146:{if(f|0)break C;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){HU(a);j=2287;break a}else{c3(5,e);break a}}case 1147:{if(f|0)break C;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){l5(a);j=2287;break a}else{c3(5,e);break a}}case 1156:{if(f|0)break C;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 1157:{if(f|0)break C;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}case 1159:{if(f|0)break C;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){mc(a);j=2287;break a}else{c3(5,e);break a}}case 1443:{if(f|0)break C;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){YC(a);j=2287;break a}else{c3(5,e);break a}}case 10184:{if(f|0)break C;if((d|0)==5){o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}h=$$(e,6)|0;f=z;D:do switch(h|0){case 63:{if(f|0)break D;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case 108:{if(f|0)break D;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 1146:{if(f|0)break D;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){HU(a);j=2287;break a}else{c3(6,e);break a}}case 1147:{if(f|0)break D;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){l5(a);j=2287;break a}else{c3(6,e);break a}}case 1156:{if(f|0)break D;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 1157:{if(f|0)break D;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}case 1159:{if(f|0)break D;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){mc(a);j=2287;break a}else{c3(6,e);break a}}case 1443:{if(f|0)break D;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){YC(a);j=2287;break a}else{c3(6,e);break a}}case -1:{if(f|0)break D;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case -1:{if(f|0)break C;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:{}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}}else switch(f|0){case 63:{if(g|0)break z;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){Ro(a);j=2287;break a}else{c3(3,e);break a}}case -1:{if(g|0)break z;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){G$(a);j=2287;break a}else{c3(3,e);break a}}default:break z}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}if((f|0)<106212971){switch(f|0){case 88713574:break;default:break c}if(g|0)break;if((d|0)==2){R3(a);o7(a);d=c[l>>2]|0;if((d|0)==2){j=2287;break a}e=c[i>>2]|0}f=$$(e,3)|0;g=z;E:do if((f|0)>=10532){if((f|0)>=710577){if((f|0)<1882403)if((f|0)<1868715){switch(f|0){case 710577:break;default:break E}if(g|0)break;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){GS(a);j=2287;break a}else{c3(3,e);break a}}else{switch(f|0){case 1868715:break;default:break E}if(g|0)break;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){l5(a);j=2287;break a}else{c3(3,e);break a}}if((f|0)<1999803){switch(f|0){case 1882403:break;default:break E}if(g|0)break;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){n7(a);j=2287;break a}else{c3(3,e);break a}}if((f|0)<2013475){switch(f|0){case 1999803:break;default:break E}if(g|0)break;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){l5(a);j=2287;break a}else{c3(3,e);break a}}else{switch(f|0){case 2013475:break;default:break E}if(g|0)break;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){n7(a);j=2287;break a}else{c3(3,e);break a}}}if((f|0)>=13220)if((f|0)<15273){switch(f|0){case 13220:break;default:break E}if(g|0)break;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){Ml(a);j=2287;break a}else{c3(3,e);break a}}else{switch(f|0){case 15273:break;default:break E}if(g|0)break;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){hN(a);j=2287;break a}else{c3(3,e);break a}}if((f|0)>=13188){switch(f|0){case 13188:break;default:break E}if(g|0)break;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){l5(a);j=2287;break a}else{c3(3,e);break a}}switch(f|0){case 10532:break;default:break E}if(!g){if((d|0)==3){o7(a);d=c[l>>2]|0;if((d|0)==3){j=2287;break a}e=c[i>>2]|0}f=$$(e,4)|0;g=z;F:do if((f|0)<10661)switch(f|0){case 63:{if(g|0)break F;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Ro(a);j=2287;break a}else{c3(4,e);break a}}case 108:{if(g|0)break F;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case -1:{if(g|0)break F;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}default:break F}else switch(f|0){case 10661:{if(g|0)break F;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}case 10687:{if(g|0)break F;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 10748:{if(g|0)break F;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}default:break F}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}}else switch(f|0){case 63:{if(g|0)break E;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){Ro(a);j=2287;break a}else{c3(3,e);break a}}case 108:{if(g|0)break E;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){n7(a);j=2287;break a}else{c3(3,e);break a}}case 1092:{if(g|0)break E;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){G$(a);j=2287;break a}else{c3(3,e);break a}}case 1121:{if(g|0)break E;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){OC(a);j=2287;break a}else{c3(3,e);break a}}case 1161:{if(g|0)break E;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){tW(a);j=2287;break a}else{c3(3,e);break a}}case 3456:{if(g|0)break E;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){ZM(a);j=2287;break a}else{c3(3,e);break a}}case 5953:{if(g|0)break E;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){XM(a);j=2287;break a}else{c3(3,e);break a}}case -1:{if(g|0)break E;if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){G$(a);j=2287;break a}else{c3(3,e);break a}}default:break E}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}switch(f|0){case 106212971:break;default:break c}if(!g){if((d|0)==2){SK(a);o7(a);d=c[l>>2]|0;if((d|0)==2){j=2287;break a}e=c[i>>2]|0}h=$$(e,3)|0;f=z;switch(h|0){case 46:{if(!f){if((d|0)==3){fu(a);o7(a);d=c[l>>2]|0;if((d|0)==3){j=2287;break a}e=c[i>>2]|0}f=$$(e,4)|0;g=z;G:do if((f|0)<5546)do switch(f|0){case 3:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){ys(a);j=2287;break a}else{c3(4,e);break a}}case 6:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){TJ(a);j=2287;break a}else{c3(4,e);break a}}case 8:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){DL(a);j=2287;break a}else{c3(4,e);break a}}case 28:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 42:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 57:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 63:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Ro(a);j=2287;break a}else{c3(4,e);break a}}case 64:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 65:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 68:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 70:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 71:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 87:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){Ir(a);j=2287;break a}else{c3(4,e);break a}}case 96:{if(g|0)break G;if((d|0)==4){kX(a);o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}f=$$(e,5)|0;g=z;H:do if((f|0)<5296)do switch(f|0){case 26:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 29:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 48:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){oI(a);j=2287;break a}else{c3(5,e);break a}}case 58:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){kI(a);j=2287;break a}else{c3(5,e);break a}}case 63:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case 108:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 5048:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){vH(a);j=2287;break a}else{c3(5,e);break a}}case 5049:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){vH(a);j=2287;break a}else{c3(5,e);break a}}case 5056:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 5290:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){JK(a);j=2287;break a}else{c3(5,e);break a}}case -1:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:break H}while(0);else{if((f|0)<5341)switch(f|0){case 5296:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Jy(a);j=2287;break a}else{c3(5,e);break a}}case 5298:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 5299:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 5306:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ky(a);j=2287;break a}else{c3(5,e);break a}}case 5307:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){RK(a);j=2287;break a}else{c3(5,e);break a}}case 5324:{if(g|0)break H;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){QK(a);j=2287;break a}else{c3(5,e);break a}}default:break H}if((f|0)>=230371){if((f|0)<963876){switch(f|0){case 230371:break;default:break H}if(g|0)break;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){iO(a);j=2287;break a}else{c3(5,e);break a}}if((f|0)<1029411){switch(f|0){case 963876:break;default:break H}if(g|0)break;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}else{switch(f|0){case 1029411:break;default:break H}if(g|0)break;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){h3(a);j=2287;break a}else{c3(5,e);break a}}}if((f|0)<5552){switch(f|0){case 5341:break;default:break H}if(g|0)break;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){OK(a);j=2287;break a}else{c3(5,e);break a}}if((f|0)>=13936){switch(f|0){case 13936:break;default:break H}if(g|0)break;if((d|0)==5){o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}f=$$(e,6)|0;g=z;I:do if((f|0)<13938){if((f|0)<108)switch(f|0){case 63:{if(g|0)break I;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case -1:{if(g|0)break I;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:break I}if((f|0)<13937){switch(f|0){case 108:break;default:break I}if(g|0)break;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}else{switch(f|0){case 13937:break;default:break I}if(g|0)break;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}}else switch(f|0){case 13938:{if(g|0)break I;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}case 13939:{if(g|0)break I;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){h3(a);j=2287;break a}else{c3(6,e);break a}}case 13940:{if(g|0)break I;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){h3(a);j=2287;break a}else{c3(6,e);break a}}case 13941:{if(g|0)break I;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){h3(a);j=2287;break a}else{c3(6,e);break a}}default:break I}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}switch(f|0){case 5552:break;default:break H}if(g|0)break;if((d|0)==5){o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}h=$$(e,6)|0;f=z;J:do switch(h|0){case 63:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case 108:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 5553:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){oi(a);j=2287;break a}else{c3(6,e);break a}}case 5554:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 5555:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 5556:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 5557:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 5558:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 5559:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 5560:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 5561:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Tk(a);j=2287;break a}else{c3(6,e);break a}}case 5562:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){$k(a);j=2287;break a}else{c3(6,e);break a}}case 5563:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){fl(a);j=2287;break a}else{c3(6,e);break a}}case 5564:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 5565:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 5584:{if(f|0)break J;if((d|0)==6){o7(a);d=c[l>>2]|0;if((d|0)==6){j=2287;break a}e=c[i>>2]|0}h=$$(e,7)|0;f=z;K:do switch(h|0){case 63:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){Ro(a);j=2287;break a}else{c3(7,e);break a}}case 108:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case 5585:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){h3(a);j=2287;break a}else{c3(7,e);break a}}case 5586:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){h3(a);j=2287;break a}else{c3(7,e);break a}}case 5587:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){h3(a);j=2287;break a}else{c3(7,e);break a}}case 5588:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){h3(a);j=2287;break a}else{c3(7,e);break a}}case 5589:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){h3(a);j=2287;break a}else{c3(7,e);break a}}case 5590:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){h3(a);j=2287;break a}else{c3(7,e);break a}}case 5591:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){h3(a);j=2287;break a}else{c3(7,e);break a}}case 5592:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){h3(a);j=2287;break a}else{c3(7,e);break a}}case 5593:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){h3(a);j=2287;break a}else{c3(7,e);break a}}case 5594:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){h3(a);j=2287;break a}else{c3(7,e);break a}}case -1:{if(f|0)break K;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case -1:{if(f|0)break J;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:{}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 97:{if(g|0)break G;if((d|0)==4){o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}f=$$(e,5)|0;g=z;L:do if((f|0)>=108){if((f|0)>=14517)switch(f|0){case 14517:{if(g|0)break L;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){nQ(a);j=2287;break a}else{c3(5,e);break a}}case 15739:{if(g|0)break L;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:break L}if((f|0)<8804){switch(f|0){case 108:break;default:break L}if(g|0)break;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}else{switch(f|0){case 8804:break;default:break L}if(g|0)break;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){BM(a);j=2287;break a}else{c3(5,e);break a}}}else switch(f|0){case 31:{if(g|0)break L;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){fP(a);j=2287;break a}else{c3(5,e);break a}}case 53:{if(g|0)break L;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){wq(a);j=2287;break a}else{c3(5,e);break a}}case 63:{if(g|0)break L;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case -1:{if(g|0)break L;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:break L}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 98:{if(g|0)break G;if((d|0)==4){o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}h=$$(e,5)|0;f=z;M:do switch(h|0){case 63:{if(f|0)break M;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case 99:{if(f|0)break M;if((d|0)==5){o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}h=$$(e,6)|0;f=z;N:do switch(h|0){case 63:{if(f|0)break N;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case 100:{if(f|0)break N;if((d|0)==6){o7(a);d=c[l>>2]|0;if((d|0)==6){j=2287;break a}e=c[i>>2]|0}h=$$(e,7)|0;f=z;O:do switch(h|0){case 63:{if(f|0)break O;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){Ro(a);j=2287;break a}else{c3(7,e);break a}}case 101:{if(f|0)break O;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case 102:{if(f|0)break O;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case 108:{if(f|0)break O;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case -1:{if(f|0)break O;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 108:{if(f|0)break N;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case -1:{if(f|0)break N;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 105:{if(f|0)break M;if((d|0)==5){o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}h=$$(e,6)|0;f=z;P:do switch(h|0){case 63:{if(f|0)break P;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case 108:{if(f|0)break P;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 109:{if(f|0)break P;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case -1:{if(f|0)break P;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 108:{if(f|0)break M;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case -1:{if(f|0)break M;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 108:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 4974:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){qF(a);j=2287;break a}else{c3(4,e);break a}}case 4991:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case -1:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){G$(a);j=2287;break a}else{c3(4,e);break a}}default:break G}while(0);else{if((f|0)>=13253){if((f|0)<216698){if((f|0)<177564)switch(f|0){case 13253:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){zF(a);j=2287;break a}else{c3(4,e);break a}}case 13382:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}default:break G}if((f|0)<177565){switch(f|0){case 177564:break;default:break G}if(g|0)break;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){rK(a);j=2287;break a}else{c3(4,e);break a}}if((f|0)<209231){switch(f|0){case 177565:break;default:break G}if(g|0)break;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){l5(a);j=2287;break a}else{c3(4,e);break a}}else{switch(f|0){case 209231:break;default:break G}if(g|0)break;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){h3(a);j=2287;break a}else{c3(4,e);break a}}}if((f|0)<438848){if((f|0)<254851){switch(f|0){case 216698:break;default:break G}if(g|0)break;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}if((f|0)<362120){switch(f|0){case 254851:break;default:break G}if(g|0)break;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){XK(a);j=2287;break a}else{c3(4,e);break a}}else{switch(f|0){case 362120:break;default:break G}if(g|0)break;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){l5(a);j=2287;break a}else{c3(4,e);break a}}}else{if((f|0)<1742487){switch(f|0){case 438848:break;default:break G}if(g|0)break;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){l5(a);j=2287;break a}else{c3(4,e);break a}}if((f|0)<1785920){switch(f|0){case 1742487:break;default:break G}if(g|0)break;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){l5(a);j=2287;break a}else{c3(4,e);break a}}else{switch(f|0){case 1785920:break;default:break G}if(g|0)break;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){l5(a);j=2287;break a}else{c3(4,e);break a}}}}do switch(f|0){case 5546:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){KL(a);j=2287;break a}else{c3(4,e);break a}}case 5614:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 5802:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 5819:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 9122:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){jq(a);j=2287;break a}else{c3(4,e);break a}}case 9764:{if(g|0)break G;if((d|0)==4){o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}f=$$(e,5)|0;g=z;Q:do if((f|0)<9893)switch(f|0){case 63:{if(g|0)break Q;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case 108:{if(g|0)break Q;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case -1:{if(g|0)break Q;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:break Q}else switch(f|0){case 9893:{if(g|0)break Q;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}case 9919:{if(g|0)break Q;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}case 9980:{if(g|0)break Q;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}default:break Q}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 11648:{if(g|0)break G;if((d|0)==4){o7(a);d=c[l>>2]|0;if((d|0)==4){j=2287;break a}e=c[i>>2]|0}f=$$(e,5)|0;g=z;R:do if((f|0)<108)switch(f|0){case 63:{if(g|0)break R;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){Ro(a);j=2287;break a}else{c3(5,e);break a}}case -1:{if(g|0)break R;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){G$(a);j=2287;break a}else{c3(5,e);break a}}default:break R}else{if((f|0)<8768){switch(f|0){case 108:break;default:break R}if(g|0)break;if((d|0)!=5){j=2287;break a}if(k2(5,e)|0){n7(a);j=2287;break a}else{c3(5,e);break a}}switch(f|0){case 8768:break;default:break R}if(g|0)break;if((d|0)==5){o7(a);d=c[l>>2]|0;if((d|0)==5){j=2287;break a}e=c[i>>2]|0}h=$$(e,6)|0;f=z;S:do switch(h|0){case 63:{if(f|0)break S;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){Ro(a);j=2287;break a}else{c3(6,e);break a}}case 108:{if(f|0)break S;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 4145:{if(f|0)break S;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 4146:{if(f|0)break S;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 4147:{if(f|0)break S;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){n7(a);j=2287;break a}else{c3(6,e);break a}}case 4148:{if(f|0)break S;if((d|0)==6){nE(a);o7(a);d=c[l>>2]|0;if((d|0)==6){j=2287;break a}e=c[i>>2]|0}h=$$(e,7)|0;f=z;T:do switch(h|0){case 63:{if(f|0)break T;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){Ro(a);j=2287;break a}else{c3(7,e);break a}}case 108:{if(f|0)break T;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case 596:{if(f|0)break T;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){eB(a);j=2287;break a}else{c3(7,e);break a}}case 597:{if(f|0)break T;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){vB(a);j=2287;break a}else{c3(7,e);break a}}case -1:{if(f|0)break T;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 4149:{if(f|0)break S;if((d|0)==6){o7(a);d=c[l>>2]|0;if((d|0)==6){j=2287;break a}e=c[i>>2]|0}h=$$(e,7)|0;f=z;U:do switch(h|0){case 63:{if(f|0)break U;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){Ro(a);j=2287;break a}else{c3(7,e);break a}}case 108:{if(f|0)break U;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case 2017:{if(f|0)break U;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case 2018:{if(f|0)break U;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}case 2019:{if(f|0)break U;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}case 2020:{if(f|0)break U;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}case 2021:{if(f|0)break U;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case 2022:{if(f|0)break U;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){n7(a);j=2287;break a}else{c3(7,e);break a}}case -1:{if(f|0)break U;if((d|0)!=7){j=2287;break a}if(k2(7,e)|0){G$(a);j=2287;break a}else{c3(7,e);break a}}default:{}}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case -1:{if(f|0)break S;if((d|0)!=6){j=2287;break a}if(k2(6,e)|0){G$(a);j=2287;break a}else{c3(6,e);break a}}default:{}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}while(0);e1(a,HN(a,0)|0,z);j=2287;break a}case 11751:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 11768:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}case 12203:{if(g|0)break G;if((d|0)!=4){j=2287;break a}if(k2(4,e)|0){n7(a);j=2287;break a}else{c3(4,e);break a}}default:break G}while(0)}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}break}case 63:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){Ro(a);j=2287;break a}else{c3(3,e);break a}}break}case 108:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){n7(a);j=2287;break a}else{c3(3,e);break a}}break}case -1:{if(!f){if((d|0)!=3){j=2287;break a}if(k2(3,e)|0){G$(a);j=2287;break a}else{c3(3,e);break a}}break}default:{}}j=HN(a,0)|0;e1(a,j,z);j=2287;break a}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}}else{switch(f|0){case 172351395:break;default:break b}if(!g){if(h){o7(a);d=c[l>>2]|0;if((d|0)==1){j=2287;break a}e=c[i>>2]|0}h=$$(e,2)|0;f=z;do switch(h|0){case 63:{if(!f){if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){Ro(a);j=2287;break a}else{c3(2,e);break a}}break}case 108:{if(!f){if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){n7(a);j=2287;break a}else{c3(2,e);break a}}break}case 642:{if(!f){if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){jp(a);j=2287;break a}else{c3(2,e);break a}}break}case 645:{if(!f){if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){Ju(a);j=2287;break a}else{c3(2,e);break a}}break}case 646:{if(!f){if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){n7(a);j=2287;break a}else{c3(2,e);break a}}break}case 647:{if(!f){if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){Mu(a);j=2287;break a}else{c3(2,e);break a}}break}case 754:{if(!f){if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){n7(a);j=2287;break a}else{c3(2,e);break a}}break}case 755:{if(!f){if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){JP(a);j=2287;break a}else{c3(2,e);break a}}break}case 759:{if(!f){if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){n7(a);j=2287;break a}else{c3(2,e);break a}}break}case -1:{if(!f){if((d|0)!=2){j=2287;break a}if(k2(2,e)|0){G$(a);j=2287;break a}else{c3(2,e);break a}}break}default:{}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287;break a}}while(0);j=HN(a,0)|0;e1(a,j,z);j=2287}while(0);if((j|0)==2287){if(!(J1(c[l>>2]|0,c[i>>2]|0)|0)?(c[a+952>>2]|0)!=(c[a+956>>2]|0):0)Ak(a);e=a+1016|0;j=e;if(!((c[j>>2]|0)==0&(c[j+4>>2]|0)==0)?(i=a+48|0,i=z0(c[a+612>>2]|0,0,c[i>>2]|0,c[i+4>>2]|0)|0,m=a+528|0,b=m,k=c[b>>2]|0,b=c[b+4>>2]|0,i=z0(i|0,z|0,k|0,b|0)|0,j=a+1024|0,(i|0)==(c[j>>2]|0)?(z|0)==(c[j+4>>2]|0):0):0){f=a+536|0;d=k;while(1){k=f;if((c[l>>2]|0)>>>0<=(((d|0)==(c[k>>2]|0)?(b|0)==(c[k+4>>2]|0):0)?2:1)>>>0)break;J3(a);b=m;d=c[b>>2]|0;b=c[b+4>>2]|0}m=e;ty(a,c[m>>2]|0,c[m+4>>2]|0);m=e;c[m>>2]=0;c[m+4>>2]=0}}return}
function D6(a){a=a|0;Mj(a);return}function E6(a){a=a|0;Xk(a);return}function F6(a){a=a|0;Tf(a);return}function G6(a){a=a|0;vl(a);return}function H6(a){a=a|0;D6(a);return}function I6(a){a=a|0;Hw(a);return}function J6(a){a=a|0;Qk(a);return}function K6(a){a=a|0;return mO(a)|0}function L6(a,b){a=a|0;b=b|0;if(!o){o=a;p=b}}function M6(a,b){a=a|0;b=b|0;return c[a+(b<<2)>>2]|0}function N6(a){a=a|0;sW(a);c[a>>2]=5588;return}function O6(a){a=a|0;ZJ(a);return}function P6(a){a=a|0;W5(a);return}function Q6(a){a=a|0;qA(a);return}function R6(a,b,c){a=a|0;b=b|0;c=c|0;c=d5(a,b,c)|0;return c|0}function S6(a){a=a|0;return a+12|0}function T6(){c[102049]=0;c[102048]=57088;return}function U6(){c[102047]=0;c[102046]=57056;return}function V6(a){a=a|0;nZ(a);laa(a);return}function W6(a){a=a|0;UG(a);laa(a);return}function X6(a){a=a|0;EC(a);laa(a);return}function Y6(a,b,c){a=a|0;b=b|0;c=c|0;kb[a&63](b|0,c|0)}function Z6(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;S(7);return 0}function _6(a){a=a|0;return (a|0)!=50720&((a|0)!=0&(a|0)!=409040)&1|0}function $6(){c[101975]=0;c[101974]=54960;return}function a7(){c[101973]=0;c[101972]=54928;return}function b7(a,b){a=a|0;b=b|0;return (b-a|0)>>>3|0}function c7(b){b=b|0;a[b>>0]=0;a[b+1>>0]=0;return}function d7(a,b){a=a|0;b=b|0;return A5(a,b)|0}function e7(a){a=a|0;j8(a);laa(a);return}function f7(a){a=a|0;a_(a);laa(a);return}function g7(a){a=a|0;FG(a);laa(a);return}function h7(a){a=a|0;vV(a);laa(a);return}function i7(a){a=a|0;IP(a);laa(a);return}function j7(a){a=a|0;ix(a);laa(a);return}function k7(a){a=a|0;Q1(a);laa(a);return}function l7(a){a=a|0;GI(a);laa(a);return}function m7(a){a=a|0;OF(a);laa(a);return}function n7(a){a=a|0;Il(a);return}function o7(b){b=b|0;a[b+512>>0]=1;return}function p7(a,b){a=a|0;b=b|0;return -1}function q7(){c[101981]=0;c[101980]=57480;return}function r7(a){a=a|0;s6(c[a>>2]|0);return}function s7(a){a=a|0;i8(a);return}function t7(a){a=a|0;return F$(a)|0}function u7(a){a=a|0;lN(a);laa(a);return}function v7(a){a=a|0;Wu(a);laa(a);return}function w7(a){a=a|0;Tn(a);return}function x7(a,b,c){a=a|0;b=b|0;c=c|0;return JC(a,b,c)|0}function y7(a,b){a=a|0;b=b|0;c[a>>2]=b;return}function z7(a){a=a|0;mT(a);z5(a);return}function A7(b){b=b|0;a[b+773>>0]=0;return}function B7(a){a=a|0;c[a+904>>2]=0;return}function C7(a){a=a|0;_4(a);return}function D7(a){a=a|0;X4(a);return}function E7(a){a=a|0;$4(a);return}function F7(a,b,c){a=a|0;b=b|0;c=c|0;return Ub(O(c,b)|0)|0}function G7(a){a=a|0;return ((a+-48|0)>>>0<10|((a|32)+-97|0)>>>0<6)&1|0}function H7(){var a=0;a=c[102760]|0;c[102760]=a+0;return a|0}function I7(a,b){a=a|0;b=b|0;return b-a>>2|0}function J7(b,c){b=b|0;c=c|0;a[b>>0]=c;return}function K7(b){b=b|0;a[b+909>>0]=1;return}function L7(a){a=a|0;return a+-12|0}function M7(a){a=a|0;h[a+968>>3]=0.0;return}function N7(a){a=a|0;GV(a);return}function O7(){f5();return}function P7(a){a=a|0;return +(+uB(a))}function Q7(a){a=a|0;return +(+wM(a))}function R7(a){a=a|0;return +(+ZQ(a))}function S7(b){b=b|0;a[b+4>>0]=-1;return}function T7(a){a=a|0;TX(a+4|0);return}function U7(b){b=b|0;a[b+376>>0]=1;return 1}function V7(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;S(2)}function W7(a){a=a|0;var b=0;b=(U9(a)|0)==0;return (b?a:a&95)|0}function X7(a){a=a|0;var b=0;b=(T9(a)|0)==0;return (b?a:a|32)|0}function Y7(a,b,c){a=a|0;b=b|0;c=c|0;pq(a,b,c);return a|0}function Z7(a){a=a|0;z5(a+4|0);return}function _7(){var a=0;a=hQ(379775)|0;return a|0}function $7(a){a=a|0;c[a+820>>2]=0;return}function a8(a,b,c){a=a|0;b=b|0;c=c|0;return rO(a,b,c)|0}function b8(){var a=0;a=c[14439]|0;c[14439]=a+0;return a|0}function c8(a){a=a|0;cI(a);laa(a);return}function d8(a,b){a=a|0;b=b|0;return (a|0)==(b|0)|0}function e8(a){a=a|0;return a+4|0}function f8(a){a=a|0;a=MF(a)|0;return a|0}function g8(a){a=a|0;a=p6(a)|0;return a|0}function h8(a){a=a|0;a=q6(a)|0;return a|0}function i8(a){a=a|0;saa(c[a>>2]|0)|0;return}function j8(a){a=a|0;bt(a);return}function k8(a,b){a=a|0;b=b|0;return b-a|0}function l8(a){a=a|0;Y2(c[a>>2]|0);return}function m8(b){b=b|0;a[b+1039>>0]=1;return}function n8(a){a=a|0;r1(a);laa(a);return}function o8(a){a=a|0;s1(a);laa(a);return}function p8(a){a=a|0;ZR(a);return 411044}function q8(){Uf();return}function r8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;S(12);return 0}function s8(a){a=a|0;if(a|0)laa(a);return}function t8(a,b,c){a=a|0;b=b|0;c=c|0;return li(a,b,c)|0}function u8(a,b){a=a|0;b=b|0;return 0}function v8(a){a=a|0;c[a+788>>2]=-1;return}function w8(a,b,c){a=a|0;b=b|0;c=c|0;return Ft(a,b,c)|0}function x8(){MU();return}function y8(){OU();return}function z8(a){a=a|0;c[a+768>>2]=0;return}function A8(a,b){a=a|0;b=b|0;return nb[a&255](b|0)|0}function B8(a){a=a|0;Da(a|0)|0;TS()}function C8(a){a=a|0;z5(a);return}function D8(a){a=a|0;return c[a+12>>2]|0}function E8(a,b){a=a|0;b=b|0;return b<<24>>24|0}function F8(a,b,c){a=a|0;b=b|0;c=c|0;return C1(a,b,c)|0}function G8(a){a=a|0;GV(a);laa(a);return}function H8(a){a=a|0;e0(a);laa(a);return}function I8(a){a=a|0;y5(a);laa(a);return}function J8(a){a=a|0;return c[a+8>>2]|0}function K8(a){a=a|0;return c[a+56>>2]|0}function L8(a){a=a|0;jaa(a);return}function M8(b){b=b|0;return a[b+9>>0]|0}function N8(b){b=b|0;return a[b+8>>0]|0}function O8(a){a=a|0;return raa(c[a+4>>2]|0)|0}function P8(a){a=a|0;F5(a);laa(a);return}function Q8(a){a=a|0;return (a?382668:383821)|0}function R8(a){a=a|0;if(_6(a)|0)pe(a);return}function S8(a){a=a|0;r7(a);return}function T8(a,b){a=a|0;b=b|0;l=a;m=b}function U8(a){a=a|0;return 2147483647}function V8(a){a=a|0;a=f8(a)|0;return a|0}function W8(a){a=a|0;return S$(a)|0}function X8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;S(16)}function Y8(b){b=b|0;a[b>>0]=0;return}function Z8(a){a=a|0;return ((a|0)==32|(a+-9|0)>>>0<5)&1|0}function _8(a,b){a=a|0;b=b|0;jb[a&511](b|0)}function $8(a){a=a|0;d1(a);return}function a9(a,b){a=a|0;b=b|0;return wf(a,b)|0}function b9(a,b){a=a|0;b=b|0;return Z_(a,b)|0}function c9(a){a=a|0;return 4}function d9(a,b){a=a|0;b=b|0;return b|0}function e9(a){a=a|0;return a&255|0}function f9(a){a=a|0;return 127}function g9(a,b){a=a|0;b=b|0;return a|0}function h9(){Lr();return}function i9(a){a=a|0;return N0(a)|0}function j9(a){a=a|0;return FD(a)|0}function k9(){return k3(84,65,71)|0}function l9(a,b){a=a|0;b=b|0;cv(a,b);return a|0}function m9(){return (c[c[12815]>>2]|0?4:1)|0}function n9(a,b){a=a|0;b=b|0;return}function o9(a,b,c){a=a|0;b=b|0;c=c|0;S(1);return 0}function p9(a){a=a|0;lY(c[a>>2]|0);pe(a);return}function q9(a){a=a|0;return OD(a,c[12815]|0)|0}function r9(){xA(408388);return}function s9(a,b){a=a|0;b=b|0;return +(+t9(a,b))}function t9(a,b){a=a|0;b=b|0;return +(+CF(a,b,2))}function u9(a){a=a|0;return ((a|0)==32|(a|0)==9)&1|0}function v9(a,b){a=a|0;b=b|0;return +(+CF(a,b,0))}function w9(a,b){a=a|0;b=b|0;return +(+CF(a,b,1))}function x9(){c[102036]=57728;return}function y9(){c[102032]=57692;return}function z9(a){a=a|0;return -1}function A9(a,b){a=a|0;b=b|0;return +(+v9(a,b))}function B9(a,b){a=a|0;b=b|0;return +(+w9(a,b))}function C9(a){a=a|0;return W8(a)|0}function D9(a){a=a|0;return Z9(a)|0}function E9(a){a=a|0;return (aaa(a)|0)!=(a|0)|0}function F9(a){a=a|0;return ($9(a)|0)!=(a|0)|0}function G9(a){a=a|0;c[a>>2]=57908;return}function H9(a,b){a=+a;b=+b;return +(+PQ(a,b))}function I9(){TX(408468);return}function J9(){TX(408456);return}function K9(a){a=a|0;return 1}function L9(a,b){a=+a;b=b|0;return +(+LC(a,b))}function M9(){J9();return}function N9(){I9();return}function O9(a,b){a=+a;b=b|0;return +(+ND(a,b))}function P9(){TX(408444);return}function Q9(a,b,c){a=a|0;b=b|0;c=c|0;S(9)}function R9(a){a=a|0;return (a+-48|0)>>>0<10|0}function S9(){TX(408376);return}function T9(a){a=a|0;return (a+-65|0)>>>0<26|0}function U9(a){a=a|0;return (a+-97|0)>>>0<26|0}function V9(a,b){a=a|0;b=b|0;pe(b);return}function W9(a){a=a|0;return Xz(a)|0}function X9(a,b){a=+a;b=+b;return +(+ji(a,b))}function Y9(a){a=a|0;return gO(a)|0}function Z9(a){a=a|0;return raa(a)|0}function _9(a,b){a=a|0;b=b|0;S(14);return 0}function $9(a){a=a|0;return wo(a,0)|0}function aaa(a){a=a|0;return wo(a,1)|0}function baa(a){a=a|0;return 404640}function caa(a){a=a|0;pb[a&3]()}function daa(a){a=a|0;return G7(a)|0}function eaa(a){a=a|0;return +(+LC(1.0,a))}function faa(a){a=a|0;return u9(a)|0}function gaa(a){a=a|0;return +(+eJ(a))}function haa(a,b){a=a|0;b=b|0;S(5)}function iaa(a){a=a|0;return ZW(a)|0}function jaa(a){a=a|0;laa(a);return}function kaa(a){a=a|0;l=a}function laa(a){a=a|0;pe(a);return}function maa(a){a=a|0;return}function naa(a){a=a|0;z=a}function oaa(){return 408976}function paa(){Ua(409080);return}function qaa(a){a=a|0;S(8);return 0}function raa(a){a=a|0;return a|0}function saa(a){a=a|0;return 0}function taa(){Za(409080);return}function uaa(){ra()}function vaa(){return z|0}function waa(){return l|0}function xaa(a){a=a|0;S(4)}function yaa(){S(10)}

// EMSCRIPTEN_END_FUNCS
var fb=[P2,hv,cw,yi,cj,Ei,kj,P2];var gb=[o9,W4,Mz,Cz,su,W4,jA,aA,yo,AL,BN,nV,dV,cV,P0,P0,xU,yU,P4,E_,pV,qV,K4,Ay,F7,Cw,a8,o9,o9,o9,o9,o9];var hb=[V7,vx,fp,Nh];var ib=[b5,di,Wh,b5];var jb=[xaa,Yw,S4,KG,bt,k6,maa,maa,maa,maa,maa,maa,maa,maa,maa,maa,S_,maa,maa,maa,oU,maa,maa,maa,jaa,maa,jaa,y1,EK,u6,maa,maa,maa,maa,pJ,j4,fx,oQ,_g,aX,k6,P6,fW,OF,m7,sy,wV,Fm,eu,pm,r0,hW,hm,GI,l7,DU,PX,Wb,uc,lx,ai,Yp,Q1,k7,d2,_D,Im,IP,i7,$Q,xc,ip,P1,tc,Q1,k7,d2,l3,HI,by,Ci,iG,w6,mf,Fd,qi,od,nZ,V6,d$,Gp,xx,we,Wu,v7,ps,tA,Ab,se,wb,rF,x6,b_,lm,uv,yb,nd,xb,EO,c4,Qp,Ve,k6,Uq,Ip,PC,e6,maa,Jk,Dh,kf,Pr,Wj,Tm,Tl,Tt,mh,PV,d6,Yk,aw,maa,Nm,f4,Lt,Xt,zj,ud,Vy,Hx,vV,h7,Rh,tt,qf,Gf,OW,F4,ep,ap,P6,Lm,xz,UG,W6,M7,xv,Db,yc,Bb,lN,u7,Hc,ft,bc,ix,j7,Vm,maa,Jw,ow,In,Si,Dd,j8,e7,A7,j2,fw,maa,maa,PO,HO,hf,EC,X6,$Y,lg,maa,Fu,ei,ae,yM,f6,Z3,nc,$E,im,Gy,Fj,iv,v6,Kp,j2,Fb,Eh,Vd,om,cz,Mm,Oi,k6,zL,TY,FG,g7,B7,rN,ue,YH,nw,_p,Zs,a_,f7,maa,Rd,maa,nq,Lg,W3,y2,l$,m$,ZX,t$,dY,eY,$W,K$,j8,e7,Sq,MO,uX,maa,maa,k6,OL,KZ,k6,uN,OY,k6,W5,Bo,Qb,j8,e7,lR,fj,Cd,a$,A2,v2,w2,p$,q$,X3,z2,n$,o$,cS,B2,F5,P8,maa,YX,s$,bY,cY,_W,J$,hY,y$,w$,x$,mY,nY,X3,z2,n$,o$,W3,y2,l$,m$,GV,G8,G3,a2,F3,$1,maa,jaa,Y2,maa,jaa,maa,jaa,maa,jaa,maa,jaa,maa,jaa,maa,jaa,maa,jaa,L3,_1,L3,_1,maa,jaa,maa,jaa,maa,jaa,maa,jaa,maa,jaa,maa,jaa,maa,jaa,maa,jaa,maa,jaa,maa,jaa,maa,jaa,jaa,yY,o5,cI,c8,e0,H8,s1,o8,r1,n8,jaa,jaa,jaa,jaa,jaa,maa,jaa,maa,maa,jaa,y5,I8,I8,I8,maa,jaa,jaa,x2,maa,pe,hX,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa,xaa];var kb=[haa,b2,Rn,n9,mq,n9,EW,EW,EW,uV,U$,U$,EW,EW,EW,uV,U$,U$,EW,EW,EW,FV,U$,U$,EW,EW,EW,FV,U$,U$,n9,n9,E0,aG,$F,D0,AB,zB,V9,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa,haa];var lb=[N4,Uv,B$,xn,FQ,EQ,wQ,xQ,xQ,vQ,aQ,cQ,bQ,Jf,wn,DQ,CQ,tQ,uQ,uQ,sQ,ZP,$P,_P,Sf,Ns,Ms,Js,Is,AP,QD,XE,WE,KF,FP,uD,VE,UE,JF,Qi,Ki,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4,N4];var mb=[Z6,nl,ol,Uk,Vk,Z6,Z6,Z6];var nb=[qaa,z9,U7,K9,K9,K9,saa,Y0,r5,K8,a4,n6,R_,c1,JZ,zJ,kU,Jt,uO,lf,up,xO,jI,Xf,fK,Fy,aJ,Ec,Fr,Rr,yk,ED,vP,Aq,K9,N_,oc,zn,Pu,Z2,Wp,vs,rc,dn,ek,LS,$U,KV,ch,Uw,Bm,VA,EI,bp,WL,al,TA,EI,x4,FJ,Z2,x4,JJ,Z2,x4,SJ,vL,Ty,saa,saa,SF,oS,QO,$i,si,saa,saa,iH,_T,KX,z9,z9,h6,rZ,gZ,sZ,CD,BD,AD,DD,h6,kZ,aZ,lZ,FA,EA,DA,JA,f9,f9,saa,f9,f9,saa,U8,U8,saa,U8,U8,saa,saa,saa,c9,bL,saa,ZV,N8,M8,J8,D8,K9,K9,K9,saa,saa,c9,O8,baa,$0,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa,qaa];var ob=[Q9,wY,LQ,Q9];var pb=[yaa,cu,dZ,yaa];var qb=[Q0,Te,Se,sJ,tJ,cl,dk,cX,cX,oJ,rJ,Q0,Q0,Q0,Q0,Q0];var rb=[r8,mX,qS,PT,FS,tX,r8,r8];var sb=[B5,_j,pu,Tj,KU,KU,$r,lk,eQ,CJ,qp,B5,B5,B5,B5,B5];var tb=[_9,u8,u8,Rv,jm,Cx,yy,ew,yl,vz,sj,Sw,Gl,p7,p7,p7,p7,V0,H0,d9,f2,g2,E8,mV,_9,_9,_9,_9,_9,_9,_9,_9];var ub=[l6,MH,BI,mn,hr,gr,ts,nn,$q,dr,is,Z$,NY,Hy,LE,RU,fQ,Z$,g_,Z$,KY,l6,l6,l6,l6,l6,l6,l6,l6,l6,l6,l6];var vb=[X8,mU,Hv,mU,oW,oW,KB,Ry,OS,RL,Lx,X8,X8,X8,X8,X8];return{_llvm_bswap_i32:C5,__GLOBAL__sub_I_InfoMap_cpp:M9,_i64Subtract:D_,_emscripten_bind_MediaInfo___destroy___0:n5,___udivdi3:g5,dynCall_iiiiiii:LY,setThrew:L6,_emscripten_bind_MediaInfo_getOption_1:e5,dynCall_viii:i4,_bitshift64Lshr:XZ,_emscripten_bind_MediaInfo_MediaInfo_0:y6,dynCall_iiiiiid:eZ,_bitshift64Shl:PZ,dynCall_vi:_8,_emscripten_bind_MediaInfo_close_0:S8,_pthread_cond_broadcast:saa,dynCall_iiiiiiiii:pW,___cxa_is_pointer_type:R2,dynCall_iii:G5,_emscripten_bind_VoidPtr___destroy___0:s8,_memset:Ow,dynCall_ii:A8,_emscripten_bind_MediaInfo_openBufferInit_2:Q2,_sbrk:IN,_emscripten_bind_MediaInfo_inform_0:p8,_memcpy:no,stackAlloc:k4,___muldi3:UW,dynCall_vii:Y6,___uremdi3:nW,___divdi3:nF,getTempRet0:vaa,_emscripten_bind_MediaInfo_openBufferFinalize_0:X5,setTempRet0:naa,_i64Add:z0,dynCall_iiii:O2,_emscripten_bind_MediaInfo_openBufferContinue_2:f1,_pthread_mutex_unlock:saa,__GLOBAL__sub_I_Ztring_cpp:N9,dynCall_iiiiid:k$,_emscripten_get_global_libc:oaa,dynCall_iiiii:t0,___remdi3:pB,dynCall_iiiiiiii:qX,__GLOBAL__sub_I_MediaInfo_Config_cpp:K1,dynCall_iiiiii:Q_,stackSave:waa,dynCall_viiiii:C$,___cxa_can_catch:SS,_emscripten_bind_MediaInfo_setOption_2:o2,_free:pe,runPostSets:C_,dynCall_viiii:b1,dynCall_viiiiii:CZ,establishStackSpace:T8,_memmove:TR,stackRestore:kaa,_malloc:Ub,_pthread_mutex_lock:saa,_emscripten_bind_MediaInfo_openBufferGetSeekTo_0:v4,dynCall_v:caa}})


// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg,Module.asmLibraryArg,buffer);var __GLOBAL__sub_I_InfoMap_cpp=Module["__GLOBAL__sub_I_InfoMap_cpp"]=asm["__GLOBAL__sub_I_InfoMap_cpp"];var stackSave=Module["stackSave"]=asm["stackSave"];var getTempRet0=Module["getTempRet0"]=asm["getTempRet0"];var _emscripten_bind_MediaInfo___destroy___0=Module["_emscripten_bind_MediaInfo___destroy___0"]=asm["_emscripten_bind_MediaInfo___destroy___0"];var ___udivdi3=Module["___udivdi3"]=asm["___udivdi3"];var setThrew=Module["setThrew"]=asm["setThrew"];var _emscripten_bind_MediaInfo_getOption_1=Module["_emscripten_bind_MediaInfo_getOption_1"]=asm["_emscripten_bind_MediaInfo_getOption_1"];var _bitshift64Lshr=Module["_bitshift64Lshr"]=asm["_bitshift64Lshr"];var _emscripten_bind_MediaInfo_MediaInfo_0=Module["_emscripten_bind_MediaInfo_MediaInfo_0"]=asm["_emscripten_bind_MediaInfo_MediaInfo_0"];var _bitshift64Shl=Module["_bitshift64Shl"]=asm["_bitshift64Shl"];var _emscripten_bind_MediaInfo_close_0=Module["_emscripten_bind_MediaInfo_close_0"]=asm["_emscripten_bind_MediaInfo_close_0"];var ___cxa_is_pointer_type=Module["___cxa_is_pointer_type"]=asm["___cxa_is_pointer_type"];var _emscripten_bind_VoidPtr___destroy___0=Module["_emscripten_bind_VoidPtr___destroy___0"]=asm["_emscripten_bind_VoidPtr___destroy___0"];var _memset=Module["_memset"]=asm["_memset"];var _emscripten_bind_MediaInfo_openBufferInit_2=Module["_emscripten_bind_MediaInfo_openBufferInit_2"]=asm["_emscripten_bind_MediaInfo_openBufferInit_2"];var _sbrk=Module["_sbrk"]=asm["_sbrk"];var _emscripten_bind_MediaInfo_inform_0=Module["_emscripten_bind_MediaInfo_inform_0"]=asm["_emscripten_bind_MediaInfo_inform_0"];var _memcpy=Module["_memcpy"]=asm["_memcpy"];var stackAlloc=Module["stackAlloc"]=asm["stackAlloc"];var ___muldi3=Module["___muldi3"]=asm["___muldi3"];var ___uremdi3=Module["___uremdi3"]=asm["___uremdi3"];var ___divdi3=Module["___divdi3"]=asm["___divdi3"];var _i64Subtract=Module["_i64Subtract"]=asm["_i64Subtract"];var _emscripten_bind_MediaInfo_openBufferContinue_2=Module["_emscripten_bind_MediaInfo_openBufferContinue_2"]=asm["_emscripten_bind_MediaInfo_openBufferContinue_2"];var _emscripten_bind_MediaInfo_openBufferFinalize_0=Module["_emscripten_bind_MediaInfo_openBufferFinalize_0"]=asm["_emscripten_bind_MediaInfo_openBufferFinalize_0"];var setTempRet0=Module["setTempRet0"]=asm["setTempRet0"];var _i64Add=Module["_i64Add"]=asm["_i64Add"];var _pthread_mutex_unlock=Module["_pthread_mutex_unlock"]=asm["_pthread_mutex_unlock"];var __GLOBAL__sub_I_MediaInfo_Config_cpp=Module["__GLOBAL__sub_I_MediaInfo_Config_cpp"]=asm["__GLOBAL__sub_I_MediaInfo_Config_cpp"];var __GLOBAL__sub_I_Ztring_cpp=Module["__GLOBAL__sub_I_Ztring_cpp"]=asm["__GLOBAL__sub_I_Ztring_cpp"];var _emscripten_get_global_libc=Module["_emscripten_get_global_libc"]=asm["_emscripten_get_global_libc"];var ___remdi3=Module["___remdi3"]=asm["___remdi3"];var _pthread_cond_broadcast=Module["_pthread_cond_broadcast"]=asm["_pthread_cond_broadcast"];var _llvm_bswap_i32=Module["_llvm_bswap_i32"]=asm["_llvm_bswap_i32"];var ___cxa_can_catch=Module["___cxa_can_catch"]=asm["___cxa_can_catch"];var _emscripten_bind_MediaInfo_setOption_2=Module["_emscripten_bind_MediaInfo_setOption_2"]=asm["_emscripten_bind_MediaInfo_setOption_2"];var _free=Module["_free"]=asm["_free"];var runPostSets=Module["runPostSets"]=asm["runPostSets"];var establishStackSpace=Module["establishStackSpace"]=asm["establishStackSpace"];var _memmove=Module["_memmove"]=asm["_memmove"];var stackRestore=Module["stackRestore"]=asm["stackRestore"];var _malloc=Module["_malloc"]=asm["_malloc"];var _pthread_mutex_lock=Module["_pthread_mutex_lock"]=asm["_pthread_mutex_lock"];var _emscripten_bind_MediaInfo_openBufferGetSeekTo_0=Module["_emscripten_bind_MediaInfo_openBufferGetSeekTo_0"]=asm["_emscripten_bind_MediaInfo_openBufferGetSeekTo_0"];var dynCall_iiiiiiii=Module["dynCall_iiiiiiii"]=asm["dynCall_iiiiiiii"];var dynCall_iiii=Module["dynCall_iiii"]=asm["dynCall_iiii"];var dynCall_viiiii=Module["dynCall_viiiii"]=asm["dynCall_viiiii"];var dynCall_iiiiiid=Module["dynCall_iiiiiid"]=asm["dynCall_iiiiiid"];var dynCall_vi=Module["dynCall_vi"]=asm["dynCall_vi"];var dynCall_vii=Module["dynCall_vii"]=asm["dynCall_vii"];var dynCall_iiiiiii=Module["dynCall_iiiiiii"]=asm["dynCall_iiiiiii"];var dynCall_iiiiid=Module["dynCall_iiiiid"]=asm["dynCall_iiiiid"];var dynCall_ii=Module["dynCall_ii"]=asm["dynCall_ii"];var dynCall_viii=Module["dynCall_viii"]=asm["dynCall_viii"];var dynCall_v=Module["dynCall_v"]=asm["dynCall_v"];var dynCall_iiiiiiiii=Module["dynCall_iiiiiiiii"]=asm["dynCall_iiiiiiiii"];var dynCall_iiiii=Module["dynCall_iiiii"]=asm["dynCall_iiiii"];var dynCall_viiiiii=Module["dynCall_viiiiii"]=asm["dynCall_viiiiii"];var dynCall_iii=Module["dynCall_iii"]=asm["dynCall_iii"];var dynCall_iiiiii=Module["dynCall_iiiiii"]=asm["dynCall_iiiiii"];var dynCall_viiii=Module["dynCall_viiii"]=asm["dynCall_viiii"];Runtime.stackAlloc=Module["stackAlloc"];Runtime.stackSave=Module["stackSave"];Runtime.stackRestore=Module["stackRestore"];Runtime.establishStackSpace=Module["establishStackSpace"];Runtime.setTempRet0=Module["setTempRet0"];Runtime.getTempRet0=Module["getTempRet0"];Module["asm"]=asm;if(memoryInitializer){if(typeof Module["locateFile"]==="function"){memoryInitializer=Module["locateFile"](memoryInitializer)}else if(Module["memoryInitializerPrefixURL"]){memoryInitializer=Module["memoryInitializerPrefixURL"]+memoryInitializer}if(ENVIRONMENT_IS_NODE||ENVIRONMENT_IS_SHELL){var data=Module["readBinary"](memoryInitializer);HEAPU8.set(data,Runtime.GLOBAL_BASE)}else{addRunDependency("memory initializer");var applyMemoryInitializer=(function(data){if(data.byteLength)data=new Uint8Array(data);HEAPU8.set(data,Runtime.GLOBAL_BASE);if(Module["memoryInitializerRequest"])delete Module["memoryInitializerRequest"].response;removeRunDependency("memory initializer")});function doBrowserLoad(){Module["readAsync"](memoryInitializer,applyMemoryInitializer,(function(){throw"could not load memory initializer "+memoryInitializer}))}if(Module["memoryInitializerRequest"]){function useRequest(){var request=Module["memoryInitializerRequest"];if(request.status!==200&&request.status!==0){console.warn("a problem seems to have happened with Module.memoryInitializerRequest, status: "+request.status+", retrying "+memoryInitializer);doBrowserLoad();return}applyMemoryInitializer(request.response)}if(Module["memoryInitializerRequest"].response){setTimeout(useRequest,0)}else{Module["memoryInitializerRequest"].addEventListener("load",useRequest)}}else{doBrowserLoad()}}}Module["then"]=(function(func){if(Module["calledRun"]){func(Module)}else{var old=Module["onRuntimeInitialized"];Module["onRuntimeInitialized"]=(function(){if(old)old();func(Module)})}return Module});function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}ExitStatus.prototype=new Error;ExitStatus.prototype.constructor=ExitStatus;var initialStackTop;var preloadStartTime=null;var calledMain=false;dependenciesFulfilled=function runCaller(){if(!Module["calledRun"])run();if(!Module["calledRun"])dependenciesFulfilled=runCaller};Module["callMain"]=Module.callMain=function callMain(args){args=args||[];ensureInitRuntime();var argc=args.length+1;function pad(){for(var i=0;i<4-1;i++){argv.push(0)}}var argv=[allocate(intArrayFromString(Module["thisProgram"]),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i=i+1){argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL));pad()}argv.push(0);argv=allocate(argv,"i32",ALLOC_NORMAL);try{var ret=Module["_main"](argc,argv,0);exit(ret,true)}catch(e){if(e instanceof ExitStatus){return}else if(e=="SimulateInfiniteLoop"){Module["noExitRuntime"]=true;return}else{var toLog=e;if(e&&typeof e==="object"&&e.stack){toLog=[e,e.stack]}Module.printErr("exception thrown: "+toLog);Module["quit"](1,e)}}finally{calledMain=true}};function run(args){args=args||Module["arguments"];if(preloadStartTime===null)preloadStartTime=Date.now();if(runDependencies>0){return}preRun();if(runDependencies>0)return;if(Module["calledRun"])return;function doRun(){if(Module["calledRun"])return;Module["calledRun"]=true;if(ABORT)return;ensureInitRuntime();preMain();if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();if(Module["_main"]&&shouldRunNow)Module["callMain"](args);postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout((function(){setTimeout((function(){Module["setStatus"]("")}),1);doRun()}),1)}else{doRun()}}Module["run"]=Module.run=run;function exit(status,implicit){if(implicit&&Module["noExitRuntime"]){return}if(Module["noExitRuntime"]){}else{ABORT=true;EXITSTATUS=status;STACKTOP=initialStackTop;exitRuntime();if(Module["onExit"])Module["onExit"](status)}if(ENVIRONMENT_IS_NODE){process["exit"](status)}Module["quit"](status,new ExitStatus(status))}Module["exit"]=Module.exit=exit;var abortDecorators=[];function abort(what){if(Module["onAbort"]){Module["onAbort"](what)}if(what!==undefined){Module.print(what);Module.printErr(what);what=JSON.stringify(what)}else{what=""}ABORT=true;EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";var output="abort("+what+") at "+stackTrace()+extra;if(abortDecorators){abortDecorators.forEach((function(decorator){output=decorator(output,what)}))}throw output}Module["abort"]=Module.abort=abort;if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}var shouldRunNow=false;if(Module["noInitialRun"]){shouldRunNow=false}Module["noExitRuntime"]=true;run();function WrapperObject(){}WrapperObject.prototype=Object.create(WrapperObject.prototype);WrapperObject.prototype.constructor=WrapperObject;WrapperObject.prototype.__class__=WrapperObject;WrapperObject.__cache__={};Module["WrapperObject"]=WrapperObject;function getCache(__class__){return(__class__||WrapperObject).__cache__}Module["getCache"]=getCache;function wrapPointer(ptr,__class__){var cache=getCache(__class__);var ret=cache[ptr];if(ret)return ret;ret=Object.create((__class__||WrapperObject).prototype);ret.ptr=ptr;return cache[ptr]=ret}Module["wrapPointer"]=wrapPointer;function castObject(obj,__class__){return wrapPointer(obj.ptr,__class__)}Module["castObject"]=castObject;Module["NULL"]=wrapPointer(0);function destroy(obj){if(!obj["__destroy__"])throw"Error: Cannot destroy object. (Did you create it yourself?)";obj["__destroy__"]();delete getCache(obj.__class__)[obj.ptr]}Module["destroy"]=destroy;function compare(obj1,obj2){return obj1.ptr===obj2.ptr}Module["compare"]=compare;function getPointer(obj){return obj.ptr}Module["getPointer"]=getPointer;function getClass(obj){return obj.__class__}Module["getClass"]=getClass;var ensureCache={buffer:0,size:0,pos:0,temps:[],needed:0,prepare:(function(){if(ensureCache.needed){for(var i=0;i<ensureCache.temps.length;i++){Module["_free"](ensureCache.temps[i])}ensureCache.temps.length=0;Module["_free"](ensureCache.buffer);ensureCache.buffer=0;ensureCache.size+=ensureCache.needed;ensureCache.needed=0}if(!ensureCache.buffer){ensureCache.size+=128;ensureCache.buffer=Module["_malloc"](ensureCache.size);assert(ensureCache.buffer)}ensureCache.pos=0}),alloc:(function(array,view){assert(ensureCache.buffer);var bytes=view.BYTES_PER_ELEMENT;var len=array.length*bytes;len=len+7&-8;var ret;if(ensureCache.pos+len>=ensureCache.size){assert(len>0);ensureCache.needed+=len;ret=Module["_malloc"](len);ensureCache.temps.push(ret)}else{ret=ensureCache.buffer+ensureCache.pos;ensureCache.pos+=len}return ret}),copy:(function(array,view,offset){var offsetShifted=offset;var bytes=view.BYTES_PER_ELEMENT;switch(bytes){case 2:offsetShifted>>=1;break;case 4:offsetShifted>>=2;break;case 8:offsetShifted>>=3;break}for(var i=0;i<array.length;i++){view[offsetShifted+i]=array[i]}})};function ensureString(value){if(typeof value==="string"){var intArray=intArrayFromString(value);var offset=ensureCache.alloc(intArray,HEAP8);ensureCache.copy(intArray,HEAP8,offset);return offset}return value}function MediaInfo(){this.ptr=_emscripten_bind_MediaInfo_MediaInfo_0();getCache(MediaInfo)[this.ptr]=this}MediaInfo.prototype=Object.create(WrapperObject.prototype);MediaInfo.prototype.constructor=MediaInfo;MediaInfo.prototype.__class__=MediaInfo;MediaInfo.__cache__={};Module["MediaInfo"]=MediaInfo;MediaInfo.prototype["openBufferInit"]=MediaInfo.prototype.openBufferInit=(function(arg0,arg1){var self=this.ptr;if(arg0&&typeof arg0==="object")arg0=arg0.ptr;if(arg1&&typeof arg1==="object")arg1=arg1.ptr;return _emscripten_bind_MediaInfo_openBufferInit_2(self,arg0,arg1)});MediaInfo.prototype["openBufferContinue"]=MediaInfo.prototype.openBufferContinue=(function(arg0,arg1){var self=this.ptr;if(arg0&&typeof arg0==="object")arg0=arg0.ptr;if(arg1&&typeof arg1==="object")arg1=arg1.ptr;return _emscripten_bind_MediaInfo_openBufferContinue_2(self,arg0,arg1)});MediaInfo.prototype["openBufferGetSeekTo"]=MediaInfo.prototype.openBufferGetSeekTo=(function(){var self=this.ptr;return _emscripten_bind_MediaInfo_openBufferGetSeekTo_0(self)});MediaInfo.prototype["openBufferFinalize"]=MediaInfo.prototype.openBufferFinalize=(function(){var self=this.ptr;return _emscripten_bind_MediaInfo_openBufferFinalize_0(self)});MediaInfo.prototype["inform"]=MediaInfo.prototype.inform=(function(){var self=this.ptr;return Pointer_stringify(_emscripten_bind_MediaInfo_inform_0(self))});MediaInfo.prototype["getOption"]=MediaInfo.prototype.getOption=(function(arg0){var self=this.ptr;ensureCache.prepare();if(arg0&&typeof arg0==="object")arg0=arg0.ptr;else arg0=ensureString(arg0);return Pointer_stringify(_emscripten_bind_MediaInfo_getOption_1(self,arg0))});MediaInfo.prototype["setOption"]=MediaInfo.prototype.setOption=(function(arg0,arg1){var self=this.ptr;ensureCache.prepare();if(arg0&&typeof arg0==="object")arg0=arg0.ptr;else arg0=ensureString(arg0);if(arg1&&typeof arg1==="object")arg1=arg1.ptr;else arg1=ensureString(arg1);return Pointer_stringify(_emscripten_bind_MediaInfo_setOption_2(self,arg0,arg1))});MediaInfo.prototype["close"]=MediaInfo.prototype.close=(function(){var self=this.ptr;_emscripten_bind_MediaInfo_close_0(self)});MediaInfo.prototype["__destroy__"]=MediaInfo.prototype.__destroy__=(function(){var self=this.ptr;_emscripten_bind_MediaInfo___destroy___0(self)});function VoidPtr(){throw"cannot construct a VoidPtr, no constructor in IDL"}VoidPtr.prototype=Object.create(WrapperObject.prototype);VoidPtr.prototype.constructor=VoidPtr;VoidPtr.prototype.__class__=VoidPtr;VoidPtr.__cache__={};Module["VoidPtr"]=VoidPtr;VoidPtr.prototype["__destroy__"]=VoidPtr.prototype.__destroy__=(function(){var self=this.ptr;_emscripten_bind_VoidPtr___destroy___0(self)});((function(){function setupEnums(){}if(Module["calledRun"])setupEnums();else addOnPreMain(setupEnums)}))()





  return Module;
};
if (typeof module === "object" && module.exports) {
  module['exports'] = Module;
};
return function MediaInfoLib(opts) {
    return new Promise(function(resolve) {
        Module(Object.assign({}, opts, {
            onRuntimeInitialized: function() {
                var Module = this;
                var modMediaInfo = Module.MediaInfo;
                var MediaInfo = function MediaInfo() {
                    modMediaInfo.call(this);
                };
                MediaInfo.prototype = Object.create(modMediaInfo.prototype);
                MediaInfo.prototype.constructor = MediaInfo;

                MediaInfo.prototype.openBufferGetSeekTo = (function(openBufferGetSeekTo) {
                    return function openBufferGetSeekToWrapper() {
                        var res = openBufferGetSeekTo.call(this);
                        var tempRet0 = Module.Runtime.getTempRet0();
                        return Module.Runtime.makeBigInt(res, tempRet0, !1);
                    };
                })(modMediaInfo.prototype.openBufferGetSeekTo);

                MediaInfo.prototype.openBufferContinue = (function(openBufferContinue) {
                    return function openBufferContinueWrapper(a0, a1) {
                        if (a0 instanceof ArrayBuffer) {
                            a0 = new Uint8Array(a0);
                        }

                        var ptr = Module._malloc(a0.byteLength | 0);
                        if (ptr) {
                            Module.HEAPU8.set(a0, ptr);
                            a0 = {ptr: ptr};
                        }

                        var res = openBufferContinue.call(this, a0, a1);

                        if (ptr) {
                            Module._free(ptr);
                        }

                        return res;
                    };
                })(modMediaInfo.prototype.openBufferContinue);

                resolve(new MediaInfo());
                Module.memoryInitializerRequest = MediaInfo = modMediaInfo = resolve = undefined;
            }
        }));
        opts = undefined;
    });
};
}));
